(*
%Copyright   (c) Polak Computer System
%Author      27.07.2001 18:33:58 RSN
%Purpose     室 ᮫
%Type        report
%Specific    AP
%Modified    10.04.2012 12:01:20 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_OwnData, D_Fl, L_Basis, FIO, L_Car, L_bp;

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "ॢ");
  L_Basis.wb_WrInQM(F, "ॢ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠦ");
  L_Basis.wb_WrInQM(F, "᭮");
  L_Basis.wb_WrInQM(F, "設");
  L_Basis.wb_WrInQM(F, " 뤠");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⥫");
  L_Basis.wb_WrInQM(F, "⥫");
  L_Basis.wb_WrInQM(F, "஡  ।- ");
  L_Basis.wb_WrInQM(F, "ଠ");
  L_Basis.wb_WrInQM(F, "뤠");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]);
 BEGIN
  IF OCCURE(TKind) THEN
   L_Basis.wb_WrScl(F, CarLog.TKind);
   L_Basis.wb_WrStr(F, TKind.Name);
  ELSE
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "-----");
  END;
  L_Basis.wb_WrScl(F, CarLog.Column);
  L_Basis.wb_WrScl(F, Car.BoxNbr);
  L_Basis.wb_WrStr(F, CarLog.StateNbr);
  L_Basis.wb_WrScl(F, Car.BoxNbr + " " + CarLog.StateNbr);
  L_Basis.wb_WrDat(F, FL003.Date);
  IF OCCURE(Math) THEN
   L_Basis.wb_WrScl(F, Math.Math);
   L_Basis.wb_WrStr(F, Math.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_WrScl(F, FL003.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrNum(F, FL003.Run, 2);
  L_Basis.wb_WrNum(F, FL003.Norm, 4);
  L_Basis.wb_WrNum(F, FL003.Fact, 4);
  L_Basis.wb_WrScl(F, CarLog.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PUBLIC PROCEDURE FL003();
  CONST
   bpId = "FL003";
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_bp.Begin(bpId, "뤠 ᮫", L_bp.t_Basis, L_General.timeCond_InIntvl);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  D_Fl.Prepare_FL003("");
  MakeHeader("R");
  SELECT(FL003, BoxNbr);
  WHILE OCCURE(FL003) DO
   PROMPT(" " + FL003.BoxNbr);
   SEARCH(Car, BoxNbr, , FL003.BoxNbr);
   L_Car.StandOnCarLog(Car.BoxNbr, FL003.Date);
   CONFORM(CarLog, Mark);
   CONFORM(CarLog, TKind);
   CONFORM(FL003, Math);
   CONFORM(FL003, Staff);
   CONFORM(Staff, Man);
   MakePart("R");
   NEXT(FL003);
  END; (* WHILE OCCURE(FL003) ... *)
  D_Fl.Purge_FL003();
  FIO.Close(R);
  L_bp.End();
 END {FL003};

END.
