(*
%Copyright   (c) Polak Computer System
%Author      01.10.1999 10:20:27 BOR
%Purpose     ᮪ 㬥⮢   ॣ⮢
%Type        report
%Specific    AP
%Modified    26.02.2013 13:50:40 ROBOT by POLAK\LDA
%Environment
*)

 MODULE MDLCURep [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_OwnData, L_AFM, L_MDoc, L_Str, L_CUC, L_XDoc, L_XDoc,
        L_DatTim, Str;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc), L, ""
MDoc.Date, L, "D.N.y"
@
############################################################# ########## #####
=#####========================================================================
|                㬥   ஢, ஢              |
|                   㬥  ########### ##########                 |
|----------------------------------------------------------------------------|
|                                |㬥              ||
|-----------------------------------------|----------------------|-----------|
}

$P{ Line:
?, L, ""
L_MDoc.MDocStr(_CUMv.MDocKind, _CUMv.MDoc), L, ""
_CUMv.Date, L, "D.N.y"
L_Str.PoolItem(L_CUC.ok_Pool, _CUMv.OpKind), L, ""
@
|#########################################|########### ##########|###########|
}
$P{ Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE dcc_PutSingleMDocLCU();
  VAR
   _MDocKind: LIKE(MDocLCU.MDocKind);
   _MDoc    : LIKE(MDocLCU.MDoc);
   _Date    : LIKE(MDocLCU.Date);
   _PassDTS : LIKE(MDocLCU.PassDTS);
 BEGIN
  APP.Get().NewPrompt(MDocLCU.CUCopy);
  _MDocKind:=MDocLCU.MDocKind;
  _MDoc    :=MDocLCU.MDoc;
  _Date    :=MDocLCU.Date;
  _PassDTS :=MDocLCU.PassDTS;
  SAVE(MDocLCU);
  CHANGESEL(MDocLCU, CUCopy, , MDocLCU.CUCopy);
  FIRST(MDocLCU);
  WHILE OCCURE(MDocLCU) DO
   PROMPT(L_MDoc.MDocStr(MDocLCU.MDocKind, MDocLCU.MDoc));
   IF (MDocLCU.MDocKind # _MDocKind) | (MDocLCU.MDoc # _MDoc) THEN
    IF MDocLCU.Status # L_MDoc.st_Canceled THEN
     IF (MDocLCU.Date > _Date) |
        ((MDocLCU.Date = _Date) & (!MDocLCU.PassDTS | (MDocLCU.PassDTS > _PassDTS))) THEN
      IF ~SELECT(_CUMv, CUCopy, MDocLCU.CUCopy, MDocLCU.MDocKind, MDocLCU.MDoc) THEN
       _CUMv.MDocKind:=MDocLCU.MDocKind;
       _CUMv.MDoc    :=MDocLCU.MDoc;
       _CUMv.CUCopy  :=MDocLCU.CUCopy;
       _CUMv.Date    :=MDocLCU.Date;
       _CUMv.PassDTS :=MDocLCU.PassDTS;
       _CUMv.OpKind  :=MDocLCU.OpKind;
       INSERT(_CUMv);
       dcc_PutSingleMDocLCU();
      END;
     END;
    END;
   END;
   NEXT(MDocLCU);
  END; (* WHILE OCCURE(MDocLCU) ... *)
  RESTORE(MDocLCU);
 END {dcc_PutSingleMDocLCU};

 PUBLIC PROCEDURE MDLCU();
  CONST
   RepName = "MDLCU";
  VAR
   prvCUCopy  : LIKE(CUCopy.CUCopy);
   CUCopyAsStr: STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  APP.Get().NewPrompt("("+RepName+")");
  L_General.Assert(ACCESS(MDoc), " । ⥪騩 㬥");
 
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName);
 
  L_AFM.MakeMultipleIndex("_CUMv", "MDocKind: LIKE(MDocLCU.MDocKind);"+
                                      "MDoc    : LIKE(MDocLCU.MDoc);"+
                                      "CUCopy  : LIKE(MDocLCU.CUCopy);"+
                                      "Date    : DATE;"+
                                      "PassDTS : LIKE(MDocLCU.PassDTS);"+
                                      "OpKind  : LIKE(MDocLCU.OpKind)",
                             "CUCopy: CUCopy, MDocKind, MDoc;"+
                             "MDoc: MDocKind, MDoc");
 
  SELECT(MDocLCU, MDoc, , MDoc.MDocKind, MDoc.MDoc);
  WHILE OCCURE(MDocLCU) DO
   dcc_PutSingleMDocLCU();
   NEXT(MDocLCU);
  END;
 
  L_XDoc.sl_Init("쭥襥  ஢");
  SETEMPTY(prvCUCopy);
  SELECT(_CUMv, CUCopy);
  WHILE OCCURE(_CUMv) DO
   IF _CUMv.CUCopy # prvCUCopy THEN
    SEARCH(CUCopy, CUCopy, , _CUMv.CUCopy);
    CONFORM(CUCopy, Math);
    CUCopyAsStr:=CUCopy.CUCopy + " " + Math.Math + " " + Math.Name;
    prvCUCopy:=CUCopy.CUCopy;
   ELSE
    CUCopyAsStr:="";
   END;
   L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_MDoc, _CUMv.MDocKind, _CUMv.MDoc),
                     Str.Align(CUCopyAsStr, 32, LEFT) + " " +
                     L_MDoc.MDocStr(_CUMv.MDocKind, _CUMv.MDoc) + " " +
                     L_DatTim.DateStr(_CUMv.Date) + " " +
                     L_Str.PoolItem(L_CUC.ok_Pool, _CUMv.OpKind));
   MAKEPART(R, Line, CUCopyAsStr);
   NEXT(_CUMv);
  END; (* WHILE OCCURE(_CUMv) ... *)
 
  MAKEPART(R, Bot);
  L_AFM.AF_PurgeTemp("_CUMv");
  CLOSEREP(R);
  L_XDoc.sl_Done();
 END {MDLCU};

END.