(*
%Copyright   (c) Polak IT
%Author      12.12.2008 19:38:21 POLAK\GAV
%Purpose       樭᪮ ᯥ樨
%Type        report
%Specific    AP
%Modified    11.03.2014 17:51:29 POLAK\GAV
%Environment
*)

 IMPORT L_AFM, P_OwnData, Memo, L_XDoc, L_ODoc, L_Prop, L_General,
        L_Str, L_OwnData, L_DatTim, L_Staff, L_Env, L_StdFrm, Str, L_kn;

 CONST
  KindAmount = 4;
  TypeAmount = 4;

(*
$P{ Top1:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
@
################################################################################################################################################################################################ ########## #####
=#####===========================================================================================================================================================================================================
}
*)

(*
$P{ Top2:
?, C, "", "B"
@
|###############################################################################################################################################################################################################|
}
*)

(*
$P{ Top3:
@
|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| |  |      |६|. |  ⢮            |     |ᬮ    |஡|                                  |||. |稭 ࠭  ࠡ                     |
|    |       |          |     |     |                                |       |             ||                                        ||     |.|                                                  |
}
*)

(*
$P{ Line:
?, R, "0"
ODoc.ODoc, L, ""
?, L, "D.N.y"
?, L, "H:M"
?, L, ""
Man.Name, L, ""
?, L, ""
?, L, L_ODoc.amo_TypePool
?, L, "  -  |  +  "
?, L, ""
?, C, ""
?, C, ""
?, C, ""
?, L, ""
@
|----|-------|----------|-----|-----|--------------------------------|-------|-------------|-----|----------------------------------------|----|-----|-------|--------------------------------------------------|
|####|#######|##########|#####|#####|################################|#######|#############|#####|########################################|####|#####|#######|##################################################|
}
*)

(*
$P{ Bot:
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, L, ""
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, L, ""
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, L, ""
@
|================================================================================================================================================================================================================
|                          |        |           ࠭           |
|                       |饭|--------------------------------|
|                          |        | |  .| મ.|
|==========================|========|==========|==========|==========|
|।३ᮢ              |########|##########|##########|##########|                                                                     ######################################################################
|३ᮢ               |########|##########|##########|##########|
|᫥३ᮢ             |########|##########|##########|##########|
| ।              |########|##########|##########|##########|                                                                     ######################################################################
|==========================|========|==========|==========|==========|
|                     |########|##########|##########|##########|
=(c) Polak============================================================                                                                     ######################################################################
}
*)

(*
$P{ Sign:
?, L, ""
@

                                                                                                                                           ######################################################################
}
*)

 PRIVATE PROCEDURE amoTemp(): STRING[];
  VAR
   s: STRING[];
 BEGIN
  s:=Str.Condense(FLDTOSTR(L_ODoc.amo_Temperature()));
  IF ~!s THEN
   RETURN s;
  ELSE
   RETURN "";
  END;
 END {amoTemp};

 PRIVATE PROCEDURE amoPulse(): STRING[];
  VAR
   s: STRING[];
 BEGIN
  s:=Str.Condense(FLDTOSTR(L_ODoc.amo_Pulse()));
  IF ~!s THEN
   RETURN s;
  ELSE
   RETURN "";
  END;
 END {amoPulse};

 PRIVATE PROCEDURE amoAD(): STRING[];
  VAR
   trgPressureHigh,
   trgPressureLow  : NUMERIC[4,0];
 BEGIN
  L_ODoc.amo_AD(trgPressureHigh, trgPressureLow);
  IF ~!trgPressureHigh THEN
   RETURN Str.Condense(FLDTOSTR(trgPressureHigh)) + "/" + Str.Condense(FLDTOSTR(trgPressureLow));
  ELSE
   RETURN "";
  END;
 END {amoAD};

 PRIVATE PROCEDURE amoKind(): STRING[];
  VAR
   amk: NUMERIC[0];
 BEGIN
  amk:=L_ODoc.amo_Kind();
  IF amk = L_ODoc.amok_Granted THEN
   RETURN "";
  ELSE
   RETURN L_Str.PoolItem(L_ODoc.amo_KindPool, amk);
  END;
 END {amoKind};

 PRIVATE PROCEDURE Make(cond: PROC; From, UpTo: DATE; RepName, TopStr: STRING[]);
  VAR
   Idx    : NUMERIC[0];
   Cnt    : NUMERIC[0][KindAmount*TypeAmount];
   acsobj : LIKE(AcsObj.AcsObj)[10];
   acsName: STRING[][10];
   curAO  : LIKE(AcsObj.AcsObj);
   List   : STRING[];
 BEGIN
  L_AFM.MakeMultipleIndex("tmp",
                          "ODocKind: LIKE(ODoc.ODocKind);" +
                          "ODoc    : LIKE(ODoc.ODoc);" +
                          "AcsObj  : LIKE(AcsObj.AcsObj);" +
                          "D       : DATE;" +
                          "T       : TIME;" +
                          "Type    : SCAL["+L_Str.IntStr(TypeAmount) + "]",
                          "ODoc: ODocKind, ODoc; D: D, T; AcsObj: AcsObj, D, T");

  L_AFM.MakeIndex("acs", "AcsObj: LIKE(AcsObj.AcsObj)");
 
  SETZERO(Cnt);
  SETSEL(ODoc, ODKDate, L_kn.Get(UpTo, L_ODoc.erkn_MedicalExaminationAct));
  SRCINSEL(ODoc, GE, , From);
  WHILE OCCURE(ODoc) & (ODoc.Date <= UpTo) DO
   PROMPT(ODoc.ODoc);
   IF ODoc.Status = L_ODoc.ods_Passed THEN
    CONFORM(ODoc, Staff);
    IF cond(ODoc.Date) THEN
     tmp.ODocKind:=ODoc.ODocKind;
     tmp.ODoc    :=ODoc.ODoc;
     tmp.D       :=ODoc.SrcDate;
     tmp.T       :=L_ODoc.amo_Time();
     tmp.Type    :=L_ODoc.amo_Type();
     SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_ODoc, ODoc.ODocKind, ODoc.ODoc);
     WHILE (XDocJrn.Action # L_XDoc.action_Insert) DO
      NEXT(XDocJrn);
     END; (* WHILE OCCURE(XDocJrn) ... *)
     tmp.AcsObj:=XDocJrn.AcsObj;
     INSERT(tmp);
     ADD(acs, acs, , XDocJrn.AcsObj);
    END;
   END;
   NEXT(ODoc);
  END; (* WHILE OCCURE(ODoc) ... *)

  Idx:=1;
  SETEMPTY(acsName, acsobj, List);
  List:=" |";
  SELECT(tmp, AcsObj);
  WHILE OCCURE(tmp) DO
   NARROWSEL(tmp, AcsObj);
   SEARCH(AcsObj, AcsObj, , tmp.AcsObj);
   acsobj[Idx]:=AcsObj.AcsObj;
   IF ~!AcsObj.Man THEN
    CONFORM(AcsObj, Man);
    acsName[Idx]:=Man.Name;
   ELSE
    acsName[Idx]:=AcsObj.FullName;
   END;
   List:=List + acsName[Idx] + "|" ;
   INC(Idx);
   NEXTINEXTENDEDSEL(tmp, AcsObj);
  END; (* WHILE OCCURE(acs) ... *)

  Idx:=L_StdFrm.ShowListAsMenu(List, " 롮  ");
  curAO:=acsobj[Idx];
  IF ~!curAO THEN
   SETEMPTY(acsName, acsobj);
   acsobj [1]:=curAO;
   acsName[1]:=L_Str.PoolItem(List, Idx);
  END;

  OPENREP(R, L_General.NameConnection(RepName), Create,
             FontEnlargement, 1.1,
             FontProperty,    "/B",
             TopMargin,       10,
             BottomMargin,    10,
             LeftMargin,      20,
             RightMargin,     10);
  MAKEPART(R, Top1, RepName);
  SetPrintAttr(R, FontEnlargement, 1.25);
  MAKEPART(R, Top2, TopStr);
  SetPrintAttr(R, FontEnlargement, 1.1);
  MAKEPART(R, Top3);
  IF !curAO THEN
   SELECT(tmp, D);
  ELSE
   SELECT(tmp, AcsObj, , curAO);
  END;
  Idx:=0;
  WHILE OCCURE(tmp) DO
   SEARCH(ODoc, ODoc, , tmp.ODocKind, tmp.ODoc);
   PROMPT(ODoc.ODoc);
   CONFORM(ODoc, Staff);
   CONFORM(Staff, Man);
   INC(Idx);
   IF tmp.Type # L_ODoc.amot_Undefined THEN
    L_ODoc.curRefToXDoc_PositionOn(L_XDoc.xdt_RWayS);
    MAKEPART(R, Line, Idx, tmp.D, tmp.T, Staff.TSN, RWayS.RWayS, tmp.Type,
                      L_ODoc.amo_AlcoholTestResult(),
                      L_ODoc.amo_Complaints(),
                      amoTemp(), amoPulse(), amoAD(), amoKind());
   ELSE
    MAKEPART(R, Line, Idx, tmp.D, tmp.T, Staff.TSN, "", tmp.Type,
                      L_ODoc.amo_AlcoholTestResult(),
                      L_ODoc.amo_Complaints(),
                      amoTemp(), amoPulse(), amoAD(), amoKind());
   END;
   INC(Cnt[KindAmount*tmp.Type + L_ODoc.amo_Kind()]);
   NEXT(tmp);
  END; (* WHILE OCCURE(tmp) ... *)

  Idx:=1;
  WHILE ~!acsName[Idx] DO
   acsName[Idx]:="________________ " + acsName[Idx];
   INC(Idx);
  END;

  MAKEPART(R, Bot, Cnt[L_ODoc.amot_First * KindAmount + L_ODoc.amok_Granted],
                   Cnt[L_ODoc.amot_First * KindAmount + L_ODoc.amok_Sickness],
                   Cnt[L_ODoc.amot_First * KindAmount + L_ODoc.amok_Alcohol],
                   Cnt[L_ODoc.amot_First * KindAmount + L_ODoc.amok_Drugs],
                   acsName[3],
                   Cnt[L_ODoc.amot_InterJob * KindAmount + L_ODoc.amok_Granted],
                   Cnt[L_ODoc.amot_InterJob * KindAmount + L_ODoc.amok_Sickness],
                   Cnt[L_ODoc.amot_InterJob * KindAmount + L_ODoc.amok_Alcohol],
                   Cnt[L_ODoc.amot_InterJob * KindAmount + L_ODoc.amok_Drugs],
                   Cnt[L_ODoc.amot_Final * KindAmount + L_ODoc.amok_Granted],
                   Cnt[L_ODoc.amot_Final * KindAmount + L_ODoc.amok_Sickness],
                   Cnt[L_ODoc.amot_Final * KindAmount + L_ODoc.amok_Alcohol],
                   Cnt[L_ODoc.amot_Final * KindAmount + L_ODoc.amok_Drugs],
                   Cnt[L_ODoc.amot_Undefined * KindAmount + L_ODoc.amok_Granted],
                   Cnt[L_ODoc.amot_Undefined * KindAmount + L_ODoc.amok_Sickness],
                   Cnt[L_ODoc.amot_Undefined * KindAmount + L_ODoc.amok_Alcohol],
                   Cnt[L_ODoc.amot_Undefined * KindAmount + L_ODoc.amok_Drugs],
                   acsName[2],
                   Cnt[L_ODoc.amot_First     * KindAmount + L_ODoc.amok_Granted] +
                   Cnt[L_ODoc.amot_InterJob  * KindAmount + L_ODoc.amok_Granted] +
                   Cnt[L_ODoc.amot_Final     * KindAmount + L_ODoc.amok_Granted] +
                   Cnt[L_ODoc.amot_Undefined * KindAmount + L_ODoc.amok_Granted],
                   Cnt[L_ODoc.amot_First     * KindAmount + L_ODoc.amok_Sickness] +
                   Cnt[L_ODoc.amot_InterJob  * KindAmount + L_ODoc.amok_Sickness] +
                   Cnt[L_ODoc.amot_Final     * KindAmount + L_ODoc.amok_Sickness] +
                   Cnt[L_ODoc.amot_Undefined * KindAmount + L_ODoc.amok_Sickness],
                   Cnt[L_ODoc.amot_First     * KindAmount + L_ODoc.amok_Alcohol] +
                   Cnt[L_ODoc.amot_InterJob  * KindAmount + L_ODoc.amok_Alcohol] +
                   Cnt[L_ODoc.amot_Final     * KindAmount + L_ODoc.amok_Alcohol] +
                   Cnt[L_ODoc.amot_Undefined * KindAmount + L_ODoc.amok_Alcohol],
                   Cnt[L_ODoc.amot_First     * KindAmount + L_ODoc.amok_Drugs] +
                   Cnt[L_ODoc.amot_InterJob  * KindAmount + L_ODoc.amok_Drugs] +
                   Cnt[L_ODoc.amot_Final     * KindAmount + L_ODoc.amok_Drugs] +
                   Cnt[L_ODoc.amot_Undefined * KindAmount + L_ODoc.amok_Drugs],
                   acsName[1]);

  Idx:=4;
  WHILE ~!acsName[Idx] DO
   MAKEPART(R, Sign, acsName[Idx]);
   INC(Idx);
  END;
 END {Make};

 PRIVATE PROCEDURE cond_All(D: DATE): SCAL[2];
 BEGIN
  RETURN 1;
 END {cond_All};

 PRIVATE PROCEDURE cond_Drivers(D: DATE): SCAL[2];
 BEGIN
  L_Staff.PosToStaffLog(Staff.TSN, D, 1);
  CONFORM(StaffLog, Officer);
  RETURN L_Env.IsDriver();
 END {cond_Drivers};

 PUBLIC PROCEDURE MdJr1();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  Make(PROCREF(cond_All), Memo.ud_cd(), Memo.ud_cd(), "MdJr1",
       "  樭᪮ ᯥ樨  " + L_DatTim.DateStr(Memo.ud_cd()));
 END {MdJr1};

 PUBLIC PROCEDURE MdJr2();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  Make(PROCREF(cond_Drivers), Memo.ud_cd(), Memo.ud_cd(), "MdJr2",
       "  樭᪮ ᯥ樨  " + L_DatTim.DateStr(Memo.ud_cd()) + " (⥫)");
 END {MdJr2};

 PRIVATE PROCEDURE Gather_FMMEA(From, UpTo: DATE);
  VAR
   _XDocType: L_XDoc.tXDocType;
   _XDocKind: L_XDoc.tXDocKind;
 BEGIN
  L_AFM.MakeMultipleIndex("FMMEA",
                          "ODocKind: LIKE(ODoc.ODocKind);" +
                          "ODoc    : LIKE(ODoc.ODoc);"     +
                          "AcsObj  : LIKE(AcsObj.AcsObj);" +
                          "Firm    : LIKE(Firm.Firm);"     +
                          "Man     : LIKE(Man.Man);"       +
                          "D       : DATE;"                +
                          "T       : TIME",
                    "ODoc  : ODocKind, ODoc; " +
                    "D     : D, T; " +
                    "Firm  : Firm, D, T; " +
                    "Man   : Firm, Man, D, T; " +
                    "AcsObj: AcsObj, D, T");

  L_AFM.MakeIndex("acs", "AcsObj: LIKE(AcsObj.AcsObj)");

  SETSEL(ODoc, ODKDate, L_kn.Get(UpTo, L_ODoc.erkn_ForeignManMedExamAct));
  SRCINSEL(ODoc, GE, , From);
  WHILE OCCURE(ODoc) & (ODoc.Date <= UpTo) DO
   PROMPT(ODoc.ODoc);
   IF ODoc.Status = L_ODoc.ods_Passed THEN
    FMMEA.ODocKind:=ODoc.ODocKind;
    FMMEA.ODoc    :=ODoc.ODoc;
    FMMEA.D       :=ODoc.SrcDate;
    FMMEA.T       :=L_ODoc.amo_Time();
    SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_ODoc, ODoc.ODocKind, ODoc.ODoc);
    WHILE (XDocJrn.Action # L_XDoc.action_Insert) DO
     NEXT(XDocJrn);
    END; (* WHILE OCCURE(XDocJrn) ... *)
    FMMEA.AcsObj:=XDocJrn.AcsObj;
    FMMEA.Firm  :=ODoc.Firm;
    L_XDoc.DecodeXDocId(L_ODoc.curRefToXDoc_GetId(), _XDocType, _XDocKind, FMMEA.Man);
    L_General.CallUs(_XDocType = L_XDoc.xdt_Man);
    INSERT(FMMEA);
    ADD(acs, acs, , XDocJrn.AcsObj);
   END;
   NEXT(ODoc);
  END; (* WHILE OCCURE(ODoc) ... *)
 END {Gather_FMMEA};

(*
$P{ MdJr3_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
@
################################################################################################################################################################################################ ########## #####
=#####===========================================================================================================================================================================================================
|###############################################################################################################################################################################################################|
|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| |  |      |६|  ⢮            |࣠                |஡|                                  |||. |稭 ࠭  ࠡ                     |
|    |       |          |     |                                |                           ||                                        ||     |.|                                                  |
}
*)


(*
$P{ MdJr3_Line:
?, R, "0"
ODoc.ODoc, L, ""
?, L, "D.N.y"
?, L, "H:M"
Man.Name, L, ""
Firm.Firm, L, ""
Firm.Name, L, ""
?, L, "-|+"
?, L, ""
?, C, ""
?, C, ""
?, C, ""
?, L, ""
@
|----|-------|----------|-----|--------------------------------|---------------------------|-----|----------------------------------------|----|-----|-------|--------------------------------------------------|
|####|#######|##########|#####|################################|#### ######################|  #  |########################################|####|#####|#######|##################################################|
}
*)

(*
$P{ MdJr3_Bot:
@
=(c) Polak=======================================================================================================================================================================================================
}
*)

 PUBLIC PROCEDURE MdJr3();
  CONST
   RepName = "MdJr3";
  VAR
   Idx    : NUMERIC[0];
   acsobj : LIKE(AcsObj.AcsObj)[10];
   acsName: STRING[][10];
   curAO  : LIKE(AcsObj.AcsObj);
   List   : STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  Gather_FMMEA(Memo.ud_cd(), Memo.ud_cd());
  SELECT(FMMEA, D);
  OPENREP(R, L_General.NameConnection(RepName), Create,
             FontEnlargement, 1.1,
             FontProperty,    "/B",
             TopMargin,       10,
             BottomMargin,    10,
             LeftMargin,      20,
             RightMargin,     10);
  MAKEPART(R, MdJr3_Top, RepName,
           "  樭᪮ ᯥ樨  " + L_DatTim.DateStr(Memo.ud_cd()) + " (஭ )");
  Idx:=0;
  WHILE OCCURE(FMMEA) DO
   PROMPT(L_DatTim.DateTimeStr(FMMEA.D, FMMEA.T));
   SEARCH(ODoc, ODoc, , FMMEA.ODocKind, FMMEA.ODoc);
   CONFORM(ODoc, Firm);
   SEARCH(Man, Man, , FMMEA.Man);
   INC(Idx);
   MAKEPART(R, MdJr3_Line, Idx, FMMEA.D, FMMEA.T, L_ODoc.amo_AlcoholTestResult(),
            L_ODoc.amo_Complaints(), amoTemp(), amoPulse(), amoAD(), amoKind());
   NEXT(FMMEA);
  END; (* WHILE OCCURE(FMMEA) *)
  MAKEPART(R, MdJr3_Bot);

  SELECT(FMMEA, AcsObj);
  WHILE OCCURE(FMMEA) DO
   NARROWSEL(FMMEA, AcsObj);
   SEARCH(AcsObj, AcsObj, , FMMEA.AcsObj);
   IF ~!AcsObj.Man THEN
    CONFORM(AcsObj, Man);
    MAKEPART(R, Sign, "________________ " + Man.Name);
   ELSE
    MAKEPART(R, Sign, "________________ " + AcsObj.FullName);
   END;
   NEXTINEXTENDEDSEL(FMMEA, AcsObj);
  END; (* WHILE OCCURE(FMMEA) ... *)
 END {MdJr3};
END.
