(*
%Copyright   (c) Polak Computer System
%Author      27.02.2001 13:05:03 SAN
%Purpose        ᪫
%Type        report
%Specific    AP
%Modified    06.08.2014 11:53:42 POLAK\GAV
%Environment
*)

 IMPORT L_Print, Memo, Str, L_XDoc, L_General, L_MDoc, L_AFM, L_OwnData, L_MathR,
        L_Str, L_StdFrm, E_Stock, L_Man, Math, L_PagePr, L_Stock, P_Storage,
        L_DatTim, L_AR;

 CONST
  RepName = "MSDly";

 VAR
  DefaultStorageMode: SCAL[2];

  Prefix : STRING[3];
  _AcsObj: LIKE(AcsObj.AcsObj);

 PRIVATE PROCEDURE GetStorageName(): STRING[];
  VAR
   tmpStr: STRING[];
 BEGIN
  SETEMPTY(tmpStr);
  IF P_Storage.IsOnLine(Storage.Storage, Memo.ud_cd()) THEN
   tmpStr:=" (OnLine)";
  END;
  RETURN " "+ Storage.Storage + " " + Storage.Name + tmpStr;
 END {GetStorageName};

 PRIVATE PROCEDURE GetRepTitle(LineNbr: NUMERIC[0]): STRING[];
 BEGIN
  IF P_Storage.IsOnLine(Storage.Storage, Memo.ud_cd()) THEN
   IF LineNbr = 1 THEN
    RETURN "   ᪫  ᬥ";
   ELSE
    RETURN " " + L_DatTim.DateTimeStr(BDate, BTime) + "  " + L_DatTim.DateTimeStr(EDate, ETime);
   END;
  ELSE
   IF LineNbr = 1 THEN
    RETURN "  ᪫";
   ELSE
    RETURN " ਮ  " + L_DatTim.DateStr(BDate) + "  " + L_DatTim.DateStr(EDate);
   END;
  END;
 END {GetRepTitle};

(*
$P{ XX_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
PAGENUM(R), R, "0"
GetRepTitle(1), C, ""
GetRepTitle(2), C, ""
?, L, ""
@
############################################################# ########## #####
=#####========================================================== ࠭ ## =
|############################################################################|
|############################################################################|
| ###################################################################|
}
*)

(*
$P{ XX_StorageTop:
GetStorageName(), L, ""
@
|============================================================================|
|############################################################################|
}
*)

(*
$P{ TM_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
PAGENUM(R), R, "0"
GetRepTitle(1), C, ""
GetRepTitle(2), C, ""
?, L, ""
@
####################### ########## #####
=#####==================== ࠭ ## =
########################################
########################################
########################################
}
*)

(*
$P{ TM_StorageTop:
GetStorageName(), L, ""
@
========================================

########################################

}
*)

(*
$P{ XX_TopMDK1:
?, L, ""
?, R, "0"
@
|============================================================================|
|############################################################################|
|1. ஢ 㬥⮢:                                        #######|
|2. ਭ/饭 :                                                     |
|----------------------------------------------------------------------------|
}
*)

(*
$P{ XX_TopMDK2:
@
|                           || 樨         |  ਭ| 饭|
|------------------------------|---|---------------------|---------|---------|
}
*)

(*
$P{ TM_TopMDK1:
?, L, ""
?, R, "0"
@
========================================
########################################

1. ஢ 㬥⮢:     ######
2. ਭ/饭 :
----------------------------------------
}
*)

(*
$P{ TM_TopMDK2:
@
                ਭ 饭
----------------------------------------
}
*)

(*
$P{ XX_TopTot1:
?, L, ""
@
|============================================================================|
|############################################################################|
|1. ਭ/饭 :                                                     |
|----------------------------------------------------------------------------|
}
*)

(*
$P{ XX_TopTot2:
@
|                                                     |  ਭ| 饭|
|--------------------------------------------------------|---------|---------|
}
*)

(*
$P{ TM_TopTot1:
?, L, ""
@
========================================
########################################

1. ਭ/饭 :
----------------------------------------
}
*)

(*
$P{ TM_TopTot2:
@
                     ਭ 饭
----------------------------------------
}
*)

(*
$P{ XX_MathLine:
Math.Math, L, ""
Math.Name, L, ""
?, L, ""
Dest.Dest, L, ""
Dest.Name, L, ""
?, R, ""
?, R, ""
@
|##### ########################|###|### #################|#########|#########|
}
*)

(*
$P{ TM_MathLine:
Math.Math, L, ""
Math.Name, L, ""
?, L, ""
Dest.Dest, L, ""
?, R, ""
?, R, ""
@
##### ######## ### ### ######## ########
}
*)

(*
$P{ XX_MathTotLine:
Math.Math, L, ""
Math.Name, L, ""
?, R, ""
?, R, ""
@
|##### ##################################################|#########|#########|
}
*)

(*
$P{ TM_MathTotLine:
Math.Math, L, ""
Math.Name, L, ""
?, R, ""
?, R, ""
@
##### ################ ######## ########
}
*)

(*
$P{ XX_ITpMDK:
?, R, "0"
@
|----------------------------------------------------------------------------|
|3.  ⮬ ᫥  㬥⮢:                                  #######|
}
*)

(*
$P{ TM_ITpMDK:
?,  R, "0"
@
----------------------------------------
3.  . .  㬥⮢:   ######
}
*)

(*
$P{ XX_ChgMDK1:
@
|4. 祭  㬥⮢     ():               |
|----------------------------------------------------------------------------|
}
*)

(*
$P{ XX_ChgMDK2:
@
|  |१                         | 樨                  ||
|-------|----------------------------------|------------------------------|--|
}
*)

(*
$P{ TM_ChgMDK1:
@
4. 祭  㬥⮢  -
   ():
----------------------------------------
}
*)

(*
$P{ TM_ChgMDK2:
@
   १                   
----------------------------------------
}
*)

(*
$P{ XX_ChgLine:
MDoc.MDoc, L, ""
Staff.TSN, L, ""
Man.Name, L, ""
Dest.Dest, L, ""
Dest.Name, L, ""
MDoc.CopyCnt, R, "0"
@
|#######|##### ############################|### ##########################|##|
}
*)

(*
$P{ TM_ChgLine:
MDoc.MDoc, L, ""
Staff.TSN, L, ""
Man.Name, L, ""
Dest.Dest, L, ""
MDoc.CopyCnt, R, "0"
@
####### ##### ################### ### ##
}
*)

(*
$P{ XX_EmptyLine:
@
|----------------------------------------------------------------------------|
|                                                                            |
}
*)

(*
$P{ TM_EmptyLine:
@
----------------------------------------

}
*)

(*
$P{ XX_PageTop:
PAGENUM(R), R, "0"
@
================================================================ ࠭ ## =
}
*)

(*
$P{ TM_PageTop:
PAGENUM(R), R, "0"
@
========================== ࠭ ## =
}
*)

(*
$P{ XX_PageBot:
@
==============================================================================
}
*)

(*
$P{ TM_PageBot:
@
========================================
}
*)

(*
$P{ XX_Bot:
L_Str.ShortName(FULLNAME()), C, ""
@
|============================================================================|
|                                                                            |
|                  __________________/##############################/|
|                                                                            |
=(c) Polak====================================================================
}
*)

(*
$P{ TM_Bot:
L_Str.ShortName(FULLNAME()), L, ""
@
----------------------------------------

.........#######################

=() Polak==============================
}
*)

 PRIVATE PROCEDURE Create_MS_DL();
 BEGIN
  CreateFILE(MS_DL, "", "", "");

  CreateFIELD(MS_DL, Storage,  LIKE(Storage.Storage), "", "", "", "", "");
  CreateFIELD(MS_DL, MDocKind, LIKE(MDocKind.MDocKind), "", "", "", "", "");
  CreateFIELD(MS_DL, Math,     LIKE(Math.Math), "", "", "", "", "");
  CreateFIELD(MS_DL, MMode,    LIKE(MMode.MMode), "1", "1", "", "", "");

  CreateFIELD(MS_DL, Dest,     LIKE(Dest.Dest), "", "", "", "", "");
  CreateFIELD(MS_DL, In,       NUMERIC[2], "1", "1", "", "", "");
  CreateFIELD(MS_DL, Out,      NUMERIC[2], "1", "1", "", "", "");

  CreateINDEX(MS_DL, MS_DL, UNIQUE, "", "", Storage, MDocKind, Math, MMode, Dest);
  CreateINDEX(MS_DL, Math , PLURAL, "", "", Storage, Math);

  SetVersionOfFILE(MS_DL, 01); L_AFM.CreateTemp("MS_DL");

  CreateFILE(MS_D1, "", "", "");

  CreateFIELD(MS_D1, Storage,  LIKE(Storage.Storage), "", "", "", "", "");
  CreateFIELD(MS_D1, MDocKind, LIKE(MDocKind.MDocKind), "", "", "", "", "");
  CreateFIELD(MS_D1, MDoc,     LIKE(MDoc.MDoc), "", "", "", "", "");
  CreateFIELD(MS_D1, Illegal,  SCAL[2], "", "0", "", "", "");

  CreateINDEX(MS_D1, MS_D1, UNIQUE, "", "", Storage, MDocKind, MDoc);

  SetVersionOfFILE(MS_D1, 01); L_AFM.CreateTemp("MS_D1");

  CreateFILE(Cnt);
  CreateFIELD(Cnt, Storage,  LIKE(Storage.Storage));
  CreateFIELD(Cnt, MDocKind, LIKE(MDocKind.MDocKind));
  CreateFIELD(Cnt, TotCnt,   NUMERIC[0]);
  CreateFIELD(Cnt, ChgCnt,   NUMERIC[0]);
  CreateINDEX(Cnt, Cnt, UNIQUE, "", "", Storage, MDocKind);
  SetVersionOfFILE(Cnt, 01); L_AFM.CreateTemp("Cnt");
 END {Create_MS_DL};

 PRIVATE PROCEDURE MS_DL_Ins(_In, _Out: NUMERIC[2]);
 BEGIN
  IF MDoc.Status = L_MDoc.st_Canceled THEN
   _In :=0;
   _Out:=0;
  END;
  ADD(MS_DL, MS_DL, , MDoc.Storage, MDoc.MDocKind, MDocList.Math, MDocList.MMode, MDoc.Dest,
      MS_DL.In,   _In,
      MS_DL.Out, _Out);
  IF ~!MDoc.Storage2 THEN
   ADD(MS_DL, MS_DL, , MDoc.Storage2, MDoc.MDocKind, MDocList.Math, MDocList.MMode, MDoc.Dest,
       MS_DL.In, _Out,
       MS_DL.Out, _In);
  END;
 END {MS_DL_Ins};

 PRIVATE PROCEDURE GetPartName(Suffix: STRING[]): STRING[];
 BEGIN
  RETURN Prefix + "_" + Suffix;
 END {GetPartName};

 PRIVATE PROCEDURE IsNeedMDoc(): SCAL[2];
 BEGIN
  RETURN MDocKind.Activity & (~!MDoc.Storage | ~!MDoc.Storage2);
 END {IsNeedMDoc};

 PRIVATE PROCEDURE IsNeedDoc(): SCAL[2];
 BEGIN
  IF SEARCH(MDoc, MDoc, XDocJrn.XDocKind, XDocJrn.XDoc) THEN
   CONFORM(MDoc, MDocKind);
   IF DefaultStorageMode THEN
    RETURN IsNeedMDoc();
   ELSE
    RETURN MDocKind.Activity &
           ((MDoc.Storage = Storage.Storage) | (MDoc.Storage2 = Storage.Storage));
   END;
  ELSE
   RETURN 0;
  END;
 END {IsNeedDoc};

 PRIVATE PROCEDURE _RegisterMDoc(_Storage: LIKE(Storage.Storage); _Illegal: SCAL[2]);
 BEGIN
  IF ~!_Storage THEN
   MS_D1.Storage :=_Storage;
   MS_D1.MDocKind:=MDoc.MDocKind;
   MS_D1.MDoc    :=MDoc.MDoc;
   MS_D1.Illegal :=_Illegal;
   INSERT(MS_D1);

   ADD(Cnt, Cnt, , _Storage, MDoc.MDocKind, Cnt.TotCnt, 1, Cnt.ChgCnt, _Illegal);
  END;
 END {_RegisterMDoc};

 PRIVATE PROCEDURE RegisterMDoc(_Illegal: SCAL[2]);
 BEGIN
  _RegisterMDoc(MDoc.Storage,  _Illegal);
  _RegisterMDoc(MDoc.Storage2, _Illegal);
 END {RegisterMDoc};

 PRIVATE PROCEDURE PutOneMDoc(_Illegal: SCAL[2]);
 BEGIN
  CONFORM(MDoc, MDocList);
  WHILE OCCURE(MDocList) DO
   IF L_MDoc.getMDocListMathFlowType() = L_MDoc.mft_Credit THEN
    MS_DL_Ins(              0, MDocList.Qnt);
   ELSE
    MS_DL_Ins(MDocList.Qnt,               0);
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
  RegisterMDoc(_Illegal);
 END {PutOneMDoc};

 PRIVATE PROCEDURE GatherMDocBySelect(D: DATE);
 BEGIN
  WHILE OCCURE(MDoc) DO
   PROMPT("⮢  " + L_MDoc.GetMDocStrNbr());
   CONFORM(MDoc, MDocKind);
   IF IsNeedMDoc() THEN
    PutOneMDoc(MDoc.CopyCnt > 1);
   END;
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)
 END {GatherMDocByDate};

 PRIVATE PROCEDURE Gather();
  VAR
   D: DATE;
   T: TIME;
 BEGIN
  IF DefaultStorageMode | P_Storage.IsOnLine(Storage.Storage, Memo.ud_cd()) THEN
   SELECT(XDocJrn, UserIdx, , L_XDoc.xdt_MDoc, _AcsObj);
   IF SRCINSEL(XDocJrn, GE, BDate, BTime) THEN
    SAVE(XDocJrn);
    T:=BTime - 4;
    D:=BDate - (T > BTime);
    IF SRCINSEL(XDocJrn, GE, D, T) &
       (L_DatTim.GetVARIANTDATE(XDocJrn.Date, XDocJrn.BegTime, XDocJrn.BegSec) <
        L_DatTim.GetVARIANTDATE(BDate, BTime, 0)) THEN
     L_StdFrm.JustQuestion(" ࠡ  㬥⠬ " +
                            L_DatTim.DateTimeStr(XDocJrn.Date, XDocJrn.BegTime) +
                           "||⢨⥫쭮 㦥    砫 ᬥ?");
    END;
    T:=ETime + 4;
    D:=EDate - (T < ETime);
    IF SRCINSEL(XDocJrn, LE, D, T) &
       (L_DatTim.GetVARIANTDATE(XDocJrn.Date, XDocJrn.BegTime, XDocJrn.BegSec) >
        L_DatTim.GetVARIANTDATE(EDate, ETime, 0)) THEN
     L_StdFrm.JustQuestion(" ࠡ  㬥⠬ " +
                            L_DatTim.DateTimeStr(XDocJrn.Date, XDocJrn.BegTime) +
                           "||⢨⥫쭮 㦥    砭 ᬥ?");
    END;
    RESTORE(XDocJrn);
    WHILE OCCURE(XDocJrn) & L_XDoc.XDocJrnInSession(BDate, EDate, BTime, ETime) DO
     PROMPT("⮢  " +
            L_MDoc.MDocKindNick(XDocJrn.XDocKind, 1) + " " + XDocJrn.XDoc);
     L_General.Assert(SEARCH(MDoc, MDoc, XDocJrn.XDocKind, XDocJrn.XDoc),
                      " XDoc " + XDocJrn.XDocKind + ":" + XDocJrn.XDoc);
     IF ~SEARCH(MS_D1, MS_D1, MDoc.Storage, XDocJrn.XDocKind, XDocJrn.XDoc) THEN
      IF DefaultStorageMode |
         (MDoc.Storage = Storage.Storage) |
         (MDoc.Storage2 = Storage.Storage) THEN
       CONFORM(MDoc, MDocKind);
       IF IsNeedMDoc() THEN
        SAVE(XDocJrn);
        CHANGESEL(XDocJrn, XDocJrn, , XDocJrn.XDocType, XDocJrn.XDocKind, XDocJrn.XDoc);
        FIRST(XDocJrn);
        IF ((XDocJrn.Action = L_XDoc.action_Insert) | (XDocJrn.Action = L_XDoc.action_AutoBuild)) &
           L_XDoc.XDocJrnInSession(BDate, EDate, BTime, ETime) THEN
         PutOneMDoc(MDoc.CopyCnt > 1);
        ELSE
         RegisterMDoc(1);
        END;
        RESTORE(XDocJrn);
       END;
      END;
     END;
     NEXT(XDocJrn);
    END; (* WHILE OCCURE(XDocJrn) ... *)
   END;
  ELSE
   D:=BDate;
   WHILE D <= EDate DO
    SELECT(MDoc, Storage,  , Storage.Storage, D);
    GatherMDocBySelect(D);
    SELECT(MDoc, Storage2, , Storage.Storage, D);
    GatherMDocBySelect(D);
    INC(D);
   END;
  END;
 END {Gather};

 PRIVATE PROCEDURE Make(_MDocKind: LIKE(MDoc.MDocKind); Header: STRING[]);
 BEGIN
  SEARCH(Cnt, Cnt, , Storage.Storage, _MDocKind);
  IF SELECT(MS_DL, MS_DL, Storage.Storage, _MDocKind) | OCCURE(Cnt) & (Cnt.ChgCnt > 0) THEN
   L_PagePr.PagePr_BeforePrintLine(DEPTH(^(GetPartName("TopMDK1"))) +
                                   DEPTH(^(GetPartName("TopMDK2"))) +
                                   DEPTH(^(GetPartName("MathLine"))));
   MAKEPART(R, ^(GetPartName("TopMDK1")), Header, Cnt.TotCnt);
   MAKEPART(R, ^(GetPartName("TopMDK2")));
   CurPageTop:=GetPartName("TopMDK2");
   WHILE OCCURE(MS_DL) DO
    PROMPT(" " + L_MDoc.MDocKindNick(_MDocKind, 1) + " " + MS_DL.Math);
    SEARCH(Dest, Dest, , MS_DL.Dest);
    SEARCH(Math, Math, , MS_DL.Math);
    L_PagePr.PagePr_BeforePrintLine(DEPTH(^(GetPartName("MathLine"))));
    MAKEPART(R, ^(GetPartName("MathLine")),
             L_MathR.MModeStr(MS_DL.MMode),
             L_MathR.DefaultFormatCir(Math.Math,  MS_DL.In),
             L_MathR.DefaultFormatCir(Math.Math, MS_DL.Out));
    NEXT(MS_DL);
   END; (* WHILE OCCURE(MS_DL) ... *)
   L_PagePr.PagePr_BeforePrintLine(DEPTH(^(GetPartName("ITpMDK"))) +
                                   DEPTH(^(GetPartName("ChgMDK1"))) +
                                   DEPTH(^(GetPartName("ChgMDK2"))) +
                                   DEPTH(^(GetPartName("ChgLine"))));
   MAKEPART(R, ^(GetPartName("ITpMDK")), Cnt.ChgCnt);
   IF Cnt.ChgCnt > 0 THEN
    L_PagePr.PagePr_BeforePrintLine(DEPTH(^(GetPartName("ChgMDK1"))) +
                                    DEPTH(^(GetPartName("ChgMDK2"))) +
                                    DEPTH(^(GetPartName("ChgLine"))));
    MAKEPART(R, ^(GetPartName("ChgMDK1")));
    MAKEPART(R, ^(GetPartName("ChgMDK2")));
    CurPageTop:=GetPartName("ChgMDK2");
    SELECT(MS_D1, MS_D1, , Storage.Storage, _MDocKind);
    WHILE OCCURE(MS_D1) DO
     IF MS_D1.Illegal THEN
      SEARCH(MDoc, MDoc, , MS_D1.MDocKind, MS_D1.MDoc);
      CONFORM(MDoc, Staff, Man);
      CONFORM(MDoc, Dest);
      L_PagePr.PagePr_BeforePrintLine(DEPTH(^(GetPartName("ChgLine"))));
      MAKEPART(R, ^(GetPartName("ChgLine")));
     END;
     NEXT(MS_D1);
    END; (* WHILE OCCURE(MS_D1) ... *)
   END;
  END;
 END {Make};

 PRIVATE PROCEDURE MakeTotals(Header: STRING[]);
  VAR
   _In,
   _Out: NUMERIC[2];
 BEGIN
  L_PagePr.PagePr_BeforePrintLine(DEPTH(^(GetPartName("TopTot1"))) +
                                  DEPTH(^(GetPartName("TopTot2"))) +
                                  DEPTH(^(GetPartName("MathTotLine"))));
  MAKEPART(R, ^(GetPartName("TopTot1")), Header);
  MAKEPART(R, ^(GetPartName("TopTot2")));
  CurPageTop:=GetPartName("TopTot2");
  SELECT(MS_DL, Math, , Storage.Storage);
  WHILE OCCURE(MS_DL) DO
   SETZERO(_In, _Out);
   CHANGESEL(MS_DL, Math, , Storage.Storage, MS_DL.Math);
   SEARCH(Math, Math, , MS_DL.Math);
   WHILE OCCURE(MS_DL) DO
    PROMPT(" ⮣ " +  MS_DL.Math);
    INC(_In, MS_DL.In);
    INC(_Out, MS_DL.Out);
    NEXT(MS_DL);
   END; (* WHILE OCCURE(MS_DL) ... *)
   LAST(MS_DL);
   CHANGESEL(MS_DL, Math, , Storage.Storage);
   L_PagePr.PagePr_BeforePrintLineAtLast(~NEXT(MS_DL),
                                         DEPTH(^(GetPartName("MathTotLine"))));
   MAKEPART(R, ^(GetPartName("MathTotLine")),
            L_MathR.DefaultFormatCir(Math.Math, _In),
            L_MathR.DefaultFormatCir(Math.Math, _Out));
  END; (* WHILE OCCURE(MS_DL) ... *)
 END {MakeTotals};

 PRIVATE PROCEDURE FoundNearestShiftBeg(VAR BDShift: DATE;
                                VAR BTShift: TIME;
                                ShiftLength: NUMERIC[3];
                                RepDate    : DATE;
                                RepTime    : TIME): SCAL[2];
  VAR
   BShift,
   EShift,
   _RepDate: NUMERIC[3];
   EDShift: DATE;
   ETShift: TIME;
 BEGIN
  PackVARIANTDATE(BShift, BDShift, BTShift);
  ETShift:=BTShift + Math.Mod(ShiftLength, 24);
  EDShift:=BDShift + Math.Div(ShiftLength, 24) + (ETShift < BTShift);
  PackVARIANTDATE(EShift, EDShift, ETShift);
  PackVARIANTDATE(_RepDate, RepDate, RepTime);
  IF (_RepDate >= BShift) & (_RepDate <= EShift) THEN
   RETURN 1;
  ELSE
   BTShift:=ETShift;
   BDShift:=EDShift;
   RETURN 0;
  END;
 END {FoundNearestShiftBeg};

 PRIVATE PROCEDURE _RprtTop(Mode: SCAL[20]);
  VAR
   _Login: STRING[];
 BEGIN
  IF Mode = L_PagePr.m_Print THEN
   IF ~!_AcsObj THEN
    SEARCH(AcsObj, AcsObj, , _AcsObj);
    _Login:=AcsObj.Name + " " + L_AR.GetAcsObjManName();
   ELSE
    SETEMPTY(_Login);
   END;
   MAKEPART(R, ^(GetPartName("Top")),
            _Login);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtTop};

 PRIVATE PROCEDURE _PageTop(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Print THEN
   IF (PAGENUM(R) > 1) THEN
    MAKEPART(R, ^(GetPartName("PageTop")));
    MAKEPART(R, ^CurPageTop);
   END;
  ELSIF Mode = L_PagePr.m_RDoneTop THEN
   MAKEPART(R, ^(GetPartName("PageTop")));
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageTop};

 PRIVATE PROCEDURE _PageBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(^(GetPartName("PageBot"))));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, ^(GetPartName("PageBot")));
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_None);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageBot};

 PRIVATE PROCEDURE _RprtBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(^(GetPartName("Bot"))));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, ^(GetPartName("Bot")));
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_Fill);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtBot};

 PRIVATE PROCEDURE _Filling(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(^(GetPartName("EmptyLine"))));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, ^(GetPartName("EmptyLine")));
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_Filling};

 VAR
  BDate,
  EDate      : DATE;
  DefBegTime,
  BTime,
  ETime      : TIME;
  ShiftLength: NUMERIC[3];
  CurPageTop : STRING[];

 PUBLIC PROCEDURE MakeRep(trgDefaultStorageMode: SCAL[2]);
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  DefaultStorageMode:=trgDefaultStorageMode;
  IF ~DefaultStorageMode THEN
   L_General.Assert(ACCESS(Storage), " ⠭ ⥪饥  ࠭");
  ELSE
   IF ~!L_Stock.DefaultStorage() THEN
    SEARCH(Storage, Storage, , L_Stock.DefaultStorage());
    L_General.Assert(P_Storage.IsOnLine(Storage.Storage, Memo.ud_cd()),
                     " " + Storage.Storage + " ࠡ⠥   ॠ쭮 ६");
   ELSE
    L_General.Error(" ⠭   㬮砭");
   END;
  END;

  P_Storage.GetShiftParams(Storage.Storage, Memo.ud_cd(), DefBegTime, ShiftLength);
 
  BDate:=Memo.ud_cd();
  BTime:=DefBegTime;
 
  IF BDate >= SYSDATE() THEN
   BDate:=SYSDATE();
   EDate:=BDate;
   ETime:=SYSTIME();
   IF ETime >= BTime THEN
    LOOP
     IF FoundNearestShiftBeg(BDate, BTime, ShiftLength, EDate, ETime) THEN
      EXIT
     END;
    END; (* LOOP *)
   ELSE
    DEC(BDate, Math.Div(ShiftLength, 24));
   END;
  ELSE
   ETime:=BTime + Math.Mod(ShiftLength, 24);
   EDate:=BDate + Math.Div(ShiftLength, 24) + (ETime < BTime);
  END;
 
  IF P_Storage.IsOnLine(Storage.Storage, Memo.ud_cd()) THEN
   STDFORM(L_StdFrm.sf_Choice("" + GetStorageName() +
                              "|" +
                              "|%#############% %##########% %#####%" +
                              "|" +
                              "|%#############% %##########% %#####%",
                              "%<砫 ᬥ>T" +
                              "%<D.N.y>I" +
                              "%<H:M>I" +
                              "%<砭 ᬥ>T" +
                              "%<D.N.y>I" +
                              "%<H:M>I"),
           " ਮ ࠡ ᬥ ", , 1, BDate, BTime, EDate, ETime);
   _AcsObj:=L_XDoc.ChooseAcsObj(L_XDoc.xdt_MDoc, BDate, EDate, BTime, ETime, PROCREF(IsNeedDoc));
  ELSE
   _AcsObj:="";
  END;
 
  Create_MS_DL();
 
  IF (L_MDoc.E_MDocPrinterType(Memo.ud_cd()) = L_MDoc.mdpt_TM) THEN
   Prefix:="TM";
   OPENREP(R, L_General.NameConnection(RepName), Create);
   SetPrintAttr(R, Orientation,     Portrait,
                   PaperForm,       ^(L_Print.Cheque_PaperForm()),
                   TopMargin,       10,
                   BottomMargin,    10,
                   LeftMargin,      0,
                   RightMargin,     0,
                   FontEnlargement, 1.2,
                   FontWHRatio,     0.41);
  ELSE
   Prefix:="XX";
   OPENREP(R, L_General.NameConnection(RepName), Create);
  END;
 
  L_PagePr.PagePr_Init("R", 64, PROCREF(_RprtTop),
                                PROCREF(_PageTop),
                                PROCREF(_PageBot),
                                PROCREF(_RprtBot),
                                PROCREF(_Filling));
  Gather();
  SELECT(MS_DL, MS_DL);
  WHILE OCCURE(MS_DL) DO
   CHANGESEL(MS_DL, MS_DL, , MS_DL.Storage);
   SAVE(MS_DL);
 
   SELECT(Storage, Storage, , MS_DL.Storage);
   L_PagePr.PagePr_BeforePrintLine(DEPTH(^(GetPartName("StorageTop"))) +
                                   DEPTH(^(GetPartName("TopMDK1"))) +
                                   DEPTH(^(GetPartName("TopMDK2"))) +
                                   DEPTH(^(GetPartName("MathLine"))));
   MAKEPART(R, ^(GetPartName("StorageTop")));
 
   SELECT(MDocKind, MDocKind);
   WHILE OCCURE(MDocKind) DO
    IF MDocKind.Activity THEN
     Make(MDocKind.MDocKind, MDocKind.MDocKind+" "+MDocKind.Sign+" "+MDocKind.Name);
    END;
    NEXT(MDocKind);
   END; (* WHILE OCCURE(MDocKind) ... *)
   IF P_Storage.IsFuelStation(Storage.Storage) THEN
    MakeTotals("室-室   ꥪ⠬");
   END;
 
   RESTORE(MS_DL);
   LAST(MS_DL);
   CHANGESEL(MS_DL, MS_DL);
   NEXT(MS_DL);
  END; (* WHILE OCCURE(MS_DL) ... *)
 
  L_PagePr.PagePr_Done();
  CLOSEREP(R);
 
  L_AFM.AF_PurgeTemp("MS_DL");
  L_AFM.AF_PurgeTemp("MS_D1");
  LIKEMENU(Survey, "");
 END {MakeRep};

END.
