(*
%Copyright   (c) Polak IT
%Author      04.11.2003 18:47:23 POLAK\Bor
%Purpose     
%Type        report
%Specific    AP
%Modified    15.01.2013 09:06:00 POLAK\MLB
%Environment
*)

 MODULE Otp10 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_OwnData, L_Basis, L_Way, D_TP, Memo, FIO, L_Str, L_bp;

(*
$P{ Top07:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
?, L, "D.N.y"
?, L, "H:M"
?, L, "H:M"
?, L, "H:M"
?, L, "H:M"
?, L, "H:M"
?, L, "H:M"
@
############################################################################### ########## #####
=#####==========================================================================================
|                          ਮ  ##########  ##########                           |
|----------------------------------------------------------------------------------------------|
|    |     #####    |     #####    |     #####    |     #####    |     #####    |     #####    |
||--------------|--------------|--------------|--------------|--------------|--------------|
|    |  ⪫|  ⪫|  ⪫|  ⪫|  ⪫|  ⪫|
|----|--------------|--------------|--------------|--------------|--------------|--------------|
}
*)

(*
$P{ Line07:
OTP1.Route, L, ""
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
@
|####|#### #### ####|#### #### ####|#### #### ####|#### #### ####|#### #### ####|#### #### ####|
}
*)

(*
$P{ Bot07:
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
@
|----|--------------|--------------|--------------|--------------|--------------|--------------|
|⮣|#### #### ####|#### #### ####|#### #### ####|#### #### ####|#### #### ####|#### #### ####|
|----------------------------------------------------------------------------------------------|
|                                                               ᥣ   ਮ   ####    |
|                                                                                 䠪 ####    |
|                                                                                 ⪫ ####    |
=(c) Polak======================================================================================
}
*)

 PRIVATE PROCEDURE MakeHeaderOTP10(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "K");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ॢ");
  L_Basis.wb_WrInQM(F, " ॢ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "⨬");
  L_Basis.wb_WrInQM(F, "⬥⪠");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "㯯 ப");
  L_Basis.wb_WrInQM(F, "㯯 ப");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_TermLine(F);
 END {MakeHeaderOTP10};

 PRIVATE PROCEDURE MakePartOTP10(F: STRING[]; _Plan, _Fact: NUMERIC[0]; _Change: D_TP.tOTP_Change; EPer: DATE);
 BEGIN
  CONFORM(OTP1, Route);
  CONFORM(OTP1, MarkG);
  L_Basis.wb_WrScl(F, OTP1.Column);
  L_Basis.wb_WrStr(F, OTP1.Route);
  L_Basis.wb_WrStr(F, Route.Name);
  L_Way.StandOnRouteTKind(EPer);
  L_General.CallUs(OCCURE(TKind));
  L_Basis.wb_WrScl(F, TKind.TKind);
  L_Basis.wb_WrStr(F, TKind.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("㤭|室", OTP1.WD));
  L_Basis.wb_WrStr(F, L_Way.PasVolEnum2Sign(OTP1.MPVol));
  L_Basis.wb_WrStr(F, L_Way.GetCtrlTimes(OTP1.CtrlTime));
  L_Basis.wb_WrNum(F, _Plan, 0);
  L_Basis.wb_WrNum(F, _Fact, 0);
  IF ~!OTP1.Mark THEN
   CONFORM(OTP1, Mark);
   L_Basis.wb_WrStr(F, Mark.Name);
   L_Basis.wb_WrScl(F, MarkG.MarkG);
   L_Basis.wb_WrScl(F, MarkG.Name);
  ELSE
   L_Basis.wb_WrStr(F, "-------------------");
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "----");
  END;
  L_Basis.wb_WrStr(F, FLDTOSTR(_Change, "ᬥ|ᬥ"));
  L_Basis.wb_TermLine(F);
 END {MakePartOTP10};

 PUBLIC PROCEDURE Otp10();
  CONST
   bpId = "Otp10";
  VAR
   _Plan,
   _Fact: NUMERIC[0][MAXOF(D_TP.tOTP_Change)+1];
   Need : SCAL[2][MAXOF(D_TP.tOTP_Change)+1];
   i    : NUMERIC[0];
   BPer,
   EPer : DATE;
 BEGIN
  L_bp.Begin(bpId, " ᪠", L_bp.t_Basis, L_General.tc_inIntvl);

  BPer:=Memo.ud_fr();
  EPer:=Memo.ud_ut();
  D_TP.PrepareOTP1(1, BPer, EPer);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeaderOTP10("R");

  SELECT(OTP1, BoxNbr);
  WHILE OCCURE(OTP1) DO
   PROMPT(FLDTOSTR(OTP1.BoxNbr));
   SETZERO(_Plan, _Fact, Need);
   CHANGESEL(OTP1, BoxNbr, , OTP1.BoxNbr, OTP1.Route, OTP1.Mark, OTP1.MarkG,
                             OTP1.WD, OTP1.CtrlTime, OTP1.Column, OTP1.MPVol);
   WHILE OCCURE(OTP1) DO
    IF OTP1.InOtp THEN
     INC(_Plan[OTP1.Change], OTP1.Plan);
     INC(_Fact[OTP1.Change], OTP1.Fact);
     Need[OTP1.Change]:=1;
    END;
    NEXT(OTP1);
   END; (* WHILE OCCURE(OTP1) ... *)
   LAST(OTP1);
   i:=0;
   WHILE i <= MAXOF(D_TP.tOTP_Change) DO
    IF Need[i] THEN
     MakePartOTP10("R", _Plan[i], _Fact[i], i, EPer);
    END;
    INC(i);
   END;
   CHANGESEL(OTP1, BoxNbr);
   NEXT(OTP1);
  END; (* WHILE OCCURE(OTP1) ... *)
  FIO.Close(R);
  L_bp.End();
 END {Otp10};

 PRIVATE PROCEDURE MakeHeaderOTP11(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "K");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ॢ");
  L_Basis.wb_WrInQM(F, " ॢ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "⨬");
  L_Basis.wb_WrInQM(F, "⬥⪠");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠦ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "㯯 ப");
  L_Basis.wb_WrInQM(F, "㯯 ப");
  L_Basis.wb_WrInQM(F, " ࠡ");
  L_Basis.wb_WrInQM(F, " ࠡ");
  L_Basis.wb_WrInQM(F, " ᪥");
  L_Basis.wb_TermLine(F);
 END {MakeHeaderOTP11};

 PRIVATE PROCEDURE MakePartOTP11(F: STRING[]; _Plan, _Fact: NUMERIC[0]; OnDate: DATE);
 BEGIN
  CONFORM(OTP1, Route);
  CONFORM(OTP1, MarkG);
  CONFORM(OTP1, WJMode);
  L_Basis.wb_WrScl(F, OTP1.Column);
  L_Basis.wb_WrStr(F, OTP1.Route);
  L_Basis.wb_WrStr(F, Route.Name);
  L_Way.StandOnRouteTKind(OnDate);
  L_General.Assert(OCCURE(TKind), " 㤠 ।  ॢ  " + L_DatTim.DateStr(OnDate));
  L_Basis.wb_WrScl(F, TKind.TKind);
  L_Basis.wb_WrStr(F, TKind.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("㤭|室", OTP1.WD));
  L_Basis.wb_WrStr(F, L_Way.PasVolEnum2Sign(OTP1.MPVol));
  L_Basis.wb_WrStr(F, L_Way.GetCtrlTimes(OTP1.CtrlTime));
  L_Basis.wb_WrNum(F, _Plan, 0);
  L_Basis.wb_WrNum(F, _Fact, 0);
  IF ~!OTP1.BoxNbr THEN
   L_Basis.wb_WrScl(F, OTP1.BoxNbr);
   CONFORM(OTP1, Mark);
   L_Basis.wb_WrStr(F, Mark.Name);
   L_Basis.wb_WrScl(F, MarkG.MarkG);
   L_Basis.wb_WrScl(F, MarkG.Name);
  ELSE
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "-------------------");
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "----");
  END;
  L_Basis.wb_WrStr(F, OTP1.WJCode);
  L_Basis.wb_WrStr(F, WJMode.Name);
  L_Basis.wb_WrStr(F, FLDTOSTR(OTP1.InOtp, "-|+"));
  L_Basis.wb_TermLine(F);
 END {MakePartOTP11};

 PUBLIC PROCEDURE Otp11();
  CONST
   bpId = "Otp11";
  VAR
   _Plan,
   _Fact: NUMERIC[0];
   OnDate: DATE;
 BEGIN
  L_bp.Begin(bpId, " ᪠  ஢ 室", L_bp.t_Basis, L_General.tc_onDate);
  OnDate:=Memo.ud_cd();
  D_TP.PrepareOTP1(1, OnDate, OnDate);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeaderOTP11("R");
  SELECT(OTP1, BoxNbr);
  WHILE OCCURE(OTP1) DO
   PROMPT(FLDTOSTR(OTP1.BoxNbr));
   SETZERO(_Plan, _Fact);
   CHANGESEL(OTP1, BoxNbr, , OTP1.BoxNbr, OTP1.Route, OTP1.Mark, OTP1.MarkG,
                             OTP1.WD, OTP1.CtrlTime, OTP1.Column, OTP1.MPVol,
                             OTP1.InOtp, OTP1.WJCode);
   WHILE OCCURE(OTP1) DO
    INC(_Plan, OTP1.Plan);
    INC(_Fact, OTP1.Fact);
    NEXT(OTP1);
   END; (* WHILE OCCURE(OTP1) ... *)
   LAST(OTP1);
   MakePartOTP11("R", _Plan, _Fact, OnDate);
   CHANGESEL(OTP1, BoxNbr);
   NEXT(OTP1);
  END; (* WHILE OCCURE(OTP1) ... *)
  FIO.Close(R);
  L_bp.End();
 END {Otp11};

 PRIVATE PROCEDURE Delta(d: NUMERIC[0]): STRING[];
 BEGIN
  IF d = 0 THEN
   RETURN "";
  ELSE
   RETURN FLDTOSTR(d, "0");
  END;
 END {Delta};

 PUBLIC PROCEDURE Otp07();
  CONST
   RepName     = "Otp07";
   NumOfPoints = 6;
  VAR
   CtrlTimes: TIME[NumOfPoints];
   dPlan,
   dFact: NUMERIC[0];
   tPlan,
   tFact,
   _Plan,
   _Fact: NUMERIC[0][NumOfPoints];
   i    : NUMERIC[0];
   Has  : SCAL[2];
   BPer,
   EPer : DATE;
 BEGIN
  BPer:=Memo.ud_fr();
  EPer:=Memo.ud_ut();
  D_TP.PrepareOTP1(1, BPer, EPer);
  L_General.Assert(SEARCH(Calendar, Date, BPer), "    " + L_DatTim.DateStr(BPer));
  L_Way.SetCtrlTimes(BPer, Calendar.WDWay, CtrlTimes);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top07, RepName, BPer, EPer,
                              CtrlTimes[0], CtrlTimes[1], CtrlTimes[2],
                              CtrlTimes[3], CtrlTimes[4], CtrlTimes[5]);
   SETZERO(tPlan, tFact, dPlan, dFact);
  SELECT(OTP1, Route);
  WHILE OCCURE(OTP1) DO
   PROMPT(": "+OTP1.Route);
   SETZERO(_Plan, _Fact, Has);
   CHANGESEL(OTP1, Route, , OTP1.Route);
   WHILE OCCURE(OTP1) DO
    IF OTP1.InOtp THEN
     Has:=1;
     i:=0;
     WHILE i < NumOfPoints DO
      IF OTP1.CtrlTime = CtrlTimes[i] THEN
       INC(_Plan[i], OTP1.Plan);
       INC(_Fact[i], OTP1.Fact);
       INC(tPlan[i], OTP1.Plan);
       INC(tFact[i], OTP1.Fact);
      END;
      INC(i);
     END;
     IF OTP1.CtrlTime = L_Way.DayPoint() THEN
      INC(dPlan, OTP1.Plan);
      INC(dFact, OTP1.Fact);
     END;
    END; (* IF OTP1.InOtp ... *)
    NEXT(OTP1);
   END; (* WHILE OCCURE(OTP1) ... *)
   LAST(OTP1);
   IF Has THEN
    MAKEPART(R, Line07, _Plan[0], _Fact[0], Delta(_Fact[0]-_Plan[0]),
                        _Plan[1], _Fact[1], Delta(_Fact[1]-_Plan[1]),
                        _Plan[2], _Fact[2], Delta(_Fact[2]-_Plan[2]),
                        _Plan[3], _Fact[3], Delta(_Fact[3]-_Plan[3]),
                        _Plan[4], _Fact[4], Delta(_Fact[4]-_Plan[4]),
                        _Plan[5], _Fact[5], Delta(_Fact[5]-_Plan[5]));
   END;
   CHANGESEL(OTP1, Route);
   NEXT(OTP1);
  END; (* WHILE OCCURE(OTP1) ... *)
  MAKEPART(R, Bot07, tPlan[0], tFact[0], Delta(tFact[0]-tPlan[0]),
                     tPlan[1], tFact[1], Delta(tFact[1]-tPlan[1]),
                     tPlan[2], tFact[2], Delta(tFact[2]-tPlan[2]),
                     tPlan[3], tFact[3], Delta(tFact[3]-tPlan[3]),
                     tPlan[4], tFact[4], Delta(tFact[4]-tPlan[4]),
                     tPlan[5], tFact[5], Delta(tFact[5]-tPlan[5]),
                     dPlan,    dFact,    Delta(dFact-dPlan));
  CLOSEREP(R);
 END {Otp07};

END.
