(*
%Copyright   (c) Polak IT
%Author      27.01.2012 15:24:35 POLAK\MLB
%Purpose
%Type        report
%Specific    AP
%Modified    11.03.2014 18:33:59 POLAK\GAV
%Environment
*)

 IMPORT L_General, Memo, FIO, L_Str, L_DatTim, L_Basis, L_bp,
        L_ODoc, L_Man, L_Staff, L_Car, L_Russia, L_Way, L_BegRWS, L_kn;

 PRIVATE PROCEDURE RA001_MakeTop();
 BEGIN
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "७ ");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", " ");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "६");
  L_Basis.wb_WrInQM("F", "६ ⮪");
  L_Basis.wb_WrInQM("F", " ࠡ祣 ६");
  L_Basis.wb_WrInQM("F", " ( ) ᫥ 室");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "ࠦ");
  L_Basis.wb_WrInQM("F", "᭮");
  L_Basis.wb_WrInQM("F", "ઠ");
  L_Basis.wb_WrInQM("F", "ઠ");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", " ॣ樨");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "⥣");
  L_Basis.wb_WrInQM("F", "⥣");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "⠦ ");
  L_Basis.wb_WrInQM("F", "⠦ 楢");
  L_Basis.wb_WrInQM("F", "⠦ ");
  L_Basis.wb_WrInQM("F", "⠦  ( ।⨨)");
  L_Basis.wb_WrInQM("F", "⠦ 楢 ( ।⨨)");
  L_Basis.wb_WrInQM("F", "⠦  ( ।⨨)");
  L_Basis.wb_WrInQM("F", " ");
  L_Basis.wb_WrInQM("F", " ");
  L_Basis.wb_WrInQM("F", "祭 ");
  L_Basis.wb_WrInQM("F", "/");
  L_Basis.wb_TermLine("F");
 END {RA001_MakeTop};

 PRIVATE PROCEDURE GetDayNumberAfterRest(): NUMERIC[0];
  VAR
   trgD,
   curD,
   rwsD       : DATE;
   IsRealRWayS: SCAL[2];
 BEGIN
  APP.Get().NewPrompt("  ( ) ᫥ 室  " + L_DatTim.DateStr(RWayS.Date));
  trgD:=RWayS.Date;
  curD:=trgD;
  TRY
   CHANGESEL(RWayS, TSN, , RWayS.TSN);
   LOOP
    IF ~PREV(RWayS) THEN
     EXIT;
    END;
    IsRealRWayS:=0;
    SELECT(RWayJ, RWayS, , RWayS.RWayS);
    WHILE OCCURE(RWayJ) & ~IsRealRWayS DO
     CONFORM(RWayJ, WJMode);
     IsRealRWayS:=WJMode.WJType # L_Way.WJType_Void;
     NEXT(RWayJ);
    END; (* WHILE OCCURE(RWayJ) ... *)
    IF IsRealRWayS THEN
     IF RWayS.Date < curD  THEN
      LAST(RWayJ);
      rwsD:=RWayS.Date + RWayJ.Day - 1;
      rwsD:=L_BegRWS.DspDate(rwsD, RWayJ.StopT);
     ELSE
      rwsD:=RWayS.Date;
     END;
     IF rwsD < (curD - 1) THEN
      EXIT;
     END;
     curD:=RWayS.Date;
    END; (* IF IsRealRWayS *)
   END; (* LOOP *)
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
  RETURN trgD-curD+1;
 END {GetDayNumberAfterRest};

 PRIVATE PROCEDURE RA001_MakeLine();
  VAR
   DaysDriver,
   MonthsDriver,
   YearsDriver,
   DaysDrInFirm,
   MonthsDrInFirm,
   YearsDrInFirm  : NUMERIC[0];
   dummy1,
   dummy2         : NUMERIC[6];
 BEGIN
  APP.Get().NewPrompt("㧪 㬥   " + ODoc.ODocKind + " " + ODoc.ODoc);
  L_Basis.wb_WrScl("F", ODoc.ODoc);
  L_Basis.wb_WrScl("F", ODoc.SrcNbr);
  L_Basis.wb_WrScl("F", L_Str.PoolItem(L_ODoc.StatusPool(0), ODoc.Status));
  L_Basis.wb_WrDat("F", RWayS.Date);
  L_Basis.wb_WrStr("F", L_DatTim.WeekDayStr(L_DatTim.WEEKDAY(RWayS.Date), 0));
  L_Basis.wb_WrStr("F", L_DatTim.MonthStr(RWayS.Date, 0));
  L_Basis.wb_WrTim("F", RAccid.Time);
  L_Basis.wb_WrStr("F", FLDTOSTR(RAccid.Time, "H"));
  L_Basis.wb_WrNum("F", L_DatTim.GetVARIANTDATEPeriod_Hour(L_DatTim.GetVARIANTDATE(RWayS.Date, RWayS.StartTim, 0),
                                                           L_DatTim.GetVARIANTDATE(ODoc.Date,  RAccid.Time,    0)),
                        0);
  L_Basis.wb_WrNum("F", GetDayNumberAfterRest(), 0);
  L_Basis.wb_WrScl("F", RWayS.RWayS);
  L_Basis.wb_WrScl("F", RWayS.BoxNbr);
  L_Basis.wb_WrScl("F", Car.StateNbr);
  L_Basis.wb_WrScl("F", Mark.Mark);
  L_Basis.wb_WrStr("F", Mark.Name);
  L_Basis.wb_WrScl("F", Staff.TSN);
  L_Basis.wb_WrStr("F", Man.Name);
  L_Man.AccessRgManAdr(Man.Man, RWayS.Date);
  CONFORM(ManAdr, Country);
  IF    Country.Country # L_Russia.c_Russia THEN
   L_Basis.wb_WrStr("F", "࠭");
  ELSIF L_Man.IsLocalManAdr(RWayS.Date) THEN
   L_Basis.wb_WrStr("F", "");
  ELSE
   L_Basis.wb_WrStr("F", "த");
  END;
  L_Basis.wb_WrScl("F", Sort.Sort);
  L_Basis.wb_WrStr("F", Sort.Name);
  L_Basis.wb_WrScl("F", Union.Union);
  L_Basis.wb_WrStr("F", Union.Name);
  L_Basis.wb_WrScl("F", Post.Post);
  L_Basis.wb_WrStr("F", Post.Name);
  L_Man.FillStageDriver(ODoc.Date, DaysDriver,   MonthsDriver,   YearsDriver,
                                   DaysDrInFirm, MonthsDrInFirm, YearsDrInFirm,
                                   dummy1, dummy2);
  L_Basis.wb_WrNum("F", YearsDriver, 0);
  L_Basis.wb_WrNum("F", MonthsDriver, 0);
  L_Basis.wb_WrNum("F", DaysDriver, 0);
  L_Basis.wb_WrNum("F", YearsDrInFirm, 0);
  L_Basis.wb_WrNum("F", MonthsDrInFirm, 0);
  L_Basis.wb_WrNum("F", DaysDrInFirm, 0);
  IF ~!RAccid.Place THEN
   L_Basis.wb_WrStr("F", RAccid.Place);
  ELSE
   L_Basis.wb_WrStr("F", "----------");
  END;
  IF ~!RAccid.Kind THEN
   L_Basis.wb_WrStr("F", L_Str.PoolItem(L_ODoc.k_pool, RAccid.Kind));
  ELSE
   L_Basis.wb_WrStr("F", "----------");
  END;
  IF ~!RAccid.Intoxic THEN
   L_Basis.wb_WrStr("F", L_Str.PoolItem(L_ODoc.i_pool, RAccid.Intoxic));
  ELSE
   L_Basis.wb_WrStr("F", "----------");
  END;
  L_Basis.wb_WrStr("F", L_Str.PoolItem("|", ~!RAccid.Violat));
  L_Basis.wb_TermLine("F");
 END {RA001_MakeLine};

 PUBLIC PROCEDURE RA001();
  CONST
   bpId = "RA001";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, " ⮢  ", L_bp.t_Basis, L_General.tc_inIntvl);
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  APP.Get().NewPrompt(bpId);
  RA001_MakeTop();
  SELECT(ODoc, ODKDate);
  WHILE OCCURE(ODoc) DO
   NARROWSEL(ODoc, ODocKind);
   CONFORM(ODoc, ODocKind);
   IF L_kn.Is(ODoc.Date, L_ODoc.erkn_RAccid) THEN
    SRCINSEL(ODoc, GE, , Memo.ud_fr());
    WHILE OCCURE(ODoc) & (ODoc.Date <= Memo.ud_ut()) DO
     PROMPT(ODoc.ODocKind + " " + ODoc.ODoc);
     IF ODoc.Status # L_ODoc.ods_Canceled THEN
      L_General.CallUs(SEARCH(RAccid, XDocId, ODoc.XDocId));
      CONFORM(RAccid, RWayS);
      CONFORM(RWayS, Car);
      L_Car.AccessMark(Car.BoxNbr, ODoc.Date);
      CONFORM(ODoc, Staff);
      CONFORM(Staff, Man);
      L_Staff.PosToStaffLog(Staff.TSN, ODoc.Date, 1);
      CONFORM(StaffLog, Sort);
      CONFORM(StaffLog, Officer);
      CONFORM(Officer, Union);
      CONFORM(Officer, Post);
      RA001_MakeLine();
     END;
     NEXT(ODoc);
    END; (* WHILE OCCURE(ODoc) ... *)
   END; (* IF L_kn.Is(ODoc.Date, L_ODoc.erkn_RAccid)...*)
   NEXTINEXTENDEDSEL(ODoc, ODocKind);
  END; (* WHILE OCCURE(ODoc) *)
  FIO.Close(F);
  L_bp.End();
 END {RA001};

END.
