(*
%Copyright   (c) Polak IT
%Author      09.12.2003 17:23:04 POLAK\LDA
%Purpose     祭   祭묨 ६묨 ﬨ
%Type        report
%Specific    LOC
%Modified    04.03.2013 14:39:25 POLAK\LDA
%Environment
*)

 MODULE Rpr11 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Rpr, L_OwnData, L_General, L_DatTim, L_AFM, L_CUC, L_Car, L_Str;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
" " + L_DatTim.DateTimeStr(SYSDATE(), SYSTIME()), C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|############################################################################################################|
|############################################################################################################|
}
*)

(*
$P{ Line:
?, L, ""
@
|------------------------------------------------------------------------------------------------------------|
|                                                                                                            |
|##################################################                                                          |
}
*)

(*
$P{ Total:
?, L, ""
@
|------------------------------------------------------------------------------------------------------------|
|                                                                                                            |
|#########################################                                                                   |
|                                                                                                            |
}
*)


(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE Create_RprSList();
 BEGIN
  CreateFILE(RprSList, "", "᮪   ", "");

  CreateFIELD(RprSList, Group, STRING[10],      "", "", "", " 㯯஢ ", "");
  CreateFIELD(RprSList, RprS,  LIKE(RprS.RprS), "", "", "", " ", "");
  CreateFIELD(RprSList, RprT,  LIKE(RprT.RprT), "", "", "", " ", "");

  CreateINDEX(RprSList, Group, PLURAL, "", "", Group, RprS);
  CreateINDEXandLINK(RprSList, RprS,  PLURAL, RprS, RprS,  USER, "", "", RprS, RprT);
  SetVersionOfFILE(RprSList, 000);

  L_AFM.AF_CreateTemp("RprSList", "RprSList");
 END {Create_RprSList};

 PRIVATE PROCEDURE BegRep(RepName, Title: STRING[]);
 BEGIN
  L_Rpr.InitRprSReport(L_General.KioskExecution_IsRunning(), Title);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  SetPrintAttr(R,
               LeftMargin,      10,
               RightMargin,     10,
               TopMargin,       10,
               BottomMargin,    10,
               FontEnlargement, 1.2);
  MAKEPART(R, Top, RepName, Title);
 END {BegRep};

 PRIVATE PROCEDURE EndRep();
 BEGIN
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_Rpr.DoneRprSReport(L_General.KioskExecution_IsRunning());
 END {EndRep};

 PRIVATE PROCEDURE MakeIndex_Rpr11();
  VAR
   _PlnEDate: DATE;
   _PlnETime: TIME;
 BEGIN
  Create_RprSList();

  SELECT(RprS, cOrdDate, , 0);
  WHILE OCCURE(RprS) DO
   PROMPT("⮢  " + RprS.RprS);
   SELECT(RprT, RprS, , RprS.RprS);
   WHILE OCCURE(RprT) DO
    IF (RprT.Result = L_Rpr.tr_InProgress) &
       L_Rpr.HasRprTNotification()         &
       (L_DatTim.GetVARIANTDATE(RprT.BDate, RprT.BTime, 00) < L_DatTim.GetSysVARIANTDATE()) THEN
     L_Rpr.GetRprTEndDateTime(_PlnEDate, _PlnETime);
     IF L_Rpr.SysOverTime(_PlnEDate, _PlnETime) > 0 THEN
      DEFAULT(RprSList);
      RprSList.RprS :=RprS.RprS;
      RprSList.RprT :=RprT.RprT;
      INSERT(RprSList);
     END;
    END;
    NEXT(RprT);
   END; (* WHILE OCCURE(RprT) ... *)
   NEXT(RprS);
  END; (* WHILE OCCURE(RprS) ... *)
 END {MakeIndex_Rpr11};

 PUBLIC PROCEDURE Rpr11();
  CONST
   RepName = "Rpr11";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  MakeIndex_Rpr11();
  BegRep(RepName, "祭   祭묨 ६묨 ﬨ");
  SELECT(RprSList, RprS);
  WHILE OCCURE(RprSList) DO
   CHANGESEL(RprSList, RprS, , RprSList.RprS);
   CONFORM(RprSList, RprS);
   PROMPT(" " + RprS.RprS);
   L_Rpr.SinglePrintRprS("R", L_Rpr.pro_RprObj, L_General.KioskExecution_IsRunning(), 0, L_General.EMPTY_NUMBER(), L_Rpr.pr_Length);
   WHILE OCCURE(RprSList) DO
    SEARCH(RprT, RprS, , RprSList.RprS, RprSList.RprT);
    L_Rpr.SinglePrintRprT("R", L_Rpr.pro_RprObj, L_General.KioskExecution_IsRunning(), 0, L_General.EMPTY_NUMBER(), L_General.EMPTY_NUMBER(), L_Rpr.pr_Length);
    NEXT(RprSList);
   END; (* WHILE OCCURE(RprSList) ... *)
   LAST(RprSList);
   CHANGESEL(RprSList, RprS);
   NEXT(RprSList);
  END; (* WHILE OCCURE(RprSList) ... *)
  EndRep();
 END {Make_Rpr11};

 PRIVATE PROCEDURE Create_RprSL();
 BEGIN
  CreateFILE(RprSL, "", "᮪   ", "");

  CreateFIELD(RprSL, Group,      STRING[32],          "", "", "", " 㯯஢ ", "");
  CreateFIELD(RprSL, prnOrdDTS,  TIMESTAMP,           "", "", "", " ᮧ ᭮ ", "");
  CreateFIELD(RprSL, OrdDTS,     TIMESTAMP,           "", "", "", " ᮧ ", "");
  CreateFIELD(RprSL, RprS,       LIKE(RprS.RprS),     "", "", "", " ", "");
  CreateFIELD(RprSL, CUCopy,     LIKE(CUCopy.CUCopy), "", "", "", "ꥪ ६", "");

  CreateINDEX(RprSL, Group, UNIQUE, "", "", Group, prnOrdDTS, OrdDTS, RprS);
  CreateINDEX(RprSL, CUCopy,  PLURAL, "", "", Group, CUCopy);
  SetVersionOfFILE(RprSL, 000);

  L_AFM.AF_CreateTemp("RprSL", "RprSL");
 END {Create_RprSL};

 PRIVATE PROCEDURE MakeIndex_Rpr12();
 BEGIN
  Create_RprSL();
  SELECT(RprS, cRprS, , 0);
  WHILE OCCURE(RprS) DO
   PROMPT("⮢  " + RprS.RprS);
   CONFORM(RprS, CUCopy);
   L_CUC.AccessOrigin();

   DEFAULT(RprSL);
   IF    L_Rpr.IsRprS_w_Car() THEN
    L_Car.StandOnCarLog(Car.BoxNbr, SYSDATE());
    CONFORM(CarLog, Column);
    RprSL.Group:=" " + CarLog.Column + " " + Column.Name;
   ELSIF L_Rpr.IsRprS_w_OutCar() THEN
    RprSL.Group:="஭ ";
   ELSIF L_Rpr.IsRprS_w_CarBlock() THEN
    RprSL.Group:="ॣ";
   ELSIF L_Rpr.IsRprS_w_OutCBlc() THEN
    RprSL.Group:="஭ ॣ";
   ELSIF L_Rpr.IsRprS_w_Math() THEN
    RprSL.Group:=" ॣ";
   ELSE
    L_General.CallUs(0);
   END;

   IF !RprS.Parent THEN
    RprSL.prnOrdDTS:=L_DatTim.GetTIMESTAMP(RprS.OrdDate, RprS.OrdTime);
   ELSE
    SAVE(RprS);
    SEARCH(RprS, RprS, , RprS.Parent);
    RprSL.prnOrdDTS:=L_DatTim.GetTIMESTAMP(RprS.OrdDate, RprS.OrdTime);
    RESTORE(RprS);
   END;
   RprSL.OrdDTS:=L_DatTim.GetTIMESTAMP(RprS.OrdDate, RprS.OrdTime);
   RprSL.RprS  :=RprS.RprS;
   RprSL.CUCopy:=RprS.CUCopy;
   INSERT(RprSL);

   NEXT(RprS);
  END; (* WHILE OCCURE(RprS) ... *)
 END {MakeIndex_Rpr12};

 PRIVATE PROCEDURE GetRepairAmount(trgGroup: STRING[]): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  SETZERO(Result);
  SAVE(RprSL);
  SELECT(RprSL, CUCopy, , trgGroup);
  WHILE OCCURE(RprSL) DO
   NARROWSEL(RprSL, CUCopy);
   INC(Result);
   NEXTINEXTENDEDSEL(RprSL, CUCopy);
  END; (* WHILE OCCURE(RprSL) ... *)
  RESTORE(RprSL);
  RETURN Result;
 END {GetRepairAmount};

 PUBLIC PROCEDURE Rpr12();
  CONST
   RepName = "Rpr12";
  VAR
   Total,
   Amount: NUMERIC[0];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  BegRep(RepName, "祭  ");
  MakeIndex_Rpr12();

  Total:=0;
  SELECT(RprSL, Group);
  WHILE OCCURE(RprSL) DO
   NARROWSEL(RprSL, Group);
   MAKEPART(R, Line, RprSL.Group);
   Amount:=GetRepairAmount(RprSL.Group);
   WHILE OCCURE(RprSL) DO
    SEARCH(RprS, RprS, , RprSL.RprS);
    PROMPT(" " + RprS.RprS);
    L_Rpr.intPrintRprS("R", L_Rpr.pro_RprObj, L_General.KioskExecution_IsRunning(), 1, L_General.EMPTY_NUMBER(), L_General.EMPTY_NUMBER());
    NEXT(RprSL);
   END; (* WHILE OCCURE(RprSL) ... *)
   INC(Total, Amount);
   MAKEPART(R, Total, "⮣  ६: " + L_Str.IntStr(Amount));
   NEXTINEXTENDEDSEL(RprSL, Group);
  END; (* WHILE OCCURE(RprSL) ... *)
  MAKEPART(R, Total, "ᥣ  ६: " + L_Str.IntStr(Total));
  EndRep();
 END {Rpr12};

END.
