(*
%Copyright   (c) Polak Computer System
%Author
%Purpose     ⮪ 
%Type        to paste
%Specific    AP
%Modified    06.03.2014 19:49:18 POLAK\Gina
%Environment
*)

 IMPORT L_Str, L_Way, L_AFM, L_OwnData, L_Car, P_Car, P_Mark, L_General, L_RWayS, P_OwnData;

(*
$P { BotExp1:
?, R, "2-"
?, R, "2-"
?, R, "3."
?, R, "3."
?, R, "3."
?, R, "3."
?, R, "3."
?, R, "3."
?, R, "3."
?, R, "3."
StExit.TotT, R, "3."
?, R, "3."
TotalRun, R, "2."
TotalRun-ZrRun, R, "2."
ZrRun, R, "2."
L_Way.RunBySM(), R, "0"
@
|稥 ⥫-----------------------------------------------------------|
| 窠 (/䠪᪠):                       ######### / #########|
| ⢮ ᮢ ࠡ                                           #########|
|  )   (ᥣ/ 㫥 ஡)             ######### / #########|
|  )                                                       #########|
|  )  ⮥                                                     #########|
|  )  १ࢥ                                                     #########|
|  )  ६                                                     #########|
|  )                                                     #########|
|  )   拉                                             #########|
|  ) ६  ࠪ                                                #########|
| ஡ (騩/ /㫥/ ᯨ): ####### /####### /####### /####|
|   ⠬:                                                             |
}

$P{ BotExpLine:
Route.Route, L, ""
Route.Name, L, ""
Exp01._Run, R, "2."
@
|               #### ############################################## #########|
}

$P{ BotExp2:
StExit.TripAm, R, "1."
?, R, "1."
L_Str.PoolItem("|室", RWayS.FuelNorm <= RWayS.FuelFact)+"):", L, ""
RWayS.FuelNorm, R, "4."
RWayS.FuelFact, R, "0"
Math.Abs(RWayS.FuelNorm-RWayS.FuelFact), R, "4."
RWayS.StartTim, L, "H:M"
?, L, "H:M"
?, R, "0"
@
|  (/䠪᪨):                               ###### / ######|
| 室 ⮯ (ଠ/䠪/############        ######### / #### / #########|
|  (砫 / 砭):                                   ##### / #####|
| ᠦ                                                         #########|
}
*)

 PROCEDURE IsRWayJwStaff(VAR CurWho: L_Way.tRWSWho; VAR _Number: LIKE(WayLMen.Number)): SCAL[2];
 BEGIN
  IF ~KioskMode | (RWayS.TSN = KioskTSN) THEN
   CurWho :=L_Way.rwswho_Dr_W_Gu;
   _Number:=1;
   RETURN 1;
  ELSE
   SELECT(WayLMen, RWayS, , RWayS.RWayS);
   WHILE OCCURE(WayLMen) DO
    IF (WayLMen.TSN = KioskTSN) & L_RWayS.IsRWayJForCurWayLMen() THEN
     IF WayLMen.Who = L_Way.wlmwho_SDriver THEN
      CurWho:=L_Way.rwswho_Dr_W_Gu;
     ELSE
      CurWho:=WayLMen.Who + 1;
     END;
     _Number:=WayLMen.Number;
     RETURN 1;
    END;
    NEXT(WayLMen);
   END; (* WHILE OCCURE(WayLMen) ... *)
  END;
  RETURN 0;
 END {IsRWayJwStaff};

 PROCEDURE MakeBotExp();
  VAR
   _IncPln,
   _IncFct: LIKE(RWayJ.PlIncome);
   _TripFct: LIKE(RWayJ.Fact);
   _RepairTim,
   _StandTim,
   _ResTim,
   _NightTim,
   _WorkTim,
   _LineTim,
   _OrdTim,
   _BadTim,
   _LineTimWork,
   CurTime: NUMERIC[3];
   _StopT : LTIME;
   _Psg   : NUMERIC[0];
   CurWho : L_Way.tRWSWho;
   _Number: LIKE(WayLMen.Number);
 BEGIN
  L_AFM.MakeMultipleIndex("Exp01", "_Route: LIKE(SEJobs.Route);"+
                                   "_Run  : LIKE(CarRun.Run)",
                                "Exp01: _Route");
  SETZERO(_IncPln, _IncFct, _WorkTim, _LineTim, _OrdTim, _BadTim, _LineTimWork,
          _StandTim, _ResTim, _RepairTim,
          _NightTim, _TripFct, _Psg);
  CONFORM(RWayS, RWayJ);
  _StopT:=C_T2L(RWayJ.Day, RWayJ.StartT);
  WHILE OCCURE(RWayJ) DO
   IF IsRWayJwStaff(CurWho, _Number) THEN
    CONFORM(RWayJ, RWayJP);
    WHILE OCCURE(RWayJP) DO
     IF    L_Way.TrIncFct(CurWho, _Number, RWayJP.RWJPro) THEN
      INC(_IncFct, RWayJP.Value);
     ELSIF L_Way.E_TrPsgFct(CurWho, _Number, RWayJP.RWJPro) THEN
      INC(_Psg, RWayJP.Value);
     END;
     NEXT(RWayJP);
    END; (* WHILE OCCURE(RWayJP) ... *)
    INC(_IncPln, RWayJ.PlIncome);
    CONFORM(RWayJ, Quality);
    IF Quality.Type # L_Way.QualType_Annul THEN
     CONFORM(RWayJ, SEJobs, WJMode, Route);
     L_Way.StandOnRouteTKind(RWayS.Date);
     ADD(Exp01, Exp01, , SEJobs.Route,
                         Exp01._Run, RWayJ.Run * RWayJ.Fact);
     CurTime:=RWayJ.StopT-RWayJ.StartT;
     IF Quality.Type = L_Way.QualType_Defect THEN
      INC(_BadTim, CurTime);
     END;
     IF WJMode.WJType # L_Way.WJType_Void THEN
      INC(_NightTim, TIMEINT(RWayJ.StartT, RWayJ.StopT, 22:00, 06:00));
      INC(_WorkTim, CurTime);
     END;
     IF (WJMode.IncSel * Route.IncSel > 0) &
        (WJMode.RunSel = L_Way.runsel_Work) & L_Way.RealRWayJTrip() THEN
      INC(_TripFct, RWayJ.Fact);
     END;
     IF TKind.Rgn = L_Way.tkrgn_Order THEN
      INC(_OrdTim, CurTime);
     ELSIF (WJMode.WJType = L_Way.WJType_Work) THEN
      IF WJMode.RunSel > L_Way.runsel_None THEN
       INC(_LineTim, CurTime);
       IF WJMode.RunSel = L_Way.runsel_Work THEN
        INC(_LineTimWork, CurTime);
       END;
      ELSE
       INC(_ResTim, CurTime);
      END;
     END;
     IF (WJMode.WJType = L_Way.WJType_Stand) THEN
      INC(_StandTim, CurTime);
     END;
     IF (WJMode.WJType = L_Way.WJType_Repair) THEN
      INC(_RepairTim, CurTime);
     END;
     _StopT:=C_T2L(RWayJ.Day + (RWayJ.StopT<RWayJ.StartT), RWayJ.StopT);
    END;
   END;
   NEXT(RWayJ);
  END; (* WHILE OCCURE(RWayJ) ... *)

  CONFORM(RWayS, StExit);
  MAKEPART(R, BotExp1, _IncPln, _IncFct, _WorkTim, _LineTim, _LineTimWork, _OrdTim, _StandTim, _ResTim,
                       _RepairTim, _NightTim, _BadTim);
  SELECT(Exp01, Exp01);
  WHILE OCCURE(Exp01) DO
   IF Exp01._Run # 0 THEN
    SEARCH(Route, Route, , Exp01._Route);
    MAKEPART(R, BotExpLine);
   END;
   NEXT(Exp01);
  END; (* WHILE OCCURE(Exp01) ... *)
  IF C_L2D(RWayS.StartTim) > 01 THEN
   MAKEPART(R, BotExp2, _TripFct, _StopT, _Psg);
  ELSE
   MAKEPART(R, BotExp2, _TripFct, C_L2T(_StopT), _Psg);
  END;
  L_AFM.AF_PurgeTemp("Exp01");
 END {MakeBotExp};

 CONST
  FRepName = "RWSFN";

(*$P { Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
FRepName, L, ""
RWayS.RWayS, L, ""
RWayS.Date, L, "D.N.y"
RWayS.Exit, L, ""
RWayS.Change, R, ""
RWayS.Gap, R, "-|+"
RWayS.Type, L, "0"
Car.BoxNbr, L, ""
Car.StateNbr, L, ""
Mark.Mark, L, ""
Mark.Name, L, ""
@
################################################################ ########## #####
=#####===========================================================================
                 ⮪   ⮯  ⥢ 
---------------------------------------------------------------------------------
: #######   : ##########   室: #########       : #  : #  : ##
⮬-------ઠ-----------------------------------------------------------
. .     
#### ##########  #### ################################
}
*)

(*
$P { Norms:
L_Way._FCorMove, R, "3."
L_Way._FCorHeat, R, "3."
L_Way._FCorWarm, R, "3."
?, R, "1."
?, R, "1."
L_Way._FMarkHeat, R, "3."
L_Way.MarkFNAlFTim, R, "3."
L_Way.MarkFNConTim, R, "3."
L_Way._FMarkWarm, R, "3."
L_Way.MarkFNAlFRun, R, "3."
L_Way.MarkFNConRun, R, "3."
L_Way.MarkFnConRepr, R, "3."
@
樥  ⮯--------------------------------------------
           . 㤮            ணॢ
 ###############            ###############       ##############      ##### #####
室  --------------------------------稩 室------------------
                 ﭭ     騩   |             ##########
 1  ࠡ  ##########     ################ | ணॢ ⥫ ##########
 100 ஡ ##########     ################ | ६            ##########
}
*)

(*
$P { CarCTop:
L_Way._FCarCMove*L_Way._FMarkCMove, R, "3."
L_Way._FCarCHeat*L_Way._FMarkCHeat, R, "3."
L_Way._FCarCWarm*L_Way._FMarkCWarm, R, "3."
@
ࠢ  ⮯  ⮬-------------------------------------------------
           . 㤮            ணॢ
 ###############            ###############       ##############
}
*)

(*
$P { WJMTop:
@
 ࠡ------------------------樥 室 ⮯------------------
                                ணॢ   ६
}
*)

(*
$P { WJMLine:
WJMode.WJCode, L, ""
WJMode.Name, L, ""
WJMode.FCorMove, R, "3."
WJMode.FCorHeat, R, "3."
WJMode.FCorWarm, R, "3."
WJMode.FCorRepr, R, "3."
@
##  ############################## ###########  ##########  ##########  #########
}
*)

(*
$P { RWJTop:
@
--------------------------------------------- -----------------------
   ஡  ६  100       ணॢ     ⮣
}
*)

(*
$P { RWJLine:
RWayJ.StartT, L, "HM"
SEJobs.Route, L, ""
SEJobs.WJCode, L, ""
CurRun, R, "2."
CurTime, R, "3."
?, L, " |*"
?, R, "2."
?, R, "3."
?, R, "3."
?, R, "3."
?, R, "3."
?, R, "3."
?, R, "3."
@
#### #### ## ###### ###### # ###### ##### ####### ####### ####### ####### #######
}
*)

(*
$P { Bot:
?, R, "3."
?, R, "3."
?, R, "3."
?, R, "3."
?, R, "3."
@
---------------------------------------------------------------------------------
⮣                                     ####### ####### ####### ####### #######
=(c) Polak=======================================================================
}
*)

(*
$P { Bot1:
@
---------------------------------------------------------------------------------
                       室 ⮯  ନ
=(c) Polak=======================================================================
}
*)

 PROCEDURE MakeFNPRT();
  VAR
   Continue,
   _WithDp        : SCAL[2];
   _FCor          : LIKE(RoutMod.FCor);
   dummy1,
   dummy2         : NUMERIC[3];
   PureNormAs100km: L_Way.tNorm;
   Norms,
   TotalNorms     : L_Way.tNorms;
   Temp           : NUMERIC[2][2];
 BEGIN
  L_General.Assert(ACCESS(RWayS), " ⠭ ");
  CONFORM(RWayS, Car);
  L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
  OPENREP(R, L_General.NameConnection(FRepName), Create);
  MAKEPART(R, Top);
  IF Mark.Electric | P_Car.GetP_NormAsFact(RWayS.BoxNbr, RWayS.Date) THEN
   MAKEPART(R, Bot1);
  ELSE
   L_Way.PrepareFNorm();
   P_OwnData.Temperature(RWayS.Date, Temp);

   MAKEPART(R, Norms, Temp[0], Temp[1]);
   IF P_Car.HasActualCarPro(RWayS.BoxNbr, RWayS.Date, P_Car.P_CarFuelCor) |
      P_Mark.HasActualMarkPro(Mark.Mark, RWayS.Date, P_Mark.P_MarkFuelCor) THEN
    MAKEPART(R, CarCTop);
   END;

   MAKEPART(R, WJMTop);
   SELECT(WJMode, WJCode);
   WHILE OCCURE(WJMode) DO
    Continue:=1;
    CONFORM(RWayS, RWayJ);
    WHILE OCCURE(RWayJ) & Continue DO
     CONFORM(RWayJ, SEJobs);
     PROMPT(SEJobs.Trip);
     IF SEJobs.WJCode = WJMode.WJCode THEN
      MAKEPART(R, WJMLine);
      Continue:=0;
     END;
     NEXT(RWayJ);
    END; (* WHILE OCCURE(RWayJ)... *)
    NEXT(WJMode);
   END; (* WHILE OCCURE(WJMode) ... *)

   SETZERO(TotalNorms);
   MAKEPART(R, RWJTop);
   CONFORM(RWayS, RWayJ);
   WHILE OCCURE(RWayJ) DO
    CONFORM(RWayJ, SEJobs, Route, RoutMod, WJMode, Quality);
    PROMPT(SEJobs.Trip);
    CurTime:=RWayJ.StopT - RWayJ.StartT;
    CurRun :=RWayJ.Run * RWayJ.Fact;
    _WithDp:=L_Way._IsWith(L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT),
                           L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT),
                           L_Way.wlmwho_DrPupil);
    L_Way.extCalcFN(RWayS.Date, CurTime, CurRun, _WithDp, PureNormAs100km, Norms, dummy1, _FCor, dummy2, 1);
    MAKEPART(R, RWJLine, _WithDp>0, PureNormAs100km, _FCor*RoutMod.FCor, Norms[0], Norms[1], Norms[2], Norms[3], Norms[0]+Norms[1]+Norms[2]+Norms[3]);
    INC(TotalNorms[0], Norms[0]);
    INC(TotalNorms[1], Norms[1]);
    INC(TotalNorms[2], Norms[2]);
    INC(TotalNorms[3], Norms[3]);
    NEXT(RWayJ);
   END; (* WHILE OCCURE(RWayJ)... *)
   MAKEPART(R, Bot, TotalNorms[0], TotalNorms[1], TotalNorms[2], TotalNorms[3], TotalNorms[0]+TotalNorms[1]+TotalNorms[2]+TotalNorms[3]);
  END;
 END {MakeFNPRT};

END.
