(*
%Copyright   (c) Polak Computer System
%Author      19.02.2001 13:00:04 SAN
%Purpose     । ௫  
%Type        report
%Specific    AP
%Modified    15.08.2014 16:47:52 POLAK\San
%Environment
*)

 IMPORT Memo, L_General, L_Basis, L_Way, D_RWS, FIO, L_Str, L_PRoll, L_AFM,
        P_Firm, L_DatTim, L_APtm, P_Car, L_Env, P_Route, Math, L_bp, L_SFee,
        P_MCList, P_Sort, P_Column;

 TYPE
  tRouteGroup = SCAL[16];

 CONST
  bpId = "RwDst";

 VAR
  _wASCP,
  _wInvFacil,
  wMF,
  wMP    : SCAL[2];

 PRIVATE PROCEDURE MakeTop();
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
  END;
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "⥣");
  L_Basis.wb_WrStr("F", "⥣");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "१");
  L_Basis.wb_WrStr("F", "१");
  L_Basis.wb_WrStr("F", "१");
  L_Basis.wb_WrStr("F", "_");
  L_Basis.wb_WrStr("F", "_");
  L_Basis.wb_WrStr("F", " ॢ");
  L_Basis.wb_WrStr("F", " ॢ");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "஢");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "㯯 ⮢");
  L_Basis.wb_WrStr("F", " ");
  L_Basis.wb_WrStr("F", "㯯 ப");
  L_Basis.wb_WrStr("F", "㯯 ப");
  L_Basis.wb_WrStr("F", "ઠ");
  L_Basis.wb_WrStr("F", "ઠ");
  L_Basis.wb_WrStr("F", "_㯯ப");
  L_Basis.wb_WrStr("F", "_㯯ப");
  L_Basis.wb_WrStr("F", "ࠦ");
  L_Basis.wb_WrStr("F", "᭮");
  L_Basis.wb_WrStr("F", "㯯");
  L_Basis.wb_WrStr("F", "㯯");
  L_Basis.wb_WrStr("F", " ");
  L_Basis.wb_WrStr("F", " /");
  L_Basis.wb_WrStr("F", " /");
  IF Memo.ud_mb() >= L_SFee.TheStartingPoint THEN
   L_Basis.wb_WrStr("F", "⭮襭  客 ᠬ");
   L_Basis.wb_WrStr("F", " ᫥ 客 ᮢ");
  END;
  L_Basis.wb_WrStr("F", "㬬");
  L_Basis.wb_WrStr("F", "६");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "ᮡ ।");
  IF _wASCP THEN
   L_Basis.wb_WrInQM("F", "");
  END;
  IF _wInvFacil THEN
   L_Basis.wb_WrInQM("F", "㤮  ");
  END;
  IF wMP THEN
   L_Basis.wb_WrInQM("F", "");
   L_Basis.wb_WrInQM("F", "");
  END;
  L_Basis.wb_TermLine("F");
 END {MakeTop};

 PRIVATE PROCEDURE MakeLine();
  VAR
   SFeeInSign: P_MCList.tAttitude2SFee;
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrScl("F", MyFirm.MyFirm);
   L_Basis.wb_WrStr("F", MyFirm.vzSign);
  END;
  IF ~!RWM02.TSN THEN
   L_Basis.wb_WrScl("F", Sort.Sort);
   L_Basis.wb_WrStr("F", Sort.Name);
   L_Basis.wb_WrScl("F", Union.Union);
   L_Basis.wb_WrStr("F", Union.Name);
   L_Basis.wb_WrScl("F", Staff.TSN);
   L_Basis.wb_WrStr("F", Man.Name);
   L_Basis.wb_WrScl("F", AcCut.AcCut);
   L_Basis.wb_WrStr("F", AcCut.Sign);
   L_Basis.wb_WrStr("F", AcCut.Name);
   IF OCCURE(CostItem) THEN
    L_Basis.wb_WrScl("F", CostItem.CostItem);
    L_Basis.wb_WrStr("F", CostItem.Name);
   ELSE
    L_Basis.wb_WrStr("F", "---");
    L_Basis.wb_WrStr("F", "---");
   END;
  ELSE
   L_Basis.wb_WrScl("F", "---");
   L_Basis.wb_WrStr("F", "---");
   L_Basis.wb_WrScl("F", "---");
   L_Basis.wb_WrStr("F", "---");
   L_Basis.wb_WrScl("F", "---");
   L_Basis.wb_WrStr("F", "---");
   L_Basis.wb_WrStr("F", "---");
   L_Basis.wb_WrStr("F", "---");
   L_Basis.wb_WrStr("F", "---");
   L_Basis.wb_WrStr("F", "---");
   L_Basis.wb_WrStr("F", "---");
  END;
  IF ~!RWM02.Route THEN
   SEARCH(Route, Route, , RWM02.Route);
   L_Way.StandOnRouteTKind(Memo.ud_mb());
   L_Basis.wb_WrScl("F", TKind.TKind);
   L_Basis.wb_WrStr("F", TKind.Name);
   L_Basis.wb_WrStr("F", L_Str.PoolItem(L_Way.tkrgn_Pool, TKind.Rgn));
   L_Basis.wb_WrStr("F", L_Str.PoolItem(L_Way.tkfnm_Pool, TKind.FnMode));
   L_Basis.wb_WrStr("F", Route.Route);
   L_Basis.wb_WrStr("F", Route.Name);
   L_Basis.wb_WrStr("F", P_Route.GetRouteProSoft(Route.Route, Memo.ud_me(), P_Route.P_Group));
   L_Basis.wb_WrStr("F", L_Str.PoolItem("|", D_RWS.E_IsRoute2Distribute(Route.Route, Memo.ud_me())));
  ELSE
   L_Basis.wb_WrScl("F", "---");
   L_Basis.wb_WrStr("F", "---");
   L_Basis.wb_WrStr("F", "---");
   L_Basis.wb_WrStr("F", "---");
   L_Basis.wb_WrStr("F", "---");
   L_Basis.wb_WrStr("F", "---");
   L_Basis.wb_WrStr("F", "---");
   L_Basis.wb_WrStr("F", "---");
  END;
  IF ~!RWM02.Mark THEN
   SEARCH(Mark, Mark, , RWM02.Mark);
   L_Way.StandOnMarkG(Mark.Mark, L_Way.mgt_WagePay);
   L_Basis.wb_WrScl("F", MarkG.MarkG);
   L_Basis.wb_WrStr("F", MarkG.Name);
   L_Basis.wb_WrScl("F", Mark.Mark);
   L_Basis.wb_WrStr("F", Mark.Name);
   IF L_Way.StandOnMarkG_Soft(Mark.Mark, L_Way.mgt_CostAccounting) THEN
    L_Basis.wb_WrScl("F", MarkG.MarkG);
    L_Basis.wb_WrStr("F", MarkG.Name);
   ELSE
    L_Basis.wb_WrStr("F", "");
    L_Basis.wb_WrStr("F", "---");
   END;
  ELSE
   L_Basis.wb_WrScl("F", "---");
   L_Basis.wb_WrStr("F", "---");
   L_Basis.wb_WrScl("F", "---");
   L_Basis.wb_WrStr("F", "---");
   L_Basis.wb_WrScl("F", "---");
   L_Basis.wb_WrStr("F", "---");
  END;
  IF ~!RWM02.BoxNbr THEN
   SEARCH(Car, BoxNbr, , RWM02.BoxNbr);
   L_Basis.wb_WrScl("F", Car.BoxNbr);
   L_Basis.wb_WrStr("F", Car.StateNbr);
  ELSE
   L_Basis.wb_WrScl("F", "---");
   L_Basis.wb_WrStr("F", "---");
  END;
  CONFORM(MCList, MCGroup);
  L_Basis.wb_WrScl("F", MCGroup.MCGroup);
  L_Basis.wb_WrStr("F", MCGroup.Name);
  L_Basis.wb_WrStr("F", L_Str.PoolItem("-|+|", MCGroup.FOT));
  L_Basis.wb_WrScl("F", MCList.MCode);
  L_Basis.wb_WrStr("F", MCList.Name);
  IF Memo.ud_mb() >= L_SFee.TheStartingPoint THEN
   SFeeInSign:=P_MCList.a2sf_Attitude(MCList.MCode, Memo.ud_mb());
   L_Basis.wb_WrStr("F", L_Str.PoolItem(P_MCList.a2sf_Pool, SFeeInSign));
   IF (SFeeInSign # P_MCList.a2sf_NotObject) & ~!RWM02.TSN & OCCURE(ManSFee) THEN
    L_Basis.wb_WrStr("F", L_Str.PoolItem(L_SFee.t_Pool, ManSFee.Type));
   ELSE
    L_Basis.wb_WrStr("F", "---");
   END;
  END;
  L_Basis.wb_WrNum("F", RWM02.Sum, 2);
  IF MCList.TimeType = L_PRoll.tt_Production THEN
   L_Basis.wb_WrNum("F", RWM02.Tim, 3);
  ELSE
   L_Basis.wb_WrNum("F", 0, 3);
  END;
  L_Basis.wb_WrStr("F", L_Str.PoolItem("||ந⢥", RWM02.Direct));
  IF ~!RWM02.Who THEN
   L_Basis.wb_WrStr("F", L_Str.PoolItem(".|.|.|.|2 .|.", RWM02.Who));
  ELSE
   L_Basis.wb_WrStr("F", "---");
  END;
  L_Basis.wb_WrScl("F", RWM02.IsDistr);
  IF _wASCP THEN
   L_Basis.wb_WrScl("F", RWM02.ASCP);
  END;
  IF _wInvFacil THEN
   L_Basis.wb_WrScl("F", RWM02.InvFacil);
  END;
  IF wMP THEN
   IF    ~!RWM02.TSN THEN
    SEARCH(MyPlace, MyPlace, , P_Sort.GetMyPlace(Sort.Sort, Memo.ud_me()));
   ELSIF ~!RWM02.BoxNbr THEN
    SEARCH(MyPlace, MyPlace, , P_Column.GetMyPlace(Car.Column, Memo.ud_me()));
   ELSE
    SEARCH(MyPlace, MyPlace, , P_Firm.mp_Fict);
   END;
   L_Basis.wb_WrScl("F", MyPlace.MyPlace);
   L_Basis.wb_WrStr("F", MyPlace.Name);
  END;
  L_Basis.wb_TermLine("F");
 END {MakeLine};

 PRIVATE PROCEDURE E_NeedSpreadFictBoxNbr(): SCAL[2];
 BEGIN
  RETURN (L_General.GetAPSiteID() = "84");
 END {E_NeedSpreadFictBoxNbr};

 PRIVATE PROCEDURE Create_RWM04();
 BEGIN
  CreateFILE(RWM04, "", "אַ ࠡ⮪  ࠦ", "");

  CreateFIELD(RWM04, RWM04,    SCAL[1e8],          "", "", "", "䨪 ", "");
  CreateFIELD(RWM04, MyFirm,   P_Firm.tMyFirm,     "", "", "", " ࣠", "");
  CreateFIELD(RWM04, Sort,     LIKE(Sort.Sort),    "", "", "", "", "");
  CreateFIELD(RWM04, Route,    LIKE(Route.Route),  "", "", "", "", "");
  CreateFIELD(RWM04, Mark,     LIKE(Mark.Mark),    "", "", "", "ઠ", "");
  CreateFIELD(RWM04, BoxNbr,   LIKE(Car.BoxNbr),   "", "", "", "ࠦ", "");
  CreateFIELD(RWM04, Who,      L_Way.tRWSWho,      "", "", "", "", "");
  CreateFIELD(RWM04, ASCP,     SCAL[2],            "", "", "", "稥 ", "");
  CreateFIELD(RWM04, InvFacil, SCAL[2],            "", "", "", "稥 㤮  ॢ ", "");
  CreateFIELD(RWM04, AcCut,    LIKE(AcCut.AcCut),  "", "", "", "१ ", "");
  CreateFIELD(RWM04, CostItem, LIKE(CostItem.CostItem),  "", "", "", " ", "");
  CreateFIELD(RWM04, Sum,      NUMERIC[12, 2],     "", "0", "", "㬬", "");

  CreateINDEX(RWM04, mfSort, UNIQUE,   "", "",  MyFirm, Sort, Who, AcCut, CostItem, Route, Mark, BoxNbr, ASCP, InvFacil);
  CreateINDEX(RWM04, RWM04,  AUTOINCR, "", "", RWM04);

  SetVersionOfFILE(RWM04, 0001);
 END {Create_RWM04};

 PRIVATE PROCEDURE GetRWM02DstAttr(VAR trgAcCut   : LIKE(AcCut.AcCut);
                                   VAR trgCostItem: LIKE(CostItem.CostItem));

 BEGIN
  IF ~SEARCH(StaffLog, TSN, RWM02.TSN, RWM02.ODate) THEN
   L_General.Error("  ਪ  /|⠡ " + RWM02.TSN + " / " + L_DatTim.DateStr(RWM02.ODate));
  END;
  L_PRoll.GetOfficerDstAttr(L_PRoll.dm_MainSalary, Memo.ud_mb(), 1, trgAcCut, trgCostItem);
 END {GetRWM02DstAttr};

 PRIVATE PROCEDURE HasNotProductionRWM02(trgAcCut   : LIKE(AcCut.AcCut);
                                         trgCostItem: LIKE(CostItem.CostItem)): SCAL[2];
  VAR
   Result     : SCAL[2];
   curASCP,
   curInvFacil: SCAL[2];
   curAcCut   : LIKE(AcCut.AcCut);
   curCostItem: LIKE(CostItem.CostItem);
 BEGIN
  curASCP    :=RWM02.ASCP;
  curInvFacil:=RWM02.InvFacil;
  Result:=0;
  SAVE(RWM02);
  SELECT(RWM02, mfMark, , RWM02.MyFirm, 1(*ந⢥*), RWM02.Who, RWM02.Mark, RWM02.Sort, RWM02.Route);
  WHILE OCCURE(RWM02) & ~Result DO
   IF (RWM02.ASCP = curASCP) & (RWM02.InvFacil = curInvFacil) THEN
    GetRWM02DstAttr(curAcCut, curCostItem);
    IF (curAcCut = trgAcCut) & (curCostItem = trgCostItem) THEN
     Result:=1;
    END;
   END;
   NEXT(RWM02);
  END; (* WHILE OCCURE(RWM02) ... *)
  RESTORE(RWM02);
  RETURN Result;
 END {HasNotProductionRWM02};

 PRIVATE PROCEDURE SpreadFictBoxNbr();
  VAR
   Total      : L_PRoll.tSum;
   dTim,
   cTim,
   rTim       : L_PRoll.tTime;
   dSum,
   cSum,
   rSum       : L_PRoll.tSum;
   mRWM04     : SCAL[1e8];
   mSum       : L_PRoll.tSum;
   trgAcCut   : LIKE(AcCut.AcCut);
   trgCostItem: LIKE(CostItem.CostItem);
   oPrompt    : PROMPT_LINE;
 BEGIN
  IF E_NeedSpreadFictBoxNbr() THEN
   oPrompt:=PROMPT_LINE.Create("। 䨪⨢ ");
   L_AFM.msrf_Store_InOutputMode("RWM02");
   Create_RWM04(); L_AFM.CreateTemp("RWM04");
   SELECT(MyFirm, MyFirm);
   WHILE OCCURE(MyFirm) DO
    SELECT(RWM02, mfMark, , MyFirm.MyFirm, 0); (* ந⢥*)
    WHILE OCCURE(RWM02) DO
     PROMPT(RWM02.TSN);
     GetRWM02DstAttr(trgAcCut, trgCostItem);
     IF HasNotProductionRWM02(trgAcCut, trgCostItem) THEN
      ADD(RWM04, mfSort, , RWM02.MyFirm, RWM02.Sort, RWM02.Who, trgAcCut, trgCostItem, RWM02.Route,
                           RWM02.Mark, RWM02.BoxNbr, RWM02.ASCP, RWM02.InvFacil,
          RWM04.Sum, RWM02.Sum);
     END;
     NEXT(RWM02);
    END; (* WHILE OCCURE(RWM02) ... *)

    SELECT(RWM02, mfMark, , MyFirm.MyFirm, 1); (*ந⢥*)
    WHILE OCCURE(RWM02) DO
     PROMPT("। ந⢥ ᫥  ࠦ: ࠡ⭨ " + RWM02.TSN);
     GetRWM02DstAttr(trgAcCut, trgCostItem);
     SAVE(RWM02);

     Total:=0;
     IF ~SELECT(RWM04, mfSort, RWM02.MyFirm, RWM02.Sort, RWM02.Who, trgAcCut, trgCostItem, RWM02.Route) THEN
      SELECT(RWM04, mfSort, , RWM02.MyFirm, RWM02.Sort, RWM02.Who, trgAcCut, trgCostItem);
     END;
     WHILE OCCURE(RWM04) DO
      INC(Total, RWM04.Sum);
      NEXT(RWM04);
     END; (* WHILE OCCURE(RWM04) ... *)
  
     mSum:=0;
     dSum:=RWM02.Sum;
     dTim:=RWM02.Tim;
     rSum:=RWM02.Sum;
     rTim:=RWM02.Tim;
     ADD(RWM02, TSN, , RWM02.TSN, RWM02.ODate, RWM02.MyFirm, RWM02.Sort, RWM02.Who, RWM02.Route, RWM02.Mark, RWM02.BoxNbr,
                       RWM02.ASCP, RWM02.InvFacil, RWM02.MCode, RWM02.Direct, 2,
         RWM02.Sum, -dSum,
         RWM02.Tim, -dTim);
     IF Total # 0 THEN
      FIRST(RWM04);
      mRWM04:=RWM04.RWM04;
      WHILE OCCURE(RWM04) DO
       cSum:=dSum * (RWM04.Sum / Total);
       cTim:=dTim * (RWM04.Sum / Total);
       ADD(RWM02, TSN, , RWM02.TSN, RWM02.ODate, RWM04.MyFirm, RWM04.Sort, RWM04.Who, RWM04.Route, RWM04.Mark, RWM04.BoxNbr,
                         RWM04.ASCP, RWM04.InvFacil, RWM02.MCode, RWM02.Direct, 2,
           RWM02.Sum, cSum,
           RWM02.Tim, cTim);
       IF Math.Abs(cSum) > mSum THEN
        mRWM04:=RWM04.RWM04;
        mSum:=Math.Abs(cSum);
       END;
       DEC(rSum, cSum);
       DEC(rTim, cTim);
       NEXT(RWM04);
      END; (* WHILE OCCURE(RWM04) ... *)
      IF (rSum # 0) | (rTim # 0) THEN
       SEARCH(RWM04, RWM04, , mRWM04);
       ADD(RWM02, TSN, , RWM02.TSN, RWM02.ODate, RWM04.MyFirm, RWM04.Sort, RWM04.Who, RWM04.Route, RWM04.Mark, RWM04.BoxNbr,
                         RWM04.ASCP, RWM04.InvFacil, RWM02.MCode, RWM02.Direct, 2,
           RWM02.Sum, rSum,
           RWM02.Tim, rTim);
      END;
     ELSE
      ADD(RWM02, TSN, , RWM02.TSN, RWM02.ODate, RWM02.MyFirm, RWM02.Sort, RWM02.Who, "", L_General.EMPTY_NUMBER(), L_General.EMPTY_NUMBER(),
                        RWM02.ASCP, RWM02.InvFacil, RWM02.MCode, RWM02.Direct, 2,
          RWM02.Sum, dSum,
          RWM02.Tim, dTim);
     END; (* IF Total # 0...*)

     RESTORE(RWM02);
     NEXT(RWM02);
    END; (* WHILE OCCURE(RWM02) ... *)
    NEXT(MyFirm);
   END; (* WHILE OCCURE(MyFirm) ... *)
   L_AFM.AF_PurgeTemp("RWM04");
  END; (* IF E_NeedSpreadFictBoxNbr() ... *)
 END {SpreadFictBoxNbr};

 PRIVATE PROCEDURE Print();
  VAR
   Prompt     : STRING[];
   curAcCut   : LIKE(AcCut.AcCut);
   curCostItem: LIKE(CostItem.CostItem);
   oPrompt    : PROMPT_LINE;
 BEGIN
  oPrompt:=PROMPT_LINE.Create("㧪  䠩");
  _wASCP    :=L_Way.E_ASCPLev(Memo.ud_me());
  _wInvFacil:=L_Way.E_InvFacilLev(Memo.ud_me());
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  MakeTop();
  SELECT(RWM02, TSN);
  WHILE OCCURE(RWM02) DO
   SEARCH(MyFirm, MyFirm, , RWM02.MyFirm);
   IF ~!RWM02.TSN THEN
    SEARCH(Staff, TSN, , RWM02.TSN);
    Prompt:="⭨ " + Staff.TSN;
    CONFORM(Staff, Man);
    SELECT(ManSFee, MyFirm, , MyFirm.MyFirm, Man.Man, 1, Memo.ud_mb());
    GetRWM02DstAttr(curAcCut, curCostItem);
    SEARCH(AcCut, AcCut, , curAcCut);
    SEARCH(CostItem, CostItem, , curCostItem);
    CONFORM(StaffLog, Officer);
    CONFORM(Officer, Sort);
    CONFORM(Officer, Union);
   ELSE
    Prompt:="";
   END;
   NARROWSEL(RWM02, TSN, ODate);
   WHILE OCCURE(RWM02) DO
    IF ~!RWM02.Route & ~!RWM02.Mark THEN
     PROMPT(Prompt + "  " + RWM02.Route + " ઠ " + RWM02.Mark);
    END;
    SEARCH(MCList, MCode, , RWM02.MCode);
    MakeLine();
    NEXT(RWM02);
   END; (* WHILE OCCURE(RWM02) *)
   NEXTINEXTENDEDSEL(RWM02, TSN, ODate);
  END; (* WHILE OCCURE(RWM02) ... *)
  FIO.Close(F);
 END {Print};

 PRIVATE PROCEDURE RWDst();
 BEGIN
  L_bp.Begin(bpId,"ࠡ⮪   ॢ  ", L_bp.t_Basis, L_General.tc_inMonth);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  wMP:=P_Firm.E_wMultipleMyPlace(SYSDATE());
  D_RWS.PrepareRWM02(0);
  SpreadFictBoxNbr();
  Print();
  D_RWS.PurgeRWM02();
  L_bp.End();
 END {RWDst};

END.
