(*
%Copyright   (c) Polak IT
%Author      11.06.2003 20:19:47 POLAK\Gina
%Purpose     祭   ਮ
%Type        report
%Specific    AP
%Modified    10.01.2014 15:50:29 POLAK\GAV
%Environment
*)

 MODULE RWJourn [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_OwnData, L_PagePr, L_DatTim, L_XDoc, L_AR,
        L_Str, L_Env, L_AFM, P_Firm, L_Way;

 CONST
  RepName   = "RWJrn";
  PagLength = 65;

 VAR
  WriteOutDate: DATE;
  WriteOutStr,
  AcceptStr,
  EditStr     : STRING[];

  _Ops, tOps          : NUMERIC[0][MAXOF(XDocJrn.Action)+1];
  _OpLen, tOpLen      : NUMERIC[2][MAXOF(XDocJrn.Action)+1];
  _WrkTime, tWrkTime,
  _WstTime, tWstTime  : NUMERIC[0];
  _OpsCnt,   tOpsCnt,
  _RWSCnt, tRWSCnt    : NUMERIC[0];
  _OpLenCnt, tOpLenCnt: NUMERIC[2];

(*
$P{ RepTop:
P_Firm.FP_FirmName(P_Firm.fomf(MyFirm.MyFirm), SYSDATE()), L, ""
L_OwnData.ODOKPO(SYSDATE()), L, ""
P_Firm.GetDefaultMyPlaceName(), L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
                                                                                                                                                     ᫥ ଠ N 8
                                                                                                                 ⢥ত ⠭ ᪮ ᨨ  28.11.1997 . N 78
                                                                                                                                                                         ----------
                                                                                                                                                                         |     |
                                                                                                                                                                         |--------|
                                                                                                                                                           ଠ   |0345008 |
                                                                                                                                                                         |--------|
###################################################################################################################################                                |########|
࣠                                                                                                                                                              ----------

###############################################      ୠ   ⥢ ⮢  ਮ  ##########  ##########
}
*)

(*
$P{ PageTop:
L_PagePr.PagePr_CurrentPage(), R, "0"
@
------------------------------------------------------------------------------------------------------------------------------------------------------------------------- ###--
|  |      |            ⥫             |ࠦ.|                                                                                            |                 |
|-  |뤠    |---------------------------------| |---------------------------------------------------------------------------------------------------|                 |
|   |⥢  |䠬, , ⢮     |⠡. |- |⥫  - |ᯥ   ਥ ⥢     |壠   ਥ              |ਬ砭       |
|  |     |                           ||| ⥢  |  㬥⮢  ⥫         |⥢                          |                 |
|-------|----------|---------------------------|-----|------|-------------------|---------------------------------------|---------------------------------------|-----------------|
|   1   |    2     |             3             |  4  |   5  |         6         |                   7                   |                   8                   |        9        |
}
*)

(*
$P{ Line:
RWayS.RWayS, L, ""
WriteOutDate, L, "D.N.y"
GetManName(), L, ""
RWayS.TSN, L, ""
RWayS.BoxNbr, L, ""
WriteOutStr, L, ""
AcceptStr, L, ""
EditStr, L, ""
@
|-------|----------|---------------------------|-----|------|-------------------|---------------------------------------|---------------------------------------|-----------------|
|#######|##########|###########################|#####|####  |###################|#######################################|#######################################|                 |
}
*)

(*
$P{ Filling:
@
|-------|----------|---------------------------|-----|------|-------------------|---------------------------------------|---------------------------------------|-----------------|
|       |          |                           |     |      |                   |                                       |                                       |                 |
}
*)

(*
$P{ PageBot:
SYSDATE(), L "DNy"
SYSTIME(), L "HM"
@
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
⮢ " ⮏" (c) Polak                                                                                                                                   ######## ####
}
*)

 PRIVATE PROCEDURE GetManName(): STRING[];
 BEGIN
  IF L_Env.RealMan(Man.Man) THEN
   RETURN L_Str.ShortName(Man.Name);
  ELSE
   RETURN "";
  END;
 END {GetManName};

 PRIVATE PROCEDURE _RprtTop(Mode: SCAL[20]);
 BEGIN
  IF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, RepTop);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtTop};

 PRIVATE PROCEDURE _PageTop(Mode: SCAL[20]);
 BEGIN
  IF (Mode = L_PagePr.m_Print) | (Mode = L_PagePr.m_RDoneTop) THEN
   MAKEPART(R, PageTop);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageTop};

 PRIVATE PROCEDURE _PageBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(PageBot));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, PageBot);
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_None);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageBot};

 PRIVATE PROCEDURE _RprtBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(PageBot));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, PageBot);
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_Fill);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtBot};

 PRIVATE PROCEDURE _Filling(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(Filling));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, Filling);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_Filling};

 PRIVATE PROCEDURE HoursStr(Full: SCAL[2]): STRING[];
  VAR
   s,
   S: STRING[];
 BEGIN
  SETEMPTY(S);
  IF Full THEN
   S:=L_DatTim.DateStr(XDocJrn.Date) + " ";
  END;
  S:=S + L_DatTim.TimeStr(XDocJrn.BegTime) + ":" + L_Str.FixedIntStr(XDocJrn.BegSec, 2);
  IF Full THEN
   CONFORM(XDocJrn, AcsObj);
   L_General.Assert(OCCURE(AcsObj), " । 짮⥫");
   s:=L_Str.ShortName(L_AR.GetAcsObjManName());
   L_General.Assert(~!s, " । 䨧᪮   짮⥫ " + AcsObj.Name);
   S:=S + " " + s;
  END;
  RETURN S;
 END {HoursStr};

 PRIVATE PROCEDURE OneRWayS();
 BEGIN
  L_PagePr.PagePr_BeforePrintLine(DEPTH("Line"));
  CONFORM(RWayS, Staff, Man);
  SETEMPTY(WriteOutDate, WriteOutStr, AcceptStr, EditStr);
  SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind,
                             RWayS.RWayS);
  WHILE OCCURE(XDocJrn) DO
   IF    XDocJrn.Action = L_XDoc.action_begDst THEN
    WriteOutDate:=XDocJrn.Date;
    IF L_Env.RealTSN(RWayS.TSN) THEN
     WriteOutStr:=HoursStr(0);
    END;
   ELSIF XDocJrn.Action = L_XDoc.action_begRcp THEN
    AcceptStr:=HoursStr(1);
   ELSIF (XDocJrn.Action = L_XDoc.action_Edit) & !EditStr THEN
    EditStr:=HoursStr(1);
   END;
   NEXT(XDocJrn);
  END; (* WHILE OCCURE(XDocJrn) ... *)
  MAKEPART(R, Line);
 END {OneRWayS};

 PUBLIC PROCEDURE MakeJournal();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  SetPrintAttr(R, FontEnlargement, 1.3);
 
  L_AFM.MakeIndex("Tmp01", "_MyFirm: LIKE(Staff.MyFirm); _RWayS: LIKE(RWayS.RWayS)");
 
  SELECT(RWayS, Date);
  SRCINSEL(RWayS, GE, , Memo.ud_fr());
  WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.ud_ut()) DO
   PROMPT(" " + L_DatTim.DateStr(RWayS.Date) + " " + RWayS.RWayS);
   IF P_Firm.IsAllowedMyPlace(RWayS.MyPlace) THEN
    CONFORM(RWayS, Staff);
    Tmp01._RWayS :=RWayS.RWayS;
    Tmp01._MyFirm:=Staff.MyFirm;
    INSERT(Tmp01);
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)

  SELECT(Tmp01, Tmp01);
  WHILE OCCURE(Tmp01) DO
   NARROWSEL(Tmp01, _MyFirm);
   SEARCH(MyFirm, MyFirm, , Tmp01._MyFirm);
   L_PagePr.PagePr_Init("R", PagLength, PROCREF(_RprtTop), PROCREF(_PageTop),
                        PROCREF(_PageBot), PROCREF(_RprtBot), PROCREF(_Filling));
   WHILE OCCURE(Tmp01) DO
    SEARCH(RWayS, RWayS, , Tmp01._RWayS);
    PROMPT(" " + L_DatTim.DateStr(RWayS.Date) + " " + RWayS.RWayS);
    OneRWayS();
    NEXT(Tmp01);
   END; (* WHILE OCCURE(Tmp01) ... *)
   L_PagePr.PagePr_Done();
   NEXTINEXTENDEDSEL(Tmp01, _MyFirm);
  END; (* WHILE OCCURE(Tmp01) *)
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("Tmp01");
  L_General.SurveyLastReport();
 END {MakeJournal};

END.