(*
%Copyright   (c) Polak Computer System
%Author      Unknown
%Purpose     ஢ઠ ⥢ ⮢
%Type        operation
%Specific    AP_PC
%Modified    10.04.2012 12:06:05 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_AP, L_Way, L_OwnData, L_General, L_AFM, Memo, L_XDoc, L_Str, L_Car, Math,
        Str, L_DatTim, L_BegRWS, L_Env;

(*
$P{ RepTop:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.tmp_cd(), L, "D.N.y"
@
############################################################# ########## #####
=#####========================================================================
|              ⠪஢ ⥢   ##########                   |
|----------------------------------------------------------------------------|
|/    |    |C|?|. |室    |⥫                      ||
|-------|--------|-|-|----------|---------|------------------------------|---|
}
*)

(*
$P{ RepLine:
RWayS.RWayS, L, ""
RWayS.Date, L, "D.N.Y"
RWayS.Status, L, ""
?, L, ""
Car.StateNbr, L, ""
RWayS.Exit, L, ""
RWayS.TSN, L, ""
Man.Name, L, ""
RWayS.FuelFact, R, "0"
@
|#######|########|#|#|##########|#########|##### ########################|###|
}
*)

(*
$P{ RepDlm:
@
|----------------------------------------------------------------------------|
}
*)

(*
$P{ BadCh_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
############################################################# ########## #####
=#####========================================================================
|                 祭   襭 楯窮 権                 |
|                     ਮ  ##########  ##########                    |
|----------------------------------------------------------------------------|
|     |    |⥫                                              |.|
|-------|--------|------------------------------------------------------|----|
}
*)

(*
$P{ BadCh_Line:
RWayS.RWayS, L, ""
RWayS.Date, L, "D.N.Y"
RWayS.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
RWayS.BoxNbr, L, ""
@
|#######|########|##### ################################################|####|
}
*)

(*
$P { Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE PrintNotTaxRWayS(_Status: LIKE(RWayS.Status));
  VAR
   Attr : STRING[1];
 BEGIN
  SELECT(RWayS, sDate, , _Status);
  SRCINSEL(RWayS, LE, , Memo.tmp_cd());
  WHILE OCCURE(RWayS) DO
   PROMPT("⥢  " + RWayS.RWayS);
   CONFORM(RWayS, Car);
   CONFORM(RWayS, Staff);
   CONFORM(Staff, Man);
   SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind,
                              RWayS.RWayS);
   SETEMPTY(Attr);
   WHILE OCCURE(XDocJrn) DO
    IF XDocJrn.Action = L_XDoc.action_Edit THEN
     Attr := "*";
    END;
    NEXT(XDocJrn);
   END; (* WHILE OCCURE(XDocJrn) ... *)

   MAKEPART(R, RepLine, Attr);
   PREV(RWayS);
  END; (* WHILE OCCURE(RWayS) *)
 END {PrintNotTaxRWayS};

 PRIVATE PROCEDURE NotTaxRWayS();
  CONST
   RepName = "NoTax";
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, RepTop, RepName);

  PrintNotTaxRWayS(1);
  MAKEPART(R, RepDlm);
  PrintNotTaxRWayS(2);

  MAKEPART(R, Bot);
  CLOSEREP(R);
 END {NotTaxPL};

 PRIVATE PROCEDURE IsBadActionChain(): SCAL[2];
  VAR
   prvAction: LIKE(XDocJrn.Action);
 BEGIN
  IF SELECT(XDocJrn, XDocJrn, L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS) &
     (XDocJrn.Action = L_XDoc.action_Insert) THEN
   RETURN 0;
  END;
  SETEMPTY(prvAction);
  WHILE OCCURE(XDocJrn) DO
   IF ~L_BegRWS.IsActionToIgnore(XDocJrn.Action) THEN
    prvAction:=XDocJrn.Action;
   END;
   IF NEXT(XDocJrn) &
      L_BegRWS.IsActionToCheck(XDocJrn.Action) &
      ~L_BegRWS.IsAcceptableAction(prvAction, XDocJrn.Action) THEN
    RETURN 1;
   END;
  END; (* WHILE OCCURE(XDocJrn) ... *)
  RETURN 0;
 END {IsBadActionChain};

 PRIVATE PROCEDURE BadActionChain();
  CONST
   RepName = "BChRW";
 BEGIN
  L_XDoc.sl_Init("  襭 楯窮 権");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, BadCh_Top, RepName);
  SELECT(RWayS, Date);
  SRCINSEL(RWayS, GE, , Memo.ud_fr());
  WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.ud_ut()) DO
   PROMPT(" " + RWayS.RWayS);
   IF IsBadActionChain() THEN
    CONFORM(RWayS, Staff);
    CONFORM(Staff, Man);
    L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS),
                      RWayS.RWayS + " " +
                      L_DatTim.DateStr(RWayS.Date));

    MAKEPART(R, BadCh_Line);
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_XDoc.sl_Done();
 END {BadActionChain};

(*
$P{ RWwPS_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
############################################################# ########## #####
=#####========================================================================
| 祭      ⠡  ਮ  ##########  ########## |
|----------------------------------------------------------------------------|
|     |    |.|⭨                                          |||
|=======|========|====|==================================================|=|=|
}
*)

(*
$P{ RWwPS_Line:
RWayS.RWayS, L, ""
RWayS.Date, L, "D.N.Y"
RWayS.BoxNbr, L, ""
?, L, L_Way.rwswho_Pool_Short
Staff.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
?, L, "-|"
?, L, "-||"
@
|#######|########|####|### ##### ########################################|#|#|
}
*)

(*
$P{ RWwPS_Line2:
?, L, L_Way.rwswho_Pool_Short
Staff.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
?, L, "-|"
?, L, "-||"
@
|       |        |    |### ##### ########################################|#|#|
}
*)

 PRIVATE PROCEDURE RWwPS_Test(VAR TSNCount: NUMERIC[0];
                          Who     : L_Way.tRWSWho;
                          _ToPay  : LIKE(RWayS.ToPay);
                          _ToSheet: LIKE(RWayS.ToSheet));
 BEGIN
  IF L_Env.RealTSN(Staff.TSN) & ((_ToSheet = L_Way.toSheet_Dummy) | ~_ToPay) THEN
   CONFORM(Staff, Man);
   IF TSNCount = 0 THEN
    L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS),
                      RWayS.RWayS + " " +
                      L_DatTim.DateStr(RWayS.Date));
    MAKEPART(R, RWwPS_Line, Who, _ToPay, _ToSheet);
   ELSE
    MAKEPART(R, RWwPS_Line2, Who, _ToPay, _ToSheet);
   END;
   INC(TSNCount);
  END;
 END {RWwPS_Test};

 PRIVATE PROCEDURE RWS_woPayOrSheet();
  CONST
   RepName = "RWwPS";
  VAR
   TSNCount: NUMERIC[0];
 BEGIN
  L_XDoc.sl_Init("  ⠡  ");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, RWwPS_Top, RepName);
  SELECT(RWayS, Date);
  SRCINSEL(RWayS, GE, , Memo.ud_fr());
  WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.ud_ut()) DO
   PROMPT(" " + RWayS.RWayS);
   TSNCount:=0;
   CONFORM(RWayS, Staff);
   RWwPS_Test(TSNCount, L_Way.rwswho_Driver, RWayS.ToPay, RWayS.ToSheet);
   SELECT(WayLMen, RWayS, , RWayS.RWayS);
   WHILE OCCURE(WayLMen) DO
    CONFORM(WayLMen, Staff);
    RWwPS_Test(TSNCount, WayLMen.Who + 1, L_Way.GetWLMToPaySign(WayLMen.Who), L_Way.GetWLMToSheetSign(WayLMen.Who));
    NEXT(WayLMen);
   END; (* WHILE OCCURE(WayLMen) ... *)
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_XDoc.sl_Done();
 END {RWS_woPayOrSheet};

BEGIN
 SE_ACCESSDATAMODE(AccessDataMode_SOFT);
 IF    MODE = 100 THEN
  BadActionChain();
 ELSIF MODE = 104 THEN
  NotTaxRWayS();
 ELSIF MODE = 105 THEN
  RWS_woPayOrSheet();
 ELSE
  L_General.BadMode(MODE);
 END; (* IF MODE =... *)
END.
