(*
%Copyright   (c) Polak Computer System
%Author
%Purpose      ⥫ (஢)    
%Type        report,operation
%Specific    AP
%Modified    28.02.2014 13:29:02 POLAK\Gina
%Environment
*)

 MODULE Shit04 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Staff, L_Way, L_AFM, L_Str, Math, L_Hld, L_EC,
        L_OwnData, L_Sheet, Str, L_Env, Memo, L_StdFrm, L_RWayS;

 PRIVATE TYPE
 tMode = SCAL[16];

 CONST
  TA          = 20;
  LPerPage    = 87;
  TSNPerPage  = 24;
  AnotherSign = "X";
  PupilSign   = "";

  m_DrvAllMainCnt = 0; (* ᥬ ⥫ (᭮ ⥫쭮)*)
  m_GrdAllMainCnt = 1; (* ᥬ ࠬ (᭮ ⥫쭮)*)
  m_DrvSingle     = 2; (* ⥪饬 ⥫*)
  m_GrdSingle     = 3; (* ⥪饬 *)
  m_DrvSingleKsk  = 4; (* ⥫  ᪥*)
  m_GrdSingleKsk  = 5; (*   ᪥*)
  m_DrvAll        = 6; (* ᥬ ⥫*)
  m_GrdAll        = 7; (* ᥬ ࠬ*)
  m_DrvAllNotMainCnt = 8; (* ᥬ ⥫ ( ᭮ ⥫쭮)*)
  m_GrdAllNotMainCnt = 9; (* ᥬ ࠬ ( ᭮ ⥫쭮)*)
  m_DrvAllMainCntBySort = 10; (* ᥬ ⥫ ⥪饣 ᥪ(.⥫쭮)*)

 VAR
  Mode : tMode;
  RName: STRING[9];
  _From,
  _UpTo    : DATE;
  TotTimes,
  Times    : NUMERIC[3][TA];
  CurTime  : NUMERIC[3];
  Done     : SCAL[2];
  _TimDone,
  _Bal,
  _CorBal  : NUMERIC[3];
  Sht      : LIKE(JMode.ShtSign)[32];
  TimesLn,
  TotTimesLn: NUMERIC[3];
  WkD       : STRING[2][32];
  NmH       : NUMERIC[3][32];
  Day       : SCAL[32];
  LinT,
  OthT      : NUMERIC[3][32];
  HolTime,
  NightTime,
  TotLinT,
  TotNotBT,
  TotOthT,
  TotTotT   : NUMERIC[3];
  Over      : NUMERIC[3];
  Page      : NUMERIC[0];
  AllTrips,
  GoodTrips,
  TAllTrips,
  TGoodTrips:  NUMERIC[1];

 PRIVATE PROCEDURE ExtraSortName(): STRING[];
 BEGIN
  IF ~!_StLg._ExtSort THEN
   L_General.Assert(SEARCH(TimeKeep, TimeKeep, _StLg._ExtSort), "  ⠡騪 "+_StLg._ExtSort);
   RETURN TimeKeep.Name;
  ELSE
   RETURN "";
  END;
 END {ExtraSortName};

(*
$P{ Sort:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RName, L, ""
("'' ࠡ⪨ "+Str.Item(" ⥫|஢", "|", GuardCond())+"  ਮ  "+L_DatTim.DateStr(_From)+"  "+L_DatTim.DateStr(_UpTo)), C, ""
Sort.Sort, L, ""
Sort.Name+" "+ExtraSortName(), L, ""
Page, R, "0"
WkD[01], L, ""
WkD[02], L, ""
WkD[03], L, ""
WkD[04], L, ""
WkD[05], L, ""
WkD[06], L, ""
WkD[07], L, ""
WkD[08], L, ""
WkD[09], L, ""
WkD[10], L, ""
WkD[11], L, ""
WkD[12], L, ""
WkD[13], L, ""
WkD[14], L, ""
WkD[15], L, ""
WkD[16], L, ""
WkD[17], L, ""
WkD[18], L, ""
WkD[19], L, ""
WkD[20], L, ""
WkD[21], L, ""
WkD[22], L, ""
WkD[23], L, ""
WkD[24], L, ""
WkD[25], L, ""
WkD[26], L, ""
WkD[27], L, ""
WkD[28], L, ""
WkD[29], L, ""
WkD[30], L, ""
WkD[31], L, ""
NmH[01], R, "1."
NmH[02], R, "1."
NmH[03], R, "1."
NmH[04], R, "1."
NmH[05], R, "1."
NmH[06], R, "1."
NmH[07], R, "1."
NmH[08], R, "1."
NmH[09], R, "1."
NmH[10], R, "1."
NmH[11], R, "1."
NmH[12], R, "1."
NmH[13], R, "1."
NmH[14], R, "1."
NmH[15], R, "1."
NmH[16], R, "1."
NmH[17], R, "1."
NmH[18], R, "1."
NmH[19], R, "1."
NmH[20], R, "1."
NmH[21], R, "1."
NmH[22], R, "1."
NmH[23], R, "1."
NmH[24], R, "1."
NmH[25], R, "1."
NmH[26], R, "1."
NmH[27], R, "1."
NmH[28], R, "1."
NmH[29], R, "1."
NmH[30], R, "1."
NmH[31], R, "1."
@
##############################################################################################                                                                                                                                                                ########## #####
=###==========================================================================================================================================================================================================================================================================
|############################################################################################################################################################################################################################################################################|
|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| ### ###################################################################                                                                                                                                                                                      ### |
|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|     |               |  01  |  02  |  03  |  04  |  05  |  06  |  07  |  08  |  09  |  10  |  11  |  12  |  13  |  14  |  15  |  16  |  17  |  18  |  19  |  20  |  21  |  22  |  23  |  24  |  25  |  26  |  27  |  28  |  29  |  30  |  31  |.|ࠡ|ᥣ|৤|"|
|. |            |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |  ##  |६.|     |     |    |"|
|-----|---------------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|-----|-----|-----|----|------|
|     |ଠ ᮢ    |######|######|######|######|######|######|######|######|######|######|######|######|######|######|######|######|######|######|######|######|######|######|######|######|######|######|######|######|######|######|######|     |     |     |    |      |
}
*)

(*
$P{ LineSh:
Staff.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
Sht[01], L, ""
LinT[01], R, "1."
Sht[02], L, ""
LinT[02], R, "1."
Sht[03], L, ""
LinT[03], R, "1."
Sht[04], L, ""
LinT[04], R, "1."
Sht[05], L, ""
LinT[05], R, "1."
Sht[06], L, ""
LinT[06], R, "1."
Sht[07], L, ""
LinT[07], R, "1."
Sht[08], L, ""
LinT[08], R, "1."
Sht[09], L, ""
LinT[09], R, "1."
Sht[10], L, ""
LinT[10], R, "1."
Sht[11], L, ""
LinT[11], R, "1."
Sht[12], L, ""
LinT[12], R, "1."
Sht[13], L, ""
LinT[13], R, "1."
Sht[14], L, ""
LinT[14], R, "1."
Sht[15], L, ""
LinT[15], R, "1."
Sht[16], L, ""
LinT[16], R, "1."
Sht[17], L, ""
LinT[17], R, "1."
Sht[18], L, ""
LinT[18], R, "1."
Sht[19], L, ""
LinT[19], R, "1."
Sht[20], L, ""
LinT[20], R, "1."
Sht[21], L, ""
LinT[21], R, "1."
Sht[22], L, ""
LinT[22], R, "1."
Sht[23], L, ""
LinT[23], R, "1."
Sht[24], L, ""
LinT[24], R, "1."
Sht[25], L, ""
LinT[25], R, "1."
Sht[26], L, ""
LinT[26], R, "1."
Sht[27], L, ""
LinT[27], R, "1."
Sht[28], L, ""
LinT[28], R, "1."
Sht[29], L, ""
LinT[29], R, "1."
Sht[30], L, ""
LinT[30], R, "1."
Sht[31], L, ""
LinT[31], R, "1."
_CorBal, R, "1."
TotLinT, R, "1."
TotTotT, R, "1."
HolTime, R, "0"
?, R, ""
OthT[01], R, "1."
OthT[02], R, "1."
OthT[03], R, "1."
OthT[04], R, "1."
OthT[05], R, "1."
OthT[06], R, "1."
OthT[07], R, "1."
OthT[08], R, "1."
OthT[09], R, "1."
OthT[10], R, "1."
OthT[11], R, "1."
OthT[12], R, "1."
OthT[13], R, "1."
OthT[14], R, "1."
OthT[15], R, "1."
OthT[16], R, "1."
OthT[17], R, "1."
OthT[18], R, "1."
OthT[19], R, "1."
OthT[20], R, "1."
OthT[21], R, "1."
OthT[22], R, "1."
OthT[23], R, "1."
OthT[24], R, "1."
OthT[25], R, "1."
OthT[26], R, "1."
OthT[27], R, "1."
OthT[28], R, "1."
OthT[29], R, "1."
OthT[30], R, "1."
OthT[31], R, "1."
TotOthT, R, "1."
?, R, ""
@
|-----|---------------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|-----|-----|-----|----|------|
|#####|###############|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|# ####|#####|#####|#####|####|######|
|     |               |  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|  ####|     |#####|     |    |######|
}
*)

(*
$P{ FillSh:
@
|-----|---------------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|------|-----|-----|-----|----|------|
|     |               |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |     |     |     |    |      |
|     |               |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |      |     |     |     |    |      |
}
*)

(*
$P{ BotSh:
@
=(c) Polak====================================================================================================================================================================================================================================================================
}
*)

(*
$P{ Top1:
_UpTo, L, "D.N.y"
@
==============================================================================
|                                 ⮣  ##########                        |
|----------------------------------------------------------------------------|
|                  |      ࠡ⠭|      ࠡ⪠|     ࠡ⪠|
|------------------------|----------------|-----------------|----------------|
}
*)

(*
$P{ TotSort:
Sort.Sort, L, ""
Sort.Name, L, ""
?, R, "1."
?, R, "1."
?, R, "1."
@
|### ####################|################|#################|################|
}
*)

(*
$P{ Bot1:
?, R, "1."
?, R, "1."
?, R, "1."
@
|========================|================|=================|================|
|⮣  ।    |################|#################|################|
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE E_Shit04_HasClientPartForSingleBot(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(Shit04_HasClientPartForSingleBot), 0);
 END {E_Shit04_HasClientPartForSingleBot};

 PRIVATE PROCEDURE E_Shit04_HasClientPartForNotSingleBot(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(Shit04_HasClientPartForNotSingleBot), 0);
 END {E_Shit04_HasClientPartForNotSingleBot};

 PRIVATE PROCEDURE E_Shit04_NeedDay(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(Shit04_NeedDay), 1);
 END {E_Shit04_NeedDay};

 PRIVATE PROCEDURE E_Shit04_NeedRWayS(_Who: SCAL[8]): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(Shit04_NeedRWayS);
  IF ~!Local THEN
   RETURN Shit04_NeedRWayS(_Who);
  ELSE
   RETURN 1;
  END;
 END {E_Shit04_NeedRWayS};

 PRIVATE PROCEDURE E_Shit04_NeedExclOtherOfficer(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(Shit04_NeedExclOtherOfficer), 0);
 END {E_Shit04_NeedExclOtherOfficer};

 PRIVATE PROCEDURE GetJMSign(_JMode: LIKE(JMode.JMode)): LIKE(JMode.ShtSign);
 BEGIN
  L_General.Assert(SEARCH(JMode, JMode, _JMode), " ࠢ筨  ᠭ  ࠡ  ⠡ "+_JMode);
  RETURN JMode.ShtSign;
 END {GetJMSign};

 PRIVATE PROCEDURE _Add(I: NUMERIC[0]; TimeType: SCAL[2]);
 BEGIN
  INC(   Times[I], CurTime);
  INC(TotTimes[I], CurTime);
  INC(TotTimesLn,  CurTime);
  IF TimeType THEN
   INC(LinT[Day], CurTime);
   INC(TotLinT,   CurTime);
   IF Quality.Type # L_Way.QualType_Defect (* ࠪ*) THEN
    INC(TotNotBT, CurTime);
   END;
  ELSE
   INC(OthT[Day], CurTime);
   INC(TotOthT,   CurTime);
  END;
 END {_Add};

 PRIVATE PROCEDURE Conv(VAR T, t: NUMERIC[3][]; MaxIdx: SCAL[100]);
  VAR i: NUMERIC[0];
 BEGIN i:=1;
  WHILE i < MaxIdx DO
   IF AsSingleCond() THEN
    INC(TimesLn, T[i]);
   END;
   IF (T[i] = 0) & (!t[i] | (t[i] = 0)) THEN
    SETEMPTY(T[i]);
   END;
   INC(i);
  END;
 END {Conv};

 PRIVATE PROCEDURE ConvSht(VAR _ShtSign: LIKE(JMode.ShtSign)[32]; MaxIdx: SCAL[100]);
  VAR
   i: NUMERIC[0];
   LineSign: LIKE(JMode.ShtSign);
 BEGIN
  LineSign:=GetJMSign(L_Sheet.jm_Line(_From));
  i:=1;
  WHILE i < MaxIdx DO
   IF (_ShtSign[i] = LineSign) THEN
    SETEMPTY(_ShtSign[i]);
   END;
   INC(i);
  END;
 END {ConvSht};

 PRIVATE PROCEDURE SetSht(Idx: NUMERIC[0]; _ShtSign: LIKE(JMode.ShtSign));
 BEGIN
  IF !Sht[Idx] THEN
   Sht[Idx]:=_ShtSign;
  END;
 END {SetSht};

 PRIVATE PROCEDURE GetGate(VAR D1, D2: DATE);
 BEGIN
  IF Staff.BegDate > _From THEN
   D1:=Staff.BegDate;
  ELSE
   D1:=_From;
  END;
  IF !Staff.EndDate THEN
   D2:=_UpTo;
  ELSE
   D2:=Math.Min(Staff.EndDate, _UpTo);
  END;
 END {GetGate};

 PRIVATE PROCEDURE GetBal();
  VAR
   EndD,
   SeqD,
   D     : DATE;
   _Tim  : LIKE(Sheet.Tim);
   _Night: LIKE(Sheet.SpTime);
   OutStaffSign: LIKE(JMode.ShtSign);
   _Day  : SCAL[32];
 BEGIN
  OutStaffSign:=GetJMSign(L_Sheet.jm_ContractBreak(_From));

  SETZERO(_TimDone, _Bal, _CorBal);
  GetGate(SeqD, EndD);

  D:=_From;
  WHILE D<=Math.Min(SeqD-1, _UpTo) DO
   SetSht(L_DatTim.DAY(D), OutStaffSign); (* *)
   INC(D);
  END;

  WHILE D<=EndD DO
   PROMPT(Staff.TSN + " - " + L_DatTim.DateStr(D));
   _Day:=L_DatTim.DAY(D);
   HISTCONF(D, Staff, StaffLog, Officer);
   IF L_Staff.IsDischargeStaffLog() THEN
    SetSht(_Day, OutStaffSign);
   ELSIF E_Shit04_NeedExclOtherOfficer(D) & ((DriverCond() & ~Shit04_Driver()) | (GuardCond() & ~L_Env.IsGuard())) THEN
    SetSht(_Day, AnotherSign);
   ELSE
    L_General.Assert(SEARCH(RegList, HumReg, StaffLog.Regime, L_DatTim.Per(D), _Day),
           " ⠭ ० ࠡ "+StaffLog.Regime+"  "+L_DatTim.DateStr(D));
    SETZERO(_Night);
 
    IF SEARCH(Sheet, TSN, Staff.TSN, L_DatTim.Per(D), _Day) & (Sheet.Source # L_Sheet.src_Regime) THEN
     CONFORM(Sheet, JMode);
     _Tim:=Sheet.Tim;
     IF Sheet.SpKind = L_Sheet.spk_Night THEN
      _Night:=Sheet.SpTime;
     END;
     IF !Sht[_Day] THEN
      IF SELECT(_WMen, _WMen, D) & ((_WMen.Who=L_Way.rwswho_DrPupil)|(_WMen.Who=L_Way.rwswho_GuPupil)) THEN
       SetSht(_Day, PupilSign);
       IF E_Shit04_NeedDay(D) THEN
        OthT[_Day]:=Sheet.Tim;
        INC(TotOthT, OthT[_Day]);
       END;
      ELSE
       SetSht(_Day, JMode.ShtSign);
      END;
     END;
    ELSE
     CONFORM(RegList, JMode);
     _Tim:=RegList.GrTime;
     IF RegList.SpKind = L_Sheet.spk_Night THEN
      _Night:=RegList.SpTime;
     END;
     IF !Sht[_Day] THEN
      Shit04_RegimeSign(D);
     END;
    END;
    IF E_Shit04_NeedDay(D) & JMode.InFirm THEN
     IF    JMode.Type = L_Sheet.jmType_TimDone THEN
      INC(_TimDone, _Tim);
      INC(NightTime, _Night);
     ELSIF JMode.DecrBal THEN
      DEC(_CorBal, _Tim);
     END;
     IF L_Hld.DayIsHoliday(D) THEN
      INC(HolTime, _Tim);
     END;
     INC(_Bal, RegList.Durat);
    END;
   END;
   INC(D);
  END;

  WHILE D <= _UpTo DO
   SetSht(L_DatTim.DAY(D), OutStaffSign); (* *)
   INC(D);
  END;

  _CorBal:=_Bal+_CorBal;
 END {GetBal};

 PRIVATE PROCEDURE SetCurTimes(curStartT, curStopT: TIME);
  VAR
   TotCoef: L_RWayS.tTimeCoeff;
 BEGIN
  TotCoef:=L_RWayS.E_RWAYS_CoeffForCurTimes(RWayS.Date, _WMen.Who) + L_RWayS.E_RWAYS_CoeffForAddTimes(RWayS.Date, _WMen.Who);
  CurTime:=TotCoef * (curStopT  - curStartT);
 END {SetCurTimes};

 PRIVATE PROCEDURE LeftCond(): SCAL[2];
  VAR
   doIt: SCAL[2];
 BEGIN
  IF L_RWayS.E_GetTimesFromWayLMen() THEN
   TRY [RESTORE_CURSORS(RC_ON)]
    doIt:=~PREV(RWayJ);
   EXCEPT
   END; (* TRY *)
   IF doIt THEN
    SetCurTimes(WayLMen.StartT, WayLMen.StopT);
   ELSE
    CurTime:=0;
   END;
  ELSE
   IF L_RWayS.IsRWayJForCurWayLMen() THEN
    SetCurTimes(RWayJ.StartT, RWayJ.StopT);
    IF WayLMen.Who = L_Way.wlmwho_Chopper THEN
     L_Way.PosToWJMethod(SEJobs.WJCode, L_Way.rwswho_Chopper, L_Way.GetRouteJRegime(RWayS.Date, 1), L_RWayS.Qlt_Good, RWayS.Date);
     IF WJMethod.TimeSel = 0 THEN
      CurTime:=0;
     END;
    END;
   ELSE
    CurTime:=0;
   END;
  END;
  RETURN CurTime > 0;
 END {LeftCond};

 PRIVATE PROCEDURE DrvCond(): SCAL[2];
 BEGIN
  SetCurTimes(RWayJ.StartT, RWayJ.StopT);
  RETURN 1;
 END {DrvCond};

 PRIVATE PROCEDURE ClientPartForSingleBot();
 BEGIN
  IF E_Shit04_HasClientPartForSingleBot(_UpTo) THEN
   Shit04_MakeClientPartForSingleBot();
  END;
 END {ClientPartForSingleBot};

 PRIVATE PROCEDURE ClientPartForNotSingleBot();
 BEGIN
  IF E_Shit04_HasClientPartForNotSingleBot(_UpTo) THEN
   Shit04_MakeClientPartForNotSingleBot();
  END;
 END {ClientPartForNotSingleBot};

 PRIVATE PROCEDURE LinesPerPage(): NUMERIC[0];
 BEGIN
  IF E_Shit04_HasClientPartForNotSingleBot(_UpTo) THEN
   RETURN LPerPage + Shit04_ClientPartForNotSingleBotDepth();
  ELSE
   RETURN LPerPage;
  END;
 END {LinesPerPage};

 PRIVATE PROCEDURE LMDrNeed(): SCAL[2];
 BEGIN
  RETURN (WayLMen.Who = L_Way.wlmwho_DrPupil) | (WayLMen.Who = L_Way.wlmwho_SDriver);
 END {LMDrNeed};

 PRIVATE PROCEDURE LMGuNeed(): SCAL[2];
 BEGIN
  RETURN (WayLMen.Who = L_Way.wlmwho_Guard) | (WayLMen.Who = L_Way.wlmwho_GuPupil) | (WayLMen.Who = L_Way.wlmwho_Chopper);
 END {LMGuNeed};

 PRIVATE PROCEDURE Create_WMen();
 BEGIN
  CreateFILE(_WMen, "", "ᮭ ", "");

  CreateFIELD(_WMen, RWayS, LIKE(RWayS.RWayS), "", "", "", " ⥢ ", "");
  CreateFIELD(_WMen, Date, DATE, "", "", "", " ⥢ ", "");
  CreateFIELD(_WMen, Day, LIKE(WayLMen.Day), "1", "", "", " 砫 ࠡ", "");
  CreateFIELD(_WMen, Who, SCAL[8], "", "0", "", "0-;1-⠦ ⥫;2-⠦ ;3- 2 ;4-稪", "");
  CreateFIELD(_WMen, StartT, TIME, "", "", "", "砫 ࠡ", "");
  CreateFIELD(_WMen, Number, SCAL[100], "1", "1", "", "  ਣ", "");

  CreateINDEX(_WMen, _WMen, UNIQUE, "", "", Date, RWayS, Who, Day, StartT, Number);
  CreateINDEXandLINK(_WMen, RWayS, PLURAL, RWayS, RWayS, USER, "", "", RWayS);

  SetVersionOfFILE(_WMen, 0);
 END {Create_WMen};

 PRIVATE PROCEDURE MakeIndex();
  VAR
   LMenNeed: PROC;
 BEGIN
  IF DriverCond() THEN
   LMenNeed:=PROCREF(LMDrNeed);
  ELSE
   LMenNeed:=PROCREF(LMGuNeed);
  END;
  L_AFM.AF_CreateTemp("_WMen", "_WMen");
 
  SELECT(WayLMen, TSN, , Staff.TSN);
  SRCINSEL(WayLMen, GE, , _From);
  WHILE OCCURE(WayLMen) & (WayLMen.RWayDate <= _UpTo) DO
   PROMPT(WayLMen.TSN + " - " + L_DatTim.DateStr(WayLMen.RWayDate) + " : " + WayLMen.RWayS);
   CONFORM(WayLMen, RWayS);
   IF LMenNeed() THEN
    _WMen.Date  := RWayS.Date;
    _WMen.RWayS := WayLMen.RWayS;
    _WMen.Day   := WayLMen.Day;
    _WMen.StartT:= WayLMen.StartT;
    _WMen.Who   := WayLMen.Who + 1;
    _WMen.Number:= WayLMen.Number;
    INSERT(_WMen);
   END;
   NEXT(WayLMen);
  END; (* WHILE OCCURE(WayLMen)... *)

  IF DriverCond() THEN
   SELECT(RWayS, TSN, , Staff.TSN);
   SRCINSEL(RWayS, GE, , _From);
   WHILE OCCURE(RWayS) & (RWayS.Date <= _UpTo) DO
    _WMen.Date  := RWayS.Date;
    _WMen.RWayS := RWayS.RWayS;
    _WMen.Day   := C_L2D(RWayS.StartTim);
    _WMen.StartT:= C_L2T(RWayS.StartTim);
    _WMen.Who   := L_Way.rwswho_Driver;
    _WMen.Number:= 1;
    INSERT(_WMen);
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS) ... *)
  END;
 END {MakeIndex};

 PRIVATE PROCEDURE OneRWayS(Cond: PROC; VAR RWaysCnt, NDCnt: NUMERIC[0]; VAR Done: SCAL[2]);
 BEGIN
  Day:=L_DatTim.DAY(RWayS.Date);
  CurTime:=0;
  HISTCONF(RWayS.Date, Staff, StaffLog, Officer);
  IF ((_WMen.Who # L_Way.rwswho_Driver) | (RWayS.ToSheet # L_Way.toSheet_Dummy)) &
     E_Shit04_NeedRWayS(_WMen.Who) THEN
   INC(RWaysCnt);
   IF ~RWayS.Done THEN
    Done:=0;
    INC(NDCnt);
   END;
   IF RWayS.Status = L_Way.rwsStat_Rated THEN
    CONFORM(RWayS, RWayJ);
    WHILE OCCURE(RWayJ) DO
     CONFORM(RWayJ, SEJobs);
     CONFORM(SEJobs, Route);
     CONFORM(RWayJ, Quality);
     L_General.CallUs(SEARCH(WJMode, WJCode, L_RWayS.GetasWJMode(_WMen.Who)));
     L_Way.StandOnRouteTKind(RWayS.Date);
     IF (Quality.Type > L_Way.QualType_Annul) & Cond() THEN
      L_Way.PosToWJMethod(WJMode.WJCode, L_Way.GetWho(_WMen.Who), L_Way.GetRouteJRegime(RWayS.Date, 1), RWayJ.Quality, RWayS.Date);
      IF WJMethod.TimeSel THEN
       Shit04_AddTimes((GuardCond()  & L_Env.IsGuard()) |
                       (DriverCond() & Shit04_Driver()));
      END;
     END;
     NEXT(RWayJ);
    END; (* WHILE OCCURE(RWayJ)... *)
    IF (DriverCond() & (L_Way.GetWho(_WMen.Who) = L_Way.rwswho_Driver)) |
       (GuardCond()  & (L_Way.GetWho(_WMen.Who) = L_Way.rwswho_Guard))  THEN
     CurTime:=L_Way.E_GetPzvTotalTime(L_Way.GetWho(_WMen.Who));
     L_Way.PosToWJMethod(L_Way.RWaySType(RWayS.Type), L_Way.GetWho(_WMen.Who), 01, L_RWayS.Qlt_Good, RWayS.Date);
     IF WJMethod.TimeSel THEN
      _Add(6, 0);
     END;
    END;
   END;
  END;
 END {OneRWayS};

 PRIVATE PROCEDURE StandOnRWayS();
 BEGIN
  IF _WMen.Who > L_Way.rwswho_Driver THEN
   L_General.Assert(SEARCH(WayLMen, RWayS, _WMen.RWayS, _WMen.Who-1, _WMen.Day, _WMen.StartT, _WMen.Number, Staff.TSN), "    . ᮭ"+_WMen.RWayS);
   CONFORM(WayLMen, RWayS);
  ELSE
   L_General.Assert(SEARCH(RWayS, RWayS, _WMen.RWayS), "    ⥫ "+_WMen.RWayS);
  END;
 END {StandOnRWayS};

 PRIVATE PROCEDURE MakeTSN();
  VAR
   Dummy   : NUMERIC[3][TA];
   RWaysCnt,
   NDCnt   : NUMERIC[0];
 BEGIN
  CONFORM(Staff, Man);
  IF AsSingleCond() THEN
   Shit04_MakePart("Top");
  END;
  SETZERO(Dummy, TotTimes, TotTimesLn, LinT, OthT, TotLinT, TotOthT, HolTime, NightTime,
          TotNotBT, TimesLn, NDCnt, TAllTrips, TGoodTrips);
  SETEMPTY(Sht);

  MakeIndex();

  SELECT(_WMen, _WMen);
  WHILE OCCURE(_WMen) DO
   CHANGESEL(_WMen,  _WMen, , _WMen.Date);
   SETZERO(Times, TimesLn, RWaysCnt, AllTrips, GoodTrips); Done:=1;
   WHILE OCCURE(_WMen) DO
    PROMPT(Staff.TSN + " - " + L_DatTim.DateStr(_WMen.Date) + " : " + _WMen.RWayS);
    StandOnRWayS();
    IF _WMen.Who > L_Way.rwswho_Driver THEN
     OneRWayS(PROCREF(LeftCond), RWaysCnt, NDCnt, Done);
    ELSE
     OneRWayS(PROCREF(DrvCond), RWaysCnt, NDCnt, Done);
    END;
    NEXT(_WMen);
   END; (* WHILE ... *)
   LAST(_WMen);
   StandOnRWayS();
   IF RWaysCnt THEN
    INC(TAllTrips, AllTrips);
    INC(TGoodTrips, GoodTrips);
    IF ((_WMen.Who = L_Way.rwswho_Driver) & (RWayS.ToSheet = L_Way.toSheet_Holid)) |
       (((_WMen.Who = L_Way.rwswho_Guard) | (_WMen.Who = L_Way.rwswho_SDriver)) &
        (L_Way.GetWLMToSheetSign(WayLMen.Who) = L_Way.toSheet_Holid)) THEN
     SetSht(Day, GetJMSign(L_Sheet.jm_LineHld(_From)));
    ELSE
     IF ~Done THEN
      IF RWayS.Status # L_Way.rwsStat_Rated THEN
       SetSht(Day, "!");
      ELSE
       SetSht(Day, "?");
      END;
     ELSIF (_WMen.Who = L_Way.rwswho_DrPupil)|(_WMen.Who = L_Way.rwswho_GuPupil) THEN
      SetSht(Day, PupilSign);
     END;
    END;
    IF AsSingleCond() THEN
     Conv(Times, Dummy, TA);
     Shit04_MakePart("Line");
    END;
   ELSIF OCCURE(RWayS) & (RWayS.Status # L_Way.rwsStat_Rated) THEN
    SetSht(Day, "!");
   END;
   CHANGESEL(_WMen, _WMen);
   NEXT(_WMen);
  END;

  GetBal();

  TotTotT:=TotLinT+TotOthT;
  IF NDCnt = 0 THEN
   Over:=_TimDone - _CorBal;
  ELSE
   Over:=TotTotT - _CorBal;
  END;

  IF AsSingleCond() THEN
   Conv(TotTimes, Dummy, TA);
   ClientPartForSingleBot();
   Shit04_MakePart("Bot");
  ELSE
   Conv(LinT, OthT, 32);
   Conv(OthT, LinT, 32);
   ConvSht(Sht, 32);
   IF (Over = 0) & (NDCnt = 0) THEN
    MAKEPART(R, LineSh,
             "",
             "");
   ELSE
    MAKEPART(R, LineSh,
             L_Str.PoolItem("?| ", NDCnt = 0) + " " + L_Str.PoolItem("---|+++", Over >= 0),
             FLDTOSTR(Math.Abs(Over), "1.", 6));
   END;
  END;
  L_AFM.AF_PurgeTemp("_WMen");

 END {MakeTSN};

 PRIVATE PROCEDURE StaffCond(): SCAL[2];
 BEGIN
  RETURN (((Mode=m_DrvAllMainCnt) | (Mode = m_DrvAllMainCntBySort) | (Mode = m_GrdAllMainCnt)) & (Staff.Contract=L_Staff.cnt_Basic))
       | (((Mode = m_DrvAllNotMainCnt) | (Mode = m_GrdAllNotMainCnt)) & (Staff.Contract#L_Staff.cnt_Basic)
       |  (Mode = m_DrvAll) | (Mode = m_GrdAll));
 END {StaffCond};

 PRIVATE PROCEDURE SortCond(): SCAL[2];
 BEGIN
  IF Mode = m_DrvAllMainCntBySort THEN
   RETURN StaffLog.Sort = Sort.Sort;
  ELSE
   RETURN 1;
  END;
 END {SortCond};

 PRIVATE PROCEDURE GuardCond(): SCAL[2];
 BEGIN
  RETURN (Mode = m_GrdAllMainCnt) | (Mode = m_GrdSingle) | (Mode = m_GrdAll) | (Mode = m_GrdAllNotMainCnt) | (Mode = m_GrdSingleKsk);
 END {GuardCond};

 PRIVATE PROCEDURE DriverCond(): SCAL[2];
 BEGIN
  RETURN (Mode=m_DrvAllMainCnt) | (Mode = m_DrvAll) | (Mode = m_DrvAllMainCntBySort) | (Mode = m_DrvAllNotMainCnt) | (Mode = m_DrvSingle) | (Mode = m_DrvSingleKsk);
 END {DriverCond};

 PRIVATE PROCEDURE StreamCond(): SCAL[2];
 BEGIN
  RETURN (Mode=m_DrvAllMainCnt) | (Mode = m_DrvAll) | (Mode = m_GrdAll) | (Mode = m_DrvAllMainCntBySort) | (Mode = m_DrvAllNotMainCnt) | (Mode = m_GrdAllMainCnt) | (Mode = m_GrdAllNotMainCnt);
 END {StreamCond};

 PRIVATE PROCEDURE SingleCond(): SCAL[2];
 BEGIN
  RETURN (Mode = m_DrvSingle) | (Mode = m_GrdSingle) | (Mode = m_DrvSingleKsk) | (Mode = m_GrdSingleKsk);
 END {SingleCond};

 PRIVATE PROCEDURE AsSingleCond(): SCAL[2];
 BEGIN
  RETURN SingleCond();
 END {AsSingleCond()};

 PRIVATE PROCEDURE E_Shit04_NeedExtraSort(): LIKE(Officer.TimeKeep);
 BEGIN
  IF L_EC.ExecE_Func_Scal2(_From, PROCREF(Shit04_NeedExtraSort), 0) THEN
   RETURN Officer.TimeKeep;
  ELSE
   RETURN EMPTYOF(Officer.TimeKeep);
  END;
 END {E_Shit04_NeedExtraSort};

 PRIVATE PROCEDURE E_Shit04_NeedSpleetByColumn(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(_From, PROCREF(Shit04_NeedSpleetByColumn), 0);
 END {E_Shit04_NeedSpleetByColumn};

 PRIVATE PROCEDURE MakeIndx();
  VAR
   Done: SCAL[2];

   SortList  : STRING[];
   SortChoice: NUMERIC[0];
   _Sort     : LIKE(Sort.Sort);
 BEGIN
  SETEMPTY(_Sort);
  IF ((Mode = m_DrvAll) | (Mode=m_DrvAllMainCnt)) & E_Shit04_NeedSpleetByColumn() THEN
   PROMPT("⮢ ᯨ᪠ ᥪ஢");
   SELECT(Staff, TSN);
   WHILE OCCURE(Staff) & (Staff.TSN = L_Env.fictTSN) DO
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
   L_General.CallUs(OCCURE(Staff));

   SortList:="     ";
   SELECT(Sort, Sort);
   WHILE OCCURE(Sort) DO
    PROMPT("⮢ ᯨ᪠ ᥪ஢ " + Sort.Sort);
    SELECT(Officer, Sort, , Sort.Sort);
    WHILE OCCURE(Officer) DO
     IF Shit04_Driver() THEN
      SortList:=SortList + "|" + Sort.Sort + " " + Sort.Name;
      LAST(Officer);
     END;
     NEXT(Officer);
    END; (* WHILE OCCURE(Officer) ... *)
    NEXT(Sort);
   END; (* WHILE OCCURE(Sort) ... *)

   SortChoice:=L_StdFrm.ShowListAsMenu(SortList, "롮 ");
   IF SortChoice > 0 THEN
    _Sort:=Str.Item(L_Str.PoolItem(SortList, SortChoice), " ", 0);
   END;
  END;

  L_AFM.MakeIndex("_StLg", "_Sort: LIKE(StaffLog.Sort);"+
                           "_ExtSort: LIKE(StaffLog.Sort);"+
                           "_TSN : LIKE(StaffLog.TSN);"+
                           "_Date: DATE;");

  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(" "+Staff.TSN);
   IF L_Env.RealTSN(Staff.TSN) & StaffCond() THEN
    SELECT(StaffLog, TSN, , Staff.TSN);
    LAST(StaffLog);
    Done:=0;
    WHILE OCCURE(StaffLog) & ~Done DO
     CONFORM(StaffLog, Staff, Officer);
     IF ((DriverCond() & Shit04_Driver() & (!_Sort | (_Sort = StaffLog.Sort))) |
         (GuardCond() & L_Env.IsGuard())) &
        L_Staff.OrderInMonth(_From) & ~L_Staff.IsDischargeStaffLog() & SortCond() THEN
      _StLg._Sort   :=StaffLog.Sort;
      _StLg._ExtSort:=E_Shit04_NeedExtraSort();
      _StLg._TSN    :=StaffLog.TSN;
      _StLg._Date   :=StaffLog.Date;
      INSERT(_StLg);
      Done:=1;
     END;
     PREV(StaffLog);
    END; (* WHILE OCCURE(StaffLog)... *)
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff)... *)
 END {MakeIndx};

 PRIVATE PROCEDURE SetWkD();
  VAR
   _Bal : NUMERIC[3];
 BEGIN
  _Bal:=0; SETEMPTY(WkD, NmH);
  SELECT(Calendar, Period, , _From);
  WHILE OCCURE(Calendar) DO
   WkD[Calendar.Day]:=L_DatTim.WeekDayShortStr(Calendar.WeekDay);
   L_General.Assert(SEARCH(RegList, HumReg, Shit04_Regime(), _From, Calendar.Day), "  䨪 "+Shit04_Regime()+"  "+L_DatTim.DateStr(Calendar.Period+(Calendar.Day-1)));
   INC(_Bal, RegList.Durat);
   NmH[Calendar.Day]:=_Bal;
   NEXT(Calendar);
  END; (* WHILE OCCURE(Calendar)... *)
 END {SetWkD};

 PRIVATE PROCEDURE Make();
  VAR
   Cnt   : NUMERIC[0];
   PTotT,
   PUndT,
   POvrT,
   STotT,
   SUndT,
   SOvrT : NUMERIC[3];
 BEGIN
  IF StreamCond() THEN
   L_AFM.MakeIndex("_Sort", "_Sort: LIKE(Sort.Sort);"+
                            "_ExtSort: LIKE(Sort.Sort);"+
                            "TotT : NUMERIC[3];"+
                            "UndT : NUMERIC[3];"+
                            "OvrT : NUMERIC[3];");
   SetWkD();
   MakeIndx();
   SELECT(_StLg, _StLg);
   WHILE OCCURE(_StLg) DO
    CHANGESEL(_StLg, _StLg, , _StLg._Sort);
    SEARCH(Sort, Sort, , _StLg._Sort);
    WHILE OCCURE(_StLg) DO
     CHANGESEL(_StLg, _StLg, , _StLg._Sort, _StLg._ExtSort);
     WHILE OCCURE(_StLg) DO
      SETZERO(STotT, SUndT, SOvrT);
      Page:=1;
      WHILE OCCURE(_StLg) DO
       IF ~AsSingleCond() THEN
        MAKEPART(R, Sort);
       END;
       Cnt:=0;
       WHILE OCCURE(_StLg) & (Cnt <= TSNPerPage) DO
        SEARCH(StaffLog, TSN, , _StLg._TSN, _StLg._Date);
        CONFORM(StaffLog, Staff);
        SETZERO(LinT, OthT);
        MakeTSN();
        INC(STotT, TotTotT);
        IF Over > 0 THEN
         INC(SOvrT, Over);
        ELSE
         INC(SUndT, -Over);
        END;
        NEXT(_StLg);
        INC(Cnt);
       END;
       IF ~AsSingleCond() THEN
        WHILE (Cnt <= TSNPerPage) DO
         MAKEPART(R, FillSh);
         INC(Cnt);
        END;
        MAKEPART(R, BotSh);
        ClientPartForNotSingleBot();
        IF OCCURE(_StLg) THEN
         FORMFEED(R);
        END;
       END;
       INC(Page);
      END; (* WHILE OCCURE(_StLg)... *)
      LAST(_StLg);
      _Sort._Sort   :=Sort.Sort;
      _Sort._ExtSort:=_StLg._ExtSort;
      _Sort.TotT    :=STotT;
      _Sort.UndT    :=SUndT;
      _Sort.OvrT    :=SOvrT;
      INSERT(_Sort);
      NEXT(_StLg);
     END; (* WHILE OCCURE(_StLg)... *)
     LAST(_StLg);
     CHANGESEL(_StLg, _StLg, , _StLg._Sort);
     NEXT(_StLg);
    END; (* WHILE OCCURE(_StLg)... *)
    LAST(_StLg);
    CHANGESEL(_StLg, _StLg);
    NEXT(_StLg);
   END; (* WHILE OCCURE(_StLg)... *)
   InitPrintAttr(R, Orientation, Landscape);
   MAKEPART(R, Top1);
   SETZERO(PTotT, PUndT, POvrT);
   SELECT(_Sort, _Sort);
   WHILE OCCURE(_Sort) DO
    SEARCH(Sort, Sort, , _Sort._Sort);
    STotT:=_Sort.TotT;
    SUndT:=_Sort.UndT;
    SOvrT:=_Sort.OvrT;
    INC(PTotT, STotT);
    INC(PUndT, SUndT);
    INC(POvrT, SOvrT);
    MAKEPART(R, TotSort, STotT, SUndT, SOvrT);
    NEXT(_Sort);
   END; (* WHILE OCCURE(_Sort)... *)
   MAKEPART(R, Bot1, PTotT, PUndT, POvrT);
   L_AFM.AF_PurgeTemp("_StLg");
   L_AFM.AF_PurgeTemp("_Sort");
  ELSE
   L_General.Assert(ACCESS(Staff), " ⠭ ࠡ⭨");
   MakeTSN();
  END;
 END {Make};

 PRIVATE PROCEDURE EUMode(): SCAL[2];
 BEGIN
  RETURN (Mode = m_GrdSingleKsk) | (Mode = m_DrvSingleKsk);
 END {EUMode};

 PRIVATE PROCEDURE GetRepName(): STRING[];
 BEGIN
  IF    (Mode = m_DrvAll) | (Mode=m_DrvAllMainCnt) THEN
   RETURN "Sh4";
  ELSIF Mode = m_DrvAllMainCntBySort THEN
   L_General.Assert(ACCESS(Sort), " ⠭ ᥪ");
   RETURN "S"+Str.Slice(Sort.Sort, 1, 2);
  ELSIF (Mode = m_GrdAllMainCnt) | (Mode = m_GrdAll) THEN
   RETURN "Sg4";
  ELSIF Mode = m_DrvAllNotMainCnt THEN
   RETURN "Sh04o";
  ELSIF Mode = m_DrvSingle THEN
   RETURN "Sht04";
  ELSIF Mode = m_GrdSingle THEN
   RETURN "Sht4G";
  ELSIF Mode = m_GrdAllNotMainCnt THEN
   RETURN "Sg04o";
  ELSIF EUMode() THEN
   RETURN "Sht04";
  ELSE
   L_General.CallUs(0);
  END;
 END {GetRepName};

 PRIVATE PROCEDURE GetFullRepName(): STRING[];
 BEGIN
  IF Str.Length(RName) = 3 THEN RETURN L_General.NameMonth(RName);
  ELSE                          RETURN L_General.NameConnection(RName);
  END;
 END {GetFullRepName};

 PRIVATE PROCEDURE E_Shit04_NeedMargin(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(Shit04_NeedMargin), 0);
 END {E_Shit04_NeedMargin};

 PRIVATE PROCEDURE Shit04_Make();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  PASTE(E_Shit04);
  RName:=GetRepName();
  IF ~EUMode() THEN
   _From:=Memo.ud_mb();
   _UpTo:=Memo.ud_cd();
   OPENREP(R, GetFullRepName(), Create);
   IF ~AsSingleCond() THEN
    IF E_Shit04_NeedMargin() THEN
     SetPrintAttr(R, Orientation,     Landscape,
                     LinesPerPage,    LinesPerPage());
    ELSE
     SetPrintAttr(R, Orientation,     Landscape,
                     TopMargin,       0,
                     BottomMargin,    0,
                     LeftMargin,      0,
                     RightMargin,     0,
                     LinesPerPage,    LinesPerPage());
    END;
   END;
  ELSE
   _From:=Memo.ud_fr();
   _UpTo:=Memo.ud_ut();
  END;
  Create_WMen();
  Make();
  IF ~EUMode() THEN
   CLOSEREP(R);
  END;
 END {Shit04_Make};

 PUBLIC PROCEDURE Shit04_DrvAllMainCnt();
 BEGIN
  Mode:=m_DrvAllMainCnt;
  Shit04_Make();
  L_General.SurveyLastReport();
 END {Shit04_DrvAllMainCnt};

 PUBLIC PROCEDURE Shit04_GrdAllMainCnt();
 BEGIN
  Mode:=m_GrdAllMainCnt;
  Shit04_Make();
  L_General.SurveyLastReport();
 END {Shit04_GrdAllMainCnt};

 PUBLIC PROCEDURE Shit04_DrvSingle();
 BEGIN
  Mode:=m_DrvSingle;
  Shit04_Make();
  L_General.SurveyLastReport();
 END {Shit04_DrvSingle};

 PUBLIC PROCEDURE Shit04_GrdSingle();
 BEGIN
  Mode:=m_GrdSingle;
  Shit04_Make();
  L_General.SurveyLastReport();
 END {Shit04_GrdSingle};

 PUBLIC PROCEDURE Shit04_DrvSingleKsk();
 BEGIN
  Mode:=m_DrvSingleKsk;
  Shit04_Make();
 END {Shit04_DrvSingleKsk};

 PUBLIC PROCEDURE Shit04_GrdSingleKsk();
 BEGIN
  Mode:=m_GrdSingleKsk;
  Shit04_Make();
 END {Shit04_GrdSingleKsk};

 PUBLIC PROCEDURE Shit04_DrvAll();
 BEGIN
  Mode:=m_DrvAll;
  Shit04_Make();
  L_General.SurveyLastReport();
 END {Shit04_DrvAll};

 PUBLIC PROCEDURE Shit04_GrdAll();
 BEGIN
  Mode:=m_GrdAll;
  Shit04_Make();
  L_General.SurveyLastReport();
 END {Shit04_GrdAll};

 PUBLIC PROCEDURE Shit04_DrvAllNotMainCnt();
 BEGIN
  Mode:=m_DrvAllNotMainCnt;
  Shit04_Make();
  L_General.SurveyLastReport();
 END {Shit04_DrvAllNotMainCnt};

 PUBLIC PROCEDURE Shit04_DrvAllMainCntBySort();
 BEGIN
  Mode:=m_DrvAllMainCntBySort;
  Shit04_Make();
  L_General.SurveyLastReport();
 END {Shit04_DrvAllMainCntBySort};

END.
