(*
%Copyright   (c) Polak IT
%Author      16.01.2014 19:38:50 POLAK\Bor
%Purpose        ᪮ࠪ  ਮ
%Type        report
%Specific    AP
%Modified    25.06.2014 19:03:37 POLAK\Gina
%Environment
*)

 MODULE Shit06 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_AFM, L_DatTim, L_Car, L_Str, L_Way, L_Excel, D_TP, L_StdFrm, Math, L_Env, P_Mark, L_APtm,
        P_Route, P_Firm, L_Prop, L_kn;

 TYPE
  tOrdTim = NUMERIC[3];

 CONST
  totC = 10;

  erkn_Route_Shit06 = 009423700;

 VAR
  totOrdTim: tOrdTim;
  curRouteCode,
  curRouteName: STRING[];

 PRIVATE PROCEDURE Shit06_NeedRoute(curDate: DATE): SCAL[2];
 BEGIN
  CONFORM(SEJobs, Route);
  RETURN L_kn.Is(curDate, erkn_Route_Shit06);
 END {Shit06_NeedRoute};

 PRIVATE PROCEDURE intPeriodStr(D: DATE): STRING[];
 BEGIN
  RETURN FLDTOSTR(D, L_DatTim.MonthStr(D, 0)+" y ", 0);
 END {intPeriodStr};

 PRIVATE PROCEDURE PeriodStr(): STRING[];
 BEGIN
  IF (L_DatTim.DAY(Memo.ud_fr()) # 1) | (L_DatTim.DAY(Memo.ud_ut()+1) # 1) THEN
   RETURN " ਮ  "+L_DatTim.DateStr(Memo.ud_fr())+"  "+L_DatTim.DateStr(Memo.ud_ut());
  ELSIF L_DatTim.Per(Memo.ud_fr()) = L_DatTim.Per(Memo.ud_ut()) THEN
   RETURN intPeriodStr(Memo.ud_fr());
  ELSE
   RETURN " ਮ "+intPeriodStr(Memo.ud_fr()) + "  " + intPeriodStr(Memo.ud_ut());
  END;
 END {PeriodStr};

 PRIVATE PROCEDURE GetContractRequisite(VAR CntDate, CntNum: STRING[]);
 BEGIN
  IF L_APtm.IsMTA() THEN
   CntDate:=' 03 䥢ࠫ 2014 ';
   CntNum :=' 0148200005413000027-2014.27215'
  ELSE
   CntDate:=' "_____" ___________________ 201__ ';
   CntNum :=' _______________________________________'
  END;
 END {GetContractRequisite};

 PRIVATE PROCEDURE Shit06_ExcelTop(objWS: OBJECT);
  VAR
   CurRange: OBJECT;
   CntDate,
   CntNum  : STRING[];
 BEGIN
  PROMPT("ଫ ...");
  objWS.Cells.EntireColumn.HorizontalAlignment:=L_Excel.xlLeft;
  objWS.Cells(, totC).EntireColumn.HorizontalAlignment:=L_Excel.xlRight;
  objWS.Columns(2).NumberFormat:="0000000";                                (**)
  objWS.Columns(5).NumberFormat:="0000";                                   (*ࠦ*)
  objWS.Columns(8).NumberFormat:="@";                                      (*, ६ 륧  *)
  objWS.Columns(9).NumberFormat:="@";                                      (*, ६ 饭  *)

  L_Excel.ws_Init(objWS);

  L_Excel.ws_SkipCols(objWS, totC-3); L_Excel.ws_WrStr(objWS, "ਫ  4  㤠⢥ ࠪ");
  L_Excel.ws_TermLine(objWS);
  GetContractRequisite(CntDate, CntNum);
  L_Excel.ws_SkipCols(objWS, totC-3); L_Excel.ws_WrStr(objWS, CntDate);
  L_Excel.ws_TermLine(objWS);
  L_Excel.ws_SkipCols(objWS, totC-3); L_Excel.ws_WrStr(objWS, CntNum);

  L_Excel.ws_TermLine(objWS);
  L_Excel.ws_TermLine(objWS);

  CurRange:=objWS.Range(objWS.Cells(6, 1), objWS.Cells(6, totC));
  CurRange.MergeCells:=L_Excel.xlTrue;
  CurRange.HorizontalAlignment:=L_Excel.xlCenter;
  CurRange.Value     :=" ⥢ ⮢    "+curRouteCode+"   믮 ॢ稪 ࠬ஢ ॢ  "+PeriodStr();
  CurRange.Font.Bold:=L_Excel.xlTrue;
  L_Excel.ws_TermLine(objWS);
  L_Excel.ws_TermLine(objWS);

  L_Excel.ws_StartHeader(objWS);
  L_Excel.ws_AddHeaderItem(objWS, " /", 5, 0);
  L_Excel.ws_AddHeaderItem(objWS, " ⥢ ", 10, 0);
  L_Excel.ws_AddHeaderItem(objWS, "⥫ ()", 22, 0);
  L_Excel.ws_AddHeaderItem(objWS, "/⨬  ⠢", 15, 0);
  L_Excel.ws_AddHeaderItem(objWS, "ࠦ   ⠢",  11, 0);
  L_Excel.ws_AddHeaderItem(objWS, " ", 7, 0);
  L_Excel.ws_AddHeaderItem(objWS, " ", 32, 0);
  L_Excel.ws_AddHeaderItem(objWS, ", ६ 륧  ",      18, 0);
  L_Excel.ws_AddHeaderItem(objWS, ", ६ 饭  ", 18, 0);
  L_Excel.ws_AddHeaderItem(objWS, "⢮ ᮢ  拉 ()",    12, 0);

  L_Excel.ws_StopHeader(objWS);
 END {Shit06_ExcelTop};

 PRIVATE PROCEDURE Shit06_ExcelBot(objWS: OBJECT);
 BEGIN
  L_Excel.ws_WrStr(objWS, "⮣:");
  L_Excel.ws_SkipCols(objWS, totC-2);
  L_Excel.ws_WrNum(objWS, totOrdTim);
  L_Excel.ws_TermLine(objWS);

  L_Excel.ws_PaintGrid(objWS, L_Excel.xlThin, 0);

  L_Excel.ws_TermLine(objWS);

  IF L_APtm.IsMTA() THEN
   L_Excel.ws_WrStr(objWS, ' ⥫ ࠫ쭮 ४   ""');
   L_Excel.ws_TermLine(objWS);
   L_Excel.ws_WrStr(objWS, "____________________________ . . 饢");
  ELSE
   L_Excel.ws_WrStr(objWS, P_Firm.FP_LeadPostName1(P_Firm.OWN_FIRM, SYSDATE()));
   L_Excel.ws_TermLine(objWS);
   L_Excel.ws_WrStr(objWS, "____________________________ "+P_Firm.FP_LeadName(P_Firm.OWN_FIRM, SYSDATE()));
  END;
  L_Excel.ws_TermLine(objWS);
  L_Excel.ws_TermLine(objWS);
  L_Excel.ws_TermLine(objWS);
  L_Excel.ws_WrStr(objWS, "..");
  L_Excel.ws_TermLine(objWS);
 END {Shit06_ExcelBot};

 PRIVATE PROCEDURE Shit06_ExcelLine(objWS: OBJECT; LineNbr: NUMERIC[0]);
 BEGIN
  SEARCH(RWayS, RWayS, , _rws.RWayS);

  L_Excel.ws_WrNum(objWS, LineNbr);
  L_Excel.ws_WrScl(objWS, RWayS.RWayS);

  IF L_Env.RealTSN(RWayS.TSN) THEN
   CONFORM(RWayS, Staff);
   CONFORM(Staff, Man);
   L_Excel.ws_WrStr(objWS, L_Str.ShortName(Man.Name));
  ELSE
   L_Excel.ws_SkipCols(objWS, 1);
  END;

  L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
  IF Mark.Electric THEN
   L_Excel.ws_WrStr(objWS, "஫");
  ELSE
   L_Excel.ws_WrStr(objWS, "⮡ "+ L_Way.GetMarkPasVolSign_50(RWayS.Date, Mark.Mark));
  END;
  L_Excel.ws_WrScl(objWS, RWayS.BoxNbr);
  L_Excel.ws_WrStr(objWS, curRouteCode);
  L_Excel.ws_WrStr(objWS, curRouteName);

  L_Excel.ws_WrStr(objWS, L_DatTim.DateTimeStr(_rws.StartD, _rws.StartT));
  L_Excel.ws_WrStr(objWS, L_DatTim.DateTimeStr(_rws.StopD,  _rws.StopT));

  L_Excel.ws_WrNum(objWS, _rws.OrdTim);
  INC(totOrdTim, _rws.OrdTim);
  L_Excel.ws_TermLine(objWS);
 END {Shit06_ExcelLine};

 PRIVATE PROCEDURE intShit06(objWB: OBJECT);
  VAR
   objWS    : OBJECT;
   SheetNbr,
   LineNbr  : NUMERIC[0];
 BEGIN
  SheetNbr:=0;
  SELECT(_rws, _rws);
  WHILE OCCURE(_rws) DO
   objWS:=L_Excel.NewWorksheet(objWB, SheetNbr, " "+_rws.Route);

   IF P_Route.HasActualRoutePro(_rws.Route, Memo.ud_ut(), P_Route.P_CodeInHeadFirm) THEN
    curRouteCode:=L_Prop.getRES(RoutePro.Value, 1);
    curRouteName:=L_Prop.getRES(RoutePro.Value, 2);
   ELSE
    SEARCH(Route, Route, , _rws.Route);
    curRouteCode:=Route.Route;
    curRouteName:=Route.Name;
   END;

   Shit06_ExcelTop(objWS);
   totOrdTim:=0;
   LineNbr:=1;
   NARROWSEL(_rws, Route);
   WHILE OCCURE(_rws) DO
    PROMPT(":  " + _rws.RWayS);
    Shit06_ExcelLine(objWS, LineNbr);
    INC(LineNbr);
    NEXT(_rws);
   END; (* WHILE OCCURE(File) *)
   Shit06_ExcelBot(objWS);
   INC(SheetNbr);
   NEXTINEXTENDEDSEL(_rws, Route);
  END; (* WHILE OCCURE(_rws) *)
 END {intShit06};

 PUBLIC PROCEDURE Shit06();
 VAR
  curRoute   : LIKE(Route.Route);
  curOrdTim  : tOrdTim;
  StartD,
  StopD      : DATE;
  StartT,
  StopT      : TIME;
  trgERKNName: STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

  L_Way.CheckTaxed(Memo.ud_fr(), Memo.ud_ut());

  TRY [TRANSACTION(TRANSACTION_SLAVE)]
   L_kn.UpdateERKN(erkn_Route_Shit06, "Route", " ॥  㤠⢥ ࠪ (Sht06)", 01\01\2014, 1, 1);
  EXCEPT
  END; (* TRY *)
  L_kn.StandOnERKN(erkn_Route_Shit06);
  trgERKNName:="'" + ERKN.Name + "'";
  TOOLTIP("  ⠬, 騬 祭 "+trgERKNName);

  L_AFM.MakeIndex("_rws", "Route  : LIKE(Route.Route);" +
                          "RWayS  : LIKE(RWayS.RWayS);" +
                          "StartD : DATE;" +
                          "StartT : TIME;" +
                          "StopD  : DATE;" +
                          "StopT  : TIME;" +
                          "OrdTim : "+TYPENAMEOF(tOrdTim));

  SELECT(RWayS, sDate, , L_Way.rwsStat_Rated);
  SRCINSEL(RWayS, GE, , Memo.ud_fr());
  WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.ud_ut()) DO
   PROMPT(": "+L_DatTim.DateStr(RWayS.Date)+ "  "+RWayS.RWayS);
   IF L_Env.RealBoxNbr(RWayS.BoxNbr) THEN
    CONFORM(RWayS, RWayJ);
    WHILE OCCURE(RWayJ) DO
     CONFORM(RWayJ, SEJobs);
     IF Shit06_NeedRoute(Memo.ud_ut()) THEN
      curRoute:=SEJobs.Route;
      StartD:=RWayS.Date + (RWayJ.Day - 1);
      StartT:=RWayJ.StartT;
      curOrdTim:=0;
      WHILE OCCURE(RWayJ) & (curRoute = SEJobs.Route) DO
       CONFORM(SEJobs, WJMode);
       CONFORM(RWayJ, Quality);
       IF Quality.Type # L_Way.QualType_Annul THEN
        INC(curOrdTim, D_TP.E_GetOrdTim(D_TP.TrOrdTim(), D_TP.otp_Whl));
       END;
       StopD:=RWayS.Date + (RWayJ.Day - 1) + (RWayJ.StopT < RWayJ.StartT);
       StopT:=RWayJ.StopT;
       NEXT(RWayJ);
       IF OCCURE(RWayJ) THEN
        CONFORM(RWayJ, SEJobs);
       END;
      END;
      IF curOrdTim > 0 THEN
       ADD(_rws, _rws, , curRoute, RWayS.RWayS, StartD, StartT, StopD, StopT, curOrdTim);
      END;
     ELSE
      NEXT(RWayJ);
     END;
    END; (* WHILE OCCURE(RWayJ) ... *)
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)

  IF SELECT(_rws, _rws) THEN
   L_Excel.MakeRep(PROCREF(intShit06), "Sht06_" +
                                       FLDTOSTR(Memo.ud_fr(), "yND_") +
                                       FLDTOSTR(Memo.ud_ut(), "yND_") +
                                       L_DatTim.SysDateTimeStamp());
  ELSE
   L_StdFrm.Inform(" ⭮ ਮ    ⠬,|騬 祭 "+trgERKNName);
  END;
 END {Shit06};

END.