(*
%Copyright   (c) Polak Computer System
%Author      28.09.2000 14:37:28 BOR
%Purpose      ઠ   ॢ
%Type        report
%Specific    AP
%Modified    09.09.2014 14:01:24 POLAK\Gina
%Environment
*)

 MODULE ShTkn [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT D_CarTb, P_Mark, L_General, L_Basis, L_Way, FIO, L_Car, P_Firm, P_Route, L_APtm,
        L_Str, L_Env, L_bp, L_StdFrm;

 PRIVATE VAR
  wMF       : SCAL[2];
  shtknFrom,
  shtknUpTo : DATE;

 PRIVATE PROCEDURE MakeTop();
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM("F", "");
   L_Basis.wb_WrInQM("F", "");
  END;
  L_Basis.wb_WrStr("F", " /");
  L_Basis.wb_WrStr("F", "ࠦ");
  L_Basis.wb_WrStr("F", "᭮");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", " ");
  L_Basis.wb_WrStr("F", "ઠ");
  L_Basis.wb_WrStr("F", "ઠ");
  L_Basis.wb_WrStr("F", "㯯 ப");
  L_Basis.wb_WrStr("F", "㯯 ப");
  L_Basis.wb_WrStr("F", " ॢ");
  L_Basis.wb_WrStr("F", " ॢ");
  L_Basis.wb_WrStr("F", "㯯 ⮢");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "室");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "⮩");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "஡");
  L_Basis.wb_WrStr("F", " ");
  L_Basis.wb_WrStr("F", " ");
  L_Basis.wb_WrStr("F", " ");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", " 宧");
  L_Basis.wb_WrStr("F", "X");
  L_Basis.wb_WrStr("F", "X");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "- /");
  L_Basis.wb_WrStr("F", "_");
  L_Basis.wb_WrStr("F", "_");
  L_Basis.wb_WrStr("F", "_⮩");
  L_Basis.wb_WrStr("F", "_");
  L_Basis.wb_TermLine("F");
 END {MakeTop};

 PRIVATE PROCEDURE MakeLine();
 BEGIN
  IF wMF THEN
   P_Firm.PositionOnMyFirm(CarTb2.MyFirm);
   L_Basis.wb_WrScl("F", MyFirm.MyFirm);
   L_Basis.wb_WrStr("F", MyFirm.vzSign);
  END;
  IF ~!CarTb2.BoxNbr THEN
   PROMPT("㧪 " + CarTb2.BoxNbr);
   L_General.Assert(SEARCH(CarLog, BoxNbr, CarTb2.BoxNbr, CarTb2.clDate),
                    "ଠ  䠩 '" + TABLE.Get("CarTb2").Description + "' ५" +
                    L_StdFrm.HR()+"  ந 䠩");
   L_Basis.wb_WrScl("F", "+");
   L_Basis.wb_WrScl("F", CarLog.BoxNbr);
   L_Basis.wb_WrStr("F", CarLog.StateNbr);
   L_Basis.wb_WrScl("F", CarLog.Column);
  ELSE
   PROMPT("㧪 ---");
   L_Basis.wb_WrScl("F", "-");
   L_Basis.wb_WrScl("F", "---");
   L_Basis.wb_WrStr("F", "---");
   L_Basis.wb_WrScl("F", "---");
  END;
  CONFORM(CarTb2, Mark);
  L_Basis.wb_WrStr("F", L_Str.PoolItem(L_Car.purp_Pool, CarTb2.Purpose));
  L_Basis.wb_WrScl("F", Mark.Mark);
  L_Basis.wb_WrStr("F", Mark.Name);
  L_Way.StandOnMarkG(Mark.Mark, L_Way.mgt_TEP);
  L_Basis.wb_WrScl("F", MarkG.MarkG);
  L_Basis.wb_WrStr("F", MarkG.Name);
  IF ~!CarTb2.TKind THEN
   CONFORM(CarTb2, TKind);
   L_Basis.wb_WrScl("F", TKind.TKind);
   L_Basis.wb_WrStr("F", TKind.Name);
  ELSE
   L_Basis.wb_WrStr("F", "---");
   L_Basis.wb_WrStr("F", "---");
  END;
  IF ~!CarTb2.Route THEN
   CONFORM(CarTb2, Route);
   L_Basis.wb_WrStr("F", P_Route.GetRouteProSoft(Route.Route, shtknUpTo, P_Route.P_Group));
   L_Basis.wb_WrStr("F", Route.Route);
   L_Basis.wb_WrStr("F", Route.Name);
  ELSE
   L_Basis.wb_WrStr("F", "---");
   L_Basis.wb_WrStr("F", "---");
   L_Basis.wb_WrStr("F", "---");
  END;
  L_Basis.wb_WrNum("F", CarTb2.RCarDays[D_CarTb.rcd_Nothing], 3);
  L_Basis.wb_WrNum("F", CarTb2.RCarDays[D_CarTb.rcd_Line],    3);
  L_Basis.wb_WrNum("F", CarTb2.RCarDays[D_CarTb.rcd_Repair],  3);
  L_Basis.wb_WrNum("F", CarTb2.RCarDays[D_CarTb.rcd_Outage],  3);
  L_Basis.wb_WrNum("F", CarTb2.RCarDays[D_CarTb.rcd_Reserv],  3);
  L_Basis.wb_WrNum("F", CarTb2.Run, 2);
  L_Basis.wb_WrNum("F", P_Mark.GetP_PasVol(Mark.Mark, shtknUpTo),    0);
  L_Basis.wb_WrNum("F", P_Mark.GetP_PVLim(Mark.Mark, shtknUpTo),     0);
  L_Basis.wb_WrNum("F", P_Mark.GetP_PVSitting(Mark.Mark, shtknUpTo), 0);
  L_Basis.wb_WrNum("F", D_CarTb.PasVol(CarTb2.RCarDays[D_CarTb.rcd_Line], shtknUpTo),    3);
  L_Basis.wb_WrNum("F", D_CarTb.PVLim(CarTb2.RCarDays[D_CarTb.rcd_Line], shtknUpTo),     3);
  L_Basis.wb_WrNum("F", D_CarTb.PVSitting(CarTb2.RCarDays[D_CarTb.rcd_Line], shtknUpTo), 3);
  L_Basis.wb_WrNum("F", CarTb2.DIO, 6);
  L_Basis.wb_WrNum("F", D_CarTb.PasVol(CarTb2.DIO, shtknUpTo),    3);
  L_Basis.wb_WrNum("F", D_CarTb.PVLim(CarTb2.DIO, shtknUpTo),     3);
  L_Basis.wb_WrNum("F", D_CarTb.PVSitting(CarTb2.DIO, shtknUpTo), 3);
  L_Basis.wb_WrNum("F", CarTb2.DIO / (shtknUpTo - shtknFrom + 1), 6);
  L_Basis.wb_WrNum("F", CarTb2.RCarTims[D_CarTb.rcd_Line], 3);
  L_Basis.wb_WrNum("F", CarTb2.RCarTims[D_CarTb.rcd_Repair], 3);
  L_Basis.wb_WrNum("F", CarTb2.RCarTims[D_CarTb.rcd_Outage], 3);
  L_Basis.wb_WrNum("F", CarTb2.RCarTims[D_CarTb.rcd_Reserv], 3);
  L_Basis.wb_TermLine("F");
 END {MakeLine};

 PUBLIC PROCEDURE ShTkn();
  CONST
   bpId = "ShTkn";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, " ઠ   ॢ", L_bp.t_Basis, L_General.tc_inIntvl);
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  L_General.SetIntvlByIntvl(shtknFrom, shtknUpTo);

  D_CarTb.Prepare_CarTb2(shtknFrom, shtknUpTo);
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  MakeTop();

  SELECT(CarTb2, BoxNbr);
  WHILE OCCURE(CarTb2) DO
   IF L_Env.RealBoxNbr(CarTb2.BoxNbr) THEN
    MakeLine();
   END;
   NEXT(CarTb2);
  END; (* WHILE OCCURE(CarTb2) ... *)

  D_CarTb.Purge_CarTb2();
  FIO.Close(F);
  L_bp.End();
 END {ShTkn};

END.