(*
%Copyright   (c) Polak IT
%Author      21.12.2004 20:50:14 POLAK\GAV
%Purpose
%Type        report
%Specific    AP
%Modified    31.05.2012 20:24:02 POLAK\Bor
%Environment
*)

 MODULE Stream [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, Memo, L_DatTim, L_AFM, L_Way, L_OwnData, Str, L_Str, L_StdFrm;

 CONST
  WeekDays = MAXOF(L_DatTim.tWeekday) + 1;

 VAR
  EveryOtherDayActiveStExitCnt: NUMERIC[0];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_cd(), L, "D.N.y"
@
#####################################################  ########## #####
=#####=================================================================
|         ⮪ 륧  ઠ,     ##########        |
|---------------------------------------------------------------------|
|     |    |    |    |    |    |    |    |    |
|६|-------|-------|-------|-------|-------|-------|-------|-------|
|     | | | | | | | | |
|-----|-------|-------|-------|-------|-------|-------|-------|-------|
}
*)

(*
$P{ Line:
Strm.Time, L, "H:M"
Strm.Out[L_DatTim.wd_Mon], R, "0"
Strm.In[L_DatTim.wd_Mon], R, "0"
Strm.Out[L_DatTim.wd_Tue], R, "0"
Strm.In[L_DatTim.wd_Tue], R, "0"
Strm.Out[L_DatTim.wd_Wed], R, "0"
Strm.In[L_DatTim.wd_Wed], R, "0"
Strm.Out[L_DatTim.wd_Thu], R, "0"
Strm.In[L_DatTim.wd_Thu], R, "0"
Strm.Out[L_DatTim.wd_Fri], R, "0"
Strm.In[L_DatTim.wd_Fri], R, "0"
Strm.Out[L_DatTim.wd_Sat], R, "0"
Strm.In[L_DatTim.wd_Sat], R, "0"
Strm.Out[L_DatTim.wd_Sun], R, "0"
Strm.In[L_DatTim.wd_Sun], R, "0"
Strm.Out[L_DatTim.wd_Hol], R, "0"
Strm.In[L_DatTim.wd_Hol], R, "0"
@
|#####|### ###|### ###|### ###|### ###|### ###|### ###|### ###|### ###|
}
*)

(*
$P{ Bot:
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
@
|-----|-------|-------|-------|-------|-------|-------|-------|-------|
|⮣|### ###|### ###|### ###|### ###|### ###|### ###|### ###|### ###|
=(c) Polak=============================================================
}
*)

(*
$P{ Top_Full:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_cd(), L, "D.N.y"
@
#####################################################################################################################  ########## #####
=#####=================================================================================================================================
|                                         ⮪ 륧  ઠ,     ##########                                        |
|-------------------------------------------------------------------------------------------------------------------------------------|
|     |  쭨  |    ୨    |     ।     |    ⢥    |    ⭨    |    㡡    |  ᥭ  |   ࠧ    |
|६|---------------|---------------|---------------|---------------|---------------|---------------|---------------|---------------|
|     | 륧 :| 륧 :| 륧 :| 륧 :| 륧 :| 륧 :| 륧 :| 륧 :|
}
*)

PROCEDURE OutStr(Arr: NUMERIC[0][]; Idx: NUMERIC[0]): STRING[];
BEGIN
 RETURN Str.Align(L_Str.IntStr(Arr[Idx]), 3, RIGHT) + " " +
        Str.Align(L_Str.IntStr(Arr[WeekDays + Idx]), 3, RIGHT);
END {OutStr};

(*
$P{ Line_Full:
Strm.Time, L, "H:M"
OutStr(Strm.Out, L_DatTim.wd_Mon), R, ""
OutStr(Strm.In, L_DatTim.wd_Mon), R, ""
OutStr(Strm.Out, L_DatTim.wd_Tue), R, ""
OutStr(Strm.In, L_DatTim.wd_Tue), R, ""
OutStr(Strm.Out, L_DatTim.wd_Wed), R, ""
OutStr(Strm.In, L_DatTim.wd_Wed), R, ""
OutStr(Strm.Out, L_DatTim.wd_Thu), R, ""
OutStr(Strm.In, L_DatTim.wd_Thu), R, ""
OutStr(Strm.Out, L_DatTim.wd_Fri), R, ""
OutStr(Strm.In, L_DatTim.wd_Fri), R, ""
OutStr(Strm.Out, L_DatTim.wd_Sat), R, ""
OutStr(Strm.In, L_DatTim.wd_Sat), R, ""
OutStr(Strm.Out, L_DatTim.wd_Sun), R, ""
OutStr(Strm.In, L_DatTim.wd_Sun), R, ""
OutStr(Strm.Out, L_DatTim.wd_Hol), R, ""
OutStr(Strm.In, L_DatTim.wd_Hol), R, ""
@
|-----|-------:-------|-------:-------|-------:-------|-------:-------|-------:-------|-------:-------|-------:-------|-------:-------|
|#####|#######:#######|#######:#######|#######:#######|#######:#######|#######:#######|#######:#######|#######:#######|#######:#######|
}
*)

(*
$P{ Bot_Full:
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
@
|-----|-------:-------|-------:-------|-------:-------|-------:-------|-------:-------|-------:-------|-------:-------|-------:-------|
|⮣|#######:#######|#######:#######|#######:#######|#######:#######|#######:#######|#######:#######|#######:#######|#######:#######|
=(c) Polak=============================================================================================================================
}
*)

 PRIVATE PROCEDURE Create_Strm();
 BEGIN
  CreateFILE(Strm);
  CreateFIELD(Strm, Day,  SCAL[100]);
  CreateFIELD(Strm, Time, TIME);
  CreateFIELD(Strm, Out,  NUMERIC[0][WeekDays*2], , "0");
  CreateFIELD(Strm, In,   NUMERIC[0][WeekDays*2], , "0");
  CreateINDEX(Strm, Strm, UNIQUE, , , Day, Time);
  SetVersionOfFILE(Strm, 0);
  L_AFM.AF_CreateTemp("Strm", "Strm");
 END {Create_Strm};

 PRIVATE PROCEDURE Prepare(Step: FLOAT);
  VAR
   wd,
   shift: NUMERIC[0];
 BEGIN
  SELECT(StExit, Exit);
  WHILE OCCURE(StExit) DO
   IF (StExit.Strict = L_Way.ExitStrict_Reg) &
      L_DatTim.IsActive(Memo.ud_cd(), StExit.FromD, StExit.UpDate) THEN
    PROMPT(StExit.Exit);
    IF (StExit.ActivKnd = L_Way.seak_OnDays) THEN
     wd:=L_DatTim.wd_Mon;
     WHILE wd <= L_DatTim.wd_Hol DO
      IF StExit.OnDays[wd] THEN
       IF (StExit.Change = 0) | (StExit.Change = 1) THEN
        ADD(Strm, Strm, , 1, 00:00 + (StExit.BegTime - 00:00) DIV Step * Step,
               Strm.Out[WeekDays + wd], 1,
               Strm.Out[wd],            1);
       END;
       IF (StExit.Change = 0) | (StExit.Change = 2) THEN
        ADD(Strm, Strm, , 1 + (StExit.StopTim < 06:00), 00:00 + (StExit.StopTim - 00:00) DIV Step * Step,
               Strm.In[WeekDays + wd], 1,
               Strm.In[wd],            1);
       END;
      END;
      INC(wd);
     END;
    ELSIF (StExit.ActivKnd = L_Way.seak_EveryOtherDay) THEN
     INC(EveryOtherDayActiveStExitCnt);
     IF (Memo.ud_cd() - StExit.FromD) MOD 2 THEN
      shift:=WeekDays;
     ELSE
      shift:=0;
     END;
     IF (StExit.Change = 0) | (StExit.Change = 1) THEN
      ADD(Strm, Strm, , 1, 00:00 + (StExit.BegTime - 00:00) DIV Step * Step,
              Strm.Out[shift + L_DatTim.wd_Mon], 1,
              Strm.Out[shift + L_DatTim.wd_Tue], 1,
              Strm.Out[shift + L_DatTim.wd_Wed], 1,
              Strm.Out[shift + L_DatTim.wd_Thu], 1,
              Strm.Out[shift + L_DatTim.wd_Fri], 1,
              Strm.Out[shift + L_DatTim.wd_Sat], 1,
              Strm.Out[shift + L_DatTim.wd_Sun], 1,
              Strm.Out[shift + L_DatTim.wd_Hol], 1);
 
     END;
     IF (StExit.Change = 0) | (StExit.Change = 2) THEN
      ADD(Strm, Strm, , 1 + (StExit.StopTim < 06:00), 00:00 + (StExit.StopTim - 00:00) DIV Step * Step,
              Strm.In[shift + L_DatTim.wd_Mon], 1,
              Strm.In[shift + L_DatTim.wd_Tue], 1,
              Strm.In[shift + L_DatTim.wd_Wed], 1,
              Strm.In[shift + L_DatTim.wd_Thu], 1,
              Strm.In[shift + L_DatTim.wd_Fri], 1,
              Strm.In[shift + L_DatTim.wd_Sat], 1,
              Strm.In[shift + L_DatTim.wd_Sun], 1,
              Strm.In[shift + L_DatTim.wd_Hol], 1);
     END;
    ELSE
     L_General.ConsultToUs(0, " ঠ StExit.ActivKnd = " + StExit.ActivKnd);
    END;
   END;
   NEXT(StExit);
  END; (* WHILE OCCURE(StExit) ... *)
 END {Prepare};

 PRIVATE PROCEDURE _Inc(VAR Tot: NUMERIC[0][];
                    Arr: NUMERIC[0][]);
  VAR
   wd: NUMERIC[0];
 BEGIN
  wd:=L_DatTim.wd_Mon;
  WHILE wd < RANGEOF(Tot) DO
   INC(Tot[wd], Arr[wd]);
   INC(wd);
  END;
 END {_Inc};

 PRIVATE PROCEDURE Print(RepName: STRING[]);
  VAR
   TotIn,
   TotOut: NUMERIC[0][WeekDays*2];
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create);
  SETZERO(TotIn, TotOut);
  IF EveryOtherDayActiveStExitCnt THEN
   MAKEPART(R, Top_Full, RepName);
  ELSE
   MAKEPART(R, Top, RepName);
  END;
  SELECT(Strm, Strm);
  WHILE OCCURE(Strm) DO
   IF EveryOtherDayActiveStExitCnt THEN
    MAKEPART(R, Line_Full);
   ELSE
    MAKEPART(R, Line);
   END;
   _Inc(TotIn,  Strm.In);
   _Inc(TotOut, Strm.Out);
   NEXT(Strm);
  END; (* WHILE OCCURE(Strm) ... *)

  IF EveryOtherDayActiveStExitCnt THEN
   MAKEPART(R, Bot_Full, OutStr(TotOut, L_DatTim.wd_Mon), OutStr(TotIn, L_DatTim.wd_Mon),
                         OutStr(TotOut, L_DatTim.wd_Tue), OutStr(TotIn, L_DatTim.wd_Tue),
                         OutStr(TotOut, L_DatTim.wd_Wed), OutStr(TotIn, L_DatTim.wd_Wed),
                         OutStr(TotOut, L_DatTim.wd_Thu), OutStr(TotIn, L_DatTim.wd_Thu),
                         OutStr(TotOut, L_DatTim.wd_Fri), OutStr(TotIn, L_DatTim.wd_Fri),
                         OutStr(TotOut, L_DatTim.wd_Sat), OutStr(TotIn, L_DatTim.wd_Sat),
                         OutStr(TotOut, L_DatTim.wd_Sun), OutStr(TotIn, L_DatTim.wd_Sun),
                         OutStr(TotOut, L_DatTim.wd_Hol), OutStr(TotIn, L_DatTim.wd_Hol));
  ELSE
   MAKEPART(R, Bot, TotOut[L_DatTim.wd_Mon], TotIn[L_DatTim.wd_Mon],
                    TotOut[L_DatTim.wd_Tue], TotIn[L_DatTim.wd_Tue],
                    TotOut[L_DatTim.wd_Wed], TotIn[L_DatTim.wd_Wed],
                    TotOut[L_DatTim.wd_Thu], TotIn[L_DatTim.wd_Thu],
                    TotOut[L_DatTim.wd_Fri], TotIn[L_DatTim.wd_Fri],
                    TotOut[L_DatTim.wd_Sat], TotIn[L_DatTim.wd_Sat],
                    TotOut[L_DatTim.wd_Sun], TotIn[L_DatTim.wd_Sun],
                    TotOut[L_DatTim.wd_Hol], TotIn[L_DatTim.wd_Hol]);
  END;
  CLOSEREP(R);
 END {Print};

 PUBLIC PROCEDURE EStrm();
  CONST
   RepName = "EStrm";
  VAR
   Step: FLOAT;
 BEGIN
  Step:=30;
  LOOP
   STDFORM(L_StdFrm.sf_Choice("|ࢠ ⠫樨 (.) %####%", "%R<0>I"),
           , CHOICE, 1, Step);
   IF Step <= 0 THEN
    L_StdFrm.ShowINFORM_AsSTOP("ࢠ ⠫樨    ");
   ELSE
    EXIT;
   END;
  END; (* LOOP *)
  Step:=Step / 60;
  Create_Strm();
  EveryOtherDayActiveStExitCnt:=0;
  Prepare(Step);
  Print(RepName);
  L_AFM.AF_PurgeTemp("Strm");
  L_General.SurveyLastReport();
 END {EStrm};

END.