(*
%Copyright   (c) Polak Computer System
%Author      10.04.2000 15:23:27 RSN
%Purpose        ਮ
%Type        report
%Specific    AP
%Modified    12.04.2012 17:01:57 POLAK\GAV
%Environment
*)

 IMPORT L_Way, L_AFM, L_General, L_Basis, D_TP, FIO, L_Str,
        DBD, Memo, Math, P_Route, D_RWS, P_Firm, L_Car, L_APWI, L_bp;

 VAR
  wMF : SCAL[2];

 PRIVATE PROCEDURE T0002_MakeTop(Full, wASCP: SCAL[2]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
  END;
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "஢");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "室");
  L_Basis.wb_WrStr("F", " ");
  L_Basis.wb_WrStr("F", " ");
  L_Basis.wb_WrStr("F", "썥");
  L_Basis.wb_WrStr("F", "");
  IF ~Full THEN
   L_Basis.wb_WrStr("F", "室");
  END;
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", " ஬");
  L_Basis.wb_WrStr("F", "⨬");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "ࠡ");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "ࠡ");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "ࠡ");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  IF Full THEN
   L_Basis.wb_WrStr("F", "");
  END;
  L_Basis.wb_WrStr("F", "ৢ");
  L_Basis.wb_WrStr("F", "_");
  L_Basis.wb_WrStr("F", " ");
  L_Basis.wb_WrStr("F", " 室");
  L_Basis.wb_WrStr("F", "設  ࠡ");
  IF wASCP THEN
   L_Basis.wb_WrStr("F", "");
  END;
  L_Basis.wb_WrStr("F", "ᨬ쭠 ᪮ 室");
  IF D_TP.wTimeIntvl THEN
   L_Basis.wb_WrStr("F", "६ࢠ");
  END;
  L_Basis.wb_WrStr("F", "㯯 ⮢");
  IF D_TP.wVldPsgPlan THEN
   L_Basis.wb_WrInQM("F", "ଏᏫ");
  END;
  L_Basis.wb_TermLine("F");
 END {T0002_MakeTop};

 PRIVATE PROCEDURE _PoolItem(Pool: STRING[]; Item: NUMERIC[0]): STRING[];
 BEGIN
  IF !Item THEN
   RETURN "";
  ELSE
   RETURN L_Str.PoolItem(Pool, Item);
  END;
 END {_PoolItem};

 PRIVATE PROCEDURE T0002_MakeLine(Full, wASCP: SCAL[2]; ExitMaxSpeed: NUMERIC[1]);
  VAR
   _MyFirm: P_Firm.tMyFirm;
 BEGIN
  CONFORM(SEJ01, StExit, ExitClss);
  CONFORM(SEJ01, Route);
  L_Way.StandOnRouteTKind(Memo.ud_ut());
  IF wMF THEN
   _MyFirm:=L_Way.GetMyFirmOfExit(SEJ01.Exit, Memo.ud_ut());
   L_General.Assert(SEARCH(MyFirm, MyFirm, _MyFirm), "  '' ࣠ "+_MyFirm);
   L_Basis.wb_WrScl("F", MyFirm.MyFirm);
   L_Basis.wb_WrStr("F", MyFirm.vzSign);
  END;
  L_Basis.wb_WrStr("F", _PoolItem(L_Way.tkrgn_Pool, TKind.Rgn));
  L_Basis.wb_WrStr("F", _PoolItem(L_Way.tkfnm_Pool, TKind.FnMode));
  L_Basis.wb_WrScl("F", TKind.TKind);
  L_Basis.wb_WrStr("F", TKind.Name);
  L_Basis.wb_WrStr("F", Route.Route);
  L_Basis.wb_WrStr("F", Route.Name);
  L_Basis.wb_WrScl("F", SEJ01.Exit);
  L_Basis.wb_WrScl("F", ExitClss.ExitClss);
  L_Basis.wb_WrStr("F", ExitClss.Name);
  L_Basis.wb_WrStr("F", L_Way.E_ConvertWDStr(Memo.ud_ut(), SEJ01.WDWay));
  L_Basis.wb_WrDat("F", SEJ01.ExitDate);
  IF ~Full THEN
   L_Basis.wb_WrStr("F", _PoolItem(L_Way.ExitStrict_Pool, StExit.Strict));
  END;
  L_Basis.wb_WrScl("F", SEJ01.Column);
  L_Basis.wb_WrStr("F", L_Way.E_ConvertWDStr(Memo.ud_ut(), SEJ01.WDWay));
  L_Basis.wb_WrStr("F", _PoolItem("-|+", SEJ01.withGu));
  L_Basis.wb_WrStr("F", L_Way.PasVolEnum2Sign(SEJ01.PasVol));
  L_Basis.wb_WrNum("F", SEJ01.TotTim,  3);
  L_Basis.wb_WrNum("F", SEJ01.WrkTim,  3);
  L_Basis.wb_WrNum("F", SEJ01.ZerTim,  3);
  L_Basis.wb_WrNum("F", SEJ01.TotRun,  2);
  L_Basis.wb_WrNum("F", SEJ01.WrkRun,  2);
  L_Basis.wb_WrNum("F", SEJ01.ZerRun,  2);
  L_Basis.wb_WrNum("F", SEJ01.TotTrp,  0);
  L_Basis.wb_WrNum("F", SEJ01.WrkTrp,  0);
  L_Basis.wb_WrNum("F", SEJ01.ZerTrp,  0);
  L_Basis.wb_WrNum("F", SEJ01.IncTim,  3);
  IF Full THEN
   L_Basis.wb_WrNum("F", SEJ01.IncPlan, 2);
  END;
  L_Basis.wb_WrNum("F", SEJ01.LinTim,  3);
  L_Basis.wb_WrNum("F", SEJ01.PVKm,    2);
  L_Basis.wb_WrScl("F", StExit.ExitClss);
  L_Basis.wb_WrStr("F", _PoolItem("-|+", StExit.Suppl));
  L_Basis.wb_WrNum("F", SEJ01.CarDay, 2);
  IF wASCP THEN
   L_Basis.wb_WrScl("F", L_Str.PoolItem("-|+", SEJ01.ASCP));
  END;
  L_Basis.wb_WrNum("F", ExitMaxSpeed, 1);
  IF D_TP.wTimeIntvl THEN
   L_Basis.wb_WrStr("F", SEJ01.TimeItvl);
  END;
  L_Basis.wb_WrStr("F", P_Route.GetRouteProSoft(Route.Route, Memo.ud_ut(), P_Route.P_Group));
  IF D_TP.wVldPsgPlan THEN
   L_Basis.wb_WrNum("F", SEJ01.VldPsgPlan, 2);
  END;
  L_Basis.wb_TermLine("F");
 END {T0002_MakeLine};

 PRIVATE PROCEDURE GetExitMaxSpeed(): NUMERIC[1];
  VAR
   ExitMaxSpeed: NUMERIC[1];
 BEGIN
  ExitMaxSpeed:=0;
  SELECT(SEJobs, Exit, , SEJ01.Exit);
  WHILE OCCURE(SEJobs) DO
   CONFORM(SEJobs, Route);
   CONFORM(Route, RoutMod);
   ExitMaxSpeed:=Math.Max(ExitMaxSpeed, RoutMod.Run / (SEJobs.StopT - SEJobs.StartT));
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)
  RETURN ExitMaxSpeed;
 END {GetExitMaxSpeed};

 PRIVATE PROCEDURE TypeT0002(Full, wASCP: SCAL[2]);
  VAR
   _PasVNm : STRING[];
   ExitMaxSpeed: NUMERIC[1];
 BEGIN
  T0002_MakeTop(Full, wASCP);
  SELECT(SEJ01, Exit);
  WHILE OCCURE(SEJ01) DO
   PROMPT(" " + SEJ01.Exit);
   CHANGESEL(SEJ01, Exit, , SEJ01.Exit);
   ExitMaxSpeed:=GetExitMaxSpeed();
   WHILE OCCURE(SEJ01) DO
    T0002_MakeLine(Full, wASCP, ExitMaxSpeed);
    NEXT(SEJ01);
   END; (* WHILE OCCURE(SEJ01) ... *)
   LAST(SEJ01);
   CHANGESEL(SEJ01, Exit);
   NEXT(SEJ01);
  END; (* WHILE OCCURE(SEJ01) ... *)
 END {TypeT0002};

 PRIVATE PROCEDURE T2102_MakeHeader();
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM("F", "");
   L_Basis.wb_WrInQM("F", "");
  END;
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "஢");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "㯯 ⮢");
  L_Basis.wb_WrInQM("F", "室");
  L_Basis.wb_WrInQM("F", " ");
  L_Basis.wb_WrInQM("F", " ");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "␥");
  L_Basis.wb_WrInQM("F", "ࠪ");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "⌗");
  L_Basis.wb_WrInQM("F", "஡");
  L_Basis.wb_WrInQM("F", "஡");
  L_Basis.wb_WrInQM("F", "室될");
  L_Basis.wb_WrInQM("F", "室");
  L_Basis.wb_WrInQM("F", "℮室");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "₍");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "⏎");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "₍");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "␍");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "⌊");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "⏠Ꭱ");
  IF D_TP.wVldPsgPlan THEN
   L_Basis.wb_WrInQM("F", "ଏ");
   L_Basis.wb_WrInQM("F", "죏1");
   L_Basis.wb_WrInQM("F", "죏2");
   L_Basis.wb_WrInQM("F", "죏");
   L_Basis.wb_WrInQM("F", "⏠");
  END;
  L_Basis.wb_TermLine("F");
 END {T2102_MakeHeader};

 PRIVATE PROCEDURE T2102_MakeLine();
 BEGIN
  CONFORM(T2102, Route);
  L_General.Assert(OCCURE(Route), "   " + T2102.Route + " - ᫥  ⮢ ࠭ 䠩");
  L_Way.StandOnRouteTKind(Memo.ud_ut());
  CONFORM(T2102, StExit);
  L_General.Assert(OCCURE(StExit), "  室 " + T2102.Exit + " - ᫥  ⮢ ࠭ 䠩");
  IF wMF THEN
   L_General.Assert(SEARCH(MyFirm, MyFirm, T2102.MyFirm), "  '' ࣠ "+T2102.MyFirm);
   L_Basis.wb_WrScl("F", MyFirm.MyFirm);
   L_Basis.wb_WrStr("F", MyFirm.vzSign);
  END;
  L_Basis.wb_WrStr("F", _PoolItem(L_Way.tkrgn_Pool, TKind.Rgn));
  L_Basis.wb_WrStr("F", _PoolItem(L_Way.tkfnm_Pool, TKind.FnMode));
  L_Basis.wb_WrScl("F", TKind.TKind);
  L_Basis.wb_WrStr("F", TKind.Name);
  L_Basis.wb_WrStr("F", Route.Route);
  L_Basis.wb_WrStr("F", P_Route.GetRouteProSoft(Route.Route, Memo.ud_ut(), P_Route.P_Group));
  L_Basis.wb_WrStr("F", StExit.Exit);
  L_Basis.wb_WrStr("F", StExit.ExitClss);
  L_Basis.wb_WrStr("F", L_Way.E_ConvertWDStr(Memo.ud_ut(), T2102.WDWay));
  L_Basis.wb_WrNum("F", T2102.WrkTrp[D_TP.idx_Plan], 1);
  L_Basis.wb_WrNum("F", T2102.WrkTrp[D_TP.idx_Fact], 1);
  L_Basis.wb_WrNum("F", T2102.BadTrp          , 1);
  L_Basis.wb_WrNum("F", T2102.WrkTim[D_TP.idx_Plan], 3);
  L_Basis.wb_WrNum("F", T2102.WrkTim[D_TP.idx_Fact], 3);
  L_Basis.wb_WrNum("F", T2102.WrkRun[D_TP.idx_Plan], 2);
  L_Basis.wb_WrNum("F", T2102.WrkRun[D_TP.idx_Fact], 2);
  L_Basis.wb_WrNum("F", T2102.SEJInc, 2);
  L_Basis.wb_WrNum("F", T2102.Inc[D_TP.idx_Plan], 2);
  L_Basis.wb_WrNum("F", T2102.Inc[D_TP.idx_Fact], 2);
  L_Basis.wb_WrNum("F", T2102.OrdTim[D_TP.idx_Plan], 3);
  L_Basis.wb_WrNum("F", T2102.OrdTim[D_TP.idx_Fact], 3);
  L_Basis.wb_WrNum("F", T2102.TotRun[D_TP.idx_Plan], 2);
  L_Basis.wb_WrNum("F", T2102.TotRun[D_TP.idx_Fact], 2);
  L_Basis.wb_WrNum("F", T2102.ZerTim[D_TP.idx_Plan], 3);
  L_Basis.wb_WrNum("F", T2102.ZerTim[D_TP.idx_Fact], 3);
  L_Basis.wb_WrNum("F", T2102.ZerTrp[D_TP.idx_Plan], 1);
  L_Basis.wb_WrNum("F", T2102.ZerTrp[D_TP.idx_Fact], 1);
  L_Basis.wb_WrNum("F", T2102.PVKm[D_TP.idx_Plan], 1);
  L_Basis.wb_WrNum("F", T2102.PVKm[D_TP.idx_Fact], 1);
  L_Basis.wb_WrNum("F", T2102.ChngCnt[D_TP.idx_Plan],   3);
  L_Basis.wb_WrNum("F", T2102.PassRound[D_TP.idx_Fact], 3);
  IF D_TP.wVldPsgPlan THEN
   L_Basis.wb_WrNum("F", T2102.PlanVldPsg, 2);
   L_Basis.wb_WrNum("F", T2102.FactVldPsg[L_Way.vpk_MoscowRegion], 0);
   L_Basis.wb_WrNum("F", T2102.FactVldPsg[L_Way.vpk_Moscow      ], 0);
   L_Basis.wb_WrNum("F", T2102.FactVldPsg[L_Way.vpk_OtherSocial ], 0);
   L_Basis.wb_WrNum("F", T2102.FactVldPsg[L_Way.vpk_Paid        ], 0);
  END;
  L_Basis.wb_TermLine("F");
 END {T2102_MakeLine};

 PUBLIC PROCEDURE MakeT2102();
  CONST
   bpId = "T2102";
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  L_bp.Begin(bpId, "/䠪᪨ ", L_bp.t_Basis, L_General.timeCond_InIntvl);
  D_TP.Prepare_T2102();
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  T2102_MakeHeader();
  SELECT(T2102, Route);
  WHILE OCCURE(T2102) DO
   PROMPT("㧪   " + T2102.Route);
   T2102_MakeLine();
   NEXT(T2102);
  END; (* WHILE OCCURE(T2102) ... *)
  D_TP.Purge_T2102();
  FIO.Close(F);
  L_bp.End();
 END {MakeT2102};

 PUBLIC PROCEDURE MakeT0012();
  CONST
   bpId = "T0012";
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  L_bp.Begin(bpId, "  ( 窨)", L_bp.t_Basis, L_General.timeCond_InIntvl);
  D_TP._PrepareSEJ01(Memo.ud_fr(), Memo.ud_ut(), 0, 0);
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  TypeT0002(0, 0);
  D_TP.PurgeSEJ01();
  FIO.Close(F);
  L_bp.End();
 END {MakeT0012};

 PUBLIC PROCEDURE MakeT0002();
  CONST
   bpId = "T0002";
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  L_bp.Begin(bpId, " ", L_bp.t_Basis, L_General.timeCond_InIntvl);
  D_TP.PrepareSEJ01();
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  TypeT0002(1, DBD.FieldExist(SEJ01, ASCP));
  D_TP.PurgeSEJ01();
  FIO.Close(F);
  L_bp.End();
 END {MakeT0002};

 PUBLIC PROCEDURE MakeT0002_2();
  CONST
   bpId = "T0002";  (* 0080755 *)
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  L_bp.Begin(bpId, "   ਮ  ࢠ ६", L_bp.t_Basis, L_General.timeCond_InIntvl);
  D_TP.wTimeIntvl:=1;
  D_TP._PrepareSEJ01(Memo.ud_fr(), Memo.ud_ut(), 0, 0);
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  TypeT0002(0, 0);
  D_TP.PurgeSEJ01();
  FIO.Close(F);
  L_bp.End();
 END {MakeT0002_2};

END.
