(*
%Copyright   (c) Polak IT
%Author      15.07.2004 18:12:19 POLAK\GAV
%Purpose       ࠡ  ⠢
%Type        report
%Specific    AP_PT
%Modified    16.06.2014 14:35:03 POLAK\GAV
%Environment
*)

 MODULE T0004 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT D_TP, L_General, L_Basis, FIO, L_Str, L_Way, DBD, L_OwnData, L_AFM, Str, Memo, L_bp;

 PRIVATE PROCEDURE T0004_MakeHeader(F: STRING[]; _wASCP: SCAL[2]);
 BEGIN
  L_Basis.wb_WrStr(F, " ");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "ઠ");
  L_Basis.wb_WrStr(F, "ઠ");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "室");
  L_Basis.wb_WrStr(F, " ᥣ");
  L_Basis.wb_WrStr(F, "㫥");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "ࠪ");
  L_Basis.wb_WrStr(F, "஡");
  L_Basis.wb_WrStr(F, " ");
  L_Basis.wb_WrStr(F, "㫥");
  L_Basis.wb_WrStr(F, " 拉");
  L_Basis.wb_WrStr(F, "設");
  L_Basis.wb_WrStr(F, "㫥 ६");
  L_Basis.wb_WrStr(F, " ");
  L_Basis.wb_WrStr(F, "_");
  L_Basis.wb_WrStr(F, "_ 㫏");
  L_Basis.wb_WrStr(F, " ஬");
  L_Basis.wb_WrStr(F, " ⠦஬");
  L_Basis.wb_WrStr(F, "㦮");
  L_Basis.wb_WrStr(F, "㯯_ப");
  L_Basis.wb_WrStr(F, "㯯_ப");
  L_Basis.wb_WrStr(F, "_");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "䨪");
  L_Basis.wb_WrStr(F, "䨪");
  L_Basis.wb_WrStr(F, "_㯯ப");
  L_Basis.wb_WrStr(F, "_㯯ப");
  IF _wASCP THEN
   L_Basis.wb_WrInQM(F, "");
  END;
  IF D_TP.wTimeIntvl THEN
   L_Basis.wb_WrStr(F, "६ࢠ");
  END;
  L_Basis.wb_TermLine(F);
 END {T0004_MakeHeader};

 PRIVATE PROCEDURE T0004_MakePart(F: STRING[]; _wASCP: SCAL[2]);
 BEGIN
  L_General.Assert(SEARCH(RoutMod, Route, TP.Route, TP._Modif),
                   " ࠢ筨   䨪 " + TP._Modif +
                   "  " + TP.Route);
  CONFORM(TP, TKind, Mark, MarkG, Sort);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", TKind.InTEP));
  L_Basis.wb_WrScl(F, TKind.TKind);
  L_Basis.wb_WrStr(F, TKind.Name);
  L_Basis.wb_WrStr(F, TP.Route);
  L_Basis.wb_WrScl(F, TP.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("㤭||㡡||ࠧ", TP.DN));
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", TP.TOL));
  L_Basis.wb_WrScl(F, TP.Column);
  L_Basis.wb_WrScl(F, TP.Exit);
  L_Basis.wb_WrNum(F, TP.AllTrips, 1);
  L_Basis.wb_WrNum(F, TP.ZeroTrips, 1);
  L_Basis.wb_WrNum(F, TP.GoodTrips, 1);
  L_Basis.wb_WrNum(F, TP.BadTrips, 1);
  L_Basis.wb_WrNum(F, TP.FullRun, 2);
  L_Basis.wb_WrNum(F, TP.RunPass, 2);
  L_Basis.wb_WrNum(F, TP.ZeroRun, 2);
  L_Basis.wb_WrNum(F, TP.OrdTim, 3);
  L_Basis.wb_WrNum(F, TP.WrkTim, 3);
  L_Basis.wb_WrNum(F, TP.ZeroTim, 3);
  L_Basis.wb_WrNum(F, TP.PikTim, 3);
  L_Basis.wb_WrNum(F, TP.PVKm, 2);
  L_Basis.wb_WrNum(F, TP.ZeroPVKm, 2);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", TP.Wlm0));
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", TP.Wlm1));
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", TP.Alien));
  L_Basis.wb_WrScl(F, TP.MarkG);
  L_Basis.wb_WrStr(F, MarkG.Name);
  L_Basis.wb_WrNum(F, TP.CarAmnt, 0);
  L_Basis.wb_WrScl(F, TP.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrScl(F, TP._Modif);
  L_Basis.wb_WrStr(F, RoutMod.Name);

  IF L_Way.StandOnMarkG_Soft(TP.Mark, L_Way.mgt_CostAccounting) THEN
   L_Basis.wb_WrScl(F, MarkG.MarkG);
   L_Basis.wb_WrStr(F, MarkG.Name);
  ELSE
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "---");
  END;
  IF _wASCP THEN
   L_Basis.wb_WrScl(F, L_Str.PoolItem("-|+", TP.ASCP));
  END;
  IF D_TP.wTimeIntvl THEN
   L_Basis.wb_WrStr(F, TP.TimeItvl);
  END;
  L_Basis.wb_TermLine(F);
 END {T0004_MakePart};

 PUBLIC PROCEDURE T0004();
  CONST
   bpId = "T0004";
  VAR
   _wASCP: SCAL[2];
 BEGIN
  L_bp.Begin(bpId, "  ࠡ  ⠢", L_bp.t_Basis, L_General.tc_inIntvl);
  D_TP.PrepareTP();
  FIO.Open(F, L_General.NameConnection(bpId), "rep", Create);
  _wASCP:=DBD.FieldExist(TP, ASCP);
  T0004_MakeHeader("F", _wASCP);
  SELECT(TP, Route);
  WHILE OCCURE(TP) DO
   PROMPT(TP.Route + " " + TP._Modif + " " + TP.Mark);
   T0004_MakePart("F", _wASCP);
   NEXT(TP);
  END; (* WHILE OCCURE(TP) ... *)
  FIO.Close(F);
  L_bp.End();
 END {T0004};

(*
$P{ TP004_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
#############################################################################                                 ########## #####
=#####========================================================================================================================
|                           ࠡ  ⠢  ਮ  ##########  ##########                          |
|----------------------------------------------------------------------------------------------------------------------------|
|                        |          |             ஡             |            設/            |              |
|                 |---------------|--------------------------------|-----------------------------------|⮪|
|                        |   ᥣ|  ࠪ|     ᥣ|    .|   㫥|      ᥣ|      㤭|     |              |
|------------------------|--------|------|----------|----------|----------|-----------|-----------|-----------|--------------|
}
*)

(*
$P{ TP004_SubTop:
?, L, ""
@
|########################|--------|------|----------|----------|----------|-----------|-----------|-----------|--------------|
}
*)

(*
$P{ TP004_Line:
?, L, ""
?, R, "1."
?, R, "1."
?, R, "2."
?, R, "2."
?, R, "2."
?, R, "3."
?, R, "3."
?, R, "3."
?, R, "2."
@
|########################|########|######|##########|##########|##########|###########|###########|###########|##############|
}
*)

(*
$P{ TP004_SubBot:
@
|~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~|
}
*)

(*
$P{ TP004_Bot:
@
=(c) Polak====================================================================================================================
}
*)

 PRIVATE PROCEDURE TP004_CreateTemp(ByMarkG: SCAL[2]);
 BEGIN
  CreateFILE(tmp);
  CreateFIELD(tmp, TKind,    LIKE(Route.TKind));
  CreateFIELD(tmp, Route,    LIKE(Route.Route));
  IF ByMarkG THEN
   CreateFIELD(tmp, MarkG,   LIKE(MarkG.MarkG));
  ELSE
   CreateFIELD(tmp, Mark,    LIKE(Mark.Mark));
  END;
  CreateFIELD(tmp, TotTrips, NUMERIC[1], , "0");
  CreateFIELD(tmp, BadTrips, NUMERIC[1], , "0");
  CreateFIELD(tmp, TotRun,   NUMERIC[2], , "0");
  CreateFIELD(tmp, WPsRun,   NUMERIC[2], , "0");
  CreateFIELD(tmp, ZeroRun,  NUMERIC[2], , "0");
  CreateFIELD(tmp, TotTime,  NUMERIC[3], , "0");
  CreateFIELD(tmp, WMTime,   NUMERIC[3], , "0");
  CreateFIELD(tmp, PikTime,  NUMERIC[3], , "0");
  CreateFIELD(tmp, PlaceKm,  NUMERIC[2], , "0");

  IF ByMarkG THEN
   CreateINDEX(tmp, TKRoute, UNIQUE, , , TKind, Route, MarkG);
   CreateINDEX(tmp, TKMark,  PLURAL, , , TKind, MarkG);
  ELSE
   CreateINDEX(tmp, TKRoute, UNIQUE, , , TKind, Route, Mark);
   CreateINDEX(tmp, TKMark,  PLURAL, , , TKind, Mark);
  END;

  SetVersionOfFILE(tmp, 0);
  L_AFM.AF_CreateTemp("tmp", "tmp");
 END {TP004_CreateTemp};

 PRIVATE PROCEDURE intTP004(ByMarkG: SCAL[2]);
  CONST
   TP004_RepName = "TP004";
  VAR
   TotTrips: NUMERIC[1];
   BadTrips: NUMERIC[1];
   TotRun  : NUMERIC[2];
   WPsRun  : NUMERIC[2];
   ZeroRun : NUMERIC[2];
   TotTime : NUMERIC[3];
   WMTime  : NUMERIC[3];
   PikTime : NUMERIC[3];
   PlaceKm : NUMERIC[2];

   stTotTrips: NUMERIC[1];
   stBadTrips: NUMERIC[1];
   stTotRun  : NUMERIC[2];
   stWPsRun  : NUMERIC[2];
   stZeroRun : NUMERIC[2];
   stTotTime : NUMERIC[3];
   stWMTime  : NUMERIC[3];
   stPikTime : NUMERIC[3];
   stPlaceKm : NUMERIC[2];

   tTotTrips: NUMERIC[1];
   tBadTrips: NUMERIC[1];
   tTotRun  : NUMERIC[2];
   tWPsRun  : NUMERIC[2];
   tZeroRun : NUMERIC[2];
   tTotTime : NUMERIC[3];
   tWMTime  : NUMERIC[3];
   tPikTime : NUMERIC[3];
   tPlaceKm : NUMERIC[2];
 BEGIN
  D_TP.PrepareTP();
  TP004_CreateTemp(ByMarkG);
  SELECT(TP, Route);
  WHILE OCCURE(TP) DO
   CHANGESEL(TP, Route, , TP.Route);
   CONFORM(TP, Route);
   CONFORM(Route, TKind);
   L_Way.StandOnRouteTKind(Memo.ud_fr());
   IF TKind.InTEP THEN
    WHILE OCCURE(TP) DO
     PROMPT(TP.Route + " " + TP.Mark);
     IF ByMarkG THEN
      ADD(tmp, TKRoute, , L_Way.GetRouteTKind(Memo.ud_fr(), 1), Route.Route, TP.MarkG,
            tmp.TotTrips, TP.GoodTrips,
            tmp.BadTrips, TP.BadTrips,
            tmp.TotRun,   TP.FullRun,
            tmp.WPsRun,   TP.RunPass,
            tmp.ZeroRun,  TP.ZeroRun,
            tmp.TotTime,  TP.WrkTim,
            tmp.PikTime,  TP.PikTim,
            tmp.PlaceKm,  TP.PVKm);
     ELSE
      ADD(tmp, TKRoute, , L_Way.GetRouteTKind(Memo.ud_fr(), 1), Route.Route, TP.Mark,
            tmp.TotTrips, TP.GoodTrips,
            tmp.BadTrips, TP.BadTrips,
            tmp.TotRun,   TP.FullRun,
            tmp.WPsRun,   TP.RunPass,
            tmp.ZeroRun,  TP.ZeroRun,
            tmp.TotTime,  TP.WrkTim,
            tmp.PikTime,  TP.PikTim,
            tmp.PlaceKm,  TP.PVKm);
     END;
     IF TP.DN = 0 THEN
      INC(tmp.WMTime, TP.WrkTim);
      REPLACE(tmp);
     END;
     NEXT(TP);
    END; (* WHILE OCCURE(TP) ... *)
   END;
   LAST(TP);
   CHANGESEL(TP, Route);
   NEXT(TP);
  END; (* WHILE OCCURE(TP) ... *)
  D_TP.PurgeTP();

  OPENREP(R, L_General.NameConnection(TP004_RepName), Create);
  MAKEPART(R, TP004_Top, TP004_RepName);
  SETZERO(tTotTrips, tBadTrips, tTotRun, tWPsRun, tZeroRun, tTotTime, tWMTime, tPikTime, tPlaceKm);
  SELECT(tmp, TKRoute);
  WHILE OCCURE(tmp) DO
   CHANGESEL(tmp, TKRoute, , tmp.TKind);
   SEARCH(TKind, TKind, , tmp.TKind);
   SETZERO(stTotTrips, stBadTrips, stTotRun, stWPsRun, stZeroRun, stTotTime, stWMTime, stPikTime, stPlaceKm);
   WHILE OCCURE(tmp) DO
    CHANGESEL(tmp, TKRoute, , tmp.TKind, tmp.Route);
    SEARCH(Route, Route, , tmp.Route);
    SETZERO(TotTrips, BadTrips, TotRun, WPsRun, ZeroRun, TotTime, WMTime, PikTime, PlaceKm);
    WHILE OCCURE(tmp) DO
     INC(TotTrips, tmp.TotTrips);
     INC(BadTrips, tmp.BadTrips);
     INC(TotRun,   tmp.TotRun);
     INC(WPsRun,   tmp.WPsRun);
     INC(ZeroRun,  tmp.ZeroRun);
     INC(TotTime,  tmp.TotTime);
     INC(WMTime,   tmp.WMTime);
     INC(PikTime,  tmp.PikTime);
     INC(PlaceKm,  tmp.PlaceKm);
     NEXT(tmp);
    END; (* WHILE OCCURE(tmp) ... *)
    MAKEPART(R, TP004_Line, Str.Align(Route.Route, 5, LEFT) + Route.Name,
             TotTrips, BadTrips, TotRun, WPsRun, ZeroRun, TotTime, WMTime, PikTime, PlaceKm);
    INC(stTotTrips, TotTrips);
    INC(stBadTrips, BadTrips);
    INC(stTotRun,   TotRun);
    INC(stWPsRun,   WPsRun);
    INC(stZeroRun,  ZeroRun);
    INC(stTotTime,  TotTime);
    INC(stWMTime,   WMTime);
    INC(stPikTime,  PikTime);
    INC(stPlaceKm,  PlaceKm);
    LAST(tmp);
    CHANGESEL(tmp, TKRoute, , tmp.TKind);
    NEXT(tmp);
   END; (* WHILE OCCURE(tmp) ... *)
   LAST(tmp);

   MAKEPART(R, TP004_SubTop, "⮣   ॢ-");
   MAKEPART(R, TP004_Line, TKind.TKind + " " + TKind.Name,
            stTotTrips, stBadTrips, stTotRun, stWPsRun, stZeroRun, stTotTime, stWMTime, stPikTime, stPlaceKm);
   MAKEPART(R, TP004_SubTop, " ⮬ ᫥  ઠ---");
   INC(tTotTrips, stTotTrips);
   INC(tBadTrips, stBadTrips);
   INC(tTotRun,   stTotRun);
   INC(tWPsRun,   stWPsRun);
   INC(tZeroRun,  stZeroRun);
   INC(tTotTime,  stTotTime);
   INC(tWMTime,   stWMTime);
   INC(tPikTime,  stPikTime);
   INC(tPlaceKm,  stPlaceKm);

   SAVE(tmp);
   CHANGESEL(tmp, TKMark, , tmp.TKind);
   FIRST(tmp);
   WHILE OCCURE(tmp) DO
    IF ByMarkG THEN
     CHANGESEL(tmp, TKMark, , tmp.TKind, tmp.MarkG);
     SEARCH(MarkG, MarkG, , tmp.MarkG);
    ELSE
     CHANGESEL(tmp, TKMark, , tmp.TKind, tmp.Mark);
     SEARCH(Mark, Mark, , tmp.Mark);
    END;
    SETZERO(TotTrips, BadTrips, TotRun, WPsRun, ZeroRun, TotTime, WMTime, PikTime, PlaceKm);
    WHILE OCCURE(tmp) DO
     INC(TotTrips, tmp.TotTrips);
     INC(BadTrips, tmp.BadTrips);
     INC(TotRun,   tmp.TotRun);
     INC(WPsRun,   tmp.WPsRun);
     INC(ZeroRun,  tmp.ZeroRun);
     INC(TotTime,  tmp.TotTime);
     INC(WMTime,   tmp.WMTime);
     INC(PikTime,  tmp.PikTime);
     INC(PlaceKm,  tmp.PlaceKm);
     NEXT(tmp);
    END; (* WHILE OCCURE(tmp) ... *)
    IF ByMarkG THEN
     MAKEPART(R, TP004_Line, MarkG.MarkG + " " + MarkG.Name,
              TotTrips, BadTrips, TotRun, WPsRun, ZeroRun, TotTime, WMTime, PikTime, PlaceKm);
    ELSE
     MAKEPART(R, TP004_Line, Mark.Mark + " " + Mark.Name,
              TotTrips, BadTrips, TotRun, WPsRun, ZeroRun, TotTime, WMTime, PikTime, PlaceKm);
    END;
    LAST(tmp);
    CHANGESEL(tmp, TKMark, , tmp.TKind);
    NEXT(tmp);
   END; (* WHILE OCCURE(tmp) ... *)
   RESTORE(tmp);
   CHANGESEL(tmp, TKRoute);
   MAKEPART(R, TP004_SubBot);
   NEXT(tmp);
  END; (* WHILE OCCURE(tmp) ... *)
  MAKEPART(R, TP004_Line, "⮣  ",
           tTotTrips, tBadTrips, tTotRun, tWPsRun, tZeroRun, tTotTime, tWMTime, tPikTime, tPlaceKm);
  MAKEPART(R, TP004_Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {intTP004};

 PUBLIC PROCEDURE TP004();
 BEGIN
  intTP004(0)
 END {TP004};

END.
