(*
%Copyright   (c) Polak IT
%Author      18.10.2004 19:54:45 POLAK\Bor
%Purpose     ᯮ짮 ⥫  ॢ
%Type        report
%Specific    AP
%Modified    15.01.2013 09:02:54 POLAK\MLB
%Environment
*)

 IMPORT L_General, L_DatTim, L_Basis, L_Str, L_Staff, L_Way, L_Car, Memo, FIO, P_Firm,
        L_Env, L_bp;

 CONST
  RepName = "T0410";

 VAR
  wMF: SCAL[2];

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "᭮");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠪ");
  L_Basis.wb_WrInQM(F, " ࠡ");
  L_Basis.wb_WrInQM(F, " ࠡ");
  L_Basis.wb_WrInQM(F, " ⢠");
  L_Basis.wb_WrInQM(F, " ⢠");
  L_Basis.wb_WrInQM(F, " ॢ");
  L_Basis.wb_WrInQM(F, " ॢ");
  L_Basis.wb_WrInQM(F, "६");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]);
 BEGIN
  IF wMF THEN
   CONFORM(Column, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrDat(F, RWayS.Date);
  L_Basis.wb_WrScl(F, RWayS.RWayS);
  L_Basis.wb_WrTim(F, RWayJ.StartT);
  L_Basis.wb_WrTim(F, RWayJ.StopT);
  L_Basis.wb_WrScl(F, RWayS.TSN);
  L_Basis.wb_WrStr(F, L_Str.ShortName(Man.Name));
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrScl(F, RWayS.BoxNbr);
  L_Basis.wb_WrStr(F, CarLog.StateNbr);
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Basis.wb_WrScl(F, CarLog.Column);
  L_Basis.wb_WrStr(F, Route.Route);
  L_Basis.wb_WrStr(F, Route.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("???|ந.||⮩", WJMode.WJType));
  L_Basis.wb_WrStr(F, WJMode.WJCode);
  L_Basis.wb_WrStr(F, WJMode.Name);
  L_Basis.wb_WrScl(F, Quality.Quality);
  L_Basis.wb_WrStr(F, Quality.Name);
  L_Basis.wb_WrScl(F, TKind.TKind);
  L_Basis.wb_WrStr(F, TKind.Name);
  L_Basis.wb_WrNum(F, RWayJ.StopT-RWayJ.StartT, 3);
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE Make(F: STRING[]);
 BEGIN
  SELECT(RWayS, Date);
  SRCINSEL(RWayS, GE, , Memo.ud_fr());
  WHILE OCCURE(RWayS) & (RWayS.Date<=Memo.ud_ut()) DO
   PROMPT(L_DatTim.DateStr(RWayS.Date) + " " + RWayS.RWayS);
   IF (RWayS.Status = L_Way.rwsStat_Rated) & L_Env.RealTSN(RWayS.TSN) THEN
    CONFORM(RWayS, RWayJ);
    WHILE OCCURE(RWayJ) DO
     CONFORM(RWayJ, Quality);
     IF Quality.Type # L_Way.QualType_Annul THEN
      CONFORM(RWayJ, SEJobs);
      CONFORM(SEJobs, WJMode);
      IF (WJMode.WJType = L_Way.WJType_Repair) |
         (WJMode.WJType = L_Way.WJType_Stand) |
         ((WJMode.WJType = L_Way.WJType_Work) = (WJMode.RunSel = L_Way.runsel_None)) THEN
       CONFORM(RWayS, Staff);
       L_Staff.PosToStaffLog(RWayS.TSN, RWayS.Date, 1);
       CONFORM(StaffLog, Sort);
       CONFORM(Staff, Man);
       L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
       CONFORM(CarLog, Mark);
       CONFORM(CarLog, Column);
       CONFORM(SEJobs, Route);
       L_Way.StandOnRouteTKind(RWayS.Date);
       MakePart(F);
       SELECT(WayLMen, RWayS, , RWayS.RWayS, L_Way.wlmwho_SDriver);
       WHILE OCCURE(WayLMen) DO
        IF L_Way._TimeInt(L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT),
                          L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT),
                          L_Way.FullBegTime(WayLMen.Day, WayLMen.StartT),
                          L_Way.FullEndTime(WayLMen.Day, WayLMen.StartT, WayLMen.StopT)) > 0 THEN
         CONFORM(WayLMen, Staff);
         L_Staff.PosToStaffLog(WayLMen.TSN, RWayS.Date, 1);
         CONFORM(StaffLog, Sort);
         CONFORM(Staff, Man);
         MakePart(F);
        END;
        NEXT(WayLMen);
       END; (* WHILE OCCURE(WayLMen) ... *)
      END;
     END;
     NEXT(RWayJ);
    END; (* WHILE OCCURE(RWayJ) ... *)
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 END {Make};

 PRIVATE PROCEDURE T0410();
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_bp.Begin(RepName, "ᯮ짮 ⥫  ॢ", L_bp.t_Basis, L_General.tc_inIntvl);
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  MakeHeader("R");
  Make("R");
  FIO.Close(R);
  L_bp.End();
 END {T0410};

END.