(*
%Copyright   (c) Polak Computer System
%Author      16.10.2001 17:11:12 RSN
%Purpose       室  ਮ.
%Type        report
%Specific    AP
%Modified    16.06.2014 14:21:58 POLAK\GAV
%Environment
*)

 IMPORT FIO, L_EC, L_General, L_Basis, L_Str, L_Env, L_Way, L_DatTim, L_bp,
        D_RWS, P_Mark, P_Firm, E_Way, Memo, DBD, L_Car, P_Route, L_Russia, L_APWI, L_Staff;

 VAR
  wPlnIncForStExit,
  _wASCP,
  _ByDay,
  _WithPlnTrips: SCAL[2];
  GrVol        : NUMERIC[0];
  _PV          : NUMERIC[0];
  GrVolName    : STRING[];
  wMF          : SCAL[2];

 PRIVATE PROCEDURE E_ShowPlanTrips(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.ShowPlanTrips), 1);
 END {E_ShowPlanTrips};

 PRIVATE PROCEDURE E_ShowPlnIncForStExit(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.ShowPlnIncForStExit), 0);
 END {E_ShowPlnIncForStExit};

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "஢");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "㯯 ⮢");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "ࠪ 室");
  IF _wASCP THEN
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "㯯 ப");
  L_Basis.wb_WrInQM(F, "㯯 ப");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "㯯 ⨬   ");
  L_Basis.wb_WrInQM(F, "㯯 ⨬");
  L_Basis.wb_WrInQM(F, "⨬    室");
  L_Basis.wb_WrInQM(F, "ࠦ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⥫ ");
  L_Basis.wb_WrInQM(F, "⥫ ");
  L_Basis.wb_WrInQM(F, "⥫ ⤥");
  L_Basis.wb_WrInQM(F, "⥫ ⤥");
  L_Basis.wb_WrInQM(F, "⥫ ");
  L_Basis.wb_WrInQM(F, "⥫ ");
  L_Basis.wb_WrInQM(F, "'' ");
  L_Basis.wb_WrInQM(F, " ஢");
  L_Basis.wb_WrInQM(F, "ꥪ ஢");
  L_Basis.wb_WrInQM(F, " ࢠ ஢");
  L_Basis.wb_WrInQM(F, "६ ࢠ ஢");
  L_Basis.wb_WrInQM(F, "⥫⢠");
  L_Basis.wb_WrInQM(F, " ஢");
  IF _ByDay THEN
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "  ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "⢮ ஢");
  L_Basis.wb_WrInQM(F, "⢮ ⥫");
  L_Basis.wb_WrInQM(F, " ப");
  IF _WithPlnTrips THEN
   IF wPlnIncForStExit THEN
    L_Basis.wb_WrInQM(F, "室될");
   END;
   L_Basis.wb_WrInQM(F, "돫");
   L_Basis.wb_WrInQM(F, "६");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "६");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ࠡ⭨");
  L_Basis.wb_WrInQM(F, "६ ࠡ⭨");
  L_Basis.wb_WrInQM(F, " ࠡ⭨");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "६ ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "஥");
  L_Basis.wb_WrInQM(F, "஥2");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "ᠦ");
  IF D_RWS.wVldPsgPlan THEN
   L_Basis.wb_WrInQM(F, "ଏᏫ");
  END;
  IF (L_Env.Region = L_Russia.reg_50) | (L_Env.Region = L_Russia.reg_77) THEN
(*     㤠.
     ஡ ஢ ⮩ 䨣  ⠪ 񫮬  - 訡.
          T2100 - ⮦. *)
   L_Basis.wb_WrInQM(F, "抠댎");
   L_Basis.wb_WrInQM(F, "抠");
   L_Basis.wb_WrInQM(F, "죏稥");
   L_Basis.wb_WrInQM(F, "륊");
  ELSE
   L_Basis.wb_WrInQM(F, "죏1");
   L_Basis.wb_WrInQM(F, "죏2");
   L_Basis.wb_WrInQM(F, "죏");
   L_Basis.wb_WrInQM(F, "⏠");
  END;
  L_Basis.wb_WrInQM(F, "஡");
  L_Basis.wb_WrInQM(F, "६  ஡");
  IF DBD.FieldExist(IN001, Number) THEN
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "叮६");
  L_Basis.wb_WrInQM(F, "叮ᠬ");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE PrintDvr(F: STRING[]);
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   SEARCH(Staff, TSN, , IN001.drvTSN);
   HISTCONF(IN001.Date, Staff, StaffLog);
   CONFORM(StaffLog, Officer, Sort);
   CONFORM(Staff, Man);
   L_Basis.wb_WrStr(F, Man.Name);
   L_Basis.wb_WrScl(F, L_Staff.getDepart());
   L_Basis.wb_WrStr(F, L_Staff.getDepartName());
   L_Basis.wb_WrScl(F, Sort.Sort);
   L_Basis.wb_WrStr(F, Sort.Name);
  EXCEPT
  END; (* TRY *)
 END {PrintDvr};

 PRIVATE PROCEDURE GetIncPlanForStExit(): L_APWI.tPlanIncome;
  VAR
   IncPlan: L_APWI.tPlanIncome;
   curWho : L_Way.tRWSWho;
 BEGIN
  IncPlan:=0;
  IF IN001.Who # L_Way.rwswho_Chopper THEN
   SELECT(SEJobs, Exit, , StExit.Exit);
   WHILE OCCURE(SEJobs) DO
    IF SEJobs.Route=IN001.Route THEN
     CONFORM(SEJobs, Route, WJMode);
     L_General.Assert(SEARCH(Calendar, Date, IN001.Date), "    "+L_DatTim.DateStr(IN001.Date));
     IF IN001.Who = L_Way.rwswho_Dr_W_Gu THEN
      curWho:=L_Way.rwswho_Driver;
     ELSE
      curWho:=IN001.Who;
     END;
     INC(IncPlan, L_APWI.E_GetPlanIncomeScope(L_APWI.piScope_SEJobs,
                                              IN001.Date,
                                              L_APWI.E_rwsWho2IPC(L_APWI.w2im_toAnalyze, curWho, 1)));
    END;
    NEXT(SEJobs);
   END; (* WHILE OCCURE(SEJobs) ... *)
  END;
  RETURN IncPlan;
 END {GetIncPlanForStExit};

 PRIVATE PROCEDURE MakePart(F: STRING[]);
 BEGIN
  IF wMF THEN
   CONFORM(Staff, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Way.tkrgn_Pool, TKind.Rgn));
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Way.tkfnm_Pool, TKind.FnMode));
  L_Basis.wb_WrScl(F, TKind.TKind);
  L_Basis.wb_WrStr(F, TKind.Name);
  L_Basis.wb_WrStr(F, Route.Route);
  L_Basis.wb_WrStr(F, Route.Name);
  L_Basis.wb_WrStr(F, P_Route.GetRouteProSoft(Route.Route, Memo.ud_ut(), P_Route.P_Group));
  L_Basis.wb_WrScl(F, ExitClss.ExitClss);
  L_Basis.wb_WrStr(F, ExitClss.Name);
  L_Basis.wb_WrScl(F, StExit.Exit);
  L_Basis.wb_WrScl(F, L_Str.PoolItem(L_Way.ExitStrict_Pool, StExit.Strict));
  IF _wASCP THEN
   L_Basis.wb_WrScl(F, IN001.ASCP);
  END;
  L_Way.StandOnMarkG(Mark.Mark, L_Way.mgt_TEP);
  L_Basis.wb_WrScl(F, MarkG.MarkG);
  L_Basis.wb_WrStr(F, MarkG.Name);
  L_Basis.wb_WrStr(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Basis.wb_WrStr(F, FLDTOSTR(GrVol, "0", 0));
  L_Basis.wb_WrStr(F, GrVolName);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", (_PV >= StExit.MinPV) & (!StExit.MaxPV | (_PV <= StExit.MaxPV))));
  L_Basis.wb_WrScl(F, IN001.BoxNbr);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Way.rwswho_Pool_Short, IN001.Who));
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrScl(F, L_Staff.getDepart());
  L_Basis.wb_WrStr(F, L_Staff.getDepartName());
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrScl(F, IN001.drvTSN);
  PrintDvr(F);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", IN001.myPln));
  L_Basis.wb_WrStr(F, L_Str.PoolItem("|室", IN001.piKind));
  L_Basis.wb_WrStr(F, IN001.piObject);
  IF ~!IN001.piDay THEN
   L_Basis.wb_WrScl(F, IN001.piDay);
  ELSE
   L_Basis.wb_WrStr(F, "---");
  END;
  IF ~!IN001.piTime THEN
   L_Basis.wb_WrTim(F, IN001.piTime);
  ELSE
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Way.E_IPConditionPool(IN001.Date), IN001.piCnd));
  IF ~!IN001.piType THEN
   IF IN001.piKind = 1 THEN
    L_Basis.wb_WrStr(F, L_Str.PoolItem(" | 室| ३| |", IN001.piType));
   ELSE
    L_Basis.wb_WrStr(F, L_Str.PoolItem(" | ३| 室|", IN001.piType));
   END;
  ELSE
    L_Basis.wb_WrStr(F, "---");
  END;
  IF _ByDay THEN
   L_Basis.wb_WrDat(F, IN001.Date);
  END;
  L_Basis.wb_WrStr(F, L_DatTim.WeekDayShortStr(IN001.WD));
  L_Basis.wb_WrStr(F, L_Way.E_ConvertWDStr(IN001.Date, L_Way.E_ConvertWD(IN001.Date, IN001.WD)));
  L_Basis.wb_WrInQM(F, IN001.GuardCnt);
  L_Basis.wb_WrInQM(F, IN001.DriverCnt);
  L_Basis.wb_WrScl(F, IN001.Dummy);
  IF _WithPlnTrips THEN
   IF wPlnIncForStExit THEN
    IF ~!IN001.piDay THEN
     L_Basis.wb_WrNum(F, GetIncPlanForStExit(), 2);
    ELSE
     L_Basis.wb_WrNum(F, 0, 2);
    END;
   END;
   L_Basis.wb_WrNum(F, StExit.TripAm, 2);
   L_Basis.wb_WrNum(F, StExit.PaidT, 3);
  END;
  L_Basis.wb_WrNum(F, IN001.IncPln, 3);
  L_Basis.wb_WrNum(F, IN001.IncTim, 3);
  L_Basis.wb_WrNum(F, IN001.IncTrp, 2);
  L_Basis.wb_WrNum(F, IN001.pIncPln, 3);
  L_Basis.wb_WrNum(F, IN001.pIncTim, 3);
  L_Basis.wb_WrNum(F, IN001.pIncTrp, 2);
  L_Basis.wb_WrNum(F, IN001.iIncPln, 3);
  L_Basis.wb_WrNum(F, IN001.iIncTim, 3);
  L_Basis.wb_WrNum(F, IN001.iIncTrp, 2);
  L_Basis.wb_WrNum(F, IN001.IncFct,  3);
  L_Basis.wb_WrNum(F, IN001.iIndFct, 3);
  L_Basis.wb_WrNum(F, IN001.TkMFct[0], 3);
  L_Basis.wb_WrNum(F, IN001.TkMFct[1], 3);
  L_Basis.wb_WrNum(F, IN001.CasFct, 3);
  L_Basis.wb_WrNum(F, IN001.Pass, 1);
  IF D_RWS.wVldPsgPlan THEN
   L_Basis.wb_WrNum(F, IN001.VldPsgPln, 2);
  END;
  L_Basis.wb_WrNum(F, IN001.VldPsg[L_Way.vpk_MoscowRegion], 1);
  L_Basis.wb_WrNum(F, IN001.VldPsg[L_Way.vpk_Moscow      ], 1);
  L_Basis.wb_WrNum(F, IN001.VldPsg[L_Way.vpk_OtherSocial ], 1);
  L_Basis.wb_WrNum(F, IN001.VldPsg[L_Way.vpk_Paid        ], 1);
  L_Basis.wb_WrNum(F, IN001.Run, 3);
  L_Basis.wb_WrNum(F, IN001.RunTim, 3);
  IF DBD.FieldExist(IN001, Number) THEN
   L_Basis.wb_WrInQM(F, IN001.Number);
  END;
  IF StExit.PaidT # 0 THEN
   L_Basis.wb_WrNum(F, IN001.pIncTim / StExit.PaidT, 6);
  ELSE
   L_Basis.wb_WrNum(F, 0, 0);
  END;
  IF StExit.TripAm # 0 THEN
   L_Basis.wb_WrNum(F, IN001.pIncTrp / StExit.TripAm, 6);
  ELSE
   L_Basis.wb_WrNum(F, 0, 0);
  END;
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PUBLIC PROCEDURE T9021();
  CONST
   bpId = "T9021";
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_bp.Begin(bpId, " 믮   窥", L_bp.t_Basis, L_General.tc_inIntvl);
 
  FIO.Open(R, L_General.NameConnection("T9021"), "REP", Create);
 
  _ByDay       :=D_RWS.E_DetailByDayIN001(Memo.ud_ut());
  _WithPlnTrips:=E_ShowPlanTrips(Memo.ud_ut());
  IF _WithPlnTrips THEN
   L_General.Assert(_ByDay, "  ⠭ ࠧ  ");
  END;
  _wASCP       :=L_Way.E_ASCPLev(Memo.ud_ut());
  wMF          :=P_Firm.E_wMultipleMyFirm(SYSDATE());
  wPlnIncForStExit:=E_ShowPlnIncForStExit(Memo.ud_ut());
 
  D_RWS.Prepare_IN001(_ByDay);
 
  MakeHeader("R");
 
  SELECT(IN001, TSN);
  WHILE OCCURE(IN001) DO
   PROMPT(" " + IN001.TSN);
   CONFORM(IN001, Staff, Man);
   HISTCONF(IN001.ODate, Staff, StaffLog);
   CONFORM(StaffLog, Officer, Sort);
   CHANGESEL(IN001, TSN, , IN001.TSN, IN001.ODate);
   WHILE OCCURE(IN001) DO
    L_Car.AccessMark(IN001.BoxNbr, Memo.ud_ut());
    _PV:=P_Mark.GetP_PVLim(Mark.Mark, Memo.ud_ut());
    GrVol    :=L_Way.E_DefinePasVol(Memo.ud_ut(), _PV);
    GrVolName:=L_Way.GetMarkPasVolSign(Memo.ud_ut(), Mark.Mark);
    CHANGESEL(IN001, TSN, , IN001.TSN, IN001.ODate, IN001.BoxNbr);
    WHILE OCCURE(IN001) DO
     PROMPT(" " + IN001.TSN+" "+IN001.BoxNbr+" "+IN001.Route);
     CONFORM(IN001, Route);
     L_Way.StandOnRouteTKind(Memo.ud_ut());
     CONFORM(IN001, StExit, ExitClss);
     MakePart("R");
     NEXT(IN001);
    END;
    LAST(IN001);
    CHANGESEL(IN001, TSN, , IN001.TSN, IN001.ODate);
    NEXT(IN001);
   END;
   LAST(IN001);
   CHANGESEL(IN001, TSN);
   NEXT(IN001);
  END; (* WHILE OCCURE(IN001) ... *)
 
  D_RWS.Purge_IN001();
  FIO.Close(R);
  L_bp.End();
 END {T9021};

END.
