(*
%Copyright   (c) Polak IT
%Author      04.10.2004 16:11:43 POLAK\GAV
%Purpose       ⭮ த樨
%Type        report
%Specific    AP
%Modified    08.04.2014 16:36:00 POLAK\GAV
%Environment
*)

 MODULE Tck01 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Basis, Memo, L_Str, L_Way, FIO, L_General, L_TRS, L_Car,
        Math, P_Route, P_Firm, L_bp, L_DatTim, L_AFM, L_IRec, Str, L_lsStore;

 PRIVATE CONST
  src_ElTck  = 0;
  src_TckRcS = 1;
  src_IRec   = 2;

 PRIVATE VAR
  wMF: SCAL[2];

 PRIVATE PROCEDURE MakeTop(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ॢ稪");
  L_Basis.wb_WrInQM(F, "ॢ稪");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ॢ");
  L_Basis.wb_WrInQM(F, "ॢ");
  L_Basis.wb_WrInQM(F, "㯯 ⮢");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠦ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "᭮");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "த");
  L_Basis.wb_WrInQM(F, "Ꮰᠦࠬ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⢮");
  L_Basis.wb_WrInQM(F, "㬬");
  L_Basis.wb_WrInQM(F, "ᠭ⢮");
  L_Basis.wb_WrInQM(F, "ᠭ㬬");
  L_Basis.wb_WrInQM(F, "ᠦ");
  L_Basis.wb_WrInQM(F, "筨");
  L_Basis.wb_TermLine(F);
 END {MakeTop};

 PRIVATE PROCEDURE OutTck_IRec(F          : STRING[];
                               Num,
                               Psg,
                               Returned   : NUMERIC[0];
                               Sum,
                               ReturnedSum: NUMERIC[2];
                               asInCash   : LIKE(TckKind.InCash);
                               asInSale   : LIKE(TckKind.InSale));
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;

  L_Basis.wb_WrStr(F, "---");
  L_Basis.wb_WrScl(F, IRec.IRec);
  IF IRec.Type = L_IRec.type_Sale THEN
   L_Basis.wb_WrDat(F, IRecL.Date);
  ELSE
   L_Basis.wb_WrDat(F, IRecL.StartD);
  END;
  L_Basis.wb_WrScl(F, IRec.Storage);
  SEARCH(Storage, Storage, , IRec.Storage);
  CONFORM(IRec, Firm);

  IF OCCURE(Storage) THEN
   L_Basis.wb_WrStr(F, Storage.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
  END;

  L_Basis.wb_WrScl(F, Firm.Firm);
  L_Basis.wb_WrStr(F, Firm.Name);

  IF ~!IRecL.Route THEN
   L_General.CallUs(SEARCH(Route, Route, IRecL.Route));
   L_Basis.wb_WrStr(F, Route.Route);
   L_Basis.wb_WrStr(F, Route.Name);
   L_Way.StandOnRouteTKind(IRecL.StartD);
   L_Basis.wb_WrScl(F, TKind.TKind);
   L_Basis.wb_WrStr(F, TKind.Name);
   L_Basis.wb_WrStr(F, P_Route.GetRouteProSoft(Route.Route, IRecL.StartD, P_Route.P_Group));
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "");
  END;

  IF ~!IRecL.asRWayS & ~!IRecL.asDay & ~!IRecL.asStartT THEN
   L_General.CallUs(SEARCH(RWayJ, RWayS, IRecL.asRWayS, IRecL.asDay, IRecL.asStartT));
   CONFORM(RWayJ, RWayS);
   CONFORM(RWayJ, SEJobs);
   CONFORM(SEJobs, StExit);
   L_Basis.wb_WrScl(F, StExit.Exit);
   L_Basis.wb_WrStr(F, StExit.ExitClss);
   L_Basis.wb_WrScl(F, RWayJ.Trip);
   L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
   L_Basis.wb_WrScl(F, RWayS.BoxNbr);
   L_Basis.wb_WrScl(F, Mark.Mark);
   L_Basis.wb_WrStr(F, Mark.Name);
  ELSIF ~!IRecL.asBoxNbr & SEARCH(Car, BoxNbr, IRecL.asBoxNbr) THEN
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Car.AccessMark(IRecL.asBoxNbr, IRecL.StartD);
   L_Basis.wb_WrScl(F, IRecL.asBoxNbr);
   L_Basis.wb_WrScl(F, Mark.Mark);
   L_Basis.wb_WrStr(F, Mark.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_WrStr(F, "---");
  L_Basis.wb_WrStr(F, "---");
  L_Basis.wb_WrStr(F, "---");
  L_Basis.wb_WrStr(F, "---");
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_IRec.TicketK_Pool, IRecL.TicketK));
  L_Basis.wb_WrStr(F, "---");
  L_Basis.wb_WrStr(F, "---");
  L_Basis.wb_WrScl(F, asInCash);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_TRS.tks_Pool, asInSale));
  L_Basis.wb_WrStr(F, "---");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrNum(F, Num, 0);
  L_Basis.wb_WrNum(F, Sum, 2);
  L_Basis.wb_WrNum(F, Returned, 0);
  L_Basis.wb_WrNum(F, ReturnedSum, 2);
  L_Basis.wb_WrNum(F, Psg, 0);

  L_Basis.wb_WrStr(F, L_Str.PoolItem("஭ ||", src_IRec));
  L_Basis.wb_TermLine(F);
 END {OutTck_IRec};

 PRIVATE PROCEDURE OutTck(F          : STRING[];
                          Num,
                          Psg,
                          Returned   : NUMERIC[0];
                          Sum,
                          ReturnedSum: NUMERIC[2];
                          Src        : SCAL[3]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;

  L_Basis.wb_WrScl(F, TckRcS.TckRcS);
  L_Basis.wb_WrStr(F, "---");
  L_Basis.wb_WrDat(F, TckRcS.Date);
  L_Basis.wb_WrScl(F, TckRcS.Storage);
  CONFORM(TckRcS, Storage);
  CONFORM(MyFirm, Firm);

  IF OCCURE(Storage) THEN
   L_Basis.wb_WrStr(F, Storage.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
  END;

  L_Basis.wb_WrScl(F, Firm.Firm);
  L_Basis.wb_WrStr(F, Firm.Name);

  L_Basis.wb_WrStr(F, Route.Route);
  L_Basis.wb_WrStr(F, Route.Name);
  L_Way.StandOnRouteTKind(TckRcS.Date);
  L_Basis.wb_WrScl(F, TKind.TKind);
  L_Basis.wb_WrStr(F, TKind.Name);
  L_Basis.wb_WrStr(F, P_Route.GetRouteProSoft(Route.Route, TckRcS.Date, P_Route.P_Group));

  IF L_Way.E_IsImaginaryRoute(TckRcS.Date, TckRcJ.Route) THEN
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  ELSE
   L_Basis.wb_WrScl(F, StExit.Exit);
   L_Basis.wb_WrStr(F, StExit.ExitClss);
   L_Basis.wb_WrScl(F, RWayJ.Trip);
   L_Basis.wb_WrScl(F, RWayS.BoxNbr);
   L_Basis.wb_WrScl(F, Mark.Mark);
   L_Basis.wb_WrStr(F, Mark.Name);
  END;
  L_Basis.wb_WrScl(F, TckRcS.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Way.trs_Pool, TckRcS.AsWho));
  L_Basis.wb_WrScl(F, TckKind.TckKind);
  L_Basis.wb_WrStr(F, TckKind.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("|", L_TRS.IsMainTckKind(TckKind.TckKind, TckRcS.Date, TckRcJ.Route)));
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_TRS.tkt_Pool, TckKind.Type));
  L_Basis.wb_WrScl(F, TckKind.InCash);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_TRS.tks_Pool, TckKind.InSale));
  L_Basis.wb_WrStr(F, L_Str.PoolItem("|", TckKind.wPsg | L_TRS.IsMainTckKind(TckKind.TckKind, TckRcS.Date, TckRcJ.Route)));
  L_Basis.wb_WrNum(F, TckKind.FaceVal, 2);
  L_Basis.wb_WrNum(F, Num, 0);
  L_Basis.wb_WrNum(F, Sum, 2);
  L_Basis.wb_WrNum(F, Returned, 0);
  L_Basis.wb_WrNum(F, ReturnedSum, 2);
  L_Basis.wb_WrNum(F, Psg, 0);

  L_Basis.wb_WrStr(F, L_Str.PoolItem("஭ ||", Src));
  L_Basis.wb_TermLine(F);
 END {OutTck};

 PRIVATE PROCEDURE MakeOneTckRcS(F: STRING[]; trgTckRcS: LIKE(TckRcS.TckRcS));
  VAR
   PrvNbrs    : LIKE(TckRcJ.TckNbrs);
   PrvPsg     : LIKE(TckRcJ.TckPsg);
   idx,
   Num,
   Psg,
   Returned   : NUMERIC[0];
   Sum,
   ReturnedSum: NUMERIC[2];
   NeedTckRcJ : SCAL[2];
 BEGIN
  IF ~ADD(trs, trs, trgTckRcS) THEN
   SAVE(TckRcJ);
   SAVE(RWayS);
   SEARCH(TckRcS, TckRcS, , trgTckRcS);
   CONFORM(TckRcS, Staff);
   CONFORM(Staff, Man);
   CONFORM(Staff, MyFirm);
   SELECT(TckRcJ, TckRcS, , TckRcS.TckRcS);
   WHILE OCCURE(TckRcJ) DO
    PROMPT(TckRcS.TckRcS + " " + TckRcJ.Day + " " + L_DatTim.TimeStr(TckRcJ.StartT));
    IF L_Way.E_IsImaginaryRoute(TckRcS.Date, TckRcJ.Route) THEN
     CONFORM(TckRcJ, Route);
     NeedTckRcJ:=1;
    ELSIF !TckRcJ.asRWayS | !TckRcJ.asDay | !TckRcJ.asStartT THEN
     NeedTckRcJ:=0;
    ELSE
     L_General.CallUs(SEARCH(RWayJ, RWayS, TckRcJ.asRWayS, TckRcJ.asDay, TckRcJ.asStartT));
     CONFORM(RWayJ, RWayS);
     L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
     CONFORM(RWayJ, SEJobs);
     CONFORM(SEJobs, StExit);
     CONFORM(SEJobs, Route);
     NeedTckRcJ:=L_DatTim.IsActive_Inc(RWayS.Date, Memo.ud_fr(), Memo.ud_ut())
    END;

    IF NeedTckRcJ THEN
     PrvNbrs:=L_TRS.GetPrvNbrs();
     L_TRS.GetPrvJobInfo(PrvNbrs, PrvPsg);
     idx:=0;
     WHILE (idx <= HIGH(TckRcJ.TckNbrs)) DO
      IF ~!TckRcJ.TckNbrs[idx] THEN
       SELECT(TckRcT, Number, , TckRcS.TckRcS, idx + 1);
       CONFORM(TckRcT, TckKind);
       IF ~L_TRS.E_NeedAutoTaxTckRcJR(TckRcS.Date) THEN
        IF L_TRS.IsBulk_wCUC() THEN
         Returned   :=TckRcJ.TckRPsg[idx];
         Sum        :=Math.Abs(TckRcJ.TckNbrs[idx] - PrvNbrs[idx]);
         IF TckKind.Type = L_TRS.tkt_ZonalTicket THEN
          ReturnedSum:=TckRcJ.TckRAmnt[idx];
         ELSE
          ReturnedSum:=TckRcJ.TckRAmnt[idx] * TckKind.FaceVal;
         END;
         IF L_TRS.IsMainTckKind(TckRcT.TckKind, TckRcS.Date, TckRcJ.Route) THEN
          Psg       :=TckRcJ.TckPsg[idx] - PrvPsg[idx];
          Num       :=TckRcJ.TckPsg[idx];
         ELSE
          Num       :=0;
          Psg       :=0;
          SELECT(TckRcD, TckRcS, , TckRcJ.TckRcS);
          WHILE OCCURE(TckRcD) DO
           IF (TckRcD.Type # L_TRS.trdt_Laying) & SEARCH(TckRcDL, TckRcD, TckRcD.TckRcD, TckRcT.TckRcT) THEN
            CONFORM(TckRcDL, TckRcDLL);
            WHILE OCCURE(TckRcDLL) DO
             IF (TckRcDLL.Day = TckRcJ.Day) & (TckRcDLL.Time = TckRcJ.StartT) THEN
              INC(Num, 1);
             END;
             NEXT(TckRcDLL);
            END; (* WHILE OCCURE(TckRcDLL) ... *)
           END;
           NEXT(TckRcD);
          END; (* WHILE OCCURE(TckRcD) ... *)
         END;
        ELSIF (TckKind.Type = L_TRS.tkt_Ticket) | (TckKind.Type = L_TRS.tkt_PieceTck) THEN
         IF    L_TRS.IsMainTckKind(TckKind.TckKind, TckRcS.Date, TckRcJ.Route) THEN
          Num       :=Math.Abs(TckRcJ.TckNbrs[idx] - PrvNbrs[idx]);
          Psg       :=Num - TckRcJ.TckRPsg[idx];
          Returned  :=TckRcJ.TckRAmnt[idx];
         ELSIF L_TRS.TckKind_wPsg() THEN
          Num       :=TckRcJ.TckPsg[idx] - PrvPsg[idx];
          Psg       :=Num - TckRcJ.TckRPsg[idx];
          Returned  :=TckRcJ.TckRPsg[idx];
         ELSE
          Num       :=Math.Abs(TckRcJ.TckNbrs[idx] - PrvNbrs[idx]);
          Psg       :=0;
          Returned  :=TckRcJ.TckRAmnt[idx];
         END;
         Sum        :=Math.Abs(TckRcJ.TckNbrs[idx] - PrvNbrs[idx]) * TckKind.FaceVal;
         ReturnedSum:=TckRcJ.TckRAmnt[idx] * TckKind.FaceVal;
        ELSE
         IF    L_TRS.IsMainTckKind(TckKind.TckKind, TckRcS.Date, TckRcJ.Route) THEN
          Num       :=Math.Abs(TckRcJ.TckNbrs[idx] - PrvNbrs[idx]);
          Psg       :=Num - TckRcJ.TckRPsg[idx];
          Returned  :=TckRcJ.TckRPsg[idx];
         ELSIF L_TRS.TckKind_wPsg() THEN
          Num       :=TckRcJ.TckPsg[idx] - PrvPsg[idx];
          Psg       :=Num - TckRcJ.TckRPsg[idx];
          Returned  :=TckRcJ.TckRPsg[idx];
         ELSE
          Num       :=Math.Abs(TckRcJ.TckNbrs[idx] - PrvNbrs[idx]);
          Psg       :=0;
          Returned  :=TckRcJ.TckRAmnt[idx];
         END;
         Sum        :=Math.Abs(TckRcJ.TckNbrs[idx] - PrvNbrs[idx]) * TckKind.FaceVal;
         ReturnedSum:=TckRcJ.TckRAmnt[idx] * TckKind.FaceVal;
        END; (* IF L_TRS.IsBulk_wCUC() *)
        IF (Num # 0) | (Psg # 0) | (Returned # 0) | (Sum # 0) | (ReturnedSum # 0) THEN
         OutTck(F, Num, Psg, Returned, Sum, ReturnedSum, src_TckRcS);
        END;
       END; (* IF ~L_TRS.E_NeedAutoTaxTckRcJR(TckRcS.Date)  *)
      END; (* IF ~!TckRcJ.TckNbrs[idx] *)
      INC(idx);
     END; (* WHILE (idx <= HIGH(TckRcJ.TckNbrs)) DO *)
     SELECT(TckRcJR, TckRcS, , TckRcJ.TckRcS, TckRcJ.Day, TckRcJ.StartT);
     WHILE OCCURE(TckRcJR) DO
      CONFORM(TckRcJR, TckKind);
      IF L_TRS.E_MakeVldPsgRWJP(TckRcS.Date, TckRcJR.TckKind) |
         (L_TRS.E_NeedAutoTaxTckRcJR(TckRcS.Date) & L_TRS.TckKind_wPsg()) THEN
       Psg:=TckRcJR.Psg;
      ELSE
       Psg:=0;
      END;
      OutTck(F, TckRcJR.Psg, Psg, 0, TckRcJR.Sum, 0, src_ElTck);
      NEXT(TckRcJR);
     END; (* WHILE OCCURE(TckRcJR) ... *)
    END; (* IF NeedTckRcJ *)
    NEXT(TckRcJ);
   END; (* WHILE OCCURE(TckRcJ) ... *)
   RESTORE(RWayS);
   RESTORE(TckRcJ);
  END; (* IF ~ADD(trs, trs, trgTckRcS) THEN *)
 END {MakeOneTckRcS};

 PRIVATE PROCEDURE Tck01_GatherIRec(From, UpTo: DATE);
  VAR
   Num,
   Psg,
   Returned   : NUMERIC[0];
   Sum,
   ReturnedSum: NUMERIC[2];
   trgTckNbr  : LIKE(IRecL.TckNbr);
   trgKKM     : LIKE(IRecL.KKM);
   asInCash   : LIKE(TckKind.InCash);
   asInSale   : LIKE(TckKind.InSale);
 BEGIN
  APP.Get().NewPrompt("ઠ   த ⮢");
  SETSEL(IRec, Date);
  SRCINSEL(IRec, GE, , From);
  WHILE OCCURE(IRec) & (IRec.Date <= UpTo) DO
   PROMPT(IRec.IRec);
   CONFORM(IRec, MyFirm);
   CONFORM(IRec, IRecL);
   WHILE OCCURE(IRecL) DO
    IF !IRecL.Route THEN
     L_General.Assert(L_IRec.E_IsOutsideTransporter(),
                      " 㪠   ப " + IRecL.IRecL + "  " + IRecL.IRecL);
    END;
    IF ~!IRecL.TckAmnt & (IRecL.TckAmnt # 0) THEN
     IF IRecL.Kind # L_IRec.knd_Return THEN
      Num        :=IRecL.TckAmnt;
      Returned   :=0;
      Sum        :=IRecL.TotalSum;
      ReturnedSum:=0;
      IF (IRecL.TicketK = L_IRec.tk_Baggage) | (IRec.Type = L_IRec.type_Sale) THEN
       Psg       :=0;
      ELSE
       Psg       :=IRecL.TckAmnt;
      END;

      IF IRec.Type = L_IRec.type_Sale THEN
       (*த *)
       L_General.CallUs(L_IRec.E_GetIRecLInsertMode() = L_IRec.irlim_Import);
       asInCash:=IRecL.PayMth = L_IRec.paymth_Cash;
       asInSale:=L_TRS.tks_Prepayment;
      ELSE
       IF ~!IRecL.PsgDescr THEN
        trgKKM   :=Str.Item(L_lsStore.Get(IRecL.PsgDescr), ";", 0, 0, 1);
        trgTckNbr:=Str.Item(L_lsStore.Get(IRecL.PsgDescr), ";", 1, 0, 1);
       ELSE
        trgKKM   :=IRecL.KKM;
        trgTckNbr:=IRecL.TckNbr;
       END;
       asInCash:=IRecL.PayMth = L_IRec.paymth_Cash;
       asInSale:=L_TRS.tks_Sales;
       SAVE(IRec);
       SAVE(IRecL);
       SELECT(IRec, TSrcNbr, , L_IRec.type_Sale, IRec.SrcNbr, IRec.DprtStrg, IRec.CarrFirm);
       LOOP
        IF ~OCCURE(IRec) THEN
         EXIT;
        END;
        IF SELECT(IRecL, TckNbr, IRec.IRec, L_IRec.knd_Sale, trgTckNbr, trgKKM) THEN
         (*஥  த   த*)
         asInCash:=0;
         asInSale:=L_TRS.tks_CashlessSales;
         EXIT;
        END;
        NEXT(IRec);
       END; (* LOOP ... *)
       RESTORE(IRecL);
       RESTORE(IRec);
      END;
     ELSE
      IF IRec.Type = L_IRec.type_Sale THEN
       (*ᮡ⢥ *)
       Num        :=0;
       Psg        :=0;
       Sum        :=0;
       ReturnedSum:=IRecL.TotalSum;
       IF IRecL.TicketK = L_IRec.tk_Baggage THEN
        Returned  :=0;
       ELSE
        Returned  :=IRecL.TckAmnt;
       END;
       asInCash:=IRecL.PayMth = L_IRec.paymth_Cash;
       asInSale:=L_TRS.tks_Prepayment;
      ELSE
       (*룮  *)
       Num        :=1;
       Psg        :=0;
       Sum        :=IRecL.TotalSum;
       ReturnedSum:=0;
       Returned   :=0;
       asInCash   :=0;
       asInSale   :=L_TRS.tks_Goods;
      END;
     END;
     OutTck_IRec("F", Num, Psg, Returned, Sum, ReturnedSum, asInCash, asInSale);
    END; (* IF ~!IRecL.TckAmnt & (IRecL.TckAmnt # 0) *)
    NEXT(IRecL);
   END; (* WHILE OCCURE(IRecL) ... *)
   NEXT(IRec);
  END; (* WHILE OCCURE(IRec) ... *)
 END {Tck01_GatherIRec};

 PRIVATE PROCEDURE Make(F: STRING[]);
 BEGIN
  Tck01_GatherIRec(Memo.ud_fr(), Memo.ud_ut());
  APP.Get().NewPrompt("ઠ  ");
  L_AFM.MakeIndex("trs", "TckRcS: LIKE(TckRcS.TckRcS)");
  SETSEL(RWayS, Date);
  SRCINSEL(RWayS, GE, , Memo.ud_fr());
  WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.ud_ut()) DO
   PROMPT(RWayS.RWayS);
   IF SELECT(TckRcJ, asRWayS, RWayS.RWayS) THEN
    WHILE OCCURE(TckRcJ) DO
     MakeOneTckRcS(F, TckRcJ.TckRcS);
     NEXT(TckRcJ);
    END; (* WHILE OCCURE(TckRcJ) ... *)
   END;
   IF SELECT(TckRcJ, asBoxNbr, RWayS.BoxNbr, RWayS.Date) THEN
    WHILE OCCURE(TckRcJ) DO
     IF !TckRcJ.asRWayS THEN
      MakeOneTckRcS(F, TckRcJ.TckRcS);
     END;
     NEXT(TckRcJ);
    END; (* WHILE OCCURE(TckRcJ) ... *)
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
  SETSEL(TckRcS, Date);
  SRCINSEL(TckRcS, GE, , Memo.ud_fr());
  WHILE OCCURE(TckRcS) & (TckRcS.Date <= Memo.ud_ut()) DO
   PROMPT(TckRcS.TckRcS);
   SAVE(TckRcS);
   MakeOneTckRcS(F, TckRcS.TckRcS);
   RESTORE(TckRcS);
   NEXT(TckRcS);
  END; (* WHILE OCCURE(TckRcS) ... *)
 END {Make};

 PUBLIC PROCEDURE Tck01();
  CONST
   bpId = "Tck01";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  L_bp.Begin(bpId, " ॠ樨 ஥ 㬥⮢", L_bp.t_Basis, L_General.tc_inIntvl);
  L_TRS.CheckDone(Memo.ud_fr() - 5, Memo.ud_ut());
  FIO.Open(F, L_General.NameConnection(bpId), "rep", Create);
  MakeTop("F");
  Make("F");
  FIO.Close(F);
  L_bp.End();
 END {Tck01};

END.
