(*
%Copyright   (c) Polak IT
%Author      05.09.2005 19:38:44 POLAK\Gina
%Purpose     ଫ   
%Type        report,operation
%Specific    AP
%Modified    22.09.2014 18:51:25 POLAK\San
%Environment
*)

 IMPORT Memo, L_General, L_TRS, L_Str, L_AFM, L_PDoc, L_XDoc, L_Staff, L_Dest,
        L_Pmnt, L_DatTim, L_MDoc, L_MathR, L_StdFrm, L_XObj, L_CUC, L_Acnt, L_AR,
        P_MDoc, P_Cntr, P_Firm, Str, E_Pmnt, E_TRS, L_Cntr,
        L_JDoc, L_Stock, L_IRec;

 PRIVATE CONST
  rt_Daily    = 0;
  rt_Periodic = 1;
  rt_tck40    = 2;

  RepAmount = 4;
  i_Cash = 0;
  i_Defc = 1;
  i_SurP = 2;
  i_Sale = 3;
  RepPool = "||誨|த ";

 PRIVATE VAR
  RepName  : STRING[];
  genPDocId: L_XDoc.tXDocCollection;
  IntvlStr : STRING[];
  MakeDoc  : SCAL[2];
  MakeRep  : SCAL[2][RepAmount];
  IntvlB,
  IntvlE   : DATE;
  RT       : SCAL[3];
  fr_SBD,
  ut_SED   : DATE;
  fr_SBT,
  ut_SET   : TIME;

(*
$P{ TopFirm:
P_Firm.FP_FirmName(MyFirm.Firm, SYSDATE()), L ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
?, C, ""
?, C, ""
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
|############################################################################|
}
*)

(*
$P{ TopDoc:
@
|============================================================================|
|                         ⥦ 㬥                       |
|----------------------------------------------------------------------------|
|㬥                | 樨              |      |        㬬|
|------------------------|--------------------------|----------|-------------|
}
*)

(*
$P{ Tck32_Top:
@
|============================================================================|
|㬥                | 樨              |      |             |
|------------------------|--------------------------|----------|-------------|
}
*)

(*
$P{ LineDoc:
?, L, ""
Dest.Dest, L, ""
Dest.Name, L, ""
?, L, "D.N.y"
?, R, ",2-"
@
|########################|### ######################|##########|#############|
}
*)

(*
$P{ BotDoc:
@
=(c) Polak====================================================================

}
*)

(*
$P{ TopRcS:
"த "+IntvlStr, C, ""
@
==============================================================================
|############################################################################|
|----------------------------------------------------------------------------|
|. |                           |    |      ||        㬬|
|-----|------------------------------|-------|----------|------|-------------|
}
*)

(*
$P{ TopRcS_1:
@
|----------------------------------------------------------------------------|
|                              ࠡ⠭                             |
|----------------------------------------------------------------------------|
|. |                           |    |      ||        㬬|
|-----|------------------------------|-------|----------|------|-------------|
}
*)

(*
$P{ LineRcS:
TckRcS.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
TckRcS.TckRcS, L, ""
TckRcS.Date, L, "D.N.y"
TckRcS.Status, L, "0"
?, R, ",2-"
@
|#####|##############################|#######|##########|  #   |#############|
}
*)

(*
$P{ BotRcS:
?, L, ""
?, R, ",2-"
@
|--------------------------------------------------------------|-------------|
|⮣ ########################################################|#############|
}
*)

(*
$P{ BotRcS_1:
@
=(c) Polak====================================================================

}
*)

(*
$P{ Top:
?, C, ""
@
==============================================================================
|############################################################################|
|----------------------------------------------------------------------------|
|. |                          |    |    |      |        㬬|
|-----|-----------------------------|-------|-------|----------|-------------|
}
*)

(*
$P{ Line:
TckRcS.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
TckRcC.TckRcC, L, ""
TckRcS.TckRcS, L, ""
TckRcS.Date, L, "D.N.y"
TckRcC.Total, R, ",2-"
@
|#####|#############################|#######|#######|##########|#############|
}
*)

(*
$P{ Bot:
?, R, ",2-"
@
|--------------------------------------------------------------|-------------|
|⮣                                                         |#############|
=(c) Polak====================================================================

}
*)

 PRIVATE PROCEDURE HasGeneratedPDoc(baseXDocId: L_XDoc.tXDocId): SCAL[2];
  VAR
   RefPDocs : L_XDoc.tXDocCollection;
   i, gpc   : NUMERIC[0];
   _XDocType: L_XDoc.tXDocType;
 BEGIN
  SETZERO(i, gpc);
  RefPDocs:=L_XDoc.GetAllDependentXDC(baseXDocId);
  WHILE L_XDoc.xdc_PositionOn(RefPDocs, i) & (gpc=0) DO
   _XDocType:=L_XDoc.ExtractXDocType(L_XDoc.xdc_Item(RefPDocs, i));
   IF    _XDocType = L_XDoc.xdt_PDoc THEN
    INC(gpc, PDoc.Status # L_PDoc.st_Canceled);
   ELSIF _XDocType = L_XDoc.xdt_MDoc THEN
    INC(gpc, MDoc.Status # L_MDoc.st_Canceled);
   END;
   INC(i);
  END; (* L_XDoc.xdc_PositionOn ... *)
  RETURN gpc > 0;
 END {HasGeneratedPDoc};

 PRIVATE PROCEDURE _FillPDocAbout();
  VAR
   pdComment: STRING[];
 BEGIN
  L_PDoc.SetPDocComment("");
  L_PDoc.FillPDocAbout();
  IF ((PDoc.PDocKind = L_PDoc.pd_PKO) | (PDoc.PDocKind = L_PDoc.pd_POO)) THEN
   IF !L_PDoc.GetPDocCommentPart(0) THEN
    L_PDoc.SetPDocCommentPart(0, " ");
   END;
   IF !L_PDoc.GetPDocCommentPart(2) THEN
    L_PDoc.SetPDocCommentPart(2, "窠  த " + IntvlStr);
   END;
  ELSIF ((PDoc.PDocKind = L_PDoc.pd_RKO) | (PDoc.PDocKind = L_PDoc.pd_OVN)) & !L_PDoc.GetPDocCommentPart(1) THEN
   IF !L_PDoc.GetPDocCommentPart(1) THEN
    L_PDoc.SetPDocCommentPart(1, "窠  த " + IntvlStr);
   END;
  ELSIF PDoc.PDocKind = L_PDoc.pd_VhP THEN
   pdComment:=L_PDoc.GetPDocComment();
   IF ~Str.Match(pdComment, "*" + "" + IntvlStr) THEN
    L_PDoc.SetPDocComment(pdComment + ". " + IntvlStr);
   END;
  END;
 END {_FillPDocAbout};

 PRIVATE PROCEDURE InsPDocList(_TSN: LIKE(PDocList.TSN); _Sum: LIKE(PDocList.Sum));
 BEGIN
  IF MakeDoc THEN
   IF ~ADD(PDocList, PDoc, PDoc.PDocKind, PDoc.PDoc, _TSN,
              PDocList.Sum, _Sum) THEN
    PDocList.PDocDate:=PDoc.Date;
    PDocList.State   :=L_PDoc.pdl_st_Paid;
    REPLACE(PDocList);
   END;
  END;
 END {InsPDocList};

 PRIVATE PROCEDURE InsPDoc(trgPDocKind: LIKE(PDoc.PDocKind); D: DATE);
 BEGIN
  IF MakeDoc THEN
   DEFAULT(PDoc);
   PDoc.PDocKind:=trgPDocKind;
   SETEMPTY(PDoc.PDoc);
   PDoc.Date    :=D; (* Insert_PDoc    PDoc.Date*)
   PDoc.MyFirm  :=MyFirm.MyFirm;
   L_PDoc.Insert_PDoc();
   PDoc.PrpDate :=PDoc.Date;
   IF    (trgPDocKind = L_PDoc.pd_POO) THEN
    L_General.Assert(L_PDoc.dodAssigned, " ⠭ 樮   㬮砭");
    L_General.Assert(L_PDoc.dodMyFirm = MyFirm.MyFirm, "樮   㬮砭   ⮩ ");
    PDoc.OwnAcnt:=L_PDoc.dodFirmAcnt;
    PDoc.Status  :=L_PDoc.st_Passed;
   ELSIF (trgPDocKind = L_PDoc.pd_VhP) THEN
    PDoc.Status  :=L_PDoc.st_Passed;
   ELSE
    PDoc.Status  :=L_PDoc.st_Prepared;
   END;
   SETZERO(PDoc.Total);
   IF (trgPDocKind = L_PDoc.pd_OVN) | (trgPDocKind = L_PDoc.pd_RKO) THEN
    PDoc.Dest    :=L_Dest.erkn_Get(PDoc.Date, L_Dest.erkn_CashMovement);
    PDoc.Firm    :=P_Firm.fomf(PDoc.MyFirm);
    IF trgPDocKind = L_PDoc.pd_OVN THEN
     P_Firm.AccessSilentFirmAcnt(PDoc.Firm, D);
     PDoc.OwnAcnt:=FirmAcnt.FirmAcnt;
    END;
   ELSE
    PDoc.Dest   :=L_Dest.PDocwMDocDest();
    PDoc.Firm   :=Contract.Firm;
   END;
   PDoc.Source  :=L_PDoc.src_Auto;
   PDoc.Type    :=L_PDoc.typ_Other;
   PDoc.Done    :=0;
  END;
 END {InsPDoc};

 PRIVATE PROCEDURE Add_genPDocId(DocId: L_XDoc.tXDocId);
 BEGIN
  IF MakeDoc THEN
   IF !genPDocId THEN
    genPDocId:=DocId;
   ELSE
    genPDocId:=genPDocId+"|"+DocId;
   END;
  END;
 END {Add_genPDocId};

 PRIVATE PROCEDURE Docs_OnAnyModification(Collection: L_XDoc.tXDocCollection);
  VAR
   i: NUMERIC[0];
   _XDocId  : L_XDoc.tXDocId;
   _XDocType: L_XDoc.tXDocType;
 BEGIN
  i:=0;
  WHILE i < L_XDoc.xdc_Count(Collection) DO
   _XDocId:=L_XDoc.xdc_Item(Collection, i);
   _XDocType:=L_XDoc.ExtractXDocType(_XDocId);
   L_XDoc.PositionOnXDoc(_XDocId);
   IF    _XDocType = L_XDoc.xdt_PDoc THEN
    L_PDoc.PDoc_OnAnyModification(+1, L_PDoc.np_No, 0);
   ELSIF _XDocType = L_XDoc.xdt_MDoc THEN
    L_MDoc.MDoc_OnAnyModification(+1, L_MDoc.np_No, 0);
   ELSE
    L_General.CallUs(0);
   END;
   INC(i);
  END;
 END {Docs_OnAnyModification};

 PRIVATE PROCEDURE CompletePDoc(_Total: LIKE(PDoc.Total));
 BEGIN
  _FillPDocAbout();
  PDoc.Total:=_Total;
  REPLACE(PDoc);
  Add_genPDocId(L_XDoc.curXDocId(L_XDoc.xdt_PDoc));
 END {CompletePDoc};

 PRIVATE PROCEDURE InsMDL(_Math: LIKE(Math.Math); _Cir0: LIKE(MDocList.Sum); _VAT: LIKE(MDocList.VAT));
 BEGIN
  IF _Cir0 # 0 THEN
   L_General.CallUs(SEARCH(Math, Math, _Math));
   IF SELECT(MDocList, MDLMath, MDoc.MDocKind, MDoc.MDoc, Math.Math) THEN
    INC(MDocList.Sum, _Cir0);
    INC(MDocList.VAT,    _VAT);
    REPLACE(MDocList);
    INC(MDoc.Total, _Cir0+_VAT);
    REPLACE(MDoc);
   ELSE
    L_MDoc.InsMDocList(Math.Math,
                       L_MathR.mm_New,
                       EMPTYOF(MDocList.VATMode),
                       1,
                       _Cir0,
                       _VAT);
   END;
  END;
 END {InsMDL};

 PRIVATE PROCEDURE Generate_MDoc(trgMDocKind: LIKE(MDoc.MDocKind); D: DATE);
 BEGIN
  L_General.Assert(SEARCH(MDocKind, MDocKind, trgMDocKind), " 㬥 "+trgMDocKind+" "+L_MDoc.MDocKindNick(trgMDocKind, 1)+"   ࠢ筨");
  DEFAULT(MDoc);
  MDoc.MDocKind:=MDocKind.MDocKind;
  MDoc.MyFirm  :=P_Firm.mf_Fict; (*ࠢ  MDoc_OnAnyModification*)
  MDoc.Date    :=D;
  L_MDoc.Insert_MDoc();
  MDoc.SrcDate :=MDoc.Date;
  MDoc.PayDate :=L_Pmnt.E_DefineMDocPayDate();
  MDoc.Contract:=Contract.Contract;
  MDoc.Firm    :=Contract.Firm;
  MDoc.TSN     :=L_MDoc.curUSER2MDocTSN(0);
  MDoc.Dest    :=L_Dest.erkn_Get(MDoc.Date, L_Dest.erkn_TckProceeds);
  IF trgMDocKind = L_MDoc.md_VOD THEN
   MDoc.Status  :=L_MDoc.st_Passed;
  ELSE
   MDoc.Status  :=L_MDoc.st_Prepared;
  END;
  REPLACE(MDoc);

  P_MDoc.SetMDocPro(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Note, "த "+IntvlStr);
  IF trgMDocKind=L_MDoc.md_OBK THEN
   P_MDoc.SetMDocPro(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_DealCheckType, L_Str.PoolItem(P_MDoc.GetMDocProPool(P_MDoc.P_DealCheckType), 1));
   DEFAULT(JDoc);
   JDoc.JDocKind:=L_JDoc.jd_MDoc;
   JDoc.Date    :=D;
   JDoc.SrcDate :=D;
   JDoc.MyFirm  :=MyFirm.MyFirm;
   JDoc.SubstAM :=1;
   JDoc.CopyCnt :=01;
   JDoc.Status  :=L_JDoc.st_Prepared;
   JDoc.Done    :=0;
   L_JDoc.Insert_JDoc();
   L_XDoc.rf_coreInsert(JDoc.XDocId, L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.rft_Annex);
  END;
  Add_genPDocId(L_XDoc.curXDocId(L_XDoc.xdt_MDoc));
 END {Generate_MDoc};

 PRIVATE PROCEDURE E_Tck30_GeneratePOO(): SCAL[2];
 BEGIN
  RETURN L_General.GetAPSiteNumber() = 84;
 END {E_Tck30_GeneratePOO};

 PRIVATE PROCEDURE Date4PDoc(trgPDocKind: LIKE(PDoc.PDocKind); D: DATE): DATE;
  VAR
   model: NUMERIC[0];
 BEGIN
  IF E_Tck30_GeneratePOO() THEN
   model:=1;
  ELSIF (L_General.GetAPSiteNumber() = 21) |
        (L_General.GetAPSiteNumber() = 26) |
        (L_General.GetAPSiteNumber() = 55) THEN
   model:=3;
  ELSE
   model:=2;
  END;
  IF    trgPDocKind = L_PDoc.pd_PKO THEN
   IF    (model = 2) | (model = 3) THEN
    RETURN D;
   END;
  ELSIF trgPDocKind = L_PDoc.pd_POO THEN
   IF    model = 1 THEN
    RETURN D;
   END;
  ELSIF trgPDocKind = L_PDoc.pd_RKO THEN
   IF    model = 2 THEN
    RETURN D;
   ELSIF model = 3 THEN
    RETURN D+1;
   END;
  ELSIF trgPDocKind = L_PDoc.pd_OVN THEN
   IF    (model = 2) | (model = 3) THEN
    RETURN L_DatTim.IncWorkDay(D, +1);
   END;
  END;
 END {Date4PDoc};

 PRIVATE PROCEDURE Generate_PDoc(trgType    : LIKE(TckRcC.Type);
                                 trgPDocKind: LIKE(PDoc.PDocKind);
                                 WithPrint  : SCAL[2];
                                 D          : DATE);
  VAR
   T_Sum : NUMERIC[2];
   rko_Id: L_XDoc.tXDocId;
 BEGIN
  IF WithPrint & MakeRep[trgType] THEN
   MAKEPART(R, Top, L_Str.PoolItem(RepPool, trgType) + IntvlStr);
  END;
  T_Sum:=0;
  IF SELECT(Tmp01, Tmp01, MyFirm.MyFirm, trgType) THEN
   InsPDoc(trgPDocKind, D);
   WHILE OCCURE(Tmp01) DO
    IF ~WithPrint THEN
     NARROWSEL(Tmp01, Date, TSN);
    END;
    WHILE OCCURE(Tmp01) DO
     L_General.Assert(SEARCH(TckRcC, TckRcC, Tmp01.TckRcC), " " + Tmp01.TckRcC + " ");
     INC(T_Sum, TckRcC.Total);
     IF MakeDoc THEN
      L_XDoc.rf_coreInsert(L_XDoc.curXDocId(L_XDoc.xdt_PDoc),
                           L_XDoc.curXDocId(L_XDoc.xdt_TckRcC), L_XDoc.rft_BaseOn);
      IF (trgPDocKind # L_PDoc.pd_PKO) & (trgPDocKind # L_PDoc.pd_POO) THEN
       InsPDocList(TckRcC.TSN, TckRcC.Total);
      END;
     END;
     IF WithPrint & MakeRep[trgType] THEN
      CONFORM(TckRcC, TckRcS);
      CONFORM(TckRcC, Staff);
      CONFORM(Staff, Man);
      MAKEPART(R, Line);
     END;
     NEXT(Tmp01);
    END; (* WHILE OCCURE(Tmp01) ... *)
    IF ~WithPrint THEN
     NEXTINEXTENDEDSEL(Tmp01, Date, TSN);
    END;
   END; (* WHILE OCCURE(Tmp01) ... *)
 
   IF MakeDoc THEN
    InsMDL(E_Pmnt.MathForPayment(MDoc.Date), T_Sum, 0);
    L_Pmnt.InsPDocMDoc(MDoc.MDocKind, MDoc.MDoc, T_Sum, 0, 0);
    CompletePDoc(T_Sum);
 
    IF (trgPDocKind = L_PDoc.pd_PKO) THEN
     InsPDoc(L_PDoc.pd_RKO, Date4PDoc(L_PDoc.pd_RKO, D));
     CompletePDoc(T_Sum);
     rko_Id:=L_XDoc.curXDocId(L_XDoc.xdt_PDoc);
     InsPDoc(L_PDoc.pd_OVN, Date4PDoc(L_PDoc.pd_OVN, D));
     L_XDoc.rf_coreInsert(L_XDoc.curXDocId(L_XDoc.xdt_PDoc), rko_Id, L_XDoc.rft_BaseOn);
     CompletePDoc(T_Sum);
    END;
   END;
  END;
  IF WithPrint & MakeRep[trgType] THEN
   MAKEPART(R, Bot, T_Sum);
  END;
 END {Generate_PDoc};

 PRIVATE PROCEDURE TckRcSIsMissed(): SCAL[2];
 BEGIN
  RETURN ~TckRcS.Done;
 END {TckRcSIsMissed};

 PRIVATE PROCEDURE GetAdjustedTckRcSTotSale(): NUMERIC[2];
  VAR
   SalesSum: NUMERIC[2];
 BEGIN
  SalesSum:=0;
  CONFORM(TckRcS, TckRcT);
  WHILE OCCURE(TckRcT) DO
   CONFORM(TckRcT, TckKind);
   IF TckKind.InSale > L_TRS.tks_Void THEN
    INC(SalesSum, TckRcT.ExpSum - TckRcT.RSum);
   END;
   NEXT(TckRcT);
  END; (* WHILE OCCURE(TckRcT) ... *)
  RETURN SalesSum;
 END {GetAdjustedTckRcSTotSale};

 PRIVATE PROCEDURE PrintMissed();
 BEGIN
  MAKEPART(R, TopRcS_1);
  SELECT(OBK01, OBK01, , MyFirm.MyFirm);
  WHILE OCCURE(OBK01) DO
   L_General.Assert(SEARCH(TckRcS, TckRcS, OBK01.TckRcS), " "+OBK01.TckRcS+" ");
   IF TckRcSIsMissed() THEN
    CONFORM(TckRcS, Staff, Man);
    MAKEPART(R, LineRcS, GetAdjustedTckRcSTotSale());
   END; (* IF TckRcS.Status... *)
   NEXT(OBK01);
  END; (* WHILE OCCURE(OBK01) ... *)
 END {PrintMissed};

 PRIVATE PROCEDURE GetAdjustedTckRcJTotTInc(VAR _SumByTckRcS: LIKE(TckRcJ.Sum));
  VAR
   PrvNbrs    : LIKE(TckRcJ.TckNbrs);
   PrvPsg     : LIKE(TckRcJ.TckPsg);
   i          : NUMERIC[0];
   PsgByTckRcJ: LIKE(TckRcJ.Psg);
   SumByTckRcJ: LIKE(TckRcJ.Sum);
   Amount     : NUMERIC[0];
 BEGIN
  _SumByTckRcS:=0;
  L_TRS.GetPrvJobInfo(PrvNbrs, PrvPsg);

  i:=0;
  WHILE i <= HIGH(TckRcJ.TckNbrs) DO
   IF ~!TckRcJ.TckNbrs[i] & ((TckRcJ.TckNbrs[i] # PrvNbrs[i]) | (TckRcJ.TckPsg[i] # PrvPsg[i])) THEN
    SELECT(TckRcT, Number, , TckRcS.TckRcS, i + 1);
    CONFORM(TckRcT, TckKind);
    IF TckKind.InSale > L_TRS.tks_Void THEN
     L_TRS.Calc2NumbersDifference(TckKind.TckKind, PrvNbrs[i], TckRcJ.TckNbrs[i], Amount, SumByTckRcJ);
     IF TckKind.Type = L_TRS.tkt_ZonalTicket THEN
      DEC(SumByTckRcJ, TckRcJ.TckRAmnt[i]);
     ELSE
      DEC(SumByTckRcJ, TckRcJ.TckRAmnt[i] * TckKind.FaceVal);
     END;
     IF    L_TRS.IsMainTckKind(TckKind.TckKind, TckRcS.Date, TckRcJ.Route) | L_TRS.TckKind_wPsg() THEN
      PsgByTckRcJ:=TckRcJ.TckPsg[i] - PrvPsg[i] - TckRcJ.TckRPsg[i];
     ELSIF L_TRS.E_NeedAutoTaxTckRcJR(TckRcS.Date) &
           SEARCH(TckRcJR, TckRcS, TckRcJ.TckRcS, TckRcJ.Day, TckRcJ.StartT, TckKind.TckKind) THEN
      PsgByTckRcJ:=TckRcJR.Psg;
     ELSE
      PsgByTckRcJ:=0;
     END;
     E_TRS.Tck30_PutSingleTckKindByTckRcJ(TckRcS.Date, SumByTckRcJ, PsgByTckRcJ);
     INC(_SumByTckRcS, SumByTckRcJ);
    END;
   END;
   INC(i);
  END;
 END {GetAdjustedTckRcJTotTInc};

 PRIVATE PROCEDURE GetXObjectOfObject(    D       : DATE;
                                          _MyFirm : LIKE(MyFirm.MyFirm);
                                          _Origin : L_XObj.tOrigin;
                                          _Object : L_XDoc.tXDoc;
                                      VAR _XObject: LIKE(XObject.XObject);
                                      VAR _AcCut  : LIKE(AcCut.AcCut));
 BEGIN
  IF    _Origin = L_XObj.o_Contract THEN
   SAVE(Contract);
   L_General.Assert(SEARCH(Contract, Contract, _Object) & Contract.Leaf, "୮ 祭   " + _Object);
   _XObject:=Contract.XObject;
   _AcCut:=L_Acnt.GetSpecificAcCutForContract(Contract.Contract, L_Acnt.acp_Contract_Netto);
   RESTORE(Contract);
  ELSIF _Origin = L_XObj.o_CostItem THEN
   SAVE(CostItem);
   L_General.Assert(SEARCH(CostItem, CostItem, _Object) & CostItem.Leaf, "୮ 祭   " + _Object);
   _XObject:=CostItem.XObject;
   _AcCut:=L_Acnt.GetSpecificAcCutForCostItem(CostItem.CostItem, L_Acnt.acp_CostItemSale);
   RESTORE(CostItem);
  ELSIF _Origin = L_XObj.o_Math THEN
   L_MathR.AccessMath(_Object);
   L_Stock.Obtain_mItem(Math.Math, L_Stock.Obtain_MyFirmStorage(_MyFirm, D));
   _XObject:=mItem.XObject;
   _AcCut:=L_Acnt.GetSpecificAcCutForMTMM(D, Math.MathType, L_MathR.mm_New, L_Acnt.acp_MathSale_VAT);
  ELSE
   L_General.CallUs(0);
  END;
 END {GetXObjectOfObject};

 PRIVATE PROCEDURE NormalizeOBK02(); (*ᣮ 譮⥩ 㣫 -  *)
  VAR
   Tails: L_TRS.tOBK02Sum;
   maxSum,
   _Sum : NUMERIC[2];
 BEGIN
  SELECT(OBK02, OBK02);
  WHILE OCCURE(OBK02) DO
   NARROWSEL(OBK02, MyFirm, Math, dOrigin, dObject);
   Tails:=0;
   maxSum:=0;
   WHILE OCCURE(OBK02) DO
    _Sum:=OBK02.Sum;
    INC(Tails,  OBK02.Sum-_Sum);
    OBK02.Sum:=_Sum;
    REPLACE(OBK02);
    IF OBK02.Sum > maxSum THEN
     maxSum:=OBK02.Sum;
    END;
    NEXT(OBK02);
   END; (* WHILE OCCURE(OBK02) ... *)
   IF Tails # 0 THEN
    FIRST(OBK02);
    WHILE OCCURE(OBK02) DO
     IF OBK02.Sum = maxSum THEN
      INC(OBK02.Sum, Tails);
      REPLACE(OBK02);
      _Sum:=OBK02.Sum;
      L_General.CallUs(_Sum = OBK02.Sum);
      LAST(OBK02);
     END;
     NEXT(OBK02);
    END; (* WHILE OCCURE(OBK02) ... *)
   END;
   NEXTINEXTENDEDSEL(OBK02, MyFirm, Math, dOrigin, dObject);
  END; (* WHILE OCCURE(OBK02) ... *)
 END {NormalizeOBK02};

 PRIVATE PROCEDURE Generate_OBK(WithPrint: SCAL[2]);
  VAR
   TckRcJ_Sum,
   TckRcS_Sum,
   T_Sum      : NUMERIC[2];
   missedCount: NUMERIC[0];
   missedTckRcS: LIKE(TckRcS.TckRcS);
   summaryMsg : STRING[];
   First,
   _VAT       : LIKE(MDocList.VAT);
 BEGIN
  L_General.Assert(~!PROCREF(E_TRS.Tck30_PutSingleTckKindByTckRcJ), "  ஥");

  TRY
   SETZERO(T_Sum, missedCount); SETEMPTY(missedTckRcS);
   IF WithPrint & MakeRep[i_Sale] THEN
    MAKEPART(R, TopRcS);
   END;
   Generate_MDoc(L_MDoc.md_OBK, IntvlE);
   SELECT(OBK02, OBK02);
   REMSEL(OBK02);
   SELECT(OBK01, OBK01, , MyFirm.MyFirm);
   WHILE OCCURE(OBK01) DO
    L_General.Assert(SEARCH(TckRcS, TckRcS, OBK01.TckRcS), " "+OBK01.TckRcS+" ");
    PROMPT(": "+OBK01.TSN+" : "+TckRcS.TckRcS+" "+L_DatTim.DateStr(TckRcS.Date));
    IF ~TckRcSIsMissed() THEN
     TckRcS_Sum:=0;
     SELECT(TckRcJ, TckRcS, , TckRcS.TckRcS);
     WHILE OCCURE(TckRcJ) DO
      CONFORM(TckRcJ, Route);
      GetAdjustedTckRcJTotTInc(TckRcJ_Sum);
      INC(TckRcS_Sum, TckRcJ_Sum);
      NEXT(TckRcJ);
     END; (* WHILE OCCURE(TckRcJ) ... *)
     L_General.CallUs(TckRcS_Sum = GetAdjustedTckRcSTotSale());
     INC(T_Sum, TckRcS_Sum);
     IF WithPrint & MakeRep[i_Sale] THEN
      CONFORM(TckRcS, Staff, Man);
      MAKEPART(R, LineRcS, TckRcS_Sum);
     END;
     L_XDoc.rf_coreInsert(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.curXDocId(L_XDoc.xdt_TckRcS), L_XDoc.rft_BaseOn);
    ELSE
     INC(missedCount);
     IF !missedTckRcS THEN
      missedTckRcS:=TckRcS.TckRcS;
     END;
    END; (* IF ~TckRcSIsMissed()... *)
    NEXT(OBK01);
   END; (* WHILE OCCURE(OBK01) ... *)
   IF WithPrint & MakeRep[i_Sale] THEN
    IF missedCount > 0 THEN
     summaryMsg:=" " + L_Str.IntStr(missedCount) + " !";
    ELSE
     summaryMsg:="";
    END;
    MAKEPART(R, BotRcS, summaryMsg, T_Sum);
    IF missedCount > 0 THEN
(*
     summaryMsg:=" ࠡ⠭ , ਬ "+missedTckRcS+"|㬥  ନ஢ "+summaryMsg;
     IF MyFirm.MyFirm > P_Firm.mf_Own THEN
      summaryMsg:=" "+MyFirm.Name+"|"+summaryMsg;
     END;
     L_StdFrm.Question(summaryMsg);
*)
     PrintMissed();
    END;
    MAKEPART(R, BotRcS_1);
   END;
 
   SETZERO(T_Sum);
   IF WithPrint & MakeRep[i_SurP] THEN
    MAKEPART(R, Top, "誨"+IntvlStr);
   END;
   SELECT(Tmp01, Tmp01, , MyFirm.MyFirm, L_TRS.trct_SurPlusAct);
   WHILE OCCURE(Tmp01) DO
    L_General.Assert(SEARCH(TckRcC, TckRcC, Tmp01.TckRcC), " "+Tmp01.TckRcC+" ");
    L_XDoc.rf_coreInsert(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.curXDocId(L_XDoc.xdt_TckRcC), L_XDoc.rft_BaseOn);
    E_TRS.Tck30_PutSurplus(TckRcC.Date, TckRcC.Total);
    INC(T_Sum, TckRcC.Total);
    IF WithPrint & MakeRep[i_SurP] THEN
     CONFORM(TckRcC, TckRcS);
     CONFORM(TckRcS, Staff, Man);
     MAKEPART(R, Line);
    END;
    NEXT(Tmp01);
   END; (* WHILE OCCURE(Tmp01) ... *)
   IF WithPrint & MakeRep[i_SurP] THEN
    MAKEPART(R, Bot, T_Sum);
   END;
   NormalizeOBK02();
   IF SELECT(OBK02, OBK02, MyFirm.MyFirm) THEN
    WHILE OCCURE(OBK02) DO
     _VAT:=0;
     IF OBK02.toMDL THEN
      L_General.CallUs(~!OBK02.Math);
      IF P_Cntr.GetSpecialAttitudeToVAT(MDoc.Contract, MDoc.Date) = P_Cntr.satVAT_woFeatures THEN
       _VAT:=L_Acnt.GetInclMathVAT(OBK02.Math, MDoc.Date, OBK02.Sum);
      END;
      InsMDL(OBK02.Math, OBK02.Sum-_VAT, _VAT);
     END;
     JDocList.JDocKind:=JDoc.JDocKind;
     JDocList.JDoc    :=JDoc.JDoc;
     SETEMPTY(JDocList.JDLNbr);
     GetXObjectOfObject(JDoc.Date, MyFirm.MyFirm, OBK02.dOrigin, OBK02.dObject, JDocList.XObject, JDocList.AcCut);
     JDocList.Apport  :=L_Acnt.E_Apport_MoneyDebit(JDoc.Date);
     GetXObjectOfObject(JDoc.Date, MyFirm.MyFirm, OBK02.cOrigin, OBK02.cObject, JDocList.XObject2, JDocList.AcCut2);
     JDocList.Apport2 :=L_Acnt.E_Apport_MoneyCredit(JDoc.Date);
     SETZERO(JDocList.Qnt, JDocList.wQnt, JDocList.wQnt2);
     JDocList.Sum     :=OBK02.Sum-_VAT;
     JDocList.Date    :=JDoc.Date;
     JDocList.DoneDTS :=JDoc.DoneDTS;
     INSERT(JDocList);
     IF _VAT # 0 THEN
      SETEMPTY(JDocList.JDLNbr);
      GetXObjectOfObject(JDoc.Date, MyFirm.MyFirm, L_XObj.o_Math, OBK02.Math, JDocList.XObject2, JDocList.AcCut2);
      JDocList.Sum     :=_VAT;
      INSERT(JDocList);
     END;
     NEXT(OBK02);
    END; (* WHILE OCCURE(OBK02) ... *)
    IF ~MakeDoc THEN
     L_General.RaiseLockReleaseException();
    END;
   ELSE
    L_General.RaiseLockReleaseException();
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
 END {Generate_OBK};

 PRIVATE PROCEDURE SelectJrn(_XDocType: L_XDoc.tXDocType; _XDocKind: LIKE(XDocJrn.XDocKind); _XDoc: LIKE(XDocJrn.XDoc)): SCAL[2];
 BEGIN
  IF SELECT(XDocJrn, XDocJrn, _XDocType, _XDocKind, _XDoc) THEN
   RETURN 1;
  ELSE
   L_XDoc.CheckXDocJrnNeed(_XDocType, _XDocKind, _XDoc);
   RETURN 0;
  END;
 END {SelectJrn};

 PRIVATE PROCEDURE _JrnHasValidAction(_XDocType: L_XDoc.tXDocType;
                              _XDocKind: LIKE(XDocJrn.XDocKind);
                              _XDoc    : LIKE(XDocJrn.XDoc);
                              SrcAction: LIKE(XDocJrn.Action)): SCAL[2];
 BEGIN
  IF SelectJrn(_XDocType, _XDocKind, _XDoc) THEN
   LAST(XDocJrn);
   WHILE OCCURE(XDocJrn) DO
    IF    XDocJrn.Action = SrcAction THEN
     RETURN 1;
    END;
    PREV(XDocJrn);
   END; (* WHILE OCCURE(XDocJrn) ... *)
  END;
  RETURN 0;
 END {_JrnHasValidAction};

 PRIVATE PROCEDURE SetTicketKassaShiftParam(IntvlB, IntvlE: DATE);
  VAR
   DummyD: DATE;
   DummyT: TIME;
 BEGIN
  L_TRS.SetupTicketKassaShiftBorders(IntvlB, fr_SBD, DummyD, fr_SBT, DummyT);
  L_TRS.SetupTicketKassaShiftBorders(IntvlE, DummyD, ut_SED, DummyT, ut_SET);
  L_General.Assert(IntvlE < L_TRS.GetTRDOnDate(), " " + L_DatTim.DateStr(IntvlE) + "   稫");
 END {SetTicketKassaShiftParam};

 PRIVATE PROCEDURE SetCashOfficeShiftParam(IntvlB, IntvlE: DATE);
  VAR
   DummyD: DATE;
   DummyT: TIME;
 BEGIN
  L_TRS.SetupShiftBorders(IntvlB, fr_SBD, DummyD, fr_SBT, DummyT);
  L_TRS.SetupShiftBorders(IntvlE, DummyD, ut_SED, DummyT, ut_SET);
  L_General.Assert(~!ut_SET, " " + L_DatTim.DateStr(IntvlE) + "   稫");
 END {SetCashOfficeShiftParam};

 PRIVATE PROCEDURE MakeTmpFile();
 BEGIN
  L_AFM.MakeMultipleIndex("Tmp01", "MyFirm: SCAL[1E4];"+
                                   "Type  : LIKE(TckRcC.Type);"+
                                   "TSN   : LIKE(TckRcC.TSN);"+
                                   "TckRcC: LIKE(TckRcC.TckRcC);"+
                                   "Date  : DATE",
                                "Tmp01: MyFirm, Type, Date, TSN, TckRcC;"+
                                "Date : Date");

  L_AFM.MakeIndex        ("OBK01", "MyFirm: SCAL[1E4];"+
                                   "TSN   : LIKE(TckRcS.TSN);"+
                                   "TckRcS: LIKE(TckRcS.TckRcS)");

  L_AFM.MakeMultipleIndex("OBK02", "MyFirm : LIKE(MyFirm.MyFirm);"+
                                   "Math   : LIKE(Math.Math);"+
                                   "dOrigin:" + TYPENAMEOF(L_XObj.tOrigin)  + ";" +
                                   "dObject:" + TYPENAMEOF(L_XDoc.tXDoc)    + ";" +
                                   "cOrigin:" + TYPENAMEOF(L_XObj.tOrigin)  + ";" +
                                   "cObject:" + TYPENAMEOF(L_XDoc.tXDoc)    + ";" +
                                   "toMDL  : SCAL[2];" +
                                   "Sum    :" + TYPENAMEOF(L_TRS.tOBK02Sum),
                                "OBK02: MyFirm, Math, dOrigin, dObject, cOrigin, cObject, toMDL");
  IF RT = rt_Daily THEN
   SetCashOfficeShiftParam(IntvlB, IntvlE);
   SETSEL(TckRcC, Date);
   SRCINSEL(TckRcC, GE, , IntvlB);
   WHILE OCCURE(TckRcC) & (TckRcC.Date <= IntvlE) DO
    PROMPT(" "+TckRcC.TckRcC+" "+L_DatTim.DateStr(TckRcC.Date));
    IF (TckRcC.Status # L_TRS.trcStat_Canceled) &
       ((TckRcC.Type = L_TRS.trct_CashAccept) | (TckRcC.Type = L_TRS.trct_DeficitAct)) &
       ~HasGeneratedPDoc(L_XDoc.curXDocId(L_XDoc.xdt_TckRcC)) THEN
     CONFORM(TckRcC, Staff);
     ADD(Tmp01, Tmp01, , L_Staff.GetStaffMyFirm(), TckRcC.Type, TckRcC.Date, TckRcC.TSN, TckRcC.TckRcC);
    END;
    NEXT(TckRcC);
   END; (* WHILE OCCURE(TckRcC) ... *)
  ELSE
   SetTicketKassaShiftParam(IntvlB, IntvlE);
   SETSEL(TckRcS, Done, 0);
   IF SRCINSEL(TckRcS, GE, IntvlB) & (TckRcS.Date <= IntvlE) THEN
    L_StdFrm.Question(" ࠡ⠭ , ਬ " + TckRcS.TckRcS);
   END;
   SETSEL(TckRcS, Date);
   SRCINSEL(TckRcS, GE, , IntvlB);
   WHILE OCCURE(TckRcS) & (TckRcS.Date<=IntvlE) DO
    PROMPT(" "+TckRcS.TckRcS+" "+L_DatTim.DateStr(TckRcS.Date));
    SELECT(TckRcC, TckRcS, , TckRcS.TckRcS);
    WHILE OCCURE(TckRcC) DO
     IF (TckRcC.Status # L_TRS.trcStat_Canceled) & (TckRcC.Type = L_TRS.trct_SurPlusAct) &
        ~HasGeneratedPDoc(L_XDoc.curXDocId(L_XDoc.xdt_TckRcC)) THEN
      CONFORM(TckRcC, Staff);
      ADD(Tmp01, Tmp01, , L_Staff.GetStaffMyFirm(), TckRcC.Type, TckRcC.Date, TckRcC.TSN, TckRcC.TckRcC);
     END;
     NEXT(TckRcC);
    END; (* WHILE OCCURE(TckRcC) ... *)
    IF ~HasGeneratedPDoc(L_XDoc.curXDocId(L_XDoc.xdt_TckRcS)) THEN
     CONFORM(TckRcS, Staff);
     ADD(OBK01, OBK01, , L_Staff.GetStaffMyFirm(), TckRcS.TSN, TckRcS.TckRcS);
    END;
    NEXT(TckRcS);
   END; (* WHILE OCCURE(TckRcS) ... *)
  END; (* IF RT = ... *)
 END {MakeTmpFile};

 PRIVATE PROCEDURE PrintDoc();
  VAR
   i        : NUMERIC[0];
   _XDocType: L_XDoc.tXDocType;
   _XDI     : L_XDoc.tXDocId;
 BEGIN
  MAKEPART(R, TopFirm,
              L_Str.PoolItem("祭 㬥⮢  ନ஢|⮪ ନ஢", MakeDoc)
              + " " + L_Str.PoolItem("⥦ 㬥⮢  ⭮ ||㬥⮢  த ", RT),
              IntvlStr);
  IF MakeDoc THEN
   MAKEPART(R, TopDoc);
   i:=0;
   WHILE L_XDoc.xdc_PositionOn(genPDocId, i) DO
    _XDI:=L_XDoc.xdc_Item(genPDocId, i);
    _XDocType:=L_XDoc.ExtractXDocType(_XDI);
    IF    _XDocType = L_XDoc.xdt_PDoc THEN
     CONFORM(PDoc, Dest);
     MAKEPART(R, LineDoc, L_XDoc.XDocStr(_XDI), PDoc.Date, PDoc.Total);
    ELSIF _XDocType = L_XDoc.xdt_MDoc THEN
     CONFORM(MDoc, Dest);
     MAKEPART(R, LineDoc, L_XDoc.XDocStr(_XDI), MDoc.Date, MDoc.Total);
    ELSE
     L_General.Error(" 㬥 " + _XDocType + "  ।");
    END;
    INC(i);
   END;
   MAKEPART(R, BotDoc);
  END;
 END {PrintDoc};

 PRIVATE PROCEDURE UserChoice();
 BEGIN
  MakeDoc:=1;
  IF RT = rt_Daily THEN
   MakeRep[i_Cash]:=1;
   MakeRep[i_Defc]:=1;
   STDFORM(L_StdFrm.sf_Confirm("|" + IntvlStr +
                               "||%############################%" +
                               "||ନ஢ ᯨ᪨ 㬥⮢:" +
                               "||%############################%" +
                               "||%############################%",
                               "%<ନ஢ 㬥>"+ L_Str.PoolItem("NE|E", MakeDoc) +
                               "%<" + L_Str.PoolItem(RepPool, i_Cash) + ">E" +
                               "%<" + L_Str.PoolItem(RepPool, i_Defc) + ">E"),
           " ନ஢ 㬥⮢   ",
           QUESTION,
           ,
           MakeDoc,  MakeRep[i_Cash], MakeRep[i_Defc]);
  ELSE
   MakeRep[i_SurP]:=1;
   MakeRep[i_Sale]:=1;
   STDFORM(L_StdFrm.sf_Confirm("|" + IntvlStr +
                               "||%############################%" +
                               "||ନ஢ ᯨ᪨ 㬥⮢:" +
                               "||%############################%" +
                               "||%############################%",
                               "%<ନ஢ 㬥>"+ L_Str.PoolItem("NE|E", MakeDoc) +
                               "%<" + L_Str.PoolItem(RepPool, i_SurP) + ">E" +
                               "%<" + L_Str.PoolItem(RepPool, i_Sale) + ">E"),
           " ନ஢ 㬥⮢   ",
           QUESTION,
           ,
           MakeDoc,  MakeRep[i_SurP], MakeRep[i_Sale]);
  END;
 END {UserChoice};

 PRIVATE PROCEDURE blin_PurgeTmpFiles();
 BEGIN
  L_AFM.AF_PurgeTemp("Tmp01");
  L_AFM.AF_PurgeTemp("OBK01");
  L_AFM.AF_PurgeTemp("OBK02");
 END {blin_PurgeTmpFiles};

 PRIVATE PROCEDURE Make();
  VAR
   _MakeDoc     : SCAL[2];
   _genPDocId   : L_XDoc.tXDocCollection;
   D            : DATE;
   CashAcceptPDK: LIKE(PDocKind.PDocKind);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode  :=adm_SOFT;
  TABLE.Get("XDocRef").AccessDataMode:=adm_RIDGE;
  TABLE.Get("MDoc").AccessDataMode   :=adm_RIDGE;
  TABLE.Get("PDoc").AccessDataMode   :=adm_RIDGE;

  UserChoice();

  MakeTmpFile();

  IF (AMOUNT(Tmp01) + AMOUNT(OBK01)) > 0 THEN
   SETEMPTY(_genPDocId);
   _MakeDoc:=MakeDoc;
   OPENREP(R, L_General.NameConnection(RepName), Create);
   SELECT(MyFirm, MyFirm);
   WHILE OCCURE(MyFirm) DO
    IF SELECT(Tmp01, Tmp01, MyFirm.MyFirm) | SELECT(OBK01, OBK01, MyFirm.MyFirm) THEN
     IF LINENUM(R)>0 THEN
      FORMFEED(R);
     END;
     SEARCH(Contract, Contract, , L_Cntr.erkn_Get(IntvlE, L_Cntr.erkn_TckRcSale, MyFirm.MyFirm));
     SETEMPTY(genPDocId);
     MakeDoc:=_MakeDoc;
     IF RT = rt_Daily THEN
      IF E_Tck30_GeneratePOO() THEN
       CashAcceptPDK:=L_PDoc.pd_POO;
      ELSE
       CashAcceptPDK:=L_PDoc.pd_PKO;
      END;
      D:=Date4PDoc(CashAcceptPDK, IntvlB);
      Generate_MDoc(L_MDoc.md_VOD, D);
      Generate_PDoc(L_TRS.trct_CashAccept, CashAcceptPDK, 0, D);
      Generate_PDoc(L_TRS.trct_DeficitAct, L_PDoc.pd_VhP, 0, D);
      PrintDoc();
      MakeDoc:=0;
      Generate_PDoc(L_TRS.trct_CashAccept, CashAcceptPDK, 1, D);
      Generate_PDoc(L_TRS.trct_DeficitAct, L_PDoc.pd_VhP, 1, D);
     ELSE
      Generate_OBK(0);
      PrintDoc();
      MakeDoc:=0;
      Generate_OBK(1);
     END;
     _genPDocId:=_genPDocId+genPDocId+"|";
    END;
    NEXT(MyFirm);
   END; (* WHILE OCCURE(MyFirm) ... *)
   CLOSEREP(R);
   blin_PurgeTmpFiles();
   IF ~!_genPDocId THEN
    Docs_OnAnyModification(_genPDocId);
    L_Pmnt.ConfirmGeneratedDocs(0, _genPDocId);
   END;
   L_General.SurveyLastReport();
  ELSE
   blin_PurgeTmpFiles();
   L_StdFrm.RedInform(" 㬥  ନ஢");
  END;
 END {Make};

 PRIVATE PROCEDURE Tck32_CreateTemporaryFiles();
 BEGIN
  L_AFM.MakeMultipleIndex("Tck32", "MyFirm : SCAL[1E4];"+
                                   "Type   : LIKE(TckRcD.Type);"+
                                   "Date   : DATE;"+
                                   "Math   : LIKE(Math.Math);"+
                                   "CUCopy : LIKE(CUCopy.CUCopy);"+
                                   "TckRcD : LIKE(TckRcD.TckRcD);"+
                                   "Amount : NUMERIC[0];"+
                                   "PassDTS: TIMESTAMP",
                              "Tck32: MyFirm, Date, PassDTS, Type, CUCopy");
 END {Tck32_CreateTemporaryFiles};

 PRIVATE PROCEDURE Tck32_PurgeTemporaryFiles();
 BEGIN
  L_AFM.AF_PurgeTemp("Tck32");
 END {Tck32_PurgeTemporaryFiles};

 PRIVATE PROCEDURE GetDefaultStorage(D: DATE; mf: LIKE(MyFirm.MyFirm)): LIKE(Storage.Storage);
 BEGIN
  RETURN L_Stock.DefaultStorage();
 END {GetDefaultStorage};

 PRIVATE PROCEDURE Tck3233_BuildMDoc(PerStr: STRING[]; _Status: LIKE(MDoc.Status); GetStorage: PROC);
  CONST
   milliSecond = 1/24/60/60/100;
  VAR
   Qnt    : L_XObj.tQnt;
   CurType: LIKE(TckRcD.Type);
   CurD   : DATE;
 BEGIN
  SELECT(Tck32, Tck32);
  WHILE OCCURE(Tck32) DO
   NARROWSEL(Tck32, MyFirm);
   SEARCH(MyFirm, MyFirm, , Tck32.MyFirm);
   MAKEPART(R, TopFirm, "⮪ ନ஢ ⮢ 㬥⮢  ⭮ ",
                        " " + PerStr);
   MAKEPART(R, Tck32_Top);
   SETEMPTY(CurType, CurD);
   WHILE OCCURE(Tck32) DO
    IF (Tck32.Date # CurD) | (Tck32.Type # CurType) THEN
     CurType:=Tck32.Type;
     CurD   :=Tck32.Date;
     DEFAULT(MDoc);
     IF Tck32.Type = L_TRS.trdt_Return THEN
      MDoc.MDocKind:=L_MDoc.md_ViP;
     ELSE
      MDoc.MDocKind:=L_MDoc.md_TOV;
     END;
     MDoc.Date    :=Tck32.Date;
     L_MDoc.Insert_MDoc();
     MDoc.SrcDate :=SYSDATE();
     MDoc.Storage :=GetStorage(Tck32.Date, Tck32.MyFirm);
     MDoc.Dest    :=L_Dest.erkn_GetSoft(Tck32.Date, L_Dest.erkn_ReleaseToProduction);
     IF !MDoc.Dest THEN
      MDoc.Dest   :=L_Dest.erkn_Get(Tck32.Date, L_Dest.erkn_TckMovement);
     END;
     MDoc.CostItem:=L_TRS.E_TckMovementMDocCostItem(Tck32.Date);
     MDoc.TSN     :=L_MDoc.curUSER2MDocTSN(0);
     MDoc.Alower  :=L_MathR.NoAlower;
     MDoc.Status  :=_Status;
     REPLACE(MDoc);
    END;
    IF SELECT(MDocList, MDLMath, MDoc.MDocKind, MDoc.MDoc, Tck32.Math, L_MathR.mm_New) THEN
     INC(MDocList.Qnt, Tck32.Amount);
     REPLACE(MDocList);
    ELSE
     L_MDoc.InsMDocList(Tck32.Math, L_MathR.mm_New, EMPTYOF(MDocList.VATMode), Tck32.Amount, 0, 0);
    END;
    IF ~!Tck32.CUCopy THEN
     DEFAULT(MDocLCU);
     MDocLCU.Status  :=_Status;
     MDocLCU.MDocKind:=MDocList.MDocKind;
     MDocLCU.MDoc    :=MDocList.MDoc;
     MDocLCU.MDLNbr  :=MDocList.MDLNbr;
     MDocLCU.CUCopy  :=Tck32.CUCopy;
     MDocLCU.PassDTS :=Tck32.PassDTS;
     IF (MDoc.MDocKind = L_MDoc.md_TOV) THEN
      IF L_TRS.IsSaleTckRcD(Tck32.Type) THEN
       MDocLCU.OpKind:=L_CUC.ok_Sale;
      ELSE
       MDocLCU.OpKind:=L_CUC.ok_Setting;
      END;
     ELSE
      MDocLCU.OpKind:=L_CUC.ok_Dismant;
     END;
     IF Tck32.Type = L_TRS.trdt_Laying THEN
      DEC(MDocLCU.PassDTS, milliSecond);
     ELSE
      INC(MDocLCU.PassDTS, milliSecond);
     END;
     INSERT(MDocLCU);
     L_CUC.CompleteMDocLCU(1);
    END;
    TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
     L_XDoc.rf_Insert(L_XDoc.xdt_MDoc,
                      L_XDoc.XDocId(L_XDoc.xdt_TckRcD, L_XDoc.EmptyXDocKind, Tck32.TckRcD), L_XDoc.rft_BaseOn);
    EXCEPT
    ON Exc: Exc_RunTime DO
     IF ~L_General.IsUniquenessViolationException(Exc) THEN
      RAISE();
     END;
    END;

    NEXT(Tck32);
    IF ~OCCURE(Tck32) | (Tck32.Date # CurD) | (Tck32.Type # CurType) THEN
     L_MDoc.MDoc_OnAnyModification(+1, L_MDoc.np_Yes, 1);
 
     CONFORM(MDoc, Dest);
     MAKEPART(R, LineDoc, L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc), MDoc.Date);
    END;
   END; (* WHILE OCCURE(Tck32) *)
   MAKEPART(R, BotDoc);
   FORMFEED(R);
   NEXTINEXTENDEDSEL(Tck32, MyFirm);
  END; (* WHILE OCCURE(Tck32) ... *)
 END {Tck3233_BuildMDoc};

 PRIVATE PROCEDURE Tck32_BuildMDoc(D: DATE; _Status: LIKE(MDoc.Status); GetStorage: PROC);
 BEGIN
  Tck3233_BuildMDoc(L_DatTim.DateStr(D), _Status, GetStorage);
 END {Tck32_BuildMDoc};

 PRIVATE PROCEDURE Tck33_BuildMDoc(fr, ut: DATE; _Status: LIKE(MDoc.Status); GetStorage: PROC);
 BEGIN
  Tck3233_BuildMDoc("ਮ  " + L_DatTim.DateStr(fr) + "  " + L_DatTim.DateStr(ut), _Status, GetStorage);
 END {Tck33_BuildMDoc};

 PRIVATE PROCEDURE IsSaleFromStorage(trgStorage: LIKE(Storage.Storage)): SCAL[2];
 BEGIN
  RETURN L_TRS.IsSaleTckRcD(TckRcD.Type) & (TckRcD.Storage = trgStorage);
 END {IsSaleFromStorage};

 PRIVATE PROCEDURE IsTckOfficeMove(): SCAL[2];
 BEGIN
  RETURN (TckRcD.Type = L_TRS.trdt_Laying) | (TckRcD.Type = L_TRS.trdt_Return);
 END {IsTckOfficeMove};

 PRIVATE PROCEDURE HasGeneratedTckMoveMDoc(): SCAL[2];
  VAR
   xdc: L_XDoc.tXDocCollection;
   i  : NUMERIC[0];
 BEGIN
  xdc:=L_XDoc.GetDependentXDC(L_XDoc.curXDocId(L_XDoc.xdt_TckRcD), L_XDoc.xdt_MDoc);
  i:=0;
  WHILE ~!L_XDoc.xdc_Item(xdc, i) DO
   IF (L_XDoc.ExtractXDocKindId(L_XDoc.xdc_Item(xdc, i)) = L_XDoc.XDocKindId(L_XDoc.xdt_MDoc, L_MDoc.md_TOV)) |
      (L_XDoc.ExtractXDocKindId(L_XDoc.xdc_Item(xdc, i)) = L_XDoc.XDocKindId(L_XDoc.xdt_MDoc, L_MDoc.md_ViP)) THEN
    L_XDoc.PositionOnXDoc(L_XDoc.xdc_Item(xdc, i));
    IF MDoc.Status # L_MDoc.st_Canceled THEN
     RETURN 1;
    END;
   END;
   INC(i);
  END;
  RETURN 0;
 END {HasGeneratedTckMoveMDoc};

 PRIVATE PROCEDURE intTck32_DoOneDay(D: DATE; JustCheckIsDone: SCAL[2]): SCAL[3];
  VAR
   DoneCnt,
   NotDoneCnt: NUMERIC[0];
 BEGIN
  SetTicketKassaShiftParam(D, D);
  SETZERO(DoneCnt, NotDoneCnt);
  SELECT(Tck32, Tck32);
  REMSEL(Tck32);

  PROMPT("⮢ : " + L_DatTim.DateStr(D));
  SELECT(TckRcD, Type);
  WHILE OCCURE(TckRcD) DO
   NARROWSEL(TckRcD, Type);
   IF IsTckOfficeMove() THEN
    SRCINSEL(TckRcD, GE, , D);
    WHILE OCCURE(TckRcD) & (TckRcD.Date = D) & (~JustCheckIsDone | (NotDoneCnt = 0)) DO
     PROMPT("⮢ : " + L_DatTim.TimestampStr(TckRcD.PassDTS));
     IF (TckRcD.Status = L_TRS.trdStat_Passed) THEN
      IF HasGeneratedTckMoveMDoc() THEN
       INC(DoneCnt);
      ELSE
       SELECT(TckRcDL, TckRcD, , TckRcD.TckRcD);
       WHILE OCCURE(TckRcDL) DO
        CONFORM(TckRcDL, TckKind);
        IF L_TRS.IsBulk_wCUC() THEN
         INC(NotDoneCnt);
         IF ~JustCheckIsDone THEN
          CONFORM(TckRcD,  Storage);
          SELECT(TckRcDLL, TckRcD, , TckRcDL.TckRcD, TckRcDL.TRDLNbr);
          WHILE OCCURE(TckRcDLL) DO
           CONFORM(TckRcDLL, CUCopy);
           Tck32.MyFirm :=Storage.MyFirm;
           Tck32.Type   :=TckRcD.Type;
           Tck32.Date   :=TckRcDL.Date;
           Tck32.Math   :=CUCopy.Math;
           Tck32.CUCopy :=CUCopy.CUCopy;
           Tck32.TckRcD :=TckRcD.TckRcD;
           Tck32.PassDTS:=TckRcDL.PassDTS;
           Tck32.Amount :=1;
           INSERT(Tck32);
           NEXT(TckRcDLL);
          END; (* WHILE OCCURE(TckRcDLL) ... *)
         END; (* IF JustCheckIsDone *)
        ELSIF ~L_TRS.IsDevice(TckKind.Type) THEN
         INC(NotDoneCnt);
         IF ~JustCheckIsDone THEN
          CONFORM(TckRcD,  Storage);
          Tck32.MyFirm :=Storage.MyFirm;
          Tck32.Type   :=TckRcD.Type;
          Tck32.Date   :=TckRcDL.Date;
          IF L_TRS.IsBulk() THEN
           Tck32.Math   :=TckKind.Math;
           SETEMPTY(Tck32.CUCopy);
           Tck32.Amount :=TckRcDL.RestNbr;
          ELSE
           CONFORM(TckRcDL, CUCopy);
           Tck32.Math   :=CUCopy.Math;
           Tck32.CUCopy :=CUCopy.CUCopy;
           Tck32.Amount :=1;
          END;
          Tck32.TckRcD :=TckRcD.TckRcD;
          Tck32.PassDTS:=TckRcDL.PassDTS;
          INSERT(Tck32);
         END; (* IF JustCheckIsDone *)
        END;
        NEXT(TckRcDL);
       END; (* WHILE OCCURE(TckRcDL) ... *)
      END; (*IF ~HasGeneratedTckMoveMDoc() THEN*)
     END; (*IF (TckRcD.Status = L_TRS.trdStat_Passed) THEN*)
     NEXT(TckRcD);
    END; (* WHILE OCCURE(File) *)
   END;
   NEXTINEXTENDEDSEL(TckRcD, Type);
  END; (* WHILE OCCURE(TckRcD) *)
  IF    NotDoneCnt > 0 THEN
   RETURN 0;
  ELSIF DoneCnt > 0 THEN
   RETURN 1;
  ELSE
   RETURN 2;
  END;
 END {intTck32_DoOneDay};

 PRIVATE PROCEDURE intTck33_DoOneDay(D: DATE; trgStorage: LIKE(Storage.Storage); JustCheckIsDone: SCAL[2]): SCAL[3];
  VAR
   DoneCnt,
   NotDoneCnt: NUMERIC[0];
 BEGIN
  SetTicketKassaShiftParam(D, D);
  PROMPT("⮢ : " + L_DatTim.DateStr(D));
  SETZERO(DoneCnt, NotDoneCnt);
  SELECT(XDocJrn, UserIdx, , L_XDoc.xdt_TckRcD);
  WHILE OCCURE(XDocJrn) & (~JustCheckIsDone | (NotDoneCnt = 0)) DO
   NARROWSEL(XDocJrn, AcsObj);
   CONFORM(XDocJrn, AcsObj);
   SRCINSEL(XDocJrn, GE, , fr_SBD, fr_SBT);
   WHILE OCCURE(XDocJrn) & ((XDocJrn.Date < ut_SED) |
                            (XDocJrn.Date = ut_SED) & (XDocJrn.BegTime < ut_SET)) DO
    IF (XDocJrn.Action = L_XDoc.action_AutoBuild) | (XDocJrn.Action = L_XDoc.action_Insert) THEN
     SEARCH(TckRcD, TckRcD, , XDocJrn.XDoc);
     IF IsSaleFromStorage(trgStorage) & (TckRcD.Status = L_TRS.trdStat_Passed) THEN
      PROMPT("⮢ : " + L_DatTim.DateStr(D) + ", " + AcsObj.Name + ", " +
             L_DatTim.TimeStr(XDocJrn.BegTime));
      IF HasGeneratedTckMoveMDoc() THEN
       INC(DoneCnt);
      ELSE
       SELECT(TckRcDL, TckRcD, , TckRcD.TckRcD);
       WHILE OCCURE(TckRcDL) DO
        CONFORM(TckRcDL, TckKind);
        IF L_TRS.IsBulk_wCUC() THEN
         INC(NotDoneCnt);
         IF ~JustCheckIsDone THEN
          CONFORM(TckRcD,  Storage);
          SELECT(TckRcDLL, TckRcD, , TckRcDL.TckRcD, TckRcDL.TRDLNbr);
          WHILE OCCURE(TckRcDLL) DO
           CONFORM(TckRcDLL, CUCopy);
           Tck32.MyFirm :=Storage.MyFirm;
           Tck32.Type   :=TckRcD.Type;
           Tck32.Date   :=TckRcDL.Date;
           Tck32.Math   :=CUCopy.Math;
           Tck32.CUCopy :=CUCopy.CUCopy;
           Tck32.TckRcD :=TckRcD.TckRcD;
           Tck32.PassDTS:=TckRcDL.PassDTS;
           Tck32.Amount :=1;
           INSERT(Tck32);
           NEXT(TckRcDLL);
          END; (* WHILE OCCURE(TckRcDLL) ... *)
         END;
        ELSIF ~L_TRS.IsDevice(TckKind.Type) & (TckKind.Type # L_TRS.tkt_EasySales) THEN
         INC(NotDoneCnt);
         IF ~JustCheckIsDone THEN
          CONFORM(TckRcD,  Storage);
          Tck32.MyFirm :=Storage.MyFirm;
          Tck32.Type   :=TckRcD.Type;
          Tck32.Date   :=TckRcDL.Date;
          IF L_TRS.IsBulk() THEN
           Tck32.Math  :=TckKind.Math;
           SETEMPTY(Tck32.CUCopy);
           Tck32.Amount:=TckRcDL.Psg;
          ELSE
           CONFORM(TckRcDL, CUCopy);
           Tck32.Math  :=CUCopy.Math;
           Tck32.CUCopy:=CUCopy.CUCopy;
           Tck32.Amount:=1;
          END;
          Tck32.TckRcD :=TckRcD.TckRcD;
          Tck32.PassDTS:=TckRcDL.PassDTS;
          INSERT(Tck32);
         END;
        END;
        NEXT(TckRcDL);
       END; (* WHILE OCCURE(TckRcDL) ... *)
      END; (*IF ~HasGeneratedTckMoveMDoc() THEN*)
     END; (*IF NeedTRD() & (TckRcD.Status = L_TRS.trdStat_Passed) THEN*)
    END; (*IF (XDocJrn.Action = L_XDoc.action_AutoBuild)*)
    NEXT(XDocJrn);
   END; (* WHILE OCCURE(XDocJrn) ... *)
   NEXTINEXTENDEDSEL(XDocJrn, AcsObj);
  END; (* WHILE OCCURE(XDocJrn) ... *)
  IF    NotDoneCnt > 0 THEN
   RETURN 0;
  ELSIF DoneCnt > 0 THEN
   RETURN 1;
  ELSE
   RETURN 2;
  END;
 END {intTck33_DoOneDay};

 PUBLIC PROCEDURE Tck32_DoOneDay(D: DATE);
  VAR
   Dummy: SCAL[3];
 BEGIN
  Dummy:=intTck32_DoOneDay(D, 0);
  Tck32_BuildMDoc(D, L_MDoc.st_Passed, PROCREF(L_TRS.TckOfficeStorage));
 END {Tck32_DoOneDay};

 PUBLIC PROCEDURE Tck33_DoOneDay(D: DATE);
  VAR
   Dummy: SCAL[3];
 BEGIN
  Dummy:=intTck33_DoOneDay(D, L_Stock.DefaultStorage(), 0);
 END {Tck33_DoOneDay};

 PUBLIC PROCEDURE Tck33_CheckIsNotDone(D: DATE; trgStorage: LIKE(Storage.Storage));
  VAR
   Done   : SCAL[3];
   oPrompt: PROMPTLINE;
 BEGIN
  oPrompt:=PROMPTLINE.Create("");
  L_General.CallUs(~!trgStorage);
  Tck32_CreateTemporaryFiles();
  LOOP
   IF D >= L_TRS.GetTRDOnDate() THEN
    EXIT;
   ELSE
    Done:=intTck33_DoOneDay(D, trgStorage, 1);
    L_General.Assert(Done # 1,
                     " 믮 ନ஢ ⮢ 㬥⮢" +
                     "|  " + trgStorage + "  " + L_DatTim.DateStr(D));
    IF Done = 0 THEN
     EXIT;
    END;
    INC(D);
   END;
  END;
  Tck32_PurgeTemporaryFiles();
 END {Tck33_CheckIsNotDone};

 PUBLIC PROCEDURE Tck33_CheckIsDone(D: DATE; trgStorage: LIKE(Storage.Storage));
  VAR
   Done: SCAL[3];
 BEGIN
  APP.Get().NewPrompt("");
  L_General.CallUs(~!trgStorage);
  SAVE(Storage);
  SEARCH(Storage, Storage, , trgStorage);
  Tck32_CreateTemporaryFiles();
  LOOP
   IF D < Storage.Begin THEN
    EXIT;
   END;
   Done:=intTck33_DoOneDay(D, trgStorage, 1);
   IF    Done = 0 THEN
    L_General.Error(" 믮 ନ஢ ⮢ 㬥⮢" +
                    "|  " + trgStorage + "  " + L_DatTim.DateStr(D));
   ELSIF Done = 1 THEN
    EXIT;
   END;
   DEC(D);
  END; (* LOOP *)
  RESTORE(Storage);
  Tck32_PurgeTemporaryFiles();
 END {Tck33_CheckIsDone};

 PUBLIC PROCEDURE Tck32_CheckIsDone(D: DATE);
  VAR
   Done: SCAL[3];
 BEGIN
  APP.Get().NewPrompt("");
  Tck32_CreateTemporaryFiles();
  LOOP
   IF ~L_TRS.E_HasTckAtStorage(D) THEN
    EXIT;
   END;
   Done:=intTck32_DoOneDay(D, 1);
   IF    Done = 0 THEN
    L_General.Error(" 믮 ନ஢      ");
   ELSIF Done = 1 THEN
    EXIT;
   END;
   DEC(D);
  END; (* LOOP *)
  Tck32_PurgeTemporaryFiles();
 END {Tck32_CheckIsDone};

 PRIVATE PROCEDURE Tck32_Do();
  VAR
   from,
   upto,
   D    : DATE;
 BEGIN
  L_AR.GrantRightsUnconditionally();

  upto:=L_TRS.GetTRDOnDate() - 1;
  Tck32_CreateTemporaryFiles();

  from:=upto;
  WHILE L_TRS.E_HasTckAtStorage(from) & (intTck32_DoOneDay(from, 1) # 1) DO
   DEC(from);
  END;
  INC(from);
  IF from <= upto THEN
   L_StdFrm.Question("ନ஢        ਮ  " + L_DatTim.DateStr(from) +
                     "  "  + L_DatTim.DateStr(upto));
   RepName:="Tck32";
   OPENREP(R, L_General.NameConnection(RepName), Create);
   D:=from;
   WHILE D <= upto DO
    Tck32_DoOneDay(D);
    INC(D);
   END;
   CLOSEREP(R);
   Tck32_PurgeTemporaryFiles();
   L_General.SurveyLastReport();
  ELSE
   Tck32_PurgeTemporaryFiles();
   STDMSG("ନ஢        ॡ", INFORM);
  END;
 END {Tck32_Do};

 PRIVATE PROCEDURE Tck33_Do();
  VAR
   from,
   upto,
   D    : DATE;
 BEGIN
  L_General.Assert(~!L_Stock.DefaultStorage(), " ⠭   㬮砭");
  L_AR.GrantRightsUnconditionally();

  upto:=SYSDATE() - 1;
  Tck32_CreateTemporaryFiles();

  from:=upto;
  WHILE L_TRS.E_HasTckAtStorage(from) & (intTck33_DoOneDay(from, L_Stock.DefaultStorage(), 1) # 1) DO
   DEC(from);
  END;
  INC(from);

  IF from <= upto THEN
   L_StdFrm.Question("ନ஢   த "+
                     "|  ࠭ " + L_Stock.DefaultStorage() +
                     "| ਮ  " + L_DatTim.DateStr(from) + "  "  + L_DatTim.DateStr(upto));
   D:=from;
   WHILE D <= upto DO
    Tck33_DoOneDay(D);
    INC(D);
   END;
   RepName:="Tck33";
   OPENREP(R, L_General.NameConnection(RepName + "_" + L_Stock.DefaultStorage()), Create);
   Tck33_BuildMDoc(from, upto, L_MDoc.st_Passed, PROCREF(GetDefaultStorage));
   CLOSEREP(R);
   Tck32_PurgeTemporaryFiles();
   L_General.SurveyLastReport();
  ELSE
   Tck32_PurgeTemporaryFiles();
   STDMSG("ନ஢   த    ࠭ "+L_Stock.DefaultStorage()+"  ॡ", INFORM);
  END;
 END {Tck33_Do};

 PRIVATE PROCEDURE bfvip_intPackCUCopyAtStorage(atTckRcDL: SCAL[2]; trgType: LIKE(TckRcD.Type); _RestNbr: NUMERIC[0]);
 BEGIN
  IF atTckRcDL & (TckRcD.Type = L_TRS.trdt_Return) & (TckRcD.Status = L_TRS.trdStat_Passed) &
     (TckKind.Type # L_TRS.tkt_PieceTck) THEN
   Tck32.MyFirm :=L_TRS.GetTckRcDMyFirm();
   Tck32.Type   :=trgType;
   Tck32.Date   :=Memo.ud_cd();
   Tck32.PassDTS:=TckRcDL.PassDTS;
   Tck32.TckRcD :=TckRcDL.TckRcD;
   IF    TckKind.Type = L_TRS.tkt_PieceTck THEN
    Tck32.Math   :=TckKind.Math;
    SETEMPTY(Tck32.CUCopy);
    Tck32.Amount :=_RestNbr;
   ELSE
    Tck32.Math   :=CUCopy.Math;
    Tck32.CUCopy :=CUCopy.CUCopy;
    Tck32.Amount :=1;
   END;
   INSERT(Tck32);
  END;
 END {bfvip_intPackCUCopyAtStorage};

 PRIVATE PROCEDURE bfvip_ViP_PackCUCopyAtStorage(atTckRcDL: SCAL[2];
                                         avp      : L_Acnt.tAcntVectorPart;
                                         _RestNbr : NUMERIC[0]);
 BEGIN
  IF (avp = L_Acnt.avp_InSaldo) THEN
   bfvip_intPackCUCopyAtStorage(atTckRcDL, L_TRS.trdt_Return, _RestNbr);
  END;
 END {bfvip_ViP_PackCUCopyAtStorage};

 PRIVATE PROCEDURE bfvip_TOV_PackCUCopyAtStorage(atTckRcDL: SCAL[2];
                                         avp      : L_Acnt.tAcntVectorPart;
                                         _RestNbr : NUMERIC[0]);
 BEGIN
  IF (avp = L_Acnt.avp_InSaldo) THEN
   bfvip_intPackCUCopyAtStorage(atTckRcDL, L_TRS.trdt_Laying, _RestNbr);
  END;
 END {bfvip_TOV_PackCUCopyAtStorage};

 PRIVATE PROCEDURE intBuildFirstViP(Proc: PROC);
  VAR
   shiftBegDate,
   shiftEndDate : DATE;
   shiftBegTime,
   shiftEndTime : TIME;
 BEGIN
  Tck32_CreateTemporaryFiles();
  L_TRS.SetupShiftBorders(Memo.ud_cd(), shiftBegDate, shiftEndDate, shiftBegTime, shiftEndTime);
  L_CUC.extCollectTckMovement(L_TRS.TckOfficeStorage(shiftEndDate, P_Firm.mf_Own),
                              PackTIMESTAMP(shiftBegDate, shiftBegTime),
                              PackTIMESTAMP(shiftBegDate, shiftBegTime),
                              Proc,
                              1);
  RepName:="TckXX";
  OPENREP(R, L_General.NameConnection(RepName), Create);
  Tck32_BuildMDoc(Memo.ud_cd(), L_MDoc.st_Prepared, PROCREF(L_TRS.TckOfficeStorage));
  CLOSEREP(R);
  Tck32_PurgeTemporaryFiles();
 END {intBuildFirstViP};

 PRIVATE PROCEDURE Tck40_CreateTemporaryFiles();
 BEGIN
  CreateFILE(Tck40);
  CreateFIELD(Tck40, MyFirm,   LIKE(MyFirm.MyFirm));
  CreateFIELD(Tck40, Type,     SCAL[4]);
  CreateFIELD(Tck40, Contract, LIKE(Contract.Contract));
  CreateFIELD(Tck40, TckRcD,   LIKE(TckRcD.TckRcD));
  CreateFIELD(Tck40, Sum,      NUMERIC[2], , "0");
  CreateINDEX(Tck40, Tck40, UNIQUE, "", "", MyFirm, Type, Contract, TckRcD);
  SetVersionOfFILE(Tck40, 0000);
  L_AFM.CreateTemp("Tck40");
 END {Tck40_CreateTemporaryFiles};

 PRIVATE PROCEDURE Tck40_PurgeTemporaryFiles();
 BEGIN
  L_AFM.AF_PurgeTemp("Tck40");
 END {Tck40_PurgeTemporaryFiles};

 PRIVATE PROCEDURE Tck40_Generate_MDoc(trgMDocKind: LIKE(MDoc.MDocKind);
                                       D          : DATE;
                                       trgDest    : LIKE(Dest.Dest);
                                       trgContract: LIKE(Contract.Contract));
 BEGIN
  L_General.Assert(SEARCH(MDocKind, MDocKind, trgMDocKind),
                   " 㬥 " + trgMDocKind + " " + L_MDoc.MDocKindNick(trgMDocKind, 1) +
                   "   ࠢ筨");
  L_General.CallUs(SEARCH(Contract, Contract, trgContract));
  DEFAULT(MDoc);
  MDoc.MDocKind:=MDocKind.MDocKind;
  MDoc.MyFirm  :=P_Firm.mf_Fict; (*ࠢ  MDoc_OnAnyModification*)
  MDoc.Date    :=D;
  L_MDoc.Insert_MDoc();
  MDoc.SrcDate :=MDoc.Date;
  MDoc.PayDate :=L_Pmnt.E_DefineMDocPayDate();
  MDoc.Contract:=Contract.Contract;
  MDoc.Firm    :=Contract.Firm;
  MDoc.TSN     :=L_MDoc.curUSER2MDocTSN(0);
  MDoc.Dest    :=trgDest;
  MDoc.Status  :=L_MDoc.st_Passed;
  REPLACE(MDoc);
  P_MDoc.SetMDocPro(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Note, "த  ஥ " + L_DatTim.DateStr(D));
  Add_genPDocId(L_XDoc.curXDocId(L_XDoc.xdt_MDoc));
 END {Tck40_Generate_MDoc};

 PRIVATE PROCEDURE Tck40_CompletePDoc();
  CONST
   addComment = "  ஥ ";
  VAR
   vat      : LIKE(MDocList.VAT);
   pdComment: STRING[];
 BEGIN
  vat:=0;
  SELECT(MDocList, MDoc, , MDoc.MDocKind, MDoc.MDoc);
  WHILE OCCURE(MDocList) DO
   INC(vat, MDocList.VAT);
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
  L_Pmnt.InsPDocMDoc(MDoc.MDocKind, MDoc.MDoc, PDoc.Total - vat, vat, 0);
  L_PDoc.FillPDocAbout();
  IF L_PDoc.PDocKindHasStructuredComment(PDoc.PDocKind) THEN
   IF !L_PDoc.GetPDocCommentPart(2) THEN
    L_PDoc.SetPDocCommentPart(2, addComment);
   END;
  ELSE
   pdComment:=L_PDoc.GetPDocComment();
   IF ~Str.Match(pdComment, "*" + addComment) THEN
    L_PDoc.SetPDocComment(pdComment + ". " + addComment);
   END;
  END;
  REPLACE(PDoc);
  Add_genPDocId(L_XDoc.curXDocId(L_XDoc.xdt_PDoc));
 END {Tck40_CompletePDoc};

 PRIVATE PROCEDURE Tck40_InsMDL();
  VAR
   vat: LIKE(MDocList.VAT);
   math: LIKE(Math.Math);
 BEGIN
(*
  math:=;   md_VOD 㤥 ଠ   -  㤥  MathForPayment.
*)
  math:=E_Pmnt.MathForPayment(MDoc.Date);
  InsMDL(math, Tck40.Sum, 0);
(*
  IF L_MDoc.MDocListVATPossible() THEN
   MDocList.VAT:=L_Acnt.GetInclMathVAT(MDocList.Math, MDoc.Date, Tck40.Sum);
  ELSE
   MDocList.VAT:=0;
  END;
  DEC(MDocList.Sum, MDocList.VAT);
  REPLACE(MDocList);
*)
  L_XDoc.rf_coreInsert(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.curXDocId(L_XDoc.xdt_TckRcD), L_XDoc.rft_BaseOn);
 END {Tck40_InsMDL};

 PRIVATE PROCEDURE Tck40_GenerateDocs(D: DATE);
 BEGIN
  MakeDoc:=1;
  IF SELECT(Tck40, Tck40) THEN
   WHILE OCCURE(Tck40) DO
    NARROWSEL(Tck40, MyFirm);
    L_General.CallUs(SEARCH(MyFirm, MyFirm, Tck40.MyFirm));
    WHILE OCCURE(Tck40) DO
     NARROWSEL(Tck40, Type);
     IF    (Tck40.Type = L_TRS.trdst_Distribution) THEN
      WHILE OCCURE(Tck40) DO
       L_General.CallUs(SEARCH(TckRcD, TckRcD, Tck40.TckRcD));
(*
       Tck40_Generate_MDoc(L_MDoc.md_RPr, D, E_TRS.Tck30_SaleToStaffDest(), Tck40.Contract);
*)
       Tck40_Generate_MDoc(L_MDoc.md_VOD, D, E_TRS.Tck30_SaleToStaffDest(), Tck40.Contract);
       Tck40_InsMDL();
       InsPDoc(L_PDoc.pd_VhP, D);
       PDoc.Total:=Tck40.Sum;
       PDoc.Firm :=TckRcD.Firm;
       Tck40_CompletePDoc();
       NEXT(Tck40);
      END; (* WHILE OCCURE(Tck40) ... *)
     ELSIF (Tck40.Type = L_TRS.trdst_Staff) THEN
(*
      Tck40_Generate_MDoc(L_MDoc.md_RPr, D, E_TRS.Tck30_SaleToStaffDest(), Tck40.Contract);
*)
      Tck40_Generate_MDoc(L_MDoc.md_VOD, D, E_TRS.Tck30_SaleToStaffDest(), Tck40.Contract);
      InsPDoc(L_PDoc.pd_VhP, D);
      PDoc.Firm  :=MyFirm.Firm;
      PDoc.Status:=L_PDoc.st_Passed;
      WHILE OCCURE(Tck40) DO
       L_General.CallUs(SEARCH(TckRcD, TckRcD, Tck40.TckRcD));
       InsPDocList(TckRcD.TSN, Tck40.Sum);
       INC(PDoc.Total, Tck40.Sum);
       Tck40_InsMDL();
       NEXT(Tck40);
      END; (* WHILE OCCURE(Tck40) ... *)
      Tck40_CompletePDoc();
     ELSIF (Tck40.Type = L_TRS.trdst_Retail) THEN
(*
      Tck40_Generate_MDoc(L_MDoc.md_RPr, D, L_Dest.erkn_Get(D, L_Dest.erkn_TckProceeds), Tck40.Contract);
*)
      WHILE OCCURE(Tck40) DO
       NARROWSEL(Tck40, Contract);
       Tck40_Generate_MDoc(L_MDoc.md_VOD, D, L_Dest.erkn_Get(D, L_Dest.erkn_TckProceeds), Tck40.Contract);
       InsPDoc(L_PDoc.pd_POO, D);
       L_General.Assert(L_PDoc.dodAssigned, " ⠭ 樮   㬮砭");
       L_General.Assert(L_PDoc.dodMyFirm = MyFirm.MyFirm, "樮   㬮砭    㬮砭 -  ࠧ ");
       PDoc.OwnAcnt:=L_PDoc.dodFirmAcnt;
       PDoc.Firm   :=Contract.Firm;
       WHILE OCCURE(Tck40) DO
        L_General.CallUs(SEARCH(TckRcD, TckRcD, Tck40.TckRcD));
        INC(PDoc.Total, Tck40.Sum);
        Tck40_InsMDL();
        NEXT(Tck40);
       END; (* WHILE OCCURE(Tck40) ... *)
       Tck40_CompletePDoc();
       NEXTINEXTENDEDSEL(Tck40, Contract);
      END; (* WHILE OCCURE(Tck40) *)
     ELSIF (Tck40.Type = L_TRS.trdst_Firm) THEN
(*
      WHILE OCCURE(Tck40) DO
       L_General.CallUs(SEARCH(TckRcD, TckRcD, Tck40.TckRcD));
       Tck40_Generate_MDoc(L_MDoc.md_IsS, D, L_Dest.erkn_Get(D, L_Dest.erkn_TckProceeds), Tck40.Contract);
       Tck40_InsMDL();
       NEXT(Tck40);
      END; (* WHILE OCCURE(Tck40) ... *)
*)
     END; (* IF (Tck40.Type = L_TRS.trdst_Staff) ...*)
     NEXTINEXTENDEDSEL(Tck40, Type);
    END; (* WHILE OCCURE(Tck40) *)
    NEXTINEXTENDEDSEL(Tck40, MyFirm);
   END; (* WHILE OCCURE(Tck40) *)
  END; (* IF SELECT(Tck40, Tck40) THEN *)
 END {Tck40_GenerateDocs};

 PRIVATE PROCEDURE HasGeneratedSalesMDoc(): SCAL[2];
  VAR
   xdc: L_XDoc.tXDocCollection;
   i  : NUMERIC[0];
 BEGIN
  xdc:=L_XDoc.GetDependentXDC(L_XDoc.curXDocId(L_XDoc.xdt_TckRcD), L_XDoc.xdt_MDoc);
  i:=0;
  WHILE ~!L_XDoc.xdc_Item(xdc, i) DO
   IF (L_XDoc.ExtractXDocKindId(L_XDoc.xdc_Item(xdc, i)) # L_XDoc.XDocKindId(L_XDoc.xdt_MDoc, L_MDoc.md_TOV)) &
      (L_XDoc.ExtractXDocKindId(L_XDoc.xdc_Item(xdc, i)) # L_XDoc.XDocKindId(L_XDoc.xdt_MDoc, L_MDoc.md_ViP)) THEN
    L_XDoc.PositionOnXDoc(L_XDoc.xdc_Item(xdc, i));
    IF MDoc.Status # L_MDoc.st_Canceled THEN
     RETURN 1;
    END;
   END;
   INC(i);
  END;
  RETURN 0;
 END {HasGeneratedSalesMDoc};

 PRIVATE PROCEDURE FoundContract(D: DATE; ptrnCntr: LIKE(Contract.Contract); wFirm: LIKE(Firm.Firm)): SCAL[2];
 BEGIN
  SELECT(Contract, Parent, , ptrnCntr, 1);
  WHILE OCCURE(Contract) DO
   IF (!wFirm | (Contract.Firm = wFirm)) &
      L_DatTim.IsActive(D, Contract.Begin, Contract.Till) THEN
    RETURN 1;
   END;
   NEXT(Contract);
  END; (* WHILE OCCURE(Contract) ... *)
  RETURN 0;
 END {FoundContract};

 PRIVATE PROCEDURE Tck40_DoOneDay(D: DATE);
  VAR
   type: L_TRS.tTckRcDSaleType;
 BEGIN
  SELECT(Tck40, Tck40);
  REMSEL(Tck40);

  SELECT(TckRcD, TypeStrg, , L_TRS.trdt_Sale, Storage.Storage, D);
  WHILE OCCURE(TckRcD) DO
   PROMPT("⮢ : " + L_DatTim.DateStr(D) + ", " + TckRcD.TckRcD);
   IF (TckRcD.Status = L_TRS.trdStat_Passed) THEN
    IF ~HasGeneratedSalesMDoc() THEN
     SELECT(TckRcDL, TckRcD, , TckRcD.TckRcD);
     WHILE OCCURE(TckRcDL) DO
      CONFORM(TckRcDL, TckKind);
      L_General.CallUs(L_TRS.IsBulk() | (TckKind.Type = L_TRS.tkt_EasySales));

      type:=L_TRS.TckRcDSaleType();
      IF    (type = L_TRS.trdst_Distribution) THEN
       L_General.Assert(FoundContract(D, E_TRS.Tck30_ContractParentForSnTckDistribution(D), TckRcD.Firm),
                        "    த ஥ ࠡ⭨ (ࠣ " + TckRcD.Firm + ")");
      ELSIF (type = L_TRS.trdst_Staff) THEN
       L_General.Assert(FoundContract(D, E_TRS.Tck30_ContractParentForSnTckDistribution(D), MyFirm.Firm),
                        "    த ஥ ࠡ⭨ (ࠣ " + MyFirm.Firm + ")");
      ELSIF (type = L_TRS.trdst_Retail) THEN
       L_General.Assert(FoundContract(D, E_TRS.Tck30_ContractParentForSnTckRetailSale(D), ""),
                        "    த ஥  ஧");
      ELSIF (type = L_TRS.trdst_Firm) THEN
       L_General.Assert(FoundContract(D, E_TRS.Tck30_ContractParentForSnTckSaleToFirm(D), TckRcD.Firm),
                        "    த ஥ (ࠣ " + TckRcD.Firm + ")");
      ELSE
       L_General.CallUs(0);
      END;

      ADD(Tck40, Tck40, , Storage.MyFirm, type, Contract.Contract, TckRcD.TckRcD,
                  Tck40.Sum, TckRcDL.RestNbr);
      NEXT(TckRcDL);
     END; (* WHILE OCCURE(TckRcDL) ... *)
    END; (*IF ~HasGeneratedSalesMDoc() THEN*)
   END; (* IF TckRcD.Status = L_TRS.trdStat_Passed *)
   NEXT(TckRcD);
  END; (* WHILE OCCURE(TckRcD) ... *)
  Tck40_GenerateDocs(D);
 END {Tck40_DoOneDay};

 PRIVATE PROCEDURE Tck40_Do();
  VAR
   upto,
   D    : DATE;
   Dummy: SCAL[3];
 BEGIN
  L_General.Assert(~!L_Stock.DefaultStorage(), " ⠭   㬮砭");
  L_AR.GrantRightsUnconditionally();
  SEARCH(Storage, Storage, , L_Stock.DefaultStorage());
  CONFORM(Storage, MyFirm);

  upto:=SYSDATE();
  Tck40_CreateTemporaryFiles();
  L_General.SetIntvlByIntvl(D, upto);
  IntvlStr:="  ਮ  "+L_DatTim.DateStr(D)+"  "+L_DatTim.DateStr(upto);
  SETEMPTY(genPDocId);
  RT:=rt_tck40;

  L_StdFrm.Question("ନ஢ 㬥  த " +
                    "|  ࠭ " + L_Stock.DefaultStorage() +
                    "|" + IntvlStr);
  RepName:="Tck40";
  OPENREP(R, L_General.NameConnection(RepName), Create);
  WHILE D <= upto DO
   Tck40_DoOneDay(D);
   INC(D);
  END;
  Tck40_PurgeTemporaryFiles();
  PrintDoc();
  CLOSEREP(R);
  IF ~!genPDocId THEN
   Docs_OnAnyModification(genPDocId);
   L_Pmnt.ConfirmGeneratedDocs(0, genPDocId);
  END;
  L_General.SurveyLastReport();
 END {Tck40_Do};

(*
$P{ Tck34_Top:
?, C, ""
@
==============================================================================
|############################################################################|
|----------------------------------------------------------------------------|
|㭪 ਥ 窨                |- ||      |        㬬|
|------------------------------------|-------|------|----------|-------------|
}
*)

(*
$P{ Tck34_Line:
Storage.Storage, L, ""
Storage.Name, L, ""
IRec.IRec, L, ""
Tmp02.PayMth, L, "|ᯊ|"
IRec.Date, L, "D.N.y"
Tmp02.Sum, R, ",2-"
@
|####### ############################|#######|######|##########|#############|
}
*)

(*
$P{ Tck34_Bot:
?, R, ",2-"
@
|--------------------------------------------------------------|-------------|
|⮣                                                         |#############|
=(c) Polak====================================================================

}
*)

 PRIVATE PROCEDURE Tck34_Generate_PDoc(D: DATE; wPrint: SCAL[2]);
  VAR
   Sum,
   T_Sum : NUMERIC[2];
   rko_Id: L_XDoc.tXDocId;
   trgPDocKind: LIKE(PDoc.PDocKind);
 BEGIN
  IF wPrint THEN
   MAKEPART(R, Tck34_Top, "㬬 த" + IntvlStr);
  END;
  IF MakeDoc THEN
   T_Sum:=0;
   IF Tmp02.PayMth = L_IRec.paymth_Cash THEN
(*
    IF E_Tck30_GeneratePOO() THEN
*)
     trgPDocKind:=L_PDoc.pd_POO;
(*
    ELSE
     trgPDocKind:=L_PDoc.pd_PKO;
    END;
*)
   ELSE
    trgPDocKind:=L_PDoc.pd_VhP;
   END;
   InsPDoc(trgPDocKind, D);
   Sum:=0;
   WHILE OCCURE(Tmp02) DO
    L_General.CallUs(SEARCH(IRec, IRec, Tmp02.IRec));
    INC(Sum, Tmp02.Sum);
    INC(T_Sum, Tmp02.Sum);
    IF wPrint THEN
     SEARCH(Storage, Storage, , IRec.Storage);
     MAKEPART(R, Tck34_Line);
    END;
    NEXT(Tmp02);
   END; (* WHILE OCCURE(Tmp01) ... *)
   L_XDoc.rf_coreInsert(L_XDoc.curXDocId(L_XDoc.xdt_PDoc),
                        L_XDoc.curXDocId(L_XDoc.xdt_IRec), L_XDoc.rft_BaseOn);
   InsMDL(E_Pmnt.MathForPayment(MDoc.Date), Sum, 0);
   L_Pmnt.InsPDocMDoc(MDoc.MDocKind, MDoc.MDoc, Sum, 0, 0);
   CompletePDoc(Sum);
  END;
  IF wPrint THEN
   MAKEPART(R, Tck34_Bot, T_Sum);
  END;
 END {Tck34_Generate_PDoc};

 PRIVATE PROCEDURE Tck34_Do();
  VAR
   dir,
   i            : NUMERIC[0];
   _XDocType    : L_XDoc.tXDocType;
   _XDI         : L_XDoc.tXDocId;
   _genPDocId   : L_XDoc.tXDocCollection;
   D            : DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode  :=adm_SOFT;
  TABLE.Get("XDocRef").AccessDataMode:=adm_RIDGE;
  TABLE.Get("MDoc").AccessDataMode   :=adm_RIDGE;
  TABLE.Get("PDoc").AccessDataMode   :=adm_RIDGE;

  L_AFM.MakeMultipleIndex("Tmp02", "MyFirm : LIKE(MyFirm.MyFirm);"+
                                   "Storage: LIKE(Storage.Storage);"+
                                   "PayMth : LIKE(IRecL.PayMth);" +
                                   "IRec   : LIKE(IRec.IRec);"+
                                   "Sum    : NUMERIC[2];",
                                "Tmp02: MyFirm, Storage, PayMth, IRec");

  IF L_IRec.E_GetIRecLInsertMode() = L_IRec.irlim_AutoFill THEN
   SELECT(IRec, TDate, , L_IRec.type_Departure, Memo.ud_cd());
  ELSE
   SELECT(IRec, TDate, , L_IRec.type_Sale, Memo.ud_cd());
  END;
  WHILE OCCURE(IRec) DO
   PROMPT(IRec.IRec);
   IF L_IRec.E_IsOurIncomeReceivedPlace() THEN
    SELECT(IRecL, IRec, , IRec.IRec);
    WHILE OCCURE(IRecL) DO
     IF IRecL.Kind = L_IRec.knd_Sale THEN
      dir:=1;
     ELSE
      dir:=-1;
     END;
     ADD(Tmp02, Tmp02, , IRec.MyFirm, IRec.Storage, IRecL.PayMth, IRec.IRec,
            Tmp02.Sum, dir * IRecL.TotalSum);
     NEXT(IRecL);
    END; (* WHILE OCCURE(IRecL) ... *)
   END; (* IF L_IRec.E_IsOurIncomeReceivedPlace() *)
   NEXT(IRec);
  END; (* WHILE OCCURE(IRec) ... *)

  IF AMOUNT(Tmp02) > 0 THEN
   SETEMPTY(_genPDocId);
   OPENREP(R, L_General.NameConnection(RepName), Create);
   SELECT(MyFirm, MyFirm);
   WHILE OCCURE(MyFirm) DO
    IF SELECT(Tmp02, Tmp02, MyFirm.MyFirm) THEN
     SETEMPTY(genPDocId);
     MAKEPART(R, TopFirm, "⮪ ନ஢ ⥦ 㬥⮢   த ⮢", IntvlStr);
     WHILE OCCURE(Tmp02) DO
      NARROWSEL(Tmp02, Storage, PayMth);
      WHILE OCCURE(Tmp02) DO
       Tck34_StandOnContract();
       MakeDoc:=1;
       D:=SYSDATE();
       Generate_MDoc(L_MDoc.md_VOD, D);
       Tck34_Generate_PDoc(D, 1);
       MAKEPART(R, TopDoc);
       i:=0;
       WHILE L_XDoc.xdc_PositionOn(genPDocId, i) DO
        _XDI     :=L_XDoc.xdc_Item(genPDocId, i);
        _XDocType:=L_XDoc.ExtractXDocType(_XDI);
        IF    _XDocType = L_XDoc.xdt_PDoc THEN
         CONFORM(PDoc, Dest);
         MAKEPART(R, LineDoc, L_XDoc.XDocStr(_XDI), PDoc.Date, PDoc.Total);
        ELSIF _XDocType = L_XDoc.xdt_MDoc THEN
         CONFORM(MDoc, Dest);
         MAKEPART(R, LineDoc, L_XDoc.XDocStr(_XDI), MDoc.Date, MDoc.Total);
        ELSE
         L_General.Error(" 㬥 " + _XDocType + "  ।");
        END;
        INC(i);
       END;
       MAKEPART(R, BotDoc);
       MakeDoc:=0;
       Tck34_Generate_PDoc(D, 0);
       _genPDocId:=_genPDocId+genPDocId+"|";
       NEXT(Tmp02);
      END; (* WHILE OCCURE(File) *)
      NEXTINEXTENDEDSEL(Tmp02, Storage, PayMth);
     END; (* WHILE OCCURE(Tmp02) *)
    END;
    NEXT(MyFirm);
   END; (* WHILE OCCURE(MyFirm) ... *)
   CLOSEREP(R);
   L_AFM.AF_PurgeTemp("Tmp02");
   IF ~!_genPDocId THEN
    Docs_OnAnyModification(_genPDocId);
    L_Pmnt.ConfirmGeneratedDocs(0, _genPDocId);
   END;
   L_General.SurveyLastReport();
  ELSE
   L_AFM.AF_PurgeTemp("Tmp02");
   L_StdFrm.RedInform(" 㬥  ନ஢");
  END;
 END {Tck34_Do};

 PRIVATE PROCEDURE GetAdjustedIRecTotTInc(VAR Sum: NUMERIC[2]);
  VAR
   i          : NUMERIC[0];
   PsgByTckRcJ: LIKE(TckRcJ.Psg);
   SumByTckRcJ: LIKE(TckRcJ.Sum);
 BEGIN
  Sum:=0;

  i:=0;
  WHILE i <= HIGH(TckRcJ.TckNbrs) DO
   IF ~!TckRcJ.TckNbrs[i] & ((TckRcJ.TckNbrs[i] # PrvNbrs[i]) | (TckRcJ.TckPsg[i] # PrvPsg[i])) THEN
    SELECT(TckRcT, Number, , TckRcS.TckRcS, i + 1);
    CONFORM(TckRcT, TckKind);
    IF TckKind.InSale > L_TRS.tks_Void THEN
     SumByTckRcJ:=(TckRcJ.TckNbrs[i] - PrvNbrs[i] - TckRcJ.TckRAmnt[i]) * TckKind.FaceVal;
     IF    L_TRS.IsMainTckKind(TckKind.TckKind, TckRcS.Date, TckRcJ.Route) | L_TRS.TckKind_wPsg() THEN
      PsgByTckRcJ:=TckRcJ.TckPsg[i] - PrvPsg[i] - TckRcJ.TckRPsg[i];
     ELSIF L_TRS.E_NeedAutoTaxTckRcJR(TckRcS.Date) &
           SEARCH(TckRcJR, TckRcS, TckRcJ.TckRcS, TckRcJ.Day, TckRcJ.StartT, TckKind.TckKind) THEN
      PsgByTckRcJ:=TckRcJR.Psg;
     ELSE
      PsgByTckRcJ:=0;
     END;

     E_TRS.Tck30_PutSingleTckKindByTckRcJ(TckRcS.Date, SumByTckRcJ, PsgByTckRcJ);

     INC(Sum, SumByTckRcJ);
    END;
   END;
   INC(i);
  END;
 END {GetAdjustedIRecTotTInc};

 PUBLIC PROCEDURE Tck35();
 BEGIN

 END {Tck35};

 PUBLIC PROCEDURE Tck30();
 BEGIN
  RT      :=rt_Daily;
  IntvlB  :=Memo.ud_cd();
  IntvlE  :=IntvlB;
  IntvlStr:="  "+L_DatTim.DateStr(IntvlB);
  RepName :="Tck30";
  Make();
 END {Tck30};

 PUBLIC PROCEDURE Tck31();
 BEGIN
  RT      :=rt_Periodic;
  IntvlB  :=Memo.ud_fr();
  IntvlE  :=Memo.ud_ut();
  IntvlStr:="  ਮ  "+L_DatTim.DateStr(IntvlB)+"  "+L_DatTim.DateStr(IntvlE);
  RepName :="Tck31";
  Make();
 END {Tck31};

 PUBLIC PROCEDURE Tck32();
 BEGIN
  Tck32_Do();
 END {Tck32};

 PUBLIC PROCEDURE Tck34();
 BEGIN
  IntvlB  :=Memo.ud_cd();
  IntvlE  :=IntvlB;
  IntvlStr:="  "+L_DatTim.DateStr(IntvlB);
  RepName :="Tck34";
  Tck34_Do();
 END {Tck34};

 PUBLIC PROCEDURE BuildFirstViP();
 BEGIN
  intBuildFirstViP(PROCREF(bfvip_ViP_PackCUCopyAtStorage));
 END {BuildFirstViP};

 PUBLIC PROCEDURE BuildFirstTOV();
 BEGIN
  intBuildFirstViP(PROCREF(bfvip_TOV_PackCUCopyAtStorage));
 END {BuildFirstTOV};

END.
