(*
%Copyright   (c) Polak IT
%Author      06.06.2006 15:37:23 POLAK\Gina
%Purpose     ᪨ ⬥⪨  䨪  ਮ
%Type        report
%Specific    AP
%Modified    26.02.2013 13:51:10 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT Memo, L_General, L_DatTim, L_BegRWS, L_OwnData, L_AFM, L_Str;

(*
$P{ TopDtwo:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
?, L, "D.N.y"
@
############################################################################## ########## #####
=#####=========================================================================================
|             ᪨ ⬥⪨  䨪  ਮ  ##########  ##########             |
}
*)

(*
$P{ TopSortDtwo:
?, L, ""
?, L, ""
@
|---------------------------------------------------------------------------------------------|
| ### ##################################################################################|
|---------------------------------------------------------------------------------------------|
| |⥫                       |  |             |                      |
|-----|-------------------------------|-------|---------------|-------------------------------|
}
*)

 PRIVATE PROCEDURE GetName(_TSN: LIKE(Staff.TSN)): STRING[];
 BEGIN
  IF ~!_TSN THEN
   L_General.Assert(SEARCH(Staff, TSN, _TSN), "  ࠡ⭨ "+_TSN);
   CONFORM(Staff, Man);
   RETURN L_Str.ShortName(Man.Name)
  ELSE
   RETURN "";
  END;
 END {GetName};

(*
$P{ LineDtwo:
Dtwo.Date, L, "D.N"
Dtwo.TSN, L, ""
GetName(Dtwo.TSN), L, ""
ExitClassSign(Dtwo.ExitClss), L, ""
Dtwo.BoxNbr, L, ""
?, L, ""
Dtwo.GuardTSN, L, ""
Dtwo.GuardNam, L, ""
@
|#####|##### #########################|#######|#### ##########|##### #########################|
}
*)

(*
$P{ BotDtwo:
@
=(c) Polak=====================================================================================
}
*)

 PRIVATE PROCEDURE DtwoOperatorNotes(From, UpTo: DATE);
  CONST
   RepName = "Two02";
  VAR
   D    : DATE;
   Day  : NUMERIC[0];
   What : LIKE(TrfWO.What[0]);
   ExCls: LIKE(ExitClss.ExitClss);
   _ECFM: L_BegRWS.tECFixMethod;
 BEGIN
  L_AFM.MakeIndex("tmp", "_Sort: LIKE(Dtwo.Sort);"+
                            "_Date: LIKE(Dtwo.Date);"+
                            "_TSN: LIKE(Dtwo.TSN);"+
                            "_Dtwo: LIKE(Dtwo.Dtwo)");

  SELECT(Dtwo, Source);
  SRCINSEL(Dtwo, GE, , From);
  WHILE OCCURE(Dtwo) & (Dtwo.Date<=UpTo) DO
   CHANGESEL(Dtwo, Source, , Dtwo.Date);
   SRCINSEL(Dtwo, EQ, , L_BegRWS.twosrc_Operator);
   WHILE OCCURE(Dtwo) & (Dtwo.Source=L_BegRWS.twosrc_Operator) DO
    PROMPT(": "+L_DatTim.DateStr(Dtwo.Date));
    ADD(tmp, tmp, , Dtwo.Sort, Dtwo.Date, Dtwo.TSN, Dtwo.Dtwo);
    NEXT(Dtwo);
   END; (* WHILE OCCURE(Dtwo) ... *)
   LAST(Dtwo);
   CHANGESEL(Dtwo, Source);
   NEXT(Dtwo);
  END; (* WHILE OCCURE(Dtwo) ... *)

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, TopDtwo, RepName, From, UpTo);

  SELECT(tmp, tmp);
  WHILE OCCURE(tmp) DO
   IF ~!tmp._Sort THEN
    L_General.Assert(SEARCH(Sort, Sort, tmp._Sort), "  ᥪ "+tmp._Sort);
    MAKEPART(R, TopSortDtwo, Sort.Sort, Sort.Name);
   ELSE
    MAKEPART(R, TopSortDtwo, "", "");
   END;
   CHANGESEL(tmp, tmp, , tmp._Sort);
   WHILE OCCURE(tmp) DO
    PROMPT(": "+L_DatTim.DateStr(tmp._Date)+" "+tmp._Dtwo);
    L_General.Assert(SEARCH(Dtwo, Dtwo, tmp._Date, tmp._Dtwo), "  ப 鸞");
    IF ~!Dtwo.BoxNbr THEN
     CONFORM(Dtwo, Car);
     MAKEPART(R, LineDtwo, Car.StateNbr);
    ELSE
     MAKEPART(R, LineDtwo, "");
    END;
    NEXT(tmp);
   END; (* WHILE OCCURE(tmp) ... *)
   LAST(tmp);
   CHANGESEL(tmp, tmp);
   NEXT(tmp);
  END; (* WHILE OCCURE(tmp) ... *)

  MAKEPART(R, BotDtwo);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("tmp");
 END {DtwoOperatorNotes};

BEGIN
 IF    MODE = 101 THEN
  DtwoOperatorNotes(Memo.ud_fr(), Memo.ud_ut());
 ELSE
  L_General.BadMode(MODE);
 END;
END.