(*
%Copyright   (c) Polak IT
%Author      14.07.2006 18:10:36 POLAK\San
%Purpose     ந  ஢  
%Type        operation
%Specific    AP
%Modified    04.01.2014 18:09:05 POLAK\Gina
%Environment
*)

 MODULE two03 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_Str, L_DatTim, L_BegRWS, L_two, L_OwnData,
        L_AFM, L_Way, Math, L_StdFrm, E_two;

 CONST
  RepName = "Two03";

 VAR
  WDAmo           : SCAL[31];
  ReserveExitClss : LIKE(ExitClss.ExitClss);
  NeedTKindRgn    : LIKE(TKind.Rgn);
  GuAmntOnDays,
  ExitAmntOnDays  : NUMERIC[0][42];
  CurPass,
  OrdCnt,
  BegIdx,
  EndIdx          : NUMERIC[0];

(*
$P{ TopU:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_cd(), L, "D.N.y"
Memo.ud_me(), L, "D.N.y"
@
############################################################# ########## #####
=#####========================================================================
|             室  ਮ  ##########  ##########            |
|----------------------------------------------------------------------------|
|室    | 室  |      ||. ||                         |
|---------|--------------|----------|--|-----|-----|-------------------------|
}
*)

(*
$P{ LineU:
StExit.Exit, L, ""
ExitClss.ExitClss, L, ""
ExitClss.Sign, L, ""
?, L, "D.N.y"
StExit.Change, L, " |1|2"
L_Way.FullStExitBegTimeStr(), L, ""
L_Way.FullStExitStopTimStr(), L, ""
@
|#########|###### #######|##########|##|#####|#####|                         |
}
*)

(*
$P{ BotU:
@
=(c) Polak====================================================================
}
*)

(*
$P{ Top1:
@
  室
-------------------------
}
*)

(*
$P{ Line1:
ExitL.SortNbr, R, "0"
ExitL.Exit, R, "0"
@
###### ############
}
*)

 PRIVATE PROCEDURE RandomNbr(): NUMERIC[0];
 BEGIN
  RETURN L_StdFrm.GetRandomNumber() MOD 100 (*⠢ ⮫쪮  騩 墮*);
 END {RandomNbr};

 PRIVATE PROCEDURE InsExitL();
  VAR
   D: DATE;
   i: NUMERIC[0];
 BEGIN
  SETEMPTY(ExitL.Work, ExitL.Closed);
  D:=Memo.ud_cd();
  WHILE D <= Memo.ud_me() DO
   i:=L_two.Date2Idx(D);
   ExitL.Work[i]  :=L_Way._CheckExitOnDate(StExit.Exit, D) = L_Way.exvld_Active;
   ExitL.Closed[i]:=0;
   INC(D);
  END;
  L_Way.GetExitFullTimes(L_Way.rwswho_Guard, ExitL.BegTim, ExitL.EndTim);
  ExitL.SortNbr :=RandomNbr();
  ExitL.ExitClss:=StExit.ExitClss;
  ExitL.Change  :=StExit.Change;
  ExitL.Exit    :=StExit.Exit;
  INSERT(ExitL);
 END {InsExitL};

 PRIVATE PROCEDURE Print();
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top1);
  SELECT(ExitL, ExitL);
  WHILE OCCURE(ExitL) DO
   MAKEPART(R, Line1);
   NEXT(ExitL);
  END; (* WHILE OCCURE(ExitL) ... *)
 END {Print};

 PRIVATE PROCEDURE MkExitList();
 BEGIN
  L_AFM.MakeMultipleIndex("ExitL",
                          "SortNbr : NUMERIC[0];"+
                          "ExitClss: LIKE(ExitClss.ExitClss);"+
                          "Change  : LIKE(StExit.Change);"+
                          "Exit    : LIKE(StExit.Exit);"+
                          "BegTim  : NUMERIC[3];"+
                          "EndTim  : NUMERIC[3];"+
                          "Work    : SCAL[2][42];"+
                          "Closed  : SCAL[2][42]",
                          "ExitL   : SortNbr, Exit; Exit: Exit; ExitClss: ExitClss, Change");

  SELECT(StExit, Exit);
  WHILE OCCURE(StExit) DO
   PROMPT(": 室 " + StExit.Exit);
   IF (StExit.Strict = L_Way.ExitStrict_Reg) & (StExit.GuNeed = L_Way.egn_Required) THEN
    IF L_DatTim.IsActiveInIntvl(Memo.ud_cd(), Memo.ud_me()+1, StExit.FromD, StExit.UpDate) THEN
     InsExitL();
    END;
   END;
   NEXT(StExit);
  END; (* WHILE OCCURE(StExit) ... *)

  Print();
 END {MkExitList};

 PRIVATE PROCEDURE RestTime(_B, _E: NUMERIC[3]): NUMERIC[3];
 BEGIN
  WHILE _B < _E DO
   INC(_B, 24);
  END;
  RETURN _B-_E;
 END {RestTime};

 PRIVATE PROCEDURE PreviousIsLate(D: DATE; BegTime: NUMERIC[3]): SCAL[2];
  VAR
   _GuBegTime,
   _GuStopTime,
   _EndTime       : NUMERIC[3];
   Result         : SCAL[2];
   NormalRestTime,
   MinimalRestTime: NUMERIC[3];
 BEGIN
  Result:=0;
  SAVE(Mtwo);
  DEC(D); _EndTime:=MINOF(_EndTime);
  IF SELECT(Mtwo, TSN, Mtwo.TSN, L_DatTim.Per(D)) & ~!Mtwo.ExitClss[L_two.Date2Idx(D)] THEN
   L_two.E_RestPeriod(D, Mtwo.Sort, Mtwo.Who, NormalRestTime, MinimalRestTime);
   SELECT(StExit, ExitClss, , Mtwo.ExitClss[L_two.Date2Idx(D)]);
   WHILE OCCURE(StExit) DO
    IF StExit.Strict = L_Way.ExitStrict_Reg THEN
     IF L_Way._CheckExitOnDate(StExit.Exit, D) = L_Way.exvld_Active THEN
      L_Way.GetExitFullTimes(L_Way.rwswho_Guard, _GuBegTime, _GuStopTime);
      _EndTime:=Math.Max(_EndTime, _GuStopTime);
     END;
    END;
    NEXT(StExit);
   END; (* WHILE OCCURE(StExit) ... *)
   Result:=(_EndTime > MINOF(_EndTime)) & (RestTime(BegTime, _EndTime)<NormalRestTime);
  END;
  RESTORE(Mtwo);
  RETURN Result;
 END {PreviousIsLate};

 PRIVATE PROCEDURE NextIsEarly(D: DATE; EndTim: NUMERIC[3]): SCAL[2];
  VAR
   _GuBegTime,
   _GuStopTime,
   _BegTime       : NUMERIC[3];
   Result         : SCAL[2];
   NormalRestTime,
   MinimalRestTime: NUMERIC[3];
 BEGIN
  Result:=0;
  SAVE(Mtwo);
  INC(D); _BegTime:=MAXOF(_BegTime);
  IF SELECT(Mtwo, TSN, Mtwo.TSN, L_DatTim.Per(D)) & ~!Mtwo.ExitClss[L_two.Date2Idx(D)] THEN
   L_two.E_RestPeriod(D, Mtwo.Sort, Mtwo.Who, NormalRestTime, MinimalRestTime);
   SELECT(StExit, ExitClss, , Mtwo.ExitClss[L_two.Date2Idx(D)]);
   WHILE OCCURE(StExit) DO
    IF (StExit.Strict = L_Way.ExitStrict_Reg) | (Mtwo.ExitClss[L_two.Date2Idx(D)] = ReserveExitClss) THEN
     IF L_Way._CheckExitOnDate(StExit.Exit, D) = L_Way.exvld_Active THEN
      L_Way.GetExitFullTimes(L_Way.rwswho_Guard, _GuBegTime, _GuStopTime);
      _BegTime:=Math.Min(_BegTime, _GuBegTime);
     END;
    END;
    NEXT(StExit);
   END; (* WHILE OCCURE(StExit) ... *)
   IF _BegTime < MAXOF(_BegTime) THEN
    Result:=RestTime(_BegTime, EndTim)<NormalRestTime;
   END;
  END;
  RESTORE(Mtwo);
  RETURN Result;
 END {NextIsEarly};

 PRIVATE PROCEDURE _SuitableExit(D: DATE): SCAL[2];
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=L_two.Date2Idx(D);
  RETURN ExitL.Work[i] & ~ExitL.Closed[i];
 END {_SuitableExit};

 PRIVATE PROCEDURE GetTKindRgnOfExit(_Exit: LIKE(StExit.Exit); D: DATE): LIKE(TKind.Rgn);
  VAR
   i      : NUMERIC[0];
   MaxTime: NUMERIC[3];
   TimsTK : NUMERIC[3][MAXOF(TKind.Rgn)+1];
   Result : LIKE(TKind.Rgn);
   _Route : LIKE(SEJobs.Route);
 BEGIN
  SETZERO(TimsTK);
  SELECT(SEJobs, Exit, , _Exit);
  CONFORM(SEJobs, Route);
  _Route:=SEJobs.Route;
  L_Way.StandOnRouteTKind(D);
  WHILE OCCURE(SEJobs) & (TKind.Rgn>L_Way.tkrgn_Intercity) DO
   CONFORM(SEJobs, WJMode);
   IF WJMode.WJType # L_Way.WJType_Void THEN
    INC(TimsTK[TKind.Rgn], SEJobs.StopT - SEJobs.StartT);
   END;
   IF NEXT(SEJobs) & (_Route#SEJobs.Route) THEN
    CONFORM(SEJobs, Route);
    L_Way.StandOnRouteTKind(D);
   END;
  END; (* WHILE OCCURE(SEJobs) ... *)
  SETEMPTY(Result);
  SETZERO(i, MaxTime);
  WHILE i <= MAXOF(TKind.Rgn) DO
   IF MaxTime < TimsTK[i] THEN
    Result :=i;
    MaxTime:=TimsTK[i];
   END;
   INC(i);
  END;
  RETURN Result;
 END {GetTKindRgnOfExit};

 PRIVATE PROCEDURE GoodTkind(D: DATE): SCAL[2];
 BEGIN
  IF !NeedTKindRgn THEN
   RETURN 1;
  ELSE
   RETURN NeedTKindRgn = GetTKindRgnOfExit(ExitL.Exit, D);
  END;
 END {GoodTkind};

 PRIVATE PROCEDURE SuitableExit(D: DATE): SCAL[2];
 BEGIN
  RETURN (Mtwo.What[L_two.Date2Idx(D)] = ExitL.Change) & _SuitableExit(D) & GoodTkind(D) &
         ~PreviousIsLate(D, ExitL.BegTim) &
         ((D=Memo.ud_me()) | ~NextIsEarly(D, ExitL.EndTim));
 END {SuitableExit};

 PRIVATE PROCEDURE E_BegRWS_NeedYesterdayAnalyze(D: DATE): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_two.two05_NeedSameExitInPairDays);
  IF ~!Local THEN
   RETURN Local(D, EMPTYOF(Sort.Sort), L_two.who_Guard);
  ELSE
   RETURN 0;
  END;
 END {E_BegRWS_NeedYesterdayAnalyze};

 PRIVATE PROCEDURE WorkYesterday(D: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(Mtwo);
  DEC(D);
  IF SELECT(Mtwo, TSN, Mtwo.TSN, L_DatTim.Per(D)) & L_BegRWS.IsWorkDayType(Mtwo.What[L_two.Date2Idx(D)]) THEN
   Result:=1;
  ELSE
   Result:=0;
  END;
  RESTORE(Mtwo);
  RETURN Result;
 END {WorkYesterday};

 PRIVATE PROCEDURE AsYesterday(D: DATE): SCAL[2];
  VAR
   _ExitClss: LIKE(ExitClss.ExitClss);
   _Change  : L_BegRWS.tDayType;
 BEGIN
  IF E_BegRWS_NeedYesterdayAnalyze(Memo.ud_cd()) & (WDAmo < 2) THEN
   SAVE(Mtwo);
   _Change:=Mtwo.What[L_two.Date2Idx(D)];
   DEC(D);
   IF SELECT(Mtwo, TSN, Mtwo.TSN, L_DatTim.Per(D)) &
      ~!Mtwo.ExitClss[L_two.Date2Idx(D)] &
      (Mtwo.What[L_two.Date2Idx(D)] = _Change) THEN
    _ExitClss:=Mtwo.ExitClss[L_two.Date2Idx(D)];
    INC(D);
    SELECT(StExit, ExitClss, , _ExitClss);
    WHILE OCCURE(StExit) DO
     IF StExit.Strict = L_Way.ExitStrict_Reg THEN
      IF L_Way._CheckExitOnDate(StExit.Exit, D) = L_Way.exvld_Active THEN
       IF SELECT(ExitL, Exit, StExit.Exit) & _SuitableExit(D) THEN
        RESTORE(Mtwo);
        RETURN 1;
       END;
      END;
     END;
     NEXT(StExit);
    END; (* WHILE OCCURE(StExit) ... *)
   END;
   RESTORE(Mtwo);
  END;
  RETURN 0;
 END {AsYesterday};

 PRIVATE PROCEDURE FindSuitableExit(VAR _SortNbr: NUMERIC[0]; D: DATE);
  VAR
   Idx    : NUMERIC[0];
   Found  : SCAL[2];
 BEGIN
  Found:=AsYesterday(D);
  IF ~Found THEN
   SELECT(ExitL, ExitL);
   IF ~!_SortNbr THEN
    SRCINSEL(ExitL, GT, , _SortNbr);
   END;
   WHILE OCCURE(ExitL) & ~Found DO
    IF SuitableExit(D) THEN
     Found:=1;
     _SortNbr:=ExitL.SortNbr;
    ELSE
     NEXT(ExitL);
    END;
   END; (* WHILE OCCURE(ExitL) ... *)
   IF ~Found & ~!_SortNbr THEN
    SELECT(ExitL, ExitL);
    WHILE OCCURE(ExitL) & ~Found & (ExitL.SortNbr <= _SortNbr) DO
     IF SuitableExit(D) THEN
      Found:=1;
      _SortNbr:=ExitL.SortNbr;
     ELSE
      NEXT(ExitL);
     END;
    END; (* WHILE OCCURE(ExitL) ... *)
   END;
  END;
  IF Found THEN
   INC(OrdCnt);
   Idx:=L_two.Date2Idx(D);
   ExitL.Closed[Idx]:=1;
   REPLACE(ExitL);
   L_two.m_ChangeDA(L_two.da_ExitClss, L_two.m_SubstituteDA(L_two.da_ExitClss, ExitL.ExitClss, Idx, L_BegRWS.twosrc_Auto), Idx, L_BegRWS.twosrc_Auto);
  END;
 END {FindSuitableExit};

 PRIVATE PROCEDURE PrintUnclosedExit();
  VAR
   D: DATE;
 BEGIN
  MAKEPART(R, TopU);
  SELECT(ExitL, ExitClss);
  WHILE OCCURE(ExitL) DO
   PROMPT(" 室: "+ExitL.Exit);
   D:=Memo.ud_cd();
   WHILE D <= Memo.ud_me() DO
    IF _SuitableExit(D) THEN
     SEARCH(ExitClss, ExitClss, , ExitL.ExitClss);
     SEARCH(StExit, Exit, , ExitL.Exit);
     MAKEPART(R, LineU, D);
    END;
    INC(D);
   END;
   NEXT(ExitL);
  END; (* WHILE OCCURE(ExitL) ... *)

  MAKEPART(R, BotU);
  CLOSEREP(R);
 END {PrintUnclosedExit};

 PRIVATE PROCEDURE GoodGuardForReserv(i: NUMERIC[0]): SCAL[2];
 BEGIN
  RETURN !Mtwo.ExitClss[i] & L_two.m_ReplacableSource(i, L_two.da_ExitClss, L_BegRWS.twosrc_Auto) & L_BegRWS.IsWorkDayType(Mtwo.What[i]);
 END {GoodGuardForReserv};

 PRIVATE PROCEDURE MkReserv();
  VAR
   D          : DATE;
   FreeGuard,
   Idx        : NUMERIC[0];
   Forward    : SCAL[2];
 BEGIN
  L_General.Assert(SEARCH(StExit, Exit, L_Way.E_GuardReserveExit(Memo.ud_cd())), "  १");

  ReserveExitClss:=StExit.ExitClss;

  SETZERO(ExitAmntOnDays, FreeGuard);

  SELECT(ExitL, ExitL);
  WHILE OCCURE(ExitL) DO
   PROMPT(" ࠡ 室: "+ExitL.Exit);
   D:=Memo.ud_cd();
   WHILE D <= Memo.ud_me() DO
    IF _SuitableExit(D) THEN
     INC(ExitAmntOnDays[L_two.Date2Idx(D)]);
    END;
    INC(D);
   END;
   NEXT(ExitL);
  END; (* WHILE OCCURE(ExitL) ... *)

  Forward:=1;
  SELECT(GuardL, GuardL);
  D:=Memo.ud_cd();
  WHILE D <= Memo.ud_me() DO
   PROMPT("祭 १ࢮ: "+L_DatTim.DateStr(D));
   Idx:=L_two.Date2Idx(D);
   FreeGuard:=GuAmntOnDays[Idx]-ExitAmntOnDays[Idx];
   WHILE FreeGuard > 0 DO
    L_General.CallUs(SEARCH(Mtwo, Mtwo, GuardL.Mtwo));
    IF GoodGuardForReserv(Idx) & (*????*) (Mtwo.What[Idx] = StExit.Change) THEN
     L_two.m_ChangeDA(L_two.da_ExitClss, L_two.m_SubstituteDA(L_two.da_ExitClss, StExit.ExitClss, Idx, L_BegRWS.twosrc_Auto), Idx, L_BegRWS.twosrc_Auto);
     DEC(FreeGuard);
    END;
    IF    Forward & ~NEXT(GuardL) THEN
     Forward:=0;
     LAST(GuardL);
    ELSIF ~Forward & ~PREV(GuardL) THEN
     Forward:=1;
     FIRST(GuardL);
    END;
   END;
   INC(D);
  END;
 END {MkReserv};

 PRIVATE PROCEDURE TKindCond(i: NUMERIC[0]): SCAL[2];
 BEGIN
  IF !NeedTKindRgn THEN
   RETURN 1;
  ELSE
   RETURN (OrdCnt<=4) | L_BegRWS.IsWorkDayType(Mtwo.What[i]);
  END;
 END {TKindCond};

 PRIVATE PROCEDURE WorkDayCond(): SCAL[2];
  VAR
   i: NUMERIC[0];
   D: DATE;
 BEGIN
  IF CurPass < 8 THEN
   IF !GuardL.Pass | ((GuardL.Pass DIV 4) < (CurPass DIV 4)) THEN
    D:=Memo.ud_cd() + CurPass MOD 4;
    RETURN L_BegRWS.IsWorkDayType(Mtwo.What[L_two.Date2Idx(D)]) & WorkYesterday(D);
   ELSE
    RETURN 0;
   END;
  ELSE
   RETURN 1;
  END;
 END {WorkDayCond};

 PRIVATE PROCEDURE NormalPair(i: NUMERIC[0]): SCAL[2];
 BEGIN
  IF CurPass = 8 THEN
   RETURN 1;
  ELSIF (i > BegIdx) & (Mtwo.ExitClss[i-1] = ReserveExitClss) THEN
   RETURN 0;
  ELSIF (i < EndIdx) & (Mtwo.ExitClss[i+1] = ReserveExitClss) THEN
   RETURN 0;
  ELSIF (i > BegIdx) & ~L_BegRWS.IsWorkDayType(Mtwo.What[i-1]) &
        (i < EndIdx) & ~L_BegRWS.IsWorkDayType(Mtwo.What[i+1]) THEN
   RETURN 0;
  ELSIF (i > BegIdx) &  L_BegRWS.IsWorkDayType(Mtwo.What[i-1]) & !Mtwo.ExitClss[i-1] THEN
   RETURN 0;
  ELSE
   RETURN 1;
  END;
 END {NormalPair};

 PRIVATE PROCEDURE OneTKind();
  VAR
   i      : NUMERIC[0];
   SortNbr: NUMERIC[0];
 BEGIN
  SETEMPTY(SortNbr);
  SELECT(GuardL, GuardL);
  IF ((CurPass DIV 2) MOD 2) = 1 THEN
   LAST(GuardL);
  END;
  WHILE OCCURE(GuardL) DO
   L_General.Assert(SEARCH(Mtwo, Mtwo, GuardL.Mtwo), "  Mtwo "+GuardL.Mtwo);
   PROMPT("ந쭠 ࠧ浪: " + L_Str.IntStr(CurPass) +  ", " + L_Str.IntStr(GuardL.SortNbr) + " (" + Mtwo.TSN + ")");
   OrdCnt:=0;
   WDAmo:=0;
   IF WorkDayCond() THEN
    i:=BegIdx;
    WHILE (i <= EndIdx) & TKindCond(i) DO
     IF !Mtwo.ExitClss[i] & L_two.m_ReplacableSource(i, L_two.da_ExitClss, L_BegRWS.twosrc_Auto) THEN
      IF L_BegRWS.IsWorkDayType(Mtwo.What[i]) THEN
       IF NormalPair(i) THEN
        FindSuitableExit(SortNbr, L_two.Idx2Date(i, Memo.ud_mb()));
        INC(WDAmo);
       END;
      ELSE
       WDAmo:=0;
      END;
     END;
     INC(i);
    END;
    GuardL.Pass:=CurPass;
    REPLACE(GuardL);
   END;
   IF ((CurPass DIV 2) MOD 2) = 1 THEN
    PREV(GuardL);
   ELSE
    NEXT(GuardL);
   END;
  END; (* WHILE OCCURE(GuardL) ... *)
  INC(CurPass);
 END {OneTKind};

 PUBLIC PROCEDURE FillGuard();
  VAR
   i: NUMERIC[0];
 BEGIN
  L_StdFrm.Question("ந쭠 ࠧ浪 ஢  ਮ  "+L_DatTim.DateStr(Memo.ud_cd())+"  "+L_DatTim.DateStr(Memo.ud_me()));
  L_General.Assert(Memo.ud_cd() >= SYSDATE(), "浪   ਮ ⨬");
  L_General.Assert(~L_BegRWS.E_GuardFixedByDriver(Memo.ud_me()), " ९  ⥫ﬨ|ந쭠 ࠧ浪 室  ந");

  L_two.Renovate(Memo.ud_mb(), L_two.rm_NotActual);

  BegIdx:=L_two.Date2Idx(Memo.ud_cd());
  EndIdx:=L_two.Date2Idx(Memo.ud_me());

  MkExitList();

  SETZERO(GuAmntOnDays, ExitAmntOnDays);

  L_AFM.MakeMultipleIndex("GuardL",
                          "SortNbr : NUMERIC[0];"+
                          "TSN     : LIKE(Staff.TSN);"+
                          "Pass    : NUMERIC[0];"+
                          "Mtwo    : LIKE(Mtwo.Mtwo)",
                          "GuardL  : SortNbr");

  SELECT(Mtwo, Who, , Memo.ud_mb(), L_two.who_Guard);
  WHILE OCCURE(Mtwo) DO
   PROMPT("⮢ ᯨ᪠  室: " + Mtwo.TSN);
   i:=BegIdx;
   WHILE i <= EndIdx DO
    IF ~!Mtwo.ExitClss[i] THEN
     IF SELECT(ExitL, ExitClss, Mtwo.ExitClss[i], Mtwo.What[i]) THEN
      WHILE OCCURE(ExitL) DO
       ExitL.Closed[i]:=1;
       REPLACE(ExitL);
       NEXT(ExitL);
      END;
     ELSE
      (* ??? *)
     END;
    END;
    IF !Mtwo.ExitClss[i] & L_BegRWS.IsWorkDayType(Mtwo.What[i]) THEN
     INC(GuAmntOnDays[i]);
    END;
    INC(i);
   END;
   GuardL.SortNbr:=Mtwo.TSN(*RandomNbr()*);
   GuardL.TSN  :=Mtwo.TSN;
   SETEMPTY(GuardL.Pass);
   GuardL.Mtwo:=Mtwo.Mtwo;
   INSERT(GuardL);
   NEXT(Mtwo);
  END; (* WHILE OCCURE(Mtwo) ... *)

  MkReserv();

  NeedTKindRgn:=L_Way.tkrgn_City;
  CurPass:=0;
  OneTKind();
  OneTKind();
  OneTKind();
  OneTKind();

  SETEMPTY(NeedTKindRgn);
  OneTKind();
  OneTKind();
  OneTKind();
  OneTKind();

  OneTKind();
  OneTKind();

  PrintUnclosedExit();

  L_AFM.AF_PurgeTemp("ExitL");
  L_AFM.AF_PurgeTemp("GuardL");
 END {FillGuard};

END.