(*
%Copyright   (c) Polak IT
%Author      26.04.2010 19:28:16 POLAK\Bor
%Purpose
%Type        control,report,temporary,convertor,operation,library,to paste
%Specific    AP,AP_PC,AP_PT,SYS,TOOL,LOC
%Modified    31.08.2011 19:20:41 POLAK\Bor
%Environment
*)

 IMPORT Memo, L_General, L_DatTim, L_MDoc, L_XDoc, L_Dest, L_Fuel, L_Events, L_Env;

 PRIVATE PROCEDURE GetStartRfOpPer(): DATE;
  VAR
   P: DATE;
 BEGIN
  P:=L_DatTim.IncMonth(L_Env.aptm_Start, -1);
  L_General.Assert(L_Env.FlAcntLev(P) # L_Fuel.fal_RefuelOperator, " 뫠 ᥣ?|  㫨஢   ?");
  REPEAT
   P:=L_DatTim.IncMonth(P, +1);
   IF L_Env.FlAcntLev(P) = L_Fuel.fal_RefuelOperator THEN
    RETURN P;
   END;
  UNTIL P>(SYSDATE()+40);
  L_General.Error(" ⠭ L_Env.FlAcntLev() = L_Fuel.fal_RefuelOperator");
 END {GetStartRfOpPer};

 PUBLIC PROCEDURE CancelOldFuelNOV();
  VAR
   StartP: DATE;
   trgDest: LIKE(Dest.Dest);
 BEGIN
  L_General.SilentPrgsOnly();
  StartP:=GetStartRfOpPer();
  STDMSG("㫨஢    ⮯  "+L_DatTim.PeriodStr(StartP)+"?", CHOICE);
  trgDest:=L_Dest.erkn_Get(StartP, L_Dest.erkn_FuelStationMovement);
  SELECT(MDoc, MDKDest, , L_MDoc.md_NOV, trgDest);
  WHILE OCCURE(MDoc) & (MDoc.Date < StartP) DO
   PROMPT(L_MDoc.GetMDocStrNbr());
   IF MDoc.Status # L_MDoc.st_Canceled THEN
(*
    IF ~!L_MDoc.curRefToXDoc_GetId() THEN
     L_MDoc.curRefToXDoc_PositionOn(L_XDoc.xdt_RWayS);
    ELSE
     L_General.Error(" 㪠  ⥢ ");
    END;
    Memo.gl_SetCurDate(RWayS.Date);
    CALL(RWayS, L_Events.md_StreamMakeUnDone);
    L_General.CallUs(~RWayS.Done);
*)
    Memo.gl_SetCurDate(MDoc.Date);
    L_MDoc.Cancel_MDoc();
(*
    Memo.gl_SetCurDate(RWayS.Date);
    CALL(RWayS, L_Events.md_StreamMakeDone);
*)
   END;
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)
 END {CancelOldFuelNOV};

END.