(*
%Copyright   (c) Polak Computer System
%Author      13.04.2001 20:54:29 BOR
%Purpose     ஢ન ப WayLCar
%Type        control
%Specific    AP
%Modified    10.04.2012 12:10:00 ROBOT by POLAK\LDA
*)

 IMPORT L_Events, L_Car;

 PRIVATE PROCEDURE WayLCar_OnBeforeInsert();
 BEGIN
  WayLCar.RWayDate:=RWayS.Date;
  REPLACE(WayLCar);
 END {WayLCar_OnBeforeInsert};

 PRIVATE PROCEDURE WayLCar_OnAfterEdIns();
 BEGIN
  L_Car.CheckAdaptability(WayLCar.BoxNbr, WayLCar.RWayDate, 0);
 END {WayLCar_OnAfterEdIns};

 PRIVATE PROCEDURE WayLCar_OnAfterEdit();
 BEGIN
  WayLCar_OnAfterEdIns();
 END {WayLCar_OnAfterEdit};

 PRIVATE PROCEDURE WayLCar_OnAfterInsert();
 BEGIN
  WayLCar_OnAfterEdIns();
 END {WayLCar_OnAfterInsert};

BEGIN
 IF L_Events.IsInternalEvents(MODE) THEN
   ^(L_Events.GetHandlerName(Event))();
 ELSE
  L_General.BadMode(MODE);
 END; (* IF MODE ... *)
END.
