(*
%Copyright   (c) Polak IT
%Author      19.01.2012 11:53:12 POLAK\MLB
%Purpose       祭 㬥⠬
%Type        report
%Specific    AP,AP_PC,AP_PT,SYS,TOOL,LOC
%Modified    14.03.2013 11:41:05 POLAK\GAV
%Environment
*)

 IMPORT L_General, L_OwnData, Memo, L_XDF, L_AFM, L_Str, L_XDoc, L_DatTim, L_bp;

 CONST

  t_Pool               = " ᯮ| ᯮ,  ப ᯮ   㯨|ᯮ  窮";
  t_NotDone            = 0;
  t_DeadlineHasNotCome = 1;
  t_DoneWithDelay      = 2;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
@
############################################################################################# ########## #####
=#####========================================================================================================
|                        㬥  ᯮ  ஫  ﭨ  ##########                       |
}
*)

(*
$P{ SubTop:
XDF01.Type, C, t_Pool
@
|------------------------------------------------------------------------------------------------------------|
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|ப      |ᯮ⥫                           |㬥                                             |  |
|----------|--------------------------------------|-----------------------------------------------------|----|
}
*)

(*
$P{ Line:
XDF01.TrgDate, L, "D.N.y"
AcsObj.AcsObj, L, ""
AcsObj.FullName, L, ""
L_XDoc.extXDocStr(XDF01.XDocId, L_XDoc.xdast_wDate), L, ""
XDF01.CntDays, R, ""
@
|##########|#### #################################|#####################################################|####|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PUBLIC PROCEDURE XDF01();
  CONST
   bpId = "XDF01";
  VAR
   CurD             : DATE;
   HasImplementation: SCAL[2];
   TrgDate,
   SrcDate          : DATE;
   Type             : SCAL[3];
   CntDays          : NUMERIC[0];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.extBegin(bpId, "㬥  ᯮ  ஫", L_bp.t_Prc_wF3, L_General.tc_Entire, L_bp.pt_Usual);
  L_AFM.MakeMultipleIndex("XDF01", "XDocId : LIKE(ODoc.XDocId);" +
                                   "To     : LIKE(AcsObj.AcsObj);" +
                                   "TrgDate: DATE;" +
                                   "SrcDate: DATE;" +
                                   "Type   : SCAL[3];" +
                                   "CntDays: NUMERIC[0]",
                             "XDocId: XDocId, To; Type: Type, CntDays");
  CurD:=Memo.ud_cd();
 
  SELECT(XDocFlow, XDocFlow);
  WHILE OCCURE(XDocFlow) DO
   PROMPT(" : " + XDocFlow.XDocId);
   IF XDocFlow.Action = L_XDF.a_Permission THEN
    TrgDate:=XDocFlow.TrgDate;
    SETEMPTY(SrcDate, Type, CntDays);

    SAVE(XDocFlow);
    HasImplementation:=0;
    SELECT(XDocFlow, XDocFlow, , XDocFlow.XDocId);
    WHILE OCCURE(XDocFlow) & ~HasImplementation DO
     IF XDocFlow.Action = L_XDF.a_Implementation THEN
      HasImplementation:=1;
      IF XDocFlow.SrcDate > TrgDate THEN
       SrcDate:=XDocFlow.SrcDate;
       Type   :=t_DoneWithDelay;
       CntDays:=TrgDate - SrcDate;
      END;
     END;
     NEXT(XDocFlow);
    END; (* WHILE OCCURE(XDocFlow) ... *)
    RESTORE(XDocFlow);
    IF ~HasImplementation THEN
     CntDays:=TrgDate - CurD;
     IF TrgDate > CurD THEN
      Type:=t_DeadlineHasNotCome;
     ELSE
      Type:=t_NotDone;
     END;
    END;
    IF ~!Type THEN
     ADD(XDF01, XDocId, , XDocFlow.XDocId, XDocFlow.To);
     XDF01.TrgDate:=TrgDate;
     XDF01.SrcDate:=SrcDate;
     XDF01.Type   :=Type;
     XDF01.CntDays:=CntDays;
     REPLACE(XDF01);
    END;
   END;
   NEXT(XDocFlow);
  END; (* WHILE OCCURE(XDocFlow) ... *)
 
 
  OPENREP(R, L_General.NameConnection(bpId), Create);
  L_XDoc.sl_Init("㬥  祭 ப ᯮ");
  MAKEPART(R, Top, bpId, CurD);
  SELECT(XDF01, Type);
  WHILE OCCURE(XDF01) DO
   NARROWSEL(XDF01, Type);
   MAKEPART(R, SubTop);
   WHILE OCCURE(XDF01) DO
    PROMPT("뢮 : " + XDF01.XDocId);
    SEARCH(AcsObj, AcsObj, , XDF01.To);
    MAKEPART(R, Line);
    L_XDoc.PositionOnXDoc(XDF01.XDocId);
    L_XDoc.sl_AddCurrentXDoc(L_XDoc.ExtractXDocType(XDF01.XDocId));
    NEXT(XDF01);
   END; (* WHILE OCCURE(XDF01) ... *)
   NEXTINEXTENDEDSEL(XDF01, Type);
  END; (* WHILE OCCURE(XDF01) ... *)
  MAKEPART(R, Bot);
  L_bp.End();
 END {XDF01};

END.