(*
%Copyright   (c) Polak IT
%Author      16.04.2003 17:47:47 POLAK\RSN
%Purpose     孨᪮ ﭨ ઠ  
%Type        report
%Specific    AP
%Modified    11.07.2014 16:39:43 POLAK\GAV
%Environment
*)

 IMPORT L_General, L_DatTim, L_Car, FIO, L_Basis, L_Env, L_Str, L_Way, Memo, P_Firm, L_bp;

 VAR
  wMF: SCAL[2];

 PRIVATE PROCEDURE MakeTop_Car02();
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrStr("R", "");
   L_Basis.wb_WrStr("R", "");
  END;
  L_Basis.wb_WrStr("R", "");
  L_Basis.wb_WrStr("R", "᭮");
  L_Basis.wb_WrStr("R", "VIN");
  L_Basis.wb_WrStr("R", "ઠ");
  L_Basis.wb_WrStr("R", "㯯 ப");
  L_Basis.wb_WrStr("R", "");
  L_Basis.wb_WrStr("R", "ய⨥");
  L_Basis.wb_WrStr("R", "ய⨥");
  L_Basis.wb_WrStr("R", "ய⨥");
  L_Basis.wb_WrStr("R", "ய⨥");
  L_Basis.wb_WrStr("R", " 砫");
  L_Basis.wb_WrStr("R", " 砭");
  L_Basis.wb_WrStr("R", "騩 ஡");
  L_Basis.wb_WrStr("R", "ଠ");
  L_Basis.wb_WrStr("R", "祭");
  L_Basis.wb_WrStr("R", "஡ ᫥");
  L_Basis.wb_TermLine("R");
 END {MakeTop_Car02};

 PRIVATE PROCEDURE MakeLine_Car02(curRE,
                                  factRE     : STRING[2];
                                  curREName,
                                  factREName,
                                  MarkGName  : STRING[];
                                  StartD,
                                  StopD      : DATE;
                                  GlobRun,
                                  Norm,
                                  Run        : NUMERIC[2]);
 BEGIN
  IF wMF THEN
   CONFORM(CarLog, Column);
   CONFORM(Column, MyFirm);
   L_Basis.wb_WrScl("R", MyFirm.MyFirm);
   L_Basis.wb_WrStr("R", MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl("R", Car.BoxNbr);
  L_Basis.wb_WrStr("R", CarLog.StateNbr);
  IF ~!CarLog.VehPasp THEN
   CONFORM(CarLog, VehPasp);
   L_Basis.wb_WrStr("R", VehPasp.VIN);
  ELSE
   L_Basis.wb_WrStr("R", "");
  END;

  L_Basis.wb_WrStr("R", Mark.Name);
  L_Basis.wb_WrStr("R", MarkGName);
  L_Basis.wb_WrScl("R", Car.Column);
  L_Basis.wb_WrStr("R", curRE);
  L_Basis.wb_WrStr("R", curREName);
  L_Basis.wb_WrStr("R", factRE);
  L_Basis.wb_WrStr("R", factREName);
  L_Basis.wb_WrDat("R", StartD);
  L_Basis.wb_WrDat("R", StopD);
  L_Basis.wb_WrNum("R", GlobRun, 2);
  L_Basis.wb_WrNum("R", Norm, 2);
  L_Basis.wb_WrStr("R", L_Str.PoolItem(L_Car.purp_Pool, Car.Purpose));
  L_Basis.wb_WrNum("R", Run, 2);
  L_Basis.wb_TermLine("R");
 END {MakeLine_Car02};

 PRIVATE PROCEDURE Car02();
  CONST
   RepName = "Car02";
  VAR
   Date       : DATE;
   Norm       : LIKE(MarkREN.Norm[0]);
   EventDate  : DATE;
   Cnt,
   GlobRun,
   Run        : NUMERIC[2];
   curRepEvent: LIKE(CarEvn.RepEvent);
   EventName,
   MarkGName  : STRING[];
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  L_bp.Begin(RepName, "孨᪮ ﭨ  ⠢", L_bp.t_Basis, L_General.tc_onDate);
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  MakeTop_Car02();
  Date:=Memo.ud_cd();
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT(Car.BoxNbr);
   IF L_Env.RealBoxNbr(Car.BoxNbr) & L_DatTim.IsActive(Date, Car.BegDate, Car.EndDate) THEN
    Cnt:=0;
    L_Car.StandOnCarLog(Car.BoxNbr, Date);
    CONFORM(CarLog, Mark);
    GlobRun:=L_Car.GetGlobalRun(Car.BoxNbr, Date);
    IF L_Way.StandOnMarkG_Soft(Mark.Mark, L_Way.mgt_Math) THEN
     MarkGName:=MarkG.Name;
    ELSE
     MarkGName:="";
    END;

    SELECT(RepEvent, RepEvent);
    WHILE OCCURE(RepEvent) DO
     PROMPT(Car.BoxNbr + " " + RepEvent.RepEvent);
     IF L_DatTim.IsActive(Date, RepEvent.Begin, RepEvent.Till) THEN
      curRepEvent:=RepEvent.RepEvent;
      EventName  :=RepEvent.Name;
      EventDate  :=L_Car.NearestPastRepEventDate_Strong(Date, RepEvent.RepEvent);
      IF OCCURE(CarEvn) | (RepEvent.FrAllMrk # L_Car.fam_No) THEN
       Norm:=L_Car.MarkRepEventNorm(Mark.Mark, curRepEvent, Date, GlobRun,
                                    RepEvent.FrAllMrk # L_Car.fam_Strong);
       IF OCCURE(CarEvn) THEN
        IF ~!CarEvn.StopD THEN
         Run:=GlobRun - L_Car.GetGlobalRun(Car.BoxNbr, CarEvn.StopD);
        ELSE
         Run:=0;
        END;
        SAVE(RepEvent);
        CONFORM(CarEvn, RepEvent);
        MakeLine_Car02(curRepEvent, RepEvent.RepEvent, EventName, RepEvent.Name, MarkGName,
                       CarEvn.StartD, CarEvn.StopD, GlobRun, Norm, Run);
        RESTORE(RepEvent);
        INC(Cnt);
       ELSIF Norm > 0 THEN
        MakeLine_Car02(curRepEvent, "", EventName, "", MarkGName, L_General.EMPTY_DATE(),
                       L_General.EMPTY_DATE(), GlobRun, Norm, GlobRun);
        INC(Cnt);
       END;
      END;
     END;
     NEXT(RepEvent);
    END;

    IF Cnt = 0 THEN
     MakeLine_Car02("--", "--", "--", "--", MarkGName, L_General.EMPTY_DATE(), L_General.EMPTY_DATE(),
                    GlobRun, 0, 0);
    END;
   END; (* IF L_Env.RealBoxNbr(Car.BoxNbr) & *)
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
  FIO.Close(R);
  L_bp.End();
 END {Car02};

END.