(*
%Copyright   (c) Polak IT
%Author      14.05.2003 10:29:02 POLAK\LDA
%Purpose     ᮮ⢥⢨ 䠪᪮ ஡  ஡  ᯨ
%Type        report
%Specific    AP
%Modified    07.11.2013 18:11:31 POLAK\GAV
%Environment
*)

 IMPORT Memo, L_OwnData, L_General, P_Car, Math, L_Way, L_AFM,
        L_Car, D_TP, L_Str, E_Utils, L_bp, L_Basis, FIO, L_DatTim;

 VAR
  RepName: STRING[];
  RepType: SCAL[3];

 PRIVATE PROCEDURE PrintCorSM(CorSM: NUMERIC[3]): STRING[];
 BEGIN
  IF CorSM = 1 THEN
   RETURN "";
  END;
  RETURN FLDTOSTR(CorSM, "3.");
 END {PrintCorSM};

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
Tmp.Column, L, ""
@
########################################################################################## ########## #####
=#####=====================================================================================================
|     ᮮ⢥⢨ 䠪᪮ ஡  ஡  ᯨ  ਮ  ##########  ##########    |
|                                                 ##                                               |
|---------------------------------------------------------------------------------------------------------|
|                        |    |       |       |     |        |                 |                 |
|.                 |.|⥢|  | |  ஡|--------------------------|   ⪫    |
|                        |    |   |室 |     | 䠪.|  ஡|४.|. |                 |
|------------------------|----|-------|-------|-----|--------|--------|--------|--------|-----------------|
}
*)

(*
$P{ Line:
Tmp.TSN, L ,""
L_Str.ShortName(Man.Name), L, ""
Tmp.BoxNbr, L, ""
Tmp.RWayS, L, ""
Tmp.ExClsSgn, L, ""
Tmp.Date, L, "D.N"
Tmp.FactRun, R, "1."
Tmp.SpdRun, R, "1."
PrintCorSM(Tmp.SpdCor), R, ""
Tmp.SpdRunCor, R, "1."
Tmp.SpdRunCor - Tmp.FactRun, R, "1."
Tmp.R_Dif, R, "1."
@
|##### ##################|####|#######|#######|#####|########|########|########|########|######## #######%|
}
*)

(*
$P{ DetailLine:
Tmp.Column, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
Tmp.TSN, L ,""
Tmp.BoxNbr, L, ""
Tmp.RWayS, L, ""
Tmp.Date, L, "D.N"
Tmp.FactRun, R, "1."
Tmp.SpdRun, R, "1."
Tmp.SpdCor, R, "3."
Tmp.SpdRunCor, R, "1."
Tmp.R_Dif, R, "1."
@
- ##----------------------------------------------------########## #####
|         ᮮ⢥⢨ 䠪᪮ ஡  ஡  ᯨ         |
|=============================================================================|
|     |    |       |     |         |                      |          |
|. |.|⥢| |   ஡|-------------------------------|⪫|
|     |    |   |     |  䠪.|    ஡|४.|஡ |        % |
|-----|----|-------|-----|---------|----------|--------|-----------|----------|
|#####|####|#######|#####|#########|##########|########|###########|##########|
=(c) Polak=====================================================================







}
*)

(*
$P{ Bot:
@
=(c) Polak=================================================================================================
}
*)

(*
$P{ BadSpdTop:
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
@
                        ########## #####
=#####==================================
|᮪   ࠡ騬 ᯨࠬ|
}
*)

(*
$P{ BadSpdColumnLine:
Tmp.Column, L, ""
@
|======================================|
| ##                            |
|--------------------------------------|
|. ઠ                            |
|--------------------------------------|
}
*)

(*
$P{ BadSpdLine:
Tmp.BoxNbr, L, ""
Mark.Name, L, ""
@
|#### #################################|
}
*)

(*
$P{ BadSpdBot:
@
=(c) Polak==============================
}
*)

 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CreateFILE(Tmp, "", "६ 䠩", "");

  CreateFIELD(Tmp, Column,    LIKE(CarLog.Column), "", "",  "", "", "");
  CreateFIELD(Tmp, TSN,       LIKE(Staff.TSN),     "", "",  "", "", "");
  CreateFIELD(Tmp, BoxNbr,    LIKE(CarLog.BoxNbr), "", "",  "", "ࠦ", "");
  CreateFIELD(Tmp, RWayS,     LIKE(RWayS.RWayS),   "", "",  "", "", "");
  CreateFIELD(Tmp, ExClsSgn,  LIKE(ExitClss.Sign), "", "",  "", " 室 祭", "");
  CreateFIELD(Tmp, Date,      DATE,                "", "",  "", " ", "");
  CreateFIELD(Tmp, SMBef,     NUMERIC[0],          "", "0", "", "  砫", "");
  CreateFIELD(Tmp, SMAft,     NUMERIC[0],          "", "0", "", "  ", "");
  CreateFIELD(Tmp, FactRun,   NUMERIC[1],          "", "0", "", "᪨ ஡", "");
  CreateFIELD(Tmp, SpdRun,    NUMERIC[1],          "", "0", "", "஡  ᯨ", "");
  CreateFIELD(Tmp, SpdCor,    NUMERIC[3],          "", "0", "", "४", "");
  CreateFIELD(Tmp, SpdRunCor, NUMERIC[1],          "", "0", "", "४஢ ஡", "");
  CreateFIELD(Tmp, R_Dif,     NUMERIC[1],          "", "0", "", "⪫", "");

  CreateINDEX(Tmp, Column, PLURAL, "", "", Column, R_Dif, TSN, BoxNbr, RWayS, Date);
  CreateINDEX(Tmp, SpdCor, PLURAL, "", "", SpdCor, Column, BoxNbr);
  CreateINDEXandLINK(Tmp, TSN, PLURAL, Staff, TSN, USER,"", "", TSN);
  CreateINDEXandLINK(Tmp, RWayS,  PLURAL, RWayS, RWayS,  USER,"", "", RWayS);
  CreateINDEXandLINK(Tmp, BoxNbr, PLURAL, Car,   BoxNbr, USER,"", "", BoxNbr, Date, RWayS);

  SetVersionOfFILE(Tmp, 0);
  L_AFM.CreateTemp("Tmp");
 END {Create_Tmp};

 PRIVATE PROCEDURE RunBySM(MaxSM: NUMERIC[0]): NUMERIC[0];
 BEGIN
  RETURN Math.Mod((RWayS.SMAft - RWayS.SMBef + MaxSM), MaxSM);
 END {RunBySM};

 PRIVATE PROCEDURE GetMaxSM(): NUMERIC[0];
  VAR
   i, tmpMaxSM: NUMERIC[0];
 BEGIN
  i       :=1;
  tmpMaxSM:=10;
  WHILE i < Mark.SpdSize DO
   tmpMaxSM:=tmpMaxSM * 10;
   INC(i);
  END;
  RETURN tmpMaxSM;
 END {GetMaxSM};

 PRIVATE PROCEDURE DifferencePrc(SpdRun, FactRun: NUMERIC[1]): NUMERIC[1];
 BEGIN
  IF FactRun = 0 THEN
   RETURN 0;
  ELSE
   RETURN (SpdRun - FactRun) / FactRun * 100;
  END;

 END {DifferencePrc};

 PRIVATE PROCEDURE E_DifferenceCond(SpdRun, FactRun: NUMERIC[1]): SCAL[2];
  VAR
   default: SCAL[2];
   local  : PROC;
 BEGIN
  default:=Math.Abs(DifferencePrc(SpdRun, FactRun)) > 6.0;
  local  :=PROCREF(E_Utils.RuDif_Cond);
  IF ~!local  THEN
   RETURN local(SpdRun, FactRun, default);
  ELSE
   RETURN default;
  END;
 END {E_DifferenceCond};

 PRIVATE PROCEDURE MakeIndex();
  VAR
   MaxSM   : NUMERIC[0];
   CorSM   : NUMERIC[3];
   _SpdRun,
   _FactRun: NUMERIC[1];
 BEGIN
  Create_Tmp();
  SELECT(RWayS, sDate, , L_Way.rwsStat_Rated);
  SRCINSEL(RWayS, GE, , Memo.ud_fr());
  WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.ud_ut()) DO
   PROMPT(RWayS.RWayS);
   L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
   CONFORM(CarLog, Mark);
   MaxSM:=GetMaxSM();
   CorSM:=P_Car.GetP_SMCor(RWayS.BoxNbr, RWayS.Date);
   SELECT(RWayJ, RWayS, , RWayS.RWayS);
   SETZERO(_SpdRun, _FactRun);
   WHILE OCCURE(RWayJ) DO
    CONFORM(RWayJ, Quality);
    IF Quality.Type # L_Way.QualType_Annul THEN
     INC(_FactRun, D_TP.TrTotRun());
    END;
    NEXT(RWayJ);
   END; (* WHILE OCCURE(RWayJ) ... *)
   _SpdRun:=RunBySM(MaxSM);
   IF ((_FactRun # 0) | (_SpdRun # 0)) &
      ((RepType = 2) | E_DifferenceCond(_SpdRun * CorSM, _FactRun) | (CorSM = 0)) THEN
    CONFORM(RWayS,  StExit);
    CONFORM(StExit, ExitClss);
    Tmp.Column   :=CarLog.Column;
    Tmp.TSN      :=RWayS.TSN;
    Tmp.BoxNbr   :=RWayS.BoxNbr;
    Tmp.RWayS    :=RWayS.RWayS;
    Tmp.Date     :=RWayS.Date;
    Tmp.SMBef    :=RWayS.SMBef;
    Tmp.SMAft    :=RWayS.SMAft;
    Tmp.ExClsSgn :=ExitClss.Sign;
    Tmp.FactRun  :=_FactRun;
    Tmp.SpdRun   :=_SpdRun;
    Tmp.SpdCor   :=CorSM;
    Tmp.SpdRunCor:=_SpdRun * CorSM;
    Tmp.R_Dif    :=DifferencePrc(Tmp.SpdRunCor, _FactRun);
    INSERT(Tmp);
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 END {MakeIndex};

 PRIVATE PROCEDURE PrintRep();
  CONST
   PartsOnPage = 4;
   BadSpdRepName  = "DamSp";
  VAR
   PartsAmnt: NUMERIC[0];
   FirstPass: SCAL[2];
 BEGIN
  PartsAmnt:=0;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  SELECT(Tmp, Column);
  WHILE OCCURE(Tmp) DO
   CHANGESEL(Tmp, Column, , Tmp.Column);
   FirstPass:=1;
   WHILE OCCURE(Tmp) DO
    IF FirstPass & (RepType = 0) THEN
     MAKEPART(R, Top);
     FirstPass:=0;
    END;
    PROMPT(" " + Tmp.TSN);
    CONFORM(Tmp, Staff);
    CONFORM(Staff, Man);
     IF Tmp.SpdCor # 0 THEN
      IF    RepType = 0 THEN
       MAKEPART(R, Line);
      ELSE
       MAKEPART(R, DetailLine);
       INC(PartsAmnt);
       IF Math.Mod(PartsAmnt, PartsOnPage) = 0 THEN
        FORMFEED(R);
       END;
      END;
     END;
    NEXT(Tmp);
   END; (* WHILE OCCURE(Tmp) ... *)
   LAST(Tmp);
   CHANGESEL(Tmp, Column);
   NEXT(Tmp);
   IF RepType = 0 THEN
    MAKEPART(R, Bot);
   END;
  END; (* WHILE OCCURE(Tmp) ... *)

  IF SELECT(Tmp, SpdCor, 0) THEN
   IF (RepType = 0) | (Math.Mod(PartsAmnt, PartsOnPage) # 0) THEN
    FORMFEED(R);
   END;
   MAKEPART(R, BadSpdTop, BadSpdRepName);
   WHILE OCCURE(Tmp) DO
    PROMPT(" " + Tmp.TSN);
    CHANGESEL(Tmp, SpdCor, , 0, Tmp.Column);
    FirstPass:=1;
    WHILE OCCURE(Tmp) DO
     CHANGESEL(Tmp, SpdCor, , 0, Tmp.Column, Tmp.BoxNbr);
     IF OCCURE(Tmp) & (Tmp.SpdCor = 0) THEN
      IF FirstPass THEN
       MAKEPART(R, BadSpdColumnLine);
       FirstPass:=0;
      END;
      L_Car.StandOnCarLog(Tmp.BoxNbr, Tmp.Date);
      CONFORM(CarLog, Mark);
      MAKEPART(R, BadSpdLine);
     END;
     LAST(Tmp);
     CHANGESEL(Tmp, SpdCor, , 0, Tmp.Column);
     NEXT(Tmp);
    END; (* WHILE OCCURE(Tmp) ... *)
    LAST(Tmp);
    CHANGESEL(Tmp, SpdCor, , 0);
    NEXT(Tmp);
   END; (* WHILE OCCURE(Tmp) ... *)
   MAKEPART(R, BadSpdBot);
  END;
 END {PrintRep};

 PUBLIC PROCEDURE RunDi();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  RepType:=0;
  RepName:="RunDi";
  MakeIndex();
  PrintRep();
  L_General.SurveyLastReport();
 END {RunDi};

 PUBLIC PROCEDURE RnDiP();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  RepType:=1;
  RepName:="RnDiP";
  MakeIndex();
  PrintRep();
  L_General.SurveyLastReport();
 END {RnDiP};

 PRIVATE PROCEDURE RnDif_Top(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "ࠦ");
  L_Basis.wb_WrInQM(F, "᭮");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⠥");
  L_Basis.wb_WrInQM(F, "஡砫");
  L_Basis.wb_WrInQM(F, "஡");
  L_Basis.wb_WrInQM(F, "஡砫");
  L_Basis.wb_WrInQM(F, "஡");
  L_Basis.wb_WrInQM(F, "஡砫");
  L_Basis.wb_WrInQM(F, "஡");
  L_Basis.wb_WrInQM(F, "஡");
  L_Basis.wb_WrInQM(F, "砫");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "஡");
  L_Basis.wb_WrInQM(F, "஡");
  L_Basis.wb_WrInQM(F, "⪫");
  L_Basis.wb_TermLine(F);
 END {RnDif_Top};

 PRIVATE PROCEDURE RnDif_Line(F: STRING[]; bSM, eSM: LIKE(RWayS.SMAft); bRun, eRun: LIKE(CarRun.TotRun));
 BEGIN
  IF OCCURE(Tmp) THEN
   L_General.Assert(SEARCH(Calendar, Date, Tmp.Date), "   ᠭ  "+L_DatTim.DateStr(Tmp.Date));
   L_Car.StandOnCarLog(Tmp.BoxNbr, Tmp.Date);
   CONFORM(Tmp, Staff);
   CONFORM(Staff, Man);
  ELSE
   L_Car.StandOnCarLog(Car.BoxNbr, Memo.ud_ut());
  END;
  CONFORM(CarLog, Mark);
  CONFORM(Mark, VehType);
  CONFORM(CarLog, Column);
  L_Basis.wb_WrScl(F, CarLog.BoxNbr);
  L_Basis.wb_WrStr(F, CarLog.StateNbr);
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  IF OCCURE(VehType) THEN
   L_Basis.wb_WrStr(F, VehType.Name);
  ELSE
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_WrScl(F, Column.Column);
  L_Basis.wb_WrStr(F, Column.Name);
  IF OCCURE(Tmp) THEN
   L_Basis.wb_WrScl(F, Tmp.RWayS);
   L_Basis.wb_WrStr(F, Tmp.ExClsSgn);
   L_Basis.wb_WrDat(F, Tmp.Date);
   L_Basis.wb_WrStr(F, L_Way.E_ConvertWDStr(Memo.ud_ut(), L_Way.E_ConvertWD(Calendar.Date, Calendar.WDWay)));
   L_Basis.wb_WrScl(F, Staff.TSN);
   L_Basis.wb_WrStr(F, Man.Name);
   L_Basis.wb_WrScl(F, Tmp.SpdCor = 0);
  ELSE
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrScl(F, P_Car.GetP_SMCor(Car.BoxNbr, Memo.ud_ut()) = 0);
  END;
  L_Basis.wb_WrNum(F, bSM, 0);
  L_Basis.wb_WrNum(F, eSM, 0);
  L_Basis.wb_WrNum(F, bRun, 2);
  L_Basis.wb_WrNum(F, eRun, 2);
  IF ~!bSM THEN
   L_Basis.wb_WrNum(F, bSM - bRun, 2);
  ELSE
   L_Basis.wb_WrNum(F, EMPTYOF(FLOAT), 2);
  END;
  IF ~!eSM THEN
   L_Basis.wb_WrNum(F, eSM - eRun, 2);
  ELSE
   L_Basis.wb_WrNum(F, EMPTYOF(FLOAT), 2);
  END;
  IF OCCURE(Tmp) THEN
   L_Basis.wb_WrNum(F, Tmp.FactRun, 1);
   L_Basis.wb_WrNum(F, Tmp.SMBef, 0);
   L_Basis.wb_WrNum(F, Tmp.SMAft, 0);
   L_Basis.wb_WrNum(F, Tmp.SpdRun, 1);
   L_Basis.wb_WrNum(F, Tmp.SpdRunCor, 1);
   L_Basis.wb_WrNum(F, Tmp.SpdRunCor-Tmp.FactRun, 1);
  ELSE
   L_Basis.wb_WrNum(F, EMPTYOF(FLOAT), 1);
   L_Basis.wb_WrNum(F, EMPTYOF(FLOAT), 0);
   L_Basis.wb_WrNum(F, EMPTYOF(FLOAT), 0);
   L_Basis.wb_WrNum(F, EMPTYOF(FLOAT), 1);
   L_Basis.wb_WrNum(F, EMPTYOF(FLOAT), 1);
   L_Basis.wb_WrNum(F, EMPTYOF(FLOAT), 1);
  END;
  L_Basis.wb_TermLine(F);
 END {RnDif_Line};

 PUBLIC PROCEDURE RnDif();
  CONST
   bpId = "RnDif";
  VAR
   bSM,
   eSM: LIKE(RWayS.SMAft);
   bRun,
   eRun: LIKE(CarRun.TotRun);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, "஡ 䠪᪨   ᯨ", L_bp.t_Basis, L_General.tc_inIntvl);
  RepType:=2;
  MakeIndex();
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  RnDif_Top("F");

  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT(Car.BoxNbr);
   IF L_Car.CarDaysInOperation(Car.BoxNbr, Memo.ud_fr(), Memo.ud_ut()) > 0 THEN
    bRun:=L_Car.GetAccurateRunOnDate(Car.BoxNbr, Memo.ud_fr());
    eRun:=L_Car.GetAccurateRunOnDate(Car.BoxNbr, Memo.ud_ut() + 1);
    SETSEL(RWayS, sBoxNbr, L_Way.rwsStat_Rated, Car.BoxNbr);
    IF SRCINSEL(RWayS, LT, Memo.ud_ut() + 1) THEN
     eSM:=RWayS.SMAft;
    ELSE
     SETEMPTY(eSM);
    END;
    IF SRCINSEL(RWayS, GE, Memo.ud_fr()) & (RWayS.Date <= Memo.ud_ut()) THEN
     bSM:=RWayS.SMBef;
    ELSE
     bSM:=eSM;
    END;
    IF SELECT(Tmp, BoxNbr, Car.BoxNbr) THEN
     WHILE OCCURE(Tmp) DO
      PROMPT(Tmp.BoxNbr + " " + Tmp.RWayS);
      RnDif_Line("F", bSM, eSM, bRun, eRun);
      NEXT(Tmp);
     END; (* WHILE OCCURE(Tmp) *)
    ELSE
     RnDif_Line("F", bSM, eSM, bRun, eRun);
    END;
   END;
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
  FIO.Close(F);
  L_bp.End();
 END {RnDif};

END.
