(*
%Copyright   (c) Polak Computer System
%Author      24.12.2002 15:45:28 POLAK\GAV
%Purpose     ᮪  客 ""
%Type        report
%Specific    LOC
%Modified    28.06.2012 14:40:04 POLAK\Gina
%Environment
*)

 MODULE Staff013 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, P_Man, L_Man, Str, L_Staff, P_Firm, L_Russia, E_Staff, L_EC;

 VAR
  _MyFirm: P_Firm.tMyFirm;

(*
$P{ Top:
P_Firm.FP_FirmName(P_Firm.fomf(_MyFirm), SYSDATE()), C, ""
?, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
@
                                                                                                                    
                                                                                                   ஢쭮 樭᪮ 客
                                                                                                    ___________  "___"_____________ 20___ .
                                                                         
                                      ࠡ⭨  樭᪮ 客  客  ""
##################################################################################################################################################

=#####===========================================================================================================================##########=#####=
|    |                        |    |                                |                                                                            |
| |  ⢮    | |, ࠡ稩 ⥫䮭      | 䠪᪮ ஦, 譨 ⥫䮭                             |
|    |                        |஦|                                |                                                                            |
}
*)

(*
$P{ Line:
?, R, "0"
?, L, ""
Man.Birth, L, "y"
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
|----|------------------------|----|--------------------------------|----------------------------------------------------------------------------|
|####|########################|####|################################|############################################################################|
|    |########################|    |################################|############################################################################|
}
*)

(*
$P{ Bot:
@
=(c) Polak========================================================================================================================================

                                                                           ४ 䨫             ______________

                                                                           㪮⥫ ஢ 㦡 ______________
}
*)

 PRIVATE PROCEDURE GetAdrAndPhone(D: DATE): STRING[];
  VAR
   Telephon: STRING[];
 BEGIN
  IF ~L_Man.AccessManAdr(Man.Man, D, L_Russia.at_DwMA) THEN
   L_Man.AccessRgManAdr(Man.Man, D);
  END;
  Telephon:=L_Man.ManPhone(D);
  IF ~!Telephon THEN
   RETURN L_Man.GetPostAdr_asStr(1) + ", " + Telephon;
  ELSE
   RETURN L_Man.GetPostAdr_asStr(1);
  END;
 END {GetAdrAndPhone};

 PRIVATE PROCEDURE xStandOnStaffLog(D: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  IF L_Staff.IsStandOnMainContract(Man.Man, _MyFirm, D) THEN
   Result:=(Staff.Contract = L_Staff.cnt_Basic) & L_Staff.rInState(D);
   IF Result THEN
    Result:=L_EC.ExecE_Func_Scal2(D, PROCREF(E_Staff.Staff013_NeedStaff), Result);
   END;
  ELSE
   Result:=0;
  END;
  RETURN Result;
 END {xStandOnStaffLog};

 PUBLIC PROCEDURE St013();
  CONST
   RepName      = "St013";
   AddrLen      = 76;
   PostPhoneLen = 32;
  VAR
   Phone: STRING[];
   PostPhone,
   Name,
   Addr : STRING[][2];
   Idx  : NUMERIC[0];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  _MyFirm:=P_Firm.DefineMyFirm();
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName);

  Idx:=0;
  SELECT(Man, Name);
  WHILE OCCURE(Man) DO
   PROMPT(Man.Name);
   IF xStandOnStaffLog(Memo.ud_cd()) THEN
    CONFORM(StaffLog, Post);
    Str.Format(Name, Man.Name, 24, LEFT);
    Str.Format(Addr, GetAdrAndPhone(Memo.ud_cd()), AddrLen, LEFT);
    Phone:=P_Man.GetStaffWorkTelefon(Memo.ud_cd(), P_Man.ci_ExtTelefon);
    IF ~!Phone THEN
     Str.Format(PostPhone, Post.Name + ", " + Phone, PostPhoneLen, LEFT);
    ELSE
     Str.Format(PostPhone, Post.Name,                PostPhoneLen, LEFT);
    END;
    INC(Idx);
    MAKEPART(R, Line, Idx, Name[0], PostPhone[0], Addr[0], Name[1], PostPhone[1], Addr[1]);
   END;
   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
 END {St013};

END.
