(*
%Copyright   (c) Polak Computer System
%Author      08.01.2003 17:54:23 POLAK\GAV
%Purpose     襭 ॣ୮    
%Type        report
%Specific    AP_PC
%Modified    15.10.2013 11:35:58 POLAK\GAV
%Environment
*)

 MODULE Bad_CP [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_OwnData, L_Env, L_Way, Math, L_SCAD, L_Str, Memo,
        L_Prop, P_Route, L_AFM, FIO, L_Basis, L_Staff, L_StdFrm, L_bp,
        L_DatTim, L_EDO, L_PRoll, P_Officer, E_Prop, L_Sheet;

 PRIVATE VAR
  EUMode: SCAL[2];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
@
############################################################################################# ########## #####
=#####========================================================================================================
|                     襭 ॣ୮  ᯮ  ⬥⪨  ##########                     |
|------------------------------------------------------------------------------------------------------------|
|⥫                   |      |     | |                           ||| | |+/-|
}
*)

(*
$P{ Top_EU:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
?, L, "D.N.y"
Staff.TSN, L, ""
Man.Name, L, ""
@
################################################################# ########## #####
=#####============================================================================
|    襭 ॣ୮, ᯮ  ⬥⪨  믮 ३   |
|                       ਮ  ##########  ##########                      |
|⥫ ##### #################################################################|
|--------------------------------------------------------------------------------|
|      |     | |                           ||| | |+/-|
|----------|-------|-----|----------------------------------|-|--|-----|-----|---|
}
*)


(*
$P{ TSN_Prf1:
Staff.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
@
|---------------------------|----------|-------|-----|----------------------------------|-|--|-----|-----|---|
|##### #####################}
*)

(*
$P{ TSN_Prf2:
@
|                           }
*)

(*
$P{ Line:
RWayS.Date, L, "D.N.y"
RWayS.RWayS, L, ""
RWayJ.StartT, L, "H:M"
SEJobs.Route, L, ""
Route.Name, L, ""
?, L, ""
?, L, ""
?, L, "H:M"
?, L, "H:M"
?, R, ""
@
|##########|#######|#####|#### #############################|#|##|#####|#####|###|
}
*)

(*
$P{ Bot:
@
|------------------------------------------------------------------------------------------------------------|
|᫮ 祭:  - 襭 ॣ୮                                                            |
|                       - 襭 ॣ୮, ⢮ ३ "믮"                                |
|                      * - 饥 ⠡,   ⬥⪠   ࠡ饬                                 |
|                       - ᯮ ⬥⪠                                                            |
|                       -   믮 (३   )                                                |
=(c) Polak====================================================================================================
}
*)

(*
$P{ Bot_EU:
@
|--------------------------------------------------------------------------------|
|᫮ 祭:  - 襭 ॣ୮                                |
|                       - 襭 ॣ୮, ⢮ ३ "믮"    |
|                      * - 饥 ⠡,   ⬥⪠   ࠡ饬     |
|                       - ᯮ ⬥⪠                                |
|                       -   믮 (३   )                    |
=(c) Polak========================================================================
}
*)

 PRIVATE PROCEDURE UsefulTrip(): SCAL[2];
 BEGIN
  RETURN (WJMode.WJType = L_Way.WJType_Work) &
         (WJMode.RunSel # L_Way.runsel_None);
 END {UsefulTrip};

 PRIVATE PROCEDURE FalseRWaySCP(): SCAL[2];
 BEGIN
  IF RWayCP.Value = L_SCAD.cpv_Disable THEN
   CONFORM(RWayCP, Stop);
   HISTCONF(RWayS.Date, Stop, StopCP);
   RETURN StopCP.Value # L_SCAD.cpv_Disable;
  ELSE
   RETURN 0;
  END;
 END {FalseRWaySCP};

 PRIVATE PROCEDURE BadQl_Create();
 BEGIN
  CreateFILE(BadQl);
  CreateFIELD(BadQl, TSN,      LIKE(Staff.TSN));
  CreateFIELD(BadQl, ExitClss, LIKE(ExitClss.ExitClss));
  CreateFIELD(BadQl, Exit,     LIKE(StExit.Exit));
  CreateFIELD(BadQl, Route,    LIKE(Route.Route));
  CreateFIELD(BadQl, WJCode,   LIKE(WJMode.WJCode));
  CreateFIELD(BadQl, Quality,  LIKE(Quality.Quality));
  CreateFIELD(BadQl, TripPl,   NUMERIC[0], , "0");
  CreateFIELD(BadQl, TripFc,   NUMERIC[0], , "0");
  CreateFIELD(BadQl, TripGd,   NUMERIC[0], , "0");
(*
  CreateFIELD(BadQl, RWCPPl,   NUMERIC[0], , "0");
*)
  CreateFIELD(BadQl, RWCPFc,   NUMERIC[0], , "0");
  CreateFIELD(BadQl, RWCPGd,   NUMERIC[0], , "0");
  CreateFIELD(BadQl, Date,     DATE);

  CreateINDEXandLINK(BadQl, TSN,      UNIQUE, Staff,    TSN,      USER, , , TSN, ExitClss, Exit, Route, WJCode, Quality, Date);
  CreateINDEXandLINK(BadQl, Exit,     PLURAL, StExit,   Exit,     USER, , , Exit, Date, TripPl);
  CreateINDEXandLINK(BadQl, ExitClss, PLURAL, ExitClss, ExitClss, USER, , , ExitClss);
  CreateINDEXandLINK(BadQl, Route,    PLURAL, Route,    Route,    USER, , , Route);
  CreateINDEXandLINK(BadQl, WJCode,   PLURAL, WJMode,   WJCode,   USER, , , WJCode);
  CreateINDEXandLINK(BadQl, Quality,  PLURAL, Quality,  Quality,  USER, , , Quality);
  SetVersionOfFILE(BadQl, 00001);
 END {BadQl_Create};

 PRIVATE PROCEDURE MakeTop(F: STRING[]);
 BEGIN
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "⤥");
  L_Basis.wb_WrStr(F, "⤥");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "啠ࠪ");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "ॢ");
  L_Basis.wb_WrStr(F, "ॢ");
  L_Basis.wb_WrStr(F, "ॢ");
  L_Basis.wb_WrStr(F, "ॢ");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "⢮");
  L_Basis.wb_WrStr(F, "⢮");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "돫");
  L_Basis.wb_WrStr(F, "딠");
  L_Basis.wb_WrStr(F, "");
(*
  L_Basis.wb_WrStr(F, "⬥⪨");
*)
  L_Basis.wb_WrStr(F, "⬥⪨");
  L_Basis.wb_WrStr(F, "⬥⪨");
  L_Basis.wb_TermLine(F);
 END {MakeTop};

 PRIVATE PROCEDURE MakeLine(F: STRING[]);
 BEGIN
  CONFORM(BadQl, Staff);
  L_Staff.PosToStaffLog(Staff.TSN, BadQl.Date, 1);
  CONFORM(StaffLog, Officer);
  CONFORM(Officer, Sort);
  CONFORM(Staff, Man);
  CONFORM(BadQl, ExitClss);
  CONFORM(BadQl, Route);
  CONFORM(Route, TKind);
  CONFORM(BadQl, WJMode);
  CONFORM(BadQl, Quality);
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrScl(F, L_Staff.getDepart());
  L_Basis.wb_WrStr(F, L_Staff.getDepartName());
  L_Basis.wb_WrStr(F, ExitClss.Sign);
  L_Basis.wb_WrStr(F, ExitClss.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Way.ExitStrict_Pool, ExitClss.Strict));
  L_Basis.wb_WrStr(F, Route.Route);
  L_Basis.wb_WrStr(F, Route.Name);
  L_Basis.wb_WrScl(F, TKind.TKind);
  L_Basis.wb_WrStr(F, TKind.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Way.tkrgn_Pool, TKind.Rgn));
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Way.tkfnm_Pool, TKind.FnMode));
  L_Basis.wb_WrStr(F, WJMode.WJCode);
  L_Basis.wb_WrStr(F, WJMode.Name);
  L_Basis.wb_WrScl(F, Quality.Quality);
  L_Basis.wb_WrStr(F, Quality.Name);
  L_Basis.wb_WrDat(F, BadQl.Date);
  L_Basis.wb_WrNum(F, BadQl.TripPl, 0);
  L_Basis.wb_WrNum(F, BadQl.TripFc, 0);
  L_Basis.wb_WrNum(F, BadQl.TripGd, 0);
(*
  L_Basis.wb_WrNum(F, BadQl.RWCPPl, 0);
*)
  L_Basis.wb_WrNum(F, BadQl.RWCPFc, 0);
  L_Basis.wb_WrNum(F, BadQl.RWCPGd, 0);
  L_Basis.wb_TermLine(F);
 END {MakeLine};

 PRIVATE PROCEDURE MakeSubTopPart(Cond: SCAL[2]);
 BEGIN
  IF ~EUMode THEN
   IF Cond THEN
    CONFORM(Staff, Man);
    MAKEPART(R, TSN_Prf1);
   ELSE
    MAKEPART(R, TSN_Prf2);
   END;
  END;
 END {MakeSubTopPart};

 PRIVATE PROCEDURE MakeSingleTSN(From, UpTo: DATE; ToExcel: SCAL[2]);
  VAR
   VoidTr_RWayJ,
   All_RWayCP,
   Bad_RWayCP,
   UnD_RWayCP,
   Fls_RWayCP,
   GQB_RWayCP    : NUMERIC[0];(*襭 ॣ୮, ३  ࠪ *)
   IsFalseRWaySCP: SCAL[3];
 BEGIN
  SETZERO(All_RWayCP, Bad_RWayCP, GQB_RWayCP, Fls_RWayCP, UnD_RWayCP, VoidTr_RWayJ);
  SELECT(RWayS, TSN, , Staff.TSN);
  SRCINSEL(RWayS, GE, , From);
  WHILE OCCURE(RWayS) & (RWayS.Date <= UpTo) DO
   PROMPT(Staff.TSN + "-" + RWayS.RWayS);
   IF RWayS.Status = L_Way.rwsStat_Rated THEN
    IF ToExcel THEN
     IF ~SELECT(BadQl, Exit, RWayS.Exit, RWayS.Date) | (LAST(BadQl) & (BadQl.TripPl = 0)) THEN
      SELECT(StExit, Exit, , RWayS.Exit);
      SELECT(SEJobs, Exit, , RWayS.Exit);
      WHILE OCCURE(SEJobs) DO
       CONFORM (SEJobs, WJMode);
       IF UsefulTrip() THEN
        ADD(BadQl, TSN, , Staff.TSN, StExit.ExitClss, RWayS.Exit, SEJobs.Route, SEJobs.WJCode, 00, RWayS.Date,
                 BadQl.TripPl, 1);
 (*
        SELECT(RtMStop, RoutMod, , SEJobs.Route, SEJobs.Modif);
        WHILE OCCURE(RtMStop) DO
         IF L_SCAD.IsActiveStopCP() THEN
          INC(BadQl.RWCPPl);
         END;
         NEXT(RtMStop);
        END; (* WHILE OCCURE(RtMStop) ... *)
        REPLACE(BadQl);
 *)
       END;
       NEXT(SEJobs);
      END; (* WHILE OCCURE(SEJobs) ... *)
     END;
    END;
    SELECT(RWayJ, RWayS, , RWayS.RWayS);
    WHILE OCCURE(RWayJ) DO
     CONFORM (RWayJ, WJMode);
     IF UsefulTrip() THEN
      CONFORM(RWayJ, SEJobs);
      CONFORM(SEJobs, StExit);
      CONFORM(SEJobs, Route);
      CONFORM(RWayJ, Quality);
      IF ToExcel THEN
       IF (Quality.Type # L_Way.QualType_Annul) & (RWayJ.StartT # RWayJ.StopT) THEN
        ADD(BadQl, TSN, , Staff.TSN, StExit.ExitClss, StExit.Exit, Route.Route, SEJobs.WJCode, RWayJ.Quality, RWayS.Date,
                 BadQl.TripFc, RWayJ.Fact);
        IF Quality.Type = L_Way.QualType_Realiz THEN
         INC(BadQl.TripGd, RWayJ.Fact);
        END;
        IF L_SCAD.E_RWayCPLevel(UpTo) THEN
         SELECT(RWayCP, RWayS, , RWayJ.RWayS, RWayJ.Day, RWayJ.StartT);
         WHILE OCCURE(RWayCP) DO
          IF (RWayCP.Value # L_SCAD.cpv_Disable) | FalseRWaySCP() THEN
           INC(BadQl.RWCPFc);
           IF (Quality.Type # L_Way.QualType_Defect) |
              (RWayCP.Value # L_SCAD.cpv_Unknown) & (Math.Abs(RWayCP.Shift) <= L_SCAD.GetAccuracy()) THEN
            INC(BadQl.RWCPGd);
           END;
          END;
          NEXT(RWayCP);
         END; (* WHILE OCCURE(RWayCP) ... *)
        END;
        REPLACE(BadQl)
       END;
      ELSE
       IF Quality.Type = L_Way.QualType_VoidTr THEN
        MakeSubTopPart((Bad_RWayCP + GQB_RWayCP + Fls_RWayCP + UnD_RWayCP + VoidTr_RWayJ) = 0);
        MAKEPART(R, Line, "");
        INC(VoidTr_RWayJ);
       ELSE
        SELECT(RWayCP, RWayS, , RWayJ.RWayS, RWayJ.Day, RWayJ.StartT);
        WHILE OCCURE(RWayCP) DO
         IsFalseRWaySCP:=FalseRWaySCP();
         IF (RWayCP.Value # L_SCAD.cpv_Disable) | IsFalseRWaySCP THEN
          INC(All_RWayCP);
          IF (RWayCP.Value = L_SCAD.cpv_Unknown) THEN
           MakeSubTopPart((Bad_RWayCP + GQB_RWayCP + Fls_RWayCP + UnD_RWayCP + VoidTr_RWayJ) = 0);
           INC(UnD_RWayCP);
           CONFORM(RWayCP, Stop);
           MAKEPART(R, Line, "", Stop.CP, RWayCP.PlanT);
          ELSE
           IF IsFalseRWaySCP | (Math.Abs(RWayCP.Shift) > L_SCAD.GetAccuracy()) THEN
            MakeSubTopPart((Bad_RWayCP + GQB_RWayCP + Fls_RWayCP + UnD_RWayCP + VoidTr_RWayJ) = 0);
            IF IsFalseRWaySCP THEN
             INC(Fls_RWayCP);
            ELSE
             IF Quality.Type = L_Way.QualType_Realiz THEN
              IsFalseRWaySCP:=2;
              INC(GQB_RWayCP);
             ELSE
              INC(Bad_RWayCP);
             END;
            END;
            CONFORM(RWayCP, Stop);
            MAKEPART(R, Line, L_Str.PoolItem("|*|", IsFalseRWaySCP), Stop.CP, RWayCP.PlanT, RWayCP.FactT, RWayCP.Shift);
           END;
          END;
         END;
         NEXT(RWayCP);
        END; (* WHILE OCCURE(RWayCP) ... *)
       END; (* IF Quality.Type = L_Way.QualType_VoidTr ... *)
      END; (* IF ToExcel ... *)
     END; (* IF UsefulTrip() ... *)
     NEXT(RWayJ);
    END; (* WHILE OCCURE(RWayJ) ... *)
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 END {MakeSingleTSN};

 PRIVATE PROCEDURE BadQl_Gather(fr, ut: DATE; Force: SCAL[2]);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  BadQl_Create();
  L_AFM.msrf_Register("BadQl", "BadQl", L_General.timeCond_InIntvl, fr, ut);
  IF Force | ~L_AFM.msrf_Reuse("BadQl", 0) THEN
   L_AFM.msrf_Create("BadQl");
   SELECT(Staff, TSN);
   WHILE OCCURE(Staff) DO
    PROMPT(Staff.TSN);
    IF L_Env.RealTSN(Staff.TSN) THEN
     MakeSingleTSN(fr, ut, 1);
    END; (* IF L_Env.RealTSN(Staff.TSN) *)
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
   L_AFM.msrf_Store("BadQl");
  END;
 END {BadQl_Gather};

 PUBLIC PROCEDURE BQl01();
  CONST
   bpId = "BQl01";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, " ॣ୮  ਮ", L_bp.t_Basis, L_General.tc_inIntvl);
  FIO.Open(F, L_General.NameConnection(bpId), "rep", Create);
  BadQl_Gather(Memo.ud_fr(), Memo.ud_ut(), 1);
  MakeTop("F");
  SELECT(BadQl, TSN);
  WHILE OCCURE(BadQl) DO
   PROMPT(BadQl.TSN);
   MakeLine("F");
   NEXT(BadQl);
  END; (* WHILE OCCURE(BadQl) ... *)
  FIO.Close(F);
  L_bp.End();
 END {BQl01};

 PUBLIC PROCEDURE BQl02();
  CONST
   RepName = "BQl02";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  EUMode:=0;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, Memo.ud_cd());
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   IF L_Env.RealTSN(Staff.TSN) THEN
    MakeSingleTSN(Memo.ud_cd(), Memo.ud_cd(), 0);
   END; (* IF L_Env.RealTSN(Staff.TSN) *)
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
  LIKEMENU(Survey, "");
 END {BQl02};

 PRIVATE PROCEDURE BQl03_MakeTop(F: STRING[]);
 BEGIN
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "⤥");
  L_Basis.wb_WrStr(F, "⤥");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "啠ࠪ");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "ॢ");
  L_Basis.wb_WrStr(F, "ॢ");
  L_Basis.wb_WrStr(F, "ॢ");
  L_Basis.wb_WrStr(F, "ॢ");
  L_Basis.wb_WrStr(F, "⢮");
  L_Basis.wb_WrStr(F, "⢮");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, " (३)");
  L_Basis.wb_WrStr(F, "६ (३");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "+/-");
  L_Basis.wb_TermLine(F);
 END {BQl03_MakeTop};

 PRIVATE PROCEDURE BQl03_MakeLine(F: STRING[]);
 BEGIN
  CONFORM(RWayS, Staff);
  L_Staff.PosToStaffLog(Staff.TSN, RWayS.Date, 1);
  CONFORM(StaffLog, Officer);
  CONFORM(Officer, Sort);
  CONFORM(Staff, Man);
  CONFORM(RWayJ, SEJobs);
  CONFORM(SEJobs, ExitClss);
  CONFORM(SEJobs, Route);
  CONFORM(Route, TKind);
  CONFORM(RWayJ, Quality);
  CONFORM(RWayCP, Stop);
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrScl(F, L_Staff.getDepart());
  L_Basis.wb_WrStr(F, L_Staff.getDepartName());
  L_Basis.wb_WrStr(F, ExitClss.Sign);
  L_Basis.wb_WrStr(F, ExitClss.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Way.ExitStrict_Pool, ExitClss.Strict));
  L_Basis.wb_WrStr(F, Route.Route);
  L_Basis.wb_WrStr(F, Route.Name);
  L_Basis.wb_WrScl(F, TKind.TKind);
  L_Basis.wb_WrStr(F, TKind.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Way.tkrgn_Pool, TKind.Rgn));
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Way.tkfnm_Pool, TKind.FnMode));
  L_Basis.wb_WrScl(F, Quality.Quality);
  L_Basis.wb_WrStr(F, Quality.Name);
  L_Basis.wb_WrDat(F, RWayS.Date);
  L_Basis.wb_WrScl(F, SEJobs.Day);
  L_Basis.wb_WrTim(F, SEJobs.StartT);
  L_Basis.wb_WrScl(F, Stop.CP);
  L_Basis.wb_WrNum(F, RWayCP.Shift, 0);
  L_Basis.wb_TermLine(F);
 END {BQl03_MakeLine};

 PUBLIC PROCEDURE BQl03();
  CONST
   bpId = "BQl03";
 BEGIN
  L_bp.Begin(bpId, "⪫ ()  ᯨᠭ  ਮ", L_bp.t_Basis, L_General.tc_inIntvl);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  FIO.Open(F, L_General.NameConnection(bpId), "rep", Create);
  BQl03_MakeTop("F");

  SELECT(RWayS, sDate, , L_Way.rwsStat_Rated);
  SRCINSEL(RWayS, GE, , Memo.ud_fr());
  WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.ud_ut()) DO
   PROMPT(L_DatTim.DateStr(RWayS.Date) + ": " + RWayS.RWayS);
   SELECT(RWayJ, RWayS, , RWayS.RWayS);
   WHILE OCCURE(RWayJ) DO
    CONFORM (RWayJ, WJMode);
    IF UsefulTrip() THEN
     SELECT(RWayCP, RWayS, , RWayJ.RWayS, RWayJ.Day, RWayJ.StartT);
     WHILE OCCURE(RWayCP) DO
      IF Math.Abs(RWayCP.Shift) > 1 THEN
       BQl03_MakeLine("F");
      END;
      NEXT(RWayCP);
     END; (* WHILE OCCURE(RWayCP) ... *)
    END; (* IF UsefulTrip() ... *)
    NEXT(RWayJ);
   END; (* WHILE OCCURE(RWayJ) ... *)
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
  FIO.Close(F);
  L_bp.End();
 END {BQl03};

 PUBLIC PROCEDURE MakeRep_EU();
  CONST
   RepName = "BQl02";
  VAR
   From, UpTo: DATE;
 BEGIN
  L_General.Assert(ACCESS(Staff), " ࠭ ࠡ⭨");
  EUMode:=1;
  From  :=Memo.ud_fr();
  UpTo  :=Memo.ud_ut();
  CONFORM(Staff, Man);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top_EU, RepName, From, UpTo);
  MakeSingleTSN(From, UpTo, 0);
  MAKEPART(R, Bot_EU);
  CLOSEREP(R);
 END {MakeRep_EU};

(*
$P{ dcp_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "H:M"
?, L, "D.N.y"
@
######################################### ########## #####
=#####====================================================
|     ࠢ  ⥬   ##### ##########    |
|--------------------------------------------------------|
|⠭                           |ࠢ        |
|------------------------------------|-------------------|
}
*)

(*
$P{ dcp_Line:
Stop.Stop, L, ""
L_Way.GetStopName(Stop.Stop), L, ""
StopCP.Date, L, "D.N.y"
StopCP.Tim, L, "H:M"
StopCP.Sec, L, ""
@
|### ################################|########## #####:##|
}
*)

(*
$P{ dcp_Bot:
@
=(c) Polak================================================
}
*)

 PUBLIC PROCEDURE DisCP();
  CONST
   RepName = "DisCP";
  VAR
   D: DATE;
   T: TIME;
 BEGIN
  D:=SYSDATE();
  T:=SYSTIME();
  STDFORM(L_StdFrm.sf_Choice(  "%#################################%" +
                             "||%#####% %##########%",
                             "%<뢥 ࠢ ⠡  >T" +
                             "%<H:M>I" +
                             "%<D.N.y>I"),
          , , , T, D);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, dcp_Top, RepName, T, D);
  SELECT(Stop, SName);
  WHILE OCCURE(Stop) DO
   PROMPT(Stop.Stop);
   IF (Stop.CPType = L_Way.scpt_SCAD) &
      SELECT(StopCP, Stop, Stop.Stop) &
      SRCINSEL(StopCP, LE, D, T) &
      (StopCP.Value = L_SCAD.cpv_Disable) THEN
    WHILE OCCURE(StopCP) & (StopCP.Value = L_SCAD.cpv_Disable) DO
     PREV(StopCP);
    END; (* WHILE OCCURE(StopCP) ... *)
    IF OCCURE(StopCP) THEN
     NEXT(StopCP);
    ELSE
     FIRST(StopCP);
    END;
    MAKEPART(R, dcp_Line);
   END;
   NEXT(Stop);
  END; (* WHILE OCCURE(Stop) ... *)
  MAKEPART(R, dcp_Bot);
  CLOSEREP(R);
  LIKEMENU(Survey, "");
 END {DisCP};

(*
$P{ RegBn_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_mb(), L, "N.y"
@
############################################################################################# ########## #####
=#####========================================================================================================
|                           ⮪ ᫥ ६  ॣ୮  #######                            |
|------------------------------------------------------------------------------------------------------------|
|  믮  ३ᮢ                                                                          |
}
*)

(*
$P{ RegBn_DprtTop:
?, L, ""
?, L, ""
?, L, ""
@
|------------------------------------------------------------------------------------------------------------|
|         |################################|################################|################################|
|         |--------------------------------|--------------------------------|--------------------------------|
|     |  த   | ਣத | த |  த   | ਣத | த |  த   | ਣத | த |
|         |----------|----------|----------|----------|----------|----------|----------|----------|----------|
|         |  |  |  |  |  |  |  |  |  |
|---------|----------|----------|----------|----------|----------|----------|----------|----------|----------|
}
*)

(*
$P{ RegBn_DprtLine0:
?, L, "D.N.Y"
@
|#########}
*)

(*
$P{ RegBn_DprtLine1:
?, L, " |*"
@
|#}
*)

(*
$P{ RegBn_DprtLine2:
?, R, "0"
?, R, "0"
@
#### ####}
*)

(*
$P{ RegBn_DprtLine3:
@
|
}
*)

(*
$P{ RegBn_StaffTop:
@
|============================================================================================================|
|     |                               |          ||    த     |   ਣத   |   த   |          |
|. |                            |    |  |--------------|--------------|--------------|     ⮣|
|     |                               |          |.||   業||   業||   業|   業|
|-----|-------------------------------|----------|---|---|----------|---|----------|---|----------|----------|
}
*)

(*
$P { RegBn_StaffLine:
Staff.TSN, L, ""
Man.Name, L, ""
StaffLog.Date, L, "D.N.y"
?, R, "0"
?, R, "0"
?, R, "3."
?, R, "0"
?, R, "3."
?, R, "0"
?, R, "3."
?, R, "3."
@
|#####|###############################|##########|###|###|##########|###|##########|###|##########|##########|
}
*)

(*
$P { RegBn_Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE RegBn_GetPrc(Idx: SCAL[3]): NUMERIC[3];
 BEGIN
  RETURN 3.8 * L_Prop.GetNumericValueFromStr(L_Prop.getRES(OfcPro.Value, Idx)) /
         (L_Prop.GetNumericValueFromStr(L_Prop.getRES(OfcPro.Value, 0)) +
          L_Prop.GetNumericValueFromStr(L_Prop.getRES(OfcPro.Value, 1)) +
          L_Prop.GetNumericValueFromStr(L_Prop.getRES(OfcPro.Value, 2)));
 END {RegBn_GetPrc};

 PRIVATE PROCEDURE RegBn_MakeTmp();
  VAR
   D, Fr, UT: DATE;
 BEGIN
  BadQl_Gather(Memo.ud_mb(), Memo.ud_me(), 0);
  L_AFM.MakeMultipleIndex("tmp", "Dprt  : LIKE(Sort.Sort);" +
                                 "Rgn   : LIKE(TKind.Rgn);" +
                                 "Date  : DATE;" +
                                 "Plan  : NUMERIC[0];" +
                                 "Fact  : NUMERIC[0]",
                            "Dprt: Dprt, Date, Rgn;" +
                            "Rgn   : Rgn, Date, Dprt");
  L_AFM.MakeMultipleIndex("tmpT", "Rgn   : LIKE(TKind.Rgn);" +
                                  "Date  : DATE;" +
                                  "Plan  : NUMERIC[0];" +
                                  "Fact  : NUMERIC[0]",
                            "Date: Date, Rgn;" +
                            "Rgn : Rgn, Date");
  L_AFM.MakeMultipleIndex("stf", "TSN   : LIKE(Staff.TSN);" +
                                 "ODate : DATE;" +
                                 "DateE : DATE;" +
                                 "Dprt  : LIKE(Sort.Sort);" +
                                 "Pr    : NUMERIC[3][3];" +
                                 "Days  : NUMERIC[0];" +
                                 "WrkDay: SCAL[2][32]",
                             "TSN: TSN, ODate, DateE, Dprt");
  SELECT(BadQl, TSN);
  WHILE OCCURE(BadQl) DO
   PROMPT("1 " + BadQl.TSN);
   CONFORM(BadQl, Staff);
   NARROWSEL(BadQl, TSN);
   WHILE OCCURE(BadQl) DO
    NARROWSEL(BadQl, ExitClss);
    CONFORM(BadQl, ExitClss);
    WHILE OCCURE(BadQl) DO
     CONFORM(BadQl, Route);
     CONFORM(Route, TKind);
     CONFORM(BadQl, WJMode);
     IF (TKind.Rgn <= L_Way.tkrgn_Intercity) &
        (WJMode.WJType = L_Way.WJType_Work) & (WJMode.RunSel = L_Way.runsel_Work) THEN
      L_Staff.PosToStaffLog(Staff.TSN, BadQl.Date, 1);
      CONFORM(StaffLog, Officer);
      ADD(tmp, Dprt, , L_Staff.getDepart(), BadQl.Date, TKind.Rgn,
             tmp.Plan, BadQl.TripPl,
             tmp.Fact, BadQl.TripFc);
      ADD(tmpT, Date, , BadQl.Date, TKind.Rgn,
             tmpT.Plan, BadQl.TripPl,
             tmpT.Fact, BadQl.TripFc);
     END;
     NEXT(BadQl);
    END; (* WHILE OCCURE(BadQl) *)
    NEXTINEXTENDEDSEL(BadQl, ExitClss);
   END; (* WHILE OCCURE(BadQl) *)
   NEXTINEXTENDEDSEL(BadQl, TSN);
  END; (* WHILE OCCURE(BadQl) *)

  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT("2 " + Staff.TSN);
   SELECT(StaffLog, TSN, , Staff.TSN);
   SRCINSEL(StaffLog, LE, , Memo.ud_mb());
   WHILE OCCURE(StaffLog) & (StaffLog.Date <= Memo.ud_me()) DO
    IF ~L_Staff.IsDischargeStaffLog() &
       P_Officer.HasActualPro_Normal(StaffLog.Sort, StaffLog.Officer,
                                     Memo.ud_mb(), E_Prop.P_RegularityBonusProportion) THEN
     CONFORM(StaffLog, Officer);
     ADD(stf, TSN, , Staff.TSN, StaffLog.Date, StaffLog.DateE, L_Staff.getDepart(),
            stf.Pr[0], RegBn_GetPrc(0),
            stf.Pr[1], RegBn_GetPrc(1),
            stf.Pr[2], RegBn_GetPrc(2),
            stf.Days, L_DatTim.DATEINT(StaffLog.Date, StaffLog.DateE,
                                       Memo.ud_mb(), Memo.ud_me()));
     SETZERO(stf.WrkDay);
     IF stf.Days > 0 THEN
      Fr:=Math.Max(StaffLog.Date, Memo.ud_mb());
      UT:=Math.Min(StaffLog.DateE, Memo.ud_me());
      SETSEL(Sheet, TSN, Staff.TSN, Memo.ud_mb());
      SRCINSEL(Sheet, GE, , L_DatTim.DAY(Fr));
      WHILE OCCURE(Sheet) & (Sheet.Day <= L_DatTim.DAY(UT)) DO
       stf.WrkDay[Sheet.Day]:=Sheet.Source # L_Sheet.src_AvePay;
       NEXT(Sheet);
      END;
     END;
     REPLACE(stf);
    END;
    NEXT(StaffLog);
   END; (* WHILE OCCURE(StaffLog) ... *)
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
 END {RegBn_MakeTmp};

 PRIVATE PROCEDURE RegBn_RegNorm(Idx: SCAL[3]): FLOAT;
 BEGIN
  IF    Idx = L_Way.tkrgn_City THEN
   RETURN 0.975;
  ELSIF Idx = L_Way.tkrgn_Suburb THEN
   RETURN 0.985;
  ELSIF Idx = L_Way.tkrgn_Intercity THEN
   RETURN 1;
  END;
 END {RegBn_RegNorm};

 PUBLIC PROCEDURE RegBn();
  CONST
   RepName = "RegBn";
   Dprts   = [012, 013];
  VAR
   PerDays: NUMERIC[0];
   prc    : FLOAT[3];
   days   : NUMERIC[0][3];
   D      : DATE;
   rgn    : SCAL[3];
   pl,
   fc     : NUMERIC[0];
   dep0,
   dep1   : STRING[];
   i      : SCAL[2];
 BEGIN
  PerDays:=Memo.ud_me() - Memo.ud_mb() + 1;
  RegBn_MakeTmp();
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, RegBn_Top, RepName);

  SEARCH(Sort, Sort, , Dprts[0]);
  dep0:=Sort.Name;
  SEARCH(Sort, Sort, , Dprts[1]);
  dep1:=Sort.Name;

  MAKEPART(R, RegBn_DprtTop, dep0, dep1, " 楫  ।");
  D:=Memo.ud_mb();
  WHILE D <= Memo.ud_me() DO
   PROMPT(L_DatTim.DateStr(D));
   MAKEPART(R, RegBn_DprtLine0, D);
   FOR_EACH i DO
    FOR_EACH rgn DO
     IF SEARCH(tmp, Dprt, Dprts[i], D, rgn) THEN
      MAKEPART(R, RegBn_DprtLine1, tmp.Fact < tmp.Plan * RegBn_RegNorm(rgn));
      MAKEPART(R, RegBn_DprtLine2, tmp.Plan, tmp.Fact);
     ELSE
      MAKEPART(R, RegBn_DprtLine1);
      MAKEPART(R, RegBn_DprtLine2);
     END;
    END;
   END;
   FOR_EACH rgn DO
    IF SEARCH(tmpT, Date, D, rgn) THEN
     MAKEPART(R, RegBn_DprtLine1, tmpT.Fact < tmpT.Plan * RegBn_RegNorm(rgn));
     MAKEPART(R, RegBn_DprtLine2, tmpT.Plan, tmpT.Fact);
    ELSE
     MAKEPART(R, RegBn_DprtLine1);
     MAKEPART(R, RegBn_DprtLine2);
    END;
   END;
   MAKEPART(R, RegBn_DprtLine3);
   INC(D);
  END;

  MAKEPART(R, RegBn_StaffTop);
  SELECT(stf, TSN);
  WHILE OCCURE(stf) DO
   PROMPT("3 " + stf.TSN);
   NARROWSEL(stf, TSN);
   SEARCH(Staff, TSN, , stf.TSN);
   CONFORM(Staff, Man);
   WHILE OCCURE(stf) DO
    SETZERO(prc, days);
    D:=Math.Max(stf.ODate, Memo.ud_mb());
    WHILE (D <= stf.DateE) & (D <= Memo.ud_me()) DO
     IF stf.WrkDay[L_DatTim.DAY(D)] THEN
      FOR_EACH rgn DO
       SETZERO(pl, fc);
       IF SELECT(tmp, Dprt, stf.Dprt) THEN
        IF SEARCH(tmp, Rgn, rgn, D, stf.Dprt) THEN
         pl:=tmp.Plan;
         fc:=tmp.Fact;
        END;
       ELSIF SEARCH(tmpT, Date, D, rgn) THEN
        pl:=tmpT.Plan;
        fc:=tmpT.Fact;
       END;
       IF pl & (fc >= pl * RegBn_RegNorm(rgn)) THEN
        INC(prc[rgn], stf.Pr[rgn] * PerDays / stf.Days);
        INC(days[rgn]);
       END;
      END; (* FOR_EACH rgn *)
     END; (* IF stf.WrkDay.. *)
     INC(D);
    END; (* WHILE (D.. *)
    SEARCH(StaffLog, TSN, , stf.TSN, stf.ODate);
    MAKEPART(R, RegBn_StaffLine, stf.Days, days[0], prc[0], days[1], prc[1], days[2], prc[2], prc[0] + prc[1] + prc[2]);
    NEXT(stf);
   END; (* WHILE OCCURE(File) *)
   NEXTINEXTENDEDSEL(stf, TSN);
  END; (* WHILE OCCURE(stf) *)
  MAKEPART(R, RegBn_Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {RegBn};

END.
