(*
%Copyright   (c) Polak Computer System
%Author      07.09.2001 20:26:11 GINA
%Purpose     樨  ᯮ樥, ࠧ१
%Type        report
%Specific    SYS
%Modified    22.08.2012 18:29:24 POLAK\San
%Environment
*)

 IMPORT Memo, L_General, L_OwnData, L_DatTim, L_MathR, L_AFM, L_Str, L_XDR, L_Acnt, Math, L_PRoll;

 CONST
  RepName = "AcmAC";

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
SubjTitle(MODE), C, ""
WherePrefix(MODE), C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|############################################################################################################|
|############################################################################################################|
}
*)

(*
$P{ SubTop:
?, L, ""
@
|------------------------------------------------------------------------------------------------------------|
|ꥪ ᪮ : ###############################################################################|
|------------------------------------------------------------------------------------------------------------|
|㯯 権                    | 樨                                      |      |     |  |
|-----------------------------------|--------------------------------------------------|-------|-------|-----|
}
*)

(*
$P{ Line:
_AcMt.DGroup, L, ""
DGroup.Name, L, ""
_AcMt.Dest, L, ""
Dest.Name, L, ""
_AcMt.Prd,  L, "N.y"
_AcMt.PrdE, L, "N.y"
_AcMt.AcMth, L, ""
@
|## ################################|### ##############################################|#######|#######|#####|
}
*)

(*
$P{ ACSetTop:
@
|============================================================================================================|
|                          ਬ    ࠧ१  奬                            |
|------------------------------------------------------------------------------------------------------------|
|  ࠧ१     |          |祭          |         |  |         |        |
|---------------------------|-------------|--------------------|---------------|-------|----------|----------|
}
*)

(*
$P{ ACSetLine:
_MTMM.ACSet, L, ""
ACSet.Name, L, ""
L_Str.PoolItem(L_Acnt.acsk_Pool, ACSet.Kind), L, ""
L_Str.PoolItem(L_Acnt.acp_Pool, _MTMM.ACPrp), L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
_MTMM.Begin, L, "D.N.y"
_MTMM.Till, L, "D.N.y"
@
|#### ######################|#############|####################|## ############|### ###|##########|##########|
}
*)

(*
$P{ MCListTop:
@
|------------------------------------------------------------------------------------------------------------|
|                                   ᯮ짮   ᫥/㤥ঠ                               |
|------------------------------------------------------------------------------------------------------------|
|                                  |       |㯯                               |         |        |
|-------------------------------------|----------|-------------------------------------|----------|----------|
}
*)

(*
$P{ MCListLine:
MCList.MCode, L, ""
MCList.Name , L, ""
L_Str.PoolItem("᫥|ঠ", MCList.MCTyp), L, ""
MCList.MCGroup, L, ""
MCGroup.Name,   L, ""
MCList.Begin,   L, "D.N.y"
MCList.Till,    L, "D.N.y"
@
|### #################################|##########|## ##################################|##########|##########|
}
*)

(*
$P{ OfcDstTop:
@
|============================================================================================================|
|                                         ᯮ짮  ࠡ                                      |
|------------------------------------------------------------------------------------------------------------|
|                    |祥                    |ᮡ ।      |         |        |
|--------------------------|--------------------------------|--------------------------|----------|----------|
}
*)

(*
$P{ OfcDstLine:
OfcDst.Sort,    L, ""
Sort.Name ,     L, ""
OfcDst.Officer, L, ""
Officer.Post,   L, ""
Post.Name,      L, ""
OfcDst.DstMode, L, ""
DstMode.Name,   L, ""
Officer.Begin,  L, "D.N.y"
Officer.Till,   L, "D.N.y"
@
|### ######################|#### #### ######################|## #######################|##########|##########|
}
*)


(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE SubjTitle(_Mode: SCAL[255]): STRING[];
 BEGIN
  IF    ByApport(_Mode) THEN
   RETURN "樨  ᯮ樨 " + Apport.Apport + " " + Apport.Name;
  ELSIF ByAcCut(_Mode)  THEN
   RETURN "樨  ⭮ ࠧ१ " + AcCut.AcCut + " " + AcCut.Name;
  ELSE
   L_General.BadMode(_Mode);
  END;
 END {SubjTitle};

 PRIVATE PROCEDURE WherePrefix(_Mode: SCAL[255]): STRING[];
 BEGIN
  IF OperatingOnly(_Mode) THEN RETURN "騥  " + L_DatTim.PeriodStr(Memo.ud_cd());
  ELSE                         RETURN "( )";
  END;
 END {WherePrefix};

 PRIVATE PROCEDURE ByApport(_Mode: SCAL[255]): SCAL[2];
 BEGIN
  RETURN (_Mode = 080) | (_Mode = 081);
 END {ByApport};

 PRIVATE PROCEDURE ByAcCut(_Mode: SCAL[255]): SCAL[2];
 BEGIN
  RETURN (_Mode = 090) | (_Mode = 091) | (MODE = 92);
 END {ByAcCut};

 PRIVATE PROCEDURE OperatingOnly(_Mode: SCAL[255]): SCAL[2];
 BEGIN
  RETURN (_Mode = 080) | (_Mode = 090);
 END {OperatingOnly};

 PRIVATE PROCEDURE ThroughACSet(): SCAL[2];
 BEGIN
  RETURN (MODE = 92);
 END {ThroughACSet};

 PRIVATE PROCEDURE SubTitle(S: STRING[]): STRING[];
 BEGIN
  IF    ByApport(MODE) THEN
   RETURN "ᯮ " + Apport.Apport + " " + Apport.Name;
  ELSIF ByAcCut(MODE)  THEN
   RETURN S+" " + AcCut.AcCut + " " + AcCut.Name;
  ELSE
   L_General.BadMode(MODE);
  END;
 END {SubTitle};

 PRIVATE PROCEDURE NeedPer(Begin, Till: DATE): SCAL[2];
 BEGIN
  RETURN ~OperatingOnly(MODE) |
         L_DatTim.IsActive(Memo.ud_mb(), Begin, Till)
 END {NeedPer};

 PRIVATE PROCEDURE Make_MTMMIdx();
 BEGIN
  SELECT(ACSetL, AcCut, , AcCut.AcCut);
  WHILE OCCURE(ACSetL) DO
   PROMPT(ACSetL.ACSet);
   CONFORM(ACSetL, ACSet);
   IF NeedPer(ACSet.Begin, ACSet.Till) THEN
    IF ACSet.Kind = L_Acnt.acsk_Math THEN
     SELECT(MTMM, ACSet, , ACSet.ACSet);
     WHILE OCCURE(MTMM) DO
      IF NeedPer(MTMM.Begin, MTMM.Till) THEN
       ADD(_MTMM, ACSet, , ACSet.ACSet, ACSetL.ACPrp, MTMM.MathType, MTMM.MMode, MTMM.Begin, MTMM.Till);
      END;
      NEXT(MTMM);
     END; (* WHILE OCCURE(MTMM) ... *)
    ELSE
     ADD(_MTMM, ACSet, , ACSet.ACSet, ACSetL.ACPrp, "", "", ACSet.Begin, ACSet.Till);
    END;
   END;
   NEXT(ACSetL);
  END; (* WHILE OCCURE(ACSetL) ... *)
 END {Make_MTMMIdx};

 PRIVATE PROCEDURE MakeIdxBySelect(byMTMM: SCAL[2]; Side: STRING[]);
  VAR
   Need: SCAL[2];
 BEGIN
  WHILE OCCURE(AcMthL) DO
   CONFORM(AcMthL, AcMthH);
   CONFORM(AcMthH, AcMth);
   PROMPT(AcMth.DGroup + " " + AcMth.Dest);
   IF NeedPer(AcMthH.Date, AcMthH.Till) THEN
    IF ~byMTMM THEN
     Need:=1;
    ELSE
     Need:=0;
     IF Side = "1" THEN
      SELECT(_MTMM, ACPrp, , AcMthL.ACPrp);
     ELSE
      SELECT(_MTMM, ACPrp, , AcMthL.ACPrp2);
     END;
     WHILE OCCURE(_MTMM) DO
      IF ~!_MTMM.MathType THEN
       SELECT(AcMthA, AcMth, , AcMthL.AcMth, _MTMM.MathType, _MTMM.MMode);
       WHILE OCCURE(AcMthA) DO
        IF NeedPer(AcMthA.Begin, AcMthA.Till) &
           L_DatTim.IsActiveInIntvl(AcMthH.Date, AcMthH.Till, Math.Max(AcMthA.Begin, _MTMM.Begin), Math.Min(AcMthA.Till, _MTMM.Till)) THEN
         Need:=1;
        END;
        NEXT(AcMthA);
       END; (* WHILE OCCURE(AcMthA) ... *)
      ELSE
       Need:=1;
      END;
      NEXT(_MTMM);
     END; (* WHILE OCCURE(_MTMM) ... *)
    END;
    IF Need THEN
     ADD(_AcMt, _AcMt, , ^("AcMthL.Origin"+Side), AcMth.DGroup, AcMth.Dest, AcMthH.Date, AcMthH.Till, AcMth.AcMth);
    END;
   END;
   NEXT(AcMthL);
  END; (* WHILE OCCURE(AcMthL) ... *)
 END {MakeIdxBySelect};

 PRIVATE PROCEDURE PrintRep();
 BEGIN
  SELECT(_AcMt, _AcMt);
  WHILE OCCURE(_AcMt) DO
   IF ~!_AcMt.Origin THEN
    MAKEPART(R, SubTop, L_Str.PoolItem(L_Acnt.amo_Pool, _AcMt.Origin));
   ELSE
    MAKEPART(R, SubTop, "");
   END;
   NARROWSEL(_AcMt, Origin);
   WHILE OCCURE(_AcMt) DO
    SEARCH(AcMth, AcMth, , _AcMt.AcMth);
    PROMPT(AcMth.DGroup + " " + AcMth.Dest);
    CONFORM(AcMth, DGroup);
    CONFORM(AcMth, Dest);
    L_XDR.sl_AddItem(AcMth.AcMth,  AcMth.DGroup   + " " + FLDTOSTR(DGroup.Name,   "", 32) +
                                   " " +
                                   AcMth.Dest     + " " + FLDTOSTR(Dest.Name,     "", 32));
    MAKEPART(R, Line);
    NEXT(_AcMt);
   END; (* WHILE OCCURE(_AcMt) ... *)
   NEXTINEXTENDEDSEL(_AcMt, Origin);
  END; (* WHILE OCCURE(_AcMt) ... *)
 END {PrintRep};

 PRIVATE PROCEDURE Make_MCList();
 BEGIN
IF ~L_PRoll.UseSalDSet() THEN
  IF SELECT(MCList, AcCut, AcCut.AcCut) THEN
   MAKEPART(R, MCListTop);
   WHILE OCCURE(MCList) DO
    PROMPT(" : "+MCList.MCode);
    IF NeedPer(MCList.Begin, MCList.Till) THEN
     CONFORM(MCList, MCGroup);
     MAKEPART(R, MCListLine);
    END;
    NEXT(MCList);
   END; (* WHILE OCCURE(MCList) ... *)
  END;
END;
 END {Make_MCList};

 PRIVATE PROCEDURE Make_OfcDst();
 BEGIN
IF ~L_PRoll.UseSalDSet() THEN
  IF SELECT(OfcDst, AcCut, AcCut.AcCut) THEN
   L_AFM.MakeIndex("_Ofc1", "Sort   : LIKE(OfcDst.Sort);"+
                            "Officer: LIKE(OfcDst.Officer);"+
                            "DstMode: LIKE(OfcDst.DstMode)");
   MAKEPART(R, OfcDstTop);
   WHILE OCCURE(OfcDst) DO
    PROMPT(" ᮡ । ௫: "+OfcDst.Sort+" "+OfcDst.Officer);
    CONFORM(OfcDst, Officer);
    IF NeedPer(Officer.Begin, Officer.Till) THEN
     ADD(_Ofc1, _Ofc1, , OfcDst.Sort, OfcDst.Officer, OfcDst.DstMode);
    END;
    NEXT(OfcDst);
   END; (* WHILE OCCURE(OfcDst) ... *)

   SELECT(_Ofc1, _Ofc1);
   WHILE OCCURE(_Ofc1) DO
    SEARCH(OfcDst, Officer, , _Ofc1.Sort, _Ofc1.Officer, _Ofc1.DstMode);
    PROMPT("ᮡ । ௫: "+OfcDst.Sort+" "+OfcDst.Officer);
    CONFORM(OfcDst, DstMode);
    CONFORM(OfcDst, Officer);
    CONFORM(Officer, Post);
    CONFORM(Officer, Sort);
    MAKEPART(R, OfcDstLine);
    NEXT(_Ofc1);
   END; (* WHILE OCCURE(_Ofc1) ... *)
   L_AFM.AF_PurgeTemp("_Ofc1");
  END;
END;
 END {Make_OfcDst};

BEGIN
 SE_ACCESSDATAMODE(AccessDataMode_SOFT);
 L_AFM.MakeIndex("_AcMt", "Origin: LIKE(AcMthL.Origin1);"+
                          "DGroup: LIKE(AcMth.DGroup);"+
                          "Dest:   LIKE(AcMth.Dest);"+
                          "Prd:    DATE;"+
                          "PrdE:   DATE;"+
                          "AcMth:  LIKE(AcMth.AcMth)");
 L_XDR.sl_Init("奬 権");

 OPENREP(R, L_General.NameConnection(RepName), Create);

 IF    ByApport(MODE) THEN
  L_General.Assert(ACCESS(Apport), " । ᯮ");
  MAKEPART(R, Top);
  SELECT(AcMthL, Apport, , Apport.Apport);
  MakeIdxBySelect(0, "1");
  SELECT(AcMthL, Apport2, , Apport.Apport);
  MakeIdxBySelect(0, "2");
  PrintRep();
 ELSIF ByAcCut(MODE) THEN
  L_General.Assert(ACCESS(AcCut), " ।  ࠧ१");
  L_AFM.MakeMultipleIndex("_MTMM", "ACSet   : LIKE(ACSet.ACSet);" +
                                   "ACPrp   : LIKE(ACSetL.ACPrp);" +
                                   "MathType: LIKE(MTMM.MathType);" +
                                   "MMode   : LIKE(MTMM.MMode);" +
                                   "Begin   : LIKE(MTMM.Begin);" +
                                   "Till    : LIKE(MTMM.Till)",
                          "ACSet: ACSet, ACPrp, MathType, MMode, Begin, Till;" +
                          "ACPrp: ACPrp");
  Make_MTMMIdx();
  MAKEPART(R, Top);
  SELECT(AcMthL, AcCut, , AcCut.AcCut);
  MakeIdxBySelect(0, "1");
  SELECT(AcMthL, AcCut2, , AcCut.AcCut);
  MakeIdxBySelect(0, "2");

  IF ThroughACSet() & SELECT(_MTMM, ACSet) THEN
   SELECT(AcMthL, AcCut, , "");
   MakeIdxBySelect(1, "1");
   SELECT(AcMthL, AcCut2, , "");
   MakeIdxBySelect(1, "2");
  END;
  PrintRep();

  IF SELECT(_MTMM, ACSet) THEN
   MAKEPART(R, ACSetTop);
   WHILE OCCURE(_MTMM) DO
    SEARCH(ACSet, ACSet, , _MTMM.ACSet);
    IF ~!_MTMM.MathType THEN
     SEARCH(MathType, MathType, , _MTMM.MathType);
     MAKEPART(R, ACSetLine, _MTMM.MathType, MathType.Name, _MTMM.MMode, L_MathR.MModeStr(_MTMM.MMode));
    ELSE
     MAKEPART(R, ACSetLine);
    END;
    NEXT(_MTMM);
   END; (* WHILE OCCURE(_MTMM) ... *)
  END;
  L_AFM.AF_PurgeTemp("_MTMM");

  Make_MCList();
  Make_OfcDst();
 ELSE
  L_General.BadMode(MODE);
 END;

 L_AFM.AF_PurgeTemp("_AcMt");
 MAKEPART(R, Bot);
 CLOSEREP(R);
 L_XDR.sl_Done();
END.
