(*
%Copyright   (c) Polak Computer System
%Author      04.11.1995 14:05:18 NAIL
%Purpose      ⥫ 㬥⮢
%Type        operation
%Specific    SYS
%Modified    21.03.2014 20:57:01 POLAK\Gina
%Environment MODE = 061 -  ⥪饣 ⥦ 㬥
%Environment MODE = 062 -  ᮧ ⥦ 㬥
%Environment MODE = 063 -  ⥪饣 㤥ঠ
*)

 MODULE Add_Doc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_PDoc, L_PRoll, L_AFM, L_APtm, Memo, L_StdFrm;

 PRIVATE PROCEDURE DoPaste(): SCAL[2];
 BEGIN
  IF ~!PayP.PstFile THEN
   LOADMODULE(^PayP.PstFile, Card);
  END;
  RETURN ~!PayP.PstFile;
 END {DoPaste};

 PRIVATE PROCEDURE Ins_Ded();
 BEGIN
  IF ~!PROCREF(Card.SpecConformForIndexBy) THEN
   Card.SpecConformForIndexBy();
  END;
  L_PDoc._AssertByDeduct(~!^(Card.GetItemForIndex()), " 㪠 祭 ४ ஢");
  _Ded._IndexBy:=^(Card.GetItemForIndex());
  _Ded._TSN    :=Deduct.TSN;
  _Ded._Nbr    :=Deduct.DedNbr;
  INSERT(_Ded);
 END {Ins_Ded};

 PRIVATE PROCEDURE MakeIndex();
  VAR
   _IsSalPDoc: SCAL[2];
 BEGIN
  _IsSalPDoc:=L_PDoc.IsSalPDoc();
  CONFORM(PDoc, PDocList);
  L_General.Assert(OCCURE(PDocList), "㬥 "+L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc)+"  ᮤন   ப");
  WHILE OCCURE(PDocList) DO
   CONFORM(PDocList, Staff, Man);
   CONFORM(Staff, Deduct);
   PROMPT(L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc)+" : "+Staff.TSN);
   L_General.Assert(_IsSalPDoc | L_PRoll.IsDedD(), " 믮  㤥ঠ |"+Staff.TSN+" "+Man.Name);
   L_PDoc.ScanDeductTSN(Staff.TSN, PROCREF(Ins_Ded));
   NEXT(PDocList);
  END; (* WHILE OCCURE(PDocList) ... *)
 END {MakeIndex};

 PRIVATE PROCEDURE Make();
 BEGIN
  MakeIndex();

  Card.PrologForPDoc();
  SELECT(_Ded, _Ded);
  WHILE OCCURE(_Ded) DO
   L_General.CallUs(SEARCH(Deduct, TSN, _Ded._TSN, _Ded._Nbr));
   CONFORM(Deduct, DedType, DedAcnt, Staff, Man);
   SRCINSEL(DedAcnt, EQ, , Memo.gl_mb());
   Card.CreateDocument();
   NEXT(_Ded);
  END; (* WHILE OCCURE(_Ded) ... *)
  Card.EpilogForPDoc();
 END {Make};

BEGIN
 IF    (MODE = 061) | (MODE = 062) THEN
  IF MODE = 061 THEN
   L_PDoc.AccessPDoc();
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  END;
  L_AFM.MakeIndex("_Ded", "_IndexBy : LIKE(Deduct.PAddr[0]);"+
                          "_TSN : LIKE(Staff.TSN);"+
                          "_Nbr : LIKE(Deduct.DedNbr)");

  IF ~!PDoc.payp THEN
   L_General.Assert(SEARCH(PayP, PayP, PDoc.payp), " 祭 ⥦ "+PDoc.payp);
   CONFORM(PDoc, Firm);
   IF DoPaste() THEN
    IF (MODE = 061) | Card.MayCreateInAutoMode() THEN
     IF ~!PDoc.ServDate THEN
      L_APtm.TemporarySetMemoDate(PDoc.ServDate, PROCREF(Make));
     ELSE
      Make();
     END;
    END; (* IF (MODE = 061) | ... *)
   END;
  ELSIF MODE = 061 THEN
   L_StdFrm.Inform("⥫ 㬥     ।ᬮ७");
  END; (* IF ~!PDoc.payp ... *)
  L_AFM.AF_PurgeTemp("_Ded");
 ELSIF MODE = 063 THEN
  L_General.Assert(ACCESS(Deduct), " ⠭ ⥪饥 㤥ঠ");
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  CONFORM(Deduct, DedType, DedAcnt, Staff, Man, Firm, PayP);
  L_General.Assert(DoPaste(), " ᮧ ⥫ 㬥⮢ 室"+
                              "|㪠  祭 ⥦  砥 ");
  IF SRCINSEL(DedAcnt, EQ, Memo.gl_mb()) & (DedAcnt.NetDebt > 0) THEN
   L_General.Assert(L_PRoll.IsDedD(), " 믮  㤥ঠ |"+Staff.TSN+" "+Man.Name);
   Card.PrologForDeduct();
   Card.CreateDocument();
   Card.EpilogForDeduct();
  END; (* IF OCCURE(DedAcnt) & ... *)
 END; (* IF MODE = ... *)
END.
