(*
%Copyright   (c) Polak Computer System
%Author      03.09.2002 09:52:36 GINA
%Purpose     PASTE  Add_Doc - ⮢ 䠩  ⮡
%Type        to_paste
%Specific    SYS
%Modified    05.02.2010 19:55:59 POLAK\GAV
%Environment
*)

 IMPORT Memo, L_DatTim, L_General, L_PDoc, Str, FIO, L_Str, L_EC, E_PDoc, Add_Doc, L_PayP, L_FIO;

 CONST
  Path = "REP\AVTOB";

 VAR
  Count    : NUMERIC[0];
  _FileName: STRING[];

 PROCEDURE GetItemForIndex(): STRING[];
 BEGIN
  RETURN "Deduct.PCode";
 END {GetItemForIndex};

 PROCEDURE MayCreateInAutoMode(): SCAL[2];
 BEGIN
  RETURN 1;
 END {MayCreateInAutoMode};

(*------ Empty procedures ------------------------------------------*)

 PROCEDURE PrologForPayP();
 BEGIN
 END {PrologForAll};

 PROCEDURE EpilogForPayP();
 BEGIN
 END {EpilogForAll};

 PROCEDURE EpilogForDeduct();
 BEGIN
 END {EpilogForDeduct};

(*------------------------------------------------------------------*)

 PROCEDURE AddComent(Text: STRING[]);
 BEGIN
  FIO.WrLn(P);
  FIO.WrStr(P, ";" + Text);
 END {AddComent};

 PROCEDURE PrologForDeduct();
 BEGIN
  STDMSG("祭 ⥦ "+PayP.PayP+" "+PayP.Name+"|饭 ᮧ .㬥⮢  筮 㤥ঠ");
 END {PrologForDeduct};

 PROCEDURE E_ClientBankUploadNameForAdd_Doc(D: DATE): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(D, PROCREF(E_PDoc.ClientBankUploadNameForAdd_Doc), Str.Slice(PDoc.PDoc, Str.Length(PDoc.PDoc)-5, 5));
 END {E_ClientBankUploadNameForAdd_Doc};

 PROCEDURE PrologForPDoc();
 BEGIN
  _FileName:=FIO.MakePath(E_ClientBankUploadNameForAdd_Doc(Memo.tmp_mb()), "TXT", E_PDoc.ClientBankUploadPathForAdd_Doc(1));
  IF (L_PDoc.CB_GetPDocClientBank(PDoc.PDocKind, PDoc.PDoc)#0) & (FIO.Exists(_FileName)) THEN
   STDMSG("  䠩 "+_FileName, CHOICE);
  END;
  FIO.Open(P, _FileName, , Create);
  Count:=0;
 END {PrologForPDoc};

 PROCEDURE EpilogForPDoc();
  VAR
   CopyPath,
   CopyName : STRING[];
 BEGIN
  IF Count # 0 THEN
   FIO.WrLn(P);
  END;
  FIO.WrStr(P, ";" + " ᮧ "+L_DatTim.DateStr(SYSDATE())+"  "+L_DatTim.TimeStr(SYSTIME()));;
  AddComent(" "+FULLNAME()+" - "+LOGINNAME());
  AddComent(" ᭮ ⥦ 㬥 "+PDoc.SrcNbr+"  "+L_DatTim.DateStr(PDoc.Date));
  AddComent("  㬬 "+FLDTOSTR(PDoc.Total, ",2-", 20, "L"));
  AddComent(L_PDoc.GetPDocComment());
  FIO.WrLn(P);
  FIO.Close(P);
  CopyPath:=Path+FLDTOSTR(PDoc.Date, "\y", 5);  (*㥬  ࠭*)
  IF ~FIO.DirExists(CopyPath) THEN
   FIO.MkDir(CopyPath);
  END;
  CopyName:=FIO.MakePath(E_ClientBankUploadNameForAdd_Doc(Memo.tmp_mb()), "TXT", CopyPath);
  IF FIO.Exists(CopyName) THEN
   STDMSG("  䠩 "+CopyName, CHOICE);
  END;
  L_FIO.FileCopy(_FileName, CopyName);
 END {EpilogForPDoc};

 PROCEDURE CreateDocument();
  VAR
   Sum : NUMERIC[2] [L_PayP.MaxSumAmnt];
   _Sum: LIKE(PDocList.Sum);
 BEGIN
  SEARCH(PDocList, PDoc, , PDoc.PDocKind, PDoc.PDoc, Deduct.TSN);
  PROMPT(" ⥫쭮 㬥 "+_FileName+": "+PDocList.TSN);
  IF Count # 0 THEN
   FIO.WrLn(P);
  END;
  INC(Count);
  IF L_PDoc.IsSalPDoc() THEN
   _Sum:=PDocList.Sum;
  ELSE
   L_PayP.GetDedAcntDebts(Sum[0], Sum[1]);
   _Sum:=Sum[0]+Sum[1];
  END;
  FIO.WrStr(P, L_Str.IntStr(Count)+","
              +Deduct.PCode+","
              +FLDTOSTR(_Sum, "2.", 0)+","
              +Deduct.Person+",");
 END {CreateDocument};

END.
