(*
%Copyright   (c) Polak Computer System
%Author      25.10.2002 10:16:44 POLAK\LDA
%Purpose     PASTE  Add_Doc - txt-䠩   ᪢
%Type        to_paste
%Specific    SYS
%Modified    25.09.2008 20:47:31 POLAK\Gina
%Environment
*)

 IMPORT FIO, L_General, L_OwnData, L_Str, L_PDoc, Str, L_PayP;

 PROCEDURE MayCreateInAutoMode(): SCAL[2];
 BEGIN
  RETURN ~L_PDoc.IsSingleTSN_PDoc();
 END {MayCreateInAutoMode};

 PROCEDURE GetItemForIndex(): STRING[250];
 BEGIN
  RETURN "Deduct.Person";
 END {GetItemForIndex};

 PROCEDURE GetFileName(): STRING[];
 BEGIN
  RETURN FIO.MakePath(FLDTOSTR(PDoc.Date, "Y", 2)+"_"+Str.Slice(PDoc.PDoc, Str.Length(PDoc.PDoc)-5, 5),
                      "txt", "REP\TO_BANK");
 END {GetFileName};

 PROCEDURE PrologForPDoc();
  VAR
   _FileName: STRING[];
 BEGIN
  _FileName:=GetFileName();
  IF FIO.Exists(_FileName) THEN
   STDMSG("  䠩 " + _FileName, CHOICE);
  END;
  FIO.Open(F, _FileName, , Create);
  FIO.WrStr(F, FLDTOSTR(PDoc.Date, "D.N.y") + ";"  +
              PDoc.PDoc + ";" +
              L_OwnData.ODFirmName(SYSDATE()));
  FIO.WrLn(F);
 END {PrologForPDoc};

 PROCEDURE EpilogForPDoc();
  VAR
   Amnt: NUMERIC[0];
 BEGIN
  Amnt:=0;
  SELECT(PDocList, PDoc, , PDoc.PDocKind, PDoc.PDoc);
  WHILE OCCURE(PDocList) DO
   INC(Amnt);
   NEXT(PDocList);
  END; (* WHILE OCCURE(PDocList) ... *)
  FIO.WrStr(F, FLDTOSTR(PDoc.Total, "2.") + ";" + L_Str.IntStr(Amnt));
  FIO.WrLn(F);
  FIO.Close(F);
  STDMSG("ନ஢ 䠩 " + GetFileName(), INFORM);
 END {EpilogForPDoc};

 PROCEDURE CreateDocument();
  VAR
   Sum : NUMERIC[2] [L_PayP.MaxSumAmnt];
   _Sum: LIKE(PDocList.Sum);
 BEGIN
  SEARCH(PDocList, PDoc, , PDoc.PDocKind, PDoc.PDoc, Deduct.TSN);
  PROMPT(" ⥫쭮 㬥: "+PDocList.TSN);
  CONFORM(PDocList, Staff);
  IF L_PDoc.IsSalPDoc() THEN
   _Sum:=PDocList.Sum;
  ELSE
   L_PayP.GetDedAcntDebts(Sum[0], Sum[1]);
   _Sum:=Sum[0]+Sum[1];
  END;
  FIO.WrStr(F, Deduct.PCode+";"+
               FLDTOSTR(_Sum, "2.")+";"+
               Deduct.Person);
  FIO.WrLn(F);
 END {CreateDocument};

END.
