(*
%Copyright   (c) Polak Computer System
%Author      06.07.2001 22:47:23 GINA
%Purpose     PASTE  Add_Doc - dbf 䠩    ᨬ
%Type        to_paste
%Specific    SYS
%Modified    31.01.2012 10:51:54 POLAK\San
%Environment
*)

(*
cmd        character(1)    ! 
name       character(64)   ! 
sex        character(1)    !  ''  ''
state      character(16)   ! ࠦ⢮, 
index      character(6)    ! ⮢ 
domain     character(16)   ! 
city       character(16)   ! த
place      character(48)   ! ⠫쭠  
address    character(128)  !   ᨩ᪮ 樨
birthday   date            !  ஦
passport   character(16)   !    㬥
ps_created character(48)   !  뤠
ps_date    date            !  뤠
sum        numeric(9)      ! 㬬  
ext        string(256)     ! ⥫쭮 
 ext  ᫥騬 ࠧ(  ᨢ 稭  1):
ext[1..20] -   饣  騩 ;
ext[22] -  , ࠢ筨 ।⠢;
ext[23..42] -   , ᫨  ,  ᮢ  祭  ext[1..20];
ext[65..192] - ᮮ饭;
  ext[193..256]  ᯮ짮 .
*)

 IMPORT DBF, Str, FIO, L_General, L_Man, L_EC, L_PDoc, E_PDoc, L_Russia, L_PayP;

 CONST
  _FNP = "import_p";
  _FN  = "import";
  Path = "REP\IMPORT";

 VAR
  TotSum   : NUMERIC[2];
  Count    : NUMERIC[0];
  _FileName_P,
  _FileName: STRING[];

(*------ Subsidiary procedures -------------------------------------*)

 PROCEDURE AddComma(S: STRING[]): STRING[];
 BEGIN
  IF ~!S THEN
   RETURN S+", ";
  ELSE
   RETURN S;
  END;
 END {AddComma};

 PROCEDURE GetPlace(): STRING[];
  VAR
   S, tmpstr: STRING[];
 BEGIN
  SETEMPTY(S);
  IF ~!ManAdr.Village THEN
   S:=AddComma(S)+L_Russia.VillageT_asStr(ManAdr.VillageT)+" "+ManAdr.Village;
  END;
  IF ~!ManAdr.Street THEN
   S:=AddComma(S)+L_Russia.StreetT_asStr(ManAdr.StreetT)+" "+ManAdr.Street;
  END;
  IF ~!ManAdr.House THEN
   S:=AddComma(S)+"."+ManAdr.House;
  END;
  IF ~!ManAdr.Block THEN
   S:=AddComma(S)+"."+ManAdr.Block;
  END;
  IF ~!ManAdr.Build THEN
   S:=AddComma(S)+"."+ManAdr.Build;
  END;
  IF ~!ManAdr.Flat THEN
   S:=AddComma(S)+"."+ManAdr.Flat;
  END;
  RETURN Str.Condense(S);
 END {GetPlace};

 PROCEDURE GetShortBthPlace(): STRING[];
 BEGIN
  IF L_Man.AccessManAdr(Man.Man, SYSDATE(), L_Russia.at_BthMA) THEN
   IF    ~!ManAdr.RegionN THEN
    RETURN ManAdr.RegionN;
   ELSIF ~!ManAdr.Town THEN
    RETURN ". "+ManAdr.Town;
   ELSIF ~!ManAdr.Village THEN
    RETURN L_Russia.VillageT_asStr(ManAdr.VillageT)+" "+ManAdr.Village;
   ELSIF ~!ManAdr.Country THEN
    CONFORM(ManAdr, Country);
    RETURN Country.Name;
   END;
  END;
  RETURN "";
 END {GetShortBthPlace};

(*------------------------------------------------------------------*)

 PROCEDURE GetItemForIndex(): STRING[250];
 BEGIN
  RETURN "Deduct.Person";
 END {GetItemForIndex};

 PROCEDURE MayCreateInAutoMode(): SCAL[2];
 BEGIN
  RETURN ~L_PDoc.IsSingleTSN_PDoc();
 END {MayCreateInAutoMode};

(*------ Empty procedures ------------------------------------------*)

 PROCEDURE PrologForPayP();
 BEGIN
 END {PrologForPayP};

 PROCEDURE EpilogForPayP();
 BEGIN
 END {EpilogForPayP};

 PROCEDURE EpilogForDeduct();
 BEGIN
 END {EpilogForDeduct};

(*------------------------------------------------------------------*)

 PROCEDURE PrologForDeduct();
 BEGIN
  STDMSG("祭 ⥦ "+PayP.PayP+" "+PayP.Name+"|饭 ᮧ .㬥⮢  筮 㤥ঠ");
 END {PrologForDeduct};

(*
 PROCEDURE E_ClientBankUploadNameForAdd_Doc(D: DATE): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(D, PROCREF(E_PDoc.ClientBankUploadNameForAdd_Doc), _FN);
 END {E_ClientBankUploadNameForAdd_Doc};
*)

 PROCEDURE E_ClientBankUploadNameForAdd_Doc(D: DATE): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(D, PROCREF(E_PDoc.ClientBankUploadNameForAdd_Doc), Str.Slice(PDoc.PDoc, Str.Length(PDoc.PDoc)-5, 5));
 END {E_ClientBankUploadNameForAdd_Doc};

 PROCEDURE PrologForPDoc();
 BEGIN
  PROMPT("⨥ DBF");
  _FileName_P:=FIO.MakePath(_FNP, "DBF", "REP\TO_BANK");
  L_General.Assert(FIO.Exists(_FileName_P), " 䠩-蠡 "+_FileName_P);
  FIO.Open(Dbf_P, _FileName_P, , Input);
  Count:=0;
  _FileName:=FIO.MakePath(E_ClientBankUploadNameForAdd_Doc(SYSDATE()), "DBF", E_PDoc.ClientBankUploadPathForAdd_Doc(2));
  IF (L_PDoc.CB_GetPDocClientBank(PDoc.PDocKind, PDoc.PDoc)#0) & (FIO.Exists(_FileName)) THEN
   STDMSG("  䠩 "+_FileName, CHOICE);
  END;
  FIO.Open(Dbf, _FileName, , Create); (*ᮧ*)
  FIO.Copy(Dbf_P, Dbf);
  FIO.Close(Dbf_P);
  FIO.Close(Dbf);
  DBF.Open(Dbf, _FileName, Output); (*  dbf*)
  DBF.SetAmount(Dbf, 0);            (**)
  DBF.SetAmount(Dbf, 1);
 END {PrologForPDoc};

 PROCEDURE EpilogForPDoc();
  VAR
   TmpName: STRING[];
 BEGIN
  DBF.Close(Dbf);
  IF ~FIO.DirExists(Path) THEN
   FIO.MkDir(Path);
  END;
  TmpName:=FIO.MakePath(FLDTOSTR(PDoc.Date, "Y", 2)+"_"+Str.Slice(PDoc.PDoc, Str.Length(PDoc.PDoc)-5, 5), "DBF", Path);
  IF FIO.Exists(TmpName) THEN
   STDMSG("  䠩 "+TmpName, CHOICE);
  END;
  FIO.Open(In, _FileName, , Input);
  FIO.Open(Tmp, TmpName, , Create);
  FIO.Copy(In, Tmp);
  FIO.Close(Tmp);
  FIO.Close(In);
 END {EpilogForPDoc};

 PROCEDURE Set_DBFField(_Sum: LIKE(PDocList.Sum); VAR _AskForAliensWithNoDwAdr: SCAL[2]);
  VAR
   Choice: SCAL[2];
 BEGIN
  L_General.Assert(OCCURE(Man), " । 䨧᪮ ");
  DBF.SetField(Dbf, "NAME", Man.Name);
  DBF.SetField(Dbf, "SEX", Str.Item("|", "|", Man.Sex));
  L_General.Assert(L_Man.AccessManAdr(Man.Man, SYSDATE(), L_Russia.at_RgMA), "  :  "+Man.Man);
  CONFORM(ManAdr, Country);
  DBF.SetField(Dbf, "STATE", Country.Name);
  IF ManAdr.Country # 643 THEN
   DBF.SetField(Dbf, "ADDRESS", L_Man.GetAdr_asShortStr(Man.Man, SYSDATE(), L_Russia.at_RgMA));
   IF ~L_Man.AccessManAdr(Man.Man, SYSDATE(), L_Russia.at_DwMA) & _AskForAliensWithNoDwAdr THEN
    Choice:=STDFORM("| 㪠  䠪᪮ .  " + Man.Man + "|||"+
                    "%< ! >DZ  %< 믮 >B  %< 믮   >B", , STOP);
    _AskForAliensWithNoDwAdr:=(Choice = 1);
   END;
  END;
  IF OCCURE(ManAdr) THEN
   DBF.SetField(Dbf, "INDEX", STRTOFLD(ManAdr.Zip, NUMERIC));
   DBF.SetField(Dbf, "DOMAIN", ManAdr.RegionN);
   IF !ManAdr.Town & (ManAdr.Region = 77) THEN
    DBF.SetField(Dbf, "CITY", "᪢");
   ELSE
    DBF.SetField(Dbf, "CITY", ManAdr.Town);
   END;
   DBF.SetField(Dbf, "PLACE", GetPlace());
  ELSE
   DBF.SetField(Dbf, "PLACE", "⭮");
  END;
  DBF.SetField(Dbf, "BIRTHDAY", Man.Birth);
  DBF.SetField(Dbf, "BIRTHPLACE", GetShortBthPlace());
  DBF.SetField(Dbf, "PASSPORT", Man.PspSer+" "+Man.PspNbr);
  DBF.SetField(Dbf, "PS_CREATED", Man.PspGiveS);
  DBF.SetField(Dbf, "PS_DATE", Man.PspGiveD);
  DBF.SetField(Dbf, "SUM", _Sum*100);
 END {Set_DBFField};

 PROCEDURE CreateDocument();
  VAR
   _AskForAliensWithNoDwAdr: SCAL[2];
   Sum : NUMERIC[2] [L_PayP.MaxSumAmnt];
   _Sum: LIKE(PDocList.Sum);
 BEGIN
  SEARCH(PDocList, PDoc, , PDoc.PDocKind, PDoc.PDoc, Deduct.TSN);
  PROMPT(" ⥫쭮 㬥 "+_FileName+": "+PDocList.TSN);
  DBF.SetAmount(Dbf, Count+1);
  DBF.Seek(Dbf, Count);

  _AskForAliensWithNoDwAdr:=0;
  IF L_PDoc.IsSalPDoc() THEN
   _Sum:=PDocList.Sum;
  ELSE
   L_PayP.GetDedAcntDebts(Sum[0], Sum[1]);
   _Sum:=Sum[0]+Sum[1];
  END;
  Set_DBFField(_Sum, _AskForAliensWithNoDwAdr);

  DBF.SetDeleted(Dbf, 0);
  DBF.Update(Dbf);
  INC(Count);
 END {CreateDocument};

END.
