
 IMPORT L_General, L_GUI, L_General, L_Str, L_Math, Str, Math;

 PRIVATE VAR
  dlg: DIALOG;

 PRIVATE TYPE
  tColorsNumber = SCAL[16];

 CONST
  CurNumPalette = 0;

  Id_Line           = "Line";
  Id_Background     = "The background";
  Id_BottomLine     = "Bottom line";
  Id_ComboBox       = "ComboBox";
  Id_SamplePalettes = "SamplePalettes";
  Id_SampleText     = "LabelText";
  Id_SampleLines    = "LabelLines";
  Id_SampleHatching = "LabelHatching";
  Id_Ok             = "OK";

  Id_BtnMultChromaH = "Btn mult chroma";
  Id_BtnDivChromaH  = "Btn div chroma";
  Id_STMultChromaH  = "static text mult";
  Id_STDivChromaH   = "static text div";
  Id_EMultChromaH   = "Edit mult chroma";
  Id_EDivChromaH    = "Edit div chroma";

  Id_BtnMultChromaL = "Btn mult chroma lines";
  Id_BtnDivChromaL  = "Btn div chroma lines";
  Id_STMultChromaL  = "static text mult lines";
  Id_STDivChromaL   = "static text div lines";
  Id_EMultChromaL   = "Edit mult chroma lines";
  Id_EDivChromaL    = "Edit div chroma lines";

  STMultChroma = ". 㢥. . MAX = ";
  STDivChroma = ". 㬥. . MAX = ";

  TextPool = "⥪  ࠬ "                              + "|" +
             "梥  1 (DATE, TIME, TIMESTAMP)"            + "|" +
             "梥  2 (NUMERIC, FLOAT)"                   + "|" +
             "梥  3 (SCAL, STRING)"                     + "|" +
             "梥  4 (饭 )"                 + "|" +
             "祭 "                               + "|" +
             "⥪饥    ⨢ "            + "|" +
             " ᨬ  䨪஢ "          + "|" +
             " ⨢ "                            + "|" +
             " "                                  + "|" +
             "।㥬 "                              + "|" +
             "뤥  ।㥬 "                  + "|" +
             "।㥬   ࠢ筨"              + "|" +
             "뤥  ।㥬   ࠢ筨"  + "|" +
             " -ࠢ筨  ⨢"              + "|" +
             " , 易  ⨢"             ;
(*
             + "|" +
             " "                                   + "|" +
             " ";
*)

  DefaultFontColor0 = "40, 40, 40" + "|" +
                      "80, 00, 00" + "|" +
                      "00, 00, 80" + "|" +
                      "00, 80, 80" + "|" +
                      "FF, FF, FF" + "|" +
                      "a8, 54, 54" + "|" +
                      "FF, E0, 00" + "|" +
                      "43, 99, FF" + "|" +
                      "FF, FF, FF" + "|" +
                      "FF, FF, FF" + "|" +
                      "00, 00, 00" + "|" +
                      "00, 00, 00" + "|" +
                      "00, 00, 00" + "|" +
                      "00, 00, 00" + "|" +
                      "40, 40, 40" + "|" +
                      "40, 40, 40" + "|" +
                      "D5, DF, E5" + "|" +
                      "D5, DF, E5";

  DefaultBackgroundColor0 = "C0, C0, C0" + "|" +
                            "C0, C0, C0" + "|" +
                            "C0, C0, C0" + "|" +
                            "C0, C0, C0" + "|" +
                            "C0, C0, C0" + "|" +
                            "C0, C0, C0" + "|" +
                            "00, 00, 80" + "|" +
                            "88, E0, E0" + "|" +
                            "00, 00, 80" + "|" +
                            "00, 80, 80" + "|" +
                            "D5, D5, D5" + "|" +
                            "88, E0, E0" + "|" +
                            "D5, D5, D5" + "|" +
                            "b0, b0, b0" + "|" +
                            "DA, DA, DA" + "|" +
                            "C9, C9, C9" + "|" +
                            "A0, A0, A0" + "|" +
                            "80, 80, 80" ;

  DefaultLinesColor0 = "d5, df, e5" + "|" +
                       "A8, 54, 54" + "|" +
                       "15, 15, 6a" + "|" +
                       "40, a0, a0" + "|" +
                       "e0, e0, e0" + "|" +
                       "e8, 84, 84" + "|" +
                       "e0, e0, e0" + "|" +
                       "e0, e0, e0" + "|" +
                       "e0, e0, e0" + "|" +
                       "e0, e0, e0" + "|" +
                       "d5, df, e5" + "|" +
                       "e0, e0, e0" + "|" +
                       "d5, df, e5" + "|" +
                       "e0, e0, e0" + "|" +
                       "e0, e0, e0" + "|" +
                       "e0, e0, e0" + "|" +
                       "e0, e0, e0" + "|" +
                       "e0, e0, e0";

  DefaultHatchingColor0 = "80, 80, 80" + "|" +
                          "A8, 54, 54" + "|" +
                          "15, 15, 6a" + "|" +
                          "40, A0, A0" + "|" +
                          "f0, f0, f0" + "|" +
                          "e8, 84, 84" + "|" +
                          "d4, bb, 00" + "|" +
                          "e0, e0, e0" + "|" +
                          "f0, f0, f0" + "|" +
                          "e0, e0, e0" + "|" +
                          "e0, e0, e0" + "|" +
                          "e0, e0, e0" + "|" +
                          "e0, e0, e0" + "|" +
                          "e0, e0, e0" + "|" +
                          "80, 80, 80" + "|" +
                          "80, 80, 80" + "|" +
                          "e0, e0, e0" + "|" +
                          "e0, e0, e0";

 PRIVATE PROCEDURE ConvHexStr2RGB(RGB: STRING[]): RGBCOLOR;
  VAR
   Result: RGBCOLOR;
 BEGIN
  Result:=RGBCOLOR.Create();
  Result.Red  :=L_Math.HexToDec(Str.Item(RGB, ", ", 0));
  Result.Green:=L_Math.HexToDec(Str.Item(RGB, ", ", 1));
  Result.Blue :=L_Math.HexToDec(Str.Item(RGB, ", ", 2));
  RETURN Result;
 END {ConvHexStr2RGB};

 PRIVATE PROCEDURE SetColors(NumPalette: NUMERIC[0]; C: tColorsNumber; VAR FCol, BCol, LCol, HCol: RGBCOLOR);
 BEGIN
  IF NumPalette = 0 THEN
   FCol:=ConvHexStr2RGB(L_Str.PoolItem(DefaultFontColor0,       C));
   BCol:=ConvHexStr2RGB(L_Str.PoolItem(DefaultBackgroundColor0, C));
   LCol:=ConvHexStr2RGB(L_Str.PoolItem(DefaultLinesColor0,      C));
   HCol:=ConvHexStr2RGB(L_Str.PoolItem(DefaultHatchingColor0,   C));
  ELSE
   L_General.Error(" N " + L_Str.IntStr(NumPalette) + "  ஥");
  END;
 END {SetColors};

 PRIVATE PROCEDURE MaxRGB(R, G, B: NUMERIC[0]): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  Result:=Math.Max(R, G);
  Result:=Math.Max(Result, B);
  IF Result = 0 THEN Result:=1; END;
  RETURN Result;
 END {MaxRGB};

 PRIVATE PROCEDURE intMaxFactorMult(R, G, B: STRING[]): NUMERIC[3];
 BEGIN
  RETURN 255/MaxRGB(L_Math.HexToDec(R), L_Math.HexToDec(G), L_Math.HexToDec(B));
 END {intMaxFactorMult};

 PRIVATE PROCEDURE MaxFactorMultH(): NUMERIC[3];
 BEGIN
  RETURN intMaxFactorMult(dlg.Controls.Item("RH").Value, dlg.Controls.Item("GH").Value, dlg.Controls.Item("BH").Value);
 END {MaxFactorMultH};

 PRIVATE PROCEDURE MaxFactorMultL(): NUMERIC[3];
 BEGIN
  RETURN intMaxFactorMult(dlg.Controls.Item("RL").Value, dlg.Controls.Item("GL").Value, dlg.Controls.Item("BL").Value);
 END {MaxFactorMultL};

 PRIVATE PROCEDURE MinRGB(R, G, B: NUMERIC[0]): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  Result:=Math.Min(R, G);
  Result:=Math.Min(Result, B);
  IF Result = 0 THEN Result:=1; END;
  RETURN Result;
 END {MaxRGB};

 PRIVATE PROCEDURE intMaxFactorDiv(R, G, B: STRING[]): NUMERIC[3];
 BEGIN
  RETURN MinRGB(L_Math.HexToDec(R), L_Math.HexToDec(G), L_Math.HexToDec(B));
 END {intMaxFactorDiv};

 PRIVATE PROCEDURE MaxFactorDivH(): NUMERIC[3];
 BEGIN
  RETURN intMaxFactorDiv(dlg.Controls.Item("RH").Value, dlg.Controls.Item("GH").Value, dlg.Controls.Item("BH").Value);
 END {MaxFactorDivH};

 PRIVATE PROCEDURE MaxFactorDivL(): NUMERIC[3];
 BEGIN
  RETURN intMaxFactorDiv(dlg.Controls.Item("RL").Value, dlg.Controls.Item("GL").Value, dlg.Controls.Item("BL").Value);
 END {MaxFactorDivL};

 PRIVATE PROCEDURE SetTextMultDivChromaH();
 BEGIN
  dlg.Controls.Item(Id_STMultChromaH).Text:=STMultChroma + L_Str.NumericStr(MaxFactorMultH(), 3);
  dlg.Controls.Item(Id_STDivChromaH).Text:=STDivChroma + L_Str.NumericStr(MaxFactorDivH(), 3);
 END {SetTextMultDivChromaH};

 PRIVATE PROCEDURE SetTextMultDivChromaL();
 BEGIN
  dlg.Controls.Item(Id_STMultChromaL).Text:=STMultChroma + L_Str.NumericStr(MaxFactorMultL(), 3);
  dlg.Controls.Item(Id_STDivChromaL).Text:=STDivChroma + L_Str.NumericStr(MaxFactorDivL(), 3);
 END {SetTextMultDivChromaL};

 PRIVATE PROCEDURE Edit_Hatching_OnSuccessfulChange(RGB: RGBCOLOR; SPId: STRING[]);
 BEGIN
  dlg.Controls.Item(Id_SampleHatching).Style.Color.Copy(RGB);
  dlg.Controls.Item(SPId).Style.Color.Copy(RGB);
  dlg.Controls.Item(SPId).Text:="H (" + RGB2Text(RGB) + ")";
  SetTextMultDivChromaH();
 END {Edit_Hatching_OnSuccessfulChange};

 PRIVATE PROCEDURE Edit_Lines_OnSuccessfulChange(RGB: RGBCOLOR; SPId: STRING[]);
 BEGIN
  dlg.Controls.Item(Id_SampleLines).Style.Color.Copy(RGB);
  dlg.Controls.Item(SPId).Style.Color.Copy(RGB);
  dlg.Controls.Item(SPId).Text:="L (" + RGB2Text(RGB) + ")";
  SetTextMultDivChromaL();
 END {Edit_Lines_OnSuccessfulChange};

 PRIVATE PROCEDURE GetSamplePalettesId(PaletteChar: STRING[1]; C: tColorsNumber): STRING[];
 BEGIN
  RETURN PaletteChar + "_" + Id_SamplePalettes + "_" + L_Str.IntStr(C);
 END {GetSamplePalettesId};

 PRIVATE PROCEDURE RGB2Text(RGB: RGBCOLOR): STRING[];
 BEGIN
  RETURN L_Math.DecToHex(RGB.Red) + ", " + L_Math.DecToHex(RGB.Green) + ", " + L_Math.DecToHex(RGB.Blue);
 END {RGB2Text};

 PRIVATE PROCEDURE Edit_OnSuccessfulChange(SLF: EDIT; PrvValue: STRING[]);
  VAR
   RGB: RGBCOLOR;
   c  : OBJECT;
   C  : tColorsNumber;
 BEGIN
  RGB:=RGBCOLOR.Create();
  C:=dlg.Controls.Item(Id_ComboBox).Value;
  IF L_Str.Char(SLF.Id, 1) = "F" THEN
   RGB.Copy(dlg.Controls.Item(Id_SampleText).Style.Color);
   IF    L_Str.Char(SLF.Id, 0) = "R" THEN RGB.Red  :=L_Math.HexToDec(SLF.Value);
   ELSIF L_Str.Char(SLF.Id, 0) = "G" THEN RGB.Green:=L_Math.HexToDec(SLF.Value);
   ELSIF L_Str.Char(SLF.Id, 0) = "B" THEN RGB.Blue :=L_Math.HexToDec(SLF.Value);
   END;
   dlg.Controls.Item(Id_SampleText).Style.Color.Copy(RGB);
   dlg.Controls.Item(GetSamplePalettesId("T", C)).Style.Color.Copy(RGB);
   dlg.Controls.Item(GetSamplePalettesId("T", C)).Text:="T (" + RGB2Text(RGB) + ")";
  ELSIF L_Str.Char(SLF.Id, 1) = "B" THEN
   RGB.Copy(dlg.Controls.Item(Id_SampleText).Style.BkColor);
   IF    L_Str.Char(SLF.Id, 0) = "R" THEN RGB.Red  :=L_Math.HexToDec(SLF.Value);
   ELSIF L_Str.Char(SLF.Id, 0) = "G" THEN RGB.Green:=L_Math.HexToDec(SLF.Value);
   ELSIF L_Str.Char(SLF.Id, 0) = "B" THEN RGB.Blue :=L_Math.HexToDec(SLF.Value);
   END;
   dlg.Controls.Item(Id_SampleText).Style.BkColor.Copy(RGB);
   dlg.Controls.Item(Id_SampleLines).Style.BkColor.Copy(RGB);
   dlg.Controls.Item(Id_SampleHatching).Style.BkColor.Copy(RGB);
   dlg.Controls.Item(GetSamplePalettesId("T", C)).Style.BkColor.Copy(RGB);
   dlg.Controls.Item(GetSamplePalettesId("L", C)).Style.BkColor.Copy(RGB);
   dlg.Controls.Item(GetSamplePalettesId("H", C)).Style.BkColor.Copy(RGB);
(*
   IF C = FORM_FIELD.Color_Pane THEN
    dlg.Controls.Item(Id_BottomLine).Style.BkColor.Copy(RGB);
   ELSIF (C >= FORM_FIELD.Color_Text) & (C <= FORM_FIELD.Color_Field4) THEN
    dlg.Controls.Item(Id_Background).Style.BkColor.Copy(RGB);
   END;
*)
   IF (C >= FORM_FIELD.Color_Text) & (C <= FORM_FIELD.Color_Field4) THEN
    dlg.Controls.Item(Id_Background).Style.BkColor.Copy(RGB);
   END;
  ELSIF L_Str.Char(SLF.Id, 1) = "L" THEN
   RGB.Copy(dlg.Controls.Item(Id_SampleLines).Style.Color);
   IF    L_Str.Char(SLF.Id, 0) = "R" THEN RGB.Red  :=L_Math.HexToDec(SLF.Value);
   ELSIF L_Str.Char(SLF.Id, 0) = "G" THEN RGB.Green:=L_Math.HexToDec(SLF.Value);
   ELSIF L_Str.Char(SLF.Id, 0) = "B" THEN RGB.Blue :=L_Math.HexToDec(SLF.Value);
   END;
   Edit_Lines_OnSuccessfulChange(RGB, GetSamplePalettesId("L", C));
  ELSE
   RGB.Copy(dlg.Controls.Item(Id_SampleHatching).Style.Color);
   IF    L_Str.Char(SLF.Id, 0) = "R" THEN RGB.Red  :=L_Math.HexToDec(SLF.Value);
   ELSIF L_Str.Char(SLF.Id, 0) = "G" THEN RGB.Green:=L_Math.HexToDec(SLF.Value);
   ELSIF L_Str.Char(SLF.Id, 0) = "B" THEN RGB.Blue :=L_Math.HexToDec(SLF.Value);
   END;
   Edit_Hatching_OnSuccessfulChange(RGB, GetSamplePalettesId("H", C));
  END;
  FOR_EACH c IN dlg.Controls DO
   c.Redraw();
  END;
 END {Edit_OnSuccessfulChange};

 PRIVATE PROCEDURE ComboBox_OnSuccessfulChange(SLF: EDIT; PrvValue: NUMERIC[0]);
  VAR
   C   : tColorsNumber;
   FCol,
   BCol,
   LCol,
   HCol: RGBCOLOR;
   c   : OBJECT;
 BEGIN
  C:=dlg.Controls.Item(Id_ComboBox).Value;
  FCol:=RGBCOLOR.Create();
  BCol:=RGBCOLOR.Create();
  LCol:=RGBCOLOR.Create();
  HCol:=RGBCOLOR.Create();
  FCol.Copy(APP.Get().PaletteKit.TextPalette.Item(C).Color);
  BCol.Copy(APP.Get().PaletteKit.TextPalette.Item(C).BkColor);
  LCol.Copy(APP.Get().PaletteKit.LinesPalette.Item(C).Color);
  HCol.Copy(APP.Get().PaletteKit.HatchingPalette.Item(C).Color);


  dlg.Controls.Item("RB").Value:=L_Math.DecToHex(BCol.Red);
  dlg.Controls.Item("GB").Value:=L_Math.DecToHex(BCol.Green);
  dlg.Controls.Item("BB").Value:=L_Math.DecToHex(BCol.Blue);

  dlg.Controls.Item("RF").Value:=L_Math.DecToHex(FCol.Red);
  dlg.Controls.Item("GF").Value:=L_Math.DecToHex(FCol.Green);
  dlg.Controls.Item("BF").Value:=L_Math.DecToHex(FCol.Blue);

  dlg.Controls.Item("RL").Value:=L_Math.DecToHex(LCol.Red);
  dlg.Controls.Item("GL").Value:=L_Math.DecToHex(LCol.Green);
  dlg.Controls.Item("BL").Value:=L_Math.DecToHex(LCol.Blue);

  dlg.Controls.Item("RH").Value:=L_Math.DecToHex(HCol.Red);
  dlg.Controls.Item("GH").Value:=L_Math.DecToHex(HCol.Green);
  dlg.Controls.Item("BH").Value:=L_Math.DecToHex(HCol.Blue);

  dlg.Controls.Item("RL").Visible:=IsLinesVis(C);
  dlg.Controls.Item("GL").Visible:=IsLinesVis(C);
  dlg.Controls.Item("BL").Visible:=IsLinesVis(C);

  dlg.Controls.Item("RH").Visible:=IsHatchingVis(C);
  dlg.Controls.Item("GH").Visible:=IsHatchingVis(C);
  dlg.Controls.Item("BH").Visible:=IsHatchingVis(C);

  SetTextMultDivChromaH();
  SetTextMultDivChromaL();

  dlg.Controls.Item(Id_SampleText).Style.Color.Copy(FCol);
  dlg.Controls.Item(Id_SampleText).Style.BkColor.Copy(BCol);

  dlg.Controls.Item(Id_SampleLines).Style.Color.Copy(LCol);
  dlg.Controls.Item(Id_SampleLines).Style.BkColor.Copy(BCol);
  dlg.Controls.Item(Id_SampleLines).Visible:=IsLinesVis(C);

  dlg.Controls.Item(Id_SampleHatching).Style.Color.Copy(HCol);
  dlg.Controls.Item(Id_SampleHatching).Style.BkColor.Copy(BCol);
  dlg.Controls.Item(Id_SampleHatching).Visible:=IsHatchingVis(C);

  FOR_EACH c IN dlg.Controls DO
   c.Redraw();
  END;
 END {ComboBox_OnSuccessfulChange};

 PRIVATE PROCEDURE OnClick_OK(SLF: PUSH_BUTTON);
  VAR
   C: tColorsNumber;
 BEGIN
  FOR_EACH C DO
   APP.Get().PaletteKit.TextPalette.Item(C).Color.Copy(dlg.Controls.Item(GetSamplePalettesId("T", C)).Style.Color);
   APP.Get().PaletteKit.TextPalette.Item(C).BkColor.Copy(dlg.Controls.Item(GetSamplePalettesId("T", C)).Style.BkColor);
 
   APP.Get().PaletteKit.LinesPalette.Item(C).Color.Copy(dlg.Controls.Item(GetSamplePalettesId("L", C)).Style.Color);
   APP.Get().PaletteKit.LinesPalette.Item(C).BkColor.Copy(dlg.Controls.Item(GetSamplePalettesId("L", C)).Style.BkColor);
 
   APP.Get().PaletteKit.HatchingPalette.Item(C).Color.Copy(dlg.Controls.Item(GetSamplePalettesId("H", C)).Style.Color);
   APP.Get().PaletteKit.HatchingPalette.Item(C).BkColor.Copy(dlg.Controls.Item(GetSamplePalettesId("H", C)).Style.BkColor);
  END;
 END {OnClick_OK};

 PRIVATE PROCEDURE SetPalette();
  VAR
   Idx : tColorsNumber;
   FCol,
   BCol,
   LCol,
   HCol: RGBCOLOR;
 BEGIN
(*
  APP.Get().PaletteKit.Reset(0);
*)
  FOR_EACH Idx DO

   SetColors(CurNumPalette, Idx, FCol, BCol, LCol, HCol);
   APP.Get().PaletteKit.TextPalette.Item(Idx).Color.Copy(FCol);
   APP.Get().PaletteKit.TextPalette.Item(Idx).BkColor.Copy(BCol);

   APP.Get().PaletteKit.LinesPalette.Item(Idx).Color.Copy(LCol);
   APP.Get().PaletteKit.LinesPalette.Item(Idx).BkColor.Copy(BCol);

   APP.Get().PaletteKit.HatchingPalette.Item(Idx).Color.Copy(HCol);
   APP.Get().PaletteKit.HatchingPalette.Item(Idx).BkColor.Copy(BCol);
  END;
 END {SetPalette};

 PRIVATE PROCEDURE DrawEdit(Id: STRING[]; Left, Top: NUMERIC[0]; Value: NUMERIC[0]);
 BEGIN
  L_GUI.add_Edit(dlg, Id, Left, Top,
                 45, 30, EMPTYOF(FLOAT),
                 CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
  dlg.Controls.Item(Id).Value  :=L_Math.DecToHex(Value);
  dlg.Controls.Item(Id).OnSuccessfulChange:=PROCREF(Edit_OnSuccessfulChange);
  dlg.Controls.Item(Id).Visible:=1;
 END {DrawEdit};

 PRIVATE PROCEDURE Check_EMultHValue(Val: NUMERIC[3]);
 BEGIN
  IF (Val < 1) | (Val > MaxFactorMultH()) THEN
   L_General.Error("⨬ 樥 㢥祭 饭 梥");
  END;
 END {Check_EMultHValue};

 PRIVATE PROCEDURE Check_EMultLValue(Val: NUMERIC[3]);
 BEGIN
  IF (Val < 1) | (Val > MaxFactorMultL()) THEN
   L_General.Error("⨬ 樥 㢥祭 饭 梥");
  END;
 END {Check_EMultLValue};

 PRIVATE PROCEDURE Check_EDivHValue(Val: NUMERIC[3]);
 BEGIN
  IF (Val < 1) | (Val > MaxFactorDivH()) THEN
   L_General.Error("⨬ 樥 㬥襭 饭 梥");
  END;
 END {Check_EDivHValue};

 PRIVATE PROCEDURE Check_EDivLValue(Val: NUMERIC[3]);
 BEGIN
  IF (Val < 1) | (Val > MaxFactorDivL()) THEN
   L_General.Error("⨬ 樥 㬥襭 饭 梥");
  END;
 END {Check_EDivLValue};

 PRIVATE PROCEDURE EMultChromaH_OnSuccessfulChange(SLF: EDIT; PrvValue: NUMERIC[3]);
  VAR
   NewVal: NUMERIC[3];
 BEGIN
  NewVal:=SLF.Value;
  Check_EMultHValue(NewVal);
 END {EMultChromaH_OnSuccessfulChange};

 PRIVATE PROCEDURE EMultChromaL_OnSuccessfulChange(SLF: EDIT; PrvValue: NUMERIC[3]);
  VAR
   NewVal: NUMERIC[3];
 BEGIN
  NewVal:=SLF.Value;
  Check_EMultLValue(NewVal);
 END {EMultChromaL_OnSuccessfulChange};

 PRIVATE PROCEDURE EDivChromaH_OnSuccessfulChange(SLF: EDIT; PrvValue: NUMERIC[3]);
 BEGIN
  Check_EDivHValue(SLF.Value);
 END {EDivChromaH_OnSuccessfulChange};

 PRIVATE PROCEDURE EDivChromaL_OnSuccessfulChange(SLF: EDIT; PrvValue: NUMERIC[3]);
 BEGIN
  Check_EDivLValue(SLF.Value);
 END {EDivChromaL_OnSuccessfulChange};

 PRIVATE PROCEDURE GetMultChromaH(): NUMERIC[3];
  VAR
   Result: NUMERIC[3];
 BEGIN
  Result:=dlg.Controls.Item(Id_EMultChromaH).Value;
  RETURN Result;
 END {GetMultChromaH};

 PRIVATE PROCEDURE GetMultChromaL(): NUMERIC[3];
  VAR
   Result: NUMERIC[3];
 BEGIN
  Result:=dlg.Controls.Item(Id_EMultChromaL).Value;
  RETURN Result;
 END {GetMultChromaL};

 PRIVATE PROCEDURE GetDivChromaH(): NUMERIC[3];
 BEGIN
  RETURN dlg.Controls.Item(Id_EDivChromaH).Value;
 END {GetDivChromaH};

 PRIVATE PROCEDURE GetDivChromaL(): NUMERIC[3];
 BEGIN
  RETURN dlg.Controls.Item(Id_EDivChromaL).Value;
 END {GetDivChromaL};

 PRIVATE PROCEDURE OnClick_MultChromaH(SLF: PUSH_BUTTON);
  VAR
   RGB: RGBCOLOR;
   c  : OBJECT;
   MultChromaH: NUMERIC[3];
 BEGIN
  MultChromaH:=GetMultChromaH();
  Check_EMultHValue(MultChromaH);

  RGB:=RGBCOLOR.Create();
  RGB.Copy(dlg.Controls.Item(Id_SampleHatching).Style.Color);
  RGB.Red  :=Math.Trunc(RGB.Red*MultChromaH);
  RGB.Green:=Math.Trunc(RGB.Green*MultChromaH);
  RGB.Blue :=Math.Trunc(RGB.Blue*MultChromaH);

  dlg.Controls.Item("RH").Value:=L_Math.DecToHex(RGB.Red);
  dlg.Controls.Item("GH").Value:=L_Math.DecToHex(RGB.Green);
  dlg.Controls.Item("BH").Value:=L_Math.DecToHex(RGB.Blue);

  Edit_Hatching_OnSuccessfulChange(RGB, GetSamplePalettesId("H", dlg.Controls.Item(Id_ComboBox).Value));
  FOR_EACH c IN dlg.Controls DO
   c.Redraw();
  END;
 END {OnClick_MultChromaH};

 PRIVATE PROCEDURE OnClick_MultChromaL(SLF: PUSH_BUTTON);
  VAR
   RGB: RGBCOLOR;
   c  : OBJECT;
   MultChromaL: NUMERIC[3];
 BEGIN
  MultChromaL:=GetMultChromaL();
  Check_EMultLValue(MultChromaL);

  RGB:=RGBCOLOR.Create();
  RGB.Copy(dlg.Controls.Item(Id_SampleLines).Style.Color);
  RGB.Red  :=Math.Trunc(RGB.Red*MultChromaL);
  RGB.Green:=Math.Trunc(RGB.Green*MultChromaL);
  RGB.Blue :=Math.Trunc(RGB.Blue*MultChromaL);

  dlg.Controls.Item("RL").Value:=L_Math.DecToHex(RGB.Red);
  dlg.Controls.Item("GL").Value:=L_Math.DecToHex(RGB.Green);
  dlg.Controls.Item("BL").Value:=L_Math.DecToHex(RGB.Blue);

  Edit_Lines_OnSuccessfulChange(RGB, GetSamplePalettesId("L", dlg.Controls.Item(Id_ComboBox).Value));
  FOR_EACH c IN dlg.Controls DO
   c.Redraw();
  END;
 END {OnClick_MultChromaL};

 PRIVATE PROCEDURE OnClick_DivChromaH(SLF: PUSH_BUTTON);
  VAR
   RGB: RGBCOLOR;
   c  : OBJECT;
   DivChromaH: NUMERIC[3];
 BEGIN
  DivChromaH:=GetDivChromaH();
  Check_EDivHValue(DivChromaH);

  RGB:=RGBCOLOR.Create();
  RGB.Copy(dlg.Controls.Item(Id_SampleHatching).Style.Color);
  RGB.Red  :=Math.Trunc(RGB.Red/DivChromaH);
  RGB.Green:=Math.Trunc(RGB.Green/DivChromaH);
  RGB.Blue :=Math.Trunc(RGB.Blue/DivChromaH);

  dlg.Controls.Item("RH").Value:=L_Math.DecToHex(RGB.Red);
  dlg.Controls.Item("GH").Value:=L_Math.DecToHex(RGB.Green);
  dlg.Controls.Item("BH").Value:=L_Math.DecToHex(RGB.Blue);

  Edit_Hatching_OnSuccessfulChange(RGB, GetSamplePalettesId("H", dlg.Controls.Item(Id_ComboBox).Value));
  FOR_EACH c IN dlg.Controls DO
   c.Redraw();
  END;
 END {OnClick_DivChromaH};

 PRIVATE PROCEDURE OnClick_DivChromaL(SLF: PUSH_BUTTON);
  VAR
   RGB: RGBCOLOR;
   c  : OBJECT;
   DivChromaL: NUMERIC[3];
 BEGIN
  DivChromaL:=GetDivChromaL();
  Check_EDivLValue(DivChromaL);

  RGB:=RGBCOLOR.Create();
  RGB.Copy(dlg.Controls.Item(Id_SampleLines).Style.Color);
  RGB.Red  :=Math.Trunc(RGB.Red/DivChromaL);
  RGB.Green:=Math.Trunc(RGB.Green/DivChromaL);
  RGB.Blue :=Math.Trunc(RGB.Blue/DivChromaL);

  dlg.Controls.Item("RL").Value:=L_Math.DecToHex(RGB.Red);
  dlg.Controls.Item("GL").Value:=L_Math.DecToHex(RGB.Green);
  dlg.Controls.Item("BL").Value:=L_Math.DecToHex(RGB.Blue);

  Edit_Lines_OnSuccessfulChange(RGB, GetSamplePalettesId("L", dlg.Controls.Item(Id_ComboBox).Value));
  FOR_EACH c IN dlg.Controls DO
   c.Redraw();
  END;
 END {OnClick_DivChromaL};

 PRIVATE PROCEDURE CreateDialog();
  VAR
   FCol,
   BCol,
   LCol,
   HCol: RGBCOLOR;
   C: tColorsNumber;
   IdST, IdT, IdL, IdH: STRING[];
 BEGIN
  PROMPT("⮢ 㠫 ꥪ⮢");
  dlg                     :=L_GUI.extCreateDialog(0);
  dlg.CaptionText         :="᪨";
  dlg.ShowMouseCursor     :=1;
  dlg.WindowSizeStatus    :=DIALOG.WindowSizeStatus_Restored;
  dlg.StandardClientWidth :=1085;
  dlg.StandardClientHeight:=740;
  dlg.ClientRect.Right    :=dlg.ClientRect.Left + dlg.StandardClientWidth;
  dlg.ClientRect.Bottom   :=dlg.ClientRect.Top  + dlg.StandardClientHeight;

(*
  SetPalette();
*)

  L_GUI.add_StaticText(dlg, Id_Background, "", 0, 0, dlg.ClientRect.Right, dlg.ClientRect.Bottom, EMPTYOF(NUMERIC[0]),
                       CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
  dlg.Controls.Item(Id_Background).Style.BkColor.Copy(APP.Get().PaletteKit.TextPalette.Item(FORM_FIELD.Color_Text).BkColor);
  dlg.Controls.Item(Id_Background).Style.BkTransparent:=0;
  dlg.Controls.Item(Id_Background).Visible:=1;

  L_GUI.add_StaticText(dlg, Id_BottomLine, " ", 0, 705, dlg.ClientRect.Right, dlg.ClientRect.Bottom-35, EMPTYOF(NUMERIC[0]),
                       CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
(*
  dlg.Controls.Item(Id_BottomLine).Style.BkColor.Copy(APP.Get().PaletteKit.TextPalette.Item(FORM_FIELD.Color_Pane).BkColor);
*)
  dlg.Controls.Item(Id_BottomLine).Style.BkTransparent:=0;
  dlg.Controls.Item(Id_BottomLine).Visible:=1;

  L_GUI.add_Edit(dlg, Id_ComboBox, 10, 20, 350, 30, EMPTYOF(FLOAT),
                 CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
  dlg.Controls.Item(Id_ComboBox).Value  :=FORM_FIELD.Color_Text;
  dlg.Controls.Item(Id_ComboBox).Format :=TextPool;
  dlg.Controls.Item(Id_ComboBox).OnSuccessfulChange:=PROCREF(ComboBox_OnSuccessfulChange);
  dlg.Controls.Item(Id_ComboBox).Visible:=1;

  SetColors(CurNumPalette, FORM_FIELD.Color_Text, FCol, BCol, LCol, HCol);
  L_GUI.add_StaticText(dlg, "BackGroundLabel", "BackGround", 370+50*0, 5,
                       150, 15, 15,
                       CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
  dlg.Controls.Item("BackGroundLabel").Visible:=1;

  DrawEdit("RB", 370 + 50*0, 20, BCol.Red);
  DrawEdit("GB", 370 + 50*1, 20, BCol.Green);
  DrawEdit("BB", 370 + 50*2, 20, BCol.Blue);

  L_GUI.add_StaticText(dlg, "TextLabel", "Text", 370+50*3, 5,
                       150, 15, 15,
                       CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
  dlg.Controls.Item("TextLabel").Visible:=1;

  DrawEdit("RF", 370 + 50*3, 20, FCol.Red);
  DrawEdit("GF", 370 + 50*4, 20, FCol.Green);
  DrawEdit("BF", 370 + 50*5, 20, FCol.Blue);

  L_GUI.add_StaticText(dlg, "LinesLabel", "Lines", 370+50*6, 5,
                       150, 15, 15,
                       CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
  dlg.Controls.Item("LinesLabel").Visible:=1;

  DrawEdit("RL", 370 + 50*6, 20, LCol.Red);
  DrawEdit("GL", 370 + 50*7, 20, LCol.Green);
  DrawEdit("BL", 370 + 50*8, 20, LCol.Blue);

  L_GUI.add_StaticText(dlg, "HatchingLabel", "Hatching", 370+50*9, 5,
                       150, 15, 15,
                       CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
  dlg.Controls.Item("HatchingLabel").Visible:=1;

  DrawEdit("RH", 370 + 50*9,  20, HCol.Red);
  DrawEdit("GH", 370 + 50*10, 20, HCol.Green);
  DrawEdit("BH", 370 + 50*11, 20, HCol.Blue);

  L_GUI.add_Button(dlg, Id_Ok, "SAVE ALL", "", 975, 20, 100, 30, 15, L_GUI.fn_Default, PROCREF(OnClick_OK));
  dlg.Controls.Item(Id_Ok).Visible:=1;

  L_GUI.add_StaticText(dlg, Id_SampleText, "ࠧ ᪨ TextPalette", 10, 60,
                       330, 30, 20,
                       CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
  dlg.Controls.Item(Id_SampleText).Style.Color.Copy  (FCol);
  dlg.Controls.Item(Id_SampleText).Style.BkColor.Copy(BCol);
  dlg.Controls.Item(Id_SampleText).Style.BkTransparent:=0;
  dlg.Controls.Item(Id_SampleText).Visible:=1;

  L_GUI.add_StaticText(dlg, Id_SampleLines, "ࠧ ᪨ LinesPalette", 350, 60,
                       330, 30, 20,
                       CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
  dlg.Controls.Item(Id_SampleLines).Style.Color.Copy  (LCol);
  dlg.Controls.Item(Id_SampleLines).Style.BkColor.Copy(BCol);
  dlg.Controls.Item(Id_SampleLines).Style.BkTransparent:=0;
  dlg.Controls.Item(Id_SampleLines).Visible:=1;

  L_GUI.add_StaticText(dlg, Id_SampleHatching, "ࠧ ᪨ HatchingPalette", 690, 60,
                       330, 30, 20,
                       CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
  dlg.Controls.Item(Id_SampleHatching).Style.Color.Copy  (HCol);
  dlg.Controls.Item(Id_SampleHatching).Style.BkColor.Copy(BCol);
  dlg.Controls.Item(Id_SampleHatching).Style.BkTransparent:=0;
  dlg.Controls.Item(Id_SampleHatching).Visible:=1;

  L_GUI.add_StaticText(dlg, Id_STMultChromaH, "",
                       10, 100, 300, 30, 20,
                       CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
  dlg.Controls.Item(Id_STMultChromaH).Visible:=1;
  L_GUI.add_Edit(dlg, Id_EMultChromaH, 320, 100, 45, 30, EMPTYOF(FLOAT),
                 CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
  dlg.Controls.Item(Id_EMultChromaH).Value  :=1.000;
  dlg.Controls.Item(Id_EMultChromaH).Format :="3.";
  dlg.Controls.Item(Id_EMultChromaH).OnSuccessfulChange:=PROCREF(EMultChromaH_OnSuccessfulChange);
  dlg.Controls.Item(Id_EMultChromaH).Visible:=1;
  L_GUI.add_Button(dlg, Id_BtnMultChromaH, ". . 梥 Hatching", "", 375, 100, 300, 30, 20, L_GUI.fn_Default, PROCREF(OnClick_MultChromaH));
  dlg.Controls.Item(Id_BtnMultChromaH).Visible:=1;

  L_GUI.add_StaticText(dlg, Id_STDivChromaH, "",
                       10, 140, 300, 30, 20,
                       CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
  dlg.Controls.Item(Id_STDivChromaH).Visible:=1;
  L_GUI.add_Edit(dlg, Id_EDivChromaH, 320, 140, 45, 30, EMPTYOF(FLOAT),
                 CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
  dlg.Controls.Item(Id_EDivChromaH).Value  :=1.000;
  dlg.Controls.Item(Id_EDivChromaH).Format :="3.";
  dlg.Controls.Item(Id_EDivChromaH).OnSuccessfulChange:=PROCREF(EDivChromaH_OnSuccessfulChange);
  dlg.Controls.Item(Id_EDivChromaH).Visible:=1;
  L_GUI.add_Button(dlg, Id_BtnDivChromaH, ". . 梥 Hatching", "", 375, 140, 300, 30, 20, L_GUI.fn_Default, PROCREF(OnClick_DivChromaH));
  dlg.Controls.Item(Id_BtnDivChromaH).Visible:=1;
  SetTextMultDivChromaH();

  L_GUI.add_StaticText(dlg, Id_STMultChromaL, "",
                       10, 180, 300, 30, 20,
                       CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
  dlg.Controls.Item(Id_STMultChromaL).Visible:=1;
  L_GUI.add_Edit(dlg, Id_EMultChromaL, 320, 180, 45, 30, EMPTYOF(FLOAT),
                 CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
  dlg.Controls.Item(Id_EMultChromaL).Value  :=1.000;
  dlg.Controls.Item(Id_EMultChromaL).Format :="3.";
  dlg.Controls.Item(Id_EMultChromaL).OnSuccessfulChange:=PROCREF(EMultChromaL_OnSuccessfulChange);
  dlg.Controls.Item(Id_EMultChromaL).Visible:=1;
  L_GUI.add_Button(dlg, Id_BtnMultChromaL, ". . 梥 Lines", "", 375, 180, 300, 30, 20, L_GUI.fn_Default, PROCREF(OnClick_MultChromaL));
  dlg.Controls.Item(Id_BtnMultChromaL).Visible:=1;

  L_GUI.add_StaticText(dlg, Id_STDivChromaL, "",
                       10, 220, 300, 30, 20,
                       CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
  dlg.Controls.Item(Id_STDivChromaL).Visible:=1;
  L_GUI.add_Edit(dlg, Id_EDivChromaL, 320, 220, 45, 30, EMPTYOF(FLOAT),
                 CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
  dlg.Controls.Item(Id_EDivChromaL).Value  :=1.000;
  dlg.Controls.Item(Id_EDivChromaL).Format :="3.";
  dlg.Controls.Item(Id_EDivChromaL).OnSuccessfulChange:=PROCREF(EDivChromaL_OnSuccessfulChange);
  dlg.Controls.Item(Id_EDivChromaL).Visible:=1;
  L_GUI.add_Button(dlg, Id_BtnDivChromaL, ". . 梥 Lines", "", 375, 220, 300, 30, 20, L_GUI.fn_Default, PROCREF(OnClick_DivChromaL));
  dlg.Controls.Item(Id_BtnDivChromaL).Visible:=1;
  SetTextMultDivChromaL();

(*
  APP.Get().PaletteKit.Reset(0);
*)
  FOR_EACH C DO
   IdST:="ST_" + Id_SamplePalettes + "_" + L_Str.IntStr(C);
   IdT:="T_" + Id_SamplePalettes + "_" + L_Str.IntStr(C);
   IdL:="L_" + Id_SamplePalettes + "_" + L_Str.IntStr(C);
   IdH:="H_" + Id_SamplePalettes + "_" + L_Str.IntStr(C);
   L_GUI.add_StaticText(dlg, IdST, L_Str.PoolItem(TextPool, C), 10,  255 + C*25, 290, 20, 15, CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
   L_GUI.add_StaticText(dlg, IdT, "T (" + RGB2Text(APP.Get().PaletteKit.TextPalette.Item(C).Color) + ")", 310,  255 + C*25, 200, 20, 20, CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
   L_GUI.add_StaticText(dlg, IdL, "L (" + RGB2Text(APP.Get().PaletteKit.LinesPalette.Item(C).Color) + ")", 520,  255 + C*25, 200, 20, 20, CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
   L_GUI.add_StaticText(dlg, IdH, "H (" + RGB2Text(APP.Get().PaletteKit.HatchingPalette.Item(C).Color) + ")", 730, 255 + C*25, 200, 20, 20, CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
   dlg.Controls.Item(IdT).Style.BkColor.Copy(APP.Get().PaletteKit.TextPalette.Item(C).BkColor);
   dlg.Controls.Item(IdT).Style.Color.Copy(APP.Get().PaletteKit.TextPalette.Item(C).Color);
   dlg.Controls.Item(IdL).Style.BkColor.Copy(APP.Get().PaletteKit.LinesPalette.Item(C).BkColor);
   dlg.Controls.Item(IdL).Style.Color.Copy(APP.Get().PaletteKit.LinesPalette.Item(C).Color);
   dlg.Controls.Item(IdH).Style.BkColor.Copy(APP.Get().PaletteKit.HatchingPalette.Item(C).BkColor);
   dlg.Controls.Item(IdH).Style.Color.Copy(APP.Get().PaletteKit.HatchingPalette.Item(C).Color);
   dlg.Controls.Item(IdT).Style.BkTransparent:=0;
   dlg.Controls.Item(IdL).Style.BkTransparent:=0;
   dlg.Controls.Item(IdH).Style.BkTransparent:=0;
   dlg.Controls.Item(IdST).Visible:=1;
   dlg.Controls.Item(IdT).Visible:=1;
   dlg.Controls.Item(IdL).Visible:=IsLinesVis(C);
   dlg.Controls.Item(IdH).Visible:=IsHatchingVis(C);
  END;
 END {CreateDialog};

 PRIVATE PROCEDURE IsLinesVis(C: tColorsNumber): SCAL[2];
 BEGIN
  RETURN ((C >= FORM_FIELD.Color_Text) & (C <= FORM_FIELD.Color_Field3)) |
         (C = FORM_FIELD.Color_MarkedRecord) |
         (C = FORM_FIELD.Color_EditedField)  |
         (C = FORM_FIELD.Color_EditedFieldWithLookup);
 END {IsLinesVis};

 PRIVATE PROCEDURE IsHatchingVis(C: tColorsNumber): SCAL[2];
 BEGIN
  RETURN ((C >= FORM_FIELD.Color_Text) & (C <= FORM_FIELD.Color_Field4)) |
         (C = FORM_FIELD.Color_MarkedRecord) |
         (C = FORM_FIELD.Color_CurFieldInActiveHighlightBar) |
         (C = FORM_FIELD.Color_ActiveHighlightBar) |
         (C = FORM_FIELD.Color_LookupHighlightBar) |
         (C = FORM_FIELD.Color_OtherHighlightBar);
 END {IsHatchingVis};

(*
 Color_Text = 0;
 Color_Field1 = 1;
 Color_Field2 = 2;
 Color_Field3 = 3;
 Color_Field4 = 4;
 Color_MarkedRecord = 5;
 Color_CurFieldInActiveHighlightBar = 6;
 Color_FoundChars = 7;
 Color_ActiveHighlightBar = 8;
 Color_Title = 9;
 Color_EditedField = 10;
 Color_SelectionOfEditedField = 11;
 Color_EditedFieldWithLookup = 12;
 Color_SelectionOfEditedFieldWithLookup = 13;
 Color_LookupHighlightBar = 14;
 Color_OtherHighlightBar = 15;
 Color_Pane = 16,
 Color_MainWindow = 17,
*)

 PRIVATE PROCEDURE PlayDialog();
 BEGIN
  dlg.Visible:=1;
  dlg.Redraw();
  WHILE dlg.Visible DO
   PROMPT("");
   TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
    dlg.Wait(0.5);
   EXCEPT
   ON Exc: Exc_Root DO
    L_GUI.Error(dlg, Exc.MsgOriginalText);
   END;
  END; (* WHILE dlg.Visible *)
 END {PlayDialog};

BEGIN

 IF APP.Get().PaletteKit.TextPalette.Count = 0 THEN
  L_General.Error(" ࠡ⠥ ⮫쪮  ᪥ V32  箬 /gui");
 END;

 CreateDialog();
 PlayDialog();

END.