(*
%Copyright   (c) Polak IT
%Author      24.11.2003 18:35:27 POLAK\Bor
%Purpose         
%Type        report
%Specific    LOC
%Modified    17.06.2014 22:27:35 POLAK\Gina
%Environment
*)

 MODULE Drv2PFRF [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_OwnData, L_DatTim, L_Way, L_AFM, E_Way,
        L_Env, L_EC, E_Utils, L_Staff, L_SFee, L_Str, Math, Memo, L_Packet, L_Sheet;

 CONST
  NormalD = 01\01\2013;

 VAR
  _From, _UpTo: DATE;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
_From, L, "D.N.y"
_UpTo, L, "D.N.y"
Staff.TSN, L, ""
Man.Name, L, ""
@
################################################################## ########## #####
=#####=============================================================================
|            ⥢ ⠬  ਮ c ##########  ##########          |
|---------------------------------------------------------------------------------|
|⥫ ##### ##################################################################|
|---------------------------------------------------------------------------------|
|      |/ |室    |           | ॢ   |६|    |
|----------|-------|---------|------------------|----------------|-----|----------|
}
*)

(*
$P{ Line:
?, L, "D.N.y"
?, L, ""
?, L, ""
Route.Route, L, ""
Route.Name, L, ""
TKind.TKind, L, ""
TKind.Name, L, ""
?, R, "1."
TKind.Rgn, L, L_Way.tkrgn_Pool
@
|##########|#######|#########|#### #############|## #############|#####|##########|
}
*)

(*
$P{ Bot:
@
=(c) Polak=========================================================================
}
*)

(*
$P{ Top_A:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
_From, L, "D.N.y"
_UpTo, L, "D.N.y"
@
################################################################## ########## #####
=#####=============================================================================
|            ⥢ ⠬  ਮ c ##########  ##########          |
|---------------------------------------------------------------------------------|
|     |                         |           |           |           |       |.|
|. |                      |ਮ     |     |      ६|業|ᮡ.|
|-----|-------------------------|-----------|-----------|-----------|-------|-----|
}
*)

(*
$P{ Line_A:
?, L, ""
?, L, ""
?, C, ""
?, C, ""
?, L, L_Way.tkrgn_Pool
?, R, "3."
?, R, "2."
PnsAttr.Name, L, ""
?, L, "!| "
@
|#####|#########################|#####-#####|###########|###########|#######|### #|
}
*)

(*
$P{ Bot_A:
@
=(c) Polak=========================================================================
}
*)

(*
$P{ Top_A_2013:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
_From, L, "D.N.y"
_UpTo, L, "D.N.y"
@
################################################################## ########## #####
=#####=============================================================================
|        ⥢ ⠬  ਮ c ##########  ##########        |
|---------------------------------------------------------------------------------|
|     |                                     |      த    |     祥    |     |
|. |                                  |---------------|---------------|.|
|     |                                     |   ६|     %|   ६|     %|ᮡ.|
|-----|-------------------------------------|--------|------|--------|------|-----|
}
*)

(*
$P{ Line_A_2013:
Tmp01.TSN, L, ""
Man.Name, L, ""
Tmp01.Tim[L_Way.tkrgn_City], R, "3."
GetPrcTmp01(Tmp01.Tim[L_Way.tkrgn_City]), R, "2."
Tmp01.Tim[L_Way.tkrgn_Other], R, "3."
GetPrcTmp01(Tmp01.Tim[L_Way.tkrgn_Other]), R, "2."
PnsAttr.Name, L, ""
CheckPnsAttr(EMPTYOF(TKind.Rgn)), L, "!| "
@
|#####|#####################################|########|######|########|######|### #|
}
*)

 PRIVATE PROCEDURE GetPrcTmp01(trgTim: NUMERIC[3]): NUMERIC[3];
 BEGIN
  IF Tmp01.Tim[L_Way.tkrgn_City]+Tmp01.Tim[L_Way.tkrgn_Other] = 0 THEN
   RETURN 0;
  ELSE
   RETURN trgTim/(Tmp01.Tim[L_Way.tkrgn_City]+Tmp01.Tim[L_Way.tkrgn_Other])*100;
  END;
 END {GetPrcTmp01};

 PRIVATE PROCEDURE Create__D2PF();
 BEGIN
  CreateFILE(_D2PF, "", "", "");
  CreateFIELD(_D2PF, RWayS, LIKE(RWayS.RWayS), "", "", "", "", "");
  CreateFIELD(_D2PF, Date,  LIKE(RWayS.Date), "", "", "", "", "");
  CreateFIELD(_D2PF, Route, LIKE(Route.Route), "", "", "", "", "");
  CreateFIELD(_D2PF, Exit,  LIKE(StExit.Exit), "", "", "", "", "");
  CreateFIELD(_D2PF, Tim,   NUMERIC[3], "", "", "", "", "");

  CreateINDEX(_D2PF, RWayS, UNIQUE, "", "", Date, RWayS, Exit, Route);
  CreateINDEXandLINK(_D2PF, Route, PLURAL, Route, Route, USER, "", "", Route);
  SetVersionOfFILE(_D2PF, 000);
  L_AFM.AF_CreateTemp("_D2PF", "_D2PF");
 END {Create__D2PF};

 PRIVATE PROCEDURE NeedMan(): SCAL[2];
 BEGIN
  CONFORM(Staff, Man);
  IF    _From >= 01\01\2013 THEN
   RETURN L_SFee.ManIsInsuredInPF(Man.Man, L_DatTim.Per(RWayS.Date));
  ELSIF _From >= 01\01\2010 THEN
   RETURN L_SFee.ManCitizenship(Man.Man, L_DatTim.Per(RWayS.Date));
  ELSE
   RETURN 1;
  END;
 END {NeedMan};

 PRIVATE PROCEDURE E_Drv2pfr_NeedRWayS(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(RWayS.Date, PROCREF(E_Utils.Drv2pfr_NeedRWayS), 1);
 END {E_Drv2pfr_NeedRWayS};

 PRIVATE PROCEDURE PzvTotalTime(): NUMERIC[3];
 BEGIN
  RETURN E_Way.GetPzvTotalTime(L_Way.rwswho_Driver);
 END {PzvTotalTime};

 PRIVATE PROCEDURE CheckPnsAttr(curRgn: LIKE(TKind.Rgn)): SCAL[2];
 BEGIN
  IF _From >= NormalD THEN
   RETURN (GetPrcTmp01(Tmp01.Tim[L_Way.tkrgn_City]) >= 80) = (PnsAttr.PnsAttr#L_Packet.OrdinaryPnsAttr);
  ELSE
   RETURN (curRgn=L_Way.tkrgn_City) = (PnsAttr.PnsAttr#L_Packet.OrdinaryPnsAttr);
  END;
 END {CheckPnsAttr};

 PRIVATE PROCEDURE PrintPer(curDate, curDateE: DATE; VAR BegS, EndS: STRING[]);
 BEGIN
  IF (Math.Max(curDate, _From) = _From) & (Math.Min(curDateE, _UpTo) = _UpTo) THEN
   SETEMPTY(BegS, EndS);
  ELSE
   BegS:=FLDTOSTR(Math.Max(curDate, _From), "D.N");
   EndS:=FLDTOSTR(Math.Min(curDateE, _UpTo), "D.N");
  END;
 END {PrintPer};

 PRIVATE PROCEDURE PrintLine(Tim: NUMERIC[3][]; TotalTim: NUMERIC[3]; curDate, curDateE: DATE);
  VAR
   _Rgn : LIKE(TKind.Rgn);
   First: SCAL[2];
   curPnsAttr: LIKE(PnsAttr.PnsAttr);
   curPrc    : NUMERIC[3];
   BegS, EndS: STRING[];
 BEGIN
  First:=1;
  FOR_EACH _Rgn DO
   IF Tim[_Rgn] # 0 THEN
    curPrc:=Tim[_Rgn]/TotalTim*100;
    IF First THEN
     First:=0;
     CONFORM(Staff, Man);
     TRY [RESTORE_CURSORS(RC_ON)]
      L_Staff.PosToStaffLog(Staff.TSN, curDate, 1);
      CONFORM(StaffLog, Officer);
      curPnsAttr:=Officer.PnsAttr;
     EXCEPT
     END;
     PrintPer(curDate, curDateE, BegS, EndS);
     SEARCH(PnsAttr, PnsAttr, , curPnsAttr);
     MAKEPART(R, Line_A, Staff.TSN, L_Str.ShortName(Man.Name),
                         BegS, EndS,
                         _Rgn, Tim[_Rgn], curPrc, CheckPnsAttr(_Rgn));
    ELSE
     MAKEPART(R, Line_A, , , , ,
                         _Rgn, Tim[_Rgn], curPrc, CheckPnsAttr(_Rgn));
    END;
   END;
  END; (* FOR_EACH ... *)
 END {PrintLine};

 PRIVATE PROCEDURE AddTmp01(D: DATE; Tim: NUMERIC[3][MAXOF(TKind.Rgn)+1]);
 BEGIN
  ADD(Tmp01, Tmp01, , Staff.TSN, L_SFee.GetPnsAttrOnDate(D),
             Tmp01.Tim[L_Way.tkrgn_City], Tim[L_Way.tkrgn_City],
             Tmp01.Tim[L_Way.tkrgn_Other], Tim[L_Way.tkrgn_Other]);
 END {AddTmp01};

 PRIVATE PROCEDURE RgnCond(): SCAL[2];
 BEGIN
  IF _From >= NormalD THEN
   RETURN TKind.Rgn = L_Way.tkrgn_City;
  ELSE
   RETURN TKind.Rgn < L_Way.tkrgn_Order;
  END;
 END {RgnCond};

 PRIVATE PROCEDURE IsLine(): SCAL[2];
 BEGIN
  RETURN (WJMode.WJType=L_Way.WJType_Work) & (WJMode.RunSel>0) & (Route.IncSel > 0);
 END {IsLine};

 PRIVATE PROCEDURE NeedRWayJ(SingleRep: SCAL[2]): SCAL[2];
 BEGIN
  IF SingleRep THEN
   L_Way.PosToWJMethod(WJMode.WJCode, L_Way.rwswho_Driver, L_Way.GetRouteJRegime(RWayS.Date, 1), RWayJ.Quality, RWayS.Date);
   RETURN WJMethod.TimeSel;
  ELSE
   RETURN RgnCond() &
          (IsLine() | L_Way.E_IsRepInLine(RWayS.Date) | (WJMode.WJCode="31"(*-2*)) | (WJMode.WJCode="32"(*-1*)));
  END;
 END {NeedRWayJ};

 PRIVATE PROCEDURE MakeOneStaff(SingleRep: SCAL[2]);
  VAR
   _ExitPriv,
   _ExitOther : LIKE(SEJobs.Exit);
   _RoutePriv,
   _RouteOther: LIKE(SEJobs.Route);
   _RgnPriv,
   _RgnOther: LIKE(TKind.Rgn);
   PzvTime,
   PrivilegedPfrTime,
   OtherTime: NUMERIC[3];
   Tim: NUMERIC[3][MAXOF(TKind.Rgn)+1];
   Dummy,
   TimDone,
   CurTime,
   TotalTim: NUMERIC[3];
   StffL_Date,
   StffL_DateE: DATE;
 BEGIN
  SETEMPTY(StffL_Date, StffL_DateE);
  SETZERO(Tim, TotalTim);
  SELECT(RWayS, TSN, , Staff.TSN);
  SRCINSEL(RWayS, GE, , _From);
  WHILE OCCURE(RWayS) & (RWayS.Date <= _UpTo) DO
   PROMPT(": ⠡. "+Staff.TSN+" "+L_DatTim.DateStr(RWayS.Date)+" "+RWayS.RWayS);
   IF SingleRep | (NeedMan() & E_Drv2pfr_NeedRWayS()) THEN
    L_Staff.PosToStaffLog(Staff.TSN, RWayS.Date, 1);
    CONFORM(StaffLog, Officer);
    IF !StffL_Date THEN
     StffL_Date:=StaffLog.Date;
     StffL_DateE:=StaffLog.DateE;
    ELSIF StaffLog.Date # StffL_Date THEN
     IF ~SingleRep THEN
      IF (_From < NormalD) & (TotalTim > 0) THEN
       PrintLine(Tim, TotalTim, StffL_Date, StffL_DateE);
      END;
     END;
     StffL_Date:=StaffLog.Date;
     StffL_DateE:=StaffLog.DateE;
     SETZERO(Tim, TotalTim);
    END;
    SETZERO(PrivilegedPfrTime, OtherTime);
    NARROWSEL(RWayS, Date);
    WHILE OCCURE(RWayS) DO
     CONFORM(RWayS, RWayJ);
     WHILE OCCURE(RWayJ) DO
      CONFORM(RWayJ,  Quality);
      CONFORM(RWayJ,  SEJobs);
      CONFORM(SEJobs, WJMode);
      CONFORM(SEJobs, Route);
      L_Way.StandOnRouteTKind(RWayS.Date);
      IF (Quality.Type # L_Way.QualType_Annul) & NeedRWayJ(SingleRep) THEN
       CurTime:=RWayJ.StopT - RWayJ.StartT;
       IF SingleRep THEN
        ADD(_D2PF, RWayS, , RWayS.Date, RWayS.RWayS, SEJobs.Exit, SEJobs.Route,
                            _D2PF.Tim, CurTime);
       END;
       IF TKind.Rgn = L_Way.tkrgn_City THEN
        _ExitPriv :=SEJobs.Exit;
        _RoutePriv:=SEJobs.Route;
        _RgnPriv  :=TKind.Rgn;
        INC(PrivilegedPfrTime, CurTime);
       ELSE
        _ExitOther :=SEJobs.Exit;
        _RouteOther:=SEJobs.Route;
        _RgnOther  :=TKind.Rgn;
        INC(OtherTime, CurTime);
       END;
       INC(Tim[TKind.Rgn], CurTime);
       INC(TotalTim,       CurTime);
      END;
      NEXT(RWayJ);
     END; (* WHILE OCCURE(RWayJ) ... *)
     NEXT(RWayS);
    END; (* WHILE OCCURE(RWayS) ... *)
    LAST(RWayS);

    IF (_From >= NormalD) & ~SingleRep THEN
     L_Sheet.GetBalInf(RWayS.Date, RWayS.Date, 0, TimDone, Dummy, Dummy, Dummy, Dummy);
     IF (PrivilegedPfrTime > 0) & (TimDone >= PrivilegedPfrTime) THEN
      PzvTime:=PzvTotalTime()/TimDone*PrivilegedPfrTime;
      INC(PrivilegedPfrTime, PzvTime);
      INC(Tim[_RgnPriv], PzvTime);
      INC(TotalTim,      PzvTime);
     END;
     OtherTime:=Math.Max(0, TimDone-PrivilegedPfrTime);
     INC(Tim[L_Way.tkrgn_Other], OtherTime);
     INC(TotalTim,               OtherTime);
     AddTmp01(RWayS.Date, Tim);
     SETZERO(Tim);
    ELSE
     IF PrivilegedPfrTime > 0 THEN
      PzvTime:=PzvTotalTime()/(PrivilegedPfrTime+OtherTime)*PrivilegedPfrTime;
      INC(Tim[_RgnPriv], PzvTime);
      INC(TotalTim,      PzvTime);
      IF SingleRep THEN
       ADD(_D2PF, RWayS, , RWayS.Date, RWayS.RWayS, _ExitPriv, _RoutePriv,
                           _D2PF.Tim, PzvTime);
      END;
     END;
     IF OtherTime > 0 THEN
      PzvTime:=PzvTotalTime()/(PrivilegedPfrTime+OtherTime)*OtherTime;
      INC(Tim[_RgnOther], PzvTime);
      INC(TotalTim,       PzvTime);
      IF SingleRep THEN
       ADD(_D2PF, RWayS, , RWayS.Date, RWayS.RWayS, _ExitOther, _RouteOther,
                           _D2PF.Tim, PzvTime);
      END;
     END;
    END;
    NEXTINEXTENDEDSEL(RWayS, Date);
   ELSE
    NEXT(RWayS);
   END; (* IF SingleRep... *)
  END; (* WHILE OCCURE(RWayS) ... *)
  IF ~SingleRep & (TotalTim > 0) THEN
   IF _From < NormalD THEN
    PrintLine(Tim, TotalTim, StffL_Date, StffL_DateE);
   END;
  END;
 END {MakeOneStaff};

 PUBLIC PROCEDURE Dr2PF();
  CONST
   RepName = "Dr2PF";
  VAR
   FirsRWayS: SCAL[2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Staff), " ⠭ ࠡ⭨");
  _From:=Memo.ud_fr();
  _UpTo:=Memo.ud_ut();
 
  Create__D2PF();
 
  CONFORM(Staff, Man);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName);

  MakeOneStaff(1);

  SELECT(_D2PF, RWayS);
  WHILE OCCURE(_D2PF) DO
   FirsRWayS:=1;
   CHANGESEL(_D2PF, RWayS, , _D2PF.Date, _D2PF.RWayS);
   WHILE OCCURE(_D2PF) DO
    CONFORM(_D2PF, Route);
    L_Way.StandOnRouteTKind(_D2PF.Date);
    IF FirsRWayS THEN
     MAKEPART(R, Line, _D2PF.Date, _D2PF.RWayS, _D2PF.Exit, _D2PF.Tim);
     FirsRWayS:=0;
    ELSE
     MAKEPART(R, Line, , , _D2PF.Exit, _D2PF.Tim);
    END;
    NEXT(_D2PF);
   END; (* WHILE OCCURE(_D2PF) ... *)
   LAST(_D2PF);
   CHANGESEL(_D2PF, RWayS);
   NEXT(_D2PF);
  END; (* WHILE OCCURE(_D2PF) ... *)
  L_AFM.AF_PurgeTemp("_D2PF");
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {Dr2PF};

 PRIVATE PROCEDURE Create_Tmp01();
 BEGIN
  CreateFILE(Tmp01, "", "", "");

  CreateFIELD(Tmp01, TSN,      LIKE(Staff.TSN),                "", "", "", " ", "");
  CreateFIELD(Tmp01, PnsAttr,  LIKE(PnsAttr.PnsAttr),          "", "", "", "ᨮ ᮡ", "");
  CreateFIELD(Tmp01, Tim,      NUMERIC[3][MAXOF(TKind.Rgn)+1], "", "", "", "६  ॣ", "");

  CreateINDEX(Tmp01, Tmp01, UNIQUE, "", "", TSN, PnsAttr);

  SetVersionOfFILE(Tmp01, 0);
  L_AFM.CreateTemp("Tmp01");
 END {Create_Tmp01};

 PUBLIC PROCEDURE DrAPF();
  CONST
   RepName = "DrAPF";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

  _From:=Memo.ud_fr();
  _UpTo:=Memo.ud_ut();
  IF _From >= NormalD THEN
   L_Way.WarnUnDoneRWayS(_From, _UpTo);
   Create_Tmp01();
  ELSE
   OPENREP(R, L_General.NameConnection(RepName), Create);
   MAKEPART(R, Top_A, RepName);
  END;

  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(": ⠡. " + Staff.TSN);
   IF (Staff.Contract # L_Staff.cnt_OutStaff) & L_Env.RealTSN(Staff.TSN) THEN
    MakeOneStaff(0);
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)

  IF _From >= NormalD THEN
   OPENREP(R, L_General.NameConnection(RepName), Create);
   MAKEPART(R, Top_A_2013, RepName);
   SELECT(Tmp01, Tmp01);
   WHILE OCCURE(Tmp01) DO
    PROMPT(" "+Tmp01.TSN);
    IF (GetPrcTmp01(Tmp01.Tim[L_Way.tkrgn_City]) >= 50) | (Tmp01.PnsAttr # L_Packet.OrdinaryPnsAttr) THEN
     SEARCH(Staff, TSN, , Tmp01.TSN);
     CONFORM(Staff, Man);
     SEARCH(PnsAttr, PnsAttr, , Tmp01.PnsAttr);
     MAKEPART(R, Line_A_2013);
    END;
    NEXT(Tmp01);
   END; (* WHILE OCCURE(Tmp01) ... *)
   L_AFM.AF_PurgeTemp("Tmp01");
   MAKEPART(R, Bot_A);
   CLOSEREP(R);
  ELSE
   MAKEPART(R, Bot_A);
   CLOSEREP(R);
  END;
  L_General.SurveyLastReport();
 END {DrAPF};

END.
