(*
%Copyright   (c) Polak IT
%Author      11.04.2005 14:57:21 POLAK\LDA
%Purpose     । ࠭ᯮ⭮    ॢ
%Type        report
%Specific    SYS
%Modified    04.09.2014 12:34:26 POLAK\LDA
%Environment
*)

 MODULE DSTTT [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_OTx, L_AFM, L_Car, L_DatTim, L_MathR, L_Packet, L_Basis,
        P_Firm, FIO, Str, E_Stock, L_Way, L_bp, L_Basis, L_StdFrm, L_Str;

 PRIVATE PROCEDURE MakeHeader(F: STRING[]; GatherByMath: SCAL[2]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ॢ");
  L_Basis.wb_WrInQM(F, " ॢ");
  L_Basis.wb_WrInQM(F, "ꥪ");
  L_Basis.wb_WrInQM(F, "ꥪ");
  IF GatherByMath THEN
   L_Basis.wb_WrInQM(F, " 樨");
   L_Basis.wb_WrInQM(F, " 樨");
  ELSE
   L_Basis.wb_WrInQM(F, "㯯ப");
   L_Basis.wb_WrInQM(F, "㯯ப");
  END;
  L_Basis.wb_WrInQM(F, "⥫ 筮 ⥫");
  L_Basis.wb_WrInQM(F, "⥫ 筮 ⥫");
  L_Basis.wb_WrInQM(F, "稭");
  L_Basis.wb_WrInQM(F, "㬬   䠪᪮ ࠡ");
  L_Basis.wb_WrInQM(F, "⢮  ९");
  L_Basis.wb_WrInQM(F, "㬬   ९");
  L_Basis.wb_WrInQM(F, "।");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F           : STRING[];
                            GatherByMath: SCAL[2];
                            _Column     : LIKE(Column.Column);
                            _TKind      : LIKE(TKind.TKind);
                            _Sum        : NUMERIC[2];
                            EPer        : DATE;
                            trgDone     : SCAL[2]);
 BEGIN
  L_Basis.wb_WrStr(F, _Column);
  IF ~!_TKind THEN
   SEARCH(TKind, TKind, , _TKind);
   L_Basis.wb_WrScl(F, TKind.TKind);
   L_Basis.wb_WrStr(F, TKind.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  IF trgDone THEN
   IF GatherByMath THEN
    L_Basis.wb_WrScl(F, Math.Math);
    L_Basis.wb_WrStr(F, Math.Name);
    IF L_MathR.PosToKAGSoft(Math.Math, EPer) THEN
     CONFORM(MathKAGL, Dest);
     L_Basis.wb_WrScl(F, Dest.Dest);
     L_Basis.wb_WrStr(F, Dest.Name);
    ELSE
     L_Basis.wb_WrStr(F, "---");
     L_Basis.wb_WrStr(F, "---");
    END;
    IF OCCURE(TmpMT) THEN
     CONFORM(TmpMT, MtyIdx);
     L_Basis.wb_WrScl(F, TmpMT.MtyIdx);
     L_Basis.wb_WrStr(F, MtyIdx.Name);
     L_Basis.wb_WrNum(F, TmpMT.Proof, 3);
    ELSE
     L_Basis.wb_WrStr(F, "---");
     L_Basis.wb_WrStr(F, "---");
     L_Basis.wb_WrNum(F, 0, 3);
    END;
   ELSE
    L_Basis.wb_WrScl(F, Car.BoxNbr);
    L_Basis.wb_WrStr(F, CarLog.StateNbr);
    L_Way.StandOnMarkG(CarLog.Mark, L_Way.mgt_TEP);
    L_Basis.wb_WrScl(F, MarkG.MarkG);
    L_Basis.wb_WrStr(F, MarkG.Name);
    L_Basis.wb_WrStr(F, "--");
    L_Basis.wb_WrStr(F, "------");
    L_Basis.wb_WrNum(F, 0, 3);
   END;
  ELSE
   L_General.CallUs(~trgDone);
   L_Basis.wb_WrStr(F, GetObjectFromID(TrTax.ID, GatherByMath));
   L_Basis.wb_WrStr(F, TrTax.StateNbr);
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrNum(F, 0, 3);
  END;
  L_Basis.wb_WrNum(F, _Sum, 2);

  IF OCCURE(TmpTk) THEN
   L_Basis.wb_WrNum(F, TmpTk.Days, 0);
   L_Basis.wb_WrNum(F, TmpTk.Sum, 2);
  ELSE
   L_Basis.wb_WrNum(F, 0, 0);
   L_Basis.wb_WrNum(F, 0, 2);
  END;
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", trgDone));
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE Create_TmpFiles();
 BEGIN
  CreateFILE(TrTax, "", "  ", "");

  CreateFIELD(TrTax, StateNbr, LIKE(CarLog.StateNbr), "", "", "", ".", "");
  CreateFIELD(TrTax, EngPower, NUMERIC[2],            "", "", "", " ", "");
  CreateFIELD(TrTax, VIN,      LIKE(VehPasp.VIN),     "", "", "", " (䨪樮 )", "");
  CreateFIELD(TrTax, ID,       L_OTx.tID,             "", "", "", "ID", "");
  CreateFIELD(TrTax, Sum,      NUMERIC[2],            "", "", "", "㬬", "");
  CreateFIELD(TrTax, Done,     SCAL[3],               "", "0", "", "    ।", "");

  CreateINDEX(TrTax, StateNbr, PLURAL, "", "", StateNbr, EngPower, VIN);

  SetVersionOfFILE(TrTax, 0);
  L_AFM.AF_CreateTemp("TrTax", "TrTax");

  CreateFILE(TmpMT, "", "।   䠪᪮ ࠡ", "");

  CreateFIELD(TmpMT, ID,     L_OTx.tID,           "", "", "", "ID", "");
  CreateFIELD(TmpMT, Column, LIKE(Column.Column), "", "", "", "", "");
  CreateFIELD(TmpMT, TKind,  LIKE(TKind.TKind),   "", "", "", " ॢ", "");
  CreateFIELD(TmpMT, MtyIdx, LIKE(MtyIdx.MtyIdx), "", "", "", " ⥫", "");
  CreateFIELD(TmpMT, Proof,  NUMERIC[3],          "", "", "", "稭", "");
  CreateFIELD(TmpMT, Sum,    NUMERIC[2],          "", "", "", "㬬   䠪᪮ ࠡ", "");

  CreateINDEXandLINK(TmpMT, TKind,  PLURAL, TKind, TKind, USER,"", "", TKind);
  CreateINDEXandLINK(TmpMT, MtyIdx, PLURAL, MtyIdx, MtyIdx, USER,"", "", MtyIdx);
  CreateINDEX(TmpMT, TMtyIdx, UNIQUE, "", "", ID, Column, TKind, MtyIdx);
  SetVersionOfFILE(TmpMT, 0);
  L_AFM.AF_CreateTemp("TmpMT", "TmpMT");

  CreateFILE(TmpTk, "", "।   ९", "");

  CreateFIELD(TmpTk, ID,     L_OTx.tID,           "", "", "", "ID", "");
  CreateFIELD(TmpTk, BoxNbr, LIKE(Car.BoxNbr),    "", "", "", "ࠦ", "");
  CreateFIELD(TmpTk, Column, LIKE(Column.Column), "", "", "", "", "");
  CreateFIELD(TmpTk, TKind,  LIKE(TKind.TKind),   "", "", "", " ॢ", "");
  CreateFIELD(TmpTk, Days,   NUMERIC[2],          "", "", "", "  ९", "");
  CreateFIELD(TmpTk, Sum,    NUMERIC[2],          "", "", "", "㬬   ९", "");

  CreateINDEX(TmpTk, ID, UNIQUE, "", "", ID, Column, TKind, BoxNbr);

  SetVersionOfFILE(TmpTk, 0);
  L_AFM.AF_CreateTemp("TmpTk", "TmpTk");
 END {Create_TmpFiles};

 PRIVATE PROCEDURE GetSingleBoxNbrTransportTax(): NUMERIC[2];
  VAR
   _Sum: NUMERIC[2];
 BEGIN
  SETZERO(_Sum);
  WHILE OCCURE(TmpCr) DO
   SELECT(TrTax, StateNbr, , TmpCr.StateNbr, TmpCr.EngPower, TmpCr.VIN);
   WHILE OCCURE(TrTax) DO
    IF !TrTax.ID | (TrTax.ID = TmpCr.ID) THEN
     INC(_Sum, TrTax.Sum);
     IF TrTax.Done < 2 THEN
      INC(TrTax.Done);
      REPLACE(TrTax);
     ELSE
      L_General.CallUs(0);
     END;
    END;
    NEXT(TrTax);
   END; (* WHILE OCCURE(TrTax) ... *)
   NEXT(TmpCr);
  END; (* WHILE OCCURE(TmpCr) ... *)
  RETURN _Sum;
 END {GetSingleBoxNbrTransportTax};

 PRIVATE PROCEDURE GetObjectFromID(_ID: L_OTx.tID; IsKeyAss: SCAL[2]): SCAL[1E5];
 BEGIN
  RETURN (_ID - IsKeyAss) / 10;
 END {GetObjectFromID};

 PRIVATE PROCEDURE intGather_TT_AnyRep(_Table: LIKE(ATERAttr.Table));
  VAR
   _Table2: LIKE(ATERAttr.Table);
 BEGIN
  _Table2:=00000;
  WHILE SELECT(PckATER, Table2, Packet.Packet, _Table2, _Table) DO
   DEFAULT(TrTax);
   WHILE OCCURE(PckATER) DO
    PROMPT("    ⭮ " + _Table2);
    IF    PckATER.ATERAttr = ""      THEN TrTax.VIN     :=PckATER.Value;
    ELSIF PckATER.ATERAttr = ""    THEN TrTax.StateNbr:=PckATER.Value;
    ELSIF PckATER.ATERAttr = ""      THEN TrTax.EngPower:=STRTOFLD(PckATER.Value, NUMERIC);
    ELSIF PckATER.ATERAttr = "㬈᫓" THEN TrTax.Sum     :=STRTOFLD(PckATER.Value, NUMERIC);
    ELSIF PckATER.ATERAttr = "ID"           THEN TrTax.ID      :=PckATER.Value;
    END;
    NEXT(PckATER);
   END;
   INSERT(TrTax);
   INC(_Table2);
  END;
 END {intGather_TT_AnyRep};

 PRIVATE PROCEDURE Gather_TT_Decl_Ver4();
 BEGIN
  intGather_TT_AnyRep(00011);
 END {Gather_TT_Decl_Ver4};

 PRIVATE PROCEDURE Gather_TT_AnyRep_Ver3();
 BEGIN
  intGather_TT_AnyRep(00013);
 END {Gather_TT_AnyRep_Ver3};

 PRIVATE PROCEDURE Gather_TT_Decl_Ver3();
 BEGIN
  Gather_TT_AnyRep_Ver3();
 END {Gather_TT_Decl_Ver3};

 PRIVATE PROCEDURE Gather_TT_Decl_Ver2();
  VAR
   _Table2: LIKE(ATERAttr.Table);
 BEGIN
  _Table2:=00000;
  WHILE SELECT(PckATER, Table, Packet.Packet, 00002, _Table2) DO
   DEFAULT(TrTax);
   WHILE OCCURE(PckATER) DO
    PROMPT("    ⭮ " + _Table2);
    IF    PckATER.ATERAttr = "000020002003" THEN TrTax.VIN     :=PckATER.Value;
    ELSIF PckATER.ATERAttr = "000020002005" THEN TrTax.StateNbr:=PckATER.Value;
    ELSIF PckATER.ATERAttr = "000020002006" THEN TrTax.EngPower:=STRTOFLD(PckATER.Value, NUMERIC);
    ELSIF PckATER.ATERAttr = "000020002014" THEN TrTax.Sum     :=STRTOFLD(PckATER.Value, NUMERIC);
    END;
    NEXT(PckATER);
   END; (* WHILE OCCURE(PckATER) ... *)
   INSERT(TrTax);
   INC(_Table2);
  END; (* WHILE SELECT(PckATER, Table, Packet.Packet, 00002, _Table2) ... *)
 END {Gather_TT_Decl_Ver2};

 PRIVATE PROCEDURE Gather_TT_AdvRep_Ver2();
 BEGIN
  Gather_TT_AnyRep_Ver3();
 END {Gather_TT_AdvRep_Ver2};

 PRIVATE PROCEDURE Gather_TT_Decl_Ver1();
  VAR
   _Table2: LIKE(ATERAttr.Table);
 BEGIN
  _Table2:=00000;
  WHILE SELECT(PckATER, Table, Packet.Packet, 00002, _Table2) DO
   DEFAULT(TrTax);
   WHILE OCCURE(PckATER) DO
    PROMPT("    ⭮ " + _Table2);
    IF    PckATER.Row = 00030 THEN TrTax.VIN     :=PckATER.Value;
    ELSIF PckATER.Row = 00040 THEN TrTax.StateNbr:=PckATER.Value;
    ELSIF PckATER.Row = 00050 THEN TrTax.EngPower:=STRTOFLD(PckATER.Value, NUMERIC);
    ELSIF PckATER.Row = 00130 THEN TrTax.Sum     :=STRTOFLD(PckATER.Value, NUMERIC);
    END;
    NEXT(PckATER);
   END; (* WHILE OCCURE(PckATER) ... *)
   INSERT(TrTax);
   INC(_Table2);
  END; (* WHILE SELECT(PckATER, Table, Packet.Packet, 00002, _Table2) ... *)
 END {Gather_TT_Decl_Ver1};

 PRIVATE PROCEDURE Gather_TT_AdvRep_Ver1();
  VAR
   _Table2: LIKE(ATERAttr.Table);
 BEGIN
  _Table2:=00000;
  WHILE SELECT(PckATER, Table2, Packet.Packet, _Table2, 00002, 00020) DO
   WHILE OCCURE(PckATER) DO
    PROMPT("    ⭮ " + _Table2 + " " + PckATER.Row2);
    DEFAULT(TrTax);
    CHANGESEL(PckATER, Table2, , Packet.Packet, _Table2, 00002, 00020, PckATER.Row2);
    SRCINSEL(PckATER, EQ, , "000020002003"); TrTax.VIN     :=PckATER.Value;
    SRCINSEL(PckATER, EQ, , "000020002005"); TrTax.StateNbr:=PckATER.Value;
    SRCINSEL(PckATER, EQ, , "000020002006"); TrTax.EngPower:=STRTOFLD(PckATER.Value, NUMERIC);
    SRCINSEL(PckATER, EQ, , "000020002014"); TrTax.Sum     :=STRTOFLD(PckATER.Value, NUMERIC);
    INSERT(TrTax);
    LAST(PckATER);
    CHANGESEL(PckATER, Table2, , Packet.Packet, _Table2, 00002, 00020);
    NEXT(PckATER);
   END;
   INC(_Table2);
  END;
 END {Gather_TT_AdvRep_Ver1};

 PRIVATE PROCEDURE StandOnCarLogByID(GatherByMath: SCAL[2]; trgID: L_OTx.tID; trgDate: DATE; Strong: SCAL[2]);
 BEGIN
  IF GatherByMath THEN
   SELECT(CarLog, Math, , GetObjectFromID(trgID, 1));
   WHILE OCCURE(CarLog) & (CarLog.Date # trgDate) DO
    NEXT(CarLog);
   END; (* WHILE OCCURE(CarLog) ... *)
  ELSE
   SELECT(CarLog, BoxNbr, , GetObjectFromID(trgID, 0), trgDate);
  END;
  IF Strong THEN
   L_General.CallUs(OCCURE(CarLog));
  END;
 END {StandOnCarLogByID};

 PRIVATE PROCEDURE MakeIndex();
  VAR
   P           : DATE;
   _TKind      : LIKE(TKind.TKind);
   _Proof      : LIKE(MathMty.Proof);
   _Sum,
   DistrSum    : NUMERIC[2];
   _Days,
   TotalDays   : NUMERIC[0];
   GatherByMath: SCAL[2];
   _ID         : L_OTx.tID;
   BPer, EPer  : DATE;
 BEGIN
  L_General.Assert(ACCESS(Packet), " ࠭    ⭮");
  L_General.Assert((Packet.Kind=L_Packet.knd_TT_Decl  ) |
                   (Packet.Kind=L_Packet.knd_TT_AdvRep) , "  ⭮  ࠭ᯮ⭮ ");
  L_General.Assert(SEARCH(Region, Region, Str.Slice(P_Firm.FP_KPP(P_Firm.OWN_FIRM, Packet.PerE), 0, 2)),
                   " ࠢ筨 ॣ   ॣ,|" +
                   "㪠   ࣠樨");
  BPer:=Packet.PerB;
  EPer:=L_DatTim.MonthEnd(Packet.PerE);

  L_OTx.Create_TmpCr();
  Create_TmpFiles();

  IF    Packet.Kind=L_Packet.knd_TT_Decl THEN
   IF    (Packet.ATER = 0040) | (Packet.ATER = 0043) | (Packet.ATER = 0049) THEN
    Gather_TT_Decl_Ver4();
   ELSIF (Packet.ATER = 0024) | (Packet.ATER = 0030) THEN
    Gather_TT_Decl_Ver3();
   ELSIF (Packet.ATER = 0016) THEN
    Gather_TT_Decl_Ver2();
   ELSIF (Packet.ATER = 0003) | (Packet.ATER = 0006) | (Packet.ATER = 0009) THEN
    Gather_TT_Decl_Ver1();
   ELSE
    L_General.CallUs(0);
   END;
  ELSIF Packet.Kind=L_Packet.knd_TT_AdvRep THEN
   IF    (Packet.ATER = 0022) | (Packet.ATER = 0029) THEN
    Gather_TT_AdvRep_Ver2();
   ELSIF (Packet.ATER = 0014) | (Packet.ATER = 0019) THEN
    Gather_TT_AdvRep_Ver1();
   ELSE
    L_General.CallUs(0);
   END;
  END;

  GatherByMath:=L_OTx.GatherByKeyAssets(EPer);
  MakeHeader("R", GatherByMath);

  IF GatherByMath THEN
   SELECT(Math, LeafMK, , 1, L_MathR.mathk_KeyAs);
   WHILE OCCURE(Math) DO
    L_OTx.TT_PrepareBySingleKeyAssets(Math.Math, BPer, EPer);
    IF SELECT(TmpCr, ID, L_OTx.GetID(Math.Math, 1)) THEN
     L_Car.StandOnCarLog(TmpCr.BoxNbr, EPer);
     _TKind:=CarLog.TKind;
     _ID   :=TmpCr.ID;
     _Sum  :=GetSingleBoxNbrTransportTax();

     P:=BPer;
     SETZERO(_Proof);
     WHILE P <= EPer DO
      SELECT(MathMty, Math, , Math.Math, P);
      WHILE OCCURE(MathMty) DO
       IF E_Stock.IsRunMathMty(MathMty.MtyIdx) & (MathMty.Proof # 0) THEN
        ADD(TmpMT, TMtyIdx, , _ID, CarLog.Column, _TKind, MathMty.MtyIdx,
            TmpMT.Proof, MathMty.Proof);
        INC(_Proof, MathMty.Proof);
       END;
       NEXT(MathMty);
      END; (* WHILE OCCURE(MathMty) ... *)
      P:=L_DatTim.IncMonth(P, +1);
     END; (* WHILE P <= EPer...*)

     SETZERO(DistrSum);
     SELECT(TmpMT, TMtyIdx, , _ID);
     WHILE OCCURE(TmpMT) DO
      TmpMT.Sum:=_Sum * TmpMT.Proof / _Proof;
      REPLACE(TmpMT);
      INC(DistrSum, TmpMT.Sum);
      NEXT(TmpMT);
     END; (* WHILE OCCURE(TmpMT) ... *)
     IF SELECT(TmpMT, TMtyIdx, _ID) THEN
      LAST(TmpMT);
      TmpMT.Sum:=TmpMT.Sum + (_Sum-DistrSum);
      REPLACE(TmpMT);
     ELSE
      MakePart("R", 1, CarLog.Column, _TKind, _Sum, EPer, 1);
     END;
    END;
    NEXT(Math);
   END; (* WHILE OCCURE(Math) ... *)
  ELSE
   L_OTx.TT_Prepare(0, BPer, EPer);
  END; (* IF GatherByMath *)

  SELECT(TmpCL, ID);
  WHILE OCCURE(TmpCL) DO
   CHANGESEL(TmpCL, ID, , TmpCL.ID);
   PROMPT("।  ९ " + TmpCL.ID);
   SETZERO(TotalDays);
   WHILE OCCURE(TmpCL) DO
    StandOnCarLogByID(GatherByMath, TmpCL.ID, TmpCL.Date, 1);
    _Days:=L_DatTim.DATEINT(BPer, EPer, CarLog.Date, CarLog.DateE);

    ADD(TmpTk, ID, , TmpCL.ID, CarLog.Column, CarLog.TKind, CarLog.BoxNbr,
        TmpTk.Days, _Days);
    INC(TotalDays, _Days);

    NEXT(TmpCL);
   END; (* WHILE OCCURE(TmpCL) ... *)
   LAST(TmpCL);
   CHANGESEL(TmpCL, ID);

   SELECT(TmpCr, ID, , TmpCL.ID);
   _Sum:=GetSingleBoxNbrTransportTax();
   SETZERO(DistrSum);
   SELECT(TmpTk, ID, , TmpCL.ID);
   WHILE OCCURE(TmpTk) DO
    TmpTk.Sum:=_Sum * TmpTk.Days / TotalDays;
    REPLACE(TmpTk);
    INC(DistrSum, TmpTk.Sum);
    NEXT(TmpTk);
   END; (* WHILE OCCURE(TmpTk) ... *)
   IF SELECT(TmpTk, ID, TmpCL.ID) THEN
    LAST(TmpTk);
    TmpTk.Sum:=TmpTk.Sum + (_Sum-DistrSum);
    REPLACE(TmpTk);
   END;

   NEXT(TmpCL);
  END; (* WHILE OCCURE(TmpCL) ... *)

  L_General.CLEAR("TmpTk");
  SELECT(TmpMT, TMtyIdx);
  WHILE OCCURE(TmpMT) DO
   SEARCH(Math, Math, , GetObjectFromID(TmpMT.ID, 1));
   MakePart("R", 1, TmpMT.Column, TmpMT.TKind, TmpMT.Sum, EPer, 1);
   NEXT(TmpMT);
  END; (* WHILE OCCURE(TmpMT) ... *)

  L_General.CLEAR("TmpMT");
  SELECT(TmpTk, ID);
  WHILE OCCURE(TmpTk) DO
   IF GatherByMath THEN
    SEARCH(Math, Math, , GetObjectFromID(TmpTk.ID, 1));
   ELSE
    SEARCH(Car, BoxNbr, , TmpTk.BoxNbr);
    L_Car.StandOnCarLog(Car.BoxNbr, EPer);
   END;
   MakePart("R", GatherByMath, TmpTk.Column, TmpTk.TKind, 0, EPer, 1);
   NEXT(TmpTk);
  END; (* WHILE OCCURE(TmpTk) ... *)

  SELECT(TrTax, StateNbr);
  WHILE OCCURE(TrTax) DO
   PROMPT("஢ઠ 楫⭮: " + TrTax.StateNbr);
   IF TrTax.Done # 2 THEN
    StandOnCarLogByID(GatherByMath, TrTax.ID, BPer, 0);
    IF OCCURE(CarLog) THEN
     CONFORM(CarLog, Car);
     MakePart("R", GatherByMath, CarLog.Column, CarLog.TKind, TrTax.Sum, EPer, 0);
    ELSE
     MakePart("R", GatherByMath, EMPTYOF(CarLog.Column), EMPTYOF(CarLog.TKind), TrTax.Sum, EPer, 0);
    END;
   END;
   NEXT(TrTax);
  END; (* WHILE OCCURE(TrTax) ... *)
  L_OTx.Purge_TmpCr();
  L_AFM.AF_PurgeTemp("TmpMT");
  L_AFM.AF_PurgeTemp("TmpTk");
  L_AFM.AF_PurgeTemp("TrTax");
 END {MakeIndex};

 PUBLIC PROCEDURE DstTT();
  CONST
   bpId = "DstTT";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Pass(bpId, "। ࠭ᯮ⭮ ");
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeIndex();
  FIO.Close(R);
  L_Basis.ExtPlayMakedRunTimeRep(bpId,
                                 Packet.Packet,
                                 L_General.tc_Entire,
                                 "।  " +
                                 " ਮ  " + L_DatTim.DateStr(Packet.PerB) + "  " + L_DatTim.DateStr(L_DatTim.MonthEnd(Packet.PerE)) + " " +
                                 " " + Packet.Packet,
                                 0);
 END {DSTTT};

END.
