(*
%Copyright   (c) Polak Computer System
%Author      12.01.1999 11:10:56 GINA
%Purpose     ନ஢ ਪ  ᫥ । 㯯 ࠡ⭨
%Type        operation
%Specific    SYS
%Modified    01.08.2014 12:28:34 POLAK\GAV
%Environment
*)

 MODULE FO_Value [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_PRoll, L_Staff, L_Money, L_Man, L_StdFrm, Memo, P_Firm, L_EDO;

 PRIVATE TYPE
  tContract = SCAL[3];

 PRIVATE CONST
  c_exlInternalCombine  = 0;
  c_onlyBasic           = 1;
  c_onlyExternalCombine = 2;

 PRIVATE VAR
  SumToPay: NUMERIC[2];
  Citizen : SCAL[3];
  ContDTyp,
  Sex     : SCAL[3];
  Contract: tContract;
  NoLv,
  IsAfter,
  IsBefore: DATE;

 PRIVATE PROCEDURE GoodTSN(): SCAL[2];
 BEGIN
  RETURN (Staff.Contract # L_Staff.cnt_OutStaff) &
         (~ContDTyp | ((StaffLog.ContDTyp + 1) = ContDTyp)) &
         (((Contract = c_exlInternalCombine)  & (Staff.Contract # L_Staff.cnt_InternalCombine)) |
          ((Contract = c_onlyBasic)           & (Staff.Contract = L_Staff.cnt_Basic)) |
          ((Contract = c_onlyExternalCombine) & (Staff.Contract = L_Staff.cnt_ExternalCombine))) &
         ( ~Citizen |
          ((Citizen = L_Man.ct_Russia) & (L_Man.Man_Citizen(Man.Man, NoLv) <= L_Man.ct_Russia)) |
          ((Citizen = L_Man.ct_CIS) &    (L_Man.Man_Citizen(Man.Man, NoLv) >  L_Man.ct_Russia))) &
         (~Sex | (Man.Sex + 1 = Sex)) &
         (L_Man.GetTakeOnDate(FOrder.Date) <= IsBefore) &
         (!IsAfter | (L_Man.GetTakeOnDate(FOrder.Date) >= IsAfter));
 END {GoodTSN};

 PRIVATE PROCEDURE GoodMyFirm(): SCAL[2];
 BEGIN
  IF P_Firm.E_wMultipleMyFirm(FOrder.Date) THEN
   RETURN Staff.MyFirm = FOrder.MyFirm;
  ELSE
   RETURN 1;
  END;
 END {GoodMyFirm};

 PUBLIC PROCEDURE FO_Value();
 BEGIN
  L_EDO.InitPrepareFOrder();
  SETEMPTY(SumToPay, Contract, ContDTyp, Sex, Citizen, ContDTyp, IsAfter, IsBefore, NoLv);
 
  STDFORM(L_StdFrm.sf_Choice("|᫨ %#######% %#########%      %###%" +
                             "|| 㤮  %##############################% %##########%" +
                             "|| ﭭ ஦            %#############%             " +
                             "||                                     %#############%             " +
                             "||ਭ  ࠭ (  )   %##########%                " +
                             "||ਭ                       %##########%                " +
                             "||騬                       %##########%                |",
                             "%RI" +
                             "%L<㡫|業⮢>NI"+
                             "%LNI"+
                             "%L<஬ ७ ᮢ⥫|᭮ ࠡ|쪮 譨 ᮢ⥫>I" +
                             "%L<||>I" +
                             "%L< 뢠||㣨 ࠭>I" +
                             "%L< 뢠|᪨|᪮>I" +
                             "%<D.N.y>YI" +
                             "%<D.N.y>I" +
                             "%<D.N.y>I"),
          " ନ஢ ਪ  ᫥ ",
          ,
          ,
          SumToPay, FOrder.Type, FOrder.MCode, Contract, ContDTyp, Citizen, Sex, IsAfter, IsBefore, NoLv);
 
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   CONFORM(Staff, Man);
   IF L_Staff.rInState(NoLv) THEN
    IF GoodMyFirm() & GoodTSN() THEN
     L_EDO.AppendFOrderL(0, SumToPay);
     L_PRoll.ShtDone(0);
    END; (* IF GoodTSN() ... *)
   END; (* IF InState ... *)
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
 END {FO_Value};

END.
