(*
%Copyright   (c) Polak Computer System
%Author      30.09.1999 18:22:55 BOR
%Purpose      ⢥   砫 
%Type        report
%Specific    SYS
%Modified    04.06.2014 14:38:14 POLAK\Bor
%Environment
*)

 IMPORT L_General, L_DatTim, L_MathR, L_MDoc, L_Car, L_Basis, L_XObj, L_bp,
        L_Staff, L_Str, P_Math, P_Firm, FIO, Memo, E_Stock, L_Env, L_StdFrm;

 VAR
  Need2002  : SCAL[2];
  CDate,
  From,
  UpTo      : DATE;
  wMF       : SCAL[2];

 PRIVATE PROCEDURE IsActiveOnDate(_Math: LIKE(Math.Math); D: DATE): SCAL[2];
 BEGIN
  RETURN (L_MathR.GetKeyAssAPrDate(Math.Math) < D) & (L_MathR.GetKeyAssASpDate(Math.Math) >= D);
 END {IsActiveOnDate};

 PRIVATE PROCEDURE MakeHeader(F: STRING[]; tc: L_General.tTimeCond);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "祭");
  L_Basis.wb_WrInQM(F, "⮢⥫");
  L_Basis.wb_WrInQM(F, "⮢⥫");
  L_Basis.wb_WrInQM(F, "᪮ ");
  L_Basis.wb_WrInQM(F, "᪠");
  L_Basis.wb_WrInQM(F, "⠂");
  L_Basis.wb_WrInQM(F, "⠑ᠭ");
  L_Basis.wb_WrInQM(F, "ᠭ");
  L_Basis.wb_WrInQM(F, "VIN");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "  뤠");

  IF    tc = L_General.tc_onMonthBeg THEN
   L_Basis.wb_WrInQM(F, "ந⢥");
   L_Basis.wb_WrInQM(F, "ᮢ⮨");
   L_Basis.wb_WrInQM(F, "ၠᮢ");
   L_Basis.wb_WrInQM(F, "ᇠᮢ");
   L_Basis.wb_WrInQM(F, "%");
   L_Basis.wb_WrInQM(F, "筠⮨");
   L_Basis.wb_WrInQM(F, "筠⮨쁠");
   L_Basis.wb_WrInQM(F, "筠⮨쁠>100");
   L_Basis.wb_WrInQM(F, " 襭");
   L_Basis.wb_WrInQM(F, "⨢ ");
   L_Basis.wb_WrInQM(F, "⮨  ");
   L_Basis.wb_WrInQM(F, "⮨ ");
   L_Basis.wb_WrInQM(F, " ");
   L_Basis.wb_WrInQM(F, "஡");
   L_Basis.wb_WrInQM(F, "⥪訩 ப");
  ELSIF tc = L_General.tc_inIntvl THEN
   L_Basis.wb_WrInQM(F, "灠⮨");
   L_Basis.wb_WrInQM(F, "灠⮨");
   L_Basis.wb_WrInQM(F, "爧ၠ");
   L_Basis.wb_WrInQM(F, "爧ၠ");
   L_Basis.wb_WrInQM(F, "爧ᇠ");
   L_Basis.wb_WrInQM(F, "爧ᇠ");
   L_Basis.wb_WrInQM(F, "筠⮨");
   L_Basis.wb_WrInQM(F, "⮨");
   L_Basis.wb_WrInQM(F, "⮨");
   L_Basis.wb_WrInQM(F, "ၠ");
   L_Basis.wb_WrInQM(F, "ၠ");
   L_Basis.wb_WrInQM(F, "ᇠ");
   L_Basis.wb_WrInQM(F, "ᇠ");
   L_Basis.wb_WrInQM(F, "筠⮨");
   L_Basis.wb_WrInQM(F, "᫥멈ၠ");
   L_Basis.wb_WrInQM(F, "᫥멈ၠਮ");
   L_Basis.wb_WrInQM(F, "᫥멈ᇠ");
   L_Basis.wb_WrInQM(F, "᫥멈ᇠਮ");
   L_Basis.wb_WrInQM(F, "獠⮨");
   L_Basis.wb_WrInQM(F, "獠");
   L_Basis.wb_WrInQM(F, "⮨");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "᫥멍ሇਮ");
   L_Basis.wb_WrInQM(F, "栌㈧ᮬ");
   L_Basis.wb_WrInQM(F, "஡");
   L_Basis.wb_WrInQM(F, "஡");
   L_Basis.wb_WrInQM(F, "獠稥");
   L_Basis.wb_WrInQM(F, "稥");
  ELSE
   L_General.CallUs(0);
  END;

  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠦ");
  L_Basis.wb_WrInQM(F, "፮");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ॢ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "㯯");
  L_Basis.wb_WrInQM(F, "㯯");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ᮡ ⨧樨");
  L_Basis.wb_WrInQM(F, "ᮡ ⨧樨 ");
  L_Basis.wb_WrInQM(F, "ﭨ");
  L_Basis.wb_WrInQM(F, "ﭨ ");
  L_Basis.wb_WrInQM(F, "ப ᯮ짮");
  L_Basis.wb_WrInQM(F, "ப ᯮ짮 ");
  L_Basis.wb_WrInQM(F, ". ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "  ⨧樨");
  L_Basis.wb_WrInQM(F, " 樨");
  L_Basis.wb_WrInQM(F, " 樨");
  L_Basis.wb_WrInQM(F, "㯯த");
  L_Basis.wb_WrInQM(F, "㯯த");
  L_Basis.wb_WrInQM(F, "਩");
  IF Need2002 THEN
   L_Basis.wb_WrInQM(F, "ၠᮢ멍2002");
  END;
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]; tc           : L_General.tTimeCond;
                                 BalCost      : L_XObj.tSum;
                                 Productive   : SCAL[2];
                                 OcKAGL,
                                 OcStaff,
                                 OcCar        : SCAL[2];
                                 _RunFrom,
                                 _RunUpTo     : LIKE(CarRun.TotRun));
  VAR
   BalWear,
   OutBalWear,
   InUseCost,
   BalWearPerR,
   TaxWearPerR: L_XObj.tSum;
   APrDate    : DATE;
 BEGIN
  IF wMF THEN
   CONFORM(Math, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(F, Math.Math);
  L_Basis.wb_WrStr(F, Math.Name);
  L_Basis.wb_WrStr(F, Math.UnitedC);
  CONFORM(Math, Vendor);
  L_Basis.wb_WrScl(F, Vendor.Vendor);
  L_Basis.wb_WrStr(F, Vendor.Name);
  L_Basis.wb_WrStr(F, P_Math.GetMathProSoft(Math.Math, UpTo, P_Math.P_Serial));
  L_Basis.wb_WrStr(F, FLDTOSTR(Math.Born, "y"));
  APrDate:=L_MathR.GetKeyAssAPrDate(Math.Math);
  L_Basis.wb_WrDat(F, APrDate);
  L_Basis.wb_WrDat(F, L_MathR.GetKeyAssASpDate(Math.Math));
  L_Basis.wb_WrScl(F, GetASPDest(Math.Math));

  IF OcCar & OCCURE(VehPasp) THEN
   L_Basis.wb_WrStr(F, VehPasp.VIN);
   L_Basis.wb_WrStr(F, VehPasp.VehPasp);
   L_Basis.wb_WrStr(F, L_Car.VehPaspNbr_AsStr());
   L_Basis.wb_WrDat(F, VehPasp.GiveDate);
  ELSE
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "----");
  END;

  IF tc = L_General.tc_onMonthBeg THEN
   L_Basis.wb_WrStr(F, FLDTOSTR(Productive, "-|+"));

   BalWear   :=L_MathR.GetKeyAssWear   (CDate, L_MathR.KA_BalDepr);
   OutBalWear:=L_MathR.GetKeyAssWear   (CDate, L_MathR.KA_OutBalDepr);
   InUseCost :=L_MathR.GetKeyAssBalCost(CDate, L_MathR.KA_InUse);

   L_Basis.wb_WrNum(F, BalCost, 2);
   L_Basis.wb_WrNum(F, BalWear, 2);
   L_Basis.wb_WrNum(F, OutBalWear, 2);
   L_Basis.wb_WrNum(F, GetPerc(BalCost, BalWear+OutBalWear), 1);
   L_Basis.wb_WrNum(F, BalCost-BalWear-OutBalWear, 2);
   L_Basis.wb_WrNum(F, BalCost-BalWear, 2);
   L_Basis.wb_WrStr(F, FLDTOSTR((BalCost-BalWear) > 100000, "-|+"));
   L_Basis.wb_WrStr(F, FLDTOSTR((BalCost>0) & (BalCost=(BalWear+OutBalWear)), "-|+"));
   L_Basis.wb_WrStr(F, FLDTOSTR(InUseCost>0, "-|+"));
 
   L_Basis.wb_WrNum(F, InUseCost, 2);
   L_Basis.wb_WrNum(F, L_MathR.GetKeyAssBalCostR(CDate, L_MathR.KA_Tax), 2);
   L_Basis.wb_WrNum(F, L_MathR.GetKeyAssWearR   (CDate, L_MathR.KA_Tax), 2);
   L_Basis.wb_WrNum(F, _RunUpTo, 2);
   IF ~!APrDate THEN
    L_Basis.wb_WrNum(F, L_DatTim.CompleteMonthsInIntvl(L_DatTim.MonthEnd(APrDate)+1, CDate), 0);
   ELSE
    L_Basis.wb_WrNum(F, 0, 0);
   END;
  ELSIF tc = L_General.tc_inIntvl THEN
   BalCost   :=L_MathR.GetKeyAssBalCost(From, L_MathR.KA_All);
   BalWear   :=L_MathR.GetKeyAssWear   (From, L_MathR.KA_BalDepr);
   OutBalWear:=L_MathR.GetKeyAssWear   (From, L_MathR.KA_OutBalDepr);
   L_Basis.wb_WrNum(F, BalCost, 2);
   L_Basis.wb_WrNum(F, L_MathR.GetKeyAssBalCostR(From, L_MathR.KA_All), 2);
   L_Basis.wb_WrNum(F, BalWear, 2);
   L_Basis.wb_WrNum(F, L_MathR.GetKeyAssWearR   (From, L_MathR.KA_BalDepr), 2);
   L_Basis.wb_WrNum(F, OutBalWear, 2);
   L_Basis.wb_WrNum(F, L_MathR.GetKeyAssWearR   (From, L_MathR.KA_OutBalDepr), 2);
   L_Basis.wb_WrNum(F, BalCost-BalWear-OutBalWear, 2);

   BalCost   :=L_MathR.GetKeyAssBalCost(UpTo+1, L_MathR.KA_All);
   BalWear   :=L_MathR.GetKeyAssWear(UpTo+1, L_MathR.KA_BalDepr);
   OutBalWear:=L_MathR.GetKeyAssWear(UpTo+1, L_MathR.KA_OutBalDepr);
   L_Basis.wb_WrNum(F, BalCost, 2);
   L_Basis.wb_WrNum(F, L_MathR.GetKeyAssBalCostR(UpTo+1, L_MathR.KA_All), 2);
   L_Basis.wb_WrNum(F, BalWear, 2);
   L_Basis.wb_WrNum(F, L_MathR.GetKeyAssWearR   (UpTo+1, L_MathR.KA_BalDepr), 2);
   L_Basis.wb_WrNum(F, OutBalWear, 2);
   L_Basis.wb_WrNum(F, L_MathR.GetKeyAssWearR   (UpTo+1, L_MathR.KA_OutBalDepr), 2);
   L_Basis.wb_WrNum(F, BalCost-BalWear-OutBalWear, 2);

   BalWearPerR:=L_MathR.GetKeyAssWearPerR(From, UpTo, L_MathR.KA_BalDepr);
   TaxWearPerR:=L_MathR.GetKeyAssWearPerR(From, UpTo, L_MathR.KA_Tax);

   L_Basis.wb_WrNum(F, L_MathR.GetKeyAssWearPer (From, UpTo, L_MathR.KA_BalDepr), 2);
   L_Basis.wb_WrNum(F, BalWearPerR, 2);
   L_Basis.wb_WrNum(F, L_MathR.GetKeyAssWearPer (From, UpTo, L_MathR.KA_OutBalDepr), 2);
   L_Basis.wb_WrNum(F, L_MathR.GetKeyAssWearPerR(From, UpTo, L_MathR.KA_OutBalDepr), 2);
   L_Basis.wb_WrNum(F, L_MathR.GetKeyAssBalCostR(From, L_MathR.KA_Tax), 2);
   L_Basis.wb_WrNum(F, L_MathR.GetKeyAssWearR   (From, L_MathR.KA_Tax), 2);
   L_Basis.wb_WrNum(F, L_MathR.GetKeyAssBalCostR(UpTo+1, L_MathR.KA_Tax), 2);
   L_Basis.wb_WrNum(F, L_MathR.GetKeyAssWearR   (UpTo+1, L_MathR.KA_Tax), 2);
   L_Basis.wb_WrNum(F, TaxWearPerR, 2);
   IF    BalWearPerR = TaxWearPerR THEN
    L_Basis.wb_WrStr(F, "=");
   ELSIF BalWearPerR > TaxWearPerR THEN
    L_Basis.wb_WrStr(F, ">");
   ELSIF BalWearPerR < TaxWearPerR THEN
    L_Basis.wb_WrStr(F, "<");
   ELSE
    L_General.CallUs(0);
   END;
   L_Basis.wb_WrNum(F, _RunFrom, 2);
   L_Basis.wb_WrNum(F, _RunUpTo, 2);
   L_Basis.wb_WrNum(F, IsActiveOnDate(Math.Math, From),   0);
   L_Basis.wb_WrNum(F, IsActiveOnDate(Math.Math, UpTo+1), 0);
  ELSE
   L_General.CallUs(0);
  END;

  L_Basis.wb_WrStr(F, L_MathR.GetKeyAssAddressSoft(Math.Math, UpTo));
  IF OcStaff THEN
   L_Basis.wb_WrScl(F, Staff.TSN);
   L_Basis.wb_WrStr(F, Man.Name);
   L_Basis.wb_WrScl(F, Sort.Sort);
   L_Basis.wb_WrStr(F, Sort.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  IF OcCar THEN
   L_Basis.wb_WrScl(F, Car.BoxNbr);
   L_Basis.wb_WrStr(F, CarLog.StateNbr);
   L_Basis.wb_WrScl(F, CarLog.Column);
   IF ~!CarLog.TKind THEN
    CONFORM(CarLog, TKind);
    L_Basis.wb_WrStr(F, TKind.Name);
   ELSE
    L_Basis.wb_WrStr(F, "---");
   END;
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Car.purp_Pool, CarLog.Purpose));
   L_Basis.wb_WrScl(F, Mark.Mark);
   L_Basis.wb_WrStr(F, GetMarkName(Mark.Name));
  ELSE
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, GetMarkName("----"));
  END;

  IF OcKAGL THEN
   L_Basis.wb_WrScl(F, KAGLog.DprGroup);
   IF OCCURE(DprGroup) THEN
    L_Basis.wb_WrStr(F, DprGroup.Name);
   ELSE
    L_Basis.wb_WrStr(F, "");
   END;
   L_Basis.wb_WrScl(F, DeprecT.DeprecT);
   L_Basis.wb_WrStr(F, DeprecT.Name);
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_MathR.dprm_Pool, KAGroup.AcnDprM));
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_MathR.dprm_Pool, KAGroup.TaxDprM));
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_MathR.matst_Pool, MathKAGL.AcnStat));
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_MathR.matst_Pool, MathKAGL.TaxStat));
   IF ~!APrDate THEN
    L_Basis.wb_WrNum(F, L_MathR.GetFullUL(APrDate, L_MathR.DprK_Acn), 0);
    L_Basis.wb_WrNum(F, L_MathR.GetFullUL(APrDate, L_MathR.DprK_Tax), 0);
   ELSE
    L_Basis.wb_WrNum(F, L_MathR.GetFullUL(MathKAGL.Date, L_MathR.DprK_Acn), 0);
    L_Basis.wb_WrNum(F, L_MathR.GetFullUL(MathKAGL.Date, L_MathR.DprK_Tax), 0);
   END;
   L_Basis.wb_WrNum(F, KAGLog.TaxNumb, 3);
   L_Basis.wb_WrStr(F, FLDTOSTR(KAGLog.OKOF, "00 0000000000"));
   L_Basis.wb_WrScl(F, KAGLog.Deprec);
   L_Basis.wb_WrScl(F, MathKAGL.Dest);
   L_Basis.wb_WrScl(F, Dest.Name);
   L_Basis.wb_WrScl(F, KAGroup.KAGroup);
   L_Basis.wb_WrScl(F, KAGroup.Name);
  ELSE
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "0");
   L_Basis.wb_WrStr(F, "0");
   L_Basis.wb_WrStr(F, "0");
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "----");
  END;
  L_Basis.wb_WrStr(F, Math.Comment);
  IF Need2002 THEN
   L_Basis.wb_WrNum(F, L_MathR.GetKeyAssWearR(01\01\2002, L_MathR.KA_BalDepr), 2);
  END;
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE GetMarkName(DefMarkName: STRING[]): STRING[];
  VAR
   MarkName: STRING[];
 BEGIN
  MarkName:=P_Math.GetMathProSoft(Math.Math, UpTo, P_Math.P_Model);
  IF ~!MarkName THEN
   RETURN MarkName;
  ELSE
   RETURN DefMarkName;
  END;
 END {GetMarkName};

 PRIVATE PROCEDURE GetASPDest(_Math: LIKE(Math.Math)): LIKE(MDoc.Dest);
 BEGIN
  IF L_MathR.AccessMDoc_asASp(_Math) THEN RETURN MDoc.Dest;
  ELSE                                    RETURN L_General.EMPTY_NUMBER();
  END;
 END {GetASPDest};

 PRIVATE PROCEDURE GetPerc(Bal, Wear: L_XObj.tSum): NUMERIC[2];
 BEGIN
  IF Bal = 0 THEN
   RETURN 0.0;
  ELSE
   RETURN Wear/Bal*100;
  END;
 END {GetPerc};

 PRIVATE PROCEDURE Make(bpId: L_bp.tId; tc: L_General.tTimeCond);
  VAR
   DprGroupName: LIKE(DprGroup.Name);
   Productive  : SCAL[2];
   ProdCost,
   NonPCost,
   BalCost     : L_XObj.tSum;
   OcKAGL,
   OcMDoc,
   OcStaff,
   OcCar       : SCAL[2];
   RunFrom,
   RunUpTo     : LIKE(CarRun.TotRun);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

  Need2002:=(L_Env.KeyAssAcntLev(01\01\2002) = L_MathR.kaal_WithActProcess);
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());

  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeader("R", tc);

  SELECT(Math, LeafMK, , 1, L_MathR.mathk_KeyAs);
  WHILE OCCURE(Math) DO
   PROMPT(Math.Math);
   L_MathR.CountUpMath(Math.Math, UpTo);
   IF    tc = L_General.tc_onMonthBeg THEN
    ProdCost  :=L_MathR.GetKeyAssBalCost(CDate, L_MathR.KA_dst_Productive);
    NonPCost  :=L_MathR.GetKeyAssBalCost(CDate, L_MathR.KA_dst_NonProductive);
    IF (ProdCost # 0) & (NonPCost # 0) THEN
     L_StdFrm.Confirm("ꥪ  " + Math.Math + "|६  ந⢥  ந⢥?");
    END;
    OcMDoc:=IsActiveOnDate(Math.Math, CDate);
    BalCost   :=ProdCost+NonPCost;
    Productive:=ProdCost > NonPCost;
   ELSIF tc = L_General.tc_inIntvl THEN
    OcMDoc:=L_MathR.IsActiveKeyAss(Math.Math, From, UpTo);
    SETEMPTY(Productive);
    BalCost:=0;
   ELSE
    L_General.CallUs(0);
   END;
   IF OcMDoc | (BalCost # 0) THEN
    IF L_MDoc.PosToLastKeyAssChangeResponsibleMDoc(Math.Math, UpTo) THEN
     OcStaff:=1;
     CONFORM(MDoc, Staff);
     CONFORM(Staff, Man);
     L_Staff.PosToStaffLog(MDoc.TSN, UpTo, 1);
     CONFORM(StaffLog, Sort);
    ELSE
     OcStaff:=0;
    END;
    IF L_MathR.PosToKAGSoft(Math.Math, UpTo) THEN
     CONFORM(MathKAGL, Dest);
     CONFORM(KAGLog, DprGroup);
     OcKAGL:=1;
    ELSE
     OcKAGL:=0;
    END;
    IF    tc = L_General.tc_onMonthBeg THEN
     OcCar:=L_MathR.PosToCarLog(Math.Math, UpTo);
     IF OcKAGL THEN
      L_General.Assert(KAGLog.IsCar = OcCar, " "+Math.Math+L_Str.PoolItem("  | ", KAGLog.IsCar)+" |"+L_Str.PoolItem("  | ", KAGLog.IsCar)+"  ᮯ⠢ ࠦ  "+L_DatTim.DateStr(CDate));
     END;
    ELSIF tc = L_General.tc_inIntvl THEN
     OcCar:=L_MathR.PosToLastCarLog(Math.Math, UpTo);
    ELSE
     L_General.CallUs(0);
    END;
    IF OcCar THEN
     CONFORM(CarLog, Car);
     CONFORM(CarLog, Mark);
     CONFORM(CarLog, VehPasp);
     SAVE(CarLog);
     RunUpTo:=L_Car.GetWhiteRun(Math.Math, UpTo+1);
     IF (tc = L_General.tc_inIntvl) & (RunUpTo # 0) THEN
      RunFrom:=L_Car.GetWhiteRun(Math.Math, From);
     ELSE
      RunFrom:=0;
     END;
     RESTORE(CarLog);
    ELSE
     RunFrom:=0;
     RunUpTo:=0;
    END;

    MakePart("R", tc, BalCost, Productive, OcKAGL, OcStaff, OcCar, RunFrom, RunUpTo);
   END;
   NEXT(Math);
  END; (* WHILE OCCURE(Math) ... *)
  FIO.Close(R);
 END {Make};

 PUBLIC PROCEDURE KeyAs();
  CONST
   bpId = "KeyAs";
 BEGIN
  L_bp.Begin(bpId, " ⢥   砫 ", L_bp.t_Basis, L_General.tc_onMonthBeg);
  CDate:=Memo.ud_mb();
  From :=CDate;
  UpTo :=CDate-1;
  Make(bpId, L_General.tc_onMonthBeg);
  L_bp.End();
 END {KeyAs};

 PUBLIC PROCEDURE KeyA1();
  CONST
   bpId = "KeyA1";
 BEGIN
  L_bp.Begin(bpId, " ⢥   ਮ", L_bp.t_Basis, L_General.tc_inIntvl);
  L_General.SetIntvlByIntvl(From, UpTo);
  L_DatTim.CheckWMIntvl(From, UpTo);
  CDate:=UpTo+1;
  Make(bpId, L_General.tc_inIntvl);
  L_bp.End();
 END {KeyA1};

END.
