(*
%Copyright   (c) Polak Computer System
%Author      14.05.1998 13:52:51 SAN
%Purpose       ᪫᪨ 㬥⠬
%Type        library
%Specific    SYS
%Modified    19.09.2014 17:09:15 POLAK\Bor
%Environment
*)

 MODULE L_MDoc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tStockType    = SCAL[2];
  tMDocDir      = SCAL[4];
  tMDocScope    = SCAL[2];
  tStock        = SCAL[1E2];
  tMathFlowType = SCAL[3];
  fmdc_tQueue   = SCAL[2];

  tFillMDocSrcNbr = SCAL[4]; (*FillMDocSrcNbr*)

 PUBLIC CONST
  mds_External = 0;
  mds_Internal = 1;

  mds_Pool = "譨|७";

  mdd_Ingoing   = 0;
  mdd_Outgoing  = 1;
  mdd_Undefined = 2;
  mdd_MSP       = 3;

  mdd_Pool = "室騩|室騩| ।|";

  mft_Debit   = 0;
  mft_Credit  = 1;
  mft_None    = 2;

  mft_Pool       = "室|室| ";
  mft_Pool_1Char = "+|-|";

  st_Prepared  = 0; (* ⮢ *)
  st_Passed    = 1; (* ஢    *)
  st_Canceled  = 2; (* 㫨஢ *)
  st_Pool = "⮢|஢|㫨஢";

  DG_Use = 08; (* 㯯 権  室  *)
  DG_Amr = 09; (* 㯯 権  ᫥ ⨧樨 *)
  DG_AdT = 19; (* 㯯 権  ⥫쭮 ⠪஢  *)
  DG_TIU = 20; (* 㯯 権  ⠪஢  *)
  DG_CnT = 98; (* 㯯 権  ⥫쭮 ⠪஢ XObject   *)

  md_NPr = 05; (*   室 !  ᯮ짮  " ⮢" *)
  md_TOV = 06; (* ॡ  - *)
  md_NOV = 07; (*   - *)
  md_DONTTOUCH08 = 08; (* ⥦ 㬥 *)
  md_Amr = 09; (* ⨧ , ⮫쪮  ନ஢ ⮪ ᫥ ⨧樨 *)
  md_APr = 10; (*    ᯫ  *)
  md_APP = 11; (*  ।  *)
  md_ADo = 12; (*  ୨樨  *)
  md_ASp = 13; (*  ᯨᠭ  *)
  md_ASO = 14; (*  ᬥ ⢥⢥  *)
  md_ADg = 15; (*  -   ࠢ 宧.  *)
  md_DDA = 16; (* 㬥   ॣ⮢ *)
  md_AVb = 17; (*   (த, ।)  *)
  md_DONTTOUCH19 = 19; (* ⠤  Math *)
  md_DONTTOUCH20 = 20; (*  *)
  md_APO = 21; (* ய樮쭮  ⮨  *)
  md_APc = 22; (* ८業  *)
  md_Spc = 39; (* 䨪 ??? *)
  md_IsS = 40; (* 室騩  *)
  md_ITN = 41; (* 室 ⮢ୠ  *)
  md_ISF = 42; (* 室騩 -䠪 *)
  md_IAS = 43; (* 室騩  ᤠ-ਥ *)
  md_VSF = 44; (* 室騩 -䠪 *)
  md_IAU = 45; (* 室騩  ⠭ , ਥ-ࠤ *)
  md_Nrd = 46; (*  *)
  md_DPr = 47; (* 㬥  த *)
  md_DPk = 48; (* 㬥  㯮 *)
  md_VhS = 50; (* 室騩  *)
  md_VhA = 51; (*  室騥 *)
  md_VTN = 52; (* 室 ⮢ୠ  *)
  md_Dvr = 53; (* ७ *)
  md_RPk = 54; (* 㬥 ஧筮 㯪 *)
  md_RPr = 55; (* 㬥 ஧筮 த *)
  md_OBK = 56; (*  ⭮  *)
  md_PPk = 57; (* 㬥  㯮 *)
  md_RNR = 58; (* 㬥  । ᪫㥬 室 *)
  md_PPr = 59; (* 㬥  த *)
  md_MSP = 60; (* ᪫᪮ ६饭 *)
  md_ViP = 61; (*   ந⢠ *)
  md_VPC = 62; (* 譥 ६饭  *)
  md_FPk = 63; (* ।  䨫 *)
  md_ISA = 64; (* 室騩 - *)
  md_ZNr = 65; (* - *)
  md_FPr = 66; (* । (த) 䨫 *)
  md_RPU = 67; (*   ᮭ (㤥ঠ) *)
  md_RPN = 68; (*   ᮭ (᫥) *)
  md_RSZ = 69; (* ।   室  室 *)
  md_TCh = 70; (*  祪 *)
  md_PPK = 71; (* 㬥  㯮 ( )*)
  md_ZMC = 72; (*    *)
  md_PPR = 73; (* 㬥  த ( )*)
  md_NDk = 80; (*   *)
  md_NlO = 81; (*  易⥫⢮ *)

  md_IAP = 87; (* 室騩  । ࠢ *)
  md_VAP = 88; (* 室騩  । ࠢ *)
  md_VAU = 89; (* 室騩  ਥ-। *)
  md_SpB = 90; (* ࠢ 壠 *)
  md_PCh = 91; (* 室 祪 *)
  md_RCh = 92; (* 室 祪 *)
  md_PIO = 93; (*   ஬諥 ᯫ *)
  md_VOD = 94; (* 室    *)
  md_IOD = 95; (* 室    *)

  pf_Roll76 = 0;
  pf_A4     = 1;
  pf_A5onA4 = 2;
  pf_A5     = 3;

  vatm_Deduction    = 0;
  vatm_Distribution = 1;
  vatm_AddToCost    = 2;
  vatm_Pool         = " |।| ⮨";
  vatm_Pool_Short   ="||";

  mdpt_TM     = 0; (* MDocPrinterType *)
  mdpt_Normal = 1;

  cvat_Impossible = 0;
  cvat_Possible   = 1;
  cvat_Necessary  = 2;

  mdkip_No           = 0; (*MDocKind.ImdPrint*)
  mdkip_Yes          = 1;
  mdkip_GetFromStock = 2;

  convertionId = 159;

  fmdsn_No                 = 0; (*FillMDocSrcNbr*)
  fmdsn_Yes                = 1;
  fmdsn_YesAndNotAllowEdit = 2;
  fmdsn_NoAndNotAllowEdit  = 3;
 
  np_No  = 0; (*MDoc_OnAnyModification.NeedProceed*)
  np_Yes = 1;
  np_Try = 2;

  im_No    = 0; (* MDocKind.imOC and so forth *)
  im_Yes   = 1;
  im_Basic = 2;

  NoAlower = 99;

 PUBLIC TYPE
  tRequiredMDocKind = SCAL[3];
 PUBLIC CONST
  mdkrq_Disabled   = 0;
  mdkrq_Required   = 1;
  mdkrq_Unrequired = 2;

 IMPORT Memo, L_General, L_DatTim, L_Events, L_XDoc, L_Acnt, L_MathR, L_EC, L_Prop, L_AFM, L_StdFrm, L_Car,
        L_Pmnt, L_XObj, L_CUC, L_Str, P_Cntr, P_Math, P_Firm, P_Storage, L_MSO,
        Str, E_Stock, E_Pmnt, L_Stock, L_AR, L_Env, L_Print, P_CI, L_PDoc, L_AcsPnt, L_Dest, L_JDoc,
        L_WDO, SysLog, L_XDR, L_Fuel, L_CI, Math, P_Man, L_Staff;

 PUBLIC PROCEDURE KeyAssetsMDoc(_MDocKind: LIKE(MDoc.MDocKind)): SCAL[2];
 BEGIN
  RETURN (_MDocKind=md_APr) |
         (_MDocKind=md_APP) |
         (_MDocKind=md_ADo) |
         (_MDocKind=md_ASp) |
         (_MDocKind=md_ASO) |
         (_MDocKind=md_ADg) |
         (_MDocKind=md_AVb) |
         (_MDocKind=md_APO) |
         (_MDocKind=md_APc);
 END {KeyAssetsMDoc};

 PUBLIC PROCEDURE md_asAPr(_MDocKind: LIKE(MDocKind.MDocKind)): SCAL[2];
 BEGIN
  RETURN (_MDocKind=md_APr);
 END {md_asAPr};

 PUBLIC PROCEDURE md_asASp(_MDocKind: LIKE(MDocKind.MDocKind)): SCAL[2];
 BEGIN
  RETURN (_MDocKind=md_ASp) | (_MDocKind=md_AVb);
 END {md_asASp};

 PUBLIC PROCEDURE IsMDoc_woMath(_MDocKind: LIKE(MDocKind.MDocKind)): SCAL[2];
 BEGIN
  RETURN (_MDocKind = md_RPU) | (_MDocKind = md_RPN) | (_MDocKind = md_RSZ);
 END {IsMDoc_woMath};

(*!*) PUBLIC PROCEDURE Get_vatm_Pool(Short: SCAL[2]): STRING[];
 BEGIN
  IF Short THEN   RETURN vatm_Pool_Short;
  ELSE            RETURN vatm_Pool;
  END;
 END {Get_vatm_Pool};

 PUBLIC PROCEDURE GetMDocNameS(_MDocKind: LIKE(MDoc.MDocKind)): LIKE(MDocKind.SName);
  VAR
   _SName: LIKE(MDocKind.SName);
 BEGIN
  SAVE(MDocKind);
  IF SEARCH(MDocKind, MDocKind, _MDocKind) THEN
   _SName:=MDocKind.SName;
  ELSE
   _SName:="???????????????????";
  END;
  RESTORE(MDocKind);
  RETURN _SName;
 END {GetMDocNameS};

 PUBLIC PROCEDURE MDocStr(_MDocKind: LIKE(MDoc.MDocKind); _MDoc: LIKE(MDoc.MDoc)): STRING[];
 BEGIN
  RETURN MDocKindNick(_MDocKind, 1)+" "+_MDoc;
 END {MDocStr};

 PUBLIC PROCEDURE DecodeMDocId(    curMDocId: STRING[];
                               VAR trgMDocKind: LIKE(MDocKind.MDocKind);
                               VAR trgMDoc    : LIKE(MDoc.MDoc));
  VAR
   trgXDocType: L_XDoc.tXDocType;
 BEGIN
  L_XDoc.DecodeXDocId(curMDocId, trgXDocType, trgMDocKind, trgMDoc);
  L_General.CallUs(trgXDocType = L_XDoc.xdt_MDoc);
 END {DecodeMDocId};

 PUBLIC PROCEDURE GetDependentMDocXDC(): L_XDoc.tXDocCollection;
 BEGIN
  RETURN L_XDoc.GetDependentXDC(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.xdt_MDoc);
 END {GetDependentMDocXDC};

 PUBLIC PROCEDURE GetMDocStrNbr(): STRING[];
 BEGIN
  RETURN MDocStr(MDoc.MDocKind, MDoc.MDoc) + "  " + L_DatTim.DateStr(MDoc.Date);
 END {GetMDocStrNbr};

 PUBLIC PROCEDURE BarCode(): STRING[];
 BEGIN
  RETURN L_XDoc.BarCode(L_XDoc.bck_IdIn17, L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc, MDoc.CopyCnt);
 END {BarCode};

 PUBLIC PROCEDURE CurMDocSource(): L_XObj.tSource;
 BEGIN
  IF KeyAssetsMDoc(MDoc.MDocKind) THEN
   IF L_XObj.E_DoSecondSide(MDoc.Date) THEN
    RETURN L_XObj.src_ACalc;
   ELSE
    RETURN L_XObj.src_KAMDoc;
   END;
  ELSE
   RETURN L_XObj.src_MDoc;
  END;
 END {CurMDocSource};

(*!*) PUBLIC PROCEDURE GetMDocSource(_MDocKind: LIKE(MDoc.MDocKind)): L_XObj.tSource;
 BEGIN
  RETURN CurMDocSource();
 END {GetMDocSource};

 PUBLIC PROCEDURE curRefToXDoc_GetId(): L_XDoc.tXDocId;
 BEGIN
  RETURN L_XDoc.GetSingleRefToXDocId(L_XDoc.curXDocId(L_XDoc.xdt_MDoc));
 END {curRefToXDoc_GetId};

 PUBLIC PROCEDURE curRefToXDoc_PositionOn(reqXDT: L_XDoc.tXDocType);
  VAR
   reqToXDocId: L_XDoc.tXDocId;
 BEGIN
  reqToXDocId:=curRefToXDoc_GetId();
  L_General.CallUs(L_XDoc.ExtractXDocType(reqToXDocId) = reqXDT);
  L_XDoc.PositionOnXDoc(reqToXDocId);
 END {curRefToXDoc_PositionOn};

 PUBLIC PROCEDURE MDocKindNick(_MDocKind: LIKE(MDoc.MDocKind); NoLatin: SCAL[2]): STRING[3];
 BEGIN
  IF    _MDocKind = md_NPr THEN RETURN Str.Item("NPR|", "|", NoLatin);
  ELSIF _MDocKind = md_TOV THEN RETURN Str.Item("TOV|", "|", NoLatin);
  ELSIF _MDocKind = md_NOV THEN RETURN Str.Item("NOV|", "|", NoLatin);
  ELSIF _MDocKind = md_APr THEN RETURN Str.Item("APr|", "|", NoLatin);
  ELSIF _MDocKind = md_APP THEN RETURN Str.Item("APP|", "|", NoLatin);
  ELSIF _MDocKind = md_ADo THEN RETURN Str.Item("ADo|", "|", NoLatin);
  ELSIF _MDocKind = md_ASp THEN RETURN Str.Item("ASp|", "|", NoLatin);
  ELSIF _MDocKind = md_ASO THEN RETURN Str.Item("ASO|", "|", NoLatin);
  ELSIF _MDocKind = md_ADg THEN RETURN Str.Item("ADG|", "|", NoLatin);
  ELSIF _MDocKind = md_DDA THEN RETURN Str.Item("DDA|", "|", NoLatin);
  ELSIF _MDocKind = md_AVb THEN RETURN Str.Item("AVb|", "|", NoLatin);
  ELSIF _MDocKind = md_APO THEN RETURN Str.Item("APO|", "|", NoLatin);
  ELSIF _MDocKind = md_APc THEN RETURN Str.Item("APc|", "|", NoLatin);
  ELSIF _MDocKind = md_IsS THEN RETURN Str.Item("IsS|", "|", NoLatin);
  ELSIF _MDocKind = md_ITN THEN RETURN Str.Item("ITN|", "|", NoLatin);
  ELSIF _MDocKind = md_ISF THEN RETURN Str.Item("ISF|", "|", NoLatin);
  ELSIF _MDocKind = md_IAS THEN RETURN Str.Item("IAS|", "|", NoLatin);
  ELSIF _MDocKind = md_VSF THEN RETURN Str.Item("VSF|", "|", NoLatin);
  ELSIF _MDocKind = md_IAU THEN RETURN Str.Item("IAU|", "|", NoLatin);
  ELSIF _MDocKind = md_Spc THEN RETURN Str.Item("Spc|", "|", NoLatin);
  ELSIF _MDocKind = md_Nrd THEN RETURN Str.Item("Nrd|", "|", NoLatin);
  ELSIF _MDocKind = md_DPr THEN RETURN Str.Item("DPr|", "|", NoLatin);
  ELSIF _MDocKind = md_DPk THEN RETURN Str.Item("DPk|", "|", NoLatin);
  ELSIF _MDocKind = md_VhS THEN RETURN Str.Item("VhS|", "|", NoLatin);
  ELSIF _MDocKind = md_VhA THEN RETURN Str.Item("VhA|", "|", NoLatin);
  ELSIF _MDocKind = md_VTN THEN RETURN Str.Item("VTN|", "|", NoLatin);
  ELSIF _MDocKind = md_Dvr THEN RETURN Str.Item("Dvr|", "|", NoLatin);
  ELSIF _MDocKind = md_RPk THEN RETURN Str.Item("RPk|", "|", NoLatin);
  ELSIF _MDocKind = md_RPr THEN RETURN Str.Item("RPr|", "|", NoLatin);
  ELSIF _MDocKind = md_OBK THEN RETURN Str.Item("OBK|", "|", NoLatin);
  ELSIF _MDocKind = md_PPk THEN RETURN Str.Item("PPk|", "|", NoLatin);
  ELSIF _MDocKind = md_PPK THEN RETURN Str.Item("PPK|", "|", NoLatin);
  ELSIF _MDocKind = md_RNR THEN RETURN Str.Item("RNR|", "|", NoLatin);
  ELSIF _MDocKind = md_PPr THEN RETURN Str.Item("PPr|", "|", NoLatin);
  ELSIF _MDocKind = md_PPR THEN RETURN Str.Item("PPR|", "|", NoLatin);
  ELSIF _MDocKind = md_MSP THEN RETURN Str.Item("MSP|", "|", NoLatin);
  ELSIF _MDocKind = md_ViP THEN RETURN Str.Item("ViP|", "|", NoLatin);
  ELSIF _MDocKind = md_VPC THEN RETURN Str.Item("VPC|", "|", NoLatin);
  ELSIF _MDocKind = md_FPk THEN RETURN Str.Item("FPk|", "|", NoLatin);
  ELSIF _MDocKind = md_ISA THEN RETURN Str.Item("ISA|", "|", NoLatin);
  ELSIF _MDocKind = md_ZNr THEN RETURN Str.Item("ZNr|", "|", NoLatin);
  ELSIF _MDocKind = md_FPr THEN RETURN Str.Item("FPr|", "|", NoLatin);
  ELSIF _MDocKind = md_RPU THEN RETURN Str.Item("RPU|", "|", NoLatin);
  ELSIF _MDocKind = md_RPN THEN RETURN Str.Item("RPN|", "|", NoLatin);
  ELSIF _MDocKind = md_RSZ THEN RETURN Str.Item("RSZ|", "|", NoLatin);
  ELSIF _MDocKind = md_TCh THEN RETURN Str.Item("TCh|", "|", NoLatin);
  ELSIF _MDocKind = md_NDk THEN RETURN Str.Item("NDk|", "|", NoLatin);
  ELSIF _MDocKind = md_NlO THEN RETURN Str.Item("NlO|", "|", NoLatin);
  ELSIF _MDocKind = md_IAP THEN RETURN Str.Item("IAP|", "|", NoLatin);
  ELSIF _MDocKind = md_VAP THEN RETURN Str.Item("VAP|", "|", NoLatin);
  ELSIF _MDocKind = md_VAU THEN RETURN Str.Item("VAU|", "|", NoLatin);
  ELSIF _MDocKind = md_SpB THEN RETURN Str.Item("SpB|", "|", NoLatin);
  ELSIF _MDocKind = md_PCh THEN RETURN Str.Item("PCh|", "|", NoLatin);
  ELSIF _MDocKind = md_RCh THEN RETURN Str.Item("RCh|", "|", NoLatin);
  ELSIF _MDocKind = md_PIO THEN RETURN Str.Item("IAE|", "|", NoLatin);
  ELSIF _MDocKind = md_VOD THEN RETURN Str.Item("VOD|", "|", NoLatin);
  ELSIF _MDocKind = md_IOD THEN RETURN Str.Item("IOD|", "|", NoLatin);
  ELSIF _MDocKind = md_ZMC THEN RETURN Str.Item("ZMC|", "|", NoLatin);
  ELSE  L_General.CallUs(0);
  END;
 END {MDocKindNick};

 PUBLIC PROCEDURE MDocStorage(): LIKE(Storage.Storage);
 BEGIN
  RETURN MDoc.Storage;
 END {MDocStorage};

 PUBLIC PROCEDURE MDocStorageName(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF ~!MDoc.Storage THEN
   SAVE(Storage);
   CONFORM(MDoc, Storage);
   Result:=Storage.Name;
   RESTORE(Storage);
  ELSE
   Result:="";
  END;
  RETURN Result;
 END {MDocStorageName};

 PUBLIC PROCEDURE PrintMDocImmediately(): SCAL[3];
 BEGIN
  CONFORM(MDoc, MDocKind);
  IF MDocKind.ImdPrint = mdkip_GetFromStock THEN
   RETURN ~!MDoc.Storage & P_Storage.ImdPrint(MDoc.Storage, SYSDATE());
  ELSE
   RETURN MDocKind.ImdPrint;
  END;
 END {PrintMDocImmediately};

 PRIVATE PROCEDURE ptlkamd_UsualCond(): SCAL[2];
 BEGIN
  RETURN (MDoc.MDocKind # md_ADg);
 END {ptlkamd_UsualCond};

 PUBLIC PROCEDURE IsKeyAssChangeResponsibleMDocKind(trgMDocKind: LIKE(MDoc.MDocKind)): SCAL[2];
 BEGIN
  RETURN KeyAssetsMDoc(trgMDocKind) &
         ((trgMDocKind # md_ADg) & (trgMDocKind # md_ADo) & (trgMDocKind # md_APO) & (trgMDocKind # md_APc));
 END {IsKeyAssChangeResponsibleMDoc};

 PUBLIC PROCEDURE ptlkamd_ChangeResponsibleCond(): SCAL[2];
 BEGIN
  RETURN IsKeyAssChangeResponsibleMDocKind(MDoc.MDocKind);
 END {ptlkamd_ChangeResponsibleCond};

 PUBLIC PROCEDURE _PosToLastKeyAssMDoc(_Math: LIKE(Math.Math);
                                       D    : DATE;
                                       Cond : PROC): SCAL[2];
  VAR
   _MDocKind: LIKE(MDoc.MDocKind);
   _MDoc: LIKE(MDoc.MDoc);
   _Date: LIKE(MDoc.Date);
 BEGIN
  SETEMPTY(_MDoc);
  _Date:=L_DatTim.MINDATE();
  _MDocKind:=0;
  SELECT(MDocList, Math, , _Math);
  WHILE OCCURE(MDocList) DO
   IF KeyAssetsMDoc(MDocList.MDocKind) THEN
    CONFORM(MDocList, MDoc);
    IF (MDoc.Status = st_Passed) & (MDoc.Date <= D) & Cond() &
       ((MDoc.Date > _Date) |
        ((MDoc.Date = _Date) & (MDoc.MDocKind > _MDocKind)) |
        ((MDoc.Date = _Date) & (MDoc.MDocKind = _MDocKind) & (MDoc.MDoc > _MDoc))) THEN
     _Date    :=MDoc.Date;
     _MDocKind:=MDoc.MDocKind;
     _MDoc    :=MDoc.MDoc;
    END;
   END;
   NEXT(MDocList);
  END;
  IF ~!_MDoc THEN
   SEARCH(MDoc, MDoc, , _MDocKind, _MDoc);
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {_PosToLastKeyAssMDoc};

 PUBLIC PROCEDURE PosToLastKeyAssMDoc(_Math: LIKE(Math.Math); D: DATE): SCAL[2];
 BEGIN
  RETURN _PosToLastKeyAssMDoc(_Math, D, PROCREF(ptlkamd_UsualCond));
 END {PosToLastKeyAssMDoc};

 PUBLIC PROCEDURE PosToLastKeyAssChangeResponsibleMDoc(_Math: LIKE(Math.Math); D: DATE): SCAL[2];
 BEGIN
  RETURN _PosToLastKeyAssMDoc(_Math, D, PROCREF(ptlkamd_ChangeResponsibleCond));
 END {PosToLastKeyAssChangeResponsibleMDoc};

 PUBLIC PROCEDURE extInsMDocList(curMath   : LIKE(MDocList.Math);
                                 curMMode  : LIKE(MDocList.MMode);
                                 curVATMode: LIKE(MDocList.VATMode);
                                 curMUNbr  : LIKE(MDocList.MUNbr);
                                 curQnt    : LIKE(MDocList.Qnt);
                                 curSum    : LIKE(MDocList.Sum);
                                 curVAT    : LIKE(MDocList.VAT));
 BEGIN
  IF (curQnt#0) | (curSum#0) | (curVAT#0) | KeyAssetsMDoc(MDoc.MDocKind) THEN
   DEFAULT(MDocList);
   MDocList.MDocKind:=MDoc.MDocKind;
   MDocList.MDoc    :=MDoc.MDoc;
   SETEMPTY(MDocList.MDLNbr);
   MDocList.Math    :=curMath;
   MDocList.Date    :=MDoc.Date;
   MDocList.MMode   :=curMMode;
   MDocList.VATMode :=curVATMode;
   MDocList.MUNbr   :=curMUNbr;
   MDocList.Sum     :=curSum;
   MDocList.Qnt     :=curQnt;
   MDocList.VAT     :=curVAT;
   INSERT(MDocList);
   IF (MDocList.Sum + MDocList.VAT) # 0 THEN
    INC(MDoc.Total, MDocList.Sum + MDocList.VAT);
    REPLACE(MDoc);
   END;
  END;
 END {extInsMDocList};

 PUBLIC PROCEDURE InsMDocList(curMath   : LIKE(MDocList.Math);
                              curMMode  : LIKE(MDocList.MMode);
                              curVATMode: LIKE(MDocList.VATMode);
                              curQnt    : LIKE(MDocList.Qnt);
                              curSum    : LIKE(MDocList.Sum);
                              curVAT    : LIKE(MDocList.VAT));
 BEGIN
  extInsMDocList(curMath, curMMode, curVATMode, 000, curQnt, curSum, curVAT);
 END {InsMDocList};

 PUBLIC PROCEDURE InsMDocList_wVAT(curMath   : LIKE(MDocList.Math);
                                   curMMode  : LIKE(MDocList.MMode);
                                   curVATMode: LIKE(MDocList.VATMode);
                                   curQnt    : LIKE(MDocList.Qnt);
                                   curSum    : LIKE(MDocList.Sum));
 BEGIN
  InsMDocList(curMath, curMMode, curVATMode, curQnt, curSum, L_Acnt.GetExclMathVAT(curMath, MDoc.Date, curSum));
 END {InsMDocList_wVAT};

 PUBLIC PROCEDURE GetMDocNetto(): NUMERIC[2];
  VAR
   Netto: NUMERIC[2];
 BEGIN
  Netto:=0;
  CONFORM(MDoc, MDocList);
  WHILE OCCURE(MDocList) DO
   INC(Netto, MDocList.Sum);
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
  RETURN Netto;
 END {GetMDocNetto};

 PUBLIC PROCEDURE AccessMDoc();
 BEGIN
  L_General.Assert(ACCESS(MDoc), " ⠭ ⮢ 㬥");
 END {AccessMDoc};

 PRIVATE PROCEDURE StandOnByMDocList(Entity: STRING[]);
 BEGIN
  IF    ~!MDocList.^Entity THEN
   L_General.CallUs(!MDoc.^Entity);
   CONFORM(MDocList, ^Entity);
  ELSIF ~!MDoc.^Entity THEN
   CONFORM(MDoc, ^Entity);
  ELSE
   SELECT(^Entity, ^Entity, , "");
  END;
 END {StandOnByMDocList};

 PUBLIC PROCEDURE soByMDL_Math();
 BEGIN
  StandOnByMDocList("Math");
 END {soByMDL_Math};

 PRIVATE PROCEDURE soByMDL_CostItem();
 BEGIN
  StandOnByMDocList("CostItem");
 END {soByMDL_CostItem};

 PRIVATE PROCEDURE soByMDL_Contract();
 BEGIN
  StandOnByMDocList("Contract");
 END {soByMDL_Contract};

 PUBLIC PROCEDURE CheckPassed();
 BEGIN
  L_General.Assert(MDoc.Status=st_Passed, "  믮  㬥⮢  ﭨ '஢'");
 END {CheckPassed};

 PUBLIC PROCEDURE Insert_MDoc();
 BEGIN
  MDoc.convId:=convertionId;
  MDoc.DoneDTS:=L_XDoc.GetSysDTS();
  INSERT(MDoc);
  MDoc.XDocId:=L_XDoc.curXDocId(L_XDoc.xdt_MDoc);
  REPLACE(MDoc);
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc, L_XDoc.action_AutoBuild);
 END {Insert_MDoc};

 PUBLIC PROCEDURE GetMDocMyFirm(): P_Firm.tMyFirm;
  VAR
   Result: P_Firm.tMyFirm;
 BEGIN
  IF ~P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
   Result:=P_Firm.DefineMyFirm();
  ELSE
   SETEMPTY(Result);
   IF    ~!MDoc.Contract THEN
    SAVE(Contract);
    CONFORM(MDoc, Contract);
    Result:=Contract.MyFirm;
    RESTORE(Contract);
   END;
   IF ~!MDoc.Storage THEN
    SAVE(Storage);
    CONFORM(MDoc, Storage);
    IF ~!Result THEN
     L_General.Assert(Storage.MyFirm = Result, " ࣠樨    ");
    ELSE
     Result:=Storage.MyFirm;
    END;
    RESTORE(Storage);
    IF ~!MDoc.Storage2 THEN
     SAVE(Storage2);
     CONFORM(MDoc, Storage2);
     L_General.Assert(Storage2.MyFirm = Result, " ࣠樨    2");
     RESTORE(Storage2);
    END;
   END;
   IF ~!MDoc.CostItem THEN
    SAVE(CostItem);
    CONFORM(MDoc, CostItem);
    IF ~!Result THEN
     L_General.Assert(CostItem.MyFirm = Result, " ࣠樨    ");
    ELSE
     Result:=CostItem.MyFirm;
    END;
    RESTORE(CostItem);
   END;
   IF ~!MDoc.BoxNbr THEN
    IF ~!Result THEN
     L_General.Assert(L_Car.GetCarMyFirm(MDoc.BoxNbr, MDoc.Date) = Result, " ࣠樨    ࠦ");
    ELSE
     Result:=L_Car.GetCarMyFirm(MDoc.BoxNbr, MDoc.Date);
    END;
   END;
   SELECT(MDocList, MDoc, , MDoc.MDocKind, MDoc.MDoc);
   WHILE OCCURE(MDocList) DO
    IF ~!MDocList.CostItem THEN
     SAVE(CostItem);
     CONFORM(MDocList, CostItem);
     IF ~!Result THEN
      L_General.Assert(CostItem.MyFirm = Result, "  ࣠樨. . ᯨ᮪  ");
     ELSE
      Result:=CostItem.MyFirm;
     END;
     RESTORE(CostItem);
    END;
    IF ~!MDocList.Math THEN
     SAVE(Math);
     CONFORM(MDocList, Math);
     IF Math.MathKind = L_MathR.mathk_KeyAs THEN
      IF ~!Result THEN
       L_General.Assert(Math.MyFirm = Result, "  ࣠樨. . ᯨ᮪  ");
      ELSE
       Result:=Math.MyFirm;
      END;
     END;
     RESTORE(Math);
    END;
    IF ~!MDocList.Contract THEN
     SAVE(Contract);
     CONFORM(MDocList, Contract);
     IF ~!Result THEN
      L_General.Assert(Contract.MyFirm = Result, "  ࣠樨. . ᯨ᮪  ");
     ELSE
      Result:=Contract.MyFirm;
     END;
     RESTORE(Contract);
    END;
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)
   IF (MDoc.MDocKind = md_ZMC) & !Result THEN
    Result:=P_Firm.DefineMyFirm();
   END;
   L_General.Assert(~!Result, " । ' ࣠'. , 㬥 ଫ");
  END;
  RETURN Result;
 END {GetMDocMyFirm};

 PUBLIC PROCEDURE E_ResetMDocNumberingFromYearBeg(D: DATE): SCAL[2];
 BEGIN
  IF D >= 01\01\2008 THEN
   IF (MDoc.MDocKind # md_DPr) & (MDoc.MDocKind # md_DPk) THEN
    RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Pmnt.ResetMDocNumberingFromYearBeg), 0);
   END;
  END;
  RETURN 0;
 END {E_ResetMDocNumberingFromYearBeg};

 PUBLIC PROCEDURE E_FillMDocSrcNbr(): tFillMDocSrcNbr;
  VAR
   Default: tFillMDocSrcNbr;
   Local  : PROC;
 BEGIN
  IF    MDocKind.MDocKind = md_VAU THEN
   Default:=fmdsn_YesAndNotAllowEdit;
  ELSIF IsPrchMDocKind() THEN
   Default:=fmdsn_No;
  ELSIF MDocKind.MDocKind = md_NPr THEN
   Default:=fmdsn_No;
  ELSIF MDocKind.MDocKind = md_ASp THEN
   Default:=fmdsn_Yes;
  ELSIF MDocKind.MDocKind = md_AVb THEN
   Default:=fmdsn_Yes;
  ELSIF KeyAssetsMDoc(MDocKind.MDocKind) THEN
   Default:=fmdsn_YesAndNotAllowEdit;
  ELSIF L_XDoc.ExtractXDocType(L_XDoc.GetBaseOnXDocId(L_XDoc.curXDocId(L_XDoc.xdt_MDoc))) = L_XDoc.xdt_FlRec THEN
   Default:=fmdsn_NoAndNotAllowEdit
  ELSE
   Default:=fmdsn_YesAndNotAllowEdit;
  END;
  Local:=PROCREF(E_Pmnt.FillMDocSrcNbr);
  IF ~!Local THEN
   RETURN Local(Default);
  ELSE
   RETURN Default;
  END;
 END {E_FillMDocSrcNbr};

 PRIVATE PROCEDURE mfNbrYearPart(D: DATE): LIKE(MDoc.mfNbr);
 BEGIN
  RETURN (L_DatTim.YEAR(D)-2007) * 100000;
 END {mfNbrYearPart};

 PUBLIC PROCEDURE mfNbr_woYearPart(_mfNbr: LIKE(MDoc.mfNbr)): LIKE(MDoc.mfNbr);
 BEGIN
  RETURN _mfNbr MOD 100000;
 END {mfNbr_woYearPart};

 PRIVATE PROCEDURE fmdc_IsSignificantMDoc(_MyFirm: P_Firm.tMyFirm): SCAL[2];
 BEGIN
  IF OCCURE(MDoc) THEN
   IF (MDoc.Status = st_Passed) & (MDoc.MyFirm = _MyFirm) THEN
    CONFORM(MDoc, MDocKind);
    RETURN MDocKind.Activity;
   END;
  ELSE
   L_General.CallUs(~L_AR.DatabaseIsTransparent());
  END;
  RETURN 0;
 END {fmdc_IsSignificantMDoc};

 PUBLIC PROCEDURE fmdc_CheckIsSignificantMDoc();
 BEGIN
  IF ~fmdc_IsSignificantMDoc(MDoc.MyFirm) THEN
   L_StdFrm.BlueStop(" "+MDocStr(MDoc.MDocKind, MDoc.MDoc)+"   㬥⮬   |    楯窥 '㬥⮢  묨 '");
  END;
 END {fmdc_CheckIsSignificantMDoc};

 PRIVATE PERMANENT VAR
  fmdc_List: OBJECT;

 PRIVATE PROCEDURE fmdc_ListItem(s: STRING[][]; i: NUMERIC[0]): STRING[];
 BEGIN
  RETURN s[i];
 END {fmdc_ListItem};

 PRIVATE PROCEDURE fmdc_LT(curDate: DATE; curQueue: fmdc_tQueue; curDoneDTS: LIKE(MDoc.DoneDTS);
                           trgDate: DATE; trgQueue: fmdc_tQueue; trgDoneDTS: LIKE(MDoc.DoneDTS)): SCAL[2];
 BEGIN
  IF    (curDate < trgDate) THEN RETURN 1;
  ELSIF (curDate = trgDate) THEN
   IF    (curQueue < trgQueue) THEN RETURN 1;
   ELSIF (curQueue = trgQueue) THEN
    RETURN (curDoneDTS < trgDoneDTS);
   END;
  END;
  RETURN 0;
 END {fmdc_LT};

 PRIVATE PROCEDURE fmth_Add(trgMath: LIKE(Math.Math); trgQueue: fmdc_tQueue; trgTermDate: DATE);
  VAR
   curTermDate: DATE;
 BEGIN
IF ~L_Acnt.E_SetMathPriceOnline(MDoc.Date) THEN
 SEARCH(Math, Math, , trgMath);
 IF Math.MathType = L_MathR.mtyp_Fuels THEN
  RETURN;
 END;
END;
  SAVE(_fmth);
  IF ~SELECT(_fmth, Math, trgMath) | fmdc_LT(MDoc.Date, trgQueue, MDoc.DoneDTS, _fmth.Date, _fmth.Queue, _fmth.DoneDTS) THEN
   IF OCCURE(_fmth) THEN
    _fmth.Actual:=0;
    REPLACE(_fmth);
   END;
   SETEMPTY(_fmth._fmth);
   _fmth.Math    :=trgMath;
   _fmth.Date    :=MDoc.Date;
   _fmth.Queue   :=trgQueue;
   _fmth.Actual  :=1;
   _fmth.DoneDTS :=MDoc.DoneDTS;
   _fmth.TermDate:=trgTermDate;
   INSERT(_fmth);
  ELSIF ~!trgTermDate THEN
   _fmth.TermDate:=trgTermDate;
   REPLACE(_fmth);
  END;
  RESTORE(_fmth);
 END {fmth_Add};

 PUBLIC PROCEDURE fmdc_GetQueue(): fmdc_tQueue;
 BEGIN
  IF ~!MDoc.Storage THEN
   CONFORM(MDoc, MDocKind);
   IF IsExternalMDocKind() & MDocKind.Activity & P_Storage.DontCheckXCalcRest(MDoc.Storage, MDoc.Date) THEN
    RETURN 0;
   END;
  END;
  RETURN 1;
 END {fmdc_GetQueue};

 PRIVATE PROCEDURE fmdc_Add(IsCurMD: SCAL[2]; trgQueue: fmdc_tQueue);
 BEGIN
  IF ~SEARCH(_fmdc, MDoc, MDoc.MDocKind, MDoc.MDoc) THEN
   _fmdc.MDocKind:=MDoc.MDocKind;
   _fmdc.MDoc    :=MDoc.MDoc;
   _fmdc.Date    :=MDoc.Date;
   _fmdc.Queue   :=trgQueue;
   _fmdc.IsCurMD :=IsCurMD;
   _fmdc.Done    :=MDoc.Done;
   _fmdc.DoneDTS :=MDoc.DoneDTS;
   INSERT(_fmdc);
  END;
 END {fmdc_Add};

 PUBLIC PROCEDURE fmdc_Init();
 BEGIN
  IF !DATABASE.Get().Tables("_fmth") THEN
   CREATE_TABLE(_fmth, , "᮪ ");
   CREATE_FIELD(_fmth, _fmth,    SCAL[1e10],         , , , "浪 ");
   CREATE_FIELD(_fmth, Math,     LIKE(Math.Math),    , , , " ");
   CREATE_FIELD(_fmth, Date,     DATE,               , , , " ࢮ 㬥");
   CREATE_FIELD(_fmth, TermDate, DATE,               , , , " ᫥ 㬥");
   CREATE_FIELD(_fmth, Queue,    fmdc_tQueue,        , , , "। ࠡ⪨ ", "0-࠭;1-");
   CREATE_FIELD(_fmth, Actual,   SCAL[2],            , , , "  㠫쭠");
   CREATE_FIELD(_fmth, DoneDTS,  LIKE(MDoc.DoneDTS), , , , "/६ ࠡ⪨");
 
   CREATE_INDEX(_fmth, _fmth, AUTOINCR, , , _fmth);
   CREATE_INDEX_AND_LINK(_fmth, Math, UNIQUE, Math, Math, USER, , , Math, Date, Queue, DoneDTS);
   SET_VERSION_OF_TABLE(_fmth, 000);

   CREATE_TABLE(_fmdc, "", "᮪ 㬥⮢", "");
   CREATE_FIELD(_fmdc, MDocKind, LIKE(MDoc.MDocKind), , , , " 㬥⮢");
   CREATE_FIELD(_fmdc, MDoc,     LIKE(MDoc.MDoc),     , , , " 㬥");
   CREATE_FIELD(_fmdc, Date,     LIKE(MDoc.Date),     , , , " 㬥");
   CREATE_FIELD(_fmdc, Queue,    fmdc_tQueue,         , , , "। ࠡ⪨ ", "0-࠭;1-");
   CREATE_FIELD(_fmdc, IsCurMD,  SCAL[2],             , , , " ⥪騩 㬥");
   CREATE_FIELD(_fmdc, Done,     SCAL[2],             , , , "ਧ ࠡ⪨");
   CREATE_FIELD(_fmdc, DoneDTS,  LIKE(MDoc.DoneDTS),  , , , "/६ ࠡ⪨");
 
   CREATE_INDEX(_fmdc, _fmdc, UNIQUE, , , Date, Queue, DoneDTS);
   CREATE_INDEX(_fmdc, Done,  UNIQUE, , , Done, Date, Queue, DoneDTS);
   CREATE_INDEX(_fmdc, IsCurMD, PLURAL, , , IsCurMD, Date, Queue, DoneDTS);
   CREATE_INDEX_AND_LINK(_fmdc, MDoc, UNIQUE, MDoc, MDoc, USER, , , MDocKind, MDoc);
   SET_VERSION_OF_TABLE(_fmdc, 001);
  END;
  L_AFM.CreateTemp("_fmth");
  L_AFM.CreateTemp("_fmdc");
 END {fmdc_Init};

 PRIVATE PROCEDURE fmdc_wConditionalFurtherProceed(): SCAL[2];
 BEGIN
  RETURN L_General.IsAdmin();
 END {fmdc_wConditionalFurtherProceed};

 PRIVATE PROCEDURE int_fmdc_MakeList(DoneOnly, CheckOnly: SCAL[2]);
  VAR
   curQueue : fmdc_tQueue;
   curMyFirm: P_Firm.tMyFirm;
 BEGIN
  curQueue :=fmdc_GetQueue();
  fmdc_Add(1, curQueue);

  IF fmdc_IsSignificantMDoc(MDoc.MyFirm) THEN
   APP.Get().NewPrompt("᮪ ᫥ ");

   curMyFirm  :=MDoc.MyFirm;

   SAVE(MDoc);
   SETSEL(MDocList, MDoc, MDoc.MDocKind, MDoc.MDoc);
   FOR_EACH MDocList DO
    IF ~!MDocList.Math THEN
     fmth_Add(MDocList.Math, curQueue, EMPTYOF(DATE));
    END;
   END; (* FOR_EACH MDocList *)

   SELECT(_fmth, _fmth);
   WHILE OCCURE(_fmth) DO (*ਭ樯쭮 WHILE,   FOR_EACH, ⮬   横 ⠢  _fmth. 0104967 15.09.2014 19:35:50 POLAK\Bor*)
    IF _fmth.Actual THEN
     SETSEL(MDocList, Math, _fmth.Math);
     SRCINSEL(MDocList, GE, , _fmth.Date);
     WHILE OCCURE(MDocList) & (~DoneOnly | (MDocList.Date <= _fmth.TermDate)) DO
      PROMPT(" " + _fmth.Math + ", " + MDocStr(MDocList.MDocKind, MDocList.MDoc));
      IF ~SEARCH(_fmdc, MDoc, MDocList.MDocKind, MDocList.MDoc) THEN
       CONFORM(MDocList, MDoc);
       curQueue:=fmdc_GetQueue();
       IF fmdc_IsSignificantMDoc(curMyFirm) & ~fmdc_LT(MDoc.Date, curQueue, MDoc.DoneDTS, _fmth.Date, _fmth.Queue, _fmth.DoneDTS) THEN
        fmdc_Add(0, curQueue);
        IF CheckOnly THEN (* ஢ન 筮 ࢮ  . 室  楤*)
         LAST(MDocList);
         LAST(_fmth);
        ELSE
         SAVE(MDocList);
         SETSEL(MDocList, MDoc, MDoc.MDocKind, MDoc.MDoc);
         FOR_EACH MDocList DO
          IF DoneOnly & ~MDoc.Done THEN
           fmth_Add(MDocList.Math, curQueue, MDoc.Date);
          ELSE
           fmth_Add(MDocList.Math, curQueue, EMPTYOF(DATE));
          END;
         END; (* FOR_EACH MDocList *)
         RESTORE(MDocList);
        END;
       END;
      END;
      NEXT(MDocList);
     END; (* WHILE OCCURE(MDocList) ... *)
    END; (* IF _fmth.Actual ... *)
    NEXT(_fmth);
   END; (* WHILE OCCURE(_fmth) ... *)

   RESTORE(MDoc);
  END; (* IF fmdc_IsSignificantMDoc() ... *)
 END {int_fmdc_MakeList};

 PUBLIC PROCEDURE fmdc_MakeList(DoneOnly: SCAL[2]);
 BEGIN
  int_fmdc_MakeList(DoneOnly, 0);
 END {fmdc_MakeList};

 PUBLIC PROCEDURE fmdc_GetNeighborMDoc(trgMath: LIKE(Math.Math); Next: SCAL[2]): L_XDoc.tXDocId;
  VAR
   curMyFirm : LIKE(MyFirm.MyFirm);
   ngbDate,
   curDate   : DATE;
   ngbQueue,
   curQueue  : fmdc_tQueue;
   ngbDoneDTS,
   curDoneDTS: LIKE(MDoc.DoneDTS);
   curXDocId,
   Result    : L_XDoc.tXDocId;
 BEGIN
  SETEMPTY(Result);
  curMyFirm :=MDoc.MyFirm;
  curDate   :=MDoc.Date;
  curQueue  :=fmdc_GetQueue();
  curDoneDTS:=MDoc.DoneDTS;
  curXDocId :=MDoc.XDocId;
  SAVE(MDocList);
  SAVE(MDoc);
  SETSEL(MDocList, Math, trgMath);
  IF Next THEN
   SRCINSEL(MDocList, GE, , curDate);
  ELSE
   SRCINSEL(MDocList, LE, , curDate);
  END;
  LOOP
   IF ~OCCURE(MDocList) THEN
    EXIT;
   ELSIF ~!Result & (MDocList.Date # ngbDate) THEN
    EXIT;
   ELSIF L_XDoc.XDocId(L_XDoc.xdt_MDoc, MDocList.MDocKind, MDocList.MDoc) # curXDocId THEN
    CONFORM(MDocList, MDoc);
    IF fmdc_IsSignificantMDoc(curMyFirm) THEN
     IF (Next = ~fmdc_LT(MDoc.Date, fmdc_GetQueue(), MDoc.DoneDTS, curDate, curQueue, curDoneDTS)) THEN
      IF !Result |
         (Next = fmdc_LT(MDoc.Date, fmdc_GetQueue(), MDoc.DoneDTS, ngbDate, ngbQueue, ngbDoneDTS)) THEN
       Result    :=MDoc.XDocId;
       ngbDate   :=MDoc.Date;
       ngbQueue  :=fmdc_GetQueue();
       ngbDoneDTS:=MDoc.DoneDTS;
      END;
     END;
    END; (* IF fmdc_IsSignificantMDoc(curMyFirm) ... *)
   END; (* IF ~OCCURE(MDocList) ... *)
   IF Next THEN
    NEXT(MDocList);
   ELSE
    PREV(MDocList);
   END;
  END; (* LOOP ... *)
  RESTORE(MDoc);
  RESTORE(MDocList);
  RETURN Result;
 END {fmdc_GetNeighborMDoc};

 PUBLIC PROCEDURE fmdc_HasFollowingMDoc(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  fmdc_Init();
  int_fmdc_MakeList(0, 1);
  Result:=SELECT(_fmdc, IsCurMD, 0);
  fmdc_DeInit();
  RETURN Result;
 END {fmdc_HasFollowingMDoc};

 PRIVATE PROCEDURE fmdc_RollBackFollowMDoc();
 BEGIN
  SETSEL(_fmdc, Done, 1);
  IF LAST(_fmdc) THEN
   APP.Get().NewPrompt("⪠ ᫥ ");
   TABLE.Get("Staff").AccessDataMode:=adm_SOFT;
 
   WHILE OCCURE(_fmdc) DO
    CONFORM(_fmdc, MDoc);
    PROMPT(MDocStr(MDoc.MDocKind, MDoc.MDoc));
    IF ~_fmdc.IsCurMD THEN
     CALL(MDoc.InternalStreamMakeUnDone());
    END;
    PREV(_fmdc);
   END; (* WHILE OCCURE(_fmdc) ... *)
  END; (* IF LAST(_fmdc) ... *)
 END {fmdc_RollBackFollowMDoc};

 PRIVATE PROCEDURE fmdc_intProceedMDoc(_Done, Stream: SCAL[2]);
  VAR
   i  : NUMERIC[0];
   All: SCAL[2];
   curMDocKind : LIKE(MDoc.MDocKind);
   curMDoc     : LIKE(MDoc.MDoc);
   aftMDocKind : LIKE(MDoc.MDocKind);
   aftMDoc     : LIKE(MDoc.MDoc);
   curQueue    : fmdc_tQueue;
 BEGIN
  APP.Get().NewPrompt(L_Str.PoolItem("⪠|ࠡ⪠", _Done) + " ");
  TABLE.Get("Staff").AccessDataMode:=adm_SOFT;

  curMDocKind:=MDoc.MDocKind;
  curMDoc    :=MDoc.MDoc;
  SAVE(MDoc);

  IF ~_Done & ~Stream & SELECT(_fmdc, IsCurMD, 1) & CHANGESEL(_fmdc, _fmdc) & NEXT(_fmdc) THEN
   TOOLTIP("㤥 믮"+L_Str.PoolItem(" ⪠| ࠡ⪠", _Done)+" ᫥ 㬥⮢");  (*७ TOOLTIP  fmdc_RollBackFollowMDoc   ⠭ ମ 믮 ணࠬ 0099426 03.10.2013 18:41:47 POLAK\Bor*)
  END;
  fmdc_RollBackFollowMDoc();

  SELECT(_fmdc, IsCurMD, , 1);
  CONFORM(_fmdc, MDoc);
  PROMPT(MDocStr(MDoc.MDocKind, MDoc.MDoc));
  IF _Done THEN
   IF ~Stream THEN
    CALL(MDoc.InternalSingleMakeDone());
   ELSE
    CALL(MDoc.InternalStreamMakeDone());
   END;
  ELSE
   IF ~Stream THEN
    CALL(MDoc.InternalSingleMakeUnDone());
   ELSE
    CALL(MDoc.InternalStreamMakeUnDone());
   END;
  END;

  L_General.CreatePermanentDictionary(fmdc_List);

  All:=0;
  IF _Done & ~Stream & ((SELECT(_fmdc, IsCurMD, 1) & CHANGESEL(_fmdc, _fmdc) & NEXT(_fmdc)) |
                       (fmdc_List.Exists("1"+curMDocKind+curMDoc) & (fmdc_List.Count > 1))) THEN
   IF    ~fmdc_wConditionalFurtherProceed() THEN
    TOOLTIP("㤥 믮"+L_Str.PoolItem(" ⪠| ࠡ⪠", _Done)+" ᫥ 㬥⮢");
    All:=1;
   ELSIF L_StdFrm.Alternative("믮 ࠡ ᫥ 㬥⮢?") THEN
    All:=1;
   END;
  END;

  IF ~_Done & ~Stream THEN
   fmdc_List.RemoveAll();
   SETSEL(_fmdc, Done, 1);
   FOR_EACH _fmdc DO
    fmdc_List.Add(""+_fmdc.IsCurMD + _fmdc.MDocKind + _fmdc.MDoc, L_XDoc.XDocId(L_XDoc.xdt_MDoc, _fmdc.MDocKind, _fmdc.MDoc));
   END; (* FOR_EACH _fmdc *)
  ELSIF All & _Done & fmdc_List.Exists("1"+curMDocKind+curMDoc) THEN
   i:=fmdc_List.Count;
   IF i > 1 (* ᫨  樨 1 ,    㯥 *) THEN
    WHILE i > 0 DO
     DEC(i);
     DecodeMDocId(fmdc_ListItem(fmdc_List.Items(), i), aftMDocKind, aftMDoc);
     IF ~SEARCH(_fmdc, MDoc, aftMDocKind, aftMDoc) THEN
      SEARCH(MDoc, MDoc, , aftMDocKind, aftMDoc);
      curQueue:=fmdc_GetQueue();
      fmdc_Add(0, curQueue);
     END;
    END; (* WHILE i > 0 ... *)
   END; (* IF i > 1 ... *)
  END; (* IF ~_Done & ... *)

  IF All THEN
   L_General.CallUs(_Done);

   fmdc_MakeList(0);

   SELECT(_fmdc, IsCurMD, , 0);
   WHILE OCCURE(_fmdc) DO
    CONFORM(_fmdc, MDoc);
    PROMPT(MDocStr(MDoc.MDocKind, MDoc.MDoc));
    IF _Done THEN
     IF _fmdc.IsCurMD & ~Stream THEN
      CALL(MDoc.InternalSingleMakeDone());
     ELSE
      CALL(MDoc.InternalStreamMakeDone());
     END;
     NEXT(_fmdc);
    ELSE
     IF _fmdc.IsCurMD & ~Stream THEN
      CALL(MDoc.InternalSingleMakeUnDone());
     ELSE
      CALL(MDoc.InternalStreamMakeUnDone());
     END;
     PREV(_fmdc);
    END;
   END; (* WHILE OCCURE(_fmdc) ... *)
  END;

  RESTORE(MDoc);
 END {fmdc_intProceedMDoc};

 PUBLIC PROCEDURE fmdc_ProceedMDoc(_Done, Stream: SCAL[2]);
 BEGIN
  fmdc_Init();
  fmdc_MakeList(1);

  fmdc_intProceedMDoc(_Done, Stream);

  fmdc_DeInit();
 END {fmdc_ProceedMDoc};

 PUBLIC PROCEDURE fmdc_DeInit();
 BEGIN
  L_AFM.AF_PurgeTemp("_fmth");
  L_AFM.AF_PurgeTemp("_fmdc");
 END {fmdc_DeInit};

 PRIVATE PROCEDURE _fmdc_Show(Title: STRING[]; ShowCurrent: SCAL[2]): L_XDoc.tXDocId;
  VAR
   XDocIds,
   List : STRING[];
   i, j: NUMERIC[0];
 BEGIN
  List:="";
  XDocIds:="";
  i:=0;
  j:=0;

  SETSEL(_fmdc, _fmdc);
  FOR_EACH _fmdc DO
   PROMPT("⮢ ᯨ᪠: " + MDocStr(_fmdc.MDocKind, _fmdc.MDoc));
   IF ShowCurrent | ~_fmdc.IsCurMD THEN
    IF ShowCurrent THEN
     IF _fmdc.IsCurMD THEN
      List:=List + "> ";
      j:=i;
     ELSE
      List:=List + "  ";
     END;
    END;
    XDocIds:=XDocIds + L_XDoc.XDocId(L_XDoc.xdt_MDoc, _fmdc.MDocKind, _fmdc.MDoc)+"|";
    List:=List + MDocStr(_fmdc.MDocKind, _fmdc.MDoc) + " " + L_DatTim.DateStr(_fmdc.Date)+" "+L_Str.PoolItem("-|", _fmdc.Done)+" ("+L_Str.DTSStr(_fmdc.DoneDTS)+ ")" + L_Str.PoolItem(" !|  ", _fmdc.Queue) + "|";
   END;
   INC(i);
  END; (* FOR_EACH _fmdc *)
  fmdc_DeInit();
  j:=L_StdFrm.ShowListAsMenu_wInit(List, Title, j);
  RETURN L_Str.PoolItem(XDocIds, j);
 END {_fmdc_Show};

 PUBLIC PROCEDURE fmdc_ChangeOnDatePos();
  VAR
   curDoneDTS,
   trgDoneDTS: LIKE(MDoc.DoneDTS);
   CurMDocStr: STRING[];
   CurXDocId,
   _XDocId   : L_XDoc.tXDocId;
   curMyFirm : P_Firm.tMyFirm;
   Need: SCAL[2];
 BEGIN
  Need:=0;
  fmdc_Init();
  curDoneDTS:=MDoc.DoneDTS;
  curMyFirm :=MDoc.MyFirm;
  CurXDocId :=L_XDoc.XDocId(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc);
  CurMDocStr:=MDocStr(MDoc.MDocKind, MDoc.MDoc);
  SAVE(MDoc);
  fmdc_Add(1, fmdc_GetQueue());

  SETSEL(MDocList, MDoc, MDoc.MDocKind, MDoc.MDoc);
  FOR_EACH MDocList DO
(*  FOR_EACH SAVE  㦥 -   ᡨ
   SAVE(MDocList);
*)
   SETSEL(MDocList, Math, MDocList.Math, MDocList.Date);
   FOR_EACH MDocList DO
    IF ~SEARCH(_fmdc, MDoc, MDocList.MDocKind, MDocList.MDoc) THEN
     CONFORM(MDocList, MDoc);
     IF fmdc_IsSignificantMDoc(curMyFirm) THEN
      fmdc_Add(0, fmdc_GetQueue());
      Need:=1;
     END;
    END;
   END; (* FOR_EACH MDocList *)
(*
   RESTORE(MDocList);
*)
  END; (* FOR_EACH MDocList *)

  IF ~Need THEN
   L_StdFrm.BlueHalt("  易 㬥⮢  ");
  END;

  _XDocId:=_fmdc_Show(" । 㬥⮢  ", 1);
  L_General.Assert(_XDocId # CurXDocId, " ⥪騩 㬥");

  L_XDoc.PositionOnXDoc(_XDocId);
  L_StdFrm.Choice(" 冷 ᫥ 㬥⮢ "+CurMDocStr+"  "+MDocStr(MDoc.MDocKind, MDoc.MDoc));
  trgDoneDTS:=MDoc.DoneDTS;
  IF trgDoneDTS < curDoneDTS THEN
   CALL(MDoc.SingleMakeUnDone());
   RESTORE(MDoc);
  ELSE
   RESTORE(MDoc);
   CALL(MDoc.SingleMakeUnDone());
  END;
  MDoc.DoneDTS:=trgDoneDTS;
  REPLACE(MDoc);
  SAVE(MDoc);
  L_XDoc.PositionOnXDoc(_XDocId);
  MDoc.DoneDTS:=curDoneDTS;
  REPLACE(MDoc);
  RESTORE(MDoc);
 END {fmdc_ChangeOnDatePos};

PRIVATE PROCEDURE TmpExclude(): SCAL[2]; (*0058556*)
BEGIN
 IF OCCURE(MDocList) & ~L_Acnt.E_SetMathPriceOnline(MDocList.Date) THEN
  IF ~!MDocList.Math THEN
   CONFORM(MDocList, Math);
   IF Math.MathType = L_MathR.mtyp_Fuels THEN
    RETURN 1;
   END;
  END;
 END;
 RETURN 0;
END {TmpExclude};

 PUBLIC PROCEDURE CheckChainMDocDone();
  VAR
   prvNeed,
   nxtNeed   : SCAL[2];
   curDate   : DATE;
   curQueue  : fmdc_tQueue;
   curDoneDTS: LIKE(MDoc.DoneDTS);
   curDone   : LIKE(MDoc.Done);
   curMyFirm : P_Firm.tMyFirm;
 BEGIN
  IF E_NeedMDocProceedQueueControl(MDoc.Date) & fmdc_IsSignificantMDoc(MDoc.MyFirm) THEN
   APP.Get().NewPrompt("஢ઠ । ࠡ⪨ ");

   curDate   :=MDoc.Date;
   curQueue  :=fmdc_GetQueue();
   curDoneDTS:=MDoc.DoneDTS;
   curDone   :=MDoc.Done;
   curMyFirm :=MDoc.MyFirm;
   SAVE(MDoc);
   SAVE(MDocList);
   SETSEL(MDocList, MDoc, MDoc.MDocKind, MDoc.MDoc);
   FOR_EACH MDocList DO
IF ~TmpExclude() THEN
    IF ~!MDocList.Math THEN
(*  FOR_EACH SAVE  㦥
     SAVE(MDocList);
*)
     CHANGESEL(MDocList, Math, , MDocList.Math);
     prvNeed:=1;
     nxtNeed:=1;
     SRCINSEL(MDocList, LE, , curDate);
     WHILE prvNeed & OCCURE(MDocList) DO
      NARROWSEL(MDocList, Date);
      WHILE OCCURE(MDocList) DO
       CONFORM(MDocList, MDoc);
       PROMPT(MDocStr(MDoc.MDocKind, MDoc.MDoc));
       IF fmdc_LT(MDoc.Date, fmdc_GetQueue(), MDoc.DoneDTS, curDate, curQueue, curDoneDTS) & fmdc_IsSignificantMDoc(curMyFirm) THEN
        L_General.Assert(MDoc.Done, " ࠡ⠭ ।騩 㬥 "+GetMDocStrNbr());
        prvNeed:=0;
       END;
       IF ~curDone & (MDocList.Date = curDate) & (*⮡   ஢  室 㬥 0099500 04.10.2013 16:43:01 POLAK\Bor*)
          fmdc_LT(curDate, curQueue, curDoneDTS, MDoc.Date, fmdc_GetQueue(), MDoc.DoneDTS) & fmdc_IsSignificantMDoc(curMyFirm) THEN
        L_General.Assert(~MDoc.Done, " ࠡ⠭ ᫥騩 㬥 "+GetMDocStrNbr());
        nxtNeed:=0;
       END;
       PREV(MDocList);
      END; (* WHILE OCCURE(MDocList) ... *)
      FIRST(MDocList);
      CHANGESEL(MDocList, Math, , MDocList.Math);
      PREV(MDocList);
     END;
 
     IF ~curDone & nxtNeed THEN
      SRCINSEL(MDocList, GT, , curDate); (* GE, ⮬   室 㬥 ஢ਫ *)
      WHILE nxtNeed & OCCURE(MDocList) DO
       NARROWSEL(MDocList, Date);
       FOR_EACH MDocList DO
        CONFORM(MDocList, MDoc);
        PROMPT(MDocStr(MDoc.MDocKind, MDoc.MDoc));
        IF fmdc_LT(curDate, curQueue, curDoneDTS, MDoc.Date, fmdc_GetQueue(), MDoc.DoneDTS) & fmdc_IsSignificantMDoc(curMyFirm) THEN
         L_General.Assert(~MDoc.Done, " ࠡ⠭ ᫥騩 㬥 "+GetMDocStrNbr());
         nxtNeed:=0;
        END;
       END; (* FOR_EACH MDocList *)
       NEXTINEXTENDEDSEL(MDocList, Date);
      END;
     END;
(*
     RESTORE(MDocList);
*)
    END; (* IF ~!MDocList.Math *)
END;
   END; (* FOR_EACH MDocList *)
   RESTORE(MDocList);
   RESTORE(MDoc);
  END;
 END {CheckChainMDocDone};

 PUBLIC PROCEDURE fmdc_Show();
  VAR
   _XDocId: L_XDoc.tXDocId;
 BEGIN
  _XDocId:=_fmdc_Show("'᫥騥' 㬥", 0);
  L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, _XDocId, "");
 END {fmdc_Show};

 PUBLIC PROCEDURE MDoc_OnAnyModification(Dir: NUMERIC[0]; NeedProceed: SCAL[3]; Stream: SCAL[2]);
  VAR
   _MyFirm        : P_Firm.tMyFirm;
   _FillMDocSrcNbr: tFillMDocSrcNbr;
   xdc            : L_XDoc.tXDocClass;
   _mfNbr         : LIKE(MDoc.mfNbr);
 BEGIN
  CONFORM(MDoc, MDocKind);
  IF IsInternalMDocKind() THEN
   xdc:=L_XDoc.xdcls_InternalMDoc;
  ELSIF L_Pmnt.IsAcptMDocKind(MDocKind.MDocKind) THEN
   xdc:=L_XDoc.xdcls_VATRelated;
  ELSE
   xdc:=L_XDoc.xdcls_AllPmnt;
  END;
  IF MDocKind.MDocKind # md_DDA THEN
   L_XDoc.xdmb_CheckABan(xdc, MDoc.Date);
  END;
  IF Dir = +1 THEN
   _MyFirm:=GetMDocMyFirm();
   IF MDoc.MyFirm = P_Firm.mf_Fict THEN
    MDoc.MyFirm:=_MyFirm;
    SETEMPTY(MDoc.mfNbr);
    REPLACE(MDoc);
    CONFORM(MDoc, MDocKind);
    IF E_ResetMDocNumberingFromYearBeg(MDoc.Date) THEN
     IF (MDoc.mfNbr - mfNbr_woYearPart(MDoc.mfNbr)) # mfNbrYearPart(MDoc.Date) THEN
      _mfNbr:=mfNbrYearPart(MDoc.Date);
      IF MDoc.mfNbr >= _mfNbr (*   *) THEN
       _mfNbr:=mfNbrYearPart(L_DatTim.IncYear(L_DatTim.MonthBeg(MDoc.Date), +1));
       SAVE(MDoc);
       CHANGESEL(MDoc, mfNbr, , MDoc.MDocKind, MDoc.MyFirm);
       IF SRCINSEL(MDoc, LT, _mfNbr) THEN
        _mfNbr:=mfNbr_woYearPart(MDoc.mfNbr);
       ELSE
        _mfNbr:=0;
       END;
       RESTORE(MDoc);
      ELSE
       _mfNbr:=0;
      END; (* IF MDoc.mfNbr >= _mfNbr *)
      MDoc.mfNbr:=mfNbrYearPart(MDoc.Date) + _mfNbr + 1;
      REPLACE(MDoc);
     END;
    END;
    _FillMDocSrcNbr:=E_FillMDocSrcNbr();
    IF (_FillMDocSrcNbr # fmdsn_No) & (_FillMDocSrcNbr # fmdsn_NoAndNotAllowEdit) THEN
     IF !MDoc.SrcNbr THEN
      MDoc.SrcNbr:=L_Pmnt.E_DefaultMDocSrcNbr(MDoc.Date);
      REPLACE(MDoc);
     ELSE
      L_General.CallUs(_FillMDocSrcNbr = fmdsn_Yes);
     END;
    END;
   ELSE
    L_General.Assert(MDoc.MyFirm = _MyFirm, "饭 ⠪  , ஥  ' ࣠'");
   END;
   L_JDoc.ReplicateAnnexJDoc(MDoc.XDocId);
   SAVE(MDoc);
   IF    NeedProceed = np_Try THEN
    IF E_NeedMDocProceedQueueControl(MDoc.Date) THEN
     fmdc_Init();
     fmdc_MakeList(1);
    END;
    TRY
     IF E_NeedMDocProceedQueueControl(MDoc.Date) THEN
      fmdc_intProceedMDoc(1, Stream);
     ELSIF Stream THEN
      CALL(MDoc.InternalStreamMakeDone());
     ELSE
      CALL(MDoc.InternalSingleMakeDone());
     END;
    EXCEPT
    ON Exc: Exc_Raise DO
     IF ~Stream THEN
      IF IsCheckXCalcRestOfMathInClearedMDocException(Exc) THEN
       L_StdFrm.Question(Exc.MsgOriginalText
                         + L_StdFrm.HR()
                         + "㬥 ⠭  ﭨ ' ࠡ⠭'");
      ELSE
       L_XDoc.OnAnyXDocModificationProceedError(Exc);
      END;
      IF E_NeedMDocProceedQueueControl(MDoc.Date) THEN
       fmdc_RollBackFollowMDoc();
      END;
     END; (* IF ~Stream ... *)
    END; (* TRY *)
    IF E_NeedMDocProceedQueueControl(MDoc.Date) THEN
     fmdc_DeInit();
    END;
   ELSIF NeedProceed = np_Yes THEN
    IF Stream THEN
     CALL(MDoc.StreamMakeDone());
    ELSE
     CALL(MDoc.SingleMakeDone());
    END;
   ELSIF NeedProceed = np_No THEN
    IF E_NeedMDocProceedQueueControl(MDoc.Date) THEN
     fmdc_Init();
     fmdc_MakeList(1);
     fmdc_RollBackFollowMDoc();
     fmdc_DeInit();
    END;
   ELSE
    L_General.CallUs(0);
   END;
   RESTORE(MDoc);
  ELSIF Dir = -1 THEN
   IF NeedProceed # np_No THEN
    IF MDoc.Done THEN
     SAVE(MDoc);
     IF Stream THEN
      CALL(MDoc.StreamMakeUnDone());
     ELSE
      CALL(MDoc.SingleMakeUnDone());
     END;
     RESTORE(MDoc);
    END;
    L_General.Assert(MDoc.doneRWF # 1, "㬥 室  ﭨ ' ࠡ⠭'" +
                                       "|᫥   ⪠, ந  ᯥ樠 ᫮" +
                                       "|( 䨪樨  )" +
                                       L_StdFrm.HR() +
                                       " 믮   ⪠   䨪樥  ");
   ELSE
    L_General.CallUs(~MDoc.Done);
   END;
  END;
  L_Pmnt.SupportOnlineBalance(L_XDoc.xdt_MDoc, Dir);
  L_Pmnt.ResetMDocClosed();
  IF (Dir = +1) & ~!MDoc.Contract & (MDoc.Status # st_Canceled) THEN
   IF ~L_Pmnt.IsVATMDocKind(MDoc.MDocKind) THEN
    L_Pmnt.CheckOwnAgentCntrSumLimit(MDoc.Contract, MDoc.Date);
   END;
  END;
 END {MDoc_OnAnyModification};

 PUBLIC PROCEDURE IsMDoc_wJDocOnly(): SCAL[2];
  VAR
   Result: SCAL[2];
   JDocId: L_XDoc.tXDocId;
 BEGIN
  Result:=0;
  IF (MDoc.MDocKind = md_OBK) & (L_General.GetAPSiteID() = "55") THEN
   JDocId:=L_XDoc.GetAnnexXDocId(MDoc.XDocId);
   IF ~!JDocId & (L_XDoc.ExtractXDocType(JDocId) = L_XDoc.xdt_JDoc) THEN
    L_XDoc.PositionOnXDoc(JDocId);
    Result:=SELECT(JDocList, JDoc, JDoc.JDocKind, JDoc.JDoc);
   END;
  END;
IF (Result=0) THEN
  JDocId:=L_XDoc.GetAnnexXDocId(MDoc.XDocId);
  IF ~!JDocId & (L_XDoc.ExtractXDocType(JDocId) = L_XDoc.xdt_JDoc) THEN
   L_XDoc.PositionOnXDoc(JDocId);
   Result:=JDoc.SubstAM;
  END;
END;
  RETURN Result;
 END {IsMDoc_wJDocOnly};

 PUBLIC PROCEDURE extRemove_MDoc(wRemove: SCAL[2]);
 BEGIN
  MDoc_OnAnyModification(-1, np_Yes, 1);
  L_XDoc.XDoc_OnBeforeDelete(L_XDoc.curXDocId(L_XDoc.xdt_MDoc));
  IF wRemove THEN
   TRY [INTEGRITY(INTEGRITY_ON)]
    REMOVE(MDoc);
   EXCEPT
   END; (* TRY *)
  END;
 END {extRemove_MDoc};

 PUBLIC PROCEDURE Remove_MDoc();
 BEGIN
  extRemove_MDoc(1);
 END {Remove_MDoc};

 PUBLIC PROCEDURE BreakRef();
 BEGIN
  L_XDoc.rf_Clear(L_XDoc.xdt_MDoc);
 END {BreakRef};

 PUBLIC PROCEDURE Cancel_MDoc();
 BEGIN
  L_General.CallUs(MDoc.Status # st_Canceled);
  APP.Get().NewPrompt("㫨஢ : " + GetMDocStrNbr());
  MDoc_OnAnyModification(-1, np_Yes, 1);
  MDoc.Status:=st_Canceled;
  REPLACE(MDoc);
  MDoc_OnAnyModification(+1, np_Yes, 1);
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc, L_XDoc.action_AutoEdit);
  SELECT(XDocRef, bXDocId, , MDoc.XDocId);
  WHILE OCCURE(XDocRef) DO
   IF XDocRef.RefType # L_XDoc.rft_BaseOn THEN
    REMOVE(XDocRef);
   ELSE
(*
   (!)  뫪  த⥫᪨  - . 0071551
*)
    NEXT(XDocRef);
   END;
  END; (* WHILE OCCURE(XDocRef) ... *)
 END {Cancel_MDoc};

 PUBLIC PROCEDURE CheckMDocKAGroup();
  VAR
   _KAGroup: LIKE(MathKAGL.KAGroup);
   _Math   : LIKE(MDocList.Math);
 BEGIN
  SETEMPTY(_KAGroup, _Math);
  SAVE(MDocList);
  CONFORM(MDoc, MDocList);
  WHILE OCCURE(MDocList) DO
   CONFORM(MDocList, Math);
   L_MathR.PosToKAG(Math.Math, MDoc.Date);
   IF ~!_KAGroup THEN
    L_General.Assert(MathKAGL.KAGroup = _KAGroup, "ꥪ "+_Math+"  "+MDocList.Math+" 室  ࠧ 㯯 த ");
   END;
   _KAGroup:=MathKAGL.KAGroup;
   _Math   :=MDocList.Math;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
  RESTORE(MDocList);
 END {CheckMDocKAGroup};

 PUBLIC PROCEDURE CalculateVAT(): SCAL[3];
  VAR
   _CalculateVAT: SCAL[3];
 BEGIN
  _CalculateVAT:=cvat_Necessary;
  L_General.CallUs(OCCURE(MDoc));
  SAVE(MDocKind);
  CONFORM(MDoc, MDocKind);
  IF (MDoc.MDocKind = md_AVb) |
     (MDoc.MDocKind = md_APc) THEN
   _CalculateVAT:=cvat_Necessary;
  ELSIF (MDoc.MDocKind # md_Nrd)      &
     (KeyAssetsMDoc(MDoc.MDocKind)    |
      (MDocKind.Scope = mds_Internal) |
      (MDoc.MDocKind = md_RPk)        |
      (MDoc.MDocKind = md_NDk)        |
      (MDoc.MDocKind = md_NlO)        |
      (MDoc.MDocKind = md_PCh)        |
      (MDoc.MDocKind = md_RCh)) THEN
   _CalculateVAT:=cvat_Impossible;
  ELSE
   IF ~!MDoc.Contract THEN
    IF P_Cntr.GetSpecialAttitudeToVAT(MDoc.Contract, MDoc.Date) = P_Cntr.satVAT_woFeatures THEN
     IF MDoc.MDocKind = md_OBK THEN
      _CalculateVAT:=cvat_Possible;
     ELSE
      _CalculateVAT:=cvat_Necessary;
     END;
    ELSE
     _CalculateVAT:=cvat_Impossible;
    END;
   END;
  END;
  RESTORE(MDocKind);
  RETURN _CalculateVAT;
 END {CalculateVAT};

 PUBLIC PROCEDURE MDocListVATPossible(): SCAL[2];
 BEGIN
  RETURN (CalculateVAT() # cvat_Impossible) &
         (P_Math.GetSpecialAttitudeToVAT(MDocList.Math, MDoc.Date) # P_Math.satVAT_TaxFree);
 END {MDocListVATPossible};

 PUBLIC PROCEDURE IsAvailableVATModeMDocKind(trgMDocKind: LIKE(MDoc.MDocKind)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(MDocKind);
  SEARCH(MDocKind, MDocKind, , trgMDocKind);
  Result:=(MDocKind.Dir = mdd_Ingoing) |
          (MDocKind.MDocKind = md_NPr) |
          (MDocKind.MDocKind = md_Dvr);
  RESTORE(MDocKind);
  RETURN Result;
 END {IsAvailableVATModeMDocKind};

(*!*) PUBLIC PROCEDURE IsAvailableVATMode(): SCAL[2];
 BEGIN
  RETURN IsAvailableVATModeMDocKind(MDoc.MDocKind);
 END {IsAvailableVATMode};

 PUBLIC PROCEDURE GetMDocListCir2(): L_XObj.tQnt;
  VAR
   _MDLNbr : LIKE(MDocList.MDLNbr);
   _MDocStr: STRING[];
   Result  : L_XObj.tQnt;
 BEGIN
  Result:=MDocList.Qnt;
  IF E_MDocListIsPartOfComplex(MDoc.Date) THEN
   Result  :=MDocList.Qnt;
   _MDLNbr :=MDocList.MDLNbr;
   _MDocStr:=MDocStr(MDocList.MDocKind, MDocList.MDoc);
   SAVE(MDocList);
   CHANGESEL(MDocList, MDoc, , MDocList.MDocKind, MDocList.MDoc);
   WHILE PREV(MDocList) & (E_MDocListIsPartOfComplex(MDoc.Date)) DO
   END;
   L_General.Assert(OCCURE(MDocList), _MDocStr + ":    ஢ . ப "+_MDLNbr);
   Result:=Result*MDocList.Qnt;
   RESTORE(MDocList);
  END;
  RETURN Result;
 END {GetMDocListCir2};

 PUBLIC PROCEDURE IsExternalMDocKind(): SCAL[2];
 BEGIN
  RETURN MDocKind.Scope = mds_External;
 END {IsExternalMDocKind};

 PUBLIC PROCEDURE IsInternalMDocKind(): SCAL[2];
 BEGIN
  RETURN MDocKind.Scope = mds_Internal;
 END {IsInternalMDocKind};

 PUBLIC PROCEDURE GetMDocKindDir(): tMDocDir;
 BEGIN
  RETURN MDocKind.Dir;
 END {GetMDocKindDir};

 PUBLIC PROCEDURE InvertMathFlowType(mft: tMathFlowType): tMathFlowType;
 BEGIN
  IF    mft = mft_Credit THEN RETURN mft_Debit;
  ELSIF mft = mft_Debit  THEN RETURN mft_Credit;
  ELSE
   RETURN mft;
  END;
 END {InvertMathFlowType};

 PUBLIC PROCEDURE MDocDirection(): tMDocDir;
  VAR
   Result: tMDocDir;
 BEGIN
  SAVE(MDocKind);
  CONFORM(MDoc, MDocKind);
  Result:=GetMDocKindDir();
  IF (Result = mdd_Undefined) | (Result = mdd_MSP) THEN
   SAVE(Dest);
   CONFORM(MDoc, Dest);
   IF    Dest.Type = L_Acnt.dt_Credit THEN
    Result:=mdd_Outgoing;
   ELSIF Dest.Type = L_Acnt.dt_Debit THEN
    Result:=mdd_Ingoing;
   ELSE
    L_General.Error("    ࠢ '" + L_Str.PoolItem(mdd_Pool, GetMDocKindDir()) + "'" +
                    "|⨬ ᯮ짮  樨  ⨯ '" + L_Str.PoolItem(L_Acnt.dt_Pool, Dest.Type) + "'" +
                    "|(" + GetMDocStrNbr() + ",  樨 " + Dest.Dest + ")");
   END;
   RESTORE(Dest);
  END;
  RESTORE(MDocKind);
  RETURN Result;
 END {MDocDirection};

 PUBLIC PROCEDURE MDoc3Direction(): SCAL[3];
 BEGIN
  IF IsMDocToWriteOffFromAdvanceHolder() THEN
   CONFORM(MDoc, Dest);
   IF Dest.Type = L_Acnt.dt_Credit THEN
    RETURN 2;
   ELSE
    RETURN 0;
   END;
  ELSE
   IF MDocDirection() = mdd_Outgoing THEN
    RETURN 0;
   ELSE
    RETURN 1;
   END;
  END;
 END {MDoc3Direction};

 PRIVATE TYPE
  tParams = SCAL[Math.Max(Math.Max(MAXOF(MDMth.Dest), MAXOF(MDMth.MMode)), MAXOF(MDMth.MDocKind))+1];
 PRIVATE CONST
  fld_FlowType = 0;
  fld_DefOpKnd = 1;
  fld_CUCChar  = 2;

 PRIVATE PROCEDURE intSrcMDMth(D: DATE;
                               KeyName: STRING[];
                               trgParams0,
                               trgParams1,
                               trgParams2  : tParams;
                               VAR prvMDMth: LIKE(MDMth.MDMth));
 BEGIN
  SETSEL(MDMth, ^KeyName, 1, trgParams0, trgParams1, trgParams2);
  IF SRCINSEL(MDMth, LE, D) & (MDMth.Till > D) THEN
   IF ~!prvMDMth THEN
    L_General.Error("ᥪ ਬ ᯥ樠 権   "+prvMDMth+"  "+MDMth.MDMth);
   END;
   prvMDMth:=MDMth.MDMth;
  END;
 END {intSrcMDMth};

 PRIVATE PROCEDURE SrcMDMth(D: DATE;
                            trgMDocKind: LIKE(MDMth.MDocKind);
                            trgDest: LIKE(MDoc.Dest);
                            trgMMode: LIKE(MDocList.MMode);
                            fld_What: SCAL[3]): SCAL[2];
  VAR
   KeyName  : STRING[];
   curParams: tParams[3];
   curMDMth : LIKE(MDMth.MDMth);
   HasParam1: SCAL[2];
 BEGIN
  IF    fld_What = fld_FlowType THEN
   KeyName:="sFlowTyp";
   curParams[0]:=trgMMode;
   curParams[1]:=trgMDocKind;
   curParams[2]:=trgDest;
  ELSIF fld_What = fld_DefOpKnd THEN
   KeyName:="sDfOpKnd";
   curParams[0]:=trgMDocKind;
   curParams[1]:=trgDest;
   curParams[2]:=trgMMode;
  ELSIF fld_What = fld_CUCChar THEN
   KeyName:="sCUCChar";
   curParams[0]:=trgMDocKind;
   curParams[1]:=trgDest;
   curParams[2]:=trgMMode;
  ELSE
   L_General.CallUs(0);
  END;
  curMDMth:="";
  IF SELECT(MDMth, ^KeyName, 1, curParams[0]) THEN
   IF SELECT(MDMth, ^KeyName, 1, curParams[0], curParams[1]) THEN (*㦥      ࠬࠬ*)
    intSrcMDMth(D, KeyName, curParams[0], curParams[1], curParams[2], curMDMth);
    IF ~!curMDMth THEN (*諨  㤮⢮ ᥬ ६ ࠬࠬ*)
     RETURN 1;
    END;
    intSrcMDMth(D, KeyName, curParams[0], curParams[1], "",           curMDMth); (*஢塞   ࠬ஢*)
   END;
   intSrcMDMth(D, KeyName, curParams[0], "",           curParams[2], curMDMth); (*஢塞   ⨩ ࠬ.   ன  ஢७ *)
   IF ~!curMDMth THEN
    SEARCH(MDMth, MDMth, , curMDMth);
    RETURN 1;
   END;
   intSrcMDMth(D, KeyName, curParams[0], "", "", curMDMth); (*஢塞 ⮫쪮  ࠬ *)
   IF ~!curMDMth THEN (*諨  㤮⢮ ᥬ ६ ࠬࠬ*)
    RETURN 1;
   END;
  END;
  RETURN 0;
 END {SrcMDMth};

 PRIVATE PROCEDURE IsCUCharValidOpKind(_OpKind: L_CUC.tOpKind): SCAL[2];
 BEGIN
  RETURN (_OpKind = L_CUC.ok_Dismant) | (_OpKind = L_CUC.ok_Accpt);
 END {IsCUCharValidOpKind};

 PUBLIC PROCEDURE getMDocLCUChar(): LIKE(MDMth.CUCChar);
  VAR
   Result: LIKE(MDMth.CUCChar);
 BEGIN
  SETEMPTY(Result);
  SAVE(MDocLCU);
  SAVE(MDocList);
  SAVE(MDoc);
  CHANGESEL(MDocLCU, CUCopy, , MDocLCU.CUCopy, MDocLCU.Status);
  REPEAT
   IF IsCUCharValidOpKind(MDocLCU.OpKind) THEN
    CONFORM(MDocLCU, MDocList);
    CONFORM(MDocList, MDoc);
    IF SrcMDMth(MDoc.Date, MDoc.MDocKind, MDoc.Dest, MDocList.MMode, fld_CUCChar) THEN
     Result:=MDMth.CUCChar;
    END;
   END;
  UNTIL ~!Result | ~PREV(MDocLCU);
  RESTORE(MDoc);
  RESTORE(MDocList);
  RESTORE(MDocLCU);
  RETURN(Result);
 END {getMDocLCUChar};

 PRIVATE PROCEDURE intGetMDocListMathFlowType(StorageRelated: SCAL[2]): tMathFlowType;
  VAR
   mdd   : tMDocDir;
   Result: tMathFlowType;
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON), TABLE_FILTER_MODE(TABLE_FILTER_MODE_THROW)]
   CONFORM(MDocList, MDoc);
   IF SrcMDMth(MDoc.Date, MDoc.MDocKind, MDoc.Dest, MDocList.MMode, fld_FlowType) THEN
    Result:=MDMth.FlowType;
   ELSE
    CONFORM(MDoc, MDocKind);
    mdd:=MDocDirection();
    IF    mdd = mdd_Ingoing THEN
     Result:=mft_Debit;
    ELSIF mdd = mdd_Outgoing THEN
     Result:=mft_Credit;
    ELSE
     Result:=mft_None;
    END;
   END;
   RETURN Result;
  EXCEPT
  END; (* TRY *)
 END {intGetMDocListMathFlowType};

 PUBLIC PROCEDURE getMDocListMathFlowType(): tMathFlowType;
 BEGIN
  RETURN intGetMDocListMathFlowType(0);
 END {getMDocListMathFlowType};

 PUBLIC PROCEDURE getMDocListStorageRelatedMathFlowType(): tMathFlowType;
 BEGIN
  RETURN intGetMDocListMathFlowType(1);
 END {getMDocListStorageRelatedMathFlowType};

 PUBLIC PROCEDURE ManufacturingCostIsExplicit(_MDocKind: LIKE(MDocKind.MDocKind)): SCAL[2];
 BEGIN
  RETURN (_MDocKind = md_ViP) |
         (_MDocKind = md_RNR) |
         (_MDocKind = md_SpB) ;
 END {ManufacturingCostIsExplicit};

 PUBLIC PROCEDURE IsSellMDocKind(): SCAL[2];
 BEGIN
  RETURN IsExternalMDocKind() & (GetMDocKindDir() = mdd_Outgoing) & (MDocKind.MDocKind # md_Dvr);
 END {IsSellMDocKind};

 PUBLIC PROCEDURE IsPrchMDocKind(): SCAL[2];
 BEGIN
  RETURN IsExternalMDocKind() & (GetMDocKindDir() = mdd_Ingoing);
 END {IsPrchMDocKind};

 PUBLIC PROCEDURE IsIngoingMDocKind(_MDocKind: LIKE(MDocKind.MDocKind)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(MDocKind);
  Result:=SEARCH(MDocKind, MDocKind, _MDocKind) & (MDocKind.Dir = mdd_Ingoing);
  RESTORE(MDocKind);
  RETURN Result;
 END {IsIngoingMDocKind};

 PUBLIC PROCEDURE IsOutgoingMDocKind(_MDocKind: LIKE(MDocKind.MDocKind)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(MDocKind);
  Result:=SEARCH(MDocKind, MDocKind, _MDocKind) & (MDocKind.Dir = mdd_Outgoing);
  RESTORE(MDocKind);
  RETURN Result;
 END {IsOutgoingMDocKind};

 PUBLIC PROCEDURE IsMDocKind_wAnyStorage(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  IF    KeyAssetsMDoc(MDocKind.MDocKind) THEN
   Result:=(MDocKind.MDocKind=md_APr) |
           (MDocKind.MDocKind=md_APP) |
           (MDocKind.MDocKind=md_ASO) |
           (MDocKind.MDocKind=md_AVb);
  ELSIF MDocKind.Activity THEN
   Result:=(MDocKind.MDocKind # md_NDk) &
           (MDocKind.MDocKind # md_NlO) &
           (MDocKind.MDocKind # md_RNR);
  ELSE
   Result:= (MDocKind.MDocKind = md_SpB)                       |
            (MDocKind.MDocKind = md_Nrd)                       |
            (MDocKind.MDocKind = md_DDA)                       |
            (L_General.IsPolakSpecific() & (MDocKind.MDocKind = md_IsS));
  END;
  RETURN Result;
 END {IsMDocKind_wAnyStorage};

(*-------------BEGIN OF NORMAL ENVIRONMENT--------------------------*)

 PUBLIC PROCEDURE MDocPrinterType(P: DATE; Printer: STRING[]): SCAL[2];
 BEGIN
  IF    ~!L_Print.GetPrinterName(L_Print.pt_Cheque) &
        (L_Print.GetPrinterName(L_Print.pt_Cheque) = Printer) THEN
   RETURN mdpt_TM;
  ELSE
   RETURN mdpt_Normal;
  END;
 END {MDocPrinterType};

 PUBLIC PROCEDURE E_MDocPrinterType(P: DATE): SCAL[2];
 BEGIN
  RETURN MDocPrinterType(P, GETDEFAULTPRINTER());
 END {E_MDocPrinterType};

 PUBLIC PROCEDURE E_PaperFormat(): NUMERIC[0];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(MDoc.Date, PROCREF(E_Stock.PaperFormat), pf_A5onA4);
 END {E_PaperFormat};

 PRIVATE PROCEDURE E_NeedPreCalculateCir0(P: DATE): NUMERIC[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(P, PROCREF(E_Stock.NeedPreCalculateCir0), 0);
 END {E_NeedPreCalculateCir0};

 PRIVATE PROCEDURE E_OilOutByFuelStation(P: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(P, PROCREF(E_Stock.OilOutByFuelStation), 0);
 END {E_OilOutByFuelStation};

 PUBLIC PROCEDURE E_DefMDocDest(P: DATE): LIKE(Dest.Dest);
  VAR
   Result: LIKE(Dest.Dest);
 BEGIN
  SETEMPTY(Result);
  IF (MDoc.MDocKind = md_NOV) & L_Stock.IsFuelStationMDoc() & ~E_OilOutByFuelStation(P) THEN
   Result:=L_Dest.erkn_Get(P, L_Dest.erkn_FuelStationMovement);
  ELSE
   IF ~!MDoc.Contract & ~!MDoc.Date THEN
    Result:=P_Cntr.GetSingleDest(MDoc.Contract, MDoc.Date);
   END;
   IF !Result THEN
    Result:=L_EC.ExecE_Func_Numeric(P, PROCREF(E_Stock.DefMDocDest), EMPTYOF(Dest.Dest));
   END;
  END;
  RETURN Result;
 END {E_DefMDocDest};

 PUBLIC PROCEDURE E_DefMDocCostItem(): LIKE(CostItem.CostItem);
  VAR
   Local : PROC;
   Result: LIKE(CostItem.CostItem);
 BEGIN
  SETEMPTY(Result);
  IF E_MayModifyMDocCostItem() &
     (!MDoc.Dest | (MDoc.Dest # L_Dest.erkn_GetSoft(MDoc.Date, L_Dest.erkn_FuelStationMovement))) THEN
   IF ~!MDoc.Contract THEN
    Result:=P_Cntr.GetSingleCostItem(MDoc.Contract, MDoc.Date);
   END;
   IF !Result THEN
    Local:=PROCREF(E_Stock.DefMDocCostItem);
    IF ~!Local THEN
     Result:=Local(Result);
    END;
   END;
  END;
  RETURN Result;
 END {E_DefMDocCostItem};

 PUBLIC PROCEDURE E_MayModifyMDocCostItem(): SCAL[2];
  VAR
   Result: SCAL[2];
   Local : PROC;
 BEGIN
  Result:=L_Pmnt.IsAcptMDocKind(MDoc.MDocKind) |
          (MDoc.MDocKind = md_RSZ) |
          (MDoc.MDocKind = md_RCh) |
          (MDoc.MDocKind = md_IAP) ;
  IF ~Result THEN
   Local:=PROCREF(E_Stock.NormalUsingMDocCostItem);
   IF ~!Local & Local() THEN
    Result:=(MDoc.MDocKind = md_TOV) |
            (MDoc.MDocKind = md_NOV) |
            (MDoc.MDocKind = md_ViP) |
            (MDoc.MDocKind = md_VPC) |
            (MDoc.MDocKind = md_TCh) |
            (MDoc.MDocKind = md_AVb) |
            (MDoc.MDocKind = md_ASp) |
            (MDoc.MDocKind = md_APc);
   END;
  END;
  RETURN Result;
 END {E_MayModifyMDocCostItem};

 PUBLIC PROCEDURE E_DefaultAlower(D: DATE): LIKE(Alower.Alower);
 BEGIN
  IF (MDoc.MDocKind = md_NOV) & L_Stock.IsFuelStationMDoc() & L_Env.RealTSN(MDoc.TSN) & SEARCH(Alower, Alower, NoAlower) THEN
   RETURN Alower.Alower;
  ELSE
   RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Stock.DefaultAlower), EMPTYOF(Alower.Alower));
  END;
 END {E_DefaultAlower};

 PUBLIC PROCEDURE E_NeedMDocProceedQueueControl(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Stock.NeedMDocProceedQueueControl), L_General.IsPolakSpecific());
 END {E_NeedMDocProceedQueueControl};

(*!*) PUBLIC PROCEDURE E_NeedMDocProcceedQueueControl(D: DATE): SCAL[2];
 BEGIN
  RETURN E_NeedMDocProceedQueueControl(D);
 END {E_NeedMDocProcceedQueueControl};

 PRIVATE PROCEDURE GetVATModeForMath(trgMath: LIKE(Math.Math); D: DATE): LIKE(MDocList.VATMode);
 BEGIN
  IF P_Math.HasActualMathPro(trgMath, D, P_Math.P_VATMode) THEN
   RETURN L_Prop.GetProValueAsScal(P_Math.GetMathProPool(P_Math.P_VATMode), MathPro.Value);
  ELSE
   RETURN EMPTYOF(MDocList.VATMode);
  END;
 END {GetVATModeForMath};

 PUBLIC PROCEDURE GetVATModeForCostItem(trgCostItem: LIKE(CostItem.CostItem); D: DATE): LIKE(MDocList.VATMode);
 BEGIN
  IF    P_CI.HasActualPro(trgCostItem, D, P_CI.P_VATMode) THEN
   RETURN L_Prop.GetProValueAsScal(P_CI.GetPool(P_CI.P_VATMode), CIPro.Value);
  ELSIF L_General.IsPolakSpecific() THEN
   RETURN vatm_Deduction;
  ELSE
   RETURN EMPTYOF(MDocList.VATMode);
  END;
 END {GetVATModeForCostItem};

 PRIVATE PROCEDURE GetVATModeForContract(trgContract: LIKE(Contract.Contract); D: DATE): LIKE(MDocList.VATMode);
 BEGIN
  IF P_Cntr.HasActualPro(trgContract, D, P_Cntr.P_VATMode) THEN
   RETURN L_Prop.GetProValueAsScal(P_Cntr.GetPool(P_Cntr.P_VATMode), CntrPro.Value);
  ELSE
   RETURN EMPTYOF(MDocList.VATMode);
  END;
 END {GetVATModeForContract};

 PUBLIC PROCEDURE GetVATModeDefinedByPro(trgContract: LIKE(Contract.Contract);
                                         trgCostItem: LIKE(CostItem.CostItem);
                                         trgMath    : LIKE(Math.Math);
                                         D: DATE): LIKE(MDocList.VATMode);
  VAR
   Result: LIKE(MDocList.VATMode);
 BEGIN
  SETEMPTY(Result);
  IF ~!trgCostItem THEN
   Result:=GetVATModeForCostItem(trgCostItem, D);
  END;
  IF !Result & ~!trgMath THEN
   Result:=GetVATModeForMath(trgMath, D);
  END;
  IF !Result & ~!trgContract THEN
   Result:=GetVATModeForContract(trgContract, D);
  END;
  RETURN Result;
 END {GetVATModeDefinedByPro};

 PUBLIC PROCEDURE E_DefaultVATMode(D: DATE; trgMath: LIKE(Math.Math)): LIKE(MDocList.VATMode);
  VAR
   Result: LIKE(MDocList.VATMode);
 BEGIN
  SETEMPTY(Result);
  IF (CalculateVAT() # cvat_Impossible) & IsAvailableVATModeMDocKind(MDoc.MDocKind) &
     (!trgMath | (P_Math.GetSpecialAttitudeToVAT(trgMath, D) # P_Math.satVAT_TaxFree)) THEN
   Result:=GetVATModeDefinedByPro(MDoc.Contract, MDoc.CostItem, trgMath, D);
   IF !Result THEN
    Result:=L_EC.ExecE_Func_Numeric(D, PROCREF(E_Stock.DefaultVATMode), vatm_Deduction);
   END;
  END;
  RETURN Result;
 END {E_DefaultVATMode};

 PUBLIC PROCEDURE E_MDocListIsPartOfComplex(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Stock.MDocListIsPartOfComplex), 0);
 END {E_MDocListIsPartOfComplex};

 PUBLIC PROCEDURE E_DefineMDocLCU_OpKind(): L_CUC.tOpKind;
  VAR
   Result: L_CUC.tOpKind;
 BEGIN
  SAVE(MDocList);
  SAVE(MDoc);
  IF OCCURE(MDocLCU) THEN
   CONFORM(MDocLCU, MDocList);
  END;
  CONFORM(MDocList, MDoc);

  IF SrcMDMth(MDoc.Date, MDoc.MDocKind, MDoc.Dest, MDocList.MMode, fld_DefOpKnd) THEN
   Result:=MDMth.DefOpKnd;
  ELSIF (MDocList.MDocKind = md_MSP) THEN
   Result:=L_CUC.ok_Relocation;
  ELSIF ((MDocList.MDocKind = md_TOV) |
         (MDocList.MDocKind = md_ViP)) &
        L_MathR.IsAdvHolderFlow(InvertMathFlowType(getMDocListStorageRelatedMathFlowType())) THEN 
   Result:=L_CUC.ok_Relocation;
  ELSE
   SETEMPTY(Result);
  END;
  RESTORE(MDoc);
  RESTORE(MDocList);
  RETURN Result;
 END {E_DefineMDocLCU_OpKind};

 PUBLIC PROCEDURE E_RemoveRefTo(): SCAL[2];
 BEGIN
  IF    (MDoc.MDocKind = md_IsS) &
        (L_XDoc.ExtractXDocKindId(curRefToXDoc_GetId()) =
         L_XDoc.XDocKindId(L_XDoc.xdt_MDoc, md_IsS)) THEN
   RETURN 0;
  ELSIF (MDoc.MDocKind = md_ISA) &
        (L_XDoc.ExtractXDocKindId(curRefToXDoc_GetId()) =
         L_XDoc.XDocKindId(L_XDoc.xdt_MDoc, md_ISA)) THEN
   RETURN 0;
  ELSE
   RETURN 1;
  END;
 END {E_RemoveRefTo};

 PUBLIC PROCEDURE E_MDocKind_wSaleTax(_MDocKind: LIKE(MDocKind.MDocKind)): SCAL[2];
 BEGIN
  RETURN (_MDocKind = md_OBK) | (_MDocKind = md_RPr);
 END {E_MDocKind_wSaleTax};

 PUBLIC PROCEDURE IsMDocToTransferBetweenAdvanceHolders(): SCAL[2];
 BEGIN
  IF (MDoc.MDocKind = md_MSP) & ~!MDoc.Storage & ~!MDoc.Storage2 THEN
   CONFORM(MDoc, Storage);
   CONFORM(MDoc, Storage2);
   RETURN (Storage.Type = L_Stock.st_AdvHolder) & (Storage2.Type = L_Stock.st_AdvHolder);
  END;
  RETURN 0;
 END {IsMDocToTransferBetweenAdvanceHolders};

 PUBLIC PROCEDURE IsMDocToWriteOffFromAdvanceHolder(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  IF (MDoc.MDocKind = md_TOV) & ~!MDoc.Storage THEN
   CONFORM(MDoc, Storage);
   Result:=Storage.Type = L_Stock.st_AdvHolder;
  ELSE
   Result:=0;
  END;
  RETURN Result;
 END {IsMDocToWriteOffFromAdvanceHolder};

 PRIVATE PROCEDURE CheckPDocContract(_MDocKind: LIKE(MDoc.MDocKind); _MDoc: LIKE(MDoc.MDoc); NewContract: LIKE(MDoc.Contract));
  VAR
   _Firm: LIKE(Contract.Firm);
 BEGIN
  SEARCH(Contract, Contract, , NewContract);
  _Firm:=Contract.Firm;
  SAVE(PDocMDoc);
  CONFORM(PDoc, PDocMDoc);
  WHILE OCCURE(PDocMDoc) DO
   IF (PDocMDoc.MDocKind # _MDocKind) |
      (PDocMDoc.MDoc     # _MDoc) THEN
    CONFORM(PDocMDoc, Contract);
    IF PDoc.PDocKind # L_PDoc.pd_AVO THEN
     L_General.Assert(Contract.Firm = _Firm, L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc)+":  १ 樨|뫪    ⭮  ࠧ ࠣ⠬");
    END;
   END;
   NEXT(PDocMDoc);
  END; (* WHILE OCCURE(PDocMDoc) ... *)
  RESTORE(PDocMDoc);
 END {CheckPDocContract};

 PRIVATE PROCEDURE ismdcc_PassAccessPoint(Msg: STRING[]; DoIt: SCAL[2]): SCAL[2];
 BEGIN
  IF DoIt THEN
   L_AcsPnt.PassAccessPoint_wExplanation(0000006, Msg);
  END;
  RETURN 0;
 END {ismdcc_PassAccessPoint};

 PRIVATE PROCEDURE intSupportMDocContractChange(OldContract, NewContract: LIKE(MDoc.Contract); VAR ChPDocMDoc, ChDependMDoc: SCAL[2]; IsBaseMDoc: SCAL[2]);
  VAR
   DependentMDocs: L_XDoc.tXDocCollection;
   i             : NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt(MDocStr(MDoc.MDocKind, MDoc.MDoc));
  IF IsBaseMDoc THEN
   MDoc.Contract:=OldContract;
   SEARCH(Contract, Contract, , OldContract);
   MDoc.Firm:=Contract.Firm;
   REPLACE(MDoc);
  END;

  SAVE(PDoc);
  SAVE(PDocMDoc);
  IF SELECT(PDocMDoc, MDoc, MDoc.MDocKind, MDoc.MDoc) THEN
   ChPDocMDoc:=ismdcc_PassAccessPoint("   뫪  ⥪騩 ", ChPDocMDoc);
  END;
  WHILE OCCURE(PDocMDoc) DO
   CONFORM(PDocMDoc, PDoc);
   CheckPDocContract(MDoc.MDocKind, MDoc.MDoc, NewContract);
   SAVE(PDocMDoc);
   SAVE(MDoc);
   L_PDoc.PDoc_OnAnyModification(-1, L_PDoc.np_Yes, 1);
   RESTORE(MDoc);
   RESTORE(PDocMDoc);
   NEXT(PDocMDoc);
  END; (* WHILE OCCURE(PDocMDoc) ... *)
  RESTORE(PDocMDoc);
  RESTORE(PDoc);

  SAVE(MDoc);
  DependentMDocs:=L_XDoc.GetDependentXDC(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.xdt_MDoc);
  IF ~!DependentMDocs THEN
   ChDependMDoc:=ismdcc_PassAccessPoint(" , 易 c ⥪騬 ", ChDependMDoc);
  END;
  i:=0;
  WHILE L_XDoc.xdc_PositionOn(DependentMDocs, i) DO
   IF MDoc.Contract = OldContract THEN
    IF MDoc.Done THEN
     CALL(MDoc.StreamMakeUnDone());
     L_General.Assert(~MDoc.Done, " 㤠 ⪠ "+MDocStr(MDoc.MDocKind, MDoc.MDoc));
    END;
    intSupportMDocContractChange(OldContract, NewContract, ChPDocMDoc, ChDependMDoc, 0);
    CALL(MDoc.StreamMakeDone());
    IF ~MDoc.Done THEN
     L_StdFrm.Choice(" 㤠 ࠡ "+MDocStr(MDoc.MDocKind, MDoc.MDoc));
    END;
   END;
   INC(i);
  END; (* L_XDoc.xdc_PositionOn ... *)
  RESTORE(MDoc);

  IF IsBaseMDoc THEN
   MDoc.Contract:=NewContract;
   SEARCH(Contract, Contract, , NewContract);
   MDoc.Firm:=Contract.Firm;
   REPLACE(MDoc);
  ELSIF ~!MDoc.Contract THEN
   MDoc_OnAnyModification(-1, np_No, 0);
   MDoc.Contract:=NewContract;
   SEARCH(Contract, Contract, , NewContract);
   MDoc.Firm:=Contract.Firm;
   REPLACE(MDoc);
   L_XDoc.XDocJrn_Mark(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc, L_XDoc.action_AutoEdit);
   MDoc_OnAnyModification(+1, np_No, 0);
  END;

  SAVE(PDoc);
  SAVE(PDocMDoc);
  SAVE(MDoc);
  SELECT(PDocMDoc, MDoc, , MDoc.MDocKind, MDoc.MDoc);
  WHILE OCCURE(PDocMDoc) DO
   PDocMDoc.Contract:=NewContract;
   REPLACE(PDocMDoc);
   CONFORM(PDocMDoc, PDoc);
   L_General.CallUs(~PDoc.Done);
   L_XDoc.XDocJrn_Mark(L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc, L_XDoc.action_AutoEdit);
   SAVE(PDocMDoc);
   L_PDoc.PDoc_OnAnyModification(+1, L_PDoc.np_Yes, 1);
   IF ~PDoc.Done THEN
    L_StdFrm.Choice(" 㤠 ࠡ "+L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
   END;
   RESTORE(PDocMDoc);
   NEXT(PDocMDoc);
  END; (* WHILE OCCURE(PDocMDoc) ... *)
  RESTORE(MDoc);
  RESTORE(PDocMDoc);
  RESTORE(PDoc);
 END {intSupportMDocContractChange};

 PUBLIC PROCEDURE SupportMDocContractChange(OldContract, NewContract: LIKE(MDoc.Contract));
  VAR
   ChPDocMDoc,
   ChDependMDoc: SCAL[2];
 BEGIN
  APP.Get().NewPrompt("   ");
  ChPDocMDoc  :=1;
  ChDependMDoc:=1;
  intSupportMDocContractChange(OldContract, NewContract, ChPDocMDoc, ChDependMDoc, 1);
 END {SupportMDocContractChange};

 PUBLIC PROCEDURE E_MDocCopiesCount(PrpResult: L_MSO.PrpResultType): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
   Local : PROC;
 BEGIN
  Result:=1;
  IF PrpResult = L_MSO.PrpResult_Original THEN
   IF (MDoc.MDocKind =  md_MSP) | (MDoc.MDocKind =  md_TCh) THEN
    Result:=2;
   END;
   Local:=PROCREF(E_Stock.MDocCopiesCount);
   IF ~!Local THEN
    Result:=Local(Result);
   END;
  END;
  RETURN Result;
 END {E_MDocCopiesCount};

 PUBLIC PROCEDURE SetMDocTotals(Window: STRING[]);
  VAR
   TotalVAT,
   TotalNetto: LIKE(MDoc.Total);
 BEGIN
  IF ~!Window & L_WDO.wz_FieldExists(Window, 0, "v_MDocTotalNetto") THEN
   SETZERO(TotalNetto, TotalVAT);
   SAVE(MDocList);
   CONFORM(MDoc, MDocList);
   WHILE OCCURE(MDocList) DO
    INC(TotalNetto, MDocList.Sum);
    INC(TotalVAT,   MDocList.VAT);
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)
   RESTORE(MDocList);
   L_WDO.wz_setFieldValue(Window, 0, "v_MDocTotalNetto", TotalNetto);
   L_WDO.wz_setFieldValue(Window, 0, "v_MDocTotalVAT",   TotalVAT);
   L_WDO.wz_setFieldValue(Window, 0, "v_MDocTotal",      MDoc.Total);
  END;
 END {SetMDocTotals};

 PRIVATE CONST
  ec_Raise_CheckXCalcRestOfMathInClearedMDoc = 951753741;

 PRIVATE PROCEDURE IsCheckXCalcRestOfMathInClearedMDocException(Exc: Exc_Root): SCAL[2];
 BEGIN
  RETURN (Exc.Class = "Exc_Raise") & (Exc.ErrorCode = ec_Raise_CheckXCalcRestOfMathInClearedMDoc);
 END {IsCheckXCalcRestOfMathInClearedMDocException};

 PRIVATE PROCEDURE MathIsInClearedMDoc(_Math: LIKE(Math.Math)): SCAL[2];
  VAR
   MDocWasCleared,
   Result         : SCAL[2];
   Cnt            : NUMERIC[0];
 BEGIN
  TRY
   L_AR.GrantRightsUnconditionally();
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   SETZERO(MDocWasCleared, Result);
   SETSEL(SYSLOG, SYSLOG1, SysLog.UserEvent, "MDoc");
   IF LAST(SYSLOG) THEN
    LOOP
     IF    ~OCCURE(SYSLOG) THEN
      EXIT;
     ELSIF (SYSTIMESTAMP() - PackTIMESTAMP(SYSLOG.Date, SYSLOG.BTime, SYSLOG.BSec)) > 1/24*6 THEN
      EXIT;
     ELSE
      MDocWasCleared:=1;
      EXIT;
     END;
     PREV(SYSLOG);
    END; (* LOOP *)
   END;
   IF MDocWasCleared THEN
    SAVE(MDoc);
    SAVE(MDocList);
    SETSEL(MDocList, Math, _Math);
    IF LAST(MDocList) THEN
     Cnt:=0;
     LOOP
      IF ~OCCURE(MDocList) | (Cnt = 100) THEN
       EXIT;
      ELSE
       INC(Cnt);
       CONFORM(MDocList, MDoc);
       IF ~MDoc.Done & (L_XDoc.curXDocId(L_XDoc.xdt_MDoc) # L_XDR.XDocId) THEN
        Result:=1;
        EXIT;
       END;
      END;
      PREV(MDocList);
     END; (* LOOP *)
    END;
    RESTORE(MDoc);
    RESTORE(MDocList);
   END;
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
  RETURN Result;
 END {MathIsInClearedMDoc};

 PUBLIC PROCEDURE RaiseCheckXCalcRestException(_Math: LIKE(Math.Math); Msg: STRING[]);
 BEGIN
  IF MathIsInClearedMDoc(_Math) THEN
   RAISE(ec_Raise_CheckXCalcRestOfMathInClearedMDoc, Msg + "| |,  易   ᮬ ");
  ELSE
   L_General.Error(Msg);
  END;
 END {RaiseCheckXCalcRestException};

 PUBLIC PROCEDURE curUSER2MDocTSN(interactive: SCAL[2]): LIKE(MDoc.TSN);
  VAR
   curMyFirm: P_Firm.tMyFirm;
   Result   : LIKE(MDoc.TSN);
   force    : SCAL[2];
 BEGIN
  SETEMPTY(Result);
  L_General.CallUs(~!MDoc.Date);
  force:=~interactive;
  IF ~force THEN
   L_General.CallUs(~!MDoc.MDocKind & ~!MDoc.Date);
   SAVE(MDocKind);
   SEARCH(MDocKind, MDocKind, , MDoc.MDocKind);
   force:=(MDoc.MDocKind # md_RPU) &
          (MDoc.MDocKind # md_Dvr) &
          (MDoc.MDocKind # md_RPk) &
          (~MDocKind.Activity |
           IsExternalMDocKind() |
           (MDocKind.MDocKind = md_ADo) | (MDocKind.MDocKind = md_OBK) | (MDocKind.MDocKind = md_Spc));
   RESTORE(MDocKind);
  END;
  IF force THEN
   SETEMPTY(curMyFirm);
   TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
    curMyFirm:=GetMDocMyFirm();
   EXCEPT
   ELSE
   END;
   Result:=L_Staff.Man2TSN(MDoc.Date, P_Man.curUSER2Man(), curMyFirm, 0, 1);
  END; (* IF force *)
  IF ~interactive & !Result THEN
   L_General.Error(" ଫ  室  ⠡ .   ⠭");
  END;
  RETURN Result;
 END {curUSER2MDocTSN};

 PUBLIC PROCEDURE GetMDocAuthor(): STRING[];
  VAR
   trgTNS: LIKE(Staff.TSN);
   Result: STRING[];
 BEGIN
  Result:="";
  IF (L_General.GetAPSiteID() = "10") &
     (MDoc.MDocKind = md_TOV) & (MDoc.Date >= 20\02\2013) THEN
   trgTNS:=L_XDoc.GetXDocAuthorTSN(L_XDoc.xdt_MDoc);
   IF ~!trgTNS THEN
    SEARCH(Staff, TSN, , trgTNS);
    CONFORM(Staff, Man);
    Result:=Staff.TSN+" "+Man.Name;
   END;
  END;
  RETURN Result;
 END {GetMDocAuthor};

 PUBLIC PROCEDURE IsRequiredMDocKind(trgMDocKind: LIKE(MDocKind.MDocKind); D: DATE): tRequiredMDocKind;
 BEGIN
  IF    (trgMDocKind = md_NPr)  THEN RETURN mdkrq_Required;
  ELSIF (trgMDocKind = md_TOV) |
        (trgMDocKind = md_NOV) |
        (trgMDocKind = md_APr) |
        (trgMDocKind = md_APP) |
        (trgMDocKind = md_ADo) |
        (trgMDocKind = md_ASp) |
        (trgMDocKind = md_ASO) |
        (trgMDocKind = md_DDA) |
        (trgMDocKind = md_AVb) |
        (trgMDocKind = md_APc) |
        (trgMDocKind = md_IsS) |
        (trgMDocKind = md_ITN) |
        (trgMDocKind = md_ISF) |
        (trgMDocKind = md_IAS) |
        (trgMDocKind = md_VSF) |
        (trgMDocKind = md_Nrd) |
        (trgMDocKind = md_DPr) |
        (trgMDocKind = md_DPk) |
        (trgMDocKind = md_VhS) |
        (trgMDocKind = md_VhA) |
        (trgMDocKind = md_VTN) |
        (trgMDocKind = md_Dvr) |
        (trgMDocKind = md_RPk) |
        (trgMDocKind = md_RPr) |
        (trgMDocKind = md_OBK) |
        (trgMDocKind = md_PPk) |
        (trgMDocKind = md_PPr) |
        (trgMDocKind = md_MSP) |
        (trgMDocKind = md_ViP) |
        (trgMDocKind = md_VPC) |
        (trgMDocKind = md_ISA) |
        (trgMDocKind = md_TCh) |
        (trgMDocKind = md_NDk) |
        (trgMDocKind = md_NlO) |
        (trgMDocKind = md_VOD) |
        (trgMDocKind = md_IOD)  THEN RETURN mdkrq_Required;
  ELSIF (trgMDocKind = md_Spc) |
        (trgMDocKind = md_IAU) |
        (trgMDocKind = md_RPU) |
        (trgMDocKind = md_RPN) |
        (trgMDocKind = md_RSZ) |
        (trgMDocKind = md_PPK) |
        (trgMDocKind = md_PPR) |
        (trgMDocKind = md_ZMC) |
        (trgMDocKind = md_IAP) |
        (trgMDocKind = md_VAP) |
        (trgMDocKind = md_VAU) |
        (trgMDocKind = md_PIO)  THEN RETURN mdkrq_Unrequired;
  ELSIF (trgMDocKind = md_ADg) |
        (trgMDocKind = md_APO) |
        (trgMDocKind = md_FPk) |
        (trgMDocKind = md_ZNr) |
        (trgMDocKind = md_FPr) |
        (trgMDocKind = md_RNR) |
        (trgMDocKind = md_SpB) |
        (trgMDocKind = md_PCh) |
        (trgMDocKind = md_RCh)  THEN RETURN mdkrq_Disabled;
  ELSE
   L_General.CallUs(0);
  END;
 END {IsRequiredMDocKind};

END.
