(*
%Copyright   (c) Polak Computer System
%Author      14.11.2002 09:54:50 POLAK\LDA
%Purpose     ⥪  ࠡ  ᢥﬨ    
%Type        library
%Specific    SYS
%Modified    14.05.2014 13:25:05 POLAK\GAV
%Environment
*)

 MODULE L_ManMlt [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Str, L_DatTim, DBD;

 PUBLIC PERMANENT VAR
  v_mm_Event: LIKE(ManMlt.Event);

 PUBLIC CONST
  mme_Registration      = 0;
  mme_MedExam           = 1;
  mme_DocDeliv          = 2;
  mme_MilitaryServ      = 3;
  mme_ContractServ      = 4;
  mme_AlternativeServ   = 5;
  mme_MilitaryGathering = 6;
  mme_Reserv            = 7;
  mme_OrderX            = 8;
  mme_ChangeAccount     = 9;

  mdt_00          = 0;
  mdt_01          = 1;
  mdt_02          = 2;
  mdt_03          = 3;
  mdt_Certificate = 4;
  mdt_Reserv      = 5;
  mdt_OrderX      = 6;

  mdt_PoolPart1 = " |ਯ᭮ ᢨ⥫⢮|. 㤮⮢७ |  |ࠢ";
  mdt_PoolPart2 = "஭஢|樮 ।ᠭ";
  mdt_FullPool  = mdt_PoolPart1 + "|" + mdt_PoolPart2;

  mmp_Officers       = 0;
  mmp_Eng_Technical  = 1;
  mmp_Humanitarian   = 2;
  mmp_Legal          = 3;
  mmp_Medical        = 4;
  mmp_Veterinary     = 5;
  mmp_Soldiers       = 6;
  mmp_Conscripts     = 7;

  mmp_PoolPart1      = "|୮-孨᪨|-㬠|ਤ᪨|樭᪨|ਭ";
  mmp_PoolPart2      = "| - ";
  mmp_FullPool       = mmp_PoolPart1 + "|" + mmp_PoolPart2;

  mms_Pool           ="-|1|2|3"; (*ManMlt.Sort*)

  mm_EventPool = " |"+
                 ". ᢨ⥫⢮|"+
                 "뤠 㬥|"+
                 "㦡  ਧ|"+
                 "㦡  ࠪ|"+
                 "ୠ⨢ 㦡|"+
                 " ᡮ|"+
                 "஭஢|"+
                 ". ।ᠭ|"+
                 "  ";

  mm_WindowNamePool = "ManMlt0E|"+
                      "ManMlt1E|"+
                      "ManMlt2E|"+
                      "ManMlt3E|"+
                      "ManMlt3E|"+
                      "ManMlt3E|"+
                      "ManMlt3E|"+
                      "ManMlt6E|"+
                      "ManMlt4E|"+
                      "ManMlt5E";

  mm_ReadyPool = " |"+
                 "६  |"+
                 "࠭祭 |"+
                 "  ⥫묨 ⪫ﬨ|"+
                 "|"+
                 "ਧ뢭, ਧ뢭";

  mm_ReadyPool_Short = "|||||";

  rt_Army  = 0;
  rt_Naval = 1;

  mrc_Soldier       = 0; (* ७  MltRank.Composit !!! *)
  mrc_Sailor        = 1;
  mrc_Sergeant      = 2;
  mrc_Foreman       = 3;
  mrc_Ensign        = 4;
  mrc_JuniorOfficer = 5;
  mrc_FirstOfficer  = 6;
  mrc_HigherOfficer = 7;
  mrc_Conscript     = 8;
  mrc_PreConscript  = 9;

  mrc_Pool = "|" +
             "|" +
             "ঠ|" +
             "設|" +
             "࠯騪  笠|" +
             "訥 |" +
             "訥 |" +
             "訥 |" +
             "ਧ뢭|" +
             "ਧ뢭";

  mgrp_Recruit       = 0;
  mgrp_Army          = 1;
  mgrp_Navy          = 2;
  mgrp_FSB           = 3;
  mgrp_Internal      = 4;
  mgrp_Border        = 5;
  mgrp_Emergency     = 6;
  mgrp_Communication = 7;
  mgrp_Railway       = 8;
  mgrp_Intelligence  = 9;
  mgrp_Guard         = 10;
  mgrp_CISArmy       = 11;
  mgrp_Training      = 12;

  mgrp_Pool = "- ਧ뢭, ਧ뢭|" +
              "1 㦥 ᨫ |" +
              "2 -᪮ 䫮|" +
              "3 ࠫ쭠 㦡 ᭮ ᨨ|" +
              "4 ७ ᪠  ᨨ|" +
              "5 ࠫ쭠 ࠭筠 㦡 ᨨ|" +
              "6 ⢮  १砩  ᨨ|" +
              "7 ᪠ ࠢ⥫⢥ 裡 ()|" +
              "8 ஦ ᪠ |" +
              "9 㦡 譥 ࠧ ᨨ|" +
              "0  ࠢ ࠭ ᨨ|" +
              "A ନ |" +
              "  ⮢";

 PUBLIC VAR
  mmas_From,
  mmas_UpTo    : DATE;
  mmas_DocType : LIKE(ManMlt.DocType);
  mmas_DocSer  : LIKE(ManMlt.DocSer);
  mmas_DocNbr  : LIKE(ManMlt.DocNbr);
  mmas_DocGiveS: LIKE(ManMlt.DocGiveS);
  mmas_DocGiveD: LIKE(ManMlt.DocGiveD);
  mmas_MltDep  : LIKE(ManMlt.MltDep);
  mmas_Grp     : LIKE(ManMlt.Grp);
  mmas_Sort    : LIKE(ManMlt.Sort);
  mmas_MltRank : LIKE(ManMlt.MltRank);
  mmas_Profil  : LIKE(ManMlt.Profil);
  mmas_Spec    : LIKE(ManMlt.Spec);
  mmas_CmndNum : LIKE(ManMlt.CmndNum);
  mmas_Liter   : LIKE(ManMlt.Liter);
  mmas_Marks   : LIKE(ManMlt.Marks);
  mmas_SpecC   : LIKE(ManMlt.SpecC);
  mmas_Ready   : LIKE(ManMlt.Ready);
  mmas_OrderX  : LIKE(ManMlt.OrderX);
  mmas_Comment : LIKE(ManMlt.Comment);

 PRIVATE PROCEDURE CondStandOnAnyManMltEvent(_Man : LIKE(Man.Man);
                                             _Date: DATE;
                                             Cond : STRING[]): SCAL[2];
  VAR
   Res: SCAL[2];
 BEGIN
  IF SELECT(ManMlt, Man, _Man) & SRCINSEL(ManMlt, LE, _Date) THEN
   WHILE OCCURE(ManMlt) DO
    IF L_DatTim.IsActive_Inc(_Date, ManMlt.From, ManMlt.UpTo) THEN
     Res:=^Cond;
     IF Res THEN
      RETURN 1;
     END;
    END;
    PREV(ManMlt);
   END; (* WHILE OCCURE(ManMlt) & (ManMlt.From >= _Date)... *)
  END;
  RETURN 0;
 END {CondStandOnAnyManMltEvent};

 PUBLIC PROCEDURE HasActualManMltEvent(_Man: LIKE(Man.Man); _Date: DATE; _Event: LIKE(ManMlt.Event)): SCAL[2];
 BEGIN
  RETURN SELECT(ManMlt, Event, _Man, _Event) & SRCINSEL(ManMlt, LE, _Date) & (ManMlt.UpTo >= _Date);
 END {HasActualManMltEvent};

 PUBLIC PROCEDURE SearchManMltEvent_wCurEvent(_Man      : LIKE(Man.Man);
                                              _Event    : LIKE(ManMlt.Event);
                                              CheckIntvl: SCAL[2]): SCAL[2];
  VAR
   _EvNbr: LIKE(ManMlt.EvNbr);
   _From,
   _UpTo : DATE;
 BEGIN
  _EvNbr:=ManMlt.EvNbr;
  _From :=ManMlt.From;
  _UpTo :=ManMlt.UpTo;
  IF SELECT(ManMlt, Event, _Man, _Event) THEN
   LAST(ManMlt);
   WHILE OCCURE(ManMlt) DO
    IF ~CheckIntvl |
       (_EvNbr # ManMlt.EvNbr) & L_DatTim.IsActiveInIntvl_Inc(_From, _UpTo, ManMlt.From, ManMlt.UpTo) THEN
      RETURN 1;
    END;
    PREV(ManMlt);
   END; (* WHILE OCCURE(ManMlt) ... *)
  END;
  RETURN 0;
 END {SearchManMltEvent_wCurEvent};

 PRIVATE PROCEDURE StandOnActiveReg(_Man: LIKE(Man.Man); _Date: DATE): SCAL[2];
 BEGIN
  RETURN HasActualManMltEvent(_Man, _Date, mme_Registration);
 END {StandOnActiveReg};

 PUBLIC PROCEDURE GetManMltReady(_Man: LIKE(Man.Man); _Date: DATE): LIKE(ManMlt.Ready);
  VAR
   _Ready: LIKE(ManMlt.Ready);
 BEGIN
  IF HasActualManMltEvent(_Man, _Date, mme_MedExam) | StandOnActiveReg(_Man, _Date) THEN
   RETURN ManMlt.Ready;
  ELSE
   RETURN "";
  END;
 END {GetManMltReady};

 PUBLIC PROCEDURE GetManMltEvent_AsStr(_Event: LIKE(ManMlt.Event)): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(mm_EventPool, _Event);
 END {GetManMltEvent_AsStr};

 PUBLIC PROCEDURE GetDocAttr_AsStr(_Man : LIKE(Man.Man);
                                   _Date: DATE;
                                   Dlm  : STRING[];
                                   Full : SCAL[2]): STRING[];
 BEGIN
  IF CondStandOnAnyManMltEvent(_Man, _Date,
                               "(ManMlt.Event = mme_Registration) |"+
                               "(ManMlt.Event = mme_DocDeliv)") THEN
   IF Full THEN
    RETURN " " + ManMlt.DocSer +   Dlm +
           " " + ManMlt.DocNbr +   Dlm +
           "뤠 " + ManMlt.DocGiveS + Dlm +
                       L_DatTim.DateStr(ManMlt.DocGiveD);
   ELSE
    RETURN ManMlt.DocSer + Dlm +
           ManMlt.DocNbr + Dlm +
           ManMlt.DocGiveS + Dlm +
           L_DatTim.DateStr(ManMlt.DocGiveD);
   END;
  ELSE
   RETURN "";
  END;
 END {GetDocAttr_AsStr};

 PUBLIC PROCEDURE MltRankComposCond(Age     : NUMERIC[0];
                                    Conscrip: SCAL[2]): SCAL[2];
 BEGIN
  IF (MltRank.Composit = 0(*  *)) |
     (~Conscrip &  ((MltRank.Composit = 7(*ਧ뢭   *)) |
                    (MltRank.Composit = 8(*ਧ뢭 *)))) THEN
   RETURN 0;
  END;
  IF    MltRank.Composit = 4(*訩 *) THEN
   RETURN Age <= 55;
  ELSIF MltRank.Composit = 5(*訩 *) THEN
   RETURN Age <= 60;
  ELSE
   RETURN Age <= 50;
  END;
 END {MltRankComposCond};

  PRIVATE PROCEDURE FillAllVariables();
  VAR
   i,
   FieldAmount: NUMERIC[0];
   VarName,
   FieldName  : STRING[];
 BEGIN
  FieldAmount:=DBD.FieldAmount(ManMlt);
  i:=10; (*!!! ய᪠ EvNbr, Man, Event, From, UpTo  ਡ 㬥*)

  WHILE i < FieldAmount DO
   VarName  :="mmas_" + DBD.FieldName(ManMlt, i);
   FieldName:="ManMlt." + DBD.FieldName(ManMlt, i);
   IF ~!^FieldName THEN
    ^VarName:=^FieldName;
   END;
   INC(i);
  END; (* WHILE i < FieldAmount...*)
  IF (ManMlt.Event = mme_Registration) |
     (ManMlt.Event = mme_DocDeliv) THEN
   (*mmas_From  mmas_UpTo 塞 ⮫쪮  mme_Registration *)
   IF ManMlt.Event = mme_Registration THEN
    mmas_From   :=ManMlt.From;
    mmas_UpTo   :=ManMlt.UpTo;
   END;
   mmas_DocType :=ManMlt.DocType;
   mmas_DocSer  :=ManMlt.DocSer;
   mmas_DocNbr  :=ManMlt.DocNbr;
   mmas_DocGiveS:=ManMlt.DocGiveS;
   mmas_DocGiveD:=ManMlt.DocGiveD;
  END;
 END {FillAllVariables};

 PUBLIC PROCEDURE GetManMltActualStatus(_Man: LIKE(Man.Man); _Date: DATE);
 BEGIN
  SAVE(ManMlt);
  SETEMPTY(mmas_From,
           mmas_UpTo,
           mmas_DocType,
           mmas_DocSer,
           mmas_DocNbr,
           mmas_DocGiveS,
           mmas_DocGiveD,
           mmas_MltDep,
           mmas_Grp,
           mmas_Sort,
           mmas_MltRank,
           mmas_Profil,
           mmas_Spec,
           mmas_SpecC,
           mmas_CmndNum,
           mmas_Liter,
           mmas_Marks,
           mmas_Ready,
           mmas_Comment);
  SELECT(ManMlt, Man, , _Man);
  WHILE OCCURE(ManMlt) & (ManMlt.From <= _Date) DO
   IF (ManMlt.Event = mme_Registration) |
      (ManMlt.Event = mme_MedExam)      |
      (ManMlt.Event = mme_DocDeliv)     |
      (ManMlt.Event = mme_ChangeAccount) THEN
    FillAllVariables();
   END;
   NEXT(ManMlt);
  END; (* WHILE OCCURE(ManMlt)...*)
  RESTORE(ManMlt);
 END {GetManMltActualStatus};

 PUBLIC PROCEDURE GetRealComposit(_Composit: LIKE(MltRank.Composit);
                                  _RankType: LIKE(MltRank.RankType)): SCAL[11];
 BEGIN
  IF    _Composit = 1 THEN
   IF _RankType = rt_Army THEN
    RETURN mrc_Soldier;
   ELSE
    RETURN mrc_Sailor;
   END;
  ELSIF _Composit = 2 THEN
   IF _RankType = rt_Army THEN
    RETURN mrc_Sergeant;
   ELSE
    RETURN mrc_Foreman;
   END;
  ELSE
   RETURN _Composit + 1;
  END;
 END {GetRealComposit};

 PUBLIC PROCEDURE GetRealComposit_asStr(_Composit: LIKE(MltRank.Composit);
                                        _RankType: LIKE(MltRank.RankType)): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(mrc_Pool, GetRealComposit(_Composit, _RankType));
 END {GetRealComposit_asStr};

END.
