(*
%Copyright   (c) Polak IT
%Author      05.08.2008 19:22:40 POLAK\San
%Purpose     ⨫  ⠬,  ⮬ ᫥,  㧪  MS Word.
%Type        library
%Specific    SYS
%Modified    01.12.2010 13:15:55 POLAK\San
%Environment
*)

 MODULE L_PmntU [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Pmnt, P_Firm, L_MDoc, L_XDoc, L_MSO;

 PUBLIC PROCEDURE wordSetVTB(vtbName: STRING[]; D: DATE; vtbValue: L_Pmnt.tValuesToBalance);
 BEGIN
  L_MSO.wordSetMoneyVar(vtbName+".Total", D, vtbValue[L_Pmnt.vtb_Total]);
  L_MSO.wordSetMoneyVar(vtbName+".Netto", D, vtbValue[L_Pmnt.vtb_Netto]);
  L_MSO.wordSetMoneyVar(vtbName         , D, vtbValue[L_Pmnt.vtb_Netto]);
  L_MSO.wordSetMoneyVar(vtbName+".VAT",   D, vtbValue[L_Pmnt.vtb_VAT]);
 END {wordSetVTB};

 PUBLIC PROCEDURE wordPrepareFirmUnderpay(_Firm  : LIKE(Firm.Firm);
                                          _MyFirm: P_Firm.tMyFirm;
                                          D      : DATE;
                                          Root   : STRING[]);
  VAR
   i           : NUMERIC[0];
   _Paid,
   _Underpay,
   t_Underpay  : L_Pmnt.tValuesToBalance;
 BEGIN
  i:=0;
  SETZERO(t_Underpay);
  SELECT(MDoc, Firm, , _Firm);
  WHILE OCCURE(MDoc) DO
   PROMPT("஢ઠ ﭨ  " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   IF MDoc.MyFirm = _MyFirm THEN
    IF L_Pmnt.E_IsSellMDoc() & L_Pmnt.E_IsMayBePaidMDoc() & (MDoc.Date<=D) THEN
     _Paid:=L_Pmnt.GetMDocPmntBalance(D, L_XDoc.max_DoneDTS);
     _Underpay:=L_Pmnt.vtbAdd(L_Pmnt.GetMDocAcpt(), _Paid);
     _Paid:=L_Pmnt.vtbInv(_Paid);
    ELSE
     SETZERO(_Underpay);
    END;
    IF (_Underpay[L_Pmnt.vtb_Total] # 0) |
       (_Underpay[L_Pmnt.vtb_Netto] # 0) |
       (_Underpay[L_Pmnt.vtb_VAT]   # 0) THEN
     CONFORM(MDoc, Contract);
     CONFORM(MDoc, MDocKind);
     CONFORM(Contract, CntrT);
     t_Underpay:=L_Pmnt.vtbAdd(t_Underpay, _Underpay);
     Root:="upMDoc"+L_MSO.IndexStr(i);
     L_MSO.wordSetVarsByFile_wAlias("MDoc", Root);
     wordSetVTB(Root            , D, L_Pmnt.GetMDocAcpt());
     wordSetVTB(Root+".Underpay", D, _Underpay);
     wordSetVTB(Root+".Paid"    , D, _Paid);
     L_MSO.wordSetVar(Root+".BarCode", L_MDoc.BarCode());
     L_MSO.wordSetVarsByFile_wPrefix("MDocKind", Root+".");
     L_MSO.wordSetVarsByFile_wPrefix("Contract", Root+".");
     L_MSO.wordSetVarsByFile_wPrefix("CntrT",    Root+".Contract.");
     INC(i);
    END;
   END;
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)
  L_MSO.extSetWordTable("upMDocTbl", i, L_MSO.tt_Soft);
  wordSetVTB("Underpay", D, t_Underpay);
 END {wordPrepareFirmUnderpay};

END.
