(*
%Copyright   (c) Polak Computer System
%Author      05.03.2001 23:52:19 MOG
%Purpose      ᨩ᪨ 
%Type        library
%Specific    SYS
%Modified    17.09.2014 20:36:10 POLAK\Bor
%Environment
*)

 MODULE L_Russia [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tAddressFormat = SCAL[4];
  tPostKind      = SCAL[3];
  tKlAdrId       = STRING[1+2+3+3+3+4+4+2];

 PUBLIC CONST
  KLADR_Void  = 000;

  ao_ManAdr   = 0;
  ao_CtcAdr   = 1;

  at_BthMA      = 0;
  at_RgMA       = 1;
  at_DwMA       = 2;
  at_CtMA       = 3;

(*!*)  reg_72 = 72;
(*!*)  reg_77 = 77;
(*!*)  reg_78 = 78;
(*!*)  reg_50 = 50;
(*!*)  reg_62 = 62;
(*!*)  reg_69 = 69;

  reg_Chuvashia    = 21;
  reg_MoscowOblast = 50;
  reg_Ryazan       = 62;
  reg_Tver         = 69;
  reg_Tyumen       = 72;
  reg_Moscow       = 77;
  reg_StPetersburg = 78;
  reg_Baikonur     = 99;

  ap_Country  = 0;
  ap_Zip      = 1;
  ap_Region   = 2;
  ap_Distr    = 3;
  ap_TownT    = 4;
  ap_Town     = 5;
  ap_VillageT = 6;
  ap_Village  = 7;
  ap_StreetT  = 8;
  ap_Street   = 9;
  ap_House    = 10;
  ap_Block    = 11;
  ap_Build    = 12;
  ap_Flat     = 13;
  ap_CountryN = 90;
  ap_RegionN  = 91;

  lv_Region   = 1;
  lv_District = 2;
  lv_City     = 3;
  lv_Village  = 4;
  lv_Street   = 5;
  lv_House    = 6;
  lv_Flat     = 7;
  lv_All      = 7;

  lv_Pool     = "࠭|||த|ᥫ 㭪|||";

  c_USSR         = 000;
  c_Russia       = 643;
  c_Russia_asStr = FLDTOSTR(c_Russia, "0", 3);

  c_StreetT      = " 䨪樨|㫨||०|㫮|頤|஥|ᯥ||ࠩ|좠|⠫|㯨||ய| |-|ਣ|㣮|㤪||||ꥧ|ᥫ(|ࠦ|ࠦ.|த|-.| |()||ॢ|| |ண|ਪ|/ 㤪|/ |/ ⠭|.|.ᨢ|||⠢|㫮||..|ଠ|||||宧||म|||.|᭨|宧|||ᨢ||窮|⥮⠭|||.㭪|饦⨥|ࠣ||஢||⤥||ᨮ||॥||.|.-|ଠ|頤||. -|⠭|ꥬ|||஢|⠭||ᥫ|..|.⠭||稭|.⤥|஬.|ᥪ|ᥫ|㫮|䨫.||ࠡ.ᥫ.|ࠧ१|ࠧꥧ|४|६.|窠|஢|㤭|뭮||ᠤ|ᠤ.⮢-|ᠭ਩|-䨫|ᥫ|᪢|᫮|ᮢ宧|ᮮ㦥||⠤|⠭|஦|஥|ꥧ||࣮ |ࠪ|ࡠ||ᠤ졠|⮪|祡.宧|ଠ|宧⢮||業.ᠤ|.ᠤ.|||/ .() 㭪|/ |/ ࠧꥧ|⠭|/ ଠ|ࡠ|ࠦ-. .|ᠤ. . ⮢-|஬宧|⮪||᪨ 騪|ॣ||⮪|ᥪ|ଥ᪮ 宧⢮|筮 - ⭥⢮|᪮ ⭥⢮|⭮||ઠ|⮭";
  c_VillageT     = " 䨪樨| | |᪮ |த| ᥫ|ॢ|筮- | |/ ⠭|⠢|⠫||宧| |窮|ࠩ|ᥫ 㭪|饦⨥|⤥|ᨮ|᪨ |ᮡ 宧-|ᥫ|ᥫ .⨯|ᥫ  -|⮢ -|ࠡ稩 ᥫ|ᠭ਩|ᥫ|᫮|ᮢ宧|⠭|⠭|ࡠ||⮪|祡 宧-||業. ᠤ졠|諠||㤪||ᥫ()|த|᪨ |-ୠ|/ .㭪|/ ⠭.㭪|/ 㤪|/ ଠ|/ ࠧꥧ| ᨢ||.ன|ଠ||म|᭨⢮||㭨樯.|ᥫ 㭪||஢||⮬|஢ -|ଠ|魮 |頤||⠭||⠭|ᥫ ᪮|稭|⮢ ⤥.|ਨ|஬諥 |䨫਩|ࠧꥧ|㤭|ᠤ|ᠤ.⮢⢮|ᠭ-䨫਩|஦|஥||㯨||ᠤ졠|䠪|ଠ|宧⢮|. 業.ᠤ졠| 業.ᠤ졠||業⠫ |||/ ||/ ଠ|ࡠ|ᠤ. . ⮢-|⮤ண| ࠩ|ᨢ| |஬宧";
  c_TownT        = " 䨪樨|த| ᥫ|⮢ ⤥|ᥫ . ⨯|ࠡ稩 (.) .|ᥫ᪨ |ᥫᮢ|| ᥫ|ᥫ᪠ .|ᥫ᪮ .ࠧ.||ᥫ᪮ ᥫ|ᨢ|㬮|ᥫ";

  sf_ManSINumber = "000-000-000 00"; (* sf - string format *)

  c_StreetT_Short  = " |.||.|.|.|஥|-|.|.|-|-|.||/|/|/|ਣ|㣮|㤪||||ꥧ|ᥫ|ࠦ||த|||||.||/||ਪ|/ 㤪|/ |/ |||-||.|㫮||/|ଠ|||.|-|||म||||-|宧|||ᨢ||.|/||||.|ࠣ||஢||.||.||॥||/|/||-|||.|ꥬ|||-|/⠭||.||/||稭|/|஬|ᥪ|ᥫ|㫮|.|||ࠧ१|৤|४|६|窠|஢|㤭|뭮||ᠤ||ᠭ.|ᠭ-.|.|᪢|||ᮮ||⠤|.|஦|.|ꥧ|.||ࠪ|/|-|ᠤ졠|-|宧|ଠ|-|.|| |||/_|/_|/_৤|⠭|/_|ࡠ||||⮪||/|ॣ||⮪|ᥪ|/||/|⭮||ઠ|⮭";
  c_VillageT_Short = " |/|/|/|.||.||/|/ |.|-|.||..|.|.|..|.|.|.|/||.|...|/|/|..|ᠭ.|.|.|.|-|.|/|.|-|宧|.||諠||㤪|.|ᥫ|த||/|/ |/ |/ 㤪|/ |/ ৤|.|.|/|ଠ||म|-|||||஢||.|/|.|/|-||.||/⠭||稭|/|ਨ|஬|.|৤|㤭|ᠤ||ᠭ-|஦|.|.|.|-|ᠤ졠|䠪|ଠ|-| | | ⮮||||/_||/_|ࡠ||⮤ண|ࠩ|ᨢ||";
  c_TownT_Short    = " |.||/|...||/|/|.||/|/||/|ᨢ|㬮|";

  af_Short   = 0; (* tAddressFormat *)
  af_Full    = 1;
  af_Browser = 2;
  af_Post    = 3;

  capk_Stndr          = 0; (* CtcAdr.PostKind *)
  capk_PostRest       = 1;
  capk_PostBox        = 2;
  capk_Pool           = " | ॡ|᪨ 騪";
  capk_PoolShort      = "| |/";
  capk_PoolForWdo     = "   | |/";

  tit_Error  = 0;
  tit_Choice = 1;

 IMPORT L_General, L_Str, Str, L_DatTim, L_StdFrm, L_AFM, Math, L_Events, L_MSO;

 PRIVATE TYPE
  tAddressPart    = SCAL[100];
  tAdrOrigin      = SCAL[2];
  tAdrType        = SCAL[4];

  tKlAdrActuality = SCAL[5];

 PRIVATE CONST
  kla_Actual     = 0;
  kla_Renamed    = 1;
  kla_Transfered = 2;
  kla_Reserved   = 3;
  kla_Removed    = 4;
  kla_Pool       = " |२|९稭|??? !!!|  ";

  kf_Region   = "Region";
  kf_District = "District";
  kf_City     = "City";
  kf_Village  = "Village";
  kf_Street   = "Street";
  kf_House    = "House";

 PRIVATE PERMANENT VAR
  KLADR_Region   : LIKE(KlAdr.Region);
  KLADR_District : LIKE(KlAdr.District);
  KLADR_City     : LIKE(KlAdr.City);
  KLADR_Village  : LIKE(KlAdr.Village);
  KLADR_Street   : LIKE(KlAdr.Street);

 PRIVATE VAR
  KLADR_Region1  : LIKE(KlAdr.Region);
  KLADR_Region2  : LIKE(KlAdr.Region);
  KLADR_District1: LIKE(KlAdr.District);
  KLADR_District2: LIKE(KlAdr.District);
  KLADR_City1    : LIKE(KlAdr.City);
  KLADR_City2    : LIKE(KlAdr.City);
  KLADR_Village1 : LIKE(KlAdr.Village);
  KLADR_Village2 : LIKE(KlAdr.Village);
  KLADR_Street1  : LIKE(KlAdr.Street);
  KLADR_Street2  : LIKE(KlAdr.Street);

  ByDistrCenter      : SCAL[2];
  KLADR_HasDuplicates: SCAL[2];
  KLADR_Duplicates   : STRING[];

  glb_Date     : DATE;
  glb_PostBox  : STRING[];
  glb_Country  : LIKE(Country.Country);
  glb_Region   : LIKE(Region.Region);
  glb_TownT,
  glb_VillageT,
  glb_StreetT  : SCAL[250];
  glb_Zip      : STRING[6];
  glb_House,
  glb_Block,
  glb_Build,
  glb_Flat,
  glb_RegionN,
  glb_Distr,
  glb_Town,
  glb_Village,
  glb_Street   : STRING[];
  glb_PostKind : tPostKind;

 PUBLIC PROCEDURE intCheckKLADRState(OnAfterEdIns: SCAL[2]): SCAL[2];
  VAR
   ProblemMsg: STRING[];
 BEGIN
  TABLE.Get("KlAdr").AccessDataMode:=adm_SOFT;
  SETEMPTY(ProblemMsg);
  IF ~SELECT(KlAdr, VerDTS) THEN
   ProblemMsg:=" 믮  ";
  ELSE
   NARROWSEL(KlAdr, VerDTS);
   IF NEXTINEXTENDEDSEL(KlAdr, VerDTS) THEN
    ProblemMsg:="    襭";
   END;
  END;
  IF ~!ProblemMsg THEN
   IF OnAfterEdIns THEN
    L_StdFrm.Choice(ProblemMsg + "||" +
                    " 믮 ஢   ᮮ⢥⢨ " +
                    L_StdFrm.HR() +
                    " ࠭ ⮩ ஡   ");
    RETURN 0;
   ELSE
    STDMSG(ProblemMsg + L_StdFrm.HR() + " ࠭ ⮩ ஡   ", STOP_AND_CALL_ADMIN);
   END;
  ELSE
   RETURN 1;
  END;
 END {intCheckKLADRState};

 PUBLIC PROCEDURE CheckKLADRState();
  VAR
   Dummy: SCAL[2];
 BEGIN
  Dummy:=intCheckKLADRState(0);
 END {CheckKLADRState};

 PUBLIC PROCEDURE Check_MayChooseCountry(File: STRING[]; trgCountry: LIKE(Country.Country));
 BEGIN
  IF ~!trgCountry THEN
   SEARCH(Country, Country, , trgCountry);
   IF Country.NotCntry THEN
    L_General.Assert(File = "CstDclr", "' ࠭'  ᯮ짮 ⮫쪮  ࠢ筨 ' 樨'");
   END;
  END;
 END {Check_MayChooseCountry};

 PUBLIC PROCEDURE CheckCountryIsActive(trgCountry: LIKE(Country.Country); D: DATE);
  VAR
   Msg: STRING[];
 BEGIN
  IF ~!trgCountry THEN
   Msg:="";
   SEARCH(Country, Country, , trgCountry);
   IF ~!Country.BegDate & (D<Country.BegDate) THEN
    Msg:="࠭ "+trgCountry+' "'+Country.Name+'"   ⢮  '+L_DatTim.DateStr(D);
   ELSIF D > Country.EndDate THEN
    Msg:="࠭ "+trgCountry+' "'+Country.Name+'" 㦥 ⠫ ⢮  '+L_DatTim.DateStr(D);
   END;
   IF ~!Msg THEN
    L_General.Error(Msg);
   END;
  END;
 END {CheckCountryIsActive};

 PUBLIC PROCEDURE Set_glb_AdrVar(trgCountry : LIKE(Country.Country);
                                 trgZip     : STRING[6];
                                 trgRegion  : LIKE(Region.Region);
                                 trgRegionN : LIKE(Region.Name);
                                 trgDistr,
                                 trgTown,
                                 trgVillage,
                                 trgStreet  : STRING[];
                                 trgTownT,
                                 trgVillageT,
                                 trgStreetT : SCAL[250];
                                 trgHouse,
                                 trgBlock,
                                 trgBuild,
                                 trgFlat,
                                 trgPostBox : STRING[];
                                 trgPostKind: tPostKind;
                                 trgDate    : DATE);
 BEGIN
  glb_Country :=trgCountry;
  glb_Region  :=trgRegion;
  glb_RegionN :=trgRegionN;
  glb_TownT   :=trgTownT;
  glb_VillageT:=trgVillageT;
  glb_StreetT :=trgStreetT;
  glb_Zip     :=trgZip;
  glb_House   :=trgHouse;
  glb_Block   :=trgBlock;
  glb_Build   :=trgBuild;
  glb_Flat    :=trgFlat;
  glb_Distr   :=trgDistr;
  glb_Town    :=trgTown;
  glb_Village :=trgVillage;
  glb_Street  :=trgStreet;
  glb_PostBox :=trgPostBox;
  glb_PostKind:=trgPostKind;
  glb_Date    :=trgDate;
 END {Set_glb_AdrVar};

 PUBLIC PROCEDURE Set_glb_AdrVar_ToEmpty();
 BEGIN
  Set_glb_AdrVar(EMPTYOF(Country.Country),
                 EMPTYOF(STRING[]),
                 EMPTYOF(Region.Region),
                 EMPTYOF(STRING[]),
                 EMPTYOF(STRING[]),
                 EMPTYOF(STRING[]),
                 EMPTYOF(STRING[]),
                 EMPTYOF(STRING[]),
                 EMPTYOF(SCAL[250]),
                 EMPTYOF(SCAL[250]),
                 EMPTYOF(SCAL[250]),
                 EMPTYOF(STRING[]),
                 EMPTYOF(STRING[]),
                 EMPTYOF(STRING[]),
                 EMPTYOF(STRING[]),
                 EMPTYOF(STRING[]),
                 EMPTYOF(tPostKind),
                 EMPTYOF(DATE));
 END {Set_glb_AdrVar_ToEmpty};

 PUBLIC PROCEDURE Get_glb_AdrVar(VAR trgCountry : LIKE(Country.Country);
                                 VAR trgZip     : STRING[6];
                                 VAR trgRegion  : LIKE(Region.Region);
                                 VAR trgRegionN : STRING[];
                                 VAR trgDistr,
                                     trgTown,
                                     trgVillage,
                                     trgStreet  : STRING[];
                                 VAR trgTownT,
                                     trgVillageT,
                                     trgStreetT : SCAL[250];
                                 VAR trgHouse,
                                     trgBlock,
                                     trgBuild,
                                     trgFlat,
                                     trgPostBox : STRING[];
                                 VAR trgPostKind: tPostKind;
                                 VAR trgDate    : DATE);
 BEGIN
  trgCountry :=glb_Country;
  trgRegion  :=glb_Region;
  trgTownT   :=glb_TownT;
  trgVillageT:=glb_VillageT;
  trgStreetT :=glb_StreetT;
  trgZip     :=glb_Zip;
  trgHouse   :=glb_House;
  trgBlock   :=glb_Block;
  trgBuild   :=glb_Build;
  trgFlat    :=glb_Flat;
  trgRegionN :=glb_RegionN;
  trgDistr   :=glb_Distr;
  trgTown    :=glb_Town;
  trgVillage :=glb_Village;
  trgStreet  :=glb_Street;
  trgPostBox :=glb_PostBox;
  trgPostKind:=glb_PostKind;
  trgDate    :=glb_Date;
 END {Get_glb_AdrVar};

 PUBLIC PROCEDURE CurKlAdrId(): tKlAdrId;
 BEGIN
  RETURN ""+KlAdr.Level+KlAdr.Region+KlAdr.District+KlAdr.City+KlAdr.Village+KlAdr.Street+KlAdr.House+KlAdr.AddCode;
 END {CurKlAdrId};

 PUBLIC PROCEDURE PositionOnKlAdr(trgKlAdrId: tKlAdrId);
 BEGIN
  SEARCH(KlAdr, KlAdr, , Str.Slice(trgKlAdrId,  0, 1),
                         Str.Slice(trgKlAdrId,  1, 2),
                         Str.Slice(trgKlAdrId,  3, 3),
                         Str.Slice(trgKlAdrId,  6, 3),
                         Str.Slice(trgKlAdrId,  9, 3),
                         Str.Slice(trgKlAdrId, 12, 4),
                         Str.Slice(trgKlAdrId, 16, 4),
                         Str.Slice(trgKlAdrId, 20, 2));
 END {PositionOnKlAdr};

 PRIVATE PROCEDURE Actualer(newAddCode, oldAddCode: LIKE(KlAdr.AddCode)): SCAL[2];
 BEGIN
  RETURN (newAddCode = 0) |
         ((oldAddCode # 0) & (newAddCode > oldAddCode));
 END {Actualer};

 PRIVATE PROCEDURE SrcActualKlAdr(VAR trgType: LIKE(KlAdr.Type); VAR trgName: LIKE(KlAdr.Name));
  VAR
   trgAddCode: LIKE(KlAdr.AddCode);
 BEGIN
  SETEMPTY(trgAddCode);
  REPEAT
   IF !trgAddCode | Actualer(KlAdr.AddCode, trgAddCode) THEN
    trgType:=KlAdr.Type;
    trgName:=KlAdr.Name;
    IF KlAdr.AddCode = 0 THEN
     RETURN;
    ELSE
     trgAddCode:=KlAdr.AddCode;
    END;
   END;
  UNTIL ~NEXT(KlAdr);
 END {SrcActualKlAdr};

 PRIVATE PROCEDURE SelActualKlAdrByName(trgType: LIKE(KlAdr.Type));
  VAR
   trgAddCode: LIKE(KlAdr.AddCode);
   trgKlAdrId: tKlAdrId;
 BEGIN
  IF ~!trgType THEN
   SETEMPTY(trgAddCode);
   WHILE OCCURE(KlAdr) & (trgAddCode # 0) DO
    IF (trgType = KlAdr.Type) &
       (!trgAddCode | Actualer(KlAdr.AddCode, trgAddCode)) THEN
     trgKlAdrId:=CurKlAdrId();
     trgAddCode:=KlAdr.AddCode;
    END;
    NEXT(KlAdr);
   END;
   IF ~!trgAddCode THEN
    PositionOnKlAdr(trgKlAdrId);
    CHANGESEL(KlAdr, Name, , KlAdr.Level, KlAdr.Name, KlAdr.Region, KlAdr.District, KlAdr.City, KlAdr.Village, KlAdr.Street, KlAdr.House);
   END;
  END;
 END {SelActualKlAdrByName};

 PRIVATE PROCEDURE ClearFollowing(Lev: LIKE(KlAdr.Level));
 BEGIN
  IF Lev < lv_House THEN
   SETEMPTY(glb_House, glb_Block, glb_Build, glb_Flat);
  END;
  IF Lev < lv_Street THEN
   SETEMPTY(glb_Street, glb_StreetT);
  END;
  IF Lev < lv_Village THEN
   SETEMPTY(glb_Village, glb_VillageT);
  END;
  IF Lev < lv_City THEN
   SETEMPTY(glb_Town, glb_TownT);
  END;
  IF Lev < lv_District THEN
   SETEMPTY(glb_Distr);
  END;
  IF Lev < lv_Region THEN
   SETEMPTY(glb_RegionN);
  END;
  SETEMPTY(glb_PostBox);
 END {ClearFollowing};

 PRIVATE PROCEDURE IsDistrCenter(): SCAL[2];
  VAR
   curType: LIKE(KlAdr.Type);
   Result: SCAL[2];
 BEGIN
  L_General.CallUs((KlAdr.Level = lv_City) | (KlAdr.Level = lv_Village));
  Result:=0;
  IF ~!KlAdr.Status THEN
   IF KlAdr.Status # 0 THEN
    Result:=1;
   ELSIF ((KlAdr.Level = lv_City) & (KlAdr.District = KLADR_Void)) |
         ((KlAdr.Level = lv_Village) & (KlAdr.District = KLADR_Void) & (KlAdr.City = KLADR_Void)) THEN
    Result:=1;
   ELSIF KlAdr.AddCode # 0 THEN
    curType:=KlAdr.Type;
    SAVE(KlAdr);
    IF    KlAdr.Level = lv_City THEN
     SELECT(KlAdr, Name, , KlAdr.Level, KlAdr.Name, KlAdr.Region, KLADR_Void);
    ELSIF KlAdr.Level = lv_Village THEN
     SELECT(KlAdr, Name, , KlAdr.Level, KlAdr.Name, KlAdr.Region, KLADR_Void, KLADR_Void);
    ELSE
     L_General.CallUs(0);
    END;
    WHILE OCCURE(KlAdr) & ~Result DO
     IF KlAdr.Type = curType THEN
      Result:=1;
     END;
     NEXT(KlAdr);
    END; (* WHILE OCCURE(KlAdr) ... *)
    RESTORE(KlAdr);
   END;
  ELSE
   Result:=(KlAdr.Level = lv_City) &
           ((KlAdr.District = KLADR_Void) | (KlAdr.City = 001));
  END;
  RETURN Result;
 END {IsDistrCenter};

 PRIVATE PROCEDURE IsDebilDistrCenterDuplicate(trgField: STRING[]): SCAL[2];
 BEGIN
  RETURN (trgField = kf_District) &
         ((KlAdr.Level = lv_City) | (KlAdr.Level = lv_Village)) &
         (KLADR_District1 = KLADR_Void) & (*।騩 - ⮦  ࠩ 業஬*)
         (KLADR_District2 = KLADR_Void) & (*।騩 - ⮦  ࠩ 業஬*)
         (KlAdr.District  # KLADR_Void) &
         IsDistrCenter();
 END {IsDebilDistrCenterDuplicate};

 PRIVATE PROCEDURE SetVars(trgField: STRING[]; trgType: LIKE(KlAdr.Type));
 BEGIN
  IF !trgType | (trgType = KlAdr.Type) THEN
   IF ~IsDebilDistrCenterDuplicate(trgField) THEN
    IF ^("KLADR_"+trgField+"1") > KlAdr.^trgField THEN
     ^("KLADR_"+trgField+"1"):=KlAdr.^trgField;
    END;
    IF ^("KLADR_"+trgField+"2") < KlAdr.^trgField THEN
     ^("KLADR_"+trgField+"2"):=KlAdr.^trgField;
    END;
    IF ~!KlAdr.Index THEN
     INC(KLADR_Duplicates, KlAdr.Name + " ( " + KlAdr.Index + ")" + "|");
    END;
    IF ^("KLADR_"+trgField+"1") # ^("KLADR_"+trgField+"2") THEN
     SETEMPTY(^("KLADR_"+trgField));
     KLADR_HasDuplicates:=1;
    ELSE
     ^("KLADR_"+trgField):=^("KLADR_"+trgField+"1");
    END;
   END; (* IF ~IsDebilDistrCenterDuplicate(trgField) ... *)
  END;
 END {SetVars};

 PRIVATE PROCEDURE SetVarsByZip(trgLevel: LIKE(KlAdr.Level);
                                trgIndex: LIKE(KlAdr.Index));
 BEGIN
  SELECT(KlAdr, Index, , trgIndex, trgLevel);
  WHILE OCCURE(KlAdr) DO
   IF trgLevel >= lv_Street THEN
    SetVars(kf_Street, "");
   END;
   IF trgLevel >= lv_Village THEN
    SetVars(kf_Village, "");
   END;
   IF trgLevel >= lv_City THEN
    SetVars(kf_City, "");
   END;
   IF trgLevel >= lv_District THEN
    SetVars(kf_District, "");
   END;
   IF trgLevel >= lv_Region THEN
    SetVars(kf_Region, "");
   END;
   NEXT(KlAdr);
  END; (* WHILE OCCURE(KlAdr) ... *)
 END {SetVarsByZip};

 PUBLIC PROCEDURE SetAdrByZip(trgZip: LIKE(KlAdr.Index));
  VAR
   dummy: LIKE(KlAdr.Type);
 BEGIN
  CheckKLADRState();
  APP.Get().NewPrompt(" ");
  L_General.Assert(~!trgZip, "  ");
  ResetKLADR();
  IF ~!trgZip THEN
   SetVarsByZip(lv_House,    trgZip);
   SetVarsByZip(lv_Street,   trgZip);
   SetVarsByZip(lv_Village,  trgZip);
   SetVarsByZip(lv_City,     trgZip);
   SetVarsByZip(lv_District, trgZip);
   SetVarsByZip(lv_Region,   trgZip);
  END;
  L_General.Assert(KLADR_Region # 00, "  室騥  ");
  glb_Zip:=trgZip;
  glb_Country :=c_Russia;
  ClearFollowing(lv_Region);
  IF SEARCH(Region, Region, KLADR_Region) THEN
   glb_Region :=Region.Region;
   glb_RegionN:=Region.Name;
  END;
  IF SELECT(KlAdr, KlAdr, lv_District, KLADR_Region, KLADR_District) THEN
   SrcActualKlAdr(dummy, glb_Distr);
  END;
  IF SELECT(KlAdr, KlAdr, lv_City,     KLADR_Region, KLADR_District, KLADR_City) THEN
   SrcActualKlAdr(glb_TownT, glb_Town);
  END;
  IF SELECT(KlAdr, KlAdr, lv_Village,  KLADR_Region, KLADR_District, KLADR_City, KLADR_Village) THEN
   SrcActualKlAdr(glb_VillageT, glb_Village);
  END;
  IF SELECT(KlAdr, KlAdr, lv_Street,   KLADR_Region, KLADR_District, KLADR_City, KLADR_Village, KLADR_Street) THEN
   SrcActualKlAdr(glb_StreetT, glb_Street);
  END;
 END {SetAdrByZip};

 PRIVATE PROCEDURE SetCondition(Lev            : LIKE(KlAdr.Level);
                               wShowDuplicates: SCAL[2]);
 BEGIN
  CheckKLADRState();
  APP.Get().NewPrompt(" ");
  ResetKLADR();
  IF glb_Country = c_Russia THEN
   IF    Lev > lv_Region THEN
    IF ~!glb_Region THEN
     SELECT(KlAdr, KlAdr, , lv_Region, glb_Region);
     SETEMPTY(KLADR_Region);
    ELSE
     SELECT(KlAdr, KlAdr, , lv_Region);
    END;
   ELSIF Lev = lv_Region THEN
    SELECT(KlAdr, KlAdr, , lv_Region);
   ELSE
    RETURN;
   END;
   WHILE OCCURE(KlAdr) DO
    PROMPT(KlAdr.Name);
    SetVars(kf_Region, "");
    NEXT(KlAdr);
   END; (* WHILE OCCURE(KlAdr) ... *)

   ByDistrCenter:=0;
   IF    Lev > lv_District THEN
    IF ~!glb_Distr THEN
     SELECT(KlAdr, Name, , lv_District, glb_Distr, KLADR_Region);
     SETEMPTY(KLADR_District);
    ELSIF (Lev > lv_City) & ~!glb_Town THEN (*ࠩ 業*)
     SELECT(KlAdr, Name, , lv_City, glb_Town, KLADR_Region);
     ByDistrCenter:=1;
    ELSIF (Lev > lv_Village) & ~!glb_Village THEN (*ࠩ 業*)
     SELECT(KlAdr, Name, , lv_Village, glb_Village, KLADR_Region);
     ByDistrCenter:=1;
    ELSE
     SELECT(KlAdr, KlAdr, , lv_District, KLADR_Region, KLADR_Void);
    END;
   ELSIF Lev = lv_District THEN
    SELECT(KlAdr, KlAdr, , lv_District, KLADR_Region);
   ELSE
    RETURN;
   END;
   WHILE OCCURE(KlAdr) DO
    PROMPT(KlAdr.Name);
    IF ~ByDistrCenter | IsDistrCenter() THEN
     SetVars(kf_District, "");
    END;
    NEXT(KlAdr);
   END; (* WHILE OCCURE(KlAdr) ... *)

   IF    Lev > lv_City THEN
    IF ~!glb_Town THEN
     SELECT(KlAdr, Name, , lv_City, glb_Town, KLADR_Region, KLADR_District);
     SETEMPTY(KLADR_City);
     SelActualKlAdrByName(glb_TownT);
    ELSE
     SELECT(KlAdr, KlAdr, , lv_City, KLADR_Region, KLADR_District, KLADR_Void);
    END;
   ELSIF Lev = lv_City THEN
    SELECT(KlAdr, KlAdr, , lv_City, KLADR_Region, KLADR_District);
   ELSE
    RETURN;
   END;
   WHILE OCCURE(KlAdr) DO
    PROMPT(KlAdr.Name);
    SetVars(kf_City, glb_TownT);
    NEXT(KlAdr);
   END; (* WHILE OCCURE(KlAdr) ... *)

   IF    Lev > lv_Village THEN
    IF ~!glb_Village THEN
     SELECT(KlAdr, Name, , lv_Village, glb_Village, KLADR_Region, KLADR_District, KLADR_City);
     SETEMPTY(KLADR_Village);
     SelActualKlAdrByName(glb_VillageT);
    ELSE
     SELECT(KlAdr, KlAdr, , lv_Village, KLADR_Region, KLADR_District, KLADR_City, KLADR_Void);
    END;
   ELSIF Lev = lv_Village THEN
    SELECT(KlAdr, KlAdr, , lv_Village, KLADR_Region, KLADR_District, KLADR_City);
   ELSE
    RETURN;
   END;
   WHILE OCCURE(KlAdr) DO
    PROMPT(KlAdr.Name);
    SetVars(kf_Village, glb_VillageT);
    NEXT(KlAdr);
   END; (* WHILE OCCURE(KlAdr) ... *)

   IF    Lev > lv_Street THEN
    IF ~!glb_Street THEN
     SELECT(KlAdr, Name, , lv_Street, glb_Street,  KLADR_Region, KLADR_District, KLADR_City, KLADR_Village);
     SETEMPTY(KLADR_Street);
     SelActualKlAdrByName(glb_StreetT);
    ELSE
     SELECT(KlAdr, KlAdr, , lv_Street, KLADR_Region, KLADR_District, KLADR_City, KLADR_Village, KLADR_Void);
    END;
   ELSIF Lev = lv_Street THEN
    SELECT(KlAdr, KlAdr, , lv_Street, KLADR_Region, KLADR_District, KLADR_City, KLADR_Village);
   ELSE
    RETURN;
   END;
   WHILE OCCURE(KlAdr) DO
    PROMPT(KlAdr.Name);
    SetVars(kf_Street, glb_StreetT);
    NEXT(KlAdr);
   END; (* WHILE OCCURE(KlAdr) ... *)
  END;
  IF wShowDuplicates & KLADR_HasDuplicates THEN
   L_StdFrm.Question("   ꥪ   ." +
                     "||" + " ᮡ    ." +
                     "||" + KLADR_Duplicates);
  END;
 END {SetCondition};

 PRIVATE PROCEDURE TestZipByKlAdr(VAR ErrMsg  : STRING[]);
 BEGIN
  SETEMPTY(ErrMsg);
  IF (glb_Country = c_Russia) THEN
   IF !KlAdr.Index THEN
    ErrMsg:=" 㤠 ।   ᭮ "+L_StdFrm.THR(" 稭")+"1.       |2.   ᮮ⢥ ";
   ELSIF (KlAdr.Index # STRTOFLD(glb_Zip, NUMERIC)) THEN
    ErrMsg:=" ⮢  (" + glb_Zip  + ")| ᮮ⢥     (" + KlAdr.Index + ")";
   END;
  END;
 END {TestZipByKlAdr};

 PRIVATE PROCEDURE TestOtherZipInCity(): SCAL[2];
  VAR
   trgIndex: LIKE(KlAdr.Index);
 BEGIN
  trgIndex:=KlAdr.Index;
  SAVE(KlAdr);
  SELECT(KlAdr, KlAdr, , lv_House,  KLADR_Region, KLADR_District, KLADR_City, KLADR_Village, KLADR_Street);
  WHILE OCCURE(KlAdr) DO
   IF ~!KlAdr.Index & (KlAdr.Index # trgIndex) THEN
    RESTORE(KlAdr);
    RETURN 1;
   END;
   NEXT(KlAdr);
  END; (* WHILE OCCURE(KlAdr) ... *)
  RESTORE(KlAdr);
  RETURN 0;
 END {TestOtherZipInCity};

 PUBLIC PROCEDURE GetZipByKlAdr(): LIKE(KlAdr.Index);
  VAR
   Result: LIKE(KlAdr.Index);
 BEGIN
  SETEMPTY(Result);
  CheckKLADRState();
  SetCondition(lv_All, 1);
  IF    PosToKlAdrHouse(glb_House, glb_Block, glb_Build) THEN
   Result:=KlAdr.Index;
  ELSIF SELECT(KlAdr, KlAdr, lv_Street,   KLADR_Region, KLADR_District, KLADR_City, KLADR_Village, KLADR_Street) & ~!KlAdr.Index THEN
   Result:=KlAdr.Index;
  ELSIF SELECT(KlAdr, KlAdr, lv_Village,  KLADR_Region, KLADR_District, KLADR_City, KLADR_Village) & ~!KlAdr.Index THEN
   Result:=KlAdr.Index;
  ELSIF SELECT(KlAdr, KlAdr, lv_City,     KLADR_Region, KLADR_District, KLADR_City) & ~!KlAdr.Index THEN
   IF TestOtherZipInCity() THEN
    L_StdFrm.Choice(" ᮮ⢥⢨   |㤥 ⠢  த᪮ ⠬");
   END;
   Result:=KlAdr.Index;
  ELSIF SELECT(KlAdr, KlAdr, lv_District, KLADR_Region, KLADR_District) & ~!KlAdr.Index THEN
   Result:=KlAdr.Index;
  END;
  L_General.Assert(~!Result, "     ");
  RETURN Result;
 END {GetZipByKlAdr};

 PRIVATE PROCEDURE GetAnyType_asStr(pool: STRING[]; val: LIKE(ManAdr.StreetT)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF !val | (val = 0)   THEN
   SETEMPTY(Result);
  ELSE
   Result:=L_Str.PoolItem(pool, val);
  END;
  RETURN Result;
 END {GetAnyType_asStr};

 PUBLIC PROCEDURE StreetT_asStr(trgStreetT: LIKE(ManAdr.StreetT)): STRING[];
 BEGIN
  RETURN GetAnyType_asStr(c_StreetT_Short, trgStreetT);
 END {StreetT_asStr};

 PUBLIC PROCEDURE StreetT_asLongStr(trgStreetT: LIKE(ManAdr.StreetT)): STRING[];
 BEGIN
  RETURN GetAnyType_asStr(c_StreetT, trgStreetT);
 END {StreetT_asLongStr};

 PUBLIC PROCEDURE VillageT_asStr(trgVillageT: LIKE(ManAdr.VillageT)): STRING[];
 BEGIN
  RETURN GetAnyType_asStr(c_VillageT_Short, trgVillageT);
 END {VillageT_asStr};

 PUBLIC PROCEDURE VillageT_asLongStr(trgVillageT: LIKE(ManAdr.VillageT)): STRING[];
 BEGIN
  RETURN GetAnyType_asStr(c_VillageT, trgVillageT);
 END {VillageT_asLongStr};

 PUBLIC PROCEDURE TownT_asStr(trgTownT: LIKE(ManAdr.TownT)): STRING[];
 BEGIN
  RETURN GetAnyType_asStr(c_TownT_Short, trgTownT);
 END {TownT_asStr};

 PUBLIC PROCEDURE TownT_asLongStr(trgTownT: LIKE(ManAdr.TownT)): STRING[];
 BEGIN
  RETURN GetAnyType_asStr(c_TownT, trgTownT);
 END {TownT_asLongStr};

 PUBLIC PROCEDURE GetManAdrVillageT_asStr(): STRING[];
 BEGIN
  RETURN VillageT_asLongStr(ManAdr.VillageT);
 END {GetManAdrVillageT_asStr};

 PUBLIC PROCEDURE GetManAdrTownT_asStr(): STRING[];
 BEGIN
  RETURN TownT_asLongStr(ManAdr.TownT);
 END {GetManAdrTownT_asStr};

 PUBLIC PROCEDURE GetManAdrStreetT_asStr(): STRING[];
 BEGIN
  RETURN StreetT_asLongStr(ManAdr.StreetT);
 END {GetManAdrStreetT_asStr};

 PRIVATE PROCEDURE ConvertToMNSFormat(_Value: STRING[]): STRING[];
  VAR
   i      : NUMERIC[0];
   tmpstr,
   Result : STRING[];
 BEGIN
  i:=0;
  SETEMPTY(Result);
  WHILE i < Str.Length(_Value) DO
   tmpstr:=L_Str.Char(_Value, i);
   IF tmpstr#"." THEN
    IF tmpstr=" " THEN
     tmpstr:="_";
    END;
    Result:=Result+tmpstr;
   END;
   INC(i);
  END; (* WHILE i <= Str.Length(_Value)...*)
  RETURN Str.Cap(Result);
 END {ConvertToMNSFormat};

 PRIVATE PROCEDURE GetRegionNPart(trgRegion: LIKE(KlAdr.Region); Part: SCAL[3]): STRING[];
  VAR
   i       : NUMERIC[0];
   _EndS,
   tmpstr,
   Result  : STRING[];
 BEGIN
  IF    trgRegion = reg_Moscow THEN
   Result:="᪢||த";
  ELSIF trgRegion = reg_StPetersburg THEN
   Result:="-||த";
  ELSIF trgRegion = reg_Baikonur THEN
   Result:="||த";
  ELSIF trgRegion = reg_Chuvashia THEN (*0083305 24.01.2011 18:43:40 POLAK\Bor*)
   Result:="㢠᪠ 㡫 -|㢠|㢠";
  ELSE
   SEARCH(Region, Region, , trgRegion);
   i:=0; SETEMPTY(_EndS, Result);
   LOOP
    tmpstr:=Str.Item(Region.Name, " ", i);
    IF !tmpstr THEN
     EXIT;
    ELSIF L_Str.IsEqStrI(tmpstr, "㡫") THEN
     _EndS:="|㡫";
    ELSIF L_Str.IsEqStrI(tmpstr, "") THEN
     _EndS:="|";
    ELSIF L_Str.IsEqStrI(tmpstr, "ࠩ") | L_Str.IsEqStrI(tmpstr, "") | L_Str.IsEqStrI(tmpstr, "") THEN
     _EndS:=Str.Small(tmpstr)+"|"+Str.Small(tmpstr);
    ELSE
     Result:=Result+" "+tmpstr;
    END;
    INC(i);
   END;
   Result:=Result+"|"+_EndS;
  END;
  RETURN L_Str.PoolItem(Str.Condense(Result), Part);
 END {GetRegionNPart};

 PUBLIC PROCEDURE RegionN_asStr(trgRegion: LIKE(KlAdr.Region)): STRING[];
 BEGIN
  RETURN GetRegionNPart(trgRegion, 0);
 END {RegionN_asStr};

 PUBLIC PROCEDURE RegionT_asStr(trgRegion: LIKE(KlAdr.Region)): STRING[];
 BEGIN
  RETURN GetRegionNPart(trgRegion, 1);
 END {RegionT_asStr};

 PUBLIC PROCEDURE RegionT_asLongStr(trgRegion: LIKE(KlAdr.Region)): STRING[];
 BEGIN
  RETURN GetRegionNPart(trgRegion, 2);
 END {RegionT_asLongStr};

 PUBLIC PROCEDURE RegionN_InPFRFormat(trgRegion: LIKE(KlAdr.Region)): STRING[];
 BEGIN
  RETURN Str.Cap(RegionN_asStr(trgRegion));
 END {RegionN_InPFRFormat};

 PUBLIC PROCEDURE RegionT_InPFRFormat(trgRegion: LIKE(KlAdr.Region)): STRING[];
 BEGIN
  RETURN Str.Cap(RegionT_asStr(trgRegion));
 END {RegionT_InPFRFormat};

 PRIVATE PROCEDURE Any_InMNSFormat(trgPool: STRING[]; trgItem: NUMERIC[0]): STRING[];
  VAR
   Result:STRING[];
 BEGIN
  IF !trgItem | (trgItem = 0) THEN
   SETEMPTY(Result);
  ELSE
   Result:=ConvertToMNSFormat(Str.Item(trgPool, "|", trgItem));
  END;
  RETURN Result;
 END {Any_InMNSFormat};

 PUBLIC PROCEDURE StreetT_InMNSFormat(trgItem: NUMERIC[0]): STRING[];
 BEGIN
  RETURN Any_InMNSFormat(c_StreetT_Short, trgItem);
 END {StreetT_InMNSFormat};

 PUBLIC PROCEDURE VillageT_InMNSFormat(trgItem: NUMERIC[0]): STRING[];
 BEGIN
  RETURN Any_InMNSFormat(c_VillageT_Short, trgItem);
 END {VillageT_InMNSFormat};

 PUBLIC PROCEDURE TownT_InMNSFormat(trgItem: NUMERIC[0]): STRING[];
 BEGIN
  RETURN Any_InMNSFormat(c_TownT_Short, trgItem);
 END {TownT_InMNSFormat};

 PRIVATE PROCEDURE _GetPool_InMNSFormat(srcPool: STRING[]): STRING[];
  VAR
   dstPool: STRING[];
   i      : NUMERIC[0];
 BEGIN
  i:=1;
  dstPool:=" "; (*!!!!*)
  WHILE ~!Str.Item(srcPool, "|", i) DO
   dstPool:=dstPool + "|" + Any_InMNSFormat(srcPool, i) ;
   INC(i);
  END;
  RETURN dstPool;
 END {_GetPool_InMNSFormat};

 PUBLIC PROCEDURE GetStreetTPool_InMNSFormat(): STRING[];
 BEGIN
  RETURN _GetPool_InMNSFormat(c_StreetT_Short);
 END {GetStreetTPool_InMNSFormat};

 PUBLIC PROCEDURE GetVillageTPool_InMNSFormat(): STRING[];
 BEGIN
  RETURN _GetPool_InMNSFormat(c_VillageT_Short);
 END {GetVillageTPool_InMNSFormat};

 PUBLIC PROCEDURE GetTownTPool_InMNSFormat(): STRING[];
 BEGIN
  RETURN _GetPool_InMNSFormat(c_TownT_Short);
 END {GetTownTPool_InMNSFormat};

 PRIVATE PROCEDURE StrToScal(s: STRING[]; VAR r: SCAL[1E7]): SCAL[2];
 BEGIN
  TRY
   SE_EXCEPTIONHANDLING(0(*EXCEPTIONHANDLING_OFF*));
   r:=s;
   RETURN 1;
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode # L_General.ec_rt_Overfilling THEN
    RAISE();
   END;
  END;
  RETURN 0;
 END {StrToScal};

 PRIVATE PROCEDURE GetPart(_Source: STRING[]; PartNbr: tAddressPart): STRING[];
 BEGIN
  RETURN Str.Condense(L_Str.AnyItem(_Source, ",", PartNbr));
 END {GetPart};

 PRIVATE PROCEDURE GetCountryCode(_Source: STRING[]): STRING[];
  VAR
   tmpstr: STRING[];
 BEGIN
  tmpstr:=GetPart(_Source, ap_Country);
  IF !tmpstr & ~!Str.Item(_Source, ",", 0) THEN
   tmpstr:=c_Russia_asStr;
  END;
  RETURN tmpstr;
 END {GetCountryCode};

 PUBLIC PROCEDURE GetPartOfAddress(_Source: STRING[]; PartNbr: tAddressPart): STRING[];
  VAR
   tmpstr  : STRING[];
   _Region : LIKE(Region.Region);
   _Country: LIKE(Country.Country);
 BEGIN
  IF    PartNbr=ap_RegionN THEN
   tmpstr:=GetPart(_Source, ap_Region);
   IF StrToScal(tmpstr, _Region) & SEARCH(Region, Region, _Region) THEN
    RETURN Region.Name;
   ELSE
    RETURN tmpstr;
   END;
  ELSIF PartNbr=ap_CountryN THEN
   tmpstr:=GetCountryCode(_Source);
   IF StrToScal(tmpstr, _Country) & SEARCH(Country, Country, _Country) THEN
    RETURN Country.Name;
   ELSE
    RETURN tmpstr;
   END;
  ELSIF PartNbr=ap_Country THEN
   RETURN GetCountryCode(_Source);
  ELSE
   RETURN GetPart(_Source, PartNbr);
  END; (* IF *)
 END {GetPartOfAddress};

 PRIVATE PROCEDURE AddComma(S: STRING[]): STRING[];
 BEGIN
  IF ~!S THEN
   RETURN S+", ";
  ELSE
   RETURN S;
  END;
 END {AddComma};

 PUBLIC PROCEDURE RegionNameMeanCapital(trgRegionN: LIKE(Region.Name); trgTown: STRING[]): STRING[];
 BEGIN
  IF !trgRegionN | (SELECT(Region, RegionN, trgRegionN) & ~!Region.Capital & ~!trgTown & L_Str.IsEqStrI(Region.Capital, trgTown)) THEN
   RETURN "";
  ELSE
   RETURN trgRegionN;
  END;
 END {RegionNameMeanCapital};

 PRIVATE PROCEDURE Concatenate2Str(str1, str2: STRING[]; VAR S:STRING[]);
 BEGIN
  IF ~!str2 THEN
   S:=AddComma(S) + str1 + str2;
  END;
 END {Concatenate2Str};

 PRIVATE PROCEDURE AddPart_wTypeName(type: SCAL[250]; pool, name: STRING[]; VAR S: STRING[]);
 BEGIN
  IF ~!name THEN
   S:=AddComma(S);
   IF ~!type & (type # 0) THEN
    S:=S + L_Str.PoolItem(pool, type) + " ";
   END;
   S:=S + name;
  END;
 END {AddPart_wTypeName};

 PRIVATE PROCEDURE GetValueByFormat(Val0, Val1, Val2, Val3, Val4, Val5 : STRING[]; Format: tAddressFormat): STRING[];
 BEGIN
  IF    Format = af_Short           THEN
   RETURN Val0;
  ELSIF Format = af_Full            THEN
   RETURN Val1;
  ELSIF Format = af_Browser         THEN
   RETURN Val2;
  ELSIF Format = af_Post THEN
   IF    !glb_PostKind THEN
    RETURN "";
   ELSIF glb_PostKind = capk_Stndr    THEN
    RETURN Val3;
   ELSIF glb_PostKind = capk_PostBox  THEN
    RETURN Val4;
   ELSIF glb_PostKind = capk_PostRest THEN
    RETURN Val5;
   ELSE
    L_General.CallUs(0);
   END;
  ELSE
   L_General.CallUs(0);
  END;
 END {GetValueByFormat};

 PRIVATE PROCEDURE Concatenate9Strings(s1, s2, s3, s4, s5, s6, s7, s8, s9: STRING[]): STRING[];
  VAR
   Result: STRING[];
   Idx   : NUMERIC[0];
 BEGIN
  Result:=s1;
  Idx   :=2;
  WHILE Idx <= 9 DO
   IF ~!(^("s" + L_Str.IntStr(Idx))) THEN
    Result:=AddComma(Result) + (^("s" + L_Str.IntStr(Idx)));
   END;
   INC(Idx);
  END;
  RETURN Result;
 END {Concatenate9Strings};

 PUBLIC PROCEDURE Adr_asStr(Format: tAddressFormat): STRING[];
  VAR
   Result,
   sPostBox,
   sZip,
   sCountry,
   sRegion,
   sDistrict,
   sTown,
   sVillage,
   sStreet,
   sHouseBlockBuild,
   sFlat            : STRING[];
 BEGIN
  SETEMPTY(Result, sPostBox, sZip, sCountry,sRegion, sDistrict, sTown, sVillage, sStreet, sHouseBlockBuild, sFlat);
  IF ~!glb_PostKind THEN
   IF (glb_Country # c_Russia) & SEARCH(Country, Country, glb_Country) THEN
    Concatenate2Str("", Country.Name, sCountry);
   END;
   Concatenate2Str("",       glb_Zip,                                      sZip);
   Concatenate2Str("",       RegionNameMeanCapital(glb_RegionN, glb_Town), sRegion);
   Concatenate2Str("ࠩ ",  glb_Distr,                                    sDistrict);
   AddPart_wTypeName(glb_TownT,    GetValueByFormat(c_TownT_Short,    c_TownT,    c_TownT,    c_TownT_Short,    c_TownT_Short,    c_TownT_Short,    Format), glb_Town,    sTown);
   AddPart_wTypeName(glb_VillageT, GetValueByFormat(c_VillageT_Short, c_VillageT, c_VillageT, c_VillageT_Short, c_VillageT_Short, c_VillageT_Short, Format), glb_Village, sVillage);
   AddPart_wTypeName(glb_StreetT,  GetValueByFormat(c_StreetT_Short,  c_StreetT,  c_StreetT,  c_StreetT_Short,  c_StreetT_Short,  c_StreetT_Short,  Format), glb_Street,  sStreet);
   Concatenate2Str(GetValueByFormat("",       " ",      " ",      ". ",    ". ",    ". ",    Format), glb_House, sHouseBlockBuild);
   Concatenate2Str(GetValueByFormat(". ", " ",   " ",   ". ", ". ", ". ", Format), glb_Block, sHouseBlockBuild);
   Concatenate2Str(GetValueByFormat(". ",  "஥ ", "஥ ", ". " , ". ",  ". ",  Format), glb_Build, sHouseBlockBuild);
   IF L_Str.TestStrAlowChar(Str.Slice(glb_Flat, 0, 1), "09") THEN
    Concatenate2Str(GetValueByFormat("", ". ", "", ".", "", "", Format), glb_Flat, sFlat);
   ELSE
    Concatenate2Str("", glb_Flat, sFlat); (*   㪠    ᫮ ⨯ " 饭 1" *)
   END;
   IF glb_PostKind = capk_PostBox THEN
    IF Str.Pos(glb_PostBox, "/") = Str.Length(glb_PostBox) THEN
     sPostBox:= "/ " + glb_PostBox;
    ELSE
     sPostBox:= glb_PostBox;
    END;
   END;
 
   IF    (Format = af_Short) | (Format = af_Full) | (Format = af_Browser) THEN
    IF Format = af_Browser THEN
     SETEMPTY(sZip, sFlat);
    END;
    IF    glb_PostKind = capk_Stndr    THEN
     Result:=Concatenate9Strings(sCountry,   sZip, sRegion, sDistrict, sTown, sVillage, sStreet, sHouseBlockBuild, sFlat);
    ELSIF glb_PostKind = capk_PostBox  THEN
     Result:=Concatenate9Strings(sCountry,   sZip, sRegion, sDistrict, sTown, sVillage, sPostBox, "", "");
    ELSIF glb_PostKind = capk_PostRest THEN
     Result:=Concatenate9Strings(sCountry,   sZip, sRegion, sDistrict, sTown, sVillage, "", "", "");
    ELSE
     L_General.CallUs(0);
    END;
   ELSIF Format = af_Post   THEN
    IF    glb_PostKind = capk_Stndr    THEN
     Result:=Concatenate9Strings(sStreet,     sHouseBlockBuild, sFlat, sTown, sVillage, sDistrict, sRegion, sCountry, "");
    ELSIF glb_PostKind = capk_PostBox  THEN
     Result:=Concatenate9Strings(sPostBox,    "",               "",    sTown, sVillage, sDistrict, sRegion, sCountry, "");
    ELSIF glb_PostKind = capk_PostRest THEN
     Result:=Concatenate9Strings("",          "",               "",    sTown, sVillage, sDistrict, sRegion, sCountry, "");
    ELSE
     L_General.CallUs(0);
    END;
   ELSE
    L_General.CallUs(0);
   END;
  END; (* IF ~!glb_PostKind ... *)
  RETURN Result;
 END {Adr_asStr};

 PRIVATE PROCEDURE extAdr_asStr(Short, PFRFormat: SCAL[2]): STRING[];
  VAR
   IsForeigner: SCAL[2];
   S,
   tmp        : STRING[];
 BEGIN
  SETEMPTY(S);
  L_General.Assert(~!glb_Country, " ᪠ ।  ࠭");
  IsForeigner:= glb_Country # c_Russia;
  IF IsForeigner THEN
   S:=glb_Country + ",";
  ELSE
   IF Short THEN
    S:=",";
   ELSE
    S:=c_Russia_asStr + ",";
   END;
  END;
  L_General.Assert(IsForeigner | ~!glb_Zip, " ⮢ ");
  S:=S+glb_Zip+",";
  L_General.Assert(IsForeigner | (~!glb_Region & (glb_Region # 0)), " ᪠ ।  ॣ");
  IF PFRFormat THEN
   IF glb_Region = 0 THEN
    S:=S + glb_RegionN + ",";
   ELSE
    S:=S + Str.Condense(RegionN_InPFRFormat(glb_Region)+" "+RegionT_InPFRFormat(glb_Region)) + ",";
   END;
  ELSE
   IF ~!glb_Region THEN
    S:=S + glb_Region + ",";
   ELSE
    S:=S +",";
   END;
  END;
  IF ~!glb_Distr THEN
   S:=S + glb_Distr +" -,";
  ELSE
   S:=S +",";
  END;
  tmp:=Str.Cap(glb_Town);
  IF ~!tmp THEN
   IF ~( ((glb_Region = reg_Moscow)       & Str.Match(tmp, "")) |
         ((glb_Region = reg_StPetersburg) & Str.Match(tmp, "")) ) THEN
    L_General.Assert(~!L_Str.PoolItem(c_TownT, glb_TownT), "L_Russia:  । 祭 ᥫ 㭪 "+ glb_TownT);
    S:=S + tmp + " "+ TownT_InMNSFormat(glb_TownT);
   END;
  END;
  S:=S + ",";
  L_General.Assert(~(!glb_VillageT # !glb_Village),
                   "   ᥫ 㭪|    ६");
  IF ~!glb_Village THEN
   IF ~IsForeigner & (L_General.GetAPSiteID() # "SN") & (L_Str.PoolItem(c_VillageT_Short, glb_VillageT) = "") & !glb_Town THEN
    L_General.Error("ᥫ 㭪 'த'     'த'");
   END;
   L_General.Assert(~!L_Str.PoolItem(c_VillageT, glb_VillageT), "L_Russia:  । 祭 ᥫ 㭪 "+glb_VillageT);
   S:=S+glb_Village+" "+VillageT_InMNSFormat(glb_VillageT);
  END;
  S:=S+",";
  L_General.Assert(~(!glb_StreetT # !glb_Street),
                   "   㫨|    ६");
  IF ~!glb_Street THEN
   L_General.Assert(~!L_Str.PoolItem(c_StreetT, glb_StreetT), "L_Russia:  । 祭 㫨 "+glb_StreetT);
   S:=S+glb_Street+" "+StreetT_InMNSFormat(glb_StreetT);
  END;
  S:=S+",";
  S:=S+glb_House+",";
  S:=S+glb_Block;
  IF ~!glb_Build THEN
   IF ~!glb_Block THEN
    S:=S+" ";
   END;
   S:=S+" "+glb_Build;
  END;
  S:=S+",";
  S:=S+glb_Flat;
  RETURN Str.Cap(S);
 END {extAdr_asStr};

 PUBLIC PROCEDURE TaxAdr_asStr(): STRING[];
 BEGIN
  RETURN extAdr_asStr(1, 0);
 END {TaxAdr_asStr};

 PUBLIC PROCEDURE PFRAdr_asStr(): STRING[];
 BEGIN
  RETURN extAdr_asStr(1, 1);
 END {PFRAdr_asStr};

 PUBLIC PROCEDURE FullTaxAdr_asStr(): STRING[];
 BEGIN
  RETURN extAdr_asStr(0, 0);
 END {FullTaxAdr_asStr};

 PUBLIC PROCEDURE GetAdrOKATO(): STRING[];
  VAR
   _OKATO : LIKE(Region.OKATO);
 BEGIN
  IF SEARCH(Region, Region, glb_Region) THEN
   _OKATO:=Region.OKATO;
  ELSE
   SETEMPTY(_OKATO);
  END;
  IF ~!_OKATO THEN
   RETURN FLDTOSTR(_OKATO, "00 000 000 0");
  ELSE
   RETURN "";
  END;
 END {GetAdrOKATO};

 PRIVATE PROCEDURE CheckSeq(Seq: STRING[]; Digits: NUMERIC[0]): SCAL[2];
  CONST
   VK = "3 7 2 4 10 3 5 9 4 6 8";
  VAR
   i, S: NUMERIC[0];
 BEGIN
  i:=0; S:=0;
  WHILE i < (Digits-1) DO
   INC(S, STRTOFLD(Seq[i], NUMERIC)*STRTOFLD(Str.Item(VK, " ", 12-Digits+i), NUMERIC));
   INC(i);
  END;
  RETURN (S MOD 11 MOD 10) = STRTOFLD(Seq[i], NUMERIC);
 END {CheckSeq};

 PUBLIC PROCEDURE CheckINN(_INN: STRING[]): SCAL[2];
 BEGIN
  IF Str.Length(_INN)=10 THEN
   RETURN CheckSeq(_INN, 10);
  ELSIF Str.Length(_INN)=12 THEN
   IF ~CheckSeq(_INN, 11) THEN
    RETURN 0;
   END;
   RETURN CheckSeq(_INN, 12);
  ELSE
   RETURN 0;
  END;
 END {CheckINN};

 PUBLIC PROCEDURE CheckSINumber(_SINumber: LIKE(Man.SINumber); Silent: SCAL[2]);
  VAR
   NumberAsStr: STRING[];
   i          : NUMERIC[0];
   _CntrNum   : NUMERIC[0];
 BEGIN
  IF ~!_SINumber THEN
   L_General.Assert(_SINumber > 100000000, "ࠢ ");
   NumberAsStr:=_SINumber;
   _CntrNum:=0;
   i:=1;
   WHILE i <= 09 DO
    INC(_CntrNum, STRTOFLD(NumberAsStr[09-i], NUMERIC)*i);
    INC(i);
   END;
   _CntrNum:=(_CntrNum MOD 101) MOD 100;
   L_General.Assert((_CntrNum = (_SINumber MOD 100)) | Silent,
                    "ࠢ  ( 室 ஢ ஫쭮 ࠧ鸞)");
  END;
 END {CheckSINumber};

 PUBLIC PROCEDURE intRussianToTransliteration(s: STRING[]; ResultInOriginalCase: SCAL[2]): STRING[];
  CONST
   PatRussiant = "||||||||||||||||||||||||||||||";
   PatTranslit = "A|B|V|G|D|E|E|ZH|Z|I|I|K|L|M|N|O|P|R|S|T|U|F|KH|TC|CH|SH|SHCH|Y|E|IU|IA";
  VAR
   i       : NUMERIC[0];
   S,
   Char,
   CharLat,
   Original: STRING[];
 BEGIN
  Original:=s;
  SETEMPTY(S);
  s:=Str.Cap(s);
  i:=0;
  LOOP
   Char:=L_Str.Char(s, i);
   IF !Char THEN
    EXIT;
   END;
   IF L_Str.TestStrAlowChar(Char, "") | L_Str.TestStrAlowChar(Char, "") THEN
    IF (Char = "") | (Char = "") THEN
     SETEMPTY(CharLat);
    ELSE
     CharLat:=L_Str.PoolItem(PatTranslit, L_Str.PositionInPool(PatRussiant, Char));
    END;

    IF ResultInOriginalCase & ~!CharLat & (s # Original) THEN
     CharLat:=Str.Small(CharLat);
     IF Char = L_Str.Char(Original, i) THEN
      CharLat:=Str.Cap(Str.Slice(CharLat, 0, 1)) + Str.Delete(CharLat, 0, 1);
     END;
    END;
   ELSE
    CharLat:=Char;
   END;
   S:=S + CharLat;
   INC(i);
  END;
  RETURN S;
 END {intRussianToTransliteration};

 PUBLIC PROCEDURE RussianToTransliteration(s: STRING[]): STRING[];
 BEGIN
  RETURN intRussianToTransliteration(s, 0);
 END {RussianToTransliteration};

 PRIVATE PROCEDURE ResetKLADR();
 BEGIN
  KLADR_Region1  :=MAXOF(KLADR_Region1);
  KLADR_Region2  :=MINOF(KLADR_Region2);
  KLADR_District1:=MAXOF(KLADR_District1);
  KLADR_District2:=MINOF(KLADR_District2);
  KLADR_Village1 :=MAXOF(KLADR_Village1);
  KLADR_Village2 :=MINOF(KLADR_Village2);
  KLADR_City1    :=MAXOF(KLADR_City1);
  KLADR_City2    :=MINOF(KLADR_City2);
  KLADR_Street1  :=MAXOF(KLADR_Street1);
  KLADR_Street2  :=MINOF(KLADR_Street2);
  SETZERO(KLADR_Region, KLADR_District, KLADR_Village, KLADR_City, KLADR_Street,
          KLADR_HasDuplicates);
  SETEMPTY(KLADR_Duplicates);
 END {ResetKLADR};

 PRIVATE PROCEDURE GetHouseNumberFromStr(HouseStr: STRING[]; Idx: NUMERIC[0]): NUMERIC[0];
  VAR
   SingleHouseStr: STRING[];
 BEGIN
  SingleHouseStr:=Str.Item(HouseStr, "-", Idx);
  IF L_Str.TestStrAlowChar(SingleHouseStr, "09") THEN
   RETURN STRTOFLD(SingleHouseStr, NUMERIC);
  ELSE
   RETURN EMPTYOF(NUMERIC[0]);
  END;
 END {GetHouseNumberFromStr};

 PRIVATE PROCEDURE PosToKlAdrHouse(trgHouse, trgBlock, trgBuild : STRING[]): SCAL[2];
  VAR
   HouseStr: STRING[];
   MaxHouse,
   MinHouse: NUMERIC[0];
   i, j    : NUMERIC[0];
   Shift   : SCAL[3];
   DHouse  : NUMERIC[0];
 BEGIN
  IF ~!trgHouse | ~!trgBlock | ~!trgBuild THEN
   IF L_Str.TestStrAlowChar(trgHouse, "09") THEN
    DHouse:=STRTOFLD(trgHouse, NUMERIC);
   ELSE
    SETEMPTY(DHouse);
   END;

   SELECT(KlAdr, KlAdr, , lv_House, KLADR_Region, KLADR_District, KLADR_City, KLADR_Village, KLADR_Street);
   WHILE OCCURE(KlAdr) DO
    i:=0;
    REPEAT
     HouseStr:=Str.Condense(Str.Item(KlAdr.Name, ",", i));
     IF !trgBlock & !trgBuild THEN
      IF L_Str.IsEqStrI(trgHouse, HouseStr) THEN
       RETURN 1;
      END;
      IF ~!DHouse THEN
       Shift:=0;
       IF    (HouseStr = "") & ((DHouse MOD 2) = 0) THEN
        RETURN 1;
       ELSIF (HouseStr = "") & ((DHouse MOD 2) = 1) THEN
        RETURN 1;
       ELSIF Str.Match(HouseStr, "(*-*)") | Str.Match(HouseStr, "(*-*)") THEN
        Shift:=2;
       ELSIF Str.Match(HouseStr, "*-*") THEN
        Shift:=1;
       END;
       IF Shift > 0 THEN
        HouseStr:=Str.Item(HouseStr, "()", Shift-1);
        MinHouse:=GetHouseNumberFromStr(HouseStr, 0);
        MaxHouse:=GetHouseNumberFromStr(HouseStr, 1);
        IF ~!MinHouse & ~!MaxHouse THEN
         IF (DHouse >= MinHouse) & (DHouse <= MaxHouse) &
            ((DHouse MOD Shift) = (MinHouse MOD Shift)) THEN
          RETURN 1;
         END;
        END;
       END;
      END;
     ELSIF !trgBuild THEN
      IF ((!trgHouse & Str.Match(HouseStr, "*")) &
          L_Str.IsEqStrI(trgBlock, Str.Item(HouseStr, "", 0))) |
         (L_Str.IsEqStrI(trgHouse, Str.Item(HouseStr, "", 0)) &
          L_Str.IsEqStrI(trgBlock, Str.Item(HouseStr, "", 1))) THEN
       RETURN 1;
      END;
     ELSIF !trgBlock THEN
      IF ((!trgHouse & Str.Match(HouseStr, "*")) &
          L_Str.IsEqStrI(trgBuild, Str.Item(HouseStr, "", 0))) |
         (L_Str.IsEqStrI(trgHouse, Str.Item(HouseStr, "", 0)) &
          L_Str.IsEqStrI(trgBuild, Str.Item(HouseStr, "", 1))) THEN
       RETURN 1;
      END;
     END;
     INC(i);
    UNTIL HouseStr = "";
    NEXT(KlAdr);
   END; (* WHILE OCCURE(KlAdr) ... *)
  END;
  RETURN 0;
 END {PosToKlAdrHouse};

 PUBLIC PROCEDURE CheckAdrByKlAdr(InformType : SCAL[2];
                                  trgNotKLADR: SCAL[2];
                                  Lev        : LIKE(KlAdr.Level));
  CONST
   BadAdr = "  ᮮ⢥ : ";
  VAR
   ErrMsg : STRING[];
 BEGIN
  SETEMPTY(ErrMsg);

  IF glb_Country = c_Russia THEN
   SetCondition(lv_All, 0);
   IF !KLADR_Region THEN
    ErrMsg:=BadAdr + "  ⠪ ॣ";
   ELSIF !KLADR_District THEN
    ErrMsg:=BadAdr + L_Str.PoolItem("  ⠪ ࠩ| 㪠 ࠩ!", !glb_Distr);
   ELSIF !KLADR_City THEN
    ErrMsg:=BadAdr + L_Str.PoolItem("  ⠪ த| 㪠 த!", !glb_Town);
   ELSIF !KLADR_Village THEN
    ErrMsg:=BadAdr + L_Str.PoolItem("  ⠪ ᥫ 㭪| 㪠 ᥫ 㭪!", !glb_Village);
   ELSIF !KLADR_Street THEN
    ErrMsg:=BadAdr + L_Str.PoolItem("  ⠪ 㫨| 㪠 㫨!", !glb_Street);
   ELSE
    IF (Lev = lv_All) & (~!glb_House | ~!glb_Block | ~!glb_Build) &
       SELECT(KlAdr, KlAdr, lv_House, KLADR_Region, KLADR_District, KLADR_City, KLADR_Village, KLADR_Street) THEN
     IF ~PosToKlAdrHouse(glb_House, glb_Block, glb_Build) THEN
      ErrMsg:=BadAdr + "  ⠪ //஥";
     END;
    ELSIF (Lev >= lv_Street) & ~!glb_Street THEN
     IF ~SELECT(KlAdr, KlAdr, lv_Street, KLADR_Region, KLADR_District, KLADR_City, KLADR_Village, KLADR_Street) THEN
      ErrMsg:=BadAdr + "  ⠪ 㫨";
     END;
    ELSIF (Lev >= lv_Village) &  ~!glb_Village THEN
     IF ~SELECT(KlAdr, KlAdr, lv_Village,  KLADR_Region, KLADR_District, KLADR_City, KLADR_Village) THEN
      ErrMsg:=BadAdr + "  ⠪ ᥫ 㭪";
     ELSIF (Lev > lv_Village) THEN
      SAVE(KlAdr);
      IF SELECT(KlAdr, KlAdr, lv_Street,  KLADR_Region, KLADR_District, KLADR_City, KLADR_Village) THEN
       ErrMsg:=BadAdr + " 㪠 㫨";
      END;
      RESTORE(KlAdr);
     END;
    ELSIF (Lev >= lv_City) & ~!glb_Town THEN
     IF ~SELECT(KlAdr, KlAdr, lv_City, KLADR_Region, KLADR_District, KLADR_City) THEN
      ErrMsg:=BadAdr + "  ⠪ த";
     END;
    ELSIF (Lev >= lv_District) & ~!glb_Distr THEN
     IF ~SELECT(KlAdr, KlAdr, lv_District, KLADR_Region, KLADR_District) THEN
      ErrMsg:=BadAdr + "  ⠪ ࠩ";
     END;
    ELSIF (Lev >= lv_Region) & ~!glb_Region THEN
     IF ~SELECT(KlAdr, KlAdr, lv_Region, KLADR_Region) THEN
      ErrMsg:=BadAdr + "  ⠪ ॣ";
     END;
    ELSE
     ErrMsg:=BadAdr + "   ";
    END;
   END;
   IF !ErrMsg THEN
    TestZipByKlAdr(ErrMsg);
   END;
   IF    InformType = tit_Choice THEN
    IF ~!ErrMsg THEN
     L_StdFrm.Choice(ErrMsg);
    ELSE
     L_StdFrm.Inform(" ᮮ⢥ ");
    END;
   ELSIF InformType = tit_Error THEN
    IF ~!ErrMsg THEN
     IF trgNotKLADR THEN
      IF L_Events.IsAfterEditInsertEvents(RTI.Get().StartMode) THEN
       L_StdFrm.Question(ErrMsg + "||" + " ⠭ ਧ ' ⢨⥫쭮  ᮮ⢥ '");
      END;
     ELSE
      L_General.Error(ErrMsg);
     END;
    ELSE
     L_General.Assert(~trgNotKLADR, " ᮮ⢥ .|᭮ ⠭ ਧ ᮮ⢥⢨  ");
    END;
   END;
  END;
 END {CheckAdrByKlAdr};

 PUBLIC PROCEDURE TestRus(S, Txt, AlowChar: STRING[]);
  VAR
   i,
   l: NUMERIC[0];
   s: STRING[];
 BEGIN
  IF ~!S THEN
   i:=0; l:=Str.Length(S); s:=Str.Cap(S, 0, l);
   WHILE i < l DO
    IF ("A" <= s[i]) & (s[i] <= "Z") & (!AlowChar | ~L_Str.TestStrAlowChar(S[i], AlowChar)) THEN
     L_General.Error(" ⨭᪨ 㪢 - " + Txt);
    END;
    INC(i);
   END;
  END;
 END {TestRus};

 PRIVATE PROCEDURE TestNoComma(S, Txt: STRING[]);
 BEGIN
  L_General.Assert(~Str.Match(S, "*,*"), "  - " + Txt)
 END {TestNoComma};

 PRIVATE PROCEDURE TestRusAndNoComma(S, Txt, AlowChar: STRING[]);
 BEGIN
  TestRus(S, Txt, AlowChar);
  TestNoComma(S, Txt);
 END {TestRusAndNoComma};

 PUBLIC PROCEDURE CountryIsCIS(c: LIKE(Country.Country)): SCAL[2];
 BEGIN
  RETURN (c=112)|(c=804)|(c=498)|(c=051)|(c=860)|(c=c_Russia)|
         (c=762)|(c=417)|(c=268)|(c=031)|(c=398)|(c=795);
 END {CountryIsCIS};

 PUBLIC PROCEDURE TestAdr(Origin     : tAdrOrigin;
                          trgAdrType : tAdrType;
                          trgPostKind: LIKE(CtcAdr.PostKind));
  CONST
   RegionTPool = "|||||||";
  VAR
   trgStr: STRING[];
   Num, i: NUMERIC[0];
 BEGIN
  IF ((Origin = ao_ManAdr) & (trgAdrType > MAXOF(ManAdr.AdrType))) |
     ((Origin = ao_CtcAdr) & (trgAdrType > MAXOF(CtcAdr.Type   ))) THEN
   L_General.CallUs(0);
  END;

  L_General.Assert(~!glb_Country, " 㪠 ࠭");
  IF (Origin = ao_ManAdr) & (trgAdrType=at_BthMA) THEN
   CheckCountryIsActive(glb_Country, Man.Birth);
   IF (glb_Country # c_USSR) & ~CountryIsCIS(glb_Country) THEN
    L_StdFrm.Choice("  ?");
   END;
   L_General.Assert((glb_Country # c_Russia) | (glb_Region # 00) | (~!glb_RegionN),
           "  ॣ");
  ELSE
   L_General.Assert(glb_Country # c_USSR, " ࠭  ");
  END;

  IF ((Origin = ao_ManAdr) & (trgAdrType # at_CtMA)) |
     (Origin = ao_CtcAdr) THEN
   L_General.Assert(((Origin = ao_ManAdr) & (trgAdrType=at_BthMA)) | (glb_Country#c_Russia) | (glb_Region#00),
                    " ᪠ ।  ॣ  ᨨ");
   IF (((Origin = ao_ManAdr) & (trgAdrType # at_BthMA)) | (Origin = ao_CtcAdr)) & ~!glb_Region & (glb_Region # 00) THEN
    L_General.Assert((glb_Country=c_Russia), "㫥  ॣ ᪠ 㪠뢠 ⮫쪮  ᨨ");
   END;
   L_General.Assert((!glb_TownT = !glb_Town),
                    "   த|    ६");
   L_General.Assert((!glb_VillageT = !glb_Village),
                    "   ᥫ 㭪|    ६");
   L_General.Assert(!glb_StreetT = !glb_Street,
                    "   㫨|    ६");
   IF ~!glb_Distr & ~Str.Match(Str.Cap(glb_Distr), "*") THEN
    L_StdFrm.Choice("  稢  ");
   END;

   IF ~!glb_RegionN THEN
    IF (glb_Region # reg_Moscow) & (glb_Region # reg_StPetersburg) THEN
     i:=0;
     REPEAT
      trgStr:=Str.Cap(Str.Item(glb_RegionN, " ", i));
      INC(i);
     UNTIL !trgStr | ~!L_Str.PositionInPool(RegionTPool, trgStr);
     IF !trgStr THEN
      L_StdFrm.Choice("  㪠 ⨯ ॣ:| |"+RegionTPool);
     END;
    END;
   END;
 
   IF glb_Country = c_Russia THEN
    L_General.Assert(~!glb_Zip | (trgAdrType = at_BthMA), "  ");
    IF ~!glb_Zip THEN
     L_General.Assert(L_Str.TestStrAlowChar(glb_Zip, "09"), "   ᫮  ।  100000  999999");
     Num:=STRTOFLD(glb_Zip, NUMERIC);
     L_General.Assert(~!Num & (Num >= 100000) & (Num <= 999999), "   ᫮  ।  100000  999999");
    END;
   END;
 
   IF ~!glb_Town THEN
    trgStr:=Str.Cap(glb_Town);
    IF ((glb_Region = reg_Moscow)       & Str.Match(trgStr, "")) |
       ((glb_Region = reg_StPetersburg) & Str.Match(trgStr, "")) THEN
     L_General.Error(trgStr+"  ॣ   㪠뢠   'த'");
    END;
   END;
 
   IF (glb_Region = reg_Moscow) | (glb_Region = reg_StPetersburg) THEN
    IF (((Origin = ao_ManAdr) & (trgAdrType # at_BthMA)) |
        ((Origin = ao_CtcAdr) & (trgPostKind = capk_Stndr))) &
       !glb_Town & !glb_Village & !glb_Street THEN
     L_StdFrm.Choice("  த,  ᥫ 㭪,  㫨");
    END;
   ELSIF !glb_Town & !glb_Village THEN
    L_StdFrm.Choice("  த,  ᥫ 㭪");
   END;
   IF (((Origin = ao_ManAdr) & (trgAdrType # at_BthMA)) |
       ((Origin = ao_CtcAdr) & (trgPostKind = capk_Stndr)))  &
      ~!glb_Street & !glb_House & !glb_Block & !glb_Build THEN
    L_StdFrm.Choice("  ,  ,  ஥");
   END;

   TestRusAndNoComma(glb_RegionN,  "",           "");
   TestRusAndNoComma(glb_Distr,    "",            "");
   TestRusAndNoComma(glb_Village,  "ᥫ 㭪", "NN");
   TestRusAndNoComma(glb_Town,     "த",            "");
   TestRusAndNoComma(glb_Street,   "",            "NN");
   TestNoComma(glb_House, "");
   TestNoComma(glb_Block, "");
   TestNoComma(glb_Build, "஥");
   TestNoComma(glb_Flat,  "");
  END; (* IF trgAdrType # at_CtMA... *)
 END {TestAdr};

 PUBLIC PROCEDURE FormatNameType(Name: STRING[]; Type: LIKE(KlAdr.Type); TypePool: STRING[]): STRING[];
 BEGIN
  IF ~!TypePool & ~!Type THEN
   RETURN FLDTOSTR(Name, "", Str.MaxLength(KlAdr.Name)) + " " + L_Str.PoolItem(TypePool, Type);
  ELSE
   RETURN Name;
  END;
 END {FormatNameType};

 PRIVATE PROCEDURE GetAddCodeActuality(trgAddCode: LIKE(KlAdr.AddCode)): tKlAdrActuality;
 BEGIN
  IF    (trgAddCode = 0) THEN RETURN kla_Actual;
  ELSIF (trgAddCode<=50) THEN RETURN kla_Renamed;
  ELSIF (trgAddCode =51) THEN RETURN kla_Transfered;
  ELSIF (trgAddCode<=98) THEN RETURN kla_Reserved;
  ELSIF (trgAddCode =99) THEN RETURN kla_Removed;
  ELSE
   L_General.CallUs(0);
  END;
 END {GetAddCodeActuality};

 PUBLIC PROCEDURE PosToFieldKlAdr(Lev: LIKE(KlAdr.Level));
  CONST
   tItemLength = Str.MaxLength(KlAdr.Name)+31;
  VAR
   NeedType,
   DistrCntrCond: SCAL[2];
   kl_Ids,
   kl_List,
   CurItem : STRING[];
   curIdx,
   maxL,
   addL,
   maxI,
   Count   : NUMERIC[0];
   Title,
   TypePool: STRING[];
   CurName : STRING[];
   CurType : LIKE(KlAdr.Type);
   FormatKlAdrName,
   Msg     : STRING[];
 BEGIN
  APP.Get().NewPrompt("롮  ");
  SetCondition(lv_All, 1);
  SETEMPTY(DistrCntrCond);
  L_AFM.MakeMultipleIndex("_MACt", "Name   : STRING["+FLDTOSTR(tItemLength, "")+"];"+
                                   "KlAdrId:"+GET_TYPE_SPEC(tKlAdrId).Name+";"+
                                   "AddCode: LIKE(KlAdr.AddCode)",
                          "_MACt: Name; AddCode: AddCode");
  DistrCntrCond:=0;
  IF Lev = lv_District THEN
   Title   :="";
   TypePool:="";
   CurName :=glb_Distr;
   CurType :="";
   SELECT(KlAdr, KlAdr, , Lev, KLADR_Region);
  ELSIF Lev = lv_City THEN
   Title   :="த";
   TypePool:=c_TownT;
   CurName :=glb_Town;
   CurType :=glb_TownT;
   IF ~!glb_Distr THEN
    SELECT(KlAdr, KlAdr, , lv_City, KLADR_Region, KLADR_District);
    DistrCntrCond:=0;
   ELSE
    SELECT(KlAdr, KlAdr, , lv_City, KLADR_Region);
    DistrCntrCond:=1;
   END;
  ELSIF Lev = lv_Village THEN
   Title   :="ᥫ 㭪";
   TypePool:=c_VillageT;
   CurName :=glb_Village;
   CurType :=glb_VillageT;
   IF ~!glb_Distr | ~!glb_Town THEN
    SELECT(KlAdr, KlAdr, , Lev, KLADR_Region, KLADR_District, KLADR_City);
    DistrCntrCond:=0;
   ELSE
    SELECT(KlAdr, KlAdr, , Lev, KLADR_Region);
    DistrCntrCond:=1;
   END;
  ELSIF Lev = lv_Street THEN
   Title   :="";
   TypePool:=c_StreetT;
   CurName :=glb_Street;
   CurType :=glb_StreetT;
   SELECT(KlAdr, KlAdr, , Lev, KLADR_Region, KLADR_District, KLADR_City, KLADR_Village);
  ELSE
   L_General.CallUs(0);
  END;

  maxL :=0;

  WHILE OCCURE(KlAdr) DO
   IF (~DistrCntrCond | (DistrCntrCond = IsDistrCenter())) &
      (!CurType | (CurType = KlAdr.Type)) THEN
    FormatKlAdrName:=FormatNameType(KlAdr.Name, KlAdr.Type, TypePool);
    PROMPT(FormatKlAdrName);
    IF ~ADD(_MACt, _MACt, FormatKlAdrName) |
       Actualer(KlAdr.AddCode, _MACt.AddCode) THEN
     _MACt.KlAdrId:=CurKlAdrId();
     _MACt.AddCode:=KlAdr.AddCode;
     REPLACE(_MACt);
     maxL:=Math.Max(maxL, Str.Length(_MACt.Name));
    END;
   END;
   NEXT(KlAdr);
  END; (* WHILE OCCURE(KlAdr) ... *)

  CurItem:=FormatNameType(CurName, CurType, TypePool);
  curIdx :=0;

  Count:=0;
  kl_List:="";
  kl_Ids :="";

  SETSEL(_MACt, AddCode);
  IF LAST(_MACt) THEN
   IF _MACt.AddCode # 00 THEN
    addL:=20+3;
   ELSE
    addL:=0;
   END;
 
   SELECT(_MACt, _MACt);
   WHILE OCCURE(_MACt) DO
    PROMPT(_MACt.Name);
    kl_List:=kl_List+Str.Align(_MACt.Name, maxL, LEFT);
    IF _MACt.AddCode = 00 THEN
     kl_List:=kl_List+Str.Align("", addL, LEFT);
    ELSE
     kl_List:=kl_List+Str.Align(" ("+L_Str.PoolItem(kla_Pool, GetAddCodeActuality(_MACt.AddCode))+")", addL, LEFT);
    END;
    kl_Ids:=kl_Ids+_MACt.KlAdrId+"|";
    kl_List:=kl_List+"|";
    IF _MACt.Name = CurItem THEN
     curIdx:=Count;
    END;
    INC(Count);
    NEXT(_MACt);
   END; (* WHILE OCCURE(_MACt) ... *)
   L_AFM.AF_PurgeTemp("_MACt");
 
   INC(maxL, addL);
   IF ~!CurType THEN
    Title:=Title+" ("+Str.Item(TypePool, "|", CurType)+")";
   END;

   GE_APPWIN_SIZE(, maxI);
   STDFORM("%" + L_Str.IntStr(maxL) + "," +
                  L_Str.IntStr(Math.Min(Math.Max(Count, 2), maxI*0.8)) +
            "<" + kl_List + ">I",
           " " + Title + " ",
           INFORM_NEUTRAL, -1, curIdx);
  ELSE
   L_StdFrm.BlueHalt(Title + "|| ᮪  ");
  END;
  PositionOnKlAdr(L_Str.PoolItem(kl_Ids, curIdx));
  IF    GetAddCodeActuality(KlAdr.AddCode) = kla_Reserved THEN
   L_General.InformUs("࠭    १ࢨ஢ 祭 ਧ 㠫쭮 "+KlAdr.AddCode+"|"+CurKlAdrId());
  ELSIF GetAddCodeActuality(KlAdr.AddCode) # kla_Actual THEN
   Msg:="࠭  ||'"+Str.Condense(FormatNameType(KlAdr.Name, KlAdr.Type, TypePool))+"'||"+L_Str.PoolItem(kla_Pool, GetAddCodeActuality(KlAdr.AddCode));
   IF GetAddCodeActuality(KlAdr.AddCode) = kla_Renamed THEN
    SAVE(KlAdr);
    IF SEARCH(KlAdr, KlAdr, KlAdr.Level, KlAdr.Region, KlAdr.District, KlAdr.City, KlAdr.Village, KlAdr.Street, KlAdr.House, 00) THEN
     Msg:=Msg+L_StdFrm.HR()+" ||'"+Str.Condense(FormatNameType(KlAdr.Name, KlAdr.Type, TypePool))+"'";
    END;
    RESTORE(KlAdr);
   END;
   L_StdFrm.Choice(Msg);
  END;
 END {PosToFieldKlAdr};

 PUBLIC PROCEDURE wordSetAddr_byPart(Prefix: STRING[]);
  VAR
   trgCountryN: STRING[];
   trgCountry : LIKE(Country.Country);
   trgZip     : STRING[6];
   trgRegion  : LIKE(Region.Region);
   trgRegionN : STRING[];
   trgDistr,
   trgTown,
   trgVillage,
   trgStreet  : STRING[];
   trgTownT,
   trgVillageT,
   trgStreetT : SCAL[250];
   trgHouse,
   trgBlock,
   trgBuild,
   trgFlat,
   dummy      : STRING[];
   trgPostKind: tPostKind;
   trgDate    : DATE;
 BEGIN
  Get_glb_AdrVar(trgCountry, trgZip, trgRegion, trgRegionN, trgDistr, trgTown, trgVillage,
                 trgStreet, trgTownT, trgVillageT, trgStreetT, trgHouse, trgBlock, trgBuild, trgFlat, dummy, trgPostKind, trgDate);
  L_MSO.wordSetDateVar(Prefix + ".Date",         trgDate);
  L_MSO.wordSetVar(Prefix+".Source",             Adr_asStr(af_Full));
  L_MSO.wordSetVar(Prefix+".OKATO",              GetAdrOKATO());
  L_MSO.wordSetVar(Prefix,                       Adr_asStr(af_Short));
  L_MSO.wordSetVar(Prefix+".ShortPost",          Adr_asStr(af_Short));
  L_MSO.wordSetVar(Prefix+".Full",               Adr_asStr(af_Full));
  L_MSO.wordSetVar(Prefix+".FullPost",           Adr_asStr(af_Full));
  L_MSO.wordSetVar(Prefix+".Post",               Adr_asStr(af_Post));
  L_MSO.wordSetVar(Prefix+".Post_wZip",          Adr_asStr(af_Post) + ", " + trgZip);
  L_MSO.wordSetVar(Prefix+".Country",            trgCountry);
  IF SEARCH(Country, Country, trgCountry) THEN
   trgCountryN:=Country.Name;
  ELSE
   SETEMPTY(trgCountryN);
  END;
  L_MSO.wordSetVar(Prefix+".Country.Name",       trgCountryN);
  L_MSO.wordSetVar(Prefix+".Zip",                trgZip);
  L_MSO.wordSetVar(Prefix+".Region",             trgRegion);
  L_MSO.wordSetVar(Prefix+".Region.Name",        trgRegionN);
  L_MSO.wordSetVar(Prefix+".RegionN",            trgRegionN);
  L_MSO.wordSetVar(Prefix+".Distr",              trgDistr);
  IF    (trgRegion = reg_Moscow) | (trgRegion = reg_StPetersburg) THEN
   L_MSO.wordSetVar(Prefix+".City",              ". " + trgRegionN);
  ELSIF ~!trgTown THEN
   L_MSO.wordSetVar(Prefix+".City",              TownT_asStr(trgTownT) + " " + trgTown);
  ELSE
   L_MSO.wordSetVar(Prefix+".City",              trgRegionN);
  END;
  L_MSO.wordSetVar(Prefix+".Town",               trgTown);
  L_MSO.wordSetVar(Prefix+".Town.Type",          TownT_asLongStr(trgTownT));
  L_MSO.wordSetVar(Prefix+".Town.Type.Short",    TownT_asStr(trgTownT));
  L_MSO.wordSetVar(Prefix+".Village",            trgVillage);
  L_MSO.wordSetVar(Prefix+".Village.Type",       VillageT_asLongStr(trgVillageT));
  L_MSO.wordSetVar(Prefix+".Village.Type.Short", VillageT_asStr(trgVillageT));
  L_MSO.wordSetVar(Prefix+".Street",             trgStreet);
  L_MSO.wordSetVar(Prefix+".Street.Type",        StreetT_asLongStr(trgStreetT));
  L_MSO.wordSetVar(Prefix+".Street.Type.Short",  StreetT_asStr(trgStreetT));
  L_MSO.wordSetVar(Prefix+".House",              trgHouse);
  L_MSO.wordSetVar(Prefix+".Block",              trgBlock);
  L_MSO.wordSetVar(Prefix+".Build",              trgBuild);
  L_MSO.wordSetVar(Prefix+".Flat",               trgFlat);
 END {wordSetAddr_byPart};

END.
