(*
%Copyright   (c) Polak Computer System
%Author      03.01.2001 19:32:54 SAN
%Purpose       ந묨 㬥⠬ (XDoc)
%Type        library
%Specific    SYS
%Modified    24.09.2014 16:11:37 LDA
%Environment
*)

 MODULE L_XDoc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tXDocType       = SCAL[1E2];
  tXDocKind       = SCAL[1E2];
  tXDoc           = SCAL[1E9];
  tCopyCnt        = SCAL[1E2];
  tXDFKind        = SCAL[256];
  tXDocFile       = SCAL[1E7];
  tXDocProcType   = SCAL[3];
  tXDocAsStr      = SCAL[5];
  tXDocId         = STRING[2+2+9];
  tXDAct          = SCAL[2];
  tXDocCollection = STRING[];
  tXDocKindId     = STRING[2+2];
  tReferenceType  = SCAL[5];
  tBarCodeKind    = SCAL[2];
  tPositionMethod = SCAL[3];
  tCommand        = SCAL[1E2];
  tDoneDTS        = FLOAT;
  tProceedManner  = SCAL[3];
  tXDocClass      = SCAL[8];
  tAction         = SCAL[100];
  tFileOper       = SCAL[5];
  tXDFType        = SCAL[3];

 PUBLIC CONST
  FO_None         = 0;
  FO_Copy         = 1;
  FO_Move         = 2;
  FO_Link         = 4;

  xdfSt_Prepared  = 0;
  xdfSt_Passed    = 1;
  xdfSt_Canceled  = 2;

  xdfSt_Pool      = "⮢|஢|㫨஢";
  xdfSt_ShortPool = "||";

  xdfk_DocCopy     = 001;
  xdfk_SchemaRA    = 002;
  xdfk_DocOrig     = 003;
  xdfk_UserDefined = 032;

  EmptyXDocKind = 00;

  xdt_RWayS    = 00;
  xdt_RprS     = 01;
  xdt_PDoc     = 02;
  xdt_MDoc     = 03;
  xdt_TckRcS   = 04;
  xdt_AvePay   = 05;
  xdt_Dfrls    = 06;
  xdt_Dispatch = 07; (* ࠢ *)
  xdt_Contract = 08;
  xdt_Math     = 09;
  xdt_Staff    = 10;
  xdt_CWOrder  = 11;
  xdt_ODoc     = 12;
  xdt_FlRec    = 13;
  xdt_DsptPck  = 14;
  xdt_CUCopy   = 15;
  xdt_SprtCrsp = 16;
  xdt_TckRcD   = 17;
  xdt_TckRcC   = 18;
  xdt_CarAD    = 19;
  xdt_Command  = 20;
  xdt_Firm     = 21;
  xdt_EDOrder  = 22;
  xdt_MtrRdout = 23;
  xdt_DUMMY    = 24; (* ⮫쪮  ନ஢ ६ XDocId *)
  xdt_JDoc     = 25;
  xdt_Route    = 26;
  xdt_CostItem = 27;
  xdt_Car      = 28;
  xdt_IRec     = 29;
  xdt_PLDoc    = 30;
  xdt_XDocFile = 32;
  xdt_FOrder   = 33;
  xdt_Man      = 34;
  xdt_Packet   = 35;
  xdt_PCalc    = 36;
  xdt_AMO      = 37;
  xdt_ACalc    = 38;

  xdt_Sticker  = 40;

  ref_FullNames =  "⥢ "+
                  "| "+
                  "|⥦ 㬥"+
                  "| 㬥"+
                  "|⭮- "+
                  "|㬥  ।"+
                  "| "+
                  "|ࠢ"+
                  "|"+
                  "|ꥪ ਠ쭮 "+
                  "|⭨"+
                  "|   ॢ"+
                  "|稩 㬥"+
                  "|ࠢ筠 "+
                  "| ࠢ"+
                  "|"+
                  "|孨᪮ ॡ"+
                  "|㬥  "+
                  "|㬥  "+
                  "| ᤥ"+
                  "|ࠢ "+
                  "|ࠣ"+
                  "|ਪ  ᮭ"+
                  "|   稪" +
                  "| "+
                  "|ୠ 㬥" +
                  "|" +
                  "| 室  室" +
                  "|࠭ᯮ⭮ ।⢮" +
                  "| த ⮢" +
                  "|㬥 ⠭ 業" +
                  "| " +
                  "|ਪ९  㬥 䠩" +
                  "|ਪ  ᫥  㤥ঠ" +
                  "|᪮ "+
                  "| "+
                  "|  ௫"+
                  "| ᢨ⥫⢮"+
                  "|'㬥  '";

  ref_ShortNames = " || | |||||||||| ||| ||||||||   | ||| |||   ||| |||AMO|";

  action_begInsert                   = 00; (* tAction *)
  action_begEdit                     = 01;
  action_AcceptCarDeparture          = 02;
  action_begDst                      = 03;
  action_begDstCncl                  = 04;
  action_begRcp                      = 05;
  action_begRcpCncl                  = 06;
  action_Edit                        = 07;
  action_Insert                      = 08;
  action_CarDeparture                = 09;
  action_AutoEdit                    = 10;
  action_CarReturn                   = 11;
  action_AutoBuild                   = 12;
  action_begSwitch                   = 13;
  action_Reprint                     = 14;
  action_Sent                        = 15;
  action_PrintCopy                   = 16;
  action_VerifyCC                    = 17;
  action_AcceptCarReturn             = 18;
  action_ChainCor                    = 19;
  action_rprTransfer                 = 20;
  action_rprPuttingIntoOperation     = 21;
  action_rprInspection               = 22;
  action_rprCnclPuttingIntoOperation = 23;
  action_PrintAdditionalDocument     = 24;
  action_AutoVerification            = 25;
  action_MedicalExamination          = 26;
  action_NotAllowedByMedic           = 27;

  action_UserDefined                 = 90;

(*ᨬ쭠  = 18*)
  action_Pool        =  ".  ࠧ浪" +
                       "|. ࠧ浪" +
                       "|륧  ࠧ襭" +
                       "|뤠" +
                       "|⬥ 뤠" +
                       "|ਥ" +
                       "|⬥ ਥ" +
                       "|஢" +
                       "|⠢" +
                       "|륧 " +
                       "|. ।-"+
                       "| " +
                       "|. ⮢"+
                       "|४祭"+
                       "|"+
                       "|ࠢ"+
                       "| " +
                       "|⢥ত " +
                       "|ਥ "+
                       "|. 楯窨 "+
                       "|। " +
                       "|  ᯫ" +
                       "|" +
                       "|⬥ । " +
                       "| . -" +
                       "|⮢䨪" +
                       "|ᬮ" +
                       "|࠭";

  xdpt_asStr   = 0;
  xdpt_StandOn = 1;

  xdast_Simple   = 0;
  xdast_wDate    = 1;
  xdast_wStatus  = 2;
  xdast_wSrcNbr  = 3;
  xdast_External = 4;

  rft_BaseOn  = 0;
  rft_RefTo   = 1;
  rft_wRelTo  = 2;
  rft_Reverse = 3;
  rft_Annex   = 4;

  bck_IdIn17 = 0;
  bck_IdIn20 = 1;

  pm_StandOnly      = 0;
  pm_WaitUserChoice = 1;
  pm_GoToEdit       = 2;

  cmd_CancelVerifing  = 1;
  cmd_BadXDocBC       = 2;
  cmd_BuildGasStanTOV = 3;
  cmd_BuildGasStanMSP = 4;
  cmd_BuildGasStanTCh = 5;
  cmd_BegShift        = 6;
  cmd_EndShift        = 7;

  cmd_Pool =  " " +
             "|⪠  䨪樨" +
             "| ᪠  㬥" +
             "| ⥯த⮢  " +
             "| ⥯த⮢  " +
             "| ⥯த⮢  " +
             "|⨥ ᬥ" +
             "|⨥ ᬥ";

  min_DoneDTS = 0;
  max_DoneDTS = MAXOF(FLOAT);

  pm_Proceed      = 0; (*tProceedManner*)
  pm_Backtracking = 1;
  pm_Clear        = 2;
  pm_Pool = "ࠡ|⪠|";

  xdcls_AllPmnt      = 0; (*tXDocClass*)
  xdcls_InternalMDoc = 1;
  xdcls_VATRelated   = 2;
  xdcls_RWayS        = 3;

  xdcls_Pool = " 㬥  |७ ⮢ 㬥|㬥, 騥    |⥢ 㬥";

  txdclsAmount = MAXOF(tXDocClass)+1;

  xdasrc_Operator = 0;
  xdasrc_System   = 1;

  xdft_Copy       = 0;
  xdft_Source     = 1;
  xdft_SourceLink = 2;
  xdft_Pool = " 䠩|  室 |뫪  䠩  室 ";

 PUBLIC PERMANENT VAR
  ref_XDocId,
  pvs_XDocId: tXDocId;
  pvs_ActionAfter: STRING[];

 PUBLIC VAR
  TransactionMustBeRollback: SCAL[2];

 IMPORT Memo, Str, L_General, L_Str, L_DatTim, L_StdFrm, L_BarCode, L_AFM, L_FIO, L_SysLog,
        L_JDoc, L_MathR, L_DBD, Math, DBD, FIO, L_Russia, P_OwnData, SysLog, L_Dspt, L_ACL,
        L_ODoc, L_PDoc, L_MDoc, L_Rpr, L_TRS, L_AR, L_WDO, L_Acnt, L_AcsPnt, L_Way, Shell, P_Firm, L_XDF, L_Staff;

 PRIVATE CONST
  ref_FileNames = "RWayS|RprS|PDoc|MDoc|TckRcS|AvePay|Dfrls|Dspt|Contract|Math" +
                  "|Staff|CWOrder|ODoc|FlRec|DsptPck|CUCopy|SprtCrsp|TckRcD|TckRcC|CarAD"+
                  "| |Firm|EDOrder|MtrRdout| |JDoc|Route|CostItem|Car|IRec" +
                  "|PLDoc| |XDocFile|FOrder|Man|Packet|PCalc|AMO|ACalc";

  ref_KindNames = "None|None|PDocKind|MDocKind|None|None|None|None|None|None"+
                  "|None|None|ODocKind|None|None|None|None|None|None|None"+
                  "|None|None|None|None|None|JDocKind|None|None|None|None" +
                  "|PLDKind|None|None|None|None|None|None|None|None";

  ed_BarCodeDialogNormalExit = " ଠ 室  横 ⥭ - 21.04.2005 15:34:31 POLAK\LDA";

 PRIVATE VAR
  xdmb_CryCount: NUMERIC[0];

 PUBLIC PROCEDURE ExtractXDocType(trgXDocId: STRING[]): tXDocType;
 BEGIN
  RETURN STRTOFLD(Str.Slice(trgXDocId,  0, 2), SCAL);
 END {ExtractXDocType};

 PUBLIC PROCEDURE ExtractXDocKindId(trgXDocId: STRING[]): tXDocKindId;
 BEGIN
  RETURN Str.Slice(trgXDocId,  0, 4);
 END {ExtractXDocKindId};

 PUBLIC PROCEDURE DecodeXDocId(    trgXDocId  : STRING[];
                               VAR trgXDocType: tXDocType;
                               VAR trgXDocKind: tXDocKind;
                               VAR trgXDoc    : tXDoc);
 BEGIN
  trgXDocType:=ExtractXDocType(trgXDocId);
  trgXDocKind:=STRTOFLD(Str.Slice(trgXDocId,  2, 2), SCAL);
  trgXDoc    :=STRTOFLD(Str.Slice(trgXDocId,  4, 9), SCAL);
 END {DecodeXDocId};

 PUBLIC PROCEDURE DecodeXDocKindId(    trgXDocKindId: tXDocKindId;
                                   VAR trgXDocType  : tXDocType;
                                   VAR trgXDocKind  : tXDocKind);
 BEGIN
  trgXDocType:=STRTOFLD(Str.Slice(trgXDocKindId,  0, 2), SCAL);
  trgXDocKind:=STRTOFLD(Str.Slice(trgXDocKindId,  2, 2), SCAL);
 END {DecodeXDocKindId};

 PRIVATE PROCEDURE CheckXDocJrnNeed(trgXDocId: tXDocId);
  VAR
   begDate: DATE;
 BEGIN
  IF ExtractXDocType(trgXDocId) = xdt_PDoc THEN
   begDate:=01\06\2002;
  ELSE
   begDate:=01\05\2001;
  END;
  L_General.CallUs(GetXDocDate(trgXDocId) < begDate);
 END {CheckXDocJrnNeed};

 PRIVATE PROCEDURE SelectJrn(trgXDocType: tXDocType; trgXDocKind: LIKE(XDocJrn.XDocKind); trgXDoc: LIKE(XDocJrn.XDoc)): SCAL[2];
 BEGIN
  IF SELECT(XDocJrn, XDocJrn, trgXDocType, trgXDocKind, trgXDoc) THEN
   RETURN 1;
  ELSE
   CheckXDocJrnNeed(XDocId(trgXDocType, trgXDocKind, trgXDoc));
   RETURN 0;
  END;
 END {SelectJrn};

 PRIVATE PROCEDURE IsHoldValidStatus(SrcAction, DoneAction: tAction): SCAL[2];
 BEGIN
  IF    SrcAction=action_Reprint THEN
   RETURN (DoneAction=action_Sent) | (DoneAction=action_PrintCopy) | (DoneAction=action_VerifyCC);
  ELSIF SrcAction=action_VerifyCC THEN
   RETURN (DoneAction=action_Sent) | (DoneAction=action_PrintCopy);
  ELSIF SrcAction=action_Sent THEN
   RETURN (DoneAction=action_PrintCopy);
  ELSIF SrcAction=action_PrintCopy THEN
   RETURN (DoneAction=action_Sent);
  END;
  L_General.CallUs(0);
 END {IsHoldValidStatus};

 PUBLIC PROCEDURE JrnHasValidAction(_XDocType: tXDocType;
                                    _XDocKind: LIKE(XDocJrn.XDocKind);
                                    _XDoc    : LIKE(XDocJrn.XDoc);
                                    SrcAction: tAction): SCAL[2];
 BEGIN
  IF SelectJrn(_XDocType, _XDocKind, _XDoc) THEN
   LAST(XDocJrn);
   WHILE OCCURE(XDocJrn) DO
    IF    XDocJrn.Action = SrcAction THEN
     RETURN 1;
    ELSIF ~IsHoldValidStatus(SrcAction, XDocJrn.Action) THEN
     RETURN 0;
    END;
    PREV(XDocJrn);
   END; (* WHILE OCCURE(XDocJrn) ... *)
   L_General.CallUs(0);
  ELSE
   RETURN 0;
  END;
 END {JrnHasValidAction};

 PUBLIC PROCEDURE XDocIsPrinted(_XDocType: tXDocType; _XDocKind: LIKE(XDocJrn.XDocKind); _XDoc: LIKE(XDocJrn.XDoc)): SCAL[2];
 BEGIN
  RETURN JrnHasValidAction(_XDocType, _XDocKind, _XDoc, action_Reprint);
 END {XDocIsPrinted};

 PUBLIC PROCEDURE XDocIsSent(_XDocType: tXDocType; _XDocKind: LIKE(XDocJrn.XDocKind); _XDoc: LIKE(XDocJrn.XDoc)): SCAL[2];
 BEGIN
  RETURN JrnHasValidAction(_XDocType, _XDocKind, _XDoc, action_Sent);
 END {XDocIsSent};

 PUBLIC PROCEDURE XDocSomeTimeWas(_XDocType: tXDocType;
                                  _XDocKind: LIKE(XDocJrn.XDocKind);
                                  _XDoc    : LIKE(XDocJrn.XDoc);
                                  srcAction: tAction): SCAL[2];
 BEGIN
  IF SelectJrn(_XDocType, _XDocKind, _XDoc) THEN
   WHILE OCCURE(XDocJrn) DO
    IF XDocJrn.Action = srcAction THEN
     RETURN 1;
    END;
    NEXT(XDocJrn);
   END; (* WHILE OCCURE(XDocJrn) ... *)
  END;
  RETURN 0;
 END {XDocSomeTimeWas};

 PUBLIC PROCEDURE XDocHasUnclosedCoupledAction(_XDocType: tXDocType;
                                               _XDocKind: LIKE(XDocJrn.XDocKind);
                                               _XDoc    : LIKE(XDocJrn.XDoc);
                                               First,
                                               Second   : tAction): SCAL[2];
 BEGIN
  IF SelectJrn(_XDocType, _XDocKind, _XDoc) THEN
   LAST(XDocJrn);
   WHILE OCCURE(XDocJrn) DO
    IF    XDocJrn.Action = Second THEN
     RETURN 0;
    ELSIF XDocJrn.Action = First THEN
     RETURN 1;
    END;
    PREV(XDocJrn);
   END; (* WHILE OCCURE(XDocJrn) ... *)
  END;
  RETURN 0;
 END {XDocHasUnclosedCoupledAction};

 PUBLIC PROCEDURE XDocSomeTimeWasSent(_XDocType: tXDocType; _XDocKind: LIKE(XDocJrn.XDocKind);_XDoc: LIKE(XDocJrn.XDoc)): SCAL[2];
 BEGIN
  RETURN XDocSomeTimeWas(_XDocType, _XDocKind, _XDoc, action_Sent);
 END {XDocSomeTimeWasSent};

 PUBLIC PROCEDURE XDocIsPrintedCopy(_XDocType: tXDocType; _XDocKind: LIKE(XDocJrn.XDocKind); _XDoc: LIKE(XDocJrn.XDoc)): SCAL[2];
 BEGIN
  RETURN JrnHasValidAction(_XDocType, _XDocKind, _XDoc, action_PrintCopy);
 END {XDocIsPrintedCopy};

 PUBLIC PROCEDURE XDocIsVerifiedCC(_XDocType: tXDocType; _XDocKind: LIKE(XDocJrn.XDocKind); _XDoc: LIKE(XDocJrn.XDoc)): SCAL[2];
 BEGIN
  RETURN JrnHasValidAction(_XDocType, _XDocKind, _XDoc, action_VerifyCC);
 END {XDocIsVerifiedCC};

 PUBLIC PROCEDURE BegXDocIsVerified(_XDocType             : tXDocType;
                                    _XDocKind             : LIKE(XDocJrn.XDocKind);
                                    _XDoc                 : LIKE(XDocJrn.XDoc);
                                    AutoVerificationPeriod: NUMERIC[3]): SCAL[2];
 BEGIN
  IF SelectJrn(_XDocType, _XDocKind, _XDoc) THEN
   LAST(XDocJrn);
   IF XDocJrn.Action = action_AutoVerification THEN
    RETURN L_DatTim.GetVARIANTDATEPeriod_Hour(L_DatTim.GetVARIANTDATE(XDocJrn.Date, XDocJrn.BegTime, XDocJrn.BegSec),
                                              L_DatTim.GetSysVARIANTDATE()) > AutoVerificationPeriod;
   ELSE
    WHILE OCCURE(XDocJrn) DO
     IF    XDocJrn.Action = action_VerifyCC THEN
      RETURN 1;
     ELSIF (XDocJrn.Action = action_Reprint) | (XDocJrn.Action = action_begDstCncl) THEN
      RETURN 0;
     END;
     PREV(XDocJrn);
    END; (* WHILE OCCURE(XDocJrn) ... *)
   END;
  END; (* IF SelectJrn(...*)
  RETURN 0;
 END {BegXDocIsVerified};

 PUBLIC PROCEDURE XDocWasAutoBuild(_XDocType: tXDocType; _XDocKind: LIKE(XDocJrn.XDocKind); _XDoc: LIKE(XDocJrn.XDoc)): SCAL[2];
 BEGIN
  IF SelectJrn(_XDocType, _XDocKind, _XDoc) THEN
   RETURN (XDocJrn.Action = action_AutoBuild);
  ELSE
   RETURN 0;
  END;
 END {XDocWasAutoBuild};

 PUBLIC PROCEDURE XDoc_wo_Handicraft(_XDocType: tXDocType; _XDocKind: LIKE(XDocJrn.XDocKind); _XDoc: LIKE(XDocJrn.XDoc)): SCAL[2];
 BEGIN
  IF XDocWasAutoBuild(_XDocType, _XDocKind, _XDoc) THEN
   WHILE NEXT(XDocJrn) & (XDocJrn.Action = action_AutoEdit) DO
   END;
   RETURN ~OCCURE(XDocJrn);
  ELSE
   RETURN 0;
  END;
 END {XDoc_wo_Handicraft};

 PUBLIC PROCEDURE DoJrnProcByXDocId(_XDocId: tXDocId; Proc: PROC): SCAL[2];
  VAR
   _XDocType : tXDocType;
   _XDocKind : tXDocKind;
   _XDoc     : tXDoc;
 BEGIN
  DecodeXDocId(_XDocId, _XDocType, _XDocKind, _XDoc);
  RETURN Proc(_XDocType, _XDocKind, _XDoc);
 END {DoJrnProcByXDocId};

 PUBLIC PROCEDURE XDoc_Clear(_XDocType: tXDocType; _XDocKind: LIKE(XDocJrn.XDocKind); _XDoc: LIKE(XDocJrn.XDoc));
 BEGIN
  IF SelectJrn(_XDocType, _XDocKind, _XDoc) THEN
   REMSEL(XDocJrn);
  END;
 END {XDoc_Clear};

 PRIVATE PROCEDURE UnPkTIMESTAMPInXDocJrn(    DTS  : TIMESTAMP;
                                          VAR _Date: DATE;
                                          VAR _Time: TIME;
                                          VAR _Sec : LIKE(XDocJrn.BegSec));
  VAR
   second        : NUMERIC[0];
   secondFraction: FLOAT;
 BEGIN
  UnPkTIMESTAMP(DTS, _Date, _Time, second, secondFraction);
  _Sec:=second + secondFraction;
  IF _Sec = 60.00 THEN
   _Sec:=59.99;
  END;
 END {UnPkTIMESTAMPInXDocJrn};

 PUBLIC PROCEDURE XDocJrn_xMark(_XDocType: LIKE(XDocJrn.XDocType);
                                _XDocKind: LIKE(XDocJrn.XDocKind);
                                _XDoc    : LIKE(XDocJrn.XDoc);
                                _Action  : tAction;
                                withEnd  : SCAL[2]);
  VAR
   CurXDocJrnDTS,
   LastXDocJrnDTS: TIMESTAMP;
   _Date   : DATE;
   _BegTime: TIME;
   _BegSec : LIKE(XDocJrn.BegSec);
 BEGIN
  SETSEL(XDocJrn, XDocJrn, _XDocType, _XDocKind, _XDoc);
  IF LAST(XDocJrn) THEN
   LastXDocJrnDTS:=PackTIMESTAMP(XDocJrn.Date, XDocJrn.BegTime, XDocJrn.BegSec);
  ELSE
   SETEMPTY(LastXDocJrnDTS);
  END;

  UnPkTIMESTAMPInXDocJrn(SYSTIMESTAMP(), _Date, _BegTime, _BegSec);
  CurXDocJrnDTS:=PackTIMESTAMP(_Date, _BegTime, _BegSec);
  IF ~!LastXDocJrnDTS & (LastXDocJrnDTS >= CurXDocJrnDTS) THEN
   CurXDocJrnDTS:=LastXDocJrnDTS + 1/24/60/60;
  END;

  DEFAULT(XDocJrn);
  XDocJrn.XDocType:=_XDocType;
  XDocJrn.XDocKind:=_XDocKind;
  XDocJrn.XDoc    :=_XDoc;
  XDocJrn.AcsObj  :=L_General.curUSER;
  XDocJrn.Action  :=_Action;
  UnPkTIMESTAMPInXDocJrn(CurXDocJrnDTS, XDocJrn.Date, XDocJrn.BegTime, XDocJrn.BegSec);
  IF withEnd THEN
   XDocJrn.EndTime:=XDocJrn.BegTime;
   XDocJrn.EndSec :=XDocJrn.BegSec;
  ELSE
   SETEMPTY(XDocJrn.EndTime, XDocJrn.EndSec);
  END;
  INSERT(XDocJrn);
 END {XDocJrn_xMark};

 PUBLIC PROCEDURE XDocJrn_Start(_XDocType: LIKE(XDocJrn.XDocType);
                                _XDocKind: LIKE(XDocJrn.XDocKind);
                                _XDoc    : LIKE(XDocJrn.XDoc);
                                _Action  : tAction);
 BEGIN
  XDocJrn_xMark(_XDocType, _XDocKind, _XDoc, _Action, 0);
 END {XDocJrn_Start};

 PUBLIC PROCEDURE Jrn_Start(_XDocId:tXDocId; _Action: tAction);
  VAR
   _XDocType: LIKE(XDocJrn.XDocType);
   _XDocKind: LIKE(XDocJrn.XDocKind);
   _XDoc    : LIKE(XDocJrn.XDoc);
 BEGIN
  DecodeXDocId(_XDocId, _XDocType, _XDocKind, _XDoc);
  XDocJrn_Start(_XDocType, _XDocKind, _XDoc, _Action);
 END {Jrn_Start};

 PUBLIC PROCEDURE XDocJrn_Stop(_XDocType: LIKE(XDocJrn.XDocType);
                               _XDocKind: LIKE(XDocJrn.XDocKind);
                               _XDoc    : LIKE(XDocJrn.XDoc));
  VAR
   Dummy: DATE;
 BEGIN
  SETSEL(XDocJrn, XDocJrn, _XDocType, _XDocKind, _XDoc);
  L_General.CallUs(LAST(XDocJrn));
  WHILE OCCURE(XDocJrn) & (XDocJrn.AcsObj # L_General.curUSER) DO
   PREV(XDocJrn);
  END; (* WHILE OCCURE(XDocJrn)...*)
  IF ~OCCURE(XDocJrn) | ~!XDocJrn.EndTime THEN
   L_General.Error(", ᫨  ⠪ ,  室  䨪樨  ࠭" +
                   L_StdFrm.HR() +
                   "  ᪮॥ ᮮ ࠡ稪  ஡!" +
                   L_StdFrm.HR() +
                   "஡    ⮏  த ࠡ");
  END;
  L_General.CallUs(!XDocJrn.EndTime);
  UnPkTIMESTAMPInXDocJrn(SYSTIMESTAMP(), Dummy, XDocJrn.EndTime, XDocJrn.EndSec);
  REPLACE(XDocJrn);
 END {XDocJrn_Stop};

 PUBLIC PROCEDURE Jrn_Stop(_XDocId:tXDocId);
  VAR
   _XDocType: LIKE(XDocJrn.XDocType);
   _XDocKind: LIKE(XDocJrn.XDocKind);
   _XDoc    : LIKE(XDocJrn.XDoc);
 BEGIN
  DecodeXDocId(_XDocId, _XDocType, _XDocKind, _XDoc);
  XDocJrn_Stop(_XDocType, _XDocKind, _XDoc);
 END {Jrn_Stop};

 PUBLIC PROCEDURE XDocJrn_Mark(_XDocType: LIKE(XDocJrn.XDocType);
                               _XDocKind: LIKE(XDocJrn.XDocKind);
                               _XDoc    : LIKE(XDocJrn.XDoc);
                               _Action  : tAction);
 BEGIN
  XDocJrn_xMark(_XDocType, _XDocKind, _XDoc, _Action, 1);
 END {XDocJrn_Mark};

 PUBLIC PROCEDURE Jrn_Mark(_XDocId: tXDocId; _Action: tAction);
  VAR
   _XDocType: LIKE(XDocJrn.XDocType);
   _XDocKind: LIKE(XDocJrn.XDocKind);
   _XDoc    : LIKE(XDocJrn.XDoc);
 BEGIN
  DecodeXDocId(_XDocId, _XDocType, _XDocKind, _XDoc);
  XDocJrn_Mark(_XDocType, _XDocKind, _XDoc, _Action);
 END {Jrn_Mark};

 PRIVATE PROCEDURE extChangeXDocId_SingleFile(FileName,
                                              IndexName,
                                              FieldName : STRING[];
                                              oldXDocId,
                                              newXDocId : tXDocId);
 BEGIN
  WHILE SELECT((FileName), (IndexName), oldXDocId) DO
   ^(FileName + '.' + FieldName) := newXDocId;
   REPLACE((FileName));
  END; (* WHILE SELECT((FileName), (IndexName) ... *)
 END {extChangeXDocId_SingleFile};

 PUBLIC PROCEDURE extChangeXDoc(_XDocType  : tXDocType;
                                oldXDocKind: tXDocKind;
                                oldXDoc    : tXDoc;
                                newXDocKind: tXDocKind;
                                newXDoc    : tXDoc;
                                wDependent : SCAL[2]);
  VAR
   oldXDocId,
   newXDocId: tXDocId;
 BEGIN
  L_General.CallUs((oldXDocKind # newXDocKind) | (oldXDoc # newXDoc));
  WHILE SELECT(XDocJrn, XDocJrn, _XDocType, oldXDocKind, oldXDoc) DO
   XDocJrn.XDocKind:=newXDocKind;
   XDocJrn.XDoc    :=newXDoc;
   REPLACE(XDocJrn);
  END; (* WHILE SELECT(XDocJrn ... *)

  oldXDocId := XDocId(_XDocType, oldXDocKind, oldXDoc);
  newXDocId := XDocId(_XDocType, newXDocKind, newXDoc);

  extChangeXDocId_SingleFile('XDocRef',  'bXDocId',  'bXDocId', oldXDocId, newXDocId);
  IF SELECT(XDocRef, rXDocId, oldXDocId) THEN
   IF ~!wDependent THEN
    L_General.Assert(wDependent,
                     " ᭮  㬥 ନ஢ 易 㬥."+
                     "|"+
                     "⨬    㬥");
   END;
  END;

  extChangeXDocId_SingleFile('XDocRef',  'rXDocId',  'rXDocId', oldXDocId, newXDocId);
  extChangeXDocId_SingleFile('XDocApr',  'XDocApr',  'XDocId',  oldXDocId, newXDocId);
  extChangeXDocId_SingleFile('XDocFlow', 'XDocFlow', 'XDocId',  oldXDocId, newXDocId);
  extChangeXDocId_SingleFile('iSwap',    'XDocId',   'XDocId',  oldXDocId, newXDocId);

  WHILE SELECT(DsptDoc, XDocId, oldXDocId) DO
   DsptDoc.XDocId :=newXDocId;
   DsptDoc.DocKind:=newXDocKind;
   DsptDoc.Doc    :=newXDoc;
   REPLACE(DsptDoc);
  END; (* WHILE SELECT(DsptDoc ... *)

  WHILE SELECT(EDOLC, XDocId, oldXDocId) DO
   EDOLC.XDocId  :=newXDocId;
   EDOLC.XDocKind:=newXDocKind;
   EDOLC.XDoc    :=newXDoc;
   REPLACE(EDOLC);
  END;

  IF ~!TABLE.Get(Ref_FileName(_XDocType)).Fields("XDocId") THEN
   SAVE((Ref_FileName(_XDocType)));
   PositionOnXDoc(oldXDocId);
   ^(Ref_FileName(_XDocType)).XDocId:=newXDocId;
   REPLACE((Ref_FileName(_XDocType)));
   RESTORE((Ref_FileName(_XDocType)));
  END;
 END {extChangeXDoc};

 PUBLIC PROCEDURE ChangeXDoc(_XDocType: LIKE(XDocJrn.XDocType);
                             _XDocKind: LIKE(XDocJrn.XDocKind);
                             oldXDoc,
                             newXDoc  : LIKE(XDocJrn.XDoc));
 BEGIN
  extChangeXDoc(_XDocType, _XDocKind, oldXDoc, _XDocKind, newXDoc, 0);
 END {ChangeXDoc};

 PUBLIC PROCEDURE Ref_FileName(_RefDocT: tXDocType): STRING[];
 BEGIN
  RETURN Str.Item(ref_FileNames, "|", _RefDocT);
 END {Ref_FileName};

 PUBLIC PROCEDURE Ref_KindName(_RefDocT: tXDocType): STRING[];
 BEGIN
  RETURN Str.Item(ref_KindNames, "|", _RefDocT);
 END {Ref_KindName};

 PUBLIC PROCEDURE Ref_FullName(_RefDocT: tXDocType): STRING[];
 BEGIN
  RETURN Str.Item(ref_FullNames, "|", _RefDocT);
 END {Ref_FullName};

 PUBLIC PROCEDURE Ref_ShortName(_RefDocT: tXDocType): STRING[];
 BEGIN
  RETURN Str.Item(ref_ShortNames, "|", _RefDocT);
 END {Ref_ShortName};

 PUBLIC PROCEDURE XDocTypeHasXDocJrn(_RefDocT: tXDocType): SCAL[2];
 BEGIN
  IF    (_RefDocT = xdt_RWayS)    |
        (_RefDocT = xdt_RprS)     |
        (_RefDocT = xdt_PDoc)     |
        (_RefDocT = xdt_MDoc)     |
        (_RefDocT = xdt_TckRcS)   |
        (_RefDocT = xdt_AvePay)   |
        (_RefDocT = xdt_Dispatch) |
        (_RefDocT = xdt_CWOrder)  |
        (_RefDocT = xdt_ODoc)     |
        (_RefDocT = xdt_TckRcD)   |
        (_RefDocT = xdt_TckRcC)   |
        (_RefDocT = xdt_SprtCrsp) |
        (_RefDocT = xdt_MtrRdout) |
        (_RefDocT = xdt_JDoc)     |
        (_RefDocT = xdt_Dfrls)    |
        (_RefDocT = xdt_IRec)     |
        (_RefDocT = xdt_XDocFile) |
        (_RefDocT = xdt_PLDoc)    |
        (_RefDocT = xdt_Packet)   |
        (_RefDocT = xdt_FOrder)   |
        (_RefDocT = xdt_AMO)      THEN
   RETURN 1;
  ELSIF (_RefDocT = xdt_Contract) |
        (_RefDocT = xdt_Math)     |
        (_RefDocT = xdt_Staff)    |
        (_RefDocT = xdt_FlRec)    |
        (_RefDocT = xdt_DsptPck)  |
        (_RefDocT = xdt_CUCopy)   |
        (_RefDocT = xdt_CarAD)    |
        (_RefDocT = xdt_Command)  |
        (_RefDocT = xdt_Firm)     |
        (_RefDocT = xdt_Car)      |
        (_RefDocT = xdt_Route)    |
        (_RefDocT = xdt_CostItem) |
        (_RefDocT = xdt_EDOrder)  |
        (_RefDocT = xdt_Man)      |
        (_RefDocT = xdt_PCalc)    |
        (_RefDocT = xdt_ACalc)    THEN
   RETURN 0;
  ELSE
   L_General.CallUs(0);
  END;
 END {XDocTypeHasXDocJrn};

 PUBLIC PROCEDURE XDocTypeHasXDocKind(_DocType: tXDocType): SCAL[2];
 BEGIN
  RETURN Ref_KindName(_DocType) # "None";
 END {XDocTypeHasXDocKind};

 PUBLIC PROCEDURE XDocId(_XDocType: tXDocType;
                         _XDocKind: tXDocKind;
                         _XDoc    : tXDoc     ): tXDocId;
 BEGIN
  RETURN FLDTOSTR(_XDocType)+FLDTOSTR(_XDocKind)+FLDTOSTR(_XDoc);
 END {XDocId};

 PUBLIC PROCEDURE curXDocIdSoft(_XDocType: tXDocType): tXDocId;
  VAR
   _XDocId: tXDocId;
 BEGIN
  IF    _XDocType = xdt_MDoc THEN
   RETURN XDocId(xdt_MDoc, MDoc.MDocKind, MDoc.MDoc);
  ELSIF _XDocType = xdt_PDoc THEN
   RETURN XDocId(xdt_PDoc, PDoc.PDocKind, PDoc.PDoc);
  ELSIF _XDocType = xdt_RprS THEN
   RETURN XDocId(xdt_RprS, EmptyXDocKind, RprS.RprS);
  ELSIF _XDocType = xdt_RWayS THEN
   RETURN XDocId(xdt_RWayS, EmptyXDocKind, RWayS.RWayS);
  ELSIF _XDocType = xdt_TckRcS THEN
   RETURN XDocId(xdt_TckRcS, EmptyXDocKind, TckRcS.TckRcS);
  ELSIF _XDocType = xdt_AvePay THEN
   RETURN XDocId(xdt_AvePay, EmptyXDocKind, AvePay.AvePay);
  ELSIF _XDocType = xdt_CWOrder THEN
   RETURN XDocId(xdt_CWOrder, EmptyXDocKind, CWOrder.CWOrder);
  ELSIF _XDocType = xdt_Contract THEN
   RETURN XDocId(xdt_Contract, EmptyXDocKind, Contract.Contract);
  ELSIF _XDocType = xdt_Math THEN
   RETURN XDocId(xdt_Math, EmptyXDocKind, Math.Math);
  ELSIF _XDocType = xdt_ODoc THEN
   RETURN XDocId(xdt_ODoc, ODoc.ODocKind, ODoc.ODoc);
  ELSIF _XDocType = xdt_FlRec THEN
   RETURN XDocId(xdt_FlRec, EmptyXDocKind, FlRec.FlRec);
  ELSIF _XDocType = xdt_DsptPck THEN
   RETURN XDocId(xdt_DsptPck, EmptyXDocKind, DsptPck.DsptPck);
  ELSIF _XDocType = xdt_Dispatch THEN
   RETURN XDocId(xdt_Dispatch, Dspt.Type, Dspt.Dspt);
  ELSIF _XDocType = xdt_TckRcD THEN
   RETURN XDocId(xdt_TckRcD, EmptyXDocKind, TckRcD.TckRcD);
  ELSIF _XDocType = xdt_TckRcC THEN
   RETURN XDocId(xdt_TckRcC, EmptyXDocKind, TckRcC.TckRcC);
  ELSIF _XDocType = xdt_CarAD THEN
   RETURN XDocId(xdt_CarAD, EmptyXDocKind, CarAD.CarAD);
  ELSIF _XDocType = xdt_SprtCrsp THEN
   RETURN XDocId(xdt_SprtCrsp, EmptyXDocKind, SprtCrsp.SprtCrsp);
  ELSIF _XDocType = xdt_Firm THEN
   RETURN XDocId(xdt_Firm, EmptyXDocKind, Firm.Firm);
  ELSIF _XDocType = xdt_Car THEN
   RETURN XDocId(xdt_Car, EmptyXDocKind, Car.BoxNbr);
  ELSIF _XDocType = xdt_CostItem THEN
   RETURN XDocId(xdt_CostItem, EmptyXDocKind, CostItem.CostItem);
  ELSIF _XDocType = xdt_Route THEN
   RETURN XDocId(xdt_Route, EmptyXDocKind, Route.RECORDID);
  ELSIF _XDocType = xdt_EDOrder THEN
   RETURN XDocId(xdt_EDOrder, EmptyXDocKind, EDOrder.EDOrder);
  ELSIF _XDocType = xdt_MtrRdout THEN
   RETURN XDocId(xdt_MtrRdout, EmptyXDocKind, MtrRdout.MtrRdout);
  ELSIF _XDocType = xdt_Staff THEN
   RETURN XDocId(xdt_Staff, EmptyXDocKind, Staff.TSN);
  ELSIF _XDocType = xdt_JDoc THEN
   RETURN XDocId(xdt_JDoc, JDoc.JDocKind, JDoc.JDoc);
  ELSIF _XDocType = xdt_CUCopy THEN
   RETURN XDocId(xdt_CUCopy, EmptyXDocKind, CUCopy.CUCopy);
  ELSIF _XDocType = xdt_Dfrls THEN
   RETURN XDocId(xdt_Dfrls, EmptyXDocKind, Dfrls.Dfrls);
  ELSIF _XDocType = xdt_IRec THEN
   RETURN XDocId(xdt_IRec, EmptyXDocKind, IRec.IRec);
  ELSIF _XDocType = xdt_PLDoc THEN
   RETURN XDocId(xdt_PLDoc, PLDoc.PLDKind, PLDoc.PLDoc);
  ELSIF _XDocType = xdt_XDocFile THEN
   RETURN XDocId(xdt_XDocFile, EmptyXDocKind, XDocFile.XDocFile);
  ELSIF _XDocType = xdt_FOrder THEN
   RETURN XDocId(xdt_FOrder, EmptyXDocKind, FOrder.FOrder);
  ELSIF _XDocType = xdt_Man THEN
   RETURN XDocId(xdt_Man, EmptyXDocKind, Man.Man);
  ELSIF _XDocType = xdt_Packet THEN
   RETURN XDocId(xdt_Packet, EmptyXDocKind, Packet.Packet);
  ELSIF _XDocType = xdt_PCalc THEN
   RETURN XDocId(xdt_PCalc, EmptyXDocKind, PCalc.RECORDID);
  ELSIF _XDocType = xdt_AMO THEN
   RETURN XDocId(xdt_AMO, AMO.Kind, AMO.AMO);
  ELSIF _XDocType = xdt_ACalc THEN
   RETURN XDocId(xdt_ACalc, EmptyXDocKind, ACalc.RECORDID);
  ELSE
   SETEMPTY(_XDocId);
   RETURN _XDocId;
  END;
 END {curXDocIdSoft};

 PUBLIC PROCEDURE curXDocId(_XDocType: tXDocType): tXDocId;
  VAR
   _XDocId: tXDocId;
 BEGIN
  _XDocId:=curXDocIdSoft(_XDocType);
  L_General.CallUs(~!_XDocId);
  RETURN _XDocId;
 END {curXDocId};

 PUBLIC PROCEDURE XDocKindId(_XDocType: tXDocType; _XDocKind: tXDocKind): tXDocKindId;
 BEGIN
  RETURN FLDTOSTR(_XDocType)+FLDTOSTR(_XDocKind);
 END {XDocKindId};

 PUBLIC PROCEDURE BarCode(_BarCodeKind: tBarCodeKind;
                          _XDocType   : tXDocType;
                          _XDocKind   : tXDocKind;
                          _XDoc       : tXDoc;
                          _CopyCnt    : tCopyCnt): STRING[];
 BEGIN
  IF    _BarCodeKind = bck_IdIn17 THEN
   RETURN L_BarCode.BarCode("2"+XDocId(_XDocType, _XDocKind, _XDoc)+_CopyCnt);
  ELSIF _BarCodeKind = bck_IdIn20 THEN
   RETURN L_BarCode.BarCode("2900"+XDocId(_XDocType, _XDocKind, _XDoc)+_CopyCnt);
  ELSE
   L_General.CallUs(0);
  END;
 END {BarCode};

 PUBLIC PROCEDURE AskForXDocProceed(pm: tProceedManner; Msg: STRING[]; StrongThrough: SCAL[2]): SCAL[2];
  VAR
   btnsDlm,
   lastDlm,
   Blank,
   PoolIns,
   AddBtnsBlank,
   AddBtnsPoolIns: STRING[];
 BEGIN
  Blank:="|" + L_Str.PoolItem(pm_Pool, pm) + " " + Msg +
         "||" +
         " " + L_DatTim.PeriodStr(Memo.ud_mb());
  SETEMPTY(PoolIns, AddBtnsBlank, AddBtnsPoolIns);
  IF L_DatTim.Per(SYSDATE()) > Memo.ud_mb() THEN
   AddBtnsPoolIns:="%C<{} " + L_DatTim.PeriodStr(SYSDATE()) + ">";
   AddBtnsBlank  :="%##########%";
   IF StrongThrough THEN
    INC(AddBtnsPoolIns, "DB");
    IF L_StdFrm.wGUI() THEN lastDlm:="|";  SETEMPTY(btnsDlm);
    ELSE                    lastDlm:="||"; btnsDlm:=" ";
    END;
    PoolIns:=PoolIns + "%C< ⮯! >Z" + AddBtnsPoolIns;
    Blank  :=Blank   + lastDlm + "%#########%" + btnsDlm + AddBtnsBlank;
    IF pm = pm_Proceed THEN
     RETURN STDFORM(L_StdFrm.intPartForm(PoolIns, Blank), "", QUESTION) = 1;
    ELSE
     RETURN STDFORM(L_StdFrm.intPartForm(PoolIns, Blank), "", CHOICE) = 1;
    END;
   ELSE
    INC(AddBtnsPoolIns, "B");
   END;
  END;
  IF pm = pm_Proceed THEN
   RETURN STDFORM(L_StdFrm.sf_Choice_wAddBtns(Blank, PoolIns, AddBtnsBlank, AddBtnsPoolIns), "", QUESTION) = 2;
  ELSE
   RETURN STDFORM(L_StdFrm.sf_Choice_wAddBtns(Blank, PoolIns, AddBtnsBlank, AddBtnsPoolIns), "", CHOICE) = 2;
  END;
 END {AskForXDocProceed};

 (*  譥 ᯮ짮 - . PositionOnXDoc *)
 PUBLIC PROCEDURE StandOnXDoc(_XDocId: tXDocId): SCAL[2];
  VAR
   _DocType: tXDocType;
   _DocKind: tXDocKind;
   _Doc    : tXDoc;
 BEGIN
  DecodeXDocId(_XDocId, _DocType, _DocKind, _Doc);
  IF    _DocType = xdt_MDoc     THEN RETURN SEARCH(MDoc,     MDoc,     _DocKind, _Doc);
  ELSIF _DocType = xdt_PDoc     THEN RETURN SEARCH(PDoc,     PDoc,     _DocKind, _Doc);
  ELSIF _DocType = xdt_AvePay   THEN RETURN SEARCH(AvePay,   AvePay,   _Doc);
  ELSIF _DocType = xdt_Contract THEN RETURN SEARCH(Contract, Contract, _Doc);
  ELSIF _DocType = xdt_RprS     THEN RETURN SEARCH(RprS,     RprS,     _Doc);
  ELSIF _DocType = xdt_RWayS    THEN RETURN SEARCH(RWayS,    RWayS,    _Doc);
  ELSIF _DocType = xdt_TckRcS   THEN RETURN SEARCH(TckRcS,   TckRcS,   _Doc);
  ELSIF _DocType = xdt_Staff    THEN RETURN SEARCH(Staff,    TSN,      _Doc);
  ELSIF _DocType = xdt_FlRec    THEN RETURN SEARCH(FlRec,    FlRec,    _Doc);
  ELSIF _DocType = xdt_Dispatch THEN RETURN SEARCH(Dspt,     Dspt,     _DocKind, _Doc);
  ELSIF _DocType = xdt_ODoc     THEN RETURN SEARCH(ODoc,     ODoc,     _DocKind, _Doc);
  ELSIF _DocType = xdt_DsptPck  THEN RETURN SEARCH(DsptPck,  DsptPck,  _Doc);
  ELSIF _DocType = xdt_Math     THEN RETURN SEARCH(Math,     Math,     _Doc);
  ELSIF _DocType = xdt_CUCopy   THEN RETURN SEARCH(CUCopy,   CUCopy,   _Doc);
  ELSIF _DocType = xdt_CWOrder  THEN RETURN SEARCH(CWOrder,  CWOrder,  _Doc);
  ELSIF _DocType = xdt_TckRcC   THEN RETURN SEARCH(TckRcC,   TckRcC,   _Doc);
  ELSIF _DocType = xdt_TckRcD   THEN RETURN SEARCH(TckRcD,   TckRcD,   _Doc);
  ELSIF _DocType = xdt_SprtCrsp THEN RETURN SEARCH(SprtCrsp, SprtCrsp, _Doc);
  ELSIF _DocType = xdt_CarAD    THEN RETURN SEARCH(CarAD,    CarAD,    _Doc);
  ELSIF _DocType = xdt_Firm     THEN RETURN SEARCH(Firm,     Firm,     _Doc);
  ELSIF _DocType = xdt_Car      THEN RETURN SEARCH(Car,      BoxNbr,   _Doc);
  ELSIF _DocType = xdt_CostItem THEN RETURN SEARCH(CostItem, CostItem, _Doc);
  ELSIF _DocType = xdt_Route    THEN RETURN SEARCH(Route,    RECORDID, _Doc);
  ELSIF _DocType = xdt_EDOrder  THEN RETURN SEARCH(EDOrder,  EDOrder,  _Doc);
  ELSIF _DocType = xdt_JDoc     THEN RETURN SEARCH(JDoc,     JDoc,     _DocKind, _Doc);
  ELSIF _DocType = xdt_Dfrls    THEN RETURN SEARCH(Dfrls,    Dfrls,    _Doc);
  ELSIF _DocType = xdt_IRec     THEN RETURN SEARCH(IRec,     IRec,     _Doc);
  ELSIF _DocType = xdt_PLDoc    THEN RETURN SEARCH(PLDoc,    PLDoc,    _DocKind, _Doc);
  ELSIF _DocType = xdt_XDocFile THEN RETURN SEARCH(XDocFile, XDocFile, _Doc);
  ELSIF _DocType = xdt_FOrder   THEN RETURN SEARCH(FOrder,   FOrder,   _Doc);
  ELSIF _DocType = xdt_Man      THEN RETURN SEARCH(Man,      Man,      _Doc);
  ELSIF _DocType = xdt_MtrRdout THEN RETURN SEARCH(MtrRdout, MtrRdout, _Doc);
  ELSIF _DocType = xdt_Packet   THEN RETURN SEARCH(Packet,   Packet,   _Doc);
  ELSIF _DocType = xdt_PCalc    THEN RETURN SEARCH(PCalc,    RECORDID, _Doc);
  ELSIF _DocType = xdt_ACalc    THEN RETURN SEARCH(ACalc,    RECORDID, _Doc);
  ELSE
   L_General.CallUs(0);
  END;
 END {StandOnXDoc};

 PUBLIC PROCEDURE PositionOnXDoc(trgXDocId: tXDocId);
  VAR
   AddText    : STRING[];
   trgXDocType: tXDocType;
   trgXDocKind: tXDocKind;
   trgXDoc    : tXDoc;
 BEGIN
  L_General.Assert(ExtractXDocType(trgXDocId) # xdt_Command, "   䨪஬ 㬥  ꥪ");
  IF ~StandOnXDoc(trgXDocId) THEN
   DecodeXDocId(trgXDocId, trgXDocType, trgXDocKind, trgXDoc);
   L_General.Error("  㬥 " + Ref_ShortName(trgXDocType) + " " + trgXDocKind + " " + trgXDoc + "." +
                   "|" + L_StdFrm.HR() +
                   " ࠧ襭 ஡   .");
  END;
 END {PositionOnXDoc};

 PUBLIC PROCEDURE PositionOnNonEmptyXDoc(trgXDocId: tXDocId);
 BEGIN
  IF ~!trgXDocId THEN
   PositionOnXDoc(trgXDocId);
  ELSE
   HALT();
  END;
 END {PositionOnNonEmptyXDoc};

 PUBLIC PROCEDURE GetXDocCopyCnt(trgXDocId: tXDocId): tCopyCnt;
  VAR
   Result : tCopyCnt;
   trgXDoc: STRING[];
 BEGIN
  Result:=0;
  trgXDoc:=Ref_FileName(ExtractXDocType(trgXDocId));
  IF  ~!TABLE.Get(trgXDoc).Fields("CopyCnt") THEN
   SAVE((trgXDoc));
   PositionOnXDoc(trgXDocId);
   Result:=^(TABLE.Get(trgXDoc).Fields("CopyCnt").ObtainName());
   RESTORE((trgXDoc));
  END;
  RETURN Result;
 END {GetXDocCopyCnt};

 PUBLIC PROCEDURE GetFirmByXDocId(xdid: tXDocId): LIKE(Firm.Firm);
  VAR
   xdt: tXDocType;
   xdk: tXDocKind;
   xd : tXDoc;
 BEGIN
  DecodeXDocId(xdid, xdt, xdk, xd);
  IF    xdt = xdt_PDoc     THEN
   SELECT(PDoc, PDoc, , xdk, xd);
   RETURN PDoc.Firm;
  ELSIF xdt = xdt_MDoc     THEN
   SELECT(MDoc, MDoc, , xdk, xd);
   RETURN MDoc.Firm;
  ELSIF xdt = xdt_ODoc     THEN
   SELECT(ODoc, ODoc, , xdk, xd);
   RETURN ODoc.Firm;
  ELSIF xdt = xdt_Contract THEN
   SELECT(Contract, Contract, , xd);
   RETURN Contract.Firm;
  ELSIF xdt = xdt_CWOrder  THEN
   SELECT(CWOrder, CWOrder, , xd);
   CONFORM(CWOrder, Contract);
   RETURN Contract.Firm;
  ELSIF xdt = xdt_TckRcD   THEN
   SELECT(TckRcD, TckRcD, , xd);
   RETURN TckRcD.Firm;
  ELSIF xdt = xdt_CarAD    THEN
   SELECT(CarAD, CarAD, , xd);
   CONFORM(CarAD, Contract);
   RETURN Contract.Firm;
  ELSIF xdt = xdt_Firm     THEN
   SELECT(Firm, Firm, , xd);
   RETURN Firm.Firm;
  ELSIF xdt = xdt_IRec     THEN
   SELECT(IRec, IRec, , xd);
   RETURN IRec.CarrFirm;
  ELSE
   RETURN "";
  END;
 END {GetFirmByXDocId};

 PRIVATE PROCEDURE GetMyFirmByTable(trgTable: TABLE): LIKE(MyFirm.MyFirm);
  VAR
   Result: LIKE(MyFirm.MyFirm);
 BEGIN
  IF    ~!trgTable.Fields("MyFirm") THEN
   Result:=^(trgTable.Fields("MyFirm").ObtainName());
  ELSIF trgTable.Name = "RWayS" THEN
   Result:=L_Way.GetRWaySMyFirm();
  ELSIF trgTable.Name = "PCalc" THEN
   CONFORM(PCalc, Staff);
   Result:=Staff.MyFirm;
  ELSE
   L_General.CallUs(0);
  END;
  RETURN Result;
 END {GetMyFirmByTable};

 PUBLIC PROCEDURE GetMyFirmByXDocId(trgXDocId: tXDocId): LIKE(MyFirm.MyFirm);
  VAR
   Result: LIKE(MyFirm.MyFirm);
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   PositionOnXDoc(trgXDocId);
   Result:=GetMyFirmByTable(TABLE.Get(Ref_FileName(ExtractXDocType(trgXDocId))));
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {GetMyFirmByXDocId};

 PUBLIC PROCEDURE GetMyFirmBy_iri(trg_iri: L_General.tInternalRecordId): LIKE(MyFirm.MyFirm);
  VAR
   trgTable: TABLE;
   Result  : LIKE(MyFirm.MyFirm);
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   trgTable:=DATABASE.Get().TableById(L_General.iri_fi(trg_iri));
   SEARCH((trgTable.Name), RECORDID, , L_General.iri_ri(trg_iri));
   Result:=GetMyFirmByTable(trgTable);
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {GetMyFirmBy_iri};

 PUBLIC PROCEDURE xdc_Item(Collection: tXDocCollection; i: NUMERIC[0]): tXDocId;
 BEGIN
  RETURN L_Str.PoolItem(Collection, i);
 END {xdc_Item};

 PUBLIC PROCEDURE xdc_Count(Collection: tXDocCollection): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  Result:=0;
  WHILE ~!xdc_Item(Collection, Result) DO
   INC(Result);
  END;
  RETURN Result;
 END {xdc_Count};

 PUBLIC PROCEDURE xdc_Put(VAR Collection: tXDocCollection; XDocId: tXDocId);
 BEGIN
  Collection:=Collection + "|" + XDocId;
 END {xdc_Put};

 PUBLIC PROCEDURE xdc_PositionOn(Collection: tXDocCollection; i: NUMERIC[0]): SCAL[2];
 BEGIN
  IF i < xdc_Count(Collection) THEN
   PositionOnXDoc(xdc_Item(Collection, i));
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {xdc_PositionOn};

 PUBLIC PROCEDURE GetSingleRefToXDocId(_XDocId: tXDocId): tXDocId;
  VAR
   Result: tXDocId;
 BEGIN
  SETEMPTY(Result);
  IF SELECT(XDocRef, bXDocId, _XDocId) THEN
   LOOP
    IF ~OCCURE(XDocRef) THEN
     EXIT;
    ELSIF XDocRef.RefType # rft_BaseOn THEN
     IF !Result THEN
      Result:=XDocRef.rXDocId;
     ELSE
      SETEMPTY(Result);
      EXIT;
     END;
    END; (* IF OCCURE(XDocRef) *)
    NEXT(XDocRef);
   END; (* LOOP *)
  END; (* IF SELECT ... *)
  RETURN Result;
 END {GetSingleRefToXDocId};

 PUBLIC PROCEDURE GetBaseOnXDocId(_XDocId: tXDocId): tXDocId;
  VAR
   Result: tXDocId;
 BEGIN
  SETEMPTY(Result);
  SELECT(XDocRef, bXDocId, , _XDocId);
  WHILE OCCURE(XDocRef) DO
   IF XDocRef.RefType = rft_BaseOn THEN
    IF !Result THEN
     Result:=XDocRef.rXDocId;
    ELSE
     SETEMPTY(Result);
     LAST(XDocRef);
    END;
   END;
   NEXT(XDocRef);
  END; (* WHILE OCCURE(XDocRef) *)
  RETURN Result;
 END {GetBaseOnXDocId};

 PUBLIC PROCEDURE GetAnnexXDocId(rXDocId: tXDocId): tXDocId;
  VAR
   Result: tXDocId;
 BEGIN
  SETEMPTY(Result);
  SELECT(XDocRef, rXDocId, , rXDocId);
  WHILE OCCURE(XDocRef) DO
   IF XDocRef.RefType = rft_Annex THEN
    L_General.CallUs(!Result);
    Result:=XDocRef.bXDocId;
   END;
   NEXT(XDocRef);
  END; (* WHILE OCCURE(XDocRef) *)
  RETURN Result;
 END {GetAnnexXDocId};

 PUBLIC PROCEDURE GetMainXDocIdPfAnnexXDoc(bXDocId: tXDocId): tXDocId;
  VAR
   Result: tXDocId;
 BEGIN
  SETEMPTY(Result);
  SELECT(XDocRef, bXDocId, , bXDocId);
  WHILE OCCURE(XDocRef) DO
   IF XDocRef.RefType = rft_Annex THEN
    L_General.CallUs(!Result);
    Result:=XDocRef.rXDocId;
   END;
   NEXT(XDocRef);
  END; (* WHILE OCCURE(XDocRef) *)
  RETURN Result;
 END {GetMainXDocIdPfAnnexXDoc};

 PUBLIC PROCEDURE GetRefToXDC(_XDocId: tXDocId; reqXDT: tXDocType): tXDocCollection;
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  SETSEL(XDocRef, bXDocId, _XDocId);
  FOR_EACH XDocRef DO
   IF (XDocRef.RefType # rft_Reverse) & (!reqXDT | (ExtractXDocType(XDocRef.rXDocId) = reqXDT)) THEN
    xdc_Put(Result, XDocRef.rXDocId);
   END;
  END; (* FOR_EACH XDocRef *)
  RETURN Result;
 END {GetRefToXDC};

 PUBLIC PROCEDURE GetRefToXDC_Transitively(_XDocId: tXDocId; reqXDT : tXDocType): tXDocCollection;
  VAR
   Result: tXDocCollection;
 BEGIN
  LOOP
   Result:=GetRefToXDC(_XDocId, reqXDT);
   IF ~!Result THEN
    EXIT;
   ELSE
    _XDocId:=GetBaseOnXDocId(_XDocId);
    IF !_XDocId THEN
     EXIT;
    END;
   END;
  END; (* LOOP *)
  RETURN Result;
 END {GetRefToXDC_Transitively};

 PUBLIC PROCEDURE GetSingleRefToReqXDT(_XDocId: tXDocId; reqXDT : tXDocType): tXDocId;
  VAR
   xdc   : tXDocCollection;
   Result: tXDocId;
 BEGIN
  xdc:=GetRefToXDC(_XDocId, reqXDT);
  IF xdc_Count(xdc) = 1 THEN
   Result:=xdc_Item(xdc, 0);
  ELSE
   SETEMPTY(Result);
  END;
  RETURN Result;
 END {GetSingleRefToReqXDT};

 PUBLIC PROCEDURE GetAllRefToXDC(_XDocId: tXDocId): tXDocCollection;
 BEGIN
  RETURN GetRefToXDC(_XDocId, EMPTYOF(tXDocType));
 END {GetAllRefToXDC};

 PUBLIC PROCEDURE GetDependentXDC(_XDocId: tXDocId; reqXDT: tXDocType): tXDocCollection;
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  SELECT(XDocRef, rXDocId, , _XDocId);
  WHILE OCCURE(XDocRef) DO
   IF (XDocRef.RefType # rft_Reverse) & (!reqXDT | (ExtractXDocType(XDocRef.bXDocId) = reqXDT)) THEN
    xdc_Put(Result, XDocRef.bXDocId);
   END;
   NEXT(XDocRef);
  END; (*WHILE OCCURE(XDocRef) *)
  RETURN Result;
 END {GetDependentXDC};

 PUBLIC PROCEDURE GetAllDependentXDC(_XDocId: tXDocId): tXDocCollection;
 BEGIN
  RETURN GetDependentXDC(_XDocId, EMPTYOF(tXDocType));
 END {GetAllDependentXDC};

 PRIVATE PROCEDURE IsReverseXDoc(_XDocId: tXDocId): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  SAVE(XDocRef);
  SELECT(XDocRef, bXDocId, , _XDocId);
  WHILE OCCURE(XDocRef) & (XDocRef.RefType # rft_Reverse) DO
   NEXT(XDocRef);
  END; (*WHILE OCCURE(XDocRef) *)
  Result:=OCCURE(XDocRef);
  RESTORE(XDocRef);
  RETURN Result;
 END {IsReverseXDoc};

 PRIVATE PROCEDURE XDocIsReversed(_XDocId: tXDocId): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  SAVE(XDocRef);
  SELECT(XDocRef, rXDocId, , _XDocId);
  WHILE OCCURE(XDocRef) & (XDocRef.RefType # rft_Reverse) DO
   NEXT(XDocRef);
  END; (*WHILE OCCURE(XDocRef) *)
  Result:=OCCURE(XDocRef);
  RESTORE(XDocRef);
  RETURN Result;
 END {XDocIsReversed};

 PUBLIC PROCEDURE IsInReversedPair(_XDocId: tXDocId): SCAL[2];
 BEGIN
  RETURN XDocIsReversed(_XDocId) | IsReverseXDoc(_XDocId);
 END {IsInReversedPair};

 PUBLIC PROCEDURE extXDocStr(_XDocId: tXDocId; xdast: tXDocAsStr): STRING[];
 BEGIN
  RETURN intXDocStr("", _XDocId, xdast);
 END {extXDocStr};

 PUBLIC PROCEDURE XDocStr(_XDocId: tXDocId): STRING[];
 BEGIN
  RETURN extXDocStr(_XDocId, xdast_Simple);
 END {XDocStr};

 PRIVATE VAR
  (* 18.05.2005 21:58:24 POLAK\San -  ᪠ १ ࠬ.
     ࠡ쭮  㦭. 㦭 । MODULE   ;( *)
  lxdm_XDC,
  lxdm_Lst,
  lxdm_Leader: STRING[];

 PRIVATE PROCEDURE lxdm_XDocStr(cXDocId,
                                lXDocId: tXDocId;
                                Own,
                                Direct : SCAL[3]): STRING[];
  VAR
   SpcSign: STRING[];
 BEGIN
  IF    IsReverseXDoc(lXDocId) THEN
   SpcSign:="--";
  ELSIF XDocIsReversed(lXDocId) THEN
   SpcSign:="!!";
  ELSE
   IF    Direct = 2 THEN
    SpcSign:=L_Str.PoolItem("<?|?>", Own);
   ELSIF Direct = 1 THEN
    SpcSign:=L_Str.PoolItem("<<|>>", Own);
   ELSE
    SpcSign:=L_Str.PoolItem("<-|->", Own);
   END;
  END;
  SpcSign:=SpcSign + " ";
  RETURN SpcSign + intXDocStr(cXDocId, lXDocId, xdast_wStatus);
 END {lxdm_XDocStr};

 PRIVATE PROCEDURE lxdm_Append(cXDocId,
                               lXDocId: tXDocId;
                               Own,
                               Direct : SCAL[3]);
 BEGIN
  TRY [TABLE_FILTER_MODE(TABLE_FILTER_MODE_THROW), EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   IF ~!lXDocId THEN
    lxdm_XDC:=lxdm_XDC + "|" + lXDocId;
    lxdm_Lst:=lxdm_Lst + "|" + lxdm_XDocStr(cXDocId, lXDocId, Own, Direct);
   END;
  EXCEPT
  ON Exc: Exc_NoRights DO
  END; (* TRY *)
 END {lxdm_Append};

 PRIVATE PROCEDURE lxdm_AcceptableXDT(xdt: tXDocType): SCAL[2];
 BEGIN
  RETURN ~!xdt & XDocTypeHasXDocJrn(xdt);
 END {lxdm_AcceptableXDT};

 PUBLIC PROCEDURE GetFileXDT(File: STRING[]): tXDocType;
 BEGIN
  RETURN L_Str.PositionInPool(ref_FileNames, File);
 END {GetFileXDT};

 PRIVATE PROCEDURE lxdm_ScanDirectLinks(cXDocId: tXDocId; File: STRING[]): SCAL[2];
  VAR
   Link,
   cooFile    : STRING[];
   LinkKind   : NUMERIC[0];
   cooXDT     : tXDocType;
   i          : NUMERIC[0];
   Result     : SCAL[2];
 BEGIN
  Result:=0;
  i:=0;
  WHILE i < DBD.LinkAmount(^File) DO
   Link       :=DBD.LinkName(^File, i);
   cooFile    :=DBD.LinkCooFileName(^File, ^Link);
   IF cooFile # lxdm_Leader THEN
    LinkKind:=DBD.LinkKind(^File, ^Link);
    cooXDT  :=GetFileXDT(cooFile);
    TRY [TABLE_FILTER_MODE(TABLE_FILTER_MODE_THROW), EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
     IF    (LinkKind = L_General.lk_USER) | (LinkKind = L_General.lk_BORROW) THEN
      IF lxdm_AcceptableXDT(cooXDT) THEN
       TRY
        SAVE((cooFile));
        CONFORM((File), (cooFile));
        IF OCCURE((cooFile)) THEN
         lxdm_Append(cXDocId, curXDocId(cooXDT), 1, 1);
         Result:=1;
        END;
        RESTORE((cooFile));
       EXCEPT
       ON Exc: Exc_Root DO
        IF Exc.ErrorCode # 166 THEN
         RAISE();
        END;
       END; (* TRY *)
      END;
     ELSIF (LinkKind = L_General.lk_OWNER) | (LinkKind = L_General.lk_LEND) THEN
      SAVE((cooFile));
      L_DBD.SelectUsers(File, Link);
      IF lxdm_AcceptableXDT(cooXDT) THEN
       Result:=1;
       WHILE OCCURE((cooFile)) DO
        lxdm_Append(cXDocId, curXDocId(cooXDT), 0, 1);
        NEXT((cooFile));
       END; (* WHILE OCCURE((cooFile))...*)
      ELSE
       WHILE OCCURE((cooFile)) & lxdm_ScanDirectLinks(cXDocId, cooFile) DO
        Result:=1;
        NEXT((cooFile));
       END; (* WHILE OCCURE((cooFile))...*)
      END;
      RESTORE((cooFile));
     END;
    EXCEPT
    ON Exc: Exc_NoRights DO
    ON Exc: Exc_RunTime  DO
     IF Exc.ErrorCode # 970 THEN
      RAISE();
     END;
    END; (* TRY *)
   END;
   INC(i);
  END; (* WHILE i *)
  RETURN Result;
 END {lxdm_ScanDirectLinks};

 PRIVATE PROCEDURE lxdm_ScanLeaderDirectLinks(cXDocId: tXDocId);
  VAR
   Dummy: SCAL[2];
 BEGIN
  lxdm_Leader:=Ref_FileName(ExtractXDocType(cXDocId));
  Dummy:=lxdm_ScanDirectLinks(cXDocId, lxdm_Leader);
 END {lxdm_ScanLeaderDirectLinks};

 PRIVATE PROCEDURE lxdm_ConditionalAppend(cXDocId,
                                          lXDocId: tXDocId;
                                          Own,
                                          Direct : SCAL[3]);
 BEGIN
  IF !DATABASE.Get().Tables("lxdmCA") THEN
   L_AFM.MakeIndex("lxdmCA", "XDocId: " + TYPENAMEOF(tXDocId) + ";");
  END;
  IF ~SELECT(lxdmCA, lxdmCA, lXDocId) THEN
   lxdmCA.XDocId:=lXDocId;
   INSERT(lxdmCA);
   lxdm_Append(cXDocId, lXDocId, Own, Direct);
  END;
 END {lxdm_ConditionalAppend};

 PRIVATE PROCEDURE lxdmpl_EDOrder(cXDocId: tXDocId);
 BEGIN
  SELECT(EDOLC, XDocId, , cXDocId);
  WHILE OCCURE(EDOLC) DO
   CONFORM(EDOLC, EDOrder);
   lxdm_ConditionalAppend(cXDocId, curXDocId(xdt_EDOrder), 0, 0);
   NEXT(EDOLC);
  END;
 END {lxdmpl_EDOrder};

 PRIVATE PROCEDURE lxdmpl_Dspt(cXDocId: tXDocId);
 BEGIN
  SELECT(DsptDoc, XDocId, , cXDocId);
  WHILE OCCURE(DsptDoc) DO
   CONFORM(DsptDoc, Dspt);
   lxdm_ConditionalAppend(cXDocId, curXDocId(xdt_Dispatch), 0, 0);
   NEXT(DsptDoc);
  END;
 END {lxdmpl_Dspt};

 PRIVATE PROCEDURE lxdmpl_IRecL(cXDocId: tXDocId);
 BEGIN
  SELECT(IRecL, IRec, , IRec.IRec);
  WHILE OCCURE(IRecL) DO
   IF ~!IRecL.asRWayS & SEARCH(RWayS, RWayS, IRecL.asRWayS) THEN
    lxdm_ConditionalAppend(cXDocId, curXDocId(xdt_RWayS), 0, 0);
   END;
   NEXT(IRecL);
  END; (* WHILE OCCURE(IRecL) ... *)
 END {lxdmpl_IRecL};

 PRIVATE PROCEDURE lxdmpl_IRec(cXDocId: tXDocId);
 BEGIN
  IF SELECT(IRecL, asRWayS, RWayS.RWayS) THEN
   WHILE OCCURE(IRecL) DO
    CONFORM(IRecL, IRec);
    lxdm_ConditionalAppend(cXDocId, curXDocId(xdt_IRec), 1, 0);
    NEXT(IRecL);
   END; (* WHILE OCCURE(IRecL) ... *)
  END;
 END {lxdmpl_IRec};

 PRIVATE PROCEDURE lxdmpl_TckRcSByRWayS(cXDocId: tXDocId);
 BEGIN
  IF SELECT(TckRcJ, asRWayS, RWayS.RWayS) THEN
   WHILE OCCURE(TckRcJ) DO
    CONFORM(TckRcJ, TckRcS);
    lxdm_ConditionalAppend(cXDocId, curXDocId(xdt_TckRcS), 1, 0);
    NEXT(TckRcJ);
   END; (* WHILE OCCURE(TckRcJ) ... *)
  END;
  IF SELECT(TckRcJ, asBoxNbr, RWayS.BoxNbr, RWayS.Date) THEN
   WHILE OCCURE(TckRcJ) DO
    IF !TckRcJ.asRWayS THEN
     CONFORM(TckRcJ, TckRcS);
     lxdm_ConditionalAppend(cXDocId, curXDocId(xdt_TckRcS), 1, 2);
    END;
    NEXT(TckRcJ);
   END; (* WHILE OCCURE(TckRcJ) ... *)
  END;
 END {lxdmpl_TckRcSByRWayS};

 PRIVATE PROCEDURE lxdmpl_RWaySByTckRcS(cXDocId: tXDocId);
 BEGIN
  SELECT(TckRcJ, TckRcS, , TckRcS.TckRcS);
  WHILE OCCURE(TckRcJ) DO
   IF    ~!TckRcJ.asRWayS & SEARCH(RWayS, RWayS, TckRcJ.asRWayS) THEN
    lxdm_ConditionalAppend(cXDocId, curXDocId(xdt_RWayS), 0, 0);
   ELSIF ~!TckRcJ.asBoxNbr & SELECT(RWayS, BoxNbr, TckRcJ.asBoxNbr, TckRcJ.asDate) THEN
    REPEAT
     lxdm_ConditionalAppend(cXDocId, curXDocId(xdt_RWayS), 0, 2);
     NEXT(RWayS);
    UNTIL ~OCCURE(RWayS);
   END;
   NEXT(TckRcJ);
  END; (* WHILE OCCURE(TckRcJ) ... *)
 END {lxdmpl_RWaySByTckRcS};

 PRIVATE PROCEDURE lxdmpl_DoInTry(cXDocId: tXDocId; lxdmpl: PROC);
 BEGIN
  TRY [TABLE_FILTER_MODE(TABLE_FILTER_MODE_THROW), EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   lxdmpl(cXDocId);
  EXCEPT
  ON Exc: Exc_NoRights DO
  ON Exc: Exc_RunTime  DO
   IF Exc.ErrorCode # 970 THEN
    RAISE();
   END;
  END; (* TRY *)
 END {lxdmpl_DoInTry};

 PRIVATE PROCEDURE lxdm_PrepareList(cXDocId: tXDocId; WithDirectLinks: SCAL[2]);
 BEGIN
  SETEMPTY(lxdm_XDC, lxdm_Lst);
  IF WithDirectLinks THEN
   lxdm_ScanLeaderDirectLinks(cXDocId);
  END;
  SELECT(XDocRef, bXDocId, , cXDocId);
  WHILE OCCURE(XDocRef) DO
   lxdm_Append(cXDocId, XDocRef.rXDocId, 1, 0);
   NEXT(XDocRef);
  END; (* WHILE OCCURE(XDocRef) *)
  SELECT(XDocRef, rXDocId, , cXDocId);
  WHILE OCCURE(XDocRef) DO
   lxdm_Append(cXDocId, XDocRef.bXDocId, 0, 0);
   NEXT(XDocRef);
  END; (* WHILE OCCURE(XDocRef) *)
  lxdmpl_DoInTry(cXDocId, PROCREF(lxdmpl_EDOrder));
  lxdmpl_DoInTry(cXDocId, PROCREF(lxdmpl_Dspt));
  IF    ExtractXDocType(cXDocId) = xdt_IRec THEN
   lxdmpl_DoInTry(cXDocId, PROCREF(lxdmpl_IRecL));
  ELSIF ExtractXDocType(cXDocId) = xdt_RWayS THEN
   lxdmpl_DoInTry(cXDocId, PROCREF(lxdmpl_IRec));
   lxdmpl_DoInTry(cXDocId, PROCREF(lxdmpl_IRec));
   lxdmpl_DoInTry(cXDocId, PROCREF(lxdmpl_TckRcSByRWayS));
  ELSIF ExtractXDocType(cXDocId) = xdt_TckRcS THEN
   lxdmpl_DoInTry(cXDocId, PROCREF(lxdmpl_RWaySByTckRcS));
  END;
 END {lxdm_PrepareList};

 PRIVATE PROCEDURE lxdm_ChosenXDoc(): tXDocId;
 BEGIN
  RETURN xdc_Item(lxdm_XDC, L_StdFrm.ShowListAsMenu(lxdm_Lst, "易 㬥"));
 END {lxdm_ChosenXDoc};

 PUBLIC PROCEDURE LinkedXDocsMenu_woDirectLinks(cXDocId: tXDocId): tXDocId;
 BEGIN
  lxdm_PrepareList(cXDocId, 0);
  RETURN lxdm_ChosenXDoc();
 END {LinkedXDocsMenu_woDirectLinks};

 PUBLIC PROCEDURE LinkedXDocsMenu(cXDocId: tXDocId): tXDocId;
 BEGIN
  lxdm_PrepareList(cXDocId, 1);
  RETURN lxdm_ChosenXDoc();
 END {LinkedXDocsMenu};

 PUBLIC PROCEDURE ConvertXDocIdsToAsStrList(Collection: tXDocCollection): STRING[];
  VAR
   Result: STRING[];
   i     : NUMERIC[0];
 BEGIN
  Result:="";
  i:=0;
  WHILE i < xdc_Count(Collection) DO
   Result:=Result + "|" + extXDocStr(xdc_Item(Collection, i), xdast_wStatus);
   INC(i);
  END;
  RETURN Result;
 END {ConvertXDocIdsToAsStrList};

 PRIVATE PERMANENT VAR
  sl_Title,
  sl_XDC,
  sl_List  : STRING[];
  sl_Cur   : NUMERIC[0];

 PUBLIC PROCEDURE sl_Init(Title: STRING[]);
 BEGIN
  sl_Title:=Title;
  SETEMPTY(sl_XDC, sl_List);
  sl_Cur:=0;
 END {sl_Init};

 PUBLIC PROCEDURE sl_AddItem(Id: tXDocId; Item: STRING[]);
 BEGIN
  L_General.Assert(Str.Pos(Id, "|") = Str.Length(Id),
                   "ப '" + Id + "'|ᮤন 饭 ᨬ");
  L_General.Assert(Str.Pos(Item, "|") = Str.Length(Item),
                   "ப '" + Item + "'|ᮤন 饭 ᨬ");
  L_General.Assert(Str.Pos(Item, CHR(255)) = Str.Length(Item),
                   "ப '" + Item + "'|ᮤন 饭 ᨬ");

  sl_XDC :=sl_XDC +  Id   + "|";
  sl_List:=sl_List + Item + "|";
 END {sl_AddItem};

 PUBLIC PROCEDURE sl_Done();
 BEGIN
  IF ~L_General.BatchExecution_IsRunning() THEN
   LIKEMENU(Survey, "", CALL, "XDoc.SetReportWNavigationSurveyWindowTitle()", SC, "XDoc.Srv_wList");
  END;
 END {sl_Done};

 PUBLIC PROCEDURE sl_Done_woSurvey();
 BEGIN
  IF ~L_General.BatchExecution_IsRunning() THEN
   LIKEMENU(SC, "XDoc.Srv_wList");
  END;
 END {sl_Done_woSurvey};

 PUBLIC PROCEDURE sl_extShow(addButtons: STRING[][]; Caption: STRING[]): NUMERIC[0];
  VAR
   trgButtons: STRING[][16];
   i         : NUMERIC[0];
   Result    : NUMERIC[0];
 BEGIN
  SETEMPTY(trgButtons);
  IF L_StdFrm.wGUI() | ~!addButtons[0] THEN
   trgButtons[0]:="३  㬥";
   trgButtons[1]:="⮯!";
   i:=0;
   WHILE (i <= HIGH(addButtons)) & ~!addButtons[i] DO
    trgButtons[i+2]:=addButtons[i];
    INC(i);
   END;
  END;
  LOOP
   L_StdFrm.ShowListAsMenu_wButtons(sl_List, sl_Title, Caption, sl_Cur, trgButtons, sl_Cur, Result);
   pvs_XDocId:=xdc_Item(sl_XDC, sl_Cur);
   IF (Result = 1) & (pvs_XDocId = MAXOF(tXDocId)) THEN
    L_StdFrm.Inform(" ப   ᠭ 㬥");
   ELSE
    EXIT;
   END;
  END; (* LOOP *)
  RETURN Result;
 END {sl_extShow};

 PUBLIC PROCEDURE sl_Show();
  VAR
   Dummy: NUMERIC[0];
 BEGIN
  Dummy:=sl_extShow("", "");
 END {sl_Show};

 PUBLIC PROCEDURE sl_AddCurrentXDoc(xdt: tXDocType);
  VAR
   Item: STRING[];
 BEGIN
  Item:=extXDocStr(curXDocId(xdt), xdast_wStatus);
  sl_AddItem(curXDocId(xdt), Item);
 END {sl_AddCurrentXDoc};

 PUBLIC PROCEDURE rf_coreInsert(_bXDocId,
                                _rXDocId  : tXDocId;
                                _RefType  : tReferenceType);
 BEGIN
  XDocRef.bXDocId:=_bXDocId;
  XDocRef.rXDocId:=_rXDocId;
  XDocRef.RefType:=_RefType;
  INSERT(XDocRef);
 END {rf_coreInsert};

 PUBLIC PROCEDURE rf_Insert(_bXDocType: tXDocType;
                            _rXDocId  : tXDocId;
                            _RefType  : tReferenceType);
 BEGIN
  rf_coreInsert(curXDocId(_bXDocType), _rXDocId, _RefType);
 END {rf_Insert};

 PUBLIC PROCEDURE rf_InsertParent(_bXDocId  : tXDocId;
                                  _rXDocType: tXDocType;
                                  _RefType  : tReferenceType);
 BEGIN
  rf_coreInsert(_bXDocId, curXDocId(_rXDocType), _RefType);
 END {rf_InsertParent};

 (*?!?*)
 PUBLIC PROCEDURE rf_Remove(_bXDocType: tXDocType;
                            _rXDocId  : tXDocId;
                            _RefType  : tReferenceType);
 BEGIN
  L_General.CallUs(SEARCH(XDocRef, bXDocId, curXDocId(_bXDocType), _rXDocId));
  L_General.CallUs(XDocRef.RefType = _RefType);
  REMOVE(XDocRef);
 END {rf_Remove};

 PUBLIC PROCEDURE rf_Clear(_bXDocType: tXDocType);
 BEGIN
  IF SELECT(XDocRef, bXDocId, curXDocId(_bXDocType)) THEN
   REMSEL(XDocRef);
  END;
 END {rf_Clear};

 PUBLIC PROCEDURE XDoc_OnBeforeDelete(trgXDocId: tXDocId);
  VAR
   trgXDocType: tXDocType;
   trgXDocKind: tXDocKind;
   trgXDoc    : tXDoc;
 BEGIN
  TRY
   GRANT_ALL_RIGHTS();
   L_General.Assert(~SELECT(XDocRef, rXDocId, trgXDocId) &
                    ~SELECT(EDOLC,   XDocId,  trgXDocId) &
                    ~SELECT(DsptDoc, XDocId,  trgXDocId),
                    XDocStr(trgXDocId) + "  易 㬥  㤠  ");
   L_Acnt.RenXDocApr(trgXDocId);
   L_General.Assert(~SELECT(XDocApr, XDocApr, trgXDocId),
                    XDocStr(trgXDocId) + "  ஢   ਮ  㤠  ");
   DecodeXDocId(trgXDocId, trgXDocType, trgXDocKind, trgXDoc);
   rf_Clear(trgXDocType);
   IF XDocTypeHasXDocJrn(trgXDocType) THEN
    XDoc_Clear(trgXDocType, trgXDocKind, trgXDoc);
   END;
  EXCEPT
  END; (* TRY *)
 END {XDoc_OnBeforeDelete};

 PUBLIC PROCEDURE IsINN(_INN: STRING[]; VAR _Firm: tXDoc): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   L_AR.GrantRightsUnconditionally();
   P_Firm.Check_INN(_INN);
   IF SELECT(Firm, INN, _INN) THEN
    _Firm:=Firm.Firm;
    Result:=1;
   END;
  EXCEPT
  ON Exc: Exc_Root DO
  END; (* TRY *)
  RETURN Result;
 END {IsINN};

 PRIVATE PROCEDURE IsMathEAN(_EAN: STRING[]; VAR _Math: tXDoc): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  TRY
   L_AR.GrantRightsUnconditionally();
   IF SEARCH(MathEAN, EAN, _EAN) & ~MathEAN.IsMask THEN
    _Math:=MathEAN.Math;
    Result:=1;
   END;
  EXCEPT
  END;
  RETURN Result;
 END {IsMathEAN};

 PUBLIC PROCEDURE IsCUCopySerial(_Serial: STRING[]; VAR _CUCopy: tXDoc): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  TRY
   L_AR.GrantRightsUnconditionally();
   IF SELECT(CUCopy, Serial, _Serial) THEN
    SAVE(CUCopy);
    Result:=~NEXT(CUCopy);
    RESTORE(CUCopy);
    _CUCopy:=CUCopy.CUCopy;
   END;
  EXCEPT
  END;
  RETURN Result;
 END {IsCUCopySerial};

 PUBLIC PROCEDURE SearchMathBySerial(_Serial: STRING[]; VAR _Math: tXDoc): SCAL[2];
 BEGIN
  SETSEL(MathEAN, EAN);
  IF SRCINSEL(MathEAN, LT, _Serial) &
     MathEAN.IsMask &
     Str.Match(_Serial, MathEAN.EAN+"*") THEN
   _Math:=MathEAN.Math;
  ELSE
   SETEMPTY(_Math);
  END;
  RETURN ~!_Math;
 END {SearchMathBySerial};

 PUBLIC PROCEDURE DecodeBarCode(_BarCodeType : L_BarCode.tBarCodeType;
                                _BarCode     : STRING[];
                                Silent       : SCAL[2];
                                VAR _XDocType: tXDocType;
                                VAR _XDocKind: tXDocKind;
                                VAR _XDoc    : tXDoc;
                                VAR _CopyCnt : tCopyCnt);
  CONST
   IncorrectBarCode = "-  ᯮ";
   PleaseTryLate    = "| |஡    ࠧ";

  VAR
   _BarCodeKind  : tBarCodeKind;
   _XDocId       : tXDocId;
   bc_Length     : NUMERIC[0];
 BEGIN
  SETEMPTY(_XDocType);
  TRY
   IF    Str.Slice(_BarCode, 0, 4) = "2900" THEN
    _BarCodeKind:=bck_IdIn20;
    L_General.Assert((_BarCodeType = L_BarCode.SCAN_SDT_ITF) | (_BarCodeType = L_BarCode.SCAN_STD_KBSCAN),
                     " ᪠  ন ⥭  ⨯ -.");
    bc_Length:=20;
    _XDocId  :=Str.Slice(_BarCode, 4, 13);
   ELSIF Str.Slice(_BarCode, 0, 1) = "2"    THEN
    _BarCodeKind:=bck_IdIn17;
    bc_Length:=17;
    _XDocId  :=Str.Slice(_BarCode,  1, 13);
   ELSE
    L_General.Error(IncorrectBarCode + PleaseTryLate);
   END;
   L_General.Assert(Str.Length(_BarCode)=bc_Length,
                    IncorrectBarCode +
                    "|(୮ 祭 (ࠧ來))" +
                    PleaseTryLate);
   L_General.Assert(L_Str.TestStrAlowChar(_BarCode, "09"),
                    IncorrectBarCode +
                    "|(୮ 祭 (⠢))" +
                    PleaseTryLate);
   L_General.Assert(L_BarCode.CheckCheckDigit(_BarCode),
                    IncorrectBarCode +
                    "|(୮ 祭 (஫ ࠧ))" +
                    PleaseTryLate);
   DecodeXDocId(_XDocId, _XDocType, _XDocKind, _XDoc);
   L_General.Assert(_XDocType # xdt_Sticker,
                    ", ᮮ⢥騩 ⨪ " + _BarCode + "  ");
   _CopyCnt:=Str.Slice(_BarCode, bc_Length-3, 2);
   IF L_General.IsPolakSpecific() & (_XDocKind = 05) THEN (* 0023583 *)
    _DocKind:=52;
   END;
  EXCEPT
  ON Exc:Exc_Raise DO
   IF    IsINN(_BarCode, _XDoc) THEN
    _XDocType:=xdt_Firm;
    _XDocKind:=EmptyXDocKind;
    _CopyCnt:=0;
   ELSIF IsMathEAN(_BarCode, _XDoc) THEN
    _XDocType:=xdt_Math;
    _XDocKind:=EmptyXDocKind;
    _CopyCnt:=0;
   ELSIF IsCUCopySerial(_BarCode, _XDoc) THEN
    _XDocType:=xdt_CUCopy;
    _XDocKind:=EmptyXDocKind;
    _CopyCnt:=0;
   ELSIF SearchMathBySerial(_BarCode, _XDoc) THEN
    _XDocType:=xdt_Math;
    _XDocKind:=EmptyXDocKind;
    _CopyCnt:=0;
   ELSE
    IF ~Silent THEN
     RAISE();
    END;
   END;
  END; (* TRY *)
 END {DecodeBarCode};

 PRIVATE PROCEDURE dbbc_StandartErrorHandler(Exc: Exc_Raise;
                                             VAR _Message : STRING[];
                                             VAR _WasError: SCAL[2]);
 BEGIN
  _Message :=Exc.MsgOriginalText;
  _WasError:=1;
 END {dbbc_StandartErrorHandler};

 PRIVATE PROCEDURE bcsdm_DoByBarCodeDialog(SubTitle,
                                           _Message    : STRING[];
                                           _WasError   : SCAL[2];
                                           VAR _DocType: tXDocType;
                                           VAR _DocKind: tXDocKind;
                                           VAR _Doc    : tXDoc;
                                           VAR _CopyCnt: tCopyCnt): SCAL[2];
  VAR
   extMessage       : STRING[];
   React            : NUMERIC[0];
   bcsdm_DialogFieldsFlags: STRING[1][3];
 BEGIN
  _DocKind:=EmptyXDocKind;
  _CopyCnt:=0;
  extMessage:="";
  IF ~!_Message THEN
   extMessage:="|" + _Message + "|";
  END;
  IF VAR_IMPL.Get(grt_XDT).Initialized & ~!grt_XDT THEN
   _DocType:=grt_XDT;
   IF XDocTypeHasXDocKind(_DocType) THEN
    bcsdm_DialogFieldsFlags[0]:="";
    bcsdm_DialogFieldsFlags[1]:="F";
    bcsdm_DialogFieldsFlags[2]:="";
   ELSE
    bcsdm_DialogFieldsFlags[0]:="";
    bcsdm_DialogFieldsFlags[1]:="";
    bcsdm_DialogFieldsFlags[2]:="F";
   END;
  ELSE
   bcsdm_DialogFieldsFlags[0]:="F";
   bcsdm_DialogFieldsFlags[1]:="";
   bcsdm_DialogFieldsFlags[2]:="";
  END;
  React:=STDFORM(L_StdFrm.sf_Choice(extMessage +
                                    "| %################################% |" +
                                    "| %##%     %#######%     %##% |",
                                    "%L<" + ref_FullNames + ">" + bcsdm_DialogFieldsFlags[0] + "I" +
                                    "%L"                        + bcsdm_DialogFieldsFlags[1] + "I" +
                                    "%L"                        + bcsdm_DialogFieldsFlags[2] + "I" +
                                    "%LI"),
                 " " + SubTitle + "  ",
                 ^(L_Str.AnyItem("|STOP", "|", _WasError)),
                 ,
                 _DocType, _DocKind, _Doc, _CopyCnt);
  IF    React = 0 THEN
   RETURN 0;
  ELSIF React = 1 THEN
   IF ((_DocKind = EmptyXDocKind) &  XDocTypeHasXDocKind(_DocType) |
       (_DocKind # EmptyXDocKind) & ~XDocTypeHasXDocKind(_DocType)) & (_DocType # xdt_Dispatch) THEN
    L_General.Error("ᮮ⢥⢨   ⨯ 㬥⮢");
   END;
   RETURN 1;
  END;
 END {bcsdm_DoByBarCodeDialog};

 PRIVATE PROCEDURE intDoByBarCodeWithHint(SubTitle,
                                          Hint     : STRING[];
                                          P        : PROC;
                                          wKeyboard: SCAL[2];
                                          EHP      : PROC);
  VAR
   _BarCode   : STRING[];
   _DocType   : tXDocType;
   _DocKind   : tXDocKind;
   _Doc       : tXDoc;
   _CopyCnt   : tCopyCnt;
   _Message   : STRING[];
   BarCodeType: L_BarCode.tBarCodeType;
   _WasError  : SCAL[2];
 BEGIN
  _WasError:=0;
  SETEMPTY(_Message, _DocType, _DocKind, _Doc);
  L_BarCode.InitializeMode();
  IF ~wKeyboard &
     (L_BarCode.bcs_Mode = L_BarCode.bcsm_Normal) &
     L_General.IsProgrammer() THEN
   CALL(SYS_ENV.BarCodeScanner_SetMode());
  END;

  LOOP
   TRY
    IF L_BarCode.bcs_Mode = L_BarCode.bcsm_Normal THEN
     L_BarCode.GetBarCode(SubTitle, Hint, _Message, _WasError, wKeyboard, _BarCode, BarCodeType);
     IF !_BarCode THEN
      EXIT;
     END;
     _WasError:=0;
     DecodeBarCode(BarCodeType, _BarCode, 0, _DocType, _DocKind, _Doc, _CopyCnt);
    ELSE
     IF ~bcsdm_DoByBarCodeDialog(SubTitle, _Message, _WasError,
                                 _DocType, _DocKind, _Doc, _CopyCnt) THEN
      EXIT;
     END;
    END; (* IF L_BarCode.bcs_Mode = L_BarCode.bcsm_Normal...*)
    TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
     P(XDocId(_DocType, _DocKind, _Doc), _CopyCnt, _Message);
    EXCEPT
    ON Exc: Exc_Syntax DO
     IF Exc.ErrorCode = L_General.ec_sn_TooFewParametrs THEN
      P(XDocId(_DocType, _DocKind, _Doc), _CopyCnt, Hint, _Message);
     ELSE
      RAISE();
     END;
    END;
   EXCEPT
   ON Exc:Exc_Raise DO
    IF    Exc.MsgOriginalText = ed_BarCodeDialogNormalExit THEN
     EXIT;
    ELSIF Exc.MsgOriginalText # L_BarCode.ed_FinalError THEN
     EHP(Exc, _Message, _WasError);
    ELSE
     EXIT;
    END;
   ELSE
    RAISE();
   END; (* TRY *)
  END; (* LOOP *)
 END {intDoByBarCodeWithHint};

 PUBLIC PROCEDURE extDoByBarCode(SubTitle : STRING[];
                                 P        : PROC;
                                 wKeyboard: SCAL[2];
                                 EHP      : PROC);
 BEGIN
  intDoByBarCodeWithHint(SubTitle, EMPTYOF(STRING[]), P, wKeyboard, EHP);
 END {extDoByBarCode};

 PUBLIC PROCEDURE DoByBarCodeWithHint(SubTitle,
                                      Hint     : STRING[];
                                      P        : PROC;
                                      wKeyboard: SCAL[2]);
 BEGIN
  intDoByBarCodeWithHint(SubTitle, Hint, P, wKeyboard, PROCREF(dbbc_StandartErrorHandler));
 END {DoByBarCodeWithHint};

 PUBLIC PROCEDURE DoByBarCode(SubTitle : STRING[];
                              P        : PROC;
                              wKeyboard: SCAL[2]);
 BEGIN
  DoByBarCodeWithHint(SubTitle, EMPTYOF(STRING[]), P, wKeyboard);
 END {DoByBarCode};

 PRIVATE VAR
  grt_XDT   : tXDocType;
  grt_XDocId: tXDocId;

 PRIVATE PROCEDURE AcceptableXDT_ForXDoc_woBCS(xdt: tXDocType): SCAL[2];
 BEGIN
  RETURN (xdt = xdt_RWayS) | (xdt = xdt_TckRcS);
 END {AcceptableXDT_ForXDoc_woBCS};

 PRIVATE PROCEDURE GetXDocId_woBCS(): tXDocId;
  VAR
   _XDocId    : tXDocId;
   _CopyCnt   : NUMERIC[0];
   _BoxNbr    : LIKE(Car.BoxNbr);
   _TSN       : LIKE(Staff.TSN);
   _TckRcS    : LIKE(TckRcS.TckRcS);
   _RWayS     : LIKE(RWayS.RWayS);
   xdt        : tXDocType;
   Choice     : NUMERIC[0];
   xdtName,
   xdtList,
   xdtNameList: STRING[];
 BEGIN
  IF !grt_XDT THEN
   SETEMPTY(xdtList, xdtNameList);
   xdt:=xdt_RWayS;
   LOOP
    xdtName:=Ref_FullName(xdt);
    IF !xdtName THEN
     EXIT;
    END;
    IF AcceptableXDT_ForXDoc_woBCS(xdt) THEN
     xdtList    :=xdtList + xdt + "|";
     xdtNameList:=xdtNameList + xdtName + "|";
    END;
    INC(xdt);
   END; (* LOOP *)
   Choice:=L_StdFrm.ShowListAsMenu(xdtNameList, "롥 ⨯ 㬥,  ண  ᪠");
   grt_XDT:=L_Str.PoolItem(xdtList, Choice);
  END;
  SETEMPTY(_XDocId);
  IF    grt_XDT = xdt_RWayS THEN
   SETEMPTY(_CopyCnt, _BoxNbr, _TSN, _RWayS);
   IF STDFORM(L_StdFrm.sf_Choice("|        : %#######%  %##%|" +
                                 "|ࠦ  : %####%           |" +
                                 "| : %#####%          |" +
                                 "|",
                                 "%LI" +
                                 "%LI" +
                                 "%LI" +
                                 "%LI"),
              "", , , _RWayS, _CopyCnt, _BoxNbr, _TSN) THEN
    SAVE(RWayS);
    L_General.Assert(SEARCH(RWayS, RWayS, _RWayS), "  ⥢  " + _RWayS);
    L_General.Assert(RWayS.BoxNbr = _BoxNbr, "ࠦ      ᮮ⢥ 㪠");
    L_General.Assert(RWayS.TSN = _TSN, "      ᮮ⢥ 㪠");
    _XDocId:=curXDocId(grt_XDT);
    RESTORE(RWayS);
   ELSE
    RAISE(-1, L_BarCode.ed_FinalError);
   END;
  ELSIF grt_XDT = xdt_TckRcS THEN
   SETEMPTY(_CopyCnt, _TSN, _TckRcS);
   IF STDFORM(L_StdFrm.sf_Choice("|       : %#######%  %##%|" +
                                 "| : %#####%          |" +
                                 "|",
                                 "%LI" +
                                 "%LI" +
                                 "%LI"),
              "", , , _TckRcS, _CopyCnt, _TSN) = 1 THEN
    SAVE(TckRcS);
    L_General.Assert(SEARCH(TckRcS, TckRcS, _TckRcS), "  ⭮-  " + _TckRcS);
    L_General.Assert(TckRcS.TSN = _TSN, "      ᮮ⢥ 㪠");
    L_General.Assert(TckRcS.CopyCnt = _CopyCnt, "     ᮮ⢥  㬠 ⥫");
    _XDocId:=curXDocId(grt_XDT);
    RESTORE(TckRcS);
   ELSE
    RAISE(-1, L_BarCode.ed_FinalError);
   END;
  ELSE
   IF ~!grt_XDT THEN
    xdtName:="',| 㬥 '" +  Ref_FullName(grt_XDT) + "'";
   ELSE
    SETEMPTY(xdtName);
   END;
   L_General.Error(" ࠡ稪  ࠢ饣  '" + L_Str.PoolItem(cmd_Pool, cmd_BadXDocBC) +
                   xdtName);
  END;
  TRY [TRANSACTION(TRANSACTION_SLAVE)]
   SysLog.Mark("cmd_BadXDocBC", XDocStr(_XDocId));
  EXCEPT
  END; (* TRY *)
  RETURN _XDocId;
 END {GetXDocId_woBCS};

 PUBLIC PROCEDURE IsAcceptableBCCommand(_XDocId: tXDocId; BCCommand: tXDoc): SCAL[2];
  VAR
   _XDocType: tXDocType;
   _XDocKind: tXDocKind;
   _XDoc    : tXDoc;
 BEGIN
  DecodeXDocId(_XDocId, _XDocType, _XDocKind, _XDoc);
  RETURN (_XDocType = xdt_Command) & (_XDoc = BCCommand);
 END {IsAcceptableBCCommand};

 PRIVATE PROCEDURE grt_Proceed(trgXDocId: tXDocId; trgCopyCnt: NUMERIC[0]; VAR Message: STRING[]);
  VAR
   trgXDocType: tXDocType;
 BEGIN
  trgXDocType:=ExtractXDocType(trgXDocId);
  IF IsAcceptableBCCommand(trgXDocId, cmd_BadXDocBC) THEN
   trgXDocId:=GetXDocId_woBCS();
  ELSE
   L_General.Assert(!grt_XDT | (trgXDocType = grt_XDT), "  ꥪ  ᮮ⢥ ");
   IF trgXDocType # xdt_Command THEN
    SAVE((Ref_FileName(trgXDocType)));
    PositionOnXDoc(trgXDocId);
    IF ~!TABLE.Get(Ref_FileName(trgXDocType)).Fields("CopyCnt") THEN
     L_General.Assert(^(Ref_FileName(trgXDocType)).CopyCnt = trgCopyCnt,
                      "     ᮮ⢥  㬠 ⥫");
    END;
    RESTORE((Ref_FileName(trgXDocType)));
   END;
  END;
  grt_XDocId:=trgXDocId;
  RAISE(, ed_BarCodeDialogNormalExit);
 END {grt_Proceed};

 PUBLIC PROCEDURE GetRequiredTypeXDocIdByBC(SubTitle : STRING[];
                                            reqXDT   : tXDocType;
                                            wKeyboard: SCAL[2]): tXDocId;
 BEGIN
  grt_XDT:=reqXDT;
  SETEMPTY(grt_XDocId);
  DoByBarCode(SubTitle, PROCREF(grt_Proceed), wKeyboard);
  RETURN grt_XDocId;
 END {GetRequiredTypeXDocIdByBC};

 PUBLIC PROCEDURE GetRequiredTypeXDoc_woBCS(reqXDT: tXDocType): tXDocId;
 BEGIN
  grt_XDT:=reqXDT;
  SETEMPTY(grt_XDocId);
  RETURN GetXDocId_woBCS();
 END {GetRequiredTypeXDoc_woBCS};

 PUBLIC PROCEDURE IsCancelVerifingXDocId(_XDocId : tXDocId): SCAL[2];
 BEGIN
  RETURN IsAcceptableBCCommand(_XDocId, cmd_CancelVerifing);
 END {IsCancelVerifingXDocId};

 PRIVATE PROCEDURE vrt_VerifyXDoc(_XDocId: tXDocId; _CopyCnt: NUMERIC[0]; VAR Message: STRING[]);
  VAR
   _XDocType: tXDocType;
   _XDocKind: tXDocKind;
   _XDoc    : tXDoc;
 BEGIN
  IF ~!_XDocId THEN
   IF IsCancelVerifingXDocId(_XDocId) THEN
    L_StdFrm.RedInform("!  ⪠  易⥫쭮 䨪樨!|" +
                       "쭥 ࠡ  㬥⮬ 㤥 㤭  !");
    HALT(0);
   ELSE
    DecodeXDocId(_XDocId, _XDocType, _XDocKind, _XDoc);
    L_General.Assert(_XDocType = grt_XDT, "  ꥪ  ᮮ⢥ ");
    SAVE((Ref_FileName(_XDocType)));
    PositionOnXDoc(_XDocId);
    L_General.Assert(^(Ref_FileName(_XDocType)).CopyCnt = _CopyCnt,
                     "     ᮮ⢥  㬠 ⥫");
    RESTORE((Ref_FileName(_XDocType)));
    L_General.Assert(~BegXDocIsVerified(_XDocType, _XDocKind, _XDoc, 2),
                     "⢥ত 㦥 믮");
    grt_XDocId:=_XDocId;
    RAISE(, ed_BarCodeDialogNormalExit);
   END;
  END; (* IF ~!_XDocId...*)
 END {vrt_VerifyXDoc};

 PUBLIC PROCEDURE VerifyRequiredTypeXDocIdByBC(SubTitle              : STRING[];
                                               reqXDT                : tXDocType;
                                               wKeyboard             : SCAL[2]);
  VAR
   _XDocType: tXDocType;
   _XDocKind: tXDocKind;
   _XDoc    : tXDoc;
 BEGIN
  grt_XDT                   :=reqXDT;
  LOOP
   SETEMPTY(grt_XDocId);
   DoByBarCode(SubTitle, PROCREF(vrt_VerifyXDoc), wKeyboard);
   IF ~!grt_XDocId THEN
    DecodeXDocId(grt_XDocId, _XDocType, _XDocKind, _XDoc);
    XDocJrn_Mark(_XDocType, _XDocKind, _XDoc, action_VerifyCC);
    L_StdFrm.Inform(Ref_FullName(_XDocType) + " " + _XDoc + " ஢");
    EXIT;
   END;
  END; (* LOOP *)
 END {VerifyRequiredTypeXDocIdByBC};

 PRIVATE PROCEDURE DefineCurrentXDocTypeSoft(): tXDocType;
  VAR
   Result : tXDocType;
   CurFile: STRING[];
 BEGIN
  CurFile:=L_General.GetCurWinMasterTable();
  L_General.Assert(ACCESS((CurFile)), " ⠭ ⥪ ");
  Result :=GetFileXDT(CurFile);
  RETURN Result;
 END {DefineCurrentXDocTypeSoft};

 PUBLIC PROCEDURE DefineCurrentXDocType(): tXDocType;
  VAR
   Result: tXDocType;
 BEGIN
  Result:=DefineCurrentXDocTypeSoft();
  IF !Result THEN
   L_General.Error(" ⥪饣 䠩   㬥⮬");
  ELSE
   RETURN Result;
  END;
 END {DefineCurrentXDocType};

 PRIVATE PROCEDURE IsServiceFile(trgFile: STRING[]): SCAL[2];
 BEGIN
  RETURN (trgFile = "XDocFile") | (trgFile = "XDocFlow") | (trgFile = "XDocJrn") | (trgFile = "erkns") | (trgFile = "XDocApr");
 END {IsServiceFile};

 PUBLIC PROCEDURE GetZoneOfCurrentXDoc(): FORM_ZONE;
 BEGIN
  IF IsServiceFile(RTI.Get().CurZone.MasterTable.Name) THEN
   RETURN RTI.Get().CurWindow.ParentZone;
  ELSE
   RETURN RTI.Get().CurZone;
  END;
 END {GetZoneOfCurrentXDoc};

 PRIVATE PROCEDURE GetCurrentTable(): TABLE;
  VAR
   Result: TABLE;
 BEGIN
  Result:=GetZoneOfCurrentXDoc().MasterTable;
  ACCESS((Result.Name));
  IF Result.Name = "XDFCase" THEN
   Result:=TABLE.Get(Ref_FileName(ExtractXDocType(XDFCase.XDocId)));
   PositionOnXDoc(XDFCase.XDocId);
  END;
  RETURN Result;
 END {GetCurrentTable};

 PUBLIC PROCEDURE GetCurrentXDocId(): tXDocId;
  VAR
   trgTable: TABLE;
   Result  : tXDocId;
 BEGIN
  trgTable:=GetCurrentTable();
  Result:=curXDocIdSoft(GetFileXDT(trgTable.Name));
  IF !Result THEN
   L_StdFrm.BlueStop("騩 ꥪ   㬥⮬");
  ELSE
   RETURN Result;
  END;
 END {GetCurrentXDocId};

 PUBLIC PROCEDURE GetCurrent_iri(): L_General.tInternalRecordId;
  VAR
   trgTable: TABLE;
   LName   : STRING[];
   RecId   : L_General.tRecordId;
   Result  : L_General.tInternalRecordId;
 BEGIN
  trgTable:=GetCurrentTable();
  IF !trgTable.Fields("RECORDID") THEN
   L_StdFrm.BlueStop(" ⥪饣 䠩   ⢨  ঠ");
  END;
  RETURN L_General.iri_GetCurrent(trgTable.Name);
 END {GetCurrent_iri};

 PRIVATE PROCEDURE intGet_iri_Name(trg_fi: L_General.tFileId; trg_ri: L_General.tRecordId; wDescription: SCAL[2]): STRING[];
  VAR
   trgTable: TABLE;
   Result  : STRING[];
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   trgTable:=DATABASE.Get().TableById(trg_fi);
   SEARCH((trgTable.Name), RECORDID, , trg_ri);
   Result:=L_DBD.RecordToStr(trgTable);
   IF wDescription THEN
    Result:=trgTable.Description+": " + Result;
   END;
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {intGet_iri_Name};

 PUBLIC PROCEDURE Get_iri_Description(trg_fi: L_General.tFileId; trg_ri: L_General.tRecordId): STRING[];
 BEGIN
  RETURN intGet_iri_Name(trg_fi, trg_ri, 1);
 END {Get_iri_Description};

 PUBLIC PROCEDURE Get_iri_Name(trg_fi: L_General.tFileId; trg_ri: L_General.tRecordId): STRING[];
 BEGIN
  RETURN intGet_iri_Name(trg_fi, trg_ri, 0);
 END {Get_iri_Name};

 PUBLIC PROCEDURE LaunchViewingServiceFile(trgFile: STRING[]);
  VAR
   curFile        : STRING[];
   Window2LoadName: STRING[];
   Window2Load    : FORM_WINDOW;
   ParentZone     : FORM_ZONE;
 BEGIN
  curFile:=L_General.GetCurWinMasterTable();
  IF curFile # trgFile THEN
   IF IsServiceFile(curFile) THEN
    ParentZone:=RTI.Get().CurZone.Window.ParentZone;
   ELSE
    ParentZone:=RTI.Get().CurZone;
   END;
   curFile:=ParentZone.MasterTable.Name;
   ACCESS((curFile));
   IF    trgFile = "XDocFile" THEN Window2LoadName:="XDocFile";
   ELSIF trgFile = "XDocJrn"  THEN Window2LoadName:="XDocJrn";
   ELSIF trgFile = "XDocFlow" THEN Window2LoadName:="XDF";
   ELSIF trgFile = "erkns"    THEN Window2LoadName:="erkns";
   ELSIF trgFile = "XDocApr"  THEN Window2LoadName:="XDocApr";
   END;
   Window2Load:=APP.Get().Forms.Load(Window2LoadName,
                                     Window2LoadName + "<xyz" + ParentZone.Window.AssignedName + ">",
                                     ParentZone);
   LIKEMENU(View, Window2Load.Name + " 1 " + ParentZone.Window.Name + " " + L_Str.IntStr(ParentZone.Number));
  END; (* IF curFile # trgFile *)
 END {LaunchViewingServiceFile};

 PUBLIC PROCEDURE GetCurrentXDocIdSoft(): tXDocId;
 BEGIN
  RETURN curXDocIdSoft(DefineCurrentXDocTypeSoft());
 END {GetCurrentXDocIdSoft};

 PUBLIC PROCEDURE GetXDocCopiesStoreFolder(): STRING[];
 BEGIN
  RETURN FIO.FullPath("DOCCOPIES");
 END {GetXDocCopiesStoreFolder};

 PUBLIC PROCEDURE PositionInVideoSystem(trgPositionMethod: tPositionMethod;
                                        trgXDocId        : tXDocId;
                                        trgActionAfter   : STRING[]);
  VAR
   curDocType    : tXDocType;
   curDocKind    : tXDocKind;
   curDoc        : tXDoc;
   dN, kN,
   XDocKind_AsStr,
   curActionAfter: STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  DecodeXDocId(trgXDocId, curDocType, curDocKind, curDoc);
  dN:=Ref_FileName(curDocType);
  IF ~!curDoc THEN
   PositionOnXDoc(trgXDocId);
  ELSE
   IF    dN = "Dspt" THEN
    SETSEL(Dspt, Dspt, curDocKind); LAST(Dspt);
    IF ~OCCURE((dN)) THEN
     L_StdFrm.BlueHalt(" 믮 ⮩ 樨  ᯨ᪥  |" +
                       "   " + L_Str.PoolItem("室饥|室饥", curDocKind) + " ࠢ");
    END;
   ELSIF dN = "AMO"  THEN
    SETSEL(AMO, AMO, curDocKind); LAST(AMO);
    IF ~OCCURE((dN)) THEN
     L_StdFrm.BlueHalt(" 믮 ⮩ 樨  ᯨ᪥  |" +
                       "    " + L_Str.PoolItem("ࠡ⭨|஭ ", curDocKind));
    END;
   ELSE
    XDocKind_AsStr:=Ref_ShortName(curDocType);
    IF XDocTypeHasXDocKind(curDocType) THEN
(*樮஢  kN    맮 L_WDO.StandOnDefaultPosition*)
     kN:=Ref_KindName(curDocType);
     SEARCH((kN), (kN), , curDocKind);
     INC(XDocKind_AsStr, "  " + curDocKind);
    END;

    L_WDO.StandOnDefaultPosition(dN);

    IF ~OCCURE((dN)) THEN
     L_StdFrm.BlueHalt(" 믮 ⮩ 樨  ᯨ᪥  |" +
                       "   " + XDocKind_AsStr);
    END;
   END;
  END;

  IF    trgPositionMethod = pm_StandOnly THEN
   SETEMPTY(curActionAfter);
   IF ~!trgActionAfter THEN
    IF Str.Pos(trgActionAfter, ".") = Str.Length(trgActionAfter) THEN
     curActionAfter:='RunProg, "' + trgActionAfter + '"';
    ELSE
     curActionAfter:='CALL, "' + trgActionAfter + '"';
    END;
   END;
   L_WDO.PosToCurRecord(dN, curActionAfter, 0);
  ELSIF trgPositionMethod = pm_WaitUserChoice THEN
   (* !!!  DUMMY  a*.WDO *)
   pvs_ActionAfter:=trgActionAfter;
   L_WDO.intPosToCurRecord(dN, "<UserChoice>", 'SC, "XDoc.AskXDoc"', 1);
  ELSIF trgPositionMethod = pm_GoToEdit THEN
   curActionAfter:='Edit, "@ FixAltering=True"';
   IF ~!trgActionAfter THEN
    curActionAfter:=curActionAfter+', CALL, "'+trgActionAfter+'"';
   END;
   L_WDO.PosToCurRecord(dN, curActionAfter, 0);
  ELSE
   L_General.CallUs(0);
  END;
 END {PositionInVideoSystem};

 PUBLIC PROCEDURE GetSysDTS(): tDoneDTS;
  VAR
   DTSTime: TIME;
   DTSSec : FLOAT;
   _DTS   : tDoneDTS;
 BEGIN
  DTSTime:=SYSTIME(DTSSec);
  PackVARIANTDATE(_DTS, SYSDATE(), DTSTime, DTSSec);
  RETURN _DTS;
 END {GetSysDTS};

 PUBLIC PROCEDURE tst_Check(curXDocId   : tXDocId;
                            statusOk,
                            doneOk      : SCAL[2]);
 BEGIN
  IF ~statusOk THEN
   L_General.Error(extXDocStr(curXDocId, xdast_wDate) +
                   "||" +
                   "㬥  ⨬ ");
  END;
  IF ~doneOk THEN
   L_General.Error(extXDocStr(curXDocId, xdast_wDate) +
                   "||" +
                   "㬥   ࠡ⠭");
  END;
 END {tst_Check};

 PUBLIC PROCEDURE xdmb_GetAccessPoint(xdc: tXDocClass): LIKE(AcsPnt.AcsPnt);
  VAR
   Result: LIKE(AcsPnt.AcsPnt);
 BEGIN
  IF xdc = xdcls_RWayS THEN
   Result:=0000053;
  ELSE
   Result:=0000034;
  END;
  RETURN Result;
 END {xdmb_GetAccessPoint};

 PUBLIC PROCEDURE xdmb_PassAccessPoint(trgAcsPnt: LIKE(AcsPnt.AcsPnt); Msg: STRING[]);
 BEGIN
  L_AcsPnt.PassAccessPoint_wExplanation(trgAcsPnt, Msg);
 END {xdmb_PassAccessPoint};

 PUBLIC PROCEDURE xdmb_CheckABan(xdc: tXDocClass; D: DATE);
  VAR
   pB,
   pE : DATE[txdclsAmount];
   Msg: STRING[];
 BEGIN
  IF ~TransactionMustBeRollback THEN
   TRY
    P_OwnData.xdmb_Get(pB, pE);
    L_General.RaiseLockReleaseException();
   EXCEPT
   ON Exc: Exc_Root DO
    L_General.CheckIsLockReleaseException(Exc);
   END; (* TRY *)
   IF ~!pB[xdc] & ~!pE[xdc] & L_DatTim.IsActive_Inc(D, pB[xdc], pE[xdc]) THEN
    Msg:="  䨪樨 ࢨ 㬥⮢." +
         "||" +
         "ਮ :  " + L_DatTim.DateStr(pB[xdc]) + "  " + L_DatTim.DateStr(pE[xdc]) +
         "||" +
         "( 㬥⮢: " + Str.Small(L_Str.PoolItem(xdcls_Pool, xdc), 0, 1) + ")";
    IF xdmb_CryCount = 0 THEN
     xdmb_PassAccessPoint(xdmb_GetAccessPoint(xdc), Msg);
     INC(xdmb_CryCount);
    END;
   END;
   IF (xdc = xdcls_InternalMDoc) | (xdc = xdcls_VATRelated) THEN
    xdmb_CheckABan(xdcls_AllPmnt, D);
   END;
  END;
 END {xdmb_CheckABan};

 PRIVATE PROCEDURE Create_Ent();
 BEGIN
  CreateFILE(EntAm, "", "", "");

  CreateFIELD(EntAm, AcsObj,   LIKE(AcsObj.AcsObj), "", "", "", "", "");
  CreateFIELD(EntAm, Entry,    NUMERIC[0], "", "", "", "", "");

  CreateINDEXandLINK(EntAm, AcsObj, UNIQUE, AcsObj, AcsObj, USER, "", "", AcsObj);
  CreateINDEX       (EntAm, Entry,  PLURAL,                       "", "", Entry);

  SetVersionOfFILE(EntAm, 01); L_AFM.AF_CreateTemp("EntAm", "EntAm");

  CreateFILE(EntAmDoc, "", "", "");

  CreateFIELD(EntAmDoc, AcsObj,   LIKE(AcsObj.AcsObj), "", "", "", "", "");
  CreateFIELD(EntAmDoc, XDocKind, LIKE(XDocJrn.XDocKind), "", "", "", "", "");
  CreateFIELD(EntAmDoc, XDoc,     LIKE(XDocJrn.XDoc), "", "", "", "", "");

  CreateINDEX(EntAmDoc, XDoc,  UNIQUE, "", "", AcsObj, XDocKind, XDoc);

  SetVersionOfFILE(EntAmDoc, 01); L_AFM.AF_CreateTemp("EntAmDoc", "EntAmDoc");
 END {Create_MS_DL};

 PUBLIC PROCEDURE XDocJrnInSession(BDate, EDate: DATE; BTime, ETime: TIME): SCAL[2];
 BEGIN
  RETURN ((XDocJrn.Date > BDate) | (XDocJrn.Date = BDate) & (XDocJrn.BegTime >= BTime)) &
         ((XDocJrn.Date < EDate) | (XDocJrn.Date = EDate) & (XDocJrn.BegTime <= ETime));
 END {XDocJrnInSession};

 PUBLIC PROCEDURE ChooseAcsObj(xdt      : LIKE(XDocJrn.XDocType);
                               BDate,
                               EDate    : DATE;
                               BTime,
                               ETime    : TIME;
                               IsNeedDoc: PROC): LIKE(AcsObj.AcsObj);
  VAR
   LoginList,
   AcsObjList: STRING[];
   TotalEntry: NUMERIC[0];
   LoginAlign,
   UNameAlign: NUMERIC[0];
   Result    : LIKE(AcsObj.AcsObj);
   oPrompt   : PROMPT_LINE;
 BEGIN
  Create_Ent();
  oPrompt:=PROMPT_LINE.Create("⮢");
  SETZERO(TotalEntry, LoginAlign, UNameAlign);
  SELECT(XDocJrn, UserIdx, , xdt);
  WHILE OCCURE(XDocJrn) DO
   PROMPT(XDocJrn.XDoc);
   NARROWSEL(XDocJrn, AcsObj);
   IF ~!XDocJrn.AcsObj & SRCINSEL(XDocJrn, GE, BDate, BTime) THEN
    WHILE OCCURE(XDocJrn) & XDocJrnInSession(BDate, EDate, BTime, ETime) DO
     PROMPT(XDocJrn.XDoc);
     IF ~SEARCH(EntAmDoc, XDoc, XDocJrn.AcsObj, XDocJrn.XDocKind, XDocJrn.XDoc) &
        (!IsNeedDoc | IsNeedDoc()) THEN
      EntAmDoc.AcsObj  :=XDocJrn.AcsObj;
      EntAmDoc.XDocKind:=XDocJrn.XDocKind;
      EntAmDoc.XDoc    :=XDocJrn.XDoc;
      INSERT(EntAmDoc);
      ADD(EntAm, AcsObj, , XDocJrn.AcsObj, EntAm.Entry, 1);
      INC(TotalEntry);
      CONFORM(XDocJrn, AcsObj);
      IF Str.Length(AcsObj.Name) > LoginAlign THEN
       LoginAlign:=Str.Length(AcsObj.Name);
      END;
      IF Str.Length(L_AR.GetAcsObjManName()) > UNameAlign THEN
       UNameAlign:=Str.Length(L_AR.GetAcsObjManName());
      END;
     END;
     NEXT(XDocJrn);
    END; (* WHILE OCCURE(XDocJrn) ... *)
   END;
   NEXTINEXTENDEDSEL(XDocJrn, AcsObj);
  END; (* WHILE OCCURE(XDocJrn) ... *)
  SETEMPTY(LoginList, AcsObjList);
  SELECT(EntAm, AcsObj);
  WHILE OCCURE(EntAm) DO
   PROMPT(EntAm.AcsObj);
   CONFORM(EntAm, AcsObj);
   LoginList:=LoginList + Str.Align(AcsObj.NAME,             LoginAlign, LEFT) + " " +
                          Str.Align(L_AR.GetAcsObjManName(), UNameAlign, LEFT) +
                          ": 㬥⮢ " + L_Str.IntStr(EntAm.Entry) + "|";
   AcsObjList:=AcsObjList + AcsObj.AcsObj + "|";
   NEXT(EntAm);
  END; (* WHILE OCCURE(EntAm) ... *)
  SETEMPTY(oPrompt);
  Result:=L_Str.PoolItem(AcsObjList, L_StdFrm.ShowListAsMenu(LoginList, " ᪫"));
  L_AFM.AF_PurgeTemp("EntAm");
  L_AFM.AF_PurgeTemp("EntAmDoc");
  L_General.Assert(~!Result, " ᪫ - ᯨ᮪ ");
  RETURN Result;
 END {ChooseAcsObj};

 PUBLIC PROCEDURE GetDocKindDescription(_XDocType: tXDocType; Type: tXDocAsStr): STRING[];
 BEGIN
  IF Type = xdast_External THEN
   IF    _XDocType = xdt_PDoc THEN
    CONFORM(PDoc, PDocKind);
    RETURN PDocKind.SName;
   ELSIF _XDocType = xdt_MDoc THEN
    CONFORM(MDoc, MDocKind);
    RETURN MDocKind.ExtSName;
   ELSIF _XDocType = xdt_ODoc THEN
    CONFORM(ODoc, ODocKind);
    RETURN ODocKind.SName;
   ELSIF _XDocType = xdt_JDoc THEN
    CONFORM(JDoc, JDocKind);
    RETURN JDocKind.Name;
   ELSIF _XDocType = xdt_PLDoc THEN
    CONFORM(PLDoc, PLDKind);
    RETURN PLDKind.Name;
   END;
  ELSE
   IF    _XDocType = xdt_PDoc THEN
    RETURN L_PDoc.PDocKindNick(PDoc.PDocKind, 1);
   ELSIF _XDocType = xdt_MDoc THEN
    RETURN L_MDoc.MDocKindNick(MDoc.MDocKind, 1);
   ELSIF _XDocType = xdt_ODoc THEN
    CONFORM(ODoc, ODocKind);
    RETURN ODocKind.Sign;
   ELSIF _XDocType = xdt_JDoc THEN
    RETURN L_JDoc.JDocKindNick(JDoc.JDocKind);
   ELSIF _XDocType = xdt_PLDoc THEN
    CONFORM(PLDoc, PLDKind);
    RETURN PLDKind.Sign;
   END;
  END;
  L_General.CallUs(~XDocTypeHasXDocKind(_XDocType));
  RETURN "";
 END {GetDocKindDescription};

 PUBLIC PROCEDURE DateFieldName(FName: STRING[]): STRING[];
 BEGIN
  IF    FName = "SprtCrsp" THEN
   RETURN "PrpDate";
  ELSIF FName = "RprS" THEN
   RETURN "OrdDate";
  ELSIF FName = "EDOrder" THEN
   RETURN "PrpDate";
  ELSIF FName = "Dfrls" THEN
   RETURN "BegDate";
  ELSIF FName = "AvePay" THEN
   RETURN "StartD";
  ELSIF FName = "PCalc" THEN
   RETURN "Period";
  ELSIF FName = "ACalc" THEN
   RETURN "Period";
  ELSIF ~!TABLE.Get(FName).Fields("Date") THEN
   RETURN "Date";
  ELSE
   RETURN "";
  END;
 END {DateFieldName};

 PUBLIC PROCEDURE GetXDocDate(trgXDocId: tXDocId): DATE;
  VAR
   Result: DATE;
   curRefFileName,
   curDateFieldName: STRING[];
 BEGIN
  SETEMPTY(Result);
  curRefFileName:=Ref_FileName(ExtractXDocType(trgXDocId));
  curDateFieldName:=DateFieldName(curRefFileName);
  IF ~!curDateFieldName THEN
   TRY [ABORT_AFTER(AA_ON)]
    L_General.CallUs(StandOnXDoc(trgXDocId));
    Result:=^(L_DBD.GetFieldName(curRefFileName, curDateFieldName));
   EXCEPT
   END; (* TRY *)
  END; (* IF ~!curDateFieldName ... *)
  RETURN Result;
 END {GetXDocDate};

 PRIVATE PROCEDURE GetBegDate(FName: STRING[]): STRING[];
  VAR
   dfn: STRING[];
 BEGIN
  dfn:=DateFieldName(FName);
  IF ~!dfn THEN
   RETURN "  " + L_DatTim.DateStr(^(L_DBD.GetFieldName(FName, dfn)));
  ELSE
   RETURN "";
  END;
 END {GetBegDate};

 PRIVATE PROCEDURE BuildXDocDescription(_XDocType: tXDocType; Type: tXDocAsStr): STRING[];
  VAR
   Result: STRING[];
   FName : STRING[];
 BEGIN
  IF _XDocType = xdt_ACalc THEN
   TRY [ABORT_AFTER(AA_ON)]
    FName:=DATABASE.Get().TableById(ACalc.fiOwn).Name;
    SEARCH((FName), RECORDID, , ACalc.riOwn);
    _XDocType:=GetFileXDT(FName);
    IF ~!_XDocType THEN
     Result:=BuildXDocDescription(_XDocType, Type);
     Result:=FLDTOSTR(ACalc.Period, "N.y") + " " + L_Str.PoolItem(ref_ShortNames, _XDocType) + ":" + Result;
    ELSIF FName = "mfBnkAcn" THEN
     Result:=FLDTOSTR(ACalc.Period, "N.y") + " :" + mfBnkAcn.FirmAcnt;
    ELSE
     L_General.CallUs(0);
    END;
    RETURN Result;
   EXCEPT
   END; (* TRY *)
  END;
  SETEMPTY(Result);
  Result:=GetDocKindDescription(_XDocType, Type);
  IF ~!Result THEN
   Result:=Result+" ";
  END;
  FName:=Ref_FileName(_XDocType);
  IF (Type = xdast_wSrcNbr) & ~!TABLE.Get(FName).Fields("SrcNbr") &
     (FName # "ODoc") &
     (FName # "Contract") &
     (FName # "FlRec") THEN
   Result:=Result + FLDTOSTR(^FName.SrcNbr, "", 12);
  ELSIF (Type = xdast_External) & ~!TABLE.Get(FName).Fields("SrcNbr") THEN
   Result:=Result + ^FName.SrcNbr;
  ELSE
   IF    (FName = "Car") THEN
    Result:=Result + Car.BoxNbr;
   ELSIF (FName = "Staff") THEN
    Result:=Result + Staff.TSN;
   ELSIF (FName = "PCalc") THEN
    Result:=Result + PCalc.TSN + "_" + FLDTOSTR(PCalc.Period, "N.y");
   ELSE
    Result:=Result + FLDTOSTR(^FName.^FName, "L", 7);
   END;
   IF    FName = "TckRcC" THEN
    Result:=Result + " " + Str.Align("(" + L_Str.PoolItem(L_TRS.trct_Pool, ^FName.Type) + ")", 17, LEFT);
   ELSIF FName = "TckRcD" THEN
    Result:=Result + " " + Str.Align("(" + L_Str.PoolItem(L_TRS.trdt_Pool, ^FName.Type) + ")", 17, LEFT);
   END;
  END;
  IF (Type = xdast_External) & ~!TABLE.Get(FName).Fields("SrcDate") THEN
   IF ~!^FName.SrcDate THEN
    Result:=Result + "  " + L_DatTim.DateStr(^FName.SrcDate);
   ELSE
    Result:=Result + GetBegDate(FName);
   END;
  ELSIF (Type = xdast_wDate) | (Type = xdast_wStatus) | (Type = xdast_External) THEN
   Result:=Result + GetBegDate(FName);
  END;
  RETURN Result;
 END {BuildXDocDescription};

 PRIVATE PROCEDURE intXDocStr(basXDocId, trgXDocId: STRING[]; Type: tXDocAsStr): STRING[];
  VAR
   trgXDocType,
   basXDocType: tXDocType;
   trgXDocKind,
   basXDocKind: tXDocKind;
   trgXDoc,
   basXDoc    : tXDoc;
   FName      : STRING[];
   Stat_Pool  : STRING[];
   asPDocTotal: LIKE(PDoc.Total);
   Result     : STRING[];
 BEGIN
  Result:="";
  DecodeXDocId(trgXDocId, trgXDocType, trgXDocKind, trgXDoc);
  FName:=Ref_FileName(trgXDocType);
  SAVE((FName));
  IF StandOnXDoc(trgXDocId) THEN
   IF (trgXDocType # xdt_DsptPck) &
      (trgXDocType # xdt_Dispatch) &
      (trgXDocType # xdt_CUCopy) &
      (trgXDocType # xdt_EDOrder) THEN
    Result:=BuildXDocDescription(trgXDocType, Type);
   END;

   IF    trgXDocType = xdt_RWayS THEN
    Result:=Result + " " + RWayS.TSN + " " + RWayS.BoxNbr + " " + RWayS.Exit + " " + RWayS.Status;
   ELSIF trgXDocType = xdt_RprS THEN
    IF Type = xdast_wStatus THEN
     Result:=Result + " " + L_Str.PoolItem(L_Rpr.GetRprSStatus_Pool(1), RprS.Status);
    END;
   ELSIF trgXDocType = xdt_PDoc THEN
    IF Type = xdast_wStatus THEN
     IF ~!basXDocId & (ExtractXDocType(basXDocId) = xdt_MDoc) THEN
      DecodeXDocId(basXDocId, basXDocType, basXDocKind, basXDoc);
      asPDocTotal:=0;
      SAVE(PDocMDoc);
      SELECT(PDocMDoc, PDoc, , PDoc.PDocKind, PDoc.PDoc, basXDocKind, basXDoc);
      WHILE OCCURE(PDocMDoc) DO
       INC(asPDocTotal, PDocMDoc.Total);
       NEXT(PDocMDoc);
      END; (* WHILE OCCURE(PDocMDoc) ... *)
      RESTORE(PDocMDoc);
     ELSE
      asPDocTotal:=PDoc.Total;
     END;
     Result:=Result + " " + FLDTOSTR(asPDocTotal, "2-", 14) +
                   L_Str.PoolItem(" |!", asPDocTotal # PDoc.Total) +
                   L_Str.PoolItem("||", PDoc.Status) +
            " " + "( " + Str.Align(PDoc.SrcNbr, 12, LEFT) + ")";
    ELSIF Type = xdast_wSrcNbr THEN
     Result:=Result + GetBegDate(FName) + " ("+FLDTOSTR(PDoc.PDoc, "", 7)+")";
    END;
   ELSIF (trgXDocType = xdt_MDoc) & SEARCH(MDoc, MDoc, trgXDocKind, trgXDoc) THEN
    IF Type = xdast_wStatus THEN
     Result:=Result + " " + FLDTOSTR(MDoc.Total, "2-", 14) +
            " " + L_Str.PoolItem("||", MDoc.Status) +
            " " + "( " + Str.Align(MDoc.SrcNbr, 12, LEFT) + ")";
    ELSIF Type = xdast_wSrcNbr THEN
     Result:=Result + GetBegDate(FName) + " (" + MDoc.MDoc + ")";
    END;
   ELSIF trgXDocType = xdt_TckRcS THEN
    Result:=Result + " " + TckRcS.TSN + " (" + Str.Small(L_Str.PoolItem(L_Way.trs_Pool, TckRcS.AsWho)) + ")";
    IF Type = xdast_wStatus THEN
     Result:=Result + " " + TckRcS.Status;
    END;
   ELSIF trgXDocType = xdt_Dispatch THEN
    IF Type = xdast_wStatus THEN
     Result:=L_Str.PoolItem("|", Dspt.Type) + " " + Dspt.Dspt +
             "  " + L_DatTim.DateStr(Dspt.Date) + " " +  L_Str.PoolItem(L_Dspt.st_Pool, Dspt.Status);
    END;
   ELSIF trgXDocType = xdt_CWOrder  THEN
    IF Type = xdast_wStatus THEN
     Result:=Result + " " + L_Str.PoolItem("||", CWOrder.Status);
    END;
   ELSIF trgXDocType = xdt_ODoc     THEN
    IF (Type = xdast_wStatus) & ~!ODoc.Status THEN
     Result:=Result + " " + L_Str.PoolItem("||", ODoc.Status) +
            " " + "( " + Str.Align(ODoc.SrcNbr, 12, LEFT) + ")";
    END;
   ELSIF trgXDocType = xdt_DsptPck  THEN
    Result:="";
   ELSIF trgXDocType = xdt_CUCopy   THEN
    Result:=CUCopy.CUCopy + " " + CUCopy.Serial;
   ELSIF trgXDocType = xdt_SprtCrsp THEN
    IF Type = xdast_wStatus THEN
     Result:=Result + " " + SprtCrsp.Status;
    END;
   ELSIF trgXDocType = xdt_TckRcD   THEN
    IF trgXDocType = xdt_TckRcS THEN
     Stat_Pool:="|||";
    ELSE
     Stat_Pool:="||";
    END;
    IF Type = xdast_wStatus THEN
     Result:=Result + " " + L_Str.PoolItem(Stat_Pool, ^FName.Status);
    END;
   ELSIF trgXDocType = xdt_TckRcC   THEN
    IF trgXDocType = xdt_TckRcS THEN
     Stat_Pool:="|||";
    ELSE
     Stat_Pool:="||";
    END;
    IF Type = xdast_wStatus THEN
     Result:=Result + " " + L_Str.PoolItem(Stat_Pool, ^FName.Status);
    END;
   ELSIF trgXDocType = xdt_CarAD    THEN
    IF Type = xdast_wStatus THEN
     Result:=Result + " " + L_Str.PoolItem("||", CarAD.Status);
    END;
   ELSIF trgXDocType = xdt_JDoc THEN
    IF Type = xdast_wStatus THEN
     Result:=Result + " " + L_Str.PoolItem("||", JDoc.Status) +
            " " + "( " + Str.Align(JDoc.SrcNbr, 12, LEFT) + ")";
    ELSIF Type = xdast_wSrcNbr THEN
     Result:=Result + GetBegDate(FName) + " ("+FLDTOSTR(JDoc.JDoc, "", 7)+")";
    END;
   ELSIF trgXDocType = xdt_EDOrder THEN
    IF Type = xdast_wStatus THEN
     CONFORM(EDOrder, EDOGrp);
     Result:=EDOrder.EDOrder + " (" + EDOGrp.Name + ")  " + L_DatTim.DateStr(EDOrder.PrpDate) + " " +
             L_Str.PoolItem(" |||", EDOrder.State);
    END;
   END;
  END;
  IF (Type = xdast_wStatus) THEN
   IF (FName # "ODoc") & ~!TABLE.Get(FName).Fields("Name") THEN
    Result:=Result+" "+^FName.Name;
   END;
   IF FName = "Car" THEN
    CONFORM(Car, Mark);
    Result:=Result+" "+Str.Align(Car.StateNbr, Str.MaxLength(Car.StateNbr), LEFT)+" "+Mark.Mark+" "+Mark.Name;
   END;
  END;
  RESTORE((FName));
  IF ~!Result & (Type # xdast_External) THEN
   Result:=L_Str.PoolItem(ref_ShortNames, ExtractXDocType(trgXDocId)) + ":" + Result;
  END;
  RETURN Result;
 END {intXDocStr};

 PUBLIC PROCEDURE XDocId2iri(trgXDocId: tXDocId): L_General.tInternalRecordId;
  VAR
   Result: L_General.tInternalRecordId;
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   PositionOnXDoc(trgXDocId);
   Result:=L_General.iri_GetCurrent(Ref_FileName(ExtractXDocType(trgXDocId)));
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {XDocId2iri};

 PUBLIC PROCEDURE iri2XDocId(trg_iri: L_General.tInternalRecordId): tXDocId;
  VAR
   trgTable: TABLE;
   Result  : tXDocId;
 BEGIN
  trgTable:=DATABASE.Get().TableById(L_General.iri_fi(trg_iri));
  TRY [RESTORE_CURSORS(RC_ON)]
   SEARCH((trgTable.Name), RECORDID, , L_General.iri_ri(trg_iri));
   Result:=curXDocId(GetFileXDT(trgTable.Name));
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {iri2XDocId};

 PUBLIC PROCEDURE xdf_TypeMustBeUnique(ft: tXDFKind): SCAL[2];
 BEGIN
  RETURN 0;
 END {xdf_TypeMustBeUnique};

 PUBLIC PROCEDURE xdf_StandOnActualBy_iri(iri: L_General.tInternalRecordId; xdfk: tXDFKind): SCAL[2];
 BEGIN
  SELECT(XDocFile, iriKind, , L_General.iri_fi(iri), L_General.iri_ri(iri), xdfk);
  WHILE OCCURE(XDocFile) DO
   IF (XDocFile.Status # xdfSt_Canceled) THEN
    RETURN 1;
   END;
   NEXT(XDocFile);
  END; (* WHILE OCCURE(XDocFile) ... *)
  RETURN 0;
 END {xdf_StandOnActualBy_iri};

 PUBLIC PROCEDURE xdf_StandOnActual(trgXDocId: tXDocId; xdfk: tXDFKind): SCAL[2];
 BEGIN
  RETURN xdf_StandOnActualBy_iri(XDocId2iri(trgXDocId), xdfk);
 END {xdf_StandOnActual};

 PUBLIC PROCEDURE xdf_Cancel();
 BEGIN
  XDocFile.Status:=xdfSt_Canceled;
  REPLACE(XDocFile);
  Jrn_Mark(curXDocId(xdt_XDocFile), action_AutoEdit);
 END {xdf_Cancel};

 PUBLIC PROCEDURE xdf_CancelActualBy_iri(iri: L_General.tInternalRecordId; xdfk: tXDFKind);
 BEGIN
  IF xdf_StandOnActualBy_iri(iri, xdfk) THEN
   xdf_Cancel();
  END;
 END {xdf_CancelActualBy_iri};

 PUBLIC PROCEDURE GetCurXDocFileStoreFolder(): STRING[];
  VAR
   kiloXDocFile: LIKE(XDocFile.XDocFile);
 BEGIN
  L_General.CallUs(ACCESS(XDocFile));
  kiloXDocFile:=XDocFile.XDocFile - XDocFile.XDocFile MOD 1000;
  RETURN FIO.FullPath(FIO.BuildPath(kiloXDocFile, , "DOCCOPIES"));
 END {GetCurXDocFileStoreFolder};

 PRIVATE PROCEDURE xdf_GetLinkFileExt(): STRING[];
 BEGIN
  CONFORM(XDocFile, XDFKind);
  IF XDFKind.SrcType = xdft_SourceLink THEN RETURN "url";
  ELSE                                      RETURN L_FIO.effp_FileExt(XDocFile.Name);
  END;
 END {xdf_GetLinkFileExt};

 PUBLIC PROCEDURE xdf_GetFullFileName(): STRING[];
 BEGIN
  RETURN FIO.BuildPath(XDocFile.XDocFile, xdf_GetLinkFileExt(), GetCurXDocFileStoreFolder());
 END {xdf_GetFullFileName};

 PUBLIC PROCEDURE xdf_GetSourceFileFullName(): STRING[];
  VAR
   S: STRING[];
 BEGIN
  CONFORM(XDocFile, XDFKind);
  IF XDFKind.SrcType = xdft_SourceLink THEN
   FIO.Open(grff, xdf_GetFullFileName(), "", Input);
   FIO.SetCP(grff, FIO.CP_WindowsRussian);
   IF FIO.RdStr(grff, S) & FIO.RdStr(grff, S) & Str.Match(S, "URL=file://*") THEN
    FIO.Close(grff);
    RETURN Str.Replace(Str.Slice(S, Str.Pos(S, "//"), Str.Length(S)), "/", "\");
   ELSE
    L_General.Error("ন 䠩 " + xdf_GetFullFileName() + "  ᮮ⢥ ⠭ ଠ");
   END;
  ELSE
   RETURN xdf_GetFullFileName();
  END;
 END {xdf_GetSourceFileFullName};

 PUBLIC PROCEDURE xdf_CreateSourceFile(srcFullFN, dstFullFN: STRING[]): STRING[];
  VAR
   trgExt: STRING[];
 BEGIN
  srcFullFN:=FIO.UNCPath(srcFullFN);
  IF ~L_FIO.IsFullUNCPath(srcFullFN) THEN
   L_General.Error("   ࠧ饭  ⥢ ");
  END;
  FIO.SplitPath(dstFullFN, dstFullFN, trgExt);
  INC(dstFullFN, "." + xdf_GetLinkFileExt());
  FIO.Open(AF2XD, dstFullFN, "", Create);
  FIO.SetCP(AF2XD, FIO.CP_WindowsRussian);
  FIO.WrStr(AF2XD, "[InternetShortcut]" +
                   L_Str.CRLF +
                   "URL=file:" + Str.Replace(srcFullFN, "\", "/") +
                   L_Str.CRLF);
  FIO.Close(AF2XD);
  RETURN srcFullFN;
 END {xdf_CreateSourceFile};

 PUBLIC PROCEDURE AttachFile2iri(trg_iri    : L_General.tInternalRecordId;
                                 trgXDFKind : tXDFKind;
                                 srcFullFN  : STRING[];
                                 trgName    : STRING[];
                                 trgFileOper: tFileOper;
                                 trgStatus  : LIKE(XDocFile.Status);
                                 trgNote    : LIKE(XDocFile.Note));
  VAR
   trgExt,
   dstFullFN,
   StoreFolder: STRING[];
   TryCnt     : NUMERIC[0];
 BEGIN
  IF SEARCH((DATABASE.Get().TableById(L_General.iri_fi(trg_iri)).Name), RECORDID, L_General.iri_ri(trg_iri)) THEN
   IF !trgName THEN
    trgName:=L_FIO.effp_FileName(srcFullFN);
   END;
   trgExt:=L_FIO.effp_FileExt(trgName);
   L_General.Assert(~L_Str.IsEqStrI(trgExt, "LNK"), " ਪ९   㬥");

   IF Str.Length(trgName) > Str.MaxLength(XDocFile.Name) THEN
    trgName:=Str.Slice(trgName, 0, Str.MaxLength(XDocFile.Name) - Str.Length(trgExt) - 1) + "." + trgExt;
   END;

   DEFAULT(XDocFile);
   SETEMPTY(XDocFile.XDocFile);
   XDocFile.XDFKind :=trgXDFKind;
   XDocFile.fiOwn   :=L_General.iri_fi(trg_iri);
   XDocFile.riOwn   :=L_General.iri_ri(trg_iri);
   XDocFile.Name    :=trgName;
   XDocFile.Status  :=trgStatus;
   XDocFile.Note    :=trgNote;
   SETEMPTY(XDocFile.FileDTS, XDocFile.FileSize);
   INSERT(XDocFile);

   L_FIO.MakeSubDirs(GetCurXDocFileStoreFolder());
   dstFullFN:=xdf_GetFullFileName();

   PROMPT(L_Str.PoolItem("????|஢|७| 몠", trgFileOper) + " " + srcFullFN);
   IF    trgFileOper = FO_Copy THEN
    CONFORM(XDocFile, XDFKind);
    IF XDFKind.SrcType = xdft_SourceLink THEN
     dstFullFN:=xdf_CreateSourceFile(srcFullFN, dstFullFN);
    ELSE
     L_FIO.ExactFileCopy(srcFullFN, dstFullFN);
    END;
   ELSIF trgFileOper = FO_Move THEN
    TryCnt:=0;
    LOOP
     TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
      FIO.RenMov(srcFullFN, , dstFullFN, );
      EXIT;
     EXCEPT
     ON Exc: Exc_Root DO
      INC(TryCnt);
      IF TryCnt = 10 THEN
       RAISE();
      END;
      SLEEP(1.0);
     END; (* TRY *)
    END; (* LOOP *)
   ELSIF trgFileOper = FO_Link THEN
    L_FIO.ExactFileCopy(srcFullFN, dstFullFN);
   ELSE
    L_General.CallUs(0);
   END;
   XDocFile.FileDTS :=FOLDERENTRY.Create(dstFullFN).UTCLastModified;
   XDocFile.FileSize:=FOLDERENTRY.Create(dstFullFN).Size;
   REPLACE(XDocFile);
   Jrn_Mark(curXDocId(xdt_XDocFile), action_Insert);
  END;
 END {AttachFile2iri};

 PUBLIC PROCEDURE CopyLastXDocFileToTempDirForSendEMail(trg_iri: L_General.tInternalRecordId): STRING[];
  VAR
   TempDir: STRING[];
 BEGIN
  SETSEL(XDocFile, iriStam, L_General.iri_fi(trg_iri), L_General.iri_ri(trg_iri));
  LAST(XDocFile);
  TempDir:=L_FIO.tf_GetFullPath(L_FIO.effp_FileName_woExt(XDocFile.Name) + "." +L_FIO.effp_FileExt(XDocFile.Name), "");
  FIO.Erase(TempDir);
  L_FIO.ExactFileCopy(xdf_GetFullFileName(), TempDir);
  RETURN TempDir;
 END {CopyLastXDocFileToTempDirForSendEMail};

 PUBLIC PROCEDURE CheckXDocDateValidity(usrTable, ownTable: TABLE);
  VAR
   usrDate : DATE;
   usrXDT  : tXDocType;
   usrStrId: STRING[];
 BEGIN
  usrDate:=^(usrTable.Fields(DateFieldName(usrTable.Name)).ObtainName());
  IF ~L_DatTim.IsActive(usrDate,
                        ^(ownTable.Fields("Begin").ObtainName()),
                        ^(ownTable.Fields("Till").ObtainName())) THEN
   usrXDT:=GetFileXDT(usrTable.Name);
   IF ~!usrXDT THEN
    usrStrId:=XDocStr(curXDocId(usrXDT));
   ELSE
    usrStrId:=usrTable.Description; (* ??? *)
   END;
   L_General.Error(usrStrId
                   + "||"
                   + "   (" + L_DatTim.DateStr(usrDate) + ")"
                   + "||"
                   + " 'ਮ ਬ'  ⠡ "
                   + "|"
                   + "('" + ownTable.Description + "')");
  END;
 END {CheckXDocDateValidity};

 PUBLIC PROCEDURE IsSystemXDFKind(xdfk: tXDFKind): SCAL[2];
 BEGIN
  RETURN xdfk < xdfk_UserDefined;
 END {IsSystemXDFKind};

 PUBLIC PROCEDURE GetLastMdfTime_TheDay(trgXDocType: tXDocType; D: DATE): TIMESTAMP;
  VAR
   File       : STRING[];
   trgXDocId  : tXDocId;
   trgXDocKind: tXDocKind;
   trgXDoc    : tXDoc;
   trgStamp,
   Result     : TIMESTAMP;
 BEGIN
  File:=Ref_FileName(trgXDocType);
  TRY
   Result:=MINOF(Result);
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   SELECT((File), Date, , D);
   WHILE OCCURE((File)) DO
    trgXDocId:=curXDocId(trgXDocType);
    DecodeXDocId(trgXDocId, trgXDocType, trgXDocKind, trgXDoc);
    SETSEL(XDocJrn, XDocJrn, trgXDocType, trgXDocKind, trgXDoc);
    LAST(XDocJrn);
    trgStamp:=PackTIMESTAMP(XDocJrn.Date, XDocJrn.BegTime, XDocJrn.BegSec);
    IF trgStamp > Result THEN
     Result:=trgStamp;
    END;
    NEXT((File));
   END;
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END; (* TRY *)
  RETURN Result;
 END {GetLastMdfTime_TheDay};

 PUBLIC PROCEDURE GetXDocAuthorTSN(xdt: tXDocType): LIKE(Staff.TSN);
  VAR
   Result     : LIKE(Staff.TSN);
   curXDI     : tXDocId;
   curXDocType: tXDocType;
   curXDocKind: tXDocKind;
   curXDoc    : tXDoc;
 BEGIN
  SETEMPTY(Result);
  curXDI:=curXDocId(xdt);
  TRY
   RTI.Get().TryBlock.AccessDataMode:=adm_FINISHED;
   IF SELECT(XDocFlow, XDocFlow, curXDI) & LAST(XDocFlow) THEN
    WHILE OCCURE(XDocFlow) & (XDocFlow.Action # L_XDF.a_SetAuthor) DO
     PREV(XDocFlow);
    END;
   END;
   IF OCCURE(XDocFlow) THEN
    Result:=XDocFlow.Author;
   ELSE
    DecodeXDocId(curXDI, curXDocType, curXDocKind, curXDoc);
    IF SELECT(XDocJrn, XDocJrn, curXDocType, curXDocKind, curXDoc) THEN
     CONFORM(XDocJrn, AcsObj);
     IF ~!AcsObj.Man THEN
      Result:=L_Staff.Man2TSN(XDocJrn.Date, AcsObj.Man, EMPTYOF(P_Firm.tMyFirm), 0, 0);
     END;
    END;
   END; (* WHILE OCCURE(XDocFlow) ... *)
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
  RETURN Result;
 END {GetXDocAuthorTSN};

 PUBLIC PROCEDURE OnAnyXDocModificationProceedError(Exc: Exc_Root);
 BEGIN
  IF Exc.HasDeferredMsg | Exc.HasSuppressedMsg THEN
   IF L_General.IsAdmin() THEN
    L_StdFrm.Choice(Exc.MsgOriginalText
                    + L_StdFrm.HR()
                    + "㬥 ⠭  ﭨ ' ࠡ⠭'");
   ELSE
    L_General.Error(Exc.MsgOriginalText
                    + L_StdFrm.HR()
                    + "᫨  㢥७  ࠢ쭮 ଫ 㬥,|"
                    + "  "
                    + L_StdFrm.HR()
                    + "(६ 㬥  ࠭  ﭨ '⮢')");
   END;
  ELSE
   RAISE();
  END; (* IF Exc.HasDeferredMsg | Exc.HasSuppressedMsg ... *)
 END {OnAnyXDocModificationProceedError};

 PUBLIC PROCEDURE FixACalc(trgFileName: STRING[]; trgMyFirm: LIKE(MyFirm.MyFirm); trgPeriod: DATE);
 BEGIN
  REP(ACalc, Own, , TABLE.Get(trgFileName).Id, ^(trgFileName).RECORDID, trgMyFirm, trgPeriod,
      ACalc.Done, 0);
 END {FixACalc};

 PUBLIC PROCEDURE CompleteACalc();
  VAR
   trgXDocId: tXDocId;
 BEGIN
  trgXDocId:=curXDocId(xdt_ACalc);
  L_Acnt.RenXDocApr(trgXDocId);
  IF ~SELECT(XDocApr, XDocApr, trgXDocId) THEN
   REMOVE(ACalc);
  ELSE
   ACalc.Done:=1;
   REPLACE(ACalc);
  END;
 END {CompleteACalc};

BEGIN
 xdmb_CryCount            :=0;
 TransactionMustBeRollback:=0;
END.
