(*
%Copyright   (c) Polak IT
%Author      23.05.2003 13:22:05 POLAK\LDA
%Purpose      PDoc  MDoc
%Type        report
%Specific    SYS
%Modified    15.09.2014 20:03:53 POLAK\Bor
%Environment
*)

 MODULE L_XDR [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_XDoc;

 PUBLIC TYPE
  tXDocReportPartition = SCAL[50];
  tXDocRepDo = SCAL[3];

 PUBLIC CONST
  xdr_Complete = 0;
  xdr_XObject  = 1;
  xdr_Total    = 2;

 PUBLIC VAR
  AcMthSLDo: SCAL[2];
  XDocId   : L_XDoc.tXDocId;

 PRIVATE PERMANENT VAR
  IsProtocolMaking: tXDocRepDo;

 PUBLIC CONST
  xdrd_No     = 0;
  xdrd_Yes    = 1;
  xdrd_KeyAss = 2;

(*
$P { xdr_Top:
P_Firm.MyFirmName(MyFirm.MyFirm, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
?, L, ""
@
############################################################################################# ########## #####
==============================================================================================================
|                           ⮪ ࠡ⪨ 㬥 ###########  ##########                           |
|------------------------------------------------------------------------------------------------------------|
|室 : ############################################################################################|
}
*)

(*
$P{ xdr_Owner:
?, L, ""
@
|############################################################################################################|
}
*)

(*
$P{ xdr_MDLTop:
@
|==================================================᮪====================================================|
| |ꥪ                                                  ||       㬬|          |    -||
|----|---------------------------------------------------------|---|------------|-------------|----------|---|
}
*)

(*
$P{ xdr_MDL:
MDocList.MDLNbr, R, ""
?, L, ""
L_MathR.MModeStr(MDocList.MMode), L, ""
MDocList.Sum, R, "2-"
MDocList.VATMode, L, "||"
MDocList.VAT, R, "2-"
MDocList.Qnt, R, "3."
?, L, ""
@
|####|#########################################################|###|############|# ###########|##########|###|
}
*)

(*
$P { xdr_PDTop:
PDoc.Total, R, "2-"
PDoc.NDS, R, "2-"
PDoc.SaleTax, R, "2-"
@
|㬬 ###############    ..  ############    ..  ############                                   |
}
*)

(*
$P { xdr_PDMDTop:
@
|============================================易 㬥=============================================|
|㬥                      | 樨                       |          㬬|         |         |
|------------------------------|-----------------------------------|---------------|------------|------------|
}
*)

(*
$P{ xdr_PDMD:
L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc), L, ""
MDoc.Dest, L, ""
Dest.Name, L, ""
PDocMDoc.Total, R, "2-"
PDocMDoc.NDS, R, "2-"
PDocMDoc.SaleTax, R, "2-"
@
|##############################|### ###############################|###############|############|############|
}
*)

(*
$P{ xdr_CirTop:
@
|================================================஢====================================================|
|ꥪ         |        |।       |ꥪ         |          㬬|  ⢮|||||||
}
*)

(*
$P{ xdr_Spr:
XDE01.Prt, L, "᪨--|ꥪ⭮-----|᪨--"
@
|###############|-------------|-------------|---------------|---------------|------------|-|-|---|---|---|---|
}
*)

(*
$P{ xdr_CirLine:
?, L, ""
?, L, ""
?, L, "?|| "
?, L, ""
?, L, "?|| "
?, L, ""
?, R, "2-"
XDE01.Qnt, R, "3."
?, L, " |"
?, L, " |"
?, L, ""
?, L, ""
?, L , ""
?, L , ""
@
|###############|########### #|########### #|###############|###############|############|#|#|###|###|###|###|
}
*)

(*
$P{ xdr_XObjectTop:
@
|==============================================ꥪ =================================================|
|ꥪ         |ந宦                                                                     |      |
|---------------|----------------------------------------------------------------------------------|---------|
}
*)

(*
$P{ xdr_XObjectLine:
XObjectCode(XObject.XObject, CurDate()), L, ""
L_XObj.GetXObjectOriginName(), L, ""
XObject.XObject, L, ""
@
|###############|##################################################################################|#########|
}
*)

(*
$P{ xdr_AcCutTop:
@
|=================================================१====================================================|
|१                                                          |                                       |
|----------------------------------------------------------------|-------------------------------------------|
}
*)

(*
$P{ xdr_AcCutLine:
AcCut.AcCut, L ,""
ACLog.Sign,  L, ""
AcCut.Name,  L, ""
CAcnt.Sign,  L, ""
CAcnt.Name,  L, ""
@
|### ########### ################################################|##### #####################################|
}
*)

(*
$P{ xdr_AcMthTop:
@
|=============================================奬 権=================================================|
|㯯                       |                                  |                        ||  |
|-----------------------------|-------------------------------------|------------------------------|---|-----|
}
*)

(*
$P{ xdr_AcMthLine:
AcMth.DGroup, L, ""
DGroup.Name, L, ""
AcMth.Dest, L, ""
Dest.Name, L, ""
?, L, ""
?, L, ""
?, L, ""
AcMth.AcMth, L, ""
@
|## ##########################|### #################################|## ###########################|###|#####|
}
*)

(*
$P{ xdr_Bot:
@
=(c) Polak====================================================================================================
}
*)

 PUBLIC PROCEDURE InitEntryList();
 BEGIN
  IF !DATABASE.Get().Tables("XDE01") THEN
   CREATE_TABLE(XDE01, , "஢ 㬥");
   CREATE_FIELD(XDE01, XDocId,   L_XDoc.tXDocId,        , , , "㬥");
   CREATE_FIELD(XDE01, Prt,      tXDocReportPartition,  , , , "");
   CREATE_FIELD(XDE01, XObject,  LIKE(XObject.XObject), , , , "X ꥪ");
   CREATE_FIELD(XDE01, AcCut,    LIKE(AcCut.AcCut),     , , , "१");
   CREATE_FIELD(XDE01, Apport,   LIKE(Apport.Apport),   , , , "ᯮ");
   CREATE_FIELD(XDE01, wAmount,  SCAL[2],               , , , "஢ ⢮  XObject");
   CREATE_FIELD(XDE01, XObject2, LIKE(XObject.XObject), , , , "X ꥪ2");
   CREATE_FIELD(XDE01, AcCut2,   LIKE(AcCut2.AcCut2),   , , , "१2");
   CREATE_FIELD(XDE01, Apport2,  LIKE(Apport.Apport),   , , , "ᯮ2");
   CREATE_FIELD(XDE01, wAmount2, SCAL[2],               , , , "஢ ⢮  XObject2");
   CREATE_FIELD(XDE01, Sum,      L_XObj.tSum,           , , , ", 㬬");
   CREATE_FIELD(XDE01, Qnt,      L_XObj.tQnt,           , , , ", ⢮");
 
   CREATE_INDEX         (XDE01, XDE01,   UNIQUE,                          , , XDocId, Prt, XObject, AcCut, Apport, wAmount, XObject2, AcCut2, Apport2, wAmount2);
   CREATE_INDEX_AND_LINK(XDE01, XObject, PLURAL, XObject, XObject,  USER, , , XObject);
   CREATE_INDEX_AND_LINK(XDE01, AcCut,   PLURAL, AcCut,   AcCut,    USER, , , AcCut, Apport, AcCut2);
   CREATE_INDEX_AND_LINK(XDE01, Apport,  PLURAL, Apport,  Apport,   USER, , , Apport);
   CREATE_INDEX_AND_LINK(XDE01, AcCut2,  PLURAL, AcCut2,  AcCut2,   USER, , , AcCut2);
   CREATE_INDEX_AND_LINK(XDE01, Apport2, PLURAL, Apport2, Apport2,  USER, , , Apport2);
   CREATE_INDEX         (XDE01, xAcCut,  PLURAL,                          , , XDocId, AcCut, Apport, AcCut2);
   CREATE_INDEX         (XDE01, xAcCut2, PLURAL,                          , , XDocId, AcCut2);
 
   SET_VERSION_OF_TABLE(XDE01, 001);
  END;
  L_AFM.CreateTemp("XDE01");
  SETEMPTY(XDocId);
 END {InitEntryList};

 PRIVATE PROCEDURE MakeOwnerPart(OwnerTitle, User, Owner: STRING[]);
  VAR
  OwnerName: STRING[];
 BEGIN
  IF ~!^User.^Owner THEN
   IF Owner = "TSN" THEN
    CONFORM(^User, Staff);
    CONFORM(Staff, Man);
    OwnerName:=Man.Name;
   ELSIF Owner = "BoxNbr" THEN
    CONFORM(^User, Car);
    L_Car.StandOnCarLog(Car.BoxNbr, ^User.Date);
    CONFORM(CarLog, Mark);
    OwnerName:=CarLog.StateNbr+" "+Mark.Mark+" "+Mark.Name;
   ELSE
    CONFORM(^User, ^Owner);
    OwnerName:=^Owner.Name;
    IF (Owner = "Storage") | (Owner = "Storage2") THEN
     OwnerName:=L_Str.PoolItem(L_Stock.st_Pool_SH, ^Owner.Type)+" "+OwnerName;
    END;
   END;
   MAKEPART(R, xdr_Owner, OwnerTitle+": "+^User.^Owner+" "+OwnerName);
  END;
 END {MakeOwnerPart};

 PUBLIC PROCEDURE XDocRepDo(): tXDocRepDo;
 BEGIN
  RETURN IsProtocolMaking;
 END {XDocRepDo};

 PRIVATE PROCEDURE CurDate(): DATE;
 BEGIN
  RETURN Memo.gl_mb();
 END {CurDate};

 PRIVATE PROCEDURE IsInvertTransaction(_Apport, _Apport2: LIKE(Apport.Apport)): SCAL[2];
 BEGIN
  IF    ~!_Apport THEN
   SEARCH(Apport, Apport, , _Apport);
   RETURN (Apport.CirType = L_Acnt.ct_Credit);
  ELSIF ~!_Apport2 THEN
   SEARCH(Apport, Apport, , _Apport2);
   RETURN (Apport.CirType = L_Acnt.ct_Debit);
  ELSE
   L_General.CallUs(0);
  END;
 END {IsInvertTransaction};

 PUBLIC PROCEDURE AddToEntryList(_XObject : LIKE(XObject.XObject);
                                 _AcCut   : LIKE(AcCut.AcCut);
                                 _Apport  : LIKE(Apport.Apport);
                                 wAmount  : SCAL[2];
                                 _XObject2: LIKE(XObject.XObject);
                                 _AcCut2  : LIKE(AcCut2.AcCut2);
                                 _Apport2 : LIKE(Apport.Apport);
                                 wAmount2 : SCAL[2];
                                 curSum   : L_XObj.tSum;
                                 curQnt   : L_XObj.tQnt);
  VAR
   rspSum   : L_XObj.tSum;
   rspQnt   : L_XObj.tQnt;
 BEGIN
  L_General.CallUs(IsProtocolMaking # xdrd_No);
  IF (~!_XObject | ~!_XObject2) &
     ((curSum # 0) | (curQnt # 0)) THEN
   IF ~!_XObject THEN
    rspSum:=curSum;
    IF ~wAmount THEN
     rspQnt:=curQnt;
    ELSE
     rspQnt:=0;
    END;
    ADD(XDE01, XDE01, , XDocId, xdr_XObject,
                        _XObject,  _AcCut,  _Apport, wAmount,
                        "", _AcCut2, "", "",
                        XDE01.Sum, rspSum,
                        XDE01.Qnt, rspQnt);
   END;
   IF ~!_XObject2 THEN
    rspSum:=curSum;
    IF ~wAmount2 THEN
     rspQnt:=curQnt;
    ELSE
     rspQnt:=0;
    END;
    ADD(XDE01, XDE01, , XDocId, xdr_XObject,
                        _XObject2, _AcCut2, _Apport2, wAmount2,
                        "", _AcCut, "", "",
                        XDE01.Sum, rspSum,
                        XDE01.Qnt, rspQnt);
   END;
   IF ~IsInvertTransaction(_Apport, _Apport2) THEN
    ADD(XDE01, XDE01, , XDocId, xdr_Complete,
                        _XObject,  _AcCut,  _Apport,  wAmount,
                        _XObject2, _AcCut2, _Apport2, wAmount2,
                        XDE01.Sum, curSum,
                        XDE01.Qnt, curQnt);
    ADD(XDE01, XDE01, , XDocId, xdr_Total,
                        "",  _AcCut,  _Apport,  "",
                        "", _AcCut2, _Apport2, "",
                        XDE01.Sum, curSum);
   ELSE
    ADD(XDE01, XDE01, , XDocId, xdr_Complete,
                        _XObject2, _AcCut2, _Apport2, wAmount2,
                        _XObject,  _AcCut,  _Apport,  wAmount,
                        XDE01.Sum, curSum,
                        XDE01.Qnt, curQnt);
    ADD(XDE01, XDE01, , XDocId, xdr_Total,
                        "", _AcCut2, _Apport2, "",
                        "",  _AcCut,  _Apport,  "",
                        XDE01.Sum, curSum);
   END;
  END;
 END {AddToEntryList};

 PRIVATE PROCEDURE pel_CallSinglePDoc();
 BEGIN
  CALL(PDoc.InternalMakeProtocol());
 END {pel_CallSinglePDoc};

 PRIVATE PROCEDURE pel_CallSingleMath();
 BEGIN
  CALL(MCM.Math_Recount());
 END {pel_CallSingleMath};

 PUBLIC PROCEDURE PrepareEntryList(_XDocType: L_XDoc.tXDocType; D: DATE; AddToExistXDE: SCAL[2]);
  VAR
   P: DATE;
 BEGIN
  TRY [ABORT_AFTER(AA_ON)]
   IF ~AddToExistXDE & SELECT(XDE01, XDE01) THEN
    REMSEL(XDE01);
   END;
   IsProtocolMaking:=xdrd_Yes;
   IF    _XDocType = L_XDoc.xdt_PDoc THEN
    L_PDoc.AccessPDoc();
    L_General.RidgeExecute("PDoc", PROCREF(pel_CallSinglePDoc), L_General.rem_Discard);
   ELSIF _XDocType = L_XDoc.xdt_MDoc THEN
    L_MDoc.AccessMDoc();
    IF L_MDoc.KeyAssetsMDoc(MDoc.MDocKind) THEN
     IF L_Env.KeyAssAcntLev(MDoc.Date) = L_MathR.kaal_WithActProcess THEN
      P:=L_DatTim.Per(MDoc.Date);
      SAVE(MDoc);
      SELECT(MDocList, MDLMath, , MDoc.MDocKind, MDoc.MDoc);
      WHILE OCCURE(MDocList) DO
       NARROWSEL(MDocList, Math);
       SAVE(MDocList);
       CONFORM(MDocList, Math);
       Memo.gl_SetCurDate(P-1);
       IsProtocolMaking:=xdrd_No;
       TRY [TRANSACTION(TRANSACTION_SLAVE), MSGSUPPRESSIONMODE(MSGSUPPRESS_NONE)]
        CALL(MCM.Math_CountUp());
       EXCEPT
       END;
       RESTORE(MDocList);
       SAVE(MDocList);
       Memo.gl_SetCurDate(P);
       IsProtocolMaking:=xdrd_KeyAss;
       CALL(MCM.Math_Recount());      (*  祭 ஢*)
       RESTORE(MDocList);
       NEXTINEXTENDEDSEL(MDocList, Math);
      END; (* WHILE OCCURE(MDocList ... *)
      RESTORE(MDoc);
     END;
    ELSE
     CALL(MDoc.InternalMakeProtocol());
    END;
   ELSIF _XDocType = L_XDoc.xdt_JDoc THEN
    CALL(JDoc.InternalMakeProtocol());
   ELSIF _XDocType = L_XDoc.xdt_Math THEN
    Memo.gl_SetCurDate(D);
    IF    Math.MathKind = L_MathR.mathk_KeyAs THEN
     IsProtocolMaking:=xdrd_KeyAss;
    ELSE
     L_General.CallUs(0);
    END;
    L_General.RidgeExecute("Math", PROCREF(pel_CallSingleMath), L_General.rem_Discard);
   ELSE
    L_General.CallUs(0);
   END;
  EXCEPT
  FINALLY
   IsProtocolMaking:=xdrd_No;
  END;
 END {PrepareEntryList};

 PUBLIC PROCEDURE XDocAprToEntryList(_XDocType: L_XDoc.tXDocType);
 BEGIN
  L_General.CallUs(IsProtocolMaking # xdrd_No);
  XDocId:=L_XDoc.curXDocId(_XDocType);
  SETSEL(XDocApr, XDocApr, XDocId);
  FOR_EACH XDocApr DO
   AddToEntryList(XDocApr.XObject,  XDocApr.AcCut,  XDocApr.Apport,  XDocApr.wQnt MOD 2,
                  XDocApr.XObject2, XDocApr.AcCut2, XDocApr.Apport2, XDocApr.wQnt DIV 2,
                  XDocApr.Sum, XDocApr.Qnt);
  END; (* FOR_EACH XDocApr *)
  SETEMPTY(XDocId);
 END {XDocAprToEntryList};

 PUBLIC PROCEDURE DeInitEntryList();
 BEGIN
  L_AFM.AF_PurgeTemp("XDE01");
  IsProtocolMaking:=xdrd_No;
 END {DeInitEntryList};

 PRIVATE PROCEDURE XObjectCode(_XObject: LIKE(XObject.XObject); D: DATE): STRING[];
 BEGIN
  IF !_XObject THEN
   RETURN "";
  END;
  L_XObj.AccessXObject(_XObject);
  IF XObject.Origin = L_XObj.o_Global THEN
   RETURN ""+XObject.XObject;
  ELSE
   IF L_XObj.SoftAccessOrigin() THEN
    IF    XObject.Origin = L_XObj.o_Man THEN
     RETURN ""+FLDTOSTR(mfMan.Man, "", 5);
    ELSIF XObject.Origin = L_XObj.o_Contract THEN
     RETURN ""+Contract.Contract;
    ELSIF XObject.Origin = L_XObj.o_CostItem THEN
     RETURN ""+CostItem.CostItem;
    ELSIF XObject.Origin = L_XObj.o_KeyAss THEN
     RETURN ""+mItem.Math;
    ELSIF XObject.Origin = L_XObj.o_Math THEN
     CONFORM(mItem, Storage);
     IF Storage.Type = L_Stock.st_AdvHolder THEN
      SELECT(Staff, Storage, , mItem.Storage);
      RETURN ""+mItem.Math+" "+Staff.TSN;
     ELSE
      RETURN ""+mItem.Math+" "+mItem.Storage;
     END;
    END;
   END;
  END;
  RETURN "-"+XObject.XObject;
 END {XObjectCode};

 PRIVATE PROCEDURE DoAcnt(P: DATE; _XObject: LIKE(XObject.XObject); _AcCut: LIKE(AcCut.AcCut); _Apport: LIKE(Apport.Apport)): L_XObj.tDoAcnt;
 BEGIN
  IF ~!_XObject THEN
   RETURN L_XObj.GetAcCutDoAcnt(P, _XObject, _AcCut, _Apport);
  ELSE
   RETURN L_XObj.acda_Yes;
  END;
 END {DoAcnt};

 PRIVATE PROCEDURE PrintLine(VAR newPrt: SCAL[2]);
  VAR
   as_Obj,
   as_Obj2,
   as_AcCut,
   as_AcCut2: STRING[];
   _Sum: L_XObj.tSum;
 BEGIN
  IF (XDE01.Sum # 0) | (XDE01.Qnt # 0) THEN
   IF XDE01.Sum # 0 THEN
    _Sum:=XDE01.Sum;
   ELSE
    SETEMPTY(_Sum);
   END;
   IF newPrt THEN
    newPrt:=0;
    MAKEPART(R, xdr_Spr);
   END;
   IF ~IsInvertTransaction(XDE01.Apport, XDE01.Apport2) THEN
    MAKEPART(R, xdr_CirLine, XObjectCode(XDE01.XObject, CurDate()),
                             L_Acnt.GetAcCutSign(CurDate(), XDE01.AcCut),
                             DoAcnt(CurDate(), XDE01.XObject, XDE01.AcCut, XDE01.Apport),
                             L_Acnt.GetAcCutSign(CurDate(), XDE01.AcCut2),
                             DoAcnt(CurDate(), XDE01.XObject2, XDE01.AcCut2, XDE01.Apport2),
                             XObjectCode(XDE01.XObject2, CurDate()),
                             _Sum,
                             XDE01.wAmount,
                             XDE01.wAmount2,
                             XDE01.AcCut,
                             XDE01.AcCut2,
                             XDE01.Apport,
                             XDE01.Apport2);
   ELSE
    MAKEPART(R, xdr_CirLine, XObjectCode(XDE01.XObject2, CurDate()),
                             L_Acnt.GetAcCutSign(CurDate(), XDE01.AcCut2),
                             DoAcnt(CurDate(), XDE01.XObject2, XDE01.AcCut2, XDE01.Apport2),
                             L_Acnt.GetAcCutSign(CurDate(), XDE01.AcCut),
                             DoAcnt(CurDate(), XDE01.XObject, XDE01.AcCut, XDE01.Apport),
                             XObjectCode(XDE01.XObject, CurDate()),
                             _Sum,
                             XDE01.wAmount2,
                             XDE01.wAmount,
                             XDE01.AcCut2,
                             XDE01.AcCut,
                             XDE01.Apport2,
                             XDE01.Apport);
   END;
  END;
 END {PrintLine};

 PRIVATE PROCEDURE PrintXObjects(_XDocId: L_XDoc.tXDocId);
 BEGIN
  IF SELECT(XDE01, XDE01, _XDocId, xdr_XObject) THEN
   MAKEPART(R, xdr_XObjectTop);
   WHILE OCCURE(XDE01) DO
    NARROWSEL(XDE01, XObject);
    CONFORM(XDE01, XObject);
    MAKEPART(R, xdr_XObjectLine);
    NEXTINEXTENDEDSEL(XDE01, XObject);
   END; (* WHILE OCCURE(XDE01) ... *)
  END;
 END {PrintXObjects};

 PRIVATE PROCEDURE MakeAcCtIdx(_XDocId: L_XDoc.tXDocId; Sfx: STRING[]);
 BEGIN
  SELECT(XDE01, ^("xAcCut"+Sfx), , _XDocId);
  WHILE OCCURE(XDE01) DO
   NARROWSEL(XDE01, ^("AcCut"+Sfx));
   ADD(_AcCt, _AcCt, , XDE01.^("AcCut"+Sfx));
   NEXTINEXTENDEDSEL(XDE01, ^("AcCut"+Sfx));
  END; (* WHILE OCCURE(XDE01) ... *)
 END {MakeAcCtIdx};

 PRIVATE PROCEDURE PrintAcCuts(_Date: DATE; _XDocId: L_XDoc.tXDocId);
 BEGIN
  IF SELECT(XDE01, xAcCut, _XDocId) THEN
   MAKEPART(R, xdr_AcCutTop);
   L_AFM.MakeIndex("_AcCt", "AcCut: LIKE(AcCut.AcCut)");
   MakeAcCtIdx(_XDocId, "");
   MakeAcCtIdx(_XDocId, "2");
   SETSEL(_AcCt, _AcCt);
   FOR_EACH _AcCt DO
    L_AcCut.PositionOnAcCut(_AcCt.AcCut);
    HISTCONF(_Date, AcCut, ACLog);
    CONFORM(ACLog, CAcnt);
    MAKEPART(R, xdr_AcCutLine);
   END; (* FOR_EACH _AcCt *)
   L_AFM.AF_PurgeTemp("_AcCt");
  END;
 END {PrintAcCuts};

 PRIVATE PROCEDURE PrintAcMth();
  VAR
   i   : NUMERIC[0];
   Id  : STRING[];
 BEGIN
  IF ~!sl_Ids THEN
   MAKEPART(R, xdr_AcMthTop);
   i:=0;
   LOOP
    Id:=L_Str.PoolItem(sl_Ids, i);
    IF !Id THEN
     EXIT;
    END;
    SEARCH(AcMth, AcMth, , Str.Item(Id, ",", 0));
    CONFORM(AcMth, DGroup);
    CONFORM(AcMth, Dest);
    IF ~!Str.Item(Id, ",", 1) THEN
     SEARCH(MathType, MathType, , Str.Item(Id, ",", 1));
     SEARCH(MMode,    MMode,    , Str.Item(Id, ",", 2));
     MAKEPART(R, xdr_AcMthLine, MathType.MathType, MathType.Name, MMode.MMode);
    ELSE
     MAKEPART(R, xdr_AcMthLine);
    END;
    INC(i);
   END; (* LOOP *)
  END;
 END {PrintAcMth};

 PRIVATE PROCEDURE _Assert(Cond: SCAL[2]);
 BEGIN
  L_General.Assert(Cond,
                   " ⮪  ⮫쪮  㬥⮢|" +
                   " ᮬ '஢'");
 END {_Assert};

 PUBLIC PROCEDURE OutEntryList(_XDocType: L_XDoc.tXDocType);
  VAR
   newPrt  : SCAL[2];
   RepName : STRING[];
   _DocDate: DATE;
   _XDocId : L_XDoc.tXDocId;
   _DestName: LIKE(Dest.Name);
 BEGIN
  IF    _XDocType = L_XDoc.xdt_MDoc THEN
   RepName:="MDocR";
   _Assert(MDoc.Status = L_MDoc.st_Passed);
   _XDocId:=L_XDoc.curXDocId(L_XDoc.xdt_MDoc);
  ELSIF _XDocType = L_XDoc.xdt_PDoc THEN
   RepName:="PDocR";
   _Assert(PDoc.Status = L_PDoc.st_Passed);
   _XDocId:=L_XDoc.curXDocId(L_XDoc.xdt_PDoc);
  ELSIF _XDocType = L_XDoc.xdt_JDoc THEN
   RepName:="JDocR";
   _Assert(JDoc.Status = L_JDoc.st_Passed);
   _XDocId:=L_XDoc.curXDocId(L_XDoc.xdt_JDoc);
  ELSE
   L_General.CallUs(0);
  END;

  OPENREP(R, L_General.NameConnection(RepName), Create);
  IF _XDocType = L_XDoc.xdt_MDoc THEN
   _DocDate:=MDoc.Date;
   CONFORM(MDoc, MyFirm);
   CONFORM(MDoc, Staff, Man);
   CONFORM(MDoc, MDocKind);
   MAKEPART(R, xdr_Top, L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc), MDoc.Date, MDoc.SrcNbr);
   MakeOwnerPart(" 樨", "MDoc", "Dest");
   MakeOwnerPart("१ ", "MDoc", "TSN");
   MakeOwnerPart("", "MDoc", "Contract");
   MakeOwnerPart("", "MDoc", "Math");
   MakeOwnerPart("", "MDoc", "CostItem");
   MakeOwnerPart("", "MDoc", "BoxNbr");
   MakeOwnerPart(" ", "MDoc", "Storage");
   MakeOwnerPart("2", "MDoc", "Storage2");

   MAKEPART(R, xdr_MDLTop);
   SETSEL(MDocList, MDoc, MDoc.MDocKind, MDoc.MDoc);
   FOR_EACH MDocList DO
    IF ~!MDocList.Math THEN
     CONFORM(MDocList, Math);
     MAKEPART(R, xdr_MDL, Math.Math+" "+Math.Name, L_MathR.DefaultMUnitSign(MDocList.Math));
    ELSIF ~!MDocList.CostItem THEN
     CONFORM(MDocList, CostItem);
     MAKEPART(R, xdr_MDL, CostItem.CostItem+" "+CostItem.Name, "");
    ELSE
     L_General.CallUs(0)
    END;
   END; (* FOR_EACH MDocList *)
  ELSIF _XDocType = L_XDoc.xdt_PDoc THEN
   _DocDate:=PDoc.Date;
   CONFORM(PDoc, MyFirm);
   CONFORM(PDoc, PDocKind);
   CONFORM(PDoc, Dest);
   MAKEPART(R, xdr_Top, L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc), PDoc.Date, PDoc.SrcNbr);
   MakeOwnerPart(" 樨", "PDoc", "Dest");
   MakeOwnerPart("ࠣ", "PDoc", "Firm");
   IF SELECT(PDocMDoc, PDoc, PDoc.PDocKind, PDoc.PDoc) THEN
    MAKEPART(R, xdr_PDMDTop);
    FOR_EACH PDocMDoc DO
     CONFORM(PDocMDoc, MDoc);
     CONFORM(MDoc, Dest);
     MAKEPART(R, xdr_PDMD);
    END; (* FOR_EACH PDocMDoc *)
   END;
  ELSE
   _DocDate:=JDoc.Date;
   CONFORM(JDoc, MyFirm);
   CONFORM(JDoc, JDocKind);
   MAKEPART(R, xdr_Top, L_JDoc.JDocStr(JDoc.JDocKind, JDoc.JDoc), JDoc.Date, JDoc.SrcNbr);
   MAKEPART(R, xdr_Owner, "ਬ砭: " + L_lsStore.Get(JDoc.Comment));

   _XDocId:=L_JDoc.GetJDocOnBehalfOfXDocId();
  END; (* IF _XDocType ...*)

  IF SELECT(XDE01, XDE01, _XDocId) THEN
   MAKEPART(R, xdr_CirTop);
   WHILE OCCURE(XDE01) DO
    NARROWSEL(XDE01, Prt);
    IF XDE01.Prt # xdr_XObject THEN (*0068657 17.02.2009 14:08:43 POLAK\Bor*)
     newPrt:=1;
     WHILE OCCURE(XDE01) DO
      NARROWSEL(XDE01, XObject);
      FOR_EACH XDE01 DO
       PrintLine(newPrt);
      END; (* FOR_EACH XDE01 *)
      NEXTINEXTENDEDSEL(XDE01, XObject);
     END; (* OCCURE(XDE01) ... *)
    END;
    NEXTINEXTENDEDSEL(XDE01, Prt);
   END; (* OCCURE(XDE01) ... *)
  END;

  PrintXObjects(_XDocId);
  PrintAcCuts(_DocDate, _XDocId);
  PrintAcMth();

  MAKEPART(R, xdr_Bot);
  CLOSEREP(R);
 END {OutEntryList};

 PRIVATE PERMANENT VAR
  sl_Title,
  sl_Ids,
  sl_List  : STRING[];
  sl_Cur   : NUMERIC[0];
 PUBLIC PERMANENT VAR
  pvs_AcMth: LIKE(AcMth.AcMth);

 PUBLIC PROCEDURE sl_Init(Title: STRING[]);
 BEGIN
  L_General.CallUs(~AcMthSLDo);
  AcMthSLDo:=1;
  sl_Title:=Title;
  SETEMPTY(sl_Ids, sl_List);
  sl_Cur:=0;
 END {sl_Init};

 PUBLIC PROCEDURE sl_AddItem(Id: STRING[]; Item: STRING[]);
 BEGIN
  L_General.CallUs(AcMthSLDo);
  IF !L_Str.PositionInPool(sl_Ids, Id) THEN
   sl_Ids :=sl_Ids + Id + "|";
   sl_List:=sl_List  + Item   + "|";
  END;
 END {sl_AddItem};

 PUBLIC PROCEDURE sl_Done();
 BEGIN
  L_General.CallUs(AcMthSLDo);
  AcMthSLDo:=0;
  LIKEMENU(Survey, "", CALL, "XDoc.SetReportWNavigationSurveyWindowTitle()", SC, "AcMth.S_wList");
 END {sl_Done};

 PUBLIC PROCEDURE sl_Show();
 BEGIN
  sl_Cur   :=L_StdFrm.ShowListAsMenu_wInit(sl_List, sl_Title, sl_Cur);
  pvs_AcMth:=Str.Item(L_Str.PoolItem(sl_Ids, sl_Cur), ",", 0);
 END {sl_Show};

BEGIN
 AcMthSLDo:=0;
 IsProtocolMaking:=xdrd_No;
 SETEMPTY(XDocId);
END.