(*
%Copyright   (c) Polak Computer System
%Author      17.05.2002 12:35:02 LDA
%Purpose     ᮪ ᨮ஢, c    
%Type        report
%Specific    SYS
%Modified    03.07.2012 20:44:48 POLAK\Gina
%Environment
*)

 IMPORT Memo, L_General, L_OwnData, L_Staff, P_Man, L_AFM, L_Str, L_DatTim;

 CONST
  RepName = "Mn002";

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
?, L, "D.N.y"
@
################################################################################################################### ########## #####
=#####==============================================================================================================================
|                                       ᮪ ᨮ஢, c    ##########                                        |
|----------------------------------------------------------------------------------------------------------------------------------|
|  |  ⢮              | ᨨ |. | -|                      |                         |
|     |                                  |           |     | |                               |                               |
|-----|----------------------------------|-----------|-----|-------|-------------------------------|-------------------------------|
}
*)

(*
$P{ Line:
Tmp.Man, L, ""
Tmp.Name, L, ""
Tmp.Value, L, ""
Tmp.TSN, L, ""
L_Str.PoolItem(L_Staff.cnt_Pool, Staff.Contract), L, ""
Tmp.Post, L, ""
Post.Name, L, ""
Tmp.Sort, L, ""
Sort.Name, L, ""
@
|#####|##################################|###########|#####|#######|### ###########################|### ###########################|
}
*)

(*
$P{ Bot:
?, R, ""
@
|----------------------------------------------------------------------------------------------------------------------------------|
|ᥣ #### 祫                                                                                                                |
=(c) Polak==========================================================================================================================
}
*)

 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CreateFILE(Tmp, "", "", "");

  CreateFIELD(Tmp, Man, LIKE(Man.Man), "", "", "", " ", "");
  CreateFIELD(Tmp, TSN, LIKE(Staff.TSN), "", "", "", ".  ࠡ⭨", "");
  CreateFIELD(Tmp, Name, LIKE(Man.Name), "", "", "", " ", "");
  CreateFIELD(Tmp, Value, LIKE(ManPro.Value), "", "", "", " ᨨ", "");
  CreateFIELD(Tmp, Post, LIKE(Post.Post), "", "", "", "", "");
  CreateFIELD(Tmp, Sort, LIKE(Sort.Sort), "", "", "", "⤥", "");

  CreateINDEXandLINK(Tmp, Post, PLURAL, Post, Post, USER, "", "", Post);
  CreateINDEXandLINK(Tmp, Sort, PLURAL, Sort, Sort, USER, "", "", Sort);
  CreateINDEX(Tmp, Man, PLURAL, "", "", Man);

  SetVersionOfFILE(Tmp, 0);
  L_AFM.AF_CreateTemp("Tmp", "Tmp");
 END {Create_Tmp};

 PRIVATE PROCEDURE Do(trgDate: DATE);
 BEGIN
  SELECT(ManPro, Property, , P_Man.P_Pension);
  WHILE OCCURE(ManPro) DO
   PROMPT(ManPro.Man);
   CONFORM(ManPro, Man);
   SAVE(ManPro);
   IF L_DatTim.IsActive_Inc(trgDate, ManPro.Date, ManPro.EndDate) &
      (ManPro.DocExpD >= trgDate)                                 &
      L_Staff.IsStandOnAnyMainContract(Man.Man, trgDate) & L_Staff.rInState(trgDate) THEN
    HISTCONF(trgDate, Staff, StaffLog);
    CONFORM(StaffLog, Officer, Post);
    CONFORM(Officer, Post);
    Tmp.Man  :=Man.Man;
    Tmp.TSN  :=Staff.TSN;
    Tmp.Name :=Man.Name;
    Tmp.Value:=ManPro.Value;
    Tmp.Post :=Officer.Post;
    Tmp.Sort :=Officer.Sort;
    INSERT(Tmp);
   END;
   RESTORE(ManPro);
   NEXT(ManPro);
  END; (* WHILE OCCURE(ManPro) ... *)
 END {Do};

 PRIVATE PROCEDURE PrintRep(trgDate: DATE);
  VAR
   Amount: NUMERIC[0];
 BEGIN
  Amount:=0;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, trgDate);
  SELECT(Tmp, Man);
  WHILE OCCURE(Tmp) DO
   CONFORM(Tmp, Sort);
   CONFORM(Tmp, Post);
   PROMPT(" "+Tmp.Man);
   INC(Amount);
   L_General.Assert(SEARCH(Staff, TSN, Tmp.TSN), "  ⠡."+Tmp.TSN);
   MAKEPART(R, Line, Amount);
   NEXT(Tmp);
  END; (* WHILE OCCURE(Tmp) ... *)
  MAKEPART(R, Bot, Amount);
 END {PrintRep};

 PUBLIC PROCEDURE Man002();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  Create_Tmp();
  Do(Memo.ud_cd());
  PrintRep(Memo.ud_cd());
  L_AFM.AF_PurgeTemp("Tmp");
 END {Man002};

END.
