(*
%Copyright   (c) Polak Computer System
%Author      20.08.1999 15:06:33 SAN
%Purpose     ஫ ࠢ쭮  ManFml
%Type        control
%Specific    SYS
%Modified    02.10.2013 14:55:28 POLAK\LDA
%Environment
*)

 MODULE ManFml [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Events, L_Man, Math, L_WDO, L_ACL;

 PRIVATE PROCEDURE ManFml_Birth_OnSuccessfulChange();
 BEGIN
  IF !ManFml.BegDate THEN
   CONFORM(ManFml, Man);
   ManFml.BegDate:=Math.Max(ManFml.Birth, Man.Birth);
   REPLACE(ManFml);
  END;
 END {ManFml_Birth_OnSuccessfulChange};

 PRIVATE PROCEDURE ManFmlE_OnInitializeWindow();
 BEGIN
  L_WDO.iScsChange (0, ["ManFml.Birth"]);
  L_WDO.iMayBeEmpty(0, ["ManFml.DocGiveS", "ManFml.DocGiveD", "ManFml.Comment", "ManFml.DocNum", "ManFml.DocSer", "ManFml.Birth", "ManFml.EndDate"]);
  L_WDO.iField     (0, "ManFml.Sex"     ).Format:="|";
  L_WDO.iField     (0, "ManFml.Member"  ).Format:=L_Man.FmlMemberPool;
  L_WDO.iField     (0, "ManFml.Features").Format:=L_Man.fmf_Pool;
 END {ManFmlE_OnInitializeWindow};

BEGIN
 L_Events.ExecuteHandler();
END.
