(*
%Copyright   (c) Polak Computer System
%Author      06.08.1999 15:16:09 GINA
%Purpose      ᪫᪨ 㬥⮢  TM-ਭ
%Type        report,to paste
%Specific    SYS
%Modified    11.03.2012 16:29:08 POLAK\MLB
%Environment
*)

 IMPORT L_CUC, L_General, L_MathR, L_MDoc, L_Str, L_XDoc, P_MDoc, L_Env, P_Man, P_Firm;

 CONST
  DocLength = 23;
  Rep_Depth = 40;

 PROCEDURE GetFirmName(): STRING[];
 BEGIN
  IF OCCURE(Firm) THEN
   RETURN Firm.Firm + " " + Firm.Name;
  ELSE
   RETURN "";
  END;
 END {GetFirmName};

(*
$P {Top_05:
P_Firm.FP_FirmName(P_Firm.fomf(MDoc.MyFirm), SYSDATE()), L, ""
SYSDATE(), L, <D.N.Y>
SYSTIME(), L, <H:M>
L_MDoc.MDocStorage(), L, <>
MDoc.CopyCnt, L, <>
L_MDoc.MDocDirection(), C, <室|室>
MDoc.MDoc, L, <>
MDoc.SrcNbr, L, <>
MDoc.Date, L, <D.N.Y>
MDoc.Total, R, <2->
Dest.Dest, L, <>
Dest.Name, L, <>
L_MDoc.MDocDirection(), C, <⠢騪|⥫>
GetFirmName(), L, ""
@
######################### ######## #####
-#######-----------------------------##-
  ######### थ  . 業⥩
N #######:################   ########
----------------------------------------
 樨        㬬: #############
### ####################################
##########
########################################
}
*)

(*
$P {SubTop_05:
@
--------ਠ 業-----------
}
*)

(*
$P {Line1_05:
Math.Math, L, <>
?, L, <>
?, R, <>
L_MathR.DefaultMUnitSign(Math.Math), L, <>
MDocList.Sum, R, <,2->
Math.Name, L, <>
@
##### ### ########## ### ###############
########################################
}
*)

(*
$P {Line3_05:
Math.Math, L, <>
?, L, <>
?, R, <>
L_MathR.DefaultMUnitSign(Math.Math), L, <>
MDocList.Sum, R, <,2->
MDocList.VATMode, L, L_MDoc.Get_vatm_Pool(0)
MDocList.VAT, R, <,2->
Math.Name, L, <>
@
##### ### ########## ### ###############
#############         ###############
########################################
}
*)

(*
$P {Dlm1_05:
@
----------------------------------------
}
*)

(*
$P {Bot_05:
L_MDoc.MDocDirection(), L, <|稫>
?, R, <>
?, R, <>
@
----------------------------------------
#######   ..............................
########################################
騪 ##############################
-(c) Polak------------------------------
}
*)

(*
$P {Top_06:
P_Firm.FP_FirmName(P_Firm.fomf(MDoc.MyFirm), SYSDATE()), L, ""
SYSDATE(), L, <D.N.Y>
SYSTIME(), L, <H:M>
L_MDoc.MDocStorage(), L, <>
MDoc.CopyCnt, L, <>
L_MDoc.MDoc3Direction(), C, <|.|.>
MDoc.MDoc, L, <>
MDoc.Date, L, <D.N.Y>
Dest.Dest, L, <>
Dest.Name, L, <>
GetFirmName(), L, ""
@
######################### ######## #####
-#######-----------------------------##-
ॡ  ######  #######/########
###  ###################################
########################################
}
*)

(*
$P {SubTop_06:
@
----------------------------------------
}
*)

(*
$P {Line1_06:
Math.Math, L, <>
?, L, <>
?, R, <>
L_MathR.DefaultMUnitSign(Math.Math), R, <>
Math.Name, L, <>
@
##### ###                 ########## ###
########################################
}
*)

(*
$P {Dlm1_06:
@
----------------------------------------
}
*)

(*
$P {Bot_06:
L_MDoc.MDoc3Direction(), L, <稫||>
?, R, <>
Alower.Name, L, <>
Alower.Alower, L, <>
?, R, <>
@
#######   ..............................
########################################
訫  ..............................
################################### (##)
騪 ##############################
-(c) Polak------------------------------
}
*)

(*
$P {Top_07:
P_Firm.FP_FirmName(P_Firm.fomf(MDoc.MyFirm), SYSDATE()), L, ""
SYSDATE(), L, <D.N.Y>
SYSTIME(), L, <H:M>
L_MDoc.MDocStorage(), L, <>
MDoc.CopyCnt, L, <>
L_MDoc.MDocDirection(), L, <|>
MDoc.MDoc, L, <>
Dest.Dest, L, <>
Dest.Name, L, <>
MDoc.Date, L, <D.N.Y>
?, L, <>
Staff.TSN, L, <>
Car.BoxNbr, R, <>
Car.Column, R, <>
@
######################### ######## #####
-#######-----------------------------##-
      #######  #######
  ### ################################
########(#########):##### :####(##)
}
*)

(*
$P {SubTop_07:
@
----------------------------------------
}
*)

(*
$P {Line1_07:
Math.Math, L, <>
?, L, <>
?, R, <>
L_MathR.DefaultMUnitSign(Math.Math), R, <>
Math.Name, L, <>
@
##### ###                 ########## ###
########################################
}
*)

(*
$P {Dlm1_07:
@
----------------------------------------
}
*)

(*
$P {Bot_07:
L_MDoc.MDocDirection(), L, <|稫>
?, L, <>
Alower.Name, L, <>
Alower.Alower, L, <>
?, R, <>
@
######### ..............................
########################################
訫  ..............................
################################### (##)
騪 ##############################
-(c) Polak------------------------------
}
*)

(*
$P {Top_16:
P_Firm.FP_FirmName(P_Firm.fomf(MDoc.MyFirm), SYSDATE()), L, ""
SYSDATE(), L, <D.N.Y>
SYSTIME(), L, <H:M>
MDoc.CopyCnt, L, <>
MDoc.MDoc, L, <>
Dest.Dest, L, <>
Dest.Name, L, <>
MDoc.Date, L, <D.N.Y>
Staff.TSN, L, <>
Car.BoxNbr, R, <>
Car.Column, R, <>
@
######################### ######## #####
-------------------------------------##-
 㬥   ॣ⮢ #######
  ### ################################
########(      ) :##### :#### :##
}
*)

(*
$P {SubTop_16:
@
----------------------------------------
}
*)

(*
$P {Line1_16:
Math.Math, L, <>
?, L, <>
?, R, <>
L_MathR.DefaultMUnitSign(Math.Math), R, <>
Math.Name, L, <>
@
##### ###                 ########## ###
########################################
}
*)

(*
$P {Dlm1_16:
@
----------------------------------------
}
*)

(*
$P {Bot_16:
?, L, <>
Alower.Name, L, <>                      
Alower.Alower, L, <>
?, R, <>
@
믮  ..............................
########################################
訫  ..............................
################################### (##)
  ##############################
-(c) Polak------------------------------
}
*)

(*
$P{ CUCLine:
?, L, <>
?, L, <>
@
####### ################################
}
*)

(*
$P {LblTop:
P_Firm.FP_FirmName(P_Firm.fomf(MDoc.MyFirm), SYSDATE()), L, ""
SYSDATE(), L, <D.N.Y>
SYSTIME(), L, <H:M>
L_MDoc.MDocStorage(), L, <>
L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc), L, ""
MDoc.CopyCnt, L, ""
MDoc.Date, L, "D.N.y"
Car.BoxNbr, R, <>
Car.StateNbr, R, <>
Car.Column, R, <>
@
######################### ######## #####
-#######--------------------------------
   ᢮  
 c᭮ ###########(##)  ##########
:####      : #########      :##
}
*)

(*
$P {LblSubTop:
@
----------------------------------------
}
*)

(*
$P {LblLine:
?, L, <>
?, L, <>
Math.Name, L, <>
@
 ७ .........#######
......################################
(######################################)
}
*)

(*
$P {LblBot:
?, L, <>
?, R, <>
@
稫 ................................
########################################
騪 ##############################
-(c) Polak------------------------------
}
*)

(*
$P{ Fill:
@

}
*)

(*
$P {Top_60:
P_Firm.FP_FirmName(P_Firm.fomf(MDoc.MyFirm), SYSDATE()), L, ""
SYSDATE(), L, <D.N.Y>
SYSTIME(), L, <H:M>
MDoc.CopyCnt, L, <>
MDoc.MDoc, L, <>
MDoc.Date, L, <D.N.Y>
Dest.Type, L, "㤠|㤠"
MDoc.Storage, L, ""
Storage.Name, L, ""
Dest.Type, L, "㤠|㤠"
MDoc.Storage2, L, ""
Storage2.Name, L, ""
Dest.Dest, L, <>
Dest.Name, L, <>
@
######################### ######## #####
-------------------------------------##-
ॡ  ।  #######/########
###### ####### #########################
###### ####### #########################
###  ###################################
}
*)

(*
$P {SubTop_60:
@
----------------------------------------
}
*)

(*
$P {Line1_60:
Math.Math, L, <>
?, L, <>
?, R, <>
L_MathR.DefaultMUnitSign(Math.Math), R, <>
Math.Name, L, <>
@
##### ###                 ########## ###
########################################
}
*)

(*
$P {Dlm1_60:
@
----------------------------------------
}
*)

(*
$P {Bot_60:
L_MDoc.MDoc3Direction(), L, <稫||>
?, R, <>
Alower.Name, L, <>
Alower.Alower, L, <>
?, R, <>
@
#######   ..............................
########################################
訫  ..............................
################################### (##)
騪 ##############################
-(c) Polak------------------------------
}
*)

(*
$P {Top_62:
P_Firm.FP_FirmShortName(P_Firm.fomf(MDoc.MyFirm), SYSDATE()), L, <>
L_MDoc.MDocStorage(), L, <>
MDoc.CopyCnt, L, <>
MDoc.MDoc, L, <>
MDoc.Date, L, <D.N.Y>
Dest.Dest, L, <>
Dest.Name, L, <>
P_Firm.FP_FirmShortName(MDoc.Firm, MDoc.Date), L, ""
MDoc.Contract, L, ""
@
########################################
-#######-----------------------------##-
譥 ६饭  ####### ########
  ### ################################
############################## (#######)
}
*)

(*
$P {SubTop_62:
@
----------------------------------------
}
*)

(*
$P {Line1_62:
Math.Math, L, <>
?, L, <>
?, R, <>
L_MathR.DefaultMUnitSign(Math.Math), R, <>
Math.Name, L, <>
@
##### ###                 ########## ###
########################################
}
*)

(*
$P {Dlm1_62:
@
----------------------------------------
}
*)

(*
$P {Bot_62:
L_MDoc.MDocDirection(), L, <|稫>
P_MDoc.GetMDocProSoft(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Through), R, <>
L_MDoc.MDocDirection(), L, <稫|>
P_Man.GetFullNameOfCurrentUser(MDoc.Date), R, <>
SYSDATE(), L, <D.N.Y>
SYSTIME(), L, <H:M>
@
#######  ...............................
########################################

#######  ...............................
########################################
-(c) Polak---------------######## #####-
}
*)

(*
$P {NoteSingleLine:
?, L, ""
@
########################################
}
*)

 PRIVATE PROCEDURE PrintMDocNote(SubTopPartName: STRING[]);
  VAR
   i     : NUMERIC[0];
   StrArr: STRING[][10];
   Note  : STRING[];
 BEGIN
  Str.Format(StrArr,
             P_MDoc.GetMDocProSoft(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Note),
             Rep_Depth,
             LEFT);
  i:=0;
  WHILE ~!StrArr[i] DO
   MAKEPART(R, NoteSingleLine, StrArr[i]);
   INC(i);
  END; (* WHILE ~!StrArr[i]...*)
  MAKEPART(R, ^(SubTopPartName));
 END {PrintMDocNote};

 PROCEDURE AlignDoc(RepName: STRING[10]; L: NUMERIC[0]);
  VAR i: NUMERIC[0];
 BEGIN
  i:=DocLength - LINENUM(^RepName) - L + 1;
  WHILE i > 0 DO
   MAKEPART(^RepName, Fill);
   DEC(i);
  END;
 END {AlignDoc};

 PROCEDURE MKind(_MDocKind: LIKE(MDoc.MDocKind)): LIKE(MDoc.MDocKind);
 BEGIN
  IF (_MDocKind = L_MDoc.md_VTN) |
     (_MDocKind = L_MDoc.md_ViP) |
     (_MDocKind = L_MDoc.md_FPk) |
     (_MDocKind = L_MDoc.md_RPk) |
     (_MDocKind = L_MDoc.md_TCh) THEN
   RETURN L_MDoc.md_NPr;
  ELSE
   RETURN _MDocKind;
  END;
 END {MKind};

 PROCEDURE GetPartName(Prefix: STRING[25]): STRING[30];
 BEGIN
  RETURN Prefix + "_" + MKind(MDoc.MDocKind);
 END {GetPartName};

 PROCEDURE Open(Preview: SCAL[2]);
 BEGIN
  L_General.Assert((MDoc.MDocKind=L_MDoc.md_NOV) |
                   (MDoc.MDocKind=L_MDoc.md_TOV) |
                   (MDoc.MDocKind=L_MDoc.md_DDA) |
                   (MDoc.MDocKind=L_MDoc.md_NPr) |
                   (MDoc.MDocKind=L_MDoc.md_VTN) |
                   (MDoc.MDocKind=L_MDoc.md_MSP) |
                   (MDoc.MDocKind=L_MDoc.md_ViP) |
                   (MDoc.MDocKind=L_MDoc.md_FPk) |
                   (MDoc.MDocKind=L_MDoc.md_RPk) |
                   (MDoc.MDocKind=L_MDoc.md_VPC) |
                   (MDoc.MDocKind=L_MDoc.md_TCh),
                   " "+L_MDoc.MDocKindNick(MDoc.MDocKind, 1) +
                   "  -ਭ  ন");
  IF Preview THEN
   OPENREP(R, L_General.NameConnection("MDocX"), Create);
  ELSE
   L_General.Assert(!L_Print.GetPrinterName(L_Print.pt_Cheque) (*   প E_Stock.MDocPrinterType*) |
                    (GETDEFAULTPRINTER() = L_Print.GetPrinterName(L_Print.pt_Cheque)),
                    " ਭ  ⠭  㬮砭 (. Alt+F6)");
   OPENREP(R, L_General.NameConnection("MDocX"), Print);
  END;
  SetPrintAttr(R, CharsPerLine,    Rep_Depth,
                  LinesDist,       2.822,
                  FontEnlargement, 1.1,
                  Orientation,     Portrait,
                  PaperForm,       ^(L_Print.Cheque_PaperForm()),
                  TopMargin,       10,
                  BottomMargin,    10,
                  LeftMargin,      6.35,
                  RightMargin,     6.35);
 END {Open};

 PROCEDURE Top();
  VAR
   _RefDoc      : L_XDoc.tXDoc;
   refToXDocId  : L_XDoc.tXDocId;
   dummyXDocType: L_XDoc.tXDocType;
   dummyXDocKind: L_XDoc.tXDocKind;
 BEGIN
  refToXDocId:=L_MDoc.curRefToXDoc_GetId();
  IF ~!refToXDocId THEN
   L_XDoc.DecodeXDocId(refToXDocId, dummyXDocType, dummyXDocKind, _RefDoc);
  ELSE
   SETEMPTY(_RefDoc);
  END;
  CONFORM(MDoc, Dest);
  IF ~!MDoc.Storage THEN
   CONFORM(MDoc, Storage);
  END;
  IF ~!MDoc.Storage2 THEN
   CONFORM(MDoc, Storage2);
  END;
  CONFORM(MDoc, Dest);
  MAKEPART(R, ^(GetPartName("Top")), _RefDoc);
  PrintMDocNote(GetPartName("SubTop"));
 END {Top};

 PROCEDURE Line();
  VAR
   PartName: STRING[];
 BEGIN
  IF MDocList.VAT # 0 THEN
   PartName:=GetPartName("Line3");
  ELSE
   PartName:=GetPartName("Line1");
  END;
  MAKEPART(R, ^PartName, L_MathR.MModeStr(MDocList.MMode), L_MathR.DefaultFormatCir(Math.Math, MDocList.Qnt));
 END {Line};

 PROCEDURE Answer(Len: NUMERIC[0]): STRING[];
 BEGIN
  IF L_Env.RealTSN(MDoc.TSN) THEN
   RETURN FLDTOSTR(L_Str.ShortName(Man.Name), "", Len, "L")+" ("+Staff.TSN+")";
  ELSE
   RETURN P_MDoc.GetMDocProSoft(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Through);
  END;
 END {Answer};

 PROCEDURE Bot();
  VAR
   PartName: STRING[];
 BEGIN
  PartName:=GetPartName("Dlm1");
  MAKEPART(R, ^PartName);
  PartName:=GetPartName("Bot");
  AlignDoc("R", DEPTH(^PartName));
  IF MDoc.MDocKind = L_MDoc.md_VPC THEN
   MAKEPART(R, ^PartName);
  ELSE
   MAKEPART(R, ^PartName, Answer(32), L_Str.ShortName(FULLNAME()));
  END;
  FORMFEED(R);
 END {Bot};

 PROCEDURE PrintMDocListCUCopy();
 BEGIN
  MAKEPART(R, CUCLine, MDocLCU.CUCopy, CUCopy.Serial);
 END {PrintMDocListCUCopy};

 PROCEDURE TopOfMDocCUCopies();
 BEGIN
 END {TopOfMDocCUCopies};

 PROCEDURE PrintMDocCUCopy();
 BEGIN
 END {PrintMDocCUCopy};

 PROCEDURE BotOfMDocCUCopies();
 BEGIN
 END {BotOfMDocCUCopies};

 PROCEDURE PrintLabelsTop();
 BEGIN
 END {PrintLabelsTop};

 PROCEDURE PrintLabel();
 BEGIN
  IF L_CUC.E_NeedPrintLabel(MDocLCU.CUCopy, MDocLCU.OpKind) THEN
   CONFORM(MDocLCU, CUCopy);
   CONFORM(CUCopy, Math);
   MAKEPART(R, LblTop);
   PrintMDocNote("LblSubTop");
   MAKEPART(R, LblLine, MDocLCU.CUCopy, CUCopy.Serial);
   MAKEPART(R, LblBot, E_CUCLabelReciever(), L_Str.ShortName(FULLNAME()));
   FORMFEED(R);
  END;
 END {PrintLabel};

 PROCEDURE PrintLabelsBot();
 BEGIN
 END {PrintLabelsBot};

 PROCEDURE Close();
 BEGIN
  CLOSEREP(R);
 END {Close};

END.
