(*
%Copyright   (c) Polak Computer System
%Author      Unknown
%Purpose     ࠢ  ࠡ⪨ ᪫᪨ 㬥⮢
%Type        library,to paste
%Specific    SYS
%Modified    24.09.2014 16:14:23 LDA
%Environment
*)

 IMPORT L_DatTim, L_MDoc, L_MathR, L_General, L_OwnData, L_XObj,
        Math, Memo, E_Stock, L_Acnt, L_PRoll, L_Money;

 PROCEDURE ⮥();
 BEGIN
 END {⮥};

 PRIVATE PROCEDURE GetCirComp(CirComp: L_XObj.tSum; cccm: L_Acnt.tCirComponentCalculationManner): L_XObj.tSum;
 BEGIN
  IF    cccm = L_Acnt.cccm_Not THEN
   RETURN 0;
  ELSIF cccm = L_Acnt.cccm_AsIs THEN
   RETURN CirComp;
  ELSIF cccm = L_Acnt.cccm_Storno THEN
   RETURN -CirComp;
  ELSE
   L_General.CallUs(0);
  END;
 END {GetCirComp};

 PROCEDURE ();
 BEGIN
  L_Acnt.MakeCir(_s, L_Acnt.cs_MDoc, GetCirComp(MDocList.Qnt*10, AcMthL.aNetto ),
                                     GetCirComp(MDocList.Qnt   , AcMthL.aAmount));
 END {};

 PROCEDURE ዑ();
 BEGIN
  L_MathR.ResetMathDone_AP(Math.Math, L_DatTim.Per(MDoc.Date));
 END {ዑ};

 PRIVATE PROCEDURE extStoreInRWayF(FromStorageToTank: SCAL[2]);
  VAR
   chkFuelMov: LIKE(RWayF.FuelTake);
 BEGIN
  IF !AcMthL.Origin2 THEN
   L_General.Error("ࠢ '" + RTI.Get().Stack(1).Proc.Name + "'  ନ஢  ஢");
  END;
  L_General.Assert(MDocList.Sum=0, "㫥 㬬   "+MDocList.Math);
  chkFuelMov:=MDocList.Qnt;
  IF chkFuelMov # MDocList.Qnt THEN
   L_General.Error(" ⥯த⮢ ଫ  筮   2-  ᫥ ⮩.||" +
                   "᫨  㢥७  ࠢ쭮 ᢮ ⢨,   ");
  END;
  L_Acnt.MakeStandartCir(_s, L_Acnt.cs_MDoc);
  IF FromStorageToTank THEN
   StoreInRWayF(MDocList.Qnt, 0);
  ELSE
   StoreInRWayF(0, MDocList.Qnt);
  END;
 END {extStoreInRWayF};

 PROCEDURE __();
 BEGIN
  extStoreInRWayF(1);
 END {__};

 PROCEDURE __();
 BEGIN
  extStoreInRWayF(0);
 END {__};

 PROCEDURE ();
 BEGIN
  L_General.Assert(MDoc.Date < 01\01\2011, "ࠢ ''  ਬ  01.2011");
  L_General.Assert(MDocList.Sum>0, "㫥 㬬   "+MDocList.Math);
  L_Acnt.MakeCir(_s, L_Acnt.cs_MDoc,
                 MDocList.Sum - L_MathR.RoundMath(MDocList.Sum*E_Stock._vat()), MDocList.Qnt);
  StoreInRWayF(MDocList.Qnt, 0);
 END {};

 PROCEDURE ___();
 BEGIN
  L_General.Assert(MDoc.Date < 01\01\2011, "ࠢ '___'  ਬ  01.2011");
  L_General.Assert(MDocList.Sum>0, "㫥 㬬   "+MDocList.Math);
  L_Acnt.MakeCir(_s, L_Acnt.cs_MDoc, L_MathR.RoundMath(MDocList.Sum*E_Stock._vat(), 0);
 END {___};

 PROCEDURE ࠧめ();
 BEGIN
  L_General.Assert(MDoc.Date < 01\01\2011, "ࠢ 'ࠧめ'  ਬ  01.2011");
  L_General.Assert(MDocList.Sum>0, "㫥 㬬   "+MDocList.Math);
  L_Acnt.MakeCir(_s, L_Acnt.cs_MDoc, MDocList.Sum, MDocList.Qnt);
  StoreInRWayF(MDocList.Qnt, 0);
 END {ࠧめ};

 PROCEDURE 㬬0();
 BEGIN
  L_General.Assert((MDocList.Sum=0) & (MDocList.VAT=0),
                   "㬬      ࠢ 0|ப "+MDocList.MDLNbr);
 END {㬬0};

 PROCEDURE 줮();
 BEGIN
  IF MDocList.VAT >= 0 THEN
   L_Acnt.MakeStandartCir(_s, L_Acnt.cs_MDoc);
  END;
 END {줮};

 PROCEDURE 줮();
 BEGIN
  IF MDocList.VAT < 0 THEN
   L_Acnt.MakeStandartCir(_s, L_Acnt.cs_MDoc);
  END;
 END {줮};

 PROCEDURE 줮();
 BEGIN
  L_General.CallUs(0); (*0063619*)
 END {줮};

 PROCEDURE 業㬬();
 BEGIN
  L_Acnt.MakeCir(_s, L_Acnt.cs_MDoc, MDocList.Sum * STRTOFLD(AcMthL.RulePar, NUMERIC)/100, 0);
 END {業㬬};

 (*-- ᭮ ।⢠ --*)

 PRIVATE PROCEDURE SetRecalcNeed();
 BEGIN
  L_MathR.ResetMathDone_AP(Math.Math, Memo.gl_me()+1);
 END {SetRecalcNeed};

 PRIVATE PROCEDURE KeyAssMDocMakeCir(trgAcCut: LIKE(AcCut.AcCut); trgSum: L_XObj.tSum);
  VAR
   trgAcCut2 : LIKE(AcCut.AcCut);
   trgOrigin2: L_Acnt.tAcMthOrigin;
 BEGIN
  IF trgSum # 0 THEN
   trgAcCut2:=L_Acnt.getAcMthL_AcCut2(MDoc.Date);
   L_General.Assert(AcMthL.Origin1 = L_Acnt.amo_Math, "ࠢ '"+AcMthL.Rule+"':    ꥪ '"+L_Str.PoolItem(L_Acnt.amo_Pool, L_Acnt.amo_Math)+"'"+L_Acnt.AcMthIdForMessage(AcMthL.AcMth));
   IF (AcMthL.Origin2 = L_Acnt.amo_Math) | L_XObj.E_DoSecondSide(Memo.gl_mb()) THEN
    trgOrigin2:=AcMthL.Origin2;
   ELSE
    SETEMPTY(trgOrigin2);
   END;
   L_Acnt.sc_MakeCir(_s, Memo.gl_mb(), AcMthL.CirSrc,
                     AcMthL.Origin1, trgAcCut,  AcMthL.Apport,
                     trgOrigin2,     trgAcCut2, AcMthL.Apport2,
                     trgSum, 0, L_MDoc.GetMDocSource(MDoc.MDocKind));
   SetRecalcNeed();
  END;
 END {KeyAssMDocMakeCir};

 PROCEDURE ⮨();
 BEGIN
  L_General.Assert(MDoc.Date < 01\01\2014, "ࠢ '⮨'  ਬ  01.2014");
  L_Acnt.MakeCir(_s, L_Acnt.cs_MDoc, MDocList.Sum, 0);
  SetRecalcNeed();
 END {⮨};

 PRIVATE VAR
  NextRule       : LIKE(Rule.Rule);
  室_㬬: L_XObj.tSum;

 PROCEDURE TestRulesOrder(Cur, Nxt: LIKE(Rule.Rule); firstRule: SCAL[2]);
  CONST
   KAError = "襭  ᠭ  ";
 BEGIN
  L_General.Assert((firstRule & !NextRule) | (NextRule = Cur),
                   KAError+
                   "| |冷 ᫥ ࠢ. 饥 ࠢ " + Cur);
  NextRule:=Nxt;
 END {TestRulesOrder};

 PROCEDURE 室();
 BEGIN
  TestRulesOrder("室", "厑", 1);
  CONFORM(AcMthL, Apport);
  室_㬬:=L_MathR.RemaindersR(Memo.gl_me()+1, AcMthL.AcCut, Apport.CirType);
  IF 室_㬬 # 0 THEN
   L_Acnt.MakeCir(_s, L_Acnt.cs_MDoc, 室_㬬, 0);
   SetRecalcNeed();
  END;
 END {室};

 PROCEDURE 厑();
 BEGIN
  TestRulesOrder("厑", "", 0);
  (*⭠ ஢*)
  L_MathR.KeyAssMakeCir(_s, AcMthL.AcCut2, AcMthL.Apport2, AcMthL.AcCut,
                        室_㬬, L_MDoc.GetMDocSource(MDoc.MDocKind));
 END {厑};

 PRIVATE PROCEDURE GetTaxAmrtAcCut(trgDest: LIKE(Dest.Dest)): LIKE(AcCut.AcCut);
  VAR
   Result: LIKE(AcCut.AcCut);
 BEGIN
  L_General.CallUs(~L_XObj.E_DoSecondSide(Memo.gl_mb()));
  TRY [RESTORE_CURSORS(RC_ON)]
   L_Acnt.SelectOperatingAcMthL(Memo.gl_mb(), L_MDoc.DG_Amr, trgDest, Math.MathType, L_MathR.mm_New, 0);
   FOR_EACH AcMthL DO
    IF AcMthL.Rule = "⍠" THEN
     Result:=AcMthL.AcCut2;
     EXIT;
    END;
   END; (* FOR_EACH AcMthL ... *)
  EXCEPT
  END; (* TRY *)
  L_General.Assert(~!Result, " 㤠 । ࠧ१  ᫥ ⨧樨  "+L_StdFrm.HR()+
                             "஢ ࠢ쭮 ᠭ  "+Math.Math+"  奬 権 㯯 09");
  RETURN Result;
 END {GetTaxAmrtAcCut};

 PROCEDURE 厑();
  VAR
   amrAcCut: LIKE(AcCut.AcCut);
   Prc     :NUMERIC[2];
 BEGIN
  厑();
  TRY [RESTORE_CURSORS(RC_ON)]
   L_MathR.PosToKAG(Math.Math, MDoc.Date);
   IF L_XObj.E_DoSecondSide(Memo.gl_mb()) THEN
    amrAcCut:=L_Acnt.fictAcCut;
   ELSE
    amrAcCut:=GetTaxAmrtAcCut(MathKAGL.Dest);
   END;
   IF (KAGLog.DprGroup >= 03) & (KAGLog.DprGroup <= 07) THEN
    Prc:=0.30;
   ELSE
    Prc:=0.10;
   END;
  EXCEPT
  END; (* TRY *)
  L_MathR.KeyAssMakeCir(_s, AcMthL.AcCut2, AcMthL.Apport, amrAcCut,
                        室_㬬*Prc, L_MDoc.GetMDocSource(MDoc.MDocKind));
 END {厑};

 PRIVATE PROCEDURE OutFromAcCut(trgAcCut, trgAcCut2: LIKE(AcCut.AcCut));
  VAR
   curSum: L_XObj.tSum;
 BEGIN
  IF ~!trgAcCut THEN (*0057540*)
   CONFORM(AcMthL, Apport);
   curSum:=L_MathR.RemaindersR(Memo.gl_me()+1, trgAcCut, Apport.CirType);
   IF curSum # 0 THEN
    L_MathR.KeyAssMakeCir(_s, trgAcCut, AcMthL.Apport, trgAcCut2,
                          curSum, L_MDoc.GetMDocSource(MDoc.MDocKind));
   END;
  END;
 END {OutFromAcCut};

 PROCEDURE 室0();
 BEGIN
  L_General.Assert(!AcMthL.Origin2, "ࠢ '室0'  ନ஢ ஭ ஢");
  OutFromAcCut(AcMthL.AcCut, AcMthL.AcCut2);
 END {室0};

 PRIVATE PROCEDURE intMoveSum(trgAcCut: LIKE(AcCut.AcCut));
  VAR
   curSum: L_XObj.tSum;
 BEGIN
  CONFORM(AcMthL, Apport);
  curSum:=L_MathR.RemaindersR(Memo.gl_me()+1, trgAcCut, Apport.CirType);
  KeyAssMDocMakeCir(trgAcCut, curSum);
 END {intMoveSum};

 PROCEDURE 室();
  VAR
   curSum: L_XObj.tSum;
 BEGIN
  L_General.Assert(~!AcMthL.AcCut, "ࠢ '室':  ࠧ१   㪠 "+L_Acnt.AcMthIdForMessage(AcMthL.AcMth));
  intMoveSum(AcMthL.AcCut);
 END {室};

 PROCEDURE ᠭ();
  VAR
   curAcCut : LIKE(AcCut.AcCut);
   trgAcCuts: L_MathR.tMathAcCutCollection;
 BEGIN
  L_General.Assert(AcMthL.AcCut = L_Acnt.fictAcCut, "'ᠭOC' - ࠧ१   䨪⨢"+L_Acnt.AcMthIdForMessage(AcMthL.AcMth));

  E_Stock.GetKeyAssBalCostAcCuts(Memo.gl_mb(), trgAcCuts, L_MathR.KA_All, L_MathR.KA_All, L_MathR.KA_All);
  FOR_EACH curAcCut IN trgAcCuts DO
   intMoveSum(curAcCut);
  END;
  OutFromAcCut(E_Stock.KA_acc_InUse, L_Acnt.fictAcCut);
  SetRecalcNeed();
 END {ᠭ};

 PROCEDURE ፠();
 BEGIN
  L_General.Assert(!AcMthL.Origin2, "ࠢ '፠'  ନ஢ ஭ ஢");
  OutFromAcCut(E_Stock.KA_acc_TaxCost,    AcMthL.AcCut2);
  OutFromAcCut(E_Stock.KA_acc_FutureTax,  AcMthL.AcCut2);
  OutFromAcCut(E_Stock.KA_acc_NotTaxCost, AcMthL.AcCut2);
 END {፠};

 PROCEDURE ᠭ();
  VAR
   curAcCut : LIKE(AcCut.AcCut);
   trgAcCuts: L_MathR.tMathAcCutCollection;
 BEGIN
  L_General.Assert(AcMthL.AcCut = L_Acnt.fictAcCut, "'ᠭ' - ࠧ१   䨪⨢");
  E_Stock.GetKeyAssWearAcCuts(Memo.gl_mb(), trgAcCuts, L_MathR.KA_BalDepr, L_MathR.KA_All, L_MathR.KA_All);
  FOR_EACH curAcCut IN trgAcCuts DO
   intMoveSum(curAcCut);
  END;
  SetRecalcNeed();
 END {ᠭ};

 PROCEDURE ፠();
 BEGIN
  L_General.Assert(!AcMthL.Origin2, "ࠢ '፠'  ନ஢ ஭ ஢");
  OutFromAcCut(E_Stock.KA_acc_TaxWear, AcMthL.AcCut2);
 END {፠};

 PROCEDURE ᠭ3();
  VAR
   curAcCut : LIKE(AcCut.AcCut);
   trgAcCuts: L_MathR.tMathAcCutCollection;
 BEGIN
  L_General.Assert(!AcMthL.Origin2, "ࠢ 'ᠭ3'  ନ஢ ஭ ஢");
  L_General.Assert(AcMthL.AcCut = L_Acnt.fictAcCut, "'ᠭ3' - ࠧ१   䨪⨢");
  CONFORM(AcMthL, Apport);
  E_Stock.GetKeyAssWearAcCuts(Memo.gl_mb(), trgAcCuts, L_MathR.KA_OutBalDepr, L_MathR.KA_All, L_MathR.KA_All);
  FOR_EACH curAcCut IN trgAcCuts DO
   OutFromAcCut(curAcCut, AcMthL.AcCut2);
  END;
  SetRecalcNeed();
 END {ᠭ3};

 PROCEDURE ();
 BEGIN
  TestRulesOrder("", "", 1);
  CONFORM(AcMthL, Apport);
  室_㬬:=L_MathR.RemaindersR(Memo.gl_me()+1, AcMthL.AcCut, Apport.CirType);
 END {};

 PROCEDURE ();
 BEGIN
  TestRulesOrder("", "", 0);
  L_Acnt.MakeCir(_s, L_Acnt.cs_MDoc, 室_㬬, 0);
  SetRecalcNeed();
 END {};

 PROCEDURE E_RunsProportional(DprK: L_MathR.DprKindType): SCAL[2];
  VAR
   Prc: PROC;
 BEGIN
  Prc:=PROCREF(E_Stock.RunsProportional);
  IF ~!Prc THEN
   RETURN Prc(Memo.gl_mb(), DprK);
  END;
  RETURN 0;
 END {E_RunsProportional};

 PRIVATE VAR
  AmortPhase: SCAL[3];

 PROCEDURE SetAmortPhase(Phase: SCAL[3]);
 BEGIN
  AmortPhase:=Phase;
 END {SetAmortPhase};

 PRIVATE PROCEDURE intCalcWear(DprK: L_MathR.DprKindType; _DprM: LIKE(KAGroup.AcnDprM); _UL: LIKE(KAGLog.AcnUL);
                               CostSum, DeprSum, PCostSum, PDeprSum: L_XObj.tSum; _Months: NUMERIC[0];
                               trgAcCut: LIKE(AcCut.AcCut); trgXObject2: LIKE(XObject.XObject); trgAcCut2: LIKE(AcCut.AcCut));
  VAR
   Depr,
   RealDepr,
   maxD     : L_XObj.tSum;
   curSum   : L_XObj.tSum;
   i, maxI  : NUMERIC[0];
   _MtyIdx  : LIKE(MathMty.MtyIdx);
   _Runs    : LIKE(MathMty.Proof)[Math.Max(E_Stock.MtyRunSize, 2)];
   maxRun,
   _TotRun  : LIKE(MathMty.Proof);
 BEGIN
  IF (CostSum - DeprSum) # 0 THEN
   SETZERO(_TotRun, i);
   maxRun:=MINOF(maxRun);
   WHILE i < E_Stock.MtyRunSize DO
    _Runs[i]:=L_MathR.GetRunMathMty(Memo.gl_mb(), E_Stock.MtyRunBeg+i);
    INC(_TotRun, _Runs[i]);
    IF maxRun < _Runs[i] THEN
     maxRun:=_Runs[i];
     maxI  :=i;
    END;
    INC(i);
   END;
   IF    _DprM = L_MathR.DprM_Line THEN
    DEC(_UL, _Months);
    IF _UL > 0 THEN
     Depr:=(PCostSum-PDeprSum)/_UL;
    ELSE
     Depr:=(PCostSum-PDeprSum);
    END;
   ELSIF _DprM = L_MathR.DprM_Runs THEN
    IF _UL > 0 THEN
     Depr:=(PCostSum-PDeprSum)*(_TotRun/(_UL*1000));
    ELSIF _TotRun > 0 THEN
     Depr:=PCostSum-PDeprSum;
    ELSE
     Depr:=0;
    END;
   ELSIF _DprM = L_MathR.DprM_FullAtOnce THEN
    Depr:=CostSum-DeprSum;
   ELSE
    L_General.CallUs(0);
   END;
   RealDepr:=Math.Min(Depr, CostSum-DeprSum);
   IF RealDepr # 0 THEN
    IF ((_DprM # L_MathR.DprM_Runs) & ~E_RunsProportional(DprK)) |
       (RealDepr < 0) | (_TotRun = 0) THEN
     L_MathR.KeyAssMakeCompleteCir(_s, trgAcCut, L_Acnt.E_Apport_MoneyCredit(Memo.gl_mb()), trgXObject2, trgAcCut2,
                                   RealDepr, L_XObj.src_Amortisation);
    ELSE (*ய樮쭮 ஡*)
IF L_XObj.E_DoSecondSide(Memo.gl_mb()) THEN
 L_General.SetupRequired(); (*0104761 08.09.2014 18:43:39 POLAK\Bor*)
END;
     i:=0;
     maxD:=RealDepr;
     WHILE i <= E_Stock.MtyRunSize DO
      IF i < E_Stock.MtyRunSize THEN
       IF (i # maxI) THEN
        curSum:=RealDepr*_Runs[i]/_TotRun;
        DEC(maxD, curSum);
        _MtyIdx:=E_Stock.MtyRunBeg+i;
       ELSE
        curSum:=0;
       END;
      ELSE
       curSum:=maxD;
       _MtyIdx:=E_Stock.MtyRunBeg+maxI;
      END;
      IF curSum # 0 THEN
       L_MathR.KeyAssMakeCir(_s, trgAcCut, L_Acnt.E_Apport_MoneyCredit(Memo.gl_mb()),
                             E_Stock.MtyIdxAcCut(DprK, _MtyIdx),
                             curSum, L_XObj.src_Amortisation);
      END;
      INC(i);
     END;
    END;
   END;
   IF (CostSum-DeprSum-RealDepr) # 0 THEN
    SetRecalcNeed();
   END;
  END;
 END {intCalcWear};

 PRIVATE PROCEDURE NeedCalcAmort(_DprM  : LIKE(KAGroup.AcnDprM);
                                 _Status: LIKE(MathKAGL.AcnStat)): SCAL[2];
 BEGIN
  RETURN (_Status = L_MathR.matst_InOperat) &
         ( (_DprM # L_MathR.DprM_NoAmort) & (_DprM # L_MathR.DprM_InUse) &
           ((AmortPhase = 1) = (_DprM # L_MathR.DprM_FullAtOnce)) );
 END {NeedCalcAmort};

 PRIVATE PROCEDURE NeedStornoAmort(_DprM: LIKE(KAGroup.AcnDprM)): SCAL[2];
 BEGIN
  RETURN _DprM = L_MathR.DprM_InUse;
 END {NeedStornoAmort};

 PRIVATE PROCEDURE GetPPer(APrDate: DATE; DprK: L_MathR.DprKindType; _UL: LIKE(KAGLog.AcnUL)): DATE;
  VAR
   PMathKAGLDate,
   PKAGLogDate,
   D : DATE;
   _PrevUL,
   _DprUL: NUMERIC[0];
   _PrevDprM,
   _DprM : LIKE(KAGroup.AcnDprM);
   _Break: LIKE(MathKAGL.AcnBreak);
 BEGIN
  SETEMPTY(D);

  SAVE(MathKAGL);
  SAVE(KAGroup);
  SAVE(KAGLog);

  CHANGESEL(MathKAGL, Math, , MathKAGL.Math);

  PMathKAGLDate:=MathKAGL.Date;
  PKAGLogDate  :=KAGLog.Date;
  _Break:=L_MathR.brk_Ignore;
  LOOP
   L_General.Assert(OCCURE(KAGLog), " ᠭ 㯯  "+MathKAGL.KAGroup+"  "+L_DatTim.DateStr(PMathKAGLDate));
   CHANGESEL(KAGLog, KAGroup, , KAGLog.KAGroup);
   REPEAT
    IF    DprK = L_MathR.DprK_Acn THEN
     _DprM :=KAGroup.AcnDprM;
     _DprUL:=L_MathR.GetFullUL(APrDate, L_MathR.DprK_Acn);
    ELSIF DprK = L_MathR.DprK_Tax THEN
     IF (KAGLog.Date>=01\01\2002) | ~!KAGLog.TaxUL THEN
      _DprM:=KAGroup.TaxDprM;
      _DprUL:=L_MathR.GetFullUL(APrDate, L_MathR.DprK_Tax);
     ELSE
      _DprM:=KAGroup.AcnDprM;
      _DprUL:=L_MathR.GetFullUL(APrDate, L_MathR.DprK_Acn);
     END;
    END;
    IF _Break = L_MathR.brk_Ignore THEN
     _PrevDprM:=_DprM;
     _PrevUL:=_DprUL;
     IF _DprM # L_MathR.DprM_Runs THEN
      _Break :=L_MathR.brk_Usually;
     END;
    ELSIF (_DprM # _PrevDprM) | (_DprUL#_PrevUL) THEN
     D:=L_DatTim.NextPer(Math.Max(PKAGLogDate, MathKAGL.Date));
    END;
    PKAGLogDate:=Math.Max(KAGLog.Date, MathKAGL.Date)
   UNTIL (KAGLog.Date<=MathKAGL.Date) | ~PREV(KAGLog) | ~!D;
   IF !D THEN
    IF    DprK = L_MathR.DprK_Acn THEN
     _Break:=MathKAGL.AcnBreak;
    ELSE
     _Break:=MathKAGL.TaxBreak;
    END;
    IF    _Break = L_MathR.brk_Allways THEN
     D:=L_DatTim.NextPer(MathKAGL.Date);
    END;
   END;
   PMathKAGLDate:=MathKAGL.Date;
   IF ~PREV(MathKAGL) | ~!D THEN
    EXIT;
   END;
   CONFORM(MathKAGL, KAGroup);
   HISTCONF(PMathKAGLDate-1, KAGroup, KAGLog);
  END; (* LOOP ... *)

  RESTORE(KAGLog);
  RESTORE(KAGroup);
  RESTORE(MathKAGL);
  IF D < Math.Max(L_DatTim.NextPer(APrDate), 01\01\2002) THEN
   SETEMPTY(D);
  END;
  RETURN D;
 END {GetPPer};

 PRIVATE PROCEDURE Months(BP, EP: DATE): NUMERIC[0];
 BEGIN
  IF ~!EP THEN
   RETURN L_DatTim.MONTH(EP)-L_DatTim.MONTH(BP)+12*(L_DatTim.YEAR(EP)-L_DatTim.YEAR(BP));
  ELSE
   RETURN 0;
  END;
 END {Months};

 PRIVATE PROCEDURE intCalcAcnWear(trgXObject2: LIKE(XObject.XObject); trgAcCut2: LIKE(AcCut.AcCut));
  VAR
   Cost,
   Depr,
   PDepr    : L_XObj.tSum;
   PPer,
   BPer,
   APrDate  : DATE;
   curAcCut : LIKE(AcCut.AcCut);
   trgAcCuts: L_MathR.tMathAcCutCollection;
   curUL    : LIKE(KAGLog.AcnUL);
   waCount  : SCAL[L_MathR.KA_NumWearAcnt];
 BEGIN
  IF NeedCalcAmort(KAGroup.AcnDprM, MathKAGL.AcnStat) THEN
   APrDate:=L_MathR.GetKeyAssAPrDate(Math.Math);
   BPer:=L_DatTim.NextPer(APrDate);
   curUL:=L_MathR.GetFullUL(APrDate, L_MathR.DprK_Acn);
   PPer:=GetPPer(APrDate, L_MathR.DprK_Acn, curUL);
   FOR_EACH waCount DO
    IF waCount # L_MathR.KA_All THEN
     E_Stock.GetKeyAssBalCostAcCuts(Memo.gl_mb(), trgAcCuts, L_MathR.KA_All, L_MathR.KA_All, waCount);
     Cost:=L_MathR.GetKeyAssAcCutCollectionRemaindersR(Memo.gl_mb(), trgAcCuts, L_Acnt.ct_Credit);
  
     IF ~!trgAcCuts[0] (* ࠧ१  ⮨*) THEN
      E_Stock.GetKeyAssWearAcCuts(Memo.gl_mb(), trgAcCuts, L_MathR.KA_All, waCount, L_MathR.KA_All);
      Depr:=L_MathR.GetKeyAssAcCutCollectionRemaindersR(Memo.gl_mb(), trgAcCuts, L_Acnt.ct_Debit);
      IF ~!PPer THEN
       PDepr:=L_MathR.GetKeyAssAcCutCollectionRemaindersR(PPer, trgAcCuts, L_Acnt.ct_Debit);
      ELSE
       PDepr:=0;
      END;
 
      E_Stock.GetKeyAssWearAcCuts(Memo.gl_mb(), trgAcCuts, L_MathR.KA_All, L_MathR.KA_All, waCount);
      L_General.CallUs(~!trgAcCuts[0] & !trgAcCuts[1]); (*  ஢  ࠧ१  ⨧樨*)
      INC(Depr, L_MathR.RemaindersR(Memo.gl_mb(), trgAcCuts[0], L_Acnt.ct_Debit));
      IF ~!PPer THEN
       INC(PDepr, L_MathR.RemaindersR(PPer, trgAcCuts[0], L_Acnt.ct_Debit));
      END;
      intCalcWear(L_MathR.DprK_Acn, KAGroup.AcnDprM, curUL, Cost, Depr, Cost, PDepr, Months(BPer, PPer), trgAcCuts[0], trgXObject2, trgAcCut2);
     END; (* IF ~!trgAcCuts[0] ... *)
    END; (* IF waCount # L_MathR.KA_All ... *)
   END; (* FOR_EACH waCount ... *)
  ELSIF NeedStornoAmort(KAGroup.AcnDprM) THEN
   E_Stock.GetKeyAssWearAcCuts(Memo.gl_mb(), trgAcCuts, L_MathR.KA_All, L_MathR.KA_All, L_MathR.KA_All);
   FOR_EACH curAcCut IN trgAcCuts DO
    Depr:=L_MathR.RemaindersR(Memo.gl_me()+1, curAcCut, L_Acnt.ct_Debit);
    L_MathR.KeyAssMakeCir(_s, curAcCut, L_Acnt.E_Apport_MoneyCredit(Memo.gl_mb()), trgAcCut2,
                          -Depr, L_XObj.src_Amortisation);
   END;
  END;
 END {intCalcAcnWear};

 PUBLIC PROCEDURE CalcAcnWear();
  VAR
   WearCI: LIKE(CostItem.CostItem);
 BEGIN
  WearCI:=L_MathR.GetCurMathKAGLCostItem(Memo.gl_mb());
  SEARCH(CostItem, CostItem, , WearCI);
  intCalcAcnWear(CostItem.XObject, L_Acnt.GetSpecificAcCutForCostItem(WearCI, L_Acnt.acp_CostItem_Default));
 END {CalcAcnWear};

 PROCEDURE ⨧();
 BEGIN
  L_General.CallUs(~L_XObj.E_DoSecondSide(Memo.gl_mb()));
  L_General.Assert(AcMthL.AcCut  = L_Acnt.fictAcCut, "'⨧' - ࠧ१   䨪⨢");
  L_General.Assert(AcMthL.AcCut2 # L_Acnt.fictAcCut, "'⨧' - ᯮ騩 ࠧ१    䨪⨢");
  intCalcAcnWear(EMPTYOF(XObject.XObject), AcMthL.AcCut2);
 END {⨧};

 PRIVATE PROCEDURE intCalcTaxWear(trgAcCut2: LIKE(AcCut.AcCut));
  VAR
   Cost,
   Depr,
   PDepr    : L_XObj.tSum;
   PPer,
   BPer,
   APrDate  : DATE;
   curUL    : LIKE(KAGLog.TaxUL);
 BEGIN
  IF NeedCalcAmort(KAGroup.TaxDprM, MathKAGL.TaxStat) THEN
   APrDate:=L_MathR.GetKeyAssAPrDate(Math.Math);
   BPer:=L_DatTim.NextPer(APrDate);
   curUL:=L_MathR.GetFullUL(APrDate, L_MathR.DprK_Tax);
   PPer:=GetPPer(APrDate, L_MathR.DprK_Tax, curUL);
   SETZERO(Cost, Depr, PDepr);
   Cost:=L_MathR.RemaindersR(Memo.gl_mb(), E_Stock.KA_acc_TaxCost, L_Acnt.ct_Credit);
   Depr:=L_MathR.RemaindersR(Memo.gl_mb(), E_Stock.KA_acc_TaxWear, L_Acnt.ct_Debit);
   IF ~!PPer THEN
    PDepr:=L_MathR.RemaindersR(PPer, E_Stock.KA_acc_TaxWear, L_Acnt.ct_Debit);
   ELSE
    PDepr:=0;
   END;
   intCalcWear(L_MathR.DprK_Tax, KAGroup.TaxDprM, curUL, Cost, Depr, Cost, PDepr, Months(BPer, PPer),
               E_Stock.KA_acc_TaxWear, EMPTYOF(XObject.XObject), trgAcCut2);
  ELSIF NeedStornoAmort(KAGroup.TaxDprM) THEN
   Depr:=L_MathR.RemaindersR(Memo.gl_me()+1, E_Stock.KA_acc_TaxWear, L_Acnt.ct_Debit);
   L_MathR.KeyAssMakeCir(-_s, E_Stock.KA_acc_TaxWear, L_Acnt.E_Apport_MoneyCredit(Memo.gl_mb()), trgAcCut2,
                         Depr, L_XObj.src_Amortisation);
  END;
 END {intCalcTaxWear};

 PUBLIC PROCEDURE CalcTaxWear();
 BEGIN
  intCalcTaxWear(L_Acnt.fictAcCut);
 END {CalcTaxWear};

 PROCEDURE ⍠();
 BEGIN
  L_General.CallUs(~L_XObj.E_DoSecondSide(Memo.gl_mb()));
  L_General.Assert(AcMthL.AcCut  = L_Acnt.fictAcCut, "'⍠' - ࠧ१   䨪⨢");
  L_General.Assert(AcMthL.AcCut2 # L_Acnt.fictAcCut, "'⍠' - ᯮ騩 ࠧ१    䨪⨢");
  intCalcTaxWear(AcMthL.AcCut2);
 END {⍠};

 PRIVATE PROCEDURE intAcnInUse(trgXObject2: LIKE(XObject.XObject); trgAcCut2: LIKE(AcCut.AcCut));
  VAR
   Cost     : L_XObj.tSum;
   curSum   : L_XObj.tSum;
   curAcCut : LIKE(AcCut.AcCut);
   trgAcCuts: L_MathR.tMathAcCutCollection;
 BEGIN
  IF    KAGroup.AcnDprM = L_MathR.DprM_InUse THEN
   Cost:=0;
   E_Stock.GetKeyAssBalCostAcCuts(Memo.gl_mb(), trgAcCuts, L_MathR.KA_All, L_MathR.KA_All, L_MathR.KA_All);
   FOR_EACH curAcCut IN trgAcCuts DO
    curSum:=L_MathR.RemaindersR(Memo.gl_me()+1, curAcCut, L_Acnt.ct_Credit);
    INC(Cost, curSum);
    L_MathR.KeyAssMakeCompleteCir(_s, curAcCut, L_Acnt.E_Apport_MoneyCredit(Memo.gl_mb()), trgXObject2, trgAcCut2, curSum, L_XObj.src_Amortisation);
   END;
   E_Stock.GetKeyAssWearAcCuts(Memo.gl_mb(), trgAcCuts, L_MathR.KA_All, L_MathR.KA_All, L_MathR.KA_All);
   FOR_EACH curAcCut IN trgAcCuts DO
    curSum:=L_MathR.RemaindersR(Memo.gl_me()+1, curAcCut, L_Acnt.ct_Debit);
    DEC(Cost, curSum);
    L_MathR.KeyAssMakeCompleteCir(_s, curAcCut, L_Acnt.E_Apport_MoneyDebit(Memo.gl_mb()), trgXObject2, trgAcCut2, curSum, L_XObj.src_Amortisation);
   END;
   L_MathR.KeyAssMakeCir(_s, E_Stock.KA_acc_InUse, L_Acnt.E_Apport_MoneyDebit(Memo.gl_mb()), L_Acnt.fictAcCut,
                         Cost, L_XObj.src_Amortisation);
  END;
 END {intAcnInUse};

 PUBLIC PROCEDURE AcnInUse();
  VAR
   WearCI: LIKE(CostItem.CostItem);
 BEGIN
  WearCI:=L_MathR.GetCurMathKAGLCostItem(Memo.gl_mb());
  SEARCH(CostItem, CostItem, , WearCI);
  intAcnInUse(CostItem.XObject, L_Acnt.GetSpecificAcCutForCostItem(WearCI, L_Acnt.acp_CostItem_Default));
 END {AcnInUse};

 PROCEDURE 室();
 BEGIN
  L_General.CallUs(~L_XObj.E_DoSecondSide(Memo.gl_mb()));
  L_General.Assert(AcMthL.AcCut = L_Acnt.fictAcCut, "'室' - ࠧ१   䨪⨢");
  intAcnInUse(EMPTYOF(XObject.XObject), AcMthL.AcCut2);
 END {室};

 PRIVATE PROCEDURE intTaxInUse(trgAcCut2: LIKE(AcCut.AcCut));
  VAR
   curSum: L_XObj.tSum;
 BEGIN
  IF KAGroup.TaxDprM = L_MathR.DprM_InUse THEN
   curSum:=L_MathR.RemaindersR(Memo.gl_me()+1, E_Stock.KA_acc_TaxCost, L_Acnt.ct_Credit);
   L_MathR.KeyAssMakeCir(_s, E_Stock.KA_acc_TaxCost,
                         L_Acnt.E_Apport_MoneyCredit(Memo.gl_mb()), trgAcCut2,
                         curSum, L_XObj.src_Amortisation);
   curSum:=L_MathR.RemaindersR(Memo.gl_me()+1, E_Stock.KA_acc_TaxWear, L_Acnt.ct_Debit);
   L_MathR.KeyAssMakeCir(_s, E_Stock.KA_acc_TaxWear,
                         L_Acnt.E_Apport_MoneyDebit(Memo.gl_mb()), trgAcCut2,
                         curSum, L_XObj.src_Amortisation);
  END;
 END {intTaxInUse};

 PUBLIC PROCEDURE TaxInUse();
 BEGIN
  intTaxInUse(L_Acnt.fictAcCut);
 END {TaxInUse};

 PROCEDURE 占();
 BEGIN
  L_General.CallUs(~L_XObj.E_DoSecondSide(Memo.gl_mb()));
  L_General.Assert(AcMthL.AcCut = L_Acnt.fictAcCut, "'占' - ࠧ१   䨪⨢");
  intTaxInUse(AcMthL.AcCut2);
 END {占};

 PRIVATE PROCEDURE MakeAcCutPrcCir(_AcCut, _AcCut2: LIKE(AcCut.AcCut); _CirType: LIKE(Apport.CirType));
  VAR
   _Apport,
   _Apport2: LIKE(Apport.Apport);
   curSum  : L_XObj.tSum;
   K       : LIKE(MDocList.Qnt);
 BEGIN
  IF ~!_AcCut THEN (*0057540*)
   K:=MDocList.Qnt;
   IF (_CirType = L_Acnt.ct_Credit) = (K > 0) THEN
    _Apport :=L_Acnt.E_Apport_MoneyDebit(Memo.gl_mb());
    _Apport2:=L_Acnt.E_Apport_MoneyCredit(Memo.gl_mb());
   ELSE
    _Apport :=L_Acnt.E_Apport_MoneyCredit(Memo.gl_mb());
    _Apport2:=L_Acnt.E_Apport_MoneyDebit(Memo.gl_mb());
   END;
   K:=Math.Abs(K);
 
   curSum:=L_MathR.RemaindersR(Memo.gl_me()+1, _AcCut, _CirType);
   curSum:=curSum*K/100;
 
   L_MathR.AccessKeyAssXObject();
   IF ~!AcMthL.Origin2 & (_AcCut2 # L_Acnt.fictAcCut) THEN
    L_XObj.MakeCompleteCir(_s, Memo.gl_mb(),
                           XObject.XObject, _AcCut,  _Apport,  0,
                           XObject.XObject, _AcCut2, _Apport2, 0,
                           curSum, 0, L_MDoc.GetMDocSource(MDoc.MDocKind));
   ELSE
    L_XObj.MakeCompleteCir(_s, Memo.gl_mb(),
                           XObject.XObject, _AcCut,  _Apport,  0,
                           "",              _AcCut2, "",       0,
                           curSum, 0, L_MDoc.GetMDocSource(MDoc.MDocKind));
   END;
  END;
 END {MakeAcCutPrcCir};

 PROCEDURE ८業();
  VAR
   curAcCut : LIKE(AcCut.AcCut);
   trgAcCuts: L_MathR.tMathAcCutCollection;
 BEGIN
  L_General.Assert(AcMthL.AcCut = L_Acnt.fictAcCut, "'८業' - ࠧ१   䨪⨢");
  E_Stock.GetKeyAssBalCostAcCuts(Memo.gl_mb(), trgAcCuts, L_MathR.KA_All, L_MathR.KA_All, L_MathR.KA_All);
  FOR_EACH curAcCut IN trgAcCuts DO
   MakeAcCutPrcCir(curAcCut, AcMthL.AcCut2, L_Acnt.ct_Credit);
  END;
  E_Stock.GetKeyAssWearAcCuts(Memo.gl_mb(), trgAcCuts, L_MathR.KA_All, L_MathR.KA_All, L_MathR.KA_All);
  FOR_EACH curAcCut IN trgAcCuts DO
   MakeAcCutPrcCir(curAcCut, AcMthL.AcCut2, L_Acnt.ct_Debit);
  END;
  MakeAcCutPrcCir(E_Stock.KA_acc_InUse, L_Acnt.fictAcCut, L_Acnt.ct_Credit);
  SetRecalcNeed();
 END {८業};

 PROCEDURE ८掑捠();
 BEGIN
  L_General.Assert(AcMthL.AcCut = L_Acnt.fictAcCut, "'८掑捠' - ࠧ१   䨪⨢");
  MakeAcCutPrcCir(E_Stock.KA_acc_TaxCost, AcMthL.AcCut2, L_Acnt.ct_Credit);
  MakeAcCutPrcCir(E_Stock.KA_acc_TaxWear, AcMthL.AcCut2, L_Acnt.ct_Debit);

  MakeAcCutPrcCir(E_Stock.KA_acc_FutureTax,  L_Acnt.fictAcCut, L_Acnt.ct_Credit);
  MakeAcCutPrcCir(E_Stock.KA_acc_NotTaxCost, L_Acnt.fictAcCut, L_Acnt.ct_Credit);
  SetRecalcNeed();
 END {८掑捠};

 PROCEDURE ८業();
  VAR
   Msg       : STRING[];
   trgAcCuts : L_MathR.tMathAcCutCollection;
   curCirType: LIKE(Apport.CirType);
   Sums      : L_XObj.tSum[HIGH(trgAcCuts)];
   TotSum,
   maxSum,
   MDLSum,
   curSum    : L_XObj.tSum;
   i, maxI   : SCAL[RANGEOF(L_MathR.tMathAcCutCollection)];
 BEGIN
  L_General.Assert(AcMthL.AcCut = L_Acnt.fictAcCut, "'८業' - ࠧ१   䨪⨢");
  IF    MDocList.MMode = L_MathR.mm_New THEN
   E_Stock.GetKeyAssBalCostAcCuts(Memo.gl_mb(), trgAcCuts, L_MathR.KA_All, L_MathR.KA_All, L_MathR.KA_All);
   curCirType:=L_Acnt.ct_Credit;
   Msg:="⮨";
  ELSIF MDocList.MMode = L_MathR.mm_Amortization THEN
   E_Stock.GetKeyAssWearAcCuts(Memo.gl_mb(), trgAcCuts, L_MathR.KA_BalDepr, L_MathR.KA_All, L_MathR.KA_All);
   curCirType:=L_Acnt.ct_Debit;
   Msg:="⨧樨";
  ELSE
   L_General.Error("⨬ ਬ ࠢ '८業'| 樨  ० "+MDocList.MMode);
  END;

  TotSum:=0;
  maxI:=0;
  maxSum:=MINOF(maxSum);
  FOR_EACH i DO
   IF !trgAcCuts[i] THEN
    EXIT;
   END;
   Sums[i]:=L_MathR.RemaindersR(Memo.gl_me()+1, trgAcCuts[i], curCirType);
   INC(TotSum, Sums[i]);
   IF Sums[i] > Sums[maxI] THEN
    maxI:=i;
   END;
  END;

  L_General.Assert(TotSum # 0, " "+Math.Math+":  "+Msg+"  ८業");
  MDLSum:=GetCirComp(MDocList.Sum, AcMthL.aNetto);
  maxSum:=MDLSum;
  FOR_EACH i DO
   IF !trgAcCuts[i] THEN
    EXIT;
   END;
   IF i # maxI THEN
    curSum:=MDLSum*Sum[i]/TotSum;
    DEC(maxSum, curSum);
    L_MathR.KeyAssMakeCir(_s, trgAcCuts[i], AcMthL.Apport, AcMthL.AcCut2,
                          curSum, L_MDoc.GetMDocSource(MDoc.MDocKind));
   END;
  END;
  L_MathR.KeyAssMakeCir(_s, trgAcCuts[maxI], AcMthL.Apport, AcMthL.AcCut2,
                        maxSum, L_MDoc.GetMDocSource(MDoc.MDocKind));
 END {८業};

 PRIVATE PROCEDURE intRevaluation(revSum        : L_XObj.tSum;
                                  arrAcCuts     : LIKE(AcCut.AcCut)[];
                                  trgCirType    : LIKE(Apport.CirType);
                                  corAcMthOrigin: L_Acnt.tAcMthOrigin;
                                  corAcCut      : LIKE(AcCut.AcCut));
  VAR
   curApport,
   corApport: LIKE(Apport.Apport);
   curAcCut,
   maxAcCut : LIKE(AcCut.AcCut);
   curSum,
   trgSum,
   maxSum,
   totSum,
   rstSum   : L_XObj.tSum;
   arrSums  : L_XObj.tSum[MAXOF(AcCut.AcCut)+1];
 BEGIN
  IF revSum # 0 THEN
   L_General.CallUs(~!corAcCut);
   IF ((trgCirType = L_Acnt.ct_Credit) & (revSum > 0)) |
      ((trgCirType = L_Acnt.ct_Debit)  & (revSum < 0)) THEN
    curApport:=L_Acnt.E_Apport_MoneyDebit (Memo.gl_mb());
    corApport:=L_Acnt.E_Apport_MoneyCredit(Memo.gl_mb());
   ELSE
    curApport:=L_Acnt.E_Apport_MoneyCredit(Memo.gl_mb());
    corApport:=L_Acnt.E_Apport_MoneyDebit (Memo.gl_mb());
   END;

   trgSum:=Math.Abs(revSum);

   SETEMPTY(arrSums);
   maxSum:=0;
   totSum:=0;
   SETEMPTY(maxAcCut);
   FOR_EACH curAcCut IN arrAcCuts DO
    arrSums[curAcCut]:=L_MathR.RemaindersR(Memo.gl_me()+1, curAcCut, trgCirType);
    IF arrSums[curAcCut] > maxSum THEN
     maxAcCut:=curAcCut;
     maxSum  :=arrSums[curAcCut];
    END;
    INC(totSum, arrSums[curAcCut]);
   END;
   L_General.CallUs(~!maxAcCut);
 
   rstSum:=trgSum;
 
   L_MathR.AccessKeyAssXObject();
 
   FOR_EACH curAcCut IN arrAcCuts DO
    IF curAcCut # maxAcCut THEN
     curSum:=trgSum*arrSums[curAcCut]/totSum;
     DEC(rstSum, curSum);

     L_Acnt.sc_MakeCir(_s, Memo.gl_mb(), AcMthL.CirSrc,
                       L_Acnt.amo_Math, curAcCut, curApport,
                       corAcMthOrigin,  corAcCut, corApport,
                       curSum, 0, L_MDoc.GetMDocSource(MDoc.MDocKind));
    END;
   END;
   L_Acnt.sc_MakeCir(_s, Memo.gl_mb(), AcMthL.CirSrc,
                     L_Acnt.amo_Math, maxAcCut, curApport,
                     corAcMthOrigin,  corAcCut, corApport,
                     rstSum, 0, L_MDoc.GetMDocSource(MDoc.MDocKind));
   SetRecalcNeed();
  END;
 END {intRevaluation};

 PUBLIC PROCEDURE ८業();
  CONST
   SrcNum = 2;
   prvSrc = 0;
   curSrc = 1;
  VAR
   srcIdx        : SCAL[SrcNum];
   prvRevl,
   oldCost,
   oldWear,
   balWear,
   newCost,
   newWear       : L_XObj.tSum;
   revCost,
   revWear       : L_XObj.tSum[SrcNum];
   corAcCuts     : LIKE(AcCut.AcCut)[SrcNum];
   corAcMthOrigin: L_Acnt.tAcMthOrigin;
   arrAcCuts     : L_MathR.tMathAcCutCollection;
   MDocIdForMsg: STRING[];
 BEGIN
  MDocIdForMsg:=L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) + "  " + L_DatTim.DateStr(MDoc.Date)+L_StdFrm.HR();
  L_General.Assert(~!AcMthL.Apport2, "ࠢ '८業':   㪠  ஭ ஢"+L_Acnt.AcMthIdForMessage(AcMthL.AcMth));
  SEARCH(Apport, Apport, , AcMthL.Apport2);
  L_General.Assert(Apport.CirType = L_Acnt.ct_Credit, "ࠢ '८業': ९⠭ ⠬ ''  '।'"+L_Acnt.AcMthIdForMessage(AcMthL.AcMth));

  newCost:=MDocList.Sum;
  newWear:=MDocList.VAT;
  L_General.Assert(newCost>=newWear, L_MDoc.MDocStr(MDocList.MDocKind, MDocList.MDoc)+"  "+MDocList.Math+"|⨧     ⮨");
  L_General.Assert((newCost>=0) & (newWear>=0), L_MDoc.MDocStr(MDocList.MDocKind, MDocList.MDoc)+"  "+MDocList.Math+"|⮨  ⨧     ");

  oldCost:=L_MathR.GetKeyAssBalCostR(Memo.gl_me()+1, L_MathR.KA_All);
  oldWear:=L_MathR.GetKeyAssWearR   (Memo.gl_me()+1, L_MathR.KA_All);
  balWear:=L_MathR.GetKeyAssWearR   (Memo.gl_me()+1, L_MathR.KA_BalDepr);
  L_General.Assert(oldWear = balWear, MDocIdForMsg +
                                      "   "+Math.Math+"   "+L_DatTim.PeriodStr(Memo.gl_mb())+
                                      "| ᮢ ⨧  㬬 "+L_Money.MoneyToStr(Memo.gl_mb(), ",", oldWear-balWear)+
                                      L_StdFrm.HR() + "஢ ८業 "+
                                      "| ।⥫쭮  冷   ");

  revCost[curSrc]:=newCost-oldCost;
  revWear[curSrc]:=newWear-oldWear;
  revCost[prvSrc]:=0;
  revWear[prvSrc]:=0;

  IF    (newCost-newWear) > (oldCost-oldWear) THEN
   corAcCuts[curSrc]:=AcMthL.AcCut2;
   corAcCuts[prvSrc]:=EMPTYOF(AcMthL.AcCut);
  ELSIF (newCost-newWear) < (oldCost-oldWear) THEN
   corAcCuts[curSrc]:=L_Acnt.getAcMthL_AcCut(MDoc.Date);
   corAcCuts[prvSrc]:=AcMthL.AcCut2;

   prvRevl:=Math.Min(L_MathR.RemaindersR(Memo.gl_me()+1, AcMthL.AcCut2, L_Acnt.ct_Debit), (oldCost-oldWear) - (newCost-newWear));

   revCost[prvSrc]:=-1 * (newCost-oldCost) * prvRevl / ((newCost-newWear) - (oldCost-oldWear));
   revWear[prvSrc]:=revCost[prvSrc]+prvRevl;
  ELSE
   L_General.Error(MDocIdForMsg+" १ ८業 筠 ⮨  "+Math.Math+"  |஢ ८業 ");
  END;
  DEC(revCost[curSrc], revCost[prvSrc]);
  DEC(revWear[curSrc], revWear[prvSrc]);

  FOR_EACH srcIdx DO
   IF corAcCuts[srcIdx]=AcMthL.AcCut2 THEN (* 83 *)
    corAcMthOrigin:=AcMthL.Origin2;
   ELSE                                    (* 91 , ஢   ⮫쪮 ᫨ 祭  ஢,  - ஭*)
    IF L_XObj.E_DoSecondSide(Memo.gl_mb()) THEN
     corAcMthOrigin:=AcMthL.Origin1;
    ELSE
     SETEMPTY(corAcMthOrigin);
    END;
   END;
   IF revCost[srcIdx] # 0 THEN
    L_General.Assert(oldCost # 0, MDocIdForMsg+"⮨  "+Math.Math+"   ८業 ࠢ 0.00|஢ ८業 ");
    E_Stock.GetKeyAssBalCostAcCuts(Memo.gl_mb(), arrAcCuts, L_MathR.KA_All, L_MathR.KA_All, L_MathR.KA_All);
    intRevaluation(revCost[srcIdx], arrAcCuts, L_Acnt.ct_Credit, corAcMthOrigin, corAcCuts[srcIdx]);
   END;
   IF revWear[srcIdx] THEN
    L_General.Assert(oldWear # 0, MDocIdForMsg+"⨧  "+Math.Math+"   ८業 ࠢ 0.00|஢ ८業 ");
    E_Stock.GetKeyAssWearAcCuts   (Memo.gl_mb(), arrAcCuts, L_MathR.KA_All, L_MathR.KA_All, L_MathR.KA_All);
    intRevaluation(revWear[srcIdx], arrAcCuts, L_Acnt.ct_Debit, corAcMthOrigin, corAcCuts[srcIdx]);
   END;
  END;
 END {८業};

 PROCEDURE 鏥ਮ뎑();
  VAR
   totCost,
   totDepr,
   totRem,
   totSum    : L_XObj.tSum;
   trgAcCuts : L_MathR.tMathAcCutCollection;
 BEGIN
  CONFORM(AcMthL, Apport);
  totRem:=L_MathR.RemaindersR(Memo.gl_mb(), AcMthL.AcCut, L_Acnt.ct_Debit);

  E_Stock.GetKeyAssBalCostAcCuts(Memo.gl_mb(), trgAcCuts, L_MathR.KA_All, L_MathR.KA_All, L_MathR.^(AcMthL.RulePar));
  totCost:=L_MathR.GetKeyAssAcCutCollectionRemaindersR(Memo.gl_mb(), trgAcCuts, L_Acnt.ct_Credit);
 
  IF ~!trgAcCuts[0] (* ࠧ१  ⮨*) THEN
IF L_XObj.E_DoSecondSide(Memo.gl_mb()) THEN
 L_General.SetupRequired();
END;
   E_Stock.GetKeyAssWearAcCuts(Memo.gl_mb(), trgAcCuts, L_MathR.KA_All, L_MathR.KA_All, L_MathR.^(AcMthL.RulePar));
   L_General.CallUs(~!trgAcCuts[0] & !trgAcCuts[1]); (*  ஢  ࠧ१  ⨧樨*)
   totDepr:=L_MathR.RemaindersR(Memo.gl_mb(), trgAcCuts[0], L_Acnt.ct_Debit);

   L_General.Assert(totRem = (totCost-totDepr), "줮  ࠧ१ "+AcMthL.AcCut+"  ࠢ|ᮮ⢥饩 筮 ⮨");

   totSum:=0;
   L_MathR.AccessKeyAssXObject();
   SELECT(XApport, WFD, , XObject.XObject, trgAcCuts[0], Memo.gl_mb());
   WHILE OCCURE(XApport) DO
    IF (XApport.Source = L_XObj.src_Amortisation) & (XApport.Sum # 0) THEN
     CONFORM(XApport, Apport);
     IF Apport.CirType = L_Acnt.ct_Credit THEN
      INC(totSum, XApport.Sum);
     ELSE
      DEC(totSum, XApport.Sum);
     END;
    END;
    NEXT(XApport);
   END; (* WHILE OCCURE(XApport) ... *)

   IF totSum # 0 THEN
    L_MathR.KeyAssMakeCir(+1, AcMthL.AcCut, AcMthL.Apport,
                          AcMthL.AcCut2,
                          totSum, L_XObj.src_Amortisation);
   END;
  END;
 END {鏥ਮ뎑};

 PROCEDURE _ோ();
 BEGIN
  L_Acnt.MakeStandartCir(_s, L_Acnt.cs_MDoc);
  CONFORM(MDoc, Staff);
  L_General.Assert(Staff.MyFirm = MDoc.MyFirm, "' ࣠樨'  㬥  㤮  ࠡ⭨ ࠧ");
  L_PRoll.DedDone_AP(Math.Max(L_DatTim.Per(MDoc.Date), L_PRoll.Salary_ClcPer()), 0);
 END {_ோ};

BEGIN
 SETEMPTY(室_㬬, NextRule);
END.
