(*
%Copyright   (c) Polak IT
%Author      04.04.2003 13:01:58 POLAK\SAN
%Purpose     ஫ 䨪樨 ᮮ饭
%Type        control
%Specific    SYS
%Modified    19.09.2014 10:40:54 POLAK\Gina
%Environment
*)

 MODULE Message [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Events, L_General, L_Msg, L_lsStore, L_Str, L_DatTim, L_SysLog,
        FIO, L_AR, Str, DBD, L_DBD, L_WDO, L_StdFrm, L_Guard;

 PRIVATE PROCEDURE Message_OnInitializeWindow();
 BEGIN
  IF RTI.Get().CurWindow.Name = "Message" THEN
   L_General.AdminOnly();
  END;
  L_WDO.iEvents      (1, [L_WDO.e_OnReposition]);
  L_WDO.iSubwindow   (1, "MessageE");
  L_WDO.iField       (0, "MessageType1").Format:="ࠢ⥫|⥫";
  L_WDO.iField       (0, "MessageType2").Format:="⥫|ࠢ⥫";
  L_WDO.iField       (0, "hasNext_lsStore").Format:=L_lsStore.hasNext_Pool;
  L_WDO.iField       (0, "v_MessageText").LineBreakEnable:=1;
  L_WDO.iField       (1, "Message.Kind").Format:=L_Msg.mk_Pool_Short;
  L_WDO.iField       (1, "Message.Message").ReverseSorting:=1;
 END {Message_OnInitializeWindow};

 PRIVATE PROCEDURE Message_1_OnReposition();
 BEGIN
  IF ACCESS(Message) THEN
   RTI.Get().CurWindow.Zones(0).Fields("recMsgStr").Value:=L_Msg.LinkRecordDescription();
  ELSE
   RTI.Get().CurWindow.Zones(0).Fields("recMsgStr").Value:="";
  END;
 END {Message_1_OnReposition};

 PRIVATE PROCEDURE Message_OnBeforeInsert();
  VAR
   _Rsp     : LIKE(Message.Rsp);
   _Parent  : LIKE(Message.Parent);
   _FileId  : LIKE(Message.FileId);
   _RecordId: LIKE(Message.RecordId);
   s,
   _Text    : STRING[];
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF ~!L_WDO.AccessEnvVar("ItsReplyTo") THEN
   SAVE(Message);
   L_General.CallUs(SEARCH(Message, Message, L_WDO.GetEnvVarValue("ItsReplyTo")));
   _Rsp     :=Message.Rsp;
   _Parent  :=Message.Org;
   _FileId  :=Message.FileId;
   _RecordId:=Message.RecordId;
   _Text    :=L_lsStore.Get(Message.Text);
   _Text    :=L_Str.CRLF + "---- 室 ᮮ饭  " + Message.Org + " " +
                         L_DatTim.TimestampStr(Message.DTS) + " ----" +
              L_Str.CRLF +  _Text;
   IF Message.Status = L_Msg.ms_Unread THEN
    L_Msg.ToggleMessageStatus();
   END;
   RESTORE(Message);
   Message.Rsp     :=_Rsp;
   Message.Parent  :=_Parent;
   Message.FileId  :=_FileId;
   Message.RecordId:=_RecordId;
   Message.Text    :=L_lsStore.Replace(Message.Text, _Text);
   Fields("Message.IsGroup").Modifiable:=0;
   Fields("Message.Rsp").Modifiable:=0;
   Fields("v_MessageText").First:=1;
   Fields("Message.Rsp").First:=0;
  ELSIF ~!L_WDO.AccessEnvVar("toLogin") THEN
   Message.Rsp     :=L_WDO.GetEnvVarValue("toLogin");
   Fields("Message.IsGroup").Modifiable:=1;
   Fields("Message.Rsp").Modifiable:=1;
   Fields("v_MessageText").First:=1;
   Fields("Message.Rsp").First:=0;
  ELSIF ~!L_WDO.AccessEnvVar("toSelf") THEN
   Message.Rsp     :=L_General.curUSER;
   Fields("Message.IsGroup").Modifiable:=0;
   Fields("Message.Rsp").Modifiable:=0;
   Fields("v_MessageText").First:=1;
   Fields("Message.Rsp").First:=0;
  ELSE
   Fields("Message.IsGroup").Modifiable:=1;
   Fields("Message.Rsp").Modifiable:=1;
   Fields("v_MessageText").First:=0;
   Fields("Message.Rsp").First:=1;
  END;
  Fields("v_MessageText").Modifiable:=1;
  IF ~!L_WDO.AccessEnvVar("recFile") THEN
   Message.FileId  :=STRTOFLD(L_WDO.GetEnvVarValue("recFile"), SCAL);
   Message.RecordId:=STRTOFLD(L_WDO.GetEnvVarValue("recRecordId"), SCAL);
   RTI.Get().CurWindow.Isolated:=FORM_WINDOW.Isolated_Out;
  ELSE
   RTI.Get().CurWindow.Isolated:=FORM_WINDOW.Isolated_Off;
  END;
  IF ~!L_WDO.AccessEnvVar("Text") THEN
   Message.Text    :=L_lsStore.Replace(Message.Text, L_WDO.GetEnvVarValue("Text"));
  END;
  IF ~!L_WDO.AccessEnvVar("WatchInvite") THEN
   Fields("Message.IsGroup").Modifiable:=0;
   Fields("Message.Rsp").Modifiable:=0;
   Message.Kind    :=L_Msg.mk_WatchInvite;
   Message.ShowDTS :=L_Msg.TruncDTS(SYSTIMESTAMP() + 10/60/24);
   Message.Text    :=L_lsStore.Replace(Message.Text,
                                       L_Msg.CombineWatchInviteMsgText(APP.Get().MyConnection.Number, 0, ""));

  ELSIF Message.Rsp # L_General.curUSER THEN
   Message.Kind    :=L_Msg.mk_Usual;
   Message.ShowDTS :=L_Msg.TruncDTS(SYSTIMESTAMP());
  ELSE
   Message.Kind    :=L_Msg.mk_Note;
   SETEMPTY(Message.ShowDTS);
  END;
  Message.IsGroup:=0;
  Message.Type   :=L_Msg.mt_Org;
  Message.Blng   :=L_General.curUSER;
  Message.DTS    :=SYSTIMESTAMP();
  Message.Imp    :=L_Msg.mi_Normal;
  Message.Status :=L_Msg.ms_Unread;
  REPLACE(Message);
  FIX_ALTERING();
 END {Message_OnBeforeInsert};

 PRIVATE PROCEDURE Message_OnBeforeEdit();
 BEGIN
  L_General.Assert(Message.Blng = L_General.curUSER, "   ᮮ饭");
  L_General.Assert(Message.Status = L_Msg.ms_Unread, "饭 㦥 ⠭");
  L_General.Assert(Message.Kind # L_Msg.mk_WatchInvite, " ᮮ饭   饭");
  IF    Message.Type = L_Msg.mt_Org THEN
   L_General.Assert((Message.Kind = L_Msg.mk_Usual) | (Message.Kind = L_Msg.mk_Note),
                    " ᮮ饭   饭");
  END;
  IF ~!Message.ShowDTS THEN
   Message.ShowDTS:=L_Msg.TruncDTS(Message.ShowDTS);
   REPLACE(Message);
  END;
 END {Message_OnBeforeEdit};

 PRIVATE PROCEDURE Message_OnAfterEdIns();
  VAR
   Txt   : STRING[];
   Fields: FORM_FIELDS;
 BEGIN
  IF   Message.Kind = L_Msg.mk_WatchInvite THEN
   Fields:=RTI.Get().CurZone.Fields;
   Txt:=L_Msg.CombineWatchInviteMsgText(Fields("ConnNo").Value,
                                        Fields("Control").Value,
                                        Fields("v_MessageText").Value);
   Message.Text:=L_lsStore.Replace(Message.Text, Txt);
   REPLACE(Message);
  ELSE
   Message.Text:=L_lsStore.Replace(Message.Text, RTI.Get().CurWindow.ActiveZone.Fields("v_MessageText").Value);
   IF   Message.Kind = L_Msg.mk_Note THEN
    IF !Message.ShowDTS THEN
     L_StdFrm.Inform('⠭ ﭨ "⠭", .. ப  ⪨  㪠');
     Message.Status:=L_Msg.ms_Read;
    END;
   END;
   IF Message.Status = L_Msg.ms_Unread THEN
    SETEMPTY(Message.ViewDTS);
   END;
   REPLACE(Message);
  END;
 END {Message_OnAfterEdIns};

 PRIVATE PROCEDURE Message_OnAfterEdit();
 BEGIN
  Message_OnAfterEdIns();
 END {Message_OnAfterEdit};

 PRIVATE PROCEDURE Message_OnAfterInsert();
 BEGIN
  Message_OnAfterEdIns();
  IF Message.Kind # L_Msg.mk_Note THEN
   L_Msg.MakeMessageDuplicate(0);
   L_Msg.NotifyCurMessage(0);
  END;
  IF ~!L_WDO.AccessEnvVar("RunAfter") THEN
   LIKEMENU(RunProg, L_WDO.GetEnvVarValue("RunAfter"));
  END;
 END {Message_OnAfterInsert};

 PRIVATE PROCEDURE Message_OnBeforeDelete();
 BEGIN
  L_General.Assert((Message.Kind = L_Msg.mk_Usual) | (Message.Kind = L_Msg.mk_Note),
                   '饭 㤠 ᮮ饭  "'+L_Str.PoolItem(L_Msg.mk_Pool, Message.Kind)+'"');

  L_General.Assert(Message.Blng = L_General.curUSER, "   ᮮ饭");
  IF Message.Kind = L_Msg.mk_Usual THEN
   L_General.Assert(Message.Type = L_Msg.mt_Org,      " 室饥 ᮮ饭, 㤠 饭");
   L_General.Assert(Message.Status = L_Msg.ms_Unread, "饭 㦥 ⠭, 㤠 饭");
   SAVE(Message);
   L_General.CallUs(SELECT(Message, Org, Message.Message));
   WHILE OCCURE(Message) DO
    L_General.Assert(Message.Status = L_Msg.ms_Unread, "饭 㦥 ⠭, 㤠 饭");
    REMOVE(Message);
   END; (* WHILE OCCURE(Message) ... *)
   RESTORE(Message);
  END;
 END {Message_OnBeforeDelete};

 PRIVATE PROCEDURE SetMessageIsGroupOwnerWindow();
 BEGIN
  IF OCCURE(Message) & Message.IsGroup THEN
   RTI.Get().CurWindow.ActiveZone.Fields("Message.Rsp").OwnerWindowOriginalName:="aoGroup";
  ELSE
   RTI.Get().CurWindow.ActiveZone.Fields("Message.Rsp").OwnerWindowOriginalName:="aoUser";
  END;
 END {SetMessageIsGroupOwnerWindow};

 PRIVATE PROCEDURE Message_IsGroup_OnSuccessfulChange();
 BEGIN
  SetMessageIsGroupOwnerWindow();
  SETEMPTY(Message.Rsp);
  REPLACE(Message);
 END {Message_IsGroup_OnSuccessfulChange};

 PRIVATE PROCEDURE Message_Rsp_OnSuccessfulChange();
 BEGIN
  IF ~!Message.Rsp THEN
   SEARCH(AcsObj, AcsObj, , Message.Rsp);
   Message.IsGroup:=(AcsObj.Type = L_AR.aot_Group);
   L_General.Assert(~L_Msg.AcsObjIsRobot(Message.Rsp),
                    "짮⥫ " + Message.Rsp + " - ஡.     ⮬ ᮮ饭");
   SELECT(AOMem, AcsObj2, , Message.Rsp);
   WHILE OCCURE(AOMem) DO
    CONFORM(AOMem, AcsObj);
(* L_APtm.g_EndUser   ᯮ짮 - .0104179 *)
    L_General.Assert(~L_Str.IsEqStrI(AcsObj.NAME, "END_USER"), "ଠ樮     ⮬ ᮮ饭");
    NEXT(AOMem);
   END; (* WHILE OCCURE(AOMem) ... *)

   IF Message.Rsp = L_General.curUSER THEN
    Message.Kind:=L_Msg.mk_Note;
    IF Message.ShowDTS < SYSTIMESTAMP() THEN
     SETEMPTY(Message.ShowDTS);
    END;
   ELSE
    Message.Kind    :=L_Msg.mk_Usual;
    IF !Message.ShowDTS THEN
     Message.ShowDTS:=L_Msg.TruncDTS(SYSTIMESTAMP());
    END;
   END;
   REPLACE(Message);
  END;
 END {Message_Rsp_OnSuccessfulChange};

 PRIVATE PROCEDURE MessageE_OnInitializeWindow();
  VAR
   v    : SCAL[2];
 BEGIN
  v:=DBD.BaseName() = "JOURNAL";
  L_WDO.iWindow().MNUFileName:="Message";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iField       (0, "v_MessageText").LineBreakEnable:=1;
  L_WDO.iScsChange   (0, ["Message.IsGroup", "Message.Rsp"]);
  L_WDO.iUnmodifiable(0, ["ShowDTSTitle", "ImpTitle", "recMsgStr", "Message.Status", "Message.DTS",
                          "Message.Blng", "asType2", "asType1", "Message.Kind", "asIsGroup2",
                          "ConnNoTitle", "ControlTitle", "ConnNo"]);
  L_WDO.iMayBeEmpty  (0, ["Message.ShowDTS"]);
  L_WDO.iField       (0, "Message.Status").Format:=L_Msg.ms_Pool;
  L_WDO.iField       (0, "Message.Imp").Visible:=v;
  L_WDO.iField       (0, "Message.Imp").Format:=L_Msg.mi_Pool;
  L_WDO.iField       (0, "ShowDTSTitle").Expression:="Message.Kind";
  L_WDO.iField       (0, "ShowDTSTitle").Format    :=L_Msg.ShowDTSTitle_Pool;
  L_WDO.iField       (0, "ImpTitle").Visible:=v;
  L_WDO.iField       (0, "ImpTitle").Value:="";
  L_WDO.iField       (0, "Message.Kind").Format:=L_Msg.mk_Pool;
  L_WDO.iField       (0, "asType1").Format:="⥫|ࠢ⥫";
  L_WDO.iField       (0, "asType2").Format:="ࠢ⥫|⥫";
  L_WDO.iField       (0, "ConnNoTitle").Value :="祭";
  L_WDO.iField       (0, "ControlTitle").Value:=" ਣ襭";
  L_WDO.iField       (0, "Control").Format:=L_Msg.cntrl_Pool;
 END {MessageE_OnInitializeWindow};

 PRIVATE PROCEDURE MessageE_0_OnReposition();
  VAR
   Fields: FORM_FIELDS;
   Dummy : STRING[];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("recMsgStr").Value:=L_Msg.LinkRecordDescription();
  IF Message.Kind = L_Msg.mk_WatchInvite THEN
   L_Msg.SliceWatchInviteMsgText(Fields("ConnNo").Value, Fields("Control").Value, Fields("v_MessageText").Value);
  ELSIF Message.Kind = L_Msg.mk_Cmd THEN
   L_Msg.SliceCmdMsgText(Dummy, Dummy, Fields("v_MessageText").Value);
  ELSE
   Fields("v_MessageText").Value:=L_lsStore.Get(Message.Text);
  END;
  Fields("ConnNo").Visible      :=Message.Kind = L_Msg.mk_WatchInvite;
  Fields("ConnNoTitle").Visible :=Message.Kind = L_Msg.mk_WatchInvite;
  Fields("Control").Visible     :=Message.Kind = L_Msg.mk_WatchInvite;
  Fields("ControlTitle").Visible:=Message.Kind = L_Msg.mk_WatchInvite;

  IF RTI.Get().CurProcess.Kind # FORM_PROCESS.Kind_Insert THEN
   Fields("v_MessageText").Modifiable:=Message.Type = L_Msg.mt_Org;
   Fields("v_MessageText").First:=Message.Type = L_Msg.mt_Org;
   Fields("Message.IsGroup").Modifiable:=0;
   Fields("Message.Rsp").Modifiable:=0;
   Fields("Message.Rsp").First:=0;
  END;
  IF Message.Type = L_Msg.mt_Org THEN
   Fields("Message.IsGroup").Format:=L_AR.aot_Pool;
  ELSE
   Fields("Message.IsGroup").Format:="짮⥫|짮⥫";
  END;
  SetMessageIsGroupOwnerWindow();
 END {MessageE_0_OnReposition};

 PRIVATE PROCEDURE Msg_My_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Message";
  L_WDO.iZone        (0).ParentZone:=L_WDO.iZone(1);
  L_WDO.iField       (0, "hasNext_lsStore").Format:=L_lsStore.hasNext_Pool;
  L_WDO.iField       (0, "lsStore.Value").LineBreakEnable:=1;
  L_WDO.iField       (1, "Message.Kind").Format:=L_Msg.mk_Pool_Short;
  L_WDO.iEvents      (1, [L_WDO.e_OnReposition, L_WDO.e_OnOpenZone]);
  L_WDO.iZone        (1).Narrowing:="Message.Blng=L_General.curUSER";
  L_WDO.iZone        (1).PermanentFilter:="(Message.Kind#"+L_Str.IntStr(L_Msg.mk_SystemNote)+")" + "&" +
                                          "(Message.Kind#"+L_Str.IntStr(L_Msg.mk_ShownTrouble)+")";
  L_WDO.iSubwindow   (1, "MessageE");
  L_WDO.iField       (1, "Message.Message").ReverseSorting:=1;
  L_WDO.iField       (1, "Message.Type").Format:=" > |";
  L_WDO.iZone        (2).ViewOnly:=1;
 END {Msg_My_OnInitializeWindow};

 PRIVATE PROCEDURE Msg_My_1_OnReposition();
  VAR
   curWin : FORM_WINDOW;
 BEGIN
  curWin:=RTI.Get().CurWindow;
  IF ACCESS(Message) THEN
   curWin.Zones(0).Fields("recMsgStr").Value:=L_Msg.LinkRecordDescription();
   SETSEL(Message, Org, Message.Message);
  ELSE
   SETSEL(Message, Message, "");
  END;
  SE_WZD_CURSOR(curWin.Name, 2, Message);
 END {Msg_My_1_OnReposition};

 PRIVATE PROCEDURE Msg_My_1_OnZoneOpen();
  VAR
   curWin: FORMWINDOW;
 BEGIN
  curWin:=RTI.Get().CurWindow;
  IF SELECT(Message, Blng, L_General.curUSER, L_Msg.ms_Unread, L_Msg.mt_Dup) THEN
   CHANGESEL(Message, Blng, , L_General.curUSER);
   SE_WZD_CURSOR(curWin.Name, 1, Message);
  ELSE
   SE_WZD_CURSOR(curWin.Name, 1);
   IF ~SELECT(Message, Blng, L_General.curUSER) THEN
    (*GAV: ᫨ ᮮ饭  , OnReposition  ந室*)
    Msg_My_1_OnReposition();
   END;
  END;
 END {Msg_My_1_OnZoneOpen};

 PUBLIC PROCEDURE Notify();
 BEGIN
  ACCESS(Message);
  IF Message.Type = L_Msg.mt_Org THEN
   IF Message.Status = L_Msg.ms_Unread THEN
    L_Msg.NotifyCurMessage(0);
    L_StdFrm.Inform(" 믮");
   ELSE
    L_General.Error("饭 㦥 ⠭ 짮⥫");
   END;
  ELSE
   L_General.Error("  ⮫쪮  室騬 ᮮ饭");
  END;
 END {Notify};

 PUBLIC PROCEDURE ToggleStatus();
 BEGIN
  ACCESS(Message);
  IF    Message.Type = L_Msg.mt_Org THEN
   L_General.Assert(Message.Rsp = L_General.curUSER, "   ⥫ ⮣ ᮮ饭");
   IF Message.Rsp # Message.Blng THEN
    L_General.CallUs(SELECT(Message, Org, Message.Message, L_General.curUSER));
   END;
  ELSIF Message.Type = L_Msg.mt_Dup THEN
   L_General.Assert(Message.Blng = L_General.curUSER, "   ⥫ ⮣ ᮮ饭");
  ELSE
   L_General.Error(" ﭨ ⥬ ᮮ饭  ।ᬮ७");
  END;
  L_Msg.ToggleMessageStatus();
 END {ToggleStatus};

 PUBLIC PROCEDURE Reply();
 BEGIN
  ACCESS(Message);
  L_General.Assert((Message.Kind = L_Msg.mk_Usual) | (Message.Kind = L_Msg.mk_CrucialChoice),
                   '饭 ⢥  ᮮ饭  "'+L_Str.PoolItem(L_Msg.mk_Pool, Message.Kind)+'"');
  IF Message.Type = L_Msg.mt_Dup THEN
   L_General.Assert(Message.Blng = L_General.curUSER, "   ⥫ ⮣ ᮮ饭");
  ELSE
   L_General.Assert(SELECT(Message, Org, Message.Message, L_General.curUSER),
                    "   ⥫ ⮣ ᮮ饭");
  END;
  L_General.Assert(SEARCH(AcsObj, AcsObj, Message.Rsp) &
                   L_DatTim.IsActive(SYSDATE(), AcsObj.Begin, AcsObj.Till), " ⢥");
  LIKEMENU(Ins, "@ ItsReplyTo=" + Message.Message);
 END {Reply};

 CONST
  TxtDepth = 4096;

(*
$P{ Top:
Message.Message, L, ""
Message.Type, L, L_Msg.mt_Pool_Short
Message.DTS, L, "D.N.y H:M"
Message.Imp, L, L_Msg.mi_Pool
Message.Status, L, L_Msg.ms_Pool
Message.Type,  L, "|"
Message.Blng, L, ""
?, L, ""
Message.Type, L, "|"
Message.Rsp, L, ""
?, L, ""
@
       ६ ᮧ                           ﭨ
 ######### ### ################                      ########## ###################
 ####
 ##### ################################################################################################
 ####
 ##### ################################################################################################
}
*)

 PUBLIC PROCEDURE TypeMessage();
 VAR
  i,
  Cnt      : NUMERIC[0];
  TxtArray : STRING[][TxtDepth];
  TxtLength: NUMERIC[0];
  RspLogin,
  BlngLogin: STRING[];
 BEGIN
  GE_APPWIN_SIZE(TxtLength);
  DEC(TxtLength, 2);
  ACCESS(Message);
  OPENREP(R, L_General.NameConnection("MsTxt"), Create);
  IF SEARCH(AcsObj, AcsObj, Message.Blng) THEN
   BlngLogin:=AcsObj.Name + " " + AcsObj.FullName;
  ELSE
   SETEMPTY(BlngLogin);
  END;
  IF !Message.Rsp THEN
   RspLogin:=" ⮬⨧樨 (᥮ꥬ饥   ࠧࠡ⪥)";
  ELSIF SEARCH(AcsObj, AcsObj, Message.Rsp) THEN
   RspLogin:=AcsObj.Name + " " + AcsObj.FullName;
  ELSE
   SETEMPTY(RspLogin);
  END;
  MAKEPART(R, Top, BlngLogin, RspLogin);
 
  FIO.WrStr(R, L_Str.Repeat("", TxtLength));
  FIO.WrLn(R);
  L_Str.SplitStr(TxtArray, L_lsStore.Get(Message.Text), TxtLength, TxtDepth);
  i:=0;
  Cnt:=0;
  WHILE i < TxtDepth DO
   IF ~!TxtArray[i] THEN
    Cnt:=i;
   END;
   INC(i);
  END;
  i:=0;
  WHILE i <= Cnt DO
   FIO.WrStr(R, TxtArray[i]);
   FIO.WrLn(R);
   INC(i);
  END;
  CLOSEREP(R);
  LIKEMENU(Survey, "");
 END {TypeMessage};

 PUBLIC PROCEDURE PutMessage_w_recMsg(toSelf: SCAL[2]);
  VAR
   Link,
   cooFile,
   FileName: STRING[];
   i       : NUMERIC[0];
   FileId  : LIKE(Message.FileId);
   RecordId: LIKE(Message.RecordId);
 BEGIN
  FileName:=GE_CURFILE();
  L_General.Assert(~!FileName & ACCESS(^FileName), " ⠭ ,   뫠");

  L_General.Assert(L_Msg.GetCurRecId(FileName, FileId, RecordId),
                   ' 뫠   䠩|"' + DBD.FileDescription(^FileName) +
                   '"| ॠ');
  LIKEMENU(Ins, "MessageE 0 @ recFile=" + L_Str.IntStr(FileId) + " recRecordId=" + RecordId +
                L_Str.PoolItem(" | toSelf=1", toSelf));
 END {PutMessage_w_recMsg};
 
 PRIVATE PROCEDURE MessageE_OnConformToWindow();
 BEGIN
  IF ~ACCESS(Message) THEN
   SELECT(Message, Message);
  END;
  SE_WWD_CURSOR("MessageE", Message);
 END {MessageE_OnConformToWindow};

 PUBLIC PROCEDURE ShowCurRecMessages();
  CONST
   WindowName = "Message";
  VAR
   fw      : FORMWINDOW;
   FileName: STRING[];
 BEGIN
  FileName:=GE_CURFILE();
  L_General.Assert(~!FileName & ACCESS(^FileName), " ⠭ ");
  fw:=APPLICATION.Get().Forms.Load(WindowName, WindowName + "<" + FileName + ">");
  IF DBD.ProcessorVersion() >= 014208150 THEN
   fw.Isolated:=FORM_WINDOW.Isolated_Out;
  END;
  LIKEMENU(View, fw.Name + " 1 " + GE_CURWIN() + " " + L_Str.IntStr(GE_CURZONE()));
 END {ShowCurRecMessages};

 PRIVATE PROCEDURE Message_OnConformToWindow();
  VAR
   FileName: STRING[];
   FileId  : LIKE(Message.FileId);
   RecordId: LIKE(Message.RecordId);
 BEGIN
  FileName:=GE_CURFILE();
  L_General.Assert(ACCESS(^FileName), " ᮮ饭  뫪   㤥 ." +
                                      "|( ⥪饩  ⠡ )");
  L_General.Assert(L_Msg.GetCurRecId(FileName, FileId, RecordId),
                   ' 뫠   䠩|"' + DBD.FileDescription(^FileName) +
                   '"| ॠ');
  RTI.Get().ConformTargetWindow.Title:="饭  뫪   '" +
                                       L_SysLog.GetObjectDescription(FileName) + ": " +
                                       Str.Replace(L_DBD.GetPrimaryIndexValue(FileName), "|", ",") + "'";
  RTI.Get().ConformTargetWindow.Zones(0).Fields("recMsgStr").Value:=L_Msg.LinkRecordDescription();
  SETSEL(Message, RecordId, FileId, RecordId);
  SE_WWD_CURSOR(RTI.Get().ConformTargetWindow.Name, Message);
 END {Message_OnConformToWindow};

 PUBLIC PROCEDURE PositionInVideoSystem(MakeRead: SCAL[2]);
  VAR
   FTable: TABLE;
 BEGIN
  ACCESS(Message);
  IF MakeRead & (Message.Status = L_Msg.ms_Unread) THEN
   ToggleStatus();
  END;
  IF ~!Message.FileId & ~!Message.RecordId THEN
   FTable:=DATABASE.Get().TableById(Message.FileId);
   TRY [TABLE_FILTER_MODE(TABLE_FILTER_MODE_THROW)]
    L_General.Assert(SEARCH((FTable.Name), RECORDID, Message.RecordId),
                     "   " + Message.RecordId + "  䠩" +
                     "|" +
                     '"' + FTable.Description + '"');
    L_DBD.extPosToCurRecordOfTable(FTable);
   EXCEPT
   END; (* TRY *)
  ELSE
   L_StdFrm.Inform("饭 ⠭.||३  ꥪ , ..|ᮮ饭  ᮤন 뫪  ꥪ");
  END;
 END {PositionInVideoSystem};

 PUBLIC PROCEDURE WatchByInvite(MakeRead: SCAL[2]);
  VAR
   s        : STRING[];
   trgConnNo: LIKE(ccCnct.CnctNo);
   Control  : SCAL[2];
 BEGIN
  ACCESS(Message);
  IF MakeRead & (Message.Status = L_Msg.ms_Unread) THEN
   ToggleStatus();
  END;
  L_General.Assert(Message.Kind = L_Msg.mk_WatchInvite, "  ਣ襭");
  L_General.Assert((Message.Type = L_Msg.mt_Dup) & (Message.Blng = L_General.curUSER),
                   "   ⥫ ⮣ ਣ襭");
  L_General.Assert(Message.ShowDTS > SYSTIMESTAMP(), "ப ⢨ ਣ襭 㦥 ⥪");
  L_Msg.SliceWatchInviteMsgText(trgConnNo, Control, s);
  CALL(ccCnct.WatchByInvite(Control, trgConnNo, Message.Rsp));
 END {WatchByInvite};

 PUBLIC PROCEDURE DoCommandMessage(trgMessage: LIKE(Message.Message));
 BEGIN
  L_Msg.DoCommandMessage(trgMessage);
 END {DoCommandMessage};

 PUBLIC PROCEDURE SetShowDTS(t: FLOAT);
 BEGIN
  ACCESS(Message);
  IF t < 0 THEN
   SETEMPTY(Message.ShowDTS);
  ELSE
   Message.ShowDTS:=L_Msg.TruncDTS(SYSTIMESTAMP() + t / 24);
  END;
  REPLACE(Message);
 END {SetShowDTS};

 PUBLIC PROCEDURE scs_GetFilters_Message_1(VAR Filters: L_WDO.tFilters);
 BEGIN
  L_WDO.PutNewFilter(Filters, "쪮 ਣ", "(Message.Type = "+L_Str.IntStr(L_Msg.mt_Org)+")", 1);
 END {scs_GetFilters_Message_1};

 PUBLIC PROCEDURE scs_GetNarrowing_Msg_My_1(VAR NarrowingDescriptions: STRING[]);
 BEGIN
  NarrowingDescriptions:="室騥" +
                         "|⠭ 室騥" +
                         "|" +
                         "|⪨" +
                         "|  롮";
 END {scs_GetNarrowing_Msg_My_1};

 PUBLIC PROCEDURE scs_GetNarrowing_Message_1(VAR NarrowingDescriptions: STRING[]);
 BEGIN
  IF RTI.Get().CurWindow.AssignedName = "Message" THEN
   NarrowingDescriptions:="" +
                          "|⪨" +
                          "|  롮" +
                          "| ஡" ;
  END;
 END {scs_GetNarrowing_Message_1};

 PRIVATE PROCEDURE Message_SetNarrowing_By_BlngKind(trgKind: LIKE(Message.Kind));
 BEGIN
  GE_WZD_CURSOR("Msg_My", 1, Message);
  CHANGESEL(Message, BlngKind,  , L_General.curUSER, trgKind);
  IF (Message.Kind # trgKind) | (Message.Blng # L_General.curUSER) THEN
   SELECT(Message, BlngKind,  , L_General.curUSER, trgKind);
   LAST(Message);
  END;
 END {Message_SetNarrowing_By_BlngKind};

 PUBLIC PROCEDURE scs_SetNarrowing_Msg_My_1(SelectChoice: NUMERIC[0]);
 BEGIN
  IF    SelectChoice = 1 THEN
   GE_WZD_CURSOR("Msg_My", 1, Message);
   CHANGESEL(Message, BlngTDat,  , L_General.curUSER, L_Msg.mt_Dup);
   IF (Message.Blng # L_General.curUSER) | (Message.Type # L_Msg.mt_Dup) THEN
    SELECT(Message, BlngTDat,  , L_General.curUSER, L_Msg.mt_Dup);
    LAST(Message);
   END;
  ELSIF SelectChoice = 2 THEN
   GE_WZD_CURSOR("Msg_My", 1, Message);
   CHANGESEL(Message, Blng,      , L_General.curUSER, L_Msg.ms_Unread, L_Msg.mt_Dup);
   IF (Message.Blng # L_General.curUSER) | (Message.Status # L_Msg.ms_Unread) | (Message.Type # L_Msg.mt_Dup) THEN
    SELECT(Message, Blng,      , L_General.curUSER, L_Msg.ms_Unread, L_Msg.mt_Dup);
    LAST(Message);
   END;
  ELSIF SelectChoice = 3 THEN
   Message_SetNarrowing_By_BlngKind(L_Msg.mk_Usual);
  ELSIF SelectChoice = 4 THEN
   Message_SetNarrowing_By_BlngKind(L_Msg.mk_Note);
  ELSIF SelectChoice = 5 THEN
   Message_SetNarrowing_By_BlngKind(L_Msg.mk_CrucialChoice);
  END;
 END {scs_SetNarrowing_Msg_My_1};

 PRIVATE PROCEDURE Message_SetNarrowing_By_Kind(trgKind: LIKE(Message.Kind));
 BEGIN
  GE_WZD_CURSOR("Message", 1, Message);
  CHANGESEL(Message, Kind,  , trgKind);
  IF Message.Kind # trgKind THEN
   SELECT(Message, Kind,  , trgKind);
   LAST(Message);
  END;
 END {Message_SetNarrowing_By_Kind};

 PUBLIC PROCEDURE scs_SetNarrowing_Message_1(SelectChoice: NUMERIC[0]);
 BEGIN
  IF RTI.Get().CurWindow.AssignedName = "Message" THEN
   IF    SelectChoice = 1 THEN
    Message_SetNarrowing_By_Kind(L_Msg.mk_Usual);
   ELSIF SelectChoice = 2 THEN
    Message_SetNarrowing_By_Kind(L_Msg.mk_Note);
   ELSIF SelectChoice = 3 THEN
    Message_SetNarrowing_By_Kind(L_Msg.mk_CrucialChoice);
   ELSIF SelectChoice = 4 THEN
    Message_SetNarrowing_By_Kind(L_Msg.mk_FromRobot);
   END;
  END;
 END {scs_SetNarrowing_Message_1};

BEGIN
 L_Events.ExecuteHandler();
END.
