(*
%Copyright   (c) Polak IT
%Author      29.04.2011 14:20:45 POLAK\SSV
%Purpose      ४஢ ⭥ᥭ  ਮ ⮢  ௫
%Type        report
%Specific    SYS
%Modified    23.04.2013 16:52:44 POLAK\MLB
%Environment
*)

 IMPORT L_DatTim, P_Firm, L_General, L_Basis, FIO, Memo, L_bp, L_PRoll, L_Staff;

 PRIVATE PROCEDURE MakeHeader(F: STRING[]; wMF: SCAL[2]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;

  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ਮ");
  L_Basis.wb_WrInQM(F, "ਮ");
  L_Basis.wb_WrInQM(F, "㬬");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]; wMF: SCAL[2]);
 BEGIN
  L_General.CallUs(SEARCH(Money, RECORDID, eMoney.ori));
  CONFORM(Money, MCList);
  CONFORM(Money, Staff);
  CONFORM(Staff, Man);
  SEARCH(StaffLog, TSN, , Staff.TSN, Money.ODate);
  CONFORM(StaffLog, Officer);
  CONFORM(Officer, Union);
  CONFORM(Officer, Sort);
  CONFORM(Officer, Post);

  IF wMF THEN
   CONFORM(Staff, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrScl(F, Union.Union);
  L_Basis.wb_WrStr(F, Union.Name);
  L_Basis.wb_WrScl(F, L_Staff.getDepart());
  L_Basis.wb_WrStr(F, L_Staff.getDepartName());
  L_Basis.wb_WrScl(F, Officer.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrScl(F, Post.Post);
  L_Basis.wb_WrStr(F, Post.Name);
  L_Basis.wb_WrScl(F, Officer.Officer);
  L_Basis.wb_WrScl(F, MCList.MCode);
  L_Basis.wb_WrStr(F, MCList.Name);
  L_Basis.wb_WrDat(F, Money.Closed);
  L_Basis.wb_WrDat(F, eMoney.ClcPer);
  L_Basis.wb_WrNum(F, Money.Sum, 2);
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PUBLIC PROCEDURE MFAcc();
  CONST
   bpId = "MFAcc";
  VAR
   wMF  : SCAL[2];
   From,
   UpTo : DATE;
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_bp.Begin(bpId, " ४஢ ⭥ᥭ  ਮ ⮢  ௫", L_bp.t_Basis, L_General.tc_inIntvl);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  MakeHeader("R", wMF); 
  From:=Memo.ud_fr();
  UpTo:=Memo.ud_ut();
  L_DatTim.CheckWMIntvl(From, UpTo);

  SELECT(eMoney, TSN);
  WHILE OCCURE(eMoney) DO
   PROMPT(eMoney.TSN);
   NARROWSEL(eMoney, TSN, Type);
   IF (eMoney.Type = L_PRoll.et_ManSFee) & SRCINSEL(eMoney, GE, From) THEN
    WHILE OCCURE(eMoney) & (eMoney.ClcPer <= UpTo) DO
     MakePart("R", wMF);
     NEXT(eMoney);
    END;
   END;
   NEXTINEXTENDEDSEL(eMoney, TSN, Type);
  END;
  FIO.Close(R);
  L_bp.End();
 END {MFAcc};

END.