(*
%Copyright   (c) Polak IT
%Author      21.03.2007 17:20:38 POLAK\GAV
%Purpose     ᪨ 
%Type        report
%Specific    SYS
%Modified    17.06.2014 22:47:21 POLAK\Gina
%Environment
*)

 MODULE MnMlt [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_Basis, L_Man, L_ManMlt, FIO, L_Staff, L_Str, L_DatTim, L_Russia,
        L_bp, L_Env, E_Utils;

 PRIVATE PROCEDURE MakeTop();
 BEGIN
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "⠏ਥ");
  L_Basis.wb_WrInQM("F", "⠓쭥");
  L_Basis.wb_WrInQM("F", "ਭ");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", " ");
  L_Basis.wb_WrInQM("F", "⠐");
  L_Basis.wb_WrInQM("F", " 㤮 ");
  L_Basis.wb_WrInQM("F", " ॣ樨");
  L_Basis.wb_WrInQM("F", " 䠪᪨");
  L_Basis.wb_WrInQM("F", " ");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "⥣");
  L_Basis.wb_WrInQM("F", "⥣");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "⠢");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "㬥");
  L_Basis.wb_WrInQM("F", "।ᠭ");
  L_Basis.wb_WrInQM("F", "஭஢");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "⮨  ");
  L_Basis.wb_WrInQM("F", "   ");
  L_Basis.wb_WrInQM("F", "   ");
  L_Basis.wb_WrInQM("F", "஭㥬");
  L_Basis.wb_WrInQM("F", "ਧ뢭");
  L_Basis.wb_WrInQM("F", " ");
  L_Basis.wb_TermLine("F");
 END {MakeTop};

 PRIVATE PROCEDURE E_MustBeReserved(D: DATE): STRING[];
  VAR
   local : PROC;
   Result: STRING[];
 BEGIN
  local:=PROCREF(E_Utils.MnMlt_MustBeReserved);
  IF !local THEN
   Result:="  ஥.   ࠧࠡ稪";
  ELSE
   Result:=L_Str.PoolItem("|", local(D));
  END;
  RETURN Result;
 END {E_MustBeReserved};

 PRIVATE PROCEDURE MakeLine(BPer, EPer: DATE);
  VAR
   DocAttr: STRING[];
   Age    : NUMERIC[0];
 BEGIN
  Age:=L_DatTim.YearsInIntvl(Man.Birth, EPer);
  L_ManMlt.GetManMltActualStatus(Man.Man, EPer);
  L_Basis.wb_WrScl("F", Staff.TSN);
  L_Basis.wb_WrStr("F", Man.Name);
  L_Basis.wb_WrStr("F", L_Man.GetManSex_asStr());
  L_Basis.wb_WrDat("F", L_Man.GetTakeOnDate(EPer));
  L_Basis.wb_WrDat("F", L_Man.GetRealEndDate(EPer));
  L_Basis.wb_WrStr("F", L_Str.PoolItem("|", L_DatTim.IsActive_Inc(L_Man.GetTakeOnDate(EPer),  BPer, EPer)));
  L_Basis.wb_WrStr("F", L_Str.PoolItem("|", L_DatTim.IsActive_Inc(L_Man.GetRealEndDate(EPer), BPer, EPer)));
  L_Basis.wb_WrStr("F", L_Str.PoolItem("|", L_Staff.rInState(EPer)));
  L_Basis.wb_WrDat("F", Man.Birth);
  L_Basis.wb_WrStr("F", L_Staff.GetStaffContract_asStr());
  L_Man.AccessRgManAdr(Man.Man, EPer);
  L_Basis.wb_WrStr("F", L_Man.GetPostAdr_asStr(L_Russia.af_Short));
  L_Basis.wb_WrStr("F", L_Man.GetAdr_asShortStr(Man.Man, EPer, L_Russia.at_DwMA));
  L_Basis.wb_WrStr("F", L_Man.GetManFmlState_asStr());
  L_Basis.wb_WrScl("F", Sort.Sort);
  L_Basis.wb_WrStr("F", Sort.Name);
  L_Basis.wb_WrScl("F", Post.Post);
  L_Basis.wb_WrStr("F", Post.Name);
  L_Basis.wb_WrScl("F", StaffLog.Class);
  L_Basis.wb_WrScl("F", Union.Union);
  L_Basis.wb_WrStr("F", Union.Name);
  L_Basis.wb_WrStr("F", L_ManMlt.mmas_SpecC);
  L_Basis.wb_WrStr("F", L_ManMlt.mmas_Spec);
  IF ~!L_ManMlt.mmas_MltRank THEN
   SEARCH(MltRank, MltRank, , L_ManMlt.mmas_MltRank);
   L_Basis.wb_WrStr("F", L_ManMlt.GetRealComposit_asStr(MltRank.Composit, MltRank.RankType));
   L_Basis.wb_WrStr("F", MltRank.Name);
  ELSE
   L_Basis.wb_WrStr("F", "-----");
   L_Basis.wb_WrStr("F", "-----");
  END;
  IF ~!L_ManMlt.mmas_MltDep THEN
   SEARCH(MltDep, MltDep, , L_ManMlt.mmas_MltDep);
   L_Basis.wb_WrScl("F", MltDep.MltDep);
   L_Basis.wb_WrStr("F", MltDep.Name);
  ELSE
   L_Basis.wb_WrStr("F", "--");
   L_Basis.wb_WrStr("F", "-----");
  END;
  DocAttr:=L_ManMlt.GetDocAttr_AsStr(Man.Man, EPer, ", ", 1);
  IF ~!DocAttr & ~!ManMlt.DocType THEN
   L_Basis.wb_WrStr("F", L_Str.PoolItem(L_ManMlt.mdt_FullPool, ManMlt.DocType) + " " + DocAttr);
  ELSE
   L_Basis.wb_WrStr("F", "-----");
  END;
  L_Basis.wb_WrStr("F", L_Str.PoolItem("|", L_ManMlt.HasActualManMltEvent(Man.Man, EPer, L_ManMlt.mme_OrderX)));
  L_Basis.wb_WrStr("F", L_Str.PoolItem("|", L_ManMlt.HasActualManMltEvent(Man.Man, EPer, L_ManMlt.mme_Reserv)));
  IF ~!L_ManMlt.mmas_Ready THEN
   L_Basis.wb_WrStr("F", L_Str.PoolItem(L_ManMlt.mm_ReadyPool, L_ManMlt.mmas_Ready));
  ELSE
   L_Basis.wb_WrStr("F", "-----");
  END;
  L_Basis.wb_WrStr("F", L_Str.PoolItem("|", L_DatTim.IsActive_Inc(EPer, L_ManMlt.mmas_From, L_ManMlt.mmas_UpTo)));
  L_Basis.wb_WrStr("F", L_Str.PoolItem("|", ~!L_ManMlt.mmas_MltRank & (L_ManMlt.mmas_Ready # 0) & L_ManMlt.MltRankComposCond(Age, 1)));
  L_Basis.wb_WrStr("F", L_Str.PoolItem("|", ~!L_ManMlt.mmas_MltRank & L_DatTim.IsActive_Inc(EPer, L_ManMlt.mmas_From, L_ManMlt.mmas_UpTo) &
                                                 ~L_ManMlt.MltRankComposCond(Age, 1)));
  L_Basis.wb_WrStr("F", E_MustBeReserved(EPer));
  L_Basis.wb_WrStr("F", L_Str.PoolItem("|", L_ManMlt.mmas_DocType = L_ManMlt.mdt_01));
  L_Basis.wb_WrStr("F", L_Str.PoolItem("|", ~!L_ManMlt.mmas_MltRank & L_DatTim.IsActive_Inc(EPer, L_ManMlt.mmas_From, L_ManMlt.mmas_UpTo) &
                                                 L_ManMlt.MltRankComposCond(Age, 1) & (L_ManMlt.mmas_DocType # L_ManMlt.mdt_01)));
  L_Basis.wb_TermLine("F");
 END {MakeLine};

 PRIVATE PROCEDURE Do(BPer, EPer: DATE);
 BEGIN
  MakeTop();
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   IF (Staff.Contract # L_Staff.cnt_OutStaff) & L_Env.RealTSN(Staff.TSN) & L_Staff.InStateInPer(BPer, EPer) THEN
    HISTCONF(EPer, Staff, StaffLog);
    CONFORM(Staff, Man);
    CONFORM(StaffLog, Sort);
    CONFORM(StaffLog, Post);
    CONFORM(StaffLog, Union);
    IF L_Man.Man_Citizen(Man.Man, EPer) <= L_Man.ct_Russia THEN
     MakeLine(BPer, EPer);
    END;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff)... *)
 END {Do};

 PUBLIC PROCEDURE MnMlt();
  CONST
   bpId = "MnMlt";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, "᪨ ", L_bp.t_Basis, L_General.tc_inIntvl);
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  Do(Memo.ud_fr(), Memo.ud_ut());
  FIO.Close(F);
  L_bp.End();
 END {MnMlt};

END.
