(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose     ⪨  
%Type        report
%Specific    SYS
%Modified    21.11.2013 16:47:04 POLAK\Bor
*)

 MODULE MS_Rest [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Acnt, Str, L_OwnData, L_General, L_MathR, L_DatTim, L_CUC, L_Str,
        L_APtm, L_XObj, L_AFM, L_MDoc, L_XDoc, Memo, L_AcCut, Math, L_Stock, L_StdFrm,
        P_Math, L_AR, FIO, L_Basis, L_AcsPnt;

 PRIVATE CONST
  acspnt_MathRestView = 0000012;

(*
$P{ RepTop:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, R, ""
?, L, "D.N.y"
Storage.Storage, L, ""
Storage.Type, L, L_Stock.st_Pool_SH
Storage.Name, L, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|                                         ##########  ##########                                           |
| ࠭ #######(###) ################################################################################|
}
*)

(*
$P{ RepGroup:
?, L, ""
@
|------------------------------------------------------------------------------------------------------------|
|############################################################################################################|
}
*)

(*
$P{ RepDefs:
@
|------------------------------------------------------------------------------------------------------------|
|                                                                              |||        ⢮|
|---------------------------------------------------------------------------------|---|---|------------------|
}
*)

(*
$P{ RepLine:
Math.Math, L, ""
Math.Name, L, ""
AcCut.AcCut, L, ""
L_MathR.amm_GetMModeSign(Math.MathType, AcCut.AcCut), L, ""
?, R, "3."
L_MathR.DefaultMUnitSign(Math.Math), L, ""
@
|##### ###########################################################################|###|###|############## ###|
}
*)

(*
$P{ RepBot:
@
=(c) Polak====================================================================================================
}
*)

(*
$P{ RepTop1:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
Math.Math + " " + Math.Name, C, ""
@
############################################################################################  ########## #####
=#####========================================================================================================
|                                       ᪫  ##########                                     |
|############################################################################################################|
}
*)

(*
$P{ RepSubTop1:
?, R, ""
@
|------------------------------------------------------------------------------------------------------------|
|############################################################################################################|
}
*)

(*
$P{ RepSubTop2:
?, L, ""
@
|------------------------------------------------------------------------------------------------------------|
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|    |᪮                              |㬥              |ࠪ                        |
|-------|--------------------------------------------|----------------------|--------------------------------|
}
*)

(*
$P{ RepLine1:
CUCopy.CUCopy, L, ""
CUCopy.Serial, L, ""
L_MDoc.MDocStr(MDocLCU.MDocKind, MDocLCU.MDoc), L, ""
MDocLCU.Date, L, "D.N.y"
L_MDoc.getMDocLCUChar(), L, L_CUC.chr_Pool
@
|#######|############################################|########### ##########|################################|
}
*)

(*
$P{ RepSubBot2:
?, R, ""
@
|------------------------------------------------------------------------------------------------------------|
|       #####################################################################################################|
}
*)

(*
$P{ RepBot2:
@
=(c) Polak====================================================================================================
}
*)

(*
$P{ RepGTop1:
@
--------------------------------------------------------------------------------------------------------------
|                                                                                                            |
|                                          㯯஢                                   |
}
*)

(*
$P{ RepGSubTop2:
?, L, ""
@
|------------------------------------------------------------------------------------------------------------|
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|    |᪮                        |  |㬥              |ࠪ                        |
|-------|--------------------------------------|-----|----------------------|--------------------------------|
}
*)

(*
$P{ RepGLine1:
CUCopy.CUCopy, L, ""
CUCopy.Serial, L, ""
?, L, ""
L_MDoc.MDocStr(MDocLCU.MDocKind, MDocLCU.MDoc), L, ""
MDocLCU.Date, L, "D.N.y"
L_MDoc.getMDocLCUChar(), L, L_CUC.chr_Pool
@
|#######|######################################|#####|########### ##########|################################|
}
*)

(*
$P{ RepCUTop:
?, L, ""
@
|------------------------------------------------------------------------------------------------------------|
|                                                                                                            |
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|    |᪮                          ||㬥              |ࠪ                        |
|-------|----------------------------------------|---|----------------------|--------------------------------|
}
*)

(*
$P{ RepCUTopG:
?, L, ""
@
|------------------------------------------------------------------------------------------------------------|
|                                                                                                            |
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|    |᪮                    |  ||㬥              |ࠪ                        |
|-------|----------------------------------|-----|---|----------------------|--------------------------------|
}
*)

(*
$P{ RepCULine:
CUCopy.CUCopy, L, ""
CUCopy.Serial, L, ""
?, L, L_CUC.cnd_Pool
?, L, ""
?, L, "D.N.y"
?, L, L_CUC.chr_Pool
@
|#######|########################################|###|########### ##########|################################|
}
*)

(*
$P{ RepCULineG:
CUCopy.CUCopy, L, ""
CUCopy.Serial, L, ""
CUCopy.Math, L, ""
?, L, L_CUC.cnd_Pool
?, L, ""
?, L, "D.N.y"
?, L, L_CUC.chr_Pool
@
|#######|##################################|#####|###|########### ##########|################################|
}
*)

(*
$P{ smh_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
Math.Math       + " " + Math.Name, L, ""
Storage.Storage + " " + Storage.Name, L, ""
AcCut.AcCut     + " " + AcCut.Name, L, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|                               (, , ࠧ१)  ##########                               |
|------------------------------------------------------------------------------------------------------------|
|    #####################################################################################################|
|     #####################################################################################################|
|१ #####################################################################################################|
}
*)

(*
$P{ smh_Line:
?, L, ""
@
|------------------------------------------------------------------------------------------------------------|
|############################################################################################################|
}
*)

(*
$P{ smh_Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE GetAvl(_XObject: LIKE(XObject.XObject);
                          _AcCut  : LIKE(AcCut.AcCut);
                          P       : DATE;
                          collect : SCAL[2];
                          VAR AvlSum: L_XObj.tSum;
                          VAR AvlQnt: L_XObj.tQnt;
                          VAR atP   : DATE);
  VAR
   curSum: L_XObj.tSum;
   curQnt: L_XObj.tQnt;
 BEGIN
  SAVE(XCalc);
  SAVE(AcCut);
  SETZERO(AvlSum, AvlQnt);
  SETEMPTY(atP);
  L_AcCut.PositionOnAcCut(_AcCut);
  CHANGESEL(AcCut, PriceGrp, , AcCut.PriceGrp);
  FIRST(AcCut);
  WHILE OCCURE(AcCut) DO
   SETSEL(XCalc, XObject, _XObject, AcCut.AcCut);
   IF SRCINSEL(XCalc, LT, P) THEN
    IF ~collect & L_MathR.IsMathDone_AP(Math.Math, XCalc.XDat) THEN
     L_XObj.OutSaldo(curSum, curQnt);
     INC(AvlSum, curSum);
     INC(AvlQnt, curQnt);
    ELSE
     REPEAT
      INC(AvlSum, XCalc.SldSum);
      INC(AvlQnt, XCalc.SldQnt);
      CONFORM(XCalc, XApport);
      WHILE OCCURE(XApport) DO
       CONFORM(XApport, Apport);
       IF (Apport.CirType = L_Acnt.ct_Debit) &
          (Apport.CirKind = L_Acnt.ck_ExplicitCir) THEN
        L_XObj.AddXA2Saldo(AvlSum, AvlQnt, +1);
       END;
       NEXT(XApport);
      END; (* WHILE OCCURE(XApport)... *)
      IF AvlQnt # 0 THEN
       IF !atP THEN
        atP:=XCalc.XDat;
       ELSE
        atP:=Math.Max(atP, XCalc.XDat);
       END;
      END;
     UNTIL ~PREV(XCalc) | (~collect & L_MathR.IsMathDone_AP(Math.Math, XCalc.XDat)) | (collect & ~!atP);
    END; (* IF ~collect ... *)
   END; (* IF SRCINSEL(XCalc ... *)
   NEXT(AcCut);
  END; (* WHILE OCCURE(AcCut) ... *)
  RESTORE(AcCut);
  RESTORE(XCalc);
 END {GetAvl};

 CONST
  maxRestDialogDepth = 15;

 VAR
  sr_len_Total,
  sr_len_Storage,
  sr_len_AcCut   : NUMERIC[0];

 PRIVATE PROCEDURE MakeRest_SetupDialogSize();
  VAR
   w, d: NUMERIC[0];
 BEGIN
  GE_APPWIN_SIZE(w, d);
  IF w >= 112 THEN
   sr_len_Total  :=106;
   sr_len_Storage:=58;
   sr_len_AcCut  :=28;
  ELSE
   sr_len_Total  :=74;
   sr_len_Storage:=26;
   sr_len_AcCut  :=28;
  END;
 END {MakeRest_SetupDialogSize};

 PRIVATE PROCEDURE sr_SingleItemAsStr(_Storage: LIKE(Storage.Storage); _AcCut: LIKE(AcCut.AcCut)): STRING[];
 BEGIN
  SEARCH(Storage, Storage, , _Storage);
  L_AcCut.PositionOnAcCut(_AcCut);
  RETURN Str.Align(Storage.Storage + " " + Storage.Name, sr_len_Storage-1,  LEFT) + " " +
         Str.Align(AcCut.AcCut     + " " + AcCut.Name,     sr_len_AcCut-1,  LEFT) + " " ;
 END {sr_SingleItemAsStr};

 PRIVATE PROCEDURE LastPrice(P: DATE);
  VAR
   AvlSum: L_XObj.tSum;
   AvlQnt: L_XObj.tQnt;
   atP   : DATE;
   S,
   List  : STRING[];
   macc  : L_MathR.tMathAcCutCollection;
   i,
   Idx,
   Count : NUMERIC[0];
 BEGIN
  L_General.Assert(OCCURE(Math), " । ꥪ ਠ쭮 ");
  S:="|" + Str.Align("",                          sr_len_Storage,  LEFT) +
           Str.Align(" ࠧ१",                sr_len_AcCut,  LEFT) +
           Str.Align("ਮ",                                   7,  LEFT) +
           Str.Align(" "+L_MathR.DefaultMUnitSign(Math.Math), 13, RIGHT) +
     "|" + L_Str.Repeat("", sr_len_Total) + "|";
  Count:=0;
  List:="";
  SELECT(mItem, Math, , Math.Math);
  WHILE OCCURE(mItem) DO
   CONFORM(mItem, Storage);
   IF Storage.Type # L_Stock.st_AdvHolder THEN
    macc:=L_MathR.GetXObjectAcCutCollection(mItem.XObject);
    i:=0;
    WHILE ~!macc[i] DO
     IF L_MathR.AcCutOfRealStock(macc[i]) THEN
      LOOP
       GetAvl(mItem.XObject, macc[i], P, 1, AvlSum, AvlQnt, atP);
       IF !atP THEN
        EXIT;
       ELSIF AvlQnt # 0 THEN
        List:=List + sr_SingleItemAsStr(mItem.Storage, macc[i])               +
                     Str.Align(FLDTOSTR(atP, "N.y", 7),             7,  LEFT) +
                     Str.Align(FLDTOSTR(AvlSum/AvlQnt, "2-", 0), 13, RIGHT) + "|";
        INC(Count);
        EXIT;
       END;
       P:=L_DatTim.IncMonth(P, -1);
      END; (* LOOP *)
     END;
     INC(i);
    END; (* WHILE ~!macc[i] *)
   END;
   NEXT(mItem);
  END; (* WHILE OCCURE(mItem) ... *)
  IF Count > 0 THEN
   S:=S + "%" + L_Str.IntStr(sr_len_Total) + "," + L_Str.IntStr(Math.Min(Count+1, maxRestDialogDepth)) + "AI" +
                L_Str.Repeat("|", Math.Min(Count+1, maxRestDialogDepth)) +
          "||%< 믮 >DX";
   Idx:=0;
   STDFORM(S, " ᫥ 業  "+L_DatTim.DateStr(P) + " ", INFORM, , List, Idx);
  ELSE
   S:=S + " ଠ樨!||%< 믮 >DX";
   STDFORM(S, " ᫥ 業  "+L_DatTim.DateStr(P) + " ", INFORM);
  END;
 END {LastPrice};

 PRIVATE PROCEDURE CountUpMath(P: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=1;
  TRY
   L_MathR.CountUpMath(Math.Math, P);
  EXCEPT
  ON Exc: Exc_Root DO
   Result:=0;
  END; (* TRY *)
  RETURN Result;
 END {CountUpMath};

 PRIVATE PROCEDURE GetXDocDoneDTS(trgXDocId: L_XDoc.tXDocId): L_XDoc.tDoneDTS;
  VAR
   curRefFileName : STRING[];
   curDoneDTSField: FIELD;
   Result         : L_XDoc.tDoneDTS;
 BEGIN
  curRefFileName:=L_XDoc.Ref_FileName(L_XDoc.ExtractXDocType(trgXDocId));
  curDoneDTSField:=TABLE.Get(curRefFileName).Fields("DoneDTS");
  L_General.CallUs(~!curDoneDTSField);
  TRY
   L_General.CallUs(L_XDoc.StandOnXDoc(trgXDocId));
   Result:=^(curDoneDTSField.ObtainName());
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END; (* TRY *)
  RETURN Result;
 END {GetXDocDoneDTS};

 PRIVATE PROCEDURE ShowMathHistory(P         : DATE;
                                   trgStorage: LIKE(Storage.Storage);
                                   trgAcCut  : LIKE(AcCut.AcCut);
                                   trgXObject: LIKE(XObject.XObject));
  CONST
   SaldoMDocId = MAXOF(L_XDoc.tXDocId);
   RepName     = "MSHst";
  VAR
   Cnt       : NUMERIC[0];
   dmySum    : L_XObj.tSum;
   Sld       : L_XObj.tQnt;
   prvP,
   curP,
   D         : DATE;
   DoAll,
   leftSide,
   NeedExit  : SCAL[2];
   curDoneDTS: L_XDoc.tDoneDTS;
   AddStr,
   Caption   : STRING[];
   oPrompt   : PROMPT_LINE;
   FormResult: NUMERIC[0];
 BEGIN
  oPrompt:=PROMPT_LINE.Create("");
  L_AFM.MakeMultipleIndex("MSHst", "XDat    : DATE;"+
                                   "Date    : DATE;"+
                                   "DoneDTS : "+GET_TYPE_SPEC(L_XDoc.tDoneDTS).Name+";"+
                                   "XDocId  : "+GET_TYPE_SPEC(L_XDoc.tXDocId).Name+";"+
                                   "CirType : LIKE(Apport.CirType);"+
                                   "Qnt     : "+GET_TYPE_SPEC(L_XObj.tQnt).Name+";"+
                                   "Text    : STRING[256]",
                          "DoneDTS: XDat, Date, DoneDTS, XDocId, CirType;"+
                          "XDocId: XDocId");

  SETZERO(Cnt);
  prvP:=P;
  DoAll:=0;

  NeedExit:=0;
  SETSEL(XApport, WFD, trgXObject, trgAcCut);
  SRCINSEL(XApport, LT, , P);
  WHILE OCCURE(XApport) & ~NeedExit DO
   curP:=XApport.WFDate;
   IF ~L_Acnt.E_DoXDocAprOfSpecifiedSource(XApport.WFDate, L_XObj.src_MDoc) THEN
    NeedExit:=1;
   ELSIF ~DoAll & (Cnt >= 50) & (curP < prvP) THEN
    IF L_StdFrm.Alternative(" ਨ 㦥   50 . ⮢  ?") THEN
     DoAll:=1;
    ELSE
     NeedExit:=1;
    END;
   END;

   IF NeedExit THEN
    L_XObj.AccessXObject(trgXObject);
    L_General.CLEAR("MSHst");
    MSHst.XDocId :=SaldoMDocId;
    MSHst.XDat   :=L_DatTim.NextPer(curP);
    MSHst.Date   :=MSHst.XDat;
    MSHst.DoneDTS:=0;
    SETEMPTY(MSHst.CirType, MSHst.Text);
    L_XObj.GetOutRSaldo(trgAcCut, curP, dmySum, MSHst.Qnt);
    INSERT(MSHst);
   ELSE
    NARROWSEL(XApport, WFDate);
    WHILE OCCURE(XApport) DO
     CONFORM(XApport, Apport);
     FOR_EACH leftSide DO
      L_XObj.SelectXDocAprByXApport(leftSide);
      WHILE OCCURE(XDocApr) DO
       PROMPT(L_DatTim.PeriodStr(XApport.WFDate)+" "+L_XDoc.XDocStr(XDocApr.XDocId));
       IF (( leftSide & (XDocApr.wQnt MOD 2)) |
           (~leftSide & (XDocApr.wQnt DIV 2))) &
           (XDocApr.Qnt # 0) THEN
        curDoneDTS:=GetXDocDoneDTS(XDocApr.XDocId);
        INC(Cnt, ~ADD(MSHst, DoneDTS, XDocApr.XDat, L_XDoc.GetXDocDate(XDocApr.XDocId),
                                      curDoneDTS, XDocApr.XDocId, Apport.CirType,
                      MSHst.Qnt, XDocApr.Qnt));
        prvP:=curP;
       END;
       NEXT(XDocApr);
      END; (* WHILE OCCURE(XDocApr) ... *)
     END; (* FOR_EACH leftSide ... *)
     PREV(XApport);
    END; (* WHILE OCCURE(XApport) *)
 
    FIRST(XApport);
    CHANGESEL(XApport, WFD, , XApport.XObject, XApport.AcCut);
    PREV(XApport);
   END;
  END; (* WHILE OCCURE(XApport) *)

  IF P > SYSDATE() THEN
   D:=SYSDATE()+1;
  ELSE
   D:=P;
  END;
  L_XDoc.sl_Init("   " + L_DatTim.DateStr(D) + ".  " + Math.Math + ",  " + trgStorage + ", १ " + trgAcCut);
  Sld:=0;
  SELECT(MSHst, DoneDTS);
  WHILE OCCURE(MSHst) DO

   IF MSHst.XDocId = SaldoMDocId THEN
    Sld :=MSHst.Qnt;
    MSHst.Text:=Str.Align("줮  " + L_DatTim.DateStr(MSHst.Date), 15+11+26+11+3, LEFT) +
                Str.Align(L_MathR.DefaultFormatCir(Math.Math, Sld), 10, RIGHT);
   ELSE
    PROMPT("뢮: "+L_XDoc.XDocStr(MSHst.XDocId));
    IF MSHst.CirType = L_Acnt.ct_Debit THEN
     INC(Sld, MSHst.Qnt);
    ELSE
     DEC(Sld, MSHst.Qnt);
    END;
    IF L_XDoc.ExtractXDocType(MSHst.XDocId) = L_XDoc.xdt_MDoc THEN
     L_XDoc.PositionOnXDoc(MSHst.XDocId);
     CONFORM(MDoc, Dest);
     AddStr:=" " + Str.Align(Dest.Dest + " " + Dest.Name, 25, LEFT);
    ELSE
     AddStr:=" " + Str.Align(" ", 25, LEFT);
    END;
    MSHst.Text:=L_XDoc.XDocStr(MSHst.XDocId) + " " +
                L_DatTim.DateStr(MSHst.Date) + AddStr + " " +
                Str.Align(L_MathR.DefaultFormatCir(Math.Math, MSHst.Qnt), 10, RIGHT) + " " +
                L_Str.PoolItem("|", MSHst.CirType) + " " +
                Str.Align(L_MathR.DefaultFormatCir(Math.Math, Sld), 10, RIGHT);
   END;
   REPLACE(MSHst);
   L_XDoc.sl_AddItem(MSHst.XDocId, MSHst.Text);
   NEXT(MSHst);
  END; (* WHILE OCCURE(MSHst) ... *)
  Caption:="㬥                                                        줮";
  SETEMPTY(oPrompt);
  TRY
   FormResult:=L_XDoc.sl_extShow("{}", Caption);
   IF    FormResult = 1 THEN
    L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, L_XDoc.pvs_XDocId, "");
   ELSIF FormResult = 2 THEN
    OPENREP(R, L_General.NameConnection(RepName), Create);
    SEARCH(AcCut,   AcCut,   , trgAcCut);
    SEARCH(Storage, Storage, , trgStorage);
    MAKEPART(R, smh_Top, RepName, D);
    MAKEPART(R, smh_Line, Caption);
    SELECT(MSHst, DoneDTS);
    WHILE OCCURE(MSHst) DO
     MAKEPART(R, smh_Line, MSHst.Text);
     NEXT(MSHst);
    END; (* WHILE OCCURE(MSHst) ... *)
    MAKEPART(R, smh_Bot, RepName);
    CLOSEREP(R);
    L_General.HaltAndSurveyLastReport(EMPTYOF(Exc_Root));
   END;
  EXCEPT
  ON Exc: Exc_Raise DO
  END; (* TRY *)
  L_AFM.AF_PurgeTemp("MSHst");
 END {ShowMathHistory};

 PRIVATE PROCEDURE CountUpAllowed(trgMath: LIKE(Math.Math); P: DATE): SCAL[2];
  VAR
   Dummy,
   Result: SCAL[2];
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), TRANSACTION(TRANSACTION_SLAVE)]
   SELECT(MyFirm, Storage);
   WHILE OCCURE(MyFirm) DO
    IF SEARCH(mItem, Math, trgMath, MyFirm.Storage) THEN
     CONFORM(mItem, XObject);
     Dummy:=L_XObj.XODone_IsDone(P);
    END;
    NEXT(MyFirm);
   END; (* WHILE OCCURE(MyFirm) ... *)
   Result:=1;
  EXCEPT
  ON Exc: Exc_Root DO
   Result:=0;
  END; (* TRY *)
  RETURN Result;
 END {CountUpAllowed};

 PRIVATE PROCEDURE CountUp(P: DATE; wCheckCountUpAllowed: SCAL[2]): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  IF ~wCheckCountUpAllowed | CountUpAllowed(Math.Math, P) THEN
   Result:=CountUpMath(P);
  ELSE
   Result:=0;
  END;
  RETURN Result;
 END {CountUp};

 PRIVATE PROCEDURE intMakeRest(P: DATE; _Math: LIKE(Math.Math); wZeroRests, wCheckCountUpAllowed: SCAL[2]);
  CONST
   BtnStep = 3;
  VAR
   prvP        : DATE;
   AvlSum      : L_XObj.tSum;
   AvlQnt      : L_XObj.tQnt;
   Title,
   S,
   List,
   Prc         : STRING[];
   Qnt         : L_XObj.tQnt;
   Sum         : L_XObj.tSum;
   macc        : L_MathR.tMathAcCutCollection;
   i,
   Count,
   Choice      : NUMERIC[0];
   CountUpDone : SCAL[2];
   dummyP      : DATE;
   Storages    : LIKE(Storage.Storage)[1024];
   AcCuts      : LIKE(AcCut.AcCut)    [1024];
   RstType     : SCAL[2];
   New_wZeroRests: SCAL[2];
 BEGIN
  prvP:=L_DatTim.IncMonth(P, -1);
  SEARCH(Math, Math, , _Math);
  MakeRest_SetupDialogSize();
  CONFORM(Math, MathType);
  IF    (Math.MathKind = L_MathR.mathk_Math) & (MathType.Category = L_Acnt.mtc_Inventories) THEN
   RstType:=0;
   CountUpDone:=CountUp(prvP, wCheckCountUpAllowed);

   Title:="⪨  " + L_DatTim.DateStr(P);
   S:="|" + Math.Math + " " + Str.Align(Str.Replace(Math.Name, "%", "%%"), sr_len_Total-6, LEFT) +
      "|" +
      "|" + Str.Align("",                    sr_len_Storage,  LEFT) +
            Str.Align(" ࠧ१",          sr_len_AcCut,  LEFT) +
            Str.Align(L_MathR.DefaultMUnitSign(Math.Math), 10, RIGHT) +
            Str.Align("",                              10, RIGHT) +
      "|" + L_Str.Repeat("", sr_len_Total) + "|";
  ELSE
   RstType:=1;
   CountUpDone:=CountUp(prvP, wCheckCountUpAllowed);
   L_MathR.CheckMathDone(prvP);
   Title:="줮  " + L_DatTim.DateStr(P);
   S:="|"+Str.Align("",            sr_len_Storage,  LEFT) +
          Str.Align(" ࠧ१",  sr_len_AcCut,  LEFT) +
          Str.Align("줮",                    20, RIGHT) +
      "|" + L_Str.Repeat("", sr_len_Total) + "|";
  END;
  List:="";
  Count:=0;
  SELECT(mItem, Math, , Math.Math);
  WHILE OCCURE(mItem) DO
   CONFORM(mItem, Storage);
   CONFORM(mItem, XObject);
   IF Storage.Type # L_Stock.st_AdvHolder THEN
    macc:=L_MathR.GetXObjectAcCutCollection(mItem.XObject);
    i:=0;
    WHILE ~!macc[i] DO
     IF RstType = 0 THEN
      IF L_MathR.AcCutOfRealStock(macc[i]) THEN
       Qnt:=L_XObj.qo_GetInSaldo(macc[i], P);
       IF (Qnt # 0) | wZeroRests THEN
        IF CountUpDone THEN
         GetAvl(mItem.XObject, macc[i], P, 0, AvlSum, AvlQnt, dummyP);
         IF AvlQnt # 0 THEN
          Prc:=FLDTOSTR(AvlSum/AvlQnt, "2-");
         ELSE
          Prc:=FLDTOSTR(0,             "2-");
         END;
        ELSE
         Prc:="/";
        END;
        List:=List + sr_SingleItemAsStr(mItem.Storage, macc[i])                     +
                     Str.Align(L_MathR.DefaultFormatCir(Math.Math, Qnt), 10, RIGHT) +
                     Str.Align(Prc,                                      10, RIGHT) + "|";
        Storages[Count]:=mItem.Storage;
        AcCuts[Count]  :=macc[i];
        INC(Count);
       END;
      END;
     ELSE
      Sum:=L_XObj.mo_GetInSaldo(macc[i], P);
      IF Sum # 0 THEN
       List:=List + sr_SingleItemAsStr(mItem.Storage, macc[i])               +
                    Str.Align(FLDTOSTR(Sum, ",2-"),               20, RIGHT) + "|";
       INC(Count);
      END;
     END;
     INC(i);
    END; (* WHILE  ~!macc[i] *)
   END;
   NEXT(mItem);
  END; (* WHILE OCCURE(mItem) ... *)
  IF Count = 0 THEN
   S:=S+"祣 !|";
  ELSE
   S:=S + "%" + L_Str.IntStr(sr_len_Total) + "," + L_Str.IntStr(Math.Min(Count+1, maxRestDialogDepth)) + "AI" +
           L_Str.Repeat("|", Math.Min(Count+1, maxRestDialogDepth)) + "|";
  END;
  IF RstType = 0 THEN
   S:=S+"|" + "%< ᫥ {} >"   + L_Str.PoolItem("DB|B",  Count>0) + L_Str.Repeat(" ", BtnStep) +
              "%< {}  >" + L_Str.PoolItem("NB|DB", Count>0) + L_Str.Repeat(" ", BtnStep);
   IF wZeroRests THEN
    S:=S+"%< 쪮 {}㫥 ⪨ >B" + L_Str.Repeat(" ", BtnStep);
    New_wZeroRests:=0;
   ELSE
    S:=S+"%<  ⮬ ᫥ {}㫥 ⪨ >B" + L_Str.Repeat(" ", BtnStep);
    New_wZeroRests:=1;
   END;
   IF P_Math.IsCompositeMath(Math.Math, P) THEN
    S:=S + "%< {}⠢  >B" + L_Str.Repeat(" ", BtnStep);
   END;
   S:=S + "%< 믮 >X";
  ELSE
   S:=S+"|%< 믮 >X";
  END;
  i:=0;
  LOOP
   IF Count > 0 THEN
    Choice:=STDFORM(S, " " + Title + " ", ^(L_StdFrm.SFMenuStyle()), , List, i);
   ELSE
    Choice:=STDFORM(S, " " + Title + " ", INFORM);
   END;
   IF    Choice = 0 THEN
    EXIT;
   ELSIF Choice = 1 THEN
    LastPrice(P);
   ELSIF Choice = 2 THEN
    SEARCH(mItem, Math, , Math.Math, Storages[i]);
    ShowMathHistory(P, mItem.Storage, AcCuts[i], mItem.XObject)
   ELSIF Choice = 3 THEN
    intMakeRest(P, Math.Math, New_wZeroRests, wCheckCountUpAllowed);
    EXIT;
   ELSIF Choice = 4 THEN
    ShowRestOfStructureOfCompositeMath(P);
   END;
  END; (* LOOP *)
 END {intMakeRest};

 PRIVATE PROCEDURE ShowRestOfStructureOfCompositeMath(D: DATE);
  VAR
   i, j     : NUMERIC[0];
   macc     : L_MathR.tMathAcCutCollection;
   Qnt      : L_XObj.tQnt;
   List,
   S        : STRING[];
   Choice   : NUMERIC[0];
   arrMath  : LIKE(Math.Math)[P_Math.cs_Amount];
   arrAmount: NUMERIC[0][P_Math.cs_Amount];
   arrType  : P_Math.tCompositionSetType[P_Math.cs_Amount];
 BEGIN
  SAVE(Math);
  S:="|" + Math.Math + " " + Str.Align(Math.Name, sr_len_Total-6, LEFT) +
     "|" + L_Str.Repeat("", sr_len_Total) + "|";
  List:="";
  P_Math.Decode_CompositionSet(P_Math.GetMathProSoft(Math.Math, D, P_Math.P_CompositionSet), arrMath, arrAmount, arrType);
  i:=0;
  WHILE (i < P_Math.cs_Amount) & ~!arrMath[i] DO
   SEARCH(Math, Math, , arrMath[i]);
   Qnt:=0;
   SELECT(mItem, Math, , Math.Math);
   WHILE OCCURE(mItem) DO
    CONFORM(mItem, Storage);
    CONFORM(mItem, XObject);
    IF Storage.Type # L_Stock.st_AdvHolder THEN
     macc:=L_MathR.GetXObjectAcCutCollection(mItem.XObject);
     j:=0;
     WHILE ~!macc[j] DO
      IF L_MathR.AcCutOfRealStock(macc[j]) THEN
       INC(Qnt, L_XObj.qo_GetInSaldo(macc[j], D));
      END;
      INC(j);
     END;
    END;
    NEXT(mItem);
   END; (* WHILE OCCURE(mItem) *)
   List:=List + Math.Math + " " +
                Str.Align(Math.Name, sr_len_Total-(6+10+4), LEFT) +
                Str.Align(L_MathR.DefaultFormatCir(Math.Math, Qnt), 10, RIGHT) + " " +
                Str.Align(L_MathR.DefaultMUnitSign(Math.Math),       3, LEFT) + "|";
   INC(i);
  END;
  RESTORE(Math);
  S:=S + "%" + L_Str.IntStr(sr_len_Total) + "," + L_Str.IntStr(Math.Min(i+1, maxRestDialogDepth)) + "AI" +
          L_Str.Repeat("|", Math.Min(i+1, maxRestDialogDepth)) +
         "|" + "%< {}஡ >B" + L_Str.Repeat(" ", 20) + "%< 믮 >X";
  i:=0;
  LOOP
   Choice:=STDFORM(S, " ⪨     " + L_DatTim.DateStr(D) + " ", ^(L_StdFrm.SFMenuStyle()), , List, i);
   IF    Choice = 0 THEN
    EXIT;
   ELSIF Choice = 1 THEN
    intMakeRest(D, arrMath[i], 0, 0);
   END;
  END; (* LOOP *)
 END {ShowRestOfStructureOfCompositeMath};

 PRIVATE PROCEDURE mrr_MakePart();
 BEGIN
  PROMPT(mRst1.Math);
  L_AcCut.PositionOnAcCut(mRst1.AcCut);
  SEARCH(Math, Math, , mRst1.Math);
  MAKEPART(R, RepLine, mRst1.Qnt);
 END {mrr_MakePart};

 PRIVATE PROCEDURE mrr_MakeExcelTop(F: STRING[]; DoExcel: SCAL[3]);
 BEGIN
  L_Basis.wb_WrInQM(F, "ꥪ");
  L_Basis.wb_WrInQM(F, "ꥪ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ꥪ⠊");
  L_Basis.wb_WrInQM(F, " ꥪ");
  L_Basis.wb_WrInQM(F, "ॣ");
  L_Basis.wb_WrInQM(F, "ॣ");
  L_Basis.wb_WrInQM(F, "⮢⥫");
  L_Basis.wb_WrInQM(F, "⮢⥫");
  L_Basis.wb_WrInQM(F, "  ⠫");
  L_Basis.wb_WrInQM(F, "१");
  L_Basis.wb_WrInQM(F, "१");
  L_Basis.wb_WrInQM(F, "१");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⢮");
  IF DoExcel = 2 THEN
   L_Basis.wb_WrInQM(F, "㬬");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, " 믮");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_TermLine(F);
 END {mrr_MakeExcelTop};

 PRIVATE PROCEDURE mrr_MakeExcelPart(F: STRING[]; P: DATE; DoExcel: SCAL[3]);
 BEGIN
  PROMPT(mRst1.Math);
  L_AcCut.PositionOnAcCut(mRst1.AcCut);
  SEARCH(Math,     Math, ,     mRst1.Math);
  SEARCH(Vendor,   Vendor, ,   mRst1.Vendor);
  SEARCH(MathType, MathType, , mRst1.MathType);
  SEARCH(CarUnit,  CarUnit, ,  mRst1.CarUnit);
  L_Basis.wb_WrScl(F, Math.Math);
  L_Basis.wb_WrStr(F, Math.Name);
  L_Basis.wb_WrStr(F, L_MathR.DefaultMUnitSign(Math.Math));
  L_Basis.wb_WrScl(F, MathType.MathType);
  L_Basis.wb_WrStr(F, MathType.Name);
  L_Basis.wb_WrStr(F, CarUnit.CarUnit);
  L_Basis.wb_WrStr(F, CarUnit.Name);
  L_Basis.wb_WrStr(F, Vendor.Vendor);
  L_Basis.wb_WrStr(F, Vendor.Name);
  L_Basis.wb_WrStr(F, Math.UnitedC);
  L_Basis.wb_WrScl(F, AcCut.AcCut);
  L_Basis.wb_WrStr(F, AcCut.Sign);
  L_Basis.wb_WrStr(F, AcCut.Name);
  L_Basis.wb_WrStr(F, L_Acnt.GetCAcntSign(P, AcCut.AcCut));
  L_Basis.wb_WrNum(F, mRst1.Qnt, 2);
  IF DoExcel = 2 THEN
   L_Basis.wb_WrNum(F, mRst1.Sum, 2);
   IF mRst1.Qnt # 0 THEN
    L_Basis.wb_WrNum(F, mRst1.Sum / mRst1.Qnt, 2);
   ELSE
    L_Basis.wb_WrNum(F, EMPTYOF(L_XObj.tSum), 2);
   END;
   L_Basis.wb_WrStr(F, L_Str.PoolItem("|", mRst1.CUpDone));
  END;
  L_Basis.wb_WrStr(F, L_MathR.amm_GetMModeSign(Math.MathType, AcCut.AcCut));
  L_Basis.wb_TermLine(F);
 END {mrr_MakeExcelPart};

 PUBLIC PROCEDURE mRst1_Gather(P: DATE; DoExcel: SCAL[3]);
  VAR
   i          : NUMERIC[0];
   Qnt        : L_XObj.tQnt;
   macc       : L_MathR.tMathAcCutCollection;
   CountUpDone: SCAL[2];
 BEGIN
  SELECT(mItem, Storage, , Storage.Storage);
  WHILE OCCURE(mItem) DO
   PROMPT(mItem.Math);
   CONFORM(mItem, Math);
   CONFORM(mItem, XObject);
   IF DoExcel = 2 THEN
    SAVE(mItem);
    SAVE(Storage);
    CountUpDone:=CountUpMath(L_DatTim.IncMonth(P, -1));
    RESTORE(mItem);
    RESTORE(Storage);
   END;
   macc:=L_MathR.GetXObjectAcCutCollection(mItem.XObject);
   i:=0;
   WHILE ~!macc[i] DO
    IF L_MathR.AcCutOfRealStock(macc[i]) THEN
     Qnt:=L_XObj.qo_GetInSaldo(macc[i], P);
     IF Qnt # 0 THEN
      ADD(mRst1, Math, , Math.Math, macc[i], Math.Vendor, Math.MathType, Math.CarUnit,
               mRst1.Qnt, Qnt,
               mRst1.Sum, 0);
      IF DoExcel = 2 THEN
       mRst1.CUpDone:=CountUpDone;
       INC(mRst1.Sum, L_XObj.mo_GetInSaldo(macc[i], P));
       REPLACE(mRst1);
      END;
     END;
    END;
    INC(i);
   END;
   NEXT(mItem);
  END; (* WHILE OCCURE(mItem) ... *)
 END {mRst1_Gather};

 PUBLIC PROCEDURE MSRst();
  CONST
   RepName = "MSRst";
   gt_None     = 0;
   gt_Vendor   = 1;
   gt_MathType = 2;
   gt_AcCut    = 3;
   gt_CarUnit  = 4;
  VAR
   P        : DATE;
   Index,
   GroupBy  : STRING[];
   DoExcel  : SCAL[3];
   GroupType: NUMERIC[0];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_AcsPnt.PassAccessPoint(acspnt_MathRestView);
  L_General.Assert(ACCESS(Storage), " ࠭  ࠭");

  DoExcel:=0;
  GroupType:=gt_None;
  STDFORM(L_StdFrm.sf_Choice("|   %############################%|" +
                             "|㯯஢ %####################%        |",
                             "%L<|Excel|Excel  ⮨⭮ 業>I" +
                             "%L< |⮢⥫| |१|ॣ+⮢⥫>I"),
          " ⪨    ", , -1, DoExcel, GroupType);

  P:=L_DatTim.NextPer(Memo.ud_cd());
  L_MathR.amm_Init(P);
  L_MathR.mr_Init();
  mRst1_Gather(P, DoExcel);

  IF DoExcel THEN
   FIO.Open(F, L_General.NameConnection(RepName), "REP", Create);
   mrr_MakeExcelTop("F", DoExcel);
   Index  :="Math";
  ELSE
   OPENREP(R, L_General.NameConnection(RepName), Create);
   MAKEPART(R, RepTop, RepName, "⪨", P);
   IF    GroupType = gt_None     THEN
    Index  :="Math";
    MAKEPART(R, RepDefs);
   ELSIF GroupType = gt_Vendor   THEN
    Index  :="Vendor";
    GroupBy:="mRst1.Vendor";
   ELSIF GroupType = gt_MathType THEN
    Index  :="MathType";
    GroupBy:="mRst1.MathType";
   ELSIF GroupType = gt_AcCut    THEN
    Index  :="AcCut";
    GroupBy:="mRst1.AcCut";
   ELSIF GroupType = gt_CarUnit  THEN
    Index  :="CarUnit";
    GroupBy:="mRst1.CarUnit, mRst1.Vendor";
   END;
  END;

  SELECT(mRst1, ^Index);
  WHILE OCCURE(mRst1) DO
   IF DoExcel THEN
    mrr_MakeExcelPart("F", P, DoExcel);
   ELSIF GroupType = gt_None THEN
    mrr_MakePart();
   ELSE
    IF    GroupType = gt_Vendor   THEN
     SEARCH(Vendor, Vendor, , mRst1.Vendor);
     MAKEPART(R, RepGroup, "⮢⥫ " + Vendor.Vendor + " " + Vendor.Name);
    ELSIF GroupType = gt_MathType THEN
     SEARCH(MathType, MathType, , mRst1.MathType);
     MAKEPART(R, RepGroup, "  " + MathType.MathType + " " + MathType.Name);
    ELSIF GroupType = gt_AcCut    THEN
     L_AcCut.PositionOnAcCut(mRst1.AcCut);
     MAKEPART(R, RepGroup, "१ " + AcCut.AcCut + " " + AcCut.Sign + " " + AcCut.Name);
    ELSIF GroupType = gt_CarUnit  THEN
     SEARCH(CarUnit, CarUnit, , mRst1.CarUnit);
     SEARCH(Vendor, Vendor, , mRst1.Vendor);
     MAKEPART(R, RepGroup, "ॣ " + CarUnit.CarUnit + " " + CarUnit.Name + ". " +
                           "⮢⥫ " + Vendor.Vendor + " " + Vendor.Name);
    END;
    MAKEPART(R, RepDefs);
    CHANGESEL(mRst1, ^Index, , ^GroupBy);
    WHILE OCCURE(mRst1) DO
     mrr_MakePart();
     NEXT(mRst1);
    END; (* WHILE OCCURE(mRst1) ... *)
    LAST(mRst1);
    CHANGESEL(mRst1, ^Index);
   END;
   NEXT(mRst1);
  END; (* WHILE OCCURE(mRst1) ... *)
  L_MathR.amm_DeInit();
  L_AFM.AF_PurgeTemp("mRst1");
  IF DoExcel THEN
   FIO.Close(F);
   L_Basis.ExtPlayMakedRunTimeRep(RepName, Storage.Storage, L_General.timeCond_OnMonthEnd,
                                  "c⪨   " + Storage.Storage + " " + Storage.Name, 0);
  ELSE
   MAKEPART(R, RepBot);
   CLOSEREP(R);
   L_General.SurveyLastReport();
  END;
 END {MSRst};

 PRIVATE PROCEDURE GetCUCopyMath(_Math: LIKE(Math.Math); _D: DATE);
 BEGIN
  SETSEL(CUCopy, Math, _Math);
  SRCINSEL(CUCopy, GT, , _D);
  WHILE OCCURE(CUCopy) DO
   PROMPT(CUCopy.CUCopy);
   IF L_CUC.AccessMDocLCU(CUCopy.CUCopy, _D) &
      (L_CUC.IsCUAtStock(MDocLCU.OpKind) | (L_CUC.DefineCULocation(MDocLCU.OpKind) = L_CUC.l_Others)) THEN
    ADD(CURest, CURest, , L_CUC.GetCUCondition(CUCopy.CUCopy, _D),
                          L_CUC.GetCurMDocLCUStorage(),
                          CUCopy.CUCopy);
   END;
   NEXT(CUCopy);
  END; (* WHILE OCCURE(CUCopy) ... *)
 END {GetCUCopyMath};

 PRIVATE PROCEDURE MakeSingleRepCURest(_Date: DATE; IsGroup: SCAL[2]);
  VAR
   cCount,
   sCount   : NUMERIC[0];
   StorageAsStr: STRING[];
 BEGIN
  L_XDoc.sl_Init("");
  SELECT(CURest, CURest);
  WHILE OCCURE(CURest) DO
   NARROWSEL(CURest, CUCond);
   SAVE(CURest);
   cCount:=0;
   WHILE OCCURE(CURest) DO
    INC(cCount);
    NEXT(CURest);
   END;
   RESTORE(CURest);
   MAKEPART(R, "RepSubTop1", L_Str.IntStr(cCount) + " " +
                             Str.EnumObject(cCount, "||஢") + '  ﭨ "' +
                             L_Str.PoolItem(L_CUC.cnd_Pool, CURest.CUCond) + '"');
   WHILE OCCURE(CURest) DO
    NARROWSEL(CURest, Storage);
    IF ~!CURest.Storage THEN
     SEARCH(Storage, Storage, , CURest.Storage);
     StorageAsStr:=" ࠭ " + Storage.Storage + "(" +
                   L_Str.PoolItem(L_Stock.st_Pool_SH, Storage.Type) + ") " + Storage.Name;
    ELSE
     StorageAsStr:="  ࠭?";
    END;
    IF IsGroup THEN
     MAKEPART(R, RepGSubTop2, StorageAsStr);
    ELSE
     MAKEPART(R, RepSubTop2, StorageAsStr);
    END;
    sCount:=0;
    WHILE OCCURE(CURest) DO
     SEARCH(CUCopy, CUCopy, , CURest.CUCopy);
     PROMPT(CUCopy.CUCopy);
     L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_CUCopy,
                                     L_XDoc.EmptyXDocKind,
                                     CURest.CUCopy),
                       Str.Align(CUCopy.CUCopy, 8, LEFT) +
                       Str.Align(CUCopy.Serial, 49, LEFT) +
                       L_Str.PoolItem(L_CUC.cnd_Pool, CURest.CUCond));
     L_General.CallUs(L_CUC.AccessMDocLCU(CUCopy.CUCopy, _Date));
     CONFORM(MDocLCU, MDocList);
     CONFORM(MDocList, MDoc);
     IF IsGroup THEN
      MAKEPART(R, "RepGLine1", CUCopy.Math);
     ELSE
      MAKEPART(R, "RepLine1");
     END;
     INC(sCount);
     NEXT(CURest);
    END; (* WHILE OCCURE(CURest) ... *)
    MAKEPART(R, RepSubBot2, "⮣ " + L_Str.IntStr(sCount) + " " +
                            Str.EnumObject(sCount, "||஢"));
    NEXTINEXTENDEDSEL(CURest, Storage);
   END; (* WHILE OCCURE(CURest) ... *)
   NEXTINEXTENDEDSEL(CURest, CUCond);
  END; (* WHILE OCCURE(CURest) ... *)
 END {MakeSingleRepCURest};

 PUBLIC PROCEDURE MakeRepCURest(_Date: DATE; _RepName: STRING[]);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_AcsPnt.PassAccessPoint(acspnt_MathRestView);
  L_General.Assert(ACCESS(Math), " ࠭ ");

  OPENREP(R, L_General.NameConnection(_RepName), Create);

  L_AFM.MakeMultipleIndex("CURest", "CUCond : " + TYPENAMEOF(L_CUC.tCondition)       + ";"+
                                    "Storage: " + TYPENAMEOF(LIKE(Storage.Storage))  + ";"+
                                    "CUCopy : " + TYPENAMEOF(LIKE(CUCopy.CUCopy))    + ";",
                           "CURest: CUCond, Storage, CUCopy");

  MAKEPART(R, RepTop1, _RepName, _Date + 1);
  GetCUCopyMath(Math.Math, _Date);
  MakeSingleRepCURest(_Date, 0);

  IF SELECT(MathPro, Property, P_Math.P_ParentMath, Math.Math) THEN
   SELECT(CURest, CURest);
   REMSEL(CURest);
   WHILE OCCURE(MathPro) DO
    GetCUCopyMath(MathPro.Math, _Date);
    NEXT(MathPro);
   END;
   IF SELECT(CURest, CURest) THEN
    MAKEPART(R, RepGTop1);
    MakeSingleRepCURest(_Date, 1);
   END;
  END;
  MAKEPART(R, RepBot2);
  CLOSEREP(R);
  L_XDoc.sl_Done();
 END {MakeRepCURest};

 PUBLIC PROCEDURE MakeRestByMath(P: DATE; wZeroRests: SCAL[2]);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_AcsPnt.PassAccessPoint(acspnt_MathRestView);
  L_General.Assert(ACCESS(Math), " । ꥪ ਠ쭮 ");
  intMakeRest(P, Math.Math, wZeroRests, 0);
 END {MakeRestByMath};

 PUBLIC PROCEDURE MakeRestByMDocList();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_AcsPnt.PassAccessPoint(acspnt_MathRestView);
  L_General.Assert(ACCESS(MDocList), " । ப ");
  CONFORM(MDocList, MDoc);
  L_General.Assert(~!MDoc.Date, " ।  㬥");
  L_General.Assert(~!MDocList.Math, " 㪠 ");
  CONFORM(MDocList, Math);
  L_General.Assert(Math.MathKind # L_MathR.mathk_KeyAs, "⢥   ꥪ⠬   ");
  intMakeRest(L_DatTim.NextPer(MDoc.Date), MDocList.Math, 0, 1);
 END {MakeRestByMDocList};

 PUBLIC PROCEDURE MSRCU();
  CONST
   RepName = "MSRCU";
  VAR
   D           : DATE;
   Mth         : LIKE(Math.Math);
   IsGroupMath : SCAL[2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_AcsPnt.PassAccessPoint(acspnt_MathRestView);
  L_General.Assert(ACCESS(Storage), " ࠭  ࠭");

  L_AFM.MakeMultipleIndex("CUMath", "Math: "    + TYPENAMEOF(LIKE(Math.Math))     + ";" +
                                    "CUCopy : " + TYPENAMEOF(LIKE(CUCopy.CUCopy)) + ";" +
                                    "CUCond : " + TYPENAMEOF(L_CUC.tCondition)    + ";" +
                                    "DocName: " + TYPENAMEOF(STRING[32])          + ";" +
                                    "DocDate: " + TYPENAMEOF(DATE)                + ";" +
                                    "CUCChar: " + TYPENAMEOF(LIKE(MDMth.CUCChar)) + ";" ,
                            "CUMath: Math, CUCopy, CUCond, DocName, DocDate, CUCChar");

  D:=L_DatTim.NextPer(Memo.ud_cd());
  SELECT(MDocLCU, Storage, , Storage.Storage, L_MDoc.st_Passed);
  WHILE OCCURE(MDocLCU) DO
   PROMPT(MDocLCU.CUCopy);
   SAVE(MDocLCU);
   CHANGESEL(MDocLCU, CUCopy, , MDocLCU.CUCopy, MDocLCU.Status);
   LAST(MDocLCU);
   WHILE OCCURE(MDocLCU) & (MDocLCU.Date > D) & (MDocLCU.OpKind = L_CUC.ok_Mentioning) DO
    PREV(MDocLCU);
   END;
   IF OCCURE(MDocLCU) & (MDocLCU.Date <= D) & (MDocLCU.Storage = Storage.Storage) &
      (L_CUC.IsCUAtStock(MDocLCU.OpKind) | (L_CUC.DefineCULocation(MDocLCU.OpKind) = L_CUC.l_Others)) THEN
    CONFORM(MDocLCU, CUCopy);
    Mth:=P_Math.GetParentMath(CUCopy.Math, D);
    IF !Mth THEN
     Mth:=CUCopy.Math;
    END;
    CONFORM(MDocLCU, MDocList);
    CONFORM(MDocList, MDoc);
    ADD(CUMath, CUMath, , Mth,
                          CUCopy.CUCopy,
                          L_CUC.GetCUCondition(CUCopy.CUCopy, D),
                          L_MDoc.MDocStr(MDocLCU.MDocKind, MDocLCU.MDoc),
                          MDocLCU.Date,
                          L_MDoc.getMDocLCUChar());
   END;
   RESTORE(MDocLCU);
   NEXT(MDocLCU);
  END;

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, RepTop, RepName, "", D);
  SELECT(CUMath, CUMath);
  WHILE OCCURE(CUMath) DO
   PROMPT(CUMath.Math+" "+CUMath.CUCopy);
   SEARCH(CUCopy, CUCopy, , CUMath.CUCopy);
   SEARCH(Math, Math, , CUMath.Math);
   IF CUCopy.Math = CUMath.Math THEN
    MAKEPART(R, RepCUTop, CUMath.Math+" "+Math.Name);
   ELSE
    MAKEPART(R, RepCUTopG, CUMath.Math+" "+Math.Name);
   END;
   IsGroupMath:=(CUCopy.Math # CUMath.Math);
   NARROWSEL(CUMath, Math);
   WHILE OCCURE(CUMath) DO
    SEARCH(CUCopy, CUCopy, , CUMath.CUCopy);
    IF IsGroupMath THEN
     MAKEPART(R, RepCULineG, CUMath.CUCond, CUMath.DocName, CUMath.DocDate, CUMath.CUCChar);
    ELSE
     MAKEPART(R, RepCULine, CUMath.CUCond, CUMath.DocName, CUMath.DocDate, CUMath.CUCChar);
    END;
    NEXT(CUMath);
   END;
   NEXTINEXTENDEDSEL(CUMath, Math);
  END;

  MAKEPART(R, RepBot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {MSRCU};

END.
