(*
%Copyright   (c) Polak Computer System
%Author      29.08.2000 19:27:04 BOR
%Purpose     ᮪ ꥪ⮢   ਭ  ᯫ
%Type        report
%Specific    SYS
%Modified    10.04.2012 12:23:25 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT Memo, L_General, L_OwnData, L_DatTim, L_MathR, L_MDoc, L_Acnt, L_XObj, E_Stock, L_Env;

 VAR
  RepName: STRING[];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_cd(), L, "D.N.y"
@
############################################################ ########## #####
=#####=======================================================================
|           ꥪ ,  ਭ  ᯫ  ##########            |
|---------------------------------------------------------------------------|
|ꥪ                           |                    |      ⮨||
|---------------------------------|-----------------------|---------------|-|
}
*)

(*
$P{ TopKAG:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_cd(), L, "D.N.y"
KAGroup.KAGroup+" "+KAGroup.Name, C, ""
@
############################################################ ########## #####
=#####=======================================================================
| ꥪ,  ਭ  ᯫ  ##########  㯯 த   |
|###########################################################################|
|---------------------------------------------------------------------------|
|ꥪ                           |                    |      ⮨||
|---------------------------------|-----------------------|---------------|-|
}
*)

(*
$P{ Line:
Math.Math, L, ""
Math.Name, L, ""
?, L, ""
?, L, ""
?, R, "2."
?, L, " |"
@
|##### ###########################|## ####################|###############|#|
}
*)

(*
$P{ Bot:
?, R, "2."
@
|---------------------------------------------------------|---------------|-|
|⮣                                                    |###############| |
=(c) Polak===================================================================
}
*)

 PRIVATE PROCEDURE MakeOneMath();
  VAR
   Sum      : L_XObj.tSum;
   HAct     : SCAL[2];
   curAcCuts: L_MathR.tMathAcCutCollection;
 BEGIN
  SAVE(MathKAGL);
  L_MathR.CountUpMath(Math.Math, Memo.ud_mb());
  E_Stock.GetKeyAssNotInOperAcCuts(Memo.ud_mb(), curAcCuts, L_MathR.KA_All, L_MathR.KA_All, L_MathR.KA_All);
  Sum:=L_MathR.GetKeyAssAcCutCollectionRemaindersR(Memo.ud_me()+1, curAcCuts, L_Acnt.ct_Credit);
  HAct:=L_MDoc.PosToLastKeyAssMDoc(Math.Math, Memo.ud_cd());
  IF ~HAct & L_MathR.PosToKAGSoft(Math.Math, Memo.ud_cd()) THEN
   MAKEPART(R, Line, DeprecT.DeprecT, DeprecT.Name, Sum, HAct);
  ELSIF Sum # 0 THEN
   MAKEPART(R, Line, , , Sum, HAct);
  END;
  INC(TSum, Sum);
  RESTORE(MathKAGL);
 END {MakeOneMath};

 VAR
  TSum: L_XObj.tSum;

BEGIN
 SE_ACCESSDATAMODE(AccessDataMode_SOFT);
 TSum:=0;
 IF !MODE | (MODE = 100) THEN
  RepName:="NewKA";
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top);
  SELECT(Math, LeafMK, , 1, L_MathR.mathk_KeyAs);
  WHILE OCCURE(Math) DO
   PROMPT(Math.Math);
   MakeOneMath();
   NEXT(Math);
  END; (* WHILE OCCURE(Math) ... *)
 ELSIF MODE = 101 THEN
  L_General.Assert(ACCESS(KAGroup), " ⭮ 㯯 த ");
  RepName:="NewKG";
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, TopKAG);
  SELECT(MathKAGL, KAGroup, , KAGroup.KAGroup);
  WHILE OCCURE(MathKAGL) DO
   PROMPT(MathKAGL.Math);
   IF L_DatTim.IsActive_Inc(Memo.ud_cd(), MathKAGL.Date, MathKAGL.DateE) THEN
    CONFORM(MathKAGL, Math);
    IF Math.Leaf THEN
     MakeOneMath();
    END;
   END;
   NEXT(MathKAGL);
  END; (* WHILE OCCURE(MathKAGL) ... *)
 ELSE
  L_General.BadMode(MODE);
 END;

 MAKEPART(R, Bot, TSum);
 CLOSEREP(R);
END.
