(*
%Copyright   (c) Polak Computer System
%Author      16.05.2002 16:52:10 LDA
%Purpose     ,  騥   
%Purpose      騥  
%Purpose      騥 ᢥ   -2
%Type        report
%Specific    SYS
%Modified    30.07.2014 18:31:46 POLAK\GAV
%Environment
*)

 MODULE NoINN [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, P_Man, L_AFM, L_Staff, L_Man, L_Env,
        Memo, L_DatTim, L_Russia, Str, P_Firm, L_SFee, L_AR;

 CONST
  Part1   = 0;
  Part2   = 1;

 VAR
  RepName : STRING[];

 PRIVATE PROCEDURE PutDate(_D: DATE): STRING[];
 BEGIN
  IF !_D THEN
   RETURN "";
  ELSE
   RETURN L_DatTim.DateStr(_D);
  END;
 END {PutDate};

(*
$P{ Top:
P_Firm.FP_FirmName(P_Firm.OWN_FIRM, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
?, C, ""
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
}
*)

(*
$P{ Partition:
TMan.Citizen, L, "᪢  |||㣨 ࠭"
@
|----------------------------------------------------------------------------|
|஦ ###########################################################       |
|----------------------------------------------------------------------------|
|, , ⢮                       | |ਭ    |    |
|---------------------------------------------|--------|----------|----------|
}
*)

(*
$P{ Line:
TMan.Name, L, ""
TMan.Man, L, ""
TMan.BegDate, L, "D.N.y"
PutDate(TMan.EndDate), L, ""
@
|#############################################|########|##########|##########|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================
}
*)

(*
$P{ SubTop:
?, C, ""
@
|============================================================================|
|############################################################################|
}
*)

(*
$P{ Top_ManActv:
P_Firm.FP_FirmName(P_Firm.OWN_FIRM, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_cd(), L, "D.N.y"
@
############################################################# ########## #####
=#####========================================================================
|            ᪨ ,  騥 ᢥ               |
|                  -2 (筮 窨)  ##########                  |
|----------------------------------------------------------------------------|
|   |                                     |ࠧ|㤮 ⥫|
|-----|----------------------------------------|-----------|-----------------|
}
*)

(*
$P{ Line_ManActv:
Man.Man, L, ""
Man.Name, L, ""
?, C, "-| "
?, C, "-| "
@
|#####|########################################|###########|#################|
}
*)

 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CreateFILE(TMan, "", "", "");

  CreateFIELD(TMan, Part,    SCAL[2], "", "", "", "ਧ  ஢", "");
  CreateFIELD(TMan, Man,     LIKE(Man.Man), "", "", "", " ", "");
  CreateFIELD(TMan, Name,    LIKE(Man.Name), "", "", "", " ", "");
  CreateFIELD(TMan, Citizen, SCAL[4], "", "", "", "஦", "");
  CreateFIELD(TMan, BegDate, DATE, "", "", "", " ਭ", "");
  CreateFIELD(TMan, EndDate, DATE, "", "", "", " 㢮쭥", "");

  CreateINDEX(TMan, TMan, PLURAL, "", "", Part, Citizen, Name);

  SetVersionOfFILE(TMan, 0);
 END {Create_Tmp};

 PRIVATE PROCEDURE PrintRep(_Part: SCAL[2]);
 BEGIN
  SELECT(TMan, TMan, , _Part);
  WHILE OCCURE(TMan) DO
   NARROWSEL(TMan, Citizen);
   MAKEPART(R, Partition);
   WHILE OCCURE(TMan) DO
    MAKEPART(R, Line);
    NEXT(TMan);
   END; (* WHILE OCCURE(TMan) ... *)
   NEXTINEXTENDEDSEL(TMan, Citizen);
  END; (* WHILE OCCURE(TMan) ... *)
 END {PrintRep};

 PRIVATE PROCEDURE InsTMan(D: DATE; trgPart: SCAL[2]);
 BEGIN
  TMan.Part   :=trgPart;
  TMan.Man    :=Man.Man;
  TMan.Name   :=Man.Name;
  TMan.BegDate:=L_Man.GetTakeOnDate(D);
  TMan.EndDate:=L_Man.GetRealEndDate(D);
  TMan.Citizen:=L_Man.Man_Citizen(Man.Man, D);
  INSERT(TMan);
 END {InsTMan};

 PUBLIC PROCEDURE TestINN();
  VAR
   OnDate: DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  Create_Tmp();
  L_AFM.CreateTemp("TMan");
  RepName:="NoInn";
  OnDate :=Memo.ud_cd();
  SELECT(Man, rsMan, , 1);
  WHILE OCCURE(Man) DO
   PROMPT(Man.Man);
   IF !Man.INN &
      L_Staff.IsStandOnAnyMainContract(Man.Man, OnDate) &
      L_Env.RealTSN(Staff.TSN) &
      L_Staff.rInState(OnDate) &
      (L_Man.Man_Citizen(Man.Man, OnDate) < L_Man.ct_CIS) THEN
    InsTMan(OnDate, Part1);
   END; (* IF !Man.INN... *)
   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, "᪨ ,  騥   "+L_DatTim.DateStr(OnDate));
  PrintRep(Part1);
  MAKEPART(R, Bot);
  CLOSEREP(R);
 END {TestINN};

 PRIVATE PROCEDURE HaveSFee(PwSFee: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
   trgD  : DATE;
 BEGIN
  Result:=0;
  SELECT(ManSFee, Man, , Man.Man);
  WHILE OCCURE(ManSFee) DO
   NARROWSEL(ManSFee, MyFirm);
   SRCINSEL(ManSFee, GE, , Memo.ud_fr());
   WHILE OCCURE(ManSFee) & (ManSFee.Period <= Memo.ud_ut()) DO
    IF ManSFee.Actual & (ManSFee.Object # 0) THEN
     Result:=1;
    END;
    NEXT(ManSFee);
   END;
   NEXTINEXTENDEDSEL(ManSFee, MyFirm);
  END; (* WHILE OCCURE(ManSFee) ... *)
  IF ~Result THEN
   trgD:=L_DatTim.MonthEnd(Memo.ud_ut());
   Result:=L_Staff.IsStandOnAnyMainContract(Man.Man, trgD) & (L_Man.GetTakeOnDate(trgD) >= PwSFee);
  END;
  RETURN Result;
 END {HaveSFee};

 PRIVATE PROCEDURE HaveMoney(): SCAL[2];
 BEGIN
  SELECT(Money, TSN, , Staff.TSN);
  SRCINSEL(Money, GE, , Memo.ud_fr());
  IF OCCURE(Money) THEN
   RETURN Money.Closed <= Memo.ud_ut();
  END;
  RETURN 0;
 END {HaveMoney};

 PRIVATE PROCEDURE NeedManForSIN(): SCAL[2];
  VAR
   trgD: DATE;
 BEGIN
  IF Memo.ud_ut() >= L_SFee.TheStartingPoint THEN
   trgD:=L_DatTim.MonthEnd(Memo.ud_ut());
   IF L_Staff.IsStandOnAnyMainContract(Man.Man, trgD) THEN
    RETURN L_SFee.ManNeedInsureInPF(Man.Man, trgD);
   ELSE
    RETURN 0;
   END;
  ELSE
   RETURN 1;
  END;
 END {NeedManForSIN};

 PUBLIC PROCEDURE TestSINumber();
  VAR
   Found: SCAL[2];
   PwSFee: DATE;
 BEGIN
  L_DatTim.CheckWMIntvl(Memo.ud_fr(), Memo.ud_ut());
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_AR.GrantRightsUnconditionally();
  Create_Tmp();
  L_AFM.CreateTemp("TMan");
  RepName:="NoSIN";

  PwSFee:=L_DatTim.Per(SYSDATE());
  WHILE ~L_SFee.SFeeIsCalculatedInProperConsecution(PwSFee) & (PwSFee >= L_SFee.TheStartingPoint) DO
   PwSFee:=L_DatTim.IncMonth(PwSFee, -1);
  END;

  SELECT(Man, rsMan, , 1);
  WHILE OCCURE(Man) DO
   PROMPT(Man.Man);
   IF L_Env.RealMan(Man.Man) & NeedManForSIN() THEN
    IF ~L_SFee.ManHasSINumber() THEN
     IF Memo.ud_ut() >= L_SFee.TheStartingPoint THEN
      IF L_Staff.InStateInPer(Memo.ud_fr(), Memo.ud_ut()) | HaveSFee(PwSFee) THEN
       IF L_SFee.ManHasADV1() THEN
        InsTMan(Memo.ud_ut(), Part1);
       ELSE
        InsTMan(Memo.ud_ut(), Part2);
       END;
      END;
     ELSE
      Found:=0;
      SELECT(Staff, Man, , Man.Man);
      WHILE OCCURE(Staff) & ~Found DO
       IF L_Staff.InStateInPer(Memo.ud_fr(), Memo.ud_ut()) | HaveMoney() THEN
        Found:=1;
        InsTMan(Memo.ud_ut(), Part1);
       END;
       NEXT(Staff);
      END; (* WHILE OCCURE(Staff) ... *)
     END;
    END;
   END; (* IF L_Env.RealMan... *)
   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, "騥    騥 ꥪ   "+L_DatTim.DateStr(Memo.ud_fr())+"  "+L_DatTim.DateStr(Memo.ud_ut()));
  MAKEPART(R, SubTop, ",  騥    ");
  MAKEPART(R, SubTop, " ");
  PrintRep(Part1);
  MAKEPART(R, SubTop, "  ");
  PrintRep(Part2);

  MAKEPART(R, Bot);
  CLOSEREP(R);
 END {TestSINumber};

 PRIVATE PROCEDURE HaveActv(_ActvKind : LIKE(ManActv.ActvKind)) : SCAL[2];
 BEGIN
  SELECT(ManActv, Man, , Man.Man, _ActvKind);
  WHILE OCCURE(ManActv) DO
   IF ~!ManActv.BegDate & ~!ManActv.EndDate & ~!ManActv.FndName[0] &
              (Str.Item(ManActv.FndName[0], " ", 0) # "") THEN
    RETURN 1;
   END;
   NEXT(ManActv);
  END; (* WHILE OCCURE(ManActv) ... *)
  RETURN 0;
 END {HaveActv};

 PUBLIC PROCEDURE TestManActv();
  VAR
   IsEd,
   IsWr: SCAL[2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  RepName:="NoT2f";
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top_ManActv);
  SELECT(Man, rsMan, , 1);
  WHILE OCCURE(Man) DO
   PROMPT(Man.Man);
   IF L_Env.RealMan(Man.Man) & L_Staff.IsStandOnAnyMainContract(Man.Man, Memo.ud_cd()) &
      L_Staff.rInState(Memo.ud_cd()) THEN
    IsEd:=HaveActv(L_Man.actvk_Education);
    IsWr:=HaveActv(L_Man.actvk_Work);
    IF ~IsEd | ~IsWr THEN
     MAKEPART(R, Line_ManActv, IsEd, IsWr);
    END;
   END;
   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
 END {TestManActv};

END.