(*
%Copyright   (c) Polak Computer System
%Author      02.12.1993 17:15:07 MOG
%Purpose      ⥦ ⥩
%Type        report
%Specific    SYS
%Modified    27.06.2012 18:22:54 POLAK\Gina
%Environment
*)

 MODULE PaySheet [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Str, L_Money, L_AFM, L_PRoll, L_Staff, L_PDoc, Str, Memo, P_Firm;

 CONST
  Depth = 60;    (*62*)
  SWLen = 66;

 VAR
  Page,
  Line: SCAL [250];

  Amount: NUMERIC[0];

  NextMon: DATE;

  Cash_: LIKE(TimeKeep.Cash);

  TotalSum,
  PageSum,
  ToGetSum,
  TakenSum,
  RemndSum,
  CreSld,
  DebtSum  : NUMERIC [2];

  CreSldW,
  TakenSW,
  RemndSW,
  ToGetSW,
  DebtSW : STRING [80][2];

  NeedFutInc,
  WithCash : SCAL[2];

 _sysDateS,
 _sysTimeS : STRING[];
 _FirmName : STRING[][3];

 StaffInCashCount : NUMERIC[0];
 SourceSum : NUMERIC[2];

 PRIVATE PROCEDURE LeadPostName(): STRING[];
 BEGIN
  IF L_General.GetAPSiteID() = "SP" THEN
   RETURN "";
  ELSE
   RETURN P_Firm.FP_LeadPostName1(P_Firm.fomf(PDoc.MyFirm), PDoc.Date);
  END;
 END {LeadPostName};

(*
$P { SheetTop:
_FirmName[0], L, ""
P_Firm.FP_OKPO(P_Firm.fomf(PDoc.MyFirm), PDoc.Date), R, ""
_FirmName[1], L, ""
_FirmName[2], L, ""
L_PDoc.GetCorAcnt(PDoc.PDocKind, PDoc.PDoc), L, ""
PDoc.PrpDate, R, "y"
PDoc.PrpDate, R, "y"
ToGetSW[0], L, ""
ToGetSW[1], L, ""
?, C, ""
LeadPostName(), L, ""
L_Str.ShortName(P_Firm.FP_LeadName(P_Firm.fomf(PDoc.MyFirm), PDoc.Date)), R, ""
L_Str.ShortName(P_Firm.FP_AcntName(P_Firm.fomf(PDoc.MyFirm), PDoc.Date)), R, ""
PDoc.PrpDate, R, "D.N.y"
?, L, ""
?, L, ""
L_PDoc.GetPDocCommentPart(1), C, ""
@
                                      ஢ ଠ N -53
    ⢥ত ⠭ ᪮ ᨨ  05.01.2004 N 1
                                                        ----------
                                          ଠ   | 0301011|
                                                        |--------|
###############################################   |########|
###############################################         |        |
###############################################         |        |
                                                        |--------|
୮ ࠧ _____________________________ |        |
                                                        |--------|
                                 ᯮ騩  | #####  |
                                                        ----------


     ப

 "___" ______________ ####   "___" ______________ #### 

㬬
##################################################################
##################################################################

##################################################################


㪮⥫ ࣠樨

######################## _____________________ ###################

 壠        _____________________ ###################

                             "_____" _________________ ______ 


                  -----------------------  -----------------------
                  |    |       |  |    ਮ  |
                  |㬥|⠢|  |---------------------|
                  |         |           |  |         |        |
         |---------|-----------|  |----------|----------|
         |         |###########|  |##########|##########|
                  -----------------------  -----------------------

##################################################################
}

$P { PageTop:
Page, L, ""
@
                                           ࠭ ###  -53
------------------------------------------------------------------
}

(*
$P{ PTApp0:
?, L, ""
?, R, ""
_sysDateS, L, ""
_sysTimeS, L, ""
@

################################################# ################














                                                    ######## ####
}
*)

$P { CashMark:
Cash_, R, ""
Cash.Name, L, ""
@
| ## ###################################################|
|----------------------------------------------------------------|
}

$P { BodyTop:
@
||.  |,.,.         |㬬,.|  |ਬ|
}

$P { Line:
Line, L, ""
?, L, ""
?, L, ""
SourceSum, R, ",2-"
@
|---|------|----------------------|-------------|---------|------|
|###|######|######################|#############|         |      |
}

$P { PageFil:
@
|---|------|----------------------|-------------|---------|------|
|   |      |                      |             |         |      |
}

$P { PageBot:
Page, L, ""
Line, L, ""
L_Money.MoneyToSpecStr(PDoc.Date, ",", PageSum), L, ""
?, R, ""
?, L, ""
@
|----------------------------------------------------------------|
|࠭ ### ᮤন ### ப  㬬 #######################|
----------------------------------------------------########-####-
}

$P { Total1:
Page, L, ""
Amount, R, "0"
L_Str.ShortName(P_Firm.FP_AcntCashName(P_Firm.fomf(PDoc.MyFirm), SYSDATE())), R, ""
_sysDateS, L, ""
_sysTimeS, L, ""
@

 ⥦  ᮤন ### ⮢, #### ப

 饩 ⥦ 

믫祭_________________________________________________________

__________________________________________________________________

_________________________ .___ .(_____________ .___ .)


஢______________________________________________________

__________________________________________________________________

_________________________ .___ .(_____________ .___ .)


믫 ந   ____________________ __________________________

室 ᮢ थ N ______  "___" _______________ _____.

஢ਫ 壠 ____________________ ##########################

                                "_____" _________________ ______.



⮢ " ⮏" (c) Polak                  ######## ####
}

$P { Total2:
Page, L, ""
Amount, R, "0"
L_Str.ShortName(P_Firm.FP_AcntCashName(P_Firm.fomf(PDoc.MyFirm), SYSDATE())), R, ""
_sysDateS, L, ""
_sysTimeS, L, ""
@

 ⥦  ᮤন ### ⮢, #### ப

 饩 ⥦ 

믫祭_________________________________________________________

__________________________________________________________________

_________________________ .___ .(_____________ .___ .)

 믫祭______________________________________________________

__________________________________________________________________

_________________________ .___ .(_____________ .___ .)

஢______________________________________________________

__________________________________________________________________

_________________________ .___ .(_____________ .___ .)


믫 ந   ____________________ __________________________

室 ᮢ थ N ______  "___" _______________ _____.

஢ਫ 壠 ____________________ ##########################

                                "_____" _________________ ______.



⮢ " ⮏" (c) Polak                  ######## ####
}
*)

 PRIVATE PROCEDURE NoRoomForLine(NeedLines: NUMERIC[0]): SCAL[2];
 BEGIN
  RETURN LINENUM(Mon)+DEPTH(PageFil) >= Depth-NeedLines;
 END {NoRoomForLine};

 PRIVATE PROCEDURE EndPage(ExtraPart: STRING[250]);
  VAR
   ExtraRoom: NUMERIC[0];
 BEGIN
  IF !ExtraPart THEN
   ExtraRoom:=0;
  ELSE
   ExtraRoom:=DEPTH(^ExtraPart);
  END;
  IF NoRoomForLine(DEPTH(PageBot)+ExtraRoom) THEN
   WHILE ~NoRoomForLine(DEPTH(PageBot)) DO
    MAKEPART(Mon, PageFil);
   END;
   MAKEPART(Mon, PageBot, _sysDateS, _sysTimeS);
   FORMFEED(Mon);
  END;
  IF ~!ExtraPart THEN
   BegPage(0);
   WHILE ~NoRoomForLine(DEPTH(PageBot)+ExtraRoom) DO
    MAKEPART(Mon, PageFil);
   END;
   MAKEPART(Mon, PageBot, "-------------", "-------------");
   MAKEPART(Mon, ^ExtraPart);
   FORMFEED(Mon);
  END;
 END {EndPage};

 PRIVATE PROCEDURE BegPage(UnCond: SCAL[2]);
 BEGIN
  IF UnCond | (LINENUM(Mon) = 0) THEN
   SETZERO(PageSum, Line); INC(Page);
   MAKEPART(Mon, PageTop);
   IF  WithCash THEN
    SEARCH(Cash, Cash, , Cash_);
    MAKEPART(Mon, CashMark);
   END;
   MAKEPART(Mon, BodyTop);
  END;
 END {BegPage};

 PRIVATE PROCEDURE MakeLine(RealMake: SCAL[2]; Satellite: SCAL[2]; _IsDeductPayP: SCAL[2]);
 BEGIN
  IF ~_IsDeductPayP THEN
   SourceSum:=PDocList.Sum;
  ELSE
   CONFORM(Deduct, DedAcnt);
   L_General.CallUs(SRCINSEL(DedAcnt, EQ, Memo.ud_mb()));
   SourceSum:=L_General.Denominate(DedAcnt.Period, L_DatTim.Per(SYSDATE()), DedAcnt.NetDebt);
  END;
  IF RealMake THEN
   EndPage("");
   BegPage(0);
   INC(PageSum,  SourceSum); INC(Line);
   DEC(ToGetSum, SourceSum); INC(Amount);
   IF ~_IsDeductPayP THEN
    CONFORM(Staff, Man);
    IF Satellite THEN
     MAKEPART(Mon, Line, Str.Align(Staff.TSN, 6, RIGHT), L_Str.ShortName(Man.Name));
    ELSE
     MAKEPART(Mon, Line, Str.Align(Staff.TSN, 6,  LEFT), L_Str.ShortName(Man.Name));
    END;
   ELSE
    MAKEPART(Mon, Line, "", L_Str.ShortName(Deduct.Person));
   END;
  ELSE
   INC(ToGetSum, SourceSum);
   INC(TotalSum, SourceSum);
  END;
 END {MakeLine};

 PRIVATE PROCEDURE MakeIndex();
  VAR
   MainTSN : LIKE(Staff.TSN);
   MainCash: LIKE(Cash.Cash);
 BEGIN
  SELECT(PDocList, PDoc, , PDoc.PDocKind, PDoc.PDoc);
  WHILE OCCURE(PDocList) DO
   PROMPT(PDocList.TSN + " : ");
   CONFORM(PDocList, Staff);
   L_Staff.PosToStaffLog(Staff.TSN, PDoc.Date, 0);
   MainTSN :=L_PDoc.GetStaffMainTSN(Staff.TSN, PDoc.Date);
   MainCash:=L_PDoc.GetStaffCash(PDoc.Date);
   _Cash._Cash    :=MainCash;
   _Cash.MainTSN  :=MainTSN;
   _Cash.AfterMain:=Staff.TSN # MainTSN;
   _Cash._TSN     :=Staff.TSN;
   INSERT(_Cash);
   NEXT(PDocList);
  END; (* WHILE OCCURE(PDocList) ... *)
 END {MakeIndex};

 PRIVATE PROCEDURE PS_Init1();
  VAR
   CntPerB,
   CntPerE: STRING[];
 BEGIN
  SETZERO(Amount);
  Page:=1; (*쭠*)
  L_Str.SplitStr(ToGetSW, L_Money.ByWord(ToGetSum), SWLen, 2);
  L_Str.SplitStr(_FirmName, P_Firm.MyFirmName(PDoc.MyFirm, SYSDATE()), 47, 10);
  SETEMPTY(CntPerB, CntPerE);
  IF PDoc.Type=L_PDoc.typ_Mass THEN
   CntPerB:=L_DatTim.DateStr(L_DatTim.MonthBeg(PDoc.ServDate));
   CntPerE:=L_DatTim.DateStr(L_DatTim.MonthEnd(PDoc.ServDate));
  END;
  MAKEPART(Mon, SheetTop, "("+L_Money.MoneyToSpecStr(PDoc.Date, ",", ToGetSum)+")", CntPerB, CntPerE);
  IF WithCash THEN
   L_General.CallUs(SEARCH(Cash, Cash, Cash_));
   MAKEPART(Mon, PTApp0, Cash.Name, " " + Cash_);
  ELSE
   MAKEPART(Mon, PTApp0, ""       , "");
  END;
  FORMFEED(Mon);
  BegPage(1);
 END {PS_Init1};

 PRIVATE PROCEDURE PS_Done1();
 BEGIN
  L_General.CallUs(ToGetSum = 0);
  IF L_PRoll.E_MethodOfPDocToMoney(PDoc.Date) = L_PRoll.pdtom_PaidOnly THEN
   EndPage("Total1");
  ELSE
   EndPage("Total2");
  END;
 END {PS_Done1};

 PRIVATE PROCEDURE CrossByStaff(RealMake: SCAL[2]; Prompt: STRING[80]);
 BEGIN
  StaffInCashCount:=0;
  WHILE OCCURE(_Cash) DO
   PROMPT(FLDTOSTR(Cash_) + " " + _Cash._TSN + " : " + Prompt);
   IF SEARCH(PDocList, PDoc, PDoc.PDocKind, PDoc.PDoc, _Cash._TSN) THEN
    L_General.CallUs(SEARCH(Staff, TSN, _Cash._TSN));
    MakeLine(RealMake, _Cash.AfterMain, 0);
    INC(StaffInCashCount);
   END;
   NEXT(_Cash);
  END;
 END {CrossByStaff};

 VAR
  __RealMake: SCAL[2];

 PRIVATE PROCEDURE _MakeLine();
 BEGIN
  MakeLine(__RealMake, 0, 1);
 END {_MakeLine};

 PRIVATE PROCEDURE CrossByPDocList(RealMake: SCAL[2]; Prompt: STRING[80]);
  VAR
   _IsDeductPayP: SCAL[2];
 BEGIN
  _IsDeductPayP:=L_PDoc.IsDeductPayP(PDoc.payp);
  SELECT(PDocList, PDoc, , PDoc.PDocKind, PDoc.PDoc);
  WHILE OCCURE(PDocList) DO
   CONFORM(PDocList, Staff);
   PROMPT(Staff.TSN + " : " + Prompt);
   IF ~_IsDeductPayP THEN
    MakeLine(RealMake, 0, 0);
   ELSE
    CONFORM(Staff, Man);
    __RealMake:=RealMake;
    L_PDoc.ScanDeductTSN(Staff.TSN, PROCREF(_MakeLine));
   END;
   NEXT(PDocList);
  END; (* WHILE OCCURE(PDocList) ... *)
 END {CrossByPDocList};

 PUBLIC PROCEDURE PaySheet(NewRep, needCash: SCAL[2]);
 BEGIN
  WithCash:=needCash;
  L_General.Assert(PDoc.PDocKind = L_PDoc.pd_RKO,
                   "⥦  ᮧ ⮫쪮  室 थ஢");
  IF ~L_PDoc.IsUnClosedSalPDoc(PDoc.mfNbr) & L_PDoc.IsSingleTSN_PDoc() THEN
   IF NewRep THEN
    L_General.Error(" 㬥 ⮫쪮  ⥫" +
                    "| 室  ᮧ ");
   ELSE
    HALT(0);
   END;
  END;
  CONFORM(PDoc, PDocList);
  L_General.Assert(OCCURE(PDocList), "室 थ ");
 
  NeedFutInc :=L_PRoll.E_MPD_PCalc_NeedFutInc(Memo.ud_me());
  _sysDateS  :=FLDTOSTR(SYSDATE(), "yND");
  _sysTimeS  :=FLDTOSTR(SYSTIME(), "HM");
 
  TotalSum:=0;
 
  IF NewRep THEN
   OPENREP(Mon, L_General.NameConnection("PaySh"), Create);
  ELSE
   InitPrintAttr(Mon);
  END;
 
  L_AFM.MakeIndex("_Cash", "_Cash    : LIKE(TimeKeep.Cash);"+
                           "MainTSN  : LIKE(Staff.TSN)    ;"+
                           "AfterMain: SCAL[2]            ;"+
                           "_TSN     : LIKE(Staff.TSN)     " );
 
  IF WithCash THEN
   MakeIndex();
   SELECT(_Cash, _Cash);
   WHILE OCCURE(_Cash) DO
    SETZERO(ToGetSum);
    Cash_:=_Cash._Cash;
    CHANGESEL(_Cash, _Cash, , Cash_);
    CrossByStaff(0, "ᡮ 㬬");
    IF StaffInCashCount > 0 THEN
     FIRST(_Cash);
     PS_Init1();
     CrossByStaff(1, " ");
     PS_Done1();
    END;
    LAST(_Cash);
    CHANGESEL(_Cash, _Cash);
    NEXT(_Cash);
   END; (* WHILE OCCURE(_Cash) ... *)
  ELSE
   SETZERO(ToGetSum);
   CrossByPDocList(0, "ᡮ 㬬");
   PS_Init1();
   CrossByPDocList(1, " ");
   PS_Done1();
  END;
 
  L_General.Assert(TotalSum = PDoc.Total,
                   "  㦥    뤠 㬬." +
                   "||  ⨬.");
 
  IF NewRep THEN
   CLOSEREP(Mon);
  END;
 
  L_AFM.AF_PurgeTemp("_Cash");
 END {PaySheet};

END.
