(*
%Copyright   (c) Polak Computer System
%Author      06.08.2001 19:28:34 RSN
%Purpose      ⥦ 祭  ਮ
%Type        report
%Specific    SYS
%Modified    31.05.2013 19:28:55 POLAK\Bor
%Environment
*)

 IMPORT L_General, L_OwnData, L_PDoc, P_Firm, L_Str, L_DatTim, Memo, L_AFM, L_XDoc, Str;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
?, C, ""
@
###############################################################################################################################################################                                                         ########## #####
=#####==================================================================================================================================================================================================================================
|                                                                               ######### ⥦ 祭  ਮ  ##########  ##########                                                                               |
|######################################################################################################################################################################################################################################|
|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| |      ||祭                                                  |ࠣ                                                       |                                   .             |             㬬|
|------|----------|--|------------------------------------------------------------|--------------------------------------------------------------------|------------------------------------------------------------|------------------|
}
*)

(*
$P{ Line:
PDoc.SrcNbr, R, ""
PDoc.Date, L, "D.N.y"
L_Str.PoolItem("||", PDoc.Status) + L_Str.PoolItem(" |", PDoc.Done), L, ""
?, L, ""
PDoc.Firm, L, ""
?, L, ""
?, L, ""
FirmAcnt.Bank, L, ""
?, L, ""
?, L, ""
PDoc.Total, R, ",2-"
?, L, ""
?, L, ""
?, L, ""
@
|######|##########|##|############################################################|#### ################################################## ############|### ################################## #####################|##################|
|      |          |  |############################################################|     ##################################################             |    ##################################                      |                  |
}
*)

(*
$P{ Bot:
?, R, ",2-"
@
|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|------------------|
|⮣                                                                                                                                                                                                              |##################|
=(c) Polak==============================================================================================================================================================================================================================
}
*)

 PRIVATE PROCEDURE StatusDone(_Status: LIKE(PDoc.Status); _Done: LIKE(PDoc.Done)): STRING[];
 BEGIN
  RETURN ;
 END {StatusDone};

 PRIVATE PROCEDURE MakeRep(RepName: STRING[]; trgPDocKind: LIKE(PDoc.PDocKind);
                           Title, SubTitle: STRING[]; AllPD: SCAL[2]);
  VAR
   _Sum  : NUMERIC[2];
   _Name,
   _Bank,
   _BIC,
   _INN  : STRING[];
   _Acnt,
   aName,
   aBank,
   aAbout: STRING[][2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  APP.Get().NewPrompt("("+RepName+")");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, Title, SubTitle);
  SETZERO(_Sum);
  SETSEL(PDoc, PDKDate, trgPDocKind);
  SRCINSEL(PDoc, GE, , Memo.ud_fr());
  WHILE OCCURE(PDoc) & (PDoc.Date <= Memo.ud_ut()) DO
   PROMPT(L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
   IF (PDoc.Status # L_PDoc.st_Canceled) &
      (AllPD | (PDoc.Status # L_PDoc.st_Prepared)) THEN
    CONFORM(PDoc, Firm);
    P_Firm.CheckFirmAcnt(PDoc.Date, PDoc.Firm, PDoc.FirmAcnt);
    P_Firm.GetFirmData(PDoc.Date, _Name, _Bank, _Acnt, _BIC, _INN, 0);
    Str.Format(aAbout, L_PDoc.PDocAbout(PDoc.PDocKind, PDoc.PDoc), 60, LEFT);
    Str.Format(aName, _Name, 50, LEFT);
    Str.Format(aBank, _Bank, 34, LEFT);

    MAKEPART(R, Line, aAbout[0], aName[0], _INN, aBank[0], _Acnt[1], aAbout[1], aName[1], aBank[1]);
    INC(_Sum, PDoc.Total);
   END;
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc) ... *)
  MAKEPART(R, Bot, _Sum);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {MakeRep};

 PRIVATE PROCEDURE OnePDocKind(trgPDocKind: LIKE(PDoc.PDocKind));
 BEGIN
  APP.Get().NewPrompt(L_PDoc.PDocKindNick(trgPDocKind, 1));
  SETSEL(PDoc, PDKDate, trgPDocKind);
  SRCINSEL(PDoc, GE, , SYSDATE()-45);
  WHILE OCCURE(PDoc) DO
   PROMPT(PDoc.PDoc);
   IF L_PDoc.IsUnClosedSalPDoc(PDoc.mfNbr) THEN
    L_XDoc.sl_AddCurrentXDoc(L_XDoc.xdt_PDoc);
   END;
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc) ... *)
 END {OnePDocKind};

 PUBLIC PROCEDURE MakeListUnClosedSalPDoc();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_XDoc.sl_Init("  ६ ஬");
  OnePDocKind(L_PDoc.pd_RKO);
  OnePDocKind(L_PDoc.pd_IPP);
  L_XDoc.sl_Show();
  L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, L_XDoc.pvs_XDocId, "");
 END {MakeListUnClosedSalPDoc};

 PUBLIC PROCEDURE PD003();
 BEGIN
  MakeRep("PD003", L_PDoc.pd_IPP, "室", "( ஢ )", 0);
 END {PD003};

 PUBLIC PROCEDURE PD013();
 BEGIN
  MakeRep("PD013", L_PDoc.pd_IPP, "室", "( ⮢  ஢ )", 1);
 END {PD013};

 PUBLIC PROCEDURE PD004();
 BEGIN
  MakeRep("PD004", L_PDoc.pd_VPP, "室", "( ஢ )", 0);
 END {PD004};

END.
