(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose     ᯥ⪠ ⥦ 㬥
%Type        operation
%Specific    sys
%Modified    11.06.2014 19:33:19 POLAK\Bor
%Environment
*)

 MODULE PDocP [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_PRoll, L_Money, L_PDoc, L_Str, L_Man, L_ExtAb, L_Pmnt, L_MDoc, L_StdFrm, L_Dest,
        P_Firm, Str, L_XDoc, L_Print, P_Man, L_MSO;

 CONST
  BankLen  = 40;
  FirmLen  = 40;
  AcntLen  = 25;
  OrderWid = 112;

  pt_PDoc           = 0;
  pt_PaySheetByCash = 1;
  pt_PaySheet       = 2;

  pm_Single      = 0;
  pm_Stream      = 1;

  out_Printer      = 0;
  out_File         = 1;
  out_OpenRep      = 2;
  out_ImageAndSend = 3;

 VAR
  InWords   : STRING[150][3];
  StateTxt  : STRING[OrderWid][3];
  PspTxt    : STRING[OrderWid][2];
  _Former,
  _KBK,
  _OKTMO,
  _Reason,
  _Period,
  _DocNbr,
  _DocDate,
  _Type,
  MyKPP,
  ThKPP,
  LeadPostName,
  LeadName,
  AcntName,
  CashName,
  Appeal    : STRING[];
  MyName,
  ThName    : STRING[FirmLen][4];
  MyBank,
  ThBank    : STRING[BankLen][2];
  MyAcnt,
  ThAcnt    : STRING[AcntLen][2];
  MyMFO,
  ThMFO     : LIKE(BankLog.BIC);
  MyINN,
  ThINN     : STRING[];
  _VAT,
  _DetailVAT,
  _SaleTax  : STRING[60];
  _Date     : STRING[10];
  RepDepth  : NUMERIC[0];
  _Name     : STRING[OrderWid][2];

  PrintType : SCAL[3];
  Output    : SCAL[9];
  PrintMode : SCAL[2];

(*
$P{ StateTop:
@
----------------------------------------------------------------------------------------------------------------




                                                                                         "뤠  ࠧ"
}
*)

(*
$P{ StateBot:
L_Str.Left(LeadPostName, 112-Str.Length(" .............................. "+LeadName))+" .............................. "+LeadName, R, ""
PDoc.Date, L, "D.N.y"
Appeal, L, ""
Staff.TSN, L, ""
Man.Name, L, ""
StateTxt[0], L, ""
StateTxt[1], L, ""
StateTxt[2], L, ""
PDoc.Date, L, "D.N.y"
@

################################################################################################################

                                                                                                      ##########






################################################################################################################


 :  #####  ###############################################


                                               뤠 



################################################################################################################
################################################################################################################
################################################################################################################




##########                                                       ........................................
}
*)

(*
$P{ StateSumAndDeadline:
@


                                                                      㬬 ............................. 㡫


                                                                       ப  ....................... 20... 
}
*)


(*
$P{ T_PDocRKO:
?, L, ""
?, L, ""
L_APtm.GetTheDocCause(PDoc.Date, "⢥ত ⠭ ᪮ ᨨ  18.08.98 N 88"), R, ""
P_Firm.FP_FirmName(L_PDoc.GetPDocOwnFirm(), PDoc.Date), L, ""
P_Firm.FP_OKPO(L_PDoc.GetPDocOwnFirm(), PDoc.Date), R, ""
PDoc.SrcNbr, R, ""
PDoc.Date, L, "D.N.y"
L_PDoc.GetCorAcnt(PDoc.PDocKind, PDoc.PDoc), C, ""
PDoc.Dest, C, ""
L_PDoc.GetOwnAcnt(PDoc.PDocKind, PDoc.PDoc), C, ""
PDoc.Total, R, ",2-"
L_PDoc.GetPDocCommentPart(0), L, ""
_Name[0], L, ""
_Name[1], L, ""
L_PDoc.GetPDocCommentPart(1), L, ""
InWords[0], L, ""
InWords[1], L, ""
L_PDoc.GetPDocCommentPart(2), L, ""
LeadPostName, L, ""
LeadName, L, ""
AcntName, L, ""
PDoc.Date, L, "y"
@
##############################################################################
##############################################################################      ஢ ଠ N -2
################################################################################################################
                                                                                              ------------------
                                                                                ଠ   |     0310002    |
###############################################################################         |    ########    |
________________________________________________________________                              |                |
୮ ࠧ                                                          -----------|----------------|
                                                                                   |     | ⠢|
                                                             |----------|----------------|
                                                                                   |######### |   ##########   |
-----------------------------------------------------------------------------------|---------------------------|
|                                                                      |      |              |       | |
|---------------------------------------------------------------------------|।|㬬,..| 楫 | |
| | ୮ ࠧ|., | ᪮ |      |              |祭| |
|-|------------------------------|-----------------|------------------------|------|--------------|----------|-|
| |                              |#################|          ###           |######|##############|          | |
----------------------------------------------------------------------------------------------------------------

뤠:         ################################################################
################################################################################################################
################################################################################################################
᭮:      ################################################################

㬬 ய: ################################################################################################
                ################################################################################################

ਫ:     ################################################################



㪮⥫ ################################ ................................. ################################

 壠                             ................................. ################################



稫.........................................................................................................

..........................................................................................................


"......."................................... #### .            .........................................

}
*)

(*
$P{ Bot1:
PspTxt[0], L, ""
PspTxt[1], L, ""
CashName, L, ""
PDoc.PDoc, L, ""
@
################################################################################################################
################################################################################################################

뤠                                   ................................. ################################



                                                                                                         #######
}
*)

(*
$P{ Bot2:
CashName, L, ""
PDoc.PDoc, L, ""
@
 .............................................................................................................


뤠                                   ................................. ################################



                                                                                                         #######
}
*)

(*
$P{ T_PDocPKO:
?, L ,""
?, L, ""
L_APtm.GetTheDocCause(PDoc.Date, "⢥ত ⠭ ᪮ ᨨ  18.08.98 N 88"), R, ""
P_Firm.FP_FirmName(L_PDoc.GetPDocOwnFirm(), PDoc.Date), L, ""
P_Firm.FP_OKPO(L_PDoc.GetPDocOwnFirm(), PDoc.Date), R, ""
PDoc.SrcNbr, R, ""
PDoc.Date, L, "D.N.y"
L_PDoc.GetOwnAcnt(PDoc.PDocKind, PDoc.PDoc), C, ""
L_PDoc.GetCorAcnt(PDoc.PDocKind, PDoc.PDoc), C, ""
PDoc.Dest, C, ""
PDoc.Total, R, ",2-"
L_PDoc.GetPDocCommentPart(0), L, ""
_Name[0], L, ""
_Name[1], L, ""
L_PDoc.GetPDocCommentPart(1), L, ""
InWords[0], L, ""
InWords[1], L, ""
_VAT, L, ""
_DetailVAT, L, ""
_SaleTax, L, ""
L_PDoc.GetPDocCommentPart(2), L, ""
AcntName, L, ""
CashName, L, ""
PDoc.PDoc, L, ""
@
##############################################################################
##############################################################################      ஢ ଠ N -1
################################################################################################################
                                                                                              ------------------
                                                                                ଠ   |     0310001    |
###############################################################################         |    ########    |
________________________________________________________________                              |                |
୮ ࠧ                                                          -----------|----------------|
                                                                                   |     | ⠢|
                                                             |----------|----------------|
                                                                                   |######### |   ##########   |
-----------------------------------------------------------------------------------|---------------------------|
|      |                                ।                                     |              |       | |
| |---------------------------------------------------------------------------|㬬,..| 楫 | |
|      | | ୮ ࠧ|., | ᪮ |              |祭| |
|------|-|------------------------------|-----------------|------------------------|--------------|----------|-|
|######| |                              |#################|          ###           |##############|          | |
----------------------------------------------------------------------------------------------------------------

ਭ :     ################################################################
################################################################################################################
################################################################################################################
᭮:      ################################################################

㬬 ய: ################################################################################################
                ################################################################################################


 ⮬ ᫥ ####################################################
################################################################################################################

################################################################



ਫ:     ################################################################################################



 壠                             ................................. ################################

                                        ................................. ################################









                                                                                                         #######
}
*)

(*
$P{ B_PDocPKO:
P_Firm.FP_FirmName(L_PDoc.GetPDocOwnFirm(), PDoc.Date), L, ""
PDoc.SrcNbr, L, ""
L_DatTim.FullDateStr(PDoc.Date), L, ""
L_PDoc.GetPDocCommentPart(0), L, ""
_Name[0], L, ""
_Name[0], L, ""
L_PDoc.GetPDocCommentPart(1), L, ""
PDoc.Total, L, ",2-"
InWords[0], L, ""
InWords[1], L, ""
_VAT, L, ""
_DetailVAT, L, ""
_SaleTax, L, ""
L_DatTim.FullDateStr(PDoc.Date), L, ""
AcntName, L, ""
CashName, L, ""
@
================================================== १==================================================




################################################################################################################


  室  ᮢ  थ N ########  ########################################################



ਭ :     ################################################################
################################################################################################################
################################################################################################################

᭮:      ################################################################


㬬:          #############################


㬬 ய: ################################################################################################
                ################################################################################################


 ⮬ ᫥ ####################################################
################################################################################################################

################################################################


 ###############################################################

               .. (⠬)



 壠                             ................................. ################################

                                        ................................. ################################

}
*)

(*
$P{ Banner:
PDoc.SrcNbr, L, ""
PDoc.PrpDate, L, "D.N.y"                          "U"
PDoc.PmntKind, L, "⮩|⥫䮬|஭| " "U"
_Former, C, ""
InWords[0], L, ""
InWords[1], L, ""
InWords[2], L, ""
MyINN, L, ""
MyKPP, L, ""
PDoc.Total, L, "2-"
MyName[0], L, ""
MyName[1], L, ""
MyName[2], L, ""
MyAcnt[0], L, ""
MyName[3], L, ""
MyBank[0], L, ""
MyMFO, L, ""
MyBank[1], L, ""
MyAcnt[1], L, ""
ThBank[0], L, ""
ThMFO, L, ""
ThBank[1], L, ""
ThAcnt[1], L, ""
ThINN, L, ""
ThKPP, L, ""
ThAcnt[0], L, ""
ThName[0], L, ""
ThName[1], L, ""
_Date, L, ""
ThName[2], L, ""
PDoc.Queue, L, ""
ThName[3], L, ""
?, L, ""
?, L, ""
_KBK, C, ""
_OKTMO, C, ""
_Reason, C, ""
_Period, C, ""
_DocNbr, C, ""
_DocDate, C, ""
_Type, C, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
_______________            _______________                     ---------
.   .         ᠭ  ..                 |0401060|
                                                               ---------
  N ############ ##############  ##############   |##|
                                                ⥦      ----

㬬   |###############################################################
ய|###############################################################
        |###############################################################
        |
------------------------------------------------------------------------
 #############  | ################|㬬|#########################
----------------------------------------|     |
########################################|     |
########################################|-----|-------------------------
########################################| .N|#########################
########################################|     |
⥫騪                              |     |
----------------------------------------|-----|
########################################|  |#########
########################################|-----|
 ⥫騪                        | .N|#########################
----------------------------------------|-----|-------------------------
########################################|  |#########
########################################|-----|
 ⥫                         | .N|#########################
----------------------------------------|-----|
 #############  | ################| .N|#########################
----------------------------------------|     |
########################################|-----|-------------------------
########################################| |01        |ப |##########
########################################|.|          |.|#
########################################|  |##########|.|
⥫                              |     |##########|       |
------------------------------------------------------------------------
CharsPerLine=76 ####################|###########|##|##########|###############|##########|##CharsPerLine=72 
------------------------------------------------------------------------
########################################################################
########################################################################
########################################################################
########################################################################


祭 ⥦
------------------------------------------------------------------------
                                                ⬥⪨ 

                     ________________________
        ..


                     ________________________
}
*)

(*
$P{ CBStamp:
?, "L", ""
?, "L", ""
SYSDATE(), "L", "D.N.y"
L_DatTim.LongSystimeStr(), "L", "00:00:00"
LOGINNAME()+" - "+FULLNAME(), "L", ""
PDoc.PDoc, L, ""
@



------------------------------------------------------------------------
|㬥 ।  "-": ####################################|
|⠬ ।: ########################################              |
|            ----------------          ⯥⠭: ########## #########|
|            |              |                                          |
|ᯮ⥫ |              | #########################################|
|----------------------------------------------------------------------|
| ࠡ⪨ 㬥                                  |
|ਭ     -------------      -------------          ----------------|
|------- |   |   |   | ६|   |   |   | ⠭|               |
| ⪠      |---------------------------------------------------------|
|            |              |                                          |
|ᯮ⥫ |              |                                          |
----------------------------------------------------------------#######-}
*)

(*
$P{ NonCBStamp:
PDoc.PDoc, L, ""
@
















                                                                ####### }
*)

(*
$P{ OVN:
PDoc.SrcNbr, L, ""
L_DatTim.FullDateStr(PDoc.Date), C, ""
?, L, "" "U"
FirmAcnt.AcntA , C, ""
?, L, "" "U"
BankLog.RegName[0], L, "" "U"
PDoc.Total, C, "2-"
BankLog.RegName[1], L, "" "U"
" ", L, "" "U"
?, L, "" "U"
?, L, "" "U"
L_PDoc.GetPDocCommentPart(1), L, "" "U"
PDoc.SrcNbr, L, ""
L_DatTim.FullDateStr(PDoc.Date), C, ""
?, L, "" "U"
FirmAcnt.AcntA, C, ""
?, L, "" "U"
BankLog.RegName[0], L, "" "U"
PDoc.Total, C, "2-"
BankLog.RegName[1], L, "" "U"
" ", L, "" "U"
?, L, "" "U"
?, L, "" "U"
L_PDoc.GetPDocCommentPart(1), L, "" "U"
PDoc.PDoc, L, ""
PDoc.SrcNbr, L, ""
L_DatTim.FullDateStr(PDoc.Date), C, ""
?, L, "" "U"
"", L, ""
?, L, "" "U"
PDoc.Total, C, "2-"
?, L, ""
BankLog.BIC, C, ""
FirmAcnt.AcntA, C, ""
?, L, ""
?, L, ""
" ", L, ""
L_PDoc.GetPDocCommentPart(1), L, "" "U"
@
               N ###################                            0402001
        

    #########################
                                                      ---------------------------
                                     . |                         |
#########################################   N   |#########################|
#########################################             |-------------------------|
 ⥫                                       |                         |
##################################################### |#########################|
##################################################### |      㬬 ࠬ      |
⥫                                            |                         |
##################################################### ---------------------------

㬬 ய  #################################################################
                #################################################################
筨  #################################################################

_________________________________________________________________________________
 ⥫                          壠

                                           죨 ਭ 

---------------------------------------------------------------------------------

                N #########                                      0402001

    #########################
                                                      ---------------------------
                                     . |                         |
#########################################   N   |#########################|
#########################################             |-------------------------|
 ⥫                                       |                         |
##################################################### |#########################|
##################################################### |      㬬 ࠬ      |
⥫                                            |                         |
##################################################### ---------------------------

㬬 ய  #################################################################
                #################################################################
筨  #################################################################

_________________________________________________________________________________
    ..           壠                  죨 ਭ 
                                                                          #######
---------------------------------------------------------------------------------

                    N #########                                      0402001

    #########################

                                                                㬬
                                   ----------------------------------------
######################################## | N ############ |                 |
######################################## ---------------------|#################|
                                                        |                 |
--------------------------------------------------------------|            |
 ⥫           |      |                         |-----------------|
##########################|#########|#########################|    |ᨬ- |
##########################|         |                         |           | |
##########################|         |                         |-----------|-----|
------------------------------------|                         |-----------|-----|
⥫                          |                         |-----------|-----|
####################################|                         |-----------|-----|
                                    | N                   |-----------|-----|
---------------------------------------------------------------------------------
筨  #################################################################

壠                                 
}
*)

(*
$P{ SimplePDoc:
PDocKind.SName, L, ""
PDoc.PDoc, R, ""
PDoc.SrcNbr, L, ""
PDoc.Date, L, "D.N.y"
PDoc.PDoc, L, ""
PDoc.Dest, L, ""
Dest.Name, L, ""
PDoc.Total, R, "2-"
(~!PDoc.Queue), L, " |।"
PDoc.Queue, L, ""
L_PDoc.GetPDocCommentPart(0), L, ""
PspTxt[0], L, ""
PspTxt[1], L, ""
L_PDoc.GetPDocCommentPart(1), L, ""
L_PDoc.GetPDocCommentPart(2), L, ""
?, L, ""
@
================================================================

################################ #########
############                    ##########               #######

 樨 ### ################################

 㬬 ##################                ####### ##

################################################################
################################################################
################################################################
################################################################
################################################################
################################################################
================================================================
}                
*)

 PRIVATE PROCEDURE FillSaleTaxStr();
 BEGIN
  IF   !PDoc.SaleTax THEN
   _SaleTax:="";
  ELSIF PDoc.SaleTax=0 THEN
   _SaleTax:="   த";
  ELSE
   _SaleTax:=" ⮬ ᫥   த: " +
             L_Money.MoneyToStr(PDoc.Date, ",", PDoc.SaleTax);
  END;
 END {FillSaleTaxStr};

 PRIVATE PROCEDURE GetMDocBruttobyRate(VAR Bruttos: L_Pmnt.tValuesByVATRate; _Total: LIKE(PDocMDoc.Total));
  VAR
   VATRate,
   maxVR   : L_Pmnt.tVATRates;
   Result  : L_Pmnt.tValuesByVATRate;
   maxRes  : NUMERIC[2];
   i       : NUMERIC[0];
   T, Tot, Sum: LIKE(PDocMDoc.Total);
 BEGIN
  SETZERO(Result, Tot);
  maxRes:=MINOF(maxRes);
  SETEMPTY(maxVR);
  IF (MDoc.Status#L_MDoc.st_Canceled) THEN
   CONFORM(MDoc, MDocList);
   WHILE OCCURE(MDocList) DO
    VATRate:=L_Pmnt.GetMDocListVATRate();
    Sum:=MDocList.Sum+MDocList.VAT+MDocList.SaleTax;
    INC(Result[VATRate], Sum);
    IF Result[VATRate] > maxRes THEN
     maxRes:=Result[VATRate];
     maxVR :=VATRate;
    END;
    INC(Tot, Sum);
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)
  END;
  IF Tot # 0 THEN
   T:=0;
   i:=0;
   WHILE i<HIGH(Result) DO
    IF i # maxVR THEN
     Result[i]:=Result[i]*_Total/Tot;
     INC(T, Result[i]);
     INC(Bruttos[i], Result[i]);
    END;
    INC(i);
   END;
   Result[maxVR]:=_Total-T;
   INC(Bruttos[maxVR], Result[maxVR]);
  END;
 END {GetMDocBruttobyRate};

 PRIVATE PROCEDURE FillDetailVatStr();
  VAR
   VbVR: L_Pmnt.tValuesByVATRate;
   Count, i: NUMERIC[0];
 BEGIN
  SETZERO(VbVR);
  _DetailVAT:="";
  IF (PDoc.NDS # 0) & ~!PDoc.NDS & L_PDoc.IsPDocwMDoc() THEN
   CONFORM(PDoc, PDocMDoc);
   WHILE OCCURE(PDocMDoc) DO
    CONFORM(PDocMDoc, MDoc);
    GetMDocBruttobyRate(VbVR, PDocMDoc.Total);
    NEXT(PDocMDoc);
   END; (* WHILE OCCURE(PDocMDoc) ... *)
  END;
  Count:=0;
  i:=0;
  WHILE i<HIGH(VbVR) DO
   IF VbVR[i] # 0 THEN
    INC(Count);
    IF ~!_DetailVAT THEN
     _DetailVAT:=_DetailVAT+"; ";
    END;
    _DetailVAT:=_DetailVAT+L_Str.NumericStr(VbVR[i], 2)+" ("+L_Str.IntStr(L_Pmnt.VATValue(i))+"%)";
   END;
   INC(i);
  END;
  IF Count <= 1 THEN
   _DetailVAT:="";
  END;
 END {FillDetailVatStr};

 PRIVATE PROCEDURE GetFormatedFirmData(VAR _Name: STRING[FirmLen][4];
                                       VAR _Bank: STRING[BankLen][2];
                                       VAR _Acnt: STRING[AcntLen][2];
                                       VAR _BIC_: STRING[];
                                       VAR _INN_: STRING[]);
  VAR
   _longBank,
   _longFirm: STRING[];
 BEGIN
  P_Firm.GetFirmData(PDoc.Date, _longFirm, _longBank, _Acnt,  _BIC_, _INN_, ~L_PDoc.CB_IsUploadedPDoc(PDoc.PDocKind, PDoc.PDoc));
  L_Str.FormatStr(_Bank, _longBank, BankLen);
  L_Str.FormatStr(_Name, _longFirm, FirmLen);
 END {GetFormatedFirmData};

 PRIVATE PROCEDURE PrintIPP_VPP(IsIPP: SCAL[2]);
  VAR
   curCode,
   Rest,
   _About   : STRING[];
   ArrAbout : STRING[][4];
   _PayLAmnt: NUMERIC[0];
   curCodeArr: STRING[10][2];
 BEGIN
  L_Str.FormatStr(InWords, L_Money.ByWord(PDoc.Total), 63);
  P_Firm.AccessOwnFirm(PDoc.MyFirm);
  P_Firm.CheckFirmAcnt(PDoc.Date, Firm.Firm, PDoc.OwnAcnt);
  IF IsIPP THEN
   GetFormatedFirmData(MyName, MyBank, MyAcnt, MyMFO, MyINN);
  ELSE
   GetFormatedFirmData(ThName, ThBank, ThAcnt, ThMFO, ThINN);
  END;

  CONFORM(PDoc, Firm);
  P_Firm.CheckFirmAcnt(PDoc.Date, Firm.Firm, PDoc.FirmAcnt);
  IF IsIPP THEN
   GetFormatedFirmData(ThName, ThBank, ThAcnt, ThMFO, ThINN);
  ELSE
   GetFormatedFirmData(MyName, MyBank, MyAcnt, MyMFO, MyINN);
  END;

  L_ExtAb.SliceExtAbout(PDoc.ExtAbout,
                        _Former, _KBK, _OKTMO, _Reason,
                        _Period, _DocNbr, _DocDate, _Type, curCode);
  L_Str.SplitStr(curCodeArr, curCode, 10, 2);

  IF L_PDoc.PDocMustHaveKPP() THEN
   IF IsIPP THEN
    MyKPP:=L_PDoc.GetPDocOwnFirmKPP();
    ThKPP:=P_Firm.FP_KPP(Firm.Firm, PDoc.Date);
   ELSE
    MyKPP:=P_Firm.FP_KPP(Firm.Firm, PDoc.Date);
    ThKPP:=L_PDoc.GetPDocOwnFirmKPP();
   END;
  ELSE
   SETEMPTY(MyKPP, ThKPP);
  END;

  _About:=L_PDoc.GetFullPDocAbout();
  Str.Format(ArrAbout, _About, 72, LEFT, Rest);
  ArrAbout[3]:=Str.Condense(ArrAbout[3] + " " + Rest);

  IF 1 (*ப ⥦    㪠  ᨨ*) |
       (PDoc.Date = PDoc.PrpDate) THEN
   _Date:="";
  ELSE
   _Date:=FLDTOSTR(PDoc.Date, "D.N.y", 10);
  END;
  InitPrintAttr(Mon, LeftMargin, 20,
                     RightMargin, 10,
                     TopMargin, 10,
                     CharsPerLine, 72,
                     LinesPerPage, 66,
                     SpreadLinInPage, 72);
  IF L_PDoc.CB_IsUploadedPDoc(PDoc.PDocKind, PDoc.PDoc) THEN (*  㬥 "-" *)
   MAKEPART(Mon, Banner, curCodeArr[0], curCodeArr[1], ArrAbout[0], ArrAbout[1], ArrAbout[2], ArrAbout[3]);
   MAKEPART(Mon, CBStamp,
            L_PDoc.CB_GetClientBankName(L_PDoc.CB_GetPDocClientBank(PDoc.PDocKind, PDoc.PDoc)),
            L_PDoc.CB_GetStamp(PDoc.PDocKind, PDoc.PDoc));
   FORMFEED(Mon);
  ELSE
   _PayLAmnt:=L_PDoc.E_DefaultPayLAmnt(PDoc.Date);
   WHILE _PayLAmnt > 0 DO
    MAKEPART(Mon, Banner, curCodeArr[0], curCodeArr[1], ArrAbout[0], ArrAbout[1], ArrAbout[2], ArrAbout[3]);
    MAKEPART(Mon, NonCBStamp);
    FORMFEED(Mon);
    DEC(_PayLAmnt);
   END;
  END;
 END {PrintIPP_VPP};

 PRIVATE PROCEDURE GetOrderFirmName();
 BEGIN
  IF PDoc.Firm # L_PDoc.GetPDocOwnFirm() THEN
   CONFORM(PDoc, Firm);
   L_Str.FormatStr(_Name, P_Firm.FP_FirmName(Firm.Firm, PDoc.Date), OrderWid);
  ELSE
   SETEMPTY(_Name);
  END;
 END {GetOrderFirmName};

 PRIVATE PROCEDURE GetCashierName(): STRING[];
 BEGIN
  IF L_PDoc.MoneyKind(PDoc.PDocKind) = L_PDoc.mk_OprDskCash THEN
   RETURN L_Str.ShortName(P_Man.GetFullNameOfCurrentUser(SYSDATE()));
  ELSE
   RETURN L_Str.ShortName(P_Firm.FP_CashName(L_PDoc.GetPDocOwnFirm(), PDoc.Date));
  END;
 END {GetCashierName};

 PRIVATE PROCEDURE PspToStr(Wid: NUMERIC[0]; VAR PspTxt: STRING[OrderWid][2]);
 BEGIN
  CONFORM(PDoc, PDocList);
  CONFORM(PDocList, Staff, Man);
  L_Str.FormatStr(PspTxt, ": " + L_Man.GetManDocAttr_asStr(), Wid);
 END {PspToStr};

 PRIVATE PROCEDURE Print_RKO();
  CONST
   dcm_Len = 78;
  VAR
   DocDraftsman: STRING[dcm_Len][2];
 BEGIN
  L_Str.FormatStr(InWords, L_Money.ByWord(PDoc.Total), OrderWid);
  L_Str.FormatStr(DocDraftsman, L_APtm.GetTheDocDraftsman(PDoc.Date, ""), dcm_Len);

  RepDepth:=(DEPTH(T_PDocRKO)+DEPTH(Bot1))*2;
  SetPrintAttr(Mon, LeftMargin, 20, RightMargin, 20,
                    SpreadLinInPage, RepDepth, MinLinesPerPage, 80,
                    SpreadChrInLine, OrderWid, MinCharsPerLine, 81);
  IF L_PDoc.E_NeedSignInKO(PDoc.Date) THEN
   IF L_General.GetAPSiteID() = "SP" THEN
    SETEMPTY(LeadPostName);
   ELSE
    LeadPostName:=Str.Small(P_Firm.FP_LeadPostName1(L_PDoc.GetPDocOwnFirm(), PDoc.Date), 0, 1);
   END;
   LeadName    :=L_Str.ShortName(P_Firm.FP_LeadName(L_PDoc.GetPDocOwnFirm(), PDoc.Date));
   AcntName    :=P_Firm.FP_RealAcntName_Short(L_PDoc.GetPDocOwnFirm(), PDoc.Date);
  ELSE
   SETEMPTY(LeadPostName);
   LeadName    :=".........................................";
   AcntName    :=".........................................";
  END;
  CashName     :=GetCashierName();
  GetOrderFirmName();
  IF L_PDoc.IsSingleTSN_PDoc() THEN
   MAKEPART(Mon, T_PDocRKO, DocDraftsman[0], DocDraftsman[1]);
   IF L_PDoc.E_NeedPasspInPDoc(PDoc.Date) & (!L_PDoc.GetPDocCommentPart(2) | ~L_PDoc.IsSalPDoc()) THEN
    PspToStr(OrderWid, PspTxt);
    MAKEPART(Mon, Bot1);
   ELSE
    MAKEPART(Mon, Bot2);
   END;
   IF ~L_PDoc.IsSalPDoc() & L_PRoll.E_NeedCashIssueStatement(PDoc.Date) THEN
    Appeal:="㪮⥫ " + P_Firm.FP_ContractorBriefName(L_PDoc.GetPDocOwnFirm(), PDoc.Date);
    L_Str.FormatStr(StateTxt, " 뤠  " + Str.Small(L_PDoc.GetPDocCommentPart(1), 0, 1) + " " +
                              L_Money.MoneyToStr(PDoc.Date, ",", PDoc.Total) +
                              " (" + L_Money.ByWord(PDoc.Total) + ").", OrderWid);
    MAKEPART(Mon, StateTop);
    IF PDoc.Dest = L_Dest.erkn_GetSoft(PDoc.Date, L_Dest.erkn_SumPaidOutOnAccount) THEN
     MAKEPART(Mon, StateSumAndDeadline);
    END;
    MAKEPART(Mon, StateBot);
   END;
  ELSE
   MAKEPART(Mon, T_PDocRKO, DocDraftsman[0], DocDraftsman[1]);
   MAKEPART(Mon, Bot2);
  END;
  FORMFEED(Mon);
 END {Print_RKO};

 PRIVATE PROCEDURE Print_PKO();
  CONST
   dcm_Len = 78;
  VAR
   DocDraftsman: STRING[dcm_Len][2];
 BEGIN
  L_Str.FormatStr(InWords, L_Money.ByWord(PDoc.Total), OrderWid);
  RepDepth:=DEPTH(T_PDocPKO)*2;
  SetPrintAttr(Mon, LeftMargin, 20, RightMargin, 20,
                    SpreadLinInPage, RepDepth, MinLinesPerPage, 80,
                    SpreadChrInLine, OrderWid, MinCharsPerLine, 81);
  _VAT:=L_PDoc.VatStr();
  FillDetailVatStr();
  FillSaleTaxStr();
  IF L_PDoc.E_NeedSignInKO(PDoc.Date) THEN
   AcntName:=L_Str.ShortName(P_Firm.FP_AcntName(L_PDoc.GetPDocOwnFirm(), PDoc.Date));
  ELSE
   AcntName:=".........................................";
  END;
  CashName:=GetCashierName();
  GetOrderFirmName();
  L_Str.FormatStr(DocDraftsman, L_APtm.GetTheDocDraftsman(PDoc.Date, ""), dcm_Len);
  MAKEPART(Mon, T_PDocPKO, DocDraftsman[0], DocDraftsman[1]);
  MAKEPART(Mon, B_PDocPKO);
  FORMFEED(Mon);
 END {Print_PKO};

 PRIVATE PROCEDURE Print_IPP();
 BEGIN
  PrintIPP_VPP(1);
 END {Print_IPP};

 PRIVATE PROCEDURE Print_VPP();
 BEGIN
  PrintIPP_VPP(0);
 END {Print_VPP};

 PRIVATE PROCEDURE Print_OVN();
  CONST
   TotStrLen   = 65;
   BankNameLen = 26;
   FirmNameLen = 41;
  VAR
   TotStr    : STRING[TotStrLen][2];
   BankName  : STRING[BankNameLen][3];
   FirmName  : STRING[FirmNameLen][2];
 BEGIN
  CONFORM(PDoc, PDocKind, Dest);
  SEARCH(Firm, Firm, , L_PDoc.GetPDocOwnFirm());
  CONFORM(Firm, FirmAcnt);
  SRCINSEL(FirmAcnt, EQ, , PDoc.OwnAcnt);
  CONFORM(FirmAcnt, Bank);
  HISTCONF(PDoc.Date, Bank, BankLog);
  IF OCCURE(BankLog) THEN
   Str.Format(BankName, L_Str.StrFormat(BankLog.RegName), BankNameLen, LEFT);
  END;
  Str.Format(TotStr,   L_Money.ByWord(PDoc.Total),      TotStrLen,   LEFT);
  Str.Format(FirmName, P_Firm.FP_FirmName(L_PDoc.GetPDocOwnFirm(), PDoc.Date), FirmNameLen, LEFT);
  MAKEPART(Mon, OVN, FirmName[0], FirmName[1], TotStr[0], TotStr[1],
                     FirmName[0], FirmName[1], TotStr[0], TotStr[1],
                     FirmName[0], FirmName[1], BankName[0], BankName[1],
                     BankName[2]);
 END {Print_OVN};

 PRIVATE PROCEDURE Print_XYZ();
  VAR
   refToXDocId: L_XDoc.tXDocId;
   RefPDocStr : STRING[];
 BEGIN
  CONFORM(PDoc, PDocKind, Dest);
  refToXDocId:=L_XDoc.GetBaseOnXDocId(L_XDoc.curXDocId(L_XDoc.xdt_PDoc));
  IF ~!refToXDocId THEN
   RefPDocStr:="易 㬥: " + L_XDoc.XDocStr(refToXDocId);
  ELSE
   RefPDocStr:="";
  END;
  IF L_PDoc.IsSingleTSN_PDoc() THEN
   PspToStr(64, PspTxt)
  ELSE
   SETEMPTY(PspTxt);
  END;
  MAKEPART(Mon, SimplePDoc, RefPDocStr);
 END {Print_XYZ};

 PRIVATE PROCEDURE PrintPDoc();
  VAR
   IsPrepared           : SCAL[2];
   re_EXCEPTION_HANDLING: NUMERIC[0];
 BEGIN
  IF Output # out_OpenRep THEN
   L_PDoc.AccessPDoc();
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  END;
  IF PDoc.Status = L_PDoc.st_Prepared THEN
   re_EXCEPTION_HANDLING:=EXCEPTION_HANDLING_OFF;
   IsPrepared:=1;
  ELSE
   re_EXCEPTION_HANDLING:=EXCEPTION_HANDLING_ON;
   IsPrepared:=0;
  END;
  TRY [EXCEPTION_HANDLING(re_EXCEPTION_HANDLING)]
   IF PrintType = pt_PDoc THEN
    IF PDoc.Status = L_PDoc.st_Canceled THEN
     IF Output = out_Printer THEN
      L_Print.PrintCancelledXDoc(L_XDoc.curXDocId(L_XDoc.xdt_PDoc));
     ELSE
      L_General.Error("㬥 㫨஢");
     END;
    ELSIF (PrintMode = pm_Single) & ((Output = out_File) | (Output = out_Printer)) &
          L_PDoc.E_PDocP_SpecialPrint(Output) THEN
     IF    Output = out_Printer THEN
      CALL(O_PDoc.MakeDoc(L_MSO.PrpMode_Print));
     ELSIF Output = out_ImageAndSend THEN
      CALL(O_PDoc.MakeDoc(L_MSO.PrpMode_ToImage));
     ELSIF Output = out_File THEN
      CALL(O_PDoc.MakeDoc(L_MSO.PrpMode_ToDoc));
     END;
    ELSE
     IF    Output = out_Printer THEN
      OPENREP(Mon, L_General.NameConnection("PDocP"), Print);
     ELSIF Output = out_File THEN
      OPENREP(Mon, L_General.NameConnection("PDocP"), Create);
     END;
     SetPrintAttr(Mon, FontProperty, "/U /B /I",
                       Duplex, Off);
     IF    (PDoc.PDocKind=L_PDoc.pd_RKO) | (PDoc.PDocKind=L_PDoc.pd_ROO) THEN
      Print_RKO();
     ELSIF (PDoc.PDocKind=L_PDoc.pd_PKO) | (PDoc.PDocKind=L_PDoc.pd_POO) THEN
      Print_PKO();
     ELSIF PDoc.PDocKind=L_PDoc.pd_IPP THEN
      Print_IPP();
     ELSIF PDoc.PDocKind=L_PDoc.pd_VPP THEN
      Print_VPP();
     ELSIF (PDoc.PDocKind=L_PDoc.pd_VMO) | (PDoc.PDocKind=L_PDoc.pd_IMO) |
           (PDoc.PDocKind=L_PDoc.pd_VTP) | (PDoc.PDocKind=L_PDoc.pd_ITP) |
           (PDoc.PDocKind=L_PDoc.pd_CND) THEN
      Print_XYZ();
     ELSIF PDoc.PDocKind=L_PDoc.pd_OVN THEN
      Print_OVN();
     END; (* IF PDoc.PDocKind = ... *)
     IF Output # out_OpenRep THEN
      CLOSEREP(Mon);
     END;
     IF (PrintMode # pm_Stream) & (Output = out_File) THEN
      L_General.SurveyLastReport();
     END;
    END;
   ELSE
    IF    PDoc.PDocKind=L_PDoc.pd_RKO THEN
     CALL(PaySheet.PaySheet(Output=out_File, PrintType=pt_PaySheetByCash));
    ELSIF PDoc.PDocKind=L_PDoc.pd_IPP THEN
     IF    Output = out_File THEN
      CALL(PDocLP.PDocLP(1));
     ELSIF Output = out_OpenRep THEN
      CALL(PDocLP.PDocLP(0));
     END;
    ELSE
     L_General.Error("   㬥⮢  ।ᬮ७  ⥦ ");
    END;
   END;
  EXCEPT
  ON Exc: Exc_Raise DO
   RAISE();
  ON Exc: Exc_Root DO
   IF IsPrepared THEN
    L_General.Error("  㬥 ந諠 訡|⭮,  맢 ⥬,     ஢"+L_StdFrm.HR()+"஢   ஡  ");
   ELSE
    RAISE();
   END;
  END;
 END {PrintPDoc};

 PUBLIC PROCEDURE Print();
 BEGIN
  PrintMode:=pm_Single;
  PrintType:=pt_PDoc;
  Output   :=out_Printer;
  PrintPDoc();
 END {Print};

 PUBLIC PROCEDURE Print_InFile();
 BEGIN
  PrintMode:=pm_Single;
  PrintType:=pt_PDoc;
  Output   :=out_File;
  PrintPDoc();
 END {Print_InFile};

 PUBLIC PROCEDURE Print_InOpenRep();
 BEGIN
  PrintMode:=pm_Single;
  PrintType:=pt_PDoc;
  Output   :=out_OpenRep;
  PrintPDoc();
 END {Print_InOpenRep};

 PUBLIC PROCEDURE PrintPaySheetByCash();
 BEGIN
  PrintMode:=pm_Single;
  PrintType:=pt_PaySheetByCash;
  Output   :=out_File;
  PrintPDoc();
 END {PrintPaySheetByCash};

 PUBLIC PROCEDURE PrintPaySheet();
 BEGIN
  PrintMode:=pm_Single;
  PrintType:=pt_PaySheet;
  Output   :=out_File;
  PrintPDoc();
 END {PrintPaySheet};

 PUBLIC PROCEDURE PrintPaySheetByCash_InOpenRep();
 BEGIN
  PrintMode:=pm_Single;
  PrintType:=pt_PaySheetByCash;
  Output   :=out_OpenRep;
  PrintPDoc();
 END {PrintPaySheetByCash_InOpenRep};

 PUBLIC PROCEDURE PrintPaySheet_InOpenRep();
 BEGIN
  PrintMode:=pm_Single;
  PrintType:=pt_PaySheet;
  Output   :=out_OpenRep;
  PrintPDoc();
 END {PrintPaySheet_InOpenRep};

 PUBLIC PROCEDURE Print_Stream();
 BEGIN
  PrintMode:=pm_Stream;
  PrintType:=pt_PDoc;
  Output   :=out_File;
  PrintPDoc();
 END {Print_Stream};

END.
