(*
%Copyright   (c) Polak IT
%Author      12.04.2005 14:33:30 POLAK\GAV
%Purpose
%Type        report
%Specific    SYS
%Modified    19.03.2012 17:14:32 POLAK\Gina
%Environment
*)

 MODULE PDReestr [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 CONST
  pdstt_RepName = "PDStt";

 IMPORT L_General, L_PDoc, L_AFM, L_Staff, L_DatTim, L_Str, L_Money, P_Firm;

(*
$P{ pdstt_Top:
P_Firm.FP_FirmName(L_PDoc.GetPDocOwnFirm(), PDoc.Date), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
pdstt_RepName, L, ""
L_PDoc.PDocKindNick(PDoc.PDocKind, 1)+" "+PDoc.SrcNbr, L, ""
L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc), L, ""
PDoc.Date, L, "D.N.y"
?, R, ",2-"
?, R, ",2-"
?, R, ",2-"
?, R, ",2-"
?, R, ",2-"
@
############################################################# ########## #####
=#####========================================================================
|      ஢ / 뤠 㬬 ௫  ###########    |
|                         ###########  ##########                        |
|----------------------------------------------------------------------------|
|                                      㬬      ######################|
|                                      뤠  㪨  ######################|
|                                       뤠(ᥣ)######################|
|                                        뤠      ######################|
|                                              ######################|
}
*)

(*
$P{ pdstt_SubTop:
?, C, " |᮪ ࠡ⭨, /  ᫥  ௫ ᫥饣 |᮪ ࠡ⭨, /  ஢"
@
|----------------------------------------------------------------------------|
|############################################################################|
}
*)

(*
$P{ pdstt_CashSubTop:
Cash.Cash, L, ""
Cash.Name, L, ""
@
|----------------------------------------------------------------------------|
| ## ###################################################################|
|----------------------------------------------------------------------------|
|  |                                            |                 㬬|
|-----|-----------------------------------------------|----------------------|
}
*)

(*
$P{ pdstt_Line:
PDocList.TSN, L, ""
Man.Name, L, ""
PDocList.Sum, R, ",2-"
@
|#####|###############################################|######################|
}
*)

(*
$P{ pdstt_Totals:
?, L, ""
?, R, ",2-"
@
|-----------------------------------------------------|----------------------|
|⮣ ###############################################|######################|
}
*)

(*
$P{ pdstt_Bot:
L_Str.ShortName(P_Firm.FP_CashName(L_PDoc.GetPDocOwnFirm(), PDoc.Date)), L, ""
L_Str.ShortName(P_Firm.FP_AcntCashName(L_PDoc.GetPDocOwnFirm(), PDoc.Date)), L, ""
@
|----------------------------------------------------------------------------|
|                                                                            |
|                 _______________________ #############################|
|                                                                            |
|             壠 _______________________ #############################|
|                                                                            |
=(c) Polak====================================================================
}
*)

 PUBLIC PROCEDURE PDStt();
  VAR
   Total   : NUMERIC[2][3];
   CashTot,
   Tot     : NUMERIC[2];
 BEGIN
  L_PDoc.AccessPDoc();

  L_AFM.MakeIndex("tmp", "State: LIKE(PDocList.State); Cash: LIKE(TimeKeep.Cash); TSN: LIKE(Staff.TSN)");
  SETZERO(Total);
  Total[L_PDoc.pdl_st_Paid]:=PDoc.Total;
  SELECT(PDocList, PDoc, , PDoc.PDocKind, PDoc.PDoc);
  WHILE OCCURE(PDocList) DO
   PROMPT(PDocList.TSN);
   IF PDocList.State # L_PDoc.pdl_st_Paid THEN
    INC(Total[PDocList.State], PDocList.Sum);
    CONFORM(PDocList, Staff);
    L_Staff.PosToStaffLog(PDocList.TSN, PDoc.Date, 1);
    CONFORM(StaffLog, Officer);
    CONFORM(Officer, TimeKeep);
    ADD(tmp, tmp, , PDocList.State, TimeKeep.Cash, PDocList.TSN);
   END;
   NEXT(PDocList);
  END; (* WHILE OCCURE(PDocList) ... *)

  OPENREP(R, L_General.NameConnection(pdstt_RepName), Create);
  MAKEPART(R, pdstt_Top,
           Total[L_PDoc.pdl_st_Paid] + Total[L_PDoc.pdl_st_NotPaid] + Total[L_PDoc.pdl_st_Deposited],
           Total[L_PDoc.pdl_st_Paid],
           Total[L_PDoc.pdl_st_NotPaid] + Total[L_PDoc.pdl_st_Deposited],
           Total[L_PDoc.pdl_st_NotPaid],
           Total[L_PDoc.pdl_st_Deposited]);
  SELECT(tmp, tmp);
  WHILE OCCURE(tmp) DO
   Tot:=0;
   MAKEPART(R, pdstt_SubTop, tmp.State);
   CHANGESEL(tmp, tmp, , tmp.State);
   WHILE OCCURE(tmp) DO
    CashTot:=0;
    SEARCH(Cash, Cash, , tmp.Cash);
    MAKEPART(R, pdstt_CashSubTop);
    CHANGESEL(tmp, tmp, , tmp.State, tmp.Cash);
    WHILE OCCURE(tmp) DO
     SEARCH(PDocList, PDoc, , PDoc.PDocKind, PDoc.PDoc, tmp.TSN);
     CONFORM(PDocList, Staff);
     CONFORM(Staff, Man);
     MAKEPART(R, pdstt_Line);
     INC(CashTot, PDocList.Sum);
     NEXT(tmp);
    END; (* WHILE OCCURE(tmp) ... *)
    MAKEPART(R, pdstt_Totals, "  " + Cash.Cash + " " + Cash.Name, CashTot);
    INC(Tot, CashTot);
    LAST(tmp);
    CHANGESEL(tmp, tmp, , tmp.State);
    NEXT(tmp);
   END; (* WHILE OCCURE(tmp) ... *)
   MAKEPART(R, pdstt_Totals, " 㬥  楫", Tot);
   LAST(tmp);
   CHANGESEL(tmp, tmp);
   NEXT(tmp);
  END; (* WHILE OCCURE(tmp) ... *)
  MAKEPART(R, pdstt_Bot);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("tmp");
 END {PDStt};

(*
$P{ DpCard:
P_Firm.FP_FirmName(L_PDoc.GetPDocOwnFirm(), PDoc.Date), L, ""
L_DatTim.FullDateStr(PDoc.Date), L, ""
PDoc.Type, R, " 뤠|ᮢ 뤠|稥 믫"
Man.Name, L, ""
Staff.TSN, L, ""
PDoc.SrcNbr, L, ""
FLDTOSTR(PDoc.PDoc, "", 7), L, ""
L_PDoc.GetPDocCommentPart(1), L, ""
?, L, ""
?, L, ""
@
࣠ ##############################################################

窠  N________  ######################## #################

, ., . ##########################################  #####

 뤠  ⥦ 
       N ##### ( ####### ############################################)
##########################################################################
##########################################################################

室  ᮢ   ____________________________ _________.

                                     壠

--------------------------------------------------------------------------
뤠______________________           |஢________________ _____.
                                       |
___________________ ______.    |----------------------------------
---------------------------------------|    | ।  |
稫________________________________|---------|---------|    㬬
            (㬬 ய)           |||||
_______________________________________|----|----|----|----|--------------
                                       |    |    |    |    |       |
___________________ ______.    |    |    |    |    |       |
                                       |----------------------------------
       뤠 }

$P{ Empty:
@



--------------------------------------------------------------------------


}
*)

 PUBLIC PROCEDURE PDState();
  VAR
   SumStr: STRING[74][2];
   i     : NUMERIC[0];
 BEGIN
  L_General.Assert(ACCESS(PDoc), " ⠭ ⥦ 㬥");
  OPENREP(R, L_General.NameConnection("Depnt"), Create);
  i:=0;
  SELECT(PDocList, PDoc, , PDoc.PDocKind, PDoc.PDoc);
  WHILE OCCURE(PDocList) DO
   PROMPT(PDocList.TSN);
   IF PDocList.State = L_PDoc.pdl_st_Deposited THEN
    CONFORM(PDocList, Staff, Man);
    SETEMPTY(SumStr);
    L_Str.SplitStr(SumStr,
                    "௫ " + L_Money.MoneyToStr(L_DatTim.Per(PDoc.Date), ",", PDocList.Sum) +
                    " (" + L_Money.ByWord(PDocList.Sum) + ")",
                    74, HIGH(SumStr)+1);
    MAKEPART(R, DpCard, SumStr[0], SumStr[1]);
    INC(i);
    IF (i MOD 2) = 0 THEN
     FORMFEED(R);
    ELSE
     MAKEPART(R, Empty);
    END;
   END;
   NEXT(PDocList);
  END; (* WHILE OCCURE(PDocList)... *)
  CLOSEREP(R);
 END {PDState};

END.