(*
%Copyright   (c) Polak Computer System
%Author      26.09.2000 12:45:09 SAN
%Purpose     ஫ 䨪樨 ⥪饣 䨫
%Type        control
%Specific    SYS
%Modified    11.03.2013 17:52:54 POLAK\LDA
%Environment
*)

 MODULE SCBranch [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Env, L_Events, L_SES, L_OwnData;

 PRIVATE PROCEDURE SCBranch_OnBeforeEdit();
  VAR
   trgTemplate: STRING[];
 BEGIN
  L_General.Assert(L_OwnData.E_BranchesAmount(SYSDATE()) > 0, "㤠 䨫");
  IF L_OwnData.BranchNumber(SYSDATE(), L_OwnData.branchName_OwnBranch(SYSDATE())) = 0 THEN
   trgTemplate:=L_Env.BranchesNamesPool() + "|"+L_OwnData.branchName_Consolidating();
  ELSE
   trgTemplate:=L_OwnData.branchName_OwnBranch(SYSDATE());
  END;
  RTI.Get().CurZone.Fields("CurBrnch").Template:=trgTemplate;
  RTI.Get().CurZone.Fields("CurBrnch").TemplateIsStrict:=1;
 END {SCBranch_OnBeforeEdit};

 PRIVATE PROCEDURE SCBranch_OnAfterEdit();
 BEGIN
  L_SES.PutValueAtCurTrn(L_SES.sit_User, "L_APtm.CurBrnch", L_OwnData.CurBrnch);
 END {SCBranch_OnAfterEdit};

BEGIN
 L_Events.ExecuteHandler();
END.
