(*
%Copyright   (c) Polak Computer System
%Author      SAN
%Purpose      ⭮ 
%Purpose     믮   ࠢ MPrint  AllM
%Type        report
%Specific    SYS
%Modified    08.05.2014 13:26:52 POLAK\Gina
%Environment
*)

 MODULE SMPrint [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_PRoll, L_General, L_PDoc, L_Print, L_Staff,
        L_DatTim, L_Money, L_kn, Memo, P_Firm, E_PRoll, P_MCList;

 PRIVATE TYPE
  tMode = SCAL[3];

 CONST
  Depth = 49;
  LinesOnNoSheet = 96;

  m_Single = 0;
  m_Stream = 1;
  m_EU     = 2;

 VAR
  SMAmo,
  LinesOnPage    : NUMERIC[0];
  DepStr         : STRING[20];
  HiddenIncr,
  HiddenDecr,
  Kops,
  Deponent,
  InpRest,
  OutRest,
  _Incr,
  _Decr,
  TakenByPDoc,
  TakenByMoney,
  Taken,
  GivedByPDoc,
  GivedByMoney,
  ToTkPS,
  _InSaldo,
  _OutSaldoFutInc: NUMERIC[2]; (*LIKE(Money.Sum);*)

  Hours          : LIKE(Money.Tim);
  LineCount      : NUMERIC[0];

  _About         : STRING[64];

  SysDate,
  NextMon        : DATE;
  SysTime        : TIME;

  sKops,
  sDeponent,
  sSum1,
  sSum2,
  sIncr1,
  sIncr2,
  sDecr1,
  sDecr2,
  sFutInc1,
  sFutInc2,
  sTaken,
  sInSaldo,
  sOutSaldo,
  sOutRest1,
  sOutRest2,
  sToTkPS1,
  sToTkPS2       : STRING[12];

  PArr           : STRING[64][10];
  PIdx           : NUMERIC[0];

  MonthB,
  MonthE: DATE;

(*
$P { Top:
_MyFirmName(), L, ""
_FirmName(), L, ""
Staff.TSN, L, ""
Man.Name, L, ""
Staff.TSN, L, ""
Man.Name, L, ""
MonthB, L, "N.y"
Post.Name, L, ""
MonthB, L, "N.Y"
SysDate, L, "DNY"
SysTime, L, "HM"
Post.Post, L, ""
Post.Name, L, ""
SysDate, L, "D.N.y"
SysTime, L, "H:M"
@
=###########################################   |              =#####################################################################
##### ######################################   |              : ##### ##########################################   : #######
########################## ##### ###### ####   |              :  #### ########################################## ########## #####
- ᫥------------६-----㬬   |              --- ᫥-----------------------------६---------㬬
}

$P { PItog:
@
- 㤥ঠ-----------------------㬬   |              e--- 㤥ঠ--------------------------------------------㬬
}

$P { PLine1:
Money.Period, L, "N"
MCList.Name, L, ""
Money.Tim, R, "3."
sSum1, R, ""
Money.Period, L, "N.y"
Money.MCode, L, ""
MCList.Name, L, ""
Money.Tim, R, "3."
sSum2, R, ""
@
## ###################### ######## #########   |              ####### ###  ################################## ######## #############
}

$P { PLine2:
Money.Period, L, "N.y"
Money.MCode, L, ""
MCList.Name, L, ""
Money.Tim, R, "3."
sSum2, R, ""
@
                                               |              ####### ###  ################################## ######## #############
}

$P { NLine1:
Money.Period, L, "N"
MCList.Name, L, ""
sSum1, R, ""
Money.Period, L, "N.y"
Money.MCode, L, ""
MCList.Name, L, ""
sSum2, R, ""
@
## ############################### #########   |              ####### ###  ########################################### #############
}

$P { NLine2:
Money.Period, L, "N.y"
Money.MCode, L, ""
MCList.Name, L, ""
sSum2, R, ""
@
                                               |              ####### ###  ########################################### #############
}

$P { TakenCap:
@
-᭮ 믫-------------------㬬   |              -㬥--᭮ 믫-----------------------------------㬬
}

$P { TLine1:
PDoc.Date, L, "D"
_About, L, ""
sSum1, R, ""
PDoc.Date, L, "D"
L_PDoc.PDocKindNick(PDoc.PDocKind, 1), L, ""
PDoc.SrcNbr, L, ""
_About, L, ""
sSum2, R, ""
@
## ############################# ###########   |              ## ### ######### ####################################### #############
}

$P { TLine2:
PDoc.Date, L, "D"
L_PDoc.PDocKindNick(PDoc.PDocKind, 1), L, ""
PDoc.SrcNbr, L, ""
_About, L, ""
sSum2, R, ""
@
                                               |              ## ### ######### ####################################### #############
}

$P { Fil:
@
                                               |
}

$P { Bot:
sKops, R, ""
DepStr, R, ""
MonthB, L, "N.y"
NextMon, L, "N.y"
sDeponent, R, ""
sIncr1, R, ""
sDecr1, R, ""
sTaken, R, ""
sInSaldo, R, ""
sIncr2, R, ""
sDecr2, R, ""
sOutSaldo, R, ""
sToTkPS1, R, ""
sOutRest1, R, ""
sFutInc1, R, ""
Hours, R, "3."
sToTkPS2, R, ""
sFutInc2, R, ""
Hours, R, "3."
GetMPacket(), L, ""
GetMPacket(), L, ""
@
---⮪ #######--------------------------   |              ----------------------------------------------------------------------
 ##########  ᫥   ঠ  믫祭   |                  01.#######            ।                   01.#######
 ########## ########## ########## ##########   |              ################  ################  ################  ################
--------------------------------------------   |              ----------------------------------------------------------------------
   믫    ⮪    -          |                      믫                    騩                     
 ########## ########## ########## ##########   |              ################             ################             ############
=(c) Polak===============================##=   |              =(c) Polak=========================================================##=}

$P{ Btw:
@


}
*)

(* 
$P { Top_UI:
P_Firm.MyFirmName(L_Staff.GetStaffMyFirm(), SysDate), L, ""
SysDate, L, "D.N.y"
SysTime, L, "H:M"
Staff.TSN, L, ""
Man.Name, L, ""
Post.Post, L, ""
Post.Name, L, ""
MonthB, L, "N.y"
@
############################################################# ########## #####
==============================================================================
|⭨  ##### ############################################################|
| #### ###########################################           #######|
| - ᫥--------------------------------------६-----㬬|
}

$P { PItog_UI:
@
|                                                                            |
| - 㤥ঠ-------------------------------------------------㬬|
}

$P { PLine1_UI:
Money.Period, L, "m.y"
Money.MCode, L, ""
MCList.Name, L, ""
Money.Tim, R, "3."
sSum1, R, ""
@
|######## ### ############################################ ######## #########|
}

$P { PLine2_UI:
@
|                                                                            |
}

$P { NLine1_UI:
Money.Period, L, "m.y"
Money.MCode, L, ""
MCList.Name, L, ""
sSum1, R, ""
@
|######## ### ##################################################### #########|
}

$P { NLine2_UI:
@
|                                                                            |
}

$P { TakenCap_UI:
@
|---᭮ 믫-----------------------------------------------㬬|
}

$P { TLine1_UI:
PDoc.Date, L, "D m"
_About, L, ""
sSum1, R, ""
@
|###### ######################################################### ###########|
}

$P { TLine2_UI:
@
|                                                                            |
}

$P { Fil_UI:
@
|                                                                            |
}

$P { Bot_UI:
sKops, R, ""
DepStr, R, ""
sDeponent, R, ""
sIncr1, R, ""
sDecr1, R, ""
sTaken, R, ""
sToTkPS1, R, ""
sOutRest1, R, ""
sFutInc1, R, ""
Hours, R, "3."
@
|---⮪ #######----------------------------------------------------------|
| ##########            ᫥             ঠ            믫祭  |
| ##########           ##########           ##########           ##########  |
|----------------------------------------------------------------------------|
|   믫              ⮪              -                   |
| ##########           ##########           ##########           ##########  |
=(c) Polak====================================================================
}
*)

(*
$P { Top_Acc:
_FirmName(), L, ""
Staff.TSN, L, ""
Man.Name, L, ""
MonthB, L, "N.y"
Post.Post, L, ""
Post.Name, L, ""
SysDate, L, "D.N.y"
SysTime, L, "H:M"
@
                  =#####################################################################
                  : ##### ##########################################   : #######
                  :  #### ########################################## ########## #####
                  --- ᫥-----------------------------६---------㬬
}

$P { PItog_Acc:
@
                  e--- 㤥ঠ--------------------------------------------㬬
}

$P { PLine1_Acc:
Money.Period, L, "N.y"
Money.MCode, L, ""
MCList.Name, L, ""
Money.Tim, R, "3."
sSum2, R, ""
@
                  ####### ###  ################################## ######## #############
}

$P { PLine2_Acc:
Money.Period, L, "N.y"
Money.MCode, L, ""
MCList.Name, L, ""
Money.Tim, R, "3."
sSum2, R, ""
@
                  ####### ###  ################################## ######## #############
}

$P { NLine1_Acc:
Money.Period, L, "N.y"
Money.MCode, L, ""
MCList.Name, L, ""
sSum2, R, ""
@
                  ####### ###  ########################################### #############
}

$P { NLine2_Acc:
Money.Period, L, "N.y"
Money.MCode, L, ""
MCList.Name, L, ""
sSum2, R, ""
@
                  ####### ###  ########################################### #############
}

$P { TakenCap_Acc:
@
                  -㬥--᭮ 믫-----------------------------------㬬
}

$P { TLine1_Acc:
PDoc.Date, L, "D"
L_PDoc.PDocKindNick(PDoc.PDocKind, 1), L, ""
PDoc.SrcNbr, L, ""
_About, L, ""
sSum2, R, ""
@
                  ## ### ######### ####################################### #############
}

$P { TLine2_Acc:
PDoc.Date, L, "D"
L_PDoc.PDocKindNick(PDoc.PDocKind, 1), L, ""
PDoc.SrcNbr, L, ""
_About, L, ""
sSum2, R, ""
@
                  ## ### ######### ####################################### #############
}

$P { Fil_Acc:
@

}

$P { Bot_Acc:
MonthB, L, "N.y"
NextMon, L, "N.y"
sInSaldo, R, ""
sIncr2, R, ""
sDecr2, R, ""
sOutSaldo, R, ""
sToTkPS2, R, ""
sFutInc2, R, ""
Hours, R, "3."
GetMPacket(), L, ""
@
                  ----------------------------------------------------------------------
                      01.#######            ।                   01.#######
                  ################  ################  ################  ################
                  ----------------------------------------------------------------------
                          믫                    騩                     
                  ################             ################             ############
                  =(c) Polak=========================================================##=}
*)

 PRIVATE PROCEDURE E_SMHideMoney(): SCAL[2];
  VAR
   curSMPM  : P_MCList.tSMPrintMode;
   local    : PROC;
   Generally: SCAL[2];
 BEGIN
  curSMPM:=P_MCList.Get_SMPrintMode(Money.MCode, MonthB);
  IF    curSMPM = P_MCList.smpm_Nothing THEN
   Generally:=0;
  ELSE
   Generally:=(curSMPM = P_MCList.smpm_AllSrc) |
              ((Money.Source=L_PRoll.src_System) | (Money.Source=L_PRoll.src_FtSys));
  END;
  local:=PROCREF(E_PRoll.SMHideMoney);
  IF ~!local THEN
   RETURN local(Generally, MonthB, Money.MCode);
  ELSE
   RETURN Generally;
  END;
 END {E_SMHideMoney};

 PRIVATE PROCEDURE _MyFirmName(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  IF P_Firm.E_wMultipleMyFirm(SysDate) THEN
   P_Firm.PositionOnMyFirm(L_Staff.GetStaffMyFirm());
   Result:=MyFirm.Name;
  END;
  RETURN Result+"============================================";
 END {_MyFirmName};

 PRIVATE PROCEDURE _FirmName(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  IF P_Firm.E_wMultipleMyFirm(SysDate) THEN
   Result:=P_Firm.MyFirmName(L_Staff.GetStaffMyFirm(), MonthE);
  END;
  RETURN Result+"======================================================================";
 END {_FirmName};

 PRIVATE PROCEDURE GetMPacket(): LIKE(TimeKeep.MPacket);
 BEGIN
  RETURN L_PDoc.GetStaffMPacket(MonthE);
 END {GetMPacket};

 PRIVATE PROCEDURE PrintOnSheet(): SCAL[2];
 BEGIN
  RETURN (SMAmo = 1) | (SMAmo = 2);
 END {PrintOnSheet};

 PRIVATE PROCEDURE CantPrintOnPaperRest(NeedDepth: NUMERIC[0]): SCAL[2];
 BEGIN
  RETURN (LinesOnPage - (LINENUM(Mon) + DEPTH(Btw))) < NeedDepth;
 END {CantPrintOnPaperRest};

 PRIVATE PROCEDURE MakePart(PartName: STRING[64]; IsTitle: SCAL[2]; Mode: tMode);
 BEGIN
  IF (Mode = m_EU) | ((Mode = m_Single) & ~L_PRoll.E_PrintMoneyForStaff(MonthB, 1) )THEN
   PartName:=PartName + "_UI";
  ELSIF (Mode = m_Stream) & ~L_PRoll.E_PrintMoneyForStaff(MonthB, 0) THEN
   PartName:=PartName + "_Acc";
  END;
  MAKEPART(Mon, ^PartName);
  INC(LineCount, DEPTH(^PartName));
  IF ~!PArr[0] & IsTitle THEN
   L_General.CallUs(~!PArr[PIdx] & (PArr[PIdx]=PartName));
   INC(PIdx);
  END;
 END {MakePart};

 PRIVATE PROCEDURE ProgCheckWM(C: SCAL[2]; M: STRING[30]);
 BEGIN
  L_General.Assert(C, "訡  ணࠬ ᫥ |" + M);
 END {ProgCheckWM};

 PRIVATE PROCEDURE StoreTitlePart(P: STRING[64]): NUMERIC[0];
 BEGIN
  PArr[PIdx]:=P;
  INC(PIdx);
  RETURN DEPTH(^P);
 END {StoreTitlePart};

 PRIVATE PROCEDURE IsDebitPDoc(): SCAL[2];
 BEGIN
  RETURN (PDoc.PDocKind = L_PDoc.pd_RKO) | (PDoc.PDocKind = L_PDoc.pd_IPP);
 END {IsDebitPDoc};

 PRIVATE PROCEDURE IsKreditPDoc(): SCAL[2];
 BEGIN
  RETURN (PDoc.PDocKind = L_PDoc.pd_PKO) | (PDoc.PDocKind = L_PDoc.pd_VPP) |
         (PDoc.PDocKind = L_PDoc.pd_VMO);
 END {IsDebitPDoc};

 PRIVATE PROCEDURE SMPrint(Mode: tMode);
 BEGIN
  L_General.CallUs(Mode<=m_EU);
  MonthB:=Memo.gl_mb();
  MonthE:=Memo.gl_me();
  SMAmo :=L_PRoll.E_SMAmountOnA4(MonthB);
  IF PrintOnSheet() THEN
   LinesOnPage:=SMAmo * (Depth + 1) - 1; (* +1- ⮩ ப  ⪠  m_Stream *)
  ELSE
   LinesOnPage:=LinesOnNoSheet;
  END;
 
  PROMPT(Staff.TSN + " :    " + L_DatTim.PeriodStr(MonthB));
  L_PRoll.FixPCalc(MonthB);
  IF SELECT(Money, TSN, Staff.TSN, MonthB) | L_Staff.IsWorking(MonthB) THEN
   SETZERO(LineCount, PIdx);
   SysDate:=SYSDATE();
   SysTime:=SYSTIME();
   NextMon:=L_DatTim.IncMonth(MonthB, +1);
   HISTCONF(MonthE, Staff, Post, Officer);
 
   SETZERO(_Incr, _Decr, TakenByMoney, TakenByPDoc, Taken, Hours,
                         GivedByMoney, GivedByPDoc, HiddenIncr, HiddenDecr);
 
   IF    (Mode = m_Single) | ((Mode = m_Stream) & (L_Print.GetPageNbr() = 0)) THEN
    SetPrintAttr(Mon, Duplex,          Off,
                      LeftMargin,      7,
                      RightMargin,     7,
                      TopMargin,       6,
                      BottomMargin,    6,
                      MaxCharsPerInch, 12 * SMAmo,
                      MinCharsPerLine, 111,
                      SpreadChrInLine, 132,
                      LinesPerPage, LinesOnPage);
    IF SMAmo = 1 THEN
     SetPrintAttr(Mon, Orientation, Landscape);
    END;
   END;
 
   IF Mode = m_Stream THEN
    WHILE OCCURE(Money) DO
     INC(LineCount);
     NEXT(Money);
    END;
    SELECT(PDocList, TSN, , Staff.TSN);
    SRCINSEL(PDocList, GE, , MonthB);
    WHILE OCCURE(PDocList) & (PDocList.PDocDate <= MonthE) DO
     IF PDocList.State = L_PDoc.pdl_st_Paid THEN
      CONFORM(PDocList, PDoc);
      IF L_PDoc.IsSalPDoc() THEN
       L_PDoc.CheckDone();
       IF IsDebitPDoc() THEN
        INC(LineCount);
       END;
      END;
     END;
     NEXT(PDocList);
    END;
    INC(LineCount, StoreTitlePart("Top")+
                   StoreTitlePart("PItog")+
                   StoreTitlePart("TakenCap")+
                   StoreTitlePart("Bot")+
                   1);
    IF LINENUM(Mon) # 0 THEN
     IF PrintOnSheet() & (LineCount > Depth) |
       ~PrintOnSheet() & CantPrintOnPaperRest(LineCount) THEN
      FORMFEED(Mon);
     ELSE
      MAKEPART(Mon, Btw);
     END;
    ELSIF SMAmo = 1 THEN
     IF LineCount <= Depth THEN
      SetPrintAttr(Mon, LinesPerPage, LinesOnPage);
     ELSE
      SetPrintAttr(Mon, LinesPerPage, LineCount);
     END;
    END;
    SETZERO(LineCount, PIdx);
   ELSIF Mode = m_Single THEN
    SetPrintAttr(Mon, MaxPages, 1);
   END; (* IF Mode = m_Stream ... *)
 
   FIRST(Money);
   SETEMPTY(PArr);
 
   MakePart("Top", 1, Mode);
   WHILE OCCURE(Money) DO
    HISTCONF(Money.ODate, Money, StaffLog);
    L_General.Assert(OCCURE(StaffLog) & (StaffLog.Date = Money.ODate),
                     "୮ 祭  /  ப |" +
                     " " + Money.TSN + ",  / " + Money.MCode);
    CONFORM(Money, MCList);
    IF MCList.MCTyp = L_PRoll.mct_Credit THEN
     INC(_Incr, Money.Sum);
     IF (MCList.TimeType = L_PRoll.tt_Production) & (Money.Period = MonthB) THEN
      INC(Hours, Money.Tim);
     END;
     sSum1:=L_Money.MoneyToStr(MonthB, "",  Money.Sum);
     sSum2:=L_Money.MoneyToStr(MonthB, ",", Money.Sum);
     IF E_SMHideMoney() THEN
      INC(HiddenIncr, Money.Sum);
      MakePart("PLine2", 0, Mode);
     ELSE
      MakePart("PLine1", 0, Mode);
     END;
    END;
    NEXT(Money);
   END;
 
   MakePart("PItog", 1, Mode);
   SELECT(Money, TSN, , Staff.TSN, MonthB);
   WHILE OCCURE(Money) DO
    CONFORM(Money, MCList);
    IF MCList.MCTyp = L_PRoll.mct_Debit THEN
     INC(_Decr, Money.Sum);
     sSum1:=L_Money.MoneyToStr(MonthB, "",  Money.Sum);
     sSum2:=L_Money.MoneyToStr(MonthB, ",", Money.Sum);
     IF (Money.MCode = L_kn.GetSoft(MonthB, L_PRoll.erkn_MCList_PaidByCash)) |
        (Money.MCode = L_kn.GetSoft(MonthB, L_PRoll.erkn_MCList_PaidByBank)) THEN
      MakePart("NLine2", 0, Mode);
      IF MonthB >= 01\01\1999 THEN
       INC(TakenByMoney, Money.Sum);
      END;
     ELSE
      IF E_SMHideMoney() THEN
       INC(HiddenDecr, Money.Sum);
       MakePart("NLine2", 0, Mode);
      ELSE
       MakePart("NLine1", 0, Mode);
      END;
     END;
    ELSIF (Money.MCode = L_kn.GetSoft(MonthB, L_PRoll.erkn_MCList_ReturnedByCash)) |
          (Money.MCode = L_kn.GetSoft(MonthB, L_PRoll.erkn_MCList_ReturnedByBank)) THEN
     INC(GivedByMoney, Money.Sum);
    END;
    NEXT(Money);
   END;
 
   MakePart("TakenCap", 1, Mode);
   SELECT(PDocList, TSN, , Staff.TSN);
   SRCINSEL(PDocList, GE, , MonthB);
   WHILE OCCURE(PDocList) & (PDocList.PDocDate <= MonthE) DO
    IF PDocList.State = L_PDoc.pdl_st_Paid THEN
     CONFORM(PDocList, PDoc);
     IF L_PDoc.IsSalPDoc() THEN
      L_PDoc.CheckDone();
      IF PDoc.Status # L_PDoc.st_Canceled THEN
       IF IsDebitPDoc() THEN
        _About:=L_PDoc.GetPDocPurpose();
        INC(TakenByPDoc, PDocList.Sum);
        sSum1:=L_Money.MoneyToStr(MonthB, "",  PDocList.Sum);
        sSum2:=L_Money.MoneyToStr(MonthB, ",", PDocList.Sum);
        IF PDoc.Type # L_PDoc.typ_Mass THEN
         INC(Taken, PDocList.Sum);
         MakePart("TLine1", 0, Mode);
        ELSE
         MakePart("TLine2", 0, Mode);
        END;
       ELSIF IsKreditPDoc() THEN
        INC(GivedByPDoc, PDocList.Sum);
       END;
      END; (* IF PDoc.Status ... *)
     END; (* IF L_PDoc.IsSalPDoc()... *)
    END;
    NEXT(PDocList);
   END;
 
   IF PrintOnSheet() & (Mode # m_EU) THEN
    WHILE LineCount < (Depth - DEPTH(Bot) - 1) DO
     MakePart("Fil", 0, Mode);
    END;
   END;
 
   ProgCheckWM(_Incr = PCalc.Incr, "");
   ProgCheckWM(_Decr = PCalc.Decr, "");
   ProgCheckWM(TakenByMoney = TakenByPDoc, "");
   ProgCheckWM(GivedByMoney = GivedByPDoc, "");
 
   _InSaldo :=PCalc.Saldo;
   InpRest  :=_InSaldo + Taken - TakenByPDoc;
 
   IF InpRest >= 0 THEN
    DepStr   :="";
    Deponent :=L_PRoll.TruncMoney(L_DatTim.IncMonth(MonthB, -1), InpRest);
    Kops     :=InpRest - Deponent;
   ELSE
    DepStr   :="";
    Deponent :=-InpRest;
    Kops     :=0;
   END;
 
   _OutSaldoFutInc:=L_PRoll.OutSaldoFutInc(MonthB, MonthB,
                                           L_PRoll.E_MPD_PCalc_NeedFutInc(MonthB));
 
   IF _OutSaldoFutInc > 0 THEN
    IF ~L_Staff.IsLeave(MonthB) THEN
     ToTkPS:=L_PRoll.TruncMoney(MonthB, _OutSaldoFutInc);
    ELSE
     ToTkPS:=_OutSaldoFutInc;
    END;
   ELSE
    ToTkPS:=0;
   END;
 
   OutRest  :=_OutSaldoFutInc - ToTkPS;
 
   sKops    :=L_Money.MoneyToStr(MonthB, "",  Kops);
   sDeponent:=L_Money.MoneyToStr(MonthB, "",  Deponent);
   sInSaldo :=L_Money.MoneyToStr(MonthB, ",", PCalc.Saldo);
   sIncr1   :=L_Money.MoneyToStr(MonthB, "",  PCalc.Incr - HiddenIncr);
   sIncr2   :=L_Money.MoneyToStr(MonthB, ",", PCalc.Incr);
   sDecr1   :=L_Money.MoneyToStr(MonthB, "",  PCalc.Decr - TakenByPDoc - HiddenDecr);
   sDecr2   :=L_Money.MoneyToStr(MonthB, ",", PCalc.Decr);
   sFutInc1 :=L_Money.MoneyToStr(MonthB, "",  PCalc.FutInc);
   sFutInc2 :=L_Money.MoneyToStr(MonthB, ",", PCalc.FutInc);
   sOutSaldo:=L_Money.MoneyToStr(MonthB, ",", L_PRoll.OutSaldo(MonthB));
   sTaken   :=L_Money.MoneyToStr(MonthB, "",  Taken);
   sToTkPS1 :=L_Money.MoneyToStr(MonthB, "",  ToTkPS);
   sToTkPS2 :=L_Money.MoneyToStr(MonthB, ",", ToTkPS);
   sOutRest1:=L_Money.MoneyToStr(MonthB, "",  OutRest);
   sOutRest2:=L_Money.MoneyToStr(MonthB, ",", OutRest);
 
   MakePart("Bot", 1, Mode);
 
   L_General.CallUs(!PArr[PIdx]);
 
   IF Mode = m_Stream THEN
    L_Print.IncPageNbr();
    IF PrintOnSheet() & CantPrintOnPaperRest(Depth) THEN
     FORMFEED(Mon);
    END;
   END;
  END;
 END {SMPrint};

 PUBLIC PROCEDURE SMPrint_Single();
 BEGIN
  SMPrint(m_Single);
 END {SMPrint_Single};

 PUBLIC PROCEDURE SMPrint_Stream();
 BEGIN
  SMPrint(m_Stream);
 END {SMPrint_Stream};

 PUBLIC PROCEDURE SMPrint_EU();
 BEGIN
  SMPrint(m_EU);
 END {SMPrint_EU};

END.
