(*
%Copyright   (c) Polak Computer System
%Author      21.05.2002 15:24:54 LDA
%Purpose     ᮪ 㤭,  樠 죮  
%Type        report
%Specific    SYS
%Modified    10.04.2012 12:27:05 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_OwnData, L_General, P_Man, L_Staff, L_AFM, L_Str, Memo, L_Man, L_DatTim, Str;

 CONST
  RepName = "Stf17";

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_cd(), L, "D.N.y"
@
#############################################################                                                ########## #####
=#####=======================================================================================================================
|                                ᮪ 㤭,  樠 죮  ##########                                |
|---------------------------------------------------------------------------------------------------------------------------|
|                     |                  |.   . .      | ஦.| 죮                    |
|---------------------------|---------------------------|-------------------------|----------|------------------------------|
}
*)

(*
$P{ Line:
Sort.Sort, L, ""
Sort.Name, L, ""
Post.Post, L, ""
Post.Name, L, ""
Tmp.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
Man.Birth, L, "D.N.y"
Tmp.BnfDescr, L, ""
@
|### #######################|### #######################|##### ###################|##########|##############################|
}
*)

(*
$P{ Bot:
@
=(c) Polak===================================================================================================================
}
*)

 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CreateFILE(Tmp, "", "", "");

  CreateFIELD(Tmp, TSN,      LIKE(Staff.TSN), "", "", "", ".", "");
  CreateFIELD(Tmp, Sort,     LIKE(Sort.Sort), "", "", "", "⤥", "");
  CreateFIELD(Tmp, Post,     LIKE(Post.Post), "", "", "", "", "");
  CreateFIELD(Tmp, BnfDescr, STRING[32], "", "", "", "죮", "");

  CreateINDEXandLINK(Tmp, Sort,     PLURAL, Sort,     Sort,     USER, "", "", Sort, TSN);
  CreateINDEXandLINK(Tmp, Post,     PLURAL, Post,     Post,     USER, "", "", Post, TSN);

  SetVersionOfFILE(Tmp, 0);
 END {Create_Tmp};

 PRIVATE PROCEDURE InsIntoTmp(_BnfDescr: STRING[]);
 BEGIN
  IF L_Staff.IsStandOnAnyMainContract(Man.Man, Memo.ud_cd()) THEN
   IF L_Staff.rInState(Memo.ud_cd()) THEN
    CONFORM(StaffLog, Officer);
    Tmp.TSN     :=Staff.TSN;
    Tmp.Sort    :=Officer.Sort;
    Tmp.Post    :=Officer.Post;
    Tmp.BnfDescr:=_BnfDescr;
    INSERT(Tmp);
   END;
  END;
 END {InsIntoTmp};

 PRIVATE PROCEDURE Do(_Property: LIKE(Property.Property));
 BEGIN
  SELECT(ManPro, Property, , _Property);
  WHILE OCCURE(ManPro) DO
   PROMPT(ManPro.Man);
   SAVE(ManPro);
   IF P_Man.HasActualManPro(ManPro.Man, Memo.ud_cd(), _Property) THEN
    CONFORM(ManPro, Property);
    CONFORM(ManPro, Man);
    InsIntoTmp(Property.Name);
   END;
   RESTORE(ManPro);
   NEXT(ManPro);
  END; (* WHILE OCCURE(ManPro) ... *)
 END {Do};

 PRIVATE PROCEDURE PrintRep();
  VAR
   Amount: NUMERIC[0];
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top);
  SELECT(Tmp, Sort);
  WHILE OCCURE(Tmp) DO
   NARROWSEL(Tmp, Sort);
   CONFORM(Tmp, Sort);
   WHILE OCCURE(Tmp) DO
    PROMPT(" " + Tmp.TSN);
    CONFORM(Tmp, Post);
    SEARCH(Staff, TSN, , Tmp.TSN);
    CONFORM(Staff, Man);
    MAKEPART(R, Line);
    NEXT(Tmp);
   END; (* WHILE OCCURE(Tmp) ... *)
   NEXTINEXTENDEDSEL(Tmp, Sort);
  END; (* WHILE OCCURE(Tmp) ... *)
  MAKEPART(R, Bot);
 END {PrintRep};

 PRIVATE PROCEDURE GatherDependant();
 BEGIN
  SELECT(ManFml, Man);
  WHILE OCCURE(ManFml) DO
   PROMPT("ઠ " + ManFml.Man);
   IF ((ManFml.Features = L_Man.fmf_Dependant) | (ManFml.Features = L_Man.fmf_InvalidDependant)) &
      L_DatTim.IsActive(Memo.ud_cd(), ManFml.BegDate, ManFml.EndDate) THEN
    CONFORM(ManFml, Man);
    InsIntoTmp(Str.Condense(L_Str.PoolItem(L_Man.fmf_Pool, ManFml.Features) + " " + ManFml.Comment));
   END;
   NEXT(ManFml);
  END; (* WHILE OCCURE(ManFml) ... *)
 END {GatherDependant};

BEGIN
 Create_Tmp();
 L_AFM.AF_CreateTemp("Tmp", "Tmp");
 Do(P_Man.P_MemberGPW);
 Do(P_Man.P_Chernobil);
 Do(P_Man.P_VeteranOfWork);
 Do(P_Man.P_LeningradBlockade);
 Do(P_Man.P_WorkFront);
 Do(P_Man.P_BattleActionVeteran);
 GatherDependant();
 PrintRep();
 L_AFM.AF_PurgeTemp("Tmp");
END.
