(*
%Copyright   (c) Polak Computer System
%Author      17.05.2002 10:25:50 LDA
%Purpose     ᮪ ࠡ⭨, ⨣ ᨮ   ਮ
%Type        report
%Specific    SYS
%Modified    10.04.2012 12:27:25 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_DatTim, L_Staff, L_OwnData, L_AFM, L_Russia, L_Man,
        P_Man, Memo, L_Env;

 CONST
  RepName = "StPns";

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
SYSDATE(), L, "D.N.y"
Memo.From(), L, "D.N.y"
Memo.UpTo(), L, "D.N.y"
@
#################################################################################################                                                                                       ########## #####
=#####==================================================================================================================================================================================================
|                        ⭨, 騥    ##########  ⨣騥 ᨮ  (騭 50-55, 稭 55-60 )  ਮ  ##########  ##########                         |
|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|N |,,⢮                      |. |客     |      ||                          |                             |ਬ砭                            |
|    |                                          |     |     |஦  |       |                                   |                                   |                                      |
|----|------------------------------------------|-----|--------------|----------|-------|-----------------------------------|-----------------------------------|--------------------------------------|
}
*)

(*
$P{ Line:
?, R, ""
Man.Name, L, ""
Tmp.TSN, L, ""
Man.SINumber, L, L_Russia.sf_ManSINumber
Man.Birth, L, "D.N.y"
Tmp.Age, R, ""
Tmp.Post, L, ""
Tmp.Sort, L, ""
@
|####|##########################################|#####|##############|##########|#######|###################################|###################################|                                      |
}
*)

(*
$P{ Bot:
@
=(c) Polak==============================================================================================================================================================================================
}
*)

 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CreateFILE(Tmp, "", "", "");

  CreateFIELD(Tmp, Man,  LIKE(Man.Man),   "", "", "", " ", "");
  CreateFIELD(Tmp, TSN,  LIKE(Staff.TSN), "", "", "", ".  ", "");
  CreateFIELD(Tmp, Age,  NUMERIC[0],      "", "", "", " ", "");
  CreateFIELD(Tmp, Sort, LIKE(Sort.Name), "", "", "", "", "");
  CreateFIELD(Tmp, Post, LIKE(Post.Name), "", "", "", "", "");

  CreateINDEXandLINK(Tmp, Man,    PLURAL, Man, Man, USER, "", "", Man);
  CreateINDEX       (Tmp, ManAge, PLURAL,                 "", "", Age);

  SetVersionOfFILE(Tmp, 0);
  L_AFM.AF_CreateTemp("Tmp", "Tmp");
 END {Create_Tmp};

 PRIVATE PROCEDURE Condition(Age: NUMERIC[0]): SCAL[2];
 BEGIN
  IF Man.Sex = L_Man.sex_Female THEN
   RETURN (Age >= 50) & (Age <= 55);
  ELSE
   RETURN (Age >= 55) & (Age <= 60);
  END;
 END {Condition};

 PRIVATE PROCEDURE Do();
  VAR
   Age: NUMERIC[0];
 BEGIN
  SELECT(Man, Man);
  WHILE OCCURE(Man) DO
   PROMPT(Man.Man);
   Age:=L_DatTim.CompleteYearsInIntvl(Man.Birth, Memo.UpTo()-1);
   IF Condition(Age) THEN
    IF L_Staff.IsStandOnAnyMainContract(Man.Man, SYSDATE()) &
       L_Staff.rInState(SYSDATE()) &
       ~P_Man.HasActualManPro(Man.Man, Memo.From(), P_Man.P_Pension) THEN
     IF OCCURE(StaffLog) THEN
      CONFORM(StaffLog, Officer, Post);
      CONFORM(Officer, Sort);
      Tmp.Man :=Man.Man;
      Tmp.TSN :=Staff.TSN;
      Tmp.Age :=Age;
      Tmp.Sort:=Sort.Name;
      Tmp.Post:=Post.Name;
      INSERT(Tmp);
     END;
    END;
   END;
   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)
 END {Do};

 PRIVATE PROCEDURE PrintRep();
  VAR
   Amount: NUMERIC[0];
 BEGIN
  Amount:=1;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top);
  SELECT(Tmp, ManAge);
  WHILE OCCURE(Tmp) DO
   CONFORM(Tmp, Man);
   MAKEPART(R, Line, Amount);
   INC(Amount);
   NEXT(Tmp);
  END; (* WHILE OCCURE(Tmp) ... *)
  MAKEPART(R, Bot);
 END {PrintRep};

BEGIN
 Create_Tmp();
 Do();
 PrintRep();
 L_AFM.AF_PurgeTemp("Tmp");
END.
