(*
%Copyright   (c) Polak Computer System
%Author      26.01.2012 12:09:58 Bor
%Purpose       믫  ࠦ  ᨮ 䮭
%Type        report
%Specific    SYS
%Modified    27.01.2014 16:58:36 POLAK\Bor
%Environment
*)

 MODULE SZV_Inc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_AFM, L_Russia, L_DatTim, L_Str, L_Staff, L_XML,
        L_StdFrm, L_APtm, L_PRoll, L_SFee, L_XObj, L_Packet, P_OwnData;

 VAR
  CurPacket: L_Packet.tPFExtNbr;
  CurNumInP,
  TotNumInP: NUMERIC[0];

 VAR
  PerB,
  PerE: DATE;

 CONST
  pg_Norm = 0;
  pg_9999 = 1;

 CONST
  patt_Type = "";

 PROCEDURE GetCategoryNick(P: DATE; trgType: LIKE(ManSFee.Type)): STRING[];
 BEGIN
  IF    trgType = L_SFee.t_Normal              THEN RETURN "";
  ELSIF trgType = L_SFee.t_Invalid             THEN RETURN "";
  ELSIF trgType = L_SFee.t_USNO                THEN RETURN "";
  ELSIF trgType = L_SFee.t_woCtzn              THEN RETURN "????";
  ELSIF trgType = L_SFee.t_woCtzn_Commorancy   THEN RETURN "";
  ELSIF trgType = L_SFee.t_woCtzn_TmpResidence THEN RETURN "";
  ELSE L_General.CallUs(0);
  END;
 END {GetCategoryNick};

 PRIVATE PROCEDURE IsSince2012(): SCAL[2];
 BEGIN
  RETURN PerB >= 01\01\2012;
 END {IsSince2012};

(*
$P{ ADV_6_4:
Packet.ExtNbr, R, "", "U"
1, R, "", "U"
L_Packet.OwnOKPO, R, "", "U"
L_Packet.OwnNumInPFR, L, "", "U"
L_Packet.OwnFirmName, L, "", "U"
L_Packet.OwnINN, L, "", "U"
L_Packet.OwnKPP, L, "", "U"
Packet.DataType, L, " |X| "
?, L, "", "U"
Packet.CorrType, L, " |X| "
Packet.CorrType, L, " | |X"
?, L, " |X"
?, L, " |X"
PerE, L, "y", "U"
?, R, "0"
Packet.ExtNbr, R, "", "U"
?, R, "2-"
?, R, "2-"
L_Packet.ActingLeadPostName, L, "", "U"
L_Str.ShortName(L_Packet.ActingLeadName), L, "", "U"
L_DatTim.FullDateStr(L_Packet.PrepareDate), L, "", "U"
@
                                             N 窨 #####   N  窥 ###
ଠ -6-4        ________               ############

                  㬥⮢ ᢥ  㬬 믫
               ࠦ, 塞 ⥫騪
                    客 ᮢ - 客⥫ﬨ
                           䨧᪮ 

 ⥫騪 客 ᮢ - 客⥫:
樮   ################################
 ࣠樨  ################################################
(⪮)                                                ᢥ:
 ##########         #########                     [#] 室
 ⥣ਨ 客  #################### [#] ४
                                                        [#] ⬥
 (⨯ ), 祭  客 殬:
[#] 㤮
[#] ࠦ᪮-ࠢ

 ਮ:  ####

ਬ砭: ______________________________________________________________
--------------------------------------------------------------------------
| 室饣 㬥                          |⢮   |
|                                                          |㬥⮢   |
|                                                          | 窥      |
|----------------------------------------------------------|-------------|
|  㬬 믫   ࠦ, 塞|#############|
|⥫騪 客 ᮢ - 客⥫ﬨ   |             |
|䨧᪨  (ଠ -6-3)                            |             |
|----------------------------------------------------------|-------------|
|                                                          |             |
|----------------------------------------------------------|-------------|
|                                                          |             |
--------------------------------------------------------------------------
  窨 㬥⮢,ᮯ஢ ஭ ।⠢
 窨 㬥⮢, ᢮ 客⥫    ######
 ॣ樨 窨  ਠ쭮 ࣠  __________ / _____

--------------------------------------------------------------------------
|                |       㬬 믫   ࠦ     |
|                |-------------------------------------------------------|
|                |    㬬 믫      |    ᫥|
|                |      ࠦ,      |    客      |
|                |   ᫥      |  易⥫쭮 ᨮ  |
|                |     䨧᪮       |        客        |
|----------------|---------------------------|---------------------------|
|ᥣ ᫥ |###########################|###########################|
--------------------------------------------------------------------------

  㪮⥫     ஢ 
###################################            ###########################

 ##############################            ..}
*)

(*
$P{ SZV_6_3_Top:
Packet.ExtNbr, R, "", "U"
CurNumInP, R, "", "U"
L_Packet.OwnOKPO, R, "", "U"
?, L, "", "U"
?, L, "", "U"
Packet.DataType, L, " |X| "
?, L, "", "U"
Packet.CorrType, L, " |X| "
L_Packet.SINumberToAnyOut(Man.SINumber), L, "", "U"
Packet.CorrType, L, " | |X"
?, L, "", "U"
?, L, " |X"
?, L, " |X"
L_Packet.OwnNumInPFR, L, "", "U"
L_Packet.OwnINN, L, "", "U"
L_Packet.OwnKPP, L, "", "U"
L_Packet.OwnFirmName, L, "", "U"
@
                                             N 窨 #####  N 㬥 ###
ଠ -6-3          ________              ############

              , 
            -   
                              

  ######################################  ᢥ:
      ###################################### [#] 室
⢮ ###################################### [#] ४
客  ############################### [#] ⬥
 ⥣ਨ 客  ########################################
 (⨯ ), 祭  客 殬:
[#] 㤮
[#] ࠦ᪮-ࠢ

  ⥫騪 客 ᮢ - 客⥫:
樮    ###############################################
 ############         #########
 (⪮)      ###############################################

  㬬 믫   ࠦ

===========================================================================
|    |      㬬 믫        |      ᫥  |
|         |  ࠦ, ᫥  |       客         |
|         |     䨧᪮    |    易⥫쭮 ᨮ  |
|         |                               |          客          |
}
*)

(*
$P{ SZV_6_3_Line:
?, L, ""
?, R, "2-"
?, R, "2-"
@
|---------|-------------------------------|-------------------------------|
|#########|###############################|###############################|
}
*)

(*
$P{ SZV_6_3_Bot:
L_Packet.ActingLeadPostName, L, "", "U"
L_Str.ShortName(L_Packet.ActingLeadName), L, "", "U"
L_DatTim.FullDateStr(L_Packet.PrepareDate), L, "", "U"
@
===========================================================================

              ஢  㪮⥫

###########################               #################################

 ##############################             ..}
*)

(*
$P{ NN1_3_00_1:
Packet.ExtNbr, R, ""
L_Packet.OwnNumInPFR, L, ""
L_Packet.OwnINN, L, ""
L_Packet.OwnKPP, L, ""
L_Packet.OwnFirmName, L, ""
PerE, L, "y"
@
           ᮪ 客                         窠 N ######

--------------------------------------------------------------------------
| ࠡ⮤⥫, ।饣 㬥:                          |
|樮   ##############################################|
| ##########         #########                                     |
| ࣠樨  ##############################################|
|(⪮)                                                               |
| : ####                                                      |
|------------------------------------------------------------------------|
| N  |  客   | , , ⢮                             |
|/ |         |                                                    |
|----|--------------|----------------------------------------------------|
}
*)

(*
$P{ NN1_3_00_2:
PckBody.SeqNbr+1, R, "N"
L_Packet.SINumberToAnyOut(Man.SINumber), L, ""
L_Packet.GetManInPFRFName(PerE), L, ""
@
|####|##############|####################################################|
}
*)

(*
$P{ NN1_3_00_3:
@
--------------------------------------------------------------------------}
*)

(*
$P{ R_ErrTop:
L_Packet.OwnFirmName, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
PerB, L, "D.N.y"
PerE, L, "D.N.y"
@
########################################################################################################################################## ########## #####
===========================================================================================================================================================
|                             㦥 訡  ନ஢ ᢥ  ଥ -6-3  ਮ ##########  ##########                             |
|---------------------------------------------------------------------------------------------------------------------------------------------------------|
|                                  |  㬬 믫|     .. |                                                                                         |
|                                |         |      |ਬ砭                                                                               |
|                                  |ࠦ|᫥ |                                                                                         |
|----------------------------------|--------------|-------------|-----------------------------------------------------------------------------------------|
}
*)

(*
$P{ R_ErrLine:
Intrm.Man, L, ""
Intrm.Name, L, ""
Intrm.totObject, R, "2-"
Intrm.totBase, R, "2-"
Intrm.ErrMsg, L, ""
@
|##### ############################|##############|#############|#########################################################################################|
}
*)

(*
$P{ R_ErrBot:
@
=(c) Polak=================================================================================================================================================
}
*)

(*
$P{ R_PrtTop:
L_Packet.OwnFirmName, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
PerB, L, "N.y"
PerE, L, "N.y"
@
############################################################## ########## #####
===============================================================================
|⮪ ନ஢ ᢥ  ଥ -6-3  ਮ #######  ####### |
|-----------------------------------------------------------------------------|
|                                      |  |  㬬 믫|     .. |
|                                        |       |         |      |
|                                        |       |ࠦ|᫥ |
|----------------------------------------|-------|--------------|-------------|
}
*)

(*
$P{ R_PrtLine:
Intrm.Man, L, ""
Intrm.Name, L, ""
Intrm.Packet, L, ""
Intrm.totObject, R, "2-"
Intrm.totBase, R, "2-"
@
|##### ##################################|#######|##############|#############|
}
*)

(*
$P{ R_PrtBot:
?, R, "2-"
?, R, "2-"
@
|------------------------------------------------|--------------|-------------|
|⮣                                           |##############|#############|
=(c) Polak=====================================================================
}
*)

 PRIVATE PROCEDURE GetManStrId(trgMan: LIKE(Man.Man)): STRING[];
 BEGIN
  RETURN Packet.ExtNbr+"-"+L_Str.IntStr(CurNumInP) + " (" + trgMan + ")";
 END {GetManStrId};

 PRIVATE PROCEDURE SetPckBodyByIntrm(trgExtNbr: LIKE(Packet.ExtNbr));
 BEGIN
  IF ~SELECT(Packet, PacketDS, L_Packet.rcv_PensFund, L_Packet.DTStamp, trgExtNbr) THEN
   L_Packet.InsPFPacket(L_Packet.knd_PF_SZV6_3, trgExtNbr, PerB, PerE, Intrm.DataType, Intrm.CorrType);
   L_Packet.PutPacketAttr(Packet.Packet, patt_Type, L_Str.IntStr(Intrm.Type));
  END;
  DEFAULT(PckBody);
  PckBody.Packet  :=Packet.Packet;
  PckBody.Man     :=Intrm.Man;
  INSERT(PckBody);
  Intrm.Packet:=PckBody.Packet;
  Intrm.SeqNbr:=PckBody.SeqNbr;
  REPLACE(Intrm);
 END {SetPckBodyByIntrm};

 PRIVATE PROCEDURE trn_PutInc(nParent: L_XML.tNode; StrTypeName: STRING[]; trgMonth: L_DatTim.tMonth; trgObject, trgBase: L_PRoll.tSum);
  VAR
   nIncStr: L_XML.tNode;
 BEGIN
  nIncStr:=L_Packet.trn_PutNode(nParent, "㬬믫∢ࠦ");
   L_Packet.trn_PutString(nIncStr, "ப", StrTypeName);
   IF ~!trgMonth THEN
    L_Packet.trn_PutInt(nIncStr, "", trgMonth+1);
   END;
   L_Packet.trn_PutMoney(nIncStr, "㬬믫ᥣ", trgObject);
   L_Packet.trn_PutMoney(nIncStr, "㬬믫⍠᫥客륂", trgBase);
 END {trn_PutInc};

 PRIVATE PROCEDURE trn_PckKind(): STRING[];
 BEGIN
  IF    Packet.Kind = L_Packet.knd_PF_SZV6_3 THEN RETURN "_____";
  ELSE
   L_General.CallUs(0);
  END;
 END {trn_PckKind};

 PRIVATE PROCEDURE MakeOneMan(nPack: L_XML.tNode);
  VAR
   M         : L_DatTim.tMonth;
   nDoc      : L_XML.tNode;
   Surname,
   FirstName,
   Patronymic: STRING[];
 BEGIN
  nDoc:=L_Packet.trn_PutAbstractDoc(nPack, trn_PckKind(), CurNumInP);
  L_Packet.trn_PutString(nDoc, "", L_Packet.FormType(Packet.DataType, Packet.CorrType));
  L_Packet.trn_PutString(nDoc, "客", L_Packet.SINumberToAnyOut(Man.SINumber));
  L_Packet.trn_PutFIO(nDoc, "", Intrm.Name);
  L_Packet.trn_PutString(nDoc, "樮멍", L_Packet.OwnNumInPFR);
  L_Packet.trn_PutString(nDoc, "⪮", L_Packet.OwnFirmName);
  L_Packet.trn_PutOwnFirmTaxNum(nDoc, "멍");
  L_Packet.trn_PutString(nDoc, "⥣ਨ", GetCategoryNick(Packet.PerB, Intrm.Type));
  L_Packet.trn_PutString(nDoc, "", L_Str.PoolItem(L_Packet.cntrt_Pool, Intrm.CntrType));

  L_Packet.trn_PutInt(nDoc, "멃", L_DatTim.YEAR(PerE));
  L_Packet.trn_PutDate(nDoc, "⠇", L_Packet.PrepareDate);

  L_Str.SplitManName(Intrm.Name, Surname, FirstName, Patronymic);
  MAKEPART(R, SZV_6_3_Top, Surname, FirstName, Patronymic, GetCategoryNick(Packet.PerB, Intrm.Type), (Intrm.CntrType=L_Packet.cntrt_Basic), (Intrm.CntrType=L_Packet.cntrt_CA));

  FOR_EACH M DO
   trn_PutInc(nDoc, "", M, Intrm.Object[M], Intrm.Base[M]);
   MAKEPART(R, SZV_6_3_Line, L_Str.PoolItem(L_DatTim._Month_0, M), Intrm.Object[M], Intrm.Base[M]);
  END;
  trn_PutInc(nDoc, "", EMPTYOF(M), Intrm.totObject, Intrm.totBase);
  MAKEPART(R, SZV_6_3_Line, "⮣", Intrm.totObject, Intrm.totBase);
  MAKEPART(R, SZV_6_3_Bot);
  FORMFEED(R);
 END {MakeOneMan};

 PRIVATE PROCEDURE MakeOnePacket();
  CONST
   sObj = 0;
   sBas = 1;
  VAR
   nPack,
   nInvH  : L_XML.tNode;
 BEGIN
  L_Packet.CheckExistTrnFiles();
  L_Packet.trn_OpenFiles();
  L_Packet.CheckPacketType();
  SETZERO(CurNumInP, TotNumInP);

  SELECT(PckBody, Packet, , Packet.Packet);
  CurNumInP:=0;
  WHILE OCCURE(PckBody) DO
   PROMPT(": 窠 "+GetManStrId(PckBody.Man));
   INC(CurNumInP);
   L_General.CallUs(PckBody.SeqNbr = CurNumInP);
   SEARCH(Intrm, Packet, , PckBody.Packet, PckBody.SeqNbr);
   INC(Packet.Sums[sObj], Intrm.totObject);
   INC(Packet.Sums[sBas], Intrm.totBase);
   NEXT(PckBody);
  END; (* WHILE OCCURE(PckBody) ... *)
  REPLACE(Packet);

  TotNumInP:=CurNumInP;
  FIRST(PckBody);
  SEARCH(Intrm, Packet, , PckBody.Packet, PckBody.SeqNbr);

  nPack:=L_Packet.trn_PutHead();
  nInvH:=L_Packet.trn_PutInventoryHead(nPack, "____", trn_PckKind(), TotNumInP);
  L_Packet.trn_PutString(nInvH, "", L_Packet.FormType(Packet.DataType, Packet.CorrType));
  L_Packet.trn_PutString(nInvH, "⥣ਨ", GetCategoryNick(Packet.PerB, Intrm.Type));
  L_Packet.trn_PutString(nInvH, "", L_Str.PoolItem(L_Packet.cntrt_Pool, Intrm.CntrType));
  L_Packet.trn_PutInt(nInvH, "멃", L_DatTim.YEAR(PerE));
  trn_PutInc(nInvH, "  ", EMPTYOF(L_DatTim.tMonth), Packet.Sums[sObj], Packet.Sums[sBas]);

  MAKEPART(R, ADV_6_4, GetCategoryNick(Packet.PerB, Intrm.Type), (Intrm.CntrType=L_Packet.cntrt_Basic), (Intrm.CntrType=L_Packet.cntrt_CA),
                       TotNumInP, Packet.Sums[sObj], Packet.Sums[sBas]);
  FORMFEED(R);

  CurNumInP:=1;
  FIRST(PckBody);
  WHILE OCCURE(PckBody) DO
   INC(CurNumInP);
   PROMPT(": 窠 "+GetManStrId(PckBody.Man));
   CONFORM(PckBody, Man);
   SEARCH(Intrm, Packet, , PckBody.Packet, PckBody.SeqNbr);
   MakeOneMan(nPack);
   NEXT(PckBody);
  END; (* WHILE OCCURE(PckBody) ... *)

  InitPrintAttr(R, Duplex, Off);
  MAKEPART(R, NN1_3_00_1);
  FIRST(PckBody);
  WHILE OCCURE(PckBody) DO
   PROMPT("᮪ 客 : 窠 "+GetManStrId(PckBody.Man));
   CONFORM(PckBody, Man);
   MAKEPART(R, NN1_3_00_2);
   NEXT(PckBody);
  END; (* WHILE OCCURE(PckBody) ... *)
  MAKEPART(R, NN1_3_00_3);
  L_Packet.trn_CloseFiles(nPack);
 END {MakeOnePacket};

 PRIVATE PROCEDURE GetCurPckBodyAttrAsSum(trgAttr: LIKE(PckAttr.Attr)): L_XObj.tSum;
 BEGIN
  IF SEARCH(PckAttr, PckBody, PckBody.Packet, PckBody.SeqNbr, trgAttr) THEN
   RETURN STRTOFLD(PckAttr.Value, NUMERIC);
  ELSE
   RETURN 0;
  END;
 END {GetCurPckBodyAttrAsSum};

 PRIVATE PROCEDURE InitServices(trgPerB, trgPerE: DATE);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

  SetDateParms(trgPerB, trgPerE);
  L_AFM.MakeMultipleIndex("Prb01", "Man: LIKE(Man.Man);"+
                                   "Problem: STRING[32];" +
                                   "PrbShort: STRING[6]",
                                   "Man: Man, Problem");

  CREATE_TABLE(Intrm);
  CREATE_FIELD(Intrm, Group,     L_Packet.tPacketGroup);
  CREATE_FIELD(Intrm, Type,      LIKE(ManSFee.Type));
  CREATE_FIELD(Intrm, CntrType,  L_Packet.tCntrType);
  CREATE_FIELD(Intrm, DataType,  LIKE(Packet.DataType));
  CREATE_FIELD(Intrm, CorrType,  LIKE(Packet.CorrType));
  CREATE_FIELD(Intrm, Man,       LIKE(Man.Man));
  CREATE_FIELD(Intrm, Name,      LIKE(Man.Name));
  CREATE_FIELD(Intrm, ErrMsg,    STRING[124]);
  CREATE_FIELD(Intrm, Packet,    LIKE(Packet.Packet));
  CREATE_FIELD(Intrm, SeqNbr,    LIKE(PckBody.SeqNbr));
  CREATE_FIELD(Intrm, Object,    LIKE(ManSFee.Object)[12], , "0");
  CREATE_FIELD(Intrm, Base,      LIKE(ManSFee.Object)[12], , "0");
  CREATE_FIELD(Intrm, totObject, LIKE(ManSFee.Object));
  CREATE_FIELD(Intrm, totBase,   LIKE(ManSFee.Object));

  CREATE_INDEX(Intrm, Intrm, UNIQUE, , , Group, Type, CntrType, DataType, CorrType, Name, Man);
  CREATE_INDEX(Intrm, Packet, UNIQUE, , , Packet, SeqNbr);
  SET_VERSION_OF_TABLE(Intrm, 0000);
  L_AFM.CreateTemp("Intrm");
 END {InitServices};

 PRIVATE PROCEDURE DeInitServices();
 BEGIN
  L_AFM.AF_PurgeTemp("Prb01");
  L_AFM.AF_PurgeTemp("Intrm");
 END {DeInitServices};

 PRIVATE PROCEDURE CheckIntrm();
 BEGIN
  IF SELECT(Intrm, Intrm, pg_9999) THEN
   OPENREP(R_Err, L_General.NameConnection("SZVIn"), Create);
 
   MAKEPART(R_Err, R_ErrTop);
   WHILE OCCURE(Intrm) DO
    MAKEPART(R_Err, R_ErrLine);
    NEXT(Intrm);
   END; (* WHILE OCCURE(Intrm) *)
   MAKEPART(R_Err, R_ErrBot);
   CLOSEREP(R_Err);
   LIKEMENU(Survey, ""); (*蠥 ࠡ*)
  END;
 END {CheckIntrm};

 PRIVATE PROCEDURE PrintPrt();
  VAR
   totObject,
   totBase: L_PRoll.tSum;
 BEGIN
  IF SELECT(Packet, PacketDS, L_Packet.rcv_PensFund, L_Packet.DTStamp) THEN
   SETZERO(totObject, totBase);
   OPENREP(R_Prt, L_Packet.PacketPrtFullName(), Create, FontProperty, "/U /B /I");
   MAKEPART(R_Prt, R_PrtTop);
   SELECT(Intrm, Packet);
   WHILE OCCURE(Intrm) DO
    MAKEPART(R_Prt, R_PrtLine);
    INC(totObject, Intrm.totObject);
    INC(totBase,   Intrm.totBase);
    NEXT(Intrm);
   END; (* WHILE OCCURE(Intrm) *)
   MAKEPART(R_Prt, R_PrtBot, totObject, totBase);
   L_Packet.SetTimeStampByTheStamp("R_Prt");
   CLOSEREP(R_Prt);
  END;
 END {PrintPrt};

 PRIVATE PROCEDURE MakeAll();
 BEGIN
  IF SELECT(Packet, PacketDS, L_Packet.rcv_PensFund, L_Packet.DTStamp) THEN
   WHILE OCCURE(Packet) DO
    MakeOnePacket();
    NEXT(Packet);
   END; (* WHILE OCCURE(Packet) ... *)
   PrintPrt();
  END;
 END {MakeAll};

 PRIVATE PROCEDURE IntrmPutOneMan(trgGroup: L_Packet.tPacketGroup; trgErrMsg: STRING[]);
  VAR
   curDataType: LIKE(Packet.DataType);
   curCorrType: LIKE(Packet.CorrType);
   curCntrType: L_Packet.tCntrType;
   M          : L_DatTim.tMonth;
   curObject,
   curBase    : LIKE(ManSFee.Object);
 BEGIN
  IF L_Packet.BuildMode = L_Packet.bm_byPacket THEN
   curDataType:=Packet.DataType;
   curCorrType:=Packet.CorrType;
  ELSE
   curDataType:=L_Packet.dt_Basic;
   curCorrType:=L_Packet.ct_None;
  END;
  L_Staff.StandOnMainContract(Man.Man, L_Packet.PckMyFirm, L_DatTim.MonthEnd(ManSFee.Period));
  IF Staff.Contract = L_Staff.cnt_ContractorsAgreement THEN
   curCntrType:=L_Packet.cntrt_CA;
  ELSE
   curCntrType:=L_Packet.cntrt_Basic;
  END;
  M:=L_DatTim.MONTH(ManSFee.Period);
  curObject:=ManSFee.Object;
  curBase:=ManSFee.Object-ManSFee.ExcCmn-ManSFee.ExcPrt[L_SFee.b_PFR];
  IF ManSFee.Fee[L_SFee.p_PFOv] = 0 (* ᮢ  㬬 ॢ襭*) THEN
   DEC(curBase, ManSFee.OvrPrt[L_SFee.b_PFR]);
  END;

  ADD(Intrm, Intrm, , trgGroup, ManSFee.Type, curCntrType, curDataType, curCorrType,
                      L_Packet.GetManInPFRFName(PerE), Man.Man,
                      Intrm.Object[M], curObject, Intrm.Base[M], curBase,
                      Intrm.totObject, curObject, Intrm.totBase, curBase);
  IF ~!trgErrMsg & !Intrm.ErrMsg THEN
   Intrm.ErrMsg:=L_DatTim.PeriodStr(ManSFee.Period)+": "+trgErrMsg;
   REPLACE(Intrm);
  END;
 END {IntrmPutOneMan};

 PRIVATE PROCEDURE CheckManSFee(Cond: SCAL[2]);
 BEGIN
  L_General.Assert(Cond,
                   " "+Man.Man+" "+Man.Name+
                   "|室 믮  客 ᮢ  "+L_DatTim.PeriodStr(ManSFee.Period));
 END {CheckManSFee};

 PRIVATE PROCEDURE PutManInIntrm();
  VAR
   defType: LIKE(ManSFee.Type);
 BEGIN
  PROMPT(": " + L_Str.IntStr(Man.Man));

  SETSEL(ManSFee, MyFirm, L_Packet.PckMyFirm, Man.Man, 1);
  SRCINSEL(ManSFee, GE, , PerB);
  WHILE OCCURE(ManSFee) & (ManSFee.Period <= PerE) DO
   L_Staff.StandOnMainContract(ManSFee.Man, ManSFee.MyFirm, L_DatTim.MonthEnd(ManSFee.Period));
   defType:=L_SFee.DefineType(ManSFee.MyFirm, ManSFee.Man, ManSFee.Period);
   IF ManSFee.Type # defType THEN
    IntrmPutOneMan(pg_9999, "    ᫮  '"+L_Str.PoolItem(L_SFee.t_Pool, ManSFee.Type)+
                            "'  '"+L_Str.PoolItem(L_SFee.t_Pool, defType)+"'");
   ELSIF L_SFee.ManIsInsuredInPF(ManSFee.Man, ManSFee.Period) THEN
    IF L_SFee.ManHasSINumber() THEN
     L_Russia.CheckSINumber(Man.SINumber, 0);
     IntrmPutOneMan(pg_Norm, "");
    ELSIF L_SFee.ManHasADV1() THEN
     IntrmPutOneMan(pg_9999, " ");
    ELSE
     IntrmPutOneMan(pg_9999, "  ");
    END;
   END;
   NEXT(ManSFee);
  END; (* WHILE OCCURE(ManSFee) ... *)
 END {PutManInIntrm};

 PRIVATE PROCEDURE PrepareGroup();
 BEGIN
  SELECT(ManSFee, Actual, , 1, L_Packet.PckMyFirm);
  WHILE OCCURE(ManSFee) DO
   NARROWSEL(ManSFee, Man);
   SAVE(ManSFee);
   CONFORM(ManSFee, Man);
   PutManInIntrm();
   RESTORE(ManSFee);
   NEXTINEXTENDEDSEL(ManSFee, Man);
  END; (* WHILE OCCURE(ManSFee) *)
 END {PrepareGroup};

 PRIVATE PROCEDURE CheckPer(Msg: STRING[]);
 BEGIN
  L_StdFrm.Question(Msg+"| | ਮ  "+L_DatTim.DateStr(PerB)+"  "+L_DatTim.DateStr(PerE));

  L_General.Assert_wReferToAdmin(L_APtm.MonthIsClosed(PerE, L_APtm.system_Salary),
                                 L_DatTim.PeriodStr(PerE) + "     ௫");
 END {CheckPer};

 PRIVATE PROCEDURE SetDateParms(trgPerB, trgPerE: DATE);
 BEGIN
  PerB:=trgPerB;
  PerE:=trgPerE;
  L_General.Assert((PerB = L_DatTim.YearBeg(PerB)) & (PerE = L_DatTim.YearEnd(PerB)), "ਮ ᢥ  ࠢ ");
 END {SetDateParms};

 PUBLIC PROCEDURE Single();
  VAR
   PerOfPay: SCAL[2][12];
   Dummy   : SCAL[2];
   nPack   : L_XML.tNode;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Man), " ⠭ 䨧᪮ ");
  TRY [ABORT_AFTER(AA_ON)]
   InitServices(Memo.ud_fr(), Memo.ud_ut());
   CurPacket:=L_Packet.trn_Init(PerE, L_Packet.bm_bySingle, L_Packet.part_Manins, L_Packet.knd_PF_SZV6_3);
   CheckPer("ନ஢ ᢥ  "+
            "| | - " + FLDTOSTR(Man.Man, "0", 6) + " " + Man.Name);

   L_Packet.InsPFPacket(L_Packet.knd_PF_SZV6_3, CurPacket, PerB, PerE, L_Packet.dt_Basic, L_Packet.ct_None);
   CurNumInP     :=0001;
   TotNumInP     :=CurNumInP;
   L_Packet.trn_OpenFiles();
   nPack:=L_Packet.trn_PutHead();

   L_Packet.MakeProjectPrt();
   PutManInIntrm();
   IF SELECT(Intrm, Intrm) THEN
    SetPckBodyByIntrm(CurPacket);
    WHILE OCCURE(Intrm) DO
     PROMPT("⮢ ⮢ "+ Intrm.Man);
     CurNumInP:=0;
     MakeOneMan(nPack);
     NEXT(Intrm);
    END;

    L_Packet.trn_CloseFiles(nPack);
    DeInitServices();
   ELSE
    L_StdFrm.BlueHalt(" 室   ᢥ");
   END;
  EXCEPT
  END;
  Dummy:=L_Packet.ChoosePacket(L_Packet.knd_PF_SZV6_3, PerB, PerE, L_Packet.dt_Basic, L_Packet.ct_None);
 END {Single};

 PRIVATE PROCEDURE BuildPackets();
  VAR
   PacketSize: NUMERIC[0];
 BEGIN
  PacketSize:=P_OwnData.ODPacketSize(L_Packet.PrepareDate);
  SELECT(Intrm, Intrm);
  WHILE OCCURE(Intrm) DO
   NARROWSEL(Intrm, Group, Type, CntrType, DataType, CorrType);
   CurNumInP:=0;
   WHILE OCCURE(Intrm) DO
    PROMPT("⮢ ⮢ "+ Intrm.Man);
    L_General.CallUs(Intrm.Group = pg_Norm);
    CurNumInP:=(CurNumInP MOD PacketSize)+1;
    INC(CurPacket, CurNumInP = 1);
    SetPckBodyByIntrm(CurPacket);
    NEXT(Intrm);
   END;
   NEXTINEXTENDEDSEL(Intrm, Group, Type, CntrType, DataType, CorrType);
  END;
 END {BuildPackets};

 PRIVATE PROCEDURE intMake();
 BEGIN
  CheckIntrm();
  BuildPackets();
  MakeAll();
  DeInitServices();
  L_Packet.ShowMakedPackets();
 END {intMake};

 PUBLIC PROCEDURE InitialAll();
 BEGIN
  InitServices(L_DatTim.YearBeg(Memo.ud_cd()), L_DatTim.YearEnd(Memo.ud_cd()));

  CurPacket:=L_Packet.trn_Init(PerE, L_Packet.bm_byAll, L_Packet.part_Manins, L_Packet.knd_PF_SZV6_3);
  L_Packet.CheckExistingPackets(L_Packet.knd_PF_SZV6_3, PerB, PerE, L_Packet.dt_Basic, L_Packet.ct_None);
  DEC(CurPacket); (* ନ㥬 ᢮  -  ⢮   *)
  CheckPer("ନ஢ ᢥ  ");
  PrepareGroup();

  intMake();
 END {InitialAll};

 PUBLIC PROCEDURE ByCurrentPacket();
 BEGIN
  InitServices(Packet.PerB, Packet.PerE);
  L_Packet.SetSamplePacketDone();
  SAVE(Packet);
  CurPacket:=L_Packet.trn_Init(PerE, L_Packet.bm_byPacket, L_Packet.part_Manins, Packet.Kind);
  SELECT(PckBody, Packet, , Packet.Packet);
  WHILE OCCURE(PckBody) DO
   CONFORM(PckBody, Man);
   PutManInIntrm();
   NEXT(PckBody);
  END; (* WHILE OCCURE(PckBody) ... *)
  RESTORE(Packet);

  intMake();
 END {ByCurrentPacket};

END.