(*
%Copyright   (c) Polak Computer System
%Author      18.07.2002 16:28:46 LDA
%Purpose      ਪ  ਮ
%Type        report
%Specific    SYS
%Modified    19.04.2013 17:33:48 POLAK\MLB
%Environment
*)

 IMPORT L_General, L_Man, L_DatTim, L_EDO, L_Basis, Math, L_Str, FIO, P_EDOL, P_Firm,
        L_bp, E_Staff, L_EC, L_Staff;

 VAR
  wMF: SCAL[2];

 PRIVATE PROCEDURE MakeTop();
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
  END;
  L_Basis.wb_WrStr("F", "㯯 ");
  L_Basis.wb_WrStr("F", "㦡");
  L_Basis.wb_WrStr("F", "⤥");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "⥣");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "᭮");
  L_Basis.wb_WrStr("F", " ਪ");
  L_Basis.wb_WrStr("F", "筨");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "㬬");
  L_Basis.wb_WrStr("F", " 筮 ");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", " ᥪࠊ");
  L_Basis.wb_WrStr("F", " ᥪ");
  L_Basis.wb_WrStr("F", "㬬(ᥪ)");
  L_Basis.wb_WrStr("F", "ᠭ");
  L_Basis.wb_WrStr("F", "⠏");
  L_Basis.wb_WrStr("F", " ਪ");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", " ᮡ");
  L_Basis.wb_WrStr("F", "業");
  L_Basis.wb_WrStr("F", " ਪ");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "ࠦ");
  L_Basis.wb_WrStr("F", "⮢");
  L_Basis.wb_WrStr("F", " ");
  L_Basis.wb_WrStr("F", " ");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "⭨(0108)");
  L_Basis.wb_WrStr("F", "ਭ");
  L_Basis.wb_WrStr("F", "ਨ");
  L_Basis.wb_TermLine("F");
 END {MakeTop};

 PRIVATE PROCEDURE MakeLine();
  VAR
   PropValue: STRING[];
 BEGIN
  IF wMF THEN
   CONFORM(EDOrder, MyFirm);
   L_Basis.wb_WrScl("F", MyFirm.MyFirm);
   L_Basis.wb_WrStr("F", MyFirm.vzSign);
  END;
  L_Basis.wb_WrStr("F", EDOGrp.Name);
  L_Basis.wb_WrStr("F", L_Staff.getServiceName());
  L_Basis.wb_WrStr("F", L_Staff.getDepartName());
  L_Basis.wb_WrScl("F", Sort.Sort);
  L_Basis.wb_WrStr("F", Sort.Name);
  L_Basis.wb_WrStr("F", Post.Name);
  L_Basis.wb_WrStr("F", Union.Name);
  L_Basis.wb_WrScl("F", Staff.TSN);
  L_Basis.wb_WrStr("F", EDOCause.Name);
  L_Basis.wb_WrStr("F", EDOKind.Name);
  L_Basis.wb_WrStr("F", EDOSrc.Name);
  L_Basis.wb_WrStr("F", L_Man.CitizenAsStr(Man.Man, EDOrderL.OcrDate));
  L_Basis.wb_WrNum("F", EDOrderL.BySum, 2);
  L_Basis.wb_WrStr("F", L_EDO.GetFixInPC_byStr(EDOKind.EDOGrp, EDOrderL.FixInPC));

  L_EDO.GetEDOLPropValue(P_EDOL.P_Route, PropValue);
  L_Basis.wb_WrStr("F", PropValue);

  L_EDO.GetEDOLPropValue(P_EDOL.P_Sort, PropValue);
  IF ~!PropValue THEN
   SEARCH(Sort, Sort, , PropValue);
   L_Basis.wb_WrScl("F", Sort.Sort);
   L_Basis.wb_WrStr("F", Sort.Name);
  ELSE
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
  END;

  L_EDO.GetEDOLPropValue(P_EDOL.P_SortGuilt, PropValue);
  IF !PropValue THEN
   PropValue:="0";
  END;
  L_Basis.wb_WrNum("F", STRTOFLD(PropValue, FLOAT), 2);

  L_Basis.wb_WrStr("F", L_Str.PoolItem("-|+", EDOrder.State=L_EDO.st_ordSigned));
  L_Basis.wb_WrDat("F", EDOrder.Date);
  L_Basis.wb_WrStr("F", L_Str.PoolItem(L_EDO.type_Pool, EDOrderL.Type));
  L_Basis.wb_WrStr("F", L_Str.PoolItem(L_EDO.st_Pool,   EDOrderL.Status));
  L_Basis.wb_WrDat("F", EDOrderL.OcrDate);
  L_Basis.wb_WrNum("F", EDOrderL.ByPrc, 1);
  L_Basis.wb_WrScl("F", EDOrderL.EDOKind);
  L_Basis.wb_WrStr("F", Man.Name);

  L_EDO.GetEDOLPropValue(P_EDOL.P_BoxNbr, PropValue);
  L_Basis.wb_WrStr("F", PropValue);

  L_Basis.wb_WrDat("F", EDOrder.PrpDate);
  L_Basis.wb_WrStr("F", L_DatTim.PeriodStr(EDOrder.Closed));
  L_Basis.wb_WrScl("F", EDOrder.EDOrder);
  L_Basis.wb_WrStr("F", EDOrder.SrcNum);

  L_EDO.GetEDOLPropValue(P_EDOL.P_TSN, PropValue);
  L_Basis.wb_WrStr("F", PropValue);
  L_Basis.wb_WrDat("F", Staff.BegDate);
  L_EDO.GetEDOLPropValue(P_EDOL.P_Comments, PropValue);
  L_Basis.wb_WrStr("F", PropValue);
  L_Basis.wb_TermLine("F");
 END {MakeLine};

 PRIVATE PROCEDURE E_NeedPrintEDOL_T0301(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Staff.NeedPrintEDOL_T0301), 0);
 END {E_NeedPrintEDOL_T0301};

 PRIVATE PROCEDURE NeedEDOL(D: DATE): SCAL[2];
 BEGIN
  IF E_NeedPrintEDOL_T0301(D) | L_EDO.AcceptableEDOrderL() THEN
   CONFORM(EDOrderL, EDOKind);
   RETURN (EDOKind.EDOGrp = L_EDO.grp_Violation) |
          (EDOKind.EDOGrp = L_EDO.grp_Reward)    |
          (EDOKind.EDOGrp = L_EDO.grp_BonusFee);
  ELSE
   RETURN 0;
  END;
 END {NeedEDOL};

 PUBLIC PROCEDURE T0301();
  CONST
   bpId="T0301";
  VAR
   BPer,
   EPer : DATE;
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_General.SetIntvlByIntvl(BPer, EPer);
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  L_bp.Begin(bpId, " ਪ", L_bp.t_Basis, L_General.tc_inIntvl);
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  MakeTop();
  SELECT(EDOrder, EDOrder);
  WHILE OCCURE(EDOrder) DO
   PROMPT(EDOrder.EDOrder);
   IF L_DatTim.IsActive_Inc(EDOrder.PrpDate, BPer, EPer) |
      L_DatTim.IsActive_Inc(EDOrder.Date,    BPer, EPer) |
      L_DatTim.IsActive_Inc(EDOrder.Closed,  L_DatTim.Per(BPer), L_DatTim.Per(EPer)) THEN
    SELECT(EDOrderL, EDOrder, , EDOrder.EDOrder);
    WHILE OCCURE(EDOrderL) DO
     PROMPT(EDOrder.EDOrder + " . " + EDOrderL.TSN);
     IF NeedEDOL(EPer)  THEN
      CONFORM(EDOKind,  EDOGrp);
      CONFORM(EDOrderL, Staff);
      SELECT(EDOLC, edcType, , EDOrderL.EDOrder, EDOrderL.Row, L_EDO.edoct_Initial);
      CONFORM(EDOLC,    EDOCause);
      CONFORM(EDOrder,  EDOSrc);
      CONFORM(Staff,    Man);
      HISTCONF(Math.Max(EDOrderL.OcrDate, Staff.BegDate), Staff, StaffLog);
      CONFORM(StaffLog, Officer);
      CONFORM(Officer, Post);
      CONFORM(Officer, Sort);
      CONFORM(Officer, Union);
      MakeLine();
     END; (* IF (EDOKind.EDOGrp... *)
     NEXT(EDOrderL);
    END; (* WHILE OCCURE(EDOrderL) ... *)
   END; (* IF L_DatTim.IsActive_Inc... *)
   NEXT(EDOrder);
  END; (* WHILE OCCURE(EDOrder) ... *)
  FIO.Close(F);
  L_bp.End();
 END {T0301};

END.
