(*
%Copyright   (c) Polak Computer System
%Author      24.01.2001 20:31:51 GINA
%Purpose       窨  室 
%Type        report
%Specific    SYS
%Modified    11.10.2012 16:26:09 POLAK\GAV
%Environment
*)

 MODULE T7_2001 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Tax, L_Str, Math, L_Russia,
        L_PRoll, L_Staff, L_Man, P_Firm, P_Man, Memo, L_Env, P_MyFirm;

 CONST
  M = " ";
  Y = "  ";

 VAR
  CurP, CurPE: DATE;
  Numbers  : NUMERIC[2][14];
  SNumbers : STRING[30][14];
  _FirmName: STRING[][2];
  _Town,
  _Village,
  _Street,
  _Block   : STRING[];

(*
$P{Cap:
L_DatTim.YearBeg(CurP), L, "y"
P_Firm.FP_INN(Firm.Firm, CurPE)+"/"+P_Firm.FP_KPP(Firm.Firm, CurPE), L, ""
Man.INN, L, ""
L_Man.GetManSINumber_asStr(), L, ""
P_MyFirm.NumInPFR(Staff.MyFirm, CurPE), L, ""
P_Man.GetManProSoft(Man.Man, SYSDATE(), P_Man.P_TaxDep), L, ""
P_Firm.FP_TaxDepCode(Firm.Firm, SYSDATE()), L, ""
Man.Name, L, ""
L_Man.GetManDocName(Man.DocType), L ""
L_Man.GetManDocCode(Man.DocType), L ""
_FirmName[0], L, ""
Man.PspSer, L, ""
Man.PspNbr, L, ""
Man.Birth, L, "D.N.y"
_FirmName[1], L, ""
ManAdr.Country, L, ""
ManAdr.Zip, L, ""
ManAdr.Region, L, ""
ManAdr.Distr, L, ""
_Town, L, ""
P_Firm.FP_TaxCardResp(Firm.Firm, SYSDATE()), L, ""
_Village, L, ""
_Street, L, ""
ManAdr.House, L, ""
_Block, L, ""
ManAdr.Flat, L, ""
L_Tax.Tax_IsResident(CurPE), L, "2|1"
StDIsDeclared(), L, "2|1"
Post.Name, L, ""
StaffLog.Date, L, "D.N.Y"
@
                                   窠   室    室 䨧᪨   ####  N _________                     ଠ 1-
================================================================================================================================================================
| 1.     (筨 室)            2.   ⥫騪 (⥫ 室)                               |
|1.1.  /  #################################################### 2.1.  ############   2.2.  客 ᢨ⥫⢠   ########################|
|1.2.  ⥫騪 客 ᮢ    ################## 2.3.   ࣠,  ⥫騪 ⮨   ########################|
|1.3.   ࣠,   ⮨   ############ 2.4. , , ⢮ ################################################              |
|1.4.  ()                             2.5.  㬥, 㤮⮢饣 筮 ##############################  ##        |
|################################################################### 2.6. ,  㬥 ########## #######       2.7.  ஦ ##########        |
|################################################################### 2.8.  ﭭ  ⥫⢠:   ࠭ ###  ######  ॣ ##     |
|1.5. ⢥⢥    窨                    ࠩ ################################ த #############################################|
|################################################################### ᥫ 㭪 ################################ 㫨 ##################################|
|(, 䠬,,⢮)                                    ############  ###############  #########################################|
|                                                                    2.9.  # (1-१, 2-१). 㬥, ⢥ত饣 ______|
|                                                                    2.10. ⠭   (1),   (2) #                                  |
|                                                                    2.11.   ######################################  祭 ########|
}

(*
$P{ Part31:
?, L, ""
?, L, ""
@
|--------------------------------------------------------------------------------------------------------------------------------------------------------------|
| 砫         |    ⥫騪   | 0                 |७ᥭ  -  |    ⥫騪   | 0                 |
| ਮ|     ⮬    | ################# | ᫥. |     ⮬    | ################# |
}
*)

$P{SubCap:
?, L, ""
@
|##############################################################################################################################################################|
}

$P{SubCap1:
?, L, ""
@
|--------------------------------------------------------------------------------------------------------------------------------------------------------------|
|##################|ਮ   |      ࠫ          ५                                        ⮣|
}

$P{DelLine:
@
|--------------------------------------------------------------------------------------------------------------------------------------------------------------|
}

$P{DelLine2:
@
|==============================================================================================================================================================|
}

$P{Line:
?, L, ""
?, L, ""
SNumbers[01], R, ""
SNumbers[02], R, ""
SNumbers[03], R, ""
SNumbers[04], R, ""
SNumbers[05], R, ""
SNumbers[06], R, ""
SNumbers[07], R, ""
SNumbers[08], R, ""
SNumbers[09], R, ""
SNumbers[10], R, ""
SNumbers[11], R, ""
SNumbers[12], R, ""
SNumbers[13], R, ""
@
|##################|#########|######### ######### ######### ######### ######### ######### ######### ######### ######### ######### ######### ######### #########|
}

(*
$P{ Part1:
@
|     㬥, ⢥ত騥   (),  த⥫, 㭠  ⥫                                                              |
|     ________________________________________________________________________________________________________________________________________________________ |
|4. ࠢ   , ।ᬮ७  . 2, 3 . 221                                                                                           |
|     _________________________________ ᭮  ।⠢  _________________________________________________________________________ |
}
*)

(*
|==============================================================================================================================================================|
*)

(*
$P{ Part6:
@
|--------------------------------------------------------------------------------------------------------------------------------------------------------------|
|                  |                                                              㬬                                                             |
|                  |-------------------------------------------------------------------------------------------------------------------------------------------|
|⥫        |                   |                   |             |             |।  .|   ।騩 ਮ|
|                  |        ᫥|         ঠ| ⥫騪|   ⮬|࣠   ᪠|---------------------------------------|
|                  |                   |                   |                   |                   |                   |         饭|            ⥭|
|------------------|-------------------|-------------------|-------------------|-------------------|-------------------|-------------------|-------------------|
}
*)

(*
$P{ Part61:
?, L, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
@
|##################|###################|###################|###################|###################|###################|###################|###################|
}
*)

$P{EndPart:
P_Firm.FP_TaxCardCont(Firm.Firm, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
@
|==============================================================================================================================================================|
|  ।⠢ ࠢ:                                                                                                                             |
| )  ࣠  室: N ࠢ ______________________    ___________________________                                                          |
| ) ⥫騪  室: N ࠢ ______________________    ___________________________                                                          |
| )  ࣠  㬬 , ।  ᪠: N ࠢ (쬠) ______________________    ___________________________            |
|                                                                                                                                                              |
| ࠢ쭮   窨 ஢७:                                                                                                        |
|   ___________________ #################################################################### _________________________                                         |
|        ()         (, 䠬, , ⢮)                                         ()                                                  |
=(c) Polak=====================================================================================================================================##########=#####=
}
*)

 PRIVATE PROCEDURE IsAfterAPtmStart(): SCAL[2];
 BEGIN
  RETURN L_DatTim.YearBeg(L_Env.aptm_Start) <= L_DatTim.YearBeg(CurP);
 END {IsAfterAPtmStart};

 PRIVATE PROCEDURE GetNbrStr(N: NUMERIC[2]): STRING[];
 BEGIN
  IF IsAfterAPtmStart() THEN
   RETURN FLDTOSTR(N, "2.", 0);
  ELSE
   RETURN "";
  END;
 END {GetNbrStr};

 PRIVATE PROCEDURE GetNbrStrIntg(N: NUMERIC[2]): STRING[];
 BEGIN
  IF IsAfterAPtmStart() THEN
   RETURN FLDTOSTR(N, "0");
  ELSE
   RETURN "";
  END;
 END {GetNbrStrIntg};

 PRIVATE PROCEDURE StDIsDeclared(): SCAL[2];
 BEGIN
  IF L_Tax.Tax_IsResident(CurPE) THEN
   RETURN SELECT(_MnTA, _MnTA, Man.Man, L_Tax.Tax2001_mt_StD);
  END;
  RETURN 0;
 END {StDIsDeclared};

 PRIVATE PROCEDURE TypeSubCap(TopL: SCAL[3]; S, S1: STRING[]; BotL: SCAL[2]);
 BEGIN
  IF    TopL=1 THEN
   MAKEPART(R, DelLine);
  ELSIF TopL=2 THEN
   MAKEPART(R, DelLine2);
  END;
  IF ~!S THEN
   MAKEPART(R, SubCap, S);
  END;
  IF BotL THEN
   MAKEPART(R, SubCap1, S1);
  END;
 END {TypeSubCap};

 PRIVATE PROCEDURE IsPers(_VCode: LIKE(TaxAdv.VCode)): SCAL[2];
 BEGIN
  RETURN (_VCode="0103") | (_VCode="0104") | (_VCode="0105");
 END {IsPers};

 PRIVATE PROCEDURE IsSingleParent(_VCode: LIKE(TaxAdv.VCode)): SCAL[2];
 BEGIN
  RETURN (_VCode="0106");
 END {IsSingleParent};

 PRIVATE PROCEDURE GetPrepReason(_IsPers: SCAL[2]);
  VAR
   _StopD: LIKE(ManTA.StopD);
   _Cnt  : NUMERIC[0];
   _IsSingleParent: SCAL[2];
 BEGIN
  IF L_Tax.Tax_IsResident(CurPE) THEN
   _StopD:=MINOF(DATE); SETZERO(_Cnt, _IsSingleParent);
   SELECT(_MnTA, _MnTA, , Man.Man, L_Tax.Tax2001_mt_StD);
   WHILE OCCURE(_MnTA) DO
    L_Tax.Tax_AccessManTA_by_MnTA();
    CONFORM(ManTA, TaxInq);
    IF TaxInq.InqType = L_Tax.inqt_Own THEN
     CONFORM(ManTA, TaxAdv);
     IF IsPers(TaxAdv.VCode)=_IsPers THEN
      _StopD:=Math.Max(_StopD, ManTA.StopD);
      TypeSubCap(0, "     "+FLDTOSTR(L_Tax.GetTAValue(CurP, 0), "0", 0)+" 㡫"+". ᭮  ।⠢: "+TaxInq.SrcNum, " ", 0);
      IF _IsPers = 0 THEN
       TypeSubCap(0, "     ਮ ⢨  "+L_DatTim.PeriodStr(ManTA.StopD), " ", 0);
      END;
      _IsSingleParent:=_IsSingleParent | IsSingleParent(TaxAdv.VCode);
      INC(_Cnt);
     END;
    END; (* IF TaxInq.InqType... *)
    NEXT(_MnTA);
   END; (* WHILE OCCURE(_MnTA) ... *)
   IF (_IsPers = 0) & (_Cnt>0) THEN
    TypeSubCap(0, "     ⢮ ⥩ "+FLDTOSTR(_Cnt, "0", 0), " ", 0);
   END;
  END;
 END {GetPrepReason};

 PRIVATE PROCEDURE Convert(N: NUMERIC[2][14]; VAR S: STRING[30][14]; Intg: SCAL[2]);
  VAR i: SCAL[15];
 BEGIN
  SETEMPTY(S);
  i:=1;
  WHILE i < 14 DO
   IF ~!N[i] THEN
    IF Intg THEN
     S[i]:=GetNbrStrIntg(N[i]);
    ELSE
     S[i]:=GetNbrStr(N[i]);
    END;
   END;
   INC(i);
  END;
 END {Convert};

 PRIVATE PROCEDURE AddArr(VAR D: NUMERIC[2][12]; N: NUMERIC[2][12]; d: NUMERIC[0]);
  VAR i: SCAL[13];
 BEGIN
  SETZERO(i);
  WHILE i <= 11 DO
   IF N[i] = 0 THEN
    SETEMPTY(Numbers[i+1]);
   ELSE
    Numbers[i+1]:=N[i];
    INC(D[i], d*N[i]);
    INC(Numbers[13], N[i]);
   END;
   INC(i);
  END; (* WHILE i ...  *)
 END {AddArr};

 PRIVATE PROCEDURE Restrict(VAR What: NUMERIC[2][12]; By: NUMERIC[2][12]);
  VAR
   i: SCAL[100];
   W,
   B: NUMERIC[2];
 BEGIN
  SETZERO(i, W, B);
  WHILE i <= 11 DO
   INC(W, What[i]);
   INC(B,   By[i]);
   IF W > B THEN
    IF i < 11 THEN
     INC(What[i+1], W-B);
     DEC(What[i],   W-B);
     W:=B;
    ELSE
     DEC(What[i], W-B);
    END;
   END;
   INC(i);
  END; (* WHILE i ...  *)
 END {Restrict};

 PRIVATE PROCEDURE TypeLine(S: STRING[];VAR D: NUMERIC[2][12]; N: NUMERIC[2][12]; d: NUMERIC[0]; sPer: STRING[]; Intg: SCAL[2]);
 BEGIN
  SETZERO(Numbers);
  AddArr(D, N, d);
  IF (Numbers[13] # 0) | ~IsAfterAPtmStart() THEN
   Convert(Numbers, SNumbers, Intg);
   MAKEPART(R, Line, S, sPer);
  END;
 END {TypeLine};

 PRIVATE PROCEDURE TypeBlankLines();
 BEGIN
  SETEMPTY(SNumbers);
  MAKEPART(R, Line, "", M);
  MAKEPART(R, Line, "", M);
  MAKEPART(R, Line, "", M);
  MAKEPART(R, Line, "", M);
  MAKEPART(R, Line, "", M);
 END {TypeBlankLines};

 PRIVATE PROCEDURE Type_FYB_Line(S: STRING[]; N: NUMERIC[2][12]; UpTo: SCAL[12]; sPer: STRING[]; Intg: SCAL[2]);
  VAR i: SCAL[14];
 BEGIN
  SETZERO(i, Numbers);
  WHILE i <= UpTo DO
   Numbers[i+1]:=Numbers[i]+N[i]; INC(i);
  END; (* WHILE i ...  *)
  WHILE i <= 11 DO
   INC(i); SETEMPTY(Numbers[i]);
  END;
  Numbers[13]:=Numbers[UpTo+1];
  Convert(Numbers, SNumbers, Intg);
  MAKEPART(R, Line, S, sPer);
 END {Type_FYB_Line};

 PRIVATE PROCEDURE Type_ReadyFYB_Line(S: STRING[]; N: NUMERIC[2][12]; UpTo: SCAL[12]; sPer: STRING[]; VAR Total: NUMERIC[2]);
  VAR i: SCAL[14];
 BEGIN
  SETZERO(i, Numbers);
  WHILE i <= UpTo DO
   Numbers[i+1]:=N[i]; INC(i);
  END; (* WHILE i ...  *)
  WHILE i <= 11 DO
   INC(i); SETEMPTY(Numbers[i]);
  END;
  Numbers[13]:=Numbers[UpTo+1];
  Total:=Numbers[13];
  Convert(Numbers, SNumbers, 1);
  MAKEPART(R, Line, S, sPer);
 END {Type_ReadyFYB_Line};

 PRIVATE PROCEDURE MakeFYBArr(VAR D: NUMERIC[2][12]; S: NUMERIC[2][12]; UpTo: SCAL[12]; MayBeNeg: SCAL[2]);
  VAR i: SCAL[13];
 BEGIN i:=0;
  WHILE i <= UpTo DO
   IF i < UpTo THEN
    INC(D[i+1], D[i]);
    INC(S[i+1], S[i]);
   END;
   IF (D[i] > S[i]) | MayBeNeg THEN
    DEC(D[i], S[i]);
   ELSE
    D[i]:=0;
   END;
   INC(i);
  END;
 END {MakeFYBArr};

 PRIVATE PROCEDURE GetOtherYear(D1, D2: DATE): NUMERIC[2];
  VAR
   _Dummy : NUMERIC[2][12];
   LimVal : NUMERIC[0];
   Dummy  : NUMERIC[2];
 BEGIN
  SETZERO(_Dummy);
  IF L_Tax.StandOnSpecifiedTaxAdv(CurP, L_Tax.Tax2001__oc_PYTax, "") > 0 THEN
   Dummy:=L_Tax.GetOneTaxAdv(D1, D2, L_Tax.Tax2001_mt_Tax, TaxAdv.TaxAdv, _Dummy, LimVal);
  END;
  RETURN L_Tax.Tax2001_GetArrSum(_Dummy);
 END {GetOtherYear};

 PRIVATE PROCEDURE GetSpecVCode(_VCode: LIKE(TaxAdv.VCode); VAR _OthrInc, _Limits: NUMERIC[2][12]);
  VAR
   AdvInc: NUMERIC[2][12];
   LimVal: NUMERIC[2];
   Dummy : SCAL[2];
 BEGIN
  SETZERO(AdvInc, LimVal);
  IF L_Tax.StandOnSpecifiedTaxAdv(CurP, L_Tax.Tax2001__oc_IsMNS, _VCode) > 0 THEN
   Dummy:=L_Tax.GetOneTaxAdv(CurP, CurP, L_Tax.Tax2001_mt_Inc, TaxAdv.TaxAdv, AdvInc, LimVal);
   IF LimVal > 0 THEN
    SETZERO(i);
    WHILE (LimVal > 0) & (i < 12) DO
     IF _AdvInc[i] > 0 THEN
      INC(_Limits[i], Math.Min(_AdvInc[i], LimVal));
      DEC(LimVal, _Limits[i]);
     END;
     INC(i);
    END; (* WHILE i < ... *)
   END; (* IF LimVal > 0 ... *)
  END;
  TypeLine(_VCode, _OthrInc, AdvInc, +1, M, 0);
 END {GetSpecVCode};

 PRIVATE PROCEDURE Make();
  VAR
   i        : NUMERIC[0];
   _tsDbtTax,
   _tsCrdTax,
   _tsClcTax,
   _tsGetTax,
   _EnfTax,
   _ToTax,
   _Oblag,
   _Minus,
   _Dummy,
   _PureInc,
   _OthrInc,
   _AdvInc,
   _Limits,
   _LimVal,
   _OthrMns,
   _ClcTax,
   _GetTax,
   _RetnTax,
   _DbtTax,
   _CrdTax  : NUMERIC[2][12];
   Dummy,
   LimVal   : NUMERIC[2];
   P        : DATE;
   Idx      : SCAL[12];
   msClcTax, msGetTax, msDbtTax, msCrdTax, msEnfTax, msRetnTax, msOverTax,
   tsClcTax, tsGetTax, tsDbtTax, tsCrdTax, tsEnfTax, tsRetnTax, tsOverTax: NUMERIC[2];
   _MainScale: L_Tax.tTax2001_ScalesType;
 BEGIN
  _MainScale:=L_Tax.Tax_GetScaleForMainScale(CurP);
  L_Tax.SetTax2001_ScaleToGather(_MainScale);
  TypeSubCap(2, " 3.       室 䨧᪮  (஬   室,   ⠢ 35%)", "", 0);

  SETZERO(Dummy);
  IF L_DatTim.MONTH(CurP) = 11 THEN
   P:=L_DatTim.IncMonth(L_DatTim.YearBeg(CurP), +12);
   Dummy:=GetOtherYear(P, P);
  END;
  MAKEPART(R, Part31, GetNbrStrIntg(GetOtherYear(L_DatTim.YearBeg(CurP), L_DatTim.YearBeg(CurP))), GetNbrStrIntg(Dummy));

  PROMPT("室");
  TypeSubCap(0, "", " 室/", 1);
  SETZERO(_PureInc, _ToTax);
  IF IsAfterAPtmStart() THEN
   L_Tax.Tax2001_GetPureIncome(CurP, _PureInc);
   TypeLine(L_Tax.Tax2001_PureIncomVCode, _ToTax, _PureInc, +1, M, 0);
 
   IF _MainScale = L_Tax.Tax2001_ScndScale THEN
    L_Tax.SetTax2001_ScaleToGather(L_Tax.Tax2001_MainScale);  (* ᮡ 室  Tax2001_MainScale *)
   END;
   SELECT(_MnTA, _MnTA, , Man.Man, L_Tax.Tax2001_mt_Inc);
   WHILE OCCURE(_MnTA) DO
    CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType, _MnTA._TaxAdv);
    SAVE(_MnTA);
    L_Tax.Tax_AccessManTA_by_MnTA();
    SETZERO(_OthrInc);
    IF L_Tax.GetOneTaxAdv(CurP, CurP, L_Tax.Tax2001_mt_Inc, ManTA.TaxAdv, _OthrInc, LimVal) THEN
     IF TaxAdv.TaxAdv = 30 THEN
      TypeLine(L_Tax.Tax2001_PureIncomVCode, _ToTax, _OthrInc, +1, M, 0);
     ELSE
      TypeLine(TaxAdv.VCode,                 _ToTax, _OthrInc, +1, M, 0);
     END;
    END; (* IF Get ... *)
    RESTORE(_MnTA);
    LAST(_MnTA);
    CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType);
    NEXT(_MnTA);
   END; (* WHILE OCCURE(_MnTA) ... *)
  ELSE
   TypeBlankLines();
  END;

  PROMPT("");
  TypeSubCap(1, ", ।ᬮ७ 㭪⮬ 28 . 217, 㭪⠬ 2, 3 .221  ", "", 0);

  SETZERO(_Minus, _Limits);
  IF IsAfterAPtmStart() THEN
   SELECT(_MnTA, _MnTA, , Man.Man, L_Tax.Tax2001_mt_Inc);
   WHILE OCCURE(_MnTA) DO
    CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType, _MnTA._TaxAdv);
    SAVE(_MnTA);
    L_Tax.Tax_AccessManTA_by_MnTA();
    SETZERO(_OthrInc);
    IF L_Tax.GetOneTaxAdv(CurP, CurP, L_Tax.Tax2001_mt_Inc, ManTA.TaxAdv, _OthrInc, LimVal) THEN
     IF LimVal > 0 THEN
      SETZERO(i);
      WHILE (LimVal > 0) & (i < 12) DO
       IF _OthrInc[i] > 0 THEN
        _Limits[i]:=Math.Min(_OthrInc[i], LimVal);
        DEC(LimVal, _Limits[i]);
       END;
       INC(i);
      END; (* WHILE i < ... *)
      TypeLine(L_Tax.Tax2001_taGetLCode(), _ToTax, _Limits, -1, M, 0);
     END; (* IF LimVal > 0 ... *)
    END; (* IF Get ... *)
    RESTORE(_MnTA);
    LAST(_MnTA);
    CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType);
    NEXT(_MnTA);
   END; (* WHILE OCCURE(_MnTA) ... *)
   IF _MainScale = L_Tax.Tax2001_ScndScale THEN
    L_Tax.SetTax2001_ScaleToGather(_MainScale);  (* ⠭ _MainScale *)
   END;
  ELSE
   TypeBlankLines();
  END;

  SETZERO(_Oblag);
  TypeSubCap(1, " 㬬 室  ᮬ ⮢ (. 28 . 217, . 2, 3 . 221  )", " ", 0);
  TypeLine     ("", _Oblag, _ToTax, +1, M, 0);
  Type_FYB_Line("", _ToTax,  L_DatTim.MONTH(CurP), Y, 0);

  TypeSubCap(1, "⠭  (.218  )", " ", 0);

  IF IsAfterAPtmStart() THEN
   Dummy:=L_Tax.Tax2001_GetOverTax(CurP, CurP, 0); (* Man_TotInc  Estimate*)
   SETZERO(_Minus);
 
   IF L_Tax.Tax_IsResident(CurPE) THEN
    SELECT(_MnTA, _MnTA, , Man.Man, L_Tax.Tax2001_mt_StD);
    WHILE OCCURE(_MnTA) DO
     CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType, _MnTA._TaxAdv);
     SAVE(_MnTA);
     L_Tax.Tax_AccessManTA_by_MnTA();
     SETZERO(_OthrMns);
     IF L_Tax.GetOneTaxAdv(CurP, CurP, L_Tax.Tax2001_mt_StD, ManTA.TaxAdv, _OthrMns, LimVal) THEN
      TypeLine(TaxAdv.VCode, _Minus, _OthrMns, +1, M, 0);
     END; (* IF Get ... *)
     RESTORE(_MnTA);
     LAST(_MnTA);
     CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType);
     NEXT(_MnTA);
    END; (* WHILE OCCURE(_MnTA) ... *)
   END; (* IF Tax_IsResident... *)
  ELSE
   TypeBlankLines();
  END;

  Type_FYB_Line(" 㬬", _Minus, L_DatTim.MONTH(CurP), Y, 0);

  MAKEPART(R, DelLine);
  SETZERO(_Dummy);

  PROMPT("");

  SETZERO(_GetTax);
  L_Tax.Tax2001_GetTax(CurP, _GetTax);

  SELECT(_MnTA, _MnTA, , Man.Man, L_Tax.Tax2001_mt_Tax);
  WHILE OCCURE(_MnTA) DO
   CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType, _MnTA._TaxAdv);
   SAVE(_MnTA);
   L_Tax.Tax_AccessManTA_by_MnTA();
   IF L_Tax.GetOneTaxAdv(CurP, CurP, L_Tax.Tax2001_mt_Tax, ManTA.TaxAdv, _GetTax, LimVal) THEN
   END;
   RESTORE(_MnTA);
   LAST(_MnTA);
   CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType);
   NEXT(_MnTA);
  END; (* WHILE OCCURE(_MnTA) ... *)

  SETZERO(_Dummy, _ClcTax, _DbtTax, _CrdTax, _RetnTax, _tsDbtTax, _tsCrdTax,
          _tsClcTax, _tsGetTax);

  SETZERO(msOverTax); (* ।塞 ९ *)
  L_Tax.Tax2001_GetOneOwnCode(CurP, CurP, L_Tax.Tax2001__oc_PYTax, msOverTax);
  L_Tax.Tax2001_GetOneOwnCode(CurP, CurP, L_Tax.Tax2001__oc_OYRec, msOverTax);

  MakeFYBArr(_GetTax, _Dummy, L_DatTim.MONTH(CurP), 1);

  IF IsAfterAPtmStart() THEN
   P:=Math.Max(L_Env.aptm_Start, L_DatTim.YearBeg(CurP));
   REPEAT Idx:=L_DatTim.MONTH(P);
    PROMPT(" + " + L_DatTim.PeriodStr(P));
    _ClcTax[Idx]:=L_Tax._Tax2001_GetOverTax(P, P, 0, L_Tax.Tax2001_MainScale);
    _tsClcTax[Idx]:=L_Tax._Tax2001_GetOverTax(P, P, 0, L_Tax.Tax2001_ThrdScale);
    _tsGetTax[Idx]:=Math.Min(_tsClcTax[Idx], _GetTax[Idx]);
    INC(_ClcTax[Idx], _tsGetTax[Idx]);
    IF _ClcTax[Idx] > 0 THEN
     _DbtTax[Idx]:=_ClcTax[Idx];
     _CrdTax[Idx]:=0;
    ELSE
     _DbtTax[Idx]:=0;
     _CrdTax[Idx]:=-_ClcTax[Idx];
    END;
    Dummy:=_tsClcTax[Idx]-_tsGetTax[Idx];
    IF Dummy > 0 THEN
     _tsDbtTax[Idx]:=Dummy;
     _tsCrdTax[Idx]:=0;
    ELSE
     _tsDbtTax[Idx]:=0;
     _tsCrdTax[Idx]:=-Dummy;
    END;
    DEC(_GetTax[Idx], _tsGetTax[Idx]);
    INC(_ClcTax[Idx], _GetTax[Idx]);
    DEC(_GetTax[Idx], msOverTax);
    IF _GetTax[Idx]<0 THEN
     _RetnTax[Idx]:=-_GetTax[Idx];
     _GetTax[Idx] :=0;
    END;
    DEC(msOverTax, _RetnTax[Idx]);
    _RetnTax[Idx]:=0;
 
    P:=L_DatTim.IncMonth(P, +1);
   UNTIL P > CurP;
  END;

  Restrict(_Minus, _Oblag);
  AddArr(_Oblag, _Minus, -1);

  Type_FYB_Line(" ",          _Oblag,  L_DatTim.MONTH(CurP), Y, 0);
  Type_ReadyFYB_Line(" ᫥",  _ClcTax, L_DatTim.MONTH(CurP), Y, msClcTax);
  Type_ReadyFYB_Line(" 㤥ঠ",   _GetTax, L_DatTim.MONTH(CurP), Y, msGetTax);

  SETZERO(_EnfTax, _Dummy);
  L_Tax.Tax2001_GetOneType(CurP, CurP, L_Tax.Tax2001_mt_EFT, _EnfTax);
  AddArr(_ClcTax, _EnfTax, +1);

  Type_ReadyFYB_Line("  -",  _DbtTax,  L_DatTim.MONTH(CurP), Y, msDbtTax);
  Type_ReadyFYB_Line("  .⮬", _CrdTax,  L_DatTim.MONTH(CurP), Y, msCrdTax);
  Type_ReadyFYB_Line("।  .",  _EnfTax,  L_DatTim.MONTH(CurP), Y, msEnfTax);
  Type_ReadyFYB_Line("饭 ⮬",  _RetnTax, L_DatTim.MONTH(CurP), Y, msRetnTax);

  IF msRetnTax > 0 THEN
   L_General.Assert(msRetnTax<=msOverTax, "'⥭' ॢ蠥 '९'");
  END;
  TypeSubCap(1, "3. ࠢ  ⠭  :", " ", 0);
  TypeSubCap(0, "3.1.   室  ࠧ:", " ", 0);
  GetPrepReason(1(*_tr_Persn*));

  TypeSubCap(0, "3.2. 室  ᮤঠ  ॡ  ࠧ:", " ", 0);
  GetPrepReason(0(*_tr_Child*));

  MAKEPART(R, Part1);

  TypeSubCap(2, " 4.       室 䨧᪮      ⥫쭮 ࣠樨 ()", "", 0);
  TypeSubCap(0, "     室 䨧᪮      ⥫쭮 ࣠樨 () ",      "", 0);

  TypeSubCap(2, " 5.    室,   ⠢ 35%", " () 室", 1);

  SETZERO(_OthrInc, _Limits);
  IF IsAfterAPtmStart() THEN
   L_Tax.SetTax2001_ScaleToGather(L_Tax.Tax2001_ThrdScale);
   GetSpecVCode("2740", _OthrInc, _Limits); (*ਧ  楫 ४*)
   GetSpecVCode("3010", _OthrInc, _Limits); (*먣  ᭮  ᪥ *)
   GetSpecVCode("1210", _OthrInc, _Limits); (*ࠧ 客 믫  ஢ ࠬ 客*)
   GetSpecVCode("3020", _OthrInc, _Limits); (* 業    *)
   GetSpecVCode("2610", _OthrInc, _Limits); (*ਠ쭠 룮  *)
   TypeLine(" .28,.217 ", _OthrInc, _Limits, -1, M, 0);
  ELSE
   TypeBlankLines();
  END;
  MAKEPART(R, DelLine);
  TypeLine(" ",        _OthrInc, _OthrInc, +0, M, 0);
  SETZERO(_Dummy, tsOverTax);
  Type_ReadyFYB_Line(" ᫥",   _tsClcTax, L_DatTim.MONTH(CurP), Y, tsClcTax);
  Type_ReadyFYB_Line(" 㤥ঠ",    _tsGetTax, L_DatTim.MONTH(CurP), Y, tsGetTax);
  Type_ReadyFYB_Line("  -",  _tsDbtTax, L_DatTim.MONTH(CurP), Y, tsDbtTax);
  Type_ReadyFYB_Line("  .⮬", _tsCrdTax, L_DatTim.MONTH(CurP), Y, tsCrdTax);
  Type_ReadyFYB_Line("।  .",  _Dummy,    L_DatTim.MONTH(CurP), Y, tsEnfTax);
  Type_ReadyFYB_Line("饭 ⮬",  _Dummy,    L_DatTim.MONTH(CurP), Y, tsRetnTax);

  TypeSubCap(2, " 6.  㬬   ⮣  ਮ","", 0);
  MAKEPART(R, Part6);
  IF L_Tax.Tax_GetScaleForMainScale(CurP) = L_Tax.Tax2001_MainScale THEN
   MPart1(" ⠢ 13%", msClcTax, msGetTax, msDbtTax, msCrdTax, msEnfTax, msRetnTax, msOverTax);
   MPart1(" ⠢ 30%",        0,        0,        0,        0,        0,         0,         0);
  ELSE
   MPart1(" ⠢ 13%",        0,        0,        0,        0,        0,         0,         0);
   MPart1(" ⠢ 30%", msClcTax, msGetTax, msDbtTax, msCrdTax, msEnfTax, msRetnTax, msOverTax);
  END;
  MPart1(" ⠢ 35%", tsClcTax, tsGetTax, tsDbtTax, tsCrdTax, tsEnfTax, tsRetnTax, tsOverTax);
  MPart1("⮣",         msClcTax+tsClcTax, msGetTax+tsGetTax, msDbtTax+tsDbtTax, msCrdTax+tsCrdTax, msEnfTax+tsEnfTax, msRetnTax+tsRetnTax, msOverTax+tsOverTax);

  TypeSubCap(2, " 7.   믫, ந 䨧᪮   த ⢠, ਭ饣   ࠢ ᮡ⢥", "", 0);
  TypeSubCap(0, "믫, ந 䨧᪮   த ⢠, ਭ饣   ࠢ ᮡ⢥, ", " ", 0);

  TypeSubCap(2, " 8.   室,    ᮮ⢥⢨  ⥫⢮ ꥪ  ।⠢  죮", "", 0);
  TypeSubCap(0, "室,    ᮮ⢥⢨  ⥫⢮ ꥪ  ।⠢  죮, ", " ", 0);

 END {Make};

 PRIVATE PROCEDURE MPart1(Tmp: STRING[]; ClcTax, GetTax, DbtTax, CrdTax, EnfTax, RetnTax, OverTax: NUMERIC[2]);
 BEGIN
  MAKEPART(R, Part61, Tmp,
                    GetNbrStrIntg(ClcTax),
                    GetNbrStrIntg(GetTax),
                    GetNbrStrIntg(DbtTax),
                    GetNbrStrIntg(CrdTax),
                    GetNbrStrIntg(EnfTax),
                    GetNbrStrIntg(RetnTax),
                    GetNbrStrIntg(OverTax)
          );
 END {MPart1};

 PUBLIC PROCEDURE T7CurMan();
 BEGIN
  L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
  CurP :=Memo.ud_mb();
  CurPE:=Memo.ud_me();
  L_Staff.CheckCurrentAsMainForTax(CurPE);
  L_PRoll.CheckSalDone(CurP);
 
  P_Firm.AccessFirm(P_Firm.fomf(Staff.MyFirm));
 
  CONFORM(Staff, Man);
 
  OPENREP(R, L_General.NameConnection("Tax07"), Create);
  SetPrintAttr(R, Orientation, Portrait,
                  MaxPages,    1);
 
  L_Tax.Tax_InitValues(CurP);
 
  HISTCONF(CurPE, Staff, StaffLog);
  CONFORM(StaffLog, Post);
  L_Man.PrepareRgManAdressForTax_37(CurP, _Town, _Village, _Street, _Block);
  L_Str.SplitStr(_FirmName, P_Firm.FP_ContractorBriefName(Firm.Firm, CurPE), 64, 2);
  MAKEPART(R, Cap);
 
  Make();
 
  L_Tax.Tax_FreeValues(CurP);
 
  MAKEPART(R, EndPart);
  CLOSEREP(R);
 END {T7CurMan};

END.
