(*
%Copyright   (c) Polak Computer System
%Author      24.01.2001 20:31:51 GINA
%Purpose       窨  室 
%Type        report
%Specific    SYS
%Modified    23.04.2014 20:52:55 POLAK\Gina
%Environment
*)

 MODULE T7_2002 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Tax, L_Str, L_PRoll, L_Staff, L_Man,
        P_Firm, Math, Str, L_Env, L_Events, L_StdFrm, L_Russia, Memo, P_MySite;

 CONST
  M = " ";
  Y = "  ";

 VAR
  CurP, CurPE: DATE;
  Numbers    : NUMERIC[2][14];
  SNumbers   : STRING[30][14];
  _FirmName  : STRING[][2];
  _Town,
  _Village,
  _Street,
  _Block     : STRING[];

(*
$P{Cap:
L_DatTim.YearBeg(CurP), L, "y"
P_Firm.FP_INN(Firm.Firm, CurPE)+"/"+P_MySite.GetP_KPP(P_Firm.GetMyFirmOfFirm(Firm.Firm), L_Staff.GetStaffMyPlace(CurPE), CurPE), L, ""
Man.INN, L, ""
L_Man.GetManSINumber_asStr(), L, ""
P_Firm.FP_TaxDepCode(Firm.Firm, SYSDATE()), L, ""
Man.Name, L, ""
L_Man.GetManDocName(Man.DocType), L ""
L_Man.GetManDocCodeMNS(CurPE), L ""
_FirmName[0], L, ""
Man.PspSer + " " + Man.PspNbr, L, ""
Man.Birth, L, "D.N.y"
_FirmName[1], L, ""
GetCitizenCountry(), L, ""
ManAdr.Country, L, ""
ManAdr.Zip, L, ""
ManAdr.Region, L, ""
ManAdr.Distr, L, ""
_Town, L, ""
_Village, L, ""
_Street, L, ""
ManAdr.House, L, ""
_Block, L, ""
ManAdr.Flat, L, ""
@
                                   窠   室    室 䨧᪨   ####  N _________                     ଠ 1-
================================================================================================================================================================
| 1.     (筨 室)            2.   ⥫騪 (⥫ 室)                               |
|1.1.  /  #################################################### 2.1.  ############   2.2.  客 ᢨ⥫⢠  ##########################|
|1.2.   ࣠,   ⮨   ############ 2.3. , , ⢮ ################################################              |
|1.3.  ()                             2.4.  㬥, 㤮⮢饣 筮 ##############################  ##        |
|################################################################### 2.5. ,  㬥 ######################## 2.6.  ஦ ##########        |
|################################################################### 2.7. ࠦ⢮ ( ࠭) ###                                                         |
|                                                                    2.8.  ﭭ  ⥫⢠:   ࠭ ###  ######  ॣ ##     |
|                                                                    ࠩ ################################ த #############################################|
|                                                                    ᥫ 㭪 ################################ 㫨 ##################################|
|                                                                     ############  ###############  #########################################|
}

(*
$P{ CapEnd2011:
L_Tax.Tax_IsResident(CurP), L, "2|1"
StDIsDeclared(), L, "2|1"
@
|                                                                    2.9.  # (1-१, 2-१, 3-᮪஢ ࠭ ᯥ樠)|
|                                                                     㬥, ⢥ত饣 _______________________________________________|
|                                                                    2.10. ⠭   (1),   (2) #                                  |
}
*)

(*
$P{ CapEnd2002:
L_Tax.Tax_IsResident(CurP), L, "2|1"
StDIsDeclared(), L, "2|1"
@
|                                                                    2.9.  # (1-१, 2-१). 㬥, ⢥ত饣 ______|
|                                                                    2.10. ⠭   (1),   (2) #                                  |
}
*)

(*
$P{ Part31:
?, L, ""
?, L, ""
?, L, ""
@
|--------------------------------------------------------------------------------------------------------------------------------------------------------------|
| 砫         |    ⥫騪   | ################# |                                                                               |
| ਮ|     ⮬    | ################# |                                                                               |
|--------------------------------------------------------------------------------------------------------------------------------------------------------------|
|㬬 室,   ⠢ 13%  ।饣  ࠡ #################                                                                          |
}
*)

$P{SubCap:
?, L, ""
@
|##############################################################################################################################################################|
}

$P{SubCap1:
?, L, ""
@
|--------------------------------------------------------------------------------------------------------------------------------------------------------------|
|##################|ਮ   |      ࠫ          ५                                        ⮣|
}

$P{DelLine:
@
|--------------------------------------------------------------------------------------------------------------------------------------------------------------|
}

$P{DelLine2:
@
|==============================================================================================================================================================|
}

$P{Line:
?, L, ""
?, L, ""
SNumbers[01], R, ""
SNumbers[02], R, ""
SNumbers[03], R, ""
SNumbers[04], R, ""
SNumbers[05], R, ""
SNumbers[06], R, ""
SNumbers[07], R, ""
SNumbers[08], R, ""
SNumbers[09], R, ""
SNumbers[10], R, ""
SNumbers[11], R, ""
SNumbers[12], R, ""
SNumbers[13], R, ""
@
|##################|#########|######### ######### ######### ######### ######### ######### ######### ######### ######### ######### ######### ######### #########|
}

(*
$P{ Part1:
@
|     㬥, ⢥ত騥   (),  த⥫, 㭠  ⥫                                                              |
|     ________________________________________________________________________________________________________________________________________________________ |
|ࠢ   , ।ᬮ७ 쥩 214.1, 㭪⠬ 2, 3  221                                                                        |
|  _________________________________ ᭮  ।⠢  ____________________________________________________________________________ |
}
*)

(*
|==============================================================================================================================================================|
*)

(*
$P{ Part6:
@
|--------------------------------------------------------------------------------------------------------------------------------------------------------------|
|                  |           㬬            |                   |   ।騥 ਮ|                           |
|                  |---------------------------------------|                   |---------------------------------------|---------------------------------------|
|⥫        |                   |                   |।  .|                   |                   |                 |                 |
|                  |        ᫥|         ঠ|࣠   ᪠|         饭|            ⥭| ⥫騪|   ⮬|
|                  |                   |                   |                   |                   |                   |                   |                   |
|------------------|-------------------|-------------------|-------------------|-------------------|-------------------|-------------------|-------------------|
}
*)

(*
$P{ Part61:
?, L, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
@
|##################|###################|###################|###################|###################|###################|###################|###################|
}
*)

(*
$P{ Part8:
@
|==============================================================================================================================================================|
|                                      |    㬬|    㬬|   㬬 |         㬬|         㬬|  |  | 㬬 ,|
|                                      |      室,|     | 室,-|  ᫥|   㤥ঠ|   |  -| । |
|                                      |  砥 |       ⮢| 砥  .|        |        | ⮬ ।|     ⥫騪|   ᪠ |
|                                      | |              |,㬥襭-|              |              |⥫-|              |     |
|                                      |              |              |   |              |              |         騪|              |         ࣠|
|--------------------------------------|--------------|--------------|--------------|--------------|--------------|--------------|--------------|--------------|
|ࠦ  . 窥   ___ |              |              |              |              |              |              |              |              |
|    ___ |              |              |              |              |              |              |              |              |
|ࠦ  . 窥   ___ |              |              |              |              |              |              |              |              |
|    ___ |              |              |              |              |              |              |              |              |
|ࠦ  . 窥   ___ |              |              |              |              |              |              |              |              |
|    ___ |              |              |              |              |              |              |              |              |
}
*)

$P{EndPart:
P_Firm.FP_TaxCardCont(Firm.Firm, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
@
|==============================================================================================================================================================|
| 9.   ।⠢ ࠢ:                                                                                                                   |
| )  ࣠  室: N ࠢ ______________________    ___________________________                                                          |
| ) ⥫騪  室: N ࠢ ______________________    ___________________________                                                          |
| )  ࣠  㬬 , ।  ᪠: N ࠢ (쬠) ______________________    ___________________________            |
|                                                                                                                                                              |
| ࠢ쭮   窨 ஢७:                                                                                                        |
|   ___________________ #################################################################### _________________________                                         |
|        ()         (, 䠬, , ⢮)                                         ()                                                  |
=(c) Polak=====================================================================================================================================##########=#####=
}
*)

 PRIVATE PROCEDURE FirstManWorkP(): DATE;
  VAR
   P: DATE;
 BEGIN
  P:=MAXOF(DATE);
  SAVE(Staff);
  SELECT(Staff, Man, , Man.Man);
  WHILE OCCURE(Staff) DO
   IF Staff.BegDate < P THEN
    P:=L_DatTim.Per(Staff.BegDate);
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  RESTORE(Staff);
  RETURN Math.Max(Math.Max(L_Env.aptm_Start, L_DatTim.YearBeg(CurP)), P);
 END {FirstManWorkP};

 PRIVATE PROCEDURE GetCitizenCountry(): LIKE(ManAdr.Country);
 BEGIN
  IF ~L_Man.AccessManAdr(Man.Man, CurPE, L_Russia.at_CtMA) THEN
   L_Man.AccessRgManAdr(Man.Man, CurPE);
  END;
  RETURN ManAdr.Country;
 END {GetCitizenCountry};

 PRIVATE PROCEDURE GetNbrStr(N: NUMERIC[2]): STRING[];
 BEGIN
  RETURN FLDTOSTR(N, "2.", 0);
 END {GetNbrStr};

 PRIVATE PROCEDURE GetNbrStrIntg(N: NUMERIC[2]): STRING[];
 BEGIN
  RETURN FLDTOSTR(N, "0");
 END {GetNbrStrIntg};

 PRIVATE PROCEDURE StDIsDeclared(): SCAL[2];
 BEGIN
  IF L_Tax.Tax_IsResident(CurP) THEN
   RETURN SELECT(_MnTA, _MnTA, Man.Man, L_Tax.Tax2001_mt_StD);
  END;
  RETURN 0;
 END {StDIsDeclared};

 PRIVATE PROCEDURE TypeSubCap(TopL: SCAL[3]; S, S1: STRING[]; BotL: SCAL[2]);
 BEGIN
  IF    TopL=1 THEN
   MAKEPART(R, DelLine);
  ELSIF TopL=2 THEN
   MAKEPART(R, DelLine2);
  END;
  IF ~!S THEN
   MAKEPART(R, SubCap, S);
  END;
  IF BotL THEN
   MAKEPART(R, SubCap1, S1);
  END;
 END {TypeSubCap};

 PRIVATE PROCEDURE IsPers(_VCode: LIKE(TaxAdv.VCode)): SCAL[2];
 BEGIN
  RETURN (_VCode="0103") | (_VCode="0104") | (_VCode="0105");
 END {IsPers};

 PRIVATE PROCEDURE GetPrepReason(_IsPers: SCAL[2]);
  VAR
   _Cnt: NUMERIC[0];
   _Str: STRING[];
 BEGIN
  IF L_Tax.Tax_IsResident(CurP) THEN
   SETZERO(_Cnt);
   SELECT(_MnTA, _MnTA, , Man.Man, L_Tax.Tax2001_mt_StD);
   WHILE OCCURE(_MnTA) DO
    L_Tax.Tax_AccessManTA_by_MnTA();
    CONFORM(ManTA, TaxInq);
    IF TaxInq.InqType = L_Tax.inqt_Own THEN
     CONFORM(ManTA, TaxAdv);
     IF IsPers(TaxAdv.VCode)=_IsPers THEN
      _Str:=L_Str.IntStr(L_Tax.GetTAValue(CurP, 0))+" 㡫"+". ᭮  ।⠢: "+TaxInq.SrcNum;
      IF ~_IsPers THEN
       _Str:=_Str+"     ਮ ⢨  "+L_DatTim.PeriodStr(ManTA.StopD);
      END;
      TypeSubCap(0, "     "+_Str, " ", 0);
      INC(_Cnt);
     END;
    END; (* IF TaxInq.InqType... *)
    NEXT(_MnTA);
   END; (* WHILE OCCURE(_MnTA) ... *)
   IF ~_IsPers & (_Cnt>0) THEN
    TypeSubCap(0, "     ⢮ ⥩ "+L_Str.IntStr(_Cnt), " ", 0);
   END;
  END;
 END {GetPrepReason};

 PRIVATE PROCEDURE Convert(N: NUMERIC[2][14]; VAR S: STRING[30][14]; Intg: SCAL[2]);
  VAR i: SCAL[15];
 BEGIN
  SETEMPTY(S);
  i:=1;
  WHILE i < 14 DO
   IF ~!N[i] THEN
    IF Intg THEN
     S[i]:=GetNbrStrIntg(N[i]);
    ELSE
     S[i]:=GetNbrStr(N[i]);
    END;
   END;
   INC(i);
  END;
 END {Convert};

 PRIVATE PROCEDURE AddArr(VAR D: NUMERIC[2][12]; N: NUMERIC[2][12]; d: NUMERIC[0]);
  VAR i: SCAL[13];
 BEGIN
  SETZERO(i);
  WHILE i <= 11 DO
   IF N[i] = 0 THEN
    SETEMPTY(Numbers[i+1]);
   ELSE
    Numbers[i+1]:=N[i];
    INC(D[i], d*N[i]);
    INC(Numbers[13], N[i]);
   END;
   INC(i);
  END; (* WHILE i ...  *)
 END {AddArr};

 PRIVATE PROCEDURE Restrict(VAR What: NUMERIC[2][12]; By: NUMERIC[2][12]);
  VAR
   i: SCAL[100];
   W,
   B: NUMERIC[2];
 BEGIN
  SETZERO(i, W, B);
  WHILE i <= 11 DO
   INC(W, What[i]);
   INC(B,   By[i]);
   IF W > B THEN
    IF i < 11 THEN
     INC(What[i+1], W-B);
     DEC(What[i],   W-B);
     W:=B;
    ELSE
     DEC(What[i], W-B);
    END;
   END;
   INC(i);
  END; (* WHILE i ...  *)
 END {Restrict};

 PRIVATE PROCEDURE TypeLine(S: STRING[];VAR D: NUMERIC[2][12]; N: NUMERIC[2][12]; d: NUMERIC[0]; sPer: STRING[]; Intg: SCAL[2]);
 BEGIN
  SETZERO(Numbers);
  AddArr(D, N, d);
  IF (Numbers[13] # 0) THEN
   Convert(Numbers, SNumbers, Intg);
   IF Str.Match(S, "0???") THEN
    S:=Str.Delete(S, 0, 1);
   END;
   MAKEPART(R, Line, S, sPer);
  END;
 END {TypeLine};

 PRIVATE PROCEDURE Type_FYB_Line(S: STRING[]; N: NUMERIC[2][12]; UpTo: SCAL[12]; sPer: STRING[]; Intg: SCAL[2]);
  VAR i: SCAL[14];
 BEGIN
  SETZERO(i, Numbers);
  WHILE i <= UpTo DO
   Numbers[i+1]:=Numbers[i]+N[i]; INC(i);
  END; (* WHILE i ...  *)
  WHILE i <= 11 DO
   INC(i); SETEMPTY(Numbers[i]);
  END;
  Numbers[13]:=Numbers[UpTo+1];
  Convert(Numbers, SNumbers, Intg);
  MAKEPART(R, Line, S, sPer);
 END {Type_FYB_Line};

 PRIVATE PROCEDURE Type_ReadyFYB_Line(S: STRING[]; N: NUMERIC[2][12]; UpTo: SCAL[12]; sPer: STRING[]; VAR Total: NUMERIC[2]);
  VAR i: SCAL[14];
 BEGIN
  SETZERO(i, Numbers);
  WHILE i <= UpTo DO
   Numbers[i+1]:=N[i]; INC(i);
  END; (* WHILE i ...  *)
  WHILE i <= 11 DO
   INC(i); SETEMPTY(Numbers[i]);
  END;
  Numbers[13]:=Numbers[UpTo+1];
  Total:=Numbers[13];
  Convert(Numbers, SNumbers, 1);
  MAKEPART(R, Line, S, sPer);
 END {Type_ReadyFYB_Line};

 PRIVATE PROCEDURE MakeFYBArr(VAR D: NUMERIC[2][12]; S: NUMERIC[2][12]; UpTo: SCAL[12]; MayBeNeg: SCAL[2]);
  VAR i: SCAL[13];
 BEGIN i:=0;
  WHILE i <= UpTo DO
   IF i < UpTo THEN
    INC(D[i+1], D[i]);
    INC(S[i+1], S[i]);
   END;
   IF (D[i] > S[i]) | MayBeNeg THEN
    DEC(D[i], S[i]);
   ELSE
    D[i]:=0;
   END;
   INC(i);
  END;
 END {MakeFYBArr};

 PRIVATE PROCEDURE GetOtherYear(D1, D2: DATE): NUMERIC[2];
  VAR
   _Dummy : NUMERIC[2][12];
   LimVal : NUMERIC[0];
   Dummy  : NUMERIC[2];
 BEGIN
  SETZERO(_Dummy);
  IF L_Tax.StandOnSpecifiedTaxAdv(CurP, L_Tax.Tax2001__oc_PYTax, "") > 0 THEN
   Dummy:=L_Tax.GetOneTaxAdv(D1, D2, L_Tax.Tax2001_mt_Tax, TaxAdv.TaxAdv, _Dummy, LimVal);
  END;
  RETURN L_Tax.Tax2001_GetArrSum(_Dummy);
 END {GetOtherYear};

 PRIVATE PROCEDURE GetSpecVCode(_VCode: LIKE(TaxAdv.VCode); VAR _OthrInc, _Limits: NUMERIC[2][12]);
  VAR
   AdvInc: NUMERIC[2][12];
   LimVal: NUMERIC[2];
   Dummy : SCAL[2];
 BEGIN
  SETZERO(AdvInc, LimVal);
  IF L_Tax.StandOnSpecifiedTaxAdv(CurP, L_Tax.Tax2001__oc_IsMNS, _VCode) > 0 THEN
   Dummy:=L_Tax.GetOneTaxAdv(CurP, CurP, L_Tax.Tax2001_mt_Inc, TaxAdv.TaxAdv, AdvInc, LimVal);
   IF LimVal > 0 THEN
    SETZERO(i);
    WHILE (LimVal > 0) & (i < 12) DO
     IF _AdvInc[i] > 0 THEN
      INC(_Limits[i], Math.Min(_AdvInc[i], LimVal));
      DEC(LimVal, _Limits[i]);
     END;
     INC(i);
    END; (* WHILE i < ... *)
   END; (* IF LimVal > 0 ... *)
  END;
  TypeLine(_VCode, _OthrInc, AdvInc, +1, M, 0);
 END {GetSpecVCode};

 PRIVATE PROCEDURE Sc4(): STRING[]; (*⠢   ⮢*)
 BEGIN
  IF CurP >= 01\01\2004 THEN
   RETURN "9%";
  ELSE
   RETURN "6%";
  END;
 END {Sc4};

 PRIVATE PROCEDURE Make();
  VAR
   i        : NUMERIC[0];
   _tsDbtTax,
   _tsCrdTax,
   _tsClcTax,
   _tsGetTax,
   _fsDbtTax,
   _fsCrdTax,
   _fsClcTax,
   _fsGetTax,
   _EnfTax,
   _ToTax,
   _Oblag,
   _Minus,
   _Dummy,
   _PureInc,
   _OthrInc,
   _AdvInc,
   _Limits,
   _LimVal,
   _OthrMns,
   _ClcTax,
   _GetTax,
   _RetnTax,
   _DbtTax,
   _CrdTax  : NUMERIC[2][12];
   Dummy,
   LimVal   : NUMERIC[2];
   P        : DATE;
   Idx      : SCAL[12];
   msClcTax, msGetTax, msDbtTax, msCrdTax, msEnfTax, msRetnTax, msOverTax,
   tsClcTax, tsGetTax, tsDbtTax, tsCrdTax, tsEnfTax, tsRetnTax, tsOverTax,
   fsClcTax, fsGetTax, fsDbtTax, fsCrdTax, fsEnfTax, fsRetnTax, fsOverTax: NUMERIC[2];
   _MainScale: L_Tax.tTax2001_ScalesType;
   _msOthInc,
   _FromPrevYear: NUMERIC[2];
   HasFrthScale : SCAL[2];
 BEGIN
  L_Tax.Tax_InitValues(CurP);
  L_Man.PrepareRgManAdressForTax_37(CurP, _Town, _Village, _Street, _Block);
  L_Str.FormatStr(_FirmName, P_Firm.FP_FirmName(Firm.Firm, CurPE), 67);

  MAKEPART(R, Cap);
  IF CurP >= 01\01\2011 THEN
   MAKEPART(R, CapEnd2011);
  ELSE
   MAKEPART(R, CapEnd2002);
  END;

  _MainScale:=L_Tax.Tax_GetScaleForMainScale(CurP);
  L_Tax.SetTax2001_ScaleToGather(_MainScale);
  TypeSubCap(2, " 3.       室 䨧᪮  ( 室,   ⠢ 13%  30%)", "", 0);

  _FromPrevYear:=GetOtherYear(L_DatTim.YearBeg(CurP), L_DatTim.YearBeg(CurP));
  _msOthInc    :=0;
  IF L_Tax.Tax_IsResident(CurP) THEN
   L_Tax.Tax2001__GetOneType(PROCREF(L_Tax.Tax2001__W_Lim), CurP, CurP, L_Tax.Tax2001_mt_Inc, _msOthInc, 1); (*室  ।  ࠡ  ࠭祭 ⮢*)
  END;

  IF _FromPrevYear < 0 THEN (*  ⥫騪*)
   MAKEPART(R, Part31, GetNbrStrIntg(-_FromPrevYear), GetNbrStrIntg(0), GetNbrStr(_msOthInc));
  ELSE
   MAKEPART(R, Part31, GetNbrStrIntg(0), GetNbrStrIntg(_FromPrevYear), GetNbrStr(_msOthInc));
  END;

  PROMPT("室");
  TypeSubCap(0, "", " 室/", 1);

  SETZERO(_PureInc, _ToTax);
  L_Tax.Tax2001_GetPureIncome(CurP, _PureInc);
  TypeLine(L_Tax.Tax2001_PureIncomVCode, _ToTax, _PureInc, +1, M, 0);

  IF _MainScale = L_Tax.Tax2001_ScndScale THEN
   L_Tax.SetTax2001_ScaleToGather(L_Tax.Tax2001_MainScale);  (* ᮡ 室  Tax2001_MainScale *)
  END;
  SELECT(_MnTA, _MnTA, , Man.Man, L_Tax.Tax2001_mt_Inc);
  WHILE OCCURE(_MnTA) DO
   CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType, _MnTA._TaxAdv);
   SAVE(_MnTA);
   L_Tax.Tax_AccessManTA_by_MnTA();
   SETZERO(_OthrInc);
   IF L_Tax.GetOneTaxAdv(CurP, CurP, L_Tax.Tax2001_mt_Inc, ManTA.TaxAdv, _OthrInc, LimVal) THEN
    IF TaxAdv.TaxAdv = 30 THEN
     TypeLine(L_Tax.Tax2001_PureIncomVCode, _ToTax, _OthrInc, +1, M, 0);
    ELSE
     TypeLine(TaxAdv.VCode,                 _ToTax, _OthrInc, +1, M, 0);
    END;
   END; (* IF Get ... *)
   RESTORE(_MnTA);
   LAST(_MnTA);
   CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType);
   NEXT(_MnTA);
  END; (* WHILE OCCURE(_MnTA) ... *)

  PROMPT("");
  TypeSubCap(1, " ,  ᪫祭 ⠭", "", 0);

  SELECT(_MnTA, _MnTA, , Man.Man, L_Tax.Tax2001_mt_Inc);
  WHILE OCCURE(_MnTA) DO
   SETZERO(_Limits);
   CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType, _MnTA._TaxAdv);
   SAVE(_MnTA);
   L_Tax.Tax_AccessManTA_by_MnTA();
   SETZERO(_OthrInc);
   IF L_Tax.GetOneTaxAdv(CurP, CurP, L_Tax.Tax2001_mt_Inc, ManTA.TaxAdv, _OthrInc, LimVal) THEN
    IF LimVal > 0 THEN
     SETZERO(i);
     WHILE (LimVal > 0) & (i < 12) DO
      IF _OthrInc[i] > 0 THEN
       _Limits[i]:=Math.Min(_OthrInc[i], LimVal);
       DEC(LimVal, _Limits[i]);
      END;
      INC(i);
     END; (* WHILE i < ... *)
     TypeLine(L_Tax.Tax2001_taGetLCode(), _ToTax, _Limits, -1, M, 0);
    END; (* IF LimVal > 0 ... *)
   END; (* IF Get ... *)
   RESTORE(_MnTA);
   LAST(_MnTA);
   CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType);
   NEXT(_MnTA);
  END; (* WHILE OCCURE(_MnTA) ... *)

  SETZERO(_Minus, _Limits);
  SELECT(_MnTA, _MnTA, , Man.Man, L_Tax.Tax2001_mt_Exp);
  WHILE OCCURE(_MnTA) DO
   CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType, _MnTA._TaxAdv);
   SAVE(_MnTA);
   L_Tax.Tax_AccessManTA_by_MnTA();
   SETZERO(_OthrMns);
   IF L_Tax.GetOneTaxAdv(CurP, CurP, L_Tax.Tax2001_mt_Exp, ManTA.TaxAdv, _OthrMns, LimVal) THEN
    TypeLine(TaxAdv.VCode, _Minus, _OthrMns, +1, M, 0);
   END;
   RESTORE(_MnTA);
   LAST(_MnTA);
   CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType);
   NEXT(_MnTA);
  END; (* WHILE OCCURE(_MnTA) ... *)

  IF _MainScale = L_Tax.Tax2001_ScndScale THEN
   L_Tax.SetTax2001_ScaleToGather(_MainScale);  (* ⠭ _MainScale *)
  END;

  SETZERO(_Oblag);
  Restrict(_Minus, _ToTax);
  AddArr(_ToTax, _Minus, -1);

  TypeSubCap(1, " 㬬 室  ᮬ ⮢", " ", 0);
  TypeLine     ("", _Oblag, _ToTax, +1, M, 0);
  Type_FYB_Line("", _ToTax, L_DatTim.MONTH(CurP), Y, 0);

  TypeSubCap(1, "⠭  (.218  )", " ", 0);

  Dummy:=L_Tax.Tax2001_GetOverTax(CurP, CurP, 0); (* Man_TotInc  Estimate*)
  SETZERO(_Minus);

  IF L_Tax.Tax_IsResident(CurP) THEN
   SELECT(_MnTA, _MnTA, , Man.Man, L_Tax.Tax2001_mt_StD);
   WHILE OCCURE(_MnTA) DO
    CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType, _MnTA._TaxAdv);
    SAVE(_MnTA);
    L_Tax.Tax_AccessManTA_by_MnTA();
    SETZERO(_OthrMns);
    IF L_Tax.GetOneTaxAdv(CurP, CurP, L_Tax.Tax2001_mt_StD, ManTA.TaxAdv, _OthrMns, LimVal) THEN
     TypeLine(TaxAdv.VCode, _Minus, _OthrMns, +1, M, 0);
    END;
    RESTORE(_MnTA);
    LAST(_MnTA);
    CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType);
    NEXT(_MnTA);
   END; (* WHILE OCCURE(_MnTA) ... *)
  END; (* IF Tax_IsResident... *)

  Type_FYB_Line(" 㬬", _Minus, L_DatTim.MONTH(CurP), Y, 0);

  MAKEPART(R, DelLine);

  PROMPT("");

  SETZERO(_Dummy, _ClcTax, _GetTax, _DbtTax, _CrdTax, _RetnTax, _tsDbtTax, _tsCrdTax,
          _tsClcTax, _tsGetTax, _fsClcTax, _fsGetTax, _fsDbtTax, _fsCrdTax);

  SETZERO(msOverTax); (* ।塞 ९ *)
  L_Tax.Tax2001_GetOneOwnCode(CurP, CurP, L_Tax.Tax2001__oc_PYTax, msOverTax);
  L_Tax.Tax2001_GetOneOwnCode(CurP, CurP, L_Tax.Tax2001__oc_OYRec, msOverTax);

  HasFrthScale:=0;
  P:=FirstManWorkP();
  REPEAT Idx:=L_DatTim.MONTH(P);
   PROMPT(" + " + L_DatTim.PeriodStr(P));
   _ClcTax[Idx]  :=L_Tax._Tax2001_GetClcTax (P, P, 0, L_Tax.Tax2001_MainScale);
   _GetTax[Idx]  :=L_Tax._Tax2001_GetPaidTax(P, P, 0, L_Tax.Tax2001_MainScale);
   _tsClcTax[Idx]:=L_Tax._Tax2001_GetOverTax(P, P, 0, L_Tax.Tax2001_ThrdScale);
   _tsGetTax[Idx]:=Math.Max(Math.Min(_tsClcTax[Idx], _GetTax[Idx]), 0);

   _fsClcTax[Idx]:=L_Tax._Tax2001_GetOverTax(P, P, 0, L_Tax.Tax2001_FrthScale);
   _fsGetTax[Idx]:=Math.Max(Math.Min(_fsClcTax[Idx], _GetTax[Idx]-_tsGetTax[Idx]), 0);
   IF ~HasFrthScale THEN
    HasFrthScale:=(_fsClcTax[Idx]#0) | (_fsGetTax[Idx]#0);
   END;

   DEC(_GetTax[Idx], _tsGetTax[Idx]+_fsGetTax[Idx]);
   IF _ClcTax[Idx] <= _GetTax[Idx] THEN
    _CrdTax[Idx]:=_GetTax[Idx]-_ClcTax[Idx];
   END;

   Dummy:=_tsClcTax[Idx]-_tsGetTax[Idx];
   IF Dummy > 0 THEN
    _tsDbtTax[Idx]:=Dummy;
    _tsCrdTax[Idx]:=0;
   ELSE
    _tsDbtTax[Idx]:=0;
    _tsCrdTax[Idx]:=-Dummy;
   END;
   Dummy:=_fsClcTax[Idx]-_fsGetTax[Idx];
   IF Dummy > 0 THEN
    _fsDbtTax[Idx]:=Dummy;
    _fsCrdTax[Idx]:=0;
   ELSE
    _fsDbtTax[Idx]:=0;
    _fsCrdTax[Idx]:=-Dummy;
   END;

   DEC(_GetTax[Idx], msOverTax);
   IF _GetTax[Idx] < 0 THEN
    _RetnTax[Idx]:=-_GetTax[Idx];
    _GetTax[Idx] :=0;
   END;
   P:=L_DatTim.IncMonth(P, +1);
  UNTIL P > CurP;

  Restrict(_Minus, _Oblag);
  AddArr(_Oblag, _Minus, -1);

  Type_FYB_Line(" ",          _Oblag,  L_DatTim.MONTH(CurP), Y, 0);
  Type_ReadyFYB_Line(" ᫥",  _ClcTax, L_DatTim.MONTH(CurP), Y, msClcTax);
  Type_ReadyFYB_Line(" 㤥ঠ",   _GetTax, L_DatTim.MONTH(CurP), Y, msGetTax);

  SETZERO(_EnfTax, _Dummy);
  L_Tax.Tax2001_GetOneType(CurP, CurP, L_Tax.Tax2001_mt_EFT, _EnfTax);
  MakeFYBArr(_EnfTax,  _Dummy, L_DatTim.MONTH(CurP), 0);

  P:=FirstManWorkP();
  REPEAT Idx:=L_DatTim.MONTH(P);
   PROMPT("   + " + L_DatTim.PeriodStr(P));
   IF _ClcTax[Idx] > (_GetTax[Idx]+msOverTax) THEN (* ⥫騪 㦭 ।  ⮬ EnfTax,   ⮬ ९*)
    IF msOverTax > 0 THEN          (*९*)
     _DbtTax[Idx]:=_ClcTax[Idx]-_GetTax[Idx]+msOverTax;
    ELSE                           (**)
     _DbtTax[Idx]:=_ClcTax[Idx]-_GetTax[Idx]-msOverTax;
    END;
   END;
   P:=L_DatTim.IncMonth(P, +1);
  UNTIL P > CurP;

  Type_ReadyFYB_Line("  -",  _DbtTax,  L_DatTim.MONTH(CurP), Y, msDbtTax);
  Type_ReadyFYB_Line("  .⮬", _CrdTax,  L_DatTim.MONTH(CurP), Y, msCrdTax);
  Type_ReadyFYB_Line("।  .",  _EnfTax,  L_DatTim.MONTH(CurP), Y, msEnfTax);
  Type_ReadyFYB_Line("饭 ⮬",  _RetnTax, L_DatTim.MONTH(CurP), Y, msRetnTax);

  IF msRetnTax > 0 THEN
   L_General.Assert(msRetnTax<=msOverTax, "'⥭' ॢ蠥 '९'");
  END;
  TypeSubCap(1, "ࠢ  ⠭  :", " ", 0);
  TypeSubCap(0, "3.1.   室  ࠧ:", " ", 0);
  GetPrepReason(1(*_tr_Persn*));

  TypeSubCap(0, "3.2. 室  ᮤঠ  ॡ  ࠧ:", " ", 0);
  GetPrepReason(0(*_tr_Child*));
  MAKEPART(R, Part1);

  IF CurP >= 01\01\2011 THEN
   TypeSubCap(1, "   뤠 室 .    '⥦ 㬥  ௫'", "", 0);
  END;

  TypeSubCap(2, " 4.       室 䨧᪮      ⥫쭮 ࣠樨 ()", "", 0);
  IF ~HasFrthScale THEN
   TypeSubCap(0, "     室 䨧᪮      ⥫쭮 ࣠樨 () ",      "", 0);
   SETZERO(fsClcTax, fsGetTax, fsDbtTax, fsCrdTax, fsEnfTax, fsRetnTax, fsOverTax);
  ELSE
   TypeSubCap(0, "", "⥫", 1);
   MAKEPART(R, DelLine);
   L_Tax.SetTax2001_ScaleToGather(L_Tax.Tax2001_FrthScale);
   SETZERO(_OthrInc, _Limits, fsOverTax);
   L_Tax.Tax2001_GetOneType(CurP, CurP, L_Tax.Tax2001_mt_Inc, _OthrInc);
   Type_FYB_Line("㬬 ",         _OthrInc,  L_DatTim.MONTH(CurP), Y, 0);
   Type_FYB_Line(" 㬬",         _OthrInc,  L_DatTim.MONTH(CurP), Y, 0);
   Type_ReadyFYB_Line(" ᫥",   _fsClcTax, L_DatTim.MONTH(CurP), Y, fsClcTax);
   Type_ReadyFYB_Line(" 㤥ঠ",    _fsGetTax, L_DatTim.MONTH(CurP), Y, fsGetTax);
   Type_ReadyFYB_Line("  -",  _fsDbtTax, L_DatTim.MONTH(CurP), Y, fsDbtTax);
   Type_ReadyFYB_Line("  .⮬", _fsCrdTax, L_DatTim.MONTH(CurP), Y, fsCrdTax);
   Type_ReadyFYB_Line("।  .",  _Dummy,    L_DatTim.MONTH(CurP), Y, fsEnfTax);
   Type_ReadyFYB_Line("饭 ⮬",  _Dummy,    L_DatTim.MONTH(CurP), Y, fsRetnTax);
  END;

  TypeSubCap(2, " 5.    室,   ⠢ 35%", " () 室", 1);

  L_Tax.SetTax2001_ScaleToGather(L_Tax.Tax2001_ThrdScale);
  SETZERO(_OthrInc, _Limits);
  GetSpecVCode("2740", _OthrInc, _Limits); (*ਧ  楫 ४*)
  GetSpecVCode("3010", _OthrInc, _Limits); (*먣  ᭮  ᪥ *)
  GetSpecVCode("1210", _OthrInc, _Limits); (*ࠧ 客 믫  ஢ ࠬ 客*)
  GetSpecVCode("3020", _OthrInc, _Limits); (* 業    *)
  GetSpecVCode("2610", _OthrInc, _Limits); (*ਠ쭠 룮  *)
  TypeLine(" .28,.217 ", _OthrInc, _Limits, -1, M, 0);
  MAKEPART(R, DelLine);
  TypeLine(" ",        _OthrInc, _OthrInc, +0, M, 0);
  SETZERO(_Dummy, tsOverTax);
  Type_ReadyFYB_Line(" ᫥",   _tsClcTax, L_DatTim.MONTH(CurP), Y, tsClcTax);
  Type_ReadyFYB_Line(" 㤥ঠ",    _tsGetTax, L_DatTim.MONTH(CurP), Y, tsGetTax);
  Type_ReadyFYB_Line("  -",  _tsDbtTax, L_DatTim.MONTH(CurP), Y, tsDbtTax);
  Type_ReadyFYB_Line("  .⮬", _tsCrdTax, L_DatTim.MONTH(CurP), Y, tsCrdTax);
  Type_ReadyFYB_Line("।  .",  _Dummy,    L_DatTim.MONTH(CurP), Y, tsEnfTax);
  Type_ReadyFYB_Line("饭 ⮬",  _Dummy,    L_DatTim.MONTH(CurP), Y, tsRetnTax);

  TypeSubCap(2, " 6.  㬬   ⮣  ਮ","", 0);
  MAKEPART(R, Part6);
  IF L_Tax.Tax_GetScaleForMainScale(CurP) = L_Tax.Tax2001_MainScale THEN
   MPart1(" ⠢  "+Sc4(), fsClcTax, fsGetTax, fsDbtTax, fsCrdTax, fsEnfTax, fsRetnTax, fsOverTax);
   MPart1(" ⠢ 13%",     msClcTax, msGetTax, msDbtTax, msCrdTax, msEnfTax, msRetnTax, msOverTax);
   MPart1(" ⠢ 30%",            0,        0,        0,        0,        0,         0,         0);
  ELSE
   MPart1(" ⠢  "+Sc4(), fsClcTax, fsGetTax, fsDbtTax, fsCrdTax, fsEnfTax, fsRetnTax, fsOverTax);
   MPart1(" ⠢ 13%",            0,        0,        0,        0,        0,         0,         0);
   MPart1(" ⠢ 30%",     msClcTax, msGetTax, msDbtTax, msCrdTax, msEnfTax, msRetnTax, msOverTax);
  END;
  MPart1(" ⠢ 35%", tsClcTax, tsGetTax, tsDbtTax, tsCrdTax, tsEnfTax, tsRetnTax, tsOverTax);
  MPart1("⮣",         msClcTax+tsClcTax+fsClcTax, msGetTax+tsGetTax+fsGetTax, msDbtTax+tsDbtTax+fsDbtTax, msCrdTax+tsCrdTax+fsCrdTax, msEnfTax+tsEnfTax+fsEnfTax, msRetnTax+tsRetnTax+fsRetnTax, msOverTax+tsOverTax+fsOverTax);

  IF CurP >= 01\01\2011 THEN
   TypeSubCap(1, "  ᫥    .    '⥦  '", "", 0);
  END;

  TypeSubCap(2, " 7.   室,   ⢫ 묨 ࣠", "", 0);
  TypeSubCap(0, "室,   ⢫ 묨 ࣠, ", " ", 0);

  TypeSubCap(2, " 8.     ।騥  ਮ", "", 0);
  MAKEPART(R, Part8);
  MAKEPART(R, EndPart);
 END {Make};

 PRIVATE PROCEDURE MPart1(Tmp: STRING[]; ClcTax, GetTax, DbtTax, CrdTax, EnfTax, RetnTax, OverTax: NUMERIC[2]);
 BEGIN
  MAKEPART(R, Part61, Tmp,
                      GetNbrStrIntg(ClcTax),
                      GetNbrStrIntg(GetTax),
                      GetNbrStrIntg(EnfTax),
                      GetNbrStrIntg(RetnTax),
                      GetNbrStrIntg(OverTax),
                      GetNbrStrIntg(DbtTax),
                      GetNbrStrIntg(CrdTax)
          );
 END {MPart1};

 PRIVATE PROCEDURE Make1NDFLByCurMan();
 BEGIN
  L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
  L_Staff.CheckCurrentAsMainForTax(CurPE);
  L_StdFrm.Question(" 窠|| ਮ  "+L_DatTim.DateStr(L_DatTim.YearBeg(CurPE))+"  "+L_DatTim.DateStr(CurPE));
  L_PRoll.CheckSalDone(CurP);
 
  P_Firm.AccessFirm(P_Firm.fomf(Staff.MyFirm));
 
  CONFORM(Staff, Man);
 
  OPENREP(R, L_General.NameConnection("Tax07"), Create);
  SetPrintAttr(R, Orientation, Portrait,
                  MaxPages,    1);
  Make();
  CLOSEREP(R);
 END {Make1NDFLByCurMan};

 PRIVATE PROCEDURE Make1NDFL();
  VAR
   ContractAmount: NUMERIC[0];
 BEGIN
  ContractAmount:=0;
  SELECT(Staff, MyFirm, , P_Firm.curMyFirm, Man.Man);
  WHILE OCCURE(Staff) DO
   IF L_Staff.IsMainForTax(CurPE) THEN
    L_General.CallUs(ContractAmount=0);
    IF !Staff.EndDate | (Staff.EndDate >= CurP) THEN
     L_PRoll.CheckSalDone(CurP);
     Make();
     FORMFEED(R);
    END;
    INC(ContractAmount);
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
 END {Make1NDFL};

 PRIVATE PROCEDURE Make1NDFLByAll();
 BEGIN
  L_StdFrm.Question(" 窨  ᥬ || ਮ  "+L_DatTim.DateStr(L_DatTim.YearBeg(CurPE))+"  "+L_DatTim.DateStr(CurPE));
  P_Firm.SetCurMyFirm();
  P_Firm.AccessOwnFirm(P_Firm.curMyFirm);
  OPENREP(R, L_General.NameConnection("T7All"), Create);
  SetPrintAttr(R, Orientation, Portrait,
                  MaxPages,    1);
  SELECT(Man, Name);
  WHILE OCCURE(Man) DO
   Make1NDFL();
   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)
  CLOSEREP(R);
 END {Make1NDFLByAll};

 PUBLIC PROCEDURE T7CurMan();
 BEGIN
  CurP :=Memo.ud_mb();
  CurPE:=Memo.ud_me();
  Make1NDFLByCurMan();
  L_Tax.Tax_FreeValues(CurP);
 END {T7CurMan};

 PUBLIC PROCEDURE T7AllMan();
 BEGIN
  CurP :=Memo.ud_mb();
  CurPE:=Memo.ud_me();
  Make1NDFLByAll();
  L_Tax.Tax_FreeValues(CurP);
 END {T7AllMan};

END.
