(*
%Copyright    (c) Polak IT
%Author       19.06.2014 14:54:40 POLAK\San
%Purpose
%Type         control, report, temporary, convertor, operation, library, to paste
%Specific     AP, AP_PC, SYS, LOC, TOOL
%Modified     05.09.2014 13:37:30 POLAK\San
*)

 MODULE TBS [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PRIVATE TYPE
  tLevel = SCAL[5];

 PRIVATE CONST
  SingleSideCirId = "_0000000";
  HstWinName      = "TBSH";

  l_Acnt    = 0;
  l_CAcnt   = 1;
  l_AcCut   = 2;
  l_XOGroup = 3;
  l_XObject = 4;

 PRIVATE VAR
  dmyAcCut: STRING[];

 PRIVATE PROCEDURE TBS1_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="TBS";
  L_WDO.iZone(0).ParentZone:=L_WDO.iZone(2); (* ??? *)
  L_WDO.iField       (0, "ccTBSH.AK").Format:=" ਮ| ਮ";

  L_WDO.iZone        (1).Narrowing     :="(ccTBS1.ccTBSH=ccTBSH.RECORDID)";
  L_WDO.iZone        (1).HierarchicLink:=LINK.Get("ccTBS1", "Parent");
  L_WDO.iZone        (1).SubwindowOriginalName:="TBS1E";
  L_WDO.iProgs       (1, "TBS");

  L_WDO.iField       (1, "ccTBS1.Sign").Hierarchic:=1;

  L_WDO.iZone        (2).ViewOnly:=1;
  L_WDO.iEvents      (2, [L_WDO.e_OnReposition]);
  L_WDO.iProgs       (2, "TBS");
 END {TBS1_OnInitializeWindow};

 PRIVATE PROCEDURE TBS1_2_OnReposition();
  VAR
   totValue: LIKE(ccTBS1.Value);
 BEGIN
  IF ACCESS(ccTBSH) THEN
   SETZERO(totValue);
   SELECT(ccTBS1, TBSH, , ccTBSH.RECORDID, EMPTYOF(ccTBS1.Parent));
   WHILE OCCURE(ccTBS1) DO
    AddV(totValue, ccTBS1.Value);
    NEXT(ccTBS1);
   END; (* WHILE OCCURE(ccTBS1) ... *)
  ELSE
   SETEMPTY(totValue);
  END;
  RTI.Get().CurWindow.Zones(0).Fields("totValue0").Value:=totValue[0];
  RTI.Get().CurWindow.Zones(0).Fields("totValue1").Value:=totValue[1];
  RTI.Get().CurWindow.Zones(0).Fields("totValue2").Value:=totValue[2];
  RTI.Get().CurWindow.Zones(0).Fields("totValue3").Value:=totValue[3];
  RTI.Get().CurWindow.Zones(0).Fields("totValue4").Value:=totValue[4];
  RTI.Get().CurWindow.Zones(0).Fields("totValue5").Value:=totValue[5];
 END {TBS1_2_OnReposition};

 PRIVATE PROCEDURE TBS1_OnConformToWindow();
 BEGIN
  IF RTI.Get().CurWindow.OriginalName = HstWinName THEN
   ACCESS(ccTBSH);
   CHANGESEL(ccTBSH, RECORDID, , ccTBSH.RECORDID);
   SE_WWD_CURSOR(RTI.Get().TrgWindow.Name, ccTBSH);
   SE_WZD_CURSOR(RTI.Get().TrgWindow.Name, 2, ccTBSH);
  ELSE
   L_General.CallUs(0);
  END;
 END {TBS1_OnConformToWindow};

 PRIVATE PROCEDURE TBS1E_OnInitializeWindow();
 BEGIN
  L_WDO.iZone        (0).ViewOnly:=1;
  L_WDO.iEvents      (0, [L_WDO.e_OnReposition]);
  L_WDO.iField       (0, "Object_Value").LineBreakEnable:=1;
  L_WDO.iProgs       (0, "TBS");
  L_WDO.iZone(1).ViewOnly:=1;
  L_WDO.iZone(1).Narrowing:="(ccTBS2.ccTBS1=ccTBS1.RECORDID)";
  L_WDO.iZone        (1).SubwindowOriginalName:="TBS1EE";
 END {TBS1E_OnInitializeWindow};

 PRIVATE PROCEDURE ShowObjectAttr();
  VAR
   curTitle,
   curValue : STRING[];
   IsUpLevel: SCAL[2];
 BEGIN
  SETEMPTY(curValue);
  IF    ccTBS1.Level = l_Acnt THEN
   curTitle:="";
  ELSIF ccTBS1.Level = l_CAcnt THEN
   curTitle:=" ண 浪";
(*
   IF L_Str.IsStrInStr(ccTBS1.Sign, ".") THEN
    curTitle:=" ண 浪";
   ELSE
    curTitle:="";
   END;
*)
  ELSIF ccTBS1.Level = l_AcCut THEN
   curTitle:="१";
  ELSE
   SAVE(ccTBS1);
   WHILE ~!ccTBS1.Parent & SEARCH(ccTBS1, RECORDID, ccTBS1.Parent) & (ccTBS1.Level > 2) DO
   END;
   curValue:=ccTBS1.Sign + " " + ccTBS1.Name + L_Str.CRLF;
   RESTORE(ccTBS1);
   IF (ccTBS1.Sign = SingleSideCirId) THEN
    curTitle:="ꥪ   ஭ ஢";
   ELSE
    SAVE(ccTBS1);
    IF !ccTBS1.XObject THEN
     IsUpLevel:=1;
     SELECT(ccTBS1, Parent, , ccTBS1.RECORDID, 1);
    ELSE
     IsUpLevel:=0;
    END;
    IF ~!L_XObj.DecodeConciseXOId(ccTBS1.XObject) THEN
     curTitle:=" ꥪ";
     RESTORE(ccTBS1);
    ELSE
     SEARCH(XObject, XObject, , ccTBS1.XObject);
     IF    XObject.Origin = L_XObj.o_Man      THEN curTitle:="";
     ELSIF XObject.Origin = L_XObj.o_Staff    THEN curTitle:="⭨";
     ELSIF XObject.Origin = L_XObj.o_Contract THEN
      IF IsUpLevel THEN
       curTitle:="ࠣ";
      ELSE
       curTitle:="";
      END;
     ELSIF XObject.Origin = L_XObj.o_CostItem THEN curTitle:="";
     ELSIF XObject.Origin = L_XObj.o_KeyAss   THEN curTitle:="";
     ELSIF XObject.Origin = L_XObj.o_Math     THEN
      IF IsUpLevel THEN
       curTitle:="";
      ELSE
       curTitle:="  ";
      END;
     ELSIF (XObject.Origin = L_XObj.o_Global) THEN curTitle:="ꥪ";
     END;
     RESTORE(ccTBS1);
     IF ~IsUpLevel & ((XObject.Origin = L_XObj.o_Math) | (XObject.Origin = L_XObj.o_Contract)) THEN
      SAVE(ccTBS1);
      SEARCH(ccTBS1, RECORDID, , ccTBS1.Parent);
      INC(curValue, " " + ccTBS1.Sign + " " + ccTBS1.Name + L_Str.CRLF + " ");
      RESTORE(ccTBS1);
     END;
    END; (* ~!L_XObj.DecodeConciseXOId *)
    INC(curValue, " " + ccTBS1.Sign + " " + ccTBS1.Name);
   END;
  END;
  IF !curValue THEN
   curValue:=L_Str.CRLF + ccTBS1.Sign + " " + ccTBS1.Name;
  END;

  RTI.Get().CurZone.Fields("Object_Title").Value:=curTitle;
  RTI.Get().CurZone.Fields("Object_Value").Value:=curValue;
 END {ShowObjectAttr};

 PRIVATE PROCEDURE TBS1E_0_OnReposition();
  VAR
   Fields : FORM_FIELDS;
   CalcQnt: SCAL[2];
   dmySum : L_XObj.tSum;
   curQnt,
   curSld : L_XObj.tQnt;
 BEGIN
  ACCESS(ccTBS1);
  ShowObjectAttr();
  Fields:=RTI.Get().CurZone.Fields;
  SETZERO(Fields("dQntI").Value, Fields("dQnt").Value, Fields("dQntO").Value,
          Fields("cQntI").Value, Fields("cQnt").Value, Fields("cQntO").Value);
  IF (ccTBS1.Level > l_AcCut) & L_MathR.AcCutOfRealStock(ccTBS1.AcCut) THEN
   SEARCH(ccTBSH, RECORDID, , ccTBS1.ccTBSH);
   IF !ccTBS1.XObject THEN
    SELECT(ccTBS1, Parent, , ccTBS1.RECORDID, 1);
   ELSE
    CHANGESEL(ccTBS1, RECORDID, , ccTBS1.RECORDID);
   END;
   curSld:=0;
   WHILE OCCURE(ccTBS1) DO
    IF ~!ccTBS1.XObject THEN
     SETSEL(XCalc, XObject, ccTBS1.XObject, ccTBS1.AcCut);
     IF SRCINSEL(XCalc, LT, ccTBSH.PerB) THEN
      IF ccTBSH.AK = L_Acnt.ak_Acn THEN curQnt:=L_XObj.qo_OutSaldo();
      ELSE                              L_XObj.OutRSaldo(dmySum, curQnt);
      END;
      INC(curSld, curQnt);
     END;
    END;
    SELECT(ccTBS2, TBS1, , ccTBS1.RECORDID);
    WHILE OCCURE(ccTBS2) DO
     INC(Fields("dQnt").Value, ccTBS2.dQnt);
     INC(Fields("cQnt").Value, ccTBS2.cQnt);
     NEXT(ccTBS2);
    END; (* WHILE OCCURE(ccTBS2) ... *)
    NEXT(ccTBS1);
   END; (* WHILE OCCURE(ccTBS1) *)
   IF curSld >= 0 THEN
    Fields("dQntI").Value:= curSld;
   ELSE
    Fields("cQntI").Value:=-curSld;
   END;
   INC(curSld, Fields("dQnt").Value - Fields("cQnt").Value);
   IF curSld >= 0 THEN
    Fields("dQntO").Value:= curSld;
   ELSE
    Fields("cQntO").Value:=-curSld;
   END;
  END; (* IF ccTBS1.Level > l_AcCut ... *)
 END {TBS1E_0_OnReposition};

 PRIVATE PROCEDURE TBS1EE_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="TBS";

  L_WDO.iZone        (0).ViewOnly:=1;
  L_WDO.iEvents      (0, [L_WDO.e_OnReposition]);
  L_WDO.iField       (0, "Object_Value").LineBreakEnable:=1;
  L_WDO.iProgs       (0, "TBS");
  L_WDO.iZone        (1).ViewOnly:=1;
  L_WDO.iZone        (1).Narrowing:="(ccLD.cc=" + APP.Get().MyConnection.Number + ")&(ccLD.Made=ccTBS2.LDMade)";
  L_WDO.iEvents      (1, [L_WDO.e_OnSetSubwindow]);
  L_WDO.iProgs       (1, "TBS");
 END {TBS1E_OnInitializeWindow};

 PRIVATE PROCEDURE TBS1EE_0_OnReposition();
 BEGIN
  ACCESS(ccTBS2);
  RTI.Get().CurZone.Fields("corObject_Value").Value:=ccTBS2.Sign + " " + ccTBS2.Name;
  SEARCH(ccTBS1, RECORDID, , ccTBS2.ccTBS1);
  ShowObjectAttr();
  IF !ccTBS2.LDMade | ~SELECT(ccLD, ccLD, APP.Get().MyConnection.Number, ccTBS2.LDMade) THEN
   LIKEMENU(CALL, "TBS.TBS2_ShowDocs()");
  END;
 END {TBS1EE_0_OnReposition};

 PRIVATE PROCEDURE TBS1EE_1_OnSetSubwindow();
 BEGIN
  IF (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Edit) | (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_ShowWin) THEN
   CALL(CallStub.AppendMacro("CALL, 'TBS.TBS1EE_1_StandOnly()'"));
   HALT();
  END;
 END {TBS1EE_1_OnSetSubwindow};

 PUBLIC PROCEDURE TBS1EE_1_StandOnly();
  VAR
   trgFile: STRING[];
 BEGIN
  ACCESS(ccLD);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  IF ~!ccLD.ri THEN
   trgFile:=DATABASE.Get().TableById(ccLD.fi).Name;
   SEARCH((trgFile), RECORDID, , ccLD.ri);
   L_WDO.PosToCurRecord(trgFile, "", 0);
  END;
 END {TBS1EE_1_StandOnly};

 PRIVATE PROCEDURE TBSH_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="TBS";
  L_WDO.iZone(1).ViewOnly:=1;
(* !!!???
  L_WDO.iZone(1).Narrowing:="(ccTBSH.cc=" + L_WDO.v_dbConnection + ")";
*)
 END {TBSH_OnInitializeWindow};

 PUBLIC PROCEDURE scs_GetFilters_TBS1_1(VAR Filters: L_WDO.tFilters);
 BEGIN
  L_WDO.PutNewFilter(Filters, "㫥 ", "(ccTBS1.Value["+L_Str.IntStr(L_Acnt.uavp_CirDbt)+"]#0)|"+
                                                   "(ccTBS1.Value["+L_Str.IntStr(L_Acnt.uavp_CirCrd)+"]#0)", 0);
  L_WDO.PutNewFilter(Filters, "㫥 室饥 ᠫ줮", "(ccTBS1.Value["+L_Str.IntStr(L_Acnt.uavp_ISlDbt)+"]#0)|"+
                                                           "(ccTBS1.Value["+L_Str.IntStr(L_Acnt.uavp_ISlCrd)+"]#0)", 0);
  L_WDO.PutNewFilter(Filters, "㫥 室饥 ᠫ줮", "(ccTBS1.Value["+L_Str.IntStr(L_Acnt.uavp_OSlDbt)+"]#0)|"+
                                                            "(ccTBS1.Value["+L_Str.IntStr(L_Acnt.uavp_OSlCrd)+"]#0)", 0);
  L_WDO.PutNewFilter(Filters, "஭ ஢", "(ccTBS1.Sign="+SingleSideCirId+")", 0);
 END {scs_GetFilters_TBS1_1};

 PRIVATE PROCEDURE AddV(VAR r: L_Acnt.tUnfoldedAcntVector; v: L_Acnt.tUnfoldedAcntVector);
 BEGIN
  INC(r[L_Acnt.uavp_ISlDbt], v[L_Acnt.uavp_ISlDbt]);
  INC(r[L_Acnt.uavp_ISlCrd], v[L_Acnt.uavp_ISlCrd]);
  INC(r[L_Acnt.uavp_CirDbt], v[L_Acnt.uavp_CirDbt]);
  INC(r[L_Acnt.uavp_CirCrd], v[L_Acnt.uavp_CirCrd]);
  INC(r[L_Acnt.uavp_OSlDbt], v[L_Acnt.uavp_OSlDbt]);
  INC(r[L_Acnt.uavp_OSlCrd], v[L_Acnt.uavp_OSlCrd]);
 END {AddV};

 PRIVATE PROCEDURE StandOnFirstLevelCAcnt();
  VAR
   curSign,
   trgSign: LIKE(CAcnt.Sign);
 BEGIN
  IF L_Str.IsStrInStr(CAcnt.Sign, ".") THEN
   curSign:=CAcnt.Sign;
   trgSign:=Str.Item(CAcnt.Sign, ".", 0);
   IF ~SELECT(CAcnt, Sign, trgSign) THEN
    L_StdFrm.WrongDB("  ண 浪  祭 " + curSign + ",    ࢮ 浪  祭 " + trgSign);
   END;
  END;
 END {StandOnFirstLevelCAcnt};

 PRIVATE PROCEDURE SetupFirstLevels(curTable: TABLE; curRI: L_General.tRecordId; curAcCut: LIKE(AcCut.AcCut);
                                    VAR lv0Sign, lv1Sign, lv2Sign: LIKE(ccTBS1.Sign);
                                    VAR lv0Name, lv1Name, lv2Name: LIKE(ccTBS1.Name));
  VAR
   curCAcnt: LIKE(CAcnt.CAcnt);
   acAmount: NUMERIC[0];
   hasAcnt : SCAL[2];
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   SEARCH(AcCut, AcCut, , curAcCut);
   L_Acnt.AccessACLog(Memo.ud_ut(), AcCut.AcCut);
   CONFORM(ACLog, CAcnt);
   curCAcnt:=CAcnt.CAcnt;
(*
   SAVE(CAcnt);
   StandOnFirstLevelCAcnt();
   IF (CAcnt.CAcnt # curCAcnt) & (!curTable | (curTable.Name = "CAcnt") & (CAcnt.RECORDID = curRI)) THEN
    lv0Sign:=CAcnt.Sign;
    lv0Name:=CAcnt.Name;
   ELSE
    SETEMPTY(lv0Sign, lv0Name);
   END;
   RESTORE(CAcnt);
   lv1Sign:=CAcnt.Sign;
   lv1Name:=CAcnt.Name;
*)
   SAVE(CAcnt);
   StandOnFirstLevelCAcnt();
   lv0Sign:=CAcnt.Sign;
   lv0Name:=CAcnt.Name;
   hasAcnt:=(CAcnt.CAcnt # curCAcnt);
   RESTORE(CAcnt);
   IF ~hasAcnt THEN
    SETEMPTY(lv1Sign, lv1Name);
   ELSE
    lv1Sign:=CAcnt.Sign;
    lv1Name:=CAcnt.Name;
    IF ~!curTable & (curTable.Name = "CAcnt") & (CAcnt.RECORDID = curRI) THEN
     SETEMPTY(lv0Sign, lv0Name);
    END;
   END;
   lv2Sign:=ACLog.Sign;
   lv2Name:=AcCut.Name;
   IF ~!curTable & (curTable.Name = "AcCut") THEN
    SETEMPTY(lv0Sign, lv0Name, lv1Sign, lv1Name);
   ELSE
    acAmount:=0;
    SELECT(ACLog, CAcnt, , CAcnt.CAcnt);
    WHILE OCCURE(ACLog) DO
     IF L_DatTim.IsActiveInIntvl(ACLog.Date, ACLog.Till, Memo.ud_fr(), Memo.ud_ut()) THEN
      INC(acAmount);
     END;
     NEXT(ACLog);
    END; (* WHILE OCCURE(ACLog) ... *)
    IF acAmount = 1 THEN
     SETEMPTY(lv2Sign, lv2Name);
    END;
   END;
  EXCEPT
  END; (* TRY *)
 END {SetupFirstLevels};

 PRIVATE PROCEDURE SetupCurrentXObject(curXObject: LIKE(XObject.XObject);
                                       VAR lv3Sign, lv4Sign: LIKE(ccTBS1.Sign);
                                       VAR lv3Name, lv4Name: LIKE(ccTBS1.Name));
  VAR
   Section: L_XObj.tSection;
 BEGIN
  SETEMPTY(lv3Sign, lv3Name);
  Section:=L_XObj.DecodeConciseXOId(curXObject);
  IF !Section THEN
   L_XObj.AccessXObject(curXObject);
   IF    XObject.Origin = L_XObj.o_Global THEN
    lv4Sign:=""+XObject.XObject;
    lv4Name:=L_XObj.GetXObjectOriginName();
   ELSE
    L_XObj.AccessOrigin();
    IF XObject.Origin = L_XObj.o_Contract THEN
     lv4Sign:=""+Contract.Contract;
     lv4Name:=Contract.Name;
     CONFORM(Contract, Firm);
     lv3Sign:=""+Firm.Firm;
     lv3Name:=Firm.Name;
    ELSIF (XObject.Origin = L_XObj.o_Math) THEN
     CONFORM(mItem, Storage);
     lv4Sign:=""+Storage.Storage;
     lv4Name:=Storage.Name;
     CONFORM(mItem, Math);
     lv3Sign:=""+Math.Math;
     lv3Name:=Math.Name;
    ELSIF (XObject.Origin = L_XObj.o_KeyAss) THEN
     CONFORM(mItem, Math);
     lv4Sign:=""+Math.Math;
     lv4Name:=Math.Name;
    ELSIF XObject.Origin = L_XObj.o_Man THEN
     L_XObj.AccessManByXObject(XObject.XObject);
     lv4Sign:=""+L_Str.FixedIntStr(Man.Man, 5);
     lv4Name:=Man.Name;
    ELSIF XObject.Origin = L_XObj.o_CostItem THEN
     lv4Sign:=""+CostItem.CostItem;
     lv4Name:=CostItem.Name;
    ELSIF XObject.Origin = L_XObj.o_Staff THEN
     lv4Sign:=""+Staff.TSN;
     lv4Name:=Staff.Name;
    ELSE
     L_General.CallUs(0);
    END;
   END;
  ELSE
   IF Section = L_XObj.s_Salary THEN
    lv4Sign:="_70";
    lv4Name:="௫ (ᢥ ꥪ)";
   ELSE
    L_General.CallUs(0);
   END;
  END;
 END {SetupCurrentXObject};

 PRIVATE PROCEDURE InsertLevel(curLevel : LIKE(ccTBS1.Level);
                               curSign  : LIKE(ccTBS1.Sign);
                               curName  : LIKE(ccTBS1.Name);
                               curParent: LIKE(ccTBS1.Parent);
                               curValue : L_Acnt.tUnfoldedAcntVector);
 BEGIN
  DEFAULT(ccTBS1);
  ccTBS1.ccTBSH:=ccTBSH.RECORDID;
  ccTBS1.Level :=curLevel;
  IF curLevel = l_XObject THEN
   ccTBS1.Leaf:=1;
   ccTBS1.AcCut  :=XC020.AcCut;
   ccTBS1.XObject:=XC020.XObject;
  ELSE
   ccTBS1.Leaf:=0;
   IF curLevel >= l_AcCut THEN
    ccTBS1.AcCut:=XC020.AcCut;
   END;
  END;
  ccTBS1.Parent:=curParent;
  ccTBS1.Sign  :=curSign;
  ccTBS1.Name  :=curName;
  ccTBS1.Value :=curValue;
  INSERT(ccTBS1);
 END {InsertLevel};

 PRIVATE PROCEDURE InsertUpLevel(curLevel : LIKE(ccTBS1.Level);
                                 curSign  : LIKE(ccTBS1.Sign);
                                 curName  : LIKE(ccTBS1.Name);
                                 curParent: LIKE(ccTBS1.Parent);
                                 VAR curValue : L_Acnt.tUnfoldedAcntVector;
                                 VAR subParent: LIKE(ccTBS1.Parent));
 BEGIN
  SETZERO(curValue);
  IF ~!curSign THEN
   InsertLevel(curLevel, curSign, curName, curParent, curValue);
   subParent:=ccTBS1.RECORDID;
  ELSE
   subParent:=curParent;
  END;
 END {InsertUpLevel};

 PRIVATE PROCEDURE UpdateLevel(trgParent, prvParent: LIKE(ccTBS1.Parent); trgValue: L_Acnt.tUnfoldedAcntVector);
  VAR
   curName  : LIKE(ccTBS2.Name);
   curAcCut2: LIKE(ccTBS2.AcCut2);
   trgLevel : LIKE(ccTBS1.Level);
 BEGIN
  IF trgParent # prvParent THEN
   SEARCH(ccTBS1, RECORDID, , trgParent);
   ccTBS1.Value:=trgValue;
   REPLACE(ccTBS1);
   trgLevel:=ccTBS1.Level;
   SETSEL(ccTBS1, Parent, ccTBS1.RECORDID);
   FOR_EACH ccTBS1 DO
    SETSEL(ccTBS2, TBS1, ccTBS1.RECORDID);
    FOR_EACH ccTBS2 DO
     curName  :=ccTBS2.Name;
     curAcCut2:=ccTBS2.AcCut2;
     IF ~ADD(ccTBS2, TBS1, trgParent, ccTBS2.Sign,
             ccTBS2.dSum, ccTBS2.dSum,
             ccTBS2.cSum, ccTBS2.cSum,
             ccTBS2.dQnt, ccTBS2.dQnt * (trgLevel > l_AcCut),
             ccTBS2.cQnt, ccTBS2.cQnt * (trgLevel > l_AcCut)) THEN
      ccTBS2.Name  :=curName;
      ccTBS2.AcCut2:=curAcCut2;
      REPLACE(ccTBS2);
     END;
    END;
   END;
  END;
 END {UpdateLevel};

 PRIVATE PROCEDURE CompleteSecondSide(curTable: TABLE; curRI: L_General.tRecordId);
  VAR
   totDSum,
   curDSum,
   totCSum,
   curCSum  : L_XObj.tSum;
   curSign  : LIKE(ccTBS2.Sign);
   curName  : LIKE(ccTBS2.Name);
 BEGIN
  SELECT(XA020, AcCut2);
  WHILE OCCURE(XA020) DO
   NARROWSEL(XA020, MyFirm, AcCut2);
   SETZERO(totDSum, totCSum);
   SEARCH(AcCut, AcCut, , XA020.AcCut2);
   L_Acnt.AccessACLog(Memo.ud_ut(), AcCut.AcCut);
   curSign:=ACLog.Sign;
   curName:=AcCut.Name;
   WHILE OCCURE(XA020) DO
    NARROWSEL(XA020, AcCut);
    SETZERO(curDSum, curCSum);
    WHILE OCCURE(XA020) DO
     INC(curDSum, XA020.cSum);
     INC(curCSum, XA020.dSum);
     XA020.Sign:=curSign;
     XA020.Name:=curName;
     REPLACE(XA020);
     NEXT(XA020);
    END;
    FIRST(XA020);
    SAVE(XA020);
    SELECT(XA020, AcCut, , XA020.MyFirm, XA020.AcCut2, XA020.AcCut);
    WHILE OCCURE(XA020) DO
     DEC(curDSum, XA020.dSum);
     DEC(curCSum, XA020.cSum);
     NEXT(XA020);
    END;
    RESTORE(XA020);
    IF (curDSum # 0) | (curCSum # 0) THEN
     IF !curTable | SELECT(XC020, AcCut, XA020.MyFirm, XA020.AcCut2) THEN
      IF XA020.AcCut2 = XA020.AcCut THEN
       IF curDSum < 0 THEN curDSum:=0;
       ELSE                curCSum:=0;
       END;
      END;
      SAVE(XA020);
      ADD(XA020, XA020, , XA020.MyFirm, XA020.AcCut2, EMPTYOF(XA020.XObject), XA020.AcCut,
                          XA020.cSum, curCSum,
                          XA020.dSum, curDSum);
      SEARCH(AcCut, AcCut, , XA020.AcCut2);
      L_Acnt.AccessACLog(Memo.ud_ut(), AcCut.AcCut);
      XA020.Sign:=ACLog.Sign;
      XA020.Name:=AcCut.Name;
      SETZERO(XA020.cQnt, XA020.dQnt);
      REPLACE(XA020);
      RESTORE(XA020);
      INC(totDSum, curDSum);
      INC(totCSum, curCSum);
     END;
    END;
    NEXTINEXTENDEDSEL(XA020, AcCut);
   END; (* WHILE OCCURE(XA020) *)
   FIRST(XA020);
   IF (totDSum # 0) | (totCSum # 0) THEN
    SetupFirstLevels(curTable, curRI, XA020.AcCut2, XC020.lv0Sign, XC020.lv1Sign, XC020.lv2Sign, XC020.lv0Name, XC020.lv1Name, XC020.lv2Name);
    SetupCurrentXObject(L_XObj.GetRecastXObject(XA020.MyFirm),  XC020.lv3Sign, XC020.lv4Sign, XC020.lv3Name, XC020.lv4Name);
    XC020.lv4Sign:=SingleSideCirId;
    XC020.lv4Name:="஭ ஢";
    XC020.MyFirm :=XA020.MyFirm;
    XC020.AcCut  :=XA020.AcCut2;
    XC020.Object :=XA020.AcCut2;
    SETEMPTY(XC020.XObject, XC020.Cut1);
    SETZERO(XC020.Value);
    XC020.Value[L_Acnt.uavp_CirDbt]:=totDSum;
    XC020.Value[L_Acnt.uavp_CirCrd]:=totCSum;
    INSERT(XC020);
   END;
   NEXTINEXTENDEDSEL(XA020, MyFirm, AcCut2);
  END; (* WHILE OCCURE(XA020) ... *)
 END {CompleteSecondSide};

 PRIVATE PROCEDURE LaunchWDO(curMade: TIMESTAMP);
  CONST
   wName = "TBS1";
  VAR
   w      : FORM_WINDOW;
   trgZone: SCAL[10];
 BEGIN
  IF SELECT(ccTBSH, Made, APP.Get().MyConnection.Number, curMade) THEN
   w:=APP.Get().Forms.LoadBlank(wName, wName + "<xyz" + FLDTOSTR(curMade) + ">", EMPTYOF(FORM_ZONE));
   w.Zones(2).Narrowing:="(ccTBSH.cc=" + APP.Get().MyConnection.Number + ")&(ccTBSH.Made=" + FLDTOSTR(curMade) + ")";
   w:=APP.Get().Forms.Load(wName, w.AssignedName, EMPTYOF(FORM_ZONE));
   IF NEXT(ccTBSH) THEN
    FIRST(ccTBSH);
    SE_WZD_CURSOR(w.Name, 2, ccTBSH);
    trgZone:=2;
   ELSE
    trgZone:=1;
   END;
   IF ~!RTI.Get().CurWindow & (RTI.Get().CurWindow.OriginalName = HstWinName) THEN
    LIKEMENU(CloseWin, "", View, w.Name + " " + trgZone);
   ELSE
    LIKEMENU(View, w.Name + " " + trgZone);
   END;
  ELSE
   L_StdFrm.BlueHalt("  ᠫ줮,  ⮢");
  END;
 END {LaunchWDO};

 PRIVATE PROCEDURE IsAcceptableAcCut(curAcCut: LIKE(AcCut.AcCut)): SCAL[2];
 BEGIN
  RETURN ~L_Str.IsStrInStr(dmyAcCut, curAcCut);
 END {IsAcceptableAcCut};

 PRIVATE PROCEDURE PrepareDummyAcCut();
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   SETEMPTY(dmyAcCut);
   SETSEL(CAcnt, CAcnt);
   FOR_EACH CAcnt DO
    IF CAcnt.Type # L_Acnt.catyp_Balance THEN
     SELECT(ACLog, CAcnt, , CAcnt.CAcnt);
     WHILE OCCURE(ACLog) DO
      IF L_DatTim.IsActiveInIntvl(ACLog.Date, ACLog.Till, Memo.ud_fr(), Memo.ud_ut()) THEN
       INC(dmyAcCut, ACLog.AcCut + "|");
      END;
      NEXT(ACLog);
     END; (* WHILE OCCURE(ACLog) ... *)
    END;
   END; (* FOR_EACH CAcnt ... *)
  EXCEPT
  END; (* TRY *)
 END {PrepareDummyAcCut};

 PRIVATE PROCEDURE Repack(curTable: TABLE; curRI: L_General.tRecordId);
 BEGIN
  L_AFM.MakeMultipleIndex("XC020", "MyFirm : LIKE(MyFirm.MyFirm);"+
                                   "Object : STRING[20];"+
                                   "Cut1   : STRING[20];"+
                                   "lv0Sign: LIKE(ccTBS1.Sign);"+
                                   "lv0Name: LIKE(ccTBS1.Name);"+
                                   "lv1Sign: LIKE(ccTBS1.Sign);"+
                                   "lv1Name: LIKE(ccTBS1.Name);"+
                                   "lv2Sign: LIKE(ccTBS1.Sign);"+
                                   "lv2Name: LIKE(ccTBS1.Name);"+
                                   "lv3Sign: LIKE(ccTBS1.Sign);"+
                                   "lv3Name: LIKE(ccTBS1.Name);"+
                                   "lv4Sign: LIKE(ccTBS1.Sign);"+
                                   "lv4Name: LIKE(ccTBS1.Name);"+
                                   "Value  : LIKE(ccTBS1.Value);"+
                                   "AcCut  : LIKE(AcCut.AcCut);"+
                                   "XObject: LIKE(XObject.XObject);",
                           "toFill: MyFirm, lv0Sign, lv1Sign, lv2Sign, lv3Sign, lv4Sign;"+
                           "AcCut : MyFirm, AcCut");

  L_AFM.MakeMultipleIndex("XA020", "MyFirm : LIKE(MyFirm.MyFirm);"+
                                   "AcCut  : LIKE(AcCut.AcCut);"+
                                   "XObject: LIKE(XObject.XObject);"+
                                   "AcCut2 : LIKE(AcCut.AcCut);"+
                                   "Sign   : LIKE(ccTBS2.Sign);"+
                                   "Name   : LIKE(ccTBS2.Name);"+
                                   "dSum   : LIKE(XApport.Sum);"+
                                   "cSum   : LIKE(XApport.Sum);"+
                                   "dQnt   : LIKE(XApport.Qnt);"+
                                   "cQnt   : LIKE(XApport.Qnt);",
                          "XA020 : MyFirm, AcCut, XObject, AcCut2;"+
                          "AcCut2: MyFirm, AcCut2, AcCut;"+
                          "AcCut : MyFirm, AcCut, AcCut2;");

  SELECT(XC001, mfObject);
  WHILE OCCURE(XC001) DO
   NARROWSEL(XC001, MyFirm, Object);
   IF IsAcceptableAcCut(XC001.Object) THEN
    XC020.MyFirm:=XC001.MyFirm;
    SetupFirstLevels(curTable, curRI, XC001.Object, XC020.lv0Sign, XC020.lv1Sign, XC020.lv2Sign, XC020.lv0Name, XC020.lv1Name, XC020.lv2Name);
    WHILE OCCURE(XC001) DO
     PROMPT(" ⮢: " + XC001.MyFirm + ", " + XC001.Object + ", " + XC001.Cut1);
     SetupCurrentXObject(XC001.Cut1, XC020.lv3Sign, XC020.lv4Sign, XC020.lv3Name, XC020.lv4Name);
     XC020.Object :=XC001.Object;
     XC020.Cut1   :=XC001.Cut1;
     XC020.AcCut  :=XC001.Object;
     XC020.XObject:=XC001.Cut1;
     XC020.Value  :=XC001.uav_aSum;
     INSERT(XC020);
     NEXT(XC001);
    END;
   END;
   NEXTINEXTENDEDSEL(XC001, MyFirm, Object);
  END; (* WHILE OCCURE(XC001) *)

  SELECT(XA001, mfObject);
  WHILE OCCURE(XA001) DO
   PROMPT(" ᯮ ⮢: " + XA001.MyFirm + ", " + XA001.Object + ", " + XA001.Cut1 + ", " + XA001.Cut2);
   IF IsAcceptableAcCut(XA001.Object) & IsAcceptableAcCut(XA001.Cut2) THEN
    ADD(XA020, XA020, , XA001.MyFirm, XA001.Object, XA001.Cut1, XA001.Cut2,
                        XA020.cSum, XA001.Sum*(XA001.CirType = L_Acnt.ct_Credit),
                        XA020.dSum, XA001.Sum*(XA001.CirType = L_Acnt.ct_Debit ),
                        XA020.cQnt, XA001.Qnt*(XA001.CirType = L_Acnt.ct_Credit),
                        XA020.dQnt, XA001.Qnt*(XA001.CirType = L_Acnt.ct_Debit ));
   END;
   NEXT(XA001);
  END; (* WHILE OCCURE(XA001)...*)
 END {Repack};

 PRIVATE PROCEDURE Do(curTable: TABLE);
  VAR
   XCC      : D_XObj.XCContentType;
   trgOM    : L_XObj.tOriginsMap;
   trgMyFirm: P_Firm.tMyFirm;
   trgAK    : L_Acnt.tAccountingKind;
   curMade  : LIKE(ccTBSH.Made);
   curName  : LIKE(ccTBSH.Name);
   lv0Value,
   lv1Value,
   lv2Value,
   lv3Value : L_Acnt.tUnfoldedAcntVector;
   lv1Parent,
   lv2Parent,
   lv3Parent,
   lv4Parent: LIKE(ccTBS1.Parent);
   curDSum,
   curCSum  : L_XObj.tSum;
   curRI    : L_General.tRecordId;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_DatTim.CheckWMIntvl(Memo.ud_fr(), Memo.ud_ut());
  SETEMPTY(trgMyFirm);
  IF ~!curTable THEN
   ACCESS((curTable.Name));
   IF    curTable.Name = "AcCut"    THEN
    XCC:=D_XObj.XCC_WholeAcCut;
    L_Acnt.AccessACLog(Memo.ud_ut(), AcCut.AcCut);
    curName:="१ " + ACLog.Sign + " (" + AcCut.AcCut + ") " + AcCut.Name;
   ELSIF curTable.Name = "CAcnt"    THEN
    XCC:=D_XObj.XCC_WholeAcnt;
    curName:=" " + CAcnt.Sign + " " + CAcnt.Name;
   ELSIF curTable.Name = "CostItem" THEN
    XCC:=D_XObj.XCC_SingleCostItem;
    curName:=" " + CostItem.CostItem + " " + CostItem.Name;
    IF CostItem.MyFirm # P_Firm.mf_Fict THEN
     trgMyFirm:=CostItem.MyFirm;
    END;
   ELSIF curTable.Name = "Math" THEN
    XCC:=D_XObj.XCC_SingleMath;
    IF Math.MathKind = L_MathR.mathk_KeyAs THEN
     curName  :=" " + Math.Math + " " + Math.Name;
     trgMyFirm:=Math.MyFirm;
    ELSE
     curName:=" " + Math.Math + " " + Math.Name;
    END;
   ELSIF curTable.Name = "Contract" THEN
    XCC:=D_XObj.XCC_SingleXObject;
    curName:=" " + Contract.Contract + " " + Contract.Name;
    trgMyFirm:=Contract.MyFirm;
   ELSIF curTable.Name = "Firm" THEN
    XCC:=D_XObj.XCC_SingleFirm;
    curName:="ࠣ " + Firm.Firm + " " + Firm.Name;
   ELSIF curTable.Name = "Staff" THEN
    XCC:=D_XObj.XCC_SingleXObject;
    curName:="⭨ " + Staff.TSN + " " + Staff.Name;
    trgMyFirm:=Staff.MyFirm;
   ELSIF curTable.Name = "Man" THEN
    XCC:=D_XObj.XCC_SingleMan;
    curName:=" " + L_Str.FixedIntStr(Man.Man, 5) + " " + Man.Name;
   ELSIF curTable.Name = "Storage" THEN
    XCC:=D_XObj.XCC_SingleStorage;
    curName:=" " + Storage.Storage + " " + Storage.Name;
    trgMyFirm:=Storage.MyFirm;
   END;
   curRI:=^(curTable.Fields("RECORDID").ObtainName());
  ELSE
   XCC:=D_XObj.XCC_FullWealth;
   curName:="";
   SETEMPTY(curRI);
  END;

  PrepareDummyAcCut();

  L_XObj.extSetupOrigins("⮢ ", 1, trgOM, trgMyFirm, trgAK);

  curMade:=SYSTIMESTAMP();
  D_XObj.PointwiseBuildXC001(XCC,
                             EMPTYOF(L_XObj.tSection),
                             trgAK,
                             trgOM,
                             trgMyFirm,
                             D_XObj.XST_ByAcCut,
                             D_XObj.XST_ByXObj,
                             D_XObj.XST_ByAcCut2);

  Repack(curTable, curRI);

  CompleteSecondSide(curTable, curRI);

  SELECT(XC020, toFill);
  WHILE OCCURE(XC020) DO
   NARROWSEL(XC020, MyFirm);
   DEFAULT(ccTBSH);
   ccTBSH.cc    :=APP.Get().MyConnection.Number;
   ccTBSH.MyFirm:=XC020.MyFirm;
   ccTBSH.Made  :=curMade;
   ccTBSH.PerB  :=Memo.ud_fr();
   ccTBSH.PerE  :=Memo.ud_ut();
   ccTBSH.AK    :=trgAK;
   ccTBSH.OM    :=trgOM;
   IF ~!curTable THEN
    ccTBSH.fiOwn:=curTable.Id;
    ccTBSH.riOwn:=curRI;
   END;
   ccTBSH.Name:=curName;
   INSERT(ccTBSH);

   WHILE OCCURE(XC020) DO
    NARROWSEL(XC020, lv0Sign);
    InsertUpLevel(l_Acnt, XC020.lv0Sign, XC020.lv0Name, EMPTYOF(ccTBS1.Parent), lv0Value, lv1Parent);
    WHILE OCCURE(XC020) DO
     NARROWSEL(XC020, lv1Sign);
     InsertUpLevel(l_CAcnt, XC020.lv1Sign, XC020.lv1Name, lv1Parent, lv1Value, lv2Parent);
     WHILE OCCURE(XC020) DO
      NARROWSEL(XC020, lv2Sign);
      InsertUpLevel(l_AcCut, XC020.lv2Sign, XC020.lv2Name, lv2Parent, lv2Value, lv3Parent);
      WHILE OCCURE(XC020) DO
       NARROWSEL(XC020, lv3Sign);
       InsertUpLevel(l_XOGroup, XC020.lv3Sign, XC020.lv3Name, lv3Parent, lv3Value, lv4Parent);
       WHILE OCCURE(XC020) DO
        PROMPT("㧪: " + XC020.MyFirm + ", " + XC020.lv0Sign + ", " + XC020.lv1Sign + ", " + XC020.lv2Sign + ", " + XC020.lv3Sign + ", " + XC020.lv4Sign);
        InsertLevel(l_XObject, XC020.lv4Sign, XC020.lv4Name, lv4Parent, XC020.Value);
        AddV(lv3Value, XC020.Value);
        SELECT(XA020, XA020, , XC020.MyFirm, XC020.AcCut, XC020.XObject);
        WHILE OCCURE(XA020) DO
         DEFAULT(ccTBS2);
         ccTBS2.ccTBS1 :=ccTBS1.RECORDID;
         ccTBS2.Sign   :=XA020.Sign;
         ccTBS2.Name   :=XA020.Name;
         ccTBS2.AcCut2 :=XA020.AcCut2;
         ccTBS2.dSum   :=XA020.dSum;
         ccTBS2.cSum   :=XA020.cSum;
         ccTBS2.dQnt   :=XA020.dQnt;
         ccTBS2.cQnt   :=XA020.cQnt;
         INSERT(ccTBS2);
         NEXT(XA020);
        END; (* WHILE OCCURE(XA020) *)
        NEXT(XC020);
       END; (* WHILE OCCURE(XC020) ... *)
       UpdateLevel(lv4Parent, lv3Parent, lv3Value);
       AddV(lv2Value, lv3Value);
       NEXTINEXTENDEDSEL(XC020, lv3Sign);
      END; (* WHILE OCCURE(XC020) *)
      UpdateLevel(lv3Parent, lv2Parent, lv2Value);
      AddV(lv1Value, lv2Value);
      NEXTINEXTENDEDSEL(XC020, lv2Sign);
     END; (* WHILE OCCURE(XC020) *)
     UpdateLevel(lv2Parent, lv1Parent, lv1Value);
     AddV(lv0Value, lv1Value);
     NEXTINEXTENDEDSEL(XC020, lv1Sign);
    END; (* WHILE OCCURE(XC020) ... *)
    UpdateLevel(lv1Parent, EMPTYOF(ccTBS1.Parent), lv0Value);
    NEXTINEXTENDEDSEL(XC020, lv0Sign);
   END; (* WHILE OCCURE(XC020) ... *)
   NEXTINEXTENDEDSEL(XC020, MyFirm);
  END; (* WHILE OCCURE(XC020) ... *)
  LaunchWDO(curMade);
 END {Do};

 PUBLIC PROCEDURE TBS_AcCut();
 BEGIN
  Do(TABLE.Get("AcCut"));
 END {TBS_AcCut};

 PUBLIC PROCEDURE TBS_Acnt();
 BEGIN
  Do(TABLE.Get("CAcnt"));
 END {TBS_Acnt};

 PUBLIC PROCEDURE TBS_CostItem();
 BEGIN
  Do(TABLE.Get("CostItem"));
 END {TBS_CostItem};

 PUBLIC PROCEDURE TBS_Storage();
 BEGIN
  Do(TABLE.Get("Storage"));
 END {TBS_Storage};

 PUBLIC PROCEDURE TBS_Math();
 BEGIN
  Do(TABLE.Get("Math"));
 END {TBS_Math};

 PUBLIC PROCEDURE TBS_Contract();
 BEGIN
  Do(TABLE.Get("Contract"));
 END {TBS_Contract};

 PUBLIC PROCEDURE TBS_Firm();
 BEGIN
  Do(TABLE.Get("Firm"));
 END {TBS_Firm};

 PUBLIC PROCEDURE TBS_Staff();
 BEGIN
  Do(TABLE.Get("Staff"));
 END {TBS_Staff};

 PUBLIC PROCEDURE TBS_Man();
 BEGIN
  Do(TABLE.Get("Man"));
 END {TBS_Man};

 PUBLIC PROCEDURE TBS_Full();
 BEGIN
  Do(EMPTYOF(TABLE));
 END {TBS_Full};

PRIVATE PROCEDURE GetXDocDoneDTS(trgXDocId: L_XDoc.tXDocId): L_XDoc.tDoneDTS;
 VAR
  curRefFileName : STRING[];
  curDoneDTSField: FIELD;
  Result         : L_XDoc.tDoneDTS;
BEGIN
 IF    L_XDoc.ExtractXDocType(trgXDocId) = L_XDoc.xdt_PCalc THEN
  Result:=MAXOF(L_XDoc.tDoneDTS);
 ELSIF L_XDoc.ExtractXDocType(trgXDocId) = L_XDoc.xdt_ACalc THEN
  Result:=MAXOF(L_XDoc.tDoneDTS);
 ELSE
  curRefFileName:=L_XDoc.Ref_FileName(L_XDoc.ExtractXDocType(trgXDocId));
  curDoneDTSField:=TABLE.Get(curRefFileName).Fields("DoneDTS");
  L_General.CallUs(~!curDoneDTSField);
  TRY
   L_General.CallUs(L_XDoc.StandOnXDoc(trgXDocId));
   Result:=^(curDoneDTSField.ObtainName());
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END; (* TRY *)
 END;
 RETURN Result;
END {GetXDocDoneDTS};

 PRIVATE PROCEDURE TBS2_SD_Prepare_SingleXApport(InvDir: SCAL[2]);
  VAR
   leftSide  : SCAL[2];
   curDSum,
   curCSum   : L_XObj.tSum;
   curDQnt,
   curCQnt,
   curQnt    : L_XObj.tQnt;
   corXObject: LIKE(XObject.XObject);
   curSign   : LIKE(ccTBS2.Sign);
 BEGIN
  CONFORM(XApport, Apport);
  IF L_Acnt.E_DoXDocAprOfSpecifiedSource(XApport.WFDate, XApport.Source) | (XApport.Source = L_XObj.src_MathRevision) THEN
   FOR_EACH leftSide DO
    L_XObj.SelectXDocAprByXApport(leftSide);
    WHILE OCCURE(XDocApr) DO
     PROMPT(L_DatTim.PeriodStr(XApport.WFDate)+" "+L_XDoc.XDocStr(XDocApr.XDocId));
     IF leftSide THEN
      curQnt:=XDocApr.Qnt*(XDocApr.wQnt MOD 2);
     ELSE
      curQnt:=XDocApr.Qnt*(XDocApr.wQnt DIV 2);
     END;
     IF (Apport.CirType = L_Acnt.ct_Debit) = (InvDir = 0) THEN
      curDSum:=XDocApr.Sum; curDQnt:=curQnt; curCSum:=0;           curCQnt:=0;
     ELSE
      curDSum:=0;           curDQnt:=0;      curCSum:=XDocApr.Sum; curCQnt:=curQnt;
     END;
     IF XDocApr.XObject = ccTBS1.XObject THEN corXObject:=XDocApr.XObject2;
     ELSE                                     corXObject:=XDocApr.XObject;
     END;
     ADD(MSHst, DoneDTS, , XDocApr.XDat, L_XDoc.GetXDocDate(XDocApr.XDocId),
                           GetXDocDoneDTS(XDocApr.XDocId), XDocApr.XDocId, corXObject, XApport.Source,
         MSHst.dSum, curDSum,
         MSHst.cSum, curCSum,
         MSHst.dQnt, curDQnt,
         MSHst.cQnt, curCQnt);
     NEXT(XDocApr);
    END; (* WHILE OCCURE(XDocApr) *)
   END; (* FOR_EACH leftSide *)
  ELSE
   IF (Apport.CirType = L_Acnt.ct_Debit) = (InvDir = 0) THEN
    curDSum:=XApport.Sum; curDQnt:=XApport.Qnt; curCSum:=0; curCQnt:=0
   ELSE
    curDSum:=0;           curDQnt:=0;           curCSum:=XApport.Sum; curCQnt:=XApport.Qnt;
   END;
   ADD(MSHst, DoneDTS, , XApport.XDat, L_DatTim.IncMonth(XApport.XDat, +1)-1,
                         MAXOF(MSHst.DoneDTS), EMPTYOF(L_XDoc.tXDocId), XApport.XObject, XApport.Source,
       MSHst.dSum, curDSum,
       MSHst.cSum, curCSum,
       MSHst.dQnt, curDQnt,
       MSHst.cQnt, curCQnt);
  END; (* IF L_Acnt.E_DoXDocAprOfSpecifiedSource *)
 END {TBS2_SD_Prepare_SingleXApport};

PRIVATE PROCEDURE IsAcceptableXApport(AK: L_Acnt.tAccountingKind): SCAL[2];
 VAR
  P: DATE;
BEGIN
 IF (XApport.Sum#0) | (XApport.Qnt#0) THEN
  IF    AK = L_Acnt.ak_Acn THEN
   P:=XApport.XDat;
  ELSIF AK = L_Acnt.ak_Tax THEN
   P:=XApport.WFDate;
  END;
  RETURN L_DatTim.IsActive_Inc(P, ccTBSH.PerB, ccTBSH.PerE);
 ELSE
  RETURN 0;
 END;
END {IsAcceptableXApport};

PRIVATE PROCEDURE GatherXC001_SingleAcCut2(trgAcCut2,
                                           trgAcCut   : LIKE(XApport.AcCut);
                                           AK         : L_Acnt.tAccountingKind;
                                           trgOM      : L_XObj.tOriginsMap;
                                           trgMyFirm  : P_Firm.tMyFirm);
BEGIN
 SETSEL(XApport, AcCut2, trgAcCut2);
 SRCINSEL(XApport, LE, , ccTBSH.PerE);
 WHILE OCCURE(XApport) & ((AK = L_Acnt.ak_Acn) | (XApport.WFDate >= ccTBSH.PerB)) DO
  CHANGESEL(XApport, AcCut2, , XApport.AcCut2, XApport.WFDate);
  IF AK = L_Acnt.ak_Acn THEN
   SRCINSEL(XApport, LE, , ccTBSH.PerE);
  ELSE
   LAST(XApport);
  END;
  WHILE OCCURE(XApport) & (XApport.XDat >= ccTBSH.PerB) DO
   IF (XApport.AcCut = trgAcCut) & IsAcceptableXApport(AK) THEN
    IF L_XObj.SrcXObject(XApport.XObject) THEN
     PROMPT(" "+XObject.XObject);
     IF trgOM[XObject.Origin] & (!trgMyFirm | (XObject.MyFirm = trgMyFirm)) THEN
      TBS2_SD_Prepare_SingleXApport(1);
     END;
    END;
   END;
   PREV(XApport);
  END;
  FIRST(XApport);
  CHANGESEL(XApport, AcCut2, , XApport.AcCut2);
  PREV(XApport);
 END; (* WHILE OCCURE(XApport) ... *)
END {GatherXC001_SingleAcCut2};

 PRIVATE PROCEDURE TBS2_SD_Prepare();
  VAR
   curSign: LIKE(ccTBS2.Sign);
 BEGIN
  SEARCH(ccTBS1, RECORDID, ,  ccTBS2.ccTBS1);
  SEARCH(ccTBSH, RECORDID, ,  ccTBS1.ccTBSH);
  APP.Get().NewPrompt("⮢  㬥⮢. " + ccTBS1.Sign);
  IF    ~!ccTBS1.XObject THEN
   SELECT(XApport, XObject, , ccTBS1.XObject, ccTBS1.AcCut);
   SRCINSEL(XApport, GE, , ccTBSH.PerB);
   WHILE OCCURE(XApport) & (XApport.XDat <= ccTBSH.PerE) DO
    IF XApport.AcCut2 = ccTBS2.AcCut2 THEN
     TBS2_SD_Prepare_SingleXApport(0);
    END; (* IF XApport.AcCut2 = ccTBS2.AcCut2 *)
    NEXT(XApport);
   END; (* WHILE OCCURE(XApport) ... *)
  ELSIF ccTBS1.Sign = SingleSideCirId THEN
   GatherXC001_SingleAcCut2(ccTBS1.AcCut, ccTBS2.AcCut2, ccTBSH.AK, ccTBSH.OM, ccTBSH.MyFirm);
  ELSIF SELECT(ccTBS1, Parent, ccTBS1.RECORDID) THEN
   curSign:=ccTBS2.Sign;
   WHILE OCCURE(ccTBS1) DO
    IF SELECT(ccTBS2, TBS1, ccTBS1.RECORDID, curSign) THEN
     SAVE(ccTBS1);
     TBS2_SD_Prepare();
     RESTORE(ccTBS1);
    END;
    NEXT(ccTBS1);
   END; (* WHILE OCCURE(ccTBS1) ... *)
  ELSE
   L_General.CallUs(0);
  END;
 END {TBS2_SD_Prepare};

 PRIVATE PROCEDURE StandByXObject_Prepare(trgXObject: LIKE(XObject.XObject); VAR trgFile: STRING[]);
 BEGIN
  IF ~!L_XObj.DecodeConciseXOId(trgXObject) THEN
   L_StdFrm.BlueHalt("   ᢥ⮬ ꥪ");
  ELSE
   SEARCH(XObject, XObject, , trgXObject);
   L_XObj.AccessOrigin();
   IF    XObject.Origin = L_XObj.o_Man THEN
    CONFORM(mfMan, Man);
    trgFile:="Man";
   ELSIF XObject.Origin = L_XObj.o_Staff THEN
    trgFile:="Staff";
   ELSIF XObject.Origin = L_XObj.o_Contract THEN
    trgFile:="Contract";
   ELSIF XObject.Origin = L_XObj.o_CostItem THEN
    trgFile:="CostItem";
   ELSIF (XObject.Origin = L_XObj.o_KeyAss) | (XObject.Origin = L_XObj.o_Math) THEN
    CONFORM(mItem, Math);
    trgFile:="Math";
   ELSIF (XObject.Origin = L_XObj.o_Global) THEN
    trgFile:="XObject";
   ELSE
    L_General.CallUs(0);
   END;
  END;
 END {StandByXObject_Prepare};

 PUBLIC PROCEDURE TBS2_ShowDocs();
  VAR
   trgFile       : STRING[];
   curMade       : TIMESTAMP;
   corXObjectName: STRING[];
 BEGIN
  ACCESS(ccTBS2);
  curMade:=SYSTIMESTAMP();
  ccTBS2.LDMade:=curMade;
  REPLACE(ccTBS2);
  L_AFM.MakeMultipleIndex("MSHst", "XDat    : DATE;"+
                                   "Date    : DATE;"+
                                   "DoneDTS : "+GET_TYPE_SPEC(L_XDoc.tDoneDTS).Name+";"+
                                   "XDocId  : "+GET_TYPE_SPEC(L_XDoc.tXDocId).Name+";"+
                                   "XObject : LIKE(XObject.XObject);"+
                                   "Source  : LIKE(XApport.Source);"+
                                   "dSum    : LIKE(XApport.Sum);"+
                                   "cSum    : LIKE(XApport.Sum);"+
                                   "dQnt    : LIKE(XApport.Qnt);"+
                                   "cQnt    : LIKE(XApport.Qnt);"+
                                   "Text    : STRING[256]",
                          "DoneDTS: XDat, Date, DoneDTS, XDocId, XObject, Source;"+
                          "XDocId: XDocId");
  TBS2_SD_Prepare();
  SELECT(MSHst, DoneDTS);
  WHILE OCCURE(MSHst) DO
   SEARCH(XObject, XObject, , MSHst.XObject);
   SETEMPTY(trgFile);
   IF ~!MSHst.XDocId THEN
    MSHst.Text:=L_XDoc.XDocStr(MSHst.XDocId) + " " + L_DatTim.DateStr(MSHst.Date);
    trgFile:=L_XDoc.Ref_FileName(L_XDoc.ExtractXDocType(MSHst.XDocId));
    L_XDoc.PositionOnXDoc(MSHst.XDocId);
   ELSE
    MSHst.Text:=L_Str.PoolItem(L_XObj.src_Pool, MSHst.Source) + " " + L_DatTim.DateStr(MSHst.Date);
    TRY
     StandByXObject_Prepare(MSHst.XObject, trgFile);
    EXCEPT
    ON Exc: Exc_Raise THEN
    ON Exc: Exc_Halt  THEN
    END;
   END;
   IF OCCURE(XObject) THEN
    corXObjectName:=L_XObj.GetXObjectOriginName();
   ELSE
    corXObjectName:="";
   END;
   MSHst.Text:=Str.Align(Str.Align(MSHst.Text, 28, LEFT) + " " + Str.Align(corXObjectName, 64, LEFT), 148-(15+1)*2-(13+1)*2, LEFT)
       + " " + FLDTOSTR(MSHst.dQnt, "Z3.",  13)
       + " " + FLDTOSTR(MSHst.dSum, "Z,2-", 15)
       + " " + FLDTOSTR(MSHst.cQnt, "Z3.",  13)
       + " " + FLDTOSTR(MSHst.cSum, "Z,2-", 15);
   REPLACE(MSHst);
   ccLD.cc  :=APP.Get().MyConnection.Number;
   ccLD.Made:=curMade;
   ccLD.fi:=TABLE.Get(trgFile).Id;
   ccLD.ri:=^(TABLE.Get(trgFile).Fields("RECORDID").ObtainName());
   ccLD.Text:=MSHst.Text;
   SETEMPTY(ccLD.Nbr, ccLD.XDocId, ccLD.RECORDID);
   INSERT(ccLD);
   NEXT(MSHst);
  END; (* WHILE OCCURE(MSHst) ... *)
 END {TBS2_ShowDocs};

 PUBLIC PROCEDURE StandOnXObjectOrigin();
  VAR
   trgFile: STRING[];
 BEGIN
  ACCESS(ccTBS1);
  IF !ccTBS1.XObject THEN
   SETEMPTY(trgFile);
   IF SELECT(ccTBS1, Parent, ccTBS1.RECORDID) & ~!ccTBS1.XObject THEN
    StandByXObject_Prepare(ccTBS1.XObject, trgFile);
    IF trgFile = "Math" THEN
     (* just do it *)
    ELSIF trgFile = "Contract" THEN
     CONFORM(Contract, Firm);
     trgFile:="Firm";
    ELSE
     SETEMPTY(trgFile);
    END;
   END;
  ELSE
   StandByXObject_Prepare(ccTBS1.XObject, trgFile);
  END;
  IF ~!trgFile THEN
   L_WDO.PosToCurRecord(trgFile, "", 0);
  ELSE
   L_StdFrm.BlueHalt("  ꥪ");
  END;
 END {StandOnXObjectOrigin};

BEGIN
 L_Events.ExecuteHandler();
END.
