(*
%Copyright   (c) Polak Computer System
%Author      26.04.2001 21:31:59 GINA
%Purpose     㠫쭠 窠  믫  
%Type        report
%Specific    SYS
%Modified    05.09.2014 10:45:26 POLAK\Bor
%Environment
*)

 MODULE TX_2002 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Man, P_Man, L_Staff, L_STx, L_XObj, L_DatTim, L_Russia,
        L_PRoll, Math, Str, L_EC, E_PRoll, L_Acnt, Memo, P_Firm, L_APtm, L_StdFrm;

(*  MAN_T2!! -  ? *)

 PRIVATE PROCEDURE GetCitizenshipCountryName(): STRING[];
 BEGIN
  IF ~L_Man.AccessManAdr(Man.Man, SYSDATE(), L_Russia.at_CtMA) THEN
   L_Man.AccessRgManAdr(Man.Man, SYSDATE());
  END;
  CONFORM(ManAdr, Country);
  RETURN Country.Name;
 END {GetCitizenshipCountryName};

 PRIVATE VAR
  _InvldValue   : LIKE(ManPro.Value);
  _InvldDocNum  : LIKE(ManPro.DocNum);
  _InvldDocGiveD: LIKE(ManPro.DocGiveD);
  _DgOrder      : LIKE(StaffLog.Order);
  _DgDate       : DATE;

  M_ValInc,
  Y_ValInc,
  M_IncNoTaxed,
  Y_IncNoTaxed,
  M_TaxBaseSpc,
  Y_TaxBaseSpc,
  M_IncNoTaxed008_PFRF,
  M_IncNoTaxed008_Invl,
  M_IncNoTaxed008,
  Y_IncNoTaxed008,
  M_IncNoTaxedFirm,
  Y_IncNoTaxedFirm,
  M_IncNoTaxed009,
  Y_IncNoTaxed009,
  M_IncNoTaxed010,
  Y_IncNoTaxed010,
  M_NoTaxedFSS,
  Y_NoTaxedFSS,
  M_TaxBasePFR,
  Y_TaxBasePFR,
  M_TaxBaseFSS,
  Y_TaxBaseFSS,
  M_PurBasePFR,
  Y_PurBasePFR,
  M_PurBaseOMS,
  Y_PurBaseOMS,
  M_PurBaseFSS,
  Y_PurBaseFSS,
  M_TaxPFR,
  Y_TaxPFR,
  M_TaxFFOMS,
  Y_TaxFFOMS,
  M_TaxTFOMS,
  Y_TaxTFOMS,
  M_TaxFSS,
  Y_TaxFSS,
  M_TaxPFIn,
  Y_TaxPFIn,
  M_TaxPFAc,
  Y_TaxPFAc,
  M_IncFSS,
  Y_IncFSS: NUMERIC[2];

(*
$P{ Top:
Memo.ud_mb(), L, "y"
Man.Name, L, ""
Man.INN, L, ""
L_Man.GetManSINumber_asStr(), L, ""
GetCitizenshipCountryName(), L, ""
L_Man.GetManDocName(Man.DocType), L, ""
Man.PspSer, L, ""
Man.PspNbr, L, ""
Man.PspGiveD, L, "D.N.y"
Man.PspGiveS, L, ""
Man.Sex, L, "|"
Man.Birth, L, "D.N.y"
L_Man.GetAdr_asStr(Man.Man, SYSDATE(), L_Russia.at_RgMA), L, ""
Post.Name, L, ""
(Staff.Contract>2), L, "㤮|ࠦ᪮-ࠢ"
_DgOrder, L, ""
_DgDate, L, "D.N.y"
_InvldValue, L, ""
_InvldDocNum, L, ""
_InvldDocGiveD, L, "D.N.y"
@
                                                                                                                                                                                                  ਫ 1  ਪ  ᨨ  21.02.2002  -3-05/91

                                                                                         㠫쭠 窠  㬬 ᫥ 믫   ࠦ,
                                                                                   㬬 ᫥  樠쭮 ,  ⠪ 㬬    #### 
===============================================================================================================================================================================================================================================================
|  ࠡ⭨-⥫ 室: ... ##################################################   ############  客  ##############  ࠦ⢮ ############################################################################################|
|######################################:  ##########      ##########     뤠 ########## ##########################################################################################################################################################|
| #   ஦ ##########     ⥫⢠ ####################################################################################################################################################################################################|
| ################################################################    : ###################     ############  祭   (  祭 ) ########################################################|
|稥  ##########  ࠢ: ,  ################################  뤠 #########################                                                                                                                                |
|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|             | ᫥ |믫, |믫,   |믫  |                      |           죮         |    ᫥  |᫥  |         ᫥  ᮢ ⥦         |  ᫥ ᮢ  |
|             |  믫   |⭥ᥭ | -|ࠬ  |-----------------------------------|-----------------------------------|-----------------------------------|  ᮡ  |           樠쭮          | ⥦  客 |
|             |  -| 室,|騥 -|ࠦ᪮-|  |  |  | ᮮ⢥.| ᮮ⢥.| 䥤ࠫ-| 䥤ࠫ-| 䮭  |      |(室) |-----------------------------------------------|ᠬ  易⥫쭮|
|             |ࠦ|㬥騬|  |ࠢ  |樠쭮|樠쭮|ᮡ     | .239  |  .2     |  |  |           |           |     | 䥤ࠫ-|      |      |      |ᨮ  客|
|   ,    | 㤮|  |      |ࠪ, |    |    |०     |       | .245    |..3,4    |(.6-.8-|(.6-.8-|(.7-.8-|  ।  |  |           |           |           |    (. )   |
|   ਮ    |ࠦ᪮-|     |䮭      | ᪨|䥤ࠫ|     |-    |           |       |.245     |.9-.10)|.9)      |.9)      |      |           |           |           |           |-----------------------|
|             | ࠢ, |   | 䥤ࠫ-|ࠬ, |    |(.2-.3-|  |           |           |       |           |           |           |           |           |           |           |           |       ⮬ ᫥:     |
|             | ᪨ |ਡ    |  | -|䮭 , |.4-.5) |           |           |           |           |           |           |           |           |           |           |           |           |-----------------------|
|             |ࠬ -|(  |(.238    |   |客  |           |           |           |           |           |           |           |           |           |           |           |           |           | 客 |  . |
|             |   ᥣ   | 室  |  )    |(.3 .238|ᠬ   |           |           |           |           |           |           |           |           |           |           |           |           |           |      |      |
|             |           |䨧.)   |           |  )    | (.2- |           |           |           |           |           |           |           |           |           |           |           |           |           |  㤮 |  㤮 |
|             |           |           |           |           |-.3-.4)|           |           |           |           |           |           |           |           |           |           |           |           |           |   ᨨ  |   ᨨ  |
|-------------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|
|      1      |     2     |     3     |     4     |     5     |     6     |     7     |     8     |     9     |    10     |    11     |    12     |    13     |    14     |    15     |    16     |    17     |    18     |    19     |    20     |    21     |
}
*)

(*
$P{ LineMonth:
?, L, "m"
M_ValInc+M_TaxBaseSpc, R, "2."
M_IncNoTaxed, R, "2."
M_NoTaxedFSS, R, "2."
M_TaxBasePFR, R, "2."
M_TaxBaseFSS, R, "2."
M_TaxBaseSpc, R, "2."
M_IncNoTaxed008, R, "2."
M_IncNoTaxed009, R, "2."
M_IncNoTaxed010, R, "2."
M_PurBasePFR, R, "2."
M_PurBaseOMS, R, "2."
M_PurBaseFSS, R, "2."
M_IncFSS, R, "2."
M_TaxPFR, R, "2."
M_TaxFFOMS, R, "2."
M_TaxTFOMS, R, "2."
M_TaxFSS, R, "2."
M_TaxPFIn, R, "2."
M_TaxPFAc, R, "2."
Y_ValInc+Y_TaxBaseSpc, R, "2."
Y_IncNoTaxed, R, "2."
Y_NoTaxedFSS, R, "2."
Y_TaxBasePFR, R, "2."
Y_TaxBaseFSS, R, "2."
Y_TaxBaseSpc, R, "2."
Y_IncNoTaxed008, R, "2."
Y_IncNoTaxed009, R, "2."
Y_IncNoTaxed010, R, "2."
Y_PurBasePFR, R, "2."
Y_PurBaseOMS, R, "2."
Y_PurBaseFSS, R, "2."
Y_IncFSS, R, "2."
Y_TaxPFR, R, "2."
Y_TaxFFOMS, R, "2."
Y_TaxTFOMS, R, "2."
Y_TaxFSS, R, "2."
Y_TaxPFIn, R, "2."
Y_TaxPFAc, R, "2."
@
|-------------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|
|###|  |###########|           |###########|###########|###########|###########|###########|###########|###########|###########|###########|###########|###########|###########|###########|###########|###########|###########|###########|###########|
|   |  |###########|           |###########|###########|###########|###########|###########|###########|###########|###########|###########|###########|###########|###########|###########|###########|###########|###########|###########|###########|
}
*)

(*
$P{ Bot:
SYSDATE(), L, "DNy"
SYSTIME(), L, "HM"
@
===============================================================================================================================================================================================================================================================
⮢ " ⮏" (c) Polak                                                                                                                                                                                                               ######## ####
}
*)

 PRIVATE PROCEDURE NeedApport(_SignPtrn: LIKE(CAcnt.Sign)): SCAL[2];
 BEGIN
  CONFORM(XApport, Apport);
  IF ~!_SignPtrn THEN
   RETURN (Apport.CirType=L_Acnt.ct_Credit) &
          Str.Match(L_Acnt.GetCAcntSign(Memo.ud_me(), XApport.AcCut2), _SignPtrn);
  ELSE
   RETURN Apport.CirType=L_Acnt.ct_Credit;
  END;
 END {NeedApport};

 PRIVATE PROCEDURE Get_XApport_Cir_By_Acnt(P: DATE; _AcCut: LIKE(XApport.AcCut); _SignPtrn: LIKE(CAcnt.Sign)): NUMERIC[2];
  VAR
   S: NUMERIC[2];
 BEGIN
  SETZERO(S);
  IF P <= Memo.ud_mb() THEN
   SELECT(XApport, XObject, , XObject.XObject, _AcCut, P);
   WHILE OCCURE(XApport) DO
    IF NeedApport(_SignPtrn) THEN
     INC(S, XApport.Sum);
    END;
    NEXT(XApport);
   END; (* WHILE OCCURE(XApport) ... *)
  END;
  RETURN S;
 END {Get_XApport_Cir_By_Acnt};

 PRIVATE PROCEDURE Get_XApport_Cir(P: DATE; _AcCut: LIKE(XApport.AcCut)): NUMERIC[2];
 BEGIN
  RETURN Get_XApport_Cir_By_Acnt(P, _AcCut, "");
 END {Get_XApport_Cir};

 PRIVATE PROCEDURE E_Need_ManTax_GetIncFSS(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_PRoll.Need_ManTax_GetIncFSS), 0);
 END {E_Need_ManTax_GetIncFSS};

 PRIVATE PROCEDURE MakeOneMonth(P: DATE);
 BEGIN
  M_ValInc:=Get_XApport_Cir(P, L_STx.STx_TotAcCut);
  INC(Y_ValInc, M_ValInc);

  M_TaxBaseSpc:=Get_XApport_Cir(P, L_STx.Spc_BasAcCut);
  INC(Y_TaxBaseSpc, M_TaxBaseSpc);

  M_IncNoTaxedFirm:=0;                        (**)
  INC(Y_IncNoTaxedFirm, M_IncNoTaxedFirm);    (*  3  *)

  M_IncNoTaxed:=-1 * Get_XApport_Cir(P, L_STx.STx_ExlAcCut);
  INC(Y_IncNoTaxed, M_IncNoTaxed);

  M_NoTaxedFSS:=-1 * Get_XApport_Cir(P, L_STx.STx_GetPoBAcCut(L_STx.STx_SSRF()));
  INC(Y_NoTaxedFSS, M_NoTaxedFSS);

  M_TaxBasePFR:=M_ValInc-M_IncNoTaxed;
  INC(Y_TaxBasePFR, M_TaxBasePFR);

  M_TaxBaseFSS:=M_ValInc-M_IncNoTaxed-M_NoTaxedFSS;
  INC(Y_TaxBaseFSS, M_TaxBaseFSS);

  M_IncNoTaxed008:=-Get_XApport_Cir(P, L_STx.STx_GetBnfAcCut(L_STx.STx_PFRF()));
  INC(Y_IncNoTaxed008, M_IncNoTaxed008);

  M_IncNoTaxed009:=0; (*஭  *)
  INC(Y_IncNoTaxed009, M_IncNoTaxed009);

  M_IncNoTaxed010:=0; (*, ப*)
  INC(Y_IncNoTaxed010, M_IncNoTaxed010);

  M_PurBasePFR:=M_TaxBasePFR-M_IncNoTaxed008-M_IncNoTaxed009-M_IncNoTaxed010;
  INC(Y_PurBasePFR, M_PurBasePFR);

  M_PurBaseOMS:=M_TaxBasePFR-(-Get_XApport_Cir(P, L_STx.STx_GetBnfAcCut(L_STx.STx_MSFF())))-M_IncNoTaxed009-M_IncNoTaxed010;
  INC(Y_PurBaseOMS, M_PurBaseOMS);

  M_PurBaseFSS:=M_TaxBaseFSS-(-Get_XApport_Cir(P, L_STx.STx_GetBnfAcCut(L_STx.STx_SSRF())))-M_IncNoTaxed009;
  INC(Y_PurBaseFSS, M_PurBaseFSS);

  M_TaxPFR:=Get_XApport_Cir(P, L_STx.STx_GetTaxAcCut(L_STx.STx_PFRF()));
  INC(Y_TaxPFR, M_TaxPFR);

  M_TaxFFOMS:=Get_XApport_Cir(P, L_STx.STx_GetTaxAcCut(L_STx.STx_MSFF()));
  INC(Y_TaxFFOMS, M_TaxFFOMS);

  M_TaxTFOMS:=Get_XApport_Cir(P, L_STx.STx_GetTaxAcCut(L_STx.STx_MSTF()));
  INC(Y_TaxTFOMS, M_TaxTFOMS);

  M_TaxFSS:=Get_XApport_Cir(P, L_STx.STx_GetTaxAcCut(L_STx.STx_SSRF()));
  INC(Y_TaxFSS, M_TaxFSS);

  IF E_Need_ManTax_GetIncFSS(P) THEN
   M_IncFSS:=Get_XApport_Cir_By_Acnt(P, L_STx.STx_GetTotAcCut(), "69*");
  ELSE
   M_IncFSS:=0;
  END;
  INC(Y_IncFSS, M_IncFSS);

  M_TaxPFIn:=Get_XApport_Cir(P, L_STx.STx_GetTaxAcCut(L_STx.stxp_PFIn));
  INC(Y_TaxPFIn, M_TaxPFIn);

  M_TaxPFAc:=Get_XApport_Cir(P, L_STx.STx_GetTaxAcCut(L_STx.stxp_PFAc));
  INC(Y_TaxPFAc, M_TaxPFAc);

  MAKEPART(R, LineMonth, P);
 END {MakeOneMonth};

 PRIVATE PROCEDURE Make();
  VAR
   P: DATE;
 BEGIN
  SETZERO(Y_ValInc, Y_TaxBaseSpc, Y_IncNoTaxed, Y_IncNoTaxed009, Y_IncNoTaxed010,
          Y_NoTaxedFSS, Y_IncNoTaxed008, Y_IncNoTaxedFirm,
          Y_TaxBasePFR, Y_TaxBaseFSS, Y_TaxPFR, Y_TaxFFOMS, Y_TaxTFOMS, Y_TaxFSS,
          Y_IncFSS, Y_PurBaseFSS, Y_PurBasePFR, Y_PurBaseOMS, Y_TaxPFIn, Y_TaxPFAc);

  P:=L_DatTim.YearBeg(Memo.ud_mb());
  WHILE P <= L_DatTim.YearEnd(Memo.ud_mb()) DO
   PROMPT(L_DatTim.PeriodStr(P));
   MakeOneMonth(P);
   P:=L_DatTim.IncMonth(P, +1);
  END;
 END {Make};

 PRIVATE PROCEDURE Set_InvldProps();
  VAR
   _Per: DATE;
 BEGIN
  SETEMPTY(_InvldValue, _InvldDocNum, _InvldDocGiveD);
  _Per:=L_DatTim.YearBeg(Memo.ud_mb());
  WHILE _Per <= Memo.ud_me() DO
   IF P_Man.HasActualManPro(Man.Man, L_DatTim.MonthEnd(_Per), P_Man.P_Invalid) THEN
    _InvldValue   :=ManPro.Value;
    _InvldDocNum  :=ManPro.DocNum;
    _InvldDocGiveD:=ManPro.DocGiveD;
   END;
   _Per:=L_DatTim.IncMonth(_Per, +1);
  END;
 END {Set_InvldProps};

 PRIVATE PROCEDURE MakeCurrentStaff(SingleStaff: SCAL[2]);
 BEGIN
  L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
  L_Staff.CheckCurrentAsMainForTax(Memo.ud_me());
  L_General.Assert(L_PRoll.IsDedD() | ~SingleStaff,
                   " ⠭  "+L_DatTim.PeriodStr(Memo.ud_mb()));

  IF SingleStaff THEN
   CONFORM(Staff, Man);
  END;
  _DgDate:=L_Man.GetRealBegDate(Math.Max(Staff.BegDate, L_DatTim.YearBeg(Memo.ud_mb())));
  SETEMPTY(_DgOrder);
  IF Staff.Contract > 2(**) THEN
   HISTCONF(_DgDate, Staff, StaffLog);
   _DgOrder:=StaffLog.Order;
  END;
  HISTCONF(Memo.ud_me(), Staff, StaffLog);
  CONFORM(StaffLog, Post);
 
  Set_InvldProps();
 
  IF SingleStaff THEN
   OPENREP(R, L_General.NameConnection("ManTx"), Create);
  END;
  SetPrintAttr(R, FontEnlargement, 1.2, MaxPages, 1);
  MAKEPART(R, Top);

  IF ~!L_STx.GetManXObject(Man.Man, Staff.MyFirm) THEN
   L_STx.AccessManXObject(Staff.Man, Staff.MyFirm);
   Make();
  END;

  MAKEPART(R, Bot);

  IF SingleStaff THEN
   CLOSEREP(R);
  END;
 END {MakeCurrentStaff};

 PRIVATE PROCEDURE HasXObjectAcCutCollection(_XObject: LIKE(XObject.XObject)): SCAL[2];
  VAR
   _AcCut: LIKE(AcCut.AcCut);
   Found : SCAL[2];
 BEGIN
  Found :=0;
  _AcCut:=MINOF(_AcCut);
  SELECT(XCalc, XObject, , _XObject);
  WHILE SRCINSEL(XCalc, GE, _AcCut) & ~Found DO
   _AcCut:=XCalc.AcCut+1;
   SAVE(XCalc);
   CHANGESEL(XCalc, XObject, , XCalc.XObject, XCalc.AcCut);
   IF SRCINSEL(XCalc, GE, L_DatTim.YearBeg(Memo.ud_cd())) & (XCalc.XDat <= Memo.ud_me()) THEN
    Found:=1;
   END;
   RESTORE(XCalc);
  END; (* WHILE OCCURE(XCalc) ... *)
  RETURN Found;
 END {HasXObjectAcCutCollection};

 PRIVATE PROCEDURE NeedMan(): SCAL[2];
 BEGIN
  IF ~L_Staff.IsStandOnMainContract(Man.Man, P_Firm.curMyFirm, Memo.ud_me()) |
     ~L_Staff.IsMainForTax(Memo.ud_me())                                     |
     !L_STx.GetManXObject(Man.Man, P_Firm.curMyFirm) THEN
   RETURN 0;
  END;
  L_STx.AccessManXObject(Man.Man, P_Firm.curMyFirm);
  RETURN HasXObjectAcCutCollection(XObject.XObject);
 END {NeedMan};

 PUBLIC PROCEDURE ManTx();
 BEGIN
  MakeCurrentStaff(1);
  L_General.SurveyLastReport();
 END {ManTx};

 PUBLIC PROCEDURE Tx100();
 BEGIN
  L_StdFrm.Question(" 祪    ਮ  "+L_DatTim.DateStr(L_DatTim.YearBeg(Memo.ud_cd()))+"  "+L_DatTim.DateStr(Memo.ud_me()));
  IF P_Firm.E_wMultipleMyFirm(Memo.ud_me()) THEN
   P_Firm.curMyFirm:=P_Firm.ChoiceMyFirm();
  ELSE
   P_Firm.curMyFirm:=P_Firm.mf_Own;
  END;

  OPENREP(R, L_General.NameConnection("Tx100"), Create);
  L_DatTim.CheckWMIntvl(L_DatTim.YearBeg(Memo.ud_cd()), Memo.ud_me());
  L_General.Assert(L_APtm.MonthIsClosed(Memo.ud_mb(), L_APtm.system_Salary), "   : "+L_DatTim.PeriodStr(Memo.ud_mb()));

  SELECT(Man, Name);
  WHILE OCCURE(Man) DO
   PROMPT(Man.Man);
   IF NeedMan() THEN
    MakeCurrentStaff(0);
    FORMFEED(R);
   END;
   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)
  CLOSEREP(R);
 END {Tx100};

END.
