(*
%Copyright   (c) Polak Computer System
%Author      24.03.2010 19:45:17 POLAK\Gina
%Purpose     㠫쭠 窠  믫  客 ᮢ
%Type        report
%Specific    SYS
%Modified    11.04.2014 19:36:28 POLAK\Gina
%Environment
*)

 IMPORT L_General, L_Man, P_Man, L_DatTim, L_PRoll, Str, L_EC, Memo,
        P_Firm, L_SFee, L_Str, Math, L_Russia, L_APtm, L_StdFrm, L_Staff;

 PRIVATE PROCEDURE GetCitizenshipCountryName(): STRING[];
 BEGIN
  IF ~L_Man.AccessManAdr(Man.Man, SYSDATE(), L_Russia.at_CtMA) THEN
   L_Man.AccessRgManAdr(Man.Man, SYSDATE());
  END;
  CONFORM(ManAdr, Country);
  RETURN Country.Name;
 END {GetCitizenshipCountryName};

 VAR
  _InvldValue   : LIKE(ManPro.Value);
  _InvldDocNum  : LIKE(ManPro.DocNum);
  _InvldDocGiveD: LIKE(ManPro.DocGiveD);

  M_Object,
  Y_Object,
  M_ExcCmn,
  Y_ExcCmn,
  M_ExcPrtFSS,
  Y_ExcPrtFSS,
  M_OverMaxBase,
  Y_OverMaxBase,
  M_Crd69,
  Y_Crd69: NUMERIC[2];
  M_Base,
  Y_Base,
  M_Fee,
  Y_Fee  : L_SFee.tValues;
  M_ManSFeeType: STRING[];

  M_PA_TotalVal,
  Y_PA_TotalVal: NUMERIC[2];
  M_PA_TotalStr,
  Y_PA_TotalStr: STRING[];

(*
$P{ Top:
Memo.ud_me(), L, "y"
P_Firm.FP_FirmName(Firm.Firm, Memo.ud_me()), L, ""
P_Firm.FP_INN(Firm.Firm, Memo.ud_me())+"/"+P_Firm.FP_KPP(Firm.Firm, Memo.ud_me()), L, ""
?, L, ""
?, L, ""
?, L, ""
L_Man.GetManSINumber_asStr(), L, ""
Man.INN, L, ""
GetCitizenshipCountryName(), L, ""
Man.Birth, L, "D.N.y"
_InvldValue, L, ""
_InvldDocNum, L, ""
_InvldDocGiveD, L, "D.N.y"
@
                                                                                                              窠
                                                        㠫쭮  㬬 ᫥ 믫   ࠦ  㬬 ᫥ 客 ᮢ  #### 
====================================================================================================================================================================================================================================
|⥫騪 ############################################################################################################################################   / ##############################                                  |
| ###############################    ###############################   ⢮ ###############################                                                                                                          |
|客  ##############    ############   ࠦ⢮ (࠭) ##############################################    ஦ ##########                                                                                |
|稥  ##########  ࠢ: ,  ################################  뤠 #########################                                                                                                     |
|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|             |                  |믫    |        㬬,    |㬬      |  ᫥ 客 |                                   ᫥ 客 ᮢ                                   |᫥  |
|             |                  | ᮮ⢥- | 騥 |믫,    |-----------------------------------|-------------------------------------------------------------------------------------------------|ᮡ    |
|   ,    |                  |⢨     |-----------------------|ॢ|      |      |       |                                                        |                  |           |     |
|   ਮ    |             |. 1-2 .7|. 1,2 .9|  . |⠭-|           |           |           |-------------------------------------------------------------|-----------------------|       |। |
|             |                  |212-     |   212-  |       | . 4   |           |           |           | 客 |  . | 㬬 |. .58.3 212-|      |      |           |           |
|             |                  |           |           |   |.8 212-|           |           |           |      |      |।쭮  |------------------------|           |           |           |           |
|             |                  |           |           |        |           |           |           |           |           |           |稭    |   㬬   |  ᭮ |           |           |           |           |
|-------------|------------------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|------------|-----------|------------|-----------|-----------|-----------|-----------|
|      1      |         2        |     3     |     4     |     5     |     6     |     7     |     8     |     9     |    10     |    11     |    12      |    13     |     14     |    15     |    16     |    17     |    18     |
}
*)

(*
$P{ LineMonth:
?, L, "m"
M_ManSFeeType, L, ""
M_Object, R, "2."
M_ExcCmn, R, "2."
M_ExcPrtFSS, R, "2."
M_OverMaxBase, R, "2."
M_Base[L_SFee.p_PFIn], R, "2."
M_Base[L_SFee.p_MSFF], R, "2."
M_Base[L_SFee.p_xFSS], R, "2."
M_Fee[L_SFee.p_PFIn], R, "2."
M_Fee[L_SFee.p_PFAc], R, "2."
M_Fee[L_SFee.p_PFOv], R, "2."
M_PA_TotalVal, R, "2."
M_PA_TotalStr, L, ""
M_Fee[L_SFee.p_MSFF], R, "2."
M_Fee[L_SFee.p_MSTF], R, "2."
M_Fee[L_SFee.p_xFSS], R, "2."
M_Crd69, R, "2."
Y_Object, R, "2."
Y_ExcCmn, R, "2."
Y_ExcPrtFSS, R, "2."
Y_OverMaxBase, R, "2."
Y_Base[L_SFee.p_PFIn], R, "2."
Y_Base[L_SFee.p_MSFF], R, "2."
Y_Base[L_SFee.p_xFSS], R, "2."
Y_Fee[L_SFee.p_PFIn], R, "2."
Y_Fee[L_SFee.p_PFAc], R, "2."
Y_Fee[L_SFee.p_PFOv], R, "2."
Y_PA_TotalVal, R, "2."
Y_PA_TotalStr, L, ""
Y_Fee[L_SFee.p_MSFF], R, "2."
Y_Fee[L_SFee.p_MSTF], R, "2."
Y_Fee[L_SFee.p_xFSS], R, "2."
Y_Crd69, R, "2."
@
|-------------|------------------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|------------|-----------|------------|-----------|-----------|-----------|-----------|
|###|  |##################|###########|###########|###########|###########|###########|###########|###########|###########|###########|############|###########|############|###########|###########|###########|###########|
|   |  |                  |###########|###########|###########|###########|###########|###########|###########|###########|###########|############|###########|############|###########|###########|###########|###########|
}
*)

(*
$P{ Bot:
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
@
====================================================================================================================================================================================================================================
⮢ " ⮏" (c) Polak                                                                                                                                                                                 ########## #####
}
*)

 PRIVATE PROCEDURE GetPFATotal(    PA_Fee: L_SFee.tValues;
                               VAR PA_TotalVal: NUMERIC[2];
                               VAR PA_TotalStr: STRING[]);
  VAR
   i: NUMERIC[0];
 BEGIN
  PA_TotalVal:=0; PA_TotalStr:="";
  i:=L_SFee.p_PFA1;
  WHILE i <= L_SFee.p_PFA4_0 DO
   IF PA_Fee[i] # 0 THEN
    INC(PA_TotalVal, PA_Fee[i]);
    PA_TotalStr:=L_Str.AddStrDlm(PA_TotalStr, ",")+L_Str.PoolItem("||||||1|2|3.1|3.2|3.3|3.4|4", i);
   END;
   INC(i);
  END;
 END {GetPFATotal};

 PRIVATE PROCEDURE AddArr(VAR Dst: NUMERIC[2][]; Src: NUMERIC[2][]);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i <= HIGH(Dst) DO
   INC(Dst[i], Src[i]);
   INC(i);
  END;
 END {AddArr};

 PRIVATE PROCEDURE MakeOneMonth(P: DATE);
  VAR
   i: NUMERIC[0];
 BEGIN
  SETZERO(M_Object, M_ExcCmn, M_ExcPrtFSS, M_OverMaxBase, M_Base, M_Fee, M_Crd69);
  SETEMPTY(M_ManSFeeType);
  IF (P <= Memo.ud_mb()) & SELECT(ManSFee, MyFirm, Staff.MyFirm, Staff.Man, 1, P) THEN
   M_ManSFeeType:=L_Str.PoolItem(L_SFee.t_Pool, ManSFee.Type);
   M_Object:=ManSFee.Object;
   M_ExcCmn:=ManSFee.ExcCmn;
   M_ExcPrtFSS:=ManSFee.ExcPrt[L_SFee.b_FSS];
   M_OverMaxBase:=ManSFee.OvrPrt[L_SFee.b_PFR];
   i:=0;
   WHILE i < L_SFee.p_Amount DO
    INC(M_Base[i], L_SFee.GetCurrentSinglePartBase(i));
    INC(M_Fee[i],  ManSFee.Fee[i]);
    INC(i);
   END;
   INC(Y_Object,      M_Object);
   INC(Y_ExcCmn,      M_ExcCmn);
   INC(Y_ExcPrtFSS,   M_ExcPrtFSS);
   INC(Y_OverMaxBase, M_OverMaxBase);
   AddArr(Y_Base,     M_Base);
   AddArr(Y_Fee,      M_Fee);
  END;

  SAVE(Staff);
  SELECT(Staff, MyFirm, , Staff.MyFirm, Staff.Man);
  WHILE OCCURE(Staff) DO
   SELECT(Money, TSN, , Staff.TSN, P);
   WHILE OCCURE(Money) DO
    IF L_PRoll.MoneyIsForSocialInsuranceFond() THEN
     INC(M_Crd69, Money.Sum);
    END;
    NEXT(Money);
   END; (* WHILE OCCURE(Money) ... *)
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  RESTORE(Staff);
  INC(Y_Crd69, M_Crd69);

  GetPFATotal(M_Fee, M_PA_TotalVal, M_PA_TotalStr);
  GetPFATotal(Y_Fee, Y_PA_TotalVal, Y_PA_TotalStr);

  MAKEPART(R, LineMonth, P);
 END {MakeOneMonth};

 PRIVATE PROCEDURE Make();
  VAR
   P: DATE;
 BEGIN
  SETZERO(Y_Object, Y_ExcCmn, Y_ExcPrtFSS, Y_OverMaxBase, Y_Base, Y_Fee, Y_Crd69);
  P:=L_DatTim.YearBeg(Memo.ud_mb());
  WHILE P <= L_DatTim.YearEnd(Memo.ud_mb()) DO
   PROMPT(Man.Man+" "+L_DatTim.PeriodStr(P));
   MakeOneMonth(P);
   P:=L_DatTim.IncMonth(P, +1);
  END;
 END {Make};

 PRIVATE PROCEDURE Set_InvldProps();
  VAR
   _Per: DATE;
 BEGIN
  SETEMPTY(_InvldValue, _InvldDocNum, _InvldDocGiveD);
  _Per:=L_DatTim.YearBeg(Memo.ud_mb());
  WHILE (_Per <= Memo.ud_mb()) & !_InvldValue DO
   IF L_SFee.ManIsInvalid(Man.Man, _Per) THEN
    _InvldValue   :=ManPro.Value;
    _InvldDocNum  :=ManPro.DocNum;
    _InvldDocGiveD:=ManPro.DocGiveD;
   END;
   _Per:=L_DatTim.IncMonth(_Per, +1);
  END;
  IF !_InvldValue THEN
   _InvldValue:="";
  END;
 END {Set_InvldProps};

 PRIVATE PROCEDURE MakeCurrentStaff(SingleStaff: SCAL[2]);
  VAR
   Surname,
   FirstName,
   Patronymic    : STRING[];
 BEGIN
  L_General.Assert(Memo.ud_mb() >= L_SFee.TheStartingPoint,
                   "客    "+L_DatTim.PeriodStr(L_SFee.TheStartingPoint));
  L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
  L_PRoll.CheckSalDone(Memo.ud_mb());

  IF SingleStaff THEN
   IF ~L_SFee.SFeeIsCalculatedInProperConsecution(Memo.ud_mb()) THEN
    L_General.Assert(~L_APtm.MonthIsClosed(L_DatTim.Per(Memo.ud_mb()), L_APtm.system_Salary),
                     "ॡ  客 ᮢ  " + L_DatTim.PeriodStr(Memo.ud_mb()));
    L_StdFrm.Choice("    "+L_DatTim.PeriodStr(Memo.ud_mb())+"   ⥫ (  )");
   END;
   CONFORM(Staff, Man);
   OPENREP(R, L_General.NameConnection("MnFee"), Create);
   SetPrintAttr(R, FontEnlargement, 1.2, MaxPages, 1);
  END;
 
  Set_InvldProps();

  P_Firm.AccessFirm(P_Firm.fomf(Staff.MyFirm));
  L_Man.curMan_SplitName(Surname, FirstName, Patronymic);
  MAKEPART(R, Top, Surname, FirstName, Patronymic);
  Make();
 
  MAKEPART(R, Bot);

  IF SingleStaff THEN
   CLOSEREP(R);
  END;
 END {MakeCurrentStaff};

 PRIVATE PROCEDURE NeedMan(): SCAL[2];
 BEGIN
  IF SELECT(ManSFee, MyFirm, P_Firm.curMyFirm, Man.Man, 1) & SRCINSEL(ManSFee, GE, L_DatTim.YearBeg(Memo.ud_cd())) &
     (ManSFee.Period <= Memo.ud_me()) THEN
   RETURN 1;
  END;
  SELECT(Staff, Man, , Man.Man);
  WHILE OCCURE(Staff) DO
   IF L_DatTim.IsActiveInIntvl_Inc(L_DatTim.YearBeg(Memo.ud_cd()), Memo.ud_me(), Staff.BegDate, Staff.EndDate) THEN
    RETURN 1;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  RETURN 0;
 END {NeedMan};

 PRIVATE PROCEDURE MakeCurStaff();
 BEGIN
  L_StdFrm.Question("  ਮ  "+L_DatTim.DateStr(L_DatTim.YearBeg(Memo.ud_cd()))+"  "+L_DatTim.DateStr(Memo.ud_me()));
  MakeCurrentStaff(1);
 END {MakeCurStaff};

 PRIVATE PROCEDURE MakeAllStaff();
 BEGIN
  IF P_Firm.E_wMultipleMyFirm(Memo.ud_me()) THEN
   P_Firm.curMyFirm:=P_Firm.ChoiceMyFirm();
  ELSE
   P_Firm.curMyFirm:=P_Firm.mf_Own;
  END;
  OPENREP(R, L_General.NameConnection("Tx100"), Create);
  SetPrintAttr(R, FontEnlargement, 1.2, MaxPages, 1);
  L_StdFrm.Question(" 祪  ਮ  "+L_DatTim.DateStr(L_DatTim.YearBeg(Memo.ud_cd()))+"  "+L_DatTim.DateStr(Memo.ud_me()));

  L_DatTim.CheckWMIntvl(L_DatTim.YearBeg(Memo.ud_cd()), Memo.ud_me());
  L_General.Assert(L_APtm.MonthIsClosed(Memo.ud_mb(), L_APtm.system_Salary), "   : "+L_DatTim.PeriodStr(Memo.ud_mb()));

  SELECT(Man, Name);
  WHILE OCCURE(Man) DO
   PROMPT(Man.Man);
   IF NeedMan() THEN
    IF L_Staff.IsStandOnMainContract(Man.Man, P_Firm.curMyFirm, Memo.ud_me()) THEN
     MakeCurrentStaff(0);
    END;
    FORMFEED(R);
   END;
   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)
  CLOSEREP(R);
 END {MakeAllStaff};

END.
