(*
%Copyright   (c) Polak Computer System
%Author      31.10.2001 20:49:20 BOR
%Purpose      
%Type        report
%Specific    SYS
%Modified    10.04.2012 12:30:20 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT Memo, L_General, L_OwnData, L_DatTim, L_PagePr, L_Staff, L_EC, L_AP, FIO,
        E_Utils, L_Str, L_StdFrm;

 CONST
  MtyIdxKTU = 90;

(*
$P{ RepTopB:
L_OwnData.ODFirmName(SYSDATE()), L, ""
Sort.Name, C, ""
L_DatTim.MonthStr(Memo.ud_mb(), 0), C, ""
Memo.ud_mb(), L, "y"
@
################################################################################### ଠ -13

                                                             
                                                             㪮⥫ 㦡

                                                             ________________________________

                                                             "_____" __________________ 200  

                                         
                            樥 㤮  童
##############################################################################################
                                     ######## #####.
}
*)

(*
$P{ PageTopB:
@
==============================================================================================
|N |, , ⢮     | ()     |. |    |᭮       |
}
*)

(*
$P{ LineB:
?, R, "0"
Man.Name, L, ""
Post.Name, L, ""
StaffLog.TSN, L, ""
@
|----|---------------------------|--------------------------|-----|-------|------------------|
|####|###########################|##########################|#####|       |                  |
}
*)

(*
$P{ FillingB:
@
|----|---------------------------|--------------------------|-----|-------|------------------|
|    |                           |                          |     |       |                  |
}
*)

(*
$P {PageBotB:
@
=(c) Polak====================================================================================
}
*)

(*
$P{ RepBotB:
@
=(c) Polak====================================================================================

㪮⥫  (⪠) ____________________________________

 ᮢ ਣ



}
*)

(*
$P{ TopR:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_mb(), L, "N.y"
@
############################################################# ########## #####
=#####========================================================================
|                        ।   #######                        |
}
*)

(*
$P{ SortTopR:
Sort.Sort, L, ""
Sort.Name, L, ""
@
|============================================================================|
|  ### ############################################################### |
|----------------------------------------------------------------------------|
}
*)

(*
$P{ LineR:
StaffLog.TSN, L, ""
Man.Name, L, ""
?, R, ""
@
|##### ########################################|               ##############|
}
*)

(*
$P{ BotR:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE _RprtTop(Mode: SCAL[20]);
 BEGIN
  IF Mode = L_PagePr.m_Print THEN
   MAKEPART(B, RepTopB);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtTop};

 PRIVATE PROCEDURE _PageTop(Mode: SCAL[20]);
 BEGIN
  IF (Mode = L_PagePr.m_Print) | (Mode = L_PagePr.m_RDoneTop) THEN
   MAKEPART(B, PageTopB);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageTop};

 PRIVATE PROCEDURE _PageBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(PageBotB));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(B, PageBotB);
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_None);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageBot};

 PRIVATE PROCEDURE _RprtBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(RepBotB));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(B, RepBotB);
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_Fill);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtBot};

 PRIVATE PROCEDURE _Filling(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(FillingB));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(B, FillingB);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_Filling};

 PRIVATE PROCEDURE E_NeedOfficer(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(SYSDATE(), PROCREF(E_Utils.TypeKTU_NeedOfficer), 1);
 END {NeedOfficer};

 PRIVATE PROCEDURE E_NeedKTU(_Sort: LIKE(Sort.Sort)): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Utils.TypeKTU_NeedKTU);
  IF ~!Local THEN
   RETURN Local(_Sort);
  ELSE
   RETURN SEARCH(SrMnthly, Sort, _Sort, Memo.ud_mb());
  END;
 END {E_NeedKTU};

 PRIVATE PROCEDURE FillKTU();
 BEGIN
  L_General.Assert(SEARCH(MtyIdx, MtyIdx, MtyIdxKTU), " ࠢ筨  ⥫ "+L_Str.IntStr(MtyIdxKTU));
  SELECT(Sort, Sort);
  WHILE OCCURE(Sort) DO
   PROMPT(Sort.Sort);
   IF E_NeedKTU(Sort.Sort) THEN
    SELECT(StaffLog, Sort, , Sort.Sort);
    WHILE OCCURE(StaffLog) DO
     PROMPT(Sort.Sort + " : " + StaffLog.TSN);
     IF ~L_Staff.IsDischargeStaffLog() &  L_Staff.OrderInMonth(Memo.ud_mb()) THEN
      CONFORM(StaffLog, Officer);
      IF E_NeedOfficer() THEN
       IF ~SEARCH(Monthly, TSN, StaffLog.TSN, Memo.ud_mb(), StaffLog.Date, L_AP.mthlWho_Staff, L_AP.mthlSrc_Operator, MtyIdxKTU) THEN
        SETEMPTY(Monthly.Monthly);
        Monthly.TSN   :=StaffLog.TSN;
        Monthly.Who   :=L_AP.mthlWho_Staff;
        Monthly.Period:=Memo.ud_mb();
        Monthly.MtyIdx:=MtyIdxKTU;
        Monthly.ODate :=StaffLog.Date;
        Monthly.Proof :=1.000;
        Monthly.Source:=L_AP.mthlSrc_Operator;
        INSERT(Monthly);
       END;
      END;
     END;
     NEXT(StaffLog);
    END; (* WHILE OCCURE(StaffLog)... *)
   END;
   NEXT(Sort);
  END; (* WHILE OCCURE(Sort)... *)
 END {FillKTU};

 PRIVATE PROCEDURE PrintKTU(RepName: STRING[]; Rep, Nul: STRING[]);
  VAR
   i: NUMERIC[0];
 BEGIN
  OPENREP(^Nul, FIO.MakePath(RepName, "Tmp", FIO.AsbSpecialFolders("ASBTemp")), Create);
  OPENREP(^Rep, L_General.NameConnection(RepName), Create);

  MAKEPART(R, TopR, RepName);
 
  SELECT(Sort, Sort);
  WHILE OCCURE(Sort) DO
   PROMPT(Sort.Sort);
   IF E_NeedKTU(Sort.Sort) THEN
    L_PagePr.PagePr_Init("B", 60, PROCREF(_RprtTop),
                                  PROCREF(_PageTop),
                                  PROCREF(_PageBot),
                                  PROCREF(_RprtBot),
                                  PROCREF(_Filling));
    MAKEPART(R, SortTopR);
    i:=0;
    SELECT(StaffLog, Sort, , Sort.Sort);
    WHILE OCCURE(StaffLog) DO
     PROMPT(Sort.Sort + " : " + StaffLog.TSN);
     IF ~L_Staff.IsDischargeStaffLog() &  L_Staff.OrderInMonth(Memo.ud_mb()) THEN
      CONFORM(StaffLog, Officer);
      IF E_NeedOfficer() THEN
       INC(i);
       CONFORM(Officer, Post);
       CONFORM(StaffLog, Staff);
       CONFORM(Staff, Man);
       L_PagePr.PagePr_BeforePrintLine(DEPTH("LineB"));
       MAKEPART(B, LineB, i);
       IF SEARCH(Monthly, TSN, StaffLog.TSN, Memo.ud_mb(), StaffLog.Date, L_AP.mthlWho_Staff, L_AP.mthlSrc_Operator, MtyIdxKTU) THEN
        MAKEPART(R, LineR, FLDTOSTR(Monthly.Proof, "3."));
       ELSE
        MAKEPART(R, LineR, "!?!");
       END;
      END;
     END;
     NEXT(StaffLog);
    END; (* WHILE OCCURE(StaffLog)... *)
    L_PagePr.PagePr_Done();
   END;
   NEXT(Sort);
  END; (* WHILE OCCURE(Sort)... *)
  MAKEPART(R, BotR);
 
  CLOSEREP(^Nul);
  CLOSEREP(^Rep);
 END {PrintKTU};

BEGIN
 IF    MODE = 100 THEN
  PrintKTU("TpKTU", "R", "B");
 ELSIF MODE = 101 THEN
  PrintKTU("TbKTU", "B", "R");
 ELSIF MODE = 102 THEN
  L_StdFrm.JustQuestion("  = 1  " + L_DatTim.PeriodStr(Memo.ud_mb()));
  FillKTU();
 ELSIF MODE = 103 THEN
  L_StdFrm.OrdinaryCHOICE(" ᢥ   (⮫쪮 祭, ࠢ )");
  IF SELECT(Monthly, MtyIdx, MtyIdxKTU, Memo.ud_mb()) THEN
   INTEGRITY(NoAsk);
   WHILE OCCURE(Monthly) DO
    PROMPT("⪠: " + Monthly.TSN);
    IF (Monthly.Source = L_AP.mthlSrc_Operator) & (Monthly.Proof = 1) THEN
     REMOVE(Monthly);
    ELSE
     NEXT(Monthly);
    END;
   END; (* WHILE *)
   INTEGRITY(Off);
  END;
 ELSE
  L_General.BadMode(MODE);
 END;
END.
