(*
%Copyright   (c) Polak Computer System
%Author      14.03.2003 13:39:09 POLAK\GAV
%Purpose     ᮪ 童 
%Type        report
%Specific    LOC
%Modified    26.03.2013 09:29:31 POLAK\MLB
%Environment
*)

 MODULE TrdUn [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT FIO, Memo, L_General, P_Firm, P_Man, L_Staff, L_DatTim, L_PRoll, L_Basis, L_Man, L_bp;

 PRIVATE PROCEDURE MakeTop(F: STRING[]);
 BEGIN
  IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ஦");
  L_Basis.wb_WrInQM(F, "㦡");
  L_Basis.wb_WrInQM(F, "㦡");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⑥");
  L_Basis.wb_WrInQM(F, "℠");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "ঠᮢ");
  L_Basis.wb_TermLine(F);
 END {MakeTop};

 PRIVATE PROCEDURE MakeLine(F: STRING[]; D: DATE);
 BEGIN
  IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
   CONFORM(Staff, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrDat(F, Man.Birth);
  L_Basis.wb_WrScl(F, L_Staff.getService());
  L_Basis.wb_WrStr(F, L_Staff.getServiceName());
  L_Basis.wb_WrScl(F, L_Staff.getDepart());
  L_Basis.wb_WrStr(F, L_Staff.getDepartName());
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrStr(F, L_Man.GetManSex_asStr());
  L_Basis.wb_WrScl(F, Union.Union);
  L_Basis.wb_WrStr(F, Union.Name);
  L_Basis.wb_WrScl(F, Post.Post);
  L_Basis.wb_WrStr(F, Post.Name);
  IF P_Man.HasActualManPro(Staff.Man, D, P_Man.P_TradeUnionMember) THEN
   L_Basis.wb_WrNum(F, 1, 0);
   L_Basis.wb_WrStr(F, ManPro.DocNum);
   L_Basis.wb_WrDat(F, ManPro.DocGiveD);
   L_Basis.wb_WrStr(F, ManPro.DocGiveS);
  ELSE
   L_Basis.wb_WrNum(F, 0, 0);
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_WrNum(F, L_PRoll.HasTradeUnionDeduct(Staff.TSN, D), 0);
  L_Basis.wb_TermLine(F);
 END {MakeLine};

 PUBLIC PROCEDURE TrdUn();
  CONST
   bpId = "TrdUn";
  VAR
   OnDate: DATE;
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_bp.Begin(bpId, "⢮  ", L_bp.t_Basis, L_General.tc_onDate);
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);

  OnDate :=Memo.ud_cd();
  MakeTop("F");
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   IF L_Staff.rInState(OnDate) & L_Staff.IsMainForTax(OnDate) THEN
    CONFORM(Staff, Man);
    CONFORM(StaffLog, Officer);
    CONFORM(Officer, Post);
    CONFORM(Officer, Sort);
    CONFORM(Officer, Union);
    MakeLine("F", OnDate);
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  FIO.Close(F);
  L_bp.End();
 END {TrdUn};

END.
