(*
%Copyright   (c) Polak IT
%Author      11.09.2012 19:27:49 POLAK\Gina
%Purpose     ⪠  Money ஢  ॢ ਮ
%Type        operation
%Specific    SYS
%Modified    31.05.2013 18:25:15 POLAK\GAV
%Environment
*)

 MODULE U_Sal [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_PRoll, L_DatTim, L_General, L_APtm, L_StdFrm, Memo, L_OwnData;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_mb(), L, "N.y"
?, L, "N.y"
@
################################################################################### ########## #####
=#####==============================================================================================
|        ⮪ 㤠 ᥩ   ⮢  #######  ਮ #######  ࠭        |
|--------------------------------------------------------------------------------------------------|
|. |  | ਮ|/       | ਮ|                |筨   |   ६|      㬬|
|-----|-------|----------|----------|---------|-------------------|-----------|--------|-----------|
}
*)

(*
$P{ Line:
Money.TSN, L, ""
Money.Closed, L, "N.y"
Money.WFPeriod, L, "N.y"
Money.ODate, L, "D.N.y"
Money.Period, L, "N.y"
MCList.MCode, L, ""
MCList.Name, L, ""
Money.Source, L, L_PRoll.src_Pool
Money.Tim, R, "3."
Money.Sum, R, "2-"
@
|#####|#######|#######   |##########|#######  |### ###############|###########|########|###########|
}
*)

(*
$P{ Bot:
@
=(c) Polak==========================================================================================
}
*)

 PUBLIC PROCEDURE ClearMoney();
  CONST
   RepName = "ClrMn";
  VAR
   OldPer: DATE;
 BEGIN
  L_General.SilentPrgsOnly();
  OldPer:=L_DatTim.IncMonth(Memo.ud_mb(), -6);
  STDFORM(L_StdFrm.sf_Choice("| ஢     "+L_DatTim.PeriodStr(Memo.ud_mb())+
                             "||  ਮ %#######%  ࠭|",
                             "%<N.y>I"),
          "⪠ ", STOP, , OldPer);
  IF OldPer > L_DatTim.IncMonth(Memo.ud_mb(), -6) THEN
   L_StdFrm.Choice(" ஢ ' ਮ'  㣮 ?  ᢥ ஢,  㢥७?");
  END;
  L_StdFrm.CrucialChoice("   " + L_DatTim.PeriodStr(Memo.ud_mb()) +
                         " ஢  " + L_DatTim.PeriodStr(OldPer) +"  ࠭", L_APtm.g_APSupport);
 
  L_General.Assert(~L_APtm.MonthIsClosed(Memo.ud_mb(), L_APtm.system_Salary), " !");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, OldPer);
 
  SELECT(Money, TSN);
  WHILE OCCURE(Money) DO
   PROMPT(Money.TSN);
   NARROWSEL(Money, TSN);
   SRCINSEL(Money, GE, , Memo.ud_mb());
   WHILE OCCURE(Money) DO
    NARROWSEL(Money, Closed);
    WHILE OCCURE(Money) & (Money.WFPeriod <= OldPer) DO
     PROMPT(Money.TSN+": 㤠 ஢  "+L_DatTim.PeriodStr(Money.WFPeriod));
     CONFORM(Money, Staff);
     CONFORM(Money, MCList);
     MAKEPART(R, Line);
     L_PRoll.Remove_Money(1);
     L_PRoll.ShtDone(0);
    END;
    NEXTINEXTENDEDSEL(Money, Closed);
   END; (* WHILE OCCURE(File) *)
   NEXTINEXTENDEDSEL(Money, TSN);
  END; (* WHILE OCCURE(Money) *)
 
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {ClearMoney};

END.