(*
%Copyright   (c) Polak Computer System
%Author      14.12.2000 19:33:20 BOR
%Purpose       ᯮ짮  
%Type        report
%Specific    SYS
%Modified    10.04.2012 12:31:00 ROBOT by POLAK\LDA
%Environment MODE = 100 -  ⮤  
%Environment MODE = 101 -  ⮤   
%Environment MODE = 102 -  㤥ঠ  
%Environment MODE = 103 -  㤥ঠ   
*)

 IMPORT Memo, L_General, L_OwnData, L_DatTim, L_AFM, L_Str, L_StdFrm;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
"ᯮ짮   "+MCList.MCode+" "+MCList.Name, C, ""
?, C, ""
@
################################################################### ########## #####
=#####==============================================================================
|##################################################################################|
|##################################################################################|
|----------------------------------------------------------------------------------|
}

$P{ SubTop1:
@
|⮤                                ||      |     |ࠢ         |    |
}

$P{ Dlm1:
@
|-------------------------------------|--|-------|-------|----------------|--------|
}

$P{ Line1:
MoneyMth.Method, L, ""
MoneyMth.Name, L, ""
MoneyMth.MthType, L, ""
MMthLog.Date, L, "N.y"
MMthLog.Till, L, "N.y"
MoneyRul.Rule, L, ""
MoneyRul.Number, R, "3."
@
|#### ################################|##|#######|#######|################|########|
}     

$P{ SubTop2:
@
|⭨                   | |         |        | 㤥ঠ                |
|---------------------------|--|----------|----------|-----------------------------|
}

$P{ Line2:
Deduct.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
Deduct.DedNbr, L, ""
Deduct.BegDate, L, "D.N.y"
Deduct.EndDate, L, "D.N.y"
Deduct.DedType, L, ""
DedType.Name, L, ""
@
|##### #####################|##|##########|##########|## ##########################|
}     

$P{ SubTop3:
@
|筨                                |  |ਪ                           |
|----------------------------------------|-------|---------------------------------|
}

$P{ Line3:
FOrder.EDOSrc, L, ""
EDOSrc.Name, L, ""
FOrder.Closed, L, "N.y"
FOrder.FOrder, L, ""
FOrder.Name, L, ""
FOrder.Date, L, "D.N.y"
@
|## #####################################|#######|##### ################ ##########|
}     

$P{ Bot:
@
=(c) Polak==========================================================================
}
*)

 PRIVATE PROCEDURE AccessMCList();
 BEGIN
  L_General.Assert(ACCESS(MCList), " ⠭ ⥪騩  ");
 END {AccessMCList};

 PRIVATE PROCEDURE NeedAllHistory(OnDateStr, Title: STRING[]): SCAL[2];
 BEGIN
  RETURN L_StdFrm.ShowListAsMenu(OnDateStr + "| ", Title);
 END {NeedAllHistory};

 PRIVATE PROCEDURE WMCd0();
  CONST
   RepName = "WMCd0";
  VAR
   OnDate: DATE;
   Total : SCAL[2];
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  AccessMCList();
  OnDate:=Memo.ud_cd();
  Total :=NeedAllHistory("  (" + L_DatTim.DateStr(OnDate) + ")" ,
                         " ᯮ짮    ⮤ ");

  L_AFM.MakeMultipleIndex("WhMC", "Method: LIKE(MoneyRul.Method);" +
                                  "Date  : LIKE(MoneyRul.Date);" +
                                  "SeqNbr: LIKE(MoneyRul.SeqNbr)",
                          "WhMC: Method, Date, SeqNbr");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  IF Total THEN
   MAKEPART(R, Top, RepName, " ⮤   ");
  ELSE
   MAKEPART(R, Top, RepName, " ⮤  " + L_DatTim.DateStr(OnDate));
  END;
  MAKEPART(R, SubTop1);
 
  SELECT(MoneyRul, MCode, , MCList.MCode);
  WHILE OCCURE(MoneyRul) DO
   PROMPT(MoneyRul.Method);
   CONFORM(MoneyRul, MMthLog);
   CONFORM(MMthLog, MoneyMth);
   IF Total | L_DatTim.IsActive(OnDate, MMthLog.Date, MMthLog.Till) THEN
    ADD(WhMC, WhMC, , MoneyRul.Method, MoneyRul.Date, MoneyRul.SeqNbr);
   END;
   NEXT(MoneyRul);
  END; (* WHILE OCCURE(MoneyRul)... *)
 
  SELECT(WhMC, WhMC);
  WHILE OCCURE(WhMC) DO
   MAKEPART(R, Dlm1);
   NARROWSEL(WhMC, Method);
   WHILE OCCURE(WhMC) DO
    SEARCH(MoneyRul, MoneyMth, , WhMC.Method, WhMC.Date, WhMC.SeqNbr);
    CONFORM(MoneyRul, MMthLog);
    CONFORM(MMthLog, MoneyMth);
    MAKEPART(R, Line1);
    NEXT(WhMC);
   END; (* WHILE OCCURE(WhMC) ... *)
   NEXTINEXTENDEDSEL(WhMC, Method);
  END; (* WHILE OCCURE(WhMC) ... *)
 
  MAKEPART(R, Bot);
 END {WMCd0};

 PRIVATE PROCEDURE WMCd1();
  CONST
   RepName = "WMCd1";
  VAR
   OnDate: DATE;
   Total : SCAL[2];
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  AccessMCList();
  OnDate:=Memo.ud_cd();
  Total :=NeedAllHistory("  (" + L_DatTim.DateStr(OnDate) + ")",
                         " ᯮ짮    㤥ঠ ");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  IF Total THEN
   MAKEPART(R, Top, RepName, " 㤥ঠ   ");
  ELSE
   MAKEPART(R, Top, RepName, " 㤥ঠ  " + L_DatTim.DateStr(OnDate));
  END;
  MAKEPART(R, SubTop2);
  SELECT(Deduct, MCode, , MCList.MCode);
  WHILE OCCURE(Deduct) DO
   PROMPT(Deduct.TSN);
   IF Total | L_DatTim.IsActive_Inc(OnDate, Deduct.BegDate, Deduct.EndDate) THEN
    CONFORM(Deduct, Man);
    CONFORM(Deduct, DedType);
    MAKEPART(R, Line2);
   END;
   NEXT(Deduct);
  END; (* WHILE OCCURE(Deduct) ... *)
  MAKEPART(R, Bot);
 END {WMCd1};

 PRIVATE PROCEDURE WMCd2();
  CONST
   RepName = "WMCd2";
  VAR
   Total: SCAL[2];
   From,
   UpTo : DATE;
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  AccessMCList();
  From:=Memo.ud_fr();
  UpTo:=Memo.ud_ut();
  Total:=NeedAllHistory(" ਮ  " + L_DatTim.PeriodStr(From) + "  " + L_DatTim.PeriodStr(UpTo),
                        " ᯮ짮    ਪ ");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  IF Total THEN
   MAKEPART(R, Top, RepName, " ਪ   ");
  ELSE
   L_DatTim.CheckWMIntvl(From, UpTo);
   MAKEPART(R, Top, RepName, " ਪ  ਮ  " + L_DatTim.PeriodStr(From) +
                                                "  " + L_DatTim.PeriodStr(UpTo));
  END;
  MAKEPART(R, SubTop3);
  SELECT(FOrder, FOMCode);
  WHILE OCCURE(FOrder) DO
   NARROWSEL(FOrder, EDOSrc);
   CONFORM(FOrder, EDOSrc);
   IF ~Total THEN
    SRCINSEL(FOrder, GE, , From);
   END;
   WHILE OCCURE(FOrder) & (Total | (FOrder.Closed <= UpTo)) DO
    NARROWSEL(FOrder, Closed);
    IF SRCINSEL(FOrder, EQ, MCList.MCode) THEN
     NARROWSEL(FOrder, MCode);
     WHILE OCCURE(FOrder) DO
      PROMPT(FOrder.FOrder);
      MAKEPART(R, Line3);
      NEXT(FOrder);
     END; (* WHILE OCCURE(FOrder) ... *)
     NEXTINEXTENDEDSEL(FOrder, MCode);
    END;
    NEXTINEXTENDEDSEL(FOrder, Closed);
   END; (* WHILE OCCURE(FOrder) ... *)
   NEXTINEXTENDEDSEL(FOrder, EDOSrc);
  END; (* WHILE OCCURE(FOrder) ... *)
  MAKEPART(R, Bot);
 END {WMCd2};

END.
