(*
%Copyright   (c) Polak Computer System
%Author      04.05.2001 15:15:53 BOR
%Purpose     ஫ 䨪樨 XObject
%Type        control
%Specific    SYS
%Modified    22.09.2014 18:28:43 POLAK\San
%Environment
*)

 MODULE XObject [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PRIVATE PROCEDURE XObject_OnInitializeWindow();
 BEGIN
  L_WDO.iField       (1, "XObject.Origin").Format:=L_XObj.o_Pool;
  L_WDO.iSubwindow   (1, "XObjectE");
 END {XObject_OnInitializeWindow};

 PRIVATE PROCEDURE XObjectE_0_OnReposition();
 BEGIN
  RTI.Get().CurZone.Fields("ObjName").Value:=L_XObj.GetXObjectOriginName();
 END {XObjectE_0_OnReposition};

 PRIVATE PROCEDURE XObjectE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnReposition]);
  L_WDO.iZone        (0).ViewOnly:=1;
  L_WDO.iField       (0, "ObjName").LineBreakEnable:=1;
 END {XObjectE_OnInitializeWindow};

(*
$P{ xdapr_Top:
P_Firm.MyFirmName(XObject.MyFirm, SYSDATE()), L, ""
SYSDATE(), L, <D.N.y>
SYSTIME(), L, <H:M>
?, L, ""
XObject.XObject + " " + L_XObj.GetXObjectOriginName(), L, ""
AcCut.AcCut   + " " + AcCut.Name, L, ""
Apport.Apport + " " + Apport.Name, L, ""
AcCut2.AcCut2 + " " + AcCut2.Name, L, ""
XApport.XDat, L, <N.y>
XApport.WFDate, L, <N.y>
XApport.Source, L, L_XObj.src_Pool
@
############################################################################################# ########## #####
=#####========================================================================================================
|                                           ⠢                                             |
|------------------------------------------------------------------------------------------------------------|
|ꥪ                    ##################################################################################|
|१                    ##################################################################################|
|ᯮ           ##################################################################################|
|ᯮ騩 ࠧ१  ##################################################################################|
|ਮ                    #######                                                                           |
|                        #######                                                                           |
|筨                  ####################################################                              |
|------------------------------------------------------------------------------------------------------------|
|㬥                                                          |         ⢮|                㬬|
|------------------------------------------------------------------|-------------------|---------------------|
}
*)

(*
$P{ xdapr_Line:
?, L, ""
?, R, "3."
?, R, "2-"
@
|##################################################################|###################|#####################|
}
*)

(*
$P{ xdapr_Bot:
XApport.Qnt, R, <3.>
XApport.Sum, R, <2->
@
|------------------------------------------------------------------|-------------------|---------------------|
|⮣                                                             |###################|#####################|
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE xdapr_DoIt(leftSide: SCAL[2];
                      VAR tQnt: L_XObj.tQnt;
                      VAR tSum: L_XObj.tSum);
  VAR
   _Qnt: L_XObj.tQnt;
 BEGIN
  L_XObj.SelectXDocAprByXApport(leftSide);
  WHILE OCCURE(XDocApr) DO
   L_XDoc.PositionOnXDoc(XDocApr.XDocId);
   PROMPT(L_XDoc.XDocStr(XDocApr.XDocId));
   IF leftSide THEN
    _Qnt:=XDocApr.Qnt*(XDocApr.wQnt MOD 2);
   ELSE
    _Qnt:=XDocApr.Qnt*(XDocApr.wQnt DIV 2);
   END;
   L_XDoc.sl_AddItem(XDocApr.XDocId,
                     L_XDoc.extXDocStr(XDocApr.XDocId, L_XDoc.xdast_wDate) +
                      FLDTOSTR(       _Qnt, "2.", 20) +
                      FLDTOSTR(XDocApr.Sum, "2-", 20));
   MAKEPART(R, xdapr_Line, L_XDoc.extXDocStr(XDocApr.XDocId, L_XDoc.xdast_wStatus),
                           _Qnt, XDocApr.Sum);
   INC(tQnt,        _Qnt);
   INC(tSum, XDocApr.Sum);
   NEXT(XDocApr);
  END; (* WHILE OCCURE(XDocApr) ... *)
 END {xdapr_DoIt};

 PUBLIC PROCEDURE ShowXDocAprByXApport();
  CONST
   RepName = "XDApr";
  VAR
   tQnt: L_XObj.tQnt;
   tSum: L_XObj.tSum;
 BEGIN
  L_General.Assert(ACCESS(XApport), " ⠭ ⥪   '   '");
  IF L_Acnt.E_DoXDocAprOfSpecifiedSource(XApport.WFDate, XApport.Source) | (XApport.Source = L_XObj.src_MathRevision) THEN
   CONFORM(XApport, XObject);
   CONFORM(XApport, AcCut);
   CONFORM(XApport, AcCut2);
   CONFORM(XApport, Apport);
   OPENREP(R, L_General.NameConnection(RepName), Create);
   MAKEPART(R, xdapr_Top, RepName);
   SETZERO(tQnt, tSum);
   L_XDoc.sl_Init("㬥  ");
   xdapr_DoIt(1, tQnt, tSum);
   xdapr_DoIt(0, tQnt, tSum);
   IF (Apport.CirKind = L_Acnt.ck_MoneyOnly) | (Apport.CirKind = L_Acnt.ck_ExplicitCir) THEN
    IF tSum # XApport.Sum THEN
     IF ~L_General.IsProgrammer() THEN
      L_General.CallUs(0);
     ELSE
      MAKEPART(R, xdapr_Line, " 㬥⠬!", tQnt, tSum);
     END;
    END;
   END;
   L_General.CallUs(tQnt = XApport.Qnt);
   MAKEPART(R, xdapr_Bot);
   CLOSEREP(R);
   L_XDoc.sl_Done();
  ELSE
   L_StdFrm.Inform("  ஡   ⠪ 筨");
  END;
 END {ShowXDocAprByXApport};

BEGIN
 L_Events.ExecuteHandler();
END.
