(*
%Copyright   (c) Polak IT
%Author      02.12.2002 12:05:12 POLAK\LDA
%Purpose     ᮪ ࠡ⭨  ⥪騬 ⨯ 㤥ঠ.
%Type        report
%Specific    SYS
%Modified    10.04.2012 12:16:45 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_OwnData, L_DatTim, L_AFM, L_Staff, L_Str, Memo;

 CONST
  rt_byDay     = 0;
  rt_byPer     = 1;
  rt_byAllHist = 2;

  rf_ByDedType = 1;
  rf_ByFirm    = 2;

 VAR
  RepForm,
  RepType : SCAL[3];
  RepName : STRING[];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
DedType.DedType, L, ""
DedType.Name, L, ""
?, C, ""
@
################################################################# ########## #####
=#####============================================================================
|⭨, 騥 㤥ঠ ## ################################################|
|################################################################################|
|--------------------------------------------------------------------------------|
|  |              |            |ਭ||N|/|砫|.|
|-----|-----------------|---------------------|------|------|--|---|------|------|
}
*)

(*
$P{ Line:
Tmp.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
Tmp.Post, L, ""
Post.Name, L, ""
Staff.BegDate, L, "DNY"
Staff.EndDate, L, "DNY"
Tmp.DedNbr, L, ""
Tmp.MCode, L, ""
Tmp.BegDate, L, "DNY"
Tmp.EndDate, L, "DNY"
@
|#####|#################|### #################|######|######|##|###|######|######|
}
*)

(*
$P{ Bot:
@
=(c) Polak========================================================================
}
*)

(*
$P{ Top1:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Firm.Firm, L, ""
Firm.Name, L, ""
?, C, ""
@
###################################################################### ########## #####
=#####=================================================================================
|⭨, 騥 㤥ঠ १ ࠣ #### #################################|
|#####################################################################################|
|-------------------------------------------------------------------------------------|
|  |              |            |ਭ||N|/|砫|.|||
|-----|-----------------|---------------------|------|------|--|---|------|------|--|-|
}
*)

(*
$P{ Line1:
Tmp.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
Tmp.Post, L, ""
Post.Name, L, ""
Staff.BegDate, L, "DNY"
Staff.EndDate, L, "DNY"
Tmp.DedNbr, L, ""
Tmp.MCode, L, ""
Tmp.BegDate, L, "DNY"
Tmp.EndDate, L, "DNY"
Deduct.FirmAcnt, L, ""
?, L, " |!"
@
|#####|#################|### #################|######|######|##|###|######|######|##|#|
}
*)

(*
$P{ Bot1:
@
=(c) Polak=============================================================================
}
*)

 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CreateFILE(Tmp, "", "६ 䠩", "");

  CreateFIELD(Tmp, TSN, LIKE(Staff.TSN), "", "", "", ".", "");
  CreateFIELD(Tmp, Post, LIKE(Post.Post), "", "", "", "", "");
  CreateFIELD(Tmp, MCode, LIKE(MCList.MCode), "", "", "", " /", "");
  CreateFIELD(Tmp, DedNbr, LIKE(Deduct.DedNbr), "", "", "", "", "");
  CreateFIELD(Tmp, BegDate, DATE, "", "", "", " 砫 믫", "");
  CreateFIELD(Tmp, EndDate, DATE, "", "", "", " 砭 믫", "");

  CreateINDEXandLINK(Tmp, Post, PLURAL, Post, Post, USER, "", "", Post);
  CreateINDEXandLINK(Tmp, TSN, PLURAL, Staff, TSN, USER,"", "", TSN, DedNbr, MCode);

  SetVersionOfFILE(Tmp, 0);
  L_AFM.AF_CreateTemp("Tmp", "Tmp");
 END {Create_Tmp};

 PRIVATE PROCEDURE GetRepTitle(): STRING[];
 BEGIN
  IF    RepType = rt_byDay THEN
   RETURN " "+L_DatTim.DateStr(Memo.tmp_cd());
  ELSIF RepType = rt_byPer THEN
   RETURN " ਮ  " + L_DatTim.DateStr(Memo.From()) + "  " + L_DatTim.DateStr(Memo.UpTo());
  ELSIF RepType = rt_byAllHist THEN
   RETURN "  ";
  ELSE
   L_General.Error("GetRepTitle: Error 21");
  END;
 END {GetRepTitle};

 PRIVATE PROCEDURE CondPutInFile(): SCAL[2];
 BEGIN
  CONFORM(Deduct, Staff);
  IF    RepType = rt_byDay THEN
   RETURN L_Staff.rInState(Memo.tmp_cd()) &
          L_DatTim.IsActive_Inc(Memo.tmp_cd(), Deduct.BegDate, Deduct.EndDate);
  ELSIF RepType = rt_byPer THEN
   IF ~L_DatTim.IsActiveInIntvl_Inc(Memo.From(), Memo.UpTo(), Staff.BegDate, Staff.EndDate) THEN
    RETURN 0;
   END;
   L_Staff.PosToStaffLog(Staff.TSN, Memo.UpTo(), 1);
   RETURN L_Staff.OrderInIntvl(Memo.From(), Memo.UpTo()) &
          L_DatTim.IsActiveInIntvl_Inc(Memo.From(), Memo.UpTo(), Deduct.BegDate, Deduct.EndDate);
  ELSE
   L_Staff.PosToStaffLog(Staff.TSN, SYSDATE(), 1);
   RETURN 1;
  END;
 END {CondPutInFile};

 PRIVATE PROCEDURE Make();
 BEGIN
  IF    RepForm = rf_ByDedType THEN
   SELECT(Deduct, DedType, , DedType.DedType);
  ELSIF RepForm = rf_ByFirm    THEN
   SELECT(Deduct, FirmAcnt, , Firm.Firm);
  END;
  WHILE OCCURE(Deduct) DO
   PROMPT(Deduct.MCode + " " + Deduct.TSN);
   IF CondPutInFile() THEN
    CONFORM(StaffLog, Officer);
    Tmp.TSN    :=Deduct.TSN;
    Tmp.Post   :=Officer.Post;
    Tmp.DedNbr :=Deduct.DedNbr;
    Tmp.MCode  :=Deduct.MCode;
    Tmp.BegDate:=Deduct.BegDate;
    Tmp.EndDate:=Deduct.EndDate;
    INSERT(Tmp);
   END;
   NEXT(Deduct);
  END; (* WHILE OCCURE(Deduct) ... *)
 END {Make};

 PRIVATE PROCEDURE FirmAcntNotActive(): SCAL[2];
 BEGIN
  IF ~!Deduct.FirmAcnt THEN
   CONFORM(Deduct, FirmAcnt);
   IF RepType = rt_byDay THEN
    RETURN ~L_DatTim.IsActive(Memo.tmp_cd(), FirmAcnt.Begin, FirmAcnt.Till);
   ELSIF RepType = rt_byPer THEN
    RETURN ~L_DatTim.IsActiveInIntvl(Memo.From(), Memo.UpTo(),
                                     FirmAcnt.Begin, FirmAcnt.Till);
   END;
  END;
  RETURN 0;
 END {FirmAcntNotActive};

 PRIVATE PROCEDURE PrintRep();
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create);
  IF    RepForm = rf_ByDedType THEN
   MAKEPART(R, Top, GetRepTitle());
  ELSIF RepForm = rf_ByFirm    THEN
   MAKEPART(R, Top1, GetRepTitle());
  END;
  SELECT(Tmp, TSN);
  WHILE OCCURE(Tmp) DO
   PROMPT(" " + Tmp.TSN);
   CONFORM(Tmp, Staff);
   CONFORM(Staff, Man);
   CONFORM(Tmp, Post);
   IF    RepForm = rf_ByDedType THEN
    MAKEPART(R, Line);
   ELSIF RepForm = rf_ByFirm    THEN
    SEARCH(Deduct, TSN, , Tmp.TSN, Tmp.DedNbr);
    MAKEPART(R, Line1, FirmAcntNotActive());
   END;
   NEXT(Tmp);
  END; (* WHILE OCCURE(Tmp) ... *)
  IF    RepForm = rf_ByDedType THEN
   MAKEPART(R, Bot);
  ELSIF RepForm = rf_ByFirm    THEN
   MAKEPART(R, Bot1);
  END;
 END {PrintRep};

 PRIVATE PROCEDURE MakeAnyRep();
 BEGIN
  IF    RepForm = rf_ByDedType THEN
   L_General.Assert(ACCESS(DedType), " ࠭ ⨯ 㤥ঠ");
   RepName:="CDedT";
  ELSIF RepForm = rf_ByFirm    THEN
   L_General.Assert(ACCESS(Firm), " ࠭ ࠣ");
   RepName:="CDedF";
  ELSE
   L_General.CallUs(0);
  END;
  Create_Tmp();
  Make();
  PrintRep();
  L_AFM.AF_PurgeTemp("Tmp");
  LIKEMENU(Survey, "");
 END {MakeAnyRep};

 PUBLIC PROCEDURE MakeRepByDay_ByDedType();
 BEGIN
  RepForm:=rf_ByDedType;
  RepType:=rt_byDay;
  MakeAnyRep();
 END {MakeRepByDay_ByDedType};

 PUBLIC PROCEDURE MakeRepByPer_ByDedType();
 BEGIN
  RepForm:=rf_ByDedType;
  RepType:=rt_byPer;
  MakeAnyRep();
 END {MakeRepByPer_ByDedType};

 PUBLIC PROCEDURE MakeRepByAllHistory_ByDedType();
 BEGIN
  RepForm:=rf_ByDedType;
  RepType:=rt_byAllHist;
  MakeAnyRep();
 END {MakeRepByAllHistory_ByDedType};

 PUBLIC PROCEDURE MakeRepByPer_ByFirm();
 BEGIN
  RepForm:=rf_ByFirm;
  RepType:=rt_byPer;
  MakeAnyRep();
 END {MakeRepByPer_ByFirm};

BEGIN
END.
