(*
%Copyright   (c) Polak Computer System
%Author      04.04.2000 19:17:00 SAN (FRM)
%Author      10.11.2002 17:01:23 POLAK\GAV
%Specific    SYS
%Modified    10.04.2012 12:16:50 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT Memo,  L_General, L_Str, L_OwnData, L_EDO, L_DatTim;

 CONST
  RepName = "C_EDK";

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_fr(), L, "N.y"
Memo.ud_ut(), L, "N.y"
EDOKind.EDOKind + " " + EDOKind.Name, C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|                          祭 ਪ  ਮ  #######  #######                            |
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|⭨                            |  | ᮡ. | 筮   |    㬬|業|     | ਪ.|
|------------------------------------|-------|----------|---------------|---------|-------|-------|----------|
}
*)

PRIVATE PROCEDURE ConvZeroToEmpty(Value: NUMERIC[2]; Format: STRING[]): STRING[];
BEGIN
 IF Value # 0 THEN
  RETURN FLDTOSTR(Value, Format);
 ELSE
  RETURN "";
 END;
END {ConvZeroToEmpty};

(*
$P{ Line:
EDOrderL.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
EDOrderL.Closed, L, "N.y"
EDOrderL.OcrDate, L, "D.N.y"
L_EDO.GetFixInPC_byStr(EDOKind.EDOGrp, EDOrderL.FixInPC), L, ""
ConvZeroToEmpty(EDOrderL.BySum, "2-"), R, ""
ConvZeroToEmpty(EDOrderL.ByPrc, "2."), R, ""
EDOrderL.EDOrder, L, ""
EDOrder.Date, L, "D.N.y"
@
|##### ##############################|#######|##########|###############|#########|#######|#######|##########|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE Make();
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_General.Assert(ACCESS(EDOKind), " ⠭  ਪ");
  L_DatTim.CheckWMIntvl(Memo.ud_fr(), Memo.ud_ut());
 
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top);
  SELECT(EDOrderL, TSN);
  WHILE OCCURE(EDOrderL) DO
   PROMPT(EDOrderL.TSN);
   NARROWSEL(EDOrderL, TSN);
   SRCINSEL(EDOrderL, GE, , Memo.ud_fr());
   WHILE OCCURE(EDOrderL) & (EDOrderL.Closed <= Memo.ud_ut()) DO
    PROMPT(EDOrderL.TSN);
    NARROWSEL(EDOrderL, Closed);
    IF SRCINSEL(EDOrderL, EQ, EDOKind.EDOKind) THEN
     CONFORM(EDOrderL, Man);
     WHILE OCCURE(EDOrderL) & (EDOrderL.EDOKind = EDOKind.EDOKind) DO
      CONFORM(EDOrderL, EDOrder);
      MAKEPART(R, Line);
      NEXT(EDOrderL);
     END; (* WHILE OCCURE(EDOrderL) ... *)
    END;
    NEXTINEXTENDEDSEL(EDOrderL, Closed);
   END; (* WHILE OCCURE(EDOrderL) ... *)
   NEXTINEXTENDEDSEL(EDOrderL, TSN);
  END; (* WHILE OCCURE(EDOrderL) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
 END {Make};

BEGIN
 IF MODE = 100 THEN
  Make();
 ELSE
  L_General.BadMode(MODE);
 END;
END.
