(*
%Copyright   (c) Polak IT
%Author      10.02.2003 17:10:49 POLAK\LDA
%Purpose       ࠭ᯮ⭮ 
%Type        report
%Specific    SYS
%Modified    05.09.2014 10:36:19 POLAK\LDA
%Environment
*)

 MODULE XOMN7 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Str, Math, L_General, L_MSO, L_Car, L_AFM, L_Env, L_DatTim, P_Car,
        L_Str, L_OwnData, P_Firm, P_Math, E_Way, L_Packet,
        DBD, L_EC, L_OTx, L_StdFrm, L_Russia;

 PRIVATE CONST
  rn_BnfCarList = "BnfCr";
  rn_BnfTaxSum  = "BnfSm";
  rn_BadCar     = "BadCr";

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
rn_BnfCarList, L, ""
?, L, "N.y"
?, L, "N.y"
@
####################################################################################################### ########## #####
=#####==================================================================================================================
|                               ᮪ , ᢮  㯫 ࠭ᯮ⭮                                 |
|                                             ਮ  #######  #######                                            |
|----------------------------------------------------------------------------------------------------------------------|
|.|.  | ॢ                      |᭮                                                         |
}
*)

(*
$P{ Dlm:
@
|----|----------|-----------------------------------|------------------------------------------------------------------|
}
*)

(*
$P{ Line:
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
|####|##########|###################################|##################################################################|
}
*)

(*
$P{ Bot:
@
=(c) Polak==============================================================================================================
}
*)

(*
$P{ BadTop:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
rn_BadCar, L, ""
@
#############################################################                                 ########## #####
=#####========================================================================================================
|                        ᮪ ,  祭    ࠭ᯮ⭮                        |
|------------------------------------------------------------------------------------------------------------|
|.|ઠ                       |      |稭                                                        |
|----|----------------------------|----------|---------------------------------------------------------------|
}
*)

(*
$P{ BadLine:
Car.BoxNbr, L, ""
Mark.Mark, L , ""
Mark.Name, L , ""
CarLog.Date, L, "D.N.y"
?, L, ""
@
|####|#### #######################|##########|###############################################################|
}
*)

(*
$P{ BadBot:
@
=(c) Polak====================================================================================================
}
*)

(*
$P{ BnfTop:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
rn_BnfTaxSum, L, ""
?, C, ""
@
############################################################# ########## #####
=#####========================================================================
|            ࠭ᯮ⭮ , 饣 ᢮           |
|                    १ 죮⭮                    |
|           ࣠権 ᠦ᪮ ࠭ᯮ 饣 짮         |
|############################################################################|
}
*)

(*
$P{ BnfSubTop:
TmpCr.BnfType, L, "?????????|樠 ॢ| 樮 祭|  㣮|樠஢ "
@
|============================================================================|
|############################################################################|
|----------------------------------------------------------------------------|
|.|ઠ                       |  | ⠢||      㬬|      |
|----|----------------------------|------|-------|---|-----------|-----------|
}
*)

(*
$P{ BnfLine:
TmpCr.BoxNbr, L, ""
Mark.Name, L, ""
TmpCr.EngPower, R, "2."
?, R, "2-"
TmpCr.MnthAmnt, R, "0"
?, R, "0"
?, R, "0"
@
|####|############################|######|#######|###|###########|###########|
}
*)

(*
$P{ BnfSubBot:
?, L, ""
?, R, "0"
@
|----------------------------------------------------------------------------|
|############################################################# ##############|
}
*)

(*
$P{ BnfBot:
?, R, "0"
@
|----------------------------------------------------------------------------|
|⮣:                                                        ##############|
=(c) Polak====================================================================
}
*)

(*
$P{ 5AX_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
@
############################################################# ########## #####
=#####========================================================================
}
*)

(*
$P{ 5AX_Line:
@

}
*)

(*
$P{ 5AX_Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE CreateTmpFiles();
 BEGIN
  CreateFILE(TotTx, "", "⮣  樨", "");

  CreateFIELD(TotTx, Tax_VehT, STRING[6], "", "", "", " ", "");
  CreateFIELD(TotTx, BnfType,  L_OTx.tBnfType, "", "", "", " 죮", "");
  CreateFIELD(TotTx, CarAmnt,  NUMERIC[0], "", "", "", "- ", "");

  CreateINDEX(TotTx, Tax_VehT, UNIQUE, "", "", Tax_VehT, BnfType);

  SetVersionOfFILE(TotTx, 0);
  L_AFM.AF_CreateTemp("TotTx", "TotTx");
 END {CreateTmpFiles};

 PRIVATE PROCEDURE PurgeTmpFiles();
 BEGIN
  L_AFM.AF_PurgeTemp("TotTx");
 END {PurgeTmpFiles};

 PRIVATE PROCEDURE CalcTransportTax(_BnfPrc: NUMERIC[2]; BPer, EPer: DATE): NUMERIC[2];
 BEGIN
  RETURN L_OTx.CalcTransportTax(TmpCr.MnthAmnt, L_DatTim.MONTH(EPer)-L_DatTim.MONTH(BPer)+1,
                                TmpCr.EngPower, TmpCr.TaxRate, _BnfPrc, EMPTYOF(NUMERIC[2]), EMPTYOF(STRING[]), 2);
 END {CalcTransportTax};

 PRIVATE PROCEDURE GetStateNbr(BPer: DATE): STRING[];
  VAR
   _StateNbr: STRING[];
 BEGIN
  SAVE(CarLog);
  IF ~OCCURE(CarLog) THEN
   _StateNbr:=TmpCr.StateNbr;
  ELSE
   SRCINSEL(CarLog, LE, , L_DatTim.MaxDATE(CarLog.Date, BPer));
   _StateNbr:=CarLog.StateNbr;
  END;
  RESTORE(CarLog);
  RETURN _StateNbr;
 END {GetStateNbr};

 PRIVATE PROCEDURE GetTKindName(): STRING[];
 BEGIN
  IF ~!CarLog.TKind THEN
   CONFORM(CarLog, TKind);
   RETURN TKind.TKind + " " + TKind.Name;
  ELSE
   RETURN "";
  END;
 END {GetTKindName};

 PRIVATE PROCEDURE MakeBnfPart(_BoxNbr: LIKE(Car.BoxNbr);
                               BPer,
                               EPer   : DATE);
  VAR
   tmpBoxNbr: LIKE(Car.BoxNbr);
   Reason,
   TKindName: STRING[];
   _TKind   : LIKE(TKind.TKind);
   FirstPass: SCAL[2];
 BEGIN
  FirstPass:=1;
  SELECT(CarLog, BoxNbr, , _BoxNbr);
  tmpBoxNbr:=_BoxNbr;
  IF SRCINSEL(CarLog, LE, BPer) | SRCINSEL(CarLog, LE, EPer) THEN
   WHILE OCCURE(CarLog) &
         (CarLog.Date <= EPer) &
         (CarLog.Status # L_Car.carst_Retired) &
         L_OTx.E_AdditionalCheckCarAdaptability() DO
    SETEMPTY(_TKind, TKindName);
    CONFORM(CarLog, TKind);
    IF !CarLog.VehPasp THEN
     MAKEPART(R, Dlm);
     MAKEPART(R, Line, _BoxNbr, GetStateNbr(BPer), GetTKindName(), "!!!  㪠   " + L_DatTim.DateStr(CarLog.Date));
     NEXT(CarLog);
    ELSE
     CONFORM(CarLog, VehPasp);
     CONFORM(VehPasp, VehType);
 
     IF    ~L_OTx.IsAcceptableTTPayer(EPer) THEN
      NEXT(CarLog);
     ELSIF VehPasp.IsSteal THEN
      IF FirstPass THEN
       MAKEPART(R, Dlm);
       FirstPass:=0;
      END;
      MAKEPART(R, Line, _BoxNbr, GetStateNbr(BPer), GetTKindName(), "  㣮");
      NEXT(CarLog);
     ELSIF L_OTx.IsMobilizationCar(_BoxNbr, EPer) THEN
      IF FirstPass THEN
       MAKEPART(R, Dlm);
       FirstPass:=0;
      END;
      IF    P_Car.HasActualCarPro(_BoxNbr, EPer, P_Car.P_MobilizationDestinat) THEN
       Reason:=CarPro.Value;
      ELSIF ~!CarLog.Math &
            P_Math.HasActualMathPro(CarLog.Math, EPer, P_Math.P_MobilizationDestinat) THEN
       Reason:=MathPro.Value;
      ELSE
       Reason:="";
      END;
      MAKEPART(R, Line, tmpBoxNbr, GetStateNbr(BPer), GetTKindName(), "樮 : " + Reason);
      SETEMPTY(tmpBoxNbr);
      NEXT(CarLog);
     ELSIF L_OTx.IsMedicCar() THEN
      IF FirstPass THEN
       MAKEPART(R, Dlm);
       FirstPass:=0;
      END;
      MAKEPART(R, Line, tmpBoxNbr, GetStateNbr(BPer), GetTKindName(), "樭᪮ ");
      NEXT(CarLog);
     ELSIF L_OTx.IsSocialBnfCar(CarLog.Date, BPer) THEN
      _TKind   :=CarLog.TKind;
      TKindName:=GetTKindName();
      Reason   :="N " + CarLog.Order + "  " + L_DatTim.DateStr(CarLog.OrdDate) + " " + CarLog.OrdCsAtr;
      WHILE OCCURE(CarLog) & (CarLog.Date <= EPer) & (_TKind = CarLog.TKind) DO
       NEXT(CarLog);
      END;
      IF ~OCCURE(CarLog) | (CarLog.Date > BPer) THEN
       IF FirstPass THEN
        MAKEPART(R, Dlm);
        FirstPass:=0;
       END;
       MAKEPART(R, Line, tmpBoxNbr, GetStateNbr(BPer), TKindName, Reason);
       SETEMPTY(tmpBoxNbr);
      END;
     ELSE
      NEXT(CarLog);
     END;
    END;
   END; (* WHILE OCCURE(CarLog) ... *)
  END;
 END {MakeBnfPart};

 PRIVATE PROCEDURE PrintBnfCarListRep(BPer, EPer: DATE);
 BEGIN
  OPENREP(R, L_General.NameConnection(rn_BnfCarList), Create);
  MAKEPART(R, Top, BPer, EPer);
  SELECT(TmpCr, BnfType);
  WHILE OCCURE(TmpCr) DO
   CHANGESEL(TmpCr, BnfType, , TmpCr.BnfType);
   IF TmpCr.BnfType # L_OTx.bnft_None THEN
    WHILE OCCURE(TmpCr) DO
     CHANGESEL(TmpCr, BnfType, , TmpCr.BnfType, TmpCr.BoxNbr);
     WHILE OCCURE(TmpCr) DO
      PROMPT("  ,   : " + TmpCr.BoxNbr);
      MakeBnfPart(TmpCr.BoxNbr, BPer, EPer);
      NEXT(TmpCr);
     END; (* WHILE OCCURE(TmpCr) ... *)
     LAST(TmpCr);
     CHANGESEL(TmpCr, BnfType, , TmpCr.BnfType);
     NEXT(TmpCr);
    END; (* WHILE OCCURE(TmpCr) ... *)
   END;
   LAST(TmpCr);
   CHANGESEL(TmpCr, BnfType);
   NEXT(TmpCr);
  END; (* WHILE OCCURE(TmpCr) ... *)
  MAKEPART(R, Bot);
 END {PrintBnfCarListRep};

 PRIVATE PROCEDURE PrintBnfSumRep(BPer, EPer: DATE; TotalAmountOfRefund: NUMERIC[2]);
  VAR
   Total,
   SubTotal,
   BnfTaxSum,
   BnfTaxRate: NUMERIC[2];
   _BnfType  : L_OTx.tBnfType;
 BEGIN
  OPENREP(S, L_General.NameConnection(rn_BnfTaxSum), Create);
  MAKEPART(S, BnfTop, " " + L_Str.PoolItem("I ⠫ |II ⠫ |III ⠫ |", L_DatTim.QUARTAL(EPer)) + L_Str.IntStr(L_DatTim.YEAR(EPer)) + " .");
  SETZERO(Total);
  SELECT(TmpCr, BnfType);
  WHILE OCCURE(TmpCr) DO
   CHANGESEL(TmpCr, BnfType, , TmpCr.BnfType);
   _BnfType:=TmpCr.BnfType;
   IF _BnfType # L_OTx.bnft_None THEN
    SETZERO(SubTotal);
    MAKEPART(S, BnfSubTop);
    WHILE OCCURE(TmpCr) DO
     PROMPT("⮢  ,   : " + TmpCr.BoxNbr);
     L_Car.AccessMark(TmpCr.BoxNbr, EPer);
     BnfTaxSum :=CalcTransportTax(1-TmpCr.BnfPrc, BPer, EPer);
     BnfTaxRate:=TmpCr.TaxRate * TmpCr.BnfPrc;
     MAKEPART(S, BnfLine, BnfTaxRate, BnfTaxRate * TmpCr.EngPower, BnfTaxSum);
     INC(SubTotal, BnfTaxSum);
     NEXT(TmpCr);
    END; (* WHILE OCCURE(TmpCr) ... *)
    MAKEPART(S, BnfSubBot, "ᥣ", SubTotal);
    INC(Total, SubTotal);
    IF TotalAmountOfRefund > 0 THEN
     MAKEPART(S, BnfSubBot, "㬬 䨭஢", TotalAmountOfRefund);
    END;
   END;
   LAST(TmpCr);
   CHANGESEL(TmpCr, BnfType);
   NEXT(TmpCr);
  END; (* WHILE OCCURE(TmpCr) ... *)
  MAKEPART(S, BnfBot, Total);
 END {PrintBnfSumRep};

 PRIVATE PROCEDURE PrintBadCarRep(BPer, EPer: DATE);
 BEGIN
  OPENREP(B, L_General.NameConnection(rn_BadCar), Create);
  MAKEPART(B, BadTop);
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT("஢ઠ : " + Car.BoxNbr);
   IF L_Env.RealBoxNbr(Car.BoxNbr) &
      L_DatTim.IsActiveInIntvl_Inc(Car.BegDate, Car.EndDate, BPer, EPer) THEN
    HISTCONF(Math.Max(BPer, Car.BegDate), Car, CarLog);
    WHILE OCCURE(CarLog) & (CarLog.Date <= EPer) DO
     CONFORM(CarLog, Mark);
     IF L_OTx.GatherByKeyAssets(EPer) & !CarLog.Math THEN
      MAKEPART(B, BadLine, " ᮯ⠢ ");
     END;
     IF (DBD.BaseName() = "OD") & (CarLog.Column = 99) THEN
      MAKEPART(B, BadLine, "   99");
     END;
     IF CarLog.Status # L_Car.carst_Retired THEN
      IF ~!CarLog.VehPasp THEN
       CONFORM(CarLog, VehPasp);
      END;
      IF    !CarLog.VehPasp THEN
       MAKEPART(B, BadLine, "  㪠");
      ELSIF ~L_OTx.AcceptableVehPasp(BPer, EPer) THEN
       MAKEPART(B, BadLine, " " + CarLog.VehPasp + "  ");
      ELSIF ~L_OTx.IsAcceptableTTPayer(EPer) THEN
       MAKEPART(B, BadLine, "࠭ᯮ   " + L_Str.PoolItem("쥩 ஭|⢥|ᯫ⠭⮬", VehPasp.TTPayer));
      END;
     END;
     NEXT(CarLog);
    END; (* WHILE OCCURE(CarLog) & (CarLog.Date <= EPer)...*)
   END; (* IF L_Env.RealBoxNbr(Car.BoxNbr)... *)
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
  MAKEPART(B, BadBot);
 END {PrintBadCarRep};

 PRIVATE PROCEDURE BnfCancel();
 BEGIN
  TmpCr.BnfType:=L_OTx.bnft_None;
  TmpCr.BnfPrc :=0;
  REPLACE(TmpCr);
 END {BnfCancel};

 PRIVATE PROCEDURE E_BnfCancelRequired(_BnfType: L_OTx.tBnfType): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  IF (Region.Region = L_Russia.reg_50) & (_BnfType # L_OTx.bnft_IsSteal) THEN
   Local:=PROCREF(E_Way.Xomn7_BnfCancelRequired);
   IF ~!Local THEN
    RETURN Local(_BnfType);
   ELSE
    RETURN 1;
   END;
  END;
  RETURN 0;
 END {E_BnfCancelRequired};

 PRIVATE PROCEDURE MakeIndex(BPer, EPer: DATE);
  VAR
   R                 : NUMERIC[0];
   TotalAmountOfRefund,
   RestAmountOfRefund: NUMERIC[2];
 BEGIN
  SETZERO(TotalAmountOfRefund);
  IF L_OTx.AllowedMobilizationCarBnf(BPer) THEN
   R := STDFORM(L_StdFrm.sf_Choice("樮     %##########%",
                                   "%RI"),
                " 㬬 䨭஢ 죮 ", , 1,
                TotalAmountOfRefund);
  END;

  L_OTx.TT_Prepare(L_OTx.GatherByKeyAssets(EPer), BPer, EPer);

  RestAmountOfRefund:=TotalAmountOfRefund;
  SELECT(TmpCr, ID);
  WHILE OCCURE(TmpCr)  DO
   PROMPT("⬥ 죮 " + TmpCr.ID);
   IF    TmpCr.BnfType = L_OTx.bnft_Mobilization THEN
    DEC(RestAmountOfRefund, CalcTransportTax(0, BPer, EPer));
    IF RestAmountOfRefund < 0 THEN
     BnfCancel();
    END;
   ELSIF E_BnfCancelRequired(TmpCr.BnfType) THEN
    BnfCancel();
   END;
   NEXT(TmpCr);
  END; (* WHILE OCCURE(TmpCr) ... *)

  PrintBnfCarListRep(BPer, EPer);
  PrintBnfSumRep(BPer, EPer, TotalAmountOfRefund);
  PrintBadCarRep(BPer, EPer);
 END {MakeIndex};

 PRIVATE PROCEDURE AccessATERAttrByPublicName(pn: STRING[]): SCAL[2];
 BEGIN
  RETURN SELECT(ATERAttr, PublicNm, Packet.ATER, pn);
 END {AccessATERAttrByPublicName};

 PRIVATE PROCEDURE pip_SingleValue(Value: FLOAT;
                                   pn: STRING[]);
 BEGIN
  IF AccessATERAttrByPublicName(pn) THEN
   L_Packet.PutSingleValueInPacket(00000, 00000, FLDTOSTR(Value, "2."), L_Packet.src_System);
  ELSE
   L_General.ConsultToUs(!Value,
                         "AccessATERAttrByPublicName: Error 1|" +
                         "(" + pn + ")");
  END;
 END {pip_SingleValue};

 PRIVATE PROCEDURE psf_Str(Value, pn: STRING[]);
 BEGIN
  IF AccessATERAttrByPublicName(pn) THEN
   L_Packet.PutSingleValueInPacket(_Table2, _Row2, Value, L_Packet.src_System);
  ELSE
   L_General.ConsultToUs(!Value,
                         "AccessATERAttrByPublicName: Error 1|" +
                         "(" + pn + ")");
  END;
 END {psf_Str};

 PRIVATE PROCEDURE psf_Num(Value: FLOAT;
                           pn   : STRING[]);
 BEGIN
  IF AccessATERAttrByPublicName(pn) THEN
   L_Packet.PutSingleValueInPacket(_Table2, _Row2, FLDTOSTR(Value, "2."), L_Packet.src_System);
  ELSE
   L_General.ConsultToUs(!Value,
                         "AccessATERAttrByPublicName: Error 1|" +
                         "(" + pn + ")");
  END;
 END {psf_Num};

 PRIVATE PROCEDURE ConvertTaxVehTypeAsStr(Idx: NUMERIC[0]; wExclSpaces: SCAL[2]): STRING[];
  VAR
   S: STRING[];
 BEGIN
  S:=Str.Condense(Str.Item(L_Str.PoolItem(L_Car.Tax_VehTPool, VehType.Tax_VehT), "-", Idx));
  IF wExclSpaces THEN
   S:=L_Str.Replace(S, " ", "");
  END;
  RETURN S;
 END {ConvertTaxVehTypeAsStr};

 VAR
  _Table2: LIKE(ATERAttr.Table);
  _Row2  : LIKE(ATERAttr.Row);

 PRIVATE PROCEDURE PutInPacket_2005(BPer, EPer: DATE);
  CONST
   bc_Pool  = "|20106|20115||20120";
   bc_Steal = "10701";

   bc_Full  = "|20106|20115|10701|20120";
  VAR
   i,
   TotalCarAmnt: NUMERIC[0];
   pn1, pn2,
   CodTS       : STRING[];
 BEGIN
  _Table2:=00000;
  _Row2  :=00000;

  SELECT(TmpCr, ID);
  WHILE OCCURE(TmpCr) DO
   PROMPT("㧪 " + TmpCr.ID);
   SEARCH(VehType, VehType, , TmpCr.VehType);
   CodTS:=ConvertTaxVehTypeAsStr(0, 1);
   ADD(TotTx, Tax_VehT, , CodTS, TmpCr.BnfType,
       TotTx.CarAmnt, 1);

   psf_Str(ConvertTaxVehTypeAsStr(1, 0),               "");
   psf_Str(CodTS,                                      "");
   psf_Str(TmpCr.VIN,                                  "");
   psf_Str(TmpCr.StateNbr,                             "");
   psf_Num(TmpCr.EngPower,                             "");
   psf_Str("251",                                      "");
   IF TmpCr.BnfType = L_OTx.bnft_IsSteal THEN
    psf_Str(bc_Steal,                                  "358");
   ELSE
    psf_Str("",                                        "358");
   END;
   psf_Str(L_Str.AnyItem(bc_Pool, "|", TmpCr.BnfType), "죮");
   psf_Num(TmpCr.MnthAmnt,                             "Ⴋ");
   psf_Num(TmpCr.MnthAmnt / (L_DatTim.MONTH(EPer)-L_DatTim.MONTH(BPer)+1), "樥");
   psf_Num(TmpCr.TaxRate * (1-TmpCr.BnfPrc),           "⠢");
   psf_Num(CalcTransportTax(TmpCr.BnfPrc, BPer, EPer), "᫥");
   NEXT(TmpCr);
   INC(_Table2);
  END; (* WHILE OCCURE(TmpCr) ... *)

  _Table2:=00000;
   _Row2 :=00000;
  SELECT(TotTx, Tax_VehT);
  WHILE OCCURE(TotTx) DO
   CHANGESEL(TotTx, Tax_VehT, , TotTx.Tax_VehT);
   TotalCarAmnt:=0;
   WHILE OCCURE(TotTx) DO
    IF TotTx.BnfType # L_OTx.bnft_None THEN
     IF TotTx.BnfType = L_OTx.bnft_IsSteal THEN
      pn1:="᢮358";
      pn2:="⢮358";
     ELSE
      pn1:="죮";
      pn2:="⢮죮";
     END;
     psf_Str(L_Str.AnyItem(bc_Full, "|", TotTx.BnfType), pn1);
     psf_Num(TotTx.CarAmnt,                              pn2);
     INC(_Row2);
    END;
    INC(TotalCarAmnt, TotTx.CarAmnt);
    NEXT(TotTx);
   END; (* WHILE OCCURE(TotTx) ... *)
   LAST(TotTx);
   _Row2:=00000;
   psf_Str(TotTx.Tax_VehT, "2");
   psf_Num(TotalCarAmnt,   "⢮");
   INC(_Table2);
   CHANGESEL(TotTx, Tax_VehT);
   NEXT(TotTx);
  END; (* WHILE OCCURE(TotTx) ... *)
 END {PutInPacket_2005};

 PRIVATE PROCEDURE PutInPacket_2006(BPer, EPer: DATE);
  VAR
   CodTS      : STRING[];
   Tax, BnfTax: NUMERIC[2];
 BEGIN
  _Table2:=00000;
  _Row2  :=00000;
  SELECT(TmpCr, ID);
  WHILE OCCURE(TmpCr) DO
   PROMPT("㧪 " + TmpCr.ID);
   SEARCH(VehType, VehType, , TmpCr.VehType);
   L_Car.StandOnCarLog(TmpCr.BoxNbr, EPer);
   CONFORM(CarLog, Mark);
   CodTS:=ConvertTaxVehTypeAsStr(0, 1);
   psf_Str(CodTS,                                      "");
   psf_Str(TmpCr.VIN,                                  "");
   psf_Str(Mark.Name,                                  "ઠ");
   psf_Str(TmpCr.StateNbr,                             "");
   psf_Num(TmpCr.EngPower,                             "");
   psf_Str("251",                                      "");
   psf_Num(TmpCr.MnthAmnt / (L_DatTim.MONTH(EPer)-L_DatTim.MONTH(BPer)+1), "樥");
   psf_Num(TmpCr.TaxRate,                              "⠢");
   Tax:=CalcTransportTax(0, BPer, EPer);
   psf_Num(Tax,                                        "᫥");
   IF (TmpCr.BnfType # L_OTx.bnft_None) & (TmpCr.BnfType # L_OTx.bnft_IsSteal) THEN
    psf_Str("20200",                                    "죮");
    BnfTax:=CalcTransportTax(1-TmpCr.BnfPrc, BPer, EPer);
   ELSE
    BnfTax:=0;
   END;
   psf_Num(Tax - BnfTax,                               "㬬");
   NEXT(TmpCr);
   INC(_Table2);
  END; (* WHILE OCCURE(TmpCr) ... *)
 END {PutInPacket_2006};

 PRIVATE PROCEDURE PutInPacket_2007(BPer, EPer: DATE);
  VAR
   CodTS      : STRING[];
   Tax, BnfTax: NUMERIC[2];
 BEGIN
  _Table2:=00000;
  _Row2  :=00000;
  SELECT(TmpCr, ID);
  WHILE OCCURE(TmpCr) DO
   PROMPT("㧪 " + TmpCr.ID);
   SEARCH(VehType, VehType, , TmpCr.VehType);
   L_Car.StandOnCarLog(TmpCr.BoxNbr, EPer);
   CONFORM(CarLog, Car);
   CONFORM(CarLog, Mark);
   CodTS:=ConvertTaxVehTypeAsStr(0, 1);
   psf_Str(CodTS,                                                          "");
   psf_Str(TmpCr.VIN,                                                      "");
   psf_Str(Mark.Name,                                                      "ઠ");
   psf_Str(TmpCr.StateNbr,                                                 "");
   psf_Num(TmpCr.EngPower,                                                 "");
   psf_Str("251",                                                          "");
   IF L_DatTim.YEAR(BPer) >= 2009 THEN
    psf_Num(TmpCr.Age,                                                     "பᯮ");
   END;
   psf_Num(TmpCr.MnthAmnt / (L_DatTim.MONTH(EPer)-L_DatTim.MONTH(BPer)+1), "3623");
   psf_Num(TmpCr.TaxRate,                                                  "⠢");
   Tax:=CalcTransportTax(0, BPer, EPer);
   psf_Num(Tax,                                                            "㬈");
   IF (TmpCr.BnfType # L_OTx.bnft_None) & (TmpCr.BnfType # L_OTx.bnft_IsSteal) THEN
    psf_Str("20200",                                                        "");
    BnfTax:=CalcTransportTax(1-TmpCr.BnfPrc, BPer, EPer);
   ELSE
    BnfTax:=0;
   END;
   psf_Num(Tax - BnfTax,                                                    "㬈᫓");
   psf_Str(TmpCr.ID,                                                        "ID");
   NEXT(TmpCr);
   INC(_Table2);
  END; (* WHILE OCCURE(TmpCr) ... *)
 END {PutInPacket_2007};

 PRIVATE PROCEDURE PutInPacket(BPer, EPer: DATE);
 BEGIN
  CONFORM(Packet, ATER);
  IF    (L_DatTim.YEAR(BPer) >= 2007) THEN
   PutInPacket_2007(BPer, EPer);
   _Table2:=00000;
   _Row2  :=00000;
   psf_Str(Str.Cap(CreateUUID(1)), "");
   IF    (ATER.Kind = L_Packet.knd_TT_AdvRep) THEN
    psf_Str(L_Packet.GetIdFile("NO_TRANA"), "");
   ELSIF (ATER.Kind = L_Packet.knd_TT_Decl) THEN
    psf_Str(L_Packet.GetIdFile("NO_TRAND"), "");
   END;
  ELSIF L_DatTim.YEAR(BPer) >= 2006 THEN
   PutInPacket_2006(BPer, EPer);
  ELSE
   PutInPacket_2005(BPer, EPer);
  END;

  L_Packet.PutManualInputATERAttr();

  L_Packet.SetDTStamp();
  Packet.PrpDate :=SYSDATE();
  Packet.DTStamp :=L_Packet.DTStamp;
  Packet.DataType:=L_Packet.dt_None;
  Packet.CorrType:=L_Packet.ct_None;
  Packet.Status  :=L_Packet.st_Prepared;
  REPLACE(Packet);
 END {PutInPacket};

 PRIVATE PROCEDURE E_MakeAdditionalReport(EPer: DATE);
  VAR
   CountLines: NUMERIC[0];
 BEGIN
  IF L_EC.ExecE_Func_Scal2(EPer, PROCREF(E_Way.Xomn7_MakeAdditionalReport), 0) THEN
   SETZERO(CountLines);
   L_MSO.wordInitDocument(SYSDATE());
   L_MSO.wordSetDateVar("TT.SrcDate", SYSDATE());
   L_MSO.wordSetDateVar("TT.Date", SYSDATE());
   IF L_DatTim.IsLastMonthOfQuartal(EPer) THEN
    L_MSO.wordSetVar("TT.Period", L_Str.PoolItem("I ⠫|II ⠫|III ⠫", L_DatTim.QUARTAL(EPer)));
   ELSE
    L_MSO.wordSetVar("TT.Period", L_DatTim.MonthStr(EPer, 0));
   END;
 
   SELECT(TmpCr, BnfType, ,  L_OTx.bnft_Social);
   WHILE OCCURE(TmpCr) DO
    PROMPT("㧪  Word " + TmpCr.BoxNbr);
    L_Car.AccessMark(TmpCr.BoxNbr, EPer);
    L_MSO.wordSetVarsByFile_wIndex("TmpCr", CountLines, 0);
    L_MSO.wordSetVar("TmpCr[" + L_Str.IntStr(CountLines) + "].Tax_VehT.Name",    ConvertTaxVehTypeAsStr(1, 0));
    L_MSO.wordSetVar("TmpCr[" + L_Str.IntStr(CountLines) + "].BoxNbr.Mark.Name", Mark.Name);
    INC(CountLines);
    NEXT(TmpCr);
   END; (* WHILE OCCURE(TmpCr) ... *)
   IF CountLines = 0 THEN
    L_MSO.wordSetVarsByFile_wIndex("TmpCr", 0, 1);
    L_MSO.wordSetVar("TmpCr[" + L_Str.IntStr(CountLines) + "].Tax_VehT.Name",    "");
    L_MSO.wordSetVar("TmpCr[" + L_Str.IntStr(CountLines) + "].BoxNbr.Mark.Name", "");
   END;
   L_MSO.SetWordTable("Cars", CountLines);
   L_MSO.MakeWordDocument("Form43a",
                          1,
                          L_MSO.PrpMode_ToDoc,
                          "");
  END;
 END {E_MakeAdditionalReport};

 PRIVATE PROCEDURE Make(BPer, EPer: DATE);
 BEGIN
  L_OTx.Create_TmpCr();
  CreateTmpFiles();
  MakeIndex(BPer, EPer);
  PutInPacket(BPer, EPer);
  E_MakeAdditionalReport(EPer);
  L_OTx.Purge_TmpCr();
  PurgeTmpFiles();
  LIKEMENU(Survey, L_General.NameConnection(rn_BadCar),
           Survey, L_General.NameConnection(rn_BnfTaxSum),
           Survey, L_General.NameConnection(rn_BnfCarList));
 END {Make};

 PRIVATE PROCEDURE AllowedCalcTransportTax(): SCAL[2];
 BEGIN
  RETURN (Region.Region = L_Russia.reg_77) |
         (Region.Region = L_Russia.reg_50) |
         (Region.Region = L_Russia.reg_72);
 END {AllowedCalcTransportTax};

 PUBLIC PROCEDURE XOMN7();
  VAR
   Msg           : STRING[];
   StandartPeriod: SCAL[2];
   BPer, EPer    : DATE;
 BEGIN
  L_General.Assert(ACCESS(Packet), " ࠭    ⭮");
  L_Packet.ClearATER(0);
  BPer:=Packet.PerB;
  EPer:=L_DatTim.MonthEnd(Packet.PerE);
  CONFORM(Packet, ATER);
  L_Packet.CheckActualPacketInPer();
  L_General.Assert(SEARCH(Region, Region, Str.Slice(P_Firm.FP_KPP(L_Packet.GetPacketOwnFirm(), EPer), 0, 2)),
                   " ࠢ筨 ॣ   ॣ,|" + "㪠   ࣠樨");

  L_General.ConsultToUs(AllowedCalcTransportTax(),
                        " ࠭ᯮ⭮ |" +
                        " ॣ '" + Region.Region + " " + Region.Name + "'  ॠ");
  StandartPeriod:=1;
  IF (L_DatTim.MONTH(BPer) = 0) & (L_DatTim.MONTH(EPer) = 11) THEN
   Msg     :=" " +
             L_Str.IntStr(L_DatTim.YEAR(EPer)) + " ";
   L_General.Assert(ATER.Kind = L_Packet.knd_TT_Decl, "   㦭 ନ஢ ⭮  |'"+L_Str.PoolItem(L_Packet.knd_Pool, L_Packet.knd_TT_Decl)+"'");
  ELSE
   IF (L_DatTim.QUARTAL(EPer) < 3) & L_DatTim.IsLastMonthOfQuartal(EPer) & (L_DatTim.MonthEnd(L_DatTim.IncMonth(BPer, +2)) = EPer) THEN
    Msg    :=" " +
             L_Str.PoolItem("I ⠫ |II ⠫ |III ⠫ ", L_DatTim.QUARTAL(EPer)) +
             L_Str.IntStr(L_DatTim.YEAR(EPer)) + " ";
   ELSE
    StandartPeriod:=0;
    Msg    :=" ਮ c " +
             Str.Cap(L_DatTim.FullDateStr(BPer)) +
             "  " + Str.Cap(L_DatTim.FullDateStr(EPer));
   END;
   IF ATER.Kind # L_Packet.knd_TT_AdvRep THEN
    L_StdFrm.OrdinaryCHOICE("   㦭 ନ஢ ⭮  '|"+L_Str.PoolItem(L_Packet.knd_Pool, L_Packet.knd_TT_AdvRep)+"'");
   END;
  END;
  L_StdFrm.JustQuestion("⮢ ⭮  ଥ|" + L_Str.PoolItem(L_Packet.knd_Pool, ATER.Kind) + "|" +  Msg);
  IF ~StandartPeriod THEN
   L_StdFrm.OrdinaryCHOICE(" ਮ|" + "c " + Str.Cap(L_DatTim.FullDateStr(BPer)) +
                           "  " + Str.Cap(L_DatTim.FullDateStr(EPer)) + "|  ⠭! த?");
  END;

  Make(BPer, EPer);
 END {XOMN7};

END.
