(*
%Copyright   (c) Polak Computer System
%Author      25.02.2002 14:57:52 SAN
%Purpose     ᮡ   ⠬
%Type        library
%Specific    LOC
%Modified    10.11.2010 13:35:29 POLAK\Gina
%Environment
*)

 MODULE E_Pmnt [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_MDoc, L_Acnt, P_Cntr;

 PUBLIC PROCEDURE MathForPayment(D: DATE): LIKE(Math.Math);
 BEGIN
  RETURN 08000;
 END {MathForPayment};

 PUBLIC PROCEDURE DefineMDocPayDate(default: DATE): DATE;
 BEGIN
  IF MDoc.MDocKind = L_MDoc.md_Dvr THEN
   RETURN default + 10;
  ELSE
   RETURN default;
  END;
 END {DefineMDocPayDate};

 PUBLIC PROCEDURE ResetMDocNumberingFromYearBeg(D: DATE): SCAL[2];
 BEGIN
  IF L_MDoc.IsExternalMDocKind() & (L_MDoc.GetMDocKindDir() = L_MDoc.mdd_Outgoing) THEN
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {ResetMDocNumberingFromYearBeg};

 PUBLIC PROCEDURE DefaultMDocSrcNbr(D: DATE; Default: STRING[]): STRING[];
 BEGIN
  IF MDoc.MDocKind = L_MDoc.md_ISF THEN
   IF MDoc.Date >= 01\01\2007 THEN
    RETURN "24/" + Default;
   ELSE
    RETURN "31/" + Default;
   END;
  ELSE
   RETURN Default;
  END;
 END {DefaultMDocSrcNbr};

END.