(*
%Copyright   (c) Polak Computer System
%Author      30.05.2002 20:33:45 LDA
%Purpose     ⨭ ६
%Type        operation
%Specific    LOC
%Modified    10.04.2014 14:02:01 POLAK\San
%Environment
*)

 IMPORT RprShow, E_Rpr, L_General, L_GUI;

 PRIVATE CONST
  rbc_woDrv_Bus   = 2;
  rbc_woDrv_GAZel = 3;

 PUBLIC PROCEDURE PutButtonTable(dlg: DIALOG);
 BEGIN
  RprShow.PutFrame("ࢨ", 003, 045, 200, 120);
  RprShow.PutButtonGroup_byZone(2000, "2000..2003",
                                018, 070, RprShow.bo_Horizontal, RprShow.gb_Vertical);
  RprShow.PutButtonGroup_byZone(2000, "2004..2007",
                                133, 070, RprShow.bo_Horizontal, RprShow.gb_Vertical);

  RprShow.PutFrame("⮪ ᪨ ⮡", 250, 045, 145, 120);
  RprShow.PutButtonGroup_byZone(0200, "0200..0201",
                                265, 080, RprShow.bo_Horizontal, RprShow.gb_Horizontal);
  RprShow.PutFrame("", 250, 110, 145, 055);
  RprShow.PutButtonGroup_byZone(0250, "0250",
                                295, 135, RprShow.bo_Horizontal, RprShow.gb_Vertical);

  RprShow.PutFrame(" - 2 ࢨ 業", 435, 045, 185, 120);
  RprShow.PutButtonGroup_byZone(0300, "0300..0303",
                                470, 070, RprShow.bo_Horizontal, RprShow.gb_Vertical);
  RprShow.PutButtonGroup_byZone(0300, "0304..0307",
                                530, 070, RprShow.bo_Horizontal, RprShow.gb_Vertical);

  RprShow.PutFrame("⠦", 660, 045, 145, 120);
  RprShow.PutButtonGroup_byZone(0400, "0400..0402",
                                675, 080, RprShow.bo_Horizontal, RprShow.gb_Vertical);
  RprShow.PutButtonGroup_byZone(0400, "0403..0405",
                                735, 080, RprShow.bo_Horizontal, RprShow.gb_Vertical);

  RprShow.PutFrame("   -  ", 003, 180, 200, 185);

  RprShow.PutButtonGroup_byZone(0500, "0500..0504",
                                018, 215, RprShow.bo_Horizontal,   RprShow.gb_Vertical);
  RprShow.PutButtonGroup_byZone(0500, "0505..0509",
                                133, 215, RprShow.bo_Horizontal,   RprShow.gb_Vertical);

  RprShow.PutButtonGroup_byZone(3000, "3000",
                                082, 335, RprShow.bo_Horizontal,   RprShow.gb_Vertical);

  RprShow.PutFrame("   -  ", 003, 380, 200, 100);

  RprShow.PutButtonGroup_byZone(0550, "0550..0552",
                                018, 420, RprShow.bo_Horizontal, RprShow.gb_Horizontal);

  RprShow.PutFrame("   - 㧮 ", 003, 495, 200, 55);

  RprShow.PutButtonGroup_byZone(0600, "0600",
                                018, 515, RprShow.bo_Horizontal, RprShow.gb_Horizontal);
  RprShow.PutButtonGroup_byZone(0600, "0601",
                                133, 515, RprShow.bo_Horizontal, RprShow.gb_Horizontal);

  RprShow.PutFrame("⭨ ", 275, 185, 95, 117);
  RprShow.PutButtonGroup_byZone(0700, "0700..0702",
                                295, 225, RprShow.bo_Horizontal, RprShow.gb_Vertical);

  RprShow.PutFrame("", 435, 185, 185, 138);
  RprShow.PutButtonGroup_byZone(0800, "0800..0803",
                                470, 225, RprShow.bo_Horizontal, RprShow.gb_Vertical);
  RprShow.PutButtonGroup_byZone(0800, "0804..0807",
                                530, 225, RprShow.bo_Horizontal, RprShow.gb_Vertical);

  RprShow.PutFrame(" - 1", 685, 185, 95, 117);
  RprShow.PutButtonGroup_byZone(0900, "0900..0902",
                                705, 225, RprShow.bo_Horizontal, RprShow.gb_Vertical);

  RprShow.PutFrame("  - ६", 385, 330, 305, 85);
  RprShow.PutButtonGroup_byZone(1000, "1000..1004",
                                400, 355, RprShow.bo_Horizontal, RprShow.gb_Horizontal);
  RprShow.PutButtonGroup_byZone(1000, "1005..1009",
                                400, 385, RprShow.bo_Horizontal, RprShow.gb_Horizontal);

  RprShow.PutFrame("⨪", 275, 420, 95, 130);
  RprShow.PutButtonGroup_byZone(1100, "1100..1103",
                                295, 455, RprShow.bo_Horizontal, RprShow.gb_Vertical);

  RprShow.PutFrame("", 433, 420, 95, 130);
  RprShow.PutButtonGroup("1203..1204",
                         453, 477, RprShow.bo_Horizontal, RprShow.gb_Vertical);

  RprShow.PutFrame(" ⥫ .鸞", 591, 420, 95, 130);
  RprShow.PutButtonGroup_byZone(4000, "4000..4000",
                                611, 499, RprShow.bo_Horizontal, RprShow.gb_Vertical);

(*
  RprShow.PutFrame("", 475, 420, 95, 130);
  RprShow.PutButtonGroup("1201..1203",
                         495, 477, RprShow.bo_Horizontal, RprShow.gb_Vertical);

  RprShow.PutFrame(" ⥫ .鸞", 650, 420, 95, 130);
  RprShow.PutButtonGroup_byZone(4000, "4000..4000",
                                670, 499, RprShow.bo_Horizontal, RprShow.gb_Vertical);
*)
  RprShow.PutFrame("㧮  ", 745, 420, 95, 130);
  RprShow.PutButtonGroup_byZone(1300, "1300..1302",
                                765, 477, RprShow.bo_Horizontal, RprShow.gb_Vertical);
  RprShow.PutFrame(" ⥫",
           862, 045, 159, 505);
  L_GUI.put_StaticText(dlg, RprShow.p_Main, "st_Bus", "⮡",
                       862, 070, 70, 20,
                       13,
                       CONTROL.HorizontalAlignment_Center, L_GUI.br_st_None);
  RprShow._PutButtonGroup("1029..1048",
                         872, 100, RprShow.bo_Horizontal, RprShow.gb_Vertical, "", rbc_woDrv_Bus, "⮡  ⥫");

  L_GUI.put_StaticText(dlg, RprShow.p_Main, "st_GAZel", "",
                       947, 070, 70, 20,
                       13,
                       CONTROL.HorizontalAlignment_Center, L_GUI.br_st_None);
  RprShow._PutButtonGroup("1049..1068",
                         957, 100, RprShow.bo_Horizontal, RprShow.gb_Vertical, "", rbc_woDrv_GAZel, "  ⥫");
 END {PutButtonTable};

 PUBLIC PROCEDURE GetReportList(Color: STRING[]): STRING[];
 BEGIN
  RETURN "FrOut 祭   , 뢠騬 :"   + Color + "|";
 END {GetReportList};

 PUBLIC PROCEDURE MakeReport(_Report: STRING[]);
 BEGIN
  IF _Report = "FrOut" THEN
   CALL(Rpr09, 102)
  END;
 END {MakeReport};

 PUBLIC PROCEDURE IsAcceptableGroup(_Group: LIKE(RprSMirr.Group)): SCAL[2];
 BEGIN
  RETURN _Group # E_Rpr.grp_Other;
 END {IsAcceptableGroup};

 PUBLIC PROCEDURE NeedPrepare_woDrivers(D: DATE): SCAL[2];
 BEGIN
  RETURN 1;
 END {NeedPrepare_woDrivers};

 PUBLIC PROCEDURE GetCluster(_RprPlace: LIKE(RprPlace.RprPlace);
                             rb_State: RprShow.tRprBayState; default: RprShow.tRprBayCluster): RprShow.tRprBayCluster;
 BEGIN
  IF    rb_State = RprShow.rbs_woDriver THEN
   IF    _Cars.Group = E_Rpr.grp_Bus THEN
    RETURN rbc_woDrv_Bus;
   ELSIF _Cars.Group = E_Rpr.grp_GAZel THEN
    RETURN rbc_woDrv_GAZel;
   END;
  END;
  RETURN default;
 END {GetCluster};

 PUBLIC PROCEDURE GetVSpaceBtwBtns(): NUMERIC[0];
 BEGIN
  RETURN 2;
 END {GetVSpaceBtwBtns};

 PUBLIC PROCEDURE GetHSpaceBtwBtns(): NUMERIC[0];
 BEGIN
  RETURN 2;
 END {GetHSpaceBtwBtns};

END.
