(*
%Copyright   (c) Polak Computer System
%Author      21.10.1997 20:36:39 GINA
%Purpose     ᮡ   ਠ쭮 
%Type        library
%Specific    LOC
%Modified    08.04.2014 10:05:16 LDA
%Environment
*)

 MODULE E_Stock [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Str, L_DatTim, L_General, L_MathR, L_MDoc, L_CUC, L_Way, L_Car, L_XDoc, L_Stock,
        P_Storage, L_Rpr, P_Firm, FIO, L_PDoc;

 (**)

 PUBLIC PROCEDURE GetKeyAssBalCostAcCuts(P: DATE; VAR trgAcCuts: LIKE(AcCut.AcCut)[];
                                         Pr1, Pr2, Pr3: L_MathR.tKA_PrpSel);
 BEGIN
  L_MathR.InitKAPrpSelArr(Pr1, Pr2, Pr3);
  L_MathR.AddKAPrpSelArr(200, L_MathR.KA_src_IntFunds, L_MathR.KA_dst_Productive,    L_MathR.KA_wear_Basic);
  L_MathR.AddKAPrpSelArr(201, L_MathR.KA_src_IntFunds, L_MathR.KA_dst_NonProductive, L_MathR.KA_wear_Basic);
  L_MathR.AddKAPrpSelArr(202, L_MathR.KA_src_Budget,   L_MathR.KA_dst_Productive,    L_MathR.KA_wear_Budget);
  L_MathR.AddKAPrpSelArr(203, L_MathR.KA_src_Budget,   L_MathR.KA_dst_NonProductive, L_MathR.KA_wear_Budget);
  L_MathR.AddKAPrpSelArr(204, L_MathR.KA_src_Gratis,   L_MathR.KA_dst_Productive,    L_MathR.KA_wear_Gratis);
  L_MathR.AddKAPrpSelArr(205, L_MathR.KA_src_Gratis,   L_MathR.KA_dst_NonProductive, L_MathR.KA_wear_Gratis);
  L_MathR.AddKAPrpSelArr(206, L_MathR.KA_src_Budget,   L_MathR.KA_dst_Productive,    L_MathR.KA_wear_Budget98_99);
  L_MathR.AddKAPrpSelArr(207, L_MathR.KA_src_Budget,   L_MathR.KA_dst_NonProductive, L_MathR.KA_wear_Budget98_99);
  L_MathR.AddKAPrpSelArr(208, L_MathR.KA_src_Gratis,   L_MathR.KA_dst_Productive,    L_MathR.KA_wear_Gratis98_99);
  L_MathR.AddKAPrpSelArr(209, L_MathR.KA_src_Gratis,   L_MathR.KA_dst_NonProductive, L_MathR.KA_wear_Gratis98_99);
  L_MathR.AddKAPrpSelArr(210, L_MathR.KA_src_Target,   L_MathR.KA_dst_Productive,    L_MathR.KA_wear_Target);
  L_MathR.AddKAPrpSelArr(211, L_MathR.KA_src_Target,   L_MathR.KA_dst_NonProductive, L_MathR.KA_wear_Target);
  L_MathR.AddKAPrpSelArr(248, L_MathR.KA_src_Credit,   L_MathR.KA_dst_Productive,    L_MathR.KA_wear_Credit);
  L_MathR.GetKAPrpSelArr(trgAcCuts);
 END {GetKeyAssBalCostAcCuts};

 PUBLIC PROCEDURE GetKeyAssWearAcCuts(P: DATE; VAR trgAcCuts: LIKE(AcCut.AcCut)[];
                                      Pr1, Pr2, Pr3: L_MathR.tKA_PrpSel);
 BEGIN
  L_MathR.InitKAPrpSelArr(Pr1, Pr2, Pr3);
  L_MathR.AddKAPrpSelArr(212, L_MathR.KA_BalDepr,    L_MathR.KA_All, L_MathR.KA_wear_Basic);
  L_MathR.AddKAPrpSelArr(213, L_MathR.KA_BalDepr,    L_MathR.KA_All, L_MathR.KA_wear_Budget);
  L_MathR.AddKAPrpSelArr(214, L_MathR.KA_BalDepr,    L_MathR.KA_All, L_MathR.KA_wear_Gratis);
  L_MathR.AddKAPrpSelArr(215, L_MathR.KA_OutBalDepr, L_MathR.KA_All, L_MathR.KA_wear_Budget98_99);
  L_MathR.AddKAPrpSelArr(216, L_MathR.KA_OutBalDepr, L_MathR.KA_All, L_MathR.KA_wear_Gratis98_99);
  L_MathR.AddKAPrpSelArr(217, L_MathR.KA_BalDepr,    L_MathR.KA_All, L_MathR.KA_wear_Target);
  L_MathR.AddKAPrpSelArr(249, L_MathR.KA_BalDepr,    L_MathR.KA_All, L_MathR.KA_wear_Credit);
  L_MathR.GetKAPrpSelArr(trgAcCuts);
 END {GetKeyAssWearAcCuts};

 PUBLIC PROCEDURE GetKeyAssNotInOperAcCuts(P: DATE; VAR trgAcCuts: LIKE(AcCut.AcCut)[];
                                           Pr1, Pr2, Pr3: L_MathR.tKA_PrpSel);
 BEGIN
  L_MathR.InitKAPrpSelArr(Pr1, Pr2, Pr3);
  L_MathR.AddKAPrpSelArr(199, L_MathR.KA_src_IntFunds, L_MathR.KA_All, L_MathR.KA_All);
  L_MathR.AddKAPrpSelArr(196, L_MathR.KA_src_Budget,   L_MathR.KA_All, L_MathR.KA_All);
  L_MathR.AddKAPrpSelArr(197, L_MathR.KA_src_Gratis,   L_MathR.KA_All, L_MathR.KA_All);
  L_MathR.AddKAPrpSelArr(198, L_MathR.KA_src_Target,   L_MathR.KA_All, L_MathR.KA_All);
  L_MathR.AddKAPrpSelArr(250, L_MathR.KA_src_Credit,   L_MathR.KA_All, L_MathR.KA_All);
  L_MathR.AddKAPrpSelArr(251, L_MathR.KA_src_Credit,   L_MathR.KA_All, L_MathR.KA_All);
  L_MathR.GetKAPrpSelArr(trgAcCuts);
 END {GetKeyAssNotInOperAcCuts};

 PUBLIC CONST
  KA_acc_InUse      = 218;
  KA_acc_TaxCost    = 219;
  KA_acc_TaxWear    = 220;
  KA_acc_FutureTax  = 221;
  KA_acc_NotTaxCost = 222;

 PUBLIC CONST
  MtyRunSize = 15;
  MtyRunBeg  = 40;

 PUBLIC PROCEDURE TKind2MtyIdx(D: DATE; trgTKind: LIKE(TKind.TKind)): LIKE(MtyIdx.MtyIdx);
 BEGIN
  IF trgTKind = 12 THEN
   SAVE(CarLog);
   L_Car.StandOnCarLog(RWayS.BoxNbr, D);
   trgTKind:=CarLog.TKind;
   RESTORE(CarLog);
  END;

  IF    !trgTKind     THEN  RETURN EMPTYOF(MtyIdx.MtyIdx); (*0070738*)
  ELSIF trgTKind = 01 THEN  RETURN 40;
  ELSIF trgTKind = 02 THEN  RETURN 41;
  ELSIF trgTKind = 04 THEN  RETURN 42;
  ELSIF trgTKind = 05 THEN  RETURN 43;
  ELSIF trgTKind = 09 THEN  RETURN 44;
  ELSIF trgTKind = 10 THEN  RETURN 45;
  ELSIF trgTKind = 11 THEN  RETURN 46;
  ELSIF trgTKind = 13 THEN  RETURN 47;
  ELSIF trgTKind = 14 THEN  RETURN 48;
  ELSIF trgTKind = 15 THEN  RETURN 49;
  ELSIF trgTKind = 16 THEN  RETURN 50;
  ELSIF trgTKind = 18 THEN  RETURN 51;
  ELSIF trgTKind = 07 THEN  RETURN 52;
  ELSIF trgTKind = 19 THEN  RETURN 53; (*誮*)
  ELSIF trgTKind = 20 THEN  RETURN 54; (**)
  ELSE
   L_MathR.TKind2MtyIdxInformUs(trgTKind);
  END;
 END {TKind2MtyIdx};

 PUBLIC PROCEDURE MtyIdxAcCut(DprK: L_MathR.DprKindType; trgMtyIdx: LIKE(MathMty.MtyIdx)): LIKE(AcCut.AcCut);
 BEGIN
  IF DprK = L_MathR.DprK_Acn THEN
   IF    trgMtyIdx = 40 THEN  RETURN 440; (*233*)
   ELSIF trgMtyIdx = 41 THEN  RETURN 440; (*233*)
   ELSIF trgMtyIdx = 42 THEN  RETURN 444; (*231*)
   ELSIF trgMtyIdx = 43 THEN  RETURN 237;
   ELSIF trgMtyIdx = 44 THEN  RETURN 441; (*235*)
   ELSIF trgMtyIdx = 45 THEN  RETURN 363; (*239*)
   ELSIF trgMtyIdx = 46 THEN  RETURN 440; (*233*)
   ELSIF trgMtyIdx = 47 THEN  RETURN 393; (*241*)
   ELSIF trgMtyIdx = 48 THEN  RETURN 237;
   ELSIF trgMtyIdx = 49 THEN  RETURN 366; (*243*)
   ELSIF trgMtyIdx = 50 THEN  RETURN 480; (*245*)
   ELSIF trgMtyIdx = 51 THEN  RETURN 477;
   ELSIF trgMtyIdx = 52 THEN  RETURN 363;
   ELSIF trgMtyIdx = 53 THEN  RETURN 442; (*誮*)
   ELSIF trgMtyIdx = 54 THEN  RETURN 259; (**)
   END;
  END;
  L_General.CallUs(0);
 END {MtyIdxAcCut};

 PUBLIC PROCEDURE IsRunMathMty(_MtyIdx: LIKE(MtyIdx.MtyIdx)): SCAL[2];
 BEGIN
  RETURN (_MtyIdx >= MtyRunBeg) & (_MtyIdx <= (MtyRunBeg+MtyRunSize-1));
 END {IsRunMathMty};

 PUBLIC PROCEDURE RunsProportional(D: DATE; DprK: L_MathR.DprKindType): SCAL[2];
 BEGIN
  RETURN DprK = L_MathR.DprK_Acn;
 END {RunsProportional};

 PUBLIC PROCEDURE DefaultVATMode(D: DATE): LIKE(MDocList.MMode);
 BEGIN
  RETURN L_MDoc.vatm_Distribution;
 END {DefaultVATMode};

 PUBLIC PROCEDURE MDocListOrderOnPaper(_MDocKind: LIKE(MDocKind.MDocKind); default: SCAL[2]): SCAL[2];
 BEGIN
  RETURN 0; (* MDocList.MDLNbr*)
 END {MDocListOrderOnPaper};

 PUBLIC PROCEDURE MDocP_MO_GetTemplateName(default: STRING[]): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=default;
  IF    (MDoc.MDocKind = L_MDoc.md_FPr) THEN
   Result:="MD_43_##";
  ELSIF (MDoc.MDocKind = L_MDoc.md_IAS) & !Result THEN
   Result:="MD_43_01";
  END;
  RETURN Result;
 END {MDocP_MO_GetTemplateName};

 PUBLIC PROCEDURE MDocP_MO_GetOtherFormTemplateName(default: STRING[]): STRING[];
 BEGIN
  IF MDoc.MDocKind=L_MDoc.md_MSP THEN
   RETURN "MD_06_01";
  END;
  RETURN default;
 END {MDocP_MO_GetOtherFormTemplateName};

 PUBLIC PROCEDURE IsOperationalRWayS(default: SCAL[2]): SCAL[2];
 BEGIN
  IF L_Way.CarBegRWSLev(RWayS.BoxNbr, RWayS.Date) THEN
(*
   L_General.Assert(MDoc.Date = RWayS.Date, "   ᮮ⢥⢮  ");
*)
   IF default = 0 THEN
    IF (RWayS.Status = L_Way.rwsStat_Given) & ((RWayS.Date = (SYSDATE()-1)) & (SYSTIME() < 09:00)) THEN
     default:=1;
    END;
   END;
  END;
  RETURN default;
 END {IsOperationalRWayS};

 PUBLIC PROCEDURE GetAsLeaderSgnAuthR(): LIKE(SgnAuthR.SgnAuthR);
 BEGIN
  IF ((MDoc.MDocKind = L_MDoc.md_IsS) | (MDoc.MDocKind = L_MDoc.md_ISF) |
      (MDoc.MDocKind = L_MDoc.md_IAS) | (MDoc.MDocKind = L_MDoc.md_RPr)) &
      ~!L_XDoc.GetRefToXDC_Transitively(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.xdt_RprS) THEN
   RETURN 001;
  ELSE
   RETURN EMPTYOF(SgnAuthR.SgnAuthR);
  END;
 END {GetAsLeaderSgnAuthR};

 PUBLIC PROCEDURE TankIsFullOnReturn(D: DATE): SCAL[2];
 BEGIN
  RETURN 1;
 END {TankIsFullOnReturn};

 PUBLIC PROCEDURE gs_IsPumping(): SCAL[2];
 BEGIN
  RETURN MDoc.Storage2 = 0001740;
 END {gs_IsPumping};

 PUBLIC PROCEDURE gs_MakePRMRequired(trgMath: LIKE(Math.Math); default: SCAL[2]): SCAL[2];
 BEGIN
  RETURN default & (trgMath # 08194);
 END {gs_MakePRMRequired};

 PUBLIC PROCEDURE cucRole_IsEngine(D: DATE): SCAL[2];
 BEGIN
  IF !CUCopy.Math THEN
   RETURN 0;
  END;
  CONFORM(CUCopy, Math);
  RETURN Math.CarUnit = 0002;
 END {E_cucRole_IsEngine};

 PUBLIC PROCEDURE NormalUsingMDocCostItem(): SCAL[2];
 BEGIN
  RETURN 1;
 END {NormalUsingMDocCostItem};

END.
