(*
%Copyright   (c) Polak IT
%Author      27.12.2002 20:03:10 POLAK\RSN
%Purpose     ନ஢ ਪ  ᤥ騪.
%Type        operation
%Specific    SP
%Modified    23.10.2012 13:46:19 POLAK\San
%Environment
*)

 IMPORT L_General, L_DatTim, L_Staff, L_PRoll, Memo, L_EDO;

 PRIVATE PROCEDURE NeedLog(): SCAL[2];
 BEGIN
  CONFORM(StaffLog, Officer);
  RETURN ~L_Staff.IsDischargeStaffLog() & ((Officer.PayKind=11) | (Officer.PayKind = 04))(*騪*);
 END {NeedLog};

 PRIVATE PROCEDURE GetGate(VAR D1, D2: DATE);
 BEGIN
  IF    StaffLog.Date <  Memo.tmp_mb() THEN
   D1:=Memo.tmp_mb();
  ELSE
   L_General.CallUs(StaffLog.Date <= Memo.tmp_me());
   D1:=StaffLog.Date;
  END;
  IF ~!StaffLog.DateE & (StaffLog.DateE < Memo.tmp_me()) THEN
   IF StaffLog.DateE < Memo.tmp_mb() THEN
    D2:=Memo.tmp_mb() - 1;
   ELSE
    D2:=StaffLog.DateE;
   END;
  ELSE
   D2:=Memo.tmp_me();
  END;
 END {GetGate};

 PRIVATE PROCEDURE GetTimDone(): NUMERIC[3];
  VAR
   T      : NUMERIC[3];
   lastDay: LIKE(Sheet.Day);
   BegD,
   EndD   : DATE;
 BEGIN
  GetGate(BegD, EndD);
  IF L_DatTim.DATEINT(Memo.tmp_mb(), Memo.tmp_me(), BegD, EndD) = 0 THEN
   RETURN 0;
  END;
  IF (BegD = Memo.tmp_mb()) & (EndD = Memo.tmp_me()) THEN
   T:=PCalc.TimDone;
  ELSE
   SETZERO(T);
   SELECT(Sheet, TSN, , Staff.TSN, Memo.tmp_mb());
   SRCINSEL(Sheet, EQ, , L_DatTim.DAY(BegD));
   WHILE OCCURE(Sheet) & (Sheet.Day <= L_DatTim.DAY(EndD)) DO
    CONFORM(Sheet, JMode);
    IF JMode.Type = 2(*ந⢥*) THEN
     INC(T, Sheet.Tim);
    END;
    NEXT(Sheet);
   END; (* WHILE OCCURE(Sheet) ... *)
  END;
  RETURN T;
 END {GetTimDone};

 PUBLIC PROCEDURE FO_Piece();
  VAR
   Tim: LIKE(Money.Tim);
 BEGIN
  L_EDO.InitPrepareFOrder();
  L_General.Assert(FOrder.Closed = Memo.tmp_mb(), "᫥  " + L_DatTim.PeriodStr(Memo.tmp_mb()));
  L_General.Assert(FOrder.Period = Memo.tmp_mb(), "᫥    ⥪騩 ");
 
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   IF L_Staff.IsBegan(Memo.tmp_mb()) & L_Staff.IsWorking(Memo.tmp_mb()) THEN
    SETZERO(Tim);
    HISTCONF(Memo.tmp_me(), Staff, StaffLog);
    REPEAT
     IF NeedLog() THEN
      IF ~L_PRoll.IsShtD() THEN
       L_PRoll.StaffCountUp(Staff.TSN, Memo.tmp_mb());
      END;
      Tim:=GetTimDone();
      IF Tim > 0 THEN
       L_EDO.AppendFOrderL(Tim, 0);
      END;
     END;
    UNTIL ~PREV(StaffLog) | (StaffLog.DateE < Memo.tmp_mb());
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
 END {FO_Piece};

END.
