(*
%Copyright   (c) Polak IT
%Author      09.08.2011 18:40:00 POLAK\LDA
%Purpose        ६⭮   ᬥ
%Type        report
%Specific    LOC
%Modified    04.01.2013 17:06:57 POLAK\LDA
%Environment
*)

 MODULE Rpr28 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Rpr, L_StdFrm, L_General, L_PCS, L_OwnData, L_Staff, L_AFM, P_Rpr, Str, L_DatTim, L_Str;

(*
$P{ Top_28:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
?, L, "H:M"
?, L, "D.N.y"
?, L, "H:M"
?, L, ""
@
#######################################################################################       ########## #####
=#####========================================================================================================
|                                 ६⭮   ᬥ                           |
|                                     ########## #####  ########## #####                                  |
|############################################################################################################|
}
*)

(*
$P{ SubTop_28_0:
?, L, ", ਭ  ।饩 ᬥ|??????????|, ।  ᫥ ᬥ"
@
|------------------------------------------------------------------------------------------------------------|
|                                                                                                            |
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|    |ꥪ ६                  |⨥   |⪠ ଠ                              |
|-------|--------------------------------|--------------|----------------------------------------------------|
}
*)

(*
$P{ Line_28_0:
RprS.RprS, L, ""
RprS.RprObjId + " " + CUCopy.Serial, L, ""
RprS.OrdDate, L, "D.N.Y"
RprS.OrdTime, L, "H:M"
?, L, ""
@
|#######|################################|######## #####|####################################################|
}
*)

(*
$P{ SubBot_28_0:
?, R, "0"
@
|------------------------------------------------------------------------------------------------------------|
|ᥣ     ####                                                                                              |
}
*)

(*
$P{ SubTop_28_1:
@
|------------------------------------------------------------------------------------------------------------|
|                                                                                                            |
|।  ᯫ   ࠭   祭 ᬥ                                               |
|------------------------------------------------------------------------------------------------------------|
|    |ꥪ ६                  |⨥   |⪠ ଠ               | ᯫ|
|-------|--------------------------------|--------------|-------------------------------------|--------------|
}
*)

(*
$P{ Line_28_1:
RprS.RprS, L, ""
RprS.RprObjId + " " + CUCopy.Serial, L, ""
RprS.OrdDate, L, "D.N.Y"
RprS.OrdTime, L, "H:M"
?, L, ""
RprS.EDate, L, "D.N.Y"
RprS.ETime, L, "H:M"
@
|#######|################################|######## #####|#####################################|######## #####|
}
*)

(*
$P{ SubBot_28_1:
?, R, "0"
?, R, "0"
?, R, "0"
@
|------------------------------------------------------------------------------------------------------------|
|ᥣ     ###                    ###         ।  ᯫ     ###              |
}
*)

(*
$P{ SubBot_28_2:
?, R, "0"
?, R, "0"
@
|------------------------------------------------------------------------------------------------------------|
|ᥣ     ###                    ###                                                        |
}
*)

(*
$P{ Bot_28:
L_Str.ShortName(L_PCS.GetFullNameOfCurrentUser(SYSDATE())), R, ""
@
|============================================================================================================|
|                                                     |                                                      |
|                                            |                                           |
|          ________________ ####################|        ________________  _____________________ |
|                                              |                             ..       |
|                                                     |                                                      |
|                                                     |                                                      |
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE InsIntoTmp(trgState: SCAL[3]; trgOrdDTS: TIMESTAMP);
 BEGIN
  RprSL.State:=trgState;
  RprSL.OrdDTS:=trgOrdDTS;
  RprSL.RprS  :=RprS.RprS;
  INSERT(RprSL);
 END {InsIntoTmp};

 PUBLIC PROCEDURE Rpr28();
  CONST
   s_FromPrvShift = 0;
   s_InExpl       = 1;
   s_ToNextShift  = 2;

   RepName = "Rpr28";
  VAR
   curState      : SCAL[3];
   BegShiftDate,
   EndShiftDate  : DATE;
   BegShiftTime,
   EndShiftTime  : TIME;
   Title,
   ShortRprSDescr: STRING[];
   OrdDTS,
   EndDTS,
   BegShiftDTS,
   EndShiftDTS   : TIMESTAMP;
   NewAmnt,
   TotalAmnt,
   InExplAmnt    : NUMERIC[0];
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_Rpr.GetCurShiftBeginEnd(BegShiftDate, BegShiftTime, EndShiftDate, EndShiftTime);
  STDFORM(L_StdFrm.sf_Choice("|砫 ᬥ:    %##########%  %#####%" +
                             "|" +
                             "|砭 ᬥ: %##########%  %#####%",
                             "%<D.N.y>I" +"%<H:M>I" + "%<D.N.y>I" + "%<H:M>I"),
          " ਮ ࠡ ᬥ ", , 1, BegShiftDate, BegShiftTime, EndShiftDate, EndShiftTime);

  Title:=L_PCS.GetPostNameOfCurrentUser(SYSDATE()) + " " + L_PCS.GetFullNameOfCurrentUser(SYSDATE());

  BegShiftDTS:=L_DatTim.GetTIMESTAMP(BegShiftDate, BegShiftTime);
  EndShiftDTS:=L_DatTim.GetTIMESTAMP(EndShiftDate, EndShiftTime);
  L_AFM.MakeIndex("RprSL", "State: SCAL[3]; OrdDTS: TIMESTAMP; RprS: LIKE(RprS.RprS)");


  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top_28, RepName, BegShiftDate, BegShiftTime, EndShiftDate, EndShiftTime, Title);
  SELECT(RprS, EDate);
  SRCINSEL(RprS, GE, , BegShiftDate, BegShiftTime);
  WHILE OCCURE(RprS) DO
   IF (RprS.Status # L_Rpr.ms_Cancel) & L_Rpr.IsRepairZoneLocation(RprS.Location) THEN
    PROMPT(" " + RprS.RprS);
    OrdDTS:=L_DatTim.GetTIMESTAMP(RprS.OrdDate, RprS.OrdTime);
    IF ~!RprS.EDate THEN
     EndDTS:=L_DatTim.GetTIMESTAMP(RprS.EDate, RprS.ETime);
    ELSE
     SETEMPTY(EndDTS);
    END;
    IF OrdDTS < EndShiftDTS THEN
     IF    OrdDTS < BegShiftDTS THEN
      InsIntoTmp(s_FromPrvShift, OrdDTS);
     END;
     IF ~!EndDTS & (EndDTS <= EndShiftDTS) THEN
      InsIntoTmp(s_InExpl, OrdDTS);
     END;
     IF !EndDTS | (EndDTS > EndShiftDTS) THEN
      InsIntoTmp(s_ToNextShift, OrdDTS);
     END;
    END;
   END;
   NEXT(RprS);
  END; (* WHILE OCCURE(RprS) ... *)

  FOR_EACH curState DO
   SELECT(RprSL, RprSL, , curState);
   IF curState = s_InExpl THEN
    MAKEPART(R, SubTop_28_1);
   ELSE
    MAKEPART(R, SubTop_28_0, curState);
   END;
   SETZERO(NewAmnt, TotalAmnt, InExplAmnt);
   WHILE OCCURE(RprSL) DO
    SEARCH(RprS, RprS, , RprSL.RprS);
    ShortRprSDescr:=P_Rpr.GetShortRprSDescr(RprS.RprS);
    IF !ShortRprSDescr THEN
     CONFORM(RprS, RprDA);
     CONFORM(RprDA, RprDfApr);
     CONFORM(RprDfApr, CarBlock);
     ShortRprSDescr:=CarBlock.Name + ": " + Str.Small(RprDfApr.Name);
   
     IF RprDfApr.Leaf = 0 THEN
      ShortRprSDescr:=ShortRprSDescr + " (ॡ 筥)";
     END;
     ShortRprSDescr:=ShortRprSDescr + " [" + RprDfApr.RprDfApr + "]";
    END;
    PROMPT(" " + RprS.RprS);
    CONFORM(RprS, CUCopy);
    L_Rpr.AccessMark(RprS.OrdDate);
    IF curState = s_InExpl THEN
     MAKEPART(R, Line_28_1, ShortRprSDescr);
     INC(InExplAmnt);
    ELSE
     MAKEPART(R, Line_28_0, ShortRprSDescr);
    END;
    IF RprSL.OrdDTS >= BegShiftDTS THEN
     INC(NewAmnt);
    END;
    INC(TotalAmnt);
    NEXT(RprSL);
   END; (* WHILE OCCURE(RprSL) ... *)

   IF    curState = s_FromPrvShift THEN
    MAKEPART(R, SubBot_28_0, TotalAmnt);
   ELSIF curState = s_InExpl THEN
    MAKEPART(R, SubBot_28_1, TotalAmnt, NewAmnt, InExplAmnt);
   ELSIF curState = s_ToNextShift THEN
    MAKEPART(R, SubBot_28_2, TotalAmnt, NewAmnt);
   END;
  END; (* FOR_EACH curState...*)

  MAKEPART(R, Bot_28);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {Rpr28};

END.
