(*
%Copyright   (c) Polak Computer System
%Author      08.10.2003 17:54:51 POLAK\Gina
%Purpose     ନ஢ ਪ  ᫥  ⮣ ࠡ
%Type        operation
%Specific    LOC
%Modified    23.10.2012 13:44:27 POLAK\San
%Environment
*)

 IMPORT Memo, L_General, L_PRoll, L_OwnData, L_Staff, L_Money, L_Man, L_StdFrm,
        L_DatTim, L_EDO, L_Env;

 CONST
  RepName  = "FoAdP";

 VAR
  Stage : NUMERIC[2];
  Decr,
  KStage: NUMERIC[3];
  SumToPay: L_PRoll.tSum;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
@
################################################################ ########## #####
=#####===========================================================================
|                 ⮪ ᫥ ६  ⮣ ࠡ                   |
|-------------------------------------------------------------------------------|
|. |                          |       |⠦||.%|    㬬|
|-----|-----------------------------|----------------|----|----|------|---------|
}
*)

(*
$P{ Line:
Staff.TSN, L, ""
Man.Name, L, ""
Post.Name, L, ""
Stage, R, "1."
KStage, R, "1."
Decr, R, "1."
FOrderL.Value, R, "2-"
@
|#####|#############################|################|####|####|######|#########|
}
*)

(*
$P{ Bot:
FOrder.Sum, R, "2-"
@
|-------------------------------------------------------------------------------|
|⮣                                                          ################|
=(c) Polak=======================================================================
}
*)

 PRIVATE PROCEDURE GetStageValue(): NUMERIC[3];
  VAR
   D: DATE;
 BEGIN
  Stage:=L_DatTim.YearsInIntvl(L_Man.GetRealBegDate(FOrder.Date), FOrder.Date);
  IF    Stage >= 15.00 THEN
   RETURN 1.4;
  ELSIF Stage >= 10.00 THEN
   RETURN 1.2;
  ELSIF Stage >=  5.00 THEN
   RETURN 1.0;
  ELSIF Stage >=  1.00 THEN
   RETURN 0.8;
  ELSE
   RETURN 0.5;
  END;
 END {GetStageValue};

 PRIVATE PROCEDURE GetDecrValue(): NUMERIC[3];
 BEGIN
  SELECT(EDOrderL, TSN, , Staff.TSN);
  SRCINSEL(EDOrderL, LT, , FOrder.Date);
  WHILE OCCURE(EDOrderL) & (EDOrderL.Closed>=L_DatTim.YearBeg(FOrder.Date)) DO
   PROMPT(" ਪ " + EDOrderL.EDOrder);
   IF (EDOrderL.Status=L_EDO.st_Passed) &
      (EDOrderL.Type#L_EDO.type_Cancel) THEN
    IF (EDOrderL.EDOKind = 019) | (*१ ﭨ*)
       (EDOrderL.EDOKind = 020) | (*१ ﭨ*)
       (EDOrderL.EDOKind = 050) | (*१ ﭨ*)
       (EDOrderL.EDOKind = 013)   (*ண*) THEN
     RETURN 100;
    ELSIF (EDOrderL.EDOKind = 010) | (*䨭ᮢ 襭*)
          (EDOrderL.EDOKind = 111)   (*䨭ᮢ 襭*) THEN
     RETURN 50;
    END;
   END;
   PREV(EDOrderL);
  END; (* WHILE OCCURE(EDOrderL) ... *)
  RETURN 0;
 END {GetDecrValue};

BEGIN
 L_EDO.InitPrepareFOrder();
 SETEMPTY(SumToPay);
 LOOP
  STDFORM(L_StdFrm.PartForm(
                        "%RI"+
                        "%< 믮 >DB"+
                        "%< ⬥ >X"+
                        "@"+
                        "|   ᫨ ६  १⠬ ࠡ    "+
                        "|                                             "+
                        "|     ࠧ         %##########%      "+
                        "|                                             "+
                        "|     %###########%          %##########%     "),
                        " ନ஢ ਪ  ᫥ ",
                        ,
                        -1,
                        SumToPay);
  IF !SumToPay THEN
   L_StdFrm.ShowINFORM_AsSTOP("室 㪠  ࠧ ६");
  ELSE
   EXIT;
  END;
 END;

 OPENREP(R, L_General.NameConnection(RepName), Create);
 MAKEPART(R, Top);

 SELECT(Staff, TSN);
 WHILE OCCURE(Staff) DO
  PROMPT(Staff.TSN);
  CONFORM(Staff, Man);
  IF L_Staff.rInState(FOrder.Date) THEN
   CONFORM(Staff, Man);
   CONFORM(StaffLog, Officer, Post);
   KStage          :=GetStageValue();
   FOrderL.Value   :=L_Money.RoundMoney(Memo.tmp_mb(), SumToPay*KStage);
   Decr            :=0;
   IF FOrderL.Value > 0 THEN
    L_EDO.AppendFOrderL(0, FOrderL.Value);
    L_PRoll.ShtDone(0);
   ELSE
    SETEMPTY(FOrderL.Value);
   END;
   MAKEPART(R, Line);
  END; (* IF IF L_Staff.rInState... *)
  NEXT(Staff);
 END; (* WHILE OCCURE(Staff) ... *)

 MAKEPART(R, Bot);
 CLOSEREP(R);

END.
