(*
%Copyright   (c) Polak IT
%Author      22.01.2003 17:50:19 POLAK\GINA
%Purpose      ᪮ன     ࠢ࠭
%Type        report
%Specific    LOC
%Modified    26.02.2013 13:15:20 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT Memo, L_Way, L_DatTim, L_General, L_OwnData, L_AFM, L_Car;

 CONST
  _Column = 05;
  _Route  = "0550";
  RepName = "Sht01";

  VAR
   T_AmTotal,
   T_AmLine,
   _AmLine,
   _AmTotal: NUMERIC[0]; (*_AmTotal- ⮬, 騥 ࠡ  ६  *)
   T_WorkTim,
   T_RepTim,
   T_Run,
   _WorkTim,
   _RepTim,
   _Run: NUMERIC[3];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
############################################## ########## #####
=#####=========================================================
| / ᪮ன   ਮ  ##########  ##########|
|-------------------------------------------------------------|
||    ᥣ| | ࠡ⠭|     |      ஡|
|    |      a/|    |      ᮢ|        |            |
|----|---------|---------|-----------|-----------|------------|
}
*)

(*
$P{ Line:
Tmp01._Date, L, "D"
_AmTotal, R, "0"
_AmLine, R, "0"
_WorkTim, R, "3."
_RepTim, R, "3."
_Run, R, "2."
@
|####|#########|#########|###########|###########|############|
}
*)

(*
$P{ Bot:
T_AmTotal, R, "0"
T_AmLine, R, "0"
T_WorkTim, R, "3."
T_RepTim, R, "3."
T_Run, R, "2."
@
|----|---------|---------|-----------|-----------|------------|
|⮣|#########|#########|###########|###########|############|
=(c) Polak=====================================================

 . ४ a/k 1791                          ஡쥢 ..


                                        . .
}
*)

 PRIVATE PROCEDURE GatherTmp01();
 BEGIN
  SELECT(Car, Column, , _Column);
  WHILE OCCURE(Car) DO
   PROMPT(" "+Car.BoxNbr);
   SELECT(RWayS, BoxNbr, , Car.BoxNbr);
   SRCINSEL(RWayS,GE, , Memo.ud_fr());
   WHILE OCCURE(RWayS) & (RWayS.Date<=Memo.ud_ut()) DO
    CONFORM(RWayS, RWayJ);
    SETZERO(_WorkTim, _RepTim, _Run);
    WHILE OCCURE(RWayJ) DO
     CONFORM(RWayJ, SEJobs, WJMode);
(*
     IF SEJobs.Route = _Route THEN     (*६ ⭮  ⤥쭮 *)
*)
      IF    WJMode.WJType = L_Way.WJType_Work THEN
       INC(_WorkTim, RWayJ.StopT - RWayJ.StartT);
      ELSIF WJMode.WJType = L_Way.WJType_Repair THEN
       INC(_RepTim, RWayJ.StopT - RWayJ.StartT);
      END;
      INC(_Run, RWayJ.Run*RWayJ.Fact);
(*
     END;
*)
     NEXT(RWayJ);
    END; (* WHILE OCCURE(RWayJ) ... *)
    ADD(Tmp01, Tmp01, , RWayS.Date, RWayS.BoxNbr,
                        Tmp01._WorkTim, _WorkTim,
                        Tmp01._RepTim,  _RepTim,
                        Tmp01._Run, _Run);
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS) ... *)
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
 END {GatherTmp01};

 PRIVATE PROCEDURE Print();
 BEGIN
  SETZERO(T_AmTotal, T_AmLine, T_WorkTim, T_RepTim, T_Run);
  SELECT(Tmp01, Tmp01);
  WHILE OCCURE(Tmp01) DO
   CHANGESEL(Tmp01, Tmp01, , Tmp01._Date);
   SETZERO(_AmLine, _AmTotal, _WorkTim, _RepTim, _Run);
   WHILE OCCURE(Tmp01) DO
    PROMPT(" "+L_DatTim.DateStr(Tmp01._Date));
    IF Tmp01._WorkTim > 0 THEN
     INC(_AmLine);
    END;
    INC(_AmTotal);
    INC(_WorkTim, Tmp01._WorkTim);
    INC(_RepTim,  Tmp01._RepTim);
    INC(_Run,     Tmp01._Run);
    NEXT(Tmp01);
   END; (* WHILE OCCURE(Tmp01) ... *)
   INC(T_AmTotal, _AmTotal);
   INC(T_AmLine,  _AmLine);
   INC(T_WorkTim, _WorkTim);
   INC(T_RepTim,  _RepTim);
   INC(T_Run,    _Run);
   LAST(Tmp01);
   MAKEPART(R, Line);
   CHANGESEL(Tmp01, Tmp01);
   NEXT(Tmp01);
  END; (* WHILE OCCURE(Tmp01) ... *)
 END {Print};

BEGIN
 SE_ACCESSDATAMODE(AccessDataMode_SOFT);
 OPENREP(R, L_General.NameConnection(RepName), Create);
 MAKEPART(R, Top);

 L_AFM.MakeMultipleIndex("Tmp01",
                            "_Date: LIKE(RWayS.Date);"+
                            "_BoxNbr: LIKE(Car.BoxNbr);"+
                            "_WorkTim: NUMERIC[3];"+
                            "_RepTim: NUMERIC[3];"+
                            "_Run: NUMERIC[2];",
                            "Tmp01: _Date, _BoxNbr");

 GatherTmp01();
 Print();

 MAKEPART(R, Bot);
 CLOSEREP(R);
 L_AFM.AF_PurgeTemp("Tmp01");

END.
