[ASB Client]
Host            = localhost
AsbpPort        = 5301
AsbpsPort       = 5401
AsbpSchannel    = No
HttpPort        = 5380
HttpsPort       = 5480
HttpSchannel    = No
LocationAtServer= .

[ASB Special Folders]
ServerProjectRoot = ..\AUTOPARKSRV
Lib               = ..\AUTOPARK\$_LIB
ClientASBRoot     = ..\ASBCLIENT
ServerASBRoot     = ..\ASBSERVER

[Redirection]
_*.asl       = asl\tools
*.asl        = asl\tmp_lib;asl\Stable;asl;$(lib)\asl\ap_pc;$(lib)\asl\ap;$(lib)\asl\sys;$(lib)\asl\core;asl\cards;
*.wdo        = wdo\tmp_lib;wdo\Stable;wdo;$(lib)\wdo\ap_pc;$(lib)\wdo\ap;$(lib)\wdo\sys;
*.mnu        = mnu\tmp_lib;mnu\Stable;mnu;$(lib)\mnu\ap_pc;$(lib)\mnu\ap;$(lib)\mnu\sys;def
*.dot        = dot\by_user;dot\tmp_lib;dot;$(lib)\dot\ap;$(lib)\dot\sys
*.xlt        = xlt;xlt\local;xlt\tmp_lib;xlt\Stable;$(lib)\xlt\ap;$(lib)\xlt\sys
*.xla        = xla;xla\tmp_lib;xla\Stable;$(lib)\xla\ap_pc;$(lib)\xla\ap;$(lib)\xla\sys;

*_??.rep     = rep\$$
*_??01.rep   = rep\01
*_??02.rep   = rep\02
*_??03.rep   = rep\03
*_??04.rep   = rep\04
*_??05.rep   = rep\05
*_??06.rep   = rep\06
*_??07.rep   = rep\07
*_??08.rep   = rep\08
*_??09.rep   = rep\09
*_??10.rep   = rep\10
*_??11.rep   = rep\11
*_??12.rep   = rep\12
*.rep        = rep

*.xls        = rep\xls

*.imp        = txt
*.exp        = txt
*.txt        = txt
*.dbf        = txt
*.jpg        = txt\images

*.erh        = tjr
*.eeh        = tjr
*.ecn        = tjr
*.rpl        = tjr
*.ses        = tjr
*.usr        = tjr

*.ntf        = tmp
*.lst        = tmp
*.did        = tmp
*.kid        = tmp
*.tmp        = tmp
