(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose     ᯥ⪠ ࠧ浪
%Type        report
%Specific    AP
%Modified    06.06.2014 11:23:20 POLAK\Gina
%Environment
*)

 MODULE BegRWP [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Str, L_Env, L_DatTim, L_AFM,
        Str, L_BegRWS, L_Way, E_Utils, L_Car, L_Staff, L_AvePay, L_EC,
        Memo, L_PagePr, P_Firm, L_MDoc, L_two, L_StdFrm, Math,
        L_XDoc, L_Msg, L_lsStore, L_Sheet;

 PRIVATE TYPE
  tBType = SCAL[4];

 PRIVATE CONST
  PageSize = 62;
  LPerPage = 66;
  LineWidth    = 150;
  LineWidth_TP = 100;

  bt_Line   = 0;
  bt_Outage = 1;
  bt_Repair = 2;
  bt_Other  = 3;

  bk_Staff  = 0;
  bk_Car    = 1;
  bk_Exit   = 2;

  cp_All    = 0; (*CurPurpose*)
  cp_Common = 1;
  cp_Depart = 2;

 PRIVATE VAR
  _BTime    : LONGTIME[2];
  _ETime    : LTIME;
  RepTopLine: STRING[][6];
  _BTypeName: STRING[];
  RepName   : STRING[];
  DelimitersEveryLine: SCAL[2];
  Top,
  Line,
  EmptyLine,
  DlmLine,
  PostFix  : STRING[];
  LinAppendix: STRING[];
  curMyFirm: P_Firm.tMyFirm;
  RWaySCnt : NUMERIC[2];
  CurPurpose: LIKE(CarLog.Purpose);

 PRIVATE PROCEDURE BTypeStr(Title: STRING[]): STRING[];
 BEGIN
  RETURN Title + "  " + L_DatTim.DateStr(Memo.ud_cd()) + ", " + L_DatTim.WeekDayStr(L_DatTim.WEEKDAY(Memo.ud_cd()), 0);
 END {BtypeStr};

(*
$P{ RepTop:
RepTopLine[0], R, ""
RepTopLine[1], R, ""
RepTopLine[2], R, ""
RepTopLine[3], R, ""
RepTopLine[4], R, ""
RepTopLine[5], R, ""
@
################################################################################################################################################################################
################################################################################################################################################################################
################################################################################################################################################################################
################################################################################################################################################################################
################################################################################################################################################################################
################################################################################################################################################################################

}
*)

(*
$P {Top:
P_Firm.FP_FirmName(P_Firm.fomf(curMyFirm), SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
PAGENUM(R), R, ""
_BTypeName, C, ""
@
##############################################################################################################################################################  ########## #####
=#####================================================================================================================================================================= ##==
|##############################################################################################################################################################################|
|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|                            | |  砫  |     | |                        |       |                          |                          |     |                          |
| 室                ||  |  ||⮬              |/ |⥫                  |                 |砫|ਬ砭                |
}
*)

(*
$P { Line:
ExitClss.Sign, L, ""
ExitClss.Name, L, ""
RWayS.Change, L, "|1|2"
_BTime, L, "H:M"
DelimitersEveryLine, L, "....|    "
_ETime, L, "H:M"
DelimitersEveryLine, L, "....|    "
?, L, " |*"
CarAsStr(RWayS.BoxNbr, RWayS.Date, 0), L, ""
RWayS.RWayS, L, ""
StaffAsStr(RWayS.TSN, 1), L, ""
?, L, ""
?, L, "H:M"
LinAppendix, L, ""
@
|####### ####################|#|##### ####|##### ####|#|########################|#######|##########################|##########################|#####|##########################|
}
*)

(*
$P { EmptyLine:
@
|                            | |          |          | |                        |       |                          |                          |     |                          |
}
*)

(*
$P{ DlmLine:
@
|----------------------------|-|----------|----------|-|------------------------|-------|--------------------------|--------------------------|-----|--------------------------|
}
*)

(*
$P{ AWLMLine:
?, L, ""
?, L, "H:M"
LinAppendix, L, ""
@
|                            | |          |          | |                        |       |                          |##########################|#####|##########################|
}
*)

(*
$P {Bot:
@
=(c) Polak======================================================================================================================================================================
}
*)

(*
$P {TopExtra:
P_Firm.FP_FirmName(P_Firm.fomf(curMyFirm), SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
PAGENUM(R), R, ""
_BTypeName, C, ""
@
############################################################################################################################################################### ########## #####
======================================================================================================================================================================= ##==
|##############################################################################################################################################################################|
|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|                            | |  砫  |     | |                        |       |                          |                                                           |
| 室                ||  |  ||⮬              |/ |⥫                  |ਬ砭                                                 |
}
*)

(*
$P { LineExtra:
ExitClss.Sign, L, ""
ExitClss.Name, L, ""
RWayS.Change, L, "|1|2"
_BTime, L, "H:M"
DelimitersEveryLine, L, "....|    "
_ETime, L, "H:M"
DelimitersEveryLine, L, "....|    "
?, L, " |*"
CarAsStr(RWayS.BoxNbr, RWayS.Date, 0), L, ""
RWayS.RWayS, L, ""
StaffAsStr(RWayS.TSN, 1), L, ""
@
|####### ####################|#|##### ####|##### ####|#|########################|#######|##########################|                                                           |
}
*)

(*
$P { EmptyLineExtra:
@
|                            | |          |          | |                        |       |                          |                                                           |
}
*)

(*
$P{ DlmLineExtra:
@
|----------------------------|-|----------|----------|-|------------------------|-------|--------------------------|-----------------------------------------------------------|
}
*)

(*
$P {Top_E:
P_Firm.FP_FirmName(P_Firm.fomf(curMyFirm), SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
PAGENUM(R), R, ""
?, C, ""
@
############################################################################################################################################################### ########## #####
======================================================================================================================================================================= ##==
|##############################################################################################################################################################################|
}
*)

(*
$P{ Line_E:
?, C, ""
@
|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|##############################################################################################################################################################################|
}
*)

(*
$P {Top1:
P_Firm.FP_FirmName(P_Firm.fomf(curMyFirm), SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
BTypeStr("ਫ  ࠧ浪"), C, ""
@
############################################################################################################################################################### ########## #####
================================================================================================================================================================================
|##############################################################################################################################################################################|
|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|/ |⮬     | 室             | 砫 |⥫                  |᫠                                                                           |
}
*)

(*
$P {Line1:
RWayS.RWayS, L, ""
CarAsStr(RWayS.BoxNbr, RWayS.Date, 0), L, ""
ExitClss.Sign, L, ""
ExitClss.Name, L, ""
RWayS.Change, L, ""
_BTime, L, "H:M"
_ETime, L, "H:M"
StaffAsStr(RWayS.TSN, 1), L, ""
PrintMessage(), L, ""
@
|-------|---------------|-------------------------|-------------|--------------------------|-----------------------------------------------------------------------------------|
|#######|###############|####### #################|# ##### #####|##########################|###################################################################################|
}
*)

(*
$P{ Line2:
?, L, ""
@
|##############################################################################################################################################################################|
}
*)

(*
$P{ Bot1:
@
=(c) Polak======================================================================================================================================================================
}
*)

(*
$P {TopDP:
P_Firm.FP_FirmName(P_Firm.fomf(curMyFirm), SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
PAGENUM(R), R, ""
BTypeStr("祭 ⥫, ਫ  ࠧ浪"), C, ""
@
#####################################################################################################################################################           ########## #####
======================================================================================================================================================================= ##==
|##############################################################################################################################################################################|
|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|/ |⮬     | 室             | 砫 |⥫                  |祭 ⥫                                                                    |
}
*)

(*
$P {LineDP:
RWayS.RWayS, L, ""
CarAsStr(RWayS.BoxNbr, RWayS.Date, 0), L, ""
ExitClss.Sign, L, ""
ExitClss.Name, L, ""
RWayS.Change, L, ""
_BTime, L, "H:M"
_ETime, L, "H:M"
StaffAsStr(RWayS.TSN, 1), L, ""
StaffAsStr(WayLMen.TSN, 1), L, ""
@
|-------|---------------|-------------------------|-------------|--------------------------|-----------------------------------------------------------------------------------|
|#######|###############|####### #################|# ##### #####|##########################|###################################################################################|
}
*)

(*
$P{ BotDP:
@
=(c) Polak======================================================================================================================================================================
}
*)

(*
$P{ ISTop:
P_Firm.FP_FirmName(P_Firm.fomf(curMyFirm), SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
PAGENUM(R), R, ""
BTypeStr("⮣   ᮭ"), C, ""
@
###################################################################################################################               ########## #####
========================================================================================================================================= ##==
|################################################################################################################################################|
|------------------------------------------------------------------------------------------------------------------------------------------------|
|⥣ ᮭ                  |  ᥣ|  |   1 |   2 | /| | ||    /| |  | 室| 祥|
}
*)

(*
$P{ ISLine:
?, L, ""
?, L, ""
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
@
|#################################### ###|#######|#######|#######|#######|#######|#######|#######|#######|#######|#######|#######|#######|#######|
}
*)

(*
$P{ DLine:
@
|----------------------------------------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|
}
*)

(*
$P{ ISBot:
@
=(c) Polak========================================================================================================================================
}
*)

(*
$P{ ICTop:
P_Firm.FP_FirmName(P_Firm.fomf(curMyFirm), SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
BTypeStr("⮣   "), C, ""
@
######################################################################## ########## #####
=========================================================================================
|#######################################################################################|
|---------------------------------------------------------------------------------------|
|            | ᥣ| |  1 |  2 |/|||祥|  |  |
|-------------------|------|------|------|------|------|------|------|------|-----|-----|
}
*)

(*
$P{ ICLine:
?, L, ""
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "3."
?, R, "3."
@
|###################|######|######|######|######|######|######|######|######|#####|#####|
}
*)

(*
$P{ ICDlm:
@
|-------------------|------|------|------|------|------|------|------|------|-----|-----|
}
*)

(*
$P{ IETop:
BTypeStr("⮣   ॣ 室"), C, ""
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
@
=========================================================================================
|#######################################################################################|
|---------------------------------------------------------------------------------------|
|                   | ᥣ| |  1 |  2 |/|      |      ||           |
|                   |######|######|######|######|######|      |      |######|           |
=(c) Polak===============================================================================
}
*)

(*
$P{ IETop_Empty:
BTypeStr("⮣   ॣ 室"), C, ""
@
=========================================================================================
|#######################################################################################|
|---------------------------------------------------------------------------------------|
| ॣ 室.                                                                |
=(c) Polak===============================================================================
}
*)

(*
$P{ RepTop_TP:
RepTopLine[0], R, ""
RepTopLine[1], R, ""
RepTopLine[2], R, ""
RepTopLine[3], R, ""
RepTopLine[4], R, ""
RepTopLine[5], R, ""
@
############################################################################################
############################################################################################
############################################################################################
############################################################################################
############################################################################################
############################################################################################

}
*)

(*
$P {Top_TP:
P_Firm.FP_FirmName(P_Firm.fomf(curMyFirm), SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
PAGENUM(R), R, ""
_BTypeName, C, ""
@
########################################################################### ########## #####
=================================================================================== ##==
|##########################################################################################|
|------------------------------------------------------------------------------------------|
|  | |     |     | |                     |       |                         |          |
|室 ||砫|||࠭ᯮ⭮ ।⢮|/ |⥫                 |ਬ砭|
}
*)

(*
$P { Line_TP:
ExitClss.Sign, L, ""
RWayS.Change, L, "|1|2"
_BTime, L, "H:M"
_ETime, L, "H:M"
?, L, " |*"
CarAsStr(RWayS.BoxNbr, RWayS.Date, 1), L, ""
RWayS.RWayS, L, ""
StaffAsStr(RWayS.TSN, 1), L, ""
DelimitersEveryLine, L, "......|      "
@
|#######|#|#####|#####|#|#####################|#######|#########################|##########|
}
*)

(*
$P { EmptyLine_TP:
@
|       | |     |     | |                     |       |                         |          |
}
*)

(*
$P{ DlmLine_TP:
@
|-------|-|-----|-----|-|---------------------|-------|-------------------------|----------|
}
*)

(*
$P {Bot_TP:
@
=(c) Polak==================================================================================
}
*)

(*
$P {TopExtra_TP:
P_Firm.FP_FirmName(P_Firm.fomf(curMyFirm), SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
PAGENUM(R), R, ""
_BTypeName, C, ""
@
########################################################################### ########## #####
=================================================================================== ##==
|##########################################################################################|
|------------------------------------------------------------------------------------------|
|  | |     |     | |                     |       |                         |          |
|室 ||砫|||࠭ᯮ⭮ ।⢮|/ |⥫                 |ਬ砭|
}
*)

(*
$P { LineExtra_TP:
ExitClss.Sign, L, ""
RWayS.Change, L, "|1|2"
_BTime, L, "H:M"
_ETime, L, "H:M"
?, L, " |*"
CarAsStr(RWayS.BoxNbr, RWayS.Date, 1), L, ""
RWayS.RWayS, L, ""
StaffAsStr(RWayS.TSN, 1), L, ""
@
|#######|#|#####|#####|#|#####################|#######|#########################|          |
}
*)

(*
$P { EmptyLineExtra_TP:
@
|       | |     |     | |                     |       |                         |          |
}
*)

(*
$P{ DlmLineExtra_TP:
@
|-------|-|-----|-----|-|---------------------|-------|-------------------------|----------|
}
*)

(*
$P {Top_E_TP:
P_Firm.FP_FirmName(P_Firm.fomf(curMyFirm), SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
PAGENUM(R), R, ""
@
########################################################################### ########## #####
=================================================================================== ##==
}
*)

(*
$P{ Line_E_TP:
?, C, ""
@
|------------------------------------------------------------------------------------------|
|##########################################################################################|
}
*)

(*
$P {Top1_TP:
P_Firm.FP_FirmName(P_Firm.fomf(curMyFirm), SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
BTypeStr("ਫ  ࠧ浪"), C, ""
@
##################################################################################### ########## #####
======================================================================================================
|####################################################################################################|
|----------------------------------------------------------------------------------------------------|
|/ |.|..| 砫 |⥫                  |᫠                              |
}
*)

(*
$P {Line1_TP:
RWayS.RWayS, L, ""
RWayS.BoxNbr, L, ""
ExitClss.Sign, L, ""
RWayS.Change, L, ""
_BTime, L, "H:M"
_ETime, L, "H:M"
StaffAsStr(RWayS.TSN, 1), L, ""
PrintMessage(), L, ""
@
|-------|----|-------|-------------|--------------------------|--------------------------------------|
|#######|####|#######|# ##### #####|##########################|######################################|
}
*)

(*
$P{ Line2_TP:
?, L, ""
@
|####################################################################################################|
}
*)

(*
$P{ Bot1_TP:
@
=(c) Polak============================================================================================
}
*)

(*
$P {TopDP_TP:
P_Firm.FP_FirmName(P_Firm.fomf(curMyFirm), SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
PAGENUM(R), R, ""
BTypeStr("祭 ⥫, ਫ  ࠧ浪"), C, ""
@
##################################################################################### ########## #####
============================================================================================= ##==
|####################################################################################################|
|----------------------------------------------------------------------------------------------------|
|/ |.|..| 砫 |⥫                      |祭 ⥫                   |
}
*)

(*
$P {LineDP_TP:
RWayS.RWayS, L, ""
RWayS.BoxNbr, L, ""
ExitClss.Sign, L, ""
RWayS.Change, L, ""
_BTime, L, "H:M"
_ETime, L, "H:M"
StaffAsStr(RWayS.TSN, 1), L, ""
StaffAsStr(WayLMen.TSN, 1), L, ""
@
|-------|----|-------|-------------|------------------------------|----------------------------------|
|#######|####|#######|# ##### #####|##############################|##################################|
}
*)

(*
$P{ BotDP_TP:
@
=(c) Polak============================================================================================
}
*)

 PRIVATE PROCEDURE Create_Beg01();
 BEGIN
  CreateFILE(Beg01, "", "ﭨ  ", "");

  CreateFIELD(Beg01, MyFirm,      P_Firm.tMyFirm,      "", "",  "", " ࣠樨", "");
  CreateFIELD(Beg01, What,        SCAL[3],             "", "",  "", "⥣", "/, ࠡ⭨, 室");
  CreateFIELD(Beg01, Service,     LIKE(Sort.Sort),     "", "",  "", "㦡, ", "");
  CreateFIELD(Beg01, Depart,      LIKE(Sort.Sort),     "", "",  "", "⤥, ",  "");
  CreateFIELD(Beg01, Sort,        LIKE(Sort.Sort),     "", "",  "", "/, ", "");
  CreateFIELD(Beg01, ServiceName, LIKE(Sort.Name),     "", "",  "", "㦡, ", "");
  CreateFIELD(Beg01, DepartName,  LIKE(Sort.Name),     "", "",  "", "⤥, ",  "");
  CreateFIELD(Beg01, SortName,    LIKE(Sort.Name),     "", "",  "", "/, ", "");
  CreateFIELD(Beg01, Who,         SCAL[1E9],           "", "",  "", "ࠦ//室", "");
  CreateFIELD(Beg01, InBeg,       SCAL[2],             "", "0", "", " 拉", "");
  CreateFIELD(Beg01, InBeg0,      NUMERIC[6, 0],       "", "0", "", ".", "");
  CreateFIELD(Beg01, InBeg1,      NUMERIC[6, 0],       "", "0", "", "1 ᬥ", "");
  CreateFIELD(Beg01, InBeg2,      NUMERIC[6, 0],       "", "0", "", "2 ᬥ", "");
  CreateFIELD(Beg01, InRez,       SCAL[2],             "", "0", "", " १ࢥ", "");
  CreateFIELD(Beg01, InRep,       SCAL[2],             "", "0", "", " ६", "");
  CreateFIELD(Beg01, AveT,        LIKE(AveType.AveNo), "", "3", "", " 㬥", "0-, 1-/, 2-祥,3-");
  CreateFIELD(Beg01, DocNbr,      SCAL[1E7],           "", "",  "", "㬥", "");
  CreateFIELD(Beg01, Rest,        SCAL[2],             "", "0", "", "", "");
  CreateFIELD(Beg01, Holid,       SCAL[2],             "", "0", "", "室", "");
  CreateFIELD(Beg01, Other,       SCAL[2],             "", "0", "", "祥", "");

  CreateINDEX(Beg01, What, PLURAL, "", "", MyFirm, What, ServiceName, DepartName, SortName, Who);

  SetVersionOfFILE(Beg01, 001);
 END {Create_Beg01};

 PRIVATE PROCEDURE CarAsStr(_BoxNbr: LIKE(Car.BoxNbr); D: DATE; Short: SCAL[2]): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF L_Env.RealBoxNbr(_BoxNbr) THEN
   L_Car.StandOnCarLog(_BoxNbr, D);
   CONFORM(CarLog, Mark);
   Result:=_BoxNbr;
   IF ~Short THEN
    Result:=Result+" "+Str.Align(CarLog.StateNbr, Str.MaxLength(CarLog.StateNbr), LEFT);
   END;
   Result:=Result+" "+Mark.Name;
  ELSE
   Result:="---";
  END;
  RETURN Result;
 END {CarAsStr};

 PRIVATE PROCEDURE StaffAsStr(_TSN: LIKE(Staff.TSN); Short: SCAL[2]): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF L_Env.RealTSN(_TSN) THEN
   Result:=_TSN;
   SAVE(Staff);
   L_General.CallUs(SEARCH(Staff, TSN, _TSN));
   CONFORM(Staff, Man);
   RESTORE(Staff);
   IF Short THEN
    Result:=Result+" "+L_Str.ShortName(Man.Name);
   ELSE
    Result:=Result+" "+Man.Name;
   END;
  ELSE
   Result:="---";
  END;
  RETURN Result;
 END {StaffAsStr};

 PRIVATE PROCEDURE WithGuard(): SCAL[3];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(Memo.ud_cd(), PROCREF(E_Utils.BegRWP_WithGuard), 1);
 END {WithGuard};

 PRIVATE PROCEDURE GetBegTypeName(_BType: tBType);
 BEGIN
  IF    _BType = bt_Line THEN
   _BTypeName:="- ᪠  ࠭ᯮ ।  ";
  ELSIF _BType = bt_Outage THEN
   _BTypeName:="  ⮩ 孨᪨ ࠢ ࠭ᯮ ।";
  ELSIF _BType = bt_Repair THEN
   _BTypeName:="  ⮩ 孨᪨ ࠢ ࠭ᯮ ।";
  ELSE
   _BTypeName:=", 㦨, 宧⢥ ॢ";
  END;
  _BTypeName:=BTypeStr(_BTypeName);
  _BTypeName:=_BTypeName+", "+L_Str.PoolItem(GetPurposeList(), CurPurpose);
  IF ~!PROCREF(E_Utils.BegRWP_SubName) THEN
   _BTypeName:=_BTypeName+E_Utils.BegRWP_SubName(_BType);
  END;
 END {GetBegTypeName};

 PRIVATE PROCEDURE NeedDlmLine(_BType: tBType): SCAL[2];
 BEGIN
  RETURN DelimitersEveryLine;
 END {NeedDlmLine};

 PRIVATE PROCEDURE Print_DlmLine();
 BEGIN
  MAKEPART(R, ^DlmLine);
 END {Print_DlmLine};

 PRIVATE PROCEDURE Depth_Top(): NUMERIC[0];
  VAR
   depth: NUMERIC[0];
 BEGIN
  IF (_ExCl.BType = bt_Repair) | (_ExCl.BType = bt_Other) THEN
   depth:=DEPTH(^("TopExtra" + PostFix));
  ELSE
   depth:=DEPTH(^("Top" + PostFix));
  END;
  IF ~NeedDlmLine(_ExCl.BType) THEN
   INC(depth, DEPTH(^DlmLine));
  END;
  RETURN depth;
 END {Depth_Top};

 PRIVATE PROCEDURE Print_Top();
 BEGIN
  GetBegTypeName(_ExCl.BType);
  IF (_ExCl.BType = bt_Repair) | (_ExCl.BType = bt_Other) THEN
   Top:="TopExtra" + PostFix;
   Line:="LineExtra" + PostFix;
   DlmLine:="DlmLineExtra" + PostFix;
   EmptyLine:="EmptyLineExtra" + PostFix;
  ELSE
   Top:="Top" + PostFix;
   Line:="Line" + PostFix;
   DlmLine:="DlmLine" + PostFix;
   EmptyLine:="EmptyLine" + PostFix;
  END;
  MAKEPART(R, ^Top);
  IF ~NeedDlmLine(_ExCl.BType) THEN
   Print_DlmLine();
  END;
 END {Print_Top};

 PRIVATE PROCEDURE Set_BTime(): LONGTIME[2];
 BEGIN
  IF L_BegRWS.RWayTxtIsValid() & ~!RWayTxt.FExTime THEN
   RETURN RWayTxt.FExTime;
  ELSE
   RETURN RWayS.StartTim;
  END;
 END {Set_BTime};

 PRIVATE PROCEDURE Set_ETime(): LTIME;
  VAR
   curBegTime,
   curEndTime: LTIME;
 BEGIN
  IF L_BegRWS.RWayTxtIsValid() & ~!RWayTxt.LEnTime THEN
   curBegTime:=RWayTxt.FExTime;
   curEndTime:=RWayTxt.LEnTime;
  ELSE
   curBegTime:=C_T2L(StExit.BegDay, StExit.BegTime);
   curEndTime:=StExit.StopTim;
  END;
  IF C_L2D(curBegTime) = 01 THEN
   RETURN curEndTime;
  ELSE
   RETURN C_T2L(01 + (curBegTime < curEndTime), curBegTime);
  END;
 END {Set_ETime};

 PRIVATE PROCEDURE Set_GuBTime(): TIME;
  VAR
   _GuETime,
   _GuBTime: TIME;
 BEGIN
  IF L_Way.E_NeedSetTimesWayLMen(RWayS.Date) > 0 THEN
   _GuBTime:=WayLMen.StartT;
  ELSE
   L_Way.GetExitTimes(L_Way.rwswho_Guard, _GuBTime, _GuETime);
  END;
  RETURN Math.Max(_GuBTime, _BTime);
 END {Set_GuBTime};

 PRIVATE PROCEDURE GetBegType(_BegType: LIKE(ExitClss.BegType)): tBType;
 BEGIN
  IF    _BegType = L_Way.ecbt_Line THEN
   RETURN bt_Line;
  ELSIF (_BegType = L_Way.ecbt_Reserv) |
        (_BegType = L_Way.ecbt_Outage) THEN
   RETURN bt_Outage;
  ELSIF (_BegType = L_Way.ecbt_Repair) |
        (_BegType = L_Way.ecbt_Loss) THEN
   RETURN bt_Repair;
  ELSE
   RETURN bt_Other;
  END;
 END {GetBegType};

 PRIVATE PROCEDURE NeedPurpose(): SCAL[2];
  VAR
   Result: SCAL[2];
   Local : PROC;
 BEGIN
  IF CurPurpose = cp_All THEN
   RETURN 1;
  ELSE
   Result:=(CurPurpose = cp_Common) = (CarLog.Purpose = L_Car.purp_Common);
   Local:=PROCREF(E_Utils.BegRWP_NeedPurpose);
   IF ~!Local THEN
    Result:=Local(Memo.ud_cd(), Result, CurPurpose);
   END;
   RETURN Result;
  END;
 END {NeedPurpose};

 PRIVATE PROCEDURE Make_ExCl();
  VAR
   local: PROC;
 BEGIN
  L_AFM.MakeIndex("_ExCl", "MyFirm : LIKE(MyFirm.MyFirm);"+
                           "BType  : "+TYPENAMEOF(tBType)+";"+
                           "SortVal: STRING[32];"+
                           "Change : LIKE(StExit.Change);"+
                           "BoxNbr : LIKE(RWayS.BoxNbr);"+
                           "RWayS  : LIKE(RWayS.RWayS)"  );

  local:=PROCREF(E_Utils.BegRWP_ExCl_SortVal);
 
  SELECT(RWayS, sDate, , L_Way.rwsStat_Ordered, Memo.ud_cd());
  WHILE OCCURE(RWayS) DO
   PROMPT(" : "+RWayS.RWayS);
   L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
   IF NeedPurpose() & P_Firm.IsAllowedMyPlace(RWayS.MyPlace) & P_Firm.IsAllowedMyFirm(L_Way.GetRWaySMyFirm()) THEN
    CONFORM(RWayS, StExit);
    CONFORM(StExit, ExitClss);
    _ExCl.MyFirm:=L_Car.GetCarMyFirm(RWayS.BoxNbr, RWayS.Date);
    _ExCl.BType :=GetBegType(ExitClss.BegType);
    IF ~!local THEN
     _ExCl.SortVal:=local();
    ELSE
     _ExCl.SortVal:=ExitClss.Sign;
    END;
    _ExCl.Change:=StExit.Change;
    _ExCl.BoxNbr:=RWayS.BoxNbr;
    _ExCl.RWayS :=RWayS.RWayS;
    INSERT(_ExCl);
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 END {Make_ExCl};

 PRIVATE PROCEDURE FillBeg01();
 BEGIN
  IF ExitClss.BegType=L_Way.ecbt_Line THEN
   IF ~Beg01.InBeg THEN
    INC(Beg01.InBeg);
   END;
   INC(Beg01.InBeg0, StExit.Change = 0);
   INC(Beg01.InBeg1, StExit.Change = 1);
   INC(Beg01.InBeg2, StExit.Change = 2);
   SETZERO(Beg01.InRez, Beg01.InRep);
  ELSIF ~Beg01.InBeg & (ExitClss.BegType=L_Way.ecbt_Reserv) THEN
   Beg01.InRez :=1;
   SETZERO(Beg01.InRep);
  ELSIF ~Beg01.InBeg & ~Beg01.InRez & (ExitClss.BegType=L_Way.ecbt_Repair) THEN
   Beg01.InRep :=1;
  END;
 END {FillBeg01};

 PRIVATE PROCEDURE Ins_Car_Beg01();
 BEGIN
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT(" : ࠦ " + Car.BoxNbr);
   IF L_Env.RealBoxNbr(Car.BoxNbr) &
      L_DatTim.IsActive_Inc(Memo.ud_cd(), Car.BegDate, Car.EndDate) &
      L_Way.intIsAllowedPlace(Memo.ud_cd(), Car.BoxNbr, EMPTYOF(Staff.TSN), EMPTYOF(StExit.Exit)) &
      P_Firm.IsAllowedMyFirm(L_Car.GetCarMyFirm(Car.BoxNbr, Memo.ud_cd())) THEN
    L_Car.StandOnCarLog(Car.BoxNbr, Memo.ud_cd());
    CONFORM(CarLog, Column);
    DEFAULT(Beg01);
    Beg01.MyFirm :=Column.MyFirm;
    Beg01.What   :=bk_Car;
    SETEMPTY(Beg01.Service, Beg01.Depart, Beg01.ServiceName, Beg01.DepartName);
    Beg01.Sort   :=CarLog.Column;
    Beg01.Who    :=CarLog.BoxNbr;
    Beg01.SortName:=Column.Name;
    SELECT(RWayS, BoxNbr, , Car.BoxNbr, Memo.ud_cd());
    WHILE OCCURE(RWayS) DO
     CONFORM(RWayS, StExit, ExitClss);
     FillBeg01();
     NEXT(RWayS);
    END;
    INSERT(Beg01);
   END;
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
 END {Ins_Car_Beg01};

 PRIVATE PROCEDURE Ins_StExit_Beg01();
 BEGIN
  SELECT(StExit, Exit);
  WHILE OCCURE(StExit) DO
   PROMPT(" : 室 " + StExit.Exit);
   IF (StExit.Strict = L_Way.ExitStrict_Reg) & ~StExit.Suppl &
      (L_Way._CheckExitOnDate(StExit.Exit, Memo.ud_cd()) = L_Way.exvld_Active) &
      L_Way.intIsAllowedPlace(Memo.ud_cd(), EMPTYOF(Car.BoxNbr), EMPTYOF(Staff.TSN), StExit.Exit) &
      P_Firm.IsAllowedMyFirm(L_Way.GetMyFirmOfExit(StExit.Exit, Memo.ud_cd())) THEN
    DEFAULT(Beg01);
    TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
     Beg01.MyFirm:=L_Way.GetMyFirmOfExit(StExit.Exit, Memo.ud_cd());
    EXCEPT
    ON Exc: Exc_Raise DO
     Beg01.MyFirm:=0001;
    END;
    Beg01.What  :=bk_Exit;
    SETEMPTY(Beg01.Service, Beg01.Depart, Beg01.Sort, Beg01.ServiceName, Beg01.DepartName, Beg01.SortName);
    Beg01.Who   :=StExit.Exit;
    SELECT(RWayS, Exit, , StExit.Exit, Memo.ud_cd());
    WHILE OCCURE(RWayS) DO
     CONFORM(StExit, ExitClss);
     FillBeg01();
     NEXT(RWayS);
    END;
    INSERT(Beg01);
   END;
   NEXT(StExit);
  END; (* WHILE OCCURE(StExit) ... *)
 END {Ins_StExit_Beg01};

 PRIVATE PROCEDURE HasAvePay(trgTSN: LIKE(Staff.TSN); trgD: DATE): SCAL[2];
 BEGIN
  SELECT(AvePay, EBDTSN, , trgTSN);
  SRCINSEL(AvePay, GE, , trgD);
  WHILE OCCURE(AvePay) DO
   IF L_AvePay.IsRealAvePay() &
      L_DatTim.IsActive_Inc(trgD, AvePay.StartD, AvePay.StopD) THEN
    SELECT(AvePayP, AvePay, , AvePay.AvePay);
    WHILE OCCURE(AvePayP) DO
     IF L_DatTim.IsActive_Inc(trgD, AvePayP.StartD, AvePayP.StopD) THEN
      CONFORM(AvePayP, AveTypeP, JMode);
      IF ~!AveTypeP.JMode THEN
       RETURN 1;
      END;
     END;
     NEXT(AvePayP);
    END; (* WHILE OCCURE(AvePayP) ... *)
   END;
   NEXT(AvePay);
  END; (* WHILE OCCURE(AvePay) ... *)
  RETURN 0;
 END {HasAvepay};

 PRIVATE PROCEDURE IsGoodStaff(): SCAL[2];
 BEGIN
  IF WithGuard() THEN
   RETURN L_Env.IsDriver() | L_Env.IsGuard();
  ELSE
   RETURN L_Env.IsDriver();
  END;
 END {IsGoodStaff};

 PRIVATE PROCEDURE Ins_SingleStaff_Beg01();
  VAR
   _InBeg: NUMERIC[0];
 BEGIN
  SETZERO(_InBeg);
  CONFORM(StaffLog, Officer);
  DEFAULT(Beg01);
  Beg01.MyFirm :=Staff.MyFirm;
  Beg01.What   :=bk_Staff;
  SEARCH(Sort, Sort, , L_Staff.getService());
  Beg01.Service    :=Sort.Sort;
  Beg01.ServiceName:=Sort.Name;
  SEARCH(Sort, Sort, , L_Staff.getDepart());
  Beg01.Depart    :=Sort.Sort;
  Beg01.DepartName:=Sort.Name;
  CONFORM(StaffLog, Sort);
  Beg01.Sort    :=Sort.Sort;
  Beg01.SortName:=Sort.Name;
  Beg01.Who     :=Staff.TSN;

  IF L_Env.IsDriver() THEN
   SELECT(RWayS, TSN, , Staff.TSN, Memo.ud_cd());
   WHILE OCCURE(RWayS) DO
    CONFORM(RWayS, StExit, ExitClss);
    FillBeg01();
    INC(_InBeg);
    NEXT(RWayS);
   END;
  ELSE
   SELECT(WayLMen, TSN, , Staff.TSN, Memo.ud_cd());
   WHILE OCCURE(WayLMen) DO
    CONFORM(WayLMen, RWayS);
    CONFORM(RWayS, StExit, ExitClss);
    FillBeg01();
    INC(_InBeg);
    NEXT(WayLMen);
   END;
  END;
  IF _InBeg = 0 THEN
   IF HasAvePay(Staff.TSN, Memo.ud_cd()) THEN
    CONFORM(AvePay, AveType);
    Beg01.AveT  :=AveType.AveNo;
    Beg01.DocNbr:=AvePay.AvePay;
   ELSE
    IF L_BegRWS.AccessDayTypeByRegime(Staff.TSN, Memo.ud_cd()) THEN
     IF RegList.JMode = 38 (**) THEN
      INC(Beg01.Rest);
     ELSIF RegList.JMode = L_Sheet.jm_Hld(Memo.ud_cd()) THEN
      INC(Beg01.Holid);
     END;
    ELSE
     INC(Beg01.Holid);
    END;
   END;
  END;
  INSERT(Beg01);
 END {Ins_SingleStaff_Beg01};

 PRIVATE PROCEDURE Ins_Staff_Beg01();
  VAR
   trgWhat: L_BegRWS.tDayType;
 BEGIN
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(" : ⠡ " + Staff.TSN);
   IF L_Staff.rInState(Memo.ud_cd()) &
      L_Way.intIsAllowedPlace(Memo.ud_cd(), EMPTYOF(Car.BoxNbr), Staff.TSN, EMPTYOF(StExit.Exit)) &
      P_Firm.IsAllowedMyFirm(Staff.MyFirm) THEN
    HISTCONF(Memo.ud_cd(), Staff, StaffLog);
    CONFORM(StaffLog, Officer);
    IF IsGoodStaff() THEN
     Ins_SingleStaff_Beg01();
    END;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
 END {Ins_Staff_Beg01};

 PRIVATE PROCEDURE Print_Line(LineAm: SCAL[100]);
  VAR
   i: SCAL[PageSize+1];
 BEGIN
  SETZERO(i);
  WHILE (i < LineAm) &
        ((LINENUM(R) + DEPTH("Line_E" + PostFix) + DEPTH("Bot" + PostFix)) < PageSize) DO
   MAKEPART(R, ^("Line_E" + PostFix), "");
   INC(i);
  END;
 END {Print_Line};

 PRIVATE PROCEDURE Print_Bot();
 BEGIN
  SetPrintAttr(R, LinesPerPage, PageSize, Orientation, Landscape);
  MAKEPART(R, ^("Top_E" + PostFix), BTypeStr(", ᥭ   ᫥ ⢥ত"));
  Print_Line(07);
  MAKEPART(R, ^("Line_E" + PostFix), BTypeStr(", ᥭ  륧 ࢮ    ᫥"));
  Print_Line(99);
  MAKEPART(R, ^("Bot" + PostFix));
 END {Print_Bot};

 PRIVATE PROCEDURE E_NeedEmptyLine(VAR _LastVal: STRING[8]): SCAL[3];
  VAR
   local: PROC;
 BEGIN
  local:=PROCREF(E_Utils.BegRWP_NeedEmptyLine);
  IF ~!local THEN
   RETURN local(_LastVal);
  ELSE
   RETURN 0;
  END;
 END {E_NeedEmptyLine};

 PRIVATE PROCEDURE OpenRep_ExCl(RepFullName: STRING[]);
 BEGIN
  OPENREP(R, L_General.NameConnection(RepFullName), Create,
             FontEnlargement, 1.2,
             Orientation,     Landscape,
             TopMargin,       10,
             BottomMargin,    10,
             RightMargin,     10);
 END {OpenRep_ExCl};

 PRIVATE PROCEDURE OpenRep_ExCl_TP(RepFullName: STRING[]);
 BEGIN
  OPENREP(R, L_General.NameConnection(RepFullName), Create,
             FontEnlargement, 1.2,
             Orientation,     Portrait,
             TopMargin,       10,
             BottomMargin,    10,
             RightMargin,     10);
 END {OpenRep_ExCl_TP};

 PRIVATE PROCEDURE _RprtTop(Mode: SCAL[20]);
  VAR
   local: PROC;
 BEGIN
  IF Mode = L_PagePr.m_Print THEN
   local:=PROCREF(E_Utils.BegRWP_RepTop);
   IF ~!local THEN
    local(Memo.ud_cd(), RepTopLine);
    MAKEPART(R, ^("RepTop" + PostFix));
   END;
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtTop};

 PRIVATE PROCEDURE _PageTop(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Print THEN
   Print_Top();
  ELSIF Mode = L_PagePr.m_RDoneTop THEN
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageTop};

 PRIVATE PROCEDURE _PageBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(^("Bot" + PostFix)));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, ^("Bot" + PostFix));
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_Print);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageBot};

 PRIVATE PROCEDURE _RprtBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(0);
  ELSIF Mode = L_PagePr.m_Print THEN
  ELSIF Mode =  L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_None);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtBot};

 PRIVATE PROCEDURE _Filling(Mode: SCAL[20]);
 BEGIN
  IF Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(0);
  ELSIF Mode = L_PagePr.m_Print THEN
  ELSE
   PagePr_BadCallMode(0);
  END;
 END {_Filling};

 PRIVATE PROCEDURE MakePartLine2(_S: STRING[]);
 BEGIN
  IF ~!_S THEN
   MAKEPART(R, ^("Line2" + PostFix), _S);
  END;
 END {MakePartLine2};

 PRIVATE PROCEDURE SmallMessage(): SCAL[2];
  CONST
   MsgLength    = 64;
   MsgLength_TP = 33;
  VAR
   MaxLen: NUMERIC[0];
 BEGIN
  MaxLen:=^("MsgLength"+PostFix);
  RETURN L_BegRWS.RWayTxtIsValid() & ~!RWayTxt.Message & (Str.Length(RWayTxt.Message) <= MaxLen);
 END {SmallMessage};

 PRIVATE PROCEDURE PrintMessage(): LIKE(RWayTxt.Message);
 BEGIN
  IF SmallMessage() THEN
   RETURN RWayTxt.Message;
  ELSE
   RETURN "";
  END;
 END {PrintMessage};

 PRIVATE PROCEDURE GetAdditionlRWaySInf(VAR _WOrder: STRING[LineWidth][]);
  VAR
   _S: STRING[];
 BEGIN
  SETEMPTY(_S);
  CONFORM(RWayS, RWayTxt);
  IF L_BegRWS.RWayTxtIsValid() THEN
   IF ~SmallMessage() THEN
    _S:=Str.Condense(RWayTxt.Message);
   END;
  END;
  SELECT(CWOrder, RWayS, , RWayS.RWayS);
  WHILE OCCURE(CWOrder) DO
   IF CWOrder.Status # L_MDoc.st_Canceled THEN
    _S:=L_Str.AddStrDlm(_S, L_Str.CRLF) + " " + CWOrder.CWOrder +
             ": 륧 " + L_DatTim.DateTimeStr(CWOrder.p_BDate, CWOrder.p_BTime) + ", " + CWOrder.RouteDsc;
   END;
   NEXT(CWOrder);
  END; (* WHILE OCCURE(CWorder) ... *)
  Str.Format(_WOrder, _S, ^("LineWidth"+PostFix), LEFT);
 END {GetAdditionlRWaySInf};

 PRIVATE PROCEDURE AccessReference();
 BEGIN
  L_General.Assert(SEARCH(RWayS, RWayS, _ExCl.RWayS), "   "+_ExCl.RWayS);
  PROMPT(RWayS.Exit);
  CONFORM(RWayS, Car);
  L_Car.AccessMark(Car.BoxNbr, Memo.ud_cd());
  CONFORM(RWayS, Staff, Man);
  CONFORM(RWayS, StExit, ExitClss);
 END {AccessReference};

 PRIVATE PROCEDURE Print_ExCl();
  VAR
   _LastVal : STRING[8];
   NeedEL   : SCAL[3];
   _WOrder  : STRING[LineWidth][4];
   depth    : NUMERIC[0];
   WLMCount : NUMERIC[0];
   _SDrPupil: STRING[];
 BEGIN
  SETEMPTY(_LastVal);
  IF ~SELECT(_ExCl, _ExCl, curMyFirm) THEN
   RETURN;
  END;
  SEARCH(RWayS, RWayS, , _ExCl.RWayS);
  L_PagePr.PagePr_Init("R", LPerPage, PROCREF(_RprtTop),
                                      PROCREF(_PageTop),
                                      PROCREF(_PageBot),
                                      PROCREF(_RprtBot),
                                      PROCREF(_Filling));
  WHILE OCCURE(_ExCl) DO
   NARROWSEL(_ExCl, BType);
   WHILE OCCURE(_ExCl) DO
    AccessReference();
    NeedEL:=E_NeedEmptyLine(_LastVal);

    depth:=0;
    IF NeedEL = 1 THEN
     IF NeedDlmLine(_ExCl.BType) THEN
      depth:=DEPTH(^(DlmLine));
     ELSE
      depth:=DEPTH(^(EmptyLine));
     END;
    END;

    WLMCount:=0;
    SETEMPTY(_SDrPupil);
    CONFORM(RWayS, RWayTxt);
    _ETime:=Set_ETime();
    _BTime:=Set_BTime();
    CONFORM(RWayS, WayLMen);
    WHILE OCCURE(WayLMen) DO
     IF WayLMen.Who = L_BegRWS.E_GetWayLMenWhoOfGuard() THEN
      IF WLMCount = 0 THEN
       IF NeedDlmLine(_ExCl.BType) THEN
        INC(depth, DEPTH(^(DlmLine)));
       END;
       INC(depth, DEPTH("Line" + PostFix));
      ELSE
       INC(depth, DEPTH("AWLMLine" + PostFix));
      END;
      INC(WLMCount);
     ELSIF (WayLMen.Who = L_Way.wlmwho_DrPupil) THEN
      IF !_SDrPupil THEN
       _SDrPupil:="祭 ⥫: ";
       INC(depth, DEPTH("Line2" + PostFix));
      END;
     END;
     NEXT(WayLMen);
    END; (* WHILE OCCURE(WayLMen) ... *)
    IF WLMCount = 0 THEN
     IF NeedDlmLine(_ExCl.BType) THEN
      INC(depth, DEPTH(^(DlmLine)));
     END;
     INC(depth, DEPTH(^(Line)));
    END; (* IF WLMCount = 0 ... *)

    IF    NeedEL = 2 THEN
     L_PagePr.PagePr_SetNewPage();
    ELSE
     L_PagePr.PagePr_BeforePrintLine(depth);
    END;

    IF NeedEL = 1 THEN
     IF NeedDlmLine(_ExCl.BType) THEN
      Print_DlmLine();
     ELSE
      MAKEPART(R, ^EmptyLine);
     END;
    END;

    WLMCount:=0;
    SETEMPTY(_SDrPupil);
    CONFORM(RWayS, RWayTxt);
    _ETime:=Set_ETime();
    _BTime:=Set_BTime();
    CONFORM(RWayS, WayLMen);
    WHILE OCCURE(WayLMen) DO
     IF WayLMen.Who = L_BegRWS.E_GetWayLMenWhoOfGuard() THEN
      CONFORM(WayLMen, Staff, Man);
      IF WLMCount = 0 THEN
       IF NeedDlmLine(_ExCl.BType) THEN
        Print_DlmLine();
       END;
       MAKEPART(R, ^("Line" + PostFix), L_BegRWS.RWayTxtIsValid(),
                                        StaffAsStr(WayLMen.TSN, 1), Set_GuBTime());
      ELSE
       MAKEPART(R, ^("AWLMLine" + PostFix), StaffAsStr(WayLMen.TSN, 1), Set_GuBTime());
      END;
      INC(WLMCount);
     ELSIF (WayLMen.Who = L_Way.wlmwho_DrPupil) THEN
      IF !_SDrPupil THEN
       _SDrPupil:="祭 ⥫: ";
      ELSE
       _SDrPupil:=_SDrPupil+"; ";
      END;
      _SDrPupil:=_SDrPupil+StaffAsStr(WayLMen.TSN, 1);
     END;
     NEXT(WayLMen);
    END; (* WHILE OCCURE(WayLMen) ... *)
    IF WLMCount = 0 THEN
     IF NeedDlmLine(_ExCl.BType) THEN
      Print_DlmLine();
     END;
     MAKEPART(R, ^Line, L_BegRWS.RWayTxtIsValid());
    END; (* IF WLMCount = 0 ... *)

    MakePartLine2(_SDrPupil);
    NEXT(_ExCl);
   END; (* WHILE OCCURE(_ExCl) ... *)
   IF NEXTINEXTENDEDSEL(_ExCl, BType) THEN
    AccessReference();
    IF E_NeedEmptyLine(_LastVal) = 2 THEN
     L_PagePr.PagePr_SetNewPage();
    ELSIF _ExCl.BType # bt_Line THEN
     IF L_PagePr.PagePr_GetPageRest() < (Depth_Top()+depth+2*DEPTH("Bot" + PostFix)) THEN
      L_PagePr.PagePr_SetNewPage();
     ELSE
      MAKEPART(R, ^("Bot" + PostFix));
      Print_Top();
     END;
    END;
   END;
  END; (* WHILE OCCURE(_ExCl) ... *)

  L_PagePr.PagePr_Done();
  InitPrintAttr(R);
  Print_Bot();
 END {Print_ExCl};

 PRIVATE PROCEDURE Print_RWayTxt();
  VAR
   First  : SCAL[2];
   _WOrder: STRING[LineWidth][4];
   i      : NUMERIC[0];
 BEGIN
  First:=1;
  SELECT(RWayS, sBoxNbr, , L_Way.rwsStat_Ordered);
  WHILE OCCURE(RWayS) DO
   L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
   IF (RWayS.Date = Memo.ud_cd()) & NeedPurpose() THEN
    CONFORM(RWayS, RWayTxt);
    GetAdditionlRWaySInf(_WOrder);
    IF ~!_WOrder[0] | SmallMessage() THEN
     CONFORM(CarLog, Column);
     IF Column.MyFirm = curMyFirm THEN
      CONFORM(RWayS, Car, Staff, Man, StExit, ExitClss);
      _BTime:=Set_BTime();
      _ETime:=Set_ETime();
      IF First THEN
       FORMFEED(R);
       InitPrintAttr(R, Orientation, Landscape);
       MAKEPART(R, ^("Top1" + PostFix));
       First:=0;
      END;
      MAKEPART(R, ^("Line1" + PostFix));
      i:=0;
      WHILE (i <= HIGH(_WOrder)) & ~!_WOrder[i] DO
       MakePartLine2(_WOrder[i]);
       INC(i);
      END; (* WHILE (i <= HIGH(_WOrder)) & ~!_WOrder[i]...*)
     END;
    END;
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
  IF ~First THEN
   MAKEPART(R, ^("Bot1" + PostFix));
  END;
 END {Print_RWayTxt};

 PRIVATE PROCEDURE Print_DrvPupil();
  VAR
   First  : SCAL[2];
 BEGIN
  First:=1;
  SELECT(RWayS, sBoxNbr, , L_Way.rwsStat_Ordered);
  WHILE OCCURE(RWayS) DO
   CONFORM(RWayS, Car);
   L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
   IF (RWayS.Date = Memo.ud_cd()) & NeedPurpose() THEN
    CONFORM(RWayS, WayLMen);
    WHILE OCCURE(WayLMen) DO
     IF WayLMen.Who = L_Way.wlmwho_DrPupil THEN
      CONFORM(CarLog, Column);
      IF Column.MyFirm = curMyFirm THEN
       CONFORM(WayLMen, Staff, Man);
       CONFORM(RWayS, Car, Staff, Man, StExit, ExitClss);
       _BTime:=Set_BTime();
       _ETime:=Set_ETime();
       IF First THEN
        FORMFEED(R);
        InitPrintAttr(R, Orientation, Landscape);
        MAKEPART(R, ^("TopDP" + PostFix));
        First:=0;
       END;
       MAKEPART(R, ^("LineDP" + PostFix));
      END;
     END;
     NEXT(WayLMen);
    END; (* WHILE OCCURE(WayLMen) ... *)
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
  IF ~First THEN
   MAKEPART(R, ^("BotDP" + PostFix));
  END;
 END {Print_DrvPupil};

 PRIVATE PROCEDURE Inc_Amnt(VAR _Res1, _Res2: NUMERIC[0][13]);
  VAR
   i: NUMERIC[0];
 BEGIN
  SETZERO(i);
  WHILE i < 13 DO
   INC(_Res1[i], _Res2[i]);
   INC(i);
  END;
 END {Inc_Amnt};

 PRIVATE PROCEDURE E_Print_RepBot();
 BEGIN
  IF (CurPurpose = cp_Depart) & ~!PROCREF(E_Utils.BegRWP_BotDepart) THEN
   E_Utils.BegRWP_BotDepart(Memo.ud_cd());
  ELSIF ~!PROCREF(E_Utils.BegRWP_Bot) THEN
   E_Utils.BegRWP_Bot(Memo.ud_cd());
  END;
 END {E_Print_RepBot};

 PRIVATE PROCEDURE Print_Beg01();
  VAR
   SrvAmnt,
   DepAmnt,
   SrtAmnt : NUMERIC[0][13];
   SortCnt,
   DepartCnt:NUMERIC[0];
 BEGIN
  FORMFEED(R);
  InitPrintAttr(R, Orientation, Landscape);
  IF SELECT(Beg01, What, curMyFirm, bk_Staff) THEN
   MAKEPART(R, ISTop);
   WHILE OCCURE(Beg01) DO
    PROMPT(" : ⮣  ᮭ");
    SETZERO(SrvAmnt);
    NARROWSEL(Beg01, ServiceName);
    DepartCnt:=0;
    WHILE OCCURE(Beg01) DO
     SETZERO(DepAmnt);
     NARROWSEL(Beg01, DepartName);
     SETZERO(SortCnt);
     WHILE OCCURE(Beg01) DO
      SETZERO(SrtAmnt);
      NARROWSEL(Beg01, SortName);
      WHILE OCCURE(Beg01) DO
       INC(SrtAmnt[00], 1);
       INC(SrtAmnt[01], Beg01.InBeg);
       INC(SrtAmnt[02], Beg01.InBeg1);
       INC(SrtAmnt[03], Beg01.InBeg2);
       INC(SrtAmnt[04], Beg01.InBeg0);
       INC(SrtAmnt[05], Beg01.InRep);
       INC(SrtAmnt[06], Beg01.InRez);
       INC(SrtAmnt[08], Beg01.AveT=L_AvePay.aveno_Sick);
       INC(SrtAmnt[09], Beg01.AveT=L_AvePay.aveno_Hldy);
       INC(SrtAmnt[10], Beg01.Rest);
       INC(SrtAmnt[11], Beg01.Holid);
       NEXT(Beg01);
      END; (* WHILE OCCURE(Beg01) ... *)
      LAST(Beg01);
      INC(SrtAmnt[07], SrtAmnt[00]-SrtAmnt[01]-SrtAmnt[05]-SrtAmnt[06]);
      INC(SrtAmnt[12], SrtAmnt[07]-SrtAmnt[08]-SrtAmnt[09]-SrtAmnt[10]-SrtAmnt[11]);
      IF SortCnt = 0 THEN
       MAKEPART(R, DLine);
      END;
      INC(SortCnt);
      MAKEPART(R, ISLine, Beg01.SortName, Beg01.Sort, SrtAmnt[00],
                          SrtAmnt[01], SrtAmnt[02], SrtAmnt[03], SrtAmnt[04],
                          SrtAmnt[05], SrtAmnt[06], SrtAmnt[07], SrtAmnt[08],
                          SrtAmnt[09], SrtAmnt[10], SrtAmnt[11], SrtAmnt[12]);
      NEXTINEXTENDEDSEL(Beg01, SortName);
      Inc_Amnt(DepAmnt, SrtAmnt);
     END; (* WHILE OCCURE(Beg01) ... *)
     LAST(Beg01);
     MAKEPART(R, DLine);
     MAKEPART(R, ISLine, "⮣: " + Beg01.DepartName, Beg01.Depart, DepAmnt[00],
                         DepAmnt[01], DepAmnt[02], DepAmnt[03], DepAmnt[04],
                         DepAmnt[05], DepAmnt[06], DepAmnt[07], DepAmnt[08],
                         DepAmnt[09], DepAmnt[10], DepAmnt[11], DepAmnt[12]);
     INC(DepartCnt);
     Inc_Amnt(SrvAmnt, DepAmnt);
     NEXTINEXTENDEDSEL(Beg01, DepartName);
    END; (* WHILE OCCURE(Beg01) ... *)
    LAST(Beg01);
    IF DepartCnt > 1 THEN
     MAKEPART(R, DLine);
     MAKEPART(R, ISLine, "⮣ 㦡: " + Beg01.ServiceName, Beg01.Service, SrvAmnt[00],
                         SrvAmnt[01], SrvAmnt[02], SrvAmnt[03], SrvAmnt[04],
                         SrvAmnt[05], SrvAmnt[06], SrvAmnt[07], SrvAmnt[08],
                         SrvAmnt[09], SrvAmnt[10], SrvAmnt[11], SrvAmnt[12]);
    END;
    NEXTINEXTENDEDSEL(Beg01, ServiceName);
   END; (* WHILE OCCURE(Beg01) ... *)
   MAKEPART(R, ISBot);
  END; (* IF SELECT(Beg01... *)

  SETZERO(SrvAmnt);
  IF SELECT(Beg01, What, curMyFirm, bk_Car) THEN
   MAKEPART(R, ICTop);
   WHILE OCCURE(Beg01) DO
    PROMPT(" : ⮣  ");
    SETZERO(SrtAmnt);
    NARROWSEL(Beg01, ServiceName, DepartName, SortName);
    WHILE OCCURE(Beg01) DO
     INC(SrtAmnt[00], 1);
     INC(SrtAmnt[01], Beg01.InBeg);
     INC(SrtAmnt[02], Beg01.InBeg1);
     INC(SrtAmnt[03], Beg01.InBeg2);
     INC(SrtAmnt[04], Beg01.InBeg0);
     INC(SrtAmnt[05], Beg01.InRep);
     INC(SrtAmnt[06], Beg01.InRez);
     NEXT(Beg01);
    END; (* WHILE OCCURE(Beg01) ... *)
    LAST(Beg01);
    INC(SrtAmnt[07], SrtAmnt[00] - SrtAmnt[01] - SrtAmnt[05] - SrtAmnt[06]);
    MAKEPART(R, ICLine, Beg01.SortName, SrtAmnt[00],
                                     SrtAmnt[01],
                                     SrtAmnt[02],
                                     SrtAmnt[03],
                                     SrtAmnt[04],
                                     SrtAmnt[05],
                                     SrtAmnt[06],
                                     SrtAmnt[07],
                                     (SrtAmnt[00]-SrtAmnt[05])/SrtAmnt[00](**),
                                     (SrtAmnt[01]+SrtAmnt[06])/SrtAmnt[00](**));
    Inc_Amnt(SrvAmnt, SrtAmnt);
    NEXTINEXTENDEDSEL(Beg01, ServiceName, DepartName, SortName);
   END; (* WHILE OCCURE(Beg01) ... *)
   MAKEPART(R, ICDlm);
   MAKEPART(R, ICLine, "⮣  ", SrvAmnt[00],
                                         SrvAmnt[01],
                                         SrvAmnt[02],
                                         SrvAmnt[03],
                                         SrvAmnt[04],
                                         SrvAmnt[05],
                                         SrvAmnt[06],
                                         SrvAmnt[07],
                                         (SrvAmnt[00]-SrvAmnt[05])/SrvAmnt[00](**),
                                         (SrvAmnt[01]+SrvAmnt[06])/SrvAmnt[00](**));
  END; (* IF SELECT(Beg01... *)

  SETZERO(SrvAmnt, SrtAmnt);
  IF SELECT(Beg01, What, curMyFirm, bk_Exit) THEN
   WHILE OCCURE(Beg01) DO
    PROMPT(" : ⮣  室 "+Beg01.Who);
    SrtAmnt[00]:=1;
    SrtAmnt[01]:=Beg01.InBeg;
    SrtAmnt[02]:=Beg01.InBeg1;
    SrtAmnt[03]:=Beg01.InBeg2;
    SrtAmnt[04]:=Beg01.InBeg0;
    SrtAmnt[07]:=SrtAmnt[00] - SrtAmnt[01];
    Inc_Amnt(SrvAmnt, SrtAmnt);
    NEXT(Beg01);
   END; (* WHILE OCCURE(Beg01) ... *)
   MAKEPART(R, IETop, SrvAmnt[00],
                      SrvAmnt[01],
                      SrvAmnt[02],
                      SrvAmnt[03],
                      SrvAmnt[04],
                      SrvAmnt[07]);
  ELSIF LINENUM(R) > 0 THEN
   MAKEPART(R, IETop_Empty);
  END; (* IF SELECT(Beg01... *)
  E_Print_RepBot();
 END {Print_Beg01};

 PRIVATE PROCEDURE SetAppendix();
 BEGIN
  DelimitersEveryLine:=L_EC.ExecE_Func_Scal2(Memo.ud_cd(),
                                             PROCREF(E_Utils.BegRWP_DelimitersEveryLine),
                                             1);
  LinAppendix:=Str.Item(".........................................................|                                                         ", "|", DelimitersEveryLine);
 END {SetAppendix};

 PRIVATE PROCEDURE GetPurposeList(): STRING[];
 BEGIN
  RETURN " | 饣 짮| ⢥";
 END {GetPurposeList};

(*
$P {BgChg_Top:
@
|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|, ᠭ              |६|                                                                                       |ᯮ⥫                                 |
}
*)

(*
$P{ BgChg_Line:
RWayS.RWayS, L, ""
L_Str.PoolItem(L_lsStore.Get(Message.Text), 1), L, ""
Message.DTS, L, "H:M"
L_Str.PoolItem(L_lsStore.Get(Message.Text), 0), L, ""
AcsObj.Name + "  " + AcsObj.FullName, L, ""
@
|--------------------------|-----|------------------------------------------------------------------------------------------------|--------------------------------------------|
|####### ##################|#####|################################################################################################|############################################|
}
*)

 PUBLIC PROCEDURE BgChg();
  VAR
   DstBegin: TIMESTAMP;
 BEGIN
  RepName:="BgChg";
  curMyFirm:=P_Firm.DefineMyFirm();

  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_AFM.MakeIndex("bcmsg", "DTS: TIMESTAMP; Message: LIKE(Message.Message)");
  DstBegin:=PackTIMESTAMP(Memo.ud_cd() + 1);
  SELECT(RWayS, Date, , Memo.ud_cd());
  WHILE OCCURE(RWayS) DO
   PROMPT(RWayS.RWayS);
   SELECT(Message, RecordId, , TABLE.Get("RWayS").Id, RWayS.RECORDID);
   WHILE OCCURE(Message) DO
    IF Message.Kind = L_Msg.mk_SystemNote THEN
     ADD(bcmsg, bcmsg, , Message.DTS, Message.Message);
    END;
    NEXT(Message);
   END; (* WHILE OCCURE(Message) ... *)
   IF L_XDoc.XDocSomeTimeWas(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS, L_XDoc.action_begDst) THEN
    DstBegin:=Math.Min(DstBegin, PackTIMESTAMP(XDocJrn.Date, XDocJrn.BegTime, XDocJrn.BegSec));
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)

  OpenRep_ExCl(RepName);
  MAKEPART(R, Top_E, BTypeStr(", ᥭ   ᫥ ⢥ত"));
  MAKEPART(R, BgChg_Top);
  SELECT(bcmsg, bcmsg);
  WHILE OCCURE(bcmsg) & (bcmsg.DTS < DstBegin) DO
   SEARCH(Message, Message, , bcmsg.Message);
   SEARCH(RWayS, RECORDID, , Message.RecordId);
   SEARCH(AcsObj, AcsObj, , Message.Blng);
   MAKEPART(R, BgChg_Line);
   NEXT(bcmsg);
  END; (* WHILE OCCURE(bcmsg) ... *)
  MAKEPART(R, Line_E, BTypeStr(", ᥭ  륧 ࢮ    ᫥"));
  MAKEPART(R, BgChg_Top);
  WHILE OCCURE(bcmsg) DO
   SEARCH(Message, Message, , bcmsg.Message);
   SEARCH(RWayS, RECORDID, , Message.RecordId);
   SEARCH(AcsObj, AcsObj, , Message.Blng);
   MAKEPART(R, BgChg_Line);
   NEXT(bcmsg);
  END; (* WHILE OCCURE(bcmsg) ... *)
  MAKEPART(R, Bot);
 END {BgChg};

 PRIVATE PROCEDURE Make_Beg01(ForBgRWP: SCAL[2]);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  Create_Beg01();
  L_AFM.AF_CreateTemp("Beg01", "Beg01");
  IF ForBgRWP THEN
   CurPurpose:=L_StdFrm.ShowListAsMenu(GetPurposeList(), "   鸞");
  END;
 
  RWaySCnt:=0;
  SELECT(RWayS, Date, , Memo.ud_cd());
  WHILE OCCURE(RWayS) DO
   IF P_Firm.IsAllowedMyPlace(RWayS.MyPlace) & P_Firm.IsAllowedMyFirm(L_Way.GetRWaySMyFirm()) THEN
    INC(RWaySCnt);
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 
  Ins_Staff_Beg01();
 END {Make_Beg01};

 PUBLIC PROCEDURE BgRWP();
 BEGIN
  RepName:="BgRWP";
  Make_Beg01(1);
  IF WithGuard() THEN
   PostFix:="";
  ELSE
   PostFix:="_TP";
  END;
  SetAppendix();
 
  Ins_Car_Beg01();
  Ins_StExit_Beg01();
  Make_ExCl();
  ^("OpenRep_ExCl"+PostFix)(RepName + FLDTOSTR(Memo.ud_cd(), "_DN", 5)+L_Str.AnyItem("|C|D", "|", CurPurpose));

  SELECT(MyFirm, MyFirm);
  WHILE OCCURE(MyFirm) DO
   IF L_DatTim.IsActive(Memo.ud_cd(), MyFirm.Begin, MyFirm.Till) & (MyFirm.MyFirm#P_Firm.mf_Fict) & P_Firm.IsAllowedMyFirm(MyFirm.MyFirm) THEN
    IF LINENUM(R)>0 THEN
     FORMFEED(R);
    END;
    curMyFirm:=MyFirm.MyFirm;
    Print_ExCl();
    Print_Beg01();
    Print_RWayTxt();
    Print_DrvPupil();
   END;
   NEXT(MyFirm);
  END; (* WHILE OCCURE(MyFirm) ... *)
  L_AFM.AF_PurgeTemp("_ExCl");
 END {BgRWP};

END.
