(*
%Copyright   (c) Polak Computer System
%Author      SAN
%Purpose     ⮭宦 ࠡ⭨/
%Type        control
%Specific    AP
%Modified    27.05.2013 19:03:22 POLAK\Gina
%Environment
*)

 MODULE BegStnOn [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Str, L_General, L_OwnData, L_DatTim, L_BegRWS, L_Car, Memo,
        L_AvePay, L_Way, L_Rpr, Str, L_XDoc, L_AFM, L_lsStore, Math, L_EC, E_UI, L_two,
        L_RWayS, L_Staff;

 PRIVATE TYPE
  tIntvlMode = SCAL[4];

 PRIVATE CONST
  im_Curdate      = 0; (*tIntvlMode*)
  im_Sysdate      = 1;
  im_Per          = 2;
  im_From_Sysdate = 3;

  s_RWayS        = 0;
  s_OrderedRWayS = 1;
  s_Mtwo         = 2;

 VAR
  PrvDate: DATE;

(*
$P { WarningPart:
?, C, ""
@
===============================!!!  !!!===============================
|                                                                            |
|                                                                            |
|############################################################################|
|                                                                            |
|                                                                            |
===============================!!!  !!!===============================
}
*)

(*
$P { PageTop_TSN:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
Staff.TSN, L, ""
Man.Name, L, ""
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
|----------------------------------------------------------------------------|
| ##### ################################################                     |
}
*)

(*
$P{ SubTop_TSN:
L_DatTim.MonthStr(Tmp01._Date, 0), C, ""
@
|----------------------------------------------------------------------------|
|############################################################################|
|----------------------------------------------------------------------------|
| |   ||室  |砫||. .          |             |
}
*)

(*
$P{ Dlm_Line_TSN:
@
|-----|-----|-|-------|-----|-----|------------------------|-----------------|
}
*)

(*
$P { Line_TSN:
DayStr(), L, ""
Tmp01._Source, L, "||"
?, L, "|1|2"
?, L, ""
Tmp01._StartTim, L, "H:M"
Tmp01._StopTim, L, "H:M"
?, L, ""
?, L, ""
?, L, ""
Tmp01._CooTSN, L, ""
GetTSNName(Tmp01._CooTSN), L, ""
@
|#####|#####|#|#######|#####|#####|#### ########## ########|##### ###########|
}
*)

(*
$P{ RWayTxtTop:
@
|----------------------------------------------------------------------------|
| |⥫쭠 ଠ                                          |
|-----|----------------------------------------------------------------------|
}
*)

(*
$P{ RWayTxtLine:
?, L, ""
?, L, ""
@
|#####|######################################################################|
}
*)

(*
$P { AveTop:
@
|----------------------------------------------------------------------------|
|㬥                                                                   |
|----------------------------------------------------------------------------|
|ﭨ |砫    |砭 ||                                    |
|----------|----------|----------|---|---------------------------------------|
}
*)

(*
$P { AveLine:
AvePay.Status, L, "⮢.|஢|⬥"
AvePayP.StartD, L, "D.N.y"
AvePayP.StopD, L, "D.N.y"
AvePayP.Amount, L, ""
AvePayP.AveTypeP, L, ""
AveTypeP.Name, L, ""
@
|##########|##########|##########|###|## ####################################|
}
*)

(*
$P { PageTop_BoxNbr:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
Car.BoxNbr, L, ""
CarLog.StateNbr, L, ""
Mark.Mark, L, ""
Mark.Name, L, ""
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
|----------------------------------------------------------------------------|
|. #### . ########## ઠ #### ##################################|
}
*)

(*
$P { PageTop_BoxNbr_RWayS:
@
|----------------------------------------------------------------------------|
|. |     |砫          ||室    |.|⥫             |
|-------|-----------|----------------|-|---------|-----|---------------------|
}
*)

(*
$P { Line_BoxNbr_RWayS:
RWayS.RWayS, L, ""
RWayS.Status, L, L_Way.rwsStat_Pool
RWayS.Date, L, "D.N.y"
RWayS.StartTim, L, "H:M"
RWayS.Change, L, ""
RWayS.Exit, L, ""
L_BegRWS.GetRWaySEnterTime(0), L, "H:M"
RWayS.TSN, L, ""
Man.Name, L, ""
@
|#######|###########|########## #####|#|#########|#####|##### ###############|
|----------------------------------------------------------------------------|
}
*)

(*
$P{ PageTop_BoxNbr_RprS:
@
|----------------------------------------------------------------------------|
|. |     |⨥      |।  .||⮭宦   |
|-------|-----------|----------------|----------------|-|--------------------|
}
*)

(*
$P { Line_BoxNbr_RprS:
RprS.RprS, L, ""
RprS.Status, L, L_Rpr.GetRprSStatus_Pool(0)
RprS.OrdDate, L, "D.N.y"
RprS.OrdTime, L, "H:M"
RprS.EDate, L, "D.N.y"
RprS.ETime, L, "H:M"
RprS.Closed, L, "-|+"
RprS.Location, L, L_Rpr.GetRprSLocation_Pool(0)
@
|#######|###########|########## #####|########## #####|#|####################|
|----------------------------------------------------------------------------|
}
*)

(*
$P{ Line_BoxNbr_NoInf:
@
|----------------------------------------------------------------------------|
|࠭ᯮ⭮ ।⢮ ᢮                                              |
}
*)

(*
$P{ Line_BoxNbr:
?, L, ""
@
|############################################################################|
}
*)

(*
$P{ Line_BoxNbr_RprS_RprT:
?, L, ""
@
| ###########################################################################|
}
*)

(*
$P{ Line_BoxNbr_RprS_RprJ:
?, L, ""
@
|  ##########################################################################|
}
*)

(*
$P { PageTop_BoxNbr_AllDoc:
@
|----------------------------------------------------------------------------|
|㬥  |砫          |.||室    |⥫                      |
|----------|----------------|-----|-|---------|------------------------------|
}
*)

(*
$P { Line_BoxNbr_AllDoc:
?, L, ""
?, L, ""
Car01._Date, L, "D.N.y"
Car01._StartTim, L, "H:M"
?, L, "H:M"
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
|## #######|########## #####|#####|#|#########|##### ########################|
}
*)

(*
$P { PageBot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE EU_Mode(): SCAL[2];
 BEGIN
  RETURN L_General.KioskExecution_IsRunning();
 END {EU_Mode};

 PRIVATE PROCEDURE ApplyTWO(D: DATE): SCAL[2];
 BEGIN
  RETURN L_BegRWS.E_TWOLevel(D);
 END {ApplyTWO};

 PRIVATE PROCEDURE GetTSNName(_TSN: LIKE(Staff.TSN)): LIKE(Man.Name);
  VAR
   _Name: LIKE(Man.Name);
 BEGIN
  SETEMPTY(_Name);
  IF ~!_TSN THEN
   SAVE(Staff);
   SAVE(Man);
   L_General.CallUs(SEARCH(Staff, TSN, _TSN));
   CONFORM(Staff, Man);
   _Name:=L_Str.ShortName(Man.Name);
   RESTORE(Staff);
   RESTORE(Man);
  END;
  RETURN _Name;
 END {GetTSNName};

 PRIVATE PROCEDURE DayStr(): STRING[];
 BEGIN
  IF Tmp01._Date # PrvDate THEN
   PrvDate:=Tmp01._Date;
   RETURN FLDTOSTR(Tmp01._Date, "D", 2)+" "+L_DatTim.WeekDayShortStr(L_DatTim.WEEKDAY(Tmp01._Date));
  ELSE
   RETURN "";
  END;
 END {DayStr};

 PRIVATE PROCEDURE Set_GuTime(VAR _GuBTime, _GuETime: TIME);
 BEGIN
  IF L_Way.E_NeedSetTimesWayLMen(RWayS.Date) > 0 THEN
   _GuBTime:=WayLMen.StartT;
   _GuETime:=WayLMen.StopT;
  ELSE
   SAVE(StExit);
   CONFORM(RWayS, StExit);
   L_Way.GetExitTimes(L_Way.rwswho_Guard, _GuBTime, _GuETime);
   RESTORE(StExit);
  END;
  _GuBTime:=Math.Max(_GuBTime, L_BegRWS.GetRWaySExitTime(0));
  _GuETime:=Math.Min(_GuETime, L_BegRWS.GetRWaySEnterTime(0));
 END {Set_GuTime};

 PRIVATE PROCEDURE GetExitClssSign(_ExitClss: LIKE(ExitClss.ExitClss)): LIKE(ExitClss.Sign);
 BEGIN
  IF ~!_ExitClss THEN
   L_General.CallUs(SEARCH(ExitClss, ExitClss, _ExitClss));
   RETURN ExitClss.Sign;
  END;
  RETURN "";
 END {GetExitClssSign};

 PRIVATE PROCEDURE MakeLine();
  VAR
   _StateNbr: LIKE(Car.StateNbr);
   _MarkName: LIKE(Mark.Name);
 BEGIN
  IF Tmp01._Date # PrvDate THEN
   MAKEPART(R, Dlm_Line_TSN);
  END;
  IF ~!Tmp01._RWayS THEN
   L_RWayS.PositionOnRWayS(Tmp01._RWayS);
   CONFORM(RWayS, Car);
   CONFORM(RWayS, StExit);
   L_Car.AccessMark(Car.BoxNbr, Tmp01._Date);
   MAKEPART(R, Line_TSN, RWayS.Change, GetExitClssSign(StExit.ExitClss), Car.BoxNbr, Car.StateNbr, Mark.Name);
  ELSE
   L_two.r_Access(Tmp01._Date, Tmp01._Dtwo);
   SETEMPTY(_StateNbr, _MarkName);
   IF ~!Dtwo.BoxNbr THEN
    CONFORM(Dtwo, Car);
    L_Car.AccessMark(Car.BoxNbr, Tmp01._Date);
    _StateNbr:=Car.StateNbr;
    _MarkName:=Mark.Name;
   END;
   MAKEPART(R, Line_TSN, Dtwo.Change, GetExitClssSign(Dtwo.ExitClss), Dtwo.BoxNbr, _StateNbr, _MarkName);
  END;
 END {MakeLine};

 PRIVATE PROCEDURE GetCooTSN(CooWho: L_Way.tRWSWho): LIKE(RWayS.TSN);
  VAR
   _TSN: LIKE(RWayS.TSN);
 BEGIN
  SETEMPTY(_TSN);
  IF CooWho = L_Way.rwswho_Driver THEN
   _TSN:=RWayS.TSN;
  ELSIF CooWho = L_Way.rwswho_Guard THEN
   SAVE(WayLMen);
   IF SELECT(WayLMen, RWayS, RWayS.RWayS, L_Way.wlmwho_Guard) THEN
    _TSN:=WayLMen.TSN;
   END;
   RESTORE(WayLMen);
  END;
  RETURN _TSN;
 END {GetCooTSN};

 PRIVATE PROCEDURE GetMessage(): STRING[];
 BEGIN
  IF L_BegRWS.RWayTxtIsValid() THEN
   RETURN RWayTxt.Message;
  END;
  RETURN "";
 END {GetMessage};

 PRIVATE PROCEDURE MakeRWayTxt();
  CONST
   Width = 70;
  VAR
   _WOrder   : STRING[Width][5];
   i         : NUMERIC[0];
 BEGIN
  IF ~!Tmp01._Message THEN
   Str.Format(_WOrder, Tmp01._Message, Width, LEFT);
   IF ~!_WOrder[0] THEN
    MAKEPART(R, RWayTxtLine, DayStr(), _WOrder[0]);
    i:=1;
    WHILE (i <= HIGH(_WOrder)) & ~!_WOrder[i] DO
     MAKEPART(R, RWayTxtLine, , _WOrder[i]);
     INC(i);
    END;
   END;
  END;
 END {MakeRWayTxt};

 PRIVATE PROCEDURE MakeRepAvePay(trgTSN: LIKE(Staff.TSN); trgFrom, trgUpTo: DATE);
 BEGIN
  CONFORM(Staff, Man);
  MAKEPART(R, AveTop);
  SELECT(AvePay, EBDTSN, , trgTSN);
  SRCINSEL(AvePay, GE, , trgFrom);
  WHILE OCCURE(AvePay) DO
   IF L_AvePay.IsRealAvePay() &
      L_DatTim.IsActiveInIntvl_Inc(trgFrom, trgUpTo, AvePay.StartD, AvePay.StopD) THEN
    SELECT(AvePayP, AvePay, , AvePay.AvePay);
    WHILE OCCURE(AvePayP) DO
     CONFORM(AvePayP, AveTypeP);
     PROMPT(AveTypeP.Name);
     IF ~!AveTypeP.JMode THEN
      MAKEPART(R, AveLine);
     END;
     NEXT(AvePayP);
    END; (* WHILE OCCURE(AvePayP) ... *)
   END;
   NEXT(AvePay);
  END; (* WHILE OCCURE(AvePay) ... *)
 END {MakeRepAvePay};

 PRIVATE PROCEDURE E_IsWarningReportRequired(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_UI.IsWarningReportRequired), 0)
 END {E_IsWarningReportRequired};

 PRIVATE PROCEDURE SetIntvl(trgIM: tIntvlMode; VAR IntvlB, IntvlE: DATE; VAR SubTit: STRING[]);
 BEGIN
  IF    trgIM = im_Curdate THEN
   IntvlB:=Memo.ud_cd();
   IntvlE:=IntvlB;
   SubTit:=" "+L_DatTim.DateStr(IntvlB);
  ELSIF trgIM = im_Sysdate THEN
   IntvlB:=SYSDATE();
   IntvlE:=IntvlB;
   SubTit:=" "+L_DatTim.DateStr(IntvlB);
  ELSIF trgIM = im_Per THEN
   IF EU_Mode() & ApplyTWO(Memo.ud_ut()) THEN
    IntvlB:=L_BegRWS.DspSysDate();
    IntvlE:=L_DatTim.MonthEnd(L_DatTim.NextPer(IntvlB));
   ELSE
    IntvlB:=Memo.ud_fr();
    IntvlE:=Memo.ud_ut();
   END;
   SubTit:=" ਮ  " + L_DatTim.DateStr(IntvlB) + "  " + L_DatTim.DateStr(IntvlE);
  ELSIF trgIM = im_From_Sysdate THEN
   IntvlB:=SYSDATE();
   IntvlE:=L_DatTim.MonthEnd(L_DatTim.NextPer(IntvlB));
   SubTit:=" ਮ  " + L_DatTim.DateStr(IntvlB) + "  " + L_DatTim.DateStr(IntvlE);
  ELSE
   L_General.CallUs(0);
  END;
 END {SetIntvl};

 PRIVATE PROCEDURE SetAddInfo(curMessage: STRING[]): STRING[];
 BEGIN
  L_Staff.PosToStaffLog(Staff.TSN, Tmp01._Date, 0);
  CONFORM(StaffLog, Officer);
  IF ((Tmp01._Who#L_Way.rwswho_Driver) & (Tmp01._Who#L_Way.rwswho_Guard)) |
     ((L_two.E_Mtwo_Who(Tmp01._Date)=L_two.who_Driver) # (Tmp01._Who=L_Way.rwswho_Driver)) THEN
   curMessage:=L_Str.PoolItem(L_Way.rwswho_Pool, Tmp01._Who)+" "+curMessage;
  END;
  RETURN Str.Condense(curMessage);
 END {SetAddInfo};

 PRIVATE PROCEDURE Do_byTSN(trgIM: tIntvlMode);
  CONST
   RepName = "StNon";
  VAR
   _GuBTime,
   _GuETime: TIME;
   DayType : L_BegRWS.tDayType;
   curPer,
   _From,
   _UpTo,
   D       : DATE;
   SubTit  : STRING[];
 BEGIN
  L_General.Assert(ACCESS(Staff), " ⠭ ࠡ⭨");
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  SetIntvl(trgIM, _From, _UpTo, SubTit);
  CONFORM(Staff, Man);
  IF ~EU_Mode() THEN
   OPENREP(R, L_General.NameConnection(RepName), Create);
  END;
  IF E_IsWarningReportRequired() THEN
   D      :=SYSDATE() + 1;
   DayType:=L_BegRWS.GetDayTypeByRegime(Staff.TSN, D);
   IF (L_BegRWS.IsWorkDayType(DayType) | (DayType = L_BegRWS.dt_Relaxation)) &
       ~SELECT(RWayS, sTSN, L_Way.rwsStat_Ordered, Staff.TSN, D) THEN
    MAKEPART(R, WarningPart, "! -  " + L_DatTim.DateStr(D) + "  ⢥ত")
   END;
  END;
  IF EU_Mode() & ApplyTWO(Memo.ud_ut()) THEN
   MAKEPART(R, PageTop_TSN, RepName, " 䨪 "+SubTit);
  ELSE
   MAKEPART(R, PageTop_TSN, RepName, "⮭宦 ࠡ⭨ "+SubTit);
  END;
  L_AFM.MakeMultipleIndex("Tmp01", "_Date    : LIKE(RWayS.Date);"+
                                   "_Who     : SCAL[10];"+
                                   "_RWayS   : LIKE(RWayS.RWayS);"+
                                   "_StartTim: LIKE(RWayS.StartTim);"+
                                   "_StopTim : LIKE(RWayS.StartTim);"+
                                   "_CooTSN  : LIKE(RWayS.TSN);"+
                                   "_Message : LIKE(RWayTxt.Message);"+
                                   "_Dtwo    : SCAL[1E5];"+
                                   "_Source  : SCAL[3]",
                          "Tmp01: _Date, _Who, _StartTim, _RWayS, _Dtwo");
 
  SELECT(RWayS, TSN, , Staff.TSN);
  SRCINSEL(RWayS, GE, , _From);
  WHILE OCCURE(RWayS) & (RWayS.Date <= _UpTo) DO
   Tmp01._Date    :=RWayS.Date;
   Tmp01._Who     :=L_Way.rwswho_Driver;
   Tmp01._StartTim:=L_BegRWS.GetRWaySExitTime(0);
   Tmp01._RWayS   :=RWayS.RWayS;
   Tmp01._StopTim :=L_BegRWS.GetRWaySEnterTime(0);
   Tmp01._CooTSN  :=GetCooTSN(L_Way.rwswho_Guard);
   Tmp01._Message :=SetAddInfo(GetMessage());
   IF RWayS.Status = L_Way.rwsStat_Ordered THEN
    Tmp01._Source:=s_OrderedRWayS;
   ELSE
    Tmp01._Source:=s_RWayS;
   END;
   SETEMPTY(Tmp01._Dtwo);
   INSERT(Tmp01);
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 
  SELECT(WayLMen, TSN, , Staff.TSN);
  SRCINSEL(WayLMen, GE, , _From);
  WHILE OCCURE(WayLMen) & (WayLMen.RWayDate <= _UpTo) DO
   CONFORM(WayLMen, RWayS);
   Set_GuTime(_GuBTime, _GuETime);
   Tmp01._Date    :=RWayS.Date;
   Tmp01._Who     :=WayLMen.Who + 1;
   Tmp01._StartTim:=_GuBTime;
   Tmp01._RWayS   :=RWayS.RWayS;
   Tmp01._StopTim :=_GuETime;
   Tmp01._CooTSN  :=GetCooTSN(L_Way.rwswho_Driver);
   Tmp01._Message :=SetAddInfo("");
   Tmp01._Dtwo    :="";
   IF RWayS.Status = L_Way.rwsStat_Ordered THEN
    Tmp01._Source:=s_OrderedRWayS;
   ELSE
    Tmp01._Source:=s_RWayS;
   END;
   INSERT(Tmp01);
   NEXT(WayLMen);
  END; (* WHILE OCCURE(WayLMen) ... *)

  IF ApplyTWO(_UpTo) THEN
   SELECT(Dtwo, DTSN);
   SRCINSEL(Dtwo, GE, , _From);
   WHILE OCCURE(Dtwo) & (Dtwo.Date <= _UpTo) DO
    PROMPT(" "+Dtwo.Dtwo);
    CHANGESEL(Dtwo, DTSN, , Dtwo.Date);
    IF SRCINSEL(Dtwo, GE, Staff.TSN) THEN
     WHILE OCCURE(Dtwo) & (Dtwo.TSN=Staff.TSN) DO
      IF !Dtwo.RWayS THEN
       Tmp01._Date    :=Dtwo.Date;
       Tmp01._Who     :=L_Way.rwswho_Driver;
       Tmp01._StartTim:=Dtwo.BegTime;
       Tmp01._RWayS   :="";
       Tmp01._StopTim :=Dtwo.EndTime;
       Tmp01._CooTSN  :=Dtwo.GuardTSN;
       Tmp01._Message :=SetAddInfo(L_lsStore.Get(Dtwo.Message));
       Tmp01._Dtwo    :=Dtwo.Dtwo;
       Tmp01._Source  :=s_Mtwo;
       INSERT(Tmp01);
      END;
      NEXT(Dtwo);
     END; (* WHILE OCCURE(Dtwo) ... *)
    END;
    LAST(Dtwo);
    CHANGESEL(Dtwo, DTSN);
    NEXT(Dtwo);
   END; (* WHILE OCCURE(Dtwo) ... *)

   SELECT(Dtwo, DGuardTSN);
   SRCINSEL(Dtwo, GE, , _From);
   WHILE OCCURE(Dtwo) & (Dtwo.Date <= _UpTo) DO
    PROMPT(" "+Dtwo.Dtwo);
    CHANGESEL(Dtwo, DGuardTSN, , Dtwo.Date);
    IF SRCINSEL(Dtwo, GE, Staff.TSN) THEN
     WHILE OCCURE(Dtwo) & (Dtwo.GuardTSN=Staff.TSN) DO
      IF !Dtwo.RWayS THEN
       Tmp01._Date    :=Dtwo.Date;
       Tmp01._Who     :=L_Way.rwswho_Guard;
       Tmp01._StartTim:=Dtwo.BegTime;
       Tmp01._RWayS   :="";
       Tmp01._StopTim :=Dtwo.EndTime;
       Tmp01._CooTSN  :=Dtwo.TSN;
       Tmp01._Message :=SetAddInfo("");
       Tmp01._Dtwo    :=Dtwo.Dtwo;
       Tmp01._Source  :=s_Mtwo;
       INSERT(Tmp01);
      END;
      NEXT(Dtwo);
     END; (* WHILE OCCURE(Dtwo) ... *)
    END;
    LAST(Dtwo);
    CHANGESEL(Dtwo, DGuardTSN);
    NEXT(Dtwo);
   END; (* WHILE OCCURE(Dtwo) ... *)
  END;

  SETEMPTY(PrvDate);
  SETEMPTY(curPer);
  SELECT(Tmp01, Tmp01);
  WHILE OCCURE(Tmp01) DO
   IF L_DatTim.Per(Tmp01._Date) # curPer THEN
    MAKEPART(R, SubTop_TSN);
    curPer:=L_DatTim.Per(Tmp01._Date);
   END;
   MakeLine();
   NEXT(Tmp01);
  END; (* WHILE OCCURE(Tmp01) ... *)

  SETEMPTY(PrvDate);
  MAKEPART(R, RWayTxtTop);
  SELECT(Tmp01, Tmp01);
  WHILE OCCURE(Tmp01) DO
   MakeRWayTxt();
   NEXT(Tmp01);
  END; (* WHILE OCCURE(Tmp01) ... *)

  MakeRepAvePay(Staff.TSN, _From, _UpTo);
  MAKEPART(R, PageBot);
  IF ~EU_Mode() THEN
   CLOSEREP(R);
  END;
  L_AFM.AF_PurgeTemp("Tmp01");
 END {Do_byTSN};

 PRIVATE PROCEDURE _PrintLine(Value    : STRING[];
                              StrLength: NUMERIC[0];
                              PartName : STRING[]);
  VAR
   i     : NUMERIC[0];
   StrArr: STRING[][10];
 BEGIN
  Str.Format(StrArr,
             Value,
             StrLength,
             LEFT);
  MAKEPART(R, ^PartName, StrArr[0]);
  i:=1;
  WHILE ~!StrArr[i] DO
   MAKEPART(R, ^(PartName), StrArr[i]);
   INC(i);
  END; (* WHILE ~!StrArr[i]...*)
 END {_PrintLine};

 PRIVATE PROCEDURE PrintRprP(IndexValue: SCAL[1E4];
                             PartName  : STRING[]);
 BEGIN
  SELECT(RprP, RprJ, , RprS.RprS, RprT.RprT, IndexValue);
  WHILE OCCURE(RprP) DO
   CONFORM(RprP, Staff);
   CONFORM(Staff, Man);
   MAKEPART(R, ^(PartName), L_Str.PoolItem(L_Rpr.rprpwho_Pool, RprP.Who) + " " + Staff.TSN + " " + Man.Name);
   NEXT(RprP);
  END; (* WHILE OCCURE(RprP) ... *)
 END {PrintRprP};

 PRIVATE PROCEDURE PrintRprPro(_RprT   : LIKE(RprT.RprT);
                               _RprJ   : LIKE(RprJ.RprJ);
                               PartName: STRING[];
                               Length  : NUMERIC[0]);
 BEGIN
  SELECT(RprPro, RprS, , RprS.RprS, _RprT, _RprJ);
  WHILE OCCURE(RprPro) DO
   CONFORM(RprPro, Property);
   _PrintLine("$ " + Property.Name + ": " + RprPro.Value + " [" + RprPro.Property + "]", Length, PartName);
   NEXT(RprPro);
  END; (* WHILE OCCURE(RprPro) ... *)
 END {PrintRprPro};

 PRIVATE PROCEDURE PrintRWayS();
 BEGIN
  MAKEPART(R, PageTop_BoxNbr_RWayS);
  CONFORM(RWayS, Staff);
  CONFORM(Staff, Man);
  CONFORM(RWayS, StExit);
  MAKEPART(R, Line_BoxNbr_RWayS);
  SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
  LAST(XDocJrn);
  WHILE OCCURE(XDocJrn) DO
   MAKEPART(R, Line_BoxNbr,
            Str.Align(L_Str.PoolItem(L_XDoc.action_Pool, XDocJrn.Action), 20, LEFT) +
            L_DatTim.DateStr(XDocJrn.Date) + " " + L_DatTim.TimeStr(XDocJrn.BegTime));
   PREV(XDocJrn);
  END; (* WHILE OCCURE(XDocJrn) ... *)
 END {PrintRWayS};

 PRIVATE PROCEDURE PrintRprS();
 BEGIN
  MAKEPART(R, PageTop_BoxNbr_RprS);
  MAKEPART(R, Line_BoxNbr_RprS);
  PrintRprPro("", "", "Line_BoxNbr", 76);
  SELECT(RprDA, RprS, , RprS.RprS);
  WHILE OCCURE(RprDA) DO
   CONFORM(RprDA, RprDfApr);
   _PrintLine(L_Rpr.GetRprDA_AsStr(), 76, "Line_BoxNbr");
   NEXT(RprDA);
  END; (* WHILE OCCURE(RprDA) ... *)
  SELECT(RprT, RprS, , RprS.RprS);
  WHILE OCCURE(RprT) DO
   _PrintLine(L_Rpr.GetRprT_AsStr(0), 75, "Line_BoxNbr_RprS_RprT");
   PrintRprP(L_Rpr.v_EmptyIndexValue, "Line_BoxNbr_RprS_RprT");
   PrintRprPro(RprT.RprT, "", "Line_BoxNbr_RprS_RprT", 75);
   SELECT(RprJ, RprS, , RprS.RprS, RprT.RprT);
   WHILE OCCURE(RprJ) DO
    CONFORM(RprJ, RprJob);
    _PrintLine(L_Rpr.GetRprJ_AsStr(), 74, "Line_BoxNbr_RprS_RprJ");
    PrintRprP(RprJ.RprJ, "Line_BoxNbr_RprS_RprJ");
    PrintRprPro(RprT.RprT, RprJ.RprJ, "Line_BoxNbr_RprS_RprJ", 74);
    NEXT(RprJ);
   END; (* WHILE OCCURE(RprJ) ... *)
   NEXT(RprT);
  END; (* WHILE OCCURE(RprT)...*)
 END {PrintRprS};

 PRIVATE PROCEDURE PrintXDoc(XDocId: L_XDoc.tXDocId);
  VAR
   _XDocType : L_XDoc.tXDocType;
   _XDocKind : L_XDoc.tXDocKind;
   _XDoc     : L_XDoc.tXDoc;
 BEGIN
  IF ~!XDocId THEN
   L_XDoc.PositionOnXDoc(XDocId);
   L_XDoc.DecodeXDocId(XDocId, _XDocType, _XDocKind, _XDoc);
   IF    _XDocType = L_XDoc.xdt_RWayS THEN
    PrintRWayS();
   ELSIF _XDocType = L_XDoc.xdt_RprS THEN
    PrintRprS();
   ELSE
    L_General.CallUs(0);
   END;
  END;
 END {PrintXDoc};

 PRIVATE PROCEDURE Do_byBoxNbr(trgIM: tIntvlMode);
  CONST
   RepName = "CrNon";
  VAR
   BegDate,
   EndDate   : DATE;
   OnTime    : TIME;
   _XDocType : L_XDoc.tXDocType;
   _XDocKind : L_XDoc.tXDocKind;
   _XDoc     : L_XDoc.tXDoc;
   XDocIds   : L_XDoc.tXDocId[L_BegRWS.cs_Amount];
   HasInf    : SCAL[2];
   SubTit    : STRING[];
 BEGIN
  L_General.Assert(ACCESS(Car), " ⠭ ");
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  SetIntvl(trgIM, BegDate, EndDate, SubTit);
  IF trgIM = im_Sysdate THEN
   OnTime:=SYSTIME();
   SubTit:=SubTit+" "+L_DatTim.TimeStr(OnTime);
  END;
  L_Car.StandOnCarLog(Car.BoxNbr, EndDate);
  L_Car.AccessMark(Car.BoxNbr, EndDate);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, PageTop_BoxNbr, RepName, "⮭宦  "+SubTit);

  L_AFM.MakeIndex("Car01", "_Date    : LIKE(RWayS.Date);"+
                           "_StartTim: LIKE(RWayS.StartTim);"+
                           "_XDocId  : "+TYPENAMEOF(L_XDoc.tXDocId)+";"+
                           "_Dtwo    : SCAL[1E5]");
  HasInf:=0;
  IF trgIM = im_Sysdate THEN
   L_BegRWS.GetSingleBoxNbr_XDocIds(Car.BoxNbr, BegDate, OnTime, XDocIds);
   IF    ~!XDocIds[L_BegRWS.csi_Current] THEN
    L_XDoc.DecodeXDocId(XDocIds[L_BegRWS.csi_Current], _XDocType, _XDocKind, _XDoc);
    IF    _XDocType = L_XDoc.xdt_RWayS THEN
     PrintXDoc(XDocIds[L_BegRWS.csi_Current]);
    ELSIF _XDocType = L_XDoc.xdt_RprS THEN
     PrintXDoc(XDocIds[L_BegRWS.csi_Past]);
     PrintXDoc(XDocIds[L_BegRWS.csi_Current]);
     PrintXDoc(XDocIds[L_BegRWS.csi_Future]);
    ELSE
     L_General.CallUs(0);
    END;
    HasInf:=1;
   ELSIF ~!XDocIds[L_BegRWS.csi_Future] THEN
    PrintXDoc(XDocIds[L_BegRWS.csi_Future]);
    HasInf:=1;
   ELSIF ApplyTWO(BegDate) THEN
    IF SELECT(Dtwo, DBoxNbr, L_BegRWS.DspDate(BegDate, OnTime), Car.BoxNbr) THEN
     WHILE OCCURE(Dtwo) DO
      PROMPT("ᬮ 鸞 "+Dtwo.Dtwo);
      IF !Dtwo.BegTime | ((Dtwo.BegTime <= OnTime) & (OnTime <= Dtwo.EndTime)) THEN
       ADD(Car01, Car01, , Dtwo.Date, Dtwo.BegTime, "", Dtwo.Dtwo);
      END;
      NEXT(Dtwo);
     END; (* WHILE OCCURE(Dtwo) ... *)
    END; (* IF SELECT(Dtwo, DBoxNbr)... *)
   END;
  ELSE
   SELECT(RWayS, BoxNbr, , Car.BoxNbr);
   SRCINSEL(RWayS, GE, , BegDate);
   WHILE OCCURE(RWayS) & (RWayS.Date <= EndDate) DO
    PROMPT("  "+RWayS.RWayS);
    ADD(Car01, Car01, , RWayS.Date, RWayS.StartTim, L_XDoc.XDocId(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS), 0);
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS) ... *)

   IF L_Rpr.RprLev(EndDate) = L_Rpr.rprl_Active THEN
    SELECT(RprS, CUCopy, , Car.CUCopy);
    SRCINSEL(RprS, GE, , BegDate);
    WHILE OCCURE(RprS) & (RprS.OrdDate <= EndDate) DO
     PROMPT("  "+RprS.RprS);
     IF RprS.Status # L_Rpr.ms_Cancel THEN
      ADD(Car01, Car01, , RprS.OrdDate, RprS.OrdTime, L_XDoc.XDocId(L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, RprS.RprS), 0);
     END;
     NEXT(RprS);
    END; (* WHILE OCCURE(RprS) ... *)
   END;

   IF ApplyTWO(EndDate) THEN
    SELECT(Dtwo, DBoxNbr);
    SRCINSEL(Dtwo, GE, , BegDate);
    WHILE OCCURE(Dtwo) & (Dtwo.Date <= EndDate) DO
     PROMPT(" 鸞 "+Dtwo.Dtwo);
     CHANGESEL(Dtwo, DBoxNbr, , Dtwo.Date);
     IF SRCINSEL(Dtwo, GE, Car.BoxNbr) THEN
      WHILE OCCURE(Dtwo) & (Dtwo.BoxNbr=Car.BoxNbr) DO
       IF !Dtwo.RWayS THEN
        ADD(Car01, Car01, , Dtwo.Date, Dtwo.BegTime, "", Dtwo.Dtwo);
       END;
       NEXT(Dtwo);
      END; (* WHILE OCCURE(Dtwo) ... *)
     END;
     LAST(Dtwo);
     CHANGESEL(Dtwo, DBoxNbr);
     NEXT(Dtwo);
    END; (* WHILE OCCURE(Dtwo) ... *)
   END;
  END; (* IF trgIM =... *)

  IF SELECT(Car01, Car01) THEN
   MAKEPART(R, PageTop_BoxNbr_AllDoc);
   WHILE OCCURE(Car01) DO
    IF ~!Car01._XDocId THEN
     L_XDoc.DecodeXDocId(Car01._XDocId, _XDocType, _XDocKind, _XDoc);
     L_XDoc.PositionOnXDoc(Car01._XDocId);
     IF    _XDocType = L_XDoc.xdt_RWayS THEN
      CONFORM(RWayS, StExit);
      MAKEPART(R, Line_BoxNbr_AllDoc, "", RWayS.RWayS, L_BegRWS.GetRWaySEnterTime(0), RWayS.Change, GetExitClssSign(StExit.ExitClss), RWayS.TSN, GetTSNName(RWayS.TSN));
     ELSIF _XDocType = L_XDoc.xdt_RprS THEN
      MAKEPART(R, Line_BoxNbr_AllDoc, "", RprS.RprS, RprS.ETime);
     ELSE
      L_General.CallUs(0);
     END;
    ELSE
     L_two.r_Access(Car01._Date, Car01._Dtwo);
     MAKEPART(R, Line_BoxNbr_AllDoc, "", "", Dtwo.EndTime, Dtwo.Change, GetExitClssSign(Dtwo.ExitClss), Dtwo.TSN, GetTSNName(Dtwo.TSN));
    END;
    NEXT(Car01);
   END; (* WHILE OCCURE(Car01) ... *)
  ELSIF ~HasInf THEN
   MAKEPART(R, Line_BoxNbr_NoInf);
  END;
  MAKEPART(R, PageBot);
  CLOSEREP(R);
 END {Do_byBoxNbr};

 PUBLIC PROCEDURE Staff_Curdate();
 BEGIN
  Do_byTSN(im_Curdate);
 END {Staff_Curdate};

 PUBLIC PROCEDURE Staff_Sysdate();
 BEGIN
  Do_byTSN(im_Sysdate);
 END {Staff_Sysdate};

 PUBLIC PROCEDURE Staff_Per();
 BEGIN
  Do_byTSN(im_Per);
 END {Staff_Per};

 PUBLIC PROCEDURE Staff_From_Sysdate();
 BEGIN
  Do_byTSN(im_From_Sysdate);
 END {Staff_From_Sysdate};

 PUBLIC PROCEDURE Car_Sysdate();
 BEGIN
  Do_byBoxNbr(im_Sysdate);
 END {Car_Sysdate};

 PUBLIC PROCEDURE Car_Per();
 BEGIN
  Do_byBoxNbr(im_Per);
 END {Car_Per};

 PUBLIC PROCEDURE Car_From_Sysdate();
 BEGIN
  Do_byBoxNbr(im_From_Sysdate);
 END {Car_From_Sysdate};

END.
