(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose        ⪮
%Type        report
%Specific    AP
%Modified    29.05.2012 11:53:45 POLAK\LDA
%Environment
*)

 MODULE Car_Rest [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_OwnData, L_Env, L_General, L_Car, P_Car, Memo, L_Way, L_PagePr, L_AFM, L_StdFrm, L_StdFrm, L_Str;

(*
$P { FirstPage:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
CarLs_OnDate, L, "D.N.y"
Comiss[0], L, ""
Comiss[1], L, ""
Comiss[2], L, ""
Comiss[3], L, ""
@
############################################################# ########## #####
==============================================================================
|         ⪮   ࠭ᯮ ।  ##########       |
|                                                                            |
|                                                                    |
|############################################################################|
|############################################################################|
|############################################################################|
|############################################################################|
}

$P { PageTop:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
CarLs_OnDate, L, "D.N.y"
@
############################################################# ########## #####
==============================================================================
|         ⪮   ࠭ᯮ ।  ##########       |
}

(*
$P{ TopColon:
Column.Column, L, ""
Column.Name, L, ""
@
|----------------------------------------------------------------------------|
| ## ################                                                 |
|----------------------------------------------------------------------------|
| |. |ઠ              ||     |ਬ砭    |    ||
}
*)

$P { Line:
CarLog.BoxNbr, L, ""
CarLog.StateNbr, L, ""
CarLog.Mark, L, ""
Mark.Name, L, ""
L_Way.GetBakVol(Car.BoxNbr, CarLs_OnDate), R, "0"
CarCl.RWayS, L, ""
CarCl.Rem, R, "0"
@
|----|----------|-------------------|---|-------|--------------|-----|-------|
|####|##########|#### ##############|###|#######|              |#####|       |
}

$P { PageFil:
@
|----|----------|-------------------|---|-------|--------------|-----|-------|
|    |          |                   |   |       |              |     |       |
}

$P { PageBot:
Sum, R, ""
Comiss[0], L, ""
Comiss[1], L, ""
Comiss[2], L, ""
Comiss[3], L, ""
L_PagePr.PagePr_CurrentPage(), R, ""
@
|--------------------------------------------------------------|-----|-------|
|஫쭠 㬬                                             |#####|       |
|--------------------------------------------------------------------|-------|
|                                                            ||
|####################################################################|.......|
|####################################################################|.......|
|####################################################################|.......|
|####################################################################|.......|
=(c) Polak============================================================ ###
}
*)

 PRIVATE PROCEDURE CarLs_RprtTop(Mode: SCAL[20]);
  VAR
   local: PROC;
 BEGIN
  IF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, FirstPage);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {CarLs_RprtTop};

 PRIVATE PROCEDURE CarLs_PageTop(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Print THEN
   IF L_PagePr.PagePr_CurrentPage() > 1 THEN
    MAKEPART(R, PageTop);
   END;
   SEARCH(Column, Column, , CarCl.Column);
   MAKEPART(R, TopColon);
  ELSIF Mode = L_PagePr.m_RDoneTop THEN
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {CarLs_PageTop};

 PRIVATE PROCEDURE CarLs_PageBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(PageBot));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, PageBot);
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_Fill);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {CarLs_PageBot};

 PRIVATE PROCEDURE CarLs_RprtBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(0);
  ELSIF Mode = L_PagePr.m_Print THEN
  ELSIF Mode =  L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_None);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {CarLs_RprtBot};

 PRIVATE PROCEDURE CarLs_Filling(Mode: SCAL[20]);
 BEGIN
  IF Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(PageFil));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, PageFil);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {CarLs_Filling};

 PRIVATE VAR
   Sum   : NUMERIC[0];
   Comiss: STRING[68][4];
   CarLs_OnDate: DATE;

 PUBLIC PROCEDURE CarLs_Make();
  CONST
   FieldLendth = 68;
   Depth = 60;
  VAR
   Rem   : NUMERIC[0];
   _RWayS: LIKE(RWayS.RWayS);
 BEGIN
  CarLs_OnDate:=Memo.ud_cd();
  L_General.Assert(CarLs_OnDate <= SYSDATE(), "  ⮢   ");
 
  OPENREP(R, L_General.NameConnection("CarLs"), Create);
  SETEMPTY(Comiss);
  SETZERO(Sum);

  STDFORM(L_StdFrm.sf_Choice("|ଠ ।ᬠਢ  ᨨ    ." +
                             "||  㪠 ⠢ ᨨ  ⠢ " +
                             "|(  㤥   㬠 )." +
                             "||"+
                             "%"+L_Str.Repeat("#", FieldLendth)+"%|" +
                             "%"+L_Str.Repeat("#", FieldLendth)+"%|" +
                             "%"+L_Str.Repeat("#", FieldLendth)+"%|" +
                             "%"+L_Str.Repeat("#", FieldLendth)+"%|",
                             "%YI"+
                             "%YI"+
                             "%YI"+
                             "%YI"),
          ,
          ,
          ,
          Comiss[0], Comiss[1], Comiss[2], Comiss[3]);
 
  L_AFM.MakeIndex("CarCl", "Column: LIKE(Car.Column);" +
                           "BoxNbr: LIKE(Car.BoxNbr);" +
                           "RWayS : LIKE(RWayS.RWayS);" +
                           "Rem   : NUMERIC[0]");
 
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT(Car.BoxNbr);
   IF L_Env.RealBoxNbr(Car.BoxNbr) &
      L_Car.StandOnCarLogSoft(Car.BoxNbr, CarLs_OnDate) &
      (CarLog.Status # L_Car.carst_Retired) THEN
    SETEMPTY(_RWayS, Rem);
    IF SELECT(RWayS, BoxNbr, Car.BoxNbr) THEN
     IF SRCINSEL(RWayS, LT, CarLs_OnDate) THEN
      Rem   :=RWayS.RemEntr;
      _RWayS:=RWayS.RWayS;
     ELSE
      Rem:=0;
     END;
    END;
    IF !Car.EndDate | (CarLs_OnDate <= Car.EndDate) | ~!Rem & (Rem > 0) THEN
     ADD(CarCl, CarCl, , CarLog.Column, CarLog.BoxNbr, _RWayS, Rem);
    END;
   END;
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
 
  SELECT(CarCl, CarCl);
  L_PagePr.PagePr_Init("R", Depth, PROCREF(CarLs_RprtTop),
                                   PROCREF(CarLs_PageTop),
                                   PROCREF(CarLs_PageBot),
                                   PROCREF(CarLs_RprtBot),
                                   PROCREF(CarLs_Filling));
  WHILE OCCURE(CarCl) DO
   NARROWSEL(CarCl, Column);
   WHILE OCCURE(CarCl) DO
    PROMPT(CarCl.Column + " " + CarCl.BoxNbr);
    SEARCH(Car, BoxNbr, , CarCl.BoxNbr);
    L_Car.StandOnCarLog(Car.BoxNbr, CarLs_OnDate);
 
     CONFORM(CarLog, Mark);
     L_PagePr.PagePr_BeforePrintLine(DEPTH(Line));
     MAKEPART(R, Line);
     IF ~!CarCl.Rem THEN
      INC(Sum, CarCl.Rem);
     END;
    NEXT(CarCl);
   END; (* WHILE OCCURE(File) *)
   IF NEXTINEXTENDEDSEL(CarCl, Column) THEN
    L_PagePr.PagePr_SetNewPage();
   END;
  END; (* WHILE OCCURE(CarCl) *)
  L_PagePr.PagePr_Done();
  LIKEMENU(Survey, "");
 END {CarLs_Make};

END.
