(*
%Copyright   (c) Polak Computer System
%Author      SAN
%Purpose     ஫ 楯祪 ᯨ  
%Type        operation
%Specific    AP
%Modified    17.01.2014 22:17:27 POLAK\Gina
%Environment
*)

 IMPORT L_General, L_DatTim, L_OwnData, L_Math, L_Str, L_Way, L_Car, L_Fuel, L_AFM, P_Car, Memo;

 TYPE
  tPartType     = SCAL[2];
  tChainObjType = SCAL[2];

 CONST
  COT_Fuel = 0;
  COT_Run  = 1;
  COT_Pool = "|ᯨ";
  PT_Roll  = 0;
  PT_Page  = 1;

 VAR
  _RWayS    : LIKE(RWayS.RWayS);
  _Date     : LIKE(RWayS.Date);
  _RemEntr  : LIKE(RWayS.RemEntr);
  _SMAft    : LIKE(RWayS.SMAft);
  _TSN      : LIKE(RWayS.TSN);
  _Name     : LIKE(Man.Name);

  FirstInCol   : SCAL[2];

  RepName      : STRING[5];
  clmCount,
  totCount,
  clmPlus,
  clmMinus     : NUMERIC[0];

(*$P {Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
##############################################################################                                          ########## #####
-#####----------------------------------------------------------------------------------------------------------------------------------
|                                 襭 楯祪  ##########  ਮ  ##########  ##########                                 |
}
*)

(*$P{ TopCol:
Car.Column, L, ""
@
|======================================================================================================================================|
| ##                                                                                                                            |
|--------------------------------------------------------------------------------------------------------------------------------------|
|    |    |                ⥢                :  |                ⥢                 :  륧  |          |
|   N| |----------------------------------------------:---------|----------------------------------------------:---------|    |
|    |    |    .                          :|    .                          :|          |
|----|----|----------------------------------------------:---------|----------------------------------------------:---------|----------|
}
*)

(*$P {Line:
totCount, R, "0"
RWayS.BoxNbr, L, ""
_RWayS, L, ""
_Date, L, "DN"
_TSN, L, ""
_Name, L, ""
?, R, "0"
RWayS.RWayS, L, ""
RWayS.Date, L, "DN"
RWayS.TSN, L, ""
Man.Name, L, ""
?, R, "0"
?, R, ""
@
|####|####|####### #### ##### ###########################:#########|####### #### ##### ###########################:#########|##########|
}
*)

(*$P { BotCol:
clmPlus, R, ""
clmMinus, R, ""
@
|---------------------------------------------------------------------------------------------------------------------------|----------|
|⮣ ࠧ                                                                                                     |##########|
|                                                                                                                           |##########|
}
*)

(*$P { Bot:
?, R, ""
?, R, ""
@
|---------------------------------------------------------------------------------------------------------------------------|----------|
|⮣ ࠧ                                                                                                       |##########|
|                                                                                                                           |##########|
=(c) Polak==============================================================================================================================
}
*)

(*$P {LineP:
Car.Column, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
totCount, R, "0"
RWayS.BoxNbr, L, ""
_RWayS, L, ""
_Date, L, "DN"
_TSN, L, ""
?, R, "0"
RWayS.RWayS, L, ""
RWayS.Date, L, "DN"
RWayS.TSN, L, ""
?, R, "0"
@
       - ##----------------------------------------------########## #####
       |                     楯窨  #################                |
       |=======================================================================|
       |    |    |  ⥢  :    |  ⥢   :   륧   |
       |   N| |------------------:-----------|------------------:-----------|
       |    |    |  ::. :  |  ::. :  |
       |----|----|------------------:-----------|------------------:-----------|
       |####|####|####### #### #####:###########|####### #### #####:###########|
       =(c) Polak===============================================================























}
*)

(*
$P{ TopOver:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
############################################################################## ########## #####
=#####=========================================================================================
|                ॢ襭    ਮ  ##########  ##########                 |
}
*)

(*
$P{ SubTopOver:
?, L, ""
@
|---------------------------------------------------------------------------------------------|
| ##                                                                                   |
|---------------------------------------------------------------------------------------------|
|     |                |     |    |                  |      ॢ襭,      ||       |
|. |             | |.|ઠ             |------------------------|       |     |
|     |                |     |    |                  |륧||뤠||   |       |
|-----|----------------|-----|----|------------------|-----|-----|------|-----|-------|-------|
}
*)

(*
$P{ LineOver:
_FlVl.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
_FlVl.Date, L, "D.N"
_FlVl.BoxNbr, L, ""
_FlVl.Mark, L, ""
Mark.Name, L, ""
Put(_FlVl.RemExit),  R, ""
Put(_FlVl.RemEntr),  R, ""
Put(_FlVl.FuelTake), R, ""
Put(_FlVl.FuelRet),  R, ""
L_Way.GetBakVol(_FlVl.BoxNbr, _FlVl.Date), R, ""
_FlVl.RWayS, L, ""
@
|#####|################|#####|####|#### #############|#####|#####|######|#####|#######|#######|
}
*)

(*
$P{ BotOver:
@
=(c) Polak=====================================================================================
}
*)

 PRIVATE PROCEDURE Difference(): NUMERIC[0];
 BEGIN
  RETURN 0;
 END {Difference};

 PRIVATE PROCEDURE ChainObj(curCOT: tChainObjType): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(COT_Pool, curCOT);
 END {ChainObj};

 PRIVATE PROCEDURE MakePartLine(PrevValue, Value: NUMERIC[0]; curCOT: tChainObjType; curPT: tPartType);
  VAR
   Delta: NUMERIC[0];
 BEGIN
  INC(totCount);
  IF curPT = PT_Roll THEN
   IF clmCount = 0 THEN
    MAKEPART(R, TopCol);
   END;
   Delta:=Value-PrevValue;
   CONFORM(RWayS, Staff, Man);
   MAKEPART(R, Line, PrevValue, Value, Delta);
   INC(clmCount);
   IF Delta>0 THEN
    INC(clmPlus, Delta);
   ELSE
    INC(clmMinus, Delta);
   END;
  ELSE
   MAKEPART(R, LineP, ChainObj(curCOT), PrevValue, Value);
  END;
 END {MakePartLine};

 PRIVATE PROCEDURE MakeChainTstRep(curCOT: tChainObjType; curPT: tPartType);
  VAR
   totPlus,
   totMinus: NUMERIC[0];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  RepName:="ChB" + L_Str.PoolItem("F|S", curCOT) +
                   L_Str.PoolItem("R|P", curPT);
 
  SETZERO(totPlus, totMinus, totCount);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  SetPrintAttr(R, RightMargin, 0);
 
  IF curPT = PT_Roll THEN
   MAKEPART(R, Top, RepName, ChainObj(curCOT));
  END;
 
  SELECT(Car, Column);
  WHILE OCCURE(Car) DO
   CHANGESEL(Car, Column, , Car.Column);
   SETZERO(clmCount, clmPlus, clmMinus);
   WHILE OCCURE(Car) DO
    SELECT(RWayS, BoxNbr, , Car.BoxNbr);
    IF ~SRCINSEL(RWayS, LE, Memo.ud_fr()-1) THEN
     FIRST(RWayS);
    END;
    IF OCCURE(RWayS) &
       (RWayS.Status >= L_Way.rwsStat_Taken) &
       (RWayS.Date <= Memo.ud_ut()) THEN
     LOOP
      PROMPT(". "+RWayS.BoxNbr + ",  : "+L_DatTim.DateStr(RWayS.Date));
      CONFORM(RWayS, Staff, Man);
      _Name   :=Man.Name;
      _RWayS  :=RWayS.RWayS;
      _Date   :=RWayS.Date;
      _TSN    :=RWayS.TSN;
      _RemEntr:=RWayS.RemEntr;
      _SMAft  :=RWayS.SMAft;
      IF NEXT(RWayS) &
         (RWayS.Status >= L_Way.rwsStat_Taken) &
         (RWayS.Date <= Memo.ud_ut()) THEN
       IF    (curCOT = COT_Fuel) & (RWayS.RemExit # _RemEntr) THEN
        MakePartLine(_RemEntr, RWayS.RemExit, curCOT, curPT);
       ELSIF (curCOT = COT_Run) &
             (L_Math.ABS(RWayS.SMBef - _SMAft) > Difference()) THEN
        IF ~P_Car.HasCarPro(RWayS.BoxNbr, RWayS.Date, P_Car.P_SMCor) |
           (CarPro.Value # "0") THEN
         MakePartLine(_SMAft, RWayS.SMBef, curCOT, curPT);
        END;
       END;
      ELSE
       EXIT;
      END; (* IF NEXT(RWayS) ... *)
     END; (* LOOP *)
    END; (* IF OCCURE(RWayS) ... *)
    NEXT(Car);
   END; (* WHILE OCCURE(Car) *)
   LAST(Car);
   IF (curPT = PT_Roll) & (clmCount > 0) THEN
    INC(totPlus, clmPlus);
    INC(totMinus, clmMinus);
    MAKEPART(R, BotCol);
    SETZERO(clmCount, clmPlus, clmMinus);
   END;
   CHANGESEL(Car, Column);
   NEXT(Car);
  END;
 
  IF curPT = PT_Roll THEN
   MAKEPART(R, Bot, totPlus, totMinus);
  END;
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {MakeChainTstRep};

 PRIVATE PROCEDURE Create__FlVl();
 BEGIN
  CreateFILE(_FlVl, "", "ॢ襭  ", "");
  CreateFIELD(_FlVl, TSN,    LIKE(RWayS.TSN), "", "", "", "⭨", "");
  CreateFIELD(_FlVl, RWayS,  LIKE(RWayS.RWayS), "", "", "", "", "");
  CreateFIELD(_FlVl, Date,   LIKE(RWayS.Date), "", "", "", " ", "");
  CreateFIELD(_FlVl, BoxNbr, LIKE(CarLog.BoxNbr), "", "", "", "ࠦ", "");
  CreateFIELD(_FlVl, Column, LIKE(CarLog.Column), "", "", "", "", "");
  CreateFIELD(_FlVl, Mark,   LIKE(CarLog.Mark), "", "", "", "ઠ", "");
  CreateFIELD(_FlVl, RemExit,  LIKE(RWayS.RemExit), "", "", "", "ॢ襭 ⪠  륧", "");
  CreateFIELD(_FlVl, RemEntr,  LIKE(RWayS.RemEntr), "", "", "", "ॢ襭 ⪠  ", "");
  CreateFIELD(_FlVl, FuelTake, LIKE(RWayF.FuelTake), "", "", "", "ॢ襭 '뤠'", "");
  CreateFIELD(_FlVl, FuelRet,  LIKE(RWayF.FuelRet), "", "", "", "ॢ襭 'ᤠ'", "");

  CreateINDEX(_FlVl, _FlVl, UNIQUE, "", "", Column, TSN, Date, RWayS);
  CreateINDEXandLINK(_FlVl, TSN, PLURAL, Staff, TSN, USER, "", "", TSN);
  CreateINDEXandLINK(_FlVl, Mark, PLURAL, Mark, Mark, USER, "", "", Mark);
  CreateINDEXandLINK(_FlVl, RWayS, UNIQUE, RWayS, RWayS, USER, "", "", RWayS);
  SetVersionOfFILE(_FlVl, 0000);
 END {Create__FlVl};

 PRIVATE PROCEDURE Put(Value: NUMERIC[2]): STRING[];
 BEGIN
  IF Value>0 THEN RETURN FLDTOSTR(Value, "0");
  ELSE            RETURN "";
  END;
 END {Put};

 PUBLIC PROCEDURE BakOver();
  CONST
   RepName = "FlVol";
  VAR
   _RemExit : LIKE(RWayS.RemExit);
   _RemEntr : LIKE(RWayS.RemEntr);
   _FuelTake: LIKE(RWayF.FuelTake);
   _FuelRet : LIKE(RWayF.FuelRet);
   _BakVol  : LIKE(Mark.BakVol);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  Create__FlVl(); L_AFM.AF_CreateTemp("_FlVl", "_FlVl");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, TopOver, RepName);

  SELECT(RWayS, sDate, , L_Way.rwsStat_Rated);
  SRCINSEL(RWayS, GE, , Memo.ud_fr());
  WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.ud_ut()) DO
   PROMPT(": "+L_DatTim.DateStr(RWayS.Date)+" "+RWayS.RWayS);
   L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
   _BakVol:=L_Way.GetBakVol(RWayS.BoxNbr, RWayS.Date);
   _RemExit :=RWayS.RemExit-_BakVol;
   _RemEntr :=RWayS.RemEntr-_BakVol;
   SETZERO(_FuelTake, _FuelRet);
   CONFORM(RWayS, Car);
   CONFORM(RWayS, RWayF);
   WHILE OCCURE(RWayF) DO
    IF L_Fuel.IsFuelInMixOnDate(RWayS.Date, RWayF.Math) THEN
     INC(_FuelTake, RWayF.FuelTake);
     INC(_FuelRet,  RWayF.FuelRet);
    END;
    NEXT(RWayF);
   END; (* WHILE OCCURE(RWayF) ... *)
   DEC(_FuelTake, _BakVol);
   DEC(_FuelRet,  _BakVol);
   IF (_RemExit>0) | (_RemEntr>0) | (_FuelTake>0) | (_FuelRet>0) THEN
    L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
    DEFAULT(_FlVl);
    _FlVl.TSN   :=RWayS.TSN;
    _FlVl.RWayS :=RWayS.RWayS;
    _FlVl.Date  :=RWayS.Date;
    _FlVl.BoxNbr:=RWayS.BoxNbr;
    _FlVl.Column:=CarLog.Column;
    _FlVl.Mark  :=CarLog.Mark;
    _FlVl.RemExit:=_RemExit;
    _FlVl.RemEntr:=_RemEntr;
    _FlVl.FuelTake:=_FuelTake;
    _FlVl.FuelRet:=_FuelRet;
    INSERT(_FlVl);
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)

  SELECT(_FlVl, _FlVl);
  WHILE OCCURE(_FlVl) DO
   MAKEPART(R, SubTopOver, _FlVl.Column);
   CHANGESEL(_FlVl, _FlVl, , _FlVl.Column);
   WHILE OCCURE(_FlVl) DO
    PROMPT(" : "+_FlVl.Column+" "+_FlVl.TSN+" "+_FlVl.RWayS);
    CONFORM(_FlVl, Mark);
    CONFORM(_FlVl, Staff);
    CONFORM(Staff, Man);
    MAKEPART(R, LineOver);
    NEXT(_FlVl);
   END; (* WHILE OCCURE(_FlVl) ... *)
   LAST(_FlVl);
   CHANGESEL(_FlVl, _FlVl);
   NEXT(_FlVl);
  END; (* WHILE OCCURE(_FlVl) ... *)

  MAKEPART(R, BotOver);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("_FlVl");
  L_General.SurveyLastReport();
 END {BakOver};

 PUBLIC PROCEDURE ChainFlRoll();
 BEGIN
  MakeChainTstRep(COT_Fuel, PT_Roll);
 END {ChainFlRoll};

 PUBLIC PROCEDURE ChainFlPage();
 BEGIN
  MakeChainTstRep(COT_Fuel, PT_Page);
 END {ChainFlPage};

 PUBLIC PROCEDURE ChainSMRoll();
 BEGIN
  MakeChainTstRep(COT_Run, PT_Roll);
 END {ChainSMRoll};

 PUBLIC PROCEDURE ChainSMPage();
 BEGIN
  MakeChainTstRep(COT_Run, PT_Page);
 END {ChainSMPage};

END.
