(*
%Copyright   (c) Polak IT
%Author      31.10.2005 12:51:38 POLAK\GAV
%Purpose     ஫ 䨪樨 
%Type        control
%Specific    AP
%Modified    27.03.2013 18:57:44 POLAK\Gina
%Environment
*)

 MODULE Column [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Events, L_General, P_Firm, L_WDO, L_DBD;

 PRIVATE PROCEDURE Column_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (1, [L_WDO.e_OnAfterEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnAfterInsert]);
  L_WDO.iMayBeEmpty  (1, ["Column.Till", "Column.Sort"]);
 END {Column_OnInitializeWindow};

 PRIVATE PROCEDURE Column_OnBeforeInsert();
 BEGIN
  Column.MyFirm:=P_Firm.DefineMyFirm();
  REPLACE(Column);
 END {Column_OnBeforeInsert};

 PRIVATE PROCEDURE Column_OnAfterEdIns();
 BEGIN
  L_General.Assert(Column.Begin < Column.Till, "砭 ⢨    砫");
  IF ~!Column.Sort THEN
   CONFORM(Column, Sort);
   WHILE ~Sort.isDprt & ~!Sort.Parent DO
    SEARCH(Sort, Sort, , Sort.Parent);
   END;
   L_General.Assert(Sort.isDprt, "  ࠧ ஢   ⤥");
  END;
  L_DBD.CheckOwnersValidity("Column");
 END {Column_OnAfterEdIns};

 PRIVATE PROCEDURE Column_OnAfterInsert();
 BEGIN
  Column_OnAfterEdIns();
 END {Column_OnAfterInsert};

 PRIVATE PROCEDURE Column_OnAfterEdit();
 BEGIN
  Column_OnAfterEdIns();
  L_DBD.CheckUsersValidity("Column");
 END {Column_OnAfterEdit};

BEGIN
 L_Events.ExecuteHandler();
END.