(*
%Copyright   (c) Polak IT
%Author      31.05.2004 11:51:34 POLAK\ATS
%Purpose     ᮯ஢⥫  ᯥ
%Type        report
%Specific    AP
%Modified    19.02.2014 19:25:37 POLAK\GAV
%Environment
*)

 IMPORT L_General, L_OwnData, L_AFM, L_Way, L_XDoc, L_DatTim, L_Car,
        P_OwnData;

 CONST
  RepName="DSPCV";

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
SYSDATE()-1, L, "D.N.y"
?, L, "D.N.y"
?, L, "H:M"
?, L, "D.N.y"
?, L, "H:M"
@
############################################################# ########## #####
=#####========================================================================
|               ஢⥫  ᯥ  ##########              |
|                  (c ########## #####  ########## #####)                  |
}
*)

(*
$P{ Column:
RWCol.Column, L, ""
SYSDATE()-1, L, "D.N.y"
RWCol.Column, L, ""
RWCol.Amount, L, ""
@
|----------------------------------------------------------------------------|
| ##             ᤠ ⥢  (뤠 ##########  ࠭)|
|----------------------------------------------------------------------------|
|     |⥫             |   |室       |ਬ砭             |
|----------|---------------------|------|------------|-----------------------|
|          |                     |      |            |                       |
|----------|---------------------|------|------------|-----------------------|
|          |                     |      |            |                       |
|----------|---------------------|------|------------|-----------------------|
|          |                     |      |            |                       |
|----------|---------------------|------|------------|-----------------------|
|          |                     |      |            |                       |
|----------------------------------------------------------------------------|
|⮣   ##                 ਭ  ########## । __________ |
}
*)

(*
$P{ Bot:
?, L, ""
@
|----------------------------------------------------------------------------|
|⮣                               ਭ  ########## । __________ |
|----------------------------------------------------------------------------|
|                                                                            |
|                            ᯥ _____________________________________ |
|                                                                            |
|                     ।⠢⥫  _____________________________________ |
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE Create_RWCol();
 BEGIN
  CreateFILE(RWCol, "", "", "");
  CreateFIELD(RWCol, Column, LIKE(Car.Column), "", "", "", "", "");
  CreateFIELD(RWCol, Amount, NUMERIC[0],       "", "0", "", "⢮", "");
  CreateINDEX(RWCol, Column, UNIQUE, "", "", Column);
  SetVersionOfFILE(RWCol, 0000);
  L_AFM.AF_CreateTemp("RWCol", "RWCol");
 END {Create_RWCol};

 PUBLIC PROCEDURE DSPCV();
  VAR
   DRTime: TIME;
   D     : DATE;
   TAmn  : NUMERIC[0];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  Create_RWCol();
  D:=SYSDATE()-1;
  DRTime:=P_OwnData.DspPassTime(SYSDATE());
  L_General.Assert(SYSTIME() > DRTime, "஢⥫  ᯥ 믮 ᫥ "+L_DatTim.TimeStr(DRTime));
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, D, DRTime, D+1, DRTime);
  SELECT(RWayS, sRWayS, , L_Way.rwsStat_Taken);
  WHILE OCCURE(RWayS) DO
   PROMPT(" : " + RWayS.RWayS);
   SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
   LAST(XDocJrn);
   WHILE OCCURE(XDocJrn) DO
    IF XDocJrn.Action=L_XDoc.action_begRcp THEN
     IF ((XDocJrn.Date = D)     & (XDocJrn.BegTime > DRTime) ) |
        ((XDocJrn.Date = D + 1) & (XDocJrn.BegTime <= DRTime)) THEN
      L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
      ADD(RWCol, Column, , CarLog.Column,
                 RWCol.Amount, 1);
     END;
     FIRST(XDocJrn);
    END;
    PREV(XDocJrn);
   END; (* WHILE OCCURE(XDocJrn) ... *)
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)

  TAmn:=0;
  SELECT(RWCol, Column);
  WHILE OCCURE(RWCol) DO
   PROMPT(": " + RWCol.Column);
   INC(TAmn, RWCol.Amount);
   MAKEPART(R, Column);
   NEXT(RWCol);
  END; (* WHILE OCCURE(RWCol) ... *)
  MAKEPART(R, Bot, TAmn);
  L_AFM.AF_PurgeTemp("RWCol");
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {DSPCV};

END.
