(*
%Copyright   (c) Polak Computer System
%Author      12.09.2002 14:17:36 POLAK\rsn
%Purpose     C  ᯥ
%Type        report
%Specific    AP
%Modified    20.06.2012 18:21:58 POLAK\LDA
%Environment
*)

 MODULE DspRep [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_OwnData, L_Car, L_Str, L_EC, L_Env, L_Way, L_APtm, L_XDoc, P_OwnData;

 PRIVATE CONST
  PageSize = 60;

 PRIVATE VAR
  Amnt     : NUMERIC[0];
  TakeDate,
  OutDate,
  _Date    : DATE;
  OutTime,
  TakeTime,
  DRTime   : TIME;
  TakeLogin,
  OutLogin : LIKE(AcsObj.Name);
  Title,
  BotStr   : STRING[];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
PAGENUM(R), R, "0"
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
_Date, L, "D.N.y"
DRTime, L, "H:M"
_Date, L, "D.N.y"
DRTime, L, "H:M"
_Date+1, L, "D.N.y"
_Date, L, "D.N.y"
@
####################################################################################                           ## ########## #####
-------------------------------------------------------------------------------------------------------------------------------------
|                                                ᯥ  ##########                                              |
|===================================================================================================================================|
|         ਭ ⥢               | "C":" "-ਭ ६               |                                         |
|                                             |                                           |    । ⥢  ()    |
|  ( ##### ##########  ##### ##########)   |          "*"-⥢    ##########|                                         |
|---------------------------------------------|-------------------------------------------|-----------------------------------------|
|  | |  | |室    |뤠     |ਭ          ||᭥              |-|        |           |   |
}
*)

(*
$P{ Line:
RWayS.RWayS, L ""
RWayS.Date, L, "D.N"
RWayS.TSN, L, ""
RWayS.BoxNbr, L, ""
RWayS.Exit, L, ""
?, L, "HM"
?, L, ""
?, L, "D.N"
?, L, "HM"
?, L, ""
?, L, " |*"
@
|-------|-----|-----|----|---------|----------|----------------|-|------------------------|------|------|------|------|------|------|
|#######|#####|#####|####|#########|#### #####|##### #### #####|#|                        |      |      |      |      |      |      |
}
*)

(*
$P{ Fil:
@
|-------|-----|-----|----|---------|----------|----------------|-|------------------------|------|------|------|------|------|------|
|       |     |     |    |         |          |                | |                        |      |      |      |      |      |      |
}
*)

(*
$P{ Bot:
?, L, ""
@
|-----------------------------------------------------------------------------------------------------------------------------------|
|###################################################################################################################################|
==(c) Polak==========================================================================================================================
}
*)

(*
$P{ Top1:
L_OwnData.ODFirmName(SYSDATE()), L, ""
PAGENUM(R), R, "0"
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
_Date, L, "D.N.y"
?, L, ""
@
###############################################################################                              ### ########## #####
------------------------------------------------------------------------------------------------------------------------------------
|                                               ᯥ  ##########                                              |
|==================================================================================================================================|
|##################################################################################################################################|
|----------------------------------------------------------------------------------------------------------------------------------|
|  |⥫                  | |室    ||᭥                                                                   |
}
*)
(*
$P{ Line1:
RWayS.RWayS, L ""
RWayS.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
RWayS.BoxNbr, L, ""
RWayS.Exit, L, ""
RWayS.CopyCnt, R, "0"
@
|-------|--------------------------|----|---------|--|-----------------------------------------------------------------------------|
|#######|##### ####################|####|#########|##|                                                                             |
}
*)

(*
$P{ Fil1:
@
|-------|--------------------------|----|---------|--|-----------------------------------------------------------------------------|
|       |                          |    |         |  |                                                                             |
}
*)

(*
$P{ Bot1:
@
==(c) Polak=========================================================================================================================
}
*)

(*
$P{ Top2:
L_OwnData.ODFirmName(SYSDATE()), L, ""
PAGENUM(R), R, "0"
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
_Date, L, "D.N.y"
_Date, L, "D.N.y"
@
###############################################################################                              ### ########## #####
------------------------------------------------------------------------------------------------------------------------------------
|                                               ᯥ  ##########                                              |
|==================================================================================================================================|
|殮 ⮬  ##########                                                                                            |
|----------------------------------------------------------------------------------------------------------------------------------|
| |. |ઠ                              |᭥                                                                    |
}
*)
(*
$P{ Line2:
Car.BoxNbr, L ""
CarLog.StateNbr, L, ""
CarLog.Mark, L, ""
Mark.Name, L, ""
@
|----|----------|-----------------------------------|------------------------------------------------------------------------------|
|####|##########|## ################################|                                                                              |
}
*)

(*
$P{ Fil2:
@
|----|----------|-----------------------------------|------------------------------------------------------------------------------|
|    |          |                                   |                                                                              |
}
*)

 PRIVATE PROCEDURE LastPage();
 BEGIN
  WHILE LINENUM(R) <= PageSize DO
   MAKEPART(R, Fil);
  END;
  MAKEPART(R, Bot, BotStr); FORMFEED(R);
 END {LastPage};

 PRIVATE PROCEDURE NextPage();
 BEGIN
  IF LINENUM(R) > PageSize THEN
   MAKEPART(R, Bot1); FORMFEED(R);
  END;
  IF (LINENUM(R) = 0) & (Amnt > 0) THEN
   MAKEPART(R, Top);
  END;
 END {NextPage};

 PRIVATE PROCEDURE LastPage1();
 BEGIN
  WHILE LINENUM(R) <= PageSize DO
   MAKEPART(R, Fil1);
  END;
  MAKEPART(R, Bot, BotStr); FORMFEED(R);
 END {LastPage1};

 PRIVATE PROCEDURE NextPage1();
 BEGIN
  IF LINENUM(R) > PageSize THEN
   MAKEPART(R, Bot1); FORMFEED(R);
  END;
  IF (LINENUM(R) = 0) & (Amnt > 0) THEN
   MAKEPART(R, Top1, Title);
  END;
 END {NextPage1};

 PRIVATE PROCEDURE LastPage2();
 BEGIN
  WHILE LINENUM(R) <= PageSize DO
   MAKEPART(R, Fil2);
  END;
  MAKEPART(R, Bot, BotStr); FORMFEED(R);
 END {LastPage2};

 PRIVATE PROCEDURE NextPage2();
 BEGIN
  IF LINENUM(R) > PageSize THEN
   MAKEPART(R, Bot1); FORMFEED(R);
  END;
  IF (LINENUM(R) = 0) & (Amnt > 0) THEN
   MAKEPART(R, Top2);
  END;
 END {NextPage2};

 PRIVATE PROCEDURE LastParamsOfOperation(_Action: LIKE(XDocJrn.Action);
                                 _RWayS : LIKE(RWayS.RWayS);
                                 VAR _Date   : DATE;
                                 VAR _BegTime: TIME;
                                 VAR _Login  : LIKE(AcsObj.Name));
 BEGIN
  SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
  WHILE OCCURE(XDocJrn) DO
   IF XDocJrn.Action = _Action THEN
    _Date   :=XDocJrn.Date;
    _BegTime:=XDocJrn.BegTime;
    CONFORM(XDocJrn, AcsObj);
    _Login  :=AcsObj.Name;
   END;
   NEXT(XDocJrn);
  END; (* WHILE OCCURE(XDocJrn) ... *)
 END {LastParamsOfOperation};

 PRIVATE PROCEDURE PrintTakeOnRWayS();
 BEGIN
  SETZERO(Amnt);
  SELECT(RWayS, sRWayS, , L_Way.rwsStat_Taken);
  WHILE OCCURE(RWayS) DO
   PROMPT(" : ਭ / " + RWayS.RWayS);
   SETEMPTY(TakeDate, TakeTime, TakeLogin, OutDate, OutTime, OutLogin);
   LastParamsOfOperation(L_XDoc.action_begRcp, RWayS.RWayS, TakeDate, TakeTime, TakeLogin);
   IF L_DatTim.IsActive_Inc(TakeDate, _Date , _Date+1) &
     ((TakeDate = _Date) & (TakeTime > DRTime) | (TakeDate = _Date+1) & (TakeTime <= DRTime)) THEN
    LastParamsOfOperation(L_XDoc.action_begDst, RWayS.RWayS, OutDate, OutTime, OutLogin);
    INC(Amnt);
    NextPage();
    MAKEPART(R, Line, OutTime, OutLogin, TakeDate, TakeTime, TakeLogin, _Date # RWayS.Date);
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
  BotStr:="⮣ ਭ" + FLDTOSTR(Amnt, "0", 4) + " ⥢ ⮢";
  IF Amnt > 0 THEN
   LastPage();
  END;
 END {PrintTakeOnRWayS};

 PRIVATE PROCEDURE PrintUnTakeRWayS();
 BEGIN
  Title:=" ਭ ⥢  (뤠 " + L_DatTim.DateStr(_Date) + "  ࠭)";
  SETZERO(Amnt);
  SELECT(RWayS, sRWayS, , L_Way.rwsStat_Given);
  WHILE OCCURE(RWayS) DO
   PROMPT(" : ਭ / " + RWayS.RWayS);
   IF RWayS.Date <= _Date THEN
    CONFORM(RWayS, Staff, Man);
    INC(Amnt);
    NextPage1();
    MAKEPART(R, Line1);
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
  BotStr:="⮣  ਭ " + FLDTOSTR(Amnt, "0", 4) + " ⥢ ⮢";
  IF Amnt > 0 THEN
   LastPage1();
  END;
 END {PrintUnTakeRWayS};

 PRIVATE PROCEDURE PrintNotOutRWayS();
 BEGIN
  Title:="⢮ ப ࠧ浪 (ࠧ殮  " + L_DatTim.DateStr(_Date) + "  ࠭)";
  SETZERO(Amnt);
  SELECT(RWayS, sDate, , L_Way.rwsStat_Ordered);
  SRCINSEL(RWayS, LT, , _Date+1);
  WHILE OCCURE(RWayS) DO
   PROMPT(" : ᯮ짮 / " + RWayS.RWayS);
   CONFORM(RWayS, Staff, Man);
   INC(Amnt);
   NextPage1();
   MAKEPART(R, Line1);
   PREV(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
  BotStr:="⮣ " + FLDTOSTR(Amnt, "0", 4) + " ⢮ ப ࠧ浪";
  IF Amnt > 0 THEN
   LastPage1();
  END;
 END {PrintNotOutRWayS};

 PRIVATE PROCEDURE PrintRePrintRWayS();
 BEGIN
  Title:="祭 ९⠭ 㬥⮢      () " + L_DatTim.DateStr(_Date) + "     ()";
  SETZERO(Amnt);
  SELECT(RWayS, Date, , _Date);
  WHILE OCCURE(RWayS) DO
   PROMPT(" : ९⠭ / " + RWayS.RWayS);
   IF RWayS.CopyCnt > 1 THEN
    CONFORM(RWayS, Staff, Man);
    INC(Amnt);
    NextPage1();
    MAKEPART(R, Line1);
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
  BotStr:="⮣ " + FLDTOSTR(Amnt, "0", 4) + " ९⠭ 㬥⮢";
  IF Amnt > 0 THEN
   LastPage1();
  END;
 END {PrintRePrintRWayS};

 PRIVATE PROCEDURE PrintUnBegCar();
 BEGIN
  SETZERO(Amnt);
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT(" : 殮  " + Car.BoxNbr);
   IF ~SELECT(RWayS, BoxNbr, Car.BoxNbr, _Date) THEN
    IF L_Car.CarIsInOperation(Car.BoxNbr, _Date) & CarLog.InBeg THEN
     CONFORM(CarLog, Mark);
     INC(Amnt);
     NextPage2();
     MAKEPART(R, Line2);
    END;
   END;
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
  BotStr:="⮣ " + FLDTOSTR(Amnt, "0", 4) + " 殮 ⮬";
  IF Amnt > 0 THEN
   LastPage2();
  END;
 END {PrintUnBegCar};

 PUBLIC PROCEDURE DspRp();
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);

  DRTime:=P_OwnData.DspRepTime(SYSDATE());
  _Date :=SYSDATE()-1;
 
  L_General.Assert(SYSTIME() > DRTime, "  ᯥ 믮 ᫥ "+FLDTOSTR(DRTime, "H:M"));
  OPENREP(R, L_General.NameConnection("DspRp"), Create);
 
  IF L_APtm.IsMTA() THEN
   PrintTakeOnRWayS();
   PrintUnBegCar();
  END;
 
  PrintUnTakeRWayS();
 
  PrintNotOutRWayS();
 
  PrintRePrintRWayS();
 
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {DspRp};

END.
