(*
%Copyright   (c) Polak Computer System
%Author      07.12.1998 13:38:16 BOR
%Type        report
%Specific    AP
%Modified    04.01.2014 17:44:59 POLAK\Gina
%Environment
*)

 MODULE ECSort [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_OwnData, L_AFM, Memo, L_Way, L_Events, L_Staff;

 CONST
  RepName = "ExCls";

(*
$P { Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_cd(), L, "D.N.y"
@
####################################################################################### ########## #####
=#####==================================================================================================
|                            ९ 室  ᥪࠬ  ##########                            |
}

$P { SubTop:
?, L, ""
@
|------------------------------------------------------------------------------------------------------|
|###########################################################################                           |
|------------------------------------------------------------------------------------------------------|
|室                                           ||砫|.|६|ᮢ|        |
|------------------------------------------------|--|------|------|-----|------|-----------------------|
}                  

$P { Line:
?, L, ""
StExit.Name, L, ""
?, L, ""
StExit.Change, L, ""
L_Way.FullStExitBegTimeStr(), L, ""
L_Way.FullStExitStopTimStr(), L, ""
StExit.TotT, R, "1."
StExit.TripAm, R, ""
L_Way.StExitOnDaysAsStr(), L, ""
@
|######### ############################## #######|# |##### |##### |#####|   ###|#######################|
}

$P { Bot:
@
=(c) Polak==============================================================================================
}
*)

 PRIVATE PROCEDURE TypeSort();
 BEGIN
  WHILE OCCURE(_Exit) DO
   PROMPT(_Exit._Exit);
   L_General.Assert(SEARCH(StExit, Exit, _Exit._Exit), "Error 234");
   MAKEPART(R, Line, _Exit._Exit, _Exit._Sign);
   NEXT(_Exit);
  END; (* WHILE OCCURE(_Exit)... *)
 END {TypeSort};

 PUBLIC PROCEDURE ExCls();
 BEGIN
  L_AFM.MakeIndex("_Exit", "_Sort: LIKE(Sort.Sort);"+
                              "_Exit: LIKE(StExit.Exit);"+
                              "_Sign: LIKE(ExitClss.Sign)");
 
  SELECT(StExit, Strict);
  WHILE OCCURE(StExit) DO
   CHANGESEL(StExit, Strict, , StExit.Strict);
   SRCINSEL(StExit, GE, , Memo.ud_cd());
   WHILE OCCURE(StExit) DO
    PROMPT(StExit.Exit);
    IF L_DatTim.IsActive(Memo.ud_cd(), StExit.FromD, StExit.UpDate) THEN
     CONFORM(StExit, ExitClss);
     _Exit._Sort:=L_Way.E_GetFixedSortOfExit(StExit.Exit, Memo.ud_cd(), L_Way.rwswho_Driver);
     _Exit._Exit:=StExit.Exit;
     _Exit._Sign:=ExitClss.Sign;
     IF ~!_Exit._Sort | (StExit.Strict = L_Way.ExitStrict_Reg) THEN
      INSERT(_Exit);
     END;
    END;
    NEXT(StExit);
   END; (* WHILE OCCURE(StExit) ... *)
   LAST(StExit);
   CHANGESEL(StExit, Strict);
   NEXT(StExit);
  END; (* WHILE OCCURE(StExit) ... *)
 
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top);
 
  SELECT(Sort, Sort);
  WHILE OCCURE(Sort) DO
   IF SELECT(_Exit, _Exit, Sort.Sort) THEN
    MAKEPART(R, SubTop, " " + Sort.Sort + " " + Sort.Name);
    TypeSort();
   END;
   NEXT(Sort);
  END; (* WHILE OCCURE(Sort)... *)
  IF SELECT(_Exit, _Exit, "") THEN
   MAKEPART(R, SubTop, "९ ॣ 室");
   TypeSort();
  END;
 
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {ExCls};

 PRIVATE PROCEDURE ECSort_OnAfterEdIns();
 BEGIN
  CONFORM(ECSort, Sort);
  L_Staff.CheckVeritableSort("");
  SAVE(ExitClss);
  IF ~!ECSort.ExitClss THEN
   CHANGESEL(ECSort, ExitClss, , ECSort.ExitClss, ECSort.Date);
  ELSIF ~!ECSort.Exit THEN
   CHANGESEL(ECSort, Exit, , ECSort.Exit, ECSort.Date);
  END;
  L_General.Assert(FIRST(ECSort) & ~NEXT(ECSort), "    ⠪ 祭 ");
  RESTORE(ExitClss);
 END {ECSort_OnAfterEdIns};

 PRIVATE PROCEDURE ECSort_OnAfterEdit();
 BEGIN
  ECSort_OnAfterEdIns();
 END {ECSort_OnAfterEdit};

 PRIVATE PROCEDURE ECSort_OnAfterInsert();
 BEGIN
  ECSort_OnAfterEdIns();
 END {ECSort_OnAfterInsert};

BEGIN
 L_Events.ExecuteHandler();
END.
