(*
%Copyright   (c) Polak IT
%Author      16.09.2003 11:48:55 POLAK\LDA
%Purpose     宦 ப  㯯 ப
%Type        report
%Specific    AP
%Modified    10.04.2012 12:00:50 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_OwnData, L_AFM, Memo, L_DatTim, P_Mark;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
" 㯯 ப "+MarkGT.MarkGT+" "+MarkGT.Name, C , ""
?, C, ""
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
|############################################################################|
}
*)

(*
$P{ SubTop:
?, L, ""
@
|----------------------------------------------------------------------------|
|############################################################################|
|----------------------------------------------------------------------------|
}
*)

(*
$P{ Line:
Mark.Mark, L, ""
Mark.Name, L, ""
@
|#### #######################################################################|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CreateFILE(Tmp, "", "६ 䠩", "");

  CreateFIELD(Tmp, Mark,    LIKE(Mark.Mark),   "", "", "", "ઠ", "");
  CreateFIELD(Tmp, InGroup, SCAL[2],           "", "", "", "室  㯯", "");
  CreateFIELD(Tmp, MarkG,   LIKE(MarkG.MarkG), "", "", "", "", "");

  CreateINDEXandLINK(Tmp, Mark,    PLURAL, Mark, Mark, USER,   "", "", Mark);
  CreateINDEXandLINK(Tmp, MarkG,   PLURAL, MarkG, MarkG, USER, "", "", MarkG);
  CreateINDEX       (Tmp, InGroup, PLURAL,                     "", "", InGroup, MarkG, Mark);
  SetVersionOfFILE(Tmp, 0);
  L_AFM.AF_CreateTemp("Tmp", "Tmp");
 END {Create_Tmp};

 PRIVATE PROCEDURE InsIntoTmp(_InGroup: SCAL[2];
                      _MarkG  : LIKE(MarkG.MarkG));
 BEGIN
  DEFAULT(Tmp);
  Tmp.Mark   :=Mark.Mark;
  Tmp.InGroup:=_InGroup;
  Tmp.MarkG  :=_MarkG;
  INSERT(Tmp);
 END {InsIntoTmp};

 PRIVATE PROCEDURE IsAcceptableMark(trg_use_Self: LIKE(Mark.use_Self);
                                    trg_use_OutC: LIKE(Mark.use_OutC)): SCAL[2];
 BEGIN
  IF    (trg_use_Self = 1) & (trg_use_OutC = 1) THEN
   RETURN 1;
  ELSIF trg_use_Self = 1 THEN
   RETURN (Mark.use_Self = 1);
  ELSIF trg_use_OutC = 1 THEN
   RETURN (Mark.use_OutC = 1);
  END;
 END {IsAcceptableMark};

 PRIVATE PROCEDURE MakeIndex(trg_use_Self: LIKE(Mark.use_Self);
                     trg_use_OutC: LIKE(Mark.use_OutC));
  VAR
   _InGroup: SCAL[2];
 BEGIN
  Create_Tmp();
  SELECT(Mark, Mark);
  WHILE OCCURE(Mark) DO
   PROMPT("ࠡ⪠ " + Mark.Mark);
   IF L_DatTim.IsActive(Memo.ud_cd(), Mark.Begin, Mark.Till) &
      IsAcceptableMark(trg_use_Self, trg_use_OutC) THEN
    _InGroup:=0;
    SELECT(MarkGM, Mark, , Mark.Mark);
    WHILE OCCURE(MarkGM) DO
     CONFORM(MarkGM, MarkG);
     IF MarkGT.MarkGT = MarkG.MarkGT THEN
      _InGroup:=1;
      InsIntoTmp(_InGroup, MarkG.MarkG);
      END;
     NEXT(MarkGM);
    END; (* WHILE OCCURE(MarkGM) ... *)
    IF ~_InGroup THEN
     InsIntoTmp(_InGroup, L_General.EMPTY_NUMBER());
    END;
   END;
   NEXT(Mark);
  END; (* WHILE OCCURE(Mark) ... *)
 END {MakeIndex};

 PRIVATE PROCEDURE PrintRep(trg_use_Self: LIKE(Mark.use_Self);
                    trg_use_OutC: LIKE(Mark.use_OutC));
  CONST
   RepName = "EntMG";
  VAR
   Title,
   _Name: STRING[];
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create);
  IF    (trg_use_Self = 1) & (trg_use_OutC = 1) THEN
   Title:="宦  ப";
  ELSIF trg_use_Self = 1 THEN
   Title:="宦 ப ᮡ⢥ ";
  ELSIF trg_use_OutC = 1 THEN
   Title:="宦 ப ஭ ";
  END;

  MAKEPART(R, Top, RepName, Title + "  " + L_DatTim.DateStr(Memo.ud_cd()));
  SELECT(Tmp, InGroup);
  WHILE OCCURE(Tmp) DO
   PROMPT(" " + Tmp.Mark);
   CHANGESEL(Tmp, InGroup, , Tmp.InGroup);
   WHILE OCCURE(Tmp) DO
    CHANGESEL(Tmp, InGroup, , Tmp.InGroup, Tmp.MarkG);
    IF ~!Tmp.MarkG THEN
     CONFORM(Tmp, MarkG);
     _Name :="㯯 ப " + MarkG.MarkG + " " + MarkG.Name;
    ELSE
     _Name :=" 室     㯯 ப";
    END;
    MAKEPART(R, SubTop, _Name);
    WHILE OCCURE(Tmp) DO
     CONFORM(Tmp, Mark);
     MAKEPART(R, Line);
     NEXT(Tmp);
    END; (* WHILE OCCURE(Tmp) ... *)
    LAST(Tmp);
    CHANGESEL(Tmp, InGroup, , Tmp.InGroup);
    NEXT(Tmp);
   END; (* WHILE OCCURE(Tmp) ... *)
   LAST(Tmp);
   CHANGESEL(Tmp, InGroup);
   NEXT(Tmp);
  END; (* WHILE OCCURE(Tmp) ... *)
  MAKEPART(R, Bot);
  L_AFM.AF_PurgeTemp("Tmp");
 END {PrintRep};

 PRIVATE PROCEDURE MakeRep();
  VAR
   trg_use_Self: LIKE(Mark.use_Self);
   trg_use_OutC: LIKE(Mark.use_OutC);
 BEGIN
  L_General.Assert(ACCESS(MarkGT), " ࠭  㯯 ப");
  P_Mark.GetDefaultViewMarkScopeMode(trg_use_Self, trg_use_OutC);
  MakeIndex(trg_use_Self, trg_use_OutC);
  PrintRep(trg_use_Self, trg_use_OutC);
 END {MakeRep};

END.
