(*
%Copyright   (c) Polak Computer System
%Author      23.09.1999 12:08:51 RSN
%Purpose     ନ஢ ⠡  ଠ ⮯  ઠ  ⠬
%Type        report
%Specific    AP
%Modified    14.03.2013 11:38:43 POLAK\GAV
%Environment
*)

 MODULE Fl001 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Way, L_General, L_DatTim, L_AFM, L_Basis, L_Fuel, L_Car,
        L_Staff, Memo, FIO, Math, P_OwnData, D_Fl, P_Route, P_Mark, L_bp, P_Car, L_SQL, L_Str, Str, L_MSWStp,
        L_XDoc, L_Guard, L_RWayS;

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "祭");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ॢ");
  L_Basis.wb_WrInQM(F, " ॢ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "६");
  L_Basis.wb_WrInQM(F, "६  ࠡ⮩ ᪮ 㤮");
  L_Basis.wb_WrInQM(F, "஡");

  L_Basis.wb_WrInQM(F, "ଠ  થ  100 ");
  L_Basis.wb_WrInQM(F, "ଠ  100 ");
  L_Basis.wb_WrInQM(F, "ଠ  ");
  L_Basis.wb_WrInQM(F, "ࠢ    ");
  L_Basis.wb_WrInQM(F, "ࠢ    ");
  L_Basis.wb_WrInQM(F, "ࠢ     ");
  L_Basis.wb_WrInQM(F, "ࠢ    થ");
  L_Basis.wb_WrInQM(F, "ࠢ    ");
  L_Basis.wb_WrInQM(F, "ࠢ    䨪樨 ");
  L_Basis.wb_WrInQM(F, "ࠢ  ଥ  100 ");

  L_Basis.wb_WrInQM(F, "ଠ ");
  L_Basis.wb_WrInQM(F, "ଠ  ");
  L_Basis.wb_WrInQM(F, "ଠ  ࠡ ᪮ 㤮");
  L_Basis.wb_WrInQM(F, "ଠ  ணॢ");
  L_Basis.wb_WrInQM(F, "ଠ  㤮");

  L_Basis.wb_WrInQM(F, " 騩");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "  ࠡ ᪮ 㤮");
  L_Basis.wb_WrInQM(F, "  ணॢ");
  L_Basis.wb_WrInQM(F, "  㤮");

  L_Basis.wb_WrInQM(F, "⮪  砫");
  L_Basis.wb_WrInQM(F, "뤠");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⮪  ");

  L_Basis.wb_WrInQM(F, "⥫쭠 ଠ  ");

  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]);
 BEGIN
  L_Basis.wb_WrScl(F, _MrRt.RWayS);
  L_Basis.wb_WrDat(F, _MrRt.Date);
  L_Basis.wb_WrStr(F, Column.Column);
  L_Basis.wb_WrStr(F, Column.Name);
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Basis.wb_WrStr(F, FLDTOSTR(CarLog.Purpose, L_Car.purp_Pool));
  L_Basis.wb_WrScl(F, Car.BoxNbr);
  L_Basis.wb_WrScl(F, Car.StateNbr);
  L_Basis.wb_WrScl(F, TKind.TKind);
  L_Basis.wb_WrStr(F, TKind.Name);
  L_Basis.wb_WrStr(F, Route.Route);
  L_Basis.wb_WrStr(F, Route.Name);
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrStr(F, Math.Math);
  L_Basis.wb_WrStr(F, Math.Name);
  L_Basis.wb_WrNum(F,                        _MrRt.Time, 3);
  L_Basis.wb_WrNum(F, (_MrRt.Norms[1] > 0) * _MrRt.Time, 3);
  L_Basis.wb_WrNum(F, _MrRt.Run,  2);
  L_Basis.wb_WrNum(F, P_Mark.GetP_FConRun(Mark.Mark, Memo.ud_ut()), 2); (* ଠ  થ - - 1213 ન*)
  L_Basis.wb_WrNum(F, _MrRt.Norm,       4);                             (*ଠ  100 *)
  L_Basis.wb_WrNum(F, _MrRt.MarkFNAlFTim, 2);
  L_Basis.wb_WrNum(F, _MrRt.WinterC,     3);
  L_Basis.wb_WrNum(F, _MrRt.FCarCMove,   3);
  L_Basis.wb_WrNum(F, _MrRt.CorFNAgeCar, 3);
  L_Basis.wb_WrNum(F, _MrRt.FMarkCMove,  3);
  L_Basis.wb_WrNum(F, _MrRt.FRouteCMove, 3);
  L_Basis.wb_WrNum(F, _MrRt.RoutModFCor, 3);
  L_Basis.wb_WrNum(F, _MrRt.FCM,         3);
  L_Basis.wb_WrNum(F, _MrRt.FullNorm, 4);
  L_Basis.wb_WrNum(F, _MrRt.Norms[0], 4);
  L_Basis.wb_WrNum(F, _MrRt.Norms[1], 4);
  L_Basis.wb_WrNum(F, _MrRt.Norms[2], 4);
  L_Basis.wb_WrNum(F, _MrRt.Norms[3], 4);
  L_Basis.wb_WrNum(F, _MrRt.FuelFact, 4);
  L_Basis.wb_WrNum(F, _MrRt.MoveFact, 4);
  L_Basis.wb_WrNum(F, _MrRt.HeatFact, 4);
  L_Basis.wb_WrNum(F, _MrRt.WarmFact,   4);
  L_Basis.wb_WrNum(F, _MrRt.ExtrasFact, 4);

  L_Basis.wb_WrNum(F, 0, 2);
  L_Basis.wb_WrNum(F, 0, 2);
  L_Basis.wb_WrNum(F, 0, 2);
  L_Basis.wb_WrNum(F, 0, 2);

  L_Basis.wb_WrNum(F, _MrRt.AddNorm, 4);

  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE MakePart_Fict(F: STRING[]; RemBeg, FuelTake, FuelRet, RemEnd: NUMERIC[2]);
 BEGIN
  L_Basis.wb_WrScl(F, "");
  L_Basis.wb_WrDat(F, L_General.EMPTY_DATE());
  L_Basis.wb_WrStr(F, Column.Column);
  L_Basis.wb_WrStr(F, Column.Name);
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Basis.wb_WrStr(F, FLDTOSTR(CarLog.Purpose, L_Car.purp_Pool));
  L_Basis.wb_WrScl(F, Car.BoxNbr);
  L_Basis.wb_WrScl(F, Car.StateNbr);
  L_Basis.wb_WrStr(F, "--");
  L_Basis.wb_WrStr(F, "----");
  L_Basis.wb_WrStr(F, "--");
  L_Basis.wb_WrStr(F, "----");
  L_Basis.wb_WrStr(F, "----");
  L_Basis.wb_WrStr(F, "----");
  L_Basis.wb_WrScl(F, Math.Math);
  L_Basis.wb_WrStr(F, Math.Name);
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrNum(F, P_Mark.GetP_FConRun(Mark.Mark, Memo.ud_ut()), 2);
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrNum(F, RemBeg, 2);
  L_Basis.wb_WrNum(F, FuelTake, 2);
  L_Basis.wb_WrNum(F, FuelRet, 2);
  L_Basis.wb_WrNum(F, RemEnd, 2);
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_TermLine(F);
 END {MakePart_Fict};

 PRIVATE PROCEDURE OneRWayS();
  VAR
   _Time        : NUMERIC[3];
   _Run         : NUMERIC[2];
   WarmFact,
   ExtrasFact,
   FullFact,
   _FuelFact,
   MoveFact,
   HeatFact,
   ReminderhtFact,
   htFact       : NUMERIC[4];
   _WithDp      : SCAL[2];
   Norms        : L_Way.tNorms;
   CorFNAgeCar,
   FRouteCMove,
   FCM,
   _FuelNorm,
   _Norm        : NUMERIC[4];
   ReminderhtRoute: LIKE(SEJobs.Route);
 BEGIN
  L_Way.PrepareFNorm();
  SETZERO(htFact);
  CONFORM(RWayS, RWayF);
  WHILE OCCURE(RWayF) DO
   IF L_Fuel.IsInMix(RWayS.Date, Mark.Mark, RWayF.Math, L_Fuel.im_Heater) THEN
    INC(htFact, L_Fuel._FuelFact());
   END;
   NEXT(RWayF);
  END; (* WHILE OCCURE(RWayF) ... *)
  ReminderhtFact:=htFact;
  _FuelFact     :=RWayS.FuelFact;
  _FuelNorm     :=RWayS.FuelNorm;
  SELECT(RWayJ, RWayS, , RWayS.RWayS);
  WHILE OCCURE(RWayJ) DO
   SETZERO(Norms, FCM);
   CONFORM(RWayJ, SEJobs, Route, RoutMod, WJMode, Quality);
   _Time  := RWayJ.StopT  - RWayJ.StartT;
   _Run   := RWayJ.Run    * RWayJ.Fact;
   _WithDp:=L_Way._IsWith(L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT),
                          L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT),
                          L_Way.wlmwho_DrPupil);
   L_Way.extCalcFN(RWayS.Date, _Time, _Run, _WithDp, _Norm, Norms, FCM, FRouteCMove, CorFNAgeCar, 1);
   IF RWayS.FuelNorm > 0 THEN
    IF _FuelNorm = RWayJ.FNorm THEN
     FullFact:=_FuelFact;
    ELSE
     FullFact:=RWayS.FuelFact * RWayJ.FNorm / RWayS.FuelNorm;
    END;
    DEC(_FuelFact, FullFact);
    DEC(_FuelNorm, RWayJ.FNorm);
    WarmFact  :=RWayS.FuelFact * Norms[2] / RWayS.FuelNorm;
    ExtrasFact:=RWayS.FuelFact * Norms[3] / RWayS.FuelNorm;
    IF Mark.IsolHeat THEN (*થ⤥멎⮯⥫*)
     HeatFact:=htFact * Norms[1] / RWayS.FuelNorm;
     (* ᯮ짮 RWayS.FuelNorm  ய樨 - 䨣.   ன 室  . 13.09.2010 12:47:16 POLAK\San *)
     IF Norms[1] # 0 THEN
      DEC(ReminderhtFact, HeatFact);
      ReminderhtRoute:=SEJobs.Route;
     END;
    ELSE
     HeatFact:=RWayS.FuelFact * Norms[1] / RWayS.FuelNorm;
    END;
   ELSE
    FullFact  :=0;
    HeatFact  :=0;
    WarmFact  :=0;
    ExtrasFact:=0;
   END;

   MoveFact:=FullFact - HeatFact - WarmFact - ExtrasFact;

   IF L_Way.E_FuelMoveNormAsCfcSum(RWayS.Date) &
      P_Route.HasActualRoutePro(Route.Route, RWayS.Date, P_Route.P_FuelNormCoef) THEN
    _Norm:=_Norm*(1+STRTOFLD(RoutePro.Value, NUMERIC)/100);
   END;

   IF Norms[0] | Norms[1] | Norms[2] | Norms[3] THEN
    ADD(_MrRt, TSN, , RWayS.TSN, RWayS.BoxNbr, CarLog.StateNbr, SEJobs.Route, RWayS.RWayS, RWayS.Date, _Norm,
                      _MrRt.Time,     _Time,
                      _MrRt.Run,      _Run,
                      _MrRt.Norms[0], Norms[0],
                      _MrRt.Norms[1], Norms[1],
                      _MrRt.Norms[2], Norms[2],
                      _MrRt.Norms[3], Norms[3],
                      _MrRt.FullNorm, Norms[0] + Norms[1] + Norms[2] + Norms[3],
                      _MrRt.FuelFact, FullFact,
                      _MrRt.MoveFact, MoveFact,
                      _MrRt.HeatFact, HeatFact,
                      _MrRt.WarmFact, WarmFact,
                      _MrRt.ExtrasFact, ExtrasFact);

    _MrRt.RoutModFCor :=RoutMod.FCor;
    _MrRt.MarkFNAlFTim:=L_Way.MarkFNAlFTim;
    _MrRt.FRouteCMove :=FRouteCMove;
    _MrRt.CorFNAgeCar :=CorFNAgeCar;
    _MrRt.FCarCMove   :=L_Way._FCarCMove;
    _MrRt.FMarkCMove  :=L_Way._FMarkCMove;
    _MrRt.FCM         :=FCM + 1;
    _MrRt.WinterC     :=P_OwnData.FCorMove(_MrRt.Date, L_Car.GetCarMyFirm(_MrRt.BoxNbr, _MrRt.Date)) - 1;
    IF L_Way.E_FuelMoveNormAsCfcSum(_MrRt.Date) THEN
     _MrRt.CorNorm:=_MrRt.Norm * _MrRt.WinterC;
    ELSE
     IF L_Way.E_ApplyCorrectionToBaseFuelNorm(_MrRt.Date) THEN
      _MrRt.CorNorm:=P_Mark.GetP_FConRun(Mark.Mark, _MrRt.Date) * _MrRt.WinterC;
     ELSE
      _MrRt.CorNorm:=_MrRt.Norm * _MrRt.WinterC;
     END;
    END;
    _MrRt.Norm100:=_MrRt.CorNorm + _MrRt.Norm;
    IF _MrRt.Run > 0 THEN
     _MrRt.Fact100:=_MrRt.MoveFact/_MrRt.Run * 100;
    ELSE
     _MrRt.Fact100:=0;
    END;
    _MrRt.Over     :=_MrRt.Norm100 - _MrRt.Fact100;
    _MrRt.CheckOver:=_MrRt.Run*_MrRt.Over/100;

    _MrRt.AddNorm  :=_MrRt.FCarCMove*_MrRt.FMarkCMove*_MrRt.Norm*_Run/100;
    _MrRt.AddNorm  :=Norms[0] - _MrRt.RoutModFCor*(_MrRt.WinterC + 1)*_MrRt.AddNorm - _MrRt.MarkFNAlFTim*_Time;

    _MrRt.WinterC  :=_MrRt.WinterC + 1;
    REPLACE(_MrRt);
   END;
   NEXT(RWayJ);
  END; (* WHILE... *)
  IF ReminderhtFact # 0 THEN
   ADD(_MrRt, TSN, , RWayS.TSN, RWayS.BoxNbr, CarLog.StateNbr, ReminderhtRoute, RWayS.RWayS, RWayS.Date, _Norm,
                     _MrRt.HeatFact, ReminderhtFact);
  END;
 END {OneRWayS};

 PRIVATE PROCEDURE Create__MrRt();
 BEGIN
  CreateFILE(_MrRt, "", "", "");
  CreateFIELD(_MrRt, TSN,          LIKE(Staff.TSN),   "", "", "", " ", "");
  CreateFIELD(_MrRt, BoxNbr,       LIKE(Car.BoxNbr),  "", "", "", "ࠦ ", "");
  CreateFIELD(_MrRt, StateNbr,     LIKE(Car.StateNbr),"", "", "", " ", "");
  CreateFIELD(_MrRt, Route,        LIKE(Route.Route), "", "", "", "", "");
  CreateFIELD(_MrRt, RWayS,        LIKE(RWayS.RWayS), "", "", "", "⥢ ", "");
  CreateFIELD(_MrRt, Date,         LIKE(RWayS.Date),  "", "", "", "", "");
  CreateFIELD(_MrRt, Time,         NUMERIC[3],        "", "0", "", "६", "");
  CreateFIELD(_MrRt, Run,          NUMERIC[2],        "", "0", "", "஡", "");

  CreateFIELD(_MrRt, FuelFact,     NUMERIC[4],        "", "0", "", " 騩", "㬬 , , ணॢ, 㤮");
  CreateFIELD(_MrRt, MoveFact,     NUMERIC[4],        "", "0", "", " ", "");
  CreateFIELD(_MrRt, HeatFact,     NUMERIC[4],        "", "0", "", " ", "");
  CreateFIELD(_MrRt, WarmFact,     NUMERIC[4],        "", "0", "", " ணॢ", "");
  CreateFIELD(_MrRt, ExtrasFact,   NUMERIC[4],        "", "0", "", " 㤮", "");
  CreateFIELD(_MrRt, FullNorm,     NUMERIC[4],        "", "0", "", "ଠ ", "㬬 , , ணॢ, 㤮");
  CreateFIELD(_MrRt, Norms,        L_Way.tNorms,      "", "0", "", " (, , ணॢ, 㤮)", "");
  CreateFIELD(_MrRt, MarkFNAlFTim, L_Way.tFuelNorms,  "", "0", "", "ଠ  ", "");
  CreateFIELD(_MrRt, Norm,         LIKE(RWayJ.FNorm), "", "0", "", "ଠ  100  ", "");
  CreateFIELD(_MrRt, CorNorm,      NUMERIC[4],        "", "0", "", "  ଥ  100 ", "");
  CreateFIELD(_MrRt, Norm100,      NUMERIC[4],        "", "0", "", " ଠ  100  ", "");

  CreateFIELD(_MrRt, Fact100,      NUMERIC[4],        "", "0", "", "᪨ 室  100  ஡", "");
  CreateFIELD(_MrRt, Over,         NUMERIC[4],        "", "0", "", "  室 ⮯  100  ஡", "");
  CreateFIELD(_MrRt, CheckOver,    NUMERIC[4],        "", "0", "", "  室 ⮯  ", "");

  CreateFIELD(_MrRt, WinterC,      NUMERIC[3],        "", "0", "", " 樥", "");
  CreateFIELD(_MrRt, FRouteCMove,  NUMERIC[3],        "", "0", "", "ࠢ    ", "");
  CreateFIELD(_MrRt, FCM,          NUMERIC[3],        "", "0", "", "ࠢ  ଥ  100 ", "");
  CreateFIELD(_MrRt, FCarCMove,    NUMERIC[3],        "", "0", "", "ࠢ    ", "");
  CreateFIELD(_MrRt, CorFNAgeCar,  NUMERIC[3],        "", "0", "", "ࠢ     ", "");
  CreateFIELD(_MrRt, FMarkCMove,   NUMERIC[3],        "", "0", "", "ࠢ    થ", "");
  CreateFIELD(_MrRt, RoutModFCor,  LIKE(RoutMod.FCor), "","0", "", "ࠢ    䨪樨 ", "");

  CreateFIELD(_MrRt, AddNorm,       NUMERIC[4],   "", "0", "", "஢筮 ", "");

  CreateINDEXandLINK(_MrRt, TSN,    UNIQUE, Staff, TSN,    USER, "", "", TSN, BoxNbr, StateNbr, Route, RWayS, Date, Norm);
  CreateINDEXandLINK(_MrRt, Route,  PLURAL, Route, Route,  USER, "", "", Route);
  CreateINDEXandLINK(_MrRt, BoxNbr, PLURAL, Car,   BoxNbr, USER, "", "", BoxNbr);
  CreateINDEX(       _MrRt, RWayS,  PLURAL,                      "", "", RWayS);

  SetVersionOfFILE(_MrRt, 0001);
  L_AFM.AF_CreateTemp("_MrRt", "_MrRt");
 END {Create__MrRt};

 PRIVATE PROCEDURE PutSomeRWaysTo_MrRt(trgBegin, trgTill: DATE);
 BEGIN
  IF SELECT(_MrRt, RWayS) THEN
   REMSEL(_MrRt);
  END;
  SELECT(RWayS, sDate, , L_Way.rwsStat_Rated);
  SRCINSEL(RWayS, GE, , trgBegin);
  WHILE OCCURE(RWayS) & (RWayS.Date <= trgTill) DO
   PROMPT(L_DatTim.DateStr(RWayS.Date) + ",  " + RWayS.RWayS);
   CONFORM(RWayS, Car);
   HISTCONF(RWayS.Date, Car, CarLog);
   CONFORM(CarLog, Mark);
   IF ~Mark.Electric & ~P_Car.GetP_NormAsFact(RWayS.BoxNbr, RWayS.Date) THEN
    OneRWayS();
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS)... *)
 END {PutSomeRWaysTo_MrRt};

 PUBLIC PROCEDURE FL001();
  CONST
   bpId = "FL001";
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_bp.Begin(bpId, " ⠢ ⥩   室 ⮯", L_bp.t_Basis, L_General.timeCond_InIntvl);
  D_Fl.Prepare_FL1();

  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeader("R");

  Create__MrRt();

  PutSomeRWaysTo_MrRt(Memo.ud_fr(), Memo.ud_ut());

  SELECT(_MrRt, TSN);
  WHILE OCCURE(_MrRt) DO
   PROMPT(" " + _MrRt.TSN + " " + L_DatTim.DateStr(_MrRt.Date));
   CONFORM(_MrRt, Staff);
   CONFORM(Staff, Man);
   CONFORM(_MrRt, Car);
   HISTCONF(_MrRt.Date, Car, CarLog);
   CONFORM(CarLog, Mark);
   CONFORM(CarLog, Column);
   L_General.CallUs(SEARCH(Math, Math, L_Fuel.GetMainFuel(_MrRt.Date, Mark.Mark)));
   CONFORM(_MrRt, Route);
   L_Way.StandOnRouteTKind(_MrRt.Date);

   MakePart("R");
   NEXT(_MrRt);
  END; (* WHILE OCCURE(_MrRt) ... *)

  SELECT(FL1_2, BoxNbr);
  WHILE OCCURE(FL1_2) DO
   PROMPT(" " + FL1_2.BoxNbr);
   CONFORM(FL1_2, Math);
   CONFORM(FL1_2, CarLog);
   CONFORM(CarLog, Car);
   CONFORM(CarLog, Column);
   CONFORM(CarLog, Mark);
   MakePart_Fict("R", FL1_2.RemB, FL1_2.Take, FL1_2.Ret, FL1_2.RemE);
   NEXT(FL1_2);
  END; (* WHILE OCCURE(FL1_2) ... *)

  FIO.Close(R);
  L_AFM.AF_PurgeTemp("_MrRt");
  D_Fl.Purge_FL1();
  L_bp.End();
 END {FL001};

 CONST
  fn_ModifiedDTS = "६_⠬";

 PRIVATE PROCEDURE Z0001_PutInSQL(trgAPId: SCAL[1E4]; DTS: FLOAT);
 BEGIN
  L_SQL.Insert();

  L_SQL.WrInt("APId",                          trgAPId);
  L_SQL.WrDTS(fn_ModifiedDTS,                  DTS);
  L_SQL.WrInt("⥢_",                  _MrRt.RWayS);
  L_SQL.WrDat("",                          _MrRt.Date);
  L_SQL.WrStr("",                      Column.Column);
  L_SQL.WrStr("",                       Column.Name);
  L_SQL.WrStr("ઠ",                        Mark.Mark);
  L_SQL.WrStr("ઠ",                         Mark.Name);
  L_SQL.WrStr("_",                     _MrRt.BoxNbr);
  L_SQL.WrStr("_",                     Car.StateNbr);
  L_SQL.WrStr("ॢ",                 TKind.TKind);
  L_SQL.WrStr("ॢ",                  TKind.Name);
  L_SQL.WrStr("",                       _MrRt.Route);
  L_SQL.WrStr("_",                     _MrRt.TSN);
  L_SQL.WrStr("",                           Man.Name);
  L_SQL.WrStr("",                     L_Fuel.GetFuelName(Math.Math));
  L_SQL.WrNum("ଠ_",                     _MrRt.MarkFNAlFTim);
  L_SQL.WrNum("ଠ_100",                   _MrRt.Norm);
  L_SQL.WrNum("ࠢ__ଥ_100",        _MrRt.FCM);
  L_SQL.WrNum("ࠢ___",  _MrRt.CorFNAgeCar);
  L_SQL.WrNum("ࠢ__",        _MrRt.WinterC);
  L_SQL.WrNum("ࠢ__",          _MrRt.FCarCMove);
  L_SQL.WrNum("ࠢ__ઠ",       _MrRt.FMarkCMove);
  L_SQL.WrNum("ࠢ__",     _MrRt.FRouteCMove);
  L_SQL.WrNum("ࠢ__䨪", _MrRt.RoutModFCor);
  L_SQL.WrNum("६",                         _MrRt.Time);
  L_SQL.WrNum("஡",                        _MrRt.Run);
  L_SQL.WrNum("_騩",                    _MrRt.FuelFact);
  L_SQL.WrNum("_",                 _MrRt.MoveFact);
  L_SQL.WrNum("_ॢ",                  _MrRt.HeatFact);
  L_SQL.WrNum("_ணॢ",                  _MrRt.WarmFact);
  L_SQL.WrNum("_㤮",          _MrRt.ExtrasFact);
  L_SQL.WrNum("ଠ_",                   _MrRt.FullNorm);
  L_SQL.WrNum("ଠ_",                _MrRt.Norms[0]);
  L_SQL.WrNum("ଠ_ॢ",                 _MrRt.Norms[1]);
  L_SQL.WrNum("ଠ_ணॢ",                 _MrRt.Norms[2]);
  L_SQL.WrNum("ଠ_㤮",         _MrRt.Norms[3]);
  L_SQL.WrNum("஢筮_",              _MrRt.AddNorm);

  L_SQL.UpdateRecordSet(0);
 END {Z0001_PutInSQL};

 PRIVATE PROCEDURE Z0001_Do(trgBegin, trgTill: DATE; force: SCAL[2]);
  VAR
   sqlConnection: OBJECT;
   sqlStr       : STRING[];
   D            : DATE;
   CntExc       : SCAL[1E2];
   trgAPId      : SCAL[1E4];
   curDTS       : FLOAT;
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  Create__MrRt();
  SETEMPTY(sqlConnection, trgAPId);
  CntExc:=0;
  D     :=trgBegin;
  LOOP
   TRY
    IF !sqlConnection THEN
     PROMPT("  ࢥ஬ ᡮ ");
     sqlConnection:=L_SQL.ConnectToMTASQLServer();
     IF !trgAPId THEN
      L_SQL.GetFirmFromSQLServer(sqlConnection, trgAPId);
     END;
    ELSE
     EXIT;
    END;
  
    WHILE D<=trgTill DO
     PROMPT(L_DatTim.DateStr(D));
     sqlStr:="SELECT * FROM Fl001 WHERE APId=" + trgAPId + " AND =CONVERT(DATETIME, '" + L_DatTim.DateStr(D) + "', 104) FOR UPDATE";
     L_SQL.OpenRecordSet(sqlConnection, sqlStr);
     IF ~L_SQL.Occure() | force |
         (L_SQL.slqRecordSet.Fields(fn_ModifiedDTS).Value < L_DatTim.TS2FL(L_XDoc.GetLastMdfTime_TheDay(L_XDoc.xdt_RWayS, D))) THEN
      PutSomeRWaysTo_MrRt(D, D);
      TRY
       sqlConnection.BeginTrans();
       sqlStr:="DELETE FROM Fl001 WHERE (APId=" + trgAPId + ") AND (=CONVERT(DATETIME, '" + L_DatTim.DateStr(D) + "', 104))";
       L_SQL.OpenRecordSet(sqlConnection, sqlStr);
       sqlConnection.CommitTrans();
      EXCEPT
      ON Exc:Exc_Root DO
       sqlConnection.RollbackTrans();
       RAISE();
      END;
      TRY
       VARIANTSYSDATE(curDTS);
       sqlConnection.BeginTrans();
       sqlStr:="SELECT * FROM Fl001 WHERE APId=" + trgAPId + " AND =CONVERT(DATETIME, '" + L_DatTim.DateStr(D) + "', 104) FOR UPDATE";
       L_SQL.OpenRecordSet(sqlConnection, sqlStr);
    
       SELECT(_MrRt, RWayS);
       WHILE OCCURE(_MrRt) DO
        PROMPT(L_DatTim.DateStr(D) + ", 㧪  SQL  " + _MrRt.RWayS);
        CONFORM(_MrRt, Staff);
        CONFORM(Staff, Man);
        CONFORM(_MrRt, Car);
        HISTCONF(_MrRt.Date, Car, CarLog);
        CONFORM(CarLog, Mark);
        CONFORM(CarLog, Column);
        L_General.CallUs(SEARCH(Math, Math, L_Fuel.GetMainFuel(_MrRt.Date, Mark.Mark)));
        CONFORM(_MrRt, Route);
        L_Way.StandOnRouteTKind(_MrRt.Date);
        Z0001_PutInSQL(trgAPId, curDTS);
        NEXT(_MrRt);
       END; (* WHILE OCCURE(_MrRt) ... *)
       sqlConnection.CommitTrans();
      EXCEPT
      ON Exc:Exc_Root DO
       sqlConnection.RollbackTrans();
       RAISE();
      END;
     END; (* IF ~L_SQL.Occure | force *)
     INC(D);
    END;
   EXCEPT
   ON Exc:Exc_Object DO
    IF ((L_MSWStp.ScodeCode(Exc.ErrorCode) = 3633) | ((L_MSWStp.ScodeCode(Exc.ErrorCode) = -1))) & (CntExc < 5) THEN
     INC(CntExc);
     SETEMPTY(sqlConnection);
     SLEEP(10);
    ELSE
     RAISE();
    END;
   END; (* TRY ... *)
  END; (* LOOP ... *)
 END {Z0001_Do};

 PUBLIC PROCEDURE Z0001_CheckNecessity(VAR Result: SCAL[2]; VAR nextRun: TIMESTAMP);
  VAR
   begD,
   endD: DATE;
 BEGIN
  L_RWayS.GetDaemonBoundaries(begD, endD);
  Result:=L_bp.GetLastSelfExecutionTime() < L_RWayS.GetLastMdfTime_RatedRWayS(endD);
  nextRun:=SYSTIMESTAMP() + 3/24;
 END {Z0001_CheckNecessity};

 PRIVATE PROCEDURE Z0001_Daemon();
  VAR
   begD,
   endD: DATE;
 BEGIN
  L_RWayS.GetDaemonBoundaries(begD, endD);
  Z0001_Do(begD, endD, 0);
 END {Z0001_Daemon};

 PUBLIC PROCEDURE Z0001();
  CONST
   bpId = "Z0001";
 BEGIN
  L_bp.extBegin(bpId, ".㧪. ⠢ ⥩   室 ⮯",
                L_bp.t_Process, L_General.tc_inIntvl, L_bp.pt_Low);
  IF L_bp.IAmInQueue() & !bpRT.fr THEN
   Z0001_Daemon();
  ELSE
   Z0001_Do(Memo.ud_fr(), Memo.ud_ut(), 1);
  END;
  L_bp.End();
 END {Z0001};

END.
