(*
%Copyright   (c) Polak Computer System
%Author      04.03.1997 17:16:54 SAN (FRM), 12.11.2001 16:17:23 GAV
%Purpose
%Type        report
%Specific    AP
%Modified    17.04.2014 13:07:09 POLAK\LDA
%Environment
*)

 MODULE FlLst [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_OwnData, L_AFM, L_DatTim, Memo, L_Car, L_Fuel;

(*
$P{Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?,         L, ""
?,         C, ""
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
}
*)

(*
$P{MathTop:
FlLst.Math, L, ""
Math.Name,  L, ""
?,          R, ""
@
|============================================================================|
| ⮯ ##### ############################################### ##########|
}
*)

(*
$P{ColumnTop:
Column.Column, L, ""
Column.Name, L, ""
?, R, "2."
@
|----------------------------------------------------------------------------|
| ## ################################         ########################|
}
*)

(*
$P{ColumnSubTop:
@
|----------------------------------------------------------------------------|
| |. |     |⥫                       |              뤠|
|----|----------|-------|-------------------------------|--------------------|
}
*)

(*
$P{Line:
FlLst.BoxNbr,  L, ""
Car.StateNbr,   L, ""
FlLst.RWayS,   L, ""
FlLst.TSN,     L, ""
Man.Name,       L, ""
RWayF.FuelTake, R, "2."
@
|####|##########|#######|##### #########################|####################|
}
*)

(*
$P{ColumnBot:
?, R, "2."
@
|-------------------------------------------------------|--------------------|
|⮣                                         |####################|
}
*)

(*
$P{MathBot:
?, R, "2."
@
|----------------------------------------------------------------------------|
|⮣   ⮯                                   ####################|
}
*)

(*
$P{Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE Gather(DateBeg, DateEnd: DATE);
 BEGIN
  SELECT(RWayS, Date);
  SRCINSEL(RWayS, LE, , DateEnd);
  WHILE OCCURE(RWayS) & (RWayS.Date >= DateBeg) DO
   PROMPT("   " + L_DatTim.DateStr(RWayS.Date) + " - " + RWayS.BoxNbr);
   SELECT(RWayF, RWayS, , RWayS.RWayS);
   WHILE OCCURE(RWayF) DO
    IF RWayF.FuelTake > 0 THEN
     L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
     CONFORM(RWayF, Math);
     FlLst.Math  :=Math.Math;
     FlLst.Column:=CarLog.Column;
     FlLst.BoxNbr:=CarLog.BoxNbr;
     FlLst.TSN   :=RWayS.TSN;
     FlLst.RWayS :=RWayS.RWayS;
     INSERT(FlLst);
    END;
    NEXT(RWayF);
   END; (* WHILE OCCURE(RWayF) ... *)
   PREV(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 END {Gather};

 PUBLIC PROCEDURE FlLst_ByCurDate();
  VAR
   RepName  : STRING[];
   MathSum,
   ColumnSum: NUMERIC[2];
 BEGIN
  IF L_Fuel.FlAcntLev(Memo.ud_cd()) = L_Fuel.fal_RefuelOperator THEN
   L_General.Error("  ਬ  ଫ ᪠ ⮯ १ |"+
                   " ᯮ짮     ");
  END;
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_AFM.MakeIndex("FlLst", "Math  : LIKE(Math.Math);"+
                           "Column: LIKE(Car.Column);"+
                           "BoxNbr: LIKE(Car.BoxNbr);"+
                           "TSN   : LIKE(RWayS.TSN);"+
                           "RWayS : LIKE(RWayS.RWayS)");
  Gather(Memo.ud_cd(), Memo.ud_cd());
  RepName:="FlLst";
 
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, " ᢥન 뤠 ⮯  " + L_DatTim.DateStr(Memo.ud_cd()));
 
  SELECT(FlLst, FlLst);
  WHILE OCCURE(FlLst) DO
   NARROWSEL(FlLst, Math);
   SETZERO(MathSum);
   SEARCH(Math, Math, , FlLst.Math);
   MAKEPART(R, MathTop, "");
   WHILE OCCURE(FlLst) DO
    NARROWSEL(FlLst, Column);
    SETZERO(ColumnSum);
    SEARCH(Car, BoxNbr, , FlLst.BoxNbr);
    SEARCH(Column, Column, , FlLst.Column);
    MAKEPART(R, ColumnTop);
    MAKEPART(R, ColumnSubTop);
    WHILE OCCURE(FlLst) DO
     SEARCH(RWayF, RWayS,  , FlLst.RWayS, FlLst.Math);
     PROMPT(" " + FlLst.Math + "  " + FlLst.Column + "  " + FlLst.BoxNbr);
     INC(ColumnSum, RWayF.FuelTake);
     SEARCH(Car,   BoxNbr, , FlLst.BoxNbr);
     SEARCH(RWayS, RWayS,  , FlLst.RWayS);
     CONFORM(RWayS, Man);
     MAKEPART(R, Line);
     NEXT(FlLst);
    END; (* WHILE OCCURE(FlLst) ... *)
    INC(MathSum, ColumnSum);
    MAKEPART(R, ColumnBot, ColumnSum);
    NEXTINEXTENDEDSEL(FlLst, Column);
   END; (* WHILE OCCURE(FlLst) ... *)
   MAKEPART(R, MathBot, MathSum);
   NEXTINEXTENDEDSEL(FlLst, Math);
  END; (* WHILE OCCURE(FlLst) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
 END {FlLst_ByCurDate};

END.
