(*
%Copyright   (c) Polak IT
%Author      19.04.2010 18:49:04 POLAK\LDA
%Purpose      
%Type        control
%Specific    AP
%Modified    05.09.2013 13:49:34 POLAK\LDA
%Environment
*)

 IMPORT E_Stock, L_EC, L_StdFrm, L_General, L_DatTim;

 PRIVATE PROCEDURE E_IsNeftoStanExists(): SCAL[2];
 BEGIN
  RETURN ~!L_EC.ExecE_Func_String(SYSDATE(), PROCREF(E_Stock.NeftoStan_Path), "");
 END {E_IsNeftoStanExists};

 PRIVATE PROCEDURE Run();
  CONST
   DeadlineDate = 01\10\2013;
 BEGIN
  IF E_IsNeftoStanExists() THEN
   IF ((L_General.GetAPSiteNumber() = 51) | (L_General.GetAPSiteNumber() = 23)) & L_StdFrm.Alternative("   㭪樮쭮 'ࠢ筠 ⠭'?") THEN
    LIKEMENU(Edit,    "GasStan 0");
   ELSE
    IF SYSDATE() < DeadlineDate THEN
     L_StdFrm.TimedINFORM_AsSTOP("  'ࠢ筮 ⠭樨' ५ |" +
                                 "㤥 ࠡ  " + L_DatTim.DateStr(DeadlineDate) + ".||" +
                                 " ᮮ   室|" +
                                 "室    'ࠢ筮 ⠭樨'", 10);
    ELSE
     L_General.Error("  'ࠢ筮 ⠭樨' ५.||" +
                     " ᮮ   室|" +
                     "室    'ࠢ筮 ⠭樨'")
    END;
    LIKEMENU(ShowWin, "NeftoStan 0");
   END;
  ELSE
   LIKEMENU(Edit,    "GasStan 0");
  END;
 END {Run};

END.