(*
%Copyright   (c) Polak Computer System
%Author      06.12.2000 19:12:42 SAM
%Purpose     窠 ⥫/஢  ᢥન  ⤥ ᡮ஢
%Type        report
%Specific    AP
%Modified    10.04.2012 12:02:05 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT Memo, L_General, L_OwnData, L_Way, E_Way, L_AFM, Str, L_Str, L_DatTim,
        E_Utils, L_Env, L_PagePr;

 TYPE
  tObj = STRING[28];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
("窠" + Str.Item("  ⥢ ⠬ | ", "|", Form()) + Str.Item(" ਮ  "+L_DatTim.DateStr(Memo.ud_fr())+"  "+L_DatTim.DateStr(Memo.ud_ut())+"| "+L_DatTim.DateStr(Memo.tmp_cd()), "|", ForCurDat())+ SubTitle()), C, ""
@
##########################################################################      ########## #####
=#####==========================================================================================
|##############################################################################################|
}
*)

(*
$P{ TDate:
_Date, L, "D.N.y"
@
|==============================================================================================|
| ##########                                                                               |
}
*)

(*
$P{ Line:
?, L, ""
?, L, ""
@
|############################|#################################################################|
}
*)

(*
$P{ Dlm:
Term("|:-", 0), R, ""
Term("|:-", 1), R, ""
Term("|:-", 2), R, ""
Term("|:-", 3), R, ""
Term("|:-", 4), R, ""
@
|----------------------------|----------#----------#----------#----------#----------#----------|
}
*)

(*
$P{ Dlm1:
Term("|: ", 0), R, ""
Term("|: ", 1), R, ""
Term("|: ", 2), R, ""
Term("|: ", 3), R, ""
Term("|: ", 4), R, ""
@
|                            |          #          #          #          #          #          |
}
*)

(*
$P{ Dlm0:
FLDTOSTR(L_PagePr.PagePr_CurrentPage(), "L0", 3), R, ""
@
======================================================================================= ###=
}
*)

(*
$P{ Dlm2:
@
|==============================================================================================|
}
*)

(*
$P{ Dlm3:
@
=(c) Polak======================================================================================}
*)

(*
$P{ Bot:
@


ᯮ⥫ ________________________________________________
}
*)

 PRIVATE PROCEDURE TestMode();
 BEGIN
  IF (MODE < 100) | (MODE > 107) THEN
   L_General.BadMode(MODE);
  END;
 END {TestMode};

 PRIVATE PROCEDURE ForCurDat(): SCAL[2];
 BEGIN
  RETURN (MODE = 100) | (MODE = 101) | Form();
 END {ForCurDat};

 PRIVATE PROCEDURE Form(): SCAL[2];
 BEGIN
  RETURN (MODE = 106) | (MODE = 107);
 END {Form};

 PRIVATE PROCEDURE Daily(): SCAL[2];
 BEGIN
  RETURN (MODE = 102) | (MODE = 103);
 END {Daily};

 PRIVATE PROCEDURE ForWho(): SCAL[2];
 BEGIN
  RETURN (MODE = 101) | (MODE = 103) | (MODE = 105)| (MODE = 107);
 END {ForWho};

 PRIVATE PROCEDURE GetIdxLen(): NUMERIC[0];
  VAR
   Idx    : NUMERIC[0];
 BEGIN
  Idx :=0;
  WHILE (Idx < MaxIdxLen) & (E_Way.GetIncRWJPName(ForWho(), Idx) # " ") DO
   INC(Idx);
  END;
  RETURN Idx;
 END {GetIdxLen};

 CONST
  MaxIdxLen = 5;
  FillingSize = 10;

 VAR
  RepName: STRING[];
  _Date,
  _From,
  _UpTo  : DATE;
  Sum,
  ListSum,
  DateSum: NUMERIC[2][MaxIdxLen];
  _List: STRING[];
  FirstPage,
  LastPage: SCAL[2];
  IdxLen  : SCAL[MaxIdxLen];

 PRIVATE PROCEDURE Create_Inc();
 BEGIN
  CreateFILE(_Inc, "", "室", "");

  CreateFIELD(_Inc, List,   STRING[32],           "", "", "", "", "");
  CreateFIELD(_Inc, Obj,    tObj,                 "", "", "", "", "");
  CreateFIELD(_Inc, TSN,    LIKE(Staff.TSN),      "", "", "", "", "");
  CreateFIELD(_Inc, RWJPro, LIKE(RWayJP.RWJPro),  "", "", "", "⢮ ३", "");
  CreateFIELD(_Inc, Who,    L_Way.tRWSWho,        "", "", "", "", "");
  CreateFIELD(_Inc, Number, LIKE(WayLMen.Number), "", "", "", "  ਣ", "");
  CreateFIELD(_Inc, Value,  LIKE(RWayJP.Value),   "", "", "", "窠", "");

  CreateINDEX(_Inc, _Inc, UNIQUE, "", "", List, Obj, TSN, RWJPro, Who, Number);

  SetVersionOfFILE(_Inc, 0);
 END {Create_Inc};

 PRIVATE PROCEDURE Term(_Str: STRING[]; Idx: NUMERIC[0]): STRING[1];
 BEGIN
  RETURN Str.Item(_Str, ":", (E_Way.GetIncRWJPName(ForWho(), Idx) = " "));
 END {Term};
 
 PRIVATE PROCEDURE SubTitle(): STRING[];
 BEGIN
  RETURN Str.Item(" ⥫| ", "|", ForWho())
 END {SubTitle};

 PRIVATE PROCEDURE GetTSN(): LIKE(Staff.TSN);
 BEGIN
  IF ForWho() = 1 THEN
   RETURN WayLMen.TSN;
  ELSE
   RETURN RWayS.TSN;
  END;
 END {GetTSN};

 PRIVATE PROCEDURE TitlToStr(): STRING[];
  VAR
   _Str : STRING[];
   Idx  : NUMERIC[0];
 BEGIN
  SETEMPTY(_Str);
  Idx :=0;
  WHILE (Idx < IdxLen) DO
   _Str := _Str + Str.Align(E_Way.GetIncRWJPName(ForWho(), Idx), 10, RIGHT)+"|";
   INC(Idx);
  END;
  RETURN _Str+"ਬ砭";
 END {TitlToStr};

 PRIVATE PROCEDURE SumToStr(_Sum: NUMERIC[2][]): STRING[];
  VAR
   _Str : STRING[];
   Idx  : NUMERIC[0];
 BEGIN
  SETEMPTY(_Str);
  Idx :=0;
  WHILE (Idx < IdxLen) DO
   _Str := _Str + FLDTOSTR(_Sum[Idx], "2-", 10, "R")+"|";
   INC(Idx);
  END;
  RETURN _Str;
 END {SumToStr};

 PRIVATE PROCEDURE _RprtTop(Mode: SCAL[20]);
 BEGIN
  IF Mode = L_PagePr.m_Print THEN
   IF FirstPage THEN
    MAKEPART(R, Top);
   END;
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtTop};

 PRIVATE PROCEDURE _PageTop(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Print THEN
   MAKEPART(R, Dlm0);
   MAKEPART(R, Line, _List, TitlToStr());
   IF ~Form() THEN
    MAKEPART(R, Dlm);
   END;
  ELSIF Mode = L_PagePr.m_RDoneTop THEN
   MAKEPART(R, Dlm0);
   MAKEPART(R, Line, "", TitlToStr());
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageTop};

 PRIVATE PROCEDURE _PageBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(Dlm3));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, Dlm3);
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_None);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageBot};

 PRIVATE PROCEDURE _RprtBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   IF LastPage THEN
    L_PagePr.PagePr_SetResult(2*DEPTH(Dlm)+2*DEPTH(Line)+DEPTH(Dlm3)+DEPTH(Bot));
   ELSE
    L_PagePr.PagePr_SetResult(DEPTH(Dlm)+DEPTH(Line)+DEPTH(Dlm3));
   END;
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, Dlm);
   MAKEPART(R, Line, " ", SumToStr(ListSum));
   IF LastPage THEN
    MAKEPART(R, Dlm);
    MAKEPART(R, Line, "⮣", SumToStr(DateSum));
    MAKEPART(R, Dlm3);
    MAKEPART(R, Bot);
   ELSE
    MAKEPART(R, Dlm3);
   END;
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_Fill);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtBot};

 PRIVATE PROCEDURE _Filling(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   IF Form() THEN
    L_PagePr.PagePr_SetResult(DEPTH(Dlm)+DEPTH(Dlm1));
   ELSE
    L_PagePr.PagePr_SetResult(DEPTH(Dlm1));
   END;
  ELSIF Mode = L_PagePr.m_Print THEN
   IF Form() THEN
    MAKEPART(R, Dlm);
   END;
   MAKEPART(R, Dlm1);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_Filling};

 PRIVATE PROCEDURE IsZero(Arr: NUMERIC[0][]; Length: NUMERIC[0]): SCAL[2];
  VAR
   Idx : NUMERIC[0];
 BEGIN
  Idx:=0;
  WHILE Idx<Length DO
   IF Arr[Idx] # 0 THEN
    RETURN 0;
   END;
   INC(Idx);
  END;
  RETURN 1;
 END {IsZero};

 PRIVATE PROCEDURE E_In004_List(_Date: DATE; _ForWho: SCAL[2]; _TSN: LIKE(Staff.TSN)): STRING[];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Utils.In004_List);
  IF ~!Local THEN
   RETURN Local(_Date, _ForWho, _TSN);
  ELSE
   SELECT(StaffLog, TSN, , _TSN);
   SRCINSEL(StaffLog, LE, , _Date);
   CONFORM(StaffLog, Sort);
   RETURN Sort.Sort+" "+Sort.Name;
  END;
 END {In004_List};

 PRIVATE PROCEDURE E_In004_Obj(_Date: DATE; _ForWho: SCAL[2]; _TSN: LIKE(Staff.TSN)): tObj;
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Utils.In004_Obj);
  IF ~!Local THEN
   RETURN Local(_Date, _ForWho, _TSN);
  ELSE
   SEARCH(Staff, TSN, , _TSN);
   CONFORM(Staff, Man);
   RETURN Staff.TSN + " " + L_Str.ShortName(Man.Name);
  END;
 END {E_In004_Obj};

 PRIVATE PROCEDURE E_In004_Comment(_TSN: LIKE(Staff.TSN); _Date: DATE): STRING[];
  VAR
   Local: PROC;
   Value: STRING[];
 BEGIN
  Local:=PROCREF(E_Utils.In004_Comment);
  SETEMPTY(Value);
  IF ~!Local THEN
   Value:=Local(_TSN, _Date);
  END;
  RETURN Value;
 END {E_In004_Comment};

 PRIVATE PROCEDURE Make_Inc(_From, _UpTo: DATE);
  VAR
   RWSWho: L_Way.tRWSWho;
 BEGIN
  L_AFM.AF_CreateTemp("_Inc", "_Inc");
  SELECT(RWayS, Date);
  SRCINSEL(RWayS, GE, , _From);
  WHILE OCCURE(RWayS) & (RWayS.Date <= _UpTo) DO
   PROMPT(": "+L_DatTim.DateStr(RWayS.Date)+"  "+RWayS.RWayS);
   IF Form() THEN
    IF ForWho() = 0 THEN
     RWSWho:=L_Way.rwswho_Driver;
     SELECT(SEJobs, Exit, , RWayS.Exit);
     CONFORM(SEJobs, Route);
     IF RealTSN(RWayS.TSN) & ~L_Way.CalcIncPlanIsCancelled(RWayS.Date) &
        (E_SeparateIncRWJP(RWayS.Date) | ~SELECT(WayLMen, RWayS, RWayS.RWayS, 0)) THEN
      ADD(_Inc, _Inc, , E_In004_List(RWayS.Date, 0, RWayS.TSN),
                        E_In004_Obj (RWayS.Date, 0, RWayS.TSN), RWayS.TSN, 0, RWSWho, 0,
          _Inc.Value, 0);
     END;
    ELSE
     IF SELECT(WayLMen, RWayS, RWayS.RWayS) THEN
      IF WayLMen.Who = L_Way.wlmwho_Chopper THEN
       RWSWho:=L_Way.rwswho_Chopper;
      ELSE
       RWSWho:=L_Way.rwswho_Guard;
      END;
      IF ~L_Way.E_IsGuardIdleExit(RWayS.Date, RWayS.Exit) THEN
       SELECT(WayLMen, RWayS, , RWayS.RWayS, RWSWho-1);
       WHILE OCCURE(WayLMen) DO
        ADD(_Inc, _Inc, , E_In004_List(RWayS.Date, 1, WayLMen.TSN),
                          E_In004_Obj (RWayS.Date, 1, WayLMen.TSN), WayLMen.TSN, 0, RWSWho, WayLMen.Number,
            _Inc.Value, 0);
        NEXT(WayLMen);
       END;
      END;
     END;
    END;
   ELSE
    SELECT(RWayJ, RWayS, , RWayS.RWayS);
    WHILE OCCURE(RWayJ) DO
     SELECT(RWayJP, RWayS, , RWayS.RWayS, RWayJ.Day, RWayJ.StartT);
     WHILE OCCURE(RWayJP) DO
      CONFORM(RWayJP, RWJPro);
      IF RWJPro.Type = 0 THEN
       IF ForWho() = 0 THEN
        RWSWho:=L_Way.rwswho_Driver;
        IF L_Way.E_SeparateIncRWJP(RWayS.Date) | ~L_Way._IsWith(L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT), L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT), 0) THEN
         ADD(_Inc, _Inc, , E_In004_List(RWayS.Date, 0, RWayS.TSN),                           
                           E_In004_Obj (RWayS.Date, 0, RWayS.TSN), RWayS.TSN, RWayJP.RWJPro, RWSWho, 0,
             _Inc.Value, RWayJP.Value);
        END;
       ELSE
        IF SELECT(WayLMen, RWayS, RWayS.RWayS)  THEN
         IF WayLMen.Who = L_Way.wlmwho_Chopper THEN
          RWSWho:=L_Way.rwswho_Chopper;
         ELSE
          RWSWho:=L_Way.rwswho_Guard;
         END;
         IF ~L_Way.E_IsGuardIdleExit(RWayS.Date, RWayS.Exit) THEN
          SELECT(WayLMen, RWayS, , RWayS.RWayS, RWSWho-1);
          WHILE OCCURE(WayLMen) DO
           IF L_Way._TimeInt(L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT), L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT), L_Way.FullBegTime(WayLMen.Day, WayLMen.StartT), L_Way.FullEndTime(WayLMen.Day, WayLMen.StartT, WayLMen.StopT))>0 THEN
            ADD(_Inc, _Inc, , E_In004_List(RWayS.Date, 1, WayLMen.TSN),
                              E_In004_Obj (RWayS.Date, 1, WayLMen.TSN),
                              WayLMen.TSN, RWayJP.RWJPro, RWSWho, WayLMen.Number,
                _Inc.Value, RWayJP.Value);
           END;
           NEXT(WayLMen);
          END;
         END;
        END;
       END;
      END;
      NEXT(RWayJP);
     END; (* WHILE OCCURE(RWayJP) ... *)
     NEXT(RWayJ);
    END; (* WHILE OCCURE(RWayJ) ... *)
   END; (* IF Form() *)
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 END {Make_Inc};

 PRIVATE PROCEDURE MakeDailyRep();
  VAR
   Idx : NUMERIC[0];
 BEGIN
  SETZERO(DateSum);
  MAKEPART(R, TDate);
  SETEMPTY(_List);
  SELECT(_Inc, _Inc);
  WHILE OCCURE(_Inc) DO
   SETZERO(ListSum);
   _List:=_Inc.List;

   MAKEPART(R, Dlm2);
   MAKEPART(R, Line, _List, TitlToStr());
   MAKEPART(R, Dlm);

   CHANGESEL(_Inc, _Inc, , _Inc.List);
   WHILE OCCURE(_Inc) DO
    SETZERO(Sum);
    CHANGESEL(_Inc, _Inc, , _Inc.List, _Inc.Obj);

    WHILE OCCURE(_Inc) DO
     Idx :=0;
     WHILE (Idx < IdxLen) DO
      IF L_Way.IsIncRWJP(_Inc.Who, _Inc.Number, Idx, _Inc.RWJPro) THEN
       INC(Sum[Idx],     _Inc.Value);
       INC(ListSum[Idx], _Inc.Value);
       INC(DateSum[Idx], _Inc.Value);
      END;
      INC(Idx);
     END;
     NEXT(_Inc);
    END; (* WHILE OCCURE(_Inc) ... *)

    LAST(_Inc);
    CHANGESEL(_Inc, _Inc, , _Inc.List);
    NEXT(_Inc);
   END; (* WHILE OCCURE(_Inc) ... *)
   LAST(_Inc);
   CHANGESEL(_Inc, _Inc);
   MAKEPART(R, Line, " ", SumToStr(ListSum));
   NEXT(_Inc);
  END; (* WHILE OCCURE(_Inc) ... *)
  MAKEPART(R, Dlm2);
  MAKEPART(R, Line, "⮣  ", SumToStr(DateSum));

  L_AFM.AF_PurgeTemp("_Inc");
 END {MakeDailyRep};

 PRIVATE PROCEDURE MakeRep();
  VAR
   Idx : NUMERIC[0];
 BEGIN
  FirstPage:=1;
  SETZERO(DateSum);
  SETEMPTY(_List);
  LastPage:= ~Form();
  SELECT(_Inc, _Inc);
  WHILE OCCURE(_Inc) DO
   SETZERO(ListSum);

   CHANGESEL(_Inc, _Inc, , _Inc.List);
   _List:=_Inc.List;
   SAVE(_Inc);
   LAST(_Inc);
   CHANGESEL(_Inc, _Inc);
   LastPage :=~NEXT(_Inc);
   RESTORE(_Inc);

   L_PagePr.PagePr_Init("R", 64,
                        PROCREF(_RprtTop),
                        PROCREF(_PageTop),
                        PROCREF(_PageBot),
                        PROCREF(_RprtBot),
                        PROCREF(_Filling));

   FirstPage:=0;
   WHILE OCCURE(_Inc) DO
    PROMPT(": "+_Inc.Obj);
    SETZERO(Sum);
    CHANGESEL(_Inc, _Inc, , _Inc.List, _Inc.Obj);
    IF Form() THEN
     SETEMPTY(Sum, ListSum, DateSum);
    ELSE
     WHILE OCCURE(_Inc) DO
      Idx :=0;
      WHILE (Idx < IdxLen) DO
       IF L_Way.IsIncRWJP(_Inc.Who, _Inc.Number, Idx, _Inc.RWJPro) THEN
        INC(Sum[Idx],     _Inc.Value);
        INC(ListSum[Idx], _Inc.Value);
        INC(DateSum[Idx], _Inc.Value);
       END;
       INC(Idx);
      END;
      NEXT(_Inc);
     END; (* WHILE OCCURE(_Inc) ... *)
    END; (* IF ~Form() *)
    LAST(_Inc);

    IF Form() THEN
     L_PagePr.PagePr_BeforePrintLine(DEPTH(Dlm));
     MAKEPART(R, Dlm);
    END;
    IF Form() | ~IsZero(Sum, IdxLen) THEN
     L_PagePr.PagePr_BeforePrintLine(DEPTH(Line));
     MAKEPART(R, Line, _Inc.Obj, SumToStr(Sum)+E_In004_Comment(_Inc.TSN, _UpTo));
    END;
    CHANGESEL(_Inc, _Inc, , _Inc.List);
    NEXT(_Inc);
   END; (* WHILE OCCURE(_Inc) ... *)
   LAST(_Inc);
   CHANGESEL(_Inc, _Inc);
   NEXT(_Inc);
   L_PagePr.PagePr_Done();
   FirstPage:=0;
  END; (* WHILE OCCURE(_Inc) ... *)

  L_AFM.AF_PurgeTemp("_Inc");
 END {MakeRep};

BEGIN
 TestMode();
 IdxLen:=GetIdxLen();
 IF ForCurDat() THEN
  _From :=Memo.tmp_cd();
  _UpTo :=Memo.tmp_cd();
 ELSE
  _From :=Memo.ud_fr();
  _UpTo :=Memo.ud_ut();
 END;
 Create_Inc();
 RepName :=Str.Item("IN004|IN014|IN104|IN114|IN104|IN114|INF04|INF14", "|", MODE - 100);
 OPENREP(R, L_General.NameConnection(RepName), Create);
 SETEMPTY(Sum, ListSum, DateSum);

 IF Daily() THEN
  MAKEPART(R, Top);
  _Date :=_From;
  WHILE _Date <= _UpTo DO
   Make_Inc(_Date, _Date);
   MakeDailyRep();
   INC(_Date);
  END;
  MAKEPART(R, Dlm2);
  MAKEPART(R, Bot);
 ELSE
  Make_Inc(_From, _UpTo);
  MakeRep();
 END;

END.
