(*
%Copyright   (c) Polak Computer System
%Author      26.03.1994 22:31:21 SAN
%Purpose     ஫ 䨪樨 RWayTxt
%Type        control
%Specific    AP
%Modified    15.03.2013 15:22:27 POLAK\LDA
%Environment
*)

 MODULE InsRWTxt [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Events, L_General, L_BegRWS, L_StdFrm;

 PRIVATE PROCEDURE CheckTimes();
 BEGIN
  CONFORM(RWayS, StExit);
  IF (StExit.Strict = 2) & ~(!RWayTxt.Change & !RWayTxt.FExTime & !RWayTxt.LEnTime) THEN
   L_StdFrm.Choice(" 室  ⠭묨 ࠬࠬ ?");
  END;
  L_General.Assert(!RWayTxt.FExTime = !RWayTxt.LEnTime,
                   " ⠭⭮ ࠡ 室 㪠  ६");
  L_General.Assert(!RWayTxt.IEnTime = !RWayTxt.IExTime,
                   " ⠭⭮  室 㪠  ६");
  L_General.Assert(!RWayTxt.IEnTime | (RWayTxt.IEnType # 0),
                   " ⨯ ");
  L_BegRWS.intSetExitData(0);
 END {CheckTimes};

 PRIVATE PROCEDURE IsEmptyRWayTxt(): SCAL[2];
 BEGIN
  RETURN !RWayTxt.Change & !RWayTxt.FExTime & !RWayTxt.LEnTime & (RWayTxt.IEnType=0) &
         !RWayTxt.IEnTime & !RWayTxt.IExTime & !RWayTxt.Message;
 END {IsEmptyRWayTxt};

 PRIVATE PROCEDURE RWayTxt_OnAfterEdIns();
 BEGIN
  IF IsEmptyRWayTxt() THEN
   RWayTxt.Valid:=0;
   REPLACE(RWayTxt);
   L_BegRWS.intSetExitData(0);
  ELSE
   RWayTxt.Valid:=1;
   REPLACE(RWayTxt);
   CheckTimes();
  END;
 END {RWayTxt_OnAfterEdIns};

 PRIVATE PROCEDURE RWayTxt_OnAfterEdit();
 BEGIN
  RWayTxt_OnAfterEdIns();
 END {RWayTxt_OnAfterEdit};

 PRIVATE PROCEDURE RWayTxt_OnAfterInsert();
 BEGIN
  RWayTxt_OnAfterEdIns();
 END {RWayTxt_OnAfterInsert};

 PRIVATE PROCEDURE Beg0EE_wCWOrd_OnConformToWindow();
 BEGIN
  GE_WZD_CURSOR(RTI.Get().TrgWindow.ParentZone.Window.Name, RTI.Get().TrgWindow.ParentZone.Number, RWayS);
  L_General.Assert(OCCURE(RWayS), " ⠭ ⥪騩 ");
  CONFORM(RWayS, RWayTxt);
  L_General.Assert(OCCURE(RWayTxt), " ⥫쭮 ଠ樨   " + RWayS.RWayS);
  SE_WWD_CURSOR(RTI.Get().TrgWindow.Name, RWayTxt);
 END {Beg0EE_wCWOrd_OnConformToWindow};

 PUBLIC PROCEDURE ModifyRWayTxt();
 BEGIN
  L_General.Assert(~!RWayS.Exit, "室 㪠 室");
  CONFORM(RWayS, RWayTxt);
  IF ~OCCURE(RWayTxt) THEN
   DEFAULT(RWayTxt);
   RWayTxt.RWayS:=RWayS.RWayS;
   RWayTxt.Valid:=0;
   INSERT(RWayTxt);
  END;
  LIKEMENU(Edit, "Beg0EE_wCWOrd 0 " + "Beg0E 0 ");
 END {ModifyRWayTxt};

 PUBLIC PROCEDURE ShowRWayTxt();
 BEGIN
  L_General.Assert(ACCESS(RWayS), " ⠭ ⥢ ");
  LIKEMENU(ShowWin, "Beg0EE_wCWOrd 0 " + RTI.Get().CurWindow.Name + " 1", SC, "ShowPlaneInsideShowWin");
 END {ShowRWayTxt};

BEGIN
 L_Events.ExecuteHandler();
END.
