(*
%Copyright   (c) Polak Computer System
%Author      25.01.2002 18:54:05 SAN
%Purpose     ⥪ ࠡ  
%Type        library
%Specific    AP
%Modified    16.07.2014 12:40:24 POLAK\GAV
%Environment
*)

 MODULE L_Car [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tRepEvent = SCAL[100];

 PUBLIC CONST
  carst_OutOperat = 0;
  carst_InOperat  = 1;
  carst_Retired   = 2;
  carst_Pool      = " ᯫ樨| ᯫ樨|⨥";

  inBeg_DoesNot    = 0;
  inBeg_Possible   = 1;
  inBeg_Required   = 2;
  inBeg_Pool       = "||易⥫쭠";
  inBeg_Pool_Short = "-||";

  purp_Common    = 0;
  purp_Depart    = 1;
  purp_Pool_Full = "饣 짮|⢥";
  purp_Pool      = "|";

  ircvt_NotQualified        = 0;
  ircvt_PassengerCar        = 1;
  ircvt_Motorcycle          = 2;
  ircvt_Bus_wUL_UpTo5Year   = 3;
  ircvt_Bus_wUL_Over5Year   = 4;
  ircvt_Truck_wUL_UpTo5Year = 5;
  ircvt_Truck_wUL_Over5Year = 6;
  ircvt_SelfPropelledCar    = 7;
  ircvt_SnowMobile          = 8;
  ircvt_Boat                = 9;
  ircvt_Yacht               = 10;
  ircvt_Scooter             = 11;
  ircvt_Barge               = 12;
  ircvt_AirCraft            = 13;
  ircvt_JetAirplane         = 14;
  ircvt_Glider              = 15;

  IRC_VehTPool = " 㥬 |"+
                 "⮬ |"+
                 "横  ஫|"+
                 "⮡ (  5 )|"+
                 "⮡ (  5 )|"+
                 "㧮 ⮬ (  5 )|"+
                 "㧮 ⮬ (  5 )|"+
                 "㣨 ᠬ室   堭|"+
                 "室, ᠭ|"+
                 ",  |"+
                 "  㣨 ᭮- 㤠|"+
                 "横|"+
                 "ᠬ室 (㥬) 㤠|"+
                 ", ⮫|"+
                 "⨢ ᠬ|"+
                 "     ⥫";

  Tax_VehTPool =   "000 00 -  㥬" +
                  "|411 21 -  " +
                  "|411 22 -  ਩-孨᪮ 㦡" +
                  "|411 23 -  ᠭ୮ 樨  樭᪮ 㦡" +
                  "|411 24 - 㣨 ᠬ" +
                  "|412 11 - ⮫ ᠦ᪨  㧮" +
                  "|412 21 - ⮫ " +
                  "|412 22 - ⮫ ਩-孨᪮ 㦡" +
                  "|412 23 - ⮫ ᠭ୮ 樨  樭᪮ 㦡" +
                  "|412 24 - 㣨 ⮫" +
                  "|413 00 -  ࠭ᯮ ।⢠,  騥 ⥫" +
                  "|419 01 -   㤠, 騥 ⥫" +
                  "|420 11 - 㤠 ᠦ᪨  㧮 ᪨   ᠬ室" +
                  "|420 21 - 㤠 ஬᫮ ᪨   ᠬ室" +
                  "|420 22 - 㤠 ஬᫮ ᪨   ᠬ室" +
                  "|420 31 - ᥫ ,  ⠪   魮 ( 5 )" +
                  "|420 32 - ⨢  ண㫮 㤠 ᠬ室" +
                  "|420 33 - ⨢, ᪨  ண㫮 㤠 ᠬ室" +
                  "|421 00 - 室" +
                  "|422 00 - " +
                  "|423 00 - " +
                  "|424 00 - 横" +
                  "|425 00 -  " +
                  "|426 00 - ᭮- 㤠" +
                  "|427 01 - 㤠 ᠦ᪨  㧮 ᪨   ᠬ室" +
                  "|429 11 -  㤠" +
                  "|429 12 - 㤠 ਩-孨᪮ 㦡" +
                  "|429 13 - 㤠 樭᪮ 㦡" +
                  "|429 14 - 稥  ࠭ᯮ ।⢠" +
                  "|429 21 - 㣨  ࠭ᯮ ।⢠ ᠬ室" +
                  "|429 22 - 稥  ࠭ᯮ ।⢠ ᠬ室" +
                  "|510 01 - ⮬ , 㤮  - " +
                  "|510 02 - ⮬   魮 ⥫  100 " +
                  "|510 03 - ⮬  樭᪮ 㦡" +
                  "|510 04 - 稥 ⮬ " +
                  "|520 01 - ⮬ 㧮 (஬ 祭   56700)" +
                  "|530 01 - ࠪ ᥫ᪮宧⢥" +
                  "|530 02 - ࠪ 稥" +
                  "|530 03 - 室 " +
                  "|530 04 - 樠 ⮬設 (஬ 祭   590 15)" +
                  "|530 05 - 稥 ࠪ,   ᯥ樠 設" +
                  "|540 01 - ⮡ 樭᪮ 㦡" +
                  "|540 02 - ⮡ த᪮  㣮த ࠭ᯮ" +
                  "|540 03 - 稥 ⮡" +
                  "|561 00 - 横" +
                  "|562 00 - ஫" +
                  "|566 00 - ᠭ" +
                  "|567 00 - 室" +
                  "|570 01 - 室 設  堭  .  ᥭ筮 室" +
                  "|590 11 - ⮬ " +
                  "|590 12 - ⮬設  ⪨  㡮ન த" +
                  "|590 13 - ⮬設 ਩-孨᪮ 㦡" +
                  "|590 14 - ⮬-࣮ 樭᪮ 㦡" +
                  "|590 15 - 樠 ⮬設 (, ᪮⮢)" +
                  "|590 16 - 稥 ⮬ ᯥ樠";

  OwnS_VehPPool = "㦮| ᮡ⢥| | ७";

  EcoCls_VehPPool = "㫥||ன|⨩|⢥|";  (*VehPasp.EcoCls*)

  fam_No     = 0; (*RepEvent.FrAllMrk*)
  fam_Yes    = 1;
  fam_Strong = 2;

  src_Operator = 0; (*CarEvn.Source*)
  src_RprS     = 1;
  src_RWayS    = 2;
  src_FrCast   = 3;

  src_RE_Pool = "| | |ண";

  ttp_ThirdParty = 0;
  ttp_Owner      = 1;
  ttp_Operator   = 2;

  csl_None   = 0;
  csl_Active = 1;

  mcfn_Pool = "1|2";

  mcfn_1 = 0;
  mcfn_2 = 1;

 IMPORT L_General, L_DatTim, Str, L_Str, Math, L_EC, E_Way, L_Way, L_Env,
        L_StdFrm, L_MathR, L_MDoc, P_Firm, L_CUC, L_Prop;

 PUBLIC PROCEDURE GetStartDLastRepEvent(trgBoxNbr  : LIKE(Car.BoxNbr);
                                        trgRepEvent: LIKE(CarEvn.RepEvent);
                                        curDate    : DATE): DATE;
 BEGIN
  SETSEL(CarEvn, CarEvn, trgBoxNbr, trgRepEvent);
  IF SRCINSEL(CarEvn, LE, curDate) THEN
   RETURN CarEvn.StartD;
  END;
  RETURN EMPTYOF(DATE);
 END {GetStartDLastRepEvent};

 PUBLIC PROCEDURE GetStartDLastMathRepEvent(trgMath    : LIKE(Math.Math);
                                            trgRepEvent: tRepEvent;
                                            curDate    : DATE): DATE;
  VAR
   LastEventDate,
   D             : DATE;
   trgBoxNbr     : LIKE(Car.BoxNbr);
 BEGIN
  SETEMPTY(LastEventDate, trgBoxNbr);
  SELECT(CarLog, Math, , trgMath);
  WHILE OCCURE(CarLog) DO
   IF !trgBoxNbr | (CarLog.BoxNbr # trgBoxNbr) THEN
    trgBoxNbr:=CarLog.BoxNbr;
    D:=GetStartDLastRepEvent(trgBoxNbr, trgRepEvent, curDate);
    IF !LastEventDate | (LastEventDate < D) THEN
     LastEventDate:=D;
    END;
   END;
   NEXT(CarLog);
  END; (* WHILE OCCURE(CarLog) ... *)
  RETURN LastEventDate;
 END {GetStartDLastMathRepEvent};

 PUBLIC PROCEDURE HasRepEventOnDate(trgBoxNbr  : LIKE(Car.BoxNbr);
                                    trgRepEvent: LIKE(CarEvn.RepEvent);
                                    D          : DATE): SCAL[2];
 BEGIN
  SETSEL(CarEvn, CarEvn, trgBoxNbr, trgRepEvent);
  RETURN SRCINSEL(CarEvn, LE, D) & (D <= CarEvn.StopD);
 END {HasRepEventOnDate};

 PUBLIC PROCEDURE FixCarRun(trgBoxNbr: LIKE(Car.BoxNbr); D: DATE);
 BEGIN
  SETSEL(CarRun, BoxNbr, trgBoxNbr);
  IF ~SRCINSEL(CarRun, EQ, D) THEN
   IF ~SRCINSEL(CarRun, LE, D) THEN
    CarRun.BoxNbr:=trgBoxNbr;
    CarRun.TotRun:=0;
   ELSE
    INC(CarRun.TotRun, CarRun.Run);
   END;
   CarRun.Date:=D;
   CarRun.Run :=0;
   INSERT(CarRun);
  END;
 END {FixCarRun};

 PUBLIC PROCEDURE GetGlobalRun(trgBoxNbr: LIKE(Car.BoxNbr); D: DATE): LIKE(CarRun.TotRun);
 BEGIN
  SETSEL(CarRun, BoxNbr, trgBoxNbr);
  IF SRCINSEL(CarRun, LT, D) THEN
   RETURN CarRun.TotRun + CarRun.Run;
  ELSE
   RETURN 0;
  END;
 END {GetGlobalRun};

 PUBLIC PROCEDURE GetAccurateRunInPer(trgBoxNbr: LIKE(Car.BoxNbr);
                                      From,
                                      Till     : DATE): LIKE(CarRun.TotRun);
  VAR
   Result : LIKE(CarRun.TotRun);
   ntCnt  : NUMERIC[0];
   oPrompt: PROMPTLINE;
 BEGIN
  L_General.CallUs(~!Till);
  IF From < Till THEN
   Result:=GetGlobalRun(trgBoxNbr, Till) - GetGlobalRun(trgBoxNbr, From);
   IF Till > (SYSDATE() - 60) THEN
    ntCnt:=0;
    TRY
     TABLE.Get("RWayS").AccessDataMode:=AccessDataMode_SOFT;
     oPrompt:=PROMPTLINE.Create(" ஡  " + trgBoxNbr);
     SETSEL(RWayS, BoxNbr, trgBoxNbr);
     SRCINSEL(RWayS, LT, , Till);
     WHILE OCCURE(RWayS) & (RWayS.Date >= Math.Max(From, SYSDATE() - 60)) DO
      PROMPT("  " + L_DatTim.DateStr(RWayS.Date));
      IF    RWayS.Status # L_Way.rwsStat_Rated THEN
       INC(ntCnt);
      ELSIF ~RWayS.Done THEN
       CONFORM(RWayS, RWayJ);
       WHILE OCCURE(RWayJ) DO
        INC(Result, RWayJ.Fact * RWayJ.Run);
        NEXT(RWayJ);
       END; (* WHILE OCCURE(RWayJ) ... *)
      END;
      PREV(RWayS);
     END; (* WHILE OCCURE(RWayS) ... *)
     L_General.RaiseLockReleaseException();
    EXCEPT
    ON Exc: Exc_Root DO
     L_General.CheckIsLockReleaseException(Exc);
    END; (* TRY *)
    IF ntCnt > 5 THEN
     L_StdFrm.RedInform("  " + trgBoxNbr + "    ⠪஢ ." +
                        "||  ஡   묨.");
    END;
   END; (* IF Till > (SYSDATE() - 60) *)
  ELSE
   Result:=0;
  END;
  RETURN Result;
 END {GetAccurateRunInPer};

 PUBLIC PROCEDURE GetAccurateRunInPer_Inc(trgBoxNbr: LIKE(Car.BoxNbr); From, UpTo: DATE): LIKE(CarRun.TotRun);
 BEGIN
  L_General.Assert(~!UpTo, " 㪠  砭 ਮ");
  RETURN GetAccurateRunInPer(trgBoxNbr, From, UpTo + 1);
 END {GetAccurateRunInPer_Inc};

 PUBLIC PROCEDURE GetAccurateRunOnDate(trgBoxNbr: LIKE(Car.BoxNbr); D: DATE): LIKE(CarRun.TotRun);
 BEGIN
  RETURN GetAccurateRunInPer(trgBoxNbr, MINOF(DATE), D);
 END {GetAccurateRunOnDate};

 PUBLIC PROCEDURE GetWhiteRun(trgMath: LIKE(Math.Math); D: DATE): LIKE(CarRun.TotRun);
  VAR
   _BoxNbrB: LIKE(Car.BoxNbr);
   _DateB  : LIKE(CarLog.Date);
   _DateE  : LIKE(CarLog.DateE);
   Run     : LIKE(CarRun.TotRun);
 BEGIN
  Run:=0;
  IF ~!trgMath THEN
   SAVE(CarLog);
   SETEMPTY(_BoxNbrB);
   _DateB  :=D;
   SELECT(CarLog, Math, , trgMath);
   WHILE OCCURE(CarLog) DO
    IF CarLog.Date <= D THEN
     IF !CarLog.DateE THEN
      _DateE:=D - 1;
     ELSE
      _DateE:=Math.Min(CarLog.DateE, D - 1);
     END;
     IF CarLog.Date <= _DateB THEN
      _DateB:=CarLog.Date;
      _BoxNbrB:=CarLog.BoxNbr;
     END;
     SETSEL(CarRun, BoxNbr, CarLog.BoxNbr);
     IF SRCINSEL(CarRun, LE, _DateE) THEN
      INC(Run, CarRun.TotRun + CarRun.Run);
      IF SRCINSEL(CarRun, LT, CarLog.Date) THEN
       DEC(Run, CarRun.TotRun + CarRun.Run);
      END;
     END;
    END;
    NEXT(CarLog);
   END; (* WHILE OCCURE(CarLog) ... *)
   SETSEL(CarRun, BoxNbr, _BoxNbrB);
   IF SRCINSEL(CarRun, LT, _DateB) THEN
    INC(Run, CarRun.TotRun + CarRun.Run);
   END;
   RESTORE(CarLog);
  END;
  RETURN Run;
 END {GetWhiteRun};

 PUBLIC PROCEDURE BalCarRun();
  VAR
   _TotRun: LIKE(CarRun.TotRun);
 BEGIN
  _TotRun:=CarRun.TotRun;
  REPEAT
   PROMPT(L_DatTim.DateStr(CarRun.Date));
   CarRun.TotRun:=_TotRun;
   REPLACE(CarRun);
   _TotRun:=CarRun.TotRun + CarRun.Run;
  UNTIL ~NEXT(CarRun);
 END {BalCarRun};

 PUBLIC PROCEDURE ShowRun(D: DATE);
  VAR
   _Run: LIKE(CarRun.TotRun);
 BEGIN
  _Run:=GetAccurateRunInPer(Car.BoxNbr, D, SYSDATE());
  L_StdFrm.Inform("஡ ᫥ " + L_DatTim.DateStr(D) + " - " + FLDTOSTR(_Run, ",0", 0) + " ");
 END {ShowRun};

 PUBLIC PROCEDURE CarDaysInOperation(trgBoxNbr: LIKE(Car.BoxNbr); From, UpTo: DATE): NUMERIC[0];
  VAR
   Days: NUMERIC[0];
 BEGIN
  Days:=0;
  SETSEL(CarLog, BoxNbr, trgBoxNbr);
  SRCINSEL(CarLog, LE, , UpTo);
  WHILE OCCURE(CarLog) & (CarLog.DateE>=From) DO
   IF CarLog.Status = carst_InOperat THEN
    INC(Days, L_DatTim.DATEINT(From, UpTo, CarLog.Date, CarLog.DateE));
   END;
   PREV(CarLog);
  END; (* WHILE OCCURE(CarLog) ... *)
  RETURN Days;
 END {CarDaysInOperation};

 PUBLIC PROCEDURE StandOnCarLogSoft(trgBoxNbr: LIKE(Car.BoxNbr); D: DATE): SCAL[2];
 BEGIN
  SETSEL(CarLog, BoxNbr, trgBoxNbr);
  RETURN SRCINSEL(CarLog, LE, D);
 END {StandOnCarLogSoft};

(*!!!*) PUBLIC PROCEDURE _StandOnCarLog(trgBoxNbr: LIKE(Car.BoxNbr); D: DATE): SCAL[2];
 BEGIN
  RETURN StandOnCarLogSoft(trgBoxNbr, D);
 END {_StandOnCarLog};

 PUBLIC PROCEDURE StandOnCarLog(trgBoxNbr: LIKE(Car.BoxNbr); D: DATE);
 BEGIN
  IF ~!trgBoxNbr & ~StandOnCarLogSoft(trgBoxNbr, D) THEN
   L_General.Error("⨬ ਬ ࠭ᯮ⭮ ।⢠ "+trgBoxNbr+"  "+L_DatTim.DateStr(D));
  END;
 END {StandOnCarLog};

 PUBLIC PROCEDURE CarIsInOperation(trgBoxNbr: LIKE(Car.BoxNbr); D: DATE): SCAL[2];
 BEGIN
  RETURN StandOnCarLogSoft(trgBoxNbr, D) & (CarLog.Status = carst_InOperat);
 END {CarIsInOperation};

 PUBLIC PROCEDURE CheckAdaptability(trgBoxNbr: LIKE(Car.BoxNbr); D: DATE; allowRetired: SCAL[2]);
 BEGIN
  StandOnCarLog(trgBoxNbr, D);
  IF    CarLog.Status = carst_Retired THEN
   L_StdFrm.ConditionalCHOICE("࠭ᯮ⭮ ।⢮ 㦥 ᯨᠭ", allowRetired);
  ELSIF CarLog.Status = carst_OutOperat THEN
   L_StdFrm.Choice("࠭ᯮ⭮ ।⢮  ᯫ樨");
  END;
 END {CheckAdaptability};

 PUBLIC PROCEDURE AccessMark(trgBoxNbr: LIKE(Car.BoxNbr); OnDate: DATE);
 BEGIN
  SAVE(CarLog);
  StandOnCarLog(trgBoxNbr, OnDate);
  CONFORM(CarLog, Mark);
  RESTORE(CarLog);
 END {AccessMark};

 PUBLIC PROCEDURE AccessVehPasp(trgBoxNbr: LIKE(Car.BoxNbr); OnDate: DATE);
 BEGIN
  SAVE(CarLog);
  IF StandOnCarLogSoft(trgBoxNbr, OnDate) THEN
   CONFORM(CarLog, VehPasp);
  ELSE
   SETSEL(VehPasp, VehPasp);
  END;
  RESTORE(CarLog);
 END {AccessVehPasp};

 PUBLIC PROCEDURE VehPaspNbr_AsStr(): STRING[];
 BEGIN
  RETURN FLDTOSTR(VehPasp.VPNbr, "00 00 ");
 END {VehPaspNbr_AsStr};

 PUBLIC PROCEDURE VehPaspStateNbr(OnDate: DATE): LIKE(VehPasp.StateNbr);
 BEGIN
(* . 0096976 - 楤  ᯮ짮 *)
  IF (VehPasp.Till > OnDate) &
     (VehPasp.RegRemvD > OnDate) &
     (!VehPasp.CertDate | (VehPasp.CertDate <= OnDate)) THEN
   RETURN VehPasp.StateNbr;
  ELSE
   RETURN "";
  END;
 END {VehPaspStateNbr};

 PUBLIC PROCEDURE GetVehTypeIRC_VehT_asStr(): STRING[];
 BEGIN
  IF OCCURE(VehType) & ~!VehType.IRC_VehT THEN
   RETURN L_Str.PoolItem(IRC_VehTPool, VehType.IRC_VehT);
  ELSE
   RETURN "";
  END;
 END {GetVehTypeIRC_VehT_asStr};

 PUBLIC PROCEDURE GetCarProdDate(trgBoxNbr: LIKE(Car.BoxNbr); OnDate: DATE): DATE;
  VAR
   Result: DATE;
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   AccessVehPasp(trgBoxNbr, OnDate);
   IF OCCURE(VehPasp) THEN
    Result:=VehPasp.ProdDate;
   ELSE
    IF ~StandOnCarLogSoft(trgBoxNbr, OnDate) THEN
     SELECT(CarLog, BoxNbr, , trgBoxNbr);
    END;
    WHILE NEXT(CarLog) & !CarLog.VehPasp DO
    END; (* WHILE OCCURE(CarLog)...*)
    IF OCCURE(CarLog) THEN
     CONFORM(CarLog, VehPasp);
     Result:=VehPasp.ProdDate;
    ELSE
     SELECT(CarLog, BoxNbr, , trgBoxNbr);
     Result:=CarLog.Date;
    END;
   END;
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {GetCarProdDate};

 PUBLIC PROCEDURE E_IsCoveringEvent(trgRepEvent: LIKE(RepEvent.RepEvent)): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.IsCoveringEvent);
  IF ~!Local THEN
   RETURN Local(Math.Max(CarEvn.StartD, Car.BegDate), trgRepEvent);
  END;
  IF    trgRepEvent = E_Way.re_TO1 THEN
   RETURN (CarEvn.RepEvent = E_Way.re_TO2) |
          (CarEvn.RepEvent = E_RE_Overhaul(CarEvn.StartD));
  ELSIF trgRepEvent = E_Way.re_TO2 THEN
   RETURN (CarEvn.RepEvent = E_RE_Overhaul(CarEvn.StartD));
  ELSE
   RETURN 0;
  END;
 END {E_IsCoveringEvent};

 PUBLIC PROCEDURE NearestPastRepEventDate(D: DATE; trgRepEvent: LIKE(RepEvent.RepEvent)): DATE;
 BEGIN
  SETSEL(CarEvn, BoxNbr, Car.BoxNbr);
  SRCINSEL(CarEvn, LE, , D);
  WHILE OCCURE(CarEvn) & (CarEvn.RepEvent # trgRepEvent) & ~E_IsCoveringEvent(trgRepEvent) DO
   PREV(CarEvn);
  END;
  IF    OCCURE(CarEvn) THEN RETURN CarEvn.StartD;
  ELSE                      RETURN GetCarProdDate(Car.BoxNbr, D);
  END;
 END {NearestPastRepEventDate};

 PUBLIC PROCEDURE NearestPastRepEventDate_Strong(D: DATE; trgRepEvent: LIKE(RepEvent.RepEvent)): DATE;
  VAR
   Result: DATE;
 BEGIN
  Result:=NearestPastRepEventDate(D, trgRepEvent);
  IF OCCURE(CarEvn) & (CarEvn.Source = src_FrCast) & (CarEvn.StopD <= D) THEN
   L_General.Error(" ࠧ  ண ய|" +
                   RepEvent.RepEvent + " " + RepEvent.Name +
                   "  . " + CarEvn.BoxNbr + "  " + L_DatTim.DateStr(CarEvn.StartD));
  END;
  RETURN Result;
 END {NearestPastRepEventDate_Strong};

 PUBLIC PROCEDURE NearestFutureRepEventDate(D: DATE; trgRepEvent: LIKE(RepEvent.RepEvent)): DATE;
 BEGIN
  SETSEL(CarEvn, BoxNbr, Car.BoxNbr);
  SRCINSEL(CarEvn, GT, , D);
  WHILE OCCURE(CarEvn) & (CarEvn.RepEvent # trgRepEvent) & ~E_IsCoveringEvent(trgRepEvent) DO
   NEXT(CarEvn);
  END;
  IF OCCURE(CarEvn) THEN
   RETURN CarEvn.StartD;
  ELSE
   RETURN EMPTYOF(DATE);
  END;
 END {NearestFutureRepEventDate};

 PUBLIC PROCEDURE MarkRepEventNorm(trgMark    : LIKE(Mark.Mark);
                                   trgRepEvent: LIKE(RepEvent.RepEvent);
                                   D          : DATE;
                                   trgRun     : LIKE(MarkREN.Run[0]);
                                   Soft       : SCAL[2]): LIKE(MarkREN.Norm[0]);
  VAR
   _Norm: LIKE(MarkREN.Norm[0]);
   i    : NUMERIC[0];
 BEGIN
  _Norm:=0;
  SETSEL(MarkREN, Mark, trgMark, trgRepEvent);
  IF SRCINSEL(MarkREN, LE, D) & (D <= MarkREN.DateE) THEN
   i:=0;
   WHILE (i<RANGEOF(MarkREN.Run)) & ~!MarkREN.Run[i] DO
    IF trgRun >= MarkREN.Run[i] THEN
     _Norm:=MarkREN.Norm[i];
    END;
    INC(i);
   END;
  END;
  IF _Norm = 0 THEN
   L_General.Assert(Soft, " ⠭ ଠ⨢  " + L_DatTim.DateStr(D) +
                          "  ஡ " + FLDTOSTR(trgRun) +
                          "||ઠ " + trgMark + ", ய⨥ " + trgRepEvent);
  END;
  RETURN _Norm;
 END {MarkRepEventNorm};

 PUBLIC PROCEDURE IsSelfPropelledCar(trgBoxNbr: LIKE(Car.BoxNbr); D: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  SAVE(Mark);
  SAVE(VehType);
  AccessMark(trgBoxNbr, D);
  IF ~!Mark.VehType THEN
   CONFORM(Mark, VehType);
   Result:=VehType.IRC_VehT = ircvt_SelfPropelledCar;
  END;
  RESTORE(VehType);
  RESTORE(Mark);
  RETURN Result;
 END {IsSelfPropelledCar};

 PUBLIC PROCEDURE GetCarMyFirm(trgBoxNbr: LIKE(Car.BoxNbr); D: DATE): P_Firm.tMyFirm;
  VAR
   Result: P_Firm.tMyFirm;
 BEGIN
  SAVE(CarLog);
  SAVE(Column);
  StandOnCarLog(trgBoxNbr, D);
  CONFORM(CarLog, Column);
  Result:=Column.MyFirm;
  RESTORE(Column);
  RESTORE(CarLog);
  RETURN Result;
 END {GetCarMyFirm};

 PUBLIC PROCEDURE GetFirmOfCar(OnDate: DATE): LIKE(Firm.Firm);
 BEGIN
  ACCESS(Car);
  RETURN P_Firm.fomf(GetCarMyFirm(Car.BoxNbr, OnDate));
 END {GetFirmOfCar};

 PUBLIC PROCEDURE CheckVIN(trgVIN: LIKE(VehPasp.VIN));
  VAR
   Errors: STRING[];
 BEGIN
  SETEMPTY(Errors);
  IF Str.Length(trgVIN) # 17 THEN
   Errors:=" VIN  17 ᨬ.||";
  END;
  IF ~L_Str.TestStrAlowChar(Str.Slice(trgVIN, 13, 4), "09") THEN
   Errors:=Errors + " ᫥ ᨬ   ࠬ.||";
  END;
  IF ~L_Str.TestStrAlowChar(trgVIN, "0Z") THEN
   Errors:=Errors + " 饭 ᨬ|(᪠ ⮫쪮 ⨭᪨ 㪢  ).";
  END;
  IF ~!Errors THEN
   L_StdFrm.Choice("୮  VIN:||" + Errors);
  END;
 END {CheckVIN};

 PRIVATE PROCEDURE StandOnMCFix(trgTSN: LIKE(Staff.TSN); trgNbr: LIKE(MCFix.Nbr); D: DATE): SCAL[2];
 BEGIN
  SETSEL(MCFix, TSN, trgTSN, trgNbr);
  RETURN SRCINSEL(MCFix, LE, D) & (D < MCFix.Till) &
         L_Env.RealBoxNbr(MCFix.BoxNbr);
 END {StandOnMCFix};

 PUBLIC PROCEDURE StandOnFirstMCFix(trgTSN: LIKE(Staff.TSN); D: DATE): SCAL[2];
 BEGIN
  RETURN StandOnMCFix(trgTSN, mcfn_1, D);
 END {StandOnFirstMCFix};

 PUBLIC PROCEDURE StandOnSecondaryMCFix(trgTSN: LIKE(Staff.TSN); D: DATE): SCAL[2];
 BEGIN
  RETURN StandOnMCFix(trgTSN, mcfn_2, D);
 END {StandOnSecondaryMCFix};

 PUBLIC PROCEDURE StandOnAnyMCFix(trgTSN: LIKE(Staff.TSN); D: DATE): SCAL[2];
 BEGIN
  RETURN StandOnFirstMCFix(trgTSN, D) | StandOnSecondaryMCFix(trgTSN, D);
 END {StandOnAnyMCFix};

 PUBLIC PROCEDURE StaffHasSingleMCFix(trgTSN: LIKE(Staff.TSN); D: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(MCFix);
  Result:=(StandOnFirstMCFix(trgTSN, D) + StandOnSecondaryMCFix(trgTSN, D)) = 1;
  RESTORE(MCFix);
  RETURN Result;
 END {StaffHasSingleMCFix};

 PUBLIC PROCEDURE StandOnFirstMCFix_ByCar(trgBoxNbr: LIKE(Car.BoxNbr); D: DATE): SCAL[2];
 BEGIN
  SELECT(MCFix, BoxNbr, , trgBoxNbr);
  WHILE OCCURE(MCFix) DO
   NARROWSEL(MCFix, TSN);
   IF SRCINSEL(MCFix, LE, D) & (MCFix.Till > D) & (MCFix.Dschrg > D) THEN
    RETURN 1;
   END;
   NEXTINEXTENDEDSEL(MCFix, TSN);
  END; (* WHILE OCCURE(MCFix) ... *)
  RETURN 0;
 END {StandOnFirstMCFix_ByCar};

 PUBLIC PROCEDURE StandOnCarLogFromVehPasp(curVehPasp: LIKE(VehPasp.VehPasp); D: DATE): SCAL[2];
 BEGIN
  SETSEL(CarLog, VehPasp, curVehPasp);
  RETURN SRCINSEL(CarLog, LE, D);
 END {StandOnCarLogFromVehPasp};

 PUBLIC PROCEDURE GetEngineCUCopySerial(): LIKE(CUCopy.Serial);
 BEGIN
  IF L_CUC.EngineAcntLev() THEN
   SELECT(MDocLCU, BoxNbr, , CarLog.BoxNbr, L_MDoc.st_Passed);
   WHILE OCCURE(MDocLCU) DO
    CONFORM(MDocLCU, CUCopy);
    NARROWSEL(MDocLCU, CUCopy);
    IF L_CUC.cucRole_IsEngine() THEN
     CONFORM(CUCopy, Math);
     CONFORM(Math, CarUnit);
     IF SRCINSEL(MDocLCU, LE, Math.Max(CarLog.Date, CarUnit.SNDate)) & L_CUC.IsCUAtCar(MDocLCU.OpKind) THEN
      RETURN CUCopy.Serial;
     END;
    END;
    NEXTINEXTENDEDSEL(MDocLCU, CUCopy);
   END; (*WHILE*)
  END;
  RETURN "";
 END {GetEngineCUCopySerial};

 PUBLIC PROCEDURE CheckCarLogToVehPaspCompliance();
  VAR
   CUCEngineNum: STRING[];
 BEGIN
  IF ~!CarLog.VehPasp THEN
   CONFORM(CarLog, VehPasp);
   IF (CarLog.Mark # VehPasp.Mark) THEN
    L_StdFrm.Choice("ઠ  ᠭ  " + CarLog.BoxNbr +
                    "| ᮢ   " + VehPasp.VehPasp);
   END;
   IF (Str.Cap(CarLog.StateNbr) # Str.Cap(VehPasp.StateNbr)) THEN
    L_StdFrm.Choice(".   ᠭ  " + CarLog.BoxNbr +
                    "| ᮢ   " + VehPasp.VehPasp);
   END;
   CUCEngineNum:=GetEngineCUCopySerial();
   IF ~!CUCEngineNum THEN
    IF CUCEngineNum # VehPasp.EnginNum THEN
     L_StdFrm.Choice(" ⥫, ⠭   " + CarLog.BoxNbr +
                     "| ᮢ   " + VehPasp.VehPasp);
    END;
   ELSIF L_CUC.EngineAcntLev() THEN
    L_StdFrm.Choice("  ୮ " +
                    "|  " + CarLog.BoxNbr + "  ⠭ ⥫");
   END;
  END;
 END {CheckCarLogToVehPaspCompliance};

(*-------------BEGIN OF NORMAL ENVIRONMENT--------------------------*)

 PUBLIC PROCEDURE E_GetFictiveBoxNbr(trgMyFirm: P_Firm.tMyFirm): LIKE(Car.BoxNbr);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(L_Env.GetFictiveBoxNbr);
  IF ~!Local THEN
   RETURN Local(trgMyFirm);
  ELSE
   L_General.CallUs(~P_Firm.E_wMultipleMyFirm(SYSDATE()));
   RETURN 0000;
  END;
 END {E_GetFictiveBoxNbr};

 PUBLIC PROCEDURE E_RE_Overhaul(D: DATE): tRepEvent;
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.RE_Overhaul), 92);
 END {E_RE_Overhaul};

 PUBLIC PROCEDURE E_RE_InWaitingForRepair(D: DATE): tRepEvent;
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.RE_InWaitingForRepair), 90);
 END {E_RE_InWaitingForRepair};

 PRIVATE PROCEDURE StateNbrRegionMustBePresent(trgStateNbr: LIKE(CarLog.StateNbr)): SCAL[2];
  VAR
   i     : NUMERIC[0];
   Char  : STRING[];
   Result: SCAL[2];
 BEGIN
  Result:=1;
  i:=Str.Length(trgStateNbr)-1;
  WHILE (i > 0) & Result DO
   Char  :=L_Str.Char(trgStateNbr, i);
   Result:=(Char = " ") | L_Str.TestStrAlowChar(Char, "") | L_Str.TestStrAlowChar(Char, "09");
   DEC(i);
  END; (* WHILE (i < 0) & Result...*)

  IF Result THEN
   IF Str.Length(trgStateNbr) > 5 THEN
    Result:=~L_Str.TestStrAlowChar(L_Str.Right(trgStateNbr, 3), "");
   ELSE
    Result:=0;
   END;
  END;
  RETURN Result;
 END {StateNbrRegionMustBePresent};

 PUBLIC PROCEDURE E_GetCorrectedStateNbr(trgStateNbr: LIKE(CarLog.StateNbr); Strong: SCAL[2]): STRING[];
  VAR
   i            : NUMERIC[0];
   Char,
   trgRegion    : STRING[];
   IsBadStateNbr: SCAL[2];
 BEGIN
  i            :=0;
  IsBadStateNbr:=0;
  WHILE (i < Str.Length(trgStateNbr)) & ~IsBadStateNbr DO
   Char         :=L_Str.Char(trgStateNbr, i);
   IsBadStateNbr:=L_Str.TestStrAlowChar(Str.Cap(Char), "AZ");
   INC(i);
  END;
  IF IsBadStateNbr THEN
   L_StdFrm.ConditionalCHOICE("⨬ ᯮ짮 ⨭᪨ 㪢 ('"+Char+"')", ~Strong);
  END;

  IF (L_General.GetAPSiteNumber() = 21) | (L_General.GetAPSiteNumber() = 26) |
     (L_General.GetAPSiteNumber() = 50) | (L_General.GetAPSiteNumber() = 79) THEN
   trgStateNbr:=Str.Small(trgStateNbr);
   IF StateNbrRegionMustBePresent(trgStateNbr) THEN
    L_General.Assert(Str.WordAmount(trgStateNbr) = 2, " ᭮   ⢥ ஡,|" +
                                                      "⤥騩  ॣ");
    trgRegion:=Str.Item(trgStateNbr, " ", 1);
    L_General.Assert(L_Prop.IsNumericValue(trgRegion, ""), "४  ॣ '" + trgRegion +"':|" +
                                                           "    ⮫쪮 ");
    L_General.Assert((Str.Length(trgRegion) = 2) | (Str.Length(trgRegion) = 3), "४  ॣ '" + trgRegion +"':|" +
                                                                                " ⮨  2-  3- ");

   END;
  END;
  RETURN trgStateNbr;
 END {E_GetCorrectedStateNbr};

 PUBLIC PROCEDURE E_CarServiceLev(D: DATE): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(L_Env.CarServiceLev);
  IF ~!Local THEN
   RETURN Local(D);
  ELSE
   RETURN csl_None;
  END;
 END {E_CarServiceLev};

 PUBLIC PROCEDURE StateNbrToInternational(srcStateNbr: STRING[]; woSpace: SCAL[2]): STRING[];
  CONST
   PatRussian = "|||||||||||";
   PatLatin   = "A|B|E|K|M|H|O|P|C|T|Y|X";
  VAR
   i                   : NUMERIC[0];
   dstStateNbr,
   Char                : STRING[];
   Item                : NUMERIC[0];
   NormalStateNbrFormat: SCAL[2];
 BEGIN
  NormalStateNbrFormat:=1;
  IF woSpace THEN
   srcStateNbr:=Str.Replace(srcStateNbr, " ", "");
  END;
  srcStateNbr:=Str.Cap(srcStateNbr);

  i:=0;
  SETEMPTY(dstStateNbr);
  LOOP
   Char:=L_Str.Char(srcStateNbr, i);
   IF !Char | ~NormalStateNbrFormat THEN
    EXIT;
   END;
   Item:=L_Str.PositionInPool(PatRussian, Char);
   IF    ~!Item THEN
    Char:=L_Str.PoolItem(PatLatin, Item);
   ELSIF L_Str.TestStrAlowChar(Char, "") THEN
    NormalStateNbrFormat:=0;
   END;
   dstStateNbr:=dstStateNbr + Char;
   INC(i);
  END;
  IF NormalStateNbrFormat THEN
   RETURN dstStateNbr;
  ELSE
   RETURN srcStateNbr;
  END;
 END {StateNbrToInternational};

END.
