(*
%Copyright   (c) Polak Computer System
%Author      20.03.1994 14:17:11 SAN
%Purpose     ⥪  ࠡ    ⠭묨 室
%Type        library
%Specific    AP
%Modified    15.08.2014 18:24:35 POLAK\San
%Environment
*)

 MODULE L_Way [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tRWSWho           = SCAL[10];
  tWLMWho           = SCAL[5];
  tTRSWho           = SCAL[3];
  v_Arr             = STRING[][15];
  tWaySeason        = SCAL[2];
  tStExitWDType     = SCAL[2];
  tRtMVer           = SCAL[10];
  tGapType          = SCAL[2];
  tPikTimeVersion   = NUMERIC[0];
  tIncPlanCondition = SCAL[16];
  tBegRWSLev        = SCAL[3];
  tCalcPlInc        = SCAL[3];
  tTripOutLine      = SCAL[4];
  tVldPsgKind       = SCAL[4];
  ttcpi             = SCAL[3];
  tFuelNorms        = NUMERIC[2];
  tPasVolEnum       = SCAL[5];
  tRun              = NUMERIC[2];

 PUBLIC CONST
  gt_Single      = 0;
  gt_Cumulative  = 1;

  wlmwho_Guard   = 0;
  wlmwho_DrPupil = 1;
  wlmwho_GuPupil = 2;
  wlmwho_SDriver = 3;
  wlmwho_Chopper = 4;
  wlmwho_Pool       = "|祭|祭|2- .|稪";
  wlmwho_Pool_Short = "|||2|";

  rwswho_Driver  = 0;
  rwswho_Guard   = 1;
  rwswho_DrPupil = 2;
  rwswho_GuPupil = 3;
  rwswho_SDriver = 4;
  rwswho_Chopper = 5;
  rwswho_Dr_W_Gu = 9;
  rwswho_Pool       = "⥫||祭|祭|2- .|稪| | | |";
  rwswho_Pool_Short = "||||2|| | | |";

  trs_Driver  = 0;
  trs_Guard   = 1;
  trs_Chopper = 2;
  trs_Pool    = "⥫||稪";

  tcpi_FromRoute = 0;
  tcpi_FromExit  = 1;
  tcpi_Mixed     = 2;

  ript_OnHour      = 0; (*RouteIP.Type*)
  ript_OnTrip      = 1;
  ript_OnExit      = 2;
  ript_Canceled    = 3;

  ipt_OnRoute     = 0; (*ExitIP.Type*)
  ipt_OnWholeExit = 1;
  ipt_OnTrip      = 2;
  ipt_OnHour      = 3;
  ipt_Canceled    = 4;

  ipc_Driver      = 0; (*ExitIP.Cnd*)
  ipc_Guard       = 1;
  ipc_TwoGuards   = 2;
  ipc_Total       = 3;
  ipc_UserDefined = 4;

  toPay_SeeRsp   = 2;
  toSheet_SeeRsp = 3;
  trsGap_SeeRsp  = 2;
  toSheet_Dummy  = 0;
  toSheet_Sheet  = 1;
  toSheet_Holid  = 2;

  rwsStat_Ordered = 0;
  rwsStat_Given   = 1;
  rwsStat_Taken   = 2;
  rwsStat_Rated   = 3;
  rwsStat_Pool = "殮|뤠|ਭ|஢";

  ExitStrict_Fict = 0;
  ExitStrict_Ord  = 1;
  ExitStrict_Reg  = 2;
  ExitStrict_Pool = "⨢|裂|";
  ExitStrict_ShortPool = "||";

  egn_Possible   = 0;       (*StExit.GuNeed*)
  egn_Required   = 1;
  egn_Prohibited = 2;

  QualType_Annul  = 0;
  QualType_Defect = 1;
  QualType_Realiz = 2;
  QualType_VoidTr = 3;

  mgt_WagePay           = 000;
  mgt_TEP               = 010;
  mgt_Math              = 011;
  mgt_Loss              = 012;
  mgt_Fuel              = 013;
  mgt_OrderIncome       = 014;
  mgt_REPlan            = 016;
  mgt_Revise_wRDO       = 017;
  mgt_RprJobBaseTime    = 018;
  mgt_MathCompatibility = 022;
  mgt_AccessDriving     = 023;
  mgt_KIPandKTG         = 024;
  mgt_CostAccounting    = 025;

  rwjpSrc_Opert   = 0;  (*RWayJP.Source*)
  rwjpSrc_TckRcS  = 2;
  rwjpSrc_System  = 3;
  rwjpSrc_CWOrder = 4;
  rwjpSrc_Import  = 5;
  rwjpSrc_IRec    = 6;

  rwjpSrc_Pool = "| ||⥬|||";

  rwjp_PlanIsEqualFact  = 15;
  rwjp_CargoTonnage     = 65;
  rwjp_ASCPDisabled     = 66;
  rwjp_DecreaseLossTime = 81;
  rwjp_Fict             = 99;

  vpk_MoscowRegion = 0; (*tVldPsgKind*)
  vpk_Moscow       = 1;
  vpk_OtherSocial  = 2;
  vpk_Paid         = 3;

  rwjpt_PassTransportation  = 00; (*RWJPro.Type*)
  rwjpt_CargoTransportation = 01;
  rwjpt_RateSpecific        = 02;

  ecbt_Line     = 0; (*ExitClss.BegType*)
  ecbt_Reserv   = 1;
  ecbt_Order    = 2;
  ecbt_Repair   = 3;
  ecbt_Loss     = 4;
  ecbt_NightRou = 5;
  ecbt_Training = 6;
  ecbt_OwnTin   = 7;
  ecbt_IntEcon  = 8;
  ecbt_Outage   = 9;

  ecbt_Pool = "|||||.|.|.||.";

  ss_City     = 0; (* Stop.Sign *)
  ss_Suburb   = 1;
  ss_Special  = 2;
  ss_Exterior = 3;
  ss_Pool     = "த᪠|த|樠쭠|㡥";

  (* tStopCPType: LIKE(Stop.CPType) *)
  scpt_None    = 0;
  scpt_DspLink = 1;
  scpt_DspSelf = 2;
  scpt_SCAD    = 3;
  scpt_CtrlPnt = 4;
  scpt_Pool    = " |.|ᯥ| ⠡|.㭪";
  scpt_PoolWdo = "-|.|ᯥ| ⠡|.㭪";

  WJType_Void   = 0; (*WJMode.WJType*)
  WJType_Work   = 1;
  WJType_Repair = 2;
  WJType_Stand  = 3;
  WJType_Pool   = "-------|ந.||⮨";

  runsel_None = 0; (*WJMode.RunSel*)
  runsel_Zero = 1;
  runsel_Work = 2;
  runsel_Pool = "|㫥|ந.";

  rwpay_Basic = 01;

  wssn_Summer = 0;
  wssn_Winter = 1;

  sewdt_WrkDay = 0; (*tStExitWDType*)
  sewdt_OffDay = 1;

  seak_OnDays        = 0; (*StExit.ActivKnd*)
  seak_EveryOtherDay = 1;
  seak_Pool          = "  |१ ";

  dir_Forward  = 0;
  dir_Backward = 1;

  bt_Never   = 0; (*SEJobs.BoxTick*)
  bt_Ever    = 1;
  bt_Perhaps = 2;

  exvld_Active  = 0; (*_CheckExitOnDate*)
  exvld_NoOnDay = 1;
  exvld_NoBegin = 2;
  exvld_Retired = 3;

  brwsl_NoBeg  = 0; (*BegRWSLevel*)
  brwsl_Intro  = 1;
  brwsl_Active = 2;

  pve_Zero    = 0; (*tPasVolEnum*)
  pve_Small   = 1;
  pve_Middle  = 2;
  pve_Big     = 3;
  pve_VeryBig = 4;
  pve_Pool    = "||||";

  tkrgn_City      = 0; (*TKind.Rgn*)
  tkrgn_Suburb    = 1;
  tkrgn_Intercity = 2;
  tkrgn_Order     = 3;
  tkrgn_Internal  = 4;
  tkrgn_Other     = 7;
  tkrgn_Pool = "த|ਣத|த||७| | |祥";

  tkfnm_Subsidy  = 0; (*TKind.FnMode*)
  tkfnm_Commerce = 1;
  tkfnm_Other    = 2;
  tkfnm_Pool = "樮|᪨|稥";

  tkout_Off = 0;
  tkout_In  = 1;
  tkout_Clc = 2;

  ctbl_DmntTKind  = 0; (*CarTbLevel*) (*楫 設  DominantTKind( .६),  ⮢( 0000)*)
  ctbl_EveryTKind = 1; (*஡ 設  ࠧ ,  ⮢( 0000)*)
  ctbl_EveryRoute = 2; (*஡ 設  ࠧ ,  ⠬*)
  ctbl_DmntRoute  = 3; (*楫 設  DominantRoute( .६)*)

  cpit_ByTrip = 0;  (*CalcPlIncType*)
  cpit_ByTime = 1;
  cpit_ByRun  = 2;

  tol_ByFixedRoute    = 0; (*tTripOutLine*)
  tol_ByFixedTKind    = 1;
  tol_ByDominantTKind = 2;
  tol_ByPreviosRoute  = 3;

  wjmpt_ByMark    = 0; (*WJMethod.PayType*)
  wjmpt_ByMCFix   = 1;
  wjmpt_ByOfficer = 2;
  wjmpt_Other     = 3;
  wjmpt_None      = 4;
  wjmpt_Pool      = "||||";

  wlmdtl_Full = 0; (*WayLMen.FncDtl*)
  wlmdtl_Sale = 1;
  wlmdtl_Vldt = 2;
  wlmdtl_Pool = "||";

  erkn_ec_Reserve            = 010395101;
  erkn_ec_CurRepair          = 010395102;
  erkn_ec_TO2                = 010395103;
  erkn_ec_RepairWODrv        = 010395104;
  erkn_ec_Overhaul           = 010395105;
  erkn_ec_InWaitingForRepair = 010395106;
  erkn_ec_GuardReserve       = 010395107;
  erkn_ec_GuardOutage        = 010395108;
  erkn_ec_OtherDayOfWork     = 010395109;

  seca_Calendar = 0; (*StExit.ClndAppl*)
  seca_Fact     = 1;

  DtwoReadyTime = 16:00; (*६ ⮢ 鸞*)

  mc_Pool = "A|A1|B|B1|C|C1|D|D1|BE|CE|C1E|DE|D1E|M|Tm|Tb"; (* Mark.Category *)

  seob_InGarage     = 0; (*StExit.OutBox*)
  seob_InLine       = 1;
  seob_InBusStation = 2;
  seob_Pool = " ࠦ| | /";

 PUBLIC PERMANENT VAR
  v_MarkGT: LIKE(MarkGT.MarkGT);

 IMPORT L_General, L_DatTim, L_Car, L_EC, L_Hld, L_Money, L_BarCode,
        L_APtm, L_XDoc, L_Math, L_SCAD, L_Str, L_Prop, L_MDoc,
        P_Route, P_Car, P_Mark, P_Exit, Math, Str, Memo, P_OwnData, L_Staff,
        E_Way, L_Env, L_StdFrm, L_TRS, P_Firm, P_Sort, P_Column, L_APWI,
        L_RWayS, E_Utils, L_qs, L_Fuel, L_AR, L_kn;

 PUBLIC PROCEDURE extCurPlaceFilter(curTable: STRING[]; AddFilter: STRING[]): STRING[];
  VAR
   MyPlaceFFN,
   MyFirmFFN,
   Filter    : STRING[];
 BEGIN
  IF ~!TABLE.Get(curTable).Fields("MyPlace") THEN
   MyPlaceFFN:=TABLE.Get(curTable).Fields("MyPlace").ObtainName();
  ELSE
   SETEMPTY(MyPlaceFFN);
  END;
  IF ~!TABLE.Get(curTable).Fields("MyFirm") THEN
   MyFirmFFN:=TABLE.Get(curTable).Fields("MyFirm").ObtainName();
  ELSE
   SETEMPTY(MyFirmFFN);
  END;
  IF ~!MyPlaceFFN THEN
   Filter:="(((" + MyPlaceFFN + " >= P_Firm.minMyPlace) & (" + MyPlaceFFN + " <= P_Firm.maxMyPlace)) | " +
           " (" + MyPlaceFFN + " = 0000))";
  ELSE
   SETEMPTY(Filter);
  END;
  IF ~!MyFirmFFN THEN
   IF ~!Filter THEN
    INC(Filter, "&");
   END;
   INC(Filter, "(((" + MyFirmFFN + " >= P_Firm.minMyFirm) & (" + MyFirmFFN + " <= P_Firm.maxMyFirm)) | " +
               " (" + MyFirmFFN + " = 0000))");
  END;
  IF ~!AddFilter THEN
   INC(Filter, AddFilter);
  END;
  RETURN Filter;
 END {extCurPlaceFilter};

 PRIVATE PROCEDURE GetActiveStExitByExitClss(trgExitClss: LIKE(ExitClss.ExitClss);
                                             D          : DATE;
                                             Strong     : SCAL[2]): LIKE(StExit.Exit);
  VAR
   Result: LIKE(StExit.Exit);
 BEGIN
  SETEMPTY(Result);
  IF ~!trgExitClss THEN
   SAVE(StExit);
   SETSEL(StExit, ExitClss, trgExitClss);
   LAST(StExit);
   WHILE OCCURE(StExit) & !Result DO
    IF StExitActiveOnDate(StExit.Exit, D) THEN
     Result:=StExit.Exit;
    END;
    PREV(StExit);
   END; (* WHILE OCCURE(StExit) ... *)
   L_General.Assert(~!Result | ~Strong, "  室  " + trgExitClss);
   RESTORE(StExit);
  END;
  RETURN Result;
 END {GetActiveStExitByExitClss};

 PUBLIC PROCEDURE erkn_e_Get(D: DATE; trgNotion: L_kn.tNotion): LIKE(StExit.Exit);
 BEGIN
  RETURN GetActiveStExitByExitClss(L_kn.Get(D, trgNotion), D, 1);
 END {erkn_e_Get};

 PRIVATE PROCEDURE erkn_e_GetSoft(D: DATE; trgNotion: L_kn.tNotion): LIKE(StExit.Exit);
 BEGIN
  RETURN GetActiveStExitByExitClss(L_kn.GetSoft(D, trgNotion), D, 0);
 END {erkn_e_GetSoft};

 PUBLIC PROCEDURE IsExitClasswERKN(trgExitClss: LIKE(ExitClss.ExitClss); trgNotion: L_kn.tNotion): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF ~!trgExitClss THEN
   SAVE(ExitClss);
   SEARCH(ExitClss, ExitClss, , trgExitClss);
   Result:=L_kn.Is(SYSDATE(), trgNotion);
   RESTORE(ExitClss);
  END;
  RETURN Result;
 END {IsExitClasswERKN};

 PUBLIC PROCEDURE PositionOnStExit(trgExit: LIKE(StExit.Exit));
 BEGIN
  SEARCH(StExit, Exit, , trgExit);
 END {PositionOnStExit};

 PUBLIC PROCEDURE IsMainRWOp(): SCAL[2];
 BEGIN
  RETURN L_AR.IsManagerOfGroupN("RWOP") | L_General.IsAdmin();
 END {IsMainRWOp};

 PUBLIC PROCEDURE RWaySType(_Type: LIKE(RWayS.Type)): STRING[];
 BEGIN
  RETURN ''+L_Math.DecToHex(_Type);
 END {RWaySType};

 PUBLIC PROCEDURE FullBegTime(D: NUMERIC[0]; Tb: TIME): NUMERIC[3];
 BEGIN
  RETURN (D-1)*24+(Tb-00:00);
 END {FullBegTime};

 PUBLIC PROCEDURE FullEndTime(D: NUMERIC[0]; Tb, Te: TIME): NUMERIC[3];
 BEGIN
  RETURN (D-1+(Te<Tb))*24+(Te-00:00);
 END {FullEndTime};

 PUBLIC PROCEDURE SetQualityStat(_Stat: SCAL[2]);
 BEGIN
  QualityStat:=_Stat;
 END {SetQualityStat};

 PUBLIC PROCEDURE SetRWJQuality();
 BEGIN
  IF QualityStat THEN
   RWayJ.Quality:=L_RWayS.Qlt_Good;
  ELSIF L_SCAD.E_RWayCPLevel(RWayS.Date) THEN
   QualityStat:=1;
   CONFORM(RWayJ, RWayCP);
   IF OCCURE(RWayCP) THEN
    SETEMPTY(RWayJ.Quality);
   ELSE
    RWayJ.Quality:=L_RWayS.Qlt_Good;
   END;
  END;
  REPLACE(RWayJ);
 END {SetRWJQuality};

 PUBLIC PROCEDURE RemoveSingleRWayJ(VAR Asked: SCAL[2]);
 BEGIN
  ACCESS(RWayJ);
  L_SCAD.RemSelRWayCP(Asked);
  IF (E_TckRcLevel(RWayS.Date) > L_TRS.il_None) & SELECT(TckRcJ, asRWayS, RWayJ.RWayS, RWayJ.Day, RWayJ.StartT) THEN
   L_General.Error("室 ⪠  " + TckRcJ.TckRcS);
  END;
  INTEGRITY(NoAsk);
  REMOVE(RWayJ);
  INTEGRITY(Off);
 END {RemoveSingleRWayJ};

 PUBLIC PROCEDURE GetTripsGroup(LimitTrips: NUMERIC[1]; LimitTime: NUMERIC[3]; RealPass: SCAL[2]): SCAL[250];
  VAR
   Result  : SCAL[250];
   _StopT  : LIKE(SEJobs.StopT);
   _Day    : LIKE(SEJobs.Day);
   _Route  : LIKE(SEJobs.Route);
   _WJCode : LIKE(SEJobs.WJCode);
   _Modif  : LIKE(SEJobs.Modif);
   HasCP   : SCAL[2];
 BEGIN
  SETZERO(Result, HasCP);
  IF (LimitTrips >= 99) & P_Route.HasActualRoutePro(SEJobs.Route, RWayS.Date, P_Route.P_IncomeDetail) THEN
   LimitTrips:=L_Prop.GetProValueAsScal(P_Route.GetRouteProPool(P_Route.P_IncomeDetail), RoutePro.Value) + 1;
   IF LimitTrips = 3(*2  ३*) THEN
    LimitTrips:=4;
   END;
   IF SEJobs.Dir = dir_Backward THEN
    LimitTrips:=1;
   END
  END;
  REPEAT
   DEC(LimitTrips);
   INC(Result);
   _StopT   := SEJobs.StopT;
   _Day     := SEJobs.Day;
   _Route   := SEJobs.Route;
   _Modif   := SEJobs.Modif;
   _WJCode  := SEJobs.WJCode;
   IF RealPass THEN
    IF L_SCAD.E_RWayCPLevel(RWayS.Date) THEN
     L_SCAD.RWayCPForTrip(HasCP);
    END;
   END;
  UNTIL ~NEXT(SEJobs) | (LimitTrips <= 0) | HasCP |
        (LimitTime < FullEndTime(SEJobs.Day, SEJobs.StartT, SEJobs.StopT)) |
        (_Day    # SEJobs.Day)   | (_StopT # SEJobs.StartT) | (_Route  # SEJobs.Route) |
        (_Modif # SEJobs.Modif)  | (_WJCode # SEJobs.WJCode);
  IF OCCURE(SEJobs) THEN
   IF PREV(SEJobs) & (LimitTime < FullEndTime(SEJobs.Day, SEJobs.StartT, SEJobs.StopT)) THEN
    DEC(Result);
    PREV(SEJobs);
   END;
  ELSE
   LAST(SEJobs);
  END;
  RETURN Result;
 END {GetTripsGroup};

 PUBLIC PROCEDURE GetStopName(trgStop: LIKE(Stop.Stop)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SAVE(Stop);
  SEARCH(Stop, Stop, , trgStop);
  IF ~!Stop.NameSchd THEN
   Result:=Stop.NameSchd;
  ELSE
   Result:=Stop.Name;
  END;
  RESTORE(Stop);
  RETURN Result;
 END {GetStopName};

 PUBLIC PROCEDURE GetTripMovingTime(): NUMERIC[0];
  VAR
   RtMTim: NUMERIC[0];
 BEGIN
  CONFORM(SEJobs, RoutMod);
  IF SELECT(SEJMStop, Trip, SEJobs.Trip) THEN
   IF SEJobs.Dir = RoutMod.Dir THEN
    LAST(SEJMStop);
   END;
   RtMTim:=SEJMStop.ATim;
  ELSE
   RtMTim:=RoutMod.Tim[SEJobs.RtMVer];
  END;
  IF RtMTim = 0 THEN
   RtMTim:=(SEJobs.StopT - SEJobs.StartT) * 60;
  END;
  RETURN RtMTim;
 END {GetTripMovingTime};

 PUBLIC PROCEDURE GetStopCtrlTime_ofCurrentTrip(curStartT: TIME; OnDate: DATE): TIME;
  VAR
   SEJ_RM_Ratio  : FLOAT;
   TripMovingTime: NUMERIC[0];
   curATim       : LIKE(SEJMStop.ATim);
   curDTim       : LIKE(SEJMStop.DTim);
   bySEJMStop    : SCAL[2];
 BEGIN
  IF SELECT(SEJMStop, Trip, SEJobs.Trip) THEN
   IF ~SRCINSEL(SEJMStop, EQ, RtMStop.StopNbr, RtMStop.Stop) THEN
    L_StdFrm.WrongDB(" " + SEJobs.Trip + "   '筥 ६ '." +
                     "||" +
                     " ⠭:  " + RtMStop.StopNbr + ",  ⠭ " + RtMStop.Stop);
   END;
   bySEJMStop:=1;
   curATim:=SEJMStop.ATim;
   curDTim:=SEJMStop.DTim;
   SEJ_RM_Ratio:=1;
  ELSE
   bySEJMStop:=0;
   curATim:=RtMStop.ATim[SEJobs.RtMVer];
   curDTim:=RtMStop.DTim[SEJobs.RtMVer];
   TripMovingTime:=GetTripMovingTime();
   IF E_NeedSEJ_RM_Ratio(OnDate) THEN
    SEJ_RM_Ratio:=(SEJobs.StopT-SEJobs.StartT) * 60 / TripMovingTime;
   ELSE
    SEJ_RM_Ratio:=1;
   END;
  END;
  SAVE(RtMStop);
  CONFORM(SEJobs, RoutMod);
  IF SEJobs.Dir = RoutMod.Dir THEN
   NEXT(RtMStop);
  ELSE
   PREV(RtMStop);
  END;
  IF ~OCCURE(RtMStop) THEN
   DEC(curATim, curDTim);
  END;
  RESTORE(RtMStop);
  IF L_SCAD.EqualDir() | bySEJMStop THEN
   RETURN curStartT + curATim * SEJ_RM_Ratio / 60;
  ELSE
   RETURN curStartT + (TripMovingTime - curATim) * SEJ_RM_Ratio / 60;
  END;
 END {GetStopCtrlTime_ofCurrentTrip};

 PUBLIC PROCEDURE GetStopCtrlTime_ofCurSEJobs(OnDate: DATE): TIME;
  VAR
   Result: TIME;
 BEGIN
  Result:=GetStopCtrlTime_ofCurrentTrip(SEJobs.StartT, OnDate);
  IF FullEndTime(1, SEJobs.StartT, Result) > FullEndTime(1, SEJobs.StartT, SEJobs.StopT) THEN
   L_StdFrm.RedInform("୮ ଫ ३ " + SEJobs.Trip + "." +
                      "|" +
                      "|६ ਡ  ⠭ " + RtMStop.Stop + " - " + L_DatTim.TimeStr(Result) +
                      "|६ 砭 ३           - " + L_DatTim.TimeStr(SEJobs.StopT));
  END;
  RETURN Result;
 END {GetStopCtrlTime_ofCurSEJobs};

 PUBLIC PROCEDURE MayDecrRWStatus(trgAction: L_XDoc.tAction);
  VAR
   i             : NUMERIC[0];
   trgXDocId     : L_XDoc.tXDocId;
   DependentMDocs: L_XDoc.tXDocCollection;
 BEGIN
  DependentMDocs:=L_XDoc.GetAllDependentXDC(L_XDoc.curXDocId(L_XDoc.xdt_RWayS));
  i             :=0;
  LOOP
   trgXDocId:=L_XDoc.xdc_Item(DependentMDocs, i);
   IF !trgXDocId THEN
    EXIT;
   END;
   L_XDoc.PositionOnXDoc(trgXDocId);

   IF    !trgAction THEN
    L_General.Error(" ' ' 饭,|..   " + RWayS.RWayS + " 뫠 㬥, ਬ, " + L_XDoc.XDocStr(trgXDocId));
   ELSIF L_XDoc.ExtractXDocType(trgXDocId) = L_XDoc.xdt_MDoc THEN
    L_General.Assert(MDoc.Status = L_MDoc.st_Canceled,
                     " '"+L_Str.PoolItem(L_XDoc.action_Pool, trgAction)+"' 饭,|..   " + RWayS.RWayS + " 뫨 饭 ਠ 業 (" + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) + ")");
   END;
   INC(i);
  END; (* LOOP *)
 END {MayDecrRWStatus};

 PUBLIC PROCEDURE ChkTripPermiss(trgStartT, trgStopT : TIME; trgRun: tRun);
  VAR
   curTime: NUMERIC[3];
   curSpeed : NUMERIC[0];
 BEGIN
  curTime:=trgStopT - trgStartT;
  L_General.Assert(curTime # 0, "   த⥫쭮  ६");
  IF (trgStartT > trgStopT) & (curTime > 12) THEN
   L_StdFrm.Choice("誮  ३ 室  ᫥騥 ⪨");
  END;
  IF ((WJMode.RunSel = runsel_None)) & (trgRun > 0) THEN
   L_General.Error("   ஡   ࠡ|"+WJMode.WJCode+" "+WJMode.Name);
  END;
  curSpeed:=trgRun / curTime;
  L_General.Assert(curSpeed <= Route.MaxSpeed, "। ᪮ "+FLDTOSTR(curSpeed)+" /.|" +
                                               "  ⨬  !");
 END {ChkTripPermiss};

 PRIVATE PROCEDURE CheckCurExitOnCurClndDate(): SCAL[4];
  VAR
   Result      : SCAL[4];
   _CWD_ForExit: L_DatTim.tWeekday;
   trgExit     : LIKE(StExit.Exit);
   D           : DATE;
 BEGIN
  Result :=exvld_Active;
  trgExit:=StExit.Exit;
  D      :=Calendar.Date;
  IF    D < StExit.FromD THEN
   Result:=exvld_NoBegin;
  ELSIF ~!StExit.UpDate & (D >= StExit.UpDate) THEN
   Result:=exvld_Retired;
  ELSIF StExit.ActivKnd = seak_OnDays THEN
   IF StExit.ClndAppl = seca_Fact THEN
    _CWD_ForExit:=L_DatTim.WEEKDAY(D);
   ELSE
    _CWD_ForExit:=CWD_ForExit(L_APtm.wdk_toWay, trgExit);
   END;
   IF ~StExit.OnDays[_CWD_ForExit] THEN
    Result:=exvld_NoOnDay;
   END;
  ELSIF StExit.ActivKnd = seak_EveryOtherDay THEN
   IF Math.Mod(D - StExit.FromD, 2) # 0 THEN
    Result:=exvld_NoOnDay;
   END;
  ELSE
   L_General.CallUs(0);
  END;
  RETURN Result;
 END {CheckCurExitOnCurClndDate};

 PUBLIC PROCEDURE _CheckExitOnDate(trgExit: LIKE(StExit.Exit); D: DATE): SCAL[4];
  VAR
   Result: SCAL[4];
 BEGIN
  SAVE(StExit);
  SAVE(Calendar);
  PositionOnStExit(trgExit);
  L_General.Assert(SEARCH(Calendar, Date, D), "   ᠭ  "+L_DatTim.DateStr(D));
  Result:=CheckCurExitOnCurClndDate();
  RESTORE(Calendar);
  RESTORE(StExit);
  RETURN Result;
 END {_CheckExitOnDate};

 PUBLIC PROCEDURE StExitActiveOnDate(_Exit: LIKE(StExit.Exit); _Date: DATE): SCAL[2];
 BEGIN
  RETURN (_CheckExitOnDate(_Exit, _Date) = exvld_Active);
 END {StExitActiveOnDate};

 PUBLIC PROCEDURE CurExitActiveOnCurClndDate(): SCAL[2];
 BEGIN
  RETURN (CheckCurExitOnCurClndDate() = exvld_Active);
 END {CurExitActiveOnCurClndDate};

 PUBLIC PROCEDURE CheckExitOnDate(_Exit: LIKE(StExit.Exit); _Date: DATE; ForExit: SCAL[2]);
  VAR
   Result: SCAL[4];
 BEGIN
  Result:=_CheckExitOnDate(_Exit, _Date);
  IF Result # exvld_Active THEN
   SEARCH(Calendar, Date, , _Date);
   L_General.Error(L_Str.PoolItem(" 室, |室", ForExit) + " " +
                   L_Str.PoolItem(" | |  | ", Result) + " " +
                   L_DatTim.DateStr(_Date) + ", " +
                   L_DatTim.WeekDayStr(CWD_ForExit(L_APtm.wdk_toWay, _Exit), 3));
  END;
 END {CheckExitOnDate};

 PUBLIC PROCEDURE StExitOnDaysAsStr(): STRING[];
 BEGIN
  IF    StExit.ActivKnd = seak_OnDays THEN
   RETURN L_Str.PoolItem("  |", StExit.OnDays[0])+" "+
          L_Str.PoolItem("  |", StExit.OnDays[1])+" "+
          L_Str.PoolItem("  |", StExit.OnDays[2])+" "+
          L_Str.PoolItem("  |", StExit.OnDays[3])+" "+
          L_Str.PoolItem("  |", StExit.OnDays[4])+" "+
          L_Str.PoolItem("  |", StExit.OnDays[5])+" "+
          L_Str.PoolItem("  |", StExit.OnDays[6])+" "+
          L_Str.PoolItem("  |", StExit.OnDays[7]);
  ELSIF StExit.ActivKnd = seak_EveryOtherDay THEN
   RETURN "१ ";
  ELSE
   L_General.CallUs(0);
  END;
 END {StExitOnDaysAsStr};

 PRIVATE PROCEDURE ObtainRWayJP(_RWJPro: LIKE(RWayJP.RWJPro);
                                _Source: LIKE(RWayJP.Source));
 BEGIN
  SEARCH(RWJPro, RWJPro, , _RWJPro);
  IF ADD(RWayJP, RWayS, RWayJ.RWayS, RWayJ.Day, RWayJ.StartT, _RWJPro) THEN
   L_General.RoughAssert(RWayJP.Source = _Source,
                         "⨬ 稥  ⥫  ࠧ묨 '筨'"+
                         "| " + RWayJ.Day + " " + L_DatTim.TimeStr(RWayJ.StartT) + " ⥫ " + _RWJPro);
  ELSE
   RWayJP.Value :=0;
   RWayJP.Source:=_Source;
   REPLACE(RWayJP);
  END;
 END {ObtainRWayJP};

 PUBLIC PROCEDURE SetRWayJP(_RWJPro: LIKE(RWayJP.RWJPro);
                            _Value : LIKE(RWayJP.Value);
                            _Source: LIKE(RWayJP.Source));
 BEGIN
  ObtainRWayJP(_RWJPro, _Source);
  RWayJP.Value:=_Value;
  REPLACE(RWayJP);
 END {SetRWayJP};

 PUBLIC PROCEDURE SaveRWayJP(_Store : NUMERIC[0];
                             _RWJPro: LIKE(RWayJP.RWJPro);
                             _Value : LIKE(RWayJP.Value);
                             _Source: LIKE(RWayJP.Source));
 BEGIN
  IF _Value # 0 THEN (* ??? *)
   SAVE(RWayJP);
   ObtainRWayJP(_RWJPro, _Source);
   INC(RWayJP.Value, _Store*_Value);
   REPLACE(RWayJP);
   IF (_Store = -1) & (RWayJP.Value = 0) THEN
    REMOVE(RWayJP);
   END;
   RESTORE(RWayJP);
  END;
 END {SaveRWayJP};

 PUBLIC PROCEDURE RemoveRWayJP(_RWJPro: LIKE(RWayJP.RWJPro); _Source: LIKE(RWayJP.Source));
 BEGIN
  IF SEARCH(RWayJP, RWayS, RWayJ.RWayS, RWayJ.Day, RWayJ.StartT, _RWJPro) THEN
   L_General.Assert(RWayJP.Source = _Source, "⨬ 㤠 ⥫  㦨 筨");
   REMOVE(RWayJP);
  END;
 END {RemoveRWayJP};

 PUBLIC PROCEDURE MemToStr(VAR __Mem: LIKE(Monthly.Proof); _RoundMth: LIKE(MtyIdx.RoundMth); D: DATE): STRING[250];
  VAR _Format: STRING[2];
 BEGIN
  IF !__Mem THEN
   RETURN "";
  ELSIF _RoundMth=4(*죨*) THEN
   RETURN L_Money.MoneyToStr(D, "", __Mem);
  ELSE
   _Format:=_RoundMth;
   IF _RoundMth > 0 THEN
   _Format:=_RoundMth+".";
   END;
   RETURN FLDTOSTR(__Mem, _Format, 0);
  END;
 END {MemToStr};

 PUBLIC PROCEDURE DefMt_Code(_ProtInNbr  : SCAL[8];
                             _OnDate     : DATE;
                             VAR _Mt_Code: LIKE(MtyIdx.ProtIn[0])[];
                             VAR _Mem_Idx: LIKE(MCList.MCode) []);
  VAR
   i       : NUMERIC[0];
 BEGIN
  SETEMPTY(_Mt_Code, _Mem_Idx);
  SETZERO(i);
  SELECT(MtyIdx, MtyIdx);
  WHILE OCCURE(MtyIdx) DO
   IF ~!MtyIdx.ProtIn[_ProtInNbr] &
      L_DatTim.IsActive(L_DatTim.Per(_OnDate), MtyIdx.Begin, MtyIdx.Till) THEN
    L_General.Assert(i <= HIGH(_Mt_Code), "⨬   "+L_Str.IntStr(HIGH(_Mt_Code)+1)+
           " ⥫ 筮 ⥫"+
           "|   '室  ⮪  ﬨ #"+L_Str.IntStr(_ProtInNbr+1)+"'");
    _Mt_Code[i]:=MtyIdx.ProtIn[0];
    _Mem_Idx[MtyIdx.MtyIdx]:=i;
    INC(i);
   END;
   NEXT(MtyIdx);
  END; (* WHILE OCCURE(MtyIdx) ... *)
 END {DefMt_Code};

 PUBLIC PROCEDURE RunBySM(): NUMERIC[0];
  CONST _SpdSize ="0 10 100 1000 10000 100000 1000000 10000000";
  VAR MaxSM: NUMERIC[0];
 BEGIN
  L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
  MaxSM:=STRTOFLD(Str.Item(_SpdSize, " ", Mark.SpdSize), NUMERIC);
  L_General.Assert(RWayS.SMBef < MaxSM, "  륧 ॢ蠥 ⨬ 祭");
  L_General.Assert(RWayS.SMAft < MaxSM, "   ॢ蠥 ⨬ 祭");
  RETURN (RWayS.SMAft-RWayS.SMBef+MaxSM) MOD MaxSM;
 END {RunBySM};

 PUBLIC PROCEDURE GetRWJPByType(_Type: LIKE(RWJPro.Type)): LIKE(RWayJP.Value);
  VAR
   _Value  : LIKE(RWayJP.Value);
 BEGIN
  _Value:=0;
  CONFORM(RWayJ, RWayJP);
  WHILE OCCURE(RWayJP) DO
   CONFORM(RWayJP, RWJPro);
   IF RWJPro.Type = _Type THEN
    INC(_Value, RWayJP.Value);
   END;
   NEXT(RWayJP);
  END; (* WHILE OCCURE(RWayJP)... *)
  RETURN _Value;
 END {GetRWJPByType};

 PUBLIC PROCEDURE GetRWJPByCode(_RWJPro: LIKE(RWayJP.RWJPro)): LIKE(RWayJP.Value);
  VAR
   _Value  : LIKE(RWayJP.Value);
 BEGIN
  _Value:=0;
  SAVE(RWayJP);
  IF SEARCH(RWayJP, RWayS, RWayJ.RWayS, RWayJ.Day, RWayJ.StartT, _RWJPro) THEN
   _Value:=RWayJP.Value;
  END;
  RESTORE(RWayJP);
  RETURN _Value;
 END {GetRWJPByCode};

 PUBLIC PROCEDURE RWayJVoidTime(_Exit: LIKE(StExit.Exit)): NUMERIC[3];
  VAR
   Result: NUMERIC[3];
 BEGIN
  Result:=0;
  SAVE(StExit);
  PositionOnStExit(_Exit);
  IF StExit.Strict = ExitStrict_Reg THEN
   SAVE(SEJobs);
   SAVE(WJMode);
   SETSEL(SEJobs, Exit, _Exit);
   SRCINSEL(SEJobs, LE, , RWayJ.Day, RWayJ.StartT);
   WHILE OCCURE(SEJobs) DO
    CONFORM(SEJobs, WJMode);
    IF (WJMode.WJType = WJType_Void) & (WJMode.RunSel = runsel_None) THEN
     INC(Result, _TimeInt(FullBegTime(RWayJ.Day, RWayJ.StartT),
                          FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT),
                          FullBegTime(SEJobs.Day, SEJobs.StartT),
                          FullEndTime(SEJobs.Day, SEJobs.StartT, SEJobs.StopT)));
    END;
    NEXT(SEJobs);
   END; (* WHILE OCCURE(SEJobs) ... *)
   RESTORE(SEJobs);
   RESTORE(WJMode);
  END;
  RESTORE(StExit);
  RETURN Result;
 END {RWayJVoidTime};

 PRIVATE PROCEDURE GetMarkFuelNorm_ByTemp(trgDate    : DATE;
                                          trgProperty: LIKE(Property.Property);
                                          trgTempIdx : SCAL[2]): NUMERIC[3];
  VAR
   Temp: NUMERIC[2][2];
 BEGIN
  P_OwnData.Temperature(trgDate, Temp);
  IF (trgTempIdx = 1) & !Temp[trgTempIdx] THEN
   trgTempIdx:=0;
  END;
  RETURN P_Mark.Get_AnyMarkFuelNorm_ByTemp(Mark.Mark, trgDate, trgProperty, Temp[trgTempIdx]);
 END {GetMarkFuelNorm_ByTemp};

 PUBLIC TYPE
  tNorm  = NUMERIC[3];
  tNorms = LIKE(RWayJ.FNorm)[4];

 PUBLIC VAR
  _FCorMove,   _FCorHeat,   _FCorWarm,
  _FConHeat,   _FConWarm,
  _FCarCMove,  _FCarCHeat,  _FCarCWarm,
  _FMarkHeat,  _FMarkWarm,
  _FMarkCMove, _FMarkCHeat, _FMarkCWarm  : NUMERIC[3];
  MarkFNAlFRun,
  MarkFNAlFTim,
  MarkFNConTim,
  MarkFnConRepr,
  MarkFNConRun: tFuelNorms;

 PUBLIC PROCEDURE _PrepareFNorm(_BoxNbr: LIKE(RWayS.BoxNbr); _Date: LIKE(RWayS.Date));
  VAR
   _MyFirm : LIKE(MyFirm.MyFirm);
   FuelCorr: P_Car.tFuelCorr;
 BEGIN
  _MyFirm   :=L_Car.GetCarMyFirm(_BoxNbr, _Date);
  _FCorMove :=P_OwnData.FCorMove(_Date, _MyFirm);
  _FMarkHeat:=GetMarkFuelNorm_ByTemp(_Date, P_Mark.P_FMarkHeat, 0);
  _FCorHeat :=P_OwnData.FCorHeat(_Date, _MyFirm);
  _FConHeat :=_FMarkHeat * _FCorHeat;
  _FMarkWarm:=GetMarkFuelNorm_ByTemp(_Date, P_Mark.P_FMarkWarm, 1);
  _FCorWarm :=P_OwnData.FCorWarm(_Date, _MyFirm);
  _FConWarm :=_FMarkWarm * _FCorWarm;
  IF P_Car.HasActualCarPro(_BoxNbr, _Date, P_Car.P_CarFuelCor) THEN
   P_Car.Decode_CarFuelCor(CarPro.Value, FuelCorr);
   _FCarCMove:=FuelCorr[0];
   _FCarCHeat:=FuelCorr[1];
   _FCarCWarm:=FuelCorr[2];
  ELSE
   _FCarCMove:=1;
   _FCarCHeat:=1;
   _FCarCWarm:=1;
  END;
  SAVE(Mark);
  L_Car.AccessMark(_BoxNbr, _Date);
  _FMarkCMove  :=P_Mark.Get_MarkFuelCor_Move(Mark.Mark, _Date);
  _FMarkCHeat  :=P_Mark.Get_MarkFuelCor_Heat(Mark.Mark, _Date);
  _FMarkCWarm  :=P_Mark.Get_MarkFuelCor_Warm(Mark.Mark, _Date);
  MarkFNAlFTim :=P_Mark.GetP_AlFTim(Mark.Mark, _Date);
  MarkFNAlFRun :=P_Mark.GetP_AlFRun(Mark.Mark, _Date);
  MarkFNConTim :=P_Mark.GetP_FConTim(Mark.Mark, _Date);
  MarkFNConRun :=P_Mark.GetP_FConRun(Mark.Mark, _Date);
  MarkFnConRepr:=P_Mark.GetP_FConRepr(Mark.Mark, _Date);
  RESTORE(Mark);
 END {_PrepareFNorm};

 PUBLIC PROCEDURE PrepareFNorm();
 BEGIN
  _PrepareFNorm(RWayS.BoxNbr, RWayS.Date);
 END {PrepareFNorm};

 PUBLIC PROCEDURE E_FuelMoveNormAsCfcSum(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.FuelMoveNormCfcAsSum), 0);
 END {E_FuelMoveNormAsCfcSum};

 PRIVATE PROCEDURE E_CorrFN_LocalCause(D: DATE): NUMERIC[3];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.CorrFN_LocalCause), 0);
 END {E_CorrFN_LocalCause};

 PUBLIC PROCEDURE E_ApplyCorrectionToBaseFuelNorm(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.ApplyCorrectionToBaseFuelNorm), ~L_APtm.IsMTA());
 END {E_ApplyCorrectionToBaseFuelNorm};

 PRIVATE PROCEDURE E_CorrToReprNorm(D: DATE): FLOAT;
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.CorrToReprNorm), 1);
 END {E_CorrToReprNorm};

 PUBLIC PROCEDURE extCalcFN(    _Date          : DATE;
                                _Time          : NUMERIC[3];
                                _Run           : NUMERIC[2];
                                _WithDp        : SCAL[2];
                            VAR PureNormAt100km: tNorm;
                            VAR Norms          : tNorms;
                            VAR _FCM           : NUMERIC[3];
                            VAR _FRouteCMove   : NUMERIC[3];
                            VAR CorFNAgeCar    : NUMERIC[3];
                                ForRWayS       : SCAL[2]);
  VAR
   at100km         : LIKE(RWayJ.FNorm);
   _FMarkRouteCMove: NUMERIC[3];
 BEGIN
  IF L_Fuel.FlAcntLev(_Date) = L_Fuel.fal_None THEN
   SETZERO(PureNormAt100km, Norms, _FCM, _FRouteCMove, CorFNAgeCar);
   RETURN;
  END;
  _FRouteCMove:=1;
  SETZERO(PureNormAt100km, Norms, CorFNAgeCar);
  IF (Quality.Type > QualType_Annul) & (SEJobs.Trip # E_TripForFuelChainBreak(_Date)) THEN
   IF _Run # 0 THEN
    PureNormAt100km:=E_InitialFuelNormAt100km(_Date);
    IF !PureNormAt100km THEN
     IF E_GettingRouteFuelNormManner(_Date) = 0 THEN
      SETSEL(MRFlNorm, Mark, Mark.Mark, Route.Route);
      IF SRCINSEL(MRFlNorm, LE, _Date) & (_Date < MRFlNorm.Till) THEN
       PureNormAt100km:=MRFlNorm.Norm;
      END;
     ELSE
      IF E_FuelMoveNormAsCfcSum(_Date) THEN
       PureNormAt100km:=MarkFNAlFRun;
      ELSE
       IF P_Route.HasActualRoutePro(Route.Route, _Date, P_Route.P_FuelNormCoef) THEN
        PureNormAt100km:=MarkFNAlFRun * (1 + STRTOFLD(RoutePro.Value, NUMERIC)/100);
       END;
      END;
     END;
     IF !PureNormAt100km THEN
      IF ~ForRWayS | (RWayS.Status = rwsStat_Rated) THEN
       L_General.Error("  ⮯. ઠ "+Mark.Mark+",  "+Route.Route);
      ELSE
       PureNormAt100km:=Math.Max(Math.Max(MarkFNAlFRun, MarkFNConRun), 10);
      END;
     END;
    END;
   END;
   _FCM :=_FCorMove - 1;
   IF _WithDp THEN  {  ⠦ }
    INC(_FCM, E_CorrFN_WithDp(_Date));
   END;
   CorFNAgeCar:=E_CorrFN_LocalCause(_Date);
   INC(_FCM, CorFNAgeCar);
   IF E_FuelMoveNormAsCfcSum(_Date) THEN
    L_General.CallUs((E_GettingRouteFuelNormManner(_Date) # 0) & ~E_ApplyCorrectionToBaseFuelNorm(_Date));
    IF P_Route.HasActualRoutePro(Route.Route, _Date, P_Route.P_FuelNormCoef) THEN
     _FRouteCMove:=STRTOFLD(RoutePro.Value, NUMERIC)/100;
    ELSE
     _FRouteCMove:=0;
    END;
    INC(_FRouteCMove, 1);
    _FMarkRouteCMove:=P_Mark.Get_MarkFuelCor_ByRoute(Mark.Mark, _Date, Route.Route);
    _FRouteCMove:=_FRouteCMove * _FMarkRouteCMove;
    at100km :=PureNormAt100km;
    Norms[0]:=WJMode.FCorMove*((1 + _FCM  +
                                (_FRouteCMove-1)+
                                (RoutMod.FCor-1)+
                                (_FCarCMove  -1)+
                                (_FMarkCMove -1))*
                (                    at100km*_Run/100+
                (MarkFNAlFTim + MarkFNConTim*_FCM)*_Time));
   ELSE
    IF E_ApplyCorrectionToBaseFuelNorm(_Date) THEN
     at100km:=PureNormAt100km + MarkFNConRun * _FCM;
    ELSE
     at100km:=PureNormAt100km*(1 + _FCM);
    END;
    Norms[0]:=RoutMod.FCor * WJMode.FCorMove * _FCarCMove * _FMarkCMove *
               (at100km * _Run / 100 + (MarkFNAlFTim + MarkFNConTim * _FCM) * _Time);
   END; (* IF E_FuelMoveNormAsCfcSum(_Date) ...*)
   Norms[1] :=WJMode.FCorHeat * _FConHeat * _FCarCHeat * _FMarkCHeat * _Time;
   Norms[2] :=(WJMode.FCorWarm * _FConWarm +
               MarkFnConRepr * WJMode.FCorRepr * E_CorrToReprNorm(_Date))*_FCarCWarm *_FMarkCWarm *_Time;
   IF ForRWayS & (RWayS.Status=rwsStat_Rated) THEN
    Norms[3]:=P_Mark.GetP_FMarkPUWork(Mark.Mark, _Date, _Run);
   END;
  END; (* IF (Quality.Type > QualType_Annul) & (SEJobs.Trip # E_TripForFuelChainBreak(_Date)) ... *)
 END {extCalcFN};

 PRIVATE PROCEDURE GetFN(Norms: tNorms): LIKE(RWayJ.FNorm);
 BEGIN
  IF Mark.IsolHeat THEN
   RETURN Norms[0]+Norms[2]+Norms[3];
  ELSE
   RETURN Norms[0]+Norms[1]+Norms[2]+Norms[3];
  END;
 END {GetFN};

 PUBLIC PROCEDURE CalcFN(_Date   : DATE;
                         _Time   : NUMERIC[3];
                         _Run    : NUMERIC[2];
                         _WithDp : SCAL[2];
                         ForRWayS: SCAL[2]): LIKE(RWayJ.FNorm);
  VAR
   Norms : tNorms;
   dummy1: tNorm;
   dummy2,
   dummy3,
   dummy4: NUMERIC[3];
 BEGIN
  extCalcFN(_Date, _Time, _Run, _WithDp, dummy1, Norms, dummy2, dummy3, dummy4, ForRWayS);
  RETURN GetFN(Norms);
 END {CalcFN};

 PUBLIC PROCEDURE _TimeInt(B, E, B1, E1: FLOAT): FLOAT;
 BEGIN
  IF B1 > B THEN
   B:=B1;
  END;
  IF E1 < E THEN
   E:=E1;
  END;
  IF E >= B THEN
   RETURN E-B;
  ELSE
   RETURN 0;
  END;
 END {_TimeInt};

 PUBLIC PROCEDURE _IsWith(B, E: NUMERIC[3]; _Who: LIKE(WayLMen.Who)): SCAL[2];
 BEGIN
  IF SELECT(WayLMen, RWayS, RWayS.RWayS, _Who) & ~E_IsGuardIdleExit(RWayS.Date, RWayS.Exit) THEN
   WHILE OCCURE(WayLMen) DO
    IF _TimeInt(B, E, FullBegTime(WayLMen.Day, WayLMen.StartT), FullEndTime(WayLMen.Day, WayLMen.StartT, WayLMen.StopT))>0 THEN
     RETURN 1;
    END;
    NEXT(WayLMen);
   END;
  END;
  RETURN 0;
 END {_IsWith};

 PUBLIC PROCEDURE IsFirstWLMRecByTckRcS(): SCAL[2];
  CONST
   MaxDelta = 0.25;
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(TckRcS);
  SAVE(TckRcJ);
  Result:=0;
  SELECT(TckRcS, TSN, , WayLMen.TSN, RWayS.Date);
  WHILE OCCURE(TckRcS) & ~Result DO
   IF SELECT(TckRcJ, TckRcS, TckRcS.TckRcS) &
      (TckRcJ.asRWayS = WayLMen.RWayS) &
      (FullBegTime(WayLMen.Day, WayLMen.StartT) - MaxDelta <= FullBegTime(TckRcJ.Day, TckRcJ.StartT)) &
      (FullBegTime(TckRcJ.Day, TckRcJ.StartT) <= FullEndTime(WayLMen.Day, WayLMen.StartT, WayLMen.StopT) + MaxDelta) THEN
    Result:=1;
   END;
   NEXT(TckRcS);
  END; (* WHILE OCCURE(TckRcS) ... *)
  RESTORE(TckRcS);
  RESTORE(TckRcJ);
  RETURN Result;
 END {IsFirstWLMRecByTckRcS};

 PUBLIC PROCEDURE IsFirstWLMRec(OnDay: SCAL[2]): SCAL[2];
  VAR
   fbt: FLOAT;
   who: LIKE(WayLMen.Who);
   tsn: LIKE(WayLMen.TSN);
 BEGIN
  SAVE(WayLMen);
  IF OnDay THEN
   who:=WayLMen.Who;
   fbt:=FullBegTime(WayLMen.Day, WayLMen.StartT);
   SELECT(WayLMen, TSN, , WayLMen.TSN, WayLMen.RWayDate);
   WHILE OCCURE(WayLMen) DO
    IF (WayLMen.Who = who) &
       (fbt > FullBegTime(WayLMen.Day, WayLMen.StartT)) THEN
     RESTORE(WayLMen);
     RETURN 0;
    END;
    NEXT(WayLMen);
   END; (* WHILE OCCURE(WayLMen) ... *)
  ELSE
   CHANGESEL(WayLMen, RWayS, , WayLMen.RWayS, WayLMen.Who);
   tsn:=WayLMen.TSN;
   PREV(WayLMen);
   WHILE OCCURE(WayLMen) DO
    IF WayLMen.TSN = tsn THEN
     RESTORE(WayLMen);
     RETURN 0;
    END;
    PREV(WayLMen);
   END; (* WHILE OCCURE(WayLMen) ... *)
  END;
  RESTORE(WayLMen);
  RETURN 1;
 END {IsFirstWLMRec};

 PRIVATE PROCEDURE intGetMarkG(trgMark: LIKE(Mark.Mark); trgMarkGT: LIKE(MarkG.MarkGT); Strong: SCAL[2]): LIKE(MarkG.MarkG);
  VAR
   trgMarkGTName: STRING[];
 BEGIN
  IF SELECT(MarkGM, MMGT, trgMark, trgMarkGT) THEN
   RETURN MarkGM.MarkG;
  ELSIF ~Strong THEN
   RETURN EMPTYOF(MarkG.MarkG);
  ELSE
   IF SEARCH(MarkGT, MarkGT, trgMarkGT) THEN
    trgMarkGTName:=MarkGT.Name;
   ELSE
    trgMarkGTName:="";
   END;
   L_StdFrm.WrongDB("ઠ "+ trgMark + "  祭    㯯 |" +
                    trgMarkGT + " " + trgMarkGTName);
  END;
 END {intGetMarkG};

 PUBLIC PROCEDURE GetMarkG_Soft(trgMark: LIKE(Mark.Mark); trgMarkGT: LIKE(MarkG.MarkGT)): LIKE(MarkG.MarkG);
 BEGIN
  RETURN intGetMarkG(trgMark, trgMarkGT, 0);
 END {GetMarkG_Soft};

 PUBLIC PROCEDURE StandOnMarkG_Soft(trgMark: LIKE(Mark.Mark); trgMarkGT: LIKE(MarkG.MarkGT)): SCAL[2];
  VAR
   trgMarkG: LIKE(MarkG.MarkG);
 BEGIN
  trgMarkG:=GetMarkG_Soft(trgMark, trgMarkGT);
  IF ~!trgMarkG THEN
   SEARCH(MarkG, MarkG, , trgMarkG);
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {StandOnMarkG_Soft};

 PUBLIC PROCEDURE GetMarkG(trgMark: LIKE(Mark.Mark); trgMarkGT: LIKE(MarkG.MarkGT)): LIKE(MarkG.MarkG);
 BEGIN
  RETURN intGetMarkG(trgMark, trgMarkGT, 1);
 END {GetMarkG};

 PUBLIC PROCEDURE StandOnMarkG(trgMark: LIKE(Mark.Mark); trgMarkGT: LIKE(MarkG.MarkGT));
 BEGIN
  SEARCH(MarkG, MarkG, , GetMarkG(trgMark, trgMarkGT));
 END {StandOnMarkG};

 PUBLIC PROCEDURE CorrPlanIncInCongestion(_PlTim: NUMERIC[3];
                                          _Fact: LIKE(RWayJ.Fact);
                                          _Ratio: NUMERIC[3];  (*稭 ⪫*)
                                          _Type: SCAL[2];      (*⨯:0-ࠧ,1-⭮襭*)
                                          VAR _Plan: NUMERIC[3]);
  VAR
   TrpPlTm: NUMERIC[3];
 BEGIN
  L_General.Assert(ACCESS(SEJobs) & (SEJobs.Route = Route.Route),
                   "- ࠭.  ࠡ稪!");
  IF _Plan > 0 THEN
   CONFORM(SEJobs, StExit);
   IF StExit.Strict = 2 THEN
    SAVE(SEJobs);
    CHANGESEL(SEJobs, Exit, , SEJobs.Exit);
    SETZERO(TrpPlTm);
    WHILE OCCURE(SEJobs) & (_Fact >= 1) DO
     CONFORM(SEJobs, WJMode);
     L_General.Assert((WJMode.IncSel > 0) & (SEJobs.Route = Route.Route),
                      "୮ ⠪஢ 㯯 ३ᮢ. 訡 1");
     INC(TrpPlTm, SEJobs.StopT-SEJobs.StartT);
     DEC(_Fact);
     NEXT(SEJobs);
    END;
    L_General.Assert(_Fact <= 1,
                     "୮ ⠪஢ 㯯 ३ᮢ. 訡 2");
    IF ((_Type = 0) & (_PlTim-TrpPlTm >= _Ratio))|
        (_Type = 1) & (_PlTim >= (TrpPlTm * _Ratio)) THEN
     _Plan:=_Plan*(TrpPlTm/_PlTim);
    END;
    RESTORE(SEJobs);
   END; (* IF StExit.Strict ... *)
  END; (* IF _Plan > 0 *)
 END {CorrPlanIncInCongestion};

 PUBLIC TYPE
  tPVArr = NUMERIC[0][2];

 PUBLIC PROCEDURE E_DefinePasVolSit(D: DATE; trgPasVol: NUMERIC[0]): NUMERIC[0];
  VAR
   Local : PROC;
   Result: NUMERIC[0];
 BEGIN
  Local:=PROCREF(E_Way.DefinePasVolSit);
  IF !Local THEN
   L_General.SetupRequired();
  END;
  Result:=Local(D, trgPasVol);
  IF !Result THEN
   L_General.InformUs("祭 ⠫ ⨬  ⨬  ᨤ "+L_Str.IntStr(trgPasVol));
  END;
  RETURN Result;
 END {E_DefinePasVolSit};

 PUBLIC PROCEDURE E_DefinePasVol(D: DATE; trgPasVol: NUMERIC[0]): NUMERIC[0];
  VAR
   Local : PROC;
   Result: NUMERIC[0];
 BEGIN
  Local:=PROCREF(E_Way.DefinePasVol);
  IF !Local THEN
   L_General.SetupRequired();
  END;
  Result:=Local(D, trgPasVol);
  IF !Result THEN
   L_General.InformUs("祭 ⠫ ⨬  ⨬ "+L_Str.IntStr(trgPasVol));
  END;
  RETURN Result;
 END {E_DefinePasVol};

 PUBLIC PROCEDURE IncPlanRouteIP(_Cnd: tIncPlanCondition; _WDWay: L_DatTim.tWeekday; _PVLimArr: tPVArr; _Date: DATE): LIKE(RouteIPL.Plan[0]);
  VAR                       
   _IncP   : LIKE(RouteIPL.Plan[0]);
   _ElstcCf: LIKE(RouteIPL.ElstcCf[0]);
   _ElstRate: FLOAT;
 BEGIN
  _IncP:=RouteIPL.Plan[_WDWay];
  IF E_NeedCrankyWayIPLInterpretation(_Date, tcpi_FromRoute) THEN
   _IncP:=_IncP * RouteIPL.Cfc[_WDWay + 8 * E_Way.DefinePasVolCranky(_Date, _PVLimArr[0])] *
          E__IncPlanClientCorr(_Date, _WDWay, _Cnd);
  ELSE
   _ElstcCf:=RouteIPL.ElstcCf[_WDWay];
   SAVE(Route);
   CONFORM(RouteIP, Route);
   IF E_CalcPlIncBySittingPV(_Date) THEN
    _ElstRate:=(1+(E_DefinePasVolSit(_Date, _PVLimArr[1])/E_DefinePasVolSit(_Date, RouteIPL.TemplPV)-1)*_ElstcCf);
   ELSE
    _ElstRate:=(1+(E_DefinePasVol(_Date, _PVLimArr[0])/E_DefinePasVol(_Date, RouteIPL.TemplPV)-1)*_ElstcCf);
   END;
   RESTORE(Route);
   _IncP:=_IncP * _ElstRate *
          E__IncPlanClientCorr(_Date, _WDWay, _Cnd);
  END;
  IF ((RouteIP.RoutCnd = ipc_Guard) & (_Cnd = ipc_Driver)) |
     (L_APWI.E_FillVldPsgPlanFromVldPsgPlanG(_Date) & (_Cnd=E_Way.ipc_TermPlanDrv)) THEN
   _IncP:=_IncP * RouteIPL.SpcCf;
  END;
  IF ((_Cnd=ipc_Guard) | (_Cnd=ipc_TwoGuards)) & E_NeedRound_IncPlan(_Date) THEN
   RETURN Math.Round(_IncP, 1.00);
  ELSE
   RETURN _IncP;
  END;
 END {IncPlanRouteIP};

 PRIVATE PROCEDURE IncPlanExitIP(_Cnd: tIncPlanCondition; _WDWay: L_DatTim.tWeekday; _PVLimArr: tPVArr; _Date: DATE): LIKE(ExitIPL.Plan[0]);
  VAR
   _PVRatio : FLOAT;
   _IncPl   : LIKE(ExitIPL.Plan[0]);
 BEGIN
  L_General.CallUs(OCCURE(StExit) & (StExit.Exit = ExitIPL.Exit));
  L_General.Assert(StExit.OnDays[_WDWay] | (StExit.ActivKnd # seak_OnDays),
                   " ।   窥 (室  ):||     窥 "+L_DatTim.WeekDayStr(_WDWay, 0)+", 室 "+ExitIPL.Exit);
  IF E_NeedCrankyWayIPLInterpretation(_Date, tcpi_FromExit) THEN
   _IncPl:=ExitIPL.Plan[_WDWay] *
           ExitIPL.Cfc[_WDWay + 8 * E_Way.DefinePasVolCranky(_Date, _PVLimArr[0])] *
           E__IncPlanClientCorr(_Date, _WDWay, _Cnd);
  ELSE
   IF E_CalcPlIncBySittingPV(_Date) THEN
    _PVRatio:=E_DefinePasVolSit(_Date, _PVLimArr[1]) /
              E_DefinePasVolSit(_Date, ExitIPL.TemplPV);
   ELSE
    _PVRatio:=E_DefinePasVol(_Date, _PVLimArr[0]) /
              E_DefinePasVol(_Date, ExitIPL.TemplPV);
   END;
   _IncPl:=ExitIPL.Plan[_WDWay] *
           (1+(_PVRatio - 1) * ExitIPL.ElstcCf[_WDWay]) *
           E__IncPlanClientCorr(_Date, _WDWay, _Cnd);
   IF ((ExitIP.Cnd = ipc_Guard) & (_Cnd = ipc_Driver)) |
      (L_APWI.E_FillVldPsgPlanFromVldPsgPlanG(_Date) & (_Cnd=E_Way.ipc_TermPlanDrv)) THEN
    _IncPl:=_IncPl * ExitIPL.SpcCf;
   END;
  END;
  RETURN _IncPl;
 END {IncPlanExitIP};

 PUBLIC PROCEDURE IncPlant_cpi(tcpi      : ttcpi;
                               _WDWay    : L_DatTim.tWeekday;
                               _PasVolArr: tPVArr;
                               _Date     : DATE;
                               _Cnd      : tIncPlanCondition): L_APWI.tPlanIncome;
  VAR
   Proc: PROC;
 BEGIN
  IF tcpi = tcpi_FromExit THEN
   Proc:=PROCREF(IncPlanExitIP);
  ELSE
   Proc:=PROCREF(IncPlanRouteIP);
  END;
  RETURN Proc(_Cnd, _WDWay, _PasVolArr, _Date);
 END {IncPlant_cpi};

 PUBLIC PROCEDURE AccessCurRouteIP(D     : DATE;
                                   trgCnd: tIncPlanCondition): SCAL[2];
 BEGIN
  IF (trgCnd = ipc_Driver) & E_FillIncPlanFromIncPlanG(D) THEN
   trgCnd:=ipc_Guard;
  END;
  trgCnd:=L_APWI.Conv_IPCForVldPsgPlan(D, trgCnd);
  SETSEL(RouteIP, RouteIP, Route.Route, trgCnd);
  RETURN SRCINSEL(RouteIP, LE, D);
 END {AccessCurRouteIP};

 PUBLIC PROCEDURE _AssertIP(Cond     : SCAL[2];
                            Text     : STRING[];
                            trgCnd   : tIncPlanCondition;
                            D        : LIKE(RWayS.Date);
                            trgStartT: LIKE(RWayJ.StartT));
 BEGIN
  L_General.Assert(Cond,
                   " ⠭   " + Text +
                   "| |" +
                   "(: " + L_DatTim.DateStr(D) +
                   ", ६: " + L_DatTim.TimeStr(trgStartT) +
                   ", ⥫⢠: " + L_Str.PoolItem(E_IPConditionPool(D), trgCnd) +
                   ")");
 END {_AssertIP};

 PUBLIC PROCEDURE AccessCurExitIP(D     : DATE;
                                  trgCnd: tIncPlanCondition): SCAL[2];
 BEGIN
  IF (trgCnd = ipc_Driver) & E_FillIncPlanFromIncPlanG(D) THEN
   trgCnd:=ipc_Guard;
  END;
  trgCnd:=L_APWI.Conv_IPCForVldPsgPlan(D, trgCnd);
  SETSEL(ExitIP, ExitIP, StExit.Exit, trgCnd);
  RETURN SRCINSEL(ExitIP, LE, D);
 END {AccessCurExitIP};

 PUBLIC PROCEDURE GetTypeOfCalcIncPlan(trgCnd   : tIncPlanCondition;
                                       D        : LIKE(RWayS.Date);
                                       trgStartT: LIKE(RWayJ.StartT)): ttcpi;
  VAR
   Result: ttcpi;
 BEGIN
  CONFORM(SEJobs, StExit);
  IF AccessCurExitIP(D, trgCnd) THEN
   IF    ExitIP.Type = ipt_OnRoute THEN
    Result:=tcpi_FromRoute;
   ELSE
    Result:=tcpi_FromExit;
   END;
  ELSE
   _AssertIP(~SELECT(ExitIP, ExitIP, StExit.Exit, trgCnd), "室 " + StExit.Exit, trgCnd, D, trgStartT);
   Result:=tcpi_FromRoute;
  END;
  RETURN Result;
 END {GetTypeOfCalcIncPlan};

 PUBLIC PROCEDURE CalcIncPlanIsCancelled(D: LIKE(RWayS.Date)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(RouteIP);
  Result:=AccessCurRouteIP(D, ipc_Total) & (RouteIP.Type = ript_Canceled);
  RESTORE(RouteIP);
  RETURN Result;
 END {CalcIncPlanIsCancelled};

 PUBLIC PROCEDURE AccessIPL(tcpi     : ttcpi;
                            trgCnd   : tIncPlanCondition;
                            D        : LIKE(RWayS.Date);
                            trgDay   : LIKE(RWayJ.Day);
                            trgStartT: LIKE(RWayJ.StartT)): SCAL[2];

  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF WJMode.IncSel & Route.IncSel THEN
   IF    tcpi = tcpi_FromExit THEN
    SAVE(StExit);
    CONFORM(SEJobs, StExit);
    _AssertIP(AccessCurExitIP(D, trgCnd), "室 " + SEJobs.Exit, trgCnd, D, trgStartT);
    IF ExitIP.Type # ipt_Canceled THEN
     SETSEL(ExitIPL, Exit, ExitIP.Exit, ExitIP.Date, ExitIP.Cnd);
     _AssertIP(SRCINSEL(ExitIPL, LE, trgDay, trgStartT),
               "室 " + ExitIP.Exit,
               trgCnd, D, trgStartT);
     Result:=1;
    END;
    RESTORE(StExit);
   ELSIF tcpi = tcpi_FromRoute THEN
    IF ~CalcIncPlanIsCancelled(D) THEN
     _AssertIP(AccessCurRouteIP(D, trgCnd), " " + Route.Route, trgCnd, D, trgStartT);
     IF RouteIP.Type # ript_Canceled THEN
      SETSEL(RouteIPL, Route, RouteIP.Route, RouteIP.Date, RouteIP.RoutCnd);
      _AssertIP(SRCINSEL(RouteIPL, LE, trgDay, trgStartT),
                " " + Route.Route,
                trgCnd, D, trgStartT);
      Result:=1;
     END;
    END; (* IF CalcIncPlanIsCancelled ... *)
   END; (* IF tcpi ... *)
  END; (* IF WJMode.InsSel ... *)
  RETURN Result;
 END {AccessIPL};

 PUBLIC PROCEDURE GetChopperPlanIncome(_TSN: LIKE(Staff.TSN)): NUMERIC[2];
  VAR
   GetPIProc: PROC;
 BEGIN
  GetPIProc:=PROCREF(E_Way.int_GetChopperPlanIncome);
  IF ~!GetPIProc THEN
   RETURN GetPIProc(_TSN);
  ELSE
   L_General.SetupRequired();
  END;
 END {GetChopperPlanIncome};

 PRIVATE VAR
  scfip_trgPasVol: NUMERIC[0];

 PRIVATE PROCEDURE scfip_CheckCar(D: DATE): SCAL[2];
 BEGIN
  IF !scfip_trgPasVol | (scfip_trgPasVol = E_DefinePasVol(D, P_Mark.GetP_PVLim(Mark.Mark, D))) THEN
   SETSEL(CarLog, Mark, Mark.Mark);
   IF LAST(CarLog) THEN
    WHILE OCCURE(CarLog) DO
     IF (CarLog.Purpose = 0) & L_DatTim.IsActive_Inc(D, CarLog.Date, CarLog.DateE) THEN
      CONFORM(CarLog, Car);
      RETURN 1;
     END;
     PREV(CarLog);
    END; (* WHILE ... *)
   END;
  END; (* IF scfip_trgPasVol ... *)
  RETURN 0;
 END {scfip_CheckCar};

 PUBLIC PROCEDURE SetCarForIncPlan(D: DATE; trgPasVol: NUMERIC[0]) : SCAL[2];
  CONST
   xyzSize = 16;
  VAR
   Result   : SCAL[2];
   xyzGroups: NUMERIC[0][xyzSize];
   xyzCnt   : SCAL[xyzSize];
   xyzPasVol: NUMERIC[0];
 BEGIN
  IF E_CalcPlIncBySittingPV(D) THEN
   SETEMPTY(scfip_trgPasVol);
   Result:=L_qs.complexStandOnFirst("Mark", P_Mark.qsa_PasVol_Sit,
                                    P_Mark.qsa_Conv2Value(P_Mark.qsa_PasVol_Sit, trgPasVol),
                                    D, L_qs.sm_EQ, PROCREF(scfip_CheckCar));
  ELSE
   SETEMPTY(xyzGroups);
   E_Way.PasVolGrp(D, xyzGroups);
   xyzCnt:=0;
   LOOP
    IF    !xyzGroups[xyzCnt] THEN
RETURN 0;
     L_General.CallUs(0);
    ELSIF trgPasVol = xyzGroups[xyzCnt] THEN
     IF !xyzGroups[xyzCnt+1] THEN
      xyzPasVol:=999;
     ELSE
      xyzPasVol:=xyzGroups[xyzCnt+1];
     END;
     EXIT;
    END;
    INC(xyzCnt);
   END;
   scfip_trgPasVol:=trgPasVol;
   Result:=L_qs.complexStandOnFirst("Mark", P_Mark.qsa_PasVol_Lim,
                                    P_Mark.qsa_Conv2Value(P_Mark.qsa_PasVol_Lim, xyzPasVol),
                                    D, L_qs.sm_LE, PROCREF(scfip_CheckCar));
  END;
  RETURN Result;
 END {SetCarForIncPlan};

 PUBLIC PROCEDURE E_GetTimesForPlInc(D: DATE;
                                     VAR _Day: LIKE(SEJobs.Day); VAR _StartT, _StopT: LIKE(SEJobs.StartT);
                                     pis: L_APWI.tpiScope);
  VAR
   Local: PROC;
 BEGIN
  IF (pis = L_APWI.piScope_RWOrdered) | (pis = L_APWI.piScope_SEJobs) THEN
   _Day   :=SEJobs.Day;
   _StartT:=SEJobs.StartT;
   _StopT :=SEJobs.StopT;
  ELSIF pis = L_APWI.piScope_RWTaxed THEN
   _Day   :=RWayJ.Day;
   _StartT:=RWayJ.StartT;
   _StopT :=RWayJ.StopT;
  ELSE
   L_General.CallUs(0);
  END;
  Local:=PROCREF(E_Way.GetTimesForPlInc);
  IF ~!Local THEN
   Local(D, _Day, _StartT, _StopT, pis);
  END;
 END {E_GetTimesForPlInc};

 PUBLIC PROCEDURE intPasVolValue2Enum(trgPasVol: NUMERIC[0]): tPasVolEnum;
 BEGIN
  IF    trgPasVol = 000 THEN RETURN pve_Zero;
  ELSIF trgPasVol > 100 THEN RETURN pve_VeryBig;
  ELSIF trgPasVol > 065 THEN RETURN pve_Big;
  ELSIF trgPasVol > 020 THEN RETURN pve_Middle;
  ELSE                       RETURN pve_Small;
  END;
 END {intPasVolValue2Enum};

 PUBLIC PROCEDURE PasVolEnum2Sign(trgPasVolEnum: tPasVolEnum): STRING[];
 BEGIN
  RETURN Str.Item(pve_Pool, "|", trgPasVolEnum);
 END {PasVolEnum2Sign};

 PUBLIC PROCEDURE GetExitPasVolEnum(): tPasVolEnum;
 BEGIN
  L_General.CallUs(OCCURE(StExit));
  RETURN intPasVolValue2Enum(Math.Max(StExit.MinPV, StExit.MaxPV));
 END {GetExitPasVolEnum};

 PUBLIC PROCEDURE GetMarkPasVolEnum(trgD: DATE; trgMark: LIKE(Mark.Mark)): tPasVolEnum;
 BEGIN
  RETURN intPasVolValue2Enum(P_Mark.GetP_PVLim(trgMark, trgD));
 END {GetMarkPasVolEnum};

 PUBLIC PROCEDURE GetMarkPasVolSign(trgD: DATE; trgMark: LIKE(Mark.Mark)): STRING[];
 BEGIN
  RETURN PasVolEnum2Sign(GetMarkPasVolEnum(trgD, trgMark));
 END {GetMarkPasVolSign};

 PUBLIC PROCEDURE GetMarkPasVolSign_50(D: DATE; trgMark: LIKE(Mark.Mark)): STRING[];
  CONST
   ci_VerySmall = 0;
   ci_SmallI    = 1;
   ci_SmallII   = 2;
   ci_MiddleI   = 3;
   ci_MiddleII  = 4;
   ci_BigI      = 5;
   ci_BigII     = 6;
   ci_VeryBig   = 7;
   ci_Zero      = 8;
   ci_Pool    = "| I| II| I| II| I| II|| ";
  VAR
   Result     : SCAL[10];
   PasVolLimit,
   PasVolSittn: NUMERIC[0];
 BEGIN
  PasVolLimit:=P_Mark.GetP_PVLim(trgMark, D);
  PasVolSittn:=P_Mark.GetP_PVSitting(trgMark, D);

  IF    PasVolLimit <   9  THEN Result:=ci_Zero;
  ELSIF PasVolLimit <= 15 THEN Result:=ci_VerySmall;
  ELSIF PasVolLimit > 120 THEN Result:=ci_VeryBig;
  ELSIF PasVolSittn = PasVolLimit THEN (*  *)
   IF    PasVolLimit > 41 THEN Result:=ci_BigII;
   ELSIF PasVolLimit > 25 THEN Result:=ci_MiddleII;
   ELSE                        Result:=ci_SmallII;
   END;
  ELSE
   IF    PasVolLimit > 76 THEN Result:=ci_BigI;
   ELSIF PasVolLimit > 46 THEN Result:=ci_MiddleI;
   ELSE                        Result:=ci_SmallI;
   END;
  END;
  RETURN L_Str.PoolItem(ci_Pool, Result);
 END {GetMarkPasVolSign_50};

 PUBLIC PROCEDURE SetCtrlTimes(P: DATE; _WDWay: L_DatTim.tWeekday; VAR CtrlTimes: TIME[]);
 BEGIN
  IF    L_APtm.IsMGT() & L_APtm.IsTrolPark() THEN
   CtrlTimes[0]:=07:15;
   CtrlTimes[1]:=08:30;
   CtrlTimes[2]:=10:00;
   CtrlTimes[3]:=18:00;
   CtrlTimes[4]:=21:00;
   CtrlTimes[5]:=23:59;
  ELSIF L_APtm.IsMGT() & L_APtm.IsTramDepo() THEN
   CtrlTimes[0]:=07:15;
   CtrlTimes[1]:=08:30;
   CtrlTimes[2]:=17:00;
   CtrlTimes[3]:=18:00;
   CtrlTimes[4]:=21:00;
   CtrlTimes[5]:=23:59;
  ELSIF L_APtm.IsMGT() THEN
   CtrlTimes[0]:=07:15;
   IF _WDWay <= 4 THEN
    CtrlTimes[1]:=08:30;
   ELSE
    CtrlTimes[1]:=08:00;
   END;
   CtrlTimes[2]:=10:00;
   CtrlTimes[3]:=17:00;
   CtrlTimes[4]:=19:00;
   CtrlTimes[5]:=23:59;
  ELSE
   CtrlTimes[0]:=07:15;
   IF _WDWay <= 4 THEN
    CtrlTimes[1]:=08:30;
   ELSE
    CtrlTimes[1]:=08:00;
   END;
   CtrlTimes[2]:=10:00;
   CtrlTimes[3]:=17:00;
   CtrlTimes[4]:=19:00;
   CtrlTimes[5]:=23:59;
  END;
 END {SetCtrlTimes};

 PUBLIC PROCEDURE GetBakVol(_BoxNbr: LIKE(Car.BoxNbr); _Date: DATE): LIKE(Mark.BakVol);
  VAR
   Volume: LIKE(Mark.BakVol);
 BEGIN
  IF P_Car.HasActualCarPro(_BoxNbr, _Date, P_Car.P_BakVolume) THEN
   Volume:=STRTOFLD(CarPro.Value, NUMERIC);
  ELSE
   SAVE(Mark);
   L_Car.AccessMark(_BoxNbr, _Date);
   Volume:=Mark.BakVol;
   RESTORE(Mark);
  END;
  RETURN Volume;
 END {GetBakVol};

 PUBLIC PROCEDURE CheckBakVol(_BoxNbr: LIKE(Car.BoxNbr); _Date: DATE; Vol: FLOAT;
                              _Strong: SCAL[2]);
  VAR
   _BakVol: LIKE(Mark.BakVol);
   _Text  : STRING[];
 BEGIN
  IF ~!Vol THEN
   _BakVol:=GetBakVol(_BoxNbr, _Date);
   IF Vol > _BakVol THEN
    _Text:="祭 ॢ蠥   (" + L_Str.IntStr(_BakVol) + " )";
    IF _Strong THEN
     L_General.Error(_Text);
    ELSE
     L_StdFrm.Choice(_Text);
    END;
   END;
  END;
 END {CheckBakVol};

 PUBLIC PROCEDURE DayPoint(): TIME;
 BEGIN
  RETURN 00:00;
 END {DayPoint};

 PUBLIC PROCEDURE GetCtrlTimes(T: TIME): STRING[5];
 BEGIN
  IF T = DayPoint() THEN
   RETURN "⪨";
  ELSE
   RETURN FLDTOSTR(T, "H:M", 5);
  END;
 END {GetCtrlTimes};

 PUBLIC PROCEDURE RWaySSomeTimeWas(_Action: LIKE(XDocJrn.Action)): SCAL[2];
 BEGIN
  RETURN L_XDoc.XDocSomeTimeWas(L_XDoc.xdt_RWayS,
                                L_XDoc.EmptyXDocKind,
                                RWayS.RWayS,
                                _Action);
 END {RWaySSomeTimeWas};

 PUBLIC PROCEDURE WasTaxedRWayS(): SCAL[2];
 BEGIN
  IF SELECT(RWayJ, RWayS, RWayS.RWayS) THEN
   RETURN RWaySSomeTimeWas(L_XDoc.action_Edit  ) |
          RWaySSomeTimeWas(L_XDoc.action_Insert) ;
  ELSE
   RETURN 0;
  END;
 END {WasTaxedRWayS};

 PRIVATE PROCEDURE _CheckUnTaxed(B, E: DATE; _Status: LIKE(RWayS.Status); VAR _RWayS: LIKE(RWayS.RWayS)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  TRY
   TABLE.Get("RWayS").AccessDataMode:=AccessDataMode_SOFT;
   SETSEL(RWayS, sDate, _Status);
   SRCINSEL(RWayS, GE, , B);
   LOOP
    IF ~OCCURE(RWayS) THEN
     EXIT;
    ELSIF RWayS.Date <= E THEN
     _RWayS:=RWayS.RWayS;
     Result:=1;
     EXIT;
    END;
    NEXT(RWayS);
   END;
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Raise DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
  RETURN Result;
 END {_CheckUnTaxed};

 PUBLIC PROCEDURE CheckTaxed(B, E: DATE);
  VAR
   _RWayS: LIKE(RWayS.RWayS);
   Msg   : STRING[];
   Timing: NUMERIC[0];
 BEGIN
  SETEMPTY(_RWayS);
  Timing:=60;
  IF _CheckUnTaxed(B, E, rwsStat_Ordered, _RWayS) |
     _CheckUnTaxed(B, E, rwsStat_Given, _RWayS)   |
     _CheckUnTaxed(B, E, rwsStat_Taken, _RWayS)   THEN
   Msg:="| ⠪஢ ⥢  ("+_RWayS+")"+
        "||" + "%<    ⬥    >Z    %< 믮 (%T) >FD";
   STDFORM(Msg, " ஢ઠ ⠪஢  ", INFORM, , Timing);
  END;
 END {CheckTaxed};

 PUBLIC PROCEDURE WarnUnDoneRWayS(B, E: DATE);
 BEGIN
  SETSEL(RWayS, Done, 0);
  IF SRCINSEL(RWayS, GE, B) & (RWayS.Date<=E) THEN
   L_StdFrm.Choice(" ࠡ⠭ , १ 㤥 ⮢|ਬ,  "+RWayS.RWayS);
  END;
 END {WarnUnDoneRWayS};

 PUBLIC PROCEDURE HasIdenticalTckRcSGap(VAR trsGap: LIKE(TckRcS.Gap)): SCAL[2];
  VAR
   Result   : SCAL[2];
   prvTckRcS: LIKE(TckRcS.TckRcS);
 BEGIN
  Result:=0;
  SETEMPTY(trsGap, prvTckRcS);
  SETSEL(TckRcJ, asRWayS, WayLMen.RWayS);
  FOR_EACH TckRcJ DO
   IF TckRcJ.TckRcS # prvTckRcS THEN
    CONFORM(TckRcJ, TckRcS);
    prvTckRcS:=TckRcJ.TckRcS;
    IF (TckRcS.AsWho = trs_Guard) & (TckRcS.TSN = WayLMen.TSN) THEN
     IF    !trsGap THEN
      trsGap:=TckRcS.Gap;
      Result:=1;
     ELSIF TckRcS.Gap # trsGap THEN
      Result:=0;
      EXIT;
     END;
    END;
   END;
  END; (* FOR_EACH TckRcJ *)
  RETURN Result;
 END {HasIdenticalTckRcSGap};

 PUBLIC PROCEDURE GetGapSign(_who: tRWSWho): SCAL[2];
  VAR
   trsGap: LIKE(TckRcS.Gap);
 BEGIN
  IF (_who = rwswho_Guard) & HasIdenticalTckRcSGap(trsGap) & (trsGap # trsGap_SeeRsp) THEN
   RETURN trsGap;
  END;
  RETURN RWayS.Gap;
 END {GetGapSign};

 PRIVATE PROCEDURE gwlms_ApplyTRS(    msgHeader: STRING[];
                                  VAR ToSheet  : LIKE(WayLMen.ToSheet);
                                  VAR ToPay    : LIKE(WayLMen.ToPay));
 BEGIN
  IF (WayLMen.ToSheet = toSheet_SeeRsp) THEN
   IF ToSheet = toSheet_SeeRsp THEN
    ToSheet:=TckRcS.ToSheet;
    L_General.Assert(TckRcS.ToSheet # toSheet_SeeRsp, msgHeader + "' ⠡'   㪠 '',   㪠 ''");
   ELSE
    L_General.Assert(ToSheet = TckRcS.ToSheet, msgHeader +
                     " ᪮쪮    ࠧ 祭 ' ⠡',   㪠 ''.");
   END;
  END;
  IF (WayLMen.ToPay = toPay_SeeRsp) THEN
   IF ToPay = toPay_SeeRsp THEN
    ToPay:=TckRcS.ToPay;
    L_General.Assert(TckRcS.ToPay # toPay_SeeRsp,
                     msgHeader + "''   㪠 '',   㪠 ''");
   ELSE
    L_General.Assert(ToPay = TckRcS.ToPay,
                     msgHeader + " ᪮쪮    ࠧ 祭 '',   㪠 ''.");
   END;
  END;
 END {gwlms_ApplyTRS};

 PUBLIC PROCEDURE GetWLMSigns(VAR ToSheet: LIKE(WayLMen.ToSheet); VAR ToPay: LIKE(WayLMen.ToPay));
  VAR
   trsWho    : tTRSWho;
   msgHeader : STRING[];
   tmpToSheet: LIKE(WayLMen.ToSheet);
   tmpToPay  : LIKE(WayLMen.ToPay);
   prvTckRcS : LIKE(TckRcS.TckRcS);
 BEGIN
  msgHeader:=L_Str.PoolItem(wlmwho_Pool, WayLMen.Who) + " " + WayLMen.TSN + ": ";
  tmpToSheet:=WayLMen.ToSheet;
  tmpToPay  :=WayLMen.ToPay;
  IF (WayLMen.ToSheet = toSheet_SeeRsp) | (WayLMen.ToPay = toPay_SeeRsp) THEN
   SAVE(RWayJ);
   IF    WayLMen.Who = wlmwho_Chopper THEN
    trsWho:=trs_Chopper;
   ELSIF WayLMen.Who = wlmwho_SDriver THEN
    trsWho:=trs_Driver;
   ELSIF WayLMen.Who = wlmwho_Guard THEN
    trsWho:=trs_Guard;
   ELSE
    L_General.Error(msgHeader + "⨬ 㪠뢠 ''");
   END;
   SELECT(TckRcS, TSN, , WayLMen.TSN, WayLMen.RWayDate);
   WHILE OCCURE(TckRcS) DO
    IF (TckRcS.AsWho = trsWho) THEN
     gwlms_ApplyTRS(msgHeader, tmpToSheet, tmpToPay);
    END;
    NEXT(TckRcS);
   END; (* WHILE OCCURE(TckRcS) ... *)
   SETEMPTY(prvTckRcS);
   SETSEL(TckRcJ, asRWayS, WayLMen.RWayS);
   FOR_EACH TckRcJ DO
    IF TckRcJ.TckRcS # prvTckRcS THEN
     CONFORM(TckRcJ, TckRcS);
     prvTckRcS:=TckRcS.TckRcS;
    END;
    IF (TckRcS.AsWho = trsWho) & (TckRcS.TSN = WayLMen.TSN) &
       SEARCH(RWayJ, RWayS, TckRcJ.asRWayS, TckRcJ.asDay, TckRcJ.asStartT) &
       L_RWayS.IsRWayJForCurWayLMen() THEN
     gwlms_ApplyTRS(msgHeader, tmpToSheet, tmpToPay);
    END;
   END; (* FOR_EACH TckRcJ *)
   RESTORE(RWayJ);
  END; (* IF (WayLMen.ToSheet ... *)
  L_General.Assert((tmpToSheet # toSheet_SeeRsp) & (tmpToPay # toPay_SeeRsp),
                   msgHeader + "  㪠 ''.  ࠡ⭨    ");
  ToSheet:=tmpToSheet;
  ToPay  :=tmpToPay;
 END {GetWLMSigns};

 PUBLIC PROCEDURE GetWLMToSheetSign(_who: tWLMWho): SCAL[3];
  VAR
   ToSheet: LIKE(WayLMen.ToSheet);
   ToPay  : LIKE(WayLMen.ToPay);
 BEGIN
  GetWLMSigns(ToSheet, ToPay);
  RETURN ToSheet;
 END {GetWLMToSheetSign};

 PUBLIC PROCEDURE GetWLMToPaySign(_who: tWLMWho): SCAL[2];
  VAR
   ToSheet: LIKE(WayLMen.ToSheet);
   ToPay  : LIKE(WayLMen.ToPay);
 BEGIN
  GetWLMSigns(ToSheet, ToPay);
  RETURN ToPay;
 END {GetWLMToPaySign};

 PUBLIC PROCEDURE SetWayLMenDefaultValue();
 BEGIN
  IF (E_TckRcLevel(RWayS.Date) > L_TRS.il_None) &
     (WayLMen.Who = wlmwho_Guard) &
     E_TckRcSIsMainForGuard(RWayS.Date) THEN
   WayLMen.ToSheet:=toSheet_SeeRsp;
   WayLMen.ToPay  :=toPay_SeeRsp;
  ELSE
   WayLMen.ToSheet:=1;
   WayLMen.ToPay:=1;
  END;
 END {SetWayLMenDefaultValue};

 PUBLIC PROCEDURE E_TrIncFct(Who    : tRWSWho;
                             _Number: LIKE(WayLMen.Number);
                             _RWJPro: LIKE(RWayJP.RWJPro)): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.TrIncFct);
  IF ~!Local THEN
   RETURN Local(Who, _Number, _RWJPro);
  ELSE
   L_General.SetupRequired();
  END;
 END {E_TrIncFct};

 PUBLIC PROCEDURE E_TrCasFct(Who    : tRWSWho;
                             _Number: LIKE(WayLMen.Number);
                             _RWJPro: LIKE(RWayJP.RWJPro)): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.TrCasFct);
  IF ~!Local THEN
   RETURN Local(Who, _Number, _RWJPro);
  ELSE
   L_General.SetupRequired();
  END;
 END {E_TrCasFct};

 PUBLIC PROCEDURE TrIncFct(Who: tRWSWho; _Number: LIKE(WayLMen.Number); _RWJPro: LIKE(RWayJP.RWJPro)): SCAL[2];
  VAR
   Is: SCAL[2];
 BEGIN
  IF (Who = rwswho_Dr_W_Gu) THEN
   Is:=E_TrIncFct(rwswho_Driver, _Number, _RWJPro);
   IF ~Is & E_ApplyGuIncToDrv(SYSDATE()) THEN
    Is:=E_TrIncFct(rwswho_Guard, 1, _RWJPro) |
        E_TrIncFct(rwswho_Guard, 2, _RWJPro);
   END;
  ELSE
   Is:=E_TrIncFct(Who, _Number, _RWJPro);
  END;
  RETURN Is;
 END {TrIncFct};

 PRIVATE PROCEDURE VldPsgRWJPro(vpk: tVldPsgKind; Who: tRWSWho; _Number: LIKE(WayLMen.Number)): LIKE(RWayJP.RWJPro);
 BEGIN
  IF    (Who = rwswho_Driver)  & (_Number = 1) THEN
   IF    vpk = vpk_MoscowRegion  THEN RETURN 73;
   ELSIF vpk = vpk_Moscow        THEN RETURN 74;
   ELSIF vpk = vpk_OtherSocial   THEN RETURN 69;
   ELSE                               RETURN 82;
   END;
  ELSIF (Who = rwswho_Guard)   & (_Number = 1) THEN
   IF    vpk = vpk_MoscowRegion  THEN RETURN 79;
   ELSIF vpk = vpk_Moscow        THEN RETURN 80;
   ELSIF vpk = vpk_OtherSocial   THEN RETURN 72;
   ELSE                               RETURN 85;
   END;
  ELSIF (Who = rwswho_Guard)   & (_Number = 2) THEN
   IF    vpk = vpk_MoscowRegion  THEN RETURN 77;
   ELSIF vpk = vpk_Moscow        THEN RETURN 78;
   ELSIF vpk = vpk_OtherSocial   THEN RETURN 71;
   ELSE                               RETURN 84;
   END;
  ELSIF ((Who = rwswho_Chopper) & (_Number = 1)) | ((Who = rwswho_GuPupil) & (_Number = 1)) THEN
   IF    vpk = vpk_MoscowRegion  THEN RETURN 75;
   ELSIF vpk = vpk_Moscow        THEN RETURN 76;
   ELSIF vpk = vpk_OtherSocial   THEN RETURN 70;
   ELSE                               RETURN 83;
   END;
  ELSE
   RETURN EMPTYOF(RWayJP.RWJPro);
  END;
 END {VldPsgRWJPro};

 PUBLIC PROCEDURE GetVldPsgRWJPro(vpk: tVldPsgKind; Who: tRWSWho; _Number: LIKE(WayLMen.Number)): LIKE(RWayJP.RWJPro);
  VAR
   result: LIKE(RWayJP.RWJPro);
 BEGIN
  result:=VldPsgRWJPro(vpk, Who, _Number);
  L_General.Assert(~!result, " । ⥫   ⠪஢" +
                             "|  ஭ ⠬" +
                             "| " + RWSWhoStr(Who) + " " + _Number);
  RETURN result;
 END {GetVldPsgRWJPro};

 PUBLIC PROCEDURE IsVldPsgRWJPro(Who    : tRWSWho;
                                 _Number: LIKE(WayLMen.Number);
                                 vpk    : tVldPsgKind;
                                 _RWJPro: LIKE(RWayJP.RWJPro)): SCAL[2];
 BEGIN
  IF Who = rwswho_Dr_W_Gu THEN
   RETURN IsVldPsg(vpk, _RWJPro);
  ELSE
   RETURN _RWJPro = VldPsgRWJPro(vpk, Who, _Number);
  END;
 END {IsVldPsgRWJPro};

 PUBLIC PROCEDURE IsVldPsg(vpk: tVldPsgKind; _RWJPro: LIKE(RWayJP.RWJPro)): SCAL[2];
 BEGIN
  RETURN IsVldPsgRWJPro(rwswho_Driver,  1, vpk, _RWJPro) |
         IsVldPsgRWJPro(rwswho_Guard,   1, vpk, _RWJPro) |
         IsVldPsgRWJPro(rwswho_Guard,   2, vpk, _RWJPro) |
         IsVldPsgRWJPro(rwswho_Chopper, 1, vpk, _RWJPro) |
         IsVldPsgRWJPro(rwswho_GuPupil, 1, vpk, _RWJPro);
 END {IsVldPsg};

 PRIVATE PROCEDURE IsAnyVldPsg(_RWJPro: LIKE(RWayJP.RWJPro)): SCAL[2];
 BEGIN
  RETURN IsVldPsg(vpk_Moscow,       _RWJPro) |
         IsVldPsg(vpk_MoscowRegion, _RWJPro) |
         IsVldPsg(vpk_OtherSocial,  _RWJPro) |
         IsVldPsg(vpk_Paid,         _RWJPro);
 END {IsAnyVldPsg};

 PRIVATE PROCEDURE StExitWDType(OnDays: SCAL[2][]): tStExitWDType;
 BEGIN
  IF OnDays[L_DatTim.wd_Mon] |
     OnDays[L_DatTim.wd_Tue] |
     OnDays[L_DatTim.wd_Wed] |
     OnDays[L_DatTim.wd_Thu] |
     OnDays[L_DatTim.wd_Fri] THEN
   RETURN sewdt_WrkDay;
  ELSE
   RETURN sewdt_OffDay;
  END;
 END {StExitWDType};

 PUBLIC PROCEDURE CarBegRWSLev(_BoxNbr: LIKE(Car.BoxNbr); D: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF (E_BegRWSLev(D) = brwsl_Active) & L_Env.RealBoxNbr(_BoxNbr) THEN
   SAVE(CarLog);
   Result:=L_Car._StandOnCarLog(_BoxNbr, D) & (CarLog.InBeg # L_Car.inBeg_DoesNot);
   RESTORE(CarLog);
  END;
  RETURN Result;
 END {CarBegRWSLev};

 PUBLIC PROCEDURE AccessTckRcS_byRWayJ(_TSN: LIKE(Staff.TSN); _AsWho: tTRSWho): SCAL[2];
 BEGIN
  SELECT(TckRcJ, asRWayS, , RWayJ.RWayS, RWayJ.Day, RWayJ.StartT);
  WHILE OCCURE(TckRcJ) DO
   CONFORM(TckRcJ, TckRcS);
   IF (TckRcS.TSN = _TSN) & (TckRcS.AsWho = _AsWho) THEN
    RETURN 1;
   END;
   NEXT(TckRcJ);
  END; (* WHILE OCCURE(TckRcJ) ... *)
  RETURN 0;
 END {AccessTckRcS_byRWayJ};

 (*!*)PUBLIC PROCEDURE CWD_ForExit(wdk: L_APtm.tWeekdayKind; _Exit: LIKE(StExit.Exit)): L_DatTim.tWeekday;
 BEGIN
  RETURN L_APWI.CWD_ForTrip(wdk, _Exit, Calendar.Date, 01, 00:00);
 END {CWD_ForExit};

 (*!*)PUBLIC PROCEDURE Calendar_Weekday(wdk: L_APtm.tWeekdayKind): L_DatTim.tWeekday;
 BEGIN
  RETURN CWD_ForExit(wdk, SEJobs.Exit);
 END {Calendar_Weekday};

 PRIVATE PROCEDURE BarCode(): STRING[];
 BEGIN
  RETURN L_XDoc.BarCode(L_XDoc.bck_IdIn17, L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS, RWayS.CopyCnt);
 END {BarCode};

 PUBLIC PROCEDURE GetBarCode_bck_IdIn20(): STRING[];
 BEGIN
  RETURN L_BarCode.toFont_IntP36DlTt(L_XDoc.BarCode(L_XDoc.bck_IdIn20,
                                                    L_XDoc.xdt_RWayS,
                                                    L_XDoc.EmptyXDocKind,
                                                    RWayS.RWayS,
                                                    RWayS.CopyCnt));
 END {GetBarCode_bck_IdIn20};

 PUBLIC PROCEDURE GetWho(_Who: tRWSWho): tRWSWho;
 BEGIN
  IF _Who = rwswho_SDriver THEN
   RETURN rwswho_Driver;
  ELSE
   RETURN _Who;
  END;
 END {GetWho};

 PUBLIC PROCEDURE RWSWhoStr(_Who: tRWSWho): STRING[];
 BEGIN
  IF    _Who = rwswho_Driver  THEN RETURN "⥫";
  ELSIF _Who = rwswho_Guard   THEN RETURN "";
  ELSIF _Who = rwswho_DrPupil THEN RETURN "祭 ⥫";
  ELSIF _Who = rwswho_GuPupil THEN RETURN "祭 ";
  ELSIF _Who = rwswho_SDriver THEN RETURN "ண ⥫";
  ELSIF _Who = rwswho_Chopper THEN RETURN "稪";
  ELSE
   RETURN ".ᮭ " + _Who;
  END;
 END {RWSWhoStr};

 PUBLIC PROCEDURE PosToWJMethod(_WJCode : LIKE(WJMethod.WJCode);
                                _Who    : LIKE(WJMethod.Who);
                                _JRegime: LIKE(WJMethod.JRegime);
                                _Quality: LIKE(WJMethod.Quality);
                                D       : DATE);
  CONST
   Msg = "| |᫨  㢥७  ࠢ쭮 ⠪஢, ,|      |('   ࠡ  ')";
 BEGIN
  IF L_Str.Left(_WJCode, 1) = '' THEN
   IF ~(SELECT(WJMethod, WJCode, _WJCode, GetWho(_Who)) &
        CHANGESEL(WJMethod, WJCode, _WJCode, GetWho(_Who), WJMethod.JRegime, WJMethod.Quality) &
        SRCINSEL(WJMethod, LE, D) & L_DatTim.IsActive(D, WJMethod.Begin, WJMethod.Till)) THEN
    L_StdFrm.WrongDB(" । ⮤  " + RWSWhoStr(GetWho(_Who)) + "  " + L_DatTim.DateStr(D) +
                     "| ⮣ ⥢  ⨯ " + _WJCode+Msg);
   END;
  ELSE
   SETSEL(WJMethod, WJCode, _WJCode, GetWho(_Who), _JRegime, _Quality);
   IF ~(SRCINSEL(WJMethod, LE, D) & L_DatTim.IsActive(D, WJMethod.Begin, WJMethod.Till)) THEN
    L_StdFrm.WrongDB(" । ⮤  " + RWSWhoStr(GetWho(_Who)) + "  " + L_DatTim.DateStr(D) +
                     "| ࠡ " + _WJCode + ", ० ࠡ " + _JRegime + ",  ⢠ " + _Quality+Msg);
   END;
  END;
 END {PosToWJMethod};

 PUBLIC PROCEDURE IsIncRWJP(_Who: tRWSWho; _Number: LIKE(WayLMen.Number); _Idx: SCAL[5];
                            _RWJPro: LIKE(RWayJP.RWJPro)): SCAL[2];
  VAR
   curIdx : NUMERIC[0];
   curRWJP: LIKE(RWayJP.RWJPro);
 BEGIN
  curIdx:=_Idx;
  LOOP
   curRWJP:=E_Way.GetIncRWJP(_Who, _Number, curIdx);
   IF    curRWJP = rwjp_Fict THEN
    EXIT;
   ELSIF curRWJP = _RWJPro THEN
    RETURN 1;
   END;
   INC(curIdx, 10);
  END;
  RETURN 0;
 END {IsIncRWJP};

 PUBLIC PROCEDURE E_GetFixedSortOfExit(_Exit: LIKE(StExit.Exit);
                                       D    : DATE;
                                       _Who : tRWSWho): LIKE(Sort.Sort);
  VAR
   Local : PROC;
   Result: LIKE(Sort.Sort);
 BEGIN
  SETEMPTY(Result);
  SETSEL(ECSort, Exit, _Exit);
  IF SRCINSEL(ECSort, LE, D) THEN
   Result:=ECSort.Sort;
  ELSE
   SAVE(StExit);
   PositionOnStExit(_Exit);
   SETSEL(ECSort, ExitClss, StExit.ExitClss);
   IF SRCINSEL(ECSort, LE, D) THEN
    Result:=ECSort.Sort;
   END;
   RESTORE(StExit);
  END;
  Local:=PROCREF(E_Way.GetFixedSortOfExit);
  IF ~!Local THEN
   Result:=Local(Result, _Exit, D, _Who);
  END;
  RETURN Result;
 END {E_GetFixedSortOfExit};

 PUBLIC PROCEDURE StandOnFixedSortOfExit(_Exit : LIKE(StExit.Exit);
                                         D     : DATE;
                                         _Who  : tRWSWho;
                                         Strong: SCAL[2]): SCAL[2];
  VAR
   fixedSort: LIKE(Sort.Sort);
 BEGIN
  fixedSort:=E_GetFixedSortOfExit(_Exit, D, _Who);
  IF ~!fixedSort THEN
   SEARCH(Sort, Sort, , fixedSort);
  ELSE
   L_General.Assert(~Strong,
                    "室 " + _Exit + "  ९  ᥪ஬  "+L_DatTim.DateStr(D));
   L_General.CLEAR("Sort");
  END;
  RETURN OCCURE(Sort);
 END {StandOnFixedSortOfExit};

 PUBLIC PROCEDURE GetMyFirmOfExit(_Exit: LIKE(StExit.Exit); D: DATE): P_Firm.tMyFirm;
  VAR
   Dummy : SCAL[2];
   Result: P_Firm.tMyFirm;
 BEGIN
  IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
   SAVE(StExit);
   PositionOnStExit(_Exit);
   Dummy:=StandOnFixedSortOfExit(StExit.Exit, D, rwswho_Driver, 1);
   Result:=Sort.MyFirm;
   RESTORE(StExit);
  ELSE
   Result:=P_Firm.mf_Own;
  END;
  RETURN Result;
 END {GetMyFirmOfExit};

 PUBLIC PROCEDURE RealRWayJTrip(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(Quality);
  CONFORM(RWayJ, Quality);
  Result:=Quality.Type # QualType_VoidTr;
  RESTORE(Quality);
  RETURN (RWayJ.StartT # RWayJ.StopT) & Result;
 END {RealRWayJTrip};

 PUBLIC PROCEDURE SEJobsWithPlIncome(_Date: DATE): SCAL[2];
 BEGIN
  RETURN (WJMode.IncSel*Route.IncSel > 0) & ~CalcIncPlanIsCancelled(_Date);
 END {SEJobsWithPlIncome};

 PUBLIC PROCEDURE RWayJWithPlIncome(): SCAL[2];
 BEGIN
  RETURN SEJobsWithPlIncome(RWayS.Date) & (Quality.Type # QualType_Annul);
 END {RWayJWithPlIncome};

 PUBLIC PROCEDURE rwswhoWithSale(_Who: tRWSWho): SCAL[2];
 BEGIN
  IF _Who = rwswho_Guard THEN
   RETURN (WayLMen.FncDtl=wlmdtl_Full) | (WayLMen.FncDtl = wlmdtl_Sale);
  END;
  RETURN 1;
 END {rwswhoWithSale};

 PUBLIC PROCEDURE rwswhoWithVld(_Who: tRWSWho): SCAL[2];
 BEGIN
  IF _Who = rwswho_Guard THEN
   RETURN (WayLMen.FncDtl=wlmdtl_Full) | (WayLMen.FncDtl = wlmdtl_Vldt);
  END;
  RETURN 1;
 END {rwswhoWithVld};

(*-------------BEGIN OF NORMAL ENVIRONMENT--------------------------*)

 PUBLIC PROCEDURE E_IRecLevel(P: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(P, PROCREF(E_Way.IRecLevel), 0);
 END {E_IRecLevel};

 PUBLIC PROCEDURE E_MedicalSertLevel(P: DATE): SCAL[2];
 BEGIN
  IF E_BegRWSLev(P) >= brwsl_Active THEN
   RETURN L_EC.ExecE_Func_Scal2(P, PROCREF(E_Way.MedicalSertLevel), 1);
  ELSE
   RETURN L_EC.ExecE_Func_Scal2(P, PROCREF(E_Way.MedicalSertLevel), 0);
  END;
 END {E_MedicalSertLevel};

 PUBLIC PROCEDURE E_MarkCategoryLevel(P: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(P, PROCREF(L_Env.MarkCategoryLevel), 0);
 END {E_MarkCategoryLevel};

 PUBLIC PROCEDURE E_NeedFuelChain(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.NeedFuelChain), 1);
 END {E_NeedFuelChain};

 PUBLIC PROCEDURE E_NeedSMChain(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.NeedSMChain), 1);
 END {E_NeedSMChain};

 PUBLIC PROCEDURE E_GetLossReasonCode(D: DATE): NUMERIC[0];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.GetLossReasonCode), rwjp_Fict);
 END {E_GetLossReasonCode};

 PUBLIC PROCEDURE E_GetLossReasonPool(D: DATE): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(D, PROCREF(E_Way.GetLossReasonPool), "");
 END {E_GetLossReasonPool};

 PUBLIC PROCEDURE E_CheckStaffByCard(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_Way.CheckStaffByCard), 0);
 END {E_CheckStaffByCard};

 PUBLIC PROCEDURE IsLOSS(): SCAL[2];
 BEGIN
  RETURN TKind.InLoss & (WJMode.WJCode >= "80");
 END {IsLOSS};

 PUBLIC PROCEDURE LossTrpTime(): NUMERIC[3];
  VAR
   time : NUMERIC[3];
 BEGIN
  IF IsLOSS() THEN
   time:=RWayJ.StopT - RWayJ.StartT;
  ELSE
   time:=0;
  END;
  DEC(time, GetRWJPByCode(rwjp_DecreaseLossTime));
  L_General.Assert(time >= 0, "襭   ३  த⥫쭮 ३.|| " +
                              RWayJ.RWayS + " ३ " + RWayJ.Day + " " + L_DatTim.TimeStr(RWayJ.StartT));
  RETURN time;
 END {LossTrpTime};

 PUBLIC PROCEDURE E_FuelPayLev(D: DATE): NUMERIC[0];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.FuelPayLev), 0);
 END {E_FuelPayLev};

 PUBLIC PROCEDURE E_ConvertWD(D: DATE; _WDWay: L_DatTim.tWeekday): L_DatTim.tWeekday;
  VAR
   Local: PROC;
   WD   : L_DatTim.tWeekday;
 BEGIN
  IF    (_WDWay = 7) THEN WD:=4;
  ELSIF (_WDWay = 6) THEN WD:=3;
  ELSIF (_WDWay = 5) THEN WD:=2;
  ELSIF (_WDWay = 4) & ~L_APtm.IsMGT() THEN WD:=1;
  ELSE                    WD:=0;
  END;
  Local:=PROCREF(E_Way.ConvertWD);
  IF ~!Local THEN
   RETURN Local(D, _WDWay, WD);
  ELSE
   RETURN WD;
  END;
 END {E_ConvertWD};

 PUBLIC PROCEDURE E_ConvertWDStr(D: DATE; WD: L_DatTim.tWeekday): STRING[];
  VAR
   DefaultPool: STRING[];
 BEGIN
  IF L_APtm.IsMGT() THEN
   DefaultPool:="-|       |㡡||ࠧ.";
  ELSE
   DefaultPool:="-|⭨|㡡||ࠧ.";
  END;
  RETURN L_Str.PoolItem(L_EC.ExecE_Func_String(D, PROCREF(E_Way.ConvertWDPool), DefaultPool), WD);
 END {E_ConvertWDStr};

 PUBLIC PROCEDURE GetDateOfTrip(D: DATE; Day: LIKE(RWayJ.Day); StartT: TIME): DATE;
  VAR
   Shift         : NUMERIC[0];
   BegNextDayTime: TIME;
 BEGIN
  SETZERO(Shift);
  BegNextDayTime:=P_OwnData.DspRepTime(D);
  IF Day > 01 THEN
   IF StartT >= BegNextDayTime THEN
    Shift:=Day-1;
   ELSE
    Shift:=Day-2;
   END;
  END;
  RETURN D + Shift;
 END {GetDateOfTrip};

 PUBLIC PROCEDURE GetDateOfRWayJ(): DATE;
 BEGIN
  RETURN GetDateOfTrip(RWayS.Date, RWayJ.Day, RWayJ.StartT);
 END {GetDateOfRWayJ};

 PUBLIC PROCEDURE E_NeedSetTimesWayLMen(D: DATE): SCAL[3];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.NeedSetTimesWayLMen), 1);
 END {E_NeedSetTimesWayLMen};

 PUBLIC PROCEDURE E_MaxDayDuration(D: DATE; CurWho: tRWSWho): NUMERIC[3];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.MaxDayDuration);
  IF ~!Local THEN
   RETURN Local(D, CurWho);
  ELSE
   RETURN 15;
  END;
 END {E_MaxDayDuration};

 PUBLIC PROCEDURE E_CarTbLevel(D: DATE): NUMERIC[0];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.CarTbLevel), ctbl_DmntTKind);
 END {E_CarTbLevel};

 PUBLIC PROCEDURE E_TckRcLevel(D: DATE): NUMERIC[0];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.TckRcLevel), L_TRS.il_None);
 END {E_TckRcLevel};

 PUBLIC PROCEDURE E_CWOrderLevel(D: DATE): NUMERIC[0];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.CWOrderLevel), 0);
 END {E_CWOrderLevel};

 PUBLIC PROCEDURE E_TckRcSIsMainForGuard(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.TckRcSIsMainForGuard), E_TckRcLevel(D)=L_TRS.il_Full);
 END {E_TckRcSIsMainForGuard};

 PRIVATE PROCEDURE E_CorrFN_WithDp(D: DATE): NUMERIC[5];
 BEGIN
  IF L_APtm.IsMGT() THEN
   RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.CorrFN_WithDp), 0.05);
  ELSE
   RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.CorrFN_WithDp), 0.00);
  END;
 END {E_CorrFN_WithDp};

 PRIVATE PROCEDURE E_InitialFuelNormAt100km(D: DATE): tFuelNorms;
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.InitialFuelNormAt100km), STRTOFLD("", NUMERIC));
 END {E_InitialFuelNormAt100km};

 PUBLIC PROCEDURE E_ApplyGuIncToDrv(D: DATE): SCAL[2];
 BEGIN
  RETURN L_APWI.E_ApplyGuToDrvAnyObject(D, L_APWI.ObjectP_Income);
 END {E_ApplyGuIncToDrv};

 PUBLIC PROCEDURE E_SeparateIncRWJP(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.SeparateIncRWJP), 1);
 END {E_SeparateIncRWJP};

 PUBLIC PROCEDURE E_CalcPlIncType(D: DATE; _Cnd: tIncPlanCondition): tCalcPlInc;
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.CalcPlIncByTime);
  IF ~!Local THEN
   RETURN Local(D, _Cnd);
  ELSE
   RETURN cpit_ByTime;
  END;
 END {E_CalcPlIncType};

 PUBLIC PROCEDURE E_CalcPlIncBySittingPV(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.CalcPlIncBySittingPV), 0);
 END {E_CalcPlIncBySittingPV};

 PRIVATE PROCEDURE E_NeedRound_IncPlan(D: DATE): SCAL[2];
 BEGIN
  IF L_APtm.IsMGT() THEN
   RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.NeedRound_IncPlan), 1);
  ELSE
   RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.NeedRound_IncPlan), 0);
  END;
 END {E_NeedRound_IncPlan};

 PUBLIC PROCEDURE E_TripForFuelChainBreak(D: DATE): LIKE(SEJobs.Trip);
  VAR
   Result: LIKE(SEJobs.Trip);
 BEGIN
  Result:=L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.TripForFuelChainBreak), 0);
(*
  SAVE(SEJobs);
  L_General.Assert(SEARCH(SEJobs, Trip, Result), " ஥ ३  ४஢ ");
  RESTORE(SEJobs);
*)
  RETURN Result;
 END {E_TripForFuelChainBreak};

 PUBLIC PROCEDURE E_TripForSMChainBreak(D: DATE): LIKE(SEJobs.Trip);
  VAR
   Result: LIKE(SEJobs.Trip);
 BEGIN
  Result:=L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.TripForSMChainBreak), 0);
(*
  SAVE(SEJobs);
  L_General.Assert(SEARCH(SEJobs, Trip, Result), " ஥ ३  ४஢ ᯨ");
  RESTORE(SEJobs);
*)
  RETURN Result;
 END {E_TripForSMChainBreak};

 PUBLIC CONST
  ptv_07091620 = 0;
  ptv_07091719 = 1;
  ptv_07091619 = 2;
  ptv_07101619 = 3;

 PUBLIC PROCEDURE E_TrPikTim(D: DATE): NUMERIC[3];
  VAR
   PikTimeVersion: tPikTimeVersion;
 BEGIN
  IF (WJMode.RunSel = runsel_Work) & (Calendar_Weekday(L_APtm.wdk_toWay) < L_DatTim.wd_Sat) THEN
   PikTimeVersion:=L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.PikTimeVersion), ptv_07091620);
   IF    PikTimeVersion = ptv_07091620 THEN
    RETURN TIMEINT(RWayJ.StartT, RWayJ.StopT, 07:00, 09:00)+
           TIMEINT(RWayJ.StartT, RWayJ.StopT, 16:00, 20:00);
   ELSIF PikTimeVersion = ptv_07091719 THEN
    RETURN TIMEINT(RWayJ.StartT, RWayJ.StopT, 07:00, 09:00)+
           TIMEINT(RWayJ.StartT, RWayJ.StopT, 17:00, 19:00);
   ELSIF PikTimeVersion = ptv_07091619 THEN
    RETURN TIMEINT(RWayJ.StartT, RWayJ.StopT, 07:00, 09:00)+
           TIMEINT(RWayJ.StartT, RWayJ.StopT, 16:00, 19:00);
   ELSIF PikTimeVersion = ptv_07101619 THEN
    RETURN TIMEINT(RWayJ.StartT, RWayJ.StopT, 07:00, 10:00)+
           TIMEINT(RWayJ.StartT, RWayJ.StopT, 16:00, 19:00);
   ELSE
    L_General.CallUs(0);
   END;
  ELSE
   RETURN 0;
  END;
 END {E_TrPikTim};

 PUBLIC PROCEDURE E_IsPikTime(trgExit: LIKE(StExit.Exit); D: DATE; T: TIME): SCAL[2];
  VAR
   PikTimeVersion: tPikTimeVersion;
 BEGIN
  IF L_APWI.CWD_ForTrip(L_APtm.wdk_toWay, trgExit, D, 01, 00:00) < L_DatTim.wd_Sat THEN
   PikTimeVersion:=L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.PikTimeVersion), ptv_07091620);
   IF    PikTimeVersion = ptv_07091620 THEN
    RETURN (T >= 07:00) & (T <= 09:00) |
           (T >= 16:00) & (T <= 20:00);
   ELSIF PikTimeVersion = ptv_07091719 THEN
    RETURN (T >= 07:00) & (T <= 09:00) |
           (T >= 17:00) & (T <= 19:00);
   ELSIF PikTimeVersion = ptv_07091619 THEN
    RETURN (T >= 07:00) & (T <= 09:00) |
           (T >= 16:00) & (T <= 19:00);
   ELSIF PikTimeVersion = ptv_07101619 THEN
    RETURN (T >= 07:00) & (T <= 10:00) |
           (T >= 16:00) & (T <= 19:00);
   ELSE
    L_General.CallUs(0);
   END;
  ELSE
   RETURN 0;
  END;
 END {E_IsPikTime};

 PUBLIC PROCEDURE E_TrPsgFct(_Who   : tRWSWho;
                             _Number: LIKE(WayLMen.Number);
                             _RWJPro: LIKE(RWayJP.RWJPro)): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.TrPsgFct);
  IF ~!Local THEN
   RETURN Local(_Who, _Number, _RWJPro);
  ELSE
   L_General.SetupRequired();
  END;
 END {E_TrPsgFct};

 PUBLIC PROCEDURE E_TrOrdFct(_Who   : tRWSWho;
                             _Number: LIKE(WayLMen.Number);
                             _RWJPro: LIKE(RWayJP.RWJPro)): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.TrOrdFct);
  IF ~!Local THEN
   RETURN Local(_Who, _Number, _RWJPro);
  ELSE
   L_General.SetupRequired();
  END;
 END {E_TrOrdFct};

 PUBLIC PROCEDURE E_GetRtMVerPool(D: DATE): STRING[];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.GetRtMVerPool);
  IF ~!Local & RoutMod.InPsp THEN
   RETURN Local(D);
  ELSE
   RETURN "";
  END;
 END {E_GetRtMVerPool};

 PRIVATE PROCEDURE E_WaySeason(D: DATE): tWaySeason;
  VAR
   Local     : PROC;
 BEGIN
  Local:=PROCREF(E_Way.WaySeason);
  IF ~!Local THEN
   RETURN Local(D);
  ELSE
   IF (L_DatTim.MONTH(D) > 03(*?*)) & (L_DatTim.MONTH(D) < 09(*?*)) THEN
    RETURN wssn_Summer;
   ELSE
    RETURN wssn_Winter;
   END;
  END;
 END {E_WaySeason};

 PUBLIC PROCEDURE E_FittingRtMVerOnCurrentSEJobs(): NUMERIC[0];
  VAR
   Local     : PROC;
 BEGIN
  Local:=PROCREF(E_Way.FittingRtMVerOnCurrentSEJobs);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN 0;
  END;
 END {E_FittingRtMVerOnCurrentSEJobs};

 PUBLIC PROCEDURE E_GettingRouteFuelNormManner(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.GettingRouteFuelNormManner), 0);
 END {E_GettingRouteFuelNormManner};

 PUBLIC PROCEDURE E_GetStandartPZVTotalTime(D: DATE; _Who: tRWSWho): NUMERIC[3];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.GetStandartPZVTotalTime);
  IF ~!Local THEN
   RETURN Local(D, _Who);
  ELSE
   RETURN 0;
  END;
 END {E_GetStandartPZVTotalTime};

 PUBLIC PROCEDURE E_GetPzvTotalTime(_Who: tRWSWho): NUMERIC[3];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.GetPzvTotalTime);
  IF !Local THEN
   RETURN 0;
  ELSE
   RETURN Local(_Who);
  END;
 END {E_GetPzvTotalTime};

 PUBLIC PROCEDURE E_GetPzvNightTime(_Who: tRWSWho; PzvTotalTime: NUMERIC[3]): NUMERIC[3];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.GetPzvNightTime);
  IF !Local THEN
   RETURN 0;
  ELSE
   RETURN Local(_Who, PzvTotalTime);
  END;
 END {E_GetPzvNightTime};

 PUBLIC PROCEDURE E_GetPzvHolidTime(_Who: tRWSWho; PzvTotalTime: NUMERIC[3]): NUMERIC[3];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.GetPzvHolidTime);
  IF !Local THEN
   IF L_Hld.DayIsHoliday(RWayS.Date) THEN
    RETURN PzvTotalTime;
   ELSE
    RETURN 0;
   END;
  ELSE
   RETURN Local(_Who, PzvTotalTime);
  END;
 END {E_GetPzvHolidTime};

 PUBLIC PROCEDURE E_GetPzvDayTime(_Who: tRWSWho; PzvTotalTime: NUMERIC[3]): NUMERIC[3];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.GetPzvDayTime);
  IF !Local THEN
   RETURN PzvTotalTime;
  ELSE
   RETURN Local(_Who, PzvTotalTime);
  END;
 END {E_GetPzvDayTime};

 PUBLIC PROCEDURE E_GetPzvOtherDayTime(_Who: tRWSWho; PzvTotalTime: NUMERIC[3]): NUMERIC[3];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.GetPzvOtherDayTime);
  IF !Local THEN
   RETURN 0;
  ELSE
   RETURN Local(_Who, PzvTotalTime);
  END;
 END {E_GetPzvOtherDayTime};

 PUBLIC PROCEDURE E_GetCargoTonnage(): NUMERIC[3];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.GetCargoTonnage);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN 0;
  END;
 END {E_GetCargoTonnage};

 PUBLIC PROCEDURE E_Fill_asRWayS(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.Fill_asRWayS), (E_BegRWSLev(D)>=brwsl_Active));
 END {E_Fill_asRWayS};

 PUBLIC PROCEDURE E_FillIncPlanFromIncPlanG(D: DATE): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.FillIncPlanFromIncPlanG);
  IF ~!Local THEN
   IF ~OCCURE(StExit) THEN
    L_General.Assert(OCCURE(Route), " ⠭ 室");
   END;
   RETURN Local(D);
  ELSE
   RETURN 0;
  END;
 END {E_FillIncPlanFromIncPlanG};

 PUBLIC PROCEDURE E_IPConditionPool(D: DATE): STRING[];
 BEGIN
  RETURN "⥫|| | |" +
         L_EC.ExecE_Func_String(D, PROCREF(E_Way.E_IPConditionPool), "");
 END {E_IPConditionPool};

 PRIVATE PROCEDURE E__IncPlanClientCorr(D: DATE; _WDWay: L_DatTim.tWeekday; _Cnd: tIncPlanCondition): NUMERIC[4];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way._IncPlanClientCorr);
  IF ~!Local THEN
   RETURN Local(D, _WDWay, _Cnd);
  ELSE
   RETURN 1;
  END;
 END {E__IncPlanClientCorr};

 PUBLIC PROCEDURE GetAdjustedTckRcSTotTInc(): NUMERIC[2];
  VAR
   Result: NUMERIC[2];
 BEGIN
  Result:=0;
  SAVE(TckRcT);
  SAVE(TckKind);
  SELECT(TckRcT, TckRcS, , TckRcS.TckRcS);
  WHILE OCCURE(TckRcT) DO
   CONFORM(TckRcT, TckKind);
   IF TckKind.InCash = L_TRS.tkc_Cash THEN
    INC(Result, TckRcT.ExpSum - TckRcT.RSum);
   END;
   NEXT(TckRcT);
  END; (* WHILE OCCURE(TckRcT) ... *)
  RESTORE(TckKind);
  RESTORE(TckRcT);
  RETURN Result;
 END {GetAdjustedTckRcSTotTInc};

 PUBLIC PROCEDURE E_IntegerRWayJFact(P: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(P, PROCREF(E_Way.IntegerRWayJFact), 1);
 END {E_IntegerRWayJFact};

 PUBLIC PROCEDURE E_IsResInLine(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.IsResInLine), 0);
 END {E_IsResInLine};

 PUBLIC PROCEDURE E_IsResInPark(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.IsResInPark), 0);
 END {E_IsResInPark};

 PUBLIC PROCEDURE E_IsRepInLine(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.IsRepInLine), 0);
 END {E_IsRepInLine};

 PUBLIC PROCEDURE E_IsRepInPark(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.IsRepInPark), 0);
 END {E_IsRepInPark};

 PUBLIC PROCEDURE E_InvFacilLev(D: DATE): SCAL[2];
 BEGIN
  RETURN L_APtm.IsMGT() & SELECT(CarPro, Property, P_Car.P_WithInvalidFacilities);
 END {E_InvFacilLev};

 PUBLIC PROCEDURE E_CarInvFacilLev(D: DATE; _BoxNbr: LIKE(Car.BoxNbr);
                                            _Route:  LIKE(Route.Route);
                                            _Exit:   LIKE(StExit.Exit)): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  IF E_InvFacilLev(D) THEN
   Local:=PROCREF(E_Way.CarInvFacilLev);
   IF ~!Local THEN
    RETURN Local(D, _BoxNbr, _Route, _Exit);
   ELSE
    RETURN P_Car.HasActualCarPro    (_BoxNbr, D, P_Car.P_WithInvalidFacilities) &
           P_Route.HasActualRoutePro(_Route,  D, P_Route.P_InvalidFacilities) &
           P_Exit.HasActualPro      (_Exit,   D, P_Exit.P_InvalidFacilities);
   END;
  END;
  RETURN 0;
 END {E_CarInvFacilLev};

 PUBLIC PROCEDURE E_ASCPLev(D: DATE): SCAL[2];
 BEGIN
  IF L_APtm.IsMGT() THEN
   RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.ASCPLev), 1);
  ELSE
   RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.ASCPLev), 0);
  END;
 END {E_ASCPLev};

 PUBLIC PROCEDURE TripWithASCP(D: DATE; _Route: LIKE(Route.Route); _Exit: LIKE(StExit.Exit)): SCAL[2];
 BEGIN
  IF P_Exit.HasActualPro(_Exit, D, P_Exit.P_WithASCP) THEN
   RETURN L_Prop.GetProValueAsScal(P_Exit.GetPool(P_Exit.P_WithASCP), ExitPro.Value);
  ELSE
   RETURN P_Route.HasActualRoutePro(_Route, D, P_Route.P_WithASCP);
  END;
 END {TripWithASCP};

 PRIVATE PROCEDURE E_ASCPDisabledRWJPro(D: DATE): LIKE(RWJPro.RWJPro);
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.ASCPDisabledRWJPro), rwjp_ASCPDisabled);
 END {E_ASCPDisabledRWJPro};

 PUBLIC PROCEDURE E_CarASCPLev(D        : DATE;
                               trgBoxNbr: LIKE(Car.BoxNbr);
                               trgRoute : LIKE(Route.Route);
                               trgExit  : LIKE(StExit.Exit)): SCAL[2];
  VAR
   Result : SCAL[2];
   Result2: LIKE(RWayJP.Value);
 BEGIN
  Result:=E_ASCPLev(D) & P_Car.HasTurnstile(trgBoxNbr, D) & TripWithASCP(D, trgRoute, trgExit);
  IF Result THEN
   Result2:=GetRWJPByCode(E_ASCPDisabledRWJPro(D));
   L_General.Assert((Result2=0) | (Result2=1),
                    "᪠ 祭 '0'  '1'"+
                    "| " + RWayJ.Day + " " + L_DatTim.TimeStr(RWayJ.StartT) + " ⥫ " + E_ASCPDisabledRWJPro(D));
   Result:=L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.CarASCPLev), Result & (Result2=0));
  END;
  RETURN Result;
 END {E_CarASCPLev};

 PUBLIC PROCEDURE E_BegRWSLev(D: DATE): tBegRWSLev;
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.BegRWSLev), brwsl_NoBeg);
 END {E_BegRWSLev};

 PUBLIC PROCEDURE E_IPlDvdr(D: DATE; _WCnt: NUMERIC[0]; _Who: tRWSWho; _Number: LIKE(WayLMen.Number)): NUMERIC[4];
  VAR
   Local : PROC;
 BEGIN
  Local:=PROCREF(E_Way.E_IPlDvdr);
  IF ~!Local THEN
   RETURN Local(D, _WCnt, _Who, _Number);
  ELSE
   IF    _Who = rwswho_Driver THEN
    RETURN 1;
   ELSE
    RETURN _WCnt;
   END;
  END;
 END {E_IPlDvdr};

 PUBLIC PROCEDURE E_GetStopInPark(): LIKE(Stop.Stop);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.GetStopInPark);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN EMPTYOF(Stop.Stop);
  END;
 END {E_GetStopInPark};

 PUBLIC PROCEDURE E_GuardReserveExit(D: DATE): LIKE(StExit.Exit);
 BEGIN
  RETURN erkn_e_GetSoft(D, erkn_ec_GuardReserve);
 END {E_GuardReserveExit};

 PUBLIC PROCEDURE E_GuardOutageExit(D: DATE): LIKE(StExit.Exit);
 BEGIN
  RETURN erkn_e_GetSoft(D, erkn_ec_GuardOutage);
 END {E_GuardOutageExit};

 PUBLIC PROCEDURE E_IsGuardIdleExit(D: DATE; _Exit: LIKE(StExit.Exit)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(StExit);
  PositionOnStExit(_Exit);
  Result:=IsExitClasswERKN(StExit.ExitClss, erkn_ec_GuardReserve) |
          IsExitClasswERKN(StExit.ExitClss, erkn_ec_GuardOutage);
  RESTORE(StExit);
  RETURN Result;
 END {E_IsGuardIdleExit};

 PUBLIC PROCEDURE E_GetCarDprt(trgBoxNbr: LIKE(Car.BoxNbr); trgD: DATE): LIKE(Sort.Sort);
  VAR
   Result: LIKE(Sort.Sort);
 BEGIN
  SETEMPTY(Result);
  TRY [RESTORE_CURSORS(RC_ON)]
   L_Car.StandOnCarLog(trgBoxNbr, trgD);
   CONFORM(CarLog, Column);
   IF ~!Column.Sort THEN
    CONFORM(Column, Sort);
    WHILE ~Sort.isDprt & ~!Sort.Parent DO
     SEARCH(Sort, Sort, , Sort.Parent);
    END;
    L_General.Assert(Sort.isDprt, "  ࠧ ஢   ⤥:  "+Column.Column);
    Result:=Sort.Sort;
   END;
  EXCEPT
  END;
  RETURN Result;
 END {E_GetCarDprt};

 PUBLIC PROCEDURE E_VldPsgPlanLev(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.VldPsgPlanLev), 0);
 END {E_VldPsgPlanLev};

 PUBLIC PROCEDURE E_NeedSEJ_RM_Ratio(P: DATE): SCAL[2];
  VAR
   Default: SCAL[2];
 BEGIN
  IF RoutMod.InPsp THEN
   Default:=(SEJobs.StopT - SEJobs.StartT) < (RoutMod.Tim[SEJobs.RtMVer] / 60);
   RETURN L_EC.ExecE_Func_Scal2(P, PROCREF(E_Way.NeedSEJ_RM_Ratio), Default);
  ELSE
   RETURN 1;
  END;
 END {E_NeedSEJ_RM_Ratio};

 PUBLIC PROCEDURE E_NeedCrankyWayIPLInterpretation(D: DATE; tcpi: ttcpi): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.NeedCrankyWayIPLInterpretation);
  IF ~!Local THEN
   RETURN Local(D, tcpi);
  ELSE
   RETURN 0;
  END;
 END {E_NeedCrankyWayIPLInterpretation};

(*------------------------------------------------------------------*)

 PRIVATE PROCEDURE DecodeRWaySId(    _RWaySId: STRING[];
                                 VAR _RWayS  : LIKE(RWayS.RWayS));
  VAR
   _XDocType: L_XDoc.tXDocType;
   _XDocKind: L_XDoc.tXDocKind;
 BEGIN
  L_XDoc.DecodeXDocId(_RWaySId, _XDocType, _XDocKind, _RWayS);
  L_General.CallUs(_XDocType = L_XDoc.xdt_RWayS);
 END {DecodeRWaySId};

 PRIVATE PROCEDURE DecodeTckRcSId(    _TckRcSId: STRING[];
                                  VAR _TckRcS  : LIKE(TckRcS.TckRcS));
  VAR
   _XDocType: L_XDoc.tXDocType;
   _XDocKind: L_XDoc.tXDocKind;
 BEGIN
  L_XDoc.DecodeXDocId(_TckRcSId, _XDocType, _XDocKind, _TckRcS);
  L_General.CallUs(_XDocType = L_XDoc.xdt_TckRcS);
 END {DecodeTckRcSId};

 PRIVATE PROCEDURE CheckExistXDocJrn(_Action: LIKE(XDocJrn.Action));
 BEGIN
  IF (_Action # L_XDoc.action_Insert) &
     (_Action # L_XDoc.action_AutoBuild) &
     (_Action # L_XDoc.action_begInsert) THEN
   SAVE(XDocJrn);
   L_General.Assert(SELECT(XDocJrn, XDocJrn, L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS),
                    "    ६ 饭");
   RESTORE(XDocJrn);
  END;
 END {CheckExistXDocJrn};

 PUBLIC PROCEDURE CurRWayS_XDocJrn_Mark(_Action: LIKE(XDocJrn.Action));
 BEGIN
  CheckExistXDocJrn(_Action);
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS, _Action);
 END {CurRWayS_XDocJrn_Mark};

 PUBLIC PROCEDURE CurRWayS_XDocJrn_Start(_Action: LIKE(XDocJrn.Action));
 BEGIN
  CheckExistXDocJrn(_Action);
  L_XDoc.XDocJrn_Start(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS, _Action);
 END {CurRWayS_XDocJrn_Start};

 PUBLIC PROCEDURE CurRWayS_XDocJrn_Stop();
 BEGIN
  L_XDoc.XDocJrn_Stop(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
 END {CurRWayS_XDocJrn_Stop};

 PUBLIC PROCEDURE extPrepareFuelInf(VAR FNorm   : LIKE(RWayS.FuelNorm);
                                    VAR FOver   : LIKE(RWayS.FuelNorm);
                                    VAR TotNorms: tNorms);
  VAR
   _Date : DATE;
   Norms : tNorms;
   dummy1: tNorm;
   dummy2,
   dummy3,
   dummy4: NUMERIC[3];
 BEGIN
  SETZERO(FNorm, FOver, TotNorms);
  IF L_Env.RealTSN(RWayS.TSN) THEN
   IF ~Mark.Electric THEN
    PrepareFNorm();
    SELECT(Quality, Quality);
    WHILE OCCURE(Quality) & (Quality.Type # QualType_Realiz) DO
     NEXT(Quality);
    END;
    SELECT(SEJobs, Exit, , RWayS.Exit);
    WHILE OCCURE(SEJobs) DO
     CONFORM(SEJobs, RoutMod);
     CONFORM(SEJobs, Route);
     CONFORM(SEJobs, WJMode);
     extCalcFN(RWayS.Date, SEJobs.StopT-SEJobs.StartT, RoutMod.Run, 0, dummy1, Norms, dummy2, dummy3, dummy4, 1);
     INC(FNorm, GetFN(Norms));
     INC(TotNorms[0], Norms[0]);
     INC(TotNorms[1], Norms[1]);
     INC(TotNorms[2], Norms[2]);
     INC(TotNorms[3], Norms[3]);
     NEXT(SEJobs);
    END; (* WHILE OCCURE(SEJobs)... *)
   END; (* IF ~Mark.Electric... *)
 
   SAVE(RWayS);
   _Date:=RWayS.Date;
   SETSEL(RWayS, sTSN, rwsStat_Rated, RWayS.TSN);
   SRCINSEL(RWayS, GE, , L_DatTim.Per(_Date));
   WHILE OCCURE(RWayS) DO
    PROMPT(L_DatTim.DateStr(RWayS.Date));
    INC(FOver, RWayS.FuelFact-RWayS.FuelNorm);
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS)... *)
   RESTORE(RWayS);
  END;
 END {extPrepareFuelInf};

 PUBLIC PROCEDURE PrepareFuelInf(VAR FNorm, FOver: LIKE(RWayS.FuelNorm));
  VAR
   Dummy: tNorms;
 BEGIN
  extPrepareFuelInf(FNorm, FOver, Dummy);
 END {PrepareFuelInf};

 PUBLIC PROCEDURE E_RWayJPlanIsEqualFact(): SCAL[2];
 BEGIN
  RETURN L_APWI.E_RWayJPlanIsEqualFactAnyObject(RWayS.Date, L_APWI.ObjectP_Income);
 END {E_RWayJPlanIsEqualFact};

 PUBLIC PROCEDURE GetUnitForPlan(_Date: DATE; _Cnd: tIncPlanCondition): NUMERIC[3];
  VAR
   cpit: tCalcPlInc;
 BEGIN
  cpit:=E_CalcPlIncType(_Date, _Cnd);
  IF    cpit = cpit_ByTime THEN
   RETURN SEJobs.StopT-SEJobs.StartT; (*⥫쭮 ३*)
  ELSIF cpit = cpit_ByTrip THEN
   RETURN 1;                          (*३*)
  ELSIF cpit = cpit_ByRun THEN
   CONFORM(SEJobs, RoutMod);
   RETURN RoutMod.Run;                (*஡  ३*)
  ELSE
   L_General.CallUs(0);
  END;
 END {GetUnitForPlan};

 PUBLIC PROCEDURE GetExitTimes(_Who: tRWSWho; VAR bT, eT: TIME);
 BEGIN
  bT:=StExit.BegTime;
  eT:=StExit.StopTim;
  IF (_Who = rwswho_Guard) & ~!StExit.GuBTime THEN
   bT:=StExit.GuBTime;
  END;
  IF (_Who = rwswho_Guard) & ~!StExit.GuETime THEN
   eT:=StExit.GuETime;
  END;
 END {GetExitTimes};

 PUBLIC PROCEDURE GetExitFullTimes(_Who: tRWSWho; VAR begTime, endTime: NUMERIC[3]);
  VAR
   bT,
   eT: TIME;
 BEGIN
  GetExitTimes(_Who, bT, eT);
  begTime:=FullBegTime(01, bT);
  endTime:=FullEndTime(01, bT, eT);
 END {GetExitFullTimes};

 PUBLIC PROCEDURE SEJobsWithGu(): SCAL[2];
  VAR
   _GuBTime,
   _GuETime: NUMERIC[3];
 BEGIN
  GetExitFullTimes(rwswho_Guard, _GuBTime, _GuETime);
  RETURN _TimeInt(FullBegTime(SEJobs.Day, SEJobs.StartT), FullEndTime(SEJobs.Day, SEJobs.StartT, SEJobs.StopT),
                  _GuBTime,                               _GuETime) > 0;
 END {SEJobsWithGu};

 PUBLIC PROCEDURE SEJobsWithWLMGu(_TSN: LIKE(Staff.TSN)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  SAVE(WayLMen);
  SELECT(WayLMen, RWayS, , RWayS.RWayS, wlmwho_Guard);
  WHILE OCCURE(WayLMen) & ~Result DO
   IF (WayLMen.TSN = _TSN) | !_TSN(**) THEN
    Result:=L_RWayS.IsSEJobsForCurWayLMen();
   END;
   NEXT(WayLMen);
  END; (* WHILE OCCURE(WayLMen) ... *)
  RESTORE(WayLMen);
  RETURN Result;
 END {SEJobsWithWLMGu};

 PUBLIC PROCEDURE GetRWaysPlIncomeFixedIPC(_ipc : tIncPlanCondition;
                                           _Exit: LIKE(StExit.Exit);
                                           _TSN : LIKE(Staff.TSN)): NUMERIC[2];
  VAR
   IncPl: NUMERIC[2];
 BEGIN
  SETZERO(IncPl);
  TRY
   CONFORM(RWayS,  Car);
   L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
   CONFORM(CarLog, Mark);
   CONFORM(RWayS, Calendar);
   PositionOnStExit(_Exit);
   CONFORM(StExit, SEJobs);
   WHILE OCCURE(SEJobs) DO
    IF (_ipc # ipc_Guard) | SEJobsWithWLMGu(_TSN) THEN
     CONFORM(SEJobs, WJMode);
     CONFORM(SEJobs, Route);
     IF SEJobsWithPlIncome(RWayS.Date) THEN
      INC(IncPl, L_APWI.E_GetPlanIncomeScope(L_APWI.piScope_RWOrdered, RWayS.Date, _ipc));
     END;
    END;
    NEXT(SEJobs);
   END; (* WHILE OCCURE(SEJobs) ... *)
  EXCEPT
  ON Exc: Exc_Root DO
   L_StdFrm.Choice("   室: "+StExit.Exit+"|" + Exc.MsgOriginalText);
   (* 祣   *)
  END; (* TRY *)
  RETURN IncPl;
 END {GetRWaysPlIncomeFixedIPC};

 PRIVATE PROCEDURE E_IPCForRWaySPlan(Mode: L_APWI.tWho2IPCMode): tIncPlanCondition;
  VAR
   GuardCnt: NUMERIC[0];
 BEGIN
  GuardCnt:=0;
  SELECT(WayLMen, RWayS, , RWayS.RWayS, wlmwho_Guard);
  WHILE OCCURE(WayLMen) DO
   INC(GuardCnt);
   NEXT(WayLMen);
  END; (* WHILE OCCURE(WayLMen) ... *)
  IF GuardCnt = 0 THEN
   RETURN L_APWI.E_rwsWho2IPC(Mode, rwswho_Driver, 1);
  ELSE
 (* ath.Min(GuardCnt, 1) - 0072721 18.08.2009 14:16:53 POLAK\LDA *)
   RETURN L_APWI.E_rwsWho2IPC(Mode, rwswho_Guard, Math.Min(GuardCnt, 1));
  END;
 END {E_IPCForRWaySPlan};

 PUBLIC PROCEDURE GetExitPlan(): NUMERIC[2];
 BEGIN
  RETURN GetRWaysPlIncomeFixedIPC(E_IPCForRWaySPlan(L_APWI.w2im_toPrintInRWayS), RWayS.Exit, EMPTYOF(Staff.TSN));
 END {GetExitPlan};

 PUBLIC PROCEDURE E_GetIPCForTckRcSIncomePlan(D: DATE): tIncPlanCondition;
 BEGIN
  RETURN E_IPCForRWaySPlan(L_APWI.w2im_toPrintInTckRcS);
 END {E_GetIPCForTckRcSIncomePlan};

 PUBLIC PROCEDURE GetIncomePlanForTRS(): NUMERIC[2];
 BEGIN
  IF (TckRcS.AsWho # trs_Chopper) THEN
   L_APWI.StandOnRWaySExit();
   RETURN GetRWaysPlIncomeFixedIPC(E_GetIPCForTckRcSIncomePlan(RWayS.Date), StExit.Exit, TckRcS.TSN);
  END;
  RETURN 0;
 END {GetIncomePlanForTRS};

 PUBLIC PROCEDURE CrewHasMyFirmContradiction(D      : DATE;
                                             _TSN   : LIKE(Staff.TSN);
                                             _BoxNbr: LIKE(Car.BoxNbr)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
   IF ~!_TSN & ~!_BoxNbr & L_Env.RealTSN(_TSN) THEN
    SAVE(Staff);
    SEARCH(Staff, TSN, , _TSN);
    Result:=(Staff.MyFirm # L_Car.GetCarMyFirm(_BoxNbr, D));
    RESTORE(Staff);
   END;
  END;
  RETURN Result;
 END {CrewHasMyFirmContradiction};

 PUBLIC PROCEDURE GetRWaySMyFirm(): P_Firm.tMyFirm;
 BEGIN
  RETURN L_Car.GetCarMyFirm(RWayS.BoxNbr, RWayS.Date);
 END {GetRWaySMyFirm};

 PRIVATE PROCEDURE HasRouteLog(D: DATE): SCAL[2];
 BEGIN
  L_General.CallUs(OCCURE(Route));
  HISTCONF(D, Route, RouteLog);
  RETURN OCCURE(RouteLog);
 END {HasRouteLog};

 PUBLIC PROCEDURE PositionOnRouteLog(_Route: LIKE(Route.Route); D: DATE);
 BEGIN
  SETSEL(RouteLog, Route, _Route);
  IF ~SRCINSEL(RouteLog, LE, D) THEN
   L_StdFrm.WrongDB(" "+_Route+"   ਨ  "+L_DatTim.DateStr(D));
  END;
 END {PositionOnRouteLog};

 PUBLIC PROCEDURE StandOnRouteTKind(D: DATE);
 BEGIN
  IF HasRouteLog(D) THEN
   CONFORM(RouteLog, TKind);
  ELSE
   L_General.CLEAR("TKind");
  END;
 END {StandOnRouteTKind};

 PUBLIC PROCEDURE StandOnRouteJRegime(D: DATE);
 BEGIN
  IF HasRouteLog(D) THEN
   CONFORM(RouteLog, JRegime);
  ELSE
   L_General.CLEAR("JRegime");
  END;
 END {StandOnRouteJRegime};

 PUBLIC PROCEDURE GetRouteTKind(D: DATE; Strong: SCAL[2]): LIKE(Route.TKind);
  VAR
   Result: LIKE(Route.TKind);
 BEGIN
  SAVE(RouteLog);
  IF HasRouteLog(D) THEN
   Result:=RouteLog.TKind;
  ELSE
   L_General.Assert(~Strong, "  " + Route.Route +
                             "  饣  ॢ  " + L_DatTim.DateStr(D));
   SETEMPTY(Result);
  END;
  RESTORE(RouteLog);
  RETURN Result;
 END {GetRouteTKind};

 PUBLIC PROCEDURE GetRouteJRegime(D: DATE; Strong: SCAL[2]): LIKE(Route.JRegime);
  VAR
   Result: LIKE(Route.JRegime);
 BEGIN
  SAVE(RouteLog);
  IF HasRouteLog(D) THEN
   Result:=RouteLog.JRegime;
  ELSE
   L_General.Assert(~Strong, "  " + Route.Route +
                             "  饣 ० ࠡ  " + L_DatTim.DateStr(D));
   SETEMPTY(Result);
  END;
  RESTORE(RouteLog);
  RETURN Result;
 END {GetRouteJRegime};

 PUBLIC PROCEDURE GetMyPlace(D        : DATE;
                             trgBoxNbr: LIKE(Car.BoxNbr);
                             trgTSN   : LIKE(Staff.TSN);
                             trgExit  : LIKE(StExit.Exit)): LIKE(MyPlace.MyPlace);
  VAR
   tmpSort   : LIKE(Sort.Sort);
   Result,
   CarMyPlace,
   StfMyPlace,
   ExtMyPlace: LIKE(MyPlace.MyPlace);
   doCheck   : SCAL[2];
 BEGIN
  SETEMPTY(Result);
  IF P_Firm.E_wMultipleMyPlace(D) THEN
   TRY [RESTORE_CURSORS(RC_ON)]
    IF ~!trgBoxNbr & L_Env.RealBoxNbr(trgBoxNbr) THEN
     L_Car.StandOnCarLog(trgBoxNbr, D);
     CarMyPlace:=P_Column.GetMyPlace(CarLog.Column, D);
    ELSE
     SETEMPTY(CarMyPlace);
    END; (* IF ~!trgBoxNbr...*)

    Result:=CarMyPlace;

    IF ~!trgTSN & L_Env.RealTSN(trgTSN) THEN
     SEARCH(Staff, TSN, , trgTSN);
     L_Staff.PosToStaffLog(trgTSN, D, 1);
     StfMyPlace:=P_Sort.GetMyPlace(StaffLog.Sort, D);
    ELSE
     SETEMPTY(StfMyPlace);
    END; (* IF ~!trgTSN...*)

    IF !Result THEN
     Result:=StfMyPlace;
    END;

    IF L_APtm.IsOG() THEN
     doCheck:=1;
     IF ~!trgExit THEN
      SEARCH(StExit, Exit, , trgExit);
      doCheck:=~E_Way.IsPeregon();
     END;
    ELSE
     doCheck:=0;
    END;

    IF ~!CarMyPlace & ~!StfMyPlace & doCheck THEN
     L_General.Assert(CarMyPlace = StfMyPlace, " "+trgBoxNbr+"  ࠡ⭨ "+trgTSN+"|⭮  ࠧ ⮯ ந⢥ 頤");
    END;
 
    IF ~!trgExit THEN
     tmpSort:=E_GetFixedSortOfExit(trgExit, D, EMPTYOF(tRWSWho));
     IF ~!tmpSort THEN
      ExtMyPlace:=P_Sort.GetMyPlace(tmpSort, D);
      IF doCheck THEN
       IF    ~!StfMyPlace THEN
        L_General.Assert(ExtMyPlace = StfMyPlace, "室 "+trgExit+"  ࠡ⭨ "+trgTSN+"|⭮  ࠧ ⮯ ந⢥ 頤");
       ELSIF ~!CarMyPlace THEN
        L_General.Assert(ExtMyPlace = CarMyPlace, "室 "+trgExit+"   "+trgBoxNbr+"|⭮  ࠧ ⮯ ந⢥ 頤");
       END;
      END;
      IF !Result THEN
       Result:=ExtMyPlace;
      END;
     END; (* IF ~!tmpSort *)
    END; (* IF ~!trgExit *)
   EXCEPT
   ON Exc: Exc_Raise DO
    L_General.Assert_wReferToAdmin(0, Exc.MsgOriginalText);
    SETEMPTY(Result);
   END; (* TRY *)
  END; (* IF P_Firm.E_wMultipleMyPlace(D)...*)
  IF !Result THEN
   Result:=P_Firm.mp_Fict;
  END;
  RETURN Result;
 END {GetMyPlace};

 PUBLIC PROCEDURE intIsAllowedPlace(D: DATE; _BoxNbr: LIKE(Car.BoxNbr); _TSN: LIKE(Staff.TSN); _Exit: LIKE(StExit.Exit)): SCAL[2];
 BEGIN
  RETURN P_Firm.IsAllowedMyPlace(GetMyPlace(D, _BoxNbr, _TSN, _Exit));
 END {intIsAllowedPlace};

 PUBLIC PROCEDURE ClearRWayS(_Source: LIKE(RWayJP.Source); Clear: SCAL[2]);
 BEGIN
  SETSEL(RWayS, Date);
  SRCINSEL(RWayS, GE, , Memo.ud_mb());
  WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.ud_me()) DO
   PROMPT(L_Str.PoolItem("஢ઠ |⪠ ", Clear) + " " + L_DatTim.DateStr(RWayS.Date) + " " + RWayS.RWayS);
   L_General.Assert(~RWayS.Done, "    ࠡ⠭묨");
   IF Clear THEN
    SELECT(RWayJP, RWayS, , RWayS.RWayS);
    WHILE OCCURE(RWayJP) DO
     IF RWayJP.Source = _Source THEN
      REMOVE(RWayJP);
     ELSE
      NEXT(RWayJP);
     END;
    END; (* WHILE OCCURE(RWayJP) ... *)
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 END {ClearRWayS};

 PUBLIC PROCEDURE IsRepairRWayS(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  SAVE(StExit);
  SAVE(ExitClss);
  CONFORM(RWayS, StExit);
  CONFORM(StExit, ExitClss);
  Result:=L_kn.Is(SYSDATE(), erkn_ec_CurRepair)   |
          L_kn.Is(SYSDATE(), erkn_ec_TO2)         |
          L_kn.Is(SYSDATE(), erkn_ec_RepairWODrv) |
          L_kn.Is(SYSDATE(), erkn_ec_Overhaul)    |
          L_kn.Is(SYSDATE(), erkn_ec_InWaitingForRepair);
  RESTORE(ExitClss);
  RESTORE(StExit);
  RETURN Result;
 END {IsRepairRWayS};

 PUBLIC PROCEDURE E_GetTOL(D: DATE): tTripOutLine;
  VAR
   Local   : PROC;
   Result  : tTripOutLine;
   _Name   : STRING[];
   _WJCode : LIKE(WJMode.WJCode);
   _Quality: LIKE(Quality.Quality);
   _Trip   : LIKE(SEJobs.Trip);
 BEGIN
  SETEMPTY(Result);
  Local:=PROCREF(E_Utils.stol_GetElement);
  IF ~!Local THEN
   Local(RWayS.Date, 0, _Name, _WJCode, _Quality, _Trip, Result);
  END;
  RETURN Result;
 END {E_GetTOL};

 PUBLIC PROCEDURE E_IsImaginaryRoute(trgDate: DATE; trgRoute: LIKE(Route.Route)): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.IsImaginaryRoute);
  IF ~!Local THEN
   RETURN Local(trgDate, trgRoute);
  ELSE
   RETURN trgRoute = "9999";
  END;
 END {E_IsImaginaryRoute};

 PUBLIC PROCEDURE FullStExitBegTimeStr(): STRING[];
 BEGIN
  RETURN FLDTOSTR((StExit.BegDay-1)+(StExit.BegTime-00:00)/24, "RH:M");
 END {FullStExitBegTimeStr};

 PUBLIC PROCEDURE FullStExitStopTimStr(): STRING[];
 BEGIN
  RETURN FLDTOSTR((StExit.BegDay>1)*(StExit.BegDay-1+(StExit.BegTime>StExit.StopTim))+(StExit.StopTim-00:00)/24, "RH:M");
 END {FullStExitStopTimStr};

 PRIVATE VAR
  QualityStat: SCAL[2];

BEGIN
 QualityStat:=1;
END.
