(*
%Copyright   (c) Polak IT
%Author      15.08.2012 19:17:22 POLAK\LDA
%Purpose     ࠧ  㤮 ⥫쭮  / ਮ
%Type        report
%Specific    AP
%Modified    13.03.2013 18:43:08 POLAK\GAV
%Environment
*)

 MODULE MActv [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_Basis, L_bp, FIO, L_Man, L_General, L_Str, L_Staff, L_DatTim;

 PRIVATE PROCEDURE MActv_MakeTop(F: STRING[]);
 BEGIN
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, " ஦");
  L_Basis.wb_WrStr(F, " ⥫⢠");
  L_Basis.wb_WrStr(F, "࠭");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "⥣");
  L_Basis.wb_WrStr(F, "⥣");
  L_Basis.wb_WrStr(F, "⠦  ");
  L_Basis.wb_WrStr(F, " ⥫쭮");
  L_Basis.wb_WrStr(F, " ࠧ");
  L_Basis.wb_WrStr(F, "ଠ 祭");
  L_Basis.wb_WrStr(F, "砫");
  L_Basis.wb_WrStr(F, "砭");
  L_Basis.wb_WrStr(F, "࣠");
  L_Basis.wb_WrStr(F, "⥫쭮");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, " 㬥");
  L_Basis.wb_WrStr(F, " 㬥");
  L_Basis.wb_WrStr(F, " 㬥");
  L_Basis.wb_WrStr(F, " 砭 㬥");
  L_Basis.wb_WrStr(F, "㬥 ⢨⥫");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, " ");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, " ");
  L_Basis.wb_WrStr(F, "᭮ ");
  L_Basis.wb_TermLine(F);
 END {MActv_MakeTop};

 PRIVATE PROCEDURE wb_WrPoolItem(F, Pool: STRING[]; Item: NUMERIC[0]);
 BEGIN
  IF ~!Item THEN
   L_Basis.wb_WrStr(F, L_Str.PoolItem(Pool, Item));
  ELSE
   L_Basis.wb_WrStr(F, "");
  END;
 END {wb_WrPoolItem};

 PRIVATE PROCEDURE MActv_MakePart(F: STRING[]; D: DATE; wSLData: SCAL[2]);
 BEGIN
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrDat(F, Man.Birth);
  L_Basis.wb_WrStr(F, L_Man.CitizenAsStr(Man.Man, D));
  CONFORM(ManAdr, Country);
  L_Basis.wb_WrStr(F, Country.Name);
  L_Basis.wb_WrStr(F, ManAdr.RegionN);
  IF wSLData THEN
   CONFORM(StaffLog, Post);
   CONFORM(StaffLog, Sort);
   CONFORM(StaffLog, Union);
   L_Basis.wb_WrScl(F, Post.Post);
   L_Basis.wb_WrStr(F, Post.Name);
   L_Basis.wb_WrScl(F, Sort.Sort);
   L_Basis.wb_WrStr(F, Sort.Name);
   L_Basis.wb_WrScl(F, Union.Union);
   L_Basis.wb_WrStr(F, Union.Name);
  ELSE
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_WrDat(F, L_Staff.E_GetBegInFirm(Memo.ud_cd()));
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Man.actvk_Pool, ManActv.ActvKind));
  IF ManActv.ActvKind = L_Man.actvk_FurtherTrain THEN
   wb_WrPoolItem(F, L_Man.traintype_Pool, ManActv.EdType);
  ELSE
   wb_WrPoolItem(F, L_Man.edtype_Pool, ManActv.EdType);
  END;
  wb_WrPoolItem(F, L_Man.edform_Pool, ManActv.EdForm);
  L_Basis.wb_WrDat(F, ManActv.BegDate);
  L_Basis.wb_WrDat(F, ManActv.EndDate);
  L_Basis.wb_WrStr(F, ManActv.FndName);
  L_Basis.wb_WrStr(F, ManActv.DepName);
  L_Basis.wb_WrStr(F, ManActv.Result);
  wb_WrPoolItem(F, L_Man.eddoctype_Pool, ManActv.DocType);
  L_Basis.wb_WrStr(F, ManActv.DocNum);
  L_Basis.wb_WrDat(F, ManActv.DocDate);
  L_Basis.wb_WrDat(F, ManActv.DocExpD);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("|", L_DatTim.IsActive(D, ManActv.DocDate, ManActv.DocExpD)));
  L_Basis.wb_WrScl(F, ManActv.OKPDTR);
  IF ~!ManActv.OKPDTR THEN
   CONFORM(ManActv, OKPDTR);
   L_Basis.wb_WrStr(F, OKPDTR.Name);
  ELSE
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_WrScl(F, ManActv.OKSO);
  IF ~!ManActv.OKSO THEN
   CONFORM(ManActv, OKSO);
   L_Basis.wb_WrStr(F, OKSO.Name);
  ELSE
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_WrStr(F, ManActv.Main);
  L_Basis.wb_TermLine(F);
 END {MActv_MakePart};

 PUBLIC PROCEDURE MAct1();
  CONST
   bpId = "MAct1";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, "ࠧ  㤮 ⥫쭮", L_bp.t_Basis, L_General.tc_onDate);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MActv_MakeTop("R");
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   IF L_Staff.rInState(Memo.ud_cd()) THEN
    CONFORM(Staff, Man);
    SELECT(ManActv, Man, , Man.Man);
    WHILE OCCURE(ManActv) DO
     MActv_MakePart("R", Memo.ud_cd(), 1);
     NEXT(ManActv);
    END; (* WHILE OCCURE(ManActv) ... *)
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  FIO.Close(R);
  L_bp.End();
 END {MAct1};

END.
