(*
%Copyright   (c) Polak IT
%Author      09.06.2011 18:26:58 POLAK\LDA
%Purpose      ९  
%Type        report
%Specific    AP
%Modified    10.09.2013 12:13:03 POLAK\GAV
%Environment
*)

 IMPORT L_General, L_General, L_Car, L_AFM, Memo, L_Basis, FIO, P_Staff, L_Str, L_bp, L_Staff, L_Env;

 PRIVATE PROCEDURE MCF01_Top(F: STRING[]);
 BEGIN
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "⤥");
  L_Basis.wb_WrStr(F, "⤥");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "⥣");
  L_Basis.wb_WrStr(F, "⥣");
  L_Basis.wb_WrStr(F, "ࠦ");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "ઠ");
  L_Basis.wb_WrStr(F, "ઠ");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "ॢ");
  L_Basis.wb_WrStr(F, "ॢ");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "⤥");
  L_Basis.wb_WrStr(F, "⤥");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "⥣");
  L_Basis.wb_WrStr(F, "⥣");
  L_Basis.wb_WrStr(F, "ਪ");
  L_Basis.wb_WrStr(F, "ਪ");
  L_Basis.wb_WrStr(F, "ਪ");
  L_Basis.wb_WrStr(F, "९");
  L_Basis.wb_TermLine(F);
 END {MCF01_Top};

 PRIVATE PROCEDURE MCF01_Line_OneStaff(F: STRING[]; oc: SCAL[2]);
 BEGIN
  IF oc THEN
   CONFORM(StaffLog, Officer);
   CONFORM(Officer, Sort);
   CONFORM(Officer, Post);
   CONFORM(Officer, Union);
   CONFORM(Staff, Man);
   L_Basis.wb_WrScl(F, Staff.TSN);
   L_Basis.wb_WrStr(F, Man.Name);
   L_Basis.wb_WrScl(F, Sort.Sort);
   L_Basis.wb_WrStr(F, Sort.Name);
   L_Basis.wb_WrScl(F, L_Staff.getDepart());
   L_Basis.wb_WrStr(F, L_Staff.getDepartName());
   L_Basis.wb_WrScl(F, Post.Post);
   L_Basis.wb_WrStr(F, Post.Name);
   L_Basis.wb_WrScl(F, Union.Union);
   L_Basis.wb_WrStr(F, Union.Name);
  ELSE
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "----");
  END;
 END {MCF01_Line_OneStaff};

 PRIVATE PROCEDURE MCF01_Line(F: STRING[]; wDr, wCar: SCAL[2]; _Nbr: LIKE(MCFix.Nbr));
 BEGIN
  MCF01_Line_OneStaff(F, wDr);
  IF wCar THEN
   L_Car.StandOnCarLog(Car.BoxNbr, Memo.ud_cd());
   CONFORM(CarLog, Mark);
   CONFORM(CarLog, TKind);
   L_Basis.wb_WrScl(F, Car.BoxNbr);
   L_Basis.wb_WrStr(F, CarLog.StateNbr);
   L_Basis.wb_WrScl(F, Mark.Mark);
   L_Basis.wb_WrStr(F, Mark.Name);
   L_Basis.wb_WrScl(F, CarLog.Column);
   IF OCCURE(TKind) THEN
    L_Basis.wb_WrScl(F, TKind.TKind);
    L_Basis.wb_WrStr(F, TKind.Name);
    IF ~!TKind.FnMode THEN
     L_Basis.wb_WrStr(F, L_Str.PoolItem("樮|᪨|稥", TKind.FnMode));
    ELSE
     L_Basis.wb_WrStr(F, "----");
    END;
   ELSE
    L_Basis.wb_WrStr(F, "--");
    L_Basis.wb_WrStr(F, "----");
    L_Basis.wb_WrStr(F, "----");
   END;
  ELSE
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "----");
  END;
  SAVE(Staff);
  MCF01_Line_OneStaff(F, wDr &
                         P_Staff.HasActualStaffPro(Staff.TSN, Memo.ud_cd(), P_Staff.P_FixedGuard) &
                         SEARCH(Staff, TSN, P_Staff.GetFixedGuard(StaffPro.Value)) &
                         L_Staff.rInState(Memo.ud_cd()));
  RESTORE(Staff);
  IF OCCURE(MCFix) & ~!MCFix._EDOrder THEN
   L_General.Assert(SEARCH(EDOrder, EDOrder, MCFix._EDOrder), "  ਪ " + MCFix._EDOrder);
   L_Basis.wb_WrScl(F, EDOrder.EDOrder);
   L_Basis.wb_WrStr(F, EDOrder.SrcNum);
   L_Basis.wb_WrDat(F, EDOrder.Date);
  ELSE
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrDat(F, L_General.EMPTY_DATE());
  END;
  IF ~!_Nbr THEN
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Car.mcfn_Pool, _Nbr));
  ELSE
   L_Basis.wb_WrStr(F, "----");
  END;
  L_Basis.wb_TermLine(F);
 END {MCF01_Line};

 PRIVATE PROCEDURE MCF01_MakeSingleMCFix();
 BEGIN
  CONFORM(MCFix, Car);
  ADD(tmp, tmp, , Car.BoxNbr);
  MCF01_Line("F", 1, L_Car.CarIsInOperation(Car.BoxNbr, Memo.ud_cd()), MCFix.Nbr);
 END {MCF01_MakeSingleMCFix};

 PRIVATE PROCEDURE MCF01();
  CONST
   bpId = "MCF01";
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_bp.Begin(bpId, " ९", L_bp.t_Basis, L_General.timeCond_OnDate);
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  MCF01_Top("F");
  L_AFM.MakeIndex("tmp", "BoxNbr: LIKE(Car.BoxNbr)");
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   IF L_Staff.rInState(Memo.ud_cd()) THEN
    CONFORM(StaffLog, Officer);
    IF    L_Car.StandOnFirstMCFix(Staff.TSN, Memo.ud_cd()) THEN
     MCF01_MakeSingleMCFix();
    ELSIF L_Env.IsDriver() THEN
     MCF01_Line("F", 1, 0, L_Car.mcfn_1);
    END;
    IF L_Car.StandOnSecondaryMCFix(Staff.TSN, Memo.ud_cd()) THEN
     MCF01_MakeSingleMCFix();
    END;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)

  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT(Car.BoxNbr);
   IF L_Car.CarIsInOperation(Car.BoxNbr, Memo.ud_cd()) &
      ~SEARCH(tmp, tmp, Car.BoxNbr) THEN
    MCF01_Line("F", 0, 1, L_General.EMPTY_NUMBER());
   END;
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
  L_AFM.AF_PurgeTemp("tmp");
  FIO.Close(F);
  L_bp.End();
 END {MCF01};

END.
