(*
%Copyright   (c) Polak Computer System
%Author      GINA
%Purpose     ⮪ 뤠 2- ᬥ  뤠 /  /
%Type        operation
%Specific    AP
%Modified    28.03.2005 11:12:37 lda
%Environment
*)

 IMPORT L_General, L_OwnData, L_DatTim, L_BegRWS, L_Way, DBD;

 CONST
  RepName = "BadC2";

(*
$P { PageTop:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE() , L, "D.N.y"
SYSTIME() , L, "H:M"
RepName , L, ""
_Date , L, "D.N.y"
@
############################################################# ########## #####
-#####------------------------------------------------------------------------
|          ஡  뤠祩 ⥢ ⮢ 2 ᬥ  ##########           |
|============================================================================|
|      |६|  | |室    |ᠭ ஡                     |
|----------|-----|-----|----|---------|--------------------------------------|
}

$P { Line:
RWayS.Date, L, "D.N.y"
RWayS.StartTim, L, "H:M"
RWayS.TSN, L, ""
RWayS.BoxNbr, L, ""
RWayS.Exit, L, ""
?, L, ""
@
|##########|#####|#####|####|#########|######################################|
}

$P { PageBot:
@
=(c) Polak====================================================================
}
*)

 VAR
  BadCount: NUMERIC[0];
  _Date   : DATE;

BEGIN
 L_BegRWS.DispOnly();

 _Date:=SYSDATE();

 OPENREP(Bad, L_General.NameConnection(RepName), Create);
 MAKEPART(Bad, PageTop);

 SETZERO(BadCount, L_BegRWS.ToBeVerifiedRWaySCnt);
 SELECT(RWayS, Date, , _Date);
 WHILE OCCURE(RWayS) DO
  IF RWayS.Status = L_Way.rwsStat_Ordered THEN
   PROMPT(L_DatTim.TimeStr(RWayS.StartTim));
   CONFORM(RWayS, StExit);
   IF (RWayS.Change = 2(*ᬥ*)) & (StExit.OutBox = 2(* /*)) THEN
    SAVE(RWayS);
    CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr, _Date);
    IF PREV(RWayS) & (RWayS.Status >= L_Way.rwsStat_Given) THEN
     RESTORE(RWayS);
     IF DBD.FileExist(CWOrder) & SELECT(CWOrder, RWayS, RWayS.RWayS) THEN
      MAKEPART(Bad, Line, "⮪ 뤠 :  ");
      INC(BadCount);
     ELSE
      IF PROCESS(BegRWS, 084) = 0 THEN
       IF PROCESS(BegRWS, 085) # 0 THEN
        MAKEPART(Bad, Line, " ⯥⠭");
        INC(BadCount);
       END;
      ELSE
       MAKEPART(Bad, Line, " 뤠");
       INC(BadCount);
      END;
     END;
    ELSE
     RESTORE(RWayS);
    END; (* IF *)
   END;
  END; (* IF RWayS.Status = ... *)
  NEXT(RWayS);
 END; (* WHILE OCCURE(RWayS) ... *)
 MAKEPART(Bad, PageBot);
 CLOSEREP(Bad);

 IF BadCount > 0 THEN
  LIKEMENU(Survey, L_General.NameConnection(RepName));
 END;

END.
