(*
%Copyright   (c) Polak Computer System
%Author      06.10.1999 17:56:31 SAN
%Purpose     ஢ ਮ᪨ ६ ய⨩
%Type        operation
%Specific    AP
%Modified    16.07.2014 12:54:07 POLAK\GAV
%Environment
*)

 PUBLIC CONST
  MaxGrp      = 50;
  grp_Total   = 0;
  MaxAttendRE = 16;
  localGrpIdx = "local";

  src_NotFrCast   = 0;
  src_OtherFrCast = 1;
  src_ThisFrCast  = 2;
  srcPool = "|| ";

 IMPORT L_General, L_DatTim, L_Car, L_OwnData, Math, L_AFM, L_EC,
        L_StdFrm, L_Str, Str, L_Env, L_Way, L_Basis, FIO, L_PagePr,
        P_Car, Memo, DBD, E_Way, L_Hld, L_bp, L_SysLog;

 TYPE
  tPiece   = SCAL[10];
  tGroupBy = SCAL[4];

 CONST
  REPln_RepName = "REPln";

 PUBLIC VAR
  BaseDate,
  MinTargetDate,
  MaxTargetDate  : DATE;
  plnRepEvent    : LIKE(RepEvent.RepEvent);
  TeamOnBD,
  CurTeam        : NUMERIC[0];
  Piece          : tPiece;
  MaxDuration    : NUMERIC[0];
  NbrOfCar,
  CntInDay       : NUMERIC[0][MaxGrp];
  _MarkG         : STRING[][MaxGrp];
  MakeProtocol,
  HasTrouble     : SCAL[2];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
REPln_RepName, L, ""
?, C, ""
RepEvent.Name + " " + REPrm.Name, C, ""
REFrCast.REFrCast, L, ""
REFrCast.BaseDate, L, "D.N.y"
REFrCast.sysDate, L, "D.N.y"
REFrCast.sysTime, L, "H:M"
@
########################################################################### ########## #####
=#####======================================================================================
|##########################################################################################|
|##########################################################################################|
|ண #######                  ##########              ⠬ ########## #####|
}
*)

(*
$P{ HasTroubleSubtop:
@
|==========================================================================================|
|          ஢ 뫨 ஡ - . ⮪  襤訬  ᬮ७         |
}
*)


 PRIVATE PROCEDURE E_CurTeamName(): STRING[];
  VAR
   Local: PROC;
 BEGIN
  IF REPrm.TeamAmnt > 1 THEN
   Local:=PROCREF(E_RE.TeamName);
   IF ~!Local THEN
    RETURN Local();
   END;
   RETURN "ਣ  " + L_Str.IntStr(CurTeam);
  END;
  RETURN "";
 END {E_CurTeamName};

(*
$P{ OneDate:
?, L, "D.N.y"
E_CurTeamName(), L, ""
?, R, "0"
?, R, ""
@
|==========================================================================================|
| ########## ############################################      ᥣ ###      ###########|
|------------------------------------------------------------------------------------------|
| |.  |ઠ                           || ᫥| ஡|% ९.| |  |
}
*)

(*
$P{ DlmLine:
@
|----|----------|--------------------------------|--|----------|-------|---------|------|--|
}
*)

(*
$P{ Line:
Car.BoxNbr, L, ""
CarLog.StateNbr, L, ""
Mark.Name, L, ""
CarLog.Column, L, ""
?, L, "D.N.y"
?, R, "0"
?, R, "2."
?, R, "1."
?, L, ""
@
|####|##########|################################|##|##########|#######|#########|######|##|
}
*)

(*
$P{ EmptyLine:
@
|----|----------|--------------------------------|--|----------|-------|---------|------|--|
|    |          |                                |  |          |       |         |      |  |
}
*)

(*
$P{ dbgTop:
@
|------------------------------------------------------------------------------------------|
|     |                                               |।. |஡.|   |஡ |%   |  |
| |  .    ઠ                       |ய. |।. || |/|  |
|-----|-----------------------------------------------|--------|------|----|-------|----|--|
}
*)

(*
$P{ dbgLine:
?, L, "D.N"
Car.BoxNbr, L, ""
CarLog.StateNbr, L, ""
CarLog.Column, L, ""
Mark.Name, L, ""
?, L, "D.N.Y"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, L, ""
@
|#####|#### ########## ## ############################|########|######|####|#######|####|##|
}
*)

(*
$P{ dbgErrTop:
@
|------------------------------------------------------------------------------------------|
| |.  |.஡|稭 ᪫祭  ᬮ७                              |
|----|----------|---------|----------------------------------------------------------------|
}
*)

(*
$P{ dbgErr:
CarLog.BoxNbr, L, ""
CarLog.StateNbr, L, ""
?, R, "3."
?, L, ""
@
|####|##########|#########|################################################################|
}
*)

(*
$P{ Bot:
@
=(c) Polak==================================================================================
}
*)

(*
$P{ Req_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
@
########################################################################################### ########## #####
=#####======================================================================================================
}
*)

(*
$P{ Req_Title:
?, C, ""
@
|##########################################################################################################|
}
*)

(*
$P{ Req_SubTitle:
?, L, ""
@
|----------------------------------------------------------------------------------------------------------|
|##########################################################################################################|
}
*)

(*
$P{ Req_SubTop:
@
|----------------------------------------------------------------------------------------------------------|
|  |    |          |                                     |          |      |       ஡       |          |
|| |.  |ઠ                                |᫥ | ଠ|--------------------|ண   |
|  |    |          |                                     |          |      | .|    %| |          |
|--|----|----------|-------------------------------------|----------|------|-------|-----|------|----------|
}
*)

(*
$P{ Req_Line:
?, L, ""
Car.BoxNbr, L, ""
CarLog.StateNbr, L, ""
Mark.Mark, L, ""
Mark.Name, L, ""
?, L, "D.N.y"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "1."
?, L, "D.N.y"
@
|##|####|##########|#### ################################|##########|######|#######|#####|######|##########|
}
*)

(*
$P{ Req_Bot:
@
=(c) Polak==================================================================================================
}
*)

 PRIVATE PROCEDURE E_ProtocolName(): STRING[];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_RE.ProtocolName);
  IF ~!Local THEN
   RETURN Local();
  END;
  RETURN "⮪ ஢ ய";
 END {E_ProtocolName};

 PRIVATE PROCEDURE E_PrintLocalPart(Local: PROC);
 BEGIN
  IF ~!Local THEN
   Local();
  END;
 END {E_PrintLocalPart};

 PRIVATE PROCEDURE _RprtTop(Mode: SCAL[20]);
 BEGIN
  IF Mode = L_PagePr.m_Print THEN
   E_PrintLocalPart(PROCREF(E_RE.PrintApproves));
   MAKEPART(R, Top, E_ProtocolName() + "  ਮ  " +
                    L_DatTim.DateStr(MinTargetDate) + "  " + L_DatTim.DateStr(MaxTargetDate));
   IF HasTrouble THEN
    MAKEPART(R, HasTroubleSubtop);
   END;
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtTop};

 PRIVATE PROCEDURE _PageTop(Mode: SCAL[20]);
 BEGIN
  IF (Mode # L_PagePr.m_Print) & (Mode # L_PagePr.m_RDoneTop) THEN
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageTop};

 PRIVATE PROCEDURE _PageBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(Bot));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, Bot);
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_None);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageBot};

 PRIVATE PROCEDURE _RprtBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(Bot) + L_EC.ExecE_Func_Numeric(BaseDate, PROCREF(E_RE.SignsDepth), 0));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, Bot);
   E_PrintLocalPart(PROCREF(E_RE.PrintSigns));
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_Print);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtBot};

 PRIVATE PROCEDURE _Filling(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(0);
  ELSIF Mode = L_PagePr.m_Print THEN
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_Filling};

 PRIVATE PROCEDURE GetId(): LIKE(CarEvn.DocNbr);
 BEGIN
  RETURN BaseDate - L_DatTim.MINDATE() + (Piece-1)*10000;
 END {GetId};

 PRIVATE PROCEDURE CleanRefrCast();
  VAR
   HasEvents: SCAL[2];
 BEGIN
  SELECT(REFrCast, REFrCast);
  WHILE OCCURE(REFrCast) DO
   HasEvents:=0;
   SELECT(CarEvn, RepEvent, , REFrCast.RepEvent, L_Car.src_FrCast);
   WHILE ~HasEvents & OCCURE(CarEvn) DO
    HasEvents:=CarEvn.DocNbr = REFrCast.REFrCast;
    NEXT(CarEvn);
   END; (* WHILE OCCURE(CarEvn) ... *)
   IF HasEvents THEN
    NEXT(REFrCast);
   ELSE
    REMOVE(REFrCast);
   END;
  END; (* WHILE OCCURE(REFrCast) ... *)
 END {CleanRefrCast};

 PRIVATE PROCEDURE InsForeCast();
 BEGIN
  CleanRefrCast();
  SELECT(CarEvn, RepEvent, , plnRepEvent, L_Car.src_FrCast);
  IF SELECT(REFrCast, RepEvent, plnRepEvent, GetId()) THEN
   REFrCast.sysDate :=SYSDATE();
   REFrCast.sysTime :=SYSTIME();
   REPLACE(REFrCast);
  ELSE
   DEFAULT(REFrCast);
   REFrCast.RepEvent:=plnRepEvent;
   REFrCast.FCId    :=GetId();
   REFrCast.sysDate :=SYSDATE();
   REFrCast.sysTime :=SYSTIME();
   REFrCast.BaseDate:=BaseDate;
   INSERT(REFrCast);
  END;
 END {InsForeCast};

 PRIVATE PROCEDURE IncCounters(D: DATE; Count: NUMERIC[0]);
  VAR
   GrpIdx: NUMERIC[0];
 BEGIN
  INC(CntInDay[grp_Total], Count);
  GrpIdx:=1;
  WHILE ~!NbrOfCar[GrpIdx] DO
   INC(CntInDay[GrpIdx], IsInGrp(D, GrpIdx) * Count);
   INC(GrpIdx);
  END;
 END {IncCounters};

 PRIVATE PROCEDURE InsCarEvn(curBoxNbr  : LIKE(Car.BoxNbr);
                             curStartD,
                             curStopD   : DATE;
                             curRepEvent: LIKE(RepEvent.RepEvent);
                             curDocNbr  : LIKE(CarEvn.DocNbr);
                             curSource  : LIKE(CarEvn.Source));
 BEGIN
  L_General.CallUs(SEARCH(RepEvent, RepEvent, curRepEvent));
  L_General.Assert(L_DatTim.IsActive(curStartD, RepEvent.Begin, RepEvent.Till),
                   "ய⨥ " + curRepEvent + "   " + L_DatTim.DateStr(curStartD));
  CarEvn.BoxNbr  :=curBoxNbr;
  CarEvn.StartD  :=curStartD;
  CarEvn.StopD   :=curStopD;
  CarEvn.RepEvent:=curRepEvent;
  CarEvn.DocNbr  :=curDocNbr;
  CarEvn.Source  :=curSource;
  INSERT(CarEvn);
  L_SysLog.SingleMark_AutoBuild("CarEvn");
 END {InsCarEvn};

 PRIVATE PROCEDURE Ins(BegDate, EndDate: DATE);
 BEGIN
  InsCarEvn(Car.BoxNbr, BegDate, EndDate, plnRepEvent, REFrCast.REFrCast, L_Car.src_FrCast);
  IncCounters(BegDate, 1);
 END {Ins};

 PRIVATE PROCEDURE ReportPiece(): tPiece;
  VAR
   Local : PROC;
   result: tPiece;
 BEGIN
  L_Car.AccessMark(Car.BoxNbr, MinTargetDate);
  result:=0;
  SELECT(MarkGM, Mark, , Mark.Mark);
  WHILE OCCURE(MarkGM) DO
   IF SEARCH(REMGPrm, MarkG, MarkGM.MarkG, plnRepEvent) THEN
    IF result = 0 THEN
     result:=REMGPrm.Piece;
    END;
    L_General.Assert(result = REMGPrm.Piece,
                     "ઠ " + Mark.Mark + " 室  ⮪ " + result + "  " + REMGPrm.Piece);
   END;
   NEXT(MarkGM);
  END; (* WHILE OCCURE(MarkGM) ... *)
  Local:=PROCREF(E_RE.ReportPiece);
  IF ~!Local THEN
   result:=Local(result);
  END;
  RETURN result;
 END {ReportPiece};

 PRIVATE PROCEDURE E_NeedCar(): SCAL[2];
  VAR
   Local  : PROC;
   default: SCAL[2];
 BEGIN
  default:=L_Env.RealBoxNbr(Car.BoxNbr) &
           L_Car.CarIsInOperation(Car.BoxNbr, BaseDate) & (ReportPiece() = Piece) &
           (L_Car.CarDaysInOperation(Car.BoxNbr, BaseDate, MaxTargetDate) >= (MaxTargetDate - BaseDate + 1));
  IF ~default THEN
   RETURN 0;
  END;
  Local:=PROCREF(E_RE.NeedCar);
  IF ~!Local THEN
   RETURN Local();
  END;
  RETURN Car.Purpose = L_Car.purp_Common;
 END {E_NeedCar};

 PRIVATE PROCEDURE GetNorm(D: DATE; Run: NUMERIC[1]): LIKE(MarkREN.Norm[0]);
 BEGIN
  RETURN L_Car.MarkRepEventNorm(Mark.Mark, RepEvent.RepEvent, D, Run,
                                RepEvent.FrAllMrk # L_Car.fam_Strong);
 END {GetNorm};

 PRIVATE PROCEDURE GetOverPrc(R, _Norm: NUMERIC[2]): NUMERIC[2];
 BEGIN
  IF _Norm > 0 THEN
   RETURN (R - _Norm) / _Norm * 100;
  ELSE
   RETURN -100; (*   -   믮 *)
  END;
 END {GetOverPrc};

 PRIVATE PROCEDURE GetDayRun(): NUMERIC[5];
  VAR
   D1,
   D2    : DATE;
   R1,
   R2,
   DayRun: NUMERIC[5];
 BEGIN
  L_General.Assert(~!RepEvent.RatedPer, "ய⨥ "+RepEvent.RepEvent+":  㪠 ਮ 業 ஡");
  D2:=Math.Max(Car.BegDate, BaseDate);
  D1:=Math.Max(Car.BegDate, BaseDate-RepEvent.RatedPer);
  IF D1 # D2 THEN
   RETURN L_Car.GetAccurateRunInPer(Car.BoxNbr, D1, D2) / (D2 - D1);
  ELSE
   RETURN 0;
  END;
 END {GetDayRun};

 PRIVATE PROCEDURE GetForecastRun(D: DATE; RunOnBD, DayRun: NUMERIC[5]): NUMERIC[2];
 BEGIN
  RETURN RunOnBD + (D - BaseDate) * DayRun;
 END {GetForecastRun};

 PRIVATE PROCEDURE PutErr(Run: NUMERIC[5]; Msg: STRING[]);
 BEGIN
  I_Err.BoxNbr:=Car.BoxNbr;
  I_Err.DayRun:=Run;
  I_Err.Msg   :=Msg;
  INSERT(I_Err);
 END {PutErr};

 PRIVATE PROCEDURE Create_RPL01();
 BEGIN
  CreateFILE(RPL01, "", "", "");
  CreateFIELD(RPL01, BoxNbr,   LIKE(Car.BoxNbr), "", "", "", "ࠦ", "");
  CreateFIELD(RPL01, TargDate, DATE,             "", "", "", "砫쭠 ", ",   ஡   ய⨥");
  CreateFIELD(RPL01, PriorDat, DATE,             "", "", "", "ਮ⭠ ", "");
  CreateFIELD(RPL01, Norm,     NUMERIC[1],       "", "", "", "ଠ⨢", "");
  CreateFIELD(RPL01, OverPrc,  NUMERIC[5],       "", "", "", "९஡  砫 ", "");
  CreateFIELD(RPL01, DayRun,   NUMERIC[5],       "", "", "", "। ஡", "");
  CreateFIELD(RPL01, DateLast, DATE,             "", "", "", " ᫥ ய", "");
  CreateFIELD(RPL01, RunFrLst, NUMERIC[0],       "", "", "", "஡   ", "  ᫥ ய");
  CreateFIELD(RPL01, TargRun,  NUMERIC[0],       "", "", "", "஡  砫 ", "  ᫥ ய, ண");
  CreateFIELD(RPL01, UnderCvr, DATE,             "", "", "", " 뢠饣 ய", "᫨   ਮ ஢");
  CreateFIELD(RPL01, EvnStrtD, DATE,             "", "", "", "", "");
  CreateFIELD(RPL01, EvnStopD, DATE,             "", "", "", "", "");
  CreateFIELD(RPL01, Source,   SCAL[5],          "", "", "", "筨", "");
  CreateFIELD(RPL01, Count,    NUMERIC[0],       "", "1", "", "⢮", " ⥬");

  CreateINDEX(RPL01, PriorDat, PLURAL, "", "", PriorDat, OverPrc);
  CreateINDEX(RPL01, TargDate, PLURAL, "", "", TargDate, OverPrc);
  CreateINDEX(RPL01, PushDate, PLURAL, "", "", EvnStrtD, BoxNbr);
  CreateINDEXandLINK(RPL01, BoxNbr, PLURAL, Car, BoxNbr, USER, "ࠦ", "", BoxNbr);

  SetVersionOfFILE(RPL01, 0000);
  L_AFM.CreateTemp("RPL01");

  CreateFILE(RPL02, "", "", "");
  CreateFIELD(RPL02, BoxNbr,   LIKE(Car.BoxNbr), "", "", "", "ࠦ", "");
  CreateFIELD(RPL02, Date,     DATE,             "", "", "", "", "");
  CreateFIELD(RPL02, OverPrc,  NUMERIC[5],       "", "", "", "९஡  ", "");
  CreateINDEX(RPL02, Date, PLURAL, "", "", Date, OverPrc);
  SetVersionOfFILE(RPL02, 0000);
  L_AFM.CreateTemp("RPL02");

 END {Create_RPL01};

 PUBLIC PROCEDURE _HasUnclosed(D: DATE; _RepEvent: LIKE(RepEvent.RepEvent)): SCAL[2];
 BEGIN
  SELECT(CarEvn, CarEvn, , Car.BoxNbr, _RepEvent);
  WHILE OCCURE(CarEvn) DO
   IF (CarEvn.StopD > D) THEN
    RETURN 1;
   END;
   NEXT(CarEvn);
  END; (* WHILE OCCURE(CarEvn) ... *)
  RETURN 0;
 END {_HasUnclosed};

 PRIVATE PROCEDURE E_HasUnclosedEvent(D: DATE): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_RE.HasUnclosedEvent);
  IF ~!Local THEN
   RETURN Local(D);
  END;
  RETURN _HasUnclosed(D, L_Car.E_RE_Overhaul(D)) |
         _HasUnclosed(D, L_Car.E_RE_InWaitingForRepair(D));
 END {E_HasUnclosedEvent};

 PRIVATE PROCEDURE SearchWayLCarInRPL01(): SCAL[2];
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE ~!Str.Item(CarPro.Value, ";", i) DO
   IF SEARCH(RPL01, BoxNbr, Str.Item(CarPro.Value, ";", i)) THEN
    RETURN 1;
   END;
   INC(i);
  END;
  RETURN 0;
 END {SearchWayLCarInRPL01};

 PRIVATE PROCEDURE CountWayLCars(): NUMERIC[0];
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE ~!Str.Item(CarPro.Value, ";", i) DO
   INC(i);
  END;
  RETURN i;
 END {CountWayLCars};

 PRIVATE PROCEDURE E_SetPriorDate();
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_RE.SetPriorDate);
  IF ~!Local THEN
   Local();
  END;
 END {E_SetPriorDate};

 PRIVATE PROCEDURE PrepareIdx();
  VAR
   DayRun,
   _OverPrc     : NUMERIC[5];
   i,
   WayLCount,
   RunFromLast,
   TargetRun    : NUMERIC[0];
   Norm         : LIKE(MarkREN.Norm[0]);
   DateOfLast,
   TargetDate,
   InPlanDate   : DATE;
   ErrMsg       : STRING[];
   _Source      : SCAL[5];
   Cars         : P_Car.tCars;
 BEGIN
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT("⮢  - " + Car.BoxNbr);
   SETEMPTY(ErrMsg);
   IF E_NeedCar() THEN
    DayRun:=GetDayRun();
    Norm  :=GetNorm(MinTargetDate, L_Car.GetGlobalRun(Car.BoxNbr, MinTargetDate));
    IF    DayRun < 1 THEN
     ErrMsg:=" ࠡ⠥";
    ELSIF E_HasUnclosedEvent(MinTargetDate) THEN
     SAVE(RepEvent);
     CONFORM(CarEvn, RepEvent);
     ErrMsg:=RepEvent.Name + " c "  + L_DatTim.DateStr(CarEvn.StartD) +
             "  " + L_DatTim.DateStr(CarEvn.StopD);
     RESTORE(RepEvent);
    END;
    IF !ErrMsg THEN
     DateOfLast :=L_Car.NearestPastRepEventDate(BaseDate, plnRepEvent);
     RunFromLast:=L_Car.GetAccurateRunInPer(Car.BoxNbr, DateOfLast, BaseDate);
     TargetDate :=MinTargetDate;
     LOOP
      TargetRun:=GetForecastRun(TargetDate, RunFromLast, DayRun);
      IF TargetDate > MaxTargetDate THEN
       ErrMsg:="  ᪮:  "+FLDTOSTR(TargetDate, "D.N.Y")+" ஡ "+
               L_Str.IntStr(TargetRun)+"  "+FLDTOSTR(DateOfLast, "D.N.Y");
       EXIT;
      END;
      IF TargetRun > Norm * (1 - RepEvent.UnderPrc / 100) THEN
       EXIT;
      END;
      INC(TargetDate);
     END; (*LOOP*)
    END;
    IF !ErrMsg THEN
     InPlanDate:=L_Car.NearestFutureRepEventDate(BaseDate, plnRepEvent);
     IF ~!InPlanDate THEN
      _OverPrc:=GetOverPrc(GetForecastRun(InPlanDate, RunFromLast, DayRun), Norm);
      IF (InPlanDate <= TargetDate) | (_OverPrc <= RepEvent.OverPrc) THEN
       SAVE(RepEvent);
       CONFORM(CarEvn, RepEvent);
       ErrMsg:=" ஢ " + RepEvent.Name + "  " + L_DatTim.DateStr(InPlanDate);
       RESTORE(RepEvent);
      ELSE
       HasTrouble:=1;
      END;
     END;
    END;
    IF !ErrMsg THEN
     DEFAULT(RPL01);
     RPL01.BoxNbr  :=Car.BoxNbr;
     RPL01.TargDate:=TargetDate;
     RPL01.Norm    :=Norm;
     RPL01.TargRun :=TargetRun;
     RPL01.OverPrc :=(-1)*GetOverPrc(TargetRun, Norm);
     RPL01.DayRun  :=DayRun;
     RPL01.DateLast:=DateOfLast;
     RPL01.RunFrLst:=RunFromLast;
     RPL01.UnderCvr:=InPlanDate;
     INSERT(RPL01);
     E_SetPriorDate();
    ELSE
     PutErr(DayRun, ErrMsg);
    END;
   END;
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)

  IF SELECT(CarPro, Property, P_Car.P_WayLCar) THEN
   SELECT(RPL01, BoxNbr);
   WHILE OCCURE(RPL01) DO
    PROMPT("㯯஢ ⥬ - " + RPL01.BoxNbr);
    IF P_Car.HasActualCarPro(RPL01.BoxNbr, BaseDate, P_Car.P_WayLCar) THEN
     P_Car.Decode_WayLCar(CarPro.Value, Cars);
     i:=0;
     WHILE ~!Cars[i] DO
      SAVE(RPL01);
      IF SEARCH(RPL01, BoxNbr, Cars[i]) THEN
       DayRun    :=RPL01.DayRun;
       InPlanDate:=RPL01.UnderCvr;
       TargetDate:=RPL01.TargDate;
       _Source   :=RPL01.Source;
       CONFORM(RPL01, Car);
       REMOVE(RPL01);
       RESTORE(RPL01);
       PutErr(DayRun, "室  ⥬  " + RPL01.BoxNbr);
       RPL01.DayRun  :=Math.Max(RPL01.DayRun,   DayRun);
       RPL01.UnderCvr:=Math.Min(RPL01.UnderCvr, InPlanDate);
       RPL01.TargDate:=Math.Min(RPL01.TargDate, TargetDate);
       IF !RPL01.Source THEN
        RPL01.Source:=_Source;
       END;
      ELSE
       RESTORE(RPL01);
      END;
      INC(RPL01.Count);
      REPLACE(RPL01);
      INC(i);
     END;
    END;
    NEXT(RPL01);
   END; (* WHILE OCCURE(RPL01) ... *)
  END;
 END {PrepareIdx};

 PRIVATE PROCEDURE GetTeam(D: DATE): NUMERIC[0];
 BEGIN
  RETURN (TeamOnBD - 1 + (D - MinTargetDate) DIV REPrm.ShiftDur) MOD REPrm.TeamAmnt + 1;
 END {GetTeam};

 PRIVATE PROCEDURE E_GetCarDuration(D: DATE; RepEvent: LIKE(RepEvent.RepEvent)): NUMERIC[0];
  VAR
   Local : PROC;
   result: NUMERIC[0];
 BEGIN
  Local:=PROCREF(E_RE.GetCarDuration);
  IF ~!Local THEN
   RETURN Local(D, RepEvent);
  END;
  result:=0;
  SELECT(MarkGM, Mark, , Mark.Mark);
  WHILE OCCURE(MarkGM) DO
   IF SEARCH(REMGPrm, MarkG, MarkGM.MarkG, RepEvent) THEN
    result:=Math.Max(result, CountDuration(REMGPrm.Duration, 0));
   END;
   NEXT(MarkGM);
  END; (* WHILE OCCURE(MarkGM) ... *)
  IF result > 0 THEN
   RETURN result;
  END;
  RETURN MaxDuration;
 END {E_GetCarDuration};

 PRIVATE PROCEDURE MarkAsPushed(D: DATE);
 BEGIN
  DEFAULT(RPL01);
  SAVE(CarEvn);
  RPL01.DateLast:=L_Car.NearestPastRepEventDate(CarEvn.StartD - 1, plnRepEvent);
  RESTORE(CarEvn);
  RPL01.DayRun  :=GetDayRun();
  RPL01.RunFrLst:=L_Car.GetAccurateRunInPer(Car.BoxNbr, RPL01.DateLast, BaseDate);
  RPL01.BoxNbr  :=Car.BoxNbr;
  RPL01.Norm    :=GetNorm(MinTargetDate, L_Car.GetGlobalRun(Car.BoxNbr, MinTargetDate));
  RPL01.TargDate:=CarEvn.StartD;
  RPL01.UnderCvr:=CarEvn.StartD;
  RPL01.TargRun :=GetForecastRun(CarEvn.StartD, RPL01.RunFrLst, RPL01.DayRun);
  RPL01.OverPrc :=(-1) * GetOverPrc(RPL01.TargRun, RPL01.Norm);
  RPL01.EvnStrtD:=CarEvn.StartD;
  RPL01.EvnStopD:=CarEvn.StopD;
  IF (CarEvn.Source = L_Car.src_FrCast) & ~!CarEvn.DocNbr THEN
   RPL01.Source :=src_OtherFrCast;
  ELSE
   RPL01.Source :=src_NotFrCast;
  END;
  RPL01.Count   :=1;
  INSERT(RPL01);
 END {MarkAsPushed};

 PRIVATE PROCEDURE ProcessExisting();
  CONST
   srcPool = "஢ ஬ | ६  |"+
             " ⥢  |ண஢ ";
  VAR
   Count: NUMERIC[0][4];
 BEGIN
  SETZERO(Count);
  SELECT(CarEvn, RepEvent, , plnRepEvent);
  WHILE OCCURE(CarEvn) DO
   CHANGESEL(CarEvn, RepEvent, , plnRepEvent, CarEvn.Source);
   SRCINSEL(CarEvn, GT, , MinTargetDate - MaxDuration);
   WHILE OCCURE(CarEvn) & (CarEvn.StartD <= MaxTargetDate) DO
    PROMPT("ᬮ " + L_DatTim.DateStr(CarEvn.StartD) +
           " " + CarEvn.BoxNbr);
    IF CarEvn.StopD >= MinTargetDate THEN
     CONFORM(CarEvn, Car);
     L_Car.AccessMark(Car.BoxNbr, CarEvn.StartD);
     L_Car.StandOnCarLog(Car.BoxNbr, CarEvn.StartD);
     IF E_NeedCar() THEN
      IF Count[CarEvn.Source] = 0 THEN
       STDMSG("  " + L_Str.PoolItem(srcPool, CarEvn.Source) +
              " ਮ ய.|  ⥭  ண.", CHOICE);
      END;
      MarkAsPushed(CarEvn.StartD);
      INC(Count[CarEvn.Source]);
     END;
    END;
    NEXT(CarEvn);
   END; (* WHILE OCCURE(CarEvn) ... *)
   LAST(CarEvn);
   CHANGESEL(CarEvn, RepEvent, , plnRepEvent);
   NEXT(CarEvn);
  END; (* WHILE OCCURE(CarEvn) ... *)
 END {ProcessExisting};

 PUBLIC PROCEDURE IsInGrp(D: DATE; GrpIdx: NUMERIC[0]): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  IF _MarkG[GrpIdx] = localGrpIdx THEN
   RETURN E_RE.IsInGrp(D, GrpIdx);
  ELSE
   L_Car.AccessMark(Car.BoxNbr, D);
   RETURN SEARCH(MarkGM, MarkG, _MarkG[GrpIdx], Mark.Mark);
  END;
 END {IsInGrp};

 PRIVATE PROCEDURE CanBePushed(D: DATE): SCAL[2];
  VAR
   GrpIdx: NUMERIC[0];
 BEGIN
  IF (CntInDay[grp_Total] + RPL01.Count) > NbrOfCar[grp_Total] THEN
   RETURN 0;
  END;
  GrpIdx:=1;
  WHILE ~!NbrOfCar[GrpIdx] DO
   IF IsInGrp(D, GrpIdx) & ((CntInDay[GrpIdx] + RPL01.Count) > NbrOfCar[GrpIdx]) THEN
    RETURN 0;
   END;
   INC(GrpIdx);
  END;
  RETURN 1;
 END {CanBePushed};

 PRIVATE PROCEDURE NeedRepEvent(TargetDate, Past: DATE; _OverPrc: NUMERIC[1]): SCAL[2];
  VAR
   D: DATE;
 BEGIN
  IF    DBD.BaseName() = "SP" THEN
   IF RepEvent.RepEvent = E_Way.re_SeasonService THEN
    D:=PackDATE(15, 08 (*ᥭ!!!*), L_DatTim.YEAR(TargetDate));
    IF TargetDate < D THEN
     D:=PackDATE(15, 08 (*ᥭ!!!*), L_DatTim.YEAR(TargetDate)-1);
    END;
    RETURN Past < D;
   END;
  ELSIF DBD.BaseName() = "KL" THEN
   IF RepEvent.RepEvent = E_Way.re_HidraulicTransmDriveBrakingFluidReplace THEN
    RETURN Past + (2*365*(1-RepEvent.UnderPrc/100) DIV 1) < TargetDate;
   END;
  END;
  RETURN (_OverPrc >= (-1)*RepEvent.UnderPrc) | (_OverPrc > RepEvent.OverPrc);
 END {NeedRepEvent};

 PRIVATE PROCEDURE E_IsGoodDay(D, Past: DATE; Over: NUMERIC[2]): SCAL[2];
  VAR
   Is   : SCAL[2];
   Local: PROC;
   i    : NUMERIC[0];
 BEGIN
  Is:=NeedRepEvent(D, Past, Over) & CanBePushed(D);
  i:=1;
  WHILE Is & (i < E_GetCarDuration(D, RepEvent.RepEvent)) DO
   Is:=GetTeam(D + i) = CurTeam;
   INC(i);
  END;
  Local:=PROCREF(E_RE.IsGoodDay);
  IF ~!Local THEN
   Is:=Local(Is, D);
  END;
  RETURN Is;
 END {E_IsGoodDay};

 PRIVATE PROCEDURE GetTeamOnBD(): NUMERIC[0];
  VAR
   Local: PROC;
   Days : NUMERIC[0];
 BEGIN
  IF REPrm.TeamAmnt = 1 THEN
   RETURN 1;
  ELSE
   Days:=Math.Abs(MinTargetDate - REPrm.FstTeamD);
   L_General.Assert(Days MOD REPrm.ShiftDur = 0,
                    "砫 ਮ ஢  |  ࠡ ६⭮ ਣ");
   RETURN 1 + Days DIV REPrm.ShiftDur MOD REPrm.TeamAmnt;
  END;
 END {GetTeamOnBD};

 PRIVATE PROCEDURE PushOneCar(D: DATE; FirstPass: SCAL[2]);
  VAR
   i,
   FRC : NUMERIC[0];
   over: NUMERIC[2];
   Cars: P_Car.tCars;
 BEGIN
  IF !RPL01.Source & (D < RPL01.UnderCvr) THEN
   CONFORM(RPL01, Car);
   L_Car.AccessMark(Car.BoxNbr, D);
   L_Car.StandOnCarLog(Car.BoxNbr, D);
   FRC :=GetForecastRun(D, RPL01.RunFrLst, RPL01.DayRun);
   over:=GetOverPrc(FRC, RPL01.Norm);
   IF E_IsGoodDay(D, RPL01.DateLast, over) & (~FirstPass | (over < RepEvent.OverPrc)) THEN
    RPL01.EvnStrtD:=D;
    RPL01.EvnStopD:=D + E_GetCarDuration(D, plnRepEvent) - 1;
    RPL01.Source  :=src_ThisFrCast;
    REPLACE(RPL01);
    Ins(RPL01.EvnStrtD, RPL01.EvnStopD);
    IF RPL01.Count > 1 THEN
     L_General.CallUs(P_Car.HasActualCarPro(Car.BoxNbr, BaseDate, P_Car.P_WayLCar));
     P_Car.Decode_WayLCar(CarPro.Value, Cars);
     i:=0;
     WHILE ~!Cars[i] & SEARCH(Car, BoxNbr, Cars[i]) DO
      Ins(RPL01.EvnStrtD, RPL01.EvnStopD);
      INC(i);
     END;
    END;
   END;
  END; (* IF ~RPL01.EvnStrtD ... *)
 END {PushOneCar};

 PRIVATE PROCEDURE E_PlanningIncrement(): NUMERIC[0];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_RE.PlanningIncrement);
  IF ~!Local THEN
   RETURN Local();
  END;
  RETURN 1;
 END {E_PlanningIncrement};

 PRIVATE PROCEDURE CountExisting(D: DATE);
 BEGIN
  SELECT(RPL01, PushDate);
  SRCINSEL(RPL01, GT, , D - MaxDuration);
  WHILE OCCURE(RPL01) & (RPL01.EvnStrtD <= D) DO
   IF L_DatTim.IsActive_Inc(D, RPL01.EvnStrtD, RPL01.EvnStopD) THEN
    CONFORM(RPL01, Car);
    L_Car.AccessMark(Car.BoxNbr, D);
    L_Car.StandOnCarLog(Car.BoxNbr, D);
    IncCounters(D, RPL01.Count);
   END;
   NEXT(RPL01);
  END; (* WHILE OCCURE(RPL01) ... *)
 END {CountExisting};

 PRIVATE PROCEDURE SetLimits(D: DATE);
  VAR
   i: NUMERIC[0];
 BEGIN
  SETEMPTY(NbrOfCar, _MarkG);
  IF ~!PROCREF(E_RE.SetLimits) THEN
   E_RE.SetLimits(D);
  END;

  i:=1;
  WHILE ~!NbrOfCar[i] DO
   _MarkG[i]:=localGrpIdx;
   INC(i);
  END;

  NbrOfCar[grp_Total]:=REPrm.MaxCar[L_Hld.WeekDay_TransfersConsidered(D)];
  SELECT(REMGPrm, RepEvent, , plnRepEvent, Piece);
  WHILE OCCURE(REMGPrm) DO
   _MarkG[i]  :=REMGPrm.MarkG;
   NbrOfCar[i]:=REMGPrm.MaxCar[L_Hld.WeekDay_TransfersConsidered(D)];
   INC(i);
   NEXT(REMGPrm);
  END; (* WHILE OCCURE(REMGPrm) ... *)
 END {SetLimits};

 PRIVATE PROCEDURE Push();
  VAR
   D: DATE;
 BEGIN
  D:=MinTargetDate;
  WHILE D <= MaxTargetDate DO
   SetLimits(D);
   CurTeam:=GetTeam(D);
   SETZERO(CntInDay);
   CountExisting(D);

   SELECT(RPL01, PriorDat, , D);
   LAST(RPL01);
   WHILE OCCURE(RPL01) DO
    PROMPT("। " + L_DatTim.DateStr(D) + " " + RPL01.BoxNbr);
    PushOneCar(D, 1);
    PREV(RPL01);
   END;
   INC(D, E_PlanningIncrement());
  END;

  D:=MinTargetDate;
  WHILE D <= MaxTargetDate DO
   SetLimits(D);
   CurTeam:=GetTeam(D);
   SETZERO(CntInDay);
   CountExisting(D);

   SELECT(RPL01, PriorDat, , D);
   LAST(RPL01);
   WHILE OCCURE(RPL01) DO
    PROMPT("। " + L_DatTim.DateStr(D) + " " + RPL01.BoxNbr);
    PushOneCar(D, 0);
    PREV(RPL01);
   END;

   SELECT(RPL01, TargDate);
   WHILE OCCURE(RPL01) & (RPL01.TargDate <= D) DO
    PROMPT("। " + L_DatTim.DateStr(D) + " " + RPL01.BoxNbr);
    IF !RPL01.Source & (D < RPL01.UnderCvr) THEN
     CONFORM(RPL01, Car);
     L_Car.AccessMark(Car.BoxNbr, D);
     L_Car.StandOnCarLog(Car.BoxNbr, D);
     RPL02.BoxNbr :=RPL01.BoxNbr;
     RPL02.Date   :=D;
     RPL02.OverPrc:=GetOverPrc(GetForecastRun(D, RPL01.RunFrLst, RPL01.DayRun), RPL01.Norm);
     INSERT(RPL02);
    END; (* IF ~RPL01.EvnStrtD ... *)
    NEXT(RPL01);
   END;
   SELECT(RPL02, Date, , D);
   LAST(RPL02);
   WHILE OCCURE(RPL02) DO
    SELECT(RPL01, BoxNbr, , RPL02.BoxNbr);
    PushOneCar(D, 0);
    PREV(RPL02);
   END; (* WHILE OCCURE(RPL02) ... *)
   INC(D, E_PlanningIncrement());
  END;
 END {Push};

 PRIVATE PROCEDURE E_MakeDbgTop();
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_RE.MakeDbgTop);
  IF ~!Local THEN
   Local();
  ELSE
   MAKEPART(R, dbgTop);
  END;
 END {E_MakeDbgTop};

 PRIVATE PROCEDURE E_MakeDbgLine();
  VAR
   Local: PROC;
   Signs: STRING[];
 BEGIN
  Local:=PROCREF(E_RE.MakeDbgLine);
  IF ~!Local THEN
   Local();
  ELSE
   IF RPL01.Source = src_ThisFrCast THEN
    Signs:="";
   ELSE
    Signs:=" ";
   END;
   IF    ~!RPL01.UnderCvr THEN
    Signs:=Signs + "!";
   ELSIF ~!RPL01.PriorDat THEN
    Signs:=Signs + "*";
   END;
   MAKEPART(R, dbgLine, RPL01.TargDate, RPL01.DateLast, RPL01.RunFrLst,
                        RPL01.DayRun,   RPL01.TargRun,  RPL01.OverPrc*(-1),
                        Signs);
  END;
 END {E_MakeDbgLine};

 PRIVATE PROCEDURE E_MakeFilling(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_RE.MakeFilling);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN 1;
  END;
 END {E_MakeFilling};

 PRIVATE PROCEDURE PushedInDay(D: DATE): NUMERIC[0];
  VAR
   Cnt: NUMERIC[0];
 BEGIN
  Cnt:=0;
  SELECT(RPL01, PushDate);
  SRCINSEL(RPL01, LT, , D+1);
  WHILE OCCURE(RPL01) DO
   IF L_DatTim.IsActive_Inc(D, RPL01.EvnStrtD, RPL01.EvnStopD) THEN
    INC(Cnt, RPL01.Count);
   END;
   PREV(RPL01);
  END; (* WHILE OCCURE(RPL01) ... *)
  RETURN Cnt;
 END {PushedInDay};

 PRIVATE PROCEDURE PrintProtocols();
  VAR
   CurBoxNbr: LIKE(Car.BoxNbr);
 BEGIN
  MAKEPART(R, Top, "⮪  襤訬  ᬮ७");
  E_MakeDbgTop();
  SELECT(RPL01, TargDate);
  WHILE OCCURE(RPL01) DO
   PROMPT(" " + RPL01.BoxNbr);
   IF !RPL01.Source | (RPL01.Source = src_ThisFrCast) THEN
    CONFORM(RPL01, Car);
    L_Car.AccessMark(Car.BoxNbr, RPL01.TargDate);
    L_Car.StandOnCarLog(Car.BoxNbr, RPL01.TargDate);
    E_MakeDbgLine();
   END;
   NEXT(RPL01);
  END; (* WHILE OCCURE(RPL01) ... *)
  MAKEPART(R, Bot);
  FORMFEED(R);

  SETEMPTY(CurBoxNbr);
  MAKEPART(R, Top, "⮪   襤訬  ᬮ७");
  MAKEPART(R, dbgErrTop);
  SELECT(I_Err, BoxNbr);
  WHILE OCCURE(I_Err) DO
   IF I_Err.BoxNbr # CurBoxNbr THEN
    L_Car.StandOnCarLog(I_Err.BoxNbr, BaseDate);
    MAKEPART(R, dbgErr, I_Err.DayRun, I_Err.Msg);
    CurBoxNbr:=I_Err.BoxNbr;
   ELSE
    MAKEPART(R, dbgErr, "", L_General.EMPTY_NUMBER(), I_Err.Msg);
   END;
   NEXT(I_Err);
  END; (* WHILE OCCURE(I_Err) ... *)
  MAKEPART(R, Bot);
 END {PrintProtocols};

 PRIVATE PROCEDURE Print();
  CONST
   LinesInRep = 62;
  VAR
   LastRE,
   D         : DATE;
   i,
   LineNum,
   FRC       : NUMERIC[0];
   Cars      : P_Car.tCars;
 BEGIN
  L_PagePr.PagePr_Init("R", LinesInRep, PROCREF(_RprtTop), PROCREF(_PageTop),
                                        PROCREF(_PageBot), PROCREF(_RprtBot),
                                        PROCREF(_Filling));
  D:=MinTargetDate;
  WHILE D <= MaxTargetDate DO
   SETEMPTY(NbrOfCar);
   SetLimits(D);
   CurTeam:=GetTeam(D);

   SELECT(RPL01, PushDate);
   SRCINSEL(RPL01, GT, , D - MaxDuration);
   SETZERO(CntInDay);
   SAVE(RPL01);
   WHILE OCCURE(RPL01) & (RPL01.EvnStrtD <= D) DO
    IF RPL01.EvnStopD >= D THEN
     INC(CntInDay[grp_Total], RPL01.Count);
    END;
    NEXT(RPL01);
   END;
   RESTORE(RPL01);

   IF (CntInDay[grp_Total] > 0) | (E_MakeFilling() & (NbrOfCar[grp_Total] > 0)) THEN
    LineNum:=DEPTH(OneDate) + (DEPTH(DlmLine) + DEPTH(Line)) * CntInDay[grp_Total];
    IF E_MakeFilling() & (NbrOfCar[grp_Total] > CntInDay[grp_Total]) THEN
     INC(LineNum, DEPTH(EmptyLine) * (NbrOfCar[grp_Total] - CntInDay[grp_Total]));
    END;
    L_PagePr.PagePr_BeforePrintLineAtLast(D + E_PlanningIncrement() > MaxTargetDate, LineNum);
    L_General.Assert(SEARCH(Calendar, Date, D), "   ᠭ  "+L_DatTim.DateStr(D));
    MAKEPART(R, OneDate, D, CntInDay[grp_Total], L_DatTim.WeekDayStr(Calendar.WeekDay, 0));

    WHILE OCCURE(RPL01) & (RPL01.EvnStrtD <= D) DO
     IF RPL01.EvnStopD >= D THEN
      PROMPT(" " + L_DatTim.DateStr(D) + " " + RPL01.BoxNbr);
      CONFORM(RPL01, Car);
      L_Car.AccessMark(Car.BoxNbr, RPL01.TargDate);
      L_Car.StandOnCarLog(Car.BoxNbr, RPL01.TargDate);
      FRC:=GetForecastRun(RPL01.EvnStrtD, RPL01.RunFrLst, RPL01.DayRun);
      L_PagePr.PagePr_BeforePrintLine(DEPTH(Line) + DEPTH(DlmLine));
      MAKEPART(R, DlmLine);
      MAKEPART(R, Line, RPL01.DateLast, FRC, GetOverPrc(FRC, RPL01.Norm),
                        RPL01.DayRun, L_Str.PoolItem(srcPool, RPL01.Source));
      IF RPL01.Count > 1 THEN
       L_General.CallUs(P_Car.HasActualCarPro(Car.BoxNbr, BaseDate, P_Car.P_WayLCar));
       P_Car.Decode_WayLCar(CarPro.Value, Cars);
       i:=0;
       WHILE ~!Cars[i] & SEARCH(Car, BoxNbr, Cars[i]) DO
        L_Car.AccessMark(Car.BoxNbr, RPL01.TargDate);
        L_Car.StandOnCarLog(Car.BoxNbr, RPL01.TargDate);
        LastRE:=L_Car.NearestPastRepEventDate(BaseDate, plnRepEvent);
        FRC:=GetForecastRun(RPL01.EvnStrtD,
                            L_Car.GetAccurateRunInPer(Car.BoxNbr, LastRE, BaseDate),
                            RPL01.DayRun);
        L_PagePr.PagePr_BeforePrintLine(DEPTH(Line));
        MAKEPART(R, Line, LastRE, FRC, GetOverPrc(FRC, RPL01.Norm),
                          RPL01.DayRun, L_Str.PoolItem(srcPool, RPL01.Source));
        INC(i);
       END;
      END;
     END;
     NEXT(RPL01);
    END;
    IF E_MakeFilling() THEN
     WHILE CntInDay[grp_Total] < NbrOfCar[grp_Total] DO
      L_PagePr.PagePr_BeforePrintLine(DEPTH(EmptyLine));
      MAKEPART(R, EmptyLine);
      INC(CntInDay[grp_Total]);
     END;
    END;
   END;
   INC(D, E_PlanningIncrement());
  END;
  L_PagePr.PagePr_Done();

  IF MakeProtocol | HasTrouble THEN
   PrintProtocols();
  END; (* IF MakeProtocol...*)
 END {Print};

 PRIVATE PROCEDURE Clear();
  VAR
   _DocNbr: LIKE(CarEvn.DocNbr);
 BEGIN
  LOADMODULE(E_RE, E_RE);
  L_General.Assert(ACCESS(CarEvn), " ⠭ ண ᮡ");
  L_General.Assert(~!CarEvn.DocNbr, " '筮' ண");
  _DocNbr:=CarEvn.DocNbr;
  STDMSG("   ⮯ண " + CarEvn.DocNbr + "?", CHOICE);
  SELECT(CarEvn, RepEvent, , CarEvn.RepEvent, L_Car.src_FrCast);
  WHILE OCCURE(CarEvn) DO
   PROMPT(CarEvn.BoxNbr);
   IF CarEvn.DocNbr = _DocNbr THEN
    L_SysLog.SingleMark_BeforeDelete("CarEvn");
    REMOVE(CarEvn);
   ELSE
    NEXT(CarEvn);
   END;
  END; (* WHILE OCCURE(CarEvn) ... *)
  CleanRefrCast();
 END {Clear};

 PRIVATE PROCEDURE CountDuration(Hours, Days: FLOAT): FLOAT;
 BEGIN
  IF Hours <= 24 THEN
   RETURN Days + 1;
  END;
  RETURN CountDuration(Hours - 24, Days + 1);
 END {CountDuration};

 PRIVATE PROCEDURE PrepareGlobals();
  VAR
   Local: PROC;
 BEGIN
  SETEMPTY(NbrOfCar);
  MaxDuration:=0;
  SELECT(REMGPrm, RepEvent, , REPrm.RepEvent, REPrm.Piece);
  WHILE OCCURE(REMGPrm) DO
   MaxDuration:=Math.Max(MaxDuration, CountDuration(REMGPrm.Duration, 0));
   NEXT(REMGPrm);
  END; (* WHILE OCCURE(REMGPrm) ... *)
  IF MaxDuration = 0 THEN
   MaxDuration:=CountDuration(RepEvent.Duration, 0);
  END;
  Local:=PROCREF(E_RE.InitParams);
  IF ~!Local THEN
   Local();
  END;
  TeamOnBD:=GetTeamOnBD();
 END {PrepareGlobals};

 PRIVATE PROCEDURE Do();
  VAR
   RepFileName: STRING[];
 BEGIN
  PrepareGlobals();
  CreateFILE(I_Err, "", "", "");
  CreateFIELD(I_Err, BoxNbr,   LIKE(Car.BoxNbr), "", "", "", "ࠦ", "");
  CreateFIELD(I_Err, DayRun,   NUMERIC[5],       "", "", "", "", "");
  CreateFIELD(I_Err, Msg,      STRING[64],       "", "", "", "", "");
  CreateINDEX(I_Err, BoxNbr, PLURAL, "ࠦ", "", BoxNbr);
  SetVersionOfFILE(I_Err, 0000);
  L_AFM.AF_CreateTemp("I_Err", "I_Err");
  IF Piece > 1 THEN
   RepFileName:=REPln_RepName + "_" + plnRepEvent + "_" + Piece;
  ELSE
   RepFileName:=REPln_RepName + "_" + plnRepEvent;
  END;
  OPENREP(R, L_General.NameConnection(RepFileName), Create);

  Create_RPL01();
  InsForeCast();
  ProcessExisting();
  PrepareIdx();
  Push();
  Print();
  CleanRefrCast();
  L_AFM.AF_PurgeTemp("I_Err");
  L_AFM.AF_PurgeTemp("RPL01");
  L_AFM.AF_PurgeTemp("RPL02");
 END {Do};

 PRIVATE PROCEDURE Create_RqNW1();
 BEGIN
  CreateFILE(RqNW1, "", "", "");
  CreateFIELD(RqNW1, BoxNbr,   LIKE(Car.BoxNbr),   "", "", "", "ࠦ", "");
  CreateFIELD(RqNW1, _Grp,     SCAL[1E4],          "", "", "", "㯯஢", "");
  CreateFIELD(RqNW1, OverPrc,  NUMERIC[5],         "", "", "", "", "");
  CreateFIELD(RqNW1, DayRun,   NUMERIC[5],         "", "", "", "", "");
  CreateFIELD(RqNW1, DateLast, DATE,               "", "", "", "", "");
  CreateFIELD(RqNW1, DatePlan, DATE,               "", "", "", "", "");
  CreateFIELD(RqNW1, RunFrLst, NUMERIC[0],         "", "", "", "", "");
  CreateFIELD(RqNW1, Norm,     LIKE(MarkREN.Norm[0]), "", "", "", "", "");
  CreateINDEX(RqNW1, RqNW1,  PLURAL, "", "", _Grp, OverPrc, DayRun);

  SetVersionOfFILE(RqNW1, 0000);
  L_AFM.CreateTemp("RqNW1");
 END {Create_RqNW1};

 CONST
  NoGroup   = 0; (* tGroupBy *)
  ByPurpose = 1;
  ByColumn  = 2;
  ByMarkG   = 3;

 PRIVATE PROCEDURE Prepare_RqNW1(GroupBy: tGroupBy);
  VAR
   OverPrcLimit: NUMERIC[5];
 BEGIN
  Create_RqNW1();
  OverPrcLimit:=L_EC.ExecE_Func_Numeric(BaseDate, PROCREF(E_RE.OverPrcLimit), L_General.EMPTY_NUMBER());

  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT("⮢  " + Car.BoxNbr);
   IF L_Env.RealBoxNbr(Car.BoxNbr) &
      L_DatTim.IsActive(BaseDate, Car.BegDate, Car.EndDate) &
      L_EC.ExecE_Func_Scal2(BaseDate, PROCREF(E_RE.IsCarInPark), 1) THEN
    L_Car.AccessMark(Car.BoxNbr, BaseDate);
    L_Car.StandOnCarLog(Car.BoxNbr, BaseDate);
    IF    GroupBy = NoGroup   THEN
     RqNW1._Grp   :=0;
    ELSIF GroupBy = ByPurpose THEN
     RqNW1._Grp   :=CarLog.Purpose;
    ELSIF GroupBy = ByColumn  THEN
     RqNW1._Grp   :=CarLog.Column;
    ELSIF GroupBy = ByMarkG   THEN
     RqNW1._Grp   :=L_Way.GetMarkG_Soft(Mark.Mark, L_Way.mgt_REPlan);
    END;
    RqNW1.BoxNbr  :=Car.BoxNbr;
    RqNW1.DayRun  :=GetDayRun();
    RqNW1.DateLast:=L_Car.NearestPastRepEventDate_Strong(BaseDate, RepEvent.RepEvent);
    RqNW1.DatePlan:=L_Car.NearestFutureRepEventDate(BaseDate, RepEvent.RepEvent);
    RqNW1.RunFrLst:=L_Car.GetAccurateRunInPer(Car.BoxNbr, RqNW1.DateLast, BaseDate);
    RqNW1.Norm    :=GetNorm(BaseDate, L_Car.GetGlobalRun(Car.BoxNbr, BaseDate));
    RqNW1.OverPrc :=GetOverPrc(RqNW1.RunFrLst, RqNW1.Norm);
    IF !OverPrcLimit | (RqNW1.OverPrc > OverPrcLimit) THEN
     IF RqNW1.Norm = 0 THEN
      SETEMPTY(RqNW1.Norm);
      RqNW1.OverPrc:=-100 - Car.BoxNbr; (* 㯮冷稢  ࠦ*)
     END;
     INSERT(RqNW1);
    END;
   END; (* IF E_NeedCar() ... *)
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
 END {Prepare_RqNW1};

 PRIVATE PROCEDURE _OverPrc(): NUMERIC[2];
 BEGIN
  IF ~!RqNW1.Norm THEN
   RETURN RqNW1.OverPrc;
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {_OverPrc};

 PRIVATE PROCEDURE MakeBySelected();
 BEGIN
  MAKEPART(R, Req_SubTop);
  LAST(RqNW1);
  WHILE OCCURE(RqNW1) DO
   PROMPT(" " + RqNW1.BoxNbr);
   SEARCH(Car, BoxNbr, , RqNW1.BoxNbr);
   L_Car.AccessMark(Car.BoxNbr, BaseDate);
   L_Car.StandOnCarLog(Car.BoxNbr, BaseDate);
   MAKEPART(R, Req_Line, CarLog.Column, RqNW1.DateLast, RqNW1.Norm, RqNW1.RunFrLst, _OverPrc(),
                         RqNW1.DayRun, RqNW1.DatePlan);
   PREV(RqNW1);
  END; (* WHILE OCCURE(RqNW1) ... *)
 END {MakeBySelected};

 PRIVATE PROCEDURE MakeReqNw();
  CONST
   RepName = "ReqNw";
   gtPool = " ᯨ᪮| 祭 | | 㯯 ப|";
  VAR
   RepNameStr: STRING[];
   FormLength: NUMERIC[0];
   GroupBy   : tGroupBy;
 BEGIN
  LOADMODULE(E_RE, E_RE);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  ACCESS(RepEvent);
  L_General.Assert(RepEvent.FrAllMrk # L_Car.fam_No,
                   "᮪ ।  ⮫쪮   ଠ⨢ ஡  யﬨ");
  L_General.Assert(~!RepEvent.RatedPer, "  ਮ 業 ஡");
  BaseDate   :=Memo.ud_cd();
  plnRepEvent:=RepEvent.RepEvent;
  RepNameStr :=RepEvent.Name + "  " + L_DatTim.DateStr(BaseDate);
  FormLength :=Math.Max(Str.Length(RepNameStr), 33);
  GroupBy    :=NoGroup;

  STDFORM("|᮪ ।  ய⨥|" +
          RepNameStr +
          "||" + "%" + L_Str.IntStr(FormLength - 6) + ",4" + "<" + gtPool + ">O"+
          "|||||" +
          L_StdFrm.DrawButton("⬥",    10, "X") + "  " +
          L_StdFrm.DrawButton("⮢", 13, "DB"),
          " 롮 ᯮᮡ 㯯஢ ",
          ,
          1,
          GroupBy);

  Prepare_RqNW1(GroupBy);

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Req_Top, RepName);
  MAKEPART(R, Req_Title, "᮪ ।  ய⨥");
  MAKEPART(R, Req_Title, RepNameStr);

  SELECT(RqNW1, RqNW1);
  WHILE OCCURE(RqNW1) DO
   NARROWSEL(RqNW1, _Grp);
   IF    GroupBy = ByPurpose THEN
    MAKEPART(R, Req_SubTitle, "祭 " + L_Str.IntStr(RqNW1._Grp) +
                              L_Str.PoolItem(" 饣 짮| ⢥", RqNW1._Grp));
   ELSIF GroupBy = ByColumn  THEN
    SEARCH(Column, Column, , RqNW1._Grp);
    MAKEPART(R, Req_SubTitle, " " + Column.Column + " " + Column.Name);
   ELSIF GroupBy = ByMarkG   THEN
    IF SEARCH(MarkG, MarkG, RqNW1._Grp) THEN
     MAKEPART(R, Req_SubTitle, "㯯 ப " + MarkG.MarkG + " " + MarkG.Name);
    ELSE
     MAKEPART(R, Req_SubTitle, "稥 㯯 ப");
    END;
   END;
   MakeBySelected();
   NEXTINEXTENDEDSEL(RqNW1, _Grp);
  END; (* WHILE OCCURE(RqNW1) ... *)
  MAKEPART(R, Req_Bot);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("RqNW1");
 END {MakeReqNw};

 PRIVATE PROCEDURE GetRunInPer(trgBoxNbr: LIKE(Car.BoxNbr); From, Till: DATE): LIKE(CarRun.TotRun);
 BEGIN
  IF ~!Till THEN
   RETURN L_Car.GetAccurateRunInPer(trgBoxNbr, From, Till);
  ELSE
   RETURN L_Car.GetGlobalRun(trgBoxNbr, Till) - L_Car.GetGlobalRun(trgBoxNbr, From);
  END;
 END {GetRunInPer};

 PRIVATE PROCEDURE E_GetAttendRepEventList(    trgRepEvent: LIKE(RepEvent.RepEvent);
                                           VAR RepEventArr: LIKE(RepEvent.RepEvent)[]): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  SETEMPTY(RepEventArr);
  Local:=PROCREF(E_RE.GetAttendRepEventList);
  IF ~!Local THEN
   Local(trgRepEvent, RepEventArr);
  END;
  RETURN ~!RepEventArr[0];
 END {E_GetAttendRepEventList};

 PRIVATE PROCEDURE IsAttend(RE1, RE2: LIKE(RepEvent.RepEvent)): SCAL[2];
  VAR
   RepEventArr: LIKE(RepEvent.RepEvent)[MaxAttendRE];
   i          : NUMERIC[0];
 BEGIN
  IF E_GetAttendRepEventList(RE1, RepEventArr) THEN
   i:=0;
   WHILE ~!RepEventArr[i] DO
    IF RepEventArr[i] = RE2 THEN
     RETURN 1;
    END;
    INC(i);
   END;
  END;
  RETURN 0;
 END {IsAttend};

 PRIVATE PROCEDURE Prepare();
  VAR
   _Norm    : LIKE(MarkREN.Norm[0]);
   D,
   ProdD,
   _StartD,
   _NextD,
   _LastD   : DATE;
   _GlobRun : NUMERIC[0];
   IsFirst,
   FirstLine: SCAL[2];
   MarkGName: STRING[];
 BEGIN
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   IF L_Env.RealBoxNbr(Car.BoxNbr) & (Car.BegDate <= Memo.ud_ut()) &
      L_EC.ExecE_Func_Scal2(Memo.ud_ut(), PROCREF(E_RE.IsCarInPark), 1) THEN
    PROMPT(RepEvent.RepEvent + " : " + Car.BoxNbr);
    IF SELECT(CarEvn, CarEvn, Car.BoxNbr, RepEvent.RepEvent) THEN
     IF SRCINSEL(CarEvn, LE, Memo.ud_ut()) & (CarEvn.StopD >= Memo.ud_fr()) THEN
      L_Car.AccessMark(Car.BoxNbr, Memo.ud_ut());
      L_Car.StandOnCarLog(Car.BoxNbr, Memo.ud_ut());
      IF SEARCH(MarkG, MarkG, L_Way.GetMarkG_Soft(Mark.Mark, L_Way.mgt_REPlan)) THEN
       MarkGName:=MarkG.Name;
      ELSE
       MarkGName:="";
      END;
      _GlobRun:=L_Car.GetGlobalRun(Car.BoxNbr, Memo.ud_ut());
      _Norm   :=GetNorm(CarEvn.StartD, _GlobRun);
      WHILE OCCURE(CarEvn) & (CarEvn.StopD >= Memo.ud_fr()) DO
       _StartD:=CarEvn.StartD;
       D:=Math.Max(_StartD, Memo.ud_fr());
       FirstLine:=1;
       WHILE D <= Math.Min(CarEvn.StopD, Memo.ud_ut()) DO
        L_Basis.wb_WrScl('R', CarEvn.BoxNbr);
        L_Basis.wb_WrStr('R', CarLog.StateNbr);
        L_Basis.wb_WrStr('R', Mark.Name);
        L_Basis.wb_WrStr('R', MarkGName);
        L_Basis.wb_WrScl('R', Car.Column);
        L_Basis.wb_WrScl('R', RepEvent.RepEvent);
        L_Basis.wb_WrStr('R', RepEvent.Name);
 
        SAVE(RepEvent);
        SAVE(CarEvn);
        SELECT(CarEvn, BoxNbr, , CarEvn.BoxNbr, CarEvn.StartD);
        LOOP
         IF ~OCCURE(CarEvn) THEN
          RESTORE(CarEvn);
          RESTORE(RepEvent);
          L_Basis.wb_WrScl('R', RepEvent.RepEvent);
          L_Basis.wb_WrStr('R', RepEvent.Name);
          EXIT;
         ELSIF IsAttend(CarEvn.RepEvent, RepEvent.RepEvent) THEN
          CONFORM(CarEvn, RepEvent);
          L_Basis.wb_WrScl('R', RepEvent.RepEvent);
          L_Basis.wb_WrStr('R', RepEvent.Name);
          RESTORE(CarEvn);
          RESTORE(RepEvent);
          EXIT;
         END;
         NEXT(CarEvn);
        END; (* LOOP *)
 
        L_Basis.wb_WrDat('R', _StartD);
        L_Basis.wb_WrDat('R', CarEvn.StopD);
        L_Basis.wb_WrNum('R', _GlobRun, 0);
        L_Basis.wb_WrNum('R', _Norm, 0);
        L_Basis.wb_WrStr('R', L_Str.PoolItem(L_Car.purp_Pool, Car.Purpose));
        L_Basis.wb_WrStr('R', L_Str.PoolItem(L_Car.src_RE_Pool, CarEvn.Source));
        SAVE(CarEvn);
        ProdD  :=L_Car.GetCarProdDate(Car.BoxNbr, _StartD - 1);
        _LastD :=L_Car.NearestPastRepEventDate(_StartD - 1, RepEvent.RepEvent);
        IsFirst:=_LastD = ProdD;
        L_Basis.wb_WrScl('R', IsFirst);
        L_Basis.wb_WrNum('R', GetRunInPer(Car.BoxNbr, _LastD, _StartD), 0);
        _NextD:=L_Car.NearestFutureRepEventDate(_StartD, RepEvent.RepEvent);
        L_Basis.wb_WrNum('R', GetRunInPer(Car.BoxNbr, _StartD, _NextD), 0);
        RESTORE(CarEvn);
        L_Basis.wb_WrScl('R', CarEvn.DocNbr);
        L_Basis.wb_WrDat('R', D);
        L_Basis.wb_WrScl('R', ~FirstLine);
        L_Basis.wb_WrNum('R', D - _StartD + 1, 0);
        FirstLine:=0;
        L_Basis.wb_TermLine('R');
        INC(D);
       END; (* WHILE D <= *)
       PREV(CarEvn);
      END; (* WHILE OCCURE(CarEvn) ... *)
     END; (* IF SRCINSEL ... *)
    END;
   END;
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
 END {Prepare};

 PRIVATE PROCEDURE RE001();
  CONST
   bpId = "Re001";
 BEGIN
  LOADMODULE(E_RE, E_RE);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, " ॣ୮ ஢ ய⨩", L_bp.t_Basis, L_General.timeCond_InIntvl);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);

  L_Basis.wb_WrStr('R', "");
  L_Basis.wb_WrStr('R', ".");
  L_Basis.wb_WrStr('R', "ઠ");
  L_Basis.wb_WrStr('R', "㯯 ப");
  L_Basis.wb_WrStr('R', "");
  L_Basis.wb_WrStr('R', "ய⨥");
  L_Basis.wb_WrStr('R', "ய⨥");
  L_Basis.wb_WrStr('R', "᭮ ய⨥");
  L_Basis.wb_WrStr('R', "᭮ ய⨥");
  L_Basis.wb_WrStr('R', " 砫");
  L_Basis.wb_WrStr('R', " 砭");
  L_Basis.wb_WrStr('R', "騩 ஡");
  L_Basis.wb_WrStr('R', "ଠ");
  L_Basis.wb_WrStr('R', "祭");
  L_Basis.wb_WrStr('R', "筨");
  L_Basis.wb_WrStr('R', "ࢮ");
  L_Basis.wb_WrStr('R', "஡  ய");
  L_Basis.wb_WrStr('R', "஡ ᫥");
  L_Basis.wb_WrStr('R', " 㬥");
  L_Basis.wb_WrStr('R', "");
  L_Basis.wb_WrStr('R', "㡫");
  L_Basis.wb_WrStr('R', "  ய");
  L_Basis.wb_TermLine('R');

  SELECT(RepEvent, RepEvent);
  WHILE OCCURE(RepEvent) DO
   Prepare();
   NEXT(RepEvent);
  END; (* WHILE OCCURE() ... *)

  FIO.Close(R);
  L_bp.End();
 END {RE001};

(*
$P{ to1_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
" ஢ " + RepEvent.Name, C, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
############################################################################# ########## #####
=#####========================================================================================
|############################################################################################|
|                             ਮ  ##########  ##########                            |
}
*)

(*
$P{ to1_Subtop:
Column.Column, L, ""
Column.Name, L, ""
@
|--------------------------------------------------------------------------------------------|
| ## ###################################                                              |
|--------------------------------------------------------------------------------------------|
|  ઠ                           |砫    |砭 |     ଠ| ஡ |. ᫥|
|-------------------------------------|----------|----------|----------|----------|----------|
}
*)

(*
$P{ to1_Line:
Car.BoxNbr, L, ""
Mark.Name, L, ""
CarEvn.StartD, L, "D.N.y"
CarEvn.StopD, L, "D.N.y"
?, R, "0"
?, R, "0"
?, R, "0"
@
|#### ################################|##########|##########|##########|##########|##########|
}
*)

(*
$P{ to1_Bot:
@
=(c) Polak====================================================================================
}
*)

 PRIVATE PROCEDURE CheckIsFirstCarEnv(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(CarEvn);
  Result:=OCCURE(CarEvn) & ~PREV(CarEvn);
  RESTORE(CarEvn);
  RETURN Result;
 END {CheckIsFirstCarEnv};

 PRIVATE PROCEDURE Make_TO1();
  CONST
   RepName = "TO1xx";
  VAR
   Count        : NUMERIC[0];
   Date,
   DatePast,
   DateFuture   : DATE;
   IsFirstCarEvn: SCAL[2];
 BEGIN
  LOADMODULE(E_RE, E_RE);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(RepEvent), " ⠭ ய⨥");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, to1_Top, RepName);
  SELECT(Car, Column);
  WHILE OCCURE(Car) DO
   CONFORM(Car, Column);
   NARROWSEL(Car, Column);
   Count:=0;
   WHILE OCCURE(Car) DO
    PROMPT(Car.Column + " " + Car.BoxNbr);
    SELECT(CarEvn, CarEvn, , Car.BoxNbr, RepEvent.RepEvent);
    IF ~SRCINSEL(CarEvn, LE, Memo.ud_fr()) THEN
     FIRST(CarEvn);
    END;
    IsFirstCarEvn:=CheckIsFirstCarEnv();
    WHILE OCCURE(CarEvn) & (CarEvn.StartD <= Memo.ud_ut()) DO
     IF L_DatTim.IsActiveInIntvl_Inc(CarEvn.StartD, CarEvn.StopD, Memo.ud_fr(), Memo.ud_ut()) THEN
      L_General.Assert((CarEvn.Source # L_Car.src_FrCast) | (CarEvn.StopD > Memo.ud_ut()),
                       " ࠧ  ண ய|" +
                       RepEvent.RepEvent + " " + RepEvent.Name +
                       "  . " + CarEvn.BoxNbr + "  " + L_DatTim.DateStr(CarEvn.StartD));
      Date      :=CarEvn.StartD;
      SAVE(CarEvn);
      IF IsFirstCarEvn THEN
       DatePast  :=L_Car.GetCarProdDate(Car.BoxNbr, Date);
      ELSE
       DatePast  :=L_Car.NearestPastRepEventDate_Strong(Date-1, RepEvent.RepEvent);
      END;
      DateFuture:=L_Car.NearestFutureRepEventDate(Date, RepEvent.RepEvent);
      RESTORE(CarEvn);
      L_Car.StandOnCarLog(Car.BoxNbr, CarEvn.StartD);
      CONFORM(CarLog, Mark);
      IF Count = 0 THEN
       MAKEPART(R, to1_Subtop);
      END;
      MAKEPART(R, to1_Line, GetNorm(CarEvn.StartD, L_Car.GetGlobalRun(Car.BoxNbr, CarEvn.StartD)),
                            GetRunInPer(Car.BoxNbr, DatePast, CarEvn.StartD),
                            GetRunInPer(Car.BoxNbr, CarEvn.StartD, DateFuture));
      INC(Count);
     END;
     NEXT(CarEvn);
    END;
    NEXT(Car);
   END; (* WHILE OCCURE(Car) ... *)
   NEXTINEXTENDEDSEL(Car, Column);
  END; (* WHILE OCCURE(Car) ... *)
  MAKEPART(R, to1_Bot);
  CLOSEREP(R);
 END {Make_TO1};

 PRIVATE PROCEDURE MakePlan();
  CONST
   DialogWidth = 48;
 BEGIN
  LOADMODULE(E_RE, E_RE);
  L_General.Assert(ACCESS(REPrm), " ⠭ ⮪ ஢");
  CONFORM(REPrm, RepEvent);
  plnRepEvent  :=REPrm.RepEvent;
  Piece        :=REPrm.Piece;
  BaseDate     :=Memo.ud_cd();
  MinTargetDate:=BaseDate + RepEvent.FShift;
  MaxTargetDate:=MinTargetDate + RepEvent.PlanPer - 1;
  MakeProtocol:=1;
  SETZERO(HasTrouble);
  LOOP
   STDFORM(" |ய⨥  %L29NI" +
           "||ਮ        %L<D.N.y>I  %L<D.N.y>I "+
           "||  %L<D.N.y>I                  " +
           "||       %L29NI" +
           "||%< ⮪>FE" +
           "||%< 믮 >DB    %<   ⮯!   >Z",
           " ஢ ய ",
           ,
           1,
           RepEvent.RepEvent + " " + RepEvent.Name,
           MinTargetDate,
           MaxTargetDate,
           BaseDate,
           REPrm.Name,
           MakeProtocol);
   IF    BaseDate >= SYSDATE() THEN
    L_StdFrm.RedInform("     諮");
   ELSIF MinTargetDate < SYSDATE() THEN
    L_StdFrm.RedInform("ਮ ஢    㦥 襤訥 ");
   ELSE
    EXIT;
   END;
  END; (* LOOP *)
  Do();
 END {MakePlan};

 PUBLIC PROCEDURE RE_MakePlan();
  VAR
   List    : STRING[];
   arrPiece: LIKE(REPrm.Piece)[64];
   i       : NUMERIC[0];
 BEGIN
  L_General.Assert(ACCESS(RepEvent), " ⠭ ⥪  'ய⨩'");
  IF SELECT(REPrm, RepEvent, RepEvent.RepEvent) THEN
   i   :=0;
   List:="";
   WHILE OCCURE(REPrm) DO
    INC(List, REPrm.Piece + " " + REPrm.Name + "|");
    arrPiece[i]:=REPrm.Piece;
    INC(i);
    NEXT(REPrm);
   END; (* WHILE OCCURE(REPrm) *)
   IF i > 1 THEN
    i:=L_StdFrm.ShowListAsMenu(List, " 롮 ࠧ ⮪ ");
   ELSE
    i:=0;
   END;
   SRCINSEL(REPrm, EQ, , arrPiece[i]);
   MakePlan();
  ELSE
   L_General.Error(" 믮 'ன ஢'");
  END;
 END {RE_MakePlan};

 PRIVATE PROCEDURE Create_RPL03();
 BEGIN
  CreateFILE(RPL03, "", " ᮡ", "");

  CreateFIELD(RPL03, BoxNbr,   LIKE(Car.BoxNbr),        "", "", "", " ⮬", "");
  CreateFIELD(RPL03, StartD,   DATE,                    "", "", "", " 砫", "");
  CreateFIELD(RPL03, RepEvent, LIKE(RepEvent.RepEvent), "", "", "", " ᮡ", "");
  CreateFIELD(RPL03, Source,   SCAL[5],                 "", "", "", "筨", "");
  CreateFIELD(RPL03, Norm,     NUMERIC[1],              "", "", "", "ଠ⨢", "");
  CreateFIELD(RPL03, DayRun,   NUMERIC[5],              "", "", "", "। ஡", "");
  CreateFIELD(RPL03, DateLast, DATE,                    "", "", "", " ᫥ ய", "");
  CreateFIELD(RPL03, ForeCast, NUMERIC[1],              "", "", "", "ண ஡", "");
  CreateFIELD(RPL03, OverPrc,  NUMERIC[1],              "", "", "", "९஡", "");
  CreateFIELD(RPL03, BaseRE,   LIKE(RepEvent.RepEvent), "", "", "", " ய⨥", "");

  CreateINDEXandLINK(RPL03, BoxNbr,   UNIQUE, Car,      BoxNbr,   BORROW, "", "", BoxNbr, StartD, RepEvent);
  CreateINDEX       (RPL03, CarEvn,   PLURAL,                             "", "", BoxNbr, RepEvent, StartD);
  CreateINDEX       (RPL03, StartD,   PLURAL,                             "", "", StartD, BoxNbr);
  SetVersionOfFILE(RPL03, 0000);

  L_AFM.CreateTemp("RPL03");
 END {Create_RPL03};

(*
$P{ Attend_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
BaseDate, L, "D.N.y"
@
############################################################# ########## #####
=#####========================================================================
|              - ண ஢ ᮯ ய⨩            |
|                                                       ##########|
}
*)

(*
$P{ Attend_OneDate:
?, L, "D.N.y"
?, L, ""
@
|============================================================================|
| ##########, ###########                                                  |
|----------------------------------------------------------------------------|
| |.  |ઠ           ||| ᫥| ஡|%९.| |  |
|----|----------|----------------|--|--|----------|-------|--------|------|--|
}
*)

(*
$P{ Attend_Line:
Car.BoxNbr, L, ""
CarLog.StateNbr, L, ""
Mark.Name, L, ""
CarLog.Column, L, ""
?, L, ""
?, L, "D.N.y"
?, R, "0"
?, R, "2."
?, R, "1."
?, L, ""
@
|####|##########|################|##|##|##########|#######|########|######|##|
}
*)

(*
$P{ Attend_Bot:
@
=(c) Polak====================================================================
}
*)


 PRIVATE PROCEDURE PrintAttend(DoInsertCarEvn: SCAL[2]);
  CONST
   RepName = "RPlAt";
  VAR
   SrcStr   : STRING[];
   EvnSource: LIKE(CarEvn.Source);
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Attend_Top, RepName);
  SELECT(RPL03, StartD);
  WHILE OCCURE(RPL03) DO
   CHANGESEL(RPL03, StartD, , RPL03.StartD);
   L_General.Assert(SEARCH(Calendar, Date, RPL03.StartD),
                    "    " + L_DatTim.DateStr(RPL03.StartD));
   MAKEPART(R, Attend_OneDate, RPL03.StartD, L_DatTim.WeekDayStr(Calendar.WeekDay, 0));
   WHILE OCCURE(RPL03) DO
    CONFORM(RPL03, Car);
    L_Car.StandOnCarLog(Car.BoxNbr, RPL03.StartD);
    CONFORM(CarLog, Mark);
    IF RPL03.Source = src_ThisFrCast THEN
     SrcStr:=RPL03.BaseRE;
     IF DoInsertCarEvn THEN
      InsCarEvn(Car.BoxNbr, RPL03.StartD, RPL03.StartD + E_GetCarDuration(RPL03.StartD, RPL03.RepEvent) - 1,
                RPL03.RepEvent, L_General.EMPTY_NUMBER(), L_Car.src_FrCast);
     END;
    ELSE
     SrcStr:=L_Str.PoolItem(srcPool, RPL03.Source);
    END;
    MAKEPART(R, Attend_Line, RPL03.RepEvent, RPL03.DateLast, RPL03.ForeCast,
                             RPL03.OverPrc, RPL03.DayRun, SrcStr);
    NEXT(RPL03);
   END; (* WHILE OCCURE(RPL03) ... *)
   LAST(RPL03);
   CHANGESEL(RPL03, StartD);
   NEXT(RPL03);
  END; (* WHILE OCCURE(RPL03) ... *)
  MAKEPART(R, Attend_Bot);
  CLOSEREP(R);
 END {PrintAttend};

 PRIVATE PROCEDURE MakeAttend();
  VAR
   RepEventArr   : LIKE(RepEvent.RepEvent)[MaxAttendRE];
   Idx           : NUMERIC[0];
   Past          : DATE;
   _DayRun       : NUMERIC[5];
   FRC,
   _Norm,
   _OverPrc      : NUMERIC[1];
   DoInsertCarEvn: SCAL[2];
 BEGIN
  LOADMODULE(E_RE, E_RE);
  Create_RPL03();

  MinTargetDate :=SYSDATE();
  BaseDate      :=Memo.ud_cd();
  DoInsertCarEvn:=0;

  LOOP
   STDFORM("|  %L<D.N.y>I, %<쪮 c⠢ -ண|ନ ண ய⨩>FI" +
           "||%< 믮 >DB    %<   ⮯!   >Z",
           " ஢ ᮯ ய⨩ ", , -1, BaseDate, DoInsertCarEvn);
   IF BaseDate >= SYSDATE() THEN
    L_StdFrm.RedInform("     諮");
   ELSE
    EXIT;
   END;
  END;

  SELECT(CarEvn, BoxNbr);
  WHILE OCCURE(CarEvn) DO
   PROMPT(CarEvn.BoxNbr);
   NARROWSEL(CarEvn, BoxNbr);
   IF SRCINSEL(CarEvn, GE, MinTargetDate) THEN
    CONFORM(CarEvn, Car);
    L_Car.AccessMark(Car.BoxNbr, CarEvn.StartD);
    L_Car.StandOnCarLog(Car.BoxNbr, CarEvn.StartD);
    WHILE OCCURE(CarEvn) DO
     IF E_GetAttendRepEventList(CarEvn.RepEvent, RepEventArr) THEN
      Idx:=0;
      WHILE ~!RepEventArr[Idx] DO
       plnRepEvent:=RepEventArr[Idx];
       SEARCH(RepEvent, RepEvent, , plnRepEvent);
       IF L_DatTim.IsActive(CarEvn.StartD, RepEvent.Begin, RepEvent.Till) THEN
        MaxDuration:=CountDuration(RepEvent.Duration, 0);
 
        SAVE(CarEvn);
        SELECT(CarEvn, CarEvn, , Car.BoxNbr, plnRepEvent);
        SRCINSEL(CarEvn, GE, , MinTargetDate);
        WHILE OCCURE(CarEvn) DO
         IF ~ADD(RPL03, BoxNbr, CarEvn.BoxNbr, CarEvn.StartD, CarEvn.RepEvent) THEN
          RPL03.Source  :=src_NotFrCast;
          SAVE(CarEvn);
          RPL03.DateLast:=L_Car.NearestPastRepEventDate(CarEvn.StartD-1, plnRepEvent);
          RESTORE(CarEvn);
          RPL03.DayRun  :=GetDayRun();
 
          RPL03.Norm    :=GetNorm(MinTargetDate, L_Car.GetGlobalRun(Car.BoxNbr, MinTargetDate));
          RPL03.ForeCast:=GetForecastRun(CarEvn.StartD,
                                         L_Car.GetAccurateRunInPer(Car.BoxNbr,
                                                                   RPL03.DateLast,
                                                                   BaseDate),
                                         RPL03.DayRun);
          RPL03.OverPrc :=GetOverPrc(RPL03.ForeCast, RPL03.Norm);
          REPLACE(RPL03);
         END;
         NEXT(CarEvn);
        END; (* WHILE OCCURE(CarEvn) ... *)
        RESTORE(CarEvn);
        SAVE(CarEvn);
        Past:=L_Car.NearestPastRepEventDate(CarEvn.StartD, plnRepEvent);
        RESTORE(CarEvn);
        IF SELECT(RPL03, CarEvn, Car.BoxNbr, plnRepEvent) THEN
         LAST(RPL03);
         IF Past < RPL03.StartD THEN
          Past:=RPL03.StartD;
         END;
        END;
        _DayRun:=GetDayRun();
        FRC:=GetForecastRun(CarEvn.StartD,
                            L_Car.GetAccurateRunInPer(Car.BoxNbr, Past, BaseDate),
                            _DayRun);
        _Norm:=GetNorm(MinTargetDate, L_Car.GetGlobalRun(Car.BoxNbr, MinTargetDate));
        _OverPrc:=GetOverPrc(FRC, _Norm);
        IF NeedRepEvent(CarEvn.StartD, Past, _OverPrc) THEN
         IF ~ADD(RPL03, BoxNbr, Car.BoxNbr, CarEvn.StartD, plnRepEvent) THEN
          RPL03.Source  :=src_ThisFrCast;
          RPL03.Norm    :=_Norm;
          RPL03.DayRun  :=_DayRun;
          RPL03.DateLast:=Past;
          RPL03.ForeCast:=FRC;
          RPL03.OverPrc :=_OverPrc;
          RPL03.BaseRE  :=CarEvn.RepEvent;
          REPLACE(RPL03);
         END;
        END;
       END; (* IF L_DatTim.IsActive(CarEvn.StartD, RepEvent *)
       INC(Idx);
      END; (* WHILE ~!RepEventArr[Idx] *)
     END; (* IF E_GetAttendRepEventList( *)
     NEXT(CarEvn);
    END; (* WHILE OCCURE(CarEvn) ... *)
   END; (* IF SRCINSEL(CarEvn, GE, MinTargetDate) *)
   NEXTINEXTENDEDSEL(CarEvn, BoxNbr);
  END; (* WHILE OCCURE(CarEvn) ... *)

  PrintAttend(DoInsertCarEvn);

  L_AFM.AF_PurgeTemp("RPL03");
 END {MakeAttend};

END.
