(*
%Copyright   (c) Polak IT
%Author      11.12.2003 14:48:55 POLAK\LDA
%Purpose       ६⮢  ਮ
%Type        report
%Specific    LOC
%Modified    03.07.2014 09:59:27 POLAK\LDA
%Environment
*)

 MODULE Rpr08 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Car, L_Basis, FIO, L_Str, Memo, L_Rpr, L_DatTim, L_Way, L_BegRWS, P_Rpr, L_bp, L_Staff;

 PRIVATE CONST
  RepName = "Rpr08";

  EmptyLevel = "----";
  EmptyValue = "---";

  obj_RprS  = 0;
  obj_RprDA = 1;
  obj_RprT  = 2;

 PRIVATE VAR
  ShortRprSDescription : STRING[];
  RprTTaskKindConcation: SCAL[2][MAXOF(RprT.TaskKind)];

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "1");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "६");
  L_Basis.wb_WrInQM(F, "㥬⠎砭");
  L_Basis.wb_WrInQM(F, "㥬६砭");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⠇");
  L_Basis.wb_WrInQM(F, "६");
  L_Basis.wb_WrInQM(F, " ꥪ ६");
  L_Basis.wb_WrInQM(F, "ꥪ ६");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, ".");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ࠣ");
  L_Basis.wb_WrInQM(F, "ࠣ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ॣ");

  L_Basis.wb_WrInQM(F, "室  ()");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "६砭돮");
  L_Basis.wb_WrInQM(F, "⪮ ᠭ ");

  L_Basis.wb_WrInQM(F, "ॣ_ࠢ");
  L_Basis.wb_WrInQM(F, "ॣ_ࠢ");
  L_Basis.wb_WrInQM(F, "ࠢ");
  L_Basis.wb_WrInQM(F, "ࠢ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "࠭");
  L_Basis.wb_WrInQM(F, "਩");

  L_Basis.wb_WrInQM(F, "⥭");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "஫ ப");
  L_Basis.wb_WrInQM(F, "㥬⠂믮");
  L_Basis.wb_WrInQM(F, "㥬६믮");
  L_Basis.wb_WrInQM(F, "᪮ ६ ");
  L_Basis.wb_WrInQM(F, "믮");

  L_Basis.wb_WrInQM(F, "2");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ॣ_");
  L_Basis.wb_WrInQM(F, "ॣ_");
  L_Basis.wb_WrInQM(F, "⠊");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ଠ⨢ 㤮");
  L_Basis.wb_WrInQM(F, "㤮 ࠡ");
  L_Basis.wb_WrInQM(F, "㤮 ");
  L_Basis.wb_WrInQM(F, "᪮ ६ ࠡ");
  L_Basis.wb_WrInQM(F, "⢮ ࠡ");
  L_Basis.wb_WrInQM(F, "⮨ ମ");
  L_Basis.wb_WrInQM(F, "⮨ ࠡ");

  L_Basis.wb_WrInQM(F, "3");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⭨");
  L_Basis.wb_WrInQM(F, "⭨");
  L_Basis.wb_WrInQM(F, "⭨");
  L_Basis.wb_WrInQM(F, "⭨");

  L_Basis.wb_WrInQM(F, "⪠");
  L_Basis.wb_WrInQM(F, "⪠");
  L_Basis.wb_WrInQM(F, "祭");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE GetDuration(trgBDate: DATE;
                               trgBTime: TIME;
                               trgEDate: DATE;
                               trgETime: TIME): NUMERIC[3];
  VAR
   BegDTS, EndDTS: TIMESTAMP;
 BEGIN
  BegDTS:=L_DatTim.GetTIMESTAMP(trgBDate, trgBTime);
  IF !trgEDate THEN
   EndDTS:=L_DatTim.GetSysTIMESTAMP();
  ELSE
   EndDTS:=L_DatTim.GetTIMESTAMP(trgEDate, trgETime);
  END;
  RETURN (EndDTS - BegDTS) * 24;
 END {GetDuration};

 PRIVATE PROCEDURE GetRprTTaskKindConcation(): STRING[];
  VAR
   i: NUMERIC[0];
   S: STRING[];
 BEGIN
  SETEMPTY(S);
  i:=0;
  WHILE i <= HIGH(RprTTaskKindConcation) DO
   IF RprTTaskKindConcation[i] = 1 THEN
    IF ~!S THEN
     S:=S + ";";
    END;
    S:=S + L_Str.PoolItem(L_Rpr.rpr_TaskKind_Pool, i);
   END;
   INC(i);
  END;
  RETURN S;
 END {GetRprTTaskKindConcation};

 PRIVATE PROCEDURE IsAcceptableRprP(trgRprT: LIKE(RprT.RprT); trgRprJ: LIKE(RprJ.RprJ)): SCAL[2];
 BEGIN
  RETURN !RprP.RprT |
         ((RprP.RprT = trgRprT) & (!RprP.RprJ)) |
         ((RprP.RprT = trgRprT) & (RprP.RprJ = trgRprJ))
 END {IsAcceptableRprP};

 PRIVATE PROCEDURE GetRprJNormBaseTime(): NUMERIC[3];
  VAR
   Result     : NUMERIC[3];
   dummySource: LIKE(RprJ.Source);
   dummyClass : LIKE(StaffLog.Class);
 BEGIN
  SETEMPTY(Result);
  L_Rpr.extGetRprJobBaseTime(RprJ.RprJob, RprJ.BDate, 1, Result, dummySource, dummyClass);
  IF !Result THEN
   SETZERO(Result);
  END;
  RETURN Result;
 END {GetRprJNormBaseTime};

 PRIVATE PROCEDURE MakePart(F     : STRING[];
                            Object: SCAL[3];
                            wRprJ, wRprPro, wRprP   : SCAL[2]);
  VAR
   trgDate,
   PlnEDate,
   MaxPlnEDate : DATE;
   PlnETime,
   MaxPlnETime : TIME;
   trgRprJBaseTime,
   trgRprJobBaseTime: LIKE(RprJMG.BaseTime);
 BEGIN
  L_Basis.wb_WrStr(F, L_Str.PoolItem("----|ࠢ|", Object));
  L_Basis.wb_WrScl(F, RprS.RprS);
  L_Basis.wb_WrDat(F, RprS.OrdDate);
  L_Basis.wb_WrTim(F, RprS.OrdTime);
  IF RprS.Closed THEN
   MaxPlnEDate:=RprS.EDate;
   MaxPlnETime:=RprS.ETime;
  ELSE
   L_Rpr.GetMaxPlnEDateTime(MaxPlnEDate, MaxPlnETime);
  END;
  L_Basis.wb_WrDat(F, MaxPlnEDate);
  L_Basis.wb_WrTim(F, MaxPlnETime);
  L_Basis.wb_WrStr(F, L_Rpr.GetRprSStatus_AsStr(RprS.Status));
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|", RprS.Closed));
  L_Basis.wb_WrDat(F, RprS.EDate);
  L_Basis.wb_WrTim(F, RprS.ETime);

  L_Basis.wb_WrStr(F, L_Rpr.GetRprObjT_AsStr());
  L_Basis.wb_WrScl(F, RprS.RprObjId);
  IF    L_Rpr.IsRprS_w_Car() THEN
   L_Car.StandOnCarLog(Car.BoxNbr, RprS.OrdDate);
   CONFORM(CarLog, Mark);
   L_Basis.wb_WrStr(F, CarLog.Column);
   L_Basis.wb_WrStr(F, CarLog.StateNbr);
   L_Basis.wb_WrScl(F, Mark.Mark);
   L_Basis.wb_WrStr(F, Mark.Name);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
  ELSIF L_Rpr.IsRprS_w_OutCar() THEN
   CONFORM(OutCar, Mark);
   CONFORM(OutCar, Firm);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, OutCar.StateNbr);
   L_Basis.wb_WrScl(F, Mark.Mark);
   L_Basis.wb_WrStr(F, Mark.Name);
   L_Basis.wb_WrScl(F, Firm.Firm);
   L_Basis.wb_WrStr(F, Firm.Name);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
  ELSIF L_Rpr.IsRprS_w_CarBlock() THEN
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrScl(F, Math.Math);
   L_Basis.wb_WrStr(F, Math.Name);
   L_Basis.wb_WrStr(F, CUCopy.Serial);
  ELSIF L_Rpr.IsRprS_w_OutCBlc() THEN
   CONFORM(OutCBlc, Math);
   CONFORM(OutCBlc, Firm);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrScl(F, Firm.Firm);
   L_Basis.wb_WrStr(F, Firm.Name);
   L_Basis.wb_WrScl(F, Math.Math);
   L_Basis.wb_WrStr(F, Math.Name);
   L_Basis.wb_WrStr(F, OutCBlc.Serial);
  ELSIF L_Rpr.IsRprS_w_Math() THEN
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrScl(F, Math.Math);
   L_Basis.wb_WrStr(F, Math.Name);
   L_Basis.wb_WrStr(F, EmptyValue);
  ELSE
   L_General.CallUs(0);
  END;

  IF L_Rpr.IsRprS_w_Car() & L_Rpr.StandOnReturnedRWayS() THEN
   CONFORM(RWayS, StExit);
   CONFORM(StExit, SEJobs);
   CONFORM(SEJobs, Route);
   L_Basis.wb_WrStr(F, L_Str.PoolItem("室|室", RprS.OrdTime > L_BegRWS.GetRWaySExitTime(0)));
   L_Basis.wb_WrStr(F, Route.Route);
   L_Basis.wb_WrStr(F, Route.Name);
   L_Basis.wb_WrTim(F, L_BegRWS.GetRWaySEnterTime(0));
  ELSE
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
  END;

  L_Basis.wb_WrStr(F, ShortRprSDescription);

  IF Object = obj_RprDA THEN
   CONFORM(RprDA, CarBlock);
   CONFORM(RprDA, RprDfApr);
   L_Basis.wb_WrScl(F, RprDA.CarBlock);
   L_Basis.wb_WrStr(F, CarBlock.Name);
   L_Basis.wb_WrScl(F, RprDA.RprDfApr);
   L_Basis.wb_WrStr(F, RprDfApr.Name);
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Rpr.GetWhenBurn_Pool(1), RprDA.WhenBurn));
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Rpr.GetFixed_Pool(1), RprDA.Fixed));
   L_Basis.wb_WrStr(F, RprDA.Comment);
  ELSE
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
  END;

  L_Basis.wb_WrStr(F, GetRprTTaskKindConcation());

  IF Object = obj_RprT THEN
   L_Basis.wb_WrScl(F, RprT.RprT);
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Rpr.rpr_TaskKind_Pool, RprT.TaskKind));
   L_Basis.wb_WrScl(F, RprT.Sort);
   CONFORM(RprT, Sort);
   IF OCCURE(Sort) THEN
    L_Basis.wb_WrStr(F, Sort.Name);
   ELSE
    L_Basis.wb_WrStr(F, EmptyValue);
   END;
   L_Basis.wb_WrScl(F, RprT.RprPlace);
   CONFORM(RprT, RprPlace);
   IF OCCURE(RprPlace) THEN
    L_Basis.wb_WrStr(F, RprPlace.Name);
   ELSE
    L_Basis.wb_WrStr(F, EmptyValue);
   END;
   L_Basis.wb_WrNum(F, L_Rpr.GetRprTTaskLen(), 3);
   L_Rpr.GetRprTEndDateTime(PlnEDate, PlnETime);
   L_Basis.wb_WrDat(F, PlnEDate);
   L_Basis.wb_WrTim(F, PlnETime);
   IF ~!RprT.JobBDate THEN
    L_Basis.wb_WrNum(F, GetDuration(RprT.JobBDate, RprT.JobBTime, RprT.JobEDate, RprT.JobETime), 3);
   ELSE
    L_Basis.wb_WrNum(F, 0, 3);
   END;
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Rpr.GetTaskResult_Pool(0), RprT.Result));
  ELSE
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrNum(F, 0, 3);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrNum(F, 0, 3);
   L_Basis.wb_WrStr(F, EmptyValue);
  END;

  IF wRprJ THEN
   CONFORM(RprJ, RprJob);
   CONFORM(RprJob, CarBlock);
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrScl(F, RprJ.RprJ);
   L_Basis.wb_WrScl(F, RprJob.CarBlock);
   L_Basis.wb_WrStr(F, CarBlock.Name);
   L_Basis.wb_WrScl(F, RprJ.RprJob);
   L_Basis.wb_WrStr(F, RprJob.Name);
   trgRprJobBaseTime:=GetRprJNormBaseTime();
   trgRprJBaseTime  :=RprJ.BaseTime;
   L_Basis.wb_WrNum(F, trgRprJobBaseTime, 3);
   L_Basis.wb_WrNum(F, trgRprJBaseTime, 3);
   L_Basis.wb_WrStr(F, L_Str.PoolItem("-|", trgRprJobBaseTime = trgRprJBaseTime));
   L_Basis.wb_WrNum(F, GetDuration(RprJ.BDate, RprJ.BTime, RprJ.EDate, RprJ.ETime), 3);
   L_Basis.wb_WrNum(F, RprJ.Quantity, 3);
   L_Basis.wb_WrNum(F, RprJ.Price, 2);
   L_Basis.wb_WrNum(F, RprJ.Sum, 2);
  ELSE
   L_Basis.wb_WrStr(F, EmptyLevel);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrNum(F, 0, 3);
   L_Basis.wb_WrNum(F, 0, 3);
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrNum(F, 0, 3);
   L_Basis.wb_WrNum(F, 0, 0);
   L_Basis.wb_WrNum(F, 0, 2);
   L_Basis.wb_WrNum(F, 0, 2);
  END;

  IF    wRprP THEN
   L_Basis.wb_WrStr(F, "ᮭ");
  ELSIF wRprPro THEN
   L_Basis.wb_WrStr(F, "⪨");
  ELSE
   L_Basis.wb_WrStr(F, EmptyLevel);
  END;

  IF wRprP THEN
   CONFORM(RprP, Staff);
   IF    Object = obj_RprS THEN
    trgDate:=RprS.OrdDate;
   ELSIF Object = obj_RprT THEN
    IF wRprJ THEN
     IF ~!RprJ.BDate THEN
      trgDate:=RprJ.BDate;
     ELSE
      trgDate:=SYSDATE();
     END;
    ELSE
     trgDate:=RprT.BDate;
    END;
   END;
   L_Staff.PosToStaffLog(Staff.TSN, trgDate, 1);
   CONFORM(StaffLog, Sort);
   CONFORM(StaffLog, Officer);
   CONFORM(Officer, Post);
   CONFORM(Staff, Man);
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Rpr.rprpwho_Pool, RprP.Who));
   L_Basis.wb_WrScl(F, RprP.TSN);
   L_Basis.wb_WrStr(F, Man.Name);
   L_Basis.wb_WrScl(F, Sort.Sort);
   L_Basis.wb_WrStr(F, Sort.Name);
   L_Basis.wb_WrScl(F, Post.Post);
   L_Basis.wb_WrStr(F, Post.Name);
  ELSE
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
  END;
  IF wRprPro THEN
   CONFORM(RprPro, Property);
   L_Basis.wb_WrScl(F, RprPro.Property);
   L_Basis.wb_WrStr(F, Property.Name);
   L_Basis.wb_WrStr(F, RprPro.Value);
  ELSE
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
   L_Basis.wb_WrStr(F, EmptyValue);
  END;
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE PutRprP(Object : SCAL[3];
                           trgRprT: LIKE(RprT.RprT);
                           trgRprJ: LIKE(RprJ.RprJ));
 BEGIN
  SELECT(RprP, RprS, , RprS.RprS);
  WHILE OCCURE(RprP) DO
   IF IsAcceptableRprP(trgRprT, trgRprJ) THEN
    MakePart("R", Object, ~!trgRprJ, 0, 1);
   END;
   NEXT(RprP);
  END; (* WHILE OCCURE(RprP) ... *)
 END {PutRprP};

 PRIVATE PROCEDURE PutRprPro(Object: SCAL[3];
                             _RprT : LIKE(RprT.RprT);
                             _RprJ : LIKE(RprJ.RprJ));
 BEGIN
  SELECT(RprPro, RprS, , RprS.RprS, _RprT, _RprJ);
  WHILE OCCURE(RprPro) DO
   MakePart("R", Object, ~!_RprJ, 1, 0);
   NEXT(RprPro);
  END; (* WHILE OCCURE(RprPro) ... *)
 END {PutRprPro};

 PRIVATE PROCEDURE PrepareRprTTaskKindConcation(All: SCAL[2]);
 BEGIN
  SETZERO(RprTTaskKindConcation);
  SELECT(RprT, RprS, , RprS.RprS);
  WHILE OCCURE(RprT) DO
   IF All | ((RprT.Result = L_Rpr.tr_InProgress) | (RprT.Result = L_Rpr.tr_PutOff)) THEN
    RprTTaskKindConcation[RprT.TaskKind]:=1;
   END;
   NEXT(RprT);
  END; (* WHILE OCCURE(RprT) ... *)
 END {PrepareRprTTaskKindConcation};

 PRIVATE PROCEDURE MakeOneRprS(All: SCAL[2]);
 BEGIN
  L_Rpr.AccessOrigin();
  PrepareRprTTaskKindConcation(All);

  ShortRprSDescription:=P_Rpr.GetShortRprSDescr(RprS.RprS);

  MakePart("R", obj_RprS, 0, 0, 0);

  SELECT(RprDA, RprS, , RprS.RprS);
  WHILE OCCURE(RprDA) DO
   IF All | (RprDA.Fixed = L_Rpr.daf_ThereIs) THEN
    MakePart("R", obj_RprDA, 0, 0, 0);
   END;
   NEXT(RprDA);
  END; (* WHILE OCCURE(RprDA) ... *)

  PutRprP(obj_RprS, "", "");
  PutRprPro(obj_RprS, "", "");

  SELECT(RprT, RprS, , RprS.RprS);
  WHILE OCCURE(RprT) DO
   IF All | ((RprT.Result = L_Rpr.tr_InProgress) | (RprT.Result = L_Rpr.tr_PutOff)) THEN
    MakePart("R", obj_RprT, 0, 0, 0);
    PutRprP(obj_RprT, RprT.RprT, "");
    PutRprPro(obj_RprT, RprT.RprT, "");
    SELECT(RprJ, RprS, , RprS.RprS, RprT.RprT);
    WHILE OCCURE(RprJ) DO
     IF All | ~!RprJ.EDate THEN
      MakePart("R", obj_RprT, 1, 0, 0);
      PutRprP(obj_RprT, RprT.RprT, RprJ.RprJ);
      PutRprPro(obj_RprT, RprT.RprT, RprJ.RprJ);
     END;
     NEXT(RprJ);
    END; (* WHILE OCCURE(RprJ) ... *)
   END;
   NEXT(RprT);
  END; (* WHILE OCCURE(RprT) ... *)
 END {MakeOneRprS};

 PUBLIC PROCEDURE Rpr08();
  CONST
   bpId = "Rpr08";
  VAR
   BPer, EPer: DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  BPer:=Memo.ud_fr();
  EPer:=Memo.ud_ut();;
  L_bp.Begin(bpId, "  ६⮢", L_bp.t_Basis, L_General.timeCond_InIntvl);
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  MakeHeader("R");

  SELECT(RprS, EDate);
  SRCINSEL(RprS, GE, , BPer);
  WHILE OCCURE(RprS) DO
   PROMPT(RprS.RprS);
   IF RprS.OrdDate <= EPer THEN
    MakeOneRprS(1);
   END;
   NEXT(RprS);
  END; (* WHILE OCCURE(RprS) ... *)
  FIO.Close(R);
  L_bp.End();
 END {Rpr08};

 PUBLIC PROCEDURE Rpr08_Open();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  MakeHeader("R");
  SELECT(RprS, cOrdDate, , 0);
  WHILE OCCURE(RprS) DO
   PROMPT(RprS.RprS);
   MakeOneRprS(0);
   NEXT(RprS);
  END; (* WHILE OCCURE(RprS) ... *)
  FIO.Close(R);
  L_Basis.PlayMakedRunTimeRep(RepName, L_General.timeCond_InIntvl, "  ६⮢", 0);
 END {Rpr08_Open};

END.
