(*
%Copyright   (c) Polak Computer System
%Author      UnKnown
%Purpose      ஢ ᮣ᭮  /
%Type        report
%Specific    AP_PC
%Modified    26.02.2013 13:50:55 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_Way, DBD, L_Env, L_General, L_Staff, L_DatTim, L_OwnData, L_AFM,
        Memo, L_Sheet, L_PRoll;

 CONST
  Depth   = 60;
  DaySign = " ||||||2|3|4|5|6|7|8|9||?|!|*";

 VAR
  Sht : NUMERIC[0][32];
  Page: NUMERIC[0];

  Obj0,
  Obj1,
  Cond,
  Proc,
  Lin,
  Top,
  Bot,
  Spc : STRING[16];

  UpTo   : DATE;

(*
$P {TopSingle:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
Obj0, C, ""
UpTo, L, "D.N.y"
Staff.TSN, L, ""
Man.Name, L, ""
@
############################################## ########## #####
---------------------------------------------------------------
|       ##########   /  ##########       |
|=============================================================|
|##### #########################################              |
|-------------------------------------------------------------|
|1|2|3|4|5|6|7|8|9|0|1|2|3|4|5|6|7|8|9|0|1|2|3|4|5|6|7|8|9|0|1|
|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|
}
$P {LinSingle:
Sht[01], L, DaySign
Sht[02], L, DaySign
Sht[03], L, DaySign
Sht[04], L, DaySign
Sht[05], L, DaySign
Sht[06], L, DaySign
Sht[07], L, DaySign
Sht[08], L, DaySign
Sht[09], L, DaySign
Sht[10], L, DaySign
Sht[11], L, DaySign
Sht[12], L, DaySign
Sht[13], L, DaySign
Sht[14], L, DaySign
Sht[15], L, DaySign
Sht[16], L, DaySign
Sht[17], L, DaySign
Sht[18], L, DaySign
Sht[19], L, DaySign
Sht[20], L, DaySign
Sht[21], L, DaySign
Sht[22], L, DaySign
Sht[23], L, DaySign
Sht[24], L, DaySign
Sht[25], L, DaySign
Sht[26], L, DaySign
Sht[27], L, DaySign
Sht[28], L, DaySign
Sht[29], L, DaySign
Sht[30], L, DaySign
Sht[31], L, DaySign
@
|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|
|-------------------------------------------------------------|
|                                          |       ६|
|------------------------------------------------|------------|
}
$P { MonLine:
MCList.Name, L, ""
?, R, "3."
@
|################################################|############|
}

$P { Time:
?, R, "3."
?, R, "3."
?, R, "3."
@
|-------------------------------------------------------------|
|ଠ ६                                   |############|
|४஢                              |############|
|ࠡ⠭                                      |############|
=(c) Polak=====================================================
}
$P {BotSingle:
@
=() Polak=====================================================
}

$P {TopBody:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
Obj1, C, ""
Memo.ud_mb(), L, "N.y"
TimeKeep.TimeKeep, L, ""
TimeKeep.Name, L, ""
@
#############################################################################              ########## #####
-----------------------------------------------------------------------------------------------------------
|                      ########### ᮣ᭮  ⥢ ⠬  #######                     |
|=========================================================================================================|
|騪 ### ################################                                                           |
|---------------------------------------------------------------------------------------------------------|
|  |                             ||1|2|3|4|5|6|7|8|9|0|1|2|3|4|5|6|7|8|9|0|1|2|3|4|5|6|7|8|9|0|1|
}

$P {LinBody:
Staff.TSN, L, ""
Man.Name, L, ""
Officer.Union, L, ""
Sht[01], L, DaySign
Sht[02], L, DaySign
Sht[03], L, DaySign
Sht[04], L, DaySign
Sht[05], L, DaySign
Sht[06], L, DaySign
Sht[07], L, DaySign
Sht[08], L, DaySign
Sht[09], L, DaySign
Sht[10], L, DaySign
Sht[11], L, DaySign
Sht[12], L, DaySign
Sht[13], L, DaySign
Sht[14], L, DaySign
Sht[15], L, DaySign
Sht[16], L, DaySign
Sht[17], L, DaySign
Sht[18], L, DaySign
Sht[19], L, DaySign
Sht[20], L, DaySign
Sht[21], L, DaySign
Sht[22], L, DaySign
Sht[23], L, DaySign
Sht[24], L, DaySign
Sht[25], L, DaySign
Sht[26], L, DaySign
Sht[27], L, DaySign
Sht[28], L, DaySign
Sht[29], L, DaySign
Sht[30], L, DaySign
Sht[31], L, DaySign
@
|-----|--------------------------------|----|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|
|#####|################################| ## |#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#|
}

$P {SpcBody:
@
|-----|--------------------------------|----|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|
|     |                                |    | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |
}

$P {BotBody:
Page, R, ""
@
=() Polak======================================================================================== ###==
}

$P {TopFish:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
Obj1, C, ""
Memo.ud_mb(), L, "N.y"
TimeKeep.TimeKeep, L, ""
TimeKeep.Name, L, ""
@
#############################################################################                                       ########## #####
------------------------------------------------------------------------------------------------------------------------------------
|                                                   ###########  #######                                                   |
|==========================================================================================================    ====================|
|騪 ### ################################                                                           |    |                   |
|---------------------------------------------------------------------------------------------------------|    |-------------------|
|  |                             ||1|2|3|4|5|6|7|8|9|0|1|2|3|4|5|6|7|8|9|0|1|2|3|4|5|6|7|8|9|0|1|    ||||||||| | |
}

$P {LinFish:
Staff.TSN, L, ""
Man.Name, L, ""
Officer.Union, L, ""
@
|-----|--------------------------------|----|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|    |-|-|-|-|-|-|-|-|-|-|
|#####|################################| ## | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |    | | | | | | | | | | |
}

$P {SpcFish:
@
|-----|--------------------------------|----|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|    |-|-|-|-|-|-|-|-|-|-|
|     |                                |    | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |    | | | | | | | | | | |
}

$P {BotFish:
Page, R, ""
@
=() Polak=================================================================================================    ============ ###==

          騪 .......................                                            砫쭨 ..........................
}
*)

 PRIVATE PROCEDURE NoRoomForLine(NeedLines: NUMERIC[0]): SCAL[2];
 BEGIN
  RETURN LINENUM(R) > Depth-NeedLines;
 END {NoRoomForLine};

 PRIVATE PROCEDURE EndPage();
 BEGIN
  BegPage();
  IF NoRoomForLine(DEPTH(^Bot)) THEN
   FilPage();
  END;
 END {EndPage};

 PRIVATE PROCEDURE FilPage();
 BEGIN
  IF LINENUM(R) > 0 THEN
   WHILE ~NoRoomForLine(DEPTH(^Bot)) DO
    MAKEPART(R, ^Spc);
   END;
   MAKEPART(R, ^Bot);
   FORMFEED(R);
  END;
 END {FilPage};

 PRIVATE PROCEDURE BegPage();
 BEGIN
  IF LINENUM(R) = 0 THEN
   INC(Page);
   MAKEPART(R, ^Top);
  END;
 END {BegPage};

 PRIVATE PROCEDURE RWSTypeDr(): NUMERIC[0];
  VAR
   Time: NUMERIC[3][4];
 BEGIN
  SETZERO(Time);
  CONFORM(RWayS, RWayJ);
  WHILE OCCURE(RWayJ) DO
   CONFORM(RWayJ, WJMode);
   INC(Time[WJMode.WJType], RWayJ.StopT-RWayJ.StartT);
   NEXT(RWayJ);
  END; (* WHILE OCCURE(RWayJ) ... *)
  IF Time[1] > 3 THEN
   IF RWayS.ToSheet = L_Way.toSheet_Holid THEN
    RETURN 1;
   ELSE
    RETURN 2;
   END;
  ELSIF Time[2] > 0 THEN
   RETURN 3;
  ELSIF Time[3] > 0 THEN
   RETURN 4;
  ELSE
   RETURN 5;
  END;
 END {RWSTypeDr};

 PRIVATE PROCEDURE RWSTypeGu(): NUMERIC[0];
 BEGIN
  IF L_Way.GetWLMToSheetSign(WayLMen.Who) = L_Way.toSheet_Holid THEN
   RETURN 1;
  ELSE
   RETURN 2;
  END;
 END {RWSTypeGu};

 PRIVATE PROCEDURE ProcDr(D: NUMERIC[0]; _Who: SCAL[8]; VAR UseLine: NUMERIC[0]);
 BEGIN
  IF Sht[D] # 17 THEN
   IF RWayS.Status = L_Way.rwsStat_Rated THEN
    IF    _Who = L_Way.rwswho_Driver THEN
     IF RWayS.ToPay | RWayS.ToSheet THEN
      IF    Sht[D] = 0 THEN
       Sht[D]:=RWSTypeDr();
      ELSIF Sht[D] <= 5 THEN
       Sht[D]:=6;
      ELSIF Sht[D] >= 14 THEN
       Sht[D]:=15;
      ELSE
       INC(Sht[D]);
      END;
      INC(UseLine);
     END;
    ELSIF _Who = L_Way.rwswho_DrPupil THEN
     IF (Sht[D] = 00) | (Sht[D] = 14) THEN
      Sht[D]:=14; INC(UseLine);
     ELSE
      Sht[D]:=15; INC(UseLine);
     END;
    ELSIF _Who = L_Way.rwswho_SDriver THEN
     IF    Sht[D] = 0 THEN
      SAVE(WayLMen);
      CONFORM(WayLMen, RWayS);
      Sht[D]:=RWSTypeDr();
      RESTORE(WayLMen);
     ELSIF Sht[D] <= 5 THEN
      Sht[D]:=6;
     ELSIF Sht[D] >= 14 THEN
      Sht[D]:=15;
     ELSE
      INC(Sht[D]);
     END;
     INC(UseLine);
    ELSE
     Sht[D]:=15;
    END;
   ELSE
    Sht[D] := 17; INC(UseLine);
   END;
  END;
 END {ProcDr};

 PRIVATE PROCEDURE ProcGu(D: NUMERIC[0]; _Who: SCAL[8]; VAR UseLine: NUMERIC[0]);
 BEGIN
  IF Sht[D] # 17 THEN
   IF RWayS.Status = L_Way.rwsStat_Rated THEN
    IF    _Who = L_Way.rwswho_GuPupil THEN
     IF (Sht[D] = 00) | (Sht[D] = 14) THEN
      Sht[D]:=14; INC(UseLine);
     ELSE
      Sht[D]:=15; INC(UseLine);
     END;
    ELSIF (_Who = L_Way.rwswho_Guard) | (_Who = L_Way.rwswho_Chopper) THEN
     IF    Sht[D] = 0 THEN
      Sht[D]:=RWSTypeGu();
     ELSIF Sht[D] <  5  THEN
      Sht[D]:=6;
     ELSIF Sht[D] >= 14 THEN
      Sht[D]:=15;
     ELSE
      INC(Sht[D]);
     END;
     INC(UseLine);
    ELSE
     Sht[D]:=15;
    END;
   ELSE
    Sht[D] := 17; INC(UseLine);
   END;
  END;
 END {ProcGu};

 PRIVATE PROCEDURE Make(MonthB, MonthE: DATE);
  VAR
   D, J: NUMERIC[0];
 BEGIN
  SETZERO(Sht, J);
  CONFORM(StaffLog, Officer, Staff, Man);
  IF MODE#061 THEN
   SELECT(RWayS, TSN, , Staff.TSN);
   SRCINSEL(RWayS, GE, , MonthB);
   WHILE OCCURE(RWayS) & (RWayS.Date <= MonthE) DO
    PROMPT(Staff.TSN + " : " + L_DatTim.DateStr(RWayS.Date));
    ^Proc(L_DatTim.DAY(RWayS.Date), L_Way.rwswho_Driver, J);
    NEXT(RWayS);
   END;

   SELECT(WayLMen, TSN, , Staff.TSN);
   SRCINSEL(WayLMen, GE, , MonthB);
   WHILE OCCURE(WayLMen) & (WayLMen.RWayDate<=MonthE) DO
    CONFORM(WayLMen, RWayS);
    PROMPT(Staff.TSN + " : " + L_DatTim.DateStr(WayLMen.RWayDate));
    ^Proc(L_DatTim.DAY(WayLMen.RWayDate), WayLMen.Who+1, J);
    NEXT(WayLMen);
   END; (* WHILE OCCURE(WayLMen)... *)
  ELSIF L_Staff.IsWorking(MonthB) THEN
   J:=^Cond();
  END;
  IF J > 0 THEN
   EndPage();
   BegPage();
   MAKEPART(R, ^Lin);
  END;
 END {Make};

 PRIVATE PROCEDURE GetGate(MonthB: DATE; VAR D1, D2: DATE);
 BEGIN
  IF Staff.BegDate > MonthB THEN
   D1:=Staff.BegDate-1;
  ELSE
   D1:=MonthB-1;
  END;
  IF !Staff.EndDate THEN
   D2:=UpTo;
  ELSE
   D2:=L_DatTim.MinDATE(Staff.EndDate, UpTo);
  END;
 END {GetGate};

 PRIVATE PROCEDURE MakeSht(MonthB: DATE);
  VAR
   _TimDone,
   _Bal,
   _Corr     : NUMERIC[3];
   EndD,
   SeqD,
   D         : DATE;
 BEGIN
  SAVE(Sheet);
  SETZERO(_TimDone, _Bal, _Corr);
  GetGate(MonthB, SeqD, EndD);
  SELECT(Sheet, TSN, , Staff.TSN);
  SRCINSEL(Sheet, GE, , L_DatTim.Per(MonthB), L_DatTim.DAY(MonthB));
  LOOP
   IF (SeqD+1) > EndD THEN
    EXIT;
   END;
   IF OCCURE(Sheet) THEN
    D:=Sheet.Period+Sheet.Day-1;
   ELSE
    D:=SeqD+2;
   END;
   PROMPT(FLDTOSTR(D));
   IF D > (SeqD+1) THEN
    D:=SeqD+1;
   ELSE
    CONFORM(Sheet, JMode);
    IF    Sheet.Source = L_Sheet.src_RWayS THEN
     INC(_TimDone, Sheet.Tim);
    ELSIF JMode.DecrBal THEN
     INC(_Corr, Sheet.Tim);
    END;
    NEXT(Sheet);
   END;
   HISTCONF(D, Staff, StaffLog);
   SEARCH(RegList, HumReg, , StaffLog.Regime, L_DatTim.Per(D), L_DatTim.DAY(D));
   INC(_Bal, RegList.Durat);
   SeqD:=D;
  END;
  CONFORM(Staff, Man);
  MAKEPART(R, Time, _Bal, _Bal-_Corr, _TimDone);
  RESTORE(Sheet);
 END {MakeSht};

 PRIVATE PROCEDURE MakeIndx(MonthB, MonthE: DATE);
 BEGIN
  L_AFM.MakeIndex("_StLg", "_TimKeep: LIKE(TimeKeep.TimeKeep);"+
                              "_TSN    : LIKE(Staff.TSN);"+
                              "_Date   : DATE;");

  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   IF L_Env.RealTSN(Staff.TSN) & (Staff.BegDate <= MonthE) THEN
    HISTCONF(MonthE, Staff, StaffLog);
    CHANGESEL(StaffLog, TSN, , StaffLog.TSN);
    WHILE OCCURE(StaffLog) & (StaffLog.DateE >= MonthB) DO
     CONFORM(StaffLog, Officer);
     PROMPT(" "+Staff.TSN);
     IF ^Cond() THEN
      _StLg._TimKeep :=Officer.TimeKeep;
      _StLg._TSN     :=Staff.TSN;
      _StLg._Date    :=StaffLog.Date;
      INSERT(_StLg);
      FIRST(StaffLog);
     END;
     PREV(StaffLog);
    END; (* WHILE OCCURE(StaffLog) ... *)
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff)... *)
 END {MakeIndx};

BEGIN
 SE_ACCESSDATAMODE(AccessDataMode_SOFT);

 IF MODE < 070 THEN
  Proc:="ProcGu";
  Cond:="L_Env.IsGuard";
  Obj0:="";
  Obj1:="஢";
 ELSE
  DEC(MODE, 010);
  Proc:="ProcDr";
  Cond:="L_Env.IsDriver";
  Obj0:="⥫";
  Obj1:="⥫";
 END;
 IF    MODE = 060 THEN
  L_General.Assert(ACCESS(Staff), " । ⥪騩 ࠡ⭨");

  Page:=0;
  OPENREP(R, L_General.NameConnection("RWShG"), Create);
  Top := "TopSingle";
  Lin := "LinSingle";
  Bot := "BotSingle";
  UpTo:=Memo.ud_cd();

  HISTCONF(Memo.ud_me(), Staff, StaffLog);
  Make(Memo.ud_mb(), Memo.ud_me());

  CALL(ManRW.ManRW.MakeDoneRWaySwSkipUnTaxed_ByStaff());
 
  SELECT(Money, TSN, , Staff.TSN, Memo.ud_mb());
  WHILE OCCURE(Money) DO
   CONFORM(Money, MCList);
   IF (MCList.TimeType > L_PRoll.tt_Exclude) THEN
    MAKEPART(R, MonLine, Money.Tim);
   END;
   NEXT(Money);
  END; (* WHILE OCCURE(Money)... *)
 
  MakeSht(Memo.ud_mb());
 ELSE
  IF    MODE = 061 THEN
   OPENREP(R, L_General.NameMonth("RFG"), Create);
   Top := "TopFish";
   Lin := "LinFish";
   Spc := "SpcFish";
   Bot := "BotFish";
  ELSIF MODE = 062 THEN
   OPENREP(R, L_General.NameMonth("RSG"), Create);
   Top := "TopBody";
   Lin := "LinBody";
   Spc := "SpcBody";
   Bot := "BotBody";
  ELSE
   L_General.BadMode(MODE);
  END;

  MakeIndx(Memo.ud_mb(), Memo.ud_me());
  Page:=0;
  SELECT(_StLg, _StLg);
  WHILE OCCURE(_StLg) DO
   CHANGESEL(_StLg, _StLg, , _StLg._TimKeep);
   SEARCH(TimeKeep, TimeKeep, , _StLg._TimKeep);
   WHILE OCCURE(_StLg) DO
    SEARCH(StaffLog, TSN, , _StLg._TSN, _StLg._Date);
    PROMPT(StaffLog.TSN);
    Make(Memo.ud_mb(), Memo.ud_me());
    NEXT(_StLg);
   END;
   LAST(_StLg);
   CHANGESEL(_StLg, _StLg);
   FilPage();
   NEXT(_StLg);
  END; (* WHILE OCCURE(_StLg) ... *)
  FilPage();
  L_AFM.AF_PurgeTemp("_StLg");
 END;
END.
