(*
%Copyright   (c) Polak Computer System
%Author      06.05.2001 22:14:08 GINA
%Purpose     ⠦  ਮ
%Type        report
%Specific    AP
%Modified    28.06.2012 09:01:01 POLAK\MLB
%Environment
*)

 IMPORT L_General, L_Way, L_Basis, L_DatTim, Memo, FIO, L_Str, L_Car, L_RWayS, L_bp;

 PRIVATE PROCEDURE MakeTop();
 BEGIN
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "६");
  L_Basis.wb_WrStr("F", "஡");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "ઠ");
  L_Basis.wb_WrStr("F", "ઠ");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "ࠦ");
  L_Basis.wb_TermLine("F");
 END {MakeTop};

 PRIVATE PROCEDURE MakeLine();
 BEGIN
  CONFORM(WayLMen, Staff);
  CONFORM(Staff, Man);
  L_Basis.wb_WrScl("F", WayLMen.TSN);
  L_Basis.wb_WrStr("F", Man.Name);
  L_Basis.wb_WrStr("F", L_Str.PoolItem(L_Way.wlmwho_Pool, WayLMen.Who));
  CONFORM(RWayS, Staff);
  CONFORM(Staff, Man);
  CONFORM(RWayS, Car);
  L_Car.AccessMark(Car.BoxNbr, RWayS.Date);
  L_Basis.wb_WrScl("F", RWayS.TSN);
  L_Basis.wb_WrStr("F", Man.Name);
  L_Basis.wb_WrScl("F", RWayS.RWayS);
  L_Basis.wb_WrDat("F", RWayS.Date);
  L_Basis.wb_WrNum("F", RWayJ.StopT - RWayJ.StartT, 3);
  L_Basis.wb_WrNum("F", RWayJ.Run * RWayJ.Fact, 3);
  L_Basis.wb_WrStr("F", Route.Route);
  L_Basis.wb_WrStr("F", Route.Name);
  L_Basis.wb_WrScl("F", Mark.Mark);
  L_Basis.wb_WrStr("F", Mark.Name);
  SAVE(WayLMen);
  IF SELECT(WayLMen, RWayS, RWayS.RWayS, L_Way.wlmwho_Guard) &
     SRCINSEL(WayLMen, LE, RWayJ.Day, RWayJ.StartT) THEN
   L_Basis.wb_WrScl("F", WayLMen.TSN);
   CONFORM(WayLMen, Staff);
   CONFORM(Staff, Man);
   L_Basis.wb_WrStr("F", Man.Name);
  ELSE
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
  END;
  RESTORE(WayLMen);
  L_Basis.wb_WrScl("F", RWayS.BoxNbr);
  L_Basis.wb_TermLine("F");
 END {MakeLine};

 PUBLIC PROCEDURE T0011();
  CONST
   bpId = "T0011";
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_bp.Begin(bpId, "  祭 ⥫/", L_bp.t_Basis, L_General.tc_inIntvl);
  L_Way.CheckTaxed(Memo.ud_fr(), Memo.ud_ut());
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  MakeTop();

  SELECT(WayLMen, TSN);
  WHILE OCCURE(WayLMen) DO
   NARROWSEL(WayLMen, TSN);
   PROMPT(WayLMen.TSN);
   SRCINSEL(WayLMen, GE, , Memo.ud_fr());
   WHILE OCCURE(WayLMen) & (WayLMen.RWayDate <= Memo.ud_ut()) DO
    PROMPT(WayLMen.TSN + " " + L_DatTim.DateStr(WayLMen.RWayDate));
    IF (WayLMen.Who = L_Way.wlmwho_DrPupil) | (WayLMen.Who = L_Way.wlmwho_GuPupil) THEN
     CONFORM(WayLMen, RWayS);
     IF RWayS.Status = L_Way.rwsStat_Rated THEN
      SELECT(RWayJ, RWayS, , RWayS.RWayS);
      SRCINSEL(RWayJ, LE, , WayLMen.Day, WayLMen.StartT);
      WHILE OCCURE(RWayJ) & L_RWayS.IsRWayJForCurWayLMen() DO
       CONFORM(RWayJ, SEJobs);
       CONFORM(SEJobs, Route);
       L_General.CallUs(SEARCH(WJMode, WJCode, L_RWayS.GetasWJMode(WayLMen.Who + 1)));
       L_Way.PosToWJMethod(WJMode.WJCode, L_Way.GetWho(WayLMen.Who + 1),
                           L_Way.GetRouteJRegime(WayLMen.RWayDate, 1), RWayJ.Quality, WayLMen.RWayDate);
       IF (WJMode.WJType = L_Way.WJType_Work) & WJMethod.TimeSel THEN
        MakeLine();
       END;
       NEXT(RWayJ);
      END; (* WHILE OCCURE(RWayJ) ... *)
     END; (* IF RWayS.Status = L_Way.rwsStat_Rated *)
    END; (* IF (WayLMen.Who ...*)
    NEXT(WayLMen);
   END; (* WHILE OCCURE(File) *)
   NEXTINEXTENDEDSEL(WayLMen, TSN);
  END; (* WHILE OCCURE(WayLMen) *)

  FIO.Close(F);
  L_bp.End();
 END {T0011};

END.
