(*
%Copyright   (c) Polak Computer System
%Author      18.06.2001 14:04:39 SAN
%Purpose      窨  ६ ⮪.
%Type        report
%Specific    AP
%Modified    16.06.2014 14:21:48 POLAK\GAV
%Environment
*)

 MODULE T9022 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT FIO, L_General, L_AFM, L_Way, L_Str, L_DatTim, L_Basis, D_RWS, Memo, P_Firm,
        L_Env, L_Russia, DBD, L_bp, L_Car;

 VAR
  wMF,
  byTrips: SCAL[2];

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "஢");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "ࠦ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "㯯 ப");
  L_Basis.wb_WrInQM(F, "㯯 ப");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "  ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "ࠢ");
  L_Basis.wb_WrInQM(F, "  ६");
  L_Basis.wb_WrInQM(F, "  ६  ");
  IF byTrips THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "⭐");
  END;
  L_Basis.wb_WrInQM(F, "६");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  IF ~byTrips THEN
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "ᠦ");
  IF (L_Env.Region = L_Russia.reg_50) | (L_Env.Region = L_Russia.reg_77) THEN
   L_Basis.wb_WrInQM(F, "抠");
   L_Basis.wb_WrInQM(F, "抠댎");
   L_Basis.wb_WrInQM(F, "죏稥");
   L_Basis.wb_WrInQM(F, "륊");
   L_Basis.wb_WrInQM(F, "㬬抠");
   L_Basis.wb_WrInQM(F, "㬬抠댎");
   L_Basis.wb_WrInQM(F, "㬬죏稥");
   L_Basis.wb_WrInQM(F, "㬬륊");
  ELSE
   L_Basis.wb_WrInQM(F, "죏1");
   L_Basis.wb_WrInQM(F, "죏2");
   L_Basis.wb_WrInQM(F, "죏");
   L_Basis.wb_WrInQM(F, "⏠");
   L_Basis.wb_WrInQM(F, "㬬죏1");
   L_Basis.wb_WrInQM(F, "㬬죏2");
   L_Basis.wb_WrInQM(F, "㬬죏");
   L_Basis.wb_WrInQM(F, "㬬⏠");
  END;
  IF D_RWS.wVldPsgPlan THEN
   L_Basis.wb_WrInQM(F, "ଏᏫ");
  END;
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]);
 BEGIN
  L_Car.AccessMark(IN_01.BoxNbr, Memo.ud_ut());
  IF wMF THEN
   TRY
    P_Firm.PositionOnMyFirm(L_Way.GetMyFirmOfExit(IN_01.Exit, Memo.ud_ut()));
   EXCEPT
   ON Exc: Exc_Raise DO
    P_Firm.PositionOnMyFirm(P_Firm.mf_Fict);
   END;
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(F, TKind.TKind);
  L_Basis.wb_WrStr(F, TKind.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Way.tkrgn_Pool, TKind.Rgn));
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Way.tkfnm_Pool, TKind.FnMode));
  L_Basis.wb_WrStr(F, IN_01.Route);
  L_Basis.wb_WrScl(F, IN_01.Exit);
  L_General.CallUs(SEARCH(StExit, Exit, IN_01.Exit));
  CONFORM(StExit, ExitClss);
  L_Basis.wb_WrScl(F, ExitClss.ExitClss);
  L_Basis.wb_WrStr(F, ExitClss.Sign);
  L_Basis.wb_WrScl(F, IN_01.BoxNbr);
  L_Basis.wb_WrStr(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Way.StandOnMarkG(Mark.Mark, L_Way.mgt_TEP);
  L_Basis.wb_WrScl(F, MarkG.MarkG);
  L_Basis.wb_WrStr(F, MarkG.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Way.rwswho_Pool_Short, IN_01.Who));
  L_Basis.wb_WrStr(F, L_DatTim.WeekDayShortStr(IN_01.WD));
  L_Basis.wb_WrStr(F, L_Way.E_ConvertWDStr(Memo.ud_ut(), L_Way.E_ConvertWD(Memo.ud_ut(), IN_01.WD)));
  L_Basis.wb_WrStr(F, L_Str.PoolItem("אַ|⭮| ।|", IN_01.Dir));
  L_Basis.wb_WrStr(F, IN_01.Day + " " + L_DatTim.TimeStr(IN_01.StartT));
  CONFORM(IN_01, SEJobs);
  L_General.Assert(OCCURE(SEJobs),
                   "ଠ  䠩 '" + DBD.FileDescription(IN002) + "' ५." +
                   "|  ந 䠩");
  L_Basis.wb_WrStr(F, SEJobs.Day + " " + L_DatTim.TimeStr(SEJobs.StartT));
  IF byTrips THEN
   L_Basis.wb_WrScl(F, IN_01.Trip);
   IF ~IsRoundTrip(IN_01.Trip) THEN
    L_Basis.wb_WrNum(F, IN_01.IncTrp / 2, 3);
   ELSE
    L_Basis.wb_WrNum(F, IN_01.IncTrp, 3);
   END;
  END;
  L_Basis.wb_WrNum(F, IN_01.IncTim, 3);
  L_Basis.wb_WrNum(F, IN_01.IncPln, 2);
  L_Basis.wb_WrNum(F, IN_01.IncFct, 2);
  IF ~byTrips THEN
   L_Basis.wb_WrStr(F, IN_01.GDay + " " + L_DatTim.TimeStr(IN_01.GStartT));
  END;
  L_Basis.wb_WrNum(F, IN_01.Pass, 0);
  L_Basis.wb_WrNum(F, IN_01.VldPsg[L_Way.vpk_Moscow      ], 0);
  L_Basis.wb_WrNum(F, IN_01.VldPsg[L_Way.vpk_MoscowRegion], 0);
  L_Basis.wb_WrNum(F, IN_01.VldPsg[L_Way.vpk_OtherSocial ], 0);
  L_Basis.wb_WrNum(F, IN_01.VldPsg[L_Way.vpk_Paid        ], 0);
  L_Basis.wb_WrNum(F, IN_01.VldSum[L_Way.vpk_Moscow      ], 0);
  L_Basis.wb_WrNum(F, IN_01.VldSum[L_Way.vpk_MoscowRegion], 0);
  L_Basis.wb_WrNum(F, IN_01.VldSum[L_Way.vpk_OtherSocial ], 0);
  L_Basis.wb_WrNum(F, IN_01.VldSum[L_Way.vpk_Paid        ], 0);
  IF D_RWS.wVldPsgPlan THEN
   L_Basis.wb_WrNum(F, IN_01.VldPsgPln, 2);
  END;
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE Create_IN_01();
 BEGIN
  CreateFILE(IN_01, "", "", "");

  CreateFIELD(IN_01, Route,   LIKE(Route.Route), "", "",  "", "", "");
  CreateFIELD(IN_01, Exit,    LIKE(StExit.Exit), "", "",  "", "室", "");
  CreateFIELD(IN_01, BoxNbr,  LIKE(Car.BoxNbr),  "", "",  "", "ࠦ", "");
  CreateFIELD(IN_01, WD,      SCAL[8],           "", "",  "", "  ", "");
  CreateFIELD(IN_01, Who,     L_Way.tRWSWho,     "", "",  "", "", "");

  CreateFIELD(IN_01, Dir,     SCAL[4],           "", "",  "", "ࠢ", "אַ|⭮| ।");
  CreateFIELD(IN_01, Day,     SCAL[99],          "", "",  "", "", "");
  CreateFIELD(IN_01, StartT,  TIME,              "", "",  "", "", "");
  CreateFIELD(IN_01, Trip,    LIKE(SEJobs.Trip), "", "",  "", "", "");

  CreateFIELD(IN_01, GDay,    SCAL[99],          "", "",  "", "", "");
  CreateFIELD(IN_01, GStartT, TIME,              "", "",  "", "", "");

  CreateFIELD(IN_01, IncTim,  NUMERIC[10, 3],    "", "0", "", "६  ",      "");
  CreateFIELD(IN_01, IncTrp,  NUMERIC[10, 1],    "", "0", "", "᪨ ३  室", "");
  CreateFIELD(IN_01, IncPln,  NUMERIC[10, 2],    "", "0", "", " 窠",    "");
  CreateFIELD(IN_01, IncFct,  NUMERIC[10, 2],    "", "0", "", "᪠ 窠", "");
  CreateFIELD(IN_01, Pass,    NUMERIC[10, 0],    "", "0", "", "ᠦ",           "");
  CreateFIELD(IN_01, VldPsg,  NUMERIC[10, 0][10],"", "0", "", "ᠦ  ", "");
  CreateFIELD(IN_01, VldSum,  NUMERIC[10, 2][10],"", "0", "", "ᠦ  ", "");
  IF D_RWS.wVldPsgPlan THEN
   CreateFIELD(IN_01, VldPsgPln, NUMERIC[10, 2], "", "0", "", "ନ ᠦ ",   "");
  END;

  CreateINDEXandLINK(IN_01, Route, UNIQUE, Route,  Route, USER, "", "", Route, Exit, BoxNbr, Who, Dir, WD, Day, StartT, Trip);
  CreateINDEXandLINK(IN_01, Trip,  PLURAL, SEJobs, Trip,  USER, "", "", Trip);

  SetVersionOfFILE(IN_01, 0004+D_RWS.wVldPsgPlan);
 END {Create_IN_01};

 PRIVATE PROCEDURE PosToFirstRtMStop(_Trip: LIKE(SEJobs.Trip));
 BEGIN
  SEARCH(SEJobs, Trip, , _Trip);
  CONFORM(SEJobs, RoutMod);
  CONFORM(RoutMod, RtMStop);
  IF SEJobs.Dir # RoutMod.Dir THEN
   LAST(RtMStop);
  END;
 END {PosToFirstRtMStop};

 PRIVATE PROCEDURE FirstRtMStop(_Trip: LIKE(SEJobs.Trip)): LIKE(Stop.Stop);
 BEGIN
  PosToFirstRtMStop(_Trip);
  IF ~OCCURE(RtMStop) THEN
   RETURN 0;
  END;
  RETURN RtMStop.Stop;
 END {FirstRtMStop};

 PRIVATE PROCEDURE PosToLastRtMStop(_Trip: LIKE(SEJobs.Trip));
 BEGIN
  SEARCH(SEJobs, Trip, , _Trip);
  CONFORM(SEJobs, RoutMod);
  CONFORM(RoutMod, RtMStop);
  IF SEJobs.Dir = RoutMod.Dir THEN
   LAST(RtMStop);
  END;
 END {PosToLastRtMStop};

 PRIVATE PROCEDURE LastRtMStop(_Trip: LIKE(SEJobs.Trip)): LIKE(Stop.Stop);
 BEGIN
  PosToLastRtMStop(_Trip);
  IF ~OCCURE(RtMStop) THEN
   RETURN 0;
  END;
  RETURN RtMStop.Stop;
 END {LastRtMStop};

 PRIVATE PROCEDURE IsRoundTrip(_Trip: LIKE(SEJobs.Trip)): SCAL[2];
  VAR
   _Stop: LIKE(Stop.Stop);
 BEGIN
  SEARCH(SEJobs, Trip, , _Trip);
  CONFORM(SEJobs, RoutMod);
  CONFORM(RoutMod, RtMStop);
  IF ~OCCURE(RtMStop) THEN
   RETURN 0;
  END;
  _Stop:=RtMStop.Stop;
  LAST(RtMStop);
  RETURN RtMStop.Stop=_Stop;
 END {IsRoundTrip};

 PRIVATE PROCEDURE HasVldPsg(): SCAL[2];
 BEGIN
  RETURN (IN002.VldPsg[L_Way.vpk_Moscow      ] # 0) |
         (IN002.VldPsg[L_Way.vpk_MoscowRegion] # 0) |
         (IN002.VldPsg[L_Way.vpk_OtherSocial ] # 0) |
         (IN002.VldPsg[L_Way.vpk_Paid        ] # 0);
 END {HasVldPsg};

 PRIVATE PROCEDURE IsDrvIncFct(): SCAL[2];
 BEGIN
  RETURN (IN002.Who=L_Way.rwswho_Driver) & ((IN002.IncFct # 0) | HasVldPsg());
 END {IsDrvIncFct};

 PRIVATE PROCEDURE Fill_IN_01();
  VAR
   Rest           : NUMERIC[0];
   SecondHalfFound: SCAL[2];
   _Trip          : LIKE(SEJobs.Trip);
   _Dir           : SCAL[4];
 BEGIN
  Rest:=AMOUNT(IN002);
  SELECT(IN002, TSN);
  WHILE OCCURE(IN002) DO
   NARROWSEL(IN002, TSN, ODate, BoxNbr, Route, Exit, WD, Who);
   WHILE OCCURE(IN002) DO
    PROMPT("⮢ . ⠫ " + FLDTOSTR(Rest, "0", 0));
    IF (IN002.pIncTim # 0) | IsDrvIncFct() THEN
     _Dir:=IN002.Dir;
     IF byTrips THEN
      SAVE(IN002);
      _Trip:=IN002.Trip;
      IF IsRoundTrip(_Trip) |
          NEXT(IN002) & ((IN002.pIncTim # 0) | IsDrvIncFct()) & (_Dir = 0) & (IN002.Dir = 1) &
          (LastRtMStop(IN002.Trip) = FirstRtMStop(_Trip)) THEN
       _Dir:=3;
      END;
      RESTORE(IN002);
     END;

     ADD(IN_01, Route, , IN002.Route, IN002.Exit, IN002.BoxNbr, IN002.Who, _Dir, IN002.WD,
                         IN002.Day, IN002.StartT, IN002.Trip,
         IN_01.IncTim, IN002.pIncTim,
         IN_01.IncPln, IN002.pIncPln,
         IN_01.IncTrp, IN002.pIncTrp,
         IN_01.IncFct, IN002.IncFct,
         IN_01.Pass,   IN002.Pass,
         IN_01.VldPsg[L_Way.vpk_Moscow      ], IN002.VldPsg[L_Way.vpk_Moscow      ],
         IN_01.VldPsg[L_Way.vpk_MoscowRegion], IN002.VldPsg[L_Way.vpk_MoscowRegion],
         IN_01.VldPsg[L_Way.vpk_OtherSocial ], IN002.VldPsg[L_Way.vpk_OtherSocial ],
         IN_01.VldPsg[L_Way.vpk_Paid        ], IN002.VldPsg[L_Way.vpk_Paid        ],
         IN_01.VldSum[L_Way.vpk_Moscow      ], IN002.VldSum[L_Way.vpk_Moscow      ],
         IN_01.VldSum[L_Way.vpk_MoscowRegion], IN002.VldSum[L_Way.vpk_MoscowRegion],
         IN_01.VldSum[L_Way.vpk_OtherSocial ], IN002.VldSum[L_Way.vpk_OtherSocial ],
         IN_01.VldSum[L_Way.vpk_Paid        ], IN002.VldSum[L_Way.vpk_Paid        ]);
     IF D_RWS.wVldPsgPlan THEN
      INC(IN_01.VldPsgPln, IN002.VldPsgPln);
      REPLACE(IN_01);
     END;
     NEXT(IN002);
     IF byTrips & ~IsRoundTrip(IN_01.Trip) & (_Dir = 3) THEN
      INC(IN_01.IncTim, IN002.pIncTim);
      INC(IN_01.IncPln, IN002.pIncPln);
      INC(IN_01.IncTrp, IN002.pIncTrp);
      INC(IN_01.IncFct, IN002.IncFct);
      INC(IN_01.Pass,   IN002.Pass);
      INC(IN_01.VldPsg[L_Way.vpk_Moscow      ], IN002.VldPsg[L_Way.vpk_Moscow      ]);
      INC(IN_01.VldPsg[L_Way.vpk_MoscowRegion], IN002.VldPsg[L_Way.vpk_MoscowRegion]);
      INC(IN_01.VldPsg[L_Way.vpk_OtherSocial ], IN002.VldPsg[L_Way.vpk_OtherSocial ]);
      INC(IN_01.VldPsg[L_Way.vpk_Paid        ], IN002.VldPsg[L_Way.vpk_Paid        ]);
      INC(IN_01.VldSum[L_Way.vpk_Moscow      ], IN002.VldSum[L_Way.vpk_Moscow      ]);
      INC(IN_01.VldSum[L_Way.vpk_MoscowRegion], IN002.VldSum[L_Way.vpk_MoscowRegion]);
      INC(IN_01.VldSum[L_Way.vpk_OtherSocial ], IN002.VldSum[L_Way.vpk_OtherSocial ]);
      INC(IN_01.VldSum[L_Way.vpk_Paid        ], IN002.VldSum[L_Way.vpk_Paid        ]);
      IF D_RWS.wVldPsgPlan THEN
       INC(IN_01.VldPsgPln, IN002.VldPsgPln);
      END;
      REPLACE(IN_01);
      NEXT(IN002);
      DEC(Rest);
     END;
    ELSE
     NEXT(IN002);
    END;
    DEC(Rest);
   END; (* WHILE OCCURE(IN002) ... *)
   NEXTINEXTENDEDSEL(IN002, TSN, ODate, BoxNbr, Route, Exit, WD, Who);
  END; (* WHILE OCCURE(IN002) ... *)
 END {Fill_IN_01};

 VAR
  prvGoodDay,
  curGoodDay    : LIKE(RWayJ.Day);
  prvGoodStartT,
  curGoodStartT : TIME;
  badDay        : LIKE(RWayJ.Day) [256];
  badStartT     : TIME            [256];
  badTrip       : LIKE(RWayJ.Trip)[256];
  BadCnt        : NUMERIC[0];

 PRIVATE PROCEDURE DistributeBad();
  VAR
   Delta: NUMERIC[3];
 BEGIN
  Delta:=L_Way.FullBegTime(curGoodDay, curGoodStartT) -
         L_Way.FullBegTime(prvGoodDay, prvGoodStartT);
  WHILE BadCnt > 0 DO DEC(BadCnt);
   L_General.CallUs(SRCINSEL(IN_01, EQ, badDay[BadCnt], badStartT[BadCnt], badTrip[BadCnt]));
   IF (L_Way.FullBegTime(badDay[BadCnt], badStartT[BadCnt]) -
       L_Way.FullBegTime(    prvGoodDay,     prvGoodStartT)) < Delta/2 THEN
    IN_01.GDay   :=prvGoodDay;
    IN_01.GStartT:=prvGoodStartT;
   ELSE
    IN_01.GDay   :=curGoodDay;
    IN_01.GStartT:=curGoodStartT;
   END;
   REPLACE(IN_01);
  END; (* WHILE BadCnt > 0 ... *)
 END {DistributeBad};

 PRIVATE PROCEDURE Compress_IN_01();
  VAR
   Total,
   Average: NUMERIC[3];
   Amount : NUMERIC[0];
 BEGIN
  SELECT(IN_01, Route);
  WHILE OCCURE(IN_01) DO
   PROMPT(" " + IN_01.Route);
   NARROWSEL(IN_01, Route, Exit, BoxNbr, Who, Dir, WD);
   SAVE(IN_01);
   SETZERO(Total, Average, Amount);
   WHILE OCCURE(IN_01) DO
    INC(Total, IN_01.IncTim);
    INC(Amount);
    NEXT(IN_01);
   END; (* WHILE OCCURE(IN_01) ... *)
   RESTORE(IN_01);
   IF Total > 0 THEN
    Average:=Total/Amount;
   ELSE
    Average:=0;
   END;
   SAVE(IN_01);
   SETEMPTY(prvGoodDay, prvGoodStartT,
            curGoodDay, curGoodStartT);
   SETZERO(BadCnt);
   WHILE OCCURE(IN_01) DO
    IF IN_01.IncTim < Average THEN
     badDay   [BadCnt]:=IN_01.Day;
     badStartT[BadCnt]:=IN_01.StartT;
     badTrip  [BadCnt]:=IN_01.Trip;
     INC(BadCnt);
    ELSE
     IF (BadCnt > 0) & ~!prvGoodDay THEN
      curGoodDay   :=IN_01.Day;
      curGoodStartT:=IN_01.StartT;
      SAVE(IN_01);
      DistributeBad();
      RESTORE(IN_01);
     END;
     prvGoodDay   :=IN_01.Day;
     prvGoodStartT:=IN_01.StartT;
     IN_01.GDay   :=IN_01.Day;
     IN_01.GStartT:=IN_01.StartT;
     REPLACE(IN_01);
    END;
    NEXT(IN_01);
   END; (* WHILE OCCURE(IN_01) ... *)
   IF BadCnt > 0 THEN
    curGoodDay   :=MAXOF(curGoodDay);
    curGoodStartT:=MAXOF(curGoodStartT);
    DistributeBad();
   END;
   RESTORE(IN_01);
   NEXTINEXTENDEDSEL(IN_01, Route, Exit, BoxNbr, Who, Dir, WD);
  END; (* WHILE OCCURE(IN_01) ... *)
 END {Compress_IN_01};

 PRIVATE PROCEDURE CreateAnyRep(bpId: STRING[]);
 BEGIN
  D_RWS.Prepare_IN002();
 
  Create_IN_01(); L_AFM.AF_CreateTemp("IN_01", "IN_01");
 
  Fill_IN_01();
 
  IF ~byTrips THEN
   Compress_IN_01();
  END;

  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeader("R");
 
  SELECT(IN_01, Route);
  WHILE OCCURE(IN_01) DO
   PROMPT(" " + IN_01.Route + " " + IN_01.Exit);
   CONFORM(IN_01, Route);
   L_Way.StandOnRouteTKind(Memo.ud_ut());
   MakePart("R");
   NEXT(IN_01);
  END; (* WHILE OCCURE(IN_01) ... *)
  L_AFM.AF_PurgeTemp("IN_01");
  D_RWS.Purge_IN002();
  FIO.Close(R);
 END {CreateAnyRep};

 PUBLIC PROCEDURE T9022();
  CONST
   bpId="T9022";
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  wMF:=P_Firm.E_wMultipleMyFirm(Memo.ud_ut());
  L_bp.Begin(bpId, " 窨  ६ ⮪", L_bp.t_Basis, L_General.tc_inIntvl);
  byTrips:=0;
  CreateAnyRep(bpId);
  L_bp.End();
 END {T9022};

 PUBLIC PROCEDURE T9023();
  CONST
   bpId="T9023";
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  wMF:=P_Firm.E_wMultipleMyFirm(Memo.ud_ut());
  L_bp.Begin(bpId, " 窨  ३ᠬ", L_bp.t_Basis, L_General.tc_inIntvl);
  byTrips:=1;
  CreateAnyRep(bpId);
  L_bp.End();
 END {T9023};

END.
