(*
%Copyright   (c) Polak Computer System
%Author      28.09.2001 16:53:18 GINA
%Purpose     믮   室 ࠡ⭨  
%Type        report
%Specific    AP
%Modified    23.06.2014 22:22:11 POLAK\Gina
%Environment
*)

 MODULE TSN_Inc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_EC, E_Utils, L_OwnData, L_AFM, E_Way, L_Way, L_General,
        L_Car, L_Str, L_PRoll, L_DatTim, Math, L_Sheet, L_Staff,
        D_RWS, Str, L_APWI, L_RWayS;

 PRIVATE CONST
  PartsNm = 10;

 PRIVATE VAR
  _TimDone,
  _CorBal     : L_PRoll.tTime;
  tTm         : NUMERIC[3][PartsNm];
  tPl,  tFc   : NUMERIC[2][PartsNm];
  rwjp        : NUMERIC[3][5];
  CurWho      : L_Way.tRWSWho;
  RepName     : STRING[];
  RWaySAmount : NUMERIC[0];
  From,
  UpTo        : DATE;
  AllStaff,
  wVldPsgPlan,
  NeedRWayJVld,
  NeedRWayJInc: SCAL[2];
  tVldPsgPl,
  tVldPsgFc   : NUMERIC[2];
  TripNbr     : L_RWayS.tTripAmount;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
"믮 "+L_Str.PoolItem("⥫|஬", CurWho)+"   室"+L_Str.PoolItem(" |  ᠦࠬ ", wVldPsgPlan)+" ਮ  "+L_DatTim.DateStr(From)+"  "+L_DatTim.DateStr(UpTo), C, ""
Staff.TSN, L, ""
Man.Name, L, ""
"室, "+L_Str.PoolItem(" |       ", CurWho = L_Way.rwswho_Guard), L, ""
E_TSN_Inc_PlanPerTrip(From), R, "६|"
E_Way.GetIncRWJPName(CurWho, 0), R, ""
E_Way.GetIncRWJPName(CurWho, 1), R, ""
E_Way.GetIncRWJPName(CurWho, 2), R, ""
E_Way.GetIncRWJPName(CurWho, 3), R, ""
E_Way.GetIncRWJPName(CurWho, 4), R, ""
@
####################################################################################                                   ########## #####
=#####=================================================================================================================================
|#####################################################################################################################################|
|-------------------------------------------------------------------------------------------------------------------------------------|
|⭨ ##### ################################################                                                                      |
|-------------------------------------------------------------------------------------------------------------------------------------|
|  |######################|/ |?|######|        |        |     %|#############|#########|#########|#########|#########|
}
*)

(*
$P{ TopDate:
@
|------|----------------------|-------|-|------|------------|------------|------|-------------|---------|---------|---------|---------|
}
*)

(*
$P{ Line:
?, L, ""
GetRoute(), L, ""
RWayS.RWayS, L, ""
RWayS.Done, L, "?| "
TMP01.tTm, R, "1."
TMP01.tPl, R, "2-"
TMP01.tFc, R, "2-"
GetPrc(TMP01.tFc, TMP01.tPl), R, ""
SumToStr(TMP01.rwjp[0]), R, ""
SumToStr(TMP01.rwjp[1]), R, ""
SumToStr(TMP01.rwjp[2]), R, ""
SumToStr(TMP01.rwjp[3]), R, ""
SumToStr(TMP01.rwjp[4]), R, ""
@
|######|######################|#######|#|######|############|############|######|#############|#########|#########|#########|#########|
}
*)

(*
$P{ Line_VldPsg:
TMP01.VldPsgPl, R, "2."
TMP01.VldPsgFc, R, "2."
GetPrc(TMP01.VldPsgFc, TMP01.VldPsgPl), R, ""
@
|      |                      |       | |      |############|############|######|             |         |         |         |         |
}
*)

(*
$P{ Bot:
tTm[0], R, "1."
tPl[0], R, "2-"
tFc[0], R, "2-"
GetPrc(tFc[0], tPl[0]), R, ""
SumToStr(rwjp[0]), R, ""
SumToStr(rwjp[1]), R, ""
SumToStr(rwjp[2]), R, ""
SumToStr(rwjp[3]), R, ""
SumToStr(rwjp[4]), R, ""
@
|---------------------------------------|------|------------|------------|------|-------------|---------|---------|---------|---------|
|⮣  ਮ                        |######|############|############|######|#############|#########|#########|#########|#########|
}
*)

(*
$P{ Bot_VldPsg:
tVldPsgPl, R, "2."
tVldPsgFc, R, "2."
GetPrc(tVldPsgFc, tVldPsgPl), R, ""
@
|---------------------------------------|------|------------|------------|------|-------------|---------|---------|---------|---------|
|⮣  ਮ ᠦ              |      |############|############|######|             |         |         |         |         |
}
*)

(*
$P{ LastBot:
@
=(c) Polak=============================================================================================================================
}
*)

(*
$P{ All_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
CurWho, R, "믮 ⥫ﬨ|믮 ࠬ"
From, L, "D.N.y"
UpTo, L, "D.N.y"
E_TSN_Inc_PlanPerTrip(From), R, "६|"
E_Way.GetIncRWJPName(CurWho, 0), R, ""
E_Way.GetIncRWJPName(CurWho, 1), R, ""
E_Way.GetIncRWJPName(CurWho, 2), R, ""
E_Way.GetIncRWJPName(CurWho, 3), R, ""
E_Way.GetIncRWJPName(CurWho, 4), R, ""
@
##############################################################################                                         ########## #####
=#####=================================================================================================================================
|                         #######################   室  ਮ  ##########  ##########                               |
|-------------------------------------------------------------------------------------------------------------------------------------|
|. | . .           ||ࠡ.|######|     |     |     %|#############|#########|#########|#########|##########|
|-----|------------------------|------|------|------|---------|---------|------|-------------|---------|---------|---------|----------|
}
*)

(*
$P{ All_Line:
Staff.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
?, R, "1."
?, R, "1."
?, R, "1."
?, R, "2-"
?, R, "2-"
?, R, ""
SumToStr(TMP01.rwjp[0]), R, ""
SumToStr(TMP01.rwjp[1]), R, ""
SumToStr(TMP01.rwjp[2]), R, ""
SumToStr(TMP01.rwjp[3]), R, ""
SumToStr(TMP01.rwjp[4]), R, ""
@
|#####|########################|######|######|######|#########|#########|######|#############|#########|#########|#########|#########|
}
*)

(*
$P{ All_Bot:
@
=(c) Polak============================================================================================================================
}
*)

 PRIVATE PROCEDURE GetRoute(): STRING[];
  VAR
   S: STRING[];
 BEGIN
  S:=FLDTOSTR(TMP01.Exit, "", 9)+" "+FLDTOSTR(TMP01.Route, "", 4)+" "+Route.Name;
  IF (CurWho = L_Way.rwswho_Guard) & (TMP01.WLMCnt > 1) THEN
   S:=Str.Align(S, 20, LEFT) + " " + FLDTOSTR(TMP01.WLMCnt, "", 1);
  END;
  RETURN S;
 END {GetRoute};

 PRIVATE PROCEDURE SumToStr(S: NUMERIC[2]): STRING[];
 BEGIN
  IF   S = 0 THEN RETURN "";
  ELSE            RETURN FLDTOSTR(S, "2-", 0);
  END;
 END {SumToStr};

 PRIVATE PROCEDURE GetPrc(Fc, Pl: NUMERIC[2]): STRING[];
  VAR
   Prc: FLOAT;
 BEGIN
  IF Pl > 0 THEN
   Prc:=Fc / Pl * 100;
   IF Prc >= 1000 THEN
    RETURN L_Str.IntStr(Prc);
   ELSE
    RETURN FLDTOSTR(Prc, "2.");
   END;
  ELSE
   RETURN "";
  END;
 END {GetPrc};

 PRIVATE PROCEDURE Create_TMP01();
 BEGIN
  CreateFILE(TMP01, "", "", "");

  IF AllStaff THEN
   CreateFIELD(TMP01, TSN,    LIKE(Staff.TSN), "", "", "", "⭨", "");
  ELSE
   CreateFIELD(TMP01, Exit,    LIKE(StExit.Exit), "", "", "", "室", "");
   CreateFIELD(TMP01, Route,   LIKE(Route.Route), "", "", "", "", "");
   CreateFIELD(TMP01, Date,    DATE,              "", "", "", "", "");
   CreateFIELD(TMP01, RWayS,   LIKE(RWayS.RWayS), "", "", "", "", "");
   CreateFIELD(TMP01, WLMCnt,  NUMERIC[0], "", "", "", "", "");
  END;
  CreateFIELD(TMP01, tTm,     NUMERIC[3],        "", "", "", "६", "");
  CreateFIELD(TMP01, tPl,     NUMERIC[2],        "", "", "", "", "");
  CreateFIELD(TMP01, tFc,     NUMERIC[2],        "", "", "", "", "");
  CreateFIELD(TMP01, rwjp,    NUMERIC[2][5],     "", "", "", "  ", "");
  CreateFIELD(TMP01, PartNum, SCAL[PartsNm],     "", "", "", " ⮣ ", "");
  CreateFIELD(TMP01, VldPsgPl, NUMERIC[2],        "", "0", "", " ᠦ ନ", "");
  CreateFIELD(TMP01, VldPsgFc, NUMERIC[2],        "", "0", "", " ᠦ ନ", "");

  IF AllStaff THEN
   CreateINDEX(TMP01, TMP01, UNIQUE, "", "", TSN, PartNum);
  ELSE
   CreateINDEX(TMP01, TMP01, UNIQUE, "", "", Date, Exit, Route, RWayS, WLMCnt, PartNum);
   CreateINDEXandLINK(TMP01, Route, PLURAL, Route, Route, USER, "", "", Route);
   CreateINDEXandLINK(TMP01, RWayS, PLURAL, RWayS, RWayS, USER, "", "", RWayS);
  END;

  SetVersionOfFILE(TMP01, 0000);
  L_AFM.AF_CreateTemp("TMP01", "TMP01");
 END {Create_TMP01};

 PRIVATE PROCEDURE TrIncFct(rwsWho : L_Way.tRWSWho;
                            _Number: LIKE(WayLMen.Number)): SCAL[2];
 BEGIN
  IF ~D_RWS.E_IN001_TakeOnIncome(RWayS.Date, rwsWho) | ~NeedRWayJInc THEN
   RETURN 0;
  ELSE
   IF rwsWho = L_Way.rwswho_Driver THEN
    RETURN L_Way.TrIncFct(L_Way.rwswho_Dr_W_Gu, _Number, RWayJP.RWJPro);
   ELSE
    RETURN L_Way.TrIncFct(rwsWho,               _Number, RWayJP.RWJPro);
   END;
  END;
 END {TrIncFct};

 PRIVATE PROCEDURE TrVldPsgFact(rwsWho : L_Way.tRWSWho;
                                _Number: LIKE(WayLMen.Number)): L_APWI.tVldPsgAmnt;
  VAR
   Permit: SCAL[2];
 BEGIN
  Permit:=L_Way.rwswhoWithVld(rwsWho) & NeedRWayJVld;
  RETURN L_APWI.E_TrVldPsgFact(RWayS.Date, rwsWho, _Number, Permit, TripNbr);
 END {TrVldPsgFact};

 PRIVATE PROCEDURE getIncRWJP(rwsWho   : L_Way.tRWSWho;
                              _Number  : LIKE(WayLMen.Number);
                              VAR _tFc : NUMERIC[2];
                              VAR _rwjp: NUMERIC[2][5];
                              VAR _VldPsgFact: NUMERIC[2]);
 BEGIN
  INC(_VldPsgFact, TrVldPsgFact(rwsWho, _Number));
  CONFORM(RWayJ, RWayJP);
  WHILE OCCURE(RWayJP) DO
   IF    L_Way.IsIncRWJP(rwsWho, _Number, 0, RWayJP.RWJPro) THEN INC(_rwjp[0], RWayJP.Value);
   ELSIF L_Way.IsIncRWJP(rwsWho, _Number, 1, RWayJP.RWJPro) THEN INC(_rwjp[1], RWayJP.Value);
   ELSIF L_Way.IsIncRWJP(rwsWho, _Number, 2, RWayJP.RWJPro) THEN INC(_rwjp[2], RWayJP.Value);
   ELSIF L_Way.IsIncRWJP(rwsWho, _Number, 3, RWayJP.RWJPro) THEN INC(_rwjp[3], RWayJP.Value);
   ELSIF L_Way.IsIncRWJP(rwsWho, _Number, 4, RWayJP.RWJPro) THEN INC(_rwjp[4], RWayJP.Value);
   END;
   IF TrIncFct(rwsWho, _Number) THEN
    INC(_tFc, RWayJP.Value);
   END;
   NEXT(RWayJP);
  END; (* WHILE OCCURE(RWayJP) ... *)
 END {getIncRWJP};

 PRIVATE PROCEDURE E_TSN_Inc_PartNum(): SCAL[PartsNm];
  VAR
   Local: PROC;
   Res  : SCAL[PartsNm];
 BEGIN
  Local:=PROCREF(E_Utils.TSN_Inc_PartNum);
  IF ~!Local THEN
   Res:=Local(CurWho);
   L_General.CallUs(CurWho | Res);
   RETURN Res;
  ELSE
   RETURN 0;
  END;
 END {E_TSN_Inc_PartNum};

 PRIVATE PROCEDURE E_TSN_Inc_PlanPerTrip(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.TSN_Inc_PlanPerTrip), 0);
 END {E_TSN_Inc_PlanPerTrip};

 PRIVATE PROCEDURE GetWayLMenCount(rwsWho: L_Way.tRWSWho;
                                   wlmWho: L_Way.tWLMWho;
                                   VAR
                                    IncCnt,
                                    VldCnt: NUMERIC[0]);
 BEGIN
  SAVE(WayLMen);
  SELECT(WayLMen, RWayS, , RWayS.RWayS, wlmWho);
  WHILE OCCURE(WayLMen) DO
   INC(IncCnt, L_RWayS.IsRWayJForCurWayLMen() & L_Way.rwswhoWithSale(rwsWho));
   INC(VldCnt, L_RWayS.IsRWayJForCurWayLMen() & L_Way.rwswhoWithVld(rwsWho));
   NEXT(WayLMen);
  END; (* WHILE OCCURE(WayLMen) ... *)
  RESTORE(WayLMen);
 END {GetWayLMenCount};

 PRIVATE PROCEDURE OneRWayS(rwsWho : L_Way.tRWSWho;
                            wlmWho : L_Way.tWLMWho;
                            _Number: LIKE(WayLMen.Number));
  VAR
   _tTm     : NUMERIC[3];
   _tPl,
   _tFc     : NUMERIC[2];
   _rwjp    : NUMERIC[2][5];
   _WGuCnt, _WGuCntVld,
   _WCntVld,
   _WCnt    : NUMERIC[0];
   AppIdx   : STRING[];
   _PartNum : SCAL[PartsNm];
   NeedRWayJ: SCAL[2];
   _VldPsgPlan,
   _VldPsgFact: NUMERIC[2];
 BEGIN
  IF L_General.KioskExecution_IsRunning() & (Math.Mod(RWaySAmount, 5) = 0) THEN
   CALL(Ksk.UpdateStatusFile());
  END;
  INC(RWaySAmount);

  PROMPT(RWayS.RWayS);
  IF RWayS.Status < L_Way.rwsStat_Rated THEN
   RETURN;
  END;
  SELECT(RWayJ, RWayS, , RWayS.RWayS);
  TripNbr:=0;
  L_RWayS.InitRWJPStore();
  WHILE OCCURE(RWayJ) DO
   CONFORM(RWayJ, SEJobs, Route, WJMode, Quality);
   IF L_Way.SEJobsWithPlIncome(RWayS.Date) THEN
    L_RWayS.ScanRWJP(TripNbr);
    SETZERO(_rwjp, _tTm, _tFc, _tPl, _WCnt, _WCntVld, _VldPsgFact, _VldPsgPlan);
    IF ~!wlmWho THEN
     NeedRWayJ:=L_RWayS.IsRWayJForCurWayLMen();
    ELSE
     NeedRWayJ:=1;
    END;
    IF   rwsWho = L_Way.rwswho_Driver THEN
     IF NeedRWayJ THEN
      _WCnt   :=1;
      _WCntVld:=1;
      GetWayLMenCount(L_Way.rwswho_Driver, L_Way.wlmwho_SDriver, _WCnt, _WCntVld);
     END;
     _WGuCnt:=0; _WGuCntVld:=0;
     GetWayLMenCount(L_Way.rwswho_Guard, L_Way.wlmwho_Guard, _WGuCnt, _WGuCntVld);
     NeedRWayJInc:=NeedRWayJ & (L_Way.E_ApplyGuIncToDrv(RWayS.Date) | (_WGuCnt=0));
     NeedRWayJVld:=NeedRWayJ & (L_APWI.E_ApplyGuToDrvAnyObject(RWayS.Date, L_APWI.ObjectP_VldPsg) | (_WGuCntVld=0));
    ELSIF rwsWho = L_Way.rwswho_Guard THEN
     IF NeedRWayJ THEN
      GetWayLMenCount(L_Way.rwswho_Guard, L_Way.wlmwho_Guard, _WCnt, _WCntVld);
     END;
     NeedRWayJInc:=NeedRWayJ & L_Way.rwswhoWithSale(rwsWho);
     NeedRWayJVld:=NeedRWayJ & L_Way.rwswhoWithVld(rwsWho);
    ELSIF rwsWho = L_Way.rwswho_Chopper THEN
     NeedRWayJInc:=L_Way.AccessTckRcS_byRWayJ(Staff.TSN, L_Way.trs_Chopper);
     NeedRWayJVld:=0;
    END;
    NeedRWayJVld:=NeedRWayJVld & wVldPsgPlan;
    IF NeedRWayJInc | NeedRWayJVld THEN
     getIncRWJP(rwsWho, _Number, _tFc, _rwjp, _VldPsgFact);
     IF rwsWho = L_Way.rwswho_Driver THEN
      _tFc    :=_tFc     / _WCnt;
      _rwjp[0]:=_rwjp[0] / _WCnt;
      _rwjp[1]:=_rwjp[1] / _WCnt;
      _rwjp[2]:=_rwjp[2] / _WCnt;
      _rwjp[3]:=_rwjp[3] / _WCnt;
      _rwjp[4]:=_rwjp[4] / _WCnt;
     END;
    END;
    IF NeedRWayJInc | NeedRWayJVld THEN
     IF (WJMode.IncSel > 0) & (Quality.Type # L_Way.QualType_Annul) THEN
      IF E_TSN_Inc_PlanPerTrip(RWayS.Date) THEN
       IF L_Way.RealRWayJTrip() THEN
        INC(_tTm, RWayJ.Fact);
       END;
      ELSE
       INC(_tTm, RWayJ.StopT-RWayJ.StartT);
      END;
      IF rwsWho = L_Way.rwswho_Driver THEN
       _tTm:=_tTm / _WCnt;
      END;
     END;
    END;
    IF D_RWS.E_IN001_TakeOnIncome(RWayS.Date, rwsWho) THEN
     IF NeedRWayJVld THEN
      IF    rwsWho = L_Way.rwswho_Driver THEN
       INC(_VldPsgPlan, L_APWI.TrVldPsgPlan());
      ELSIF rwsWho = L_Way.rwswho_Guard THEN
       INC(_VldPsgPlan, L_APWI.TrVldPsgPlan() * L_APWI.E_VldPsgPlanMultiplier(RWayS.Date, _WCntVld));
      END;
     END;
     IF NeedRWayJInc THEN
      IF    rwsWho = L_Way.rwswho_Driver THEN
       INC(_tPl, RWayJ.PlIncome/_WCnt);
      ELSIF rwsWho = L_Way.rwswho_Guard THEN
       IF L_APWI.E_IndividualIPl(RWayS.Date, rwsWho, _WCnt) THEN
        CONFORM(RWayS, Calendar);
        L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
        INC(_tPl, L_APWI.GetPlForIPC(L_Way.ipc_Guard));
       ELSE
        INC(_tPl, RWayJ.PlIncome / L_Way.E_IPlDvdr(RWayS.Date, _WCnt, rwsWho, WayLMen.Number));
       END;
      ELSIF rwsWho = L_Way.rwswho_Chopper THEN
       INC(_tPl, L_Way.GetChopperPlanIncome(Staff.TSN));
      END;
     END;
    END; (* IF D_RWS.E_IN001_TakeOnIncome... *)
    IF AllStaff THEN
     AppIdx:="Staff.TSN, _PartNum";
    ELSE
     AppIdx:="RWayS.Date, SEJobs.Exit, Route.Route, RWayS.RWayS, _WCnt, _PartNum";
    END;
    _PartNum:=E_TSN_Inc_PartNum();
    ADD(TMP01, TMP01, , ^AppIdx,
        TMP01.tTm,     _tTm,
        TMP01.tPl,     _tPl,
        TMP01.tFc,     _tFc,
        TMP01.rwjp[0], _rwjp[0],
        TMP01.rwjp[1], _rwjp[1],
        TMP01.rwjp[2], _rwjp[2],
        TMP01.rwjp[3], _rwjp[3],
        TMP01.rwjp[4], _rwjp[4],
        TMP01.VldPsgFc, _VldPsgFact,
        TMP01.VldPsgPl, _VldPsgPlan);
   END; (* IF L_Way.SEJobsWithPlIncome... *)
   INC(TripNbr);
   NEXT(RWayJ);
  END; (* WHILE OCCURE(RWayJ) ... *)
 END {OneRWayS};

 PRIVATE PROCEDURE PassWayLMen(wlmWho: L_Way.tWLMWho; rwsWho: L_Way.tRWSWho);
 BEGIN
  SELECT(WayLMen, TSN, , Staff.TSN);
  SRCINSEL(WayLMen, GE, , From);
  WHILE OCCURE(WayLMen) & (WayLMen.RWayDate<=UpTo) DO
   IF WayLMen.Who = wlmWho THEN
    CONFORM(WayLMen, RWayS);
    OneRWayS(rwsWho, wlmWho, WayLMen.Number);
   END;
   NEXT(WayLMen);
  END; (* WHILE OCCURE(WayLMen) ... *)
 END {PassWayLMen};

 PRIVATE PROCEDURE Prepare_TMP01();
 BEGIN
  IF    CurWho = L_Way.rwswho_Driver THEN
   SELECT(RWayS, TSN, , Staff.TSN);
   SRCINSEL(RWayS, GE, , From);
   WHILE OCCURE(RWayS) & (RWayS.Date<=UpTo) DO
    OneRWayS(L_Way.rwswho_Driver, EMPTYOF(L_Way.tWLMWho), 1);
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS) ... *)
   PassWayLMen(L_Way.wlmwho_SDriver, L_Way.rwswho_Driver);
  ELSIF CurWho = L_Way.rwswho_Guard THEN
   PassWayLMen(L_Way.wlmwho_Guard, L_Way.rwswho_Guard);
   IF L_Way.E_TckRcLevel(UpTo) THEN
    L_AFM.MakeIndex("TRSRW", "Date : DATE;            "+
                                "RWayS: LIKE(RWayS.RWayS)");
    SELECT(TckRcS, TSN, , Staff.TSN);
    SRCINSEL(TckRcS, GE, , From);
    WHILE OCCURE(TckRcS) & (TckRcS.Date <= UpTo) DO
     IF TckRcS.AsWho = L_Way.trs_Chopper THEN
      SELECT(TckRcJ, TckRcS, , TckRcS.TckRcS);
      WHILE OCCURE(TckRcJ) DO
       IF ~!TckRcJ.asRWayS THEN
        SEARCH(RWayS, RWayS, , TckRcJ.asRWayS);
        IF ~SELECT(TRSRW, TRSRW, RWayS.Date, RWayS.RWayS) THEN
         TRSRW.Date :=RWayS.Date;
         TRSRW.RWayS:=RWayS.RWayS;
         INSERT(TRSRW);
        END;
       END;
       NEXT(TckRcJ);
      END; (* WHILE OCCURE(TckRcJ) ... *)
     END;
     NEXT(TckRcS);
    END; (* WHILE OCCURE(TckRcS) ... *)
    IF SELECT(TRSRW, TRSRW) THEN
     WHILE OCCURE(TRSRW) DO
      SEARCH(RWayS, RWayS, , TRSRW.RWayS);
      (* to calculate income plan *)
      CONFORM(RWayS, Calendar);
      CONFORM(RWayS, Car);
      L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
      OneRWayS(L_Way.rwswho_Chopper, EMPTYOF(L_Way.tWLMWho), 0);
      NEXT(TRSRW);
     END; (* WHILE OCCURE(TRSRW) ... *)
    END;
    L_AFM.AF_PurgeTemp("TRSRW");
   END; (* IF L_Way.E_TckRcLevel ... *)
  END;
 END {Prepare_TMP01};

 PRIVATE PROCEDURE Purge_TMP01();
 BEGIN
  L_AFM.AF_PurgeTemp("TMP01");
 END {Purge_TMP01};

 PRIVATE PROCEDURE E_TSN_Inc_MakeSpecialBot();
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Utils.TSN_Inc_MakeSpecialBot);
  IF ~!Local THEN
   Local(CurWho, tTm, tPl, tFc);
  END;
 END {E_TSN_Inc_MakeSpecialBot};

 PRIVATE PROCEDURE GetBal(VAR _TimDone, _CorBal: L_PRoll.tTime);
  VAR
   B, E : LIKE(Sheet.Day);
   _HBal: L_PRoll.tTime;
 BEGIN
  SETZERO(_TimDone, _CorBal);

  SELECT(StaffLog, TSN, , Staff.TSN);
  IF ~SRCINSEL(StaffLog, LE, From) THEN
   SRCINSEL(StaffLog, GE, , From);
  END;
  WHILE OCCURE(StaffLog) & (StaffLog.Date <= UpTo) DO
   IF ~L_Staff.IsDischargeStaffLog() THEN
    B:=L_DatTim.DAY(Math.Max(StaffLog.Date,  From));
    E:=L_DatTim.DAY(Math.Min(StaffLog.DateE, UpTo));
  
    SELECT(Sheet, TSN, , Staff.TSN, L_DatTim.Per(From));
    SELECT(RegList, HumReg, , StaffLog.Regime, L_DatTim.Per(From));
    SRCINSEL(RegList, GE, , B);
    WHILE OCCURE(RegList) & (RegList.Day <= E) DO
     IF SRCINSEL(Sheet, EQ, RegList.Day) & (Sheet.JMode # 20(*ப  㯨*)) THEN
      CONFORM(Sheet,   JMode);
     ELSE
      CONFORM(RegList, JMode);
     END;
     IF JMode.InFirm THEN
      INC(_CorBal, RegList.Durat);
      IF JMode.Type = L_Sheet.jmType_TimDone THEN
       INC(_TimDone, Sheet.Tim);
      END;
      IF JMode.DecrBal THEN
       DEC(_CorBal, Sheet.Tim);
      END;
     END;
     NEXT(RegList);
    END;
   END;
   NEXT(StaffLog);
  END; (* WHILE OCCURE(StaffLog) ... *)
 END {GetBal};

 PRIVATE PROCEDURE E_TSN_Inc_CorrPlan(VAR tPl  : NUMERIC[2];
                                      CurWho   : L_Way.tRWSWho;
                                      _TimDone,
                                      _CorBal  : L_PRoll.tTime);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Utils.TSN_Inc_CorrPlan);
  IF ~!Local THEN
   Local(tPl, CurWho, _TimDone, _CorBal);
  END;
 END {E_TSN_Inc_CorrPlan};

 PRIVATE PROCEDURE MakeRep();
  VAR
   DateCnt: NUMERIC[0];
 BEGIN
  wVldPsgPlan:=L_Way.E_VldPsgPlanLev(UpTo);
  SETZERO(RWaySAmount);
 
  Create_TMP01();
  IF ~L_General.KioskExecution_IsRunning() THEN
   OPENREP(R, L_General.NameConnection(RepName), Create);
  END;
 
  IF AllStaff THEN
   SELECT(Staff, TSN);
   WHILE OCCURE(Staff) DO
    PROMPT(Staff.TSN);
    Prepare_TMP01();
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
 
   MAKEPART(R, All_Top);
   SELECT(TMP01, TMP01);
   WHILE OCCURE(TMP01) DO
    SEARCH(Staff, TSN, , TMP01.TSN);
    PROMPT(" " + Staff.TSN);
    CONFORM(Staff, Man);
    GetBal(_TimDone, _CorBal);
    E_TSN_Inc_CorrPlan(TMP01.tPl, CurWho, _TimDone, _CorBal);
    MAKEPART(R, All_Line, _CorBal, _TimDone, TMP01.tTm, TMP01.tPl, TMP01.tFc,
                          GetPrc(TMP01.tFc, TMP01.tPl));
    NEXT(TMP01);
   END; (* WHILE OCCURE(TMP01) ... *)
   MAKEPART(R, All_Bot);
  ELSE
   CONFORM(Staff, Man);
   CHANGESEL(Staff, TSN, , Staff.TSN);
   Prepare_TMP01();
  
   MAKEPART(R, Top);
   SETZERO(tTm, tPl, tFc, rwjp, tVldPsgPl, tVldPsgFc);
  
   SELECT(TMP01, TMP01);
   WHILE OCCURE(TMP01) DO
    CHANGESEL(TMP01, TMP01, , TMP01.Date);
    DateCnt:=0;
    WHILE OCCURE(TMP01) DO
     PROMPT(TMP01.Route);
     IF (TMP01.tTm>0) | (TMP01.tPl>0) | (TMP01.tFc>0) THEN
      CONFORM(TMP01, Route);
      CONFORM(TMP01, RWayS);
      IF DateCnt = 0 THEN
       MAKEPART(R, TopDate);
       MAKEPART(R, Line, FLDTOSTR(TMP01.Date, "DNY", 0));
      ELSE
       MAKEPART(R, Line, "");
      END;
      IF wVldPsgPlan & (TMP01.VldPsgPl > 0) THEN
       MAKEPART(R, Line_VldPsg);
       INC(tVldPsgPl, TMP01.VldPsgPl);
       INC(tVldPsgFc, TMP01.VldPsgFc);
      END;
      INC(DateCnt);
      INC(rwjp[0], TMP01.rwjp[0]);
      INC(rwjp[1], TMP01.rwjp[1]);
      INC(rwjp[2], TMP01.rwjp[2]);
      INC(rwjp[3], TMP01.rwjp[3]);
      INC(rwjp[4], TMP01.rwjp[4]);
      INC(tTm[0], TMP01.tTm);
      INC(tPl[0], TMP01.tPl);
      INC(tFc[0], TMP01.tFc);
      IF (TMP01.PartNum # 0) THEN
       INC(tTm[TMP01.PartNum], TMP01.tTm);
       INC(tPl[TMP01.PartNum], TMP01.tPl);
       INC(tFc[TMP01.PartNum], TMP01.tFc);
      END;
     END;
     NEXT(TMP01);
    END; (* WHILE OCCURE(TMP01) ... *)
    LAST(TMP01);
    CHANGESEL(TMP01, TMP01);
    NEXT(TMP01);
   END; (* WHILE OCCURE(TMP01) ... *)
  
   MAKEPART(R, Bot);
   IF wVldPsgPlan & (tVldPsgPl > 0) THEN
    MAKEPART(R, Bot_VldPsg);
   END;
   E_TSN_Inc_MakeSpecialBot();
   MAKEPART(R, LastBot);
  END;
 
  IF ~L_General.KioskExecution_IsRunning() THEN
   CLOSEREP(R);
  END;
  Purge_TMP01();
 END {MakeRep};

 PUBLIC PROCEDURE GuInc();
 BEGIN
  L_General.SetIntvlByIntvl(From, UpTo);
  L_General.Assert(ACCESS(Staff), " ⠭ ࠡ⭨");
  CurWho  :=L_Way.rwswho_Guard;
  RepName :="GuInc";
  AllStaff:=0;
  MakeRep();
 END {GuInc};

 PUBLIC PROCEDURE DrInc();
 BEGIN
  L_General.SetIntvlByIntvl(From, UpTo);
  L_General.Assert(ACCESS(Staff), " ⠭ ࠡ⭨");
  CurWho  :=L_Way.rwswho_Driver;
  RepName :="DrInc";
  AllStaff:=0;
  MakeRep();
 END {DrInc};

 PUBLIC PROCEDURE GuaBl();
 BEGIN
  L_General.SetIntvlByIntvl(From, UpTo);
  L_General.Assert(L_DatTim.Per(From) = L_DatTim.Per(UpTo), "ਮ    ।  ");
  CurWho  :=L_Way.rwswho_Guard;
  RepName :="GuaBl";
  AllStaff:=1;
  MakeRep();
 END {GuaBl};

END.
