(*
%Copyright   (c) Polak IT
%Author      18.07.2006 13:05:32 POLAK\San
%Purpose      鸞
%Type        report
%Specific    AP
%Modified    02.07.2014 18:53:34 POLAK\Gina
%Environment
*)

 MODULE two04 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_Way, L_BegRWS, L_DatTim, FIO, L_General, L_Basis, L_Str, L_Car, L_two, L_Hld,
        L_OwnData, L_AFM, L_lsStore, Math, L_Env, P_Staff, L_bp, L_Staff, L_AvePay, P_Firm, P_Sort, P_Column,
        L_APtm;

 VAR
  wMF,
  wMP : SCAL[2];

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  IF wMP THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⢥");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠦ");
  L_Basis.wb_WrInQM(F, "፮");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "६");
  L_Basis.wb_WrInQM(F, "६");
  L_Basis.wb_WrInQM(F, "륧");
  L_Basis.wb_WrInQM(F, "륧");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "륧ᯨᠭ");
  L_Basis.wb_WrInQM(F, "␠ᯨᠭ");
  L_Basis.wb_WrInQM(F, "⮢");
  L_Basis.wb_WrInQM(F, "稥 ");
  L_Basis.wb_WrInQM(F, "饭 ⥫");
  L_Basis.wb_WrInQM(F, " 拉");
  L_Basis.wb_WrInQM(F, " ⢨");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⠄");
  L_Basis.wb_WrInQM(F, "ਮ");
  L_Basis.wb_WrInQM(F, "ਮ");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE GetDayWorkTime(VAR DrWorkTime, GuWorkTime: NUMERIC[3]);
 BEGIN
  DrWorkTime:=L_two.m_GetDayTime(L_two.who_Driver, Dtwo.Date, Dtwo.Change, Dtwo.ExitClss);
  IF ~!Dtwo.GuardTSN THEN
   GuWorkTime:=L_two.m_GetDayTime(L_two.who_Guard, Dtwo.Date, Dtwo.Change, Dtwo.ExitClss);
  ELSE
   GuWorkTime:=0;
  END;
 END {GetDayWorkTime};

 PRIVATE PROCEDURE WrTSN(F: STRING[]; NeedPrint: SCAL[2]; _TSN: LIKE(Staff.TSN); D: DATE);
  VAR
   trgRegime: LIKE(RegMain.Regime);
   trgShift : NUMERIC[0];
 BEGIN
  IF NeedPrint THEN
   SEARCH(Staff, TSN, , _TSN);
   CONFORM(Staff, Man);
   L_Basis.wb_WrScl(F, Staff.TSN);
   L_Basis.wb_WrStr(F, L_Str.ShortName(Man.Name));
   P_Staff.GetP_RegimeForMkBegRWS(_TSN, D, trgRegime, trgShift);
   IF ~!trgRegime THEN
    L_Basis.wb_WrStr(F, trgRegime);
    L_Basis.wb_WrNum(F, trgShift, 0);
   ELSE
    L_Basis.wb_WrStr(F, "-");
    L_Basis.wb_WrStr(F, "-");
   END;
  ELSE
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
  END;
 END {WrTSN};

 PRIVATE PROCEDURE StandOnTKForExit(_Exit: LIKE(StExit.Exit); D: DATE): SCAL[2];
  VAR
   MaxTKTime: NUMERIC[3];
   TKTime   : NUMERIC[3][100];
   MaxTKind : LIKE(TKind.TKind);
 BEGIN
  MaxTKTime:=0; SETZERO(TKTime); SETEMPTY(MaxTKind);
  SELECT(SEJobs, Exit, , _Exit);
  WHILE OCCURE(SEJobs) DO
   CONFORM(SEJobs, Route);
   INC(TKTime[L_Way.GetRouteTKind(D, 1)], SEJobs.StopT-SEJobs.StartT);
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)

  SELECT(TKind, TKind);
  WHILE OCCURE(TKind) DO
   IF TKTime[TKind.TKind] > MaxTKTime THEN
    MaxTKTime:=TKTime[TKind.TKind];
    MaxTKind :=TKind.TKind;
   END;
   NEXT(TKind);
  END; (* WHILE OCCURE(TKind) ... *)

  IF ~!MaxTKind THEN
   SEARCH(TKind, TKind, , MaxTKind);
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {StandOnTKForExit};

 PRIVATE PROCEDURE MakePart(F: STRING[]; D: DATE);
  VAR
   DrWorkTime,
   GuWorkTime: NUMERIC[3];
   GuBT,
   GuET      : TIME;
 BEGIN
  IF wMF THEN
   SEARCH(MyFirm, MyFirm, , Dtwo.MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  IF wMP THEN
   SEARCH(MyPlace, MyPlace, , Dtwo.MyPlace);
   L_Basis.wb_WrScl(F, MyPlace.MyPlace);
   L_Basis.wb_WrStr(F, MyPlace.Name);
  END;
  L_Basis.wb_WrDat(F, Dtwo.Date);
  IF !Dtwo.ExitClss | ~L_two.StandOnExit(Dtwo.ExitClss, Dtwo.Change, Dtwo.Date, 0) THEN
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
  ELSE
   CONFORM(StExit, ExitClss);
   L_Basis.wb_WrScl(F, ExitClss.ExitClss);
   L_Basis.wb_WrScl(F, ExitClss.Sign);
   L_Basis.wb_WrStr(F, ExitClss.Name);
   L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", ExitClss.Strict = L_Way.ExitStrict_Reg));
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Way.ecbt_Pool, ExitClss.BegType));
   IF StandOnTKForExit(StExit.Exit, Dtwo.Date) & (TKind.Rgn<=L_Way.tkrgn_Intercity) THEN
    L_Basis.wb_WrScl(F, TKind.TKind);
    L_Basis.wb_WrStr(F, TKind.Name);
   ELSE
    L_Basis.wb_WrScl(F, "-");
    L_Basis.wb_WrStr(F, "-");
   END;
  END;
  IF ~!Dtwo.Sort THEN
   SEARCH(Sort, Sort, , Dtwo.Sort);
   L_Basis.wb_WrStr(F, Sort.Sort);
   L_Basis.wb_WrStr(F, Sort.Name);
   L_Basis.wb_WrStr(F, L_Staff.getSortDprt(Sort.Sort));
   L_Basis.wb_WrStr(F, L_Staff.getSortDprtName(Sort.Sort));
  ELSE
   IF ~!Dtwo.Dprt THEN
    SEARCH(Sort, Sort, , Dtwo.Dprt);
    L_Basis.wb_WrStr(F, "-");
    L_Basis.wb_WrStr(F, "-");
    L_Basis.wb_WrStr(F, Sort.Sort);
    L_Basis.wb_WrStr(F, Sort.Name);
   ELSE
    L_Basis.wb_WrStr(F, "-");
    L_Basis.wb_WrStr(F, "-");
    L_Basis.wb_WrStr(F, "-");
    L_Basis.wb_WrStr(F, "-");
   END;
  END;
  IF !Dtwo.Change THEN
   L_Basis.wb_WrStr(F, "-");
  ELSE
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_BegRWS.wh_Pool, Dtwo.Change));
  END;
  WrTSN(F, ~!Dtwo.TSN, Dtwo.TSN, D);
  IF    !Dtwo.TSN | !Dtwo.Sort THEN
   L_Basis.wb_WrStr(F, "?");
  ELSIF Dtwo.Sort # L_BegRWS.GetSortOfStaff(Dtwo.TSN, D) THEN
   L_Basis.wb_WrStr(F, "-");
  ELSE
   L_Basis.wb_WrStr(F, "+");
  END;
  WrTSN(F, ~!Dtwo.GuardTSN, Dtwo.GuardTSN, D);
  IF ~!Dtwo.BoxNbr THEN
   L_Car.StandOnCarLog(Dtwo.BoxNbr, Dtwo.Date);
   CONFORM(CarLog, Mark);
   L_Basis.wb_WrScl(F, CarLog.BoxNbr);
   L_Basis.wb_WrStr(F, CarLog.StateNbr);
   L_Basis.wb_WrScl(F, Mark.Mark);
   L_Basis.wb_WrStr(F, Mark.Name);
  ELSE
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
  END;
  GetDayWorkTime(DrWorkTime, GuWorkTime);
  L_Basis.wb_WrNum(F, DrWorkTime, 3);
  L_Basis.wb_WrNum(F, GuWorkTime, 3);
  IF ~!Dtwo.BegTime THEN
   L_Basis.wb_WrScl(F, Dtwo.BegDay);
   L_Basis.wb_WrTim(F, Dtwo.BegTime);
   L_Basis.wb_WrTim(F, Dtwo.EndTime);
  ELSE
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
  END;
  IF ~!Dtwo.GuardTSN & ~!Dtwo.ExitClss & L_two.StandOnExit(Dtwo.ExitClss, Dtwo.Change, Dtwo.Date, 0) THEN
   L_Way.GetExitTimes(L_Way.rwswho_Guard, GuBT, GuET);
   L_Basis.wb_WrTim(F, GuBT);
   L_Basis.wb_WrTim(F, GuET);
  ELSE
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
  END;
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-||", Dtwo.Complete));
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-||?", Dtwo.GuardOk));
  IF ~!Dtwo.Message THEN
   L_Basis.wb_WrStr(F, L_lsStore.Get(Dtwo.Message));
  ELSE
   L_Basis.wb_WrStr(F, "-");
  END;
  L_Basis.wb_WrStr(F, "+");
  L_Basis.wb_WrStr(F, "---");
  L_Basis.wb_WrStr(F, "---");
  L_Basis.wb_WrDat(F, EMPTYOF(DATE));
  L_Basis.wb_WrDat(F, EMPTYOF(DATE));
  L_Basis.wb_WrDat(F, EMPTYOF(DATE));
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE AveTypeSequenceStart(fr, ut: DATE): DATE;
  VAR
   Result: DATE;
   curAveType: LIKE(AveType.AveType);
 BEGIN
  Result:=AvePay.StartD;
  curAveType:=AvePay.AveType;
  TRY [RESTORE_CURSORS(RC_ON)]
   CHANGESEL(AvePay, TSN, , AvePay.TSN);
   WHILE PREV(AvePay) & ((Result - 1 = L_AvePay.GetAvePayStopD()) | ~L_AvePay.IsRealAvePay()) DO
    IF L_AvePay.IsRealAvePay() & (AvePay.AveType = curAveType) & (L_DatTim.DATEINT(fr, ut, AvePay.StartD, L_AvePay.GetAvePayStopD())=0) THEN
     Result:=AvePay.StartD;
    END;
   END;
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {AveTypeSequenceStart};

 PRIVATE PROCEDURE AveTypeSequenceStop(fr, ut: DATE): DATE;
  VAR
   Result: DATE;
   curAveType: LIKE(AveType.AveType);
 BEGIN
  Result:=L_AvePay.GetAvePayStopD();
  curAveType:=AvePay.AveType;
  TRY [RESTORE_CURSORS(RC_ON)]
   CHANGESEL(AvePay, TSN, , AvePay.TSN);
   WHILE NEXT(AvePay) & ((Result + 1 = AvePay.StartD) | ~L_AvePay.IsRealAvePay()) DO
    CONFORM(AvePay, AveType);
    IF L_AvePay.IsRealAvePay() & (AvePay.AveType = curAveType) & (L_DatTim.DATEINT(fr, ut, AvePay.StartD, L_AvePay.GetAvePayStopD())=0) THEN
     Result:=AvePay.StopD;
    END;
   END;
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {AveTypeSequenceStop};

 PRIVATE PROCEDURE MakePartFromMtwo(F: STRING[]; D: DATE; WhatStr: STRING[]; trgAvePay: LIKE(AvePay.AvePay); fr, ut: DATE);
 BEGIN
  IF wMF THEN
   IF ~!Mtwo.Sort THEN
    SEARCH(MyFirm, MyFirm, , Mtwo.MyFirm);
    L_Basis.wb_WrScl(F, MyFirm.MyFirm);
    L_Basis.wb_WrStr(F, MyFirm.vzSign);
   ELSE
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
   END;
  END;
  IF wMP THEN
   IF ~!Mtwo.Sort THEN
    SEARCH(MyPlace, MyPlace, , P_Sort.GetMyPlace(Mtwo.Sort, D));
    L_Basis.wb_WrScl(F, MyPlace.MyPlace);
    L_Basis.wb_WrStr(F, MyPlace.Name);
   ELSE
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
   END;
  END;
  L_Basis.wb_WrDat(F, D);
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  IF ~!Mtwo.Sort THEN
   CONFORM(Mtwo, Sort);
   L_Basis.wb_WrStr(F, Sort.Sort);
   L_Basis.wb_WrStr(F, Sort.Name);
   L_Basis.wb_WrStr(F, L_Staff.getSortDprt(Sort.Sort));
   L_Basis.wb_WrStr(F, L_Staff.getSortDprtName(Sort.Sort));
  ELSE
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
  END;
  L_Basis.wb_WrStr(F, "-");
  WrTSN(F, Mtwo.Who = L_two.who_Driver, Mtwo.TSN, D);
  L_Basis.wb_WrStr(F, "+");
  WrTSN(F, Mtwo.Who = L_two.who_Guard,  Mtwo.TSN, D);
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrNum(F, 0, 3);
  L_Basis.wb_WrNum(F, 0, 3);
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, WhatStr);
  IF ~!trgAvePay THEN
   SEARCH(AvePay, AvePay, , trgAvePay);
   L_Basis.wb_WrStr(F, AvePay.DocNum);
   L_Basis.wb_WrDat(F, AvePay.DocDate);
   L_Basis.wb_WrDat(F, AveTypeSequenceStart(fr, ut));
   L_Basis.wb_WrDat(F, AveTypeSequenceStop(fr, ut));
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrDat(F, EMPTYOF(DATE));
   L_Basis.wb_WrDat(F, EMPTYOF(DATE));
   L_Basis.wb_WrDat(F, EMPTYOF(DATE));
  END;
  L_Basis.wb_TermLine(F);
 END {MakePartFromMtwo};

 PRIVATE PROCEDURE MakePartFromCar(F: STRING[]; _Date: DATE);
  VAR
   curDprt: LIKE(Sort.Sort);
 BEGIN
  IF wMF THEN
   CONFORM(CarLog, Column);
   CONFORM(Column, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  IF wMP THEN
   SEARCH(MyPlace, MyPlace, , P_Column.GetMyPlace(CarLog.Column, _Date));
   L_Basis.wb_WrScl(F, MyPlace.MyPlace);
   L_Basis.wb_WrStr(F, MyPlace.Name);
  END;
  L_Basis.wb_WrDat(F, _Date);
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  curDprt:=L_Way.E_GetCarDprt(Car.BoxNbr, _Date);
  IF ~!curDprt THEN
   L_General.CallUs(SEARCH(Sort, Sort, curDprt));
   L_Basis.wb_WrStr(F, Sort.Sort);
   L_Basis.wb_WrStr(F, Sort.Name);
  ELSE
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
  END;
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  CONFORM(CarLog, Mark);
  L_Basis.wb_WrScl(F, CarLog.BoxNbr);
  L_Basis.wb_WrStr(F, CarLog.StateNbr);
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Basis.wb_WrNum(F, 0, 3);
  L_Basis.wb_WrNum(F, 0, 3);
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "-");
  L_Basis.wb_WrStr(F, "---");
  L_Basis.wb_WrStr(F, "---");
  L_Basis.wb_WrDat(F, EMPTYOF(DATE));
  L_Basis.wb_WrDat(F, EMPTYOF(DATE));
  L_Basis.wb_WrDat(F, EMPTYOF(DATE));
  L_Basis.wb_TermLine(F);
 END {MakePartFromCar};

 PRIVATE PROCEDURE intTWO04(fr, ut: DATE);
  VAR
   _Date    : DATE;
   trgJMode : LIKE(JMode.JMode);
   trgAvePay: LIKE(AvePay.AvePay);
   Idx,
   BegIdx,
   EndIdx : NUMERIC[0];
   WhatStr: STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  wMP:=P_Firm.E_wMultipleMyPlace(SYSDATE());
  FIO.Open(R, L_General.NameConnection(L_bp.getCurId()), "REP", Create);
  MakeHeader("R");
  SELECT(Dtwo, Dtwo);
  SRCINSEL(Dtwo, GE, , fr);
  WHILE OCCURE(Dtwo) & (Dtwo.Date <= ut) DO
   PROMPT("㧪: " + L_DatTim.DateStr(Dtwo.Date) + " " + Dtwo.Dtwo);
   MakePart("R", Dtwo.Date);
   NEXT(Dtwo);
  END; (* WHILE OCCURE(Dtwo) ... *)

  SELECT(Mtwo, Per);
  SRCINSEL(Mtwo, GE, , L_DatTim.Per(fr));
  WHILE OCCURE(Mtwo) & (Mtwo.Per <= L_DatTim.Per(ut)) DO
   BegIdx:=L_two.Date2Idx(Math.Max(fr, Mtwo.Per));
   EndIdx:=L_two.Date2Idx(Math.Min(ut, L_DatTim.MonthEnd(Mtwo.Per)));
   Idx:=BegIdx;
   WHILE Idx <= EndIdx DO
    _Date:=L_two.Idx2Date(Idx, Mtwo.Per);
    PROMPT("㧪 (ࠡ⭨   拉): " + L_DatTim.DateStr(_Date) + " " + Mtwo.Mtwo);
    IF (Mtwo.What[Idx] # L_BegRWS.dt_NotInState) &
       ~SELECT(Dtwo, DTSN, _Date, Mtwo.TSN) & ~SELECT(Dtwo, DGuardTSN, _Date, Mtwo.TSN) THEN
     WhatStr:="???"; SETEMPTY(trgAvePay);
     IF ~!Mtwo.What[Idx] THEN
      IF    Mtwo.What[Idx] = L_BegRWS.dt_Relaxation THEN
       WhatStr:="";
      ELSIF Mtwo.What[Idx] = L_BegRWS.dt_NotDefined THEN
       WhatStr:="室";
      ELSIF Mtwo.What[Idx] = L_BegRWS.dt_Absence THEN
       L_AvePay.GetNativeSheetJModeAndAvePay(Mtwo.TSN, _Date, trgJMode, trgAvePay, 1);
       IF ~!trgJMode THEN
        L_General.Assert(SEARCH(JMode, JMode, trgJMode), "   ࠢ筨  ࠡ  ⠡ "+trgJMode);
        WhatStr:=JMode.Name;
       END;
      END;
     END;
     MakePartFromMtwo("R", _Date, WhatStr, trgAvePay, fr, ut);
    END;
    INC(Idx);
   END;
   NEXT(Mtwo);
  END; (* WHILE OCCURE(Mtwo) ... *)

  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   IF L_Env.RealBoxNbr(Car.BoxNbr) & L_Car.CarDaysInOperation(Car.BoxNbr, fr, ut) THEN
    _Date:=fr;
    WHILE _Date <= ut DO
     PROMPT("㧪 (   拉): " + L_DatTim.DateStr(_Date) + " " + Car.BoxNbr);
     IF L_Car.CarIsInOperation(Car.BoxNbr, _Date) &
        ~SELECT(Dtwo, DBoxNbr, _Date, Car.BoxNbr) THEN
      MakePartFromCar("R", _Date);
     END;
     INC(_Date);
    END;
   END;
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
  FIO.Close(R);
 END {intTWO04};

 CONST
  ECAmount = 31;

 VAR
  two07_hArr   : STRING[4][31];
  two07_sArr   : NUMERIC[3][31];
  two07_eArr   : NUMERIC[0][ECAmount];

(*
$P{ two07_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, ""
two07_hArr[00], R, ""
two07_hArr[01], R, ""
two07_hArr[02], R, ""
two07_hArr[03], R, ""
two07_hArr[04], R, ""
two07_hArr[05], R, ""
two07_hArr[06], R, ""
two07_hArr[07], R, ""
two07_hArr[08], R, ""
two07_hArr[09], R, ""
two07_hArr[10], R, ""
two07_hArr[11], R, ""
two07_hArr[12], R, ""
two07_hArr[13], R, ""
two07_hArr[14], R, ""
two07_hArr[15], R, ""
two07_hArr[16], R, ""
two07_hArr[17], R, ""
two07_hArr[18], R, ""
two07_hArr[19], R, ""
two07_hArr[20], R, ""
two07_hArr[21], R, ""
two07_hArr[22], R, ""
two07_hArr[23], R, ""
two07_hArr[24], R, ""
two07_hArr[25], R, ""
two07_hArr[26], R, ""
two07_hArr[27], R, ""
two07_hArr[28], R, ""
two07_hArr[29], R, ""
two07_hArr[30], R, ""
@
#######################################################################################################                                                                            ########## #####
=#####=============================================================================================================================================================================================
|  ᬥ  #####################################################################################                                                                                 |
|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|⭨                      ||भ|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|
}
*)

(*
$P{ two07_Line:
?, L, ""
?, R, ""
?, R, "1."
two07_sArr[00], R, "1."
two07_sArr[01], R, "1."
two07_sArr[02], R, "1."
two07_sArr[03], R, "1."
two07_sArr[04], R, "1."
two07_sArr[05], R, "1."
two07_sArr[06], R, "1."
two07_sArr[07], R, "1."
two07_sArr[08], R, "1."
two07_sArr[09], R, "1."
two07_sArr[10], R, "1."
two07_sArr[11], R, "1."
two07_sArr[12], R, "1."
two07_sArr[13], R, "1."
two07_sArr[14], R, "1."
two07_sArr[15], R, "1."
two07_sArr[16], R, "1."
two07_sArr[17], R, "1."
two07_sArr[18], R, "1."
two07_sArr[19], R, "1."
two07_sArr[20], R, "1."
two07_sArr[21], R, "1."
two07_sArr[22], R, "1."
two07_sArr[23], R, "1."
two07_sArr[24], R, "1."
two07_sArr[25], R, "1."
two07_sArr[26], R, "1."
two07_sArr[27], R, "1."
two07_sArr[28], R, "1."
two07_sArr[29], R, "1."
two07_sArr[30], R, "1."
@
|------------------------------|--|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|
|##############################|##|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|
}
*)

(*
$P{ two07_EC_Top:
@
|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| । 室                                                                                                                                                                           |
|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|室 ||⢮ 㯮  拉|६ 砫, 砭, ⢨   
|------|------|------------------------------|----------------------------------------------------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ two07_EC_Line:
EC.ExitClss, L, ""
EC.ECIdx, R, ""
EC.Amount, R, "0"
?, L, ""
@
|######|    ##|                          ####|####################################################################################################################################################|
}
*)

(*
$P{ two07_ND_Top:
@
|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|⭨                              |  00|  01|  02|  03|  04|  05|  06|  07|  08|  09|  10|  11|  12|  13|  14|  15|  16|  17|  18|  19|  20|  21|  22|  23|  24|  25|  26|  27|  28|  29|  30|
}
*)

(*
$P{ two07_ND_Line:
?, L, ""
two07_eArr[00], R, "0"
two07_eArr[01], R, "0"
two07_eArr[02], R, "0"
two07_eArr[03], R, "0"
two07_eArr[04], R, "0"
two07_eArr[05], R, "0"
two07_eArr[06], R, "0"
two07_eArr[07], R, "0"
two07_eArr[08], R, "0"
two07_eArr[09], R, "0"
two07_eArr[10], R, "0"
two07_eArr[11], R, "0"
two07_eArr[12], R, "0"
two07_eArr[13], R, "0"
two07_eArr[14], R, "0"
two07_eArr[15], R, "0"
two07_eArr[16], R, "0"
two07_eArr[17], R, "0"
two07_eArr[18], R, "0"
two07_eArr[19], R, "0"
two07_eArr[20], R, "0"
two07_eArr[21], R, "0"
two07_eArr[22], R, "0"
two07_eArr[23], R, "0"
two07_eArr[24], R, "0"
two07_eArr[25], R, "0"
two07_eArr[26], R, "0"
two07_eArr[27], R, "0"
two07_eArr[28], R, "0"
two07_eArr[29], R, "0"
two07_eArr[30], R, "0"
@
|--------------------------------------|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|
|######################################|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|
}
*)

(*
$P{ two07_Bot:
@
=(c) Polak=========================================================================================================================================================================================
}
*)

 PRIVATE PROCEDURE intTWO07(P: DATE; _Sort: LIKE(Sort.Sort); trgWho: L_two.tTWOWho);
  CONST
   RepName = "two07";
  VAR
   Idx,
   i,
   BegIdx,
   EndIdx : NUMERIC[0];
   sCnt,
   tCnt   : NUMERIC[0];
   Value,
   sVal,
   tVal   : NUMERIC[3];
   dCnt   : NUMERIC[0][31];
   dArr   : NUMERIC[3][31];
   prvET  : FLOAT;
   ECIdx  : SCAL[1E2];
   TimeStr: STRING[];
   wd     : L_DatTim.tWeekday;
   OnDayId: STRING[];
 BEGIN
  BegIdx:=L_two.Date2Idx(P);
  EndIdx:=L_two.Date2Idx(L_DatTim.MonthEnd(P));
  L_General.CallUs(SEARCH(Sort, Sort, _Sort));
  L_AFM.MakeMultipleIndex("NowDone", "TSN     : LIKE(Staff.TSN);"+
                                     "ExitClss: LIKE(ExitClss.ExitClss);"+
                                     "Amount  : NUMERIC[0]",
                             "TSN: TSN, ExitClss");
  L_AFM.MakeMultipleIndex("EC", "ExitClss: LIKE(ExitClss.ExitClss);"+
                                "ECIdx   : SCAL[1E2];"+
                                "Amount  : NUMERIC[0]",
                             "ExitClss: ExitClss");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  SETEMPTY(two07_hArr);
  i:=0;
  WHILE i < L_DatTim.MonthLen(P) DO
   two07_hArr[i]:=L_DatTim.WeekDayShortStr(L_Hld.WeekDay_TransfersConsidered(P+i)) + L_Str.IntStr(i+1);
   INC(i);
  END;
  MAKEPART(R, two07_Top, RepName,
           " " + L_DatTim.PeriodStr(P) +
           ", " + L_Str.PoolItem("⥫|", trgWho) +
           ", " + "ᥪ " + Sort.Sort + " " + Sort.Name);
  SETZERO(tCnt, tVal, dCnt, dArr);
  SELECT(Mtwo, PSort, , P, L_Staff.getSortDprt(Sort.Sort), Sort.Sort);
  WHILE OCCURE(Mtwo) DO
   PROMPT(Mtwo.TSN);
   IF Mtwo.Who = trgWho THEN
    Idx:=BegIdx;
    SETZERO(sCnt, sVal);
    SETEMPTY(two07_sArr);
    WHILE Idx <= EndIdx DO
     IF L_BegRWS.IsWorkDayType(Mtwo.What[Idx]) THEN
      ADD(EC, ExitClss, , Mtwo.ExitClss[Idx],
          EC.Amount, 1);
      ADD(NowDone, TSN, , Mtwo.TSN, Mtwo.ExitClss[Idx],
          NowDone.Amount, 1);
     END;
     IF L_BegRWS.IsWorkDayType(Mtwo.What[Idx-1]) & L_BegRWS.IsWorkDayType(Mtwo.What[Idx]) THEN
      SETEMPTY(Value);
      L_two.AccessDtwoByMtwo(Idx-1);
      IF ~!Dtwo.ExitClss THEN
       prvET:=L_Way.FullEndTime(Dtwo.BegDay, Dtwo.BegTime, Dtwo.EndTime);
       L_two.AccessDtwoByMtwo(Idx);
       IF ~!Dtwo.ExitClss THEN
        Value:=(L_Way.FullBegTime(Dtwo.BegDay, Dtwo.BegTime)+24)-prvET;
       END;
      END;
      IF ~!Value THEN
       two07_sArr[Idx-BegIdx]:=Value;
       INC(sCnt);
       INC(sVal, Value);
       INC(dCnt[Idx-BegIdx]);
       INC(dArr[Idx-BegIdx], Value);
      END;
     END;
     INC(Idx);
    END;
    IF sCnt > 0 THEN
     CONFORM(Mtwo, Staff, Man);
     MAKEPART(R, two07_Line, Staff.TSN + " " + L_Str.ShortName(Man.Name), sCnt, sVal/sCnt);
    END;
    INC(tCnt, sCnt);
    INC(tVal, sVal);
   END;
   NEXT(Mtwo);
  END; (* WHILE OCCURE(Mtwo) *)
  IF tCnt > 0 THEN
   i:=0;
   WHILE i < 31 DO
    IF dCnt[i] > 0 THEN
     two07_sArr[i]:=dArr[i]/dCnt[i];
    ELSE
     SETEMPTY(two07_sArr[i]);
    END;
    INC(i);
   END;
   MAKEPART(R, two07_Line, "⮣  ।",  , tVal/tCnt);
  END;
  MAKEPART(R, two07_EC_Top);
  ECIdx:=0;
  SELECT(EC, ExitClss);
  WHILE OCCURE(EC) DO
   IF ECIdx = ECAmount THEN
    STDMSG("誮 让 祭 室."+
           "||" +
           ", 室 ᤥ (ᨫ) ⡮ ࠡ⭨  ⥪饬 䨫", INFORM);
   END;
   EC.ECIdx:=Math.Min(ECIdx, ECAmount-1);
   REPLACE(EC);
   TimeStr:="";
   SELECT(StExit, ExitClss, , EC.ExitClss);
   WHILE OCCURE(StExit) DO
    IF L_DatTim.IsActiveInIntvl(P, L_DatTim.MonthEnd(P), StExit.FromD, StExit.UpDate) THEN
     IF ~!TimeStr THEN
      TimeStr:=TimeStr +  ", ";
     END;
     IF StExit.ActivKnd = L_Way.seak_OnDays THEN
      OnDayId:="";
      FOR_EACH wd DO
       OnDayId:=OnDayId + L_Str.PoolItem("-|", StExit.OnDays[wd]);
      END;
     ELSIF StExit.ActivKnd = L_Way.seak_EveryOtherDay THEN
      OnDayId:="१ ";
     ELSE
      L_General.CallUs(0);
     END;
     TimeStr:=TimeStr + L_Way.FullStExitBegTimeStr() + " " + L_Way.FullStExitStopTimStr() + " (" + OnDayId + ")";
    END;
    NEXT(StExit);
   END; (* WHILE OCCURE(StExit) ... *)
   MAKEPART(R, two07_EC_Line, TimeStr);
   INC(ECIdx);
   NEXT(EC);
  END; (* WHILE OCCURE(EC) ... *)
  MAKEPART(R, two07_ND_Top);
  SELECT(NowDone, TSN);
  WHILE OCCURE(NowDone) DO
   SETEMPTY(two07_eArr);
   CHANGESEL(NowDone, TSN, , NowDone.TSN);
   WHILE OCCURE(NowDone) DO
    SEARCH(EC, ExitClss, , NowDone.ExitClss);
    two07_eArr[EC.ECIdx]:=NowDone.Amount;
    NEXT(NowDone);
   END;
   LAST(NowDone);
   SEARCH(Staff, TSN, , NowDone.TSN);
   CONFORM(Staff, Man);
   MAKEPART(R, two07_ND_Line, Staff.TSN + " " + L_Str.ShortName(Man.Name));
   CHANGESEL(NowDone, TSN);
   NEXT(NowDone);
  END; (* WHILE OCCURE(NowDone) ... *)
  MAKEPART(R, two07_Bot);
  CLOSEREP(R);
  LIKEMENU(Survey, "");
 END {intTWO07};

 PUBLIC PROCEDURE TWO04();
 BEGIN
  L_bp.Begin("TWO04", " 鸞  ", L_bp.t_Basis, L_General.tc_onDate);
  intTWO04(Memo.ud_cd(), Memo.ud_cd());
  L_bp.End();
 END {TWO04};

 PUBLIC PROCEDURE TWO14();
 BEGIN
  L_bp.Begin("TWO14", " 鸞  ਮ", L_bp.t_Basis, L_General.tc_inIntvl);
  intTWO04(Memo.ud_fr(), Memo.ud_ut());
  L_bp.End();
 END {TWO14};

 PUBLIC PROCEDURE TWO07();
 BEGIN
  L_General.Assert(ACCESS(Mtwo), " ⠭ ⥪   筮 拉");
  intTWO07(Mtwo.Per, Mtwo.Sort, Mtwo.Who);
 END {TWO07};

END.
