(*
%Copyright   (c) Polak IT
%Author      25.09.2003 12:24:16 POLAK\LDA
%Purpose     ஫ 䨪樨 ࠢ筨 " ࠡ  "
%Type        control
%Specific    AP
%Modified    27.06.2014 18:59:14 POLAK\Gina
%Environment
*)

 MODULE WJMode [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_PRoll, L_General, L_Events, L_Str, L_Way, L_WDO, Memo, L_DatTim, L_RWayS, L_StdFrm;

 PRIVATE PROCEDURE WJMethod_OnBeforeInsert();
  VAR
   Flag: SCAL[2];
 BEGIN
  Flag:=L_Str.Left(WJMethod.WJCode, 1) # '';
  IF ~Flag THEN
   WJMethod.JRegime:=01;
   WJMethod.Quality:=L_RWayS.Qlt_Good;
   REPLACE(WJMethod);
  END;
  L_WDO.SetFieldModifiable("WJMethod.JRegime", Flag);
  L_WDO.SetFieldModifiable("WJMethod.Quality", Flag);
 END {WJMethod_OnBeforeInsert};

 PRIVATE PROCEDURE WJMethod_OnAfterEdIns();
  VAR
   D: DATE;
 BEGIN
  L_General.Assert(L_PRoll.E_UseMCFixPay(1, WJMethod.Begin) | (WJMethod.PayType # L_Way.wjmpt_ByMCFix),
                   "  ९  ਬ");
  L_General.Assert((WJMethod.Who # L_Way.rwswho_Chopper) | (WJMethod.PayType#L_Way.wjmpt_ByMark),
                   "稪  ।ᬮ७  '"+L_Str.PoolItem(L_Way.wjmpt_Pool, WJMethod.PayType)+"'");
  L_General.Assert(WJMethod.Begin < WJMethod.Till, " ਮ ࠭ 砫?");
  CONFORM(WJMethod, MoneyMth);
  L_General.Assert((MoneyMth.MthType = L_PRoll.mthtyp_RWaySCalc) |
                   (MoneyMth.MthType = L_PRoll.mthtyp_EmptyCalc),
                   "⮤ " + WJMethod.Method + " '" + MoneyMth.Name + "'" +
                   ", ୠ  ਬ.| |" +
                   " ਬ ⮤   " +
                   L_Str.IntStr(L_PRoll.mthtyp_RWaySCalc) + "  " +
                   L_Str.IntStr(L_PRoll.mthtyp_EmptyCalc) + ".");

  IF (L_Str.Left(WJMethod.WJCode, 1) = '') THEN
   L_General.Assert((WJMethod.JRegime = 01) | (WJMethod.Quality = L_RWayS.Qlt_Good),
                    " ᠭ   ⮣  ᫥ 㪠뢠|० ࠡ 01   ⢠ "+L_Str.FixedIntStr(L_RWayS.Qlt_Good, 3));
  END;

  CHANGESEL(WJMethod, WJCode, , WJMethod.WJCode, WJMethod.Who, WJMethod.JRegime, WJMethod.Quality);
  SAVE(WJMethod);
  D:=WJMethod.Till;
  IF NEXT(WJMethod) THEN
   L_General.Assert(WJMethod.Begin >= D, "ਮ ⢨ ᥪ  ᫥饩 ᨥ");
   IF (WJMethod.Begin > D) THEN
    L_StdFrm.Inform(" ᠭ   " + L_DatTim.PeriodStr(D) + "  " + L_DatTim.PeriodStr(WJMethod.Begin));
   END;
  END;
  RESTORE(WJMethod);

  D:=WJMethod.Begin;
  IF PREV(WJMethod) THEN
   L_General.Assert(WJMethod.Till <= D, "ਮ ⢨ ᥪ  ।饩 ᨥ");
   IF WJMethod.Till < D THEN
    L_StdFrm.Inform(" ᠭ   " + L_DatTim.PeriodStr(WJMethod.Till) + "  " + L_DatTim.PeriodStr(D));
   END;
  END;
 END {WJMethod_OnAfterEdIns};

 PRIVATE PROCEDURE WJMethod_OnAfterInsert();
 BEGIN
  WJMethod_OnAfterEdIns();
 END {WJMethod_OnAfterInsert};

 PRIVATE PROCEDURE WJMethod_OnAfterEdit();
 BEGIN
  WJMethod_OnAfterEdIns();
 END {WJMethod_OnAfterEdit};

 PRIVATE PROCEDURE WJMethod_OnBeforeDelete();
 BEGIN
  IF !WJMethod.Till THEN
   L_StdFrm.Inform("㤥    " + L_DatTim.PeriodStr(WJMethod.Begin));
  ELSE
   L_StdFrm.Inform(" 㤥 ᠭ   " + L_DatTim.PeriodStr(WJMethod.Begin) +
                   "  " + L_DatTim.PeriodStr(WJMethod.Till));
  END;
 END {WJMethod_OnBeforeDelete};

 PRIVATE PROCEDURE WJMode_OnAfterEdIns();
 BEGIN
  IF WJMode.RunSel # L_Way.runsel_None THEN
   IF    WJMode.WJType = L_Way.WJType_Stand THEN
    L_General.Error("⮩     ஡");
   ELSIF WJMode.WJType = L_Way.WJType_Void THEN
    L_StdFrm.Choice("ਧ  ஡  ᮣ  ࠪ஬ ࠡ");
   END;
  END;
  L_General.Assert((WJMode.WJType = L_Way.WJType_Work) |
                   (WJMode.IncSel = 0),
                   "ਧ  室  ᮣ  ࠪ஬ ࠡ");
 END {WJMode_OnAfterEdIns};

 PRIVATE PROCEDURE WJMode_OnAfterEdit();
 BEGIN
  WJMode_OnAfterEdIns();
 END {WJMode_OnAfterEdit};

 PRIVATE PROCEDURE WJMode_OnAfterInsert();
 BEGIN
  WJMode_OnAfterEdIns();
 END {WJMode_OnAfterInsert};

 PRIVATE PROCEDURE WJModeE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterEdit, L_WDO.e_OnAfterInsert]);
  L_WDO.iField       (0, "WJMode.WJType").Format:=L_Way.WJType_Pool;
  L_WDO.iField       (0, "WJMode.RunSel").Format:=L_Way.runsel_Pool;
  L_WDO.iEvents      (1, [L_WDO.e_OnAfterMdf, L_WDO.e_OnBeforeInsert]);
  L_WDO.iMayBeEmpty  (1, ["WJMethod.Till"]);
  L_WDO.iField       (1, "WJMethod.PayType").Format:=L_Way.wjmpt_Pool;
  L_WDO.iProgs       (1, "WJMode");
  L_WDO.iZone        (2).ViewOnly:=1;
 END {WJModeE_OnInitializeWindow};

 PUBLIC PROCEDURE WJMethod_NewVersion();
  VAR
   _Till: DATE;
 BEGIN
  L_General.Assert(ACCESS(WJMethod), " ⠭ ப    ࠡ");
  CONFORM(WJMethod, WJMty);
  SAVE(WJMethod);
  CHANGESEL(WJMethod, WJCode, , WJMethod.WJCode, WJMethod.Who, WJMethod.JRegime, WJMethod.Quality);
  IF SRCINSEL(WJMethod, LE, Memo.ud_mb()) THEN
   IF WJMethod.Till > Memo.ud_mb() THEN
    L_General.Assert(!WJMethod.Till,
                     "  ᠭ   " + L_DatTim.PeriodStr(WJMethod.Begin) +
                     "  " + L_DatTim.PeriodStr(WJMethod.Till));
    _Till:=WJMethod.Till;
    WJMethod.Till:=Memo.ud_mb();
    REPLACE(WJMethod);
   ELSIF NEXT(WJMethod) THEN
    _Till:=WJMethod.Begin;
   ELSE
    SETEMPTY(_Till);
   END;
  ELSE
   FIRST(WJMethod);
   _Till:=WJMethod.Begin;
  END;
  RESTORE(WJMethod);

  WJMethod.Begin:=Memo.ud_mb();
  WJMethod.Till :=_Till;
  INSERT(WJMethod);

  WHILE OCCURE(WJMty) DO
   SAVE(WJMty);
   WJMty.Begin:=Memo.ud_mb();
   INSERT(WJMty);
   RESTORE(WJMty);
   NEXT(WJMty);
  END; (* WHILE OCCURE(WJMty) ... *)
  SE_WZD_POSITION(GE_CURWIN(), GE_CURZONE(), WJMethod);
  WJMethod_OnAfterInsert();
 END {WJMethod_NewVersion};

BEGIN
 L_Events.ExecuteHandler();
END.
