(*
%Copyright   (c) Polak Computer System
%Author      29.10.1997 14:01:46 GINA
%Purpose     ⥢  ࠡ⭨  ਮ
%Type        report,operation
%Specific    09
%Modified    26.02.2013 13:51:25 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT Memo, L_General, L_OwnData, L_DatTim, L_Str, L_XDoc, L_Way, L_AFM;

 CONST
  RepName = "WList";

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
Staff.TSN, L, ""
Man.Name, L, ""
@
################################################# ########## #####
=#####===========================================================|
|  ⥢  ࠡ⭨  ਮ  ##########  ##########  |
|----------------------------------------------------------------|
|⭨ ##### #################################################|
|----------------------------------------------------------------|
|      |     ||| |室    |               |||
}
*)

(*
$P{ Line:
RWayS.Date, L, "D.N.y"
RWayS.RWayS, L ""
RWayS.Done, L, " |"
RWayS.Status, L, ""
RWayS.BoxNbr, L, ""
RWayS.Exit, L, ""
L_Str.PoolItem(L_Way.rwswho_Pool, Tmp01._Who), L, ""
Tmp01._ToPay, L, " |"
Tmp01._ToSheet, L, " ||"
@
|----------|-------|-|-|----|---------|------------------|---|---|
|##########|#######|#|#|####|#########|##################| # | # |
}
*)

(*
$P{ Bot:
@
=(c) Polak========================================================
}
*)

 PRIVATE PROCEDURE InsTmp01(_Who: L_Way.tRWSWho; _ToPay: LIKE(RWayS.ToPay); _ToSheet: LIKE(RWayS.ToSheet));
 BEGIN
  IF ~SELECT(Tmp01, Tmp01, RWayS.Date, RWayS.RWayS, _Who, _ToPay, _ToSheet) THEN
   Tmp01._Date   :=RWayS.Date;
   Tmp01._RWayS  :=RWayS.RWayS;
   Tmp01._Who    :=_Who;
   Tmp01._ToPay  :=_ToPay;
   Tmp01._ToSheet:=_ToSheet;
   INSERT(Tmp01);
  END;
 END {InsTmp01};

BEGIN
 SE_ACCESSDATAMODE(AccessDataMode_SOFT);
 L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
 OPENREP(R, L_General.NameConnection(RepName), Create);
 CONFORM(Staff, Man);
 L_XDoc.sl_Init(" " + Staff.TSN + " -   " +
                L_DatTim.DateStr(Memo.ud_fr()) + "  " +
                L_DatTim.DateStr(Memo.ud_ut()));
 L_AFM.MakeIndex("Tmp01", "_Date: LIKE(RWayS.Date);" +
                             "_RWayS: LIKE(RWayS.RWayS);" +
                             "_Who: SCAL[32];" +
                             "_ToPay: LIKE(RWayS.ToPay);" +
                             "_ToSheet: LIKE(RWayS.ToSheet)");

 MAKEPART(R, Top);
 SELECT(RWayS, TSN, , Staff.TSN);
 SRCINSEL(RWayS, GE, , Memo.ud_fr());
 WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.ud_ut()) DO
  PROMPT(RWayS.RWayS);
  InsTmp01(L_Way.rwswho_Driver, RWayS.ToPay, RWayS.ToSheet);
  NEXT(RWayS);
 END; (* WHILE OCCURE(RWayS)... *)

 SELECT(WayLMen, TSN, , Staff.TSN);
 SRCINSEL(WayLMen, GE, , Memo.ud_fr());
 WHILE OCCURE(WayLMen) & (WayLMen.RWayDate <= Memo.ud_ut()) DO
  CONFORM(WayLMen, RWayS);
  PROMPT(RWayS.RWayS);
  InsTmp01(WayLMen.Who+1, L_Way.GetWLMToPaySign(WayLMen.Who), L_Way.GetWLMToSheetSign(WayLMen.Who));
  NEXT(WayLMen);
 END; (* WHILE OCCURE(WayLMen)... *)

 IF L_Way.E_TckRcLevel(Memo.ud_ut()) THEN
  SELECT(TckRcS, TSN, , Staff.TSN);
  SRCINSEL(TckRcS, GE, , Memo.ud_fr());
  WHILE OCCURE(TckRcS) & (TckRcS.Date <= Memo.ud_ut()) DO
   IF TckRcS.AsWho = L_Way.trs_Chopper THEN
    CONFORM(TckRcS, TckRcJ);
    WHILE OCCURE(TckRcJ) DO
     IF ~!TckRcJ.asRWayS THEN
      SEARCH(RWayS, RWayS, , TckRcJ.asRWayS);
      PROMPT(RWayS.RWayS);
      InsTmp01(L_Way.rwswho_Chopper, TckRcS.ToPay, TckRcS.ToSheet);
     END;
     NEXT(TckRcJ);
    END; (* WHILE OCCURE(TckRcJ) ... *)
   END;
   NEXT(TckRcS);
  END; (* WHILE OCCURE(TckRcS) ... *)
 END;

 SELECT(Tmp01, Tmp01);
 WHILE OCCURE(Tmp01) DO
  SEARCH(RWayS, RWayS, , Tmp01._RWayS);
  MAKEPART(R, Line);
  L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS),
                    L_DatTim.DateStr(RWayS.Date) +
                    " " + RWayS.RWayS  +
                    " " + L_Str.PoolItem(" |", RWayS.Done) +
                    " " + RWayS.Status+
                    " " + RWayS.BoxNbr +
                    " " + RWayS.Exit   +
                    " " + L_Str.PoolItem(L_Way.rwswho_Pool, Tmp01._Who) +
                    " " + L_Str.PoolItem(" |", Tmp01._ToPay) +
                    " " + L_Str.PoolItem(" ||", Tmp01._ToSheet));
  NEXT(Tmp01);
 END; (* WHILE OCCURE(Tmp01) ... *)

 MAKEPART(R, Bot);
 CLOSEREP(R);
 L_XDoc.sl_Done();
 L_AFM.AF_PurgeTemp("Tmp01");
END.
