(*
%Copyright   (c) Polak IT
%Author      03.03.2003 14:02:25 POLAK\LDA
%Purpose     室 ⮯ (᢮)
%Type        report
%Specific    AP
%Modified    16.06.2014 14:30:48 POLAK\GAV
%Environment
*)

 IMPORT L_General, L_Basis, L_Way, D_Fl, FIO, L_Str, Memo, L_Staff,
        L_MathR, L_Fuel, L_Car, L_DatTim, L_AFM, P_Firm, P_Route, L_bp, P_Column;

 VAR
  wMF,
  wMP,
  wASCP: SCAL[2];

 PRIVATE PROCEDURE MakeHeader(F: STRING[]; wo_Details: SCAL[2]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  IF wMP THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "᭮");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ॢ");
  L_Basis.wb_WrInQM(F, " ॢ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " 䨭஢");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "䨪");
  L_Basis.wb_WrInQM(F, "䨪");
  L_Basis.wb_WrInQM(F, "㯯 ப");
  L_Basis.wb_WrInQM(F, "㯯 ப");
  IF wo_Details THEN
   L_Basis.wb_WrInQM(F, "_㯯 ப");
   L_Basis.wb_WrInQM(F, "_㯯 ப");
  ELSE
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "ந⢥ ஡");
   L_Basis.wb_WrInQM(F, "㫥 ஡");
   L_Basis.wb_WrInQM(F, "६  ");
  END;
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ⮯");
  L_Basis.wb_WrInQM(F, " ⮯");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "஡");
  L_Basis.wb_WrInQM(F, "ଠ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "뤠");
  L_Basis.wb_WrInQM(F, "");

  IF wo_Details THEN
   L_Basis.wb_WrInQM(F, "⮪  砫");
   L_Basis.wb_WrInQM(F, "⮪  ");
   L_Basis.wb_WrInQM(F, " ");
   L_Basis.wb_WrInQM(F, "⠦");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "ং");
   L_Basis.wb_WrInQM(F, " १  ");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
   IF wASCP THEN
    L_Basis.wb_WrInQM(F, "");
   END;
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "㯯 ⮢");
   L_Basis.wb_WrInQM(F, " ࠡ");
   L_Basis.wb_WrInQM(F, " ࠡ");
  END;
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F                 : STRING[];
                            wo_Details        : SCAL[2];
                            curTSN,
                            curManName,
                            curSort,
                            curSortName,
                            curTKind,
                            curTKindName,
                            curRgnName,
                            curFnMode,
                            curRoute,
                            curRouteName,
                            curModif,
                            curRoutModName,
                            curMarkG,
                            curMarkGName,
                            CA_MarkG,
                            CA_MarkGName      : STRING[];
                            curRun              : NUMERIC[2];
                            WorkRun,
                            NullRun           : NUMERIC[2];
                            WorkTim           : NUMERIC[3];
                            curFNorm,
                            curFFact          : NUMERIC[4];
                            curRemB           : NUMERIC[4];
                            curTake           : NUMERIC[2];
                            curRet            : NUMERIC[2];
                            curRemE           : NUMERIC[4];
                            curWithDp         : SCAL[2];
                            HasEconomyByBoxNbr: SCAL[2];
                            MchTime           : NUMERIC[3];
                            curASCP           : SCAL[2];
                            curVCor           : LIKE(Route.VCor);
                            curRouteGroup,
                            curWJCode,
                            curWJModeName     : STRING[]);
  VAR
   Economy,
   Overbaking: NUMERIC[4];
 BEGIN
  IF wMF THEN
   CONFORM(Column, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  IF wMP THEN
   SEARCH(MyPlace, MyPlace, , P_Column.GetMyPlace(Column.Column, Memo.ud_ut()));
   L_Basis.wb_WrScl(F, MyPlace.MyPlace);
   L_Basis.wb_WrStr(F, MyPlace.Name);
  END;
  L_Basis.wb_WrScl(F, CarLog.BoxNbr);
  L_Basis.wb_WrStr(F, CarLog.StateNbr);
  L_Basis.wb_WrScl(F, curTSN);
  L_Basis.wb_WrStr(F, curManName);
  L_Basis.wb_WrScl(F, curSort);
  L_Basis.wb_WrStr(F, curSortName);
  L_Basis.wb_WrStr(F, curTKind);
  L_Basis.wb_WrStr(F, curTKindName);
  L_Basis.wb_WrStr(F, curRgnName);
  L_Basis.wb_WrStr(F, curFnMode);
  L_Basis.wb_WrStr(F, curRoute);
  L_Basis.wb_WrStr(F, curRouteName);
  L_Basis.wb_WrStr(F, curModif);
  L_Basis.wb_WrStr(F, curRoutModName);
  L_Basis.wb_WrStr(F, curMarkG);
  L_Basis.wb_WrStr(F, curMarkGName);
  IF wo_Details THEN
   L_Basis.wb_WrStr(F, CA_MarkG);
   L_Basis.wb_WrStr(F, CA_MarkGName);
  ELSE
   L_Basis.wb_WrScl(F, RWayS.RWayS);
   L_Basis.wb_WrDat(F, RWayS.Date);
   L_Basis.wb_WrInQM(F, "ந⢥ ஡");
   L_Basis.wb_WrInQM(F, "㫥 ஡");
   L_Basis.wb_WrInQM(F, "६  ");
  END;
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Basis.wb_WrScl(F, Math.Math);
  L_Basis.wb_WrStr(F, Math.Name);
  IF ~!FL1_2.MainFuel THEN
   SAVE(Math);
   L_MathR.AccessMath(FL1_2.MainFuel);
   L_Basis.wb_WrScl(F, Math.Math);
   L_Basis.wb_WrStr(F, Math.Name);
   RESTORE(Math);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_WrStr(F, Column.Column);
  L_Basis.wb_WrStr(F, Column.Name);
  L_Basis.wb_WrNum(F, curRun, 2);
  L_Basis.wb_WrNum(F, curFNorm, 4);
  L_Basis.wb_WrNum(F, curFFact, 4);
  L_Basis.wb_WrNum(F, curTake, 2);
  L_Basis.wb_WrNum(F, curRet, 2);

  IF wo_Details THEN
   L_Basis.wb_WrNum(F, curRemB, 4);
   L_Basis.wb_WrNum(F, curRemE, 4);
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Car.purp_Pool, CarLog.Purpose));
   L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", curWithDp));
   SETZERO(Economy, Overbaking);
   IF curFNorm > curFFact THEN
    Economy   :=curFNorm - curFFact;
   ELSE
    Overbaking:=curFFact - curFNorm;
   END;
   L_Basis.wb_WrNum(F, Economy, 4);
   L_Basis.wb_WrNum(F, Overbaking, 4);
   L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", HasEconomyByBoxNbr));
   L_Basis.wb_WrNum(F, MchTime, 3);
   L_Basis.wb_WrNum(F, L_Way.GetBakVol(CarLog.BoxNbr, Memo.ud_ut()), 0);
   IF wASCP THEN
    L_Basis.wb_WrInQM(F, L_Str.PoolItem("-|+", curASCP));
   END;
   L_Basis.wb_WrNum(F, curVCor, 0);
   L_Basis.wb_WrStr(F, curRouteGroup);
   L_Basis.wb_WrStr(F, curWJCode);
   L_Basis.wb_WrStr(F, curWJModeName);
  END;
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE MakeRep(RepName: STRING[]; wo_Details: SCAL[2]);
  VAR
   Economy           : NUMERIC[4];
   curTSN,
   curManName,
   curSort,
   curSortName       : STRING[];
   curRemB,
   curRemE           : NUMERIC[4];
   F_MarkG,
   CA_MarkG          : LIKE(MarkG.MarkG);
   _FnMode,
   F_MarkGName,
   CA_MarkGName      : STRING[];
   HasEconomyByBoxNbr: SCAL[2];
 BEGIN
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  MakeHeader("R", wo_Details);

  SELECT(FL1_2, BoxNbr);
  WHILE OCCURE(FL1_2) DO
   PROMPT(" " + FL1_2.BoxNbr);
   IF wo_Details THEN
    SELECT(FL1_1, BoxNbr, , FL1_2.BoxNbr);
    Economy:=0;
    WHILE OCCURE(FL1_1) DO
     INC(Economy, FL1_1.FNorm - FL1_1.FFact);
     NEXT(FL1_1);
    END; (* WHILE OCCURE(FL1_1) *)
    HasEconomyByBoxNbr:=(Economy >= 0);
   ELSE
    SETEMPTY(HasEconomyByBoxNbr);
   END;
   NARROWSEL(FL1_2, BoxNbr);
   WHILE OCCURE(FL1_2) DO
    NARROWSEL(FL1_2, clDate);
    CONFORM(FL1_2, CarLog);
    CONFORM(CarLog, Column);
    CONFORM(CarLog, Mark);
    IF L_Way.StandOnMarkG_Soft(Mark.Mark, L_Way.mgt_CostAccounting) THEN
     CA_MarkG    :=MarkG.MarkG;
     CA_MarkGName:=MarkG.Name;
    ELSE
     SETEMPTY(CA_MarkG);
     CA_MarkGName:="---";
    END;
    IF L_Way.StandOnMarkG_Soft(Mark.Mark, L_Way.mgt_Fuel) THEN
     F_MarkG    :=MarkG.MarkG;
     F_MarkGName:=MarkG.Name;
    ELSE
     SETEMPTY(F_MarkG);
     F_MarkGName:="";
    END;
 
    WHILE OCCURE(FL1_2) DO
     CONFORM(FL1_2, Math);
     IF wo_Details THEN
      curTSN:="----";
      curManName:="-----------------------";
      curSort:="----";
      curSortName:="-----------------------";
      curRemB:=FL1_2.RemB;
      curRemE:=FL1_2.RemE;
     ELSE
      CONFORM(FL1_2, RWayS);
      CONFORM(RWayS, Staff);
      CONFORM(Staff, Man);
      L_Staff.PosToStaffLog(RWayS.TSN, RWayS.Date, 1);
      CONFORM(StaffLog, Sort);
      curTSN:=Staff.TSN;
      curManName:=Man.Name;
      curSort:=Sort.Sort;
      curSortName:=Sort.Name;
      SETZERO(curRemB, curRemE);
     END;
     MakePart("R", wo_Details,
              curTSN, curManName,
              curSort, curSortName,
              "--", "-------------------", "-----",
              "------------",
              "----", "-----------------------",
              "-----", "-----------------------",
              F_MarkG, F_MarkGName,
              CA_MarkG, CA_MarkGName,
              0,
              0,
              0,
              0,
              0,
              0,
              curRemB,
              FL1_2.Take,
              FL1_2.Ret,
              curRemE,
              0,
              HasEconomyByBoxNbr,
              0,
              0,
              EMPTYOF(Route.VCor),
              "------------",
              "--",
              "----");
     IF wo_Details THEN
      SELECT(FL1_1, BoxNbr, , FL1_2.BoxNbr, FL1_2.clDate, FL1_2.Math);
     ELSE
      SELECT(FL1_1, BoxNbr, , FL1_2.BoxNbr, FL1_2.clDate, FL1_2.Math, FL1_2.RWayS);
     END;
     WHILE OCCURE(FL1_1) DO
      CONFORM(FL1_1, Staff);
      CONFORM(Staff, Man);
      CONFORM(FL1_1, Sort);
      CONFORM(FL1_1, Route);
      CONFORM(FL1_1, RoutMod);
      CONFORM(FL1_1, WJMode);
      IF wo_Details THEN
       L_Way.StandOnRouteTKind(Memo.ud_ut());
      ELSE
       L_Way.StandOnRouteTKind(RWayS.Date);
      END;
      IF ~!TKind.FnMode THEN
       _FnMode:=L_Str.PoolItem(L_Way.tkfnm_Pool, TKind.FnMode);
      ELSE
       _FnMode:="";
      END;
      MakePart("R", wo_Details,
               Staff.TSN,   Man.Name,
               Sort.Sort,   Sort.Name,
               TKind.TKind, TKind.Name, L_Str.PoolItem(L_Way.tkrgn_Pool, TKind.Rgn),
               _FnMode,
               Route.Route, Route.Name,
               FL1_1.Modif, RoutMod.Name,
               F_MarkG,     F_MarkGName,
               CA_MarkG,    CA_MarkGName,
               FL1_1.Run,
               FL1_1.WorkRun,
               FL1_1.NullRun,
               FL1_1.WorkTim,
               FL1_1.FNorm,
               FL1_1.FFact,
               0,
               0,
               0,
               0,
               FL1_1.WithDp,
               HasEconomyByBoxNbr,
               FL1_1.MchTime,
               FL1_1.ASCP,
               Route.VCor,
               P_Route.GetRouteProSoft(Route.Route, Memo.ud_ut(), P_Route.P_Group),
               WJMode.WJCode,
               WJMode.Name);
      NEXT(FL1_1);
     END; (* WHILE OCCURE(FL1_1) ... *)
     NEXT(FL1_2);
    END;
    NEXTINEXTENDEDSEL(FL1_2, clDate);
   END; (* WHILE OCCURE(FL1_2) ... *)
   NEXTINEXTENDEDSEL(FL1_2, BoxNbr);
  END; (* WHILE OCCURE(FL1_2) ... *)
  FIO.Close(R);
 END {MakeRep};

 PUBLIC PROCEDURE T0700();
  CONST
   bpId = "T0700";
 BEGIN
  L_bp.Begin(bpId, "  室 ⮯", L_bp.t_Basis, L_General.tc_inIntvl);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  wMP:=P_Firm.E_wMultipleMyPlace(SYSDATE());
  D_Fl.Prepare_FL1();
  wASCP:=L_Way.E_ASCPLev(Memo.ud_ut());
  MakeRep(bpId, 1);
  D_Fl.Purge_FL1();
  L_bp.End();
 END {T0700};

 PUBLIC PROCEDURE T0701();
  CONST
   bpId = "T0701";
 BEGIN
  L_bp.Begin(bpId, "室 ⮯ ( )", L_bp.t_Basis, L_General.tc_inIntvl);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  wMP:=P_Firm.E_wMultipleMyPlace(SYSDATE());
  D_Fl.extPrepare_FL1(0);
  MakeRep(bpId, 0);
  D_Fl.Purge_FL1();
  L_bp.End();
 END {T0701};

END.
