(*
%Copyright   (c) Polak Computer System
%Author      16.04.2002 20:40:09 BOR
%Purpose     ᮪/⪠/ࠡ⪠ 㬥⮢  樨
%Type        operation
%Specific    SYS
%Modified    16.12.2013 22:12:50 POLAK\MLB
%Environment
*)

 MODULE AcMthMD [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Events, L_OwnData, L_MDoc, L_PDoc, L_XDoc, L_AFM, L_MathR,
        L_APtm, L_StdFrm, L_Str, L_Acnt, L_AcMth, Str, Math, Memo, L_Car;

 PRIVATE TYPE
  DocType  = SCAL[Math.Max(MAXOF(PDoc.PDoc), MAXOF(MDoc.MDoc))+1];
  tOrigin  = SCAL[3];
  tPerType = SCAL[2];

 PRIVATE VAR
  _From,
  _UpTo  : DATE;
  Mode   : SCAL[10];
  Origin : tOrigin;
  _Done  : SCAL[2];

 PRIVATE CONST
  o_AcMth  = 0;
  o_AcMthA = 1;
  o_Dest   = 2;

  pt_Month = 0;
  pt_Per   = 1;

  m_Backtracking = 0;
  m_Proceed      = 1;
  m_DocsList     = 2;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
Dest.Dest, L, ""
Dest.Name, L, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
| 樨    ### ################################                                                        |
}
*)

(*
$P{ DGroup_Top:
DGroup.DGroup, L, ""
DGroup.Name, L, ""
@
|㯯 権 ##  ################################################                                        |
}
*)

(*
$P{ MTMM_Top:
MathType.MathType, L, ""
MathType.Name, L, ""
MMode.MMode, L, ""
MMode.Sign, L, ""
MMode.Name, L, ""
@
|  ## ################################################  ### ### ##################################|
}
*)

(*
$P{ SubTopMDoc:
@
|------------------------------------------------------------------------------------------------------------|
|                                                㬥 ᪫                                            |
|------------------------------------------------------------------------------------------------------------|
|㬥                  |                                                            |     ⢮|
|----------------------------|---------------------------------------------------------------|---------------|
}
*)

(*
$P{ LineMDoc:
?, L, ""
?, L, ""
?, L, ""
?, L, "D.N.y"
?, L, ""
ltbam.Math, L, ""
?, L, ""
?, R, ""
?, L, ""
@
|## ### ####### ########## ##|##### #########################################################|########### ###|
}
*)

(*
$P{ SubTopPDoc:
@
|------------------------------------------------------------------------------------------------------------|
|                                            ⥦ 㬥                                             |
|------------------------------------------------------------------------------------------------------------|
|㬥                     |祭                                                     |       㬬|
|-------------------------------|---------------------------------------------------------------|------------|
}
*)

(*
$P{ LinePDoc:
PDoc.PDocKind, L, ""
L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc), L, ""
PDoc.Date, L, "D.N.y"
StatusDone(PDoc.Status, PDoc.Done), L, ""
L_PDoc.PDocAbout(PDoc.PDocKind, PDoc.PDoc), L, ""
PDoc.Total, R, "2-"
@
|## ############## ########## ##|###############################################################|############|
}
*)

(*
$P{ SubTopRollback:
@
|------------------------------------------------------------------------------------------------------------|
|㬥     |      |ਬ砭                                                                         |
}
*)

(*
$P{ SubTopDocKindRollback:
?, L, ""
?, L, ""
?, L, ""
@
|------------------------------------------------------------------------------------------------------------|
| 㬥 ## ### #######################################################################################|
|------------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ LineDocRollback:
?, L, ""
?, L, ""
?, L, "D.N.y"
?, L, ""
@
|### #########|##########|###################################################################################|
}
*)

(*
$P{ SubTopMath:
@
|------------------------------------------------------------------------------------------------------------|
|                                           쥪 ᭮ ।                                         |
|------------------------------------------------------------------------------------------------------------|
|                                                                                    |         |        |
|--------------------------------------------------------------------------------------|----------|----------|
}
*)

(*
$P{ LineMath:
Math.Math, L, ""
Math.Name, L, ""
MathKAGL.Date, L, "D.N.y"
?, L, "D.N.y"
@
|##### ################################################################################|##########|##########|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE m_ProceedXDoc(): SCAL[2];
 BEGIN
  RETURN (Mode = m_Backtracking) | (Mode = m_Proceed);
 END {m_ProceedXDoc};

 PRIVATE PROCEDURE MDocCond(): SCAL[2];
 BEGIN
  IF m_ProceedXDoc() THEN
   IF MDoc.Done = _Done THEN
    RETURN 0;
   END;
  END;
  IF Origin = o_AcMth THEN
   IF ~!MDoc.Math THEN
    CONFORM(MDoc, Math);
    SELECT(AcMthA, AcMth, , AcMth.AcMth);
    WHILE OCCURE(AcMthA) DO
     IF (Math.MathType = AcMthA.MathType) & L_DatTim.IsActive(MDoc.Date, AcMthA.Begin, AcMthA.Till) THEN
      RETURN 1;
     END;
     NEXT(AcMthA);
    END; (* WHILE OCCURE(AcMthA) ... *)
    RETURN 0;
   END;
  ELSIF Origin = o_AcMthA THEN
   IF ~!MDoc.Math THEN
    CONFORM(MDoc, Math);
    RETURN (Math.MathType = AcMthA.MathType) & L_DatTim.IsActive(MDoc.Date, AcMthA.Begin, AcMthA.Till);
   END;
  END;
  RETURN 1;
 END {MDocCond};

 PRIVATE PROCEDURE MDocKindCond(): SCAL[2];
 BEGIN
  IF (Origin = o_AcMth) | (Origin = o_AcMthA) THEN
   RETURN MDocKind.DGroup = AcMth.DGroup;
  ELSE
   RETURN 1;
  END;
 END {MDocKindCond};

 PRIVATE PROCEDURE PDocKindCond(): SCAL[2];
 BEGIN
  IF    Origin = o_AcMth THEN
   RETURN PDocKind.DGroup = AcMth.DGroup;
  ELSIF Origin = o_AcMthA THEN
   RETURN 0;
  ELSE
   RETURN 1;
  END;
 END {MDocKindCond};

 PRIVATE PROCEDURE MDocListCond(): SCAL[2];
 BEGIN
  IF Origin = o_AcMth THEN
   SELECT(AcMthA, AcMth, , AcMth.AcMth);
   WHILE OCCURE(AcMthA) DO
    IF L_DatTim.IsActive(MDoc.Date, AcMthA.Begin, AcMthA.Till) &
       (MDocList.MMode = AcMthA.MMode) &
       (L_MDoc.IsMDoc_woMath(MDocKind.MDocKind) | (Math.MathType = AcMthA.MathType)) THEN
     RETURN 1;
    END;
    NEXT(AcMthA);
   END; (* WHILE OCCURE(AcMthA) ... *)
   RETURN 0;
  ELSIF Origin = o_AcMthA THEN
   RETURN L_DatTim.IsActive(MDoc.Date, AcMthA.Begin, AcMthA.Till) &
          (MDocList.MMode = AcMthA.MMode) &
          (L_MDoc.IsMDoc_woMath(MDocKind.MDocKind) | (Math.MathType = AcMthA.MathType));
  END;
  RETURN 1;
 END {MDocListCond};

 PRIVATE PROCEDURE PDocwMDocCond(): SCAL[2];
 BEGIN
  IF L_PDoc.IsPDocwMDoc() THEN
   SELECT(PDocMDoc, PDoc, , PDoc.PDocKind, PDoc.PDoc);
   WHILE OCCURE(PDocMDoc) DO
    SEARCH(MDoc, MDoc, , PDocMDoc.MDocKind, PDocMDoc.MDoc);
    IF MDoc.Dest = Dest.Dest THEN
     RETURN 1;
    END;
    NEXT(PDocMDoc);
   END; (* WHILE OCCURE(PDocMDoc) ... *)
  END;
  RETURN 0;
 END {PDocwMDocCond};

 PRIVATE PROCEDURE PDocCond(): SCAL[2];
 BEGIN
  IF m_ProceedXDoc() THEN
   IF PDoc.Done = _Done THEN
    RETURN 0;
   END;
  END;
  RETURN 1;
 END {PDocCond};

 PRIVATE PROCEDURE MathKAGLCond(PerType: tPerType): SCAL[2];
 BEGIN
  IF ~m_ProceedXDoc() THEN
   IF    (Origin = o_AcMth) & (PerType = pt_Per) THEN
    RETURN (AcMth.DGroup = L_MDoc.DG_Use) | (AcMth.DGroup = L_MDoc.DG_Amr);
   ELSIF (Origin = o_Dest) & (PerType = pt_Per) THEN
    RETURN 1;
   END;
  END;
  RETURN 0;
 END {MathKAGLCond};

 PRIVATE PROCEDURE AddItem(DT: L_XDoc.tXDocType);
 BEGIN
  SAVE(Dest);
  IF    DT = L_XDoc.xdt_MDoc THEN
   CONFORM(MDoc, Dest);
   L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc),
                     L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) +
                     "    " + L_DatTim.DateStr(MDoc.Date) +
                     " " + MDoc.Dest+" "+Dest.Name);
  ELSIF DT = L_XDoc.xdt_PDoc THEN
   CONFORM(PDoc, Dest);
   L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc),
                     L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc) +
                     " " + L_DatTim.DateStr(PDoc.Date) +
                     " " + PDoc.Dest+" "+Dest.Name);
  ELSE
   L_General.CallUs(0);
  END;
  RESTORE(Dest);
 END {AddItem};

 PRIVATE PROCEDURE StatusDone(_Status: LIKE(PDoc.Status); _Done: LIKE(PDoc.Done)): STRING[];
 BEGIN
  RETURN L_Str.PoolItem("||", _Status) + L_Str.PoolItem(" |", _Done);
 END {StatusDone};

 PRIVATE PROCEDURE Prepare_ltbam(PerType: tPerType);
 BEGIN
  APP.Get().NewPrompt("");
  L_AcMth.ltbam_MakeIndex(_From, _UpTo, Dest.Dest,
                          PROCREF(MDocKindCond), PROCREF(MDocCond), PROCREF(MDocListCond),
                          PROCREF(PDocKindCond), PROCREF(PDocCond));
  IF MathKAGLCond(PerType) THEN
   SELECT(MathKAGL, Dest, , Dest.Dest);
   WHILE OCCURE(MathKAGL) DO
    PROMPT(" " + MathKAGL.Math);
    IF L_DatTim.IsActiveInIntvl_Inc(MathKAGL.Date, MathKAGL.DateE, _From, _UpTo) THEN
     ADD(ltbam, DocDate, , L_XDoc.xdt_Math, "", MathKAGL.Date, "", MathKAGL.Math, "");
    END;
    NEXT(MathKAGL);
   END; (* WHILE OCCURE(MathKAGL) ... *)
  END;
 END {Prepare_ltbam};

 PRIVATE PROCEDURE DoByAcMth(RepName: STRING[]; PerType: tPerType);
  VAR
   PrevMDocKind: LIKE(MDoc.MDocKind);
   PrevMDoc    : DocType;
   MathName    : LIKE(Math.Name);
   MUnitSign   : LIKE(MUnit.Sign);
   FormatCir   : STRING[];
   Title       : STRING[];
   FirstLine   : SCAL[2];
   DE          : DATE;
   Err         : STRING[];
 BEGIN
  APP.Get().NewPrompt("("+RepName+")");
  IF m_ProceedXDoc() THEN
   Title:=" 㤠 "+L_Str.PoolItem("⪠|ࠡ", _Done) +
          " 㬥  ਮ  "+L_DatTim.DateStr(_From)+
          "  "+L_DatTim.DateStr(_UpTo);
  ELSE
   Title:="㬥  ਮ  "+ L_DatTim.DateStr(_From)+"  "+L_DatTim.DateStr(_UpTo);
  END;
  L_XDoc.sl_Init(Title);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, Title);
  IF    Origin = o_AcMth THEN
   MAKEPART(R, DGroup_Top);
   SELECT(AcMthA, AcMth, , AcMth.AcMth);
   WHILE OCCURE(AcMthA) DO
    CONFORM(AcMthA, MathType);
    CONFORM(AcMthA, MMode);
    MAKEPART(R, MTMM_Top);
    NEXT(AcMthA);
   END; (* WHILE OCCURE(AcMthA) ... *)
  ELSIF Origin = o_AcMthA THEN
   CONFORM(AcMthA, MathType);
   CONFORM(AcMthA, MMode);
   MAKEPART(R, MTMM_Top);
  END;

  IF m_ProceedXDoc() THEN
   MAKEPART(R, SubTopRollback);
  END;

  Prepare_ltbam(PerType);

  SETEMPTY(PrevMDocKind, PrevMDoc);
  IF SELECT(ltbam, DocDate, L_XDoc.xdt_MDoc) THEN
   IF ~m_ProceedXDoc() THEN
    MAKEPART(R, SubTopMDoc);
   END;
   WHILE OCCURE(ltbam) DO
    IF m_ProceedXDoc() THEN
     IF ltbam.DocKind # PrevMDocKind THEN
      PrevMDocKind:=ltbam.DocKind;
      SEARCH(MDocKind, MDocKind, , ltbam.DocKind);
      MAKEPART(R, SubTopDocKindRollback, MDocKind.MDocKind, MDocKind.Sign, MDocKind.Name);
     END;
     PROMPT(MDocKind.Sign + " " + ltbam.Doc);
     SEARCH(MDoc, MDoc, , ltbam.DocKind, ltbam.Doc);
     TRY [TRANSACTION(TRANSACTION_SLAVE)]
      IF _Done THEN
       CALL(MDoc.StreamMakeDone());
      ELSE
       CALL(MDoc.StreamMakeUnDone());
      END;
     EXCEPT
     ON Exc:Exc_Root DO
      Err:=Exc.Description;
     END; (* TRY *)
     IF MDoc.Done # _Done THEN
      MAKEPART(R, LineDocRollback, MDocKind.Sign, MDoc.MDoc, MDoc.Date, Err);
      AddItem(L_XDoc.xdt_MDoc);
     END;
     NARROWSEL(ltbam, DocKind, Date, Doc);
     NEXTINEXTENDEDSEL(ltbam, DocKind, Date, Doc);
    ELSE
     PROMPT(": " + ltbam.DocKind + " " + ltbam.Doc);
     IF ~!ltbam.Math THEN
      CONFORM(ltbam, Math);
      MathName :=Math.Name;
      FormatCir:=L_MathR.DefaultFormatCir(ltbam.Math, ltbam.Num);
      MUnitSign:=L_MathR.DefaultMUnitSign(ltbam.Math);
     ELSE
      MathName :="";
      FormatCir:=FLDTOSTR(ltbam.Num, "2.");
      MUnitSign:="";
     END;
     IF (ltbam.DocKind # PrevMDocKind) | (ltbam.Doc # PrevMDoc) THEN
      PrevMDocKind:=ltbam.DocKind;
      PrevMDoc    :=ltbam.Doc;
      SEARCH(MDoc, MDoc, , ltbam.DocKind, ltbam.Doc);
      CONFORM(MDoc, MDocKind);
      MAKEPART(R, LineMDoc, ltbam.DocKind, MDocKind.Sign, ltbam.Doc, ltbam.Date,
                            StatusDone(MDoc.Status, MDoc.Done),
                            MathName, FormatCir, MUnitSign);
      AddItem(L_XDoc.xdt_MDoc);
     ELSE
      MAKEPART(R, LineMDoc, , , , , ,
                            MathName, FormatCir, MUnitSign);
     END;
     NEXT(ltbam);
    END;
   END; (* WHILE OCCURE(ltbam) ... *)
  END;

  IF SELECT(ltbam, DocDate, L_XDoc.xdt_PDoc) THEN
   IF ~m_ProceedXDoc() THEN
    MAKEPART(R, SubTopPDoc);
   END;
   WHILE OCCURE(ltbam) DO
    NARROWSEL(ltbam, DocKind);
    IF m_ProceedXDoc() THEN
     SEARCH(PDocKind, PDocKind, , ltbam.DocKind);
     MAKEPART(R, SubTopDocKindRollback, PDocKind.PDocKind, PDocKind.Sign, PDocKind.Name);
    END;
    WHILE OCCURE(ltbam) DO
     SEARCH(PDoc, PDoc, , ltbam.DocKind, ltbam.Doc);
     IF m_ProceedXDoc() THEN
      PROMPT(PDocKind.Sign + " " + ltbam.Doc);
      TRY [TRANSACTION(TRANSACTION_SLAVE)]
       IF _Done THEN
        CALL(PDoc.StreamMakeDone());
       ELSE
        CALL(PDoc.StreamMakeUnDone());
       END;
      EXCEPT
      ON Exc:Exc_Root DO
       Err:=Exc.Description;
      END; (* TRY *)
      IF PDoc.Done # _Done THEN
       MAKEPART(R, LineDocRollback, PDocKind.Sign, PDoc.PDoc, PDoc.Date, Err);
       AddItem(L_XDoc.xdt_PDoc);
      END;
     ELSE
      PROMPT(": "+ltbam.DocKind + " " + ltbam.Doc);
      MAKEPART(R, LinePDoc);
      AddItem(L_XDoc.xdt_PDoc);
     END;
     NEXT(ltbam);
    END; (* WHILE OCCURE(ltbam) ... *)
    NEXTINEXTENDEDSEL(ltbam, DocKind);
   END; (* WHILE OCCURE(ltbam) ... *)
  END;

  IF SELECT(ltbam, MathKAGL, L_XDoc.xdt_Math) THEN
   MAKEPART(R, SubTopMath);
   WHILE OCCURE(ltbam) DO
    PROMPT(": " + ltbam.Math);
    CONFORM(ltbam, Math);
    SEARCH(MathKAGL, Math, , Math.Math, ltbam.Date);
    DE:=Math.Min(MathKAGL.DateE, L_MathR.GetKeyAssASpDate(Math.Math));
    IF DE >= _From THEN
     MAKEPART(R, LineMath, DE);
    END;
    NEXT(ltbam);
   END; (* WHILE OCCURE(ltbam) ... *)
  END;
  MAKEPART(R, Bot);
  L_AcMth.ltbam_Purge();
  CLOSEREP(R);
  L_XDoc.sl_Done();
 END {DoByAcMth};

 PRIVATE PROCEDURE ProceedXDoc(RepName: STRING[]; trgOrigin: tOrigin; pm: L_XDoc.tProceedManner);
 BEGIN
  Origin:=trgOrigin;
  IF    Origin = o_AcMth THEN
   L_General.Assert(ACCESS(AcMth), " ⠭ 奬 樨");
  ELSIF Origin = o_AcMthA THEN
   L_General.Assert(ACCESS(AcMthA), " ⠭ ਬ 奬 樨");
   CONFORM(AcMthA, AcMth);
  ELSE
   L_Generl.CallUs(0);
  END;
  CONFORM(AcMth, Dest);
  CONFORM(AcMth, DGroup);
  _From:=Memo.ud_mb();

  IF    pm = L_XDoc.pm_Proceed THEN
   _Done:=1;
   Mode :=m_Proceed;
  ELSIF pm = L_XDoc.pm_Backtracking THEN
   _Done:=0;
   Mode :=m_Backtracking;
  ELSE
   L_General.CallUs(0);
  END;
  IF L_XDoc.AskForXDocProceed(pm, "㬥", 0) THEN
   _UpTo:=L_DatTim.MonthEnd(SYSDATE());
  ELSE
   _UpTo:=Memo.ud_me();
  END;
  DoByAcMth(RepName, EMPTYOF(tPerType));
 END {ProceedXDoc};

 PRIVATE PROCEDURE AskForXDocList(): SCAL[2];
  VAR
   Blank,
   PoolIns,
   AddBtnsBlank,
   AddBtnsPoolIns: STRING[];
 BEGIN
  Blank:="|" + "㬥  ਮ" +
         "||" +
         " " + L_DatTim.PeriodStr(Memo.ud_mb());
  SETEMPTY(PoolIns, AddBtnsBlank, AddBtnsPoolIns);
  IF L_DatTim.Per(SYSDATE()) > Memo.ud_mb() THEN
   AddBtnsPoolIns:="%C<{} " + L_DatTim.PeriodStr(SYSDATE()) + ">B";
   AddBtnsBlank  :="%##########%";
  END;
  RETURN STDFORM(L_StdFrm.sf_Choice_wAddBtns(Blank, PoolIns, AddBtnsBlank, AddBtnsPoolIns),
                  "",
                  QUESTION) = 2;
 END {AskForXDocList};

 PRIVATE PROCEDURE MakeRep(RepName: STRING[]; trgOrigin: tOrigin; PerType: tPerType);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  Origin:=trgOrigin;
  IF    Origin = o_Dest THEN
   L_General.Assert(ACCESS(Dest), " ⠭  樨");
  ELSIF Origin = o_AcMth THEN
   L_General.Assert(ACCESS(AcMth), " ⠭ 奬 樨");
   CONFORM(AcMth, Dest);
   CONFORM(AcMth, DGroup);
  ELSIF Origin = o_AcMthA THEN
   L_General.Assert(ACCESS(AcMthA), " ⠭ ");
   CONFORM(AcMthA, AcMth);
   CONFORM(AcMth, Dest);
   CONFORM(AcMth, DGroup);
  ELSE
   L_General.CallUs(0);
  END;
  Mode:=m_DocsList;
  IF    PerType = pt_Per THEN
   L_General.SetIntvlByIntvl(_From, _UpTo);
  ELSIF PerType = pt_Month THEN
   _From:=Memo.ud_mb();
   IF AskForXDocList() THEN
    _UpTo:=L_DatTim.MonthEnd(SYSDATE());
   ELSE
    _UpTo:=Memo.ud_me();
   END;
  ELSE
   L_General.CallUs(0);
  END;
  DoByAcMth(RepName, PerType);
 END {MakeRep};

 PUBLIC PROCEDURE AcDoR();
 BEGIN
  ProceedXDoc("AcDoR", o_AcMth, L_XDoc.pm_Backtracking);
 END {AcDoR};

 PUBLIC PROCEDURE AcDoM();
 BEGIN
  ProceedXDoc("AcDoM", o_AcMth, L_XDoc.pm_Proceed);
 END {AcDoM};

 PUBLIC PROCEDURE AADoM();
 BEGIN
  ProceedXDoc("AADoM", o_AcMthA, L_XDoc.pm_Proceed);
 END {AADoM};

 PUBLIC PROCEDURE AADoR();
 BEGIN
  ProceedXDoc("AADoR", o_AcMthA, L_XDoc.pm_Backtracking);
 END {AADoR};

 PUBLIC PROCEDURE AcDoP();
 BEGIN
  MakeRep("AcDoA", o_AcMth, pt_Per);
 END {AcDoP};

 PUBLIC PROCEDURE AADoP();
 BEGIN
  MakeRep("AADoP", o_AcMthA, pt_Per);
 END {AADoP};

 PUBLIC PROCEDURE AADoA();
 BEGIN
  MakeRep("AADoA", o_AcMthA, pt_Month);
 END {AADoA};

 PUBLIC PROCEDURE AcDoA();
 BEGIN
  MakeRep("AcDoA", o_AcMth, pt_Month);
 END {AcDoA};

 PUBLIC PROCEDURE ADDoP();
 BEGIN
  MakeRep("ADDoP", o_Dest, pt_Per);
 END {ADDoP};

END.
