(*
%Copyright   (c) Polak Computer System
%Author      11.04.1997 14:32:52 GINA
%Purpose     ନ஢   
%Type        operation
%Specific    SYS
%Modified    17.09.2014 20:04:54 POLAK\Bor
%Environment
*)

 MODULE Ank [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Russia, L_Basis, L_Man, L_Str,
        L_AFM, L_StdFrm, Str, P_OwnData, L_Packet, L_XML, L_SFee, L_Staff;

 TYPE
  tFlag           = SCAL[2][7];
  tBthAddrElement = SCAL[4];

 CONST
  patt_Flag = "ADVFlag";

  PagLength = 50;
  SLen      = 47;

  p_Fml   = 0;
  p_Nam   = 1;
  p_Otc   = 2;
  p_Sex   = 3;
  p_BtD   = 4;
  p_BtA   = 5;
  p_Other = 6;

  baa_Town    = 0;
  baa_Distr   = 1;
  baa_Region  = 2;
  baa_Country = 3;

 VAR
  SingleMode : SCAL[2];
  AnkRepName,
  PACKRepName: STRING[];
  Flag       : tFlag;
  CurPacket  : L_Packet.tPFExtNbr;
  CurNumInP  : NUMERIC[0];
  VarByPacket: SCAL[3];
  PerB,
  PerE: DATE;

(*
$P{ ADV1:
Packet.ExtNbr, R, "", "U"
CurNumInP, R, "", "U"
?, L, "", "U"
?, L, "", "U"
?, L, "", "U"
@
                                     N 窨 #####   N  窥 ###
ଠ -1                                   

                     

   ###############################################

       ###############################################

⢮  ###############################################

}
*)

(*
$P{ ADVx_1:
?, L, "", "U"
?, L, "", "U"
?, L, "", "U"
?, L, "", "U"
?, L, "", "U"
?, L, "", "U"
@
       #

 ஦  #######################

 ஦:

   த (ᥫ, .) ############################################

   ࠩ              ############################################

   
   (ࠩ, ., ...) ############################################

   ࠭             ############################################

}
*)

(*
$P{ ADVx_2:
?, L, "", "U"
@
ࠦ⢮  ###############################################

}
*)

(*
$P{ ADVx_3:
?, L, "", "U"
?, L, "", "U"
?, L, "", "U"
?, L, "", "U"
?, L, "", "U"
?, L, "", "U"
?, L, "", "U"
?, L, "", "U"
?, L, "", "U"
?, L, "", "U"
"", L, "", "U"
@
 ﭭ  ⥫⢠

         ######

ॣ樨   ###############################################

                   ###############################################

                   ###############################################

                   ###############################################

    ######

⥫⢠    ###############################################
   
䠪᪨        ###############################################
   
                   ###############################################
   
                   ###############################################

䮭           ################################

}
*)

(*
$P{ ADVx_4:
CS(GetManDocName(Man.DocType, 1)), L, "", "U"
CS(Man.PspSer) + "  " + CS(Man.PspNbr), L, "", "U"
CS(L_DatTim.FullDateStr(Man.PspGiveD)), L, "", "U"
?, L, "", "U"
?, L, "", "U"
?, L, "", "U"
CS(L_DatTim.FullDateStr(L_Packet.PrepareDate)), L, "", "U"
@
㬥, 㤮⮢騩 筮:

 㬥    ###############################################

,      ###############################################

 뤠      #######################

 뤠        ###############################################

                 ###############################################

                 ###############################################

              筠 

#######################     客  _______________

}
*)

(*
$P{ ADV2:
Packet.ExtNbr, R, "", "U"
CurNumInP, R, "", "U"
L_Packet.SINumberToAnyOut(Man.SINumber), L, "", "U"
?, L, "", "U"
?, L, "", "U"
?, L, "", "U"
?, L, "", "U"
?, L, "", "U"
?, L, "", "U"
@
                                     N 窨 #####   N  窥 ###
ଠ -2                                  

    

 客 殬 묨 㪢.

客   #################

..., 㪠  客 ᢨ⥫⢥

   ###############################################

       ###############################################

⢮  ###############################################

   (㪠 ⮫쪮 訥 )

   ###############################################

       ###############################################

⢮  ###############################################

}
*)

(*
$P{ ADV3_1:
Packet.ExtNbr, R, "", "U"
CurNumInP, R, "", "U"
?, L, "", "U"
?, L, "", "U"
?, L, "", "U"
@
                                     N 窨 #####   N  窥 ###
ଠ -3                                  

     

 客 殬 묨 㪢.

, 㪠  客 ᢨ⥫⢥

   ###############################################

       ###############################################

⢮  ###############################################

}
*)

(*
$P{ ADV3_2:
?, L, "", "U"
?, L, "", "U"
?, L, "", "U"
@
, ⢨⥫  饥 ६ (㪠 ⮫쪮

訥 )

   ###############################################

       ###############################################

⢮  ###############################################

}
*)

(*
$P{ ADV3_3:
L_Packet.SINumberToAnyOut(Man.SINumber), L, "", "U"
?, L, "", "U"
L_Packet.OwnLeadPostName, L, "", "U"
L_Str.ShortName(L_Packet.OwnLeadName), L, "", "U"
L_Packet.PrepareDate, L, "D.N.y", "U"
@
----------------------------------------------------------------

 客⥫ (ࠡ⮤⥫)

,   客     客 ᢨ⥫⢮

㤠⢥ ᨮ  客    客  ஬

##############,   ᭮  ண  ᢥ    ⠦  

ࠡ⪥ ################################

  㪮⥫    ஢ 

###################################           ###################

 ##########}
*)

 PRIVATE PROCEDURE AddStr(VAR S: STRING[]; s: STRING[]; Prefix, Suffix: STRING[16]);
  VAR t: STRING[];
 BEGIN
  IF ~!s THEN
   IF ~!S THEN
    S:=S+",";
   END;
   t:=s;
   IF ~!Prefix THEN
    t:=Prefix+t;
   END;
   IF ~!Suffix THEN
    t:=t+Suffix;
   END;
   IF ~!S THEN
    S:=S+t;
   ELSE
    S:=t;
   END;
  END;
 END {AddStr};

 PRIVATE PROCEDURE Address(): STRING[];
  VAR
   S: STRING[];
 BEGIN
  S:="";
  IF ~!ManAdr.Country & (ManAdr.Country # L_Russia.c_Russia) THEN
   CONFORM(ManAdr, Country);
   AddStr(S, Country.Name, " ", "");
  END;
  IF ManAdr.Region # 0 THEN
   AddStr(S, L_Russia.RegionN_InPFRFormat(ManAdr.Region), " ", " "+L_Russia.RegionT_InPFRFormat(ManAdr.Region));
  ELSE
   AddStr(S, ManAdr.RegionN, " ", "");
  END;
  AddStr(S, ManAdr.Distr, " ", " -");
  IF ~!ManAdr.TownT THEN
   AddStr(S, ManAdr.Town, " ", " "+L_Russia.TownT_InMNSFormat(ManAdr.TownT));
  ELSE
   AddStr(S, ManAdr.Town, " ", "");
  END;
  IF ~!ManAdr.VillageT THEN
   AddStr(S, ManAdr.Village, " ", " "+L_Russia.VillageT_InMNSFormat(ManAdr.VillageT));
  ELSE
   AddStr(S, ManAdr.Village, " ", "");
  END;
  IF ~!ManAdr.StreetT THEN
   AddStr(S, ManAdr.Street, " ", " "+L_Russia.StreetT_InMNSFormat(ManAdr.StreetT));
  ELSE
   AddStr(S, ManAdr.Street, " ", "");
  END;
  AddStr(S, ManAdr.House, " .", "");
  AddStr(S, ManAdr.Block, " .", "");
  AddStr(S, ManAdr.Build, " .", "");
  AddStr(S, ManAdr.Flat, " .", "");
  RETURN Str.Condense(S);
 END {Address};

 PRIVATE PROCEDURE CollectAdr(_AdrType: LIKE(ManAdr.AdrType)): STRING[];
  VAR
   Dummy : SCAL[2];
   _Str  : STRING[];
 BEGIN
  Dummy:=L_Man.AccessManAdr(Man.Man, L_Packet.PrepareDate, _AdrType);
  _Str:=Address();
  L_General.Assert(Str.Length(_Str) <= 200,
                   " 墠⠥    "+L_Man.GetManAdrType_asStr(_AdrType));
  RETURN _Str;
 END {CollectAdr};

 PRIVATE PROCEDURE CS(S: STRING[]): STRING[];
 BEGIN
  IF ~!S THEN
   L_General.Assert(Str.Pos(S, '"') = Str.Length(S), "⨬ 窨|ப "+S);
   RETURN Str.Cap(S);
  ELSE
   RETURN "";
  END;
 END {CS};

 PRIVATE PROCEDURE Test();
  VAR
   Dummy: STRING[];
 BEGIN
  L_Man.StrongAccessManAdr(Man.Man, L_Packet.PrepareDate, L_Russia.at_BthMA); CALL(ManAdr.TestAdr());
  L_Man.StrongAccessManAdr(Man.Man, L_Packet.PrepareDate, L_Russia.at_RgMA);  CALL(ManAdr.TestAdr());
  IF L_Man.AccessManAdr(Man.Man, L_Packet.PrepareDate, L_Russia.at_DwMA) THEN
   CALL(ManAdr.TestAdr());
  END;
  Dummy:=L_Man.CheckDocument();
  IF ~!Dummy THEN
   L_General.Error(Dummy);
  END;
 END {Test};

 PRIVATE PROCEDURE GetManDocName(_DocType: LIKE(Man.DocType); Full: SCAL[2]): STRING[];
 BEGIN
  IF    _DocType = 00 THEN RETURN L_Str.PoolItem("|ᯮ ࠦ ", Full);
  ELSIF _DocType = 01 THEN RETURN L_Str.PoolItem("  |⥫⢮  ஦", Full);
  ELSIF _DocType = 02 THEN RETURN L_Str.PoolItem(" |६ 㤮⮢७ 筮 ࠦ ᨩ᪮ 樨", Full);
  ELSIF _DocType = 03 THEN RETURN L_Str.PoolItem("  |ࠢ  ᢮   襭 ᢮", Full);
  ELSIF _DocType = 04 THEN RETURN L_Str.PoolItem(" |  ᮫ (, ঠ, 設)", Full);
  ELSIF _DocType = 05 THEN RETURN L_Str.PoolItem("|࠭ ᯮ", Full);
  ELSIF _DocType = 06 THEN RETURN L_Str.PoolItem(" |⥫⢮  ॣ樨 室⠩⢠  ਧ ࠭ 楬", Full);
  ELSIF _DocType = 07 THEN RETURN L_Str.PoolItem(" |⮢७   ᨩ᪮ 樨", Full);
  ELSIF _DocType = 08 THEN RETURN L_Str.PoolItem(" |ᯮ ࠦ ᨨ", Full);
  ELSIF _DocType = 09 THEN RETURN L_Str.PoolItem(" |⮢७ 筮 ", Full);
  ELSIF _DocType = 10 THEN RETURN L_Str.PoolItem("|࠭ᯮ ࠦ ", Full);
  ELSIF _DocType = 11 THEN RETURN L_Str.PoolItem(" |࠭ᯮ ࠦ ᨩ᪮ 樨", Full);
  ELSIF _DocType = 12 THEN RETURN L_Str.PoolItem("  |  ⥫⢮", Full);
  ELSIF _DocType = 13 THEN RETURN L_Str.PoolItem(" |ᯮ 䫮", Full);
  ELSIF _DocType = 14 THEN RETURN L_Str.PoolItem(" |ᯮ 猪", Full);
  ELSIF _DocType = 15 THEN RETURN L_Str.PoolItem("  |   ", Full);
  ELSIF _DocType = 16 THEN RETURN L_Str.PoolItem(" |᪨ ᯮ ࠦ ᨩ᪮ 樨", Full);
  ELSIF (_DocType = 17) |
        (_DocType = 18) THEN RETURN L_Str.PoolItem("| 㬥, 뤠 ࣠ ", Full);
  ELSE
   L_General.CallUs(0);
  END;
 END {GetManDocName};

 PRIVATE PROCEDURE _Citizenship(_Man: LIKE(Man.Man); D: DATE): STRING[];
 BEGIN
  IF ~L_Man.AccessManAdr(_Man, D, L_Russia.at_CtMA) THEN
   L_Man.StrongAccessManAdr(_Man, D, L_Russia.at_RgMA);
  END;
  IF ManAdr.Country # L_Russia.c_Russia THEN
   CONFORM(ManAdr, Country);
   RETURN Country.Name;
  ELSE
   RETURN "";
  END;
 END {_Citizenship};

 PRIVATE PROCEDURE GetBthCountryN(): LIKE(Country.Name);
 BEGIN
  IF (ManAdr.Country = L_Russia.c_USSR) | (ManAdr.Country = L_Russia.c_Russia) THEN
   RETURN "";
  ELSE
   CONFORM(ManAdr, Country);
   RETURN Country.Name;
  END;
 END {GetBthCountryN};

 PRIVATE PROCEDURE GetBthRegionN(): LIKE(ManAdr.RegionN);
 BEGIN
  IF (ManAdr.Region = L_Russia.reg_Moscow) | (ManAdr.Region = L_Russia.reg_StPetersburg) THEN
   RETURN "";
  ELSE
   RETURN L_Man.RegionNameMeanCapital();
  END;
 END {GetBthRegionN};

 PRIVATE PROCEDURE GetBthTownN(): STRING[];
 BEGIN
  IF    ~!ManAdr.Town                             THEN RETURN ManAdr.Town;
  ELSIF ~!ManAdr.Village                          THEN RETURN ManAdr.Village;
  ELSIF ManAdr.Region = L_Russia.reg_Moscow       THEN RETURN "᪢";
  ELSIF ManAdr.Region = L_Russia.reg_StPetersburg THEN RETURN "-";
  ELSE                                                 RETURN "";
  END;
 END {GetBthTownN};

 PRIVATE PROCEDURE intGetBthAddrArr(VAR BthAdrType: STRING[]): STRING[][MAXOF(tBthAddrElement)+1];
  VAR
   Result    : STRING[][MAXOF(tBthAddrElement)+1];
   SpecBthAdr: SCAL[2];
   i         : tBthAddrElement;
 BEGIN
  BthAdrType:="";
  Result[baa_Town]   :=GetBthTownN();
  Result[baa_Distr]  :=ManAdr.Distr;
  Result[baa_Region] :=GetBthRegionN();
  Result[baa_Country]:=GetBthCountryN();
  SpecBthAdr:=1;
  FOR_EACH i DO
   IF !Result[i] THEN
    SpecBthAdr:=0;
    EXIT;
   END;
  END;
  IF SpecBthAdr THEN (*   ᨬ      0104976 17.09.2014 19:59:40 POLAK\Bor*)
   BthAdrType:="";
   Result[baa_Region]:=Result[baa_Region]+" "+Result[baa_Country];
   Result[baa_Country]:="";
  END;
  RETURN Result;
 END {intGetBthAddrArr};

 PRIVATE PROCEDURE GetBthAddrElm(i: tBthAddrElement): STRING[];
  VAR
   BthAdrArr: STRING[][MAXOF(tBthAddrElement)+1];
   Dummy    : STRING[];
 BEGIN
  BthAdrArr:=intGetBthAddrArr(Dummy);
  RETURN BthAdrArr[i];
 END {GetBthAddrArr};

 PRIVATE PROCEDURE HasTransferedPacket(): SCAL[2];
 BEGIN
  RETURN L_Packet.HasDonePacket(Man.Man, L_Packet.knd_PF_SZV6)   |
         L_Packet.HasDonePacket(Man.Man, L_Packet.knd_PF_SZV6_3) |
         L_Packet.HasDonePacket(Man.Man, L_Packet.knd_PF_SZV4)   |
         L_Packet.HasDonePacket(Man.Man, L_Packet.knd_PF_SZV3)   |
         L_Packet.HasDonePacket(Man.Man, L_Packet.knd_PF_SZV1)   |
         L_Packet.HasDonePacket(Man.Man, L_Packet.knd_PF_SZVK);
 END {HasTransferedPacket};

 PRIVATE PROCEDURE PrintOnList();
  VAR
   TMP1,
   TMP2     : STRING[SLen];
   SArr1,
   SArr2    : STRING[SLen][4];
   _SIN     : LIKE(Man.SINumber);
   MaxPacket,
   _Packet,
   i        : NUMERIC[0];
   _Village : LIKE(ManAdr.Village);
   _Name    : STRING[];
   Surname,
   FirstName,
   Patronymic,
   curSurname,
   curFirstName,
   curPatronymic: STRING[];
 BEGIN
  SetPrintAttr(R, MaxPages, 1);
  IF SingleMode THEN
   L_Packet.MakeProjectPrt();
  END;
  L_Man.StrongAccessManAdr(Man.Man, L_Packet.PrepareDate, L_Russia.at_BthMA);
  _Name:=L_Packet.GetManInPFRFName(L_Packet.PrepareDate);
  L_Str.SplitManName(_Name, Surname, FirstName, Patronymic);
  IF Packet.Kind = L_Packet.knd_PF_ADV1 THEN
   MAKEPART(R, ADV1,   CS(Surname),
                       CS(FirstName),
                       CS(Patronymic));
   MAKEPART(R, ADVx_1, Str.Item("|", "|", Man.Sex),
                       CS(L_DatTim.FullDateStr(Man.Birth)),
                       CS(GetBthAddrElm(baa_Town)),
                       CS(GetBthAddrElm(baa_Distr)),
                       CS(GetBthAddrElm(baa_Region)),
                       CS(GetBthAddrElm(baa_Country)));
  ELSE
   L_General.Assert(L_SFee.ManHasSINumber(), " ଫ ⮫쪮  ,  ");
   SETEMPTY(SArr1, TMP1, TMP2);
   L_Man.curMan_SplitName(curSurname, curFirstName, curPatronymic);
   IF Flag[p_Fml] THEN
    SArr1[0]:=curSurname;
   END;
   IF Flag[p_Nam] THEN
    SArr1[1]:=curFirstName;
   END;
   IF Flag[p_Otc] THEN
    IF ~!curPatronymic THEN
     SArr1[2]:=curPatronymic;
    ELSE
     SArr1[2]:="⬥";
    END;
   END;
   IF Flag[p_Sex] THEN
    TMP1:=Str.Item("|", "|", Man.Sex);
   END;
   IF Flag[p_BtD] THEN
    TMP2:=L_DatTim.FullDateStr(Man.Birth);
   END;
   IF Packet.Kind = L_Packet.knd_PF_ADV2 THEN
    MAKEPART(R, ADV2,   CS(Surname),  CS(FirstName), CS(Patronymic),
                        CS(SArr1[0]), CS(SArr1[1]),  CS(SArr1[2]));
   ELSE
    IF Flag[p_BtA] THEN
     L_Man.StrongAccessManAdr(Man.Man, ManAdr.Date-1, L_Russia.at_BthMA);
    END;
    MAKEPART(R, ADV3_1, CS(Surname),
                        CS(FirstName),
                        CS(Patronymic));
    MAKEPART(R, ADVx_1, Str.Item("|", "|", Man.Sex # Flag[p_Sex] (* XOR*)),
                        CS(L_DatTim.FullDateStr(Man.Birth)),
                        CS(GetBthAddrElm(baa_Town)),
                        CS(GetBthAddrElm(baa_Distr)),
                        CS(GetBthAddrElm(baa_Region)),
                        CS(GetBthAddrElm(baa_Country)));
    MAKEPART(R, ADV3_2, CS(SArr1[0]), CS(SArr1[1]), CS(SArr1[2]));
   END;
   IF Flag[p_BtA] THEN
    L_Man.StrongAccessManAdr(Man.Man, L_Packet.PrepareDate, L_Russia.at_BthMA);
    MAKEPART(R, ADVx_1, CS(TMP1), CS(TMP2),
                        CS(GetBthAddrElm(baa_Town)),
                        CS(GetBthAddrElm(baa_Distr)),
                        CS(GetBthAddrElm(baa_Region)),
                        CS(GetBthAddrElm(baa_Country)));
   ELSE
    MAKEPART(R, ADVx_1, CS(TMP1), CS(TMP2));
   END;
   SETEMPTY(SArr1);
  END;
  L_Str.SplitStr(SArr1, CollectAdr(L_Russia.at_RgMA), SLen, 4); TMP1:=ManAdr.Zip;
  IF L_Man.AccessManAdr(Man.Man, L_Packet.PrepareDate, L_Russia.at_DwMA) THEN
   L_Str.SplitStr(SArr2, CollectAdr(L_Russia.at_DwMA), SLen, 4); TMP2:=ManAdr.Zip;
  ELSE
   SETEMPTY(SArr2, TMP2);
  END;

  MAKEPART(R, ADVx_2, CS(_Citizenship(Man.Man, L_Packet.PrepareDate)));

  MAKEPART(R, ADVx_3, CS(TMP1), CS(SArr1[0]), CS(SArr1[1]), CS(SArr1[2]), CS(SArr1[3]),
                      CS(TMP2), CS(SArr2[0]), CS(SArr2[1]), CS(SArr2[2]), CS(SArr2[3]));

  SETEMPTY(SArr1);
  L_Str.SplitStr(SArr1, L_Basis.ExclQM(Man.PspGiveS), SLen, 3);
  MAKEPART(R, ADVx_4, CS(SArr1[0]), CS(SArr1[1]), CS(SArr1[2]));
  IF Packet.Kind = L_Packet.knd_PF_ADV3 THEN
   MAKEPART(R, ADV3_3, L_Str.PoolItem(" ।⠢|।⠢﫨",
                                      HasTransferedPacket()) + "  .");
  END;
  FORMFEED(R);
 END {PrintOnList};

(*
$P{ PTit:
?, R, ""
L_Packet.OwnNumInPFR, L, ""
L_Packet.OwnFirmName, L, ""
?, R, "N0"
?, R, "N0"
@
⪠  窨 ##### ࠡ⮤⥫ ##############
#################################################################   #  #
==============================================================================
N |        ..          |  ஦-|   㬥                 |ਬ
|                             |     |  (*- )            |
---|-----------------------------|----------|----------------------------|----
 1 |            2                |    3     |         4                  |  5
---|-----------------------------|----------|----------------------------|----
}
*)

(*
$P{ Line:
?, R, "N"
?, L, ""
Man.Birth, L, "D/N/y"
Man.PspSer, L, ""
Man.PspNbr, L, ""
Man.PspGiveD, L, "D/N/y"
@
###|#############################|##########|######### ####### ##########|
}
*)

(*
$P{ Empt:
@
   |                             |          |                            |
}
*)

(*
$P{ PBot:
@
==============================================================================}
*)


 PRIVATE PROCEDURE trn_PckKind(): STRING[];
 BEGIN
  IF    Packet.Kind = L_Packet.knd_PF_ADV1 THEN RETURN "_";
  ELSIF Packet.Kind = L_Packet.knd_PF_ADV2 THEN RETURN "__";
  ELSIF Packet.Kind = L_Packet.knd_PF_ADV3 THEN RETURN "__";
  ELSE
   L_General.CallUs(0);
  END;
 END {trn_PckKind};

 PRIVATE PROCEDURE trn_PutBthMA(nParent: L_XML.tNode; NodeName: STRING[]; Previous: SCAL[2]);
  VAR
   nBthMA     : L_XML.tNode;
   BthAddrArr : STRING[][MAXOF(tBthAddrElement)+1];
   BthAddrType: STRING[];
 BEGIN
  L_Man.StrongAccessManAdr(Man.Man, L_Packet.PrepareDate, L_Russia.at_BthMA);
  IF Previous THEN
   L_Man.StrongAccessManAdr(Man.Man, ManAdr.Date-1, L_Russia.at_BthMA);
  END;
  BthAddrArr:=intGetBthAddrArr(BthAddrType);
  nBthMA:=L_Packet.trn_PutNode(nParent, NodeName);
   L_Packet.trn_PutString(nBthMA, "⠐", BthAddrType);
   L_Packet.trn_PutString(nBthMA, "த",  BthAddrArr[baa_Town]);
   L_Packet.trn_PutString(nBthMA, "",  BthAddrArr[baa_Distr]);
   L_Packet.trn_PutString(nBthMA, "", BthAddrArr[baa_Region]);
   L_Packet.trn_PutString(nBthMA, "࠭", BthAddrArr[baa_Country]);
 END {trn_PutBthMA};

 PRIVATE PROCEDURE _trn_PutFIO(nParent: L_XML.tNode; NodeName: STRING[]; ManName: STRING[]; All: SCAL[2]);
  VAR
   nName     : L_XML.tNode;
   Surname,
   FirstName,
   Patronymic: STRING[];
 BEGIN
  nName:=L_Packet.trn_PutNode(nParent, NodeName);
  L_Str.SplitManName(ManName, Surname, FirstName, Patronymic);
  IF All | Flag[p_Fml] THEN
   L_Packet.trn_PutString(nName, "", Surname);
  END;
  IF All | Flag[p_Nam] THEN
   L_Packet.trn_PutString(nName, "",     FirstName);
  END;
  IF All | Flag[p_Otc] THEN
   L_Packet.trn_PutString(nName, "⢮", Patronymic);
  END;
 END {_trn_PutFIO};

 PRIVATE PROCEDURE trn_PutBiogrPart(nParent: L_XML.tNode; NodeName: STRING[]; All: SCAL[2]);
  VAR
   nBPart,
   nBthMA: L_XML.tNode;
 BEGIN
  nBPart:=L_Packet.trn_PutNode(nParent, NodeName);
   _trn_PutFIO(nBPart, "", Man.Name, All);
   IF All | Flag[p_Sex] THEN
    L_Packet.trn_PutString(nBPart, "", Str.Item("|", "|", Man.Sex));
   END;
   IF All | Flag[p_BtD] THEN
    L_Packet.trn_PutDate(nBPart, "⠐", Man.Birth);
   ELSE
    L_Packet.trn_PutString(nBPart, "⠐", ""); (*!!! 0055293*)
   END;
   IF All | Flag[p_BtA] THEN
    trn_PutBthMA(nBPart, "⮐", 0);
   END;

   L_Packet.trn_PutString(nBPart, "ࠦ⢮", _Citizenship(Man.Man, L_Packet.PrepareDate));
   L_Man.StrongAccessManAdr(Man.Man, L_Packet.PrepareDate, L_Russia.at_RgMA);
   L_Packet.trn_PutAdr(nBPart, "ᐥ樨");
   IF L_Man.AccessManAdr(Man.Man, L_Packet.PrepareDate, L_Russia.at_DwMA) THEN
    L_Packet.trn_PutAdr(nBPart, "ᔠ᪨");
   END;
   L_Packet.trn_PutString(nBPart, "䮭", "");
 END {trn_PutBiogrPart};

 PRIVATE PROCEDURE trn_PutIdentityPapers(nParent: L_XML.tNode; NodeName: STRING[]);
  VAR
   nID,
   nDoc: L_XML.tNode;
   l: NUMERIC[0];
   RomN, RusN: STRING[];
 BEGIN
  nID:=L_Packet.trn_PutNode(nParent, NodeName);
   L_Packet.trn_PutString(nID, "⮢饣", GetManDocName(Man.DocType, 0));
   nDoc:=L_Packet.trn_PutNode(nID, "㬥");
    L_Packet.trn_PutString(nDoc, "⮢饣", GetManDocName(Man.DocType, 0)); (*  ࠬ 1,   0 !!!0055293*)

    IF (Man.DocType = 0(*.*)) | (Man.DocType = 1(*ᢨ  ஦*)) |
       (Man.DocType = 8(*.*)) THEN
     l:=Str.Length(Man.PspSer);
     RomN:=Str.Slice(Man.PspSer, 0, l-3);
     RusN:=Str.Slice(Man.PspSer, l-2, 2);
    ELSE
     RomN:="";
     RusN:=Man.PspSer;
    END;
    L_Packet.trn_PutString(nDoc, "᪨", RomN);
    L_Packet.trn_PutString(nDoc, "᪨㪢", RusN);
    L_Packet.trn_PutString(nDoc, "⮢饣", Man.PspNbr);
    L_Packet.trn_PutDate(nDoc, "⠂뤠", Man.PspGiveD);
    L_Packet.trn_PutString(nDoc, "뤠", Str.Condense(Str.Slice(Man.PspGiveS, 0, 80)));
 END {trn_PutIdentityPapers};

 PRIVATE PROCEDURE MakeOneMan(nPack: L_XML.tNode);
  VAR
   l         : NUMERIC[0];
   _Name     : LIKE(Man.Name);
   nDoc      : L_XML.tNode;
   FlagStr   : STRING[];
   Surname,
   FirstName,
   Patronymic: STRING[];
 BEGIN
  PROMPT(GetManStrId(Man.Man));
  L_Packet.CheckMyFirmForMan(Man.Man);
  Test();

  IF ~SingleMode &
     ((Packet.Kind = L_Packet.knd_PF_ADV2) |
      (Packet.Kind = L_Packet.knd_PF_ADV3)) THEN
   FlagStr:=L_Packet.GetPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_Flag);
   GetFlagFromStr(FlagStr);
   AskFlag(Packet.Kind, !FlagStr);
   L_Packet.PutPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_Flag, SetFlagToStr());
  END;

  PrintOnList();
  _Name:=L_Packet.GetManInPFRFName(L_Packet.PrepareDate);

  IF    Packet.Kind = L_Packet.knd_PF_ADV1 THEN
   L_General.Assert(!Man.SINumber, " 㦥 ᢮ 客 ");
   L_Staff.StandOnMainContract(Man.Man, Packet.MyFirm, PerE);
   IF ~L_SFee.ManNeedInsureInPF(Man.Man, PerE) THEN
    L_StdFrm.Choice("   客    ﭨ  "+L_DatTim.DateStr(PerE)+
                    "| ଠ ᨮ 客 ࠭ ࠦ."+
                    "| 㢥७,  室 客  "+L_Man.Man_ManAsStr()+"?");
   END;
  END;

  nDoc:=L_Packet.trn_PutAbstractDoc(nPack, trn_PckKind(), CurNumInP);

  IF    Packet.Kind = L_Packet.knd_PF_ADV1 THEN
   trn_PutBiogrPart(nDoc, "륄", 1);
  ELSE
   L_Packet.trn_PutString(nDoc, "客", L_Packet.SINumberToAnyOut(Man.SINumber));
   IF Packet.Kind = L_Packet.knd_PF_ADV3 THEN
    L_Packet.trn_PutString(nDoc, "⬥⪠।⠢", L_Str.PoolItem(" | ", HasTransferedPacket()));
   END;
   L_Packet.trn_PutFIO(nDoc, "客", L_Packet.GetManInPFRFName(L_Packet.PrepareDate));

   IF Packet.Kind = L_Packet.knd_PF_ADV3 THEN
    L_Packet.trn_PutString(nDoc, "客", L_Str.PoolItem("|", Man.Sex # Flag[p_Sex] (* XOR*)));
    L_Packet.trn_PutDate(nDoc, "⠐客", Man.Birth);
    trn_PutBthMA(nDoc, "⮐客", Flag[p_BtA]);
   END;
   trn_PutBiogrPart(nDoc, "訥", 0);
   L_Man.curMan_SplitName(Surname, FirstName, Patronymic);

   IF Flag[p_Otc] & !Patronymic THEN
    L_Packet.trn_PutString(nDoc, "ਧ⬥⢠", "");
   END;
(* !!! 0055293
   L_Packet.trn_PutString(nDoc, "ਧ⬥⢠", L_Str.PoolItem("|", ~(Flag[p_Otc] & !Patronymic)));
   L_Packet.trn_PutString(nDoc, "ਧ⬥댥⠐", "");
*)
  END;

   trn_PutIdentityPapers(nDoc, "⮢騩㬥");
   L_Packet.trn_PutDate(nDoc, "⠇", L_Packet.PrepareDate);
 END {MakeOneMan};

 PRIVATE PROCEDURE PrepareIntrm();
 BEGIN
  L_AFM.MakeIndex("Intrm", "Name   : LIKE(Man.Name);" +
                           "Man    : LIKE(Man.Man);" +
                           "FlagStr: LIKE(PckAttr.Value)");
 END {PrepareIntrm};

 PRIVATE PROCEDURE PutManInIntrm(FlagStr: STRING[]);
 BEGIN
  Intrm.Man    :=Man.Man;
  Intrm.Name   :=L_Packet.GetManInPFRFName(L_Packet.PrepareDate);
  Intrm.FlagStr:=FlagStr;
  INSERT(Intrm);
 END {PutManInIntrm};

 PRIVATE PROCEDURE AccessPacket(_ExtNbr  : LIKE(Packet.ExtNbr)): SCAL[2];
 BEGIN
  RETURN SEARCH(Packet, PacketDS, L_Packet.rcv_PensFund, L_Packet.DTStamp, _ExtNbr);
 END {AccessPacket};

 PRIVATE PROCEDURE InsertPckBody(_Man: LIKE(Man.Man); FlagStr: STRING[]);
 BEGIN
  DEFAULT(PckBody);
  PckBody.Packet  :=Packet.Packet;
  PckBody.Man     :=_Man;
  INSERT(PckBody);
  IF ~!FlagStr THEN
   L_Packet.PutPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_Flag, FlagStr);
  END;
 END {InsertPckBody};

 PRIVATE PROCEDURE BuildPackets(trgKind: LIKE(Packet.Kind));
 BEGIN
  DEC(CurPacket);
  CurNumInP:=0;
  SELECT(Intrm, Intrm);
  WHILE OCCURE(Intrm) DO
   PROMPT("⮢ ⮢ " + Intrm.Man);
   CurNumInP:=(CurNumInP MOD (P_OwnData.ODAnkPacketSize(L_Packet.PrepareDate)-1))+1;
   IF CurNumInP = 1 THEN
    INC(CurPacket);
    L_Packet.InsPFPacket(trgKind, CurPacket, PerB, PerE, L_Packet.dt_None, L_Packet.ct_None);
   END;
   InsertPckBody(Intrm.Man, Intrm.FlagStr);
   NEXT(Intrm);
  END;
  L_AFM.AF_PurgeTemp("Intrm");
 END {BuildPackets};

 PRIVATE PROCEDURE MakeAll();
 BEGIN
  SELECT(Packet, PacketDS, , L_Packet.rcv_PensFund, L_Packet.DTStamp);
  WHILE OCCURE(Packet) DO
   MakeOnePacket();
   NEXT(Packet);
  END; (* WHILE OCCURE(Packet) ... *)
 END {MakeAll};

 PRIVATE PROCEDURE MakeByPacket();
 BEGIN
  PrepareIntrm();
  SELECT(PckBody, Packet, , Packet.Packet);
  WHILE OCCURE(PckBody) DO
   CONFORM(PckBody, Man);
   PutManInIntrm(L_Packet.GetPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_Flag));
   NEXT(PckBody);
  END; (* WHILE OCCURE(PckBody) ... *)
  BuildPackets(Packet.Kind);
  MakeAll();
 END {MakeByPacket};

 PRIVATE PROCEDURE GetManStrId(_Man: LIKE(Man.Man)): STRING[];
 BEGIN
  RETURN Packet.ExtNbr+"-"+L_Str.IntStr(CurNumInP) + " (" + _Man + ")";
 END {GetManStrId};

 PRIVATE PROCEDURE MakeOnePacket();
  VAR
   PagAmount,
   PagNumber,
   LinNumber  : NUMERIC[0];
   nPack,
   nInvH: L_XML.tNode;
 BEGIN
  L_Packet.CheckExistTrnFiles();
  L_Packet.trn_OpenFiles();

  CurNumInP:=0;
  SELECT(PckBody, Packet, , Packet.Packet);
  WHILE OCCURE(PckBody) DO
   INC(CurNumInP);
   NEXT(PckBody);
  END;

  nPack:=L_Packet.trn_PutHead();
  nInvH:=L_Packet.trn_PutInventoryHead(nPack, "_", trn_PckKind(), CurNumInP);

  IF    Packet.Kind = L_Packet.knd_PF_ADV1 THEN
   L_Packet.MakeADV61forADV1_2_3(CurNumInP, EMPTYOF(CurNumInP), EMPTYOF(CurNumInP));
  ELSIF Packet.Kind = L_Packet.knd_PF_ADV2 THEN
   L_Packet.MakeADV61forADV1_2_3(EMPTYOF(CurNumInP), CurNumInP, EMPTYOF(CurNumInP));
  ELSIF  Packet.Kind = L_Packet.knd_PF_ADV3 THEN
   L_Packet.MakeADV61forADV1_2_3(EMPTYOF(CurNumInP), EMPTYOF(CurNumInP), CurNumInP);
  ELSE
   L_General.CallUs(0);
  END;

  FORMFEED(R);
  InitPrintAttr(R, Duplex, Off);

  CurNumInP:=1; (* ஬ - -6-1*)
  SELECT(PckBody, Packet, , Packet.Packet);
  WHILE OCCURE(PckBody) DO
   INC(CurNumInP);
   CONFORM(PckBody, Man);
   MakeOneMan(nPack);
   NEXT(PckBody);
  END; (* WHILE OCCURE(PckBody) ... *)

  InitPrintAttr(R, Duplex, Off);
  PagAmount:=(CurNumInP-1) DIV PagLength + 1;
  PagNumber:=0;
  LinNumber:=0;

  CurNumInP:=1;
  FIRST(PckBody);
  WHILE OCCURE(PckBody) DO
   PROMPT("᮪ : 窠 "+GetManStrId(PckBody.Man));
   INC(CurNumInP);
   CONFORM(PckBody, Man);
   IF LinNumber = 0 THEN
    INC(PagNumber);
    MAKEPART(R, PTit, Packet.ExtNbr, PagNumber, PagAmount);
   END;
   INC(LinNumber);
   MAKEPART(R, Line, CurNumInP, L_Str.ShortName(Man.Name));
   IF LinNumber >= PagLength THEN
    LinNumber:=0;
    MAKEPART(R, PBot);
    FORMFEED(R);
   END;
   NEXT(PckBody);
  END; (* WHILE OCCURE(PckBody) ... *)

  IF LinNumber > 0 THEN
   WHILE LinNumber < PagLength DO
    INC(LinNumber);
    MAKEPART(R, Empt);
   END;
   MAKEPART(R, PBot);
   FORMFEED(R);
  END;
  L_Packet.trn_CloseFiles(nPack);
 END {MakeOnePacket};

 PRIVATE PROCEDURE CheckPacket(_Packet: NUMERIC[0]): SCAL[2];
 BEGIN
  IF _Packet > 999 THEN
   L_StdFrm.Inform(" 窨     999");
   RETURN 0;
  ELSE
   RETURN 1;
  END;
 END {CheckPacket};

 PRIVATE PROCEDURE GetFlagFromStr(FlagStr: STRING[]);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i <= HIGH(Flag) DO
   Flag[i]:=Str.Item(FlagStr, ";", i);
   IF !Flag[i] THEN
    Flag[i]:=0;
   END;
   INC(i);
  END;
 END {GetFlagFromStr};

 PRIVATE PROCEDURE SetFlagToStr(): STRING[];
  VAR
   i: NUMERIC[0];
   FlagStr: STRING[];
 BEGIN
  FlagStr:="";
  i:=0;
  WHILE i <= HIGH(Flag) DO
   FlagStr:=FlagStr+Flag[i]+";";
   INC(i);
  END;
  RETURN FlagStr;
 END {SetFlagToStr};

 PRIVATE PROCEDURE AskFlag(_Kind: LIKE(Packet.Kind); FirstTime: SCAL[2]);
  VAR
   Msg: STRING[];
 BEGIN
  IF FirstTime THEN
   Msg:="";
  ELSE
   Msg:="|஢/᪮४஢|訥 :";
  END;
  STDFORM(Msg+"|"+
          "|: "+Man.Man +
          "|"+Man.Name + "|" +
          "|:                     " +
          "|%<                   >E" +
          "|%<                       >E" +
          "|%<⢮                  >E" +
          "|%<                       >E" +
          "|%< ஦             >E" +
          "|%< ஦            >E" +
          "|%<祥 ( ॡ )>E" +
          "|" +
          "|  %< 믮 >DB    %< ⬥ >X ",
          L_Str.PoolItem("  客 ᢨ⥫⢠ | 뤠 㡫 客 ᢨ⥫⢠ ",
                         _Kind=L_Packet.knd_PF_ADV3),
          ^(L_Str.PoolItem("INFORM|", _Kind=L_Packet.knd_PF_ADV3)),
          -1,
          Flag[p_Fml], Flag[p_Nam], Flag[p_Otc], Flag[p_Sex], Flag[p_BtD], Flag[p_BtA], Flag[p_Other]);
  IF (_Kind = L_Packet.knd_PF_ADV2) &
     (Flag[p_Fml] = 0) &
     (Flag[p_Nam] = 0) &
     (Flag[p_Otc] = 0) &
     (Flag[p_Sex] = 0) &
     (Flag[p_BtD] = 0) &
     (Flag[p_BtA] = 0) &
     (Flag[p_Other] = 0)  THEN
   L_StdFrm.Choice(" 㪠 !");
  END; (* IF *)
 END {AskFlag};

 PRIVATE PROCEDURE intSingleADV(trgPacketKind: LIKE(Packet.Kind));
  VAR
   Choose: SCAL[2];
   nPack : L_XML.tNode;
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_General.Assert(ACCESS(Man), " ⠭ 䨧᪮ ");
  SingleMode:=1;

  PerB:=SYSDATE();
  PerE:=SYSDATE();

  CurPacket:=L_Packet.trn_Init(SYSDATE(), L_Packet.bm_bySingle, L_Packet.part_Ank, trgPacketKind);

  Choose:=L_Packet.ChoosePacket(trgPacketKind, EMPTYOF(DATE), EMPTYOF(DATE), L_Packet.dt_None, L_Packet.ct_None);
  IF (trgPacketKind=L_Packet.knd_PF_ADV2) | (trgPacketKind=L_Packet.knd_PF_ADV3) THEN
   IF Choose THEN
    GetFlagFromStr(L_Packet.GetPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_Flag));
    AskFlag(trgPacketKind, 1);
    L_Packet.PutPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_Flag, SetFlagToStr());
   ELSE
    SETZERO(Flag);
    AskFlag(trgPacketKind, 1);
   END;
  END;

  TRY
   L_Packet.InsPFPacket(trgPacketKind, CurPacket, PerB, PerE, L_Packet.dt_None, L_Packet.ct_None);
   CurNumInP      :=0001;
   L_Packet.trn_OpenFiles();
   nPack:=L_Packet.trn_PutHead();
   MakeOneMan(nPack);
   L_Packet.trn_CloseFiles(nPack);
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc:Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
 END {intSingleADV};

 PUBLIC PROCEDURE SingleADV1();
 BEGIN
  intSingleADV(L_Packet.knd_PF_ADV1);
 END {SingleADV1};

 PUBLIC PROCEDURE SingleADV2();
 BEGIN
  intSingleADV(L_Packet.knd_PF_ADV2);
 END {SingleADV2};

 PUBLIC PROCEDURE SingleADV3();
 BEGIN
  intSingleADV(L_Packet.knd_PF_ADV3);
 END {SingleADV3};

 PUBLIC PROCEDURE ByCurrentPacket();
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_General.Assert(ACCESS(Packet), " । ⥪騩 ");
  SingleMode:=0;
  L_Packet.SetSamplePacketDone();
  CurPacket:=L_Packet.trn_Init(SYSDATE(), L_Packet.bm_byPacket, L_Packet.part_Ank, Packet.Kind);
  PerB:=Packet.PerB;
  PerE:=Packet.PerE;
  MakeByPacket();

  L_Packet.ShowMakedPackets();
 END {ByCurrentPacket};

END.
