(*
%Copyright   (c) Polak IT
%Author      19.01.2011 10:46:30 POLAK\SSV
%Purpose      뤠 ய᪮
%Type        report
%Specific    SYS
%Modified    26.06.2012 11:26:19 POLAK\LDA
%Environment
*)

 IMPORT L_General, P_Man, L_Basis, L_Staff, FIO, L_ACS, L_bp, L_ctc;

 CONST
  RepName = "APass";

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "ய᪄⠂뤠");
  L_Basis.wb_WrInQM(F, "ய᪑");
  L_Basis.wb_WrInQM(F, "ய᪍");
  L_Basis.wb_WrInQM(F, "㯄⠂뤠");
  L_Basis.wb_WrInQM(F, "㯯㯠");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "፮");
  L_Basis.wb_WrInQM(F, "ઠ2");
  L_Basis.wb_WrInQM(F, "፮2");
  L_Basis.wb_WrInQM(F, "멒䮭");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE AddPhone(VAR PhoneStr: STRING[]; nxtPhone: STRING[]);
 BEGIN
  IF ~!nxtPhone THEN
   IF ~!PhoneStr THEN
    PhoneStr:=PhoneStr + ", " + nxtPhone;
   ELSE
    PhoneStr:=nxtPhone;
   END;
  END;
 END {AddPhone};

 PRIVATE PROCEDURE MakePart(F: STRING[]; OnDate: DATE);
  VAR
   CarMark,
   StateNbr: STRING[][2];
   CardType: L_ACS.tCardType;
   CardCode: NUMERIC[0];
   Phone,
   Phones  : STRING[];
 BEGIN
  L_Basis.wb_WrScl(F, Man.Man);
  IF L_Staff.IsStandOnAnyMainContract(Man.Man, OnDate) THEN
   L_Basis.wb_WrScl(F, Staff.TSN);
  ELSE
   L_Basis.wb_WrScl(F, "");
  END;
  L_Basis.wb_WrStr(F, Man.Name);
  IF OCCURE(Staff) & L_Staff.rInState(OnDate) & L_Staff.IsMainForTax(OnDate) THEN
   CONFORM(StaffLog, Officer);
   CONFORM(Officer, Post);
   CONFORM(Officer, Sort);
   CONFORM(Officer, Union);
   L_Basis.wb_WrScl(F, Sort.Sort);
   L_Basis.wb_WrStr(F, Sort.Name);
   L_Basis.wb_WrScl(F, Post.Post);
   L_Basis.wb_WrStr(F, Post.Name);
   L_Basis.wb_WrScl(F, Union.Union);
   L_Basis.wb_WrStr(F, Union.Name);
  ELSE
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_WrDat(F, ManPro.Date);
  P_Man.GetPassAttributes(Man.Man, OnDate, CardType, CardCode);
  L_Basis.wb_WrNum(F, L_ACS.Wiegand26CardFamily(CardCode), 0);
  L_Basis.wb_WrNum(F, L_ACS.Wiegand26CardNumber(CardCode), 0);
  IF P_Man.HasActualManPro(Man.Man, OnDate, P_Man.P_AccessToTerritory) THEN
   L_Basis.wb_WrDat(F, ManPro.Date);
   P_Man.GetAccessOutsiderCar(Man.Man, OnDate, CarMark, StateNbr);
   L_Basis.wb_WrStr(F, P_Man.GetAcsGroup(Man.Man, OnDate));
   L_Basis.wb_WrStr(F, CarMark[0]);
   L_Basis.wb_WrStr(F, StateNbr[0]);
   L_Basis.wb_WrStr(F, CarMark[1]);
   L_Basis.wb_WrStr(F, StateNbr[1]);
  ELSE
   L_Basis.wb_WrDat(F, L_General.EMPTY_DATE());
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
  END;
  Phones:=L_ctc.GetCtcVal(0, Man.Contact, OnDate, L_ctc.cvc_Work,  L_ctc.cvt_PhoneClr);
  AddPhone(Phones, L_ctc.GetCtcVal(0, Man.Contact, OnDate, L_ctc.cvc_Home,  L_ctc.cvt_PhoneClr));
  AddPhone(Phones, L_ctc.GetCtcVal(0, Man.Contact, OnDate, L_ctc.cvc_Other, L_ctc.cvt_PhoneClr));
  L_Basis.wb_WrStr(F, Phones);
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PUBLIC PROCEDURE MakeRep();
  VAR
   OnDate: DATE;
 BEGIN
  OnDate:=SYSDATE();
  L_bp.Begin(RepName, " 뤠 ய᪮", L_bp.t_Basis, L_General.tc_onDate);
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  MakeHeader("R");
  SELECT(Man, Man);
  WHILE OCCURE(Man) DO
   PROMPT(Man.Man);
   IF P_Man.HasActualManPro(Man.Man, OnDate, P_Man.P_Pass) THEN
    MakePart("R", OnDate);
   END;
   NEXT(Man);
  END;
  FIO.Close(R);
  L_bp.End();
 END {MakeRep};

END.