(*
%Copyright   (c) Polak Computer System
%Author      08.06.1999 21:30:03 SAN
%Purpose     ᯥ ᮢ
%Type        control
%Specific    SYS
%Modified    03.12.2013 19:49:53 POLAK\LDA
%Environment
*)

 IMPORT L_General, L_Basis;

 PRIVATE PROCEDURE _Mode(): NUMERIC[0];
 BEGIN
  RETURN MODE MOD 100;
 END {_Mode};

BEGIN
 IF !MODE THEN
  L_Basis.PlayBasis();
 ELSIF _Mode() =  8 THEN L_Basis.MakeBasis     ("Distr",   L_Basis.ModuleType_ASL, MODE, 121,          L_General.timeCond_InIntvl,    "। ௫");
 ELSIF _Mode() = 46 THEN L_Basis.MakeBasis     ("MTHLY",   L_Basis.ModuleType_ASL, MODE, 000,          L_General.timeCond_InIntvl,    "⥫ 筮 ⥫");
 ELSIF _Mode() = 51 THEN L_Basis.Do_wAnyRepName("MS_SMM1", L_Basis.ModuleType_ASL, MODE, 110, "MSSMD", L_General.timeCond_OnMonthBeg, "  ");
 ELSIF _Mode() = 56 THEN L_Basis.Do_wAnyRepName("C_Add",   L_Basis.ModuleType_ASL, MODE, 100, "CAdd1", L_General.timeCond_InIntvl,    " ᯮ짮 ");
 ELSIF _Mode() = 57 THEN L_Basis.Do_wAnyRepName("MS_SMM1", L_Basis.ModuleType_ASL, MODE, 111, "MSSMM", L_General.timeCond_InIntvl,    "   ");
 ELSIF _Mode() = 61 THEN L_Basis.MakeBasis     ("KATAX",   L_Basis.ModuleType_ASL, MODE, 000,          L_General.timeCond_InIntvl,    "   ");
 ELSIF _Mode() = 81 THEN L_Basis.MakeBasis     ("Dis03",   L_Basis.ModuleType_ASL, MODE, 100,          L_General.timeCond_OnDate,     " 樭樨 ࠡ⭨  ");
 ELSIF _Mode() = 96 THEN L_Basis.MakeBasis     ("Rpr22",   L_Basis.ModuleType_ASL, MODE, 100,          L_General.timeCond_Entire,     " ⫮ ࠢ⥩");
 ELSE
  L_General.CallUs(0);
 END;

END.
