(*
%Copyright   (c) Polak Computer System
%Author      13.02.1998 12:00:18 SAN
%Purpose      , "" 㤮 ࠪ⮢
%Type        report
%Specific    SYS
%Modified    30.07.2014 18:32:16 POLAK\GAV
%Environment
*)

 MODULE ChkStf01 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_OwnData, L_Staff, L_AvePay, Memo, L_Env, L_AFM, L_Man;

 VAR
  RepName: STRING[];

(*
$P{ ChkDS_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_mb(), L, "N.y"
@
############################################################# ########## #####
=#####========================================================================
|            㤮   ᫥   ⪠            |
|         㬥⮢  ⢨/  ।  #######         |
|----------------------------------------------------------------------------|
|. |  ⢮       |           |ਭ    |    |
|-----|---------------------------|--------------------|----------|----------|
}

$P{ ChkDS_Line:                                     
Staff.TSN, L, ""
Man.Name, L, ""
Post.Name, L, ""
L_Man.GetTakeOnDate(Memo.ud_mb()), R, "D.N.y"
L_Man.GetRealEndDate(Memo.ud_me()), R, "D.N.y"
@
|#####|###########################|####################|##########|##########|
}

$P{ ChkDS_Bot:
@
=(c) Polak====================================================================
}
*)

 PUBLIC PROCEDURE ChkDS_Make();
  VAR
   HasSomething: SCAL[2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  RepName:="ChkDS";
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, ChkDS_Top);
 
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   IF L_Env.RealTSN(Staff.TSN) & (Staff.Contract # L_Staff.cnt_OutStaff) &
      L_Staff.InStateInPer(Memo.ud_mb(), Memo.ud_me()) THEN
    IF ~SELECT(Money, TSN, Staff.TSN, Memo.ud_mb()) THEN
     HasSomething:=0;
     SELECT(AvePay, TSN, , Staff.TSN);
     LAST(AvePay);
     WHILE OCCURE(AvePay) & ~HasSomething DO
      IF L_AvePay.IsRealAvePay() & L_AvePay.AvePayHasJMode() THEN
       HasSomething:=L_AvePay.GetAvePayStopD() >= Memo.ud_mb();
      END;
      PREV(AvePay);
     END; (* WHILE OCCURE(AvePay)... *)
     IF ~HasSomething THEN
      CONFORM(Staff, Man);
      HISTCONF(Memo.ud_me(), Staff, StaffLog, Post);
      MAKEPART(R, ChkDS_Line);
     END;
    END;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff)... *)
 
  MAKEPART(R, ChkDS_Bot);
  CLOSEREP(R);
 END {ChkDS_Make};

(*
$P{ Conr1_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_cd(), L, "D.N.y"
@
############################################################# ########## #####
=#####========================================================================
|     ᮪ ࠡ⭨  "" 㤮 ஬   ##########     |
}
*)

(*
$P{ Conr1_UnionTop:
Union.Union, L, ""
Union.Name, L, ""
@
|----------------------------------------------------------------------------|
|⥣ ## ###############################################################|
|----------------------------------------------------------------------------|
|                           |.||                         |
|---------------------------------|----|--|----------------------------------|
}
*)

(*
$P{ Conr1_Line:
Staff.TSN, L, ""
Man.Name, L, ""
StaffLog.DutyDgr, R, "2."
Staff.Contract, L, L_Staff.cnt_Pool
Post.Post, L, ""
Post.Name, L, ""
@
|##### ###########################|####|##|### ##############################|
}
*)

(*
$P{ Conr1_Bot:
@
=(c) Polak====================================================================
}
*)

 PUBLIC PROCEDURE Conr1_Make();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  RepName:="Conr1";
  L_AFM.MakeIndex("tmp", "Union: LIKE(Union.Union);" +
                         "TSN  : LIKE(Staff.TSN);" +
                         "ODate: LIKE(StaffLog.Date)");
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   IF L_Staff.rInState(Memo.ud_cd()) &
      ((Staff.Contract # L_Staff.cnt_Basic) | (StaffLog.DutyDgr < 1)) THEN
    CONFORM(StaffLog, Union);
    ADD(tmp, tmp, , Officer.Union, Staff.TSN, StaffLog.Date);
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
 
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Conr1_Top);
  SELECT(tmp, tmp);
  WHILE OCCURE(tmp) DO
   NARROWSEL(tmp, Union);
   PROMPT(tmp.Union);
   SEARCH(Union, Union, , tmp.Union);
   MAKEPART(R, Conr1_UnionTop);
   WHILE OCCURE(tmp) DO
    SEARCH(StaffLog, TSN, , tmp.TSN, tmp.ODate);
    CONFORM(StaffLog, Staff);
    CONFORM(Staff, Man);
    CONFORM(StaffLog, Officer);
    CONFORM(Officer, Post);
    CONFORM(Officer, Sort);
    MAKEPART(R, Conr1_Line);
    NEXT(tmp);
   END; (* WHILE OCCURE(tmp) ... *)
   NEXTINEXTENDEDSEL(tmp, Union);
  END; (* WHILE OCCURE(tmp) ... *)
 
  MAKEPART(R, Conr1_Bot);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("tmp");
 END {Conr1_Make};

END.
