(*
%Copyright   (c) Polak Computer System
%Author      12.02.1999 10:11:32 SAN
%Purpose     ᠭ  (+/-)   㢮 ࠡ⭨
%Type        operation
%Specific    SYS
%Modified    06.12.2013 17:56:07 POLAK\Gina
%Environment
*)

 MODULE Cl_Rest [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Acnt, P_Firm, L_Staff, L_PRoll, L_Str, Memo, L_AFM, L_EDO,
        L_StdFrm, L_Man;

(*
$P{ Top:
P_Firm.MyFirmName(_StaffTmp.MyFirm, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L "H:M"
?, L, ""
L_DatTim.IncMonth(Memo.ud_mb(), +1), L, "N.y"
?, L, "N.y"
@
######################################################################### ########## #####
=#####====================================================================================
|                ⪮  #######  楢  ࠡ⭨,              |
|                             㢮  #######  ࠭                              |
|----------------------------------------------------------------------------------------|
|     |                                   |          |           |           |       |
|. |                                |    |     ।|      |騩|
|     |                                   |          |           |           |  ࠪ |
|-----|-----------------------------------|----------|-----------|-----------|-----------|
}
*)

(*
$P{ Line:
Staff.TSN, L, ""
Man.Name, L, ""
Staff.EndDate, L, "D.N.y"
?, R, "2-"
?, R, "2-"
?, L, " |"
@
|#####|###################################|##########|###########|###########|     #     |
}
*)

(*
$P{ Bot:
?, R, "2-"
?, R, "2-"
@
|----------------------------------------------------|-----------|-----------|-----------|
|⮣                                               |###########|###########|           |
=(c) Polak================================================================================
}
*)

 PRIVATE PROCEDURE Do(DeadLine     : DATE;
                      DoTransaction: SCAL[2]);
  VAR
   FO     : LIKE(FOrder.FOrder);
   _Saldo : NUMERIC[2];
   Tot,
   Cir    : NUMERIC[2][2];
   _MCTyp,
   curType: SCAL[2];
   RepName: STRING[];
   HasActiveTSN: SCAL[2];
 BEGIN
  IF DoTransaction THEN
   L_EDO.InitPrepareFOrder();
   FO:=FOrder.FOrder;
   L_General.Assert(FOrder.Type = L_PRoll.fot_BySum, "ਪ     㬬");
   CONFORM(FOrder, MCList);
   _MCTyp:=MCList.MCTyp;
   STDMSG("㤥 ந ᯨᠭ " +
          L_Str.PoolItem("⮢|।⮢", _MCTyp) +
          " ᠫ줮|  ࠡ⭨, 㢮  " +
          L_DatTim.DateStr(DeadLine), CHOICE);
  ELSE
   RepName:="CLRxx";
   OPENREP(R, L_General.NameConnection(RepName), Create);
  END;

  L_AFM.MakeIndex("_StaffTmp", "MyFirm: LIKE(Staff.MyFirm);"+
                                  "TSN: LIKE(Staff.TSN)");
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   IF (~DoTransaction | (Staff.MyFirm = FOrder.MyFirm)) & L_Staff.IsLeaveFinally(DeadLine) THEN
    CALL(CalcDed.CountUp());
    L_PRoll.CheckSalDone(Memo.ud_mb());
    _StaffTmp.MyFirm:=Staff.MyFirm;
    _StaffTmp.TSN   :=Staff.TSN;
    INSERT(_StaffTmp);
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff)... *)

  SELECT(_StaffTmp, _StaffTmp);
  WHILE OCCURE(_StaffTmp) DO
   NARROWSEL(_StaffTmp, MyFirm);
   IF ~DoTransaction THEN
    MAKEPART(R, Top, RepName, DeadLine);
   END;
   SETZERO(Tot);

   WHILE OCCURE(_StaffTmp) DO
    L_General.CallUs(SEARCH(Staff, TSN, _StaffTmp.TSN));
    PROMPT(Staff.TSN);
    L_PRoll.FixPCalc(Memo.ud_mb());
    _Saldo:=L_PRoll.OutSaldo(Memo.ud_mb());
    IF _Saldo # 0 THEN
     HasActiveTSN:=0;
     SAVE(Staff);
     IF L_Staff.IsStandOnAnyMainContract(Staff.Man, Memo.ud_me()) & ~L_Staff.IsLeaveFinally(Memo.ud_me()) THEN
      CONFORM(Staff, Man);
      IF DoTransaction THEN
       L_StdFrm.Choice(" " + L_Man.Man_ManAsStr() + "  騩 ⠡" +
                       "| 㫥 ᠫ줮  ஬ ⠡쭮");
      END;
      HasActiveTSN:=1;
     END;
     RESTORE(Staff);
     IF _Saldo > 0 THEN
      curType:=L_Acnt.ct_Credit;
     ELSE
      curType:=L_Acnt.ct_Debit;
      _Saldo:=-_Saldo;
     END;
     IF DoTransaction THEN
      IF (_MCTyp # curType) THEN
       L_Staff.PosToStaffLog(Staff.TSN, Memo.ud_me(), 1);
       SEARCH(FOrder, FOrder, , FO);
       L_EDO.AppendFOrderL(0, _Saldo);
       L_PRoll.ShtDone(0);
      END;
     ELSE
      Cir[ curType]:=_Saldo;
      Cir[~curType]:=0;
      INC(Tot[curType], Cir[curType]);
      CONFORM(Staff, Man);
      MAKEPART(R, Line, Cir[L_Acnt.ct_Credit], Cir[L_Acnt.ct_Debit], HasActiveTSN);
     END;
    END;
    NEXT(_StaffTmp);
   END; (* WHILE OCCURE(Staff)... *)
   IF ~DoTransaction THEN
    MAKEPART(R, Bot, Tot[L_Acnt.ct_Credit], Tot[L_Acnt.ct_Debit]);
   END;
   IF NEXTINEXTENDEDSEL(_StaffTmp, MyFirm) THEN
    FORMFEED(R);
   END;
  END; (* WHILE OCCURE(_StaffTmp)... *)
  L_AFM.AF_PurgeTemp("_StaffTmp");

  IF ~DoTransaction THEN
   CLOSEREP(R);
  END;
 END {Do};

 PUBLIC PROCEDURE Cl_Rest();
 BEGIN
  L_General.Assert(~L_PRoll.E_IsLeaveInPaySheet(Memo.ud_mb()),
                  " 襬 ।⨨ 㬬  㢮 ࠡ⭨"+
                  "|    ᮢ 뤠");
  Do(L_DatTim.IncMonth(Memo.ud_mb(), L_PRoll.E_DeadMonthForPaySheet(Memo.ud_mb())), 0);
 END {Cl_Rest};

 PUBLIC PROCEDURE WriteOffCl_Rest();
 BEGIN
  Do(L_DatTim.IncYear(Memo.ud_mb(), -3), 1);
 END {WriteOffCl_Rest};

END.
