(*
%Copyright   (c) Polak IT
%Author      20.11.2007 12:56:45 POLAK\GAV
%Purpose
%Type        control,report,temporary,convertor,operation,library,to paste
%Specific    AP,AP_PC,AP_PT,SYS,TOOL,LOC
%Modified    26.03.2013 09:25:47 POLAK\MLB
%Environment
*)

 MODULE CTC01 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_ctc, L_Basis, L_General, Memo, L_DatTim, FIO, L_Staff, L_bp, P_Firm, L_AFM, L_Str;

 PRIVATE PROCEDURE MakeTop();
 BEGIN
  L_Basis.wb_WrStr("F", "筨");
  L_Basis.wb_WrStr("F", "⠪");
  L_Basis.wb_WrStr("F", "⠪");
  L_Basis.wb_WrStr("F", "࣠");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "祭");
  L_Basis.wb_WrStr("F", "਩");

  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");

  L_Basis.wb_WrStr("F", "㦡");
  L_Basis.wb_WrStr("F", "㦡");
  L_Basis.wb_WrStr("F", "⤥");
  L_Basis.wb_WrStr("F", "⤥");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "⥣");
  L_Basis.wb_WrStr("F", "⥣");

  L_Basis.wb_TermLine("F");
 END {MakeTop};
 
 PRIVATE PROCEDURE MakePart(wOfficer, wStaff: SCAL[2]; Source: STRING[]);
 BEGIN
  L_Basis.wb_WrScl("F", Source);
  L_Basis.wb_WrScl("F", Contact.Contact);
  L_Basis.wb_WrStr("F", Contact.Name);
  L_Basis.wb_WrStr("F", Contact.FirmName);
  L_Basis.wb_WrStr("F", L_ctc.GetCtcValType_asStr());
  L_Basis.wb_WrStr("F", CtcVal.Value);
  L_Basis.wb_WrStr("F", CtcVal.Comment);
  IF wOfficer THEN
   IF wStaff THEN
    L_Basis.wb_WrScl("F", Staff.TSN);
    L_Basis.wb_WrStr("F", Man.Name);
    CONFORM(Staff, MyFirm);
    L_Basis.wb_WrScl("F", MyFirm.MyFirm);
    L_Basis.wb_WrStr("F", MyFirm.Name);
   ELSE
    L_Basis.wb_WrStr("F", "");
    L_Basis.wb_WrStr("F", "");
    L_Basis.wb_WrStr("F", "");
    L_Basis.wb_WrStr("F", "");
   END;
   L_Basis.wb_WrScl("F", L_Staff.getService());
   L_Basis.wb_WrStr("F", L_Staff.getServiceName());
   L_Basis.wb_WrScl("F", L_Staff.getDepart());
   L_Basis.wb_WrStr("F", L_Staff.getDepartName());
   L_Basis.wb_WrScl("F", Officer.Sort);
   L_Basis.wb_WrStr("F", Sort.Name);
   L_Basis.wb_WrScl("F", Officer.Officer);
   L_Basis.wb_WrScl("F", Officer.Post);
   L_Basis.wb_WrStr("F", Post.Name);
   L_Basis.wb_WrScl("F", Officer.Union);
   L_Basis.wb_WrStr("F", Union.Name);
  ELSE
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
  END;
  L_Basis.wb_TermLine("F");
 END {MakePart};

 PRIVATE PROCEDURE MakeFirmCtcPart();
 BEGIN
  L_Basis.wb_WrScl("F", "⠪ ࠣ");
  L_Basis.wb_WrScl("F", Contact.Contact);
  L_Basis.wb_WrStr("F", Contact.Name);
  L_Basis.wb_WrStr("F", Contact.FirmName);
  IF ~!FCtcLst.Type THEN
   L_Basis.wb_WrStr("F", L_Str.PoolItem(L_ctc.cvt_Pool, FCtcLst.Type));
  ELSE
   L_Basis.wb_WrStr("F", "");
  END;
  L_Basis.wb_WrStr("F", FCtcLst.Value);
  L_Basis.wb_WrStr("F", FCtcLst.Comment);
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrScl("F", MyFirm.MyFirm);
  L_Basis.wb_WrStr("F", MyFirm.Name);
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_TermLine("F");
 END {MakeFirmCtcPart};

 PRIVATE PROCEDURE MakeOneContact(D: DATE; wOfficer, wStaff: SCAL[2]; Source: STRING[]);
 BEGIN
  SELECT(CtcVal, Contact, , Contact.Contact);
  WHILE OCCURE(CtcVal) DO
   IF L_DatTim.IsActive(D, CtcVal.Begin, CtcVal.Till) & (CtcVal.Coverage = L_ctc.cvc_Work) THEN
    MakePart(wOfficer, wStaff, Source);
   END;
   NEXT(CtcVal);
  END; (* WHILE OCCURE(CtcVal) ... *)
 END {MakeOneContact};

 PRIVATE PROCEDURE ConformFromOfficerToOthers();
 BEGIN
  CONFORM(Officer, Sort);
  CONFORM(Officer, Post);
  CONFORM(Officer, Union);
 END {ConformFromOfficerToOthers};
 
 PUBLIC PROCEDURE CTC01();
  CONST
   bpId = "CTC01";
  VAR
   Count: NUMERIC[0];
   D    : DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, "⠪  ।", L_bp.t_Basis, L_General.timeCond_OnDate);
  D:=Memo.ud_cd();
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  MakeTop();

  SELECT(Contact, Contact);
  WHILE OCCURE(Contact) DO
   PROMPT(Contact.Contact);
   IF L_DatTim.IsActive(D, Contact.Begin, Contact.Till) THEN
    IF SELECT(Officer, Contact, Contact.Contact) THEN
     WHILE OCCURE(Officer) DO
      ConformFromOfficerToOthers();
      Count:=0;
      SELECT(StaffLog, Officer, , Officer.Sort, Officer.Officer);
      WHILE OCCURE(StaffLog) DO
       IF L_Staff.InOrder(D) & ~L_Staff.IsDischargeStaffLog() THEN
        CONFORM(StaffLog, Staff);
        CONFORM(Staff, Man);
        MakeOneContact(D, 1, 1, "祥 ");
        INC(Count);
       END;
       NEXT(StaffLog);
      END; (* WHILE OCCURE(StaffLog) ... *)
      IF Count = 0 THEN
       MakeOneContact(D, 1, 0, "祥 ");
      END;
      NEXT(Officer);
     END; (* WHILE OCCURE(Officer) ... *)
    ELSIF SEARCH(Man, Contact, Contact.Contact) THEN
     IF L_Staff.IsStandOnAnyMainContract(Man.Man, D) & L_Staff.rInState(D) THEN
      CONFORM(StaffLog, Officer);
      ConformFromOfficerToOthers();
      MakeOneContact(D, 1, 1, "᪮ ");
     END; (* IF L_Staff.IsStandOnAnyMainContract ... *)
    ELSIF ~SELECT(FirmCtc, Contact, Contact.Contact) THEN
     MakeOneContact(D, 0, 0, "");
    END;
   END;
   NEXT(Contact);
  END; (* WHILE OCCURE(Contact) ... *)

  SELECT(MyFirm, MyFirm);
  WHILE OCCURE(MyFirm) DO
   IF (MyFirm.MyFirm # P_Firm.mf_Fict) & L_DatTim.IsActive(D, MyFirm.Begin, MyFirm.Till) THEN
    CONFORM(MyFirm, Firm);
    L_ctc.MakeFCtcLst(L_ctc.ls_Firm, D);
    SELECT(FCtcLst, Source, , L_ctc.cls_CtcVal);
    WHILE OCCURE(FCtcLst) DO
     L_General.CallUs(SEARCH(Contact, Contact, FCtcLst.Contact));
     IF !FCtcLst.Coverage | (FCtcLst.Coverage = L_ctc.cvc_Work) THEN
      MakeFirmCtcPart();
     END;
     NEXT(FCtcLst);
    END; (* WHILE OCCURE(FCtcLst) ... *)
    L_AFM.AF_PurgeTemp("FCtcLst");
   END;
   NEXT(MyFirm);
  END; (* WHILE OCCURE(MyFirm) ... *)

  FIO.Close(F);
  L_bp.End();
 END {CTC01};

END.