(*
%Copyright   (c) Polak IT
%Author      11.06.2009 17:07:22 POLAK\LDA
%Purpose     ᯮ짮   ࠧ१
%Type        report
%Specific    SYS
%Modified    26.02.2013 13:51:50 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_OwnData, L_StdFrm, L_General, L_AFM, L_Str, Memo, L_DatTim, P_Firm, L_Acnt;

 CONST
  rm_All    = 0;
  rm_Actual = 1;

  rm_Pool = "|騥";

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
ACSet.ACSet, L, ""
ACSet.Name, L, ""
?, C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|                  ᯮ짮   ࠧ१ ### ################################                |
|############################################################################################################|
}
*)

(*
$P{ SubTop_CostItem:
@
|------------------------------------------------------------------------------------------------------------|
| 室  室                                                             |         |        |
|--------------------------------------------------------------------------------------|----------|----------|
}
*)

(*
$P{ Line_CostItem:
CostItem.CostItem, L, ""
CostItem.Name, L, ""
CostItem.Leaf, L, "|"
CostItem.Begin, L, "D.N.y"
CostItem.Till, L, "D.N.y"
@
|####### ########################################################################## ###|##########|##########|
}
*)

(*
$P{ SubTop_Contract:
@
|------------------------------------------------------------------------------------------------------------|
|                                                                               |         |        |
|--------------------------------------------------------------------------------------|----------|----------|
}
*)

PROCEDURE ContractorBriefName(): STRING[];
BEGIN
 IF ~!Contract.Firm THEN
  RETURN P_Firm.FP_ContractorBriefName(Contract.Firm, Memo.ud_cd());
 ELSE
  RETURN "";
 END;
END {ContractorBriefName};

(*
$P{ Line_Contract:
Contract.Contract, L, ""
Contract.Name, L, ""
Contract.Leaf, L, "|"
Contract.Firm, L, ""
ContractorBriefName(), L, ""
Contract.Begin, L, "D.N.y"
Contract.Till, L, "D.N.y"
@
|####### ######################################## ###|#### ############################|##########|##########|
}
*)

(*
$P{ SubTop_MTMM:
@
|------------------------------------------------------------------------------------------------------------|
|奬  |                              |                            |         |        |
|---------------|------------------------------------|---------------------------------|----------|----------|
}
*)

(*
$P{ Line_MTMM:
MTMM.MTMM, L, ""
MTMM.MathType, L, ""
MathType.Name, L, ""
MTMM.MMode, L, ""
MMode.Name, L, ""
MMode.Sign, L, ""
MTMM.Begin, L, "D.N.y"
MTMM.Till, L, "D.N.y"
@
|####           |## #################################|### ######################### ###|##########|##########|
}
*)


(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE PutInObjLs(_Kind: LIKE(ACSet.Kind); Object: SCAL[1E7]);
 BEGIN
  ObjLs.Kind  :=_Kind;
  ObjLs.Object:=Object;
  INSERT(ObjLs);
 END {PutInObjLs};

 PRIVATE PROCEDURE AllowedObject(RepMode: SCAL[2]; _Begin, _Till: DATE): SCAL[2];
 BEGIN
  RETURN (RepMode = rm_All) | L_DatTim.IsActive(Memo.ud_cd(), _Begin, _Till);
 END {AllowedObject};

 PRIVATE PROCEDURE GatherByACSetKind(_Kind: LIKE(ACSet.Kind); RepMode: SCAL[2]);
 BEGIN
  IF    _Kind = L_Acnt.acsk_Math THEN
   SELECT(MTMM, ACSet, , ACSet.ACSet);
   WHILE OCCURE(MTMM) DO
    PROMPT(": 奬   " + MTMM.MTMM);
    IF AllowedObject(RepMode, MTMM.Begin, MTMM.Till) THEN
     PutInObjLs(_Kind, MTMM.MTMM);
    END;
    NEXT(MTMM);
   END; (* WHILE OCCURE(MTMM) ... *)
  ELSIF _Kind = L_Acnt.acsk_CostItem THEN
   SELECT(CostItem, ACSet, , ACSet.ACSet);
   WHILE OCCURE(CostItem) DO
    PROMPT(":  " + CostItem.CostItem);
    IF AllowedObject(RepMode, CostItem.Begin, CostItem.Till) THEN
     PutInObjLs(_Kind, CostItem.CostItem);
    END;
    NEXT(CostItem);
   END; (* WHILE OCCURE(CostItem) ... *)
  ELSIF _Kind = L_Acnt.acsk_Contract THEN
   SELECT(Contract, ACSet, , ACSet.ACSet);
   WHILE OCCURE(Contract) DO
    PROMPT(":  " + Contract.Contract);
    IF AllowedObject(RepMode, Contract.Begin, Contract.Till) THEN
     PutInObjLs(_Kind, Contract.Contract);
    END;
    NEXT(Contract);
   END; (* WHILE OCCURE(Contract) ... *)
  ELSE
   L_General.Error(" ꥪ" + _Kind);
  END;
 END {GatherByACSetKind};

 PRIVATE PROCEDURE Gather(RepMode: SCAL[2]);
 BEGIN
  GatherByACSetKind(L_Acnt.acsk_Math,     RepMode);
  GatherByACSetKind(L_Acnt.acsk_CostItem, RepMode);
  GatherByACSetKind(L_Acnt.acsk_Contract, RepMode);
 END {Gather};

 PRIVATE PROCEDURE PrintPart(PartName: STRING[]; _Kind: LIKE(ACSet.Kind));
 BEGIN
  MAKEPART(R, ^(PartName + "_" + L_Str.PoolItem("MTMM|CostItem|Contract", _Kind)));
 END {PrintPart};

 PRIVATE PROCEDURE MakeRep(RepMode: SCAL[2]);
  VAR
   RepName: STRING[];
 BEGIN
  RepName:="CACS" + RepMode;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, L_Str.PoolItem("   ꥪ|   " + L_DatTim.DateStr(Memo.ud_cd()) + " ꥪ", RepMode));

  SELECT(ObjLs, ObjLs);
  WHILE OCCURE(ObjLs) DO
   NARROWSEL(ObjLs, Kind);
   PrintPart("SubTop", ObjLs.Kind);
   WHILE OCCURE(ObjLs) DO
    PROMPT(" " + ObjLs.Object);

    IF    ObjLs.Kind = L_Acnt.acsk_Math THEN
     SEARCH(MTMM, MTMM, , ObjLs.Object);
     CONFORM(MTMM, MathType);
     CONFORM(MTMM, MMode);
    ELSIF ObjLs.Kind = L_Acnt.acsk_CostItem THEN
     SEARCH(CostItem, CostItem, , ObjLs.Object);
    ELSIF ObjLs.Kind = L_Acnt.acsk_Contract THEN
     SEARCH(Contract, Contract, , ObjLs.Object);
    END;
    PrintPart("Line", ObjLs.Kind);
    NEXT(ObjLs);
   END; (* WHILE OCCURE(ObjLs) ... *)
   NEXTINEXTENDEDSEL(ObjLs, Kind);
  END; (* WHILE OCCURE(ObjLs) ... *)

  MAKEPART(R, Bot);
 END {MakeRep};

 PRIVATE PROCEDURE Make_CACSet(RepMode: SCAL[2]);
 BEGIN
  L_AFM.MakeIndex("ObjLs", "Kind  : LIKE(ACSet.Kind);" +
                              "Object: SCAL[1E7]");
  Gather(RepMode);
  MakeRep(RepMode);
 END {Make_CACSet};

BEGIN
 SE_ACCESSDATAMODE(AccessDataMode_SOFT);
 L_General.Assert(ACCESS(ACSet), " ⠭   ࠧ१");
 IF    MODE = 100 THEN
  Make_CACSet(rm_All);
 ELSIF MODE = 101 THEN
  Make_CACSet(rm_Actual);
 ELSE
  L_General.BadMode(MODE);
 END;
END.