(*
%Copyright   (c) Polak Computer System
%Author      14.08.2001 10:53:05 SAN
%Purpose     ᯮ짮 Apport
%Type        report
%Specific    SYS
%Modified    26.02.2013 13:51:55 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_OwnData, DBD, L_AFM;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
"宦 ᯮ樨 "+Apport.Apport+" "+Apport.Name, C, ""
@
############################################################# ########## #####
==============================================================================
|############################################################################|
}
*)

(*
$P{ TopSub:
DBD.FileDescription(^Index._File), L, ""
@
|----------------------------------------------------------------------------|
|############################################################################|
|----------------------------------------------------------------------------|
| ࠧ१                             | ࠧ१                            |
|--------------------------------------|-------------------------------------|
}
*)

(*
$P{ Line:
AcCut.AcCut, L, ""
AcCut.Name, L, ""
AcCut2.AcCut2, L, ""
?, L, ""
@
|###### ###############################|###### ##############################|
}
*)

(*
$P{ Bot:
@
=(c) Polak-===================================================================
}
*)

 VAR
  curFile: STRING[];
  _AcCut2: LIKE(AcCut2.AcCut2);
  Cnt,
  i      : NUMERIC[0];

BEGIN
 SE_ACCESSDATAMODE(AccessDataMode_SOFT);
 L_General.Assert(ACCESS(Apport), " ⠭ ⥪ ᯮ");

 OPENREP(R, L_General.NameConnection("CAPRT"), Create);
 MAKEPART(R, Top);

 L_AFM.MakeIndex("Index", "_File  : STRING[8];"+
                             "_AcCut : LIKE(AcCut.AcCut);"+
                             "_AcCut2: LIKE(AcCut2.AcCut2)");
 i:=0;
 WHILE i < DBD.LinkAmount(Apport) DO
  curFile:=DBD.LinkCooFileName(Apport, ^(DBD.LinkName(Apport, i)));
  Cnt:=0;
  SELECT(^curFile, Apport, , Apport.Apport);
  WHILE OCCURE(^curFile) DO
   PROMPT(" " + curFile + " " + FLDTOSTR(Cnt, "0", 0));
   IF DBD.FieldExist(^curFile, AcCut2) THEN
    _AcCut2:=^curFile.AcCut2;
   ELSE
    SETEMPTY(_AcCut2);
   END;
   IF ~SELECT(Index, Index, curFile, ^curFile.AcCut, _AcCut2) THEN
    Index._File  :=curFile;
    Index._AcCut :=^curFile.AcCut;
    Index._AcCut2:=_AcCut2;
    INSERT(Index);
   END;
   INC(Cnt);
   NEXT(^curFile);
  END; (* WHILE OCCURE(^curFile) ... *)
  INC(i);
 END; (* WHILE i < ... *)

 SELECT(Index, Index);
 WHILE OCCURE(Index) DO
  PROMPT(Index._File);
  CHANGESEL(Index, Index, , Index._File);
  MAKEPART(R, TopSub);
  WHILE OCCURE(Index) DO
   SEARCH(AcCut, AcCut, , Index._AcCut);
   IF ~!Index._AcCut2 THEN
    SEARCH(AcCut2, AcCut2, , Index._AcCut2);
    MAKEPART(R, Line, AcCut2.Name);
   ELSE
    MAKEPART(R, Line);
   END;
   NEXT(Index);
  END; (* WHILE OCCURE(Index) ... *)
  LAST(Index);
  CHANGESEL(Index, Index);
  NEXT(Index);
 END; (* WHILE OCCURE(Index) ... *)

 MAKEPART(R, Bot);
 CLOSEREP(R);
 L_AFM.AF_PurgeTemp("Index");
END.
