(*
%Copyright   (c) Polak IT
%Author      30.11.2004 10:32:35 POLAK\GAV
%Purpose     ᪨    ॣ/࠭
%Type        report
%Specific    SYS
%Modified    24.03.2014 17:14:52 POLAK\GAV
%Environment
*)

 MODULE C_Countr [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_OwnData, L_General, L_AFM, L_Man, L_Russia;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
|----------------------------------------------------------------------------|
|                                    |            ࠭  ॣ            |
|     ⢮          |---------------------------------------|
|                                    |஦ |ॣ|䠪|ࠦ|
|------------------------------------|---------|---------|---------|---------|
}
*)

(*
$P{ Line:
?, L, ""
?, L, ""
tmp.Country[L_Russia.at_BthMA], L, ""
tmp.Region[L_Russia.at_BthMA], L, ""
tmp.Country[L_Russia.at_RgMA], L, ""
tmp.Region[L_Russia.at_RgMA], L, ""
tmp.Country[L_Russia.at_DwMA], L, ""
tmp.Region[L_Russia.at_DwMA], L, ""
tmp.Country[L_Russia.at_CtMA], L, ""
tmp.Region[L_Russia.at_CtMA], L, ""
@
|##### ##############################| ###  ## | ###  ## | ###  ## | ###  ## |
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE c_Country();
 BEGIN
  CREATE_TABLE(tmp);
  CREATE_FIELD(tmp, Name   , LIKE(Man.Name));
  CREATE_FIELD(tmp, Man    , LIKE(Man.Man));
  CREATE_FIELD(tmp, Country, LIKE(ManAdr.Country)[4]);
  CREATE_FIELD(tmp, Region , LIKE(ManAdr.Region)[4]);
  CREATE_INDEX(tmp, tmp, PLURAL, , , Name, Man);
  SET_VERSION_OF_TABLE(tmp, 0000);
  L_AFM.CreateTemp("tmp");
 
  WHILE OCCURE(ManAdr) DO
   PROMPT(ManAdr.Man);
   CONFORM(ManAdr, Man);
   SELECT(tmp, tmp, , Man.Name, Man.Man);
   WHILE OCCURE(tmp) &
      (~!tmp.Country[ManAdr.AdrType] | ~!tmp.Region [ManAdr.AdrType]) DO
    NEXT(tmp);
   END;
   IF ~OCCURE(tmp) THEN
    DEFAULT(tmp);
    tmp.Name:=Man.Name;
    tmp.Man :=Man.Man;
    INSERT(tmp);
   END;
   tmp.Country[ManAdr.AdrType]:=ManAdr.Country;
   tmp.Region [ManAdr.AdrType]:=ManAdr.Region;
   REPLACE(tmp);
   NEXT(ManAdr);
  END; (* WHILE OCCURE(ManAdr) ... *)
 
  SELECT(tmp, tmp);
  WHILE OCCURE(tmp) DO
   CHANGESEL(tmp, tmp, , tmp.Name, tmp.Man);
   PROMPT(tmp.Name);
   MAKEPART(R, Line, tmp.Man, tmp.Name);
   WHILE NEXT(tmp) DO
    MAKEPART(R, Line);
   END; (* WHILE OCCURE(tmp) ... *)
   LAST(tmp);
   CHANGESEL(tmp, tmp);
   NEXT(tmp);
  END; (* WHILE OCCURE(tmp) ... *)
  MAKEPART(R, Bot);
  L_AFM.AF_PurgeTemp("tmp");
 END {c_Country};

 PUBLIC PROCEDURE cCntr();
  VAR
   RepName: STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  ACCESS(Country);
  SELECT(ManAdr, Country, , Country.Country);
  RepName:="cCntr";
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, "᪨    ࠭ " + Country.Country + " " + Country.Name);
  c_Country();
  L_General.SurveyLastReport();
 END {cCntr};

 PUBLIC PROCEDURE cRegn();
  VAR
   RepName: STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  ACCESS(Region);
  SELECT(ManAdr, Region, , Region.Region);
  RepName:="cRegn";
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, "᪨    ॣ " + Region.Region + " " + Region.Name);
  c_Country();
  L_General.SurveyLastReport();
 END {cRegn};

END.