(*
%Copyright   (c) Polak Computer System
%Author      21.05.2002 18:29:30 LDA
%Purpose      祭 ⥩,  ࠢ  죮⭮ ᨮ ᯥ祭 裡  ᮡ묨 ᫮ﬨ 㤠
%Type        report
%Specific    SYS
%Modified    17.06.2014 19:06:07 POLAK\Gina
%Environment
*)

 MODULE C_PnsAtt [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_Staff, L_PagePr, L_AFM, L_Man, L_Packet, L_DatTim, L_APtm, L_Sheet, L_AvePay, L_StdFrm,
        Str, Math, P_MyFirm, P_Staff, P_Man, P_Firm, L_SFee;

 VAR
  RepName   : STRING[];
  PageNum   : NUMERIC[0];
  glbPnsAttr: LIKE(PnsAttr.PnsAttr);

 PRIVATE PROCEDURE GetBankData(i: NUMERIC[0]): STRING[];
 BEGIN
  RETURN Str.Condense(Str.Item(P_Firm.FP_BankReq(P_Firm.fomf(Tmp.MyFirm), Memo.ud_ut()), ",", i));
 END {GetBankData};

(*
$P{ RepTop:
P_Firm.FP_FirmName(P_Firm.fomf(Tmp.MyFirm), Memo.ud_cd()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
P_Firm.FP_FirmNameFP(P_Firm.fomf(Tmp.MyFirm), Memo.ud_ut()), L, ""
GetBankData(0), L, ""
GetBankData(1), L, ""
GetBankData(2), L, ""
GetBankData(3), L, ""
P_Firm.FP_OKPO(P_Firm.fomf(Tmp.MyFirm), Memo.ud_ut()), L, ""
P_Firm.FP_INN(P_Firm.fomf(Tmp.MyFirm), Memo.ud_ut()), L, ""
P_MyFirm.NumInPFR(Tmp.MyFirm, Memo.ud_ut()), L, ""
@
############################################################################################################                                                                                                             ########## #####
=#####===================================================================================================================================================================================================================================
|                                                             ᯨ᮪ ࠡ⭨,  ࠢ  죮⭮ ᨮ ᯥ祭  裡  ᮡ묨 ᫮ﬨ 㤠                                                            |
|                                                                           ਮ  ##########  ##########                                                                                                                           |
|                                                                           #######################################################################                                                                                     |
|                                                                           / ##################################################################                                                                                     |
|                                                                           #######################################################################                                                                                     |
|                                                                           #######################################################################                                                                                     |
|                                                                           #######################################################################                                                                                     |
|                                                                            ##################################################################                                                                                     |
|                                                                            ###################################################################                                                                                     |
|                                                                           樮  #################################################                                                                                     |
}
*)

(*
$P{ PageTop:
@
|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|N |                                             |                     |客     |                       | 樨        | ᫮|ਮ ࠡ        |ਬ砭                                     |
|    |                                                |                           |         |                                | ᯨ᪠         |㤠      |                     |                                               |
|----|------------------------------------------------|---------------------------|--------------|--------------------------------|-------------------|-----------|---------------------|-----------------------------------------------|
}
*)

(*
$P{ Line:
?, R, ""
?, L, ""
Sort.Name, L, ""
L_Man.GetManSINumber_asStr(), L, ""
Tmp.PAName, L, ""
Str.Item(Tmp.Type, ";", 1), L, ""
Str.Item(Tmp.Type, ";", 0), L, ""
Tmp.BegD, L, "D.N.y"
Tmp.EndD, L, "D.N.y"
Str.Item(Tmp.Type, ";", 3), L, ""
@
|####|################################################|###########################|##############|################################|###################|###########|########## ##########|###############################################|
}
*)

(*
$P{ LineFilling:
@
|    |                                                |                           |              |                                |                   |           |                     |                                               |
}
*)

(*
$P{ PageBot:
?, L, ""
@
=(c) Polak====================================================================================================================================================================================================================== ###==
}
*)

(*
$P{ RepBot:
P_Firm.FP_LeadPostName1(P_Firm.fomf(Tmp.MyFirm), SYSDATE()), R, ""
P_Firm.FP_LeadName(P_Firm.fomf(Tmp.MyFirm), SYSDATE()), L, ""
P_MyFirm.StaffDepChiefPostName(Tmp.MyFirm, SYSDATE()), R, ""
P_MyFirm.StaffDepChiefName(Tmp.MyFirm, SYSDATE()), L, ""
@
|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|                                                                                                                                                                                                                                       |
|                                                                             ######################################################### ..................... ##########################################################################|
|                                                                                                                                                                                                                                       |
|                                                                             ######################################################### ..................... ##########################################################################|
=(c) Polak===============================================================================================================================================================================================================================
}
*)

 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CREATE_TABLE(Tmp, , "");

  CREATE_FIELD(Tmp, MyFirm,   LIKE(MyFirm.MyFirm),   , , , "");
  CREATE_FIELD(Tmp, Name,     LIKE(Man.Name),        , , , " ");
  CREATE_FIELD(Tmp, Man,      LIKE(Man.Man),         , , , " ");
  CREATE_FIELD(Tmp, BegD,     DATE,                  , , , "砫 ࠡ");
  CREATE_FIELD(Tmp, EndD,     DATE,                  , , , "砭 ࠡ");
  CREATE_FIELD(Tmp, Sort,     LIKE(Sort.Sort),       , , , "");
  CREATE_FIELD(Tmp, PAName,   LIKE(PnsAttr.Name),    , , , " ᨮ ᮡ");
  CREATE_FIELD(Tmp, Type,     STRING[256],           , , , "");

  CREATE_INDEX_AND_LINK(Tmp, MyFirm,  PLURAL, MyFirm,  MyFirm,  USER, , , MyFirm, Name, Man, BegD);
  CREATE_INDEX_AND_LINK(Tmp, Man,     PLURAL, Man,     Man,     USER, , , Man);
  CREATE_INDEX_AND_LINK(Tmp, Sort,    PLURAL, Sort,    Sort,    USER, , , Sort);

  SET_VERSION_OF_TABLE(Tmp, 0);
  L_AFM.CreateTemp("Tmp");
 END {Create_Tmp};

 PRIVATE PROCEDURE PnsAttrCond(curPnsAttr: LIKE(PnsAttr.PnsAttr)): SCAL[2];
 BEGIN
  IF !glbPnsAttr THEN
   RETURN (curPnsAttr # L_Packet.OrdinaryPnsAttr);
  ELSE
   RETURN (curPnsAttr = glbPnsAttr);
  END;
 END {PnsAttrCond};

 PRIVATE PROCEDURE CheckStaffP_SpecificForPF(BD, ED: DATE): SCAL[2];
 BEGIN
  SETSEL(StaffPro, TSN, Staff.TSN, P_Staff.P_SpecificForPF);
  SRCINSEL(StaffPro, LE, , ED);
  WHILE OCCURE(StaffPro) & (StaffPro.EndDate >= BD) DO
   IF PnsAttrCond(P_Staff.GetP_SpecificForPF(Staff.TSN, StaffPro.Date)) THEN
    RETURN 1;
   END;
   PREV(StaffPro);
  END; (* WHILE OCCURE(StaffPro) ... *)
  RETURN 0;
 END {CheckStaffP_SpecificForPF};

 PRIVATE PROCEDURE StaffLogCond(BD, ED: DATE): SCAL[2];
 BEGIN
  RETURN PnsAttrCond(Officer.PnsAttr) | CheckStaffP_SpecificForPF(BD, ED);
 END {StaffLogCond};

 PRIVATE PROCEDURE _RprtTop(Mode: SCAL[20]);
 BEGIN
  IF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, RepTop);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtTop};

 PRIVATE PROCEDURE _PageTop(Mode: SCAL[20]);
 BEGIN
  IF (Mode = L_PagePr.m_Print) | (Mode = L_PagePr.m_RDoneTop) THEN
   MAKEPART(R, PageTop);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageTop};

 PRIVATE PROCEDURE _PageBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(PageBot));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, PageBot, PageNum);
   INC(PageNum);
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_None);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageBot};

 PRIVATE PROCEDURE _RprtBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(RepBot));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, RepBot);
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_Fill);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtBot};

 PRIVATE PROCEDURE _Filling(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(LineFilling));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, LineFilling);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_Filling};

 PRIVATE PROCEDURE GetAvePayType(D: DATE): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETSEL(AvePay, EBDTSN, Sheet.TSN);
  SRCINSEL(AvePay, GE, , D);
  WHILE OCCURE(AvePay) DO
   IF L_AvePay.IsRealAvePay() THEN
    CONFORM(AvePay, AvePayP);
    WHILE OCCURE(AvePayP) DO
     IF L_DatTim.IsActive_Inc(D, AvePayP.StartD, AvePayP.StopD) THEN
      CONFORM(AvePayP, AveTypeP);
      IF ~!AveTypeP.JMode THEN
       Result:=L_Packet.E_SpecStageForPens(D, AveTypeP.JMode);
       IF ~!Result & ~L_Packet.IsPAttMInsType(Result) & (StfLg.PnsAttr # L_Packet.OrdinaryPnsAttr) THEN
        CONFORM(AvePayP, JMode);
        Result:=" ; ; ;"+JMode.Name+" ("+AvePay.DocNum+")"
       END;
       RETURN Result;
      END;
     END;
     NEXT(AvePayP);
    END; (* WHILE OCCURE(AvePayP) ... *)
   END;
   NEXT(AvePay);
  END; (* WHILE OCCURE(AvePay) ... *)
  RETURN EMPTYOF(JMode.JMode);
 END {GetAvePayType};

 PRIVATE PROCEDURE GetSpecType(): STRING[];
  VAR
   D       : DATE;
   Result  : STRING[];
 BEGIN
  SETEMPTY(Result);
  D:=Sheet.Period+Sheet.Day-1;
  IF Sheet.Source = L_Sheet.src_AvePay THEN
   Result:=GetAvePayType(D);
  END;
  IF !Result THEN
   Result:=L_Packet.E_SpecStageForPens(D, Sheet.JMode);
   IF ~!Result & ~L_Packet.IsPAttMInsType(Result) & (StfLg.PnsAttr # L_Packet.OrdinaryPnsAttr) THEN
    CONFORM(Sheet, JMode);
    Result:=" ; ; ;"+JMode.Name;
   END;
  END;
  IF ~!Result THEN
   (*모뢠 ଠ  .塞 ⠦*)
   Result:=Str.Item(Result, ";", 0)+";"+Str.Item(Result, ";", 1)+"; ;"+Str.Item(Result, ";", 3);
  END;
  RETURN Result;
 END {GetSpecType};

 PRIVATE PROCEDURE Ins_Tmp(_Name: STRING[]; BegD, EndD: DATE; Force: SCAL[2]): SCAL[2];
  VAR
   D       : DATE;
   Has     : SCAL[2];
   prvType,
   curType : STRING[];
   curPnsAttr: LIKE(PnsAttr.PnsAttr);
 BEGIN
  BegD:=Math.Max(BegD, Memo.ud_fr());
  EndD:=Math.Min(EndD, Memo.ud_ut());

  Has:=0;
  IF StaffLogCond(BegD, EndD) | Force THEN
   D:=BegD;
   SETSEL(Sheet, TSN, StaffLog.TSN);
   SRCINSEL(Sheet, GE, , L_DatTim.Per(BegD), L_DatTim.DAY(BegD));
   L_General.Assert(OCCURE(Sheet), "  ⠡  "+L_DatTim.DateStr(BegD)+"|  "+StaffLog.TSN);
   WHILE OCCURE(Sheet) & (D<=EndD) DO
    PROMPT(Man.Man+": ⠡ "+L_DatTim.DateStr(D));
    (*㦥  ⠡*)
    L_General.Assert(D=Sheet.Period+Sheet.Day-1, "  ⠡  "+L_DatTim.DateStr(D)+"|  "+Sheet.TSN);
    curPnsAttr:=L_SFee.GetPnsAttrOnDate(D);
    StfLg.PnsAttr:=curPnsAttr;
    REPLACE(StfLg);
    SEARCH(PnsAttr, PnsAttr, , curPnsAttr);

    curType:=GetSpecType();
    IF ~!curType & L_Packet.IsPAttMInsType(curType) THEN
     Has:=Has | PnsAttrCond(curPnsAttr);
    END;

    IF D=BegD (*ࢠ *) THEN
     prvType:="";
    END;

    IF curType # prvType THEN
     IF ~!prvType THEN
      Tmp.EndD   :=D-1;
      REPLACE(Tmp);
     END;
     IF ~!curType THEN
      Tmp.MyFirm :=Staff.MyFirm;
      Tmp.Name   :=_Name;
      Tmp.Man    :=Man.Man;
      Tmp.BegD   :=D;
      SETEMPTY(Tmp.EndD);
      Tmp.Sort   :=StaffLog.Sort;
      IF L_Packet.IsPAttMInsType(curType) THEN
       L_General.CallUs(curPnsAttr # L_Packet.OrdinaryPnsAttr);
       Tmp.PAName:=PnsAttr.Name;
      ELSE
       Tmp.PAName:="";
      END;
      Tmp.Type   :=curType;
      INSERT(Tmp);
     END;
     prvType:=curType;
    END;

    NEXT(Sheet);
    INC(D);
   END; (* WHILE OCCURE(Sheet) ... *)
   IF OCCURE(Tmp) & !Tmp.EndD THEN
    Tmp.EndD:=EndD;
    REPLACE(Tmp);
   END;
  END;

  RETURN Has;
 END {Ins_Tmp};

 PRIVATE PROCEDURE CondenseTmp();
  VAR
   prvBegD,
   prvEndD  : DATE;
   prvSort  : LIKE(Sort.Sort);
   prvPAName,
   prvType  : STRING[];
 BEGIN
  SELECT(Tmp, Man);
  WHILE OCCURE(Tmp) DO
   SETEMPTY(prvEndD, prvSort, prvPAName, prvType);
   NARROWSEL(Tmp, Man);
   WHILE OCCURE(Tmp) DO
    IF (prvEndD   = (Tmp.BegD-1)) &
       (prvSort   = Tmp.Sort) &
       (prvPAName = Tmp.PAName) &
       (prvType   = Tmp.Type) THEN
     PREV(Tmp);
     prvBegD:=Tmp.BegD;
     REMOVE(Tmp);
     Tmp.BegD:=prvBegD;
     REPLACE(Tmp);
    END;
    prvEndD  :=Tmp.EndD;
    prvSort  :=Tmp.Sort;
    prvPAName:=Tmp.PAName;
    prvType  :=Tmp.Type;
    NEXT(Tmp);
   END; (* WHILE OCCURE(File) *)
   NEXTINEXTENDEDSEL(Tmp, Man);
  END; (* WHILE OCCURE(Tmp) *)
 END {CondenseTmp};

 PRIVATE PROCEDURE Create_StfLg(); (* 㦥  L_Packet.E_SpecStageForPens()*)
 BEGIN
  L_AFM.MakeMultipleIndex("StfLg", "TSN: LIKE(Staff.TSN);" +
                                   "PnsAttr: LIKE(PnsAttr.PnsAttr)",
                          "StfLg: TSN");
 END {Create_StfLg};

 PRIVATE PROCEDURE Ins_StfLg();
 BEGIN
  StfLg.TSN :=Staff.TSN;
  SETEMPTY(StfLg.PnsAttr);
  INSERT(StfLg);
 END {Ins_StfLg};

 PRIVATE PROCEDURE MakeIndex();
  VAR
   ManName: STRING[];
   Has    : SCAL[2];
 BEGIN
  IF ~L_APtm.MonthIsClosed(Memo.ud_ut(), L_APtm.system_Salary) THEN
   (*㦥  ⠡*)
   L_StdFrm.Choice(L_DatTim.PeriodStr(Memo.ud_ut()) + "     ௫, १  ⥫");
  END;
  Create_Tmp();
  Create_StfLg();
  SELECT(Man, Man);
  WHILE OCCURE(Man) DO
   PROMPT(Man.Man);
   IF ~!Man.SINumber THEN
    Has:=0;
    ManName:=L_Packet.GetManInPFRFName(Memo.ud_ut());
    SELECT(Staff, Man, , Man.Man);
    WHILE OCCURE(Staff) DO
     IF (Staff.Contract#L_Staff.cnt_InternalCombine) & (Staff.Contract#L_Staff.cnt_OutStaff) &
        L_DatTim.IsActiveInIntvl_Inc(Memo.ud_fr(), Memo.ud_ut(), Staff.BegDate, Staff.EndDate) THEN
      Ins_StfLg();
      SETSEL(StaffLog, TSN, Staff.TSN);
      IF ~SRCINSEL(StaffLog, LE, Memo.ud_fr()) THEN
       FIRST(StaffLog);
      END;
      WHILE OCCURE(StaffLog) DO
       CONFORM(StaffLog, Officer);
       IF L_Staff.OrderInIntvl(Memo.ud_fr(), Memo.ud_ut()) & ~L_Staff.IsDischargeStaffLog() THEN
        SAVE(StaffLog);
        Has:=Ins_Tmp(ManName, StaffLog.Date, StaffLog.DateE, Has) | Has;
        RESTORE(StaffLog);
       END;
       NEXT(StaffLog);
      END; (* WHILE OCCURE(StaffLog) ... *)
     END;
     NEXT(Staff);
    END; (* WHILE OCCURE(Staff) ... *)

    IF ~Has THEN
     SETSEL(Tmp, Man, Man.Man);
     REMSEL(Tmp);
    END;
   END;
   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)
  L_AFM.AF_PurgeTemp("StfLg");
  CondenseTmp();
 END {MakeIndex};

 PRIVATE PROCEDURE PrintRep();
  VAR
   Amount  : NUMERIC[0];
   First   : SCAL[2];
   ManName : LIKE(Man.Name);
   oPrompt : PROMPT_LINE;
 BEGIN
  oPrompt:=PROMPT_LINE.Create(RepName);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  MakeIndex();

  PageNum:=1;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  SELECT(Tmp, MyFirm);
  WHILE OCCURE(Tmp) DO
   Amount:=1;
   L_PagePr.PagePr_Init("R", 60, PROCREF(_RprtTop),
                        PROCREF(_PageTop),
                        PROCREF(_PageBot),
                        PROCREF(_RprtBot),
                        PROCREF(_Filling));
   NARROWSEL(Tmp, MyFirm);
   WHILE OCCURE(Tmp) DO
    PROMPT(" "+Tmp.Man);
    CONFORM(Tmp, Man);
    ManName   :=Tmp.Name;
    IF P_Man.HasActualManPro(Man.Man, Memo.ud_ut(), P_Man.P_Pension) THEN
     ManName:=ManName+", ᨮ";
    END;
    First:=1;
    NARROWSEL(Tmp, Name, Man);
    WHILE OCCURE(Tmp) DO
     CONFORM(Tmp, Sort);
     L_PagePr.PagePr_BeforePrintLine(DEPTH("Line"));
     IF First THEN
      MAKEPART(R, Line, Amount, ManName);
      First:=0;
     ELSE
      MAKEPART(R, Line);
     END;
     NEXT(Tmp);
    END; (* WHILE OCCURE(Tmp) ... *)
    NEXTINEXTENDEDSEL(Tmp, Name, Man);
    INC(Amount);
   END; (* WHILE OCCURE(Tmp) ... *)
   LAST(Tmp);
   L_PagePr.PagePr_Done();
   NEXTINEXTENDEDSEL(Tmp, MyFirm);
  END; (* WHILE OCCURE(Tmp) ... *)
  L_AFM.AF_PurgeTemp("Tmp");
  L_General.SurveyLastReport();
 END {PrintRep};

 PUBLIC PROCEDURE PnsAt();
 BEGIN
  RepName:="PnsAt";
  L_General.Assert(ACCESS(PnsAttr), " ࠭ ᨮ ᮡ");
  glbPnsAttr:=PnsAttr.PnsAttr;
  PrintRep();
 END {PnsAt};

 PUBLIC PROCEDURE aPnsA();
 BEGIN
  RepName := "aPnsA";
  glbPnsAttr:=EMPTYOF(PnsAttr.PnsAttr);
  PrintRep();
 END {aPnsA};

END.
