(*
%Copyright   (c) Polak Computer System
%Author      22.01.2010 10:02:05 POLAK\San
%Purpose     ⮢  । ࠡ⭮ 
%Type        report
%Specific    SYS
%Modified    19.09.2014 12:00:22 POLAK\Gina
%Environment
*)

 MODULE Dst10 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Acnt, L_EC, L_APtm, L_Staff, L_Str,
        L_AcCut, L_PRoll, L_Basis, Math, FIO, Memo, E_PRoll,
        P_Firm, L_OTx, L_StdFrm, L_SFee, P_MCList, L_bp, L_XObj, P_MyFirm;

 PRIVATE TYPE
  tType = SCAL[32];

 PRIVATE CONST
  t_OvrPFR = MAXOF(L_Acnt.tUnfoldedAcntVectorPart) + 1;
  t_OvrFSS = t_OvrPFR + 1;
  t_OvrMFS = t_OvrPFR + 2;
  t_Pool = L_Acnt.uavp_Pool + "|ॢ襭 |ॢ襭 |ॢ襭 ";

 PRIVATE VAR
  wMF,
  wMP: SCAL[2];

 PRIVATE PROCEDURE Excel_MakeTop(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "㯯  ");
  L_Basis.wb_WrInQM(F, "ਮ");
  L_Basis.wb_WrInQM(F, " ਮ");
  L_Basis.wb_WrInQM(F, "_१");
  L_Basis.wb_WrInQM(F, "_१");
  L_Basis.wb_WrInQM(F, "_१");
  L_Basis.wb_WrInQM(F, "_");
  L_Basis.wb_WrInQM(F, "_");
  L_Basis.wb_WrInQM(F, "_");
  L_Basis.wb_WrInQM(F, "१");
  L_Basis.wb_WrInQM(F, "१");
  L_Basis.wb_WrInQM(F, "१");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ꥪ");
  L_Basis.wb_WrInQM(F, "ꥪ");
  L_Basis.wb_WrInQM(F, "ꥪ");
  L_Basis.wb_WrInQM(F, " /");
  L_Basis.wb_WrInQM(F, " /");
  L_Basis.wb_WrInQM(F, "⭮襭  客 ᠬ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "㬬");
  L_Basis.wb_WrInQM(F, "㬬   ");
  L_Basis.wb_WrInQM(F, " " + L_Str.PoolItem(L_SFee.b_Pool, L_SFee.b_PFR));
  L_Basis.wb_WrInQM(F, " " + L_Str.PoolItem(L_SFee.b_Pool, L_SFee.b_FSS));
  L_Basis.wb_WrInQM(F, " " + L_Str.PoolItem(L_SFee.b_Pool, L_SFee.b_MSF));
  L_Basis.wb_WrInQM(F, " " + L_Str.PoolItem(L_SFee.b_Pool, L_SFee.b_PA1));
  L_Basis.wb_WrInQM(F, " " + L_Str.PoolItem(L_SFee.b_Pool, L_SFee.b_PA2));
  L_Basis.wb_WrInQM(F, " " + L_Str.PoolItem(L_SFee.b_Pool, L_SFee.b_PA3_1));
  L_Basis.wb_WrInQM(F, " " + L_Str.PoolItem(L_SFee.b_Pool, L_SFee.b_PA3_2));
  L_Basis.wb_WrInQM(F, " " + L_Str.PoolItem(L_SFee.b_Pool, L_SFee.b_PA3_3));
  L_Basis.wb_WrInQM(F, " " + L_Str.PoolItem(L_SFee.b_Pool, L_SFee.b_PA3_4));
  L_Basis.wb_WrInQM(F, " " + L_Str.PoolItem(L_SFee.b_Pool, L_SFee.b_PA4_0));
  L_Basis.wb_WrInQM(F, "筨");
  L_Basis.wb_WrInQM(F, L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_PFIn));
  L_Basis.wb_WrInQM(F, L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_PFAc));
  L_Basis.wb_WrInQM(F, L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_xFSS));
  L_Basis.wb_WrInQM(F, L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_MSFF));
  L_Basis.wb_WrInQM(F, L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_MSTF));
  L_Basis.wb_WrInQM(F, L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_PFOv));
  L_Basis.wb_WrInQM(F, L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_PFA1));
  L_Basis.wb_WrInQM(F, L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_PFA2));
  L_Basis.wb_WrInQM(F, L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_PFA3_1));
  L_Basis.wb_WrInQM(F, L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_PFA3_2));
  L_Basis.wb_WrInQM(F, L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_PFA3_3));
  L_Basis.wb_WrInQM(F, L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_PFA3_4));
  L_Basis.wb_WrInQM(F, L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_PFA4_0));
  L_Basis.wb_WrInQM(F, "⠢  ᠬ ' ࠢ⨧'");
  L_Basis.wb_WrInQM(F, "㬬 ᮢ ' ࠢ⨧'");
  L_Basis.wb_WrInQM(F, "");
(*!*)
  L_Basis.wb_WrInQM(F, " '᭮'");
(*!*)
  IF wMP THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, " ᭮ ");
  L_Basis.wb_TermLine(F);
 END {Excel_MakeTop};

 PRIVATE PROCEDURE E_ApplyDstModeMthForTravmOblig(P: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(P, PROCREF(E_PRoll.ApplyDstModeMthForTravmOblig), 0);
 END {E_ApplyDstModeMthForTravmOblig};

 PRIVATE PROCEDURE TravmObligBase(P: DATE): L_PRoll.tSum;
 BEGIN
  IF E_ApplyDstModeMthForTravmOblig(P) THEN
   RETURN L_SFee_M.asSum;
  ELSE
   RETURN L_SFee_M.Sum;
  END;
 END {TravmObligBase};

 PRIVATE PROCEDURE Excel_MakeLine(F                : STRING[];
                                  type             : tType;
                                  _TravmObligTariff: P_MyFirm.tTravmObligTariff;
                                  Value            : L_PRoll.tSum;
                                  curReasonCode    : L_SFee.tPFAReasonCode);
  CONST
   TravmObligTariffPrecision = PRECISIONOF(P_MyFirm.tTravmObligTariff);
   TravmObligTaxPrecision    = 3+2+2;
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(F, Man.Man);
  L_Basis.wb_WrScl(F, Man.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(t_Pool, type));
  IF (type = L_Acnt.uavp_CirDbt) | (type = L_Acnt.uavp_CirCrd) THEN
   L_Basis.wb_WrScl(F, L_Str.PoolItem(L_SFee.mag_Pool, L_SFee.ManAgeGroup(L_SFee_M.Period)));
   L_Basis.wb_WrDat(F, L_SFee_M.Period);
   L_Basis.wb_WrDat(F, L_SFee_M.Closed);
   SEARCH(AcCut, AcCut, , L_SFee_M.ofcAcCut);
   L_Basis.wb_WrScl(F, AcCut.AcCut);
   L_Basis.wb_WrStr(F, AcCut.Name);
   L_Basis.wb_WrStr(F, L_Acnt.GetAcCutSign(L_SFee_M.Period, AcCut.AcCut));
   L_Basis.wb_WrStr(F, L_Acnt.GetCAcntSign(L_SFee_M.Period, AcCut.AcCut));
   IF ~!L_SFee_M.ofcCostItem THEN
    SEARCH(CostItem, CostItem, , L_SFee_M.ofcCostItem);
    L_Basis.wb_WrScl(F, CostItem.CostItem);
    L_Basis.wb_WrStr(F, CostItem.Name);
   ELSE
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
   END;
   SEARCH(AcCut, AcCut, , L_SFee_M.AcCut);
   L_Basis.wb_WrScl(F, AcCut.AcCut);
   L_Basis.wb_WrStr(F, AcCut.Name);
   L_Basis.wb_WrStr(F, L_Acnt.GetAcCutSign(L_SFee_M.Period, AcCut.AcCut));
   L_Basis.wb_WrStr(F, L_Acnt.GetCAcntSign(L_SFee_M.Period, AcCut.AcCut));
   IF ~!L_SFee_M.XObject THEN
    SEARCH(XObject, XObject, , L_SFee_M.XObject);
    L_Basis.wb_WrStr(F, L_Str.PoolItem(L_XObj.o_Pool, XObject.Origin));
    L_XObj.AccessOrigin();
    IF    XObject.Origin = L_XObj.o_CostItem THEN
     L_Basis.wb_WrScl(F, CostItem.CostItem);
     L_Basis.wb_WrStr(F, CostItem.Name);
    ELSIF XObject.Origin = L_XObj.o_Contract THEN
     L_Basis.wb_WrScl(F, Contract.Contract);
     L_Basis.wb_WrStr(F, Contract.Name);
    ELSIF XObject.Origin = L_XObj.o_Global THEN
     L_Basis.wb_WrScl(F, XObject.XObject);
     L_Basis.wb_WrStr(F, L_XObj.GetXObjectOriginName());
    ELSIF XObject.Origin = L_XObj.o_Man THEN
     CONFORM(mfMan, Man);
     L_Basis.wb_WrScl(F, Man.Man);
     L_Basis.wb_WrStr(F, Man.Name);
    ELSE
     L_General.CallUs(0);
    END;
   ELSE
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
   END;
   L_Basis.wb_WrScl(F, MCList.MCode);
   L_Basis.wb_WrStr(F, MCList.Name);
   L_Basis.wb_WrStr(F, L_Str.PoolItem(P_MCList.a2sf_Pool, L_SFee_M.InSign));
   IF (L_SFee_M.InSign # P_MCList.a2sf_NotObject) & OCCURE(ManSFee) THEN
    L_Basis.wb_WrStr(F, L_Str.PoolItem(L_SFee.t_Pool, ManSFee.Type));
   ELSE
    L_Basis.wb_WrStr(F, "---");
   END;
   IF L_SFee_M.Source = L_SFee.s_Money THEN
    L_Basis.wb_WrNum(F, L_SFee_M.Sum, 2);
   ELSE
    L_Basis.wb_WrNum(F,            0, 2);
   END;
   L_Basis.wb_WrNum(F, L_SFee_M.asSum, 2);
   L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", L_SFee_M.asSum = L_SFee_M.Base[L_SFee.b_PFR]));
   L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", L_SFee_M.asSum = L_SFee_M.Base[L_SFee.b_FSS]));
   L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", L_SFee_M.asSum = L_SFee_M.Base[L_SFee.b_MSF]));
   L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", L_SFee_M.asSum = L_SFee_M.Base[L_SFee.b_PA1]));
   L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", L_SFee_M.asSum = L_SFee_M.Base[L_SFee.b_PA2]));
   L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", L_SFee_M.asSum = L_SFee_M.Base[L_SFee.b_PA3_1]));
   L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", L_SFee_M.asSum = L_SFee_M.Base[L_SFee.b_PA3_2]));
   L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", L_SFee_M.asSum = L_SFee_M.Base[L_SFee.b_PA3_3]));
   L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", L_SFee_M.asSum = L_SFee_M.Base[L_SFee.b_PA3_4]));
   L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", L_SFee_M.asSum = L_SFee_M.Base[L_SFee.b_PA4_0]));
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_SFee.s_Pool, L_SFee_M.Source));
   L_Basis.wb_WrNum(F, L_SFee_M.Fee[L_SFee.p_PFIn], 2);
   L_Basis.wb_WrNum(F, L_SFee_M.Fee[L_SFee.p_PFAc], 2);
   L_Basis.wb_WrNum(F, L_SFee_M.Fee[L_SFee.p_xFSS], 2);
   L_Basis.wb_WrNum(F, L_SFee_M.Fee[L_SFee.p_MSFF], 2);
   L_Basis.wb_WrNum(F, L_SFee_M.Fee[L_SFee.p_MSTF], 2);
   L_Basis.wb_WrNum(F, L_SFee_M.Fee[L_SFee.p_PFOv], 2);
   L_Basis.wb_WrNum(F, L_SFee_M.Fee[L_SFee.p_PFA1], 2);
   L_Basis.wb_WrNum(F, L_SFee_M.Fee[L_SFee.p_PFA2], 2);
   L_Basis.wb_WrNum(F, L_SFee_M.Fee[L_SFee.p_PFA3_1], 2);
   L_Basis.wb_WrNum(F, L_SFee_M.Fee[L_SFee.p_PFA3_2], 2);
   L_Basis.wb_WrNum(F, L_SFee_M.Fee[L_SFee.p_PFA3_3], 2);
   L_Basis.wb_WrNum(F, L_SFee_M.Fee[L_SFee.p_PFA3_4], 2);
   L_Basis.wb_WrNum(F, L_SFee_M.Fee[L_SFee.p_PFA4_0], 2);
   L_Basis.wb_WrNum(F, L_OTx.TravmOblig_MCList_Attitude(L_SFee_M.Period) * _TravmObligTariff, TravmObligTariffPrecision);
   L_Basis.wb_WrNum(F, L_OTx.TravmOblig_MCList_Attitude(L_SFee_M.Period) * _TravmObligTariff * TravmObligBase(L_SFee_M.Period) / 100, TravmObligTaxPrecision);
   L_Basis.wb_WrScl(F, L_SFee_M.TSN);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "?");
   L_Basis.wb_WrStr(F, "?");
   L_Basis.wb_WrNum(F, Value, 2);
   L_Basis.wb_WrNum(F, 0.00, 2);
   L_Basis.wb_WrStr(F, "?");
   L_Basis.wb_WrStr(F, "?");
   L_Basis.wb_WrStr(F, "?");
   L_Basis.wb_WrStr(F, "?");
   L_Basis.wb_WrStr(F, "?");
   L_Basis.wb_WrStr(F, "?");
   L_Basis.wb_WrStr(F, "?");
   L_Basis.wb_WrStr(F, "?");
   L_Basis.wb_WrStr(F, "?");
   L_Basis.wb_WrStr(F, "?");
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_SFee.s_Pool, L_SFee.s_Money));
   L_Basis.wb_WrNum(F, 0.00, 2);
   L_Basis.wb_WrNum(F, 0.00, 2);
   L_Basis.wb_WrNum(F, 0.00, 2);
   L_Basis.wb_WrNum(F, 0.00, 2);
   L_Basis.wb_WrNum(F, 0.00, 2);
   L_Basis.wb_WrNum(F, 0.00, 2);
   L_Basis.wb_WrNum(F, 0.00, 2);
   L_Basis.wb_WrNum(F, 0.00, 2);
   L_Basis.wb_WrNum(F, 0.00, 2);
   L_Basis.wb_WrNum(F, 0.00, 2);
   L_Basis.wb_WrNum(F, 0.00, 2);
   L_Basis.wb_WrNum(F, 0.00, 2);
   L_Basis.wb_WrNum(F, 0.00, 2);
   L_Basis.wb_WrNum(F, 0.00, TravmObligTariffPrecision);
   L_Basis.wb_WrNum(F, 0.00, TravmObligTaxPrecision);
   L_Basis.wb_WrScl(F, Staff.TSN);
  END;
(*!*)
  SAVE(Staff);
  L_General.Assert(L_Staff.IsStandOnMainContract(Man.Man, MyFirm.MyFirm, Memo.ud_ut()), "   ࠪ  "+L_DatTim.DateStr(Memo.ud_ut())+":  "+Man.Man);
  L_Basis.wb_WrScl(F, Staff.TSN);
  RESTORE(Staff);
(*!*)
  IF wMP THEN
   IF (type = L_Acnt.uavp_CirDbt) | (type = L_Acnt.uavp_CirCrd) THEN
    SEARCH(MyPlace, MyPlace, , L_SFee_M.MyPlace);
    L_Basis.wb_WrScl(F, MyPlace.MyPlace);
    L_Basis.wb_WrStr(F, MyPlace.Name);
   ELSE
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
   END;
  END;
  L_Basis.wb_WrScl(F, curReasonCode);
  L_Basis.wb_TermLine(F);
 END {Excel_MakeLine};

 PRIVATE PROCEDURE HasAnyCir(_Man: LIKE(Man.Man); _MyFirm: P_Firm.tMyFirm): SCAL[2];
 BEGIN
  RETURN SELECT(L_SFee_M, MyFirm, _MyFirm, _Man);
 END {HasAnyCir};

 PRIVATE PROCEDURE Excel_MakeSaldo(BPer, EPer: DATE);
  VAR
   ISaldo,
   OSaldo : L_PRoll.tSum;
   uavp   : L_Acnt.tUnfoldedAcntVectorPart;
 BEGIN
  SELECT(MyFirm, MyFirm);
  WHILE OCCURE(MyFirm) DO
   IF MyFirm.MyFirm # P_Firm.mf_Fict THEN
    SELECT(Man, Man);
    WHILE OCCURE(Man) DO
     PROMPT("⮢   ᠫ줮: " + Man.Man);
     SELECT(Staff, MyFirm, , MyFirm.MyFirm, Man.Man);
     WHILE OCCURE(Staff) DO
      ISaldo:=L_PRoll.GetInSaldo(BPer);
      OSaldo:=L_PRoll.GetOutSaldo(EPer);
      IF (ISaldo # 0) | (OSaldo # 0) | HasAnyCir(Man.Man, MyFirm.MyFirm) THEN
       IF ISaldo >= 0 THEN
        uavp:=L_Acnt.uavp_ISlCrd;
       ELSE
        uavp:=L_Acnt.uavp_ISlDbt;
       END;
       Excel_MakeLine("E", uavp, 0, Math.Abs(ISaldo), L_SFee.pfarc_None);
       IF OSaldo >= 0 THEN
        uavp:=L_Acnt.uavp_OSlCrd;
       ELSE
        uavp:=L_Acnt.uavp_OSlDbt;
       END;
       Excel_MakeLine("E", uavp, 0, Math.Abs(OSaldo), L_SFee.pfarc_None);
      END;
      NEXT(Staff);
     END; (* WHILE OCCURE(Staff) *)
     NEXT(Man);
    END; (* WHILE OCCURE(Man) ... *)
   END;
   NEXT(MyFirm);
  END; (* WHILE OCCURE(MyFirm) ... *)
 END {Excel_MakeSaldo};

 PRIVATE PROCEDURE Excel_MakeAll(RepName: STRING[]; BPer, EPer: DATE);
  VAR
   curTravmObligTariff: P_MyFirm.tTravmObligTariff;
   curBase            : L_SFee.tBase;
   curReasonCode      : L_SFee.tPFAReasonCode;
 BEGIN
  FIO.Open(E, L_General.NameConnection(RepName), "REP", Create);
  Excel_MakeTop("E");
  SELECT(L_SFee_M, MyFirm);
  WHILE OCCURE(L_SFee_M) DO
   NARROWSEL(L_SFee_M, MyFirm);
   SEARCH(MyFirm, MyFirm, , L_SFee_M.MyFirm);
   WHILE OCCURE(L_SFee_M) DO
    NARROWSEL(L_SFee_M, Man, Period);
    PROMPT("㧪  䠩 " + L_SFee_M.Man);
    SEARCH(Man, Man, , L_SFee_M.Man);
    curTravmObligTariff:=L_OTx.TravmObligTariff_InvalidCoef(L_SFee_M.MyFirm, L_SFee_M.Period, L_SFee_M.Man);
    IF SELECT(ManSFee, MyFirm, L_SFee_M.MyFirm, L_SFee_M.Man, 1, L_SFee_M.Period) THEN
     curReasonCode:=L_SFee.GetPFA_ReasonCode();
     FOR_EACH curBase DO
      IF ManSFee.OvrPrt[curBase] # 0 THEN
       SEARCH(Staff, TSN, , L_SFee_M.TSN);
       Excel_MakeLine("E", t_OvrPFR+curBase, 0, ManSFee.OvrPrt[curBase], L_SFee.pfarc_None);
      END;
     END;
    ELSE
     curReasonCode:=L_SFee.pfarc_None;
    END;
    FOR_EACH L_SFee_M DO
     SEARCH(MCList, MCode, , L_SFee_M.MCode);
     IF MCList.MCTyp = L_PRoll.mct_Credit THEN
      Excel_MakeLine("E", L_Acnt.uavp_CirCrd, curTravmObligTariff, 0, curReasonCode);
     ELSE
      Excel_MakeLine("E", L_Acnt.uavp_CirDbt, curTravmObligTariff, 0, curReasonCode);
     END;
    END; (* FOR_EACH L_SFee_M *)
    NEXTINEXTENDEDSEL(L_SFee_M, Man, Period);
   END; (* WHILE OCCURE(L_SFee_M) ... *)
   NEXTINEXTENDEDSEL(L_SFee_M, MyFirm);
  END; (* WHILE OCCURE(L_SFee_M) ... *)
  Excel_MakeSaldo(BPer, EPer);
  FIO.Close(E);
 END {Excel_MakeAll};

 PUBLIC PROCEDURE Dst10();
  CONST
   bpId = "Dst10";
  VAR
   BPer,
   EPer : DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.SetCacheables(["Man", "Staff", "StaffLog"]);
  L_bp.Begin(bpId, "। ࠡ⭮ ", L_bp.t_Basis, L_General.tc_inIntvl);
 
  L_DatTim.CheckWMIntvl(Memo.ud_fr(), Memo.ud_ut());
  BPer:=L_DatTim.MonthBeg(Memo.ud_fr());
  EPer:=L_DatTim.MonthBeg(Memo.ud_ut());

  L_StdFrm.Question("⮢ ।  ਮ|c "+L_DatTim.PeriodStr(BPer)+"  "+L_DatTim.PeriodStr(EPer));
  L_General.Assert(BPer >= 01\01\2010, "।  ਮ  2010  . Distr");

  L_General.Assert(L_DatTim.YEAR(BPer) = L_DatTim.YEAR(EPer), "⨬ ਬ ⮫쪮  । ");

  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  wMP:=P_Firm.E_wMultipleMyPlace(SYSDATE());

  IF ~L_APtm.MonthIsClosed(EPer, L_APtm.system_Salary) THEN
   L_StdFrm.CrucialChoice_FileExplicit("bpRT",
                                       " "+L_DatTim.PeriodStr(EPer)+"  , १  ⥫",
                                       L_APtm.g_Acnt);
  END;

  L_SFee.PrepareForDistribution(BPer, EPer);

  Excel_MakeAll(bpId, BPer, EPer);
  L_bp.End();
 END {Dst10};

END.
