(*
%Copyright   (c) Polak Computer System
%Author      28.04.2010 15:50:07 POLAK\MLB
%Purpose     ࠡ稪 ᮡ⨩  "ਡ ᯥ. ਭ஢"
%Type        operation
%Specific    SYS
%Modified    27.10.2011 10:42:32 POLAK\GAV
%Environment
*)

 IMPORT L_General, L_Events, L_SES, L_WDO, L_Prop, L_ctc;

 PRIVATE PROCEDURE SetField_v_Number_Modifiable();
 BEGIN
  L_WDO.getActiveForm().Zones(0).Fields("v_Number").Modifiable:=L_WDO.getActiveForm().Zones(0).Fields("v_CallMth").Value = L_ctc.cm_CallFile;
 END {SetField_v_Number_Modifiable};

 PRIVATE PROCEDURE __OnSuccessfulChange();
 BEGIN
  SetField_v_Number_Modifiable();
 END {__OnSuccessfulChange};

 PRIVATE PROCEDURE _OnBeforeEdit();
  VAR
   Number : STRING[];
   CallMth: L_ctc.tCallMth;
 BEGIN
  L_WDO.getActiveForm().Zones(0).Fields("v_CallMth").Format  :=L_ctc.cm_Pool;
  L_WDO.getActiveForm().Zones(0).Fields("v_CallMth").Template:=L_ctc.cm_Pool;
  L_ctc.GetCallMth(CallMth, Number);
  L_WDO.getActiveForm().Zones(0).Fields("v_Number").Value :=Number;
  L_WDO.getActiveForm().Zones(0).Fields("v_CallMth").Value:=CallMth;
  SetField_v_Number_Modifiable();
 END {_OnBeforeEdit};

 PRIVATE PROCEDURE _OnAfterEdit();
  VAR
   _Value: STRING[];
 BEGIN
  L_General.Assert(L_Prop.IsNumericValue(L_WDO.getActiveForm().Zones(0).Fields("v_Number").Value, "L"),
                   "ࠢ ଠ  ");
  _Value:=L_WDO.getActiveForm().Zones(0).Fields("v_CallMth").Value + ";" + L_WDO.getActiveForm().Zones(0).Fields("v_Number").Value;
  L_SES.PutValueAtCurTrn(L_SES.sit_StationAcsObj, L_ctc.DualPhone_SESValId, _Value);
 END {_OnAfterEdit};

BEGIN
 IF    L_Events.IsInternalEvents(MODE) THEN
  ^(L_Events.GetInternalEventHandlerName(MODE))();
 ELSE
  L_General.BadMode(MODE);
 END;
END.