(*
%Copyright   (c) Polak Computer System
%Author      12.01.1999 11:10:56 GINA
%Purpose     ନ஢ ਪ  ᫥ । 㯯 ࠡ⭨
%Type        operation
%Specific    SYS
%Modified    27.01.2014 19:05:52 POLAK\Gina
%Environment
*)

  MODULE FOPPause [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_DatTim, L_PRoll, L_Staff, L_Money, L_StdFrm, L_PDoc, L_OwnData, L_EDO;

 VAR
  PauseDays: NUMERIC[0];
  DateOfPay: DATE;

 PRIVATE PROCEDURE CondPDoc(): SCAL[2];
 BEGIN
  RETURN (PDoc.Status = L_PDoc.st_Passed) &
         (PDoc.MyFirm = FOrder.MyFirm) & L_PDoc.IsSalPDoc() & (PDoc.Type = L_PDoc.typ_Mass);
 END {CondPDoc};

 PRIVATE PROCEDURE SumToPay(Sum: L_PRoll.tSum): L_PRoll.tSum;
  VAR
   i: NUMERIC[0];
   Prc: NUMERIC[3];
 BEGIN
  i:=0;
  Prc:=0;
  WHILE i < PauseDays DO
   INC(i);
   INC(Prc, L_OwnData.RefinancingRate(DateOfPay-i));
  END;
  RETURN L_Money.RoundMoney(Memo.ud_me(), Sum*Prc/100/300);
 END {SumToPay};

 PUBLIC PROCEDURE FOPPause();
 BEGIN
  L_EDO.InitPrepareFOrder();
 
  SETEMPTY(DateOfPay, PauseDays);

  STDFORM(L_StdFrm.sf_Choice("|,   뫠 뤠 ௫  %##########%"+
                             "||ப প 믫 ௫,      %######%|",
                             "%<D.N.y>I" +
                             "%RI"),
          "   প 믫 ௫ ",
          ,
          ,
          DateOfPay, PauseDays);
 
  SELECT(PDoc, Date, , DateOfPay);
  WHILE OCCURE(PDoc) DO
   PROMPT(L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
   IF CondPDoc() THEN
    CONFORM(PDoc, PDocList);
    WHILE OCCURE(PDocList) DO
     PROMPT(L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc)+" "+PDocList.TSN);
     CONFORM(PDocList, Staff);
     L_Staff.PosToStaffLog(Staff.TSN, PDoc.Date, 1);
     L_EDO.AppendFOrderL(0, SumToPay(PDocList.Sum));
     L_PRoll.ShtDone(0);
     NEXT(PDocList);
    END; (* WHILE OCCURE(PDocList) ... *)
   END;
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc) ... *)
 
  CONFORM(FOrder, FOrderL);
  L_General.Assert(OCCURE(FOrderL), "    㬥 ᮢ 뤠 ௫  "+L_DatTim.DateStr(DateOfPay));
 END {FOPPause};

END.
