(*
%Copyright   (c) Polak IT
%Author      19.05.2003 16:51:57 POLAK\BOR
%Purpose       ꥪ 
%Type        report
%Specific    SYS
%Modified    30.01.2012 10:52:23 POLAK\Bor
%Environment
*)

 MODULE KAStat [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_MathR, L_MDoc, L_Acnt, L_Str, L_Car, L_XObj,
        P_Firm, Math, Memo, E_Stock;

(*
$P{ Top:
P_Firm.MyFirmName(Math.MyFirm, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
Math.Math, L, ""
Math.Name, L, ""
KAGroup.KAGroup, L, ""
KAGroup.Name, L, ""
KAGLog.DeprecT, L, ""
DeprecT.Name, L, ""
KAGLog.OKOF, L, "00 0000000"
KAGLog.DprGroup, L, ""
DprGroup.Name, L, ""
MDocKind.Sign, L ,""
MDoc.MDoc, L, ""
?, L, "D.N.y"
@
############################################################# ########## #####
=#####========================================================================
|                      ꥪ   ##########                    |
|----------------------------------------------------------------------------|
|ꥪ ##### ###############################################################|
|㯯 ##### ###############################################################|
|    ##    ###############################################################|
|   ##########  㯯   ## ########################################|
|                                                                            |
|㯨         ### ####### ##########                               |
}
*)

(*
$P{ asASp:
MDocKind.Sign, L ,""
MDoc.MDoc, L, ""
MDoc.Date, L, "D.N.y"
@
| (ᯨᠭ)   ### ####### ##########                               |
}
*)

(*
$P{ DprM:
L_Str.PoolItem(L_MathR.dprm_Pool, KAGroup.AcnDprM), L, ""
L_Str.PoolItem(L_MathR.matst_Pool, MathKAGL.AcnStat), L, ""
L_Str.PoolItem(L_MathR.dprm_Pool, KAGroup.TaxDprM), L, ""
L_Str.PoolItem(L_MathR.matst_Pool, MathKAGL.TaxStat), L, ""
@
|============================================================================|
|    ⮤                      |ﭨ                              |
|------------------------------------|---------------------------------------|
|: ################################|#####################################  |
|: ################################|#####################################  |
}
*)

(*
$P{ MDoc_asASp:
MDocKind.Sign, L ,""
MDoc.MDoc, L, ""
MDoc.Date, L, "D.N.y"
@
| (ᯨᠭ)   ### ####### ##########
}
*)

(*
$P{ MathCar:
CarLog.BoxNbr, L, ""
CarLog.StateNbr, L, ""
CarLog.VehPasp, L, ""
CarLog.Mark, L, ""
Mark.Name, L, ""
CarLog.Column, L, ""
L_Str.PoolItem(L_Car.purp_Pool, CarLog.Purpose), L, ""
?, R, "2."
CarLog.Status, L, "-||"
@
|============================================================================|
|.|. |   |ઠ                           |||      ஡||
|----|----------|------|--------------------------------|--|--|------------|-|
|####|##########|######|#### ###########################|##|##|############|#|
}
*)

(*
$P{ ULTop:
@
|============================================================================|
|ப  ᯮ짮:                                               |
|----------------------------------------------------------------------------|
|                      |                 |    ࢠ樥| ४஢|
|                 ᥣ|  諮 ⠫|  諮 ⠫|   ᥣ ⠫|
|----------------------|-----------------|-----------------|-----------------|
}
*)

(*
$P{ UL:
?, L, ""
?, L, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
@
|##, #######    #######|######## ########|######## ########|######## ########|
}
*)

(*
$P{ RemTop:
@
|============================================================================|
|⮨  ⨧                                                     |
|----------------------------------------------------------------------------|
|१                                      |㬬          |        P.㬬|
}
*)

(*
$P{ RemDls:
?, L, ""
@
|--------------------------------------------#---------------|---------------|
}
*)

(*
$P{ RemAcLine:
AcCut.AcCut, L, ""
ACLog.Sign, L, ""
AcCut.Name, L, ""
?, R, "2-"
?, R, "2-"
@
|### ########### ############################|###############|###############|
}
*)

(*
$P{ RemTxLine:
AcCut.AcCut, L, ""
ACLog.Sign, L, ""
AcCut.Name, L, ""
?, R, "2-"
@
|### ########### ############################################|###############|
}
*)

(*
$P{ RemBot:
?, R, "2-"
?, R, "2-"
?, R, "2-"
?, R, "2-"
?, R, "2-"
?, R, "2-"
?, R, "2-"
?, R, "2-"
?, R, "2-"
@
|----------------------------------------------------------------------------|
|⮣:        ᮢ ⮨|         ⨧|筠 ⮨|
|----------------------------------|--------------------|--------------------|
|:              #################|   #################|   #################|
| P.㬬:      #################|   #################|   #################|
|:              #################|   #################|   #################|
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE GetConservation(APrDate, curP: DATE; DprK: L_MathR.DprKindType): NUMERIC[0];
  VAR
   curStat: LIKE(MathKAGL.AcnStat);
   curDprM: LIKE(KAGroup.AcnDprM);
   Result : NUMERIC[0];
   DE     : DATE;
 BEGIN
  Result:=0;
  SAVE(MathKAGL);
  CHANGESEL(MathKAGL, Math, , MathKAGL.Math);
  SRCINSEL(MathKAGL, LT, , curP);
  DE:=curP-1;
  WHILE OCCURE(MathKAGL) & (APrDate <= MathKAGL.DateE) DO
   CONFORM(MathKAGL, KAGroup);
   IF OCCURE(KAGroup) THEN
    IF    DprK = L_MathR.DprK_Acn THEN
     curStat:=MathKAGL.AcnStat;
     curDprM:=KAGroup.AcnDprM;
    ELSIF DprK = L_MathR.DprK_Tax THEN
     curStat:=MathKAGL.TaxStat;
     curDprM:=KAGroup.TaxDprM;
    ELSE
     L_General.CallUs(0);
    END;
    IF (curStat = L_MathR.matst_Conservation) &
       (curDprM # L_MathR.DprM_Runs) THEN
     DEC(Result, L_DatTim.CompleteMonthsInIntvl(L_DatTim.NextPer(Math.Max(MathKAGL.Date, APrDate)), L_DatTim.NextPer(DE)));
    END;
   END;
   DE:=MathKAGL.Date;
   PREV(MathKAGL);
  END;
  RESTORE(MathKAGL);
  RETURN Result;
 END {GetConservation};

 PRIVATE PROCEDURE GetULParams(APrDate, curP: DATE; trgDprK: L_MathR.DprKindType;
                               VAR curDprM: LIKE(KAGroup.AcnDprM);
                               VAR fullUL,
                                   corrUL,
                                   fullPast,
                                   consPast: NUMERIC[0]);
 BEGIN
  IF    trgDprK = L_MathR.DprK_Acn THEN
   fullUL:=KAGLog.AcnUL;
   curDprM:=KAGroup.AcnDprM;
  ELSIF trgDprK = L_MathR.DprK_Tax THEN
   fullUL:=KAGLog.TaxUL/KAGLog.TaxNumb;
   curDprM:=KAGroup.TaxDprM;
  ELSE
   L_General.CallUs(0);
  END;
  corrUL:=L_MathR.GetFullUL(APrDate, trgDprK);
  IF curDprM # L_MathR.DprM_Runs THEN
   fullPast:=L_DatTim.CompleteMonthsInIntvl(L_DatTim.NextPer(APrDate), curP);
   consPast:=fullPast+GetConservation(APrDate, curP, trgDprK);
  ELSE
   SETEMPTY(fullPast, consPast);
  END;
 END {GetULParams};

 PRIVATE PROCEDURE PrintUL(APrDate, curP: DATE; trgDprK: L_MathR.DprKindType);
  CONST
   DprN = [ "", "" ];
  VAR
   curDprM: LIKE(KAGroup.AcnDprM);
   fullUL,
   corrUL,
   fullPast,
   consPast: NUMERIC[0];
 BEGIN
  GetULParams(APrDate, curP, trgDprK, curDprM, fullUL, corrUL, fullPast, consPast);

  IF curDprM # L_MathR.DprM_Runs THEN
   MAKEPART(R, UL, DprN[trgDprK], ".:", fullUL, fullPast, fullUL-fullPast, consPast, fullUL-consPast, corrUL, corrUL-fullPast);
  ELSE
   MAKEPART(R, UL, DprN[trgDprK], ".:", fullUL, "-", "-", "-", "-", corrUL, "-");
  END;
 END {PrintUL};

 PRIVATE PROCEDURE PrintUsefulLife(APrDate, curP: DATE);
  VAR
   S: STRING[];
 BEGIN
  MAKEPART(R, ULTop);
  PrintUL(APrDate, curP, L_MathR.DprK_Acn);
  PrintUL(APrDate, curP, L_MathR.DprK_Tax);
 END {PrintUsefulLife};

 PRIVATE PROCEDURE GetNPrintSum(P: DATE;
                                trgAcCut: LIKE(AcCut.AcCut);
                                trgCirType: LIKE(Apport.CirType);
                                VAR NeedDls: SCAL[2];
                                Full: SCAL[2];
                                VAR trgSum, trgRSum: L_XObj.tSum);
  VAR
   curSum,
   curRSum: L_XObj.tSum;
   s      : NUMERIC[0];
 BEGIN
  curSum :=L_MathR.Remainders (P, trgAcCut, trgCirType);
  curRSum:=L_MathR.RemaindersR(P, trgAcCut, trgCirType);
  IF (curSum # 0) | (curRSum # 0) THEN
   L_General.CallUs(SEARCH(AcCut, AcCut, trgAcCut));
   L_Acnt.StandOnCAcnt(P, trgAcCut);
   IF NeedDls THEN
    IF Full THEN
     MAKEPART(R, RemDls, "|");
    ELSE
     MAKEPART(R, RemDls, "-");
    END;
    NeedDls:=0;
   END;
   IF trgCirType = L_Acnt.ct_Credit THEN
    s:=1;
   ELSE
    s:=-1;
   END;
   IF Full THEN
    MAKEPART(R, RemAcLine,  s*curSum, s*curRSum);
   ELSE
    MAKEPART(R, RemTxLine,            s*curRSum);
   END;
   INC(trgSum,  curSum);
   INC(trgRSum, curRSum);
  END;
 END {GetNPrintSum};

 PRIVATE PROCEDURE PrintCost(P: DATE);
  VAR
   bCost,
   bDepr,
   rCost,
   rDepr,
   tCost,
   tDepr,
   Dummy    : L_XObj.tSum;
   curAcCuts: L_MathR.tMathAcCutCollection;
   i        : SCAL[RANGEOF(L_MathR.tMathAcCutCollection)];
   waCount  : SCAL[L_MathR.KA_NumWearAcnt];
   NeedDls  : SCAL[2];
 BEGIN
  MAKEPART(R, RemTop);
  SETZERO(bCost, bDepr, rCost, rDepr, tCost, tDepr, Dummy);
  FOR_EACH waCount DO
   IF waCount # L_MathR.KA_All THEN
    E_Stock.GetKeyAssBalCostAcCuts(P, curAcCuts, L_MathR.KA_All, L_MathR.KA_All, waCount);
    NeedDls:=1;
    FOR_EACH i DO
     IF !curAcCuts[i] THEN
      EXIT;
     END;
     GetNPrintSum(P, curAcCuts[i], L_Acnt.ct_Credit, NeedDls, 1, bCost, rCost);
    END;
  
    IF ~!curAcCuts[0] (* ࠧ१  ⮨*) THEN
     E_Stock.GetKeyAssWearAcCuts(P, curAcCuts, L_MathR.KA_All, waCount, L_MathR.KA_All);
     FOR_EACH i DO
      IF !curAcCuts[i] THEN
       EXIT;
      END;
      GetNPrintSum(P, curAcCuts[i], L_Acnt.ct_Debit, NeedDls, 1, bDepr, rDepr);
     END;
  
     E_Stock.GetKeyAssWearAcCuts(P, curAcCuts, L_MathR.KA_All, L_MathR.KA_All, waCount);
     L_General.CallUs(~!curAcCuts[0] & !curAcCuts[1]); (*  ஢  ࠧ१  ⨧樨*)
     GetNPrintSum(P, curAcCuts[0], L_Acnt.ct_Debit, NeedDls, 1, bDepr, rDepr);
    END; (* IF ~!curAcCuts[0] ... *)
   END; (* IF waCount # L_MathR.KA_All ... *)
  END; (* FOR_EACH waCount ... *)
  NeedDls:=1;
  GetNPrintSum(P, E_Stock.KA_acc_TaxCost, L_Acnt.ct_Credit, NeedDls, 0, Dummy, tCost);
  GetNPrintSum(P, E_Stock.KA_acc_TaxWear, L_Acnt.ct_Debit,  NeedDls, 0, Dummy, tDepr);

  MAKEPART(R, RemBot, bCost, bDepr, bCost-bDepr,
                      rCost, rDepr, rCost-rDepr,
                      tCost, tDepr, tCost-tDepr);
 END {PrintCost};

 PUBLIC PROCEDURE KASts();
  CONST
   RepName = "KASts";
  VAR
   P,
   APrDate: DATE;
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_General.Assert(ACCESS(Math), " ꥪ ");
  P:=Memo.ud_mb();
  L_MathR.CountUpMath(Math.Math, P-1);

  APrDate:=L_MathR.GetKeyAssAPrDate(Math.Math);
  L_General.Assert(APrDate < P, "    ᯫ  "+L_DatTim.DateStr(P));
  L_General.CallUs(L_MathR.AccessMDoc_asAPr(Math.Math));
  CONFORM(MDoc, MDocKind);
  L_MathR.PosToKAG(Math.Math, P-1);
  CONFORM(KAGLog, DprGroup);
 
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, P, APrDate);
 
  IF L_MathR.AccessMDoc_asASp(Math.Math) & (MDoc.Date<P) THEN
   CONFORM(MDoc, MDocKind);
   MAKEPART(R, asASp);
  END;
 
  MAKEPART(R, DprM);
 
  IF L_MathR.PosToCarLog(Math.Math, P) THEN
   CONFORM(CarLog, Mark);
   MAKEPART(R, MathCar, L_Car.GetWhiteRun(Math.Math, P));
  END;
 
  PrintUsefulLife(APrDate, P);
  PrintCost(P);
 
  CLOSEREP(R);
 END {KASts};

 PRIVATE PROCEDURE GetULStr(APrDate, curP: DATE; trgDprK: L_MathR.DprKindType): STRING[];
  CONST
   FL = 8;
  VAR
   Result  : STRING[];
   curDprM : LIKE(KAGroup.AcnDprM);
   fullUL,
   corrUL,
   fullPast,
   consPast: NUMERIC[0];
 BEGIN
  SAVE(MathKAGL);
  IF L_MathR.PosToKAGSoft(MathKAGL.Math, curP-1) THEN
   GetULParams(APrDate, curP, trgDprK, curDprM, fullUL, corrUL, fullPast, consPast);
   IF curDprM # L_MathR.DprM_Runs THEN
    Result:=".:  "+
            FLDTOSTR(fullUL, "", FL)+""+FLDTOSTR(fullPast, "", FL)+" "+FLDTOSTR(fullUL-fullPast, "", FL) +
            ""+FLDTOSTR(consPast, "", FL)+" "+FLDTOSTR(corrUL-consPast, "", FL) +
            ""+FLDTOSTR(corrUL, "", FL)+" "+FLDTOSTR(corrUL-fullPast, "", FL);
   ELSE
    Result:=".:"+
            FLDTOSTR(fullUL, "", FL)+"-------- ---------------- --------"+
            ""+FLDTOSTR(corrUL, "", FL)+" --------";
   END;
  ELSE
   Result:="---------------- ---------------- ---------------- --------";
  END;
  RESTORE(MathKAGL);
  RETURN Result;
 END {GetULStr};

 PUBLIC PROCEDURE ShowUsefulLife();
  VAR
   APrDate,
   curP: DATE;
   S: STRING[];
 BEGIN
  APrDate:=L_MathR.GetKeyAssAPrDate(Math.Math);
  IF ~!APrDate THEN
   L_General.Assert(~!MathKAGL.Date, "室   ''");
   curP:=L_DatTim.NextPer(Math.Max(MathKAGL.Date, APrDate));
   S:=" "+L_DatTim.DateStr(curP)+" ப  ᯮ짮:| |"+
      "                                        ࢠ樥 ४஢|"+
      "              ᥣ  諮 ⠫  諮 ⠫   ᥣ ⠫|"+
      ""+
      "|, "+GetULStr(APrDate, curP, L_MathR.DprK_Acn)+
      "|, "+GetULStr(APrDate, curP, L_MathR.DprK_Tax);
   curP:=L_DatTim.IncMonth(curP, -1);
   IF APrDate<curP THEN
    S:=S+"| | "+L_DatTim.DateStr(curP)+" ப  ᯮ짮:| "+
         "|, "+GetULStr(APrDate, curP, L_MathR.DprK_Acn)+
         "|, "+GetULStr(APrDate, curP, L_MathR.DprK_Tax);
   END;
  ELSE
   S:="   ";
  END;
  STDMSG(S, INFORM);
 END {ShowUsefulLife};

END.