(*
%Copyright   (c) Polak IT
%Author      12.05.2011 20:55:59 LDA
%Purpose      
%Type        library
%Specific    AP
%Modified    05.09.2014 13:12:11 POLAK\San
%Environment
*)

 MODULE L_APDBD [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Str;

 PUBLIC PROCEDURE IsNotInteractiveModifiableFile(File: STRING[]): SCAL[2];
 BEGIN
(*
              !!!!!!!          楤 祣  , 祭 ᭮              !!!!!

 䠩   楤 ਢ  㤠  RECORDID,
  ਢ   ᪨   ,  ᫥⢨,  ࠡᯮᮡ ⮏
*)
  RETURN (File = "ACSEvent") |
         (File = "AOMem")    |
         (File = "ATER")     |
         (File = "ATERAttr") |
         (File = "BIC")      |
         (File = "DoneEF")   |
         (File = "ERKN")     |
         (File = "ElTck")    |
         (File = "KlAdr")    |
         (File = "ManSFee")  |
         (File = "MathMty")  |
         (File = "MathRun")  |
         (File = "MoneyDst") |
         (File = "MonthRt")  |
         (File = "MtrRg")    |
         (File = "OKPDTR")   |
         (File = "OKSO")     |
         (File = "PCalc")    |
         (File = "RprSMirr") |
         (File = "SES")      |
         (File = "SYSLOG")   |
         (File = "SYSLOGA")  |
         (File = "SYSLOGD")  |
         (File = "SYSLOG_")  |
         (File = "SrMnthly") |
         (File = "XCalcDtl") |
         (File = "XDocApr")  |
         (File = "XDocJrn")  |
         (File = "XDocRef")  |
         (File = "XODone")   |
         (File = "aofr")     |
         (File = "aofrl")    |
         (File = "ccCnct")   |
         (File = "dbFile")   |
         (File = "dbRDtl")   |
         (File = "iga")      |
         (File = "lsStore")  |
         (File = "mItem")    |
         (File = "mfBnkAcn") |
         (File = "mfMan")    |
         (File = "qs")       |
         (File = "rtCar")    |
         (File = "rtExit");
 END {fIsNotInteractiveModifiableFile};

 PUBLIC PROCEDURE RECORDIDMustBeAbsent(File: STRING[]): SCAL[2];
 BEGIN
(*
              !!!!!!!          楤 祣  , 祭 ᭮              !!!!!

 䠩   楤 ਢ  㤠  RECORDID,
  ਢ   ᪨   ,  ᫥⢨,  ࠡᯮᮡ ⮏
*)
  RETURN (File = "Dtwo")     |
         (File = "OKOF")     |
         (File = "OKOFGrp")  |
         (File = "Message")  |
         (File = "PckAttr")  |
         (File = "XDocFlow") |
         (File = "RprP");
 END {RECORDIDMustBeAbsent};

 PUBLIC PROCEDURE RECORDIDMustBePresent(File: STRING[]): SCAL[2];
 BEGIN
  RETURN (File = "Adding")   |
         (File = "AcsObj")   |
         (File = "AcsPnt")   |
         (File = "bp")       |
         (File = "bpRT")     |
         (File = "CarEvn")   |
         (File = "Deduct")   |
         (File = "EDOrderL") |
         (File = "FOrderL")  |
         (File = "IsSData")  |
         (File = "iga")      |
         (File = "Money")    |
         (File = "mfBnkAcn") |
         (File = "Officer")  |
         (File = "PCalc")    |
         (File = "RprT")     |
         (File = "StaffLog") |
         (File = "StaffMon") |
         (File = "ManFml")   |
         (File = "RoutMod")  |
         (File = "FirmCtc");
 END {RECORDIDMustBePresent};

 PUBLIC PROCEDURE IsAnyProFile(File: STRING[]): SCAL[2];
  VAR
   curLink: LINK;
 BEGIN
  IF Str.Match(File, "*Pro") THEN
   IF File = "OwnDPro" THEN
    RETURN 1;
   ELSE
    FOR_EACH curLink IN TABLE.Get("Property").Links DO
     IF (curLink.Kind = LINK.Kind_Owner) & (File = curLink.CooIndex.Table.Name) THEN
      RETURN 1;
     END;
    END; (* FOR_EACH *)
   END;
  END;
  RETURN 0;
 END {IsAnyProFile};

END.
