(*
%Copyright   (c) Polak Computer System
%Author      08.09.1999 20:10:05 SAN
%Purpose     ⠭⭠ ࠡ⪠ E_㭪権
%Type        library
%Specific    SYS
%Modified    16.04.2010 16:38:28 POLAK\GAV
%Environment
*)

 MODULE L_EC [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC PROCEDURE ExecE_Func_Numeric(D: DATE; Proc: PROC; Default: NUMERIC[5]): NUMERIC[5];
 BEGIN
  IF ~!Proc THEN
   RETURN Proc(D);
  ELSE
   RETURN Default;
  END;
 END {ExecE_Func_Numeric};

 PUBLIC PROCEDURE ExecE_Func_Scal2(D: DATE; Proc: PROC; Default: SCAL[2]): SCAL[2];
 BEGIN
  IF ~!Proc THEN
   RETURN Proc(D);
  ELSE
   RETURN Default;
  END;
 END {ExecE_Func_Scal2};

 PUBLIC PROCEDURE ExecE_Func_String(D: DATE; Proc: PROC; Default: STRING[]): STRING[];
 BEGIN
  IF ~!Proc THEN
   RETURN Proc(D);
  ELSE
   RETURN Default;
  END;
 END {ExecE_Func_String};

 PUBLIC PROCEDURE ExecE_Func_Date(D: DATE; Proc: PROC; Default: DATE): DATE;
 BEGIN
  IF ~!Proc THEN
   RETURN Proc(D);
  ELSE
   RETURN Default;
  END;
 END {ExecE_Func_Date};

 PUBLIC PROCEDURE ExecE_Func_Time(D: DATE; Proc: PROC; Default: TIME): TIME;
 BEGIN
  IF ~!Proc THEN
   RETURN Proc(D);
  ELSE
   RETURN Default;
  END;
 END {ExecE_Func_Time};

END.
