(*
%Copyright   (c) Polak Computer System
%Author      25.01.1999 17:29:05 BOR
%Purpose     ⥪ ८ࠧ ᪠஢ Man  ப
%Type        library
%Specific    SYS
%Modified    05.09.2014 19:00:10 POLAK\Bor
%Environment
*)

 MODULE L_Man [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tCitizen = SCAL[4];

 PUBLIC CONST
  ReturnToPermanentPlaceSLKind = 3002;

  sex_Female = 0;
  sex_Male   = 1;

  ct_Moscow = 0; (*tCitizen*)
  ct_Russia = 1;
  ct_CIS    = 2;
  ct_Foreign= 3;
  ctz_Pool = "|||";

  actvk_Education    = 0;
  actvk_Work         = 1;
  actvk_FurtherTrain = 2;
  actvk_Retrain      = 3;
  actvk_Validation   = 4;
  actvk_Pool         = "ࠧ|㤮 ⥫쭮|襭 䨪樨|९⮢|";

  et_NativeLanguage     = 0; (* ManExpr.ExprType *)
  et_OtherLanguage      = 1;
  et_ForeignLanguage    = 2;
  et_Skill              = 3;
  et_Stimulation        = 4;
  et_Tribute            = 5;
  et_ScienceAchievement = 6;
  et_Pool = " |㣮 |࠭ | ࠡ|" +
            "७|ࠤ|筮 ⨦";

  expsrc_Internal = 0; (* Expr.Source *)
  expsrc_External = 1;
  expsrc_Skill    = 2;
  expsrc_Pool = "७|譨|";

  ins_Size       = 7;
  ins_LastProf   = 0; (*  ManActv.InStage *)
  ins_Continuous = 1;
  ins_Common     = 2;
  ins_Post       = 3;
  ins_Branch     = 4;
  ins_SocInsurance      = 5;
  ins_SocInsuranceNoIns = 6;

  edform_Face           = 0; (*筠*) (*ManActv.EdForm*)
  edform_Evening        = 1; (**)
  edform_orrespondence = 2; (*筠*)
  edform_External       = 3; (*ୠ*)
  edform_Pool = "筠|筮-筠()|筠|ୠ";

  edtype_None          = 0; (* 砫쭮*) (*ManActv.EdType*)
  edtype_Primary       = 1; (*砫쭮 饥*)
  edtype_General       = 2; (*᭮ 饥*)
  edtype_Secondary     = 3; (*। 饥*)
  edtype_PrimaryProf   = 4; (*砫쭮 .*)
  edtype_SecondaryProf = 5; (*। .*)
  edtype_HighProf      = 6; (*襥 .*)
  edtype_AfterHighProf = 7; (*᫥㧮..*)
  edtype_Pool    = " 砫쭮|砫쭮 饥|᭮ 饥|। 饥|"+
                   "砫쭮 ᨮ쭮|। ᨮ쭮|"+
                   "襥 ᨮ쭮|᫥㧮᪮ ᨮ쭮";

  traintype_SelfOrg = 0;
  traintype_Course  = 1;
  traintype_Center  = 2;
  traintype_Pool = "祭  ᢮ ।⨨|| 襭 䨪樨";

  actvc_Pool    = "|||-|||-|||";
  terc_Pool     = "|||31|33|34|35|36";
  senr_Pool     = "||104||";
  senrs_Pool    = "||";
  longsrv_Pool  = "|78|27-11|78|27-11|78|27-12|"+
                  "78|28-|80|28-|80|28-|81|28-|"+
                  "81|28-||28-||28-|15|"+
                  "20|25|30|||||"+
                  "|||||||"+
                  "1|||||27-14||27-15";

  eddoctype_None        = 0;
  eddoctype_Diploma     = 1;
  eddoctype_Warrant     = 2;
  eddoctype_Testimonial = 3;
  eddoctype_Protocol    = 4;
  eddoctype_Certificate = 5;
  eddoctype_Pool = "||⥫⢮||⮪|⮢७";

  fm_Child         = 0; (*ManFml.Member*)
  fm_MarriedCouple = 1;
  fm_Parent        = 2;
  fm_Other         = 3;
  FmlMemberPool  = "||⥫|祥";

  fmf_None             = 0;
  fmf_Study            = 1;
  fmf_Dependant        = 2;
  fmf_InvalidDependant = 3;
  fmf_Pool = "|祡||-";

  actvc_Work       = 0; (**) (*ManActv.ActvCatg*)
  actvc_MltService = 1; (* 㦡  ࠢ  *)

  pool_ManExprDocGiveS = 00990;

  e_NativeLanguage = 0000;

  rs_None     = 0; (*Man.rStaff*)
  rs_wStaff   = 1;
  rs_OutStaff = 2;
  rs_Pool_woNone = "|祭";

  dt_PaspRussia  = 08(*ᯮ ࠦ *); (*Man.DocType*)
  dt_PaspForeign = 05(*࠭ ᯮ*);

 PRIVATE TYPE
  tins_Size = SCAL[ins_Size];

 IMPORT L_General, L_Staff, L_DatTim, L_Env, L_MSO, L_Roman, L_Str, L_Russia,
        L_EC, L_AFM, Str, Math, E_Man, L_StdFrm, L_ctc, P_Man, P_Firm, L_EDO,
        L_BarCode, L_XDoc, L_ODoc, L_APtm;

 PUBLIC PROCEDURE Man_ManAsStr(): STRING[];
 BEGIN
  RETURN FLDTOSTR(Man.Man, "", 5);
 END {Man_ManAsStr};

 PUBLIC PROCEDURE GetManLanguageLevelPool(): STRING[];
 BEGIN
  RETURN " ᢮|⠥, ॢ  ᫮६|⠥   ";
 END {GetManLanguageLevelPool};

 PUBLIC PROCEDURE GetManSINumber_asStr(): STRING[14];
 BEGIN
  IF ~!Man.SINumber THEN
   RETURN FLDTOSTR(Man.SINumber, L_Russia.sf_ManSINumber, 0);
  ELSE
   RETURN "";
  END;
 END {GetManSINumber_asStr};

 PUBLIC PROCEDURE GetManFmlMember_asStr(): STRING[9];
 BEGIN
  RETURN GetFlmMember_asStr();
 END {GetManFmlMember_asStr};

 PUBLIC PROCEDURE GetManAdrType_asStr(_AdrType: LIKE(ManAdr.AdrType)): STRING[32];
 BEGIN
  IF    _AdrType = L_Russia.at_BthMA THEN
   RETURN " ஦";
  ELSIF _AdrType = L_Russia.at_RgMA THEN
   RETURN "ﭭ ";
  ELSIF _AdrType = L_Russia.at_DwMA THEN
   RETURN "䠪᪮ ஦";
  ELSIF _AdrType = L_Russia.at_CtMA THEN
   RETURN "ࠦ⢠";
  ELSE
   L_General.Error(" ⨯  " + _AdrType);
  END;
 END {GetManAdrType_asStr};

 PUBLIC PROCEDURE IsLocalManAdr(D: DATE): SCAL[2];
  VAR
   dummy: SCAL[2];
 BEGIN
  L_General.CallUs(OCCURE(ManAdr));
  dummy:=L_ctc.StandOnAdr_Reg(D, P_Firm.OWN_FIRM, 1);
  RETURN (ManAdr.Region = CtcAdr.Region) & (Str.Cap(ManAdr.Town) = Str.Cap(CtcAdr.Town));
 END {IsLocalManAdr};

 PUBLIC PROCEDURE AccessMan(_Man: LIKE(Man.Man));
 BEGIN
  L_General.Assert(SEARCH(Man, Man, _Man), "  ");
 END {AccessMan};

 PUBLIC PROCEDURE AccessManAdr(trgMan: LIKE(Man.Man); D: DATE; trgAdrType: LIKE(ManAdr.AdrType)): SCAL[2];
 BEGIN
  SETSEL(ManAdr, Man, trgMan, trgAdrType);
  RETURN SRCINSEL(ManAdr, LE, D) & (D <= ManAdr.EndDate);
 END {AccessManAdr};

 PUBLIC PROCEDURE StrongAccessManAdr(trgMan: LIKE(Man.Man); D: DATE; trgAdrType: LIKE(ManAdr.AdrType));
 BEGIN
  L_General.Assert(AccessManAdr(trgMan, D, trgAdrType),
                   " 㪠  " + GetManAdrType_asStr(trgAdrType) +
                   "  " + L_DatTim.DateStr(D) +
                   "|᪮  "+ trgMan);
 END {StrongAccessManAdr};

 PUBLIC PROCEDURE AccessRgManAdr(_Man: LIKE(Man.Man); D: DATE);
 BEGIN
  StrongAccessManAdr(_Man, D, L_Russia.at_RgMA);
 END {AccessRgManAdr};

 PUBLIC PROCEDURE CheckPsp(_ChN, _Psp, Mask:STRING[]): STRING[];
 BEGIN
  RETURN L_Str.TestStrWMask(_ChN, _Psp, Mask, Mask);
 END {CheckPsp};

 PUBLIC PROCEDURE GetManDocName(_DocType: LIKE(Man.DocType)): STRING[];
 BEGIN
  IF    _DocType = 00 THEN RETURN "ᯮ ࠦ ";
  ELSIF _DocType = 01 THEN RETURN "ᢨ⥫⢮  ஦";
  ELSIF _DocType = 02 THEN RETURN "㤮⮢७ 筮";
  ELSIF _DocType = 03 THEN RETURN "ࠢ  ᢮";
  ELSIF _DocType = 04 THEN RETURN " ";
  ELSIF _DocType = dt_PaspForeign THEN RETURN "࠭ ᯮ";
  ELSIF _DocType = 06 THEN RETURN ". ॣ樨 ࠭";
  ELSIF _DocType = 07 THEN RETURN "㤮⮢७ ";
  ELSIF _DocType = dt_PaspRussia THEN RETURN "ᯮ ࠦ ";
  ELSIF _DocType = 09 THEN RETURN "㤮⮢७ 筮 ";
  ELSIF _DocType = 10 THEN RETURN "࠭ᯮ ࠦ ";
  ELSIF _DocType = 11 THEN RETURN "࠭ᯮ ࠦ ";
  ELSIF _DocType = 12 THEN RETURN "  ⥫⢮";
  ELSIF _DocType = 13 THEN RETURN "ᯮ 䫮";
  ELSIF _DocType = 14 THEN RETURN "ᯮ 猪";
  ELSIF _DocType = 15 THEN RETURN "   ";
  ELSIF _DocType = 16 THEN RETURN "᪨ ᯮ ࠦ ";
  ELSIF _DocType = 17 THEN RETURN " 㬥, 뤠 ࣠ ";
  ELSIF _DocType = 18 THEN RETURN "⥫⢮  ஦,뤠 㯮祭 ࣠ ࠭ 㤠⢠";
  ELSE
   L_General.Error("  㬥, 㤮⮢饣 筮 "+FLDTOSTR(_DocType, "0", 0));
  END;
 END {GetManDocName};

 PUBLIC PROCEDURE GetManDocType_asStr(): STRING[];
 BEGIN
  RETURN GetManDocName(Man.DocType);
 END {GetManDocType_asStr};

 PUBLIC PROCEDURE GetManDocAttr_asStr(): STRING[];
 BEGIN
  RETURN GetManDocType_asStr() + ":" +
         "  " + Man.PspSer + "  " + Man.PspNbr +
         ", 뤠 " + Man.PspGiveS + " " + L_DatTim.DateStr(Man.PspGiveD);
 END {GetManDocAttr_asStr};

 PUBLIC PROCEDURE SplitManDocGiveS(GiveS: STRING[]; VAR S, CP: STRING[]);
 BEGIN
  IF    !L_Str.TestStrWMask(" ࠧ", L_Str.Right(GiveS, 7), "999-999", "999-999") THEN
   CP:=L_Str.Right(GiveS, 7);
   S :=Str.Condense(L_Str.Left(GiveS, Str.Length(GiveS) - Str.Length(CP)));
  ELSE
   CP:="";
   S :=GiveS;
  END;
 END {SplitManDocGiveS};

 PUBLIC PROCEDURE GetManDocCode(_DocType: LIKE(Man.DocType)): STRING[30];
 BEGIN
  L_General.Assert(_DocType < 19, "  㬥 "+FLDTOSTR(_DocType, "0", 0));
  RETURN L_Str.PoolItem("01|03|14|05|07|10|11|13|21|04|02|22|12|06|26|27|09|91|23", _DocType);
 END {GetManDocCode};

 PUBLIC PROCEDURE GetManDocCodeMNS(D: DATE): STRING[30];
  VAR
   _DocType: LIKE(Man.DocType);
 BEGIN
  _DocType:=Man.DocType;
  IF (D >= 01\01\2006) &
     ((_DocType=03(*ࠢ ᢮*)) | (_DocType=10(* *)) |
      (_DocType=11(* *)) | (_DocType=09(*..*)) |
      (_DocType=13(*ᯮ 䫮*)) | (_DocType=14(*ᯮ 猪*)) |
      (_DocType=15(*   *)) | (_DocType=16(*.ᯮ *))
     ) THEN
   _DocType:=17(* -*);
  END;
  RETURN GetManDocCode(_DocType);
 END {GetManDocCodeMNS};

 PUBLIC PROCEDURE CheckDocument(): STRING[];
  VAR
   Num  : NUMERIC[0];
   _Str,
   CP,
   GiveS: STRING[];
 BEGIN
  IF    (Man.DocType = 0(*.*)) | (Man.DocType = 1(*. ஦*)) THEN
   _Str:=CheckPsp(" 㬥", Man.PspSer, "R-");
   IF ~!_Str THEN
    RETURN _Str;
   END;
   _Str:=CheckPsp(" 㬥", Man.PspNbr, "999999");
   IF ~!_Str THEN
    RETURN _Str;
   END;
   _Str:=Str.Item(Man.PspSer, "-", 0);
   IF ~!_Str THEN
    Num:=L_Roman.RomanToArabic(_Str);
    IF (Num>49) THEN RETURN " 㬥 ॢ蠥 ᨬ쭮 祭 49  ࠢ "+FLDTOSTR(Num, "0")); END;
   END;
  ELSIF (Man.DocType=4(* *)) | (Man.DocType=9(*㤮⮢७ 筮 *)) |
        (Man.DocType=13(*ᯮ 䫮*)) | (Man.DocType=14(*ᯮ 猪*)) |
        (Man.DocType=15(*. . *))THEN
   _Str:=CheckPsp(" 㬥", Man.PspSer, "");
   IF ~!_Str THEN
    RETURN _Str;
   END;
   _Str:=CheckPsp(" 㬥", Man.PspNbr, "0999999");
   IF ~!_Str THEN
    RETURN _Str;
   END;
  ELSIF Man.DocType=dt_PaspRussia THEN
   _Str:=CheckPsp(" 㬥", Man.PspSer, "99 99");
   IF ~!_Str THEN
    RETURN _Str;
   END;
   _Str:=CheckPsp(" 㬥", Man.PspNbr, "999999");
   IF ~!_Str THEN
    RETURN _Str;
   END;
  ELSIF Man.DocType=10(*࠭ᯮ *) THEN
   _Str:=CheckPsp(" 㬥", Man.PspSer, "99");
   IF ~!_Str THEN
    RETURN _Str;
   END;
   _Str:=CheckPsp(" 㬥", Man.PspNbr, "0999999");
   IF ~!_Str THEN
    RETURN _Str;
   END;
  ELSIF (Man.DocType=11(*࠭ᯮ *)) | (Man.DocType=16(*.ᯮ .*)) THEN
   _Str:=CheckPsp(" 㬥", Man.PspSer, "99");
   IF ~!_Str THEN
    RETURN _Str;
   END;
   _Str:=CheckPsp(" 㬥", Man.PspNbr, "9999999");
   IF ~!_Str THEN
    RETURN _Str;
   END;
  END;
  L_Russia.TestRus(Man.PspGiveS, " 뤠 㬥", "");
  SplitManDocGiveS(Man.PspGiveS, GiveS, CP);
  IF !GiveS & ~!CP THEN RETURN "  ' 뤠 㬥'    㪠 ⮫쪮  ࠧ" END;
  IF !Man.PspGiveD THEN RETURN "   뤠 㬥"; END;
  IF Man.PspGiveD > SYSDATE() THEN RETURN " 뤠 㬥     "+L_DatTim.DateStr(SYSDATE()); END;
  IF    (Man.DocType = 0(*.*)) | (Man.DocType=dt_PaspRussia) THEN
   IF Man.DocType=dt_PaspRussia THEN
    IF ~(Man.PspGiveD>=01\10\1997) THEN RETURN GetManDocName(Man.DocType)+"   뤠  ࠭ 01\10\1997"; END;
   END;
   IF ~!Man.Birth THEN
    IF L_DatTim.CompleteYearsInIntvl(Man.Birth, Man.PspGiveD-1) < 14 THEN RETURN " 뤠 ᯮ|     14    ஦"; END;
   END;
  ELSE
   IF ~(!Man.Birth | (Man.PspGiveD>=Man.Birth)) THEN RETURN " 뤠 㬥 ࠭ 祬  ஦"; END;
  END;
  RETURN "";
 END {CheckDocument};

 PUBLIC PROCEDURE PrepareManAdressForTax_37(D: DATE;
                                            VAR _Town,
                                                _Village,
                                                _Street,
                                                _Block  : STRING[]);
 BEGIN
  L_General.CallUs(ACCESS(ManAdr));
  SETEMPTY(_Town, _Village, _Street, _Block);
  IF ~!ManAdr.Town THEN
   IF ~( ((ManAdr.Region = 77)&Str.Match(Str.Cap(ManAdr.Town), "")) |
         ((ManAdr.Region = 78)&Str.Match(Str.Cap(ManAdr.Town), "")) ) THEN
    _Town:=ManAdr.Town+" "+L_Russia.TownT_asStr(ManAdr.TownT);
   END;
  END;
  IF ~!ManAdr.Village THEN
   _Village:=ManAdr.Village+" "+L_Russia.VillageT_asStr(ManAdr.VillageT);
  END;
  IF ~!ManAdr.Street THEN
   _Street:=ManAdr.Street+" "+L_Russia.StreetT_asStr(ManAdr.StreetT);
  END;
  IF ~!ManAdr.Block THEN
   _Block:=ManAdr.Block;
  END;
  IF ~!ManAdr.Build THEN
   IF ~!ManAdr.Block THEN
    _Block:=_Block+" ";
   END;
   _Block:=_Block+"."+ManAdr.Build;
  END;
 END {PrepareManAdressForTax_37};

 PUBLIC PROCEDURE PrepareRgManAdressForTax_37(D: DATE;
                                              VAR _Town,
                                                  _Village,
                                                  _Street,
                                                  _Block  : STRING[]);
 BEGIN
  AccessRgManAdr(Man.Man, D);
  PrepareManAdressForTax_37(D, _Town, _Village, _Street, _Block);
 END {PrepareRgManAdressForTax_37};

 PUBLIC PROCEDURE curManAdr_Set_glb_AdrVar();
 BEGIN
  L_Russia.Set_glb_AdrVar(ManAdr.Country, ManAdr.Zip, ManAdr.Region, ManAdr.RegionN, ManAdr.Distr,
                          ManAdr.Town, ManAdr.Village, ManAdr.Street, ManAdr.TownT, ManAdr.VillageT,
                          ManAdr.StreetT, ManAdr.House, ManAdr.Block, ManAdr.Build, ManAdr.Flat, "", L_Russia.capk_Stndr, ManAdr.Date);
 END {curManAdr_Set_glb_AdrVar};

 PUBLIC PROCEDURE GetAdrForTax(VAR S: STRING[]): STRING[];
 BEGIN
  L_General.CallUs(ACCESS(ManAdr));
  TRY
   curManAdr_Set_glb_AdrVar();
   S:=L_Russia.TaxAdr_asStr();
  EXCEPT
  ON Exc: Exc_Raise DO
   IF Exc.ErrorCode = -1 THEN
    RETURN " "+GetManAdrType_asStr(ManAdr.AdrType)+"|"+Exc.MsgOriginalText;
   END;
  END;
  RETURN "";
 END {GetAdrForTax};

 PUBLIC PROCEDURE RegionNameMeanCapital(): LIKE(ManAdr.RegionN);
 BEGIN
  CONFORM(ManAdr, Region);
  IF !ManAdr.RegionN | (~!Region.Capital & ~!ManAdr.Town & (Str.Cap(Region.Capital) = Str.Cap(ManAdr.Town))) THEN
   RETURN "";
  ELSE
   RETURN ManAdr.RegionN;
  END;
 END {RegionNameMeanCapital};

 PUBLIC PROCEDURE GetPostAdr_asStr(Format: L_Russia.tAddressFormat): STRING[];
 BEGIN
  curManAdr_Set_glb_AdrVar();
  RETURN L_Russia.Adr_asStr(Format);
 END {GetPostAdr_asStr};

 PUBLIC PROCEDURE GetAdr_asStr(_Man: LIKE(Man.Man); D: DATE; _AdrType: LIKE(ManAdr.AdrType)): STRING[];
 BEGIN
  IF AccessManAdr(_Man, D, _AdrType) THEN
   RETURN GetPostAdr_asStr(L_Russia.af_Full);
  ELSE
   RETURN " ";
  END;
 END {GetAdr_asStr};

 PUBLIC PROCEDURE GetAdr_asShortStr(_Man: LIKE(Man.Man); D: DATE; _AdrType: LIKE(ManAdr.AdrType)): STRING[];
 BEGIN
  IF AccessManAdr(_Man, D, _AdrType) THEN
   RETURN GetPostAdr_asStr(L_Russia.af_Short);
  ELSE
   RETURN " ";
  END;
 END {GetAdr_asShortStr};

 PUBLIC PROCEDURE ManPhone(D: DATE): STRING[];
  VAR
   phone: STRING[];
 BEGIN
  phone:="";
  SETSEL(CtcVal, Type, Man.Contact, L_ctc.cvc_Home);
  FOR_EACH CtcVal DO
   IF L_ctc.CtcValIsPhone() & L_DatTim.IsActive(D, CtcVal.Begin, CtcVal.Till) THEN
    IF ~!phone THEN
     phone:=phone + "; ";
    END;
    phone:=phone + CtcVal.Value;
   END;
  END; (* FOR_EACH CtcVal *)
  RETURN phone;
 END {ManPhone};

 PUBLIC PROCEDURE curMan_SplitName(VAR Surname   : STRING[];
                                   VAR FirstName : STRING[];
                                   VAR Patronymic: STRING[]);
 BEGIN
  L_Str.SplitManName(Man.Name, Surname, FirstName, Patronymic);
 END {curMan_SplitName};

 PUBLIC PROCEDURE Patronymic(_Name: LIKE(Man.Name)): STRING[];
 BEGIN
  RETURN Str.Slice(_Name, Str.ItemPos(_Name, " ", 2), Str.Length(_Name));
 END {Patronymic};

 PUBLIC PROCEDURE GetFmlStatePool(): STRING[];
 BEGIN
  IF Man.Sex = 0 THEN
   RETURN " 㦥|㦥||";
  ELSE
   RETURN "|||";
  END;
 END {GetFmlStatePool};

 PUBLIC PROCEDURE GetManSexPool(): STRING[];
 BEGIN
  RETURN "|";
 END {GetManSexPool};

 PUBLIC PROCEDURE GetManFmlState_asStr(): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(GetFmlStatePool(), Man.FmlState);
 END {GetManFmlState_asStr};

 PUBLIC PROCEDURE GetManFmlSex_asStr(): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(GetManSexPool(), ManFml.Sex);
 END {GetManFmlSex_asStr};

 PUBLIC PROCEDURE GetManSex_asStr(): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(GetManSexPool(), Man.Sex);
 END {GetManSex_asStr};

 PUBLIC PROCEDURE ExprIsAnyLanguage(_ExprType: LIKE(ManExpr.ExprType)): SCAL[2]; (* 모 *)
 BEGIN
  RETURN _ExprType <= et_ForeignLanguage;
 END {ExprIsAnyLanguage};

 PUBLIC PROCEDURE ExprIsNativeLanguage(_ExprType: LIKE(ManExpr.ExprType)): SCAL[2]; (* 모 *)
 BEGIN
  RETURN _ExprType = et_NativeLanguage;
 END {ExprIsNativeLanguage};

 PUBLIC PROCEDURE ExprIsSkill(_ExprType: LIKE(ManExpr.ExprType)): SCAL[2]; (* 모 *)
 BEGIN
  RETURN _ExprType = et_Skill;
 END {ExprIsSkill};

 PUBLIC PROCEDURE ExprIsStimulation(_ExprType: LIKE(ManExpr.ExprType)): SCAL[2]; (* ७ *)
 BEGIN
  RETURN _ExprType = et_Stimulation;
 END {ExprIsStimulation};

 PUBLIC PROCEDURE ExprIsTribute(_ExprType: LIKE(ManExpr.ExprType)): SCAL[2]; (* ࠤ *)
 BEGIN
  RETURN _ExprType = et_Tribute;
 END {ExprIsTribute};

 PUBLIC PROCEDURE ExprIsScienceAchievement(_ExprType: LIKE(ManExpr.ExprType)): SCAL[2]; (*  ⨦ *)
 BEGIN
  RETURN _ExprType = et_ScienceAchievement;
 END {ExprIsScienceAchievement};

 PUBLIC PROCEDURE GetSkillNamePool(): STRING[];
 BEGIN
  RETURN "設||⥭|⥫᪨ ࠢ";
 END {GetSkillNamePool};

 PUBLIC PROCEDURE GetManExprDocNum(): STRING[];
 BEGIN
  IF ~!ManExpr._EDOrder THEN
   L_EDO.StandOnEDOrder(ManExpr._EDOrder, ManExpr._Row);
   CONFORM(ManExpr, Expr);
   IF Expr.Source = expsrc_Internal THEN
    RETURN EDOrder.SrcNum;
   ELSE
    L_EDO.StandOnEDOLCauseODoc();
    RETURN ODoc.SrcNbr;
   END;
  ELSE
   RETURN ManExpr.DocSer + " " + ManExpr.DocNum;
  END;
 END {GetManExprDocNum};

 PUBLIC PROCEDURE GetManExprDocGiveS(): STRING[];
 BEGIN
  IF ~!ManExpr._EDOrder THEN
   L_EDO.StandOnEDOrder(ManExpr._EDOrder, ManExpr._Row);
   CONFORM(ManExpr, Expr);
   IF Expr.Source = expsrc_Internal THEN
    RETURN P_Firm.FP_ContractorBriefName(P_Firm.OWN_FIRM, EDOrder.PrpDate);
   ELSE
    L_EDO.StandOnEDOLCauseODoc();
    RETURN P_Firm.FP_ContractorBriefName(ODoc.Firm, ODoc.Date);
   END;
  ELSE
   RETURN ManExpr.DocGiveS;
  END;
 END {GetManExprDocGiveS};

 PUBLIC PROCEDURE GetManExprComment(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF ~!ManExpr._EDOrder THEN
   L_EDO.StandOnEDOrder(ManExpr._EDOrder, ManExpr._Row);
   CONFORM(ManExpr, Expr);
   IF Expr.Source = expsrc_Internal THEN
    Result:=EDOrder.About;
   ELSE
    L_EDO.StandOnEDOLCauseODoc();
    Result:=L_ODoc.GetCurODocSpcName();
   END;
  ELSE
   Result:=ManExpr.Comment;
  END;
  RETURN Result;
 END {GetManExprComment};

 PUBLIC PROCEDURE Man_Citizen(_Man: LIKE(Man.Man); D: DATE): SCAL[4];
  VAR
   Result: SCAL[4];
 BEGIN
  IF AccessManAdr(_Man, D, L_Russia.at_RgMA) | AccessManAdr(_Man, D, L_Russia.at_CtMA) THEN
   IF ManAdr.Country = L_Russia.c_Russia THEN
    IF (ManAdr.Region = 77) | (ManAdr.Region = 50) THEN
     Result:=ct_Moscow;
    ELSE
     Result:=ct_Russia;
    END;
   ELSIF L_Russia.CountryIsCIS(ManAdr.Country) THEN
    Result:=ct_CIS;
   ELSE
    Result:=ct_Foreign;
   END;
  ELSE
   SAVE(Man);
   SEARCH(Man, Man, , _Man);
   IF Man.DocType=dt_PaspRussia THEN
    Result:=ct_Russia;
   ELSE
    Result:=ct_Foreign;
   END;
   RESTORE(Man);
  END;
  RETURN Result;
 END {Man_Citizen};

 PUBLIC PROCEDURE CitizenAsStr(_Man: LIKE(Man.Man); D: DATE): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(ctz_Pool, Man_Citizen(_Man, D));
 END {CitizenAsStr};

(*------------------STAGES-----------------------------------*)

 PRIVATE PROCEDURE _StandOnLastBegan(_TSN         : LIKE(Staff.TSN);
                                     D            : DATE;
                                     wProlongation: SCAL[2]);
 BEGIN
  SETSEL(StaffLog, TSN, _TSN);
  IF ~SRCINSEL(StaffLog, LE, D) THEN
   FIRST(StaffLog);
  END;
  WHILE OCCURE(StaffLog) &
        (L_Staff.GetStaffLogType() # L_Staff.slkt_TakeOn) &
        (L_Staff.GetStaffLogType() # L_Staff.slkt_TakeOnWithDischarge) &
        (wProlongation | (L_Staff.GetStaffLogType() # L_Staff.slkt_Prolongation)) DO
   PREV(StaffLog);
  END; (* WHILE OCCURE(StaffLog) ... *)
  L_General.CallUs(OCCURE(StaffLog));
 END {_StandOnLastBegan};

 PUBLIC PROCEDURE StandOnLastBegan(_TSN: LIKE(Staff.TSN); D: DATE);
 BEGIN
  _StandOnLastBegan(_TSN, D, 0);
 END {StandOnLastBegan};

 PUBLIC PROCEDURE GetRealBegDate(D: DATE): DATE;
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   StandOnLastBegan(Staff.TSN, D);
   RETURN StaffLog.Date;
  EXCEPT
  END;
 END {GetRealBegDate};

 PUBLIC PROCEDURE GetTakeOnDate(D: DATE): DATE;
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   _StandOnLastBegan(Staff.TSN, D, 1);
   RETURN StaffLog.Date;
  EXCEPT
  END;
 END {GetTakeOnDate};

 PRIVATE PROCEDURE IncludeInContractsLength(wCA: SCAL[2]): SCAL[2];
 BEGIN
  RETURN (Staff.Contract # L_Staff.cnt_InternalCombine) &
         ((Staff.Contract # L_Staff.cnt_ContractorsAgreement) | wCA) &
         (Staff.Contract # L_Staff.cnt_OutStaff);
 END {IncludeInContractsLength};

 PUBLIC PROCEDURE GetTotTakeOnDate(D: DATE; wCA: SCAL[2]): DATE;
  VAR
   _BegDate: LIKE(Staff.BegDate);
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   L_AFM.MakeIndex("_Stf1", "BegDate: DATE;"+
                            "EndDate: DATE;"+
                            "TSN    : LIKE(Staff.TSN)");
   SETSEL(Staff, Man, Staff.Man);
   FOR_EACH Staff DO
    IF (Staff.BegDate <= D) & IncludeInContractsLength(wCA) THEN
     ADD(_Stf1, _Stf1, , Staff.BegDate, Staff.EndDate, Staff.TSN);
    END;
   END; (* FOR_EACH Staff *)
 
   _BegDate:=D+1;
   SETSEL(_Stf1, _Stf1);
   IF LAST(_Stf1) THEN
    LOOP
     SEARCH(Staff, TSN, , _Stf1.TSN);
     L_Staff.PosToStaffLog(Staff.TSN, Math.Min(D, _BegDate), 1);
     WHILE OCCURE(StaffLog) DO
      IF (_BegDate > D) | (~L_Staff.IsDischargeStaffLog() & (StaffLog.DateE >= (_BegDate-1))) THEN
       _BegDate:=StaffLog.Date;
      ELSE
       FIRST(StaffLog); (* EXIT ⮬    ࠡ  㣮 MyFirm*)
      END;
      PREV(StaffLog);
     END; (* WHILE OCCURE(StaffLog) ... *)
     IF ~PREV(_Stf1) | (_Stf1.EndDate < (_BegDate-1)) THEN
      EXIT;
     END;
    END;
   END;
   L_AFM.AF_PurgeTemp("_Stf1");
   RETURN _BegDate;
  EXCEPT
  END;
 END {GetTotTakeOnDate};

 PUBLIC PROCEDURE GetRealEndDate(D: DATE): DATE;
  VAR
   Result: DATE;
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   SETEMPTY(Result);
   StandOnLastBegan(Staff.TSN, D);
   WHILE NEXT(StaffLog) & (L_Staff.GetStaffLogType() # L_Staff.slkt_Discharge) &
                          (L_Staff.GetStaffLogType() # L_Staff.slkt_Prolongation) &
                          (L_Staff.GetStaffLogType() # L_Staff.slkt_TakeOnWithDischarge) DO
   END; (* WHILE OCCURE(StaffLog) ... *)
   IF OCCURE(StaffLog) THEN
    Result:=StaffLog.Date-1;
   END;
  EXCEPT
  END;
  IF ~!Staff.EndDate THEN
   L_General.CallUs(~!Result);
  END;
  RETURN Result;
 END {GetRealEndDate};

 PUBLIC PROCEDURE GetTimedContractEndDate(D: DATE): DATE;
  VAR
   Result: DATE;
 BEGIN
  SETEMPTY(Result);
  SAVE(StaffLog);
  SAVE(SLKind);
  StandOnLastBegan(Staff.TSN, D);
  IF StaffLog.ContDTyp = L_Staff.cdt_FixedDate THEN
   Result:=StaffLog.CntrEnd;
   IF ~!Result THEN
    WHILE NEXT(StaffLog) & ~L_Staff.IsDischargeStaffLog() DO
     IF    StaffLog.ContDTyp = L_Staff.cdt_Permanent THEN
      SETEMPTY(Result);
     ELSIF L_Staff.GetStaffLogType() = L_Staff.slkt_Prolongation THEN
      Result:=StaffLog.CntrEnd;
     END;
    END; (* WHILE *)
   END; (* IF ~!Result ...*)
  END;
  RESTORE(SLKind);
  RESTORE(StaffLog);
  RETURN Result;
 END {GetTimedContractEndDate};

 PUBLIC PROCEDURE CheckManActvForPrvWork(trgMan: LIKE(Man.Man));
  VAR
   D  : DATE;
   Cnt: NUMERIC[0];
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   IF L_Staff.IsStandOnAnyMainContract(trgMan, SYSDATE()+365) THEN
    D:=GetTakeOnDate(SYSDATE()+365);
    Cnt:=0;
    SETSEL(Staff, Man, trgMan);
    FOR_EACH Staff DO
     IF IncludeInContractsLength(0) THEN
      SELECT(StaffLog, TSN, , Staff.TSN);
      WHILE OCCURE(StaffLog) & (Cnt = 0) DO
       IF ~L_Staff.IsDischargeStaffLog() & (StaffLog.DateE < D) & L_Staff.IsMainForTax(StaffLog.Date) THEN
        IF ~SELECT(ManActv, Man, trgMan, actvk_Work) |
           ~SRCINSEL(ManActv, LE, StaffLog.Date) |
           (StaffLog.Date > ManActv.EndDate) |
           ((StaffLog.Date >= L_Env.aptm_Start) &
            (Staff.Contract = L_Staff.cnt_Basic) &
            ~L_DatTim.InPatIntvl(ManActv.BegDate, ManActv.EndDate, StaffLog.Date, StaffLog.DateE)) THEN
         L_StdFrm.Choice(" 㤮 ⥫쭮  " + FLDTOSTR(trgMan, "", 5) +
                         "| ଫ  ਮ ࠡ  襬 ।⨨," +
                         "|ਬ, ਮ "+L_DatTim.DateStr(StaffLog.Date) + "-" + L_DatTim.DateStr(StaffLog.DateE)+
                         "||㤮 ⠦ 㤥 뢠 ୮.");
         INC(Cnt);
        END;
       END;
       NEXT(StaffLog);
      END; (* WHILE OCCURE(StaffLog) ... *)
     END;
    END; (* FOR_EACH Staff *)
   END;
  EXCEPT
  END; (* TRY *)
 END {CheckManActvForPrvWork};

 PUBLIC PROCEDURE GetTheLastContractEndOfMan(trgMan: LIKE(Man.Man);
                                             D     : DATE;
                                             wCA   : SCAL[2]): DATE;
  VAR
   E,
   Result: DATE;
 BEGIN
  Result:=MINOF(DATE);
  SAVE(Staff);
  SETSEL(Staff, Man, trgMan);
  FOR_EACH Staff DO
   IF IncludeInContractsLength(wCA) THEN
    E:=GetRealEndDate(D);
    IF !E THEN
     E:=GetTimedContractEndDate(D);
    END;
    Result:=Math.Max(Result, E);
   END; (* IF ... *)
  END; (* FOR_EACH Staff *)
  RESTORE(Staff);
  RETURN Result
 END {GetTheLastContractEndOfMan};

 PUBLIC PROCEDURE extGetContractsLengthOfMan(_Man      : LIKE(Man.Man);
                                             _From,
                                             _UpTo,
                                             curPeriod : DATE;
                                             wCA,
                                             wCntrEnd  : SCAL[2]): NUMERIC[0];
  VAR
   D,
   B,
   E  : DATE;
   cl : NUMERIC[0];
 BEGIN
  IF wCA THEN
   L_AFM.MakeIndex("GCLOM", "B: DATE;"+
                            "E: DATE;");
  END;
  cl:=0;
  SAVE(Staff);
  SETSEL(Staff, Man, _Man);
  FOR_EACH Staff DO
   IF IncludeInContractsLength(wCA) THEN
    D:=_UpTo;
    REPEAT
     B:=GetRealBegDate(D);
     E:=GetRealEndDate(D);
     IF wCntrEnd & !E THEN
      E:=GetTimedContractEndDate(D);
      IF E < curPeriod THEN
       SETEMPTY(E);
      END;
     END;
     IF B <= L_DatTim.MonthEnd(curPeriod) THEN
      IF wCA THEN
       GCLOM.B:=B;
       GCLOM.E:=E;
       INSERT(GCLOM);
      END;
      INC(cl, L_DatTim.DATEINT(B, E, _From, _UpTo));
     END;
     D:=B-1;
    UNTIL (B <= _From) | (B = Staff.BegDate);
   END; (* IF ... *)
  END; (* FOR_EACH Staff *)
  RESTORE(Staff);
  IF wCA THEN
   cl:=0;
   E:=MINOF(DATE);
   SELECT(GCLOM, GCLOM);
   WHILE OCCURE(GCLOM) & ~!E DO
    B:=Math.Max(GCLOM.B, E+1);
    E:=GCLOM.E;
    INC(cl, L_DatTim.DATEINT(B, E, _From, _UpTo));
    NEXT(GCLOM);
   END; (* WHILE OCCURE(GCLOM) ... *)
   L_AFM.AF_PurgeTemp("GCLOM");
  END;
  RETURN cl;
 END {extGetContractsLengthOfMan};

 PUBLIC PROCEDURE GetContractsLengthOfMan(_Man    : LIKE(Man.Man);
                                          _From,
                                          _UpTo   : DATE;
                                          wCA,
                                          wCntrEnd: SCAL[2]): NUMERIC[0];
 BEGIN
  RETURN extGetContractsLengthOfMan(_Man, _From, _UpTo, L_DatTim.Per(MAXOF(DATE))-1, wCA, wCntrEnd);
 END {GetContractsLengthOfMan};

 PUBLIC PROCEDURE InAnyStage(): SCAL[2];
  VAR
   i : NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i <= HIGH(ManActv.InStage) DO
   IF ManActv.InStage[i] THEN
    RETURN 1;
   END;
   INC(i);
  END;
  RETURN 0;
 END {InAnyStage};

 PRIVATE PROCEDURE InSocInsuranceStage(D: DATE): SCAL[2];
 BEGIN
  RETURN (ManActv.ActvKind = actvk_Work) &
         ((ManActv.ActvCatg = actvc_Work) | ((D >= 01\01\2010) & (ManActv.ActvCatg = actvc_MltService)));
 END {InSocInsuranceStage};

 PRIVATE PROCEDURE _FillStagesAssert(Cond: SCAL[2]; Msg: STRING[]);
 BEGIN
  IF ~Cond THEN
   L_General.Error(" "+Man_ManAsStr()+",   ⠦:|"+
                   Msg+"|"+Str.Slice(ManActv.FndName, 0, 70));
  END;
 END {_FillStagesAssert};

 PRIVATE PROCEDURE InsFS(_StageT: tins_Size; B, E: DATE);
  VAR
   D1,
   D2: DATE;
 BEGIN
  SETSEL(_FilS, _FilS, _StageT);
  FOR_EACH _FilS DO
   D1:=_FilS.BegD;
   D2:=_FilS.EndD;
   IF B < D1 THEN
    IF E >= D1 THEN
     _FilS.BegD:=B;
     _FilS.EndD:=D1-1;
     INSERT(_FilS);
     IF E > D2 THEN
      InsFS(_StageT, D2+1, E);
     END;
     RETURN;
    END;
   ELSIF B <= D2 THEN
    IF E > D2 THEN
     InsFS(_StageT, D2+1, E);
    END;
    RETURN;
   END;
  END; (* FOR_EACH _FilS *)
  _FilS.StageT:=_StageT;
  _FilS.BegD:=B;
  _FilS.EndD:=E;
  INSERT(_FilS);
 END {InsFS};

 PRIVATE PROCEDURE intFillStages(    Date          : DATE;
                                 VAR DaysOfStage,
                                     MonthsOfStage,
                                     YearsOfStage  : NUMERIC[0][ins_Size];
                                 VAR CntStageDate  : DATE      [ins_Size];
                                 VAR _TakeOnDate   : DATE;
                                     OnlyOneStageTDate: SCAL[2];
                                     trgStageT        : tins_Size);
  VAR
   D, M, Y,
   _StageT : NUMERIC[0];
   _BegDate,
   _EndDate: DATE;
   NoInfoBefStart: SCAL[2];
   StageTArr     : tins_Size[ins_Size];
 BEGIN
  APP.Get().NewPrompt(" ଠ樨  ⠦");
  _TakeOnDate:=GetTakeOnDate(SYSDATE()+5(* ଫ । ᫮*));
  SETZERO(DaysOfStage, MonthsOfStage, YearsOfStage);
  IF !trgStageT THEN
   L_General.CallUs(ins_SocInsuranceNoIns = ins_Size-1); (*   StageTArr*)
   StageTArr:=[ins_LastProf, ins_Continuous, ins_Common, ins_Post, ins_Branch, ins_SocInsurance, ins_SocInsuranceNoIns];
  ELSE
   SETEMPTY(StageTArr);
   StageTArr[0]:=trgStageT;
  END;
  FOR_EACH _StageT IN StageTArr DO
   CntStageDate[_StageT]:=_TakeOnDate;
  END; (* FOR_EACH *)
  L_AFM.MakeIndex("_FilS", "StageT: "+GET_TYPE_SPEC(tins_Size).Name+";"+
                           "BegD: DATE;"+
                           "EndD: DATE");
  TRY
   NoInfoBefStart:=1;
   SETSEL(ManActv, Man, Man.Man);
   FOR_EACH ManActv DO
    PROMPT(L_Str.PoolItem(actvk_Pool, ManActv.ActvKind) + " " + L_DatTim.DateStr(ManActv.BegDate));
    IF (ManActv.ActvKind = actvk_Education) |
       (ManActv.ActvKind = actvk_Work) THEN
     IF InAnyStage() | ((ManActv.ActvKind = actvk_Work) & (ManActv.ActvCatg = actvc_Work)) |
        InSocInsuranceStage(Date) THEN
      _FillStagesAssert(~!ManActv.BegDate, " 㪠  砫");
      _BegDate:=ManActv.BegDate;
      IF ~!ManActv.EndDate THEN
       _FillStagesAssert(ManActv.EndDate >= ManActv.BegDate,
                        " 砭     砫");
       _EndDate:=ManActv.EndDate;
      ELSE
       _EndDate:=_TakeOnDate;
      END;
      IF _BegDate <= _EndDate THEN
       IF (ManActv.BegDate >= _TakeOnDate) & (ManActv.BegDate < L_Env.aptm_Start) THEN
        (* ଫ  ⮏  1917,   ᪠ ⮏ 뢠 ࠪ *)
        IF NoInfoBefStart THEN
         L_General.Assert(ManActv.BegDate = _TakeOnDate,
                          " "+Man_ManAsStr()+"|  ଠ  ࠧ/㤮 ⥫쭮"+
                          "| ਮ  "+L_DatTim.DateStr(_TakeOnDate)+"  "+L_DatTim.DateStr(ManActv.BegDate-1));
        END;
        NoInfoBefStart:=0;
        _TakeOnDate:=ManActv.EndDate;
        FOR_EACH _StageT IN StageTArr DO
         CntStageDate[_StageT]:=_TakeOnDate;
        END; (* FOR_EACH *)
       END;
       _StageT:=0;
       WHILE _StageT <= HIGH(ManActv.InStage) DO
        IF ManActv.InStage[_StageT] THEN
         InsFS(_StageT, _BegDate, _EndDate);
        END; (* IF ManActv.InStage[_StageT] ... *)
        INC(_StageT);
       END; (* WHILE _StageT ... *)
       IF InSocInsuranceStage(Date) THEN
        InsFS(ins_SocInsurance, _BegDate, _EndDate);
        IF ManActv.ActvCatg = actvc_MltService THEN
         InsFS(ins_SocInsuranceNoIns, _BegDate, _EndDate);
        END;
       END;
      END; (* IF _BegDate <=  ... *)
     END; (* IF InAnyStage()... *)
    END; (* IF ManActv.ActvKind ... *)
   END; (* FOR_EACH ManActv *)

   FOR_EACH _StageT IN StageTArr DO
    SELECT(_FilS, _FilS, , _StageT);
    WHILE OCCURE(_FilS) DO (*᪫   ਮ*)
     _EndDate:=_FilS.EndD;
     IF NEXT(_FilS) & (_FilS.BegD = (_EndDate+1)) THEN
      PREV(_FilS);
      _BegDate:=_FilS.BegD;
      REMOVE(_FilS);
      _FilS.BegD:=_BegDate;
      REPLACE(_FilS);
     END;
    END; (* WHILE OCCURE(_FilS) ... *)
    FIRST(_FilS);
    WHILE OCCURE(_FilS) & (_FilS.BegD<_TakeOnDate) DO
     IF ~OnlyOneStageTDate THEN
      L_DatTim.GetDatesDifferenceIn3Part(_FilS.BegD, Math.Min(_FilS.EndD, _TakeOnDate), D, M, Y);
      INC(  DaysOfStage[_StageT], D);
      INC(MonthsOfStage[_StageT], M);
      INC( YearsOfStage[_StageT], Y);
     END;
     IF _StageT = ins_LastProf THEN
      CntStageDate[_StageT]:=Math.Min(CntStageDate[_StageT], _FilS.BegD);
     ELSE
      DEC(CntStageDate[_StageT], _FilS.EndD-_FilS.BegD);
     END;
     NEXT(_FilS);
    END; (* WHILE OCCURE(_FilS) ... *)
    IF ~OnlyOneStageTDate THEN
     L_DatTim.NormalizeDMY(DaysOfStage[_StageT], MonthsOfStage[_StageT], YearsOfStage[_StageT]);
    END;
   END; (* FOR_EACH *)
   IF !trgStageT | (trgStageT = ins_Branch) THEN
    CntStageDate[ins_Branch]:=L_DatTim.IncMonth(CntStageDate[ins_Branch], +1);
   END;
   L_AFM.AF_PurgeTemp("_FilS");
  EXCEPT
  ELSE
   L_AFM.AF_PurgeTemp("_FilS");
   RAISE();
  END;
 END {intFillStages};

 PUBLIC PROCEDURE GetStageDate(trgDate: DATE; trgStageT: tins_Size): DATE;
  VAR
   Dummy1,
   Dummy2,
   Dummy3      : NUMERIC[0][ins_Size];
   Dummy       : DATE;
   CntStageDate: DATE[ins_Size];
 BEGIN
  intFillStages(trgDate, Dummy1, Dummy2, Dummy3, CntStageDate, Dummy, 1, trgStageT);
  RETURN CntStageDate[trgStageT];
 END {GetStageDate};

 PUBLIC PROCEDURE FillStages(    Date          : DATE;
                             VAR DaysOfStage,
                                 MonthsOfStage,
                                 YearsOfStage  : NUMERIC[0][ins_Size];
                             VAR CntStageDate  : DATE      [ins_Size];
                             VAR TakeOnDate    : DATE);
 BEGIN
  intFillStages(Date, DaysOfStage, MonthsOfStage, YearsOfStage, CntStageDate, TakeOnDate, 0, EMPTYOF(tins_Size));
 END {FillStages};

 PUBLIC PROCEDURE FillStageDriver(    Date           : DATE;
                                  VAR DaysDriver,
                                      MonthsDriver,
                                      YearsDriver,
                                      DaysDrInFirm,
                                      MonthsDrInFirm,
                                      YearsDrInFirm  : NUMERIC[0];
                                  VAR StageDriver,
                                      StageDrInFirm  : NUMERIC[6]);
  VAR
   DaysOfStage,
   MonthsOfStage,
   YearsOfStage  : NUMERIC[0][ins_Size];
   CntStageDate  : DATE      [ins_Size];
   trgTakeOnDate : DATE;
   D, M, Y       : NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt(" ⥫᪮ ⠦  ।⨨:  " + Staff.TSN);
  CONFORM(Staff, Man);
  TRY
   intFillStages(Date, DaysOfStage, MonthsOfStage, YearsOfStage, CntStageDate, trgTakeOnDate, 0, ins_LastProf);
  EXCEPT
  ON Exc: Exc_Raise DO
   SETEMPTY(DaysOfStage, MonthsOfStage, YearsOfStage);
  ELSE
   RAISE();
  END;
  SAVE(Officer);
  SAVE(StaffLog);
  SETZERO(DaysDriver,   MonthsDriver,   YearsDriver,   StageDriver,
          DaysDrInFirm, MonthsDrInFirm, YearsDrInFirm, StageDrInFirm);
  IF L_Staff.rInState(Date) THEN
   CONFORM(StaffLog, Officer, Post, Sort, Union);
   IF L_Env.IsDriver() THEN
    IF ~!DaysOfStage[ins_LastProf] THEN
     DaysDriver  :=DaysOfStage  [ins_LastProf];
     MonthsDriver:=MonthsOfStage[ins_LastProf];
     YearsDriver :=YearsOfStage [ins_LastProf];
    END;
    SELECT(StaffLog, TSN, , Staff.TSN);
    SRCINSEL(StaffLog, GE, , trgTakeOnDate);
    WHILE OCCURE(StaffLog) DO
     PROMPT(L_DatTim.DateStr(StaffLog.Date));
     CONFORM(StaffLog, Officer);
     IF ~L_Staff.IsDischargeStaffLog() & L_Env.IsDriver() THEN
      IF ~!StaffLog.DateE THEN
       L_DatTim.GetDatesDifferenceIn3Part(StaffLog.Date, StaffLog.DateE, D, M, Y);
      ELSE
       L_DatTim.GetDatesDifferenceIn3Part(StaffLog.Date, Date,           D, M, Y);
      END;
      INC(DaysDrInFirm,   D);
      INC(MonthsDrInFirm, M);
      INC(YearsDrInFirm,  Y);
     END;
     NEXT(StaffLog);
    END; (* WHILE OCCURE(StaffLog) ... *)
   END; (* IF L_Env.IsDriver() ... *)
  END; (* IF L_Staff.rInState(Date) ... *)
  RESTORE(StaffLog);
  RESTORE(Officer);
  INC(DaysDriver,   DaysDrInFirm);
  INC(MonthsDriver, MonthsDrInFirm);
  INC(YearsDriver,  YearsDrInFirm);
  L_DatTim.NormalizeDMY(DaysDriver,   MonthsDriver,   YearsDriver);
  L_DatTim.NormalizeDMY(DaysDrInFirm, MonthsDrInFirm, YearsDrInFirm);
  StageDriver  :=(DaysDriver   / (L_DatTim.AveDaysInMonth*12)) + (MonthsDriver   / 12) + YearsDriver;
  StageDrInFirm:=(DaysDrInFirm / (L_DatTim.AveDaysInMonth*12)) + (MonthsDrInFirm / 12) + YearsDrInFirm;
 END {FillStageDriver};

 PUBLIC PROCEDURE GetFlmMember_asStr(): STRING[];
 BEGIN
  IF    ManFml.Member = fm_Child THEN
   RETURN L_Str.PoolItem("|", ManFml.Sex);
  ELSIF ManFml.Member = fm_MarriedCouple THEN
   RETURN L_Str.PoolItem("|", ManFml.Sex);
  ELSIF ManFml.Member = fm_Other THEN
   RETURN "祥";
  ELSIF ManFml.Member = fm_Parent THEN
   RETURN L_Str.PoolItem("|", ManFml.Sex);
  ELSE
   L_General.CallUs(0);
  END;
 END {GetFlmMember_asStr};

 PRIVATE PROCEDURE _wordSetAddresses(Prefix    : STRING[];
                                     trgMan    : LIKE(Man.Man);
                                     D         : DATE;
                                     trgAdrType: LIKE(ManAdr.AdrType));
 BEGIN
  IF AccessManAdr(trgMan, D, trgAdrType) THEN
   curManAdr_Set_glb_AdrVar();
  ELSE
   L_Russia.Set_glb_AdrVar_ToEmpty();
  END;
  L_Russia.wordSetAddr_byPart(Prefix);
 END {_wordSetAddresses};

 PUBLIC PROCEDURE wordSetAddresses(Root  : STRING[];
                                   trgMan: LIKE(Man.Man);
                                   D     : DATE);
 BEGIN
  _wordSetAddresses(Root+"BthAdr", trgMan, D, L_Russia.at_BthMA);
  _wordSetAddresses(Root+"RgAdr",  trgMan, D, L_Russia.at_RgMA);
  _wordSetAddresses(Root+"DwAdr",  trgMan, D, L_Russia.at_DwMA);
 END {wordSetAddresses};

 PUBLIC PROCEDURE ManAccessActv(_ActvKind: LIKE(ManActv.ActvKind);
                                _EdType  : LIKE(ManActv.EdType);
                                _Nbr     : NUMERIC[0]): SCAL[2];
 BEGIN              
  SELECT(ManActv, Man, , Man.Man, _ActvKind);
  WHILE OCCURE(ManActv) DO
   IF ManActv.EdType = _EdType THEN
    DEC(_Nbr);
    IF _Nbr = 0 THEN
     RETURN 1;
    END;
   END;
   NEXT(ManActv);
  END; (* WHILE ... *)
  RETURN 0;
 END {ManAccessActv};

 PUBLIC PROCEDURE GetManEducationLevelAsOKIN(): STRING[];
  VAR
   HasAny: SCAL[2];
   EdType: STRING[];
 BEGIN
  SETEMPTY(EdType);
  IF    ManAccessActv(actvk_Education, edtype_HighProf,      1) THEN EdType:="3018";
  ELSIF ManAccessActv(actvk_Education, edtype_SecondaryProf, 1) THEN EdType:="3011";
  ELSIF ManAccessActv(actvk_Education, edtype_PrimaryProf,   1) THEN EdType:="3010";
  ELSE
   HasAny:=ManAccessActv(actvk_Education, edtype_Secondary, 1) | ManAccessActv(actvk_Education, edtype_General, 1) |
           ManAccessActv(actvk_Education, edtype_Primary,   1) | ManAccessActv(actvk_Education, edtype_None,    1);
   IF HasAny THEN
    IF    ManActv.EdType = edtype_None    THEN EdType:="3001";
    ELSIF ManActv.EdType = edtype_Primary THEN EdType:="3002";
    ELSIF ManActv.EdType = edtype_General THEN EdType:="3003";
    ELSE                                       EdType:="3007";
    END;
   END;
  END;
  RETURN EdType;
 END {GetManEducationLevelAsOKIN};

 PUBLIC PROCEDURE GetManEducationLevelAsStr(): STRING[];
  VAR
   sEdType: STRING[];
 BEGIN
  sEdType:="। 饥";
  IF ManAccessActv(actvk_Education, edtype_Secondary, 1) | ManAccessActv(actvk_Education, edtype_General, 1) |
     ManAccessActv(actvk_Education, edtype_Primary,   1) | ManAccessActv(actvk_Education, edtype_None,    1) THEN
   IF    ManActv.EdType = edtype_None    THEN sEdType:=" 砫쭮";
   ELSIF ManActv.EdType = edtype_Primary THEN sEdType:="砫쭮 饥";
   ELSIF ManActv.EdType = edtype_General THEN sEdType:="᭮ 饥";
   END;
  END;
  IF ManAccessActv(actvk_Education, edtype_PrimaryProf,   1) THEN sEdType:="砫쭮 ᨮ쭮";
  END;
  IF ManAccessActv(actvk_Education, edtype_SecondaryProf, 1) THEN sEdType:="। ᨮ쭮";
  END;
  IF ManAccessActv(actvk_Education, edtype_HighProf,      1) THEN sEdType:="襥 ᨮ쭮";
  END;
  RETURN sEdType;
 END {GetManEducationLevelAsStr};

 PUBLIC PROCEDURE GetManEducationTypeAsOKIN(): STRING[];
 BEGIN
  IF    ManActv.EdType = edtype_None          THEN  RETURN "";
  ELSIF ManActv.EdType = edtype_Primary       THEN  RETURN "3002"; (*砫쭮 (饥) ࠧ*)
  ELSIF ManActv.EdType = edtype_General       THEN  RETURN "3003"; (*᭮ 饥 ࠧ*)
  ELSIF ManActv.EdType = edtype_Secondary     THEN  RETURN "3007"; (*। () 饥 ࠧ*)
  ELSIF ManActv.EdType = edtype_PrimaryProf   THEN  RETURN "3010"; (*砫쭮 ᨮ쭮 ࠧ*)
  ELSIF ManActv.EdType = edtype_SecondaryProf THEN  RETURN "3011"; (*। ᨮ쭮 ࠧ*)
  ELSIF ManActv.EdType = edtype_HighProf      THEN  RETURN "3018"; (*襥 ࠧ*)
  ELSIF ManActv.EdType = edtype_AfterHighProf THEN  RETURN "3019"; (*᫥㧮᪮ ࠧ*)
  ELSE L_General.CallUs(0);
  END;
 END {GetManEducationTypeAsOKIN};

 PUBLIC PROCEDURE GetManLangLevelAsOKIN():STRING[];
  VAR
   _Level: NUMERIC[0];
 BEGIN
  _Level:=L_Str.PositionInPool(GetManLanguageLevelPool(), Expr.Level);
  IF    _Level = 0 THEN
   RETURN "053";
  ELSIF _Level = 1 THEN
   RETURN "051";
  ELSIF _Level = 2 THEN
   RETURN "052";
  ELSE
   RETURN "";
  END;
 END {GetManLangLevelAsOKIN};

 PUBLIC PROCEDURE GetManFmlMemberAsOKIN(): STRING[];
 BEGIN
  IF    ManFml.Member = fm_Child THEN
   IF ManFml.Sex THEN
    RETURN "1105";
   ELSE
    RETURN "1106";
   END;
  ELSIF ManFml.Member = fm_MarriedCouple THEN
   IF ManFml.Sex THEN
    RETURN "1101";
   ELSE
    RETURN "1102";
   END;
  ELSIF ManFml.Member = fm_Other THEN
   RETURN "1170";
  ELSIF ManFml.Member = fm_Parent THEN
   IF ManFml.Sex THEN
    RETURN "1103";
   ELSE
    RETURN "1104";
   END;
  ELSE
   L_General.CallUs(0);
  END;
 END {GetManFmlMemberAsOKIN};

 PUBLIC PROCEDURE GetManFmlStateAsOKIN():STRING[];
 BEGIN
  IF    Man.FmlState = 0 THEN
   RETURN "101";
  ELSIF Man.FmlState = 1 THEN
   RETURN "102";
  ELSIF Man.FmlState = 2 THEN
   RETURN "105";
  ELSIF Man.FmlState = 3 THEN
   RETURN "104";
  ELSE
   RETURN "";
  END;
 END {GetManFmlStateasOKIN};

 PUBLIC PROCEDURE GetManSexAsOKIN():STRING[];
 BEGIN
  IF Man.Sex THEN
   RETURN "012";
  ELSE
   RETURN "011";
  END;
 END {GetManSexAsOKIN};

 PUBLIC PROCEDURE GetManCitizenshipAsOKIN():STRING[];
 BEGIN
  IF ManAdr.Country=L_Russia.c_Russia THEN
   RETURN "021";
  ELSE
   RETURN "023";
  END;
 END {GetManCitizenshipAsOKIN};

 PUBLIC PROCEDURE ConvName(_Name: STRING[]): STRING[];
 BEGIN
  IF ~!_Name THEN
   _Name:=Str.Cap(_Name);
   RETURN Str.Item(_Name, " ", 0) + "," +
          Str.Item(_Name, " ", 1) + "," +
          Patronymic(_Name);
  ELSE
   RETURN _Name;
  END;
 END {ConvName};

 PUBLIC PROCEDURE intInteractiveAccessStaffByMan(AccessLeaved: SCAL[2]; Silent: SCAL[2]): SCAL[2];
 BEGIN
  IF ~ACCESS(Staff) THEN
   L_General.Assert(ACCESS(Man), " ࠭ ⥪騩 ࠡ⭨");
   IF Man.rStaff = rs_wStaff THEN
    IF L_Staff.IsStandOnAnyMainContract(Man.Man, SYSDATE()+365) THEN
     IF ~L_Staff.InStateInPer(SYSDATE(), SYSDATE()+365) & ~AccessLeaved THEN
      IF ~Silent THEN
       L_StdFrm.Choice("⭨ 㦥 㢮.||    ஭ ।⠢⥫?");
      END;
      SELECT(Staff, TSN, , "");
     END;
    END;
   END;
  ELSE
   CONFORM(Staff, Man);
  END;
  RETURN OCCURE(Staff);
 END {intInteractiveAccessStaffByMan};

 PUBLIC PROCEDURE InteractiveAccessStaffByMan(AccessLeaved: SCAL[2]): SCAL[2];
 BEGIN
  RETURN intInteractiveAccessStaffByMan(AccessLeaved, 0);
 END {InteractiveAccessStaffByMan};

 PUBLIC PROCEDURE LaborActivityLicenseRequired(trgMan: LIKE(Man.Man); trgDate: DATE): SCAL[2];
  VAR
   fls: P_Man.tForeignerLegalStatus;
 BEGIN
  fls:=P_Man.GetForeignerLegalStatus(trgMan, trgDate);
  IF (fls = P_Man.fls_ResidencePermit) | ((trgDate>=11\01\2013) & (fls = P_Man.fls_TempResidence)) THEN
   RETURN 0;
  ELSE
   IF ~AccessManAdr(trgMan, trgDate, L_Russia.at_CtMA) THEN
    AccessRgManAdr(trgMan, trgDate);
   END;
   RETURN (ManAdr.Country # L_Russia.c_Russia) & (ManAdr.Country # 112);
  END;
 END {LaborActivityLicenseRequired};

 PUBLIC PROCEDURE GetBarCode_bck_IdIn20(): STRING[];
 BEGIN
  RETURN L_BarCode.toFont_IntP36DlTt(L_XDoc.BarCode(L_XDoc.bck_IdIn20, L_XDoc.xdt_Man, L_XDoc.EmptyXDocKind, Man.Man, 0));
 END {GetBarCode_bck_IdIn20};

 PUBLIC PROCEDURE CheckIfManIsIdentified(trgMan: LIKE(Man.Man); Strong: SCAL[2]);
  VAR
   Msg: STRING[];
 BEGIN
  IF ~L_APtm.IsOG() THEN
   TRY [ABORT_AFTER(AA_ON)]
    RTI.Get().TryBlock.AccessDataMode:=adm_FINISHED;
    SEARCH(Man, Man, , trgMan);
    IF (Man.rStaff = rs_wStaff) & !Man.SINumber & !Man.INN THEN
     Msg:="  ஢  ࠧ (  ,  )."
        + "|,  ⮏      ⮬ ."
        + "|᫨ ⠪,    ਢ  砫 ᫥⢨";
     IF Strong THEN
      IF Man_Citizen(trgMan, SYSDATE()) <= ct_Russia THEN
       L_StdFrm.CrucialChoice(Msg, L_APtm.g_Staff);
      END;
     ELSE
      L_StdFrm.Question(Msg);
     END;
    END;
   EXCEPT
   END; (* TRY *)
  END;
 END {CheckIfManIsIdentified};

 PUBLIC PROCEDURE ManIsInvolved(trgMan: LIKE(Man.Man)): SCAL[2];
 BEGIN
  TRY [ABORT_AFTER(AA_ON)]
   RTI.Get().TryBlock.AccessDataMode:=adm_FINISHED;
   RETURN SELECT(Staff, Man, trgMan) | P_Man.HasActualManPro(trgMan, SYSDATE(), P_Man.P_Pass);
  EXCEPT
  END; (* TRY *)
 END {ManIsInvolved};

 PUBLIC PROCEDURE GetStaffName(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=Man.Name;
  IF ~!Man.NameSfx THEN
   Result:=Result+"/"+Man.NameSfx;
  END;
  RETURN Result;
 END {GetStaffName};

 PUBLIC PROCEDURE CheckName(trgName: STRING[]);
  VAR
   i       : NUMERIC[0];
   cCh, nCh: STRING[1];
 BEGIN
  L_General.Assert(Str.Condense(trgName) = trgName, "    譨 ஡");
  i:=0;
  WHILE i < Str.Length(trgName) DO
   cCh:=L_Str.Char(trgName, i  );
   nCh:=L_Str.Char(trgName, i+1);
   L_General.Assert((cCh#"-") | (nCh#"-"), "     ");
   L_General.Assert((cCh#"-") | (nCh#" "), "   ᫥  ஡  ⠢");
   L_General.Assert((cCh#" ") | (nCh#"-"), "   । ᮬ ஡  ⠢");
   L_General.Assert((cCh=" ") |
                    (cCh="-") |
                    L_Str.TestStrAlowChar(cCh, "") |
                    L_Str.TestStrAlowChar(cCh, "") |
                    L_Str.TestStrAlowChar(cCh, ""),
                    "    ⨬ ᨬ '"+cCh+"'");
   INC(i);
  END; (* WHILE i < Str.Length(trgName ... *)
 END {CheckName};

(*-------------BEGIN OF NORMAL ENVIRONMENT--------------------------*)

 PUBLIC PROCEDURE E_ManNameModificationThroughEDOrder(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Man.ManNameModificationThroughEDOrder);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN 0;
  END;
 END {E_ManNameModificationThroughEDOrder};

END.
