(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose     প  
%Type        library
%Specific    SYS
%Modified    16.09.2014 17:24:48 POLAK\Bor
%Environment
*)

 MODULE L_MathR [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Math;

 PUBLIC TYPE
  DprKindType          = SCAL[2];
(*!*)  tMathAcCutCollection = LIKE(AcCut.AcCut)[32];
  tKA_Cut              = SCAL[100];
  tMathAcntLev         = SCAL[5];

 PUBLIC CONST
  mathk_Math  = 0;
  mathk_KeyAs = 1;

  DprK_Acn = 0;
  DprK_Tax = 1;

  DprM_Line       = 0;
  DprM_Runs       = 1;
  DprM_InUse      = 5;
  DprM_FullAtOnce = 6;
  DprM_NoAmort    = 7;
  dprm_Pool   = "| ஡| | | |ࠧ  室|ࠧ 100% .| ⨧";
  dpru_Pool   = ".|..| | | |...|...|...";

  matst_RegisterWait = 0;
  matst_InOperat     = 1;
  matst_Conservation = 2;
  matst_Pool = " ॣ樨| ᯫ樨| ࢠ樨";

  mtyp_Materials           = 01;
  mtyp_Fuels               = 03;
  mtyp_Oils                = 04;
  mtyp_Spares              = 05;
  mtyp_CarUnits            = 06;
  mtyp_Tickets             = 07;
  mtyp_Tyres               = 08;
  mtyp_Cloth               = 11; (*ᯥ殤*)
  mtyp_KeyAssets           = 12;
  mtyp_CWOrdIncome         = 16;
  mtyp_AdvertisingServices = 20;

  mm_New                          = 001;
  mm_Used                         = 002;
  mm_InBadRepair                  = 003;
  mm_Restored                     = 004;
  mm_Nonserviceable               = 005;
  mm_NewInAccountability          = 006; (*  *)
  mm_UsedInAccountability         = 007; (*  *)
  mm_ToBeReclamaition             = 008;
  mm_Amortization                 = 009;
  mm_Level2                       = 033; (* 2, , ஢ 2 *)
  mm_TransactionObject            = 050;
  mm_TrnObjectGadget              = 051;
  mm_UsedMaterial                 = 052;
  mm_TradeIn                      = 053;
  mm_MnfctOper                    = 054;
  mm_UsedMaterial_wPublishedPrice = 057;

  cortp_None = 0;
  cortp_Cut  = 1;
  cortp_Perc = 2;
  cortp_Rest = 3;

  brk_Usually = 0;
  brk_Ignore  = 1;
  brk_Allways = 2;

  KA_All              = 0;

  KA_src_WearOut      = 0; (*  (५)*)
  KA_src_IntFunds     = 1;
  KA_src_Budget       = 2;
  KA_src_Gratis       = 3;
  KA_src_Target       = 4;
  KA_src_Credit       = 5;
  KA_src_Investment   = 6;
  KA_src_AddFunds     = 7; (* ⠫*)
  KA_src_LocalBudget  = 8;
  KA_src_RegionBudget = 9;
  KA_src_CreditPrc    = 10;

  KA_dst_Productive    = 1;
  KA_dst_NonProductive = 2;

  KA_wear_Basic        = 1;
  KA_wear_Target       = 2;
  KA_wear_Budget98_99  = 3;
  KA_wear_Gratis98_99  = 4;
  KA_wear_Credit       = 5;
  KA_wear_Investment   = 6;
  KA_wear_Budget       = 7;
  KA_wear_Gratis       = 8;
  KA_wear_Housing      = 9;
  KA_wear_AddFunds     = 10;
  KA_wear_LocalBudget  = 11;
  KA_wear_RegionBudget = 12;
  KA_wear_CreditPrc    = 13;

  KA_NumSources  = 11;
  KA_NumWearAcnt = 14;
  KA_NumDestinat = 14;

  KA_NumNotInOpAcnt = 7;

  KA_BalDepr    = 1;
  KA_OutBalDepr = 2;

  KA_Tax        = 10;
  KA_InUse      = 11;

  mal_NoStock                 = 0;
  mal_Recount_ActiveSMMove    = 4;
(* mal_XXXX - ॢ訥 ⠭,  ᯮ짮. ⠢  ਨ.
 L_Env.MathAcntLev: ᯮ짮 ⮫쪮 mal_NoStock  mal_Recount_ActiveSMMove
*)
  mal_NoRecount               = 1;
  mal_Recount_NoSMMove        = 2;
  mal_Recount_NotActiveSMMove = 3;

  kaal_NoKeyAssets       = 0;
  kaal_WithActProcess    = 1;

  dg_DetectionOfStorageAcCut = 99;

  NoAlower = 99;

  vnd_Ourselves = 000;     (* Vendor =  ᠬ *)

 PUBLIC TYPE
  tKA_PrpSel = SCAL[Math.Max(Math.Max(KA_NumSources, KA_NumWearAcnt), KA_NumDestinat)+1];

 PUBLIC TYPE
  tInvCommitteeType = SCAL[5];
 PUBLIC CONST
  icomt_Common  = 0;
  icomt_Storage = 1;
  icomt_AveHold = 2;
  icomt_KeyAss  = 3;
  icomt_Dfrls   = 4;

  icomt_Pool = "| ⥪饬 |   | ᭮ ।⢠| 室  ਮ";
  icomNum = 15;

 IMPORT Memo, L_General, L_Acnt, L_DatTim, L_Str, L_MDoc, L_Way, L_Math, L_MSO, L_Stock, L_BarCode, L_r2r,
        L_AFM, L_EC, L_APtm, L_Car, L_XDoc, L_XDR, L_XObj, L_AcCut, L_SES, L_Prop, L_StdFrm,
        P_Firm, P_Math, P_Mark, P_MDoc, P_Storage, E_Stock, E_Way, L_Env,
        Str, Math, L_Fuel;

 PRIVATE VAR
  Prp1,
  Prp2,
  Prp3  : tKA_PrpSel;
  PrpArr: L_XObj.tXObjectAcCutCollection;

 PUBLIC PROCEDURE IsStock(): SCAL[2];
 BEGIN
  RETURN L_General.IsMemberOf("STOCK");
 END {IsStock};

 PRIVATE PROCEDURE IsFuelStock(): SCAL[2];
 BEGIN
  RETURN L_General.IsMemberOf("FUELSTOCK");
 END {IsFuelStock};

 PUBLIC PROCEDURE MathPrompt(s: STRING[]);
 BEGIN
  PROMPT("ꥪ: " + Math.Math + ": " + s);
 END {MathPrompt};

 PUBLIC PROCEDURE InitKAPrpSelArr(trgPrp1, trgPrp2, trgPrp3: tKA_PrpSel);
 BEGIN
  Prp1:=trgPrp1;
  Prp2:=trgPrp2;
  Prp3:=trgPrp3;
  SETEMPTY(PrpArr);
 END {InitKAPrpSelArr};

 PUBLIC PROCEDURE AddKAPrpSelArr(trgAcCut        : LIKE(AcCut.AcCut);
                                 APr1, APr2, APr3: tKA_PrpSel);
 BEGIN
  L_General.CallUs(APr1 < KA_NumSources);
  L_General.CallUs(APr2 < KA_NumDestinat);
  L_General.CallUs(APr3 < KA_NumWearAcnt);
  IF ((Prp1 = KA_All) | (APr1 = Prp1)) &
     ((Prp2 = KA_All) | (APr2 = Prp2)) &
     ((Prp3 = KA_All) | (APr3 = Prp3)) THEN
   macc_Put(trgAcCut, PrpArr);
  END;
 END {AddKAPrpSelArr};

 PUBLIC PROCEDURE GetKAPrpSelArr(VAR trgAcCuts: LIKE(AcCut.AcCut)[]);
  VAR
   i: SCAL[RANGEOF(L_XObj.tXObjectAcCutCollection)];
 BEGIN
  SETEMPTY(trgAcCuts);
  FOR_EACH i DO
   IF !PrpArr[i] THEN
    EXIT;
   END;
   trgAcCuts[i]:=PrpArr[i];
  END;
 END {GetPrpSelArr};

 PRIVATE PROCEDURE GetMinUL(_Group: LIKE(DprGroup.DprGroup)): NUMERIC[0];
 BEGIN
  IF    (_Group = 00) THEN RETURN  00;
  ELSIF (_Group = 01) THEN RETURN  12;
  ELSIF (_Group = 02) THEN RETURN  25;
  ELSIF (_Group = 03) THEN RETURN  37;
  ELSIF (_Group = 04) THEN RETURN  61;
  ELSIF (_Group = 05) THEN RETURN  85;
  ELSIF (_Group = 06) THEN RETURN 121;
  ELSIF (_Group = 07) THEN RETURN 181;
  ELSIF (_Group = 08) THEN RETURN 241;
  ELSIF (_Group = 09) THEN RETURN 301;
  ELSIF (_Group = 10) THEN RETURN 361;
  ELSIF (_Group = 11) THEN RETURN  12;
  END;
 END {GetMinUL};

 PRIVATE PROCEDURE GetMaxUL(_Group: LIKE(DprGroup.DprGroup)): NUMERIC[0];
 BEGIN
  IF    (_Group = 00) THEN RETURN  00;
  ELSIF (_Group = 01) THEN RETURN  24;
  ELSIF (_Group = 02) THEN RETURN  36;
  ELSIF (_Group = 03) THEN RETURN  60;
  ELSIF (_Group = 04) THEN RETURN  84;
  ELSIF (_Group = 05) THEN RETURN 120;
  ELSIF (_Group = 06) THEN RETURN 180;
  ELSIF (_Group = 07) THEN RETURN 240;
  ELSIF (_Group = 08) THEN RETURN 300;
  ELSIF (_Group = 09) THEN RETURN 360;
  ELSIF (_Group = 10) |
        (_Group = 11) THEN RETURN 99999999999;
  END;
 END {GetMaxUL};

 PUBLIC PROCEDURE GroupIncUL(_Group: LIKE(DprGroup.DprGroup);
                             _UL   : NUMERIC[0]) : SCAL[2];
 BEGIN
  RETURN ~!_Group & ~!_UL &
         (GetMinUL(_Group) <= _UL) & (_UL <= GetMaxUL(_Group));
 END {GroupIncUL};

 PUBLIC PROCEDURE OKOFIsInOneGroupOnly(): SCAL[2];
 BEGIN
  RETURN ((OKOF.Groups[0] + OKOF.Groups[1] + OKOF.Groups[2] + OKOF.Groups[3] +
           OKOF.Groups[4] + OKOF.Groups[5] + OKOF.Groups[6] + OKOF.Groups[7] +
           OKOF.Groups[8] + OKOF.Groups[9]) = 1) ;
 END {OKOFIsInOneGroupOnly};

 PUBLIC PROCEDURE OKOFIsInNoGroup(): SCAL[2];
 BEGIN
  RETURN ~(OKOF.Groups[0] | OKOF.Groups[1] | OKOF.Groups[2] | OKOF.Groups[3] |
           OKOF.Groups[4] | OKOF.Groups[5] | OKOF.Groups[6] | OKOF.Groups[7] |
           OKOF.Groups[8] | OKOF.Groups[9]);
 END {OKOFIsInNoGroup};

 PUBLIC PROCEDURE OKOFIsInGroup(_Group: LIKE(DprGroup.DprGroup)): SCAL[2];
 BEGIN
  IF   !_Group THEN
   RETURN 0;
  ELSIF (_Group = 00) | (_Group = 11) THEN
   RETURN 1;
  ELSE
   RETURN OKOF.Groups[_Group-1];
  END;
 END {OKOFIsInGroup};

 PUBLIC PROCEDURE RoundMath(S: NUMERIC[2]): NUMERIC[2];
 BEGIN
  IF (MClcPer(Math.MathKind) < 01\09\1996) |
     (MClcPer(Math.MathKind) >= L_General.DenominationDate()) THEN
   RETURN L_Math.ROUND(S, 0.01);
  ELSE
   RETURN L_Math.ROUND(S, 1.00);
  END;
 END {RoundMath};

 PRIVATE PROCEDURE MathKindSN(_MathKind: LIKE(Math.MathKind)): L_APtm.tSystems;
 BEGIN
  IF    _MathKind = mathk_Math  THEN   RETURN L_APtm.system_Math;
  ELSIF _MathKind = mathk_KeyAs THEN   RETURN L_APtm.system_KeyAss;
  ELSE
   L_General.CallUs(0);
  END;
 END {MathKindSN};

 PUBLIC PROCEDURE ChMNoTouch(P: DATE; _MathKind: LIKE(Math.MathKind));
 BEGIN
  L_APtm.ANYSystem_CheckNoTouch(P, MathKindSN(_MathKind));
 END {ChMNoTouch};

 PUBLIC PROCEDURE MClcPer(_MathKind: LIKE(Math.MathKind)): DATE;
 BEGIN
  RETURN L_APtm.ClcPer[MathKindSN(_MathKind)];
 END {MClcPer};

 PUBLIC PROCEDURE MClc_CntIsEqual(_MathKind: LIKE(Math.MathKind)): SCAL[2];
 BEGIN
  RETURN Memo.gl_mb() = MClcPer(_MathKind);
 END {MClc_CntIsEqual};

 PUBLIC PROCEDURE CheckMDocProceedAllowed(trgMathKind: LIKE(Math.MathKind));
 BEGIN
  IF (trgMathKind = mathk_Math) & (Memo.gl_mb() < 01\01\2002) THEN
   ChMNoTouch(Memo.gl_mb(), trgMathKind);
  END;
 END {CheckMDocProceedAllowed};

 PUBLIC PROCEDURE ChMClcPer(_MathKind: LIKE(Math.MathKind));
 BEGIN
  L_APtm.ANYSystem_CheckClcPer(MathKindSN(_MathKind));
 END {ChMClcPer};

 PUBLIC PROCEDURE MultipleClearMApport(trgSources: SCAL[2][]);
 BEGIN
  SELECT(mItem, Math, , Math.Math);
  WHILE OCCURE(mItem) DO
   CONFORM(mItem, XObject);
   L_XObj.MultipleClearXApport(L_XObj.SectionOfXObjectAcCut(EMPTYOF(AcCut.AcCut)), trgSources);
   NEXT(mItem);
  END; (* WHILE OCCURE(mItem) ... *)
 END {MultipleClearMApport};

 PUBLIC PROCEDURE ClearMApport(_Source: L_XObj.tSource);
  VAR
   _Sources: SCAL[2][100];
 BEGIN
  SETZERO(_Sources);
  _Sources[_Source]:=1;
  MultipleClearMApport(_Sources);
 END {ClearMApport};

 PUBLIC PROCEDURE AcCutOfRealStock(trgAcCut: LIKE(AcCut.AcCut)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(AcCut);
  L_AcCut.PositionOnAcCut(trgAcCut);
  Result:=(AcCut.SldType = L_AcCut.sldt_wAmount) |
          (AcCut.SldType = L_AcCut.sldt_wAmountCredit);
  RESTORE(AcCut);
  RETURN Result;
 END {AcCutOfRealStock};

 PUBLIC PROCEDURE GetFirmOfMath(): LIKE(Firm.Firm);
 BEGIN
  L_General.CallUs(ACCESS(Math) & ~!Math.MyFirm);
  RETURN P_Firm.GetFirmOfMyFirm(Math.MyFirm);
 END {GetFirmOfMath};

 PRIVATE PROCEDURE GetDprMUnit(_DprM: LIKE(KAGroup.AcnDprM)): STRING[];
 BEGIN
  IF   !_DprM THEN
   RETURN " ...";
  ELSE
   RETURN L_Str.PoolItem(dpru_Pool, _DprM);
  END;
 END {GetDprMUnit};

 PUBLIC PROCEDURE GetCorrTypePool(_DprM: LIKE(KAGroup.AcnDprM)): STRING[];
 BEGIN
  RETURN " ४஢|㬥 , "+GetDprMUnit(_DprM)+"|㬥 , %|⠫, "+GetDprMUnit(_DprM);
 END {GetCorrTypePool};

 PUBLIC PROCEDURE RecalculateKeyAssPermanent(Window: FORM_WINDOW);
  VAR
   Fields     : FORM_FIELDS;
   APrDate,
   ASpDate    : DATE;
   AcnDprMUnit,
   TaxDprMUnit,
   curTSN     : STRING[];
 BEGIN
  SETEMPTY(APrDate, ASpDate, AcnDprMUnit, TaxDprMUnit, curTSN);
(* 0104888 28.08.2014 14:04:17 POLAK\Bor
  TRY [RESTORE_CURSORS(RC_ON)]
*)
  TRY [ABORT_AFTER(AA_ON)]
   IF RTI.Get().TryBlock.AccessDataMode = adm_BIZARRE THEN
    RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   END;
   IF ACCESS((RTI.Get().CurZone.MasterTable.Name)) THEN
    IF RTI.Get().CurZone.MasterTable.Name # "Math" THEN
     CONFORM((RTI.Get().CurZone.MasterTable.Name), Math);
    END;
    IF OCCURE(Math) & (Math.MathKind = mathk_KeyAs) THEN
     APrDate:=GetKeyAssAPrDate(Math.Math);
     ASpDate:=GetKeyAssASpDate(Math.Math);
     IF SELECT(MathKAGL, Math, Math.Math) THEN
      CONFORM(MathKAGL, KAGroup);
      AcnDprMUnit:=GetDprMUnit(KAGroup.AcnDprM);
      TaxDprMUnit:=GetDprMUnit(KAGroup.TaxDprM);
     END;
    END;
   END;
   Fields:=Window.Zones(0).Fields;
   Fields("v_KeyAss_asAPr_Date").Value:=APrDate;
   Fields("v_KeyAss_asASp_Date").Value:=ASpDate;
   IF ~!Fields("v_KeyAss_asAPr_AcnDprMUnit") THEN
    Fields("v_KeyAss_asAPr_AcnDprMUnit").Value:=AcnDprMUnit;
    Fields("v_KeyAss_asAPr_TaxDprMUnit").Value:=TaxDprMUnit;
   END;
   IF ~!Fields("v_KeyAss_TSN") THEN
    IF (ASpDate >= SYSDATE()) & L_MDoc.PosToLastKeyAssChangeResponsibleMDoc(Math.Math, SYSDATE()) THEN
     CONFORM(MDoc, Staff);
     CONFORM(Staff, Man);
     curTSN:=Staff.TSN+" "+Man.Name;
    END;
    Fields("v_KeyAss_TSN").Value:=curTSN;
   END;
  EXCEPT
  END; (* TRY *)
 END {RecalculateKeyAssPermanent};

 PRIVATE PROCEDURE intAccessKeyAssXObject(Soft: SCAL[2]): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  L_General.CallUs(Math.MathKind = mathk_KeyAs);
  IF Soft THEN
   Result:=L_Stock.PositionOn_mItem(Math.Math, L_Stock.Obtain_MyFirmStorage(Math.MyFirm, SYSDATE()));
  ELSE
   L_Stock.Obtain_mItem(Math.Math, L_Stock.Obtain_MyFirmStorage(Math.MyFirm, SYSDATE()));
   Result:=1;
  END;
  IF Result THEN
   L_XObj.AccessXObject(mItem.XObject);
  END;
  RETURN Result;
 END {intAccessKeyAssXObject};

 PUBLIC PROCEDURE SoftAccessKeyAssXObject(): SCAL[2];
 BEGIN
  RETURN intAccessKeyAssXObject(1);
 END {SoftAccessKeyAssXObject};

 PUBLIC PROCEDURE AccessKeyAssXObject();
  VAR
   Dummy: SCAL[2];
 BEGIN
  Dummy:=intAccessKeyAssXObject(0);
 END {AccessKeyAssXObject};

 PUBLIC PROCEDURE GetCurMathKAGLCostItem(D: DATE): LIKE(CostItem.CostItem);
  VAR
   Result: LIKE(CostItem.CostItem);
 BEGIN
  L_General.Assert(~!MathKAGL.CostItem, "  "+Math.Math+"  㪠   "+L_DatTim.DateStr(Memo.gl_me()));
  CONFORM(MathKAGL, CostItem);
  IF CostItem.Leaf THEN
   IF ~SEARCH(CIKind, CIKind, CostItem.CIKind) | (CIKind.Type # L_CI.cikt_KeyAss) THEN
    L_kn.StandOnERKN(L_CI.erkn_KeyAssWear);
    L_StdFrm.WrongDB(" "+Math.Math+":  宦  㯯 த ꥪ⮢  "+L_DatTim.DateStr(MathKAGL.Date)+"|"+
                     '  㪠   +"'+L_Str.PoolItem(L_CI.cikt_Pool, L_CI.cikt_KeyAss)+'"');
   END;
   Result:=CostItem.CostItem;
  ELSE
   Result:=L_CI.GetElementCostItem(MathKAGL.CostItem, Memo.gl_me(), Math.MyFirm, L_CI.erkn_KeyAssWear);
  END;
  RETURN Result;
 END {GetCurMathKAGLCostItem};

 PRIVATE PROCEDURE GetKeyAssCostItem(trgMath: LIKE(Math.Math); D: DATE): LIKE(CostItem.CostItem);
  VAR
   Result: LIKE(CostItem.CostItem);
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   PosToKAG(trgMath, D);
   Result:=GetCurMathKAGLCostItem(D);
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {GetKeyAssCostItem};

 PRIVATE PROCEDURE GetComplementaryApport(trgApport: LIKE(Apport.Apport)): LIKE(Apport.Apport);
 BEGIN
  IF    trgApport = L_Acnt.E_Apport_MoneyCredit(Memo.gl_mb()) THEN
   RETURN L_Acnt.E_Apport_MoneyDebit(Memo.gl_mb());
  ELSIF trgApport = L_Acnt.E_Apport_MoneyDebit(Memo.gl_mb())  THEN
   RETURN L_Acnt.E_Apport_MoneyCredit(Memo.gl_mb());
  ELSE
   L_General.CallUs(0);
  END;
 END {GetComplementaryApport};

 PUBLIC PROCEDURE KeyAssMakeCompleteCir(trgSign    : NUMERIC[0];
                                        trgAcCut   : LIKE(AcCut.AcCut);
                                        trgApport  : LIKE(Apport.Apport);
                                        trgXObject2: LIKE(XObject.XObject);
                                        trgAcCut2  : LIKE(AcCut2.AcCut2);
                                        trgSum     : L_XObj.tSum;
                                        trgSource  : L_XObj.tSource);
  VAR
   trgApport2: LIKE(Apport.Apport);
 BEGIN
  L_General.CallUs((trgSource = L_XObj.src_Amortisation) | (trgSource = L_XObj.src_KAMDoc) | (trgSource = L_XObj.src_ACalc)); (*0087308 25.08.2011 19:49:40 POLAK\Bor*)
  AccessKeyAssXObject();
  IF (trgSource # L_XObj.src_ACalc) & L_XObj.E_DoSecondSide(Memo.gl_mb()) THEN
   trgSource:=L_XObj.src_ACalc;
  END;
  IF ~!trgXObject2 THEN
   trgApport2:=GetComplementaryApport(trgApport);
  ELSE
   SETEMPTY(trgApport2);
  END;
  L_XObj.MakeCompleteCir(trgSign, Memo.gl_mb(), XObject.XObject, trgAcCut, trgApport, 0,
                                                trgXObject2, trgAcCut2, trgApport2, 0, trgSum, 0, trgSource);
 END {KeyAssMakeCompleteCir};

 PUBLIC PROCEDURE KeyAssMakeCir(trgSign  : NUMERIC[0];
                                trgAcCut : LIKE(AcCut.AcCut);
                                trgApport: LIKE(Apport.Apport);
                                trgAcCut2: LIKE(AcCut2.AcCut2);
                                trgSum   : L_XObj.tSum;
                                trgSource: L_XObj.tSource);
 BEGIN
  KeyAssMakeCompleteCir(trgSign, trgAcCut, trgApport, EMPTYOF(XObject.XObject), trgAcCut2, trgSum, trgSource);
 END {KeyAssMakeCir};

 PUBLIC PROCEDURE IsMathD_OnDate(D: DATE): SCAL[2];
 BEGIN
  RETURN L_XObj.mfMathIsDone(Math.Math, EMPTYOF(MyFirm.MyFirm), D);
 END {IsMathD_OnDate};

 PUBLIC PROCEDURE IsMathDone_AP(_Math: LIKE(Math.Math); P: DATE): SCAL[2];
 BEGIN
  RETURN L_XObj.mfMathIsDone(_Math, EMPTYOF(MyFirm.MyFirm), P);
 END {IsMathDone_AP};

 PUBLIC PROCEDURE CheckMathDone(D: DATE);
 BEGIN
  IF ~L_APtm.MonthIsClosed(L_DatTim.Per(D), MathKindSN(Math.MathKind)) THEN
   L_General.Assert(IsMathD_OnDate(D), " " + Math.Math + ".  믮  楢   " + L_DatTim.PeriodStr(D));
  END;
 END {CheckMathDone};

 PRIVATE PROCEDURE IsPrvMathDone(): SCAL[2];
 BEGIN
  RETURN IsMathD_OnDate(L_DatTim.PrevPer(Memo.gl_mb()));
 END {IsPrvMathDone};

 PUBLIC PROCEDURE IsMathDone(): SCAL[2];
 BEGIN
  RETURN IsMathD_OnDate(Memo.gl_mb()) & IsPrvMathDone();
 END {IsMathDone};

 PUBLIC PROCEDURE AccessMath(_Math: LIKE(Math.Math));
 BEGIN
  L_General.CallUs(SEARCH(Math, Math, _Math));
 END {AccessMath};

 PUBLIC PROCEDURE ResetMathDone_AP(_Math: LIKE(Math.Math); P: DATE);
 BEGIN
  SAVE(Math);
  AccessMath(_Math);
  IF Math.MathKind = mathk_KeyAs THEN
   L_XObj.mfResetMathDone(_Math, Math.MyFirm, P, 1);
  ELSE
   L_XObj.mfResetMathDone(_Math, EMPTYOF(MyFirm.MyFirm), P, 0);
  END;
  RESTORE(Math);
 END {ResetMathDone_AP};

 PUBLIC PROCEDURE ResetMathDone(_Math: LIKE(Math.Math));
 BEGIN
  ResetMathDone_AP(_Math, Memo.gl_mb());
 END {ResetMathDone};

 PUBLIC PROCEDURE extCountUpMath(trgMath: LIKE(Math.Math); P: DATE; Strong: SCAL[2]; PrvMonthTransaction: NUMERIC[0]): SCAL[2];
  VAR
   saveDate      : DATE;
   trgTransaction: NUMERIC[0];
   Result        : SCAL[2];
 BEGIN
  Result:=1;
  IF ~IsMathDone_AP(trgMath, P) THEN
   IF L_General.DoConcurrentModification() THEN
    trgTransaction:=TRANSACTION_CURRENT;
   ELSE
    trgTransaction:=TRANSACTION_SLAVE;
   END;
   saveDate:=Memo.gl_cd();
   TRY [TRANSACTION(trgTransaction), RESTORE_CURSORS(RC_ON)]
    Memo.gl_SetCurDate(P);
    SEARCH(Math, Math, , trgMath);
    CALL(MCM.SingleCountUp(PrvMonthTransaction));
   EXCEPT
   ON Exc: Exc_Root DO
    Result:=0;
    IF Strong THEN
     L_General.Error(" 㤠  楢   " + trgMath + "  " + L_DatTim.PeriodStr(P) + L_StdFrm.THR("稭") + Exc.MsgOriginalText);
    END;
   FINALLY
    Memo.gl_SetCurDate(saveDate);
   END;
  END;
  RETURN Result;
 END {extCountUpMath};

 PUBLIC PROCEDURE CountUpMath(trgMath: LIKE(Math.Math); P: DATE);
  VAR
   Dummy: SCAL[2];
 BEGIN
  Dummy:=extCountUpMath(trgMath, P, 1, TRANSACTION_SLAVE);
 END {CountUpMath};

 PUBLIC PROCEDURE CountUpMathSoft(trgMath: LIKE(Math.Math); P: DATE): SCAL[2];
 BEGIN
  RETURN extCountUpMath(trgMath, P, 0, TRANSACTION_SLAVE);
 END {CountUpMathSoft};

 PUBLIC PROCEDURE MModeStr(trgMMode: LIKE(MMode.MMode)): LIKE(MMode.Sign);
 BEGIN
  SEARCH(MMode, MMode, , trgMMode);
  RETURN MMode.Sign;
 END {MModeStr};

 PRIVATE PROCEDURE MTypeStr(t: SCAL[2]): STRING[6];
 BEGIN
  RETURN Str.Item("|ਥ", "|", t);
 END {MTypeStr};

 PUBLIC PROCEDURE CheckFormat(Qnt: L_XObj.tQnt);
  VAR
   _Prod: NUMERIC[2];
 BEGIN
  _Prod:=Qnt * Math.Pow(10, MUnit.Format);
  L_General.Assert(_Prod MOD 1 = 0, "⢮   ७ '" + MUnit.Name + "'" +
                                    "|  㪠뢠  筮  " + MUnit.Format +
                                    "  ᫥ ⮩");
 END {CheckFormat};

 PRIVATE PROCEDURE intRemainders(P         : DATE;
                                 trgAcCut  : LIKE(AcMthL.AcCut);
                                 trgCirType: LIKE(Apport.CirType);
                                 Real      : SCAL[2]): L_XObj.tSum;
  VAR
   Result: L_XObj.tSum;
 BEGIN
  IF SoftAccessKeyAssXObject() THEN
   IF Real THEN
    Result:=L_XObj.mo_GetInRSaldo(trgAcCut, P);
   ELSE
    Result:=L_XObj.mo_GetInSaldo(trgAcCut, P);
   END;
   IF Result < 0 THEN
    L_General.Assert(trgCirType = L_Acnt.ct_Debit,
                     "ᠭ ⥫쭮 ᠫ줮  ।|१ "+trgAcCut);
    Result:=-Result;
   ELSIF Result > 0 THEN
    L_General.Assert(trgCirType = L_Acnt.ct_Credit,
                     "ᠭ ⥫쭮 ᠫ줮  |१ "+trgAcCut);
   END;
  ELSE
   Result:=0;
  END;
  RETURN Result;
 END {intRemainders};

 PUBLIC PROCEDURE Remainders(P         : DATE;
                             trgAcCut  : LIKE(AcMthL.AcCut);
                             trgCirType: LIKE(Apport.CirType)): L_XObj.tSum;
 BEGIN
  RETURN intRemainders(P, trgAcCut, trgCirType, 0);
 END {Remainders};

 PUBLIC PROCEDURE RemaindersR(P         : DATE;
                              trgAcCut  : LIKE(AcMthL.AcCut);
                              trgCirType: LIKE(Apport.CirType)): L_XObj.tSum;
 BEGIN
  RETURN intRemainders(P, trgAcCut, trgCirType, 1);
 END {RemaindersR};

 PUBLIC PROCEDURE GetRunMathMty(_MonthB: DATE;
                                _MtyIdx: LIKE(MtyIdx.MtyIdx)): LIKE(MathMty.Proof);
  VAR
   _Proof : LIKE(MathMty.Proof);
   _MonthE: DATE;
 BEGIN
  L_General.CallUs(E_Stock.IsRunMathMty(_MtyIdx));
  _MonthE:=L_DatTim.MonthEnd(_MonthB);
  SETZERO(_Proof);
  SELECT(MathMty, Math, , Math.Math, _MonthB);
  WHILE OCCURE(MathMty) DO
   IF MathMty.MtyIdx = _MtyIdx THEN
    INC(_Proof, MathMty.Proof);
   END;
   NEXT(MathMty);
  END; (* WHILE OCCURE(MathMty) ... *)
  SELECT(CarLog, Math, , Math.Math);
  WHILE OCCURE(CarLog)  &
        ((CarLog.Date > _MonthE) |
         (~!CarLog.DateE & (CarLog.DateE < _MonthB))) DO
   NEXT(CarLog);
  END; (* WHILE OCCURE(CarLog) ... *)
  IF ~OCCURE(CarLog) THEN
   L_General.Assert(KAGroup.AcnDprM # DprM_Runs,
                    "  ᮯ⠢ ࠭ᯮ⭮ ।|" +
                    "    ⮤  ⨧樨|" +
                    "'ய樮쭮 ஡'");
   L_General.Assert(_Proof = 0, "  ᮯ⠢ ࠭ᯮ⭮ ।|" +
                                "    ஡  ⥫");
  END;
  RETURN _Proof;
 END {GetRunMathMty};

 PUBLIC PROCEDURE TKind2MtyIdxInformUs(trgTKind: LIKE(TKind.TKind));
 BEGIN
  L_General.InformUs("   ॢ ("+trgTKind+")   ࠧ१|"+
                     " ᯨᠭ ⮯   ⨧樨   壠᪮ |"+
                     " ࠡ  ⮬  ॢ|"+
                     "( 室 - ।⥫쭮 ନ   ࠧ१)");
 END {TKind2MtyIdxInformUs};

 PRIVATE PROCEDURE UsefulAcMthL(_AcCut  : LIKE(AcCut.AcCut);
                                _Apport : LIKE(Apport.Apport);
                                _mft    : L_MDoc.tMathFlowType;
                                _Origin : L_Acnt.tAcMthOrigin): SCAL[2];
 BEGIN
  IF AcCutOfRealStock(_AcCut) & L_Acnt.isMathFamilyOrigin(_Origin) THEN
   SEARCH(Apport, Apport, , _Apport);
   IF _mft = L_MDoc.mft_Credit THEN
    RETURN Apport.CirType = L_Acnt.ct_Credit;
   ELSE
    RETURN Apport.CirType = L_Acnt.ct_Debit;
   END;
  ELSE
   RETURN 0;
  END;
 END {UsefulAcMthL};

 PRIVATE PROCEDURE GetAcCut(mft: L_MDoc.tMathFlowType;
                            VAR _AcCut : LIKE(AcMthL.AcCut);
                            VAR _Apport: LIKE(AcMthL.Apport);
                            VAR _AcCut2: LIKE(AcMthL.AcCut2);
                            VAR _Origin: L_Acnt.tAcMthOrigin);
 BEGIN
  SEARCH(MDocKind, MDocKind, , MDoc.MDocKind);
  L_Acnt.SelectOperatingAcMthL(L_DatTim.Per(MDoc.Date), MDocKind.DGroup, MDoc.Dest, Math.MathType, MDocList.MMode, 0);
  LOOP
   IF ~OCCURE(AcMthL) THEN
    L_General.Error("  ࠧ१    樨"+
                    L_Acnt.AcMthStrForMessage(MDocKind.DGroup, MDoc.Dest, Math.MathType, MDocList.MMode)+
                    "|⨯  "+L_Str.PoolItem(L_MDoc.mft_Pool_1Char, mft));
   END;
   IF    ~!AcMthL.Origin1 THEN
    _AcCut  :=L_Acnt.getAcMthL_AcCut(MDoc.Date);
    IF UsefulAcMthL(_AcCut, AcMthL.Apport, mft, AcMthL.Origin1) THEN
     _Apport :=AcMthL.Apport;
     _AcCut2 :=L_Acnt.getAcMthL_AcCut2(MDoc.Date);
     _Origin :=AcMthL.Origin1;
     EXIT;
    END;
   END;
   IF ~!AcMthL.Origin2 THEN
    _AcCut:=L_Acnt.getAcMthL_AcCut2(MDoc.Date);
    IF UsefulAcMthL(_AcCut, AcMthL.Apport2, mft, AcMthL.Origin2) THEN
     _Apport :=AcMthL.Apport2;
     _AcCut2 :=L_Acnt.getAcMthL_AcCut(MDoc.Date);
     _Origin :=AcMthL.Origin2;
     EXIT;
    END;
   END;
   NEXT(AcMthL);
  END; (* LOOP *)
 END {GetAcCut};

 PUBLIC PROCEDURE GetStoringAcCut(mft: L_MDoc.tMathFlowType): LIKE(AcCut.AcCut);
  VAR
   Result     : LIKE(AcCut.AcCut);
   dummyApport: LIKE(Apport.Apport);
   dummyAcCut2: LIKE(AcCut.AcCut);
   dummyOrigin: L_Acnt.tAcMthOrigin;
 BEGIN
  GetAcCut(mft, Result, dummyApport, dummyAcCut2, dummyOrigin);
  RETURN Result;
 END {GetStoringAcCut};

 PUBLIC PROCEDURE IsAdvHolderFlow(mft: L_MDoc.tMathFlowType): SCAL[2];
  VAR
   dummyAcCut : LIKE(AcCut.AcCut);
   dummyApport: LIKE(Apport.Apport);
   dummyAcCut2: LIKE(AcCut.AcCut);
   Origin     : L_Acnt.tAcMthOrigin;
 BEGIN
  TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
   SAVE(Math);
   CONFORM(MDocList, Math);
   GetAcCut(mft, dummyAcCut, dummyApport, dummyAcCut2, Origin);
   RESTORE(Math);
   RETURN Origin = L_Acnt.amo_MathInAH;
  EXCEPT
  ON Exc:Exc_Raise DO
  END;
  RETURN 0;
 END {IsAdvHolderFlow};

 PUBLIC PROCEDURE IsContractStorageFlow(mft: L_MDoc.tMathFlowType): SCAL[2];
  VAR
   dummyAcCut : LIKE(AcCut.AcCut);
   dummyApport: LIKE(Apport.Apport);
   dummyAcCut2: LIKE(AcCut.AcCut);
   Origin     : L_Acnt.tAcMthOrigin;
 BEGIN
  TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
   SAVE(Math);
   CONFORM(MDocList, Math);
   GetAcCut(mft, dummyAcCut, dummyApport, dummyAcCut2, Origin);
   RESTORE(Math);
   RETURN Origin = L_Acnt.amo_MathByCntr;
  EXCEPT
  ON Exc:Exc_Raise DO
  END;
  RETURN 0;
 END {IsContractStorageFlow};

 PUBLIC PROCEDURE PosToLastCarLog(_Math: LIKE(Math.Math); D: DATE): SCAL[2];
  VAR
   _Date  : DATE;
   _BoxNbr: LIKE(CarLog.BoxNbr);
 BEGIN
  _Date:=L_DatTim.MINDATE();
  SETEMPTY(_BoxNbr);
  SELECT(CarLog, Math, , _Math);
  WHILE OCCURE(CarLog) DO
   IF (CarLog.Status # L_Car.carst_Retired) & (CarLog.Date <= D) & (_Date < CarLog.Date) THEN
    _Date  :=CarLog.Date;
    _BoxNbr:=CarLog.BoxNbr;
   END;
   NEXT(CarLog);
  END; (* WHILE OCCURE(CarLog) ... *)
  IF ~!_BoxNbr THEN
   SEARCH(CarLog, BoxNbr, , _BoxNbr, _Date);
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {PosToLastCarLog};

 PUBLIC PROCEDURE PosToCarLog(_Math: LIKE(Math.Math); D: DATE): SCAL[2];
 BEGIN
  RETURN PosToLastCarLog(_Math, D) & (CarLog.DateE >= D);
 END {PosToCarLog};

 PRIVATE PROCEDURE GetMathPrice_BySelected_mItem(D         : DATE;
                                                 trgMath   : LIKE(Math.Math);
                                                 trgMyFirm : LIKE(MyFirm.MyFirm);
                                                 trgPriceGr: LIKE(AcCut.PriceGrp);
                                                 trgType   : LIKE(Storage.Type)): FLOAT;
  VAR
   Dummy    : SCAL[2];
   doneP,
   P        : DATE;
   curSldSum: L_XObj.tSum;
   curSldQnt: L_XObj.tQnt;
   Need     : SCAL[2];
   minXDat  : DATE;
 BEGIN
  P:=L_DatTim.Per(D);
  Dummy:=CountUpMathSoft(trgMath, L_DatTim.PrevPer(P));
  SEARCH(Math, Math, , trgMath);
  minXDat:=MAXOF(DATE);
  SETZERO(curSldSum, curSldQnt);
  FOR_EACH mItem DO
   IF !trgMyFirm | (mItem.MyFirm = trgMyFirm) THEN
    CONFORM(mItem, Storage);
    IF (trgType = L_Stock.st_AdvHolder) = (Storage.Type = L_Stock.st_AdvHolder) THEN
     SEARCH(XObject, XObject, , mItem.XObject);
     SELECT(XCalc, XObject, , XObject.XObject);
     WHILE OCCURE(XCalc) DO
      NARROWSEL(XCalc, AcCut);
      CONFORM(XCalc, AcCut);
      IF AcCut.PriceGrp = trgPriceGr THEN
       SRCINSEL(XCalc, LT, , Math.Min(P, minXDat));
       WHILE OCCURE(XCalc) & ~L_XObj.mfMathIsDone(trgMath, trgMyFirm, XCalc.XDat) & ~L_APtm.MonthIsClosed(XCalc.XDat, MathKindSN(Math.MathKind)) DO
        minXDat:=XCalc.XDat;
        PREV(XCalc);
       END;
 
       IF OCCURE(XCalc) THEN
        INC(curSldSum, XCalc.SldSum + XCalc.DbtSum - XCalc.CrdSum);
        INC(curSldQnt, XCalc.SldQnt + XCalc.DbtQnt - XCalc.CrdQnt);
        NEXT(XCalc);
       ELSE
        FIRST(XCalc);
       END;
 
       WHILE OCCURE(XCalc) & (XCalc.XDat <= P) DO
        SETSEL(XApport, XObject, XCalc.XObject, XCalc.AcCut, XCalc.XDat);
        FOR_EACH XApport DO
         CONFORM(XApport, Apport);
         Need:=0;
         IF    ((Apport.CirType = L_Acnt.ct_Debit) & (Apport.CirKind = L_Acnt.ck_ExplicitCir)) |
               ((Storage.Type = L_Stock.st_AdvHolder) & (Apport.CirKind = L_Acnt.ck_SpecialCir)) THEN
          Need:=1;
         ELSIF (XApport.WFDate < P) THEN
          Need:=L_XObj.mfMathIsDone(trgMath, trgMyFirm, XApport.WFDate) | L_APtm.MonthIsClosed(XApport.XDat, MathKindSN(Math.MathKind));
         END;
         IF Need THEN
          IF (Apport.CirType = L_Acnt.ct_Debit) THEN
           INC(curSldSum, XApport.Sum);
           INC(curSldQnt, XApport.Qnt);
          ELSE
           DEC(curSldSum, XApport.Sum);
           DEC(curSldQnt, XApport.Qnt);
          END;
         END;
        END; (* FOR_EACH XApport  *)
        NEXT(XCalc);
       END; (* WHILE OCCURE(XCalc) ... *)
 
      END; (* IF AcCut.PriceGrp = trgPriceGr ... *)
      NEXTINEXTENDEDSEL(XCalc, AcCut);
     END; (* WHILE OCCURE(XCalc) ... *)
    END; (* IF (trgType = ... *)
   END; (* !trgMyFirm | ... *)
  END; (* FOR_EACH mItem  *)
  IF    curSldQnt # 0 THEN RETURN curSldSum / curSldQnt;
  ELSE                     RETURN 0;
  END;
 END {GetMathPrice_BySelected_mItem};

 PRIVATE PROCEDURE intGetMathPrice(D         : DATE;
                                   trgMath   : LIKE(Math.Math);
                                   trgMyFirm : LIKE(MyFirm.MyFirm);
                                   trgPriceGr: LIKE(AcCut.PriceGrp);
                                   trgType   : LIKE(Storage.Type);
                                   trgStorage: LIKE(Storage.Storage)): FLOAT;
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   IF trgType = L_Stock.st_AdvHolder THEN
    SETSEL(mItem, Math, trgMath, trgStorage);
   ELSE
    SETSEL(mItem, Math, trgMath);
   END;
   RETURN GetMathPrice_BySelected_mItem(D, trgMath, trgMyFirm, trgPriceGr, trgType);
  EXCEPT
  END;
 END {intGetMathPrice};

 PUBLIC PROCEDURE GetANYMathPrice(D         : DATE;
                                  trgMath   : LIKE(Math.Math);
                                  trgMyFirm : LIKE(MyFirm.MyFirm);
                                  trgPriceGr: LIKE(AcCut.PriceGrp)): FLOAT;
 BEGIN
  RETURN intGetMathPrice(D, trgMath, trgMyFirm, trgPriceGr, L_Stock.st_Stock, EMPTYOF(Storage.Storage));
 END {GetANYMathPrice};

 PUBLIC PROCEDURE MMode2PriceGrp(D: DATE; trgMath: LIKE(Math.Math); trgMMode: LIKE(MMode.MMode)): LIKE(AcCut.PriceGrp);
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   SEARCH(Math, Math, , trgMath);
   SEARCH(AcCut, AcCut, , L_Acnt.GetSpecificAcCutForMTMM(D, Math.MathType, trgMMode, L_Acnt.acp_Math_Netto));
   RETURN AcCut.PriceGrp;
  EXCEPT
  END;
 END {MMode2PriceGrp};

 PRIVATE PROCEDURE ZeroPrice(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  IF (Math.MathType=mtyp_KeyAssets) | (MDoc.MDocKind=L_MDoc.md_DDA) |
     (L_MDoc.getMDocListMathFlowType() = L_MDoc.mft_None) THEN
   Result:=1;
  ELSE
   SEARCH(MathType, MathType, , Math.MathType);
   Result:=MathType.Category # L_Acnt.mtc_Inventories;
  END;
  RETURN Result;
 END {ZeroPrice};

 PUBLIC PROCEDURE GetMDLMathPrice(): FLOAT;
  VAR
   trgAcCut,
   dmyAcCut2  : LIKE(AcMthL.AcCut);
   dmyApport  : LIKE(AcMthL.Apport);
   trgOrigin  : L_Acnt.tAcMthOrigin;
   Result     : FLOAT;
   curMyFirm  : LIKE(Storage.MyFirm);
   curStrgType: LIKE(Storage.Type);
   curStorage : LIKE(Storage.Storage);
 BEGIN
  Result:=0;
  TRY [RESTORE_CURSORS(RC_ON)]
   SEARCH(Math, Math, , MDocList.Math);
   IF ZeroPrice() THEN
    Result:=0;
   ELSE
    SEARCH(MDocKind, MDocKind, , MDoc.MDocKind);
    IF MDocKind.Activity THEN  (*   権*)
     GetAcCut(L_MDoc.getMDocListMathFlowType(), trgAcCut, dmyApport, dmyAcCut2, trgOrigin);
     SEARCH(AcCut, AcCut, , trgAcCut);
     IF AcCut.PriceGrp = 00 THEN
      Result:=0;
     ELSE
      TRY [ABORT_AFTER(AA_ON)]                             (*0097247 25.06.2013 18:11:40 POLAK\Bor*)
       L_Acnt.sc_PrepareXObject(trgOrigin, L_Acnt.cs_MDoc);
       CONFORM(mItem, Storage);
       curMyFirm  :=Storage.MyFirm;
       curStrgType:=Storage.Type;
       curStorage :=Storage.Storage;
      EXCEPT
      END;
      Result:=intGetMathPrice(MDoc.Date, MDocList.Math, curMyFirm, AcCut.PriceGrp, curStrgType, curStorage);
     END;
    ELSE
     Result:=GetANYMathPrice(MDoc.Date, MDocList.Math, MDoc.MyFirm, 01(*!*));
    END;
   END;
  EXCEPT
  END;
  RETURN Result;
 END {GetMDLMathPrice};

 PUBLIC PROCEDURE macc_Put(_AcCut: LIKE(AcCut.AcCut); VAR Collection: L_XObj.tXObjectAcCutCollection);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  LOOP
   IF !Collection[i] THEN
    Collection[i]:=_AcCut;
    EXIT;
   ELSIF Collection[i] = _AcCut THEN
    EXIT;
   END;
   INC(i);
  END;
 END {macc_Put};

 PRIVATE PROCEDURE acc_Append(VAR Collection: L_XObj.tXObjectAcCutCollection;
                              trgXObject: LIKE(XObject.XObject));
 BEGIN
  SELECT(XCalc, XObject, , trgXObject);
  WHILE OCCURE(XCalc) DO
   NARROWSEL(XCalc, AcCut);
   macc_Put(XCalc.AcCut, Collection);
   NEXTINEXTENDEDSEL(XCalc, AcCut);
  END; (* WHILE OCCURE(XCalc) *)
 END {acc_Append};

(*!*) PUBLIC PROCEDURE GetXObjectAcCutCollection(_XObject: LIKE(XObject.XObject)): L_XObj.tXObjectAcCutCollection;
  VAR
   Result: L_XObj.tXObjectAcCutCollection;
 BEGIN SETEMPTY(Result);
  acc_Append(Result, _XObject);
  RETURN Result;
 END {GetXObjectAcCutCollection};

 PUBLIC PROCEDURE GetMathAcCutCollection(_Math: LIKE(Math.Math)): L_XObj.tXObjectAcCutCollection;
  VAR
   Result: L_XObj.tXObjectAcCutCollection;
 BEGIN SETEMPTY(Result);
  SELECT(mItem, Math, , _Math);
  WHILE OCCURE(mItem) DO
   acc_Append(Result, mItem.XObject);
   NEXT(mItem);
  END; (* WHILE OCCURE(mItem) ... *)
  RETURN Result;
 END {GetMathAcCutCollection};

 PUBLIC PROCEDURE DefaultMUnit(trgMath: LIKE(Math.Math)): LIKE(MUnit.MUnit);
  VAR
   Result: LIKE(MUnit.MUnit);
 BEGIN
  SAVE(Math);
  SEARCH(Math, Math, , trgMath);
  Result:=Math.MUnit;
  RESTORE(Math);
  RETURN Result;
 END {DefaultMUnit};

 PUBLIC PROCEDURE SearchMUnit(_MUnit: LIKE(MUnit.MUnit));
 BEGIN
  L_General.Assert(SEARCH(MUnit, MUnit, _MUnit), "  ७   " + _MUnit);
 END {SearchMUnit};

 PUBLIC PROCEDURE MUnitSign(_MUnit: LIKE(MUnit.MUnit)): LIKE(MUnit.Sign);
 BEGIN
  SearchMUnit(_MUnit);
  RETURN MUnit.Sign;
 END {MUnitSign};

 PUBLIC PROCEDURE DefaultMUnitSign(_Math: LIKE(Math.Math)): LIKE(MUnit.Sign);
 BEGIN
  RETURN MUnitSign(DefaultMUnit(_Math));
 END {DefaultMUnitSign};

 PUBLIC PROCEDURE _FormatCir(_Cir: L_XObj.tQnt; _MUnit: LIKE(MUnit.MUnit)): STRING[];
  VAR _Format: STRING[2];
 BEGIN
  SearchMUnit(_MUnit);
  _Format:=MUnit.Format;
  IF MUnit.Format > 0 THEN
   _Format:=_Format+".";
  END;
  RETURN FLDTOSTR(_Cir, _Format, 0);
 END {_FormatCir};

 PUBLIC PROCEDURE DefaultFormatCir(_Math: LIKE(Math.Math); _Cir: L_XObj.tQnt): STRING[];
 BEGIN
  RETURN _FormatCir(_Cir, DefaultMUnit(_Math));
 END {DefaultFormatCir};

 PUBLIC PROCEDURE _AmountByWord(_Cir: L_XObj.tQnt; _MUnit: LIKE(MUnit.MUnit)): STRING[];
 BEGIN
  SearchMUnit(_MUnit);
  RETURN L_Str.NumericByWord(_Cir, MUnit.Format);
 END {_AmountByWord};

 PUBLIC PROCEDURE intGetKeyAssAcCutCollectionRemainders(P: DATE;
                                                        trgAcCuts: L_XObj.tXObjectAcCutCollection;
                                                        trgCirType: LIKE(Apport.CirType);
                                                        Real: SCAL[2]): L_XObj.tSum;
  VAR
   curAcCut: LIKE(AcCut.AcCut);
   Result: L_XObj.tSum;
 BEGIN
  Result:=0;
  FOR_EACH curAcCut IN trgAcCuts DO
   INC(Result, intRemainders(P, curAcCut, trgCirType, Real));
  END;
  RETURN Result;
 END {intGetKeyAssAcCutCollectionRemainders};

 PUBLIC PROCEDURE GetKeyAssAcCutCollectionRemaindersR(P: DATE;
                                                      trgAcCuts: L_XObj.tXObjectAcCutCollection;
                                                      trgCirType: LIKE(Apport.CirType)): L_XObj.tSum;
 BEGIN
  RETURN intGetKeyAssAcCutCollectionRemainders(P, trgAcCuts, trgCirType, 1);
 END {GetKeyAssAcCutCollectionRemaindersR};

 PRIVATE PROCEDURE intGetKeyAssBalCost(P: DATE; Cut: tKA_Cut; Real: SCAL[2]): L_XObj.tSum;
  VAR
   curAcCuts: L_XObj.tXObjectAcCutCollection;
 BEGIN
  IF    Cut =  KA_All THEN
   E_Stock.GetKeyAssBalCostAcCuts(P, curAcCuts, KA_All,               KA_All, KA_All);
  ELSIF Cut = KA_dst_Productive THEN
   E_Stock.GetKeyAssBalCostAcCuts(P, curAcCuts, KA_All,    KA_dst_Productive, KA_All);
  ELSIF Cut = KA_dst_NonProductive THEN
   E_Stock.GetKeyAssBalCostAcCuts(P, curAcCuts, KA_All, KA_dst_NonProductive, KA_All);
  ELSIF Cut = KA_Tax THEN
   SETEMPTY(curAcCuts);
   curAcCuts[0]:=E_Stock.KA_acc_TaxCost;
  ELSIF Cut = KA_InUse THEN
   SETEMPTY(curAcCuts);
   curAcCuts[0]:=E_Stock.KA_acc_InUse;
  ELSE
   L_General.CallUs(0);
  END;
  RETURN intGetKeyAssAcCutCollectionRemainders(P, curAcCuts, L_Acnt.ct_Credit, Real);
 END {intGetKeyAssBalCost};

 PUBLIC PROCEDURE GetKeyAssBalCost(P: DATE; Cut: tKA_Cut): L_XObj.tSum;
 BEGIN
  RETURN intGetKeyAssBalCost(P, Cut, 0);
 END {GetKeyAssBalCost};

 PUBLIC PROCEDURE GetKeyAssBalCostR(P: DATE; Cut: tKA_Cut): L_XObj.tSum;
 BEGIN
  RETURN intGetKeyAssBalCost(P, Cut, 1);
 END {GetKeyAssBalCostR};

 PRIVATE PROCEDURE intGetKeyAssWear(P: DATE; Cut : tKA_Cut; Real: SCAL[2]): L_XObj.tSum;
  VAR
   curAcCuts: L_XObj.tXObjectAcCutCollection;
 BEGIN
  IF    Cut = KA_All THEN
   E_Stock.GetKeyAssWearAcCuts(P, curAcCuts, KA_All,        KA_All, KA_All);
  ELSIF Cut = KA_BalDepr THEN
   E_Stock.GetKeyAssWearAcCuts(P, curAcCuts, KA_BalDepr,    KA_All, KA_All);
  ELSIF Cut = KA_OutBalDepr THEN
   E_Stock.GetKeyAssWearAcCuts(P, curAcCuts, KA_OutBalDepr, KA_All, KA_All);
  ELSIF Cut = KA_Tax THEN
   SETEMPTY(curAcCuts);
   curAcCuts[0]:=E_Stock.KA_acc_TaxWear;
  ELSE
   L_General.CallUs(0);
  END;
  RETURN intGetKeyAssAcCutCollectionRemainders(P, curAcCuts, L_Acnt.ct_Debit, Real);
 END {intGetKeyAssWear};

 PUBLIC PROCEDURE GetKeyAssWear(P: DATE; Cut: tKA_Cut): L_XObj.tSum;
 BEGIN
  RETURN intGetKeyAssWear(P, Cut, 0);
 END {GetKeyAssWear};

 PUBLIC PROCEDURE GetKeyAssWearR(P: DATE; Cut: tKA_Cut): L_XObj.tSum;
 BEGIN
  RETURN intGetKeyAssWear(P, Cut, 1);
 END {GetKeyAssWearR};

 PRIVATE PROCEDURE IsCIWearXObject(D: DATE; trgXObject: LIKE(XObject.XObject)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF ~!trgXObject THEN
   SAVE(XObject);
   SEARCH(XObject, XObject, , trgXObject);
   IF XObject.Origin = L_XObj.o_CostItem THEN
    L_XObj.AccessOrigin();
    IF ~!CostItem.CIKind THEN
     CONFORM(CostItem, CIKind);
     Result:=(CIKind.Type = L_CI.cikt_KeyAss) | L_kn.Is(D, L_CI.erkn_KeyAssWear);
    END;
   END;
   RESTORE(XObject);
  END; (* IF ~!trgXObject... *)
  RETURN Result;
 END {IsCIWearXObject};

 PUBLIC PROCEDURE XApportAmortSum(): L_XObj.tSum;
  VAR
   Side  : SCAL[2];
   Result: L_XObj.tSum;
 BEGIN
  Result:=0;
  CONFORM(XApport, Apport);
  IF Apport.CirType = L_Acnt.ct_Credit THEN
   IF    XApport.Source = L_XObj.src_ACalc THEN
    IF XApport.AcCut = E_Stock.KA_acc_TaxWear THEN
     INC(Result, XApport.Sum);
    ELSE
     FOR_EACH Side DO
      IF Side THEN
       SETSEL(XDocApr, AcCut, XApport.AcCut, XApport.XDat, XApport.XObject, XApport.Apport, XApport.AcCut2, XApport.WFDate);
       FOR_EACH XDocApr DO
        IF IsCIWearXObject(XDocApr.WFDate, XDocApr.XObject2) THEN
         INC(Result, XApport.Sum);
        END;
       END; (* FOR_EACH XDocApr *)
      ELSE
       SETSEL(XDocApr, AcCut2, XApport.AcCut, XApport.XDat, XApport.XObject, XApport.Apport, XApport.AcCut2, XApport.WFDate);
       FOR_EACH XDocApr DO
        IF IsCIWearXObject(XDocApr.WFDate, XDocApr.XObject) THEN
         INC(Result, XDocApr.Sum);
        END;
       END; (* FOR_EACH XDocApr *)
      END;
     END; (* FOR_EACH Side ... *)
    END; (* IF XApport.AcCut = E_Stock.KA_acc_TaxWear ... *)
   ELSIF XApport.Source = L_XObj.src_Amortisation THEN
    INC(Result, XApport.Sum);
   END;
  END; (* IF Apport.CirType = L_Acnt.ct_Credit ... *)
  RETURN Result;
 END {XApportAmortSum};

 PRIVATE PROCEDURE intGetCrd(B, E: DATE; trgAcCut: LIKE(AcMthL.AcCut); Real: SCAL[2]): L_XObj.tSum;
  VAR
   Result     : L_XObj.tSum;
   curCostItem: LIKE(CostItem.CostItem);
 BEGIN
  Result:=0;
  IF SoftAccessKeyAssXObject() THEN
   IF Real THEN
    SETSEL(XApport, WFD,     XObject.XObject, trgAcCut);
   ELSE
    SETSEL(XApport, XObject, XObject.XObject, trgAcCut);
   END;
   SRCINSEL(XApport, GE, , B);
   LOOP
    IF ~OCCURE(XApport) |
       ( Real & (XApport.WFDate >= E)) |
       (~Real & (XApport.XDat   >= E)) THEN
     EXIT;
    END;
    INC(Result, XApportAmortSum());
    NEXT(XApport);
   END; (* LOOP ... *)
  END; (* IF SoftAccessKeyAssXObject() ... *)
  RETURN Result;
 END {intGetCrd};

 PRIVATE PROCEDURE intGetKeyAssWearPer(B, E: DATE;
                                       Cut : tKA_Cut;
                                       Real: SCAL[2]): L_XObj.tSum;
  VAR
   Result   : L_XObj.tSum;
   curAcCut : LIKE(AcCut.AcCut);
   trgAcCuts: L_XObj.tXObjectAcCutCollection;
 BEGIN
  IF    Cut = KA_All THEN
   E_Stock.GetKeyAssWearAcCuts(E, trgAcCuts, KA_All,        KA_All, KA_All);
  ELSIF Cut = KA_BalDepr THEN
   E_Stock.GetKeyAssWearAcCuts(E, trgAcCuts, KA_BalDepr,    KA_All, KA_All);
  ELSIF Cut = KA_OutBalDepr THEN
   E_Stock.GetKeyAssWearAcCuts(E, trgAcCuts, KA_OutBalDepr, KA_All, KA_All);
  ELSIF Cut = KA_Tax THEN
   SETEMPTY(trgAcCuts);
   trgAcCuts[0]:=E_Stock.KA_acc_TaxWear;
  ELSE
   L_General.CallUs(0);
  END;
  Result:=0;
  FOR_EACH curAcCut IN trgAcCuts DO
   INC(Result, intGetCrd(B, E, curAcCut, Real));
  END;
  RETURN Result;
 END {intGetKeyAssWearPer};

 PUBLIC PROCEDURE GetKeyAssWearPer(B, E: DATE; Cut: tKA_Cut): L_XObj.tSum;
 BEGIN
  RETURN intGetKeyAssWearPer(B, E, Cut, 0);
 END {GetKeyAssWearPer};

 PUBLIC PROCEDURE GetKeyAssWearPerR(B, E: DATE; Cut: tKA_Cut): L_XObj.tSum;
 BEGIN
  RETURN intGetKeyAssWearPer(B, E, Cut, 1);
 END {GetKeyAssWearPerR};

 PRIVATE PROCEDURE intAccessMDoc(trgMath     : LIKE(Math.Math);
                                 trgMDocKinds: LIKE(MDoc.MDocKind)[]): SCAL[2];
  VAR
   curMDocKind: LIKE(MDoc.MDocKind);
 BEGIN
  SETSEL(MDocList, Math, trgMath);
  FOR_EACH MDocList DO
   FOR_EACH curMDocKind IN trgMDocKinds DO
    IF (MDocList.MDocKind = curMDocKind) THEN
     CONFORM(MDocList, MDoc);
     IF (MDoc.Status = L_MDoc.st_Passed) THEN
      RETURN 1;
     END;
    END;
   END; (* FOR_EACH curMDocKind IN trgMDocKinds *)
  END; (* FOR_EACH MDocList *)
  RETURN 0;
 END {intAccessMDoc};

 PUBLIC PROCEDURE AccessMDoc_asAPr(trgMath: LIKE(Math.Math)): SCAL[2];
 BEGIN
  RETURN intAccessMDoc(trgMath, [L_MDoc.md_APr]);
 END {AccessMDoc_asAPr};

 PUBLIC PROCEDURE AccessMDoc_asASp(trgMath: LIKE(Math.Math)): SCAL[2];
 BEGIN
  RETURN intAccessMDoc(trgMath, [L_MDoc.md_ASp, L_MDoc.md_AVb]);
 END {AccessMDoc_asASp};

 PRIVATE PROCEDURE intGetKeyAssMDocDate(trgMath: LIKE(Math.Math); AccessKeyAssMDocProc: PROC): DATE;
  VAR
   Result: DATE;
 BEGIN
  SETEMPTY(Result);
  SAVE(MDoc);
  SAVE(MDocList);
  IF AccessKeyAssMDocProc(trgMath) THEN
   IF L_Env.KeyAssAcntLev(MDoc.Date) = kaal_WithActProcess THEN
    Result:=MDoc.Date;
   ELSE
    Result:=MDoc.SrcDate;
   END;
  END;
  RESTORE(MDocList);
  RESTORE(MDoc);
  RETURN Result;
 END {intGetKeyAssMDocDate};

 PUBLIC PROCEDURE GetKeyAssAPrDate(trgMath: LIKE(Math.Math)): DATE;
 BEGIN
  RETURN intGetKeyAssMDocDate(trgMath, PROCREF(AccessMDoc_asAPr));
 END {GetKeyAssAPrDate};

 PUBLIC PROCEDURE GetKeyAssASpDate(trgMath: LIKE(Math.Math)): DATE;
 BEGIN
  RETURN intGetKeyAssMDocDate(trgMath, PROCREF(AccessMDoc_asASp));
 END {GetKeyAssASpDate};

 PUBLIC PROCEDURE IsActiveKeyAss(trgMath: LIKE(Math.Math); BegD, EndD: DATE): SCAL[2];
 BEGIN
  IF (GetKeyAssAPrDate(trgMath) <= EndD) & (GetKeyAssASpDate(trgMath) >= BegD) THEN
   RETURN 1;
  END;
  RETURN (GetKeyAssBalCost(BegD, KA_All) # 0) |
         (GetKeyAssBalCost(EndD, KA_All) # 0) |
         (GetKeyAssWear   (BegD, KA_All) # 0) |
         (GetKeyAssWear   (EndD, KA_All) # 0);
 END {IsActiveKeyAss};

 PRIVATE PROCEDURE ptlkamd_AddressCond(): SCAL[2];
 BEGIN
  RETURN P_MDoc.HasMDocPro(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_KeyAssAddress);
 END {ptlkamd_AddressCond};

 PRIVATE PROCEDURE _GetKeyAssAddress(_Math: LIKE(Math.Math); D: DATE; Strong: SCAL[2]): STRING[];
  VAR
   _Value: LIKE(MDocPro.Value)[2];
   RetVal: STRING[];
 BEGIN
  SAVE(MDoc);
  IF L_MDoc._PosToLastKeyAssMDoc(_Math, D, PROCREF(ptlkamd_AddressCond)) THEN
   P_MDoc.GetMDocProArray(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_KeyAssAddress, _Value);
   RetVal:=Str.Condense(_Value[0]+" "+_Value[1]);
  ELSIF Strong THEN
   L_General.Error("  "+_Math+"  । ⮭宦  "+L_DatTim.DateStr(D));
  ELSE
   RetVal:="";
  END;
  RESTORE(MDoc);
  RETURN RetVal;
 END {_GetKeyAssAddress};

 PUBLIC PROCEDURE GetKeyAssAddressSoft(_Math: LIKE(Math.Math); D: DATE): STRING[];
 BEGIN
  RETURN _GetKeyAssAddress(_Math, D, 0);
 END {GetKeyAssAddressSoft};

 PUBLIC PROCEDURE GetKeyAssAddressStrong(_Math: LIKE(Math.Math); D: DATE): STRING[];
 BEGIN
  RETURN _GetKeyAssAddress(_Math, D, 1);
 END {GetKeyAssAddressStrong};

 PUBLIC PROCEDURE PosToKAGSoft(_Math: LIKE(Math.Math); D: DATE): SCAL[2];
 BEGIN
  SETSEL(MathKAGL, Math, _Math);
  IF SRCINSEL(MathKAGL, LE, D) THEN
   CONFORM(MathKAGL, KAGroup);
   IF OCCURE(KAGroup) THEN
    HISTCONF(D, KAGroup, KAGLog);
    L_General.Assert(OCCURE(KAGLog), " 㪠 ଠ ⨧樨|" +
                                     "㯯  " + KAGroup.KAGroup +
                                     "  " + L_DatTim.DateStr(D));
    CONFORM(KAGLog, Deprec, DeprecT);
    RETURN 1;
   END;
  END;
  RETURN 0;
 END {PosToKAGSoft};

 PUBLIC PROCEDURE PosToKAG(_Math: LIKE(Math.Math); D: DATE);
 BEGIN
  L_General.Assert(PosToKAGSoft(_Math, D),
                   " 㪠 宦  㯯|ꥪ  " + _Math +
                   "  " + L_DatTim.DateStr(D));
 END {PosToKAG};

 PUBLIC PROCEDURE GetFullUL(APrDate: DATE; DprK: DprKindType): LIKE(KAGLog.AcnUL);
  VAR
   Result  : LIKE(KAGLog.AcnUL);
   curCorUL: LIKE(MathKAGL.CorAcnUL);
   curCorTp: LIKE(MathKAGL.CorAcnTp);
   curDprM : LIKE(KAGroup.AcnDprM);
 BEGIN
  IF    DprK = DprK_Acn THEN
   Result  :=KAGLog.AcnUL;
   curCorUL:=MathKAGL.CorAcnUL;
   curCorTp:=MathKAGL.CorAcnTp;
   curDprM :=KAGroup.AcnDprM;
  ELSIF DprK = DprK_Tax THEN
   Result  :=KAGLog.TaxUL / KAGLog.TaxNumb;
   curCorUL:=MathKAGL.CorTaxUL;
   curCorTp:=MathKAGL.CorTaxTp;
   curDprM :=KAGroup.TaxDprM;
  ELSE
   L_General.CallUs(0);
  END;
  IF    curCorTp = cortp_None THEN
   (*祣  *)
  ELSIF curCorTp = cortp_Cut THEN
   DEC(Result, curCorUL);
  ELSIF curCorTp = cortp_Perc THEN
   DEC(Result, Result*curCorUL/100);
  ELSIF curCorTp = cortp_Rest THEN
   Result:=curCorUL;
   IF curDprM # DprM_Runs THEN
    INC(Result, L_DatTim.CompleteMonthsInIntvl(L_DatTim.NextPer(APrDate), L_DatTim.NextPer(MathKAGL.Date)));
   END;
  ELSE
   L_General.CallUs(0);
  END;
  RETURN Result;
 END {GetFullUL};

 PRIVATE PROCEDURE Precious_AddPropValue(VAR PreciousNameStr,
                                             PreciousUnitStr,
                                             PreciousValueStr: STRING[];
                                             PreciousName    : STRING[];
                                             PropValue       : FLOAT);
 BEGIN
  IF ~!PropValue THEN
   L_MSO._AddToStr(PreciousNameStr,  PreciousName);
   L_MSO._AddToStr(PreciousUnitStr,  ".");
   L_MSO._AddToStr(PreciousValueStr, FLDTOSTR(PropValue, "4."));
  END;
 END {Precious_AddPropValue};

 PUBLIC PROCEDURE Precious_setWordVars(D: DATE; Prefix: STRING[]; Empty: SCAL[2]);
  VAR
   PreciousNameStr,
   PreciousUnitStr,
   PreciousValueStr: STRING[];
   PreciousMetals  : P_Math.tPreciousMetals[P_Math.pm_Amount];
 BEGIN
  SETEMPTY(PreciousNameStr, PreciousUnitStr, PreciousValueStr);
  IF ~Empty THEN
   IF P_Math.HasActualMathPro(Math.Math, D, P_Math.P_PreciousMetals) THEN
    P_Math.Decode_PreciousMetals(MathPro.Value, PreciousMetals);
   ELSE
    SETEMPTY(PreciousMetals);
   END;
   Precious_AddPropValue(PreciousNameStr,
                         PreciousUnitStr,
                         PreciousValueStr,
                         "ॡ",
                         PreciousMetals[P_Math.pm_Argentum]);
   Precious_AddPropValue(PreciousNameStr,
                         PreciousUnitStr,
                         PreciousValueStr,
                         "" ,
                         PreciousMetals[P_Math.pm_Aurum]);
   Precious_AddPropValue(PreciousNameStr,
                         PreciousUnitStr,
                         PreciousValueStr,
                         "⨭",
                         PreciousMetals[P_Math.pm_Platinum]);
   Precious_AddPropValue(PreciousNameStr,
                         PreciousUnitStr,
                         PreciousValueStr,
                         "",
                         PreciousMetals[P_Math.pm_Palladium]);
  END;
  L_MSO.wordSetVar(Prefix + "Precious.Name",   PreciousNameStr);
  L_MSO.wordSetVar(Prefix + "Precious.Unit",   PreciousUnitStr);
  L_MSO.wordSetVar(Prefix + "Precious.Weight", PreciousValueStr);
 END {Precious_setWordVars};

 PUBLIC PROCEDURE KACar_setWordVars(D: DATE; Prefix: STRING[]; Empty: SCAL[2]);
  VAR
   MarkName    : STRING[];
   OverhaulDate: DATE;
   TotalRun    : NUMERIC[2];
 BEGIN
  IF Empty THEN
   MarkName:="";
  ELSE
   MarkName:=P_Math.GetMathProSoft(Math.Math, D, P_Math.P_Model);
  END;
  IF ~Empty & PosToCarLog(Math.Math, D) THEN
   CONFORM(CarLog, Car);
   CONFORM(CarLog, Mark);
   CONFORM(CarLog, VehPasp);
   IF OCCURE(VehPasp) THEN
    CONFORM(VehPasp, VehType);
    CONFORM(VehPasp, EnginTyp);
   END;
   L_MSO.wordSetVarsByFile_wPrefix("Car",    Prefix);
   L_MSO.wordSetVarsByFile_wPrefix("CarLog", Prefix);
   L_MSO.wordSetVarsByFile_wPrefix("Mark",   Prefix);
   L_MSO.wordSetVar(Prefix + "Mark.PasVol",
                    L_Str.IntStr(P_Mark.GetP_PasVol(Mark.Mark, D)));
   IF !MarkName THEN
    MarkName:=Mark.Name;
   END;
   TotalRun:=L_Car.GetWhiteRun(Math.Math, D);
   L_MSO.wordSetVar(Prefix + "TotRun", FLDTOSTR(TotalRun, "0"));
   OverhaulDate:=L_Car.GetStartDLastMathRepEvent(Math.Math, L_Car.E_RE_Overhaul(D), D);
   L_MSO.wordSetDateVar(Prefix + "LastCapDate", OverhaulDate);
   IF ~!OverhaulDate THEN
    L_MSO.wordSetVar(Prefix + "LastCapRun", FLDTOSTR(TotalRun - L_Car.GetWhiteRun(Math.Math, OverhaulDate), "0"));
   ELSE
    L_MSO.wordSetVar(Prefix + "LastCapRun", "");
   END;
  ELSE
   L_MSO.wordSetVarsByFile_wPrefixE("Car",    Prefix, 1);
   L_MSO.wordSetVarsByFile_wPrefixE("CarLog", Prefix, 1);
   L_MSO.wordSetVarsByFile_wPrefixE("Mark",   Prefix, 1);
   L_MSO.wordSetVar(Prefix + "TotRun",     "");
   L_MSO.wordSetVar(Prefix + "LastCapRun", "");
   L_MSO.wordSetDateVar(Prefix + "LastCapDate", EMPTYOF(DATE));
  END;

  L_MSO.wordSetVar(Prefix + "Mark.Name", MarkName);
  L_MSO.wordSetVarsByFile_wPrefixE("VehPasp",  Prefix + "Car.", Empty | ~OCCURE(VehPasp));
  L_MSO.wordSetVarsByFile_wPrefixE("VehType",  Prefix + "Car.", Empty | ~OCCURE(VehType));
  L_MSO.wordSetVarsByFile_wPrefixE("EnginTyp", Prefix + "Car.", Empty | ~OCCURE(EnginTyp));
 END {KACar_setWordVars};

 PUBLIC PROCEDURE StandOnVendor();
 BEGIN
  L_General.Assert(~!Math.Vendor,
                   "  ⮢⥫   " + Math.Math);
  CONFORM(Math, Vendor);
 END {StandOnVendor};

 PUBLIC PROCEDURE Math_setWordVars(D: DATE; Alias: STRING[]; Empty: SCAL[2]);
  VAR
   Prefix  : STRING[];
   FactLife: NUMERIC[0];
   APrDate : DATE;
 BEGIN
  L_MSO.wordSetVarsByFile_wAliasE("Math", Alias, Empty);
  Prefix:=Alias + ".";
  IF Empty THEN
   L_MSO.wordSetVar(Prefix + "Number",        "");
   L_MSO.wordSetVar(Prefix + "Serial",        "");
   L_MSO.wordSetVar(Prefix + "AcnDprM",       "");
   L_MSO.wordSetVar(Prefix + "BornYear",      "");
   L_MSO.wordSetVar(Prefix + "DprGroup",      "");
   L_MSO.wordSetVar(Prefix + "OKOF",          "");
   L_MSO.wordSetVar(Prefix + "FactLife",      "");
   L_MSO.wordSetVar(Prefix + "Life",          "");
   L_MSO.wordSetVar(Prefix + "BegDate",       "");
   L_MSO.wordSetVar(Prefix + "BegDate.Short", "");
   L_MSO.wordSetVar(Prefix + "BegMonth",      "");
   L_MSO.wordSetVar(Prefix + "Description",   "");
  ELSE
   APrDate:=GetKeyAssAPrDate(Math.Math);
   L_General.Assert(~!APrDate, "    ᯫ  " + Math.Math);
   PosToKAG(Math.Math, D);
   CONFORM(Math, MathType);
   StandOnVendor();
   FactLife:=L_DatTim.CompleteMonthsInIntvl(L_DatTim.NextPer(APrDate), L_DatTim.NextPer(D));
   L_MSO.wordSetVar(Prefix+"FactLife",   L_Str.IntStr(FactLife DIV 12)+" , "+
                                         L_Str.IntStr(FactLife MOD 12)+" .");
   IF    (D >= 01\01\2002) & (KAGroup.AcnDprM # DprM_Runs) THEN
    L_MSO.wordSetVar(Prefix + "Life",    L_Str.IntStr(KAGLog.AcnUL) + " .");
   ELSIF (D < 01\01\2002) & OCCURE(Deprec) & ~Deprec.Norm1000 THEN
    L_MSO.wordSetVar(Prefix + "Life",    L_Str.IntStr(12*KAGLog.Number*100/Deprec.Norm) + " .");
   ELSE
    L_MSO.wordSetVar(Prefix + "Life",    "");
   END;
   L_MSO.wordSetVar(Prefix + "Number",   "1");
   L_MSO.wordSetVar(Prefix + "Serial",   P_Math.GetMathProSoft(Math.Math, D, P_Math.P_Serial));
   L_MSO.wordSetVar(Prefix + "AcnDprM",  L_Str.PoolItem(dprm_Pool,
                                                        KAGroup.AcnDprM));
   L_MSO.wordSetVar(Prefix + "BornYear", FLDTOSTR(Math.Born, "y"));
   L_MSO.wordSetVar(Prefix + "DprGroup", KAGLog.DprGroup);
   L_MSO.wordSetVar(Prefix + "OKOF",     FLDTOSTR(KAGLog.OKOF, "00 0000000"));
   L_MSO.wordSetVar(Prefix + "Math",     E_KeyAssInv(D));
   L_MSO.wordSetVar(Prefix + "BegDate",       L_DatTim.FullDateStr(APrDate));
   L_MSO.wordSetVar(Prefix + "BegDate.Short", L_DatTim.DateStr(APrDate));
   L_MSO.wordSetVar(Prefix + "BegMonth",      L_DatTim.MonthStr(APrDate, 0) +
                                              FLDTOSTR(APrDate, ", y"));
   L_MSO.wordSetVar(Prefix + "Description",   P_Math.GetMathProSoft(Math.Math, D, P_Math.P_Description));
  END;
  L_MSO.wordSetVarsByFile_wPrefixE("Vendor",   Prefix, Empty | (Math.Vendor = vnd_Ourselves));
  L_MSO.wordSetVarsByFile_wPrefixE("MathType", Prefix, Empty);
  L_MSO.wordSetVarsByFile_wPrefixE("DeprecT",  Prefix, Empty | ~OCCURE(DeprecT));
  L_MSO.wordSetVarsByFile_wPrefixE("KAGLog",   Prefix, Empty);
 END {Math_setWordVars};

(*-------------BEGIN OF NORMAL ENVIRONMENT--------------------------*)

 PRIVATE PROCEDURE E_CurStockDeadLine(D: DATE): TIME;
 BEGIN
  RETURN L_EC.ExecE_Func_Time(D, PROCREF(E_Stock.CurStockDeadLine), 00:00);
 END {E_CurStockDeadLine};

 PUBLIC PROCEDURE E_NotFullActiveKeyAssSystem(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(L_Env.NotFullActiveKeyAssSystem), 0);
 END {E_NotFullActiveKeyAssSystem};

 PRIVATE PROCEDURE E_NoTaxAccountKeyAss(): SCAL[2];;
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(L_Env.NoTaxAccountKeyAss), 0);
 END {E_NoTaxAccountKeyAss};

 PUBLIC PROCEDURE E_IsComplexMath(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Stock.IsComplexMath), 0);
 END {E_IsComplexMath};

 PUBLIC PROCEDURE E_GetSingleRefToXDocType(D          : DATE;
                                           trgMDocKind: SCAL[1E2];
                                           trgStorage : LIKE(Storage.Storage)): L_XDoc.tXDocType;
  VAR
   Local  : PROC;
   default: L_XDoc.tXDocType;
 BEGIN
  IF    (trgMDocKind = L_MDoc.md_NOV) & L_Stock.IsFuelStationMDoc() & L_Fuel.TanksIsStock(D) THEN
   RETURN L_XDoc.xdt_RWayS;
  ELSIF P_Storage.IsRepair(trgStorage, D) THEN
   RETURN L_XDoc.xdt_RprS;
  ELSE
   SETEMPTY(default);
 (* 09.09.2005 18:00:53 POLAK\San  ।  Storage E_Stock 㤥  - 祭  *)
   Local:=PROCREF(E_Stock.GetSingleRefToXDocType);
   IF ~!Local THEN
    default:=Local(default, D, trgMDocKind, trgStorage);
   END;
   RETURN default;
  END;
 END {E_GetSingleRefToXDocType};

 PUBLIC PROCEDURE E_KeyAssInv(D: DATE): STRING[];
 BEGIN
  IF Math.MathKind = mathk_KeyAs THEN
   RETURN L_EC.ExecE_Func_String(D, PROCREF(E_Stock.KeyAssInv), Math.Math);
  ELSE
   RETURN Math.Math;
  END;
 END {E_KeyAssInv};

 PUBLIC PROCEDURE E_DefMathKAGLBreak(DprK: DprKindType): LIKE(MathKAGL.AcnBreak);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Stock.DefMathKAGLBreak);
  IF ~!Local THEN
   RETURN Local(DprK);
  ELSE
   RETURN brk_Allways;
  END;
 END {E_DefMathKAGLBreak};

 PUBLIC PROCEDURE amm_Init(D: DATE);
  VAR
   curMMode: LIKE(MMode.MMode);
 BEGIN
  L_AFM.MakeMultipleIndex("_AMMd", "MathType: LIKE(MathType.MathType);"+
                                   "AcCut: LIKE(AcCut.AcCut);"+
                                   "MMode: LIKE(MMode.MMode)",
                          "_AMMd: MathType, AcCut");
  SETSEL(MTMM, MTMM);
  FOR_EACH MTMM DO
   IF (MTMM.MMode # mm_Level2) &
      L_DatTim.IsActive(D, MTMM.Begin, MTMM.Till) &
      SEARCH(ACSetL, ACSet, MTMM.ACSet, L_Acnt.acp_Math_Netto) THEN
    IF    MTMM.MMode = mm_NewInAccountability  THEN curMMode:=mm_New;
    ELSIF MTMM.MMode = mm_UsedInAccountability THEN curMMode:=mm_Used;
    ELSE                                            curMMode:=MTMM.MMode;
    END;
    IF ~ADD(_AMMd, _AMMd, MTMM.MathType, ACSetL.AcCut) THEN
     _AMMd.MMode:=curMMode;
     REPLACE(_AMMd);
    ELSIF _AMMd.MMode # curMMode THEN
     _AMMd.MMode:=Math.Min(_AMMd.MMode, curMMode);
     REPLACE(_AMMd);
    END;
   END;
  END; (* FOR_EACH MTMM ... *)
 END {amm_Init};

 PUBLIC PROCEDURE amm_GetMMode(trgMathType: LIKE(MathType.MathType); trgAcCut: LIKE(AcCut.AcCut)): LIKE(MMode.MMode);
 BEGIN
  IF SEARCH(_AMMd, _AMMd, trgMathType, trgAcCut) THEN
   RETURN _AMMd.MMode;
  ELSE
   RETURN EMPTYOF(MMode.MMode);
  END;
 END {amm_GetMMode};

 PUBLIC PROCEDURE amm_GetMModeSign(trgMathType: LIKE(MathType.MathType); trgAcCut: LIKE(AcCut.AcCut)): LIKE(MMode.Sign);
  VAR
   curMMode: LIKE(MMode.MMode);
 BEGIN
  curMMode:=amm_GetMMode(trgMathType, trgAcCut);
  IF ~!curMMode THEN
   RETURN MModeStr(curMMode);
  ELSE
   RETURN "";
  END;
 END {amm_GetMModeSign};

 PUBLIC PROCEDURE amm_DeInit();
 BEGIN
  L_AFM.AF_PurgeTemp("_AMMd");
 END {amm_DeInit};

 PUBLIC PROCEDURE mr_Init();
 BEGIN
  L_AFM.MakeMultipleIndex("mRst1", "Math    : LIKE(Math.Math);" +
                                   "AcCut   : LIKE(AcCut.AcCut);" +
                                   "Vendor  : LIKE(Math.Vendor);" +
                                   "MathType: LIKE(Math.MathType);" +
                                   "CarUnit : LIKE(Math.CarUnit);" +
                                   "Qnt     : NUMERIC[2];" +
                                   "Sum     : NUMERIC[2];" +
                                   "CUpDone : SCAL[2]",
                             "Math    : Math, AcCut, Vendor, MathType, CarUnit; " +
                             "AcCut   : AcCut, Math; " +
                             "MathType: MathType, Math, AcCut; " +
                             "CarUnit : CarUnit, Vendor, Math, AcCut; " +
                             "Vendor  : Vendor, Math, AcCut");
 END {mr_Init};

 (* ꥤ Math *)
 PRIVATE PROCEDURE _CheckMathPro(_Math1, _Math2: LIKE(Math.Math)): SCAL[2];
  VAR
   _EndDate:  LIKE(MathPro.EndDate);
   _Value:    LIKE(MathPro.Value);
   _DocNum:   LIKE(MathPro.DocNum);
   _DocGiveS: LIKE(MathPro.DocGiveS);
   _DocGiveD: LIKE(MathPro.DocGiveD);
   _DocExpD:  LIKE(MathPro.DocExpD);
 BEGIN
  SELECT(MathPro, Math, , _Math1);
  WHILE OCCURE(MathPro) DO
   SAVE(MathPro);
   _EndDate :=MathPro.EndDate;
   _Value   :=MathPro.Value;
   _DocNum  :=MathPro.DocNum;
   _DocGiveS:=MathPro.DocGiveS;
   _DocGiveD:=MathPro.DocGiveD;
   _DocExpD :=MathPro.DocExpD;
   IF ~SEARCH(MathPro, Math, _Math2, MathPro.Property, MathPro.Date) |
      (_EndDate  # MathPro.EndDate)  |
      (_Value    # MathPro.Value)    |
      (_DocNum   # MathPro.DocNum)   |
      (_DocGiveS # MathPro.DocGiveS) |
      (_DocGiveD # MathPro.DocGiveD) |
      (_DocExpD  # MathPro.DocExpD) THEN
    RESTORE(MathPro);
    RETURN 0;
   END;
   RESTORE(MathPro);
   NEXT(MathPro);
  END; (* WHILE OCCURE(MathPro) ... *)
  RETURN 1;
 END {_CheckMathPro};

 PRIVATE PROCEDURE CheckMathPro(SrcMath, DstMath: LIKE(Math.Math));
 BEGIN
  IF ~_CheckMathPro(SrcMath, DstMath) |
     ~_CheckMathPro(DstMath, SrcMath) THEN
   L_StdFrm.Choice(" ᮢ ᢮⢠ | 㢥७,   ꥤ  ꥪ?");
  END;
  SETSEL(MathPro, Math, SrcMath);
  REMSEL(MathPro);
 END {CheckMathPro};

 PRIVATE PROCEDURE CheckMathUnit(SrcMath, DstMath: LIKE(Math.Math));
  VAR
   _MUnit: LIKE(MUnit.MUnit);
 BEGIN
  IF SELECT(MathUnit, Math, SrcMath) THEN
   WHILE OCCURE(MathUnit) DO
    _MUnit:=MathUnit.MUnit;
    SAVE(MathUnit);
    IF ~SEARCH(MathUnit, Math, DstMath, MathUnit.Number) | (_MUnit # MathUnit.MUnit) THEN
     L_StdFrm.Choice(" ᮢ  ७");
    END;
    RESTORE(MathUnit);
    NEXT(MathUnit);
   END; (* WHILE OCCURE(MathUnit) ... *)
   REMSEL(MathUnit);
  END;
 END {CheckMathUnit};

 PRIVATE PROCEDURE MergeCalc(SrcMath, DstMath: LIKE(Math.Math));
  VAR
   _XObjectSrc: LIKE(mItem.XObject);
 BEGIN
  SELECT(mItem, Math, , SrcMath);
  WHILE OCCURE(mItem) DO

   _XObjectSrc:=mItem.XObject;
   SAVE(mItem);
   L_Stock.Obtain_mItem(DstMath, mItem.Storage);
   L_XObj.MergeXObject(_XObjectSrc, mItem.XObject);

   RESTORE(mItem);
   CONFORM(mItem, XObject);
   TRY [INTEGRITY(INTEGRITY_ON)]
    REMOVE(mItem);
    REMOVE(XObject);
   EXCEPT
   END;
  END; (* WHILE OCCURE(mItem) ... *)
 END {MergeCalc};

 PUBLIC PROCEDURE MergeMath(SrcMath, DstMath: LIKE(Math.Math));
  VAR
   SrcName,
   DstName  : STRING[42];
   SrcMathType: LIKE(Math.MathType);
   SrcMathKind: LIKE(Math.MathKind);
   srcLeaf    : LIKE(Math.Leaf);
   NameLen: NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt(SrcMath + " -> " + DstMath);
  SEARCH(Math, Math, , SrcMath);
  L_r2r.Owner_OnBeforeDelete("Math");

  SrcName:=Math.Name;
  SrcMathKind:=Math.MathKind;
  SrcMathType:=Math.MathType;
  srcLeaf    :=Math.Leaf;
  SEARCH(Math, Math, , DstMath);
  DstName:=Math.Name;

  NameLen:=Math.Max(Str.Length(SrcName), Str.Length(DstName));
  L_StdFrm.Choice(" ᯮ짮 " +
                  "| |" +
                  SrcMath + " " + Str.Align(SrcName, NameLen, LEFT) +
                  "|" +
                  "" +
                  "|" +
                  DstMath + " " + Str.Align(DstName, NameLen, LEFT));

  L_General.Assert(SrcMathKind=Math.MathKind, " ᮢ 㯯 ꥪ⮢! ("+SrcMathKind+" "+Math.MathKind+")");
  L_General.Assert(SrcMathType=Math.MathType, " ᮢ  ꥪ⮢! ("  +SrcMathType+" "+Math.MathType+")");
  L_General.Assert(srcLeaf = Math.Leaf, " ᪫ 㯯஢    ");

  CheckMathPro (SrcMath, DstMath);
  CheckMathUnit(SrcMath, DstMath);

  MergeCalc(SrcMath, DstMath);

  TRY [INTEGRITY(INTEGRITY_OFF)]
   SEARCH(Math, Math, , SrcMath);
   REMOVE(Math);
 
   L_General.CallUs(SEARCH(Math, Math, DstMath));
   Math.Math:=SrcMath;
   REPLACE(Math);
  EXCEPT
  END;

  TRY [INTEGRITY(INTEGRITY_ON)]
   Math.Math:=DstMath;
   REPLACE(Math);
  EXCEPT
  END;
 END {MergeMath};

 PUBLIC PROCEDURE StfKA_Prepare(_TSN: LIKE(Staff.TSN); D: DATE);
 BEGIN
  L_AFM.MakeIndex("StfKA", "Math: LIKE(Math.Math)");
  SELECT(MDoc, TSN, , _TSN);
  WHILE OCCURE(MDoc) DO
   NARROWSEL(MDoc, MDocKind);
   IF L_MDoc.KeyAssetsMDoc(MDoc.MDocKind) & ~L_MDoc.md_asASp(MDoc.MDocKind) THEN
    WHILE OCCURE(MDoc) DO
     IF (MDoc.Date < D) & (MDoc.Status # L_MDoc.st_Canceled) THEN
      SAVE(MDoc);
      CONFORM(MDoc, MDocList);
      WHILE OCCURE(MDocList) DO
       IF ~SEARCH(StfKA, StfKA, MDocList.Math) THEN
        SAVE(MDocList);
        IF L_MDoc.PosToLastKeyAssChangeResponsibleMDoc(MDocList.Math, D-1) &
           ~L_MDoc.md_asASp(MDoc.MDocKind) &
           (MDoc.TSN = _TSN) THEN
         RESTORE(MDocList);
         ADD(StfKA, StfKA, , MDocList.Math);
        ELSE
         RESTORE(MDocList);
        END;
       END;
       NEXT(MDocList);
      END; (* WHILE OCCURE(MDocList) ... *)
      RESTORE(MDoc);
     END;
     NEXT(MDoc);
    END; (* WHILE OCCURE(MDoc) ... *)
   END;
   NEXTINEXTENDEDSEL(MDoc, MDocKind);
  END; (* WHILE OCCURE(MDoc) ... *)
 END {StfKA_Prepare};

 PUBLIC PROCEDURE StfKA_Purge();
 BEGIN
  L_AFM.AF_PurgeTemp("StfKA");
 END {StfKA_Purge};

 PRIVATE PROCEDURE icommValId(trgMyFirm: P_Firm.tMyFirm; trgComT: tInvCommitteeType; curStorage: LIKE(Storage.Storage)): L_SES.tValId;
  CONST
   Prefix = "InvComm";
  VAR
   Result: L_SES.tValId;
 BEGIN
  Result:=Prefix+"|"+trgMyFirm+"|"+trgComT;
  IF trgComT = icomt_Storage THEN
   Result:=Result+"|"+curStorage;
  END;
  RETURN Result;
 END {icommValId};

 PUBLIC PROCEDURE GetCommitteeFromSES(trgMyFirm: P_Firm.tMyFirm;
                                      trgComT: tInvCommitteeType;
                                      curStorage: LIKE(Storage.Storage);
                                      VAR From, UpTo: DATE;
                                      VAR DocName, DocNum: STRING[];
                                      VAR DocDate: DATE;
                                      VAR ComTSN: LIKE(Staff.TSN)[];
                                      VAR ChTSN: LIKE(Staff.TSN));
  VAR
   curValue: STRING[];
   Dummy   : SCAL[2];
   Idx     : SCAL[icomNum];
 BEGIN
  IF ~L_SES.GetValue(L_SES.sit_Global, icommValId(trgMyFirm, trgComT, curStorage), curValue) THEN
   curValue:="";
  END;
  From   :=STRTOFLD(L_Prop.getRecordElement(curValue, 0), DATE);
  UpTo   :=STRTOFLD(L_Prop.getRecordElement(curValue, 1), DATE);
  DocName:=L_Prop.getRecordElement(curValue, 2);
  DocNum :=L_Prop.getRecordElement(curValue, 3);
  DocDate:=STRTOFLD(L_Prop.getRecordElement(curValue, 4), DATE);
  FOR_EACH Idx DO
   ComTSN[Idx]:=L_Prop.getRecordElement(curValue, 5+Idx);
  END;
  ChTSN:=L_Prop.getRecordElement(curValue, 6+Idx);
 END {GetCommitteeFromSES};

 PUBLIC PROCEDURE SetCommitteeToSES(trgMyFirm: P_Firm.tMyFirm;
                                    trgInvComT: tInvCommitteeType;
                                    trgStorage: LIKE(Storage.Storage);
                                    From, UpTo: DATE;
                                    DocName, DocNum: STRING[];
                                    DocDate: DATE;
                                    comTSN: LIKE(Staff.TSN)[];
                                    ChTSN: LIKE(Staff.TSN));
  VAR
   curFields: FORM_FIELDS;
   curValue,
   tmpValue : STRING[];
   Idx      : SCAL[icomNum];
 BEGIN
  curValue:="";
  tmpValue:="";
  L_Prop.putRecordElement(curValue, From);
  L_Prop.putRecordElement(curValue, UpTo);
  L_Prop.putRecordElement(curValue, DocName);
  L_Prop.putRecordElement(curValue, DocNum);
  L_Prop.putRecordElement(curValue, DocDate);
  FOR_EACH Idx DO
   IF ~!comTSN[Idx] THEN
    L_Prop.putRecordElement(curValue, comTSN[Idx]);
   ELSE
    L_Prop.putRecordElement(tmpValue, comTSN[Idx]);
   END;
  END;
  curValue:=curValue+tmpValue;
  L_Prop.putRecordElement(curValue, ChTSN);
  L_SES.PutValueAtCurTrn(L_SES.sit_Global, icommValId(trgMyFirm, trgInvComT, trgStorage), curValue);
 END {SetCommitteeToSES};

 PUBLIC PROCEDURE IsInventories(trgMath: LIKE(Math.Math)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(Math);
  SAVE(MathType);
  AccessMath(trgMath);
  CONFORM(Math, MathType);
  Result:=MathType.Category = L_Acnt.mtc_Inventories;
  RESTORE(MathType);
  RESTORE(Math);
  RETURN Result;
 END {IsInventories};

END.
