(*
%Copyright   (c) Polak Computer System
%Author      SAN
%Purpose      ࠡ  , 楢 ⮬
%Type        library
%Specific    SYS
%Modified    24.09.2014 16:10:06 LDA
*)

 MODULE L_PRoll [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tSum         = NUMERIC[2];
  tTime        = NUMERIC[3];
  tCountUp     = SCAL[5];
  tMCodePayFut = SCAL[3];
  tExtensionType = SCAL[2];
  tExtensionSubType = SCAL[2];
  tMoney2XObjectOrigin = SCAL[2];

 PUBLIC CONST
  src_Operator = 0;
  src_Sheet    = 1;
  src_AvePay   = 2;
  src_System   = 3;
  src_RWayS    = 4;
  src_OrderP   = 5; (*ਪ 業⮬*)
  src_PJobs    = 6; (*ᮭ  *)
  src_KTU      = 7; (* *)
  src_PDoc     = 8;
  src_OrderS   = 9; (*ਪ 㬬*)
  src_FtSht    = 10;
  src_FtSys    = 11;
  src_XCalc    = 12;
  src_SheetDec = 13; (*㬥襭 㬬  筨 src_Sheet*)
  src_Pool     = "||㬥|⥬|⥢|ਪ |||. .|ਪ |⥬ |⥬ | |()| | | | | | | | | | | | | | | | | |KarTo";

  wplType_MonthlyWage = 0;
  wplType_Tariff      = 1;

  mct_Credit = 0;
  mct_Debit  = 1;

  mci_Exclude = 0; (*MCList.Index*)
  mci_Include = 1;
  mci_Indexed = 2;

  cu_snglFull      = 0;
  cu_snglFull_wKTM = 1;
  cu_strmUpToDate  = 2;
  cu_strmFull      = 3;
  cu_strmFinal     = 4;

  tt_Exclude    = 0; (*MCList.TimeType*)
  tt_Include    = 1;
  tt_Production = 2;

  rgt_BaseGr  = 0; (*RegMain.SlipGr*)
  rgt_SlipGr  = 1;
  rgt_OtherGr = 2;
  rgt_Pool = "|騩|稩";

  rgs_None     = 0; (*RegHead.ShdlType*)
  rgs_Month    = 1;
  rgs_Daily    = 2;
  rgs_Pool = "ᯨᠭ |ᯨᠭ   |ᯨᠭ    ";

  mthtyp_SheetCalc     = 00;
  mthtyp_BonusCalc     = 01;
  mthtyp_HolidayCalc   = 02;
  mthtyp_ByAverageCalc = 03;
  mthtyp_RWaySCalc     = 04;
  mthtyp_MonthlyCalc   = 05;
  mthtyp_EDOrder       = 88;
  mthtyp_EmptyCalc     = 90;
  mthtyp_LastCalc      = 91;
  mthtyp_BeforeDedF    = 92;

  fot_BySum = 0; (*FOrder.Type*)
  fot_ByPrc = 1;

  pdtom_PaidOnly         = 0;   (* PDocList c ﭨ "뤠" *)
  pdtom_All              = 1;   (*  PDocList,  뤠 - १  *)
  pdtom_PaidAndDeposited = 2;   (*  PDocList ஬ " 뤠" *)

  dtbn_Sum     = 0; (*DedType.BaseNo*)
  dtbn_OnBase1 = 1;
  dtbn_OnBase2 = 2;
  dtbn_OnBase3 = 4;
  dtbn_OnBase4 = 4;
  dtbn_OnBase5 = 5;
  dtbn_OnBase6 = 6;
  dtbn_OnBase7 = 7;
  dtbn_OnRest  = 8;
  dtbn_OnDept  = 9;

  mcis_FullSalary =02; (*MCList.InSign*)

  dmmm_byOfficer  = 0;
  dmmm_byMCList   = 1; (* २ ! *)
  dmmm_byManXCalc = 2;
  dmmm_byMoneyDst = 3;
  dmmm_byContract = 4;
  dmmm_ByAcCut    = 5;
  dmmm_Pool = " ࠡ祬 | ᠭ  /|ᯮ   |  㦥 ஢|  ⭮ |⥭ ⮫쪮 ࠧ१";

  dmsf_asMnMth = 0;
  dmsf_asDM01  = 1;
  dmsf_Pool = "|ᮡ 01";

  et_ManSFee = 0;

  et_Pool = "  楫  客 ᮢ|";

  est_byMyself = 0;
  est_byAudit  = 1;
  est_Pool = "  ᮡ⢥ |  譥 ஢થ";

  dm_MainSalary = 01; (*DstMode.DstMode*)

  erkn_MCList_PaidByCash     = 009423701;
  erkn_MCList_PaidByBank     = 009423702;
  erkn_MCList_ReturnedByCash = 009423703;
  erkn_MCList_ReturnedByBank = 009423704;
  erkn_MCList_ToDeponent     = 009423705;
  erkn_MCList_FromDeponent   = 009423706;
  erkn_MCList_NDLF           = 009423707;
  erkn_MCList_AtExpenseOfFSS = 010438301;

  m2xo_Contract = 0;
  m2xo_CostItem = 1;
  m2xo_Pool = "|";

 PUBLIC VAR
  curCountUp: tCountUp;

 IMPORT Memo, L_General, L_DatTim, L_APtm, L_EC, E_PRoll, E_Distr, L_AP, L_AcCut, L_StdFrm, L_AcsPnt,
        L_PDoc, P_OwnData, Str, Math, L_Money, L_Staff, L_Acnt, L_XObj, L_Env, L_Russia, L_AR, P_MCList,
        P_Sort, L_Tax, L_kn;

 PRIVATE TYPE
  tDoneIdx = SCAL[4];

 PRIVATE CONST
  DmnDoneIdx = 4; (*  믮 ७⭮   ⠢   *)
  AveDoneIdx = 3;
  ShtDoneIdx = 0;
  DedDoneIdx = 1;

 PUBLIC PROCEDURE E_PrintMoneyForStaff(D: DATE; IsSingleMode: SCAL[2]): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_PRoll.PrintMoneyForStaff);
  IF ~!Local THEN
   RETURN Local(D, IsSingleMode);
  END;
  RETURN 1;
 END {E_PrintMoneyForStaff};

 PUBLIC PROCEDURE Salary_ClcPer(): DATE;
 BEGIN
  RETURN L_APtm.ANYSystem_ClcPer(L_APtm.system_Salary);
 END {Salary_ClcPer};

 PUBLIC PROCEDURE Salary_CheckNoTouch(D: DATE);
 BEGIN
  L_APtm.ANYSystem_CheckNoTouch(D, L_APtm.system_Salary);
 END {Salary_CheckNoTouch};

 PUBLIC PROCEDURE Salary_Clc_CntIsEqual(): SCAL[2];
 BEGIN
  RETURN L_APtm.ANYSystem_Clc_CntIsEqual(L_APtm.system_Salary);
 END {Salary_Clc_CntIsEqual};

 PUBLIC PROCEDURE Salary_CheckClcPer();
 BEGIN
  L_APtm.ANYSystem_CheckClcPer(L_APtm.system_Salary);
 END {Salary_CheckClcPer};

 PUBLIC PROCEDURE FixPCalc(P: DATE);
  VAR
   _Saldo: LIKE(PCalc.Saldo);
 BEGIN
  L_General.CallUs(P = L_DatTim.Per(P));
  L_General.Assert(L_Staff.IsBegan(P), " "+L_DatTim.PeriodStr(P)+" ࠡ⭨ "+Staff.TSN+"  ਭ  ");
  IF L_General.DoConcurrentModification() THEN
   CONCURRENTRESET(PCalc, TSN,
                    Staff.TSN, P,
                   Done[DmnDoneIdx]);
   IF !PCalc.Saldo THEN
    GETLASTVERSION(PCalc);
    SAVE(PCalc);
    SETSEL(PCalc, TSN, Staff.TSN);
    IF SRCINSEL(PCalc, LT, P) THEN
     GETLASTVERSION(PCalc);
     _Saldo:=OutSaldo(P);
    ELSE
     _Saldo:=0;
    END;
    RESTORE(PCalc);
    PCalc.Saldo :=_Saldo;
    REPLACE(PCalc);
   END;
  ELSE
   IF ~SEARCH(PCalc, TSN, Staff.TSN, P) THEN
    SETSEL(PCalc, TSN, Staff.TSN);
    IF SRCINSEL(PCalc, LT, P) THEN
     _Saldo:=OutSaldo(P);
    ELSE
     _Saldo:=0;
    END;
    DEFAULT(PCalc);
    PCalc.TSN   :=Staff.TSN;
    PCalc.Period:=P;
    PCalc.Saldo :=_Saldo;
    INSERT(PCalc);
   END; (* IF SEARCH ... *)
  END;
  CHANGESEL(PCalc, TSN, , PCalc.TSN);
 END {FixPCalc};

 PUBLIC PROCEDURE SrcPCalc(P: DATE): SCAL[2];
 BEGIN
  L_General.Assert(L_Staff.IsBegan(P), " "+L_DatTim.PeriodStr(P)+" ࠡ⭨ "+Staff.TSN+"  ਭ  ");
  IF SEARCH(PCalc, TSN, Staff.TSN, P) THEN
   RETURN CHANGESEL(PCalc, TSN, PCalc.TSN);
  ELSE
   L_General.Assert(SELECT(PCalc, TSN, Staff.TSN), "   ப 楢 ");
   RETURN SRCINSEL(PCalc, EQ, P);
  END;
 END {SrcPCalc};

 PRIVATE PROCEDURE intSetDone(Idx: tDoneIdx; _Done: SCAL[2]; NeedCheck: SCAL[2]);
 BEGIN
  L_General.Assert(PCalc.Period >= L_Env.aptm_Start, "⨬   ᪠ ⮏");
  IF _Done = 0 THEN
   IF L_General.DoConcurrentModification() THEN
    WHILE ~!Idx DO
     CONCURRENTRESET(PCalc, TSN,
                      PCalc.TSN, PCalc.Period,
                     Done[Idx]);
     IF    Idx = AveDoneIdx THEN
      Idx:=ShtDoneIdx;
     ELSIF Idx = ShtDoneIdx THEN
      Idx:=DedDoneIdx;
     ELSIF Idx = DedDoneIdx THEN
      SETEMPTY(Idx);
     END;
    END; (* WHILE ~!Idx *)
   ELSE
    GETLASTVERSION(PCalc);
    WHILE ~!Idx DO
     PCalc.Done[Idx]:=0;
     IF    Idx = AveDoneIdx THEN
      Idx:=ShtDoneIdx;
     ELSIF Idx = ShtDoneIdx THEN
      Idx:=DedDoneIdx;
     ELSIF Idx = DedDoneIdx THEN
      SETEMPTY(Idx);
     END;
    END; (* WHILE ~!Idx *)
    REPLACE(PCalc);
   END;
  ELSE
   GETLASTVERSION(PCalc);
   PCalc.Done[Idx]:=1;
   IF    Idx = AveDoneIdx THEN
    PCalc.Done[ShtDoneIdx]:=0;
    PCalc.Done[DedDoneIdx]:=0;
   ELSIF Idx = ShtDoneIdx THEN
    L_General.CallUs(PCalc.Done[AveDoneIdx]);
    PCalc.Done[DedDoneIdx]:=0;
   ELSIF Idx = DedDoneIdx THEN
    L_General.CallUs(PCalc.Done[ShtDoneIdx]);
   END;
   PCalc.DoneDate:=SYSDATE();
   REPLACE(PCalc);
  END; (* IF _Done = 0 *)
  IF NeedCheck & (L_DatTim.IncMonth(PCalc.Period, 3) < Salary_ClcPer()) THEN
   L_AcsPnt.PassAccessPoint(0000058);
  END;
 END {intSetDone};

 PRIVATE PROCEDURE SetDone(P: DATE; Idx: tDoneIdx; _Done: SCAL[2]; NeedCheck: SCAL[2]);
 BEGIN
  IF ~!P THEN
   FixPCalc(P);
  END;
  intSetDone(Idx, _Done, NeedCheck);
  SAVE(PCalc);
  WHILE NEXT(PCalc) DO
   intSetDone(AveDoneIdx, 0, NeedCheck);
  END;
  RESTORE(PCalc);
 END {SetDone};

 PUBLIC PROCEDURE AveDone_AP_withoutCheck(P: DATE; _Done: SCAL[2]);
 BEGIN
  SetDone(P, AveDoneIdx, _Done, 0);
 END {AveDone_AP_withoutCheck};

 PUBLIC PROCEDURE AveDone_AP(P: DATE; _Done: SCAL[2]);
 BEGIN
  SetDone(P, AveDoneIdx, _Done, 1);
 END {AveDone_AP};

 PUBLIC PROCEDURE AveDone(_Done: SCAL[2]);
 BEGIN
  AveDone_AP(Memo.gl_mb(), _Done);
 END {AveDone};

 PUBLIC PROCEDURE ShtDone_AP_withoutCheck(P: DATE; _Done: SCAL[2]);
 BEGIN
  SetDone(P, ShtDoneIdx, _Done, 0);
 END {ShtDone_AP_withoutCheck};

 PUBLIC PROCEDURE ShtDone_AP(P: DATE; _Done: SCAL[2]);
 BEGIN
  SetDone(P, ShtDoneIdx, _Done, 1);
 END {ShtDone_AP};

 PUBLIC PROCEDURE ShtDone(_Done: SCAL[2]);
 BEGIN
  ShtDone_AP(Memo.gl_mb(), _Done);
 END {ShtDone};

 PUBLIC PROCEDURE DedDone_AP_withoutCheck(P: DATE; _Done: SCAL[2]);
 BEGIN
  L_General.CallUs(_Done = 0);
  SetDone(P, DedDoneIdx, _Done, 0);
 END {DedDone_AP_withoutCheck};

 PUBLIC PROCEDURE DedDone_AP(P: DATE; _Done: SCAL[2]);
 BEGIN
  L_General.CallUs(_Done = 0);
  SetDone(P, DedDoneIdx, _Done, 1);
 END {DedDone_AP};

 PUBLIC PROCEDURE DedDone(_Done: SCAL[2]);
 BEGIN
  DedDone_AP(Memo.gl_mb(), _Done);
 END {DedDone};

 PUBLIC PROCEDURE SetFinalDone();
 BEGIN
  SetDone(EMPTYOF(DATE), DedDoneIdx, 1, 1);
 END {SetFinalDone};

 PUBLIC PROCEDURE ForcedSetAllDone();
 BEGIN
  PCalc.Done[AveDoneIdx]:=1;
  PCalc.Done[ShtDoneIdx]:=1;
  REPLACE(PCalc);
  SetFinalDone();
 END {ForcedSetAllDone};

 PRIVATE PROCEDURE CheckDone(Idx: tDoneIdx; D: DATE): SCAL[2];
  VAR
   FinalCalcDate: DATE;
   Result       : SCAL[2];
 BEGIN
  Result:=PCalc.Done[Idx] &
          ((PCalc.DoneDate >= L_DatTim.MonthEnd(PCalc.Period)) | (PCalc.DoneDate >= D));
  IF (PCalc.Period>=01\12\2011) & Result THEN (*  楫 ᪮७ 0089293*)
   FinalCalcDate:=GetFinalCalcDate(PCalc.Period);
   Result:=Result & ((D < FinalCalcDate) | (PCalc.DoneDate >= FinalCalcDate));
  END;
  RETURN Result;
 END {CheckDone};

 PUBLIC PROCEDURE IsPrvD(): SCAL[2];
  VAR
   _Done: SCAL[2];
 BEGIN
  FixPCalc(Memo.gl_mb());
  SAVE   (PCalc);
  _Done:=~PREV(PCalc) | CheckDone(DedDoneIdx, SYSDATE());
  RESTORE(PCalc);
  RETURN _Done;
 END {IsPrvD};

 PRIVATE PROCEDURE IsAnyDone_AP_OnDate(Idx: tDoneIdx; P, OnDate: DATE): SCAL[2];
 BEGIN
  TRY
   L_AR.GrantRightsUnconditionally();
   RETURN SrcPCalc(P) & CheckDone(Idx, OnDate);
  EXCEPT
  END; (* TRY *)
 END {IsAnyDone_AP_OnDate};

 PRIVATE PROCEDURE IsAnyDone_AP(Idx: tDoneIdx; P: DATE): SCAL[2];
 BEGIN
  RETURN IsAnyDone_AP_OnDate(Idx, P, SYSDATE());
 END {IsAnyDone_AP};

 PUBLIC PROCEDURE IsAveD(): SCAL[2];
 BEGIN
  RETURN IsAnyDone_AP(AveDoneIdx, Memo.gl_mb());
 END {IsAveD};

 PUBLIC PROCEDURE IsAveD_OnDate(D: DATE): SCAL[2];
 BEGIN
  RETURN IsAnyDone_AP_OnDate(AveDoneIdx, Memo.gl_mb(), D);
 END {IsAveD_OnDate};

 PUBLIC PROCEDURE IsShtD_AP(P: DATE): SCAL[2];
 BEGIN
  RETURN IsAnyDone_AP(ShtDoneIdx, P);
 END {IsShtD_AP};

 PUBLIC PROCEDURE IsShtD(): SCAL[2];
 BEGIN
  RETURN IsShtD_AP(Memo.gl_mb());
 END {IsShtD};

 PUBLIC PROCEDURE IsShtD_OnDate(D: DATE): SCAL[2];
 BEGIN
  RETURN IsAnyDone_AP_OnDate(ShtDoneIdx, Memo.gl_mb(), D);
 END {IsShtD_OnDate};

 PUBLIC PROCEDURE IsDedD_AP(P: DATE): SCAL[2];
 BEGIN
  RETURN IsAnyDone_AP(DedDoneIdx, P);
 END {IsDedD};

 PUBLIC PROCEDURE IsDedD(): SCAL[2];
 BEGIN
  RETURN IsDedD_AP(Memo.gl_mb());
 END {IsDedD};

 PUBLIC PROCEDURE IsDedD_OnDate(D: DATE): SCAL[2];
 BEGIN
  RETURN IsAnyDone_AP_OnDate(DedDoneIdx, Memo.gl_mb(), D);
 END {IsDedD_OnDate};

 PRIVATE PROCEDURE TestSalDone(D: DATE): SCAL[2];
 BEGIN
  RETURN L_APtm.MonthIsClosed(L_DatTim.Per(D), L_APtm.system_Salary) | IsDedD_AP(L_DatTim.Per(D));
 END {TestSalDone};

 PUBLIC PROCEDURE CheckSalDone(D: DATE);
 BEGIN
  L_General.Assert(TestSalDone(D),
                   " 믮  ௫  "+Staff.TSN+"  "+L_DatTim.PeriodStr(L_DatTim.Per(D)));
 END {CheckSalDone};

 PUBLIC PROCEDURE CheckMCodeLegality(trgMCode: LIKE(Money.MCode); trgClosed: LIKE(Money.Closed));
 BEGIN
  IF (trgMCode = L_kn.GetSoft(trgClosed, erkn_MCList_PaidByCash)    ) |
     (trgMCode = L_kn.GetSoft(trgClosed, erkn_MCList_PaidByBank)    ) |
     (trgMCode = L_kn.GetSoft(trgClosed, erkn_MCList_ReturnedByCash)) |
     (trgMCode = L_kn.GetSoft(trgClosed, erkn_MCList_ReturnedByBank)) THEN
   L_General.Error("  ࠡ⭮  ଫ ⮫쪮 १ ⥦ 㬥");
  END;
  TRY [RESTORE_CURSORS(RC_ON)]
   SEARCH(MCList, MCode, , trgMCode);
   L_General.Assert(trgMCode # L_Tax.Get_mc_NDFL(trgClosed, 0), "  " + MCList.MCode + " " + MCList.Name + " 㤥ন ⮫쪮 ⮬᪨");
   L_General.Assert(L_DatTim.IsActive(trgClosed, MCList.Begin, MCList.Till),
                    "  " + MCList.MCode + "    " + L_DatTim.PeriodStr(trgClosed));
  EXCEPT
  END; (* TRY *)
 END {CheckMCodeLegality};

 PUBLIC PROCEDURE CheckMoneyLegality(trgPeriod: LIKE(Money.Period);
                                     trgClosed: LIKE(Money.Closed);
                                     trgMCode : LIKE(Money.MCode);
                                     trgSum   : LIKE(Money.Sum);
                                     trgTim   : LIKE(Money.Tim));
 BEGIN
  SEARCH(MCList, MCode, , trgMCode);
  L_General.Assert((MCList.TimeType = tt_Exclude) | (trgTim # 0),
                   "  / " + MCList.MCode + " " + MCList.Name +
                   "|室 㪠뢠 ६");
  CheckMCodeLegality(trgMCode, trgClosed);
  L_Money.CheckAcAccuracy(trgClosed, trgSum, Staff.TSN);
 END {CheckMoneyLegality};

 PUBLIC PROCEDURE E_MakeMoneyDst(_WFPeriod: DATE): SCAL[2];
 BEGIN
  RETURN _WFPeriod >= 01\12\2009;
 END {E_MakeMoneyDst};

 PUBLIC PROCEDURE UseSalDSet(): SCAL[2];
 BEGIN
  RETURN 1;
  RETURN L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_PRoll.UseSalDSet), 0);
 END {UseSalDSet};

 PUBLIC PROCEDURE E_DoSecondSide(): DATE;
 BEGIN
  IF L_General.IsPolakSpecific() THEN RETURN 01\07\2014;
  ELSE                                RETURN MAXOF(DATE);
  END;
 END {E_DoSecondSide};

 PUBLIC PROCEDURE MakeMoneyStorno(_Source: LIKE(Money.Source));
  VAR
   curODate   : LIKE(Money.ODate);
   curPeriod  : LIKE(Money.Period);
   curWFPeriod: LIKE(Money.WFPeriod);
   curMCode   : LIKE(Money.MCode);
   curTim     : LIKE(Money.Tim);
   curSum     : LIKE(Money.Sum);
   curRECORDID: LIKE(Money.RECORDID);
   curXObject : LIKE(MoneyDst.XObject);
   curAcCut   : LIKE(MoneyDst.AcCut);
   curXDocId  : LIKE(MoneyDst.XDocId);
   curWSS     : LIKE(MoneyDst.wSS);
 BEGIN
  SAVE(Money);
  curODate :=Money.ODate;
  curPeriod  :=Money.Period;
  curWFPeriod:=Money.WFPeriod;
  curMCode   :=Money.MCode;
  curTim     :=Money.Tim;
  curSum     :=L_Money.RoundMoney(Salary_ClcPer(), L_General.Denominate(Money.Closed, Salary_ClcPer(), Money.Sum));
  curRECORDID:=Money.RECORDID;
  IF L_General.DoConcurrentModification() THEN
   CONCURRENTADD(Money, TSN,
                  Staff.TSN, Salary_ClcPer(), curWFPeriod, curODate, curPeriod, curMCode, _Source,
                 Tim, (-1) * curTim,
                 Sum, (-1) * curSum);
  ELSE
   ADD(Money, TSN, , Staff.TSN, Salary_ClcPer(), curWFPeriod, curODate,
                     curPeriod, curMCode, _Source,
                     Money.Tim, (-1) * curTim,
                     Money.Sum, (-1) * curSum);
  END;
  IF E_MakeMoneyDst(curWFPeriod) THEN
   SELECT(MoneyDst, MoneyDst, , curRECORDID);
   WHILE OCCURE(MoneyDst) DO
    curXDocId :=MoneyDst.XDocId;
    curXObject:=MoneyDst.XObject;
    curAcCut  :=MoneyDst.AcCut;
    curWSS    :=MoneyDst.wSS;
    curTim    :=MoneyDst.Tim;
    curSum    :=MoneyDst.Sum;
    SAVE(MoneyDst);
    IF L_General.DoConcurrentModification() THEN
     CONCURRENTADD(MoneyDst, MoneyDst, Money.RECORDID, curXDocId, curXObject, curAcCut, curWSS,
                             Tim, (-1) * curTim,
                             Sum, (-1) * curSum);
    ELSE
     ADD(MoneyDst, MoneyDst, , Money.RECORDID, curXDocId, curXObject, curAcCut, curWSS,
                   MoneyDst.Tim, (-1) * curTim,
                   MoneyDst.Sum, (-1) * curSum);
    END;
    RESTORE(MoneyDst);
    NEXT(MoneyDst);
   END; (* WHILE OCCURE(MoneyDst) *)
  END; (* IF E_MakeMoneyDst ... *)
  RESTORE(Money);
 END {MakeMoneyStorno};

 PUBLIC PROCEDURE detailedSaveMoney_AP(Sign      : NUMERIC[0];
                                       wSS       : LIKE(MoneyDst.wSS);
                                       trgClosed : DATE;
                                       trgMCode  : LIKE(MCList.MCode);
                                       trgPeriod : LIKE(Money.Period);
                                       trgODate  : LIKE(Money.ODate);
                                       trgSource : LIKE(Money.Source);
                                       trgXDocId : LIKE(MoneyDst.XDocId);
                                       trgXObject: LIKE(MoneyDst.XObject);
                                       trgAcCut  : LIKE(MoneyDst.AcCut);
                                   VAR trgSum    : LIKE(Money.Sum);
                                       trgTim    : LIKE(Money.Tim));
  VAR
   dmtXObject: LIKE(XObject.XObject);
 BEGIN
  IF Staff.Contract = L_Staff.cnt_OutStaff THEN
   RETURN;
  END;
  trgSum:=L_Money.RoundMoney(trgClosed, L_General.Denominate(Memo.gl_mb(), trgClosed,
                             L_Money.RoundMoney(Memo.gl_mb(), trgSum)));
  IF trgSum # 0 THEN
   IF L_General.DoConcurrentModification() THEN
    CONCURRENTADD(Money, TSN,
                   Staff.TSN, trgClosed, Memo.gl_mb(), trgODate, trgPeriod, trgMCode, trgSource,
                  Tim, Sign * trgTim,
                  Sum, Sign * trgSum);
   ELSE
    ADD(Money, TSN, , Staff.TSN, trgClosed, Memo.gl_mb(), trgODate, trgPeriod, trgMCode, trgSource,
         Money.Tim, Sign * trgTim,
         Money.Sum, Sign * trgSum);
   END;
   IF E_MakeMoneyDst(Memo.gl_mb()) THEN
    IF wSS & (!trgXObject | !trgAcCut) THEN
     L_General.CallUs(0);
    END;
    IF Memo.gl_mb() >= E_DoSecondSide() THEN
     IF !trgXObject THEN
      GetMCListDstAttr(trgMCode, trgClosed, trgAcCut, trgXObject);
     END;
     IF !trgAcCut THEN
      IF ~!trgXObject THEN
       TRY [RESTORE_CURSORS(RC_ON)]
        SEARCH(XObject, XObject, , trgXObject);
        L_XObj.AccessOrigin();
        IF    XObject.Origin = L_XObj.o_Contract THEN
         trgAcCut:=L_Acnt.GetSpecificAcCutForContract(Contract.Contract, L_Acnt.acp_Contract_Netto);
        ELSIF XObject.Origin = L_XObj.o_CostItem THEN
         trgAcCut:=L_Acnt.GetSpecificAcCutForCostItem(CostItem.CostItem, L_Acnt.acp_CostItem_Default);
        END;
       EXCEPT
       END; (* TRY *)
      ELSE
       GetMCListDstAttr(trgMCode, trgClosed, trgAcCut, dmtXObject);
      END;
      IF !trgAcCut THEN
       L_StdFrm.WrongDB("    " + trgMCode + ":  ।  ࠧ१");
      END;
     END;
    END;
    IF L_General.DoConcurrentModification() THEN
     CONCURRENTADD(MoneyDst, MoneyDst,
                    Money.RECORDID, trgXDocId, trgXObject, trgAcCut, wSS,
                   Tim, Sign * trgTim,
                   Sum, Sign * trgSum);
    ELSE
     ADD(MoneyDst, MoneyDst, ,
                    Money.RECORDID, trgXDocId, trgXObject, trgAcCut, wSS,
          MoneyDst.Tim, Sign * trgTim,
          MoneyDst.Sum, Sign * trgSum);
    END;
   END;
  END;
 END {detailedSaveMoney_AP};

 PUBLIC PROCEDURE detailedSaveMoney(Sign    : NUMERIC[0];
                                    trgMCode  : LIKE(MCList.MCode);
                                    trgPeriod : LIKE(Money.Period);
                                    trgODate  : LIKE(Money.ODate);
                                    trgSource : LIKE(Money.Source);
                                    trgXDocId : LIKE(MoneyDst.XDocId);
                                    trgXObject: LIKE(MoneyDst.XObject);
                                    trgAcCut  : LIKE(MoneyDst.AcCut);
                                VAR trgSum    : LIKE(Money.Sum);
                                    trgTim    : LIKE(Money.Tim));
 BEGIN
  detailedSaveMoney_AP(Sign, 0, Salary_ClcPer(), trgMCode, trgPeriod, trgODate, trgSource,
                       trgXDocId, trgXObject, trgAcCut,
                       trgSum, trgTim);
 END {detailedSaveMoney};

 PUBLIC PROCEDURE SaveMoney(Sig: NUMERIC[0];
                            cod: LIKE(MCList.MCode);
                            prd: LIKE(Money.Period);
                            src: LIKE(Money.Source);
                        VAR sum: LIKE(Money.Sum);
                            tim: LIKE(Money.Tim));
 BEGIN
  detailedSaveMoney(Sig, cod, prd, StaffLog.Date, src, EMPTYOF(MoneyDst.XDocId), EMPTYOF(MoneyDst.XObject), EMPTYOF(MoneyDst.AcCut), sum, tim);
 END {SaveMoney};

 PUBLIC PROCEDURE ClearZeroMoneyDst();
 BEGIN
  SETSEL(MoneyDst, MoneyDst, Money.RECORDID);
  FOR_EACH MoneyDst DO
   IF (MoneyDst.Tim = 0) & (MoneyDst.Sum = 0) THEN
    REMOVE(MoneyDst);
   END;
  END; (* FOR_EACH MoneyDst ... *)
 END {ClearZeroMoneyDst};

 PUBLIC PROCEDURE extRemove_Money(wRemove, KeepMoneyDst: SCAL[2]);
  VAR
   curTim: LIKE(MoneyDst.Tim);
   curSum: LIKE(MoneyDst.Sum);
 BEGIN
  IF SELECT(eMoney, ori, Money.RECORDID) THEN
   L_General.Error("    '⥫쭠 ଠ'. 室 ࠧ" +
                   "||" +
                   "(ࠡ⭨ " + Money.TSN + ",  " + L_DatTim.PeriodStr(Money.Closed) + ",  / " + Money.MCode);
  END;
  IF KeepMoneyDst THEN
   ClearZeroMoneyDst();
   IF SELECT(MoneyDst, MoneyDst, Money.RECORDID) THEN
    SETZERO(curTim, curSum);
    FOR_EACH MoneyDst DO
     INC(curTim, MoneyDst.Tim);
     INC(curSum, MoneyDst.Sum);
    END;
    L_General.CallUs((curTim = 0) & (curSum = 0));
    IF Money.WFPeriod <= Money.Closed THEN
     IF Money.WFPeriod >= E_DoSecondSide() THEN
      wRemove:=0;
     ELSE
      KeepMoneyDst:=0;
     END;
    ELSE
     L_General.CallUs(0);
    END;
   END;
  END; (* IF KeepMoneyDst *)
  IF ~KeepMoneyDst THEN
   SELECT(MoneyDst, MoneyDst, , Money.RECORDID);
   REMSEL(MoneyDst);
  END;
  IF wRemove THEN
   REMOVE(Money);
  ELSE
   SETZERO(Money.Tim, Money.Sum);
   REPLACE(Money);
  END; (* IF wRemove *)
 END {extRemove_Money};

 PUBLIC PROCEDURE Remove_Money(wRemove: SCAL[2]);
 BEGIN
  extRemove_Money(wRemove, 0);
 END {Remove_Money};

 PUBLIC PROCEDURE Paste_Money(NewODate: DATE);
  VAR
   _TSN     : LIKE(Money.TSN);
   _Closed  : LIKE(Money.Closed);
   _WFPeriod: LIKE(Money.WFPeriod);
   _Period  : LIKE(Money.Period);
   _MCode   : LIKE(Money.MCode);
   _Source  : LIKE(Money.Source);
   _Tim     : LIKE(Money.Tim);
   _Sum     : LIKE(Money.Sum);
   _RECORDID: LIKE(Money.RECORDID);
   _XDocId  : LIKE(MoneyDst.XDocId);
   _XObject : LIKE(MoneyDst.XObject);
   _AcCut   : LIKE(MoneyDst.AcCut);
   _WSS     : LIKE(MoneyDst.wSS);
 BEGIN
  SAVE(Money);
  _TSN     :=Money.TSN;
  _Closed  :=Money.Closed;
  _WFPeriod:=Money.WFPeriod;
  _Period  :=Money.Period;
  _MCode   :=Money.MCode;
  _Source  :=Money.Source;
  _Tim     :=Money.Tim;
  _Sum     :=Money.Sum;
  _RECORDID:=Money.RECORDID;
  ADD(Money, TSN, ,
             _TSN, _Closed, _WFPeriod, NewODate, _Period, _MCode, _Source,
             Money.Tim, _Tim,
             Money.Sum, _Sum);
  WHILE SELECT(MoneyDst, MoneyDst, _RECORDID) DO
   _XDocId :=MoneyDst.XDocId;
   _XObject:=MoneyDst.XObject;
   _AcCut  :=MoneyDst.AcCut;
   _WSS    :=MoneyDst.wSS;
   _Tim    :=MoneyDst.Tim;
   _Sum    :=MoneyDst.Sum;
   REMOVE(MoneyDst);
   ADD(MoneyDst, MoneyDst, , Money.RECORDID, _XDocId, _XObject, _AcCut, _WSS,
             MoneyDst.Tim, _Tim,
             MoneyDst.Sum, _Sum);
  END;
  RESTORE(Money);
  Remove_Money(1);
 END {Paste_Money};

 PRIVATE PROCEDURE intMultipleClearMoney(_SourcesToClear: SCAL[2][]; Through: SCAL[2]);
 BEGIN
  SETSEL(Money, TSN, Staff.TSN);
  SRCINSEL(Money, GE, , Salary_ClcPer());
  WHILE OCCURE(Money) DO
   IF ((Money.WFPeriod = Memo.gl_mb()) | (Through & (Money.WFPeriod > Memo.gl_mb()))) & _SourcesToClear[Money.Source] THEN
    Remove_Money(0);
   END;
   NEXT(Money);
  END; (* WHILE OCCURE(Money) ... *)
  IF ~Salary_Clc_CntIsEqual() THEN
   SETSEL(Money, TSN, Staff.TSN);
   SRCINSEL(Money, GE, , Memo.gl_mb());
   WHILE OCCURE(Money) & (Money.Closed < Salary_ClcPer()) DO
    IF ((Money.WFPeriod = Memo.gl_mb()) | (Through & (Money.WFPeriod > Memo.gl_mb()))) & _SourcesToClear[Money.Source] THEN
     MakeMoneyStorno(Money.Source);
    END;
    NEXT(Money);
   END; (* WHILE OCCURE(Money) ... *)
  END; (* IF Clc ... *)
 END {intMultipleClearMoney};

 PUBLIC PROCEDURE MultipleClearMoney(_SourcesToClear: SCAL[2][]);
 BEGIN
  intMultipleClearMoney(_SourcesToClear, 0);
 END {MultipleClearMoney};

 PUBLIC PROCEDURE xClearMoney(trgSource: LIKE(Money.Source); Through: SCAL[2]);
  VAR
   curSourcesToClear: SCAL[2][MAXOF(Money.Source)+1];
 BEGIN
  SETZERO(curSourcesToClear);
  curSourcesToClear[trgSource]:=1;
  intMultipleClearMoney(curSourcesToClear, Through);
 END {xClearMoney};

 PUBLIC PROCEDURE ClearMoney(trgSource: LIKE(Money.Source));
 BEGIN
  xClearMoney(trgSource, 0);
 END {ClearMoney};

 PUBLIC PROCEDURE OutSaldo(OP: DATE): NUMERIC [2];
 BEGIN
  RETURN L_General.Denominate(PCalc.Period, OP, PCalc.Saldo+PCalc.Incr-PCalc.Decr);
 END {OutSaldo};

 PUBLIC PROCEDURE GetInSaldo(D: DATE): NUMERIC[2];
 BEGIN
  SETSEL(PCalc, TSN, Staff.TSN);
  IF SRCINSEL(PCalc, EQ, L_DatTim.Per(D)) THEN
   RETURN PCalc.Saldo;
  ELSE
   RETURN 0;
  END;
 END {GetInSaldo};

 PUBLIC PROCEDURE GetOutSaldo(D: DATE): NUMERIC[2];
 BEGIN
  SETSEL(PCalc, TSN, Staff.TSN);
  IF SRCINSEL(PCalc, EQ, L_DatTim.Per(D)) THEN
   RETURN OutSaldo(D);
  ELSE
   RETURN 0;
  END;
 END {GetOutSaldo};

 PRIVATE PROCEDURE intOutSaldoFutInc(P, OP: DATE; NeedFutInc: SCAL[2]): tSum;
 BEGIN
  L_General.Assert(SrcPCalc(P), "  ப 楢   " + L_DatTim.PeriodStr(P));
  IF NeedFutInc THEN
   RETURN OutSaldo(OP)+L_General.Denominate(PCalc.Period, OP, PCalc.FutInc);
  ELSE
   RETURN OutSaldo(OP);
  END;
 END {intOutSaldoFutInc};

 PUBLIC PROCEDURE OutSaldoFutInc(P, OP: DATE; NeedFutInc: SCAL[2]): tSum;
 BEGIN
  P:=L_DatTim.Per(P);
  CheckSalDone(P);
  RETURN intOutSaldoFutInc(P, OP, NeedFutInc);
 END {OutSaldoFutInc};

 PUBLIC PROCEDURE OutSaldoFutInc_OnDate(D, OP: DATE; NeedFutInc: SCAL[2]): tSum;
 BEGIN
  L_General.Assert(IsDedD_OnDate(D),
                   " 믮  ௫  "+Staff.TSN+"  "+L_DatTim.DateStr(D));
  RETURN intOutSaldoFutInc(L_DatTim.Per(D), OP, NeedFutInc);
 END {OutSaldoFutInc_OnDate};

 PUBLIC PROCEDURE TruncMoneyTo(S: tSum; _TruncTo: tSum): tSum;
  VAR
   DummyS,
   DummyTo: NUMERIC[0];
 BEGIN
  IF S > 0 THEN
   DummyTo:=_TruncTo * 100;
   DummyS  :=S       * 100;
   RETURN DummyS DIV DummyTo * DummyTo / 100;
  ELSE
   RETURN 0;
  END;
 END {TruncMoneyTo};

 PUBLIC PROCEDURE TruncMoney(P: DATE; S: tSum): tSum;
 BEGIN
  RETURN TruncMoneyTo(S, P_OwnData.TruncTo(P));
 END {TruncMoney};

 PUBLIC PROCEDURE BalPCalc(): NUMERIC[2];
  VAR
   _Saldo: LIKE(PCalc.Saldo);
 BEGIN
  LOOP _Saldo := OutSaldo(L_DatTim.IncMonth(PCalc.Period, +1));
   REPLACE(PCalc); NEXT(PCalc);
   IF ~OCCURE(PCalc) THEN
    RETURN _Saldo;
   END;
   PCalc.Saldo:=_Saldo;
  END; (* LOOP *)
 END {BalPCalc};

 PUBLIC PROCEDURE GetMethod(_Date   : DATE;
                            _MthType: LIKE(MthType.MthType)): LIKE(Methods.Method);
  VAR
   _Method: LIKE(MoneyMth.Method);
 BEGIN
  CONFORM(StaffLog, Officer);
  IF SEARCH(Methods, PayKind, Officer.PayKind, _MthType) THEN
   CONFORM(Officer, PayKind);
   L_General.Assert(L_DatTim.IsActive(_Date, PayKind.Begin, PayKind.Till) | ~L_Staff.OrderInMonth(L_DatTim.Per(_Date)),
                    "  " + PayKind.PayKind + " " + PayKind.Name +
                    "|   " + L_DatTim.PeriodStr(_Date));
   RETURN Methods.Method;
  ELSE
   _Method:=_MthType + "00";
   L_General.Assert(SEARCH(MoneyMth, MoneyMth, _Method), " ᠭ ⮤ " + _Method);
   RETURN _Method;
  END;
 END {GetMethod};

 PUBLIC PROCEDURE PositionOnMCList(_MCode: LIKE(MCList.MCode));
 BEGIN
  L_General.CallUs(SEARCH(MCList, MCode, _MCode));
 END {PositionOnMCList};

 PRIVATE PROCEDURE TakenFrom(P: DATE): NUMERIC[2];
  VAR
   _Taken: NUMERIC[2];
 BEGIN
  _Taken:=0;
  SAVE(PDoc);
  SAVE(PDocList);
  SETSEL(PDocList, TSN, Staff.TSN);
  SRCINSEL(PDocList, GE, , P);
  WHILE OCCURE(PDocList) DO
   IF PDocList.State = 0 THEN
    CONFORM(PDocList, PDoc);
    IF (PDoc.Source # L_PDoc.src_InProgress) & (PDoc.Status < L_PDoc.st_Canceled) THEN
     IF L_PDoc.IsSalPDoc() & (PDoc.Type # L_PDoc.typ_Other) THEN
      L_PDoc.CheckDone();
      INC(_Taken, L_General.Denominate(L_DatTim.Per(PDocList.PDocDate),
                                       L_DatTim.Per(SYSDATE()), PDocList.Sum));
     END;
    END;
   END;
   NEXT(PDocList);
  END; (* WHILE OCCURE(PDocList)... *)
  RESTORE(PDocList);
  RESTORE(PDoc);
  RETURN _Taken;
 END {TakenFrom};

 PUBLIC PROCEDURE Limit_ToTake(    P         : DATE;
                               VAR _ToTake, _Taken, _Remind: NUMERIC[2];
                                   NeedFutInc: SCAL[2]);
  VAR
   S: NUMERIC[2];
 BEGIN
  S:=OutSaldoFutInc(P, L_DatTim.Per(SYSDATE()), NeedFutInc);
  IF S > 0 THEN
   _Taken:=Math.Min(TakenFrom(L_DatTim.IncMonth(P, +1)), S);
   DEC(S, _Taken);
   IF L_Staff.rInState(SYSDATE()+1) THEN
    _ToTake:=TruncMoney(L_DatTim.Per(SYSDATE()), S);
   ELSE
    _ToTake:=S;
   END;
  ELSE
   SETZERO(_ToTake, _Taken);
  END;
  _Remind:=S - _ToTake;
 END {Limit_ToTake};

 PUBLIC PROCEDURE Get_ToTakeEO(P: DATE): NUMERIC[2];
  VAR
   Dump1,
   Dump2,
   _ToTake: NUMERIC[2];
 BEGIN
  Limit_ToTake(P, _ToTake, Dump1, Dump2, 1); RETURN _ToTake;
 END {Get_ToTakeEO};

 PUBLIC PROCEDURE extDefMC_Code(trgProtInNbr  : SCAL[8];
                                D             : DATE;
                                VAR MC_Code: LIKE(MCList.ProtIn[0])[];
                                VAR Mon_Idx: LIKE(MCList.MCode)[]): SCAL[2];
  VAR
   h,
   i : NUMERIC[0];
   Result: SCAL[2];
 BEGIN
  Result:=0;
  L_General.CallUs(HIGH(Mon_Idx) = MAXOF(MCList.MCode));
  SETEMPTY(MC_Code, Mon_Idx);
  i:=0;
  h:=HIGH(MC_Code);
  MC_Code[h]:="祥";
  SELECT(MCList, MCode);
  WHILE OCCURE(MCList) DO
   IF ~!MCList.ProtIn[trgProtInNbr] &
      L_DatTim.IsActive(L_DatTim.Per(D), MCList.Begin, MCList.Till) THEN
    IF (i < h) THEN
     MC_Code[i]:=MCList.ProtIn[trgProtInNbr];
     Mon_Idx[MCList.MCode]:=i;
    ELSE
     Mon_Idx[MCList.MCode]:=h;
     Result:=1;
    END;
    INC(i);
   ELSE
    Mon_Idx[MCList.MCode]:=h;
   END;
   NEXT(MCList);
  END; (* WHILE OCCURE(MCList) ... *)
  RETURN Result;
 END {extDefMC_Code};

 PUBLIC PROCEDURE DefMC_Code(trgProtInNbr  : SCAL[8];
                             D             : DATE;
                             VAR MC_Code: LIKE(MCList.ProtIn[0])[];
                             VAR Mon_Idx: LIKE(MCList.MCode)[]);
  VAR
   Dummy: SCAL[2];
 BEGIN
  Dummy:=extDefMC_Code(trgProtInNbr, D, MC_Code, Mon_Idx);
 END {DefMC_Code};

 PRIVATE PROCEDURE E_GetPersAddCode(D: DATE): NUMERIC[0];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_PRoll.GetPersAddCode), 15);
 END {E_GetPersAddCode};

 PUBLIC PROCEDURE GetPersAddValue(D: DATE): LIKE(Adding.Value);
  VAR
   _D: DATE;
 BEGIN
  _D:=Math.Max(D, StaffLog.Date);
  SETSEL(Adding, TSN, Staff.TSN, E_GetPersAddCode(D));
  IF SRCINSEL(Adding, LE, _D) & (!Adding.UpTo | (_D <= Adding.UpTo))  THEN
   RETURN Adding.Value;
  ELSE
   RETURN 0;
  END;
 END {GetPersAddValue};

 PUBLIC PROCEDURE AccessWagePayL(P: DATE);
 BEGIN
  L_General.Assert(OCCURE(WagePayL), "  䭠 ⪠ "+WagePay.WagePay+"  "+L_DatTim.PeriodStr(P));
 END {AccessWagePayL};

 PUBLIC PROCEDURE GetManyHMPay(D: DATE; HBal: LIKE(PCalc.HBal); VAR HPay, HPayAvrgBal, MPay: NUMERIC[3]);
 BEGIN
  IF E_UsePersMPay(D) & (GetPersAddValue(D) # 0) THEN
   L_General.Assert(HBal>0, "ଠ ६    ");
   MPay:=Adding.Value; HPay:=MPay/HBal; HPayAvrgBal:=MPay/AverageMonthHBal(L_DatTim.Per(D));
  ELSE
   AccessWagePayL(D);
   IF WagePayL.Type = wplType_Tariff THEN
    IF E_UseMCFixPay(0, D) THEN
     HPay:=L_AP.MCFixPay(Math.Max(D, StaffLog.Date));
    ELSE
     HPay:=WagePayL.Pay[StaffLog.Class];
    END;
    HPayAvrgBal:=HPay;
    MPay:=HPay*HBal;
   ELSE
    MPay:=WagePayL.Pay[StaffLog.Class];
    IF MPay # 0 THEN
     L_General.Assert(HBal>0, "ଠ ६    ");
     HPay:=MPay/HBal;
    ELSE
     HPay:=0;
    END;
    HPayAvrgBal:=MPay/AverageMonthHBal(L_DatTim.Per(D));
   END;
  END;
 END {GetManyHMPay};

 PUBLIC PROCEDURE GetHMPay(D: DATE; HBal: LIKE(PCalc.HBal); VAR HPay, MPay: NUMERIC[3]);
  VAR
   DummyHPay: NUMERIC[3];
 BEGIN
  GetManyHMPay(D, HBal, HPay, DummyHPay, MPay);
 END {GetHMPay};

 PRIVATE PROCEDURE SelectOperatingMoneyRul(D: DATE; M: LIKE(MoneyMth.Method));
 BEGIN
  L_General.Assert(SELECT(MoneyMth, MoneyMth, M), " ᠭ ⮤ " + M);
  L_General.Assert(L_DatTim.IsActive(D, MoneyMth.Begin, MoneyMth.Till),
                  '⮤ "' + M + '"    ' + L_DatTim.PeriodStr(D));
  HISTCONF(D, MoneyMth, MMthLog);
  CONFORM(MMthLog, MoneyRul);
 END {SelectOperatingMoneyRul};

 PUBLIC PROCEDURE ExecMethod(D            : DATE;
                             _Method      : LIKE(MoneyMth.Method);
                             ProceedSingle: PROC;
                             Prepare      : PROC);
 BEGIN
  SelectOperatingMoneyRul(D, _Method);
  IF !Prepare | Prepare() THEN
   WHILE OCCURE(MoneyRul) DO
    ProceedSingle();
    NEXT(MoneyRul);
   END;
  END;
 END {ExecMethod};

 PUBLIC PROCEDURE ClearMoneyFromXCalc();
 BEGIN
  IF Memo.gl_mb() < E_DoSecondSide() THEN
   L_XObj.AccessManXObject(Staff.Man, Staff.MyFirm);
   L_XObj.ClearXApport(L_XObj.s_Payments, L_XObj.src_Salary);
   SAVE(Staff);
   SETSEL(Staff, MyFirm, Staff.MyFirm, Staff.Man);
   FOR_EACH Staff DO
    L_XObj.AccessXObjectByOrigin(L_XObj.o_Staff);
    L_XObj.ClearXApport(L_XObj.s_Payments, L_XObj.src_Salary);
   END; (* FOR_EACH Staff *)
   RESTORE(Staff);
  END;
 END {ClearMoneyFromXCalc};

 PRIVATE PROCEDURE E_MCodeToKeepInXCalc(P: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
   Local : PROC;
 BEGIN
  Result:=0;
  Local:=PROCREF(E_PRoll.MCodeToKeepInXCalc);
  IF ~!Local THEN
   Result:=Local(P);
  ELSIF UseSalDSet() THEN
   P_MCList.StandOnDstMode(MCList.MCode, P);
   Result:=DstMode.MnMth = dmmm_byManXCalc;
  END;
  RETURN Result;
 END {E_MCodeToKeepInXCalc};

 PUBLIC PROCEDURE GetSalaryAcCut(D: DATE): LIKE(AcCut.AcCut);
  VAR
   trgNotion: L_APtm.tNotion;
 BEGIN
  IF Staff.Contract = L_Staff.cnt_ContractorsAgreement THEN
   trgNotion:=L_AcCut.erkn_Salary_CA;
  ELSE
   trgNotion:=L_AcCut.erkn_Salary;
  END;
  RETURN L_AcCut.erkn_Get(D, trgNotion);
 END {GetSalaryAcCut};

 PUBLIC PROCEDURE KeepMoneyInXCalc(trgSum: LIKE(Money.Sum));
  VAR
   trgApport  : LIKE(Apport.Apport);
   trgAcCut   : LIKE(AcCut.AcCut);
   dmyCostItem: LIKE(CostItem.CostItem);
 BEGIN
  IF Memo.gl_mb() < E_DoSecondSide() THEN
   IF (Money.Source # src_XCalc) & E_MCodeToKeepInXCalc(Money.Closed) THEN
    trgAcCut:=GetMCListAcCut(Money.MCode, Money.Closed);
    L_XObj.AccessManXObject(Staff.Man, Staff.MyFirm);
    IF MCList.MCTyp = mct_Credit THEN trgApport:=L_Acnt.E_Apport_MoneyDebit(Money.Closed);
    ELSE                              trgApport:=L_Acnt.E_Apport_MoneyCredit(Money.Closed);
    END;
    L_XObj.mo_MakeCir(+1,
                      trgAcCut,
                      Money.Closed,
                      trgApport,
                      GetSalaryAcCut(Money.Closed),
                      trgSum,
                      L_XObj.src_Salary);
   END;
  END;
 END {KeepMoneyInXCalc};

 PUBLIC PROCEDURE FillShedule(_ShdlType   : LIKE(RegHead.ShdlType);
                              VAR _BegTime: LIKE(RegHead.BegTime);
                              VAR _EndTime: LIKE(RegHead.EndTime);
                              VAR _DnrBegT: LIKE(RegHead.DnrBegT);
                              VAR _DnrEndT: LIKE(RegHead.DnrEndT));
 BEGIN
  L_General.Assert(OCCURE(RegHead), "ࠢ쭮 ᯮ짮 FillShedule");
  IF    _ShdlType = rgs_Month THEN
   _BegTime:=RegHead.BegTime;
   _EndTime:=RegHead.EndTime;
   _DnrBegT[0]:=RegHead.DnrBegT[0];
   _DnrEndT[0]:=RegHead.DnrEndT[0];
   _DnrBegT[1]:=RegHead.DnrBegT[1];
   _DnrEndT[1]:=RegHead.DnrEndT[1];
   _DnrBegT[2]:=RegHead.DnrBegT[2];
   _DnrEndT[2]:=RegHead.DnrEndT[2];
  ELSIF (_ShdlType = rgs_Daily) THEN
   L_General.Assert(OCCURE(RegList), "ࠢ쭮 ᯮ짮 FillShedule");
   _BegTime:=RegList.BegTime;
   _EndTime:=RegList.EndTime;
   _DnrBegT[0]:=RegList.DnrBegT[0];
   _DnrEndT[0]:=RegList.DnrEndT[0];
   _DnrBegT[1]:=RegList.DnrBegT[1];
   _DnrEndT[1]:=RegList.DnrEndT[1];
   _DnrBegT[2]:=RegList.DnrBegT[2];
   _DnrEndT[2]:=RegList.DnrEndT[2];
  ELSE
   SETEMPTY( _BegTime, _EndTime, _DnrBegT, _DnrEndT);
  END;
 END {FillShedule};

(*-------------BEGIN OF NORMAL ENVIRONMENT--------------------------*)

 PUBLIC PROCEDURE E_SMAmountOnA4(P: DATE): NUMERIC[0];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(P, PROCREF(E_PRoll.SMAmountOnA4), 2);
 END {E_SMAmountOnA4};

 PUBLIC PROCEDURE E_PostTaxValue(P: DATE): NUMERIC[5];
 BEGIN
  IF P >= 01\10\1999 THEN
   RETURN L_EC.ExecE_Func_Numeric(P, PROCREF(E_PRoll.PostTaxValue), 0.08);
  ELSE
   RETURN L_EC.ExecE_Func_Numeric(P, PROCREF(E_PRoll.PostTaxValue), 0.10);
  END;
 END {E_PostTaxValue};

 PUBLIC PROCEDURE E_FitOnA5_AvePayReport(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_PRoll.FitOnA5_AvePayReport), 1);
 END {E_FitOnA5_AvePayReport};

 PUBLIC PROCEDURE E_ReflectEDOrder(P: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(P, PROCREF(E_PRoll.ReflectEDOrder), 0);
 END {E_ReflectEDOrder};

 PRIVATE VAR
  DistrVersion: NUMERIC[0];

 PRIVATE PROCEDURE E_DistrVersionsAmount(D: DATE): NUMERIC[0];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Distr.DistrVersionsAmount), 1);
 END {E_DistrVersionsAmount};

 PUBLIC PROCEDURE E_DistrVersionName(D: DATE): STRING[];
 BEGIN
  IF E_DistrVersionsAmount(D) = 1 THEN
   RETURN " ࠡ⭨";
  ELSE
   RETURN E_Distr.DistrVersionName(D);
  END;
 END {E_DistrVersionName};

 PUBLIC PROCEDURE E_DistrNeedOfficer(D: DATE; _Sort: LIKE(Officer.Sort); _Officer: LIKE(Officer.Officer)): SCAL[2];
 BEGIN
  IF E_DistrVersionsAmount(D) = 1 THEN
   RETURN 1;
  ELSE
   RETURN E_Distr.DistrNeedOfficer(D, _Sort, _Officer);
  END;
 END {E_DistrNeedOfficer};

 PUBLIC PROCEDURE GetDistrVersion(): NUMERIC[0];
 BEGIN
  RETURN DistrVersion;
 END {GetDistrVersion};

 PUBLIC PROCEDURE SetDistrVersion(D: DATE; ToDo: STRING[]);
  VAR
   S: STRING[];
 BEGIN
  IF E_DistrVersionsAmount(D) > 1 THEN
   S:=ToDo+"|";
   DistrVersion:=0;
   WHILE DistrVersion < E_DistrVersionsAmount(D) DO
    S:=S+"|%<"+Str.Align(Str.Cap(E_DistrVersionName(D), 0, 1), 50, CENTRE)+">B";
    INC(DistrVersion);
   END;
   S:=S+"|%<"+Str.Align("⬥", 50, CENTRE)+">Z";
   DistrVersion:=STDFORM(S, , INFORM);
   DEC(DistrVersion);
  ELSE
   DistrVersion:=0;
  END;
 END {SetDistrVersion};

 PUBLIC PROCEDURE IsAcceptableManForCurrentDistrVersion(): SCAL[2];
 BEGIN
  IF GetDistrVersion() # 0 THEN
   SELECT(Staff, Man, , Man.Man);
   WHILE OCCURE(Staff) DO
    IF L_Staff.IsMainForTax(Memo.ud_ut()) THEN
     HISTCONF(Memo.ud_ut(), Staff, StaffLog);
     RETURN E_DistrNeedOfficer(Memo.ud_ut(), StaffLog.Sort, StaffLog.Officer);
    END;
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
  END;
  RETURN 1;
 END {IsAcceptableManForCurrentDistrVersion};

 PUBLIC PROCEDURE CheckMCListDistr(Interactive: SCAL[2]);
 BEGIN
  IF ~UseSalDSet() THEN
   CONFORM(MCList, DstMode);
   IF (MCList.MCTyp = mct_Debit) & Interactive & (DstMode.MnMth = dmmm_byOfficer) THEN
    L_StdFrm.Choice("ঠ ।  ࠡ稬 ⠬?");
   END;
   L_General.Assert((DstMode.MnMth = dmmm_byOfficer) = (MCList.AcCut=L_Acnt.fictAcCut),
                     "ࠢ쭮  ᯮᮡ ।  ࠧ१   " + MCList.MCode);
  END;
 END {CheckMCListDistr};

 PUBLIC PROCEDURE RegionalCoeff(D: DATE): NUMERIC[3];
 BEGIN
  IF L_Env.Region = L_Russia.reg_72 THEN
   RETURN 1.150;
  ELSE
   RETURN 1.000;
  END;
 END {RegionalCoeff};

 PUBLIC PROCEDURE AverageMonthHBal(P: DATE): LIKE(PCalc.HBal);
 BEGIN
  IF    (L_DatTim.YEAR(P) = 2014) | (L_DatTim.YEAR(P) = 2013) THEN
   RETURN 164.167;
  ELSIF L_DatTim.YEAR(P) = 2012 THEN
   RETURN 165.500;
  ELSIF L_DatTim.YEAR(P) = 2011 THEN
   RETURN 165.083;
  ELSIF (L_DatTim.YEAR(P) = 2010) | (L_DatTim.YEAR(P) = 2009) THEN
   RETURN 165.583;
  ELSIF L_DatTim.YEAR(P) = 2008 THEN
   RETURN 166.083;
  ELSIF L_DatTim.YEAR(P) = 2007 THEN
   RETURN 165.500;
  ELSIF L_DatTim.YEAR(P) < 2007 THEN
   RETURN 165.500; (**)
  ELSE
   L_General.InformUs(" । ।筠 ଠ ६  "+FLDTOSTR(P, "y")+" ");
  END;
 END {AverageMonthHBal};

 PUBLIC PROCEDURE AverageMonthDBal(P: DATE): NUMERIC[0];
 BEGIN
  IF    (L_DatTim.YEAR(P) = 2010) | (L_DatTim.YEAR(P) = 2009) THEN
   RETURN 20.75;                    (*249  / 12 楢*)
  ELSE
   L_General.CallUs(0);
  END;
 END {AverageMonthDBal};

 PUBLIC PROCEDURE E_DeadMonthForPaySheet(D: DATE): NUMERIC[0];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_PRoll.DeadMonthForPaySheet), -1);
 END {E_DeadMonthForPaySheet};

 PUBLIC PROCEDURE E_StatesForTaxSameAs643(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_PRoll.StatesForTaxSameAs643), 0);
 END {E_StatesForTaxSameAs643};

 PUBLIC PROCEDURE E_GetLoanProfitAcCut(P: DATE): NUMERIC[0];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(P, PROCREF(E_PRoll.GetLoanProfitAcCut), 890);
 END {E_GetLoanProfitAcCut};

 PUBLIC PROCEDURE E_IsLeaveInPaySheet(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_PRoll.IsLeaveInPaySheet), 0);
 END {E_IsLeaveInPaySheet};

 PUBLIC PROCEDURE E_MPD_PCalc_NeedFutInc(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_PRoll.MPD_PCalc_NeedFutInc), 1);
 END {E_MPD_PCalc_NeedFutInc};

 PUBLIC PROCEDURE E_NeedCashIssueStatement(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_PRoll.NeedCashIssueStatement), 1);
 END {E_NeedCashIssueStatement};

 PUBLIC PROCEDURE E_MethodOfPDocToMoney(D: DATE): SCAL[16];
 BEGIN
(* ਭ樯 ࠦ 믫  ⭮  *)
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_PRoll.MethodOfPDocToMoney), pdtom_PaidOnly);
 END {E_MethodOfPDocToMoney};

 PUBLIC PROCEDURE E_IndividualAddingCalc(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_PRoll.IndividualAddingCalc), 1);
 END {E_IndividualAddingCalc};

 PUBLIC PROCEDURE ByCassaLev(trgEvent: L_PDoc.tEvent): SCAL[2];
 BEGIN
  (* 砨,    㬮砭   *)
  (*  ᠬ (  騬 ᯨ᪮)                  *)
  RETURN (trgEvent = L_PDoc.ev_MainPay) | (trgEvent = L_PDoc.ev_AdvnPay);
 END {ByCassaLev};

 PUBLIC PROCEDURE E_UsePersMPay(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_PRoll.UsePersMPay), 0);
 END {E_UsePersMPay};

 PUBLIC PROCEDURE E_UseMCFixPay(Generally: SCAL[2]; D: DATE): SCAL[2];
  VAR
   local: PROC;
 BEGIN
  local:=PROCREF(E_PRoll.UseMCFixPay);
  IF ~!local THEN
   RETURN local(Generally, D);
  ELSE
   RETURN 0;
  END;
 END {E_UseMCFixPay};

 PUBLIC PROCEDURE E_GetTradeUnionMCode(D: DATE): NUMERIC[0];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_PRoll.GetTradeUnionMCode), 102);
 END {E_GetTradeUnionMCode};

 PUBLIC PROCEDURE HasTradeUnionDeduct(trgTSN : LIKE(Staff.TSN);
                                      trgDate: DATE): SCAL[2];
 BEGIN
  SELECT(Deduct, MCode, , E_GetTradeUnionMCode(trgDate), trgTSN);
  WHILE OCCURE(Deduct) DO
   IF L_DatTim.IsActive_Inc(trgDate, Deduct.BegDate, Deduct.EndDate) THEN
    RETURN 1;
   END;
   NEXT(Deduct);
  END; (* WHILE OCCURE(Deduct) ... *)
  RETURN 0;
 END {HasTradeUnionDeduct};

 PUBLIC PROCEDURE E_SpecifiedHld(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_PRoll.SpecifiedHld), 0);
 END {E_SpecifiedHld};

 PRIVATE PROCEDURE _StaffCountUp();
 BEGIN
  CALL(CalcDed.CountUp_Stream());
 END {_StaffCountUp};

 PRIVATE PROCEDURE intStaffCountUp(trgTSN: LIKE(Staff.TSN); trgDate: DATE; trgCountUp: tCountUp);
  VAR
   Msg,
   DateStr       : STRING[];
   trgPer,
   saveDate      : DATE;
   ContUpRequired: SCAL[2];
 BEGIN
  saveDate:=Memo.gl_cd();
  trgPer  :=L_DatTim.Per(trgDate);
  IF    trgCountUp = cu_strmFull THEN
   Memo.gl_SetCurDate(trgDate);
   ContUpRequired:=~IsDedD_AP(trgPer);
   DateStr       :="  " + L_DatTim.PeriodStr(trgPer);
  ELSIF trgCountUp = cu_strmUpToDate THEN
   Memo.gl_SetCurDate(trgPer);
   ContUpRequired:=~IsDedD_OnDate(trgDate);
   DateStr       :="  " + L_DatTim.DateStr(trgDate);
  ELSE
   L_General.CallUs(0);
  END;
  IF ContUpRequired THEN
   TRY
    curCountUp:=trgCountUp;
    L_General.RidgeExecute("Staff", PROCREF(_StaffCountUp), L_General.rem_Isolated);
   EXCEPT
   ON Exc: Exc_Root DO
    SETEMPTY(Msg);
    IF Exc.ErrorCode = L_General.ec_rt_LockedByMainASL THEN
     Msg:=L_StdFrm.HR() + " ।⥫쭮 믮   ।騥 ";
    END;
    L_General.Error(" 㤠  ⠡. " + Staff.TSN + DateStr +
                    "||" + Exc.MsgOriginalText +
                    Msg);
   END; (* TRY *)
  END;
  Memo.gl_SetCurDate(saveDate);
 END {intStaffCountUp};

 PUBLIC PROCEDURE StaffCountUp(trgTSN: LIKE(Staff.TSN); P: DATE);
 BEGIN
  intStaffCountUp(trgTSN, P, cu_strmFull);
 END {StaffCountUp};

 PUBLIC PROCEDURE StaffCountUpOnDate(trgTSN: LIKE(Staff.TSN); D: DATE);
 BEGIN
  intStaffCountUp(trgTSN, D, cu_strmUpToDate);
 END {StaffCountUpOnDate};

 PUBLIC PROCEDURE GetFinalCalcDate(P: DATE): DATE;
  CONST
   cln_Days = 5;
  VAR
   wrk_Days: NUMERIC[0];
   Result  : DATE;
 BEGIN
  wrk_Days:=L_EC.ExecE_Func_Numeric(P, PROCREF(E_PRoll.FinalCalculationLeeway), 2);
  Result:=L_DatTim.MonthEnd(P);
  IF L_DatTim.MONTH(P) = 11 THEN (*  ᪮७ 0089293. ,  㡥  ࠧ  ﭢ*)
   RETURN (Result + cln_Days) + 1;
  ELSE
   RETURN Math.Min(L_DatTim.IncWorkDay(Result, wrk_Days), Result + cln_Days) + 1;
  END;
 END {GetFinalCalcDate};

 PRIVATE PROCEDURE GetDstAttr(    P          : DATE;
                                  curCostItem: LIKE(CostItem.CostItem);
                              VAR dstAcCut   : LIKE(AcCut.AcCut);
                              VAR dstCostItem: LIKE(CostItem.CostItem));
 BEGIN
  SAVE(CostItem);
  SAVE(Officer);
  SEARCH(Officer, Officer, , StaffLog.Sort, StaffLog.Officer);
  SEARCH(CostItem, CostItem, , curCostItem);
  IF ~CostItem.Leaf THEN
   SELECT(CostItem, Parent, , CostItem.CostItem);
   WHILE OCCURE(CostItem) & (CostItem.MyFirm # Officer.MyFirm) DO
    NEXT(CostItem);
   END;
  END;
  IF ~OCCURE(CostItem) | ((CostItem.MyFirm # Officer.MyFirm) & (P >= 01\01\2012)) THEN
   L_StdFrm.WrongDB(" " + curCostItem + "    ਬ     " + Officer.MyFirm);
  END;
  dstAcCut   :=L_Acnt.GetSpecificAcCutForCostItem(CostItem.CostItem, L_Acnt.acp_CostItem_Default);
  dstCostItem:=CostItem.CostItem;
  RESTORE(Officer);
  RESTORE(CostItem);
 END {GetDstAttr};

 PRIVATE PROCEDURE GetOfcDstAcCut(trgDstMode: LIKE(DstMode.DstMode); P: DATE; Strong: SCAL[2]): LIKE(AcCut.AcCut);
  VAR
   Result     : LIKE(AcCut.AcCut);
   dmyCostItem: LIKE(CostItem.CostItem);
 BEGIN
  SETEMPTY(Result);
  IF UseSalDSet() THEN
   GetOfficerDstAttr(trgDstMode, P, Strong, Result, dmyCostItem);
  ELSE
   IF SEARCH(OfcDst, Officer, StaffLog.Sort, StaffLog.Officer, trgDstMode) THEN
    Result:=OfcDst.AcCut;
   ELSIF Strong THEN
    L_General.Error(" 㪠 ᯮᮡ । " + trgDstMode + "." +
                    "|| " + StaffLog.Sort + ", ࠡ祥  " + StaffLog.Officer);
   END;
  END;
  RETURN Result;
 END {GetOfcDstAcCut};

 PUBLIC PROCEDURE GetOfficerDstAttr(trgDstMode: LIKE(DstMode.DstMode);
                                    P         : DATE;
                                    Strong    : SCAL[2];
                                    VAR dstAcCut   : LIKE(AcCut.AcCut);
                                    VAR dstCostItem: LIKE(CostItem.CostItem));
 BEGIN
  SETEMPTY(dstAcCut, dstCostItem);
  IF UseSalDSet() THEN
   SAVE(Officer);
   SEARCH(Officer, Officer, , StaffLog.Sort, StaffLog.Officer);
   SETSEL(SalDSetL, SalDSet, Officer.SalDSet, trgDstMode);
   IF SRCINSEL(SalDSetL, LE, P) & (SalDSetL.Till > P) THEN
    GetDstAttr(P, SalDSetL.CostItem, dstAcCut, dstCostItem);
   ELSIF Strong THEN
    L_General.Error("  ᯮᮡ । " + Officer.SalDSet + "  ᯮᮡ " + trgDstMode + "  " + L_DatTim.PeriodStr(P));
   END;
   RESTORE(Officer);
  ELSE
   dstAcCut:=GetOfcDstAcCut(trgDstMode, P, Strong);
  END;
 END {GetOfficerDstAttr};
 
 PUBLIC PROCEDURE GetMCListAcCut(trgMCode: LIKE(MCList.MCode); P: DATE): LIKE(AcCut.AcCut);
  VAR
   dmyXObject: LIKE(XObject.XObject);
   Result    : LIKE(AcCut.AcCut);
 BEGIN
  IF UseSalDSet() THEN
   GetMCListDstAttr(trgMCode, P, Result, dmyXObject);
  ELSE
   SAVE(MCList);
   SAVE(DstMode);
   SEARCH(MCList, MCode, , trgMCode);
   CONFORM(MCList, DstMode);
   IF    DstMode.MnMth = dmmm_byMCList THEN
    Result:=MCList.AcCut;
   ELSIF DstMode.MnMth = dmmm_byOfficer THEN
    Result:=GetOfcDstAcCut(MCList.DstMode, P, 1);
   ELSE
    L_General.CallUs(0);
   END;
   RESTORE(DstMode);
   RESTORE(MCList);
  END;
  RETURN Result;
 END {GetMCListAcCut};

 PRIVATE PROCEDURE GetMCListDstAttr(trgMCode: LIKE(MCList.MCode);
                                    P       : DATE;
                                    VAR dstAcCut   : LIKE(AcCut.AcCut);
                                    VAR dstXObject : LIKE(XObject.XObject));
  VAR
   curDstMode : LIKE(DstMode.DstMode);
   curCostItem: LIKE(CostItem.CostItem);
   curContract: LIKE(Contract.Contract);
 BEGIN
  SETEMPTY(dstXObject);
  IF UseSalDSet() THEN
   SAVE(DstMode);
   P_MCList.Get_DstMode(trgMCode, P, curDstMode, curCostItem, dstAcCut);
   SEARCH(DstMode, DstMode, , curDstMode);
   IF DstMode.MnMth = dmmm_byOfficer THEN
    GetOfficerDstAttr(curDstMode, P, 1, dstAcCut, curCostItem);
   ELSIF ~!curCostItem THEN
    GetDstAttr(P, curCostItem, dstAcCut, curCostItem);
   ELSIF DstMode.MnMth = dmmm_byContract THEN
    SAVE(MCList);
    SEARCH(MCList, MCode, , trgMCode);
    IF    L_kn.Is(P, erkn_MCList_NDLF)           THEN
     curContract:=L_kn.GetSoft_wMF(P, L_Cntr.erkn_TAF_NDFL, Staff.MyFirm);
    ELSIF L_kn.Is(P, erkn_MCList_AtExpenseOfFSS) THEN
     curContract:=L_kn.GetSoft_wMF(P, L_Cntr.erkn_TAF_xFSS, Staff.MyFirm);
    ELSE
     SETEMPTY(curContract);
    END;
    IF ~!curContract THEN
     SEARCH(Contract, Contract, , curContract);
     dstXObject:=Contract.XObject;
     dstAcCut  :=L_Acnt.GetSpecificAcCutForContract(Contract.Contract, L_Acnt.acp_Contract_Netto);
    ELSE
     L_StdFrm.WrongDB(" / " + trgMCode + ".  ᢮⢥ 3607 㯮 ' ', ,   ⥭.  " + Staff.MyFirm);
    END;
    RESTORE(MCList);
   ELSIF DstMode.MnMth = dmmm_byManXCalc THEN
    dstXObject:=L_XObj.GetManXObject(Staff.Man, Staff.MyFirm);
   ELSIF DstMode.MnMth = dmmm_ByAcCut THEN
    (* nothing *)
   ELSIF DstMode.MnMth = dmmm_byMoneyDst THEN
    (* nothing *)
   ELSE
    L_General.CallUs(0);
   END;
   RESTORE(DstMode);
   IF ~!curCostItem THEN
    SEARCH(CostItem, CostItem, , curCostItem);
    dstXObject:=CostItem.XObject;
   END;
  ELSE
   dstAcCut:=GetMCListAcCut(trgMCode, P);
  END;
 END {GetMCListDstAttr};

 PUBLIC PROCEDURE DefineMoneyCorrespondence(VAR monAcCut,
                                                feeAcCut,
                                                ofcAcCut: LIKE(AcCut.AcCut);
                                            VAR monCostItem,
                                                feeCostItem,
                                                ofcCostItem: LIKE(CostItem.CostItem);
                                            VAR ofcMyPlace : LIKE(MyPlace.MyPlace));
  CONST
   specSFDstMode = 99; (*0081653 09.11.2010 20:05:28 POLAK\Bor*)
  VAR
   P         : DATE;
   monXObject: LIKE(XObject.XObject);
 BEGIN
  SEARCH(StaffLog, TSN, , Staff.TSN, Money.ODate);

  P:=Money.Closed;
  ofcMyPlace:=P_Sort.GetMyPlace(StaffLog.Sort, P);
  CONFORM(Money, MCList);
  SETEMPTY(monCostItem);
  IF Money.WFPeriod >= E_DoSecondSide() THEN
   monAcCut  :=MoneyDst.AcCut;
   monXObject:=MoneyDst.XObject;
  ELSE
   GetMCListDstAttr(MCList.MCode, P, monAcCut, monXObject);
  END;
  IF ~!monXObject THEN
   IF SEARCH(CostItem, XObject, monXObject) THEN
    monCostItem:=CostItem.CostItem;
   END;
  END;
  P_MCList.StandOnDstMode(MCList.MCode, P);

  GetOfficerDstAttr(dm_MainSalary, P, 1, ofcAcCut, ofcCostItem);

  L_General.Assert(DstMode.DstMode # specSFDstMode, "  "+MCList.MCode+":|ᮡ । "+DstMode.DstMode+" ᯮ ⮫쪮  ᠭ ");
  IF (DstMode.MnMth = dmmm_byOfficer) | (DstMode.SFMth = dmsf_asDM01) THEN
   GetOfficerDstAttr(specSFDstMode, P, 0, feeAcCut, feeCostItem);
  ELSE
   SETEMPTY(feeAcCut, feeCostItem);
  END;
  IF !feeAcCut THEN
   IF    DstMode.SFMth = dmsf_asMnMth THEN
    feeAcCut   :=monAcCut;
    feeCostItem:=monCostItem;
   ELSIF DstMode.SFMth = dmsf_asDM01 THEN
    feeAcCut   :=ofcAcCut;
    feeCostItem:=ofcCostItem;
   ELSE
    L_General.CallUs(0);
   END;
  END;
 END {DefineMoneyCorrespondence};

 PUBLIC PROCEDURE MoneyIsForSocialInsuranceFond(): SCAL[2];
 BEGIN
  CONFORM(Money, MCList);
  RETURN L_kn.Is(Money.Closed, erkn_MCList_AtExpenseOfFSS);
 END {MoneyIsForSocialInsuranceFond};

 PUBLIC PROCEDURE E_IsSummationSheet(D: DATE): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_PRoll.IsSummationSheet);
  IF ~!Local THEN
   L_Staff.PosToStaffLog(Staff.TSN, D, 1);
   CONFORM(StaffLog, Officer);
   RETURN Local(D);
  ELSE
   RETURN 0;
  END;
 END {E_IsSummationSheet};

 PUBLIC PROCEDURE Make70Cir(trgTSN: LIKE(Staff.TSN));
  VAR
   salAcCut,
   fctAcCut,
   balAcCut      : LIKE(AcCut.AcCut);
   fsApport,
   ssApport,
   dbtApport,
   crdApport     : LIKE(Apport.Apport);
   P             : DATE;
 BEGIN
  APP.Get().NewPrompt("ନ஢ ⮢    ௫. ⭨ " + trgTSN);
  P:=Memo.gl_mb();
  salAcCut:=GetSalaryAcCut(P);
  fctAcCut:=L_Acnt.fictAcCut;
  dbtApport:=L_Acnt.E_Apport_MoneyCredit(P);
  crdApport:=L_Acnt.E_Apport_MoneyDebit(P);
  IF P >= E_DoSecondSide() THEN
   balAcCut:=L_AcCut.erkn_Get(P, L_AcCut.erkn_OnlineBalance);
   IF SEARCH(PCalc, TSN, Staff.TSN, P) THEN
    L_XDR.XDocId:=L_XDoc.curXDocId(L_XDoc.xdt_PCalc);
    L_Acnt.RollbackXDoc(L_XDR.XDocId);
   ELSE
    SETEMPTY(L_XDR.XDocId);
    L_General.CallUs(~SELECT(Money, TSN, Staff.TSN, P));
   END;
  END;
  SETSEL(Money, TSN, trgTSN, P);
  FOR_EACH Money DO
   CONFORM(Money, MCList);
   IF MCList.MCTyp = mct_Credit THEN fsApport:=dbtApport; ssApport:=crdApport;
   ELSE                              fsApport:=crdApport; ssApport:=dbtApport;
   END;
   IF P >= E_DoSecondSide() THEN
    SETSEL(MoneyDst, MoneyDst, Money.RECORDID);
    FOR_EACH MoneyDst DO
     IF !MoneyDst.AcCut THEN
      L_StdFrm.WrongDB("  ப ⭮   ।  ࠧ१" + L_StdFrm.THR(" ப") + L_DBD.RecordToStr(TABLE.Get("Money")));
     END;
     IF ~MoneyDst.wSS THEN
      IF !MoneyDst.XObject THEN
       L_StdFrm.WrongDB("  ப ⭮   । ꥪ " + L_StdFrm.THR(" ப") + L_DBD.RecordToStr(TABLE.Get("Money")));
      END;
      IF ssApport = crdApport THEN
       L_XObj.MakeCompleteCir(+1, P,
                              MoneyDst.XObject,  MoneyDst.AcCut,  ssApport,  0,
                              Staff.XObject,     salAcCut,        fsApport,  0,
                              MoneyDst.Sum, 0, L_XObj.src_Salary);
      ELSE
       L_XObj.MakeCompleteCir(+1, P,
                              Staff.XObject,     salAcCut,        fsApport,  0,
                              MoneyDst.XObject,  MoneyDst.AcCut,  ssApport,  0,
                              MoneyDst.Sum, 0, L_XObj.src_Salary);
      END;
      SEARCH(XObject, XObject, , MoneyDst.XObject);
      IF XObject.Origin = L_XObj.o_Contract THEN
       SEARCH(XObject, XObject, , MoneyDst.XObject);
       L_XObj.mo_MakeCir(+1, balAcCut, P, ssApport, fctAcCut, MoneyDst.Sum, L_XObj.src_Salary);
      END;
     ELSE
      SEARCH(XObject, XObject, , Staff.XObject);
      L_XObj.mo_MakeCir(+1, salAcCut, Money.Closed, fsApport, MoneyDst.AcCut, MoneyDst.Sum, L_XObj.src_Salary);
     END;
    END; (* FOR_EACH MoneyDst *)
    IF ~!L_XDR.XDocId THEN
     L_Acnt.RenXDocApr(L_XDR.XDocId);
    END;
   ELSIF (Money.Closed >= 01\12\2008) | L_General.IsPolakSpecific() THEN
    SEARCH(XObject, XObject, , Staff.XObject);
    L_XObj.mo_MakeCir(+1, salAcCut, Money.Closed, fsApport, L_STx.STx_GetAcCutForMoney(), Money.Sum, L_XObj.src_Salary);
   END; (* IF P >= E_DoSecondSide() ... *)
  END; (* FOR_EACH Money *)
 END {Make70Cir};

 PUBLIC PROCEDURE ClearAll70Cir();
  VAR
   SourcesToClear: SCAL[2][100];
 BEGIN
  L_StdFrm.Choice("ਭ㤨⥫쭠 ⪠ ⮢ '  70'?");
  L_General.PrgsOnly();

  SETSEL(PCalc, Period, Memo.gl_mb());
  FOR_EACH PCalc DO
   PROMPT(PCalc.TSN);
   L_Acnt.RollbackXDoc(L_XDoc.curXDocId(L_XDoc.xdt_PCalc));
  END; (* FOR_EACH PCalc *)

  SETZERO(SourcesToClear);
  SourcesToClear[L_XObj.src_Salary]:=1;
  L_XObj.xMultipleClearXApportOfObjectsType(L_XObj.o_Staff,    L_XObj.s_Payments, SourcesToClear, 0);
  L_XObj.xMultipleClearXApportOfObjectsType(L_XObj.o_Man,      L_XObj.s_Payments, SourcesToClear, 0);
  L_XObj.xMultipleClearXApportOfObjectsType(L_XObj.o_CostItem, L_XObj.s_Payments, SourcesToClear, 0);
  L_XObj.xMultipleClearXApportOfObjectsType(L_XObj.o_Contract, L_XObj.s_Payments, SourcesToClear, 0);
  L_XObj.xMultipleClearXApportOfObjectsType(L_XObj.o_Global,   L_XObj.s_Payments, SourcesToClear, 0);
 END {ClearAll70Cir};

END.
