(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose       ᢮⢠ ꥪ⮢
%Type        library
%Specific    SYS
%Modified    18.08.2014 19:30:37 POLAK\Gina
%Environment Property.Object = 0 - Staff;
%Environment Property.Object = 10 - Firm;
*)

 MODULE L_Prop [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tProObject = SCAL[35];
  tProTag    = STRING[64];

 PUBLIC CONST
  po_Pool =  "⭨"+
             "|࠭ᯮ⭮ ।⢮"+
             "|ઠ"+
             "|"+
             "|ਪ  ᮭ"+
             "|祥 "+
             "| ਪ  ᮭ"+
             "|ꥪ ਠ쭮 "+
             "|᪮ "+
             "| 㬥"+
             "|ࠣ"+
             "|⥣"+
             "|"+
             "|⥦ 㬥"+
             "|"+
             "|" +
             "|㬥" +
             "|ன" +
             "|ᮡ ࠢ"+
             "|"+
             "| ࠭"+
             "|室"+
             "| "+
             "|'' ࣠"+
             "| ॢ"+
             "| "+
             "| 室  室"+
             "|稩 㬥"+
             "| ᫥/㤥ঠ"+
             "|"+
             "|⮯ .頤"+
             "|ந⢥ 頤" +
             "|㯯 ப";

  po_Pool_Genitive =  "ࠡ⭨"+
                      "|࠭ᯮ⭮ ।⢠"+
                      "|ન"+
                      "|"+
                      "|ਪ  ᮭ"+
                      "|ࠡ祣 "+
                      "| ਪ  ᮭ"+
                      "|ꥪ ਠ쭮 "+
                      "|䨧᪮ "+
                      "|⮢୮ 㬥"+
                      "|ࠣ"+
                      "|⥣ਨ"+
                      "|ᥪ"+
                      "|⥦ 㬥"+
                      "|"+
                      "|" +
                      "|㬥" +
                      "|ன" +
                      "|ᯮᮡ ࠢ"+
                      "|"+
                      "| ࠭"+
                      "|室"+
                      "| "+
                      "|'' ࣠樨"+
                      "| ॢ"+
                      "|६⭮ "+
                      "| 室  室"+
                      "|祣 㬥"+
                      "| ᫥/㤥ঠ"+
                      "|"+
                      "|⮯ . 頤"+
                      "|ந⢥ 頤" +
                      "|㯯 ப";

  StandartWindowName = "ObjPrE";
  wLinkWindowName    = "ObjPrL";
  PropListWindowName = "ObjPrA";

  ChooseFileDialog = "ChooseFileDialog";

  StaffProObj = 0;
  CarProObj   = 1;
  MarkProObj  = 2;
  RouteProObj = 3;
  EDOLProObj  = 4;
  OfcProObj   = 5;
  EDOKProObj  = 6;
  MathProObj  = 7;
  ManProObj   = 8;
  MDocProObj  = 9;
  FirmProObj  = 10;
  UnionProObj = 11;
  SortProObj  = 12;
  PDocProObj  = 13;
  CntrProObj  = 14;
  PostProObj  = 15;
  AvePProObj  = 16;
  OwnDProObj  = 17;
  DsptMProObj = 18;
  CUCProObj   = 19;
  StrgProObj  = 20;
  ExitProObj  = 21;

  MFProObj    = 23;
  TKindProObj = 24;
  RprProObj   = 25;
  CIProObj    = 26;
  ODocProObj  = 27;
  MCProObj    = 28;
  ClmnProObj  = 29;
  MPProObj    = 30;
  MSProObj    = 31;
  MarkGProObj = 32;

  ObjFile_Pool = "Staff|Car|Mark|Route|EDOrderL|Officer|EDOKind|Math|Man|"+
                 "MDoc|Firm|Union|Sort|PDoc|Contract|Post|AvePay| |"+
                 "DsptMode|CUCopy|Storage|StExit| |MyFirm|TKind|RprS|"+
                 "CostItem|ODoc|MCList|Column|MyPlace|MySite|MarkG";

  PrpFile_Pool = "StaffPro|CarPro|MarkPro|RoutePro|EDOLPro|OfcPro|EDOKPro|MathPro|ManPro|"+
                 "MDocPro|FirmPro|UnionPro|SortPro|PDocPro|CntrPro|PostPro|AvePPro|OwnDPro|"+
                 "DsptMPro|CUCPro|StrgPro|ExitPro| |MFPro|TKindPro|RprPro|CIPro|"+
                 "ODocPro|MCPro|ClmnPro|MPPro|MSPro|MarkGPro";

  Module_Pool = "P_Staff|P_Car|P_Mark|P_Route|P_EDOL|P_Officer|P_EDOKnd|P_Math|P_Man|"+
                "P_MDoc|P_Firm|P_Union|P_Sort|P_PDoc|P_Cntr|P_Post|P_AveP|P_OwnData|"+
                "P_DsptM|P_CUC|P_Storage|P_Exit| |P_MyFirm|P_TKind|P_Rpr|P_CI|"+
                "P_ODoc|P_MCList|P_Column|P_MyPlc|P_MySite|P_MarkG";

  P_Local               = 9500;

  pc_Soft               = 0;
  pc_Strong             = 1;

  dsc_Normal            = 0;
  dsc_Exactly           = 1;
  dsc_Exactly_OnAnyDate = 2;

  EmptyObjectName    = " ";
  ArrayElementAmount = 32;

  rd_No                   = 0;
  rd_Possible             = 1;
  rd_Necessary            = 2;
  rd_TransferFromTemplate = 3;

(*!! - rd_Pool  ᮤন "᫥", ⮡  뫮   㭪   ᢮⢠ 蠡*)
  rd_Pool      = "८। |८। |८। 易⥫쭮";
  rd_PoolShort = "|||";

  pf_Pool = "ந ⥪|ண 祭|ண 祭|樠 ଠ";

  pf_Text       = 0;
  pf_SoftPool   = 1;
  pf_StrongPool = 2;
  pf_Special    = 3;

  mac_Inside    = 0;        (*tModifAllowedCondition*)
  mac_Full      = 1;
  mac_Old       = 2;
  mac_AutoOnly  = 3;

  cpv_None = 0;
  cpv_Yes  = 1;

  chp_No        = 0;
  chp_Yes       = 1;
  chp_Necessary = 2;

  tag_Documents      = "㬥";      (*tProTag*)
  tag_Finance        = "";
  tag_DocCirculation = "㬥⮮";
  tag_Facilities     = "죮";
  tag_Control        = "ࠢ";
  tag_FillDB         = " ";
  tag_Medicine       = "樭";
  tag_Authority      = "";
  tag_RespPersons    = "⢥⢥ ";
  tag_RegInfo        = "  ॣ樨";
  tag_Traffic        = "ॢ";
  tag_Norm           = "";
  tag_Date           = ", ६, ப, ਮ";
  tag_DescriptionObj = "ᠭ ꥪ";

  tag_Pool = tag_Documents      + "|" +
             tag_Finance        + "|" +
             tag_DocCirculation + "|" +
             tag_Facilities     + "|" +
             tag_Control        + "|" +
             tag_FillDB         + "|" +
             tag_Medicine       + "|" +
             tag_Authority      + "|" +
             tag_RespPersons    + "|" +
             tag_RegInfo        + "|" +
             tag_Traffic        + "|" +
             tag_Norm           + "|" +
             tag_Date           + "|" +
             tag_DescriptionObj;

 PUBLIC TYPE
  tCHP                   = SCAL[3];
  tEntity                = SCAL[1E2];
  tPresenceCondition     = SCAL[2];
  tOnDateSearchCondition = SCAL[3];
  tArrayElement          = STRING[][ArrayElementAmount];
  tModifAllowedCondition = SCAL[4];

 IMPORT L_General, L_Str, Str, Math, L_AFM, E_Prop, L_DatTim, L_WDO, L_StdFrm, L_PCS,
        L_SysLog, L_Group, L_DBD, L_qs, L_r2r, L_MathR, L_XDoc, L_Cntr, L_lsStore, Memo;

 PUBLIC PROCEDURE GetStandartWindowName(File: STRING[]): STRING[];
 BEGIN
  IF    (File = "MDocPro") |
        (File = "PDocPro") |
        (File = "ODocPro") |
        (File = "CntrPro") |
        (File = "RprPro" ) |
        (File = "EDOLPro") |
        (File = "OwnDPro") THEN
   RETURN File + "E";
  ELSE
   RETURN StandartWindowName;
  END;
 END {GetStandartWindowName};

 PUBLIC PROCEDURE GetPropListWindowName(File: STRING[]): STRING[];
 BEGIN
  IF    (File = "MDocPro") |
        (File = "PDocPro") |
        (File = "ODocPro") |
        (File = "AvePPro") |
        (File = "OwnDPro") THEN
   RETURN File;
  ELSE
   RETURN PropListWindowName;
  END;
 END {GetPropListWindowName};

 PUBLIC PROCEDURE IsCntrProObj(trgObject: LIKE(Property.Object)): SCAL[2];
 BEGIN
  RETURN trgObject = CntrProObj;
 END {IsCntrProObj};

 PUBLIC PROCEDURE IsEDOLProObj(trgObject: LIKE(Property.Object)): SCAL[2];
 BEGIN
  RETURN trgObject = EDOLProObj;
 END {IsEDOLProObj};

 PUBLIC PROCEDURE IsOwnDProObj(trgObject: LIKE(Property.Object)): SCAL[2];
 BEGIN
  RETURN trgObject = OwnDProObj;
 END {IsOwnDProObj};

 PUBLIC PROCEDURE MayBeEmptyValue(): SCAL[2];
 BEGIN
  IF    Property.Object = CntrProObj THEN
   CONFORM(CntrPro, Contract);
   RETURN CntrPro.Redefine = rd_Necessary;
  ELSIF Property.Object = EDOLProObj THEN
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {MayBeEmptyValue};

 PUBLIC PROCEDURE GetSpecificAP_ObjectDescription(curObject: tProObject): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF    curObject = StaffProObj THEN
   CONFORM(Staff, Man);
   Result:=Staff.TSN + " " + Man.Name;
  ELSIF curObject = ManProObj THEN
   Result:=FLDTOSTR(Man.Man, "L0", 5) + " " + Man.Name;
  ELSIF curObject = CUCProObj THEN
   Result:=CUCopy.CUCopy + " " + CUCopy.Serial;
  ELSIF curObject = CarProObj THEN
   CONFORM(Car, Mark);
   Result:=Car.BoxNbr + " " + Car.StateNbr + "   " + Mark.Name;
  ELSIF curObject = OfcProObj THEN
   CONFORM(Officer, Sort);
   CONFORM(Officer, Post);
   Result:=Officer.Officer + ",  " + Sort.Sort + " " + Sort.Name + ", " + Post.Post + " " + Post.Name;
  ELSIF curObject = PDocProObj THEN
   Result:=FLDTOSTR(PDoc.PDoc, "", 7) + "  " + L_DatTim.DateStr(PDoc.Date) + " ( " + PDoc.SrcNbr + ")";
  ELSIF curObject = MDocProObj THEN
   Result:=MDoc.MDoc + "  " + L_DatTim.DateStr(MDoc.Date) + " ( " + MDoc.SrcNbr + ")";
  ELSIF curObject = AvePProObj THEN
   CONFORM(AvePPro, AvePay);
   CONFORM(AvePay, AveType);
   Result:=AvePay.AvePay;
   IF ~!AvePay.DocDate THEN
    Result:=Result + "  " + L_DatTim.DateStr(AvePay.DocDate);
   END;
   IF ~!AvePay.DocNum THEN
    Result:=Result + " ( " + AvePay.DocNum + ")";
   END;
  ELSIF curObject = ODocProObj THEN
   Result:=ODoc.ODoc + "  " + L_DatTim.DateStr(ODoc.Date) + " ( " + ODoc.SrcNbr + ")";
  ELSE
   SETEMPTY(Result);
  END;
  RETURN Result;
 END {GetSpecificAP_ObjectDescription};

 PRIVATE PROCEDURE GetObjectDescriptionSign(trgXDocType: L_XDoc.tXDocType): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=L_XDoc.Ref_ShortName(trgXDocType);
  RETURN Str.Condense(Result);
 END {GetObjectDescriptionSign};

 PUBLIC PROCEDURE GetSpecificAP_ObjectTitle(curObject: tProObject): STRING[];
  VAR
   Title: STRING[];
 BEGIN
  IF    (curObject = MathProObj) & (Math.MathKind = L_MathR.mathk_KeyAs) THEN
   Title:="ꥪ ᭮ ।";
  ELSIF curObject = PDocProObj THEN
   CONFORM(PDoc, PDocKind);
   Title:=GetObjectDescriptionSign(L_XDoc.xdt_PDoc) + " " + PDocKind.PDocKind + " " + PDocKind.SName;
  ELSIF curObject = MDocProObj THEN
   CONFORM(MDoc, MDocKind);
   Title:=GetObjectDescriptionSign(L_XDoc.xdt_MDoc) + " " + MDocKind.MDocKind + " " + MDocKind.SName;
  ELSIF curObject = AvePProObj THEN
   CONFORM(AvePPro, AvePay);
   CONFORM(AvePay, AveType);
   Title:=GetObjectDescriptionSign(L_XDoc.xdt_AvePay) + " " + AveType.AveType + " " + AveType.Name;
  ELSIF curObject = ODocProObj THEN
   CONFORM(ODoc, ODocKind);
   Title:=GetObjectDescriptionSign(L_XDoc.xdt_ODoc) + " " + ODocKind.ODocKind + " " + ODocKind.SName;
  ELSIF curObject = CntrProObj THEN
   Title:=L_Str.PoolItem(L_Cntr.iit_Pool, Contract.iiType);
  ELSE
   SETEMPTY(Title);
  END;
  RETURN Title;
 END {GetSpecificAP_ObjectTitle};

 PUBLIC PROCEDURE GetObjNum(File: STRING[]): tProObject;
 BEGIN
  RETURN ^(File+"Obj");
 END {GetObjNum};

 PUBLIC PROCEDURE GetModuleName(trgObject: tProObject) : STRING[];
 BEGIN
  RETURN L_Str.PoolItem(Module_Pool, trgObject);
 END {GetModuleName};

 PUBLIC PROCEDURE GetObjProNum(File: STRING[]): tProObject;
 BEGIN
  RETURN L_Str.PositionInPool(ObjFile_Pool, File);
 END {GetObjProNum};

 PUBLIC PROCEDURE ObjectFileName(trgObject: tProObject): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(ObjFile_Pool, trgObject);
 END {ObjectFileName};

 PUBLIC PROCEDURE ObjectFileProName(trgObject: tProObject): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(PrpFile_Pool, trgObject);
 END {ObjectFileProName};

 PUBLIC PROCEDURE IsLocalProperty(_Property: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN _Property >= P_Local;
 END {IsLocalProperty};

(*------------------------------------------------------*)
 PUBLIC PROCEDURE GetProValueAsScal(Pool, _Value: STRING[]): SCAL[1000];
  VAR
   i: SCAL[1000];
   S: STRING[];
 BEGIN
  i:=0;
  S:=Str.Item(Pool, "|", i);
  WHILE ~!S & (S#_Value) DO
   INC(i);
   S:=Str.Item(Pool, "|", i);
  END;
  L_General.Assert(~!S, "GetProValueAsScal() -   祭");
  RETURN i;
 END {GetProValueAsScal};

 PRIVATE CONST
  ErrMsg = "४⭮ 祭 ";

 PUBLIC PROCEDURE GetNumericValueFromStr(StrValue: STRING[]): FLOAT;
 BEGIN
  RETURN L_Str.Str2Num(StrValue, "");
 END {GetNumericValueFromStr};

 PUBLIC PROCEDURE CheckNumericValue(StrValue, Format: STRING[]);
  VAR
   ConvValue: FLOAT;
 BEGIN
  ConvValue:=L_Str.StrToNum(StrValue, Format, 0);
 END {CheckNumericValue};

 PUBLIC PROCEDURE IsNumericValue(StrValue, Format: STRING[]): SCAL[2];
  VAR
   ConvValue: FLOAT;
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   ConvValue:=L_Str.Str2Num(StrValue, Format);
   RETURN 1;
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode = L_General.ec_rt_FailedSTRTOFLD THEN
    RETURN 0;
   ELSE
    RAISE();
   END;
  ELSE
   RAISE();
  END; (* TRY *)
 END {IsNumericValue};

 PUBLIC PROCEDURE CheckScalValue(StrValue, Format: STRING[]; MaxVal: NUMERIC[0]);
  VAR
   ConvValue: NUMERIC[0];
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   ConvValue:=STRTOFLD(StrValue, SCAL, "L");
   IF ConvValue <= MaxVal THEN
    RETURN
   END;
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode # L_General.ec_rt_FailedSTRTOFLD THEN
    RAISE();
   END;
  END; (* TRY *)
  L_General.Error("'" + StrValue + "'  ⨬ 祭.  :  0  "+L_Str.IntStr(MaxVal));
 END {CheckScalValue};

 PUBLIC PROCEDURE GetDateValueFromStr(StrValue, Format: STRING[]; Strong: SCAL[2]): DATE;
  VAR
   ConvValue: DATE;
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   IF ~!Format THEN
    RETURN STRTOFLD(StrValue, DATE, Format);
   ELSE
    RETURN STRTOFLD(StrValue, DATE);
   END;
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode = L_General.ec_rt_FailedSTRTOFLD THEN
    L_General.Assert(~Strong, ErrMsg + " '" + StrValue + "'");
    RETURN EMPTYOF(DATE);
   ELSE
    RAISE();
   END;
  END; (* TRY *)
 END {GetDateValueFromStr};

 PUBLIC PROCEDURE GetDateFromStr(StrValue: STRING[]; Strong: SCAL[2]): DATE;
 BEGIN
  RETURN GetDateValueFromStr(StrValue, "D.N.y", Strong);
 END {GetDateFromStr};

 PUBLIC PROCEDURE CheckDateValue(StrValue, Format: STRING[]);
  VAR
   ConvValue: DATE;
 BEGIN
  ConvValue:=GetDateValueFromStr(StrValue, Format, 1);
 END {CheckDateValue};

 PUBLIC PROCEDURE IsDateValue(StrValue, Format: STRING[]): SCAL[2];
  VAR
   ConvValue: DATE;
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   ConvValue:=GetDateValueFromStr(StrValue, Format, 1);
   RETURN 1;
  EXCEPT
  ON Exc: Exc_Raise DO
   RETURN 0;
  ELSE
   RAISE();
  END; (* TRY *)
 END {IsDateValue};

 PUBLIC PROCEDURE GetTimeValueFromStr(StrValue, Format: STRING[]; Strong: SCAL[2]): TIME;
  VAR
   ConvValue: TIME;
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   IF ~!Format THEN
    RETURN STRTOFLD(StrValue, TIME, Format);
   ELSE
    RETURN STRTOFLD(StrValue, TIME);
   END;
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode = L_General.ec_rt_FailedSTRTOFLD THEN
    L_General.Assert(~Strong, ErrMsg + "६ '" + StrValue + "'");
    RETURN EMPTYOF(TIME);
   ELSE
    RAISE();
   END;
  END; (* TRY *)
 END {GetTimeValueFromStr};

 PUBLIC PROCEDURE CheckTimeValue(StrValue, Format: STRING[]);
  VAR
   ConvValue: TIME;
 BEGIN
  ConvValue:=GetTimeValueFromStr(StrValue, Format, 1);
 END {CheckTimeValue};

 PUBLIC PROCEDURE IsTimeValue(StrValue, Format: STRING[]): SCAL[2];
  VAR
   ConvValue: TIME;
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   ConvValue:=GetTimeValueFromStr(StrValue, Format, 1);
   RETURN 1;
  EXCEPT
  ON Exc: Exc_Raise DO
   RETURN 0;
  ELSE
   RAISE();
  END; (* TRY *)
 END {IsTimeValue};

 PUBLIC PROCEDURE getAIS(Pro_Value: STRING[]; Idx: NUMERIC[0]): STRING[];
 BEGIN
  RETURN Str.BracketedItem(Pro_Value, Idx);
 END {getAIS};

 (*!!!*)PUBLIC PROCEDURE getArrayItem(Pro_Value: STRING[]; Idx: NUMERIC[0]): STRING[];
 BEGIN
  RETURN getAIS(Pro_Value, Idx);
 END {getArrayItem};

 PRIVATE PROCEDURE intCheckAcceptableStringLength(VAR dstStr : STRING[];
                                                      addStr : STRING[];
                                                      wCallUs: SCAL[2]);
  VAR
   maxLength, newLength: NUMERIC[0];
 BEGIN
  maxLength:=Str.MaxLength(dstStr);
  newLength:=Str.Length(dstStr + addStr);
  IF newLength > maxLength THEN
   IF wCallUs THEN
    L_General.CallUs(0);
   ELSE
    L_General.Error("訡  ࠭: ࠧ ப (" + L_Str.IntStr(newLength) +
                    ") ॢ蠥 ᨬ쭮 ⨬ (" + L_Str.IntStr(maxLength) + ").||" +
                    "᫨  㢥७  ࠢ쭮 ᢮ ⢨,|" +
                    ",   ");
   END;
  END;
 END {intCheckAcceptableStringLength};

 PUBLIC PROCEDURE CheckAcceptableStringLength(VAR dstStr: STRING[];
                                                  addStr: STRING[]);
 BEGIN
  intCheckAcceptableStringLength(dstStr, addStr, 0);
 END {CheckAcceptableStringLength};

 PUBLIC PROCEDURE putAIS(VAR Array: STRING[]; Item: STRING[]);
  VAR
   Element: STRING[];
 BEGIN
  Element:="[" + Item + "]";
  intCheckAcceptableStringLength(Array, Element, 1);
  Array:=Array + Element;
 END {putAIS};

 (*!!!*)PUBLIC PROCEDURE putArrayItem(VAR Array: STRING[]; Item: STRING[]);
 BEGIN
  putAIS(Array, Item);
 END {putArrayItem};

 PUBLIC PROCEDURE getRES(Record: STRING[]; Num: NUMERIC[0]): STRING[];
 BEGIN
  RETURN Str.Item(Record, ";", Num, , 1);
 END {getRES};

 (*!!!*)PUBLIC PROCEDURE getRecordElement(Record: STRING[]; Num: NUMERIC[0]): STRING[];
 BEGIN
  RETURN getRES(Record, Num);
 END {getRecordElement};

 PRIVATE PROCEDURE putRE(VAR Record: STRING[]; Element: STRING[]);
  VAR
   Result: STRING[];
 BEGIN
  IF ~!Element THEN
   Result:=L_Str.CheckIllegalChars(Element, ";") + ";";
  ELSE
   Result:=";";
  END;
  intCheckAcceptableStringLength(Record, Result, 1);
  Record:=Record + Result;
 END {putRE};

 PUBLIC PROCEDURE putREV(VAR Record: STRING[]; VAR Element: VARIANT);
  VAR
   Value: STRING[];
 BEGIN
  SETEMPTY(Value);
  IF ~!Element THEN
   Value:=Str.Condense(FLDTOSTR(Element));
  END;
  putRE(Record, Value);
 END {putREV};

 (*!!!*)PUBLIC PROCEDURE putRecordElement(VAR Record: STRING[]; VAR Element: VARIANT);
  VAR
   Value: STRING[];
 BEGIN
  putREV(Record, Element);
 END {putRecordElement};

 PUBLIC PROCEDURE putRES(VAR Record: STRING[]; Element: STRING[]);
 BEGIN
  putREV(Record, Element);
 END {putRES};

 (*!!!*)PUBLIC PROCEDURE putRecordElement_Str(VAR Record: STRING[]; Element: STRING[]);
 BEGIN
  putRES(Record, Element);
 END {putRecordElement_Str};

 PUBLIC PROCEDURE putRET(VAR Record: STRING[]; Element: TIME);
  VAR
   Value: STRING[];
 BEGIN
  SETEMPTY(Value);
  IF ~!Element THEN
   Value:=FLDTOSTR(Element);
  END;
  putRE(Record, Value);
 END {putRET};

 (*!!!*)PUBLIC PROCEDURE putRecordElement_T(VAR Record: STRING[]; Element: TIME);
 BEGIN
  putRET(Record, Element);
 END {putRecordElement_T};

 PUBLIC PROCEDURE putRED(VAR Record: STRING[]; Element: DATE);
  VAR
   Value: STRING[];
 BEGIN
  SETEMPTY(Value);
  IF ~!Element THEN
   Value:=FLDTOSTR(Element, "D.N.y", 10);
  END;
  putRE(Record, Value);
 END {putRED};

 (*!!!*)PUBLIC PROCEDURE putRecordElement_D(VAR Record: STRING[]; Element: DATE);
 BEGIN
  putRED(Record, Element);
 END {putRecordElement_D};

 PUBLIC PROCEDURE CheckRow(_Date: DATE; _Value: STRING[]; ChProc: PROC);
  VAR
   i   : NUMERIC[0];
   val : STRING[];
 BEGIN
  i:=0;
  LOOP
   val:=Str.Item(_Value, ";", i);
   IF !val THEN
    EXIT;
   END;
   ChProc(_Date, val);
   INC(i);
  END; (* LOOP *)
 END {CheckRow};

 PUBLIC PROCEDURE ShowUndefinedProValueError(TableId, RecId: NUMERIC[0];
                                             trgProperty: LIKE(Property.Property); D: DATE);
  VAR
   Table  : TABLE;
   Message: STRING[];
 BEGIN
  Table:=DATABASE.Get().TableById(TableId);
  SEARCH(^(Table.Name), RECORDID, , RecId);
  Message:=" ꥪ '" + Table.Description + "'|" + L_DBD.RecordToStr(Table) +
           "|室 ନ ᢮⢮ " + trgProperty;
  IF ~!D THEN
   Message:=Message + ", 饥  " + L_DatTim.DateStr(D);
  END;
  L_General.Error(Message);
 END {ShowUndefinedProValueError};

 PRIVATE PROCEDURE Init_Prop();
 BEGIN
  IF !DATABASE.Get().Tables("_Prop") THEN
   CREATE_TABLE(_Prop, , "६ 䠩");
 
   CREATE_FIELD(_Prop, Property, LIKE(Property.Property), , , , "⢮");
   CREATE_FIELD(_Prop, Name,     LIKE(Property.Name),     , , , "");
   CREATE_FIELD(_Prop, Object,   LIKE(Property.Object),   , , , "ꥪ");
   CREATE_FIELD(_Prop, Format,   LIKE(Property.Format),   , , , "ଠ");
   CREATE_FIELD(_Prop, Tag,      LIKE(Property.Tag),      , , , "");
 
   CREATE_INDEX(_Prop, Property, UNIQUE, , , Property);
   CREATE_INDEX(_Prop, PropObj,  UNIQUE, , , Object, Property);
 
   SET_VERSION_OF_TABLE(_Prop, 0);
   L_AFM.CreateTemp("_Prop");
  END;
 END {Init_Prop};

 PRIVATE PROCEDURE PackedArrayTag(arrTag: tProTag[]): STRING[];
  VAR
   Idx   : NUMERIC[0];
   tag,
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  FOR_EACH tag IN arrTag DO
   putRES(Result, tag);
  END;
  RETURN Result;
 END {PackedArrayTag};

 PUBLIC PROCEDURE extSetProp(trgProperty: LIKE(Property.Property);
                             trgName    : STRING[];
                             trgObject  : LIKE(Property.Object);
                             trgFormat  : LIKE(Property.Format);
                             arrTag     : tProTag[]);
 BEGIN
  IF ~SEARCH(_Prop, Property, trgProperty) THEN
   _Prop.Property:=trgProperty;
   _Prop.Name    :=trgName;
   _Prop.Object  :=trgObject;
   _Prop.Format  :=trgFormat;
   _Prop.Tag     :=PackedArrayTag(arrTag);
   INSERT(_Prop);
  END;
 END {extSetProp};

 PUBLIC PROCEDURE E_GetPool(_Property: LIKE(Property.Property)): STRING[];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Prop.GetPool);
  IF ~!Local THEN
   RETURN Local(_Property);
  ELSE
   RETURN "";
  END;
 END {E_GetPool};

 PRIVATE PROCEDURE E_SetProperty();
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Prop.SetProperty);
  IF ~!Local THEN
   Local();
  END;
 END {E_SetProperty};

 PUBLIC PROCEDURE SetProperty();
 BEGIN
  Init_Prop();
  extSetProp(0099, "ᮡ   ",                          StaffProObj, pf_Special,    [tag_Date]);
  extSetProp(0100, "     ",                        StaffProObj, pf_Special,    [tag_Date]);
  extSetProp(0110, " ; ந./㯪",                  StaffProObj, pf_Special,    [tag_DescriptionObj]);
  extSetProp(0120, " 室  ",                    StaffProObj, pf_Special,    [tag_Finance]);
  extSetProp(0210, "䨪 ࠡ ⥫/",                   StaffProObj, pf_Special,    [tag_Traffic]);
  extSetProp(0213, "९ ",                           StaffProObj, pf_Special,    [tag_RespPersons, tag_Traffic]);
  extSetProp(0214, "९  ਮ ⠦஢",                 StaffProObj, pf_Special,    [tag_Traffic]);
  extSetProp(0221, "  ࠡ  ",                            StaffProObj, pf_Special,    [tag_Authority]);
  extSetProp(0225, "९ ᥪ (ࠧ浪)",                 StaffProObj, pf_Special,    [tag_Traffic]);
  extSetProp(0226, "ࠢ  ⮢ ᯨ᪮",                   StaffProObj, pf_Special,    [tag_Authority]);
  extSetProp(0227, "⥫-",                              StaffProObj, pf_Special,    [tag_RespPersons, tag_Traffic]);
  extSetProp(0228, "ᮡ ࠧ浪",                           StaffProObj, pf_Special,    [tag_Traffic]);
  extSetProp(0229, "⠢    ",                       StaffProObj, pf_Special,    [tag_Traffic]);
  extSetProp(0232, "९ ᮢ 室",                      StaffProObj, pf_Special,    [tag_Traffic]);
  extSetProp(0233, " ࠢ ",                                StaffProObj, pf_Special,    [tag_Authority]);
  extSetProp(0510, "  㣨 ",                         StaffProObj, pf_Special,    [tag_Date]);
  extSetProp(0901, "稭 , .",                            StaffProObj, pf_Special,    [tag_Finance]);

  extSetProp(1150, "樥 ४樨 ᯨ",                 CarProObj, pf_Special,      [tag_Traffic, tag_DescriptionObj]);
  extSetProp(1151, "稥 ",                                      CarProObj, pf_Special,      [tag_Traffic, tag_DescriptionObj]);
  extSetProp(1152, "室 ⮯ ନ",                       CarProObj, pf_Special,      [tag_Traffic, tag_Norm]);
  extSetProp(1153, "易⥫쭮 客 ",                     CarProObj, pf_Special,      [tag_Documents, tag_Traffic]);
  extSetProp(1154, "業 窠",                            CarProObj, pf_Special,      [tag_Documents, tag_Traffic]);
  extSetProp(1155, " ",                                     CarProObj, pf_Special,      [tag_Traffic, tag_DescriptionObj]);
  extSetProp(1156, "稥 ",                                     CarProObj, pf_Special,      [tag_Traffic, tag_DescriptionObj]);
  extSetProp(1157, "⥫ ",                                CarProObj, pf_Special,      [tag_Traffic]);
  extSetProp(1158, "孨᪨ ᮡ",                          CarProObj, pf_Text,         [tag_Traffic, tag_DescriptionObj]);
  extSetProp(1159, "樮 ",                               CarProObj, pf_Special,      [tag_Traffic]);
  extSetProp(1160, "稥 ",                                    CarProObj, pf_Special,      [tag_Traffic, tag_DescriptionObj]);
  extSetProp(1161, "稥 ୮ ",                         CarProObj, pf_Special,      [tag_Traffic, tag_DescriptionObj]);
  extSetProp(1162, "孨᪨ ᬮ",                               CarProObj, pf_Special,      [tag_Documents, tag_Traffic]);
  extSetProp(1163, "㤮  ",                       CarProObj, pf_Special,      [tag_Traffic, tag_DescriptionObj]);
  extSetProp(1164, "㤮  祭 ⥫",              CarProObj, pf_Special,      [tag_Traffic, tag_DescriptionObj]);
  extSetProp(1165, "樠 ᨣ",                              CarProObj, pf_Special,      [tag_Traffic, tag_DescriptionObj]);
  extSetProp(1166, "窠",                                          CarProObj, pf_StrongPool,   [tag_Medicine, tag_Traffic, tag_DescriptionObj]);
  extSetProp(1167, "稥 樮 ⥬",                    CarProObj, pf_Special,      [tag_Traffic, tag_DescriptionObj]);
  extSetProp(1168, " ",                                  CarProObj, pf_Special,      [tag_Documents, tag_Traffic]);
  extSetProp(1170, "஢쭮 客 ",                   CarProObj, pf_Special,      [tag_Documents, tag_Traffic]);
  extSetProp(1171, "稥 宣",                                CarProObj, pf_Special,      [tag_Traffic, tag_DescriptionObj]);
  extSetProp(1172, "ﭮ筮 ",                                 CarProObj, pf_Special,      [tag_Traffic, tag_DescriptionObj]);
  extSetProp(1173, "ᮡ ࠧ浪",                           CarProObj, pf_Special,      [tag_Traffic]);

  extSetProp(5012, "ࠢ  ଥ ⮯",                         CarProObj, pf_Special,      [tag_Traffic, tag_Norm]);
  extSetProp(5013, "ࠢ  ଠ ᥫ",                          CarProObj, pf_Special,      [tag_Traffic, tag_Norm]);

  extSetProp(1201, "ଠ  ࠡ ᪮ 㤮",      MarkProObj, pf_Special,     [tag_Traffic, tag_Norm]);
  extSetProp(1202, "ଠ  ணॢ ⥫",                       MarkProObj, pf_Special,     [tag_Traffic, tag_Norm]);
  extSetProp(1203, "ᠦ஢⨬",                             MarkProObj, pf_Special,     [tag_Traffic, tag_DescriptionObj]);
  extSetProp(1205, "६  /",                                  MarkProObj, pf_Special,    [tag_Date, tag_DescriptionObj]);
  extSetProp(1206, "६  ࠡ  , %",                    MarkProObj, pf_Special,    [tag_Finance, tag_Traffic]);
  extSetProp(1212, "ଠ ⮯   ࠡ",                  MarkProObj, pf_Special,    [tag_Traffic, tag_Norm]);
  extSetProp(1213, " 室 ⮯",                            MarkProObj, pf_Special,    [tag_Traffic, tag_Norm]);
  extSetProp(5015, "ࠢ  ଥ ⮯",                         MarkProObj, pf_Special,    [tag_Traffic, tag_Norm]);

  extSetProp(2201, "ଠ⨢ 室    ",                    MarkGProObj,pf_Special,    [tag_Traffic, tag_Norm]);

  extSetProp(5009, "㦮 ",                                    RouteProObj, pf_Special,   [tag_Traffic]);
  extSetProp(5010, "⠫ 窨  ३ᠬ ",                 RouteProObj, pf_Special,   [tag_Traffic]);
  extSetProp(5011, " 㯯",                                 RouteProObj, pf_Special,   [tag_DescriptionObj]);
  extSetProp(5016, "⢠ ᠦம",                        RouteProObj, pf_Special,   [tag_Traffic]);
  extSetProp(5017, "ࠢ  ଥ  100 (%)",                    RouteProObj, pf_Special,   [tag_Traffic, tag_Norm]);
  extSetProp(5018, "  饩 ࣠樨",           RouteProObj, pf_Text,      [tag_RegInfo, tag_DescriptionObj]);
  extSetProp(5019, "",                                             RouteProObj, pf_Special,   [tag_Traffic, tag_DescriptionObj]);
  extSetProp(5020, "㤮  ",                       RouteProObj, pf_Special,   [tag_Traffic, tag_DescriptionObj]);
  extSetProp(5021, "",                                             RouteProObj, pf_Special,   [tag_Traffic, tag_DescriptionObj]);
  extSetProp(5022, "ଠ쭮 ⪫  ᯨᠭ, ",      RouteProObj, pf_Special,   [tag_Traffic, tag_Norm]);
  extSetProp(5023, "㯯 ⮢",                                 RouteProObj, pf_StrongPool,[tag_Traffic, tag_DescriptionObj]);

  extSetProp(0101, "᭥",                                       EDOLProObj, pf_Text,       [tag_DescriptionObj]);
  extSetProp(0102, "ਨ",                                      EDOLProObj, pf_Text,       [tag_DescriptionObj]);
  extSetProp(0103, "",                                          EDOLProObj, pf_Special,    [tag_Traffic, tag_DescriptionObj]);
  extSetProp(0104, "  ⫨",                       EDOLProObj, pf_StrongPool, [tag_DescriptionObj]);
  extSetProp(0105, " ᥪ (㬬)",                             EDOLProObj, pf_Special,    [tag_Finance, tag_DescriptionObj]);
  extSetProp(0106, " ᥪ (ᥪ)",                            EDOLProObj, pf_Special,    [tag_DescriptionObj]);
  extSetProp(0107, "ࠦ ",                                   EDOLProObj, pf_Special,    [tag_Traffic, tag_DescriptionObj]);
  extSetProp(0108, "⭨",                                         EDOLProObj, pf_Special,    [tag_DescriptionObj]);
  extSetProp(0109, "㯯 ப",                                     EDOLProObj, pf_Special,    [tag_Traffic, tag_DescriptionObj]);
  extSetProp(0111, " ᭮",                              EDOLProObj, pf_Special,    [tag_DescriptionObj]);
  extSetProp(0112, "६ ⠦஢ ()",                          EDOLProObj, pf_Special,    [tag_Traffic, tag_Date, tag_DescriptionObj]);
  extSetProp(0113, " ࠡ",                                     EDOLProObj, pf_Special,    [tag_DescriptionObj]);
  extSetProp(0114, " ॢ",                                    EDOLProObj, pf_Special,    [tag_Traffic, tag_DescriptionObj]);
  extSetProp(0115, " 祭",                                 EDOLProObj, pf_Text,       [tag_Traffic, tag_DescriptionObj]);
  extSetProp(0116, "",                                             EDOLProObj, pf_Text,       [tag_DescriptionObj]);
  extSetProp(0117, "筨 䨭஢",                          EDOLProObj, pf_Text,       [tag_Finance, tag_DescriptionObj]);
  extSetProp(0118, "㠫쭮 ࠡ祥 ᯨᠭ",                EDOLProObj, pf_Special,    [tag_DescriptionObj]);
  extSetProp(0119, "ᮭ ",                              EDOLProObj, pf_Special,    [tag_DescriptionObj]);
  extSetProp(0121, "⥫⢠ ",                             EDOLProObj, pf_Text,       [tag_Traffic, tag_DescriptionObj]);

  extSetProp(3999, "⢮ ᨩ",                              OfcProObj, pf_Special,    [tag_DescriptionObj]);
  extSetProp(4010, "ॡ 樭᪨ ᬮ",                     OfcProObj, pf_Special,    [tag_Medicine]);
  extSetProp(4011, "ॡ 稥 . ",                    OfcProObj, pf_Special,    [tag_Medicine]);
  extSetProp(4013, "ࠪ ࠡ",                                  OfcProObj, pf_StrongPool, [tag_DescriptionObj]);
  extSetProp(4020, "६, %",                                        OfcProObj, pf_Special,    [tag_Finance]);
  extSetProp(4021, "।, %",                                     OfcProObj, pf_Special,    [tag_Finance]);
  extSetProp(4022, ", ⥭ᨢ, %",                      OfcProObj, pf_Special,    [tag_Finance]);
  extSetProp(4023, "樥  ।, %",                     OfcProObj, pf_Special,    [tag_Finance]);
  extSetProp(4024, "  '㣨'",                              OfcProObj, pf_Special,    [tag_Finance, tag_DescriptionObj]);
  extSetProp(4025, "।⢠ 㠫쭮 ",                   OfcProObj, pf_Special,    [tag_DescriptionObj]);
  extSetProp(4030, " ",                                 OfcProObj, pf_Special,    [tag_Finance, tag_DescriptionObj]);
  extSetProp(4050, "ᮡ ० ",                     OfcProObj, pf_Special,    [tag_DescriptionObj, tag_Finance]);
  extSetProp(4051, "࠭祭 㯠  ⠬ ࠭",            OfcProObj, pf_Special,    [tag_Authority, tag_DescriptionObj]);
  extSetProp(4052, "  ᪮ ⠩",                      OfcProObj, pf_Special,    [tag_Authority, tag_DescriptionObj]);
  extSetProp(4053, " 樨 . ࠡ⪠",                  OfcProObj, pf_Special,    [tag_Finance]);
  extSetProp(4054, "  ᮭ ",                     OfcProObj, pf_Special,    [tag_Authority, tag_DescriptionObj]);
  extSetProp(4055, "  樨",                           OfcProObj, pf_Special,    [tag_Documents, tag_DescriptionObj]);
  extSetProp(4056, "᫮ 㤠",                                    OfcProObj, pf_Special,    [tag_DescriptionObj]);

  extSetProp(0001, "祭 ᢮ ப ਪ",                  EDOKProObj, pf_Special,   [tag_FillDB]);
  extSetProp(0002, " 㬬",                                    EDOKProObj, pf_Special,   [tag_Finance, tag_FillDB]);
  extSetProp(0003, " %",                                       EDOKProObj, pf_Special,   [tag_Finance, tag_FillDB]);
  extSetProp(0004, " TXT 䠩  蠡 ",                  EDOKProObj, pf_Special,   [tag_FillDB]);
  extSetProp(0005, "ᯮ ",                        EDOKProObj, pf_Special,   [tag_Finance, tag_DescriptionObj]);
  extSetProp(0006, "ᠭ   䨪",                      EDOKProObj, pf_Special,   [tag_Traffic]);
  extSetProp(0007, " ७ த⥫쭮",              EDOKProObj, pf_SoftPool,  [tag_DescriptionObj]);
  extSetProp(0008, "ࠤ, ७",                               EDOKProObj, pf_Special,   [tag_Finance]);

  extSetProp(7000, "஢ ⪮",                                  MathProObj, pf_Special,   [tag_Control]);
  extSetProp(7002, "ப 㦡",                                      MathProObj, pf_Special,   [tag_Control, tag_Date]);
  extSetProp(7003, "ઠ ꥪ",                                    MathProObj, pf_Special,   [tag_DescriptionObj]);
  extSetProp(7004, " ࠭",                                   MathProObj, pf_Special,   [tag_DescriptionObj]);
  extSetProp(7005, "  /室",                      MathProObj, pf_Special,   [tag_Finance, tag_Traffic]);
  extSetProp(7006, "ঠ ࠣ業 ⠫",                  MathProObj, pf_Special,   [tag_DescriptionObj]);
  extSetProp(7007, "   ॢ",                     MathProObj, pf_Special,   [tag_Finance]);
  extSetProp(7008, "࠭⨩ ப",                                 MathProObj, pf_Special,   [tag_FillDB, tag_Date]);
  extSetProp(7009, " ࠢ  ",                          MathProObj, pf_Special,   [tag_FillDB]);
  extSetProp(7010, "祭 樮 ",                    MathProObj, pf_Special,   [tag_DescriptionObj]);
  extSetProp(7011, "頤, ..",                                   MathProObj, pf_Special,   [tag_DescriptionObj]);
  extSetProp(7012, "樠쭮 ⭮襭  ",                      MathProObj, pf_Special,   [tag_Finance]);
  extSetProp(7013, "ᮡ  ",                                 MathProObj, pf_Special,   [tag_Finance]);
  extSetProp(7014, "᪮ ",                                  MathProObj, pf_Text,      [tag_FillDB]);
  extSetProp(7015, "ࠪ⨪ ꥪ",                           MathProObj, pf_Text,      [tag_FillDB]);
  extSetProp(7016, "⮤  ᪭ 業",                     MathProObj, pf_Special,   [tag_Finance]);
  extSetProp(7017, " ᪠  ந⢮",                     MathProObj, pf_Special,   [tag_Control]);
  extSetProp(7020, "⠢ ",                                 MathProObj, pf_Special,   [tag_DescriptionObj]);
  extSetProp(7021, "ਬ",                                       MathProObj, pf_Special,   [tag_DescriptionObj]);
  extSetProp(7022, "㯯஢ ",                               MathProObj, pf_Special,   [tag_DescriptionObj]);
  extSetProp(7051, "  ⠢騪",                           MathProObj, pf_Special,   [tag_DescriptionObj]);
  extSetProp(7052, "뫪  ᯥ䨪樨",                           MathProObj, pf_Special,   [tag_DescriptionObj]);
  extSetProp(7053, "⠢   ⢮, %",                    MathProObj, pf_Special,   [tag_Finance]);
  extSetProp(7054, "࠭ ந宦 - ",                    MathProObj, pf_Special,   [tag_DescriptionObj]);
  extSetProp(7055, "⮯ ந⢥ 頤",         MathProObj, pf_Special,   [tag_DescriptionObj]);

  extSetProp(0201, "樭᪮ ᢨ⥫⢮",                  ManProObj, pf_Special,    [tag_Medicine, tag_Documents]);
  extSetProp(0202, "⥫᪮ 㤮⮢७",                       ManProObj, pf_Special,    [tag_Documents, tag_Traffic]);
  extSetProp(0203, "筠 樭᪠ ",                        ManProObj, pf_Special,    [tag_Medicine, tag_Documents]);
  extSetProp(0204, "ࠢ  㤮 ⥫쭮",                   ManProObj, pf_Special,    [tag_Documents]);
  extSetProp(0205, " த",                          ManProObj, pf_Special,    [tag_Documents]);
  extSetProp(0206, "宦 ண䨨",                         ManProObj, pf_Special,    [tag_Medicine, tag_Documents]);
  extSetProp(0207, "樭",                                       ManProObj, pf_Special,    [tag_Medicine, tag_Documents]);
  extSetProp(0208, " -",                                ManProObj, pf_Special,    [tag_Authority]);
  extSetProp(0209, "⮢७ ࠪ",                        ManProObj, pf_Text,       [tag_Documents, tag_Traffic]);
  extSetProp(5050, "⮣",                                       ManProObj, pf_Special,    [tag_Documents]);
  extSetProp(5100, "㯯 ",                              ManProObj, pf_Special,    [tag_Medicine, tag_Facilities, tag_Documents]);
  extSetProp(5101, " ᨨ",                                       ManProObj, pf_Special,    [tag_Documents]);
  extSetProp(5102, " ࠭ ࠦ",                   ManProObj, pf_Special,    [tag_Documents]);
  extSetProp(5105, "  ",                                     ManProObj, pf_Text,       [tag_FillDB]);
  extSetProp(5106, "",                                              ManProObj, pf_Text,       [tag_FillDB]);
  extSetProp(5110, "⭨ ",                                     ManProObj, pf_Special,    [tag_Documents, tag_Facilities]);
  extSetProp(5112, "易⥫쭮 . 客",                    ManProObj, pf_Special,    [tag_Medicine, tag_Documents]);
  extSetProp(5120, "⭨  ⢨",                         ManProObj, pf_Text,       [tag_Documents, tag_Facilities]);
  extSetProp(5121, "⭨ ୮᪨ ᮡ⨩",                   ManProObj, pf_Special,    [tag_Documents, tag_Facilities]);
  extSetProp(5122, "࠭ 㤠",                                    ManProObj, pf_Special,    [tag_Documents, tag_Facilities]);
  extSetProp(5123, "⥫  ࠤ",                     ManProObj, pf_Special,    [tag_Documents, tag_Facilities]);
  extSetProp(5124, "⭨ 㤮 ஭",                        ManProObj, pf_Special,    [tag_Documents, tag_Facilities]);
  extSetProp(5130, " ",                                        ManProObj, pf_Special,    [tag_RegInfo, tag_Documents]);
  extSetProp(5145, "᭮ ࠡ⭨  ",             ManProObj, pf_Special,    [tag_Facilities, tag_RespPersons]);
  extSetProp(5146, "⥫ SMS-뫮",                          ManProObj, pf_Special,    [tag_Control]);
  extSetProp(5151, "ய᪨ ",                        ManProObj, pf_Special,    [tag_Medicine]);
  extSetProp(5152, " ",                                   ManProObj, pf_Special,    [tag_Documents, tag_Facilities]);
  extSetProp(5155, "  ⨭᪮ ࠭ਯ樨",                     ManProObj, pf_Text,       [tag_FillDB]);
  extSetProp(5200, "㦥 㤮⮢७",                          ManProObj, pf_Special,    [tag_Documents]);
  extSetProp(5201, "ய",                                          ManProObj, pf_StrongPool, [tag_Documents, tag_Authority]);
  extSetProp(5202, "  ।⨥",                            ManProObj, pf_Special,    [tag_Documents, tag_Authority]);
  extSetProp(5203, "ᮡ 宦 ᬮ",               ManProObj, pf_Special,    [tag_Medicine]);
  extSetProp(5204, "樮 ",                               ManProObj, pf_Special,    [tag_Documents]);
  extSetProp(5205, "ࠡ⮪  ᮡ  㤮ᯮᮡ",      ManProObj, pf_Special,    [tag_Finance]);
  extSetProp(5206, "ᮡ  ",                         ManProObj, pf_Special,    [tag_Finance]);
  extSetProp(5207, "  ࠡ祥 ",                        ManProObj, pf_Special,    [tag_FillDB]);
  extSetProp(5208, "ᬮ  裡  ।묨 ᫮ﬨ 㤠",     ManProObj, pf_Special,    [tag_Medicine]);

  extSetProp(5800, "ਣ ",                                 SortProObj, pf_Special,   [tag_Traffic]);
  extSetProp(5801, "᭮ 㯯 横 鸞",                   SortProObj, pf_Special,   [tag_Traffic]);
  extSetProp(5802, "⥫ (1) 㯯 横 鸞",        SortProObj, pf_Special,   [tag_Traffic]);
  extSetProp(5803, "⥫ (2) 㯯 横 鸞",        SortProObj, pf_Special,   [tag_Traffic]);
  extSetProp(5804, "⥫ (3) 㯯 横 鸞",        SortProObj, pf_Special,   [tag_Traffic]);
  extSetProp(5805, "⮯ ந⢥ 頤",         SortProObj, pf_Special,   [tag_DescriptionObj]);
  extSetProp(5806, "⥫ (4) 㯯 横 鸞",        SortProObj, pf_Special,   [tag_Traffic]);

  extSetProp(6000, "᭮  ⠢",                        MDocProObj, pf_Special,   [tag_DescriptionObj]);
  extSetProp(6001, "宦 ꥪ  ।",                  MDocProObj, pf_StrongPool,[tag_DescriptionObj]);
  extSetProp(6003, "᭮ ६饭",                            MDocProObj, pf_StrongPool,[tag_DescriptionObj]);
  extSetProp(6004, "  ᮮ⢥ ",                          MDocProObj, pf_Text,      [tag_DescriptionObj]);
  extSetProp(6005, " ॡ ࠡ",                         MDocProObj, pf_Text,      [tag_DescriptionObj]);
  extSetProp(6006, " ⠭ ꥪ",                     MDocProObj, pf_Text,      [tag_DescriptionObj]);
  extSetProp(6007, "祭 ᨨ",                              MDocProObj, pf_StrongPool,[tag_DescriptionObj]);
  extSetProp(6008, "祭 .㬥樨",                        MDocProObj, pf_Text,      [tag_DescriptionObj]);
  extSetProp(6009, "",                                            MDocProObj, pf_Special,   [tag_DescriptionObj]);
  extSetProp(6010, "稭 ᯨᠭ",                                 MDocProObj, pf_StrongPool,[tag_DescriptionObj]);
  extSetProp(6011, "孨᪮ ﭨ",                            MDocProObj, pf_StrongPool,[tag_DescriptionObj]);
  extSetProp(6012, ".  ⨨    ",                 MDocProObj, pf_Special,   [tag_Traffic]);
  extSetProp(6013, " ᯨᠭ",                              MDocProObj, pf_Special,   [tag_FillDB]);
  extSetProp(6014, "  ᯨ.  祭",                 MDocProObj, pf_Special,   [tag_RespPersons]);
  extSetProp(6015, "''",                                      MDocProObj, pf_Special,   [tag_FillDB]);
  extSetProp(6016, "  (࠯஢ )",                 MDocProObj, pf_Special,   [tag_Finance]);
  extSetProp(6017, "१ ",                                       MDocProObj, pf_Special,   [tag_FillDB]);
  extSetProp(6018, "⥫쭠 ଠ",                        MDocProObj, pf_Special,   [tag_FillDB]);
  extSetProp(6019, "",                                           MDocProObj, pf_Special,   [tag_FillDB]);
  extSetProp(6020, "ᮡ ஫ ᤥ",                      MDocProObj, pf_Special,   [tag_FillDB]);
  extSetProp(6021, "।⠢⥫ ࠣ",                        MDocProObj, pf_Special,   [tag_FillDB]);
  extSetProp(6022, "ਬ砭",                                       MDocProObj, pf_Text,      [tag_FillDB]);
  extSetProp(6023, "㦥 ⬥⪨",                                MDocProObj, pf_Text,      [tag_FillDB]);
  extSetProp(6024, "ନ஢ ",                              MDocProObj, pf_Special,   [tag_FillDB]);
  extSetProp(6025, "    㯮",            MDocProObj, pf_Special,   [tag_FillDB]);
  extSetProp(6026, "      ",     MDocProObj, pf_Special,   [tag_FillDB]);

  extSetProp(0015, "䮭 ⤥ ஢",                            FirmProObj, pf_Special,    [tag_DescriptionObj]);
  extSetProp(0024, " ࠧ",                                FirmProObj, pf_Special,    [tag_RegInfo, tag_DescriptionObj]);
  extSetProp(0025, "   ",                                    FirmProObj, pf_Special,    [tag_RegInfo, tag_DescriptionObj]);
  extSetProp(1013, "㪮⥫   ᭮ ()",         FirmProObj, pf_Special,    [tag_FillDB]);
  extSetProp(7099, " 稭 ⠭.   ",                 FirmProObj, pf_Special,    [tag_RegInfo, tag_DescriptionObj]);
  extSetProp(7101, " ࠣ",                           FirmProObj, pf_Special,    [tag_DescriptionObj]);
  extSetProp(7105, "",                                              FirmProObj, pf_Special,    [tag_Documents, tag_RegInfo, tag_DescriptionObj]);
  extSetProp(7106, "  ",                                      FirmProObj, pf_Special,    [tag_RegInfo, tag_DescriptionObj]);
  extSetProp(7107, "",                                             FirmProObj, pf_Special,    [tag_RegInfo, tag_DescriptionObj]);
  extSetProp(7108, " ࣠樨  ",                  FirmProObj, pf_Special,    [tag_RegInfo, tag_DescriptionObj]);
  extSetProp(7115, "  ",                                     FirmProObj, pf_Special,    [tag_RegInfo, tag_DescriptionObj]);

  extSetProp(4100, " 誠  '㣨'",                        UnionProObj, pf_Special,   [tag_Finance]);
  extSetProp(4900, " 樨 . ࠡ⪠",                  UnionProObj, pf_Special,   [tag_Finance]);
  extSetProp(4901, " ६,  %",                               UnionProObj, pf_Special,   [tag_Finance]);
  extSetProp(4902, " ",                                    UnionProObj, pf_Special,   [tag_Finance]);

  extSetProp(6100, "⠬ ।  -",                     PDocProObj, pf_Special,    [tag_DocCirculation]);
  extSetProp(6101, "⠬ ਥ  -",                     PDocProObj, pf_Special,    [tag_DocCirculation]);
  extSetProp(6102, "⮯ ந⢥ 頤",         PDocProObj, pf_Special,    [tag_DescriptionObj]);
  extSetProp(6103, "ਬ砭",                                       PDocProObj, pf_Text,       [tag_DescriptionObj]);

  extSetProp(7310, "㬬",                                            CntrProObj, pf_Special,    [tag_Finance, tag_DocCirculation, tag_DescriptionObj]);
  extSetProp(7311, " ।",                                CntrProObj, pf_Special,    [tag_Finance, tag_DocCirculation, tag_DescriptionObj]);
  extSetProp(7312, "  客 ᡮ஢",                     CntrProObj, pf_Special,    [tag_DescriptionObj, tag_Finance]);
  extSetProp(7313, " ஭",                                CntrProObj, pf_Special,    [tag_DocCirculation, tag_DescriptionObj]);
  extSetProp(7314, "稥 ॠ쭮 ",                       CntrProObj, pf_Special,    [tag_DocCirculation, tag_DescriptionObj]);
  extSetProp(7315, "ਮ ⥦",                                   CntrProObj, pf_Special,    [tag_DocCirculation, tag_Date, tag_DescriptionObj]);
  extSetProp(7316, "ਮ ⥦  ਮ",                         CntrProObj, pf_Special,    [tag_DocCirculation, tag_Date, tag_DescriptionObj]);
  extSetProp(7317, "ப ⥦",                                     CntrProObj, pf_Special,    [tag_DocCirculation, tag_Date, tag_DescriptionObj]);
  extSetProp(7318, " - ⢥ । ",              CntrProObj, pf_Special,    [tag_DocCirculation, tag_DescriptionObj]);
  extSetProp(7319, "  ",                                  CntrProObj, pf_Special,    [tag_Finance]);
  extSetProp(7320, "⥦ ",                                 CntrProObj, pf_Special,    [tag_DocCirculation, tag_DescriptionObj]);
  extSetProp(7321, "㧮⥫",                                  CntrProObj, pf_Special,    [tag_DescriptionObj]);
  extSetProp(7322, "ଠ  祭 ⥦",                  CntrProObj, pf_Special,    [tag_FillDB, tag_DescriptionObj]);
  extSetProp(7323, "   ⮢",                  CntrProObj, pf_Special,    [tag_DescriptionObj]);
  extSetProp(7324, "⭮襭  䨫",                  CntrProObj, pf_Special,    [tag_DescriptionObj]);
  extSetProp(7325, "易⥫쭮  ",                     CntrProObj, pf_Special,    [tag_DescriptionObj]);
  extSetProp(7326, "   ⥦",                         CntrProObj, pf_Special,    [tag_DescriptionObj]);
  extSetProp(7327, "樠쭮 ⭮襭  ",                      CntrProObj, pf_Special,    [tag_DescriptionObj, tag_Finance]);
  extSetProp(7328, "易⥫ ᢮⢠ ࠣ",                CntrProObj, pf_Special,    [tag_FillDB, tag_DescriptionObj]);
  extSetProp(7329, " 㬥⮮",                       CntrProObj, pf_Special,    [tag_DocCirculation]);
  extSetProp(7330, " 㬥⮢ ",                        CntrProObj, pf_Special,    [tag_Documents, tag_DocCirculation, tag_DescriptionObj]);
  extSetProp(7331, "ப ⢨",                                    CntrProObj, pf_Special,    [tag_Date, tag_DescriptionObj]);
  extSetProp(7332, "⥫쭮 ᮣ襭",                        CntrProObj, pf_Special,    [tag_Documents, tag_DescriptionObj]);
  extSetProp(7333, " ⥪ ",                           CntrProObj, pf_Special,    [tag_DocCirculation, tag_DescriptionObj]);
  extSetProp(7334, "ᠭ ꥪ",                                 CntrProObj, pf_Special,    [tag_FillDB, tag_DescriptionObj]);
  extSetProp(7335, "।⠢⥫ ࠣ",                        CntrProObj, pf_Special,    [tag_RespPersons, tag_DescriptionObj]);
  extSetProp(7336, "।⠢⥫ 襩 ࣠樨",                  CntrProObj, pf_Special,    [tag_RespPersons, tag_DescriptionObj]);
  extSetProp(7337, "ࠬ ନ஢ ਮ᪨ ⮢",      CntrProObj, pf_Special,    [tag_Documents, tag_DocCirculation, tag_DescriptionObj]);
  extSetProp(7338, "祭 ⥦",                               CntrProObj, pf_Special,    [tag_FillDB, tag_DescriptionObj]);
  extSetProp(7339, "⥫  ",                CntrProObj, pf_Special,    [tag_Documents, tag_DocCirculation, tag_DescriptionObj]);
  extSetProp(7340, "஢ 業",                                      CntrProObj, pf_Special,    [tag_Finance]);
  extSetProp(7341, " ",                                    CntrProObj, pf_Special,    [tag_FillDB, tag_DescriptionObj]);
  extSetProp(7342, "ਮ᪠ ॠ",                         CntrProObj, pf_Special,    [tag_DescriptionObj]);
  extSetProp(7343, "ப ਮ᪮ ॠ樨",                    CntrProObj, pf_Special,    [tag_Date, tag_DescriptionObj]);
  extSetProp(7344, "ᮡ  ",                                 CntrProObj, pf_Special,    [tag_DescriptionObj, tag_Finance]);
  extSetProp(7345, "  権",                          CntrProObj, pf_Special,    [tag_FillDB, tag_DescriptionObj]);
  extSetProp(7346, "ࠢ    壠",         CntrProObj, pf_Special,    [tag_DescriptionObj]);

  extSetProp(2001, "।⢠ 㠫쭮 ",                   PostProObj, pf_Special,    [tag_DescriptionObj]);

  extSetProp(3000, "쭨 ",                                  AvePProObj, pf_Special,    [tag_Medicine, tag_Documents]);
  extSetProp(3001, "ᮡ ⠪஢ 㬥",                 AvePProObj, pf_Special,    [tag_DescriptionObj, tag_Finance]);
  extSetProp(3002, "⢮   ",                         AvePProObj, pf_Special,    [tag_Date, tag_DescriptionObj]);

  extSetProp(9000, "ॢ - ⠭ ",                   OwnDProObj, pf_Special,    [tag_Traffic]);
  extSetProp(9001, "⮢ 祪  ",                           OwnDProObj, pf_Special,    [tag_FillDB]);
  extSetProp(9002, " ᫮",                                 OwnDProObj, pf_Text,       [tag_Traffic]);
  extSetProp(9003, "饭  ⥢ 㬥 (, )",          OwnDProObj, pf_Special,    [tag_FillDB, tag_Traffic]);
  extSetProp(9005, "祭  ୥",                           OwnDProObj, pf_Special,    [tag_FillDB]);
  extSetProp(9006, "  ᯨ.  祭",                 OwnDProObj, pf_Special,    [tag_RespPersons]);
  extSetProp(9007, "⠫  १ࢭ ",                      OwnDProObj, pf_Special,    [tag_Control]);
  extSetProp(9008, "஫쭮 ६ ᯥ",                     OwnDProObj, pf_Special,    [tag_Traffic, tag_Date]);
  extSetProp(9009, "४  ⮯",                          OwnDProObj, pf_Special,    [tag_Traffic, tag_Norm]);
  extSetProp(9010, "",                                      OwnDProObj, pf_Special,    [tag_FillDB]);
  extSetProp(9011, "ய  '।' ",                OwnDProObj, pf_Special,    [tag_Finance]);
  extSetProp(9012, "  ᫥ ",                    OwnDProObj, pf_Special,    [tag_RespPersons, tag_Traffic]);
  extSetProp(9013, "   ॢ",                   OwnDProObj, pf_Special,    [tag_Finance]);
  extSetProp(9015, "쭠 ",                               OwnDProObj, pf_Special,    [tag_Finance]);
  extSetProp(9016, "筮 壠᪮ ",                    OwnDProObj, pf_Special,    [tag_Finance]);
  extSetProp(9018, "    ",                           OwnDProObj, pf_Special,    [tag_Finance]);
  extSetProp(9019, "⠢   த, %",                        OwnDProObj, pf_Special,    [tag_Finance]);
  extSetProp(9020, " / (/)",                         OwnDProObj, pf_Special,    [tag_Documents, tag_Traffic]);
  extSetProp(9021, "業 ணᨢ",                             OwnDProObj, pf_Special,    [tag_Finance]);
  extSetProp(9022, "  業 ஥ 㬥⮢",                OwnDProObj, pf_Special,    [tag_Traffic]);
  extSetProp(9023, " ⥫  த ",                    OwnDProObj, pf_Special,    [tag_Traffic, tag_Finance]);
  extSetProp(9024, "ଠ⨢  ⨬",                          OwnDProObj, pf_Special,    [tag_Traffic, tag_Norm]);
  extSetProp(9025, "",                                         OwnDProObj, pf_Special,    [tag_FillDB]);
  extSetProp(9026, "ᠭ ᬥ  ⭮ ",                  OwnDProObj, pf_Special,    [tag_FillDB]);
  extSetProp(9027, "祭 ᭮ ⭮ த樨",             OwnDProObj, pf_Special,    [tag_FillDB]);
  extSetProp(9028, "ࠬ ᮯ殮  ",                     OwnDProObj, pf_Special,    [tag_FillDB]);
  extSetProp(9029, " 䨪樨 ࢨ 㬥⮢",          OwnDProObj, pf_Special,    [tag_Authority]);

  extSetProp(8002, "樮    ",                  MFProObj,   pf_Special,    [tag_Documents, tag_RegInfo, tag_DescriptionObj]);
  extSetProp(8003, " ",                            MFProObj,   pf_Special,    [tag_RegInfo, tag_DescriptionObj]);
  extSetProp(8004, "砫쭨 ⤥ ஢",                          MFProObj,   pf_Special,    [tag_RespPersons, tag_DescriptionObj]);
  extSetProp(8005, ".   .窨",                 MFProObj,   pf_Special,    [tag_DocCirculation, tag_RespPersons, tag_DescriptionObj]);
  extSetProp(8006, ".  ஢ . 窨",                 MFProObj,   pf_Special,    [tag_DocCirculation, tag_RespPersons, tag_DescriptionObj]);
  extSetProp(8007, "ࠢ⥫ ᢥ. 室  ",                 MFProObj,   pf_Special,    [tag_DocCirculation, tag_RespPersons, tag_DescriptionObj]);
  extSetProp(8008, "ࠢ⥫   ",                         MFProObj,   pf_Special,    [tag_DocCirculation, tag_RespPersons, tag_DescriptionObj]);
  extSetProp(8009, "ࠢ⥫ ᢥ  ",                      MFProObj,   pf_Special,    [tag_DocCirculation, tag_RespPersons, tag_DescriptionObj]);
  extSetProp(8010, "⢥.  ⭮  ",                   MFProObj,   pf_Special,    [tag_DocCirculation, tag_RespPersons, tag_DescriptionObj]);
  extSetProp(8011, "",                                           MFProObj,   pf_Special,    [tag_RespPersons, tag_DescriptionObj]);
  extSetProp(8012, "壠   .権",                 MFProObj,   pf_Special,    [tag_RespPersons, tag_DescriptionObj]);
  extSetProp(8013, " ",                                  MFProObj,   pf_Special,    [tag_RespPersons, tag_DescriptionObj]);
  extSetProp(8014, " ",                                MFProObj,   pf_Special,    [tag_RespPersons, tag_DescriptionObj]);
  extSetProp(8015, "砫쭨 ਤ᪮ ⤥",                    MFProObj,   pf_Special,    [tag_RespPersons, tag_DescriptionObj]);
  extSetProp(8016, "७   ",                          MFProObj,   pf_Special,    [tag_RespPersons, tag_DescriptionObj]);
  extSetProp(8017, "⠢   ⢮",                       MFProObj,   pf_Special,    [tag_Finance, tag_DescriptionObj]);
  extSetProp(8018, "樮    ",                  MFProObj,   pf_Special,    [tag_Documents, tag_RegInfo, tag_DescriptionObj]);
  extSetProp(8019, " 䮭 ",                     MFProObj,   pf_Text,       [tag_RegInfo, tag_DescriptionObj]);
  extSetProp(8020, " ⤥  ",                    MFProObj,   pf_Text,       [tag_RegInfo, tag_DescriptionObj]);
  extSetProp(8021, "ࠢ⥫ 樮 㢥",             MFProObj,   pf_Special,    [tag_DocCirculation, tag_RespPersons, tag_DescriptionObj]);
  extSetProp(8022, "樮    ",                   MFProObj,   pf_Special,    [tag_Documents, tag_RegInfo, tag_DescriptionObj]);
  extSetProp(8023, "樮   ",                   MFProObj,   pf_Special,    [tag_Documents, tag_RegInfo, tag_DescriptionObj]);
  extSetProp(8024, " 䨪樮   ॣ",       MFProObj,   pf_Special,    [tag_RegInfo, tag_DescriptionObj]);

  extSetProp(8500, "",                                           DsptMProObj, pf_Special,   [tag_DocCirculation, tag_RespPersons, tag_DescriptionObj]);
  extSetProp(8501, " 裡",                                   DsptMProObj, pf_Special,   [tag_DescriptionObj]);
  extSetProp(8502, " ",                                   DsptMProObj, pf_Special,   [tag_DescriptionObj]);
  extSetProp(8503, "",                                            DsptMProObj, pf_Special,   [tag_Finance, tag_DescriptionObj]);
  extSetProp(8504, "஫ ப",                                DsptMProObj, pf_Special,   [tag_Date, tag_DescriptionObj]);

  extSetProp(7600, " ࠧ饭",                                 CUCProObj,   pf_Text,      [tag_DescriptionObj]);
  extSetProp(7601, "稭 ᯨᠭ",                                 CUCProObj,   pf_Special,   [tag_DescriptionObj]);
  extSetProp(7602, "⥫ 䨪",                     CUCProObj,   pf_Text,      [tag_DescriptionObj]);
  extSetProp(7603, "ᮡ ᯮ짮",                        CUCProObj,   pf_Special,   [tag_DescriptionObj]);

  extSetProp(3500, "ࠪ⨪ 㬥⮮",                  StrgProObj,  pf_Special,   [tag_DocCirculation]);
  extSetProp(3501, "ᮡ ࠭ ",                         StrgProObj,  pf_Special,   [tag_FillDB]);
  extSetProp(3502, "殮   ",                              StrgProObj,  pf_Special,   [tag_FillDB]);

  extSetProp(1401, "ᯮ 㤮  ",          ExitProObj,  pf_Special,   [tag_Traffic]);
  extSetProp(1402, "⮬᪠ ࠧ浪",                        ExitProObj,  pf_Special,   [tag_Traffic]);
  extSetProp(1404, "",                                             ExitProObj,  pf_Special,   [tag_Traffic, tag_DescriptionObj]);
  extSetProp(1405, "ਬ砭 ( ᮡ ᯮ 室)",   ExitProObj,  pf_Special,   [tag_Traffic]);

  extSetProp(1501, "⢮   १ࢥ",                          TKindProObj, pf_Special,   [tag_Traffic, tag_DescriptionObj]);

  extSetProp(7500, "ᮡ । ",                         CIProObj,    pf_Special,   [tag_Finance]);

  extSetProp(4501, "⥫쭠 ଠ",                        RprProObj,   pf_Special,   [tag_DescriptionObj]);
  extSetProp(4502, "⮯",                                   RprProObj,   pf_SoftPool,  [tag_DescriptionObj]);
  extSetProp(4503, " ",                                     RprProObj,   pf_Special,   [tag_DescriptionObj]);
  extSetProp(4504, "ୠ ६⭠ ࠡ",                       RprProObj,   pf_Special,   [tag_DescriptionObj]);
  extSetProp(4505, " ᪠",                                     RprProObj,   pf_StrongPool,[tag_DescriptionObj]);
  extSetProp(4506, "稭 믮",                             RprProObj,   pf_SoftPool,  [tag_DescriptionObj]);
  extSetProp(4507, "⪠ ଠ  ",                         RprProObj,   pf_SoftPool,  [tag_DescriptionObj]);
  extSetProp(4508, " ᫮",                               RprProObj,   pf_StrongPool,[tag_DescriptionObj]);
  extSetProp(4509, "ࠬ ⥫",                              RprProObj,   pf_Special,   [tag_DescriptionObj]);

  extSetProp(1169, "९  ⮬",                         CarProObj,   pf_Special,   [tag_Traffic]);

  extSetProp(2500, "ਮ ᢥન ⮢",                           ODocProObj,  pf_Special,   [tag_Date, tag_DescriptionObj]);
  extSetProp(2501, "ப ⢨ 㬥",                          ODocProObj,  pf_Special,   [tag_DocCirculation, tag_Date, tag_DescriptionObj]);
  extSetProp(2502, "ন 㬥",                             ODocProObj,  pf_Special,   [tag_DocCirculation, tag_DescriptionObj]);
  extSetProp(2503, "⭨",                                         ODocProObj,  pf_Special,   [tag_DescriptionObj]);
  extSetProp(2504, "ਬ砭",                                       ODocProObj,  pf_Special,   [tag_DescriptionObj]);

  extSetProp(3600, "⭮襭  客 ᠬ",                    MCProObj,    pf_Special,   [tag_DescriptionObj, tag_Finance]);
  extSetProp(3601, "ᮡ    ࠡ⭨",                     MCProObj,    pf_Special,   [tag_DescriptionObj]);
  extSetProp(3602, "宦    ६",                      MCProObj,    pf_Special,   [tag_DescriptionObj, tag_Finance]);
  extSetProp(3603, "⭮襭  ᠬ ' ࠢ⨧'",              MCProObj,    pf_Special,   [tag_DescriptionObj, tag_Finance]);
  extSetProp(3604, "᫥  騥 ਮ (ᮡ)",      MCProObj,    pf_Special,   [tag_DescriptionObj, tag_Finance]);
  extSetProp(3605, "  㢮쭥 (ᮡ)",           MCProObj,    pf_Special,   [tag_DescriptionObj, tag_Finance]);
  extSetProp(3606, "ਨ",                                      MCProObj,    pf_Text,      [tag_DescriptionObj]);
  extSetProp(3607, "ᮡ ।",                             MCProObj,    pf_Special,   [tag_DescriptionObj]);

  extSetProp(5500, "⮯ ந⢥ 頤",         ClmnProObj,  pf_Special,   [tag_DescriptionObj]);

  extSetProp(5600, "  ",                                     MPProObj,    pf_Special,   [tag_RegInfo]);
  extSetProp(5601, " 稭 ⠭    . ࣠", MSProObj,    pf_Special,   [tag_RegInfo]);

  E_SetProperty();
 END {SetProperty};

 PUBLIC PROCEDURE PositionOnProperty(_Property: LIKE(Property.Property));
 BEGIN
  L_General.Assert(SEARCH(Property, Property, _Property),
                   " ࠢ筨 ᢮ ꥪ⮢ |᢮⢮   " + _Property);
 END {PositionOnProperty};

 PUBLIC PROCEDURE GetCurVideoFieldArrName(): STRING[];
  VAR
   FieldName : STRING[];
   LastDlmPos: NUMERIC[0];
 BEGIN
  FieldName:=RTI.Get().CurZone.ActiveField.Name;
  LastDlmPos:=Str.Pos(FieldName, "_", Str.Length(FieldName), BACKWARD);
  RETURN Str.Slice(FieldName, 0, LastDlmPos);
 END {GetCurVideoFieldArrName};

(*!!  GetCurVideoFieldArrIdx*)
 PUBLIC PROCEDURE GetVideoFieldArrIdx(FieldName: STRING[]): NUMERIC[0];
  VAR
   LastDlmPos: NUMERIC[0];
   y: STRING[];
 BEGIN
  LastDlmPos:=Str.Pos(FieldName, "_", Str.Length(FieldName), BACKWARD);
  y:=Str.Slice(FieldName, LastDlmPos+1, Str.Length(FieldName) - LastDlmPos);
  RETURN STRTOFLD(Str.Slice(FieldName, LastDlmPos+1, Str.Length(FieldName) - LastDlmPos), NUMERIC);
 END {GetVideoFieldArrIdx};

 PUBLIC PROCEDURE GetCurVideoFieldArrIdx(): NUMERIC[0];
 BEGIN
  RETURN GetVideoFieldArrIdx(RTI.Get().CurZone.ActiveField.Name);
 END {GetCurVideoFieldArrIdx};

 PUBLIC PROCEDURE BuildVideoFieldName(FieldName: STRING[]; Idx: NUMERIC[0]): STRING[];
 BEGIN
  RETURN FieldName + "_" + L_Str.IntStr(Idx);
 END {BuildVideoFieldName};

 PUBLIC PROCEDURE IsEmptyDateArray(_Array: DATE[]): SCAL[2];
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i <= HIGH(_Array) DO
   IF ~!_Array[i] THEN
    RETURN 0;
   END;
   INC(i);
  END; (* WHILE i <= HIGH(_Array)...*)
  RETURN 1;
 END {IsEmptyDateArray};

 PUBLIC PROCEDURE IsEmptyStrArray(_Array: STRING[][]): SCAL[2];
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i <= HIGH(_Array) DO
   IF ~!_Array[i] THEN
    RETURN 0;
   END;
   INC(i);
  END; (* WHILE i <= HIGH(_Array)...*)
  RETURN 1;
 END {IsEmptyStrArray};

 PUBLIC PROCEDURE IsEmptyNumArray(_Array: FLOAT[]): SCAL[2];
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i <= HIGH(_Array) DO
   IF ~!_Array[i] THEN
    RETURN 0;
   END;
   INC(i);
  END; (* WHILE i <= HIGH(_Array)...*)
  RETURN 1;
 END {IsEmptyNumArray};

 PRIVATE PROCEDURE HasNotEmptyDocExpD(CurFile: STRING[]): SCAL[2];
 BEGIN
  IF ~!DATABASE.Get().Tables(CurFile).Fields("DocExpD") THEN
   IF ~!(^CurFile.DocExpD) THEN
    RETURN 1;
   END;
  END;
  RETURN 0;
 END {HasNotEmptyDocExpD};

 PUBLIC PROCEDURE SupportEndDate(CurFile  : STRING[];
                                 _Property: LIKE(Property.Property);
                                 WithCur  : SCAL[2]);
  VAR
   CurDate,
   _Date,
   _EndDate : DATE;
   SelStr   : STRING[];
   curTable: TABLE;
   curField: FIELD;
 BEGIN
  curTable:=DATABASE.Get().Tables(CurFile);
  IF ~!curTable.Fields("Date") THEN
   CurDate:=^CurFile.Date;
   SAVE(^CurFile);
   SelStr:=curTable.LendLink.Name + ", ";
   FOR_EACH curField IN curTable.LendLink.Index.Fields DO
    IF curField.Name = "Property" THEN
     EXIT;
    ELSE
     SelStr:=SelStr + CurFile + "." + curField.Name + ", ";
    END;
   END;
   SelStr:=SelStr + "_Property";
   SETSEL(^CurFile, ^SelStr);
   LAST(^CurFile);
   SETEMPTY(_Date);
   WHILE OCCURE(^CurFile) DO
    IF (^CurFile.Date # CurDate) | WithCur THEN
     IF !_Date THEN
      IF HasNotEmptyDocExpD(CurFile) THEN
       _EndDate:=^CurFile.DocExpD - 1;
      ELSE
       SETEMPTY(_EndDate);
      END;
     ELSIF HasNotEmptyDocExpD(CurFile) THEN
      _EndDate:=Math.Min(_Date - 1, ^CurFile.DocExpD - 1);
     ELSE
      _EndDate:=_Date - 1;
     END;
     IF _EndDate # ^CurFile.EndDate THEN
      ^CurFile.EndDate:=_EndDate;
      REPLACE(^CurFile);
      L_Group.SupportInteractiveModificationOwner(CurFile, L_SysLog.knd_AutoEdit);
      L_qs.byPro_RenovateValidyty(CurFile);
     END;
     _Date:=^CurFile.Date;
    END;
    PREV(^CurFile);
   END; (* WHILE OCCURE(^CurFile) ... *)
   RESTORE(^CurFile);
  END; (* IF ~!curTable.Fields("Date") ... *)
 END {SupportEndDate};

 PUBLIC PROCEDURE extInsertProperty(_Property: LIKE(Property.Property);
                                    _Begin   : DATE;
                                    _IsUsed  : LIKE(Property.IsUsed);
                                    _CopyPrvV: LIKE(Property.CopyPrvV));
  VAR
   defaultGroups: STRING[];
 BEGIN
  L_General.CallUs(~SEARCH(Property, Property, _Property));
  SetProperty();
  SEARCH(_Prop, Property, , _Property);
  Property.Property:=_Prop.Property;
  Property.Name    :=_Prop.Name;
  Property.Object  :=_Prop.Object;
  Property.Format  :=_Prop.Format;
  Property.Begin   :=_Begin;
  Property.Tag     :=_Prop.Tag;
  SETEMPTY(Property.Till, Property.Rights, Property.SpRights, Property.AlwDelay, Property.apModify, Property.apBDMdf);
  Property.CopyPrvV:=_CopyPrvV;
  Property.IsUsed  :=_IsUsed;
  INSERT(Property);
 END {extInsertProperty};

 PUBLIC PROCEDURE InsertProperty(_Property: LIKE(Property.Property); _Begin: DATE);
 BEGIN
  extInsertProperty(_Property, _Begin, 0, cpv_None);
 END {InsertProperty};

 PUBLIC PROCEDURE RemoveProperty(_Property: LIKE(Property.Property));
  VAR
   curapModify: LIKE(Property.apModify);
   curapBDMdf : LIKE(Property.apBDMdf);
 BEGIN
  SEARCH(Property, Property, , _Property);
  TRY [INTEGRITY(INTEGRITY_ON)]
   curapModify:=Property.apModify;
   curapBDMdf :=Property.apBDMdf;
   REMOVE(Property);
   IF SEARCH(AcsPnt, AcsPnt, curapModify) THEN
    REMOVE(AcsPnt);
   END;
   IF SEARCH(AcsPnt, AcsPnt, curapBDMdf) THEN
    REMOVE(AcsPnt);
   END;
  EXCEPT
  END; (* TRY *)
 END {RemoveProperty};

 PUBLIC PROCEDURE ConvEmptyRecordPropertyValue(VAR Value: STRING[]);
  VAR
   tmpValue: STRING[];
 BEGIN
  tmpValue:=Str.Condense(Str.Replace(Value, "[", ""));
  tmpValue:=Str.Condense(Str.Replace(tmpValue, "]", ""));
  tmpValue:=Str.Condense(Str.Replace(tmpValue, ";", ""));
  IF !tmpValue THEN
   SETEMPTY(Value);
  END;
 END {ConvEmptyRecordPropertyValue};

 PUBLIC PROCEDURE GetDocSerAndNum(    trgDocAttr: STRING[];
                                  VAR trgDocSer : STRING[];
                                  VAR trgDocNum : STRING[]);
  VAR
   Pos: NUMERIC[0];
 BEGIN
  SETEMPTY(trgDocSer, trgDocNum);
  IF ~!trgDocAttr THEN
   Pos:=Str.Pos(trgDocAttr, " ", , BACKWARD);
   IF Pos # Str.Length(trgDocAttr) THEN
    trgDocSer:=Str.Slice(trgDocAttr, 0,   Pos);
    INC(Pos);
    trgDocNum:=Str.Slice(trgDocAttr, Pos, Str.Length(trgDocAttr) - Pos);
   ELSE
    trgDocSer:="";
    trgDocNum:=trgDocAttr;
   END;
  END;
 END {GetDocSerAndNum};

 PUBLIC PROCEDURE CombineDocDescription(trgDocKind,
                                        trgDocSer,
                                        trgDocNbr,
                                        trgDocGiveS: STRING[];
                                        trgDocExpD,
                                        trgDocGiveD: DATE): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=trgDocKind;
  IF ~!trgDocSer THEN
   Result:=Result + "  " + trgDocSer;
  END;
  IF ~!trgDocNbr THEN
   Result:=Result + " " + trgDocNbr;
  END;
  IF ~!trgDocGiveD | ~!trgDocGiveS THEN
   Result:=Result + ", 뤠";
   IF ~!trgDocGiveD THEN
    Result:=Result + " " + L_DatTim.DateStr(trgDocGiveD);
   END;
   IF ~!trgDocGiveS THEN
    Result:=Result + " " + trgDocGiveS;
   END;
  END;
  IF ~!trgDocExpD THEN
   Result:=Result + ", ⢨⥫  " + L_DatTim.DateStr(trgDocExpD);
  END;
  RETURN Result;
 END {CombineDocDescription};

 PUBLIC PROCEDURE GetMyPlaceVal2Show(proValue: STRING[]): STRING[];
  VAR
   Result    : STRING[];
   trgMyPlace: LIKE(MyPlace.MyPlace);
 BEGIN
  SETEMPTY(Result);
  trgMyPlace:=L_r2r.DecodeReferenceStamp(proValue);
  IF ~!trgMyPlace THEN
   SAVE(MyPlace);
   SEARCH(MyPlace, MyPlace, , trgMyPlace);
   Result:=MyPlace.MyPlace + " " + MyPlace.Name;
   RESTORE(MyPlace);
  END;
  RETURN Result;
 END {GetMyPlaceVal2Show};

 PRIVATE PROCEDURE GetProLink(mstTable: TABLE): LINK;
  VAR
   curLink,
   Result : LINK;
 BEGIN
  SETEMPTY(Result);
  FOR_EACH curLink IN mstTable.Links DO
   IF (curLink.Kind = LINK.Kind_Lend) &
      L_PCS.IsAnyProTable(curLink.CooIndex.Table) THEN
    Result:=curLink;
    EXIT;
   END; (* IF curLink.Kind = LINK.Kind_Lend ... *)
  END; (* FOR_EACH curLink ... *)
  L_General.CallUs(~!Result);
  RETURN Result;
 END {GetProLink};

 PUBLIC PROCEDURE RemoveCurrentPro(File: STRING[]);
 BEGIN
  L_r2r.User_OnBeforeModify(File);
  L_qs.OnBeforeDelete(File);
  REMOVE((File));
 END {RemoveCurrentPro};

 PRIVATE PROCEDURE intAnyProBeginChange(curFileName: STRING[]; prvBD: DATE; Silent: SCAL[2]);
  VAR
   curTable,
   proTable : TABLE;
   proLink  : LINK;
   curFRVT,
   proFRVT  : L_DBD.tFileRecordsValidityType;
   curBD,
   curED,
   proBD,
   proED    : DATE;
   proTN,
   proBDFN,
   proEDFN  : STRING[];
   AskMsg   : STRING[];
   NeedShift: SCAL[2];
 BEGIN
  curTable:=TABLE.Get(curFileName);
  L_DBD.GetSrcFileValidity(curTable, curFRVT, curBD, curED);
  IF ~!curFRVT &
     (curFRVT # L_DBD.frvt_None) &
     (curBD # prvBD) THEN
   proLink:=GetProLink(curTable);
   IF ~!proLink THEN
    proTable:=proLink.CooIndex.Table;
    proTN:=proTable.Name;
    IF (L_DBD.FileHasValidityFields(proTN) # L_DBD.frvt_None) THEN
     L_DBD.SelectUsers(curTable.Name, proLink.Name);
     IF OCCURE((proTN)) THEN
      IF Silent THEN
       AskMsg:="";
      ELSE
       AskMsg:=" 砫 ਮ ਬ ᢮  c " + L_DatTim.DateStr(prvBD) + "  " + L_DatTim.DateStr(curBD);
      END;
      proBDFN:=proTable.Fields("Date").ObtainName();
      proEDFN:=proTable.Fields("EndDate").ObtainName();
 
      WHILE OCCURE((proTN)) DO
       NARROWSEL((proTN), Property);
 
       IF    curBD < prvBD THEN
        IF SRCINSEL((proTN), EQ, prvBD) THEN
         SAVE((proTN));
         NeedShift:=~PREV((proTN));
         RESTORE((proTN));
         IF ~!AskMsg THEN
          TOOLTIP(AskMsg);
          AskMsg:="";
         END;
         IF NeedShift THEN
          ^proBDFN:=curBD;
          L_qs.byPro_RenovateValidyty(proTN);
          REPLACE((proTN));
         END;
        END; (* SRCINSEL((proTN), EQ ... *)
       ELSIF curBD > prvBD THEN
        WHILE OCCURE((proTN)) & (^proBDFN < curBD) DO
         IF ~!AskMsg THEN
          TOOLTIP(AskMsg);
          AskMsg:="";
         END;
         IF ^proEDFN < curBD THEN
          RemoveCurrentPro(proTN);
         ELSE
          ^proBDFN:=curBD;
          REPLACE((proTN));
          L_qs.byPro_RenovateValidyty(proTN);
          L_General.CallUs(~PREV((proTN)));
         END;
        END; (* WHILE OCCURE(^proTN) ... *)
       ELSE
        L_General.CallUs(0);
       END;
       NEXTINEXTENDEDSEL((proTN), Property);
      END; (* WHILE OCCURE((proTN)) *)
     END; (* IF OCCURE((proTN)) ... *)
    END; (* IF (FileHasValidityFields( ... *)
   END; (* IF ~!proLink ... *)
  END; (* IF ~!curFRVT ... *)
 END {intAnyProBeginChange};

 PUBLIC PROCEDURE NoninteractiveAnyProBeginChange(curFileName: STRING[]; prvBD: DATE);
 BEGIN
  intAnyProBeginChange(curFileName, prvBD, 1);
 END {NoninteractiveAnyProBeginChange};

 PUBLIC PROCEDURE AnyProBeginChange(curFileName: STRING[]; prvBD: DATE);
 BEGIN
  intAnyProBeginChange(curFileName, prvBD, 0);
 END {AnyProBeginChange};

 PUBLIC PROCEDURE extCopyProRecords(mstTableName: STRING[];
                                    srcMstRI,
                                    dstMstRI    : NUMERIC[0];
                                    MakeProfile : SCAL[2];
                                    MdfExtraProc: PROC);
  VAR
   mstTable,
   proTable : TABLE;
   proLink  : LINK;
   proTN,
   proDateFN: STRING[];
   f        : FIELD;
   srcProRI,
   dstProRI : NUMERIC[0];
   srcMstFRVT,
   dstMstFRVT: L_DBD.tFileRecordsValidityType;
   srcMstBD,
   srcMstED,
   dstMstBD,
   dstMstED  : DATE;
 BEGIN
  mstTable:=TABLE.Get(mstTableName);
  proLink:=GetProLink(mstTable);
  IF ~!proLink THEN
   TRY [RESTORE_CURSORS(RC_ON)]
    proTable:=proLink.CooIndex.Table;
    proTN:=proTable.Name;

    SEARCH((mstTableName), RECORDID, , srcMstRI);
    L_DBD.SelectUsers(mstTable.Name, proLink.Name);

    L_DBD.GetSrcFileValidity(mstTable, srcMstFRVT, srcMstBD, srcMstED);

    SEARCH((mstTableName), RECORDID, , dstMstRI);

    IF ~!srcMstFRVT & (srcMstFRVT # L_DBD.frvt_None) THEN
     L_DBD.GetSrcFileValidity(mstTable, dstMstFRVT, dstMstBD, dstMstED);
     L_General.CallUs(srcMstFRVT = dstMstFRVT);
     proDateFN:=proTable.Fields("Date").ObtainName(); (*᫨    ਮ ਬ,  ᢮⢠  ⮦  *)
    ELSE
     SETEMPTY(srcMstBD, dstMstBD);
    END;


    WHILE OCCURE((proTN)) DO
     IF !proTable.Fields("Redefine") | (^(proTable.Fields("Redefine").ObtainName()) # rd_TransferFromTemplate) THEN
      IF ~MakeProfile & (!dstMstBD | (^(proTable.Fields("EndDate").ObtainName()) >= dstMstBD)) |
          MakeProfile & (L_DatTim.IsActive_Inc(Memo.ud_cd(),
                                               ^(proTable.Fields("Date"   ).ObtainName()),
                                               ^(proTable.Fields("EndDate").ObtainName()))) THEN
       TRY [RESTORE_CURSORS(RC_ON)]
        srcProRI:=^(proTable.Fields("RECORDID").ObtainName());
        FOR_EACH f IN proLink.Index.Fields DO
         ^(proTable.Fields(f.Name).ObtainName()):=^(f.ObtainName());
        END;
        IF ~!dstMstBD THEN
         IF ^proDateFN = srcMstBD THEN
          ^proDateFN:=dstMstBD;
         ELSE
          ^proDateFN:=Math.Max(^proDateFN, dstMstBD);
         END;
        END;
        TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
         INSERT((proTN));
        EXCEPT
        ON Exc: Exc_Root DO
         IF (Exc.ErrorCode # L_General.ec_rt_UniquenessViolation) | ~MakeProfile THEN
          RAISE();
         END;
        END; (* TRY *)
        IF OCCURE((proTN)) THEN
         IF ~!MdfExtraProc THEN
          MdfExtraProc();
         END;
         IF MakeProfile THEN
          ^(proTable.Fields("Redefine").ObtainName()):=rd_TransferFromTemplate;
          REPLACE((proTN));
         END;
         dstProRI:=^(proTable.Fields("RECORDID").ObtainName());
         L_r2r.MakeCopy(proTN, srcProRI, dstProRI);
         L_qs.byPro_MakeCopy(proTable.Id, mstTable.Id, srcProRI, dstProRI, srcMstRI, dstMstRI);
        END; (* IF OCCURE ... *)
       EXCEPT
       END; (* TRY *)
      END; (* IF !minBD ... *)
     END; (* IF !proTable.Fields("Redefine") ... *)
     NEXT((proTN));
    END; (* WHILE OCCURE((proTN)) ... *)
   EXCEPT
   END; (* TRY *)
  END; (* IF ~!proLink ... *)
 END {extCopyProRecords};

 PUBLIC PROCEDURE CopyProRecords(mstTableName: STRING[]; srcMstRI, dstMstRI: NUMERIC[0]);
 BEGIN
  extCopyProRecords(mstTableName, srcMstRI, dstMstRI, 0, EMPTYOF(PROC));
 END {CopyProRecords};

 PRIVATE PROCEDURE aim_GetFormFieldType(Field: FORM_FIELD): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  IF    Str.Match(Field.Expression, "NUMERIC*") THEN
   Result:=L_General.ft_NUMERIC;
  ELSIF Str.Match(Field.Expression, "SCAL*") THEN
   Result:=L_General.ft_SCAL;
  ELSIF Str.Match(Field.Expression, "STRING*") THEN
   Result:=L_General.ft_STRING;
  ELSIF Str.Match(Field.Expression, "DATE*") THEN
   Result:=L_General.ft_DATE;
  ELSE
   L_General.CallUs(0);
  END;
  RETURN Result;
 END {aim_GetFormFieldType};

 PUBLIC PROCEDURE ArrayItemMove(Dir: NUMERIC[0]; FieldNames: STRING[][]);
  CONST
   MaxIdx = 20;
  VAR
   i, Idx,
   FieldType: NUMERIC[0];
   FN,
   srcFN,
   dstFN    : STRING[];
   Fields   : FORM_FIELDS;
   StrArr   : STRING[][MaxIdx];
   NumArr   : FLOAT[MaxIdx];
   ScalArr  : SCAL[1E9][MaxIdx];
   DateArr  : DATE[MaxIdx];
   Modifiable: SCAL[2][MaxIdx];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Idx   :=GetCurVideoFieldArrIdx();
  i  :=0;
  FOR_EACH FN IN FieldNames DO
   srcFN    :=L_WDO.Fld_wIdx(FN, Idx);
   dstFN    :=L_WDO.Fld_wIdx(FN, Idx+Dir);
   FieldType:=aim_GetFormFieldType(Fields(srcFN));

   IF    FieldType = L_General.ft_NUMERIC THEN
    NumArr[i] :=Fields(dstFN).Value;
   ELSIF FieldType = L_General.ft_SCAL THEN
    ScalArr[i]:=Fields(dstFN).Value;
   ELSIF FieldType = L_General.ft_STRING THEN
    StrArr[i] :=Fields(dstFN).Value;
   ELSIF FieldType = L_General.ft_DATE THEN
    DateArr[i]:=Fields(dstFN).Value;
   ELSE
    L_General.CallUs(0);
   END;

   Modifiable[i]:=Fields(dstFN).Modifiable;

   Fields(dstFN).Value     :=Fields(srcFN).Value;
   Fields(dstFN).Modifiable:=Fields(srcFN).Modifiable;

   IF    FieldType = L_General.ft_NUMERIC THEN
    Fields(srcFN).Value:=NumArr[i];
   ELSIF FieldType = L_General.ft_SCAL THEN
    Fields(srcFN).Value:=ScalArr[i];
   ELSIF FieldType = L_General.ft_STRING THEN
    Fields(srcFN).Value:=StrArr[i];
   ELSIF FieldType = L_General.ft_DATE THEN
    Fields(srcFN).Value:=DateArr[i];
   ELSE
    L_General.CallUs(0);
   END;
   Fields(srcFN).Modifiable:=Modifiable[i];
   INC(i);
  END; (* FOR_EACH *)
 END {ArrayItemMove};

END.
