(*
%Copyright   (c) Polak Computer System
%Author      20.02.1999 01:13:00 MOG
%Purpose     ८ࠧ ப: ᫮ ਬ᪮ - > ᫮ ࠡ᪮
%Type        library
%Specific    SYS
%Modified    18.08.2010 18:38:37 POLAK\Gina
%Environment

   Exports:

 * RomanToArabic(s: STRING[]): NUMERIC[0];
     ८ࠧ ਬ᪮ 樨  ᫮.
     室:
      ப  ਬ᪮ 樨 (*ᨬ I V X L C*)
     :
      =0 -  ப
      >0 - ଠ쭮 襭, ८ࠧ 祭
      <0 - -(  ப,  ன  ࢠ 訡 (*稭  1*))
     ᮡ:
      ਬ   [0..399]
*)

 MODULE L_Roman [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Str;
 
 PRIVATE PROCEDURE RSerial(s: STRING[]; VAR p: NUMERIC[0]; Weight: NUMERIC[0]; RDig: STRING[]): NUMERIC[0];
  CONST
   AVal="876532941";
  VAR
   i, l: NUMERIC[0];
   _Rdigit: STRING[30];
 BEGIN
  IF p<Str.Length(s) THEN
   i:=0;
   LOOP
    _Rdigit:=Str.Item(RDig, " ", i);
    IF !_Rdigit THEN
     RETURN 0;
    ELSIF Str.Pos(s, _Rdigit, p)=p THEN
     INC(p, Str.Length(_Rdigit));
     RETURN Weight*STRTOFLD(AVal[i], NUMERIC);
    END;
    INC(i);
   END;
  ELSE
   RETURN 0;
  END;
 END {RSerial};

 PUBLIC PROCEDURE RomanToArabic(s: STRING[]): NUMERIC[0];
  VAR
   _pos,
   _val: NUMERIC[0];
 BEGIN
  IF ~!s THEN
   _pos:=0;
   _val:=0;
   INC(_val, RSerial(s, _pos, 100, "DCCC DCC DC D CCC CC CM CD C"));
   INC(_val, RSerial(s, _pos,  10, "LXXX LXX LX L XXX XX XC XL X"));
   INC(_val, RSerial(s, _pos,   1, "VIII VII VI V III II IX IV I"));
   IF _pos<Str.Length(s) THEN
    RETURN -(_pos+1);
   ELSE
    RETURN _val;
   END;
  ELSE
   RETURN 0;
  END;
 END {RomanToArabic};
 
END.
