(*
%Copyright   (c) Polak Computer System
%Author      16.02.1998 17:44:45 GINA
%Purpose       室  ᨮ 䮭
%Type        report
%Specific    SYS
%Modified    22.09.2014 18:27:51 POLAK\Bor
%Environment
*)

 MODULE ManIns14 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_AFM, L_Russia, L_DatTim, L_Str, L_Man, L_Staff, L_STx, L_XML,
        L_StdFrm, L_APtm, L_Prop, L_Tax, L_EC, L_Sheet, L_PRoll, L_AcCut, L_SFee, L_XDoc,
        L_Acnt, L_XObj, L_Pmnt, L_AvePay, L_Packet, P_Staff, P_Man, P_MyFirm, P_Firm,
        Math, Str, E_Staff, E_PRoll, L_Env, P_OwnData;

 CONST
  ps_Base    = 0;
  ps_Inc     = 1;
  ps_Add     = 2;

  ps_InInc   = 0; (* ४ ⮢  2014 *)
  ps_InPaid  = 1;
  ps_AcInc   = 2;
  ps_AcPaid  = 3;

 TYPE
  tPFPart = SCAL[2];
  tPFSum  = L_PRoll.tSum;

 TYPE
  tQMonth     = SCAL[3+1];
  tQuartalSum = L_PRoll.tSum[4];
 CONST
  TotQBMS = 0;

 VAR
  pSum, pPns      : L_PRoll.tSum;

  CurPacket       : L_Packet.tPFExtNbr;
  CurNumInP,
  TotNumInP       : NUMERIC[0];

 TYPE
  tAddTypeLen = NUMERIC[0][MAXOF(L_Packet.tMInsAddType)+1];
 VAR
  pckBase,
  pckInc,
  pckAdd          : L_PRoll.tSum;

  ManPerB,
  ManPerE,   (*᫥ 3  ⭮ ਮ*)
  orgnPerE,
  PerB,
  PerE            : DATE;
  orgnYear,
  Year            : SCAL[1e4];
  orgnQuarter,
  Quarter         : NUMERIC[0];

  orgnPerByWord,
  PerByWord       : STRING[];

 CONST
  pg_Main =  1;

  cat_Main                = 1;
  cat_Inv                 = 2;
  cat_Inv1                = 3;
  cat_woCtzn_Commorancy   = 4;
  cat_woCtzn_TmpResidence = 5;

 CONST
  patt_PerCode  = "";
  patt_CurInc   = "CurInInc";

(*
$P{ RSV1_6_Top:
L_Packet.OwnNumInPFR, L, "", "U"
Packet.ExtNbr, R, "", "U"
?, R, "", "U"
?, C, ""
?, C, ""
?, C, ""
L_Packet.SINumberToAnyOut(Man.SINumber), C, ""
orgnPerByWord, L, "", "U"
Packet.DataType, L, " |X| "
Packet.CorrType, L, " |X| "
Packet.CorrType, L, " | |X"
L_Str.PoolItem(PerByWord, Packet.CorrType = L_Packet.ct_None), L, "", "U"
?, L, ""
@
樮    ######################################### N 窨 #####  N 㬥 ###

                        6.   㬬 믫   ࠦ
                                客 ⠦ 客 
  
                                 6.1.   客 
======================================================================================================
|                     |                        |          ⢮          |         |
|----------------------------|---------------------------|----------------------------|--------------|
|############################|###########################|############################|##############|
======================================================================================================

                                         6.2.  ਮ
 ਮ: #####################################################################################
                      (3 - I ⠫, 6 - 㣮, 9 - 9 楢, 0 - )

                                   6.3.  ४஢ ᢥ
[#] 室     [#] ४騥   ਮ      [#] ⬥騥
 ਮ: ############################################################################
樮     ४㥬 ਮ  #################################################

      6.4.   㬬 믫   ࠦ, ᫥   䨧᪮ 
======================================================================================================
|                    |   |      |    㬬      |  ᫥ 客 |     㬬     |
|                    |ப|⥣ਨ| 믫   |   ᮢ  易⥫쭮    | 믫   |
|                    |      |-|ࠦ,|    ᨮ 客    |ࠦ,|
|                    |      |  |  ᫥  |      㬬 믫       |  ॢ  |
|                    |      |     |        |ࠦ,  ॢ|  ।   |
|                    |      |         |  䨧᪮  | । 稭   | 稭  |
|                    |      |         |           | ᫥ 客 ᮢ | ᫥ |
|                    |      |         |               |------------------------------|   客   |
|                    |      |         |               |     ᥣ     | ⮬ ᫥ |    ᮢ    |
|                    |      |         |               |               |  ࠦ᪮- |               |
|                    |      |         |               |               |   ࠢ   |               |
|                    |      |         |               |               |   ࠬ  |               |
}
*)

(*
$P{ RSV1_6_MBas:
?, C, ""
GetCategoryNick(_MBas.Type), C, ""
_MBas.Object [0], R, "2-"
_MBas.Base   [0], R, "2-"
_MBas.BaseCA [0], R, "2-"
_MBas.OverPrt[0], R, "2-"
?, C, ""
_MBas.Object [1], R, "2-"
_MBas.Base   [1], R, "2-"
_MBas.BaseCA [1], R, "2-"
_MBas.OverPrt[1], R, "2-"
?, C, ""
_MBas.Object [2], R, "2-"
_MBas.Base   [2], R, "2-"
_MBas.BaseCA [2], R, "2-"
_MBas.OverPrt[2], R, "2-"
?, C, ""
_MBas.Object [3], R, "2-"
_MBas.Base   [3], R, "2-"
_MBas.BaseCA [3], R, "2-"
_MBas.OverPrt[3], R, "2-"
@
|--------------------|------|---------|---------------|---------------|--------------|---------------|
|ᥣ  砫      |######|#########|###############|###############|##############|###############|
|⭮ ਮ, |      |         |               |               |              |               |
| ⮬ ᫥       |      |         |               |               |              |               |
|᫥  |      |         |               |               |              |               |
|⭮ ਮ   |      |         |               |               |              |               |
|1              |######|         |###############|###############|##############|###############|
|2              |######|         |###############|###############|##############|###############|
|3              |######|         |###############|###############|##############|###############|
}
*)

(*
$P{ RSV1_6_Fee:
?, C, "2-", "B"
@
======================================================================================================

                            6.5.   ᫥ 客 
            
                 ᫥  客  ᮢ  易⥫쭮 ᨮ 客 
                ᫥   ⭮ ਮ  㬬 믫   ࠦ,
                  ॢ । 稭   ᫥ 客 ᮢ:
                                  ====================================
                                  |##################################|
                                  ====================================

                              6.6. ଠ  ४ ᢥ
======================================================================================================
|ਮ,  |               㬬 ᫥ 客 ᮢ (. .)                 |
|   ந   |---------------------------------------------------------------------------------|
|  ४஢   |  易⥫쭮 ᨮ|     客     |   ⥫   |
|     ᢥ     |   客  2014 .   |                          |                          |
|------------------|                           |                          |                          |
||      |                           |                          |                          |
| ਮ |         |                           |                          |                          |
| ()  |         |                           |                          |                          |
|--------|---------|---------------------------|--------------------------|--------------------------|
}
*)

(*
$P{ RSV1_6_Corr:
_MCor.Quartal, C, ""
_MCor.Year, C, ""
_MCor.AddPF, R, "2-"
_MCor.AddPFIn, R, "2-"
_MCor.AddPFAc, R, "2-"
@
|########|#########|###########################|##########################|##########################|
}
*)

(*
$P{ RSV1_6_CorrBot:
?, R, "2-"
?, R, "2-"
?, R, "2-"
@
|------------------|---------------------------|--------------------------|--------------------------|
|             ⮣|###########################|##########################|##########################|
======================================================================================================

}
*)

(*
$P{ RSV1_6_MHrmTop:
@
                     6.7.   㬬 믫   ࠦ  
                     䨧᪮ , ⮣  ᮮ⢥  ࠡ,
                     ᫥ 客   ⥫쭮 
                        ⤥ ⥣਩ ⥫騪 客 ᮢ,
                       㪠   1, 2  2.1  58.3 ࠫ쭮
                               24  2009 . N 212-
======================================================================================================
|                    |   |             |    㬬 믫      |    㬬 믫      |
|                    |ப|   ᯥ樠쭮  |ࠦ, ᫥|ࠦ,᫥ |
|                    |      | 業 ᫮ |   客 ,   |   客 ,   |
|                    |      |     㤠      |  ⮬   ࠡ, |  ⮬   ࠡ, |
|                    |      |                |  㪠  㭪 1  |   㪠  㭪  |
|                    |      |                |     㭪 1  27    | 2 - 18 㭪 1  27 |
|                    |      |                |   ࠫ쭮    |   ࠫ쭮    |
|                    |      |                |   17.12.2001 " 㤮  |   17.12.2001 " 㤮  |
|                    |      |                |      ᨩ᪮   |      ᨩ᪮   |
|                    |      |                |         樨"        |         樨"        |
}
*)

(*
$P{ RSV1_6_MHrm:
?, C, ""
_MHrm.HarmCode, C, ""
_MHrm.Base1[0], R, "2-"
_MHrm.Base2[0], R, "2-"
?, C, ""
_MHrm.Base1[1], R, "2-"
_MHrm.Base2[1], R, "2-"
?, C, ""
_MHrm.Base1[2], R, "2-"
_MHrm.Base2[2], R, "2-"
?, C, ""
_MHrm.Base1[3], R, "2-"
_MHrm.Base2[3], R, "2-"
@
|--------------------|------|----------------|---------------------------|---------------------------|
|ᥣ  ᫥  |######|################|###########################|###########################|
|  ⭮|      |                |                           |                           |
|ਮ,  ..     |      |                |                           |                           |
|1              |######|                |###########################|###########################|
|2              |######|                |###########################|###########################|
|3              |######|                |###########################|###########################|
}
*)

(*
$P{ StageTop:
@
======================================================================================================

                     6.8. ਮ ࠡ  ᫥   ⭮ ਮ
======================================================================================================
|   |          |          |   |              |        ᫥         |     ᫮ 筮    |
| N |  砫  |     ||ᮡ ᫮|     客 ⠦      |祭 㤮 ᨨ |
|/|  ਮ |  ਮ ||     㤠    |---------------------------|---------------------------|
|   |          |          |   |              |᭮ ()|. .|᭮ ()|. .|
|---|----------|----------|---|--------------|---------------|-----------|---------------|-----------|
}
*)

(*
$P{ StageLine:
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
|## |##########|##########|   |##############|               |#########  |               |           |
}
*)


(*
$P{ StageBot:
@
======================================================================================================
}
*)


(*
$P{ pckList_Top:
Packet.ExtNbr, R, ""
L_Packet.OwnNumInPFR, L, ""
L_Packet.OwnINN, L, ""
L_Packet.OwnKPP, L, ""
L_Packet.OwnFirmName, L, ""
PerByWord, L, ""
@
                           ᮪ 客               窠 N ######
--------------------------------------------------------------------------------
| ࠡ⮤⥫, ।饣 㬥:                                |
|樮   ####################################################|
| ##########         #########                                           |
| ࣠樨  ####################################################|
|(⪮)                                                                     |
| ਮ:                                                              |
|##############################################################################|
|------------------------------------------------------------------------------|
| N  |  客   | , , ⢮                                   |
|/ |         |                                                          |
|----|--------------|----------------------------------------------------------|
}
*)

(*
$P{ pckList_Line:
PckBody.SeqNbr+1, R, "N"
L_Packet.SINumberToAnyOut(Man.SINumber), L, ""
L_Packet.GetManInPFRFName(SYSDATE()), L, ""
@
|####|##############|##########################################################|
}
*)

(*
$P{ pckList_Bot:
@
--------------------------------------------------------------------------------}
*)

(*
$P{ PrbTop:
L_Packet.OwnFirmName, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
PerB, L, "N.y"
PerE, L, "N.y"
@
############################################################################################# ########## #####
=#####========================================================================================================
|            㦥 訡  ନ஢ ᢥ   ਮ  #######  #######            |
|------------------------------------------------------------------------------------------------------------|
|                                |ਬ砭                                                               |
|----------------------------------|-------------------------------------------------------------------------|
}
*)

(*
$P{ PrbLine:
?, L, ""
?, L, ""
@
|##################################|#########################################################################|
}
*)

(*
$P{ PrbBot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE IsCorrPacket(): SCAL[2];
 BEGIN
  RETURN (Packet.CorrType # L_Packet.ct_None);
 END {IsCorrPacket};

 PRIVATE PROCEDURE IsForPensPacket(): SCAL[2];
 BEGIN
  RETURN (Packet.DataType = L_Packet.dt_ForPens) | (Packet.Kind = L_Packet.knd_PF_SPV1) | (Packet.Kind = L_Packet.knd_PF_SPV2);
 END {IsForPensPacket};

 PRIVATE PROCEDURE IsCAStaffCntrType(D: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  TRY [RESTORE_CURSORS(RC_ON)]
   IF L_Staff.IsStandOnMainContract(Man.Man, L_Packet.PckMyFirm, D) THEN
    Result:=(Staff.Contract = L_Staff.cnt_ContractorsAgreement);
   END;
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {IsCAStaffCntrType};

 PRIVATE PROCEDURE GetPckBodyAttrSum(trgAttr: STRING[]): NUMERIC[2];
  VAR
   curVal: STRING[];
 BEGIN
  curVal:=L_Packet.GetPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, trgAttr);
  IF ~!curVal THEN RETURN STRTOFLD(curVal, NUMERIC);
  ELSE             RETURN 0;
  END;
 END {GetPckBodyAttrSum};

 PRIVATE PROCEDURE MoneyToTxt(x: L_PRoll.tSum): STRING[];
 BEGIN
  IF !x THEN
   RETURN "";
  END;
  IF PerE < L_General.DenominationDate() THEN
   RETURN FLDTOSTR(x, "0", 0);
  ELSE
   RETURN FLDTOSTR(x, "2.", 0);
  END;
 END {MoneyToTxt};

 PRIVATE PROCEDURE MoneyToIntTxt(x: L_PRoll.tSum): STRING[];
 BEGIN
  IF !x THEN
   RETURN "";
  END;
  RETURN FLDTOSTR(x, "0", 0);
 END {MoneyToIntTxt};

 PRIVATE PROCEDURE GoodTSN(InIntvl, WithInternalCombine: SCAL[2]): SCAL[2];
 BEGIN
  RETURN L_Env.RealTSN(Staff.TSN) &  (Staff.Contract # L_Staff.cnt_OutStaff) &
         (WithInternalCombine | (Staff.Contract # L_Staff.cnt_InternalCombine)) &
         (~InIntvl | L_DatTim.IsActiveInIntvl_Inc(ManPerB, ManPerE, Staff.BegDate, Staff.EndDate)) &
         ~L_Packet.E_ManIns_ExcludedTSN(ManPerB);
 END {GoodTSN};

 PRIVATE PROCEDURE GetManStrId(_Man: LIKE(Man.Man)): STRING[];
 BEGIN
  RETURN "窠 "+Packet.ExtNbr+"-"+L_Str.IntStr(CurNumInP) + " (: " + _Man + ")";
 END {GetManStrId};

 PRIVATE PROCEDURE MakeStfLg();
  VAR
   DB, DE,
   B,  E    : DATE;
   PrvOut,
   Out,
   Rem,
   NewPns,
   Need     : SCAL[2];
   curPnsAttr : LIKE(Officer.PnsAttr);
   _TSN     : LIKE(Staff.TSN);
   curContract: LIKE(Staff.Contract);
 BEGIN
  SETSEL(StfLg, StfLg);
  REMSEL(StfLg);

  SETSEL(Staff, MyFirm, L_Packet.PckMyFirm, Man.Man);
  FOR_EACH Staff DO
   IF GoodTSN(1, 0) THEN
    PrvOut:=1;
    SETEMPTY(curPnsAttr);
    SETSEL(StaffLog, TSN, Staff.TSN);
    SRCINSEL(StaffLog, LE, , Math.Max(ManPerB, Staff.BegDate));
    LOOP
     Out:=~OCCURE(StaffLog) | (StaffLog.Date>Math.Min(ManPerE, Staff.EndDate)) | L_Staff.IsDischargeStaffLog();
     IF ~Out THEN
      CONFORM(StaffLog, Officer);
      NewPns:=curPnsAttr # Officer.PnsAttr;
     ELSE
      NewPns:=0;
     END;
     IF (PrvOut # Out) | NewPns THEN
      IF ~PrvOut THEN
       IF ~OCCURE(StaffLog) THEN
        E:=ManPerE;
       ELSE
        E:=Math.Min(ManPerE, StaffLog.Date-1);
       END;
       StfLg.Numb:=0;
       StfLg.TSN:=Staff.TSN;
       StfLg.Contract:=Staff.Contract;
       StfLg.DateB:=B;
       StfLg.DateE:=E;
       StfLg.PnsAttr:=curPnsAttr;
       INSERT(StfLg);
       SETEMPTY(curPnsAttr);
      END;
      IF PrvOut | NewPns THEN
       B:=Math.Max(ManPerB, StaffLog.Date);
       curPnsAttr:=Officer.PnsAttr;
      END;
     END;
     PrvOut:=Out;
     IF ~OCCURE(StaffLog) THEN
      EXIT;
     END;
     NEXT(StaffLog);
    END;
   END; (* IF Staff.Contract ... *)
  END; (* FOR_EACH Staff ... *)

  SELECT(StfLg, StfLg, , 0);
  WHILE OCCURE(StfLg) DO
   _TSN:=StfLg.TSN;
   B:=StfLg.DateB;
   E:=StfLg.DateE;
   DB:=B;
   DE:=E;
   curPnsAttr:=StfLg.PnsAttr;
   curContract:=StfLg.Contract;

   Need:=1;
   SAVE(StfLg);
   Rem:=1;
   NEXT(StfLg);
   WHILE OCCURE(StfLg) & (StfLg.DateB<=E) & Rem DO
    Rem:=0;
    IF (StfLg.PnsAttr = L_Packet.OrdinaryPnsAttr) & (StfLg.Contract # L_Staff.cnt_Basic) THEN
     IF StfLg.DateE <= E THEN
      REMOVE(StfLg);
      Rem:=1;
     ELSE
      StfLg.DateB:=E+1;
      REPLACE(StfLg);
     END;
    ELSE
     IF StfLg.DateB > B THEN
      DE:=StfLg.DateB-1;
      B:=StfLg.DateB;
      PREV(StfLg);
      StfLg.DateB:=B;
      INSERT(StfLg);
     ELSE (*StfLg.DateB = B*)
      IF StfLg.DateE<E THEN
       DE:=StfLg.DateE;
       SAVE(StfLg);
       B:=StfLg.DateE+1;
       PREV(StfLg);
       StfLg.DateB:=B;
       INSERT(StfLg);
       RESTORE(StfLg);
      END;
      IF (curContract # L_Staff.cnt_Basic) & (curPnsAttr = L_Packet.OrdinaryPnsAttr) THEN
       Need:=0;
      ELSE
       IF StfLg.DateE>E THEN
        SAVE(StfLg);
        StfLg.DateB:=E+1;
        INSERT(StfLg);
        RESTORE(StfLg);
        StfLg.DateE:=E;
        REPLACE(StfLg);
       END;
       IF (curPnsAttr = L_Packet.OrdinaryPnsAttr) & (curContract = L_Staff.cnt_Basic) THEN
        curPnsAttr:=StfLg.PnsAttr;
        REMOVE(StfLg);
       END;
      END;
     END;
    END;
   END;
   IF Need THEN
    DEFAULT(StfLg);
    StfLg.Numb:=1;
    StfLg.TSN:=_TSN;
    StfLg.DateB:=DB;
    StfLg.DateE:=DE;
    StfLg.PnsAttr:=curPnsAttr;
    StfLg.Contract:=curContract;
    INSERT(StfLg);
   END;
   RESTORE(StfLg);
   NEXT(StfLg);
  END; (* WHILE OCCURE(StfLg) ... *)
 END {MakeStfLg};

 PRIVATE PROCEDURE GetAvePay(VAR _APJMode: LIKE(Sheet.JMode); VAR BD, ED: DATE): SCAL[2];
 BEGIN
  IF Sheet.Source = L_Sheet.src_AvePay THEN
   SETSEL(AvePay, TSN, StfLg.TSN);
   SRCINSEL(AvePay, LE, , Sheet.Period+Sheet.Day-1);
   WHILE OCCURE(AvePay) DO
    IF L_AvePay.IsRealAvePay() THEN
     CONFORM(AvePay, AvePayP);
     WHILE OCCURE(AvePayP) DO
      IF L_DatTim.IsActive_Inc(Sheet.Period+Sheet.Day-1, AvePayP.StartD, AvePayP.StopD) THEN
       CONFORM(AvePayP, AveTypeP);
       IF ~!AveTypeP.JMode THEN
        _APJMode:=AveTypeP.JMode;
        BD:=AvePayP.StartD;
        ED:=AvePayP.StopD;
        RETURN 1;
       END;
      END;
      NEXT(AvePayP);
     END; (* WHILE OCCURE(AvePayP) ... *)
    END;
    PREV(AvePay);
   END; (* WHILE OCCURE(AvePay) ... *)
  END;
  RETURN 0;
 END {GetAvePay};

 PRIVATE PROCEDURE CheckType(    D: DATE;
                                 ForceNotInState: SCAL[2];
                                 curJMode: LIKE(Sheet.JMode);
                             VAR prvMInsType: L_Packet.tMInsType;
                             VAR _BegD: DATE;
                                 Last: SCAL[2]);
  VAR
   curMInsType: L_Packet.tMInsType;
 BEGIN
  IF ForceNotInState THEN
   curMInsType:=EMPTYOF(L_Packet.tMInsType);
  ELSE
   curMInsType:=L_Packet.ext_E_SpecStageForPens(D, curJMode, L_Packet.Get_PF_PacketKind(PerB, PerE, L_Packet.dt_Basic, L_Packet.ct_None));
  END;

  IF (curMInsType # prvMInsType) | Last THEN
   IF ~!prvMInsType THEN
    _MIns.Man:=Man.Man;
    _MIns.BegD:=_BegD;
    _MIns.EndD:=D-1;
    _MIns.PostName:="";
    _MIns.Type:=prvMInsType;
    INSERT(_MIns);
   END;
   IF ~!curMInsType THEN
    _BegD:=D;
   END;
   prvMInsType:=curMInsType;
  END;
 END {CheckType};

 PRIVATE PROCEDURE CheckType2(D: DATE;
                              ForceNotInState: SCAL[2];
                              curJMode: LIKE(Sheet.JMode);
                              VAR prvAddType: L_Packet.tMInsAddType;
                              VAR _BegD2: DATE);
  VAR
   curAddType: L_Packet.tMInsAddType;
 BEGIN
  IF ForceNotInState THEN
   SETEMPTY(curAddType);
  ELSE
   curAddType:=E_Staff.SpecStage2ForPens(D, curJMode);
  END;
  IF (curAddType # prvAddType) THEN
   IF ~!curAddType THEN
    _BegD2:=D;
   END;
   prvAddType:=curAddType;
  END;
 END {CheckType2};

 PRIVATE PROCEDURE GetNotInState(D: DATE): SCAL[2];
 BEGIN
  RETURN ~IsInsuredInPF_OnDate(D);
 END {GetNotInState};

 PRIVATE PROCEDURE GetSpecStage();
  CONST
   FictDate = 01\01\1900;
  VAR
   _APD1,
   _APD2,
   _BegD,
   _BegD2,
   _EndD,
   D, DE,
   D1, D2  : DATE;
   _APJMode: LIKE(Sheet.JMode);
   _PnsAttr: LIKE(Officer.PnsAttr);
   _Type   : L_Packet.tMInsType;
   _Type2  : L_Packet.tMInsAddType;
   _PostName: LIKE(Post.Name);
 BEGIN
  IF ~SELECT(_MIns, _MIns, Man.Man) THEN
   SETEMPTY(_APJMode, _APD1, _APD2);
   MakeStfLg();
   SETSEL(StfLg, StfLg, 1);
   FOR_EACH StfLg DO
    D1:=Math.Max(StfLg.DateB, ManPerB);
    D2:=StfLg.DateE;
    SETEMPTY(_Type, _Type2);

    IF D1<L_Env.aptm_Start THEN
     DE:=Math.Min(L_Env.aptm_Start-1, D2);
     D:=D1;

     SELECT(AvePay, TSN, , StfLg.TSN);
     WHILE OCCURE(AvePay) & (AvePay.StartD<=DE) DO
      IF AvePay.StopD>=D1 THEN
       CONFORM(AvePay, AvePayP);
       WHILE OCCURE(AvePayP) DO
        IF L_DatTim.IsActiveInIntvl_Inc(D1, DE, AvePayP.StartD, AvePayP.StopD) THEN
         CONFORM(AvePayP, AveTypeP);
         IF ~!AveTypeP.JMode THEN

          WHILE D < AvePayP.StartD DO
           CheckType (D, GetNotInState(D), EMPTYOF(JMode.JMode), _Type,  _BegD, 0);
           CheckType2(D, GetNotInState(D), EMPTYOF(JMode.JMode), _Type2, _BegD2);
           INC(D);
          END;

          _APD2:=Math.Min(AvePayP.StopD, DE);
          WHILE D<=_APD2 DO
           CheckType (D, GetNotInState(D), AveTypeP.JMode, _Type,  _BegD, 0);
           CheckType2(D, GetNotInState(D), AveTypeP.JMode, _Type2, _BegD2);
           D:=L_DatTim.NextPer(D);
          END;
          D:=_APD2+1;
         END;
        END;
        NEXT(AvePayP);
       END; (* WHILE OCCURE(AvePayP) ... *)
      END;
      NEXT(AvePay);
     END; (* WHILE OCCURE(AvePay) ... *)

     WHILE D <= DE DO
      CheckType (D, GetNotInState(D), EMPTYOF(JMode.JMode), _Type,  _BegD, 0);
      CheckType2(D, GetNotInState(D), EMPTYOF(JMode.JMode), _Type2, _BegD2);
      INC(D);
     END;
    END;

    D:=Math.Max(D1, L_Env.aptm_Start);
    SETSEL(Sheet, TSN, StfLg.TSN);
    SRCINSEL(Sheet, GE, , L_DatTim.Per(D), L_DatTim.DAY(D));
    WHILE OCCURE(Sheet) & ((Sheet.Period+Sheet.Day-1) <= D2) DO
     IF GetAvePay(_APJMode, _APD1, _APD2) THEN
      D:=Math.Max(_APD1, D1);
      WHILE D<=Math.Min(_APD2, D2) DO
       CheckType (D, GetNotInState(D), _APJMode, _Type,  _BegD, 0);
       CheckType2(D, GetNotInState(D), _APJMode, _Type2, _BegD2);
       D:=L_DatTim.NextPer(D);
      END;
      SRCINSEL(Sheet, GT, , L_DatTim.Per(_APD2), L_DatTim.DAY(_APD2));
     ELSE
      D:=Sheet.Period+Sheet.Day-1;
      CheckType (D, GetNotInState(D), Sheet.JMode, _Type,  _BegD, 0);
      CheckType2(D, GetNotInState(D), Sheet.JMode, _Type2, _BegD2);
      NEXT(Sheet);
     END;
    END;
    CheckType (D2+1, 1, EMPTYOF(JMode.JMode), _Type,  _BegD, 1);
    CheckType2(D2+1, 1, EMPTYOF(JMode.JMode), _Type2, _BegD2);

    SETEMPTY(_PnsAttr, _BegD);
    SEARCH(PnsAttr, PnsAttr, , StfLg.PnsAttr);
    _Type:=PnsAttr.Str2002;

   END; (* FOR_EACH StfLg ... *)

   (*⪠ 㦭 ࠧ*)
   SETEMPTY(_PostName, _Type, _BegD, _EndD);
   SELECT(_MIns, _MIns, , Man.Man);
   WHILE OCCURE(_MIns) DO
    IF !_MIns.Type THEN
     SETEMPTY(_PostName, _Type, _BegD, _EndD);
     REMOVE(_MIns);
    ELSE
     IF (_Type = _MIns.Type) & (*(_PostName = _MIns.PostName) &*) (_EndD = (_MIns.BegD-1)) THEN
      _EndD:=_MIns.EndD;
      PREV(_MIns);
      _MIns.EndD:=_EndD;
      REPLACE(_MIns);
      NEXT(_MIns);
      REMOVE(_MIns);
     ELSE
      _Type    :=_MIns.Type;
      _PostName:=_MIns.PostName;
      _BegD    :=_MIns.BegD;
      _EndD    :=_MIns.EndD;
      NEXT(_MIns);
     END;
    END;
   END; (* WHILE OCCURE(_MIns)... *)
  END;
 END {GetSpecStage};

 PRIVATE PROCEDURE AccessPacket(_ExtNbr: LIKE(Packet.ExtNbr)): SCAL[2];
 BEGIN
  RETURN SELECT(Packet, PacketDS, L_Packet.rcv_PensFund, L_Packet.DTStamp, _ExtNbr);
 END {AccessPacket};

 PRIVATE PROCEDURE SetPckBodyByIntrm(trgExtNbr: LIKE(Packet.ExtNbr));
 BEGIN
  IF ~AccessPacket(trgExtNbr) THEN
   L_Packet.InsPFPacket(L_Packet.knd_PF_RSV1_6, trgExtNbr, PerB, PerE, Intrm.DataType, Intrm.CorrType);
   L_Packet.PutPacketAttr(Packet.Packet, patt_PerCode,  L_Str.IntStr(Quarter));
  END;
  DEFAULT(PckBody);
  PckBody.Packet  :=Packet.Packet;
  PckBody.Man     :=Intrm.Man;
  INSERT(PckBody);
  Intrm.Packet:=PckBody.Packet;
  Intrm.SeqNbr:=PckBody.SeqNbr;
  REPLACE(Intrm);
 END {SetPckBodyByIntrm};

 PRIVATE PROCEDURE HasExcludedTSN(P: DATE): SCAL[2];
 BEGIN
  SETSEL(Staff, MyFirm, L_Packet.PckMyFirm, Man.Man);
  FOR_EACH Staff DO
   IF L_Packet.E_ManIns_ExcludedTSN(P) THEN
    RETURN 1;
   END;
  END; (* FOR_EACH Staff ... *)
  RETURN 0;
 END {HasExcludedTSN};

 PRIVATE PROCEDURE CheckManSFeeType();
  VAR
   dfnTypeStr: STRING[];
   dfnType   : LIKE(ManSFee.Type);
 BEGIN
  TRY
   dfnType:=L_SFee.DefineType(L_Packet.PckMyFirm, Man.Man, ManSFee.Period);
  EXCEPT
  ON Exc:Exc_Raise DO (*0091495 25.04.2012 16:02:36 AK1786\Bor.Polak*)
   SETEMPTY(dfnType);
  END;
  IF ManSFee.Type # dfnType THEN
   IF !dfnType THEN
    dfnTypeStr:='।'
   ELSE
    dfnTypeStr:=L_Str.PoolItem(L_SFee.t_Pool, dfnType);
   END;
   InsPrb01("    ᫮.  '"+L_Str.PoolItem(L_SFee.t_Pool, ManSFee.Type)+"', ⠫ '"+dfnTypeStr+"'. ॡ    "+L_DatTim.PeriodStr(ManSFee.Period), 1)
  END;
 END {CheckManSFeeType};

 PRIVATE PROCEDURE IsInsuredInPF_OnDate(D: DATE): SCAL[2];
 BEGIN
  IF D >= L_SFee.TheStartingPoint THEN
   RETURN L_Staff.IsStandOnMainContract(Man.Man, L_Packet.PckMyFirm, D) &
          L_SFee.ManIsInsuredInPF(Man.Man, D);
  ELSE
   RETURN (L_STx.Get_woTaxManKind(D, Man.Man) # L_STx.wotmk_Foreigner);
  END;
 END {IsInsuredInPF_OnDate};

 PRIVATE PROCEDURE IsInsuredInPF_InPer(): SCAL[2];
  VAR
   P: DATE;
 BEGIN
  P:=ManPerB;
  WHILE P <= ManPerE DO
   IF IsInsuredInPF_OnDate(L_DatTim.MonthEnd(P)) THEN
    RETURN 1;
   END;
   P:=L_DatTim.NextPer(P);
  END;
  RETURN 0;
 END {IsInsuredInPF_InPer};

 PRIVATE PROCEDURE GetCategoryNick(trgType: LIKE(ManSFee.Type)): STRING[];
 BEGIN
  IF    trgType = L_SFee.t_Normal              THEN RETURN "";
  ELSIF trgType = L_SFee.t_Invalid             THEN RETURN "";
  ELSIF trgType = L_SFee.t_USNO                THEN RETURN "";
  ELSIF trgType = L_SFee.t_woCtzn              THEN RETURN "????";
  ELSIF trgType = L_SFee.t_woCtzn_Commorancy   THEN RETURN "";
  ELSIF trgType = L_SFee.t_woCtzn_TmpResidence THEN RETURN "";
  ELSE L_General.CallUs(0);
  END;
 END {GetCategoryNick};

 PRIVATE PROCEDURE trn_intPutPer(nParent: L_XML.tNode; NodeName: STRING[]; trgYear: SCAL[1e4]; trgQuarter: SCAL[10]);
  VAR
   nPer: L_XML.tNode;
 BEGIN
  nPer:=L_Packet.trn_PutNode(nParent, NodeName);
  L_Packet.trn_PutInt(nPer, "⠫", trgQuarter);
  L_Packet.trn_PutInt(nPer, "", trgYear);
(*
  L_Packet.trn_PutString(nPer, "", ""); (*???*)
*)
 END {trn_intPutPer};

 PRIVATE PROCEDURE trn_PutPer(nParent: L_XML.tNode; NodeName: STRING[]);
 BEGIN
  trn_intPutPer(nParent, NodeName, Year, Quarter);
 END {trn_PutPer};

 PRIVATE PROCEDURE trn_PutQMonth(nParent: L_XML.tNode; QMonth: tQMonth);
 BEGIN
  IF ~!QMonth & (QMonth # TotQBMS) THEN
   L_Packet.trn_PutString(nParent, "ப", "");
   L_Packet.trn_PutInt(nParent, "", L_DatTim.MONTH(ManPerB)+QMonth);
  ELSE
   L_Packet.trn_PutString(nParent, "ப", "");
  END;
 END {trn_PutQMonth};

 PRIVATE PROCEDURE trn_PutMInsFeatures(nParent: L_XML.tNode; NodeName: STRING[]);
  VAR
   nFeatures,
   nSpCond,
   nStand,
   nLongServ: L_XML.tNode;
 BEGIN
  nFeatures:=L_Packet.trn_PutNode(nParent, NodeName);
  L_Packet.trn_PutTerrCond(nFeatures, "ਠ륓᫮", "", 0);

  nSpCond:=L_Packet.trn_PutNode(nFeatures, "ᮡ륓᫮㤠");
  L_Packet.trn_PutString(nSpCond, "᭮", Str.Item(_MIns.Type, ";", 0));
  L_Packet.trn_PutString(nSpCond, "᪠", Str.Item(_MIns.Type, ";", 1));

  nStand:=L_Packet.trn_PutNode(nFeatures, "塞멑⠦");
  L_Packet.trn_PutString(nStand, "᭮", "");
  L_Packet.trn_PutEarnHours(nStand, "ࠡ⪠", 0, 0);
  L_Packet.trn_PutEarnDays(nStand, "ࠡ⪠ୠ", 0, 0, 0);

  L_Packet.trn_PutString(nFeatures, "℥", Str.Item(_MIns.Type, ";", 2));

  nLongServ:=L_Packet.trn_PutNode(nFeatures, "㣠");
  L_Packet.trn_PutString(nLongServ, "᭮", "");
  L_Packet.trn_PutEarnHours(nLongServ, "ࠡ⪠", 0, 0);
  L_Packet.trn_PutEarnDays(nLongServ, "ࠡ⪠ୠ", 0, 0, 0);
  L_Packet.trn_PutNumeric(nLongServ, "⠢", 0, 2);
 END {trn_PutMInsFeatures};

 PRIVATE PROCEDURE trn_PutMCor(nParent: L_XML.tNode; i: NUMERIC[0]; trgQuartal, trgYear: NUMERIC[0]; trgPF, trgPFIn, trgPFAc: L_XObj.tSum);
  VAR
   nCorr: L_XML.tNode;
 BEGIN
  nCorr:=L_Packet.trn_PutNode(nParent, "४஢");
  L_Packet.trn_PutInt   (nCorr, "ப", i);
  IF !trgYear THEN
   L_Packet.trn_PutString(nCorr, "ப", "");
  ELSE
   L_Packet.trn_PutString(nCorr, "ப", "");
   L_Packet.trn_PutInt   (nCorr, "⠫", trgQuartal);
   L_Packet.trn_PutInt   (nCorr, "", trgYear);
  END;
  L_Packet.trn_PutMoney(nCorr, "㬬᫥傧ᮢ", trgPF);
  L_Packet.trn_PutMoney(nCorr, "㬬᫥傧ᮢ客", trgPFIn);
  L_Packet.trn_PutMoney(nCorr, "㬬᫥傧ᮢ⥫", trgPFAc);
 END {trn_PutMCor};

 PRIVATE PROCEDURE AddQSum(QuartB, P: DATE; VAR arrSum: tQuartalSum; trgSum: L_XObj.tSum);
 BEGIN
  IF trgSum # 0 THEN
   IF P >= QuartB THEN
    INC(arrSum[L_DatTim.MONTH(P)-L_DatTim.MONTH(QuartB)+1], trgSum);
   END;
   INC(arrSum[TotQBMS], trgSum);
  END;
 END {AddQSum};

 PRIVATE PROCEDURE GetHarmCode(trgPart: L_SFee.tPart): STRING[];
 BEGIN
  IF    trgPart = L_SFee.p_PFA1   THEN RETURN "";
  ELSIF trgPart = L_SFee.p_PFA2   THEN RETURN "";
  ELSIF trgPart = L_SFee.p_PFA3_1 THEN RETURN "3.1";
  ELSIF trgPart = L_SFee.p_PFA3_2 THEN RETURN "3.2";
  ELSIF trgPart = L_SFee.p_PFA3_3 THEN RETURN "3.3";
  ELSIF trgPart = L_SFee.p_PFA3_4 THEN RETURN "3.4";
  ELSIF trgPart = L_SFee.p_PFA4_0 THEN RETURN "4";
  END;
 END {GetHarmCode};

 PRIVATE PROCEDURE Add_MHrm(trgPart: L_SFee.tPart);
  VAR
   curBase  : L_XObj.tSum;
   curReason: L_SFee.tPFAReasonCode;
 BEGIN
  curBase:=L_SFee.GetCurrentSinglePartBase(trgPart);
  IF curBase # 0 THEN
   IF ManSFee.Period >= ManPerB THEN
    ADD(_MHrm, Man, , Man.Man, GetHarmCode(trgPart));
   ELSE
    SEARCH(_MHrm, Man, , Man.Man, GetHarmCode(trgPart));
   END;
   IF OCCURE(_MHrm) THEN
    curReason:=L_SFee.GetPFA_ReasonCode();
    IF    curReason = L_SFee.pfarc_1 THEN
     AddQSum(ManPerB, ManSFee.Period, _MHrm.Base1, curBase);
    ELSIF curReason = L_SFee.pfarc_2 THEN
     AddQSum(ManPerB, ManSFee.Period, _MHrm.Base2, curBase);
    ELSE
     L_General.CallUs(0);
    END;
    REPLACE(_MHrm);
   END;
  END;
 END {Add_MHrm};

 PRIVATE PROCEDURE PrepareOneMan();
  VAR
   curBase,
   manBase,
   manInc : L_PRoll.tSum;
 BEGIN
  SETZERO(manBase, manInc);
  IF Packet.CorrType # L_Packet.ct_Cancel THEN
   SETSEL(ManSFee, MyFirm, L_Packet.PckMyFirm, Man.Man, 1);
   SRCINSEL(ManSFee, LE, , PerE);
   WHILE OCCURE(ManSFee) & (ManSFee.Period >= PerB) DO
    CheckManSFeeType();
    IF (ManSFee.Object # 0) | (ManSFee.Fee[L_SFee.p_PFIn] # 0) | (L_SFee.GetCurrentSinglePartBase(L_SFee.p_PFIn) # 0) THEN
     curBase:=L_SFee.GetCurrentSinglePartBase(L_SFee.p_PFIn);
     IF ManSFee.Period >= ManPerB THEN
      ADD(_MBas, Man, , ManSFee.Man, ManSFee.Type);
      INC(manBase, curBase);
      INC(manInc,  ManSFee.Fee[L_SFee.p_PFIn]);
     ELSE
      SEARCH(_MBas, Man, , ManSFee.Man, ManSFee.Type); (*㬬  砫   ⮫쪮 ᫨  㬬  ᫥ 3 *)
     END;
     IF OCCURE(_MBas) THEN
      AddQSum(ManPerB, ManSFee.Period, _MBas.Object,  ManSFee.Object);
      AddQSum(ManPerB, ManSFee.Period, _MBas.Base,    curBase);
      IF IsCAStaffCntrType(L_DatTim.MonthEnd(ManSFee.Period)) THEN
       AddQSum(ManPerB, ManSFee.Period, _MBas.BaseCA,  curBase);
      END;
      AddQSum(ManPerB, ManSFee.Period, _MBas.OverPrt, ManSFee.OvrPrt[L_SFee.b_PFR]);
      REPLACE(_MBas);
     END;
    END;
    Add_MHrm(L_SFee.p_PFA1);
    Add_MHrm(L_SFee.p_PFA2);
    Add_MHrm(L_SFee.p_PFA3_1);
    Add_MHrm(L_SFee.p_PFA3_2);
    Add_MHrm(L_SFee.p_PFA3_3);
    Add_MHrm(L_SFee.p_PFA3_4);
    Add_MHrm(L_SFee.p_PFA4_0);
    PREV(ManSFee);
   END; (* WHILE OCCURE(ManSFee) ... *)

   IF ~SELECT(_MBas, Man, Man.Man) & ~IsCorrPacket() & SELECT(_MCor, Man, Man.Man) THEN
    SETSEL(ManSFee, MyFirm, L_Packet.PckMyFirm, Man.Man, 1);
    SRCINSEL(ManSFee, LE, , PerE);
    ADD(_MBas, Man, , ManSFee.Man, ManSFee.Type);
   END;

   INC(pckBase, manBase);
   INC(pckInc,  manInc);
 
   GetSpecStage();
  ELSE
   IF NeedManInIntrm() THEN
    InsPrb01("   ⬥ ᢥ  稨 ꥪ   ᫥ ", 1);
   END;
  END; (* IF Packet.CorrType # L_Packet.ct_Cancel ... *)

  IF IsCorrPacket() THEN
   IF SEARCH(PkIdx, Man, Man.Man, PerB, PerE) THEN
    ADD(_MCor, Man, , Man.Man, Year, Quarter,
                      _MCor.AddPF, manInc - PkIdx.Inc);
    INC(pckAdd,  manInc - PkIdx.Inc);
   END;
  END;

  Intrm.Inc:=manInc;
  REPLACE(Intrm);
 END {PrepareOneMan};

 PRIVATE PROCEDURE MakeOneMan(nPack: L_XML.tNode);
  VAR
   D1, D2,
   _Period   : DATE;
   curMonth  : L_DatTim.tMonth;
   QMonth    : tQMonth;
   i         : NUMERIC[0];
   Dummy     : STRING[250];
   nDoc,
   nHeadOld,
   nPay,
   nIncome,
   nIncStr,
   nWork,
   nWrkPer,
   nWrkBas,
   nWrkLgt,
   nInc,
   nHrm     : L_XML.tNode;
   Surname,
   FirstName,
   Patronymic: STRING[];
   curStrCode: SCAL[1e3];
   curStrNum : NUMERIC[0];
   totAddPF,
   totAddPFIn,
   totAddPFAc: L_XObj.tSum;
 BEGIN
  CONFORM(PckBody, Man);
  L_Str.SplitManName(Intrm.Name, Surname, FirstName, Patronymic);

  nDoc:=L_Packet.trn_PutAbstractDoc(nPack, trn_PckKind(), CurNumInP);

  L_Packet.trn_PutString(nDoc, "", L_Packet.FormType(Packet.DataType, Packet.CorrType));
  L_Packet.trn_PutString(nDoc, "樮멍", L_Packet.OwnNumInPFR);
  L_Packet.trn_PutString(nDoc, "客", L_Packet.SINumberToAnyOut(Man.SINumber));
  L_Packet.trn_PutFIO(nDoc, "", Intrm.Name);
  IF IsCorrPacket() THEN
   trn_intPutPer(nDoc, "멏ਮ", orgnYear, orgnQuarter);
   trn_PutPer(nDoc, "४㥬멎멏ਮ");
   L_Packet.trn_PutString(nDoc, "樮멍४㥬ਮ", P_MyFirm.NumInPFR(L_Packet.PckMyFirm, PerE));
   MAKEPART(R, RSV1_6_Top, CurNumInP, Surname, FirstName, Patronymic, P_MyFirm.NumInPFR(L_Packet.PckMyFirm, PerE));
  ELSE
   trn_PutPer(nDoc, "멏ਮ");
   MAKEPART(R, RSV1_6_Top, CurNumInP, Surname, FirstName, Patronymic, );
  END;

  IF Packet.CorrType # L_Packet.ct_Cancel THEN
   i:=1;
   curStrCode:=400;
   SETSEL(_MBas, Man, Man.Man);
   FOR_EACH _MBas DO
    FOR_EACH QMonth DO
     IF (_MBas.Object[QMonth] # 0) | (_MBas.Base[QMonth] # 0) | (_MBas.BaseCA[QMonth] # 0) | (_MBas.OverPrt[QMonth] # 0) |
        (QMonth = TotQBMS) THEN
      nInc:=L_Packet.trn_PutNode(nDoc, "㬬믫∢ࠦ㇋");
      L_Packet.trn_PutInt   (nInc, "ப", i);
      trn_PutQMonth(nInc, QMonth);
      L_Packet.trn_PutInt   (nInc, "ப",   curStrCode+QMonth);
      L_Packet.trn_PutString(nInc, "⥣ਨ", GetCategoryNick(_MBas.Type));
      L_Packet.trn_PutMoney (nInc, "㬬믫∭傮ࠦ", _MBas.Object[QMonth]);
      L_Packet.trn_PutMoney (nInc, "ॢ騥ᥣ", _MBas.Base[QMonth]);
      L_Packet.trn_PutMoney (nInc, "ॢ騥ࠬ", _MBas.BaseCA[QMonth]);
      L_Packet.trn_PutMoney (nInc, "ॢ騥।",   _MBas.OverPrt[QMonth]);
      INC(i);
     END;
    END; (* FOR_EACH QMonth ... *)

    MAKEPART(R, RSV1_6_MBas, curStrCode, curStrCode+1, curStrCode+2, curStrCode+3);

    INC(curStrCode, 10);
   END; (* FOR_EACH _MBas ... *)
 
   L_Packet.trn_PutMoney(nDoc, "㬬ᮢ", Intrm.Inc);

   MAKEPART(R, RSV1_6_Fee, Intrm.Inc);

   SETZERO(totAddPF, totAddPFIn, totAddPFAc);
   IF ~IsCorrPacket() THEN
    IF SELECT(_MCor, Man, Man.Man) THEN
     i:=1;
     FOR_EACH _MCor DO
      IF ~!_MCor.Year THEN
       trn_PutMCor(nDoc, i, _MCor.Quartal, _MCor.Year, _MCor.AddPF, _MCor.AddPFIn, _MCor.AddPFAc);
       INC(totAddPF,   _MCor.AddPF);
       INC(totAddPFIn, _MCor.AddPFIn);
       INC(totAddPFAc, _MCor.AddPFAc);
       MAKEPART(R, RSV1_6_Corr);
      END;
      INC(i);
     END; (* FOR_EACH _MCor ... *)
     trn_PutMCor(nDoc, i, EMPTYOF(_MCor.Quartal), EMPTYOF(_MCor.Year), totAddPF, totAddPFIn, totAddPFAc);
    END;
   END; (* IF ~IsCorrPacket() ... *)
   MAKEPART(R, RSV1_6_CorrBot, totAddPF, totAddPFIn, totAddPFAc);

   MAKEPART(R, RSV1_6_MHrmTop);
   i:=1;
   curStrCode:=700;
   SETSEL(_MHrm, Man, Man.Man);
   FOR_EACH _MHrm DO
    FOR_EACH QMonth DO
     IF (_MHrm.Base1[QMonth] # 0) | (_MHrm.Base2[QMonth] # 0) THEN
      nHrm:=L_Packet.trn_PutNode(nDoc, "㬬믫∢ࠦ");
      L_Packet.trn_PutInt   (nHrm, "ப", i);
      trn_PutQMonth(nHrm, QMonth);
      L_Packet.trn_PutInt   (nHrm, "ப",   curStrCode+QMonth);
      L_Packet.trn_PutString(nHrm, "樠쭮業᫮㤠", _MHrm.HarmCode);
      L_Packet.trn_PutMoney (nHrm, "㬬믫⏮27-1",    _MHrm.Base1[QMonth]);
      L_Packet.trn_PutMoney (nHrm, "㬬믫⏮27-2-18", _MHrm.Base2[QMonth]);
      INC(i);
     END;
    END; (* FOR_EACH QMonth ... *)

    MAKEPART(R, RSV1_6_MHrm, curStrCode, curStrCode+1, curStrCode+2, curStrCode+3);

    INC(curStrCode, 10);
   END; (* FOR_EACH _MHrm ... *)

   MAKEPART(R, StageTop);
   SETEMPTY(D1, D2);
   i:=1;
   IF SELECT(_MIns, _MIns, Man.Man) THEN
    D1:=_MIns.BegD;
    D2:=_MIns.EndD;
   END;
   FOR_EACH _MIns DO
    nWrkPer:=L_Packet.trn_PutNode(nDoc, "⠦멏ਮ");
    L_Packet.trn_PutInt(nWrkPer, "ப", i);
    L_Packet.trn_PutDate(nWrkPer, "⠍砫ਮ", _MIns.BegD);
    L_Packet.trn_PutDate(nWrkPer, "⠊栏ਮ",  _MIns.EndD);
    IF L_Packet.IsOrdinaryType(_MIns.Type) THEN
     L_Packet.trn_PutInt(nWrkPer, "⢮죮呮⠢", 0);
    ELSE
     L_Packet.trn_PutInt(nWrkPer, "⢮죮呮⠢", 1);
     nWrkLgt:=L_Packet.trn_PutNode(nWrkPer, "죮멑⠦");
     L_Packet.trn_PutInt(nWrkLgt, "ப", 1);
     trn_PutMInsFeatures(nWrkLgt, "ᮡ⨓");
    END;

    MAKEPART(R, StageLine, i, L_DatTim.DateStr(_MIns.BegD), L_DatTim.DateStr(_MIns.EndD), Str.Item(_MIns.Type, ";", 0), Str.Item(_MIns.Type, ";", 2));
    Dummy:=Str.Condense(Str.Item(_MIns.Type, ";", 1));
    IF ~!Dummy THEN
     MAKEPART(R, StageLine, , , , Dummy);
    END;
    INC(i);
   END; (* FOR_EACH _MIns ... *)
   MAKEPART(R, StageBot);

  END; (* IF Packet.CorrType # L_Packet.ct_Cancel ... *)
  L_Packet.trn_PutDate(nDoc, "⠇", L_Packet.PrepareDate);

  L_Packet.PutPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_CurInc,  MoneyToTxt(Intrm.Inc));
 END {MakeOneMan};

 PRIVATE PROCEDURE trn_PckKind(): STRING[];
 BEGIN
  IF    Packet.Kind = L_Packet.knd_PF_RSV1_6 THEN RETURN "_______";
  ELSE
   L_General.CallUs(0);
  END;
 END {trn_PckKind};

 PRIVATE PROCEDURE MakeOnePacket();
  VAR
   nPack,
   nInvH,
   nInvP,
   nTotPay,
   nInc       : L_XML.tNode;
 BEGIN
  APP.Get().NewPrompt(" "+Packet.ExtNbr);
  L_Packet.CheckExistTrnFiles();
  L_Packet.trn_OpenFiles();
  L_Packet.CheckPacketType();
  SETZERO(CurNumInP, TotNumInP, pckBase, pckInc, pckAdd);

  SETSEL(PckBody, Packet, Packet.Packet);
  FOR_EACH PckBody DO
   PROMPT(": "+GetManStrId(PckBody.Man));
   INC(CurNumInP);
   L_General.Assert(PckBody.SeqNbr = CurNumInP, " 窥 襭 㬥");
   CONFORM(PckBody, Man);
   SEARCH(Intrm, Packet, , PckBody.Packet, PckBody.SeqNbr);
   PrepareOneMan();
  END; (* FOR_EACH PckBody ... *)

  TotNumInP:=CurNumInP;

  nPack:=L_Packet.ext_trn_PutHead(L_Packet.ext_trnFileName(orgnPerE));

  nInvH:=L_Packet.trn_PutInventoryHead(nPack, "_____6", trn_PckKind(), TotNumInP);

  L_Packet.trn_PutString(nInvH, "", L_Packet.FormType(Packet.DataType, Packet.CorrType));
  IF IsCorrPacket() THEN
   trn_intPutPer(nInvH, "멏ਮ", orgnYear, orgnQuarter);
   trn_PutPer(nInvH, "४㥬멎멏ਮ");
  ELSE
   trn_PutPer(nInvH, "멏ਮ");
  END;
  IF Packet.CorrType # L_Packet.ct_Cancel THEN
   L_Packet.trn_PutMoney(nInvH, "᫥客傧ᮢॢ।", pckBase);
   L_Packet.trn_PutMoney(nInvH, "客傧ᮢ", pckInc);
  END;

  InitPrintAttr(R, Duplex, Off);

  CurNumInP:=1;
  SETSEL(PckBody, Packet, Packet.Packet);
  FOR_EACH PckBody DO
   INC(CurNumInP);
   PROMPT(": "+GetManStrId(PckBody.Man));
   SEARCH(Intrm, Man, , PckBody.Man, PckBody.Packet);
   MakeOneMan(nPack);
  END; (* FOR_EACH PckBody ... *)

  Packet.Sums[ps_Base]:=pckBase;
  Packet.Sums[ps_Inc] :=pckInc;
  Packet.Sums[ps_Add] :=pckAdd;
  REPLACE(Packet);

  FORMFEED(R);
  InitPrintAttr(R, Duplex, Off);
  MAKEPART(R, pckList_Top);
  SETSEL(PckBody, Packet, Packet.Packet);
  FOR_EACH PckBody DO
   PROMPT("᮪ 客 : "+GetManStrId(PckBody.Man));
   CONFORM(PckBody, Man);
   MAKEPART(R, pckList_Line);
  END; (* FOR_EACH PckBody ... *)
  MAKEPART(R, pckList_Bot);
  L_Packet.trn_CloseFiles(nPack);
 END {MakeOnePacket};

 PRIVATE PROCEDURE AddPkIdx();
 BEGIN
  IF ~ADD(PkIdx, PkIdx, Packet.PerB, Packet.PerE, PckBody.Man) |
      (PkIdx.DTStamp <= Packet.DTStamp) THEN
   L_General.CallUs(PkIdx.DTStamp # Packet.DTStamp); (* 0098850 .5.1 20.08.2013 15:53:54 POLAK\Bor *)
   PkIdx.Packet :=Packet.Packet;
   PkIdx.SeqNbr :=PckBody.SeqNbr;
   PkIdx.DTStamp:=Packet.DTStamp;
   PkIdx.Inc    :=GetPckBodyAttrSum(patt_CurInc);
   REPLACE(PkIdx);
  END;
 END {AddPkIdx};

 PRIVATE PROCEDURE MakePckIndex(trgPerB, trgPerE: DATE; trgMan: LIKE(Man.Man));
 BEGIN
  APP.Get().NewPrompt(" ᤠ ᢥ");

  TRY [RESTORE_CURSORS(RC_ON)]
   SETSEL(Packet, PacketEN, L_Packet.rcv_PensFund, trgPerB, trgPerE);
   FOR_EACH Packet DO
    PROMPT(" "+Packet.Packet);
    IF (Packet.Kind = L_Packet.knd_PF_RSV1_6) & L_Packet.IsValidPacket() THEN
     IF ~!trgMan THEN
      IF SEARCH(PckBody, Man, trgMan, Packet.Packet) THEN
       AddPkIdx();
      END;
     ELSE
      SETSEL(PckBody, Packet, Packet.Packet);
      FOR_EACH PckBody DO
       AddPkIdx();
      END; (* FOR_EACH PckBody ... *)
     END;
    END; (* IF L_Packet.IsValidPacket() ... *)
   END; (* FOR_EACH Packet ... *)
  EXCEPT
  END; (* TRY *)
 END {MakePckIndex};

 PRIVATE PROCEDURE StandOnPkIdx(trgPerB,
                                trgPerE    : DATE;
                                trgMan     : LIKE(Man.Man)): SCAL[2];
 BEGIN
  RETURN SEARCH(PkIdx, PkIdx, trgPerB, trgPerE, trgMan);
 END {StandOnPkIdx};

 PRIVATE PROCEDURE CreatePkIdx();
 BEGIN
  L_AFM.MakeMultipleIndex("PkIdx", "PerB    : DATE;"+
                                   "PerE    : DATE;"+
                                   "Man     : LIKE(Man.Man);"+
                                   "Packet  : LIKE(Packet.Packet);"+
                                   "SeqNbr  : LIKE(PckBody.SeqNbr);"+
                                   "DTStamp : LIKE(Packet.DTStamp);"+
                                   "Inc     : LIKE(ManSFee.Fee[0])",
                          "PkIdx: PerB, PerE, Man;"+
                          "Man: Man, PerB, PerE");
 END {CreatePkIdx};

 PRIVATE PROCEDURE InitServices(trgPerB, trgPerE: DATE);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

  SetDateParms(trgPerB, trgPerE);

  L_Tax.Tax2001_InitCodes(PerB);

  CREATE_TABLE(_MIns);
  CREATE_FIELD(_MIns, Man,      LIKE(Man.Man));
  CREATE_FIELD(_MIns, BegD,     DATE);
  CREATE_FIELD(_MIns, EndD,     DATE);
  CREATE_FIELD(_MIns, PostName, LIKE(Post.Name));
  CREATE_FIELD(_MIns, Type,     L_Packet.tMInsType);
  CREATE_INDEX(_MIns, _MIns, PLURAL, , , Man, BegD, EndD, Type);
  SET_VERSION_OF_TABLE(_MIns, 0000);
  L_AFM.CreateTemp("_MIns");

  CREATE_TABLE(StfLg);
  CREATE_FIELD(StfLg, Numb, SCAL[2]);
  CREATE_FIELD(StfLg, TSN, LIKE(Staff.TSN));
  CREATE_FIELD(StfLg, DateB, DATE);
  CREATE_FIELD(StfLg, DateE, DATE);
  CREATE_FIELD(StfLg, Contract, LIKE(Staff.Contract));
  CREATE_FIELD(StfLg, PnsAttr,  LIKE(Officer.PnsAttr));

  CREATE_INDEX(StfLg, StfLg, PLURAL, , , Numb, DateB, Contract, TSN);
  SET_VERSION_OF_TABLE(StfLg, 0001);
  L_AFM.CreateTemp("StfLg");

  CREATE_TABLE(Prb01);
  CREATE_FIELD(Prb01, Man, LIKE(Man.Man));
  CREATE_FIELD(Prb01, Problem, STRING[200]);
  CREATE_FIELD(Prb01, Error, SCAL[2]);

  CREATE_INDEX(Prb01, Prb01, UNIQUE, , , Error, Man, Problem);
  CREATE_INDEX(Prb01, Man,   PLURAL, , , Man);
  SET_VERSION_OF_TABLE(Prb01, 0001);
  L_AFM.CreateTemp("Prb01");

  CREATE_TABLE(Intrm);
  CREATE_FIELD(Intrm, DataType, LIKE(Packet.DataType));
  CREATE_FIELD(Intrm, CorrType, LIKE(Packet.CorrType));
  CREATE_FIELD(Intrm, Man,      LIKE(Man.Man));
  CREATE_FIELD(Intrm, Name,     LIKE(Man.Name));
  CREATE_FIELD(Intrm, Inc,      LIKE(ManSFee.Fee[0]));
  CREATE_FIELD(Intrm, Packet,   LIKE(Packet.Packet));
  CREATE_FIELD(Intrm, SeqNbr,   LIKE(PckBody.SeqNbr));

  CREATE_INDEX(Intrm, Intrm, UNIQUE, , , DataType, CorrType, Name, Man);
  CREATE_INDEX_AND_LINK(Intrm, Man,    UNIQUE, Man, Man, USER, , , Man, Packet);
  CREATE_INDEX_AND_LINK(Intrm, Packet, UNIQUE, PckBody, Packet, USER, , , Packet, SeqNbr);
  SET_VERSION_OF_TABLE(Intrm, 0000);
  L_AFM.CreateTemp("Intrm");

  CREATE_TABLE(_MBas);
  CREATE_FIELD(_MBas, Man,     LIKE(Man.Man));
  CREATE_FIELD(_MBas, Type,    LIKE(ManSFee.Type));
  CREATE_FIELD(_MBas, Object,  tQuartalSum, , "0");
  CREATE_FIELD(_MBas, Base,    tQuartalSum, , "0");
  CREATE_FIELD(_MBas, BaseCA,  tQuartalSum, , "0");
  CREATE_FIELD(_MBas, OverPrt, tQuartalSum, , "0");
  CREATE_INDEX_AND_LINK(_MBas, Man, UNIQUE, Man, Man, USER, , , Man, Type);
  SET_VERSION_OF_TABLE(_MBas, 0000);
  L_AFM.CreateTemp("_MBas");

  CREATE_TABLE(_MHrm);
  CREATE_FIELD(_MHrm, Man,      LIKE(Man.Man));
  CREATE_FIELD(_MHrm, HarmCode, STRING[10]);
  CREATE_FIELD(_MHrm, Base1,    tQuartalSum, , "0");
  CREATE_FIELD(_MHrm, Base2,    tQuartalSum, , "0");
  CREATE_INDEX_AND_LINK(_MHrm, Man, UNIQUE, Man, Man, USER, , , Man, HarmCode);
  SET_VERSION_OF_TABLE(_MHrm, 0000);
  L_AFM.CreateTemp("_MHrm");

  CreatePkIdx();
 END {InitServices};

 PRIVATE PROCEDURE ClearServices(Full: SCAL[2]);
 BEGIN
  SETSEL(Prb01, Man);    REMSEL(Prb01);
  IF Full THEN
   SETSEL(StfLg, StfLg);  REMSEL(StfLg);
   SETSEL(_MIns, _MIns);  REMSEL(_MIns);
   SETSEL(Intrm, Intrm);  REMSEL(Intrm);
  END;
  SETSEL(PkIdx, PkIdx);  REMSEL(PkIdx);
 END {ClearServices};

 PRIVATE PROCEDURE InitCorr();
 BEGIN
  L_AFM.MakeIndex("TmpCP", "PerB    : DATE;"+
                           "PerE    : DATE;"+
                           "Man     : LIKE(Man.Man)");

  CREATE_TABLE(_MCor);
  CREATE_FIELD(_MCor, Man,      LIKE(Man.Man));
  CREATE_FIELD(_MCor, Year,     NUMERIC[0]);
  CREATE_FIELD(_MCor, Quartal,  NUMERIC[0]);
  CREATE_FIELD(_MCor, AddPF,    L_XObj.tSum, , "0");
  CREATE_FIELD(_MCor, AddPFIn,  L_XObj.tSum, , "0");
  CREATE_FIELD(_MCor, AddPFAc,  L_XObj.tSum, , "0");
  CREATE_INDEX_AND_LINK(_MCor, Man, UNIQUE, Man, Man, USER, , , Man, Year, Quartal);
  SET_VERSION_OF_TABLE(_MCor, 0000);
  L_AFM.CreateTemp("_MCor");
 END {InitCorr};

 PRIVATE PROCEDURE DeInitServices();
 BEGIN
  L_AFM.AF_PurgeTemp("Prb01");
  L_AFM.AF_PurgeTemp("StfLg");
  L_AFM.AF_PurgeTemp("_MIns");
  L_AFM.AF_PurgeTemp("Intrm");
  L_AFM.AF_PurgeTemp("PkIdx");
 END {DeInitServices};

 PRIVATE PROCEDURE CheckPrb01();
  CONST
   ErrLen = 73;
   RepName = "BdMIn";
  VAR
   ManStr,
   ErrStr   : STRING[];
   ErrStrArr: STRING[ErrLen][10];
 BEGIN
  IF SELECT(Prb01, Prb01, 1) THEN
   OPENREP(R_Prb, L_General.NameConnection(RepName), Create);
   MAKEPART(R_Prb, PrbTop, RepName);
   WHILE OCCURE(Prb01) DO
    SEARCH(Man, Man, , Prb01.Man);
    ManStr:=L_Man.Man_ManAsStr()+" "+Man.Name;
    Str.Format(ErrStrArr, Prb01.Problem, ErrLen, LEFT);
    FOR_EACH ErrStr IN ErrStrArr DO
     MAKEPART(R_Prb, PrbLine, ManStr, ErrStr);
     ManStr:="";
    END;
    NEXT(Prb01);
   END; (* WHILE OCCURE(Prb01) ... *)
   MAKEPART(R_Prb, PrbBot);
   CLOSEREP(R_Prb);
   L_General.HaltAndSurveyLastReport(EMPTYOF(Exc_Root));
  END;
 END {CheckPrb01};

 PRIVATE PROCEDURE MakeAll();
  VAR
   packetDataType: LIKE(Packet.DataType);
   packetCorrType: LIKE(Packet.CorrType);
   NumTot        : NUMERIC[0];
 BEGIN
  SETZERO(NumTot);

  SETSEL(Packet, PacketDS, L_Packet.rcv_PensFund, L_Packet.DTStamp);
  FOR_EACH Packet DO
   IF (Packet.PerE = PerE) THEN
    MakeOnePacket();
    INC(NumTot, CurNumInP);
   END;
  END; (* FOR_EACH Packet ... *)

  CheckPrb01();
 END {MakeAll};

 PRIVATE PROCEDURE CheckForPensPacket();
 BEGIN
  IF IsForPensPacket() THEN
   L_General.Error("  祭 ᨨ   㣮 ଥ");
  END;
 END {CheckForPensPacket};

 PRIVATE PROCEDURE InsPrb01(Msg: STRING[]; IsError: SCAL[2]);
 BEGIN
  ADD(Prb01, Prb01, , IsError, Man.Man, Msg);
 END {InsPrb01};

 PRIVATE PROCEDURE IntrmPutOneMan(trgDataType: LIKE(Packet.DataType); trgCorrType: LIKE(Packet.CorrType));
 BEGIN
  DEFAULT(Intrm);
  Intrm.Man     :=Man.Man;
  Intrm.Name    :=L_Packet.GetManInPFRFName(SYSDATE());
  Intrm.DataType:=trgDataType;
  Intrm.CorrType:=trgCorrType;
  INSERT(Intrm);
 END {IntrmPutOneMan};

 PRIVATE PROCEDURE NeedManInIntrm(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  IF (L_Packet.BuildMode # L_Packet.bm_byPacket) &
     SELECT(_MCor, Man, Man.Man) THEN
   RETURN 1;
  ELSE
   SETSEL(ManSFee, MyFirm, L_Packet.PckMyFirm, Man.Man, 1);
   SRCINSEL(ManSFee, GE, , ManPerB);
   WHILE OCCURE(ManSFee) & (ManSFee.Period <= ManPerE) DO
    IF (ManSFee.Object # 0) | (ManSFee.Fee[L_SFee.p_PFIn] # 0) THEN
     RETURN 1;
    END;
    NEXT(ManSFee);
   END; (* WHILE OCCURE(ManSFee) ... *)
  END;
  RETURN 0;
 END {NeedManInIntrm};

 PRIVATE PROCEDURE PutManInIntrm();
  VAR
   prvCorrType: LIKE(Packet.CorrType);
   NeedBasic,
   NeedCancel : SCAL[2];
 BEGIN
  PROMPT(" "+L_Man.Man_ManAsStr());
  IF (L_Packet.BuildMode = L_Packet.bm_byPacket) THEN
   IF StandOnPkIdx(ManPerB, L_Packet.Get_PF_StdPerE(ManPerB), Man.Man) THEN
    SAVE(Packet);
    SEARCH(Packet, Packet, , PkIdx.Packet);
    prvCorrType:=Packet.CorrType;
    RESTORE(Packet);
   ELSE
    SETEMPTY(prvCorrType);
   END;
  END;

  IF NeedManInIntrm() THEN
   IF ~!Man.SINumber THEN
    L_Russia.CheckSINumber(Man.SINumber, 0);
    IF (L_Packet.BuildMode = L_Packet.bm_byPacket) THEN
     IntrmPutOneMan(L_Packet.dt_None, L_Packet.ct_Corr);
     IF !prvCorrType | (prvCorrType = L_Packet.ct_Cancel) THEN
      L_StdFrm.Inform("㦭 室 ᢥ "+Man.Man+" "+L_DatTim.PeriodStr(PerB)+" "+L_DatTim.PeriodStr(PerE)+" "+GetCategoryNick(curCategory));
     END;
    ELSE
     IntrmPutOneMan(L_Packet.dt_Basic, L_Packet.ct_None);
    END;
   ELSIF IsInsuredInPF_InPer() THEN
    IF L_SFee.ManHasADV1() THEN
     InsPrb01(" ,   -1", 1);
    ELSE
     InsPrb01(" ", 1);
    END;
   END;
  ELSE
   IF (L_Packet.BuildMode = L_Packet.bm_byPacket) &
      ~!prvCorrType & (prvCorrType # L_Packet.ct_Cancel) THEN
    IntrmPutOneMan(L_Packet.dt_None, L_Packet.ct_Cancel);
   END;
  END; (* IF NeedManInIntrm(( ... *)

  IF HasExcludedTSN(ManPerB) THEN
   InsPrb01("᪫祭   ᢥ", 0);
  END;
 END {PutManInIntrm};

 PRIVATE PROCEDURE BuildPackets();
  VAR
   PacketSize: NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt("⮢ ⮢ ");
  PacketSize:=P_OwnData.ODPacketSize(L_Packet.PrepareDate);
  SELECT(Intrm, Intrm);
  WHILE OCCURE(Intrm) DO
   NARROWSEL(Intrm, DataType, CorrType);
   CurNumInP:=0;
   FOR_EACH Intrm DO
    PROMPT(" "+Intrm.Man);
    CurNumInP:=(CurNumInP MOD PacketSize)+1;
    INC(CurPacket, CurNumInP = 1);
    SetPckBodyByIntrm(CurPacket);
   END; (* FOR_EACH Intrm ... *)
   NEXTINEXTENDEDSEL(Intrm, DataType, CorrType);
  END;
 END {BuildPackets};

 PRIVATE PROCEDURE PrepareGroup();
 BEGIN
  APP.Get().NewPrompt(" ");
  SETSEL(Man, rsMan, 1);
  FOR_EACH Man DO
   PutManInIntrm();
  END; (* FOR_EACH Man ... *)
 END {PrepareGroup};

 PRIVATE PROCEDURE CheckPer();
  VAR
   Strong : SCAL[2];
   ErrStr : STRING[];
   curPerE: DATE;
 BEGIN
  Strong:=(L_Packet.BuildMode = L_Packet.bm_byAll) | (L_Packet.BuildMode = L_Packet.bm_byPacket);

  curPerE:=PerE;

  ErrStr:="";
  IF ~L_SFee.SFeeIsCalculatedInProperConsecution(L_DatTim.Per(curPerE)) THEN
   ErrStr:=" 믮  客 ᮢ  "+L_DatTim.PeriodStr(curPerE);
  END;

  IF ~!ErrStr THEN
   IF Strong THEN
    L_General.Assert_wReferToAdmin(0, ErrStr);
   ELSE
    L_StdFrm.Choice(ErrStr);
   END;
  END;
 END {CheckPer};

 PRIVATE PROCEDURE InsDefPFPacket(trgExtNbr: LIKE(Packet.ExtNbr); trgDataType: LIKE(Packet.DataType); trgCorrType: LIKE(Packet.CorrType));
 BEGIN
  L_Packet.InsPFPacket(L_Packet.Get_PF_PacketKind(PerB, PerE, trgDataType, trgCorrType), trgExtNbr, PerB, PerE, trgDataType, trgCorrType);
 END {InsDefPFPacket};

 PRIVATE PROCEDURE SetDateParms(trgPerB, trgPerE: DATE);
 BEGIN
  PerB:=trgPerB;
  PerE:=trgPerE;
  ManPerB:=L_DatTim.GetFirstDateOfQuartal(PerE);
  ManPerE:=PerE;

  L_DatTim.CheckWMIntvl(PerB, PerE);

  Year:=L_DatTim.YEAR(PerE);
  L_General.Assert(Year = L_DatTim.YEAR(PerB), "ਮ ᢥ    । ");
 END {SetDateParms};

 PRIVATE PROCEDURE SetPerByWord(WithOrigin: SCAL[2]);
  VAR
   QSign: STRING[4];
   bQ,
   eQ   : SCAL[4];
 BEGIN
  bQ:=L_DatTim.QUARTAL(PerB);
  eQ:=L_DatTim.QUARTAL(PerE);

  SETEMPTY(Quarter);
  IF    (bQ = 0) & (eQ = 0) THEN Quarter:=3;
  ELSIF (bQ = 0) & (eQ = 1) THEN Quarter:=6;
  ELSIF (bQ = 0) & (eQ = 2) THEN Quarter:=9;
  ELSIF (bQ = 0) & (eQ = 3) THEN Quarter:=0;
  END;
  IF !Quarter | (PerB # L_DatTim.YearBeg(PerB)) | (PerE # L_DatTim.GetLastDateOfQuartal(PerE)) THEN
   L_General.Error(" "+Year+"     ਮ  砫    ⠫");
  END;
  PerByWord:="() ["+  L_Str.PoolItem("3|6|9|0", eQ)+"]    "+Year;

  IF WithOrigin THEN
   orgnPerByWord:=PerByWord;
   orgnPerE:=PerE;
   orgnYear:=Year;
   orgnQuarter:=Quarter;
  END;
 END {SetPerByWord};

 PRIVATE PROCEDURE GetActualDate(byPacket: SCAL[2]): DATE;
 BEGIN
  RETURN PerE;
 END {GetActualDate};

 PRIVATE PROCEDURE CheckPrvUnDonePackets();
  CONST
   Begin = 01\01\2013; (*15.07.2013 16:18:52 POLAK\Bor. 0098251    01.2010,   ᯮ墠⨫*)
  VAR
   prvPerB,
   prvPerE    : DATE;
 BEGIN
  APP.Get().NewPrompt("஢ઠ ᤠ ⮢");
  SAVE(Packet);
  prvPerB:=PerB;
  prvPerE:=PerE;
  WHILE prvPerB > Begin DO
   L_Packet.Get_PF_PrvPer(prvPerB, prvPerE);
   PROMPT(L_DatTim.PeriodStr(prvPerB)+"-"+L_DatTim.PeriodStr(prvPerE));
   L_Packet.CheckUnDonePacketsStrong(L_Packet.Get_PF_PacketKind(prvPerB, prvPerE, L_Packet.dt_Basic, L_Packet.ct_None),
                                     prvPerB, prvPerE, L_Packet.dt_Basic, L_Packet.ct_None);
  END; (* WHILE prvPerB > ... *)
  RESTORE(Packet);
 END {CheckPrvUnDonePackets};

 PUBLIC PROCEDURE SingleManIns();
  VAR
   Dummy: SCAL[2];
   nPack: L_XML.tNode;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Man), " ⠭ 䨧᪮ ");
  TRY [ABORT_AFTER(AA_ON)]
   InitServices(Memo.ud_fr(), Memo.ud_ut());
   InitCorr();
   CurPacket:=L_Packet.trn_Init(GetActualDate(0), L_Packet.bm_bySingle, L_Packet.part_Manins,
                                L_Packet.Get_PF_PacketKind(PerB, PerE, L_Packet.dt_Basic, L_Packet.ct_None));
   CheckPer();
   SetPerByWord(1);
   InsDefPFPacket(CurPacket, L_Packet.dt_Basic, L_Packet.ct_None);
   CurNumInP     :=0001;
   TotNumInP     :=CurNumInP;
   L_Packet.trn_OpenFiles();
   nPack:=L_Packet.trn_PutHead();

   L_Packet.MakeProjectPrt();
   PutManInIntrm();

   IF SELECT(Intrm, Intrm) THEN
    SetPckBodyByIntrm(CurPacket);
    WHILE OCCURE(Intrm) DO
     PROMPT("⮢ ⮢ "+ Intrm.Man);
     SETZERO(pckInc, pckBase, pckAdd);
     NARROWSEL(Intrm, DataType, CorrType);
     FOR_EACH Intrm DO
      CurNumInP:=0;
      PrepareOneMan();
      CheckPrb01();
      MakeOneMan(nPack);
      ClearServices(0);
     END; (* FOR_EACH Intrm ... *)
     NEXTINEXTENDEDSEL(Intrm, DataType, CorrType);
    END;

    L_Packet.trn_CloseFiles(nPack);
    DeInitServices();
   ELSE
    CheckPrb01();
    L_StdFrm.BlueHalt(" 室   ᢥ");
   END;
  EXCEPT
  END;
  Dummy:=L_Packet.ChoosePacket(L_Packet.Get_PF_PacketKind(PerB, PerE, L_Packet.dt_Basic, L_Packet.ct_None),
                               PerB, PerE,
                               L_Packet.dt_Basic, L_Packet.ct_None);
  L_General.SurveyLastReport();
 END {SingleManIns};

 PUBLIC PROCEDURE GetPersPacketsInfo(trgMyFirm: LIKE(MyFirm.MyFirm); trgPerB, trgPerE: DATE);
  VAR
   curDTS: LIKE(Packet.DTStamp);
 BEGIN
  APP.Get().NewPrompt(" ");
(*
  L_AFM.MakeMultipleIndex("_PInf", "Type    : SCAL[2];" +
                                   "Year    : NUMERIC[0];" +
                                   "Code    : NUMERIC[0];" +
                                   "TrnFName: STRING[100];"+
                                   "Packet  : LIKE(Packet.Packet);"+
                                   "Base    : NUMERIC[2];"+
                                   "Fee_PFIn: NUMERIC[2]",
                                   "Fee_PFAc: NUMERIC[2]",
                                   "ManNum  : NUMERIC[0]",
                          "_PInf:Type,Period,TrnFName,Packet");
*)
  TRY [RESTORE_CURSORS(RC_ON)]
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   L_Packet.PckMyFirm:=trgMyFirm;

   SETEMPTY(curDTS);
   SETSEL(Packet, PacketKn, L_Packet.rcv_PensFund, L_Packet.knd_PF_RSV1_6, trgPerB, trgPerE);
   FOR_EACH Packet DO
    PROMPT(Packet.Packet);
    IF L_Packet.IsValidPacket() & ~IsCorrPacket() THEN
     IF !curDTS THEN
      curDTS:=Packet.DTStamp;
     ELSE
      L_General.Assert(curDTS = Packet.DTStamp, " ਮ  "+L_DatTim.PeriodStr(trgPerB)+"  "+L_DatTim.PeriodStr(trgPerE)+
                                                "| 室   ଥ '"+L_Str.PoolItem(L_Packet.knd_Pool, L_Packet.knd_PF_RSV1_6)+"'  ࠧ묨 ⠬"+
                                                L_StdFrm.HR()+
                                                ",  뫨 㪠 ﭨ '"+L_Str.PoolItem(L_Packet.st_Pool, L_Packet.st_Rejected)+"'"+
                                                "| ࠭ ନ஢   㫨஢ ");
     END;
    END;
   END; (* FOR_EACH Packet ... *)
   IF ~!curDTS THEN
    SETSEL(Packet, PacketDS, L_Packet.rcv_PensFund, curDTS);
    FOR_EACH Packet DO
     PROMPT(Packet.Packet);
     IF L_Packet.IsValidPacket() THEN
      DEFAULT(_PInf);
      _PInf.Packet:=Packet.Packet;
      _PInf.TrnFName:=L_Packet.ext_trnFileName(trgPerE);
      SETSEL(PckBody, Packet, Packet.Packet);
      IF LAST(PckBody) THEN
       _PInf.ManAmnt:=PckBody.SeqNbr;
      ELSE
       _PInf.ManAmnt:=0;
      END;
      _PInf.Year:=L_DatTim.YEAR(Packet.PerB);
      _PInf.PerCode:=STRTOFLD(L_Packet.GetPacketAttr(Packet.Packet, patt_PerCode), NUMERIC);
      IF IsCorrPacket() THEN
       _PInf.Type:=1;
       _PInf.Base:=0;
       IF Packet.Kind = L_Packet.knd_PF_RSV1_6 THEN
        _PInf.Fee_PF:=Packet.Sums[ps_Add];
       ELSE
        L_General.CallUs(Packet.PerE < 01\01\2014);
        _PInf.Fee_PFIn:=Packet.Sums[ps_InInc];
        _PInf.Fee_PFAc:=Packet.Sums[ps_AcInc];
       END;
      ELSE
       L_General.CallUs(Packet.PerB >= 01\01\2014);
       _PInf.Type    :=0;
       _PInf.Base    :=Packet.Sums[ps_Base];
       _PInf.Fee_PF:=Packet.Sums[ps_Inc];
      END;
      INSERT(_PInf);
     END;
    END; (* FOR_EACH Packet ... *)
   END; (* IF ~!curDTS ... *)
  EXCEPT
  END;
 END {GetPersPacketsInfo};

 PUBLIC PROCEDURE CalcNumOfInsMen(trgMyFirm: LIKE(MyFirm.MyFirm); trgPerB, trgPerE: DATE): NUMERIC[0];
  VAR
   Till,
   curPerB,
   curPerE: DATE;
   Result : NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt(" ⢠ ");
  TRY [ABORT_AFTER(AA_ON)]
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   L_Packet.PckMyFirm:=trgMyFirm;
   curPerE:=trgPerE;
   curPerB:=L_Packet.Get_PF_StdPerB(curPerE);

   SELECT(Packet, PacketKn, , L_Packet.rcv_PensFund, L_Packet.knd_PF_RSV1_6, curPerB, curPerE);
   WHILE OCCURE(Packet) & ~L_Packet.IsValidPacket() DO
    NEXT(Packet);
   END; (* WHILE OCCURE(Packet) ... *)
   IF ~OCCURE(Packet) THEN
    SETEMPTY(Result);
   ELSE
    Result:=0;
    CreatePkIdx();
    WHILE curPerB >= trgPerB DO
     MakePckIndex(curPerB, curPerE, EMPTYOF(Man.Man));
     L_Packet.Get_PF_PrvPer(curPerB, curPerE);
    END;
    SELECT(PkIdx, Man);
    WHILE OCCURE(PkIdx) DO
     L_General.CallUs((PkIdx.PerB >= trgPerB) & (PkIdx.PerE <= trgPerE));
     INC(Result);
     NARROWSEL(PkIdx, Man);
     NEXTINEXTENDEDSEL(PkIdx, Man);
    END; (* WHILE OCCURE(PkIdx) ... *)
   END;
  EXCEPT
  END;
  RETURN Result;
 END {CalcNumOfInsMen};

 PUBLIC PROCEDURE InitialAll();
  VAR
   curKind: LIKE(Packet.Kind);
   Msg: STRING[];
   i  : NUMERIC[0];
   TotPrvInc,
   TotCurInc : tPFSum;
 BEGIN
  IF Memo.ud_fr() < 01\01\2014 THEN
   L_StdFrm.BlueStop("ࢮ砫쭮 ନ஢ ᢥ    ਮ  2014    ந");
  END;
  L_StdFrm.Question("ࢮ砫쭮 ନ஢ ᢥ  "+
                    "| | ਮ  "+L_DatTim.DateStr(Memo.ud_fr())+"  "+L_DatTim.DateStr(Memo.ud_ut()));

  SetDateParms(Memo.ud_fr(), Memo.ud_ut());
  curKind:=L_Packet.Get_PF_PacketKind(PerB, PerE, L_Packet.dt_Basic, L_Packet.ct_None);

  APP.Get().NewPrompt(L_Str.PoolItem(L_Packet.knd_Pool, curKind));

  CurPacket:=L_Packet.trn_Init(GetActualDate(0), L_Packet.bm_byAll, L_Packet.part_Manins, curKind)-1;
  CheckPer();
  SetPerByWord(1);
  L_Packet.CheckExistingPacketsStrong(curKind, PerB, PerE, L_Packet.dt_Basic, L_Packet.ct_None);

  CheckPrvUnDonePackets();

  InitCorr();

  SETSEL(Packet, PckDTSKn, L_Packet.rcv_PensFund, L_Packet.SampleDTStamp);
  FOR_EACH Packet DO
   IF (Packet.Status = L_Packet.st_Prepared) & (Packet.MyFirm = L_Packet.PckMyFirm) &
      (Packet.PerB >= 01\01\2010) & (Packet.PerE < Memo.ud_ut()) &
      ((Packet.Kind = L_Packet.knd_PF_SZV6_4) |
       (Packet.Kind = L_Packet.knd_PF_SZV6)   |
       (Packet.Kind = L_Packet.knd_PF_RSV1_6))  THEN
    L_General.Assert(IsCorrPacket(), "-ࠧ "+Packet.Packet+"    '室'");
    L_General.Assert(Packet.CorrType = L_Packet.ct_Corr, "-ࠧ "+Packet.Packet+"   ⨯ ४஢ '"+L_Str.PoolItem(L_Packet.ct_Pool, L_Packet.ct_Corr)+"'|"+
                                                         " ନ஢ ᢥ ணࠬ ᠬ⥫쭮 । ॡ㥬 ⨯ ४஢");
    SETSEL(PckBody, Packet, Packet.Packet);
    FOR_EACH PckBody DO
     ADD(TmpCP, TmpCP, , Packet.PerB, Packet.PerE, PckBody.Man);
    END; (* FOR_EACH PckBody ... *)
    L_Packet.SetSamplePacketDone();
   END;
  END; (* FOR_EACH Packet ... *)

  L_SFee.PrepareChanges(L_Packet.PckMyFirm, ManPerB, EMPTYOF(DATE), EMPTYOF(DATE));

  SETSEL(MSFCh, Man);
  FOR_EACH MSFCh DO
   IF (MSFCh.Fee[L_SFee.p_PFIn] # 0) | (MSFCh.Fee[L_SFee.p_PFAc] # 0) THEN
    ADD(TmpCP, TmpCP, , L_Packet.Get_PF_StdPerB(MSFCh.Period), L_Packet.Get_PF_StdPerE(MSFCh.Period), MSFCh.Man);
   END;
  END; (* FOR_EACH MSFCh ... *)

  IF SELECT(TmpCP, TmpCP) THEN
   L_Packet.BuildMode:=L_Packet.bm_byPacket;

   Msg:="";
   WHILE OCCURE(TmpCP) DO
    i:=0;
    Msg:=Msg+"|"+L_DatTim.PeriodStr(TmpCP.PerB)+"-"+L_DatTim.PeriodStr(TmpCP.PerE);
    NARROWSEL(TmpCP, PerB, PerE);
    FOR_EACH TmpCP DO
     INC(i);
    END; (* FOR_EACH TmpCP ... *)
    Msg:=Msg+"  :"+Str.Align(L_Str.IntStr(i), 4, RIGHT);
    NEXTINEXTENDEDSEL(TmpCP, PerB, PerE);
   END; (* WHILE OCCURE(TmpCP) *)

   L_StdFrm.Question(" ନ஢ ४騥 ᢥ:|"+Msg);
 
   SELECT(TmpCP, TmpCP);
   IF TmpCP.PerB < 01\01\2014 THEN
    SAVE(TmpCP);
    CurPacket:=CALL(ManIns.MakeCorrPacket(PerB, PerE, CurPacket));
    RESTORE(TmpCP);
   END;
   IF SRCINSEL(TmpCP, GE, 01\01\2014) THEN
    CurPacket:=CALL(ManIns14.MakeCorrPacket(PerB, PerE, CurPacket));
   END;

   L_Packet.BuildMode:=L_Packet.bm_byAll;
   SetDateParms(Memo.ud_fr(), Memo.ud_ut());
   SetPerByWord(1);
  END; (* IF SELECT(TmpCP, TmpCP) ... *)

  InitServices(Memo.ud_fr(), Memo.ud_ut());

  PrepareGroup();
  BuildPackets();
  MakeAll();
  DeInitServices();

  L_Packet.ShowMakedPackets();
 END {InitialAll};

 PUBLIC PROCEDURE ByCurrentPacket();
 BEGIN
  L_General.Error("ࢮ砫쭮 ନ஢ ᢥ    ४஢ । ਮ"+
                  '|믮  "F10 - ᮭ - ௫ - ⮣ -|ᮭ஢    -|ନ஢ ᢥ  ⠦  ᫥   ᥬ  ਮ"');
 END {ByCurrentPacket};

 PUBLIC PROCEDURE MakeCorrPacket(trgPerB, trgPerE: DATE; trgCurPacket: LIKE(Packet.Packet)): LIKE(Packet.Packet);
  VAR
   curKind: LIKE(Packet.Kind);
 BEGIN
  InitServices(trgPerB, trgPerE);

  APP.Get().NewPrompt("४騥 ᢥ");

  curKind:=L_Packet.Get_PF_PacketKind(trgPerB, trgPerE, L_Packet.dt_Basic, L_Packet.ct_None);
  SetPerByWord(1);

  CurPacket:=trgCurPacket;

  L_Packet.BuildMode:=L_Packet.bm_byPacket;

  SETSEL(TmpCP, TmpCP);
  L_General.CallUs(SRCINSEL(TmpCP, GE, 01\01\2014));
  WHILE OCCURE(TmpCP) DO
   SetDateParms(TmpCP.PerB, TmpCP.PerE);
   SetPerByWord(0);

   SETSEL(PkIdx, PkIdx); REMSEL(PkIdx);
   NARROWSEL(TmpCP, PerB, PerE);
   FOR_EACH TmpCP DO
    IF ~SELECT(Intrm, Man, TmpCP.Man) THEN
     MakePckIndex(PerB, PerE, TmpCP.Man);
     SEARCH(Man, Man, , TmpCP.Man);
     PutManInIntrm();
    END;
   END; (* FOR_EACH TmpCP ... *)

   BuildPackets();
   MakeAll();
   ClearServices(1);
   NEXTINEXTENDEDSEL(TmpCP, PerB, PerE);
  END; (* WHILE OCCURE(TmpCP) *)
  RETURN CurPacket;
 END {MakeCorrPacket};

END.
