(*
%Copyright   (c) Polak Computer System
%Author      27.11.2000 11:19:44 SAN
%Purpose     ନ஢    㯮/த
%Type        report
%Specific    SYS
%Modified    11.08.2014 14:41:32 POLAK\San
%Environment
*)

 MODULE MD001 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_DatTim, L_Str, FIO, Str, L_Basis, P_MDoc, L_Way, L_Car, L_CI, L_Staff,
        L_MDoc, L_MathR, L_Cntr, L_XObj, L_Acnt, L_StdFrm, P_Cntr, P_Math, P_Firm, L_bp,
        L_XDoc, L_Rpr, L_APtm;

 PRIVATE TYPE
  tRepName = STRING[];

 PRIVATE CONST
  ds_All     = 0;
  ds_Outside = 1;
  ds_Inside  = 2;
  dsPool = "|쪮 譨|쪮 ७";

  dt_All     = 0;
  dt_Real    = 1;
  dt_Debit   = 2;
  dt_Credit  = 3;
  dtPool = "|쭮 |室|室";

  rn_MD001 = "MD001";
  rn_MD002 = "MD002";
  rn_MD004 = "MD004";
  rn_MS001 = "MS001";

 PRIVATE VAR
  wMF     : SCAL[2];
  RepName : tRepName;
  DocSorts: SCAL[3];
  DocTypes: SCAL[4];

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
IF L_APtm.IsOG() THEN
L_Basis.wb_WrInQM(F, "");
L_Basis.wb_WrInQM(F, "");
END;
  L_Basis.wb_WrInQM(F, " 樨");
  L_Basis.wb_WrInQM(F, " 樨");
  L_Basis.wb_WrInQM(F, "ࠦ");
  L_Basis.wb_WrInQM(F, "᭮");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "㯯 ப");
  L_Basis.wb_WrInQM(F, "㯯 ப");

  IF    RepName = rn_MS001 THEN
   L_Basis.wb_WrInQM(F, " ");
   L_Basis.wb_WrInQM(F, "஡");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "_㯯ப");
   L_Basis.wb_WrInQM(F, "_㯯ப");
   L_Basis.wb_WrInQM(F, "ॢ");
   L_Basis.wb_WrInQM(F, "ॢ");

   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "ࠢ");
   L_Basis.wb_WrInQM(F, " ꥪ ६");
   L_Basis.wb_WrInQM(F, "ꥪ ६⠊");
   L_Basis.wb_WrInQM(F, "ꥪ ६");
   L_Basis.wb_WrInQM(F, " ");
  ELSIF (RepName = rn_MD002) | (RepName = rn_MD004) THEN
   L_Basis.wb_WrInQM(F, "");
  END;

  L_Basis.wb_WrInQM(F, " ꥪ⠊");
  L_Basis.wb_WrInQM(F, " ꥪ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⢮");
  L_Basis.wb_WrInQM(F, "㬬");

  L_Basis.wb_WrInQM(F, " 㬥⠊");
  L_Basis.wb_WrInQM(F, " 㬥");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "室 ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "室 ");
  L_Basis.wb_WrInQM(F, "ﭨ 㬥");
  L_Basis.wb_WrInQM(F, "訫");
  L_Basis.wb_WrInQM(F, "訫");
  L_Basis.wb_WrInQM(F, "쭮 ");
  L_Basis.wb_WrInQM(F, " ⢨");
  L_Basis.wb_WrInQM(F, "ࠢ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "࣠");
  L_Basis.wb_WrInQM(F, "࣠");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⭮襭");
  L_Basis.wb_WrInQM(F, " ࠊ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "2");
  L_Basis.wb_WrInQM(F, "2");
  L_Basis.wb_WrInQM(F, "ꥪ");
  L_Basis.wb_WrInQM(F, "ꥪ");
  L_Basis.wb_WrInQM(F, "ꥪ⭮襭");
  L_Basis.wb_WrInQM(F, "ந⥫");
  L_Basis.wb_WrInQM(F, "ந⥫");
  L_Basis.wb_WrInQM(F, "⠫");
  L_Basis.wb_WrInQM(F, "㬬।");
  L_Basis.wb_WrInQM(F, "⮨㬬");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ॣ");
  L_Basis.wb_WrInQM(F, "ॣ");
  L_Basis.wb_WrInQM(F, "ਬ砭");
  L_Basis.wb_WrInQM(F, " 㬬");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ᮡ  ");
  L_Basis.wb_WrInQM(F, "⮨  ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrStr( F, " ७");

  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE GetRprDAList(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  SELECT(RprDA, RprDA, , RprS.RprS);
  WHILE OCCURE(RprDA) DO
   CONFORM(RprDA, RprDfApr);
   CONFORM(RprDfApr, CarBlock);
   Result:=L_Str.AddStrDlm(Result, ";") + CarBlock.Name + ": " + Str.Small(RprDfApr.Name);
   NEXT(RprDA);
  END; (* WHILE OCCURE(RprDA) ... *)
  RETURN Result;
 END {GetRprDAList};

 PRIVATE PROCEDURE MakePart(F: STRING[]);
  VAR
   xdt          : L_XDoc.tXDocType;
   xdk          : L_XDoc.tXDocKind;
   xd           : L_XDoc.tXDoc;
   curQnt       : L_XObj.tQnt;
   curBoxNbr    : LIKE(Car.BoxNbr);
   RprSXDocId   : L_XDoc.tXDocId;
   SumByAvePrice: L_XObj.tSum;
   TaskKind     : LIKE(RprT.TaskKind);
 BEGIN
  CONFORM(MDoc, MyFirm);
  CONFORM(MDoc, Alower);
  CONFORM(MDoc, Dest);
  CONFORM(MDoc, Firm);
  CONFORM(MDoc, Contract);
  IF OCCURE(Contract) THEN
   CONFORM(Contract, CntrT);
  END;
  CONFORM(MDoc, Staff);
  CONFORM(Staff, Man);
  CONFORM(Math, CarUnit);
  CONFORM(Math, MathType);

  IF wMF THEN
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
IF L_APtm.IsOG() THEN
IF ~!MDoc.BoxNbr THEN
 CONFORM(MDoc, Car);
 CONFORM(Car, am);
ELSE
 CONFORM(Man, am);
END;
L_Basis.wb_WrScl(F, am.am);
L_Basis.wb_WrStr(F, am.Name);
END;
  L_Basis.wb_WrScl(F, Dest.Dest);
  L_Basis.wb_WrStr(F, Dest.Name);

  IF    ~!MDoc.CostItem THEN
   CONFORM(MDoc, CostItem);
  ELSIF ~!MDocList.CostItem THEN
   CONFORM(MDocList, CostItem);
  ELSE
   L_General.CLEAR("CostItem");
  END;

  SETEMPTY(curBoxNbr);
  IF    ~!MDoc.BoxNbr THEN
   curBoxNbr:=MDoc.BoxNbr;
  ELSIF OCCURE(CostItem) THEN
   curBoxNbr:=L_CI.GetCarByCostItem(CostItem.CostItem, MDoc.Date);
  END;
  IF ~!curBoxNbr THEN
   L_Car.StandOnCarLog(curBoxNbr, MDoc.Date);
   CONFORM(CarLog, Mark);
   CONFORM(CarLog, Column);
   CONFORM(CarLog, TKind);
   L_Basis.wb_WrScl(F, CarLog.BoxNbr);
   L_Basis.wb_WrScl(F, CarLog.StateNbr);
   L_Basis.wb_WrScl(F, Mark.Mark);
   L_Basis.wb_WrStr(F, Mark.Name);
   IF L_Way.StandOnMarkG_Soft(Mark.Mark, L_Way.mgt_Math) THEN
    L_Basis.wb_WrScl(F, MarkG.MarkG);
    L_Basis.wb_WrStr(F, MarkG.Name);
   ELSE
    L_Basis.wb_WrStr(F, "--");
    L_Basis.wb_WrStr(F, "---");
   END;

   IF RepName = rn_MS001 THEN
    L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Car.purp_Pool, CarLog.Purpose));
    L_Basis.wb_WrNum(F, L_Car.GetGlobalRun(CarLog.BoxNbr, Memo.ud_ut() + 1) / 1000, 0);
    CONFORM(CarLog, Car);
    L_Basis.wb_WrNum(F, L_DatTim.CompleteYearsInIntvl(L_Car.GetCarProdDate(Car.BoxNbr, MDoc.Date), Memo.ud_ut()), 0);
    L_Basis.wb_WrScl(F, Column.Column);
    IF L_Way.StandOnMarkG_Soft(Mark.Mark, L_Way.mgt_CostAccounting) THEN
     L_Basis.wb_WrScl(F, MarkG.MarkG);
     L_Basis.wb_WrStr(F, MarkG.Name);
    ELSE
     L_Basis.wb_WrStr(F, "----");
     L_Basis.wb_WrStr(F, "--------------------");
    END;
    IF OCCURE(TKind) THEN
     L_Basis.wb_WrScl(F, TKind.TKind);
     L_Basis.wb_WrStr(F, TKind.Name);
    ELSE
     L_Basis.wb_WrStr(F, "--");
     L_Basis.wb_WrStr(F, "--------------------");
    END;
   END;
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "---");

   IF RepName = rn_MS001 THEN
    L_Basis.wb_WrStr(F, "--");
    L_Basis.wb_WrNum(F, 0, 0);
    L_Basis.wb_WrNum(F, 0, 0);
    L_Basis.wb_WrStr(F, "--");
    L_Basis.wb_WrStr(F, "----");
    L_Basis.wb_WrStr(F, "--------------------");
    L_Basis.wb_WrStr(F, "--");
    L_Basis.wb_WrStr(F, "--------------------");
   END;
  END;

  IF (RepName = rn_MD002) | (RepName = rn_MD004) | (RepName = rn_MS001) THEN
   RprSXDocId:=L_XDoc.GetSingleRefToReqXDT(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.xdt_RprS);
   IF ~!RprSXDocId THEN
    L_XDoc.DecodeXDocId(RprSXDocId, xdt, xdk, xd);
    L_Basis.wb_WrStr(F, FLDTOSTR(xd, "L0", 7));
    IF RepName = rn_MS001 THEN
     TRY [RESTORE_CURSORS(RC_ON)]
      L_XDoc.PositionOnXDoc(RprSXDocId);
      L_Basis.wb_WrStr(F, GetRprDAList());
      L_Basis.wb_WrStr(F, L_Rpr.GetRprObjT_AsStr());
      L_Basis.wb_WrScl(F, RprS.RprObjId);
      L_Rpr.AccessOrigin();
      IF    L_Rpr.IsRprS_w_Car()      | L_Rpr.IsRprS_w_OutCar() THEN
       L_Basis.wb_WrStr(F, CUCopy.Serial);
      ELSIF L_Rpr.IsRprS_w_CarBlock() | L_Rpr.IsRprS_w_OutCBlc() | L_Rpr.IsRprS_w_Math() THEN
       IF L_Rpr.IsRprS_w_OutCBlc() THEN
        CONFORM(OutCBlc, Math);
       END;
       L_Basis.wb_WrStr(F, CUCopy.Serial + " " + Math.Name);
      ELSE
       L_General.CallUs(0);
      END;
      TaskKind:=L_Rpr.RprSTaskKind(RprS.RprS);
      IF ~!TaskKind THEN
       L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Rpr.rpr_TaskKind_Pool, TaskKind));
      ELSE
       L_Basis.wb_WrStr(F, "-------");
      END;
     EXCEPT
     END; (* TRY *)
    END;
   ELSE
    L_Basis.wb_WrStr(F, "--");
    IF RepName = rn_MS001 THEN
     L_Basis.wb_WrStr(F, "--------------------");
     L_Basis.wb_WrStr(F, "--------------------");
     L_Basis.wb_WrStr(F, "-------");
     L_Basis.wb_WrStr(F, "--------------------");
     L_Basis.wb_WrStr(F, "-------");
    END;
   END;
  END;

  L_Basis.wb_WrScl(F, MathType.MathType);
  L_Basis.wb_WrStr(F, MathType.Name);
  L_Basis.wb_WrStr(F, L_MathR.MModeStr(MDocList.MMode));

  curQnt:=L_MDoc.GetMDocListCir2();

  SETEMPTY(SumByAvePrice);
  IF ~!MDocList.Math & (RepName # rn_MD002) THEN
   TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
    SumByAvePrice:=curQnt * L_MathR.GetMDLMathPrice();
   EXCEPT
   ON Exc: Exc_Raise DO
   END;
  END; (* IF ~!MDocList.Math ... *)

  L_Basis.wb_WrNum(F, curQnt, GET_TYPE_SPEC(L_XObj.tQnt).Precision);
  IF RepName = rn_MS001 THEN
   L_Basis.wb_WrNum(F, SumByAvePrice, 2);
  ELSE
   L_Basis.wb_WrNum(F, MDocList.Sum, 2);
  END;

  L_Basis.wb_WrScl(F, MDoc.MDocKind);
  L_Basis.wb_WrStr(F, L_MDoc.MDocKindNick(MDoc.MDocKind, 1));
  L_Basis.wb_WrScl(F, MDoc.MDoc);
  L_Basis.wb_WrStr(F, MDoc.SrcNbr);
  L_Basis.wb_WrDat(F, MDoc.Date);
  L_Basis.wb_WrDat(F, MDoc.SrcDate);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_MDoc.st_Pool, MDoc.Status));
  IF OCCURE(Alower) THEN
   L_Basis.wb_WrScl(F, Alower.Alower);
   L_Basis.wb_WrStr(F, Alower.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", MDocKind.Activity));
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_MDoc.mds_Pool, MDocKind.Scope));
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_MDoc.mdd_Pool, MDocKind.Dir));
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_MDoc.mft_Pool_1Char, L_MDoc.getMDocListMathFlowType()));
  IF OCCURE(Firm) THEN
   L_Basis.wb_WrScl(F, Firm.Firm);
   L_Basis.wb_WrStr(F, Firm.Name);
  ELSE
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "-");
  END;
  IF OCCURE(Contract) THEN
   L_Basis.wb_WrScl(F, Contract.Contract);
   L_Basis.wb_WrStr(F, Contract.Name);
   L_Basis.wb_WrStr(F, Contract.SrcNbr);
   L_Basis.wb_WrStr(F, L_Cntr.GetContractType_asStr());
   L_Basis.wb_WrStr(F, L_Str.PoolItem(P_Cntr.satVAT_Pool,
                                      P_Cntr.GetSpecialAttitudeToVAT(Contract.Contract, MDoc.Date)));
   L_Basis.wb_WrScl(F, CntrT.CntrT);
   L_Basis.wb_WrStr(F, CntrT.Name);
  ELSE
   L_Basis.wb_WrStr(F, "-------");
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrScl(F, "---");
   L_Basis.wb_WrStr(F, "-");
  END;
  IF OCCURE(CostItem) THEN
   L_Basis.wb_WrScl(F, CostItem.CostItem);
   L_Basis.wb_WrStr(F, CostItem.Name);
   CONFORM(CostItem, CIKind);
   IF OCCURE(CIKind) THEN
    L_Basis.wb_WrScl(F, CIKind.CIKind);
    L_Basis.wb_WrStr(F, CIKind.Name);
   ELSE
    L_Basis.wb_WrStr(F, "--");
    L_Basis.wb_WrStr(F, "---");
   END;
  ELSE
   L_Basis.wb_WrStr(F, "-------");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "---");
  END;

  IF ~!MDoc.Storage THEN
   SEARCH(Storage, Storage, , MDoc.Storage);
   L_Basis.wb_WrScl(F, Storage.Storage);
   L_Basis.wb_WrStr(F, Storage.Name);
  ELSE
   L_Basis.wb_WrStr(F, "-------");
   L_Basis.wb_WrStr(F, "-");
  END;
  IF ~!MDoc.Storage2 THEN
   SEARCH(Storage, Storage, , MDoc.Storage2);
   L_Basis.wb_WrScl(F, Storage.Storage);
   L_Basis.wb_WrStr(F, Storage.Name);
  ELSE
   L_Basis.wb_WrStr(F, "-------");
   L_Basis.wb_WrStr(F, "-");
  END;
  L_Basis.wb_WrScl(F, Math.Math);
  L_Basis.wb_WrStr(F, Math.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(P_Math.satVAT_Pool,
                                     P_Math.GetSpecialAttitudeToVAT(Math.Math, MDoc.Date)));
  CONFORM(Math, Vendor);
  L_Basis.wb_WrScl(F, Vendor.Vendor);
  L_Basis.wb_WrStr(F, Vendor.Name);
  L_Basis.wb_WrStr(F, Math.UnitedC);

  L_Basis.wb_WrNum(F, SumByAvePrice, 2);
  IF L_MDoc.ManufacturingCostIsExplicit(MDoc.MDocKind) THEN
   L_Basis.wb_WrNum(F, MDocList.Sum, 2);
  ELSE
   L_Basis.wb_WrNum(F, SumByAvePrice, 2);
  END;
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrStr(F, CarUnit.CarUnit);
  L_Basis.wb_WrStr(F, CarUnit.Name);
  L_Basis.wb_WrStr(F, P_MDoc.GetMDocProSoft(MDoc.MDocKind,MDoc.MDoc, P_MDoc.P_Note));
  L_Basis.wb_WrNum(F, MDocList.Sum+MDocList.VAT, 2);
  L_Basis.wb_WrNum(F, MDocList.VAT, 2);
  IF ~!MDocList.VATMode THEN
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_MDoc.Get_vatm_Pool(0), MDocList.VATMode));
   L_Basis.wb_WrNum(F, MDocList.Sum + L_Acnt.VATPartInCost(L_Acnt.cvat_Allow, MDocList.VAT, MDocList.VATMode), 2);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrNum(F, MDocList.Sum, 2);
  END;
  L_Staff.PosToStaffLog(Staff.TSN, Memo.ud_ut(), 1);
  CONFORM(StaffLog, Sort);
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrStr(F, L_MathR.DefaultMUnitSign(Math.Math));

  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE ExecuteSetupDialog();
 BEGIN
  STDFORM(L_StdFrm.sf_Choice("|롮 ᮡ⥩  ⮢ 㬥⮢:" +
                             "|" +
                             "| ⢨          %#################%" +
                             "|" +
                             "|ࠢ               %#################%" +
                             "|",
                             "%<" + dsPool + ">I" +
                             "%<" + dtPool + ">I"),
          "      ࠦ ",
          ,
          1,
          DocSorts, DocTypes);
 END {ExecuteSetupDialog};

 PRIVATE PROCEDURE AcceptableMDocKind(): SCAL[2];
 BEGIN
  IF    (RepName = rn_MD004) |
        (RepName = rn_MD002) THEN RETURN 1;
  ELSIF  RepName = rn_MD001 THEN RETURN L_MDoc.IsExternalMDocKind()         |
                                        (MDocKind.MDocKind = L_MDoc.md_NPr) |
                                        (MDocKind.MDocKind = L_MDoc.md_ADo);
  ELSIF  RepName = rn_MS001 THEN RETURN (MDocKind.MDocKind = L_MDoc.md_NOV) |
                                        (MDocKind.MDocKind = L_MDoc.md_TOV);
  ELSE L_General.CallUs(0);
  END;
 END {AcceptableMDocKind};

 PRIVATE PROCEDURE AcceptableDir(): SCAL[2];
 BEGIN
  IF    RepName = rn_MD004  THEN
   IF    DocTypes = dt_All    THEN  RETURN 1;
   ELSIF DocTypes = dt_Real   THEN  RETURN MDocKind.Activity;
   ELSIF DocTypes = dt_Debit  THEN  RETURN MDocKind.Activity & (MDocKind.Dir = L_MDoc.mdd_Ingoing);
   ELSIF DocTypes = dt_Credit THEN  RETURN MDocKind.Activity & (MDocKind.Dir = L_MDoc.mdd_Outgoing);
   ELSE  L_General.CallUs(0);
   END;
  ELSIF (RepName = rn_MD002) THEN RETURN MDocKind.Activity;
  ELSIF (RepName = rn_MD001) | (RepName = rn_MS001) THEN RETURN 1;
  ELSE
   L_General.CallUs(0);
  END;
 END {AcceptableDir};

 PRIVATE PROCEDURE AcceptableScope(): SCAL[2];
 BEGIN
  IF      (RepName = rn_MD004)  THEN
   RETURN ( DocSorts = ds_All)                                    |
          ((DocSorts = ds_Outside) & L_MDoc.IsExternalMDocKind()) |
          ((DocSorts = ds_Inside)  & L_MDoc.IsInternalMDocKind());
  ELSIF (RepName = rn_MD001) | (RepName = rn_MD002) | (RepName = rn_MS001) THEN
   RETURN 1;
  ELSE
   L_General.CallUs(0);
  END;
 END {AcceptableScope};

 PRIVATE PROCEDURE Do();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.SetCacheables(["Man", "Mark", "Math", "Firm", "Sort", "Storage", "Staff", "StaffLog", "Vendor"]);
  wMF:=P_Firm.E_wMultipleMyFirm(Memo.ud_ut());
  MakeHeader("R");
  SELECT(MDocKind, MDocKind);
  WHILE OCCURE(MDocKind) DO
   IF AcceptableMDocKind() & AcceptableDir() & AcceptableScope() THEN
    SAVE(MDocKind);
    SETSEL(MDoc, MDKDate, MDocKind.MDocKind);
    SRCINSEL(MDoc, GE, , Memo.ud_fr());
    WHILE OCCURE(MDoc) & (MDoc.Date <= Memo.ud_ut()) DO
     PROMPT(L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) + "  " + L_DatTim.DateStr(MDoc.Date));
     IF MDoc.Status # L_MDoc.st_Canceled THEN
      SETSEL(MDocList, MDoc, MDoc.MDocKind, MDoc.MDoc);
      FOR_EACH MDocList DO
       IF (RepName # rn_MS001) | (L_MDoc.getMDocListMathFlowType() = L_MDoc.mft_Credit) THEN
        PROMPT(L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) + "  " + L_DatTim.DateStr(MDoc.Date) + ": " + MDocList.MDLNbr);
        IF    ~!MDocList.Math THEN
         CONFORM(MDocList, Math);
        ELSIF ~!MDoc.Math THEN
         CONFORM(MDoc, Math);
        ELSE
         SETSEL(Math, Math);
        END;
        IF OCCURE(Math) THEN
         MakePart("R");
        END;
       END;
      END; (* FOR_EACH MDocList *)
     END; (* IF MDoc.Status ... *)
     NEXT(MDoc);
    END; (* WHILE OCCURE(MDoc) ... *)
    RESTORE(MDocKind);
   END;
   NEXT(MDocKind);
  END; (* WHILE OCCURE(MDocKind) ... *)
 END {Do};

 PUBLIC PROCEDURE MD001();
  CONST
   bpId = rn_MD001;
 BEGIN
  L_bp.Begin(bpId, " 㯮/த", L_bp.t_Basis, L_General.timeCond_InIntvl);
  RepName:=bpId;
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  Do();
  FIO.Close(R);
  L_bp.End();
 END {MD001};

 PUBLIC PROCEDURE MD002();
  CONST
   bpId = rn_MD002;
 BEGIN
  L_bp.Begin(bpId, "   ⢥ ࠦ", L_bp.t_Basis, L_General.timeCond_InIntvl);
  RepName:=bpId;
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  Do();
  FIO.Close(R);
  L_bp.End();
 END {MD002};

 PUBLIC PROCEDURE MD004();
  CONST
   bpId = rn_MD004;
 BEGIN
  L_bp.Begin(bpId, "    ࠦ", L_bp.t_Basis, L_General.timeCond_InIntvl);
  RepName:=bpId;
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  DocSorts:=ds_All;
  DocTypes:=dt_All;
  Do();
  FIO.Close(R);
  L_bp.End();
 END {MD004};

 PUBLIC PROCEDURE MD004_Selective();
  CONST
   Title = "롮      ࠦ";
 BEGIN
  RepName:=rn_MD004;
  APP.Get().NewPrompt("("+RepName+") "+Title);
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  DocSorts:=ds_All;
  DocTypes:=dt_All;
  ExecuteSetupDialog();
  Do();
  FIO.Close(R);
  L_Basis.PlayMakedRunTimeRep(RepName,
                              L_General.timeCond_InIntvl,
                              Title,
                              0);
 END {MD004_Selective};

 PUBLIC PROCEDURE MS001();
  CONST
   bpId = rn_MS001;
 BEGIN
  L_bp.Begin(bpId, " 室 ", L_bp.t_Basis, L_General.timeCond_InIntvl);
  RepName:=bpId;
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  Do();
  FIO.Close(R);
  L_bp.End();
 END {MS001};

END.
