(*
%Copyright   (c) Polak Computer System
%Author
%Purpose      ᪫᪨ 㬥⮢   ਭ(LX,FX,PCL)
%Type        report,to paste
%Specific    SYS
%Modified    11.08.2014 10:48:45 POLAK\Bor
%Environment
*)

 IMPORT L_General, L_MathR, L_DatTim, L_MDoc, L_XDoc, L_Pmnt, L_Str, L_CUC, L_APtm,
        P_Firm, P_Math, P_MDoc, E_Prop, L_Env, L_Rpr, L_PCS;

 VAR
  S_Cir      : NUMERIC[2][3];
  S_SaleTax,
  S_VAT,
  SwoVAT     : NUMERIC[2];
  Count      : NUMERIC[0];
  XDocStr    : STRING[][6];
  TextPreview: STRING[];
  _CURate    : FLOAT;
  CommAssign : STRING[];


(*$P {CommonTop:
P_Firm.FP_FirmName(P_Firm.fomf(MDoc.MyFirm), SYSDATE()), L, ""
MDocKind.MDocKind+" "+MDocKind.SName+"  "+MDoc.MDoc+" ("+MDoc.CopyCnt+")  "+L_DatTim.DateStr(MDoc.Date), L, ""
XDocStr[0], L, ""
MDoc.SrcNbr+"  "+L_DatTim.DateStr(MDoc.SrcDate), L, ""
?, L, ""
XDocStr[1], L, ""
MDoc.Status, L, "!!!⮢!!!|஢|!!!㫨஢!!!"
XDocStr[2], L, ""
MDoc.Dest, L, ""
Dest.Name, L, ""
L_MDoc.MDocDirection(), L, "(ਥ)|()"
L_MDoc.MDocStorage(), L, ""
L_MDoc.MDocStorageName(), L, ""
XDocStr[3], L, ""
XDocStr[4], L, ""
MDoc.TSN+" "+Man.Name, L, ""
XDocStr[5], L, ""
GetMDocDescr_asStr(), L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
##################################################################                                                 ୠ
##########################################################################                                         ----------------------------------------------------
                                                                                                                   ####################################################
. ..##############################       ######################                                            ####################################################
ﭨ...##############################                                                                         ####################################################
....### ################################ ########  ####### ############################################  ####################################################
                                                                                                                   ####################################################
⭨...........#############################################################                                   ####################################################
⭠ ....#############################################################
࣠........####################################################################################################################################################
 ..........################################################################################################################################
訫...........####################################################################################################################################################
਩........####################################################################################################################################################
                   ####################################################################################################################################################
易 㬥.################################################################################################################################

-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
| |ꥪ                                           | |..|  -|     | , |  㬬 |㬬 /||    㬬 |㬬  |  㬬, |
}
*)

(*$P {CommonLine:
MDocList.MDLNbr, R, ""
?, L, ""
MDocList.MMode, L, ""
L_MathR.MModeStr(MDocList.MMode), L, ""
?, L, ""
?, L, ""
?, R, ""
?, R, "2-"
?, R, "2."
MDocList.SaleTax, R, "2-"
MDocList.Sum, R, "2-"
Ratio(MDocList.VAT*100, MDocList.Sum), R, "0"
MDocList.VATMode, L, L_MDoc.Get_vatm_Pool(1)
MDocList.VAT, R, "2-"
MDocList.Sum+MDocList.VAT, R, "2-"
Ratio(MDocList.Sum+MDocList.VAT, _CURate), R, "2."
@
|----|--------------------------------------------------|------|-------|--------|---------|---------|-----------|-----------|---|-------------|-----------|-----------|
|####|##################################################|## ###|### ###|########|#########|#########|###########|###########|###|# ###########|###########|###########|
}
*)

(*$P {CommonlineFill:
@
|----|--------------------------------------------------|------|-------|--------|---------|---------|-----------|-----------|---|-------------|-----------|-----------|
|    |                                                  |      |       |        |         |         |           |           |   |             |           |           |
}
*)

(*$P {CommonbotTotal:
S_Cir[2], R, "2."
S_SaleTax, R, "2-"
SwoVAT, R, "2-"
S_VAT, R, "2-"
MDoc.Total, R, "2-"
Ratio(MDoc.Total, _CURate), R, "2."
@
|---------------------------------------------------------------------------------------------------|-----------|-----------|---|-------------|-----------|-----------|
|⮣                                                                 |########|         |         |###########|###########|   |#############|###########|###########|
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
}
*)

(*$P {CommonbotStr:
?, L, ""
?, L, ""
@
###################################### ################################################################################################################################
}
*)

(*$P {Commonbot:
TextPreview, C, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
@
(c) Polak #####################################################################################################################                        ########## #####}
*)

(*
$P{ CommonbotSubscribe:
L_MDoc.MDoc3Direction(), L, "⨫|ਭ|ନ"
FULLNAME(), L, ""
TextPreview, C, ""
L_MDoc.MDoc3Direction(), L, "稫||"
?, L, ""
?, L, ""
@
######## 騪                            _______________________________ /################################################################/

###############################################################################################################################################
#######  #################################### _______________________________ /################################################################/}
*)

(*$P {m11top:
?, L, ""
?, L, ""
L_APtm.GetTheDocCause(MDoc.Date, "⢥ত ⠭ ᪮ ᨨ  30.10.97 N 71"), R, ""
L_MDoc.MDocKindNick(MDoc.MDocKind, 1), L, "" "B"
MDoc.MDoc, L, ""
MDoc.CopyCnt, L, ""
?, L, ""
P_Firm.FP_FirmName(P_Firm.fomf(MDoc.MyFirm), SYSDATE()), L, ""
P_Firm.FP_OKPO(P_Firm.fomf(MDoc.MyFirm), SYSDATE()), L, ""
MDoc.Date, L, "D.N.y"
Dest.Dest, L, ""
?, L, ""
?, L, ""
GetMDocDescr_asStr(), L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
"(" + MDoc.Alower + " " + Alower.Name + ")", L, ""
@
#####################################################################################################################
#####################################################################################################################               ଠ N -11
################################################################################################################################################
                                                                                                                                      ----------
                                                                                                                                      |    |
                                                                                                                                      |--------|
 -  (###)  ####### (##) ##############################                                              ଠ   | 0315006|
                                                                                                                                      |--------|
࣠ #######################################################################################                             |########|
------------------------------------------------------------------------------------------------------------------------------------------------
|      |  |ࠢ⥫                                        |⥫                                        |ᯮ騩 |
|⠢- | |---------------------------------------------------|--------------------------------------------------|----------------------|
|       |- |୮ ࠧ                |  -|୮ ࠧ               |  -| , |  - |
|          |樨|                                         |⥫쭮|                                        |⥫쭮||᪮  |
|----------|-----|-----------------------------------------|---------|----------------------------------------|---------|-------|--------------|
|##########| ### |#########################################|         |########################################|         |       |              |
|----------------------------------------------------------------------------------------------------------------------------------------------|
|⭠  ᪠ த樨 (ࠡ, )                                                                                              |
|----------------------------------------------------------------------------------------------------------------------------------------------|
|##############################################################################################################################################|
------------------------------------------------------------------------------------------------------------------------------------------------
ਬ砭 #####################################################################################################################################
           #####################################################################################################################################
१  #####################################################################################################################################
ॡ ############################################################  訫   _______________________ ####################################
------------------------------------------------------------------------------------------------------------------------------------------------
|                     ਠ 業                                     | |      ⢮     |, . .|㬬  |
|                                                                               |७.|---------------------|               |           ,|
|-------------------------------------------------------------------------------|--------|ॡ-|  饭|               |      . .|
|                                        | ⮢⥫   |-| |- |        |          |               |               |
|                                                    |                   | - | |-|          |          |               |               |
|                                                    |                   || ||          |          |               |               |
|----------------------------------------------------|-------------------|------|--|-----|----------|----------|---------------|---------------|
|                         3                          |         3        |    4 |5 |  6  |     7    |     8    |       9       |       10      |
}
*)
(*$P {m11line:
Math.Name, L, ""
L_MathR.MModeStr(MDocList.MMode), L, ""
Math.UnitedC, L, ""
Math.Math, L, ""
L_MathR.DefaultMUnit(Math.Math), L, ""
L_MathR.DefaultMUnitSign(Math.Math), R, ""
L_MathR.DefaultFormatCir(Math.Math, MDocList.Qnt), R, ""
L_MathR.DefaultFormatCir(Math.Math, MDocList.Qnt), R, ""
?, R, ""
?, R, ""
@
|----------------------------------------------------|-------------------|------|--|-----|----------|----------|---------------|---------------|
|################################################ ###|###################|######|##| ### |##########|##########|###############|###############|
}
*)
(*$P {m11lineFill:
@
|----------------------------------------------------|-------------------|------|--|-----|----------|----------|---------------|---------------|
|                                                    |                   |      |  |     |          |          |               |               |
}
*)
(*$P {m11bot:
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
L_Str.PoolItem("ᯮ⥫|"+L_Str.PoolItem("⨫|ਭ|ନ", L_MDoc.MDoc3Direction()), MDoc.Status), L, ""
?, L, ""
?, L, ""
TextPreview, C, ""
L_MDoc.MDoc3Direction(), L, "稫||"
?, L, ""
?, L, ""
@
------------------------------------------------------------------------------------------------------------------------------------------------
: 1 ", ", 2 " ᪮ ", 11 "浪   ᪫᪮ ⥪"  ਢ.             ########## #####

########### ################################# _______________________________ /################################################################/


###############################################################################################################################################
########### ################################# _______________________________ /################################################################/}
*)

(*$P {m4top:
?, L, ""
?, L, ""
L_APtm.GetTheDocCause(MDoc.Date, "⢥ত ⠭ ᪮ ᨨ  30.10.97 N 71"), R, ""
L_MDoc.MDocKindNick(MDoc.MDocKind, 1), L, "" "B"
MDoc.MDoc, L, ""
MDoc.CopyCnt, L, ""
P_Firm.FP_FirmName(P_Firm.fomf(MDoc.MyFirm), SYSDATE()), L, ""
P_Firm.FP_OKPO(P_Firm.fomf(MDoc.MyFirm), SYSDATE()), L, ""
MDoc.Date, L, "D.N.y"
Dest.Dest, L, ""
L_MDoc.MDocStorage(), L, ""
L_MDoc.MDocStorageName(), L, ""
P_Firm.FP_ContractorBriefName(Firm.Firm, MDoc.Date), L, ""
Firm.Firm, L, ""
MDoc.SrcNbr, L, ""
?, L, ""
?, L, ""
@
#####################################################################################################################
#####################################################################################################################                ଠ N -4
################################################################################################################################################
                                                                                                                                      ----------
                                                                                                                                      |    |
                                                                                                                                      |--------|
  (###)  ####### (##)                                                                                    ଠ   | 0315003|
                                                                                                                                      |--------|
࣠ ################################################################                                                    |########|
                                                                                                                                      ----------
୮ ࠧ
------------------------------------------------------------------------------------------------------------------------------------------------
|      |  |                        |                 ⠢騪                  |客|  ᯮ騩  |                  |
| ⠢-  | |                        |                                            | |                 |       㬥       |
|     |- |                   |--------------------------------------------|         |---------------------|-----------------------|
|          |樨|                        |                           | |         | , |  -|ᮯ஢-  |⥦|
|          |     |                        |                                       |    |         ||᪮ |⥫쭮    |          |
|----------|-----|------------------------|---------------------------------------|----|---------|-------|-------------|------------|----------|
|##########| ### |####### ################|#######################################|####|         |       |             |############|          |
------------------------------------------------------------------------------------------------------------------------------------------------
ਬ砭 #####################################################################################################################################
           #####################################################################################################################################
------------------------------------------------------------------------------------------------------------------------------------------------
|                    ਠ 業                     |- |  ⢮   |       ,|        㬬|      㬬 |       ᥣ |
|                                                              |.|---------------|   . .|  |      . .| ⮬ ,|
|--------------------------------------------------------------|------|  |   ਭ|            |    . .|               |    . .|
|, , ࠧ, ઠ                      |-| |||          |            |             |               |             |
|                                                       || ||-|          |            |             |               |             |
|                                                       | | |.|  |          |            |             |               |             |
|-------------------------------------------------------|------|--|---|----|----------|------------|-------------|---------------|-------------|
|                            1                          |  2   |3 | 4 |  5 |    6     |     7      |      8      |       9       |      10     |
}
*)

(*$P {m4line:
MDocList.MDLNbr L, "00"
?, L, ""
Math.Math, L, ""
L_MathR.DefaultMUnit(Math.Math), L, ""
L_MathR.DefaultMUnitSign(Math.Math), L, ""
L_MathR.DefaultFormatCir(Math.Math, MDocList.Qnt), R, ""
Ratio(MDocList.Sum, MDocList.Qnt), R, ",2-"
MDocList.Sum, R, ",2-"
MDocList.VATMode, L, L_MDoc.Get_vatm_Pool(1)
MDocList.VAT, R, ",2-"
MDocList.Sum+MDocList.VAT, R, ",2-"
@
|-------------------------------------------------------|------|--|---|----|----------|------------|-------------|---------------|-------------|
|## ####################################################|######|##|###|    |##########|############|#############|# #############|#############|
}
*)

(*$P {m4lineFill:
@
|-------------------------------------------------------|------|--|---|----|----------|------------|-------------|---------------|-------------|
|                                                       |      |  |   |    |          |            |             |               |             |
}
*)

(*$P {m4bot:
S_Cir[2], R, "2."
S_Cir[0], R, ",2-"
S_VAT, R, ",2-"
S_Cir[0]+S_VAT, R, ",2-"
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, ""
TextPreview, C, ""
?, L, ""
?, L, ""
@
|---------------------------------------------------------------------|----|----------|------------|-------------|---------------|-------------|
|⮣                                                                |    |##########|      X     |#############|###############|#############|
------------------------------------------------------------------------------------------------------------------------------------------------
(11)  ᯮ  ਢ; (12) 浪   ᪫᪮ ⥪ ᮮ⢥ ୮ .           ########## #####

ਭ   #################################### _______________________________ /################################################################/

################################################################################################################################################
     #################################### _______________________________ /################################################################/}
*)

(*$P {MDocCUCopiesShift:
@
}
*)

(*$P {MDocCUCopiesTopNextPage:
P_Firm.FP_FirmName(P_Firm.fomf(MDoc.MyFirm), SYSDATE()), L, ""
MDocKind.MDocKind+" "+MDocKind.SName+"  "+MDoc.MDoc+" ("+MDoc.CopyCnt+")  "+L_DatTim.DateStr(MDoc.Date), L, ""
MDoc.SrcNbr+"  "+L_DatTim.DateStr(MDoc.SrcDate), L, ""
@
################################################################################################################################################

################################################################################################################################################

室  ###################################################################

}
*)

(*$P {MDocCUCopiesTop:
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
@

  㬥                                                                                                          ########## #####
------------------------------------------------------------------------------------------------------------------------------------------------
|   |ꥪ                                                         |    |᪮                  |         |      |  ஡|
|.|                                                               |       |                                |  樨  | ᪠  |        |
|----|---------------------------------------------------------------|-------|--------------------------------|------------|----------|--------|
}
*)

(*$P {MDocCUCopiesLine:
MDocList.MDLNbr, R, ""
Math.Math,   L, ""
Math.Name,       L, ""
CUCopy.CUCopy,   L, ""
CUCopy.Serial,   L, ""
MDocLCU.OpKind,  L, L_CUC.ok_Pool
CUCopy.MnfDate,  L, "D.N.y"
L_CUC.GetCUCopyTotalRun(CUCopy.CUCopy, MDoc.Date, 1),  R, "0"
@
|####|##### #########################################################|#######|################################|############|##########|########|
}
*)


(*$P {MDocCUCIntTop:
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
@

  㬥                                                                                                          ########## #####
------------------------------------------------------------------------------------------------------------------------------------------------
||ꥪ                                                         |᪨                                               |⢮|
|----|---------------------------------------------------------------|--------------------------------------------------------------|----------|
}
*)

(*$P {MDocCUCIntLine:
MDocList.MDLNbr, R, ""
Math.Math,   L, ""
Math.Name,       L, ""
?,   L, ""
?,   R, "0"
@
|####|##### #########################################################|##############################################################|##########|
}
*)

(*$P {MDocCUCopiesBot:
@
------------------------------------------------------------------------------------------------------------------------------------------------
}
*)

 PRIVATE PROCEDURE Ratio(x, y: FLOAT): NUMERIC[4];
  VAR
   _dummy: NUMERIC[4];
 BEGIN
  IF    y#0 THEN
   RETURN x / y;
  ELSIF x=0 THEN
   RETURN 0;
  ELSE SETEMPTY(_dummy);
   RETURN _dummy;
(*
   L_General.Error("㫥   㫥 ⥫");
*)
  END;
 END {Ratio};

 PROCEDURE GetSumStr(Sum: NUMERIC[2]): STRING[];
 BEGIN
  IF MDocList.Sum # 0 THEN
   RETURN FLDTOSTR(Sum, "2-");
  ELSE
   RETURN "";
  END;
 END {GetSumStr};

 PROCEDURE mdOnM4(_MDocKind: LIKE(MDoc.MDocKind)): SCAL[2];
 BEGIN
  RETURN (_MDocKind = L_MDoc.md_NPr) |
         (_MDocKind = L_MDoc.md_VTN) |
         (_MDocKind = L_MDoc.md_FPk) |
         (_MDocKind = L_MDoc.md_RPk);
 END {mdOnM4};

 PROCEDURE mdOnM11(_MDocKind: LIKE(MDoc.MDocKind)): SCAL[2];
 BEGIN
  RETURN (_MDocKind = L_MDoc.md_NOV) |
         (_MDocKind = L_MDoc.md_TOV) |
         (_MDocKind = L_MDoc.md_ViP) |
         (_MDocKind = L_MDoc.md_MSP) ;
 END {mdOnM11};

 PROCEDURE GetRepDep(): NUMERIC[0];
 BEGIN
  IF    mdOnM4(MDoc.MDocKind) THEN
   RETURN DEPTH(m4top)+lines*DEPTH(m4line)+DEPTH(m4bot);
  ELSIF mdOnM11(MDoc.MDocKind) THEN
   RETURN DEPTH(m11top)+lines*DEPTH(m11line)+DEPTH(m11bot);
  ELSE
   RETURN DepthOfRep;
  END;
 END {GetRepDep};

CONST
 lines        = 15;
 DepthOfRep   = 84;
VAR
 LineNbr : NUMERIC[0];
 PartName: STRING[30];

 PROCEDURE GetPartName(Postfix: STRING[25]): STRING[30];
 BEGIN
  IF    mdOnM4(MDoc.MDocKind) THEN
   RETURN "m4"+Postfix;
  ELSIF mdOnM11(MDoc.MDocKind) THEN
   RETURN "m11"+Postfix;
  ELSE
   RETURN "Common"+Postfix;
  END
 END {GetPartName};

 PRIVATE PROCEDURE GetMDocBoxNbr_AsStr(trgBoxNbr: LIKE(Car.BoxNbr); trgDate: DATE): STRING[];
 BEGIN
  L_Car.StandOnCarLog(trgBoxNbr, trgDate);
  CONFORM(CarLog, Mark);
  RETURN " : " + trgBoxNbr + ", " + CarLog.StateNbr + ", " + Mark.Name + ",  "  + Car.Column;
 END {GetMDocBoxNbr_AsStr};

 PROCEDURE GetMDocDescr_asStr(): STRING[];
 BEGIN
  IF    ~!MDoc.BoxNbr THEN
   RETURN GetMDocBoxNbr_AsStr(MDoc.BoxNbr, MDoc.Date);
  ELSIF ~!MDoc.CostItem THEN
   CONFORM(MDoc, CostItem);
   RETURN ": " + CostItem.CostItem + " " + CostItem.Name;
  ELSE
   RETURN "";
  END;
 END {GetMDocDescr_asStr};

 PRIVATE PROCEDURE GetMDocDescrForLblTop_asStr(): STRING[];
  VAR
   i                 : NUMERIC[0];
   XDC               : L_XDoc.tXDocCollection;
   trgXDocId         : L_XDoc.tXDocId;
   MDocDescrForLblTop: STRING[];
 BEGIN
  MDocDescrForLblTop:=GetMDocDescr_asStr();
  IF !MDocDescrForLblTop THEN
   XDC:=L_XDoc.GetRefToXDC_Transitively(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.xdt_RprS);
   SETZERO(i);
   LOOP
    trgXDocId:=L_XDoc.xdc_Item(XDC, i);
    IF !trgXDocId THEN
     EXIT;
    END;
    IF L_XDoc.ExtractXDocType(trgXDocId) = L_XDoc.xdt_RprS THEN
     L_XDoc.PositionOnXDoc(trgXDocId);
     IF L_Rpr.IsRprS_w_Car() THEN
      CONFORM(RprS, CUCopy);
      L_CUC.AccessOrigin();
      RETURN GetMDocBoxNbr_AsStr(Car.BoxNbr, RprS.OrdDate);
     END;
    END;
    INC(i);
   END; (* LOOP *)
  END;
  RETURN MDocDescrForLblTop;
 END {GetMDocDescrForLblTop_asStr};

 PROCEDURE Top();
  CONST
   note_Len = 158;
   dcm_Len  = 81;
  VAR
   _NameStr,
   _Sender,
   _Recipi,
   _1Side,
   _2Side,
   _PayDate,
   _BaseOrder,
   _RefDocStr  : STRING[];
   _NoteStr    : STRING[][4];
   refToXDocId : L_XDoc.tXDocId;
   i           : NUMERIC[0];
   DocDraftsman: STRING[dcm_Len][2];
 BEGIN
  _BaseOrder:=P_MDoc.GetMDocProSoft(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_KeyAssBaseOrder);
  IF !_BaseOrder THEN
   _BaseOrder:='"____" _____________________ 200__   N ________________';
  END;
  refToXDocId:=L_MDoc.curRefToXDoc_GetId();
  L_Str.FormatStr(_NoteStr, P_MDoc.GetMDocProSoft(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Note), note_Len);
  L_Str.FormatStr(DocDraftsman, L_APtm.GetTheDocDraftsman(MDoc.Date, ""), dcm_Len);
  IF    mdOnM4(MDoc.MDocKind) THEN
   SETZERO(S_Cir, S_VAT);
   MAKEPART(R, m4top, DocDraftsman[0], DocDraftsman[1], _NoteStr[0], _NoteStr[1]);
  ELSIF mdOnM11(MDoc.MDocKind) THEN
   IF L_Env.RealTSN(MDoc.TSN) THEN
    _NameStr:=FLDTOSTR(MDoc.TSN)+" "+Man.Name;
   ELSE
    _NameStr:=P_MDoc.GetMDocProSoft(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Through);
   END;
   IF ~!MDoc.Storage THEN
    SAVE(Storage);
    SEARCH(Storage, Storage, , MDoc.Storage);
    _1Side:=Storage.Storage + " " + Storage.Name;
    RESTORE(Storage);
   ELSE
    SETEMPTY(_1Side);
   END;
   IF ~!MDoc.Storage2 THEN
    SAVE(Storage);
    SEARCH(Storage, Storage, , MDoc.Storage2);
    _2Side :=Storage.Storage + " " + Storage.Name;
    RESTORE(Storage);
   ELSIF ~!MDoc.Firm & (MDoc.Firm # P_Firm.fomf(MDoc.MyFirm)) THEN
    _2Side :=P_Firm.FP_ContractorBriefName(MDoc.Firm, MDoc.Date);
   ELSE
    _2Side :=Dest.Name;
   END;
   IF (L_MDoc.MDocDirection() = L_MDoc.mdd_Outgoing) = ~!_1Side THEN
    _Sender :=_1Side;
    _Recipi :=_2Side;
   ELSE
    _Sender :=_2Side;
    _Recipi :=_1Side;
   END;
   IF ~!refToXDocId THEN
    _RefDocStr:="(" + L_XDoc.XDocStr(refToXDocId) + ")";
   ELSE
    _RefDocStr:="";
   END;
   MAKEPART(R, m11top, DocDraftsman[0], DocDraftsman[1], _RefDocStr, _Sender, _Recipi, _NoteStr[0], _NoteStr[1], _NameStr, L_MDoc.GetMDocAuthor());
  ELSE
   CONFORM(MDoc, MDocKind);
   SETEMPTY(_Sender, _NameStr, _Recipi, _PayDate);
   SETZERO(S_Cir, SwoVAT, S_VAT, S_SaleTax);
   _CURate:=P_MDoc.GetCURate(P_MDoc.GetMDocProSoft(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_BilCURate));
   IF !_CURate THEN
    _CURate:=0;
   END;
   IF ~!MDoc.Firm THEN
    CONFORM(MDoc, Firm);
    _Sender:=Firm.Firm+" "+P_Firm.FP_ContractorBriefName(Firm.Firm, MDoc.Date);
   END;
   IF ~!MDoc.PayDate THEN
    _PayDate:="ப  "+L_DatTim.DateStr(MDoc.PayDate);
   END;
   IF ~!MDoc.Contract THEN
    CONFORM(MDoc, Contract, CntrT);
    _Recipi:=Contract.SrcNbr+" ("+MDoc.Contract+")  "+L_DatTim.DateStr(Contract.SrcDate)+" "+
             Contract.Name+" ("+CntrT.CntrT+" "+CntrT.Name+")";
   END;
   IF ~!MDoc.Alower THEN
    CONFORM(MDoc, Alower);
    _NameStr:=Alower.Alower+" "+Alower.Name;
   END;
   CONFORM(MDoc, MDocKind);
   CONFORM(MDoc, Dest);
   SETEMPTY(XDocStr);
   SETSEL(XDocJrn, XDocJrn, L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc);
   LAST(XDocJrn);
   i:=0;
   WHILE (i<=HIGH(XDocStr)-1) & OCCURE(XDocJrn) DO
    CONFORM(XDocJrn, AcsObj);
    XDocStr[i]:="|"+L_DatTim.DateStr(XDocJrn.Date)+" "+L_DatTim.TimeStr(XDocJrn.BegTime)+"|"+
                Str.Align(AcsObj.Name, 17, LEFT)+"|"+
                Str.Align(Str.Item(L_XDoc.action_Pool, "|", XDocJrn.Action), 15, LEFT)+
                "|";
    PREV(XDocJrn);
    INC(i);
   END; (* WHILE (CountXDocStr<5) | OCCURE(XDocJrn)...*)
   XDocStr[i]:="----------------------------------------------------";
   IF ~!refToXDocId THEN
    _RefDocStr:=L_XDoc.XDocStr(refToXDocId);
   ELSE
    _RefDocStr:="";
   END;
   MAKEPART(R, CommonTop, _PayDate, _Sender, _Recipi, _NameStr, _NoteStr[0], _NoteStr[1], _RefDocStr);
  END;
  SETZERO(LineNbr);
 END {Top};

 PRIVATE PROCEDURE NeedPriceInM11(): SCAL[2];
 BEGIN
  IF L_General.GetAPSiteNumber() = 84 THEN
   RETURN 1;
  ELSIF L_APtm.IsMTA() THEN
   IF MDoc.Date >= 01\12\2012 THEN
    RETURN 1;
   ELSE
    RETURN (L_General.GetAPSiteNumber() = 50) | (L_General.GetAPSiteNumber() = 27);
   END;
  ELSE
   RETURN 0;
  END;
 END {NeedPriceInM11};

 PROCEDURE Line();
  VAR
   Price   : L_XObj.tSum;
   SAP_Math: STRING[];
 BEGIN
  IF    mdOnM4(MDoc.MDocKind) THEN
   IF L_General.GetAPSiteNumber() = 10 THEN
    SAP_Math:=P_Math.GetMathProSoft(Math.Math, MDoc.Date, E_Prop.P_SAP_Math);
    MAKEPART(R, m4line, FLDTOSTR(Math.Name, "", 52-Str.Length(SAP_Math)-3-2)+" "+L_MathR.MModeStr(MDocList.MMode)+" "+SAP_Math);
   ELSE
    MAKEPART(R, m4line, FLDTOSTR(Math.Name, "", 52-3-1)+" "+L_MathR.MModeStr(MDocList.MMode));
   END;
   INC(S_Cir[0], MDocList.Sum);
   INC(S_Cir[2], MDocList.Qnt);
   INC(S_VAT,    MDocList.VAT);
  ELSIF mdOnM11(MDoc.MDocKind) THEN
   IF NeedPriceInM11() & (L_MDoc.getMDocListMathFlowType() = L_MDoc.mft_Credit) THEN
    Price:=L_MathR.GetMDLMathPrice();
    MAKEPART(R, m11line, FLDTOSTR(Price, "2-"), FLDTOSTR(Price * MDocList.Qnt, "2-"));
   ELSE
    MAKEPART(R, m11line, GetSumStr(Ratio(MDocList.Sum, MDocList.Qnt)), GetSumStr(MDocList.Sum));
   END;
  ELSE
   IF    ~!MDocList.Math THEN
    CONFORM(Math, MUnit);
    IF MUnit.Real THEN
     MAKEPART(R, CommonLine, Math.Math+" "+Math.Name, Math.MUnit, MUnit.Sign,
                             L_MathR.DefaultFormatCir(Math.Math, MDocList.Qnt),
                             Ratio(MDocList.Sum, MDocList.Qnt),
                             Ratio(MDocList.Sum+MDocList.VAT, MDocList.Qnt*_CURate));
    ELSE
     MAKEPART(R, CommonLine, Math.Math+" "+Math.Name);
    END;
   ELSIF ~!MDocList.CostItem THEN
    CONFORM(MDocList, CostItem);
    MAKEPART(R, CommonLine, MDocList.CostItem+" "+CostItem.Name, , , FLDTOSTR(MDocList.Qnt, "2."));
   ELSE
    L_General.CallUs(0);
   END;
   INC(S_Cir[0],  MDocList.Sum);
   INC(S_Cir[2],  MDocList.Qnt);
   INC(SwoVAT,    MDocList.Sum);
   INC(S_VAT,     MDocList.VAT);
   INC(S_SaleTax, MDocList.SaleTax);
  END;
  INC(LineNbr);
 END {Line};

 PROCEDURE PrintLineBot(Print: SCAL[2]): NUMERIC[0];
  VAR
   i       : NUMERIC[0];
   TitleStr: STRING[];
   ArrStr  : STRING[][64];
 BEGIN
  SETEMPTY(ArrStr);
  CONFORM(MDocPro, Property);
  TitleStr:=Property.Property+" "+Property.Name;
  L_Str.FormatStr(ArrStr, MDocPro.Value, 128);
  i:=0;
  WHILE ~!ArrStr[i] DO
   IF Print THEN
    MAKEPART(R, ^(PartName+"Str"), TitleStr, ArrStr[i]);
    TitleStr:="";
   END;
   INC(i);
  END;
  RETURN i*DEPTH(^(PartName+"Str"));
 END {PrintLineBot};

 PROCEDURE PrintCommonBot(BotTitle1, BotTitle2: STRING[];
                          Print: SCAL[2]): NUMERIC[0];
  VAR
   Title : SCAL[2];
   CountBottomStr: NUMERIC[0];
 BEGIN
  Title:=1;
  SETZERO(CountBottomStr);
  SELECT(MDocPro, MDoc, , MDoc.MDocKind, MDoc.MDoc);
  WHILE OCCURE(MDocPro) DO
   IF Title THEN
    IF Print THEN
     MAKEPART(R, ^(PartName+"Str"));
     MAKEPART(R, ^(PartName+"Str"), BotTitle1, BotTitle2);
    END;
    Title:=0;
    INC(CountBottomStr, 2*DEPTH(^(PartName+"Str")));
   END;
   INC(CountBottomStr, PrintLineBot(Print));
   NEXT(MDocPro);
  END; (* WHILE OCCURE(MDocPro) ... *)
  RETURN CountBottomStr;
 END {PrintCommonBot};

 PROCEDURE NeedCommonSubscribe(_MDocKind: LIKE(MDoc.MDocKind)): SCAL[2];
 BEGIN
  RETURN _MDocKind = L_MDoc.md_RPk;
 END {NeedCommonSubscribe};

 PROCEDURE Bot();
  VAR
   _PName        : LIKE(Post.Name);
   _MName        : LIKE(Man.Name);
   Temp,
   CountBottomStr: NUMERIC[0];
 BEGIN
  PartName:=GetPartName("lineFill");
  WHILE LineNbr<lines DO
   MAKEPART(R, ^PartName);
   INC(LineNbr);
  END;
  PartName:=GetPartName("bot");
  IF    (MDoc.MDocKind = L_MDoc.md_TOV) &
        (~!MDoc.Firm & (MDoc.Firm # P_Firm.fomf(MDoc.MyFirm))) THEN
   MAKEPART(R, ^PartName);
  ELSIF mdOnM11(MDoc.MDocKind) | mdOnM4(MDoc.MDocKind) THEN
   SAVE(Staff);
   IF L_MDoc.IsMDocToTransferBetweenAdvanceHolders() THEN
    SELECT(Staff, Storage, , MDoc.Storage2);
    _PName:=P_Firm.GetManAttrByTSN(Staff.TSN, MDoc.Date, P_Firm.mpt_ManPostName);
    _MName:=P_Firm.GetManAttrByTSN(Staff.TSN, MDoc.Date, P_Firm.mpt_ManName);
   ELSE
    _PName:=L_PCS.GetPostNameOfCurrentUser(SYSDATE());
    _MName:=L_PCS.GetFullNameOfCurrentUser(SYSDATE());
   END;
   RESTORE(Staff);
   IF L_MDoc.IsMDocToTransferBetweenAdvanceHolders() THEN
    SELECT(Staff, Storage, , MDoc.Storage);
    IF Dest.Type = L_Acnt.dt_Credit THEN
     MAKEPART(R, ^PartName, _PName,
                            _MName,
                            P_Firm.GetManAttrByTSN(Staff.TSN, MDoc.Date, P_Firm.mpt_ManPostName),
                            P_Firm.GetManAttrByTSN(Staff.TSN, MDoc.Date, P_Firm.mpt_ManName));
    ELSE
     MAKEPART(R, ^PartName, P_Firm.GetManAttrByTSN(Staff.TSN, MDoc.Date, P_Firm.mpt_ManPostName),
                            P_Firm.GetManAttrByTSN(Staff.TSN, MDoc.Date, P_Firm.mpt_ManName),
                            _PName,
                            _MName);
    END;
   ELSIF L_Env.RealTSN(MDoc.TSN) THEN
    HISTCONF(MDoc.Date, Staff, StaffLog);
    L_General.Assert(OCCURE(StaffLog), "⭨  ਭ   㬥");
    MAKEPART(R, ^PartName, _PName, _MName,
             P_Firm.GetManAttrByTSN(Staff.TSN, MDoc.Date, P_Firm.mpt_ManPostName),
             P_Firm.GetManAttrByTSN(Staff.TSN, MDoc.Date, P_Firm.mpt_ManName));
   ELSE
    MAKEPART(R, ^PartName, _PName, _MName, ,
             P_MDoc.GetMDocProSoft(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Through));
   END;
  ELSE
   SETZERO(Temp, CountBottomStr);
   Temp:=DEPTH(CommonTop)+2*LineNbr+DEPTH(CommonbotTotal);
   IF NeedCommonSubscribe(MDoc.MDocKind) THEN
    INC(Temp, DEPTH(CommonbotSubscribe));
   ELSE
    INC(Temp, DEPTH(^PartName));
   END;
   INC(CountBottomStr, PrintCommonBot("", "", 0));

   WHILE Temp+CountBottomStr<DepthOfRep DO
    MAKEPART(R, CommonlineFill);
    INC(Temp, DEPTH(CommonlineFill));
   END;

   MAKEPART(R, ^(PartName+"Total"));
   Temp:=PrintCommonBot("⢠ 㬥", "", 1);
   IF NeedCommonSubscribe(MDoc.MDocKind) THEN
    IF L_Env.RealTSN(MDoc.TSN) THEN
     HISTCONF(MDoc.Date, Staff, StaffLog);
     L_General.Assert(OCCURE(StaffLog), "⭨  ਭ   㬥");
     MAKEPART(R, CommonbotSubscribe, P_Firm.GetManAttrByTSN(Staff.TSN, MDoc.Date, P_Firm.mpt_ManPostName),
                                     P_Firm.GetManAttrByTSN(Staff.TSN, MDoc.Date, P_Firm.mpt_ManName));
    ELSE
     MAKEPART(R, CommonbotSubscribe, , P_MDoc.GetMDocProSoft(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Through));
    END;
   ELSE
    MAKEPART(R, ^PartName);
   END;
  END;
 END {Bot};

 PROCEDURE Open(Preview: SCAL[2]);
  VAR
   _TopMargin,
   _BottomMargin,
   _LinesPerPage: NUMERIC[0];
   _PaperForm,
   _Orientation,
   Action       : STRING[];
 BEGIN
  PROMPT("...");
  Action:=Str.Item("Print|Create", "|", Preview);
  TextPreview:=Str.Item(" |               ", "|", Preview);
  IF L_MDoc.KeyAssetsMDoc(MDoc.MDocKind) THEN
   OPENREP(R, L_General.NameConnection("MDocX"), ^Action,
                                                 PaperForm,       A4,
                                                 Orientation,     Portrait,
                                                 LeftMargin,      20,
                                                 RightMargin,     05,
                                                 TopMargin,       05,
                                                 MinCharsPerLine, 105,
                                                 LinesPerPage,    80,
                                                 FontProperty,    "/U /B /I");
  ELSIF mdOnM11(MDoc.MDocKind) | mdOnM4(MDoc.MDocKind) THEN
   IF    L_MDoc.E_PaperFormat()=L_MDoc.pf_A4 THEN
    _PaperForm:="A4"; _Orientation:="Portrait";
    _TopMargin:=10; _BottomMargin:=14; _LinesPerPage:=2*GetRepDep()+1;
   ELSIF L_MDoc.E_PaperFormat()=L_MDoc.pf_A5onA4 THEN
    _PaperForm:="A4"; _Orientation:="Portrait";
    _TopMargin:=5; _BottomMargin:=7+297-148; _LinesPerPage:=GetRepDep()+1;
   ELSIF L_MDoc.E_PaperFormat()=L_MDoc.pf_A5 THEN
    _PaperForm:="A5"; _Orientation:="Landscape";
    _TopMargin:=5; _BottomMargin:=7; _LinesPerPage:=GetRepDep()+1;
   ELSE
    L_General.Error(" ଠ 㬠 "+L_Str.IntStr(L_MDoc.E_PaperFormat()));
   END;
   OPENREP(R, L_General.NameConnection("MDocX"), ^Action,
                                                 PaperForm,       ^_PaperForm,
                                                 Orientation,     ^_Orientation,
                                                 LeftMargin,      25,
                                                 RightMargin,     00,
                                                 TopMargin,       _TopMargin,
                                                 BottomMargin,    _BottomMargin,
                                                 FontEnlargement, 1.2,
                                                 CharsPerLine,    144,
                                                 LinesPerPage,    _LinesPerPage,
                                                 FontProperty,    "/U /B /I");
  ELSE
   _PaperForm:="A4"; _Orientation:="Portrait";
   _TopMargin:=10; _BottomMargin:=14; _LinesPerPage:=131; (* GetRepDep() *)
   OPENREP(R, L_General.NameConnection("MDocX"), ^Action,
                                                 PaperForm,       A4,
                                                 Orientation,     Portrait,
                                                 RightMargin,     05,
                                                 TopMargin,       _TopMargin,
                                                 BottomMargin,    _BottomMargin,
                                                 FontEnlargement, 1.2,
                                                 CharsPerLine,    167,
                                                 LinesPerPage,    _LinesPerPage);
  END;
 END {Open};

 PROCEDURE Close();
 BEGIN
(* ⫠ Spool32 GPF - 30.08.2002 19:36:25 SAN *)
PROMPT("... । ⨥");
  CLOSEREP(R);
PROMPT("... ");
 END {Close};

 PROCEDURE PrintMDocListCUCopy();
 BEGIN
 END {PrintMDocListCUCopy};

 VAR
  CanPrintWithCUCIntervals: SCAL[2];

 PROCEDURE TopOfMDocCUCopies();
 BEGIN
  L_AFM.MakeIndex("MDCUC", "MDLNbr: LIKE(MDocLCU.MDLNbr); " +
                           "Serial: LIKE(CUCopy.Serial); " +
                           "CUCopy: LIKE(CUCopy.CUCopy)");
  CanPrintWithCUCIntervals:=1;
 END {TopOfMDocCUCopies};

 PROCEDURE PrintMDocCUCopy();
 BEGIN
  CONFORM(MDocList, Math);
  CONFORM(Math, CarUnit);
  ADD(MDCUC, MDCUC, , MDocList.MDLNbr, CUCopy.Serial, CUCopy.CUCopy);
  IF CarUnit.Type # L_CUC.cut_TicketProduction THEN
   CanPrintWithCUCIntervals:=0;
  END;
 END {PrintMDocCUCopy};

 PROCEDURE BotOfMDocCUCopies();
  VAR
   cuc1,
   cuc2 : LIKE(CUCopy.CUCopy);
   s    : STRING[];
   Cnt  : NUMERIC[0];
 BEGIN
  CONFORM(MDoc, MDocKind);
  SetPrintAttr(R, CharsPerLine, 144);
  IF    (L_MDoc.E_PaperFormat() = L_MDoc.pf_A5onA4) | (L_MDoc.E_PaperFormat() = L_MDoc.pf_A5) THEN
   FORMFEED(R);
   MAKEPART(R, MDocCUCopiesTopNextPage);
  ELSE
   MAKEPART(R, MDocCUCopiesShift);
  END;

  IF CanPrintWithCUCIntervals THEN
   MAKEPART(R, MDocCUCIntTop);
   SELECT(MDCUC, MDCUC);
   WHILE OCCURE(MDCUC) DO
    NARROWSEL(MDCUC, MDLNbr);
    SEARCH(MDocList, MDoc, , MDoc.MDocKind, MDoc.MDoc, MDCUC.MDLNbr);
    CONFORM(MDocList, Math);
    cuc1:=MDCUC.CUCopy;
    cuc2:=MDCUC.CUCopy;
    Cnt :=1;
    LOOP
     NEXT(MDCUC);
     IF OCCURE(MDCUC) & L_CUC.IsInSuccession(MDoc.Date, cuc2, MDCUC.CUCopy) THEN
      PROMPT(" ஢ " + MDCUC.CUCopy);
      cuc2:=MDCUC.CUCopy;
      INC(Cnt);
     ELSE
      SEARCH(CUCopy, CUCopy, , cuc1);
      IF cuc1 = cuc2 THEN
       s:="";
      ELSE
       s:=CUCopy.Serial + " .. ";
       SEARCH(CUCopy, CUCopy, , cuc2);
      END;
      MAKEPART(R, MDocCUCIntLine, s + CUCopy.Serial, Cnt);
      IF OCCURE(MDCUC) THEN
       cuc1:=MDCUC.CUCopy;
       cuc2:=MDCUC.CUCopy;
       Cnt :=1;
      ELSE
       EXIT;
      END;
     END;
    END; (* WHILE OCCURE(File) *)
    NEXTINEXTENDEDSEL(MDCUC, MDLNbr);
   END; (* WHILE OCCURE(MDCUC) *)
  ELSE
   MAKEPART(R, MDocCUCopiesTop);
   SELECT(MDCUC, MDCUC);
   WHILE OCCURE(MDCUC) DO
    NARROWSEL(MDCUC, MDLNbr);
    SEARCH(MDocList, MDoc, , MDoc.MDocKind, MDoc.MDoc, MDCUC.MDLNbr);
    CONFORM(MDocList, Math);
    WHILE OCCURE(MDCUC) DO
     SEARCH(MDocLCU, MDoc, , MDoc.MDocKind, MDoc.MDoc, MDCUC.MDLNbr, MDCUC.CUCopy);
     CONFORM(MDocLCU, CUCopy);
     MAKEPART(R, MDocCUCopiesLine);
     NEXT(MDCUC);
    END; (* WHILE OCCURE(File) *)
    NEXTINEXTENDEDSEL(MDCUC, MDLNbr);
   END; (* WHILE OCCURE(MDCUC) *)
  END;

  MAKEPART(R, MDocCUCopiesBot);
  L_AFM.AF_PurgeTemp("MDCUC");
 END {BotOfMDocCUCopies};

(*
$P {LblTop:
P_Firm.FP_FirmName(P_Firm.fomf(MDoc.MyFirm), SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc), L, ""
MDoc.CopyCnt, L, ""
MDoc.Date, L, "D.N.y"
GetMDocDescrForLblTop_asStr(), L, ""
@
############################################################# ########## #####
==============================================================================
|                    ᢮ ஢ ஢                  |
| ###########(##)  ##########                                            |
|############################################################################|
}
*)

(*
$P {LblLine:
Math.Math, L, ""
Math.Name, L, ""
?, L, ""
MDocLCU.CUCopy, L, ""
?, L, ""
@
|============================================================================|
| ##### ##################################################################|
|----------------------------------------------------------------------------|
| ७ |###################################################|
|------------------------|---------------------------------------------------|
|########################|###################################################|
}
*)

(*
$P {LblBot:
FULLNAME(), L, ""
?, L, ""
@
|============================================================================|
|                                                                            |
|뤠              ______________ ######################################### |
|                                                                            |
|稫            ______________ ######################################### |
|                                                                            |
|ᥭ ந ______________ _________________________________________ |
=(c) Polak====================================================================
}
*)

 PROCEDURE PrintLabelsTop();
 BEGIN
  FORMFEED(R);
  SetPrintAttr(R, CharsPerLine, 0,
                  LinesPerPage, 0);
  MAKEPART(R, LblTop);
 END {PrintLabelsTop};

 PROCEDURE PrintLabel();
 BEGIN
  IF L_CUC.E_NeedPrintLabel(MDocLCU.CUCopy, MDocLCU.OpKind) THEN
   CONFORM(MDocLCU, CUCopy);
   CONFORM(CUCopy, Math);
   IF CUCopy.Serial = L_CUC.GetDefaultSerial(CUCopy.CUCopy) THEN
    MAKEPART(R, LblLine, "⠭ ᪮ ");
   ELSE
    MAKEPART(R, LblLine, "஢७ ᪮ ", CUCopy.Serial);
   END;
  END;
 END {PrintLabel};

 PROCEDURE PrintLabelsBot();
  VAR
   Reciever: STRING[];
 BEGIN
  Reciever:=E_CUCLabelReciever();
  IF !Reciever THEN
   Reciever:=L_Str.Repeat("_", 41);
  END;
  MAKEPART(R, LblBot, Reciever);
 END {PrintLabelsBot};

END.
