(*
%Copyright   (c) Polak Computer System
%Author      Unknown
%Purpose     ࠢ  ࠡ⪨ ᪫᪨ 㬥⮢
%Type        library,to paste
%Specific    SYS
%Modified    10.09.2014 14:25:38 POLAK\Bor
%Environment
*)

 IMPORT L_General, L_DatTim, L_MDoc, L_MathR, L_Acnt, Math, Memo,
        E_Stock, L_XObj;

 PROCEDURE ⮥();
 BEGIN
 END {⮥};

 PRIVATE PROCEDURE GetCirComp(CirComp: L_XObj.tQnt; cccm: L_Acnt.tCirComponentCalculationManner): L_XObj.tQnt;
 BEGIN
  IF    cccm = L_Acnt.cccm_Not THEN
   RETURN 0;
  ELSIF cccm = L_Acnt.cccm_AsIs THEN
   RETURN CirComp;
  ELSIF cccm = L_Acnt.cccm_Storno THEN
   RETURN -CirComp;
  ELSE
   L_General.Error("MDT_.GetCir:  cccm "+cccm);
  END;
 END {GetCirComp};

 PROCEDURE ();
 BEGIN
  L_Acnt.MakeCir(_s, L_Acnt.cs_MDoc, GetCirComp(MDocList.Qnt*10, AcMthL.aNetto ),
                                     GetCirComp(MDocList.Qnt   , AcMthL.aAmount));
 END {};

 PROCEDURE ዑ();
 BEGIN
  L_MathR.ResetMathDone_AP(Math.Math, L_DatTim.Per(MDoc.Date));
 END {ዑ};

 PROCEDURE __();
 BEGIN
  L_General.Assert(~!AcMthL.Origin2, "ࠢ '__'  ନ஢| ஢");
  L_General.Assert(MDocList.Sum=0, "㫥 㬬   "+MDocList.Math);
  L_Acnt.MakeStandartCir(_s, L_Acnt.cs_MDoc);
  StoreInRWayF(MDocList.Qnt, 0);
 END {__};

 PROCEDURE __();
 BEGIN
  L_General.Assert(~!AcMthL.Origin2, "ࠢ '__'  ନ஢| ஢");
  L_General.Assert(MDocList.Sum=0, "㫥 㬬   "+MDocList.Math);
  L_Acnt.MakeStandartCir(_s, L_Acnt.cs_MDoc);
  StoreInRWayF(0, MDocList.Qnt);
 END {__};

 PROCEDURE ();
 BEGIN
  L_General.Assert(MDocList.Sum>0, "㫥 㬬   "+MDocList.Math);
  L_Acnt.MakeCir(_s, L_Acnt.cs_MDoc,
                 MDocList.Sum - L_MathR.RoundMath(MDocList.Sum*E_Stock._vat()),
                 MDocList.Qnt);
  StoreInRWayF(MDocList.Qnt, 0);
 END {};

 PROCEDURE ___();
 BEGIN
  L_General.Assert(MDocList.Sum>0, "㫥 㬬   "+MDocList.Math);
  L_Acnt.MakeCir(_s, L_Acnt.cs_MDoc, L_MathR.RoundMath(MDocList.Sum*E_Stock._vat()), 0);
 END {___};

 PROCEDURE ࠧめ();
 BEGIN
  L_General.Assert(MDocList.Sum>0, "㫥 㬬   "+MDocList.Math);
  L_Acnt.MakeCir(_s, L_Acnt.cs_MDoc, MDocList.Sum, MDocList.Qnt);
  StoreInRWayF(MDocList.Qnt, 0);
 END {ࠧめ};

 PROCEDURE 㬬0();
 BEGIN
  L_General.Assert((MDocList.Sum=0) & (MDocList.VAT=0),
                   "㬬      ࠢ 0|ப "+MDocList.MDLNbr);
 END {㬬0};

 (*-- ᭮ ।⢠ --*)

 PRIVATE PROCEDURE SetRecalcNeed();
 BEGIN
  L_MathR.ResetMathDone_AP(Math.Math, Memo.gl_me()+1);
 END {SetRecalcNeed};

 PROCEDURE ⮨();
 BEGIN
  L_Acnt.MakeCir(_s, L_Acnt.cs_MDoc, MDocList.Sum, 0);
  SetRecalcNeed();
 END {⮨};

 PRIVATE VAR
  室_㬬: L_XObj.tSum;

 PROCEDURE 室1();
 BEGIN    
  L_General.Assert(!AcMthL.Origin2, "ࠢ '室1'  ନ஢ ஭ ஢");
  L_General.Assert(!室_㬬, " 冷 맮 ࠢ '室1'  '室2'");
  CONFORM(AcMthL, Apport);
  室_㬬:=L_MathR.RemaindersR(Memo.gl_me()+1, AcMthL.AcCut, Apport.CirType);
  IF 室_㬬 # 0 THEN
   L_Acnt.MakeCir(_s, L_Acnt.cs_MDoc, 室_㬬, 0);
   SetRecalcNeed();
  END;
 END {室1};

 PROCEDURE 室0();
 BEGIN
  L_General.Assert(!AcMthL.Origin2, "ࠢ '室0'  ନ஢ ஭ ஢");
  室1();
  SETEMPTY(室_㬬);
 END {室0};

 PROCEDURE 室2();
 BEGIN
  L_General.Assert(!AcMthL.Origin2, "ࠢ '室2'  ନ஢ ஭ ஢");
  L_General.Assert(~!室_㬬, " 冷 맮 ࠢ '室2'  '室1'");
  IF 室_㬬 # 0 THEN
   L_Acnt.MakeCir(_s, L_Acnt.cs_MDoc, 室_㬬, 0);
   SetRecalcNeed();
  END;
  SETEMPTY(室_㬬);
 END {室2};

 PROCEDURE _室(_AcCut: LIKE(AcCut.AcCut));
  VAR
   curSum: L_XObj.tSum;
 BEGIN
  CONFORM(AcMthL, Apport);
  curSum:=L_MathR.RemaindersR(Memo.gl_me()+1, _AcCut, Apport.CirType);
  L_MathR.AccessKeyAssXObject();
  L_XObj.MakeCompleteCir(_s, Memo.gl_mb(),
                         XObject.XObject, _AcCut,        AcMthL.Apport,  0,
                         XObject.XObject, AcMthL.AcCut2, AcMthL.Apport2, 0,
                         curSum, 0, L_MDoc.GetMDocSource(MDoc.MDocKind));
 END {_室};

 PROCEDURE 室();
 BEGIN
  _室(AcMthL.AcCut);
  SetRecalcNeed();
 END {室};

 PROCEDURE intᠭ(trgAcCuts: L_MathR.tMathAcCutCollection): L_XObj.tSum;
  VAR
   curAcCut: LIKE(AcCut.AcCut);
   curSum,
   Result  : L_XObj.tSum;
 BEGIN
  Result:=0;
  CONFORM(AcMthL, Apport);
  FOR_EACH curAcCut IN trgAcCuts DO
   curSum:=L_MathR.RemaindersR(Memo.gl_me()+1, curAcCut, Apport.CirType);
   L_MathR.KeyAssMakeCir(_s, curAcCut, AcMthL.Apport, AcMthL.AcCut2,
                         curSum, L_MDoc.GetMDocSource(MDoc.MDocKind));
   INC(Result, curSum);
  END;
  SetRecalcNeed();
  RETURN Result;
 END {intᠭ};

 PROCEDURE ᠭ1();
  VAR
   curAcCuts: L_MathR.tMathAcCutCollection;
 BEGIN
  L_General.Assert(!室_㬬, " 冷 맮 ࠢ 'ᠭ1'  'ᠭ2'");
  L_General.Assert(AcMthL.AcCut = L_Acnt.fictAcCut, "'ᠭOC1' - ࠧ१   䨪⨢");

  E_Stock.GetKeyAssBalCostAcCuts(Memo.gl_mb(), curAcCuts, L_MathR.KA_All, L_MathR.KA_All, L_MathR.KA_All);
  室_㬬:=intᠭ(curAcCuts);
 END {ᠭ1};

 PROCEDURE ᠭ2();
 BEGIN
  室2();
 END {ᠭ2};

 PROCEDURE ᠭ1();
  VAR
   curAcCuts: L_MathR.tMathAcCutCollection;
 BEGIN
  L_General.Assert(!室_㬬, " 冷 맮 ࠢ 'ᠭ1'  'ᠭ2'");
  L_General.Assert(AcMthL.AcCut = L_Acnt.fictAcCut, "'ᠭ1' - ࠧ१   䨪⨢");
  E_Stock.GetKeyAssWearAcCuts(Memo.gl_mb(), curAcCuts, L_MathR.KA_BalDepr, L_MathR.KA_All, L_MathR.KA_All);
  室_㬬:=intᠭ(curAcCuts);
 END {ᠭ1};

 PROCEDURE ᠭ2();
 BEGIN
  室2();
 END {ᠭ2};

 PROCEDURE ᠭ3();
  VAR
   curAcCuts: L_MathR.tMathAcCutCollection;
   Dummy    : L_XObj.tSum;
 BEGIN
  L_General.Assert(AcMthL.AcCut = L_Acnt.fictAcCut, "'ᠭ3' - ࠧ१   䨪⨢");
  E_Stock.GetKeyAssWearAcCuts(Memo.gl_mb(), curAcCuts, L_MathR.KA_OutBalDepr, L_MathR.KA_All, L_MathR.KA_All);
  Dummy:=intᠭ(curAcCuts);
 END {ᠭ3};

 PROCEDURE E_RunsProportional(): SCAL[2];
  VAR
   Prc: PROC;
 BEGIN
  Prc:=PROCREF(E_Stock.RunsProportional);
  IF ~!Prc THEN
   RETURN Prc(Memo.gl_mb(), L_MathR.DprK_Acn);
  ELSE
   RETURN 0;
  END;
 END {E_RunsProportional};

 VAR
  AmortPhase: SCAL[3];

 PROCEDURE SetAmortPhase(Phase: SCAL[3]);
 BEGIN
  AmortPhase:=Phase;
 END {SetAmortPhase};

 PROCEDURE _⨧(CostSum, DeprSum: L_XObj.tSum; _AcCut: LIKE(AcCut.AcCut));
  CONST
   RSize = Math.Max(E_Stock.MtyRunSize, 2);
  VAR
   curSum   : L_XObj.tSum;
   Depr,
   RealDepr : L_XObj.tSum;
   MtyDepr  : L_XObj.tSum[RSize];
   i        : NUMERIC[0];
   _Runs    : LIKE(MathMty.Proof)[RSize];
   _TotRun  : LIKE(MathMty.Proof);
 BEGIN
  IF (CostSum - DeprSum) > 0 THEN
   SETZERO(_TotRun, i);
   WHILE i < E_Stock.MtyRunSize DO
    _Runs[i]:=L_MathR.GetRunMathMty(Memo.gl_mb(), E_Stock.MtyRunBeg+i);
    INC(_TotRun, _Runs[i]);
    INC(i);
   END;
 
   IF ~Deprec.Norm1000 & ((_TotRun = 0) | ~E_RunsProportional()) THEN  (**)
    Depr:=CostSum*Deprec.Norm*KAGLog.Number/100/12;
    RealDepr:=Math.Min(Depr, CostSum-DeprSum);
    IF RealDepr > 0 THEN
     L_MathR.KeyAssMakeCir(_s, _AcCut, AcMthL.Apport, AcMthL.AcCut2,
                           RealDepr, L_XObj.src_Amortisation);
    END;
   ELSE                      (*ய樮쭮 ஡*)
    SETZERO(Depr, i);
    WHILE i < E_Stock.MtyRunSize DO
     IF Deprec.Norm1000 THEN
      MtyDepr[i]:=CostSum*(_Runs[i]/1000)*Deprec.Norm*KAGLog.Number/100;
     ELSE
      MtyDepr[i]:=CostSum*Deprec.Norm*KAGLog.Number/100/12*_Runs[i]/_TotRun;
     END;
     INC(Depr, MtyDepr[i]);
     INC(i);
    END;
    RealDepr:=Math.Min(Depr, CostSum-DeprSum);
    IF RealDepr > 0 THEN
     i:=0;
     MtyDepr[E_Stock.MtyRunSize-1]:=RealDepr;
     WHILE i < E_Stock.MtyRunSize DO
      IF i # (E_Stock.MtyRunSize-1) THEN
       curSum:=MtyDepr[i]/Depr*RealDepr;
       DEC(MtyDepr[E_Stock.MtyRunSize-1], curSum);
      ELSE
       curSum:=MtyDepr[i]; (*⮡    㣫*)
      END;
      IF curSum # 0 THEN
       L_MathR.KeyAssMakeCir(_s, _AcCut, AcMthL.Apport,
                             E_Stock.MtyIdxAcCut(L_MathR.DprK_Acn, E_Stock.MtyRunBeg+i),
                             curSum, L_XObj.src_Amortisation);
      END;
      INC(i);
     END;
    END;
   END;
   IF (CostSum-DeprSum-RealDepr) > 0 THEN
    SetRecalcNeed();
   END;
  END;
 END {_⨧};

 PROCEDURE ⨧();
  VAR
   Cost,
   Depr      : L_XObj.tSum;
   curAcCuts : L_MathR.tMathAcCutCollection;
   waCount   : SCAL[L_MathR.KA_NumWearAcnt];
 BEGIN
  IF (AmortPhase = 1) & (MathKAGL.AcnStat = L_MathR.matst_InOperat) THEN
   L_General.Assert(AcMthL.AcCut = L_Acnt.fictAcCut, "'⨧' - ࠧ१   䨪⨢");
 
   FOR_EACH waCount DO
    IF waCount # L_MathR.KA_All THEN
     E_Stock.GetKeyAssBalCostAcCuts(Memo.gl_mb(), curAcCuts, L_MathR.KA_All, L_MathR.KA_All, waCount);
     Cost:=L_MathR.GetKeyAssAcCutCollectionRemaindersR(Memo.gl_me()+1, curAcCuts, L_Acnt.ct_Credit);
  
     IF ~!curAcCuts[0] (* ࠧ१  ⮨*) THEN
      E_Stock.GetKeyAssWearAcCuts(Memo.gl_mb(), curAcCuts, L_MathR.KA_All, L_MathR.KA_All, waCount);
      L_General.CallUs(~!curAcCuts[0] & !curAcCuts[1]); (*  ஢  ࠧ१  ⨧樨*)
      Depr:=L_MathR.RemaindersR(Memo.gl_me()+1, curAcCuts[0], L_Acnt.ct_Debit);
      _⨧(Cost, Depr, curAcCuts[0]);
     END; (* IF ~!curAcCuts[0] ... *)
    END; (* IF waCount # L_MathR.KA_All ... *)
   END; (* FOR_EACH waCount ... *)
  END;
 END {⨧};

BEGIN
 SETEMPTY(室_㬬);
 AmortPhase:=1;
END.
