(*
%Copyright   (c) Polak IT
%Author      29.12.2009 18:18:41 POLAK\Gina
%Purpose     ࠢ 䨪樥 MoneyDst
%Type        control
%Specific    SYS
%Modified    17.05.2012 12:22:31 POLAK\Gina
%Environment
*)

 MODULE MoneyDst [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Events, L_WDO, L_XObj, L_STx, L_AcCut, L_XDoc;

 PRIVATE PROCEDURE setFieldValue(Name: STRING[]; Value: ANYTYPE);
 BEGIN
  L_WDO.setFieldValue(Name, Value);
 END {setFieldValue};

 PRIVATE PROCEDURE MoneyDst_1_OnReposition();
 BEGIN
  IF ACCESS(MoneyDst) THEN
   IF !MoneyDst.XObject THEN
    setFieldValue("v_XObjectName", "");
   ELSE
    CONFORM(MoneyDst, XObject);
    setFieldValue("v_XObjectName", L_XObj.GetXObjectOriginName());
   END;
   IF !MoneyDst.AcCut THEN
    L_General.CallUs(SEARCH(Money, RECORDID, MoneyDst.riMoney));
    CONFORM(Money, Staff, MCList);
    L_AcCut.PositionOnAcCut(L_STx.STx_GetAcCutForMoney());
    setFieldValue("v_AcCutFrom", " ࠧ१ ");
    setFieldValue("v_AcCutName", AcCut.AcCut+" "+AcCut.Name);
   ELSE
    CONFORM(MoneyDst, AcCut);
    setFieldValue("v_AcCutFrom", " ⭮ ࠧ१");
    setFieldValue("v_AcCutName", AcCut.Name);
   END;
   IF !MoneyDst.XDocId THEN
    setFieldValue("v_XDocStr", "");
   ELSE
    setFieldValue("v_XDocStr", L_XDoc.extXDocStr(MoneyDst.XDocId, L_XDoc.xdast_wSrcNbr));
   END;
  END;
 END {MoneyDst_1_OnReposition};

 PRIVATE PROCEDURE MoneyDst_1_OnZoneOpen();
 BEGIN
  setFieldValue("v_XObjectName", "");
  setFieldValue("v_AcCutFrom", "");
  setFieldValue("v_AcCutName", "");
  setFieldValue("v_XDocStr", "");
 END {MoneyDst_1_OnZoneOpen};

 PUBLIC PROCEDURE PositionOnXDocId();
 BEGIN
  IF ACCESS(MoneyDst) THEN
   L_General.Assert(~!MoneyDst.XDocId, " 易 㬥⮢   ப");
   L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, MoneyDst.XDocId, "");
  END;
 END {PositionOnXDocId};

BEGIN
 L_Events.ExecuteHandler();
END.