(*
%Copyright   (c) Polak Computer System
%Author      01.11.2000 18:46:39 SAN
%Purpose      ⥦ 㬥⮢  ᭮ ਪ  
%Type        operation
%Specific    SYS
%Modified    30.10.2003 13:48:04 POLAK\GAV
%Environment
*)

 IMPORT L_General, L_PDoc, L_PRoll, L_Money, L_EDO;

 VAR
  DestStr: STRING[];
  S      : LIKE(EDOrderL.BySum);
  Mul    : NUMERIC[6];
  FormStr: STRING[];
  ByCassa: SCAL[2];

BEGIN
 L_General.Assert(ACCESS(EDOrder), " ⠭ ਪ  ᮭ");
 L_General.Assert(EDOrder.State = L_EDO.st_ordSigned,
                  "ਪ   ᠭ");

 IF    MODE = 060 THEN
  DestStr:="⥦ 㬥";
 ELSIF MODE = 061 THEN
  L_PDoc.ForceEOrdPay();  (* ਭ㤨⥫쭠 뤠 १ . थ *)
  DestStr:="室 थ";
 ELSE
  L_General.BadMode(MODE);
 END;

 Mul:=1;
 ByCassa:=L_PRoll.ByCassaLev(L_PDoc.ev_EdordPay);
 FormStr:="| ନ "+DestStr+
          "| ᭮ ਪ "+L_EDO.EDOrderName()+
          "|" +
          "| 樥⮬ %L10<6.>I" +
          "|" +
          "|!  楤 ਬ ⮫쪮  த ਪ,"+
          "|.. ਪ, ᮤঠ  ப  ᫥ 㬬"+
          "|" +
          "| :                                              " +
          "|%59,2< ᯨ᪮| ᠬ>O" +
          "|" +
          "|" +
          "|" +
          "|%<   !   >X  %< 믮 >FDB";
 STDFORM(FormStr, , STOP, 1, Mul, ByCassa);

 L_PDoc.InitPDocGroup(L_PDoc.ev_EdordPay);

 OPENREP(Mon, L_General.NameConnection("EPDoc"), Create);

 SELECT(EDOrderL, EDOLTSN, , EDOrder.EDOrder);
 WHILE OCCURE(EDOrderL) DO
  S:=0;
  CONFORM(EDOrderL, Staff);
  CHANGESEL(EDOrderL, EDOLTSN, , EDOrder.EDOrder, EDOrderL.TSN);
  WHILE OCCURE(EDOrderL) DO
   INC(S, EDOrderL.BySum);
   NEXT(EDOrderL);
  END;
  L_PDoc.AppendPDoc(L_Money.RoundMoney(EDOrder.Closed, S*Mul));
  LAST(EDOrderL);
  CHANGESEL(EDOrderL, EDOLTSN, , EDOrder.EDOrder);
  NEXT(EDOrderL);
 END; (* WHILE OCCURE(EDOrderL) ... *)

 L_PDoc.DonePDocGroup(ByCassa);

 CLOSEREP(Mon);
END.
