(*
%Copyright   (c) Polak Computer System
%Author      NAIL
%Purpose      ⥦ 㬥⮢  ᭮ ਪ
%Type        operation
%Specific    SYS
%Modified    16.08.2010 18:33:46 POLAK\Gina
%Environment
*)

 IMPORT L_DatTim, L_General, L_PDoc, L_Money, L_EDO, L_PRoll;

 VAR
  DestStr: STRING[];
  S      : LIKE(FOrderL.Value);
  Mul    : NUMERIC[6];
  FormStr: STRING[];
  ByCassa: SCAL[2];

BEGIN
 L_General.Assert(ACCESS(FOrder), " ⠭ ⥪騩 ਪ");
 L_General.Assert(FOrder.Done, "ਪ   ࠡ⠭");
 L_General.Assert(FOrder.Type = 0, "  믮 ⮫쪮  ਪ  ᫥ 㬬");
 L_General.Assert(FOrder.Status = L_EDO.fost_Passed, "  믮 ⮫쪮  ஢ ਪ");

 IF    MODE = 060 THEN
  DestStr:="⥦ 㬥";
 ELSIF MODE = 061 THEN
  L_PDoc.ForceEOrdPay();  (* ਭ㤨⥫쭠 뤠 १ . थ *)
  DestStr:="室 थ";
 ELSE
  L_General.BadMode(MODE);
 END;
 CONFORM(FOrder, MCList);
 Mul:=1;
 ByCassa:=L_PRoll.ByCassaLev(L_PDoc.ev_FordPay);
 FormStr:="| ନ " + DestStr +
          "| 뤠 ᫥  " + L_DatTim.PeriodStr(FOrder.Period) +
          "|  / " + FOrder.MCode + " " + MCList.Name +
          "| ᭮ ਪ" +
          "|" + L_EDO.FOrderName() +
          "|" +
          "| 樥⮬ %L10<6.>I" +
          "|" +
          "| :                  " +
          "|%31,2< ᯨ᪮| ᠬ>O" +
          "|" +
          "|" +
          "|" +
          "|%<   !   >X  %< 믮 >FDB";
 STDFORM(FormStr, , STOP, 1, Mul, ByCassa);

 L_PDoc.InitPDocGroup(L_PDoc.ev_FordPay);
 OPENREP(Mon, L_General.NameConnection("FOPay_"+FOrder.MCode), Create);

 SELECT(FOrderL, FOrder, , FOrder.FOrder);
 WHILE OCCURE(FOrderL) DO
  S:=0;
  CONFORM(FOrderL, Staff);
  CHANGESEL(FOrderL, FOrder, , FOrder.FOrder, FOrderL.TSN);
  WHILE OCCURE(FOrderL) DO
   INC(S, FOrderL.Value);
   NEXT(FOrderL);
  END;
  L_PDoc.AppendPDoc(L_Money.RoundMoney(FOrder.Closed, S*Mul));
  LAST(FOrderL);
  CHANGESEL(FOrderL, FOrder, , FOrder.FOrder);
  NEXT(FOrderL);
 END; (* WHILE OCCURE(FOrderL) ... *)

 L_PDoc.DonePDocGroup(ByCassa);
 CLOSEREP(Mon);
END.
