(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose      ⥦ 㬥⮢  ᭮  /
%Type        operation
%Specific    SYS
%Modified    16.05.2007 16:31:42 POLAK\GAV
%Environment
*)

 IMPORT L_DatTim, L_General, L_PDoc, L_PRoll, Memo;

 VAR
  DestStr: STRING[30];
  _Sum   : LIKE(Money.Sum);
  FormStr: STRING[];
  ByCassa: SCAL[2];

BEGIN

 L_General.Assert(ACCESS(MCList), " ⠭ ⥪騩  ᫥");
 L_General.Assert(MCList.MCTyp = 0, "  믮 ⮫쪮  ᫥");

 IF    MODE = 061 THEN
  DestStr:="⥦ 㬥";
 ELSIF MODE = 062 THEN
  L_PDoc.ForceEOrdPay();  (* ਭ㤨⥫쭠 뤠 १ . थ *)
  DestStr:="室 थ";
 ELSE
  L_General.BadMode(MODE);
 END;


 ByCassa:=L_PRoll.ByCassaLev(L_PDoc.ev_McodPay);
 FormStr:="| ନ " + DestStr +
          "| 뤠 ᫥  "+L_DatTim.PeriodStr(Memo.tmp_mb())+
          "|  / " + MCList.MCode + " " + MCList.Name +
          "|" +
          "| :                  " +
          "|%31,2< ᯨ᪮| ᠬ>O" +
          "|" +
          "|" +
          "|" +
          "|%<   !   >X  %< 믮 >FDB";
 STDFORM(FormStr, , STOP, 1, ByCassa);
 L_PDoc.InitPDocGroup(L_PDoc.ev_McodPay);
 OPENREP(Mon, L_General.NameConnection("MPDMC_"+MCList.MCode), Create);

 SELECT(Staff, TSN);
 WHILE OCCURE(Staff) DO
  _Sum:=0;
  PROMPT(Staff.TSN);
  SELECT(Money, TSN, , Staff.TSN, Memo.tmp_mb());
  WHILE OCCURE(Money) DO
   IF Money.MCode = MCList.MCode THEN
    INC(_Sum, Money.Sum);
   END;
   NEXT(Money);
  END; (* WHILE OCCURE(Money) ... *)
  IF _Sum > 0 THEN
   L_PDoc.AppendPDoc(_Sum);
  END;
  NEXT(Staff);
 END; (* WHILE OCCURE(Staff) ... *)

 L_PDoc.DonePDocGroup(ByCassa);
 CLOSEREP(Mon);
END.
