(*
%Copyright   (c) Polak Computer System
%Author      21.08.2002 15:52:22 POLAK\LDA
%Purpose       ꥪ⠬  ਮ
%Type        report
%Specific    SYS
%Modified    05.03.2013 15:33:08 POLAK\LDA
%Environment
*)

 MODULE Ms_Mov1 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_PagePr, L_AFM, L_Acnt, L_DatTim, L_MathR, D_XObj, L_Str, Str, L_XObj, P_Firm;

 PRIVATE CONST
  PagLength = 60;

 PRIVATE VAR
  totISlSum,
  totDbtSum,
  totCrdSum,
  totOSlSum : L_XObj.tSum;

  totISlQnt,
  totDbtQnt,
  totCrdQnt,
  totOSlQnt : L_XObj.tQnt;

  RepName,
  RepTitle: STRING[];
  curMyFirm: LIKE(MyFirm.MyFirm);

(*
$P{ RepTop:
@
}
*)

(*
$P{ PageTop:
P_Firm.FP_FirmName(P_Firm.fomf(curMyFirm), Memo.ud_ut()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
RepTitle, C, ""
MathType.MathType, L, ""
MathType.Name, L, ""
AcCut.AcCut, L, ""
AcCut.Name, L, ""
Storage.Storage, L, ""
Storage.Name, L, ""
L_Acnt.GetCAcntSign(Memo.ud_ut(), AcCut.AcCut), L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut()+1, L, "D.N.y"
@
##############################################################################                                                                                                                                       ########## #####
=#####===============================================================================================================================================================================================================================
|                                                                             ਠ 業⥩  ਮ  ##########  ##########                                                                                   |
|###################################################################################################################################################################################################################################|
|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| ꥪ ਠ쭮  ## ######################################   ࠧ१ ###### ##############################################  ࠭ ####### ################################ ᮢ  #####      |
|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|     |                                                   |   |     |       줮  ##########        |                              |               ।              |               |       줮  ##########        |
|  |                                       ||     |-----------------------------------|-----------------------------------|-----------------------------------|   । 業|-----------------------------------|
|     |                                                   |   |     |      -|                 㬬|      -|                 㬬|      -|                 㬬|               |      -|                 㬬|
|-----|---------------------------------------------------|---|-----|------------|----------------------|------------|----------------------|------------|----------------------|---------------|------------|----------------------|
}
*)

 PRIVATE PROCEDURE PrintAvPrice(): STRING[];
 BEGIN
  IF    XC001.uav_aQnt[L_Acnt.uavp_OSlDbt] # 0 THEN
   RETURN FLDTOSTR(XC001.uav_aSum[L_Acnt.uavp_OSlDbt] / XC001.uav_aQnt[L_Acnt.uavp_OSlDbt], ",2-");
  ELSIF (XC001.uav_aQnt[L_Acnt.uavp_ISlDbt]+XC001.uav_aQnt[L_Acnt.uavp_CirDbt]) # 0 THEN
   RETURN FLDTOSTR((XC001.uav_aSum[L_Acnt.uavp_ISlDbt]+XC001.uav_aSum[L_Acnt.uavp_CirDbt])/(XC001.uav_aQnt[L_Acnt.uavp_ISlDbt]+XC001.uav_aQnt[L_Acnt.uavp_CirDbt]), ",2-");
  ELSE
   RETURN "";
  END;
 END {PrintAvPrice};

 PRIVATE PROCEDURE uav_IsZero(uav: L_Acnt.tUnfoldedAcntVector): SCAL[2];
  VAR
   uavp: L_Acnt.tUnfoldedAcntVectorPart;
 BEGIN
  FOR_EACH uavp DO
   IF uav[uavp] # 0 THEN
    RETURN 0;
   END;
  END;
  RETURN 1;
 END {uav_IsZero};

(*
$P{ Line:
Math.Math, L, ""
Math.Name, L, ""
L_MathR.DefaultMUnitSign(MC.Math), L, ""
XC001.uav_aQnt[L_Acnt.uavp_ISlDbt]-XC001.uav_aQnt[L_Acnt.uavp_ISlCrd], R, "2."
XC001.uav_aSum[L_Acnt.uavp_ISlDbt]-XC001.uav_aSum[L_Acnt.uavp_ISlCrd], R, ",2-"
XC001.uav_aQnt[L_Acnt.uavp_CirDbt], R, "2."
XC001.uav_aSum[L_Acnt.uavp_CirDbt], R, ",2-"
XC001.uav_aQnt[L_Acnt.uavp_CirCrd], R, "2."
XC001.uav_aSum[L_Acnt.uavp_CirCrd], R, ",2-"
PrintAvPrice(), R, ""
XC001.uav_aQnt[L_Acnt.uavp_OSlDbt]-XC001.uav_aQnt[L_Acnt.uavp_OSlCrd], R, "2."
XC001.uav_aSum[L_Acnt.uavp_OSlDbt]-XC001.uav_aSum[L_Acnt.uavp_OSlCrd], R, ",2-"
@
|#####|###################################################|###|     |############|######################|############|######################|############|######################|###############|############|######################|
}
*)

(*
$P{ Filling:
@
|     |                                                   |   |     |            |                      |            |                      |            |                      |               |            |                      |
}
*)

(*
$P{ PageBot:
L_PagePr.PagePr_CurrentPage(), R, "0"
@
=========================================================================================================================================================================================================================== ###===
}
*)

(*
$P{ RepBot:
totISlQnt, R, "2."
totISlSum, R, ",2-"
totDbtQnt, R, "2."
totDbtSum, R, ",2-"
totCrdQnt, R, "2."
totCrdSum, R, ",2-"
totOSlQnt, R, "2."
totOSlSum, R, ",2-"
L_PagePr.PagePr_CurrentPage(), R, "0"
@
|-------------------------------------------------------------|-----|------------|----------------------|------------|----------------------|------------|----------------------|---------------|------------|----------------------|
|ᥣ                                                        |     |############|######################|############|######################|############|######################|               |############|######################|
=(c) Polak================================================================================================================================================================================================================= ###===
}
*)

 PRIVATE PROCEDURE _RprtTop(Mode: SCAL[20]);
 BEGIN
  IF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, RepTop);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtTop};

 PRIVATE PROCEDURE _PageTop(Mode: SCAL[20]);
 BEGIN
  IF (Mode = L_PagePr.m_Print) | (Mode = L_PagePr.m_RDoneTop) THEN
   MAKEPART(R, PageTop);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageTop};

 PRIVATE PROCEDURE _PageBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(PageBot));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, PageBot);
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_None);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageBot};

 PRIVATE PROCEDURE _RprtBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(RepBot));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, RepBot);
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_Fill);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtBot};

 PRIVATE PROCEDURE _Filling(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(Filling));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, Filling);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_Filling};

 PRIVATE PROCEDURE PrintRep();
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create,
             TopMargin, 0, BottomMargin, 0, FontEnlargement, 1.2);

  L_AFM.MakeIndex("MC", "MyFirm  : LIKE(MyFirm.MyFirm);" +
                        "MathType: LIKE(Math.MathType);" +
                        "AcCut   : LIKE(AcCut.AcCut);" +
                        "Storage : LIKE(Storage.Storage);" +
                        "Math    : LIKE(Math.Math);" +
                        "XObject : LIKE(XObject.XObject)");

  SELECT(XC001, mfObject);
  WHILE OCCURE(XC001) DO
   SEARCH(XObject, XObject, , XC001.Object);
   NARROWSEL(XC001, MyFirm, Object);
   WHILE OCCURE(XC001) DO
    IF ~uav_IsZero(XC001.uav_aSum) | ~uav_IsZero(XC001.uav_aQnt) THEN
     L_XObj.AccessOrigin();
     PROMPT(" "+mItem.XObject+",  "+mItem.Math);
     CONFORM(mItem, Math);
     ADD(MC, MC, , XObject.MyFirm, Math.MathType, XC001.Cut1, mItem.Storage, Math.Math, XC001.Object);
    END;
    NEXT(XC001);
   END; (* WHILE OCCURE(XC001) ... *)
   NEXTINEXTENDEDSEL(XC001, MyFirm, Object);
  END; (* WHILE OCCURE(XC001) ... *)


  SELECT(MC, MC);
  WHILE OCCURE(MC) DO
   curMyFirm:=MC.MyFirm;
   NARROWSEL(MC, MyFirm);
   WHILE OCCURE(MC) DO
    NARROWSEL(MC, MathType, AcCut, Storage);
    SEARCH(MathType, MathType, , MC.MathType);
    SEARCH(AcCut, AcCut, , MC.AcCut);
    SEARCH(Storage, Storage, , MC.Storage);
 
    L_PagePr.PagePr_Init("R", PagLength,
                         PROCREF(_RprtTop),
                         PROCREF(_PageTop),
                         PROCREF(_PageBot),
                         PROCREF(_RprtBot),
                         PROCREF(_Filling));
    SETZERO(totISlSum, totISlQnt,
            totDbtSum, totDbtQnt,
            totCrdSum, totCrdQnt,
            totOSlSum, totOSlQnt);
 
    WHILE OCCURE(MC) DO
     SEARCH(Math, Math, , MC.Math);
     PROMPT(".   "+MC.MathType+", ࠧ१ "+MC.AcCut+",  "+MC.Math);
     SEARCH(XC001, mfObject, , MC.MyFirm, MC.XObject, MC.AcCut);
     INC(totISlSum, XC001.uav_aSum[L_Acnt.uavp_ISlDbt]-XC001.uav_aSum[L_Acnt.uavp_ISlCrd]);
     INC(totISlQnt, XC001.uav_aQnt[L_Acnt.uavp_ISlDbt]-XC001.uav_aQnt[L_Acnt.uavp_ISlCrd]);
     INC(totDbtSum, XC001.uav_aSum[L_Acnt.uavp_CirDbt]);
     INC(totDbtQnt, XC001.uav_aQnt[L_Acnt.uavp_CirDbt]);
     INC(totCrdSum, XC001.uav_aSum[L_Acnt.uavp_CirCrd]);
     INC(totCrdQnt, XC001.uav_aQnt[L_Acnt.uavp_CirCrd]);
     INC(totOSlSum, XC001.uav_aSum[L_Acnt.uavp_OSlDbt]-XC001.uav_aSum[L_Acnt.uavp_OSlCrd]);
     INC(totOSlQnt, XC001.uav_aQnt[L_Acnt.uavp_OSlDbt]-XC001.uav_aQnt[L_Acnt.uavp_OSlCrd]);
     L_PagePr.PagePr_BeforePrintLine(DEPTH("Line"));
     MAKEPART(R, Line);
     NEXT(MC);
    END; (* WHILE OCCURE(MC) ... *)
    L_PagePr.PagePr_Done();
    NEXTINEXTENDEDSEL(MC, MathType, AcCut, Storage);
   END; (* WHILE OCCURE(MC) ... *)
   NEXTINEXTENDEDSEL(MC, MyFirm);
  END; (* WHILE OCCURE(MC) ... *)
 END {PrintRep};

 PUBLIC PROCEDURE MMS01();
  VAR
   trgOM    : L_XObj.tOriginsMap;
   trgMyFirm: LIKE(MyFirm.MyFirm);
 BEGIN
  RepName:="MMS01";
  APP.Get().NewPrompt("("+RepName+")");
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_DatTim.CheckWMIntvl(Memo.ud_fr(), Memo.ud_ut());
  L_XObj.SetupOrigins(0, trgOM, trgMyFirm);
  D_XObj.PointwiseBuildXC001(D_XObj.XCC_SingleStorage,
                             EMPTYOF(L_XObj.tSection),
                             L_Acnt.ak_Acn,
                             trgOM,
                             trgMyFirm,
                             D_XObj.XST_ByXObj,
                             D_XObj.XST_ByAcCut,
                             D_XObj.XST_ByAcCut2);
  RepTitle:=" ࠭ "+Storage.Storage+" "+Storage.Name;
  PrintRep();
  D_XObj.PurgeXC001();
  L_General.SurveyLastReport();
 END {MMS01};

END.
