(*
%Copyright   (c) Polak Computer System
%Author      21.08.2000 15:27:07 BOR
%Purpose     ࠢ  
%Type        report
%Specific    SYS
%Modified    10.04.2012 12:23:40 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_DatTim, L_PRoll, Str, L_Russia, Memo,
        P_Firm, L_Staff, P_MyFirm, L_ctc;

 VAR
  FstMonth,
  LstMonth,
  D        : DATE;
  Sum      : NUMERIC[2][26];
  i        : NUMERIC[0];
  OwnFirm  : LIKE(Firm.Firm);

 CONST
  M = "|ࠫ||५|||||||||⮣";

(*
$P{ Top1:
?, R, ""
@
##############################################################################
}
*)

(*
$P {Top2:
P_MyFirm.NumInPFR(Staff.MyFirm, SYSDATE()), R, ""
L_DatTim.FullDateStr(SYSDATE()), L, ""
P_Firm.FP_INN(OwnFirm, SYSDATE()), R, ""
Man.Name, L, "" "U"
Man.Sex, L, "|"
FstMonth, L, "y"
?, L, "y"
@
                                  樮   : ##############
######################                                     :   ############

N _____________
                                      

뤠 . ###################################################################

 ⮬,  ### ࠡ⮪, 뢠  ᫥ ᨨ, ⠢:

                                       
------------------------------------------------------------------------------
|  |᪠|.   | 㬬     |᪠|.   | 㬬     |
|        |   㬬   |४樨| ࠡ⪠ |   㬬   |४樨| ࠡ⪠ |
|        | ࠡ⪠ |ࠡ⪠|   ⮬ | ࠡ⪠ |ࠡ⪠|   ⮬ |
|        | #### |         | ४樨 | #### |         | ४樨 |
}

$P{ Line:
?, L, ""
?, R, "2-"
?, R, "2-"
@
|--------|-----------|---------|-----------|-----------|---------|-----------|
|########|###########|         |           |###########|         |           |
}

$P{ Bot:
Man.SINumber, L, L_Russia.sf_ManSINumber
Man.INN, L, ""
"楢 ", L, "" "U"
P_Firm.FP_LeadName(OwnFirm, SYSDATE()), R, "", "U"
P_Firm.FP_AcntName(OwnFirm, SYSDATE()), R, "", "U"
@
------------------------------------------------------------------------------
樮  ⥫騪  :                       ##############

䨪樮  ⥫騪:                        ############

ਬ砭:  ___________________________________________________________

   稭 ___________________________________________________

  㬬,   ࠢ, ந ᫥   ⠭-
 ⠢  .

㬬, 믫祭  ६ 㤮ᯮᮡ,  ᭮  ⥫-
 ᪠, ࠧ ய樮쭮 栬 ᫥.

᭮ 뤠 ࠢ #####################################################

㪮⥫ ।,
०, ࣠樨  #####################################################

 壠 ############################################################

 ந ______________________________________________________________
}                       
*)

 PRIVATE PROCEDURE GetSum(P: DATE): NUMERIC[2];
  VAR
   S: NUMERIC[2];
 BEGIN
  SETZERO(S);
  SAVE(Staff);
  SELECT(Staff, MyFirm, , Staff.MyFirm, Staff.Man);
  WHILE OCCURE(Staff) DO
   IF (L_Staff.GetFirmOfStaff() = OwnFirm) & SELECT(Money, TSN, Staff.TSN, P) THEN
    L_PRoll.CheckSalDone(P);
    WHILE OCCURE(Money) DO
     CONFORM(Money, MCList);
     IF MCList.InSign[5] (*室  *) THEN
      INC(S, Money.Sum);
     END;
     NEXT(Money);
    END; (* WHILE OCCURE(Money) ... *)
   END;
   NEXT(Staff);
  END;
  RESTORE(Staff);
  RETURN S;
 END {GetSum};

 PRIVATE PROCEDURE MakeSubTop(S: STRING[]);
  VAR
   j     : NUMERIC[0];
   TmpStr: STRING[][10];
 BEGIN
  Str.Format(TmpStr, S, 78, RIGHT);
  j:=0;
  WHILE ~!TmpStr[j] DO
   MAKEPART(R, Top1, TmpStr[j]);
   INC(j);
  END;
 END {MakeSubTop};

BEGIN
 L_General.Assert(ACCESS(Man), " । ");

 FstMonth:=L_DatTim.Per(Memo.ud_fr());
 LstMonth:=L_DatTim.Per(Memo.ud_ut());
 L_General.Assert(LstMonth < 01\01\2002, "ࠢ    ਮ ᫥ 01.2002.|. 窨    ");
 L_Staff.StandOnAnyMainContract(Man.Man, Memo.ud_ut());
 OwnFirm:=L_Staff.GetFirmOfStaff();

 OPENREP(R, L_General.NameConnection("N_PFR"), Create, FontProperty, "/U /B /I");
 MakeSubTop(P_Firm.FP_FirmName(OwnFirm, SYSDATE()));
 MakeSubTop(L_ctc.GetAdr_Reg(SYSDATE(), OwnFirm));
 IF    L_DatTim.YEAR(LstMonth) = L_DatTim.YEAR(FstMonth) THEN
  MAKEPART(R, Top2);
 ELSIF L_DatTim.YEAR(LstMonth) = (L_DatTim.YEAR(FstMonth)+1) THEN
  MAKEPART(R, Top2, LstMonth);
 ELSE
  L_General.Error("ਮ  墠뢠   2 ");
 END;

 D:=FstMonth;
 SETZERO(Sum);
 WHILE D <= LstMonth DO
  PROMPT(FLDTOSTR(D, "N.y"));
  i:=13*(L_DatTim.YEAR(D)-L_DatTim.YEAR(FstMonth));
  Sum[L_DatTim.MONTH(D)+i]:=GetSum(D);
  INC(Sum[12+i], Sum[L_DatTim.MONTH(D)+i]);
  D:=L_DatTim.IncMonth(D, +1);
 END; (* WHILE D < LstMonth ... *)

 i:=0;
 WHILE i<13 DO
  MAKEPART(R, Line, Str.Item(M, "|", i), Sum[i], Sum[13+i]);
  INC(i);
 END;

 MAKEPART(R, Bot);
 CLOSEREP(R);
END.
