(*
%Copyright   (c) Polak Computer System
%Author      07.08.2001 18:56:56 RSN
%Purpose     ⮢ , ।⮢ ᠫ줮   
%Type        report
%Specific    SYS
%Modified    26.02.2013 13:53:15 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_DatTim, L_Staff, L_PRoll, L_AFM,
        L_Math, Memo, P_Firm;

 VAR
  RepName,
  _Title,
  _Comment : STRING[];

(*
$P{ Top:
P_Firm.MyFirmName(_Cash.MyFirm, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
_Title, C, ""
L_DatTim.IncMonth(Memo.ud_mb(), +1), L, "D.N.y"
_Comment, C, ""
@
############################################################# ########## #####
=###==========================================================================
|            ########### ᠫ줮  ௫  ##########           |
|############################################################################|
}
*)

(*
$P{ Cash:
Cash.Cash, L, ""
Cash.Name, L, ""
@
|----------------------------------------------------------------------------|
| ## ################################################                   |
|----------------------------------------------------------------------------|
|  |  ⢮                        | 㢮|         㬬|
|-----|--------------------------------------------|----------|--------------|
}
*)

(*
$P{ Line:
Staff.TSN, L, ""
Man.Name, L, ""
Staff.EndDate, L, "D.N.y"
?, R, "2-"
@
|#####|############################################|##########|##############|
}
*)

(*
$P{ CashBot:
?, R, "2-"
@
|-------------------------------------------------------------|--------------|
|⮣                                                 |##############|
}
*)

(*
$P{ Bot:
?, R, "2-"
@
|-------------------------------------------------------------|--------------|
|⮣  ।                                         |##############|
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE MakeIndex();
  VAR
   _Saldo: LIKE(PCalc.Saldo);
 BEGIN
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   SETZERO(_Saldo);
   PROMPT(Staff.TSN + " : ");
   IF L_Staff.IsBegan(Memo.ud_mb()) THEN
    IF L_PRoll.SrcPCalc(Memo.ud_mb()) THEN
     _Saldo:=L_PRoll.OutSaldoFutInc(Memo.ud_mb(), Memo.ud_mb(), MODE = 102);
    END;
    IF ((MODE = 100) & (_Saldo > 0)) |
       ((MODE # 100) & (_Saldo < 0)) THEN
     HISTCONF(Memo.ud_me(), Staff, StaffLog);
     CONFORM(StaffLog, Officer, TimeKeep);
     L_General.Assert(OCCURE(TimeKeep),
                      " । ⠡騪  ⠡. " + Staff.TSN);
     _Cash._Cash :=TimeKeep.Cash;
     _Cash.TSN   :=Staff.TSN;
     _Cash.Saldo :=_Saldo;
     _Cash.MyFirm:=Staff.MyFirm;
     INSERT(_Cash);
    END;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
 END {MakeIndex};

 VAR
  _CSum,
  _TSum : NUMERIC[2];
  Cash_ : LIKE(Cash.Cash);
BEGIN
 IF    MODE = 100 THEN
  RepName :="C70";
  _Title  :="।⮢";
  SETEMPTY(_Comment);
 ELSIF MODE = 101 THEN
  RepName :="D70";
  _Title  :="⮢";
  _Comment:="   騥 ਮ";
 ELSIF MODE = 102 THEN
  RepName :="D7f";
  _Title  :="⮢";
  _Comment:=" ⮬ 㬬  騥 ਮ";
 ELSE
  L_General.BadMode();
 END;

 OPENREP(R, L_General.NameMonth(RepName), Create);
 L_AFM.MakeIndex("_Cash", "MyFirm: LIKE(Staff.MyFirm) ;"+
                             "_Cash : LIKE(TimeKeep.Cash);"+
                             "TSN   : LIKE(Staff.TSN)    ;"+
                             "Saldo : LIKE(PCalc.Saldo)   ");
 MakeIndex();
 SELECT(_Cash, _Cash);
 WHILE OCCURE(_Cash) DO
  NARROWSEL(_Cash, MyFirm);
  MAKEPART(R, Top);

  SETZERO(_TSum);
  WHILE OCCURE(_Cash) DO
   Cash_:=_Cash._Cash;
   SETZERO(_CSum);
   L_General.Assert(SEARCH(Cash, Cash , Cash_), "OutSaldo.Error1");
   MAKEPART(R, Cash);
   NARROWSEL(_Cash, _Cash);
   WHILE OCCURE(_Cash) DO
    PROMPT(":  " + Cash_ + " ⠡. " + _Cash.TSN);
    L_General.Assert(SEARCH(Staff, TSN, _Cash.TSN), "OutSaldo.Error2");
    CONFORM(Staff, Man);
    MAKEPART(R, Line, L_Math.ABS(_Cash.Saldo));
    INC(_CSum, L_Math.ABS(_Cash.Saldo));
    NEXT(_Cash);
   END;
   MAKEPART(R, CashBot, _CSum);
   INC(_TSum, _CSum);
   NEXTINEXTENDEDSEL(_Cash, _Cash);
  END; (* WHILE OCCURE(_Cash) ... *)
  MAKEPART(R, Bot, _TSum);
  IF NEXTINEXTENDEDSEL(_Cash, MyFirm) THEN
   FORMFEED(R);
  END;
 END; (* WHILE OCCURE(_Cash) ... *)

 CLOSEREP(R);
 L_AFM.AF_PurgeTemp("_Cash");
END.
