(*
%Copyright   (c) Polak IT
%Author      14.05.2010 21:21:00 POLAK\MLB
%Purpose     ஦ ࠭ᯮ ந⢨
%Type        control
%Specific    SYS
%Modified    08.09.2014 16:48:46 POLAK\Gina
%Environment
*)

 MODULE O_RAccid [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_AR, L_Str, L_DatTim, L_StdFrm, L_MSO,
        L_XDoc, L_ODoc, L_Staff, L_Man, P_Man, L_Car, P_Car, L_Way,
        P_OwnData, E_Prop, E_Way, Math, L_BegRWS, L_kn;

 PRIVATE PROCEDURE rap_Set_DailyMedSertDate(trgTSN: LIKE(Staff.TSN); trgRWayS: LIKE(RWayS.RWayS); D: DATE);
  VAR
   Result: STRING[];
   xdid  : L_XDoc.tXDocId;
   xdt   : L_XDoc.tXDocType;
   xdk   : L_XDoc.tXDocKind;
   xd    : L_XDoc.tXDoc;
 BEGIN
  TRY [TABLE_FILTER_MODE(TABLE_FILTER_MODE_OFF)]
   L_AR.GrantRightsUnconditionally();
   SETEMPTY(Result);
   SAVE(ODoc);
   SELECT(ODoc, TSN, , L_kn.Get(D, L_ODoc.erkn_MedicalExaminationAct), trgTSN);
   SRCINSEL(ODoc, LE, , D);
   WHILE OCCURE(ODoc) & !Result DO
    PROMPT(": " + ODoc.ODocKind + " " + ODoc.ODoc + " " + L_DatTim.DateStr(ODoc.SrcDate));
    xdid:=L_ODoc.curRefToXDoc_GetId();
    IF ~!xdid THEN
     L_XDoc.DecodeXDocId(xdid, xdt, xdk, xd);
     IF (xd = trgRWayS) & (L_ODoc.amo_Type() = L_ODoc.amot_First) THEN
      Result:=L_DatTim.DateStr(ODoc.SrcDate);
     END;
    END;
    PREV(ODoc);
   END; (* WHILE OCCURE(ODoc) ...*)
   RESTORE(ODoc);
   IF !Result THEN
    Result:=" 室";
   END;
  EXCEPT
  END;
  L_MSO.wordSetVar("RAccid.Staff.DailyMedSertDate", Result);
 END {rap_Set_DailyMedSertDate};

 PRIVATE PROCEDURE rap_Set_PrevChangeInfo();
  VAR
   curD      : DATE;
   prvD      : DATE;
   HourInPrvD: NUMERIC[3];
 BEGIN
  curD      :=RWayS.Date;
  HourInPrvD:=0;
  SAVE(Route);
  SAVE(RWayS);
  CHANGESEL(RWayS, TSN, , RWayS.TSN);
  WHILE OCCURE(RWayS) & (RWayS.Date = curD) (**) DO
   PREV(RWayS);
  END;
  IF OCCURE(RWayS) THEN
   prvD:=RWayS.Date;
  ELSE
   SETEMPTY(prvD);
  END;
  WHILE OCCURE(RWayS) & (RWayS.Date = prvD) (*।*) DO
   SELECT(RWayJ, RWayS, , RWayS.RWayS);
   WHILE OCCURE(RWayJ) DO
    CONFORM(RWayJ, SEJobs, Route);
    CONFORM(SEJobs, WJMode);
    IF WJMode.WJType = L_Way.WJType_Work THEN
     INC(HourInPrvD, L_DatTim.GetVARIANTDATEPeriod_Hour(L_DatTim.GetVARIANTDATE(RWayS.Date, RWayJ.StartT, 00),
                                                        L_DatTim.GetVARIANTDATE(RWayS.Date, RWayJ.StopT,  00)));
    END;
    NEXT(RWayJ);
   END; (* WHILE OCCURE(RWayJ) ... *)
   PREV(RWayS);
  END;
  RESTORE(RWayS);
  RESTORE(Route);
  L_MSO.wordSetVar("RAccid.Staff.Per_HourInPrevChange", FLDTOSTR(HourInPrvD, "0") + " ᮢ (" + L_DatTim.DateStr(prvD) + ")");
 END {rap_Set_PrevChangeInfo};

 PRIVATE PROCEDURE rap_Set_PrevRAccidInfo(D: DATE; Prefix: STRING[]);
  VAR
   curRWayS : LIKE(RAccid.XDocId);
   CntRAccid: NUMERIC[0];
 BEGIN
  curRWayS:=RAccid.RWayS;
  SETZERO(CntRAccid);
  SAVE(Staff);
  SELECT(Staff, Man, , Man.Man);
  WHILE OCCURE(Staff) DO
   SAVE(RWayS);
   SELECT(RWayS, TSN, , Staff.TSN);
   SRCINSEL(RWayS, LE, , D);
   WHILE OCCURE(RWayS) DO
    IF RWayS.RWayS # curRWayS THEN
     SAVE(RAccid);
     SELECT(RAccid, RWayS, , RWayS.RWayS);
     WHILE OCCURE(RAccid) DO
      INC(CntRAccid);
      NEXT(RAccid);
     END; (* WHILE OCCURE(RAccid) ... *)
     RESTORE(RAccid);
    END;
    PREV(RWayS);
   END; (* WHILE OCCURE(RWayS) ... *)
   RESTORE(RWayS);
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  RESTORE(Staff);
  L_MSO.wordSetVar(Prefix + "CountRAccid", L_Str.IntStr(CntRAccid));
 END {rap_Set_PrevRAccidInfo};

 PRIVATE PROCEDURE StaffName(trgTSN: LIKE(Staff.TSN)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   SEARCH(Staff, TSN, , trgTSN);
   CONFORM(Staff, Man);
   Result:=Man.Name;
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {StaffName};

 PRIVATE PROCEDURE StaffPostName(trgTSN: LIKE(Staff.TSN); D: DATE): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SAVE(Staff);
  SAVE(StaffLog);
  SAVE(Post);
  L_General.CallUs(SEARCH(Staff, TSN, trgTSN));
  L_Staff.PosToStaffLog(trgTSN, D, 1);
  CONFORM(StaffLog, Officer, Post);
  Result:=Post.Name;
  RESTORE(Post);
  RESTORE(StaffLog);
  RESTORE(Staff);
  RETURN Result;
 END {StaffPostName};

 PRIVATE PROCEDURE rap_Set_ComissVars(D: DATE);
  VAR
   Prefix,
   CurPrefix,
   Commiss,
   OrderOfCommission: STRING[];
   CntCommissMemb   : NUMERIC[0];
   CommMembIdx      : SCAL[P_OwnData.CommissMembersAmnt];
   Chairman         : LIKE(Staff.TSN);
   Members          : LIKE(Staff.TSN)[P_OwnData.CommissMembersAmnt];
 BEGIN
  Prefix :="Commission.";
  Commiss:=P_OwnData.GetOwnDProStrong(D, P_OwnData.P_RAccidCommiss);
  P_OwnData.Decode_Commiss(Commiss, Chairman, Members, OrderOfCommission);
  L_MSO.wordSetVar(Prefix + "Order",              OrderOfCommission);
  L_MSO.wordSetVar(Prefix + "Chairman.Name",      StaffName (Chairman));
  L_MSO.wordSetVar(Prefix + "Chairman.Post.Name", StaffPostName(Chairman, D));
  CntCommissMemb:=0;
  FOR_EACH CommMembIdx DO
   IF ~!Members[CommMembIdx] THEN
    INC(CntCommissMemb);
    CurPrefix:="Commission.Member" + L_MSO.IndexStr(CntCommissMemb-1) + ".";
    L_MSO.wordSetVar(CurPrefix + "Name",      StaffName (Members[CommMembIdx]));
    L_MSO.wordSetVar(CurPrefix + "Post.Name", StaffPostName(Members[CommMembIdx], D));
   END;
  END;
  L_MSO.SetWordTable("MembersOfCommission", CntCommissMemb);
  L_MSO.SetWordTable("SignOfCommission",    CntCommissMemb);
 END {rap_Set_ComissVars};

 PRIVATE PROCEDURE FillManStageInCar(    D        : DATE;
                                         trgMan   : LIKE(Man.Man);
                                         trgBoxNbr: LIKE(Car.BoxNbr);
                                     VAR Days     : NUMERIC[0];
                                     VAR Months   : NUMERIC[0];
                                     VAR Years    : NUMERIC[0]);
  VAR
   EndD: DATE;
 BEGIN
  SETZERO(Days, Months, Years);
  SAVE(Staff);
  SELECT(Staff, Man, , trgMan);
  WHILE OCCURE(Staff) DO
   SELECT(MCFix, BoxNbr, , trgBoxNbr, Staff.TSN);
   WHILE OCCURE(MCFix) & (MCFix.Begin <= D) DO
    PROMPT(" ⠦   " + trgBoxNbr + "  " + Staff.TSN + " " + L_DatTim.DateStr(MCFix.Begin));
    IF     MCFix.Dschrg < MCFix.Till THEN
     EndD:=MCFix.Dschrg;
    ELSIF MCFix.Till < D THEN
     EndD:=MCFix.Till;
    ELSE
     EndD:=D;
    END;
    INC(Days, EndD - MCFix.Begin + 1);
    NEXT(MCFix);
   END; (* WHILE OCCURE(MCFix) ... *)
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  RESTORE(Staff);
  L_DatTim.NormalizeDMY(Days, Months, Years);
 END {FillManStageInCar};

 PRIVATE PROCEDURE rap_Set_StageVars(D: DATE; Prefix: STRING[]);
  VAR
   DaysDriver,    MonthsDriver,   YearsDriver,
   DaysDrInFirm,  MonthsDrInFirm, YearsDrInFirm,
   DaysInCar,     MonthsInCar,    YearsInCar    : NUMERIC[0];
   dummy1, dummy2                               : NUMERIC[6];
 BEGIN
  L_Man.FillStageDriver(D,
                        DaysDriver,   MonthsDriver,   YearsDriver,
                        DaysDrInFirm, MonthsDrInFirm, YearsDrInFirm,
                        dummy1, dummy2);
  FillManStageInCar(D, Man.Man, RWayS.BoxNbr, DaysInCar, MonthsInCar, YearsInCar);
  L_MSO.wordSetVar(Prefix + "StageDriver",   L_Str.DMY_asStr(DaysDriver,   MonthsDriver,   YearsDriver));
  L_MSO.wordSetVar(Prefix + "StageDrInFirm", L_Str.DMY_asStr(DaysDrInFirm, MonthsDrInFirm, YearsDrInFirm));
  L_MSO.wordSetVar(Prefix + "StageInCar",    L_Str.DMY_asStr(DaysInCar,    MonthsInCar,    YearsInCar));
 END {rap_Set_StageVars};

 PRIVATE PROCEDURE rap_Set_OtherMembVars(D: DATE);
  VAR
   CntMans,
   CntCars,
   CntMansDied,
   CntMansInj : NUMERIC[0];
   Prefix,
   CurPrefix  : STRING[];
 BEGIN
  Prefix:="RAccid.OtherMemb.";
  SETZERO(CntMans, CntCars, CntMansDied, CntMansInj);
  SELECT(RAMemb, RAccid, , RAccid.XDocId);
  WHILE OCCURE(RAMemb) DO
   IF RAMemb.Type = L_ODoc.t_Car THEN
    INC(CntCars);
    CurPrefix:=Prefix + "Car" + L_MSO.IndexStr(CntCars-1) + ".";
    L_MSO.wordSetVar(CurPrefix + "Name",        RAMemb.Name);
    L_MSO.wordSetVar(CurPrefix + "Owner",       RAMemb.Owner);
    SAVE(RAMemb);
    IF L_ODoc.ram_StandOnDriver() THEN
     L_MSO.wordSetVar(CurPrefix + "Driver.Name", RAMemb.Name);
     IF ~!RAMemb.CrtD THEN
      L_MSO.wordSetVar(CurPrefix + "Driver.Age",  L_Str.IntStr(L_DatTim.CompleteYearsInIntvl(RAMemb.CrtD, D-1)));
     ELSE
      L_MSO.wordSetVar(CurPrefix + "Driver.Age",  "");
     END;
    ELSE
     L_MSO.wordSetVar(CurPrefix + "Driver.Name", "");
     L_MSO.wordSetVar(CurPrefix + "Driver.Age",  "");
    END;
    RESTORE(RAMemb);
   ELSIF RAMemb.Dmg # L_ODoc.d_NoInjuries THEN
    INC(CntMans);
    CurPrefix:=Prefix + "Man" + L_MSO.IndexStr(CntMans-1) + ".";
    L_MSO.wordSetVar(CurPrefix + "Name",   RAMemb.Name);
    L_MSO.wordSetVar(CurPrefix + "DmgStr", RAMemb.DmgStr);
    L_MSO.wordSetVar(CurPrefix + "Num",    L_Str.IntStr(CntMans));
    IF ~!RAMemb.CrtD THEN
     L_MSO.wordSetVar(CurPrefix + "Age",    L_Str.IntStr(L_DatTim.CompleteYearsInIntvl(RAMemb.CrtD, D-1)));
    ELSE
     L_MSO.wordSetVar(CurPrefix + "Age",    "");
    END;
    L_MSO.wordSetVar(CurPrefix + "Conseq", L_Str.PoolItem(L_ODoc.dm_Pool, RAMemb.Dmg) + ",");
    L_MSO.wordSetVar(CurPrefix + "Type",   L_Str.PoolItem(L_ODoc.w_Pool,  RAMemb.Who));
    IF    RAMemb.Dmg = L_ODoc.d_YesInjuries THEN
     INC(CntMansInj);
    ELSIF RAMemb.Dmg = L_ODoc.d_Death       THEN
     INC(CntMansDied);
    END;
   END;
   NEXT(RAMemb);
  END; (* WHILE OCCURE(RAMemb) ... *)

  L_MSO.SetWordTable("Mans", CntMans);
  L_MSO.SetWordTable("Cars", CntCars);
 
  L_MSO.wordSetVar(Prefix + "CountDied",    L_Str.IntStr(CntMansDied));
  L_MSO.wordSetVar(Prefix + "CountInjures", L_Str.IntStr(CntMansInj));
 END {rap_Set_OtherMembVars};

 PRIVATE PROCEDURE rap_Set_TrainingVars(D: DATE; Prefix: STRING[]);
  VAR
   strRoute, strMark: STRING[];
   datRoute, datMark: DATE;
 BEGIN
  IF OCCURE(Route) THEN
   datRoute:=L_BegRWS.GetPermit2RouteDate(D, Staff.TSN, Route.Route);
   IF ~!datRoute THEN strRoute:=L_DatTim.DateStr(datRoute);
   ELSE               strRoute:=" 室";
   END;
   datMark:=L_BegRWS.GetPermit2MarkGDate(D, Staff.TSN, L_Way.GetMarkG_Soft(Mark.Mark, L_Way.mgt_AccessDriving));
   IF ~!datMark THEN strMark:=L_DatTim.DateStr(datMark);
   ELSE              strMark:=" 室";
   END;
  ELSE
   strRoute:=" 㤠 ।";
   strMark :=" 㤠 ।";
  END;
  L_MSO.wordSetVar(Prefix + "TrainingRoute", strRoute);
  L_MSO.wordSetVar(Prefix + "TrainingMark",  strMark);
 END {rap_Set_TrainingVars};

 PRIVATE PROCEDURE rap_Set_RprDAVars(D: DATE; Prefix: STRING[]);
  VAR
   TO2Date    : DATE;
   TO2RepEvent: LIKE(RepEvent.RepEvent);
 BEGIN
  SETEMPTY(TO2Date);
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   TO2RepEvent:=E_Way.re_TO2;
   TO2Date    :=L_Car.GetStartDLastRepEvent(Car.BoxNbr, TO2RepEvent, D);
  EXCEPT
  ON Exc: Exc_Syntax DO
   IF Exc.ErrorCode # L_General.ec_rt_UnknownIdentifier THEN
    RAISE();
   END;
  ELSE
   RAISE();
  END;
  IF ~!TO2Date THEN
   L_MSO.wordSetDateVar(Prefix + "TO2Date", TO2Date);
  ELSE
   L_MSO.wordSetVar    (Prefix + "TO2Date", " ஢");
  END;
 END {rap_Set_RprDAVars};

 PRIVATE PROCEDURE rap_Set_DrivingBanVars(D: DATE; Prefix: STRING[]);
  VAR
   DrivingBanStr : STRING[];
 BEGIN
  SETEMPTY(DrivingBanStr);
  SELECT(ManPro, Man, , Man.Man, P_Man.P_DriveSertification);
  SRCINSEL(ManPro, LE, , D);
  WHILE OCCURE(ManPro) & !DrivingBanStr DO
   IF !P_Man.GetCurDriveSertification_NewStyleCategory() THEN
    DrivingBanStr :="襭  ᭮ 㬥";
    IF ~!ManPro.DocSer | ~!ManPro.DocNum THEN
     INC(DrivingBanStr, "  " + ManPro.DocSer + " " + ManPro.DocNum);
    END;
    IF ~!ManPro.DocGiveS | ~!ManPro.DocGiveD THEN
     INC(DrivingBanStr, " 뤠");
     IF ~!ManPro.DocGiveS THEN
      INC(DrivingBanStr, " " + ManPro.DocGiveS);
     END;
     IF ~!ManPro.DocGiveD THEN
      INC(DrivingBanStr, " " + L_DatTim.DateStr(ManPro.DocGiveD));
     END;
    END;
    IF ~!ManPro.DocExpD THEN
     INC(DrivingBanStr, ". ப 襭  " + L_DatTim.DateStr(ManPro.DocExpD));
    END;
   END;
   PREV(ManPro);
  END; (* WHILE OCCURE(ManPro) ... *)
  IF !DrivingBanStr THEN
   DrivingBanStr:=" 蠫";
  END;
  L_MSO.wordSetVar(Prefix + "DrivingBan", DrivingBanStr);
 END {rap_Set_DrivingBanVars};

 PRIVATE PROCEDURE rap_Set_CarVars(D: DATE);
  VAR
   Prefix: STRING[];
 BEGIN
  Prefix:="RAccid.Car.";
  CONFORM(RWayS, Car);
  L_MSO.wordSetDateVar(Prefix + "ProdDate", L_Car.GetCarProdDate(Car.BoxNbr, D));
  L_MSO.wordSetVar    (Prefix + "StateNbr", Car.StateNbr);
  L_MSO.wordSetVar    (Prefix + "Run",      L_Str.NumericStr(L_Car.GetGlobalRun(Car.BoxNbr, D), 2));
  IF P_Car.HasActualCarPro(Car.BoxNbr, D, P_Car.P_CLI_Obligatory) THEN
   L_MSO.wordSetVar(Prefix + "CLI_Obligatory.DocNum", CarPro.DocNum);
  ELSE
   L_MSO.wordSetVar(Prefix + "CLI_Obligatory.DocNum", "");
  END;
  IF P_Car.HasActualCarPro(Car.BoxNbr, D, P_Car.P_CarLicenCard) THEN
   L_MSO.wordSetVar(Prefix + "LicenCard", CarPro.Value);
  ELSE
   L_MSO.wordSetVar(Prefix + "LicenCard", "");
  END;
  rap_Set_RprDAVars(D, Prefix);

  Prefix:="RAccid.Car.Mark.";
  L_Car.AccessMark(Car.BoxNbr, D);
  L_MSO.wordSetVar(Prefix + "Name",   Mark.Name);
 END {rap_Set_CarVars};

 PRIVATE PROCEDURE rap_Set_RouteVars(D: DATE);
  VAR
   Prefix: STRING[];
 BEGIN
  Prefix:="RAccid.Route.";
  L_ODoc.StandOnRWayJByCurRAccid(1);
  IF OCCURE(RWayJ) THEN
   CONFORM(RWayJ, SEJobs, Route);
   L_Way.StandOnRouteTKind(D);
   L_MSO.wordSetVar(Prefix + "Route",      Route.Route);
   L_MSO.wordSetVar(Prefix + "Name",       Route.Name);
   L_MSO.wordSetVar(Prefix + "TKind.Name", TKind.Name);
  ELSE
   L_General.CLEAR("Route");
   L_MSO.wordSetVar(Prefix + "Route",      "---");
   L_MSO.wordSetVar(Prefix + "Name",       "---");
   L_MSO.wordSetVar(Prefix + "TKind.Name", "---");
  END;
 END {rap_Set_RouteVars};

 PRIVATE PROCEDURE rap_Set_StaffVars(D: DATE);
  VAR
   Prefix : STRING[];
   acdTime,
   endTime: TIMESTAMP;
   Length : NUMERIC[3];
 BEGIN
  Prefix:="RAccid.Staff.";
  CONFORM(RWayS, Staff);
  L_Staff.PosToStaffLog(Staff.TSN, D, 1);
  L_MSO.wordSetVar(Prefix + "StaffLog.Class", StaffLog.Class);
  acdTime:=L_DatTim.GetTIMESTAMP(D, RAccid.Time);
  Length:=0;
  SELECT(RWayJ, RWayS, , RWayS.RWayS);
  WHILE OCCURE(RWayJ) DO
   endTime:=Math.Min(acdTime, L_DatTim.GetTIMESTAMP(RWayS.Date+RWayJ.Day+(RWayJ.StopT < RWayJ.StartT)-1, RWayJ.StopT));
   CONFORM(RWayJ, WJMode);
   IF WJMode.WJType # L_Way.WJType_Void THEN
    INC(Length, endTime - L_DatTim.GetTIMESTAMP(RWayS.Date+RWayJ.Day-1, RWayJ.StartT));
   END;
   IF endTime = acdTime THEN
    LAST(RWayJ);
   END;
   NEXT(RWayJ);
  END; (* WHILE OCCURE(RWayJ) *)
  L_MSO.wordSetVar(Prefix + "Per_Hour", FLDTOSTR(Length * 24, "0"));
  rap_Set_PrevChangeInfo();
  rap_Set_DailyMedSertDate(Staff.TSN, RWayS.RWayS, D);
 END {rap_Set_StaffVars};

 PRIVATE PROCEDURE rap_Set_ManVars(D: DATE);
  VAR
   ds_DocNum,
   ds_Category,
   cli_DocNum,
   GroupRisk,
   LifeSafety,
   TrafficRules,
   PerMedSertDate,
   PerMedSertExpD,
   Prefix        : STRING[];
   cli_Prop      : LIKE(Property.Property);
 BEGIN
  CONFORM(Staff, Man);
  IF P_Man.HasActualManPro(Man.Man, D, P_Man.P_DriveSertification) THEN
   ds_DocNum  :=ManPro.DocNum;
   ds_Category:=P_Man.GetDriveSertification_Category(Man.Man, D);
  ELSE
   ds_DocNum  :="";
   ds_Category:="";
  END;
  SETEMPTY(cli_Prop);
  cli_DocNum:="";
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   cli_Prop:=E_Prop.P_CivilLiabilityInsurance;
  EXCEPT
  ON Exc: Exc_Syntax DO
   IF Exc.ErrorCode # L_General.ec_rt_UnknownIdentifier THEN
    RAISE();
   END;
  ELSE
   RAISE();
  END;
  IF ~!cli_Prop THEN
   IF P_Man.HasActualManPro(Man.Man, D, cli_Prop) THEN
    cli_DocNum:=ManPro.DocNum;
    IF ~!ManPro.DocExpD THEN
     cli_DocNum:=cli_DocNum + ",  " + L_DatTim.DateStr(ManPro.DocExpD);
    END;
   END;
  END;
  IF P_Man.HasActualManPro(Man.Man, D, P_Man.P_MedicalSertification) THEN
   PerMedSertDate:=L_DatTim.DateStr(ManPro.DocGiveD);
   IF ~!ManPro.DocExpD THEN
    PerMedSertExpD:=L_DatTim.DateStr(ManPro.DocExpD);
   ELSE
    SETEMPTY(PerMedSertExpD);
   END;
  ELSE
   PerMedSertDate:=" 室";
   SETEMPTY(PerMedSertExpD);
  END;
  IF P_Man.InRiskGroup(Man.Man, D, 1) THEN
   GroupRisk:="";
  ELSE
   GroupRisk:="";
  END;
  IF  !RAccid.DatInsLS THEN
   LifeSafety:=" 室";
  ELSE
   LifeSafety:=L_DatTim.DateStr(RAccid.DatInsLS);
  END;
  IF !RAccid.DatInsRR THEN
   TrafficRules:=" 室";
  ELSE
   TrafficRules:=L_DatTim.DateStr(RAccid.DatInsRR);
  END;

  Prefix:="RAccid.Staff.Man.";
  L_MSO.wordSetVar(Prefix + "DriveSertification.DocNum",      ds_DocNum);
  L_MSO.wordSetVar(Prefix + "DriveSertification.Category",    ds_Category);
  L_MSO.wordSetVar(Prefix + "CivilLiabilityInsurance.DocNum", cli_DocNum);
  L_MSO.wordSetVar(Prefix + "Name",                           Man.Name);
  L_MSO.wordSetVar(Prefix + "Birth",                          FLDTOSTR(Man.Birth, "y"));
  L_MSO.wordSetVar(Prefix + "PerMedSertDate",                 PerMedSertDate);
  L_MSO.wordSetVar(Prefix + "PerMedSertExpD",                 PerMedSertExpD);
  L_MSO.wordSetVar(Prefix + "GroupRisk",                      GroupRisk);
  L_MSO.wordSetVar(Prefix + "LifeSafety",                     LifeSafety);
  L_MSO.wordSetVar(Prefix + "TrafficRules",                   TrafficRules);
  L_MSO.wordSetVar(Prefix + "CountViolat",                    "   ஥");
  rap_Set_DrivingBanVars(D, Prefix);
  rap_Set_TrainingVars  (D, Prefix);
  rap_Set_StageVars     (D, Prefix);
  rap_Set_PrevRAccidInfo(D, Prefix);
 END {rap_Set_ManVars};

 PRIVATE PROCEDURE rap_Set_RWaySVars();
  VAR
   Prefix: STRING[];
 BEGIN
  Prefix:="RAccid.RWayS.";
  CONFORM(RAccid, RWayS);
  L_MSO.wordSetVar    (Prefix + "RWayS", RWayS.RWayS);
  L_MSO.wordSetDateVar(Prefix + "Date",  RWayS.Date);
 END {rap_Set_RWaySVars};

 PRIVATE PROCEDURE rap_Set_RAccidVars(D: DATE);
  VAR
   NumViolat: NUMERIC[0];
   VilIdx   : SCAL[L_ODoc.CntViolat];
   Violat   : STRING[][L_ODoc.CntViolat];
   HasViolat: SCAL[2];
   Prefix   : STRING[];
 BEGIN
  Prefix:="RAccid.Violat";
  L_ODoc.Decode_Violat(RAccid.Violat, Violat);
  NumViolat:=0;
  FOR_EACH VilIdx DO
   IF ~!Violat[VilIdx] THEN
    L_MSO.wordSetVar(Prefix + L_MSO.IndexStr(NumViolat), L_Str.IntStr(NumViolat+1) + " " + Violat[VilIdx]);
    INC(NumViolat);
   END;
  END;
  L_MSO.SetWordTable("Violat", NumViolat);
  HasViolat:=NumViolat > 0;

  CONFORM(RAccid, RWayS);
  CONFORM(RWayS, Car);
  L_Car.AccessMark(Car.BoxNbr, D);
  CONFORM(RWayS, Staff);
  CONFORM(Staff, Man);

  Prefix:="RAccid.";
  L_MSO.wordSetDateVar (Prefix + "Date",         D);
  L_MSO.wordSetVar     (Prefix + "TimeStamp",    FLDTOSTR(L_DatTim.GetTIMESTAMP(D, RAccid.Time), "D.N.y.  H:M"));
  L_MSO.wordSetVar     (Prefix + "Place",        RAccid.Place);
  L_MSO.wordSetVar     (Prefix + "Descr",        RAccid.Descr);
  L_MSO.wordSetVar     (Prefix + "Explanat",     RAccid.Explanat);
  L_MSO.wordSetMoneyVar(Prefix + "TotalDmg",  D, RAccid.TotDmgS);
  L_MSO.wordSetMoneyVar(Prefix + "DmgSum",    D, RAccid.OurDmgS);
  L_MSO.wordSetVar     (Prefix + "Intoxic",      L_Str.PoolItem(L_ODoc.i_pool, RAccid.Intoxic));
  L_MSO.wordSetVar     (Prefix + "Kind",         L_Str.PoolItem(L_ODoc.k_pool, RAccid.Kind));
  L_MSO.wordSetVar     (Prefix + "CntPass",      L_Str.IntStr(RAccid.CntPass));
  L_MSO.wordSetVar     (Prefix + "FaultDrv",     L_Str.PoolItem(" |", HasViolat));
  L_MSO.wordSetVar     (Prefix + "Summary",      "   ⥫ \ " + Mark.Name + " " + Man.Name + " " + L_Str.PoolItem("  蠫|訫 ", HasViolat));
  L_MSO.wordSetVar     (Prefix + "Offers",       " 裡  " + L_Str.PoolItem("⢨|稥", HasViolat) + "  ⢨ ⥫ " + Man.Name + " 襭  " + L_Str.PoolItem(" ⢥⢥   ਢ|ਢ   ⢥⢥", HasViolat));
 END {rap_Set_RAccidVars};

 PRIVATE PROCEDURE rap_Set_ODocVars();
  VAR
   Prefix: STRING[];
 BEGIN
  Prefix:="ODoc.";
  L_MSO.wordSetDateVar(Prefix + "SrcDate", ODoc.SrcDate);
  L_MSO.wordSetVar    (Prefix + "Nbr",     ODoc.SrcNbr);
 END {rap_Set_ODocVars};

 PRIVATE PROCEDURE RAccid1Prep(D: DATE);
 BEGIN
  rap_Set_ODocVars();
  rap_Set_ComissVars(D);
  rap_Set_RAccidVars(D);
  rap_Set_RWaySVars();
  rap_Set_CarVars(D);
  rap_Set_RouteVars(D);
  rap_Set_OtherMembVars(D);
  rap_Set_StaffVars(D);
  rap_Set_ManVars(D);
  IF L_XDoc.xdf_StandOnActual(RAccid.XDocId, L_XDoc.xdfk_SchemaRA) THEN
   L_MSO.wordSetPic("Scheme", L_XDoc.xdf_GetFullFileName(), 160, -1);
  END;
 END {RAccid1Prep};

 PUBLIC PROCEDURE MakeDoc(TemplateName: STRING[]; PrepareMode: L_MSO.PrpModeType);
 BEGIN
  L_General.CallUs(SEARCH(RAccid, XDocId, ODoc.XDocId));
  L_General.Assert(ODoc.Status # L_ODoc.ods_Canceled, "㬥 㫨஢");
  IF ODoc.Status = L_ODoc.ods_Prepared THEN
   L_StdFrm.Question("㬥 室  ﭨ '⮢'.    묨");
  END;
  RAccid1Prep(ODoc.Date);
 END {MakeDoc};

END.
