(*
%Copyright   (c) Polak IT
%Author      06.06.2007 11:45:34 POLAK\GAV
%Purpose
%Type        control,report,temporary,convertor,operation,library,to paste
%Specific    SYS
%Modified    10.04.2012 12:25:25 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_Events, L_General, L_Pool, L_DatTim;

 PRIVATE PROCEDURE Pool_OnBeforeEdit();
 BEGIN
  L_General.Assert(ACCESS(Pool), " ⠭ ⥪騩 ᯨ᮪ ப 祭");
  L_General.CheckRightsByMEMBEROF("", Pool.Rights);
 END {Pool_OnBeforeEdit};

 PRIVATE PROCEDURE Pool_OnBeforeInsert();
 BEGIN
  L_General.Error("⠢ 饭");
 END {Pool_OnBeforeEdit};

 PRIVATE PROCEDURE Pool_OnBeforeDelete();
 BEGIN
  L_General.Error(" 饭");
 END {Pool_OnBeforeEdit};

 PRIVATE PROCEDURE PoolVal_OnAfterEdIns();
  VAR
   _Begin: LIKE(PoolVal.Begin);
   _Till : LIKE(PoolVal.Till);
   Count : NUMERIC[0];
 BEGIN
  L_General.Assert(PoolVal.Begin <= Pool.Till, "砫 ⢨  砭?");
  L_Pool.SetShortVal();
  REPLACE(PoolVal);
  IF Pool.Single THEN
   _Begin:=PoolVal.Begin;
   _Till :=PoolVal.Till;
   CHANGESEL(PoolVal, PoolNbr, , PoolVal.Pool);
   Count:=0;
   WHILE OCCURE(PoolVal) DO
    INC(Count, L_DatTim.IsActiveInIntvl(_Begin, _Till, PoolVal.Begin, PoolVal.Till));
    NEXT(PoolVal);
   END; (* WHILE OCCURE(PoolVal) ... *)
   L_General.Assert(Count = 1, "ਮ ⢨ ᥪ  ਮ ⢨ 㣮 祭");
  END;
 END {PoolVal_OnAfterEdIns};

 PRIVATE PROCEDURE PoolVal_OnAfterEdit();
 BEGIN
  PoolVal_OnAfterEdIns();
 END {PoolVal_OnAfterEdit};

 PRIVATE PROCEDURE PoolVal_OnAfterInsert();
 BEGIN
  PoolVal_OnAfterEdIns();
 END {PoolVal_OnAfterInsert};

BEGIN
 IF L_Events.IsInternalEvents(MODE) THEN
  ^(L_Events.GetInternalEventHandlerName(MODE))();
 ELSE
  L_General.BadMode(MODE);
 END;

END.