(*
%Copyright   (c) Polak Computer System
%Author      27.11.1995 18:15:19 SAN
%Purpose     ନ஢ ਪ  ᫥ 13- ௫
%Type        operation
%Specific    AP_PT
%Modified    07.07.2014 11:41:50 POLAK\GAV
%Environment
*)

 MODULE Prp13 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_OwnData, L_Staff, L_AFM, L_Man, L_EC, L_Money,
        Memo, E_Utils, L_Env, L_EDO, L_PRoll, Math;

 CONST
  RepNG = "God13";
  RepNB = "Bad13";

 VAR
  From,
  UpTo,
  IsBg,
  NoLv,
  OutP    : DATE;
  Prc,
  _Value  : NUMERIC[2];
  TotMan,
  _TotMan : NUMERIC[0][2];
  TotSal,
  MldSal,
  _TotSal,
  _MldSal : NUMERIC[2][2];
  ToPay,
  YrInc   : NUMERIC[2];
  _BegDate: LIKE(Staff.BegDate);
  Ind,
  GodCnt1,
  GodCnt2,
  BadCnt1,
  BadCnt2 : NUMERIC[0];

  Need,
  CheckAllConditions: SCAL[2];

(*
$P{Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
From, L, "N.y"
UpTo, L, "N.y"
From, L, "N.y"
UpTo, L, "N.y"
IsBg, L, "D.N.y"
NoLv, L, "D.N.y"
Prc, L, "2."
@
##########################################################################                                           ########## #####
=#####===============================================================================================================================
|###################################################################################################################################|
|                                                ⮣ ࠡ  #######  #######                                               |
|-----------------------------------------------------------------------------------------------------------------------------------|
| ந  ᯮ짮 ᫥  ( ஬) -  ᭮ ௫  ਮ :  #######  #######   |
|                                                                             ਭ            : ##########             |
|                                                                             㢮  ࠭            : ##########             |
|                                                                             業  ।筮 ࠡ⪠: #####           |
}

$P{Line:
Staff.TSN, L, ""
Man.Name, L, ""
Post.Name, L, ""
_Temp._BegD, L, "DNY"
_Temp._YInc, R, ",2-"
_Temp._TPay, R, ",2-"
(E_Prp13CommentLine(1)), L, ""
@
|##### ###########################|###################|######|###############|###############|######################################|
}

$P{DelGrp1:
_Temp._GrN1, L, ""
@
|===================================================================================================================================|
|##############################################                                                                                     |
}

$P{DelGrp2:
_Temp._GrN2, L, ""
@
|-----------------------------------------------------------------------------------------------------------------------------------|
| ##############################################                                                                                    |
}

$P{Del:
(E_Prp13CommentLine(0)), L, ""
@
|-----------------------------------------------------------------------------------------------------------------------------------|
|                           |          |ਥ |      ࠡ⮪|          㬬|######################################|
|---------------------------------|-------------------|------|---------------|---------------|--------------------------------------|
}

$P{_Grp2Bot:
_TotMan[Ind], R, "0"
_TotSal[Ind], R, ",2-"
_MldSal[Ind], R, ",2-"
@
|------------------------------------------------------------|---------------|---------------|--------------------------------------|
|⮣                                        #### ࠡ⭨|###############|###############|                                      |
}

$P{Bot1:
TotMan[1], R, "0"
TotSal[1], R, ",2-"
MldSal[1], R, ",2-"
@
|------------------------------------------------------------|---------------|---------------|--------------------------------------|
|⮣                                        #### ࠡ⭨|###############|###############|                                      |
=(c) Polak===========================================================================================================================
}

$P{Bot:
@
=(c) Polak===========================================================================================================================
}
*)

 PRIVATE PROCEDURE E_Prp13MoneyToInc(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(OutP, PROCREF(E_Utils.Prp13MoneyToInc), 0);
 END {E_Prp13MoneyToInc};

 PRIVATE PROCEDURE GetYearInc(): NUMERIC[2];
  VAR
   Sum: NUMERIC[2];
 BEGIN
  Sum:=0;
  SELECT(Money, TSN, , Staff.TSN);
  SRCINSEL(Money, GE, , Math.Max(L_Env.aptm_Start, From));
  WHILE OCCURE(Money) & (Money.Closed <= UpTo) DO
   PROMPT(Staff.TSN + " : " + L_DatTim.PeriodStr(Money.Closed));
   CONFORM(Money, MCList);
   IF ((MCList.MCTyp=0) & MCList.InSign[10]) |
      E_Prp13MoneyToInc() THEN
    INC(Sum, Money.Sum);
   END;
   NEXT(Money);
  END; (* WHILE OCCURE(Money) ... *)
  RETURN Sum;
 END {GetYearInc};

 PRIVATE PROCEDURE E_ForceInFOrder(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Utils.Prp13ForceInFOrder), 0);
 END {E_ForceInFOrder};

 PRIVATE PROCEDURE E_SpecialCond(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Utils.Prp13SpecialCond), 1);
 END {E_SpecialCond};

 PRIVATE PROCEDURE E_Prp13SortString(): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(OutP,
                                PROCREF(E_Utils.Prp13SortString), Man.Name);
 END {E_Prp13SortString};

 PRIVATE PROCEDURE E_Prp13Group1ForSort(): NUMERIC[0];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(OutP,
                                 PROCREF(E_Utils.Prp13Group1ForSort), Officer.Union);
 END {E_Prp13Group1ForSort};

 PRIVATE PROCEDURE E_Prp13GrpNm1ForSort(): STRING[];
 BEGIN
  SEARCH(Union, Union, , Officer.Union);
  RETURN L_EC.ExecE_Func_String(OutP,
                                PROCREF(E_Utils.Prp13GrpNm1ForSort), Union.Name);
 END {E_Prp13GrpNm1ForSort};

 PRIVATE PROCEDURE E_Prp13Group2ForSort(): NUMERIC[0];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(OutP,
                                 PROCREF(E_Utils.Prp13Group2ForSort), 0);
 END {E_Prp13Group2ForSort};

 PRIVATE PROCEDURE E_Prp13GrpNm2ForSort(): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(OutP,
                                PROCREF(E_Utils.Prp13GrpNm2ForSort), "");
 END {E_Prp13GrpNm2ForSort};

 PRIVATE PROCEDURE E_Prp13GetRealBegDate(): DATE;
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Utils.Prp13GetRealBegDate);
  IF ~!Local THEN
   RETURN Local(NoLv);
  ELSE
   RETURN L_Man.GetTakeOnDate(NoLv);
  END;
 END {E_Prp13GetRealBegDate};

 PRIVATE PROCEDURE E_Prp13SaveVariables();
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Utils.Prp13SaveVariables);
  IF ~!Local THEN
   Local(From, UpTo, IsBg, NoLv);
  END;
 END {E_Prp13SaveVariables};

 PRIVATE PROCEDURE E_Prp13GetPersonalCoef(): NUMERIC[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(OutP,
                                 PROCREF(E_Utils.Prp13GetPersonalCoef), 0.00);
 END {E_Prp13GetPersonalCoef};

 PRIVATE PROCEDURE E_Prp13CommentLine(What: SCAL[2]): STRING[38];
 BEGIN
  IF What THEN
   RETURN L_EC.ExecE_Func_String(OutP,
                                 PROCREF(E_Utils.Prp13CommentLine1), "");
  ELSE
   RETURN L_EC.ExecE_Func_String(OutP,
                                 PROCREF(E_Utils.Prp13CommentLine0), "ਬ砭");
  END;
 END {E_Prp13CommentLine};

 PRIVATE PROCEDURE Insprp13File(_ToPay: NUMERIC[2]; IsInFOrder: SCAL[2]);
 BEGIN
  _Temp._Grp1      :=E_Prp13Group1ForSort();
  _Temp._GrN1      :=E_Prp13GrpNm1ForSort();
  _Temp._Grp2      :=E_Prp13Group2ForSort();
  _Temp._GrN2      :=E_Prp13GrpNm2ForSort();
  _Temp._Name      :=E_Prp13SortString();
  _Temp._TSN       :=Staff.TSN;
  _Temp._YInc      :=YrInc;
  _Temp._TPay      :=_ToPay;
  _Temp._BegD      :=_BegDate;
  _Temp._IsInFOrder:=IsInFOrder;
  INSERT(_Temp);
 END {Insprp13File};

 PRIVATE PROCEDURE GetParms();
 BEGIN
  From:=L_DatTim.IncMonth(Memo.ud_mb(), -03);
  UpTo:=L_DatTim.IncMonth(Memo.ud_mb(), -01);
  IsBg:=L_DatTim.IncMonth(Memo.ud_mb(), -12);
  NoLv:=Memo.ud_me();
  OutP:=Memo.ud_mb();
  Prc :=25;
 END {GetParms};

 PRIVATE PROCEDURE E_Prp13NeedOfficer(D: DATE): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Utils.Prp13NeedOfficer);
  IF ~!Local THEN
   RETURN Local(D);
  ELSE
   RETURN (Staff.Contract = L_Staff.cnt_Basic) & (StaffLog.ContDTyp = L_Staff.cdt_Permanent);
  END;
 END {E_Prp13NeedOfficer};

 PRIVATE PROCEDURE IsLeaveByGoodReason(D: DATE): SCAL[2];
 BEGIN
  L_Staff.PosToStaffLog(Staff.TSN, D, 0);
  IF L_Staff.IsDischargeStaffLog() THEN
   CONFORM(StaffLog, SLKind);
   RETURN SLKind.IsGodRsn;
  END;
  RETURN 0;
 END {IsLeaveByGoodReason};

 PRIVATE PROCEDURE E_NeedLeavedStaff(D: DATE): SCAL[2];
  VAR
   Local  : PROC;
   Default: SCAL[2];
 BEGIN
  Default:=IsLeaveByGoodReason(D);
  Local:=PROCREF(E_Utils.Prp13NeedLeavedStaff);
  IF ~!Local THEN
   RETURN Local(D, Default);
  ELSE
   RETURN Default;
  END;
 END {E_NeedLeavedStaff};

 PRIVATE PROCEDURE ShowDialog();
  VAR
   local: PROC;
   FormS: STRING[];
 BEGIN
  CheckAllConditions:=1;
  FormS:="| " + L_DatTim.PeriodStr(OutP) + "  ᭮ ௫  %<N.y>I  %<N.y>I" +
         "||ਭ                        %<D.N.y>I" +
         "||  ࠭                        %<D.N.y>I" +
         "||業  ।筮 ࠡ⪠          %L5<2.>I";
  IF L_EC.ExecE_Func_Scal2(OutP, PROCREF(E_Utils.Prp13NeedChoiceForCheckAllConditions), 0) THEN
   STDFORM(FormS +
           "||%<⮫쪮  ⥫  '⠦'  6 |⮫쪮 ,  -ଠ쭮>I" +
           "||%< 믮 >DB          %< ⬥ >X",
           "ନ஢ ਪ  ⠫쭮 ࠦ",
           , -1, From, UpTo, IsBg, NoLv, Prc, CheckAllConditions);
  ELSE
   STDFORM(FormS +
           "||%< 믮 >DB          %< ⬥ >X",
           "ନ஢ ਪ  ⠫쭮 ࠦ",
           , -1, From, UpTo, IsBg, NoLv, Prc);
  END;
  local:=PROCREF(E_Utils.Prp13AddDialog);
  IF ~!local THEN
   local();
  END;
 END {ShowDialog};

 PUBLIC PROCEDURE Prp13();
 BEGIN
  GetParms();
  L_EDO.InitPrepareFOrder();
  L_General.Assert(FOrder.Closed = OutP, "᫥  " + L_DatTim.PeriodStr(OutP));
  L_General.Assert(FOrder.Type = L_PRoll.fot_BySum, "ਪ     㬬");
 
  ShowDialog();
 
  E_Prp13SaveVariables();
  FOrder.Sum:=0;
 
  SETZERO(TotMan, TotSal, MldSal);
 
  L_AFM.MakeIndex("_Temp", "_Grp1      : SCAL[1000000];"+
                           "_Grp2      : SCAL[1000000];"+
                           "_Name      : STRING[32];"+
                           "_TSN       : LIKE(Staff.TSN);"+
                           "_YInc      : NUMERIC[2];"+
                           "_TPay      : NUMERIC[2];"+
                           "_GrN1      : STRING[32];"+
                           "_GrN2      : STRING[32];"+
                           "_BegD      : DATE;"+
                           "_IsInFOrder: SCAL[2]");
 
  SELECT(Man, Man);
  WHILE OCCURE(Man) DO
   SELECT(Staff, Man, , Man.Man);
   WHILE OCCURE(Staff) DO
    PROMPT(Staff.TSN);
    IF (Staff.Contract # L_Staff.cnt_OutStaff) & L_Env.RealTSN(Staff.TSN) & L_Staff.InStateInPer(IsBg, NoLv) &
       (L_Staff.rInState(NoLv) | E_NeedLeavedStaff(NoLv)) THEN
     L_Staff.PosToStaffLog(Staff.TSN, L_DatTim.MonthEnd(OutP), 1);
     CONFORM(StaffLog, Officer);
     CONFORM(Officer, Post);
     IF E_Prp13NeedOfficer(OutP) THEN
      YrInc:=GetYearInc();
      ToPay:=L_Money.RoundMoney(OutP,
             YrInc*Prc/100/L_DatTim.MonthsInIntvl(From, L_DatTim.MonthEnd(UpTo)));
      _Value:=ToPay*(1+E_Prp13GetPersonalCoef()/100);
      _BegDate:=E_Prp13GetRealBegDate();
      Need:=((_BegDate <= IsBg) & (_Value > 0) & E_SpecialCond(_BegDate)) | E_ForceInFOrder(_BegDate);
      IF ~CheckAllConditions THEN
       Need:=~Need &
             L_Env.IsRouteDriver() & (L_Man.GetContractsLengthOfMan(Man.Man, From, NoLv, 0, 0) >= 183);
      END;
      IF Need THEN
       L_EDO.AppendFOrderL(0, _Value);
       INC(TotSal[1], YrInc);
       INC(MldSal[1], FOrderL.Value);
       INC(TotMan[1]);
       Insprp13File(ToPay, 1);
      ELSE
       INC(TotSal[0], YrInc);
       INC(TotMan[0]);
       Insprp13File(0, 0);
      END;
     END; (* IF E_Prp13NeedOfficer... *)
    END; (* L_Env.RealTSN ... *)
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff ... *)
   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)
 
  REPLACE(FOrder);
 
  OPENREP(B, L_General.NameConnection(RepNB + "_" + CheckAllConditions), Create);
  MAKEPART(B, Top, RepNB, "᮪ ࠡ⭨,  襤  ᯨ᮪  ࠦ");
 
  OPENREP(R, L_General.NameConnection(RepNG + "_" + CheckAllConditions), Create);
  MAKEPART(R, Top, RepNG, "᮪ ࠡ⭨  ࠦ");
 
  SELECT(_Temp, _Temp);
  WHILE OCCURE(_Temp) DO
   SETZERO(GodCnt1, BadCnt1);
   CHANGESEL(_Temp, _Temp, , _Temp._Grp1);
   WHILE OCCURE(_Temp) DO
    SETZERO(GodCnt2, BadCnt2, _TotSal, _MldSal, _TotMan);
    CHANGESEL(_Temp, _Temp, , _Temp._Grp1, _Temp._Grp2);
    WHILE OCCURE(_Temp) DO
     PROMPT(" " + _Temp._TSN);
     SEARCH(Staff, TSN, , _Temp._TSN);
     L_Staff.PosToStaffLog(Staff.TSN, L_DatTim.MonthEnd(OutP), 1);
     CONFORM(Staff, Man);
     CONFORM(StaffLog, Post);
     IF ~_Temp._IsInFOrder THEN
      Ind:=0;
      IF BadCnt1 = 0 THEN
       MAKEPART(B, DelGrp1);
      END;
      IF BadCnt2 = 0 THEN
       IF ~!_Temp._GrN2 THEN
        MAKEPART(B, DelGrp2);
       END;
       MAKEPART(B, Del);
      END;
      MAKEPART(B, Line);
      INC(BadCnt1);
      INC(BadCnt2);
     ELSE
      Ind:=1;
      IF GodCnt1 = 0 THEN
       MAKEPART(R, DelGrp1);
      END;
      IF GodCnt2 = 0 THEN
       IF ~!_Temp._GrN2 THEN
        MAKEPART(R, DelGrp2);
       END;
       MAKEPART(R, Del);
      END;
      MAKEPART(R, Line);
      INC(GodCnt1);
      INC(GodCnt2);
     END;
     INC(_TotSal[Ind], _Temp._YInc);
     INC(_MldSal[Ind], _Temp._TPay);
     INC(_TotMan[Ind]);
     NEXT(_Temp);
    END; (* WHILE OCCURE(_Temp) ... *)
    IF GodCnt2 > 0 THEN
     Ind:=1;
     MAKEPART(R, _Grp2Bot);
    END;
    IF BadCnt2 > 0 THEN
     Ind:=0;
     MAKEPART(B, _Grp2Bot);
    END;
    LAST(_Temp);
    CHANGESEL(_Temp, _Temp, , _Temp._Grp1);
    NEXT(_Temp);
   END; (* WHILE OCCURE(_Temp) ... *)
   LAST(_Temp);
   CHANGESEL(_Temp, _Temp);
   NEXT(_Temp);
  END; (* WHILE OCCURE(_Temp) ... *)
  MAKEPART(R, Bot1);
  MAKEPART(B, Bot);
 
  CLOSEREP(R);
  CLOSEREP(B);
 
  L_AFM.AF_PurgeTemp("_Temp");
 
  LIKEMENU(Survey, L_General.NameConnection(RepNB + "_" + CheckAllConditions),
           Survey, L_General.NameConnection(RepNG + "_" + CheckAllConditions));
 END {Prp13};

END.
