(*
%Copyright   (c) Polak Computer System
%Author      17.11.1997 10:44:23 GINA
%Purpose     । ᫥ ࠡ⭨  ࠧࠬ ௫
%Type        report
%Specific    SYS
%Modified    25.08.2014 18:52:07 POLAK\Gina
%Environment
*)

 MODULE SalSize [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Env, L_EC, L_PRoll, L_Staff, E_Utils, L_Str, L_Man, L_General, L_AFM,
        L_DatTim, Memo, P_Firm, D_Slr, L_Sheet, L_OwnData;

 PRIVATE CONST
  LineNbr = 20;
  cRepName  = "Sl0";
  cRepName3 = "SlSm0";

 PRIVATE VAR
  RepName,
  RepName3  : STRING[];
  Amount    : NUMERIC[0][LineNbr];
  MinSlr,
  SrAmount,
  TAmount,
  MinSlrAmnt: NUMERIC[0];
  FromSum,
  ToSum,
  _Money    : NUMERIC[2][LineNbr];
  FOT,
  TMoney    : NUMERIC[2];
  curMyFirm : P_Firm.tMyFirm;

(*
$P{ Top:
@
                                     : 祫-792; 㡫-383;  㡫 -384
===========================================================================================
| ᫥ ࠡ⭮  |     |     ᫥    |   㬬, ᫥   |
|     , 㡫 <1>    |ப| ࠡ⭨, ᥣ, | ࠡ⭨, ⥭  |
|                                    |      |     祫 <2>    |      3, 㡫    |
|------------------------------------|------|--------------------|------------------------|
|                 1                  |  2   |         3          |           4            |
|------------------------------------|------|--------------------|------------------------|
}
*)

(*
$P{ Line0:
?, R, ""
?, C, ""
?, R, ""
?, R, "1,"
@
| ######,0                         |######|####################|########################|
|------------------------------------|------|--------------------|------------------------|
}
*)
(*
$P{ LineN:
?, R, ""
?, C, ""
?, R, ""
?, R, "1,"
@
| ######,1                      |######|####################|########################|
|------------------------------------|------|--------------------|------------------------|
}
*)
(*
$P{ Line:
?,R, ""
?, R, ""
?, C, ""
?, R, ""
?, R, "1,"
@
| ######,1  ######,0             |######|####################|########################|
|------------------------------------|------|--------------------|------------------------|
}
*)
(*
$P{ Bot:
LineNbr, R, ""
LineNbr+1, C, ""
TAmount, R, ""
TMoney, R, "1,"
LineNbr+2, R, ""
MinSlrAmnt, R, ""
MinSlr, L, ""
Memo.ud_mb(), L, L_DatTim.MonthStr(Memo.ud_mb(), 0)+" y .)"
LineNbr+3, R, ""
SrAmount, R, ""
Memo.ud_mb(), L, L_DatTim.MonthStr(Memo.ud_mb(), 0)+" y .)"
LineNbr+4, R, ""
FOT/1000, R, "1,"
@
|ᥣ ࠡ⭨ (.  01  ##)  |######|####################|########################|
-------------------------------------------------------------------------------------------

:
-------------------------------------------------------------------------------------------
| ப 02 - ᫥ ࠡ⭨,  ᫥         |       |               |
|ࠡ⭠   ࠧ  쭮 ࠧ  㤠|#######|###############|
|(##### 㡫), 祫                                          |       |               |
|-----------------------------------------------------------------|-------|---------------|
|।ᯨ筠 ᫥ ࠡ⭨ ( 譨 ᮢ⥫|       |               |
| ࠡ⭨ ᯨ筮 ⠢), 祫 (.01, .2 . -4|       |               |
| ####################                                          |#######|###############|
|-----------------------------------------------------------------|-------|---------------|
| ࠡ⭮  ࠡ⭨ ᯨ筮 ⠢,  譨 |       |               |
|ᮢ⥫, ..     (.01, .8  |       |               |
|. -4  ####################                                  |#######|###############|
=(c) Polak=================================================================================
     -----------
 <1> ᫨  믫  ⢫  ⠫쭮,      ࠡ⮪    ५  砥
     1/3  㬬, ᫥  I ⠫;
 <2>  ਭ      祭 ५;  ⢮      室 
     묨;  室   ᪠   ६   த,   ᪠   室 
     ॡ,   ᪠   ࠭  ࠡ⭮    5 ࠡ   ५;
      ࠡ⠢   稭    ࠡ⮤⥫    稭,   騬
       ࠡ⮤⥫   ࠡ⭨,    5 ࠡ    ५;  ࠡ⠢    ०
       ࠡ祣  ६   樠⨢  ࠡ⮤⥫, ᫨  ࠡ⠭  ६
     ⠢  ५  40 ᮢ;  譨 ᮢ⥫  ࠡ⭨, 믮
     ࠡ  ࠬ ࠦ᪮-ࠢ ࠪ.

⭮ , ⢥⢥ 
।⠢ ᪮ ଠ樨
(, 㯮祭 ।⠢
 ଠ  
ਤ᪮ )

                   _______________________  ___________________________________  ___________
                         ()                     (...)                 ()

                   ____________________________   "_______" ___________________ 20__ 
                   ( ⠪⭮ ⥫䮭)        ( ⠢ 㬥)
}
*)

(*
$P{ Topb:
P_Firm.FP_FirmName(P_Firm.fomf(curMyFirm), SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
cRepName3, L, ""
Memo.ud_mb(), L, "N.y"
@
###################################################### ########## #####
=#####=================================================================
|                諨   3 (  #######)                 |
|---------------------------------------------------------------------|
|. |                |                   |         㬬|
|-----|-------------------|----------------------------|--------------|
}
*)

(*
$P{ LineBd:
Staff.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
Post.Name, L, ""
?, R, "2-"
@
|#####|###################|############################|##############|
}
*)

(*
$P{ Botb:
@
=(c) Polak=============================================================
}
*)

 PRIVATE PROCEDURE PrintLine();
  VAR
   i: NUMERIC[0];
   numstr: SCAL[LineNbr+1];
 BEGIN
  i:=0;
  WHILE i < LineNbr DO
   numstr:=i+1;
   IF i = 0 THEN
    MAKEPART(R, Line0,             ToSum[i], numstr, Amount[i], _Money[i]);
   ELSIF i = (LineNbr-1) THEN
    MAKEPART(R, LineN, FromSum[i],           numstr, Amount[i], _Money[i]);
   ELSE
    MAKEPART(R, Line,  FromSum[i], ToSum[i], numstr, Amount[i], _Money[i]);
   END;
   INC(i);
  END;
 END {PrintLine};

 PRIVATE PROCEDURE DistrSum(_Sum: LIKE(Money.Sum));
  VAR
   i: NUMERIC[0];
   Found: SCAL[2];
 BEGIN
  i:=0; Found:=0;
  IF (FromSum[1] <= _Sum) & (_Sum < MinSlr) THEN
   INC(MinSlrAmnt);
  END;
  WHILE (i < LineNbr) & ~Found DO
   IF ((FromSum[i] <= _Sum) | (_Sum<0)) & ((_Sum < ToSum[i]) | (ToSum[i]<0)) THEN
    Found:=1;
    INC(Amount[i]);
    INC(TAmount);
    INC(_Money[i], _Sum);
    INC(TMoney,    _Sum);
   END;
   INC(i);
  END;
  L_General.CallUs(Found);
 END {DistrSum};

 PRIVATE PROCEDURE E_SalSize_NeedStaff(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Utils.SalSize_NeedStaff), 1);
 END {E_SalSize_NeedStaff};

 PRIVATE PROCEDURE E_SalSize_NeedPrevPayFut(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Utils.SalSize_NeedPrevPayFut), 0);
 END {E_SalSize_NeedPrevPayFut};

 PRIVATE PROCEDURE E_SalSize_BadJMode(_JMode: LIKE(Sheet.JMode)): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Utils.SalSize_BadJMode);
  RETURN ~!Local & Local(_JMode);
 END {E_SalSize_BadJMode};

 PRIVATE PROCEDURE E_SalSize_BadJMode_Amnt(_JMode: LIKE(Sheet.JMode); _Amnt: NUMERIC[0]): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Utils.SalSize_BadJMode_Amnt);
  RETURN ~!Local & Local(_JMode, _Amnt);
 END {E_SalSize_BadJMode_Amnt};

 PRIVATE PROCEDURE E_SalSize_NeedMCode(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Utils.SalSize_NeedMCode);
  RETURN !Local | Local();
 END {SalSize_NeedMCode};

 PRIVATE PROCEDURE GetSal(VAR Sal, FOT: LIKE(Money.Sum));
 BEGIN
  SETZERO(Sal, FOT);
  IF E_SalSize_NeedPrevPayFut(Memo.ud_mb()) THEN  (* 10 -᪠  室*)
   INC(Sal, E_Utils.SalSize_GetPrevPayFut(Memo.ud_mb()));
  END;

  SETSEL(Money, TSN, Staff.TSN, Memo.ud_mb());
  FOR_EACH Money DO
   CONFORM(Money, MCList, MCGroup);
   IF (MCList.MCTyp = L_PRoll.mct_Credit (*᫥*)) & (MCGroup.FOT # 0)(**) THEN
    INC(FOT, Money.Sum);
    IF E_SalSize_NeedMCode() & (Money.Period <= Memo.ud_mb()) THEN
     INC(Sal, Money.Sum/MCList.PerNum);
    END;
   END;
  END; (* FOR_EACH Money *)

  SETSEL(Money, PayFor, Staff.TSN, Memo.ud_mb());
  FOR_EACH Money DO
   CONFORM(Money, MCList, MCGroup);
   IF (MCList.MCTyp = L_PRoll.mct_Credit (*᫥*)) & (MCGroup.FOT # 0)(**) THEN
    IF E_SalSize_NeedMCode() & (Money.Closed < Memo.ud_mb()) THEN
     INC(Sal, Money.Sum/MCList.PerNum);
    END;
   END;
  END; (* FOR_EACH Money *)
 END {GetSal};

 PRIVATE PROCEDURE GoodTSN(): SCAL[2];
  VAR
   AmntDaysJMode: NUMERIC[0][MAXOF(JMode.JMode)];
 BEGIN
  IF    Staff.MyFirm # curMyFirm THEN
   RETURN 0;
  ELSIF ~L_Env.RealTSN(Staff.TSN) |
        (Staff.Contract = L_Staff.cnt_OutStaff) |
        (Staff.Contract = L_Staff.cnt_ExternalCombine) |
        (Staff.Contract = L_Staff.cnt_ContractorsAgreement) THEN
   RETURN 0;
  ELSIF ~L_Staff.InStateInPer(Memo.ud_mb(), Memo.ud_me()) |
        (L_Man.GetRealEndDate(Memo.ud_me()) < Memo.ud_me()) |
        (L_Man.GetTakeOnDate(Memo.ud_me()) > Memo.ud_mb()) THEN
   RETURN 0;
  ELSE
   HISTCONF(Memo.ud_me(), Staff, StaffLog);
   CONFORM(StaffLog, Officer);
   IF ~E_SalSize_NeedStaff(Memo.ud_mb()) THEN
    RETURN 0;
   END;

   L_PRoll.CheckSalDone(Memo.ud_mb());
   L_PRoll.FixPCalc(Memo.ud_mb());

   IF (PCalc.CorBal=PCalc.HBal) & (PCalc.TimDone=0) THEN
    RETURN 0;
   END;

   SETZERO(AmntDaysJMode);
   SETSEL(Sheet, TSN, Staff.TSN, Memo.ud_mb());
   FOR_EACH Sheet DO
    INC(AmntDaysJMode[Sheet.JMode]);
    IF (Sheet.JMode = L_Sheet.jm_Sick) |
       (Sheet.JMode = L_Sheet.jm_MaternityLeave) |
       (Sheet.JMode = L_Sheet.jm_ParentalLeave) |
       (Sheet.JMode = L_Sheet.jm_ParentalLeaveUntil3Y) |
       E_SalSize_BadJMode(Sheet.JMode) |
       E_SalSize_BadJMode_Amnt(Sheet.JMode, AmntDaysJMode[Sheet.JMode]) THEN
     RETURN 0;
    END;
    IF Sheet.JMode # 01 THEN
     CONFORM(Sheet, JMode);
     IF ~JMode.InFirm THEN
      RETURN 0;
     END;
    END;
   END; (* FOR_EACH Sheet *)
   RETURN 1;
  END;
 END {GoodTSN};

 PRIVATE PROCEDURE CountSrAmount(): D_Slr.tAvgCount;
  VAR
   curDaysNotFullDuty,
   curDaysInFirm,
   Result: D_Slr.tAvgCount;
 BEGIN
  Result:=0;
  D_Slr.Prepare_SL001(Memo.ud_mb(), Memo.ud_me());
  SETSEL(SL001, TSN);
  FOR_EACH SL001 DO
   CONFORM(SL001, Staff);
   IF (Staff.MyFirm = curMyFirm) &
      (Staff.Contract # L_Staff.cnt_ExternalCombine) &
      (Staff.Contract # L_Staff.cnt_OutStaff) THEN
    D_Slr.GetFromSh001(curDaysInFirm, curDaysNotFullDuty, EMPTYOF(PROC));
    INC(Result, curDaysInFirm-curDaysNotFullDuty);
   END;
  END; (* FOR_EACH SL001 *)
  RETURN Result;
 END {CountSrAmount};

 PUBLIC PROCEDURE Sl0();
  VAR
   Sal,
   curSal,
   curFOT: L_PRoll.tSum;
   curTSN: LIKE(Staff.TSN);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  MinSlr:=L_OwnData.ODMROT(Memo.ud_mb());

  IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
   curMyFirm:=P_Firm.ChoiceMyFirm();
  ELSE
   curMyFirm:=P_Firm.mf_Own;
  END;
 
  SrAmount:=CountSrAmount() / L_DatTim.MonthLen(Memo.ud_mb());
 
  FromSum[00]:=        0; ToSum[00]:=  5000;
  FromSum[01]:=ToSum[00]; ToSum[01]:=  5800;
  FromSum[02]:=ToSum[01]; ToSum[02]:=  7400;
  FromSum[03]:=ToSum[02]; ToSum[03]:=  9000;
  FromSum[04]:=ToSum[03]; ToSum[04]:= 10600;
  FromSum[05]:=ToSum[04]; ToSum[05]:= 12200;
  FromSum[06]:=ToSum[05]; ToSum[06]:= 13800;
  FromSum[07]:=ToSum[06]; ToSum[07]:= 15400;
  FromSum[08]:=ToSum[07]; ToSum[08]:= 17000;
  FromSum[09]:=ToSum[08]; ToSum[09]:= 18600;
  FromSum[10]:=ToSum[09]; ToSum[10]:= 20200;
  FromSum[11]:=ToSum[10]; ToSum[11]:= 21800;
  FromSum[12]:=ToSum[11]; ToSum[12]:= 25000;
  FromSum[13]:=ToSum[12]; ToSum[13]:= 30000;
  FromSum[14]:=ToSum[13]; ToSum[14]:= 35000;
  FromSum[15]:=ToSum[14]; ToSum[15]:= 40000;
  FromSum[16]:=ToSum[15]; ToSum[16]:= 50000;
  FromSum[17]:=ToSum[16]; ToSum[17]:= 75000;
  FromSum[18]:=ToSum[17]; ToSum[18]:=100000;
  FromSum[19]:=ToSum[18]; ToSum[19]:=    -1;
 
  RepName :=L_General.rfn_byMonth(cRepName, Memo.ud_mb());
  RepName3:=L_General.NameConnection(cRepName3);
 
  OPENREP(R, RepName, Create);
 
  MAKEPART(R, Top);
 
  L_AFM.MakeIndex("_Man", "Sum: LIKE(Money.Sum);"+
                          "TSN: LIKE(Staff.TSN) ");
 
  SETZERO(Amount, _Money, TAmount, TMoney, FOT, MinSlrAmnt);
  SETSEL(Man, Man);
  FOR_EACH Man DO
   PROMPT(Man.Man);
   Sal:=0;
   SETEMPTY(curTSN);
   SETSEL(Staff, Man, Man.Man);
   FOR_EACH Staff DO
    GetSal(curSal, curFOT);
    IF (Staff.Contract # L_Staff.cnt_ExternalCombine) & (Staff.Contract # L_Staff.cnt_OutStaff) THEN
     INC(FOT, curFOT);
    END;
 
    IF GoodTSN() THEN
     INC(Sal, curSal);
     IF L_Staff.IsMainForTax(Memo.ud_me()) THEN
      curTSN:=Staff.TSN;
     END;
    END;
   END; (* FOR_EACH Staff *)
 
   IF ~!curTSN THEN
    _Man.Sum:=Sal;
    _Man.TSN:=curTSN;
    INSERT(_Man);
    DistrSum(Sal);
   END;
  END; (* FOR_EACH Man *)
 
  PrintLine();
  MAKEPART(R, Bot);
  CLOSEREP(R);
  OPENREP(Rs, RepName3, Create);
  MAKEPART(Rs, Topb);
  SETSEL(_Man, _Man);
  FOR_EACH _Man DO
   SEARCH(Staff, TSN, , _Man.TSN);
   CONFORM(Staff, Man);
   HISTCONF(Memo.ud_mb(), Staff, StaffLog);
   CONFORM(StaffLog, Post);
   MAKEPART(Rs, LineBd, _Man.Sum);
  END; (* FOR_EACH _Man *)
  MAKEPART(Rs, Botb);
  CLOSEREP(Rs);
  L_AFM.AF_PurgeTemp("_Man");
 
  LIKEMENU(Survey, RepName3, Survey, RepName);
 END {Sl0};

END.
