(*
%Copyright   (c) Polak IT
%Author      29.05.2014 16:53:30 POLAK\Bor
%Purpose         ଥ -2
%Type        control,report,temporary,convertor,operation,library,to paste
%Specific    SYS
%Modified    18.07.2014 01:00:16 POLAK\Bor
%Environment
*)

 MODULE SPV [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_AFM, L_Russia, L_DatTim, L_Str, L_Man, L_Staff, L_STx, L_XML,
        L_StdFrm, L_APtm, L_Prop, L_Tax, L_EC, L_Sheet, L_PRoll, L_AcCut, L_SFee, L_XDoc,
        L_Acnt, L_XObj, L_Pmnt, L_AvePay, L_Packet, P_Staff, P_Man, P_MyFirm, P_Firm,
        Math, Str, E_Staff, E_PRoll, L_Env, P_OwnData;

 TYPE
  tQMonth     = SCAL[3+1];
  tQuartalSum = L_PRoll.tSum[4];
 CONST
  TotQBMS = 0;

 VAR
  CurPacket       : L_Packet.tPFExtNbr;
  CurNumInP,
  TotNumInP       : NUMERIC[0];

 TYPE
  tAddTypeLen   = NUMERIC[0][MAXOF(L_Packet.tMInsAddType)+1];
 VAR
  orgnPerE,
  PerB,
  PerE            : DATE;
  orgnYear,
  Year            : SCAL[1e4];
  orgnQuarter,
  Quarter         : NUMERIC[0];

  orgnPerByWord,
  PerByWord       : STRING[];

  chkPkIdxMan   : LIKE(Man.Man);
  chkPkIdxTill  : DATE;
  chkPkIdxMyFirm: LIKE(MyFirm.MyFirm);

 TYPE
  tContrNum    = STRING[20];

 CONST
  pg_Main =  1;

  cat_Main                = 1;
  cat_Inv                 = 2;
  cat_Inv1                = 3;
  cat_woCtzn_Commorancy   = 4;
  cat_woCtzn_TmpResidence = 5;

 CONST
  patt_PerCode     = "";
  patt_ManPerE     = "ManPerE";
  patt_ManSFeeType = "MSFeeTp";

(*
$P{ SPV2_Top:
Packet.ExtNbr, R, "", "U"
?, R, "", "U"
L_Packet.OwnOKPO, R, "", "U"
L_Packet.OwnNumInPFR, L, "", "U"
L_Packet.OwnFirmName, L, "", "U"
L_Packet.OwnINN, L, "", "U"
L_Packet.OwnKPP, L, "", "U"
GetCategoryNick(Intrm.Type), L, "", "U"
L_DatTim.FullDateStr(Intrm.ManPerE), L, "", "U"
orgnPerByWord, L, "", "U"
Packet.DataType, L, " |X| "
Packet.CorrType, L, " |X| "
Packet.CorrType, L, " | |X"
L_Str.PoolItem(PerByWord, Packet.CorrType = L_Packet.ct_None), L, "", "U"
?, L, "", "U"
?, L, "", "U"
?, L, "", "U"
L_Packet.SINumberToAnyOut(Man.SINumber), L, "", "U"
@
                                                         N 窨 #####  N 㬥 ###
ଠ -2                       ________               ############

                         
                             

 客⥫:
樮    ###########################################################
(⪮)       ###########################################################
 ############         #########
 ⥣ਨ 客  ####################################################
 ⠢          ###########################################################
 ।⠢      ___________________________________________________________
 ਮ  ######################################################################
       (3 - I ⠫, 6 - 㣮, 9 - 9 楢, 0 - )
 ᢥ:
[#] 室
[#] ४騥
[#] ⬥騥

ਮ,   ந ४஢ (⬥) ᢥ:
#######################################################################################
       (3 - I ⠫, 6 - 㣮, 9 - 9 楢, 0 - )

  客 :
         #######################################################################
             #######################################################################
⢮        #######################################################################
客  #######################################################################

}
*)

(*
$P{ StageTop:
@
ਮ ࠡ  ᫥   ⭮ ਮ:
-------------------------------------------------------------------------------
|N |          |          |   |              |  ᫥   |᫮  .|
| |  砫  |     ||ᮡ ᫮|㤮 ⠦|. .ᨨ|
| |  ਮ |  ਮ ||     㤠    |---------------|-----------------|
| |          |          |   |              |᭮|.|᭮  |.|
|--|----------|----------|---|--------------|-----|---------|-----------|-----|
}
*)

(*
$P{ StageLine:
?, R, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
|##|##########|##########|   |##############|     |#########|           |     |
}
*)


(*
$P{ StageBot:
@
===============================================================================
}
*)


(*
$P{ SPV2_Bot:
?, L, " [ ]   [X]| [X]   [ ]"
?, L, " [ ]   [X]| [X]   [ ]"
L_Packet.ActingLeadPostName, L, "", "U"
L_Str.ShortName(L_Packet.ActingLeadName), L, "", "U"
L_DatTim.FullDateStr(L_Packet.PrepareDate), L, "", "U"
@
客   易⥫쭮 ᨮ 客  ਮ, 㪠  ⠡
"ਮ ࠡ  ᫥   ⭮ ਮ", ᫥:  ###############

客   ⥫쭮    ਮ, 㪠  ⠡
"ਮ ࠡ  ᫥   ⭮ ਮ", ᫥:  ###############

  㪮⥫     ஢ 
###################################            ###########################

 ##############################            ..}
*)


(*
$P{ pckList_Top:
Packet.ExtNbr, R, ""
L_Packet.OwnNumInPFR, L, ""
L_Packet.OwnINN, L, ""
L_Packet.OwnKPP, L, ""
L_Packet.OwnFirmName, L, ""
PerByWord, L, ""
@
                           ᮪ 客               窠 N ######
--------------------------------------------------------------------------------
| ࠡ⮤⥫, ।饣 㬥:                                |
|樮   ####################################################|
| ##########         #########                                           |
| ࣠樨  ####################################################|
|(⪮)                                                                     |
| ਮ:                                                              |
|##############################################################################|
|------------------------------------------------------------------------------|
| N  |  客   | , , ⢮                                   |
|/ |         |                                                          |
|----|--------------|----------------------------------------------------------|
}
*)

(*
$P{ pckList_Line:
PckBody.SeqNbr+1, R, "N"
L_Packet.SINumberToAnyOut(Man.SINumber), L, ""
L_Packet.GetManInPFRFName(SYSDATE()), L, ""
@
|####|##############|##########################################################|
}
*)

(*
$P{ pckList_Bot:
@
--------------------------------------------------------------------------------}
*)

 PRIVATE PROCEDURE IsCorrPacket(): SCAL[2];
 BEGIN
  RETURN (Packet.CorrType # L_Packet.ct_None);
 END {IsCorrPacket};

 PRIVATE PROCEDURE IsForPensPacket(): SCAL[2];
 BEGIN
  RETURN (Packet.DataType = L_Packet.dt_ForPens) | (Packet.Kind = L_Packet.knd_PF_SPV1) | (Packet.Kind = L_Packet.knd_PF_SPV2);
 END {IsForPensPacket};

 PRIVATE PROCEDURE IsCAStaffCntrType(D: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  TRY [RESTORE_CURSORS(RC_ON)]
   IF L_Staff.IsStandOnMainContract(Man.Man, L_Packet.PckMyFirm, D) THEN
    Result:=(Staff.Contract = L_Staff.cnt_ContractorsAgreement);
   END;
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {IsCAStaffCntrType};

 PRIVATE PROCEDURE GetPckBodyManPerE(): DATE;
 BEGIN
  RETURN STRTOFLD(L_Packet.GetPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_ManPerE), DATE);
 END {GetPckBodyManPerE};

 PRIVATE PROCEDURE HasFeePF(AddPF: SCAL[2]): SCAL[2];
 BEGIN
  SETSEL(ManSFee, MyFirm, L_Packet.PckMyFirm, Intrm.Man, 1);
  SRCINSEL(ManSFee, GE, , Intrm.ManPerB);
  WHILE OCCURE(ManSFee) & (ManSFee.Period <= Intrm.ManPerE) DO
   IF ManSFee.Type = Intrm.Type THEN
    IF AddPF THEN
     IF (ManSFee.Fee[L_SFee.p_PFA1]   # 0)  |
        (ManSFee.Fee[L_SFee.p_PFA2]   # 0)  |
        (ManSFee.Fee[L_SFee.p_PFA3_1] # 0)  |
        (ManSFee.Fee[L_SFee.p_PFA3_2] # 0)  |
        (ManSFee.Fee[L_SFee.p_PFA3_3] # 0)  |
        (ManSFee.Fee[L_SFee.p_PFA3_4] # 0)  |
        (ManSFee.Fee[L_SFee.p_PFA4_0] # 0) THEN
      RETURN 1;
     END;
    ELSE
     IF ManSFee.Fee[L_SFee.p_PFIn] # 0 THEN
      RETURN 1;
     END;
    END;
   END;
   NEXT(ManSFee);
  END; (* WHILE OCCURE(ManSFee) ... *)
  RETURN 0;
 END {HasFeePF};

 PRIVATE PROCEDURE GoodTSN(InIntvl, WithInternalCombine: SCAL[2]): SCAL[2];
 BEGIN
  RETURN L_Env.RealTSN(Staff.TSN) & (Staff.Contract # L_Staff.cnt_OutStaff) &
         (WithInternalCombine | (Staff.Contract # L_Staff.cnt_InternalCombine)) &
         (~InIntvl | L_DatTim.IsActiveInIntvl_Inc(Intrm.ManPerB, Intrm.ManPerE, Staff.BegDate, Staff.EndDate)) &
         ~L_Packet.E_ManIns_ExcludedTSN(Intrm.ManPerB);
 END {GoodTSN};

 PRIVATE PROCEDURE GetManStrId(_Man: LIKE(Man.Man)): STRING[];
 BEGIN
  RETURN "窠 "+Packet.ExtNbr+"-"+L_Str.IntStr(CurNumInP) + " (: " + _Man + ")";
 END {GetManStrId};

 PRIVATE PROCEDURE MakeStfLg();
  VAR
   DB, DE,
   B,  E    : DATE;
   PrvOut,
   Out,
   Rem,
   NewPns,
   Need       : SCAL[2];
   curPnsAttr : LIKE(Officer.PnsAttr);
   curTSN     : LIKE(Staff.TSN);
   curContract: LIKE(Staff.Contract);
 BEGIN
  SETSEL(StfLg, StfLg);
  REMSEL(StfLg);

  SELECT(Staff, MyFirm, , L_Packet.PckMyFirm, Man.Man);
  WHILE OCCURE(Staff) DO
   IF GoodTSN(1, 0) THEN
    PrvOut:=1;
    SETEMPTY(curPnsAttr);
    SETSEL(StaffLog, TSN, Staff.TSN);
    SRCINSEL(StaffLog, LE, , Math.Max(Intrm.ManPerB, Staff.BegDate));
    LOOP
     Out:=~OCCURE(StaffLog) | (StaffLog.Date>Math.Min(Intrm.ManPerE, Staff.EndDate)) | L_Staff.IsDischargeStaffLog();
     IF ~Out THEN
      CONFORM(StaffLog, Officer);
      NewPns:=curPnsAttr # Officer.PnsAttr;
     ELSE
      NewPns:=0;
     END;
     IF (PrvOut # Out) | NewPns THEN
      IF ~PrvOut THEN
       IF ~OCCURE(StaffLog) THEN
        E:=Intrm.ManPerE;
       ELSE
        E:=Math.Min(Intrm.ManPerE, StaffLog.Date-1);
       END;
       StfLg.Numb:=0;
       StfLg.TSN:=Staff.TSN;
       StfLg.Contract:=Staff.Contract;
       StfLg.DateB:=B;
       StfLg.DateE:=E;
       StfLg.PnsAttr:=curPnsAttr;
       INSERT(StfLg);
       SETEMPTY(curPnsAttr);
      END;
      IF PrvOut | NewPns THEN
       B:=Math.Max(Intrm.ManPerB, StaffLog.Date);
       curPnsAttr:=Officer.PnsAttr;
      END;
     END;
     PrvOut:=Out;
     IF ~OCCURE(StaffLog) THEN
      EXIT;
     END;
     NEXT(StaffLog);
    END;
   END; (* IF GoodTSN ... *)
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)

  SELECT(StfLg, StfLg, , 0);
  WHILE OCCURE(StfLg) DO
   curTSN:=StfLg.TSN;
   B:=StfLg.DateB;
   E:=StfLg.DateE;
   DB:=B;
   DE:=E;
   curPnsAttr:=StfLg.PnsAttr;
   curContract:=StfLg.Contract;

   Need:=1;
   SAVE(StfLg);
   Rem:=1;
   NEXT(StfLg);
   WHILE OCCURE(StfLg) & (StfLg.DateB<=E) & Rem DO
    Rem:=0;
    IF (StfLg.PnsAttr = L_Packet.OrdinaryPnsAttr) & (StfLg.Contract # L_Staff.cnt_Basic) THEN
     IF StfLg.DateE <= E THEN
      REMOVE(StfLg);
      Rem:=1;
     ELSE
      StfLg.DateB:=E+1;
      REPLACE(StfLg);
     END;
    ELSE
     IF StfLg.DateB > B THEN
      DE:=StfLg.DateB-1;
      B:=StfLg.DateB;
      PREV(StfLg);
      StfLg.DateB:=B;
      INSERT(StfLg);
     ELSE (*StfLg.DateB = B*)
      IF StfLg.DateE<E THEN
       DE:=StfLg.DateE;
       SAVE(StfLg);
       B:=StfLg.DateE+1;
       PREV(StfLg);
       StfLg.DateB:=B;
       INSERT(StfLg);
       RESTORE(StfLg);
      END;
      IF (curContract # L_Staff.cnt_Basic) & (curPnsAttr = L_Packet.OrdinaryPnsAttr) THEN
       Need:=0;
      ELSE
       IF StfLg.DateE>E THEN
        SAVE(StfLg);
        StfLg.DateB:=E+1;
        INSERT(StfLg);
        RESTORE(StfLg);
        StfLg.DateE:=E;
        REPLACE(StfLg);
       END;
       IF (curPnsAttr = L_Packet.OrdinaryPnsAttr) & (curContract = L_Staff.cnt_Basic) THEN
        curPnsAttr:=StfLg.PnsAttr;
        REMOVE(StfLg);
       END;
      END;
     END;
    END;
   END;
   IF Need THEN
    DEFAULT(StfLg);
    StfLg.Numb:=1;
    StfLg.TSN:=curTSN;
    StfLg.DateB:=DB;
    StfLg.DateE:=DE;
    StfLg.PnsAttr:=curPnsAttr;
    StfLg.Contract:=curContract;
    INSERT(StfLg);
   END;
   RESTORE(StfLg);
   NEXT(StfLg);
  END; (* WHILE OCCURE(StfLg) ... *)
 END {MakeStfLg};

 PRIVATE PROCEDURE GetAvePay(VAR _APJMode: LIKE(Sheet.JMode); VAR BD, ED: DATE): SCAL[2];
 BEGIN
  IF Sheet.Source = L_Sheet.src_AvePay THEN
   SETSEL(AvePay, TSN, StfLg.TSN);
   SRCINSEL(AvePay, LE, , Sheet.Period+Sheet.Day-1);
   WHILE OCCURE(AvePay) DO
    IF L_AvePay.IsRealAvePay() THEN
     CONFORM(AvePay, AvePayP);
     WHILE OCCURE(AvePayP) DO
      IF L_DatTim.IsActive_Inc(Sheet.Period+Sheet.Day-1, AvePayP.StartD, AvePayP.StopD) THEN
       CONFORM(AvePayP, AveTypeP);
       IF ~!AveTypeP.JMode THEN
        _APJMode:=AveTypeP.JMode;
        BD:=AvePayP.StartD;
        ED:=AvePayP.StopD;
        RETURN 1;
       END;
      END;
      NEXT(AvePayP);
     END; (* WHILE OCCURE(AvePayP) ... *)
    END;
    PREV(AvePay);
   END; (* WHILE OCCURE(AvePay) ... *)
  END;
  RETURN 0;
 END {GetAvePay};

 PRIVATE PROCEDURE CheckType(    D: DATE;
                                 ForceNotInState: SCAL[2];
                                 curJMode: LIKE(Sheet.JMode);
                             VAR prvMInsType: L_Packet.tMInsType;
                             VAR _BegD: DATE;
                                 Last: SCAL[2]);
  VAR
   curMInsType: L_Packet.tMInsType;
 BEGIN
  IF ForceNotInState THEN
   curMInsType:=EMPTYOF(L_Packet.tMInsType);
  ELSE
   curMInsType:=L_Packet.ext_E_SpecStageForPens(D, curJMode, Packet.Kind);
  END;

  IF (curMInsType # prvMInsType) | Last THEN
   IF ~!prvMInsType THEN
    _MIns.Man:=Man.Man;
    _MIns.BegD:=_BegD;
    _MIns.EndD:=D-1;
    _MIns.PostName:="";
    _MIns.Type:=prvMInsType;
    INSERT(_MIns);
   END;
   IF ~!curMInsType THEN
    _BegD:=D;
   END;
   prvMInsType:=curMInsType;
  END;
 END {CheckType};

 PRIVATE PROCEDURE CheckType2(D: DATE;
                              ForceNotInState: SCAL[2];
                              curJMode: LIKE(Sheet.JMode);
                              VAR prvAddType: L_Packet.tMInsAddType;
                              VAR _BegD2: DATE);
  VAR
   curAddType: L_Packet.tMInsAddType;
 BEGIN
  IF ForceNotInState THEN
   SETEMPTY(curAddType);
  ELSE
   curAddType:=E_Staff.SpecStage2ForPens(D, curJMode);
  END;
  IF (curAddType # prvAddType) THEN
   IF ~!curAddType THEN
    _BegD2:=D;
   END;
   prvAddType:=curAddType;
  END;
 END {CheckType2};

 PRIVATE PROCEDURE GetNotInState(D: DATE): SCAL[2];
 BEGIN
  RETURN ~IsInsuredInPF_OnDate(D);
 END {GetNotInState};

 PRIVATE PROCEDURE GetSpecStage();
  CONST
   FictDate = 01\01\1900;
  VAR
   _APD1,
   _APD2,
   _BegD,
   _BegD2,
   _EndD,
   D, DE,
   D1, D2  : DATE;
   _APJMode: LIKE(Sheet.JMode);
   _PnsAttr: LIKE(Officer.PnsAttr);
   _Type   : L_Packet.tMInsType;
   _Type2  : L_Packet.tMInsAddType;
   _PostName: LIKE(Post.Name);
 BEGIN
  IF ~SELECT(_MIns, _MIns, Man.Man) THEN
   SETEMPTY(_APJMode, _APD1, _APD2);
   MakeStfLg();
   SELECT(StfLg, StfLg, , 1);
   WHILE OCCURE(StfLg) DO
    D1:=Math.Max(StfLg.DateB, Intrm.ManPerB);
    D2:=StfLg.DateE;
    SETEMPTY(_Type, _Type2);

    IF D1<L_Env.aptm_Start THEN
     DE:=Math.Min(L_Env.aptm_Start-1, D2);
     D:=D1;

     SELECT(AvePay, TSN, , StfLg.TSN);
     WHILE OCCURE(AvePay) & (AvePay.StartD<=DE) DO
      IF AvePay.StopD>=D1 THEN
       CONFORM(AvePay, AvePayP);
       WHILE OCCURE(AvePayP) DO
        IF L_DatTim.IsActiveInIntvl_Inc(D1, DE, AvePayP.StartD, AvePayP.StopD) THEN
         CONFORM(AvePayP, AveTypeP);
         IF ~!AveTypeP.JMode THEN

          WHILE D < AvePayP.StartD DO
           CheckType (D, GetNotInState(D), EMPTYOF(JMode.JMode), _Type,  _BegD, 0);
           CheckType2(D, GetNotInState(D), EMPTYOF(JMode.JMode), _Type2, _BegD2);
           INC(D);
          END;

          _APD2:=Math.Min(AvePayP.StopD, DE);
          WHILE D<=_APD2 DO
           CheckType (D, GetNotInState(D), AveTypeP.JMode, _Type,  _BegD, 0);
           CheckType2(D, GetNotInState(D), AveTypeP.JMode, _Type2, _BegD2);
           D:=L_DatTim.NextPer(D);
          END;
          D:=_APD2+1;
         END;
        END;
        NEXT(AvePayP);
       END; (* WHILE OCCURE(AvePayP) ... *)
      END;
      NEXT(AvePay);
     END; (* WHILE OCCURE(AvePay) ... *)

     WHILE D <= DE DO
      CheckType (D, GetNotInState(D), EMPTYOF(JMode.JMode), _Type,  _BegD, 0);
      CheckType2(D, GetNotInState(D), EMPTYOF(JMode.JMode), _Type2, _BegD2);
      INC(D);
     END;
    END;

    D:=Math.Max(D1, L_Env.aptm_Start);
    SETSEL(Sheet, TSN, StfLg.TSN);
    SRCINSEL(Sheet, GE, , L_DatTim.Per(D), L_DatTim.DAY(D));
    WHILE OCCURE(Sheet) & ((Sheet.Period+Sheet.Day-1) <= D2) DO
     PROMPT(":  "+Man.Man+"  "+L_DatTim.DateStr(Sheet.Period+Sheet.Day-1));

     IF GetAvePay(_APJMode, _APD1, _APD2) THEN
      D:=Math.Max(_APD1, D1);
      WHILE D<=Math.Min(_APD2, D2) DO
       CheckType (D, GetNotInState(D), _APJMode, _Type,  _BegD, 0);
       CheckType2(D, GetNotInState(D), _APJMode, _Type2, _BegD2);
       D:=L_DatTim.NextPer(D);
      END;
      SRCINSEL(Sheet, GT, , L_DatTim.Per(_APD2), L_DatTim.DAY(_APD2));
     ELSE
      D:=Sheet.Period+Sheet.Day-1;
      CheckType (D, GetNotInState(D), Sheet.JMode, _Type,  _BegD, 0);
      CheckType2(D, GetNotInState(D), Sheet.JMode, _Type2, _BegD2);
      NEXT(Sheet);
     END;
    END;
    CheckType (D2+1, 1, EMPTYOF(JMode.JMode), _Type,  _BegD, 1);
    CheckType2(D2+1, 1, EMPTYOF(JMode.JMode), _Type2, _BegD2);

    SETEMPTY(_PnsAttr, _BegD);
    SEARCH(PnsAttr, PnsAttr, , StfLg.PnsAttr);
    _Type:=PnsAttr.Str2002;

    NEXT(StfLg);
   END; (* WHILE OCCURE(Staff) ... *)

   (*⪠ 㦭 ࠧ*)
   SETEMPTY(_PostName, _Type, _BegD, _EndD);
   SELECT(_MIns, _MIns, , Man.Man);
   WHILE OCCURE(_MIns) DO
    IF !_MIns.Type THEN
     SETEMPTY(_PostName, _Type, _BegD, _EndD);
     REMOVE(_MIns);
    ELSE
     IF (_Type = _MIns.Type) & (*(_PostName = _MIns.PostName) &*) (_EndD = (_MIns.BegD-1)) THEN
      _EndD:=_MIns.EndD;
      PREV(_MIns);
      _MIns.EndD:=_EndD;
      REPLACE(_MIns);
      NEXT(_MIns);
      REMOVE(_MIns);
     ELSE
      _Type    :=_MIns.Type;
      _PostName:=_MIns.PostName;
      _BegD    :=_MIns.BegD;
      _EndD    :=_MIns.EndD;
      NEXT(_MIns);
     END;
    END;
   END; (* WHILE OCCURE(_MIns)... *)
  END;
 END {GetSpecStage};

 PRIVATE PROCEDURE AccessPacket(_ExtNbr: LIKE(Packet.ExtNbr)): SCAL[2];
 BEGIN
  RETURN SELECT(Packet, PacketDS, L_Packet.rcv_PensFund, L_Packet.DTStamp, _ExtNbr);
 END {AccessPacket};

 PRIVATE PROCEDURE SetPckBodyByIntrm(trgExtNbr: LIKE(Packet.ExtNbr));
 BEGIN
  IF ~AccessPacket(trgExtNbr) THEN
   L_Packet.InsPFPacket(L_Packet.knd_PF_SPV2, trgExtNbr, PerB, PerE, Intrm.DataType, Intrm.CorrType);
   L_Packet.PutPacketAttr(Packet.Packet, patt_PerCode,     L_Str.IntStr(Quarter));
   L_Packet.PutPacketAttr(Packet.Packet, patt_ManSFeeType, L_Str.IntStr(Intrm.Type));
  END;
  DEFAULT(PckBody);
  PckBody.Packet  :=Packet.Packet;
  PckBody.Man     :=Intrm.Man;
  INSERT(PckBody);
  Intrm.Packet:=PckBody.Packet;
  Intrm.SeqNbr:=PckBody.SeqNbr;
  REPLACE(Intrm);
 END {SetPckBodyByIntrm};

 PRIVATE PROCEDURE HasExcludedTSN(P: DATE): SCAL[2];
 BEGIN
  SELECT(Staff, MyFirm, , L_Packet.PckMyFirm, Man.Man);
  WHILE OCCURE(Staff) DO
   IF L_Packet.E_ManIns_ExcludedTSN(P) THEN
    RETURN 1;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  RETURN 0;
 END {HasExcludedTSN};

 PRIVATE PROCEDURE CheckManSFeeType();
  VAR
   dfnTypeStr: STRING[];
   dfnType   : LIKE(ManSFee.Type);
 BEGIN
  TRY
   dfnType:=L_SFee.DefineType(L_Packet.PckMyFirm, Man.Man, ManSFee.Period);
  EXCEPT
  ON Exc:Exc_Raise DO (*0091495 25.04.2012 16:02:36 AK1786\Bor.Polak*)
   SETEMPTY(dfnType);
  END;
  IF ManSFee.Type # dfnType THEN
   IF !dfnType THEN
    dfnTypeStr:='।'
   ELSE
    dfnTypeStr:=L_Str.PoolItem(L_SFee.t_Pool, dfnType);
   END;
   InsPrb01("    ᫮.  '"+L_Str.PoolItem(L_SFee.t_Pool, ManSFee.Type)+"', ⠫ '"+dfnTypeStr+"'. ॡ    "+L_DatTim.PeriodStr(ManSFee.Period), 1)
  END;
 END {CheckManSFeeType};

 PRIVATE PROCEDURE IsInsuredInPF_OnDate(D: DATE): SCAL[2];
 BEGIN
  IF D >= L_SFee.TheStartingPoint THEN
   RETURN L_Staff.IsStandOnMainContract(Man.Man, L_Packet.PckMyFirm, D) &
          L_SFee.ManIsInsuredInPF(Man.Man, D);
  ELSE
   RETURN (L_STx.Get_woTaxManKind(D, Man.Man) # L_STx.wotmk_Foreigner);
  END;
 END {IsInsuredInPF_OnDate};

 PRIVATE PROCEDURE IsInsuredInPF_InPer(): SCAL[2];
  VAR
   P: DATE;
 BEGIN,
  P:=GetManPerB();
  WHILE P <= GetManPerE() DO
   IF IsInsuredInPF_OnDate(L_DatTim.MonthEnd(P)) THEN
    RETURN 1;
   END;
   P:=L_DatTim.NextPer(P);
  END;
  RETURN 0;
 END {IsInsuredInPF_InPer};

 PRIVATE PROCEDURE GetCategoryNick(trgType: LIKE(ManSFee.Type)): STRING[];
 BEGIN
  IF    trgType = L_SFee.t_Normal              THEN RETURN "";
  ELSIF trgType = L_SFee.t_Invalid             THEN RETURN "";
  ELSIF trgType = L_SFee.t_USNO                THEN RETURN "";
  ELSIF trgType = L_SFee.t_woCtzn              THEN RETURN "????";
  ELSIF trgType = L_SFee.t_woCtzn_Commorancy   THEN RETURN "";
  ELSIF trgType = L_SFee.t_woCtzn_TmpResidence THEN RETURN "";
  ELSE L_General.CallUs(0);
  END;
 END {GetCategoryNick};

 PRIVATE PROCEDURE trn_intPutPer(nParent: L_XML.tNode; NodeName: STRING[]; trgYear: SCAL[1e4]; trgQuarter: SCAL[10]);
  VAR
   nPer: L_XML.tNode;
 BEGIN
  nPer:=L_Packet.trn_PutNode(nParent, NodeName);
  L_Packet.trn_PutInt(nPer, "⠫", trgQuarter);
  L_Packet.trn_PutInt(nPer, "", trgYear);
(*
  L_Packet.trn_PutString(nPer, "", ""); (*???*)
*)
 END {trn_intPutPer};

 PRIVATE PROCEDURE trn_PutPer(nParent: L_XML.tNode; NodeName: STRING[]);
 BEGIN
  trn_intPutPer(nParent, NodeName, Year, Quarter);
 END {trn_PutPer};

 PRIVATE PROCEDURE trn_PutMInsFeatures(nParent: L_XML.tNode; NodeName: STRING[]);
  VAR
   nFeatures,
   nSpCond,
   nStand,
   nLongServ: L_XML.tNode;
 BEGIN
  nFeatures:=L_Packet.trn_PutNode(nParent, NodeName);
  L_Packet.trn_PutTerrCond(nFeatures, "ਠ륓᫮", "", 0);

  nSpCond:=L_Packet.trn_PutNode(nFeatures, "ᮡ륓᫮㤠");
  L_Packet.trn_PutString(nSpCond, "᭮", Str.Item(_MIns.Type, ";", 0));
  L_Packet.trn_PutString(nSpCond, "᪠", Str.Item(_MIns.Type, ";", 1));

  nStand:=L_Packet.trn_PutNode(nFeatures, "塞멑⠦");
  L_Packet.trn_PutString(nStand, "᭮", "");
  L_Packet.trn_PutEarnHours(nStand, "ࠡ⪠", 0, 0);
  L_Packet.trn_PutEarnDays(nStand, "ࠡ⪠ୠ", 0, 0, 0);

  L_Packet.trn_PutString(nFeatures, "℥", Str.Item(_MIns.Type, ";", 2));

  nLongServ:=L_Packet.trn_PutNode(nFeatures, "㣠");
  L_Packet.trn_PutString(nLongServ, "᭮", "");
  L_Packet.trn_PutEarnHours(nLongServ, "ࠡ⪠", 0, 0);
  L_Packet.trn_PutEarnDays(nLongServ, "ࠡ⪠ୠ", 0, 0, 0);
  L_Packet.trn_PutNumeric(nLongServ, "⠢", 0, 2);
 END {trn_PutMInsFeatures};

 PRIVATE PROCEDURE PrepareOneMan();
 BEGIN
  IF Packet.CorrType # L_Packet.ct_Cancel THEN
   GetSpecStage();
  ELSE
   IF NeedManInIntrm() THEN
    InsPrb01("   ⬥ ᢥ  稨 ꥪ   ᫥ ", 1);
   END;
  END; (* IF Packet.CorrType # L_Packet.ct_Cancel ... *)
 END {PrepareOneMan};

 PRIVATE PROCEDURE MakeOneMan(nPack: L_XML.tNode);
  VAR
   D1, D2,
   _Period   : DATE;
   curMonth  : L_DatTim.tMonth;
   QMonth    : tQMonth;
   i         : NUMERIC[0];
   Dummy     : STRING[250];
   nDoc,
   nHeadOld,
   nPay,
   nIncome,
   nIncStr,
   nWork,
   nWrkPer,
   nWrkBas,
   nWrkLgt,
   nInc,
   nHrm     : L_XML.tNode;
   Surname,
   FirstName,
   Patronymic: STRING[];
   curStrCode: SCAL[1e3];
   curStrNum : NUMERIC[0];
   totAddPF,
   totAddPFIn,
   totAddPFAc: L_XObj.tSum;
 BEGIN
  CONFORM(PckBody, Man);
  L_Str.SplitManName(Intrm.Name, Surname, FirstName, Patronymic);

  nDoc:=L_Packet.trn_PutAbstractDoc(nPack, trn_PckKind(), CurNumInP);

  L_Packet.trn_PutString(nDoc, "", L_Packet.FormType(Packet.DataType, Packet.CorrType));
  L_Packet.trn_PutString(nDoc, "樮멍", L_Packet.OwnNumInPFR);
  L_Packet.trn_PutString(nDoc, "⪮", L_Packet.OwnFirmName);
  L_Packet.trn_PutOwnFirmTaxNum(nDoc, "멍");
  L_Packet.trn_PutString(nDoc, "⥣ਨ", GetCategoryNick(Intrm.Type));
  IF IsCorrPacket() THEN
   trn_intPutPer(nDoc, "멏ਮ", orgnYear, orgnQuarter);
   trn_PutPer(nDoc, "४㥬멎멏ਮ");
   MAKEPART(R, SPV2_Top, CurNumInP, Surname, FirstName, Patronymic, P_MyFirm.NumInPFR(L_Packet.PckMyFirm, PerE));
  ELSE
   trn_PutPer(nDoc, "멏ਮ");
   MAKEPART(R, SPV2_Top, CurNumInP, Surname, FirstName, Patronymic, );
  END;
  L_Packet.trn_PutString(nDoc, "客", L_Packet.SINumberToAnyOut(Man.SINumber));
  L_Packet.trn_PutFIO(nDoc, "", Intrm.Name);
  L_Packet.trn_PutDate(nDoc, "⠇", L_Packet.PrepareDate);
  L_Packet.trn_PutDate(nDoc, "⠑⠢", Intrm.ManPerE);

  IF Packet.CorrType # L_Packet.ct_Cancel THEN
   MAKEPART(R, StageTop);
   SETEMPTY(D1, D2);
   i:=1;
   IF SELECT(_MIns, _MIns, Man.Man) THEN
    D1:=_MIns.BegD;
    D2:=_MIns.EndD;
   END;
   WHILE OCCURE(_MIns) DO
    nWrkPer:=L_Packet.trn_PutNode(nDoc, "⠦멏ਮ");
    L_Packet.trn_PutInt(nWrkPer, "ப", i);
    L_Packet.trn_PutDate(nWrkPer, "⠍砫ਮ", _MIns.BegD);
    L_Packet.trn_PutDate(nWrkPer, "⠊栏ਮ",  _MIns.EndD);
    IF L_Packet.IsOrdinaryType(_MIns.Type) THEN
(*
     L_Packet.trn_PutInt(nWrkPer, "⢮죮呮⠢", 0);
*)
    ELSE
     L_Packet.trn_PutInt(nWrkPer, "⢮죮呮⠢", 1);
     nWrkLgt:=L_Packet.trn_PutNode(nWrkPer, "죮멑⠦");
     L_Packet.trn_PutInt(nWrkLgt, "ப", 1);
     trn_PutMInsFeatures(nWrkLgt, "ᮡ⨓");
    END;

    MAKEPART(R, StageLine, i, L_DatTim.DateStr(_MIns.BegD), L_DatTim.DateStr(_MIns.EndD), Str.Item(_MIns.Type, ";", 0), Str.Item(_MIns.Type, ";", 2));
    Dummy:=Str.Condense(Str.Item(_MIns.Type, ";", 1));
    IF ~!Dummy THEN
     MAKEPART(R, StageLine, , , , Dummy);
    END;
    INC(i);
    NEXT(_MIns);
   END; (* WHILE OCCURE(_MIns)... *)
   MAKEPART(R, StageBot);

   MAKEPART(R, SPV2_Bot, HasFeePF(0), HasFeePF(1));

   L_Packet.trn_PutString(nDoc, "ਧ᫥ᮢ",         L_Str.PoolItem("|", HasFeePF(0)));
   L_Packet.trn_PutString(nDoc, "ਧ᫥ᮢ", L_Str.PoolItem("|", HasFeePF(1)));

  END; (* IF Packet.CorrType # L_Packet.ct_Cancel ... *)
 END {MakeOneMan};

 PRIVATE PROCEDURE trn_PckKind(): STRING[];
 BEGIN
  IF    Packet.Kind = L_Packet.knd_PF_SPV2 THEN RETURN "_______";
  ELSE
   L_General.CallUs(0);
  END;
 END {trn_PckKind};

 PRIVATE PROCEDURE MakeOnePacket();
  VAR
   nPack,
   nInvH,
   nInvP,
   nTotPay,
   nInc       : L_XML.tNode;
 BEGIN
  APP.Get().NewPrompt("ନ஢.  "+Packet.ExtNbr);
  L_Packet.CheckExistTrnFiles();
  L_Packet.trn_OpenFiles();
  L_Packet.CheckPacketType();
  SETZERO(CurNumInP, TotNumInP);

  SELECT(PckBody, Packet, , Packet.Packet);
  WHILE OCCURE(PckBody) DO
   PROMPT(": "+GetManStrId(PckBody.Man));
   INC(CurNumInP);
   L_General.Assert(PckBody.SeqNbr = CurNumInP, " 窥 襭 㬥");
   CONFORM(PckBody, Man);
   SEARCH(Intrm, Packet, , PckBody.Packet, PckBody.SeqNbr);
   PrepareOneMan();
   NEXT(PckBody);
  END; (* WHILE OCCURE(PckBody) ... *)

  TotNumInP:=CurNumInP;

  L_Packet.MakeADV61forOther("-2", TotNumInP);

  nPack:=L_Packet.ext_trn_PutHead(L_Packet.ext_trnFileName(orgnPerE));
  nInvH:=L_Packet.trn_PutInventoryHead(nPack, "_", trn_PckKind(), TotNumInP);

(*
  L_Packet.trn_PutString(nInvH, "", L_Packet.FormType(Packet.DataType, Packet.CorrType));
  IF IsCorrPacket() THEN
   trn_intPutPer(nInvH, "멏ਮ", orgnYear, orgnQuarter);
   trn_PutPer(nInvH, "४㥬멎멏ਮ");
  ELSE
   trn_PutPer(nInvH, "멏ਮ");
  END;
*)
  FORMFEED(R);
  InitPrintAttr(R, Duplex, Off);

  CurNumInP:=1;
  FIRST(PckBody);
  WHILE OCCURE(PckBody) DO
   INC(CurNumInP);
   PROMPT(": "+GetManStrId(PckBody.Man));
   SEARCH(Intrm, Man, , PckBody.Man, PckBody.Packet);
   MakeOneMan(nPack);
   NEXT(PckBody);
  END; (* WHILE OCCURE(PckBody) ... *)

  REPLACE(Packet);

  FORMFEED(R);
  InitPrintAttr(R, Duplex, Off);
  MAKEPART(R, pckList_Top);
  FIRST(PckBody);
  WHILE OCCURE(PckBody) DO
   PROMPT("᮪ 客 : "+GetManStrId(PckBody.Man));
   CONFORM(PckBody, Man);
   MAKEPART(R, pckList_Line);
   NEXT(PckBody);
  END; (* WHILE OCCURE(PckBody) ... *)
  MAKEPART(R, pckList_Bot);
  L_Packet.trn_CloseFiles(nPack);
 END {MakeOnePacket};

 PRIVATE PROCEDURE AddPkIdx();
 BEGIN
  IF ~ADD(PkIdx, PkIdx, Packet.PerB, Packet.PerE, PckBody.Man, L_Packet.GetPacketAttr(Packet.Packet, patt_ManSFeeType)) |
      (PkIdx.DTStamp <= Packet.DTStamp) THEN
   L_General.CallUs(PkIdx.DTStamp # Packet.DTStamp); (* 0098850 .5.1 20.08.2013 15:53:54 POLAK\Bor *)
   PkIdx.Packet :=Packet.Packet;
   PkIdx.SeqNbr :=PckBody.SeqNbr;
   PkIdx.DTStamp:=Packet.DTStamp;
   REPLACE(PkIdx);
  END;
 END {AddPkIdx};

 PRIVATE PROCEDURE intMakePckIndex(Begin, Till: DATE; trgMan: LIKE(Man.Man));
  VAR
   prvPerB,
   prvPerE: DATE;
 BEGIN
  APP.Get().NewPrompt(" ᤠ ᢥ");
  SETSEL(PkIdx, PkIdx); REMSEL(PkIdx);

  chkPkIdxMan   :=trgMan;
  chkPkIdxTill  :=Till;
  chkPkIdxMyFirm:=L_Packet.PckMyFirm;

  SAVE(Packet);
  SAVE(PckBody);
  prvPerE:=L_Packet.Get_PF_StdPerE(Till-1);
  prvPerB:=L_Packet.Get_PF_StdPerB(PerE);
  WHILE prvPerE > Begin DO
   PROMPT(L_DatTim.PeriodStr(prvPerB)+"-"+L_DatTim.PeriodStr(prvPerE));
   SETSEL(Packet, PacketEN, L_Packet.rcv_PensFund, prvPerB, prvPerE);
   FOR_EACH Packet DO
    IF (Packet.Kind = L_Packet.knd_PF_SPV2) & L_Packet.IsValidPacket() THEN
     IF ~!trgMan THEN
      IF SEARCH(PckBody, Man, trgMan, Packet.Packet) THEN
       AddPkIdx();
      END;
     ELSE
      CONFORM(Packet, PckBody);
      WHILE OCCURE(PckBody) DO
       AddPkIdx();
       NEXT(PckBody);
      END; (* WHILE OCCURE(PckBody) ... *)
     END; (* IF ~!trgMan ... *)
    END; (* IF L_Packet.IsAcceptablePacket() ... *)
   END; (* FOR_EACH Packet ... *)
   L_Packet.Get_PF_PrvPer(prvPerB, prvPerE);
  END; (* WHILE prvPerB > ... *)
  RESTORE(PckBody);
  RESTORE(Packet);
 END {intMakePckIndex};

 PRIVATE PROCEDURE MakePckIndex(Till: DATE; trgMan: LIKE(Man.Man));
 BEGIN
  intMakePckIndex(01\01\2010, Till, trgMan);
 END {MakePckIndex};

 PRIVATE PROCEDURE StandOnPkIdx(trgPerB,
                                trgPerE: DATE;
                                trgMan : LIKE(Man.Man);
                                trgType: LIKE(ManSFee.Type)): SCAL[2];
 BEGIN
  L_General.CallUs(!chkPkIdxMan | (chkPkIdxMan = trgMan));
  L_General.CallUs(chkPkIdxTill > trgPerE);
  L_General.CallUs(chkPkIdxMyFirm = L_Packet.PckMyFirm);
  RETURN SEARCH(PkIdx, PkIdx, trgPerB, trgPerE, trgMan, trgType);
 END {StandOnPkIdx};

 PRIVATE PROCEDURE GetNxtPer(curPerE: DATE; VAR nxtPerB, nxtPerE: DATE);
 BEGIN
  nxtPerE:=L_Packet.Get_PF_StdPerE(L_Packet.Get_PF_StdPerE(curPerE)+1);
  nxtPerB:=L_Packet.Get_PF_StdPerB(nxtPerE);
 END {GetNxtPer};

 PRIVATE PROCEDURE CreatePkIdx();
 BEGIN
  L_AFM.MakeMultipleIndex("PkIdx", "PerB    : DATE;"+
                                   "PerE    : DATE;"+
                                   "Man     : LIKE(Man.Man);"+
                                   "MSFeeTp : LIKE(ManSFee.Type);"+
                                   "Packet  : LIKE(Packet.Packet);"+
                                   "SeqNbr  : LIKE(PckBody.SeqNbr);"+
                                   "DTStamp : LIKE(Packet.DTStamp)",
                          "PkIdx: PerB, PerE, Man, MSFeeTp;"+
                          "Man: Man, PerB, PerE");
 END {CreatePkIdx};

 PRIVATE PROCEDURE InitServices(trgPerB, trgPerE: DATE);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

  SetDateParms(trgPerB, trgPerE);

  L_Tax.Tax2001_InitCodes(PerB);

  CREATE_TABLE(_MIns);
  CREATE_FIELD(_MIns, Man,      LIKE(Man.Man));
  CREATE_FIELD(_MIns, BegD,     DATE);
  CREATE_FIELD(_MIns, EndD,     DATE);
  CREATE_FIELD(_MIns, PostName, LIKE(Post.Name));
  CREATE_FIELD(_MIns, Type,     L_Packet.tMInsType);
  CREATE_INDEX(_MIns, _MIns, PLURAL, , , Man, BegD, EndD, Type);
  SET_VERSION_OF_TABLE(_MIns, 0000);
  L_AFM.CreateTemp("_MIns");

  CREATE_TABLE(StfLg);
  CREATE_FIELD(StfLg, Numb, SCAL[2]);
  CREATE_FIELD(StfLg, TSN, LIKE(Staff.TSN));
  CREATE_FIELD(StfLg, DateB, DATE);
  CREATE_FIELD(StfLg, DateE, DATE);
  CREATE_FIELD(StfLg, Contract, LIKE(Staff.Contract));
  CREATE_FIELD(StfLg, PnsAttr,  LIKE(Officer.PnsAttr));

  CREATE_INDEX(StfLg, StfLg, PLURAL, , , Numb, DateB, Contract, TSN);
  SET_VERSION_OF_TABLE(StfLg, 0001);
  L_AFM.CreateTemp("StfLg");

  CREATE_TABLE(Prb01);
  CREATE_FIELD(Prb01, Man, LIKE(Man.Man));
  CREATE_FIELD(Prb01, Problem, STRING[200]);
  CREATE_FIELD(Prb01, Error, SCAL[2]);

  CREATE_INDEX(Prb01, Prb01, UNIQUE, , , Error, Man, Problem);
  CREATE_INDEX(Prb01, Man,   PLURAL, , , Man);
  SET_VERSION_OF_TABLE(Prb01, 0001);
  L_AFM.CreateTemp("Prb01");

  CREATE_TABLE(Intrm);
  CREATE_FIELD(Intrm, Type,     LIKE(ManSFee.Type));
  CREATE_FIELD(Intrm, DataType, LIKE(Packet.DataType));
  CREATE_FIELD(Intrm, CorrType, LIKE(Packet.CorrType));
  CREATE_FIELD(Intrm, Man,      LIKE(Man.Man));
  CREATE_FIELD(Intrm, Name,     LIKE(Man.Name));
  CREATE_FIELD(Intrm, ManPerB,  DATE);
  CREATE_FIELD(Intrm, ManPerE,  DATE);
  CREATE_FIELD(Intrm, Packet,   LIKE(Packet.Packet));
  CREATE_FIELD(Intrm, SeqNbr,   LIKE(PckBody.SeqNbr));

  CREATE_INDEX(Intrm, Intrm, UNIQUE, , , Type, DataType, CorrType, Name, Man);
  CREATE_INDEX_AND_LINK(Intrm, Man,    UNIQUE, Man, Man, USER, , , Man, Packet);
  CREATE_INDEX_AND_LINK(Intrm, Packet, UNIQUE, PckBody, Packet, USER, , , Packet, SeqNbr);
  SET_VERSION_OF_TABLE(Intrm, 0000);
  L_AFM.CreateTemp("Intrm");

  CreatePkIdx();
 END {InitServices};

 PRIVATE PROCEDURE ClearServices(Full: SCAL[2]);
 BEGIN
  SETSEL(Prb01, Man);    REMSEL(Prb01);
  IF Full THEN
   SETSEL(StfLg, StfLg);  REMSEL(StfLg);
   SETSEL(_MIns, _MIns);  REMSEL(_MIns);
   SETSEL(Intrm, Intrm);  REMSEL(Intrm);
  END;
  SETSEL(PkIdx, PkIdx);  REMSEL(PkIdx); chkPkIdxTill:=MINOF(DATE);
 END {ClearServices};

 PRIVATE PROCEDURE DeInitServices();
 BEGIN
  L_AFM.AF_PurgeTemp("Prb01");
  L_AFM.AF_PurgeTemp("StfLg");
  L_AFM.AF_PurgeTemp("_MIns");
  L_AFM.AF_PurgeTemp("Intrm");
  L_AFM.AF_PurgeTemp("PkIdx");
 END {DeInitServices};

 PRIVATE PROCEDURE CheckPrb01();
  CONST
   ErrLen = 73;
   RepName = "BdMIn";
  VAR
   ManStr,
   ErrStr   : STRING[];
   ErrStrArr: STRING[ErrLen][10];
 BEGIN
  IF SELECT(Prb01, Prb01, 1) THEN
   OPENREP(R_Prb, L_General.NameConnection(RepName), Create);
   MAKEPART(R_Prb, PrbTop, RepName);
   WHILE OCCURE(Prb01) DO
    SEARCH(Man, Man, , Prb01.Man);
    ManStr:=L_Man.Man_ManAsStr()+" "+Man.Name;
    Str.Format(ErrStrArr, Prb01.Problem, ErrLen, LEFT);
    FOR_EACH ErrStr IN ErrStrArr DO
     MAKEPART(R_Prb, PrbLine, ManStr, ErrStr);
     ManStr:="";
    END;
    NEXT(Prb01);
   END; (* WHILE OCCURE(Prb01) ... *)
   MAKEPART(R_Prb, PrbBot);
   CLOSEREP(R_Prb);
   L_General.HaltAndSurveyLastReport(EMPTYOF(Exc_Root));
  END;
 END {CheckPrb01};

 PRIVATE PROCEDURE MakeAll();
  VAR
   packetDataType: LIKE(Packet.DataType);
   packetCorrType: LIKE(Packet.CorrType);
   NumTot        : NUMERIC[0];
 BEGIN
  SETZERO(NumTot);

  SELECT(Packet, PacketDS, , L_Packet.rcv_PensFund, L_Packet.DTStamp);
  WHILE OCCURE(Packet) DO
   IF (Packet.PerE = PerE) THEN
    MakeOnePacket();
    INC(NumTot, CurNumInP);
   END;
   NEXT(Packet);
  END; (* WHILE OCCURE(Packet) ... *)

  CheckPrb01();
 END {MakeAll};

 PRIVATE PROCEDURE InsPrb01(Msg: STRING[]; IsError: SCAL[2]);
 BEGIN
  ADD(Prb01, Prb01, , IsError, Man.Man, Msg);
 END {InsPrb01};

 PRIVATE PROCEDURE IntrmPutOneMan(trgType: LIKE(ManSFee.Type); ManPerB, ManPerE: DATE; trgDataType: LIKE(Packet.DataType); trgCorrType: LIKE(Packet.CorrType));
 BEGIN
  DEFAULT(Intrm);
  Intrm.Man     :=Man.Man;
  Intrm.Name    :=L_Packet.GetManInPFRFName(SYSDATE());
  Intrm.Type    :=trgType;
  Intrm.DataType:=trgDataType;
  Intrm.CorrType:=trgCorrType;
  Intrm.ManPerB:=ManPerB;
  Intrm.ManPerE:=ManPerE;
  IF ~!Intrm.ManPerE & (Intrm.ManPerE # PerE) THEN
   PutManPerE(Intrm.ManPerE);
  END;
  INSERT(Intrm);
 END {IntrmPutOneMan};

 PRIVATE PROCEDURE NeedManInIntrm(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SETSEL(ManSFee, MyFirm, L_Packet.PckMyFirm, Man.Man, 1);
  SRCINSEL(ManSFee, GE, , GetManPerB());
  WHILE OCCURE(ManSFee) & (ManSFee.Period <= GetManPerE()) DO
   IF (ManSFee.Object # 0) | (ManSFee.Fee[L_SFee.p_PFIn] # 0) THEN
    RETURN 1;
   END;
   NEXT(ManSFee);
  END; (* WHILE OCCURE(ManSFee) ... *)
  RETURN 0;
 END {NeedManInIntrm};

 PRIVATE PROCEDURE GetManSFeeType(P: DATE): LIKE(ManSFee.Type);
  VAR
   dfnTypeStr: STRING[];
   dfnType   : LIKE(ManSFee.Type);
 BEGIN
  TRY
   dfnType:=L_SFee.DefineType(L_Packet.PckMyFirm, Man.Man, P);
  EXCEPT
  ON Exc:Exc_Raise DO (*0091495 25.04.2012 16:02:36 AK1786\Bor.Polak*)
   SETEMPTY(dfnType);
  END;
  IF SELECT(ManSFee, MyFirm, L_Packet.PckMyFirm, Man.Man, 1, P) THEN
   IF ManSFee.Type # dfnType THEN
    IF !dfnType THEN
     dfnTypeStr:='।'
    ELSE
     dfnTypeStr:=L_Str.PoolItem(L_SFee.t_Pool, dfnType);
    END;
    InsPrb01("    ᫮.  '"+L_Str.PoolItem(L_SFee.t_Pool, ManSFee.Type)+"', ⠫ '"+dfnTypeStr+"'. ॡ    "+L_DatTim.PeriodStr(P), 1)
   END;
  END;
  RETURN dfnType;
 END {GetManSFeeType};

 PRIVATE PROCEDURE ManHasManSFeeType(trgType: LIKE(ManSFee.Type);
                                     ManPerB,
                                     ManPerE: DATE): SCAL[2];
  VAR
   P: DATE;
 BEGIN
  IF trgType # L_SFee.t_woCtzn THEN
   P:=L_DatTim.Per(ManPerB);
   WHILE (P <= ManPerE) DO
    IF (trgType = GetManSFeeType(P)) THEN
     RETURN 1;
    END;
    P:=L_DatTim.NextPer(P);
   END;
  END;
  RETURN 0;
 END {ManHasManSFeeType};

 PRIVATE PROCEDURE PutManInIntrm(ManPerB, ManPerE: DATE);
  VAR
   curType    : LIKE(ManSFee.Type);
   prvCorrType: LIKE(Packet.CorrType);
   curGroup,
   prvGroup   : L_Packet.tPacketGroup;
   NeedBasic,
   NeedCancel : SCAL[2];
 BEGIN
  PROMPT(" "+L_Man.Man_ManAsStr());
  IF NeedManInIntrm() THEN
   IF ~!Man.SINumber THEN
    L_Russia.CheckSINumber(Man.SINumber, 0);
    FOR_EACH curType DO
     IF ManHasManSFeeType(curType, ManPerB, ManPerE) THEN
      IF L_Packet.BuildMode = L_Packet.bm_byPacket THEN
       IntrmPutOneMan(curType, ManPerB, ManPerE, Packet.DataType, Packet.CorrType);
      ELSE
       IntrmPutOneMan(curType, ManPerB, ManPerE, L_Packet.dt_Basic, L_Packet.ct_None);
      END;
      NeedCancel:=0;
     ELSE
      NeedCancel:=1;
     END;
 
     IF (L_Packet.BuildMode = L_Packet.bm_byPacket) THEN
      IF StandOnPkIdx(PerB, L_Packet.Get_PF_StdPerE(ManPerB), Man.Man, curType) THEN
       SAVE(Packet);
       SEARCH(Packet, Packet, , PkIdx.Packet);
       prvCorrType:=Packet.CorrType;
       RESTORE(Packet);
      ELSE
       SETEMPTY(prvCorrType);
      END;
      IF ~!prvCorrType THEN
       L_General.Assert((Packet.CorrType # L_Packet.ct_None) | (prvCorrType = L_Packet.ct_Cancel),
                        "  "+L_Man.Man_ManAsStr()+" 㦥   ᢥ  ଥ "+L_Str.PoolItem(L_Packet.knd_Pool, Packet.Kind)+" ( "+PkIdx.Packet+")|"+
                        " ਮ  "+L_DatTim.PeriodStr(Packet.PerB)+"  "+L_DatTim.PeriodStr(Packet.PerE)+L_StdFrm.HR()+
                        ",  뫨 㪠 ﭨ '"+L_Str.PoolItem(L_Packet.st_Pool, L_Packet.st_Rejected)+"'|"+
                        " ࠭ ନ஢   㫨஢ ");
      END;
      NeedBasic:=~NeedCancel & IsCorrPacket() & (!prvCorrType | (prvCorrType = L_Packet.ct_Cancel));
      NeedCancel:=NeedCancel & (~!prvCorrType & (prvCorrType # L_Packet.ct_Cancel));
      L_General.CallUs(~NeedBasic | ~NeedCancel);
      IF NeedCancel THEN
       IntrmPutOneMan(curType, ManPerB, L_Packet.Get_PF_StdPerE(ManPerB), L_Packet.dt_None, L_Packet.ct_Cancel);
      END;
      IF NeedBasic THEN
       L_StdFrm.Inform("㦭 室 ᢥ "+Man.Man+" "+L_DatTim.PeriodStr(PerB)+" "+L_DatTim.PeriodStr(PerE)+" "+GetCategoryNick(curType));
      END;
     END;
    END; (* FOR_EACH curType ... *)
   ELSIF IsInsuredInPF_InPer() THEN
    IF L_SFee.ManHasADV1() THEN
     InsPrb01(" ,   -1", 1);
    ELSE
     InsPrb01(" ", 1);
    END;
   END;
  END; (* IF NeedManInIntrm(( ... *)
  IF HasExcludedTSN(ManPerB) THEN
   InsPrb01("᪫祭   ᢥ", 0);
  END;
 END {PutManInIntrm};

 PRIVATE PROCEDURE BuildPackets();
  VAR
   PacketSize: NUMERIC[0];
 BEGIN
  PacketSize:=P_OwnData.ODPacketSize(L_Packet.PrepareDate);
  SELECT(Intrm, Intrm);
  WHILE OCCURE(Intrm) DO
   NARROWSEL(Intrm, Type, DataType, CorrType);
   CurNumInP:=0;
   WHILE OCCURE(Intrm) DO
    PROMPT("⮢ ⮢ "+ Intrm.Man);
    CurNumInP:=(CurNumInP MOD PacketSize)+1;
    INC(CurPacket, CurNumInP = 1);
    SetPckBodyByIntrm(CurPacket);
    NEXT(Intrm);
   END;
   NEXTINEXTENDEDSEL(Intrm, Type, DataType, CorrType);
  END;
 END {BuildPackets};

 PRIVATE PROCEDURE MakeByPacket();
 BEGIN
  SELECT(PckBody, Packet, , Packet.Packet);
  WHILE OCCURE(PckBody) DO
   IF ~SELECT(Intrm, Man, PckBody.Man) THEN (*  㦥 㯮  㣮 -ࠧ*)
    MakePckIndex(L_DatTim.NextPer(L_Packet.Get_PF_StdPerE(Packet.PerE)), PckBody.Man);
    CONFORM(PckBody, Man);
    PutManInIntrm(GetManPerB(), GetManPerE());
   END;
   NEXT(PckBody);
  END; (* WHILE OCCURE(PckBody) ... *)
 END {MakeByPacket};

 PRIVATE PROCEDURE PerBMoney(D: DATE): DATE;
 BEGIN
  IF D # L_DatTim.MonthBeg(D) THEN
   RETURN L_DatTim.MonthEnd(D)+1;
  ELSE
   RETURN D;
  END;
 END {PerBMoney};

 PRIVATE PROCEDURE PerEMoney(D: DATE): DATE;
 BEGIN
  IF D # L_DatTim.MonthEnd(D) THEN
   RETURN L_DatTim.MonthBeg(D)-1;
  ELSE
   RETURN D;
  END;
 END {PerEMoney};

 PRIVATE PROCEDURE CheckPer();
  VAR
   Strong : SCAL[2];
   ErrStr : STRING[];
   curPerE: DATE;
 BEGIN
  Strong:=(L_Packet.BuildMode = L_Packet.bm_byAll) | (L_Packet.BuildMode = L_Packet.bm_byPacket);

  IF L_Packet.BuildMode = L_Packet.bm_byPacket THEN
   curPerE:=MINOF(DATE);
   SELECT(PckBody, Packet, , Packet.Packet);
   WHILE OCCURE(PckBody) DO
    curPerE:=Math.Max(curPerE, PerEMoney(GetManPerE()));
    NEXT(PckBody);
   END; (* WHILE OCCURE(PckBody) ... *)
   curPerE:=Math.Min(curPerE, PerE);
  ELSE
   curPerE:=PerE;
  END;

  ErrStr:="";
  IF ~L_SFee.SFeeIsCalculatedInProperConsecution(L_DatTim.Per(curPerE)) THEN
   ErrStr:=" 믮  客 ᮢ  "+L_DatTim.PeriodStr(curPerE);
  END;

  IF ~!ErrStr THEN
   IF Strong THEN
    L_General.Assert_wReferToAdmin(0, ErrStr);
   ELSE
    L_StdFrm.Choice(ErrStr);
   END;
  END;
 END {CheckPer};

 PRIVATE PROCEDURE InsDefPFPacket(trgExtNbr: LIKE(Packet.ExtNbr); trgDataType: LIKE(Packet.DataType); trgCorrType: LIKE(Packet.CorrType));
 BEGIN
 END {InsDefPFPacket};

 PRIVATE PROCEDURE SetDateParms(trgPerB, trgPerE: DATE);
 BEGIN
  PerB:=trgPerB;
  PerE:=trgPerE;

  L_DatTim.CheckWMIntvl(PerB, PerE);

  Year:=L_DatTim.YEAR(PerE);
  L_General.Assert(Year = L_DatTim.YEAR(PerB), "ਮ ᢥ    । ");
 END {SetDateParms};

 PRIVATE PROCEDURE GetManPerB(): DATE;
 BEGIN
  RETURN L_DatTim.GetFirstDateOfQuartal(PerE);
 END {GetManPerB};

 PRIVATE PROCEDURE GetManPerE(): DATE;
  VAR
   D  : DATE;
   Msg: STRING[];
 BEGIN
  IF L_Packet.BuildMode = L_Packet.bm_byPacket THEN
   D:=GetPckBodyManPerE();
   IF !D THEN
    RETURN PerE;
   ELSE
    Msg:=" "+Packet.ExtNbr+" ( "+Packet.Packet+")"+
         "|ਮ  "+L_DatTim.DateStr(Packet.PerB)+
         "  "+L_DatTim.DateStr(Packet.PerE)+
         "| |ப "+PckBody.SeqNbr+" ( "+PckBody.Man+")"+
         "|ਮ  "+L_DatTim.DateStr(Packet.PerB)+
         "  "+L_DatTim.DateStr(D)+"| |";
    L_General.Assert(IsForPensPacket(), Msg+"࠭祭 ਮ    ਬ|⮫쪮    ⨯ '祭 ᨨ'");
    L_General.Assert(L_DatTim.Per(D) = L_DatTim.Per(PerE), Msg+" 砭 ਮ  |    砭 ਮ   楫");
    RETURN D;
   END;
  ELSE
   RETURN PerE;
  END;
 END {GetManPerE};

 PRIVATE PROCEDURE PutManPerE(_ManPerE: DATE);
 BEGIN
  L_Packet.PutPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_ManPerE, FLDTOSTR(_ManPerE, "D.N.y"));
 END {PutManPerE};

 PRIVATE PROCEDURE SetPerByWord(WithOrigin: SCAL[2]);
  VAR
   QSign: STRING[4];
   bQ,
   eQ   : SCAL[4];
 BEGIN
  bQ:=L_DatTim.QUARTAL(PerB);
  eQ:=L_DatTim.QUARTAL(PerE);

  SETEMPTY(Quarter);
  IF    (bQ = 0) & (eQ = 0) THEN Quarter:=3;
  ELSIF (bQ = 0) & (eQ = 1) THEN Quarter:=6;
  ELSIF (bQ = 0) & (eQ = 2) THEN Quarter:=9;
  ELSIF (bQ = 0) & (eQ = 3) THEN Quarter:=0;
  END;
  IF !Quarter | (PerB # L_DatTim.YearBeg(PerB)) THEN
   L_General.Error(" "+Year+"     ਮ  砫 ");
  END;
  PerByWord:="() ["+  L_Str.PoolItem("3|6|9|0", eQ)+"]    "+Year;

  IF WithOrigin THEN
   orgnPerByWord:=PerByWord;
   orgnPerE:=PerE;
   orgnYear:=Year;
   orgnQuarter:=Quarter;
  END;
 END {SetPerByWord};

 PRIVATE PROCEDURE GetActualDate(byPacket: SCAL[2]): DATE;
 BEGIN
  RETURN PerE;
 END {GetActualDate};

 PRIVATE PROCEDURE CheckPrvUnDonePackets();
  CONST
   Begin = 01\01\2013; (*15.07.2013 16:18:52 POLAK\Bor. 0098251    01.2010,   ᯮ墠⨫*)
  VAR
   prvPerB,
   prvPerE    : DATE;
 BEGIN
  APP.Get().NewPrompt("஢ઠ ᤠ ⮢");
  SAVE(Packet);
  prvPerE:=L_Packet.Get_PF_StdPerE(PerE);
  prvPerB:=L_Packet.Get_PF_StdPerB(PerB);
  WHILE prvPerE > Begin DO
   L_Packet.Get_PF_PrvPer(prvPerB, prvPerE);
   PROMPT(L_DatTim.PeriodStr(prvPerB)+"-"+L_DatTim.PeriodStr(prvPerE));
   L_Packet.CheckUnDonePacketsStrong(L_Packet.Get_PF_PacketKind(prvPerB, prvPerE, L_Packet.dt_Basic, L_Packet.ct_None),
                                     prvPerB, prvPerE, L_Packet.dt_Basic, L_Packet.ct_None);
  END; (* WHILE prvPerB > ... *)
  RESTORE(Packet);
 END {CheckPrvUnDonePackets};

 PUBLIC PROCEDURE Single();
  VAR
   Dummy: SCAL[2];
   nPack: L_XML.tNode;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Man), " ⠭ 䨧᪮ ");
  TRY [ABORT_AFTER(AA_ON)]
   InitServices(Memo.ud_fr(), Memo.ud_ut());
   CurPacket:=L_Packet.trn_Init(GetActualDate(0), L_Packet.bm_bySingle, L_Packet.part_Manins, L_Packet.knd_PF_SPV2);
   CheckPer();
   SetPerByWord(1);
   L_Packet.InsPFPacket(L_Packet.knd_PF_SPV2, CurPacket, PerB, PerE, L_Packet.dt_Basic, L_Packet.ct_None);
   CurNumInP     :=0001;
   TotNumInP     :=CurNumInP;
   L_Packet.trn_OpenFiles();
   nPack:=L_Packet.trn_PutHead();

   L_Packet.MakeProjectPrt();
   PutManInIntrm(GetManPerB(), GetManPerE());

   IF SELECT(Intrm, Intrm) THEN
    SetPckBodyByIntrm(CurPacket);
    WHILE OCCURE(Intrm) DO
     PROMPT("⮢ ⮢ "+ Intrm.Man);
     NARROWSEL(Intrm, Type, DataType, CorrType);
     WHILE OCCURE(Intrm) DO
      CurNumInP:=0;
      PrepareOneMan();
      CheckPrb01();
      MakeOneMan(nPack);
      ClearServices(0);
      NEXT(Intrm);
     END;
     NEXTINEXTENDEDSEL(Intrm, Type, DataType, CorrType);
    END;

    L_Packet.trn_CloseFiles(nPack);
    DeInitServices();
   ELSE
    CheckPrb01();
    L_StdFrm.BlueHalt(" 室   ᢥ");
   END;
  EXCEPT
  END;
  Dummy:=L_Packet.ChoosePacket(L_Packet.Get_PF_PacketKind(PerB, PerE, L_Packet.dt_Basic, L_Packet.ct_None),
                               PerB, PerE,
                               L_Packet.dt_Basic, L_Packet.ct_None);
  L_General.SurveyLastReport();
 END {Single};

 PRIVATE PROCEDURE intMakeManIns();
 BEGIN
 END {intMakeManIns};

 PUBLIC PROCEDURE ByCurrentPacket();
  VAR
   nxtPerB,
   nxtPerE   : DATE;
 BEGIN
  L_General.Assert(ACCESS(Packet), " । ");

  L_General.CallUs(Packet.Kind = L_Packet.knd_PF_SPV2);

  InitServices(Packet.PerB, Packet.PerE);

  L_Packet.SetSamplePacketDone();
  SAVE(Packet);
  CurPacket:=L_Packet.trn_Init(GetActualDate(1), L_Packet.bm_byPacket, L_Packet.part_Manins, Packet.Kind);
  CheckPer();
  DEC(CurPacket); (* ନ㥬 ᢮  -  ⢮   *)
  RESTORE(Packet);

  L_General.CallUs(Packet.Kind = L_Packet.knd_PF_SPV2);

  IF (Packet.Kind = L_Packet.knd_PF_SPV2) & IsCorrPacket() THEN
   GetNxtPer(PerE, nxtPerB, nxtPerE);
   SetDateParms(nxtPerB, nxtPerE);
   SetPerByWord(1);
   SetDateParms(Packet.PerB, Packet.PerE);
   SetPerByWord(0);
  ELSE
   SetPerByWord(1);
  END;

  MakeByPacket();

  BuildPackets();
  MakeAll();
  DeInitServices();
  L_Packet.ShowMakedPackets();
 END {ByCurrentPacket};

END.