(*
%Copyright   (c) Polak IT
%Author      21.11.2005 19:36:37 POLAK\Gina
%Purpose     ࠢ SrMnthly
%Type        operation
%Specific    AP
%Modified    18.07.2012 18:14:04 POLAK\LDA
%Environment
*)

 MODULE SrMnthly [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_PRoll, L_General, P_Sort, L_Str, L_DatTim, L_StdFrm;

 PRIVATE PROCEDURE InsSrMnthly();
 BEGIN
  SrMnthly.Sort  :=Sort.Sort;
  SrMnthly.Period:=Memo.ud_mb();
  SrMnthly.FOT   :=0;
  SrMnthly.Bonus :=0;
  SrMnthly.Harm  :=0;
  SrMnthly.Done  :=0;
  INSERT(SrMnthly);
 END {InsSrMnthly};

 PUBLIC PROCEDURE Renew();
 BEGIN
  L_General.Assert(SEARCH(Property, Property, P_Sort.P_BrigadeContract), "  ᢮⢮ ᥪ "+L_Str.IntStr(P_Sort.P_BrigadeContract));
  L_StdFrm.Question(" ᯨ᮪ ਣ  "+L_DatTim.PeriodStr(Memo.ud_mb())+"| ᮮ⢥⢨  ᢮⢠ ᥪ஢|"+Property.Property+" "+Property.Name);
  L_PRoll.Salary_CheckNoTouch(Memo.ud_mb());
 
  SELECT(SrMnthly, Period, , Memo.ud_mb());
  WHILE OCCURE(SrMnthly) DO
   CONFORM(SrMnthly, Sort);
   PROMPT(Sort.Sort);
   IF ~P_Sort.HasActualPro(Sort.Sort, Memo.ud_mb(), P_Sort.P_BrigadeContract) |
      ~L_DatTim.IsActive(Memo.ud_mb(), Sort.Begin, Sort.Till) THEN
    L_General.Assert((SrMnthly.FOT=0) & (SrMnthly.Bonus=0) & (SrMnthly.Harm=0),
                     "ਣ " + SrMnthly.Sort + "  㬬");
    REMOVE(SrMnthly);
   ELSE
    NEXT(SrMnthly);
   END;
  END; (* WHILE OCCURE(SrMnthly)... *)
 
  SELECT(Sort, Sort);
  WHILE OCCURE(Sort) DO
   PROMPT(Sort.Sort);
   IF P_Sort.HasActualPro(Sort.Sort, Memo.ud_mb(), P_Sort.P_BrigadeContract) &
      L_DatTim.IsActive(Memo.ud_mb(), Sort.Begin, Sort.Till) THEN
    IF ~SEARCH(SrMnthly, Sort, Sort.Sort, Memo.ud_mb()) THEN
     InsSrMnthly();
    END;
   END;
   NEXT(Sort);
  END; (* WHILE OCCURE(Sort) *)
 END {Renew};

 PUBLIC PROCEDURE Insert();
 BEGIN
  L_General.Error(" ࠢ筨  쭮 ");
 END {Insert};

 PUBLIC PROCEDURE Delete();
 BEGIN
  L_General.Error(" ࠢ筨  쭮 ");
 END {Delete};

END.
