(*
%Copyright   (c) Polak Computer System
%Author      01.08.2003 11:31:05 POLAK\Bor
%Purpose       㤮 ⠦ 客   ਮ 
%Purpose     ॣ樨  ⥬ . ᨮ 客(-)
%Type        report
%Specific    SYS
%Modified    04.08.2014 12:40:23 POLAK\Bor
%Environment
*)

 IMPORT L_General, L_Packet, L_AFM, L_Russia, L_DatTim, L_Str, L_Man, L_Staff, L_XML,
        L_STx, L_Acnt, L_Pmnt, L_AvePay, P_Staff, P_Man, P_Firm,
        L_StdFrm, L_APtm, L_Prop, P_OwnData, L_Tax, L_EC, L_Sheet,
        Math, Str, FIO, P_MyFirm, E_Staff, E_PRoll, L_Env;

 CONST
  mInitialSingle    = 100;
  mInitialAll       = 101;
  mByPacketAll      = 102;
  mIteratedAll      = 103;

  vByPacketNewAll   = 1;
  vByPacketNewReDo  = 2;

  Path        = "REP\ANK";

  MaxPerAmo   = 24;
  MaxStageNum = 1024;
  PagLength   = 80;
  FirstDate   = 01\01\1900;
  LastDate    = 31\12\2001;

  ActvC_DVSTO = 9; (**) (*ManActv.ActvCatg*)

 VAR
  CurPacket       : L_Packet.tPFExtNbr;
  CurPageInP,
  CurNumInP       : NUMERIC[0];
  CurManName      : LIKE(Man.Name);

  PerB,
  PerE            : DATE;

 TYPE
  tMInsSpec    = STRING[24][2];

 CONST
  priv_Tot  = "ᥣ";
  priv_TERR = "";
  priv_SPEC = "";
  priv_LONG = "";
  priv_TERRxxx = ""; (*- 檮 ࠧ  ⭮ ମ  䠩*)

  priv_Empty = "";

  pg_SZVK    =  7;
  pg_SZVKwPA =  8;
  pg_SZVKwTC =  9;   (*with TerrCond*)
  pg_SZVKwPATC = 10; (*with TerrCond and PnsAttr*)
  pg_9998 = 14;
  pg_9999 = 15;

  ag_NULL = 00;
  ag_NR   = 01;
  ag_NRIV = 02;

  ady_Current  = 0;
  ady_Previous = 1;
  ady_Total    = 2;

  patt_Group = "㯯";

  lsat_HoursMins  = 0;
  lsat_Count      = 1;
  lsat_MonthsDays = 2;
  lsat_Calc       = 3;


(*
$P{ SZV_K_PageNum:
CurPageInP, R, ""
@
                                                                           ####
}
*)

(*
$P{ SZV_K_Top:
Packet.ExtNbr, R, ""
CurNumInP, R, ""
L_Packet.SINumberToAnyOut(Man.SINumber), L, ""
?, L, ""
?, L, ""
Packet.DataType, L, " |X| "
?, L, ""
Packet.CorrType, L, " |X| "
L_DatTim.FullDateStr(Man.Birth), L, ""
Packet.CorrType, L, " | |X"
?, L, ""
@
                                           N 窨  #####       N 㬥 ###
ଠ -                                                   ________

   
客   ਮ  ॣ樨
 ⥬ 易⥫쭮 ᨮ 客
                                                        -----------------------
客 : ##############                         |             |
      : ######################################## |                     |
          : ######################################## | # 室          |
     ⢮: ######################################## | # ४    |
 ஦: ######################################## | # ⬥        |
ਠ ᫮ ஦  31.12.2001:       -----------------------
#######################################################

       ਮ 㤮   ⢥  ⥫쭮
}
*)

(*
$P{ SZV_K_PageTop:
Packet.ExtNbr, R, ""
CurNumInP, R, ""
?, R, ""
L_Packet.SINumberToAnyOut(Man.SINumber), L, ""
L_Str.ShortName(CurManName), L, ""
?, C, " |ਮ 㤮   ⢥  ⥫쭮"
@
                                           N 窨  #####       N 㬥 ###
ଠ -                                           ________  ##
客   : ##############
, 樠: ############################################################

###############################################################################
}
*)

(*
$P{ SZV_K_PerTop:
?, R, ""
?, L, ""
?, L, ""
?, L, ""
@

##.  ࣠樨 ###################################################
################################################################################
 ⥫쭮 () ##################
--------------------------------------------------------------------------------
|N |          |          |    | ᮡ |   塞   |     㣠      |
| |  砫  |     || ᫮|  㤮 ⠦  |                     |
| |  ਮ |  ਮ |.| 㤠  |-----------------|---------------------|
| |          |          |    |        |᭮. |.|᭮.|.ᢥ.|
|--|----------|----------|----|--------|-------|---------|--------|------------|
}
*)

(*
$P{ SZV_K_PerLine:
?, L, ""
?, L, "D.N.y"
?, L, "D.N.y"
?, L, ""
?, L, ""
?, L, ""
?, C, ""
?, L, ""
?, C, ""
@
|##|##########|##########|####|########|#######|#########|########|############|
}
*)

(*
$P{ SZV_K_PerLineAdd:
?, R, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
|  |          |          |####|################|#########|########|############|
}
*)

(*
$P{ SZV_K_PerPost:
?, L, ""
@
|------------------------------------------------------------------------------|
|(  ) ####################################################|
}
*)

(*
$P{ SZV_K_PerLineSep:
@
|------------------------------------------------------------------------------|
}
*)

(*
$P{ SZV_K_PerSep:
@
--------------------------------------------------------------------------------
}
*)

(*
$P{ SZV_K_InfoTop:
?, R, ""
?, R, ""
?, R, ""
@

   ﭨ  1 ﭢ 2002   業 ᨮ
ࠢ 客  (樨)

-------------------------------------------------------------------------------
|   | ⠦                                            |  |楢| |
|---|-----------------------------------------------------|-----|-------|-----|
| 1.|騩 㤮 ⠦                                  |#####|#######|#####|
|---|-----------------------------------------------------|-----|-------|-----|
| 2.|⠦, 騩 ࠢ  筮          |        |  |楢| |
|   |祭 㤮 ᨨ               |           |     |       |     |
|---|-----------------------------------------|-----------|-----|-------|-----|
}
*)

(*
$P{ SZV_K_InfoSep:
@
|---|-----------------------------------------|-----------|-----|-------|-----|
}
*)

(*
$P{ SZV_K_InfoLine:
?, L, ""
?, C, ""
?, R, ""
?, R, ""
?, R, ""
@
|   |#########################################|###########|#####|#######|#####|
}
*)

(*
$P{ SZV_K_Bot:
?, L, ""
?, C, ""
L_Packet.ActingLeadPostName, L, ""
L_Str.ShortName(L_Packet.ActingLeadName), L, ""
L_DatTim.FullDateStr(L_Packet.PrepareDate), L, ""
@
-------------------------------------------------------------------------------
 ###         ।⠢  ### 

  㪮⥫               ஢ 


###################################                      ######################


 ##############################              ..


 ᢥﬨ  㤮 ⠦                   
                                                           客 }
*)

 PRIVATE PROCEDURE SingleMode(): SCAL[2];
 BEGIN
  RETURN MODE = mInitialSingle;
 END {SingleMode};

 PRIVATE PROCEDURE ByCurrentPacketMode(): SCAL[2];
 BEGIN
  RETURN MODE = mByPacketAll;
 END {ByCurrentPacketMode};

 PRIVATE PROCEDURE AllMode(): SCAL[2];
 BEGIN
  RETURN (MODE = mInitialAll) | (MODE = mIteratedAll) | ByCurrentPacketMode();
 END {AllMode};

 PRIVATE PROCEDURE E_SZVK_CheckPension(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(L_Packet.PrepareDate, PROCREF(E_PRoll.SZVK_CheckPension), 1);
 END {E_SZVK_CheckPension};

 PRIVATE PROCEDURE E_SZVK_NeedSeparateTerrCond(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(L_Packet.PrepareDate, PROCREF(E_PRoll.SZVK_NeedSeparateTerrCond), 0);
 END {E_SZVK_NeedSeparateTerrCond};

 PRIVATE PROCEDURE E_SZVK_NeedPacketPages(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(L_Packet.PrepareDate, PROCREF(E_PRoll.SZVK_NeedPacketPages), 0);
 END {E_SZVK_NeedPacketPages};

 PRIVATE PROCEDURE GoodTSN(): SCAL[2];
 BEGIN
  RETURN L_Env.RealTSN(Staff.TSN) &
         (Staff.MyFirm = L_Packet.PckMyFirm) &
         ~L_Packet.E_ManIns_ExcludedTSN(L_Packet.PrepareDate);
 END {GoodTSN};

 CONST
  ssfp_NotInState = " ";
  ssfp_Ordinary   = "0";

 PRIVATE PROCEDURE SpecToOut(_Spec: tMInsSpec): tMInsSpec;
 BEGIN
  IF _Spec[0] = ssfp_Ordinary THEN
   _Spec[0]:="";
  END;
  RETURN _Spec;
 END {SpecToOut};

 PRIVATE PROCEDURE InsSL(B, E: DATE; _Spec: tMInsSpec; _SenAddS: LIKE(ManActv.SenAddS);
                             _PostName: STRING[]);
  VAR
   D1, D2,
   PrvD2 : DATE;
   Cnt   : NUMERIC[0];
   Ok    : SCAL[2];
 BEGIN
  SAVE(_MIns);
  Cnt:=0;
  Ok  :=1;
  PrvD2:=L_DatTim.MINDATE();
  SELECT(_MIns, _MIns, , Man.Man);
  WHILE OCCURE(_MIns) & Ok DO
   IF _MIns.EndD > PrvD2 THEN
    SAVE(_MIns);
    D1:=Math.Max(_MIns.BegD, PrvD2+1);
    D2:=_MIns.EndD;
    PrvD2:=D2;
    IF B < D1 THEN
     IF E >= D1 THEN
      INC(Cnt);
      DEFAULT(_MIns);
      _MIns.Man:=Man.Man;
      _MIns.BegD:=B;
      _MIns.EndD:=D1-1;
      _MIns.Spec:=SpecToOut(_Spec);
      _MIns.SenAddS:=_SenAddS;
      _MIns.PostName:=_PostName;
      _MIns.FirmName:=GetOwnFirmName(_MIns.EndD);
      SETZERO(_MIns.Seniorit, _MIns.SenAddN, _MIns.LongSrvN, _MIns.TerrCndC);
      INSERT(_MIns);
      Ok:=0;
      IF E > D2 THEN
       InsSL(D2+1, E, _Spec, _SenAddS, _PostName);
      END;
     END;
    ELSIF B <= D2 THEN
     INC(Cnt);
     IF E > D2 THEN
      InsSL(D2+1, E, _Spec, _SenAddS, _PostName);
      Ok:=0;
     END;
    END;
    RESTORE(_MIns);
   END;
   NEXT(_MIns);
  END;
  RESTORE(_MIns);
  IF Cnt = 0 THEN
   DEFAULT(_MIns);
   _MIns.Man:=Man.Man;
   _MIns.BegD:=B;
   _MIns.EndD:=E;
   _MIns.Spec:=SpecToOut(_Spec);
   _MIns.SenAddS:=_SenAddS;
   _MIns.PostName:=_PostName;
   _MIns.FirmName:=GetOwnFirmName(_MIns.EndD);
   SETZERO(_MIns.Seniorit, _MIns.SenAddN, _MIns.LongSrvN, _MIns.TerrCndC);
   INSERT(_MIns);
  END;
 END {InsSL};

 PRIVATE PROCEDURE GetManStrId(_Man: LIKE(Man.Man)): STRING[];
 BEGIN
  RETURN Packet.ExtNbr+"-"+L_Str.IntStr(CurNumInP) + " (" + _Man + ")";
 END {GetManStrId};

 PRIVATE PROCEDURE MakeStfLg(From: DATE);
  VAR
   DB, DE,
   B,  E    : DATE;
   PrvOut,
   Out,
   Rem,
   NewPns,
   NewPost,
   Need     : SCAL[2];
   _PnsAttr : LIKE(Officer.PnsAttr);
   _TSN     : LIKE(Staff.TSN);
   _Contract: LIKE(Staff.Contract);
   _Post    : LIKE(Officer.Post);
 BEGIN
  SELECT(StfLg, StfLg);
  REMSEL(StfLg);

  SELECT(Staff, Man, , Man.Man);
  WHILE OCCURE(Staff) DO
   IF (Staff.Contract#L_Staff.cnt_InternalCombine) & GoodTSN() &
      (L_DatTim.DATEINT(PerB, PerE, Staff.BegDate, Staff.EndDate) > 0) THEN
    PrvOut:=1;
    SETEMPTY(_PnsAttr, _Post);
    SETSEL(StaffLog, TSN, Staff.TSN);
    SRCINSEL(StaffLog, LE, , Math.Max(From, Staff.BegDate));
    LOOP
     Out:=~OCCURE(StaffLog) | (StaffLog.Date>Math.Min(PerE, Staff.EndDate)) | L_Staff.IsDischargeStaffLog();
     IF ~Out THEN
      CONFORM(StaffLog, Officer);
      NewPns :=_PnsAttr # Officer.PnsAttr;
      NewPost:=_Post    # Officer.Post;
     ELSE
      NewPns :=0;
      NewPost:=0;
     END;
     IF (PrvOut # Out) | NewPns | NewPost THEN
      IF ~PrvOut THEN
       IF ~OCCURE(StaffLog) THEN
        E:=PerE;
       ELSE
        E:=Math.Min(PerE, StaffLog.Date-1);
       END;
       StfLg.Numb:=0;
       StfLg.TSN:=Staff.TSN;
       StfLg.Contract:=Staff.Contract;
       StfLg.DateB:=B;
       StfLg.DateE:=E;
       StfLg.PnsAttr:=_PnsAttr;
       StfLg.Post:=_Post;
       INSERT(StfLg);
       SETEMPTY(_PnsAttr, _Post);
      END;
      IF PrvOut | NewPns | NewPost THEN
       B:=Math.Max(From, StaffLog.Date);
       _PnsAttr:=Officer.PnsAttr;
       _Post:=Officer.Post;
      END;
     END;
     PrvOut:=Out;
     IF ~OCCURE(StaffLog) THEN
      EXIT;
     END;
     NEXT(StaffLog);
    END;
   END; (* IF Staff.Contract ... *)
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  SELECT(StfLg, StfLg, , 0);
  WHILE OCCURE(StfLg) DO
   _TSN:=StfLg.TSN;
   B:=StfLg.DateB;
   E:=StfLg.DateE;
   DB:=B;
   DE:=E;
   _PnsAttr:=StfLg.PnsAttr;
   _Post   :=StfLg.Post;
   _Contract:=StfLg.Contract;

   Need:=1;
   SAVE(StfLg);
   Rem:=1;
   NEXT(StfLg);
   WHILE OCCURE(StfLg) & (StfLg.DateB<=E) & Rem DO
    Rem:=0;
    IF (StfLg.PnsAttr = 00) & (StfLg.Contract # L_Staff.cnt_Basic) THEN
     IF StfLg.DateE <= E THEN
      REMOVE(StfLg);
      Rem:=1;
     ELSE
      StfLg.DateB:=E+1;
      REPLACE(StfLg);
     END;
    ELSE
     IF StfLg.DateB > B THEN
      DE:=StfLg.DateB-1;
      B:=StfLg.DateB;
      PREV(StfLg);
      StfLg.DateB:=B;
      INSERT(StfLg);
     ELSE (*StfLg.DateB = B*)
      IF StfLg.DateE<E THEN
       DE:=StfLg.DateE;
       SAVE(StfLg);
       B:=StfLg.DateE+1;
       PREV(StfLg);
       StfLg.DateB:=B;
       INSERT(StfLg);
       RESTORE(StfLg);
      END;
      IF (_Contract # L_Staff.cnt_Basic) & (_PnsAttr = 00) THEN
       Need:=0;
      ELSE
       IF StfLg.DateE>E THEN
        SAVE(StfLg);
        StfLg.DateB:=E+1;
        INSERT(StfLg);
        RESTORE(StfLg);
        StfLg.DateE:=E;
        REPLACE(StfLg);
       END;
       IF   (_PnsAttr = 00) & (_Contract = L_Staff.cnt_Basic) THEN
        _PnsAttr:=StfLg.PnsAttr;
        _Post   :=StfLg.Post;
        REMOVE(StfLg);
       END;
      END;
     END;
    END;
   END;
   IF Need THEN
    DEFAULT(StfLg);
    StfLg.Numb:=1;
    StfLg.TSN:=_TSN;
    StfLg.DateB:=DB;
    StfLg.DateE:=DE;
    StfLg.PnsAttr:=_PnsAttr;
    StfLg.Post   :=_Post;
    INSERT(StfLg);
   END;
   RESTORE(StfLg);
   NEXT(StfLg);
  END; (* WHILE OCCURE(StfLg) ... *)
 END {MakeStfLg};

 PRIVATE PROCEDURE GetAvePay(VAR _APJMode: LIKE(Sheet.JMode); VAR BD, ED: DATE): SCAL[2];
 BEGIN
  IF Sheet.Source = L_Sheet.src_AvePay THEN
   SETSEL(AvePay, TSN, StfLg.TSN);
   SRCINSEL(AvePay, LE, , Sheet.Period+Sheet.Day-1);
   WHILE OCCURE(AvePay) DO
    IF L_AvePay.IsRealAvePay() THEN
     CONFORM(AvePay, AvePayP);
     WHILE OCCURE(AvePayP) DO
      CONFORM(AvePayP, AveTypeP);
      IF ~!AveTypeP.JMode & L_DatTim.IsActive_Inc(Sheet.Period+Sheet.Day-1, AvePayP.StartD, AvePayP.StopD) THEN
       _APJMode:=AveTypeP.JMode;
       BD:=AvePayP.StartD;
       ED:=AvePayP.StopD;
       RETURN 1;
      END;
      NEXT(AvePayP);
     END; (* WHILE OCCURE(AvePayP) ... *)
    END;
    PREV(AvePay);
   END; (* WHILE OCCURE(AvePay) ... *)
  END;
  RETURN 0;
 END {GetAvePay};

 PRIVATE PROCEDURE GetOwnFirmName(D: DATE): STRING[];
 BEGIN
  RETURN P_Firm.FP_FirmNameFP(P_Firm.OWN_FIRM, D);
 END {GetOwnFirmName};

 PRIVATE PROCEDURE CheckType(D: DATE; ForceNotInState: SCAL[2];
                             _JMode: LIKE(Sheet.JMode);
                             VAR _Spec: tMInsSpec; VAR _SenAddS: LIKE(ManActv.SenAddS);
                             VAR _BegD: DATE);
  VAR
   _Sp : tMInsSpec;
   _SnS: LIKE(ManActv.SenAddS);
   S: STRING[];
 BEGIN
  IF ForceNotInState THEN
   _Sp[0]:=ssfp_NotInState;
   _Sp[1]:="";
   _SnS:=0;
  ELSE
   S:=L_Packet.E_SpecStageForPens(D, _JMode);
   _Sp[0]:=Str.Condense(Str.Item(S, ";", 0));
   _Sp[1]:=Str.Condense(Str.Item(S, ";", 1));
   S:=Str.Condense(Str.Item(S, ";", 2));
   IF !S THEN
    _SnS:=0;
   ELSE
    _SnS:=L_Str.PositionInPool(L_Man.senrs_Pool, S);
    L_General.CallUs(~!_SnS);
   END;
  END;

  IF (_Sp[0] # _Spec[0]) | (_Sp[1] # _Spec[1]) | (_SenAddS # _SnS) THEN
   IF ~!_Spec[0] | (_SenAddS # 0) THEN
    IF _BegD < D THEN
     InsSL(_BegD, D-1, _Spec, _SenAddS, Post.Name);
    END;
    _BegD:=D;
    _Spec:=_Sp;
    _SenAddS:=_SnS;
   END;
   IF ~!_Sp[0] | (_SnS # 0) THEN
    _BegD:=D;
    _Spec:=_Sp;
    _SenAddS:=_SnS;
   END;
  END;
 END {CheckType};

 PRIVATE PROCEDURE Ass(VAR D: NUMERIC[2][3]; S: NUMERIC[2][3]);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i<3 DO
   IF !S[i] THEN
    D[i]:=0;
   ELSE
    D[i]:=S[i];
   END;
   INC(i);
  END;
 END {Ass};

 PRIVATE PROCEDURE E_SZVK_NeedEducation(): SCAL[2];
 BEGIN
  RETURN 1;
 END {E_SZVK_NeedEducation};

 PRIVATE PROCEDURE EducationForSZVK(): SCAL[2];
 BEGIN
  RETURN (ManActv.EdType >= L_Man.edtype_PrimaryProf) &
         (ManActv.EdForm = L_Man.edform_Face);
 END {EducationForSZVK};

 PRIVATE PROCEDURE PrepareSpecStage();
  VAR
   _APD1,
   _APD2,
   _BegD,
   D, DE,
   D1, D2  : DATE;
   _APJMode: LIKE(Sheet.JMode);
   _PnsAttr: LIKE(Officer.PnsAttr);
   _PostName: STRING[];
   _Spec   : tMInsSpec;
   _SenAddS : LIKE(ManActv.SenAddS);
 BEGIN
  APP.Get().NewPrompt("⠦  "+Man.Man);
  IF ~SELECT(_MIns, _MIns, Man.Man) THEN
   SELECT(ManActv, Man, , Man.Man, L_Man.actvk_Work);
   WHILE OCCURE(ManActv) DO
    PROMPT("㤮 ⥫쭮c  "+L_DatTim.DateStr(ManActv.BegDate)+"  "+L_DatTim.DateStr(ManActv.EndDate));
    L_General.Assert(~!ManActv.ActvCatg, "   ⥫쭮");
    IF ManActv.BegDate <= LastDate THEN
     DEFAULT(_MIns);
     _MIns.Man     :=Man.Man;
     L_General.Assert(ManActv.BegDate<=ManActv.EndDate, "  㤮 ⥫쭮:| 砫      砭");
     _MIns.BegD    :=ManActv.BegDate;
     _MIns.EndD    :=Math.Min(ManActv.EndDate, LastDate);
     _MIns.FirmName:=ManActv.FndName;
     _MIns.PostName:=ManActv.Result;
     _MIns.ActvCatg:=ManActv.ActvCatg;
     _MIns.TerrCond:=ManActv.TerrCond;
     _MIns.TerrCndC:=ManActv.TerrCndC;
     IF    !_MIns.TerrCndC THEN
      _MIns.TerrCndC:=0;
     ELSIF _MIns.TerrCndC # 0 THEN
      L_General.Assert(ManActv.TerrCond, "   ਠ쭮 .  㪠 ᫮");
     END;
     CONFORM(ManActv, PnsAttr);
     _MIns.Spec[0] :=Str.Item(PnsAttr.Str, ";", 0);
     _MIns.Spec[1] :=Str.Item(PnsAttr.Str, ";", 1);
     _MIns.Spec    :=SpecToOut(_MIns.Spec);
     _MIns.Seniorit:=ManActv.Seniorit;
     Ass(_MIns.SenAddN, ManActv.SenAddN);
     _MIns.SenAddS :=ManActv.SenAddS;
     _MIns.LongServ:=ManActv.LongServ;
     Ass(_MIns.LongSrvN, ManActv.LongSrvN);
     INSERT(_MIns);
    END;
    NEXT(ManActv);
   END; (* WHILE OCCURE(ManActv) ... *)

   IF E_SZVK_NeedEducation() THEN
    SELECT(ManActv, Man, , Man.Man, L_Man.actvk_Education);
    WHILE OCCURE(ManActv) DO
     IF EducationForSZVK() & ~!ManActv.BegDate THEN
      PROMPT("ࠧ  "+L_DatTim.DateStr(ManActv.BegDate)+"  "+L_DatTim.DateStr(ManActv.EndDate));
      DEFAULT(_MIns);
      _MIns.Man     :=Man.Man;
      L_General.Assert(ManActv.BegDate<=ManActv.EndDate, "  祭:| 砫      砭");
      _MIns.BegD    :=ManActv.BegDate;
      _MIns.EndD    :=Math.Min(ManActv.EndDate, LastDate);
      _MIns.FirmName:=ManActv.FndName;
      IF    ManActv.EdType = L_Man.edtype_AfterHighProf THEN
       _MIns.PostName:="ᯨ࠭";
      ELSIF ManActv.EdType = L_Man.edtype_HighProf THEN
       _MIns.PostName:="㤥";
      ELSE
       _MIns.PostName:="騩";
      END;
      SETEMPTY(_MIns.Spec);
      _MIns.ActvCatg:=ActvC_DVSTO;(**);
      SETZERO(_MIns.Seniorit, _MIns.SenAddN, _MIns.LongSrvN, _MIns.TerrCndC,
              _MIns.TerrCond, _MIns.SenAddS, _MIns.LongServ);
      INSERT(_MIns);
     END;
     NEXT(ManActv);
    END; (* WHILE OCCURE(ManActv) ... *)
   END; (* IF E_SZVK_NeedEducation()... *)

   SETEMPTY(_APJMode, _APD1, _APD2);

   IF SELECT(_MIns, _MIns, Man.Man) THEN
    LAST(_MIns);
    MakeStfLg(_MIns.EndD);
   ELSE
    MakeStfLg(PerB);
   END;
   SELECT(StfLg, StfLg, , 1);
   WHILE OCCURE(StfLg) DO
    D1:=Math.Max(StfLg.DateB, PerB);
    D2:=StfLg.DateE;
    SETEMPTY(_Spec);
    _SenAddS:=0;

    IF D1<L_Env.aptm_Start THEN
     DE:=Math.Min(L_Env.aptm_Start-1, D2);
     IF SELECT(AvePay, TSN, StfLg.TSN) THEN
      CONFORM(AvePay, Staff);
      WHILE OCCURE(AvePay) & (AvePay.StartD<=DE) DO
       IF AvePay.StopD>=D1 THEN
        CONFORM(AvePay, AvePayP);
        WHILE OCCURE(AvePayP) DO
         CONFORM(AvePayP, AveTypeP);
         IF ~!AveTypeP.JMode & L_DatTim.IsActiveInIntvl_Inc(D1, DE, AvePayP.StartD, AvePayP.StopD) THEN
          HISTCONF(AvePayP.StopD, Staff, StaffLog);
          CONFORM(StaffLog, Officer);
          CONFORM(Officer, Post);
          _APD2:=Math.Min(AvePayP.StopD, DE);
          D:=Math.Max(AvePayP.StartD, D1);
          WHILE D<=_APD2 DO
           CheckType(D, 0, AveTypeP.JMode, _Spec, _SenAddS, _BegD);
           D:=L_DatTim.IncMonth(L_DatTim.Per(D), +1);
          END;
          IF (_APD2+1)<L_Env.aptm_Start THEN
           CheckType(_APD2+1, 0, "", _Spec, _SenAddS, _BegD);
          END;
         END;
         NEXT(AvePayP);
        END; (* WHILE OCCURE(AvePayP) ... *)
       END;
       NEXT(AvePay);
      END; (* WHILE OCCURE(AvePay) ... *)
     END;
    END;

    D:=Math.Max(D1, L_Env.aptm_Start);
    _BegD:=D1;
    SETSEL(Sheet, TSN, StfLg.TSN);
    SRCINSEL(Sheet, GE, , L_DatTim.Per(D), L_DatTim.DAY(D));
    WHILE OCCURE(Sheet) & ((Sheet.Period+Sheet.Day-1) <= D2) DO
     PROMPT(" "+L_DatTim.DateStr(Sheet.Period+Sheet.Day-1));
     CONFORM(StfLg, Post);
     IF GetAvePay(_APJMode, _APD1, _APD2) THEN
      D:=Math.Max(_APD1, D1);
      WHILE D<=Math.Min(_APD2, D2) DO
       CheckType(D, 0, _APJMode, _Spec, _SenAddS, _BegD);
       D:=L_DatTim.IncMonth(L_DatTim.Per(D), +1);
      END;
      SRCINSEL(Sheet, GT, , L_DatTim.Per(_APD2), L_DatTim.DAY(_APD2));
     ELSE
      D:=Sheet.Period+Sheet.Day-1;
      CheckType(D, 0, Sheet.JMode, _Spec, _SenAddS, _BegD);
      NEXT(Sheet);
     END;
    END;
    CheckType(D2+1, 1, "", _Spec, _SenAddS, _BegD);

    SETEMPTY(_PostName, _BegD);
    CONFORM(StfLg, PnsAttr);
    _Spec[0]:=Str.Item(PnsAttr.Str, ";", 0);
    _Spec[1]:=Str.Item(PnsAttr.Str, ";", 1);
    CONFORM(StfLg, Post);
    _PostName:=Post.Name;
    _SenAddS:=0;
    InsSL(StfLg.DateB, StfLg.DateE, _Spec, _SenAddS, _PostName);
    NEXT(StfLg);
   END; (* WHILE OCCURE(Staff) ... *)
  END;
 END {PrepareSpecStage};

 PRIVATE PROCEDURE Inc(VAR S: NUMERIC[2]; s: NUMERIC[2]);
 BEGIN
  IF !S THEN S:=0; END;
  INC(S, s);
 END {Inc};

 PRIVATE PROCEDURE InsertPacket(trgExtNbr  : LIKE(Packet.ExtNbr);
                                trgDataType: LIKE(Packet.DataType);
                                trgCorrType: LIKE(Packet.CorrType));
 BEGIN
  L_Packet.InsPFPacket(L_Packet.Get_PF_PacketKind(PerB, PerE, trgDataType, trgCorrType), trgExtNbr, PerB, PerE, trgDataType, trgCorrType);
 END {InsertPacket};

 PRIVATE PROCEDURE AccessPacket(_ExtNbr  : LIKE(Packet.ExtNbr)): SCAL[2];
 BEGIN
  RETURN SELECT(Packet, PacketDS, L_Packet.rcv_PensFund, L_Packet.DTStamp, _ExtNbr);
 END {AccessPacket};

 PRIVATE PROCEDURE SetPacket(_ExtNbr  : LIKE(Packet.ExtNbr);
                             _Man     : LIKE(Man.Man);
                             _Group   : L_Packet.tPacketGroup;
                             _DataType: LIKE(Packet.DataType);
                             _CorrType: LIKE(Packet.CorrType));
 BEGIN
  IF ~AccessPacket(_ExtNbr) THEN
   InsertPacket(_ExtNbr, _DataType, _CorrType);
   L_Packet.PutPacketAttr(Packet.Packet, patt_Group, L_Str.IntStr(_Group));
  END;
  DEFAULT(PckBody);
  PckBody.Packet  :=Packet.Packet;
  PckBody.Man     :=_Man;
  INSERT(PckBody);
 END {SetPacket};

(*
$P{ NN1_3_00_1:
Packet.ExtNbr, R, ""
L_Packet.OwnNumInPFR, L, ""
L_Packet.OwnINN, L, ""
L_Packet.OwnKPP, L, ""
L_Packet.OwnFirmName, L, ""
@
           ᮪ 客                         窠 N ######

--------------------------------------------------------------------------
| ࠡ⮤⥫, ।饣 㬥:                          |
|樮   ##############################################|
| ##########         #########                                     |
| ࣠樨  ##############################################|
|(⪮)                                                               |
|------------------------------------------------------------------------|
| N  |  客   | , , ⢮                             |
|/ |         |                                                    |
|----|--------------|----------------------------------------------------|
}
*)

(*
$P{ NN1_3_00_2:
PckBody.SeqNbr, R, "N"
L_Packet.SINumberToAnyOut(Man.SINumber), L, ""
L_Packet.GetManInPFRFName(L_Packet.PrepareDate), L, ""
@
|####|##############|####################################################|
}
*)

(*
$P{ NN1_3_00_3:
@
--------------------------------------------------------------------------}
*)

 PRIVATE PROCEDURE GetPacketGroupForMan(): L_Packet.tPacketGroup;
  VAR
   Flag: SCAL[2][pg_SZVKwPATC];
 BEGIN
  PrepareSpecStage();
  SETZERO(Flag);
  IF SELECT(_MIns, _MIns, Man.Man) THEN
   WHILE OCCURE(_MIns) DO
    IF _MIns.TerrCond # 0 THEN
     IF E_SZVK_NeedSeparateTerrCond() THEN
      Flag[pg_SZVKwTC]:=1;
     ELSE
      Flag[pg_SZVKwPA]:=1;
     END;
    END;
    IF ~!_MIns.Spec[0] & (_MIns.Spec[0] # ssfp_NotInState) THEN
     Flag[pg_SZVKwPA]:=1;
    END;
    IF (_MIns.Seniorit # 0) | (_MIns.SenAddS # 0) | (_MIns.LongServ # 0) THEN
     Flag[pg_SZVKwPA]:=1;
    END;
    NEXT(_MIns);
   END; (* WHILE OCCURE(_MIns) ... *)
   IF    Flag[pg_SZVKwTC] & Flag[pg_SZVKwPA] THEN
    RETURN pg_SZVKwPATC;
   ELSIF Flag[pg_SZVKwTC] THEN
    RETURN pg_SZVKwTC;
   ELSIF Flag[pg_SZVKwPA] THEN
    RETURN pg_SZVKwPA;
   ELSE
    RETURN pg_SZVK;
   END;
  ELSE
   RETURN "";
  END;
 END {GetPacketGroupForMan};

 PRIVATE PROCEDURE EqCode(Codes, Pool: STRING[]; Item: NUMERIC[0]): SCAL[2];
  VAR
   i, j: NUMERIC[0];
   S   : STRING[];
 BEGIN
  i:=0;
  S:=Str.Item(Codes, "|", i);
  WHILE ~!S DO
   j:=L_Str.PositionInPool(Pool, S);
   L_General.CallUs(~!j);
   IF j = Item THEN
    RETURN 1;
   END;
   INC(i);
   S:=Str.Item(Codes, "|", i);
  END;
  RETURN 0;
 END {EqCode};

 PRIVATE PROCEDURE GetSPECDays(VAR PureInt: SCAL[2]): NUMERIC[0];
  VAR
   D: NUMERIC[0];
 BEGIN
  PureInt:=0;
  IF  ~EqCode("", L_Man.senr_Pool, _MIns.Seniorit) &
     (_MIns.Spec[0] # "26") THEN
   D:=L_Packet.UnNormalizeDMY(_MIns.SenAddN[2], _MIns.SenAddN[1], _MIns.SenAddN[0]);
   IF D # 0 THEN
    RETURN D;
   END;
  END;
  PureInt:=1;
  RETURN 0;
 END {GetSPECDays};

 PRIVATE PROCEDURE GetTERRDays(VAR PureInt: SCAL[2]): NUMERIC[0];
 BEGIN
  RETURN GetSPECDays(PureInt);
 END {GetTERRDays};

 PRIVATE PROCEDURE GetLONGDays(VAR PureInt: SCAL[2]): NUMERIC[0];
  VAR
   D: NUMERIC[0];
 BEGIN
  PureInt:=0;
  IF EqCode("|", L_Man.longsrv_Pool, _MIns.LongServ) THEN
   D:=L_Packet.UnNormalizeDMY(_MIns.LongSrvN[1], _MIns.LongSrvN[0], 0);
   IF D # 0 THEN
    RETURN D;
   END;
  END;
  PureInt:=1;
  RETURN 0;
 END {GetLONGDays};

 PRIVATE PROCEDURE GetTotDays(VAR PureInt: SCAL[2]): NUMERIC[0];
  VAR
   D: NUMERIC[0];
 BEGIN
  PureInt:=0;
  IF    EqCode("", L_Man.senr_Pool, _MIns.Seniorit) THEN
   RETURN L_Packet.UnNormalizeDMY(0, 0, 1);
  ELSIF EqCode("104", L_Man.senr_Pool, _MIns.Seniorit) THEN
   D:=L_Packet.UnNormalizeDMY(_MIns.SenAddN[2], _MIns.SenAddN[1], _MIns.SenAddN[0]);
   L_General.Assert(D>0, "  㪠 த⥫쭮 塞 㤮 ⠦|  "+L_Str.PoolItem(L_Man.senr_Pool, _MIns.Seniorit));
   RETURN D;
  ELSIF EqCode("", L_Man.senr_Pool, _MIns.Seniorit) THEN
   RETURN L_Packet.DaysInIntvl(_MIns.BegD, _MIns.EndD)*2-2;
  END;
  PureInt:=1;
  RETURN 0;
 END {GetTotDays};

 PRIVATE PROCEDURE CheckNewLaborActiv(PrvFirm, NxtFirm: STRING[];
                              PrvActvCatg, NxtActvCatg: LIKE(ManActv.ActvCatg);
                              PrvE, NxtB: DATE): SCAL[2];
 BEGIN
  RETURN ((NxtB-PrvE)>1) | (PrvFirm # NxtFirm) | (PrvActvCatg # NxtActvCatg);
 END {CheckNewLaborActiv};

 PRIVATE PROCEDURE GetStageCount(): NUMERIC[0];
  VAR
   StageNum: NUMERIC[0];
   PrvFirmName: STRING[];
   PrvActvCatg: LIKE(ManActv.ActvCatg);
   PrvEndD: DATE;
 BEGIN
  PrvFirmName:=_MIns.FirmName;
  PrvActvCatg:=_MIns.ActvCatg;
  StageNum:=1;
  PrvEndD:=_MIns.EndD;
  SAVE(_MIns);
  NEXT(_MIns);
  WHILE OCCURE(_MIns) &
        ~CheckNewLaborActiv(PrvFirmName, _MIns.FirmName,
                            PrvActvCatg, _MIns.ActvCatg, PrvEndD, _MIns.BegD) DO
   PrvEndD:=_MIns.EndD;
   INC(StageNum);
   NEXT(_MIns);
  END; (* WHILE OCCURE(_MIns)... *)
  RESTORE(_MIns);
  RETURN StageNum;
 END {GetStageCount};

 PRIVATE PROCEDURE MakeSrvLnPart(Type, Title: STRING[]);
  VAR
   i, D, N, Y: NUMERIC[0];
 BEGIN
  i:=0;
  IF SELECT(SrvLn, SrvLn, Type) THEN
   WHILE OCCURE(SrvLn) DO
    INC(i);
    D:=SrvLn.Days; N:=0; Y:=0;
    L_Packet.NormalizeDMY(D, N, Y);
    IF i = 1 THEN
     MAKEPART(R, SZV_K_InfoLine, Title, SrvLn.Code, Y, N, D);
    ELSE
     MAKEPART(R, SZV_K_InfoLine, , SrvLn.Code, Y, N, D);
    END;
    NEXT(SrvLn);
   END; (* WHILE OCCURE(SrvLn) ... *)
  ELSE
   MAKEPART(R, SZV_K_InfoLine, Title);
  END;
 END {MakeSrvLnPart};

 PRIVATE PROCEDURE trn_PutSrvLn(Type: STRING[]);
  VAR
   i, D, N, Y: NUMERIC[0];
 BEGIN
  i:=0;
  SELECT(SrvLn, SrvLn, , Type);
  WHILE OCCURE(SrvLn) DO
   INC(i);
   D:=SrvLn.Days; N:=0; Y:=0;
   L_Packet.NormalizeDMY(D, N, Y);
   L_Packet.trn_PutString(SrvLn.Type);
   L_Packet.trn_PutInt(i);
   L_Packet.trn_PutString(SrvLn.Code);
   L_Packet.trn_PutInt(Y);
   L_Packet.trn_PutInt(N);
   L_Packet.trn_PutInt(D);
   L_Packet.trn_NewLine();
   NEXT(SrvLn);
  END; (* WHILE OCCURE(SrvLn) ... *)
 END {trn_PutSrvLn};

 PRIVATE PROCEDURE GetSPECAdd(): STRING[];
 BEGIN
  IF    _MIns.SenAddS # 0 THEN
   RETURN L_Str.PoolItem(L_Man.senrs_Pool, _MIns.SenAddS);
  ELSIF (_MIns.SenAddN[0] # 0) | (_MIns.SenAddN[1] # 0) | (_MIns.SenAddN[2] # 0) THEN
   IF EqCode("", L_Man.senr_Pool, _MIns.Seniorit) THEN
    RETURN FLDTOSTR(_MIns.SenAddN[1], "0")+". "+FLDTOSTR(_MIns.SenAddN[2], "0")+".";
   ELSE
    RETURN FLDTOSTR(_MIns.SenAddN[0], "0")+" "+FLDTOSTR(_MIns.SenAddN[1], "0")+" "+FLDTOSTR(_MIns.SenAddN[2], "0")+"";
   END;
  END;
  RETURN "";
 END {GetSPECAdd};

 PRIVATE PROCEDURE LongServAddingType(LongServCode: STRING[]): SCAL[3];
 BEGIN
  IF (_MIns.LongSrvN[0] # 0) | (_MIns.LongSrvN[1] # 0) THEN
   IF    EqCode("80||||||", L_Man.longsrv_Pool, _MIns.LongServ) THEN
    RETURN lsat_HoursMins;
   ELSIF EqCode("||", L_Man.longsrv_Pool, _MIns.LongServ) THEN
    RETURN lsat_Count;
   ELSIF EqCode("80|81||", L_Man.longsrv_Pool, _MIns.LongServ) THEN
    RETURN lsat_Calc;
   ELSE
    RETURN lsat_MonthsDays;
   END;
  END;
  RETURN "";
 END {LongServAddingType};

 PRIVATE PROCEDURE GetLONGAdd(): STRING[];
  VAR
   S: STRING[];
 BEGIN
  S:="";
  IF    LongServAddingType(_MIns.LongServ) = lsat_HoursMins THEN
   S:=FLDTOSTR(_MIns.LongSrvN[0], "0")+". "+FLDTOSTR(_MIns.LongSrvN[1], "0")+".";
  ELSIF LongServAddingType(_MIns.LongServ) = lsat_Count THEN
   S:=FLDTOSTR(_MIns.LongSrvN[0], "0");
  ELSIF LongServAddingType(_MIns.LongServ) = lsat_MonthsDays THEN
   S:=FLDTOSTR(_MIns.LongSrvN[0], "0")+". "+FLDTOSTR(_MIns.LongSrvN[1], "0")+".";
  ELSIF LongServAddingType(_MIns.LongServ) = lsat_Calc THEN
   IF _MIns.LongSrvN[0] # 0 THEN
    S:=FLDTOSTR(_MIns.LongSrvN[0], "0")+". ";
   END;
   IF _MIns.LongSrvN[1] # 0 THEN
    S:=FLDTOSTR(_MIns.LongSrvN[1], "0");
   END;
  END;
  IF _MIns.LongSrvN[2] # 0 THEN
   S:=S+" "+FLDTOSTR(_MIns.LongSrvN[2], "2.");
  END;
  RETURN S;
 END {GetLONGAdd};

 PRIVATE PROCEDURE StoreSrvLnDays();
 BEGIN
  IF ~!SrvLn.BegD THEN
   INC(SrvLn.Days, L_Packet.DaysInIntvl(SrvLn.BegD, SrvLn.EndD)-1);
   SETEMPTY(SrvLn.BegD, SrvLn.EndD);
   REPLACE(SrvLn);
  END;
 END {StoreSrvLnDays};

 PRIVATE PROCEDURE AddLeaveDay(PureInt: SCAL[2]; Firm_Count: NUMERIC[0]);
 BEGIN
  IF PureInt THEN
   IF Firm_Count # SrvLn.FirmCnt THEN
    SrvLn.FirmCnt:=Firm_Count;
    IF EqCode("", L_Man.actvc_Pool, _MIns.ActvCatg) THEN
     INC(SrvLn.Days);           (*  㢮쭥*)
    END;
    StoreSrvLnDays();
    SrvLn.BegD:=_MIns.BegD;
    SrvLn.EndD:=_MIns.EndD;
   ELSIF SrvLn.EndD = (_MIns.BegD-1) THEN
    SrvLn.EndD:=_MIns.EndD;
   ELSE
    StoreSrvLnDays();
    SrvLn.BegD:=_MIns.BegD;
    SrvLn.EndD:=_MIns.EndD;
   END;
   REPLACE(SrvLn);
  END;
 END {AddLeaveDay};

 PRIVATE PROCEDURE trn_PckKind(): STRING[];
 BEGIN
  IF   Packet.Kind = L_Packet.knd_PF_SZVK THEN RETURN "";
  ELSE
   L_General.CallUs(0);
  END;
 END {trn_PckKind};

 PRIVATE PROCEDURE MakeOneMan(nPack: L_XML.tNode);
  VAR
   D1, D2,
   _Period     : DATE;
   _Month      : SCAL[MaxPerAmo];
   Dummy       : STRING[250];
   i           : NUMERIC[0];
   Reason      : STRING[];
   Firm_Count  : NUMERIC[0];
   PrvFirmName : STRING[];
   PrvActvCatg : LIKE(ManActv.ActvCatg);
   PrvBegD,
   PrvEndD     : DATE;
   FirmNamePart: STRING[][2];
   FirmNameRest: STRING[];
   Per_Count   : NUMERIC[0];
   AddInfStr   : STRING[][3];
   TotDays,
   TERR_Count,
   SPEC_Count,
   LONG_Count,
   TERRxxx_Count,
   D, N, Y     : NUMERIC[0];
   TerrCond2002: STRING[];
   TerrCndC2002: NUMERIC[2];
   CurPageNum  : NUMERIC[0];
   PureInt     : SCAL[2];
   LongServCode: STRING[];
   nDoc,
   nStage,
   nWorkPer,
   nWork,
   nWrkPer,
   nWrkBas,
   nFeatures,
   nSpCond,
   nStand,
   nLongServ,
   nAppraiser  : L_XML.tNode;
   AppraiserTSN: STRING[];
   Surname,
   FirstName,
   Patronymic: STRING[];
 BEGIN
  IF ~SingleMode() THEN
   CONFORM(PckBody, Man);
  END;
  L_Packet.CheckMyFirmForMan(Man.Man);
  CurManName:=L_Packet.GetManInPFRFName(L_Packet.PrepareDate);
  PrepareSpecStage();

  SETSEL(_MIns, _MIns, Man.Man);
  IF SRCINSEL(_MIns, LE, LastDate) & (_MIns.EndD>=LastDate) THEN
   TerrCond2002:=L_Packet.FirstToEmptyPool(L_Man.terc_Pool, _MIns.TerrCond);
   TerrCndC2002:=_MIns.TerrCndC;
  ELSE
   TerrCond2002:="";
   TerrCndC2002:=0.00;
  END;

  IF E_SZVK_NeedPacketPages() THEN
   INC(CurPageInP);
   MAKEPART(R, SZV_K_PageNum);
  END;

  CurPageNum:=1;

  L_Str.SplitManName(CurManName, Surname, FirstName, Patronymic);
  IF TerrCndC2002 # 0 THEN
   MAKEPART(R, SZV_K_Top, Surname, FirstName, Patronymic, TerrCond2002+" "+FLDTOSTR(TerrCndC2002, "2."));
  ELSE
   MAKEPART(R, SZV_K_Top, Surname, FirstName, Patronymic, TerrCond2002);
  END;

  SELECT(SrvLn, SrvLn);
  REMSEL(SrvLn);
  SETZERO(Firm_Count, TERR_Count, SPEC_Count, LONG_Count, TERRxxx_Count);

  SELECT(_MIns, _MIns, , Man.Man);
  SETEMPTY(PrvBegD, PrvFirmName, PrvActvCatg);
  PrvEndD:=L_DatTim.MINDATE();
  WHILE OCCURE(_MIns) DO
   IF CheckNewLaborActiv(PrvFirmName, _MIns.FirmName,
                         PrvActvCatg, _MIns.ActvCatg, PrvEndD, _MIns.BegD) THEN
    IF Firm_Count # 0 THEN
     MAKEPART(R, SZV_K_PerSep);
     IF PagLength < (LINENUM(R)+DEPTH(SZV_K_PerTop)+
                                DEPTH(SZV_K_PerLine)+
                                DEPTH(SZV_K_PerLineAdd)+
                                DEPTH(SZV_K_PerPost)+
                                DEPTH(SZV_K_PerSep)) THEN
      FORMFEED(R);
      IF E_SZVK_NeedPacketPages() THEN
       INC(CurPageInP);
       MAKEPART(R, SZV_K_PageNum);
      END;
      INC(CurPageNum);
      MAKEPART(R, SZV_K_PageTop, CurPageNum, 1);
     END;
    END;
    INC(Firm_Count);
    Per_Count:=0;
    Str.Format(FirmNamePart, _MIns.FirmName, 51, LEFT, FirmNameRest);
    MAKEPART(R, SZV_K_PerTop, Firm_Count, FirmNamePart[0],
                              Str.Condense(FirmNamePart[1])+" "+FirmNameRest, L_Str.PoolItem(L_Man.actvc_Pool, _MIns.ActvCatg));
   ELSE
    IF Per_Count # 0 THEN
     IF PagLength < (LINENUM(R)+DEPTH(SZV_K_PerLineSep)+
                                DEPTH(SZV_K_PerLine)+
                                DEPTH(SZV_K_PerLineAdd)+
                                DEPTH(SZV_K_PerPost)+
                                DEPTH(SZV_K_PerSep)) THEN
      MAKEPART(R, SZV_K_PerSep);
      FORMFEED(R);
      IF E_SZVK_NeedPacketPages() THEN
       INC(CurPageInP);
       MAKEPART(R, SZV_K_PageNum);
      END;
      INC(CurPageNum);
      MAKEPART(R, SZV_K_PageTop, CurPageNum, 1);
      MAKEPART(R, SZV_K_PerSep);
     ELSE
      MAKEPART(R, SZV_K_PerLineSep);
     END;
    END;
   END;
   PrvFirmName:=_MIns.FirmName;
   PrvActvCatg:=_MIns.ActvCatg;
   PrvBegD:=_MIns.BegD;
   PrvEndD:=_MIns.EndD;

   IF _MIns.TerrCond # 0 THEN
    IF ~ADD(SrvLn, SrvLn, priv_TERR, L_Str.PoolItem(L_Man.terc_Pool, _MIns.TerrCond),
                          SrvLn.Days, GetTERRDays(PureInt)) THEN
     INC(TERR_Count);
    END;
    AddLeaveDay(PureInt, Firm_Count);
    IF _MIns.TerrCndC # 0 THEN
     AddInfStr[0]:=" "+ FLDTOSTR(_MIns.TerrCndC, "2.");
    ELSE
     AddInfStr[0]:="";
    END;
    IF ~ADD(SrvLn, SrvLn, priv_TERRxxx,
                          L_Str.PoolItem(L_Man.terc_Pool, _MIns.TerrCond) + AddInfStr[0],
                          SrvLn.Days, GetTERRDays(PureInt)) THEN
     INC(TERRxxx_Count);
    END;
    AddLeaveDay(PureInt, Firm_Count);
   END;

   IF ~!_MIns.Spec[0] THEN
    IF ~ADD(SrvLn, SrvLn, priv_SPEC, _MIns.Spec[0],
                          SrvLn.Days, GetSPECDays(PureInt)) THEN
     INC(SPEC_Count);
    END;
    AddLeaveDay(PureInt, Firm_Count);
   END;
   IF (_MIns.LongServ # 0) THEN
    IF ~ADD(SrvLn, SrvLn, priv_LONG, L_Str.PoolItem(L_Man.longsrv_Pool, _MIns.LongServ),
                          SrvLn.Days, GetLONGDays(PureInt)) THEN
     INC(LONG_Count);
    END;
    AddLeaveDay(PureInt, Firm_Count);
   END;
   ADD(SrvLn, SrvLn, , priv_Tot, "",
                       SrvLn.Days, GetTotDays(PureInt));
   AddLeaveDay(PureInt, Firm_Count);

   INC(Per_Count);

   MAKEPART(R, SZV_K_PerLine, Per_Count, _MIns.BegD, _MIns.EndD,
               L_Packet.FirstToEmptyPool(L_Man.terc_Pool,    _MIns.TerrCond),
               _MIns.Spec[0],
               L_Packet.FirstToEmptyPool(L_Man.senr_Pool,    _MIns.Seniorit),
               GetSPECAdd(),
               L_Packet.FirstToEmptyPool(L_Man.longsrv_Pool, _MIns.LongServ),
               GetLONGAdd());
   IF (_MIns.TerrCndC # 0) | (~!_MIns.Spec[1] & (_MIns.Spec[1] # ssfp_NotInState)) THEN
    IF _MIns.TerrCndC = 0 THEN
     AddInfStr[0]:="";
    ELSE
     AddInfStr[0]:=FLDTOSTR(_MIns.TerrCndC, "2.");
    END;
    IF ~!_MIns.Spec[1] THEN
     AddInfStr[1]:=_MIns.Spec[1];
    ELSE
     AddInfStr[1]:="        |";
    END;
    MAKEPART(R, SZV_K_PerLineAdd, AddInfStr[0], AddInfStr[1]);
   END;

   MAKEPART(R, SZV_K_PerPost, _MIns.PostName);
   NEXT(_MIns);
  END; (* WHILE OCCURE(_MIns)... *)
  LAST(_MIns);
  SELECT(SrvLn, SrvLn);
  WHILE OCCURE(SrvLn) DO
   IF (_MIns.EndD = LastDate) & (Firm_Count = SrvLn.FirmCnt) THEN
    DEC(SrvLn.Days); (*  㢮쭥 㦥 ਡ,   *)
    REPLACE(SrvLn);
   END;
   StoreSrvLnDays();
   NEXT(SrvLn);
  END; (* WHILE OCCURE(SrvLn) ... *)
  MAKEPART(R, SZV_K_PerSep);

  SETZERO(D, N, Y);
  IF SEARCH(SrvLn, SrvLn, priv_Tot, "") THEN
   D:=SrvLn.Days;
  END;
  L_Packet.NormalizeDMY(D, N, Y);

  IF PagLength < (LINENUM(R)+DEPTH(SZV_K_InfoTop)+
                             DEPTH(SZV_K_InfoLine)*Math.Min(1, TERRxxx_Count)+
                             DEPTH(SZV_K_InfoSep)+
                             DEPTH(SZV_K_InfoLine)*Math.Min(1, SPEC_Count)+
                             DEPTH(SZV_K_InfoSep)+
                             DEPTH(SZV_K_InfoLine)*Math.Min(1, LONG_Count)+
                             DEPTH(SZV_K_Bot)) THEN
   FORMFEED(R);
   IF E_SZVK_NeedPacketPages() THEN
    INC(CurPageInP);
    MAKEPART(R, SZV_K_PageNum);
   END;
   INC(CurPageNum);
   MAKEPART(R, SZV_K_PageTop, CurPageNum, 0);
  END;
  MAKEPART(R, SZV_K_InfoTop, Y, N, D);

  MakeSrvLnPart(priv_TERRxxx, "2.1.|ਠ ᫮");
  MAKEPART(R, SZV_K_InfoSep);

  MakeSrvLnPart(priv_SPEC, "2.2.|ᮡ ᫮ 㤠");
  MAKEPART(R, SZV_K_InfoSep);

  MakeSrvLnPart(priv_LONG, "2.3.|㣠 ");

  MAKEPART(R, SZV_K_Bot, CurPageNum, CurPageNum);
  FORMFEED(R);


  nDoc:=L_Packet.trn_PutAbstractDoc(nPack, trn_PckKind(), CurNumInP);
   L_Packet.trn_PutString(nDoc, "", "-"); (*???*)
   L_Packet.trn_PutString(nDoc, "", L_Packet.FormType(Packet.DataType, Packet.CorrType));
   L_Packet.trn_PutString(nDoc, "客", L_Packet.SINumberToAnyOut(Man.SINumber));
   L_Packet.trn_PutFIO(nDoc, "", CurManName);
   L_Packet.trn_PutDate(nDoc, "⠐", Man.Birth);
(*
   L_Packet.trn_PutOwnFirm(nDoc, "࣠।⠢-");
*)
   L_Packet.trn_PutTerrCond(nDoc, "ਠ륓᫮31.12.2001", TerrCond2002, TerrCndC2002);
   L_Packet.trn_PutDate(nDoc, "⠇", L_Packet.PrepareDate);

   nStage:=L_Packet.trn_PutNode(nDoc, "⠦樨");
    L_Packet.trn_PutInt(nStage, "⢮", Firm_Count);

  SETEMPTY(PrvBegD, PrvFirmName, PrvActvCatg);
  PrvEndD:=L_DatTim.MINDATE();
  SELECT(_MIns, _MIns, , Man.Man);
  WHILE OCCURE(_MIns) DO

   IF CheckNewLaborActiv(PrvFirmName, _MIns.FirmName,
                         PrvActvCatg, _MIns.ActvCatg, PrvEndD, _MIns.BegD) THEN
    nWorkPer:=L_Packet.trn_PutNode(nStage, "ਮ⥫쭮");
     L_Packet.trn_PutString(nWorkPer, "⥫쭮", L_Str.PoolItem(L_Man.actvc_Pool, _MIns.ActvCatg));
     L_Packet.trn_PutString(nWorkPer, "࣠樨", _MIns.FirmName);
     (* :=L_Packet.trn_PutNode(, "ࠡ⮪ਮ");  ଠ樨 *)
     nWork:=L_Packet.trn_PutNode(nWorkPer, "᥏ਮ될");
      L_Packet.trn_PutInt(nWork, "⢮", GetStageCount());
    i:=0;
   END;

   PrvFirmName:=_MIns.FirmName;
   PrvActvCatg:=_MIns.ActvCatg;
   PrvBegD:=_MIns.BegD;
   PrvEndD:=_MIns.EndD;
   INC(i);

   nWrkPer:=L_Packet.trn_PutNode(nWork, "ਮ");
    nWrkBas:=L_Packet.trn_PutNode(nWrkPer, "᭮ப");
     L_Packet.trn_PutInt(nWrkBas, "ப", i);
     L_Packet.trn_PutDate(nWrkBas, "⠍砫ਮ", _MIns.BegD);
     L_Packet.trn_PutDate(nWrkBas, "⠊栏ਮ",  _MIns.EndD);
     nFeatures:=L_Packet.trn_PutNode(nWrkBas, "ᮡ⨓");
      L_Packet.trn_PutTerrCond(nFeatures, "ਠ륓᫮", L_Packet.FirstToEmptyPool(L_Man.terc_Pool, _MIns.TerrCond), _MIns.TerrCndC);
      nSpCond:=L_Packet.trn_PutNode(nFeatures, "ᮡ륓᫮㤠");
       L_Packet.trn_PutString(nSpCond, "᭮", _MIns.Spec[0]);
       L_Packet.trn_PutString(nSpCond, "᪠", _MIns.Spec[1]);
 
      nStand:=L_Packet.trn_PutNode(nFeatures, "塞멑⠦");
       L_Packet.trn_PutString(nStand, "᭮", L_Packet.FirstToEmptyPool(L_Man.senr_Pool, _MIns.Seniorit));
        L_Packet.trn_PutEarnHours(nStand, "ࠡ⪠", 0, 0);
        L_Packet.trn_PutEarnDays(nStand, "ࠡ⪠ୠ", 0, 0, 0);
      L_Packet.trn_PutString(nFeatures, "℥", L_Packet.FirstToEmptyPool(L_Man.senrs_Pool, _MIns.SenAddS));
      nLongServ:=L_Packet.trn_PutNode(nFeatures, "㣠");
      LongServCode:=L_Packet.FirstToEmptyPool(L_Man.longsrv_Pool, _MIns.LongServ);
       L_Packet.trn_PutString(nLongServ, "᭮", LongServCode);

       IF    LongServAddingType(_MIns.LongServ) = lsat_HoursMins THEN
        L_Packet.trn_PutEarnHours(nLongServ, "ࠡ⪠", _MIns.LongSrvN[0], _MIns.LongSrvN[1]);
       ELSIF LongServAddingType(_MIns.LongServ) = lsat_Count THEN
       ELSIF LongServAddingType(_MIns.LongServ) = lsat_MonthsDays THEN
        L_Packet.trn_PutEarnDays(nLongServ, "ࠡ⪠ୠ", 0, _MIns.LongSrvN[0], _MIns.LongSrvN[1]);
       ELSIF LongServAddingType(_MIns.LongServ) = lsat_Calc THEN
        L_Packet.trn_PutEarnHours(nLongServ, "ࠡ⪠", _MIns.LongSrvN[0], 0);
        L_Packet.trn_PutInt(nLongServ, "᫥", _MIns.LongSrvN[1]);
       END;
       IF _MIns.LongSrvN[2] # 0 THEN
        L_Packet.trn_PutNumeric(nLongServ, "⠢", _MIns.LongSrvN[2], 2);
       END;
      L_Packet.trn_PutString(nFeatures, "", _MIns.PostName);
      L_Packet.trn_PutString(nFeatures, "⬥⪠業騪", ""); (*|  *)
   NEXT(_MIns);
  END; (* WHILE OCCURE(_MIns)... *)

(*
  AppraiserTSN:=P_MyFirm.GetProValueStrong(L_Packet.PckMyFirm, L_Packet.PrepareDate, P_MyFirm.P_PFRInsSender);

  nAppraiser:=L_Packet.trn_PutNode(nDoc, "멍業騪");
(*
   L_Packet.trn_PutString(nAppraiser, "ࠧ", ""); (*Int*)
*)
  L_Packet.trn_PutString(nAppraiser, "멍", AppraiserTSN);   (*Int*)
  L_Packet.trn_PutFIO(nDoc, "業騪", P_Firm.GetManAttrByTSN(AppraiserTSN, L_Packet.PrepareDate, P_Firm.mpt_ManName));
*)

(*
  trn_PutSrvLn(priv_TERR);
  trn_PutSrvLn(priv_SPEC);
  trn_PutSrvLn(priv_LONG);
*)
 END {MakeOneMan};

 PRIVATE PROCEDURE MakeOnePacket();
  VAR
   PGasStr     : STRING[];
   _PacketGroup: L_Packet.tPacketGroup;
   TotNumInP   : NUMERIC[0];
   nPack,
   nInvH       : L_XML.tNode;
 BEGIN
  L_Packet.CheckExistTrnFiles();
  L_Packet.trn_OpenFiles();
  L_Packet.CheckPacketType();
  SETZERO(CurNumInP);

  CONFORM(Packet, PckBody);

  PGasStr:=L_Packet.GetPacketAttr(Packet.Packet, patt_Group);
  IF ~!PGasStr THEN
   _PacketGroup:=STRTOFLD(PGasStr, NUMERIC);
  ELSIF OCCURE(PckBody) & SEARCH(Man, Man, PckBody.Man) THEN
   _PacketGroup:=GetPacketGroupForMan();
  ELSE
   _PacketGroup:="";
  END;
  LAST(PckBody);
  TotNumInP:=PckBody.SeqNbr;

  L_Packet.MakeADV61forSZVK(TotNumInP);

  FORMFEED(R);
  InitPrintAttr(R, Duplex, Off);

  nPack:=L_Packet.trn_PutHead();
  nInvH:=L_Packet.trn_PutInventoryHead(nPack, "_", trn_PckKind(), TotNumInP);

  CurPageInP:=0;
  CurNumInP:=1;
  FIRST(PckBody);
  WHILE OCCURE(PckBody) DO
   PROMPT(": 窠 "+GetManStrId(PckBody.Man));
   L_General.Assert(PckBody.SeqNbr = CurNumInP, " 窥 襭 㬥");
   INC(CurNumInP);
   MakeOneMan(nPack);
   NEXT(PckBody);
  END; (* WHILE OCCURE(PckBody) ... *)

  FORMFEED(R);
  InitPrintAttr(R, Duplex, Off);
  MAKEPART(R, NN1_3_00_1);
  FIRST(PckBody);
  WHILE OCCURE(PckBody) DO
   PROMPT("᮪ 客 : 窠 "+GetManStrId(PckBody.Man));
   CONFORM(PckBody, Man);
   MAKEPART(R, NN1_3_00_2);
   NEXT(PckBody);
  END; (* WHILE OCCURE(PckBody) ... *)
  MAKEPART(R, NN1_3_00_3);

  L_Packet.trn_CloseFiles(nPack);
 END {MakeOnePacket};

 PRIVATE PROCEDURE InitServices();
 BEGIN
  CreateFILE(_MIns, "", "", "");
  CreateFIELD(_MIns, Man,  LIKE(Man.Man), "", "", "", "", "");
  CreateFIELD(_MIns, BegD, DATE, "", "", "", "", "");
  CreateFIELD(_MIns, EndD, DATE, "", "", "", "", "");
  CreateFIELD(_MIns, FirmName, LIKE(ManActv.FndName), "", "", "", "", "");
  CreateFIELD(_MIns, PostName, LIKE(ManActv.Result), "", "", "", "", "");
  CreateFIELD(_MIns, ActvCatg, LIKE(ManActv.ActvCatg), "", "0", "", "", "");
  CreateFIELD(_MIns, TerrCond, LIKE(ManActv.TerrCond), "", "0", "", "", "");
  CreateFIELD(_MIns, TerrCndC, LIKE(ManActv.TerrCndC), "", "", "", "", "");
  CreateFIELD(_MIns, Spec,     tMInsSpec, "", "", "", "", "");
  CreateFIELD(_MIns, Seniorit, LIKE(ManActv.Seniorit), "", "0", "", "", "");
  CreateFIELD(_MIns, SenAddN,  LIKE(ManActv.SenAddN), "", "", "", "", "");
  CreateFIELD(_MIns, SenAddS,  LIKE(ManActv.SenAddS), "", "0", "", "", "");
  CreateFIELD(_MIns, LongServ, LIKE(ManActv.LongServ), "", "0", "", "", "");
  CreateFIELD(_MIns, LongSrvN, LIKE(ManActv.LongSrvN), "", "", "", "", "");

  CreateINDEX(_MIns, _MIns, PLURAL, "", "", Man, BegD, EndD);
  SetVersionOfFILE(_MIns, 0000);
  L_AFM.AF_CreateTemp("_MIns", "_MIns");

  CreateFILE(StfLg, "", "", "");
  CreateFIELD(StfLg, Numb,  SCAL[2], "", "", "", "", "");
  CreateFIELD(StfLg, TSN,   LIKE(Staff.TSN), "", "", "", "", "");
  CreateFIELD(StfLg, DateB, DATE, "", "", "", "", "");
  CreateFIELD(StfLg, DateE, DATE, "", "", "", "", "");
  CreateFIELD(StfLg, Contract, LIKE(Staff.Contract), "", "", "", "", "");
  CreateFIELD(StfLg, PnsAttr,  LIKE(Officer.PnsAttr), "", "", "", "", "");
  CreateFIELD(StfLg, Post,     LIKE(Officer.Post), "", "", "", "", "");

  CreateINDEX(StfLg, StfLg, PLURAL, "", "", Numb, DateB, Contract, TSN);
  CreateINDEXandLINK(StfLg, PnsAttr, PLURAL, PnsAttr, PnsAttr, USER, "", "", PnsAttr);
  CreateINDEXandLINK(StfLg, Post,    PLURAL, Post,    Post,    USER, "", "", Post);
  SetVersionOfFILE(StfLg, 0000);
  L_AFM.AF_CreateTemp("StfLg", "StfLg");

  CreateFILE(SrvLn, "", " 죮⭮ ⠦", "");
  CreateFIELD(SrvLn, Type, STRING[15], "", "", "", " ⠦", "'', '', '', ''");
  CreateFIELD(SrvLn, Code, STRING[15], "", "", "", "᭮", "");
  CreateFIELD(SrvLn, Days, NUMERIC[0], "", "", "", "⭠ த⥫쭮 죮⭮ ⠦", " ");
  CreateFIELD(SrvLn, FirmCnt, NUMERIC[0], "", "", "", "᫥ ਮ 㤮 ⥫쭮", "浪 ");
  CreateFIELD(SrvLn, BegD, DATE, "", "", "", "᫥ ਮ 㤮 ⥫쭮", " 砫");
  CreateFIELD(SrvLn, EndD, DATE, "", "", "", "᫥ ਮ 㤮 ⥫쭮", " 砭");
  CreateINDEX(SrvLn, SrvLn, UNIQUE, "", "", Type, Code);
  SetVersionOfFILE(SrvLn, 0000);
  L_AFM.AF_CreateTemp("SrvLn", "SrvLn");
 END {InitServices};

 PRIVATE PROCEDURE DeInitServices();
 BEGIN
  L_AFM.AF_PurgeTemp("StfLg");
  L_AFM.AF_PurgeTemp("_MIns");
  L_AFM.AF_PurgeTemp("SrvLn");
 END {DeInitServices};

 PRIVATE PROCEDURE MakeAll();
  VAR
   packetDataType: LIKE(Packet.DataType);
   packetCorrType: LIKE(Packet.CorrType);
 BEGIN
  SELECT(Packet, PacketDS, , L_Packet.rcv_PensFund, L_Packet.DTStamp);
  WHILE OCCURE(Packet) DO
   MakeOnePacket();
   NEXT(Packet);
  END; (* WHILE OCCURE(Packet) ... *)
 END {MakeAll};

 PRIVATE PROCEDURE PrepareIntrm();
 BEGIN
  L_AFM.MakeIndex("Intrm", "Group   : SCAL[1E2];"+
                              "DataType: LIKE(Packet.DataType);"+
                              "CorrType: LIKE(Packet.CorrType);"+
                              "Separate: SCAL[100];"+
                              "Name    : LIKE(Man.Name);"+
                              "Man     : LIKE(Man.Man)");
 END {PrepareIntrm};

 PRIVATE PROCEDURE IntrmPutOneMan(_Group: L_Packet.tPacketGroup; byCurPacket: SCAL[2]);
 BEGIN
  IF ~!_Group THEN
   Intrm.Group   :=_Group;
   Intrm.Man     :=Man.Man;
   Intrm.Name    :=L_Packet.GetManInPFRFName(L_Packet.PrepareDate);
   Intrm.Separate:=0; (* 0104451 16.07.2014 13:32:28 AK1784\Bor.Polak *)
   IF byCurPacket THEN
    Intrm.DataType:=Packet.DataType;
    Intrm.CorrType:=Packet.CorrType;
   ELSE
    Intrm.DataType:=L_Packet.dt_Basic;
    Intrm.CorrType:=L_Packet.ct_None;
   END;
   INSERT(Intrm);
  END;
 END {IntrmPutOneMan};

 PRIVATE PROCEDURE WorkInPer(byCurPacket: SCAL[2]): SCAL[2];
  VAR
   Need,
   Work: SCAL[2];
 BEGIN
  IF ~E_SZVK_CheckPension() THEN
   RETURN 0;
  END;
  Need:=0; Work:=0;
  SELECT(Staff, Man, , Man.Man);
  WHILE OCCURE(Staff) DO
   IF Staff.Contract # L_Staff.cnt_ExternalCombine THEN
    IF GoodTSN() &
       (L_Staff.rInState(L_Packet.PrepareDate) | (byCurPacket & (Packet.CorrType # L_Packet.ct_None))) THEN
     Work:=1;
    END;
    IF (Staff.BegDate <= PerE) & GoodTSN() THEN
     Need:=1;
    END;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  IF Work & ~Need THEN
   IF SELECT(ManActv, Man, Man.Man, L_Man.actvk_Work) THEN
    Need:=ManActv.BegDate <= PerE;
   END;
   IF ~Need & E_SZVK_NeedEducation() &
      SELECT(ManActv, Man, Man.Man, L_Man.actvk_Education) THEN
    Need:=ManActv.BegDate <= PerE;
   END;
  END;
  RETURN Work & Need;
 END {WorkInPer};

 PRIVATE PROCEDURE PutManInIntrm(byCurPacket: SCAL[2]);
  VAR
   i            : NUMERIC[0];
 BEGIN
  PROMPT(":  " + L_Str.IntStr(Man.Man));
  IF (WorkInPer(byCurPacket) & (byCurPacket | ~SELECT(_MIDn, _MIDn, Man.Man))) THEN
   IF    !Man.SINumber THEN
    IF L_STx.STx_CitizenshipForSTx(Man.Man, L_Packet.PrepareDate) THEN
     IntrmPutOneMan(pg_9999, byCurPacket);
    END;
   ELSE
    L_Russia.CheckSINumber(Man.SINumber, 0);
    IntrmPutOneMan(GetPacketGroupForMan(), byCurPacket);
   END;
  END; (* IF byCurPacket | ~SELECT(_MIDn, _MIDn, Man.Man) ... *)
 END {PutManInIntrm};

 PRIVATE PROCEDURE BuildPackets();
 BEGIN
  APP.Get().NewPrompt("⮢ ⮢");
  SELECT(Intrm, Intrm);
  WHILE OCCURE(Intrm) DO
   CHANGESEL(Intrm, Intrm, , Intrm.Group, Intrm.DataType, Intrm.CorrType, Intrm.Separate);
   CurNumInP:=0;
   WHILE OCCURE(Intrm) DO
    PROMPT(" " + Intrm.Man);
    IF    Intrm.Group = pg_9999 THEN
     CurPacket:=L_Packet.fg_9999;
    ELSIF Intrm.Group = pg_9998 THEN
     CurPacket:=L_Packet.fg_9998;
    ELSE
     CurNumInP:=(CurNumInP MOD P_OwnData.ODPacketSize(L_Packet.PrepareDate))+1;
     INC(CurPacket, CurNumInP = 1);
    END;
    SetPacket(CurPacket, Intrm.Man, Intrm.Group, Intrm.DataType, Intrm.CorrType);
    NEXT(Intrm);
   END;
   LAST(Intrm);
   CHANGESEL(Intrm, Intrm);
   NEXT(Intrm);
  END;
  L_AFM.AF_PurgeTemp("Intrm");
 END {BuildPackets};

 PRIVATE PROCEDURE MakeByPacket();
 BEGIN
  PrepareIntrm();
  SELECT(PckBody, Packet, , Packet.Packet);
  WHILE OCCURE(PckBody) DO
   CONFORM(PckBody, Man);
   PutManInIntrm(1);
   NEXT(PckBody);
  END; (* WHILE OCCURE(PckBody) ... *)
  BuildPackets();
 END {MakeByPacket};

 PRIVATE PROCEDURE PrepareGroup();
 BEGIN
  PrepareIntrm();
  SELECT(Man, Man);
  WHILE OCCURE(Man) DO
   PutManInIntrm(0);
   NEXT(Man);
  END; (* WHILE OCCURE(Man)... *)
  BuildPackets();
 END {PrepareGroup};

 PRIVATE PROCEDURE InitForAll(Msg: STRING[]);
 BEGIN
  IF    ~SingleMode() THEN
   DEC(CurPacket);
  END;
  L_AFM.MakeIndex("_MIDn", "Man: LIKE(Man.Man)");
 END {InitForAll};

 PRIVATE PROCEDURE DeInitForAll();
 BEGIN
  L_AFM.AF_PurgeTemp("_MIDn");
 END {DeInitForAll};

 PRIVATE PROCEDURE SetDateParms();
 BEGIN
  PerB:=FirstDate;
  PerE:=LastDate;
 END {SetDateParms};

 VAR
  Choose     : SCAL[2];
  nPack      : L_XML.tNode;
 CONST
  ed_Normal = "⮡ ⪠   ० '⮫쪮 ᬮ' 06.05.2006 19:05:13 POLAK\Bor";
BEGIN
 RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
 SetDateParms();

 IF    SingleMode() THEN
  L_General.Assert(ACCESS(Man), " ⠭ 䨧᪮ ");
  CurPacket:=L_Packet.trn_Init(L_Packet.E_SZVK_OwnEntrysDate(), L_Packet.bm_bySingle, L_Packet.part_Manins,
                               L_Packet.knd_PF_SZVK);
  Choose:=L_Packet.ChoosePacket(L_Packet.knd_PF_SZVK, EMPTYOF(DATE), EMPTYOF(DATE), L_Packet.dt_Basic, L_Packet.ct_None);

  TRY
   InsertPacket("00000", L_Packet.dt_Basic, L_Packet.ct_None);

   CurNumInP      :=0001;
   InitServices();
   L_Packet.trn_OpenFiles();
 
   nPack:=L_Packet.trn_PutHead();
 
   L_Packet.MakeProjectPrt();
   L_Russia.CheckSINumber(Man.SINumber, 0);
   CurPageInP:=0;
   MakeOneMan(nPack);
   L_Packet.trn_CloseFiles(nPack);
   DeInitServices();
   RAISE(, ed_Normal);
  EXCEPT
  ON Exc:Exc_Raise DO
   IF Exc.MsgOriginalText # ed_Normal THEN
    RAISE();
   END;
  END;
  LIKEMENU(Survey, "");
 ELSE
  IF MODE = mInitialAll THEN
   CurPacket:=L_Packet.trn_Init(L_Packet.E_SZVK_OwnEntrysDate(), L_Packet.bm_byAll, L_Packet.part_Manins,
                                L_Packet.knd_PF_SZVK);
   L_Packet.CheckExistingPackets(L_Packet.Get_PF_PacketKind(PerB, PerE, L_Packet.dt_Basic, L_Packet.ct_None),
                                 PerB, PerE, L_Packet.dt_Basic, L_Packet.ct_None);
   InitForAll("ࢮ砫쭮 ନ஢ -");
   InitServices();
   PrepareGroup();
  ELSIF MODE = mByPacketAll THEN
   L_General.Assert(ACCESS(Packet), " ࠭ ");
   L_Packet.SetSamplePacketDone();
   CurPacket:=L_Packet.trn_Init(L_Packet.E_SZVK_OwnEntrysDate(), L_Packet.bm_byPacket, L_Packet.part_Manins,
                                L_Packet.knd_PF_SZVK);
   SAVE(Packet);
   InitForAll("ନ஢ -  ⥪饩 窥");
   RESTORE(Packet);
   InitServices();
   MakeByPacket();
  ELSIF MODE = mIteratedAll THEN
   CurPacket:=L_Packet.trn_Init(L_Packet.E_SZVK_OwnEntrysDate(), L_Packet.bm_byAll, L_Packet.part_Manins,
                                L_Packet.knd_PF_SZVK);
   InitForAll(" ᢥ  ⠦  ଥ -");
   SELECT(Packet, PacketEN, , L_Packet.rcv_PensFund, PerB);
   WHILE OCCURE(Packet) DO
    IF (Packet.PerE = PerE) & ~L_Packet.IsFictExtNbr(Packet.ExtNbr) THEN
     SELECT(PckBody, Packet, , Packet.Packet);
     WHILE OCCURE(PckBody) DO
      _MIDn.Man:=PckBody.Man;
      INSERT(_MIDn);
      NEXT(PckBody);
     END; (* WHILE OCCURE(PckBody) ... *)
    END;
    NEXT(Packet);
   END; (* WHILE OCCURE(Packet) ... *)
   InitServices();
   PrepareGroup();
  ELSE
   L_General.BadMode(MODE);
  END;
  MakeAll();
  DeInitForAll();
  DeInitServices();

  L_Packet.ShowMakedPackets();
 END;
END.