(*
%Copyright   (c) Polak Computer System
%Author      22.01.2010 10:02:05 POLAK\San
%Purpose     ⮢  । ࠡ⭮ 
%Type        report
%Specific    SYS
%Modified    08.04.2014 12:22:36 POLAK\Gina
%Environment
*)

 MODULE T0999 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Str, FIO, Memo, L_Basis, P_Firm, L_SFee, L_bp;

 PRIVATE PROCEDURE T0999_MakeTop(F: STRING[]);
 BEGIN
  IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ਮ");
  L_Basis.wb_WrInQM(F, "㠫쭠");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "稭");
  L_Basis.wb_WrInQM(F, "  ६ ");
  L_Basis.wb_WrInQM(F, "");

  L_Basis.wb_WrInQM(F, "ꥪ");
  L_Basis.wb_WrInQM(F, "᪫祭 饥");

  L_Basis.wb_WrInQM(F, "_" + L_Str.PoolItem(L_SFee.b_Pool, L_SFee.b_PFR));
  L_Basis.wb_WrInQM(F, "_" + L_Str.PoolItem(L_SFee.b_Pool, L_SFee.b_FSS));
  L_Basis.wb_WrInQM(F, "_" + L_Str.PoolItem(L_SFee.b_Pool, L_SFee.b_MSF));

  L_Basis.wb_WrInQM(F, "_" + L_Str.PoolItem(L_SFee.b_Pool, L_SFee.b_PFR));
  L_Basis.wb_WrInQM(F, "_" + L_Str.PoolItem(L_SFee.b_Pool, L_SFee.b_FSS));
  L_Basis.wb_WrInQM(F, "_" + L_Str.PoolItem(L_SFee.b_Pool, L_SFee.b_MSF));

  L_Basis.wb_WrInQM(F, "_" + L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_PFIn));
  L_Basis.wb_WrInQM(F, "_" + L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_PFAc));
  L_Basis.wb_WrInQM(F, "_" + L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_xFSS));
  L_Basis.wb_WrInQM(F, "_" + L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_MSFF));
  L_Basis.wb_WrInQM(F, "_" + L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_MSTF));
  L_Basis.wb_WrInQM(F, "_" + L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_PFOv));
  L_Basis.wb_WrInQM(F, "_" + L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_PFA1));
  L_Basis.wb_WrInQM(F, "_" + L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_PFA2));
  L_Basis.wb_WrInQM(F, "_" + L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_PFA3_1));
  L_Basis.wb_WrInQM(F, "_" + L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_PFA3_2));
  L_Basis.wb_WrInQM(F, "_" + L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_PFA3_3));
  L_Basis.wb_WrInQM(F, "_" + L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_PFA3_4));
  L_Basis.wb_WrInQM(F, "_" + L_Str.PoolItem(L_SFee.p_Pool, L_SFee.p_PFA4_0));
  L_Basis.wb_TermLine(F);
 END {T0999_MakeTop};

 PRIVATE PROCEDURE T0999_MakeLine(F: STRING[]; isDelta: SCAL[2];
                                  trgObject: LIKE(ManSFee.Object);
                                  trgExcCmn: LIKE(ManSFee.ExcCmn);
                                  trgExcPrt: LIKE(ManSFee.ExcPrt);
                                  trgOvrPrt: LIKE(ManSFee.OvrPrt);
                                  trgFee   : LIKE(ManSFee.Fee));
 BEGIN
  IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(F, Man.Man);
  L_Basis.wb_WrScl(F, Man.Name);
  L_Basis.wb_WrDat(F, ManSFee.Period);

  L_Basis.wb_WrScl(F, ManSFee.Actual);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("  |  ।騬 ⮬", isDelta));
  IF ManSFee.Actual THEN
   L_Basis.wb_WrStr(F, L_Str.PoolItem("1|2", L_SFee.GetChangingReason(ManSFee.Man, ManSFee.MyFirm, ManSFee.Period)));
  ELSE
   L_Basis.wb_WrStr(F, "-");
  END;

  SEARCH(iga, RECORDID, , ManSFee.ri_iga);
  L_Basis.wb_WrStr(F, FLDTOSTR(iga.DTS, "D.N.y H:M"));

  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_SFee.t_Pool, ManSFee.Type));

  L_Basis.wb_WrNum(F, trgObject, 2);
  L_Basis.wb_WrNum(F, trgExcCmn, 2);

  L_Basis.wb_WrNum(F, trgExcPrt[L_SFee.b_PFR], 2);
  L_Basis.wb_WrNum(F, trgExcPrt[L_SFee.b_FSS], 2);
  L_Basis.wb_WrNum(F, trgExcPrt[L_SFee.b_MSF], 2);

  L_Basis.wb_WrNum(F, trgOvrPrt[L_SFee.b_PFR], 2);
  L_Basis.wb_WrNum(F, trgOvrPrt[L_SFee.b_FSS], 2);
  L_Basis.wb_WrNum(F, trgOvrPrt[L_SFee.b_MSF], 2);

  L_Basis.wb_WrNum(F, trgFee[L_SFee.p_PFIn], 2);
  L_Basis.wb_WrNum(F, trgFee[L_SFee.p_PFAc], 2);
  L_Basis.wb_WrNum(F, trgFee[L_SFee.p_xFSS], 2);
  L_Basis.wb_WrNum(F, trgFee[L_SFee.p_MSFF], 2);
  L_Basis.wb_WrNum(F, trgFee[L_SFee.p_MSTF], 2);
  L_Basis.wb_WrNum(F, trgFee[L_SFee.p_PFOv], 2);
  L_Basis.wb_WrNum(F, trgFee[L_SFee.p_PFA1], 2);
  L_Basis.wb_WrNum(F, trgFee[L_SFee.p_PFA2], 2);
  L_Basis.wb_WrNum(F, trgFee[L_SFee.p_PFA3_1], 2);
  L_Basis.wb_WrNum(F, trgFee[L_SFee.p_PFA3_2], 2);
  L_Basis.wb_WrNum(F, trgFee[L_SFee.p_PFA3_3], 2);
  L_Basis.wb_WrNum(F, trgFee[L_SFee.p_PFA3_4], 2);
  L_Basis.wb_WrNum(F, trgFee[L_SFee.p_PFA4_0], 2);
  L_Basis.wb_TermLine(F);
 END {T0999_MakeLine};

 PRIVATE PROCEDURE SaveManSFee(VAR prvObject: LIKE(ManSFee.Object);
                               VAR prvExcCmn: LIKE(ManSFee.ExcCmn);
                               VAR prvExcPrt: LIKE(ManSFee.ExcPrt);
                               VAR prvOvrPrt: LIKE(ManSFee.OvrPrt);
                               VAR prvFee: LIKE(ManSFee.Fee));
 BEGIN
  prvObject:=ManSFee.Object;
  prvExcCmn:=ManSFee.ExcCmn;
  prvExcPrt:=ManSFee.ExcPrt;
  prvOvrPrt:=ManSFee.OvrPrt;
  prvFee   :=ManSFee.Fee;
 END {SaveManSFee};

 PRIVATE PROCEDURE Sub(VAR d: NUMERIC[2][]; s: NUMERIC[2][]);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i <= HIGH(d) DO
   DEC(d[i], s[i]);
   INC(i);
  END;
 END {Sub};

 PUBLIC PROCEDURE T0999();
  CONST
   bpId = "T0999";
  VAR
   BPer,
   EPer     : DATE;
   dltObject,
   prvObject: LIKE(ManSFee.Object);
   dltExcCmn,
   prvExcCmn: LIKE(ManSFee.ExcCmn);
   dltExcPrt,
   prvExcPrt: LIKE(ManSFee.ExcPrt);
   dltOvrPrt,
   prvOvrPrt: LIKE(ManSFee.OvrPrt);
   dltFee,
   prvFee   : LIKE(ManSFee.Fee);
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_bp.Begin(bpId, "   ", L_bp.t_Basis, L_General.tc_inIntvl);
  L_DatTim.CheckWMIntvl(Memo.ud_fr(), Memo.ud_ut());
  BPer:=L_DatTim.MonthBeg(Memo.ud_fr());
  EPer:=L_DatTim.MonthBeg(Memo.ud_ut());

  FIO.Open(E, L_General.NameConnection(bpId), "REP", Create);
  T0999_MakeTop("E");
  SELECT(ManSFee, Man);
  WHILE OCCURE(ManSFee) DO
   PROMPT("㧪  䠩 " + ManSFee.Man);
   NARROWSEL(ManSFee, Man, MyFirm);
   IF SRCINSEL(ManSFee, GE, BPer) THEN
    CONFORM(ManSFee, Man);
    CONFORM(ManSFee, MyFirm);
    WHILE OCCURE(ManSFee) & (ManSFee.Period <= EPer) DO
     NARROWSEL(ManSFee, Period);
     IF NEXT(ManSFee) THEN
      FIRST(ManSFee);
      SaveManSFee(prvObject, prvExcCmn, prvExcPrt, prvOvrPrt, prvFee);
      WHILE OCCURE(ManSFee) DO
       T0999_MakeLine("E", 0, ManSFee.Object, ManSFee.ExcCmn, ManSFee.ExcPrt, ManSFee.OvrPrt, ManSFee.Fee);
       SaveManSFee(dltObject, dltExcCmn, dltExcPrt, dltOvrPrt, dltFee);
       Sub(dltObject, prvObject);
       Sub(dltExcCmn, prvExcCmn);
       Sub(dltExcPrt, prvExcPrt);
       Sub(dltOvrPrt, prvOvrPrt);
       Sub(dltFee,    prvFee);
       SaveManSFee(prvObject, prvExcCmn, prvExcPrt, prvOvrPrt, prvFee);
       T0999_MakeLine("E", 1, dltObject, dltExcCmn, dltExcPrt, dltOvrPrt, dltFee);
       NEXT(ManSFee);
      END;
     END;
     NEXTINEXTENDEDSEL(ManSFee, Period);
    END;
   END;
   NEXTINEXTENDEDSEL(ManSFee, Man, MyFirm);
  END; (* WHILE OCCURE(ManSFee) ... *)
  FIO.Close(E);

  L_bp.End();
 END {T0999};

END.
