(*
%Copyright   (c) Polak Computer System
%Author      14.07.1995 11:45:54 SAN
%Purpose      ਫ N7  室 
%Type        report
%Specific    SYS
%Modified    11.10.2012 16:26:53 POLAK\GAV
%Environment
*)

 MODULE T7_2000 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_DatTim, L_General, L_PRoll, L_Tx2000, L_Tax, L_Staff,
        L_Money, L_Man, P_Staff, Math, Str, Memo, L_Env, P_Firm;

 CONST
  M = " ";
  Y = "  ";

 VAR
  CurP, CurPE: DATE;
  Numbers    : NUMERIC[2][14];
  SNumbers   : STRING[30][14];
  _Town,
  _Village,
  _Street,
  _Block     : STRING[];

  TA_NYInc   : LIKE(TaxAdv.TaxAdv);
  TA_OverTax : LIKE(TaxAdv.TaxAdv)[2];

(*
$P{Cap:
L_DatTim.YearBeg(CurP), L, "y"
P_Firm.FP_INN(P_Firm.OWN_FIRM, CurPE), L, ""
Man.INN, L, ""
Man.Name, L, ""
L_Man.GetManDocName(Man.DocType), L, ""
L_Man.GetManDocCode(Man.DocType), L, ""
P_Firm.FP_FirmName(P_Firm.OWN_FIRM, CurPE), L, ""
Man.PspSer, L, ""
Man.PspNbr, L, ""
Man.Birth, L, "D.N.y"
ManAdr.Country, L, ""
ManAdr.Zip, L, ""
ManAdr.Region, L, ""
Str.Item(P_Firm.FP_TaxCardResp(P_Firm.OWN_FIRM, SYSDATE()), ";", 0), L, ""
ManAdr.Distr, L, ""
_Town, L, ""
_Village, L, ""
_Street, L, ""
Str.Item(P_Firm.FP_TaxCardResp(P_Firm.OWN_FIRM, SYSDATE()), ";", 1), C, ""
ManAdr.House, L, ""
_Block, L, ""
ManAdr.Flat, L, ""
GetResidentStatus(), L, "2|1"
Staff.Contract, L, "1|2|2|2|2"
Post.Name, L, ""
StaffLog.Date, L, "D.N.Y"
GetRomeStr(), L, ""
@
                                                                            ਫ N 7  樨 㤠⢥  㦡 ᨨ  29.06.95 N 35

                                               窠   室  室   #### 
================================================================================================================================================================
|1.   筨 室                                     2.   ⥫ 室                                                           |
|1.1.  /   ############                                        2.1.  ############  2.2.                                                         |
|                                                                    2.3. , , ⢮ ################################################              |
|1.2.  ( 䨧᪮  - ࠡ⮤⥫)             2.4.  㬥, 㤮⮢饣 筮 ##############################  ##        |
|################################################################    2.5. ,  㬥 ########## #######       2.6.  ஦ ##########        |
|                                                                    2.7.  ﭭ  ⥫⢠:   ࠭ ###  ######  ॣ ##     |
|1.3. ⢥⢥    窨 ################## ࠩ ################################ த #############################################|
|                                                 ()        ᥫ 㭪 ################################ 㫨 ##################################|
|########################################### _______________________  ############  ###############  #########################################|
|          (䠬,,⢮)                   ()        2.8.  # (1-१, 2-१) 2.9.  ࠡ # (1-᭮, 2-᭮)   |
|                                                                    2.10.  㬥, ⢥ত饣 ᭮  㤥ঠ  ---           |
|                                                                    2.11.   ######################################  祭 ########|
|                                                                    2.12.   室, 祭  ।饬  ᭮ ࠡ  ਮ ______|
|                                                                     ________ N ࠢ  室 __________  ⠢ (᫮, , )___________|
|                                                                     ਮ  ######################################################           |
}

$P{SubCap:
?, L, ""
@
|##############################################################################################################################################################|
}

$P{SubCap1:
?, L, ""
@
|--------------------------------------------------------------------------------------------------------------------------------------------------------------|
|##################|ਮ   |      ࠫ          ५                                        ⮣|
}

$P{DelLine:
@
|--------------------------------------------------------------------------------------------------------------------------------------------------------------|
}

$P{DelLine2:
@
|==============================================================================================================================================================|
}

$P{Line:
?, L, ""
?, L, ""
SNumbers[01], R, ""
SNumbers[02], R, ""
SNumbers[03], R, ""
SNumbers[04], R, ""
SNumbers[05], R, ""
SNumbers[06], R, ""
SNumbers[07], R, ""
SNumbers[08], R, ""
SNumbers[09], R, ""
SNumbers[10], R, ""
SNumbers[11], R, ""
SNumbers[12], R, ""
SNumbers[13], R, ""
@
|##################|#########|######### ######### ######### ######### ######### ######### ######### ######### ######### ######### ######### ######### #########|
}

(*
$P{ Part1:
?, L, ""
?, L, ""
@
|       㬥, ⢥ত騥   (),  த⥫, 㭠  ⥫, ࠧ 㣠,  饣              |
|       ______________________________________________________________________________________________________________________________________________________ |
|3.2.3.  㬬 室   ந⥫⢮  ਮ⥭  ,  ,  ᠤ ,   ________________________________ |
|       㬬 室, ਭ    ⭮ ਮ                                                                  ################################ |
|       㬬 室, 襤  ᫥騩                                                                            ________________________________ |
|          饣  ਮ⥭ ꥪ,  ஬ ந :                                                             |
|       ###################################################################################################################################################### |
|3.2.4. 稥                                                                                                                                           |
|       ______________________________________________________________________________________________________________________________________________________ |
}
*)

$P{EndPart:
P_Firm.FP_TaxDepCode(P_Firm.OWN_FIRM, SYSDATE()), L, ""
Str.Item(P_Firm.FP_TaxCardCont(P_Firm.OWN_FIRM, SYSDATE()), ";", 0), C, ""
Str.Item(P_Firm.FP_TaxCardCont(P_Firm.OWN_FIRM, SYSDATE()), ";", 1), C, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
@
|==============================================================================================================================================================|
|6. ଠ  ।⠢ ࠢ  室 䨧᪮                                                                                               |
| )   ᯥ:                                                                                                                                    |
|     ####     ।⠢ ᢥ   ᯥ ________________                                                                         |
|   N ࠢ _____________    ⠢ ________________   N    ________________                                                                 |
| ) ⥫騪:                                                                                                                                        |
|   N ࠢ _____________    ⠢ ________________    뤠 ________________                                                                 |
|==============================================================================================================================================================|
|7. ࠢ쭮   窨 ஢७                                                                                                       |
|   ____________ ################################## ################################################## ____________________                                    |
|      ()               ()                          (䠬, , ⢮)                   ()                                          |
|   ____________ __________________________________ __________________________________________________ ____________________                                    |
|      ()               ()                          (䠬, , ⢮)                   ()                                          |
=(c) Polak=====================================================================================================================================##########=#####=
}
*)

 PRIVATE PROCEDURE GetResidentStatus(): SCAL[2];
 BEGIN
  RETURN L_Man.Man_Citizen(Man.Man, CurP)<=1(**);
 END {GetResidentStatus};

 PRIVATE PROCEDURE HasInStateJMode(P: DATE): SCAL[2];
 BEGIN
  SELECT(Sheet, TSN, , Staff.TSN, P);
  WHILE OCCURE(Sheet) DO
   CONFORM(Sheet, JMode);
   IF JMode.InFirm THEN
    RETURN 1;
   END;
   NEXT(Sheet);
  END; (* WHILE OCCURE(Sheet)... *)
  RETURN 0;
 END {HasInStateJMode};

 PRIVATE PROCEDURE GetRomeStr(): STRING[];
  VAR
   ye,
   no,
   S      : STRING[];
   W      : SCAL[2][12];
   P      : DATE;
   i      : SCAL[13];
 BEGIN
  ye:="01  ,02  ,03  ,04  ,05  ,06  ,07  ,08  ,09  ,10  ,11  ,12";
  no:="__  ,__  ,__  ,__  ,__  ,__  ,__  ,__  ,__  ,__  ,__  ,__";
  SETZERO(W);
  SAVE(Staff);
  SELECT(Staff, Man, , Man.Man);
  WHILE OCCURE(Staff) DO
   P:=L_DatTim.YearBeg(CurP);
   WHILE P <= CurP DO
    IF L_Staff.IsWorking(P) & HasInStateJMode(P) THEN
     W[L_DatTim.MONTH(P)]:=1;
    END;
    P:=L_DatTim.IncMonth(P, +1);
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  RESTORE(Staff);
  i:=0; S:=" ";
  WHILE i < 12 DO
   IF W[i] THEN
    S:=S + Str.Item(ye, ",", i);
   ELSE
    S:=S + Str.Item(no, ",", i);
   END;
   INC(i);
  END;
  RETURN S;
 END {GetRomeStr};

 PRIVATE PROCEDURE GetPrepReason(_Reason: LIKE(TaxAdv.Reason));
  CONST
   TypeStr=" 㡫|" +
           "-⭮ 쭮 筮  㤠|" +
           " 쭠 ⠢ ";
 BEGIN
  SELECT(_MnTA, _MnTA, , Man.Man, _Reason);
  WHILE OCCURE(_MnTA) DO
   L_Tax.Tax_AccessManTA_by_MnTA();
   CONFORM(ManTA, TaxInq);
   IF TaxInq.InqType = L_Tax.inqt_Own THEN
    CONFORM(ManTA, TaxAdv);
    TypeSubCap(0, "        ࠧ "+
                  FLDTOSTR(L_Tx2000.GetTAValue(CurP, 0), "0", 0)+
                  Str.Item(TypeStr, "|", TaxAdv.Type)+
                  ". ᭮ "+FLDTOSTR(TaxInq.SrcNum, "", 0), " ", 0);
   END;
   NEXT(_MnTA);
  END; (* WHILE OCCURE(_MnTA) ... *)
 END {GetPrepReason};

 PRIVATE PROCEDURE TypeSubCap(TopL: SCAL[3]; S, S1: STRING[]; BotL: SCAL[2]);
 BEGIN
  IF    TopL=1 THEN
   MAKEPART(R, DelLine);
  ELSIF TopL=2 THEN
   MAKEPART(R, DelLine2);
  END;
  MAKEPART(R, SubCap, S);
  IF BotL THEN
   MAKEPART(R, SubCap1, S1);
  END;
 END {TypeSubCap};

 PRIVATE PROCEDURE Convert(N: NUMERIC[2][14]; VAR S: STRING[30][14]);
  VAR i: SCAL[15];
 BEGIN
  SETEMPTY(S);
  i:=1;
  WHILE i < 14 DO
   IF ~!N[i] THEN
    S[i]:=L_Money.MoneyToStr(L_DatTim.YearBeg(CurP), "", N[i]);
   END;
   INC(i);
  END;
 END {Convert};

 PRIVATE PROCEDURE AddArr(VAR D: NUMERIC[2][12]; N: NUMERIC[2][12]; d: NUMERIC[0]);
  VAR i: SCAL[13];
 BEGIN
  SETZERO(i);
  WHILE i <= 11 DO
   IF N[i] = 0 THEN
    SETEMPTY(Numbers[i+1]);
   ELSE
    Numbers[i+1]:=N[i];
    INC(D[i], d*N[i]);
    INC(Numbers[13], N[i]);
   END;
   INC(i);
  END; (* WHILE i ...  *)
 END {AddArr};

 PRIVATE PROCEDURE Restrict(VAR What: NUMERIC[2][12]; By: NUMERIC[2][12]);
  VAR
   i: SCAL[100];
   W,
   B: NUMERIC[2];
 BEGIN
  SETZERO(i, W, B);
  WHILE i <= 11 DO
   INC(W, What[i]);
   INC(B,   By[i]);
   IF W > B THEN
    IF i < 11 THEN
     INC(What[i+1], W-B);
     DEC(What[i],   W-B);
     W:=B;
    ELSE
     DEC(What[i], W-B);
    END;
   END;
   INC(i);
  END; (* WHILE i ...  *)
 END {Restrict};

 PRIVATE PROCEDURE TypeLine(S: STRING[];VAR D: NUMERIC[2][12]; N: NUMERIC[2][12]; d: NUMERIC[0]; sPer: STRING[]);
 BEGIN
  SETZERO(Numbers);
  AddArr(D, N, d);
  IF (Numbers[13] # 0) THEN
   Convert(Numbers, SNumbers);
   MAKEPART(R, Line, S, sPer);
  END;
 END {TypeLine};

 PRIVATE PROCEDURE Type_FYB_Line(S: STRING[]; N: NUMERIC[2][12]; UpTo: SCAL[12]; sPer: STRING[]);
  VAR i: SCAL[14];
 BEGIN
  SETZERO(i, Numbers);
  WHILE i <= UpTo DO
   Numbers[i+1]:=Numbers[i]+N[i]; INC(i);
  END; (* WHILE i ...  *)
  WHILE i <= 11 DO
   INC(i);
   SETEMPTY(Numbers[i]);
  END;
  Numbers[13]:=Numbers[UpTo+1];
  Convert(Numbers, SNumbers);
  MAKEPART(R, Line, S, sPer);
 END {Type_FYB_Line};

 PRIVATE PROCEDURE Type_ReadyFYB_Line(S: STRING[]; N: NUMERIC[2][12]; UpTo: SCAL[12]; sPer: STRING[]);
  VAR
   i: SCAL[14];
 BEGIN
  SETZERO(i, Numbers);
  WHILE i <= UpTo DO
   Numbers[i+1]:=N[i];
   INC(i);
  END; (* WHILE i ...  *)
  WHILE i <= 11 DO
   INC(i);
   SETEMPTY(Numbers[i]);
  END;
  Numbers[13]:=Numbers[UpTo+1];
  Convert(Numbers, SNumbers);
  MAKEPART(R, Line, S, sPer);
 END {Type_ReadyFYB_Line};

 PRIVATE PROCEDURE MakeFYBArr(VAR D: NUMERIC[2][12]; S: NUMERIC[2][12]; UpTo: SCAL[12]; MayBeNeg: SCAL[2]);
  VAR
   i: SCAL[13];
 BEGIN i:=0;
  WHILE i <= UpTo DO
   IF i < UpTo THEN
    INC(D[i+1], D[i]);
    INC(S[i+1], S[i]);
   END;
   IF (D[i] > S[i]) | MayBeNeg THEN
    DEC(D[i], S[i]);
   ELSE
    D[i]:=0;
   END;
   INC(i);
  END;
 END {MakeFYBArr};

 PRIVATE PROCEDURE OtherYear(_TaxAdv: LIKE(TaxAdv.TaxAdv)[]; D1, D2: DATE; S: STRING[]);
  VAR
   _Dummy: NUMERIC[2][12];
   i     : NUMERIC[0];
 BEGIN
  SETZERO(_Dummy);
  SELECT(TaxInq, Man, , Man.Man);
  WHILE OCCURE(TaxInq) DO
   i:=0;
   WHILE i <= HIGH(_TaxAdv) DO
    SEARCH(TaxAdv, TaxAdv,  , _TaxAdv[i]);
    SELECT(ManTA, TaxInq, , TaxInq.TaxInq, _TaxAdv[i]);
    WHILE OCCURE(ManTA) DO
     IF (TaxInq.Date=D2) & (ManTA.StartD >=D1) THEN
      INC(_Dummy[0], L_Tx2000.GetTAValue(CurP, 1));
     END;
     NEXT(ManTA);
    END; (* WHILE OCCURE(ManTA) ... *)
    INC(i);
   END;
   NEXT(TaxInq);
  END; (* WHILE OCCURE(TaxInq) ... *)
  IF _Dummy[0] # 0 THEN
   Type_ReadyFYB_Line(S, _Dummy, 0, " ");
  END;
 END {OtherYear};

 PRIVATE PROCEDURE FromPrevYear();
  VAR
   Dummy    : NUMERIC[2][12];
   _Dummy   : NUMERIC[2][12];
   LimVal   : NUMERIC[2];
 BEGIN
  TypeSubCap(1, "  ।騥 ", " ", 0);
  SETZERO(Dummy, _Dummy);
  IF L_Tx2000.GetOneTaxAdv(CurP, CurP, 10(*_tr_PdTaxF*), 49, _Dummy, LimVal) THEN
   INC(Dummy, _Dummy);
  END;
  SETZERO(_Dummy);
  IF L_Tx2000.GetOneTaxAdv(CurP, CurP, 5(*_tr_PdTaxC*), 50, _Dummy, LimVal) THEN
   INC(Dummy, _Dummy);
  END;
  IF Dummy[0] # 0 THEN
   Type_FYB_Line("㬬 ", Dummy, 0, " ");
  END;
 END {FromPrevYear};

 PRIVATE PROCEDURE Make();
  VAR
   Count,
   i        : NUMERIC[0];
   _ToTax,
   _Oblag,
   _Minus,
   _Dummy,
   _PureInc,
   _OthrInc,
   _AdvInc,
   _Limits,
   _LimVal,
   _GetPns,
   _GetPnsA,
   _OthrMns,
   _ClcTaxF,
   _ClcTaxC,
   _GetTaxF,
   _GetTaxC,
   _OverF,
   _OverC,
   _Under   : NUMERIC[2][12];
   LimVal   : NUMERIC[2];
   P        : DATE;
   Idx      : SCAL[12];
   tmp      : STRING[];
   _Limit   : NUMERIC[2];
 BEGIN
  TypeSubCap(2, "3.   室, ⠭ ", " ", 0);
  TypeSubCap(0, "3.1.   ⮢:", " ", 1);

  SETZERO(_Minus);

  PROMPT("");

  SETZERO(_GetTaxF, _GetTaxC, _GetPns, _GetPnsA);
  L_Tx2000._GetTaxAndPens(CurP, _GetTaxF, _GetTaxC, _GetPns, _GetPnsA);
  IF L_Tx2000.GetArrSum(_GetPns) # 0 THEN
   TypeLine("10", _Minus, _GetPns, +1, M);
  END;

  _Dummy[0]:=L_Tx2000.GetOverTax(CurP, CurP);

  SELECT(TaxAdv, TAReason, , 2);                         (* _tr_Persn  *)
  WHILE OCCURE(TaxAdv) DO
   SAVE(TaxAdv);
   SETZERO(_OthrMns);
   IF L_Tx2000.GetOneTaxAdv(CurP, CurP, TaxAdv.Reason, TaxAdv.TaxAdv, _OthrMns, LimVal) THEN
    IF L_Tx2000.NeedEstimate(TaxAdv.TaxAdv) & L_Tx2000.EstimateDone() THEN
     L_Tx2000.GetEstimateArr(_OthrMns, _Dummy);
     TypeLine("22", _Minus, _Dummy, +1, M);
    END;
    TypeLine(TaxAdv.LCode, _Minus, _OthrMns, +1, M);
   END;
   RESTORE(TaxAdv);
   NEXT(TaxAdv);
  END; (* WHILE OCCURE(TaxAdv) ... *)

  SELECT(TaxAdv, TAReason, , 3);                         (* _tr_Child  *)
  WHILE OCCURE(TaxAdv) DO
   SAVE(TaxAdv);
   SETZERO(_OthrMns);
   IF L_Tx2000.GetOneTaxAdv(CurP, CurP, TaxAdv.Reason, TaxAdv.TaxAdv, _OthrMns, LimVal) THEN
    IF L_Tx2000.NeedEstimate(TaxAdv.TaxAdv) & L_Tx2000.EstimateDone() THEN
     L_Tx2000.GetEstimateArr(_OthrMns, _Dummy);
     IF    TaxAdv.DefValue = 1 THEN
      TypeLine("31", _Minus, _Dummy, +1, M);
     ELSIF TaxAdv.DefValue = 2 THEN
      TypeLine("46", _Minus, _Dummy, +1, M);
     ELSE
      L_General.Error("⨬ 稭 䨪樨 "+TaxAdv.TaxAdv);
     END;
    END;
    TypeLine(TaxAdv.LCode, _Minus, _OthrMns, +1, M);
   END;
   RESTORE(TaxAdv);
   NEXT(TaxAdv);
  END; (* WHILE OCCURE(TaxAdv) ... *)

  SELECT(TaxAdv, TAReason, , 4);                         (* _tr_DecWA  *)
  WHILE OCCURE(TaxAdv) DO
   SETZERO(_OthrMns);
   SAVE(TaxAdv);
   IF L_Tx2000.GetOneTaxAdv(CurP, CurP, TaxAdv.Reason, TaxAdv.TaxAdv, _OthrMns, LimVal) THEN
    SETZERO(_Limits);
    i:=0;
    WHILE (LimVal > 0) & (i < 12) DO
     IF _OthrMns[i] > 0 THEN
      IF _OthrMns[i] >= LimVal THEN
       _Limits[i]:=LimVal;
      ELSE
       _Limits[i]:=_OthrMns[i];
      END;
      DEC(LimVal, _OthrMns[i]);
     END;
     INC(i);
    END; (* WHILE i < ... *)
    TypeLine(TaxAdv.LCode, _Minus, _Limits, +1, M);
   END;
   RESTORE(TaxAdv);
   NEXT(TaxAdv);
  END; (* WHILE OCCURE(TaxAdv) ... *)

  SELECT(TaxAdv, TAReason, , 8);                         (* _tr_PdPns  *)
  WHILE OCCURE(TaxAdv) DO
   SETZERO(_OthrMns);
   SAVE(TaxAdv);
   IF L_Tx2000.GetOneTaxAdv(CurP, CurP, TaxAdv.Reason, TaxAdv.TaxAdv, _OthrMns, LimVal) THEN
    TypeLine(TaxAdv.LCode, _Minus, _OthrMns, +1, M);
    SETZERO(i);
    WHILE i <= 11 DO
     INC(_GetPns[i], _OthrMns[i]);
     INC(i);
    END; (* WHILE i ...  *)
   END;
   RESTORE(TaxAdv);
   NEXT(TaxAdv);
  END; (* WHILE OCCURE(TaxAdv) ... *)

  MAKEPART(R, DelLine);
  SETZERO(_Dummy);
  TypeLine("㬬 ⮢", _Dummy, _Minus, -1, M);
  Type_FYB_Line("ᥣ", _Minus, L_DatTim.MONTH(CurP), Y);

  TypeSubCap(1, "3.2. ࠢ  :", " ", 0);
  TypeSubCap(0, "3.2.1. ᮭ ", " ", 0);
  GetPrepReason(2(*_tr_Persn*));
  TypeSubCap(0, "3.2.2.   ⥩, 楢", " ", 0);
  GetPrepReason(3(*_tr_Child*));
  SETZERO(_Dummy);
  IF L_Tx2000.GetOneTaxAdv(CurP, CurP, 4(*_tr_DecWA*), 19(**), _Dummy, LimVal) THEN
   tmp:=GetP_BuyFlats(Staff.TSN, CurP);
  ELSE
   tmp:=" ";
  END;
  MAKEPART(R, Part1, L_Money.MoneyToStr(L_DatTim.YearBeg(CurP), "", L_Tx2000.GetArrSum(_Dummy)), tmp);
  TypeSubCap(0, " ", " ", 0);

  TypeSubCap(2, "4.  室", " 室/᪨", 1);
  TypeSubCap(1, "4.1. 室,  砥  ᮢ㯭  室", " ", 0);
  SETZERO(_ToTax, _LimVal);

  PROMPT("ࠡ⭠ ");

  SETZERO(_PureInc);
  L_Tx2000.GetPureIncome(CurP, _PureInc, 0);
  TypeLine("0200", _ToTax, _PureInc, +1, M);

  SELECT(_MnTA, _MnTA, , Man.Man, 0);                       (* _tr_PrInc  *)
  WHILE OCCURE(_MnTA) DO
   SETZERO(_OthrInc, Count);
   CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType, _MnTA._TaxAdv);
   SEARCH(TaxAdv, TaxAdv,  , _MnTA._TaxAdv);
   WHILE OCCURE(_MnTA) DO
    L_Tax.Tax_AccessManTA_by_MnTA();
    INC(_OthrInc[L_DatTim.MONTH(ManTA.StartD)],
        L_Tx2000.GetTAValue(L_DatTim.Per(ManTA.StartD), 1));
    INC(Count);
    NEXT(_MnTA);
   END; (* WHILE OCCURE(_MnTA) ... *)
   LAST(_MnTA);
   IF Count > 0 THEN
    IF TaxAdv.TaxAdv = 30 THEN
     TypeLine(      "0200", _ToTax, _OthrInc, +1, M);
    ELSE
     TypeLine(TaxAdv.VCode, _ToTax, _OthrInc, +1, M);
    END;
   END;
   CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType);
   NEXT(_MnTA);
  END; (* WHILE OCCURE(_MnTA) ... *)

  TypeSubCap(1, "4.2. 室, 筮 砥  ᮢ㯭  室", " ", 0);
  PROMPT("室  ᪨");

  SELECT(TaxAdv, TAReason, , 1);                         (* _tr_IncWA  *)
  WHILE OCCURE(TaxAdv) DO
   SETZERO(_AdvInc);
   SAVE(TaxAdv);
   IF L_Tx2000.GetOneTaxAdv(CurP, CurP, TaxAdv.Reason, TaxAdv.TaxAdv, _AdvInc, LimVal) THEN
    TypeLine(TaxAdv.VCode, _ToTax, _AdvInc, +1, M);
    IF LimVal > 0 THEN
     SETZERO(_Limits);
     i:=0;
     WHILE (LimVal > 0) & (i < 12) DO
      IF _AdvInc[i] > 0 THEN
       _Limit:=LimVal;
       IF TaxAdv.LimOft = 1(*筮*) THEN
        _Limit:=Limit(LimVal);
       END;
       _Limits[i]:=Math.Min(_AdvInc[i], _Limit);
       DEC(LimVal, _Limits[i]);
      END;
      INC(i);
     END; (* WHILE i < ... *)
     TypeLine(TaxAdv.LCode+"  .. ᪨", _LimVal, _Limits, +1, M);
    END; (* IF LimVal > 0 ... *)
   END;
   RESTORE(TaxAdv);
   NEXT(TaxAdv);
  END; (* WHILE OCCURE(TaxAdv) ... *)

  TypeSubCap(1, "4.3.  室", " ", 0);

  TypeSubCap(1, "4.4.  㬬 ᮢ㯭  室", " ", 0);
  SETZERO(_Oblag);
  TypeLine(" ", _Oblag, _ToTax, +1, M);

  TypeSubCap(1, "4.5.  㬬 ᪨ (室)", " ", 0);
  TypeLine(" ", _Oblag, _LimVal, -1, M);

  SETZERO(_Dummy);
  TypeSubCap(1, "4.6. C㬬 樥⮢  ", " ", 0);
  TypeLine(" ", _Dummy, _Dummy, 0, M);
  TypeSubCap(1, "4.7. C㬬 ਠ쭮 룮  ", " ", 0);
  TypeLine(" ", _Dummy, _Dummy, 0, M);
  TypeSubCap(1, "4.8. C㬬 ਠ쭮 룮  客 믫⠬", " ", 0);
  TypeLine(" ", _Dummy, _Dummy, 0, M);

  TypeSubCap(1, "4.9. 㯭 室  栬", " ", 0);
  TypeLine(" ", _Oblag, _Oblag, 0, M);

  TypeSubCap(2, "5.   室  㬬 室 ", " ", 0);

  TypeSubCap(1, "७ᥭ   窨 ।饣 ⭮ ", " ", 0);
  P:=L_DatTim.IncMonth(L_DatTim.YearBeg(CurP), -1);
  OtherYear(TA_NYInc, L_DatTim.YearBeg(CurP), P, "㬬 .室");
  OtherYear(TA_OverTax, L_DatTim.YearBeg(CurP), P, "㬬 ");
  SETZERO(_Dummy);

  Restrict(_Minus, _Oblag);

  AddArr(_Oblag, _Minus, -1);

  TypeSubCap(1, "㯭  室", " ", 1);
  Type_FYB_Line("㬬 ᮢ.室",      _ToTax,  L_DatTim.MONTH(CurP), Y);
  Type_FYB_Line("㬬 ᪨()",    _LimVal, L_DatTim.MONTH(CurP), Y);
  Type_FYB_Line("㬬 ⮢ ᥣ",   _Minus,  L_DatTim.MONTH(CurP), Y);
  Type_FYB_Line("㬬 ⮢  ",    _GetPns, L_DatTim.MONTH(CurP), Y);
  Type_FYB_Line("㬬 .室", _Oblag,  L_DatTim.MONTH(CurP), Y);

  PROMPT("");

  SELECT(TaxAdv, TAReason, , 5);                         (* _tr_PdTaxC *)
  WHILE OCCURE(TaxAdv) DO
   SAVE(TaxAdv);
   IF L_Tx2000.GetOneTaxAdv(CurP, CurP, TaxAdv.Reason, TaxAdv.TaxAdv, _GetTaxC, LimVal) THEN
   END;
   RESTORE(TaxAdv);
   NEXT(TaxAdv);
  END; (* WHILE OCCURE(TaxAdv) ... *)

  SELECT(TaxAdv, TAReason, , 10);                         (* _tr_PdTaxF *)
  WHILE OCCURE(TaxAdv) DO
   SAVE(TaxAdv);
   IF L_Tx2000.GetOneTaxAdv(CurP, CurP, TaxAdv.Reason, TaxAdv.TaxAdv, _GetTaxF, LimVal) THEN
   END;
   RESTORE(TaxAdv);
   NEXT(TaxAdv);
  END; (* WHILE OCCURE(TaxAdv) ... *)

  SETZERO(_Dummy, _ClcTaxF, _ClcTaxC, _OverF, _OverC, _Under);

  MakeFYBArr(_GetTaxF, _Dummy, L_DatTim.MONTH(CurP), 1);
  MakeFYBArr(_GetTaxC, _Dummy, L_DatTim.MONTH(CurP), 1);

  P:=Math.Max(L_Env.aptm_Start, L_DatTim.YearBeg(CurP));
  REPEAT Idx:=L_DatTim.MONTH(P);
   PROMPT(" + " + FLDTOSTR(P, "N.Y", 0));
   L_Tx2000._GetOverTax(P, P, _ClcTaxF[Idx], _ClcTaxC[Idx]);
   _OverF[Idx]:=_ClcTaxF[Idx];
   _OverC[Idx]:=_ClcTaxC[Idx];
   INC(_ClcTaxC[Idx], _GetTaxC[Idx]+_GetTaxF[Idx]);
   INC(_GetTaxC[Idx], _GetTaxF[Idx]);
   P:=L_DatTim.IncMonth(P, +1);
  UNTIL P > CurP;
  TypeSubCap(1, "㬬 ", " ", 0);
  Type_ReadyFYB_Line("᫥",  _ClcTaxC, L_DatTim.MONTH(CurP), Y);
  Type_ReadyFYB_Line("ঠ",   _GetTaxC, L_DatTim.MONTH(CurP), Y);

  TypeSubCap(1, "७ᥭ    ᫥饣 ⭮ ", " ", 0);
  IF L_DatTim.MONTH(CurP) = 11 THEN
   P:=L_DatTim.IncMonth(L_DatTim.YearBeg(CurP), +12);
   OtherYear(TA_NYInc, P, CurP, "㬬 .室");
   OtherYear(TA_OverTax, P, CurP, "㬬 ");
  END;

  FromPrevYear();

  SETZERO(_Dummy);
  TypeSubCap(1, "樥  ", " ", 1);
  Type_ReadyFYB_Line(" 㬬",              _Dummy, L_DatTim.MONTH(CurP), Y);
  Type_ReadyFYB_Line("㬬 ⮢ ᥣ",      _Dummy, L_DatTim.MONTH(CurP), Y);
  Type_ReadyFYB_Line("㬬 ⮢  ",       _Dummy, L_DatTim.MONTH(CurP), Y);
  Type_ReadyFYB_Line(" 㬬",         _Dummy, L_DatTim.MONTH(CurP), Y);
  TypeSubCap(1, "㬬 ", " ", 0);
  Type_ReadyFYB_Line("᫥",              _Dummy, L_DatTim.MONTH(CurP), Y);
  Type_ReadyFYB_Line("ঠ ",              _Dummy, L_DatTim.MONTH(CurP), Y);

  TypeSubCap(2, " 㬬 ਠ쭮 룮  室     ࠬ 客", " ", 0);
  TypeSubCap(0, "ਠ쭠 룮  室  ᪨   ࠬ 客 ", " ", 0);

  TypeSubCap(2, "⮣  㬬 室 ", " ", 0);
  TypeSubCap(1, "७ᥭ   窨 ।饣 ⭮ ", " ", 0);
  P:=L_DatTim.IncMonth(L_DatTim.YearBeg(CurP), -1);
  OtherYear(TA_OverTax, L_DatTim.YearBeg(CurP), P, "㬬 ");
  TypeSubCap(1, "㬬 ", " ", 0);
  Type_ReadyFYB_Line("᫥",  _ClcTaxC, L_DatTim.MONTH(CurP), Y);
  Type_ReadyFYB_Line("ঠ",   _GetTaxC, L_DatTim.MONTH(CurP), Y);
  TypeSubCap(1, " ", " ", 0);
  Type_ReadyFYB_Line("(+/-)", _OverC,   L_DatTim.MONTH(CurP), Y);
  TypeSubCap(1, "७ᥭ    ᫥饣 ⭮ ", " ", 0);
  IF L_DatTim.MONTH(CurP) = 11 THEN
   P:=L_DatTim.IncMonth(L_DatTim.YearBeg(CurP), +12);
   SETZERO(_Dummy);
   OtherYear(TA_OverTax, P, CurP, "㬬 ");
  END;
  FromPrevYear();
 END {Make};

 PUBLIC PROCEDURE T7CurMan();
 BEGIN
  TA_NYInc:=30;
  TA_OverTax[0]:=08;
  TA_OverTax[1]:=48;
  CurP :=Memo.ud_mb();
  CurPE:=Memo.ud_me();
  L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
  L_Staff.CheckCurrentAsMainForTax(CurPE);
  L_PRoll.CheckSalDone(CurP);
  CONFORM(Staff, Man);
  OPENREP(R, L_General.NameConnection("Tax07"), Create);
  SetPrintAttr(R, Orientation, Portrait,  MaxPages,    1);
  HISTCONF(CurPE, Staff, StaffLog);
  CONFORM(StaffLog, Post);
  L_Man.PrepareRgManAdressForTax_37(CurP, _Town, _Village, _Street, _Block);
  MAKEPART(R, Cap);
  L_Tx2000.NTax_InitValues(CurP);
  Make();
  L_Tax.Tax_FreeValues(CurP);
  MAKEPART(R, EndPart);
  CLOSEREP(R);
 END {T7CurMan};

END.
