(*
%Copyright   (c) Polak Computer System
%Author      11.09.1995 18:50:07 SAN
%Purpose      窠 ()
%Type        report
%Specific    SYS
%Modified    12.05.2014 12:24:41 POLAK\Gina
%Environment
*)

 MODULE Tax3 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General;

 TYPE
  tTax3Mode = SCAL[4];

 CONST
  t3m_ToPaper         = 0; (*tTax3Mode*)
  t3m_ByCurrentPacket = 1;
  t3m_ForInq          = 2;
  t3m_All             = 3;

 PRIVATE PROCEDURE Tax3(P: DATE; trgMode: tTax3Mode);
 BEGIN
  IF    P >= 01\01\2010 THEN
   CALL(T3_2010.T3_2010(trgMode));
  ELSIF P >= 01\01\2006 THEN
   CALL(T3_2006.T3_2006(trgMode));
  ELSIF P >= 01\01\2005 THEN
   CALL(T3_2005.T3_2005(trgMode));
  ELSIF P >= 01\01\2002 THEN
   CALL(T3_2002.T3_2002(trgMode));
  ELSIF P >= 01\01\2001 THEN
   CALL(T3_2001.T3_2001(trgMode));
  ELSIF P >= 01\01\2000 THEN
   CALL(T3_2000.T3_2000(trgMode));
  ELSIF P >= 01\01\1999 THEN
   CALL(T3_1999.T3_1999(trgMode));
  ELSE
   CALL(T3_1998.T3_1998(trgMode));
  END;
 END {Tax3};

 PUBLIC PROCEDURE Ta3ToPaper();
 BEGIN
  Tax3(Memo.ud_mb(), t3m_ToPaper);
 END {Ta3ToPaper};

 PUBLIC PROCEDURE Ta3ByCurrentPacket();
 BEGIN
  L_General.Assert(ACCESS(Packet), " । ⥪騩 ");
  Tax3(Packet.PerB, t3m_ByCurrentPacket);
 END {Ta3ByCurrentPacket};

 PUBLIC PROCEDURE Ta3ForInq();
 BEGIN
  Tax3(Memo.ud_mb(), t3m_ForInq);
 END {Ta3ForInq};

 PUBLIC PROCEDURE Ta3All();
 BEGIN
  Tax3(Memo.ud_mb(), t3m_All);
 END {Ta3All};

 PUBLIC PROCEDURE Tax7ToPaper();
 BEGIN
  IF    Memo.ud_mb() >= 01\01\2002 THEN
   CALL(T7_2002.T7CurMan());
  ELSIF Memo.ud_mb() >= 01\01\2001 THEN
   CALL(T7_2001.T7CurMan());
  ELSIF Memo.ud_mb() >= 01\01\2000 THEN
   CALL(T7_2000.T7CurMan());
  ELSE
   CALL(T7_1999.T7CurMan());
  END;
 END {Tax7ToPaper};

END.
