(*
%Copyright   (c) Polak Computer System
%Author      21.06.2010 17:54:55 POLAK\MLB
%Purpose     TKind
%Type        operation
%Specific    SYS
%Modified    05.02.2014 18:14:35 POLAK\LDA
%Environment
*)
 MODULE TKind [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Events, L_General, L_WDO, L_Way;

 PRIVATE PROCEDURE TKind_OnAnyModification();
 BEGIN
  (* 0078979  㤠 25.06.2010 11:38:47 POLAK\MLB *)
 END {TKind_OnAnyModification};

 PRIVATE PROCEDURE TKind_OnAfterEdit();
 BEGIN
  TKind_OnAnyModification();
 END {TKind_OnAfterEdit};

 PRIVATE PROCEDURE TKind_OnAfterInsert();
 BEGIN
  L_General.Assert(TKind.TKind # 00, "  ॢ "+TKind.TKind+" १ࢨ஢ ⮏");
  TKind_OnAnyModification();
 END {TKind_OnAfterInsert};

 PRIVATE PROCEDURE TKind_OnBeforeDelete();
 BEGIN
  TKind_OnAnyModification();
 END {TKind_OnBeforeDelete};

 PRIVATE PROCEDURE TKind_OnInitializeWindow();
 BEGIN
  L_WDO.iScsChange(1, ["TKind.InOut"]);
  L_WDO.iField    (1, "TKind.Rgn"   ).Format:=L_Way.tkrgn_Pool;
  L_WDO.iField    (1, "TKind.FnMode").Format:=L_Way.tkfnm_Pool;
 END {TKind_OnInitializeWindow};

 PRIVATE PROCEDURE TKind_InOut_OnSuccessfulChange();
 BEGIN
  L_General.Assert(TKind.InOut # L_Way.tkout_Clc, "祭 ''  ਬ");
 END {TKind_InOut_OnSuccessfulChange};

BEGIN
 L_Events.ExecuteHandler();
END.

