(*
%Copyright   (c) Polak IT
%Author      11.01.2009 08:51:46 POLAK\LDA
%Purpose     ⠢    2009 
%Type
%Specific    A
%Modified    04.03.2010 13:52:14 POLAK\LDA
%Environment
*)

 IMPORT L_Car, L_Russia, L_General;

 PROCEDURE GetTransportTaxRate(_BPer    : DATE;
                               _VehType : LIKE(VehType.IRC_VehT);
                               _Age     : NUMERIC[0];
                               _EngPower: LIKE(VehPasp.EngPower)): NUMERIC[2];
 BEGIN
  IF _VehType = L_Car.ircvt_NotQualified THEN
   RETURN 0;
  END;
  IF Region.Region = L_Russia.reg_50 THEN
   IF _BPer >= 01\01\2006 THEN
    IF    _VehType = L_Car.ircvt_PassengerCar THEN
     IF    _EngPower <= 100.0 THEN RETURN 7.00;
     ELSIF _EngPower <= 150.0 THEN RETURN 20.00;
     ELSIF _EngPower <= 200.0 THEN RETURN 30.00;
     ELSIF _EngPower <= 250.0 THEN RETURN 50.00;
     ELSE                          RETURN 100.00;
     END;
    ELSIF _VehType = L_Car.ircvt_Motorcycle THEN
     IF    _EngPower <= 20.0 THEN RETURN 5.00;
     ELSIF _EngPower <= 35.0 THEN RETURN 10.00;
     ELSE                         RETURN 32.00;
     END;
    ELSIF (_VehType = L_Car.ircvt_Bus_wUL_UpTo5Year) |
          (_VehType = L_Car.ircvt_Bus_wUL_Over5Year) THEN
     IF    _EngPower <= 200.0 THEN RETURN 20.00;
     ELSE                          RETURN 40.00;
     END;
    ELSIF (_VehType = L_Car.ircvt_Truck_wUL_UpTo5Year) |
          (_VehType = L_Car.ircvt_Truck_wUL_Over5Year) THEN
     IF    _EngPower <= 100.0 THEN RETURN 15.00;
     ELSIF _EngPower <= 150.0 THEN RETURN 20.00;
     ELSIF _EngPower <= 200.0 THEN RETURN 25.00;
     ELSIF _EngPower <= 250.0 THEN RETURN 35.00;
     ELSE                          RETURN 45.00;
     END;
    ELSIF _VehType = L_Car.ircvt_SelfPropelledCar THEN
                                   RETURN 12.00;
    ELSIF _VehType = L_Car.ircvt_SnowMobile THEN
     IF    _EngPower <= 50.0 THEN  RETURN 20.00;
     ELSE                          RETURN 40.00;
     END;
    ELSIF _VehType = L_Car.ircvt_Boat THEN
     IF    _EngPower <= 100.0 THEN RETURN 40.00;
     ELSE                          RETURN 80.00;
     END;
    ELSIF _VehType = L_Car.ircvt_Yacht THEN
     IF    _EngPower <= 100.0 THEN RETURN 80.00;
     ELSE                          RETURN 160.00;
     END;
    ELSIF _VehType = L_Car.ircvt_Scooter THEN
     IF    _EngPower <= 100.0 THEN RETURN 100.00;
     ELSE                          RETURN 200.00;
     END;
    ELSIF _VehType = L_Car.ircvt_Barge THEN
                                   RETURN 40.00;
    ELSIF _VehType = L_Car.ircvt_AirCraft THEN
                                   RETURN 100.00;
    ELSIF _VehType = L_Car.ircvt_Glider THEN
                                   RETURN 600.00;
    ELSIF _VehType = L_Car.ircvt_JetAirplane THEN
                                   RETURN 80.00;
    END;
   ELSE
    IF     _VehType = L_Car.ircvt_PassengerCar THEN
     IF    _EngPower <= 100.0 THEN RETURN 6.00;
     ELSIF _EngPower <= 150.0 THEN RETURN 17.00;
     ELSIF _EngPower <= 200.0 THEN RETURN 30.00;
     ELSIF _EngPower <= 250.0 THEN RETURN 45.00;
     ELSE                          RETURN 90.00;
     END;
    ELSIF _VehType = L_Car.ircvt_Motorcycle THEN
     IF    _EngPower <= 20.0 THEN  RETURN 4.50;
     ELSIF _EngPower <= 35.0 THEN  RETURN 6.00;
     ELSE                          RETURN 15.00;
     END;
    ELSIF (_VehType = L_Car.ircvt_Bus_wUL_UpTo5Year) |
          (_VehType = L_Car.ircvt_Bus_wUL_Over5Year) THEN
     IF    _EngPower <= 200.0 THEN RETURN 20.00;
     ELSE                          RETURN 40.00;
     END;
    ELSIF (_VehType = L_Car.ircvt_Truck_wUL_UpTo5Year) |
          (_VehType = L_Car.ircvt_Truck_wUL_Over5Year) THEN
     IF    _EngPower <= 100.0 THEN RETURN 10.00;
     ELSIF _EngPower <= 150.0 THEN RETURN 20.00;
     ELSIF _EngPower <= 200.0 THEN RETURN 22.00;
     ELSIF _EngPower <= 250.0 THEN RETURN 25.00;
     ELSE                          RETURN 45.00;
     END;
    ELSIF _VehType = L_Car.ircvt_SelfPropelledCar THEN
                                   RETURN 10.00;
    ELSIF _VehType = L_Car.ircvt_SnowMobile THEN
     IF    _EngPower <= 50.0 THEN  RETURN 6.00;
     ELSE                          RETURN 17.00;
     END;
    ELSIF _VehType = L_Car.ircvt_Boat THEN
     IF    _EngPower <= 100.0 THEN RETURN 15.00;
     ELSE                          RETURN 30.00;
     END;
    ELSIF _VehType = L_Car.ircvt_Yacht THEN
     IF    _EngPower <= 100.0 THEN RETURN 60.00;
     ELSE                          RETURN 120.00;
     END;
    ELSIF _VehType = L_Car.ircvt_Scooter THEN
     IF    _EngPower <= 100.0 THEN RETURN 75.00;
     ELSE                          RETURN 150.00;
     END;
    ELSIF _VehType = L_Car.ircvt_Barge THEN
                                   RETURN 30.00;
    ELSIF _VehType = L_Car.ircvt_AirCraft THEN
                                   RETURN 25.00;
    ELSIF _VehType = L_Car.ircvt_Glider THEN
                                   RETURN 600.00;
    END;
   END;
  ELSIF Region.Region = L_Russia.reg_77 THEN
   IF      _BPer >= 01\01\2006 THEN
    IF     _VehType = L_Car.ircvt_PassengerCar THEN
     IF    _EngPower <= 100.0 THEN RETURN 7.00;
     ELSIF _EngPower <= 150.0 THEN RETURN 20.00;
     ELSIF _EngPower <= 200.0 THEN RETURN 30.00;
     ELSIF _EngPower <= 250.0 THEN RETURN 50.00;
     ELSE                          RETURN 100.00;
     END;
    ELSIF _VehType = L_Car.ircvt_Motorcycle THEN
     IF    _EngPower <= 20.0 THEN  RETURN 5.00;
     ELSIF _EngPower <= 35.0 THEN  RETURN 10.00;
     ELSE                          RETURN 32.00;
     END;
    ELSIF (_VehType = L_Car.ircvt_Bus_wUL_UpTo5Year) |
          (_VehType = L_Car.ircvt_Bus_wUL_Over5Year) THEN
     IF    _EngPower <= 110.0 THEN RETURN 10.00;
     ELSIF _EngPower <= 200.0 THEN RETURN 17.00;
     ELSE                          RETURN 35.00;
     END;
    ELSIF (_VehType = L_Car.ircvt_Truck_wUL_UpTo5Year) |
          (_VehType = L_Car.ircvt_Truck_wUL_Over5Year) THEN
     IF    _EngPower <= 100.0 THEN RETURN 10.00;
     ELSIF _EngPower <= 150.0 THEN RETURN 17.00;
     ELSIF _EngPower <= 200.0 THEN RETURN 25.00;
     ELSIF _EngPower <= 250.0 THEN RETURN 35.00;
     ELSE                          RETURN 45.00;
     END;
    ELSIF _VehType = L_Car.ircvt_SelfPropelledCar THEN
                                   RETURN 12.00;
    ELSIF _VehType = L_Car.ircvt_SnowMobile THEN
     IF    _EngPower <= 50.0 THEN  RETURN 20.00;
     ELSE                          RETURN 40.00;
     END;
    ELSIF _VehType = L_Car.ircvt_Boat THEN
     IF    _EngPower <= 100.0 THEN RETURN 40.00;
     ELSE                          RETURN 80.00;
     END;
    ELSIF _VehType = L_Car.ircvt_Yacht THEN
     IF    _EngPower <= 100.0 THEN RETURN 80.00;
     ELSE                          RETURN 160.00;
     END;
    ELSIF _VehType = L_Car.ircvt_Scooter THEN
     IF    _EngPower <= 100.0 THEN RETURN 100.00;
     ELSE                          RETURN 200.00;
     END;
    ELSIF _VehType = L_Car.ircvt_Barge THEN
                                   RETURN 40.00;
    ELSIF _VehType = L_Car.ircvt_AirCraft THEN
                                   RETURN 100.00;
    ELSIF _VehType = L_Car.ircvt_Glider THEN
                                   RETURN 500.00;
    ELSIF _VehType = L_Car.ircvt_JetAirplane THEN
                                   RETURN 80.00;
    END;
   ELSE
    IF     _VehType = L_Car.ircvt_PassengerCar THEN
     IF    _EngPower <= 100.0 THEN RETURN 5.00;
     ELSIF _EngPower <= 150.0 THEN RETURN 15.00;
     ELSIF _EngPower <= 200.0 THEN RETURN 20.00;
     ELSIF _EngPower <= 250.0 THEN RETURN 25.00;
     ELSE                          RETURN 35.00;
     END;
    ELSIF _VehType = L_Car.ircvt_Motorcycle THEN
     IF    _EngPower <= 20.0 THEN  RETURN 3.00;
     ELSIF _EngPower <= 35.0 THEN  RETURN 6.00;
     ELSE                          RETURN 20.00;
     END;
    ELSIF (_VehType = L_Car.ircvt_Bus_wUL_UpTo5Year) |
          (_VehType = L_Car.ircvt_Bus_wUL_Over5Year) THEN
     IF    _EngPower <= 110.0 THEN RETURN 6.00;
     ELSIF _EngPower <= 200.0 THEN RETURN 10.00;
     ELSE                          RETURN 20.00;
     END;
    ELSIF (_VehType = L_Car.ircvt_Truck_wUL_UpTo5Year) |
          (_VehType = L_Car.ircvt_Truck_wUL_Over5Year) THEN
     IF    _EngPower <= 100.0 THEN RETURN 6.00;
     ELSIF _EngPower <= 150.0 THEN RETURN 10.00;
     ELSIF _EngPower <= 200.0 THEN RETURN 15.00;
     ELSIF _EngPower <= 250.0 THEN RETURN 20.00;
     ELSE                          RETURN 25.00;
     END;
    ELSIF _VehType = L_Car.ircvt_SelfPropelledCar THEN
                                   RETURN 6.00;
    ELSIF _VehType = L_Car.ircvt_SnowMobile THEN
     IF    _EngPower <= 50.0 THEN  RETURN 10.00;
     ELSE                          RETURN 20.00;
     END;
    ELSIF _VehType = L_Car.ircvt_Boat THEN
     IF    _EngPower <= 100.0 THEN RETURN 20.00;
     ELSE                          RETURN 30.00;
     END;
    ELSIF _VehType = L_Car.ircvt_Yacht THEN
     IF    _EngPower <= 100.0 THEN RETURN 35.00;
     ELSE                          RETURN 60.00;
     END;
    ELSIF _VehType = L_Car.ircvt_Scooter THEN
     IF    _EngPower <= 100.0 THEN RETURN 35.00;
     ELSE                          RETURN 60.00;
     END;
    ELSIF _VehType = L_Car.ircvt_Barge THEN
                                   RETURN 20.00;
    ELSIF _VehType = L_Car.ircvt_AirCraft THEN
                                   RETURN 25.00;
    ELSIF _VehType = L_Car.ircvt_Glider THEN
                                   RETURN 200.00;
    END;
   END;
  ELSE
   L_General.Error(" ࠭ᯮ⭮   ॣ " + Region.Region + "  ন");
  END;
  L_General.Error(" ⨯ ࠭ᯮ⭮ ।⢠ " + _VehType);
 END {GetTransportTaxRate};

END.
