(*
%Copyright   (c) Polak Computer System
%Author      26.04.2001 21:31:59 GINA
%Purpose     㠫쭠 窠  믫  
%Type        report
%Specific    SYS
%Modified    05.09.2014 10:47:19 POLAK\Bor
%Environment
*)

 MODULE TX_2001 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Man, P_Man, L_Staff, L_STx, L_XObj, L_DatTim,
        L_PRoll, Math, Str, L_EC, E_PRoll, L_Acnt, Memo, L_Russia;

(*  MAN_T2!! -  ? *)

 PRIVATE PROCEDURE GetCitizenshipCountryName(): STRING[];
 BEGIN
  IF ~L_Man.AccessManAdr(Man.Man, SYSDATE(), L_Russia.at_CtMA) THEN
   L_Man.AccessRgManAdr(Man.Man, SYSDATE());
  END;
  CONFORM(ManAdr, Country);
  RETURN Country.Name;
 END {GetCitizenshipCountryName};

 PRIVATE VAR
  _InvldValue   : LIKE(ManPro.Value);
  _InvldDocNum  : LIKE(ManPro.DocNum);
  _InvldDocGiveD: LIKE(ManPro.DocGiveD);
  _DgOrder      : LIKE(StaffLog.Order);
  _DgDate       : DATE;

  M_ValInc,
  Y_ValInc,
  M_IncNoTaxed,
  Y_IncNoTaxed,
  M_IncNoTaxed1000,
  Y_IncNoTaxed1000,
  M_IncNoTaxed2000,
  Y_IncNoTaxed2000,
  M_IncNoTaxed10000,
  Y_IncNoTaxed10000,
  M_IncNoTaxed100000,
  Y_IncNoTaxed100000,
  M_IncNoTaxedFirm,
  Y_IncNoTaxedFirm,
  M_NoTaxedPFR,
  Y_NoTaxedPFR,
  M_NoTaxedFSS,
  Y_NoTaxedFSS,
  M_TaxBasePFR,
  Y_TaxBasePFR,
  M_TaxBaseFSS,
  Y_TaxBaseFSS,
  M_TaxPFR,
  Y_TaxPFR,
  M_TaxFFOMS,
  Y_TaxFFOMS,
  M_TaxTFOMS,
  Y_TaxTFOMS,
  M_TaxFSS,
  Y_TaxFSS,
  M_IncFSS,
  Y_IncFSS   : NUMERIC[2];

(*
$P{ Top:
Memo.ud_mb(), L, "y"
Man.INN, L, ""
Man.Name, L, ""
GetCitizenshipCountryName(), L, ""
L_Man.GetManDocName(Man.DocType), L, ""
Man.PspSer, L, ""
Man.PspNbr, L, ""
Man.PspGiveD, L, "D.N.y"
Man.PspGiveS, L, ""
Man.Birth, L, "D.N.y"
L_Man.GetAdr_asStr(Man.Man, SYSDATE(), L_Russia.at_RgMA), L, ""
Post.Name, L, ""
(Staff.Contract>2), L, "㤮|ࠦ᪮-ࠢ"
_DgOrder, L, ""
_DgDate, L, "D.N.y"
_InvldValue, L, ""
_InvldDocNum, L, ""
_InvldDocGiveD, L, "D.N.y"
@
⠬ ⥫騪                                                                                                                            ਫ N 1  ਪ  ᨨ  27.02.2001 N -3-07/63

                                                                  㠫쭠 窠  㬬 ᫥ 믫   ࠦ,
                                                                    ⠪ 㬬 ᫥  樠쭮  ()  #### 
=================================================================================================================================================================================================================
|  ࠡ⭨-⥫ 室:  ############     ... ############################################################     ࠦ⢮ ##############################################################|
|######################################:  ##########      ##########     뤠 ########## ############################################################################################################|
| ஦ ##########      ⥫⢠ ############################################################################################################################################################|
| ################################################################    : ###################     ############  祭   (  祭 ) ##########|
|稥  ##########  ࠢ: ,  ################################  뤠 #########################                                                                                  |
|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|             |           |                              믫,  騥                              |          | ᫥  樠쭮  () |᫥  |
|             |           |-------------------------------------------------------------------------------------------------|-----------------------|-----------------------------------------------|  ᮡ  |
|             |᫥  |          믫,  騥    䮭           ||믫, |           |           |           |           |           |           |(室) |
|             |믫     |------------------------------------------------------------------------|        | |    ,   |      |        |      |      |      |     |
|   ,    |  -|           |                         ⮬ ᫥                         |(.26    |     | 䮭  |           |           |           |           |           |  ।  |
|   ਮ    |ࠦ|           |------------------------------------------------------------|   150-  |(  |           |           |           |           |           |           |      |
|             | ᥬ    |           |           |           |           |           |믫   |" 䥤ࠫ-|ࠦ᪮-|           |           |           |           |           |           |           |
|             |᭮,|   ᥣ   |   1000  |   2000  |   10000 |  100000 | ।|  |ࠢ  |           |           |           |           |           |           |           |
|             |ᥣ      |           |. |.   |.   |.   |⠢ | 2001 .")|ࠪ, |           |           |           |           |           |           |           |
|             |           |           |           |           |           | (죮)  |ᯮ殮|            |᪨ |           |           |           |           |           |           |           |
|             |           |           |           |           |           |           |࣠樨 |            |業.)|           |           |           |           |           |           |           |
|-------------|-----------|-----------|-----------|-----------|-----------|-----------|------------|------------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|
|      1      |     2     |     3     |     4     |     5     |     6     |     7     |     8      |      9     |    10     |    11     |    12     |    13     |    14     |    15     |    16     |    17     |
}
*)

(*
$P{ LineMonth:
?, L, "m"
M_ValInc, R, "2."
M_IncNoTaxed, R, "2."
M_IncNoTaxed1000, R, "2."
M_IncNoTaxed2000, R, "2."
M_IncNoTaxed10000, R, "2."
M_IncNoTaxed100000, R, "2."
M_IncNoTaxedFirm, R, "2."
M_NoTaxedPFR, R, "2."
M_NoTaxedFSS, R, "2."
M_TaxBasePFR, R, "2."
M_TaxBaseFSS, R, "2."
M_TaxPFR, R, "2."
M_TaxFFOMS, R, "2."
M_TaxTFOMS, R, "2."
M_TaxFSS, R, "2."
M_IncFSS, R, "2."
Y_ValInc, R, "2."
Y_IncNoTaxed, R, "2."
Y_IncNoTaxed1000, R, "2."
Y_IncNoTaxed2000, R, "2."
Y_IncNoTaxed10000, R, "2."
Y_IncNoTaxed100000, R, "2."
Y_IncNoTaxedFirm, R, "2."
Y_NoTaxedPFR, R, "2."
Y_NoTaxedFSS, R, "2."
Y_TaxBasePFR, R, "2."
Y_TaxBaseFSS, R, "2."
Y_TaxPFR, R, "2."
Y_TaxFFOMS, R, "2."
Y_TaxTFOMS, R, "2."
Y_TaxFSS, R, "2."
Y_IncFSS, R, "2."
@
|-------------|-----------|-----------|-----------|-----------|-----------|-----------|------------|------------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|-----------|
|###|  |###########|###########|###########|###########|###########|###########|############|############|###########|###########|###########|###########|###########|###########|###########|###########|
|   |  |###########|###########|###########|###########|###########|###########|############|############|###########|###########|###########|###########|###########|###########|###########|###########|
}
*)

(*
$P{ Bot:
SYSDATE(), L, "DNy"
SYSTIME(), L, "HM"
@
=================================================================================================================================================================================================================
⮢ " ⮏" (c) Polak                                                                                                                                                                 ######## ####
}
*)

 PRIVATE PROCEDURE NeedApport(_SignPtrn: LIKE(CAcnt.Sign)): SCAL[2];
 BEGIN
  IF ~!_SignPtrn THEN
   CONFORM(XApport, Apport);
   RETURN (Apport.CirType=L_Acnt.ct_Credit) &
          Str.Match(L_Acnt.GetCAcntSign(Memo.ud_me(), XApport.AcCut2), _SignPtrn);
  ELSE
   RETURN 1;
  END;
 END {NeedApport};

 PRIVATE PROCEDURE Get_XApport_Cir_By_Acnt(P: DATE; _AcCut: LIKE(XApport.AcCut); _SignPtrn: LIKE(CAcnt.Sign)): NUMERIC[2];
  VAR
   S: NUMERIC[2];
 BEGIN
  SETZERO(S);
  IF P <= Memo.ud_mb() THEN
   SELECT(XApport, XObject, , XObject.XObject, _AcCut, P);
   WHILE OCCURE(XApport) DO
    IF NeedApport(_SignPtrn) THEN
     INC(S, XApport.Sum);
    END;
    NEXT(XApport);
   END; (* WHILE OCCURE(XApport) ... *)
  END;
  RETURN S;
 END {Get_XApport_Cir_By_Acnt};

 PRIVATE PROCEDURE Get_XApport_Cir(P: DATE; _AcCut: LIKE(XApport.AcCut)): NUMERIC[2];
 BEGIN
  RETURN Get_XApport_Cir_By_Acnt(P, _AcCut, "");
 END {Get_XApport_Cir};

 PRIVATE PROCEDURE E_Need_ManTax_GetIncFSS(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_PRoll.Need_ManTax_GetIncFSS), 0);
 END {E_Need_ManTax_GetIncFSS};

 PRIVATE PROCEDURE MakeOneMonth(P: DATE);
 BEGIN
  M_ValInc:=Get_XApport_Cir(P, L_STx.STx_GetTotAcCut());
  INC(Y_ValInc, M_ValInc);

  M_IncNoTaxed1000:=0;
  INC(Y_IncNoTaxed1000, M_IncNoTaxed1000);

  M_IncNoTaxed2000:=0;
  INC(Y_IncNoTaxed2000, M_IncNoTaxed2000);

  M_IncNoTaxed10000:=0;
  INC(Y_IncNoTaxed10000, M_IncNoTaxed10000);

  M_IncNoTaxed100000:=-1 * Get_XApport_Cir(P, L_STx.STx_GetBnfAcCut(L_STx.STx_SSRF()));
  INC(Y_IncNoTaxed100000, M_IncNoTaxed100000);

  M_IncNoTaxedFirm:=0;
  INC(Y_IncNoTaxedFirm, M_IncNoTaxedFirm);

  M_IncNoTaxed:=(-1 * Get_XApport_Cir(P, L_STx.STx_GetExlAcCut()))+
                M_IncNoTaxed1000+M_IncNoTaxed2000+M_IncNoTaxed10000+M_IncNoTaxed100000;
  INC(Y_IncNoTaxed, M_IncNoTaxed);

  M_NoTaxedPFR:=0; (*, ப*)
  INC(Y_NoTaxedPFR, M_NoTaxedPFR);

  M_NoTaxedFSS:=-1 * Get_XApport_Cir(P, L_STx.STx_GetPoBAcCut(L_STx.STx_SSRF()));
  INC(Y_NoTaxedFSS, M_NoTaxedFSS);

  M_TaxBasePFR:=M_ValInc-M_IncNoTaxed;
  INC(Y_TaxBasePFR, M_TaxBasePFR);

  M_TaxBaseFSS:=M_ValInc-M_IncNoTaxed-M_NoTaxedFSS;
  INC(Y_TaxBaseFSS, M_TaxBaseFSS);

  M_TaxPFR:=Get_XApport_Cir(P, L_STx.STx_GetTaxAcCut(L_STx.STx_PFRF()));
  INC(Y_TaxPFR, M_TaxPFR);

  M_TaxFFOMS:=Get_XApport_Cir(P, L_STx.STx_GetTaxAcCut(L_STx.STx_MSFF()));
  INC(Y_TaxFFOMS, M_TaxFFOMS);

  M_TaxTFOMS:=Get_XApport_Cir(P, L_STx.STx_GetTaxAcCut(L_STx.STx_MSTF()));
  INC(Y_TaxTFOMS, M_TaxTFOMS);

  M_TaxFSS:=Get_XApport_Cir(P, L_STx.STx_GetTaxAcCut(L_STx.STx_SSRF()));
  INC(Y_TaxFSS, M_TaxFSS);

  IF E_Need_ManTax_GetIncFSS(P) THEN
   M_IncFSS:=Get_XApport_Cir_By_Acnt(P, L_STx.STx_GetTotAcCut(), "69*");
  ELSE
   M_IncFSS:=0;
  END;
  INC(Y_IncFSS, M_IncFSS);

  MAKEPART(R, LineMonth, P);
 END {MakeOneMonth};

 PRIVATE PROCEDURE Make();
  VAR
   P: DATE;
 BEGIN
  SETZERO(Y_ValInc, Y_IncNoTaxed, Y_NoTaxedPFR,
          Y_NoTaxedFSS, Y_IncNoTaxed1000, Y_IncNoTaxed2000,
          Y_IncNoTaxed10000, Y_IncNoTaxed100000, Y_IncNoTaxedFirm,
          Y_TaxBasePFR, Y_TaxBaseFSS, Y_TaxPFR, Y_TaxFFOMS, Y_TaxTFOMS, Y_TaxFSS,
          Y_IncFSS);

  P:=L_DatTim.YearBeg(Memo.ud_mb());
  WHILE P <= L_DatTim.YearEnd(Memo.ud_mb()) DO
   PROMPT(L_DatTim.PeriodStr(P));
   MakeOneMonth(P);
   P:=L_DatTim.IncMonth(P, +1);
  END;
 END {Make};

 PRIVATE PROCEDURE Set_InvldProps();
  VAR
   _Per: DATE;
 BEGIN
  SETEMPTY(_InvldValue, _InvldDocNum, _InvldDocGiveD);
  _Per:=L_DatTim.YearBeg(Memo.ud_mb());
  WHILE _Per <= Memo.ud_me() DO
   IF P_Man.HasActualManPro(Man.Man, L_DatTim.MonthEnd(_Per), P_Man.P_Invalid) THEN
    _InvldValue   :=ManPro.Value;
    _InvldDocNum  :=ManPro.DocNum;
    _InvldDocGiveD:=ManPro.DocGiveD;
   END;
   _Per:=L_DatTim.IncMonth(_Per, +1);
  END;
 END {Set_InvldProps};

 PUBLIC PROCEDURE ManTx();
 BEGIN
  L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
  L_Staff.CheckCurrentAsMainForTax(Memo.ud_me());
  L_General.Assert(L_PRoll.IsDedD(), " ⠭  "+L_DatTim.PeriodStr(Memo.ud_mb()));

  CONFORM(Staff, Man);
  _DgDate:=L_Man.GetRealBegDate(Math.Max(Staff.BegDate, L_DatTim.YearBeg(Memo.ud_mb())));
  SETEMPTY(_DgOrder);
  IF Staff.Contract > 2(**) THEN
   HISTCONF(_DgDate, Staff, StaffLog);
   _DgOrder:=StaffLog.Order;
  END;
  HISTCONF(Memo.ud_me(), Staff, StaffLog);
  CONFORM(StaffLog, Post);
 
  Set_InvldProps();
 
  OPENREP(R, L_General.NameConnection("ManTx"), Create);
  MAKEPART(R, Top);

  IF ~!L_STx.GetManXObject(Man.Man, Staff.MyFirm) THEN
   L_STx.AccessManXObject(Staff.Man, Staff.MyFirm);
   Make();
  END;
 
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {ManTx};

END.
