(*
%Copyright   (c) Polak IT
%Author      25.02.2009 11:11:19 San
%Purpose      ⮢: ࢨ ⨫
%Type        tool
%Specific    SYS
%Modified    31.05.2012 20:06:35 POLAK\Bor
%Environment
*)

 IMPORT Memo, L_General, L_DatTim, L_AcCut, L_XObj, L_StdFrm, L_Pmnt, L_XDoc, L_AFM;

 PUBLIC PROCEDURE ClearCAcntGarbageHistory();
  VAR
   P: DATE;
 BEGIN
  P:=Memo.ud_mb();
  L_General.Assert(ACCESS(CAcnt), " ⠭ ⥪騩 ");
  L_StdFrm.OrdinaryCHOICE("  ࠧ१  ⮬ "+CAcnt.CAcnt+" "+CAcnt.Sign+"  㤠  " + L_DatTim.PeriodStr(P) + "!");

  SELECT(AcCut, AcCut);
  WHILE OCCURE(AcCut) DO
   PROMPT(AcCut.AcCut);
   SELECT(ACLog, AcCut, , AcCut.AcCut);
   LAST(ACLog);
   IF (ACLog.CAcnt = CAcnt.CAcnt) & (ACLog.Date < P) THEN
    ACLog.Till:=P;
    REPLACE(ACLog);
    ACLog.Date:=P;
    SETEMPTY(ACLog.Till);
    INSERT(ACLog);
 
    WHILE PREV(ACLog) DO
     ACLog.DoAcnt:=L_XObj.acda_Ignore;
     REPLACE(ACLog);
    END; (* WHILE OCCURE(ACLog) ... *)
    CALL(AcCut.AcCut_OnAfterNoninteractiveEdit());
    L_AcCut.ClearAcCutGarbageHistory(AcCut.AcCut, 1);
   END;
   NEXT(AcCut);
  END; (* WHILE OCCURE(AcCut) ... *)
 END {ClearCAcntGarbageHistory};

 PRIVATE PROCEDURE r_oldCntrBalance();
  VAR
   xAcCut     : LIKE(AcCut.AcCut);
   trgContract: LIKE(Contract.Contract);
   _XDocType: L_XDoc.tXDocType;
 BEGIN
  L_AFM.MakeIndex("_XDId", "XDocId:"+TYPENAMEOF(L_XDoc.tXDocId));

  xAcCut:=L_AcCut.erkn_Get(SYSDATE(), L_AcCut.erkn_OnlineBalance);
 
  L_General.Assert(ACCESS(Contract), " ⠭ ⥪騩 ");
  STDMSG("१   ⨢ ᠫ줮.   " + Contract.Contract, CHOICE);

  trgContract:=Contract.Contract;
  SE_INTEGRITY(1);
  IF SELECT(XCalc, XObject, Contract.XObject, xAcCut) THEN
   REMSEL(XCalc);
  END;
  SE_INTEGRITY(0);
  L_Pmnt.PrepareContractBalanceHistory(Contract.Contract, L_DatTim.MINDATE(), SYSDATE()+365);
  SELECT(CnBHs, CnBHs, , Contract.XObject);
  WHILE OCCURE(CnBHs) DO
   PROMPT(Contract.Contract + ": " + L_XDoc.XDocStr(CnBHs.XDocId));
   L_General.Assert(L_XDoc.StandOnXDoc(CnBHs.XDocId),
                    "  㬥 ???");
   IF ~SEARCH(_XDId, _XDId, CnBHs.XDocId) THEN
    _XDId.XDocId:=CnBHs.XDocId;
    INSERT(_XDId);
    _XDocType:=L_XDoc.ExtractXDocType(CnBHs.XDocId);
    IF _XDocType = L_XDoc.xdt_PDoc THEN
     CONFORM(PDoc, PDocMDoc);
     WHILE OCCURE(PDocMDoc) DO
      IF PDocMDoc.Contract = Contract.Contract THEN
       L_Pmnt.sc_SupportOnlineBalance(L_XDoc.xdt_PDoc, +1, trgContract);
      END;
      NEXT(PDocMDoc);
     END; (* WHILE OCCURE(PDocMDoc) ... *)
    ELSE
     L_Pmnt.sc_SupportOnlineBalance(_XDocType, +1, trgContract);
    END;
   END;
   NEXT(CnBHs);
  END; (* WHILE OCCURE(CnBHs) ... *)
  L_AFM.AF_PurgeTemp("_XDId");
  L_AFM.AF_PurgeTemp("CnBHs");
 END {r_oldCntrBalance};

BEGIN
 L_General.SilentPrgsOnly();
 IF    MODE = 100 THEN
  L_General.Assert(ACCESS(AcCut), " ⠭ ⥪騩 ࠧ१");
  L_AcCut.ClearAcCutGarbageHistory(AcCut.AcCut, 0);
 ELSIF MODE = 101 THEN
  ClearCAcntGarbageHistory();
 ELSIF MODE = 102 THEN
  r_oldCntrBalance();
 ELSE
  L_General.BadMode(MODE);
 END;
END.