(*
%Copyright   (c) Polak Computer System
%Author      30.12.1994 13:34:32 GINA
%Purpose     ஫ 筮   MApport
%Type        control
%Specific    SYS
%Modified    10.04.2012 12:31:10 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_Events, L_XObj, L_APtm, Memo;

 PRIVATE PROCEDURE CheckWFDate();
  VAR
   _System: L_APtm.tSystems;
 BEGIN
  IF XApport.WFDate < XApport.XDat THEN
   Memo.gl_SetCurDate(XApport.WFDate);
   _System:=L_XObj.SystemOfSection(L_XObj.SectionOfXObjectAcCut(XCalc.AcCut));
   L_General.Assert(~L_APtm.ANYSystem_Clc_CntIsEqual(_System), "   ஢  ᫮  ⮣ ");
  END;
 END {CheckWFDate};

 PRIVATE PROCEDURE Check();
 BEGIN
  IF XApport.Source # L_XObj.src_Operator THEN
   L_General.PrgsOnly_wMes("⨬  ⮬᪨ ᫥ 㬬");
  END;
 END {Check};

 PRIVATE PROCEDURE Proceed(_Sign: NUMERIC[0]);
  VAR
  _AcCut  : LIKE(XApport.AcCut);
   _WFDate: LIKE(XApport.WFDate);
 BEGIN
  Memo.gl_SetCurDate(XApport.WFDate);
  CONFORM(XApport, XObject);
  L_XObj.CheckClcPer(L_XObj.SectionOfXObjectAcCut(XCalc.AcCut));
  CheckWFDate();

  L_XObj.AddXA2XC(_Sign);
  REPLACE(XCalc);
  _AcCut :=XApport.AcCut;
  _WFDate:=XApport.WFDate;

  IF _WFDate < XCalc.XDat THEN
   L_XObj.FixXCalc(_AcCut, _WFDate);
  END;
  L_XObj.ResetXObjectDone(_WFDate, L_XObj.SectionOfXObjectAcCut(_AcCut), 1);
 END {Proceed};

 PRIVATE PROCEDURE XApport_OnBeforeEdit();
 BEGIN
  Check();
  Proceed(-1);
 END {XApport_OnBeforeEdit};

 PRIVATE PROCEDURE XApport_OnBeforeInsert();
 BEGIN
 END {XApport_OnBeforeInsert};

 PRIVATE PROCEDURE XApport_OnBeforeDelete();
 BEGIN
  Check();
  Proceed(-1);
 END {XApport_OnBeforeDelete};

 PRIVATE PROCEDURE XApport_OnAfterEdit();
 BEGIN
  Proceed(+1);
 END {XApport_OnAfterEdit};

 PRIVATE PROCEDURE XApport_OnAfterInsert();
 BEGIN
  Proceed(+1);
 END {XApport_OnAfterInsert};

 PRIVATE PROCEDURE XApport_OnAfterDelete();
 BEGIN
 END {XApport_OnAfterDelete};

BEGIN
 IF L_Events.IsInternalEvents(MODE) THEN
  ^(L_Events.GetInternalEventHandlerName(MODE))();
 ELSE
  L_General.BadMode(MODE);
 END;
END.
