(*
%Copyright   (c) Polak IT
%Author      25.03.2003 17:29:12 POLAK\GINA
%Purpose     㬥  ਮ
%Type        report
%Specific    SYS
%Modified    01.03.2012 12:13:20 POLAK\GAV
%Environment
*)

 MODULE C_AveTyp [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_AFM, L_Staff, L_General, L_DatTim, L_OwnData, L_AvePay, L_Str;

 CONST
  isc_All = 0;

 VAR
  RepName: STRING[];
  IntvlB,
  IntvlE : DATE;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
IntvlB, L, "D.N.y"
IntvlE, L, "D.N.y"
?, C, ""
?, C, ""
@
####################################################################################    ########## #####
=#####==================================================================================================
|                            㬥  ਮ  ##########  ##########                            |
|######################################################################################################|
|######################################################################################################|
}
*)

(*
$P{ TopSort:
Sort.Sort, L, ""
Sort.Name, L, ""
@
|======================================================================================================|
| ### ###########################################################################################|
|------------------------------------------------------------------------------------------------------|
|                                          |        ਮ       |   |          |       㬥       |
|⭨                                  |---------------------||    |----------------------|
|                                          |         |        |   |          |      |      |
}
*)

(*
$P{ Dln:
@
|------------------------------------------|----------|----------|---|----------|----------|-----------|
}
*)
(*
$P{ Line:
?, L, ""
?, L, ""
?, L, ""
AvePay.StartD, L, "D.N.y"
AvePay.StopD, L, "D.N.y"
AvePay.Amount, R, "0"
Staff.EndDate, L, "D.N.y"
AvePay.DocDate, L, "D.N.y"
AvePay.DocNum, L, ""
@
|##### ################## #################|##########|##########|###|##########|##########|###########|
}
*)

(*
$P{ Bot:
@
=(c) Polak==============================================================================================
}
*)

 PRIVATE PROCEDURE CondStr(): STRING[];
 BEGIN
  RETURN " ࠡ⭨| ࠡ騬  " + L_DatTim.DateStr(Memo.ud_cd());
 END {CondStr};

 PRIVATE PROCEDURE Make_Tmp01(InStateCond: SCAL[2]);
 BEGIN
  L_AFM.MakeIndex("Tmp01", "_Sort: LIKE(Sort.Sort);"+
                           "_TSN : LIKE(Staff.TSN);"+
                           "_StartD: LIKE(AvePay.StartD);"+
                           "_AvePay: LIKE(AvePay.AvePay);"+
                           "_Post: LIKE(Post.Post)");
 
  SELECT(AvePay, AveType, , AveType.AveType);
  WHILE OCCURE(AvePay) DO
   PROMPT(" : " + AvePay.TSN);
   IF L_AvePay.IsRealAvePay() & L_DatTim.IsActiveInIntvl_Inc(AvePay.StartD, AvePay.StopD, IntvlB, IntvlE) THEN
    CONFORM(AvePay, Staff);
    IF (InStateCond=isc_All) | L_Staff.rInState(Memo.ud_cd()) THEN
     HISTCONF(AvePay.StartD, Staff, StaffLog);
     CONFORM(StaffLog, Officer);
     Tmp01._Sort  :=StaffLog.Sort;
     Tmp01._TSN   :=Staff.TSN;
     Tmp01._StartD:=AvePay.StartD;
     Tmp01._AvePay:=AvePay.AvePay;
     Tmp01._Post  :=Officer.Post;
     INSERT(Tmp01);
    END;
   END;
   NEXT(AvePay);
  END; (* WHILE OCCURE(AvePay) ... *)
 END {Make_Tmp01};

 PRIVATE PROCEDURE Print_Tmp01(InStateCond: SCAL[2]);
  VAR
   _Tsn  : LIKE(Staff.TSN);
   _Title: STRING[];
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName + "_" + AveType.AveType), Create);
  _Title:=": " + AveType.AveType + " " + AveType.Name;
  MAKEPART(R, Top, _Title, L_Str.PoolItem(CondStr(), InStateCond));
  SELECT(Tmp01, Tmp01);
  WHILE OCCURE(Tmp01) DO
   CHANGESEL(Tmp01, Tmp01, , Tmp01._Sort);
   L_General.Assert(SEARCH(Sort, Sort, Tmp01._Sort), "  ᥪ " + Tmp01._Sort);
   MAKEPART(R, TopSort);
   SETEMPTY(_Tsn);
   WHILE OCCURE(Tmp01) DO
    PROMPT(" : ᥪ " + Tmp01._Sort + " . " + Tmp01._TSN);
    L_General.Assert(SEARCH(AvePay, AvePay, Tmp01._AvePay), "  㬥 " + Tmp01._AvePay);
    IF Tmp01._TSN # _Tsn THEN
     L_General.Assert(SEARCH(Post, Post, Tmp01._Post), "   " + Tmp01._Post);
     L_General.Assert(SEARCH(Staff, TSN, Tmp01._TSN), "  ⠡ " + Tmp01._TSN);
     CONFORM(Staff, Man);
     MAKEPART(R, Dln);
     MAKEPART(R, Line, Staff.TSN, L_Str.ShortName(Man.Name), Post.Name);
     _Tsn:=Tmp01._TSN;
    ELSE
     MAKEPART(R, Line);
    END;
    NEXT(Tmp01);
   END; (* WHILE OCCURE(Tmp01) ... *)
   LAST(Tmp01);
   CHANGESEL(Tmp01, Tmp01);
   NEXT(Tmp01);
  END; (* WHILE OCCURE(Tmp01) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
 END {Print_Tmp01};

 PUBLIC PROCEDURE C_AveTyp(InStateCond: SCAL[2]);
 BEGIN
  L_General.Assert(ACCESS(AveType), " ⠭  㬥");
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  IF    InStateCond = isc_All THEN
   RepName:="RAVTA";
  ELSE
   RepName:="RAVTW";
  END;
 
  IntvlB:=Memo.ud_fr();
  IntvlE:=Memo.ud_ut();
 
  Make_Tmp01(InStateCond);
  Print_Tmp01(InStateCond);
  L_AFM.AF_PurgeTemp("Tmp01");
 END {C_AveTyp};

END.
