(*
%Copyright   (c) Polak Computer System
%Author      12.11.1998 13:47:48 BOR
%Specific    SYS
%Modified    10.04.2012 12:17:05 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT Memo, L_General, L_OwnData, L_Staff, L_AFM, P_MyFirm, P_Firm, Str;

 CONST
  RepName="cPnsA";

(*
$P{ Top:
P_Firm.FP_FirmName(P_Firm.fomf(_PnA2.MyFirm), Memo.ud_cd()), L, ""
P_MyFirm.NumInPFR(_PnA2.MyFirm, Memo.ud_cd()), L, ""
?, L, ""
Memo.ud_cd(), L, "D.N.y"
@
 ࠡ ,  ᨩ  ⥩, ࠡ⭨                                               
 ⠭   裡  ᮡ묨 ᫮ﬨ 㤠  ᮮ⢥⢨                                 ________________________
쥩 12   " 㤠⢥   ᨩ᪮ 樨"                                       㪮⥫ ࣠樨
( ᪠ N1  2  "" ᪠)

 ।, ࣠樨        ########################################################################################
樮                     ######################################
 ᫥ ࠡ⭨ (䠪᪠)   ####  ##########

=======================================================================================================================================
| N | ,        | ᨩ   |⪮ ᠭ| -   |  |      |- |
|/|⪠  㣮       | ⥩  㤮 |ࠪ 믮-|⥫ 㬥⮢, |ࠧ, - |(ﭭ    |- |
|   |୮ ࠧ|                  |塞 ࠡ.  |⢥ত ࠢ  |ࠧ ᪠|  䠪-  ||
|   |                          |                         | ⥫| 죮⭮ ᨮ-  | 樨   |᪨ ࠡ-  |     |
|   |                          |                         |(䠪஢)      | ᯥ祭       |ᯨ᪠        |⠭ ६|     |
|---|--------------------------|-------------------------|----------------|----------------------|--------------|---------------|-----|
}
*)

(*
$P{ Line:
?, R, ""
?, L, ""
?, L, ""
PnsAttr.Name, L, ""
?, L, ""
?, R, ""
@
|###|### ######################|#########################|                |                      |##############|               |#####|
|   |                          |                         |                |                      |              |               |     |
|   |                          |                         |                |                      |              |               |     |
}
*)

(*
$P{ Bot:
@
=(c) Polak=============================================================================================================================
}
*)

 PRIVATE PROCEDURE Create__PnA2();
 BEGIN
  CreateFILE(_PnA2, "", "", "");

  CreateFIELD(_PnA2, MyFirm, LIKE(MyFirm.MyFirm), "", "", "", "", "");
  CreateFIELD(_PnA2, Sort, LIKE(Sort.Sort), "", "", "", "", "");
  CreateFIELD(_PnA2, Officer, LIKE(Officer.Officer), "", "", "", "", "");
  CreateFIELD(_PnA2, Count, NUMERIC[0], "", "", "", "", "");

  CreateINDEXandLINK(_PnA2, Officer, UNIQUE, Officer, Officer, USER, "", "", Sort, Officer);
  CreateINDEXandLINK(_PnA2, Sort, UNIQUE, Sort, Sort, USER, "", "", Sort, Officer);
  CreateINDEXandLINK(_PnA2, MyFirm, UNIQUE, MyFirm, MyFirm, USER, "", "", MyFirm, Sort, Officer);

  SetVersionOfFILE(_PnA2, 0);
 END {Create__PnA2};

 VAR
  i,
  Count: NUMERIC[0];
  _Sort: LIKE(Sort.Sort);
  _Str : LIKE(PnsAttr.Str);
BEGIN
 SE_ACCESSDATAMODE(AccessDataMode_SOFT);

 OPENREP(R, L_General.NameConnection(RepName), Create);

 Create__PnA2(); L_AFM.AF_CreateTemp("_PnA2", "_PnA2");

 Count:=0;
 SELECT(Staff, TSN);
 WHILE OCCURE(Staff) DO
  PROMPT(Staff.TSN);
  IF Staff.BegDate<=Memo.ud_cd() THEN
   HISTCONF(Memo.ud_cd(), Staff, StaffLog);
   IF ~L_Staff.IsDischargeStaffLog() THEN
    INC(Count);
    CONFORM(StaffLog, Officer);
    CONFORM(Officer, PnsAttr);
    CONFORM(Officer, Sort);
    IF PnsAttr.PnsAttr # 00 THEN
     ADD(_PnA2, MyFirm, , Sort.MyFirm, StaffLog.Sort, StaffLog.Officer, _PnA2.Count, 1);
    END;
   END;
  END;
  NEXT(Staff);
 END; (* WHILE OCCURE(Staff) ... *)


 SELECT(_PnA2, MyFirm);
 WHILE OCCURE(_PnA2) DO
  MAKEPART(R, Top, Count);
  i:=0;
  SETEMPTY(_Sort);
  NARROWSEL(_PnA2, MyFirm);
  WHILE OCCURE(_PnA2) DO
   PROMPT(": "+_PnA2.Sort+" "+_PnA2.Officer);
   INC(i);
   CONFORM(_PnA2, Officer);
   CONFORM(Officer, PnsAttr);
   IF Memo.ud_cd() >= 01\01\2002 THEN
    _Str:=Str.Item(PnsAttr.Str2002, ";", 1);
   ELSE
    _Str:=Str.Item(PnsAttr.Str,     ";", 1);
   END;
   IF _Sort # _PnA2.Sort THEN
    _Sort:=_PnA2.Sort;
    CONFORM(_PnA2, Sort);
    MAKEPART(R, Line, i, _PnA2.Sort, Sort.Name, _Str, _PnA2.Count);
   ELSE
    MAKEPART(R, Line, i, , , _Str, _PnA2.Count);
   END;
   NEXT(_PnA2);
  END; (* WHILE OCCURE(_PnA2) ... *)
  MAKEPART(R, Bot);
  IF NEXTINEXTENDEDSEL(_PnA2, MyFirm) THEN
   FORMFEED(R);
  END;
 END; (* WHILE OCCURE(_PnA2) ... *)

 CLOSEREP(R);
 L_AFM.AF_PurgeTemp("_PnA2");
END.