(*
%Copyright   (c) Polak Computer System
%Author      11.11.2002 10:25:46 POLAK\GAV
%Purpose        ᮭ.
%Type        report
%Specific    SYS
%Modified    11.08.2014 14:36:37 POLAK\San
%Environment
*)

 MODULE Stf01 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT D_Staff, L_Basis, L_DatTim, L_General, L_Man, L_Staff,
        L_Str, Math, L_AFM, FIO, Memo, P_Firm, L_Russia, L_OwnData, L_bp, L_Env, L_StdFrm;

 VAR
  wMF: SCAL[2];

 PRIVATE PROCEDURE STF01_MakeTop(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrStr(F, "⥣");
  L_Basis.wb_WrStr(F, "⥣");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, " 砭 筮 ");
  L_Basis.wb_WrStr(F, " ਥ");
  L_Basis.wb_WrStr(F, " 㢮쭥");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, " ⥫⢠");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, " 砫");
  L_Basis.wb_WrStr(F, "ਥ");
  L_Basis.wb_WrStr(F, "쭥");
  L_Basis.wb_WrStr(F, " ");
  L_Basis.wb_WrStr(F, "室");
  L_Basis.wb_WrStr(F, "室");
  L_Basis.wb_WrStr(F, "室");
  L_Basis.wb_WrStr(F, "室");
  L_Basis.wb_WrStr(F, "⠦");
  L_Basis.wb_WrStr(F, "⠦  ");
  L_Basis.wb_WrStr(F, "࠭");
  L_Basis.wb_WrStr(F, "࠭");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, " த");
  L_Basis.wb_WrStr(F, "த");
  L_Basis.wb_WrStr(F, " ᥫ 㭪");
  L_Basis.wb_WrStr(F, "ᥫ 㭪");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "  ");
  L_Basis.wb_WrStr(F, " ६饭");
  L_Basis.wb_WrStr(F, " ६饭");
  L_Basis.wb_WrStr(F, " ६饭");
  L_Basis.wb_WrStr(F, "⠦");
  L_Basis.wb_WrStr(F, " ");
  L_Basis.wb_WrStr(F, "⠦");
  L_Basis.wb_WrStr(F, "६ ६饭");
  L_Basis.wb_WrStr(F, " 砭 ६ ६饭");
  L_Basis.wb_WrStr(F, "ਮ ਥ/㢮쭥");
  L_Basis.wb_TermLine(F);
 END {STF01_MakeTop};

 PRIVATE PROCEDURE STF01_MakeLine(F           : STRING[];
                                  BegDate,
                                  EndDate     : DATE;
                                  StageInFirm,
                                  FullStage   : NUMERIC[0]);
  VAR
   IsTmpMove: SCAL[2];
 BEGIN
  IF wMF THEN
   CONFORM(Staff, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(F, Union.Union);
  L_Basis.wb_WrStr(F, Union.Name);
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrScl(F, Post.Post);
  L_Basis.wb_WrStr(F, Post.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Staff.cnt_Pool, Staff.Contract));
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", StaffLog.ContDTyp));
  L_Basis.wb_WrDat(F, L_Man.GetTimedContractEndDate(EndDate));
  L_Basis.wb_WrDat(F, L_Man.GetTakeOnDate(Memo.ud_ut()));
  L_Basis.wb_WrDat(F, Staff.EndDate);
  L_Basis.wb_WrStr(F, L_Man.GetManSex_asStr());
  L_Basis.wb_WrStr(F, L_Man.CitizenAsStr(Man.Man, Memo.ud_ut()));
  L_Basis.wb_WrNum(F, L_DatTim.CompleteYearsInIntvl(Man.Birth, EndDate), 0);
  L_Basis.wb_WrNum(F, StMov.WasAtBeg, 0);
  L_Basis.wb_WrNum(F, StMov.WasBegan, 0);
  L_Basis.wb_WrNum(F, StMov.WasLeaved, 0);
  L_Basis.wb_WrNum(F, StMov.WasAtEnd, 0);
  L_Basis.wb_WrNum(F, StMov.WasIn [D_Staff.smt_Union], 0);
  L_Basis.wb_WrNum(F, StMov.WasOut[D_Staff.smt_Union], 0);
  L_Basis.wb_WrNum(F, StMov.WasIn [D_Staff.smt_Sort], 0);
  L_Basis.wb_WrNum(F, StMov.WasOut[D_Staff.smt_Sort], 0);
  L_Basis.wb_WrNum(F, L_DatTim.CompleteYearsInIntvl(BegDate, EndDate), 0);
  L_Basis.wb_WrNum(F, StageInFirm, 0);
  L_Basis.wb_WrScl(F, ManAdr.Country);
  L_Basis.wb_WrStr(F, Country.Name);
  L_Basis.wb_WrScl(F, ManAdr.Region);
  L_Basis.wb_WrStr(F, ManAdr.RegionN);
  L_Basis.wb_WrStr(F, ManAdr.Distr);
  L_Basis.wb_WrStr(F, L_Russia.TownT_asStr(ManAdr.TownT));
  L_Basis.wb_WrStr(F, ManAdr.Town);
  L_Basis.wb_WrStr(F, L_Russia.VillageT_asStr(ManAdr.VillageT));
  L_Basis.wb_WrStr(F, ManAdr.Village);
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrScl(F, SLKind.SLKind);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Staff.slkt_Pool, SLKind.Type));
  L_Basis.wb_WrStr(F, SLKind.Name);
  L_Basis.wb_WrNum(F, L_DatTim.CompleteMonthsInIntvl(BegDate, EndDate), 0);
  L_Basis.wb_WrStr(F, L_Staff.GetSLKindReason());
  L_Basis.wb_WrNum(F, FullStage, 0);
  IsTmpMove:=SLKind.IsTemp & (SLKind.Type = L_Staff.slkt_Move);
  L_Basis.wb_WrNum(F, IsTmpMove, 0);
  IF IsTmpMove THEN
   L_Basis.wb_WrDat(F, StaffLog.CntrEnd);
  ELSE
   L_Basis.wb_WrStr(F, "");
  END;
  IF StMov.WasBegan | StMov.WasLeaved THEN
   L_Basis.wb_WrDat(F, L_DatTim.Per(StMov.Date));
  ELSE
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_TermLine(F);
 END {STF01_MakeLine};

 PUBLIC PROCEDURE MakeSTF01();
  VAR
   BegDate,
   EndDate    : DATE;
   FullStage,
   StageInFirm: NUMERIC[0];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin("Stf01"," ᮭ", L_bp.t_Basis, L_General.tc_inIntvl);
  D_Staff.BuildStaffMove(Memo.ud_fr(), Memo.ud_ut());
  FIO.Open(F, L_General.NameConnection("STF01"), "REP", Create);
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  STF01_MakeTop("F");
  SELECT(StMov, TSN);
  WHILE OCCURE(StMov) DO
   PROMPT(StMov.TSN);
   CONFORM(StMov,   Staff);
   CONFORM(Staff,   Man);
   L_Man.AccessRgManAdr(Man.Man, Memo.ud_ut());
   CONFORM(ManAdr,  Country);
   EndDate:=Math.Min(Staff.EndDate, Memo.ud_ut());
   BegDate:=Math.Min(L_Man.GetTakeOnDate(Memo.ud_ut()), Memo.ud_ut());
   StageInFirm:=L_DatTim.CompleteYearsInIntvl(L_Staff.E_GetBegInFirm(EndDate), EndDate);
   FullStage:=0;
   SELECT(Staff, Man, , Man.Man);
   WHILE OCCURE(Staff) DO
    IF Staff.Contract = L_Staff.cnt_Basic THEN
     SELECT(StaffLog, TSN, , Staff.TSN);
     WHILE OCCURE(StaffLog) DO
      IF ~L_Staff.IsDischargeStaffLog() THEN
       INC(FullStage,
           Math.Min(StaffLog.DateE, Memo.ud_ut()) -
           Math.Min(StaffLog.Date,  Memo.ud_ut()) + 1);
      END;
      NEXT(StaffLog);
     END; (* WHILE OCCURE(StaffLog) ... *)
    END;
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
   CONFORM(StMov,   Staff);
   HISTCONF(StMov.Date, Staff, StaffLog);
   CONFORM(StMov,   SLKind);
   CONFORM(StMov,   Officer);
   CONFORM(StMov,   Sort);
   CONFORM(Officer, Post);
   CONFORM(Officer, Union);
   STF01_MakeLine("F", BegDate, EndDate, StageInFirm, FullStage DIV 365);
   NEXT(StMov);
  END; (* WHILE OCCURE(StMov) ... *)
  FIO.Close(F);
  D_Staff.PurgeStaffMove();
  L_bp.End();
 END {MakeSTF01};

 TYPE
  tRN = SCAL[7];

 CONST
  RepName_Pool="StU07|StM07|StS07|Began|Leavd|BegLv|TCntE|EndSL";

  rn_StU07 = 0;
  rn_StM07 = 1;
  rn_StS07 = 2;
  rn_Began = 3;
  rn_Leavd = 4;
  rn_BegLv = 5;
  rn_TCntE = 6;
  rn_EndSL = 7;

(*
$P{ Top:
P_Firm.FP_FirmName(P_Firm.fomf(Tmp.MyFirm), SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
?, C, ""
?, L, ""
Memo.ud_fr(), L, "D.N"
Memo.ud_ut() + 1, L, "D.N"
@
############################################################# ########## #####
=#####========================================================================
|           ᮭ  ਮ  ##########  ##########           |
|############################################################################|
|----------------------------------------------------------------------------|
|                          |        |     室    |     室    |        |
|##########################| #####|---------------|---------------| #####|
|                          |        |ਭ|ॢ||ॢ|        |
|--------------------------|--------|-------|-------|-------|-------|--------|
}

$P{ Line:
?, L, ""
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
@
|##########################|########|#######|#######|#######|#######|########|
}

$P{ Bot:
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
@
|--------------------------|--------|-------|-------|-------|-------|--------|
|⮣                     |########|#######|#######|#######|#######|########|
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE ReOrderBy(Rep_SMT: SCAL[2]);
 BEGIN
  CreateFILE(Tmp, "", "஢", "");
  CreateFIELD(Tmp, MyFirm,  P_Firm.tMyFirm,  "", "", "", " ࣠", "");
  CreateFIELD(Tmp, Order,   SCAL[1E3],       "", "", "", "", "");
  CreateFIELD(Tmp, TSN,     LIKE(Staff.TSN), "", "", "", "", "");
  CreateFIELD(Tmp, BegDate, DATE,            "", "", "", "", "");
  CreateFIELD(Tmp, Date,    DATE,            "", "", "", "", "");
  CreateFIELD(Tmp, RealDE,  DATE,            "", "", "", "", "");
  CreateINDEX(Tmp, Order,   UNIQUE,          "", "", MyFirm, Order, TSN,  BegDate, Date);
  CreateINDEXandLINK(Tmp, TSN, PLURAL, StMov, TSN, USER, "", "", TSN, Date, RealDE);
  SetVersionOfFILE(Tmp, 0000);
  L_AFM.CreateTemp("Tmp");

  SELECT(StMov, TSN);
  WHILE OCCURE(StMov) DO
   PROMPT("஢: " + StMov.TSN);
   IF    Rep_SMT = D_Staff.smt_Union THEN
    CONFORM(StMov, Officer);
    Tmp.Order:=Officer.Union;
   ELSIF Rep_SMT = D_Staff.smt_Sort  THEN
    Tmp.Order:=StMov.Sort;
   END;
   CONFORM(StMov, Staff);
   Tmp.MyFirm :=Staff.MyFirm;
   Tmp.TSN    :=StMov.TSN;
   Tmp.BegDate:=L_Man.GetTakeOnDate(StMov.RealDE);
   Tmp.Date   :=StMov.Date;
   Tmp.RealDE :=StMov.RealDE;
   INSERT(Tmp);
   NEXT(StMov);
  END; (* WHILE OCCURE(StMov) ... *)
 END {ReOrderBy};

 PRIVATE PROCEDURE OrderName(Rep_SMT: SCAL[2]): STRING[];
 BEGIN
  IF    Rep_SMT = D_Staff.smt_Union THEN
   SEARCH(Union, Union, , Tmp.Order);
   RETURN Union.Union + " " + Union.Name;
  ELSIF Rep_SMT = D_Staff.smt_Sort  THEN
   SEARCH(Sort, Sort, , Tmp.Order);
   RETURN Sort.Sort + " " + Sort.Name;
  END;
 END {OrderName};

 PRIVATE PROCEDURE MakeSvod(RepType: tRN; Rep_SMT: SCAL[2]; CondStr: STRING[]);
  VAR
   WasAtBeg,
   WasBegan,
   WasIn,
   WasLeaved,
   WasOut,
   WasAtEnd,
   sWasAtBeg,
   sWasBegan,
   sWasIn,
   sWasLeaved,
   sWasOut,
   sWasAtEnd  : NUMERIC[0];
   RepSubj,
   RepName    : STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  D_Staff.BuildStaffMove(Memo.ud_fr(), Memo.ud_ut());
  IF    Rep_SMT = D_Staff.smt_Union THEN
   RepSubj:="⥣";
  ELSIF Rep_SMT = D_Staff.smt_Sort  THEN
   RepSubj:="";
  END;
  ReOrderBy(Rep_SMT);
  RepName:=L_Str.PoolItem(RepName_Pool, RepType);
  OPENREP(R, L_General.NameConnection(RepName), Create);

  SELECT(Tmp, Order);
  WHILE OCCURE(Tmp) DO
   MAKEPART(R, Top, RepName, CondStr, RepSubj);
   NARROWSEL(Tmp, MyFirm);
   SETZERO(sWasAtBeg, sWasBegan, sWasIn, sWasLeaved, sWasOut, sWasAtEnd);
   WHILE OCCURE(Tmp) DO
    NARROWSEL(Tmp, Order);
    SETZERO(WasAtBeg, WasBegan, WasIn, WasLeaved, WasOut, WasAtEnd);
    WHILE OCCURE(Tmp) DO
     PROMPT("⮢ : " + RepSubj + " " + Tmp.Order + " ⠡ " + Tmp.TSN);
     CONFORM(Tmp, StMov);
     CONFORM(StMov, Staff);
     IF MustBeInRep(RepType) THEN
      INC(WasAtBeg,  StMov.WasAtBeg);
      INC(WasBegan,  StMov.WasBegan);
      INC(WasIn,     StMov.WasIn[Rep_SMT]);
      INC(WasLeaved, StMov.WasLeaved);
      INC(WasOut,    StMov.WasOut[Rep_SMT]);
      INC(WasAtEnd,  StMov.WasAtEnd);
     END;
     NEXT(Tmp);
    END; (* WHILE OCCURE(Tmp) ... *)
    IF (WasAtBeg > 0)  | (WasBegan > 0) | (WasIn > 0) |
       (WasLeaved > 0) | (WasOut > 0)   | (WasAtEnd > 0) THEN
     LAST(Tmp);
     MAKEPART(R, Line, OrderName(Rep_SMT), WasAtBeg, WasBegan, WasIn, WasLeaved, WasOut, WasAtEnd);
     INC(sWasAtBeg,  WasAtBeg);
     INC(sWasBegan,  WasBegan);
     INC(sWasIn,     WasIn);
     INC(sWasLeaved, WasLeaved);
     INC(sWasOut,    WasOut);
     INC(sWasAtEnd,  WasAtEnd);
    END;
    NEXTINEXTENDEDSEL(Tmp, Order);
   END; (* WHILE OCCURE(Tmp) ... *)
   MAKEPART(R, Bot, sWasAtBeg, sWasBegan, sWasIn, sWasLeaved, sWasOut, sWasAtEnd);
   NEXTINEXTENDEDSEL(Tmp, MyFirm);
  END; (* WHILE OCCURE(Tmp) ... *)

  CLOSEREP(R);
  D_Staff.PurgeStaffMove();
  L_AFM.AF_PurgeTemp("Tmp");
  L_General.SurveyLastReport();
 END {MakeSvod};

(*
$P{ Contr_Top:
P_Firm.FP_FirmName(P_Firm.fomf(Tmp.MyFirm), SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
############################################################# ########## #####
=#####========================================================================
|᮪ ############# 㤮 ஢  ਮ  ##########  ##########|
}

$P{ Contr_SubTop:
Union.Union, L, ""
Union.Name, L, ""
?, L, ""
@
|----------------------------------------------------------------------------|
|⥣ ## ################################                               |
|----------------------------------------------------------------------------|
|                   |᫥   |ਭ    |########  | ||
|-------------------------|---------------------|----------|----------|---|--|
}

$P{ Contr_Line:
Staff.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
Post.Name, L, ""
Tmp.BegDate, L, "D.N.y"
StMov.RealDE, L, "D.N.y"
L_Man.CitizenAsStr(Man.Man, Memo.ud_ut()), L, ""
Staff.Contract, L, L_Staff.cnt_Pool
@
|##### ###################|#####################|##########|##########|###|##|
}

$P{ Contr_SubBot:
?, R, "0"
?, L, ""
@
|----------------------------------------------------------------------------|
|⮣  ⥣ਨ #### ############# ஢                             |
}

$P{ Contr_Bot:
?, R, "0"
?, L, ""
@
|============================================================================|
|⮣  । #### ############# ஢                           |
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE MakeRepByContract(RepType: tRN; FourthColumnName, SubTitle: STRING[]);
  VAR
   First     : SCAL[2];
   Count,
   TotalCount: NUMERIC[0];
   RepName   : STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.SetCacheables(["Man", "Officer", "SLKind", "Staff", "StaffLog"]);
  D_Staff.BuildStaffMove(Memo.ud_fr(), Memo.ud_ut());
  ReOrderBy(D_Staff.smt_Union);
  RepName:=L_Str.PoolItem(RepName_Pool, RepType);
  OPENREP(R, L_General.NameConnection(RepName), Create);

  SELECT(Tmp, Order);
  WHILE OCCURE(Tmp) DO
   MAKEPART(R, Contr_Top, RepName, SubTitle);
   TotalCount:=0;
   NARROWSEL(Tmp, MyFirm);
   WHILE OCCURE(Tmp) DO
    Count:=0;
    NARROWSEL(Tmp, Order);
    WHILE OCCURE(Tmp) DO
     PROMPT("⮢ : ⥣ " + Tmp.Order + " ⠡ " + Tmp.TSN);
     NARROWSEL(Tmp, TSN, BegDate);
     First:=1;
     WHILE OCCURE(Tmp) DO
      CONFORM(Tmp, StMov);
      IF MustBeInRep(RepType) THEN
       IF Count = 0 THEN
        CONFORM(StMov, Union);
        MAKEPART(R, Contr_SubTop, FourthColumnName);
       END;
       IF First THEN
        INC(Count);
        CONFORM(StMov, Staff);
        CONFORM(Staff, Man);
        CONFORM(StMov, Post);
        MAKEPART(R, Contr_Line);
        First:=0;
       END;
      END;
      NEXT(Tmp);
     END; (* WHILE OCCURE(Tmp) ... *)
     NEXTINEXTENDEDSEL(Tmp, TSN, BegDate);
    END; (* WHILE OCCURE(Tmp) ... *)
    IF Count > 0 THEN
     INC(TotalCount, Count);
     MAKEPART(R, Contr_SubBot, Count, SubTitle);
    END;
    NEXTINEXTENDEDSEL(Tmp, Order);
   END; (* WHILE OCCURE(Tmp) ... *)
   MAKEPART(R, Contr_Bot, TotalCount, SubTitle);
   NEXTINEXTENDEDSEL(Tmp, MyFirm);
  END; (* WHILE OCCURE(Tmp) ... *)
  CLOSEREP(R);
  D_Staff.PurgeStaffMove();
  L_AFM.AF_PurgeTemp("Tmp");
  L_General.SurveyLastReport();
 END {MakeRepByContract};

 PRIVATE PROCEDURE MustBeInRep(RepType: tRN): SCAL[2];
 BEGIN
  IF    RepType = rn_StU07 THEN
   RETURN (Staff.Contract = L_Staff.cnt_Basic);
  ELSIF RepType = rn_StM07 THEN
   RETURN (Staff.Contract = L_Staff.cnt_Basic) &
          (L_Man.Man_Citizen(Staff.Man, Memo.ud_ut()) > L_Man.ct_Moscow);
  ELSIF RepType = rn_StS07 THEN
   RETURN (Staff.Contract = L_Staff.cnt_Basic);
  ELSIF RepType = rn_Began THEN
   RETURN StMov.WasBegan;
  ELSIF RepType = rn_Leavd THEN
   RETURN StMov.WasLeaved;
  ELSIF RepType = rn_BegLv THEN
   RETURN StMov.WasBegan | StMov.WasLeaved;
  ELSIF RepType = rn_TCntE THEN
   RETURN StMov.MustBeLeave;
  END;
  RETURN 0;
 END {MustBeInRep};

(*
$P{ TopEndSL:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
}

$P{ SubTopEndSL:
?, L, ""
SYSDATE(), L, "D.N.y"
?, L, ""
@
|                                                                                                            |
|            騥  祭 # ᫥  ########## ࠡ  #####################            |
|------------------------------------------------------------------------------------------------------------|
|⭨                  |                            |                          |砭 |
|--------------------------|----------------------------------|-----------------------------------|----------|
}

$P{ SubBotEndSL:
@
|------------------------------------------------------------------------------------------------------------|
}

$P{ LineEndSL:
_StMov.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
Sort.Sort, L, ""
Sort.Name, L, ""
Post.Post, L, ""
Post.Name, L, ""
_StMov.CntrEnd, L, "D.N.y"
@
|##### ####################|### ##############################|### ###############################|##########|
}

$P{ BotEndSL:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE ReOrderStMov(UpTo: DATE);
 BEGIN
  CreateFILE(_StMov, "", "஢", "");
  CreateFIELD(_StMov, TSN,     LIKE(Staff.TSN),   "", "", "", "", "");
  CreateFIELD(_StMov, Sort,    LIKE(Sort.Sort),   "", "", "", "", "");
  CreateFIELD(_StMov, Post,    LIKE(Post.Post),   "", "", "", "", "");
  CreateFIELD(_StMov, CntrEnd, DATE,              "", "", "", "", "");
  CreateFIELD(_StMov, MustBeLeave, SCAL[2], "", "", "", "", "");

  CreateINDEXandLINK(_StMov, TSN,  PLURAL, Staff, TSN,     USER, "", "", TSN);
  CreateINDEXandLINK(_StMov, Sort, PLURAL, Sort,  Sort,    USER, "", "", Sort);
  CreateINDEXandLINK(_StMov, Post, PLURAL, Post,  Post,    USER, "", "", Post);

  CreateINDEX(_StMov, _StMov, PLURAL, "", "", MustBeLeave, CntrEnd);

  SetVersionOfFILE(_StMov, 0000);
  L_AFM.CreateTemp("_StMov");

  SELECT(StMov, SLKind);
  WHILE OCCURE(StMov) DO
   CONFORM(StMov, SLKind);
   PROMPT("஢: " + StMov.SLKind);
   IF StMov.MustBeLeave | SLKind.IsTemp THEN
    CONFORM(StMov, Officer, Post);
    SEARCH(StaffLog, TSN, , StMov.TSN, StMov.Date);
    _StMov.TSN        :=StMov.TSN;
    _StMov.Sort       :=StMov.Sort;
    _StMov.Post       :=Post.Post;
    _StMov.MustBeLeave:=StMov.MustBeLeave;
    IF StMov.MustBeLeave THEN
     CONFORM(StaffLog, Staff);
     _StMov.CntrEnd   :=L_Man.GetTimedContractEndDate(UpTo);
    ELSE
     _StMov.CntrEnd   :=StaffLog.CntrEnd;
    END;
    INSERT(_StMov);
   END;
   NEXT(StMov);
  END; (* WHILE OCCURE(StMov) ... *)
 END {ReOrderStMov};

 PRIVATE PROCEDURE MakePartRepBySLKT(mbl: SCAL[2];CntWorkDays: SCAL[10]; Title: STRING[]);
  VAR
   D: DATE;
 BEGIN
  D:=L_DatTim.IncWorkDay(SYSDATE()-1, CntWorkDays);
  MAKEPART(R, SubTopEndSL, CntWorkDays, Title, D);
  SELECT(_StMov, _StMov, , mbl);
  SRCINSEL(_StMov, LE, , D);
  WHILE OCCURE(_StMov) DO
   IF L_DatTim.IsActive_Inc(_StMov.CntrEnd, MINOF(DATE), D) THEN
    CONFORM(_StMov, Staff, Man);
    CONFORM(_StMov, Sort);
    CONFORM(_StMov, Officer, Post);
    MAKEPART(R, LineEndSL);
   END;
   PREV(_StMov);
  END; (* WHILE OCCURE(_StMov) ... *)
 END {MakePartRepBySLKT};

 PUBLIC PROCEDURE MakeEndingCntrRep();
  VAR
   RepName: STRING[];
   UpTo   : DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  UpTo:=L_DatTim.IncWorkDay(SYSDATE()-1, 5);
  D_Staff.BuildStaffMove(SYSDATE(), UpTo);
  ReOrderStMov(UpTo);

  RepName:=L_Str.PoolItem(RepName_Pool, rn_EndSL);
  OPENREP(R, L_General.NameConnection(RepName), Create);

  MAKEPART(R, TopEndSL, RepName);
  MakePartRepBySLKT(1, 5, "㤮 ");
  MAKEPART(R, SubBotEndSL);
  MakePartRepBySLKT(0, 3, "६ ६饭");
  MAKEPART(R, BotEndSL);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {MakeEndingCntrRep};

 PUBLIC PROCEDURE MakeSvodStU07();
  VAR
   trgRepType: tRN;
 BEGIN
  trgRepType:=rn_StU07;
  IF (L_Env.Region = L_Russia.reg_50) | (L_Env.Region = L_Russia.reg_77) THEN
   STDFORM(L_StdFrm.sf_Choice("| ﭭ ஦ %##############################%|",
                              "%L< 뢠| ᪢  ᪮᪠ >I"),
           "", , , trgRepType);
  END;
  MakeSvod(trgRepType, D_Staff.smt_Union, L_Str.PoolItem("᭮ ࠡ|᭮ ࠡ -  ᪢", trgRepType));
 END {MakeSvodStU07};

 PUBLIC PROCEDURE MakeSvodStS07();
 BEGIN
  MakeSvod(rn_StS07, D_Staff.smt_Sort,  "᭮ ࠡ");
 END {MakeSvodStS07};

 PUBLIC PROCEDURE MakeRep_Began();
 BEGIN
  MakeRepByContract(rn_Began, "",   "祭");
 END {MakeRep_Began};

 PUBLIC PROCEDURE MakeRep_Leavd();
 BEGIN
  MakeRepByContract(rn_Leavd, "",   "࣭");
 END {MakeRep_Leavd};

 PUBLIC PROCEDURE MakeRep_BegLv();
 BEGIN
  MakeRepByContract(rn_BegLv, "",   "./.");
 END {MakeRep_BegLv};

 PUBLIC PROCEDURE MakeRep_TCntE();
 BEGIN
  MakeRepByContract(rn_TCntE, "..", "");
 END {MakeRep_TCntE};

END.

