(*
%Copyright   (c) Polak IT
%Author      03.06.2003 10:57:35 POLAK\LDA
%Purpose       ࠡ⪥  ਮ
%Type        report
%Specific    SYS
%Modified    17.02.2014 11:51:22 POLAK\LDA
%Environment
*)

 MODULE Uk_Sheet [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_DatTim, L_General, L_OwnData, L_Staff, E_Utils, L_AFM, Math, L_Str, P_Firm, P_Sort,
        L_Env, Str, E_Staff, L_Sheet, Memo, FIO, L_Basis, L_Man, L_bp, L_Way, L_Excel, L_APtm;

 PRIVATE TYPE
  tRepType = SCAL[4];

 PRIVATE CONST
  rt_LabourRent    = 0;
  rt_Arr_Ovr       = 1;
  rt_ArrReason     = 2;
  rt_Unove         = 3;

  rt_Pool          = "ࠡ⪠/  ࠡ|ࠡ⪠/ࠡ⪠";

  rm_Pool = " ࠡ⭨|᭮ ࠡ";

 PRIVATE VAR
  tPurArr, pPurArr : NUMERIC[3];
  tBad,    pBad    : NUMERIC[3][4];

 PRIVATE PROCEDURE MakeSheet(RepType: tRepType): SCAL[2];
 BEGIN
  RETURN RepType = rt_Arr_Ovr;
 END {MakeSheet};

 PRIVATE PROCEDURE Isrt_Unove(RepType: tRepType): SCAL[2];
 BEGIN
  RETURN RepType = rt_Unove;
 END {Isrt_Unove};

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
?, C, ""
@
###########################################################################                                                                                                                                     ########## #####
=#####==========================================================================================================================================================================================================================
|##############################################################################################################################################################################################################################|
|##############################################################################################################################################################################################################################|
}
*)

(*
$P{ SubTop:
TimeKeep.TimeKeep, L, ""
TimeKeep.Name, L, ""
?, C, "ࠡ⪠|ࠡ⪠"
@
|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| ### #######################################                                                                                                                                                                            |
|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|  |                                    |   |###########|  01|  02|  03|  04|  05|  06|  07|  08|  09|  10|  11|  12|  13|  14|  15|  16|  17|  18|  19|  20|  21|  22|  23|  24|  25|  26|  27|  28|  29|  30|  31|
|-----|---------------------------------------|---------|-----------|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|
}
*)

(*
$P{ Line:
Tmp.TSN, L, ""
Man.Name, L, ""
Tmp.CorBal, R, "3."
?, R, "3."
Tmp.Days[0], L, ""
Tmp.Days[1], L, ""
Tmp.Days[2], L, ""
Tmp.Days[3], L, ""
Tmp.Days[4], L, ""
Tmp.Days[5], L, ""
Tmp.Days[6], L, ""
Tmp.Days[7], L, ""
Tmp.Days[8], L, ""
Tmp.Days[9], L, ""
Tmp.Days[10], L, ""
Tmp.Days[11], L, ""
Tmp.Days[12], L, ""
Tmp.Days[13], L, ""
Tmp.Days[14], L, ""
Tmp.Days[15], L, ""
Tmp.Days[16], L, ""
Tmp.Days[17], L, ""
Tmp.Days[18], L, ""
Tmp.Days[19], L, ""
Tmp.Days[20], L, ""
Tmp.Days[21], L, ""
Tmp.Days[22], L, ""
Tmp.Days[23], L, ""
Tmp.Days[24], L, ""
Tmp.Days[25], L, ""
Tmp.Days[26], L, ""
Tmp.Days[27], L, ""
Tmp.Days[28], L, ""
Tmp.Days[29], L, ""
Tmp.Days[30], L, ""
@
|#####|#######################################|#########|###########|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|
}
*)

(*
$P{ DlmTimeKeep:
@
|-------------------------------------------------------|-----------|----------------------------------------------------------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ SubBotTimeKeep:
?, C, ""
?, R, "0"
@
|⮣ ###########  㯯                            |###########|                                                                                                                                                          |
}
*)

(*
$P{ DlmBot:
@
|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ Bot:
?, C, ""
?, R, "0"
@
|⮣ ###########                               |###########|                                                                                                                                                          |
}
*)

(*
$P{ Bottom:
@
=(c) Polak======================================================================================================================================================================================================================
}
*)

(*
$P{ Top1:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
############################################################################               ########## #####
=#####=====================================================================================================
|                      稭 ࠡ⪨  ਮ  ##########  ##########                      |
|               㯯 㤭,  㬬஢   ࠡ祣 ६               |
}
*)

(*
$P{ SubTop1:
TimeKeep.TimeKeep, L, ""
TimeKeep.Name, L, ""
@
|---------------------------------------------------------------------------------------------------------|
| ### #######################################                                                       |
|---------------------------------------------------------------------------------------------------------|
|     |                                       |    | - |     ﭨ   ࠡ      |
|  |                                    | - |⪠  |---------------------------------------|
|     |                                       |  ⪠  | 䨪 |   ண| ࠧ | | |
|-----|---------------------------------------|---------|---------|---------|---------|---------|---------|
}
*)

(*
$P{ Line1:
Tmp.TSN, L, ""
Man.Name, L, ""
Tmp.LabourRent, R, "3."
Tmp.PurArr, R, "3."
Tmp.Bad[0], R, "3."
Tmp.Bad[1], R, "3."
Tmp.Bad[2], R, "3."
Tmp.Bad[3], R, "3."
@
|#####|#######################################|#########|#########|#########|#########|#########|#########|
}
*)

(*
$P{ DlmTimeKeep1:
@
|---------------------------------------------|---------|---------|---------|---------|---------|---------|
}
*)

(*
$P{ SubBotTimeKeep1:
?, C, ""
?, R, "3."
tPurArr, R, "3."
tBad[0], R, "3."
tBad[1], R, "3."
tBad[2], R, "3."
tBad[3], R, "3."
@
|⮣ ###########  㯯                  |#########|#########|#########|#########|#########|#########|
}
*)

(*
$P{ DlmBot1:
@
|---------------------------------------------|---------|---------|---------|---------|---------|---------|
}
*)

(*
$P{ Bot1:
?, C, ""
?, R, "3."
pPurArr, R, "3."
pBad[0], R, "3."
pBad[1], R, "3."
pBad[2], R, "3."
pBad[3], R, "3."
@
|⮣ ###########                     |#########|#########|#########|#########|#########|#########|
}
*)

(*
$P{ Bottom1:
@
=(c) Polak=================================================================================================
}
*)

 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CreateFILE(Tmp, "", "६ 䠩", "");

  CreateFIELD(Tmp, TimeKeep,   LIKE(TimeKeep.TimeKeep), "", "",  "", "", "");
  CreateFIELD(Tmp, TSN,        LIKE(Staff.TSN),         "", "",  "", ".", "");
  CreateFIELD(Tmp, Date,       DATE,                    "", "",  "", " ਪ  ६饭", "");
  CreateFIELD(Tmp, CorBal,     NUMERIC[3],              "", "0", "", "४஢ ", "");
  CreateFIELD(Tmp, LabourRent, NUMERIC[3],              "", "0", "", "ࠡ⪠/ࠡ⪠", "");
  CreateFIELD(Tmp, PurArr,     NUMERIC[3],              "", "0", "", "ࠡ⪠  䨪", "");
  CreateFIELD(Tmp, Bad,        NUMERIC[3][4],           "", "0", "", "ࠡ⪠ ( 稭)", "");
  CreateFIELD(Tmp, Days,       STRING[4][32],           "", "",  "", "  ", "");
  CreateFIELD(Tmp, MaxHole,    NUMERIC[0],              "", "",  "", ". ᫮ 室  ", "");
  CreateFIELD(Tmp, MaxInWork,  NUMERIC[0],              "", "",  "", ". ᫮ ࠡ  ", "");
  CreateFIELD(Tmp, WrkTim,     NUMERIC[3],              "", "0", "", "ࠡ⠭", "");
  CreateFIELD(Tmp, WrkDays,    NUMERIC[0],              "", "0", "", "⢮ ࠡ ", "");

  CreateINDEXandLINK(Tmp, TSN,      PLURAL, Staff,    TSN,      USER, "", "", TSN);
  CreateINDEXandLINK(Tmp, TimeKeep, PLURAL, TimeKeep, TimeKeep, USER, "", "", TimeKeep, TSN, Date);

  SetVersionOfFILE(Tmp, 0);
  L_AFM.AF_CreateTemp("Tmp", "Tmp");
 END {Create_Tmp};

 PRIVATE PROCEDURE E_Uk_Sheet_NeedType(_TSN       : LIKE(Staff.TSN);
                                       _Arrear,
                                       maxHole    : NUMERIC[3]): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Utils.Uk_Sheet_NeedType);
  IF ~!Local THEN
   RETURN Local(_TSN, _Arrear, maxHole);
  ELSE
   RETURN (_Arrear > 0) | (maxHole > 2);
  END;
 END {E_Uk_Sheet_NeedType};

 PRIVATE PROCEDURE GoodContract(OnlyBasicCnt: SCAL[2]): SCAL[2];
 BEGIN
  RETURN ~OnlyBasicCnt | (Staff.Contract = L_Staff.cnt_Basic);
 END {GoodContract};

 PRIVATE PROCEDURE ConvText(Text1, Text2: STRING[]): STRING[];
  CONST
   ColumnWidth = 4;
 BEGIN
  RETURN Str.Align(Text1, ColumnWidth - Str.Length(Text2), LEFT) + Text2;
 END {ConvText};

 PRIVATE PROCEDURE E_AbsentType(_JMode: LIKE(JMode.JMode)): SCAL[5];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Staff.AbsentType);
  IF ~!Local THEN
   RETURN Local(_JMode);
  ELSE
   RETURN 0;
  END;
 END {E_AbsentType};

 PRIVATE PROCEDURE IsAcceptableStaff(): SCAL[2];
 BEGIN
  RETURN ~L_APtm.IsOG() | P_Firm.IsAllowedMyPF(Staff.MyFirm, P_Sort.GetMyPlace(StaffLog.Sort, StaffLog.Date));
 END {IsAcceptableStaff};

 PRIVATE PROCEDURE MakeIndex(RepType: tRepType; OnlyBasicCnt: SCAL[2]);
  VAR
   _FullBal,
   _ToDecrBal,
   _CorBal,
   _FullTime,
   _TimDone,
   _Arrear,
   _Tim       : NUMERIC[3];
   _Days      : STRING[4][32];
   BDate      : DATE;
   _Bad       : NUMERIC[3][4];
   i,
   _AbsType,
   curInWork,
   maxInWork,
   totWrkDays,
   curHole,
   maxHole    : NUMERIC[0];
   _ShtSign   : STRING[];
   IsHole,
   fromSheet  : SCAL[2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(L_DatTim.Per(Memo.ud_fr()) = L_DatTim.Per(Memo.ud_ut()),
                   "ਮ    ।  ");
  L_Way.WarnUnDoneRWayS(Memo.ud_fr(), Memo.ud_ut());

  Create_Tmp();
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   IF L_Env.RealTSN(Staff.TSN) & GoodContract(OnlyBasicCnt) &
      L_Staff.InStateInPer(Memo.ud_fr(), Memo.ud_ut()) THEN
    SELECT(StaffLog, TSN, , Staff.TSN);
    WHILE OCCURE(StaffLog) DO
     IF ~L_Staff.IsDischargeStaffLog() &
        L_Staff.OrderInIntvl(Memo.ud_fr(), Memo.ud_ut()) &
        IsAcceptableStaff() THEN
      CONFORM(StaffLog, Officer);
      CONFORM(Officer, TimeKeep);
      IF TimeKeep.ChSheet THEN
       SETEMPTY(_Days);
       SETZERO(_FullBal, _ToDecrBal, _CorBal, _FullTime, _TimDone, _Arrear,
               _Bad, maxHole, curHole, maxInWork, curInWork, totWrkDays);
       BDate:=Memo.ud_fr();
       WHILE BDate <= Memo.ud_ut() DO
        L_General.Assert(SEARCH(RegList, HumReg, StaffLog.Regime, L_DatTim.Per(BDate), L_DatTim.DAY(BDate)),
                         " ᠭ ० ࠡ " + StaffLog.Regime + "  " +
                         L_DatTim.DateStr(BDate));
        IF L_DatTim.IsActive_Inc(BDate, StaffLog.Date, StaffLog.DateE) THEN
         L_Sheet.GetRealSheet(IsHole, _Tim, _ShtSign, fromSheet);
         IF JMode.PrintHrs THEN
          _Days[RegList.Day-1]:=ConvText(_ShtSign, L_Str.IntStr(_Tim));
         ELSE
          _Days[RegList.Day-1]:=_ShtSign;
         END;

         IF JMode.InFirm THEN
          IF IsHole THEN
           INC(curHole);
           maxHole:=Math.Max(maxHole, curHole);
          ELSE
           curHole:=0;
          END;
 
          INC(_FullBal, RegList.Durat);
          INC(_ToDecrBal, _Tim * JMode.DecrBal);
          IF JMode.Type = L_Sheet.jmType_TimDone THEN
           INC(_TimDone,   _Tim);
           INC(totWrkDays);
           IF fromSheet THEN
            L_General.Assert(~IsHole, "室   ந⢥ ࠡ⮩ "+L_DatTim.DateStr(BDate));
            INC(curInWork);
            maxInWork:=Math.Max(maxInWork, curInWork);
           ELSE
            curInWork:=0;
           END;
          ELSE
           curInWork:=0;
          END;
          INC(_FullTime, _Tim);
          _AbsType:=E_AbsentType(JMode.JMode);
          IF _AbsType > 0 THEN
           INC(_Bad[_AbsType-1], _Tim);
          END;
         END; (* IF JMode.InFirm... *)
        ELSE
         _Days[RegList.Day-1]:="----";
        END; (* IF L_DatTim.IsActive_Inc ...*)
        INC(BDate);
       END; (* WHILE BDate <= Memo.ud_ut()...*)
 
       _CorBal:=_FullBal - _ToDecrBal;
       _Arrear:=_CorBal - _TimDone;
       DEFAULT(Tmp);
       Tmp.TimeKeep  :=Officer.TimeKeep;
       Tmp.TSN       :=Staff.TSN;
       Tmp.Date      :=StaffLog.Date;
       Tmp.LabourRent:=_Arrear;
       Tmp.MaxHole   :=maxHole;
       Tmp.MaxInWork :=maxInWork;
       Tmp.WrkDays   :=totWrkDays;
       Tmp.WrkTim    :=_TimDone;
       IF    RepType # rt_ArrReason THEN
        IF Isrt_Unove(RepType) |
           ((RepType = rt_Arr_Ovr) & (_FullBal # 0)) |
           ((RepType = rt_LabourRent) & E_Uk_Sheet_NeedType(Staff.TSN, _Arrear, maxHole)) THEN
         Tmp.CorBal  :=_CorBal;
         i:=0;
         WHILE i <= HIGH(_Days) DO
          Tmp.Days[i]:=_Days[i];
          INC(i);
         END;
         INSERT(Tmp);
        END;
       ELSIF (_Arrear > 0) &
             (Staff.Contract = L_Staff.cnt_Basic) THEN
        Tmp.PurArr  :=Math.Max(0, _FullBal - _FullTime);
        Tmp.Bad[0]  :=Math.Min(_Arrear, _Bad[0]);
        Tmp.Bad[1]  :=Math.Min(_Arrear, _Bad[1]);
        Tmp.Bad[2]  :=Math.Min(_Arrear, _Bad[2]);
        Tmp.Bad[3]  :=Math.Min(_Arrear, _Bad[3]);
        INSERT(Tmp);
       END;
      END;
     END;
     NEXT(StaffLog);
    END; (* WHILE OCCURE(StaffLog) &...*)
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
 END {MakeIndex};

 PRIVATE PROCEDURE GetPartName(Name: STRING[]; RepType: tRepType): STRING[];
 BEGIN
  RETURN Str.Condense(Name + L_Str.PoolItem(" |1", RepType = rt_ArrReason));
 END {GetPartName};

 PRIVATE PROCEDURE MakeExcelHeader();
  VAR
   _S: STRING[];
   _D: DATE;
 BEGIN
  L_Basis.wb_WrInQM("F", " ");
  L_Basis.wb_WrInQM("F", "騪");
  L_Basis.wb_WrInQM("F", "騪");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", " ⥫⢠");
  L_Basis.wb_WrInQM("F", "४஢ ଠ");
  L_Basis.wb_WrInQM("F", "ࠡ⪠");
  L_Basis.wb_WrInQM("F", "⤥");
  L_Basis.wb_WrInQM("F", "⤥");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "");
  L_Basis.wb_WrInQM("F", "⥣");
  L_Basis.wb_WrInQM("F", "⥣");
  L_Basis.wb_WrInQM("F", "max 室");
  L_Basis.wb_WrInQM("F", "max ");
  SETEMPTY(_S);
  _D:=Memo.ud_fr();
  WHILE _D <= Memo.ud_ut() DO
   IF ~!_S THEN
    _S:=_S+"|";
   END;
   _S:=_S+Str.Align(L_Str.FixedIntStr(L_DatTim.DAY(_D), 2), 4, CENTRE);
   INC(_D);
  END;
  L_Basis.wb_WrInQM("F", _S);
  L_Basis.wb_TermLine("F");
 END {MakeExcelHeader};

 PRIVATE PROCEDURE MakeExcelPart(_LabourRent: NUMERIC[3]);
  VAR
   i : NUMERIC[0];
   _S: STRING[];
 BEGIN
  SEARCH(StaffLog, TSN, , Tmp.TSN, Tmp.Date);
  CONFORM(StaffLog, Officer);
  CONFORM(Officer, Sort, Union);
  SETEMPTY(_S);
  i:=0;
  WHILE ~!Tmp.Days[i] DO
   IF ~!_S THEN
    _S:=_S+"|";
   END;
   _S:=_S+Str.Align(Tmp.Days[i], 4, LEFT);
   INC(i);
  END;
  L_Basis.wb_WrStr("F", L_Str.PoolItem("|", TimeKeep.ChSheet));
  L_Basis.wb_WrScl("F", TimeKeep.TimeKeep);
  L_Basis.wb_WrStr("F", TimeKeep.Name);
  L_Basis.wb_WrScl("F", Tmp.TSN);
  L_Basis.wb_WrStr("F", Man.Name);
  L_Basis.wb_WrStr("F", L_Man.CitizenAsStr(Man.Man, Memo.ud_ut()));
  L_Basis.wb_WrNum("F", Tmp.CorBal, 3);
  L_Basis.wb_WrNum("F", _LabourRent, 3);
  L_Basis.wb_WrScl("F", L_Staff.getDepart());
  L_Basis.wb_WrStr("F", L_Staff.getDepartName());
  L_Basis.wb_WrScl("F", Sort.Sort);
  L_Basis.wb_WrStr("F", Sort.Name);
  L_Basis.wb_WrScl("F", Union.Union);
  L_Basis.wb_WrStr("F", Union.Name);
  L_Basis.wb_WrNum("F", Tmp.MaxHole,   0);
  L_Basis.wb_WrNum("F", Tmp.MaxInWork, 0);
  L_Basis.wb_WrStr("F", _S);
  L_Basis.wb_TermLine("F");
 END {MakeExcelPart};

 PRIVATE PROCEDURE PrintRep(bpId: STRING[]; RepType: tRepType; OnlyBasicCnt: SCAL[2]);
  VAR
   tOvr,    pOvr,
   tArrear, pArrear: NUMERIC[3];
   RepTitle        : STRING[][2];
   _LabourRent     : NUMERIC[3];
 BEGIN
  SETZERO(pArrear, pOvr, pPurArr, pBad);
  IF Isrt_Unove(RepType) THEN
   MakeExcelHeader();
  ELSE
   RepTitle[0]:=L_Str.PoolItem(rt_Pool, MakeSheet(RepType)) +
                "  㯯 㤭,  㬬஢   ࠡ祣 ६";
   RepTitle[1]:=" ਮ  " + L_DatTim.DateStr(Memo.ud_fr()) +
                "  " + L_DatTim.DateStr(Memo.ud_ut()) +
                " ( ⠢, " +
                L_Str.PoolItem(rm_Pool, OnlyBasicCnt) + ")";
   IF RepType # rt_ArrReason THEN
    SetPrintAttr(R, TopMargin, 0, BottomMargin, 0);
   END;
   MAKEPART(R, ^(GetPartName("Top", RepType)), bpId, RepTitle[0], RepTitle[1]);
  END;
  SELECT(Tmp, TimeKeep);
  WHILE OCCURE(Tmp) DO
   CHANGESEL(Tmp, TimeKeep, , Tmp.TimeKeep);
   IF OCCURE(Tmp) THEN
    CONFORM(Tmp, TimeKeep);
    IF ~Isrt_Unove(RepType) THEN
     MAKEPART(R, ^(GetPartName("SubTop", RepType)), MakeSheet(RepType));
    END;
   END;
   SETZERO(tArrear, tOvr, tPurArr, tBad);
   WHILE OCCURE(Tmp) DO
    PROMPT(": " + Tmp.TimeKeep + " " + Tmp.TSN);
    CONFORM(Tmp, Staff);
    CONFORM(Staff, Man);
    IF MakeSheet(RepType) THEN
     _LabourRent:=-Tmp.LabourRent;
    ELSE
     _LabourRent:=Tmp.LabourRent;
    END;
    IF Isrt_Unove(RepType) THEN
     MakeExcelPart(_LabourRent);
    ELSE
     MAKEPART(R, ^(GetPartName("Line", RepType)), _LabourRent);
     INC(tArrear, Tmp.LabourRent  * (Tmp.LabourRent > 0));
     INC(tOvr,    -Tmp.LabourRent * (Tmp.LabourRent < 0));
     INC(tPurArr, Tmp.PurArr);
     INC(tBad[0], Tmp.Bad[0]);
     INC(tBad[1], Tmp.Bad[1]);
     INC(tBad[2], Tmp.Bad[2]);
     INC(tBad[3], Tmp.Bad[3]);
    END;
    NEXT(Tmp);
   END; (* WHILE OCCURE(Tmp) ... *)
   LAST(Tmp);
   CHANGESEL(Tmp, TimeKeep);
   IF ~Isrt_Unove(RepType) THEN
    MAKEPART(R, ^(GetPartName("DlmTimeKeep", RepType)));
    IF MakeSheet(RepType) THEN
     MAKEPART(R, ^(GetPartName("SubBotTimeKeep", RepType)), "ࠡ⪠", tOvr);
    END;
    MAKEPART(R, ^(GetPartName("SubBotTimeKeep", RepType)), "ࠡ⪠", tArrear);
    INC(pArrear, tArrear);
    INC(pOvr,    tOvr);
    INC(pPurArr, tPurArr);
    INC(pBad[0], tBad[0]);
    INC(pBad[1], tBad[1]);
    INC(pBad[2], tBad[2]);
    INC(pBad[3], tBad[3]);
   END;
   NEXT(Tmp);
  END; (* WHILE OCCURE(Tmp) ... *)

  IF ~Isrt_Unove(RepType) THEN
   MAKEPART(R, ^(GetPartName("DlmBot", RepType)));
   IF MakeSheet(RepType) THEN
    MAKEPART(R, ^(GetPartName("Bot", RepType)), "ࠡ⪠", pOvr);
   END;
   MAKEPART(R, ^(GetPartName("Bot", RepType)), "ࠡ⪠", pArrear);
   MAKEPART(R, ^(GetPartName("Bottom", RepType)));
  END;
 END {PrintRep};

 PRIVATE PROCEDURE Do(bpId: STRING[]; RepType: tRepType; OnlyBasicCnt: SCAL[2]);
 BEGIN
  MakeIndex(RepType, OnlyBasicCnt);

  IF Isrt_Unove(RepType) THEN
   FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  ELSE
   OPENREP(R, L_General.NameConnection(bpId), Create);
  END;
  PrintRep(bpId, RepType, OnlyBasicCnt);
  IF Isrt_Unove(RepType) THEN
   FIO.Close(F);
  ELSE
   CLOSEREP(R);
  END;
 END {Do};

 PUBLIC PROCEDURE UkSht();
  CONST
   bpId = "UkSht";
 BEGIN
  L_bp.Begin(bpId, "ࠡ⪠/  ࠡ (᭮ ࠡ)", L_bp.t_Report, L_General.tc_inIntvl);
  Do(bpId, rt_LabourRent, 1);
  L_bp.End();
 END {UkSht};

 PUBLIC PROCEDURE UkST1();
  CONST
   bpId = "UkST1";
 BEGIN
  L_bp.Begin(bpId, "ࠡ⪠/ࠡ⪠ (᭮ ࠡ)", L_bp.t_Report, L_General.tc_inIntvl);
  Do(bpId, rt_Arr_Ovr, 1);
  L_bp.End();
 END {UkST1};

 PUBLIC PROCEDURE UkSh1();
  CONST
   bpId = "UkSh1";
 BEGIN
  L_bp.Begin(bpId, " 稭 ࠡ⪨ (᭮ ࠡ)", L_bp.t_Report, L_General.tc_inIntvl);
  Do(bpId, rt_ArrReason, 1);
  L_bp.End();
 END {UkSh1};

 PRIVATE PROCEDURE UkUnv_ExcelTop(objWS: OBJECT);
  VAR
   i, DayAmnt: NUMERIC[0];
 BEGIN
  PROMPT("ଫ ...");
  objWS.Cells.EntireColumn.NumberFormat:="@";
  objWS.Cells.EntireColumn.HorizontalAlignment:=L_Excel.xlCenter;
  L_Excel.ws_Init(objWS);

  objWS.Cells(1, 1).HorizontalAlignment:=L_Excel.xlLeft;
  objWS.Cells(1, 1).Value:="ࠡ⪠/ࠡ⪠  ਮ  " + L_DatTim.DateStr(Memo.ud_fr()) + "  " + L_DatTim.DateStr(Memo.ud_ut());
  L_Excel.ws_TermLine(objWS);
  objWS.Cells(2, 1).HorizontalAlignment:=L_Excel.xlLeft;
  objWS.Cells(2, 1).Value:=" : " + P_Firm.GetDefaultMyFirmName();
  L_Excel.ws_TermLine(objWS);
  objWS.Cells(3, 1).HorizontalAlignment:=L_Excel.xlLeft;
  objWS.Cells(3, 1).Value:=" : " + P_Firm.GetDefaultMyPlaceName();
  L_Excel.ws_TermLine(objWS);
  L_Excel.ws_TermLine(objWS);

  L_Excel.ws_StartHeader(objWS);
  L_Excel.ws_AddHeaderItem(objWS, " ..", 4, 0);
  L_Excel.ws_AddHeaderItem(objWS, "", 6, 0);
  objWS.Columns(3).HorizontalAlignment:=L_Excel.xlLeft;
  L_Excel.ws_AddHeaderItem(objWS, " ⥫", 35, 0);
  L_Excel.ws_AddHeaderItem(objWS, "ࠡ⠭ ᮢ  , .", L_DatTim.MonthLen(Memo.ud_fr()) * 4, 0);
  L_Excel.ws_AddHeaderSubItem(objWS);
  i      :=1;
  DayAmnt:=L_DatTim.MonthLen(Memo.ud_fr());
  WHILE i <= DayAmnt DO
   L_Excel.ws_AddHeaderItem(objWS, FLDTOSTR(i, "L0", 2), 4, 0);
   INC(i);
  END;
  L_Excel.ws_HeaderReturnFromSubItem(objWS);
  objWS.Columns(35).HorizontalAlignment:=L_Excel.xlRight;
  L_Excel.ws_AddHeaderItem(objWS, "ࠡ⠭ ᮢ ᥣ, .", 10, 0);
  objWS.Columns(36).HorizontalAlignment:=L_Excel.xlRight;
  L_Excel.ws_AddHeaderItem(objWS, "ࠡ⠭ , .", 10, 0);
  objWS.Columns(37).HorizontalAlignment:=L_Excel.xlRight;
  L_Excel.ws_AddHeaderItem(objWS, " ࠡ祣 ६, .", 10, 0);
  objWS.Columns(38).HorizontalAlignment:=L_Excel.xlRight;
  L_Excel.ws_AddHeaderItem(objWS, "+/- (ࠡ⠭ - )", 10, 0);
  L_Excel.ws_StopHeader(objWS);
 END {UkUnv_ExcelTop};

 PRIVATE PROCEDURE UkUnv_MakeExcel(objWB: OBJECT);
  VAR
   i,j,DayAmnt    : NUMERIC[0];
   objWS: OBJECT;
 BEGIN
  objWS:=L_Excel.NewWorksheet(objWB, 0, "ࠡ⪠");
  UkUnv_ExcelTop(objWS);
  MakeIndex(rt_Unove, 1);
  i:=1;
  SELECT(Tmp, TSN);
  WHILE OCCURE(Tmp) DO
   PROMPT(": " + Tmp.TSN);
   CONFORM(Tmp, Staff);
   CONFORM(Staff, Man);

   L_Excel.ws_WrNum(objWS, i);
   L_Excel.ws_WrScl(objWS, Staff.TSN);
   L_Excel.ws_WrStr(objWS, Man.Name);
   j      :=1;
   DayAmnt:=L_DatTim.MonthLen(Memo.ud_fr());
   WHILE j<=DayAmnt DO
    L_Excel.ws_WrStr(objWS, Tmp.Days[j-1]);
    INC(j);
   END;
   L_Excel.ws_WrNum(objWS, Tmp.WrkTim);
   L_Excel.ws_WrNum(objWS, Tmp.WrkDays);
   L_Excel.ws_WrNum(objWS, Tmp.CorBal);
   L_Excel.ws_WrNum(objWS, -Tmp.LabourRent);
   L_Excel.ws_TermLine(objWS);

   INC(i);
   NEXT(Tmp);
  END; (* WHILE OCCURE(Tmp) ... *)
 END {UkUnv_MakeExcel};

 PUBLIC PROCEDURE UkUnv();
  VAR
   RepName: STRING[];
   trgMyFirm: LIKE(MyFirm.MyFirm);
   trgMyPlace: LIKE(MyPlace.MyPlace);
 BEGIN
  trgMyFirm:=P_Firm.defaultMyFirm;
  IF !trgMyFirm THEN
   trgMyFirm:=0000;
  END;
  trgMyPlace:=P_Firm.defaultMyPlace;
  IF !trgMyPlace THEN
   trgMyPlace:=0000;
  END;

  RepName:="UkUnv_"+trgMyFirm+"_"+trgMyPlace+"_"+FLDTOSTR(Memo.ud_fr(), "YND")+"_"+FLDTOSTR(Memo.ud_ut(), "YND");
  L_Excel.MakeRep(PROCREF(UkUnv_MakeExcel), RepName);
 END {UkUnv};

END.
