(*
%Copyright   (c) Polak IT
%Author      11.12.2002 12:37:59 POLAK\RSN
%Purpose     ᮡ   ஢ ய⨩.
%Type        to paste
%Specific    LOC
%Modified    25.11.2010 21:12:37 POLAK\Gina
%Environment
*)

 IMPORT RE_Plan, L_Car, L_Way, E_Way;

 PUBLIC PROCEDURE OverPrcLimit(D: DATE): NUMERIC[5];
 BEGIN
  RETURN -10;
 END {OverPrcLimit};

 PRIVATE PROCEDURE MarkHasRepEventNorm(_Mark: LIKE(Mark.Mark); _RepEvent: LIKE(RepEvent.RepEvent); D: DATE): SCAL[2];
 BEGIN
  RETURN L_Car.MarkRepEventNorm(_Mark, _RepEvent, D, 1000000, 1) # 0;
 END {MarkHasRepEventNorm};

 PUBLIC PROCEDURE NeedCar(): SCAL[2];
 BEGIN
  L_Car.AccessMark(Car.BoxNbr, RE_Plan.BaseDate);
  IF    RE_Plan.plnRepEvent = E_Way.re_Sinchronisation THEN
   RETURN MarkHasRepEventNorm(Mark.Mark, RE_Plan.plnRepEvent, SYSDATE());
  ELSIF RE_Plan.plnRepEvent = E_Way.re_HMT_OilReplace THEN
   RETURN MarkHasRepEventNorm(Mark.Mark, RE_Plan.plnRepEvent, SYSDATE()) & (Car.BoxNbr # 2913);
  ELSIF RE_Plan.plnRepEvent = E_Way.re_VTMStrapReplace THEN
   RETURN MarkHasRepEventNorm(Mark.Mark, RE_Plan.plnRepEvent, SYSDATE());
  ELSIF RE_Plan.plnRepEvent = E_Way.re_Capsulation THEN
   RETURN MarkHasRepEventNorm(Mark.Mark, RE_Plan.plnRepEvent, SYSDATE());
  ELSIF RE_Plan.plnRepEvent = E_Way.re_Diagnostic1 THEN
   RETURN MarkHasRepEventNorm(Mark.Mark, RE_Plan.plnRepEvent, SYSDATE());
  ELSE
   IF (Car.Purpose = L_Car.purp_Common) THEN
    RETURN 1;
   END;
   SELECT(MarkGM, Mark, , Mark.Mark);
   WHILE OCCURE(MarkGM) DO
    CONFORM(MarkGM, MarkG);
    IF MarkG.MarkGT = L_Way.mgt_REPlan THEN
     RETURN 1;
    END;
    NEXT(MarkGM);
   END; (* WHILE OCCURE(MarkGM) ... *)
   RETURN 0;
  END;
 END {NeedCar};

 PUBLIC PROCEDURE GetAttendRepEventList(    _RepEvent  : LIKE(RepEvent.RepEvent);
                                        VAR RepEventArr: LIKE(RepEvent.RepEvent)[]);
 BEGIN
  IF    _RepEvent = E_Way.re_TO2 THEN
   RepEventArr[0]:=E_Way.re_SeasonService;
  END;
 END {GetAttendRepEventList};

END.
